/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(V){for(var t=[],i=0,F=V.length;i<F;i++)t[i]=re[V[i]];return t};const Ce=this,ze=typeof global=="object"?global:{};var ce;(function(V){V.global=Ce;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof V.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}V.Environment=t})(ce||(ce={}));var ce;(function(V){class t{constructor(f,L,h){this.type=f,this.detail=L,this.timestamp=h}}V.LoaderEvent=t;class i{constructor(f){this._events=[new t(1,"",f)]}record(f,L){this._events.push(new t(f,L,V.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}V.LoaderEventRecorder=i;class F{record(f,L){}getEvents(){return[]}}F.INSTANCE=new F,V.NullLoaderEventRecorder=F})(ce||(ce={}));var ce;(function(V){class t{static fileUriToFilePath(F,y){if(y=decodeURI(y).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(y))return y.substr(8);if(/^file:\/\//.test(y))return y.substr(5)}else if(/^file:\/\//.test(y))return y.substr(7);return y}static startsWith(F,y){return F.length>=y.length&&F.substr(0,y.length)===y}static endsWith(F,y){return F.length>=y.length&&F.substr(F.length-y.length)===y}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,y){if(F){let f;for(f in F)F.hasOwnProperty(f)&&y(f,F[f])}}static isEmpty(F){let y=!0;return t.forEachProperty(F,()=>{y=!1}),y}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let y=Array.isArray(F)?[]:{};return t.forEachProperty(F,(f,L)=>{L&&typeof L=="object"?y[f]=t.recursiveClone(L):y[f]=L}),y}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=V.global.performance&&typeof V.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?V.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,V.Utilities=t})(ce||(ce={}));var ce;(function(V){function t(y){if(y instanceof Error)return y;const f=new Error(y.message||String(y)||"Unknown Error");return y.stack&&(f.stack=y.stack),f}V.ensureError=t;class i{static validateConfigurationOptions(f){function L(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=L),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(V.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,L=null){let h=V.Utilities.recursiveClone(L||{});return V.Utilities.forEachProperty(f,(l,u)=>{l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(u):l==="paths"&&typeof h.paths<"u"?V.Utilities.forEachProperty(u,(c,B)=>h.paths[c]=B):l==="config"&&typeof h.config<"u"?V.Utilities.forEachProperty(u,(c,B)=>h.config[c]=B):h[l]=V.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(h)}}V.ConfigurationOptionsUtil=i;class F{constructor(f,L){if(this._env=f,this.options=i.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],V.Utilities.forEachProperty(this.options.paths,(f,L)=>{Array.isArray(L)?this.sortedPathsRules.push({from:f,to:L}):this.sortedPathsRules.push({from:f,to:[L]})}),this.sortedPathsRules.sort((f,L)=>L.from.length-f.from.length)}cloneAndMerge(f){return new F(this._env,i.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let L;for(let h=0,l=this.sortedPathsRules.length;h<l;h++)if(L=this.sortedPathsRules[h],V.Utilities.startsWith(f,L.from)){let u=[];for(let c=0,B=L.to.length;c<B;c++)u.push(L.to[c]+f.substr(L.from.length));return u}return[f]}_addUrlArgsToUrl(f){return V.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let L=0,h=f.length;L<h;L++)f[L]=this._addUrlArgsToUrl(f[L]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let L=f,h;if(!V.Utilities.endsWith(L,".js")&&!V.Utilities.isAbsolutePath(L)){h=this._applyPaths(L);for(let l=0,u=h.length;l<u;l++)this.isBuild()&&h[l]==="empty:"||(V.Utilities.isAbsolutePath(h[l])||(h[l]=this.options.baseUrl+h[l]),!V.Utilities.endsWith(h[l],".js")&&!V.Utilities.containsQueryString(h[l])&&(h[l]=h[l]+".js"))}else!V.Utilities.endsWith(L,".js")&&!V.Utilities.containsQueryString(L)&&(L=L+".js"),h=[L];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let L=f;return V.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],V.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||V.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}V.Configuration=F})(ce||(ce={}));var ce;(function(V){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,c,B,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new y;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new i;let m={callback:B,errorback:b};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(m);return}this._callbackMap[c]=[m],this._scriptLoader.load(u,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(u){let c=this._callbackMap[u];delete this._callbackMap[u];for(let B=0;B<c.length;B++)c[B].callback()}triggerErrorback(u,c){let B=this._callbackMap[u];delete this._callbackMap[u];for(let b=0;b<B.length;b++)B[b].errorback(c)}}class i{attachListeners(u,c,B){let b=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=p=>{b(),c()},e=p=>{b(),B(p)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,c,B,b){if(/^node\|/.test(c)){let m=u.getConfig().getOptionsLiteral(),e=L(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),p=c.split("|"),j=null;try{j=e(p[1])}catch(N){b(N);return}u.enqueueDefineAnonymousModule([],()=>j),B()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,B,b);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),m.setAttribute("src",c);const{cspNonce:p}=u.getConfig().getOptionsLiteral();p&&m.setAttribute("nonce",p),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(l){const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class y{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(u)),this._cachedCanUseEval}load(u,c,B,b){if(/^node\|/.test(c)){const m=u.getConfig().getOptionsLiteral(),e=L(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),p=c.split("|");let j=null;try{j=e(p[1])}catch(N){b(N);return}u.enqueueDefineAnonymousModule([],function(){return j}),B()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(c).then(p=>{if(p.status!==200)throw new Error(p.statusText);return p.text()}).then(p=>{p=`${p}
//# sourceURL=${c}`,(m?self.eval(m.createScript("",p)):new Function(p)).call(self),B()}).then(void 0,b);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),B()}catch(p){b(p)}}}}class f{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,c){const{nodeCachedData:B}=c.getConfig().getOptionsLiteral();if(!B||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=u("module");function e(p){const j=p.constructor;let N=function(d){try{return p.require(d)}finally{}};return N.resolve=function(d,a){return j._resolveFilename(d,p,!1,a)},N.resolve.paths=function(d){return j._resolveLookupPaths(d,p)},N.main=process.mainModule,N.extensions=j._extensions,N.cache=j._cache,N}m.prototype._compile=function(p,j){const N=m.wrap(p.replace(/^#!.*/,"")),$=c.getRecorder(),d=b._getCachedDataPath(B,j),a={filename:j};let o;try{const E=b._fs.readFileSync(d);o=E.slice(0,16),a.cachedData=E.slice(16),$.record(60,d)}catch{$.record(61,d)}const n=new b._vm.Script(N,a),s=n.runInThisContext(a),v=b._path.dirname(j),g=e(this),w=[this.exports,g,this,j,v,process,ze,Buffer],A=s.apply(this.exports,w);return b._handleCachedData(n,N,d,!a.cachedData,c),b._verifyCachedData(n,N,d,o,c),A}}load(u,c,B,b){const m=u.getConfig().getOptionsLiteral(),e=L(u.getRecorder(),m.nodeRequire||V.global.nodeRequire),p=m.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,u);let j=u.getRecorder();if(/^node\|/.test(c)){let N=c.split("|"),$=null;try{$=e(N[1])}catch(d){b(d);return}u.enqueueDefineAnonymousModule([],()=>$),B()}else{c=V.Utilities.fileUriToFilePath(this._env.isWindows,c);const N=this._path.normalize(c),$=this._getElectronRendererScriptPathOrUri(N),d=!!m.nodeCachedData,a=d?this._getCachedDataPath(m.nodeCachedData,c):void 0;this._readSourceAndCachedData(N,a,j,(o,n,s,v)=>{if(o){b(o);return}let g;n.charCodeAt(0)===f._BOM?g=f._PREFIX+n.substring(1)+f._SUFFIX:g=f._PREFIX+n+f._SUFFIX,g=p(g,N);const w={filename:$,cachedData:s},A=this._createAndEvalScript(u,g,w,B,b);this._handleCachedData(A,g,a,d&&!s,u),this._verifyCachedData(A,g,a,v,u)})}}_createAndEvalScript(u,c,B,b,m){const e=u.getRecorder();e.record(31,B.filename);const p=new this._vm.Script(c,B),j=p.runInThisContext(B),N=u.getGlobalAMDDefineFunc();let $=!1;const d=function(){return $=!0,N.apply(null,arguments)};return d.amd=N.amd,j.call(V.global,u.getGlobalAMDRequireFunc(),d,B.filename,this._path.dirname(B.filename)),e.record(32,B.filename),$?b():m(new Error(`Didn't receive define call in ${B.filename}!`)),p}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let c=u.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,c){const B=this._crypto.createHash("md5").update(c,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(c).replace(/\.js$/,"");return this._path.join(u.path,`${b}-${B}.code`)}_handleCachedData(u,c,B,b,m){u.cachedDataRejected?this._fs.unlink(B,e=>{m.getRecorder().record(62,B),this._createAndWriteCachedData(u,c,B,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(u,c,B,m)}_createAndWriteCachedData(u,c,B,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,p=0,j;const N=()=>{setTimeout(()=>{j||(j=this._crypto.createHash("md5").update(c,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||p>=5)){if($.length<e){N();return}e=$.length,this._fs.writeFile(B,Buffer.concat([j,$]),d=>{d&&b.getConfig().onError(d),b.getRecorder().record(63,B),N()})}},m*Math.pow(4,p++))};N()}_readSourceAndCachedData(u,c,B,b){if(!c)this._fs.readFile(u,{encoding:"utf8"},b);else{let m,e,p,j=2;const N=$=>{$?b($):--j===0&&b(void 0,m,e,p)};this._fs.readFile(u,{encoding:"utf8"},($,d)=>{m=d,N($)}),this._fs.readFile(c,($,d)=>{!$&&d&&d.length>0?(p=d.slice(0,16),e=d.slice(16),B.record(60,c)):B.record(61,c),N()})}}_verifyCachedData(u,c,B,b,m){b&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${B}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(B,p=>{p&&m.getConfig().onError(p)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function L(l,u){if(u.__$__isRecorded)return u;const c=function(b){l.record(33,b);try{return u(b)}finally{l.record(34,b)}};return c.__$__isRecorded=!0,c}V.ensureRecordedNodeRequire=L;function h(l){return new t(l)}V.createScriptLoader=h})(ce||(ce={}));var ce;(function(V){class t{constructor(l){let u=l.lastIndexOf("/");u!==-1?this.fromModulePath=l.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(l){let u=l,c;for(c=/\/\.\//;c.test(u);)u=u.replace(c,"/");for(u=u.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(u);)u=u.replace(c,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(l){let u=l;return V.Utilities.isAbsolutePath(u)||(V.Utilities.startsWith(u,"./")||V.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),V.ModuleIdResolver=t;class i{constructor(l,u,c,B,b,m){this.id=l,this.strId=u,this.dependencies=c,this._callback=B,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,u){try{return{returnedValue:l.apply(V.global,u),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(l,u,c,B){return l.shouldInvokeFactory(u)?l.shouldCatchError()?this._safeInvokeFunction(c,B):{returnedValue:c.apply(V.global,B),producedError:null}:{returnedValue:null,producedError:null}}complete(l,u,c,B){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=i._invokeFactory(u,this.strId,this._callback,c);b=m.producedError,l.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||V.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=V.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=B(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}V.Module=i;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let u=this._strModuleIdToIntModuleId.get(l);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(l,u),this._intModuleIdToStrModuleId[u]=l),u}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class y{constructor(l){this.id=l}}y.EXPORTS=new y(0),y.MODULE=new y(1),y.REQUIRE=new y(2),V.RegularDependency=y;class f{constructor(l,u,c){this.id=l,this.pluginId=u,this.pluginParam=c}}V.PluginDependency=f;class L{constructor(l,u,c,B,b=0){this._env=l,this._scriptLoader=u,this._loaderAvailableTimestamp=b,this._defineFunc=c,this._requireFunc=B,this._moduleIdProvider=new F,this._config=new V.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new L(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,u){let c=m=>m.replace(/\\/g,"/"),B=c(l),b=u.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let p=e[1],j=e[2],N=e[3],$=Math.max(p.lastIndexOf(" ")+1,p.lastIndexOf("(")+1);if(p=p.substr($),p=c(p),p===B){let d={line:parseInt(j,10),col:parseInt(N,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],u=0;for(let c=0,B=this._modules2.length;c<B;c++){let b=this._modules2[c];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,p=this._buildInfoDependencies[b.id];l[u++]={id:b.strId,path:m,defineLocation:m&&e?L._findRelevantLocationInStack(m,e):null,dependencies:p,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new V.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=V.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:l,callback:u}}defineModule(l,u,c,B,b,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let p=new i(e,l,this._normalizeDependencies(u,m),c,B,m);this._modules2[e]=p,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(p.dependencies||[]).map(j=>this._moduleIdProvider.getStrModuleId(j.id))),this._resolve(p)}_normalizeDependency(l,u){if(l==="exports")return y.EXPORTS;if(l==="module")return y.MODULE;if(l==="require")return y.REQUIRE;let c=l.indexOf("!");if(c>=0){let B=u.resolveModule(l.substr(0,c)),b=u.resolveModule(l.substr(c+1)),m=this._moduleIdProvider.getModuleId(B+"!"+b),e=this._moduleIdProvider.getModuleId(B);return new f(m,e,b)}return new y(this._moduleIdProvider.getModuleId(u.resolveModule(l)))}_normalizeDependencies(l,u){let c=[],B=0;for(let b=0,m=l.length;b<m;b++)c[B++]=this._normalizeDependency(l[b],u);return c}_relativeRequire(l,u,c,B){if(typeof u=="string")return this.synchronousRequire(u,l);this.defineModule(V.Utilities.generateAnonymousModule(),u,c,B,null,l)}synchronousRequire(l,u=new t(l)){let c=this._normalizeDependency(l,u),B=this._modules2[c.id];if(!B)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!B.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(B.error)throw B.error;return B.exports}configure(l,u){let c=this._config.shouldRecordStats();u?this._config=new V.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),u.dependencies,u.callback,null,u.stack)}}_createLoadError(l,u){let c=this._moduleIdProvider.getStrModuleId(l),B=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=V.ensureError(u);return b.phase="loading",b.moduleId=c,b.neededBy=B,b}_onLoadError(l,u){const c=this._createLoadError(l,u);this._modules2[l]||(this._modules2[l]=new i(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let B=[];for(let e=0,p=this._moduleIdProvider.getMaxModuleId();e<p;e++)B[e]=!1;let b=!1,m=[];for(m.push(l),B[l]=!0;m.length>0;){let e=m.shift(),p=this._modules2[e];p&&(b=p.onDependencyError(c)||b);let j=this._inverseDependencies2[e];if(j)for(let N=0,$=j.length;N<$;N++){let d=j[N];B[d]||(m.push(d),B[d]=!0)}}b||this._config.onError(c)}_hasDependencyPath(l,u){let c=this._modules2[l];if(!c)return!1;let B=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)B[m]=!1;let b=[];for(b.push(c),B[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let p=0,j=e.length;p<j;p++){let N=e[p];if(N.id===u)return!0;let $=this._modules2[N.id];$&&!B[N.id]&&(B[N.id]=!0,b.push($))}}return!1}_findCyclePath(l,u,c){if(l===u||c===50)return[l];let B=this._modules2[l];if(!B)return null;let b=B.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let p=this._findCyclePath(b[m].id,u,c+1);if(p!==null)return p.push(l),p}return null}_createRequire(l){let u=(c,B,b)=>this._relativeRequire(l,c,B,b);return u.toUrl=c=>this._config.requireToUrl(l.resolveModule(c)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(c,B=!1)=>{this.configure(c,B)},u.__$__nodeRequire=V.global.nodeRequire,u}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let u=this._moduleIdProvider.getStrModuleId(l),c=this._config.moduleIdToPaths(u),B=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||B.test(u))&&c.push("node|"+u);let b=-1,m=e=>{if(b++,b>=c.length)this._onLoadError(l,e);else{let p=c[b],j=this.getRecorder();if(this._config.isBuild()&&p==="empty:"){this._buildInfoPath[l]=p,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}j.record(10,p),this._scriptLoader.load(this,p,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=p),j.record(11,p),this._onLoad(l)},N=>{j.record(12,p),m(N)})}};m(null)}_loadPluginDependency(l,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let c=B=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],B,null,null)};c.error=B=>{this._config.onError(this._createLoadError(u.id,B))},l.load(u.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(l){let u=l.dependencies;if(u)for(let c=0,B=u.length;c<B;c++){let b=u[c];if(b===y.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===y.MODULE){l.unresolvedDependenciesCount--;continue}if(b===y.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(p=>this._moduleIdProvider.getStrModuleId(p)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof f){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let p=this._inversePluginDependencies2.get(b.pluginId);p||(p=[],this._inversePluginDependencies2.set(b.pluginId,p)),p.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let u=this.getRecorder();if(l.isComplete())return;let c=l.dependencies,B=[];if(c)for(let p=0,j=c.length;p<j;p++){let N=c[p];if(N===y.EXPORTS){B[p]=l.exports;continue}if(N===y.MODULE){B[p]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(N===y.REQUIRE){B[p]=this._createRequire(l.moduleIdResolver);continue}let $=this._modules2[N.id];if($){B[p]=$.exports;continue}B[p]=null}const b=p=>(this._inverseDependencies2[p]||[]).map(j=>this._moduleIdProvider.getStrModuleId(j));l.complete(u,this._config,B,b);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let p=0,j=m.length;p<j;p++){let N=m[p],$=this._modules2[N];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let p=0,j=e.length;p<j;p++)this._loadPluginDependency(l.exports,e[p])}}}V.ModuleManager=L})(ce||(ce={}));var ne,ce;(function(V){const t=new V.Environment;let i=null;const F=function(h,l,u){typeof h!="string"&&(u=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(u=l,l=null),l||(l=["require","exports","module"]),h?i.defineModule(h,l,u,null,null):i.enqueueDefineAnonymousModule(l,u)};F.amd={jQuery:!0};const y=function(h,l=!1){i.configure(h,l)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){y(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(V.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=y,f.getConfig=function(){return i.getConfig().getOptionsLiteral()},f.reset=function(){i=i.reset()},f.getBuildInfo=function(){return i.getBuildInfo()},f.getStats=function(){return i.getLoaderEvents()},f.define=F;function L(){if(typeof V.global.require<"u"||typeof require<"u"){const h=V.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const l=V.ensureRecordedNodeRequire(i.getRecorder(),h);V.global.nodeRequire=l,f.nodeRequire=l,f.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(V.global.define=F),V.global.require=f)}V.init=L,(typeof V.global.define!="function"||!V.global.define.amd)&&(i=new V.ModuleManager(t,V.createScriptLoader(t),F,f,V.Utilities.getHighPerformanceTimestamp()),typeof V.global.require<"u"&&typeof V.global.require!="function"&&f.config(V.global.require),ne=function(){return F.apply(null,arguments)},ne.amd=F.amd,typeof doNotInitLoader>"u"&&L())})(ce||(ce={})),ne(re[71],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(h,l,u,c){if(c=c||{},(c["vs/css"]||{}).disabled){u({});return}const b=l.toUrl(h+".css");F(h,b,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+b+".")})}function F(h,l,u,c){if(y(h,l)){u();return}f(h,l,u,c)}function y(h,l){const u=window.document.getElementsByTagName("link");for(let c=0,B=u.length;c<B;c++){const b=u[c].getAttribute("data-name"),m=u[c].getAttribute("href");if(b===h||m===l)return!0}return!1}function f(h,l,u,c){const B=document.createElement("link");B.setAttribute("rel","stylesheet"),B.setAttribute("type","text/css"),B.setAttribute("data-name",h),L(h,B,u,c),B.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(B)}function L(h,l,u,c){const B=()=>{l.removeEventListener("load",b),l.removeEventListener("error",m)},b=e=>{B(),u()},m=e=>{B(),c(e)};l.addEventListener("load",b),l.addEventListener("error",m)}}),ne("vs/nls",["require","exports"],function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=c,t.localize2=B,t.getConfiguredDefaultLocale=b,t.setPseudoTranslation=m,t.create=e,t.load=p;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function y(j,N){let $;return N.length===0?$=j:$=j.replace(/\{(\d+)\}/g,(d,a)=>{const o=a[0],n=N[o];let s=d;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function f(j,N){let $=j[N];return $||($=j["*"],$)?$:null}function L(j){return j.charAt(j.length-1)==="/"?j:j+"/"}async function h(j,N,$){const d=L(j)+L(N)+"vscode/"+L($),a=await fetch(d);if(a.ok)return await a.json();throw new Error(`${a.status} - ${a.statusText}`)}function l(j){return function(N,$){const d=Array.prototype.slice.call(arguments,2);return y(j[N],d)}}function u(j){return(N,$,...d)=>({value:y(j[N],d),original:y($,d)})}function c(j,N,...$){return y(N,$)}function B(j,N,...$){const d=y(N,$);return{value:d,original:d}}function b(j){}function m(j){i=j}function e(j,N){return{localize:l(N[j]),localize2:u(N[j]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??($=>{})}}function p(j,N,$,d){const a=d["vs/nls"]??{};if(!j||j.length===0)return $({localize:c,localize2:B,getConfiguredDefaultLocale:()=>a.availableLanguages?.["*"]});const o=a.availableLanguages?f(a.availableLanguages,j):null,n=o===null||o===F;let s=".nls";n||(s=s+"."+o);const v=g=>{Array.isArray(g)?(g.localize=l(g),g.localize2=u(g)):(g.localize=l(g[j]),g.localize2=u(g[j])),g.getConfiguredDefaultLocale=()=>a.availableLanguages?.["*"],$(g)};typeof a.loadBundle=="function"?a.loadBundle(j,o,(g,w)=>{g?N([j+".nls"],v):v(w)}):a.translationServiceUrl&&!n?(async()=>{try{const g=await h(a.translationServiceUrl,o,j);return v(g)}catch(g){if(!o.includes("-"))return console.error(g),N([j+".nls"],v);try{const w=o.split("-")[0],A=await h(a.translationServiceUrl,w,j);return a.availableLanguages??={},a.availableLanguages["*"]=w,v(A)}catch(w){return console.error(w),N([j+".nls"],v)}}})():N([j+s],v,g=>{if(s===".nls"){console.error("Failed trying to load default language strings",g);return}console.error(`Failed to load message bundle for language ${o}. Falling back to the default language:`,g),N([j+".nls"],v)})}}),function(){const V=globalThis.MonacoEnvironment,t=V&&V.baseUrl?V.baseUrl:"../../../";function i(c,B){if(V?.createTrustedTypesPolicy)try{return V.createTrustedTypesPolicy(c,B)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(c,B)}catch(b){console.warn(b);return}}const F=i("amdLoader",{createScriptURL:c=>c,createScript:(c,...B)=>{const b=B.slice(0,-1).join(","),m=B.pop().toString();return`(function anonymous(${b}) { ${m}
})`}});function y(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((c,B)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&y()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,B);return}F?importScripts(F.createScriptURL(b)):importScripts(b),c()})}function L(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function h(c){f().then(()=>{L(),require([c],function(B){setTimeout(function(){const b=B.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>b.onmessage(m.data,m.ports);u.length>0;){const m=u.shift();b.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&L();let l=!0;const u=[];globalThis.onmessage=c=>{if(!l){u.push(c);return}l=!1,h(c.data)}}(),ne(re[9],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=F,t.$hb=y,t.$ib=f,t.$jb=L,t.$kb=h,t.$lb=l,t.$nb=c,t.$ob=B,t.$pb=b,t.$qb=m,t.$rb=e;function i(p,j,N){const $=F(p,j);if($!==-1)return p[$]}function F(p,j,N=p.length-1){for(let $=N;$>=0;$--){const d=p[$];if(j(d))return $}return-1}function y(p,j){const N=f(p,j);return N===-1?void 0:p[N]}function f(p,j,N=0,$=p.length){let d=N,a=$;for(;d<a;){const o=Math.floor((d+a)/2);j(p[o])?d=o+1:a=o}return d-1}function L(p,j){const N=h(p,j);return N===p.length?void 0:p[N]}function h(p,j,N=0,$=p.length){let d=N,a=$;for(;d<a;){const o=Math.floor((d+a)/2);j(p[o])?a=o:d=o+1}return d}function l(p,j,N=0,$=p.length){const d=h(p,j,N,$);return d===p.length?-1:d}class u{static{this.assertInvariants=!1}constructor(j){this.e=j,this.c=0}findLastMonotonous(j){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!j($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=j}const N=f(this.e,j,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}t.$mb=u;function c(p,j){if(p.length===0)return;let N=p[0];for(let $=1;$<p.length;$++){const d=p[$];j(d,N)>0&&(N=d)}return N}function B(p,j){if(p.length===0)return;let N=p[0];for(let $=1;$<p.length;$++){const d=p[$];j(d,N)>=0&&(N=d)}return N}function b(p,j){return c(p,(N,$)=>-j(N,$))}function m(p,j){if(p.length===0)return-1;let N=0;for(let $=1;$<p.length;$++){const d=p[$];j(d,p[N])>0&&(N=$)}return N}function e(p,j){for(const N of p){const $=j(N);if($!==void 0)return $}}}),ne(re[35],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=F,t.$M=y,t.$N=f;function i(L,h){const l=Object.create(null);for(const u of L){const c=h(u);let B=l[c];B||(B=l[c]=[]),B.push(u)}return l}function F(L,h){const l=[],u=[];for(const c of L)h.has(c)||l.push(c);for(const c of h)L.has(c)||u.push(c);return{removed:l,added:u}}function y(L,h){const l=[],u=[];for(const[c,B]of L)h.has(c)||l.push(B);for(const[c,B]of h)L.has(c)||u.push(B);return{removed:l,added:u}}function f(L,h){const l=new Set;for(const u of h)L.has(u)&&l.add(u);return l}}),ne(re[36],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Et=t.$Dt=t.$Ct=t.$Bt=void 0;function i(h,l){const u=Math.pow(10,l);return Math.round(h*u)/u}class F{constructor(l,u,c,B=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=i(Math.max(Math.min(1,B),0),3)}static equals(l,u){return l.r===u.r&&l.g===u.g&&l.b===u.b&&l.a===u.a}}t.$Bt=F;class y{constructor(l,u,c,B){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.l===u.l&&l.a===u.a}static fromRGBA(l){const u=l.r/255,c=l.g/255,B=l.b/255,b=l.a,m=Math.max(u,c,B),e=Math.min(u,c,B);let p=0,j=0;const N=(e+m)/2,$=m-e;if($>0){switch(j=Math.min(N<=.5?$/(2*N):$/(2-2*N),1),m){case u:p=(c-B)/$+(c<B?6:0);break;case c:p=(B-u)/$+2;break;case B:p=(u-c)/$+4;break}p*=60,p=Math.round(p)}return new y(p,j,N,b)}static i(l,u,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?l+(u-l)*6*c:c<1/2?u:c<2/3?l+(u-l)*(2/3-c)*6:l}static toRGBA(l){const u=l.h/360,{s:c,l:B,a:b}=l;let m,e,p;if(c===0)m=e=p=B;else{const j=B<.5?B*(1+c):B+c-B*c,N=2*B-j;m=y.i(N,j,u+1/3),e=y.i(N,j,u),p=y.i(N,j,u-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(p*255),b)}}t.$Ct=y;class f{constructor(l,u,c,B){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.v===u.v&&l.a===u.a}static fromRGBA(l){const u=l.r/255,c=l.g/255,B=l.b/255,b=Math.max(u,c,B),m=Math.min(u,c,B),e=b-m,p=b===0?0:e/b;let j;return e===0?j=0:b===u?j=((c-B)/e%6+6)%6:b===c?j=(B-u)/e+2:j=(u-c)/e+4,new f(Math.round(j*60),p,b,l.a)}static toRGBA(l){const{h:u,s:c,v:B,a:b}=l,m=B*c,e=m*(1-Math.abs(u/60%2-1)),p=B-m;let[j,N,$]=[0,0,0];return u<60?(j=m,N=e):u<120?(j=e,N=m):u<180?(N=m,$=e):u<240?(N=e,$=m):u<300?(j=e,$=m):u<=360&&(j=m,$=e),j=Math.round((j+p)*255),N=Math.round((N+p)*255),$=Math.round(($+p)*255),new F(j,N,$,b)}}t.$Dt=f;class L{static fromHex(l){return L.Format.CSS.parseHex(l)||L.red}static equals(l,u){return!l&&!u?!0:!l||!u?!1:l.equals(u)}get hsla(){return this.i?this.i:y.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof F)this.rgba=l;else if(l instanceof y)this.i=l,this.rgba=y.toRGBA(l);else if(l instanceof f)this.j=l,this.rgba=f.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&F.equals(this.rgba,l.rgba)&&y.equals(this.hsla,l.hsla)&&f.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=L.k(this.rgba.r),u=L.k(this.rgba.g),c=L.k(this.rgba.b),B=.2126*l+.7152*u+.0722*c;return i(B,4)}static k(l){const u=l/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(l){const u=this.getRelativeLuminance(),c=l.getRelativeLuminance();return u>c?(u+.05)/(c+.05):(c+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const u=this.getRelativeLuminance(),c=l.getRelativeLuminance();return u>c}isDarkerThan(l){const u=this.getRelativeLuminance(),c=l.getRelativeLuminance();return u<c}lighten(l){return new L(new y(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new L(new y(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:u,g:c,b:B,a:b}=this.rgba;return new L(new F(u,c,B,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new L(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const u=l.rgba,c=this.rgba.a,B=u.a,b=c+B*(1-c);if(b<1e-6)return L.transparent;const m=this.rgba.r*c/b+u.r*B*(1-c)/b,e=this.rgba.g*c/b+u.g*B*(1-c)/b,p=this.rgba.b*c/b+u.b*B*(1-c)/b;return new L(new F(m,e,p,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:u,g:c,b:B,a:b}=this.rgba;return new L(new F(l.rgba.r-b*(l.rgba.r-u),l.rgba.g-b*(l.rgba.g-c),l.rgba.b-b*(l.rgba.b-B),1))}flatten(...l){const u=l.reduceRight((c,B)=>L.o(B,c));return L.o(this,u)}static o(l,u){const c=1-l.rgba.a;return new L(new F(c*u.rgba.r+l.rgba.a*l.rgba.r,c*u.rgba.g+l.rgba.a*l.rgba.g,c*u.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=L.Format.CSS.format(this)),this.u}static getLighterColor(l,u,c){if(l.isLighterThan(u))return l;c=c||.5;const B=l.getRelativeLuminance(),b=u.getRelativeLuminance();return c=c*(b-B)/b,l.lighten(c)}static getDarkerColor(l,u,c){if(l.isDarkerThan(u))return l;c=c||.5;const B=l.getRelativeLuminance(),b=u.getRelativeLuminance();return c=c*(B-b)/B,l.darken(c)}static{this.white=new L(new F(255,255,255,1))}static{this.black=new L(new F(0,0,0,1))}static{this.red=new L(new F(255,0,0,1))}static{this.blue=new L(new F(0,0,255,1))}static{this.green=new L(new F(0,255,0,1))}static{this.cyan=new L(new F(0,255,255,1))}static{this.lightgrey=new L(new F(211,211,211,1))}static{this.transparent=new L(new F(0,0,0,0))}}t.$Et=L,function(h){let l;(function(u){let c;(function(B){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:h.Format.CSS.formatRGBA(n)}B.formatRGB=b;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}B.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(n)}B.formatHSL=e;function p(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}B.formatHSLA=p;function j(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function N(n){return`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}`}B.formatHex=N;function $(n,s=!1){return s&&n.rgba.a===1?h.Format.CSS.formatHex(n):`#${j(n.rgba.r)}${j(n.rgba.g)}${j(n.rgba.b)}${j(Math.round(n.rgba.a*255))}`}B.formatHexA=$;function d(n){return n.isOpaque()?h.Format.CSS.formatHex(n):h.Format.CSS.formatRGBA(n)}B.format=d;function a(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const v=16*o(n.charCodeAt(1))+o(n.charCodeAt(2)),g=16*o(n.charCodeAt(3))+o(n.charCodeAt(4)),w=16*o(n.charCodeAt(5))+o(n.charCodeAt(6));return new h(new F(v,g,w,1))}if(s===9){const v=16*o(n.charCodeAt(1))+o(n.charCodeAt(2)),g=16*o(n.charCodeAt(3))+o(n.charCodeAt(4)),w=16*o(n.charCodeAt(5))+o(n.charCodeAt(6)),A=16*o(n.charCodeAt(7))+o(n.charCodeAt(8));return new h(new F(v,g,w,A/255))}if(s===4){const v=o(n.charCodeAt(1)),g=o(n.charCodeAt(2)),w=o(n.charCodeAt(3));return new h(new F(16*v+v,16*g+g,16*w+w))}if(s===5){const v=o(n.charCodeAt(1)),g=o(n.charCodeAt(2)),w=o(n.charCodeAt(3)),A=o(n.charCodeAt(4));return new h(new F(16*v+v,16*g+g,16*w+w,(16*A+A)/255))}return null}B.parseHex=a;function o(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=u.CSS||(u.CSS={}))})(l=h.Format||(h.Format={}))}(L||(t.$Et=L={}))}),ne(re[37],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=void 0;class i{constructor(y,f,L,h){this.originalStart=y,this.originalLength=f,this.modifiedStart=L,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$dt=i}),ne(re[3],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=F,t.$Z=y,t.$1=f,t.$2=L,t.$3=h,t.$4=u,t.$6=B,t.$7=b,t.$8=m,t.$0=p;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function F(o){t.$X.setUnexpectedErrorHandler(o)}function y(o){if(!o||typeof o!="object")return!1;const n=o;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function f(o){u(o)||t.$X.onUnexpectedError(o)}function L(o){u(o)||t.$X.onUnexpectedExternalError(o)}function h(o){if(o instanceof Error){const{name:n,message:s}=o,v=o.stacktrace||o.stack;return{$isError:!0,name:n,message:s,stack:v,noTelemetry:d.isErrorNoTelemetry(o)}}return o}const l="Canceled";function u(o){return o instanceof c?!0:o instanceof Error&&o.name===l&&o.message===l}class c extends Error{constructor(){super(l),this.name=this.message}}t.$5=c;function B(){const o=new Error(l);return o.name=o.message,o}function b(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function m(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function p(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class j extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=j;class N extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=N;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class d extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof d)return n;const s=new d;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=d;class a extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.$cb=a}),ne(re[6],se([0,1,3,9]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=y,t.$tb=f,t.$ub=L,t.$vb=h,t.$wb=l,t.$xb=u,t.$yb=c,t.$zb=B,t.$Ab=b,t.$Bb=m,t.$Cb=e,t.$Db=p,t.$Eb=j,t.top=N,t.$Gb=$,t.$Hb=a,t.$Ib=o,t.$Jb=n,t.$Kb=s,t.$Lb=v,t.$Mb=g,t.$Nb=w,t.$Ob=A,t.$Pb=E,t.$Qb=M,t.$Rb=P,t.$Sb=R,t.$Tb=T,t.$Ub=k,t.$Vb=x,t.$Wb=O,t.$Xb=X,t.$Yb=te,t.$Zb=_,t.$1b=Y,t.$2b=D,t.$3b=z,t.$4b=ee,t.$5b=K,t.$6b=fe,t.$7b=we,t.$8b=$e,t.$$b=Te;function y(q,G=0){return q[q.length-(1+G)]}function f(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function L(q,G,W=(C,H)=>C===H){if(q===G)return!0;if(!q||!G||q.length!==G.length)return!1;for(let C=0,H=q.length;C<H;C++)if(!W(q[C],G[C]))return!1;return!0}function h(q,G){const W=q.length-1;G<W&&(q[G]=q[W]),q.pop()}function l(q,G,W){return u(q.length,C=>W(q[C],G))}function u(q,G){let W=0,C=q-1;for(;W<=C;){const H=(W+C)/2|0,Q=G(H);if(Q<0)W=H+1;else if(Q>0)C=H-1;else return H}return-(W+1)}function c(q,G,W){if(q=q|0,q>=G.length)throw new TypeError("invalid index");const C=G[Math.floor(G.length*Math.random())],H=[],Q=[],Z=[];for(const ie of G){const ae=W(ie,C);ae<0?H.push(ie):ae>0?Q.push(ie):Z.push(ie)}return q<H.length?c(q,H,W):q<H.length+Z.length?Z[0]:c(q-(H.length+Z.length),Q,W)}function B(q,G){const W=[];let C;for(const H of q.slice(0).sort(G))!C||G(C[0],H)!==0?(C=[H],W.push(C)):C.push(H);return W}function*b(q,G){let W,C;for(const H of q)C!==void 0&&G(C,H)?W.push(H):(W&&(yield W),W=[H]),C=H;W&&(yield W)}function m(q,G){for(let W=0;W<=q.length;W++)G(W===0?void 0:q[W-1],W===q.length?void 0:q[W])}function e(q,G){for(let W=0;W<q.length;W++)G(W===0?void 0:q[W-1],q[W],W+1===q.length?void 0:q[W+1])}function p(q,G,W){const C=[];function H(ie,ae,le){if(ae===0&&le.length===0)return;const he=C[C.length-1];he&&he.start+he.deleteCount===ie?(he.deleteCount+=ae,he.toInsert.push(...le)):C.push({start:ie,deleteCount:ae,toInsert:le})}let Q=0,Z=0;for(;;){if(Q===q.length){H(Q,0,G.slice(Z));break}if(Z===G.length){H(Q,q.length-Q,[]);break}const ie=q[Q],ae=G[Z],le=W(ie,ae);le===0?(Q+=1,Z+=1):le<0?(H(Q,1,[]),Q+=1):le>0&&(H(Q,0,[ae]),Z+=1)}return C}function j(q,G,W){const C=p(q,G,W),H=[],Q=[];for(const Z of C)H.push(...q.slice(Z.start,Z.start+Z.deleteCount)),Q.push(...Z.toInsert);return{removed:H,added:Q}}function N(q,G,W){if(W===0)return[];const C=q.slice(0,W).sort(G);return d(q,G,C,W,q.length),C}function $(q,G,W,C,H){return W===0?Promise.resolve([]):new Promise((Q,Z)=>{(async()=>{const ie=q.length,ae=q.slice(0,W).sort(G);for(let le=W,he=Math.min(W+C,ie);le<ie;le=he,he=Math.min(he+C,ie)){if(le>W&&await new Promise(ge=>setTimeout(ge)),H&&H.isCancellationRequested)throw new i.$5;d(q,G,ae,le,he)}return ae})().then(Q,Z)})}function d(q,G,W,C,H){for(const Q=W.length;C<H;C++){const Z=q[C];if(G(Z,W[Q-1])<0){W.pop();const ie=(0,F.$kb)(W,ae=>G(Z,ae)<0);W.splice(ie,0,Z)}}}function a(q){return q.filter(G=>!!G)}function o(q){let G=0;for(let W=0;W<q.length;W++)q[W]&&(q[G]=q[W],G+=1);q.length=G}function n(q,G,W){q.splice(W,0,q.splice(G,1)[0])}function s(q){return!Array.isArray(q)||q.length===0}function v(q){return Array.isArray(q)&&q.length>0}function g(q,G=W=>W){const W=new Set;return q.filter(C=>{const H=G(C);return W.has(H)?!1:(W.add(H),!0)})}function w(q){const G=new Set;return W=>{const C=q(W);return G.has(C)?!1:(G.add(C),!0)}}function A(q,G){return q.length>0?q[0]:G}function E(q,G){return q.length>0?q[q.length-1]:G}function M(q,G,W=(C,H)=>C===H){let C=0;for(let H=0,Q=Math.min(q.length,G.length);H<Q&&W(q[H],G[H]);H++)C++;return C}function P(q){return[].concat(...q)}function R(q,G){let W=typeof G=="number"?q:0;typeof G=="number"?W=q:(W=0,G=q);const C=[];if(W<=G)for(let H=W;H<G;H++)C.push(H);else for(let H=W;H>G;H--)C.push(H);return C}function T(q,G,W){return q.reduce((C,H)=>(C[G(H)]=W?W(H):H,C),Object.create(null))}function k(q,G){return q.push(G),()=>x(q,G)}function x(q,G){const W=q.indexOf(G);if(W>-1)return q.splice(W,1),G}function O(q,G,W){const C=q.slice(0,G),H=q.slice(G);return C.concat(W,H)}function X(q,G){let W;if(typeof G=="number"){let C=G;W=()=>{const H=Math.sin(C++)*179426549;return H-Math.floor(H)}}else W=Math.random;for(let C=q.length-1;C>0;C-=1){const H=Math.floor(W()*(C+1)),Q=q[C];q[C]=q[H],q[H]=Q}}function te(q,G){const W=q.indexOf(G);W>-1&&(q.splice(W,1),q.unshift(G))}function _(q,G){const W=q.indexOf(G);W>-1&&(q.splice(W,1),q.push(G))}function Y(q,G){for(const W of G)q.push(W)}function D(q,G){return Array.isArray(q)?q.map(G):G(q)}function z(q){return Array.isArray(q)?q:[q]}function ee(q){return q[Math.floor(Math.random()*q.length)]}function K(q,G,W){const C=r(q,G),H=q.length,Q=W.length;q.length=H+Q;for(let Z=H-1;Z>=C;Z--)q[Z+Q]=q[Z];for(let Z=0;Z<Q;Z++)q[Z+C]=W[Z]}function fe(q,G,W,C){const H=r(q,G);let Q=q.splice(H,W);return Q===void 0&&(Q=[]),K(q,H,C),Q}function r(q,G){return G<0?Math.max(G+q.length,0):Math.min(G,q.length)}var de;(function(q){function G(Q){return Q<0}q.isLessThan=G;function W(Q){return Q<=0}q.isLessThanOrEqual=W;function C(Q){return Q>0}q.isGreaterThan=C;function H(Q){return Q===0}q.isNeitherLessOrGreaterThan=H,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(de||(t.CompareResult=de={}));function we(q,G){return(W,C)=>G(q(W),q(C))}function $e(...q){return(G,W)=>{for(const C of q){const H=C(G,W);if(!de.isNeitherLessOrGreaterThan(H))return H}return de.neitherLessOrGreaterThan}}const Me=(q,G)=>q-G;t.$9b=Me;const ye=(q,G)=>(0,t.$9b)(q?1:0,G?1:0);t.$0b=ye;function Te(q){return(G,W)=>-q(G,W)}class Se{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let W=this.c;for(;W<this.g.length&&G(this.g[W]);)W++;const C=W===this.c?null:this.g.slice(this.c,W);return this.c=W,C}takeFromEndWhile(G){let W=this.d;for(;W>=0&&G(this.g[W]);)W--;const C=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,C}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const W=this.g.slice(this.c,this.c+G);return this.c+=G,W}}t.$_b=Se;class Be{static{this.empty=new Be(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(W=>(G(W),!0))}toArray(){const G=[];return this.iterate(W=>(G.push(W),!0)),G}filter(G){return new Be(W=>this.iterate(C=>G(C)?W(C):!0))}map(G){return new Be(W=>this.iterate(C=>W(G(C))))}some(G){let W=!1;return this.iterate(C=>(W=G(C),!W)),W}findFirst(G){let W;return this.iterate(C=>G(C)?(W=C,!1):!0),W}findLast(G){let W;return this.iterate(C=>(G(C)&&(W=C),!0)),W}findLastMaxBy(G){let W,C=!0;return this.iterate(H=>((C||de.isGreaterThan(G(H,W)))&&(C=!1,W=H),!0)),W}}t.$ac=Be;class Ee{constructor(G){this.c=G}static createSortPermutation(G,W){const C=Array.from(G.keys()).sort((H,Q)=>W(G[H],G[Q]));return new Ee(C)}apply(G){return G.map((W,C)=>G[this.c[C]])}inverse(){const G=this.c.slice();for(let W=0;W<this.c.length;W++)G[this.c[W]]=W;return new Ee(G)}}t.$bc=Ee}),ne(re[13],se([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.$0c=y,t.$$c=f,t.$_c=L,t.$ad=h,t.$bd=l;function F(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function y(u,c="Unreachable"){throw new Error(c)}function f(u){if(!u)throw new i.$cb("Assertion Failed")}function L(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function h(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function l(u,c){let B=0;for(;B<u.length-1;){const b=u[B],m=u[B+1];if(!c(b,m))return!1;B++}return!0}}),ne(re[19],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(F,y){const f=this;let L=!1,h;return function(){if(L)return h;if(L=!0,y)try{h=F.apply(f,arguments)}finally{y()}else h=F.apply(f,arguments);return h}}}),ne(re[20],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(F){function y(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}F.is=y;const f=Object.freeze([]);function L(){return f}F.empty=L;function*h(n){yield n}F.single=h;function l(n){return y(n)?n:h(n)}F.wrap=l;function u(n){return n||f}F.from=u;function*c(n){for(let s=n.length-1;s>=0;s--)yield n[s]}F.reverse=c;function B(n){return!n||n[Symbol.iterator]().next().done===!0}F.isEmpty=B;function b(n){return n[Symbol.iterator]().next().value}F.first=b;function m(n,s){for(const v of n)if(s(v))return!0;return!1}F.some=m;function e(n,s){for(const v of n)if(s(v))return v}F.find=e;function*p(n,s){for(const v of n)s(v)&&(yield v)}F.filter=p;function*j(n,s){let v=0;for(const g of n)yield s(g,v++)}F.map=j;function*N(...n){for(const s of n)yield*s}F.concat=N;function $(n,s,v){let g=v;for(const w of n)g=s(g,w);return g}F.reduce=$;function*d(n,s,v=n.length){for(s<0&&(s+=n.length),v<0?v+=n.length:v>n.length&&(v=n.length);s<v;s++)yield n[s]}F.slice=d;function a(n,s=Number.POSITIVE_INFINITY){const v=[];if(s===0)return[v,n];const g=n[Symbol.iterator]();for(let w=0;w<s;w++){const A=g.next();if(A.done)return[v,F.empty()];v.push(A.value)}return[v,{[Symbol.iterator](){return g}}]}F.consume=a;async function o(n){const s=[];for await(const v of n)s.push(v);return Promise.resolve(s)}F.asyncToArray=o})(i||(t.Iterable=i={}))}),ne(re[38],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$lr=t.$kr=t.$jr=t.$ir=t.$hr=t.ScanCode=t.KeyCode=void 0,t.$mr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class y{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(p,j){this._keyCodeToStr[p]=j,this._strToKeyCode[j.toLowerCase()]=p}keyCodeToStr(p){return this._keyCodeToStr[p]}strToKeyCode(p){return this._strToKeyCode[p.toLowerCase()]||0}}const f=new y,L=new y,h=new y;t.$hr=new Array(230),t.$ir={};const l=[],u=Object.create(null),c=Object.create(null);t.$jr={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>u[e]||0,toString:e=>l[e]||"None"},t.$kr=[],t.$lr=[];for(let e=0;e<=193;e++)t.$kr[e]=-1;for(let e=0;e<=132;e++)t.$lr[e]=-1;(function(){const e="",p=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],j=[],N=[];for(const $ of p){const[d,a,o,n,s,v,g,w,A]=$;if(N[a]||(N[a]=!0,l[a]=o,u[o]=a,c[o.toLowerCase()]=a,d&&(t.$kr[a]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$lr[n]=a))),!j[n]){if(j[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${o}`);f.define(n,s),L.define(n,w||s),h.define(n,A||w||s)}v&&(t.$hr[v]=n),g&&(t.$ir[g]=n)}t.$lr[3]=46})();var B;(function(e){function p(o){return f.keyCodeToStr(o)}e.toString=p;function j(o){return f.strToKeyCode(o)}e.fromString=j;function N(o){return L.keyCodeToStr(o)}e.toUserSettingsUS=N;function $(o){return h.keyCodeToStr(o)}e.toUserSettingsGeneral=$;function d(o){return L.strToKeyCode(o)||h.strToKeyCode(o)}e.fromUserSettings=d;function a(o){if(o>=98&&o<=113)return null;switch(o){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(o)}e.toElectronAccelerator=a})(B||(t.KeyCodeUtils=B={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,p){const j=(p&65535)<<16>>>0;return(e|j)>>>0}}),ne(re[39],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(y){this.d=y,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(y){this.c=y}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),ne(re[21],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(f){this.element=f,this.next=i.Undefined,this.prev=i.Undefined}}class F{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let f=this.a;for(;f!==i.Undefined;){const L=f.next;f.prev=i.Undefined,f.next=i.Undefined,f=L}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,L){const h=new i(f);if(this.a===i.Undefined)this.a=h,this.b=h;else if(L){const u=this.b;this.b=h,h.prev=u,u.next=h}else{const u=this.a;this.a=h,h.next=u,u.prev=h}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(h))}}shift(){if(this.a!==i.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==i.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==i.Undefined&&f.next!==i.Undefined){const L=f.prev;L.next=f.next,f.next.prev=L}else f.prev===i.Undefined&&f.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):f.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):f.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==i.Undefined;)yield f.element,f=f.next}}t.$5c=F}),ne(re[22],se([0,1]),function(V,t){"use strict";var i,F,y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=f,t.$zc=L,t.$Ac=h,t.$Ic=$;function f(d,a,o){let n=d.get(a);return n===void 0&&(n=o,d.set(a,n)),n}function L(d){const a=[];return d.forEach((o,n)=>{a.push(`${n} => ${o}`)}),`Map(${d.size}) {${a.join(", ")}}`}function h(d){const a=[];return d.forEach(o=>{a.push(o)}),`Set(${d.size}) {${a.join(", ")}}`}class l{constructor(a,o){this.uri=a,this.value=o}}function u(d){return Array.isArray(d)}class c{static{this.c=a=>a.toString()}constructor(a,o){if(this[i]="ResourceMap",a instanceof c)this.d=new Map(a.d),this.e=o??c.c;else if(u(a)){this.d=new Map,this.e=o??c.c;for(const[n,s]of a)this.set(n,s)}else this.d=new Map,this.e=a??c.c}set(a,o){return this.d.set(this.e(a),new l(a,o)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,o){typeof o<"u"&&(a=a.bind(o));for(const[n,s]of this.d)a(s.value,s.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Bc=c;class B{constructor(a,o){this[F]="ResourceSet",!a||typeof a=="function"?this.c=new c(a):(this.c=new c(o),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,o){this.c.forEach((n,s)=>a.call(o,s,s,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=B;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[y]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,o=0){const n=this.c.get(a);if(n)return o!==0&&this.l(n,o),n.value}set(a,o,n=0){let s=this.c.get(a);if(s)s.value=o,n!==0&&this.l(s,n);else{switch(s={key:a,value:o,next:void 0,previous:void 0},n){case 0:this.j(s);break;case 1:this.i(s);break;case 2:this.j(s);break;default:this.j(s);break}this.c.set(a,s),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const o=this.c.get(a);if(o)return this.c.delete(a),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.k(a),this.f--,a.value}forEach(a,o){const n=this.g;let s=this.d;for(;s;){if(o?a.bind(o)(s.value,s.key,this):a(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const a=this,o=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return s}values(){const a=this,o=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return s}entries(){const a=this,o=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return s}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let o=this.d,n=this.size;for(;o&&n>a;)this.c.delete(o.key),o=o.next,n--;this.d=o,this.f=n,o&&(o.previous=void 0),this.g++}i(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}j(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}k(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const o=a.next,n=a.previous;if(!o||!n)throw new Error("Invalid list");o.previous=n,n.next=o}a.next=void 0,a.previous=void 0,this.g++}l(a,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(a===this.d)return;const n=a.next,s=a.previous;a===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(o===2){if(a===this.e)return;const n=a.next,s=a.previous;a===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((o,n)=>{a.push([n,o])}),a}fromJSON(a){this.clear();for(const[o,n]of a)this.set(o,n)}}t.$Dc=m;class e extends m{constructor(a,o=1){super(),this.m=a,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(a){this.m=a,this.o()}get ratio(){return this.n}set ratio(a){this.n=Math.min(Math.max(0,a),1),this.o()}get(a,o=2){return super.get(a,o)}peek(a){return super.get(a,0)}set(a,o){return super.set(a,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class p{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let o=this.c.get(a)||0;return o===0?!1:(o--,o===0?this.c.delete(a):this.c.set(a,o),!0)}has(a){return this.c.has(a)}}t.$Fc=p;class j{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[o,n]of a)this.set(o,n)}clear(){this.c.clear(),this.d.clear()}set(a,o){this.c.set(a,o),this.d.set(o,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const o=this.c.get(a);return o===void 0?!1:(this.c.delete(a),this.d.delete(o),!0)}forEach(a,o){this.c.forEach((n,s)=>{a.call(o,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=j;class N{constructor(){this.c=new Map}add(a,o){let n=this.c.get(a);n||(n=new Set,this.c.set(a,n)),n.add(o)}delete(a,o){const n=this.c.get(a);n&&(n.delete(o),n.size===0&&this.c.delete(a))}forEach(a,o){const n=this.c.get(a);n&&n.forEach(o)}get(a){const o=this.c.get(a);return o||new Set}}t.$Hc=N;function $(d,a){if(d===a)return!0;if(d.size!==a.size)return!1;for(const[o,n]of d)if(!a.has(o)||a.get(o)!==n)return!1;for(const[o]of a)if(!d.has(o))return!1;return!0}}),ne(re[10],se([0,1,6,35,22,19,20]),function(V,t,i,F,y,f,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=c,t.$Lc=B,t.$Mc=b,t.$Nc=p,t.$Oc=j,t.$Pc=N,t.$Qc=$,t.$Rc=d,t.$Sc=a,t.$3c=P;const h=!1;let l=null;class u{constructor(){this.b=new Map}static{this.a=0}c(k){let x=this.b.get(k);return x||(x={parent:null,source:null,isSingleton:!1,value:k,idx:u.a++},this.b.set(k,x)),x}trackDisposable(k){const x=this.c(k);x.source||(x.source=new Error().stack)}setParent(k,x){const O=this.c(k);O.parent=x}markAsDisposed(k){this.b.delete(k)}markAsSingleton(k){this.c(k).isSingleton=!0}f(k,x){const O=x.get(k);if(O)return O;const X=k.parent?this.f(this.c(k.parent),x):k;return x.set(k,X),X}getTrackedDisposables(){const k=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,k).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(k=10,x){let O;if(x)O=x;else{const D=new Map,z=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,D).isSingleton);if(z.length===0)return;const ee=new Set(z.map(K=>K.value));if(O=z.filter(K=>!(K.parent&&ee.has(K.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function X(D){function z(K,fe){for(;K.length>0&&fe.some(r=>typeof r=="string"?r===K[0]:K[0].match(r));)K.shift()}const ee=D.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return z(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const te=new y.$Hc;for(const D of O){const z=X(D);for(let ee=0;ee<=z.length;ee++)te.add(z.slice(0,ee).join(`
`),D)}O.sort((0,i.$7b)(D=>D.idx,i.$9b));let _="",Y=0;for(const D of O.slice(0,k)){Y++;const z=X(D),ee=[];for(let K=0;K<z.length;K++){let fe=z[K];fe=`(shared with ${te.get(z.slice(0,K+1).join(`
`)).size}/${O.length} leaks) at ${fe}`;const de=te.get(z.slice(0,K).join(`
`)),we=(0,F.$K)([...de].map($e=>X($e)[K]),$e=>$e);delete we[z[K]];for(const[$e,Me]of Object.entries(we))ee.unshift(`    - stacktraces of ${Me.length} other leaks continue with ${$e}`);ee.unshift(fe)}_+=`


==================== Leaking disposable ${Y}/${O.length}: ${D.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return O.length>k&&(_+=`


... and ${O.length-k} more leaking disposables

`),{leaks:O,details:_}}}t.$Jc=u;function c(T){l=T}if(h){const T="__is_disposable_tracked__";c(new class{trackDisposable(k){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[T]||console.log(x)},3e3)}setParent(k,x){if(k&&k!==n.None)try{k[T]=!0}catch{}}markAsDisposed(k){if(k&&k!==n.None)try{k[T]=!0}catch{}}markAsSingleton(k){}})}function B(T){return l?.trackDisposable(T),T}function b(T){l?.markAsDisposed(T)}function m(T,k){l?.setParent(T,k)}function e(T,k){if(l)for(const x of T)l.setParent(x,k)}function p(T){return l?.markAsSingleton(T),T}function j(T){return typeof T.dispose=="function"&&T.dispose.length===0}function N(T){if(L.Iterable.is(T)){const k=[];for(const x of T)if(x)try{x.dispose()}catch(O){k.push(O)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function $(T){for(const k of T)j(k)&&k.dispose();return[]}function d(...T){const k=a(()=>N(T));return e(T,k),k}function a(T){const k=B({dispose:(0,f.$db)(()=>{b(k),T()})});return k}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,B(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return m(k,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(k),k.dispose()}}deleteAndLeak(k){k&&this.f.has(k)&&(this.f.delete(k),m(k,null))}}t.$Tc=o;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,B(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(k)}}t.$Uc=n;class s{constructor(){this.b=!1,B(this)}get value(){return this.b?void 0:this.a}set value(k){this.b||k===this.a||(this.a?.dispose(),k&&m(k,this),this.a=k)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const k=this.a;return this.a=void 0,k&&m(k,null),k}}t.$Vc=s;class v{constructor(k){this.a=new s,this.b=!1,this.a.value=k}get value(){return this.a.value}set value(k){this.b||k===this.a.value||(this.a.value=k)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=v;class g{constructor(k){this.b=k,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=g;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(k){let x=k;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,b(this))},this}}t.$Yc=w;class A{constructor(){this.a=new Map}acquire(k,...x){let O=this.a.get(k);O||(O={counter:0,object:this.b(k,...x)},this.a.set(k,O));const{object:X}=O,te=(0,f.$db)(()=>{--O.counter===0&&(this.c(k,O.object),this.a.delete(k))});return O.counter++,{object:X,dispose:te}}}t.$Zc=A;class E{constructor(k){this.a=k}async acquire(k,...x){const O=this.a.acquire(k,...x);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(X){throw O.dispose(),X}}}t.$1c=E;class M{constructor(k){this.object=k}dispose(){}}t.$2c=M;function P(T){const k=new o;try{T(k)}finally{k.dispose()}}class R{constructor(){this.a=new Map,this.b=!1,B(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(k){return this.a.has(k)}get size(){return this.a.size}get(k){return this.a.get(k)}set(k,x,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(k)?.dispose(),this.a.set(k,x)}deleteAndDispose(k){this.a.get(k)?.dispose(),this.a.delete(k)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=R}),ne(re[23],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(f){return new F(f)}constructor(f){this.c=i&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3d=F}),ne(re[11],se([0,1,3,19,10,21,23]),function(V,t,i,F,y,f,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$5d=t.Event=void 0,t.$6d=b;const h=!1,l=!1;var u;(function(P){P.None=()=>y.$Uc.None;function R(C){if(l){const{onDidAddListener:H}=C,Q=e.create();let Z=0;C.onDidAddListener=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),H?.()}}}function T(C,H){return ee(C,()=>{},0,void 0,!0,void 0,H)}P.defer=T;function k(C){return(H,Q=null,Z)=>{let ie=!1,ae;return ae=C(le=>{if(!ie)return ae?ae.dispose():ie=!0,H.call(Q,le)},null,Z),ie&&ae.dispose(),ae}}P.once=k;function x(C,H,Q){return D((Z,ie=null,ae)=>C(le=>Z.call(ie,H(le)),null,ae),Q)}P.map=x;function O(C,H,Q){return D((Z,ie=null,ae)=>C(le=>{H(le),Z.call(ie,le)},null,ae),Q)}P.forEach=O;function X(C,H,Q){return D((Z,ie=null,ae)=>C(le=>H(le)&&Z.call(ie,le),null,ae),Q)}P.filter=X;function te(C){return C}P.signal=te;function _(...C){return(H,Q=null,Z)=>{const ie=(0,y.$Rc)(...C.map(ae=>ae(le=>H.call(Q,le))));return z(ie,Z)}}P.any=_;function Y(C,H,Q,Z){let ie=Q;return x(C,ae=>(ie=H(ie,ae),ie),Z)}P.reduce=Y;function D(C,H){let Q;const Z={onWillAddFirstListener(){Q=C(ie.fire,ie)},onDidRemoveLastListener(){Q?.dispose()}};H||R(Z);const ie=new d(Z);return H?.add(ie),ie.event}function z(C,H){return H instanceof Array?H.push(C):H&&H.add(C),C}function ee(C,H,Q=100,Z=!1,ie=!1,ae,le){let he,ge,Re,ke=0,Fe;const xe={leakWarningThreshold:ae,onWillAddFirstListener(){he=C(ve=>{ke++,ge=H(ge,ve),Z&&!Re&&(Pe.fire(ge),ge=void 0),Fe=()=>{const Oe=ge;ge=void 0,Re=void 0,(!Z||ke>1)&&Pe.fire(Oe),ke=0},typeof Q=="number"?(clearTimeout(Re),Re=setTimeout(Fe,Q)):Re===void 0&&(Re=0,queueMicrotask(Fe))})},onWillRemoveListener(){ie&&ke>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,he.dispose()}};le||R(xe);const Pe=new d(xe);return le?.add(Pe),Pe.event}P.debounce=ee;function K(C,H=0,Q){return P.debounce(C,(Z,ie)=>Z?(Z.push(ie),Z):[ie],H,void 0,!0,void 0,Q)}P.accumulate=K;function fe(C,H=(Z,ie)=>Z===ie,Q){let Z=!0,ie;return X(C,ae=>{const le=Z||!H(ae,ie);return Z=!1,ie=ae,le},Q)}P.latch=fe;function r(C,H,Q){return[P.filter(C,H,Q),P.filter(C,Z=>!H(Z),Q)]}P.split=r;function de(C,H=!1,Q=[],Z){let ie=Q.slice(),ae=C(ge=>{ie?ie.push(ge):he.fire(ge)});Z&&Z.add(ae);const le=()=>{ie?.forEach(ge=>he.fire(ge)),ie=null},he=new d({onWillAddFirstListener(){ae||(ae=C(ge=>he.fire(ge)),Z&&Z.add(ae))},onDidAddFirstListener(){ie&&(H?setTimeout(le):le())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return Z&&Z.add(he),he.event}P.buffer=de;function we(C,H){return(Z,ie,ae)=>{const le=H(new Me);return C(function(he){const ge=le.evaluate(he);ge!==$e&&Z.call(ie,ge)},void 0,ae)}}P.chain=we;const $e=Symbol("HaltChainable");class Me{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(Q=>(H(Q),Q)),this}filter(H){return this.f.push(Q=>H(Q)?Q:$e),this}reduce(H,Q){let Z=Q;return this.f.push(ie=>(Z=H(Z,ie),Z)),this}latch(H=(Q,Z)=>Q===Z){let Q=!0,Z;return this.f.push(ie=>{const ae=Q||!H(ie,Z);return Q=!1,Z=ie,ae?ie:$e}),this}evaluate(H){for(const Q of this.f)if(H=Q(H),H===$e)break;return H}}function ye(C,H,Q=Z=>Z){const Z=(...he)=>le.fire(Q(...he)),ie=()=>C.on(H,Z),ae=()=>C.removeListener(H,Z),le=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:ae});return le.event}P.fromNodeEventEmitter=ye;function Te(C,H,Q=Z=>Z){const Z=(...he)=>le.fire(Q(...he)),ie=()=>C.addEventListener(H,Z),ae=()=>C.removeEventListener(H,Z),le=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:ae});return le.event}P.fromDOMEventEmitter=Te;function Se(C){return new Promise(H=>k(C)(H))}P.toPromise=Se;function Be(C){const H=new d;return C.then(Q=>{H.fire(Q)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}P.fromPromise=Be;function Ee(C,H,Q){return H(Q),C(Z=>H(Z))}P.runAndSubscribe=Ee;class q{constructor(H,Q){this._observable=H,this.f=0,this.g=!1;const Z={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};Q||R(Z),this.emitter=new d(Z),Q&&Q.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,Q){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function G(C,H){return new q(C,H).emitter.event}P.fromObservable=G;function W(C){return(H,Q,Z)=>{let ie=0,ae=!1;const le={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(C.reportChanges(),ae&&(ae=!1,H.call(Q)))},handlePossibleChange(){},handleChange(){ae=!0}};C.addObserver(le),C.reportChanges();const he={dispose(){C.removeObserver(le)}};return Z instanceof y.$Tc?Z.add(he):Array.isArray(Z)&&Z.push(he),he}}P.fromObservableLight=W})(u||(t.Event=u={}));class c{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${c.f++}`,c.all.add(this)}start(R){this.g=new L.$3d,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}t.$5d=c;let B=-1;function b(P){const R=B;return B=P,{dispose(){B=R}}}class m{constructor(R,T=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=T,this.g=0}dispose(){this.f?.clear()}check(R,T){const k=this.threshold;if(k<=0||T<k)return;this.f||(this.f=new Map);const x=this.f.get(R.value)||0;if(this.f.set(R.value,x+1),this.g-=1,this.g<=0){this.g=k*.5;let O,X=0;for(const[te,_]of this.f)(!O||X<_)&&(O=te,X=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${X}):`),console.warn(O)}return()=>{const O=this.f.get(R.value)||0;this.f.set(R.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class j{constructor(R){this.value=R,this.id=p++}}const N=2,$=(P,R)=>{if(P instanceof j)R(P);else for(let T=0;T<P.length;T++){const k=P[T];k&&R(k)}};class d{constructor(R){this.w=0,this.f=R,this.g=B>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??B):void 0,this.j=this.f?._profName?new c(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const R=this.t;queueMicrotask(()=>{$(R,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,T,k)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),y.$Uc.None;if(this.m)return y.$Uc.None;T&&(R=R.bind(T));const x=new j(R);let O,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(x.stack=e.create(),O=this.g.check(x.stack,this.w+1)),h&&(x.stack=X??e.create()),this.t?this.t instanceof j?(this.u??=new o,this.t=[this.t,x]):this.t.push(x):(this.f?.onWillAddFirstListener?.(this),this.t=x,this.f?.onDidAddFirstListener?.(this)),this.w++;const te=(0,y.$Sc)(()=>{O?.(),this.x(x)});return k instanceof y.$Tc?k.add(te):Array.isArray(k)&&k.push(te),te},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,k=T.indexOf(R);if(k===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[k]=void 0;const x=this.u.current===this;if(this.w*N<=T.length){let O=0;for(let X=0;X<T.length;X++)T[X]?T[O++]=T[X]:x&&(this.u.end--,O<this.u.i&&this.u.i--);T.length=O}}y(R,T){if(!R)return;const k=this.f?.onListenerError||i.$1;if(!k){R.value(T);return}try{R.value(T)}catch(x){k(x)}}z(R){const T=R.current.t;for(;R.i<R.end;)this.y(T[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof j)this.y(this.t,R);else{const T=this.u;T.enqueue(this,R,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}t.$7d=d;const a=()=>new o;t.$8d=a;class o{constructor(){this.i=-1,this.end=0}enqueue(R,T,k){this.i=0,this.end=k,this.current=R,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends d{async fireAsync(R,T,k){if(this.t)for(this.h||(this.h=new f.$5c),$(this.t,x=>this.h.push([x.value,R]));this.h.size>0&&!T.isCancellationRequested;){const[x,O]=this.h.shift(),X=[],te={...O,token:T,waitUntil:_=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");k&&(_=k(_,x)),X.push(_)}};try{x(te)}catch(_){(0,i.$1)(_);continue}Object.freeze(X),await Promise.allSettled(X).then(_=>{for(const Y of _)Y.status==="rejected"&&(0,i.$1)(Y.reason)})}}}t.$9d=n;class s extends d{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new f.$5c,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}t.$0d=s;class v extends s{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}t.$$d=v;class g extends d{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}t.$_d=g;class w{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const T={event:R,listener:null};this.h.push(T),this.g&&this.m(T);const k=()=>{this.g&&this.o(T);const x=this.h.indexOf(T);this.h.splice(x,1)};return(0,y.$Sc)((0,F.$db)(k))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(T=>this.f.fire(T))}o(R){R.listener?.dispose(),R.listener=null}dispose(){this.f.dispose();for(const R of this.h)R.listener?.dispose();this.h=[]}}t.$ae=w;class A{constructor(R,T,k,x){this.f=new y.$Tc;const O=this.f.add(new w),X=this.f.add(new y.$4c);function te(_){X.set(_,O.add(x(_)))}for(const _ of R)te(_);this.f.add(T(_=>{te(_)})),this.f.add(k(_=>{X.deleteAndDispose(_)})),this.event=O.event}dispose(){this.f.dispose()}}t.$be=A;class E{constructor(){this.f=[]}wrapEvent(R){return(T,k,x)=>R(O=>{const X=this.f[this.f.length-1];X?X.push(()=>T.call(k,O)):T.call(k,O)},void 0,x)}bufferEvents(R){const T=[];this.f.push(T);const k=R();return this.f.pop(),T.forEach(x=>x()),k}}t.$ce=E;class M{constructor(){this.f=!1,this.g=u.None,this.h=y.$Uc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$de=M}),ne(re[24],se([0,1,11]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.CancellationToken=void 0;const F=Object.freeze(function(h,l){const u=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(u)}}});var y;(function(h){function l(u){return u===h.None||u===h.Cancelled||u instanceof f?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(y||(t.CancellationToken=y={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new i.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=y.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=y.None}}t.$ee=L}),ne(re[40],se([0,1,24]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.$Pe=void 0;class F{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new i.$ee,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Pe=F;class y{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const l=JSON.stringify(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}t.$Qe=y;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const l=this.b(h);return this.a.set(h,l),l}}t.$Re=f}),ne(re[7],se([0,1,40,39]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.$Rf=t.GraphemeBreakType=t.$Hf=t.$Bf=t.$uf=t.$tf=void 0,t.$Ue=y,t.$Ve=L,t.$We=l,t.$Xe=u,t.$Ye=c,t.$Ze=B,t.$1e=b,t.$2e=m,t.$3e=e,t.$4e=p,t.$5e=j,t.$6e=N,t.$7e=$,t.$8e=d,t.$9e=a,t.$0e=o,t.$$e=n,t.$_e=s,t.$af=v,t.$bf=g,t.$cf=w,t.$df=A,t.$ef=E,t.$ff=M,t.$gf=P,t.$hf=R,t.$if=T,t.$jf=k,t.$kf=x,t.$lf=O,t.$mf=X,t.$nf=te,t.$of=_,t.$pf=Y,t.$qf=D,t.$rf=z,t.$sf=ee,t.$vf=de,t.$wf=we,t.$xf=$e,t.$yf=Me,t.$zf=Se,t.$Af=Ee,t.$Cf=q,t.$Df=G,t.$Ef=W,t.$Ff=C,t.$Gf=Z,t.$If=ie,t.$Jf=ae,t.$Kf=le,t.$Lf=he,t.$Mf=ge,t.$Nf=Re,t.$Of=ke,t.$Pf=Fe,t.$Qf=He;function y(S){return!S||typeof S!="string"?!0:S.trim().length===0}const f=/{(\d+)}/g;function L(S,...I){return I.length===0?S:S.replace(f,function(J,U){const ue=parseInt(U,10);return isNaN(ue)||ue<0||ue>=I.length?J:I[ue]})}const h=/{([^}]+)}/g;function l(S,I){return Object.keys(I).length===0?S:S.replace(h,(J,U)=>I[U]??J)}function u(S){return S.replace(/[<>"'&]/g,I=>{switch(I){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return I})}function c(S){return S.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}function B(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(S,I){let J=0;const U=I.charCodeAt(0);for(let ue=S.length-1;ue>=0;ue--)S.charCodeAt(ue)===U&&J++;return J}function m(S,I,J="\u2026"){return S.length<=I?S:`${S.substr(0,I)}${J}`}function e(S,I,J="\u2026"){if(S.length<=I)return S;const U=Math.ceil(I/2)-J.length/2,ue=Math.floor(I/2)-J.length/2;return`${S.substr(0,U)}${J}${S.substr(S.length-ue)}`}function p(S,I=" "){const J=j(S,I);return N(J,I)}function j(S,I){if(!S||!I)return S;const J=I.length;if(J===0||S.length===0)return S;let U=0;for(;S.indexOf(I,U)===U;)U=U+J;return S.substring(U)}function N(S,I){if(!S||!I)return S;const J=I.length,U=S.length;if(J===0||U===0)return S;let ue=U,oe=-1;for(;oe=S.lastIndexOf(I,ue-1),!(oe===-1||oe+J!==ue);){if(oe===0)return"";ue=oe}return S.substring(0,ue)}function $(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(S){return S.replace(/\*/g,"")}function a(S,I,J={}){if(!S)throw new Error("Cannot create regex from empty string");I||(S=B(S)),J.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let U="";return J.global&&(U+="g"),J.matchCase||(U+="i"),J.multiline&&(U+="m"),J.unicode&&(U+="u"),new RegExp(S,U)}function o(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}function n(S){return S.split(/\r\n|\r|\n/)}function s(S){const I=[],J=S.split(/(\r\n|\r|\n)/);for(let U=0;U<Math.ceil(J.length/2);U++)I.push(J[2*U]+(J[2*U+1]??""));return I}function v(S){for(let I=0,J=S.length;I<J;I++){const U=S.charCodeAt(I);if(U!==32&&U!==9)return I}return-1}function g(S,I=0,J=S.length){for(let U=I;U<J;U++){const ue=S.charCodeAt(U);if(ue!==32&&ue!==9)return S.substring(I,U)}return S.substring(I,J)}function w(S,I=S.length-1){for(let J=I;J>=0;J--){const U=S.charCodeAt(J);if(U!==32&&U!==9)return J}return-1}function A(S,I,J){const U=[];let ue=0;for(const oe of S.matchAll(I)){if(U.push(S.slice(ue,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ue=oe.index+oe[0].length,U.push(J(oe[0],...oe.slice(1),oe.index,S,oe.groups))}return U.push(S.slice(ue)),Promise.all(U).then(oe=>oe.join(""))}function E(S,I){return S<I?-1:S>I?1:0}function M(S,I,J=0,U=S.length,ue=0,oe=I.length){for(;J<U&&ue<oe;J++,ue++){const Le=S.charCodeAt(J),Ne=I.charCodeAt(ue);if(Le<Ne)return-1;if(Le>Ne)return 1}const me=U-J,je=oe-ue;return me<je?-1:me>je?1:0}function P(S,I){return R(S,I,0,S.length,0,I.length)}function R(S,I,J=0,U=S.length,ue=0,oe=I.length){for(;J<U&&ue<oe;J++,ue++){let Le=S.charCodeAt(J),Ne=I.charCodeAt(ue);if(Le===Ne)continue;if(Le>=128||Ne>=128)return M(S.toLowerCase(),I.toLowerCase(),J,U,ue,oe);k(Le)&&(Le-=32),k(Ne)&&(Ne-=32);const be=Le-Ne;if(be!==0)return be}const me=U-J,je=oe-ue;return me<je?-1:me>je?1:0}function T(S){return S>=48&&S<=57}function k(S){return S>=97&&S<=122}function x(S){return S>=65&&S<=90}function O(S,I){return S.length===I.length&&R(S,I)===0}function X(S,I){const J=I.length;return I.length>S.length?!1:R(S,I,0,J)===0}function te(S,I){const J=Math.min(S.length,I.length);let U;for(U=0;U<J;U++)if(S.charCodeAt(U)!==I.charCodeAt(U))return U;return J}function _(S,I){const J=Math.min(S.length,I.length);let U;const ue=S.length-1,oe=I.length-1;for(U=0;U<J;U++)if(S.charCodeAt(ue-U)!==I.charCodeAt(oe-U))return U;return J}function Y(S){return 55296<=S&&S<=56319}function D(S){return 56320<=S&&S<=57343}function z(S,I){return(S-55296<<10)+(I-56320)+65536}function ee(S,I,J){const U=S.charCodeAt(J);if(Y(U)&&J+1<I){const ue=S.charCodeAt(J+1);if(D(ue))return z(U,ue)}return U}function K(S,I){const J=S.charCodeAt(I-1);if(D(J)&&I>1){const U=S.charCodeAt(I-2);if(Y(U))return z(U,J)}return J}class fe{get offset(){return this.e}constructor(I,J=0){this.c=I,this.d=I.length,this.e=J}setOffset(I){this.e=I}prevCodePoint(){const I=K(this.c,this.e);return this.e-=I>=65536?2:1,I}nextCodePoint(){const I=ee(this.c,this.d,this.e);return this.e+=I>=65536?2:1,I}eol(){return this.e>=this.d}}t.$tf=fe;class r{get offset(){return this.c.offset}constructor(I,J=0){this.c=new fe(I,J)}nextGraphemeLength(){const I=ve.getInstance(),J=this.c,U=J.offset;let ue=I.getGraphemeBreakType(J.nextCodePoint());for(;!J.eol();){const oe=J.offset,me=I.getGraphemeBreakType(J.nextCodePoint());if(xe(ue,me)){J.setOffset(oe);break}ue=me}return J.offset-U}prevGraphemeLength(){const I=ve.getInstance(),J=this.c,U=J.offset;let ue=I.getGraphemeBreakType(J.prevCodePoint());for(;J.offset>0;){const oe=J.offset,me=I.getGraphemeBreakType(J.prevCodePoint());if(xe(me,ue)){J.setOffset(oe);break}ue=me}return U-J.offset}eol(){return this.c.eol()}}t.$uf=r;function de(S,I){return new r(S,I).nextGraphemeLength()}function we(S,I){return new r(S,I).prevGraphemeLength()}function $e(S,I){I>0&&D(S.charCodeAt(I))&&I--;const J=I+de(S,I);return[J-we(S,J),J]}function Me(S){const I=new r(S);let J=0;for(;!I.eol();)J++,I.nextGraphemeLength();return J}let ye;function Te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(S){return ye||(ye=Te()),ye.test(S)}const Be=/^[\t\n\r\x20-\x7E]*$/;function Ee(S){return Be.test(S)}t.$Bf=/[\u2028\u2029]/;function q(S){return t.$Bf.test(S)}function G(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}function W(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}function C(S,I,J=""){const U=S.trimStart();if(U.length<I)return U;const ue=/\b/g;let oe=0;for(;ue.test(U)&&!(U.length-ue.lastIndex<I);)oe=ue.lastIndex,ue.lastIndex+=1;return oe===0?U:J+U.substring(oe).trimStart()}const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Q=/\x1b\].*?\x07/g;function Z(S){return S&&(S=S.replace(H,"").replace(Q,"")),S}t.$Hf="\uFEFF";function ie(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}function ae(S){return ie(S)?S.substr(1):S}function le(S,I){if(!S||!I||S.length<I.length)return!1;const J=I.length,U=S.toLowerCase();let ue=0,oe=-1;for(;ue<J;){const me=U.indexOf(I[ue],oe+1);if(me<0)return!1;oe=me,ue++}return!0}function he(S,I=!1){return S?(I&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}function ge(S){return S.charAt(0).toUpperCase()+S.slice(1)}function Re(S,I=1){if(I===0)return"";let J=-1;do J=S.indexOf(`
`,J+1),I--;while(I>0&&J>=0);return J===-1?S:(S[J-1]==="\r"&&J--,S.substr(0,J))}function ke(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}function Fe(S){return ve.getInstance().getGraphemeBreakType(S)}function xe(S,I){return S===0?I!==5&&I!==7:S===2&&I===3?!1:S===4||S===2||S===3||I===4||I===2||I===3?!0:!(S===8&&(I===8||I===9||I===11||I===12)||(S===11||S===9)&&(I===9||I===10)||(S===12||S===10)&&I===10||I===5||I===13||I===7||S===1||S===13&&I===14||S===6&&I===6)}var Pe;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Oe()}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const J=this.d,U=J.length/3;let ue=1;for(;ue<=U;)if(I<J[3*ue])ue=2*ue;else if(I>J[3*ue+1])ue=2*ue+1;else return J[3*ue+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(S,I){if(S===0)return 0;const J=Ge(S,I);if(J!==void 0)return J;const U=new fe(I,S);return U.prevCodePoint(),U.offset}function Ge(S,I){const J=new fe(I,S);let U=J.prevCodePoint();for(;Xe(U)||U===65039||U===8419;){if(J.offset===0)return;U=J.prevCodePoint()}if(!W(U))return;let ue=J.offset;return ue>0&&J.prevCodePoint()===8205&&(ue=J.offset),ue}function Xe(S){return 127995<=S&&S<=127999}var We;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$Rf="\xA0";class De{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Qe(I=>{function J(be){const Ae=new Map;for(let pe=0;pe<be.length;pe+=2)Ae.set(be[pe],be[pe+1]);return Ae}function U(be,Ae){const pe=new Map(be);for(const[qe,Ve]of Ae)pe.set(qe,Ve);return pe}function ue(be,Ae){if(!be)return Ae;const pe=new Map;for(const[qe,Ve]of be)Ae.has(qe)&&pe.set(qe,Ve);return pe}const oe=this.c.value;let me=I.filter(be=>!be.startsWith("_")&&be in oe);me.length===0&&(me=["_default"]);let je;for(const be of me){const Ae=J(oe[be]);je=ue(je,Ae)}const Le=J(oe._common),Ne=U(Le,je);return new De(Ne)})}static getInstance(I){return De.d.get(Array.from(I))}static{this.e=new F.$V(()=>Object.keys(De.c.value).filter(I=>!I.startsWith("_")))}static getLocales(){return De.e.value}constructor(I){this.f=I}isAmbiguous(I){return this.f.has(I)}getPrimaryConfusable(I){return this.f.get(I)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Sf=De;class Ie{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ie.c())),this.d}static isInvisibleCharacter(I){return Ie.e().has(I)}static get codePoints(){return Ie.e()}}t.$Tf=Ie}),ne(re[41],se([0,1,7]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bj=t.$_i=void 0,t.$8i=F,t.$9i=y,t.$0i=f,t.$$i=h,t.$aj=p;function F(N){return y(N,0)}function y(N,$){switch(typeof N){case"object":return N===null?f(349,$):Array.isArray(N)?l(N,$):u(N,$);case"string":return h(N,$);case"boolean":return L(N,$);case"number":return f(N,$);case"undefined":return f(937,$);default:return f(617,$)}}function f(N,$){return($<<5)-$+N|0}function L(N,$){return f(N?433:863,$)}function h(N,$){$=f(149417,$);for(let d=0,a=N.length;d<a;d++)$=f(N.charCodeAt(d),$);return $}function l(N,$){return $=f(104579,$),N.reduce((d,a)=>y(a,d),$)}function u(N,$){return $=f(181387,$),Object.keys(N).sort().reduce((d,a)=>(d=h(a,d),y(N[a],d)),$)}class c{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}t.$_i=c;var B;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(B||(B={}));function b(N,$,d=32){const a=d-$,o=~((1<<a)-1);return(N<<$|(o&N)>>>a)>>>0}function m(N,$=0,d=N.byteLength,a=0){for(let o=0;o<d;o++)N[$+o]=a}function e(N,$,d="0"){for(;N.length<$;)N=d+N;return N}function p(N,$=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),$/4)}class j{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const d=$.length;if(d===0)return;const a=this.p;let o=this.r,n=this.u,s,v;for(n!==0?(s=n,v=-1,n=0):(s=$.charCodeAt(0),v=0);;){let g=s;if(i.$pf(s))if(v+1<d){const w=$.charCodeAt(v+1);i.$qf(w)?(v++,g=i.$rf(s,w)):g=65533}else{n=s;break}else i.$qf(s)&&(g=65533);if(o=this.w(a,o,g),v++,v<d)s=$.charCodeAt(v);else break}this.r=o,this.u=n}w($,d,a){return a<128?$[d++]=a:a<2048?($[d++]=192|(a&1984)>>>6,$[d++]=128|(a&63)>>>0):a<65536?($[d++]=224|(a&61440)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0):($[d++]=240|(a&1835008)>>>18,$[d++]=128|(a&258048)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=j.g,d=this.q;for(let E=0;E<64;E+=4)$.setUint32(E,d.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)$.setUint32(E,b($.getUint32(E-12,!1)^$.getUint32(E-32,!1)^$.getUint32(E-56,!1)^$.getUint32(E-64,!1),1),!1);let a=this.h,o=this.l,n=this.m,s=this.n,v=this.o,g,w,A;for(let E=0;E<80;E++)E<20?(g=o&n|~o&s,w=1518500249):E<40?(g=o^n^s,w=1859775393):E<60?(g=o&n|o&s|n&s,w=2400959708):(g=o^n^s,w=3395469782),A=b(a,5)+g+v+w+$.getUint32(E*4,!1)&4294967295,v=s,s=n,n=b(o,30),o=a,a=A;this.h=this.h+a&4294967295,this.l=this.l+o&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+v&4294967295}}t.$bj=j}),ne(re[25],se([0,1,37,41]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=t.$et=void 0,t.$ft=f;class y{constructor(b){this.a=b}getElements(){const b=this.a,m=new Int32Array(b.length);for(let e=0,p=b.length;e<p;e++)m[e]=b.charCodeAt(e);return m}}t.$et=y;function f(B,b,m){return new c(new y(B),new y(b)).ComputeDiff(m).changes}class L{static Assert(b,m){if(!b)throw new Error(m)}}class h{static Copy(b,m,e,p,j){for(let N=0;N<j;N++)e[p+N]=b[m+N]}static Copy2(b,m,e,p,j){for(let N=0;N<j;N++)e[p+N]=b[m+N]}}var l;(function(B){B[B.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$dt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(b,m,e=null){this.a=e,this.b=b,this.c=m;const[p,j,N]=c.o(b),[$,d,a]=c.o(m);this.d=N&&a,this.e=p,this.f=j,this.g=$,this.h=d,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const m=b.getElements();if(c.n(m)){const e=new Int32Array(m.length);for(let p=0,j=m.length;p<j;p++)e[p]=(0,F.$$i)(m[p],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(b,m){return this.f[b]!==this.h[m]?!1:this.d?this.e[b]===this.g[m]:!0}q(b,m){if(!this.p(b,m))return!1;const e=c.r(this.b,b),p=c.r(this.c,m);return e===p}static r(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}s(b,m){return this.f[b]!==this.f[m]?!1:this.d?this.e[b]===this.e[m]:!0}u(b,m){return this.h[b]!==this.h[m]?!1:this.d?this.g[b]===this.g[m]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,m,e,p,j){const N=[!1];let $=this.w(b,m,e,p,N);return j&&($=this.z($)),{quitEarly:N[0],changes:$}}w(b,m,e,p,j){for(j[0]=!1;b<=m&&e<=p&&this.p(b,e);)b++,e++;for(;m>=b&&p>=e&&this.p(m,p);)m--,p--;if(b>m||e>p){let n;return e<=p?(L.Assert(b===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$dt(b,0,e,p-e+1)]):b<=m?(L.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$dt(b,m-b+1,e,0)]):(L.Assert(b===m+1,"originalStart should only be one more than originalEnd"),L.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const N=[0],$=[0],d=this.y(b,m,e,p,N,$,j),a=N[0],o=$[0];if(d!==null)return d;if(!j[0]){const n=this.w(b,a,e,o,j);let s=[];return j[0]?s=[new i.$dt(a+1,m-(a+1)+1,o+1,p-(o+1)+1)]:s=this.w(a+1,m,o+1,p,j),this.H(n,s)}return[new i.$dt(b,m-b+1,e,p-e+1)]}x(b,m,e,p,j,N,$,d,a,o,n,s,v,g,w,A,E,M){let P=null,R=null,T=new u,k=m,x=e,O=v[0]-A[0]-p,X=-1073741824,te=this.k.length-1;do{const _=O+b;_===k||_<x&&a[_-1]<a[_+1]?(n=a[_+1],g=n-O-p,n<X&&T.MarkNextChange(),X=n,T.AddModifiedElement(n+1,g),O=_+1-b):(n=a[_-1]+1,g=n-O-p,n<X&&T.MarkNextChange(),X=n-1,T.AddOriginalElement(n,g+1),O=_-1-b),te>=0&&(a=this.k[te],b=a[0],k=1,x=a.length-1)}while(--te>=-1);if(P=T.getReverseChanges(),M[0]){let _=v[0]+1,Y=A[0]+1;if(P!==null&&P.length>0){const D=P[P.length-1];_=Math.max(_,D.getOriginalEnd()),Y=Math.max(Y,D.getModifiedEnd())}R=[new i.$dt(_,s-_+1,Y,w-Y+1)]}else{T=new u,k=N,x=$,O=v[0]-A[0]-d,X=1073741824,te=E?this.m.length-1:this.m.length-2;do{const _=O+j;_===k||_<x&&o[_-1]>=o[_+1]?(n=o[_+1]-1,g=n-O-d,n>X&&T.MarkNextChange(),X=n+1,T.AddOriginalElement(n+1,g+1),O=_+1-j):(n=o[_-1],g=n-O-d,n>X&&T.MarkNextChange(),X=n,T.AddModifiedElement(n+1,g+1),O=_-1-j),te>=0&&(o=this.m[te],j=o[0],k=1,x=o.length-1)}while(--te>=-1);R=T.getChanges()}return this.H(P,R)}y(b,m,e,p,j,N,$){let d=0,a=0,o=0,n=0,s=0,v=0;b--,e--,j[0]=0,N[0]=0,this.k=[],this.m=[];const g=m-b+(p-e),w=g+1,A=new Int32Array(w),E=new Int32Array(w),M=p-e,P=m-b,R=b-e,T=m-p,x=(P-M)%2===0;A[M]=b,E[P]=m,$[0]=!1;for(let O=1;O<=g/2+1;O++){let X=0,te=0;o=this.J(M-O,O,M,w),n=this.J(M+O,O,M,w);for(let Y=o;Y<=n;Y+=2){Y===o||Y<n&&A[Y-1]<A[Y+1]?d=A[Y+1]:d=A[Y-1]+1,a=d-(Y-M)-R;const D=d;for(;d<m&&a<p&&this.p(d+1,a+1);)d++,a++;if(A[Y]=d,d+a>X+te&&(X=d,te=a),!x&&Math.abs(Y-P)<=O-1&&d>=E[Y])return j[0]=d,N[0]=a,D<=E[Y]&&1447>0&&O<=1448?this.x(M,o,n,R,P,s,v,T,A,E,d,m,j,a,p,N,x,$):null}const _=(X-b+(te-e)-O)/2;if(this.a!==null&&!this.a(X,_))return $[0]=!0,j[0]=X,N[0]=te,_>0&&1447>0&&O<=1448?this.x(M,o,n,R,P,s,v,T,A,E,d,m,j,a,p,N,x,$):(b++,e++,[new i.$dt(b,m-b+1,e,p-e+1)]);s=this.J(P-O,O,P,w),v=this.J(P+O,O,P,w);for(let Y=s;Y<=v;Y+=2){Y===s||Y<v&&E[Y-1]>=E[Y+1]?d=E[Y+1]-1:d=E[Y-1],a=d-(Y-P)-T;const D=d;for(;d>b&&a>e&&this.p(d,a);)d--,a--;if(E[Y]=d,x&&Math.abs(Y-M)<=O&&d<=A[Y])return j[0]=d,N[0]=a,D>=A[Y]&&1447>0&&O<=1448?this.x(M,o,n,R,P,s,v,T,A,E,d,m,j,a,p,N,x,$):null}if(O<=1447){let Y=new Int32Array(n-o+2);Y[0]=M-o+1,h.Copy2(A,o,Y,1,n-o+1),this.k.push(Y),Y=new Int32Array(v-s+2),Y[0]=P-s+1,h.Copy2(E,s,Y,1,v-s+1),this.m.push(Y)}}return this.x(M,o,n,R,P,s,v,T,A,E,d,m,j,a,p,N,x,$)}z(b){for(let m=0;m<b.length;m++){const e=b[m],p=m<b.length-1?b[m+1].originalStart:this.f.length,j=m<b.length-1?b[m+1].modifiedStart:this.h.length,N=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<p&&e.modifiedStart+e.modifiedLength<j&&(!N||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const d=[null];if(m<b.length-1&&this.I(b[m],b[m+1],d)){b[m]=d[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let p=0,j=0;if(m>0){const n=b[m-1];p=n.originalStart+n.originalLength,j=n.modifiedStart+n.modifiedLength}const N=e.originalLength>0,$=e.modifiedLength>0;let d=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,v=e.modifiedStart-n;if(s<p||v<j||N&&!this.s(s,s+e.originalLength)||$&&!this.u(v,v+e.modifiedLength))break;const w=(s===p&&v===j?5:0)+this.G(s,e.originalLength,v,e.modifiedLength);w>a&&(a=w,d=n)}e.originalStart-=d,e.modifiedStart-=d;const o=[null];if(m>0&&this.I(b[m-1],b[m],o)){b[m-1]=o[0],b.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=b.length;m<e;m++){const p=b[m-1],j=b[m],N=j.originalStart-p.originalStart-p.originalLength,$=p.originalStart,d=j.originalStart+j.originalLength,a=d-$,o=p.modifiedStart,n=j.modifiedStart+j.modifiedLength,s=n-o;if(N<5&&a<20&&s<20){const v=this.A($,a,o,s,N);if(v){const[g,w]=v;(g!==p.originalStart+p.originalLength||w!==p.modifiedStart+p.modifiedLength)&&(p.originalLength=g-p.originalStart,p.modifiedLength=w-p.modifiedStart,j.originalStart=g+N,j.modifiedStart=w+N,j.originalLength=d-j.originalStart,j.modifiedLength=n-j.modifiedStart)}}}return b}A(b,m,e,p,j){if(m<j||p<j)return null;const N=b+m-j+1,$=e+p-j+1;let d=0,a=0,o=0;for(let n=b;n<N;n++)for(let s=e;s<$;s++){const v=this.B(n,s,j);v>0&&v>d&&(d=v,a=n,o=s)}return d>0?[a,o]:null}B(b,m,e){let p=0;for(let j=0;j<e;j++){if(!this.p(b+j,m+j))return 0;p+=this.e[b+j].length}return p}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,m){if(this.C(b)||this.C(b-1))return!0;if(m>0){const e=b+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,m){if(this.E(b)||this.E(b-1))return!0;if(m>0){const e=b+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,m,e,p){const j=this.D(b,m)?1:0,N=this.F(e,p)?1:0;return j+N}H(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.I(b[b.length-1],m[0],e)){const p=new Array(b.length+m.length-1);return h.Copy(b,0,p,0,b.length-1),p[b.length-1]=e[0],h.Copy(m,1,p,b.length,m.length-1),p}else{const p=new Array(b.length+m.length);return h.Copy(b,0,p,0,b.length),h.Copy(m,0,p,b.length,m.length),p}}I(b,m,e){if(L.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),L.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const p=b.originalStart;let j=b.originalLength;const N=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(j=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new i.$dt(p,j,N,$),!0}else return e[0]=null,!1}J(b,m,e,p){if(b>=0&&b<p)return b;const j=e,N=p-e-1,$=m%2===0;if(b<0){const d=j%2===0;return $===d?0:1}else{const d=N%2===0;return $===d?p-1:p-2}}}t.$gt=c}),ne(re[26],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=i,t.$Vf=F,t.$Wf=y,t.$Xf=f,t.$Yf=L,t.$Zf=h,t.$1f=l,t.$2f=u,t.$3f=c,t.$4f=B,t.$5f=b,t.$6f=m,t.$7f=e,t.$8f=j,t.$9f=N,t.$0f=$,t.$$f=d,t.$_f=a;function i(o){return typeof o=="string"}function F(o){return Array.isArray(o)&&o.every(n=>i(n))}function y(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function f(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function L(o){return typeof o=="number"&&!isNaN(o)}function h(o){return!!o&&typeof o[Symbol.iterator]=="function"}function l(o){return o===!0||o===!1}function u(o){return typeof o>"u"}function c(o){return!B(o)}function B(o){return u(o)||o===null}function b(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function m(o){if(B(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function e(...o){const n=[];for(let s=0;s<o.length;s++){const v=o[s];if(B(v))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(v)}return n}const p=Object.prototype.hasOwnProperty;function j(o){if(!y(o))return!1;for(const n in o)if(p.call(o,n))return!1;return!0}function N(o){return typeof o=="function"}function $(...o){return o.length>0&&o.every(N)}function d(o,n){const s=Math.min(o.length,n.length);for(let v=0;v<s;v++)a(o[v],n[v])}function a(o,n){if(i(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(N(n)){try{if(o instanceof n)return}catch{}if(!B(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(re[27],se([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bj=y,t.$Cj=f;const F=Object.create(null);function y(L,h){if((0,i.$Uf)(h)){const l=F[h];if(l===void 0)throw new Error(`${L} references an unknown codicon: ${h}`);h=l}return F[L]=h,{id:L}}function f(){return F}}),ne(re[42],se([0,1,27]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dj=void 0,t.$Dj={add:(0,i.$Bj)("add",6e4),plus:(0,i.$Bj)("plus",6e4),gistNew:(0,i.$Bj)("gist-new",6e4),repoCreate:(0,i.$Bj)("repo-create",6e4),lightbulb:(0,i.$Bj)("lightbulb",60001),lightBulb:(0,i.$Bj)("light-bulb",60001),repo:(0,i.$Bj)("repo",60002),repoDelete:(0,i.$Bj)("repo-delete",60002),gistFork:(0,i.$Bj)("gist-fork",60003),repoForked:(0,i.$Bj)("repo-forked",60003),gitPullRequest:(0,i.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Bj)("record-keys",60005),keyboard:(0,i.$Bj)("keyboard",60005),tag:(0,i.$Bj)("tag",60006),gitPullRequestLabel:(0,i.$Bj)("git-pull-request-label",60006),tagAdd:(0,i.$Bj)("tag-add",60006),tagRemove:(0,i.$Bj)("tag-remove",60006),person:(0,i.$Bj)("person",60007),personFollow:(0,i.$Bj)("person-follow",60007),personOutline:(0,i.$Bj)("person-outline",60007),personFilled:(0,i.$Bj)("person-filled",60007),gitBranch:(0,i.$Bj)("git-branch",60008),gitBranchCreate:(0,i.$Bj)("git-branch-create",60008),gitBranchDelete:(0,i.$Bj)("git-branch-delete",60008),sourceControl:(0,i.$Bj)("source-control",60008),mirror:(0,i.$Bj)("mirror",60009),mirrorPublic:(0,i.$Bj)("mirror-public",60009),star:(0,i.$Bj)("star",60010),starAdd:(0,i.$Bj)("star-add",60010),starDelete:(0,i.$Bj)("star-delete",60010),starEmpty:(0,i.$Bj)("star-empty",60010),comment:(0,i.$Bj)("comment",60011),commentAdd:(0,i.$Bj)("comment-add",60011),alert:(0,i.$Bj)("alert",60012),warning:(0,i.$Bj)("warning",60012),search:(0,i.$Bj)("search",60013),searchSave:(0,i.$Bj)("search-save",60013),logOut:(0,i.$Bj)("log-out",60014),signOut:(0,i.$Bj)("sign-out",60014),logIn:(0,i.$Bj)("log-in",60015),signIn:(0,i.$Bj)("sign-in",60015),eye:(0,i.$Bj)("eye",60016),eyeUnwatch:(0,i.$Bj)("eye-unwatch",60016),eyeWatch:(0,i.$Bj)("eye-watch",60016),circleFilled:(0,i.$Bj)("circle-filled",60017),primitiveDot:(0,i.$Bj)("primitive-dot",60017),closeDirty:(0,i.$Bj)("close-dirty",60017),debugBreakpoint:(0,i.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Bj)("primitive-square",60018),edit:(0,i.$Bj)("edit",60019),pencil:(0,i.$Bj)("pencil",60019),info:(0,i.$Bj)("info",60020),issueOpened:(0,i.$Bj)("issue-opened",60020),gistPrivate:(0,i.$Bj)("gist-private",60021),gitForkPrivate:(0,i.$Bj)("git-fork-private",60021),lock:(0,i.$Bj)("lock",60021),mirrorPrivate:(0,i.$Bj)("mirror-private",60021),close:(0,i.$Bj)("close",60022),removeClose:(0,i.$Bj)("remove-close",60022),x:(0,i.$Bj)("x",60022),repoSync:(0,i.$Bj)("repo-sync",60023),sync:(0,i.$Bj)("sync",60023),clone:(0,i.$Bj)("clone",60024),desktopDownload:(0,i.$Bj)("desktop-download",60024),beaker:(0,i.$Bj)("beaker",60025),microscope:(0,i.$Bj)("microscope",60025),vm:(0,i.$Bj)("vm",60026),deviceDesktop:(0,i.$Bj)("device-desktop",60026),file:(0,i.$Bj)("file",60027),fileText:(0,i.$Bj)("file-text",60027),more:(0,i.$Bj)("more",60028),ellipsis:(0,i.$Bj)("ellipsis",60028),kebabHorizontal:(0,i.$Bj)("kebab-horizontal",60028),mailReply:(0,i.$Bj)("mail-reply",60029),reply:(0,i.$Bj)("reply",60029),organization:(0,i.$Bj)("organization",60030),organizationFilled:(0,i.$Bj)("organization-filled",60030),organizationOutline:(0,i.$Bj)("organization-outline",60030),newFile:(0,i.$Bj)("new-file",60031),fileAdd:(0,i.$Bj)("file-add",60031),newFolder:(0,i.$Bj)("new-folder",60032),fileDirectoryCreate:(0,i.$Bj)("file-directory-create",60032),trash:(0,i.$Bj)("trash",60033),trashcan:(0,i.$Bj)("trashcan",60033),history:(0,i.$Bj)("history",60034),clock:(0,i.$Bj)("clock",60034),folder:(0,i.$Bj)("folder",60035),fileDirectory:(0,i.$Bj)("file-directory",60035),symbolFolder:(0,i.$Bj)("symbol-folder",60035),logoGithub:(0,i.$Bj)("logo-github",60036),markGithub:(0,i.$Bj)("mark-github",60036),github:(0,i.$Bj)("github",60036),terminal:(0,i.$Bj)("terminal",60037),console:(0,i.$Bj)("console",60037),repl:(0,i.$Bj)("repl",60037),zap:(0,i.$Bj)("zap",60038),symbolEvent:(0,i.$Bj)("symbol-event",60038),error:(0,i.$Bj)("error",60039),stop:(0,i.$Bj)("stop",60039),variable:(0,i.$Bj)("variable",60040),symbolVariable:(0,i.$Bj)("symbol-variable",60040),array:(0,i.$Bj)("array",60042),symbolArray:(0,i.$Bj)("symbol-array",60042),symbolModule:(0,i.$Bj)("symbol-module",60043),symbolPackage:(0,i.$Bj)("symbol-package",60043),symbolNamespace:(0,i.$Bj)("symbol-namespace",60043),symbolObject:(0,i.$Bj)("symbol-object",60043),symbolMethod:(0,i.$Bj)("symbol-method",60044),symbolFunction:(0,i.$Bj)("symbol-function",60044),symbolConstructor:(0,i.$Bj)("symbol-constructor",60044),symbolBoolean:(0,i.$Bj)("symbol-boolean",60047),symbolNull:(0,i.$Bj)("symbol-null",60047),symbolNumeric:(0,i.$Bj)("symbol-numeric",60048),symbolNumber:(0,i.$Bj)("symbol-number",60048),symbolStructure:(0,i.$Bj)("symbol-structure",60049),symbolStruct:(0,i.$Bj)("symbol-struct",60049),symbolParameter:(0,i.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Bj)("symbol-type-parameter",60050),symbolKey:(0,i.$Bj)("symbol-key",60051),symbolText:(0,i.$Bj)("symbol-text",60051),symbolReference:(0,i.$Bj)("symbol-reference",60052),goToFile:(0,i.$Bj)("go-to-file",60052),symbolEnum:(0,i.$Bj)("symbol-enum",60053),symbolValue:(0,i.$Bj)("symbol-value",60053),symbolRuler:(0,i.$Bj)("symbol-ruler",60054),symbolUnit:(0,i.$Bj)("symbol-unit",60054),activateBreakpoints:(0,i.$Bj)("activate-breakpoints",60055),archive:(0,i.$Bj)("archive",60056),arrowBoth:(0,i.$Bj)("arrow-both",60057),arrowDown:(0,i.$Bj)("arrow-down",60058),arrowLeft:(0,i.$Bj)("arrow-left",60059),arrowRight:(0,i.$Bj)("arrow-right",60060),arrowSmallDown:(0,i.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Bj)("arrow-small-up",60064),arrowUp:(0,i.$Bj)("arrow-up",60065),bell:(0,i.$Bj)("bell",60066),bold:(0,i.$Bj)("bold",60067),book:(0,i.$Bj)("book",60068),bookmark:(0,i.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Bj)("briefcase",60076),broadcast:(0,i.$Bj)("broadcast",60077),browser:(0,i.$Bj)("browser",60078),bug:(0,i.$Bj)("bug",60079),calendar:(0,i.$Bj)("calendar",60080),caseSensitive:(0,i.$Bj)("case-sensitive",60081),check:(0,i.$Bj)("check",60082),checklist:(0,i.$Bj)("checklist",60083),chevronDown:(0,i.$Bj)("chevron-down",60084),chevronLeft:(0,i.$Bj)("chevron-left",60085),chevronRight:(0,i.$Bj)("chevron-right",60086),chevronUp:(0,i.$Bj)("chevron-up",60087),chromeClose:(0,i.$Bj)("chrome-close",60088),chromeMaximize:(0,i.$Bj)("chrome-maximize",60089),chromeMinimize:(0,i.$Bj)("chrome-minimize",60090),chromeRestore:(0,i.$Bj)("chrome-restore",60091),circleOutline:(0,i.$Bj)("circle-outline",60092),circle:(0,i.$Bj)("circle",60092),debugBreakpointUnverified:(0,i.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Bj)("circle-slash",60093),circuitBoard:(0,i.$Bj)("circuit-board",60094),clearAll:(0,i.$Bj)("clear-all",60095),clippy:(0,i.$Bj)("clippy",60096),closeAll:(0,i.$Bj)("close-all",60097),cloudDownload:(0,i.$Bj)("cloud-download",60098),cloudUpload:(0,i.$Bj)("cloud-upload",60099),code:(0,i.$Bj)("code",60100),collapseAll:(0,i.$Bj)("collapse-all",60101),colorMode:(0,i.$Bj)("color-mode",60102),commentDiscussion:(0,i.$Bj)("comment-discussion",60103),creditCard:(0,i.$Bj)("credit-card",60105),dash:(0,i.$Bj)("dash",60108),dashboard:(0,i.$Bj)("dashboard",60109),database:(0,i.$Bj)("database",60110),debugContinue:(0,i.$Bj)("debug-continue",60111),debugDisconnect:(0,i.$Bj)("debug-disconnect",60112),debugPause:(0,i.$Bj)("debug-pause",60113),debugRestart:(0,i.$Bj)("debug-restart",60114),debugStart:(0,i.$Bj)("debug-start",60115),debugStepInto:(0,i.$Bj)("debug-step-into",60116),debugStepOut:(0,i.$Bj)("debug-step-out",60117),debugStepOver:(0,i.$Bj)("debug-step-over",60118),debugStop:(0,i.$Bj)("debug-stop",60119),debug:(0,i.$Bj)("debug",60120),deviceCameraVideo:(0,i.$Bj)("device-camera-video",60121),deviceCamera:(0,i.$Bj)("device-camera",60122),deviceMobile:(0,i.$Bj)("device-mobile",60123),diffAdded:(0,i.$Bj)("diff-added",60124),diffIgnored:(0,i.$Bj)("diff-ignored",60125),diffModified:(0,i.$Bj)("diff-modified",60126),diffRemoved:(0,i.$Bj)("diff-removed",60127),diffRenamed:(0,i.$Bj)("diff-renamed",60128),diff:(0,i.$Bj)("diff",60129),diffSidebyside:(0,i.$Bj)("diff-sidebyside",60129),discard:(0,i.$Bj)("discard",60130),editorLayout:(0,i.$Bj)("editor-layout",60131),emptyWindow:(0,i.$Bj)("empty-window",60132),exclude:(0,i.$Bj)("exclude",60133),extensions:(0,i.$Bj)("extensions",60134),eyeClosed:(0,i.$Bj)("eye-closed",60135),fileBinary:(0,i.$Bj)("file-binary",60136),fileCode:(0,i.$Bj)("file-code",60137),fileMedia:(0,i.$Bj)("file-media",60138),filePdf:(0,i.$Bj)("file-pdf",60139),fileSubmodule:(0,i.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Bj)("file-symlink-file",60142),fileZip:(0,i.$Bj)("file-zip",60143),files:(0,i.$Bj)("files",60144),filter:(0,i.$Bj)("filter",60145),flame:(0,i.$Bj)("flame",60146),foldDown:(0,i.$Bj)("fold-down",60147),foldUp:(0,i.$Bj)("fold-up",60148),fold:(0,i.$Bj)("fold",60149),folderActive:(0,i.$Bj)("folder-active",60150),folderOpened:(0,i.$Bj)("folder-opened",60151),gear:(0,i.$Bj)("gear",60152),gift:(0,i.$Bj)("gift",60153),gistSecret:(0,i.$Bj)("gist-secret",60154),gist:(0,i.$Bj)("gist",60155),gitCommit:(0,i.$Bj)("git-commit",60156),gitCompare:(0,i.$Bj)("git-compare",60157),compareChanges:(0,i.$Bj)("compare-changes",60157),gitMerge:(0,i.$Bj)("git-merge",60158),githubAction:(0,i.$Bj)("github-action",60159),githubAlt:(0,i.$Bj)("github-alt",60160),globe:(0,i.$Bj)("globe",60161),grabber:(0,i.$Bj)("grabber",60162),graph:(0,i.$Bj)("graph",60163),gripper:(0,i.$Bj)("gripper",60164),heart:(0,i.$Bj)("heart",60165),home:(0,i.$Bj)("home",60166),horizontalRule:(0,i.$Bj)("horizontal-rule",60167),hubot:(0,i.$Bj)("hubot",60168),inbox:(0,i.$Bj)("inbox",60169),issueReopened:(0,i.$Bj)("issue-reopened",60171),issues:(0,i.$Bj)("issues",60172),italic:(0,i.$Bj)("italic",60173),jersey:(0,i.$Bj)("jersey",60174),json:(0,i.$Bj)("json",60175),kebabVertical:(0,i.$Bj)("kebab-vertical",60176),key:(0,i.$Bj)("key",60177),law:(0,i.$Bj)("law",60178),lightbulbAutofix:(0,i.$Bj)("lightbulb-autofix",60179),linkExternal:(0,i.$Bj)("link-external",60180),link:(0,i.$Bj)("link",60181),listOrdered:(0,i.$Bj)("list-ordered",60182),listUnordered:(0,i.$Bj)("list-unordered",60183),liveShare:(0,i.$Bj)("live-share",60184),loading:(0,i.$Bj)("loading",60185),location:(0,i.$Bj)("location",60186),mailRead:(0,i.$Bj)("mail-read",60187),mail:(0,i.$Bj)("mail",60188),markdown:(0,i.$Bj)("markdown",60189),megaphone:(0,i.$Bj)("megaphone",60190),mention:(0,i.$Bj)("mention",60191),milestone:(0,i.$Bj)("milestone",60192),gitPullRequestMilestone:(0,i.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Bj)("mortar-board",60193),move:(0,i.$Bj)("move",60194),multipleWindows:(0,i.$Bj)("multiple-windows",60195),mute:(0,i.$Bj)("mute",60196),noNewline:(0,i.$Bj)("no-newline",60197),note:(0,i.$Bj)("note",60198),octoface:(0,i.$Bj)("octoface",60199),openPreview:(0,i.$Bj)("open-preview",60200),package:(0,i.$Bj)("package",60201),paintcan:(0,i.$Bj)("paintcan",60202),pin:(0,i.$Bj)("pin",60203),play:(0,i.$Bj)("play",60204),run:(0,i.$Bj)("run",60204),plug:(0,i.$Bj)("plug",60205),preserveCase:(0,i.$Bj)("preserve-case",60206),preview:(0,i.$Bj)("preview",60207),project:(0,i.$Bj)("project",60208),pulse:(0,i.$Bj)("pulse",60209),question:(0,i.$Bj)("question",60210),quote:(0,i.$Bj)("quote",60211),radioTower:(0,i.$Bj)("radio-tower",60212),reactions:(0,i.$Bj)("reactions",60213),references:(0,i.$Bj)("references",60214),refresh:(0,i.$Bj)("refresh",60215),regex:(0,i.$Bj)("regex",60216),remoteExplorer:(0,i.$Bj)("remote-explorer",60217),remote:(0,i.$Bj)("remote",60218),remove:(0,i.$Bj)("remove",60219),replaceAll:(0,i.$Bj)("replace-all",60220),replace:(0,i.$Bj)("replace",60221),repoClone:(0,i.$Bj)("repo-clone",60222),repoForcePush:(0,i.$Bj)("repo-force-push",60223),repoPull:(0,i.$Bj)("repo-pull",60224),repoPush:(0,i.$Bj)("repo-push",60225),report:(0,i.$Bj)("report",60226),requestChanges:(0,i.$Bj)("request-changes",60227),rocket:(0,i.$Bj)("rocket",60228),rootFolderOpened:(0,i.$Bj)("root-folder-opened",60229),rootFolder:(0,i.$Bj)("root-folder",60230),rss:(0,i.$Bj)("rss",60231),ruby:(0,i.$Bj)("ruby",60232),saveAll:(0,i.$Bj)("save-all",60233),saveAs:(0,i.$Bj)("save-as",60234),save:(0,i.$Bj)("save",60235),screenFull:(0,i.$Bj)("screen-full",60236),screenNormal:(0,i.$Bj)("screen-normal",60237),searchStop:(0,i.$Bj)("search-stop",60238),server:(0,i.$Bj)("server",60240),settingsGear:(0,i.$Bj)("settings-gear",60241),settings:(0,i.$Bj)("settings",60242),shield:(0,i.$Bj)("shield",60243),smiley:(0,i.$Bj)("smiley",60244),sortPrecedence:(0,i.$Bj)("sort-precedence",60245),splitHorizontal:(0,i.$Bj)("split-horizontal",60246),splitVertical:(0,i.$Bj)("split-vertical",60247),squirrel:(0,i.$Bj)("squirrel",60248),starFull:(0,i.$Bj)("star-full",60249),starHalf:(0,i.$Bj)("star-half",60250),symbolClass:(0,i.$Bj)("symbol-class",60251),symbolColor:(0,i.$Bj)("symbol-color",60252),symbolConstant:(0,i.$Bj)("symbol-constant",60253),symbolEnumMember:(0,i.$Bj)("symbol-enum-member",60254),symbolField:(0,i.$Bj)("symbol-field",60255),symbolFile:(0,i.$Bj)("symbol-file",60256),symbolInterface:(0,i.$Bj)("symbol-interface",60257),symbolKeyword:(0,i.$Bj)("symbol-keyword",60258),symbolMisc:(0,i.$Bj)("symbol-misc",60259),symbolOperator:(0,i.$Bj)("symbol-operator",60260),symbolProperty:(0,i.$Bj)("symbol-property",60261),wrench:(0,i.$Bj)("wrench",60261),wrenchSubaction:(0,i.$Bj)("wrench-subaction",60261),symbolSnippet:(0,i.$Bj)("symbol-snippet",60262),tasklist:(0,i.$Bj)("tasklist",60263),telescope:(0,i.$Bj)("telescope",60264),textSize:(0,i.$Bj)("text-size",60265),threeBars:(0,i.$Bj)("three-bars",60266),thumbsdown:(0,i.$Bj)("thumbsdown",60267),thumbsup:(0,i.$Bj)("thumbsup",60268),tools:(0,i.$Bj)("tools",60269),triangleDown:(0,i.$Bj)("triangle-down",60270),triangleLeft:(0,i.$Bj)("triangle-left",60271),triangleRight:(0,i.$Bj)("triangle-right",60272),triangleUp:(0,i.$Bj)("triangle-up",60273),twitter:(0,i.$Bj)("twitter",60274),unfold:(0,i.$Bj)("unfold",60275),unlock:(0,i.$Bj)("unlock",60276),unmute:(0,i.$Bj)("unmute",60277),unverified:(0,i.$Bj)("unverified",60278),verified:(0,i.$Bj)("verified",60279),versions:(0,i.$Bj)("versions",60280),vmActive:(0,i.$Bj)("vm-active",60281),vmOutline:(0,i.$Bj)("vm-outline",60282),vmRunning:(0,i.$Bj)("vm-running",60283),watch:(0,i.$Bj)("watch",60284),whitespace:(0,i.$Bj)("whitespace",60285),wholeWord:(0,i.$Bj)("whole-word",60286),window:(0,i.$Bj)("window",60287),wordWrap:(0,i.$Bj)("word-wrap",60288),zoomIn:(0,i.$Bj)("zoom-in",60289),zoomOut:(0,i.$Bj)("zoom-out",60290),listFilter:(0,i.$Bj)("list-filter",60291),listFlat:(0,i.$Bj)("list-flat",60292),listSelection:(0,i.$Bj)("list-selection",60293),selection:(0,i.$Bj)("selection",60293),listTree:(0,i.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Bj)("symbol-string",60301),debugReverseContinue:(0,i.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Bj)("debug-step-back",60303),debugRestartFrame:(0,i.$Bj)("debug-restart-frame",60304),debugAlt:(0,i.$Bj)("debug-alt",60305),callIncoming:(0,i.$Bj)("call-incoming",60306),callOutgoing:(0,i.$Bj)("call-outgoing",60307),menu:(0,i.$Bj)("menu",60308),expandAll:(0,i.$Bj)("expand-all",60309),feedback:(0,i.$Bj)("feedback",60310),gitPullRequestReviewer:(0,i.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Bj)("ungroup-by-ref-type",60312),account:(0,i.$Bj)("account",60313),gitPullRequestAssignee:(0,i.$Bj)("git-pull-request-assignee",60313),bellDot:(0,i.$Bj)("bell-dot",60314),debugConsole:(0,i.$Bj)("debug-console",60315),library:(0,i.$Bj)("library",60316),output:(0,i.$Bj)("output",60317),runAll:(0,i.$Bj)("run-all",60318),syncIgnored:(0,i.$Bj)("sync-ignored",60319),pinned:(0,i.$Bj)("pinned",60320),githubInverted:(0,i.$Bj)("github-inverted",60321),serverProcess:(0,i.$Bj)("server-process",60322),serverEnvironment:(0,i.$Bj)("server-environment",60323),pass:(0,i.$Bj)("pass",60324),issueClosed:(0,i.$Bj)("issue-closed",60324),stopCircle:(0,i.$Bj)("stop-circle",60325),playCircle:(0,i.$Bj)("play-circle",60326),record:(0,i.$Bj)("record",60327),debugAltSmall:(0,i.$Bj)("debug-alt-small",60328),vmConnect:(0,i.$Bj)("vm-connect",60329),cloud:(0,i.$Bj)("cloud",60330),merge:(0,i.$Bj)("merge",60331),export:(0,i.$Bj)("export",60332),graphLeft:(0,i.$Bj)("graph-left",60333),magnet:(0,i.$Bj)("magnet",60334),notebook:(0,i.$Bj)("notebook",60335),redo:(0,i.$Bj)("redo",60336),checkAll:(0,i.$Bj)("check-all",60337),pinnedDirty:(0,i.$Bj)("pinned-dirty",60338),passFilled:(0,i.$Bj)("pass-filled",60339),circleLargeFilled:(0,i.$Bj)("circle-large-filled",60340),circleLarge:(0,i.$Bj)("circle-large",60341),circleLargeOutline:(0,i.$Bj)("circle-large-outline",60341),combine:(0,i.$Bj)("combine",60342),gather:(0,i.$Bj)("gather",60342),table:(0,i.$Bj)("table",60343),variableGroup:(0,i.$Bj)("variable-group",60344),typeHierarchy:(0,i.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Bj)("git-pull-request-create",60348),runAbove:(0,i.$Bj)("run-above",60349),runBelow:(0,i.$Bj)("run-below",60350),notebookTemplate:(0,i.$Bj)("notebook-template",60351),debugRerun:(0,i.$Bj)("debug-rerun",60352),workspaceTrusted:(0,i.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Bj)("workspace-unknown",60355),terminalCmd:(0,i.$Bj)("terminal-cmd",60356),terminalDebian:(0,i.$Bj)("terminal-debian",60357),terminalLinux:(0,i.$Bj)("terminal-linux",60358),terminalPowershell:(0,i.$Bj)("terminal-powershell",60359),terminalTmux:(0,i.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Bj)("terminal-ubuntu",60361),terminalBash:(0,i.$Bj)("terminal-bash",60362),arrowSwap:(0,i.$Bj)("arrow-swap",60363),copy:(0,i.$Bj)("copy",60364),personAdd:(0,i.$Bj)("person-add",60365),filterFilled:(0,i.$Bj)("filter-filled",60366),wand:(0,i.$Bj)("wand",60367),debugLineByLine:(0,i.$Bj)("debug-line-by-line",60368),inspect:(0,i.$Bj)("inspect",60369),layers:(0,i.$Bj)("layers",60370),layersDot:(0,i.$Bj)("layers-dot",60371),layersActive:(0,i.$Bj)("layers-active",60372),compass:(0,i.$Bj)("compass",60373),compassDot:(0,i.$Bj)("compass-dot",60374),compassActive:(0,i.$Bj)("compass-active",60375),azure:(0,i.$Bj)("azure",60376),issueDraft:(0,i.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Bj)("git-pull-request-draft",60379),debugAll:(0,i.$Bj)("debug-all",60380),debugCoverage:(0,i.$Bj)("debug-coverage",60381),runErrors:(0,i.$Bj)("run-errors",60382),folderLibrary:(0,i.$Bj)("folder-library",60383),debugContinueSmall:(0,i.$Bj)("debug-continue-small",60384),beakerStop:(0,i.$Bj)("beaker-stop",60385),graphLine:(0,i.$Bj)("graph-line",60386),graphScatter:(0,i.$Bj)("graph-scatter",60387),pieChart:(0,i.$Bj)("pie-chart",60388),bracket:(0,i.$Bj)("bracket",60175),bracketDot:(0,i.$Bj)("bracket-dot",60389),bracketError:(0,i.$Bj)("bracket-error",60390),lockSmall:(0,i.$Bj)("lock-small",60391),azureDevops:(0,i.$Bj)("azure-devops",60392),verifiedFilled:(0,i.$Bj)("verified-filled",60393),newline:(0,i.$Bj)("newline",60394),layout:(0,i.$Bj)("layout",60395),layoutActivitybarLeft:(0,i.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Bj)("layout-panel-right",60401),layoutPanel:(0,i.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Bj)("layout-statusbar",60405),layoutMenubar:(0,i.$Bj)("layout-menubar",60406),layoutCentered:(0,i.$Bj)("layout-centered",60407),target:(0,i.$Bj)("target",60408),indent:(0,i.$Bj)("indent",60409),recordSmall:(0,i.$Bj)("record-small",60410),errorSmall:(0,i.$Bj)("error-small",60411),terminalDecorationError:(0,i.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Bj)("layout-sidebar-left-off",60418),blank:(0,i.$Bj)("blank",60419),heartFilled:(0,i.$Bj)("heart-filled",60420),map:(0,i.$Bj)("map",60421),mapFilled:(0,i.$Bj)("map-filled",60422),circleSmall:(0,i.$Bj)("circle-small",60423),bellSlash:(0,i.$Bj)("bell-slash",60424),bellSlashDot:(0,i.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Bj)("search-fuzzy",60429),commentDraft:(0,i.$Bj)("comment-draft",60430),send:(0,i.$Bj)("send",60431),sparkle:(0,i.$Bj)("sparkle",60432),insert:(0,i.$Bj)("insert",60433),mic:(0,i.$Bj)("mic",60434),thumbsdownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Bj)("thumbsup-filled",60436),coffee:(0,i.$Bj)("coffee",60437),snake:(0,i.$Bj)("snake",60438),game:(0,i.$Bj)("game",60439),vr:(0,i.$Bj)("vr",60440),chip:(0,i.$Bj)("chip",60441),piano:(0,i.$Bj)("piano",60442),music:(0,i.$Bj)("music",60443),micFilled:(0,i.$Bj)("mic-filled",60444),repoFetch:(0,i.$Bj)("repo-fetch",60445),copilot:(0,i.$Bj)("copilot",60446),lightbulbSparkle:(0,i.$Bj)("lightbulb-sparkle",60447),robot:(0,i.$Bj)("robot",60448),sparkleFilled:(0,i.$Bj)("sparkle-filled",60449),diffSingle:(0,i.$Bj)("diff-single",60450),diffMultiple:(0,i.$Bj)("diff-multiple",60451),surroundWith:(0,i.$Bj)("surround-with",60452),share:(0,i.$Bj)("share",60453),gitStash:(0,i.$Bj)("git-stash",60454),gitStashApply:(0,i.$Bj)("git-stash-apply",60455),gitStashPop:(0,i.$Bj)("git-stash-pop",60456),vscode:(0,i.$Bj)("vscode",60457),vscodeInsiders:(0,i.$Bj)("vscode-insiders",60458),codeOss:(0,i.$Bj)("code-oss",60459),runCoverage:(0,i.$Bj)("run-coverage",60460),runAllCoverage:(0,i.$Bj)("run-all-coverage",60461),coverage:(0,i.$Bj)("coverage",60462),githubProject:(0,i.$Bj)("github-project",60463)}}),ne(re[43],se([0,1,27,42]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gj=t.$Fj=void 0,t.$Ej=y;function y(){return Object.values(t.$Gj)}t.$Fj={dialogError:(0,i.$Bj)("dialog-error","error"),dialogWarning:(0,i.$Bj)("dialog-warning","warning"),dialogInfo:(0,i.$Bj)("dialog-info","info"),dialogClose:(0,i.$Bj)("dialog-close","close"),treeItemExpanded:(0,i.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Bj)("tree-item-loading","loading"),menuSelection:(0,i.$Bj)("menu-selection","check"),menuSubmenu:(0,i.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Bj)("toolbar-more","more"),quickInputBack:(0,i.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Bj)("drop-down-button",60084),symbolCustomColor:(0,i.$Bj)("symbol-customcolor",60252),exportIcon:(0,i.$Bj)("export",60332),workspaceUnspecified:(0,i.$Bj)("workspace-unspecified",60355),newLine:(0,i.$Bj)("newline",60394),thumbsDownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Bj)("thumbsup-filled",60436),gitFetch:(0,i.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Bj)("debug-breakpoint-pending",60377)},t.$Gj={...F.$Dj,...t.$Fj}}),ne(re[14],se([0,1,26]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nn=F,t.$On=y,t.$Pn=L,t.$Qn=l,t.$Rn=u,t.$Sn=c,t.$Tn=B,t.$Un=b,t.$Vn=m,t.$Wn=e,t.$Xn=p,t.$Yn=j;function F(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const $=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([d,a])=>{$[d]=a&&typeof a=="object"?F(a):a}),$}function y(N){if(!N||typeof N!="object")return N;const $=[N];for(;$.length>0;){const d=$.shift();Object.freeze(d);for(const a in d)if(f.call(d,a)){const o=d[a];typeof o=="object"&&!Object.isFrozen(o)&&!(0,i.$Xf)(o)&&$.push(o)}}return N}const f=Object.prototype.hasOwnProperty;function L(N,$){return h(N,$,new Set)}function h(N,$,d){if((0,i.$4f)(N))return N;const a=$(N);if(typeof a<"u")return a;if(Array.isArray(N)){const o=[];for(const n of N)o.push(h(n,$,d));return o}if((0,i.$Wf)(N)){if(d.has(N))throw new Error("Cannot clone recursive data-structure");d.add(N);const o={};for(const n in N)f.call(N,n)&&(o[n]=h(N[n],$,d));return d.delete(N),o}return N}function l(N,$,d=!0){return(0,i.$Wf)(N)?((0,i.$Wf)($)&&Object.keys($).forEach(a=>{a in N?d&&((0,i.$Wf)(N[a])&&(0,i.$Wf)($[a])?l(N[a],$[a],d):N[a]=$[a]):N[a]=$[a]}),N):$}function u(N,$){if(N===$)return!0;if(N==null||$===null||$===void 0||typeof N!=typeof $||typeof N!="object"||Array.isArray(N)!==Array.isArray($))return!1;let d,a;if(Array.isArray(N)){if(N.length!==$.length)return!1;for(d=0;d<N.length;d++)if(!u(N[d],$[d]))return!1}else{const o=[];for(a in N)o.push(a);o.sort();const n=[];for(a in $)n.push(a);if(n.sort(),!u(o,n))return!1;for(d=0;d<o.length;d++)if(!u(N[o[d]],$[o[d]]))return!1}return!0}function c(N){const $=new Set;return JSON.stringify(N,(d,a)=>{if((0,i.$Wf)(a)||Array.isArray(a)){if($.has(a))return"[Circular]";$.add(a)}return a})}function B(N,$){const d=Object.create(null);return!N||!$||Object.keys($).forEach(o=>{const n=N[o],s=$[o];u(n,s)||(d[o]=s)}),d}function b(N,$){const d=$.toLowerCase(),a=Object.keys(N).find(o=>o.toLowerCase()===d);return a?N[a]:N[$]}function m(N,$){const d=Object.create(null);for(const[a,o]of Object.entries(N))$(a,o)&&(d[a]=o);return d}function e(N){let $=[];for(;Object.prototype!==N;)$=$.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return $}function p(N){const $=[];for(const d of e(N))typeof N[d]=="function"&&$.push(d);return $}function j(N,$){const d=o=>function(){const n=Array.prototype.slice.call(arguments,0);return $(o,n)},a={};for(const o of N)a[o]=d(o);return a}}),ne(re[28],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$Se=F,t.$Te=y;var i;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function F(f){return f<0?0:f>255?255:f|0}function y(f){return f<0?0:f>4294967295?4294967295:f|0}}),ne(re[29],se([0,1,28]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yt=t.$xt=void 0;class F{constructor(h){const l=(0,i.$Se)(h);this.c=l,this.a=F.d(l),this.b=new Map}static d(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const u=(0,i.$Se)(l);h>=0&&h<256?this.a[h]=u:this.b.set(h,u)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$xt=F;var y;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(y||(y={}));class f{constructor(){this.a=new F(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$yt=f}),ne(re[4],se([0,1,3]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$ht=void 0;class F{static addRange(L,h){let l=0;for(;l<h.length&&h[l].endExclusive<L.start;)l++;let u=l;for(;u<h.length&&h[u].start<=L.endExclusive;)u++;if(l===u)h.splice(l,0,L);else{const c=Math.min(L.start,h[l].start),B=Math.max(L.endExclusive,h[u-1].endExclusive);h.splice(l,u-l,new F(c,B))}}static tryCreate(L,h){if(!(L>h))return new F(L,h)}static ofLength(L){return new F(0,L)}static ofStartAndLength(L,h){return new F(L,L+h)}constructor(L,h){if(this.start=L,this.endExclusive=h,L>h)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(L){return new F(this.start+L,this.endExclusive+L)}deltaStart(L){return new F(this.start+L,this.endExclusive)}deltaEnd(L){return new F(this.start,this.endExclusive+L)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(L){return this.start===L.start&&this.endExclusive===L.endExclusive}containsRange(L){return this.start<=L.start&&L.endExclusive<=this.endExclusive}contains(L){return this.start<=L&&L<this.endExclusive}join(L){return new F(Math.min(this.start,L.start),Math.max(this.endExclusive,L.endExclusive))}intersect(L){const h=Math.max(this.start,L.start),l=Math.min(this.endExclusive,L.endExclusive);if(h<=l)return new F(h,l)}intersects(L){const h=Math.max(this.start,L.start),l=Math.min(this.endExclusive,L.endExclusive);return h<l}intersectsOrTouches(L){const h=Math.max(this.start,L.start),l=Math.min(this.endExclusive,L.endExclusive);return h<=l}isBefore(L){return this.endExclusive<=L.start}isAfter(L){return this.start>=L.endExclusive}slice(L){return L.slice(this.start,this.endExclusive)}substring(L){return L.substring(this.start,this.endExclusive)}clip(L){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,L))}clipCyclic(L){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return L<this.start?this.endExclusive-(this.start-L)%this.length:L>=this.endExclusive?this.start+(L-this.start)%this.length:L}map(L){const h=[];for(let l=this.start;l<this.endExclusive;l++)h.push(L(l));return h}forEach(L){for(let h=this.start;h<this.endExclusive;h++)L(h)}}t.$ht=F;class y{constructor(){this.a=[]}addRange(L){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<L.start;)h++;let l=h;for(;l<this.a.length&&this.a[l].start<=L.endExclusive;)l++;if(h===l)this.a.splice(h,0,L);else{const u=Math.min(L.start,this.a[h].start),c=Math.max(L.endExclusive,this.a[l-1].endExclusive);this.a.splice(h,l-h,new F(u,c))}}toString(){return this.a.map(L=>L.toString()).join(", ")}intersectsStrict(L){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=L.start;)h++;return h<this.a.length&&this.a[h].start<L.endExclusive}intersectWithRange(L){const h=new y;for(const l of this.a){const u=l.intersect(L);u&&h.addRange(u)}return h}intersectWithRangeLength(L){return this.intersectWithRange(L).length}get length(){return this.a.reduce((L,h)=>L+h.length,0)}}t.$it=y}),ne(re[5],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=void 0;class i{constructor(y,f){this.lineNumber=y,this.column=f}with(y=this.lineNumber,f=this.column){return y===this.lineNumber&&f===this.column?this:new i(y,f)}delta(y=0,f=0){return this.with(this.lineNumber+y,this.column+f)}equals(y){return i.equals(this,y)}static equals(y,f){return!y&&!f?!0:!!y&&!!f&&y.lineNumber===f.lineNumber&&y.column===f.column}isBefore(y){return i.isBefore(this,y)}static isBefore(y,f){return y.lineNumber<f.lineNumber?!0:f.lineNumber<y.lineNumber?!1:y.column<f.column}isBeforeOrEqual(y){return i.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,f){return y.lineNumber<f.lineNumber?!0:f.lineNumber<y.lineNumber?!1:y.column<=f.column}static compare(y,f){const L=y.lineNumber|0,h=f.lineNumber|0;if(L===h){const l=y.column|0,u=f.column|0;return l-u}return L-h}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new i(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$_s=i}),ne(re[2],se([0,1,5]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=void 0;class F{constructor(f,L,h,l){f>h||f===h&&L>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=f,this.endColumn=L):(this.startLineNumber=f,this.startColumn=L,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return F.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return F.containsPosition(this,f)}static containsPosition(f,L){return!(L.lineNumber<f.startLineNumber||L.lineNumber>f.endLineNumber||L.lineNumber===f.startLineNumber&&L.column<f.startColumn||L.lineNumber===f.endLineNumber&&L.column>f.endColumn)}static strictContainsPosition(f,L){return!(L.lineNumber<f.startLineNumber||L.lineNumber>f.endLineNumber||L.lineNumber===f.startLineNumber&&L.column<=f.startColumn||L.lineNumber===f.endLineNumber&&L.column>=f.endColumn)}containsRange(f){return F.containsRange(this,f)}static containsRange(f,L){return!(L.startLineNumber<f.startLineNumber||L.endLineNumber<f.startLineNumber||L.startLineNumber>f.endLineNumber||L.endLineNumber>f.endLineNumber||L.startLineNumber===f.startLineNumber&&L.startColumn<f.startColumn||L.endLineNumber===f.endLineNumber&&L.endColumn>f.endColumn)}strictContainsRange(f){return F.strictContainsRange(this,f)}static strictContainsRange(f,L){return!(L.startLineNumber<f.startLineNumber||L.endLineNumber<f.startLineNumber||L.startLineNumber>f.endLineNumber||L.endLineNumber>f.endLineNumber||L.startLineNumber===f.startLineNumber&&L.startColumn<=f.startColumn||L.endLineNumber===f.endLineNumber&&L.endColumn>=f.endColumn)}plusRange(f){return F.plusRange(this,f)}static plusRange(f,L){let h,l,u,c;return L.startLineNumber<f.startLineNumber?(h=L.startLineNumber,l=L.startColumn):L.startLineNumber===f.startLineNumber?(h=L.startLineNumber,l=Math.min(L.startColumn,f.startColumn)):(h=f.startLineNumber,l=f.startColumn),L.endLineNumber>f.endLineNumber?(u=L.endLineNumber,c=L.endColumn):L.endLineNumber===f.endLineNumber?(u=L.endLineNumber,c=Math.max(L.endColumn,f.endColumn)):(u=f.endLineNumber,c=f.endColumn),new F(h,l,u,c)}intersectRanges(f){return F.intersectRanges(this,f)}static intersectRanges(f,L){let h=f.startLineNumber,l=f.startColumn,u=f.endLineNumber,c=f.endColumn;const B=L.startLineNumber,b=L.startColumn,m=L.endLineNumber,e=L.endColumn;return h<B?(h=B,l=b):h===B&&(l=Math.max(l,b)),u>m?(u=m,c=e):u===m&&(c=Math.min(c,e)),h>u||h===u&&l>c?null:new F(h,l,u,c)}equalsRange(f){return F.equalsRange(this,f)}static equalsRange(f,L){return!f&&!L?!0:!!f&&!!L&&f.startLineNumber===L.startLineNumber&&f.startColumn===L.startColumn&&f.endLineNumber===L.endLineNumber&&f.endColumn===L.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(f){return new i.$_s(f.endLineNumber,f.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(f){return new i.$_s(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,L){return new F(this.startLineNumber,this.startColumn,f,L)}setStartPosition(f,L){return new F(f,L,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(f){return new F(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(f){return new F(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new F(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,L=f){return new F(f.lineNumber,f.column,L.lineNumber,L.column)}static lift(f){return f?new F(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,L){return!(f.endLineNumber<L.startLineNumber||f.endLineNumber===L.startLineNumber&&f.endColumn<L.startColumn||L.endLineNumber<f.startLineNumber||L.endLineNumber===f.startLineNumber&&L.endColumn<f.startColumn)}static areIntersecting(f,L){return!(f.endLineNumber<L.startLineNumber||f.endLineNumber===L.startLineNumber&&f.endColumn<=L.startColumn||L.endLineNumber<f.startLineNumber||L.endLineNumber===f.startLineNumber&&L.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,L){if(f&&L){const u=f.startLineNumber|0,c=L.startLineNumber|0;if(u===c){const B=f.startColumn|0,b=L.startColumn|0;if(B===b){const m=f.endLineNumber|0,e=L.endLineNumber|0;if(m===e){const p=f.endColumn|0,j=L.endColumn|0;return p-j}return m-e}return B-b}return u-c}return(f?1:0)-(L?1:0)}static compareRangesUsingEnds(f,L){return f.endLineNumber===L.endLineNumber?f.endColumn===L.endColumn?f.startLineNumber===L.startLineNumber?f.startColumn-L.startColumn:f.startLineNumber-L.startLineNumber:f.endColumn-L.endColumn:f.endLineNumber-L.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$at=F}),ne(re[44],se([0,1,2]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=void 0;class F{static insert(f,L){return{range:new i.$at(f.lineNumber,f.column,f.lineNumber,f.column),text:L,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,L){return{range:f,text:L}}static replaceMove(f,L){return{range:f,text:L,forceMoveMarkers:!0}}}t.$bt=F}),ne(re[12],se([0,1,3,4,2,9]),function(V,t,i,F,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=t.$jt=void 0;class L{static fromRange(u){return new L(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new L(u.startLineNumber,u.endLineNumber+1)}static subtract(u,c){return c?u.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<u.endLineNumberExclusive?[new L(u.startLineNumber,c.startLineNumber),new L(c.endLineNumberExclusive,u.endLineNumberExclusive)]:c.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<u.endLineNumberExclusive?[new L(Math.max(c.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new L(u.startLineNumber,Math.min(c.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let c=new h(u[0].slice());for(let B=1;B<u.length;B++)c=c.getUnion(new h(u[B].slice()));return c.ranges}static ofLength(u,c){return new L(u,u+c)}static deserialize(u){return new L(u[0],u[1])}constructor(u,c){if(u>c)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=u,this.endLineNumberExclusive=c}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new L(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new L(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new L(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const c=Math.max(this.startLineNumber,u.startLineNumber),B=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(c<=B)return new L(c,B)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new y.$at(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new y.$at(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const c=[];for(let B=this.startLineNumber;B<this.endLineNumberExclusive;B++)c.push(u(B));return c}forEach(u){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)u(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new F.$ht(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$jt=L;class h{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const c=(0,f.$kb)(this.c,b=>b.endLineNumberExclusive>=u.startLineNumber),B=(0,f.$ib)(this.c,b=>b.startLineNumber<=u.endLineNumberExclusive)+1;if(c===B)this.c.splice(c,0,u);else if(c===B-1){const b=this.c[c];this.c[c]=b.join(u)}else{const b=this.c[c].join(this.c[B-1]).join(u);this.c.splice(c,B-c,b)}}contains(u){const c=(0,f.$hb)(this.c,B=>B.startLineNumber<=u);return!!c&&c.endLineNumberExclusive>u}intersects(u){const c=(0,f.$hb)(this.c,B=>B.startLineNumber<u.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const c=[];let B=0,b=0,m=null;for(;B<this.c.length||b<u.c.length;){let e=null;if(B<this.c.length&&b<u.c.length){const p=this.c[B],j=u.c[b];p.startLineNumber<j.startLineNumber?(e=p,B++):(e=j,b++)}else B<this.c.length?(e=this.c[B],B++):(e=u.c[b],b++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new L(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(m),m=e)}return m!==null&&c.push(m),new h(c)}subtractFrom(u){const c=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),B=(0,f.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(c===B)return new h([u]);const b=[];let m=u.startLineNumber;for(let e=c;e<B;e++){const p=this.c[e];p.startLineNumber>m&&b.push(new L(m,p.startLineNumber)),m=p.endLineNumberExclusive}return m<u.endLineNumberExclusive&&b.push(new L(m,u.endLineNumberExclusive)),new h(b)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const c=[];let B=0,b=0;for(;B<this.c.length&&b<u.c.length;){const m=this.c[B],e=u.c[b],p=m.intersect(e);p&&!p.isEmpty&&c.push(p),m.endLineNumberExclusive<e.endLineNumberExclusive?B++:b++}return new h(c)}getWithDelta(u){return new h(this.c.map(c=>c.delta(u)))}}t.$kt=h}),ne(re[45],se([0,1,5,2]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=t.SelectionDirection=void 0;var y;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(y||(t.SelectionDirection=y={}));class f extends F.$at{constructor(h,l,u,c){super(h,l,u,c),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=u,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,l):new f(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new i.$_s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$_s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new f(h,l,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new f(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let u=0,c=h.length;u<c;u++)if(!this.selectionsEqual(h[u],l[u]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,u,c,B){return B===0?new f(h,l,u,c):new f(u,c,h,l)}}t.$ct=f}),ne(re[46],se([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=t.$zt=t.WordCharacterClass=void 0;var F;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(F||(t.WordCharacterClass=F={}));class y extends i.$xt{constructor(h){super(0);for(let l=0,u=h.length;l<u;l++)this.set(h.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$zt=y;function f(L){const h={};return l=>(h.hasOwnProperty(l)||(h[l]=L(l)),h[l])}t.$At=f(L=>new y(L))}),ne(re[30],se([0,1,20,10,21]),function(V,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=void 0,t.$Ns=L,t.$Os=l,t.$Ps=u,t.$Ls="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(B=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Ls)B.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.$Ms=f();function L(B){let b=t.$Ms;if(B&&B instanceof RegExp)if(B.global)b=B;else{let m="g";B.ignoreCase&&(m+="i"),B.multiline&&(m+="m"),B.unicode&&(m+="u"),b=new RegExp(B.source,m)}return b.lastIndex=0,b}const h=new y.$5c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(B){const b=h.unshift(B);return(0,F.$Sc)(b)}function u(B,b,m,e,p){if(b=L(b),p||(p=i.Iterable.first(h)),m.length>p.maxLen){let a=B-p.maxLen/2;return a<0?a=0:e+=a,m=m.substring(a,B+p.maxLen/2),u(B,b,m,e,p)}const j=Date.now(),N=B-1-e;let $=-1,d=null;for(let a=1;!(Date.now()-j>=p.timeBudget);a++){const o=N-p.windowSize*a;b.lastIndex=Math.max(0,o);const n=c(b,m,N,$);if(!n&&d||(d=n,o<=0))break;$=o}if(d){const a={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return b.lastIndex=0,a}return null}function c(B,b,m,e){let p;for(;p=B.exec(b);){const j=p.index||0;if(j<=m&&B.lastIndex>=m)return p;if(e>0&&j>e)return null}return null}}),ne(re[8],se([0,1,6,3,4]),function(V,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$t2=t.$s2=t.$r2=t.$q2=t.$p2=void 0;class f{static trivial(B,b){return new f([new L(y.$ht.ofLength(B.length),y.$ht.ofLength(b.length))],!1)}static trivialTimedOut(B,b){return new f([new L(y.$ht.ofLength(B.length),y.$ht.ofLength(b.length))],!0)}constructor(B,b){this.diffs=B,this.hitTimeout=b}}t.$p2=f;class L{static invert(B,b){const m=[];return(0,i.$Bb)(B,(e,p)=>{m.push(L.fromOffsetPairs(e?e.getEndExclusives():h.zero,p?p.getStarts():new h(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),m}static fromOffsetPairs(B,b){return new L(new y.$ht(B.offset1,b.offset1),new y.$ht(B.offset2,b.offset2))}constructor(B,b){this.seq1Range=B,this.seq2Range=b}swap(){return new L(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(B){return new L(this.seq1Range.join(B.seq1Range),this.seq2Range.join(B.seq2Range))}delta(B){return B===0?this:new L(this.seq1Range.delta(B),this.seq2Range.delta(B))}deltaStart(B){return B===0?this:new L(this.seq1Range.deltaStart(B),this.seq2Range.deltaStart(B))}deltaEnd(B){return B===0?this:new L(this.seq1Range.deltaEnd(B),this.seq2Range.deltaEnd(B))}intersectsOrTouches(B){return this.seq1Range.intersectsOrTouches(B.seq1Range)||this.seq2Range.intersectsOrTouches(B.seq2Range)}intersect(B){const b=this.seq1Range.intersect(B.seq1Range),m=this.seq2Range.intersect(B.seq2Range);if(!(!b||!m))return new L(b,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$q2=L;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(B,b){this.offset1=B,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(B){return B===0?this:new h(this.offset1+B,this.offset2+B)}equals(B){return this.offset1===B.offset1&&this.offset2===B.offset2}}t.$r2=h;class l{static{this.instance=new l}isValid(){return!0}}t.$s2=l;class u{constructor(B){if(this.e=B,this.c=Date.now(),this.d=!0,B<=0)throw new F.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$t2=u}),ne(re[31],se([0,1,4,8]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$y2=void 0;class y{compute(u,c,B=F.$s2.instance){if(u.length===0||c.length===0)return F.$p2.trivial(u,c);const b=u,m=c;function e(s,v){for(;s<b.length&&v<m.length&&b.getElement(s)===m.getElement(v);)s++,v++;return s}let p=0;const j=new L;j.set(0,e(0,0));const N=new h;N.set(0,j.get(0)===0?null:new f(null,0,0,j.get(0)));let $=0;e:for(;;){if(p++,!B.isValid())return F.$p2.trivialTimedOut(b,m);const s=-Math.min(p,m.length+p%2),v=Math.min(p,b.length+p%2);for($=s;$<=v;$+=2){let g=0;const w=$===v?-1:j.get($+1),A=$===s?-1:j.get($-1)+1;g++;const E=Math.min(Math.max(w,A),b.length),M=E-$;if(g++,E>b.length||M>m.length)continue;const P=e(E,M);j.set($,P);const R=E===w?N.get($+1):N.get($-1);if(N.set($,P!==E?new f(R,E,M,P-E):R),j.get($)===b.length&&j.get($)-$===m.length)break e}}let d=N.get($);const a=[];let o=b.length,n=m.length;for(;;){const s=d?d.x+d.length:0,v=d?d.y+d.length:0;if((s!==o||v!==n)&&a.push(new F.$q2(new i.$ht(s,o),new i.$ht(v,n))),!d)break;o=d.x,n=d.y,d=d.prev}return a.reverse(),new F.$p2(a,!1)}}t.$y2=y;class f{constructor(u,c,B,b){this.prev=u,this.x=c,this.y=B,this.length=b}}class L{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){if(u<0){if(u=-u-1,u>=this.b.length){const B=this.b;this.b=new Int32Array(B.length*2),this.b.set(B)}this.b[u]=c}else{if(u>=this.a.length){const B=this.a;this.a=new Int32Array(B.length*2),this.a.set(B)}this.a[u]=c}}}class h{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,c){u<0?(u=-u-1,this.b[u]=c):this.a[u]=c}}}),ne(re[47],se([0,1,6,4,8]),function(V,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C2=f,t.$D2=u,t.$E2=c,t.$F2=b,t.$G2=m;function f(e,p,j){let N=j;return N=L(e,p,N),N=L(e,p,N),N=h(e,p,N),N}function L(e,p,j){if(j.length===0)return j;const N=[];N.push(j[0]);for(let d=1;d<j.length;d++){const a=N[N.length-1];let o=j[d];if(o.seq1Range.isEmpty||o.seq2Range.isEmpty){const n=o.seq1Range.start-a.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(o.seq1Range.start-s)!==e.getElement(o.seq1Range.endExclusive-s)||p.getElement(o.seq2Range.start-s)!==p.getElement(o.seq2Range.endExclusive-s));s++);if(s--,s===n){N[N.length-1]=new y.$q2(new F.$ht(a.seq1Range.start,o.seq1Range.endExclusive-n),new F.$ht(a.seq2Range.start,o.seq2Range.endExclusive-n));continue}o=o.delta(-s)}N.push(o)}const $=[];for(let d=0;d<N.length-1;d++){const a=N[d+1];let o=N[d];if(o.seq1Range.isEmpty||o.seq2Range.isEmpty){const n=a.seq1Range.start-o.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(o.seq1Range.start+s,o.seq1Range.endExclusive+s)||!p.isStronglyEqual(o.seq2Range.start+s,o.seq2Range.endExclusive+s));s++);if(s===n){N[d+1]=new y.$q2(new F.$ht(o.seq1Range.start+n,a.seq1Range.endExclusive),new F.$ht(o.seq2Range.start+n,a.seq2Range.endExclusive));continue}s>0&&(o=o.delta(s))}$.push(o)}return N.length>0&&$.push(N[N.length-1]),$}function h(e,p,j){if(!e.getBoundaryScore||!p.getBoundaryScore)return j;for(let N=0;N<j.length;N++){const $=N>0?j[N-1]:void 0,d=j[N],a=N+1<j.length?j[N+1]:void 0,o=new F.$ht($?$.seq1Range.endExclusive+1:0,a?a.seq1Range.start-1:e.length),n=new F.$ht($?$.seq2Range.endExclusive+1:0,a?a.seq2Range.start-1:p.length);d.seq1Range.isEmpty?j[N]=l(d,e,p,o,n):d.seq2Range.isEmpty&&(j[N]=l(d.swap(),p,e,n,o).swap())}return j}function l(e,p,j,N,$){let a=1;for(;e.seq1Range.start-a>=N.start&&e.seq2Range.start-a>=$.start&&j.isStronglyEqual(e.seq2Range.start-a,e.seq2Range.endExclusive-a)&&a<100;)a++;a--;let o=0;for(;e.seq1Range.start+o<N.endExclusive&&e.seq2Range.endExclusive+o<$.endExclusive&&j.isStronglyEqual(e.seq2Range.start+o,e.seq2Range.endExclusive+o)&&o<100;)o++;if(a===0&&o===0)return e;let n=0,s=-1;for(let v=-a;v<=o;v++){const g=e.seq2Range.start+v,w=e.seq2Range.endExclusive+v,A=e.seq1Range.start+v,E=p.getBoundaryScore(A)+j.getBoundaryScore(g)+j.getBoundaryScore(w);E>s&&(s=E,n=v)}return e.delta(n)}function u(e,p,j){const N=[];for(const $ of j){const d=N[N.length-1];if(!d){N.push($);continue}$.seq1Range.start-d.seq1Range.endExclusive<=2||$.seq2Range.start-d.seq2Range.endExclusive<=2?N[N.length-1]=new y.$q2(d.seq1Range.join($.seq1Range),d.seq2Range.join($.seq2Range)):N.push($)}return N}function c(e,p,j){const N=y.$q2.invert(j,e.length),$=[];let d=new y.$r2(0,0);function a(n,s){if(n.offset1<d.offset1||n.offset2<d.offset2)return;const v=e.findWordContaining(n.offset1),g=p.findWordContaining(n.offset2);if(!v||!g)return;let w=new y.$q2(v,g);const A=w.intersect(s);let E=A.seq1Range.length,M=A.seq2Range.length;for(;N.length>0;){const P=N[0];if(!(P.seq1Range.intersects(w.seq1Range)||P.seq2Range.intersects(w.seq2Range)))break;const T=e.findWordContaining(P.seq1Range.start),k=p.findWordContaining(P.seq2Range.start),x=new y.$q2(T,k),O=x.intersect(P);if(E+=O.seq1Range.length,M+=O.seq2Range.length,w=w.join(x),w.seq1Range.endExclusive>=P.seq1Range.endExclusive)N.shift();else break}E+M<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),d=w.getEndExclusives()}for(;N.length>0;){const n=N.shift();n.seq1Range.isEmpty||(a(n.getStarts(),n),a(n.getEndExclusives().delta(-1),n))}return B(j,$)}function B(e,p){const j=[];for(;e.length>0||p.length>0;){const N=e[0],$=p[0];let d;N&&(!$||N.seq1Range.start<$.seq1Range.start)?d=e.shift():d=p.shift(),j.length>0&&j[j.length-1].seq1Range.endExclusive>=d.seq1Range.start?j[j.length-1]=j[j.length-1].join(d):j.push(d)}return j}function b(e,p,j){let N=j;if(N.length===0)return N;let $=0,d;do{d=!1;const a=[N[0]];for(let o=1;o<N.length;o++){let v=function(w,A){const E=new F.$ht(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(E).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const n=N[o],s=a[a.length-1];v(s,n)?(d=!0,a[a.length-1]=a[a.length-1].join(n)):a.push(n)}N=a}while($++<10&&d);return N}function m(e,p,j){let N=j;if(N.length===0)return N;let $=0,d;do{d=!1;const o=[N[0]];for(let n=1;n<N.length;n++){let g=function(A,E){const M=new F.$ht(v.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const R=e.getText(M).trim();if(R.length>20||R.split(/\r\n|\r|\n/).length>1)return!1;const T=e.countLinesIn(A.seq1Range),k=A.seq1Range.length,x=p.countLinesIn(A.seq2Range),O=A.seq2Range.length,X=e.countLinesIn(E.seq1Range),te=E.seq1Range.length,_=p.countLinesIn(E.seq2Range),Y=E.seq2Range.length,D=2*40+50;function z(ee){return Math.min(ee,D)}return Math.pow(Math.pow(z(T*40+k),1.5)+Math.pow(z(x*40+O),1.5),1.5)+Math.pow(Math.pow(z(X*40+te),1.5)+Math.pow(z(_*40+Y),1.5),1.5)>(D**1.5)**1.5*1.3};const s=N[n],v=o[o.length-1];g(v,s)?(d=!0,o[o.length-1]=o[o.length-1].join(s)):o.push(s)}N=o}while($++<10&&d);const a=[];return(0,i.$Cb)(N,(o,n,s)=>{let v=n;function g(R){return R.length>0&&R.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const w=e.extendToFullLines(n.seq1Range),A=e.getText(new F.$ht(w.start,n.seq1Range.start));g(A)&&(v=v.deltaStart(-A.length));const E=e.getText(new F.$ht(n.seq1Range.endExclusive,w.endExclusive));g(E)&&(v=v.deltaEnd(E.length));const M=y.$q2.fromOffsetPairs(o?o.getEndExclusives():y.$r2.zero,s?s.getStarts():y.$r2.max),P=v.intersect(M);a.length>0&&P.getStarts().equals(a[a.length-1].getEndExclusives())?a[a.length-1]=a[a.length-1].join(P):a.push(P)}),a}}),ne(re[48],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B2=void 0;class i{constructor(f,L){this.a=f,this.b=L}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const L=f===0?0:F(this.b[f-1]),h=f===this.b.length?0:F(this.b[f]);return 1e3-(L+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,L){return this.b[f]===this.b[L]}}t.$B2=i;function F(y){let f=0;for(;f<y.length&&(y.charCodeAt(f)===32||y.charCodeAt(f)===9);)f++;return f}}),ne(re[15],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$w2=t.$u2=void 0,t.$v2=F;class i{constructor(L,h){this.width=L,this.height=h,this.a=[],this.a=new Array(L*h)}get(L,h){return this.a[L+h*this.width]}set(L,h,l){this.a[L+h*this.width]=l}}t.$u2=i;function F(f){return f===32||f===9}class y{static{this.a=new Map}static b(L){let h=this.a.get(L);return h===void 0&&(h=this.a.size,this.a.set(L,h)),h}constructor(L,h,l){this.range=L,this.lines=h,this.source=l,this.d=[];let u=0;for(let c=L.startLineNumber-1;c<L.endLineNumberExclusive-1;c++){const B=h[c];for(let m=0;m<B.length;m++){u++;const e=B[m],p=y.b(e);this.d[p]=(this.d[p]||0)+1}u++;const b=y.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=u}computeSimilarity(L){let h=0;const l=Math.max(this.d.length,L.d.length);for(let u=0;u<l;u++)h+=Math.abs((this.d[u]??0)-(L.d[u]??0));return 1-h/(this.c+L.c)}}t.$w2=y}),ne(re[49],se([0,1,4,8,15]),function(V,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x2=void 0;class f{compute(h,l,u=F.$s2.instance,c){if(h.length===0||l.length===0)return F.$p2.trivial(h,l);const B=new y.$u2(h.length,l.length),b=new y.$u2(h.length,l.length),m=new y.$u2(h.length,l.length);for(let a=0;a<h.length;a++)for(let o=0;o<l.length;o++){if(!u.isValid())return F.$p2.trivialTimedOut(h,l);const n=a===0?0:B.get(a-1,o),s=o===0?0:B.get(a,o-1);let v;h.getElement(a)===l.getElement(o)?(a===0||o===0?v=0:v=B.get(a-1,o-1),a>0&&o>0&&b.get(a-1,o-1)===3&&(v+=m.get(a-1,o-1)),v+=c?c(a,o):1):v=-1;const g=Math.max(n,s,v);if(g===v){const w=a>0&&o>0?m.get(a-1,o-1):0;m.set(a,o,w+1),b.set(a,o,3)}else g===n?(m.set(a,o,0),b.set(a,o,1)):g===s&&(m.set(a,o,0),b.set(a,o,2));B.set(a,o,g)}const e=[];let p=h.length,j=l.length;function N(a,o){(a+1!==p||o+1!==j)&&e.push(new F.$q2(new i.$ht(a+1,p),new i.$ht(o+1,j))),p=a,j=o}let $=h.length-1,d=l.length-1;for(;$>=0&&d>=0;)b.get($,d)===3?(N($,d),$--,d--):b.get($,d)===1?$--:d--;return N(-1,-1),e.reverse(),new F.$p2(e,!1)}}t.$x2=f}),ne(re[32],se([0,1,9,4,5,2,15]),function(V,t,i,F,y,f,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$z2=void 0;class h{constructor(e,p,j){this.lines=e,this.considerWhitespaceChanges=j,this.b=[],this.c=[],this.d=[];let N=!1;p.start>0&&p.endExclusive>=e.length&&(p=new F.$ht(p.start-1,p.endExclusive),N=!0),this.lineRange=p,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let d=e[$],a=0;if(N)a=d.length,d="",N=!1;else if(!j){const o=d.trimStart();a=d.length-o.length,d=o.trimEnd()}this.d.push(a);for(let o=0;o<d.length;o++)this.b.push(d.charCodeAt(o));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.$ht(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(p=>String.fromCharCode(p)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const p=b(e>0?this.b[e-1]:-1),j=b(e<this.b.length?this.b[e]:-1);if(p===7&&j===8)return 0;if(p===8)return 150;let N=0;return p!==j&&(N+=10,p===0&&j===1&&(N+=1)),N+=B(p),N+=B(j),N}translateOffset(e){if(this.lineRange.isEmpty)return new y.$_s(this.lineRange.start+1,1);const p=(0,i.$ib)(this.c,j=>j<=e);return new y.$_s(this.lineRange.start+p+1,e-this.c[p]+this.d[p]+1)}translateRange(e){return f.$at.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let p=e;for(;p>0&&l(this.b[p-1]);)p--;let j=e;for(;j<this.b.length&&l(this.b[j]);)j++;return new F.$ht(p,j)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,p){return this.b[e]===this.b[p]}extendToFullLines(e){const p=(0,i.$hb)(this.c,N=>N<=e.start)??0,j=(0,i.$jb)(this.c,N=>e.endExclusive<=N)??this.b.length;return new F.$ht(p,j)}}t.$z2=h;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var u;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const c={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function B(m){return c[m]}function b(m){return m===10?8:m===13?7:(0,L.$v2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),ne(re[33],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pt=t.$ot=void 0;class i{constructor(f,L,h){this.changes=f,this.moves=L,this.hitTimeout=h}}t.$ot=i;class F{constructor(f,L){this.lineRangeMapping=f,this.changes=L}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$pt=F}),ne(re[16],se([0,1,12]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nt=t.$mt=t.$lt=void 0;class F{static inverse(h,l,u){const c=[];let B=1,b=1;for(const e of h){const p=new F(new i.$jt(B,e.original.startLineNumber),new i.$jt(b,e.modified.startLineNumber));p.modified.isEmpty||c.push(p),B=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const m=new F(new i.$jt(B,l+1),new i.$jt(b,u+1));return m.modified.isEmpty||c.push(m),c}static clip(h,l,u){const c=[];for(const B of h){const b=B.original.intersect(l),m=B.modified.intersect(u);b&&!b.isEmpty&&m&&!m.isEmpty&&c.push(new F(b,m))}return c}constructor(h,l){this.original=h,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(h){return new F(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$lt=F;class y extends F{constructor(h,l,u){super(h,l),this.innerChanges=u}flip(){return new y(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$mt=y;class f{constructor(h,l){this.originalRange=h,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$nt=f}),ne(re[50],se([0,1,8,16,6,9,22,12,4,32,15,31]),function(V,t,i,F,y,f,L,h,l,u,c,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A2=b;function b(d,a,o,n,s,v){let{moves:g,excludedChanges:w}=e(d,a,o,v);if(!v.isValid())return[];const A=d.filter(M=>!w.has(M)),E=p(A,n,s,a,o,v);return(0,y.$1b)(g,E),g=N(g),g=g.filter(M=>{const P=M.original.toOffsetRange().slice(a).map(T=>T.trim());return P.join(`
`).length>=15&&m(P,T=>T.length>=2)>=2}),g=$(d,g),g}function m(d,a){let o=0;for(const n of d)a(n)&&o++;return o}function e(d,a,o,n){const s=[],v=d.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new c.$w2(A.original,a,A)),g=new Set(d.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new c.$w2(A.modified,o,A))),w=new Set;for(const A of v){let E=-1,M;for(const P of g){const R=A.computeSimilarity(P);R>E&&(E=R,M=P)}if(E>.9&&M&&(g.delete(M),s.push(new F.$lt(A.range,M.range)),w.add(A.source),w.add(M.source)),!n.isValid())return{moves:s,excludedChanges:w}}return{moves:s,excludedChanges:w}}function p(d,a,o,n,s,v){const g=[],w=new L.$Hc;for(const R of d)for(let T=R.original.startLineNumber;T<R.original.endLineNumberExclusive-2;T++){const k=`${a[T-1]}:${a[T+1-1]}:${a[T+2-1]}`;w.add(k,{range:new h.$jt(T,T+3)})}const A=[];d.sort((0,y.$7b)(R=>R.modified.startLineNumber,y.$9b));for(const R of d){let T=[];for(let k=R.modified.startLineNumber;k<R.modified.endLineNumberExclusive-2;k++){const x=`${o[k-1]}:${o[k+1-1]}:${o[k+2-1]}`,O=new h.$jt(k,k+3),X=[];w.forEach(x,({range:te})=>{for(const Y of T)if(Y.originalLineRange.endLineNumberExclusive+1===te.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===O.endLineNumberExclusive){Y.originalLineRange=new h.$jt(Y.originalLineRange.startLineNumber,te.endLineNumberExclusive),Y.modifiedLineRange=new h.$jt(Y.modifiedLineRange.startLineNumber,O.endLineNumberExclusive),X.push(Y);return}const _={modifiedLineRange:O,originalLineRange:te};A.push(_),X.push(_)}),T=X}if(!v.isValid())return[]}A.sort((0,y.$$b)((0,y.$7b)(R=>R.modifiedLineRange.length,y.$9b)));const E=new h.$kt,M=new h.$kt;for(const R of A){const T=R.modifiedLineRange.startLineNumber-R.originalLineRange.startLineNumber,k=E.subtractFrom(R.modifiedLineRange),x=M.subtractFrom(R.originalLineRange).getWithDelta(T),O=k.getIntersection(x);for(const X of O.ranges){if(X.length<3)continue;const te=X,_=X.delta(-T);g.push(new F.$lt(_,te)),E.addRange(te),M.addRange(_)}}g.sort((0,y.$7b)(R=>R.original.startLineNumber,y.$9b));const P=new f.$mb(d);for(let R=0;R<g.length;R++){const T=g[R],k=P.findLastMonotonous(z=>z.original.startLineNumber<=T.original.startLineNumber),x=(0,f.$hb)(d,z=>z.modified.startLineNumber<=T.modified.startLineNumber),O=Math.max(T.original.startLineNumber-k.original.startLineNumber,T.modified.startLineNumber-x.modified.startLineNumber),X=P.findLastMonotonous(z=>z.original.startLineNumber<T.original.endLineNumberExclusive),te=(0,f.$hb)(d,z=>z.modified.startLineNumber<T.modified.endLineNumberExclusive),_=Math.max(X.original.endLineNumberExclusive-T.original.endLineNumberExclusive,te.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let Y;for(Y=0;Y<O;Y++){const z=T.original.startLineNumber-Y-1,ee=T.modified.startLineNumber-Y-1;if(z>n.length||ee>s.length||E.contains(ee)||M.contains(z)||!j(n[z-1],s[ee-1],v))break}Y>0&&(M.addRange(new h.$jt(T.original.startLineNumber-Y,T.original.startLineNumber)),E.addRange(new h.$jt(T.modified.startLineNumber-Y,T.modified.startLineNumber)));let D;for(D=0;D<_;D++){const z=T.original.endLineNumberExclusive+D,ee=T.modified.endLineNumberExclusive+D;if(z>n.length||ee>s.length||E.contains(ee)||M.contains(z)||!j(n[z-1],s[ee-1],v))break}D>0&&(M.addRange(new h.$jt(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+D)),E.addRange(new h.$jt(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+D))),(Y>0||D>0)&&(g[R]=new F.$lt(new h.$jt(T.original.startLineNumber-Y,T.original.endLineNumberExclusive+D),new h.$jt(T.modified.startLineNumber-Y,T.modified.endLineNumberExclusive+D)))}return g}function j(d,a,o){if(d.trim()===a.trim())return!0;if(d.length>300&&a.length>300)return!1;const s=new B.$y2().compute(new u.$z2([d],new l.$ht(0,1),!1),new u.$z2([a],new l.$ht(0,1),!1),o);let v=0;const g=i.$q2.invert(s.diffs,d.length);for(const M of g)M.seq1Range.forEach(P=>{(0,c.$v2)(d.charCodeAt(P))||v++});function w(M){let P=0;for(let R=0;R<d.length;R++)(0,c.$v2)(M.charCodeAt(R))||P++;return P}const A=w(d.length>a.length?d:a);return v/A>.6&&A>10}function N(d){if(d.length===0)return d;d.sort((0,y.$7b)(o=>o.original.startLineNumber,y.$9b));const a=[d[0]];for(let o=1;o<d.length;o++){const n=a[a.length-1],s=d[o],v=s.original.startLineNumber-n.original.endLineNumberExclusive,g=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(v>=0&&g>=0&&v+g<=2){a[a.length-1]=n.join(s);continue}a.push(s)}return a}function $(d,a){const o=new f.$mb(d);return a=a.filter(n=>{const s=o.findLastMonotonous(w=>w.original.startLineNumber<n.original.endLineNumberExclusive)||new F.$lt(new h.$jt(1,1),new h.$jt(1,1)),v=(0,f.$hb)(d,w=>w.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==v}),a}}),ne(re[51],se([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,16]),function(V,t,i,F,y,f,L,h,l,u,c,B,b,m,e,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H2=void 0,t.$I2=N,t.$J2=$;class j{constructor(){this.e=new l.$x2,this.f=new u.$y2}computeDiff(a,o,n){if(a.length<=1&&(0,i.$ub)(a,o,(D,z)=>D===z))return new e.$ot([],[],!1);if(a.length===1&&a[0].length===0||o.length===1&&o[0].length===0)return new e.$ot([new p.$mt(new y.$jt(1,a.length+1),new y.$jt(1,o.length+1),[new p.$nt(new L.$at(1,1,a.length,a[0].length+1),new L.$at(1,1,o.length,o[0].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?h.$s2.instance:new h.$t2(n.maxComputationTimeMs),v=!n.ignoreTrimWhitespace,g=new Map;function w(D){let z=g.get(D);return z===void 0&&(z=g.size,g.set(D,z)),z}const A=a.map(D=>w(D.trim())),E=o.map(D=>w(D.trim())),M=new b.$B2(A,a),P=new b.$B2(E,o),R=M.length+P.length<1700?this.e.compute(M,P,s,(D,z)=>a[D]===o[z]?o[z].length===0?.1:1+Math.log(1+o[z].length):.99):this.f.compute(M,P);let T=R.diffs,k=R.hitTimeout;T=(0,B.$C2)(M,P,T),T=(0,B.$F2)(M,P,T);const x=[],O=D=>{if(v)for(let z=0;z<D;z++){const ee=X+z,K=te+z;if(a[ee]!==o[K]){const fe=this.j(a,o,new h.$q2(new f.$ht(ee,ee+1),new f.$ht(K,K+1)),s,v);for(const r of fe.mappings)x.push(r);fe.hitTimeout&&(k=!0)}}};let X=0,te=0;for(const D of T){(0,F.$ad)(()=>D.seq1Range.start-X===D.seq2Range.start-te);const z=D.seq1Range.start-X;O(z),X=D.seq1Range.endExclusive,te=D.seq2Range.endExclusive;const ee=this.j(a,o,D,s,v);ee.hitTimeout&&(k=!0);for(const K of ee.mappings)x.push(K)}O(a.length-X);const _=N(x,a,o);let Y=[];return n.computeMoves&&(Y=this.h(_,a,o,A,E,s,v)),(0,F.$ad)(()=>{function D(ee,K){if(ee.lineNumber<1||ee.lineNumber>K.length)return!1;const fe=K[ee.lineNumber-1];return!(ee.column<1||ee.column>fe.length+1)}function z(ee,K){return!(ee.startLineNumber<1||ee.startLineNumber>K.length+1||ee.endLineNumberExclusive<1||ee.endLineNumberExclusive>K.length+1)}for(const ee of _){if(!ee.innerChanges)return!1;for(const K of ee.innerChanges)if(!(D(K.modifiedRange.getStartPosition(),o)&&D(K.modifiedRange.getEndPosition(),o)&&D(K.originalRange.getStartPosition(),a)&&D(K.originalRange.getEndPosition(),a)))return!1;if(!z(ee.modified,o)||!z(ee.original,a))return!1}return!0}),new e.$ot(_,Y,k)}h(a,o,n,s,v,g,w){return(0,c.$A2)(a,o,n,s,v,g).map(M=>{const P=this.j(o,n,new h.$q2(M.original.toOffsetRange(),M.modified.toOffsetRange()),g,w),R=N(P.mappings,o,n,!0);return new e.$pt(M,R)})}j(a,o,n,s,v){const g=new m.$z2(a,n.seq1Range,v),w=new m.$z2(o,n.seq2Range,v),A=g.length+w.length<500?this.e.compute(g,w,s):this.f.compute(g,w,s);let E=A.diffs;return E=(0,B.$C2)(g,w,E),E=(0,B.$E2)(g,w,E),E=(0,B.$D2)(g,w,E),E=(0,B.$G2)(g,w,E),{mappings:E.map(P=>new p.$nt(g.translateRange(P.seq1Range),w.translateRange(P.seq2Range))),hitTimeout:A.hitTimeout}}}t.$H2=j;function N(d,a,o,n=!1){const s=[];for(const v of(0,i.$Ab)(d.map(g=>$(g,a,o)),(g,w)=>g.original.overlapOrTouch(w.original)||g.modified.overlapOrTouch(w.modified))){const g=v[0],w=v[v.length-1];s.push(new p.$mt(g.original.join(w.original),g.modified.join(w.modified),v.map(A=>A.innerChanges[0])))}return(0,F.$ad)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||o.length-s[s.length-1].modified.endLineNumberExclusive!==a.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,F.$bd)(s,(v,g)=>g.original.startLineNumber-v.original.endLineNumberExclusive===g.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<g.original.startLineNumber&&v.modified.endLineNumberExclusive<g.modified.startLineNumber)),s}function $(d,a,o){let n=0,s=0;d.modifiedRange.endColumn===1&&d.originalRange.endColumn===1&&d.originalRange.startLineNumber+n<=d.originalRange.endLineNumber&&d.modifiedRange.startLineNumber+n<=d.modifiedRange.endLineNumber&&(s=-1),d.modifiedRange.startColumn-1>=o[d.modifiedRange.startLineNumber-1].length&&d.originalRange.startColumn-1>=a[d.originalRange.startLineNumber-1].length&&d.originalRange.startLineNumber<=d.originalRange.endLineNumber+s&&d.modifiedRange.startLineNumber<=d.modifiedRange.endLineNumber+s&&(n=1);const v=new y.$jt(d.originalRange.startLineNumber+n,d.originalRange.endLineNumber+1+s),g=new y.$jt(d.modifiedRange.startLineNumber+n,d.modifiedRange.endLineNumber+1+s);return new p.$mt(v,g,[d])}}),ne(re[34],se([0,1,25,33,16,7,2,13,12]),function(V,t,i,F,y,f,L,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rt=t.$qt=void 0;const u=3;class c{computeDiff(n,s,v){const w=new N(n,s,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let E=null;for(const M of w.changes){let P;M.originalEndLineNumber===0?P=new l.$jt(M.originalStartLineNumber+1,M.originalStartLineNumber+1):P=new l.$jt(M.originalStartLineNumber,M.originalEndLineNumber+1);let R;M.modifiedEndLineNumber===0?R=new l.$jt(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):R=new l.$jt(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let T=new y.$mt(P,R,M.charChanges?.map(k=>new y.$nt(new L.$at(k.originalStartLineNumber,k.originalStartColumn,k.originalEndLineNumber,k.originalEndColumn),new L.$at(k.modifiedStartLineNumber,k.modifiedStartColumn,k.modifiedEndLineNumber,k.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===T.modified.startLineNumber||E.original.endLineNumberExclusive===T.original.startLineNumber)&&(T=new y.$mt(E.original.join(T.original),E.modified.join(T.modified),E.innerChanges&&T.innerChanges?E.innerChanges.concat(T.innerChanges):void 0),A.pop()),A.push(T),E=T}return(0,h.$ad)(()=>(0,h.$bd)(A,(M,P)=>P.original.startLineNumber-M.original.endLineNumberExclusive===P.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<P.original.startLineNumber&&M.modified.endLineNumberExclusive<P.modified.startLineNumber)),new F.$ot(A,[],w.quitEarly)}}t.$qt=c;function B(o,n,s,v){return new i.$gt(o,n,s).ComputeDiff(v)}class b{constructor(n){const s=[],v=[];for(let g=0,w=n.length;g<w;g++)s[g]=$(n[g],1),v[g]=d(n[g],1);this.lines=n,this.a=s,this.b=v}getElements(){const n=[];for(let s=0,v=this.lines.length;s<v;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,v){const g=[],w=[],A=[];let E=0;for(let M=s;M<=v;M++){const P=this.lines[M],R=n?this.a[M]:1,T=n?this.b[M]:P.length+1;for(let k=R;k<T;k++)g[E]=P.charCodeAt(k-1),w[E]=M+1,A[E]=k,E++;!n&&M<v&&(g[E]=10,w[E]=M+1,A[E]=P.length+1,E++)}return new m(g,w,A)}}class m{constructor(n,s,v){this.a=n,this.b=s,this.d=v}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,v,g,w,A,E,M){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=v,this.originalEndColumn=g,this.modifiedStartLineNumber=w,this.modifiedStartColumn=A,this.modifiedEndLineNumber=E,this.modifiedEndColumn=M}static createFromDiffChange(n,s,v){const g=s.getStartLineNumber(n.originalStart),w=s.getStartColumn(n.originalStart),A=s.getEndLineNumber(n.originalStart+n.originalLength-1),E=s.getEndColumn(n.originalStart+n.originalLength-1),M=v.getStartLineNumber(n.modifiedStart),P=v.getStartColumn(n.modifiedStart),R=v.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),T=v.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(g,w,A,E,M,P,R,T)}}function p(o){if(o.length<=1)return o;const n=[o[0]];let s=n[0];for(let v=1,g=o.length;v<g;v++){const w=o[v],A=w.originalStart-(s.originalStart+s.originalLength),E=w.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(A,E)<u?(s.originalLength=w.originalStart+w.originalLength-s.originalStart,s.modifiedLength=w.modifiedStart+w.modifiedLength-s.modifiedStart):(n.push(w),s=w)}return n}class j{constructor(n,s,v,g,w){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=g,this.charChanges=w}static createFromDiffResult(n,s,v,g,w,A,E){let M,P,R,T,k;if(s.originalLength===0?(M=v.getStartLineNumber(s.originalStart)-1,P=0):(M=v.getStartLineNumber(s.originalStart),P=v.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(R=g.getStartLineNumber(s.modifiedStart)-1,T=0):(R=g.getStartLineNumber(s.modifiedStart),T=g.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),A&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&w()){const x=v.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),O=g.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(x.getElements().length>0&&O.getElements().length>0){let X=B(x,O,w,!0).changes;E&&(X=p(X)),k=[];for(let te=0,_=X.length;te<_;te++)k.push(e.createFromDiffChange(X[te],x,O))}}return new j(M,P,R,T,k)}}class N{constructor(n,s,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new b(n),this.j=new b(s),this.k=a(v.maxComputationTime),this.l=a(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=B(this.h,this.j,this.k,this.e),s=n.changes,v=n.quitEarly;if(this.d){const E=[];for(let M=0,P=s.length;M<P;M++)E.push(j.createFromDiffResult(this.d,s[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:E}}const g=[];let w=0,A=0;for(let E=-1,M=s.length;E<M;E++){const P=E+1<M?s[E+1]:null,R=P?P.originalStart:this.f.length,T=P?P.modifiedStart:this.g.length;for(;w<R&&A<T;){const k=this.f[w],x=this.g[A];if(k!==x){{let O=$(k,1),X=$(x,1);for(;O>1&&X>1;){const te=k.charCodeAt(O-2),_=x.charCodeAt(X-2);if(te!==_)break;O--,X--}(O>1||X>1)&&this.m(g,w+1,1,O,A+1,1,X)}{let O=d(k,1),X=d(x,1);const te=k.length+1,_=x.length+1;for(;O<te&&X<_;){const Y=k.charCodeAt(O-1),D=k.charCodeAt(X-1);if(Y!==D)break;O++,X++}(O<te||X<_)&&this.m(g,w+1,O,te,A+1,X,_)}}w++,A++}P&&(g.push(j.createFromDiffResult(this.d,P,this.h,this.j,this.l,this.a,this.b)),w+=P.originalLength,A+=P.modifiedLength)}return{quitEarly:v,changes:g}}m(n,s,v,g,w,A,E){if(this.n(n,s,v,g,w,A,E))return;let M;this.a&&(M=[new e(s,v,s,g,w,A,w,E)]),n.push(new j(s,s,w,w,M))}n(n,s,v,g,w,A,E){const M=n.length;if(M===0)return!1;const P=n[M-1];return P.originalEndLineNumber===0||P.modifiedEndLineNumber===0?!1:P.originalEndLineNumber===s&&P.modifiedEndLineNumber===w?(this.a&&P.charChanges&&P.charChanges.push(new e(s,v,s,g,w,A,w,E)),!0):P.originalEndLineNumber+1===s&&P.modifiedEndLineNumber+1===w?(P.originalEndLineNumber=s,P.modifiedEndLineNumber=w,this.a&&P.charChanges&&P.charChanges.push(new e(s,v,s,g,w,A,w,E)),!0):!1}}t.$rt=N;function $(o,n){const s=f.$af(o);return s===-1?n:s+1}function d(o,n){const s=f.$cf(o);return s===-1?n:s+2}function a(o){if(o===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<o}}),ne(re[52],se([0,1,34,51]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K2=void 0,t.$K2={getLegacy:()=>new i.$qt,getDefault:()=>new F.$H2}}),ne(re[53],se([0,1,36]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L2=B;function F(b){const m=[];for(const e of b){const p=Number(e);(p||p===0&&e.replace(/\s/g,"")!=="")&&m.push(p)}return m}function y(b,m,e,p){return{red:b/255,blue:e/255,green:m/255,alpha:p}}function f(b,m){const e=m.index,p=m[0].length;if(!e)return;const j=b.positionAt(e);return{startLineNumber:j.lineNumber,startColumn:j.column,endLineNumber:j.lineNumber,endColumn:j.column+p}}function L(b,m){if(!b)return;const e=i.$Et.Format.CSS.parseHex(m);if(e)return{range:b,color:y(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(b,m,e){if(!b||m.length!==1)return;const j=m[0].values(),N=F(j);return{range:b,color:y(N[0],N[1],N[2],e?N[3]:1)}}function l(b,m,e){if(!b||m.length!==1)return;const j=m[0].values(),N=F(j),$=new i.$Et(new i.$Ct(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:b,color:y($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(b,m){return typeof b=="string"?[...b.matchAll(m)]:b.findMatches(m)}function c(b){const m=[],p=u(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(p.length>0)for(const j of p){const N=j.filter(o=>o!==void 0),$=N[1],d=N[2];if(!d)continue;let a;if($==="rgb"){const o=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;a=h(f(b,j),u(d,o),!1)}else if($==="rgba"){const o=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=h(f(b,j),u(d,o),!0)}else if($==="hsl"){const o=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;a=l(f(b,j),u(d,o),!1)}else if($==="hsla"){const o=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=l(f(b,j),u(d,o),!0)}else $==="#"&&(a=L(f(b,j),$+d));a&&m.push(a)}return m}function B(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:c(b)}}),ne(re[54],se([0,1,29]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$k2=t.$j2=t.State=void 0,t.$l2=b;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class y{constructor(e,p,j){const N=new Uint8Array(e*p);for(let $=0,d=e*p;$<d;$++)N[$]=j;this.a=N,this.rows=e,this.cols=p}get(e,p){return this.a[e*this.cols+p]}set(e,p,j){this.a[e*this.cols+p]=j}}class f{constructor(e){let p=0,j=0;for(let $=0,d=e.length;$<d;$++){const[a,o,n]=e[$];o>p&&(p=o),a>j&&(j=a),n>j&&(j=n)}p++,j++;const N=new y(j,p,0);for(let $=0,d=e.length;$<d;$++){const[a,o,n]=e[$];N.set(a,o,n)}this.a=N,this.b=p}nextState(e,p){return p<0||p>=this.b?0:this.a.get(e,p)}}t.$j2=f;let L=null;function h(){return L===null&&(L=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let u=null;function c(){if(u===null){u=new i.$xt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<m.length;p++)u.set(m.charCodeAt(p),1);const e=".,;:";for(let p=0;p<e.length;p++)u.set(e.charCodeAt(p),2)}return u}class B{static a(e,p,j,N,$){let d=$-1;do{const a=p.charCodeAt(d);if(e.get(a)!==2)break;d--}while(d>N);if(N>0){const a=p.charCodeAt(N-1),o=p.charCodeAt(d);(a===40&&o===41||a===91&&o===93||a===123&&o===125)&&d--}return{range:{startLineNumber:j,startColumn:N+1,endLineNumber:j,endColumn:d+2},url:p.substring(N,d+1)}}static computeLinks(e,p=h()){const j=c(),N=[];for(let $=1,d=e.getLineCount();$<=d;$++){const a=e.getLineContent($),o=a.length;let n=0,s=0,v=0,g=1,w=!1,A=!1,E=!1,M=!1;for(;n<o;){let P=!1;const R=a.charCodeAt(n);if(g===13){let T;switch(R){case 40:w=!0,T=0;break;case 41:T=w?0:1;break;case 91:E=!0,A=!0,T=0;break;case 93:E=!1,T=A?0:1;break;case 123:M=!0,T=0;break;case 125:T=M?0:1;break;case 39:case 34:case 96:v===R?T=1:v===39||v===34||v===96?T=0:T=1;break;case 42:T=v===42?1:0;break;case 124:T=v===124?1:0;break;case 32:T=E?0:1;break;default:T=j.get(R)}T===1&&(N.push(B.a(j,a,$,s,n)),P=!0)}else if(g===12){let T;R===91?(A=!0,T=0):T=j.get(R),T===1?P=!0:g=13}else g=p.nextState(g,R),g===0&&(P=!0);P&&(g=1,w=!1,A=!1,M=!1,s=n+1,v=R),n++}g===13&&N.push(B.a(j,a,$,s,o))}return N}}t.$k2=B;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:B.computeLinks(m)}}),ne(re[55],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$m2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(y,f,L,h,l){if(y&&f){const u=this.a(f,l);if(u)return{range:y,value:u}}if(L&&h){const u=this.a(h,l);if(u)return{range:L,value:u}}return null}a(y,f){const L=this.b(y,f);return L!==null?L:this.d(y,f)}b(y,f){const L=Math.pow(10,y.length-(y.lastIndexOf(".")+1));let h=Number(y);const l=parseFloat(y);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!f?null:(h=Math.floor(h*L),h+=f?L:-L,String(h/L)):null}d(y,f){return this.e(this.c,y,f)}e(y,f,L){let h=null;for(let l=0,u=y.length;h===null&&l<u;l++)h=this.f(y[l],f,L);return h}f(y,f,L){let h=y.indexOf(f);return h>=0?(h+=L?1:-1,h<0?h=y.length-1:h%=y.length,y[h]):null}}t.$m2=i}),ne(re[56],se([0,1,14]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yv=t.$xv=t.$wv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$uv=t.$tv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$vv=m,t.$zv=d;var F;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var y;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=3]="Right"})(y||(t.GlyphMarginLane=y={}));var f;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var L;(function(a){a[a.Both=0]="Both",a[a.Right=1]="Right",a[a.Left=2]="Left",a[a.None=3]="None"})(L||(t.InjectedTextCursorStops=L={}));var h;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var l;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var u;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));class c{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,i.$Rn)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}t.$tv=c;class B{constructor(o,n){this._findMatchBrand=void 0,this.range=o,this.matches=n}}t.$uv=B;var b;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function m(a){return a&&typeof a.read=="function"}var e;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None",a[a.LeftOfInjectedText=3]="LeftOfInjectedText",a[a.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var p;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(t.ModelConstants=p={}));class j{constructor(o,n,s,v,g,w){this.identifier=o,this.range=n,this.text=s,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=g,this._isTracked=w}}t.$wv=j;class N{constructor(o,n,s){this.regex=o,this.wordSeparators=n,this.simpleSearch=s}}t.$xv=N;class ${constructor(o,n,s){this.reverseEdits=o,this.changes=n,this.trimAutoWhitespaceLineNumbers=s}}t.$yv=$;function d(a){return!a.isTooLargeForSyncing()&&!a.isForSimpleWidget}}),ne(re[57],se([0,1,6,28]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ev=t.$Dv=t.$Cv=void 0;class y{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,u){l=(0,F.$Te)(l);const c=this.a,B=this.b,b=u.length;return b===0?!1:(this.a=new Uint32Array(c.length+b),this.a.set(c.subarray(0,l),0),this.a.set(c.subarray(l),l+b),this.a.set(u,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(B.subarray(0,this.c[0]+1)),!0)}setValue(l,u){return l=(0,F.$Te)(l),u=(0,F.$Te)(u),this.a[l]===u?!1:(this.a[l]=u,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,u){l=(0,F.$Te)(l),u=(0,F.$Te)(u);const c=this.a,B=this.b;if(l>=c.length)return!1;const b=c.length-l;return u>=b&&(u=b),u===0?!1:(this.a=new Uint32Array(c.length-u),this.a.set(c.subarray(0,l),0),this.a.set(c.subarray(l+u),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(B.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,F.$Te)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),l>=this.a.length&&(l=this.a.length-1);for(let c=u;c<=l;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let u=0,c=this.a.length-1,B=0,b=0,m=0;for(;u<=c;)if(B=u+(c-u)/2|0,b=this.b[B],m=b-this.a[B],l<m)c=B-1;else if(l>=b)u=B+1;else break;return new L(B,l-m)}}t.$Cv=y;class f{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const u=this.e[l],c=u>0?this.d[u-1]:0;return new L(u,l-c)}removeValues(l,u){this.a.splice(l,u),this.f(l)}insertValues(l,u){this.a=(0,i.$Wb)(this.a,l,u),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,u=this.a.length;l<u;l++){const c=this.a[l],B=l>0?this.d[l-1]:0;this.d[l]=B+c;for(let b=0;b<c;b++)this.e[B+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,u){this.a[l]!==u&&(this.a[l]=u,this.f(l))}}t.$Dv=f;class L{constructor(l,u){this.index=l,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=u}}t.$Ev=L}),ne(re[58],se([0,1,7,5,57]),function(V,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fv=void 0;class f{constructor(h,l,u,c){this.d=h,this.f=l,this.g=u,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const l=h.changes;for(const u of l)this.o(u.range),this.p(new F.$_s(u.range.startLineNumber,u.range.startColumn),u.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,l=this.f.length,u=new Uint32Array(l);for(let c=0;c<l;c++)u[c]=this.f[c].length+h;this.j=new y.$Cv(u)}}n(h,l){this.f[h]=l,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,l){if(l.length===0)return;const u=(0,i.$$e)(l);if(u.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+u[0]+this.f[h.lineNumber-1].substring(h.column-1));return}u[u.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+u[0]);const c=new Uint32Array(u.length-1);for(let B=1;B<u.length;B++)this.f.splice(h.lineNumber+B-1,0,u[B]),c[B-1]=u[B].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,c)}}t.$Fv=f}),ne(re[59],se([0,1,7,46,5,2,56]),function(V,t,i,F,y,f,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qC=t.$oC=t.$lC=void 0,t.$mC=u,t.$nC=c,t.$pC=p;const h=999;class l{constructor($,d,a,o){this.searchString=$,this.isRegex=d,this.matchCase=a,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let d=null;try{d=i.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!d)return null;let a=!this.isRegex&&!$;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new L.$xv(d,this.wordSeparators?(0,F.$At)(this.wordSeparators):null,a?this.searchString:null)}}t.$lC=l;function u(N){if(!N||N.length===0)return!1;for(let $=0,d=N.length;$<d;$++){const a=N.charCodeAt($);if(a===10)return!0;if(a===92){if($++,$>=d)break;const o=N.charCodeAt($);if(o===110||o===114||o===87)return!0}}return!1}function c(N,$,d){if(!d)return new L.$uv(N,null);const a=[];for(let o=0,n=$.length;o<n;o++)a[o]=$[o];return new L.$uv(N,a)}class B{constructor($){const d=[];let a=0;for(let o=0,n=$.length;o<n;o++)$.charCodeAt(o)===10&&(d[a++]=o);this.a=d}findLineFeedCountBeforeOffset($){const d=this.a;let a=0,o=d.length-1;if(o===-1||$<=d[0])return 0;for(;a<o;){const n=a+((o-a)/2>>0);d[n]>=$?o=n-1:d[n+1]>=$?(a=n,o=n):a=n+1}return a+1}}class b{static findMatches($,d,a,o,n){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b($,a,new j(s.wordSeparators,s.regex),o,n):this.c($,a,s,o,n):[]}static a($,d,a,o,n,s){let v,g=0;o?(g=o.findLineFeedCountBeforeOffset(n),v=d+n+g):v=d+n;let w;if(o){const P=o.findLineFeedCountBeforeOffset(n+s.length)-g;w=v+s.length+P}else w=v+s.length;const A=$.getPositionAt(v),E=$.getPositionAt(w);return new f.$at(A.lineNumber,A.column,E.lineNumber,E.column)}static b($,d,a,o,n){const s=$.getOffsetAt(d.getStartPosition()),v=$.getValueInRange(d,1),g=$.getEOL()===`\r
`?new B(v):null,w=[];let A=0,E;for(a.reset(0);E=a.next(v);)if(w[A++]=c(this.a($,s,v,g,E.index,E[0]),E,o),A>=n)return w;return w}static c($,d,a,o,n){const s=[];let v=0;if(d.startLineNumber===d.endLineNumber){const w=$.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return v=this.d(a,w,d.startLineNumber,d.startColumn-1,v,s,o,n),s}const g=$.getLineContent(d.startLineNumber).substring(d.startColumn-1);v=this.d(a,g,d.startLineNumber,d.startColumn-1,v,s,o,n);for(let w=d.startLineNumber+1;w<d.endLineNumber&&v<n;w++)v=this.d(a,$.getLineContent(w),w,0,v,s,o,n);if(v<n){const w=$.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);v=this.d(a,w,d.endLineNumber,0,v,s,o,n)}return s}static d($,d,a,o,n,s,v,g){const w=$.wordSeparators;if(!v&&$.simpleSearch){const M=$.simpleSearch,P=M.length,R=d.length;let T=-P;for(;(T=d.indexOf(M,T+P))!==-1;)if((!w||p(w,d,R,T,P))&&(s[n++]=new L.$uv(new f.$at(a,T+1+o,a,T+1+P+o),null),n>=g))return n;return n}const A=new j($.wordSeparators,$.regex);let E;A.reset(0);do if(E=A.next(d),E&&(s[n++]=c(new f.$at(a,E.index+1+o,a,E.index+1+E[0].length+o),E,v),n>=g))return n;while(E);return n}static findNextMatch($,d,a,o){const n=d.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,a,s,o):this.f($,a,s,o)}static e($,d,a,o){const n=new y.$_s(d.lineNumber,1),s=$.getOffsetAt(n),v=$.getLineCount(),g=$.getValueInRange(new f.$at(n.lineNumber,n.column,v,$.getLineMaxColumn(v)),1),w=$.getEOL()===`\r
`?new B(g):null;a.reset(d.column-1);const A=a.next(g);return A?c(this.a($,s,g,w,A.index,A[0]),A,o):d.lineNumber!==1||d.column!==1?this.e($,new y.$_s(1,1),a,o):null}static f($,d,a,o){const n=$.getLineCount(),s=d.lineNumber,v=$.getLineContent(s),g=this.g(a,v,s,d.column,o);if(g)return g;for(let w=1;w<=n;w++){const A=(s+w-1)%n,E=$.getLineContent(A+1),M=this.g(a,E,A+1,1,o);if(M)return M}return null}static g($,d,a,o,n){$.reset(o-1);const s=$.next(d);return s?c(new f.$at(a,s.index+1,a,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,d,a,o){const n=d.parseSearchRequest();if(!n)return null;const s=new j(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,a,s,o):this.j($,a,s,o)}static h($,d,a,o){const n=this.b($,new f.$at(1,1,d.lineNumber,d.column),a,o,10*h);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return d.lineNumber!==s||d.column!==$.getLineMaxColumn(s)?this.h($,new y.$_s(s,$.getLineMaxColumn(s)),a,o):null}static j($,d,a,o){const n=$.getLineCount(),s=d.lineNumber,v=$.getLineContent(s).substring(0,d.column-1),g=this.k(a,v,s,o);if(g)return g;for(let w=1;w<=n;w++){const A=(n+s-w-1)%n,E=$.getLineContent(A+1),M=this.k(a,E,A+1,o);if(M)return M}return null}static k($,d,a,o){let n=null,s;for($.reset(0);s=$.next(d);)n=c(new f.$at(a,s.index+1,a,s.index+1+s[0].length),s,o);return n}}t.$oC=b;function m(N,$,d,a,o){if(a===0)return!0;const n=$.charCodeAt(a-1);if(N.get(n)!==0||n===13||n===10)return!0;if(o>0){const s=$.charCodeAt(a);if(N.get(s)!==0)return!0}return!1}function e(N,$,d,a,o){if(a+o===d)return!0;const n=$.charCodeAt(a+o);if(N.get(n)!==0||n===13||n===10)return!0;if(o>0){const s=$.charCodeAt(a+o-1);if(N.get(s)!==0)return!0}return!1}function p(N,$,d,a,o){return m(N,$,d,a,o)&&e(N,$,d,a,o)}class j{constructor($,d){this._wordSeparators=$,this.a=d,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const d=$.length;let a;do{if(this.b+this.c===d||(a=this.a.exec($),!a))return null;const o=a.index,n=a[0].length;if(o===this.b&&n===this.c){if(n===0){i.$sf($,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=n,!this._wordSeparators||p(this._wordSeparators,$,d,o,n))return a}while(a);return null}}t.$qC=j}),ne(re[60],se([0,1,2,59,7,13,30]),function(V,t,i,F,y,f,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$i2=void 0;class h{static computeUnicodeHighlights(e,p,j){const N=j?j.startLineNumber:1,$=j?j.endLineNumber:e.getLineCount(),d=new c(p),a=d.getCandidateCodePoints();let o;a==="allNonBasicAscii"?o=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):o=new RegExp(`${l(Array.from(a))}`,"g");const n=new F.$qC(null,o),s=[];let v=!1,g,w=0,A=0,E=0;e:for(let M=N,P=$;M<=P;M++){const R=e.getLineContent(M),T=R.length;n.reset(0);do if(g=n.next(R),g){let k=g.index,x=g.index+g[0].length;if(k>0){const _=R.charCodeAt(k-1);y.$pf(_)&&k--}if(x+1<T){const _=R.charCodeAt(x-1);y.$pf(_)&&x++}const O=R.substring(k,x);let X=(0,L.$Ps)(k+1,L.$Ms,R,0);X&&X.endColumn<=k+1&&(X=null);const te=d.shouldHighlightNonBasicASCII(O,X?X.word:null);if(te!==0){if(te===3?w++:te===2?A++:te===1?E++:(0,f.$0c)(te),s.length>=1e3){v=!0;break e}s.push(new i.$at(M,k+1,M,x+1))}}while(g)}return{ranges:s,hasMore:v,ambiguousCharacterCount:w,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:E}}static computeUnicodeHighlightReason(e,p){const j=new c(p);switch(j.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),d=j.ambiguousCharacters.getPrimaryConfusable($),a=y.$Sf.getLocales().filter(o=>!y.$Sf.getInstance(new Set([...p.allowedLocales,o])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}t.$i2=h;function l(m,e){return`[${y.$Ze(m.map(j=>String.fromCodePoint(j)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=y.$Sf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const p of y.$Tf.codePoints)B(String.fromCodePoint(p))||e.add(p);if(this.b.ambiguousCharacters)for(const p of this.ambiguousCharacters.getConfusableCodePoints())e.add(p);for(const p of this.a)e.delete(p);return e}shouldHighlightNonBasicASCII(e,p){const j=e.codePointAt(0);if(this.a.has(j))return 0;if(this.b.nonBasicASCII)return 1;let N=!1,$=!1;if(p)for(const d of p){const a=d.codePointAt(0),o=y.$Af(d);N=N||o,!o&&!this.ambiguousCharacters.isAmbiguous(a)&&!y.$Tf.isInvisibleCharacter(a)&&($=!0)}return!N&&$?0:this.b.invisibleCharacters&&!B(e)&&y.$Tf.isInvisibleCharacter(j)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(j)?3:0}}function B(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),ne(re[61],se([0,1]),function(V,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var F;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var y;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(y||(t.CompletionItemInsertTextRule=y={}));var f;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var L;(function(r){r[r.Deprecated=1]="Deprecated"})(L||(t.CompletionItemTag=L={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var B;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(B||(t.DocumentHighlightKind=B={}));var b;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSeparators=130]="wordSeparators",r[r.wordWrap=131]="wordWrap",r[r.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=134]="wordWrapColumn",r[r.wordWrapOverride1=135]="wordWrapOverride1",r[r.wordWrapOverride2=136]="wordWrapOverride2",r[r.wrappingIndent=137]="wrappingIndent",r[r.wrappingStrategy=138]="wrappingStrategy",r[r.showDeprecated=139]="showDeprecated",r[r.inlayHints=140]="inlayHints",r[r.editorClassName=141]="editorClassName",r[r.pixelRatio=142]="pixelRatio",r[r.tabFocusMode=143]="tabFocusMode",r[r.layoutInfo=144]="layoutInfo",r[r.wrappingInfo=145]="wrappingInfo",r[r.defaultColorDecorators=146]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var p;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(p||(t.EndOfLineSequence=p={}));var j;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(j||(t.GlyphMarginLane=j={}));var N;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var $;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var d;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(d||(t.InlayHintKind=d={}));var a;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(a||(t.InlineCompletionTriggerKind=a={}));var o;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(o||(t.InlineEditTriggerKind=o={}));var n;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s||(t.MarkerSeverity=s={}));var v;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(v||(t.MarkerTag=v={}));var g;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(g||(t.MinimapPosition=g={}));var w;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(w||(t.MouseTargetType=w={}));var A;(function(r){r[r.AIGenerated=1]="AIGenerated"})(A||(t.NewSymbolNameTag=A={}));var E;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(E||(t.OverlayWidgetPositionPreference=E={}));var M;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var P;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(P||(t.PartialAcceptTriggerKind=P={}));var R;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(R||(t.PositionAffinity=R={}));var T;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(T||(t.RenderLineNumbersType=T={}));var k;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var x;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(x||(t.ScrollType=x={}));var O;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(O||(t.ScrollbarVisibility=O={}));var X;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(X||(t.SelectionDirection=X={}));var te;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(te||(t.ShowLightbulbIconMode=te={}));var _;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var Y;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(Y||(t.SymbolKind=Y={}));var D;(function(r){r[r.Deprecated=1]="Deprecated"})(D||(t.SymbolTag=D={}));var z;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(z||(t.TextEditorCursorBlinkingStyle=z={}));var ee;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(ee||(t.TextEditorCursorStyle=ee={}));var K;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(K||(t.TrackedRangeStickiness=K={}));var fe;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(fe||(t.WrappingIndent=fe={}))}),ne(re[62],se([0,1,11,10]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lt=void 0;class y{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this.a.set(h,l),this.handleChange([h]),(0,F.$Sc)(()=>{this.a.get(h)===l&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,l){this.b.get(h)?.dispose();const u=new f(this,h,l);return this.b.set(h,u),(0,F.$Sc)(()=>{const c=this.b.get(h);!c||c!==u||(this.b.delete(h),c.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const u=this.b.get(h);return!u||u.isResolved?null:(await u.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const u=this.b.get(h);return!!(!u||u.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Lt=y;class f extends F.$Uc{get isResolved(){return this.c}constructor(h,l,u){super(),this.f=h,this.g=l,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),ne(re[63],se([64,65]),function(V,t){return V.create("vs/base/common/platform",t)}),ne(re[17],se([0,1,63]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=s,t.$D=M,t.$J=P,t.$g="en";let F=!1,y=!1,f=!1,L=!1,h=!1,l=!1,u=!1,c=!1,B=!1,b=!1,m,e=t.$g,p=t.$g,j,N;const $=globalThis;let d;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?d=$.vscode.process:typeof process<"u"&&(d=process);const a=typeof d?.versions?.electron=="string",o=a&&d?.type==="renderer";if(typeof d=="object"){F=d.platform==="win32",y=d.platform==="darwin",f=d.platform==="linux",L=f&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,u=a,B=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const R=d.env.VSCODE_NLS_CONFIG;if(R)try{const T=JSON.parse(R),k=T.availableLanguages["*"];m=T.locale,p=T.osLocale,e=k||t.$g,j=T._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!o?(N=navigator.userAgent,F=N.indexOf("Windows")>=0,y=N.indexOf("Macintosh")>=0,c=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=N.indexOf("Linux")>=0,b=N?.indexOf("Mobi")>=0,l=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,p=navigator.language):console.error("Unable to resolve platform.");var n;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let v=0;y?v=1:F?v=3:f&&(v=2),t.$i=F,t.$j=y,t.$k=f,t.$l=L,t.$m=h,t.$n=u,t.$o=l,t.$p=l&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=c,t.$s=b,t.$t=B,t.$u=v,t.$v=N,t.$w=e;var g;(function(R){function T(){return t.$w}R.value=T;function k(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}R.isDefaultVariant=k;function x(){return t.$w==="en"}R.isDefault=x})(g||(t.Language=g={})),t.$x=m,t.$y=p,t.$z=j,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const R=[];$.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let x=0,O=R.length;x<O;x++){const X=R[x];if(X.id===k.data.vscodeScheduleAsyncWork){R.splice(x,1),X.callback();return}}});let T=0;return k=>{const x=++T;R.push({id:x,callback:k}),$.postMessage({vscodeScheduleAsyncWork:x},"*")}}return R=>setTimeout(R)})();var w;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=y||c?2:F?1:3;let A=!0,E=!1;function M(){if(!E){E=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,A=new Uint16Array(R.buffer)[0]===513}return A}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function P(R){return parseFloat(R)>=20}}),ne(re[66],se([0,1,17]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let F;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const f=y.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$ec=F.platform,t.$fc=F.arch}),ne(re[67],se([0,1,66]),function(V,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const F=65,y=97,f=90,L=122,h=46,l=47,u=92,c=58,B=63;class b extends Error{constructor(s,v,g){let w;typeof v=="string"&&v.indexOf("not ")===0?(w="must not be",v=v.replace(/^not /,"")):w="must be";const A=s.indexOf(".")!==-1?"property":"argument";let E=`The "${s}" ${A} ${w} of type ${v}`;E+=`. Received type ${typeof g}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new b(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new b(s,"string",n)}const p=i.$ec==="win32";function j(n){return n===l||n===u}function N(n){return n===l}function $(n){return n>=F&&n<=f||n>=y&&n<=L}function d(n,s,v,g){let w="",A=0,E=-1,M=0,P=0;for(let R=0;R<=n.length;++R){if(R<n.length)P=n.charCodeAt(R);else{if(g(P))break;P=l}if(g(P)){if(!(E===R-1||M===1))if(M===2){if(w.length<2||A!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const T=w.lastIndexOf(v);T===-1?(w="",A=0):(w=w.slice(0,T),A=w.length-1-w.lastIndexOf(v)),E=R,M=0;continue}else if(w.length!==0){w="",A=0,E=R,M=0;continue}}s&&(w+=w.length>0?`${v}..`:"..",A=2)}else w.length>0?w+=`${v}${n.slice(E+1,R)}`:w=n.slice(E+1,R),A=R-E-1;E=R,M=0}else P===h&&M!==-1?++M:M=-1}return w}function a(n,s){m(s,"pathObject");const v=s.dir||s.root,g=s.base||`${s.name||""}${s.ext||""}`;return v?v===s.root?`${v}${g}`:`${v}${n}${g}`:g}t.$gc={resolve(...n){let s="",v="",g=!1;for(let w=n.length-1;w>=-1;w--){let A;if(w>=0){if(A=n[w],e(A,"path"),A.length===0)continue}else s.length===0?A=i.cwd():(A=i.env[`=${s}`]||i.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==s.toLowerCase()&&A.charCodeAt(2)===u)&&(A=`${s}\\`));const E=A.length;let M=0,P="",R=!1;const T=A.charCodeAt(0);if(E===1)j(T)&&(M=1,R=!0);else if(j(T))if(R=!0,j(A.charCodeAt(1))){let k=2,x=k;for(;k<E&&!j(A.charCodeAt(k));)k++;if(k<E&&k!==x){const O=A.slice(x,k);for(x=k;k<E&&j(A.charCodeAt(k));)k++;if(k<E&&k!==x){for(x=k;k<E&&!j(A.charCodeAt(k));)k++;(k===E||k!==x)&&(P=`\\\\${O}\\${A.slice(x,k)}`,M=k)}}}else M=1;else $(T)&&A.charCodeAt(1)===c&&(P=A.slice(0,2),M=2,E>2&&j(A.charCodeAt(2))&&(R=!0,M=3));if(P.length>0)if(s.length>0){if(P.toLowerCase()!==s.toLowerCase())continue}else s=P;if(g){if(s.length>0)break}else if(v=`${A.slice(M)}\\${v}`,g=R,R&&s.length>0)break}return v=d(v,!g,"\\",j),g?`${s}\\${v}`:`${s}${v}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let v=0,g,w=!1;const A=n.charCodeAt(0);if(s===1)return N(A)?"\\":n;if(j(A))if(w=!0,j(n.charCodeAt(1))){let M=2,P=M;for(;M<s&&!j(n.charCodeAt(M));)M++;if(M<s&&M!==P){const R=n.slice(P,M);for(P=M;M<s&&j(n.charCodeAt(M));)M++;if(M<s&&M!==P){for(P=M;M<s&&!j(n.charCodeAt(M));)M++;if(M===s)return`\\\\${R}\\${n.slice(P)}\\`;M!==P&&(g=`\\\\${R}\\${n.slice(P,M)}`,v=M)}}}else v=1;else $(A)&&n.charCodeAt(1)===c&&(g=n.slice(0,2),v=2,s>2&&j(n.charCodeAt(2))&&(w=!0,v=3));let E=v<s?d(n.slice(v),!w,"\\",j):"";return E.length===0&&!w&&(E="."),E.length>0&&j(n.charCodeAt(s-1))&&(E+="\\"),g===void 0?w?`\\${E}`:E:w?`${g}\\${E}`:`${g}${E}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const v=n.charCodeAt(0);return j(v)||s>2&&$(v)&&n.charCodeAt(1)===c&&j(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,v;for(let A=0;A<n.length;++A){const E=n[A];e(E,"path"),E.length>0&&(s===void 0?s=v=E:s+=`\\${E}`)}if(s===void 0)return".";let g=!0,w=0;if(typeof v=="string"&&j(v.charCodeAt(0))){++w;const A=v.length;A>1&&j(v.charCodeAt(1))&&(++w,A>2&&(j(v.charCodeAt(2))?++w:g=!1))}if(g){for(;w<s.length&&j(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const v=t.$gc.resolve(n),g=t.$gc.resolve(s);if(v===g||(n=v.toLowerCase(),s=g.toLowerCase(),n===s))return"";let w=0;for(;w<n.length&&n.charCodeAt(w)===u;)w++;let A=n.length;for(;A-1>w&&n.charCodeAt(A-1)===u;)A--;const E=A-w;let M=0;for(;M<s.length&&s.charCodeAt(M)===u;)M++;let P=s.length;for(;P-1>M&&s.charCodeAt(P-1)===u;)P--;const R=P-M,T=E<R?E:R;let k=-1,x=0;for(;x<T;x++){const X=n.charCodeAt(w+x);if(X!==s.charCodeAt(M+x))break;X===u&&(k=x)}if(x!==T){if(k===-1)return g}else{if(R>T){if(s.charCodeAt(M+x)===u)return g.slice(M+x+1);if(x===2)return g.slice(M+x)}E>T&&(n.charCodeAt(w+x)===u?k=x:x===2&&(k=3)),k===-1&&(k=0)}let O="";for(x=w+k+1;x<=A;++x)(x===A||n.charCodeAt(x)===u)&&(O+=O.length===0?"..":"\\..");return M+=k,O.length>0?`${O}${g.slice(M,P)}`:(g.charCodeAt(M)===u&&++M,g.slice(M,P))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$gc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const v=s.charCodeAt(2);if(v!==B&&v!==h)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===c&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let v=-1,g=0;const w=n.charCodeAt(0);if(s===1)return j(w)?n:".";if(j(w)){if(v=g=1,j(n.charCodeAt(1))){let M=2,P=M;for(;M<s&&!j(n.charCodeAt(M));)M++;if(M<s&&M!==P){for(P=M;M<s&&j(n.charCodeAt(M));)M++;if(M<s&&M!==P){for(P=M;M<s&&!j(n.charCodeAt(M));)M++;if(M===s)return n;M!==P&&(v=g=M+1)}}}}else $(w)&&n.charCodeAt(1)===c&&(v=s>2&&j(n.charCodeAt(2))?3:2,g=v);let A=-1,E=!0;for(let M=s-1;M>=g;--M)if(j(n.charCodeAt(M))){if(!E){A=M;break}}else E=!1;if(A===-1){if(v===-1)return".";A=v}return n.slice(0,A)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let v=0,g=-1,w=!0,A;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===c&&(v=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let E=s.length-1,M=-1;for(A=n.length-1;A>=v;--A){const P=n.charCodeAt(A);if(j(P)){if(!w){v=A+1;break}}else M===-1&&(w=!1,M=A+1),E>=0&&(P===s.charCodeAt(E)?--E===-1&&(g=A):(E=-1,g=M))}return v===g?g=M:g===-1&&(g=n.length),n.slice(v,g)}for(A=n.length-1;A>=v;--A)if(j(n.charCodeAt(A))){if(!w){v=A+1;break}}else g===-1&&(w=!1,g=A+1);return g===-1?"":n.slice(v,g)},extname(n){e(n,"path");let s=0,v=-1,g=0,w=-1,A=!0,E=0;n.length>=2&&n.charCodeAt(1)===c&&$(n.charCodeAt(0))&&(s=g=2);for(let M=n.length-1;M>=s;--M){const P=n.charCodeAt(M);if(j(P)){if(!A){g=M+1;break}continue}w===-1&&(A=!1,w=M+1),P===h?v===-1?v=M:E!==1&&(E=1):v!==-1&&(E=-1)}return v===-1||w===-1||E===0||E===1&&v===w-1&&v===g+1?"":n.slice(v,w)},format:a.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const v=n.length;let g=0,w=n.charCodeAt(0);if(v===1)return j(w)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(j(w)){if(g=1,j(n.charCodeAt(1))){let k=2,x=k;for(;k<v&&!j(n.charCodeAt(k));)k++;if(k<v&&k!==x){for(x=k;k<v&&j(n.charCodeAt(k));)k++;if(k<v&&k!==x){for(x=k;k<v&&!j(n.charCodeAt(k));)k++;k===v?g=k:k!==x&&(g=k+1)}}}}else if($(w)&&n.charCodeAt(1)===c){if(v<=2)return s.root=s.dir=n,s;if(g=2,j(n.charCodeAt(2))){if(v===3)return s.root=s.dir=n,s;g=3}}g>0&&(s.root=n.slice(0,g));let A=-1,E=g,M=-1,P=!0,R=n.length-1,T=0;for(;R>=g;--R){if(w=n.charCodeAt(R),j(w)){if(!P){E=R+1;break}continue}M===-1&&(P=!1,M=R+1),w===h?A===-1?A=R:T!==1&&(T=1):A!==-1&&(T=-1)}return M!==-1&&(A===-1||T===0||T===1&&A===M-1&&A===E+1?s.base=s.name=n.slice(E,M):(s.name=n.slice(E,A),s.base=n.slice(E,M),s.ext=n.slice(A,M))),E>0&&E!==g?s.dir=n.slice(0,E-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(p){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...n){let s="",v=!1;for(let g=n.length-1;g>=-1&&!v;g--){const w=g>=0?n[g]:o();e(w,"path"),w.length!==0&&(s=`${w}/${s}`,v=w.charCodeAt(0)===l)}return s=d(s,!v,"/",N),v?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l,v=n.charCodeAt(n.length-1)===l;return n=d(n,!s,"/",N),n.length===0?s?"/":v?"./":".":(v&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===l},join(...n){if(n.length===0)return".";let s;for(let v=0;v<n.length;++v){const g=n[v];e(g,"path"),g.length>0&&(s===void 0?s=g:s+=`/${g}`)}return s===void 0?".":t.$hc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$hc.resolve(n),s=t.$hc.resolve(s),n===s))return"";const v=1,g=n.length,w=g-v,A=1,E=s.length-A,M=w<E?w:E;let P=-1,R=0;for(;R<M;R++){const k=n.charCodeAt(v+R);if(k!==s.charCodeAt(A+R))break;k===l&&(P=R)}if(R===M)if(E>M){if(s.charCodeAt(A+R)===l)return s.slice(A+R+1);if(R===0)return s.slice(A+R)}else w>M&&(n.charCodeAt(v+R)===l?P=R:R===0&&(P=0));let T="";for(R=v+P+1;R<=g;++R)(R===g||n.charCodeAt(R)===l)&&(T+=T.length===0?"..":"/..");return`${T}${s.slice(A+P)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l;let v=-1,g=!0;for(let w=n.length-1;w>=1;--w)if(n.charCodeAt(w)===l){if(!g){v=w;break}}else g=!1;return v===-1?s?"/":".":s&&v===1?"//":n.slice(0,v)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let v=0,g=-1,w=!0,A;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let E=s.length-1,M=-1;for(A=n.length-1;A>=0;--A){const P=n.charCodeAt(A);if(P===l){if(!w){v=A+1;break}}else M===-1&&(w=!1,M=A+1),E>=0&&(P===s.charCodeAt(E)?--E===-1&&(g=A):(E=-1,g=M))}return v===g?g=M:g===-1&&(g=n.length),n.slice(v,g)}for(A=n.length-1;A>=0;--A)if(n.charCodeAt(A)===l){if(!w){v=A+1;break}}else g===-1&&(w=!1,g=A+1);return g===-1?"":n.slice(v,g)},extname(n){e(n,"path");let s=-1,v=0,g=-1,w=!0,A=0;for(let E=n.length-1;E>=0;--E){const M=n.charCodeAt(E);if(M===l){if(!w){v=E+1;break}continue}g===-1&&(w=!1,g=E+1),M===h?s===-1?s=E:A!==1&&(A=1):s!==-1&&(A=-1)}return s===-1||g===-1||A===0||A===1&&s===g-1&&s===v+1?"":n.slice(s,g)},format:a.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const v=n.charCodeAt(0)===l;let g;v?(s.root="/",g=1):g=0;let w=-1,A=0,E=-1,M=!0,P=n.length-1,R=0;for(;P>=g;--P){const T=n.charCodeAt(P);if(T===l){if(!M){A=P+1;break}continue}E===-1&&(M=!1,E=P+1),T===h?w===-1?w=P:R!==1&&(R=1):w!==-1&&(R=-1)}if(E!==-1){const T=A===0&&v?1:A;w===-1||R===0||R===1&&w===E-1&&w===A+1?s.base=s.name=n.slice(T,E):(s.name=n.slice(T,w),s.base=n.slice(T,E),s.ext=n.slice(w,E))}return A>0?s.dir=n.slice(0,A-1):v&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=p?t.$gc.normalize:t.$hc.normalize,t.$jc=p?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=p?t.$gc.join:t.$hc.join,t.$lc=p?t.$gc.resolve:t.$hc.resolve,t.$mc=p?t.$gc.relative:t.$hc.relative,t.$nc=p?t.$gc.dirname:t.$hc.dirname,t.$oc=p?t.$gc.basename:t.$hc.basename,t.$pc=p?t.$gc.extname:t.$hc.extname,t.$qc=p?t.$gc.format:t.$hc.format,t.$rc=p?t.$gc.parse:t.$hc.parse,t.$sc=p?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=p?t.$gc.sep:t.$hc.sep,t.$uc=p?t.$gc.delimiter:t.$hc.delimiter}),ne(re[18],se([0,1,67,17]),function(V,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=a;const y=/^\w[\w\d+.-]*$/,f=/^\//,L=/^\/\//;function h(g,w){if(!g.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!y.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!f.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(g,w){return!g&&!w?"file":g}function u(g,w){switch(g){case"https":case"http":case"file":w?w[0]!==B&&(w=B+w):w=B;break}return w}const c="",B="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(w){return w instanceof m?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,A,E,M,P,R=!1){typeof w=="object"?(this.scheme=w.scheme||c,this.authority=w.authority||c,this.path=w.path||c,this.query=w.query||c,this.fragment=w.fragment||c):(this.scheme=l(w,R),this.authority=A||c,this.path=u(this.scheme,E||c),this.query=M||c,this.fragment=P||c,h(this,R))}get fsPath(){return a(this,!1)}with(w){if(!w)return this;let{scheme:A,authority:E,path:M,query:P,fragment:R}=w;return A===void 0?A=this.scheme:A===null&&(A=c),E===void 0?E=this.authority:E===null&&(E=c),M===void 0?M=this.path:M===null&&(M=c),P===void 0?P=this.query:P===null&&(P=c),R===void 0?R=this.fragment:R===null&&(R=c),A===this.scheme&&E===this.authority&&M===this.path&&P===this.query&&R===this.fragment?this:new j(A,E,M,P,R)}static parse(w,A=!1){const E=b.exec(w);return E?new j(E[2]||c,v(E[4]||c),v(E[5]||c),v(E[7]||c),v(E[9]||c),A):new j(c,c,c,c,c)}static file(w){let A=c;if(F.$i&&(w=w.replace(/\\/g,B)),w[0]===B&&w[1]===B){const E=w.indexOf(B,2);E===-1?(A=w.substring(2),w=B):(A=w.substring(2,E),w=w.substring(E)||B)}return new j("file",A,w,c,c)}static from(w,A){return new j(w.scheme,w.authority,w.path,w.query,w.fragment,A)}static joinPath(w,...A){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return F.$i&&w.scheme==="file"?E=m.file(i.$gc.join(a(w,!0),...A)).path:E=i.$hc.join(w.path,...A),w.with({path:E})}toString(w=!1){return o(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof m)return w;{const A=new j(w);return A._formatted=w.external??null,A._fsPath=w._sep===p?w.fsPath??null:null,A}}else return w}}t.URI=m;function e(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}const p=F.$i?1:void 0;class j extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(w=!1){return w?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=p),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const N={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(g,w,A){let E,M=-1;for(let P=0;P<g.length;P++){const R=g.charCodeAt(P);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||w&&R===47||A&&R===91||A&&R===93||A&&R===58)M!==-1&&(E+=encodeURIComponent(g.substring(M,P)),M=-1),E!==void 0&&(E+=g.charAt(P));else{E===void 0&&(E=g.substr(0,P));const T=N[R];T!==void 0?(M!==-1&&(E+=encodeURIComponent(g.substring(M,P)),M=-1),E+=T):M===-1&&(M=P)}}return M!==-1&&(E+=encodeURIComponent(g.substring(M))),E!==void 0?E:g}function d(g){let w;for(let A=0;A<g.length;A++){const E=g.charCodeAt(A);E===35||E===63?(w===void 0&&(w=g.substr(0,A)),w+=N[E]):w!==void 0&&(w+=g[A])}return w!==void 0?w:g}function a(g,w){let A;return g.authority&&g.path.length>1&&g.scheme==="file"?A=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?w?A=g.path.substr(1):A=g.path[1].toLowerCase()+g.path.substr(2):A=g.path,F.$i&&(A=A.replace(/\//g,"\\")),A}function o(g,w){const A=w?d:$;let E="",{scheme:M,authority:P,path:R,query:T,fragment:k}=g;if(M&&(E+=M,E+=":"),(P||M==="file")&&(E+=B,E+=B),P){let x=P.indexOf("@");if(x!==-1){const O=P.substr(0,x);P=P.substr(x+1),x=O.lastIndexOf(":"),x===-1?E+=A(O,!1,!1):(E+=A(O.substr(0,x),!1,!1),E+=":",E+=A(O.substr(x+1),!1,!0)),E+="@"}P=P.toLowerCase(),x=P.lastIndexOf(":"),x===-1?E+=A(P,!1,!0):(E+=A(P.substr(0,x),!1,!0),E+=P.substr(x))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const x=R.charCodeAt(1);x>=65&&x<=90&&(R=`/${String.fromCharCode(x+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const x=R.charCodeAt(0);x>=65&&x<=90&&(R=`${String.fromCharCode(x+32)}:${R.substr(2)}`)}E+=A(R,!0,!1)}return T&&(E+="?",E+=A(T,!1,!1)),k&&(E+="#",E+=w?k:$(k,!1,!1)),E}function n(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+n(g.substr(3)):g}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(g){return g.match(s)?g.replace(s,w=>n(w)):g}}),ne(re[72],se([0,1,3,11,10,14,17,7]),function(V,t,i,F,y,f,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=s;const l="$initialize";let u=!1;function c(v){L.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(v.message))}var B;(function(v){v[v.Request=0]="Request",v[v.Reply=1]="Reply",v[v.SubscribeEvent=2]="SubscribeEvent",v[v.Event=3]="Event",v[v.UnsubscribeEvent=4]="UnsubscribeEvent"})(B||(B={}));class b{constructor(g,w,A,E){this.vsWorker=g,this.req=w,this.method=A,this.args=E,this.type=0}}class m{constructor(g,w,A,E){this.vsWorker=g,this.seq=w,this.res=A,this.err=E,this.type=1}}class e{constructor(g,w,A,E){this.vsWorker=g,this.req=w,this.eventName=A,this.arg=E,this.type=2}}class p{constructor(g,w,A){this.vsWorker=g,this.req=w,this.event=A,this.type=3}}class j{constructor(g,w){this.vsWorker=g,this.req=w,this.type=4}}class N{constructor(g){this.a=-1,this.g=g,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(g){this.a=g}sendMessage(g,w){const A=String(++this.b);return new Promise((E,M)=>{this.c[A]={resolve:E,reject:M},this.o(new b(this.a,A,g,w))})}listen(g,w){let A=null;const E=new F.$7d({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,E),this.o(new e(this.a,A,g,w))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new j(this.a,A)),A=null}});return E.event}handleMessage(g){!g||!g.vsWorker||this.a!==-1&&g.vsWorker!==this.a||this.h(g)}h(g){switch(g.type){case 1:return this.j(g);case 0:return this.k(g);case 2:return this.l(g);case 3:return this.m(g);case 4:return this.n(g)}}j(g){if(!this.c[g.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[g.seq];if(delete this.c[g.seq],g.err){let A=g.err;g.err.$isError&&(A=new Error,A.name=g.err.name,A.message=g.err.message,A.stack=g.err.stack),w.reject(A);return}w.resolve(g.res)}k(g){const w=g.req;this.g.handleMessage(g.method,g.args).then(E=>{this.o(new m(this.a,w,E,void 0))},E=>{E.detail instanceof Error&&(E.detail=(0,i.$3)(E.detail)),this.o(new m(this.a,w,void 0,(0,i.$3)(E)))})}l(g){const w=g.req,A=this.g.handleEvent(g.eventName,g.arg)(E=>{this.o(new p(this.a,w,E))});this.f.set(w,A)}m(g){if(!this.d.has(g.req)){console.warn("Got event for unknown req");return}this.d.get(g.req).fire(g.event)}n(g){if(!this.f.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(g.req).dispose(),this.f.delete(g.req)}o(g){const w=[];if(g.type===0)for(let A=0;A<g.args.length;A++)g.args[A]instanceof ArrayBuffer&&w.push(g.args[A]);else g.type===1&&g.res instanceof ArrayBuffer&&w.push(g.res);this.g.sendMessage(g,w)}}class $ extends y.$Uc{constructor(g,w,A){super();let E=null;this.a=this.B(g.create("vs/base/common/worker/simpleWorker",x=>{this.c.handleMessage(x)},x=>{E?.(x)})),this.c=new N({sendMessage:(x,O)=>{this.a.postMessage(x,O)},handleMessage:(x,O)=>{if(typeof A[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(A[x].apply(A,O))}catch(X){return Promise.reject(X)}},handleEvent:(x,O)=>{if(a(x)){const X=A[x].call(A,O);if(typeof X!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return X}if(d(x)){const X=A[x];if(typeof X!="function")throw new Error(`Missing event ${x} on main thread host.`);return X}throw new Error(`Malformed event name ${x}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const P=globalThis.require;typeof P<"u"&&typeof P.getConfig=="function"?M=P.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const R=(0,f.$Xn)(A);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(M)),w,R]);const T=(x,O)=>this.g(x,O),k=(x,O)=>this.c.listen(x,O);this.f=new Promise((x,O)=>{E=O,this.b.then(X=>{x(o(X,T,k))},X=>{O(X),this.h("Worker failed to load "+w,X)})})}getProxyObject(){return this.f}g(g,w){return new Promise((A,E)=>{this.b.then(()=>{this.c.sendMessage(g,w).then(A,E)},E)})}h(g,w){console.error(g),console.info(w)}}t.SimpleWorkerClient=$;function d(v){return v[0]==="o"&&v[1]==="n"&&h.$kf(v.charCodeAt(2))}function a(v){return/^onDynamic/.test(v)&&h.$kf(v.charCodeAt(9))}function o(v,g,w){const A=P=>function(){const R=Array.prototype.slice.call(arguments,0);return g(P,R)},E=P=>function(R){return w(P,R)},M={};for(const P of v){if(a(P)){M[P]=E(P);continue}if(d(P)){M[P]=w(P,void 0);continue}M[P]=A(P)}return M}class n{constructor(g,w){this.a=w,this.b=null,this.c=new N({sendMessage:(A,E)=>{g(A,E)},handleMessage:(A,E)=>this.d(A,E),handleEvent:(A,E)=>this.f(A,E)})}onmessage(g){this.c.handleMessage(g)}d(g,w){if(g===l)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this.b[g].apply(this.b,w))}catch(A){return Promise.reject(A)}}f(g,w){if(!this.b)throw new Error("Missing requestHandler");if(a(g)){const A=this.b[g].call(this.b,w);if(typeof A!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return A}if(d(g)){const A=this.b[g];if(typeof A!="function")throw new Error(`Missing event ${g} on request handler.`);return A}throw new Error(`Malformed event name ${g}`)}g(g,w,A,E){this.c.setWorkerId(g);const R=o(E,(T,k)=>this.c.sendMessage(T,k),(T,k)=>this.c.listen(T,k));return this.a?(this.b=this.a(R),Promise.resolve((0,f.$Xn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((T,k)=>{(globalThis.require||V)([A],O=>{if(this.b=O.create(R),!this.b){k(new Error("No RequestHandler!"));return}T((0,f.$Xn)(this.b))},k)}))}}t.SimpleWorkerServer=n;function s(v){return new n(v,null)}}),ne(re[68],se([64,65]),function(V,t){return V.create("vs/editor/common/languages",t)}),ne(re[69],se([0,1,43,18,44,2,62,68]),function(V,t,i,F,y,f,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$7t=t.$6t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$5t=t.$4t=t.SymbolKinds=t.SymbolTag=t.$2t=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$Zt=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Yt=t.$Xt=t.$Wt=void 0,t.$1t=s,t.$3t=g;class l{constructor(z,ee,K){this.offset=z,this.type=ee,this.language=K,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Wt=l;class u{constructor(z,ee){this.tokens=z,this.endState=ee,this._tokenizationResultBrand=void 0}}t.$Xt=u;class c{constructor(z,ee){this.tokens=z,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}t.$Yt=c;var B;(function(D){D[D.Method=0]="Method",D[D.Function=1]="Function",D[D.Constructor=2]="Constructor",D[D.Field=3]="Field",D[D.Variable=4]="Variable",D[D.Class=5]="Class",D[D.Struct=6]="Struct",D[D.Interface=7]="Interface",D[D.Module=8]="Module",D[D.Property=9]="Property",D[D.Event=10]="Event",D[D.Operator=11]="Operator",D[D.Unit=12]="Unit",D[D.Value=13]="Value",D[D.Constant=14]="Constant",D[D.Enum=15]="Enum",D[D.EnumMember=16]="EnumMember",D[D.Keyword=17]="Keyword",D[D.Text=18]="Text",D[D.Color=19]="Color",D[D.File=20]="File",D[D.Reference=21]="Reference",D[D.Customcolor=22]="Customcolor",D[D.Folder=23]="Folder",D[D.TypeParameter=24]="TypeParameter",D[D.User=25]="User",D[D.Issue=26]="Issue",D[D.Snippet=27]="Snippet"})(B||(t.CompletionItemKind=B={}));var b;(function(D){const z=new Map;z.set(0,i.$Gj.symbolMethod),z.set(1,i.$Gj.symbolFunction),z.set(2,i.$Gj.symbolConstructor),z.set(3,i.$Gj.symbolField),z.set(4,i.$Gj.symbolVariable),z.set(5,i.$Gj.symbolClass),z.set(6,i.$Gj.symbolStruct),z.set(7,i.$Gj.symbolInterface),z.set(8,i.$Gj.symbolModule),z.set(9,i.$Gj.symbolProperty),z.set(10,i.$Gj.symbolEvent),z.set(11,i.$Gj.symbolOperator),z.set(12,i.$Gj.symbolUnit),z.set(13,i.$Gj.symbolValue),z.set(15,i.$Gj.symbolEnum),z.set(14,i.$Gj.symbolConstant),z.set(15,i.$Gj.symbolEnum),z.set(16,i.$Gj.symbolEnumMember),z.set(17,i.$Gj.symbolKeyword),z.set(27,i.$Gj.symbolSnippet),z.set(18,i.$Gj.symbolText),z.set(19,i.$Gj.symbolColor),z.set(20,i.$Gj.symbolFile),z.set(21,i.$Gj.symbolReference),z.set(22,i.$Gj.symbolCustomColor),z.set(23,i.$Gj.symbolFolder),z.set(24,i.$Gj.symbolTypeParameter),z.set(25,i.$Gj.account),z.set(26,i.$Gj.issues);function ee(r){let de=z.get(r);return de||(console.info("No codicon found for CompletionItemKind "+r),de=i.$Gj.symbolProperty),de}D.toIcon=ee;const K=new Map;K.set("method",0),K.set("function",1),K.set("constructor",2),K.set("field",3),K.set("variable",4),K.set("class",5),K.set("struct",6),K.set("interface",7),K.set("module",8),K.set("property",9),K.set("event",10),K.set("operator",11),K.set("unit",12),K.set("value",13),K.set("constant",14),K.set("enum",15),K.set("enum-member",16),K.set("enumMember",16),K.set("keyword",17),K.set("snippet",27),K.set("text",18),K.set("color",19),K.set("file",20),K.set("reference",21),K.set("customcolor",22),K.set("folder",23),K.set("type-parameter",24),K.set("typeParameter",24),K.set("account",25),K.set("issue",26);function fe(r,de){let we=K.get(r);return typeof we>"u"&&!de&&(we=9),we}D.fromString=fe})(b||(t.CompletionItemKinds=b={}));var m;(function(D){D[D.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(D){D[D.None=0]="None",D[D.KeepWhitespace=1]="KeepWhitespace",D[D.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var p;(function(D){D[D.Word=0]="Word",D[D.Line=1]="Line",D[D.Suggest=2]="Suggest"})(p||(t.PartialAcceptTriggerKind=p={}));var j;(function(D){D[D.Invoke=0]="Invoke",D[D.TriggerCharacter=1]="TriggerCharacter",D[D.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(j||(t.CompletionTriggerKind=j={}));var N;(function(D){D[D.Automatic=0]="Automatic",D[D.Explicit=1]="Explicit"})(N||(t.InlineCompletionTriggerKind=N={}));class ${constructor(z,ee,K,fe){this.range=z,this.text=ee,this.completionKind=K,this.isSnippetText=fe}equals(z){return f.$at.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}t.$Zt=$;var d;(function(D){D[D.Invoke=1]="Invoke",D[D.Auto=2]="Auto"})(d||(t.CodeActionTriggerType=d={}));var a;(function(D){D[D.Automatic=0]="Automatic",D[D.PasteAs=1]="PasteAs"})(a||(t.DocumentPasteTriggerKind=a={}));var o;(function(D){D[D.Invoke=1]="Invoke",D[D.TriggerCharacter=2]="TriggerCharacter",D[D.ContentChange=3]="ContentChange"})(o||(t.SignatureHelpTriggerKind=o={}));var n;(function(D){D[D.Text=0]="Text",D[D.Read=1]="Read",D[D.Write=2]="Write"})(n||(t.DocumentHighlightKind=n={}));function s(D){return D&&F.URI.isUri(D.uri)&&f.$at.isIRange(D.range)&&(f.$at.isIRange(D.originSelectionRange)||f.$at.isIRange(D.targetSelectionRange))}var v;(function(D){D[D.File=0]="File",D[D.Module=1]="Module",D[D.Namespace=2]="Namespace",D[D.Package=3]="Package",D[D.Class=4]="Class",D[D.Method=5]="Method",D[D.Property=6]="Property",D[D.Field=7]="Field",D[D.Constructor=8]="Constructor",D[D.Enum=9]="Enum",D[D.Interface=10]="Interface",D[D.Function=11]="Function",D[D.Variable=12]="Variable",D[D.Constant=13]="Constant",D[D.String=14]="String",D[D.Number=15]="Number",D[D.Boolean=16]="Boolean",D[D.Array=17]="Array",D[D.Object=18]="Object",D[D.Key=19]="Key",D[D.Null=20]="Null",D[D.EnumMember=21]="EnumMember",D[D.Struct=22]="Struct",D[D.Event=23]="Event",D[D.Operator=24]="Operator",D[D.TypeParameter=25]="TypeParameter"})(v||(t.SymbolKind=v={})),t.$2t={17:(0,h.localize)(0,null),16:(0,h.localize)(1,null),4:(0,h.localize)(2,null),13:(0,h.localize)(3,null),8:(0,h.localize)(4,null),9:(0,h.localize)(5,null),21:(0,h.localize)(6,null),23:(0,h.localize)(7,null),7:(0,h.localize)(8,null),0:(0,h.localize)(9,null),11:(0,h.localize)(10,null),10:(0,h.localize)(11,null),19:(0,h.localize)(12,null),5:(0,h.localize)(13,null),1:(0,h.localize)(14,null),2:(0,h.localize)(15,null),20:(0,h.localize)(16,null),15:(0,h.localize)(17,null),18:(0,h.localize)(18,null),24:(0,h.localize)(19,null),3:(0,h.localize)(20,null),6:(0,h.localize)(21,null),14:(0,h.localize)(22,null),22:(0,h.localize)(23,null),25:(0,h.localize)(24,null),12:(0,h.localize)(25,null)};function g(D,z){return(0,h.localize)(26,null,D,t.$2t[z])}var w;(function(D){D[D.Deprecated=1]="Deprecated"})(w||(t.SymbolTag=w={}));var A;(function(D){const z=new Map;z.set(0,i.$Gj.symbolFile),z.set(1,i.$Gj.symbolModule),z.set(2,i.$Gj.symbolNamespace),z.set(3,i.$Gj.symbolPackage),z.set(4,i.$Gj.symbolClass),z.set(5,i.$Gj.symbolMethod),z.set(6,i.$Gj.symbolProperty),z.set(7,i.$Gj.symbolField),z.set(8,i.$Gj.symbolConstructor),z.set(9,i.$Gj.symbolEnum),z.set(10,i.$Gj.symbolInterface),z.set(11,i.$Gj.symbolFunction),z.set(12,i.$Gj.symbolVariable),z.set(13,i.$Gj.symbolConstant),z.set(14,i.$Gj.symbolString),z.set(15,i.$Gj.symbolNumber),z.set(16,i.$Gj.symbolBoolean),z.set(17,i.$Gj.symbolArray),z.set(18,i.$Gj.symbolObject),z.set(19,i.$Gj.symbolKey),z.set(20,i.$Gj.symbolNull),z.set(21,i.$Gj.symbolEnumMember),z.set(22,i.$Gj.symbolStruct),z.set(23,i.$Gj.symbolEvent),z.set(24,i.$Gj.symbolOperator),z.set(25,i.$Gj.symbolTypeParameter);function ee(K){let fe=z.get(K);return fe||(console.info("No codicon found for SymbolKind "+K),fe=i.$Gj.symbolProperty),fe}D.toIcon=ee})(A||(t.SymbolKinds=A={}));class E{static asEditOperation(z){return y.$bt.replace(f.$at.lift(z.range),z.text)}}t.$4t=E;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(z){switch(z){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(z)}constructor(z){this.value=z}}t.$5t=M;var P;(function(D){D[D.AIGenerated=1]="AIGenerated"})(P||(t.NewSymbolNameTag=P={}));var R;(function(D){function z(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}D.is=z})(R||(t.Command=R={}));var T;(function(D){D[D.Collapsed=0]="Collapsed",D[D.Expanded=1]="Expanded"})(T||(t.CommentThreadCollapsibleState=T={}));var k;(function(D){D[D.Unresolved=0]="Unresolved",D[D.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var x;(function(D){D[D.Editing=0]="Editing",D[D.Preview=1]="Preview"})(x||(t.CommentMode=x={}));var O;(function(D){D[D.Published=0]="Published",D[D.Draft=1]="Draft"})(O||(t.CommentState=O={}));var X;(function(D){D[D.Type=1]="Type",D[D.Parameter=2]="Parameter"})(X||(t.InlayHintKind=X={}));class te{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$6t=te,t.$7t=new L.$Lt;var _;(function(D){D[D.None=0]="None",D[D.Option=1]="Option",D[D.Default=2]="Default",D[D.Preferred=3]="Preferred"})(_||(t.ExternalUriOpenerPriority=_={}));var Y;(function(D){D[D.Invoke=0]="Invoke",D[D.Automatic=1]="Automatic"})(Y||(t.InlineEditTriggerKind=Y={}))}),ne(re[70],se([0,1,24,11,38,18,5,2,45,69,61]),function(V,t,i,F,y,f,L,h,l,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n2=void 0,t.$o2=b;class B{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,p){return(0,y.$mr)(e,p)}}t.$n2=B;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$ee,Emitter:F.$7d,KeyCode:c.KeyCode,KeyMod:B,Position:L.$_s,Range:h.$at,Selection:l.$ct,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:f.URI,Token:u.$Wt}}}),ne(re[73],se([0,1,25,18,5,2,58,30,54,55,70,23,60,34,52,14,3,53]),function(V,t,i,F,y,f,L,h,l,u,c,B,b,m,e,p,j,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=a;class $ extends L.$Fv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const s=[];for(let v=0;v<this.f.length;v++){const g=this.f[v],w=this.offsetAt(new y.$_s(v+1,1)),A=g.matchAll(n);for(const E of A)(E.index||E.index===0)&&(E.index=E.index+w),s.push(E)}return s}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,s){const v=(0,h.$Ps)(n.column,(0,h.$Ns)(s),this.f[n.lineNumber-1],0);return v?new f.$at(n.lineNumber,v.startColumn,n.lineNumber,v.endColumn):null}getWordUntilPosition(n,s){const v=this.getWordAtPosition(n,s);return v?{word:this.f[n.lineNumber-1].substring(v.startColumn-1,n.column-1),startColumn:v.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const s=this.f,v=this.q.bind(this);let g=0,w="",A=0,E=[];return{*[Symbol.iterator](){for(;;)if(A<E.length){const M=w.substring(E[A].start,E[A].end);A+=1,yield M}else if(g<s.length)w=s[g],E=v(w,n),A=0,g+=1;else break}}}getLineWords(n,s){const v=this.f[n-1],g=this.q(v,s),w=[];for(const A of g)w.push({word:v.substring(A.start,A.end),startColumn:A.start+1,endColumn:A.end+1});return w}q(n,s){const v=[];let g;for(s.lastIndex=0;(g=s.exec(n))&&g[0].length!==0;)v.push({start:g.index,end:g.index+g[0].length});return v}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const s=this.g,v=n.startLineNumber-1,g=n.endLineNumber-1,w=[];w.push(this.f[v].substring(n.startColumn-1));for(let A=v+1;A<g;A++)w.push(this.f[A]);return w.push(this.f[g].substring(0,n.endColumn-1)),w.join(s)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),v=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,v)}}r(n){const s=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),v=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return s.lineNumber!==n.startLineNumber||s.column!==n.startColumn||v.lineNumber!==n.endLineNumber||v.column!==n.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:v.lineNumber,endColumn:v.column}:n}s(n){if(!y.$_s.isIPosition(n))throw new Error("bad position");let{lineNumber:s,column:v}=n,g=!1;if(s<1)s=1,v=1,g=!0;else if(s>this.f.length)s=this.f.length,v=this.f[s-1].length+1,g=!0;else{const w=this.f[s-1].length+1;v<1?(v=1,g=!0):v>w&&(v=w,g=!0)}return g?{lineNumber:s,column:v}:n}}class d{constructor(n,s){this.d=n,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(s=>n.push(this.f[s])),n}acceptNewModel(n){this.f[n.url]=new $(F.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,s){if(!this.f[n])return;this.f[n].onEvents(s)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,s,v){const g=this.j(n);return g?b.$i2.computeUnicodeHighlights(g,s,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,s,v,g){const w=this.j(n),A=this.j(s);return!w||!A?null:d.l(w,A,v,g)}static l(n,s,v,g){const w=g==="advanced"?e.$K2.getDefault():e.$K2.getLegacy(),A=n.getLinesContent(),E=s.getLinesContent(),M=w.computeDiff(A,E,v),P=M.changes.length>0?!1:this.n(n,s);function R(T){return T.map(k=>[k.original.startLineNumber,k.original.endLineNumberExclusive,k.modified.startLineNumber,k.modified.endLineNumberExclusive,k.innerChanges?.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])])}return{identical:P,quitEarly:M.hitTimeout,changes:R(M.changes),moves:M.moves.map(T=>[T.lineRangeMapping.original.startLineNumber,T.lineRangeMapping.original.endLineNumberExclusive,T.lineRangeMapping.modified.startLineNumber,T.lineRangeMapping.modified.endLineNumberExclusive,R(T.changes)])}}static n(n,s){const v=n.getLineCount(),g=s.getLineCount();if(v!==g)return!1;for(let w=1;w<=v;w++){const A=n.getLineContent(w),E=s.getLineContent(w);if(A!==E)return!1}return!0}async computeDirtyDiff(n,s,v){const g=this.j(n),w=this.j(s);if(!g||!w)return null;const A=g.getLinesContent(),E=w.getLinesContent();return new m.$rt(A,E,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:v,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(n,s,v){const g=this.j(n);if(!g)return s;const w=[];let A;s=s.slice(0).sort((M,P)=>{if(M.range&&P.range)return f.$at.compareRangesUsingStarts(M.range,P.range);const R=M.range?0:1,T=P.range?0:1;return R-T});let E=0;for(let M=1;M<s.length;M++)f.$at.getEndPosition(s[E].range).equals(f.$at.getStartPosition(s[M].range))?(s[E].range=f.$at.fromPositions(f.$at.getStartPosition(s[E].range),f.$at.getEndPosition(s[M].range)),s[E].text+=s[M].text):(E++,s[E]=s[M]);s.length=E+1;for(let{range:M,text:P,eol:R}of s){if(typeof R=="number"&&(A=R),f.$at.isEmpty(M)&&!P)continue;const T=g.getValueInRange(M);if(P=P.replace(/\r\n|\n|\r/g,g.eol),T===P)continue;if(Math.max(P.length,T.length)>d.o){w.push({range:M,text:P});continue}const k=(0,i.$ft)(T,P,v),x=g.offsetAt(f.$at.lift(M).getStartPosition());for(const O of k){const X=g.positionAt(x+O.originalStart),te=g.positionAt(x+O.originalStart+O.originalLength),_={text:P.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:X.lineNumber,startColumn:X.column,endLineNumber:te.lineNumber,endColumn:te.column}};g.getValueInRange(_.range)!==_.text&&w.push(_)}}return typeof A=="number"&&w.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(n,s,v){const g=this.j(n);if(!g)return s;const w=[];let A;s=s.slice(0).sort((E,M)=>{if(E.range&&M.range)return f.$at.compareRangesUsingStarts(E.range,M.range);const P=E.range?0:1,R=M.range?0:1;return P-R});for(let{range:E,text:M,eol:P}of s){let X=function(_,Y){return new y.$_s(_.lineNumber+Y.lineNumber-1,Y.lineNumber===1?_.column+Y.column-1:Y.column)},te=function(_,Y){const D=[];for(let z=Y.startLineNumber;z<=Y.endLineNumber;z++){const ee=_[z-1];z===Y.startLineNumber&&z===Y.endLineNumber?D.push(ee.substring(Y.startColumn-1,Y.endColumn-1)):z===Y.startLineNumber?D.push(ee.substring(Y.startColumn-1)):z===Y.endLineNumber?D.push(ee.substring(0,Y.endColumn-1)):D.push(ee)}return D};if(typeof P=="number"&&(A=P),f.$at.isEmpty(E)&&!M)continue;const R=g.getValueInRange(E);if(M=M.replace(/\r\n|\n|\r/g,g.eol),R===M)continue;if(Math.max(M.length,R.length)>d.o){w.push({range:E,text:M});continue}const T=R.split(/\r\n|\n|\r/),k=M.split(/\r\n|\n|\r/),x=e.$K2.getDefault().computeDiff(T,k,v),O=f.$at.lift(E).getStartPosition();for(const _ of x.changes)if(_.innerChanges)for(const Y of _.innerChanges)w.push({range:f.$at.fromPositions(X(O,Y.originalRange.getStartPosition()),X(O,Y.originalRange.getEndPosition())),text:te(k,Y.modifiedRange).join(g.eol)});else throw new j.$cb("The experimental diff algorithm always produces inner changes")}return typeof A=="number"&&w.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(n){const s=this.j(n);return s?(0,l.$l2)(s):null}async computeDefaultDocumentColors(n){const s=this.j(n);return s?(0,N.$L2)(s):null}static{this.p=1e4}async textualSuggest(n,s,v,g){const w=new B.$3d,A=new RegExp(v,g),E=new Set;e:for(const M of n){const P=this.j(M);if(P){for(const R of P.words(A))if(!(R===s||!isNaN(Number(R)))&&(E.add(R),E.size>d.p))break e}}return{words:Array.from(E),duration:w.elapsed()}}async computeWordRanges(n,s,v,g){const w=this.j(n);if(!w)return Object.create(null);const A=new RegExp(v,g),E=Object.create(null);for(let M=s.startLineNumber;M<s.endLineNumber;M++){const P=w.getLineWords(M,A);for(const R of P){if(!isNaN(Number(R.word)))continue;let T=E[R.word];T||(T=[],E[R.word]=T),T.push({startLineNumber:M,startColumn:R.startColumn,endLineNumber:M,endColumn:R.endColumn})}}return E}async navigateValueSet(n,s,v,g,w){const A=this.j(n);if(!A)return null;const E=new RegExp(g,w);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const M=A.getValueInRange(s),P=A.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},E);if(!P)return null;const R=A.getValueInRange(P);return u.$m2.INSTANCE.navigateValueSet(s,M,P,R,v)}loadForeignModule(n,s,v){const g=(E,M)=>this.d.fhr(E,M),A={host:(0,p.$Yn)(v,g),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(A,s),Promise.resolve((0,p.$Xn)(this.h))):new Promise((E,M)=>{V([n],P=>{this.h=P.create(A,s),E((0,p.$Xn)(this.h))},M)})}fmr(n,s){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,s))}catch(v){return Promise.reject(v)}}}t.EditorSimpleWorker=d;function a(o){return new d(o,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$o2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c3cc8b9948d52f04836997a7de01dbd9bb2a7bf/core/vs/base/worker/workerMain.js.map
