/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/hover/updatableHoverWidget","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(se){for(var t=[],i=0,N=se.length;i<N;i++)t[i]=me[se[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ot,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Ct}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,i,N){return t.apply(i,N)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Ct||(Ct=function(t,i){return new t(...i)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),yt=ct(String.prototype.toLowerCase),Rt=ct(String.prototype.toString),li=ct(String.prototype.match),dt=ct(String.prototype.replace),ai=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(se){return function(t){for(var i=arguments.length,N=new Array(i>1?i-1:0),z=1;z<i;z++)N[z-1]=arguments[z];return Nt(se,t,N)}}function ui(se){return function(){for(var t=arguments.length,i=new Array(t),N=0;N<t;N++)i[N]=arguments[N];return Ct(se,i)}}function He(se,t,i){var N;i=(N=i)!==null&&N!==void 0?N:yt,xt&&xt(se,null);let z=t.length;for(;z--;){let H=t[z];if(typeof H=="string"){const E=i(H);E!==H&&(ii(t)||(t[z]=E),H=E)}se[H]=!0}return se}function bt(se){const t=ri(null);for(const[i,N]of Ot(se))t[i]=N;return t}function Et(se,t){for(;se!==null;){const N=si(se,t);if(N){if(N.get)return ct(N.get);if(typeof N.value=="function")return ct(N.value)}se=ni(se)}function i(N){return console.warn("fallback value for",N),null}return i}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),jt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,Di=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let N=null;const z="data-tt-policy-suffix";i&&i.hasAttribute(z)&&(N=i.getAttribute(z));const H="dompurify"+(N?"#"+N:"");try{return t.createPolicy(H,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Xt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Oe=>Xt(Oe);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const i=se.document,N=i.currentScript;let{document:z}=se;const{DocumentFragment:H,HTMLTemplateElement:E,Node:A,Element:b,NodeFilter:$,NamedNodeMap:w=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:P,DOMParser:f,trustedTypes:d}=se,e=b.prototype,s=Et(e,"cloneNode"),u=Et(e,"nextSibling"),m=Et(e,"childNodes"),p=Et(e,"parentNode");if(typeof E=="function"){const Oe=z.createElement("template");Oe.content&&Oe.content.ownerDocument&&(z=Oe.content.ownerDocument)}let v,l="";const{implementation:g,createNodeIterator:r,createDocumentFragment:S,getElementsByTagName:C}=z,{importNode:I}=i;let M={};t.isSupported=typeof Ot=="function"&&typeof p=="function"&&g&&g.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:O,ERB_EXPR:y,TMPLIT_EXPR:x,DATA_ATTR:W,ARIA_ATTR:T,IS_SCRIPT_OR_DATA:R,ATTR_WHITESPACE:L}=Gt;let{IS_ALLOWED_URI:X}=Gt,J=null;const de=He({},[...Ht,...Lt,...It,...Mt,...Wt]);let ae=null;const ie=He({},[...Vt,...jt,...qt,...At]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Fe=null,Ne=null,Pe=!0,oe=!0,U=!1,le=!0,re=!1,Y=!1,Q=!1,te=!1,ue=!1,ye=!1,Te=!1,Ee=!0,fe=!1;const c="user-content-";let k=!0,D=!1,o={},a=null;const n=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let h=null;const F=He({},["audio","video","img","source","image","track"]);let B=null;const j=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),V="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",_="http://www.w3.org/1999/xhtml";let $e=_,ve=!1,we=null;const Me=He({},[V,Z,_],Rt);let Se;const Ae=["application/xhtml+xml","text/html"],Ce="text/html";let Re,Xe=null;const nt=z.createElement("form"),Ge=function(he){return he instanceof RegExp||he instanceof Function},Ue=function(he){if(!(Xe&&Xe===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),Se=Ae.indexOf(he.PARSER_MEDIA_TYPE)===-1?Se=Ce:Se=he.PARSER_MEDIA_TYPE,Re=Se==="application/xhtml+xml"?Rt:yt,J="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Re):de,ae="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Re):ie,we="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Rt):Me,B="ADD_URI_SAFE_ATTR"in he?He(bt(j),he.ADD_URI_SAFE_ATTR,Re):j,h="ADD_DATA_URI_TAGS"in he?He(bt(F),he.ADD_DATA_URI_TAGS,Re):F,a="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Re):n,Fe="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Re):{},Ne="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Re):{},o="USE_PROFILES"in he?he.USE_PROFILES:!1,Pe=he.ALLOW_ARIA_ATTR!==!1,oe=he.ALLOW_DATA_ATTR!==!1,U=he.ALLOW_UNKNOWN_PROTOCOLS||!1,le=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,Y=he.WHOLE_DOCUMENT||!1,ue=he.RETURN_DOM||!1,ye=he.RETURN_DOM_FRAGMENT||!1,Te=he.RETURN_TRUSTED_TYPE||!1,te=he.FORCE_BODY||!1,Ee=he.SANITIZE_DOM!==!1,fe=he.SANITIZE_NAMED_PROPS||!1,k=he.KEEP_CONTENT!==!1,D=he.IN_PLACE||!1,X=he.ALLOWED_URI_REGEXP||Kt,$e=he.NAMESPACE||_,ge=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ge(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ge(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(oe=!1),ye&&(ue=!0),o&&(J=He({},[...Wt]),ae=[],o.html===!0&&(He(J,Ht),He(ae,Vt)),o.svg===!0&&(He(J,Lt),He(ae,jt),He(ae,At)),o.svgFilters===!0&&(He(J,It),He(ae,jt),He(ae,At)),o.mathMl===!0&&(He(J,Mt),He(ae,qt),He(ae,At))),he.ADD_TAGS&&(J===de&&(J=bt(J)),He(J,he.ADD_TAGS,Re)),he.ADD_ATTR&&(ae===ie&&(ae=bt(ae)),He(ae,he.ADD_ATTR,Re)),he.ADD_URI_SAFE_ATTR&&He(B,he.ADD_URI_SAFE_ATTR,Re),he.FORBID_CONTENTS&&(a===n&&(a=bt(a)),He(a,he.FORBID_CONTENTS,Re)),k&&(J["#text"]=!0),Y&&He(J,["html","head","body"]),J.table&&(He(J,["tbody"]),delete Fe.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=he.TRUSTED_TYPES_POLICY,l=v.createHTML("")}else v===void 0&&(v=Di(d,N)),v!==null&&typeof l=="string"&&(l=v.createHTML(""));ot&&ot(he),Xe=he}},G=He({},["mi","mo","mn","ms","mtext"]),ne=He({},["foreignobject","desc","title","annotation-xml"]),pe=He({},["title","style","font","a","script"]),De=He({},Lt);He(De,It),He(De,ci);const Le=He({},Mt);He(Le,fi);const ze=function(he){let Be=p(he);(!Be||!Be.tagName)&&(Be={namespaceURI:$e,tagName:"template"});const Ie=yt(he.tagName),Ke=yt(Be.tagName);return we[he.namespaceURI]?he.namespaceURI===Z?Be.namespaceURI===_?Ie==="svg":Be.namespaceURI===V?Ie==="svg"&&(Ke==="annotation-xml"||G[Ke]):!!De[Ie]:he.namespaceURI===V?Be.namespaceURI===_?Ie==="math":Be.namespaceURI===Z?Ie==="math"&&ne[Ke]:!!Le[Ie]:he.namespaceURI===_?Be.namespaceURI===Z&&!ne[Ke]||Be.namespaceURI===V&&!G[Ke]?!1:!Le[Ie]&&(pe[Ie]||!De[Ie]):!!(Se==="application/xhtml+xml"&&we[he.namespaceURI]):!1},Ve=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},_e=function(he,Be){try{wt(t.removed,{attribute:Be.getAttributeNode(he),from:Be})}catch{wt(t.removed,{attribute:null,from:Be})}if(Be.removeAttribute(he),he==="is"&&!ae[he])if(ue||ye)try{Ve(Be)}catch{}else try{Be.setAttribute(he,"")}catch{}},tt=function(he){let Be,Ie;if(te)he="<remove></remove>"+he;else{const at=li(he,/^[\r\n\t ]+/);Ie=at&&at[0]}Se==="application/xhtml+xml"&&$e===_&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ke=v?v.createHTML(he):he;if($e===_)try{Be=new f().parseFromString(Ke,Se)}catch{}if(!Be||!Be.documentElement){Be=g.createDocument($e,"template",null);try{Be.documentElement.innerHTML=ve?l:Ke}catch{}}const it=Be.body||Be.documentElement;return he&&Ie&&it.insertBefore(z.createTextNode(Ie),it.childNodes[0]||null),$e===_?C.call(Be,Y?"html":"body")[0]:Y?Be.documentElement:it},st=function(he){return r.call(he.ownerDocument||he,he,$.SHOW_ELEMENT|$.SHOW_COMMENT|$.SHOW_TEXT,null,!1)},Je=function(he){return he instanceof P&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof w)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof A=="object"?he instanceof A:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},et=function(he,Be,Ie){M[he]&&oi(M[he],Ke=>{Ke.call(t,Be,Ie,Xe)})},mt=function(he){let Be;if(et("beforeSanitizeElements",he,null),Je(he))return Ve(he),!0;const Ie=Re(he.nodeName);if(et("uponSanitizeElement",he,{tagName:Ie,allowedTags:J}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ve(he),!0;if(!J[Ie]||Fe[Ie]){if(!Fe[Ie]&&kt(Ie)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Ie)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Ie)))return!1;if(k&&!a[Ie]){const Ke=p(he)||he.parentNode,it=m(he)||he.childNodes;if(it&&Ke){const at=it.length;for(let Ye=at-1;Ye>=0;--Ye)Ke.insertBefore(s(it[Ye],!0),u(he))}}return Ve(he),!0}return he instanceof b&&!ze(he)||(Ie==="noscript"||Ie==="noembed"||Ie==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ve(he),!0):(re&&he.nodeType===3&&(Be=he.textContent,Be=dt(Be,O," "),Be=dt(Be,y," "),Be=dt(Be,x," "),he.textContent!==Be&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Be)),et("afterSanitizeElements",he,null),!1)},gt=function(he,Be,Ie){if(Ee&&(Be==="id"||Be==="name")&&(Ie in z||Ie in nt))return!1;if(!(oe&&!Ne[Be]&&ht(W,Be))){if(!(Pe&&ht(T,Be))){if(!ae[Be]||Ne[Be]){if(!(kt(he)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,he)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(he))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Be)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Be))||Be==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Ie)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Ie))))return!1}else if(!B[Be]){if(!ht(X,dt(Ie,L,""))){if(!((Be==="src"||Be==="xlink:href"||Be==="href")&&he!=="script"&&ai(Ie,"data:")===0&&h[he])){if(!(U&&!ht(R,dt(Ie,L,"")))){if(Ie)return!1}}}}}}return!0},kt=function(he){return he.indexOf("-")>0},St=function(he){let Be,Ie,Ke,it;et("beforeSanitizeAttributes",he,null);const{attributes:at}=he;if(!at)return;const Ye={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ae};for(it=at.length;it--;){Be=at[it];const{name:ut,namespaceURI:$t}=Be;if(Ie=ut==="value"?Be.value:hi(Be.value),Ke=Re(ut),Ye.attrName=Ke,Ye.attrValue=Ie,Ye.keepAttr=!0,Ye.forceKeepAttr=void 0,et("uponSanitizeAttribute",he,Ye),Ie=Ye.attrValue,Ye.forceKeepAttr||(_e(ut,he),!Ye.keepAttr))continue;if(!le&&ht(/\/>/i,Ie)){_e(ut,he);continue}re&&(Ie=dt(Ie,O," "),Ie=dt(Ie,y," "),Ie=dt(Ie,x," "));const Tt=Re(he.nodeName);if(gt(Tt,Ke,Ie)){if(fe&&(Ke==="id"||Ke==="name")&&(_e(ut,he),Ie=c+Ie),v&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!$t)switch(d.getAttributeType(Tt,Ke)){case"TrustedHTML":{Ie=v.createHTML(Ie);break}case"TrustedScriptURL":{Ie=v.createScriptURL(Ie);break}}try{$t?he.setAttributeNS($t,ut,Ie):he.setAttribute(ut,Ie),zt(t.removed)}catch{}}}et("afterSanitizeAttributes",he,null)},Bt=function Oe(he){let Be;const Ie=st(he);for(et("beforeSanitizeShadowDOM",he,null);Be=Ie.nextNode();)et("uponSanitizeShadowNode",Be,null),!mt(Be)&&(Be.content instanceof H&&Oe(Be.content),St(Be));et("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Oe){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Be,Ie,Ke,it;if(ve=!Oe,ve&&(Oe="<!-->"),typeof Oe!="string"&&!rt(Oe))if(typeof Oe.toString=="function"){if(Oe=Oe.toString(),typeof Oe!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Oe;if(Q||Ue(he),t.removed=[],typeof Oe=="string"&&(D=!1),D){if(Oe.nodeName){const ut=Re(Oe.nodeName);if(!J[ut]||Fe[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Oe instanceof A)Be=tt("<!---->"),Ie=Be.ownerDocument.importNode(Oe,!0),Ie.nodeType===1&&Ie.nodeName==="BODY"||Ie.nodeName==="HTML"?Be=Ie:Be.appendChild(Ie);else{if(!ue&&!re&&!Y&&Oe.indexOf("<")===-1)return v&&Te?v.createHTML(Oe):Oe;if(Be=tt(Oe),!Be)return ue?null:Te?l:""}Be&&te&&Ve(Be.firstChild);const at=st(D?Oe:Be);for(;Ke=at.nextNode();)mt(Ke)||(Ke.content instanceof H&&Bt(Ke.content),St(Ke));if(D)return Oe;if(ue){if(ye)for(it=S.call(Be.ownerDocument);Be.firstChild;)it.appendChild(Be.firstChild);else it=Be;return(ae.shadowroot||ae.shadowrootmode)&&(it=I.call(i,it,!0)),it}let Ye=Y?Be.outerHTML:Be.innerHTML;return Y&&J["!doctype"]&&Be.ownerDocument&&Be.ownerDocument.doctype&&Be.ownerDocument.doctype.name&&ht(Qt,Be.ownerDocument.doctype.name)&&(Ye="<!DOCTYPE "+Be.ownerDocument.doctype.name+`>
`+Ye),re&&(Ye=dt(Ye,O," "),Ye=dt(Ye,y," "),Ye=dt(Ye,x," ")),v&&Te?v.createHTML(Ye):Ye},t.setConfig=function(Oe){Ue(Oe),Q=!0},t.clearConfig=function(){Xe=null,Q=!1},t.isValidAttribute=function(Oe,he,Be){Xe||Ue({});const Ie=Re(Oe),Ke=Re(he);return gt(Ie,Ke,Be)},t.addHook=function(Oe,he){typeof he=="function"&&(M[Oe]=M[Oe]||[],wt(M[Oe],he))},t.removeHook=function(Oe){if(M[Oe])return zt(M[Oe])},t.removeHooks=function(Oe){M[Oe]&&(M[Oe]=[])},t.removeAllHooks=function(){M={}},t}var yi=Xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(me[45],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0,t.$DS=z;class i{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const A=N(E);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(E){const A=N(E);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(E){const A=N(E);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(E){const A=N(E);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(E){const A=N(E);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(E){const A=N(E);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(E){const A=N(E);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(E){const A=N(E);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const A=N(E);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const A=N(E);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const A=N(E);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const A=N(E);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const A=N(E);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const A=N(E);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,A){this.domNode.classList.toggle(E,A),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,A){this.domNode.setAttribute(E,A)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$CS=i;function N(H){return typeof H=="number"?`${H}px`:H}function z(H){return new i(H)}}),define(me[72],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UQ=void 0,t.$VQ=H;const i=new WeakMap;function N(A){if(!A.parent||A.parent===A)return null;try{const b=A.location,$=A.parent.location;if(b.origin!=="null"&&$.origin!=="null"&&b.origin!==$.origin)return null}catch{return null}return A.parent}class z{static a(b){let $=i.get(b);if(!$){$=[],i.set(b,$);let w=b,P;do P=N(w),P?$.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):$.push({window:new WeakRef(w),iframeElement:null}),w=P;while(w)}return $.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,$){if(!$||b===$)return{top:0,left:0};let w=0,P=0;const f=this.a(b);for(const d of f){const e=d.window.deref();if(w+=e?.scrollY??0,P+=e?.scrollX??0,e===$||!d.iframeElement)break;const s=d.iframeElement.getBoundingClientRect();w+=s.top,P+=s.left}return{top:w,left:P}}}t.$UQ=z;async function H(A,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const $=JSON.stringify({parentOrigin:A,salt:b}),P=new TextEncoder().encode($),f=await crypto.subtle.digest("sha-256",P);return E(f)}function E(A){const $=Array.from(new Uint8Array(A)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${$}`).toString(32).padStart(52,"0")}}),define(me[73],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mT=t.$lT=t.$kT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(E){E[E.Copy=0]="Copy",E[E.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var N;(function(E){E.Over="drop-target",E.Before="drop-target-before",E.After="drop-target-after"})(N||(t.ListDragOverEffectPosition=N={})),t.$kT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class z extends Error{constructor(A,b){super(`ListError [${A}] ${b}`)}}t.$lT=z;class H{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,b){b>0&&this.c.set(A,b)}}t.$mT=H}),define(me[74],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=void 0;class i{constructor(z){this.a=z}splice(z,H,E){this.a.forEach(A=>A.splice(z,H,E))}}t.$aT=i}),define(me[46],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IS=void 0;const i=20;class N{constructor(H,E,A,b,$,w){this.a=Math.round(E),this.b=Math.round(A),this.c=Math.round(H),this.d=b,this.e=$,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new N(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const E=Math.round(H);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(H){const E=Math.round(H);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(H){const E=Math.round(H);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,E,A,b,$){const w=Math.max(0,A-H),P=Math.max(0,w-2*E),f=b>0&&b>A;if(!f)return{computedAvailableSize:Math.round(w),computedIsNeeded:f,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(i,Math.floor(A*P/b))),e=(P-d)/(b-A),s=$*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:f,computedSliderSize:Math.round(d),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=N.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const E=H-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const E=H-this.c;let A=this.f;return E<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const E=this.k+H;return Math.round(E/this.j)}}t.$IS=N}),define(me[27],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eV=t.$dV=t.$cV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var N;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(N||(t.ObjectTreeElementCollapseState=N={}));var z;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(z||(t.TreeMouseEventTarget=z={}));var H;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$cV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class E extends Error{constructor($,w){super(`TreeError [${$}] ${w}`)}}t.$dV=E;class A{constructor($){this.a=$,this.b=new WeakMap}map($){let w=this.b.get($);return w||(w=this.a($),this.b.set($,w)),w}}t.$eV=A}),define(me[22],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$window=t.$xQ=void 0,t.$wQ=i,t.$zQ=N;function i(z,H){const E=z;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>H})}t.$xQ=window,t.$window=t.$xQ;function N(z){return z===t.$xQ?!1:typeof z?.vscodeWindowId=="number"}}),define(me[75],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=N,t.$hb=z,t.$ib=H,t.$jb=E,t.$kb=A,t.$lb=b,t.$nb=w,t.$ob=P,t.$pb=f,t.$qb=d,t.$rb=e;function i(s,u,m){const p=N(s,u);if(p!==-1)return s[p]}function N(s,u,m=s.length-1){for(let p=m;p>=0;p--){const v=s[p];if(u(v))return p}return-1}function z(s,u){const m=H(s,u);return m===-1?void 0:s[m]}function H(s,u,m=0,p=s.length){let v=m,l=p;for(;v<l;){const g=Math.floor((v+l)/2);u(s[g])?v=g+1:l=g}return v-1}function E(s,u){const m=A(s,u);return m===s.length?void 0:s[m]}function A(s,u,m=0,p=s.length){let v=m,l=p;for(;v<l;){const g=Math.floor((v+l)/2);u(s[g])?l=g:v=g+1}return v}function b(s,u,m=0,p=s.length){const v=A(s,u,m,p);return v===s.length?-1:v}class ${static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if($.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!u(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const m=H(this.e,u,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$mb=$;function w(s,u){if(s.length===0)return;let m=s[0];for(let p=1;p<s.length;p++){const v=s[p];u(v,m)>0&&(m=v)}return m}function P(s,u){if(s.length===0)return;let m=s[0];for(let p=1;p<s.length;p++){const v=s[p];u(v,m)>=0&&(m=v)}return m}function f(s,u){return w(s,(m,p)=>-u(m,p))}function d(s,u){if(s.length===0)return-1;let m=0;for(let p=1;p<s.length;p++){const v=s[p];u(v,s[m])>0&&(m=p)}return m}function e(s,u){for(const m of s){const p=u(m);if(p!==void 0)return p}}}),define(me[76],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=N,t.$M=z,t.$N=H;function i(E,A){const b=Object.create(null);for(const $ of E){const w=A($);let P=b[w];P||(P=b[w]=[]),P.push($)}return b}function N(E,A){const b=[],$=[];for(const w of E)A.has(w)||b.push(w);for(const w of A)E.has(w)||$.push(w);return{removed:b,added:$}}function z(E,A){const b=[],$=[];for(const[w,P]of E)A.has(w)||b.push(P);for(const[w,P]of A)E.has(w)||$.push(P);return{removed:b,added:$}}function H(E,A){const b=new Set;for(const $ of A)E.has($)&&b.add($);return b}}),define(me[77],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Et=t.$Dt=t.$Ct=t.$Bt=void 0;function i(A,b){const $=Math.pow(10,b);return Math.round(A*$)/$}class N{constructor(b,$,w,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,$))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.r===$.r&&b.g===$.g&&b.b===$.b&&b.a===$.a}}t.$Bt=N;class z{constructor(b,$,w,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=i(Math.max(Math.min(1,$),0),3),this.l=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.l===$.l&&b.a===$.a}static fromRGBA(b){const $=b.r/255,w=b.g/255,P=b.b/255,f=b.a,d=Math.max($,w,P),e=Math.min($,w,P);let s=0,u=0;const m=(e+d)/2,p=d-e;if(p>0){switch(u=Math.min(m<=.5?p/(2*m):p/(2-2*m),1),d){case $:s=(w-P)/p+(w<P?6:0);break;case w:s=(P-$)/p+2;break;case P:s=($-w)/p+4;break}s*=60,s=Math.round(s)}return new z(s,u,m,f)}static i(b,$,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?b+($-b)*6*w:w<1/2?$:w<2/3?b+($-b)*(2/3-w)*6:b}static toRGBA(b){const $=b.h/360,{s:w,l:P,a:f}=b;let d,e,s;if(w===0)d=e=s=P;else{const u=P<.5?P*(1+w):P+w-P*w,m=2*P-u;d=z.i(m,u,$+1/3),e=z.i(m,u,$),s=z.i(m,u,$-1/3)}return new N(Math.round(d*255),Math.round(e*255),Math.round(s*255),f)}}t.$Ct=z;class H{constructor(b,$,w,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=i(Math.max(Math.min(1,$),0),3),this.v=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(b,$){return b.h===$.h&&b.s===$.s&&b.v===$.v&&b.a===$.a}static fromRGBA(b){const $=b.r/255,w=b.g/255,P=b.b/255,f=Math.max($,w,P),d=Math.min($,w,P),e=f-d,s=f===0?0:e/f;let u;return e===0?u=0:f===$?u=((w-P)/e%6+6)%6:f===w?u=(P-$)/e+2:u=($-w)/e+4,new H(Math.round(u*60),s,f,b.a)}static toRGBA(b){const{h:$,s:w,v:P,a:f}=b,d=P*w,e=d*(1-Math.abs($/60%2-1)),s=P-d;let[u,m,p]=[0,0,0];return $<60?(u=d,m=e):$<120?(u=e,m=d):$<180?(m=d,p=e):$<240?(m=e,p=d):$<300?(u=e,p=d):$<=360&&(u=d,p=e),u=Math.round((u+s)*255),m=Math.round((m+s)*255),p=Math.round((p+s)*255),new N(u,m,p,f)}}t.$Dt=H;class E{static fromHex(b){return E.Format.CSS.parseHex(b)||E.red}static equals(b,$){return!b&&!$?!0:!b||!$?!1:b.equals($)}get hsla(){return this.i?this.i:z.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof N)this.rgba=b;else if(b instanceof z)this.i=b,this.rgba=z.toRGBA(b);else if(b instanceof H)this.j=b,this.rgba=H.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&N.equals(this.rgba,b.rgba)&&z.equals(this.hsla,b.hsla)&&H.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=E.k(this.rgba.r),$=E.k(this.rgba.g),w=E.k(this.rgba.b),P=.2126*b+.7152*$+.0722*w;return i(P,4)}static k(b){const $=b/255;return $<=.03928?$/12.92:Math.pow(($+.055)/1.055,2.4)}getContrastRatio(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $>w?($+.05)/(w+.05):(w+.05)/($+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $>w}isDarkerThan(b){const $=this.getRelativeLuminance(),w=b.getRelativeLuminance();return $<w}lighten(b){return new E(new z(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new E(new z(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:$,g:w,b:P,a:f}=this.rgba;return new E(new N($,w,P,f*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new N(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const $=b.rgba,w=this.rgba.a,P=$.a,f=w+P*(1-w);if(f<1e-6)return E.transparent;const d=this.rgba.r*w/f+$.r*P*(1-w)/f,e=this.rgba.g*w/f+$.g*P*(1-w)/f,s=this.rgba.b*w/f+$.b*P*(1-w)/f;return new E(new N(d,e,s,f))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:$,g:w,b:P,a:f}=this.rgba;return new E(new N(b.rgba.r-f*(b.rgba.r-$),b.rgba.g-f*(b.rgba.g-w),b.rgba.b-f*(b.rgba.b-P),1))}flatten(...b){const $=b.reduceRight((w,P)=>E.o(P,w));return E.o(this,$)}static o(b,$){const w=1-b.rgba.a;return new E(new N(w*$.rgba.r+b.rgba.a*b.rgba.r,w*$.rgba.g+b.rgba.a*b.rgba.g,w*$.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(b,$,w){if(b.isLighterThan($))return b;w=w||.5;const P=b.getRelativeLuminance(),f=$.getRelativeLuminance();return w=w*(f-P)/f,b.lighten(w)}static getDarkerColor(b,$,w){if(b.isDarkerThan($))return b;w=w||.5;const P=b.getRelativeLuminance(),f=$.getRelativeLuminance();return w=w*(P-f)/P,b.darken(w)}static{this.white=new E(new N(255,255,255,1))}static{this.black=new E(new N(0,0,0,1))}static{this.red=new E(new N(255,0,0,1))}static{this.blue=new E(new N(0,0,255,1))}static{this.green=new E(new N(0,255,0,1))}static{this.cyan=new E(new N(0,255,255,1))}static{this.lightgrey=new E(new N(211,211,211,1))}static{this.transparent=new E(new N(0,0,0,0))}}t.$Et=E,function(A){let b;(function($){let w;(function(P){function f(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:A.Format.CSS.formatRGBA(r)}P.formatRGB=f;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}P.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(r)}P.formatHSL=e;function s(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}P.formatHSLA=s;function u(r){const S=r.toString(16);return S.length!==2?"0"+S:S}function m(r){return`#${u(r.rgba.r)}${u(r.rgba.g)}${u(r.rgba.b)}`}P.formatHex=m;function p(r,S=!1){return S&&r.rgba.a===1?A.Format.CSS.formatHex(r):`#${u(r.rgba.r)}${u(r.rgba.g)}${u(r.rgba.b)}${u(Math.round(r.rgba.a*255))}`}P.formatHexA=p;function v(r){return r.isOpaque()?A.Format.CSS.formatHex(r):A.Format.CSS.formatRGBA(r)}P.format=v;function l(r){const S=r.length;if(S===0||r.charCodeAt(0)!==35)return null;if(S===7){const C=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),I=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),M=16*g(r.charCodeAt(5))+g(r.charCodeAt(6));return new A(new N(C,I,M,1))}if(S===9){const C=16*g(r.charCodeAt(1))+g(r.charCodeAt(2)),I=16*g(r.charCodeAt(3))+g(r.charCodeAt(4)),M=16*g(r.charCodeAt(5))+g(r.charCodeAt(6)),O=16*g(r.charCodeAt(7))+g(r.charCodeAt(8));return new A(new N(C,I,M,O/255))}if(S===4){const C=g(r.charCodeAt(1)),I=g(r.charCodeAt(2)),M=g(r.charCodeAt(3));return new A(new N(16*C+C,16*I+I,16*M+M))}if(S===5){const C=g(r.charCodeAt(1)),I=g(r.charCodeAt(2)),M=g(r.charCodeAt(3)),O=g(r.charCodeAt(4));return new A(new N(16*C+C,16*I+I,16*M+M,(16*O+O)/255))}return null}P.parseHex=l;function g(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=$.CSS||($.CSS={}))})(b=A.Format||(A.Format={}))}(E||(t.$Et=E={}))}),define(me[28],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lh=N,t.$Mh=z,t.$Nh=H;function i(E){return(A,b,$)=>{let w=null,P=null;if(typeof $.value=="function"?(w="value",P=$.value):typeof $.get=="function"&&(w="get",P=$.get),!P)throw new Error("not supported");$[w]=E(P,b)}}function N(E,A,b){let $=null,w=null;if(typeof b.value=="function"?($="value",w=b.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&($="get",w=b.get),!w)throw new Error("not supported");const P=`$memoize$${A}`;b[$]=function(...f){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,f)}),this[P]}}function z(E,A,b){return i(($,w)=>{const P=`$debounce$${w}`,f=`$debounce$result$${w}`;return function(...d){this[f]||(this[f]=b?b():void 0),clearTimeout(this[P]),A&&(this[f]=A(this[f],...d),d=[this[f]]),this[P]=setTimeout(()=>{$.apply(this,d),this[f]=b?b():void 0},E)}})}function H(E,A,b){return i(($,w)=>{const P=`$throttle$timer$${w}`,f=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...s){if(this[f]||(this[f]=b?b():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),A&&(this[f]=A(this[f],...s)),this[e])return;const u=this[d]+E;u<=Date.now()?(this[d]=Date.now(),$.apply(this,[this[f]]),this[f]=b?b():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[d]=Date.now(),$.apply(this,[this[f]]),this[f]=b?b():void 0},u-Date.now()))}})}}),define(me[78],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=void 0;class i{constructor(z,H,E,A){this.originalStart=z,this.originalLength=H,this.modifiedStart=E,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$dt=i}),define(me[6],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=N,t.$Z=z,t.$1=H,t.$2=E,t.$3=A,t.$4=$,t.$6=P,t.$7=f,t.$8=d,t.$0=s;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(S=>{S(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function N(g){t.$X.setUnexpectedErrorHandler(g)}function z(g){if(!g||typeof g!="object")return!1;const r=g;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function H(g){$(g)||t.$X.onUnexpectedError(g)}function E(g){$(g)||t.$X.onUnexpectedExternalError(g)}function A(g){if(g instanceof Error){const{name:r,message:S}=g,C=g.stacktrace||g.stack;return{$isError:!0,name:r,message:S,stack:C,noTelemetry:v.isErrorNoTelemetry(g)}}return g}const b="Canceled";function $(g){return g instanceof w?!0:g instanceof Error&&g.name===b&&g.message===b}class w extends Error{constructor(){super(b),this.name=this.message}}t.$5=w;function P(){const g=new Error(b);return g.name=g.message,g}function f(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}function d(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}class u extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=u;class m extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=m;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=p;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const S=new v;return S.message=r.message,S.stack=r.stack,S}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=v;class l extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}t.$cb=l}),define(me[12],be([1,0,6,75]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=z,t.$tb=H,t.$ub=E,t.$vb=A,t.$wb=b,t.$xb=$,t.$yb=w,t.$zb=P,t.$Ab=f,t.$Bb=d,t.$Cb=e,t.$Db=s,t.$Eb=u,t.top=m,t.$Gb=p,t.$Hb=l,t.$Ib=g,t.$Jb=r,t.$Kb=S,t.$Lb=C,t.$Mb=I,t.$Nb=M,t.$Ob=O,t.$Pb=y,t.$Qb=x,t.$Rb=W,t.$Sb=T,t.$Tb=R,t.$Ub=L,t.$Vb=X,t.$Wb=J,t.$Xb=de,t.$Yb=ae,t.$Zb=ie,t.$1b=ge,t.$2b=Fe,t.$3b=Ne,t.$4b=Pe,t.$5b=oe,t.$6b=U,t.$7b=Y,t.$8b=Q,t.$$b=ye;function z(c,k=0){return c[c.length-(1+k)]}function H(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}function E(c,k,D=(o,a)=>o===a){if(c===k)return!0;if(!c||!k||c.length!==k.length)return!1;for(let o=0,a=c.length;o<a;o++)if(!D(c[o],k[o]))return!1;return!0}function A(c,k){const D=c.length-1;k<D&&(c[k]=c[D]),c.pop()}function b(c,k,D){return $(c.length,o=>D(c[o],k))}function $(c,k){let D=0,o=c-1;for(;D<=o;){const a=(D+o)/2|0,n=k(a);if(n<0)D=a+1;else if(n>0)o=a-1;else return a}return-(D+1)}function w(c,k,D){if(c=c|0,c>=k.length)throw new TypeError("invalid index");const o=k[Math.floor(k.length*Math.random())],a=[],n=[],h=[];for(const F of k){const B=D(F,o);B<0?a.push(F):B>0?n.push(F):h.push(F)}return c<a.length?w(c,a,D):c<a.length+h.length?h[0]:w(c-(a.length+h.length),n,D)}function P(c,k){const D=[];let o;for(const a of c.slice(0).sort(k))!o||k(o[0],a)!==0?(o=[a],D.push(o)):o.push(a);return D}function*f(c,k){let D,o;for(const a of c)o!==void 0&&k(o,a)?D.push(a):(D&&(yield D),D=[a]),o=a;D&&(yield D)}function d(c,k){for(let D=0;D<=c.length;D++)k(D===0?void 0:c[D-1],D===c.length?void 0:c[D])}function e(c,k){for(let D=0;D<c.length;D++)k(D===0?void 0:c[D-1],c[D],D+1===c.length?void 0:c[D+1])}function s(c,k,D){const o=[];function a(F,B,j){if(B===0&&j.length===0)return;const V=o[o.length-1];V&&V.start+V.deleteCount===F?(V.deleteCount+=B,V.toInsert.push(...j)):o.push({start:F,deleteCount:B,toInsert:j})}let n=0,h=0;for(;;){if(n===c.length){a(n,0,k.slice(h));break}if(h===k.length){a(n,c.length-n,[]);break}const F=c[n],B=k[h],j=D(F,B);j===0?(n+=1,h+=1):j<0?(a(n,1,[]),n+=1):j>0&&(a(n,0,[B]),h+=1)}return o}function u(c,k,D){const o=s(c,k,D),a=[],n=[];for(const h of o)a.push(...c.slice(h.start,h.start+h.deleteCount)),n.push(...h.toInsert);return{removed:a,added:n}}function m(c,k,D){if(D===0)return[];const o=c.slice(0,D).sort(k);return v(c,k,o,D,c.length),o}function p(c,k,D,o,a){return D===0?Promise.resolve([]):new Promise((n,h)=>{(async()=>{const F=c.length,B=c.slice(0,D).sort(k);for(let j=D,V=Math.min(D+o,F);j<F;j=V,V=Math.min(V+o,F)){if(j>D&&await new Promise(Z=>setTimeout(Z)),a&&a.isCancellationRequested)throw new i.$5;v(c,k,B,j,V)}return B})().then(n,h)})}function v(c,k,D,o,a){for(const n=D.length;o<a;o++){const h=c[o];if(k(h,D[n-1])<0){D.pop();const F=(0,N.$kb)(D,B=>k(h,B)<0);D.splice(F,0,h)}}}function l(c){return c.filter(k=>!!k)}function g(c){let k=0;for(let D=0;D<c.length;D++)c[D]&&(c[k]=c[D],k+=1);c.length=k}function r(c,k,D){c.splice(D,0,c.splice(k,1)[0])}function S(c){return!Array.isArray(c)||c.length===0}function C(c){return Array.isArray(c)&&c.length>0}function I(c,k=D=>D){const D=new Set;return c.filter(o=>{const a=k(o);return D.has(a)?!1:(D.add(a),!0)})}function M(c){const k=new Set;return D=>{const o=c(D);return k.has(o)?!1:(k.add(o),!0)}}function O(c,k){return c.length>0?c[0]:k}function y(c,k){return c.length>0?c[c.length-1]:k}function x(c,k,D=(o,a)=>o===a){let o=0;for(let a=0,n=Math.min(c.length,k.length);a<n&&D(c[a],k[a]);a++)o++;return o}function W(c){return[].concat(...c)}function T(c,k){let D=typeof k=="number"?c:0;typeof k=="number"?D=c:(D=0,k=c);const o=[];if(D<=k)for(let a=D;a<k;a++)o.push(a);else for(let a=D;a>k;a--)o.push(a);return o}function R(c,k,D){return c.reduce((o,a)=>(o[k(a)]=D?D(a):a,o),Object.create(null))}function L(c,k){return c.push(k),()=>X(c,k)}function X(c,k){const D=c.indexOf(k);if(D>-1)return c.splice(D,1),k}function J(c,k,D){const o=c.slice(0,k),a=c.slice(k);return o.concat(D,a)}function de(c,k){let D;if(typeof k=="number"){let o=k;D=()=>{const a=Math.sin(o++)*179426549;return a-Math.floor(a)}}else D=Math.random;for(let o=c.length-1;o>0;o-=1){const a=Math.floor(D()*(o+1)),n=c[o];c[o]=c[a],c[a]=n}}function ae(c,k){const D=c.indexOf(k);D>-1&&(c.splice(D,1),c.unshift(k))}function ie(c,k){const D=c.indexOf(k);D>-1&&(c.splice(D,1),c.push(k))}function ge(c,k){for(const D of k)c.push(D)}function Fe(c,k){return Array.isArray(c)?c.map(k):k(c)}function Ne(c){return Array.isArray(c)?c:[c]}function Pe(c){return c[Math.floor(Math.random()*c.length)]}function oe(c,k,D){const o=le(c,k),a=c.length,n=D.length;c.length=a+n;for(let h=a-1;h>=o;h--)c[h+n]=c[h];for(let h=0;h<n;h++)c[h+o]=D[h]}function U(c,k,D,o){const a=le(c,k);let n=c.splice(a,D);return n===void 0&&(n=[]),oe(c,a,o),n}function le(c,k){return k<0?Math.max(k+c.length,0):Math.min(k,c.length)}var re;(function(c){function k(n){return n<0}c.isLessThan=k;function D(n){return n<=0}c.isLessThanOrEqual=D;function o(n){return n>0}c.isGreaterThan=o;function a(n){return n===0}c.isNeitherLessOrGreaterThan=a,c.greaterThan=1,c.lessThan=-1,c.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function Y(c,k){return(D,o)=>k(c(D),c(o))}function Q(...c){return(k,D)=>{for(const o of c){const a=o(k,D);if(!re.isNeitherLessOrGreaterThan(a))return a}return re.neitherLessOrGreaterThan}}const te=(c,k)=>c-k;t.$9b=te;const ue=(c,k)=>(0,t.$9b)(c?1:0,k?1:0);t.$0b=ue;function ye(c){return(k,D)=>-c(k,D)}class Te{constructor(k){this.g=k,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(k){let D=this.c;for(;D<this.g.length&&k(this.g[D]);)D++;const o=D===this.c?null:this.g.slice(this.c,D);return this.c=D,o}takeFromEndWhile(k){let D=this.d;for(;D>=0&&k(this.g[D]);)D--;const o=D===this.d?null:this.g.slice(D+1,this.d+1);return this.d=D,o}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const k=this.g[this.c];return this.c++,k}removeLast(){const k=this.g[this.d];return this.d--,k}takeCount(k){const D=this.g.slice(this.c,this.c+k);return this.c+=k,D}}t.$_b=Te;class Ee{static{this.empty=new Ee(k=>{})}constructor(k){this.iterate=k}forEach(k){this.iterate(D=>(k(D),!0))}toArray(){const k=[];return this.iterate(D=>(k.push(D),!0)),k}filter(k){return new Ee(D=>this.iterate(o=>k(o)?D(o):!0))}map(k){return new Ee(D=>this.iterate(o=>D(k(o))))}some(k){let D=!1;return this.iterate(o=>(D=k(o),!D)),D}findFirst(k){let D;return this.iterate(o=>k(o)?(D=o,!1):!0),D}findLast(k){let D;return this.iterate(o=>(k(o)&&(D=o),!0)),D}findLastMaxBy(k){let D,o=!0;return this.iterate(a=>((o||re.isGreaterThan(k(a,D)))&&(o=!1,D=a),!0)),D}}t.$ac=Ee;class fe{constructor(k){this.c=k}static createSortPermutation(k,D){const o=Array.from(k.keys()).sort((a,n)=>D(k[a],k[n]));return new fe(o)}apply(k){return k.map((D,o)=>k[this.c[o]])}inverse(){const k=this.c.slice();for(let D=0;D<this.c.length;D++)k[this.c[D]]=D;return new fe(k)}}t.$bc=fe}),define(me[79],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=N,t.$0c=z,t.$$c=H,t.$_c=E,t.$ad=A,t.$bd=b;function N($,w){if(!$)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function z($,w="Unreachable"){throw new Error(w)}function H($){if(!$)throw new i.$cb("Assertion Failed")}function E($){$||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function A($){if(!$()){debugger;$(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function b($,w){let P=0;for(;P<$.length-1;){const f=$[P],d=$[P+1];if(!w(f,d))return!1;P++}return!0}}),define(me[47],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(N,z){const H=this;let E=!1,A;return function(){if(E)return A;if(E=!0,z)try{A=N.apply(H,arguments)}finally{z()}else A=N.apply(H,arguments);return A}}}),define(me[80],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GO=t.$FO=void 0;class i{constructor(z){this.a=z,this.b=0}nextId(){return this.a+ ++this.b}}t.$FO=i,t.$GO=new i("id#")}),define(me[29],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(N){function z(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}N.is=z;const H=Object.freeze([]);function E(){return H}N.empty=E;function*A(r){yield r}N.single=A;function b(r){return z(r)?r:A(r)}N.wrap=b;function $(r){return r||H}N.from=$;function*w(r){for(let S=r.length-1;S>=0;S--)yield r[S]}N.reverse=w;function P(r){return!r||r[Symbol.iterator]().next().done===!0}N.isEmpty=P;function f(r){return r[Symbol.iterator]().next().value}N.first=f;function d(r,S){for(const C of r)if(S(C))return!0;return!1}N.some=d;function e(r,S){for(const C of r)if(S(C))return C}N.find=e;function*s(r,S){for(const C of r)S(C)&&(yield C)}N.filter=s;function*u(r,S){let C=0;for(const I of r)yield S(I,C++)}N.map=u;function*m(...r){for(const S of r)yield*S}N.concat=m;function p(r,S,C){let I=C;for(const M of r)I=S(I,M);return I}N.reduce=p;function*v(r,S,C=r.length){for(S<0&&(S+=r.length),C<0?C+=r.length:C>r.length&&(C=r.length);S<C;S++)yield r[S]}N.slice=v;function l(r,S=Number.POSITIVE_INFINITY){const C=[];if(S===0)return[C,r];const I=r[Symbol.iterator]();for(let M=0;M<S;M++){const O=I.next();if(O.done)return[C,N.empty()];C.push(O.value)}return[C,{[Symbol.iterator](){return I}}]}N.consume=l;async function g(r){const S=[];for await(const C of r)S.push(C);return Promise.resolve(S)}N.asyncToArray=g})(i||(t.Iterable=i={}))}),define(me[48],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$lr=t.$kr=t.$jr=t.$ir=t.$hr=t.ScanCode=t.KeyCode=void 0,t.$mr=d;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(N||(t.ScanCode=N={}));class z{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,u){this._keyCodeToStr[s]=u,this._strToKeyCode[u.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new z,E=new z,A=new z;t.$hr=new Array(230),t.$ir={};const b=[],$=Object.create(null),w=Object.create(null);t.$jr={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>$[e]||0,toString:e=>b[e]||"None"},t.$kr=[],t.$lr=[];for(let e=0;e<=193;e++)t.$kr[e]=-1;for(let e=0;e<=132;e++)t.$lr[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],u=[],m=[];for(const p of s){const[v,l,g,r,S,C,I,M,O]=p;if(m[l]||(m[l]=!0,b[l]=g,$[g]=l,w[g.toLowerCase()]=l,v&&(t.$kr[l]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$lr[r]=l))),!u[r]){if(u[r]=!0,!S)throw new Error(`String representation missing for key code ${r} around scan code ${g}`);H.define(r,S),E.define(r,M||S),A.define(r,O||M||S)}C&&(t.$hr[C]=r),I&&(t.$ir[I]=r)}t.$lr[3]=46})();var P;(function(e){function s(g){return H.keyCodeToStr(g)}e.toString=s;function u(g){return H.strToKeyCode(g)}e.fromString=u;function m(g){return E.keyCodeToStr(g)}e.toUserSettingsUS=m;function p(g){return A.keyCodeToStr(g)}e.toUserSettingsGeneral=p;function v(g){return E.strToKeyCode(g)||A.strToKeyCode(g)}e.fromUserSettings=v;function l(g){if(g>=98&&g<=113)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(g)}e.toElectronAccelerator=l})(P||(t.KeyCodeUtils=P={}));var f;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(f||(t.KeyMod=f={}));function d(e,s){const u=(s&65535)<<16>>>0;return(e|u)>>>0}}),define(me[81],be([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tr=t.$sr=t.$rr=t.$qr=t.$pr=void 0,t.$nr=z,t.$or=H;var N;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(N||(N={}));function z(P,f){if(typeof P=="number"){if(P===0)return null;const d=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new b([H(d,f),H(e,f)]):new b([H(d,f)])}else{const d=[];for(let e=0;e<P.length;e++)d.push(H(P[e],f));return new b(d)}}function H(P,f){const d=!!(P&2048),e=!!(P&256),s=f===2?e:d,u=!!(P&1024),m=!!(P&512),p=f===2?d:e,v=P&255;return new E(s,u,m,p,v)}class E{constructor(f,d,e,s,u){this.ctrlKey=f,this.shiftKey=d,this.altKey=e,this.metaKey=s,this.keyCode=u}equals(f){return f instanceof E&&this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.keyCode===f.keyCode}getHashCode(){const f=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${f}${d}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$pr=E;class A{constructor(f,d,e,s,u){this.ctrlKey=f,this.shiftKey=d,this.altKey=e,this.metaKey=s,this.scanCode=u}equals(f){return f instanceof A&&this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}getHashCode(){const f=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${f}${d}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$qr=A;class b{constructor(f){if(f.length===0)throw(0,i.$7)("chords");this.chords=f}getHashCode(){let f="";for(let d=0,e=this.chords.length;d<e;d++)d!==0&&(f+=";"),f+=this.chords[d].getHashCode();return f}equals(f){if(f===null||this.chords.length!==f.chords.length)return!1;for(let d=0;d<this.chords.length;d++)if(!this.chords[d].equals(f.chords[d]))return!1;return!0}}t.$rr=b;class ${constructor(f,d,e,s,u,m){this.ctrlKey=f,this.shiftKey=d,this.altKey=e,this.metaKey=s,this.keyLabel=u,this.keyAriaLabel=m}}t.$sr=$;class w{}t.$tr=w}),define(me[23],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(z){this.d=z,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(z){this.c=z}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(me[14],be([1,0,23]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XS=A,t.$YS=b,t.$ZS=$;let z=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const H=new i.$V(()=>z("mouse",!1)),E=new i.$V(()=>z("element",!1));function A(w){z=w}function b(w){return w==="element"?E.value:H.value}function $(){return z("element",!0)}}),define(me[49],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(H){this.element=H,this.next=i.Undefined,this.prev=i.Undefined}}class N{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let H=this.a;for(;H!==i.Undefined;){const E=H.next;H.prev=i.Undefined,H.next=i.Undefined,H=E}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,E){const A=new i(H);if(this.a===i.Undefined)this.a=A,this.b=A;else if(E){const $=this.b;this.b=A,A.prev=$,$.next=A}else{const $=this.a;this.a=A,A.next=$,$.prev=A}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(A))}}shift(){if(this.a!==i.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==i.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==i.Undefined&&H.next!==i.Undefined){const E=H.prev;E.next=H.next,H.next.prev=E}else H.prev===i.Undefined&&H.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):H.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):H.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==i.Undefined;)yield H.element,H=H.next}}t.$5c=N}),define(me[34],be([1,0]),function(se,t){"use strict";var i,N,z;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=H,t.$zc=E,t.$Ac=A,t.$Ic=p;function H(v,l,g){let r=v.get(l);return r===void 0&&(r=g,v.set(l,r)),r}function E(v){const l=[];return v.forEach((g,r)=>{l.push(`${r} => ${g}`)}),`Map(${v.size}) {${l.join(", ")}}`}function A(v){const l=[];return v.forEach(g=>{l.push(g)}),`Set(${v.size}) {${l.join(", ")}}`}class b{constructor(l,g){this.uri=l,this.value=g}}function $(v){return Array.isArray(v)}class w{static{this.c=l=>l.toString()}constructor(l,g){if(this[i]="ResourceMap",l instanceof w)this.d=new Map(l.d),this.e=g??w.c;else if($(l)){this.d=new Map,this.e=g??w.c;for(const[r,S]of l)this.set(r,S)}else this.d=new Map,this.e=l??w.c}set(l,g){return this.d.set(this.e(l),new b(l,g)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,g){typeof g<"u"&&(l=l.bind(g));for(const[r,S]of this.d)l(S.value,S.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}t.$Bc=w;class P{constructor(l,g){this[N]="ResourceSet",!l||typeof l=="function"?this.c=new w(l):(this.c=new w(g),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,g){this.c.forEach((r,S)=>l.call(g,S,S,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=P;var f;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(f||(t.Touch=f={}));class d{constructor(){this[z]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,g=0){const r=this.c.get(l);if(r)return g!==0&&this.l(r,g),r.value}set(l,g,r=0){let S=this.c.get(l);if(S)S.value=g,r!==0&&this.l(S,r);else{switch(S={key:l,value:g,next:void 0,previous:void 0},r){case 0:this.j(S);break;case 1:this.i(S);break;case 2:this.j(S);break;default:this.j(S);break}this.c.set(l,S),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const g=this.c.get(l);if(g)return this.c.delete(l),this.k(g),this.f--,g.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.k(l),this.f--,l.value}forEach(l,g){const r=this.g;let S=this.d;for(;S;){if(g?l.bind(g)(S.value,S.key,this):l(S.value,S.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const l=this,g=this.g;let r=this.d;const S={[Symbol.iterator](){return S},next(){if(l.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const C={value:r.key,done:!1};return r=r.next,C}else return{value:void 0,done:!0}}};return S}values(){const l=this,g=this.g;let r=this.d;const S={[Symbol.iterator](){return S},next(){if(l.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const C={value:r.value,done:!1};return r=r.next,C}else return{value:void 0,done:!0}}};return S}entries(){const l=this,g=this.g;let r=this.d;const S={[Symbol.iterator](){return S},next(){if(l.g!==g)throw new Error("LinkedMap got modified during iteration.");if(r){const C={value:[r.key,r.value],done:!1};return r=r.next,C}else return{value:void 0,done:!0}}};return S}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let g=this.d,r=this.size;for(;g&&r>l;)this.c.delete(g.key),g=g.next,r--;this.d=g,this.f=r,g&&(g.previous=void 0),this.g++}i(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}j(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}k(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const g=l.next,r=l.previous;if(!g||!r)throw new Error("Invalid list");g.previous=r,r.next=g}l.next=void 0,l.previous=void 0,this.g++}l(l,g){if(!this.d||!this.e)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(l===this.d)return;const r=l.next,S=l.previous;l===this.e?(S.next=void 0,this.e=S):(r.previous=S,S.next=r),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(g===2){if(l===this.e)return;const r=l.next,S=l.previous;l===this.d?(r.previous=void 0,this.d=r):(r.previous=S,S.next=r),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((g,r)=>{l.push([r,g])}),l}fromJSON(l){this.clear();for(const[g,r]of l)this.set(g,r)}}t.$Dc=d;class e extends d{constructor(l,g=1){super(),this.m=l,this.n=Math.min(Math.max(0,g),1)}get limit(){return this.m}set limit(l){this.m=l,this.o()}get ratio(){return this.n}set ratio(l){this.n=Math.min(Math.max(0,l),1),this.o()}get(l,g=2){return super.get(l,g)}peek(l){return super.get(l,0)}set(l,g){return super.set(l,g,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class s{constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let g=this.c.get(l)||0;return g===0?!1:(g--,g===0?this.c.delete(l):this.c.set(l,g),!0)}has(l){return this.c.has(l)}}t.$Fc=s;class u{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[g,r]of l)this.set(g,r)}clear(){this.c.clear(),this.d.clear()}set(l,g){this.c.set(l,g),this.d.set(g,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const g=this.c.get(l);return g===void 0?!1:(this.c.delete(l),this.d.delete(g),!0)}forEach(l,g){this.c.forEach((r,S)=>{l.call(g,r,S,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=u;class m{constructor(){this.c=new Map}add(l,g){let r=this.c.get(l);r||(r=new Set,this.c.set(l,r)),r.add(g)}delete(l,g){const r=this.c.get(l);r&&(r.delete(g),r.size===0&&this.c.delete(l))}forEach(l,g){const r=this.c.get(l);r&&r.forEach(g)}get(l){const g=this.c.get(l);return g||new Set}}t.$Hc=m;function p(v,l){if(v===l)return!0;if(v.size!==l.size)return!1;for(const[g,r]of v)if(!l.has(g)||l.get(g)!==r)return!1;for(const[g]of l)if(!v.has(g))return!1;return!0}}),define(me[3],be([1,0,12,76,34,47,29]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=w,t.$Lc=P,t.$Mc=f,t.$Nc=s,t.$Oc=u,t.$Pc=m,t.$Qc=p,t.$Rc=v,t.$Sc=l,t.$3c=W;const A=!1;let b=null;class ${constructor(){this.b=new Map}static{this.a=0}c(L){let X=this.b.get(L);return X||(X={parent:null,source:null,isSingleton:!1,value:L,idx:$.a++},this.b.set(L,X)),X}trackDisposable(L){const X=this.c(L);X.source||(X.source=new Error().stack)}setParent(L,X){const J=this.c(L);J.parent=X}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,X){const J=X.get(L);if(J)return J;const de=L.parent?this.f(this.c(L.parent),X):L;return X.set(L,de),de}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,J])=>J.source!==null&&!this.f(J,L).isSingleton).flatMap(([J])=>J)}computeLeakingDisposables(L=10,X){let J;if(X)J=X;else{const Fe=new Map,Ne=[...this.b.values()].filter(oe=>oe.source!==null&&!this.f(oe,Fe).isSingleton);if(Ne.length===0)return;const Pe=new Set(Ne.map(oe=>oe.value));if(J=Ne.filter(oe=>!(oe.parent&&Pe.has(oe.parent))),J.length===0)throw new Error("There are cyclic diposable chains!")}if(!J)return;function de(Fe){function Ne(oe,U){for(;oe.length>0&&U.some(le=>typeof le=="string"?le===oe[0]:oe[0].match(le));)oe.shift()}const Pe=Fe.source.split(`
`).map(oe=>oe.trim().replace("at ","")).filter(oe=>oe!=="");return Ne(Pe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Pe.reverse()}const ae=new z.$Hc;for(const Fe of J){const Ne=de(Fe);for(let Pe=0;Pe<=Ne.length;Pe++)ae.add(Ne.slice(0,Pe).join(`
`),Fe)}J.sort((0,i.$7b)(Fe=>Fe.idx,i.$9b));let ie="",ge=0;for(const Fe of J.slice(0,L)){ge++;const Ne=de(Fe),Pe=[];for(let oe=0;oe<Ne.length;oe++){let U=Ne[oe];U=`(shared with ${ae.get(Ne.slice(0,oe+1).join(`
`)).size}/${J.length} leaks) at ${U}`;const re=ae.get(Ne.slice(0,oe).join(`
`)),Y=(0,N.$K)([...re].map(Q=>de(Q)[oe]),Q=>Q);delete Y[Ne[oe]];for(const[Q,te]of Object.entries(Y))Pe.unshift(`    - stacktraces of ${te.length} other leaks continue with ${Q}`);Pe.unshift(U)}ie+=`


==================== Leaking disposable ${ge}/${J.length}: ${Fe.value.constructor.name} ====================
${Pe.join(`
`)}
============================================================

`}return J.length>L&&(ie+=`


... and ${J.length-L} more leaking disposables

`),{leaks:J,details:ie}}}t.$Jc=$;function w(R){b=R}if(A){const R="__is_disposable_tracked__";w(new class{trackDisposable(L){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[R]||console.log(X)},3e3)}setParent(L,X){if(L&&L!==r.None)try{L[R]=!0}catch{}}markAsDisposed(L){if(L&&L!==r.None)try{L[R]=!0}catch{}}markAsSingleton(L){}})}function P(R){return b?.trackDisposable(R),R}function f(R){b?.markAsDisposed(R)}function d(R,L){b?.setParent(R,L)}function e(R,L){if(b)for(const X of R)b.setParent(X,L)}function s(R){return b?.markAsSingleton(R),R}function u(R){return typeof R.dispose=="function"&&R.dispose.length===0}function m(R){if(E.Iterable.is(R)){const L=[];for(const X of R)if(X)try{X.dispose()}catch(J){L.push(J)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function p(R){for(const L of R)u(L)&&L.dispose();return[]}function v(...R){const L=l(()=>m(R));return e(R,L),L}function l(R){const L=P({dispose:(0,H.$db)(()=>{f(L),R()})});return L}class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return d(L,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),d(L,null))}}t.$Tc=g;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,P(this),d(this.q,this)}dispose(){f(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}t.$Uc=r;class S{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&d(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&d(L,null),L}}t.$Vc=S;class C{constructor(L){this.a=new S,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=C;class I{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=I;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(L){let X=L;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,f(this))},this}}t.$Yc=M;class O{constructor(){this.a=new Map}acquire(L,...X){let J=this.a.get(L);J||(J={counter:0,object:this.b(L,...X)},this.a.set(L,J));const{object:de}=J,ae=(0,H.$db)(()=>{--J.counter===0&&(this.c(L,J.object),this.a.delete(L))});return J.counter++,{object:de,dispose:ae}}}t.$Zc=O;class y{constructor(L){this.a=L}async acquire(L,...X){const J=this.a.acquire(L,...X);try{return{object:await J.object,dispose:()=>J.dispose()}}catch(de){throw J.dispose(),de}}}t.$1c=y;class x{constructor(L){this.object=L}dispose(){}}t.$2c=x;function W(R){const L=new g;try{R(L)}finally{L.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,X,J=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),J||this.a.get(L)?.dispose(),this.a.set(L,X)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=T}),function(se,t){typeof define=="function"&&define.amd?define(me[82],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(c,k){for(var D=0;D<k.length;D++){var o=k[D];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(c,o.key,o)}}function i(c,k,D){return k&&t(c.prototype,k),D&&t(c,D),Object.defineProperty(c,"prototype",{writable:!1}),c}function N(c,k){if(c){if(typeof c=="string")return z(c,k);var D=Object.prototype.toString.call(c).slice(8,-1);if(D==="Object"&&c.constructor&&(D=c.constructor.name),D==="Map"||D==="Set")return Array.from(c);if(D==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(D))return z(c,k)}}function z(c,k){(k==null||k>c.length)&&(k=c.length);for(var D=0,o=new Array(k);D<k;D++)o[D]=c[D];return o}function H(c,k){var D=typeof Symbol<"u"&&c[Symbol.iterator]||c["@@iterator"];if(D)return(D=D.call(c)).next.bind(D);if(Array.isArray(c)||(D=N(c))||k&&c&&typeof c.length=="number"){D&&(c=D);var o=0;return function(){return o>=c.length?{done:!0}:{done:!1,value:c[o++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=E();function A(c){se.defaults=c}var b=/[&<>"']/,$=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(k){return f[k]};function e(c,k){if(k){if(b.test(c))return c.replace($,d)}else if(w.test(c))return c.replace(P,d);return c}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(c){return c.replace(s,function(k,D){return D=D.toLowerCase(),D==="colon"?":":D.charAt(0)==="#"?D.charAt(1)==="x"?String.fromCharCode(parseInt(D.substring(2),16)):String.fromCharCode(+D.substring(1)):""})}var m=/(^|[^\[])\^/g;function p(c,k){c=typeof c=="string"?c:c.source,k=k||"";var D={replace:function(a,n){return n=n.source||n,n=n.replace(m,"$1"),c=c.replace(a,n),D},getRegex:function(){return new RegExp(c,k)}};return D}var v=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(c,k,D){if(c){var o;try{o=decodeURIComponent(u(D)).replace(v,"").toLowerCase()}catch{return null}if(o.indexOf("javascript:")===0||o.indexOf("vbscript:")===0||o.indexOf("data:")===0)return null}k&&!l.test(D)&&(D=M(k,D));try{D=encodeURI(D).replace(/%25/g,"%")}catch{return null}return D}var r={},S=/^[^:]+:\/*[^/]*$/,C=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function M(c,k){r[" "+c]||(S.test(c)?r[" "+c]=c+"/":r[" "+c]=W(c,"/",!0)),c=r[" "+c];var D=c.indexOf(":")===-1;return k.substring(0,2)==="//"?D?k:c.replace(C,"$1")+k:k.charAt(0)==="/"?D?k:c.replace(I,"$1")+k:c+k}var O={exec:function(){}};function y(c){for(var k=1,D,o;k<arguments.length;k++){D=arguments[k];for(o in D)Object.prototype.hasOwnProperty.call(D,o)&&(c[o]=D[o])}return c}function x(c,k){var D=c.replace(/\|/g,function(n,h,F){for(var B=!1,j=h;--j>=0&&F[j]==="\\";)B=!B;return B?"|":" |"}),o=D.split(/ \|/),a=0;if(o[0].trim()||o.shift(),o.length>0&&!o[o.length-1].trim()&&o.pop(),o.length>k)o.splice(k);else for(;o.length<k;)o.push("");for(;a<o.length;a++)o[a]=o[a].trim().replace(/\\\|/g,"|");return o}function W(c,k,D){var o=c.length;if(o===0)return"";for(var a=0;a<o;){var n=c.charAt(o-a-1);if(n===k&&!D)a++;else if(n!==k&&D)a++;else break}return c.slice(0,o-a)}function T(c,k){if(c.indexOf(k[1])===-1)return-1;for(var D=c.length,o=0,a=0;a<D;a++)if(c[a]==="\\")a++;else if(c[a]===k[0])o++;else if(c[a]===k[1]&&(o--,o<0))return a;return-1}function R(c){c&&c.sanitize&&!c.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(c,k){if(k<1)return"";for(var D="";k>1;)k&1&&(D+=c),k>>=1,c+=c;return D+c}function X(c,k,D,o){var a=k.href,n=k.title?e(k.title):null,h=c[1].replace(/\\([\[\]])/g,"$1");if(c[0].charAt(0)!=="!"){o.state.inLink=!0;var F={type:"link",raw:D,href:a,title:n,text:h,tokens:o.inlineTokens(h)};return o.state.inLink=!1,F}return{type:"image",raw:D,href:a,title:n,text:e(h)}}function J(c,k){var D=c.match(/^(\s+)(?:```)/);if(D===null)return k;var o=D[1];return k.split(`
`).map(function(a){var n=a.match(/^\s+/);if(n===null)return a;var h=n[0];return h.length>=o.length?a.slice(o.length):a}).join(`
`)}var de=function(){function c(D){this.options=D||se.defaults}var k=c.prototype;return k.space=function(o){var a=this.rules.block.newline.exec(o);if(a&&a[0].length>0)return{type:"space",raw:a[0]}},k.code=function(o){var a=this.rules.block.code.exec(o);if(a){var n=a[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:a[0],codeBlockStyle:"indented",text:this.options.pedantic?n:W(n,`
`)}}},k.fences=function(o){var a=this.rules.block.fences.exec(o);if(a){var n=a[0],h=J(n,a[3]||"");return{type:"code",raw:n,lang:a[2]?a[2].trim():a[2],text:h}}},k.heading=function(o){var a=this.rules.block.heading.exec(o);if(a){var n=a[2].trim();if(/#$/.test(n)){var h=W(n,"#");(this.options.pedantic||!h||/ $/.test(h))&&(n=h.trim())}return{type:"heading",raw:a[0],depth:a[1].length,text:n,tokens:this.lexer.inline(n)}}},k.hr=function(o){var a=this.rules.block.hr.exec(o);if(a)return{type:"hr",raw:a[0]}},k.blockquote=function(o){var a=this.rules.block.blockquote.exec(o);if(a){var n=a[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:a[0],tokens:this.lexer.blockTokens(n,[]),text:n}}},k.list=function(o){var a=this.rules.block.list.exec(o);if(a){var n,h,F,B,j,V,Z,_,$e,ve,we,Me,Se=a[1].trim(),Ae=Se.length>1,Ce={type:"list",raw:"",ordered:Ae,start:Ae?+Se.slice(0,-1):"",loose:!1,items:[]};Se=Ae?"\\d{1,9}\\"+Se.slice(-1):"\\"+Se,this.options.pedantic&&(Se=Ae?Se:"[*+-]");for(var Re=new RegExp("^( {0,3}"+Se+")((?:[	 ][^\\n]*)?(?:\\n|$))");o&&(Me=!1,!(!(a=Re.exec(o))||this.rules.block.hr.test(o)));){if(n=a[0],o=o.substring(n.length),_=a[2].split(`
`,1)[0],$e=o.split(`
`,1)[0],this.options.pedantic?(B=2,we=_.trimLeft()):(B=a[2].search(/[^ ]/),B=B>4?1:B,we=_.slice(B),B+=a[1].length),V=!1,!_&&/^ *$/.test($e)&&(n+=$e+`
`,o=o.substring($e.length+1),Me=!0),!Me)for(var Xe=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),Ue=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");o&&(ve=o.split(`
`,1)[0],_=ve,this.options.pedantic&&(_=_.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(_)||Ue.test(_)||Xe.test(_)||nt.test(o)));){if(_.search(/[^ ]/)>=B||!_.trim())we+=`
`+_.slice(B);else if(!V)we+=`
`+_;else break;!V&&!_.trim()&&(V=!0),n+=ve+`
`,o=o.substring(ve.length+1)}Ce.loose||(Z?Ce.loose=!0:/\n *\n *$/.test(n)&&(Z=!0)),this.options.gfm&&(h=/^\[[ xX]\] /.exec(we),h&&(F=h[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:n,task:!!h,checked:F,loose:!1,text:we}),Ce.raw+=n}Ce.items[Ce.items.length-1].raw=n.trimRight(),Ce.items[Ce.items.length-1].text=we.trimRight(),Ce.raw=Ce.raw.trimRight();var G=Ce.items.length;for(j=0;j<G;j++){this.lexer.state.top=!1,Ce.items[j].tokens=this.lexer.blockTokens(Ce.items[j].text,[]);var ne=Ce.items[j].tokens.filter(function(De){return De.type==="space"}),pe=ne.every(function(De){for(var Le=De.raw.split(""),ze=0,Ve=H(Le),_e;!(_e=Ve()).done;){var tt=_e.value;if(tt===`
`&&(ze+=1),ze>1)return!0}return!1});!Ce.loose&&ne.length&&pe&&(Ce.loose=!0,Ce.items[j].loose=!0)}return Ce}},k.html=function(o){var a=this.rules.block.html.exec(o);if(a){var n={type:"html",raw:a[0],pre:!this.options.sanitizer&&(a[1]==="pre"||a[1]==="script"||a[1]==="style"),text:a[0]};if(this.options.sanitize){var h=this.options.sanitizer?this.options.sanitizer(a[0]):e(a[0]);n.type="paragraph",n.text=h,n.tokens=this.lexer.inline(h)}return n}},k.def=function(o){var a=this.rules.block.def.exec(o);if(a){a[3]&&(a[3]=a[3].substring(1,a[3].length-1));var n=a[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:n,raw:a[0],href:a[2],title:a[3]}}},k.table=function(o){var a=this.rules.block.table.exec(o);if(a){var n={type:"table",header:x(a[1]).map(function(Z){return{text:Z}}),align:a[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:a[3]&&a[3].trim()?a[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(n.header.length===n.align.length){n.raw=a[0];var h=n.align.length,F,B,j,V;for(F=0;F<h;F++)/^ *-+: *$/.test(n.align[F])?n.align[F]="right":/^ *:-+: *$/.test(n.align[F])?n.align[F]="center":/^ *:-+ *$/.test(n.align[F])?n.align[F]="left":n.align[F]=null;for(h=n.rows.length,F=0;F<h;F++)n.rows[F]=x(n.rows[F],n.header.length).map(function(Z){return{text:Z}});for(h=n.header.length,B=0;B<h;B++)n.header[B].tokens=this.lexer.inline(n.header[B].text);for(h=n.rows.length,B=0;B<h;B++)for(V=n.rows[B],j=0;j<V.length;j++)V[j].tokens=this.lexer.inline(V[j].text);return n}}},k.lheading=function(o){var a=this.rules.block.lheading.exec(o);if(a)return{type:"heading",raw:a[0],depth:a[2].charAt(0)==="="?1:2,text:a[1],tokens:this.lexer.inline(a[1])}},k.paragraph=function(o){var a=this.rules.block.paragraph.exec(o);if(a){var n=a[1].charAt(a[1].length-1)===`
`?a[1].slice(0,-1):a[1];return{type:"paragraph",raw:a[0],text:n,tokens:this.lexer.inline(n)}}},k.text=function(o){var a=this.rules.block.text.exec(o);if(a)return{type:"text",raw:a[0],text:a[0],tokens:this.lexer.inline(a[0])}},k.escape=function(o){var a=this.rules.inline.escape.exec(o);if(a)return{type:"escape",raw:a[0],text:e(a[1])}},k.tag=function(o){var a=this.rules.inline.tag.exec(o);if(a)return!this.lexer.state.inLink&&/^<a /i.test(a[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(a[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(a[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(a[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:a[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(a[0]):e(a[0]):a[0]}},k.link=function(o){var a=this.rules.inline.link.exec(o);if(a){var n=a[2].trim();if(!this.options.pedantic&&/^</.test(n)){if(!/>$/.test(n))return;var h=W(n.slice(0,-1),"\\");if((n.length-h.length)%2===0)return}else{var F=T(a[2],"()");if(F>-1){var B=a[0].indexOf("!")===0?5:4,j=B+a[1].length+F;a[2]=a[2].substring(0,F),a[0]=a[0].substring(0,j).trim(),a[3]=""}}var V=a[2],Z="";if(this.options.pedantic){var _=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);_&&(V=_[1],Z=_[3])}else Z=a[3]?a[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(n)?V=V.slice(1):V=V.slice(1,-1)),X(a,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},a[0],this.lexer)}},k.reflink=function(o,a){var n;if((n=this.rules.inline.reflink.exec(o))||(n=this.rules.inline.nolink.exec(o))){var h=(n[2]||n[1]).replace(/\s+/g," ");if(h=a[h.toLowerCase()],!h||!h.href){var F=n[0].charAt(0);return{type:"text",raw:F,text:F}}return X(n,h,n[0],this.lexer)}},k.emStrong=function(o,a,n){n===void 0&&(n="");var h=this.rules.inline.emStrong.lDelim.exec(o);if(h&&!(h[3]&&n.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=h[1]||h[2]||"";if(!F||F&&(n===""||this.rules.inline.punctuation.exec(n))){var B=h[0].length-1,j,V,Z=B,_=0,$e=h[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,a=a.slice(-1*o.length+B);(h=$e.exec(a))!=null;)if(j=h[1]||h[2]||h[3]||h[4]||h[5]||h[6],!!j){if(V=j.length,h[3]||h[4]){Z+=V;continue}else if((h[5]||h[6])&&B%3&&!((B+V)%3)){_+=V;continue}if(Z-=V,!(Z>0)){if(V=Math.min(V,V+Z+_),Math.min(B,V)%2){var ve=o.slice(1,B+h.index+V);return{type:"em",raw:o.slice(0,B+h.index+V+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var we=o.slice(2,B+h.index+V-1);return{type:"strong",raw:o.slice(0,B+h.index+V+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},k.codespan=function(o){var a=this.rules.inline.code.exec(o);if(a){var n=a[2].replace(/\n/g," "),h=/[^ ]/.test(n),F=/^ /.test(n)&&/ $/.test(n);return h&&F&&(n=n.substring(1,n.length-1)),n=e(n,!0),{type:"codespan",raw:a[0],text:n}}},k.br=function(o){var a=this.rules.inline.br.exec(o);if(a)return{type:"br",raw:a[0]}},k.del=function(o){var a=this.rules.inline.del.exec(o);if(a)return{type:"del",raw:a[0],text:a[2],tokens:this.lexer.inlineTokens(a[2])}},k.autolink=function(o,a){var n=this.rules.inline.autolink.exec(o);if(n){var h,F;return n[2]==="@"?(h=e(this.options.mangle?a(n[1]):n[1]),F="mailto:"+h):(h=e(n[1]),F=h),{type:"link",raw:n[0],text:h,href:F,tokens:[{type:"text",raw:h,text:h}]}}},k.url=function(o,a){var n;if(n=this.rules.inline.url.exec(o)){var h,F;if(n[2]==="@")h=e(this.options.mangle?a(n[0]):n[0]),F="mailto:"+h;else{var B;do B=n[0],n[0]=this.rules.inline._backpedal.exec(n[0])[0];while(B!==n[0]);h=e(n[0]),n[1]==="www."?F="http://"+h:F=h}return{type:"link",raw:n[0],text:h,href:F,tokens:[{type:"text",raw:h,text:h}]}}},k.inlineText=function(o,a){var n=this.rules.inline.text.exec(o);if(n){var h;return this.lexer.state.inRawBlock?h=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(n[0]):e(n[0]):n[0]:h=e(this.options.smartypants?a(n[0]):n[0]),{type:"text",raw:n[0],text:h}}},c}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=p(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=p(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=p(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=p(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=p(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=p(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=y({},ae),ae.gfm=y({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=p(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=p(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=y({},ae.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:p(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=p(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=p(ae._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=p(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=p(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=p(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=p(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=p(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=p(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=p(ie.reflink).replace("label",ie._label).replace("ref",ae._label).getRegex(),ie.nolink=p(ie.nolink).replace("ref",ae._label).getRegex(),ie.reflinkSearch=p(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=y({},ie),ie.pedantic=y({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=y({},ie.normal,{escape:p(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=p(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=y({},ie.gfm,{br:p(ie.br).replace("{2,}","*").getRegex(),text:p(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(c){return c.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Fe(c){var k="",D,o,a=c.length;for(D=0;D<a;D++)o=c.charCodeAt(D),Math.random()>.5&&(o="x"+o.toString(16)),k+="&#"+o+";";return k}var Ne=function(){function c(D){this.tokens=[],this.tokens.links=Object.create(null),this.options=D||se.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var o={block:ae.normal,inline:ie.normal};this.options.pedantic?(o.block=ae.pedantic,o.inline=ie.pedantic):this.options.gfm&&(o.block=ae.gfm,this.options.breaks?o.inline=ie.breaks:o.inline=ie.gfm),this.tokenizer.rules=o}c.lex=function(o,a){var n=new c(a);return n.lex(o)},c.lexInline=function(o,a){var n=new c(a);return n.inlineTokens(o)};var k=c.prototype;return k.lex=function(o){o=o.replace(/\r\n|\r/g,`
`),this.blockTokens(o,this.tokens);for(var a;a=this.inlineQueue.shift();)this.inlineTokens(a.src,a.tokens);return this.tokens},k.blockTokens=function(o,a){var n=this;a===void 0&&(a=[]),this.options.pedantic?o=o.replace(/\t/g,"    ").replace(/^ +$/gm,""):o=o.replace(/^( *)(\t+)/gm,function(Z,_,$e){return _+"    ".repeat($e.length)});for(var h,F,B,j;o;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(h=Z.call({lexer:n},o,a))?(o=o.substring(h.raw.length),a.push(h),!0):!1}))){if(h=this.tokenizer.space(o)){o=o.substring(h.raw.length),h.raw.length===1&&a.length>0?a[a.length-1].raw+=`
`:a.push(h);continue}if(h=this.tokenizer.code(o)){o=o.substring(h.raw.length),F=a[a.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+h.raw,F.text+=`
`+h.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):a.push(h);continue}if(h=this.tokenizer.fences(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.heading(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.hr(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.blockquote(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.list(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.html(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.def(o)){o=o.substring(h.raw.length),F=a[a.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+h.raw,F.text+=`
`+h.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[h.tag]||(this.tokens.links[h.tag]={href:h.href,title:h.title});continue}if(h=this.tokenizer.table(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.lheading(o)){o=o.substring(h.raw.length),a.push(h);continue}if(B=o,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,_=o.slice(1),$e=void 0;n.options.extensions.startBlock.forEach(function(ve){$e=ve.call({lexer:this},_),typeof $e=="number"&&$e>=0&&(Z=Math.min(Z,$e))}),Z<1/0&&Z>=0&&(B=o.substring(0,Z+1))}(),this.state.top&&(h=this.tokenizer.paragraph(B))){F=a[a.length-1],j&&F.type==="paragraph"?(F.raw+=`
`+h.raw,F.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):a.push(h),j=B.length!==o.length,o=o.substring(h.raw.length);continue}if(h=this.tokenizer.text(o)){o=o.substring(h.raw.length),F=a[a.length-1],F&&F.type==="text"?(F.raw+=`
`+h.raw,F.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):a.push(h);continue}if(o){var V="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,a},k.inline=function(o,a){return a===void 0&&(a=[]),this.inlineQueue.push({src:o,tokens:a}),a},k.inlineTokens=function(o,a){var n=this;a===void 0&&(a=[]);var h,F,B,j=o,V,Z,_;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)$e.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,V.index)+"["+L("a",V[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,V.index)+"["+L("a",V[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,V.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;o;)if(Z||(_=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(h=we.call({lexer:n},o,a))?(o=o.substring(h.raw.length),a.push(h),!0):!1}))){if(h=this.tokenizer.escape(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.tag(o)){o=o.substring(h.raw.length),F=a[a.length-1],F&&h.type==="text"&&F.type==="text"?(F.raw+=h.raw,F.text+=h.text):a.push(h);continue}if(h=this.tokenizer.link(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.reflink(o,this.tokens.links)){o=o.substring(h.raw.length),F=a[a.length-1],F&&h.type==="text"&&F.type==="text"?(F.raw+=h.raw,F.text+=h.text):a.push(h);continue}if(h=this.tokenizer.emStrong(o,j,_)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.codespan(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.br(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.del(o)){o=o.substring(h.raw.length),a.push(h);continue}if(h=this.tokenizer.autolink(o,Fe)){o=o.substring(h.raw.length),a.push(h);continue}if(!this.state.inLink&&(h=this.tokenizer.url(o,Fe))){o=o.substring(h.raw.length),a.push(h);continue}if(B=o,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Me=o.slice(1),Se=void 0;n.options.extensions.startInline.forEach(function(Ae){Se=Ae.call({lexer:this},Me),typeof Se=="number"&&Se>=0&&(we=Math.min(we,Se))}),we<1/0&&we>=0&&(B=o.substring(0,we+1))}(),h=this.tokenizer.inlineText(B,ge)){o=o.substring(h.raw.length),h.raw.slice(-1)!=="_"&&(_=h.raw.slice(-1)),Z=!0,F=a[a.length-1],F&&F.type==="text"?(F.raw+=h.raw,F.text+=h.text):a.push(h);continue}if(o){var ve="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return a},i(c,null,[{key:"rules",get:function(){return{block:ae,inline:ie}}}]),c}(),Pe=function(){function c(D){this.options=D||se.defaults}var k=c.prototype;return k.code=function(o,a,n){var h=(a||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(o,h);F!=null&&F!==o&&(n=!0,o=F)}return o=o.replace(/\n$/,"")+`
`,h?'<pre><code class="'+this.options.langPrefix+e(h,!0)+'">'+(n?o:e(o,!0))+`</code></pre>
`:"<pre><code>"+(n?o:e(o,!0))+`</code></pre>
`},k.blockquote=function(o){return`<blockquote>
`+o+`</blockquote>
`},k.html=function(o){return o},k.heading=function(o,a,n,h){if(this.options.headerIds){var F=this.options.headerPrefix+h.slug(n);return"<h"+a+' id="'+F+'">'+o+"</h"+a+`>
`}return"<h"+a+">"+o+"</h"+a+`>
`},k.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},k.list=function(o,a,n){var h=a?"ol":"ul",F=a&&n!==1?' start="'+n+'"':"";return"<"+h+F+`>
`+o+"</"+h+`>
`},k.listitem=function(o){return"<li>"+o+`</li>
`},k.checkbox=function(o){return"<input "+(o?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},k.paragraph=function(o){return"<p>"+o+`</p>
`},k.table=function(o,a){return a&&(a="<tbody>"+a+"</tbody>"),`<table>
<thead>
`+o+`</thead>
`+a+`</table>
`},k.tablerow=function(o){return`<tr>
`+o+`</tr>
`},k.tablecell=function(o,a){var n=a.header?"th":"td",h=a.align?"<"+n+' align="'+a.align+'">':"<"+n+">";return h+o+("</"+n+`>
`)},k.strong=function(o){return"<strong>"+o+"</strong>"},k.em=function(o){return"<em>"+o+"</em>"},k.codespan=function(o){return"<code>"+o+"</code>"},k.br=function(){return this.options.xhtml?"<br/>":"<br>"},k.del=function(o){return"<del>"+o+"</del>"},k.link=function(o,a,n){if(o=g(this.options.sanitize,this.options.baseUrl,o),o===null)return n;var h='<a href="'+e(o)+'"';return a&&(h+=' title="'+a+'"'),h+=">"+n+"</a>",h},k.image=function(o,a,n){if(o=g(this.options.sanitize,this.options.baseUrl,o),o===null)return n;var h='<img src="'+o+'" alt="'+n+'"';return a&&(h+=' title="'+a+'"'),h+=this.options.xhtml?"/>":">",h},k.text=function(o){return o},c}(),oe=function(){function c(){}var k=c.prototype;return k.strong=function(o){return o},k.em=function(o){return o},k.codespan=function(o){return o},k.del=function(o){return o},k.html=function(o){return o},k.text=function(o){return o},k.link=function(o,a,n){return""+n},k.image=function(o,a,n){return""+n},k.br=function(){return""},c}(),U=function(){function c(){this.seen={}}var k=c.prototype;return k.serialize=function(o){return o.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},k.getNextSafeSlug=function(o,a){var n=o,h=0;if(this.seen.hasOwnProperty(n)){h=this.seen[o];do h++,n=o+"-"+h;while(this.seen.hasOwnProperty(n))}return a||(this.seen[o]=h,this.seen[n]=0),n},k.slug=function(o,a){a===void 0&&(a={});var n=this.serialize(o);return this.getNextSafeSlug(n,a.dryrun)},c}(),le=function(){function c(D){this.options=D||se.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new oe,this.slugger=new U}c.parse=function(o,a){var n=new c(a);return n.parse(o)},c.parseInline=function(o,a){var n=new c(a);return n.parseInline(o)};var k=c.prototype;return k.parse=function(o,a){a===void 0&&(a=!0);var n="",h,F,B,j,V,Z,_,$e,ve,we,Me,Se,Ae,Ce,Re,Xe,nt,Ge,Ue,G=o.length;for(h=0;h<G;h++){if(we=o[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Ue=this.options.extensions.renderers[we.type].call({parser:this},we),Ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){n+=Ue||"";continue}switch(we.type){case"space":continue;case"hr":{n+=this.renderer.hr();continue}case"heading":{n+=this.renderer.heading(this.parseInline(we.tokens),we.depth,u(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{n+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for($e="",_="",j=we.header.length,F=0;F<j;F++)_+=this.renderer.tablecell(this.parseInline(we.header[F].tokens),{header:!0,align:we.align[F]});for($e+=this.renderer.tablerow(_),ve="",j=we.rows.length,F=0;F<j;F++){for(Z=we.rows[F],_="",V=Z.length,B=0;B<V;B++)_+=this.renderer.tablecell(this.parseInline(Z[B].tokens),{header:!1,align:we.align[B]});ve+=this.renderer.tablerow(_)}n+=this.renderer.table($e,ve);continue}case"blockquote":{ve=this.parse(we.tokens),n+=this.renderer.blockquote(ve);continue}case"list":{for(Me=we.ordered,Se=we.start,Ae=we.loose,j=we.items.length,ve="",F=0;F<j;F++)Re=we.items[F],Xe=Re.checked,nt=Re.task,Ce="",Re.task&&(Ge=this.renderer.checkbox(Xe),Ae?Re.tokens.length>0&&Re.tokens[0].type==="paragraph"?(Re.tokens[0].text=Ge+" "+Re.tokens[0].text,Re.tokens[0].tokens&&Re.tokens[0].tokens.length>0&&Re.tokens[0].tokens[0].type==="text"&&(Re.tokens[0].tokens[0].text=Ge+" "+Re.tokens[0].tokens[0].text)):Re.tokens.unshift({type:"text",text:Ge}):Ce+=Ge),Ce+=this.parse(Re.tokens,Ae),ve+=this.renderer.listitem(Ce,nt,Xe);n+=this.renderer.list(ve,Me,Se);continue}case"html":{n+=this.renderer.html(we.text);continue}case"paragraph":{n+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(ve=we.tokens?this.parseInline(we.tokens):we.text;h+1<G&&o[h+1].type==="text";)we=o[++h],ve+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);n+=a?this.renderer.paragraph(ve):ve;continue}default:{var ne='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return n},k.parseInline=function(o,a){a=a||this.renderer;var n="",h,F,B,j=o.length;for(h=0;h<j;h++){if(F=o[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(B=this.options.extensions.renderers[F.type].call({parser:this},F),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){n+=B||"";continue}switch(F.type){case"escape":{n+=a.text(F.text);break}case"html":{n+=a.html(F.text);break}case"link":{n+=a.link(F.href,F.title,this.parseInline(F.tokens,a));break}case"image":{n+=a.image(F.href,F.title,F.text);break}case"strong":{n+=a.strong(this.parseInline(F.tokens,a));break}case"em":{n+=a.em(this.parseInline(F.tokens,a));break}case"codespan":{n+=a.codespan(F.text);break}case"br":{n+=a.br();break}case"del":{n+=a.del(this.parseInline(F.tokens,a));break}case"text":{n+=a.text(F.text);break}default:{var V='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return n},c}();function re(c,k,D){if(typeof c>"u"||c===null)throw new Error("marked(): input parameter is undefined or null");if(typeof c!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(c)+", string expected");if(typeof k=="function"&&(D=k,k=null),k=y({},re.defaults,k||{}),R(k),D){var o=k.highlight,a;try{a=Ne.lex(c,k)}catch(j){return D(j)}var n=function(V){var Z;if(!V)try{k.walkTokens&&re.walkTokens(a,k.walkTokens),Z=le.parse(a,k)}catch(_){V=_}return k.highlight=o,V?D(V):D(null,Z)};if(!o||o.length<3||(delete k.highlight,!a.length))return n();var h=0;re.walkTokens(a,function(j){j.type==="code"&&(h++,setTimeout(function(){o(j.text,j.lang,function(V,Z){if(V)return n(V);Z!=null&&Z!==j.text&&(j.text=Z,j.escaped=!0),h--,h===0&&n()})},0))}),h===0&&n();return}function F(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(j.message+"",!0)+"</pre>";throw j}try{var B=Ne.lex(c,k);if(k.walkTokens){if(k.async)return Promise.all(re.walkTokens(B,k.walkTokens)).then(function(){return le.parse(B,k)}).catch(F);re.walkTokens(B,k.walkTokens)}return le.parse(B,k)}catch(j){F(j)}}re.options=re.setOptions=function(c){return y(re.defaults,c),A(re.defaults),re},re.getDefaults=E,re.defaults=se.defaults,re.use=function(){for(var c=arguments.length,k=new Array(c),D=0;D<c;D++)k[D]=arguments[D];var o=y.apply(void 0,[{}].concat(k)),a=re.defaults.extensions||{renderers:{},childTokens:{}},n;k.forEach(function(h){if(h.extensions&&(n=!0,h.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var j=a.renderers?a.renderers[B.name]:null;j?a.renderers[B.name]=function(){for(var V=arguments.length,Z=new Array(V),_=0;_<V;_++)Z[_]=arguments[_];var $e=B.renderer.apply(this,Z);return $e===!1&&($e=j.apply(this,Z)),$e}:a.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");a[B.level]?a[B.level].unshift(B.tokenizer):a[B.level]=[B.tokenizer],B.start&&(B.level==="block"?a.startBlock?a.startBlock.push(B.start):a.startBlock=[B.start]:B.level==="inline"&&(a.startInline?a.startInline.push(B.start):a.startInline=[B.start]))}B.childTokens&&(a.childTokens[B.name]=B.childTokens)})),h.renderer&&function(){var B=re.defaults.renderer||new Pe,j=function(_){var $e=B[_];B[_]=function(){for(var ve=arguments.length,we=new Array(ve),Me=0;Me<ve;Me++)we[Me]=arguments[Me];var Se=h.renderer[_].apply(B,we);return Se===!1&&(Se=$e.apply(B,we)),Se}};for(var V in h.renderer)j(V);o.renderer=B}(),h.tokenizer&&function(){var B=re.defaults.tokenizer||new de,j=function(_){var $e=B[_];B[_]=function(){for(var ve=arguments.length,we=new Array(ve),Me=0;Me<ve;Me++)we[Me]=arguments[Me];var Se=h.tokenizer[_].apply(B,we);return Se===!1&&(Se=$e.apply(B,we)),Se}};for(var V in h.tokenizer)j(V);o.tokenizer=B}(),h.walkTokens){var F=re.defaults.walkTokens;o.walkTokens=function(B){var j=[];return j.push(h.walkTokens.call(this,B)),F&&(j=j.concat(F.call(this,B))),j}}n&&(o.extensions=a),re.setOptions(o)})},re.walkTokens=function(c,k){for(var D=[],o=function(){var F=n.value;switch(D=D.concat(k.call(re,F)),F.type){case"table":{for(var B=H(F.header),j;!(j=B()).done;){var V=j.value;D=D.concat(re.walkTokens(V.tokens,k))}for(var Z=H(F.rows),_;!(_=Z()).done;)for(var $e=_.value,ve=H($e),we;!(we=ve()).done;){var Me=we.value;D=D.concat(re.walkTokens(Me.tokens,k))}break}case"list":{D=D.concat(re.walkTokens(F.items,k));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[F.type]?re.defaults.extensions.childTokens[F.type].forEach(function(Se){D=D.concat(re.walkTokens(F[Se],k))}):F.tokens&&(D=D.concat(re.walkTokens(F.tokens,k)))}},a=H(c),n;!(n=a()).done;)o();return D},re.parseInline=function(c,k){if(typeof c>"u"||c===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof c!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(c)+", string expected");k=y({},re.defaults,k||{}),R(k);try{var D=Ne.lexInline(c,k);return k.walkTokens&&re.walkTokens(D,k.walkTokens),le.parseInline(D,k)}catch(o){if(o.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(o.message+"",!0)+"</pre>";throw o}},re.Parser=le,re.parser=le.parse,re.Renderer=Pe,re.TextRenderer=oe,re.Lexer=Ne,re.lexer=Ne.lex,re.Tokenizer=de,re.Slugger=U,re.parse=re;var Y=re.options,Q=re.setOptions,te=re.use,ue=re.walkTokens,ye=re.parseInline,Te=re,Ee=le.parse,fe=Ne.lex;se.Lexer=Ne,se.Parser=le,se.Renderer=Pe,se.Slugger=U,se.TextRenderer=oe,se.Tokenizer=de,se.getDefaults=E,se.lexer=fe,se.marked=re,se.options=Y,se.parse=Te,se.parseInline=ye,se.parser=Ee,se.setOptions=Q,se.use=te,se.walkTokens=ue,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[83],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gk=i;function i(s){const u=H(s);if(u&&u.length>0)return new Uint32Array(u)}let N=0;const z=new Uint32Array(10);function H(s){if(N=0,E(s,P,4352),N>0||(E(s,f,4449),N>0)||(E(s,d,4520),N>0)||(E(s,e,12593),N))return z.subarray(0,N);if(s>=44032&&s<=55203){const u=s-44032,m=u%588,p=Math.floor(u/588),v=Math.floor(m/28),l=m%28-1;if(p<P.length?E(p,P,0):4352+p-12593<e.length&&E(4352+p,e,12593),v<f.length?E(v,f,0):4449+v-12593<e.length&&E(4449+v-12593,e,12593),l>=0&&(l<d.length?E(l,d,0):4520+l-12593<e.length&&E(4520+l-12593,e,12593)),N>0)return z.subarray(0,N)}}function E(s,u,m){s>=m&&s<m+u.length&&A(u[s-m])}function A(s){s!==0&&(z[N++]=s&255,s>>8&&(z[N++]=s>>8&255),s>>16&&(z[N++]=s>>16&255))}var b;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var $;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})($||($={}));var w;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(w||(w={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),f=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),d=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[84],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vU=void 0;class i{constructor(z,H=0,E=z.length,A=H-1){this.a=z,this.b=H,this.c=E,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$vU=i}),define(me[85],be([1,0,84]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.$wU=void 0;class N{constructor(E=[],A=10){this.h(E),this.b=A,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new i.$vU(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const A of E)this.a.add(A)}get j(){const E=[];return this.a.forEach(A=>E.push(A)),E}}t.$wU=N;class z{get size(){return this.f}constructor(E,A=10){if(this.g=A,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let b=1;b<E.length;b++)this.add(E[b])}add(E){const A={value:E,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const A=this.c.value;return this.a.delete(A),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),A}prepend(E){if(this.f===this.g||this.a.has(E))return;const A={value:E,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let A=this.b;for(;A!==this.c;)A.value===E&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$xU=z}),define(me[35],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qm=t.$pm=t.$om=void 0,t.$mm=i,t.rot=N;function i(A,b,$){return Math.min(Math.max(A,b),$)}function N(A,b){return(b+A%b)%b}class z{constructor(){this.a=0}getNext(){return this.a++}}t.$om=z;class H{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$pm=H;class E{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const $=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$qm=E}),define(me[50],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(N){function z(b,$){if(b.start>=$.end||$.start>=b.end)return{start:0,end:0};const w=Math.max(b.start,$.start),P=Math.min(b.end,$.end);return P-w<=0?{start:0,end:0}:{start:w,end:P}}N.intersect=z;function H(b){return b.end-b.start<=0}N.isEmpty=H;function E(b,$){return!H(z(b,$))}N.intersects=E;function A(b,$){const w=[],P={start:b.start,end:Math.min($.start,b.end)},f={start:Math.max($.end,b.start),end:b.end};return H(P)||w.push(P),H(f)||w.push(f),w}N.relativeComplement=A})(i||(t.Range=i={}))}),define(me[86],be([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=void 0,t.$bT=N,t.$cT=z,t.$dT=H;function N(b,$){const w=[];for(const P of $){if(b.start>=P.range.end)continue;if(b.end<P.range.start)break;const f=i.Range.intersect(b,P.range);i.Range.isEmpty(f)||w.push({range:f,size:P.size})}return w}function z({start:b,end:$},w){return{start:b+w,end:$+w}}function H(b){const $=[];let w=null;for(const P of b){const f=P.range.start,d=P.range.end,e=P.size;if(w&&e===w.size){w.range.end=d;continue}w={range:{start:f,end:d},size:e},$.push(w)}return $}function E(...b){return H(b.reduce(($,w)=>$.concat(w),[]))}class A{get paddingTop(){return this.c}set paddingTop($){this.b=this.b+$-this.c,this.c=$}constructor($){this.a=[],this.b=0,this.c=0,this.c=$??0,this.b=this.c}splice($,w,P=[]){const f=P.length-w,d=N({start:0,end:$},this.a),e=N({start:$+w,end:Number.POSITIVE_INFINITY},this.a).map(u=>({range:z(u.range,f),size:u.size})),s=P.map((u,m)=>({range:{start:$+m,end:$+m+1},size:u.size}));this.a=E(d,s,e),this.b=this.c+this.a.reduce((u,m)=>u+m.size*(m.range.end-m.range.start),0)}get count(){const $=this.a.length;return $?this.a[$-1].range.end:0}get size(){return this.b}indexAt($){if($<0)return-1;if($<this.c)return 0;let w=0,P=this.c;for(const f of this.a){const d=f.range.end-f.range.start,e=P+d*f.size;if($<e)return w+Math.floor(($-P)/f.size);w+=d,P=e}return w}indexAfter($){return Math.min(this.indexAt($)+1,this.count)}positionAt($){if($<0)return-1;let w=0,P=0;for(const f of this.a){const d=f.range.end-f.range.start,e=P+d;if($<e)return this.c+w+($-P)*f.size;w+=d*f.size,P=e}return-1}}t.$eT=A}),define(me[87],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(H){return new N(H)}constructor(H){this.c=i&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3d=N}),define(me[4],be([1,0,6,47,3,49,87]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$5d=t.Event=void 0,t.$6d=f;const A=!1,b=!1;var $;(function(W){W.None=()=>z.$Uc.None;function T(o){if(b){const{onDidAddListener:a}=o,n=e.create();let h=0;o.onDidAddListener=()=>{++h===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),n.print()),a?.()}}}function R(o,a){return Pe(o,()=>{},0,void 0,!0,void 0,a)}W.defer=R;function L(o){return(a,n=null,h)=>{let F=!1,B;return B=o(j=>{if(!F)return B?B.dispose():F=!0,a.call(n,j)},null,h),F&&B.dispose(),B}}W.once=L;function X(o,a,n){return Fe((h,F=null,B)=>o(j=>h.call(F,a(j)),null,B),n)}W.map=X;function J(o,a,n){return Fe((h,F=null,B)=>o(j=>{a(j),h.call(F,j)},null,B),n)}W.forEach=J;function de(o,a,n){return Fe((h,F=null,B)=>o(j=>a(j)&&h.call(F,j),null,B),n)}W.filter=de;function ae(o){return o}W.signal=ae;function ie(...o){return(a,n=null,h)=>{const F=(0,z.$Rc)(...o.map(B=>B(j=>a.call(n,j))));return Ne(F,h)}}W.any=ie;function ge(o,a,n,h){let F=n;return X(o,B=>(F=a(F,B),F),h)}W.reduce=ge;function Fe(o,a){let n;const h={onWillAddFirstListener(){n=o(F.fire,F)},onDidRemoveLastListener(){n?.dispose()}};a||T(h);const F=new v(h);return a?.add(F),F.event}function Ne(o,a){return a instanceof Array?a.push(o):a&&a.add(o),o}function Pe(o,a,n=100,h=!1,F=!1,B,j){let V,Z,_,$e=0,ve;const we={leakWarningThreshold:B,onWillAddFirstListener(){V=o(Se=>{$e++,Z=a(Z,Se),h&&!_&&(Me.fire(Z),Z=void 0),ve=()=>{const Ae=Z;Z=void 0,_=void 0,(!h||$e>1)&&Me.fire(Ae),$e=0},typeof n=="number"?(clearTimeout(_),_=setTimeout(ve,n)):_===void 0&&(_=0,queueMicrotask(ve))})},onWillRemoveListener(){F&&$e>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,V.dispose()}};j||T(we);const Me=new v(we);return j?.add(Me),Me.event}W.debounce=Pe;function oe(o,a=0,n){return W.debounce(o,(h,F)=>h?(h.push(F),h):[F],a,void 0,!0,void 0,n)}W.accumulate=oe;function U(o,a=(h,F)=>h===F,n){let h=!0,F;return de(o,B=>{const j=h||!a(B,F);return h=!1,F=B,j},n)}W.latch=U;function le(o,a,n){return[W.filter(o,a,n),W.filter(o,h=>!a(h),n)]}W.split=le;function re(o,a=!1,n=[],h){let F=n.slice(),B=o(Z=>{F?F.push(Z):V.fire(Z)});h&&h.add(B);const j=()=>{F?.forEach(Z=>V.fire(Z)),F=null},V=new v({onWillAddFirstListener(){B||(B=o(Z=>V.fire(Z)),h&&h.add(B))},onDidAddFirstListener(){F&&(a?setTimeout(j):j())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return h&&h.add(V),V.event}W.buffer=re;function Y(o,a){return(h,F,B)=>{const j=a(new te);return o(function(V){const Z=j.evaluate(V);Z!==Q&&h.call(F,Z)},void 0,B)}}W.chain=Y;const Q=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(a){return this.f.push(a),this}forEach(a){return this.f.push(n=>(a(n),n)),this}filter(a){return this.f.push(n=>a(n)?n:Q),this}reduce(a,n){let h=n;return this.f.push(F=>(h=a(h,F),h)),this}latch(a=(n,h)=>n===h){let n=!0,h;return this.f.push(F=>{const B=n||!a(F,h);return n=!1,h=F,B?F:Q}),this}evaluate(a){for(const n of this.f)if(a=n(a),a===Q)break;return a}}function ue(o,a,n=h=>h){const h=(...V)=>j.fire(n(...V)),F=()=>o.on(a,h),B=()=>o.removeListener(a,h),j=new v({onWillAddFirstListener:F,onDidRemoveLastListener:B});return j.event}W.fromNodeEventEmitter=ue;function ye(o,a,n=h=>h){const h=(...V)=>j.fire(n(...V)),F=()=>o.addEventListener(a,h),B=()=>o.removeEventListener(a,h),j=new v({onWillAddFirstListener:F,onDidRemoveLastListener:B});return j.event}W.fromDOMEventEmitter=ye;function Te(o){return new Promise(a=>L(o)(a))}W.toPromise=Te;function Ee(o){const a=new v;return o.then(n=>{a.fire(n)},()=>{a.fire(void 0)}).finally(()=>{a.dispose()}),a.event}W.fromPromise=Ee;function fe(o,a,n){return a(n),o(h=>a(h))}W.runAndSubscribe=fe;class c{constructor(a,n){this._observable=a,this.f=0,this.g=!1;const h={onWillAddFirstListener:()=>{a.addObserver(this)},onDidRemoveLastListener:()=>{a.removeObserver(this)}};n||T(h),this.emitter=new v(h),n&&n.add(this.emitter)}beginUpdate(a){this.f++}handlePossibleChange(a){}handleChange(a,n){this.g=!0}endUpdate(a){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function k(o,a){return new c(o,a).emitter.event}W.fromObservable=k;function D(o){return(a,n,h)=>{let F=0,B=!1;const j={beginUpdate(){F++},endUpdate(){F--,F===0&&(o.reportChanges(),B&&(B=!1,a.call(n)))},handlePossibleChange(){},handleChange(){B=!0}};o.addObserver(j),o.reportChanges();const V={dispose(){o.removeObserver(j)}};return h instanceof z.$Tc?h.add(V):Array.isArray(h)&&h.push(V),V}}W.fromObservableLight=D})($||(t.Event=$={}));class w{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${w.f++}`,w.all.add(this)}start(T){this.g=new E.$3d,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}t.$5d=w;let P=-1;function f(W){const T=P;return P=W,{dispose(){P=T}}}class d{constructor(T,R=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=R,this.g=0}dispose(){this.f?.clear()}check(T,R){const L=this.threshold;if(L<=0||R<L)return;this.f||(this.f=new Map);const X=this.f.get(T.value)||0;if(this.f.set(T.value,X+1),this.g-=1,this.g<=0){this.g=L*.5;let J,de=0;for(const[ae,ie]of this.f)(!J||de<ie)&&(J=ae,de=ie);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${de}):`),console.warn(J)}return()=>{const J=this.f.get(T.value)||0;this.f.set(T.value,J-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class u{constructor(T){this.value=T,this.id=s++}}const m=2,p=(W,T)=>{if(W instanceof u)T(W);else for(let R=0;R<W.length;R++){const L=W[R];L&&T(L)}};class v{constructor(T){this.w=0,this.f=T,this.g=P>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(A){const T=this.t;queueMicrotask(()=>{p(T,R=>R.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,R,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),z.$Uc.None;if(this.m)return z.$Uc.None;R&&(T=T.bind(R));const X=new u(T);let J,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),J=this.g.check(X.stack,this.w+1)),A&&(X.stack=de??e.create()),this.t?this.t instanceof u?(this.u??=new g,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const ae=(0,z.$Sc)(()=>{J?.(),this.x(X)});return L instanceof z.$Tc?L.add(ae):Array.isArray(L)&&L.push(ae),ae},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const R=this.t,L=R.indexOf(T);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,R[L]=void 0;const X=this.u.current===this;if(this.w*m<=R.length){let J=0;for(let de=0;de<R.length;de++)R[de]?R[J++]=R[de]:X&&(this.u.end--,J<this.u.i&&this.u.i--);R.length=J}}y(T,R){if(!T)return;const L=this.f?.onListenerError||i.$1;if(!L){T.value(R);return}try{T.value(R)}catch(X){L(X)}}z(T){const R=T.current.t;for(;T.i<T.end;)this.y(R[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,T);else{const R=this.u;R.enqueue(this,T,this.t.length),this.z(R)}this.j?.stop()}hasListeners(){return this.w>0}}t.$7d=v;const l=()=>new g;t.$8d=l;class g{constructor(){this.i=-1,this.end=0}enqueue(T,R,L){this.i=0,this.end=L,this.current=T,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends v{async fireAsync(T,R,L){if(this.t)for(this.h||(this.h=new H.$5c),p(this.t,X=>this.h.push([X.value,T]));this.h.size>0&&!R.isCancellationRequested;){const[X,J]=this.h.shift(),de=[],ae={...J,token:R,waitUntil:ie=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");L&&(ie=L(ie,X)),de.push(ie)}};try{X(ae)}catch(ie){(0,i.$1)(ie);continue}Object.freeze(de),await Promise.allSettled(de).then(ie=>{for(const ge of ie)ge.status==="rejected"&&(0,i.$1)(ge.reason)})}}}t.$9d=r;class S extends v{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new H.$5c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}t.$0d=S;class C extends S{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}t.$$d=C;class I extends v{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(R=>super.fire(R)),this.h=[]}))}}t.$_d=I;class M{constructor(){this.g=!1,this.h=[],this.f=new v({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const R={event:T,listener:null};this.h.push(R),this.g&&this.m(R);const L=()=>{this.g&&this.o(R);const X=this.h.indexOf(R);this.h.splice(X,1)};return(0,z.$Sc)((0,N.$db)(L))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(R=>this.f.fire(R))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}t.$ae=M;class O{constructor(T,R,L,X){this.f=new z.$Tc;const J=this.f.add(new M),de=this.f.add(new z.$4c);function ae(ie){de.set(ie,J.add(X(ie)))}for(const ie of T)ae(ie);this.f.add(R(ie=>{ae(ie)})),this.f.add(L(ie=>{de.deleteAndDispose(ie)})),this.event=J.event}dispose(){this.f.dispose()}}t.$be=O;class y{constructor(){this.f=[]}wrapEvent(T){return(R,L,X)=>T(J=>{const de=this.f[this.f.length-1];de?de.push(()=>R.call(L,J)):R.call(L,J)},void 0,X)}bufferEvents(T){const R=[];this.f.push(R);const L=T();return this.f.pop(),R.forEach(X=>X()),L}}t.$ce=y;class x{constructor(){this.f=!1,this.g=$.None,this.h=z.$Uc.None,this.j=new v({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$de=x}),define(me[17],be([1,0,22,4]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$EQ=void 0,t.$BQ=H,t.$CQ=E,t.$DQ=A,t.$FQ=b,t.$GQ=$,t.$HQ=w,t.$IQ=P,t.$RQ=e,t.$SQ=s;class z{constructor(){this.a=new Map,this.b=new N.$7d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new N.$7d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new z}getZoomLevel(m){return this.a.get(this.f(m))??0}setZoomLevel(m,p){if(this.getZoomLevel(p)===m)return;const v=this.f(p);this.a.set(v,m),this.b.fire(v)}getZoomFactor(m){return this.c.get(this.f(m))??1}setZoomFactor(m,p){this.c.set(this.f(p),m)}setFullscreen(m,p){if(this.isFullscreen(p)===m)return;const v=this.f(p);this.e.set(v,m),this.d.fire(v)}isFullscreen(m){return!!this.e.get(this.f(m))}f(m){return m.vscodeWindowId}}function H(u,m,p){typeof m=="string"&&(m=u.matchMedia(m)),m.addEventListener("change",p)}function E(u,m){z.INSTANCE.setZoomLevel(u,m)}function A(u){return z.INSTANCE.getZoomLevel(u)}t.$EQ=z.INSTANCE.onDidChangeZoomLevel;function b(u){return z.INSTANCE.getZoomFactor(u)}function $(u,m){z.INSTANCE.setZoomFactor(u,m)}function w(u,m){z.INSTANCE.setFullscreen(u,m)}function P(u){return z.INSTANCE.isFullscreen(u)}t.$JQ=z.INSTANCE.onDidChangeFullscreen;const f=navigator.userAgent;t.$KQ=f.indexOf("Firefox")>=0,t.$LQ=f.indexOf("AppleWebKit")>=0,t.$MQ=f.indexOf("Chrome")>=0,t.$NQ=!t.$MQ&&f.indexOf("Safari")>=0,t.$OQ=!t.$MQ&&!t.$NQ&&t.$LQ,t.$PQ=f.indexOf("Electron/")>=0,t.$QQ=f.indexOf("Android")>=0;let d=!1;if(typeof i.$xQ.matchMedia=="function"){const u=i.$xQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),m=i.$xQ.matchMedia("(display-mode: fullscreen)");d=u.matches,H(i.$xQ,u,({matches:p})=>{d&&m.matches||(d=p)})}function e(){return d}function s(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9S=void 0;class N{get event(){return this.a.event}constructor(H,E,A){const b=$=>this.a.fire($);this.a=new i.$7d({onWillAddFirstListener:()=>H.addEventListener(E,b,A),onDidRemoveLastListener:()=>H.removeEventListener(E,b,A)})}dispose(){this.a.dispose()}}t.$9S=N}),define(me[30],be([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.CancellationToken=void 0;const N=Object.freeze(function(A,b){const $=setTimeout(A.bind(b),0);return{dispose(){clearTimeout($)}}});var z;(function(A){function b($){return $===A.None||$===A.Cancelled||$ instanceof H?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}A.isCancellationToken=b,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(z||(t.CancellationToken=z={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new i.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=z.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=z.None}}t.$ee=E}),define(me[88],be([1,0,30]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.$Pe=void 0;class N{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new i.$ee,b=this.b(A.token);return this.a={promise:b,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.$Pe=N;class z{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const b=JSON.stringify(A);return this.b!==b&&(this.b=b,this.a=this.c(A)),this.a}}t.$Qe=z;class H{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const b=this.b(A);return this.a.set(A,b),b}}t.$Re=H}),define(me[51],be([1,0,4,3]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fs=t.$Es=t.$Ds=t.$Cs=t.ScrollbarVisibility=void 0;var z;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(z||(t.ScrollbarVisibility=z={}));class H{constructor(e,s,u,m,p,v,l){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,u=u|0,m=m|0,p=p|0,v=v|0,l=l|0),this.rawScrollLeft=m,this.rawScrollTop=l,s<0&&(s=0),m+s>u&&(m=u-s),m<0&&(m=0),p<0&&(p=0),l+p>v&&(l=v-p),l<0&&(l=0),this.width=s,this.scrollWidth=u,this.scrollLeft=m,this.height=p,this.scrollHeight=v,this.scrollTop=l}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const u=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,p=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,l=this.scrollHeight!==e.scrollHeight,g=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:u,scrollWidthChanged:m,scrollLeftChanged:p,heightChanged:v,scrollHeightChanged:l,scrollTopChanged:g}}}t.$Cs=H;class E extends N.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$7d),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const u=this.g.withScrollDimensions(e,s);this.n(u,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const u=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===u.scrollLeft&&this.h.to.scrollTop===u.scrollTop)return;let m;s?m=new w(this.h.from,u,this.h.startTime,this.h.duration):m=this.h.combine(this.g,u,this.c),this.h.dispose(),this.h=m}else{const u=this.g.withScrollPosition(e);this.h=w.start(this.g,u,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const u=this.g;u.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(u,s)))}}t.$Ds=E;class A{constructor(e,s,u){this.scrollLeft=e,this.scrollTop=s,this.isDone=u}}t.$Es=A;function b(d,e){const s=e-d;return function(u){return d+s*f(u)}}function $(d,e,s){return function(u){return u<s?d(u/s):e((u-s)/(1-s))}}class w{constructor(e,s,u,m){this.from=e,this.to=s,this.duration=m,this.startTime=u,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,u){if(Math.abs(e-s)>2.5*u){let p,v;return e<s?(p=e+.75*u,v=s-.75*u):(p=e-.75*u,v=s+.75*u),$(b(e,p),b(v,s),.33)}return b(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const u=this.c(s),m=this.d(s);return new A(u,m,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,u){return w.start(e,s,u)}static start(e,s,u){u=u+10;const m=Date.now()-10;return new w(e,s,m,u)}}t.$Fs=w;function P(d){return Math.pow(d,3)}function f(d){return 1-P(1-d)}}),define(me[89],be([1,0,6,3]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=z,t.$ge=H,t.$he=E,t.$ie=A,t.$je=$,t.$ke=w,t.$le=P,t.$me=f,t.$ne=d,t.$oe=e,t.$pe=s,t.$qe=u,t.$re=m,t.$se=p,t.$te=v;function z(l){const g=l;return g?typeof g.read=="function":!1}function H(l){const g=l;return g?[g.on,g.pause,g.resume,g.destroy].every(r=>typeof r=="function"):!1}function E(l){const g=l;return g?H(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function A(l,g){return new b(l,g)}class b{constructor(g,r){this.e=g,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(r=>r(g))}h(g){this.c.error.length===0?(0,i.$1)(g):this.c.error.slice(0).forEach(r=>r(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,r){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(g,r){if(this.a.destroyed)return;let S;switch(g){case"data":S=this.c.data;break;case"end":S=this.c.end;break;case"error":S=this.c.error;break}if(S){const C=S.indexOf(r);C>=0&&S.splice(C,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(S=>S())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(l,g){const r=[];let S;for(;(S=l.read())!==null;)r.push(S);return g(r)}function w(l,g,r){const S=[];let C;for(;(C=l.read())!==null&&S.length<r;)S.push(C);return C===null&&S.length>0?g(S):{read:()=>{if(S.length>0)return S.shift();if(typeof C<"u"){const I=C;return C=void 0,I}return l.read()}}}function P(l,g){return new Promise((r,S)=>{const C=[];f(l,{onData:I=>{g&&C.push(I)},onError:I=>{g?S(I):r(void 0)},onEnd:()=>{r(g?g(C):void 0)}})})}function f(l,g,r){l.on("error",S=>{r?.isCancellationRequested||g.onError(S)}),l.on("end",()=>{r?.isCancellationRequested||g.onEnd()}),l.on("data",S=>{r?.isCancellationRequested||g.onData(S)})}function d(l,g){return new Promise((r,S)=>{const C=new N.$Tc,I=[],M=x=>{if(I.push(x),I.length>g)return C.dispose(),l.pause(),r({stream:l,buffer:I,ended:!1})},O=x=>(C.dispose(),S(x)),y=()=>(C.dispose(),r({stream:l,buffer:I,ended:!0}));C.add((0,N.$Sc)(()=>l.removeListener("error",O))),l.on("error",O),C.add((0,N.$Sc)(()=>l.removeListener("end",y))),l.on("end",y),C.add((0,N.$Sc)(()=>l.removeListener("data",M))),l.on("data",M)})}function e(l,g){const r=A(g);return r.end(l),r}function s(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}function u(l){let g=!1;return{read:()=>g?null:(g=!0,l)}}function m(l,g,r){const S=A(r);return f(l,{onData:C=>S.write(g.data(C)),onError:C=>S.error(g.error?g.error(C):C),onEnd:()=>S.end()}),S}function p(l,g,r){let S=!1;return{read:()=>{const C=g.read();return S?C:(S=!0,C!==null?r([l,C]):l)}}}function v(l,g,r){let S=!1;const C=A(r);return f(g,{onData:I=>S?C.write(I):(S=!0,C.write(r([l,I]))),onError:I=>C.error(I),onEnd:()=>{S||(S=!0,C.write(l)),C.end()}}),C}}),define(me[36],be([1,0,23,89]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=void 0,t.$ve=$,t.$we=w,t.$xe=P,t.$ye=f,t.$ze=d,t.$Ae=e,t.$Be=s,t.$Ce=u,t.$De=m,t.$Ee=p,t.$Fe=v,t.$Ge=l,t.$He=g,t.$Ie=r,t.$Je=S,t.$Ke=C,t.$Le=I,t.$Me=M,t.$Ne=O,t.$Oe=W;const z=typeof Buffer<"u",H=new i.$V(()=>new Uint8Array(256));let E,A;class b{static alloc(R){return z?new b(Buffer.allocUnsafe(R)):new b(new Uint8Array(R))}static wrap(R){return z&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new b(R)}static fromString(R,L){return!(L?.dontUseNodeBuffer||!1)&&z?new b(Buffer.from(R)):(E||(E=new TextEncoder),new b(E.encode(R)))}static fromByteArray(R){const L=b.alloc(R.length);for(let X=0,J=R.length;X<J;X++)L.buffer[X]=R[X];return L}static concat(R,L){if(typeof L>"u"){L=0;for(let de=0,ae=R.length;de<ae;de++)L+=R[de].byteLength}const X=b.alloc(L);let J=0;for(let de=0,ae=R.length;de<ae;de++){const ie=R[de];X.set(ie,J),J+=ie.byteLength}return X}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=b.alloc(this.byteLength);return R.set(this),R}toString(){return z?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(R,L){return new b(this.buffer.subarray(R,L))}set(R,L){if(R instanceof b)this.buffer.set(R.buffer,L);else if(R instanceof Uint8Array)this.buffer.set(R,L);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),L);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return f(this.buffer,R)}writeUInt32BE(R,L){d(this.buffer,R,L)}readUInt32LE(R){return e(this.buffer,R)}writeUInt32LE(R,L){s(this.buffer,R,L)}readUInt8(R){return u(this.buffer,R)}writeUInt8(R,L){m(this.buffer,R,L)}indexOf(R,L=0){return $(this.buffer,R instanceof b?R.buffer:R,L)}}t.$ue=b;function $(T,R,L=0){const X=R.byteLength,J=T.byteLength;if(X===0)return 0;if(X===1)return T.indexOf(R[0]);if(X>J-L)return-1;const de=H.value;de.fill(R.length);for(let Fe=0;Fe<R.length;Fe++)de[R[Fe]]=R.length-Fe-1;let ae=L+R.length-1,ie=ae,ge=-1;for(;ae<J;)if(T[ae]===R[ie]){if(ie===0){ge=ae;break}ae--,ie--}else ae+=Math.max(R.length-ie,de[T[ae]]),ie=R.length-1;return ge}function w(T,R){return T[R+0]<<0>>>0|T[R+1]<<8>>>0}function P(T,R,L){T[L+0]=R&255,R=R>>>8,T[L+1]=R&255}function f(T,R){return T[R]*2**24+T[R+1]*2**16+T[R+2]*2**8+T[R+3]}function d(T,R,L){T[L+3]=R,R=R>>>8,T[L+2]=R,R=R>>>8,T[L+1]=R,R=R>>>8,T[L]=R}function e(T,R){return T[R+0]<<0>>>0|T[R+1]<<8>>>0|T[R+2]<<16>>>0|T[R+3]<<24>>>0}function s(T,R,L){T[L+0]=R&255,R=R>>>8,T[L+1]=R&255,R=R>>>8,T[L+2]=R&255,R=R>>>8,T[L+3]=R&255}function u(T,R){return T[R]}function m(T,R,L){T[L]=R}function p(T){return N.$je(T,R=>b.concat(R))}function v(T){return N.$qe(T)}function l(T){return N.$le(T,R=>b.concat(R))}async function g(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await l(T.stream)])}function r(T){return N.$oe(T,R=>b.concat(R))}function S(T){return N.$re(T,{data:R=>typeof R=="string"?b.fromString(R):b.wrap(R)},R=>b.concat(R))}function C(T){return N.$ie(R=>b.concat(R),T)}function I(T,R){return N.$se(T,R,L=>b.concat(L))}function M(T,R){return N.$te(T,R,L=>b.concat(L))}function O(T){let R=0,L=0,X=0;const J=new Uint8Array(Math.floor(T.length/4*3)),de=ie=>{switch(L){case 3:J[X++]=R|ie,L=0;break;case 2:J[X++]=R|ie>>>2,R=ie<<6,L=3;break;case 1:J[X++]=R|ie>>>4,R=ie<<4,L=2;break;default:R=ie<<2,L=1}};for(let ie=0;ie<T.length;ie++){const ge=T.charCodeAt(ie);if(ge>=65&&ge<=90)de(ge-65);else if(ge>=97&&ge<=122)de(ge-97+26);else if(ge>=48&&ge<=57)de(ge-48+52);else if(ge===43||ge===45)de(62);else if(ge===47||ge===95)de(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ie]}`)}}const ae=X;for(;L>0;)de(0);return b.wrap(J).slice(0,ae)}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",x="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:T},R=!0,L=!1){const X=L?x:y;let J="";const de=T.byteLength%3;let ae=0;for(;ae<T.byteLength-de;ae+=3){const ie=T[ae+0],ge=T[ae+1],Fe=T[ae+2];J+=X[ie>>>2],J+=X[(ie<<4|ge>>>4)&63],J+=X[(ge<<2|Fe>>>6)&63],J+=X[Fe&63]}if(de===1){const ie=T[ae+0];J+=X[ie>>>2],J+=X[ie<<4&63],R&&(J+="==")}else if(de===2){const ie=T[ae+0],ge=T[ae+1];J+=X[ie>>>2],J+=X[(ie<<4|ge>>>4)&63],J+=X[ge<<2&63],R&&(J+="=")}return J}}),define(me[10],be([1,0,88,23]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tf=t.$Sf=t.$Rf=t.GraphemeBreakType=t.$Hf=t.$Bf=t.$uf=t.$tf=void 0,t.$Ue=z,t.$Ve=E,t.$We=b,t.$Xe=$,t.$Ye=w,t.$Ze=P,t.$1e=f,t.$2e=d,t.$3e=e,t.$4e=s,t.$5e=u,t.$6e=m,t.$7e=p,t.$8e=v,t.$9e=l,t.$0e=g,t.$$e=r,t.$_e=S,t.$af=C,t.$bf=I,t.$cf=M,t.$df=O,t.$ef=y,t.$ff=x,t.$gf=W,t.$hf=T,t.$if=R,t.$jf=L,t.$kf=X,t.$lf=J,t.$mf=de,t.$nf=ae,t.$of=ie,t.$pf=ge,t.$qf=Fe,t.$rf=Ne,t.$sf=Pe,t.$vf=re,t.$wf=Y,t.$xf=Q,t.$yf=te,t.$zf=Te,t.$Af=fe,t.$Cf=c,t.$Df=k,t.$Ef=D,t.$Ff=o,t.$Gf=h,t.$If=F,t.$Jf=B,t.$Kf=j,t.$Lf=V,t.$Mf=Z,t.$Nf=_,t.$Of=$e,t.$Pf=ve,t.$Qf=Ce;function z(G){return!G||typeof G!="string"?!0:G.trim().length===0}const H=/{(\d+)}/g;function E(G,...ne){return ne.length===0?G:G.replace(H,function(pe,De){const Le=parseInt(De,10);return isNaN(Le)||Le<0||Le>=ne.length?pe:ne[Le]})}const A=/{([^}]+)}/g;function b(G,ne){return Object.keys(ne).length===0?G:G.replace(A,(pe,De)=>ne[De]??pe)}function $(G){return G.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function w(G){return G.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function P(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(G,ne){let pe=0;const De=ne.charCodeAt(0);for(let Le=G.length-1;Le>=0;Le--)G.charCodeAt(Le)===De&&pe++;return pe}function d(G,ne,pe="\u2026"){return G.length<=ne?G:`${G.substr(0,ne)}${pe}`}function e(G,ne,pe="\u2026"){if(G.length<=ne)return G;const De=Math.ceil(ne/2)-pe.length/2,Le=Math.floor(ne/2)-pe.length/2;return`${G.substr(0,De)}${pe}${G.substr(G.length-Le)}`}function s(G,ne=" "){const pe=u(G,ne);return m(pe,ne)}function u(G,ne){if(!G||!ne)return G;const pe=ne.length;if(pe===0||G.length===0)return G;let De=0;for(;G.indexOf(ne,De)===De;)De=De+pe;return G.substring(De)}function m(G,ne){if(!G||!ne)return G;const pe=ne.length,De=G.length;if(pe===0||De===0)return G;let Le=De,ze=-1;for(;ze=G.lastIndexOf(ne,Le-1),!(ze===-1||ze+pe!==Le);){if(ze===0)return"";Le=ze}return G.substring(0,Le)}function p(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(G){return G.replace(/\*/g,"")}function l(G,ne,pe={}){if(!G)throw new Error("Cannot create regex from empty string");ne||(G=P(G)),pe.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(G,De)}function g(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}function r(G){return G.split(/\r\n|\r|\n/)}function S(G){const ne=[],pe=G.split(/(\r\n|\r|\n)/);for(let De=0;De<Math.ceil(pe.length/2);De++)ne.push(pe[2*De]+(pe[2*De+1]??""));return ne}function C(G){for(let ne=0,pe=G.length;ne<pe;ne++){const De=G.charCodeAt(ne);if(De!==32&&De!==9)return ne}return-1}function I(G,ne=0,pe=G.length){for(let De=ne;De<pe;De++){const Le=G.charCodeAt(De);if(Le!==32&&Le!==9)return G.substring(ne,De)}return G.substring(ne,pe)}function M(G,ne=G.length-1){for(let pe=ne;pe>=0;pe--){const De=G.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}function O(G,ne,pe){const De=[];let Le=0;for(const ze of G.matchAll(ne)){if(De.push(G.slice(Le,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Le=ze.index+ze[0].length,De.push(pe(ze[0],...ze.slice(1),ze.index,G,ze.groups))}return De.push(G.slice(Le)),Promise.all(De).then(ze=>ze.join(""))}function y(G,ne){return G<ne?-1:G>ne?1:0}function x(G,ne,pe=0,De=G.length,Le=0,ze=ne.length){for(;pe<De&&Le<ze;pe++,Le++){const tt=G.charCodeAt(pe),st=ne.charCodeAt(Le);if(tt<st)return-1;if(tt>st)return 1}const Ve=De-pe,_e=ze-Le;return Ve<_e?-1:Ve>_e?1:0}function W(G,ne){return T(G,ne,0,G.length,0,ne.length)}function T(G,ne,pe=0,De=G.length,Le=0,ze=ne.length){for(;pe<De&&Le<ze;pe++,Le++){let tt=G.charCodeAt(pe),st=ne.charCodeAt(Le);if(tt===st)continue;if(tt>=128||st>=128)return x(G.toLowerCase(),ne.toLowerCase(),pe,De,Le,ze);L(tt)&&(tt-=32),L(st)&&(st-=32);const Je=tt-st;if(Je!==0)return Je}const Ve=De-pe,_e=ze-Le;return Ve<_e?-1:Ve>_e?1:0}function R(G){return G>=48&&G<=57}function L(G){return G>=97&&G<=122}function X(G){return G>=65&&G<=90}function J(G,ne){return G.length===ne.length&&T(G,ne)===0}function de(G,ne){const pe=ne.length;return ne.length>G.length?!1:T(G,ne,0,pe)===0}function ae(G,ne){const pe=Math.min(G.length,ne.length);let De;for(De=0;De<pe;De++)if(G.charCodeAt(De)!==ne.charCodeAt(De))return De;return pe}function ie(G,ne){const pe=Math.min(G.length,ne.length);let De;const Le=G.length-1,ze=ne.length-1;for(De=0;De<pe;De++)if(G.charCodeAt(Le-De)!==ne.charCodeAt(ze-De))return De;return pe}function ge(G){return 55296<=G&&G<=56319}function Fe(G){return 56320<=G&&G<=57343}function Ne(G,ne){return(G-55296<<10)+(ne-56320)+65536}function Pe(G,ne,pe){const De=G.charCodeAt(pe);if(ge(De)&&pe+1<ne){const Le=G.charCodeAt(pe+1);if(Fe(Le))return Ne(De,Le)}return De}function oe(G,ne){const pe=G.charCodeAt(ne-1);if(Fe(pe)&&ne>1){const De=G.charCodeAt(ne-2);if(ge(De))return Ne(De,pe)}return pe}class U{get offset(){return this.e}constructor(ne,pe=0){this.c=ne,this.d=ne.length,this.e=pe}setOffset(ne){this.e=ne}prevCodePoint(){const ne=oe(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Pe(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$tf=U;class le{get offset(){return this.c.offset}constructor(ne,pe=0){this.c=new U(ne,pe)}nextGraphemeLength(){const ne=Se.getInstance(),pe=this.c,De=pe.offset;let Le=ne.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ze=pe.offset,Ve=ne.getGraphemeBreakType(pe.nextCodePoint());if(we(Le,Ve)){pe.setOffset(ze);break}Le=Ve}return pe.offset-De}prevGraphemeLength(){const ne=Se.getInstance(),pe=this.c,De=pe.offset;let Le=ne.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ze=pe.offset,Ve=ne.getGraphemeBreakType(pe.prevCodePoint());if(we(Ve,Le)){pe.setOffset(ze);break}Le=Ve}return De-pe.offset}eol(){return this.c.eol()}}t.$uf=le;function re(G,ne){return new le(G,ne).nextGraphemeLength()}function Y(G,ne){return new le(G,ne).prevGraphemeLength()}function Q(G,ne){ne>0&&Fe(G.charCodeAt(ne))&&ne--;const pe=ne+re(G,ne);return[pe-Y(G,pe),pe]}function te(G){const ne=new le(G);let pe=0;for(;!ne.eol();)pe++,ne.nextGraphemeLength();return pe}let ue;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Te(G){return ue||(ue=ye()),ue.test(G)}const Ee=/^[\t\n\r\x20-\x7E]*$/;function fe(G){return Ee.test(G)}t.$Bf=/[\u2028\u2029]/;function c(G){return t.$Bf.test(G)}function k(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}function D(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}function o(G,ne,pe=""){const De=G.trimStart();if(De.length<ne)return De;const Le=/\b/g;let ze=0;for(;Le.test(De)&&!(De.length-Le.lastIndex<ne);)ze=Le.lastIndex,Le.lastIndex+=1;return ze===0?De:pe+De.substring(ze).trimStart()}const a=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,n=/\x1b\].*?\x07/g;function h(G){return G&&(G=G.replace(a,"").replace(n,"")),G}t.$Hf="\uFEFF";function F(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}function B(G){return F(G)?G.substr(1):G}function j(G,ne){if(!G||!ne||G.length<ne.length)return!1;const pe=ne.length,De=G.toLowerCase();let Le=0,ze=-1;for(;Le<pe;){const Ve=De.indexOf(ne[Le],ze+1);if(Ve<0)return!1;ze=Ve,Le++}return!0}function V(G,ne=!1){return G?(ne&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}function Z(G){return G.charAt(0).toUpperCase()+G.slice(1)}function _(G,ne=1){if(ne===0)return"";let pe=-1;do pe=G.indexOf(`
`,pe+1),ne--;while(ne>0&&pe>=0);return pe===-1?G:(G[pe-1]==="\r"&&pe--,G.substr(0,pe))}function $e(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}function ve(G){return Se.getInstance().getGraphemeBreakType(G)}function we(G,ne){return G===0?ne!==5&&ne!==7:G===2&&ne===3?!1:G===4||G===2||G===3||ne===4||ne===2||ne===3?!0:!(G===8&&(ne===8||ne===9||ne===11||ne===12)||(G===11||G===9)&&(ne===9||ne===10)||(G===12||G===10)&&ne===10||ne===5||ne===13||ne===7||G===1||G===13&&ne===14||G===6&&ne===6)}var Me;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(t.GraphemeBreakType=Me={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Ae()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const pe=this.d,De=pe.length/3;let Le=1;for(;Le<=De;)if(ne<pe[3*Le])Le=2*Le;else if(ne>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return 0}}function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(G,ne){if(G===0)return 0;const pe=Re(G,ne);if(pe!==void 0)return pe;const De=new U(ne,G);return De.prevCodePoint(),De.offset}function Re(G,ne){const pe=new U(ne,G);let De=pe.prevCodePoint();for(;Xe(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!D(De))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===8205&&(Le=pe.offset),Le}function Xe(G){return 127995<=G&&G<=127999}var nt;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),t.$Rf="\xA0";class Ge{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Qe(ne=>{function pe(Je){const rt=new Map;for(let et=0;et<Je.length;et+=2)rt.set(Je[et],Je[et+1]);return rt}function De(Je,rt){const et=new Map(Je);for(const[mt,gt]of rt)et.set(mt,gt);return et}function Le(Je,rt){if(!Je)return rt;const et=new Map;for(const[mt,gt]of Je)rt.has(mt)&&et.set(mt,gt);return et}const ze=this.c.value;let Ve=ne.filter(Je=>!Je.startsWith("_")&&Je in ze);Ve.length===0&&(Ve=["_default"]);let _e;for(const Je of Ve){const rt=pe(ze[Je]);_e=Le(_e,rt)}const tt=pe(ze._common),st=De(tt,_e);return new Ge(st)})}static getInstance(ne){return Ge.d.get(Array.from(ne))}static{this.e=new N.$V(()=>Object.keys(Ge.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Ge.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Sf=Ge;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(ne){return Ue.e().has(ne)}static get codePoints(){return Ue.e()}}t.$Tf=Ue}),define(me[37],be([1,0,34,83,10]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uk=t.FuzzyScore=t.$jk=t.$ik=void 0,t.or=H,t.$kk=A,t.$lk=b,t.$mk=P,t.$nk=O,t.$ok=y,t.$pk=X,t.$qk=J,t.$rk=de,t.$sk=ae,t.$tk=Te,t.$vk=k,t.$wk=a,t.$xk=n;function H(...B){return function(j,V){for(let Z=0,_=B.length;Z<_;Z++){const $e=B[Z](j,V);if($e)return $e}return null}}t.$ik=E.bind(void 0,!1),t.$jk=E.bind(void 0,!0);function E(B,j,V){if(!V||V.length<j.length)return null;let Z;return B?Z=z.$mf(V,j):Z=V.indexOf(j)===0,Z?j.length>0?[{start:0,end:j.length}]:[]:null}function A(B,j){const V=j.toLowerCase().indexOf(B.toLowerCase());return V===-1?null:[{start:V,end:V+B.length}]}function b(B,j){return $(B.toLowerCase(),j.toLowerCase(),0,0)}function $(B,j,V,Z){if(V===B.length)return[];if(Z===j.length)return null;if(B[V]===j[Z]){let _=null;return(_=$(B,j,V+1,Z+1))?l({start:Z,end:Z+1},_):null}return $(B,j,V,Z+1)}function w(B){return 97<=B&&B<=122}function P(B){return 65<=B&&B<=90}function f(B){return 48<=B&&B<=57}function d(B){return B===32||B===9||B===10||B===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(B=>e.add(B.charCodeAt(0)));function s(B){return d(B)||e.has(B)}function u(B,j){return B===j||s(B)&&s(j)}const m=new Map;function p(B){if(m.has(B))return m.get(B);let j;const V=(0,N.$gk)(B);return V&&(j=V),m.set(B,j),j}function v(B){return w(B)||P(B)||f(B)}function l(B,j){return j.length===0?j=[B]:B.end===j[0].start?j[0].start=B.start:j.unshift(B),j}function g(B,j){for(let V=j;V<B.length;V++){const Z=B.charCodeAt(V);if(P(Z)||f(Z)||V>0&&!v(B.charCodeAt(V-1)))return V}return B.length}function r(B,j,V,Z){if(V===B.length)return[];if(Z===j.length)return null;if(B[V]!==j[Z].toLowerCase())return null;{let _=null,$e=Z+1;for(_=r(B,j,V+1,Z+1);!_&&($e=g(j,$e))<j.length;)_=r(B,j,V+1,$e),$e++;return _===null?null:l({start:Z,end:Z+1},_)}}function S(B){let j=0,V=0,Z=0,_=0,$e=0;for(let Ae=0;Ae<B.length;Ae++)$e=B.charCodeAt(Ae),P($e)&&j++,w($e)&&V++,v($e)&&Z++,f($e)&&_++;const ve=j/B.length,we=V/B.length,Me=Z/B.length,Se=_/B.length;return{upperPercent:ve,lowerPercent:we,alphaPercent:Me,numericPercent:Se}}function C(B){const{upperPercent:j,lowerPercent:V}=B;return V===0&&j>.6}function I(B){const{upperPercent:j,lowerPercent:V,alphaPercent:Z,numericPercent:_}=B;return V>.2&&j<.8&&Z>.6&&_<.2}function M(B){let j=0,V=0,Z=0,_=0;for(let $e=0;$e<B.length;$e++)Z=B.charCodeAt($e),P(Z)&&j++,w(Z)&&V++,d(Z)&&_++;return(j===0||V===0)&&_===0?B.length<=30:j<=5}function O(B,j){if(!j||(j=j.trim(),j.length===0)||!M(B))return null;j.length>60&&(j=j.substring(0,60));const V=S(j);if(!I(V)){if(!C(V))return null;j=j.toLowerCase()}let Z=null,_=0;for(B=B.toLowerCase();_<j.length&&(Z=r(B,j,0,_))===null;)_=g(j,_+1);return Z}function y(B,j,V=!1){if(!j||j.length===0)return null;let Z=null,_=0;for(B=B.toLowerCase(),j=j.toLowerCase();_<j.length&&(Z=x(B,j,0,_,V),Z===null);)_=W(j,_+1);return Z}function x(B,j,V,Z,_){let $e=0;if(V===B.length)return[];if(Z===j.length)return null;if(!u(B.charCodeAt(V),j.charCodeAt(Z))){const Me=p(B.charCodeAt(V));if(!Me)return null;for(let Se=0;Se<Me.length;Se++)if(!u(Me[Se],j.charCodeAt(Z+Se)))return null;$e+=Me.length-1}let ve=null,we=Z+$e+1;if(ve=x(B,j,V+1,we,_),!_)for(;!ve&&(we=W(j,we))<j.length;)ve=x(B,j,V+1,we,_),we++;if(!ve)return null;if(B.charCodeAt(V)!==j.charCodeAt(Z)){const Me=p(B.charCodeAt(V));if(!Me)return ve;for(let Se=0;Se<Me.length;Se++)if(Me[Se]!==j.charCodeAt(Z+Se))return ve}return l({start:Z,end:Z+$e+1},ve)}function W(B,j){for(let V=j;V<B.length;V++)if(s(B.charCodeAt(V))||V>0&&s(B.charCodeAt(V-1)))return V;return B.length}const T=H(t.$jk,O,A),R=H(t.$jk,O,b),L=new i.$Ec(1e4);function X(B,j,V=!1){if(typeof B!="string"||typeof j!="string")return null;let Z=L.get(B);Z||(Z=new RegExp(z.$7e(B),"i"),L.set(B,Z));const _=Z.exec(j);return _?[{start:_.index,end:_.index+_[0].length}]:V?R(B,j):T(B,j)}function J(B,j){const V=k(B,B.toLowerCase(),0,j,j.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?ae(V):null}function de(B,j,V,Z,_,$e){const ve=Math.min(13,B.length);for(;V<ve;V++){const we=k(B,j,V,Z,_,$e,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,$e]}function ae(B){if(typeof B>"u")return[];const j=[],V=B[1];for(let Z=B.length-1;Z>1;Z--){const _=B[Z]+V,$e=j[j.length-1];$e&&$e.end===_?$e.end=_+1:j.push({start:_,end:_+1})}return j}const ie=128;function ge(){const B=[],j=[];for(let V=0;V<=ie;V++)j[V]=0;for(let V=0;V<=ie;V++)B.push(j.slice(0));return B}function Fe(B){const j=[];for(let V=0;V<=B;V++)j[V]=0;return j}const Ne=Fe(2*ie),Pe=Fe(2*ie),oe=ge(),U=ge(),le=ge(),re=!1;function Y(B,j,V,Z,_){function $e(we,Me,Se=" "){for(;we.length<Me;)we=Se+we;return we}let ve=` |   |${Z.split("").map(we=>$e(we,3)).join("|")}
`;for(let we=0;we<=V;we++)we===0?ve+=" |":ve+=`${j[we-1]}|`,ve+=B[we].slice(0,_+1).map(Me=>$e(Me.toString(),3)).join("|")+`
`;return ve}function Q(B,j,V,Z){B=B.substr(j),V=V.substr(Z),console.log(Y(U,B,B.length,V,V.length)),console.log(Y(le,B,B.length,V,V.length)),console.log(Y(oe,B,B.length,V,V.length))}function te(B,j){if(j<0||j>=B.length)return!1;const V=B.codePointAt(j);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!z.$Ef(V)}}function ue(B,j){if(j<0||j>=B.length)return!1;switch(B.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function ye(B,j,V){return j[B]!==V[B]}function Te(B,j,V,Z,_,$e,ve=!1){for(;j<V&&_<$e;)B[j]===Z[_]&&(ve&&(Ne[j]=_),j+=1),_+=1;return j===V}var Ee;(function(B){B[B.Diag=1]="Diag",B[B.Left=2]="Left",B[B.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var fe;(function(B){B.Default=[-100,0];function j(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}B.isDefault=j})(fe||(t.FuzzyScore=fe={}));class c{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(j,V){this.firstMatchCanBeWeak=j,this.boostFullMatch=V}}t.$uk=c;function k(B,j,V,Z,_,$e,ve=c.default){const we=B.length>ie?ie:B.length,Me=Z.length>ie?ie:Z.length;if(V>=we||$e>=Me||we-V>Me-$e||!Te(j,V,we,_,$e,Me,!0))return;D(we,Me,V,$e,j,_);let Se=1,Ae=1,Ce=V,Re=$e;const Xe=[!1];for(Se=1,Ce=V;Ce<we;Se++,Ce++){const ne=Ne[Ce],pe=Pe[Ce],De=Ce+1<we?Pe[Ce+1]:Me;for(Ae=ne-$e+1,Re=ne;Re<De;Ae++,Re++){let Le=Number.MIN_SAFE_INTEGER,ze=!1;Re<=pe&&(Le=o(B,j,Ce,V,Z,_,Re,Me,$e,oe[Se-1][Ae-1]===0,Xe));let Ve=0;Le!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ve=Le+U[Se-1][Ae-1]);const _e=Re>ne,tt=_e?U[Se][Ae-1]+(oe[Se][Ae-1]>0?-5:0):0,st=Re>ne+1&&oe[Se][Ae-1]>0,Je=st?U[Se][Ae-2]+(oe[Se][Ae-2]>0?-5:0):0;if(st&&(!_e||Je>=tt)&&(!ze||Je>=Ve))U[Se][Ae]=Je,le[Se][Ae]=3,oe[Se][Ae]=0;else if(_e&&(!ze||tt>=Ve))U[Se][Ae]=tt,le[Se][Ae]=2,oe[Se][Ae]=0;else if(ze)U[Se][Ae]=Ve,le[Se][Ae]=1,oe[Se][Ae]=oe[Se-1][Ae-1]+1;else throw new Error("not possible")}}if(re&&Q(B,V,Z,$e),!Xe[0]&&!ve.firstMatchCanBeWeak)return;Se--,Ae--;const nt=[U[Se][Ae],$e];let Ge=0,Ue=0;for(;Se>=1;){let ne=Ae;do{const pe=le[Se][ne];if(pe===3)ne=ne-2;else if(pe===2)ne=ne-1;else break}while(ne>=1);Ge>1&&j[V+Se-1]===_[$e+Ae-1]&&!ye(ne+$e-1,Z,_)&&Ge+1>oe[Se][ne]&&(ne=Ae),ne===Ae?Ge++:Ge=1,Ue||(Ue=ne),Se--,Ae=ne-1,nt.push(Ae)}Me===we&&ve.boostFullMatch&&(nt[0]+=2);const G=Ue-we;return nt[0]-=G,nt}function D(B,j,V,Z,_,$e){let ve=B-1,we=j-1;for(;ve>=V&&we>=Z;)_[ve]===$e[we]&&(Pe[ve]=we,ve--),we--}function o(B,j,V,Z,_,$e,ve,we,Me,Se,Ae){if(j[V]!==$e[ve])return Number.MIN_SAFE_INTEGER;let Ce=1,Re=!1;return ve===V-Z?Ce=B[V]===_[ve]?7:5:ye(ve,_,$e)&&(ve===0||!ye(ve-1,_,$e))?(Ce=B[V]===_[ve]?7:5,Re=!0):te($e,ve)&&(ve===0||!te($e,ve-1))?Ce=5:(te($e,ve-1)||ue($e,ve-1))&&(Ce=5,Re=!0),Ce>1&&V===Z&&(Ae[0]=!0),Re||(Re=ye(ve,_,$e)||te($e,ve-1)||ue($e,ve-1)),V===Z?ve>Me&&(Ce-=Re?3:5):Se?Ce+=Re?2:0:Ce+=Re?0:1,ve+1===we&&(Ce-=Re?3:5),Ce}function a(B,j,V,Z,_,$e,ve){return h(B,j,V,Z,_,$e,!0,ve)}function n(B,j,V,Z,_,$e,ve){return h(B,j,V,Z,_,$e,!1,ve)}function h(B,j,V,Z,_,$e,ve,we){let Me=k(B,j,V,Z,_,$e,we);if(Me&&!ve)return Me;if(B.length>=3){const Se=Math.min(7,B.length-1);for(let Ae=V+1;Ae<Se;Ae++){const Ce=F(B,Ae);if(Ce){const Re=k(Ce,Ce.toLowerCase(),V,Z,_,$e,we);Re&&(Re[0]-=3,(!Me||Re[0]>Me[0])&&(Me=Re))}}}return Me}function F(B,j){if(j+1>=B.length)return;const V=B[j],Z=B[j+1];if(V!==Z)return B.slice(0,j)+Z+V+B.slice(j+2)}}),define(me[52],be([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bj=t.$_i=void 0,t.$8i=N,t.$9i=z,t.$0i=H,t.$$i=A,t.$aj=s;function N(m){return z(m,0)}function z(m,p){switch(typeof m){case"object":return m===null?H(349,p):Array.isArray(m)?b(m,p):$(m,p);case"string":return A(m,p);case"boolean":return E(m,p);case"number":return H(m,p);case"undefined":return H(937,p);default:return H(617,p)}}function H(m,p){return(p<<5)-p+m|0}function E(m,p){return H(m?433:863,p)}function A(m,p){p=H(149417,p);for(let v=0,l=m.length;v<l;v++)p=H(m.charCodeAt(v),p);return p}function b(m,p){return p=H(104579,p),m.reduce((v,l)=>z(l,v),p)}function $(m,p){return p=H(181387,p),Object.keys(m).sort().reduce((v,l)=>(v=A(l,v),z(m[l],v)),p)}class w{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=z(p,this.g),this.g}}t.$_i=w;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function f(m,p,v=32){const l=v-p,g=~((1<<l)-1);return(m<<p|(g&m)>>>l)>>>0}function d(m,p=0,v=m.byteLength,l=0){for(let g=0;g<v;g++)m[p+g]=l}function e(m,p,v="0"){for(;m.length<p;)m=v+m;return m}function s(m,p=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),p/4)}class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const v=p.length;if(v===0)return;const l=this.p;let g=this.r,r=this.u,S,C;for(r!==0?(S=r,C=-1,r=0):(S=p.charCodeAt(0),C=0);;){let I=S;if(i.$pf(S))if(C+1<v){const M=p.charCodeAt(C+1);i.$qf(M)?(C++,I=i.$rf(S,M)):I=65533}else{r=S;break}else i.$qf(S)&&(I=65533);if(g=this.w(l,g,I),C++,C<v)S=p.charCodeAt(C);else break}this.r=g,this.u=r}w(p,v,l){return l<128?p[v++]=l:l<2048?(p[v++]=192|(l&1984)>>>6,p[v++]=128|(l&63)>>>0):l<65536?(p[v++]=224|(l&61440)>>>12,p[v++]=128|(l&4032)>>>6,p[v++]=128|(l&63)>>>0):(p[v++]=240|(l&1835008)>>>18,p[v++]=128|(l&258048)>>>12,p[v++]=128|(l&4032)>>>6,p[v++]=128|(l&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,p[0]=p[64],p[1]=p[65],p[2]=p[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=u.g,v=this.q;for(let y=0;y<64;y+=4)p.setUint32(y,v.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)p.setUint32(y,f(p.getUint32(y-12,!1)^p.getUint32(y-32,!1)^p.getUint32(y-56,!1)^p.getUint32(y-64,!1),1),!1);let l=this.h,g=this.l,r=this.m,S=this.n,C=this.o,I,M,O;for(let y=0;y<80;y++)y<20?(I=g&r|~g&S,M=1518500249):y<40?(I=g^r^S,M=1859775393):y<60?(I=g&r|g&S|r&S,M=2400959708):(I=g^r^S,M=3395469782),O=f(l,5)+I+C+M+p.getUint32(y*4,!1)&4294967295,C=S,S=r,r=f(g,30),g=l,l=O;this.h=this.h+l&4294967295,this.l=this.l+g&4294967295,this.m=this.m+r&4294967295,this.n=this.n+S&4294967295,this.o=this.o+C&4294967295}}t.$bj=u}),define(me[90],be([1,0,78,52]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=t.$et=void 0,t.$ft=H;class z{constructor(f){this.a=f}getElements(){const f=this.a,d=new Int32Array(f.length);for(let e=0,s=f.length;e<s;e++)d[e]=f.charCodeAt(e);return d}}t.$et=z;function H(P,f,d){return new w(new z(P),new z(f)).ComputeDiff(d).changes}class E{static Assert(f,d){if(!f)throw new Error(d)}}class A{static Copy(f,d,e,s,u){for(let m=0;m<u;m++)e[s+m]=f[d+m]}static Copy2(f,d,e,s,u){for(let m=0;m<u;m++)e[s+m]=f[d+m]}}var b;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class ${constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$dt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(f,d,e=null){this.a=e,this.b=f,this.c=d;const[s,u,m]=w.o(f),[p,v,l]=w.o(d);this.d=m&&l,this.e=s,this.f=u,this.g=p,this.h=v,this.k=[],this.m=[]}static n(f){return f.length>0&&typeof f[0]=="string"}static o(f){const d=f.getElements();if(w.n(d)){const e=new Int32Array(d.length);for(let s=0,u=d.length;s<u;s++)e[s]=(0,N.$$i)(d[s],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(f,d){return this.f[f]!==this.h[d]?!1:this.d?this.e[f]===this.g[d]:!0}q(f,d){if(!this.p(f,d))return!1;const e=w.r(this.b,f),s=w.r(this.c,d);return e===s}static r(f,d){return typeof f.getStrictElement=="function"?f.getStrictElement(d):null}s(f,d){return this.f[f]!==this.f[d]?!1:this.d?this.e[f]===this.e[d]:!0}u(f,d){return this.h[f]!==this.h[d]?!1:this.d?this.g[f]===this.g[d]:!0}ComputeDiff(f){return this.v(0,this.f.length-1,0,this.h.length-1,f)}v(f,d,e,s,u){const m=[!1];let p=this.w(f,d,e,s,m);return u&&(p=this.z(p)),{quitEarly:m[0],changes:p}}w(f,d,e,s,u){for(u[0]=!1;f<=d&&e<=s&&this.p(f,e);)f++,e++;for(;d>=f&&s>=e&&this.p(d,s);)d--,s--;if(f>d||e>s){let r;return e<=s?(E.Assert(f===d+1,"originalStart should only be one more than originalEnd"),r=[new i.$dt(f,0,e,s-e+1)]):f<=d?(E.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$dt(f,d-f+1,e,0)]):(E.Assert(f===d+1,"originalStart should only be one more than originalEnd"),E.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const m=[0],p=[0],v=this.y(f,d,e,s,m,p,u),l=m[0],g=p[0];if(v!==null)return v;if(!u[0]){const r=this.w(f,l,e,g,u);let S=[];return u[0]?S=[new i.$dt(l+1,d-(l+1)+1,g+1,s-(g+1)+1)]:S=this.w(l+1,d,g+1,s,u),this.H(r,S)}return[new i.$dt(f,d-f+1,e,s-e+1)]}x(f,d,e,s,u,m,p,v,l,g,r,S,C,I,M,O,y,x){let W=null,T=null,R=new $,L=d,X=e,J=C[0]-O[0]-s,de=-1073741824,ae=this.k.length-1;do{const ie=J+f;ie===L||ie<X&&l[ie-1]<l[ie+1]?(r=l[ie+1],I=r-J-s,r<de&&R.MarkNextChange(),de=r,R.AddModifiedElement(r+1,I),J=ie+1-f):(r=l[ie-1]+1,I=r-J-s,r<de&&R.MarkNextChange(),de=r-1,R.AddOriginalElement(r,I+1),J=ie-1-f),ae>=0&&(l=this.k[ae],f=l[0],L=1,X=l.length-1)}while(--ae>=-1);if(W=R.getReverseChanges(),x[0]){let ie=C[0]+1,ge=O[0]+1;if(W!==null&&W.length>0){const Fe=W[W.length-1];ie=Math.max(ie,Fe.getOriginalEnd()),ge=Math.max(ge,Fe.getModifiedEnd())}T=[new i.$dt(ie,S-ie+1,ge,M-ge+1)]}else{R=new $,L=m,X=p,J=C[0]-O[0]-v,de=1073741824,ae=y?this.m.length-1:this.m.length-2;do{const ie=J+u;ie===L||ie<X&&g[ie-1]>=g[ie+1]?(r=g[ie+1]-1,I=r-J-v,r>de&&R.MarkNextChange(),de=r+1,R.AddOriginalElement(r+1,I+1),J=ie+1-u):(r=g[ie-1],I=r-J-v,r>de&&R.MarkNextChange(),de=r,R.AddModifiedElement(r+1,I+1),J=ie-1-u),ae>=0&&(g=this.m[ae],u=g[0],L=1,X=g.length-1)}while(--ae>=-1);T=R.getChanges()}return this.H(W,T)}y(f,d,e,s,u,m,p){let v=0,l=0,g=0,r=0,S=0,C=0;f--,e--,u[0]=0,m[0]=0,this.k=[],this.m=[];const I=d-f+(s-e),M=I+1,O=new Int32Array(M),y=new Int32Array(M),x=s-e,W=d-f,T=f-e,R=d-s,X=(W-x)%2===0;O[x]=f,y[W]=d,p[0]=!1;for(let J=1;J<=I/2+1;J++){let de=0,ae=0;g=this.J(x-J,J,x,M),r=this.J(x+J,J,x,M);for(let ge=g;ge<=r;ge+=2){ge===g||ge<r&&O[ge-1]<O[ge+1]?v=O[ge+1]:v=O[ge-1]+1,l=v-(ge-x)-T;const Fe=v;for(;v<d&&l<s&&this.p(v+1,l+1);)v++,l++;if(O[ge]=v,v+l>de+ae&&(de=v,ae=l),!X&&Math.abs(ge-W)<=J-1&&v>=y[ge])return u[0]=v,m[0]=l,Fe<=y[ge]&&1447>0&&J<=1448?this.x(x,g,r,T,W,S,C,R,O,y,v,d,u,l,s,m,X,p):null}const ie=(de-f+(ae-e)-J)/2;if(this.a!==null&&!this.a(de,ie))return p[0]=!0,u[0]=de,m[0]=ae,ie>0&&1447>0&&J<=1448?this.x(x,g,r,T,W,S,C,R,O,y,v,d,u,l,s,m,X,p):(f++,e++,[new i.$dt(f,d-f+1,e,s-e+1)]);S=this.J(W-J,J,W,M),C=this.J(W+J,J,W,M);for(let ge=S;ge<=C;ge+=2){ge===S||ge<C&&y[ge-1]>=y[ge+1]?v=y[ge+1]-1:v=y[ge-1],l=v-(ge-W)-R;const Fe=v;for(;v>f&&l>e&&this.p(v,l);)v--,l--;if(y[ge]=v,X&&Math.abs(ge-x)<=J&&v<=O[ge])return u[0]=v,m[0]=l,Fe>=O[ge]&&1447>0&&J<=1448?this.x(x,g,r,T,W,S,C,R,O,y,v,d,u,l,s,m,X,p):null}if(J<=1447){let ge=new Int32Array(r-g+2);ge[0]=x-g+1,A.Copy2(O,g,ge,1,r-g+1),this.k.push(ge),ge=new Int32Array(C-S+2),ge[0]=W-S+1,A.Copy2(y,S,ge,1,C-S+1),this.m.push(ge)}}return this.x(x,g,r,T,W,S,C,R,O,y,v,d,u,l,s,m,X,p)}z(f){for(let d=0;d<f.length;d++){const e=f[d],s=d<f.length-1?f[d+1].originalStart:this.f.length,u=d<f.length-1?f[d+1].modifiedStart:this.h.length,m=e.originalLength>0,p=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<u&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!p||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const l=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!l)break;e.originalStart++,e.modifiedStart++}const v=[null];if(d<f.length-1&&this.I(f[d],f[d+1],v)){f[d]=v[0],f.splice(d+1,1),d--;continue}}for(let d=f.length-1;d>=0;d--){const e=f[d];let s=0,u=0;if(d>0){const r=f[d-1];s=r.originalStart+r.originalLength,u=r.modifiedStart+r.modifiedLength}const m=e.originalLength>0,p=e.modifiedLength>0;let v=0,l=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const S=e.originalStart-r,C=e.modifiedStart-r;if(S<s||C<u||m&&!this.s(S,S+e.originalLength)||p&&!this.u(C,C+e.modifiedLength))break;const M=(S===s&&C===u?5:0)+this.G(S,e.originalLength,C,e.modifiedLength);M>l&&(l=M,v=r)}e.originalStart-=v,e.modifiedStart-=v;const g=[null];if(d>0&&this.I(f[d-1],f[d],g)){f[d-1]=g[0],f.splice(d,1),d++;continue}}if(this.d)for(let d=1,e=f.length;d<e;d++){const s=f[d-1],u=f[d],m=u.originalStart-s.originalStart-s.originalLength,p=s.originalStart,v=u.originalStart+u.originalLength,l=v-p,g=s.modifiedStart,r=u.modifiedStart+u.modifiedLength,S=r-g;if(m<5&&l<20&&S<20){const C=this.A(p,l,g,S,m);if(C){const[I,M]=C;(I!==s.originalStart+s.originalLength||M!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=I-s.originalStart,s.modifiedLength=M-s.modifiedStart,u.originalStart=I+m,u.modifiedStart=M+m,u.originalLength=v-u.originalStart,u.modifiedLength=r-u.modifiedStart)}}}return f}A(f,d,e,s,u){if(d<u||s<u)return null;const m=f+d-u+1,p=e+s-u+1;let v=0,l=0,g=0;for(let r=f;r<m;r++)for(let S=e;S<p;S++){const C=this.B(r,S,u);C>0&&C>v&&(v=C,l=r,g=S)}return v>0?[l,g]:null}B(f,d,e){let s=0;for(let u=0;u<e;u++){if(!this.p(f+u,d+u))return 0;s+=this.e[f+u].length}return s}C(f){return f<=0||f>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[f])}D(f,d){if(this.C(f)||this.C(f-1))return!0;if(d>0){const e=f+d;if(this.C(e-1)||this.C(e))return!0}return!1}E(f){return f<=0||f>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[f])}F(f,d){if(this.E(f)||this.E(f-1))return!0;if(d>0){const e=f+d;if(this.E(e-1)||this.E(e))return!0}return!1}G(f,d,e,s){const u=this.D(f,d)?1:0,m=this.F(e,s)?1:0;return u+m}H(f,d){const e=[];if(f.length===0||d.length===0)return d.length>0?d:f;if(this.I(f[f.length-1],d[0],e)){const s=new Array(f.length+d.length-1);return A.Copy(f,0,s,0,f.length-1),s[f.length-1]=e[0],A.Copy(d,1,s,f.length,d.length-1),s}else{const s=new Array(f.length+d.length);return A.Copy(f,0,s,0,f.length),A.Copy(d,0,s,f.length,d.length),s}}I(f,d,e){if(E.Assert(f.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),E.Assert(f.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),f.originalStart+f.originalLength>=d.originalStart||f.modifiedStart+f.modifiedLength>=d.modifiedStart){const s=f.originalStart;let u=f.originalLength;const m=f.modifiedStart;let p=f.modifiedLength;return f.originalStart+f.originalLength>=d.originalStart&&(u=d.originalStart+d.originalLength-f.originalStart),f.modifiedStart+f.modifiedLength>=d.modifiedStart&&(p=d.modifiedStart+d.modifiedLength-f.modifiedStart),e[0]=new i.$dt(s,u,m,p),!0}else return e[0]=null,!1}J(f,d,e,s){if(f>=0&&f<s)return f;const u=e,m=s-e-1,p=d%2===0;if(f<0){const v=u%2===0;return p===v?0:1}else{const v=m%2===0;return p===v?s-1:s-2}}}t.$gt=w}),define(me[53],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4d=void 0,t.$4d=Symbol("MicrotaskDelay")}),define(me[91],be([1,0,12,10]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ni=t.$mi=t.$li=t.$ki=t.$ji=void 0;class z{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const e=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$ji=z;class H{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,N.$ff)(d,this.b,0,d.length,this.c,this.d):(0,N.$hf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$ki=H;class E{constructor(d=!0,e=!0){this.f=d,this.g=e}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let e=d.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,N.$ff)(d,this.b,0,d.length,this.d,this.e):(0,N.$hf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$li=E;var A;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(A||(A={}));class b{constructor(d,e){this.f=d,this.g=e,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,N.$gf)(d,this.c.scheme);if(this.d[this.e]===2)return(0,N.$gf)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,N.$ef)(d,this.c.query);if(this.d[this.e]===5)return(0,N.$ef)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$mi=b;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(w||(w={}));class P{static forUris(d=()=>!1,e=()=>!1){return new P(new b(d,e))}static forPaths(d=!1){return new P(new E(void 0,!d))}static forStrings(){return new P(new z)}static forConfigKeys(){return new P(new H)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,e){if(e){const s=e.slice(0);(0,i.$Xb)(s);for(const u of s)this.set(u,d)}else{const s=d.slice(0);(0,i.$Xb)(s);for(const u of s)this.set(u[0],u[1])}}set(d,e){const s=this.b.reset(d);let u;this.c||(this.c=new $,this.c.segment=s.value());const m=[];for(u=this.c;;){const v=s.cmp(u.segment);if(v>0)u.left||(u.left=new $,u.left.segment=s.value()),m.push([-1,u]),u=u.left;else if(v<0)u.right||(u.right=new $,u.right.segment=s.value()),m.push([1,u]),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new $,u.mid.segment=s.value()),m.push([0,u]),u=u.mid;else break}const p=u.value;u.value=e,u.key=d;for(let v=m.length-1;v>=0;v--){const l=m[v][1];l.updateHeight();const g=l.balanceFactor();if(g<-1||g>1){const r=m[v][0],S=m[v+1][0];if(r===1&&S===1)m[v][1]=l.rotateLeft();else if(r===-1&&S===-1)m[v][1]=l.rotateRight();else if(r===1&&S===-1)l.right=m[v+1][1]=m[v+1][1].rotateRight(),m[v][1]=l.rotateLeft();else if(r===-1&&S===1)l.left=m[v+1][1]=m[v+1][1].rotateLeft(),m[v][1]=l.rotateRight();else throw new Error;if(v>0)switch(m[v-1][0]){case-1:m[v-1][1].left=m[v][1];break;case 1:m[v-1][1].right=m[v][1];break;case 0:m[v-1][1].mid=m[v][1];break}else this.c=m[0][1]}}return p}get(d){return this.d(d)?.value}d(d){const e=this.b.reset(d);let s=this.c;for(;s;){const u=e.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(d){const e=this.d(d);return!(e?.value===void 0&&e?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,e){const s=this.b.reset(d),u=[];let m=this.c;for(;m;){const p=s.cmp(m.segment);if(p>0)u.push([-1,m]),m=m.left;else if(p<0)u.push([1,m]),m=m.right;else if(s.hasNext())s.next(),u.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const p=this.f(m.right);if(p.key){const{key:v,value:l,segment:g}=p;this.e(p.key,!1),m.key=v,m.value=l,m.segment=g}}else{const p=m.left??m.right;if(u.length>0){const[v,l]=u[u.length-1];switch(v){case-1:l.left=p;break;case 0:l.mid=p;break;case 1:l.right=p;break}}else this.c=p}for(let p=u.length-1;p>=0;p--){const v=u[p][1];v.updateHeight();const l=v.balanceFactor();if(l>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),u[p][1]=v.rotateLeft()):l<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),u[p][1]=v.rotateRight()),p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this.c=u[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const e=this.b.reset(d);let s=this.c,u;for(;s;){const m=e.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(e.hasNext())e.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(d){return this.g(d,!1)}g(d,e){const s=this.b.reset(d);let u=this.c;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this.h(u.mid):e?u.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[e,s]of this)d(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const e=[];return this.j(d,e),e[Symbol.iterator]()}j(d,e){d&&(d.left&&this.j(d.left,e),d.value&&e.push([d.key,d.value]),d.mid&&this.j(d.mid,e),d.right&&this.j(d.right,e))}_isBalanced(){const d=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:d(e.left)&&d(e.right)};return d(this.c)}}t.$ni=P}),define(me[7],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=i,t.$Vf=N,t.$Wf=z,t.$Xf=H,t.$Yf=E,t.$Zf=A,t.$1f=b,t.$2f=$,t.$3f=w,t.$4f=P,t.$5f=f,t.$6f=d,t.$7f=e,t.$8f=u,t.$9f=m,t.$0f=p,t.$$f=v,t.$_f=l;function i(g){return typeof g=="string"}function N(g){return Array.isArray(g)&&g.every(r=>i(r))}function z(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}function H(g){const r=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof r}function E(g){return typeof g=="number"&&!isNaN(g)}function A(g){return!!g&&typeof g[Symbol.iterator]=="function"}function b(g){return g===!0||g===!1}function $(g){return typeof g>"u"}function w(g){return!P(g)}function P(g){return $(g)||g===null}function f(g,r){if(!g)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function d(g){if(P(g))throw new Error("Assertion Failed: argument is undefined or null");return g}function e(...g){const r=[];for(let S=0;S<g.length;S++){const C=g[S];if(P(C))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);r.push(C)}return r}const s=Object.prototype.hasOwnProperty;function u(g){if(!z(g))return!1;for(const r in g)if(s.call(g,r))return!1;return!0}function m(g){return typeof g=="function"}function p(...g){return g.length>0&&g.every(m)}function v(g,r){const S=Math.min(g.length,r.length);for(let C=0;C<S;C++)l(g[C],r[C])}function l(g,r){if(i(r)){if(typeof g!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(m(r)){try{if(g instanceof r)return}catch{}if(!P(g)&&g.constructor===r||r.length===1&&r.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[38],be([1,0,7]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bj=z,t.$Cj=H;const N=Object.create(null);function z(E,A){if((0,i.$Uf)(A)){const b=N[A];if(b===void 0)throw new Error(`${E} references an unknown codicon: ${A}`);A=b}return N[E]=A,{id:E}}function H(){return N}}),define(me[92],be([1,0,38]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dj=void 0,t.$Dj={add:(0,i.$Bj)("add",6e4),plus:(0,i.$Bj)("plus",6e4),gistNew:(0,i.$Bj)("gist-new",6e4),repoCreate:(0,i.$Bj)("repo-create",6e4),lightbulb:(0,i.$Bj)("lightbulb",60001),lightBulb:(0,i.$Bj)("light-bulb",60001),repo:(0,i.$Bj)("repo",60002),repoDelete:(0,i.$Bj)("repo-delete",60002),gistFork:(0,i.$Bj)("gist-fork",60003),repoForked:(0,i.$Bj)("repo-forked",60003),gitPullRequest:(0,i.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Bj)("record-keys",60005),keyboard:(0,i.$Bj)("keyboard",60005),tag:(0,i.$Bj)("tag",60006),gitPullRequestLabel:(0,i.$Bj)("git-pull-request-label",60006),tagAdd:(0,i.$Bj)("tag-add",60006),tagRemove:(0,i.$Bj)("tag-remove",60006),person:(0,i.$Bj)("person",60007),personFollow:(0,i.$Bj)("person-follow",60007),personOutline:(0,i.$Bj)("person-outline",60007),personFilled:(0,i.$Bj)("person-filled",60007),gitBranch:(0,i.$Bj)("git-branch",60008),gitBranchCreate:(0,i.$Bj)("git-branch-create",60008),gitBranchDelete:(0,i.$Bj)("git-branch-delete",60008),sourceControl:(0,i.$Bj)("source-control",60008),mirror:(0,i.$Bj)("mirror",60009),mirrorPublic:(0,i.$Bj)("mirror-public",60009),star:(0,i.$Bj)("star",60010),starAdd:(0,i.$Bj)("star-add",60010),starDelete:(0,i.$Bj)("star-delete",60010),starEmpty:(0,i.$Bj)("star-empty",60010),comment:(0,i.$Bj)("comment",60011),commentAdd:(0,i.$Bj)("comment-add",60011),alert:(0,i.$Bj)("alert",60012),warning:(0,i.$Bj)("warning",60012),search:(0,i.$Bj)("search",60013),searchSave:(0,i.$Bj)("search-save",60013),logOut:(0,i.$Bj)("log-out",60014),signOut:(0,i.$Bj)("sign-out",60014),logIn:(0,i.$Bj)("log-in",60015),signIn:(0,i.$Bj)("sign-in",60015),eye:(0,i.$Bj)("eye",60016),eyeUnwatch:(0,i.$Bj)("eye-unwatch",60016),eyeWatch:(0,i.$Bj)("eye-watch",60016),circleFilled:(0,i.$Bj)("circle-filled",60017),primitiveDot:(0,i.$Bj)("primitive-dot",60017),closeDirty:(0,i.$Bj)("close-dirty",60017),debugBreakpoint:(0,i.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Bj)("primitive-square",60018),edit:(0,i.$Bj)("edit",60019),pencil:(0,i.$Bj)("pencil",60019),info:(0,i.$Bj)("info",60020),issueOpened:(0,i.$Bj)("issue-opened",60020),gistPrivate:(0,i.$Bj)("gist-private",60021),gitForkPrivate:(0,i.$Bj)("git-fork-private",60021),lock:(0,i.$Bj)("lock",60021),mirrorPrivate:(0,i.$Bj)("mirror-private",60021),close:(0,i.$Bj)("close",60022),removeClose:(0,i.$Bj)("remove-close",60022),x:(0,i.$Bj)("x",60022),repoSync:(0,i.$Bj)("repo-sync",60023),sync:(0,i.$Bj)("sync",60023),clone:(0,i.$Bj)("clone",60024),desktopDownload:(0,i.$Bj)("desktop-download",60024),beaker:(0,i.$Bj)("beaker",60025),microscope:(0,i.$Bj)("microscope",60025),vm:(0,i.$Bj)("vm",60026),deviceDesktop:(0,i.$Bj)("device-desktop",60026),file:(0,i.$Bj)("file",60027),fileText:(0,i.$Bj)("file-text",60027),more:(0,i.$Bj)("more",60028),ellipsis:(0,i.$Bj)("ellipsis",60028),kebabHorizontal:(0,i.$Bj)("kebab-horizontal",60028),mailReply:(0,i.$Bj)("mail-reply",60029),reply:(0,i.$Bj)("reply",60029),organization:(0,i.$Bj)("organization",60030),organizationFilled:(0,i.$Bj)("organization-filled",60030),organizationOutline:(0,i.$Bj)("organization-outline",60030),newFile:(0,i.$Bj)("new-file",60031),fileAdd:(0,i.$Bj)("file-add",60031),newFolder:(0,i.$Bj)("new-folder",60032),fileDirectoryCreate:(0,i.$Bj)("file-directory-create",60032),trash:(0,i.$Bj)("trash",60033),trashcan:(0,i.$Bj)("trashcan",60033),history:(0,i.$Bj)("history",60034),clock:(0,i.$Bj)("clock",60034),folder:(0,i.$Bj)("folder",60035),fileDirectory:(0,i.$Bj)("file-directory",60035),symbolFolder:(0,i.$Bj)("symbol-folder",60035),logoGithub:(0,i.$Bj)("logo-github",60036),markGithub:(0,i.$Bj)("mark-github",60036),github:(0,i.$Bj)("github",60036),terminal:(0,i.$Bj)("terminal",60037),console:(0,i.$Bj)("console",60037),repl:(0,i.$Bj)("repl",60037),zap:(0,i.$Bj)("zap",60038),symbolEvent:(0,i.$Bj)("symbol-event",60038),error:(0,i.$Bj)("error",60039),stop:(0,i.$Bj)("stop",60039),variable:(0,i.$Bj)("variable",60040),symbolVariable:(0,i.$Bj)("symbol-variable",60040),array:(0,i.$Bj)("array",60042),symbolArray:(0,i.$Bj)("symbol-array",60042),symbolModule:(0,i.$Bj)("symbol-module",60043),symbolPackage:(0,i.$Bj)("symbol-package",60043),symbolNamespace:(0,i.$Bj)("symbol-namespace",60043),symbolObject:(0,i.$Bj)("symbol-object",60043),symbolMethod:(0,i.$Bj)("symbol-method",60044),symbolFunction:(0,i.$Bj)("symbol-function",60044),symbolConstructor:(0,i.$Bj)("symbol-constructor",60044),symbolBoolean:(0,i.$Bj)("symbol-boolean",60047),symbolNull:(0,i.$Bj)("symbol-null",60047),symbolNumeric:(0,i.$Bj)("symbol-numeric",60048),symbolNumber:(0,i.$Bj)("symbol-number",60048),symbolStructure:(0,i.$Bj)("symbol-structure",60049),symbolStruct:(0,i.$Bj)("symbol-struct",60049),symbolParameter:(0,i.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Bj)("symbol-type-parameter",60050),symbolKey:(0,i.$Bj)("symbol-key",60051),symbolText:(0,i.$Bj)("symbol-text",60051),symbolReference:(0,i.$Bj)("symbol-reference",60052),goToFile:(0,i.$Bj)("go-to-file",60052),symbolEnum:(0,i.$Bj)("symbol-enum",60053),symbolValue:(0,i.$Bj)("symbol-value",60053),symbolRuler:(0,i.$Bj)("symbol-ruler",60054),symbolUnit:(0,i.$Bj)("symbol-unit",60054),activateBreakpoints:(0,i.$Bj)("activate-breakpoints",60055),archive:(0,i.$Bj)("archive",60056),arrowBoth:(0,i.$Bj)("arrow-both",60057),arrowDown:(0,i.$Bj)("arrow-down",60058),arrowLeft:(0,i.$Bj)("arrow-left",60059),arrowRight:(0,i.$Bj)("arrow-right",60060),arrowSmallDown:(0,i.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Bj)("arrow-small-up",60064),arrowUp:(0,i.$Bj)("arrow-up",60065),bell:(0,i.$Bj)("bell",60066),bold:(0,i.$Bj)("bold",60067),book:(0,i.$Bj)("book",60068),bookmark:(0,i.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Bj)("briefcase",60076),broadcast:(0,i.$Bj)("broadcast",60077),browser:(0,i.$Bj)("browser",60078),bug:(0,i.$Bj)("bug",60079),calendar:(0,i.$Bj)("calendar",60080),caseSensitive:(0,i.$Bj)("case-sensitive",60081),check:(0,i.$Bj)("check",60082),checklist:(0,i.$Bj)("checklist",60083),chevronDown:(0,i.$Bj)("chevron-down",60084),chevronLeft:(0,i.$Bj)("chevron-left",60085),chevronRight:(0,i.$Bj)("chevron-right",60086),chevronUp:(0,i.$Bj)("chevron-up",60087),chromeClose:(0,i.$Bj)("chrome-close",60088),chromeMaximize:(0,i.$Bj)("chrome-maximize",60089),chromeMinimize:(0,i.$Bj)("chrome-minimize",60090),chromeRestore:(0,i.$Bj)("chrome-restore",60091),circleOutline:(0,i.$Bj)("circle-outline",60092),circle:(0,i.$Bj)("circle",60092),debugBreakpointUnverified:(0,i.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Bj)("circle-slash",60093),circuitBoard:(0,i.$Bj)("circuit-board",60094),clearAll:(0,i.$Bj)("clear-all",60095),clippy:(0,i.$Bj)("clippy",60096),closeAll:(0,i.$Bj)("close-all",60097),cloudDownload:(0,i.$Bj)("cloud-download",60098),cloudUpload:(0,i.$Bj)("cloud-upload",60099),code:(0,i.$Bj)("code",60100),collapseAll:(0,i.$Bj)("collapse-all",60101),colorMode:(0,i.$Bj)("color-mode",60102),commentDiscussion:(0,i.$Bj)("comment-discussion",60103),creditCard:(0,i.$Bj)("credit-card",60105),dash:(0,i.$Bj)("dash",60108),dashboard:(0,i.$Bj)("dashboard",60109),database:(0,i.$Bj)("database",60110),debugContinue:(0,i.$Bj)("debug-continue",60111),debugDisconnect:(0,i.$Bj)("debug-disconnect",60112),debugPause:(0,i.$Bj)("debug-pause",60113),debugRestart:(0,i.$Bj)("debug-restart",60114),debugStart:(0,i.$Bj)("debug-start",60115),debugStepInto:(0,i.$Bj)("debug-step-into",60116),debugStepOut:(0,i.$Bj)("debug-step-out",60117),debugStepOver:(0,i.$Bj)("debug-step-over",60118),debugStop:(0,i.$Bj)("debug-stop",60119),debug:(0,i.$Bj)("debug",60120),deviceCameraVideo:(0,i.$Bj)("device-camera-video",60121),deviceCamera:(0,i.$Bj)("device-camera",60122),deviceMobile:(0,i.$Bj)("device-mobile",60123),diffAdded:(0,i.$Bj)("diff-added",60124),diffIgnored:(0,i.$Bj)("diff-ignored",60125),diffModified:(0,i.$Bj)("diff-modified",60126),diffRemoved:(0,i.$Bj)("diff-removed",60127),diffRenamed:(0,i.$Bj)("diff-renamed",60128),diff:(0,i.$Bj)("diff",60129),diffSidebyside:(0,i.$Bj)("diff-sidebyside",60129),discard:(0,i.$Bj)("discard",60130),editorLayout:(0,i.$Bj)("editor-layout",60131),emptyWindow:(0,i.$Bj)("empty-window",60132),exclude:(0,i.$Bj)("exclude",60133),extensions:(0,i.$Bj)("extensions",60134),eyeClosed:(0,i.$Bj)("eye-closed",60135),fileBinary:(0,i.$Bj)("file-binary",60136),fileCode:(0,i.$Bj)("file-code",60137),fileMedia:(0,i.$Bj)("file-media",60138),filePdf:(0,i.$Bj)("file-pdf",60139),fileSubmodule:(0,i.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Bj)("file-symlink-file",60142),fileZip:(0,i.$Bj)("file-zip",60143),files:(0,i.$Bj)("files",60144),filter:(0,i.$Bj)("filter",60145),flame:(0,i.$Bj)("flame",60146),foldDown:(0,i.$Bj)("fold-down",60147),foldUp:(0,i.$Bj)("fold-up",60148),fold:(0,i.$Bj)("fold",60149),folderActive:(0,i.$Bj)("folder-active",60150),folderOpened:(0,i.$Bj)("folder-opened",60151),gear:(0,i.$Bj)("gear",60152),gift:(0,i.$Bj)("gift",60153),gistSecret:(0,i.$Bj)("gist-secret",60154),gist:(0,i.$Bj)("gist",60155),gitCommit:(0,i.$Bj)("git-commit",60156),gitCompare:(0,i.$Bj)("git-compare",60157),compareChanges:(0,i.$Bj)("compare-changes",60157),gitMerge:(0,i.$Bj)("git-merge",60158),githubAction:(0,i.$Bj)("github-action",60159),githubAlt:(0,i.$Bj)("github-alt",60160),globe:(0,i.$Bj)("globe",60161),grabber:(0,i.$Bj)("grabber",60162),graph:(0,i.$Bj)("graph",60163),gripper:(0,i.$Bj)("gripper",60164),heart:(0,i.$Bj)("heart",60165),home:(0,i.$Bj)("home",60166),horizontalRule:(0,i.$Bj)("horizontal-rule",60167),hubot:(0,i.$Bj)("hubot",60168),inbox:(0,i.$Bj)("inbox",60169),issueReopened:(0,i.$Bj)("issue-reopened",60171),issues:(0,i.$Bj)("issues",60172),italic:(0,i.$Bj)("italic",60173),jersey:(0,i.$Bj)("jersey",60174),json:(0,i.$Bj)("json",60175),kebabVertical:(0,i.$Bj)("kebab-vertical",60176),key:(0,i.$Bj)("key",60177),law:(0,i.$Bj)("law",60178),lightbulbAutofix:(0,i.$Bj)("lightbulb-autofix",60179),linkExternal:(0,i.$Bj)("link-external",60180),link:(0,i.$Bj)("link",60181),listOrdered:(0,i.$Bj)("list-ordered",60182),listUnordered:(0,i.$Bj)("list-unordered",60183),liveShare:(0,i.$Bj)("live-share",60184),loading:(0,i.$Bj)("loading",60185),location:(0,i.$Bj)("location",60186),mailRead:(0,i.$Bj)("mail-read",60187),mail:(0,i.$Bj)("mail",60188),markdown:(0,i.$Bj)("markdown",60189),megaphone:(0,i.$Bj)("megaphone",60190),mention:(0,i.$Bj)("mention",60191),milestone:(0,i.$Bj)("milestone",60192),gitPullRequestMilestone:(0,i.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Bj)("mortar-board",60193),move:(0,i.$Bj)("move",60194),multipleWindows:(0,i.$Bj)("multiple-windows",60195),mute:(0,i.$Bj)("mute",60196),noNewline:(0,i.$Bj)("no-newline",60197),note:(0,i.$Bj)("note",60198),octoface:(0,i.$Bj)("octoface",60199),openPreview:(0,i.$Bj)("open-preview",60200),package:(0,i.$Bj)("package",60201),paintcan:(0,i.$Bj)("paintcan",60202),pin:(0,i.$Bj)("pin",60203),play:(0,i.$Bj)("play",60204),run:(0,i.$Bj)("run",60204),plug:(0,i.$Bj)("plug",60205),preserveCase:(0,i.$Bj)("preserve-case",60206),preview:(0,i.$Bj)("preview",60207),project:(0,i.$Bj)("project",60208),pulse:(0,i.$Bj)("pulse",60209),question:(0,i.$Bj)("question",60210),quote:(0,i.$Bj)("quote",60211),radioTower:(0,i.$Bj)("radio-tower",60212),reactions:(0,i.$Bj)("reactions",60213),references:(0,i.$Bj)("references",60214),refresh:(0,i.$Bj)("refresh",60215),regex:(0,i.$Bj)("regex",60216),remoteExplorer:(0,i.$Bj)("remote-explorer",60217),remote:(0,i.$Bj)("remote",60218),remove:(0,i.$Bj)("remove",60219),replaceAll:(0,i.$Bj)("replace-all",60220),replace:(0,i.$Bj)("replace",60221),repoClone:(0,i.$Bj)("repo-clone",60222),repoForcePush:(0,i.$Bj)("repo-force-push",60223),repoPull:(0,i.$Bj)("repo-pull",60224),repoPush:(0,i.$Bj)("repo-push",60225),report:(0,i.$Bj)("report",60226),requestChanges:(0,i.$Bj)("request-changes",60227),rocket:(0,i.$Bj)("rocket",60228),rootFolderOpened:(0,i.$Bj)("root-folder-opened",60229),rootFolder:(0,i.$Bj)("root-folder",60230),rss:(0,i.$Bj)("rss",60231),ruby:(0,i.$Bj)("ruby",60232),saveAll:(0,i.$Bj)("save-all",60233),saveAs:(0,i.$Bj)("save-as",60234),save:(0,i.$Bj)("save",60235),screenFull:(0,i.$Bj)("screen-full",60236),screenNormal:(0,i.$Bj)("screen-normal",60237),searchStop:(0,i.$Bj)("search-stop",60238),server:(0,i.$Bj)("server",60240),settingsGear:(0,i.$Bj)("settings-gear",60241),settings:(0,i.$Bj)("settings",60242),shield:(0,i.$Bj)("shield",60243),smiley:(0,i.$Bj)("smiley",60244),sortPrecedence:(0,i.$Bj)("sort-precedence",60245),splitHorizontal:(0,i.$Bj)("split-horizontal",60246),splitVertical:(0,i.$Bj)("split-vertical",60247),squirrel:(0,i.$Bj)("squirrel",60248),starFull:(0,i.$Bj)("star-full",60249),starHalf:(0,i.$Bj)("star-half",60250),symbolClass:(0,i.$Bj)("symbol-class",60251),symbolColor:(0,i.$Bj)("symbol-color",60252),symbolConstant:(0,i.$Bj)("symbol-constant",60253),symbolEnumMember:(0,i.$Bj)("symbol-enum-member",60254),symbolField:(0,i.$Bj)("symbol-field",60255),symbolFile:(0,i.$Bj)("symbol-file",60256),symbolInterface:(0,i.$Bj)("symbol-interface",60257),symbolKeyword:(0,i.$Bj)("symbol-keyword",60258),symbolMisc:(0,i.$Bj)("symbol-misc",60259),symbolOperator:(0,i.$Bj)("symbol-operator",60260),symbolProperty:(0,i.$Bj)("symbol-property",60261),wrench:(0,i.$Bj)("wrench",60261),wrenchSubaction:(0,i.$Bj)("wrench-subaction",60261),symbolSnippet:(0,i.$Bj)("symbol-snippet",60262),tasklist:(0,i.$Bj)("tasklist",60263),telescope:(0,i.$Bj)("telescope",60264),textSize:(0,i.$Bj)("text-size",60265),threeBars:(0,i.$Bj)("three-bars",60266),thumbsdown:(0,i.$Bj)("thumbsdown",60267),thumbsup:(0,i.$Bj)("thumbsup",60268),tools:(0,i.$Bj)("tools",60269),triangleDown:(0,i.$Bj)("triangle-down",60270),triangleLeft:(0,i.$Bj)("triangle-left",60271),triangleRight:(0,i.$Bj)("triangle-right",60272),triangleUp:(0,i.$Bj)("triangle-up",60273),twitter:(0,i.$Bj)("twitter",60274),unfold:(0,i.$Bj)("unfold",60275),unlock:(0,i.$Bj)("unlock",60276),unmute:(0,i.$Bj)("unmute",60277),unverified:(0,i.$Bj)("unverified",60278),verified:(0,i.$Bj)("verified",60279),versions:(0,i.$Bj)("versions",60280),vmActive:(0,i.$Bj)("vm-active",60281),vmOutline:(0,i.$Bj)("vm-outline",60282),vmRunning:(0,i.$Bj)("vm-running",60283),watch:(0,i.$Bj)("watch",60284),whitespace:(0,i.$Bj)("whitespace",60285),wholeWord:(0,i.$Bj)("whole-word",60286),window:(0,i.$Bj)("window",60287),wordWrap:(0,i.$Bj)("word-wrap",60288),zoomIn:(0,i.$Bj)("zoom-in",60289),zoomOut:(0,i.$Bj)("zoom-out",60290),listFilter:(0,i.$Bj)("list-filter",60291),listFlat:(0,i.$Bj)("list-flat",60292),listSelection:(0,i.$Bj)("list-selection",60293),selection:(0,i.$Bj)("selection",60293),listTree:(0,i.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Bj)("symbol-string",60301),debugReverseContinue:(0,i.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Bj)("debug-step-back",60303),debugRestartFrame:(0,i.$Bj)("debug-restart-frame",60304),debugAlt:(0,i.$Bj)("debug-alt",60305),callIncoming:(0,i.$Bj)("call-incoming",60306),callOutgoing:(0,i.$Bj)("call-outgoing",60307),menu:(0,i.$Bj)("menu",60308),expandAll:(0,i.$Bj)("expand-all",60309),feedback:(0,i.$Bj)("feedback",60310),gitPullRequestReviewer:(0,i.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Bj)("ungroup-by-ref-type",60312),account:(0,i.$Bj)("account",60313),gitPullRequestAssignee:(0,i.$Bj)("git-pull-request-assignee",60313),bellDot:(0,i.$Bj)("bell-dot",60314),debugConsole:(0,i.$Bj)("debug-console",60315),library:(0,i.$Bj)("library",60316),output:(0,i.$Bj)("output",60317),runAll:(0,i.$Bj)("run-all",60318),syncIgnored:(0,i.$Bj)("sync-ignored",60319),pinned:(0,i.$Bj)("pinned",60320),githubInverted:(0,i.$Bj)("github-inverted",60321),serverProcess:(0,i.$Bj)("server-process",60322),serverEnvironment:(0,i.$Bj)("server-environment",60323),pass:(0,i.$Bj)("pass",60324),issueClosed:(0,i.$Bj)("issue-closed",60324),stopCircle:(0,i.$Bj)("stop-circle",60325),playCircle:(0,i.$Bj)("play-circle",60326),record:(0,i.$Bj)("record",60327),debugAltSmall:(0,i.$Bj)("debug-alt-small",60328),vmConnect:(0,i.$Bj)("vm-connect",60329),cloud:(0,i.$Bj)("cloud",60330),merge:(0,i.$Bj)("merge",60331),export:(0,i.$Bj)("export",60332),graphLeft:(0,i.$Bj)("graph-left",60333),magnet:(0,i.$Bj)("magnet",60334),notebook:(0,i.$Bj)("notebook",60335),redo:(0,i.$Bj)("redo",60336),checkAll:(0,i.$Bj)("check-all",60337),pinnedDirty:(0,i.$Bj)("pinned-dirty",60338),passFilled:(0,i.$Bj)("pass-filled",60339),circleLargeFilled:(0,i.$Bj)("circle-large-filled",60340),circleLarge:(0,i.$Bj)("circle-large",60341),circleLargeOutline:(0,i.$Bj)("circle-large-outline",60341),combine:(0,i.$Bj)("combine",60342),gather:(0,i.$Bj)("gather",60342),table:(0,i.$Bj)("table",60343),variableGroup:(0,i.$Bj)("variable-group",60344),typeHierarchy:(0,i.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Bj)("git-pull-request-create",60348),runAbove:(0,i.$Bj)("run-above",60349),runBelow:(0,i.$Bj)("run-below",60350),notebookTemplate:(0,i.$Bj)("notebook-template",60351),debugRerun:(0,i.$Bj)("debug-rerun",60352),workspaceTrusted:(0,i.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Bj)("workspace-unknown",60355),terminalCmd:(0,i.$Bj)("terminal-cmd",60356),terminalDebian:(0,i.$Bj)("terminal-debian",60357),terminalLinux:(0,i.$Bj)("terminal-linux",60358),terminalPowershell:(0,i.$Bj)("terminal-powershell",60359),terminalTmux:(0,i.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Bj)("terminal-ubuntu",60361),terminalBash:(0,i.$Bj)("terminal-bash",60362),arrowSwap:(0,i.$Bj)("arrow-swap",60363),copy:(0,i.$Bj)("copy",60364),personAdd:(0,i.$Bj)("person-add",60365),filterFilled:(0,i.$Bj)("filter-filled",60366),wand:(0,i.$Bj)("wand",60367),debugLineByLine:(0,i.$Bj)("debug-line-by-line",60368),inspect:(0,i.$Bj)("inspect",60369),layers:(0,i.$Bj)("layers",60370),layersDot:(0,i.$Bj)("layers-dot",60371),layersActive:(0,i.$Bj)("layers-active",60372),compass:(0,i.$Bj)("compass",60373),compassDot:(0,i.$Bj)("compass-dot",60374),compassActive:(0,i.$Bj)("compass-active",60375),azure:(0,i.$Bj)("azure",60376),issueDraft:(0,i.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Bj)("git-pull-request-draft",60379),debugAll:(0,i.$Bj)("debug-all",60380),debugCoverage:(0,i.$Bj)("debug-coverage",60381),runErrors:(0,i.$Bj)("run-errors",60382),folderLibrary:(0,i.$Bj)("folder-library",60383),debugContinueSmall:(0,i.$Bj)("debug-continue-small",60384),beakerStop:(0,i.$Bj)("beaker-stop",60385),graphLine:(0,i.$Bj)("graph-line",60386),graphScatter:(0,i.$Bj)("graph-scatter",60387),pieChart:(0,i.$Bj)("pie-chart",60388),bracket:(0,i.$Bj)("bracket",60175),bracketDot:(0,i.$Bj)("bracket-dot",60389),bracketError:(0,i.$Bj)("bracket-error",60390),lockSmall:(0,i.$Bj)("lock-small",60391),azureDevops:(0,i.$Bj)("azure-devops",60392),verifiedFilled:(0,i.$Bj)("verified-filled",60393),newline:(0,i.$Bj)("newline",60394),layout:(0,i.$Bj)("layout",60395),layoutActivitybarLeft:(0,i.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Bj)("layout-panel-right",60401),layoutPanel:(0,i.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Bj)("layout-statusbar",60405),layoutMenubar:(0,i.$Bj)("layout-menubar",60406),layoutCentered:(0,i.$Bj)("layout-centered",60407),target:(0,i.$Bj)("target",60408),indent:(0,i.$Bj)("indent",60409),recordSmall:(0,i.$Bj)("record-small",60410),errorSmall:(0,i.$Bj)("error-small",60411),terminalDecorationError:(0,i.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Bj)("layout-sidebar-left-off",60418),blank:(0,i.$Bj)("blank",60419),heartFilled:(0,i.$Bj)("heart-filled",60420),map:(0,i.$Bj)("map",60421),mapFilled:(0,i.$Bj)("map-filled",60422),circleSmall:(0,i.$Bj)("circle-small",60423),bellSlash:(0,i.$Bj)("bell-slash",60424),bellSlashDot:(0,i.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Bj)("search-fuzzy",60429),commentDraft:(0,i.$Bj)("comment-draft",60430),send:(0,i.$Bj)("send",60431),sparkle:(0,i.$Bj)("sparkle",60432),insert:(0,i.$Bj)("insert",60433),mic:(0,i.$Bj)("mic",60434),thumbsdownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Bj)("thumbsup-filled",60436),coffee:(0,i.$Bj)("coffee",60437),snake:(0,i.$Bj)("snake",60438),game:(0,i.$Bj)("game",60439),vr:(0,i.$Bj)("vr",60440),chip:(0,i.$Bj)("chip",60441),piano:(0,i.$Bj)("piano",60442),music:(0,i.$Bj)("music",60443),micFilled:(0,i.$Bj)("mic-filled",60444),repoFetch:(0,i.$Bj)("repo-fetch",60445),copilot:(0,i.$Bj)("copilot",60446),lightbulbSparkle:(0,i.$Bj)("lightbulb-sparkle",60447),robot:(0,i.$Bj)("robot",60448),sparkleFilled:(0,i.$Bj)("sparkle-filled",60449),diffSingle:(0,i.$Bj)("diff-single",60450),diffMultiple:(0,i.$Bj)("diff-multiple",60451),surroundWith:(0,i.$Bj)("surround-with",60452),share:(0,i.$Bj)("share",60453),gitStash:(0,i.$Bj)("git-stash",60454),gitStashApply:(0,i.$Bj)("git-stash-apply",60455),gitStashPop:(0,i.$Bj)("git-stash-pop",60456),vscode:(0,i.$Bj)("vscode",60457),vscodeInsiders:(0,i.$Bj)("vscode-insiders",60458),codeOss:(0,i.$Bj)("code-oss",60459),runCoverage:(0,i.$Bj)("run-coverage",60460),runAllCoverage:(0,i.$Bj)("run-all-coverage",60461),coverage:(0,i.$Bj)("coverage",60462),githubProject:(0,i.$Bj)("github-project",60463)}}),define(me[18],be([1,0,38,92]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gj=t.$Fj=void 0,t.$Ej=z;function z(){return Object.values(t.$Gj)}t.$Fj={dialogError:(0,i.$Bj)("dialog-error","error"),dialogWarning:(0,i.$Bj)("dialog-warning","warning"),dialogInfo:(0,i.$Bj)("dialog-info","info"),dialogClose:(0,i.$Bj)("dialog-close","close"),treeItemExpanded:(0,i.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Bj)("tree-item-loading","loading"),menuSelection:(0,i.$Bj)("menu-selection","check"),menuSubmenu:(0,i.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Bj)("toolbar-more","more"),quickInputBack:(0,i.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Bj)("drop-down-button",60084),symbolCustomColor:(0,i.$Bj)("symbol-customcolor",60252),exportIcon:(0,i.$Bj)("export",60332),workspaceUnspecified:(0,i.$Bj)("workspace-unspecified",60355),newLine:(0,i.$Bj)("newline",60394),thumbsDownFilled:(0,i.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Bj)("thumbsup-filled",60436),gitFetch:(0,i.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Bj)("debug-breakpoint-pending",60377)},t.$Gj={...N.$Dj,...t.$Fj}}),define(me[54],be([1,0,7]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nn=N,t.$On=z,t.$Pn=E,t.$Qn=b,t.$Rn=$,t.$Sn=w,t.$Tn=P,t.$Un=f,t.$Vn=d,t.$Wn=e,t.$Xn=s,t.$Yn=u;function N(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const p=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([v,l])=>{p[v]=l&&typeof l=="object"?N(l):l}),p}function z(m){if(!m||typeof m!="object")return m;const p=[m];for(;p.length>0;){const v=p.shift();Object.freeze(v);for(const l in v)if(H.call(v,l)){const g=v[l];typeof g=="object"&&!Object.isFrozen(g)&&!(0,i.$Xf)(g)&&p.push(g)}}return m}const H=Object.prototype.hasOwnProperty;function E(m,p){return A(m,p,new Set)}function A(m,p,v){if((0,i.$4f)(m))return m;const l=p(m);if(typeof l<"u")return l;if(Array.isArray(m)){const g=[];for(const r of m)g.push(A(r,p,v));return g}if((0,i.$Wf)(m)){if(v.has(m))throw new Error("Cannot clone recursive data-structure");v.add(m);const g={};for(const r in m)H.call(m,r)&&(g[r]=A(m[r],p,v));return v.delete(m),g}return m}function b(m,p,v=!0){return(0,i.$Wf)(m)?((0,i.$Wf)(p)&&Object.keys(p).forEach(l=>{l in m?v&&((0,i.$Wf)(m[l])&&(0,i.$Wf)(p[l])?b(m[l],p[l],v):m[l]=p[l]):m[l]=p[l]}),m):p}function $(m,p){if(m===p)return!0;if(m==null||p===null||p===void 0||typeof m!=typeof p||typeof m!="object"||Array.isArray(m)!==Array.isArray(p))return!1;let v,l;if(Array.isArray(m)){if(m.length!==p.length)return!1;for(v=0;v<m.length;v++)if(!$(m[v],p[v]))return!1}else{const g=[];for(l in m)g.push(l);g.sort();const r=[];for(l in p)r.push(l);if(r.sort(),!$(g,r))return!1;for(v=0;v<g.length;v++)if(!$(m[g[v]],p[g[v]]))return!1}return!0}function w(m){const p=new Set;return JSON.stringify(m,(v,l)=>{if((0,i.$Wf)(l)||Array.isArray(l)){if(p.has(l))return"[Circular]";p.add(l)}return l})}function P(m,p){const v=Object.create(null);return!m||!p||Object.keys(p).forEach(g=>{const r=m[g],S=p[g];$(r,S)||(v[g]=S)}),v}function f(m,p){const v=p.toLowerCase(),l=Object.keys(m).find(g=>g.toLowerCase()===v);return l?m[l]:m[p]}function d(m,p){const v=Object.create(null);for(const[l,g]of Object.entries(m))p(l,g)&&(v[l]=g);return v}function e(m){let p=[];for(;Object.prototype!==m;)p=p.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return p}function s(m){const p=[];for(const v of e(m))typeof m[v]=="function"&&p.push(v);return p}function u(m,p){const v=g=>function(){const r=Array.prototype.slice.call(arguments,0);return p(g,r)},l={};for(const g of m)l[g]=v(g);return l}}),define(me[19],be([1,0,18]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Hj=z;var N;(function(E){function A(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=A})(N||(t.ThemeColor=N={}));function z(E){return{id:E}}var H;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function b(p){const v=A.exec(p.id);if(!v)return b(i.$Gj.error);const[,l,g]=v,r=["codicon","codicon-"+l];return g&&r.push("codicon-modifier-"+g.substring(1)),r}E.asClassNameArray=b;function $(p){return b(p).join(" ")}E.asClassName=$;function w(p){return"."+b(p).join(".")}E.asCSSSelector=w;function P(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||N.isThemeColor(p.color))}E.isThemeIcon=P;const f=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function d(p){const v=f.exec(p);if(!v)return;const[,l]=v;return{id:l}}E.fromString=d;function e(p){return{id:p}}E.fromId=e;function s(p,v){let l=p.id;const g=l.lastIndexOf("~");return g!==-1&&(l=l.substring(0,g)),v&&(l=`${l}~${v}`),{id:l}}E.modify=s;function u(p){const v=p.id.lastIndexOf("~");if(v!==-1)return p.id.substring(v+1)}E.getModifier=u;function m(p,v){return p.id===v.id&&p.color?.id===v.color?.id}E.isEqual=m})(H||(t.ThemeIcon=H={}))}),define(me[39],be([1,0,37,10,19]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yk=b,t.$zk=w,t.$Ak=f,t.$Bk=d,t.$Ck=s,t.$Dk=u;const H="$(",E=new RegExp(`\\$\\(${z.ThemeIcon.iconNameExpression}(?:${z.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${E.source}`,"g");function b(m){return m.replace(A,(p,v)=>v?p:`\\${p}`)}const $=new RegExp(`\\\\${E.source}`,"g");function w(m){return m.replace($,p=>`\\${p}`)}const P=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function f(m){return m.indexOf(H)===-1?m:m.replace(P,(p,v,l,g)=>l?p:v||g||"")}function d(m){return m?m.replace(/\$\((.*?)\)/g,(p,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${z.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(m){e.lastIndex=0;let p="";const v=[];let l=0;for(;;){const g=e.lastIndex,r=e.exec(m),S=m.substring(g,r?.index);if(S.length>0){p+=S;for(let C=0;C<S.length;C++)v.push(l)}if(!r)break;l+=r[0].length}return{text:p,iconOffsets:v}}function u(m,p,v=!1){const{text:l,iconOffsets:g}=p;if(!g||g.length===0)return(0,i.$pk)(m,l,v);const r=(0,N.$5e)(l," "),S=l.length-r.length,C=(0,i.$pk)(m,r,v);if(C)for(const I of C){const M=g[I.start+S]+S;I.start+=M,I.end+=M}return C}}),define(me[93],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XV=t.$WV=void 0,t.$WV="vscode:contextmenu",t.$XV="vscode:onCloseContextMenu"}),define(me[94],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5V=void 0;class i{constructor(z,H){this.a=z,this.onMessage=H}send(z){try{this.a.send("vscode:message",z.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$5V=i}),define(me[31],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(me[95],be([1,0,93,31]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1V=H;let z=0;function H(A,b,$){const w=[],P=z++,f=`vscode:onContextMenu${P}`,d=(e,s,u)=>{w[s].click?.(u)};N.$O.once(f,d),N.$O.once(i.$XV,(e,s)=>{s===P&&(N.$O.removeListener(f,d),$?.())}),N.$O.send(i.$WV,P,A.map(e=>E(e,w)),f,b)}function E(A,b){const $={id:b.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return b.push(A),Array.isArray(A.submenu)&&($.submenu=A.submenu.map(w=>E(w,b))),$}}),define(me[55],be([8]),{}),define(me[96],be([8]),{}),define(me[97],be([8]),{}),define(me[98],be([8]),{}),define(me[99],be([1,0,97,98]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[100],be([8]),{}),define(me[101],be([8]),{}),define(me[102],be([8]),{}),define(me[103],be([8]),{}),define(me[104],be([8]),{}),define(me[105],be([8]),{}),define(me[106],be([8]),{}),define(me[107],be([8]),{}),define(me[108],be([8]),{}),define(me[109],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[110],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[111],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[112],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/hover/updatableHoverWidget",t)}),define(me[113],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[114],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[115],be([13,11]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[116],be([13,11]),function(se,t){return se.create("vs/base/common/actions",t)}),define(me[40],be([1,0,4,3,116]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3i=t.$2i=t.$1i=t.$Zi=t.$Yi=void 0,t.$4i=w;class H extends N.$Uc{constructor(f,d="",e="",s=!0,u){super(),this.h=this.B(new i.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=d,this.u=e,this.w=s,this.C=u}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,d){this.C&&await this.C(f)}}t.$Yi=H;class E extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$7d),this.onWillRun=this.f.event,this.m=this.B(new i.$7d),this.onDidRun=this.m.event}async run(f,d){if(!f.enabled)return;this.f.fire({action:f});let e;try{await this.u(f,d)}catch(s){e=s}this.m.fire({action:f,error:e})}async u(f,d){await f.run(d)}}t.$Zi=E;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let d=[];for(const e of f)e.length&&(d.length?d=[...d,new A,...e]:d=e);return d}static{this.ID="vs.actions.separator"}async run(){}}t.$1i=A;class b{get actions(){return this.a}constructor(f,d,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=d,this.class=s,this.a=e}async run(){}}t.$2i=b;class $ extends H{static{this.ID="vs.actions.empty"}constructor(){super($.ID,z.localize(0,null),void 0,!1)}}t.$3i=$;function w(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...f)=>P.run(...f),tooltip:P.label}}}),define(me[117],be([13,11]),function(se,t){return se.create("vs/base/common/platform",t)}),define(me[5],be([1,0,117]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=S,t.$D=x,t.$J=W,t.$g="en";let N=!1,z=!1,H=!1,E=!1,A=!1,b=!1,$=!1,w=!1,P=!1,f=!1,d,e=t.$g,s=t.$g,u,m;const p=globalThis;let v;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?v=p.vscode.process:typeof process<"u"&&(v=process);const l=typeof v?.versions?.electron=="string",g=l&&v?.type==="renderer";if(typeof v=="object"){N=v.platform==="win32",z=v.platform==="darwin",H=v.platform==="linux",E=H&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,$=l,P=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=t.$g,e=t.$g;const T=v.env.VSCODE_NLS_CONFIG;if(T)try{const R=JSON.parse(T),L=R.availableLanguages["*"];d=R.locale,s=R.osLocale,e=L||t.$g,u=R._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!g?(m=navigator.userAgent,N=m.indexOf("Windows")>=0,z=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=m.indexOf("Linux")>=0,f=m?.indexOf("Mobi")>=0,b=!0,d=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=d,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(r||(t.Platform=r={}));function S(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let C=0;z?C=1:N?C=3:H&&(C=2),t.$i=N,t.$j=z,t.$k=H,t.$l=E,t.$m=A,t.$n=$,t.$o=b,t.$p=b&&typeof p.importScripts=="function",t.$q=t.$p?p.origin:void 0,t.$r=w,t.$s=f,t.$t=P,t.$u=C,t.$v=m,t.$w=e;var I;(function(T){function R(){return t.$w}T.value=R;function L(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}T.isDefaultVariant=L;function X(){return t.$w==="en"}T.isDefault=X})(I||(t.Language=I={})),t.$x=d,t.$y=s,t.$z=u,t.$A=typeof p.postMessage=="function"&&!p.importScripts,t.$B=(()=>{if(t.$A){const T=[];p.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let X=0,J=T.length;X<J;X++){const de=T[X];if(de.id===L.data.vscodeScheduleAsyncWork){T.splice(X,1),de.callback();return}}});let R=0;return L=>{const X=++R;T.push({id:X,callback:L}),p.postMessage({vscodeScheduleAsyncWork:X},"*")}}return T=>setTimeout(T)})();var M;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=z||w?2:N?1:3;let O=!0,y=!1;function x(){if(!y){y=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,O=new Uint16Array(T.buffer)[0]===513}return O}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function W(T){return parseFloat(T)>=20}}),define(me[118],be([1,0,17,22,5]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.KeyboardSupport=void 0;var H;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$TQ={clipboard:{writeText:z.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:z.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:z.$m||i.$RQ()?0:navigator.keyboard||i.$NQ?1:2,touch:"ontouchstart"in N.$xQ||navigator.maxTouchPoints>0,pointerEvents:N.$xQ.PointerEvent&&("ontouchstart"in N.$xQ||navigator.maxTouchPoints>0)}}),define(me[15],be([1,0,17,48,81,5]),function(se,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=void 0,t.$ZQ=P,t.$1Q=f;function E(e){if(e.charCode){const u=String.fromCharCode(e.charCode).toUpperCase();return N.KeyCodeUtils.fromString(u)}const s=e.keyCode;if(s===3)return 7;if(i.$KQ)switch(s){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(i.$LQ){if(H.$j&&s===93)return 57;if(!H.$j&&s===92)return 57}return N.$hr[s]||0}const A=H.$j?256:2048,b=512,$=1024,w=H.$j?2048:256;function P(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function f(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${N.KeyCodeUtils.toString(e.keyCode)}')`}class d{constructor(s){this._standardKeyboardEventBrand=!0;const u=s;this.browserEvent=u,this.target=u.target,this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,this.altGraphKey=u.getModifierState("AltGraph"),this.keyCode=E(u),this.code=u.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let u=0;return this.ctrlKey&&(u|=A),this.altKey&&(u|=b),this.shiftKey&&(u|=$),this.metaKey&&(u|=w),u|=s,u}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new z.$pr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$2Q=d}),define(me[20],be([1,0,17,72,5]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YQ=t.$XQ=t.$WQ=void 0;class H{constructor($,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const P=N.$UQ.getPositionOfChildWindowRelativeToAncestorWindow($,w.view);this.posx-=P.left,this.posy-=P.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$WQ=H;class E extends H{constructor($,w){super($,w),this.dataTransfer=w.dataTransfer}}t.$XQ=E;class A{constructor($,w=0,P=0){this.browserEvent=$||null,this.target=$?$.target||$.targetNode||$.srcElement:null,this.deltaY=P,this.deltaX=w;let f=!1;if(i.$MQ){const d=navigator.userAgent.match(/Chrome\/(\d+)/);f=(d?parseInt(d[1]):123)<=122}if($){const d=$,e=$,s=$.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")f?this.deltaY=d.wheelDeltaY/(120*s):this.deltaY=d.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if($.type==="wheel"){const u=$;u.deltaMode===u.DOM_DELTA_LINE?i.$KQ&&!z.$j?this.deltaY=-$.deltaY/3:this.deltaY=-$.deltaY:this.deltaY=-$.deltaY/40}if(typeof d.wheelDeltaX<"u")i.$NQ&&z.$i?this.deltaX=-(d.wheelDeltaX/120):f?this.deltaX=d.wheelDeltaX/(120*s):this.deltaX=d.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-$.detail/3;else if($.type==="wheel"){const u=$;u.deltaMode===u.DOM_DELTA_LINE?i.$KQ&&!z.$j?this.deltaX=-$.deltaX/3:this.deltaX=-$.deltaX:this.deltaX=-$.deltaX/40}this.deltaY===0&&this.deltaX===0&&$.wheelDelta&&(f?this.deltaY=$.wheelDelta/(120*s):this.deltaY=$.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$YQ=A}),define(me[119],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let N;const z=globalThis.vscode;if(typeof z<"u"&&typeof z.process<"u"){const H=z.process;N={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=N.cwd,t.env=N.env,t.$ec=N.platform,t.$fc=N.arch}),define(me[25],be([1,0,119]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const N=65,z=97,H=90,E=122,A=46,b=47,$=92,w=58,P=63;class f extends Error{constructor(S,C,I){let M;typeof C=="string"&&C.indexOf("not ")===0?(M="must not be",C=C.replace(/^not /,"")):M="must be";const O=S.indexOf(".")!==-1?"property":"argument";let y=`The "${S}" ${O} ${M} of type ${C}`;y+=`. Received type ${typeof I}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,S){if(r===null||typeof r!="object")throw new f(S,"Object",r)}function e(r,S){if(typeof r!="string")throw new f(S,"string",r)}const s=i.$ec==="win32";function u(r){return r===b||r===$}function m(r){return r===b}function p(r){return r>=N&&r<=H||r>=z&&r<=E}function v(r,S,C,I){let M="",O=0,y=-1,x=0,W=0;for(let T=0;T<=r.length;++T){if(T<r.length)W=r.charCodeAt(T);else{if(I(W))break;W=b}if(I(W)){if(!(y===T-1||x===1))if(x===2){if(M.length<2||O!==2||M.charCodeAt(M.length-1)!==A||M.charCodeAt(M.length-2)!==A){if(M.length>2){const R=M.lastIndexOf(C);R===-1?(M="",O=0):(M=M.slice(0,R),O=M.length-1-M.lastIndexOf(C)),y=T,x=0;continue}else if(M.length!==0){M="",O=0,y=T,x=0;continue}}S&&(M+=M.length>0?`${C}..`:"..",O=2)}else M.length>0?M+=`${C}${r.slice(y+1,T)}`:M=r.slice(y+1,T),O=T-y-1;y=T,x=0}else W===A&&x!==-1?++x:x=-1}return M}function l(r,S){d(S,"pathObject");const C=S.dir||S.root,I=S.base||`${S.name||""}${S.ext||""}`;return C?C===S.root?`${C}${I}`:`${C}${r}${I}`:I}t.$gc={resolve(...r){let S="",C="",I=!1;for(let M=r.length-1;M>=-1;M--){let O;if(M>=0){if(O=r[M],e(O,"path"),O.length===0)continue}else S.length===0?O=i.cwd():(O=i.env[`=${S}`]||i.cwd(),(O===void 0||O.slice(0,2).toLowerCase()!==S.toLowerCase()&&O.charCodeAt(2)===$)&&(O=`${S}\\`));const y=O.length;let x=0,W="",T=!1;const R=O.charCodeAt(0);if(y===1)u(R)&&(x=1,T=!0);else if(u(R))if(T=!0,u(O.charCodeAt(1))){let L=2,X=L;for(;L<y&&!u(O.charCodeAt(L));)L++;if(L<y&&L!==X){const J=O.slice(X,L);for(X=L;L<y&&u(O.charCodeAt(L));)L++;if(L<y&&L!==X){for(X=L;L<y&&!u(O.charCodeAt(L));)L++;(L===y||L!==X)&&(W=`\\\\${J}\\${O.slice(X,L)}`,x=L)}}}else x=1;else p(R)&&O.charCodeAt(1)===w&&(W=O.slice(0,2),x=2,y>2&&u(O.charCodeAt(2))&&(T=!0,x=3));if(W.length>0)if(S.length>0){if(W.toLowerCase()!==S.toLowerCase())continue}else S=W;if(I){if(S.length>0)break}else if(C=`${O.slice(x)}\\${C}`,I=T,T&&S.length>0)break}return C=v(C,!I,"\\",u),I?`${S}\\${C}`:`${S}${C}`||"."},normalize(r){e(r,"path");const S=r.length;if(S===0)return".";let C=0,I,M=!1;const O=r.charCodeAt(0);if(S===1)return m(O)?"\\":r;if(u(O))if(M=!0,u(r.charCodeAt(1))){let x=2,W=x;for(;x<S&&!u(r.charCodeAt(x));)x++;if(x<S&&x!==W){const T=r.slice(W,x);for(W=x;x<S&&u(r.charCodeAt(x));)x++;if(x<S&&x!==W){for(W=x;x<S&&!u(r.charCodeAt(x));)x++;if(x===S)return`\\\\${T}\\${r.slice(W)}\\`;x!==W&&(I=`\\\\${T}\\${r.slice(W,x)}`,C=x)}}}else C=1;else p(O)&&r.charCodeAt(1)===w&&(I=r.slice(0,2),C=2,S>2&&u(r.charCodeAt(2))&&(M=!0,C=3));let y=C<S?v(r.slice(C),!M,"\\",u):"";return y.length===0&&!M&&(y="."),y.length>0&&u(r.charCodeAt(S-1))&&(y+="\\"),I===void 0?M?`\\${y}`:y:M?`${I}\\${y}`:`${I}${y}`},isAbsolute(r){e(r,"path");const S=r.length;if(S===0)return!1;const C=r.charCodeAt(0);return u(C)||S>2&&p(C)&&r.charCodeAt(1)===w&&u(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let S,C;for(let O=0;O<r.length;++O){const y=r[O];e(y,"path"),y.length>0&&(S===void 0?S=C=y:S+=`\\${y}`)}if(S===void 0)return".";let I=!0,M=0;if(typeof C=="string"&&u(C.charCodeAt(0))){++M;const O=C.length;O>1&&u(C.charCodeAt(1))&&(++M,O>2&&(u(C.charCodeAt(2))?++M:I=!1))}if(I){for(;M<S.length&&u(S.charCodeAt(M));)M++;M>=2&&(S=`\\${S.slice(M)}`)}return t.$gc.normalize(S)},relative(r,S){if(e(r,"from"),e(S,"to"),r===S)return"";const C=t.$gc.resolve(r),I=t.$gc.resolve(S);if(C===I||(r=C.toLowerCase(),S=I.toLowerCase(),r===S))return"";let M=0;for(;M<r.length&&r.charCodeAt(M)===$;)M++;let O=r.length;for(;O-1>M&&r.charCodeAt(O-1)===$;)O--;const y=O-M;let x=0;for(;x<S.length&&S.charCodeAt(x)===$;)x++;let W=S.length;for(;W-1>x&&S.charCodeAt(W-1)===$;)W--;const T=W-x,R=y<T?y:T;let L=-1,X=0;for(;X<R;X++){const de=r.charCodeAt(M+X);if(de!==S.charCodeAt(x+X))break;de===$&&(L=X)}if(X!==R){if(L===-1)return I}else{if(T>R){if(S.charCodeAt(x+X)===$)return I.slice(x+X+1);if(X===2)return I.slice(x+X)}y>R&&(r.charCodeAt(M+X)===$?L=X:X===2&&(L=3)),L===-1&&(L=0)}let J="";for(X=M+L+1;X<=O;++X)(X===O||r.charCodeAt(X)===$)&&(J+=J.length===0?"..":"\\..");return x+=L,J.length>0?`${J}${I.slice(x,W)}`:(I.charCodeAt(x)===$&&++x,I.slice(x,W))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const S=t.$gc.resolve(r);if(S.length<=2)return r;if(S.charCodeAt(0)===$){if(S.charCodeAt(1)===$){const C=S.charCodeAt(2);if(C!==P&&C!==A)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(p(S.charCodeAt(0))&&S.charCodeAt(1)===w&&S.charCodeAt(2)===$)return`\\\\?\\${S}`;return r},dirname(r){e(r,"path");const S=r.length;if(S===0)return".";let C=-1,I=0;const M=r.charCodeAt(0);if(S===1)return u(M)?r:".";if(u(M)){if(C=I=1,u(r.charCodeAt(1))){let x=2,W=x;for(;x<S&&!u(r.charCodeAt(x));)x++;if(x<S&&x!==W){for(W=x;x<S&&u(r.charCodeAt(x));)x++;if(x<S&&x!==W){for(W=x;x<S&&!u(r.charCodeAt(x));)x++;if(x===S)return r;x!==W&&(C=I=x+1)}}}}else p(M)&&r.charCodeAt(1)===w&&(C=S>2&&u(r.charCodeAt(2))?3:2,I=C);let O=-1,y=!0;for(let x=S-1;x>=I;--x)if(u(r.charCodeAt(x))){if(!y){O=x;break}}else y=!1;if(O===-1){if(C===-1)return".";O=C}return r.slice(0,O)},basename(r,S){S!==void 0&&e(S,"ext"),e(r,"path");let C=0,I=-1,M=!0,O;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(C=2),S!==void 0&&S.length>0&&S.length<=r.length){if(S===r)return"";let y=S.length-1,x=-1;for(O=r.length-1;O>=C;--O){const W=r.charCodeAt(O);if(u(W)){if(!M){C=O+1;break}}else x===-1&&(M=!1,x=O+1),y>=0&&(W===S.charCodeAt(y)?--y===-1&&(I=O):(y=-1,I=x))}return C===I?I=x:I===-1&&(I=r.length),r.slice(C,I)}for(O=r.length-1;O>=C;--O)if(u(r.charCodeAt(O))){if(!M){C=O+1;break}}else I===-1&&(M=!1,I=O+1);return I===-1?"":r.slice(C,I)},extname(r){e(r,"path");let S=0,C=-1,I=0,M=-1,O=!0,y=0;r.length>=2&&r.charCodeAt(1)===w&&p(r.charCodeAt(0))&&(S=I=2);for(let x=r.length-1;x>=S;--x){const W=r.charCodeAt(x);if(u(W)){if(!O){I=x+1;break}continue}M===-1&&(O=!1,M=x+1),W===A?C===-1?C=x:y!==1&&(y=1):C!==-1&&(y=-1)}return C===-1||M===-1||y===0||y===1&&C===M-1&&C===I+1?"":r.slice(C,M)},format:l.bind(null,"\\"),parse(r){e(r,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return S;const C=r.length;let I=0,M=r.charCodeAt(0);if(C===1)return u(M)?(S.root=S.dir=r,S):(S.base=S.name=r,S);if(u(M)){if(I=1,u(r.charCodeAt(1))){let L=2,X=L;for(;L<C&&!u(r.charCodeAt(L));)L++;if(L<C&&L!==X){for(X=L;L<C&&u(r.charCodeAt(L));)L++;if(L<C&&L!==X){for(X=L;L<C&&!u(r.charCodeAt(L));)L++;L===C?I=L:L!==X&&(I=L+1)}}}}else if(p(M)&&r.charCodeAt(1)===w){if(C<=2)return S.root=S.dir=r,S;if(I=2,u(r.charCodeAt(2))){if(C===3)return S.root=S.dir=r,S;I=3}}I>0&&(S.root=r.slice(0,I));let O=-1,y=I,x=-1,W=!0,T=r.length-1,R=0;for(;T>=I;--T){if(M=r.charCodeAt(T),u(M)){if(!W){y=T+1;break}continue}x===-1&&(W=!1,x=T+1),M===A?O===-1?O=T:R!==1&&(R=1):O!==-1&&(R=-1)}return x!==-1&&(O===-1||R===0||R===1&&O===x-1&&O===y+1?S.base=S.name=r.slice(y,x):(S.name=r.slice(y,O),S.base=r.slice(y,x),S.ext=r.slice(O,x))),y>0&&y!==I?S.dir=r.slice(0,y-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(s){const r=/\\/g;return()=>{const S=i.cwd().replace(r,"/");return S.slice(S.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...r){let S="",C=!1;for(let I=r.length-1;I>=-1&&!C;I--){const M=I>=0?r[I]:g();e(M,"path"),M.length!==0&&(S=`${M}/${S}`,C=M.charCodeAt(0)===b)}return S=v(S,!C,"/",m),C?`/${S}`:S.length>0?S:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const S=r.charCodeAt(0)===b,C=r.charCodeAt(r.length-1)===b;return r=v(r,!S,"/",m),r.length===0?S?"/":C?"./":".":(C&&(r+="/"),S?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===b},join(...r){if(r.length===0)return".";let S;for(let C=0;C<r.length;++C){const I=r[C];e(I,"path"),I.length>0&&(S===void 0?S=I:S+=`/${I}`)}return S===void 0?".":t.$hc.normalize(S)},relative(r,S){if(e(r,"from"),e(S,"to"),r===S||(r=t.$hc.resolve(r),S=t.$hc.resolve(S),r===S))return"";const C=1,I=r.length,M=I-C,O=1,y=S.length-O,x=M<y?M:y;let W=-1,T=0;for(;T<x;T++){const L=r.charCodeAt(C+T);if(L!==S.charCodeAt(O+T))break;L===b&&(W=T)}if(T===x)if(y>x){if(S.charCodeAt(O+T)===b)return S.slice(O+T+1);if(T===0)return S.slice(O+T)}else M>x&&(r.charCodeAt(C+T)===b?W=T:T===0&&(W=0));let R="";for(T=C+W+1;T<=I;++T)(T===I||r.charCodeAt(T)===b)&&(R+=R.length===0?"..":"/..");return`${R}${S.slice(O+W)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const S=r.charCodeAt(0)===b;let C=-1,I=!0;for(let M=r.length-1;M>=1;--M)if(r.charCodeAt(M)===b){if(!I){C=M;break}}else I=!1;return C===-1?S?"/":".":S&&C===1?"//":r.slice(0,C)},basename(r,S){S!==void 0&&e(S,"ext"),e(r,"path");let C=0,I=-1,M=!0,O;if(S!==void 0&&S.length>0&&S.length<=r.length){if(S===r)return"";let y=S.length-1,x=-1;for(O=r.length-1;O>=0;--O){const W=r.charCodeAt(O);if(W===b){if(!M){C=O+1;break}}else x===-1&&(M=!1,x=O+1),y>=0&&(W===S.charCodeAt(y)?--y===-1&&(I=O):(y=-1,I=x))}return C===I?I=x:I===-1&&(I=r.length),r.slice(C,I)}for(O=r.length-1;O>=0;--O)if(r.charCodeAt(O)===b){if(!M){C=O+1;break}}else I===-1&&(M=!1,I=O+1);return I===-1?"":r.slice(C,I)},extname(r){e(r,"path");let S=-1,C=0,I=-1,M=!0,O=0;for(let y=r.length-1;y>=0;--y){const x=r.charCodeAt(y);if(x===b){if(!M){C=y+1;break}continue}I===-1&&(M=!1,I=y+1),x===A?S===-1?S=y:O!==1&&(O=1):S!==-1&&(O=-1)}return S===-1||I===-1||O===0||O===1&&S===I-1&&S===C+1?"":r.slice(S,I)},format:l.bind(null,"/"),parse(r){e(r,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return S;const C=r.charCodeAt(0)===b;let I;C?(S.root="/",I=1):I=0;let M=-1,O=0,y=-1,x=!0,W=r.length-1,T=0;for(;W>=I;--W){const R=r.charCodeAt(W);if(R===b){if(!x){O=W+1;break}continue}y===-1&&(x=!1,y=W+1),R===A?M===-1?M=W:T!==1&&(T=1):M!==-1&&(T=-1)}if(y!==-1){const R=O===0&&C?1:O;M===-1||T===0||T===1&&M===y-1&&M===O+1?S.base=S.name=r.slice(R,y):(S.name=r.slice(R,M),S.base=r.slice(R,y),S.ext=r.slice(M,y))}return O>0?S.dir=r.slice(0,O-1):C&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=s?t.$gc.normalize:t.$hc.normalize,t.$jc=s?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=s?t.$gc.join:t.$hc.join,t.$lc=s?t.$gc.resolve:t.$hc.resolve,t.$mc=s?t.$gc.relative:t.$hc.relative,t.$nc=s?t.$gc.dirname:t.$hc.dirname,t.$oc=s?t.$gc.basename:t.$hc.basename,t.$pc=s?t.$gc.extname:t.$hc.extname,t.$qc=s?t.$gc.format:t.$hc.format,t.$rc=s?t.$gc.parse:t.$hc.parse,t.$sc=s?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=s?t.$gc.sep:t.$hc.sep,t.$uc=s?t.$gc.delimiter:t.$hc.delimiter}),define(me[120],be([1,0,25,5,10,7]),function(se,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ag=E,t.$bg=A,t.$cg=b,t.$dg=$,t.$eg=w,t.$fg=e,t.$gg=s,t.$hg=u,t.$ig=m,t.$jg=p,t.$kg=v,t.$lg=l,t.$mg=g,t.$ng=r,t.$og=S,t.$pg=M;function E(O){return O===47||O===92}function A(O){return O.replace(/[\\/]/g,i.$hc.sep)}function b(O){return O.indexOf("/")===-1&&(O=A(O)),/^[a-zA-Z]:(\/|$)/.test(O)&&(O="/"+O),O}function $(O,y=i.$hc.sep){if(!O)return"";const x=O.length,W=O.charCodeAt(0);if(E(W)){if(E(O.charCodeAt(1))&&!E(O.charCodeAt(2))){let R=3;const L=R;for(;R<x&&!E(O.charCodeAt(R));R++);if(L!==R&&!E(O.charCodeAt(R+1))){for(R+=1;R<x;R++)if(E(O.charCodeAt(R)))return O.slice(0,R+1).replace(/[\\/]/g,y)}}return y}else if(m(W)&&O.charCodeAt(1)===58)return E(O.charCodeAt(2))?O.slice(0,2)+y:O.slice(0,2);let T=O.indexOf("://");if(T!==-1){for(T+=3;T<x;T++)if(E(O.charCodeAt(T)))return O.slice(0,T+1)}return""}function w(O){if(!N.$i||!O||O.length<5)return!1;let y=O.charCodeAt(0);if(y!==92||(y=O.charCodeAt(1),y!==92))return!1;let x=2;const W=x;for(;x<O.length&&(y=O.charCodeAt(x),y!==92);x++);return!(W===x||(y=O.charCodeAt(x+1),isNaN(y)||y===92))}const P=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(O,y=N.$i){const x=y?P:f;return!(!O||O.length===0||/^\s+$/.test(O)||(x.lastIndex=0,x.test(O))||y&&d.test(O)||O==="."||O===".."||y&&O[O.length-1]==="."||y&&O.length!==O.trim().length||O.length>255)}function s(O,y,x){const W=O===y;return!x||W?W:!O||!y?!1:(0,z.$lf)(O,y)}function u(O,y,x,W=i.sep){if(O===y)return!0;if(!O||!y||y.length>O.length)return!1;if(x){if(!(0,z.$mf)(O,y))return!1;if(y.length===O.length)return!0;let R=y.length;return y.charAt(y.length-1)===W&&R--,O.charAt(R)===W}return y.charAt(y.length-1)!==W&&(y+=W),O.indexOf(y)===0}function m(O){return O>=65&&O<=90||O>=97&&O<=122}function p(O,y){return N.$i&&O.endsWith(":")&&(O+=i.sep),(0,i.$jc)(O)||(O=(0,i.$kc)(y,O)),O=(0,i.$ic)(O),N.$i?(O=(0,z.$6e)(O,i.sep),O.endsWith(":")&&(O+=i.sep)):(O=(0,z.$6e)(O,i.sep),O||(O=i.sep)),O}function v(O){const y=(0,i.$ic)(O);return N.$i?O.length>3?!1:l(y)&&(O.length===2||y.charCodeAt(2)===92):y===i.$hc.sep}function l(O,y=N.$i){return y?m(O.charCodeAt(0))&&O.charCodeAt(1)===58:!1}function g(O,y=N.$i){return l(O,y)?O[0]:void 0}function r(O,y,x){return y.length>O.length?-1:O===y?0:(x&&(O=O.toLowerCase(),y=y.toLowerCase()),O.indexOf(y))}function S(O){const y=O.split(":");let x,W,T;for(const R of y){const L=Number(R);(0,H.$Yf)(L)?W===void 0?W=L:T===void 0&&(T=L):x=x?[x,R].join(":"):R}if(!x)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:x,line:W!==void 0?W:void 0,column:T!==void 0?T:W!==void 0?1:void 0}}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function M(O,y,x=8){let W="";for(let R=0;R<x;R++){let L;R===0&&N.$i&&!y&&(x===3||x===4)?L=I:L=C,W+=L.charAt(Math.floor(Math.random()*L.length))}let T;return y?T=`${y}-${W}`:T=W,O?(0,i.$kc)(O,T):T}}),define(me[121],be([1,0,25]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=void 0,t.$ys=H,t.$zs=E,t.$As=A,t.$Bs=$,t.$xs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},z={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(w){const P=(0,i.$pc)(w),f=N[P.toLowerCase()];return f!==void 0?f:E(w)}function E(w){const P=(0,i.$pc)(w);return z[P.toLowerCase()]}function A(w){for(const P in z)if(z[P]===w)return P}const b=/^(.+)\/(.+?)(;.+)?$/;function $(w,P){const f=b.exec(w);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:P?void 0:w}}),define(me[16],be([1,0,25,5]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=l;const z=/^\w[\w\d+.-]*$/,H=/^\//,E=/^\/\//;function A(I,M){if(!I.scheme&&M)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${I.authority}", path: "${I.path}", query: "${I.query}", fragment: "${I.fragment}"}`);if(I.scheme&&!z.test(I.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(I.path){if(I.authority){if(!H.test(I.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(I.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(I,M){return!I&&!M?"file":I}function $(I,M){switch(I){case"https":case"http":case"file":M?M[0]!==P&&(M=P+M):M=P;break}return M}const w="",P="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(M){return M instanceof d?!0:M?typeof M.authority=="string"&&typeof M.fragment=="string"&&typeof M.path=="string"&&typeof M.query=="string"&&typeof M.scheme=="string"&&typeof M.fsPath=="string"&&typeof M.with=="function"&&typeof M.toString=="function":!1}constructor(M,O,y,x,W,T=!1){typeof M=="object"?(this.scheme=M.scheme||w,this.authority=M.authority||w,this.path=M.path||w,this.query=M.query||w,this.fragment=M.fragment||w):(this.scheme=b(M,T),this.authority=O||w,this.path=$(this.scheme,y||w),this.query=x||w,this.fragment=W||w,A(this,T))}get fsPath(){return l(this,!1)}with(M){if(!M)return this;let{scheme:O,authority:y,path:x,query:W,fragment:T}=M;return O===void 0?O=this.scheme:O===null&&(O=w),y===void 0?y=this.authority:y===null&&(y=w),x===void 0?x=this.path:x===null&&(x=w),W===void 0?W=this.query:W===null&&(W=w),T===void 0?T=this.fragment:T===null&&(T=w),O===this.scheme&&y===this.authority&&x===this.path&&W===this.query&&T===this.fragment?this:new u(O,y,x,W,T)}static parse(M,O=!1){const y=f.exec(M);return y?new u(y[2]||w,C(y[4]||w),C(y[5]||w),C(y[7]||w),C(y[9]||w),O):new u(w,w,w,w,w)}static file(M){let O=w;if(N.$i&&(M=M.replace(/\\/g,P)),M[0]===P&&M[1]===P){const y=M.indexOf(P,2);y===-1?(O=M.substring(2),M=P):(O=M.substring(2,y),M=M.substring(y)||P)}return new u("file",O,M,w,w)}static from(M,O){return new u(M.scheme,M.authority,M.path,M.query,M.fragment,O)}static joinPath(M,...O){if(!M.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return N.$i&&M.scheme==="file"?y=d.file(i.$gc.join(l(M,!0),...O)).path:y=i.$hc.join(M.path,...O),M.with({path:y})}toString(M=!1){return g(this,M)}toJSON(){return this}static revive(M){if(M){if(M instanceof d)return M;{const O=new u(M);return O._formatted=M.external??null,O._fsPath=M._sep===s?M.fsPath??null:null,O}}else return M}}t.URI=d;function e(I){return!I||typeof I!="object"?!1:typeof I.scheme=="string"&&(typeof I.authority=="string"||typeof I.authority>"u")&&(typeof I.path=="string"||typeof I.path>"u")&&(typeof I.query=="string"||typeof I.query>"u")&&(typeof I.fragment=="string"||typeof I.fragment>"u")}const s=N.$i?1:void 0;class u extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(M=!1){return M?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const M={$mid:1};return this._fsPath&&(M.fsPath=this._fsPath,M._sep=s),this._formatted&&(M.external=this._formatted),this.path&&(M.path=this.path),this.scheme&&(M.scheme=this.scheme),this.authority&&(M.authority=this.authority),this.query&&(M.query=this.query),this.fragment&&(M.fragment=this.fragment),M}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(I,M,O){let y,x=-1;for(let W=0;W<I.length;W++){const T=I.charCodeAt(W);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||M&&T===47||O&&T===91||O&&T===93||O&&T===58)x!==-1&&(y+=encodeURIComponent(I.substring(x,W)),x=-1),y!==void 0&&(y+=I.charAt(W));else{y===void 0&&(y=I.substr(0,W));const R=m[T];R!==void 0?(x!==-1&&(y+=encodeURIComponent(I.substring(x,W)),x=-1),y+=R):x===-1&&(x=W)}}return x!==-1&&(y+=encodeURIComponent(I.substring(x))),y!==void 0?y:I}function v(I){let M;for(let O=0;O<I.length;O++){const y=I.charCodeAt(O);y===35||y===63?(M===void 0&&(M=I.substr(0,O)),M+=m[y]):M!==void 0&&(M+=I[O])}return M!==void 0?M:I}function l(I,M){let O;return I.authority&&I.path.length>1&&I.scheme==="file"?O=`//${I.authority}${I.path}`:I.path.charCodeAt(0)===47&&(I.path.charCodeAt(1)>=65&&I.path.charCodeAt(1)<=90||I.path.charCodeAt(1)>=97&&I.path.charCodeAt(1)<=122)&&I.path.charCodeAt(2)===58?M?O=I.path.substr(1):O=I.path[1].toLowerCase()+I.path.substr(2):O=I.path,N.$i&&(O=O.replace(/\//g,"\\")),O}function g(I,M){const O=M?v:p;let y="",{scheme:x,authority:W,path:T,query:R,fragment:L}=I;if(x&&(y+=x,y+=":"),(W||x==="file")&&(y+=P,y+=P),W){let X=W.indexOf("@");if(X!==-1){const J=W.substr(0,X);W=W.substr(X+1),X=J.lastIndexOf(":"),X===-1?y+=O(J,!1,!1):(y+=O(J.substr(0,X),!1,!1),y+=":",y+=O(J.substr(X+1),!1,!0)),y+="@"}W=W.toLowerCase(),X=W.lastIndexOf(":"),X===-1?y+=O(W,!1,!0):(y+=O(W.substr(0,X),!1,!0),y+=W.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}y+=O(T,!0,!1)}return R&&(y+="?",y+=O(R,!1,!1)),L&&(y+="#",y+=M?L:p(L,!1,!1)),y}function r(I){try{return decodeURIComponent(I)}catch{return I.length>3?I.substr(0,3)+r(I.substr(3)):I}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(I){return I.match(S)?I.replace(S,M=>r(M)):I}}),define(me[56],be([1,0,36,16]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oh=z,t.$Ph=H,t.$Qh=A;function z(b){return JSON.stringify(b,E)}function H(b){let $=JSON.parse(b);return $=A($),$}function E(b,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function A(b,$=0){if(!b||$>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return N.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof i.$ue||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let w=0;w<b.length;++w)b[w]=A(b[w],$+1);else for(const w in b)Object.hasOwnProperty.call(b,w)&&(b[w]=A(b[w],$+1))}return b}}),define(me[32],be([1,0,6,5,10,16,25]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$ug=t.$tg=t.$sg=t.Schemas=void 0,t.$qg=b,t.$rg=$,t.$vg=P;var A;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.codeSetting="code-setting"})(A||(t.Schemas=A={}));function b(e,s){return H.URI.isUri(e)?(0,z.$lf)(e.scheme,s):(0,z.$mf)(e,s+":")}function $(e,...s){return s.some(u=>b(e,u))}t.$sg="vscode-tkn",t.$tg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,u){this.f=P(s,u)}getServerRootPath(){return this.f}get g(){return E.$hc.join(this.f,A.vscodeRemoteResource)}set(s,u,m){this.a[s]=u,this.b[s]=m}setConnectionToken(s,u){this.c[s]=u}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(g){return i.$1(g),s}const u=s.authority;let m=this.a[u];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[u],v=this.c[u];let l=`path=${encodeURIComponent(s.path)}`;return typeof v=="string"&&(l+=`&${t.$tg}=${encodeURIComponent(v)}`),H.URI.from({scheme:N.$o?this.d:A.vscodeRemoteResource,authority:`${m}:${p}`,path:this.g,query:l})}}t.$ug=new w;function P(e,s){return E.$hc.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$wg="vs/../../extensions",t.$xg="vs/../../node_modules",t.$yg="vs/../../node_modules.asar",t.$zg="vs/../../node_modules.asar.unpacked",t.$Ag="vscode-app";class f{static{this.a=t.$Ag}asBrowserUri(s){const u=this.b(s,se);return this.uriToBrowserUri(u)}uriToBrowserUri(s){return s.scheme===A.vscodeRemote?t.$ug.rewrite(s):s.scheme===A.file&&(N.$m||N.$q===`${A.vscodeFileResource}://${f.a}`)?s.with({scheme:A.vscodeFileResource,authority:s.authority||f.a,query:null,fragment:null}):s}asFileUri(s){const u=this.b(s,se);return this.uriToFileUri(u)}uriToFileUri(s){return s.scheme===A.vscodeFileResource?s.with({scheme:A.file,authority:s.authority!==f.a?s.authority:null,query:null,fragment:null}):s}b(s,u){return H.URI.isUri(s)?s:H.URI.parse(u.toUrl(s))}}t.$Bg=new f;var d;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const u="vscode-coi";function m(v){let l;typeof v=="string"?l=new URL(v).searchParams:v instanceof URL?l=v.searchParams:H.URI.isUri(v)&&(l=new URL(v.toString(!0)).searchParams);const g=l?.get(u);if(g)return s.get(g)}e.getHeadersFromQuery=m;function p(v,l,g){if(!globalThis.crossOriginIsolated)return;const r=l&&g?"3":g?"2":"1";v instanceof URLSearchParams?v.set(u,r):v[u]=r}e.addSearchParam=p})(d||(t.COI=d={}))}),define(me[41],be([1,0,120,32,25,5,10,16]),function(se,t,i,N,z,H,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=void 0,t.$Ig=b,t.$4g=w,t.$5g=f;function b(d){return(0,A.$xc)(d,!0)}class ${constructor(e){this.a=e}compare(e,s,u=!1){return e===s?0:(0,E.$ef)(this.getComparisonKey(e,u),this.getComparisonKey(s,u))}isEqual(e,s,u=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,u)===this.getComparisonKey(s,u)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,u=!1){if(e.scheme===s.scheme){if(e.scheme===N.Schemas.file)return i.$hg(b(e),b(s),this.a(e))&&e.query===s.query&&(u||e.fragment===s.fragment);if((0,t.$Zg)(e.authority,s.authority))return i.$hg(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(u||e.fragment===s.fragment)}return!1}joinPath(e,...s){return A.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Rg)(e)||e.authority}basename(e){return z.$hc.basename(e.path)}extname(e){return z.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===N.Schemas.file?s=A.URI.file(z.$nc(b(e))).path:(s=z.$hc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===N.Schemas.file?s=A.URI.file(z.$ic(b(e))).path:s=z.$hc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Zg)(e.authority,s.authority))return;if(e.scheme===N.Schemas.file){const p=z.$mc(b(e),b(s));return H.$i?i.$bg(p):p}let u=e.path||"/";const m=s.path||"/";if(this.a(e)){let p=0;for(const v=Math.min(u.length,m.length);p<v&&!(u.charCodeAt(p)!==m.charCodeAt(p)&&u.charAt(p).toLowerCase()!==m.charAt(p).toLowerCase());p++);u=m.substr(0,p)+u.substr(p)}return z.$hc.relative(u,m)}resolvePath(e,s){if(e.scheme===N.Schemas.file){const u=A.URI.file(z.$lc(b(e),s));return e.with({authority:u.authority,path:u.path})}return s=i.$cg(s),e.with({path:z.$hc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,E.$lf)(e,s)}hasTrailingPathSeparator(e,s=z.sep){if(e.scheme===N.Schemas.file){const u=b(e);return u.length>i.$dg(u).length&&u[u.length-1]===s}else{const u=e.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=z.sep){return(0,t.$1g)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=z.sep){let u=!1;if(e.scheme===N.Schemas.file){const m=b(e);u=m!==void 0&&m.length===i.$dg(m).length&&m[m.length-1]===s}else{s="/";const m=e.path;u=m.length===1&&m.charCodeAt(m.length-1)===47}return!u&&!(0,t.$1g)(e,s)?e.with({path:e.path+"/"}):e}}t.$Jg=$,t.$Kg=new $(()=>!1),t.$Lg=new $(d=>d.scheme===N.Schemas.file?!H.$k:!0),t.$Mg=new $(d=>!0),t.$Ng=t.$Kg.isEqual.bind(t.$Kg),t.$Og=t.$Kg.isEqualOrParent.bind(t.$Kg),t.$Pg=t.$Kg.getComparisonKey.bind(t.$Kg),t.$Qg=t.$Kg.basenameOrAuthority.bind(t.$Kg),t.$Rg=t.$Kg.basename.bind(t.$Kg),t.$Sg=t.$Kg.extname.bind(t.$Kg),t.$Tg=t.$Kg.dirname.bind(t.$Kg),t.$Ug=t.$Kg.joinPath.bind(t.$Kg),t.$Vg=t.$Kg.normalizePath.bind(t.$Kg),t.$Wg=t.$Kg.relativePath.bind(t.$Kg),t.$Xg=t.$Kg.resolvePath.bind(t.$Kg),t.$Yg=t.$Kg.isAbsolutePath.bind(t.$Kg),t.$Zg=t.$Kg.isEqualAuthority.bind(t.$Kg),t.$1g=t.$Kg.hasTrailingPathSeparator.bind(t.$Kg),t.$2g=t.$Kg.removeTrailingPathSeparator.bind(t.$Kg),t.$3g=t.$Kg.addTrailingPathSeparator.bind(t.$Kg);function w(d,e){const s=[];for(let u=0;u<d.length;u++){const m=e(d[u]);d.some((p,v)=>v===u?!1:(0,t.$Og)(m,e(p)))||s.push(d[u])}return s}var P;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function e(s){const u=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(v=>{const[l,g]=v.split(":");l&&g&&u.set(l,g)});const p=s.path.substring(0,s.path.indexOf(";"));return p&&u.set(d.META_DATA_MIME,p),u}d.parseMetaData=e})(P||(t.DataUri=P={}));function f(d,e,s){if(e){let u=d.path;return u&&u[0]!==z.$hc.sep&&(u=z.$hc.sep+u),d.with({scheme:s,authority:e,path:u})}return d.with({scheme:s})}}),define(me[9],be([1,0,30,6,4,3,41,5,53,23]),function(se,t,i,N,z,H,E,A,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.Promises=t.$Eh=t.$Dh=t.$Ch=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=void 0,t.$6g=w,t.$7g=P,t.$8g=f,t.$9g=d,t.$0g=e,t.$$g=s,t.$_g=u,t.$ah=m,t.$ih=O,t.$jh=y,t.$kh=x,t.$lh=W,t.$mh=T,t.$Bh=U,t.$Jh=c;function w(D){return!!D&&typeof D.then=="function"}function P(D){const o=new i.$ee,a=D(o.token),n=new Promise((h,F)=>{const B=o.token.onCancellationRequested(()=>{B.dispose(),F(new N.$5)});Promise.resolve(a).then(j=>{B.dispose(),o.dispose(),h(j)},j=>{B.dispose(),o.dispose(),F(j)})});return new class{cancel(){o.cancel(),o.dispose()}then(h,F){return n.then(h,F)}catch(h){return this.then(void 0,h)}finally(h){return n.finally(h)}}}function f(D,o,a){return new Promise((n,h)=>{const F=o.onCancellationRequested(()=>{F.dispose(),n(a)});D.then(n,h).finally(()=>F.dispose())})}function d(D,o){return new Promise((a,n)=>{const h=o.onCancellationRequested(()=>{h.dispose(),n(new N.$5)});D.then(a,n).finally(()=>h.dispose())})}async function e(D){let o=-1;const a=D.map((n,h)=>n.then(F=>(o=h,F)));try{return await Promise.race(a)}finally{D.forEach((n,h)=>{h!==o&&n.cancel()})}}function s(D,o,a){let n;const h=setTimeout(()=>{n?.(void 0),a?.()},o);return Promise.race([D.finally(()=>clearTimeout(h)),new Promise(F=>n=F)])}function u(D){return new Promise((o,a)=>{const n=D();w(n)?n.then(o,a):o(n)})}function m(){let D,o;return{promise:new Promise((n,h)=>{D=n,o=h}),resolve:D,reject:o}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const a=()=>{if(this.b=null,this.f)return;const n=this.queue(this.d);return this.d=null,n};this.b=new Promise(n=>{this.a.then(a,a).then(n)})}return new Promise((a,n)=>{this.b.then(a,n)})}return this.a=o(),new Promise((a,n)=>{this.a.then(h=>{this.a=null,a(h)},h=>{this.a=null,n(h)})})}dispose(){this.f=!0}}t.$bh=p;class v{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}t.$ch=v;class l{constructor(){this.a=new Map}queue(o,a){const h=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(a).finally(()=>{this.a.get(o)===h&&this.a.delete(o)});return this.a.set(o,h),h}}t.$dh=l;const g=(D,o)=>{let a=!0;const n=setTimeout(()=>{a=!1,o()},D);return{isTriggered:()=>a,dispose:()=>{clearTimeout(n),a=!1}}},r=D=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,D())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class S{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,a=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((h,F)=>{this.d=h,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const h=this.g;return this.g=null,h()}}));const n=()=>{this.a=null,this.d?.(null)};return this.a=a===b.$4d?r(n):g(a,n),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$eh=S;class C{constructor(o){this.a=new S(o),this.b=new p}trigger(o,a){return this.a.trigger(()=>this.b.queue(o),a)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$fh=C;class I{constructor(){this.a=!1,this.b=new Promise((o,a)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$gh=I;class M extends I{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}t.$hh=M;function O(D,o){return o?new Promise((a,n)=>{const h=setTimeout(()=>{F.dispose(),a()},D),F=o.onCancellationRequested(()=>{clearTimeout(h),F.dispose(),n(new N.$5)})}):P(a=>O(D,a))}function y(D,o=0,a){const n=setTimeout(()=>{D(),a&&h.dispose()},o),h=(0,H.$Sc)(()=>{clearTimeout(n),a?.deleteAndLeak(h)});return a?.add(h),h}function x(D){const o=[];let a=0;const n=D.length;function h(){return a<n?D[a++]():null}function F(B){B!=null&&o.push(B);const j=h();return j?j.then(F):Promise.resolve(o)}return Promise.resolve(null).then(F)}function W(D,o=n=>!!n,a=null){let n=0;const h=D.length,F=()=>{if(n>=h)return Promise.resolve(a);const B=D[n++];return Promise.resolve(B()).then(V=>o(V)?Promise.resolve(V):F())};return F()}function T(D,o=n=>!!n,a=null){if(D.length===0)return Promise.resolve(a);let n=D.length;const h=()=>{n=-1;for(const F of D)F.cancel?.()};return new Promise((F,B)=>{for(const j of D)j.then(V=>{--n>=0&&o(V)?(h(),F(V)):n===0&&F(a)}).catch(V=>{--n>=0&&(h(),B(V))})})}class R{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new z.$7d}whenIdle(){return this.size>0?z.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((a,n)=>{this.g.push({factory:o,c:a,e:n}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const a=o.factory();a.then(o.c,o.e),a.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$nh=R;class L extends R{constructor(){super(1)}}t.$oh=L;class X{constructor(){this.a=new le,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}t.$ph=X;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new Q;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,a=E.$Kg){const n=a.getComparisonKey(o);return this.a.get(n)?.size??0}queueFor(o,a,n=E.$Kg){const h=n.getComparisonKey(o);let F=this.a.get(h);if(!F){F=new L;const B=this.f++,j=z.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(h),this.h(),this.d?.deleteAndDispose(B),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$4c),this.d.set(B,j),this.a.set(h,F)}return F.queue(a)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$qh=J;class de{constructor(o,a){this.a=-1,typeof o=="function"&&typeof a=="number"&&this.setIfNotSet(o,a)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,a){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},a)}setIfNotSet(o,a){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},a))}}t.$rh=de;class ae{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,a,n=globalThis){this.cancel();const h=n.setInterval(()=>{o()},a);this.d=(0,H.$Sc)(()=>{n.clearInterval(h),this.d=void 0})}dispose(){this.cancel()}}t.$sh=ae;class ie{constructor(o,a){this.b=-1,this.a=o,this.d=a,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$th=ie;class ge{constructor(o,a){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.a=o,this.b=a,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$uh=ge;class Fe extends ie{constructor(o,a){super(o,a),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}t.$vh=Fe;class Ne extends H.$Uc{constructor(o,a){super(),this.g=o,this.h=a,this.a=[],this.b=this.B(new H.$Vc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const a of o)this.a.push(a);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$wh=Ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$yh=(D,o)=>{(0,A.$B)(()=>{if(a)return;const n=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,n-Date.now())}}))});let a=!1;return{dispose(){a||(a=!0)}}}:t.$yh=(D,o,a)=>{const n=D.requestIdleCallback(o,typeof a=="number"?{timeout:a}:void 0);let h=!1;return{dispose(){h||(h=!0,D.cancelIdleCallback(n))}}},t.$xh=D=>(0,t.$yh)(globalThis,D)}();class Pe{constructor(o,a){this.g=!1,this.d=()=>{try{this.j=a()}catch(n){this.l=n}finally{this.g=!0}},this.f=(0,t.$yh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$zh=Pe;class oe extends Pe{constructor(o){super(globalThis,o)}}t.$Ah=oe;async function U(D,o,a){let n;for(let h=0;h<a;h++)try{return await D()}catch(F){n=F,await O(o)}throw n}class le{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,a,n){return this.a={taskId:o,cancel:()=>n?.(),promise:a},a.then(()=>this.d(o),()=>this.d(o)),a}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:a,resolve:n,reject:h}=m();this.b={run:o,promise:a,promiseResolve:n,promiseReject:h}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Ch=le;class re{constructor(o,a=()=>Date.now()){this.d=o,this.f=a,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}t.$Dh=re;var Y;(function(D){D[D.Resolved=0]="Resolved",D[D.Rejected=1]="Rejected"})(Y||(Y={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,a)=>{this.a=o,this.b=a})}complete(o){return new Promise(a=>{this.a(o),this.d={outcome:0,value:o},a()})}error(o){return new Promise(a=>{this.b(o),this.d={outcome:1,value:o},a()})}cancel(){return this.error(new N.$5)}}t.$Eh=Q;var te;(function(D){async function o(n){let h;const F=await Promise.all(n.map(B=>B.then(j=>j,j=>{h||(h=j)})));if(typeof h<"u")throw h;return F}D.settled=o;function a(n){return new Promise(async(h,F)=>{try{await n(h,F)}catch(B){F(B)}})}D.withAsyncBody=a})(te||(t.Promises=te={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(a=>(this.a=a,this.d=!0,a),a=>{throw this.b=a,this.d=!0,a})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Fh=ue;class ye{constructor(o){this.b=o,this.a=new $.$V(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Gh=ye;var Te;(function(D){D[D.Initial=0]="Initial",D[D.DoneOK=1]="DoneOK",D[D.DoneError=2]="DoneError"})(Te||(Te={}));class Ee{static fromArray(o){return new Ee(a=>{a.emitMany(o)})}static fromPromise(o){return new Ee(async a=>{a.emitMany(await o)})}static fromPromises(o){return new Ee(async a=>{await Promise.all(o.map(async n=>a.emitOne(await n)))})}static merge(o){return new Ee(async a=>{await Promise.all(o.map(async n=>{for await(const h of n)a.emitOne(h)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new z.$7d,queueMicrotask(async()=>{const a={emitOne:n=>this.g(n),emitMany:n=>this.h(n),reject:n=>this.k(n)};try{await Promise.resolve(o(a)),this.j()}catch(n){this.k(n)}finally{a.emitOne=void 0,a.emitMany=void 0,a.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await z.Event.toPromise(this.f.event)}while(!0)}}}static map(o,a){return new Ee(async n=>{for await(const h of o)n.emitOne(a(h))})}map(o){return Ee.map(this,o)}static filter(o,a){return new Ee(async n=>{for await(const h of o)a(h)&&n.emitOne(h)})}filter(o){return Ee.filter(this,o)}static coalesce(o){return Ee.filter(o,a=>!!a)}coalesce(){return Ee.coalesce(this)}static async toPromise(o){const a=[];for await(const n of o)a.push(n);return a}toPromise(){return Ee.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}t.$Hh=Ee;class fe extends Ee{constructor(o,a){super(a),this.l=o}cancel(){this.l.cancel()}}t.$Ih=fe;function c(D){const o=new i.$ee,a=D(o.token);return new fe(o,async n=>{const h=o.token.onCancellationRequested(()=>{h.dispose(),o.dispose(),n.reject(new N.$5)});try{for await(const F of a){if(o.token.isCancellationRequested)return;n.emitOne(F)}h.dispose(),o.dispose()}catch(F){h.dispose(),o.dispose(),n.reject(F)}})}class k{constructor(){this.a=new Q,this.b=new Ee(n=>{if(o){n.reject(o);return}return a&&n.emitMany(a),this.d=h=>n.reject(h),this.f=h=>n.emitOne(h),this.a.p});let o,a;this.f=n=>{a||(a=[]),a.push(n)},this.d=n=>{o||(o=n)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}t.$Kh=k}),define(me[2],be([1,0,17,118,15,20,9,6,4,122,3,32,5,16,52,22]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e,s){"use strict";var u;Object.defineProperty(t,"__esModule",{value:!0}),t.$uS=t.$sS=t.$pS=t.DetectedFullscreenMode=t.Namespace=t.$ZR=t.$XR=t.$OR=t.$kR=t.$eR=t.$cR=t.$bR=t.$aR=t.$8Q=t.$7Q=t.$6Q=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$4Q=m,t.$5Q=v,t.$9Q=I,t.$0Q=M,t.$$Q=O,t.$_Q=y,t.$dR=W,t.$fR=L,t.$gR=X,t.$hR=ie,t.$iR=ge,t.$jR=Fe,t.$lR=oe,t.$mR=U,t.$nR=le,t.$oR=re,t.$pR=Y,t.$qR=Q,t.$rR=te,t.$sR=ue,t.$tR=ye,t.$uR=Te,t.$vR=fe,t.$wR=c,t.$xR=D,t.$yR=a,t.$zR=n,t.$AR=h,t.$BR=F,t.$CR=B,t.$DR=j,t.$ER=V,t.$FR=Z,t.$GR=_,t.$HR=$e,t.$IR=ve,t.$JR=we,t.$KR=Se,t.$LR=Ae,t.$MR=Re,t.$NR=Xe,t.$PR=Ge,t.$QR=Ue,t.$RR=Le,t.$SR=ze,t.$TR=_e,t.$UR=tt,t.$VR=st,t.$WR=Je,t.$YR=rt,t.$1R=et,t.$2R=mt,t.$3R=kt,t.$4R=St,t.$5R=Bt,t.$6R=Oe,t.$7R=he,t.$=it,t.$9R=at,t.$0R=Ye,t.$$R=ut,t.$_R=$t,t.$aS=Yt,t.$bS=Ai,t.$cS=ki,t.$dS=Si,t.$eS=Bi,t.$fS=Ti,t.$gS=Fi,t.$hS=Ni,t.$iS=Ci,t.$jS=Ri,t.$kS=Ut,t.$lS=Li,t.$mS=Ii,t.$nS=Mi,t.$oS=_t,t.$qS=Oi,t.$rS=zi,t.$tS=Hi,t.h=qi,t.$wS=ti,t.$xS=Qi,u=function(){const q=new Map;(0,s.$wQ)(s.$xQ,1);const K={window:s.$xQ,disposables:new w.$Tc};q.set(s.$xQ.vscodeWindowId,K);const ee=new b.$7d,ce=new b.$7d,ke=new b.$7d;function xe(je,We){return(typeof je=="number"?q.get(je):void 0)??(We?K:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:ke.event,onDidUnregisterWindow:ce.event,registerWindow(je){if(q.has(je.vscodeWindowId))return w.$Uc.None;const We=new w.$Tc,qe={window:je,disposables:We.add(new w.$Tc)};return q.set(je.vscodeWindowId,qe),We.add((0,w.$Sc)(()=>{q.delete(je.vscodeWindowId),ce.fire(je)})),We.add(v(je,t.$XR.BEFORE_UNLOAD,()=>{ke.fire(je)})),ee.fire(qe),We},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(je){return je.vscodeWindowId},hasWindow(je){return q.has(je)},getWindowById:xe,getWindow(je){const We=je;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const qe=je;return qe?.view?qe.view.window:s.$xQ},getDocument(je){const We=je;return(0,t.getWindow)(We).document}}}(),t.registerWindow=u.registerWindow,t.getWindow=u.getWindow,t.getDocument=u.getDocument,t.getWindows=u.getWindows,t.getWindowsCount=u.getWindowsCount,t.getWindowId=u.getWindowId,t.getWindowById=u.getWindowById,t.hasWindow=u.hasWindow,t.onDidRegisterWindow=u.onDidRegisterWindow,t.onWillUnregisterWindow=u.onWillUnregisterWindow,t.onDidUnregisterWindow=u.onDidUnregisterWindow;function m(q){for(;q.firstChild;)q.firstChild.remove()}class p{constructor(K,ee,ce,ke){this.f=K,this.g=ee,this.d=ce,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function v(q,K,ee,ce){return new p(q,K,ee,ce)}function l(q,K){return function(ee){return K(new H.$WQ(q,ee))}}function g(q){return function(K){return q(new z.$2Q(K))}}const r=function(K,ee,ce,ke){let xe=ce;return ee==="click"||ee==="mousedown"?xe=l((0,t.getWindow)(K),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(xe=g(ce)),v(K,ee,xe,ke)};t.$6Q=r;const S=function(K,ee,ce){const ke=l((0,t.getWindow)(K),ee);return I(K,ke,ce)};t.$7Q=S;const C=function(K,ee,ce){const ke=l((0,t.getWindow)(K),ee);return O(K,ke,ce)};t.$8Q=C;function I(q,K,ee){return v(q,f.$r&&N.$TQ.pointerEvents?t.$XR.POINTER_DOWN:t.$XR.MOUSE_DOWN,K,ee)}function M(q,K,ee){return v(q,f.$r&&N.$TQ.pointerEvents?t.$XR.POINTER_MOVE:t.$XR.MOUSE_MOVE,K,ee)}function O(q,K,ee){return v(q,f.$r&&N.$TQ.pointerEvents?t.$XR.POINTER_UP:t.$XR.MOUSE_UP,K,ee)}function y(q,K,ee){return(0,E.$yh)(q,K,ee)}class x extends E.$zh{constructor(K,ee){super(K,ee)}}t.$aR=x;function W(q,K,ee,ce){let ke=0;const xe=q.setInterval(()=>{ke++,(typeof ce=="number"&&ke>=ce||K()===!0)&&je.dispose()},ee),je=(0,w.$Sc)(()=>{q.clearInterval(xe)});return je}class T extends E.$sh{constructor(K){super(),this.f=K&&(0,t.getWindow)(K)}cancelAndSet(K,ee,ce){return super.cancelAndSet(K,ee,ce??this.f)}}t.$eR=T;class R{constructor(K,ee=0){this.d=K,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,A.$1)(K)}}static sort(K,ee){return ee.priority-K.priority}}(function(){const q=new Map,K=new Map,ee=new Map,ce=new Map,ke=xe=>{ee.set(xe,!1);const je=q.get(xe)??[];for(K.set(xe,je),q.set(xe,[]),ce.set(xe,!0);je.length>0;)je.sort(R.sort),je.shift().execute();ce.set(xe,!1)};t.$cR=(xe,je,We=0)=>{const qe=(0,t.getWindowId)(xe),Qe=new R(je,We);let lt=q.get(qe);return lt||(lt=[],q.set(qe,lt)),lt.push(Qe),ee.get(qe)||(ee.set(qe,!0),xe.requestAnimationFrame(()=>ke(qe))),Qe},t.$bR=(xe,je,We)=>{const qe=(0,t.getWindowId)(xe);if(ce.get(qe)){const Qe=new R(je,We);let lt=K.get(qe);return lt||(lt=[],K.set(qe,lt)),lt.push(Qe),Qe}else return(0,t.$cR)(xe,je,We)}})();function L(q,K){return(0,t.$cR)(q,K,1e4)}function X(q,K){return(0,t.$cR)(q,K,-1e4)}const J=8,de=function(q,K){return K};class ae extends w.$Uc{constructor(K,ee,ce,ke=de,xe=J){super();let je=null,We=0;const qe=this.B(new E.$rh),Qe=()=>{We=new Date().getTime(),ce(je),je=null};this.B(v(K,ee,lt=>{je=ke(je,lt);const Ft=new Date().getTime()-We;Ft>=xe?(qe.cancel(),Qe()):qe.setIfNotSet(Qe,xe-Ft)}))}}function ie(q,K,ee,ce,ke){return new ae(q,K,ee,ce,ke)}function ge(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}function Fe(q,K){const ee=(0,t.getWindow)(q),ce=ee.document;if(q!==ce.body)return new Pe(q.clientWidth,q.clientHeight);if(f.$r&&ee?.visualViewport)return new Pe(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Pe(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Pe(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Pe(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(K)return Fe(K);throw new Error("Unable to figure out browser width and height")}class Ne{static d(K,ee){return parseFloat(ee)||0}static f(K,ee,ce){const ke=ge(K),xe=ke?ke.getPropertyValue(ee):"0";return Ne.d(K,xe)}static getBorderLeftWidth(K){return Ne.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return Ne.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return Ne.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return Ne.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return Ne.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return Ne.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return Ne.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return Ne.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return Ne.f(K,"margin-left","marginLeft")}static getMarginTop(K){return Ne.f(K,"margin-top","marginTop")}static getMarginRight(K){return Ne.f(K,"margin-right","marginRight")}static getMarginBottom(K){return Ne.f(K,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(K,ee){this.width=K,this.height=ee}with(K=this.width,ee=this.height){return K!==this.width||ee!==this.height?new Pe(K,ee):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof Pe?K:new Pe(K.width,K.height)}static equals(K,ee){return K===ee?!0:!K||!ee?!1:K.width===ee.width&&K.height===ee.height}}t.$kR=Pe;function oe(q){let K=q.offsetParent,ee=q.offsetTop,ce=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){ee-=q.scrollTop;const ke=F(q)?null:ge(q);ke&&(ce-=ke.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===K&&(ce+=Ne.getBorderLeftWidth(q),ee+=Ne.getBorderTopWidth(q),ee+=q.offsetTop,ce+=q.offsetLeft,K=q.offsetParent)}return{left:ce,top:ee}}function U(q,K,ee){typeof K=="number"&&(q.style.width=`${K}px`),typeof ee=="number"&&(q.style.height=`${ee}px`)}function le(q,K,ee,ce,ke,xe="absolute"){typeof K=="number"&&(q.style.top=`${K}px`),typeof ee=="number"&&(q.style.right=`${ee}px`),typeof ce=="number"&&(q.style.bottom=`${ce}px`),typeof ke=="number"&&(q.style.left=`${ke}px`),q.style.position=xe}function re(q){const K=q.getBoundingClientRect(),ee=(0,t.getWindow)(q);return{left:K.left+ee.scrollX,top:K.top+ee.scrollY,width:K.width,height:K.height}}function Y(q){let K=q,ee=1;do{const ce=ge(K).zoom;ce!=null&&ce!=="1"&&(ee*=ce),K=K.parentElement}while(K!==null&&K!==K.ownerDocument.documentElement);return ee}function Q(q){const K=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.offsetWidth+K}function te(q){const K=Ne.getBorderLeftWidth(q)+Ne.getBorderRightWidth(q),ee=Ne.getPaddingLeft(q)+Ne.getPaddingRight(q);return q.offsetWidth-K-ee}function ue(q){const K=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.scrollWidth+K}function ye(q){const K=Ne.getBorderTopWidth(q)+Ne.getBorderBottomWidth(q),ee=Ne.getPaddingTop(q)+Ne.getPaddingBottom(q);return q.offsetHeight-K-ee}function Te(q){const K=Ne.getMarginTop(q)+Ne.getMarginBottom(q);return q.offsetHeight+K}function Ee(q,K){if(q===null)return 0;const ee=oe(q),ce=oe(K);return ee.left-ce.left}function fe(q,K){const ee=K.map(ke=>Math.max(ue(ke),Q(ke))+Ee(ke,q)||0);return Math.max(...ee)}function c(q,K){return!!K?.contains(q)}const k="parentFlowToElementId";function D(q,K){q.dataset[k]=K.id}function o(q){const K=q.dataset[k];return typeof K=="string"?q.ownerDocument.getElementById(K):null}function a(q,K){let ee=q;for(;ee;){if(ee===K)return!0;if(ee instanceof HTMLElement){const ce=o(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}function n(q,K,ee){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(K))return q;if(ee){if(typeof ee=="string"){if(q.classList.contains(ee))return null}else if(q===ee)return null}q=q.parentNode}return null}function h(q,K,ee){return!!n(q,K,ee)}function F(q){return q&&!!q.host&&!!q.mode}function B(q){return!!j(q)}function j(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return F(q)?q:null}function V(){let q=ve().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}function Z(q){return V()===q}function _(q){return c(V(),q)}function $e(q){return q.ownerDocument===ve()}function ve(){return(0,t.getWindowsCount)()<=1?s.$xQ.document:Array.from((0,t.getWindows)()).map(({window:K})=>K.document).find(K=>K.hasFocus())??s.$xQ.document}function we(){return ve().defaultView?.window??s.$xQ}const Me=new Map;function Se(q){return Me.has(q)}function Ae(){return new Ce}class Ce{constructor(){this.d="",this.f=void 0}setStyle(K){K!==this.d&&(this.d=K,this.f?this.f.innerText=K:this.f=Re(s.$xQ.document.head,ee=>ee.innerText=K))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Re(q=s.$xQ.document.head,K,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",K?.(ce),q.appendChild(ce),ee&&ee.add((0,w.$Sc)(()=>q.removeChild(ce))),q===s.$xQ.document.head){const ke=new Set;Me.set(ce,ke);for(const{window:xe,disposables:je}of(0,t.getWindows)()){if(xe===s.$xQ)continue;const We=je.add(nt(ce,ke,xe));ee?.add(We)}}return ce}function Xe(q){const K=new w.$Tc;for(const[ee,ce]of Me)K.add(nt(ee,ce,q));return K}function nt(q,K,ee){const ce=new w.$Tc,ke=q.cloneNode(!0);ee.document.head.appendChild(ke),ce.add((0,w.$Sc)(()=>ee.document.head.removeChild(ke)));for(const xe of De(q))ke.sheet?.insertRule(xe.cssText,ke.sheet?.cssRules.length);return ce.add(t.$OR.observe(q,ce,{childList:!0})(()=>{ke.textContent=q.textContent})),K.add(ke),ce.add((0,w.$Sc)(()=>K.delete(ke))),ce}t.$OR=new class{constructor(){this.mutationObservers=new Map}observe(q,K,ee){let ce=this.mutationObservers.get(q);ce||(ce=new Map,this.mutationObservers.set(q,ce));const ke=(0,e.$8i)(ee);let xe=ce.get(ke);if(xe)xe.users+=1;else{const je=new b.$7d,We=new MutationObserver(Qe=>je.fire(Qe));We.observe(q,ee);const qe=xe={users:1,observer:We,onDidMutate:je.event};K.add((0,w.$Sc)(()=>{qe.users-=1,qe.users===0&&(je.dispose(),We.disconnect(),ce?.delete(ke),ce?.size===0&&this.mutationObservers.delete(q))})),ce.set(ke,xe)}return xe.onDidMutate}};function Ge(q=s.$xQ.document.head){return G("meta",q)}function Ue(q=s.$xQ.document.head){return G("link",q)}function G(q,K=s.$xQ.document.head){const ee=document.createElement(q);return K.appendChild(ee),ee}let ne=null;function pe(){return ne||(ne=Re()),ne}function De(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Le(q,K,ee=pe()){if(!(!ee||!K)){ee.sheet?.insertRule(`${q} {${K}}`,0);for(const ce of Me.get(ee)??[])Le(q,K,ce)}}function ze(q,K=pe()){if(!K)return;const ee=De(K),ce=[];for(let ke=0;ke<ee.length;ke++){const xe=ee[ke];Ve(xe)&&xe.selectorText.indexOf(q)!==-1&&ce.push(ke)}for(let ke=ce.length-1;ke>=0;ke--)K.sheet?.deleteRule(ce[ke]);for(const ke of Me.get(K)??[])ze(q,ke)}function Ve(q){return typeof q.selectorText=="string"}function _e(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}function tt(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}function st(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}function Je(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$XR={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$LQ?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$LQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$LQ?"webkitAnimationIteration":"animationiteration"};function rt(q){const K=q;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.$ZR={stop:(q,K)=>(q.preventDefault(),K&&q.stopPropagation(),q)};function et(q){const K=[];for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)K[ee]=q.scrollTop,q=q.parentNode;return K}function mt(q,K){for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)q.scrollTop!==K[ee]&&(q.scrollTop=K[ee]),q=q.parentNode}class gt extends w.$Uc{static m(K){if(K instanceof HTMLElement){const ee=j(K),ce=ee?ee.activeElement:K.ownerDocument.activeElement;return c(ce,K)}else{const ee=K;return c(ee.document.activeElement,ee.document)}}constructor(K){super(),this.f=this.B(new b.$7d),this.onDidFocus=this.f.event,this.g=this.B(new b.$7d),this.onDidBlur=this.g.event;let ee=gt.m(K),ce=!1;const ke=()=>{ce=!1,ee||(ee=!0,this.f.fire())},xe=()=>{ee&&(ce=!0,(K instanceof HTMLElement?(0,t.getWindow)(K):K).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{gt.m(K)!==ee&&(ee?xe():ke())},this.B(v(K,t.$XR.FOCUS,ke,!0)),this.B(v(K,t.$XR.BLUR,xe,!0)),K instanceof HTMLElement&&(this.B(v(K,t.$XR.FOCUS_IN,()=>this.j())),this.B(v(K,t.$XR.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function kt(q){return new gt(q)}function St(q,K){return q.after(K),K}function Bt(q,...K){if(q.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}function Oe(q,K){return q.insertBefore(K,q.firstChild),K}function he(q,...K){q.innerText="",Bt(q,...K)}const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Ie;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(Ie||(t.Namespace=Ie={}));function Ke(q,K,ee,...ce){const ke=Be.exec(K);if(!ke)throw new Error("Bad use of emmet");const xe=ke[1]||"div";let je;return q!==Ie.HTML?je=document.createElementNS(q,xe):je=document.createElement(xe),ke[3]&&(je.id=ke[3]),ke[4]&&(je.className=ke[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([We,qe])=>{typeof qe>"u"||(/^on\w+$/.test(We)?je[We]=qe:We==="selected"?qe&&je.setAttribute(We,"true"):je.setAttribute(We,qe))}),je.append(...ce),je}function it(q,K,...ee){return Ke(Ie.HTML,q,K,...ee)}it.SVG=function(q,K,...ee){return Ke(Ie.SVG,q,K,...ee)};function at(q,K){const ee=[];return q.forEach((ce,ke)=>{ke>0&&(K instanceof Node?ee.push(K.cloneNode()):ee.push(document.createTextNode(K))),ee.push(ce)}),ee}function Ye(q,...K){q?ut(...K):$t(...K)}function ut(...q){for(const K of q)K.style.display="",K.removeAttribute("aria-hidden")}function $t(...q){for(const K of q)K.style.display="none",K.setAttribute("aria-hidden","true")}function Tt(q,K){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(K))return q;q=q.parentNode}return null}function Yt(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Tt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}function Ai(q){return K=>{K.preventDefault(),K.stopPropagation(),q(K)}}function ki(q){return new Promise(K=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)K(void 0);else{const ce=()=>{q.window.removeEventListener("DOMContentLoaded",ce,!1),K()};q.window.addEventListener("DOMContentLoaded",ce,!1)}})}function Si(q,K){const ee=q.devicePixelRatio*K;return Math.max(1,Math.floor(ee))/q.devicePixelRatio}function Bi(q){s.$xQ.open(q,"_blank","noopener")}const Zt=780,Jt=640;function Ti(q){const K=Math.floor(s.$xQ.screenLeft+s.$xQ.innerWidth/2-Zt/2),ee=Math.floor(s.$xQ.screenTop+s.$xQ.innerHeight/2-Jt/2);s.$xQ.open(q,"_blank",`width=${Zt},height=${Jt},top=${ee},left=${K}`)}function Fi(q,K=!0){const ee=s.$xQ.open();return ee?(K&&(ee.opener=null),ee.location.href=q,!0):!1}function Ni(q,K){const ee=()=>{K(),ce=(0,t.$cR)(q,ee)};let ce=(0,t.$cR)(q,ee);return(0,w.$Sc)(()=>ce.dispose())}P.$ug.setPreferredWebSchema(/^https:/.test(s.$xQ.location.href)?"https":"http");function Ci(q){return q?`url('${P.$Bg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ri(q){return`'${q.replace(/'/g,"%27")}'`}function Ut(q,K){if(q!==void 0){const ee=q.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(K=Ut(ce[1].trim(),K)),`var(${ce[0]}, ${K})`}return q}return K}function Li(q,K){let ee;if(d.URI.isUri(q))ee=q.toString(!0);else{const xe=new Blob([q]);ee=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=we(),ke=document.createElement("a");ce.document.body.appendChild(ke),ke.download=K,ke.href=ee,ke.click(),setTimeout(()=>ce.document.body.removeChild(ke))}function Ii(){return new Promise(q=>{const K=we(),ee=document.createElement("input");K.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(ee,"input"))(()=>{q(ee.files??void 0)}),ee.click(),setTimeout(()=>K.document.body.removeChild(ee))})}var Dt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Mi(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:Dt.BROWSER,guess:!1}:(f.$j||f.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}function _t(q,K=!1){const ee=document.createElement("a");return $.addHook("afterSanitizeAttributes",ce=>{for(const ke of["href","src"])if(ce.hasAttribute(ke)){const xe=ce.getAttribute(ke);if(ke==="href"&&xe.startsWith("#"))continue;if(ee.href=xe,!q.includes(ee.protocol.replace(/:$/,""))){if(K&&ke==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(ke)}}}),(0,w.$Sc)(()=>{$.removeHook("afterSanitizeAttributes")})}const ji=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$pS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Oi(q,K){const ee=_t(ji);try{const ce=$.sanitize(K,Pi);q.innerHTML=ce}finally{ee.dispose()}}function xi(q){const K=new Uint16Array(q.length);for(let ke=0;ke<K.length;ke++)K[ke]=q.charCodeAt(ke);let ee="";const ce=new Uint8Array(K.buffer);for(let ke=0;ke<ce.length;ke++)ee+=String.fromCharCode(ce[ke]);return ee}function zi(q){return btoa(xi(q))}class pt extends b.$7d{constructor(){super(),this.o=new w.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:K,disposables:ee})=>this.C(K,ee),{window:s.$xQ,disposables:this.o}))}C(K,ee){ee.add(v(K,"keydown",ce=>{if(ce.defaultPrevented)return;const ke=new z.$2Q(ce);if(!(ke.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(ce.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(ke.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyPressed&&(this.A.event=ce,this.fire(this.A))}},!0)),ee.add(v(K,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!ce.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!ce.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!ce.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyReleased&&(this.A.event=ce,this.fire(this.A)))},!0)),ee.add(v(K.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(v(K.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add(v(K.document.body,"mousemove",ce=>{ce.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add(v(K,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$sS=pt;function Hi(q){const K=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}class Wi extends w.$Uc{constructor(K,ee){super(),this.j=K,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(v(this.j,t.$XR.DRAG_START,K=>{this.m.onDragStart?.(K)})),this.m.onDrag&&this.B(v(this.j,t.$XR.DRAG,K=>{this.m.onDrag?.(K)})),this.B(v(this.j,t.$XR.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.m.onDragEnter?.(K)})),this.B(v(this.j,t.$XR.DRAG_OVER,K=>{K.preventDefault(),this.m.onDragOver?.(K,K.timeStamp-this.g)})),this.B(v(this.j,t.$XR.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(K))})),this.B(v(this.j,t.$XR.DRAG_END,K=>{this.f=0,this.g=0,this.m.onDragEnd?.(K)})),this.B(v(this.j,t.$XR.DROP,K=>{this.f=0,this.g=0,this.m.onDrop?.(K)}))}}t.$uS=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(q,...K){let ee,ce;Array.isArray(K[0])?(ee={},ce=K[0]):(ee=K[0]||{},ce=K[1]);const ke=Vi.exec(q);if(!ke||!ke.groups)throw new Error("Bad use of h");const xe=ke.groups.tag||"div",je=document.createElement(xe);ke.groups.id&&(je.id=ke.groups.id);const We=[];if(ke.groups.class)for(const Qe of ke.groups.class.split("."))Qe!==""&&We.push(Qe);if(ee.className!==void 0)for(const Qe of ee.className.split("."))Qe!==""&&We.push(Qe);We.length>0&&(je.className=We.join(" "));const qe={};if(ke.groups.name&&(qe[ke.groups.name]=je),ce)for(const Qe of ce)Qe instanceof HTMLElement?je.appendChild(Qe):typeof Qe=="string"?je.append(Qe):"root"in Qe&&(Object.assign(qe,Qe),je.appendChild(Qe.root));for(const[Qe,lt]of Object.entries(ee))if(Qe!=="className")if(Qe==="style")for(const[Ft,Pt]of Object.entries(lt))je.style.setProperty(ei(Ft),typeof Pt=="number"?Pt+"px":""+Pt);else Qe==="tabIndex"?je.tabIndex=lt:je.setAttribute(ei(Qe),lt.toString());return qe.root=je,qe}function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,K,ee){for(const{name:ce,value:ke}of q.attributes)(!ee||ee.includes(ce))&&K.setAttribute(ce,ke)}function Ki(q,K,ee){const ce=q.getAttribute(ee);ce?K.setAttribute(ee,ce):K.removeAttribute(ee)}function Qi(q,K,ee){ti(q,K,ee);const ce=new w.$Tc;return ce.add(t.$OR.observe(q,ce,{attributes:!0,attributeFilter:ee})(ke=>{for(const xe of ke)xe.type==="attributes"&&xe.attributeName&&Ki(q,K,xe.attributeName)})),ce}}),define(me[57],be([1,0,2,3,121]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zS=t.$yS=void 0,t.$AS=E;class H extends N.$Uc{constructor(b,$){super(),this.B((0,i.$5Q)(b,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{$(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$5Q)(b,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$yS=H,t.$zS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:z.$xs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(A,b,$,w,P){const f=document.createElement("div");if(f.className=$,f.textContent=b,P&&(f.style.color=P),w&&(f.style.background=w),A.dataTransfer){const d=(0,i.getWindow)(A).document;d.body.appendChild(f),A.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>d.body.removeChild(f),0)}}}),define(me[58],be([1,0,2]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6S=N,t.$7S=z,t.$8S=H;function N(f,d={}){const e=H(d);return e.textContent=f,e}function z(f,d={}){const e=H(d);return b(e,$(f,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),e}function H(f){const d=f.inline?"span":"div",e=document.createElement(d);return f.className&&(e.className=f.className),e}class E{constructor(d){this.b=d,this.c=0}eos(){return this.c>=this.b.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(f){f[f.Invalid=0]="Invalid",f[f.Root=1]="Root",f[f.Text=2]="Text",f[f.Bold=3]="Bold",f[f.Italics=4]="Italics",f[f.Action=5]="Action",f[f.ActionClose=6]="ActionClose",f[f.Code=7]="Code",f[f.NewLine=8]="NewLine"})(A||(A={}));function b(f,d,e,s){let u;if(d.type===2)u=document.createTextNode(d.content||"");else if(d.type===3)u=document.createElement("b");else if(d.type===4)u=document.createElement("i");else if(d.type===7&&s)u=document.createElement("code");else if(d.type===5&&e){const m=document.createElement("a");e.disposables.add(i.$6Q(m,"click",p=>{e.callback(String(d.index),p)})),u=m}else d.type===8?u=document.createElement("br"):d.type===1&&(u=f);u&&f!==u&&f.appendChild(u),u&&Array.isArray(d.children)&&d.children.forEach(m=>{b(u,m,e,s)})}function $(f,d){const e={type:1,children:[]};let s=0,u=e;const m=[],p=new E(f);for(;!p.eos();){let v=p.next();const l=v==="\\"&&P(p.peek(),d)!==0;if(l&&(v=p.next()),!l&&w(v,d)&&v===p.peek()){p.advance(),u.type===2&&(u=m.pop());const g=P(v,d);if(u.type===g||u.type===5&&g===6)u=m.pop();else{const r={type:g,children:[]};g===5&&(r.index=s,s++),u.children.push(r),m.push(u),u=r}}else if(v===`
`)u.type===2&&(u=m.pop()),u.children.push({type:8});else if(u.type!==2){const g={type:2,content:v};u.children.push(g),m.push(u),u=g}else u.content+=v}return u.type===2&&(u=m.pop()),m.length,e}function w(f,d){return P(f,d)!==0}function P(f,d){switch(f){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return d?7:0;default:return 0}}}),define(me[59],be([1,0,2,3]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ES=void 0;class z{constructor(){this.a=new N.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,E&&b&&b(A)}isMonitoring(){return!!this.b}startMonitoring(E,A,b,$,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=$,this.c=w;let P=E;try{E.setPointerCapture(A),this.a.add((0,N.$Sc)(()=>{try{E.releasePointerCapture(A)}catch{}}))}catch{P=i.getWindow(E)}this.a.add(i.$5Q(P,i.$XR.POINTER_MOVE,f=>{if(f.buttons!==b){this.stopMonitoring(!0);return}f.preventDefault(),this.b(f)})),this.a.add(i.$5Q(P,i.$XR.POINTER_UP,f=>this.stopMonitoring(!0)))}}t.$ES=z});var Ze=this&&this.__decorate||function(se,t,i,N){var z=arguments.length,H=z<3?t:N===null?N=Object.getOwnPropertyDescriptor(t,i):N,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(se,t,i,N);else for(var A=se.length-1;A>=0;A--)(E=se[A])&&(H=(z<3?E(H):z>3?E(t,i,H):E(t,i))||H);return z>3&&H&&Object.defineProperty(t,i,H),H};define(me[26],be([1,0,2,22,12,28,4,3,49]),function(se,t,i,N,z,H,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=t.EventType=void 0;var $;(function(P){P.Tap="-monaco-gesturetap",P.Change="-monaco-gesturechange",P.Start="-monaco-gesturestart",P.End="-monaco-gesturesend",P.Contextmenu="-monaco-gesturecontextmenu"})($||(t.EventType=$={}));class w extends A.$Uc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$5c,this.h=new b.$5c,this.m={},this.j=null,this.n=0,this.B(E.Event.runAndSubscribe(i.onDidRegisterWindow,({window:f,disposables:d})=>{d.add(i.$5Q(f.document,"touchstart",e=>this.s(e),{passive:!1})),d.add(i.$5Q(f.document,"touchend",e=>this.u(f,e))),d.add(i.$5Q(f.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:N.$xQ,disposables:this.q}))}static addTarget(f){if(!w.isTouchDevice())return A.$Uc.None;w.b||(w.b=(0,A.$Nc)(new w));const d=w.b.g.push(f);return(0,A.$Sc)(d)}static ignoreTarget(f){if(!w.isTouchDevice())return A.$Uc.None;w.b||(w.b=(0,A.$Nc)(new w));const d=w.b.h.push(f);return(0,A.$Sc)(d)}static isTouchDevice(){return"ontouchstart"in N.$xQ||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(f){const d=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=f.targetTouches.length;e<s;e++){const u=f.targetTouches.item(e);this.m[u.identifier]={id:u.identifier,initialTarget:u.target,initialTimeStamp:d,initialPageX:u.pageX,initialPageY:u.pageY,rollingTimestamps:[d],rollingPageX:[u.pageX],rollingPageY:[u.pageY]};const m=this.w($.Start,u.target);m.pageX=u.pageX,m.pageY=u.pageY,this.z(m)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}u(f,d){const e=Date.now(),s=Object.keys(this.m).length;for(let u=0,m=d.changedTouches.length;u<m;u++){const p=d.changedTouches.item(u);if(!this.m.hasOwnProperty(String(p.identifier))){console.warn("move of an UNKNOWN touch",p);continue}const v=this.m[p.identifier],l=Date.now()-v.initialTimeStamp;if(l<w.c&&Math.abs(v.initialPageX-z.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-z.$sb(v.rollingPageY))<30){const g=this.w($.Tap,v.initialTarget);g.pageX=z.$sb(v.rollingPageX),g.pageY=z.$sb(v.rollingPageY),this.z(g)}else if(l>=w.c&&Math.abs(v.initialPageX-z.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-z.$sb(v.rollingPageY))<30){const g=this.w($.Contextmenu,v.initialTarget);g.pageX=z.$sb(v.rollingPageX),g.pageY=z.$sb(v.rollingPageY),this.z(g)}else if(s===1){const g=z.$sb(v.rollingPageX),r=z.$sb(v.rollingPageY),S=z.$sb(v.rollingTimestamps)-v.rollingTimestamps[0],C=g-v.rollingPageX[0],I=r-v.rollingPageY[0],M=[...this.g].filter(O=>v.initialTarget instanceof Node&&O.contains(v.initialTarget));this.C(f,M,e,Math.abs(C)/S,C>0?1:-1,g,Math.abs(I)/S,I>0?1:-1,r)}this.z(this.w($.End,v.initialTarget)),delete this.m[p.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(f,d){const e=document.createEvent("CustomEvent");return e.initEvent(f,!1,!0),e.initialTarget=d,e.tapCount=0,e}z(f){if(f.type===$.Tap){const d=new Date().getTime();let e=0;d-this.n>w.r?e=1:e=2,this.n=d,f.tapCount=e}else(f.type===$.Change||f.type===$.Contextmenu)&&(this.n=0);if(f.initialTarget instanceof Node){for(const d of this.h)if(d.contains(f.initialTarget))return;for(const d of this.g)d.contains(f.initialTarget)&&(d.dispatchEvent(f),this.f=!0)}}C(f,d,e,s,u,m,p,v,l){this.j=i.$cR(f,()=>{const g=Date.now(),r=g-e;let S=0,C=0,I=!0;s+=w.a*r,p+=w.a*r,s>0&&(I=!1,S=u*s*r),p>0&&(I=!1,C=v*p*r);const M=this.w($.Change);M.translationX=S,M.translationY=C,d.forEach(O=>O.dispatchEvent(M)),I||this.C(f,d,g,s,u,m+S,p,v,l+C)})}D(f){const d=Date.now();for(let e=0,s=f.changedTouches.length;e<s;e++){const u=f.changedTouches.item(e);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("end of an UNKNOWN touch",u);continue}const m=this.m[u.identifier],p=this.w($.Change,m.initialTarget);p.translationX=u.pageX-z.$sb(m.rollingPageX),p.translationY=u.pageY-z.$sb(m.rollingPageY),p.pageX=u.pageX,p.pageY=u.pageY,this.z(p),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(u.pageX),m.rollingPageY.push(u.pageY),m.rollingTimestamps.push(d)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}t.$BS=w,Ze([H.$Lh],w,"isTouchDevice",null)}),define(me[60],be([1,0,2,96]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0S=$,t.$$S=w,t.$_S=P;const N=2e4;let z,H,E,A,b;function $(d){z=document.createElement("div"),z.className="monaco-aria-container";const e=()=>{const u=document.createElement("div");return u.className="monaco-alert",u.setAttribute("role","alert"),u.setAttribute("aria-atomic","true"),z.appendChild(u),u};H=e(),E=e();const s=()=>{const u=document.createElement("div");return u.className="monaco-status",u.setAttribute("aria-live","polite"),u.setAttribute("aria-atomic","true"),z.appendChild(u),u};A=s(),b=s(),d.appendChild(z)}function w(d){z&&(H.textContent!==d?(i.$4Q(E),f(H,d)):(i.$4Q(H),f(E,d)))}function P(d){z&&(A.textContent!==d?(i.$4Q(b),f(A,d)):(i.$4Q(A),f(b,d)))}function f(d,e){i.$4Q(d),e.length>N&&(e=e.substr(0,N)),d.textContent=e,d.style.visibility="hidden",d.style.visibility="visible"}}),define(me[123],be([1,0,2,19]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CT=H,t.$DT=E;const z=new RegExp(`(\\\\)?\\$\\((${N.ThemeIcon.iconNameExpression}(?:${N.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(A){const b=new Array;let $,w=0,P=0;for(;($=z.exec(A))!==null;){P=$.index||0,w<P&&b.push(A.substring(w,P)),w=($.index||0)+$[0].length;const[,f,d]=$;b.push(f?`$(${d})`:E({id:d}))}return w<A.length&&b.push(A.substring(w)),b}function E(A){const b=i.$("span");return b.classList.add(...N.ThemeIcon.asClassNameArray(A)),b}}),define(me[124],be([1,0,2]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fT=void 0;function N(H){try{H.parentElement?.removeChild(H)}catch{}}class z{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let A=this.h(E).pop(),b=!1;if(A)b=this.b.has(A.domNode),b&&this.b.delete(A.domNode);else{const $=(0,i.$)(".monaco-list-row"),P=this.i(E).renderTemplate($);A={domNode:$,templateId:E,templateData:P}}return{row:A,isReusingConnectedDomNode:b}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(E){const{domNode:A,templateId:b}=E;A&&(this.c?this.b.add(A):this.g(A)),this.h(b).push(E)}g(E){E.classList.remove("scrolling"),N(E)}h(E){let A=this.a.get(E);return A||(A=[],this.a.set(E,A)),A}dispose(){this.a.forEach((E,A)=>{for(const b of E)this.i(A).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(E){const A=this.d.get(E);if(!A)throw new Error(`No renderer found for ${E}`);return A}}t.$fT=z}),define(me[125],be([1,0,9,3]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JS=void 0;class z extends N.$Uc{constructor(E,A,b){super(),this.a=E,this.b=A,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$rh)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$JS=z}),define(me[126],be([1,0,2,26,12,4,3,5]),function(se,t,i,N,z,H,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KT=void 0;class b extends E.$Uc{constructor(w,P,f,d){super(),this.f=0,this.b=d||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$7d),this.h=f,this.j(),this.setOptions(w,P)}j(){this.B(N.$BS.addTarget(this.a)),[N.EventType.Tap].forEach(w=>{this.B(i.$5Q(this.a,w,P=>{this.a.focus()}))}),this.B(i.$6Q(this.a,"click",w=>{i.$ZR.stop(w,!0)})),this.B(i.$6Q(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(i.$6Q(this.a,"keydown",w=>{let P=!1;A.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(P=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(P=!0),P&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,P){(!this.c||!z.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((f,d)=>{this.a.add(this.m(f.text,d,f.isDisabled))})),P!==void 0&&this.select(P)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,P,f){const d=document.createElement("option");return d.value=w,d.text=w,d.disabled=!!f,d}}t.$KT=b}),define(me[61],be([1,0,27,12,9,53,90,4,29]),function(se,t,i,N,z,H,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hV=void 0,t.$fV=$,t.$gV=w;function $(d){return typeof d=="object"&&"visibility"in d&&"data"in d}function w(d){switch(d){case!0:return 1;case!1:return 0;default:return d}}function P(d){return typeof d.collapsible=="boolean"}class f{constructor(e,s,u,m={}){this.o=e,this.p=s,this.rootRef=[],this.d=new A.$ce,this.f=new A.$7d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$7d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.$7d,this.onDidSplice=this.l.event,this.m=new z.$eh(H.$4d),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:u,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,u=b.Iterable.empty(),m={}){if(e.length===0)throw new i.$dV(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,s,u,m):this.s(e,s,u,m)}q(e,s,u,m=b.Iterable.empty(),p,v=p.diffDepth??0){const{parentNode:l}=this.G(s);if(!l.lastDiffIds)return this.s(s,u,m,p);const g=[...m],r=s[s.length-1],S=new E.$gt({getElements:()=>l.lastDiffIds},{getElements:()=>[...l.children.slice(0,r),...g,...l.children.slice(r+u)].map(y=>e.getId(y.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return l.lastDiffIds=void 0,this.s(s,u,g,p);const C=s.slice(0,-1),I=(y,x,W)=>{if(v>0)for(let T=0;T<W;T++)y--,x--,this.q(e,[...C,y,0],Number.MAX_SAFE_INTEGER,g[x].children,p,v-1)};let M=Math.min(l.children.length,r+u),O=g.length;for(const y of S.changes.sort((x,W)=>W.originalStart-x.originalStart))I(M,O,M-(y.originalStart+y.originalLength)),M=y.originalStart,O=y.modifiedStart-r,this.s([...C,M],y.originalLength,b.Iterable.slice(g,O,O+y.modifiedLength),p);I(M,O,M)}s(e,s,u=b.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:p,diffIdentityProvider:v}){const{parentNode:l,listIndex:g,revealed:r,visible:S}=this.G(e),C=[],I=b.Iterable.map(u,X=>this.w(X,l,l.visible?1:0,r,C,m)),M=e[e.length-1];let O=0;for(let X=M;X>=0&&X<l.children.length;X--){const J=l.children[X];if(J.visible){O=J.visibleChildIndex;break}}const y=[];let x=0,W=0;for(const X of I)y.push(X),W+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=O+x++);const T=(0,N.$6b)(l.children,M,s,y);v?l.lastDiffIds?(0,N.$6b)(l.lastDiffIds,M,s,y.map(X=>v.getId(X.element).toString())):l.lastDiffIds=l.children.map(X=>v.getId(X.element).toString()):l.lastDiffIds=void 0;let R=0;for(const X of T)X.visible&&R++;if(R!==0)for(let X=M+y.length;X<l.children.length;X++){const J=l.children[X];J.visible&&(J.visibleChildIndex-=R)}if(l.visibleChildrenCount+=x-R,r&&S){const X=T.reduce((J,de)=>J+(de.visible?de.renderNodeCount:0),0);this.B(l,W-X),this.p.splice(g,X,C)}if(T.length>0&&p){const X=J=>{p(J),J.children.forEach(X)};T.forEach(X)}this.l.fire({insertedNodes:y,deletedNodes:T});let L=l;for(;L;){if(L.visibility===2){this.m.trigger(()=>this.refilter());break}L=L.parent}}rerender(e){if(e.length===0)throw new i.$dV(this.o,"Invalid tree location");const{node:s,listIndex:u,revealed:m}=this.F(e);s.visible&&m&&this.p.splice(u,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$dV(this.o,"Invalid tree location");const{listIndex:u}=this.F(e);this.p.updateElementHeight(u,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:u,revealed:m}=this.F(e);return u&&m?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const u=this.E(e);typeof s>"u"&&(s=!u.collapsible);const m={collapsible:s};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,u){const m=this.E(e);typeof s>"u"&&(s=!m.collapsed);const p={collapsed:s,recursive:u||!1};return this.d.bufferEvents(()=>this.t(e,p))}t(e,s){const{node:u,listIndex:m,revealed:p}=this.F(e),v=this.u(u,m,p,s);if(u!==this.c&&this.k&&v&&!P(s)&&u.collapsible&&!u.collapsed&&!s.recursive){let l=-1;for(let g=0;g<u.children.length;g++)if(u.children[g].visible)if(l>-1){l=-1;break}else l=g;l>-1&&this.t([...e,l],s)}return v}u(e,s,u,m){const p=this.v(e,m,!1);if(!u||!e.visible||!p)return p;const v=e.renderNodeCount,l=this.x(e),g=v-(s===-1?0:1);return this.p.splice(s+1,g,l.slice(1)),p}v(e,s,u){let m;if(e===this.c?m=!1:(P(s)?(m=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(m=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):m=!1,m&&this.f.fire({node:e,deep:u})),!P(s)&&s.recursive)for(const p of e.children)m=this.v(p,s,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,u,m,p,v){const l={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},g=this.C(l,u);l.visibility=g,m&&p.push(l);const r=e.children||b.Iterable.empty(),S=m&&g!==0&&!l.collapsed;let C=0,I=1;for(const M of r){const O=this.w(M,l,g,S,p,v);l.children.push(O),I+=O.renderNodeCount,O.visible&&(O.visibleChildIndex=C++)}return l.collapsible=l.collapsible||l.children.length>0,l.visibleChildrenCount=C,l.visible=g===2?C>0:g===1,l.visible?l.collapsed||(l.renderNodeCount=I):(l.renderNodeCount=0,m&&p.pop()),v?.(l),l}x(e){const s=e.renderNodeCount,u=[];return this.y(e,u),this.B(e.parent,u.length-s),u}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const u of e.children)e.renderNodeCount+=this.y(u,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,u=[];return this.A(e,e.visible?1:0,u),this.B(e.parent,u.length-s),u}A(e,s,u,m=!0){let p;if(e!==this.c){if(p=this.C(e,s),p===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&u.push(e)}const v=u.length;e.renderNodeCount=e===this.c?0:1;let l=!1;if(!e.collapsed||p!==0){let g=0;for(const r of e.children)l=this.A(r,p,u,m&&!e.collapsed)||l,r.visible&&(r.visibleChildIndex=g++);e.visibleChildrenCount=g}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=p===2?l:p===1,e.visibility=p),e.visible?e.collapsed||(e.renderNodeCount+=u.length-v):(e.renderNodeCount=0,m&&u.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const u=this.j?this.j.filter(e.element,s):1;return typeof u=="boolean"?(e.filterData=void 0,u?1:0):$(u)?(e.filterData=u.data,w(u.visibility)):(e.filterData=void 0,w(u))}D(e,s=this.c){if(!e||e.length===0)return!0;const[u,...m]=e;return u<0||u>s.children.length?!1:this.D(m,s.children[u])}E(e,s=this.c){if(!e||e.length===0)return s;const[u,...m]=e;if(u<0||u>s.children.length)throw new i.$dV(this.o,"Invalid tree location");return this.E(m,s.children[u])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:u,revealed:m,visible:p}=this.G(e),v=e[e.length-1];if(v<0||v>s.children.length)throw new i.$dV(this.o,"Invalid tree location");const l=s.children[v];return{node:l,listIndex:u,revealed:m,visible:p&&l.visible}}G(e,s=this.c,u=0,m=!0,p=!0){const[v,...l]=e;if(v<0||v>s.children.length)throw new i.$dV(this.o,"Invalid tree location");for(let g=0;g<v;g++)u+=s.children[g].renderNodeCount;return m=m&&!s.collapsed,p=p&&s.visible,l.length===0?{parentNode:s,listIndex:u,revealed:m,visible:p}:this.G(l,s.children[v],u+1,m,p)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let u=e;for(;u.parent;)s.push(u.parent.children.indexOf(u)),u=u.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,N.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$hV=f}),define(me[127],be([1,0,61,27,29]),function(se,t,i,N,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oV=void 0;class H{get size(){return this.d.size}constructor(A,b,$={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$hV(A,b,null,$),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,$.sorter&&(this.j={compare(w,P){return $.sorter.compare(w.element,P.element)}}),this.h=$.identityProvider}setChildren(A,b=z.Iterable.empty(),$={}){const w=this.o(A);this.l(w,this.m(b),$)}l(A,b=z.Iterable.empty(),$){const w=new Set,P=new Set,f=e=>{if(e.element===null)return;const s=e;if(w.add(s.element),this.d.set(s.element,s),this.h){const u=this.h.getId(s.element).toString();P.add(u),this.f.set(u,s)}$.onDidCreateNode?.(s)},d=e=>{if(e.element===null)return;const s=e;if(w.has(s.element)||this.d.delete(s.element),this.h){const u=this.h.getId(s.element).toString();P.has(u)||this.f.delete(u)}$.onDidDeleteNode?.(s)};this.c.splice([...A,0],Number.MAX_VALUE,b,{...$,onDidCreateNode:f,onDidDeleteNode:d})}m(A=z.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),z.Iterable.map(A,b=>{let $=this.d.get(b.element);if(!$&&this.h){const f=this.h.getId(b.element).toString();$=this.f.get(f)}if(!$){let f;return typeof b.collapsed>"u"?f=void 0:b.collapsed===N.ObjectTreeElementCollapseState.Collapsed||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed?f=!0:b.collapsed===N.ObjectTreeElementCollapseState.Expanded||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?f=!1:f=!!b.collapsed,{...b,children:this.m(b.children),collapsed:f}}const w=typeof b.collapsible=="boolean"?b.collapsible:$.collapsible;let P;return typeof b.collapsed>"u"||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===N.ObjectTreeElementCollapseState.PreserveOrExpanded?P=$.collapsed:b.collapsed===N.ObjectTreeElementCollapseState.Collapsed?P=!0:b.collapsed===N.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!b.collapsed,{...b,collapsible:w,collapsed:P,children:this.m(b.children)}})}rerender(A){const b=this.o(A);this.c.rerender(b)}updateElementHeight(A,b){const $=this.o(A);this.c.updateElementHeight($,b)}resort(A=null,b=!0){if(!this.j)return;const $=this.o(A),w=this.c.getNode($);this.l($,this.n(w,b),{})}n(A,b,$=!0){let w=[...A.children];return(b||$)&&(w=w.sort(this.j.compare.bind(this.j))),z.Iterable.map(w,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,b,!1)}))}getFirstElementChild(A=null){const b=this.o(A);return this.c.getFirstElementChild(b)}getLastElementAncestor(A=null){const b=this.o(A);return this.c.getLastElementAncestor(b)}has(A){return this.d.has(A)}getListIndex(A){const b=this.o(A);return this.c.getListIndex(b)}getListRenderCount(A){const b=this.o(A);return this.c.getListRenderCount(b)}isCollapsible(A){const b=this.o(A);return this.c.isCollapsible(b)}setCollapsible(A,b){const $=this.o(A);return this.c.setCollapsible($,b)}isCollapsed(A){const b=this.o(A);return this.c.isCollapsed(b)}setCollapsed(A,b,$){const w=this.o(A);return this.c.setCollapsed(w,b,$)}expandTo(A){const b=this.o(A);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(A);if(!b)throw new N.$dV(this.k,`Tree element not found: ${A}`);return b}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new N.$dV(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(A);if(!b)throw new N.$dV(this.k,`Tree element not found: ${A}`);const $=this.c.getNodeLocation(b),w=this.c.getParentNodeLocation($);return this.c.getNode(w).element}o(A){if(A===null)return[];const b=this.d.get(A);if(!b)throw new N.$dV(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(b)}}t.$oV=H}),define(me[21],be([1,0,2,15,20,26,3]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FS=void 0;class A extends E.$Uc{f($,w){this.B(i.$5Q($,i.$XR.CLICK,P=>w(new z.$WQ(i.getWindow($),P))))}j($,w){this.B(i.$5Q($,i.$XR.MOUSE_DOWN,P=>w(new z.$WQ(i.getWindow($),P))))}m($,w){this.B(i.$5Q($,i.$XR.MOUSE_OVER,P=>w(new z.$WQ(i.getWindow($),P))))}u($,w){this.B(i.$5Q($,i.$XR.MOUSE_LEAVE,P=>w(new z.$WQ(i.getWindow($),P))))}z($,w){this.B(i.$5Q($,i.$XR.KEY_DOWN,P=>w(new N.$2Q(P))))}C($,w){this.B(i.$5Q($,i.$XR.KEY_UP,P=>w(new N.$2Q(P))))}D($,w){this.B(i.$5Q($,i.$XR.INPUT,w))}F($,w){this.B(i.$5Q($,i.$XR.BLUR,w))}G($,w){this.B(i.$5Q($,i.$XR.FOCUS,w))}H($,w){this.B(i.$5Q($,i.$XR.CHANGE,w))}I($){return H.$BS.ignoreTarget($)}}t.$FS=A}),define(me[42],be([1,0,59,21,9,19,2]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=t.$GS=void 0,t.$GS=11;class A extends N.$FS{constructor($){super(),this.a=$.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=$.bgWidth+"px",this.bgDomNode.style.height=$.bgHeight+"px",typeof $.top<"u"&&(this.bgDomNode.style.top="0px"),typeof $.left<"u"&&(this.bgDomNode.style.left="0px"),typeof $.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof $.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=$.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray($.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$GS+"px",this.domNode.style.height=t.$GS+"px",typeof $.top<"u"&&(this.domNode.style.top=$.top+"px"),typeof $.left<"u"&&(this.domNode.style.left=$.left+"px"),typeof $.bottom<"u"&&(this.domNode.style.bottom=$.bottom+"px"),typeof $.right<"u"&&(this.domNode.style.right=$.right+"px"),this.g=this.B(new i.$ES),this.B(E.$6Q(this.bgDomNode,E.$XR.POINTER_DOWN,w=>this.h(w))),this.B(E.$6Q(this.domNode,E.$XR.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new E.$eR),this.c=this.B(new z.$rh)}h($){if(!$.target||!($.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow($))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring($.target,$.pointerId,$.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),$.preventDefault()}}t.$HS=A}),define(me[62],be([1,0,2,45,59,42,125,21,5]),function(se,t,i,N,z,H,E,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KS=void 0;const $=140;class w extends A.$FS{constructor(f){super(),this.g=f.lazyRender,this.a=f.host,this.b=f.scrollable,this.c=f.scrollByPage,this.h=f.scrollbarState,this.n=this.B(new E.$JS(f.visibility,"visible scrollbar "+f.extraScrollbarClassName,"invisible scrollbar "+f.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new z.$ES),this.s=!0,this.domNode=(0,N.$DS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$5Q(this.domNode.domNode,i.$XR.POINTER_DOWN,d=>this.M(d)))}t(f){const d=this.B(new H.$HS(f));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}w(f,d,e,s){this.slider=(0,N.$DS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(f),this.slider.setLeft(d),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$5Q(this.slider.domNode,i.$XR.POINTER_DOWN,u=>{u.button===0&&(u.preventDefault(),this.O(u))})),this.f(this.slider.domNode,u=>{u.leftButton&&u.stopPropagation()})}y(f){return this.h.setVisibleSize(f)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(f){return this.h.setScrollSize(f)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(f){return this.h.setScrollPosition(f)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(f){f.target===this.domNode.domNode&&this.N(f)}delegatePointerDown(f){const d=this.domNode.domNode.getClientRects()[0].top,e=d+this.h.getSliderPosition(),s=d+this.h.getSliderPosition()+this.h.getSliderSize(),u=this.U(f);e<=u&&u<=s?f.button===0&&(f.preventDefault(),this.O(f)):this.N(f)}N(f){let d,e;if(f.target===this.domNode.domNode&&typeof f.offsetX=="number"&&typeof f.offsetY=="number")d=f.offsetX,e=f.offsetY;else{const u=i.$oR(this.domNode.domNode);d=f.pageX-u.left,e=f.pageY-u.top}const s=this.S(d,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),f.button===0&&(f.preventDefault(),this.O(f))}O(f){if(!f.target||!(f.target instanceof Element))return;const d=this.U(f),e=this.W(f),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(f.target,f.pointerId,f.buttons,u=>{const m=this.W(u),p=Math.abs(m-e);if(b.$i&&p>$){this.P(s.getScrollPosition());return}const l=this.U(u)-d;this.P(s.getDesiredScrollPositionFromDelta(l))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(f){const d={};this.writeScrollPosition(d,f),this.b.setScrollPositionNow(d)}updateScrollbarSize(f){this.X(f),this.h.setScrollbarSize(f),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$KS=w}),define(me[128],be([1,0,20,62,42,46,18]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LS=void 0;class A extends N.$KS{constructor($,w,P){const f=$.getScrollDimensions(),d=$.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$IS(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,f.width,f.scrollWidth,d.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:$,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-z.$GS)/2,s=(w.horizontalScrollbarSize-z.$GS)/2;this.t({className:"scra",icon:E.$Gj.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$YQ(null,1,0))}),this.t({className:"scra",icon:E.$Gj.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$YQ(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R($,w){this.slider.setWidth($),this.slider.setLeft(w)}Q($,w){this.domNode.setWidth($),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll($){return this.s=this.J($.scrollWidth)||this.s,this.s=this.L($.scrollLeft)||this.s,this.s=this.y($.width)||this.s,this.s}S($,w){return $}U($){return $.pageX}W($){return $.pageY}X($){this.slider.setHeight($)}writeScrollPosition($,w){$.scrollLeft=w}updateOptions($){this.updateScrollbarSize($.horizontal===2?0:$.horizontalScrollbarSize),this.h.setOppositeScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.n.setVisibility($.horizontal),this.c=$.scrollByPage}}t.$LS=A}),define(me[129],be([1,0,20,62,42,46,18]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MS=void 0;class A extends N.$KS{constructor($,w,P){const f=$.getScrollDimensions(),d=$.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:P,scrollbarState:new H.$IS(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,f.height,f.scrollHeight,d.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:$,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-z.$GS)/2,s=(w.verticalScrollbarSize-z.$GS)/2;this.t({className:"scra",icon:E.$Gj.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$YQ(null,0,1))}),this.t({className:"scra",icon:E.$Gj.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$YQ(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R($,w){this.slider.setHeight($),this.slider.setTop(w)}Q($,w){this.domNode.setWidth(w),this.domNode.setHeight($),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll($){return this.s=this.J($.scrollHeight)||this.s,this.s=this.L($.scrollTop)||this.s,this.s=this.y($.height)||this.s,this.s}S($,w){return w}U($){return $.pageY}W($){return $.pageX}X($){this.slider.setWidth($)}writeScrollPosition($,w){$.scrollTop=w}updateOptions($){this.updateScrollbarSize($.vertical===2?0:$.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility($.vertical),this.c=$.scrollByPage}}t.$MS=A}),define(me[63],be([1,0,17,2,45,20,128,129,21,9,4,3,5,51,103]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RS=t.$QS=t.$PS=t.$OS=t.$NS=void 0;const e=500,s=50,u=!0;class m{constructor(I,M,O){this.timestamp=I,this.deltaX=M,this.deltaY=O,this.score=0}}class p{static{this.INSTANCE=new p}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let I=1,M=0,O=1,y=this.d;do{const x=y===this.c?I:Math.pow(2,-O);if(I-=x,M+=this.b[y].score*x,y===this.c)break;y=(this.a+y-1)%this.a,O++}while(!0);return M<=.5}acceptStandardWheelEvent(I){if(i.$MQ){const M=N.getWindow(I.browserEvent),O=(0,i.$FQ)(M);this.accept(Date.now(),I.deltaX*O,I.deltaY*O)}else this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,M,O){const y=new m(I,M,O);y.score=this.f(y),this.c===-1&&this.d===-1?(this.b[0]=y,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=y)}f(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let M=.5;const O=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(I.deltaX)||!this.g(I.deltaY))&&(M+=.25),Math.min(Math.max(M,0),1)}g(I){return Math.abs(Math.round(I)-I)<.01}}t.$NS=p;class v extends b.$FS{get options(){return this.a}constructor(I,M,O){super(),this.O=this.B(new w.$7d),this.onScroll=this.O.event,this.P=this.B(new w.$7d),this.onWillScroll=this.P.event,I.style.overflow="hidden",this.a=S(M),this.b=O,this.B(this.b.onScroll(x=>{this.P.fire(x),this.S(x),this.O.fire(x)}));const y={onMouseWheel:x=>this.R(x),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$MS(this.b,this.a,y)),this.g=this.B(new E.$LS(this.b,this.a,y)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(I),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,z.$DS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,z.$DS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,z.$DS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,x=>this.Z(x)),this.u(this.t,x=>this.Y(x)),this.L=this.B(new $.$rh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this.c.delegatePointerDown(I)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(I){this.b.setScrollDimensions(I,!1)}updateClassName(I){this.a.className=I,f.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this.a.handleMouseWheel=I.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this.a.horizontal=I.horizontal),typeof I.vertical<"u"&&(this.a.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this.a.scrollByPage=I.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(I){this.N=I}delegateScrollFromMouseWheelEvent(I){this.R(new H.$YQ(I))}Q(I){if(this.w.length>0!==I&&(this.w=(0,P.$Pc)(this.w),I)){const O=y=>{this.R(new H.$YQ(y))};this.w.push(N.$5Q(this.t,N.$XR.MOUSE_WHEEL,O,{passive:!1}))}}R(I){if(I.browserEvent?.defaultPrevented)return;const M=p.INSTANCE;u&&M.acceptStandardWheelEvent(I);let O=!1;if(I.deltaY||I.deltaX){let x=I.deltaY*this.a.mouseWheelScrollSensitivity,W=I.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+x===0?W=x=0:Math.abs(x)>=Math.abs(W)?W=0:x=0),this.a.flipAxes&&([x,W]=[W,x]);const T=!f.$j&&I.browserEvent&&I.browserEvent.shiftKey;(this.a.scrollYToX||T)&&!W&&(W=x,x=0),I.browserEvent&&I.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,x=x*this.a.fastScrollSensitivity);const R=this.b.getFutureScrollPosition();let L={};if(x){const X=s*x,J=R.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(L,J)}if(W){const X=s*W,J=R.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(L,J)}L=this.b.validateScrollPosition(L),(R.scrollLeft!==L.scrollLeft||R.scrollTop!==L.scrollTop)&&(u&&this.a.mouseWheelSmoothScroll&&M.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(L):this.b.setScrollPositionNow(L),O=!0)}let y=O;!y&&this.a.alwaysConsumeMouseWheel&&(y=!0),!y&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(y=!0),y&&(I.preventDefault(),I.stopPropagation())}S(I){this.M=this.g.onDidScroll(I)||this.M,this.M=this.c.onDidScroll(I)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const I=this.b.getCurrentScrollPosition(),M=I.scrollTop>0,O=I.scrollLeft>0,y=O?" left":"",x=M?" top":"",W=O||M?" top-left-corner":"";this.n.setClassName(`shadow${y}`),this.r.setClassName(`shadow${x}`),this.s.setClassName(`shadow${W}${x}${y}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(I){this.J=!1,this.ab()}Z(I){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$OS=v;class l extends v{constructor(I,M){M=M||{},M.mouseWheelSmoothScroll=!1;const O=new d.$Ds({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>N.$cR(N.getWindow(I),y)});super(I,M,O),this.B(O)}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$PS=l;class g extends v{constructor(I,M,O){super(I,M,O)}setScrollPosition(I){I.reuseAnimation?this.b.setScrollPositionSmooth(I,I.reuseAnimation):this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$QS=g;class r extends v{constructor(I,M){M=M||{},M.mouseWheelSmoothScroll=!1;const O=new d.$Ds({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>N.$cR(N.getWindow(I),y)});super(I,M,O),this.B(O),this.cb=I,this.B(this.onScroll(y=>{y.scrollTopChanged&&(this.cb.scrollTop=y.scrollTop),y.scrollLeftChanged&&(this.cb.scrollLeft=y.scrollLeft)})),this.scanDomNode()}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$RS=r;function S(C){const I={lazyRender:typeof C.lazyRender<"u"?C.lazyRender:!1,className:typeof C.className<"u"?C.className:"",useShadows:typeof C.useShadows<"u"?C.useShadows:!0,handleMouseWheel:typeof C.handleMouseWheel<"u"?C.handleMouseWheel:!0,flipAxes:typeof C.flipAxes<"u"?C.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof C.consumeMouseWheelIfScrollbarIsNeeded<"u"?C.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof C.alwaysConsumeMouseWheel<"u"?C.alwaysConsumeMouseWheel:!1,scrollYToX:typeof C.scrollYToX<"u"?C.scrollYToX:!1,mouseWheelScrollSensitivity:typeof C.mouseWheelScrollSensitivity<"u"?C.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof C.fastScrollSensitivity<"u"?C.fastScrollSensitivity:5,scrollPredominantAxis:typeof C.scrollPredominantAxis<"u"?C.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof C.mouseWheelSmoothScroll<"u"?C.mouseWheelSmoothScroll:!0,arrowSize:typeof C.arrowSize<"u"?C.arrowSize:11,listenOnDomNode:typeof C.listenOnDomNode<"u"?C.listenOnDomNode:null,horizontal:typeof C.horizontal<"u"?C.horizontal:1,horizontalScrollbarSize:typeof C.horizontalScrollbarSize<"u"?C.horizontalScrollbarSize:10,horizontalSliderSize:typeof C.horizontalSliderSize<"u"?C.horizontalSliderSize:0,horizontalHasArrows:typeof C.horizontalHasArrows<"u"?C.horizontalHasArrows:!1,vertical:typeof C.vertical<"u"?C.vertical:1,verticalScrollbarSize:typeof C.verticalScrollbarSize<"u"?C.verticalScrollbarSize:10,verticalHasArrows:typeof C.verticalHasArrows<"u"?C.verticalHasArrows:!1,verticalSliderSize:typeof C.verticalSliderSize<"u"?C.verticalSliderSize:0,scrollByPage:typeof C.scrollByPage<"u"?C.scrollByPage:!1};return I.horizontalSliderSize=typeof C.horizontalSliderSize<"u"?C.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof C.verticalSliderSize<"u"?C.verticalSliderSize:I.verticalScrollbarSize,f.$j&&(I.className+=" mac"),I}}),define(me[64],be([1,0,57,2,24,26,63,12,9,28,4,3,50,51,86,124,6,35]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e,s,u,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.$iT=t.$hT=t.$gT=t.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var v;(function(O){O[O.TOP=0]="TOP",O[O.CENTER_TOP=1]="CENTER_TOP",O[O.CENTER_BOTTOM=2]="CENTER_BOTTOM",O[O.BOTTOM=3]="BOTTOM"})(v||(t.ListViewTargetSector=v={}));const l={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(O){return[O]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class g{get context(){return this.d}set context(y){this.d=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.$gT=g;class r{constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.$hT=r;class S{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let x=0;x<y.files.length;x++){const W=y.files.item(x);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$iT=S;function C(O,y){return Array.isArray(O)&&Array.isArray(y)?(0,A.$ub)(O,y):O===y}class I{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(x,W,T)=>T,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(x,W)=>W+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=x=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=x=>{}}}class M{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(y){if(y!==this.P){if(y&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=y,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const x of this.d)this.ab(x);this.X(),this.q.setScrollDimensions({width:(0,N.$rR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(y,x,W,T=l){if(this.R=x,this.domId=`list_id_${++M.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$eh(50),this.v=!1,this.x=P.$Uc.None,this.y=0,this.G=!1,this.K=P.$Uc.None,this.L=P.$Uc.None,this.M=new P.$Tc,this.N=new w.$7d,this.O=new w.$7d,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,T.horizontalScrolling&&T.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(T.paddingTop??0);for(const L of W)this.j.set(L.templateId,L);this.h=this.M.add(new s.$fT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof T.mouseSupport=="boolean"?T.mouseSupport:!0),this.P=T.horizontalScrolling??l.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof T.paddingBottom>"u"?0:T.paddingBottom,this.D=new I(T.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(T.transformOptimization??l.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$BS.addTarget(this.o)),this.p=this.M.add(new d.$Ds({forceIntegerValues:!0,smoothScrollDuration:T.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,N.$cR)((0,N.getWindow)(this.domNode),L)})),this.q=this.M.add(new E.$QS(this.o,{alwaysConsumeMouseWheel:T.alwaysConsumeMouseWheel??l.alwaysConsumeMouseWheel,horizontal:1,vertical:T.verticalScrollMode??l.verticalScrollMode,useShadows:T.useShadows??l.useShadows,mouseWheelScrollSensitivity:T.mouseWheelScrollSensitivity,fastScrollSensitivity:T.fastScrollSensitivity,scrollByPage:T.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),y.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,N.$5Q)(this.o,H.EventType.Change,L=>this.jb(L))),this.M.add((0,N.$5Q)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,N.$5Q)(this.domNode,"dragover",L=>this.lb(this.hb(L)))),this.M.add((0,N.$5Q)(this.domNode,"drop",L=>this.nb(this.hb(L)))),this.M.add((0,N.$5Q)(this.domNode,"dragleave",L=>this.mb(this.hb(L)))),this.M.add((0,N.$5Q)(this.domNode,"dragend",L=>this.ob(L))),this.z=T.setRowLineHeight??l.setRowLineHeight,this.A=T.setRowHeight??l.setRowHeight,this.B=T.supportDynamicHeights??l.supportDynamicHeights,this.F=T.dnd??this.M.add(l.dnd),this.layout(T.initialSize?.height,T.initialSize?.width)}updateOptions(y){y.paddingBottom!==void 0&&(this.C=y.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.Q=y.horizontalScrolling);let x;if(y.scrollByPage!==void 0&&(x={...x??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(x={...x??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(x={...x??{},fastScrollSensitivity:y.fastScrollSensitivity}),x&&this.q.updateOptions(x),y.paddingTop!==void 0&&y.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),T=y.paddingTop-this.g.paddingTop;this.g.paddingTop=y.paddingTop,this.Y(W,Math.max(0,this.k+T),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(y){this.q.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.q.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,x,W){if(y<0||y>=this.d.length)return;const T=this.d[y].size;if(typeof x>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[y].lastDynamicHeightWidth=void 0,x=T+this.xb(y)}if(T===x)return;const R=this.vb(this.k,this.m);let L=0;y<R.start||W!==null&&W>y&&W<R.end?L=x-T:L=0,this.g.splice(y,1,[{size:x}]),this.d[y].size=x,this.Y(R,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(y){return new e.$eT(y)}splice(y,x,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(y,x,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(y,x,W=[]){const T=this.vb(this.k,this.m),R={start:y,end:y+x},L=f.Range.intersect(T,R),X=new Map;for(let Q=L.end-1;Q>=L.start;Q--){const te=this.d[Q];if(te.dragStartDisposable.dispose(),te.checkedDisposable.dispose(),te.row){let ue=X.get(te.templateId);ue||(ue=[],X.set(te.templateId,ue));const ye=this.j.get(te.templateId);ye&&ye.disposeElement&&ye.disposeElement(te.element,Q,te.row.templateData,te.size),ue.push(te.row)}te.row=null,te.stale=!0}const J={start:y+x,end:this.d.length},de=f.Range.intersect(J,T),ae=f.Range.relativeComplement(J,T),ie=W.map(Q=>({id:String(this.f++),element:Q,templateId:this.R.getTemplateId(Q),size:this.R.getHeight(Q),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(Q),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$Uc.None,checkedDisposable:P.$Uc.None,stale:!1}));let ge;y===0&&x>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ie),ge=this.d,this.d=ie):(this.g.splice(y,x,ie),ge=this.d.splice(y,x,...ie));const Fe=W.length-x,Ne=this.vb(this.k,this.m),Pe=(0,e.$cT)(de,Fe),oe=f.Range.intersect(Ne,Pe);for(let Q=oe.start;Q<oe.end;Q++)this.bb(this.d[Q],Q);const U=f.Range.relativeComplement(Pe,Ne);for(const Q of U)for(let te=Q.start;te<Q.end;te++)this.db(te);const le=ae.map(Q=>(0,e.$cT)(Q,Fe)),Y=[{start:y,end:y+W.length},...le].map(Q=>f.Range.intersect(Ne,Q)).reverse();for(const Q of Y)for(let te=Q.end-1;te>=Q.start;te--){const ue=this.d[te],Te=X.get(ue.templateId)?.pop();this.Z(te,Te)}for(const Q of X.values())for(const te of Q)this.h.release(te);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(Q=>Q.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,N.$cR)((0,N.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let y=0;for(const x of this.d)typeof x.width<"u"&&(y=Math.max(y,x.width));this.E=y,this.q.setScrollDimensions({scrollWidth:y===0?0:y+10}),this.O.fire(this.E)}updateWidth(y){if(!this.Q||typeof this.E>"u")return;const x=this.d[y];this.ab(x),typeof x.width<"u"&&x.width>this.E&&(this.E=x.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const y of this.d)y.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const y=this.firstVisibleIndex,x=this.g.positionAt(y),W=this.g.positionAt(y+1);return W!==-1&&(W-x)/2+x<this.scrollTop?y+1:y}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(y){return this.d[y].element}indexOf(y){return this.d.findIndex(x=>x.element===y)}domElement(y){const x=this.d[y].row;return x&&x.domNode}elementHeight(y){return this.d[y].size}elementTop(y){return this.g.positionAt(y)}indexAt(y){return this.g.indexAt(y)}indexAfter(y){return this.g.indexAfter(y)}layout(y,x){const W={height:typeof y=="number"?y:(0,N.$tR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof x<"u"&&(this.n=x,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof x=="number"?x:(0,N.$rR)(this.domNode)})}Y(y,x,W,T,R,L=!1){const X=this.vb(x,W),J=f.Range.relativeComplement(X,y).reverse(),de=f.Range.relativeComplement(y,X);if(L){const ae=f.Range.intersect(y,X);for(let ie=ae.start;ie<ae.end;ie++)this.bb(this.d[ie],ie)}this.h.transact(()=>{for(const ae of de)for(let ie=ae.start;ie<ae.end;ie++)this.db(ie);for(const ae of J)for(let ie=ae.end-1;ie>=ae.start;ie--)this.Z(ie)}),T!==void 0&&(this.o.style.left=`-${T}px`),this.o.style.top=`-${x}px`,this.Q&&R!==void 0&&(this.o.style.width=`${Math.max(R,this.n)}px`),this.k=x,this.m=W}Z(y,x){const W=this.d[y];if(!W.row)if(x)W.row=x,W.stale=!0;else{const J=this.h.alloc(W.templateId);W.row=J.row,W.stale||=J.isReusingConnectedDomNode}const T=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",T);const R=this.D.isChecked(W.element);if(typeof R=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!R));else if(R){const J=de=>W.row.domNode.setAttribute("aria-checked",String(!!de));J(R.value),W.checkedDisposable=R.onDidChange(J)}if(W.stale||!W.row.domNode.parentElement){const J=this.d.at(y+1)?.row?.domNode??null;this.o.insertBefore(W.row.domNode,J),W.stale=!1}this.bb(W,y);const L=this.j.get(W.templateId);if(!L)throw new Error(`No renderer found for template id ${W.templateId}`);L?.renderElement(W.element,y,W.row.templateData,W.size);const X=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!X,X&&(W.dragStartDisposable=(0,N.$5Q)(W.row.domNode,"dragstart",J=>this.kb(W.element,X,J))),this.Q&&(this.ab(W),this.W())}ab(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,N.$rR)(y.row.domNode);const x=(0,N.getWindow)(y.row.domNode).getComputedStyle(y.row.domNode);x.paddingLeft&&(y.width+=parseFloat(x.paddingLeft)),x.paddingRight&&(y.width+=parseFloat(x.paddingRight)),y.row.domNode.style.width=""}bb(y,x){y.row.domNode.style.top=`${this.elementTop(x)}px`,this.A&&(y.row.domNode.style.height=`${y.size}px`),this.z&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${x}`),y.row.domNode.setAttribute("data-last-element",x===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",x%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(y.element,x,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(y.element,x))),y.row.domNode.setAttribute("id",this.getElementDomId(x)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}db(y){const x=this.d[y];if(x.dragStartDisposable.dispose(),x.checkedDisposable.dispose(),x.row){const W=this.j.get(x.templateId);W&&W.disposeElement&&W.disposeElement(x.element,y,x.row.templateData,x.size),this.h.release(x.row),x.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(y,x){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:y,reuseAnimation:x})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"click")).event,y=>this.eb(y),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"dblclick")).event,y=>this.eb(y),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new z.$9S(this.domNode,"auxclick")).event,y=>this.eb(y),this.M),y=>y.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"mouseup")).event,y=>this.eb(y),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"mousedown")).event,y=>this.eb(y),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"mouseover")).event,y=>this.eb(y),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"mousemove")).event,y=>this.eb(y),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"mouseout")).event,y=>this.eb(y),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new z.$9S(this.domNode,"contextmenu")).event,y=>this.eb(y),this.M),w.Event.map(this.M.add(new z.$9S(this.domNode,H.EventType.Contextmenu)).event,y=>this.gb(y),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new z.$9S(this.domNode,"touchstart")).event,y=>this.fb(y),this.M)}get onTap(){return w.Event.map(this.M.add(new z.$9S(this.o,H.EventType.Tap)).event,y=>this.gb(y),this.M)}eb(y){const x=this.ub(y.target||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element;return{browserEvent:y,index:x,element:T}}fb(y){const x=this.ub(y.target||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element;return{browserEvent:y,index:x,element:T}}gb(y){const x=this.ub(y.initialTarget||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element;return{browserEvent:y,index:x,element:T}}hb(y){const x=this.ub(y.target||null),W=typeof x>"u"?void 0:this.d[x],T=W&&W.element,R=this.tb(y,x);return{browserEvent:y,index:x,element:T,sector:R}}ib(y){try{const x=this.vb(this.k,this.m);this.Y(x,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.B&&this.wb(y.scrollTop,y.height,y.inSmoothScrolling)}catch(x){throw console.error("Got bad scroll event:",y),x}}jb(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}kb(y,x,W){if(!W.dataTransfer)return;const T=this.F.getDragElements(y);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.$zS.TEXT,x),W.dataTransfer.setDragImage){let R;this.F.getDragLabel&&(R=this.F.getDragLabel(T,W)),typeof R>"u"&&(R=String(T.length));const L=(0,N.$)(".monaco-drag-image");L.textContent=R;const J=(de=>{for(;de&&!de.classList.contains("monaco-workbench");)de=de.parentElement;return de||this.domNode.ownerDocument})(this.domNode);J.appendChild(L),W.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>J.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new g(T),p.CurrentDragAndDropData=new r(T),this.F.onDragStart?.(this.H,W)}lb(y){if(y.browserEvent.preventDefault(),this.L.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.H)if(p.CurrentDragAndDropData)this.H=p.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.H=new S}const x=this.F.onDragOver(this.H,y.element,y.index,y.sector,y.browserEvent);if(this.G=typeof x=="boolean"?x:x.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof x!="boolean"&&x.effect?.type===0?"copy":"move";let W;typeof x!="boolean"&&x.feedback?W=x.feedback:typeof y.index>"u"?W=[-1]:W=[y.index],W=(0,A.$Mb)(W).filter(R=>R>=-1&&R<this.length).sort((R,L)=>R-L),W=W[0]===-1?[-1]:W;let T=typeof x!="boolean"&&x.effect&&x.effect.position?x.effect.position:"drop-target";if(C(this.I,W)&&this.J===T)return!0;if(this.I=W,this.J=T,this.K.dispose(),W[0]===-1)this.domNode.classList.add(T),this.o.classList.add(T),this.K=(0,P.$Sc)(()=>{this.domNode.classList.remove(T),this.o.classList.remove(T)});else{if(W.length>1&&T!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");T==="drop-target-after"&&W[0]<this.length-1&&(W[0]+=1,T="drop-target-before");for(const R of W){const L=this.d[R];L.dropTarget=!0,L.row?.domNode.classList.add(T)}this.K=(0,P.$Sc)(()=>{for(const R of W){const L=this.d[R];L.dropTarget=!1,L.row?.domNode.classList.remove(T)}})}return!0}mb(y){this.L.dispose(),this.L=(0,b.$jh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,y.element,y.index,y.browserEvent)}nb(y){if(!this.G)return;const x=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,!(!x||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),x.update(y.browserEvent.dataTransfer),this.F.drop(x,y.element,y.index,y.sector,y.browserEvent))}ob(y){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(y)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=P.$Uc.None}qb(y){if(!this.w){const x=(0,N.$lR)(this.domNode).top;this.w=(0,N.$hS)((0,N.getWindow)(this.domNode),this.rb.bind(this,x))}this.x.dispose(),this.x=(0,b.$jh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=y.pageY}rb(y){if(this.y===void 0)return;const x=this.y-y,W=this.renderHeight-35;x<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(x-35))):x>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(x-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(y,x){if(x===void 0)return;const W=y.offsetY/this.d[x].size,T=Math.floor(W/.25);return(0,m.$mm)(T,0,3)}ub(y){const x=this.q.getDomNode();let W=y;for(;W instanceof HTMLElement&&W!==this.o&&x.contains(W);){const T=W.getAttribute("data-index");if(T){const R=Number(T);if(!isNaN(R))return R}W=W.parentElement}}vb(y,x){return{start:this.g.indexAt(y),end:this.g.indexAfter(y+x-1)}}wb(y,x,W){const T=this.vb(y,x);let R,L;y===this.elementTop(T.start)?(R=T.start,L=0):T.end-T.start>1&&(R=T.start+1,L=this.elementTop(R)-y);let X=0;for(;;){const J=this.vb(y,x);let de=!1;for(let ae=J.start;ae<J.end;ae++){const ie=this.xb(ae);ie!==0&&this.g.splice(ae,1,[this.d[ae]]),X+=ie,de=de||ie!==0}if(!de){X!==0&&this.V();const ae=f.Range.relativeComplement(T,J);for(const ge of ae)for(let Fe=ge.start;Fe<ge.end;Fe++)this.d[Fe].row&&this.db(Fe);const ie=f.Range.relativeComplement(J,T).reverse();for(const ge of ie)for(let Fe=ge.end-1;Fe>=ge.start;Fe--)this.Z(Fe);for(let ge=J.start;ge<J.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof R=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-y,Fe=this.elementTop(R)-L+ge;this.setScrollTop(Fe,W)}this.N.fire(this.contentHeight);return}}}xb(y){const x=this.d[y];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(x.element);if(L!==null){const X=x.size;return x.size=L,x.lastDynamicHeightWidth=this.n,L-X}}if(!x.hasDynamicHeight||x.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(x.element))return 0;const W=x.size;if(x.row)return x.row.domNode.style.height="",x.size=x.row.domNode.offsetHeight,x.lastDynamicHeightWidth=this.n,x.size-W;const{row:T}=this.h.alloc(x.templateId);T.domNode.style.height="",this.o.appendChild(T.domNode);const R=this.j.get(x.templateId);if(!R)throw new u.$cb("Missing renderer for templateId: "+x.templateId);return R.renderElement(x.element,y,T.templateData,void 0),x.size=T.domNode.offsetHeight,R.disposeElement?.(x.element,y,T.templateData,void 0),this.R.setDynamicHeight?.(x.element,x.size),x.lastDynamicHeightWidth=this.n,this.o.removeChild(T.domNode),this.h.release(T),x.size-W}getElementDomId(y){return`${this.domId}_${y}`}dispose(){for(const y of this.d)if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const x=this.j.get(y.row.templateId);x&&(x.disposeElement?.(y.element,-1,y.row.templateData,void 0),x.disposeTemplate(y.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$jT=M,Ze([$.$Lh],M.prototype,"onMouseClick",null),Ze([$.$Lh],M.prototype,"onMouseDblClick",null),Ze([$.$Lh],M.prototype,"onMouseMiddleClick",null),Ze([$.$Lh],M.prototype,"onMouseUp",null),Ze([$.$Lh],M.prototype,"onMouseDown",null),Ze([$.$Lh],M.prototype,"onMouseOver",null),Ze([$.$Lh],M.prototype,"onMouseMove",null),Ze([$.$Lh],M.prototype,"onMouseOut",null),Ze([$.$Lh],M.prototype,"onContextMenu",null),Ze([$.$Lh],M.prototype,"onTouchStart",null),Ze([$.$Lh],M.prototype,"onTap",null)}),define(me[43],be([1,0,2,24,15,26,60,74,12,9,77,28,4,37,3,35,5,7,73,64,20,102]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e,s,u,m,p,v,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=t.$AT=t.$zT=t.$yT=t.$vT=t.TypeNavigationMode=void 0,t.$nT=I,t.$oT=O,t.$pT=y,t.$qT=x,t.$rT=W,t.$sT=T,t.$tT=R,t.$uT=L,t.$wT=ge,t.$xT=Fe;class g{constructor(c){this.d=c,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(c){return c}renderElement(c,k,D){const o=this.c.findIndex(a=>a.templateData===D);if(o>=0){const a=this.c[o];this.d.unrender(D),a.index=k}else{const a={index:k,templateData:D};this.c.push(a)}this.d.renderIndex(k,D)}splice(c,k,D){const o=[];for(const a of this.c)a.index<c?o.push(a):a.index>=c+k&&o.push({index:a.index+D-k,templateData:a.templateData});this.c=o}renderIndexes(c){for(const{index:k,templateData:D}of this.c)c.indexOf(k)>-1&&this.d.renderIndex(k,D)}disposeTemplate(c){const k=this.c.findIndex(D=>D.templateData===c);k<0||this.c.splice(k,1)}}class r{get name(){return this.g}get renderer(){return new g(this)}constructor(c){this.g=c,this.c=[],this.d=[],this.f=new f.$7d,this.onChange=this.f.event}splice(c,k,D){const o=D.length-k,a=c+k,n=[];let h=0;for(;h<this.d.length&&this.d[h]<c;)n.push(this.d[h++]);for(let F=0;F<D.length;F++)D[F]&&n.push(F+c);for(;h<this.d.length&&this.d[h]>=a;)n.push(this.d[h++]+o);this.renderer.splice(c,k,D.length),this.h(n,n)}renderIndex(c,k){k.classList.toggle(this.g,this.contains(c))}unrender(c){c.classList.remove(this.g)}set(c,k){return this.h(c,[...c].sort(te),k)}h(c,k,D){const o=this.c,a=this.d;this.c=c,this.d=k;const n=Y(a,c);return this.renderer.renderIndexes(n),this.f.fire({indexes:c,browserEvent:D}),o}get(){return this.c}contains(c){return(0,b.$wb)(this.d,c,te)>=0}dispose(){(0,e.$Pc)(this.f)}}Ze([P.$Lh],r.prototype,"renderer",null);class S extends r{constructor(c){super("selected"),this.k=c}renderIndex(c,k){super.renderIndex(c,k),this.k&&(this.contains(c)?k.setAttribute("aria-selected","true"):k.setAttribute("aria-selected","false"))}}class C{constructor(c,k,D){this.c=c,this.d=k,this.f=D}splice(c,k,D){if(!this.f)return this.c.splice(c,k,new Array(D.length).fill(!1));const o=this.c.get().map(h=>this.f.getId(this.d.element(h)).toString());if(o.length===0)return this.c.splice(c,k,new Array(D.length).fill(!1));const a=new Set(o),n=D.map(h=>a.has(this.f.getId(h).toString()));this.c.splice(c,k,n)}}function I(fe){return fe.tagName==="INPUT"||fe.tagName==="TEXTAREA"}function M(fe,c){return fe.classList.contains(c)?!0:fe.classList.contains("monaco-list")||!fe.parentElement?!1:M(fe.parentElement,c)}function O(fe){return M(fe,"monaco-editor")}function y(fe){return M(fe,"monaco-custom-toggle")}function x(fe){return M(fe,"action-item")}function W(fe){return M(fe,"monaco-tl-twistie")}function T(fe){return M(fe,"monaco-tree-sticky-row")}function R(fe){return fe.classList.contains("monaco-tree-sticky-container")}function L(fe){return fe.tagName==="A"&&fe.classList.contains("monaco-button")||fe.tagName==="DIV"&&fe.classList.contains("monaco-button-dropdown")?!0:fe.classList.contains("monaco-list")||!fe.parentElement?!1:L(fe.parentElement)}class X{get g(){return f.Event.chain(this.c.add(new N.$9S(this.k.domNode,"keydown")).event,c=>c.filter(k=>!I(k.target)).map(k=>new z.$2Q(k)))}constructor(c,k,D){this.h=c,this.k=k,this.c=new e.$Tc,this.d=new e.$Tc,this.f=D.multipleSelectionSupport,this.c.add(this.g(o=>{switch(o.keyCode){case 3:return this.l(o);case 16:return this.o(o);case 18:return this.p(o);case 11:return this.q(o);case 12:return this.s(o);case 9:return this.u(o);case 31:this.f&&(u.$j?o.metaKey:o.ctrlKey)&&this.t(o)}}))}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.f=c.multipleSelectionSupport)}l(c){c.preventDefault(),c.stopPropagation(),this.h.setSelection(this.h.getFocus(),c.browserEvent)}o(c){c.preventDefault(),c.stopPropagation(),this.h.focusPrevious(1,!1,c.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}p(c){c.preventDefault(),c.stopPropagation(),this.h.focusNext(1,!1,c.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}q(c){c.preventDefault(),c.stopPropagation(),this.h.focusPreviousPage(c.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}s(c){c.preventDefault(),c.stopPropagation(),this.h.focusNextPage(c.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}t(c){c.preventDefault(),c.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),c.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(c){this.h.getSelection().length&&(c.preventDefault(),c.stopPropagation(),this.h.setSelection([],c.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ze([P.$Lh],X.prototype,"g",null);var J;(function(fe){fe[fe.Automatic=0]="Automatic",fe[fe.Trigger=1]="Trigger"})(J||(t.TypeNavigationMode=J={}));var de;(function(fe){fe[fe.Idle=0]="Idle",fe[fe.Typing=1]="Typing"})(de||(de={})),t.$vT=new class{mightProducePrintableCharacter(fe){return fe.ctrlKey||fe.metaKey||fe.altKey?!1:fe.keyCode>=31&&fe.keyCode<=56||fe.keyCode>=21&&fe.keyCode<=30||fe.keyCode>=98&&fe.keyCode<=107||fe.keyCode>=85&&fe.keyCode<=95}};class ae{constructor(c,k,D,o,a){this.o=c,this.p=k,this.q=D,this.s=o,this.t=a,this.c=!1,this.d=de.Idle,this.f=J.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(c.options)}updateOptions(c){c.typeNavigationEnabled??!0?this.u():this.v(),this.f=c.typeNavigationMode??J.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let c=!1;const k=f.Event.chain(this.k.add(new N.$9S(this.p.domNode,"keydown")).event,a=>a.filter(n=>!I(n.target)).filter(()=>this.f===J.Automatic||this.g).map(n=>new z.$2Q(n)).filter(n=>c||this.s(n)).filter(n=>this.t.mightProducePrintableCharacter(n)).forEach(n=>i.$ZR.stop(n,!0)).map(n=>n.browserEvent.key)),D=f.Event.debounce(k,()=>null,800,void 0,void 0,void 0,this.k);f.Event.reduce(f.Event.any(k,D),(a,n)=>n===null?null:(a||"")+n,void 0,this.k)(this.x,this,this.k),D(this.w,this,this.k),k(()=>c=!0,void 0,this.k),D(()=>c=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const c=this.o.getFocus();if(c.length>0&&c[0]===this.h){const k=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(c[0]));k&&(0,E.$$S)(k)}this.h=-1}x(c){if(!c){this.d=de.Idle,this.g=!1;return}const k=this.o.getFocus(),D=k.length>0?k[0]:0,o=this.d===de.Idle?1:0;this.d=de.Typing;for(let a=0;a<this.o.length;a++){const n=(D+a+o)%this.o.length,h=this.q.getKeyboardNavigationLabel(this.p.element(n)),F=h&&h.toString();if(this.o.options.typeNavigationEnabled){if(typeof F<"u"){if((0,d.$jk)(c,F)){this.h=D,this.o.setFocus([n]),this.o.reveal(n);return}const B=(0,d.$qk)(c,F);if(B&&B[0].end-B[0].start>1&&B.length===1){this.h=D,this.o.setFocus([n]),this.o.reveal(n);return}}}else if(typeof F>"u"||(0,d.$jk)(c,F)){this.h=D,this.o.setFocus([n]),this.o.reveal(n);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ie{constructor(c,k){this.d=c,this.f=k,this.c=new e.$Tc;const D=f.Event.chain(this.c.add(new N.$9S(k.domNode,"keydown")).event,a=>a.filter(n=>!I(n.target)).map(n=>new z.$2Q(n)));f.Event.chain(D,a=>a.filter(n=>n.keyCode===2&&!n.ctrlKey&&!n.metaKey&&!n.shiftKey&&!n.altKey))(this.g,this,this.c)}g(c){if(c.target!==this.f.domNode)return;const k=this.d.getFocus();if(k.length===0)return;const D=this.f.domElement(k[0]);if(!D)return;const o=D.querySelector("[tabIndex]");if(!o||!(o instanceof HTMLElement)||o.tabIndex===-1)return;const a=(0,i.getWindow)(o).getComputedStyle(o);a.visibility==="hidden"||a.display==="none"||(c.preventDefault(),c.stopPropagation(),o.focus())}dispose(){this.c.dispose()}}function ge(fe){return u.$j?fe.browserEvent.metaKey:fe.browserEvent.ctrlKey}function Fe(fe){return fe.browserEvent.shiftKey}function Ne(fe){return(0,i.$TR)(fe)&&fe.button===2}const Pe={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Fe};class oe{constructor(c){this.k=c,this.f=new e.$Tc,this.g=new f.$7d,this.onPointer=this.g.event,c.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Pe),this.d=typeof c.options.mouseSupport>"u"||!!c.options.mouseSupport,this.d&&(c.onMouseDown(this.s,this,this.f),c.onContextMenu(this.t,this,this.f),c.onMouseDblClick(this.v,this,this.f),c.onTouchStart(this.s,this,this.f),this.f.add(H.$BS.addTarget(c.getHTMLElement()))),f.Event.any(c.onMouseClick,c.onMouseMiddleClick,c.onTap)(this.u,this,this.f)}updateOptions(c){c.multipleSelectionSupport!==void 0&&(this.c=void 0,c.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Pe))}o(c){return this.c?this.c.isSelectionSingleChangeEvent(c):!1}p(c){return this.c?this.c.isSelectionRangeChangeEvent(c):!1}q(c){return this.o(c)||this.p(c)}s(c){O(c.browserEvent.target)||(0,i.$ER)()!==c.browserEvent.target&&this.k.domFocus()}t(c){if(I(c.browserEvent.target)||O(c.browserEvent.target))return;const k=typeof c.index>"u"?[]:[c.index];this.k.setFocus(k,c.browserEvent)}u(c){if(!this.d||I(c.browserEvent.target)||O(c.browserEvent.target)||c.browserEvent.isHandledByList)return;c.browserEvent.isHandledByList=!0;const k=c.index;if(typeof k>"u"){this.k.setFocus([],c.browserEvent),this.k.setSelection([],c.browserEvent),this.k.setAnchor(void 0);return}if(this.q(c))return this.w(c);this.k.setFocus([k],c.browserEvent),this.k.setAnchor(k),Ne(c.browserEvent)||this.k.setSelection([k],c.browserEvent),this.g.fire(c)}v(c){if(I(c.browserEvent.target)||O(c.browserEvent.target)||this.q(c)||c.browserEvent.isHandledByList)return;c.browserEvent.isHandledByList=!0;const k=this.k.getFocus();this.k.setSelection(k,c.browserEvent)}w(c){const k=c.index;let D=this.k.getAnchor();if(this.p(c)){typeof D>"u"&&(D=this.k.getFocus()[0]??k,this.k.setAnchor(D));const o=Math.min(D,k),a=Math.max(D,k),n=(0,b.$Sb)(o,a+1),h=this.k.getSelection(),F=re(Y(h,[D]),D);if(F.length===0)return;const B=Y(n,Q(h,F));this.k.setSelection(B,c.browserEvent),this.k.setFocus([k],c.browserEvent)}else if(this.o(c)){const o=this.k.getSelection(),a=o.filter(n=>n!==k);this.k.setFocus([k]),this.k.setAnchor(k),o.length===a.length?this.k.setSelection([...a,k],c.browserEvent):this.k.setSelection(a,c.browserEvent)}}dispose(){this.f.dispose()}}t.$yT=oe;class U{constructor(c,k){this.c=c,this.d=k}style(c){const k=this.d&&`.${this.d}`,D=[];c.listBackground&&D.push(`.monaco-list${k} .monaco-list-rows { background: ${c.listBackground}; }`),c.listFocusBackground&&(D.push(`.monaco-list${k}:focus .monaco-list-row.focused { background-color: ${c.listFocusBackground}; }`),D.push(`.monaco-list${k}:focus .monaco-list-row.focused:hover { background-color: ${c.listFocusBackground}; }`)),c.listFocusForeground&&D.push(`.monaco-list${k}:focus .monaco-list-row.focused { color: ${c.listFocusForeground}; }`),c.listActiveSelectionBackground&&(D.push(`.monaco-list${k}:focus .monaco-list-row.selected { background-color: ${c.listActiveSelectionBackground}; }`),D.push(`.monaco-list${k}:focus .monaco-list-row.selected:hover { background-color: ${c.listActiveSelectionBackground}; }`)),c.listActiveSelectionForeground&&D.push(`.monaco-list${k}:focus .monaco-list-row.selected { color: ${c.listActiveSelectionForeground}; }`),c.listActiveSelectionIconForeground&&D.push(`.monaco-list${k}:focus .monaco-list-row.selected .codicon { color: ${c.listActiveSelectionIconForeground}; }`),c.listFocusAndSelectionBackground&&D.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { background-color: ${c.listFocusAndSelectionBackground}; }
			`),c.listFocusAndSelectionForeground&&D.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { color: ${c.listFocusAndSelectionForeground}; }
			`),c.listInactiveFocusForeground&&(D.push(`.monaco-list${k} .monaco-list-row.focused { color:  ${c.listInactiveFocusForeground}; }`),D.push(`.monaco-list${k} .monaco-list-row.focused:hover { color:  ${c.listInactiveFocusForeground}; }`)),c.listInactiveSelectionIconForeground&&D.push(`.monaco-list${k} .monaco-list-row.focused .codicon { color:  ${c.listInactiveSelectionIconForeground}; }`),c.listInactiveFocusBackground&&(D.push(`.monaco-list${k} .monaco-list-row.focused { background-color:  ${c.listInactiveFocusBackground}; }`),D.push(`.monaco-list${k} .monaco-list-row.focused:hover { background-color:  ${c.listInactiveFocusBackground}; }`)),c.listInactiveSelectionBackground&&(D.push(`.monaco-list${k} .monaco-list-row.selected { background-color:  ${c.listInactiveSelectionBackground}; }`),D.push(`.monaco-list${k} .monaco-list-row.selected:hover { background-color:  ${c.listInactiveSelectionBackground}; }`)),c.listInactiveSelectionForeground&&D.push(`.monaco-list${k} .monaco-list-row.selected { color: ${c.listInactiveSelectionForeground}; }`),c.listHoverBackground&&D.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${c.listHoverBackground}; }`),c.listHoverForeground&&D.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${c.listHoverForeground}; }`);const o=(0,i.$kS)(c.listFocusAndSelectionOutline,(0,i.$kS)(c.listSelectionOutline,c.listFocusOutline??""));o&&D.push(`.monaco-list${k}:focus .monaco-list-row.focused.selected { outline: 1px solid ${o}; outline-offset: -1px;}`),c.listFocusOutline&&D.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused .monaco-list-row.focused { outline: 1px solid ${c.listFocusOutline}; outline-offset: -1px; }
			`);const a=(0,i.$kS)(c.listSelectionOutline,c.listInactiveFocusOutline??"");a&&D.push(`.monaco-list${k} .monaco-list-row.focused.selected { outline: 1px dotted ${a}; outline-offset: -1px; }`),c.listSelectionOutline&&D.push(`.monaco-list${k} .monaco-list-row.selected { outline: 1px dotted ${c.listSelectionOutline}; outline-offset: -1px; }`),c.listInactiveFocusOutline&&D.push(`.monaco-list${k} .monaco-list-row.focused { outline: 1px dotted ${c.listInactiveFocusOutline}; outline-offset: -1px; }`),c.listHoverOutline&&D.push(`.monaco-list${k} .monaco-list-row:hover { outline: 1px dashed ${c.listHoverOutline}; outline-offset: -1px; }`),c.listDropOverBackground&&D.push(`
				.monaco-list${k}.drop-target,
				.monaco-list${k} .monaco-list-rows.drop-target,
				.monaco-list${k} .monaco-list-row.drop-target { background-color: ${c.listDropOverBackground} !important; color: inherit !important; }
			`),c.listDropBetweenBackground&&(D.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${k} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${c.listDropBetweenBackground};
			}`),D.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${k} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${c.listDropBetweenBackground};
			}`)),c.tableColumnsBorder&&D.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${c.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),c.tableOddRowsBackgroundColor&&D.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${c.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=D.join(`
`)}}t.$zT=U,t.$AT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Et.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Et.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Et.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const le={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function re(fe,c){const k=fe.indexOf(c);if(k===-1)return[];const D=[];let o=k-1;for(;o>=0&&fe[o]===c-(k-o);)D.push(fe[o--]);for(D.reverse(),o=k;o<fe.length&&fe[o]===c+(o-k);)D.push(fe[o++]);return D}function Y(fe,c){const k=[];let D=0,o=0;for(;D<fe.length||o<c.length;)if(D>=fe.length)k.push(c[o++]);else if(o>=c.length)k.push(fe[D++]);else if(fe[D]===c[o]){k.push(fe[D]),D++,o++;continue}else fe[D]<c[o]?k.push(fe[D++]):k.push(c[o++]);return k}function Q(fe,c){const k=[];let D=0,o=0;for(;D<fe.length||o<c.length;)if(D>=fe.length)k.push(c[o++]);else if(o>=c.length)k.push(fe[D++]);else if(fe[D]===c[o]){D++,o++;continue}else fe[D]<c[o]?k.push(fe[D++]):o++;return k}const te=(fe,c)=>fe-c;class ue{constructor(c,k){this.c=c,this.d=k}get templateId(){return this.c}renderTemplate(c){return this.d.map(k=>k.renderTemplate(c))}renderElement(c,k,D,o){let a=0;for(const n of this.d)n.renderElement(c,k,D[a++],o)}disposeElement(c,k,D,o){let a=0;for(const n of this.d)n.disposeElement?.(c,k,D[a],o),a+=1}disposeTemplate(c){let k=0;for(const D of this.d)D.disposeTemplate(c[k++])}}class ye{constructor(c){this.c=c,this.templateId="a18n"}renderTemplate(c){return c}renderElement(c,k,D){const o=this.c.getAriaLabel(c);o?D.setAttribute("aria-label",o):D.removeAttribute("aria-label");const a=this.c.getAriaLevel&&this.c.getAriaLevel(c);typeof a=="number"?D.setAttribute("aria-level",`${a}`):D.removeAttribute("aria-level")}disposeTemplate(c){}}class Te{constructor(c,k){this.c=c,this.d=k}getDragElements(c){const k=this.c.getSelectedElements();return k.indexOf(c)>-1?k:[c]}getDragURI(c){return this.d.getDragURI(c)}getDragLabel(c,k){if(this.d.getDragLabel)return this.d.getDragLabel(c,k)}onDragStart(c,k){this.d.onDragStart?.(c,k)}onDragOver(c,k,D,o,a){return this.d.onDragOver(c,k,D,o,a)}onDragLeave(c,k,D,o){this.d.onDragLeave?.(c,k,D,o)}onDragEnd(c){this.d.onDragEnd?.(c)}drop(c,k,D,o,a){this.d.drop(c,k,D,o,a)}dispose(){this.d.dispose()}}class Ee{get onDidChangeFocus(){return f.Event.map(this.g.wrapEvent(this.c.onChange),c=>this.G(c),this.y)}get onDidChangeSelection(){return f.Event.map(this.g.wrapEvent(this.d.onChange),c=>this.G(c),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let c=!1;const k=f.Event.chain(this.y.add(new N.$9S(this.k.domNode,"keydown")).event,a=>a.map(n=>new z.$2Q(n)).filter(n=>c=n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$ZR.stop(n,!0)).filter(()=>!1)),D=f.Event.chain(this.y.add(new N.$9S(this.k.domNode,"keyup")).event,a=>a.forEach(()=>c=!1).map(n=>new z.$2Q(n)).filter(n=>n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$ZR.stop(n,!0)).map(({browserEvent:n})=>{const h=this.getFocus(),F=h.length?h[0]:void 0,B=typeof F<"u"?this.k.element(F):void 0,j=typeof F<"u"?this.k.domElement(F):this.k.domNode;return{index:F,element:B,anchor:j,browserEvent:n}})),o=f.Event.chain(this.k.onContextMenu,a=>a.filter(n=>!c).map(({element:n,index:h,browserEvent:F})=>({element:n,index:h,anchor:new l.$WQ((0,i.getWindow)(this.k.domNode),F),browserEvent:F})));return f.Event.any(k,D,o)}get onKeyDown(){return this.y.add(new N.$9S(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new N.$9S(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new N.$9S(this.k.domNode,"keypress")).event}get onDidFocus(){return f.Event.signal(this.y.add(new N.$9S(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return f.Event.signal(this.y.add(new N.$9S(this.k.domNode,"blur",!0)).event)}constructor(c,k,D,o,a=le){this.A=c,this.B=a,this.c=new r("focused"),this.f=new r("anchor"),this.g=new f.$ce,this.x="",this.y=new e.$Tc,this.z=new f.$7d,this.onDidDispose=this.z.event;const n=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new S(n!=="listbox");const h=[this.c.renderer,this.d.renderer];this.u=a.accessibilityProvider,this.u&&(h.push(new ye(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),o=o.map(B=>new ue(B.templateId,[...h,B]));const F={...a,dnd:a.dnd&&new Te(this,a.dnd)};if(this.k=this.C(k,D,o,F),this.k.domNode.setAttribute("role",n),a.styleController)this.q=a.styleController(this.k.domId);else{const B=(0,i.$MR)(this.k.domNode);this.q=new U(B,this.k.domId)}if(this.o=new A.$aT([new C(this.c,this.k,a.identityProvider),new C(this.d,this.k,a.identityProvider),new C(this.f,this.k,a.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ie(this,this.k)),(typeof a.keyboardSupport!="boolean"||a.keyboardSupport)&&(this.v=new X(this,this.k,a),this.y.add(this.v)),a.keyboardNavigationLabelProvider){const B=a.keyboardNavigationDelegate||t.$vT;this.t=new ae(this,this.k,a.keyboardNavigationLabelProvider,a.keyboardNavigationEventFilter??(()=>!0),B),this.y.add(this.t)}this.w=this.D(a),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(c,k,D,o){return new v.$jT(c,k,D,o)}D(c){return new oe(this)}updateOptions(c={}){this.B={...this.B,...c},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(c),this.v?.updateOptions(c),this.k.updateOptions(c)}get options(){return this.B}splice(c,k,D=[]){if(c<0||c>this.k.length)throw new p.$lT(this.A,`Invalid start index: ${c}`);if(k<0)throw new p.$lT(this.A,`Invalid delete count: ${k}`);k===0&&D.length===0||this.g.bufferEvents(()=>this.o.splice(c,k,D))}updateWidth(c){this.k.updateWidth(c)}updateElementHeight(c,k){this.k.updateElementHeight(c,k,null)}rerender(){this.k.rerender()}element(c){return this.k.element(c)}indexOf(c){return this.k.indexOf(c)}indexAt(c){return this.k.indexAt(c)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(c){this.k.setScrollTop(c)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(c){this.k.setScrollLeft(c)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(c){this.x=c,this.k.domNode.setAttribute("aria-label",c)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(c,k){this.k.layout(c,k)}triggerTypeNavigation(){this.t?.trigger()}setSelection(c,k){for(const D of c)if(D<0||D>=this.length)throw new p.$lT(this.A,`Invalid index ${D}`);this.d.set(c,k)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(c=>this.k.element(c))}setAnchor(c){if(typeof c>"u"){this.f.set([]);return}if(c<0||c>=this.length)throw new p.$lT(this.A,`Invalid index ${c}`);this.f.set([c])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const c=this.getAnchor();return typeof c>"u"?void 0:this.element(c)}setFocus(c,k){for(const D of c)if(D<0||D>=this.length)throw new p.$lT(this.A,`Invalid index ${D}`);this.c.set(c,k)}focusNext(c=1,k=!1,D,o){if(this.length===0)return;const a=this.c.get(),n=this.E(a.length>0?a[0]+c:0,k,o);n>-1&&this.setFocus([n],D)}focusPrevious(c=1,k=!1,D,o){if(this.length===0)return;const a=this.c.get(),n=this.F(a.length>0?a[0]-c:0,k,o);n>-1&&this.setFocus([n],D)}async focusNextPage(c,k){let D=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);D=D===0?0:D-1;const o=this.getFocus()[0];if(o!==D&&(o===void 0||D>o)){const a=this.F(D,!1,k);a>-1&&o!==a?this.setFocus([a],c):this.setFocus([D],c)}else{const a=this.k.getScrollTop();let n=a+this.k.renderHeight;D>o&&(n-=this.k.elementHeight(D)),this.k.setScrollTop(n),this.k.getScrollTop()!==a&&(this.setFocus([]),await(0,$.$ih)(0),await this.focusNextPage(c,k))}}async focusPreviousPage(c,k,D=()=>0){let o;const a=D(),n=this.k.getScrollTop()+a;n===0?o=this.k.indexAt(n):o=this.k.indexAfter(n-1);const h=this.getFocus()[0];if(h!==o&&(h===void 0||h>=o)){const F=this.E(o,!1,k);F>-1&&h!==F?this.setFocus([F],c):this.setFocus([o],c)}else{const F=n;this.k.setScrollTop(n-this.k.renderHeight-a),this.k.getScrollTop()+D()!==F&&(this.setFocus([]),await(0,$.$ih)(0),await this.focusPreviousPage(c,k,D))}}focusLast(c,k){if(this.length===0)return;const D=this.F(this.length-1,!1,k);D>-1&&this.setFocus([D],c)}focusFirst(c,k){this.focusNth(0,c,k)}focusNth(c,k,D){if(this.length===0)return;const o=this.E(c,!1,D);o>-1&&this.setFocus([o],k)}E(c,k=!1,D){for(let o=0;o<this.length;o++){if(c>=this.length&&!k)return-1;if(c=c%this.length,!D||D(this.element(c)))return c;c++}return-1}F(c,k=!1,D){for(let o=0;o<this.length;o++){if(c<0&&!k)return-1;if(c=(this.length+c%this.length)%this.length,!D||D(this.element(c)))return c;c--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(c=>this.k.element(c))}reveal(c,k,D=0){if(c<0||c>=this.length)throw new p.$lT(this.A,`Invalid index ${c}`);const o=this.k.getScrollTop(),a=this.k.elementTop(c),n=this.k.elementHeight(c);if((0,m.$Yf)(k)){const h=n-this.k.renderHeight+D;this.k.setScrollTop(h*(0,s.$mm)(k,0,1)+a-D)}else{const h=a+n,F=o+this.k.renderHeight;a<o+D&&h>=F||(a<o+D||h>=F&&n>=this.k.renderHeight?this.k.setScrollTop(a-D):h>=F&&this.k.setScrollTop(h-this.k.renderHeight))}}getRelativeTop(c,k=0){if(c<0||c>=this.length)throw new p.$lT(this.A,`Invalid index ${c}`);const D=this.k.getScrollTop(),o=this.k.elementTop(c),a=this.k.elementHeight(c);if(o<D+k||o+a>D+this.k.renderHeight)return null;const n=a-this.k.renderHeight+k;return Math.abs((D+k-o)/n)}isDOMFocused(){return(0,i.$FR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(c){return this.k.getElementDomId(c)}getElementTop(c){return this.k.elementTop(c)}style(c){this.q.style(c)}G({indexes:c,browserEvent:k}){return{indexes:c,elements:c.map(D=>this.k.element(D)),browserEvent:k}}H(){const c=this.c.get();this.k.domNode.classList.toggle("element-focused",c.length>0),this.I()}I(){const c=this.c.get();if(c.length>0){let k;this.u?.getActiveDescendantId&&(k=this.u.getActiveDescendantId(this.k.element(c[0]))),this.k.domNode.setAttribute("aria-activedescendant",k||this.k.getElementDomId(c[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const c=this.d.get();this.k.domNode.classList.toggle("selection-none",c.length===0),this.k.domNode.classList.toggle("selection-single",c.length===1),this.k.domNode.classList.toggle("selection-multiple",c.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$BT=Ee,Ze([P.$Lh],Ee.prototype,"onDidChangeFocus",null),Ze([P.$Lh],Ee.prototype,"onDidChangeSelection",null),Ze([P.$Lh],Ee.prototype,"onContextMenu",null),Ze([P.$Lh],Ee.prototype,"onKeyDown",null),Ze([P.$Lh],Ee.prototype,"onKeyUp",null),Ze([P.$Lh],Ee.prototype,"onKeyPress",null),Ze([P.$Lh],Ee.prototype,"onDidFocus",null),Ze([P.$Lh],Ee.prototype,"onDidBlur",null)}),define(me[65],be([1,0,6,39,41,10,16]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ek=t.MarkdownStringTextNewlineStyle=void 0,t.$Fk=$,t.$Gk=w,t.$Hk=P,t.$Ik=f,t.$Jk=d,t.$Kk=e,t.$Lk=s,t.$Mk=u;var A;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class b{constructor(p="",v=!1){if(this.value=p,typeof this.value!="string")throw(0,i.$7)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(p,v=0){return this.value+=f(this.supportThemeIcons?(0,N.$yk)(p):p).replace(/([ \t]+)/g,(l,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,v){return this.value+=`
${d(v,p)}
`,this}appendLink(p,v,l){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(p),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(p,v){const l=new RegExp((0,H.$Ze)(v),"g");return p.replace(l,(g,r)=>p.charAt(r-1)!=="\\"?`\\${g}`:g)}}t.$Ek=b;function $(m){return w(m)?!m.value:Array.isArray(m)?m.every($):!0}function w(m){return m instanceof b?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}function P(m,p){return m===p?!0:!m||!p?!1:m.value===p.value&&m.isTrusted===p.isTrusted&&m.supportThemeIcons===p.supportThemeIcons&&m.supportHtml===p.supportHtml&&(m.baseUri===p.baseUri||!!m.baseUri&&!!p.baseUri&&(0,z.$Ng)(E.URI.from(m.baseUri),E.URI.from(p.baseUri)))}function f(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function d(m,p){const v=m.match(/^`+/gm)?.reduce((g,r)=>g.length>r.length?g:r).length??0,l=v>=3?v+1:3;return[`${"`".repeat(l)}${p}`,m,`${"`".repeat(l)}`].join(`
`)}function e(m){return m.replace(/"/g,"&quot;")}function s(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function u(m){const p=[],v=m.split("|").map(g=>g.trim());m=v[0];const l=v[1];if(l){const g=/height=(\d+)/.exec(l),r=/width=(\d+)/.exec(l),S=g?g[1]:"",C=r?r[1]:"",I=isFinite(parseInt(C)),M=isFinite(parseInt(S));I&&p.push(`width="${C}"`),M&&p.push(`height="${S}"`)}return{href:m,dimensions:p}}}),define(me[130],be([1,0,2,122,24,58,15,20,123,6,4,65,39,80,23,3,82,56,32,54,41,10,16]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e,s,u,m,p,v,l,g,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FT=void 0,t.$ET=C,t.$GT=x,t.$HT=W,t.$IT=de;const S=Object.freeze({image:(Q,te,ue)=>{let ye=[],Te=[];return Q&&({href:Q,dimensions:ye}=(0,P.$Mk)(Q),Te.push(`src="${(0,P.$Kk)(Q)}"`)),ue&&Te.push(`alt="${(0,P.$Kk)(ue)}"`),te&&Te.push(`title="${(0,P.$Kk)(te)}"`),ye.length&&(Te=Te.concat(ye)),"<img "+Te.join(" ")+">"},paragraph:Q=>`<p>${Q}</p>`,link:(Q,te,ue)=>typeof Q!="string"?"":(Q===ue&&(ue=(0,P.$Lk)(ue)),te=typeof te=="string"?(0,P.$Kk)((0,P.$Lk)(te)):"",Q=(0,P.$Lk)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${te||Q}" draggable="false">${ue}</a>`)});function C(Q,te={},ue={}){const ye=new s.$Tc;let Te=!1;const Ee=(0,H.$8S)(te),fe=function(B){let j;try{j=(0,m.$Ph)(decodeURIComponent(B))}catch{}return j?(j=(0,v.$Pn)(j,V=>{if(Q.uris&&Q.uris[V])return r.URI.revive(Q.uris[V])}),encodeURIComponent(JSON.stringify(j))):B},c=function(B,j){const V=Q.uris&&Q.uris[B];let Z=r.URI.revive(V);return j?B.startsWith(p.Schemas.data+":")?B:(Z||(Z=r.URI.parse(B)),p.$Bg.uriToBrowserUri(Z).toString(!0)):!Z||r.URI.parse(B).toString()===Z.toString()?B:(Z.query&&(Z=Z.with({query:fe(Z.query)})),Z.toString())},k=new u.marked.Renderer;k.image=S.image,k.link=S.link,k.paragraph=S.paragraph;const D=[],o=[];if(te.codeBlockRendererSync?k.code=(B,j)=>{const V=d.$GO.nextId(),Z=te.codeBlockRendererSync(I(j),B);return o.push([V,Z]),`<div class="code" data-code="${V}">${(0,g.$Ye)(B)}</div>`}:te.codeBlockRenderer&&(k.code=(B,j)=>{const V=d.$GO.nextId(),Z=te.codeBlockRenderer(I(j),B);return D.push(Z.then(_=>[V,_])),`<div class="code" data-code="${V}">${(0,g.$Ye)(B)}</div>`}),te.actionHandler){const B=function(Z){let _=Z.target;if(!(_.tagName!=="A"&&(_=_.parentElement,!_||_.tagName!=="A")))try{let $e=_.dataset.href;$e&&(Q.baseUri&&($e=M(r.URI.from(Q.baseUri),$e)),te.actionHandler.callback($e,Z))}catch($e){(0,$.$1)($e)}finally{Z.preventDefault()}},j=te.actionHandler.disposables.add(new z.$9S(Ee,"click")),V=te.actionHandler.disposables.add(new z.$9S(Ee,"auxclick"));te.actionHandler.disposables.add(w.Event.any(j.event,V.event)(Z=>{const _=new A.$WQ(i.getWindow(Ee),Z);!_.leftButton&&!_.middleButton||B(_)})),te.actionHandler.disposables.add(i.$5Q(Ee,"keydown",Z=>{const _=new E.$2Q(Z);!_.equals(10)&&!_.equals(3)||B(_)}))}Q.supportHtml||(ue.sanitizer=B=>(Q.isTrusted?B.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?B:"",ue.sanitize=!0,ue.silent=!0),ue.renderer=k;let a=Q.value??"";a.length>1e5&&(a=`${a.substr(0,1e5)}\u2026`),Q.supportThemeIcons&&(a=(0,f.$zk)(a));let n;if(te.fillInIncompleteTokens){const B={...u.marked.defaults,...ue},j=u.marked.lexer(a,B),V=de(j);n=u.marked.parser(V,B)}else n=u.marked.parse(a,ue);Q.supportThemeIcons&&(n=(0,b.$CT)(n).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const F=new DOMParser().parseFromString(O(Q,n),"text/html");if(F.body.querySelectorAll("img").forEach(B=>{const j=B.getAttribute("src");if(j){let V=j;try{Q.baseUri&&(V=M(r.URI.from(Q.baseUri),V))}catch{}B.src=c(V,!0)}}),F.body.querySelectorAll("a").forEach(B=>{const j=B.getAttribute("href");if(B.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!Q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))B.replaceWith(...B.childNodes);else{let V=c(j,!1);Q.baseUri&&(V=M(r.URI.from(Q.baseUri),j)),B.dataset.href=V}}),Ee.innerHTML=O(Q,F.body.innerHTML),D.length>0)Promise.all(D).then(B=>{if(Te)return;const j=new Map(B),V=Ee.querySelectorAll("div[data-code]");for(const Z of V){const _=j.get(Z.dataset.code??"");_&&i.$7R(Z,_)}te.asyncRenderCallback?.()});else if(o.length>0){const B=new Map(o),j=Ee.querySelectorAll("div[data-code]");for(const V of j){const Z=B.get(V.dataset.code??"");Z&&i.$7R(V,Z)}}if(te.asyncRenderCallback)for(const B of Ee.getElementsByTagName("img")){const j=ye.add(i.$5Q(B,"load",()=>{j.dispose(),te.asyncRenderCallback()}))}return{element:Ee,dispose:()=>{Te=!0,ye.dispose()}}}function I(Q){if(!Q)return"";const te=Q.split(/[\s+|:|,|\{|\?]/,1);return te.length?te[0]:Q}function M(Q,te){return/^\w[\w\d+.-]*:/.test(te)?te:Q.path.endsWith("/")?(0,l.$Xg)(Q,te).toString():(0,l.$Xg)((0,l.$Tg)(Q),te).toString()}function O(Q,te){const{config:ue,allowedSchemes:ye}=y(Q);N.addHook("uponSanitizeAttribute",(Ee,fe)=>{if(fe.attrName==="style"||fe.attrName==="class"){if(Ee.tagName==="SPAN"){if(fe.attrName==="style"){fe.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(fe.attrValue);return}else if(fe.attrName==="class"){fe.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(fe.attrValue);return}}fe.keepAttr=!1;return}else if(Ee.tagName==="INPUT"&&Ee.attributes.getNamedItem("type")?.value==="checkbox"){if(fe.attrName==="type"&&fe.attrValue==="checkbox"||fe.attrName==="disabled"||fe.attrName==="checked"){fe.keepAttr=!0;return}fe.keepAttr=!1}}),N.addHook("uponSanitizeElement",(Ee,fe)=>{fe.tagName==="input"&&(Ee.attributes.getNamedItem("type")?.value==="checkbox"?Ee.setAttribute("disabled",""):Ee.parentElement?.removeChild(Ee))});const Te=i.$oS(ye);try{return N.sanitize(te,{...ue,RETURN_TRUSTED_TYPE:!0})}finally{N.removeHook("uponSanitizeAttribute"),Te.dispose()}}t.$FT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function y(Q){const te=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return Q.isTrusted&&te.push(p.Schemas.command),{config:{ALLOWED_TAGS:[...i.$pS],ALLOWED_ATTR:t.$FT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:te}}function x(Q){return typeof Q=="string"?Q:W(Q)}function W(Q){let te=Q.value??"";te.length>1e5&&(te=`${te.substr(0,1e5)}\u2026`);const ue=u.marked.parse(te,{renderer:R.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ye=>T.get(ye)??ye);return O({isTrusted:!1},ue).toString()}const T=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),R=new e.$V(()=>{const Q=new u.marked.Renderer;return Q.code=te=>te,Q.blockquote=te=>te,Q.html=te=>"",Q.heading=(te,ue,ye)=>te+`
`,Q.hr=()=>"",Q.list=(te,ue)=>te,Q.listitem=te=>te+`
`,Q.paragraph=te=>te+`
`,Q.table=(te,ue)=>te+ue+`
`,Q.tablerow=te=>te,Q.tablecell=(te,ue)=>te+" ",Q.strong=te=>te,Q.em=te=>te,Q.codespan=te=>te,Q.br=()=>`
`,Q.del=te=>te,Q.image=(te,ue,ye)=>"",Q.text=te=>te,Q.link=(te,ue,ye)=>ye,Q});function L(Q){let te="";return Q.forEach(ue=>{te+=ue.raw}),te}function X(Q){for(let te=0;te<Q.tokens.length;te++){const ue=Q.tokens[te];if(ue.type==="text"){const ye=ue.raw.split(`
`),Te=ye[ye.length-1];if(Te.includes("`"))return ie(Q);if(Te.includes("**"))return U(Q);if(Te.match(/\*\w/))return ge(Q);if(Te.match(/(^|\s)__\w/))return le(Q);if(Te.match(/(^|\s)_\w/))return Fe(Q);if(Te.match(/(^|\s)\[.*\]\(\w*/)){const Ee=Q.tokens.slice(te+1);return Ee[0]?.type==="link"&&Ee[1]?.type==="text"&&Ee[1].raw.match(/^ *"[^"]*$/)?Pe(Q):Ne(Q)}else{if(J(Te))return Ne(Q);if(Te.match(/(^|\s)\[\w/)&&!Q.tokens.slice(te+1).some(Ee=>J(Ee.raw)))return oe(Q)}}}}function J(Q){return!!Q.match(/^[^\[]*\]\([^\)]*$/)}function de(Q){let te,ue;for(te=0;te<Q.length;te++){const ye=Q[te];let Te;if(ye.type==="paragraph"&&(Te=ye.raw.match(/(\n|^)(````*)/))){const Ee=Te[2];ue=ae(Q.slice(te),Ee);break}if(ye.type==="paragraph"&&ye.raw.match(/(\n|^)\|/)){ue=Y(Q.slice(te));break}if(te===Q.length-1&&ye.type==="paragraph"){const Ee=X(ye);if(Ee){ue=[Ee];break}}}if(ue){const ye=[...Q.slice(0,te),...ue];return ye.links=Q.links,ye}return Q}function ae(Q,te){const ue=L(Q);return u.marked.lexer(ue+`
${te}`)}function ie(Q){return re(Q,"`")}function ge(Q){return re(Q,"*")}function Fe(Q){return re(Q,"_")}function Ne(Q){return re(Q,")")}function Pe(Q){return re(Q,'")')}function oe(Q){return re(Q,"](about:blank)")}function U(Q){return re(Q,"**")}function le(Q){return re(Q,"__")}function re(Q,te){const ue=L(Array.isArray(Q)?Q:[Q]);return u.marked.lexer(ue+te)[0]}function Y(Q){const te=L(Q),ue=te.split(`
`);let ye,Te=!1;for(let Ee=0;Ee<ue.length;Ee++){const fe=ue[Ee].trim();if(typeof ye>"u"&&fe.match(/^\s*\|/)){const c=fe.match(/(\|[^\|]+)(?=\||$)/g);c&&(ye=c.length)}else if(typeof ye=="number")if(fe.match(/^\s*\|/)){if(Ee!==ue.length-1)return;Te=!0}else return}if(typeof ye=="number"&&ye>0){const Ee=Te?ue.slice(0,-1).join(`
`):te,fe=!!Ee.match(/\|\s*$/),c=Ee+(fe?"":"|")+`
|${" --- |".repeat(ye)}`;return u.marked.lexer(c)}}}),define(me[33],be([1,0,2,9,30,65,39,3,7,112]),function(se,t,i,N,z,H,E,A,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VS=w,t.$WS=d;function w(e,s){(0,b.$Uf)(s)?e.title=(0,E.$Ak)(s):s?.markdownNotSupportedFallback?e.title=s.markdownNotSupportedFallback:e.removeAttribute("title")}class P{constructor(s,u,m){this.c=s,this.d=u,this.f=m}async update(s,u,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let p;if(s===void 0||(0,b.$Uf)(s)||s instanceof HTMLElement)p=s;else if(!(0,b.$9f)(s.markdown))p=s.markdown??s.markdownNotSupportedFallback;else{this.a||this.g((0,$.localize)(0,null),u),this.b=new z.$ee;const v=this.b.token;if(p=await s.markdown(v),p===void 0&&(p=s.markdownNotSupportedFallback),this.isDisposed||v.isCancellationRequested)return}this.g(p,u,m)}g(s,u,m){const p=this.a;if(this.h(s)){const v={content:s,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!p},position:{hoverPosition:2},...m};this.a=this.c.showHover(v,u)}p?.dispose()}h(s){return s?(0,H.$Gk)(s)?!!s.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function f(e,s){for(s=s??i.getWindow(e).document.body;!e.hasAttribute("custom-hover")&&e!==s;)e=e.parentElement;return e}function d(e,s,u,m){s.setAttribute("custom-hover","true"),s.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",s.title),s.title="");let p,v;const l=(R,L)=>{const X=v!==void 0;R&&(v?.dispose(),v=void 0),L&&(p?.dispose(),p=void 0),X&&(e.onDidHideHover?.(),v=void 0)},g=(R,L,X)=>new N.$rh(async()=>{(!v||v.isDisposed)&&(v=new P(e,X||s,R>0),await v.update(typeof u=="function"?u():u,L,m))},R);let r=!1;const S=i.$5Q(s,i.$XR.MOUSE_DOWN,()=>{r=!0,l(!0,!0)},!0),C=i.$5Q(s,i.$XR.MOUSE_UP,()=>{r=!1},!0),I=i.$5Q(s,i.$XR.MOUSE_LEAVE,R=>{r=!1,l(!1,R.fromElement===s)},!0),M=R=>{if(p)return;const L=new A.$Tc,X={targetElements:[s],dispose:()=>{}};if(e.placement===void 0||e.placement==="mouse"){const J=de=>{X.x=de.x+10,de.target instanceof HTMLElement&&f(de.target,s)!==s&&l(!0,!0)};L.add(i.$5Q(s,i.$XR.MOUSE_MOVE,J,!0))}p=L,!(R.target instanceof HTMLElement&&f(R.target,s)!==s)&&L.add(g(e.delay,!1,X))},O=i.$5Q(s,i.$XR.MOUSE_OVER,M,!0),y=()=>{if(r||p)return;const R={targetElements:[s],dispose:()=>{}},L=new A.$Tc,X=()=>l(!0,!0);L.add(i.$5Q(s,i.$XR.BLUR,X,!0)),L.add(g(e.delay,!1,R)),p=L};let x;const W=s.tagName.toLowerCase();return W!=="input"&&W!=="textarea"&&(x=i.$5Q(s,i.$XR.FOCUS,y,!0)),{show:R=>{l(!1,!0),g(0,R)},hide:()=>{l(!0,!0)},update:async(R,L)=>{u=R,await v?.update(u,void 0,L)},dispose:()=>{O.dispose(),I.dispose(),S.dispose(),C.dispose(),x?.dispose(),l(!0,!0)}}}}),define(me[131],be([1,0,2,24,15,130,14,33,43,12,4,48,3,5,114,105]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JT=void 0;const s=i.$,u="selectOption.entry.template";class m{get templateId(){return u}renderTemplate(l){const g=Object.create(null);return g.root=l,g.text=i.$5R(l,s(".option-text")),g.detail=i.$5R(l,s(".option-detail")),g.decoratorRight=i.$5R(l,s(".option-decorator-right")),g}renderElement(l,g,r){const S=r,C=l.text,I=l.detail,M=l.decoratorRight,O=l.isDisabled;S.text.textContent=C,S.detail.textContent=I||"",S.decoratorRight.innerText=M||"",O?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(l){}}class p extends f.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(l,g,r,S,C){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=S,this.g=C||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=p.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$7d,this.B(this.r),this.Q(),this.P(r),this.n=g||0,l&&this.setOptions(l,g),this.S()}O(l){!this.M&&l?this.M=this.B((0,A.$WS)((0,E.$YS)("mouse"),this.h,l)):this.M&&this.M.update(l)}getHeight(){return 22}getTemplateId(){return u}P(l){this.u=l,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$5R(this.w,s(".select-box-details-pane"));const g=i.$5R(this.w,s(".select-box-dropdown-container-width-control")),r=i.$5R(g,s(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$5R(r,this.D),this.G=0,this.y=i.$MR(this.w),this.w.setAttribute("draggable","true"),this.B(i.$5Q(this.w,i.$XR.DRAG_START,S=>{i.$ZR.stop(S,!0)}))}Q(){this.B(i.$6Q(this.h,"change",g=>{this.n=g.target.selectedIndex,this.r.fire({index:g.target.selectedIndex,selected:g.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$5Q(this.h,i.$XR.CLICK,g=>{i.$ZR.stop(g),this.f?this.Z(!0):this.Y()})),this.B(i.$5Q(this.h,i.$XR.MOUSE_DOWN,g=>{i.$ZR.stop(g)}));let l;this.B(i.$5Q(this.h,"touchstart",g=>{l=this.f})),this.B(i.$5Q(this.h,"touchend",g=>{i.$ZR.stop(g),l?this.Z(!0):this.Y()})),this.B(i.$5Q(this.h,i.$XR.KEY_DOWN,g=>{const r=new z.$2Q(g);let S=!1;d.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(S=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(S=!0),S&&(this.Y(),i.$ZR.stop(g,!0))}))}get onDidSelect(){return this.r.event}setOptions(l,g){$.$ub(this.m,l)||(this.m=l,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,S)=>{this.h.add(this.X(r.text,S,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),g!==void 0&&(this.select(g),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(l){l>=0&&l<this.m.length?this.n=l:l>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(l){this.g.ariaLabel=l,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(l){this.h.tabIndex=l?0:-1}render(l){this.j=l,l.classList.add("select-container"),l.appendChild(this.h),this.U()}S(){const l=[];this.s.listFocusBackground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(l.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),l.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),l.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=l.join(`
`)}U(){const l=this.s.selectBackground??"",g=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=l,this.h.style.color=g,this.h.style.borderColor=r}W(){const l=this.s.selectBackground??"",g=i.$kS(this.s.selectListBackground,l);this.C.style.backgroundColor=g,this.I.style.backgroundColor=g;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(l,g,r){const S=document.createElement("option");return S.value=l,S.text=l,S.disabled=!!r,S}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:l=>this.ab(l,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:l=>this.ab(l),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(l){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),l&&this.h.focus(),this.u.hideContextView())}ab(l,g){return l.appendChild(this.w),this.cb(g),{dispose:()=>{try{l.removeChild(this.w)}catch{}}}}bb(){let l=0;return this.m.forEach((g,r)=>{this.jb(r),this.I.offsetHeight>l&&(l=this.I.offsetHeight)}),l}cb(l){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const g=i.getWindow(this.h),r=i.$oR(this.h),S=i.getWindow(this.h).getComputedStyle(this.h),C=parseFloat(S.getPropertyValue("--dropdown-padding-top"))+parseFloat(S.getPropertyValue("--dropdown-padding-bottom")),I=g.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),M=r.top-p.b,O=this.h.offsetWidth,y=this.db(this.D),x=Math.max(y,Math.round(O)).toString()+"px";this.w.style.width=x,this.z.getHTMLElement().style.height="",this.z.layout();let W=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const T=this.H?this.L:0,R=W+C+T,L=Math.floor((I-C-T)/this.getHeight()),X=Math.floor((M-C-T)/this.getHeight());if(l)return r.top+r.height>g.innerHeight-22||r.top<p.b||L<1&&X<1?!1:(L<p.c&&X>L&&this.m.length>L?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>g.innerHeight-22||r.top<p.b||this.G===0&&L<1||this.G===1&&X<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&L+X<1)return this.Z(!0),!1;R>I&&(W=L*this.getHeight())}else R>M&&(W=X*this.getHeight());return this.z.layout(W),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=W+C+"px",this.w.style.height=""):this.w.style.height=W+C+"px",this.jb(this.n),this.w.style.width=x,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(l){let g=0;if(l){let r=0,S=0;this.m.forEach((C,I)=>{const M=C.detail?C.detail.length:0,O=C.decoratorRight?C.decoratorRight.length:0,y=C.text.length+M+O;y>S&&(r=I,S=y)}),l.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),g=i.$qR(l)}return g}eb(l){if(this.z)return;this.C=i.$5R(l,s(".select-box-dropdown-list-container")),this.t=new m,this.z=new b.$BT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let C=S.text;return S.detail&&(C+=`. ${S.detail}`),S.decoratorRight&&(C+=`. ${S.decoratorRight}`),S.description&&(C+=`. ${S.description}`),C},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>d.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const g=this.B(new N.$9S(this.C,"keydown")),r=w.Event.chain(g.event,S=>S.filter(()=>this.z.length>0).map(C=>new z.$2Q(C)));this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===3))(this.lb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===2))(this.lb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===9))(this.kb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===16))(this.nb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===18))(this.mb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===12))(this.pb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===11))(this.ob,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===14))(this.qb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode===13))(this.rb,this)),this.B(w.Event.chain(r,S=>S.filter(C=>C.keyCode>=21&&C.keyCode<=56||C.keyCode>=85&&C.keyCode<=113))(this.sb,this)),this.B(i.$5Q(this.z.getHTMLElement(),i.$XR.POINTER_UP,S=>this.fb(S))),this.B(this.z.onMouseOver(S=>typeof S.index<"u"&&this.z.setFocus([S.index]))),this.B(this.z.onDidChangeFocus(S=>this.ib(S))),this.B(i.$5Q(this.w,i.$XR.FOCUS_OUT,S=>{!this.f||i.$wR(S.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(l){if(!this.z.length)return;i.$ZR.stop(l);const g=l.target;if(!g||g.classList.contains("slider"))return;const r=g.closest(".monaco-list-row");if(!r)return;const S=Number(r.getAttribute("data-index")),C=r.classList.contains("option-disabled");S>=0&&S<this.m.length&&!C&&(this.n=S,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(l,g){const r=C=>{for(let I=0;I<C.childNodes.length;I++){const M=C.childNodes.item(I);(M.tagName&&M.tagName.toLowerCase())==="img"?C.removeChild(M):r(M)}},S=(0,H.$ET)({value:l,supportThemeIcons:!0},{actionHandler:g});return S.element.classList.add("select-box-description-markdown"),r(S.element),S.element}ib(l){!this.f||!this.H||this.jb(l.indexes[0])}jb(l){this.I.innerText="";const g=this.m[l],r=g?.description??"",S=g?.descriptionIsMarkdown??!1;if(r){if(S){const C=g.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,C))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(l){i.$ZR.stop(l),this.select(this.F),this.Z(!0)}lb(l){i.$ZR.stop(l),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(l){if(this.n<this.m.length-1){i.$ZR.stop(l,!0);const g=this.m[this.n+1].isDisabled;if(g&&this.m.length>this.n+2)this.n+=2;else{if(g)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(l){this.n>0&&(i.$ZR.stop(l,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(l){i.$ZR.stop(l),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(l){i.$ZR.stop(l),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(l){i.$ZR.stop(l),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(l){i.$ZR.stop(l),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(l){const g=P.KeyCodeUtils.toString(l.keyCode);let r=-1;for(let S=0;S<this.m.length-1;S++)if(r=(S+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===g&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$ZR.stop(l);break}}dispose(){this.Z(!1),super.dispose()}}t.$JT=p}),define(me[132],be([1,0,43,131,126,21,5,104]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MT=t.$LT=void 0,t.$LT={...i.$AT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends H.$FS{constructor($,w,P,f,d){super(),E.$j&&!d?.useCustomDrawn?this.a=new z.$KT($,w,f,d):this.a=new N.$JT($,w,P,f,d),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions($,w){this.a.setOptions($,w)}select($){this.a.select($)}setAriaLabel($){this.a.setAriaLabel($)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable($){this.a.setFocusable($)}render($){this.a.render($)}}t.$MT=A}),define(me[66],be([1,0,17,57,2,26,14,33,132,40,3,5,7,109,55]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=t.$TT=t.$ST=void 0;class e extends w.$Uc{get action(){return this._action}constructor(p,v,l={}){super(),this.m=l,this._context=p||this,this._action=v,v instanceof $.$Yi&&this.B(v.onDidChange(g=>{this.element&&this.t(g)}))}t(p){p.enabled!==void 0&&this.u(),p.checked!==void 0&&this.H(),p.class!==void 0&&this.G(),p.label!==void 0&&(this.w(),this.D()),p.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new $.$Zi)),this.j}set actionRunner(p){this.j=p}isEnabled(){return this._action.enabled}setActionContext(p){this._context=p}render(p){const v=this.element=p;this.B(H.$BS.addTarget(p));const l=this.m&&this.m.draggable;l&&(p.draggable=!0,i.$KQ&&this.B((0,z.$5Q)(p,z.$XR.DRAG_START,g=>g.dataTransfer?.setData(N.$zS.TEXT,this._action.label)))),this.B((0,z.$5Q)(v,H.EventType.Tap,g=>this.onClick(g,!0))),this.B((0,z.$5Q)(v,z.$XR.MOUSE_DOWN,g=>{l||z.$ZR.stop(g,!0),this._action.enabled&&g.button===0&&v.classList.add("active")})),P.$j&&this.B((0,z.$5Q)(v,z.$XR.CONTEXT_MENU,g=>{g.button===0&&g.ctrlKey===!0&&this.onClick(g)})),this.B((0,z.$5Q)(v,z.$XR.CLICK,g=>{z.$ZR.stop(g,!0),this.m&&this.m.isMenu||this.onClick(g)})),this.B((0,z.$5Q)(v,z.$XR.DBLCLICK,g=>{z.$ZR.stop(g,!0)})),[z.$XR.MOUSE_UP,z.$XR.MOUSE_OUT].forEach(g=>{this.B((0,z.$5Q)(v,g,r=>{z.$ZR.stop(r),v.classList.remove("active")}))})}onClick(p,v=!1){z.$ZR.stop(p,!0);const l=f.$4f(this._context)?this.m?.useEventAsContext?p:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,l)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(p){this.element&&(this.element.tabIndex=p?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const p=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=p;else if(!this.f&&p!==""){const v=this.m.hoverDelegate??(0,E.$YS)("element");this.f=this.q.add((0,A.$WS)(v,this.element,p))}else this.f&&this.f.update(p)}F(){if(this.element){const p=this.C()??"";this.element.setAttribute("aria-label",p)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$ST=e;class s extends e{constructor(p,v,l){super(p,v,l),this.m=l,this.m.icon=l.icon!==void 0?l.icon:!1,this.m.label=l.label!==void 0?l.label:!0,this.L=""}render(p){super.render(p),f.$5f(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.M()),this.I=v,this.element.appendChild(v),this.m.label&&this.m.keybinding){const l=document.createElement("span");l.classList.add("keybinding"),l.textContent=this.m.keybinding,this.element.appendChild(l)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===$.$1i.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(p){this.I&&(this.I.tabIndex=p?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let p=null;return this.action.tooltip?p=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(p=this.action.label,this.m.keybinding&&(p=d.localize(0,null,p,this.m.keybinding))),p??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const p=this.C()??"";this.I.setAttribute("aria-label",p)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$TT=s;class u extends e{constructor(p,v,l,g,r,S,C){super(p,v),this.b=new b.$MT(l,g,r,S,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(p,v){this.b.setOptions(p,v)}select(p){this.b.select(p)}g(){this.B(this.b.onDidSelect(p=>this.n(p.selected,p.index)))}n(p,v){this.actionRunner.run(this._action,this.r(p,v))}r(p,v){return p}setFocusable(p){this.b.setFocusable(p)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(p){this.b.render(p)}}t.$UT=u}),define(me[67],be([1,0,2,15,66,14,40,4,3,7,55]),function(se,t,i,N,z,H,E,A,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=t.ActionsOrientation=void 0,t.$2S=f;var w;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class P extends b.$Uc{constructor(e,s={}){super(),this.j=this.B(new b.$Tc),this.s=this.B(new b.$4c),this.y=!1,this.z=!0,this.D=this.B(new A.$7d),this.onDidBlur=this.D.event,this.F=this.B(new A.$7d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new A.$7d),this.onDidRun=this.H.event,this.I=this.B(new A.$7d),this.onWillRun=this.I.event,this.b=s,this.m=s.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=s.hoverDelegate??this.B((0,H.$ZS)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new E.$Zi,this.j.add(this.g)),this.j.add(this.g.onDidRun(p=>this.H.fire(p))),this.j.add(this.g.onWillRun(p=>this.I.fire(p))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let u,m;switch(this.n){case 0:u=[15],m=[17];break;case 1:u=[16],m=[18],this.domNode.className+=" vertical";break}this.B(i.$5Q(this.domNode,i.$XR.KEY_DOWN,p=>{const v=new N.$2Q(p);let l=!0;const g=typeof this.u=="number"?this.viewItems[this.u]:void 0;u&&(v.equals(u[0])||v.equals(u[1]))?l=this.Q():m&&(v.equals(m[0])||v.equals(m[1]))?l=this.P():v.equals(9)&&this.G?this.F.fire():v.equals(14)?l=this.N():v.equals(13)?l=this.O():v.equals(2)&&g instanceof z.$ST&&g.trapsArrowNavigation?l=this.P():this.L(v)?this.r.keyDown?this.S(v):this.y=!0:l=!1,l&&(v.preventDefault(),v.stopPropagation())})),this.B(i.$5Q(this.domNode,i.$XR.KEY_UP,p=>{const v=new N.$2Q(p);this.L(v)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(v)),v.preventDefault(),v.stopPropagation()):(v.equals(2)||v.equals(1026)||v.equals(16)||v.equals(18)||v.equals(15)||v.equals(17))&&this.M()})),this.w=this.B(i.$3R(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$ER()===this.domNode||!i.$wR(i.$ER(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const s=this.viewItems.find(u=>u instanceof z.$ST&&u.isEnabled());s instanceof z.$ST&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof z.$ST&&s.setFocusable(!1)})}L(e){let s=!1;return this.r.keys.forEach(u=>{s=s||e.equals(u)}),s}M(){for(let e=0;e<this.C.children.length;e++){const s=this.C.children[e];if(i.$wR(i.$ER(),s)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(s=>s.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(s=>this.H.fire(s))),this.j.add(this.g.onWillRun(s=>this.I.fire(s))),this.viewItems.forEach(s=>s.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(s=>s.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let s=0;s<this.C.childNodes.length;s++)if(this.C.childNodes[s]===e)return this.viewItems[s].action}}push(e,s={}){const u=Array.isArray(e)?e:[e];let m=$.$Yf(s.index)?s.index:null;u.forEach(p=>{const v=document.createElement("li");v.className="action-item",v.setAttribute("role","presentation");let l;const g={hoverDelegate:this.f,...s};this.b.actionViewItemProvider&&(l=this.b.actionViewItemProvider(p,g)),l||(l=new z.$TT(this.context,p,g)),this.b.allowContextMenu||this.s.set(l,i.$5Q(v,i.$XR.CONTEXT_MENU,r=>{i.$ZR.stop(r,!0)})),l.actionRunner=this.g,l.setActionContext(this.context),l.render(v),this.z&&l instanceof z.$ST&&this.viewItems.length===0&&l.setFocusable(!0),m===null||m<0||m>=this.C.children.length?(this.C.appendChild(v),this.viewItems.push(l)):(this.C.insertBefore(v,this.C.children[m]),this.viewItems.splice(m,0,l),m++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const s=this.C.children.item(e);if(s)return s.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const s=this.C.children.item(e);if(s)return s.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,b.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,b.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$4Q(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let s=!1,u;if(e===void 0?s=!0:typeof e=="number"?u=e:typeof e=="boolean"&&(s=e),s&&typeof this.u>"u"){const m=this.viewItems.findIndex(p=>p.isEnabled());this.u=m===-1?void 0:m,this.R(void 0,void 0,!0)}else u!==void 0&&(this.u=u),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.u;let u;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=s,!1;this.u=(this.u+1)%this.viewItems.length,u=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===E.$1i.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const s=this.u;let u;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=s,!1;this.u=this.viewItems.length-1}u=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===E.$1i.ID));return this.R(!0),!0}R(e,s,u=!1){typeof this.u>"u"&&this.C.focus({preventScroll:s}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const m=this.u!==void 0?this.viewItems[this.u]:void 0;if(m){let p=!0;$.$9f(m.focus)||(p=!1),this.b.focusOnlyEnabledItems&&$.$9f(m.isEnabled)&&!m.isEnabled()&&(p=!1),m.action.id===E.$1i.ID&&(p=!1),p?(u||this.t!==this.u)&&(m.focus(e),this.t=this.u):(this.C.focus({preventScroll:s}),this.t=void 0),p&&m.showHover?.()}}S(e){if(typeof this.u>"u")return;const s=this.viewItems[this.u];if(s instanceof z.$ST){const u=s._context===null||s._context===void 0?e:s._context;this.run(s._action,u)}}async run(e,s){await this.g.run(e,s)}dispose(){this.m=void 0,this.viewItems=(0,b.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$1S=P;function f(d){if(!d.length)return d;let e=-1;for(let u=0;u<d.length;u++)if(d[u].id!==E.$1i.ID){e=u;break}if(e===-1)return[];d=d.slice(e);for(let u=d.length-1;u>=0&&d[u].id===E.$1i.ID;u--)d.splice(u,1);let s=!1;for(let u=d.length-1;u>=0;u--){const m=d[u].id===E.$1i.ID;m&&!s?d.splice(u,1):m?m&&(s=!1):s=!0}return d}}),define(me[68],be([1,0,2,24,58,67,60,14,33,63,21,4,85,54,113,101]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AU=t.$zU=t.$yU=t.MessageType=void 0;const s=i.$;var u;(function(v){v[v.INFO=1]="INFO",v[v.WARNING=2]="WARNING",v[v.ERROR=3]="ERROR"})(u||(t.MessageType=u={})),t.$yU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class m extends w.$FS{constructor(l,g,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new P.$7d),this.onDidChange=this.P.event,this.Q=this.B(new P.$7d),this.onDidHeightChange=this.Q.event,this.a=g,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$5R(l,s(".monaco-inputbox.idle"));const S=this.g.flexibleHeight?"textarea":"input",C=i.$5R(this.element,s(".ibwrapper"));if(this.b=i.$5R(C,s(S+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$5R(C,s("div.mirror")),this.y.innerText="\xA0",this.N=new $.$PS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$5R(l,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(O=>this.b.scrollTop=O.scrollTop));const I=this.B(new N.$9S(l.ownerDocument,"selectionchange")),M=P.Event.filter(I.event,()=>l.ownerDocument.getSelection()?.anchorNode===C);this.B(M(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new H.$1S(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(l){this.n=l,this.b.setAttribute("placeholder",l)}setTooltip(l){this.r=l,this.O?this.O.update(l):this.O=this.B((0,b.$WS)((0,A.$YS)("mouse"),this.b,l))}setAriaLabel(l){this.s=l,l?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(l){this.b.value!==l&&(this.b.value=l,this.Z())}get step(){return this.b.step}set step(l){this.b.step=l}get height(){return typeof this.J=="number"?this.J:i.$uR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$FR(this.b)}select(l=null){this.b.select(),l&&(this.b.setSelectionRange(l.start,l.end),l.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(l){l?this.enable():this.disable()}get width(){return i.$qR(this.b)}set width(l){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,S=parseFloat(this.y.style.paddingRight||"")||0;g=r+S}this.b.style.width=l-g+"px"}else this.b.style.width=l+"px";this.y&&(this.y.style.width=l+"px")}set paddingRight(l){this.b.style.width=`calc(100% - ${l}px)`,this.y&&(this.y.style.paddingRight=l+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const l=this.L,g=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:l,height:g}),this.N.setScrollPosition({scrollTop:r})}showMessage(l,g){if(this.w==="open"&&(0,d.$Rn)(this.h,l))return;this.h=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(l.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$kS(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||g)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let l=null;return this.t&&(l=this.t(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){const g=this.g.inputBoxStyles;switch(l){case 1:return{border:g.inputValidationInfoBorder,background:g.inputValidationInfoBackground,foreground:g.inputValidationInfoForeground};case 2:return{border:g.inputValidationWarningBorder,background:g.inputValidationWarningBackground,foreground:g.inputValidationWarningForeground};default:return{border:g.inputValidationErrorBorder,background:g.inputValidationErrorBackground,foreground:g.inputValidationErrorForeground}}}W(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let l;const g=()=>l.style.width=i.$qR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.h)return null;l=i.$5R(S,s(".monaco-inputbox-container")),g();const C={inline:!0,className:"monaco-inputbox-message"},I=this.h.formatContent?(0,z.$7S)(this.h.content,C):(0,z.$6S)(this.h.content,C);I.classList.add(this.W(this.h.type));const M=this.stylesForType(this.h.type);return I.style.backgroundColor=M.background??"",I.style.color=M.foreground??"",I.style.border=M.border?`1px solid ${M.border}`:"",i.$5R(l,I),null},onHide:()=>{this.w="closed"},layout:g});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),E.$$S(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const l=this.value,r=l.charCodeAt(l.length-1)===10?" ":"";(l+r).replace(/\u000c/g,"")?this.y.textContent=l+r:this.y.innerText="\xA0",this.layout()}bb(){const l=this.g.inputBoxStyles,g=l.inputBackground??"",r=l.inputForeground??"",S=l.inputBorder??"";this.element.style.backgroundColor=g,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$kS(S,"transparent")}`}layout(){if(!this.y)return;const l=this.L;this.L=i.$uR(this.y),l!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(l){const g=this.inputElement,r=g.selectionStart,S=g.selectionEnd,C=g.value;r!==null&&S!==null&&(this.value=C.substr(0,r)+l+C.substr(S),g.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$zU=m;class p extends m{constructor(l,g,r){const S=e.localize(3,null,"\u21C5"),C=e.localize(4,null,"\u21C5");super(l,g,r),this.eb=this.B(new P.$7d),this.onDidFocus=this.eb.event,this.fb=this.B(new P.$7d),this.onDidBlur=this.fb.event,this.cb=new f.$wU(r.history,100);const I=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(S)&&!this.n.endsWith(C)&&this.cb.getHistory().length){const M=this.n.endsWith(")")?S:C,O=this.n+M;r.showPlaceholderOnFocus&&!i.$FR(this.b)?this.n=O:this.setPlaceHolder(O)}};this.db=new MutationObserver((M,O)=>{M.forEach(y=>{y.target.textContent||I()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>I()),this.F(this.b,()=>{const M=O=>{if(this.n.endsWith(O)){const y=this.n.slice(0,this.n.length-O.length);return r.showPlaceholderOnFocus?this.n=y:this.setPlaceHolder(y),!0}else return!1};M(C)||M(S)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(l){this.value&&(l||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(l){const g=this.getHistory();this.clearHistory(),l.forEach(r=>{this.cb.add(r)}),g.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let l=this.kb();l&&(l=l===this.value?this.kb():l),this.value=l??"",E.$_S(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let l=this.jb();l&&(l=l===this.value?this.jb():l),l&&(this.value=l,E.$_S(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(l){super.setPlaceHolder(l),this.setTooltip(l)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let l=this.cb.current();return l||(l=this.cb.last(),this.cb.next()),l}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$AU=p}),define(me[69],be([1,0,66,21,18,19,4,2,33,14,106]),function(se,t,i,N,z,H,E,A,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=t.$QT=t.$PT=t.$OT=t.$NT=void 0,t.$NT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends i.$ST{constructor(s,u,m){super(s,u,m),this.a=this.B(new P({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:m.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:m.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:m.toggleStyles?.inputActiveOptionForeground,hoverDelegate:m.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$OT=w;class P extends N.$FS{constructor(s){super(),this.a=this.B(new E.$7d),this.onChange=this.a.event,this.b=this.B(new E.$7d),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const u=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,u.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&u.push(...this.c.actionClassName.split(" ")),this.s&&u.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,b.$WS)(s.hoverDelegate??(0,$.$YS)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...u),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,m=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),m.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,m=>{if(m.keyCode===10||m.keyCode===3){this.checked=!this.s,this.a.fire(!0),m.preventDefault(),m.stopPropagation();return}this.b.fire(m)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(s){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.t.update(s),this.domNode.setAttribute("aria-label",s)}}t.$PT=P;class f extends N.$FS{constructor(s,u,m){super(),this.g=s,this.h=u,this.a=this.B(new E.$7d),this.onChange=this.a.event,this.b=new P({title:this.g,isChecked:this.h,icon:z.$Gj.check,actionClassName:"monaco-checkbox",...t.$NT}),this.domNode=this.b.domNode,this.c=m,this.n(),this.B(this.b.onChange(p=>{this.n(),this.a.fire(p)}))}get checked(){return this.b.checked}set checked(s){this.b.checked=s,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$FR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$QT=f;class d extends i.$ST{constructor(s,u,m){super(s,u,m),this.a=this.B(new f(this._action.label,!!this._action.checked,m.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const u=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this.B((0,A.$5Q)(u,A.$XR.CLICK,m=>{this.a.checked=!this.a.checked,m.stopPropagation(),m.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$RT=d}),define(me[133],be([1,0,14,69,18,111]),function(se,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NU=t.$MU=t.$LU=void 0;const E=H.localize(0,null),A=H.localize(1,null),b=H.localize(2,null);class $ extends N.$PT{constructor(d){super({icon:z.$Gj.caseSensitive,title:E+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$YS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$LU=$;class w extends N.$PT{constructor(d){super({icon:z.$Gj.wholeWord,title:A+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$YS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$MU=w;class P extends N.$PT{constructor(d){super({icon:z.$Gj.regex,title:b+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$YS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$NU=P}),define(me[134],be([1,0,2,133,68,21,4,110,3,14,100]),function(se,t,i,N,z,H,E,A,b,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OU=void 0;const w=A.localize(0,null);class P extends H.$FS{static{this.OPTION_CHANGE="optionChange"}constructor(d,e,s){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Vc),this.N=[],this.O=this.B(new E.$7d),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$7d),this.onKeyDown=this.P.event,this.Q=this.B(new E.$7d),this.onMouseDown=this.Q.event,this.R=this.B(new E.$7d),this.onInput=this.R.event,this.S=this.B(new E.$7d),this.onKeyUp=this.S.event,this.U=this.B(new E.$7d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$7d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=s.placeholder||"",this.b=s.validation,this.c=s.label||w,this.h=!!s.showCommonFindToggles;const u=s.appendCaseSensitiveLabel||"",m=s.appendWholeWordsLabel||"",p=s.appendRegexLabel||"",v=s.history||[],l=!!s.flexibleHeight,g=!!s.flexibleWidth,r=s.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new z.$AU(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:v,showHistoryHint:s.showHistoryHint,flexibleHeight:l,flexibleWidth:g,flexibleMaxHeight:r,inputBoxStyles:s.inputBoxStyles}));const S=this.B((0,$.$ZS)());if(this.h){this.J=this.B(new N.$NU({appendTitle:p,isChecked:!1,hoverDelegate:S,...s.toggleStyles})),this.B(this.J.onChange(I=>{this.O.fire(I),!I&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(I=>{this.W.fire(I)})),this.L=this.B(new N.$MU({appendTitle:m,isChecked:!1,hoverDelegate:S,...s.toggleStyles})),this.B(this.L.onChange(I=>{this.O.fire(I),!I&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new N.$LU({appendTitle:u,isChecked:!1,hoverDelegate:S,...s.toggleStyles})),this.B(this.M.onChange(I=>{this.O.fire(I),!I&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(I=>{this.U.fire(I)}));const C=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,I=>{if(I.equals(15)||I.equals(17)||I.equals(9)){const M=C.indexOf(this.domNode.ownerDocument.activeElement);if(M>=0){let O=-1;I.equals(17)?O=(M+1)%C.length:I.equals(15)&&(M===0?O=C.length-1:O=M-1),I.equals(9)?(C[M].blur(),this.inputBox.focus()):O>=0&&C[O].focus(),i.$ZR.stop(I,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(s?.additionalToggles),this.y&&this.domNode.appendChild(this.y),d?.appendChild(this.domNode),this.B(i.$5Q(this.inputBox.inputElement,"compositionstart",C=>{this.s=!0})),this.B(i.$5Q(this.inputBox.inputElement,"compositionend",C=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,C=>this.P.fire(C)),this.C(this.inputBox.inputElement,C=>this.S.fire(C)),this.D(this.inputBox.inputElement,C=>this.R.fire()),this.j(this.inputBox.inputElement,C=>this.Q.fire(C))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(d){this.inputBox.layout(),this.X(d.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const d of this.N)d.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const d of this.N)d.disable()}setFocusInputOnOptionClick(d){this.n=d}setEnabled(d){d?this.enable():this.disable()}setAdditionalToggles(d){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new b.$Tc;for(const e of d??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(s=>{this.O.fire(s),!s&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(d=!1){d?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,s)=>e+s.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(d){this.inputBox.value!==d&&(this.inputBox.value=d)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(d){this.M&&(this.M.checked=d)}getWholeWords(){return this.L?.checked??!1}setWholeWords(d){this.L&&(this.L.checked=d)}getRegex(){return this.J?.checked??!1}setRegex(d){this.J&&(this.J.checked=d,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(d){this.inputBox.showMessage(d)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$OU=P}),define(me[135],be([1,0,2,24,15,67,134,68,64,43,69,61,27,40,12,9,18,19,34,4,37,3,35,7,115,14,107]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e,s,u,m,p,v,l,g,r,S,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$mV=t.$lV=t.$kV=t.RenderIndentGuides=t.$jV=t.$iV=void 0;class M extends b.$gT{set context(n){this.c.context=n}get context(){return this.c.context}constructor(n){super(n.elements.map(h=>h.element)),this.c=n}}function O(a){return a instanceof b.$gT?new M(a):a}class y{constructor(n,h){this.d=n,this.f=h,this.b=g.$Uc.None,this.c=new g.$Tc}getDragURI(n){return this.f.getDragURI(n.element)}getDragLabel(n,h){if(this.f.getDragLabel)return this.f.getDragLabel(n.map(F=>F.element),h)}onDragStart(n,h){this.f.onDragStart?.(O(n),h)}onDragOver(n,h,F,B,j,V=!0){const Z=this.f.onDragOver(O(n),h&&h.element,F,B,j),_=this.a!==h;if(_&&(this.b.dispose(),this.a=h),typeof h>"u")return Z;if(_&&typeof Z!="boolean"&&Z.autoExpand&&(this.b=(0,s.$jh)(()=>{const Se=this.d(),Ae=Se.getNodeLocation(h);Se.isCollapsed(Ae)&&Se.setCollapsed(Ae,!1),this.a=void 0},500,this.c)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!V){const Se=typeof Z=="boolean"?Z:Z.accept,Ae=typeof Z=="boolean"?void 0:Z.effect;return{accept:Se,effect:Ae,feedback:[F]}}return Z}if(Z.bubble===1){const Se=this.d(),Ae=Se.getNodeLocation(h),Ce=Se.getParentNodeLocation(Ae),Re=Se.getNode(Ce),Xe=Ce&&Se.getListIndex(Ce);return this.onDragOver(n,Re,Xe,B,j,!1)}const $e=this.d(),ve=$e.getNodeLocation(h),we=$e.getListIndex(ve),Me=$e.getListRenderCount(ve);return{...Z,feedback:(0,e.$Sb)(we,we+Me)}}drop(n,h,F,B,j){this.b.dispose(),this.a=void 0,this.f.drop(O(n),h&&h.element,F,B,j)}onDragEnd(n){this.f.onDragEnd?.(n)}dispose(){this.c.dispose(),this.f.dispose()}}function x(a,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(h){return n.identityProvider.getId(h.element)}},dnd:n.dnd&&new y(a,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(h){return n.multipleSelectionController.isSelectionSingleChangeEvent({...h,element:h.element})},isSelectionRangeChangeEvent(h){return n.multipleSelectionController.isSelectionRangeChangeEvent({...h,element:h.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(h){const F=a(),B=F.getNodeLocation(h),j=F.getParentNodeLocation(B);return F.getNode(j).visibleChildrenCount},getPosInSet(h){return h.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?h=>n.accessibilityProvider.isChecked(h.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?h=>n.accessibilityProvider.getRole(h.element):()=>"treeitem",getAriaLabel(h){return n.accessibilityProvider.getAriaLabel(h.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?h=>n.accessibilityProvider.getAriaLevel(h.element):h=>h.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(h=>n.accessibilityProvider.getActiveDescendantId(h.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(h){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(h.element)}}}}class W{constructor(n){this.a=n}getHeight(n){return this.a.getHeight(n.element)}getTemplateId(n){return this.a.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(n.element)}setDynamicHeight(n,h){this.a.setDynamicHeight?.(n.element,h)}}t.$iV=W;class T{static lift(n){return n instanceof T?n:new T(n)}static empty(n=0){return new T({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const h of n.expanded)this.expanded[h]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$jV=T;var R;(function(a){a.None="none",a.OnHover="onHover",a.Always="always"})(R||(t.RenderIndentGuides=R={}));class L{get elements(){return this.b}constructor(n,h=[]){this.b=h,this.a=new g.$Tc,this.onDidChange=v.Event.forEach(n,F=>this.b=F,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(n,h,F,B,j,V={}){this.o=n,this.p=h,this.q=B,this.s=j,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=g.$Uc.None,this.m=new g.$Tc,this.templateId=n.templateId,this.updateOptions(V),v.Event.map(F,Z=>Z.node)(this.u,this,this.m),n.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(n={}){if(typeof n.indent<"u"){const h=(0,r.$mm)(n.indent,0,40);if(h!==this.d){this.d=h;for(const[F,B]of this.c)this.v(F,B)}}if(typeof n.renderIndentGuides<"u"){const h=n.renderIndentGuides!==R.None;if(h!==this.g){this.g=h;for(const[F,B]of this.c)this.w(F,B);if(this.k.dispose(),h){const F=new g.$Tc;this.q.onDidChange(this.x,this,F),this.k=F,this.x(this.q.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.f=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const h=(0,i.$5R)(n,(0,i.$)(".monaco-tl-row")),F=(0,i.$5R)(h,(0,i.$)(".monaco-tl-indent")),B=(0,i.$5R)(h,(0,i.$)(".monaco-tl-twistie")),j=(0,i.$5R)(h,(0,i.$)(".monaco-tl-contents")),V=this.o.renderTemplate(j);return{container:n,indent:F,twistie:B,indentGuidesDisposable:g.$Uc.None,templateData:V}}renderElement(n,h,F,B){this.c.set(n,F),this.b.set(n.element,n),this.v(n,F),this.o.renderElement(n,h,F.templateData,B)}disposeElement(n,h,F,B){F.indentGuidesDisposable.dispose(),this.o.disposeElement?.(n,h,F.templateData,B),typeof B=="number"&&(this.c.delete(n),this.b.delete(n.element))}disposeTemplate(n){this.o.disposeTemplate(n.templateData)}t(n){const h=this.b.get(n);h&&this.u(h)}u(n){const h=this.c.get(n);h&&(this.x(this.q.elements),this.v(n,h))}v(n,h){const F=X.a+(n.depth-1)*this.d;h.twistie.style.paddingLeft=`${F}px`,h.indent.style.width=`${F+this.d-16}px`,n.collapsible?h.container.setAttribute("aria-expanded",String(!n.collapsed)):h.container.removeAttribute("aria-expanded"),h.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(u.$Gj.treeItemExpanded));let B=!1;this.o.renderTwistie&&(B=this.o.renderTwistie(n.element,h.twistie)),n.collapsible&&(!this.f||n.visibleChildrenCount>0)?(B||h.twistie.classList.add(...m.ThemeIcon.asClassNameArray(u.$Gj.treeItemExpanded)),h.twistie.classList.add("collapsible"),h.twistie.classList.toggle("collapsed",n.collapsed)):h.twistie.classList.remove("collapsible","collapsed"),this.w(n,h)}w(n,h){if((0,i.$4Q)(h.indent),h.indentGuidesDisposable.dispose(),!this.g)return;const F=new g.$Tc,B=this.p();for(;;){const j=B.getNodeLocation(n),V=B.getParentNodeLocation(j);if(!V)break;const Z=B.getNode(V),_=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&_.classList.add("active"),h.indent.childElementCount===0?h.indent.appendChild(_):h.indent.insertBefore(_,h.indent.firstElementChild),this.s.add(Z,_),F.add((0,g.$Sc)(()=>this.s.delete(Z,_))),n=Z}h.indentGuidesDisposable=F}x(n){if(!this.g)return;const h=new Set,F=this.p();n.forEach(B=>{const j=F.getNodeLocation(B);try{const V=F.getParentNodeLocation(j);B.collapsible&&B.children.length>0&&!B.collapsed?h.add(B):V&&h.add(F.getNode(V))}catch{}}),this.j.forEach(B=>{h.has(B)||this.s.forEach(B,j=>j.classList.remove("active"))}),h.forEach(B=>{this.j.has(B)||this.s.forEach(B,j=>j.classList.add("active"))}),this.j=h}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,g.$Pc)(this.m)}}t.$kV=X;class J{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(n){this.c=n,this.d=n.toLowerCase()}constructor(n,h,F){this.g=n,this.j=h,this.k=F,this.a=0,this.b=0,this.c="",this.d="",this.f=new g.$Tc,n.onWillRefilter(this.m,this,this.f)}filter(n,h){let F=1;if(this.k){const V=this.k.filter(n,h);if(typeof V=="boolean"?F=V?1:0:(0,P.$fV)(V)?F=(0,P.$gV)(V.visibility):F=V,F===0)return!1}if(this.a++,!this.c)return this.b++,{data:l.FuzzyScore.Default,visibility:F};const B=this.j.getKeyboardNavigationLabel(n),j=Array.isArray(B)?B:[B];for(const V of j){const Z=V&&V.toString();if(typeof Z>"u")return{data:l.FuzzyScore.Default,visibility:F};let _;if(this.g.findMatchType===Fe.Contiguous){const $e=Z.toLowerCase().indexOf(this.d);if($e>-1){_=[Number.MAX_SAFE_INTEGER,0];for(let ve=this.d.length;ve>0;ve--)_.push($e+ve-1)}}else _=(0,l.$vk)(this.c,this.d,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_)return this.b++,j.length===1?{data:_,visibility:F}:{data:{label:Z,score:_},visibility:F}}return this.g.findMode===ge.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(n):2:{data:l.FuzzyScore.Default,visibility:F}}m(){this.a=0,this.b=0}dispose(){(0,g.$Pc)(this.f)}}class de extends w.$PT{constructor(n){super({icon:u.$Gj.listFilter,title:(0,C.localize)(0,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,I.$YS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$lV=de;class ae extends w.$PT{constructor(n){super({icon:u.$Gj.searchFuzzy,title:(0,C.localize)(1,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,I.$YS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}t.$mV=ae;const ie={inputBoxStyles:A.$yU,toggleStyles:w.$NT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ge;(function(a){a[a.Highlight=0]="Highlight",a[a.Filter=1]="Filter"})(ge||(t.TreeFindMode=ge={}));var Fe;(function(a){a[a.Fuzzy=0]="Fuzzy",a[a.Contiguous=1]="Contiguous"})(Fe||(t.TreeFindMatchType=Fe={}));class Ne extends g.$Uc{set mode(n){this.b.checked=n===ge.Filter,this.f.inputBox.setPlaceHolder(n===ge.Filter?(0,C.localize)(2,null):(0,C.localize)(3,null))}set matchType(n){this.c.checked=n===Fe.Fuzzy}get value(){return this.f.inputBox.value}set value(n){this.f.inputBox.value=n}constructor(n,h,F,B,j,V){super(),this.t=h,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new v.$7d,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.a.root),this.B((0,g.$Sc)(()=>n.removeChild(this.a.root)));const Z=V?.styles??ie;Z.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const _=this.B((0,I.$ZS)());this.b=this.B(new de({...Z.toggleStyles,isChecked:B===ge.Filter,hoverDelegate:_})),this.c=this.B(new ae({...Z.toggleStyles,isChecked:j===Fe.Fuzzy,hoverDelegate:_})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?ge.Filter:ge.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?Fe.Fuzzy:Fe.Contiguous,this.q),this.f=this.B(new E.$OU(this.a.findInput,F,{label:(0,C.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:V?.history})),this.g=this.B(new H.$1S(this.a.actionbar)),this.mode=B;const $e=this.B(new N.$9S(this.f.inputBox.inputElement,"keydown")),ve=v.Event.chain($e.event,Ae=>Ae.map(Ce=>new z.$2Q(Ce)));this.B(ve(Ae=>{if(Ae.equals(3)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ae.equals(18)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ae.equals(16)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const we=this.B(new d.$Yi("close",(0,C.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(we,{icon:!0,label:!1});const Me=this.B(new N.$9S(this.a.grab,"mousedown"));this.B(Me.event(Ae=>{const Ce=new g.$Tc,Re=Ce.add(new N.$9S((0,i.getWindow)(Ae),"mousemove")),Xe=Ce.add(new N.$9S((0,i.getWindow)(Ae),"mouseup")),nt=this.m,Ge=Ae.pageX,Ue=this.s,G=Ae.pageY;this.a.grab.classList.add("grabbing");const ne=this.a.root.style.transition;this.a.root.style.transition="unset";const pe=De=>{const Le=De.pageX-Ge;this.m=nt-Le;const ze=De.pageY-G;this.s=Ue+ze,this.layout()};Ce.add(Re.event(pe)),Ce.add(Xe.event(De=>{pe(De),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=ne,Ce.dispose()}))}));const Se=v.Event.chain(this.B(new N.$9S(this.a.grab,"keydown")).event,Ae=>Ae.map(Ce=>new z.$2Q(Ce)));this.B(Se(Ae=>{let Ce,Re;if(Ae.keyCode===15?Ce=Number.POSITIVE_INFINITY:Ae.keyCode===17?Ce=0:Ae.keyCode===10&&(Ce=this.m===0?Number.POSITIVE_INFINITY:0),Ae.keyCode===16?Re=0:Ae.keyCode===18&&(Re=Number.POSITIVE_INFINITY),Ce!==void 0&&(Ae.preventDefault(),Ae.stopPropagation(),this.m=Ce,this.layout()),Re!==void 0){Ae.preventDefault(),Ae.stopPropagation(),this.s=Re;const Xe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(n=this.j){this.j=n,this.m=(0,r.$mm)(this.m,0,Math.max(0,n-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$mm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(n){this.f.showMessage(n)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$ih)(300),super.dispose()}}class Pe{get pattern(){return this.b}get mode(){return this.d}set mode(n){n!==this.d&&(this.d=n,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(n))}get matchType(){return this.f}set matchType(n){n!==this.f&&(this.f=n,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(n))}constructor(n,h,F,B,j,V={}){this.t=n,this.u=F,this.v=B,this.w=j,this.x=V,this.b="",this.c="",this.j=0,this.k=new v.$7d,this.onDidChangeMode=this.k.event,this.m=new v.$7d,this.onDidChangeMatchType=this.m.event,this.o=new v.$7d,this.onDidChangePattern=this.o.event,this.p=new v.$7d,this.onDidChangeOpenState=this.p.event,this.q=new g.$Tc,this.s=new g.$Tc,this.d=n.options.defaultFindMode??ge.Highlight,this.f=n.options.defaultFindMatchType??Fe.Fuzzy,h.onDidSplice(this.z,this,this.s)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ne(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(n=>this.mode=n,void 0,this.q),this.g.onDidChangeMatchType(n=>this.matchType=n,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(n){this.b=n,this.o.fire(n),this.v.pattern=n,this.t.refilter(),n&&this.t.focusNext(0,!0,void 0,F=>!l.FuzzyScore.isDefault(F.filterData));const h=this.t.getFocus();if(h.length>0){const F=h[0];this.t.getRelativeTop(F)===null&&this.t.reveal(F,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const n=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&n?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,C.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(n){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!l.FuzzyScore.isDefault(n.filterData)}layout(n){this.j=n,this.g?.layout(n)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function oe(a,n){return a.position===n.position&&U(a,n)}function U(a,n){return a.node.element===n.node.element&&a.startIndex===n.startIndex&&a.height===n.height&&a.endIndex===n.endIndex}class le{constructor(n=[]){this.stickyNodes=n}get count(){return this.stickyNodes.length}equal(n){return(0,e.$ub)(this.stickyNodes,n.stickyNodes,oe)}lastNodePartiallyVisible(){if(this.count===0)return!1;const n=this.stickyNodes[this.count-1];if(this.count===1)return n.position!==0;const h=this.stickyNodes[this.count-2];return h.position+h.height!==n.position}animationStateChanged(n){if(!(0,e.$ub)(this.stickyNodes,n.stickyNodes,U)||this.count===0)return!1;const h=this.stickyNodes[this.count-1],F=n.stickyNodes[n.count-1];return h.position!==F.position}}class re{constrainStickyScrollNodes(n,h,F){for(let B=0;B<n.length;B++){const j=n[B];if(j.position+j.height>F||B>=h)return n.slice(0,B)}return n}}class Y extends g.$Uc{constructor(n,h,F,B,j,V={}){super(),this.g=n,this.j=h,this.m=F,this.s=j,this.c=.4;const Z=this.validateStickySettings(V);this.b=Z.stickyScrollMaxItemCount,this.a=V.stickyScrollDelegate??new re,this.f=this.B(new Q(F.getScrollableElement(),F,n,B,j,V.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(F.onDidScroll(()=>this.u())),this.B(F.onDidChangeContentHeight(()=>this.u())),this.B(n.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(n){return this.f.getNode(n)}t(n){let h;if(n===0?h=this.m.firstVisibleIndex:h=this.m.indexAt(n+this.m.scrollTop),!(h<0||h>=this.m.length))return this.m.element(h)}u(){const n=this.t(0);if(!n||this.g.scrollTop===0){this.f.setState(void 0);return}const h=this.w(n);this.f.setState(h)}w(n){const h=[];let F=n,B=0,j=this.z(F,void 0,B);for(;j&&(h.push(j),B+=j.height,!(h.length<=this.b&&(F=this.y(j),!F)));)j=this.z(F,j.node,B);const V=this.H(h);return V.length?new le(V):void 0}y(n){return this.t(n.position+n.height)}z(n,h,F){const B=this.F(n,h);if(B&&!(B===n&&(!this.J(n)||this.C(n,F))))return this.D(B,F)}C(n,h){const F=this.L(n),B=this.m.getElementTop(F),j=h;return this.m.scrollTop===B-j}D(n,h){const F=this.s.getHeight(n),{startIndex:B,endIndex:j}=this.M(n),V=this.G(j,h,F);return{node:n,position:V,height:F,startIndex:B,endIndex:j}}F(n,h=void 0){let F=n,B=this.I(F);for(;B;){if(B===h)return F;F=B,B=this.I(F)}if(h===void 0)return F}G(n,h,F){let B=this.m.getRelativeTop(n);if(B===null&&this.m.firstVisibleIndex===n&&n+1<this.m.length){const $e=this.s.getHeight(this.m.element(n)),ve=this.m.getRelativeTop(n+1);B=ve?ve-$e/this.m.renderHeight:null}if(B===null)return h;const j=this.m.element(n),V=this.s.getHeight(j),_=B*this.m.renderHeight+V;return h+F>_&&h<=_?_-F:h}H(n){if(n.length===0)return[];const h=this.m.renderHeight*this.c,F=n[n.length-1];if(n.length<=this.b&&F.position+F.height<=h)return n;const B=this.a.constrainStickyScrollNodes(n,this.b,h);if(!B.length)return[];const j=B[B.length-1];if(B.length>this.b||j.position+j.height>h)throw new Error("stickyScrollDelegate violates constraints");return B}I(n){const h=this.j.getNodeLocation(n),F=this.j.getParentNodeLocation(h);return F?this.j.getNode(F):void 0}J(n){const h=this.j.getNodeLocation(n);return this.j.getListRenderCount(h)>1}L(n){const h=this.j.getNodeLocation(n);return this.j.getListIndex(h)}M(n){const h=this.j.getNodeLocation(n),F=this.j.getListIndex(h);if(F<0)throw new Error("Node not found in tree");const B=this.j.getListRenderCount(h),j=F+B-1;return{startIndex:F,endIndex:j}}nodePositionTopBelowWidget(n){const h=[];let F=this.I(n);for(;F;)h.push(F),F=this.I(F);let B=0;for(let j=0;j<h.length&&j<this.b;j++)B+=this.s.getHeight(h[j]);return B}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(n={}){if(!n.stickyScrollMaxItemCount)return;const h=this.validateStickySettings(n);this.b!==h.stickyScrollMaxItemCount&&(this.b=h.stickyScrollMaxItemCount,this.u())}validateStickySettings(n){let h=7;return typeof n.stickyScrollMaxItemCount=="number"&&(h=Math.max(n.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:h}}}class Q{constructor(n,h,F,B,j,V){this.g=h,this.j=F,this.k=B,this.m=j,this.o=V,this.c=[],this.d=new g.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),n.appendChild(this.a);const Z=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(Z),this.f=new te(this.a,h),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const n=this.b.stickyNodes[this.b.count-1];return n.position+n.height}get count(){return this.b?.count??0}getNode(n){return this.b?.stickyNodes.find(h=>h.node===n)}setState(n){const h=!!this.b&&this.b.count>0,F=!!n&&n.count>0;if(!h&&!F||h&&F&&this.b.equal(n))return;if(h!==F&&this.s(F),!F){this.b=void 0,this.c=[],this.d.clear();return}const B=n.stickyNodes[n.count-1];if(this.b&&n.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${B.position}px`;else{this.d.clear();const j=Array(n.count);for(let V=n.count-1;V>=0;V--){const Z=n.stickyNodes[V],{element:_,disposable:$e}=this.p(Z,V,n.count);j[V]=_,this.a.appendChild(_),this.d.add($e)}this.f.updateElements(j,n),this.c=j}this.b=n,this.a.style.height=`${B.position+B.height}px`}p(n,h,F){const B=n.startIndex,j=document.createElement("div");j.style.top=`${n.position}px`,j.style.height=`${n.height}px`,j.style.lineHeight=`${n.height}px`,j.classList.add("monaco-tree-sticky-row"),j.classList.add("monaco-list-row"),j.setAttribute("data-index",`${B}`),j.setAttribute("data-parity",B%2===0?"even":"odd"),j.setAttribute("id",this.g.getElementID(B)),this.q(j,n.node.element,h,F);const V=this.m.getTemplateId(n.node),Z=this.k.find(we=>we.templateId===V);if(!Z)throw new Error(`No renderer found for template id ${V}`);let _=n.node;_===this.j.getNode(this.j.getNodeLocation(n.node))&&(_=new Proxy(n.node,{}));const $e=Z.renderTemplate(j);Z.renderElement(_,n.startIndex,$e,n.height);const ve=(0,g.$Sc)(()=>{Z.disposeElement(_,n.startIndex,$e,n.height),Z.disposeTemplate($e),j.remove()});return{element:j,disposable:ve}}q(n,h,F,B){if(!this.o)return;this.o.getSetSize&&n.setAttribute("aria-setsize",String(this.o.getSetSize(h,F,B))),this.o.getPosInSet&&n.setAttribute("aria-posinset",String(this.o.getPosInSet(h,F))),this.o.getRole&&n.setAttribute("role",this.o.getRole(h)??"treeitem");const j=this.o.getAriaLabel(h);j&&n.setAttribute("aria-label",j);const V=this.o.getAriaLevel&&this.o.getAriaLevel(h);typeof V=="number"&&n.setAttribute("aria-level",`${V}`),n.setAttribute("aria-selected",String(!1))}s(n){this.a.classList.toggle("empty",!n),n||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class te extends g.$Uc{get m(){return this.j}set m(n){n!==this.j&&(this.f.fire(n),this.j=n)}constructor(n,h){super(),this.s=n,this.t=h,this.a=-1,this.b=[],this.f=new v.$7d,this.onDidChangeHasFocus=this.f.event,this.g=new v.$7d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(F=>this.w(F))),this.B(this.t.onMouseDown(F=>this.y(F))),this.B(this.t.onContextMenu(F=>this.u(F)))}u(n){const h=n.browserEvent.target;if(!(0,$.$tT)(h)&&!(0,$.$sT)(h)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$UR)(n.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const V=this.c.stickyNodes.findIndex(Z=>Z.node.element===n.element?.element);if(V===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(V);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const B=this.c.stickyNodes[this.a].node.element,j=this.b[this.a];this.g.fire({element:B,anchor:j,browserEvent:n.browserEvent,isStickyScroll:!0})}w(n){if(this.m&&this.c){if(n.key==="ArrowUp")this.z(Math.max(0,this.a-1)),n.preventDefault(),n.stopPropagation();else if(n.key==="ArrowDown"||n.key==="ArrowRight"){if(this.a>=this.c.count-1){const h=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([h]),this.C(h,this.c)}else this.z(this.a+1);n.preventDefault(),n.stopPropagation()}}}y(n){const h=n.browserEvent.target;!(0,$.$tT)(h)&&!(0,$.$sT)(h)||(n.browserEvent.preventDefault(),n.browserEvent.stopPropagation())}updateElements(n,h){if(h&&h.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(h&&h.count!==n.length)throw new Error("Sticky scroll focus received illigel state");const F=this.a;if(this.D(),this.b=n,this.c=h,h){const B=(0,r.$mm)(F,0,h.count-1);this.F(B)}else this.m&&this.t.domFocus();this.s.tabIndex=h?0:-1}z(n){const h=this.c;if(!h)throw new Error("Cannot set focus when state is undefined");if(this.F(n),!(n<h.count-1)&&h.lastNodePartiallyVisible()){const F=h.stickyNodes[n];this.C(F.endIndex+1,h)}}C(n,h){const F=h.stickyNodes[h.count-1],B=h.count>1?h.stickyNodes[h.count-2]:void 0,j=this.t.getElementTop(n),V=B?B.position+B.height+F.height:F.height;this.t.scrollTop=j-V}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(n){if(0>n)throw new Error("addFocus() can not remove focus");if(!this.c&&n>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&n>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const h=this.a;h>=0&&this.G(this.b[h],!1),n>=0&&this.G(this.b[n],!0),this.a=n}G(n,h){n.classList.toggle("focused",h)}H(n){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",n)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ue(a){let n=f.TreeMouseEventTarget.Unknown;return(0,i.$AR)(a.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=f.TreeMouseEventTarget.Twistie:(0,i.$AR)(a.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=f.TreeMouseEventTarget.Element:(0,i.$AR)(a.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=f.TreeMouseEventTarget.Filter),{browserEvent:a.browserEvent,element:a.element?a.element.element:null,target:n}}function ye(a){const n=(0,$.$tT)(a.browserEvent.target);return{element:a.element?a.element.element:null,browserEvent:a.browserEvent,anchor:a.anchor,isStickyScroll:n}}function Te(a,n){n(a),a.children.forEach(h=>Te(h,n))}class Ee{get f(){return this.d||(this.d=this.m()),this.d}constructor(n,h){this.g=n,this.j=h,this.a=[],this.c=new v.$7d,this.onDidChange=this.c.event}set(n,h){!h?.__forceEvent&&(0,e.$ub)(this.a,n)||this.k(n,!1,h)}k(n,h,F){if(this.a=[...n],this.b=void 0,this.d=void 0,!h){const B=this;this.c.fire({get elements(){return B.get()},browserEvent:F})}}get(){return this.b||(this.b=this.a.map(n=>n.element)),[...this.b]}getNodes(){return this.a}has(n){return this.f.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:h}){if(!this.j){const _=this.m(),$e=ve=>_.delete(ve);h.forEach(ve=>Te(ve,$e)),this.set([..._.values()]);return}const F=new Set,B=_=>F.add(this.j.getId(_.element).toString());h.forEach(_=>Te(_,B));const j=new Map,V=_=>j.set(this.j.getId(_.element).toString(),_);n.forEach(_=>Te(_,V));const Z=[];for(const _ of this.a){const $e=this.j.getId(_.element).toString();if(!F.has($e))Z.push(_);else{const we=j.get($e);we&&we.visible&&Z.push(we)}}if(this.a.length>0&&Z.length===0){const _=this.g();_&&Z.push(_)}this.k(Z,!0)}m(){const n=new Set;for(const h of this.a)n.add(h);return n}}class fe extends $.$yT{constructor(n,h,F){super(n),this.x=h,this.y=F}u(n){if((0,$.$uT)(n.browserEvent.target)||(0,$.$nT)(n.browserEvent.target)||(0,$.$oT)(n.browserEvent.target)||n.browserEvent.isHandledByList)return;const h=n.element;if(!h)return super.u(n);if(this.p(n)||this.o(n))return super.u(n);const F=n.browserEvent.target,B=F.classList.contains("monaco-tl-twistie")||F.classList.contains("monaco-icon-label")&&F.classList.contains("folder-icon")&&n.browserEvent.offsetX<16,j=(0,$.$sT)(n.browserEvent.target);let V=!1;if(j?V=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?V=this.x.expandOnlyOnTwistieClick(h.element):V=!!this.x.expandOnlyOnTwistieClick,j)this.A(n,h);else{if(V&&!B&&n.browserEvent.detail!==2)return super.u(n);if(!this.x.expandOnDoubleClick&&n.browserEvent.detail===2)return super.u(n)}if(h.collapsible&&(!j||B)){const Z=this.x.getNodeLocation(h),_=n.browserEvent.altKey;if(this.x.setFocus([Z]),this.x.toggleCollapsed(Z,_),V&&B){n.browserEvent.isHandledByList=!0;return}}j||super.u(n)}A(n,h){if((0,$.$pT)(n.browserEvent.target)||(0,$.$qT)(n.browserEvent.target))return;const F=this.y();if(!F)throw new Error("Sticky scroll controller not found");const B=this.k.indexOf(h),j=this.k.getElementTop(B),V=F.nodePositionTopBelowWidget(h);this.x.scrollTop=j-V,this.k.domFocus(),this.k.setFocus([B]),this.k.setSelection([B])}v(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||n.browserEvent.isHandledByList||super.v(n)}s(n){const h=n.browserEvent.target;if(!(0,$.$tT)(h)&&!(0,$.$sT)(h)){super.s(n);return}}t(n){const h=n.browserEvent.target;if(!(0,$.$tT)(h)&&!(0,$.$sT)(h)){super.t(n);return}}}class c extends $.$BT{constructor(n,h,F,B,j,V,Z,_){super(n,h,F,B,_),this.p=j,this.s=V,this.K=Z}D(n){return new fe(this,n.tree,n.stickyScrollProvider)}splice(n,h,F=[]){if(super.splice(n,h,F),F.length===0)return;const B=[],j=[];let V;F.forEach((Z,_)=>{this.p.has(Z)&&B.push(n+_),this.s.has(Z)&&j.push(n+_),this.K.has(Z)&&(V=n+_)}),B.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...B])),j.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...j])),typeof V=="number"&&super.setAnchor(V)}setFocus(n,h,F=!1){super.setFocus(n,h),F||this.p.set(n.map(B=>this.element(B)),h)}setSelection(n,h,F=!1){super.setSelection(n,h),F||this.s.set(n.map(B=>this.element(B)),h)}setAnchor(n,h=!1){super.setAnchor(n),h||(typeof n>"u"?this.K.set([]):this.K.set([this.element(n)]))}}var k;(function(a){a[a.Tree=0]="Tree",a[a.StickyScroll=1]="StickyScroll"})(k||(t.AbstractTreePart=k={}));class D{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,ue)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,ue),n=>n.target!==f.TreeMouseEventTarget.Filter)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.j.onContextMenu,ye),n=>!n.isStickyScroll),this.B?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.j.onTap,ue)}get onPointer(){return v.Event.map(this.j.onPointer,ue)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ge.Highlight}set findMode(n){this.z&&(this.z.mode=n)}get findMatchType(){return this.z?.matchType??Fe.Fuzzy}set findMatchType(n){this.z&&(this.z.matchType=n)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(n,h,F,B,j={}){this.G=n,this.H=j,this.y=new v.$ce,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.D=new g.$Tc,this.E=new v.$7d,this.onWillRefilter=this.E.event,this.F=new v.$7d,this.onDidUpdateOptions=this.F.event,this.p=new W(F);const V=new v.$de,Z=new v.$de,_=this.D.add(new L(Z.event)),$e=new p.$Hc;this.k=B.map(Ae=>new X(Ae,()=>this.o,V.event,_,$e,j));for(const Ae of this.k)this.D.add(Ae);let ve;j.keyboardNavigationLabelProvider&&(ve=new J(this,j.keyboardNavigationLabelProvider,j.filter),j={...j,filter:ve},this.D.add(ve)),this.q=new Ee(()=>this.j.getFocusedElements()[0],j.identityProvider),this.w=new Ee(()=>this.j.getSelectedElements()[0],j.identityProvider),this.x=new Ee(()=>this.j.getAnchorElement(),j.identityProvider),this.j=new c(n,h,this.p,this.k,this.q,this.w,this.x,{...x(()=>this.o,j),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(n,this.j,j),V.input=this.o.onDidChangeCollapseState;const we=v.Event.forEach(this.o.onDidSplice,Ae=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ae),this.w.onDidModelSplice(Ae)})},this.D);we(()=>null,null,this.D);const Me=this.D.add(new v.$7d),Se=this.D.add(new s.$eh(0));if(this.D.add(v.Event.any(we,this.q.onDidChange,this.w.onDidChange)(()=>{Se.trigger(()=>{const Ae=new Set;for(const Ce of this.q.getNodes())Ae.add(Ce);for(const Ce of this.w.getNodes())Ae.add(Ce);Me.fire([...Ae.values()])})})),Z.input=Me.event,j.keyboardSupport!==!1){const Ae=v.Event.chain(this.j.onKeyDown,Ce=>Ce.filter(Re=>!(0,$.$nT)(Re.target)).map(Re=>new z.$2Q(Re)));v.Event.chain(Ae,Ce=>Ce.filter(Re=>Re.keyCode===15))(this.J,this,this.D),v.Event.chain(Ae,Ce=>Ce.filter(Re=>Re.keyCode===17))(this.K,this,this.D),v.Event.chain(Ae,Ce=>Ce.filter(Re=>Re.keyCode===10))(this.L,this,this.D)}if((j.findWidgetEnabled??!0)&&j.keyboardNavigationLabelProvider&&j.contextViewProvider){const Ae=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Pe(this,this.o,this.j,ve,j.contextViewProvider,Ae),this.A=Ce=>this.z.shouldAllowFocus(Ce),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;j.enableStickyScroll&&(this.B=new Y(this,this.o,this.j,this.k,this.p,j),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$MR)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===R.Always)}updateOptions(n={}){this.H={...this.H,...n};for(const h of this.k)h.updateOptions(n);this.j.updateOptions(this.H),this.z?.updateOptions(n),this.I(n),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===R.Always)}get options(){return this.H}I(n){!this.B&&this.H.enableStickyScroll?(this.B=new Y(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(n)}updateWidth(n){const h=this.o.getListIndex(n);h!==-1&&this.j.updateWidth(h)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(n){this.j.scrollTop=n}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(n){this.j.scrollLeft=n}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let n=this.j.firstVisibleIndex;return this.B&&(n+=this.B.count),n<0||n>=this.j.length?void 0:this.j.element(n).element}get lastVisibleElement(){const n=this.j.lastVisibleIndex;return this.j.element(n).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(n){this.j.ariaLabel=n}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$FR)(this.getHTMLElement())}layout(n,h){this.j.layout(n,h),(0,S.$Yf)(h)&&this.z?.layout(h)}style(n){const h=`.${this.j.domId}`,F=[];n.treeIndentGuidesStroke&&(F.push(`.monaco-list${h}:hover .monaco-tl-indent > .indent-guide, .monaco-list${h}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeInactiveIndentGuidesStroke}; }`),F.push(`.monaco-list${h} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`)),n.listBackground&&(F.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${n.listBackground}; }`),F.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${n.listBackground}; }`)),n.listFocusForeground&&(F.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),F.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const B=(0,i.$kS)(n.listFocusAndSelectionOutline,(0,i.$kS)(n.listSelectionOutline,n.listFocusOutline??""));B&&(F.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${B}; outline-offset: -1px;}`),F.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),n.listFocusOutline&&(F.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),F.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=F.join(`
`),this.j.style(n)}getParentElement(n){const h=this.o.getParentNodeLocation(n);return this.o.getNode(h).element}getFirstElementChild(n){return this.o.getFirstElementChild(n)}getNode(n){return this.o.getNode(n)}getNodeLocation(n){return this.o.getNodeLocation(n)}collapse(n,h=!1){return this.o.setCollapsed(n,!0,h)}expand(n,h=!1){return this.o.setCollapsed(n,!1,h)}toggleCollapsed(n,h=!1){return this.o.setCollapsed(n,void 0,h)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(n){return this.o.isCollapsible(n)}setCollapsible(n,h){return this.o.setCollapsible(n,h)}isCollapsed(n){return this.o.isCollapsed(n)}expandTo(n){this.o.expandTo(n)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(n){if(typeof n>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const h=this.o.getNode(n);this.x.set([h]);const F=this.o.getListIndex(n);F>-1&&this.j.setAnchor(F,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(n,h){this.y.bufferEvents(()=>{const F=n.map(j=>this.o.getNode(j));this.w.set(F,h);const B=n.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setSelection(B,h,!0)})}getSelection(){return this.w.get()}setFocus(n,h){this.y.bufferEvents(()=>{const F=n.map(j=>this.o.getNode(j));this.q.set(F,h);const B=n.map(j=>this.o.getListIndex(j)).filter(j=>j>-1);this.j.setFocus(B,h,!0)})}focusNext(n=1,h=!1,F,B=(0,i.$UR)(F)&&F.altKey?void 0:this.A){this.j.focusNext(n,h,F,B)}focusPrevious(n=1,h=!1,F,B=(0,i.$UR)(F)&&F.altKey?void 0:this.A){this.j.focusPrevious(n,h,F,B)}focusNextPage(n,h=(0,i.$UR)(n)&&n.altKey?void 0:this.A){return this.j.focusNextPage(n,h)}focusPreviousPage(n,h=(0,i.$UR)(n)&&n.altKey?void 0:this.A){return this.j.focusPreviousPage(n,h,()=>this.B?.height??0)}focusLast(n,h=(0,i.$UR)(n)&&n.altKey?void 0:this.A){this.j.focusLast(n,h)}focusFirst(n,h=(0,i.$UR)(n)&&n.altKey?void 0:this.A){this.j.focusFirst(n,h)}getFocus(){return this.q.get()}getStickyScrollFocus(){const n=this.B?.getFocus();return n!==void 0?[n]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(n,h){this.o.expandTo(n);const F=this.o.getListIndex(n);if(F!==-1)if(!this.B)this.j.reveal(F,h);else{const B=this.B.nodePositionTopBelowWidget(this.getNode(n));this.j.reveal(F,h,B)}}getRelativeTop(n){const h=this.o.getListIndex(n);if(h===-1)return null;const F=this.B?.getNode(this.getNode(n));return this.j.getRelativeTop(h,F?.position??this.B?.height)}getViewState(n=this.options.identityProvider){if(!n)throw new f.$dV(this.G,"Can't get tree view state without an identity provider");const h=V=>n.getId(V).toString(),F=T.empty(this.scrollTop);for(const V of this.getFocus())F.focus.add(h(V));for(const V of this.getSelection())F.selection.add(h(V));const B=this.o.getNode(),j=[B];for(;j.length>0;){const V=j.shift();V!==B&&V.collapsible&&(F.expanded[h(V.element)]=V.collapsed?0:1),j.push(...V.children)}return F}J(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const F=h[0],B=this.o.getNodeLocation(F);if(!this.o.setCollapsed(B,!0)){const V=this.o.getParentNodeLocation(B);if(!V)return;const Z=this.o.getListIndex(V);this.j.reveal(Z),this.j.setFocus([Z])}}K(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const F=h[0],B=this.o.getNodeLocation(F);if(!this.o.setCollapsed(B,!1)){if(!F.children.some(_=>_.visible))return;const[V]=this.j.getFocus(),Z=V+1;this.j.reveal(Z),this.j.setFocus([Z])}}L(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const F=h[0],B=this.o.getNodeLocation(F),j=n.browserEvent.altKey;this.o.setCollapsed(B,void 0,j)}navigate(n){return new o(this.j,this.o,n)}dispose(){(0,g.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$nV=D;class o{constructor(n,h,F){this.b=n,this.c=h,F?this.a=this.c.getListIndex(F):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[136],be([1,0,135,127,27,29]),function(se,t,i,N,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yV=void 0;class E extends i.$nV{constructor(b,$,w,P,f,d={}){super(b,$,w,P,d),this.f=b,this.g=f,this.d=new Map,this.c=d.identityProvider}getInput(){return this.b}setInput(b,$){if($&&!this.c)throw new z.$dV(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!$){this.m(b);return}const w=[],P=[],f=e=>{const s=this.c.getId(e).toString();return!$.expanded[s]},d=e=>{const s=this.c.getId(e.element).toString();$.focus.has(s)&&w.push(e.element),$.selection.has(s)&&P.push(e.element)};this.m(b,f,d),this.setFocus(w),this.setSelection(P),$&&typeof $.scrollTop=="number"&&(this.scrollTop=$.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new z.$dV(this.f,"Tree input not set");let $;this.c&&($=w=>{const P=this.c.getId(w).toString(),f=this.d.get(P);if(f)return f.collapsed}),this.m(b,$)}resort(b=this.b,$=!0){this.o.resort(b===this.b?null:b,$)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,$,w){let P;if(this.c){const f=new Set,d=w;w=e=>{const s=this.c.getId(e.element).toString();f.add(s),this.d.set(s,e),d?.(e)},P=e=>{const s=this.c.getId(e.element).toString();f.has(s)||this.d.delete(s)}}this.o.setChildren(b===this.b?null:b,this.s(b,$).elements,{onDidCreateNode:w,onDidDeleteNode:P})}s(b,$){const w=[...this.g.getChildren(b)];return{elements:H.Iterable.map(w,f=>{const{elements:d,size:e}=this.s(f,$),s=this.g.hasChildren?this.g.hasChildren(f):void 0,u=e===0?void 0:$&&$(f);return{element:f,children:d,collapsible:s,collapsed:u}}),size:w.length}}M(b,$,w){return new N.$oV(b,$,w)}}t.$yV=E}),define(me[70],be([1,0,12,9,36,30,28,6,4,3,56,10,7]),function(se,t,i,N,z,H,E,A,b,$,w,P,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3h=t.ProxyChannel=t.$2h=t.$Yh=t.$Xh=t.$Wh=t.RequestInitiator=t.$Vh=t.$Sh=t.$Rh=void 0,t.$Th=O,t.$Uh=y,t.$Zh=X,t.$1h=J;var d;(function(oe){oe[oe.Promise=100]="Promise",oe[oe.PromiseCancel=101]="PromiseCancel",oe[oe.EventListen=102]="EventListen",oe[oe.EventDispose=103]="EventDispose"})(d||(d={}));function e(oe){switch(oe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(oe){oe[oe.Initialize=200]="Initialize",oe[oe.PromiseSuccess=201]="PromiseSuccess",oe[oe.PromiseError=202]="PromiseError",oe[oe.PromiseErrorObj=203]="PromiseErrorObj",oe[oe.EventFire=204]="EventFire"})(s||(s={}));function u(oe){switch(oe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(oe){oe[oe.Uninitialized=0]="Uninitialized",oe[oe.Idle=1]="Idle"})(m||(m={}));function p(oe){let U=0;for(let le=0;;le+=7){const re=oe.read(1);if(U|=(re.buffer[0]&127)<<le,!(re.buffer[0]&128))return U}}const v=C(0);function l(oe,U){if(U===0){oe.write(v);return}let le=0;for(let Y=U;Y!==0;Y=Y>>>7)le++;const re=z.$ue.alloc(le);for(let Y=0;U!==0;Y++)re.buffer[Y]=U&127,U=U>>>7,U>0&&(re.buffer[Y]|=128);oe.write(re)}class g{constructor(U){this.b=U,this.a=0}read(U){const le=this.b.slice(this.a,this.a+U);return this.a+=le.byteLength,le}}t.$Rh=g;class r{constructor(){this.a=[]}get buffer(){return z.$ue.concat(this.a)}write(U){this.a.push(U)}}t.$Sh=r;var S;(function(oe){oe[oe.Undefined=0]="Undefined",oe[oe.String=1]="String",oe[oe.Buffer=2]="Buffer",oe[oe.VSBuffer=3]="VSBuffer",oe[oe.Array=4]="Array",oe[oe.Object=5]="Object",oe[oe.Int=6]="Int"})(S||(S={}));function C(oe){const U=z.$ue.alloc(1);return U.writeUInt8(oe,0),U}const I={Undefined:C(S.Undefined),String:C(S.String),Buffer:C(S.Buffer),VSBuffer:C(S.VSBuffer),Array:C(S.Array),Object:C(S.Object),Uint:C(S.Int)},M=typeof Buffer<"u";function O(oe,U){if(typeof U>"u")oe.write(I.Undefined);else if(typeof U=="string"){const le=z.$ue.fromString(U);oe.write(I.String),l(oe,le.byteLength),oe.write(le)}else if(M&&Buffer.isBuffer(U)){const le=z.$ue.wrap(U);oe.write(I.Buffer),l(oe,le.byteLength),oe.write(le)}else if(U instanceof z.$ue)oe.write(I.VSBuffer),l(oe,U.byteLength),oe.write(U);else if(Array.isArray(U)){oe.write(I.Array),l(oe,U.length);for(const le of U)O(oe,le)}else if(typeof U=="number"&&(U|0)===U)oe.write(I.Uint),l(oe,U);else{const le=z.$ue.fromString(JSON.stringify(U));oe.write(I.Object),l(oe,le.byteLength),oe.write(le)}}function y(oe){switch(oe.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return oe.read(p(oe)).toString();case S.Buffer:return oe.read(p(oe)).buffer;case S.VSBuffer:return oe.read(p(oe));case S.Array:{const le=p(oe),re=[];for(let Y=0;Y<le;Y++)re.push(y(oe));return re}case S.Object:return JSON.parse(oe.read(p(oe)).toString());case S.Int:return p(oe)}}class x{constructor(U,le,re=null,Y=1e3){this.h=U,this.j=le,this.k=re,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,le){this.b.set(U,le),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const le=this.o([U.type]);this.k?.logOutgoing(le,0,1,u(U.type));return}case 201:case 202:case 204:case 203:{const le=this.o([U.type,U.id],U.data);this.k?.logOutgoing(le,U.id,1,u(U.type),U.data);return}}}o(U,le=void 0){const re=new r;return O(re,U),O(re,le),this.p(re.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const le=new g(U),re=y(le),Y=y(le),Q=re[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,re[1],1,`${e(Q)}: ${re[2]}.${re[3]}`,Y),this.s({type:Q,id:re[1],channelName:re[2],name:re[3],arg:Y});case 102:return this.k?.logIncoming(U.byteLength,re[1],1,`${e(Q)}: ${re[2]}.${re[3]}`,Y),this.t({type:Q,id:re[1],channelName:re[2],name:re[3],arg:Y});case 101:return this.k?.logIncoming(U.byteLength,re[1],1,`${e(Q)}`),this.u({type:Q,id:re[1]});case 103:return this.k?.logIncoming(U.byteLength,re[1],1,`${e(Q)}`),this.u({type:Q,id:re[1]})}}s(U){const le=this.b.get(U.channelName);if(!le){this.v(U);return}const re=new H.$ee;let Y;try{Y=le.call(this.j,U.name,U.arg,re.token)}catch(ue){Y=Promise.reject(ue)}const Q=U.id;Y.then(ue=>{this.m({id:Q,data:ue,type:201})},ue=>{ue instanceof Error?this.m({id:Q,data:{message:ue.message,name:ue.name,stack:ue.stack?ue.stack.split?ue.stack.split(`
`):ue.stack:void 0},type:202}):this.m({id:Q,data:ue,type:203})}).finally(()=>{te.dispose(),this.d.delete(U.id)});const te=(0,$.$Sc)(()=>re.cancel());this.d.set(U.id,te)}t(U){const le=this.b.get(U.channelName);if(!le){this.v(U);return}const re=U.id,Q=le.listen(this.j,U.name,U.arg)(te=>this.m({id:re,data:te,type:204}));this.d.set(U.id,Q)}u(U){const le=this.d.get(U.id);le&&(le.dispose(),this.d.delete(U.id))}v(U){let le=this.g.get(U.channelName);le||(le=[],this.g.set(U.channelName,le));const re=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);le.push({request:U,timeoutTimer:re})}w(U){const le=this.g.get(U);if(le){for(const re of le)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}t.$Vh=x;var W;(function(oe){oe[oe.LocalSide=0]="LocalSide",oe[oe.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class T{constructor(U,le=null){this.l=U,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=le}getChannel(U){const le=this;return{call(re,Y,Q){return le.a?Promise.reject(new A.$5):le.m(U,re,Y,Q)},listen(re,Y){return le.a?b.Event.None:le.o(U,re,Y)}}}m(U,le,re,Y=H.CancellationToken.None){const Q=this.g++,ue={id:Q,type:100,channelName:U,name:le,arg:re};if(Y.isCancellationRequested)return Promise.reject(new A.$5);let ye;return new Promise((Ee,fe)=>{if(Y.isCancellationRequested)return fe(new A.$5);const c=()=>{const a=n=>{switch(n.type){case 201:this.f.delete(Q),Ee(n.data);break;case 202:{this.f.delete(Q);const h=new Error(n.data.message);h.stack=Array.isArray(n.data.stack)?n.data.stack.join(`
`):n.data.stack,h.name=n.data.name,fe(h);break}case 203:this.f.delete(Q),fe(n.data);break}};this.f.set(Q,a),this.p(ue)};let k=null;this.b===m.Idle?c():(k=(0,N.$7g)(a=>this.u()),k.then(()=>{k=null,c()}));const D=()=>{k?(k.cancel(),k=null):this.p({id:Q,type:101}),fe(new A.$5)},o=Y.onCancellationRequested(D);ye=(0,$.$Rc)((0,$.$Sc)(D),o),this.d.add(ye)}).finally(()=>{ye.dispose(),this.d.delete(ye)})}o(U,le,re){const Y=this.g++,te={id:Y,type:102,channelName:U,name:le,arg:re};let ue=null;const ye=new b.$7d({onWillAddFirstListener:()=>{ue=(0,N.$7g)(Ee=>this.u()),ue.then(()=>{ue=null,this.d.add(ye),this.p(te)})},onDidRemoveLastListener:()=>{ue?(ue.cancel(),ue=null):(this.d.delete(ye),this.p({id:Y,type:103}))}}),Te=Ee=>ye.fire(Ee.data);return this.f.set(Y,Te),ye.event}p(U){switch(U.type){case 100:case 102:{const le=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(le,U.id,0,`${e(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const le=this.q([U.type,U.id]);this.j?.logOutgoing(le,U.id,0,e(U.type));return}}}q(U,le=void 0){const re=new r;return O(re,U),O(re,le),this.r(re.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const le=new g(U),re=y(le),Y=y(le),Q=re[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,u(Q)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,re[1],0,u(Q),Y),this.t({type:re[0],id:re[1],data:Y})}}t(U){if(U.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Pc)(this.d.values()),this.d.clear()}}t.$Wh=T,Ze([E.$Lh],T.prototype,"onDidInitializePromise",null);class R{get connections(){const U=[];return this.f.forEach(le=>U.push(le)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new b.$7d,this.onDidAddConnection=this.g.event,this.h=new b.$7d,this.onDidRemoveConnection=this.h.event,this.j=new $.$Tc,this.j.add(U(({protocol:le,onDidClientDisconnect:re})=>{const Y=b.Event.once(le.onMessage);this.j.add(Y(Q=>{const te=new g(Q),ue=y(te),ye=new x(le,ue),Te=new T(le);this.a.forEach((fe,c)=>ye.registerChannel(c,fe));const Ee={channelServer:ye,channelClient:Te,ctx:ue};this.f.add(Ee),this.g.fire(Ee),this.j.add(re(()=>{ye.dispose(),Te.dispose(),this.f.delete(Ee),this.h.fire(Ee)}))}))}))}getChannel(U,le){const re=this;return{call(Y,Q,te){let ue;if((0,f.$9f)(le)){const Te=(0,i.$4b)(re.connections.filter(le));ue=Te?Promise.resolve(Te):b.Event.toPromise(b.Event.filter(re.onDidAddConnection,le))}else ue=le.routeCall(re,Y,Q);const ye=ue.then(Te=>Te.channelClient.getChannel(U));return X(ye).call(Y,Q,te)},listen(Y,Q){if((0,f.$9f)(le))return re.k(U,le,Y,Q);const te=le.routeEvent(re,Y,Q).then(ue=>ue.channelClient.getChannel(U));return X(te).listen(Y,Q)}}}k(U,le,re,Y){const Q=this;let te;const ue=new b.$7d({onWillAddFirstListener:()=>{te=new $.$Tc;const ye=new b.$ae,Te=new Map,Ee=c=>{const D=c.channelClient.getChannel(U).listen(re,Y),o=ye.add(D);Te.set(c,o)},fe=c=>{const k=Te.get(c);k&&(k.dispose(),Te.delete(c))};Q.connections.filter(le).forEach(Ee),b.Event.filter(Q.onDidAddConnection,le)(Ee,void 0,te),Q.onDidRemoveConnection(fe,void 0,te),ye.event(ue.fire,ue,te),te.add(ye)},onDidRemoveLastListener:()=>{te?.dispose(),te=void 0}});return ue.event}registerChannel(U,le){this.a.set(U,le);for(const re of this.f)re.channelServer.registerChannel(U,le)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Xh=R;class L{constructor(U,le,re=null){const Y=new r;O(Y,le),U.send(Y.buffer),this.a=new T(U,re),this.d=new x(U,le,re)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,le){this.d.registerChannel(U,le)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Yh=L;function X(oe){return{call(U,le,re){return oe.then(Y=>Y.call(U,le,re))},listen(U,le){const re=new b.$de;return oe.then(Y=>re.input=Y.listen(U,le)),re.event}}}function J(oe){let U=!1;return{call(le,re,Y){return U?oe.call(le,re,Y):(0,N.$ih)(0).then(()=>U=!0).then(()=>oe.call(le,re,Y))},listen(le,re){if(U)return oe.listen(le,re);const Y=new b.$de;return(0,N.$ih)(0).then(()=>U=!0).then(()=>Y.input=oe.listen(le,re)),Y.event}}}class de{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const le of U.connections)if(await Promise.resolve(this.a(le.ctx)))return Promise.resolve(le);return await b.Event.toPromise(U.onDidAddConnection),await this.b(U)}}t.$2h=de;var ae;(function(oe){function U(Q,te,ue){const ye=Q,Te=ue&&ue.disableMarshalling,Ee=new Map;for(const fe in ye)re(fe)&&Ee.set(fe,b.Event.buffer(ye[fe],!0,void 0,te));return new class{listen(fe,c,k){const D=Ee.get(c);if(D)return D;const o=ye[c];if(typeof o=="function"){if(Y(c))return o.call(ye,k);if(re(c))return Ee.set(c,b.Event.buffer(ye[c],!0,void 0,te)),Ee.get(c)}throw new A.$bb(`Event not found: ${c}`)}call(fe,c,k){const D=ye[c];if(typeof D=="function"){if(!Te&&Array.isArray(k))for(let a=0;a<k.length;a++)k[a]=(0,w.$Qh)(k[a]);let o=D.apply(ye,k);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new A.$bb(`Method not found: ${c}`)}}}oe.fromService=U;function le(Q,te){const ue=te&&te.disableMarshalling;return new Proxy({},{get(ye,Te){if(typeof Te=="string")return te?.properties?.has(Te)?te.properties.get(Te):Y(Te)?function(Ee){return Q.listen(Te,Ee)}:re(Te)?Q.listen(Te):async function(...Ee){let fe;te&&!(0,f.$4f)(te.context)?fe=[te.context,...Ee]:fe=Ee;const c=await Q.call(Te,fe);return ue?c:(0,w.$Qh)(c)};throw new A.$bb(`Property not found: ${String(Te)}`)}})}oe.toService=le;function re(Q){return Q[0]==="o"&&Q[1]==="n"&&P.$kf(Q.charCodeAt(2))}function Y(Q){return/^onDynamic/.test(Q)&&P.$kf(Q.charCodeAt(9))}})(ae||(t.ProxyChannel=ae={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(oe){if(Array.isArray(oe))return oe;if(oe&&typeof oe=="object"&&typeof oe.toString=="function"){const U=oe.toString();if(U!=="[object Object]")return U}return oe}function Fe(oe){return Array.isArray(oe)?oe.map(ge):ge(oe)}function Ne(oe,U,le,re,Y,Q,te){te=Fe(te);const ue=ie[Y],ye=ue[re%ue.length];let Te=[`%c[${oe}]%c[${String(U).padStart(7," ")}]%c[len: ${String(le).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(Q)?(Te=Te.concat(te),Te.push(")")):Te.push(te),console.log.apply(console,Te)}class Pe{constructor(U,le){this.d=U,this.f=le,this.a=0,this.b=0}logOutgoing(U,le,re,Y,Q){this.b+=U,Ne(this.d,this.b,U,le,re,Y,Q)}logIncoming(U,le,re,Y,Q){this.a+=U,Ne(this.f,this.a,U,le,re,Y,Q)}}t.$3h=Pe}),define(me[137],be([1,0,36,4,70,94,31]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9V=void 0;class A extends z.$Yh{static f(){const $=N.Event.fromNodeEventEmitter(E.$O,"vscode:message",(w,P)=>i.$ue.wrap(P));return E.$O.send("vscode:hello"),new H.$5V(E.$O,$)}constructor($){const w=A.f();super(w,$),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$9V=A}),define(me[138],be([13,11]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(me[139],be([13,11]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(me[44],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gi=t._util=void 0,t.$hi=z,t.$ii=H;var i;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function A(b){return b[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=A})(i||(t._util=i={})),t.$gi=z("instantiationService");function N(E,A,b){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:E,index:b}):(A[i.DI_DEPENDENCIES]=[{id:E,index:b}],A[i.DI_TARGET]=A)}function z(E){if(i.serviceIds.has(E))return i.serviceIds.get(E);const A=function(b,$,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(A,b,w)};return A.toString=()=>E,i.serviceIds.set(E,A),A}function H(E){return E}}),define(me[140],be([1,0,44]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3m=t.$1m=t.ID=void 0,t.$2m=N,t.ID="diagnosticsService",t.$1m=(0,i.$hi)(t.ID);function N(H){return!!H.hostName&&!!H.errorMessage}class z{async getPerformanceInfo(E,A){return{}}async getSystemInfo(E,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,A){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$3m=z}),define(me[141],be([1,0,91,25,10,7,16,138,44,5,32,23]),function(se,t,i,N,z,H,E,A,b,$,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jl=t.$gl=t.FileKind=t.$fl=t.$el=t.$dl=t.$cl=t.$bl=t.$al=t.$_k=t.FileOperationResult=t.$$k=t.$0k=t.$9k=t.$7k=t.FileChangeType=t.$6k=t.FileOperation=t.$Zk=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Nk=void 0,t.$Ok=f,t.$Pk=s,t.$Qk=m,t.$Rk=p,t.$Sk=v,t.$Tk=l,t.$Uk=g,t.$Vk=r,t.$Wk=S,t.$Xk=C,t.$Yk=I,t.$1k=y,t.$2k=x,t.$3k=W,t.$4k=T,t.$5k=R,t.$8k=ae,t.$hl=oe,t.$il=U,t.$kl=re,t.$Nk=(0,b.$hi)("fileService");function f(Y){return Y.create===!0}var d;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(d||(t.FileType=d={}));var e;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(Y){const Q=Y;return!!Q&&typeof Q.onDidChange=="function"}var u;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(u||(t.FileSystemProviderCapabilities=u={}));function m(Y){return!!(Y.capabilities&2)}function p(Y){return!!(Y.capabilities&8)}function v(Y){return!!(Y.capabilities&131072)}function l(Y){return!!(Y.capabilities&4)}function g(Y){return!!(Y.capabilities&16)}function r(Y){return m(Y)?!!(Y.capabilities&16384):!1}function S(Y){return m(Y)?!!(Y.capabilities&32768):!1}function C(Y){return!!(Y.capabilities&65536)}function I(Y){return!!(Y.capabilities&2048)}var M;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(M||(t.FileSystemProviderErrorCode=M={}));class O extends Error{static create(Q,te){const ue=new O(Q.toString(),te);return W(ue,te),ue}constructor(Q,te){super(Q),this.code=te}}t.$Zk=O;function y(Y,Q){return O.create(Y,Q)}function x(Y){return Y||y((0,A.localize)(0,null),M.Unknown)}function W(Y,Q){return Y.name=Q?`${Q} (FileSystemError)`:"FileSystemError",Y}function T(Y){if(!Y)return M.Unknown;if(Y instanceof O)return Y.code;const Q=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!Q)return M.Unknown;switch(Q[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}function R(Y){if(Y instanceof ie)return Y.fileOperationResult;switch(T(Y)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 9;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileTooLarge:return 7;default:return 10}}var L;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(L||(t.FileOperation=L={}));class X{constructor(Q,te,ue){this.resource=Q,this.operation=te,this.target=ue}isOperation(Q){return this.operation===Q}}t.$6k=X;var J;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(J||(t.FileChangeType=J={}));class de{static{this.a=null}constructor(Q,te){this.c=te,this.b=void 0,this.d=new P.$V(()=>{const ue=i.$ni.forUris(()=>this.c);return ue.fill(this.rawAdded.map(ye=>[ye,!0])),ue}),this.f=new P.$V(()=>{const ue=i.$ni.forUris(()=>this.c);return ue.fill(this.rawUpdated.map(ye=>[ye,!0])),ue}),this.g=new P.$V(()=>{const ue=i.$ni.forUris(()=>this.c);return ue.fill(this.rawDeleted.map(ye=>[ye,!0])),ue}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ue of Q){switch(ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}this.b!==de.a&&(typeof ue.cId=="number"?this.b===void 0?this.b=ue.cId:this.b!==ue.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(Q,...te){return this.h(Q,{includeChildren:!1},...te)}affects(Q,...te){return this.h(Q,{includeChildren:!0},...te)}h(Q,te,...ue){if(!Q)return!1;const ye=ue.length>0;return!!((!ye||ue.includes(1))&&(this.d.value.get(Q)||te.includeChildren&&this.d.value.findSuperstr(Q))||(!ye||ue.includes(0))&&(this.f.value.get(Q)||te.includeChildren&&this.f.value.findSuperstr(Q))||(!ye||ue.includes(2))&&(this.g.value.findSubstr(Q)||te.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}t.$7k=de;function ae(Y,Q,te){return!Y||!Q||Y===Q||Q.length>Y.length?!1:(Q.charAt(Q.length-1)!==N.sep&&(Q+=N.sep),te?(0,z.$mf)(Y,Q):Y.indexOf(Q)===0)}class ie extends Error{constructor(Q,te,ue){super(Q),this.fileOperationResult=te,this.options=ue}}t.$9k=ie;class ge extends ie{constructor(Q,te,ue,ye){super(Q,te,ye),this.fileOperationResult=te,this.size=ue}}t.$0k=ge;class Fe extends ie{constructor(Q,te,ue){super(Q,2,ue),this.stat=te}}t.$$k=Fe;var Ne;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(t.FileOperationResult=Ne={})),t.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$bl="files.associations",t.$cl="files.exclude",t.$dl="files.readonlyInclude",t.$el="files.readonlyExclude",t.$fl="files.readonlyFromPermissions";var Pe;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$gl="";function oe(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}async function U(Y,Q){if(!Q.hasProvider(E.URI.from({scheme:Y.scheme})))return new Promise(te=>{const ue=Q.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===Y.scheme&&ye.added&&(ue.dispose(),te())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(Q){return(0,H.$Yf)(Q)||(Q=0),Q<le.KB?(0,A.localize)(1,null,Q.toFixed(0)):Q<le.MB?(0,A.localize)(2,null,(Q/le.KB).toFixed(2)):Q<le.GB?(0,A.localize)(3,null,(Q/le.MB).toFixed(2)):Q<le.TB?(0,A.localize)(4,null,(Q/le.GB).toFixed(2)):(0,A.localize)(5,null,(Q/le.TB).toFixed(2))}}t.$jl=le;function re(Y){const Q=typeof Y=="string"||Y?.scheme===w.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===w.Schemas.file?1024*le.MB:Q?10*le.MB:$.$o?50*le.MB:1024*le.MB}}),define(me[142],be([1,0,44]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wbc=t.$vbc=void 0,t.$vbc=(0,i.$hi)("mainProcessService");class N{constructor(H,E){this.a=H,this.b=E}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,E){this.a.registerChannel(H,E)}}t.$wbc=N}),define(me[143],be([1,0,3,137]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xbc=void 0;class z extends i.$Uc{constructor(E){super(),this.a=this.B(new N.$9V(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,A){this.a.registerChannel(E,A)}}t.$xbc=z});var Ei=this&&this.__param||function(se,t){return function(i,N){t(i,N,se)}};define(me[144],be([1,0,70,142]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bbc=void 0;let z=class{constructor(E,A){return this.windowId=E,i.ProxyChannel.toService(A.getChannel("nativeHost"),{context:E,properties:(()=>{const b=new Map;return b.set("windowId",E),b})()})}};t.$Bbc=z,t.$Bbc=z=Ze([Ei(1,N.$vbc)],z)}),define(me[71],be([1,0,79,7]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zn=void 0;class z{constructor(){this.a=new Map}add(E,A){i.ok(N.$Uf(E)),i.ok(N.$Wf(A)),i.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,A)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$Zn=new z}),define(me[145],be([1,0,4,71]),function(se,t,i,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1n=void 0,t.$1n={JSONContribution:"base.contributions.json"};function z(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class H{constructor(){this.b=new i.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,$){this.a[z(b)]=$,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const E=new H;N.$Zn.add(t.$1n.JSONContribution,E)}),define(me[146],be([1,0,9,18,38,19,4,7,16,139,145,71]),function(se,t,i,N,z,H,E,A,b,$,w,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zw=t.$Yw=t.$Xw=t.$Ww=t.$Vw=t.$Uw=t.IconFontDefinition=t.IconContribution=t.$Rw=void 0,t.$Sw=u,t.$Tw=m,t.$Rw={IconContribution:"base.contributions.icons"};var f;(function(g){function r(S,C){let I=S.defaults;for(;H.ThemeIcon.isThemeIcon(I);){const M=s.getIcon(I.id);if(!M)return;I=M.defaults}return I}g.getDefinition=r})(f||(t.IconContribution=f={}));var d;(function(g){function r(C){return{weight:C.weight,style:C.style,src:C.src.map(I=>({format:I.format,location:I.location.toString()}))}}g.toJSONObject=r;function S(C){const I=M=>(0,A.$Uf)(M)?M:void 0;if(C&&Array.isArray(C.src)&&C.src.every(M=>(0,A.$Uf)(M.format)&&(0,A.$Uf)(M.location)))return{weight:I(C.weight),style:I(C.style),src:C.src.map(M=>({format:M.format,location:b.URI.parse(M.location)}))}}g.fromJSONObject=S})(d||(t.IconFontDefinition=d={}));class e{constructor(){this.a=new E.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${H.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,S,C,I){const M=this.b[r];if(M){if(C&&!M.description){M.description=C,this.d.properties[r].markdownDescription=`${C} $(${r})`;const x=this.e.enum.indexOf(r);x!==-1&&(this.e.enumDescriptions[x]=C),this.a.fire()}return M}const O={id:r,description:C,defaults:S,deprecationMessage:I};this.b[r]=O;const y={$ref:"#/definitions/icons"};return I&&(y.deprecationMessage=I),C&&(y.markdownDescription=`${C}: $(${r})`),this.d.properties[r]=y,this.e.enum.push(r),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const S=this.e.enum.indexOf(r);S!==-1&&(this.e.enum.splice(S,1),this.e.enumDescriptions.splice(S,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,S){const C=this.f[r];return C||(this.f[r]=S,this.a.fire(),S)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(M,O)=>M.id.localeCompare(O.id),S=M=>{for(;H.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const I=Object.keys(this.b).map(M=>this.b[M]);for(const M of I.filter(O=>!!O.description).sort(r))C.push(`|<i class="${S(M)}"></i>|${M.id}|${H.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const M of I.filter(O=>!H.ThemeIcon.isThemeIcon(O.defaults)).sort(r))C.push(`|<i class="${S(M)}"></i>|${M.id}|`);return C.join(`
`)}}const s=new e;P.$Zn.add(t.$Rw.IconContribution,s);function u(g,r,S,C){return s.registerIcon(g,r,S,C)}function m(){return s}function p(){const g=(0,z.$Cj)();for(const r in g){const S="\\"+g[r].toString(16);s.registerIcon(r,{fontCharacter:S})}}p(),t.$Uw="vscode://schemas/icons";const v=P.$Zn.as(w.$1n.JSONContribution);v.registerSchema(t.$Uw,s.getIconSchema());const l=new i.$th(()=>v.notifySchemaChanged(t.$Uw),200);s.onDidChange(()=>{l.isScheduled()||l.schedule()}),t.$Vw=u("widget-close",N.$Gj.close,(0,$.localize)(2,null)),t.$Ww=u("goto-previous-location",N.$Gj.arrowUp,(0,$.localize)(3,null)),t.$Xw=u("goto-next-location",N.$Gj.arrowDown,(0,$.localize)(4,null)),t.$Yw=H.ThemeIcon.modify(N.$Gj.sync,"spin"),t.$Zw=H.ThemeIcon.modify(N.$Gj.loading,"spin")}),define(me[147],be([1,0,2,4,3,19,146]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IHb=void 0,t.$HHb=A;function A($){const w=new z.$Tc,P=w.add(new N.$7d),f=(0,E.$Tw)();return w.add(f.onDidChange(()=>P.fire())),$&&w.add($.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>w.dispose(),onDidChange:P.event,getCSS(){const d=$?$.getProductIconTheme():new b,e={},s=m=>{const p=d.getIcon(m);if(!p)return;const v=p.font;return v?(e[v.id]=v.definition,`.codicon-${m.id}:before { content: '${p.fontCharacter}'; font-family: ${(0,i.$jS)(v.id)}; }`):`.codicon-${m.id}:before { content: '${p.fontCharacter}'; }`},u=[];for(const m of f.getIcons()){const p=s(m);p&&u.push(p)}for(const m in e){const p=e[m],v=p.weight?`font-weight: ${p.weight};`:"",l=p.style?`font-style: ${p.style};`:"",g=p.src.map(r=>`${(0,i.$iS)(r.location)} format('${r.format}')`).join(", ");u.push(`@font-face { src: ${g}; font-family: ${(0,i.$jS)(m)};${v}${l} font-display: block; }`)}return u.join(`
`)}}}class b{getIcon(w){const P=(0,E.$Tw)();let f=w.defaults;for(;H.ThemeIcon.isThemeIcon(f);){const d=P.getIcon(f.id);if(!d)return;f=d.defaults}return f}}t.$IHb=b}),define(me[148],be([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$9C=void 0,t.$0C=N,t.$$C=z,t.$_C=H,t.$aD=E,t.$bD=A,t.$cD=P,t.$dD=f,t.$eD=d,t.$fD=e,t.$gD=s,t.$hD=u,t.$9C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function N(m){return typeof m.parentId=="number"}function z(m){return!!m.workspaceUri}function H(m){return!!m.folderUri}function E(m){return!!m.fileUri}function A(m){const p=f(m),v=m.getValue("window.menuBarVisibility");return v==="default"||p&&v==="compact"||i.$j&&i.$m?"classic":v}var b;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(t.TitleBarSetting=b={}));var $;(function(m){m.NATIVE="native",m.CUSTOM="custom"})($||(t.TitlebarStyle=$={}));var w;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function P(m,p){return!0}function f(m,p){return p||(p=d(m)),p==="native"}function d(m){if(i.$o)return"custom";const p=m.getValue("window");if(p){if(i.$j&&p.nativeTabs===!0||i.$j&&p.nativeFullScreen===!1)return"native";const g=p.titleBarStyle;if(g==="native"||g==="custom")return g}return i.$k?"native":"custom"}function e(m){return!(!i.$i||i.$o||f(m))}function s(m){const p=m.getValue("window");return!p||typeof p.nativeFullScreen!="boolean"||p.nativeTabs?!0:p.nativeFullScreen!==!1}function u(m=0){return Math.pow(1.2,m)}}),define(me[149],be([1,0,17,2,22,31,148]),function(se,t,i,N,z,H,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ebc=t.$Dbc=t.ApplyZoomTarget=void 0,t.$Fbc=b,t.$Gbc=w,t.$Hbc=P;var A;(function(f){f[f.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",f[f.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={})),t.$Dbc=8,t.$Ebc=-8;function b(f,d){f=Math.min(Math.max(f,t.$Ebc),t.$Dbc);const e=[];d===A.ACTIVE_WINDOW?e.push((0,N.$JR)()):d===A.ALL_WINDOWS?e.push(...Array.from((0,N.getWindows)()).map(({window:s})=>s)):e.push(d);for(const s of e)$(s)?.webFrame?.setZoomLevel(f),(0,i.$GQ)((0,E.$hD)(f),s),(0,i.$CQ)(f,s)}function $(f){if(f===z.$xQ)return{ipcRenderer:H.$O,webFrame:H.$Q};{const d=f;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function w(f){b((0,i.$DQ)(typeof f=="number"?(0,N.$JR)():f)+1,f)}function P(f){b((0,i.$DQ)(typeof f=="number"?(0,N.$JR)():f)-1,f)}}),define(me[150],be([1,0,11,2,136,9,95,31,140,141,143,144,147,149,15,22,108,99]),function(se,t,i,N,z,H,E,A,b,$,w,P,f,d,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=x;const u=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(T){return 22}getTemplateId(T){return M(T)?"process":C(T)?"machine":(0,b.$2m)(T)?"error":I(T)?"header":""}}class v{hasChildren(T){return(0,b.$2m)(T)?!1:M(T)?!!T.children?.length:!0}getChildren(T){return M(T)?T.children?T.children:[]:(0,b.$2m)(T)?[]:I(T)?T.processRoots.length>1?T.processRoots:[T.processRoots[0].rootProcess]:C(T)?[T.rootProcess]:[T.processes]}}class l{constructor(){this.templateId="header"}renderTemplate(T){const R=(0,N.$5R)(T,(0,N.$)(".row")),L=(0,N.$5R)(R,(0,N.$)(".nameLabel")),X=(0,N.$5R)(R,(0,N.$)(".cpu")),J=(0,N.$5R)(R,(0,N.$)(".memory")),de=(0,N.$5R)(R,(0,N.$)(".pid"));return{name:L,CPU:X,memory:J,PID:de}}renderElement(T,R,L,X){L.name.textContent=(0,i.localize)(0,null),L.CPU.textContent=(0,i.localize)(1,null),L.PID.textContent=(0,i.localize)(2,null),L.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(T){}}class g{constructor(){this.templateId="machine"}renderTemplate(T){const R=Object.create(null),L=(0,N.$5R)(T,(0,N.$)(".row"));return R.name=(0,N.$5R)(L,(0,N.$)(".nameLabel")),R}renderElement(T,R,L,X){L.name.textContent=T.element.name}disposeTemplate(T){}}class r{constructor(){this.templateId="error"}renderTemplate(T){const R=Object.create(null),L=(0,N.$5R)(T,(0,N.$)(".row"));return R.name=(0,N.$5R)(L,(0,N.$)(".nameLabel")),R}renderElement(T,R,L,X){L.name.textContent=T.element.errorMessage}disposeTemplate(T){}}class S{constructor(T,R,L){this.a=T,this.b=R,this.c=L,this.templateId="process"}renderTemplate(T){const R=(0,N.$5R)(T,(0,N.$)(".row")),L=(0,N.$5R)(R,(0,N.$)(".nameLabel")),X=(0,N.$5R)(R,(0,N.$)(".cpu")),J=(0,N.$5R)(R,(0,N.$)(".memory")),de=(0,N.$5R)(R,(0,N.$)(".pid"));return{name:L,CPU:X,PID:de,memory:J}}renderElement(T,R,L,X){const{element:J}=T,de=J.pid.toFixed(0);let ae=J.name;this.c.has(J.pid)&&(ae=this.c.get(J.pid)),L.name.textContent=ae,L.name.title=J.cmd,L.CPU.textContent=J.load.toFixed(0),L.PID.textContent=de,L.PID.parentElement.id=`pid-${de}`;const ie=this.a==="win32"?J.mem:this.b*(J.mem/100);L.memory.textContent=(ie/$.$jl.MB).toFixed(0)}disposeTemplate(T){}}function C(W){return!!W.name&&!!W.rootProcess}function I(W){return!!W.processRoots}function M(W){return!!W.pid}class O{constructor(T,R){this.f=R,this.b=new Map;const L=new w.$xbc(T);this.c=new P.$Bbc(T,L),this.k(R.styles),this.g(R),A.$O.on("vscode:pidToNameResponse",(X,J)=>{this.b.clear();for(const[de,ae]of J)this.b.set(de,ae)}),A.$O.on("vscode:listProcessesResponse",async(X,J)=>{J.forEach((de,ae)=>{M(de.rootProcess)&&(de.rootProcess.name=ae===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:J}}),this.d.layout(s.$xQ.innerHeight,s.$xQ.innerWidth)):await this.h(J),this.m(0)}),this.a=Date.now(),A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")}g(T){s.$xQ.document.onkeydown=R=>{const L=T.platform==="darwin"?R.metaKey:R.ctrlKey;L&&R.keyCode===87&&(R.stopPropagation(),R.preventDefault(),A.$O.send("vscode:closeProcessExplorer")),L&&R.keyCode===187&&(0,d.$Gbc)(s.$xQ),L&&R.keyCode===189&&(0,d.$Hbc)(s.$xQ)}}async h(T){const R=s.$xQ.document.getElementById("process-list");if(!R)return;const{totalmem:L}=await this.c.getOSStatistics(),X=[new S(this.f.platform,L,this.b),new l,new g,new r];this.d=new z.$yV("processExplorer",R,new p,X,new v,{identityProvider:{getId:J=>M(J)?J.pid.toString():(0,b.$2m)(J)?J.hostName:I(J)?"processes":C(J)?J.name:"header"}}),this.d.setInput({processes:{processRoots:T}}),this.d.layout(s.$xQ.innerHeight,s.$xQ.innerWidth),this.d.onKeyDown(J=>{const de=new e.$2Q(J);if(de.keyCode===35&&de.altKey){const ae=this.n();Promise.all(ae.map(ie=>this.c.killProcess(ie,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(J=>{M(J.element)&&this.l(J.element,!0)}),R.style.height=`${s.$xQ.innerHeight}px`,s.$xQ.addEventListener("resize",()=>{R.style.height=`${s.$xQ.innerHeight}px`,this.d?.layout(s.$xQ.innerHeight,s.$xQ.innerWidth)})}i(T){const R=u.exec(T);return R&&R.groups.port!=="0"||T.indexOf("node ")>=0||T.indexOf("node.exe")>=0}j(T){const R={type:"node",request:"attach",name:`process ${T.pid}`};let L=u.exec(T.cmd);L?R.port=Number(L.groups.port):R.processId=String(T.pid),L=m.exec(T.cmd),L&&(R.port=Number(L.groups.port)),A.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[R]})}k(T){const R=(0,N.$MR)(),L=[];T.listFocusBackground&&(L.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&L.push(`.monaco-list:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(L.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&L.push(`.monaco-list:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listHoverBackground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${T.listHoverForeground}; }`),T.listFocusOutline&&L.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&L.push(`.monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.scrollbarShadowColor&&L.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${T.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),T.scrollbarSliderBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${T.scrollbarSliderBackgroundColor};
				}
			`),T.scrollbarSliderHoverBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${T.scrollbarSliderHoverBackgroundColor};
				}
			`),T.scrollbarSliderActiveBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${T.scrollbarSliderActiveBackgroundColor};
				}
			`),R.textContent=L.join(`
`),T.color&&(s.$xQ.document.body.style.color=T.color)}l(T,R){const L=[],X=Number(T.pid);R&&(L.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),L.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),L.push({type:"separator"})),L.push({label:(0,i.localize)(6,null),click:()=>{const J=this.n();J?.includes(X)||(J.length=0,J.push(X));const de=J?.map(ae=>s.$xQ.document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(de){const ae=de.map(ie=>ie.innerText).filter(ie=>!!ie);this.c.writeClipboardText(ae.join(`
`))}}}),L.push({label:(0,i.localize)(7,null),click:()=>{const J=s.$xQ.document.getElementById("process-list");J&&this.c.writeClipboardText(J.innerText)}}),T&&R&&this.i(T.cmd)&&(L.push({type:"separator"}),L.push({label:(0,i.localize)(8,null),click:()=>{this.j(T)}})),(0,E.$1V)(L)}m(T){setTimeout(()=>{const R=Date.now(),L=T+R-this.a;this.a=R,L>1e3?(A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")):this.m(L)},200)}n(){return this.d?.getSelection()?.map(T=>{if(!(!T||!("pid"in T)))return T.pid}).filter(T=>!!T)}}function y(){const W=(0,N.$MR)();W.id="codiconStyles";const T=(0,f.$HHb)(void 0);function R(){W.textContent=T.getCSS()}const L=new H.$th(R,0);T.onDidChange(()=>L.schedule()),L.schedule()}function x(W){const T=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";s.$xQ.document.body.classList.add(T),y(),(0,d.$Fbc)(W.data.zoomLevel,s.$xQ),new O(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c3cc8b9948d52f04836997a7de01dbd9bb2a7bf/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
