/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/errors","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/node/watcher/baseWatcher","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(J){for(var e=[],D=0,O=J.length;D<O;D++)e[D]=ne[J[D]];return e};define(ne[71],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const k=new Map,j=new Map,N=new Map,E=new Map;function l(p,y){p.has(y.detail)||p.set(y.detail,-y.timestamp)}function a(p,y){const R=p.get(y.detail);R&&(R>=0||p.set(y.detail,R+y.timestamp))}let b=[];typeof J=="function"&&typeof J.getStats=="function"&&(b=J.getStats().slice(0).sort((p,y)=>p.timestamp-y.timestamp));for(const p of b)switch(p.type){case 10:l(k,p);break;case 11:case 12:a(k,p);break;case 21:l(j,p);break;case 22:a(j,p);break;case 33:l(N,p);break;case 34:a(N,p);break;case 31:l(E,p);break;case 32:a(E,p);break}let v=0;N.forEach(p=>v+=p);function d(p){const y=[];return p.forEach((R,g)=>y.push([g,R])),y}return{amdLoad:d(k),amdInvoke:d(j),nodeRequire:d(N),nodeEval:d(E),nodeRequireTotal:v}}static toMarkdownTable(k,j){let N="";const E=[];return k.forEach((l,a)=>{E[a]=l.length}),j.forEach(l=>{l.forEach((a,b)=>{typeof a>"u"&&(a=l[b]="-");const v=a.toString().length;E[b]=Math.max(v,E[b])})}),k.forEach((l,a)=>{N+=`| ${l+" ".repeat(E[a]-l.toString().length)} `}),N+=`|
`,k.forEach((l,a)=>{N+=`| ${"-".repeat(E[a])} `}),N+=`|
`,j.forEach(l=>{l.forEach((a,b)=>{typeof a<"u"&&(N+=`| ${a+" ".repeat(E[b]-a.toString().length)} `)}),N+=`|
`}),N}}e.$U=D}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=O,e.$Mh=k,e.$Nh=j;function D(N){return(E,l,a)=>{let b=null,v=null;if(typeof a.value=="function"?(b="value",v=a.value):typeof a.get=="function"&&(b="get",v=a.get),!v)throw new Error("not supported");a[b]=N(v,l)}}function O(N,E,l){let a=null,b=null;if(typeof l.value=="function"?(a="value",b=l.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(a="get",b=l.get),!b)throw new Error("not supported");const v=`$memoize$${E}`;l[a]=function(...d){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,d)}),this[v]}}function k(N,E,l){return D((a,b)=>{const v=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...p){this[d]||(this[d]=l?l():void 0),clearTimeout(this[v]),E&&(this[d]=E(this[d],...p),p=[this[d]]),this[v]=setTimeout(()=>{a.apply(this,p),this[d]=l?l():void 0},N)}})}function j(N,E,l){return D((a,b)=>{const v=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,p=`$throttle$lastRun$${b}`,y=`$throttle$pending$${b}`;return function(...R){if(this[d]||(this[d]=l?l():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),E&&(this[d]=E(this[d],...R)),this[y])return;const g=this[p]+N;g<=Date.now()?(this[p]=Date.now(),a.apply(this,[this[d]]),this[d]=l?l():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[p]=Date.now(),a.apply(this,[this[d]]),this[d]=l?l():void 0},g-Date.now()))}})}}),define(ne[72],re([0,1,8]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$0c=k,e.$$c=j,e.$_c=N,e.$ad=E,e.$bd=l;function O(a,b){if(!a)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}function k(a,b="Unreachable"){throw new Error(b)}function j(a){if(!a)throw new D.$cb("Assertion Failed")}function N(a){a||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function l(a,b){let v=0;for(;v<a.length-1;){const d=a[v],p=a[v+1];if(!b(d,p))return!1;v++}return!0}}),define(ne[38],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=N,e.$tn=v,e.$un=d,e.$vn=p,e.$wn=y,e.$xn=R,e.$yn=g,e.$zn=c,e.$An=w,e.$Bn=$,e.$Cn=h,e.$Dn=m;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var j;(function(i){i.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function N(i,r=!1){let t=0;const n=i.length;let s="",o=0,u=16,S=0;function I(te){let ue=0,he=0;for(;ue<te;){const ce=i.charCodeAt(t);if(ce>=48&&ce<=57)he=he*16+ce-48;else if(ce>=65&&ce<=70)he=he*16+ce-65+10;else if(ce>=97&&ce<=102)he=he*16+ce-97+10;else break;t++,ue++}return ue<te&&(he=-1),he}function L(te){t=te,s="",o=0,u=16,S=0}function U(){const te=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return S=3,i.substring(te,t);let ue=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;ue=t}else S=3;return i.substring(te,ue)}function z(){let te="",ue=t;for(;;){if(t>=n){te+=i.substring(ue,t),S=2;break}const he=i.charCodeAt(t);if(he===34){te+=i.substring(ue,t),t++;break}if(he===92){if(te+=i.substring(ue,t),t++,t>=n){S=2;break}switch(i.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const B=I(4);B>=0?te+=String.fromCharCode(B):S=4;break}default:S=5}ue=t;continue}if(he>=0&&he<=31)if(l(he)){te+=i.substring(ue,t),S=2;break}else S=6;t++}return te}function V(){if(s="",S=0,o=t,t>=n)return o=n,u=17;let te=i.charCodeAt(t);if(E(te)){do t++,s+=String.fromCharCode(te),te=i.charCodeAt(t);while(E(te));return u=15}if(l(te))return t++,s+=String.fromCharCode(te),te===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),u=14;switch(te){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,s=z(),u=10;case 47:{const ue=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!l(i.charCodeAt(t));)t++;return s=i.substring(ue,t),u=12}if(i.charCodeAt(t+1)===42){t+=2;const he=n-1;let ce=!1;for(;t<he;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,S=1),s=i.substring(ue,t),u=13}return s+=String.fromCharCode(te),t++,u=16}case 45:if(s+=String.fromCharCode(te),t++,t===n||!a(i.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),u=11;default:for(;t<n&&Q(te);)t++,te=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(te),t++,u=16}}function Q(te){if(E(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let te;do te=V();while(te>=12&&te<=15);return te}return{setPosition:L,getPosition:()=>t,scan:r?se:V,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>S}}function E(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function l(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function v(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function S(I,L,U,z){o.value=I,o.offset=L,o.length=U,o.type=z,o.colonOffset=void 0,s=o}try{$(i,{onObjectBegin:(I,L)=>{if(r<=I)throw n;s=void 0,u=r>I,t.push("")},onObjectProperty:(I,L,U)=>{if(r<L||(S(I,L,U,"property"),t[t.length-1]=I,r<=L+U))throw n},onObjectEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,L)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,L,U)=>{if(r<L||(S(I,L,U,m(I)),r<=L+U))throw n},onSeparator:(I,L,U)=>{if(r<=L)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=L,u=!1,s=void 0;else if(I===","){const z=t[t.length-1];typeof z=="number"?t[t.length-1]=z+1:(u=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:u,matches:I=>{let L=0;for(let U=0;L<I.length&&U<t.length;U++)if(I[L]===t[U]||I[L]==="*")L++;else if(I[L]!=="**")return!1;return L===I.length}}}function d(i,r=[],t=j.DEFAULT){let n=null,s=[];const o=[];function u(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return $(i,{onObjectBegin:()=>{const I={};u(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];u(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:u,onError:(I,L,U)=>{r.push({error:I,offset:L,length:U})}},t),s[0]}function p(i,r=[],t=j.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}$(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,L,U)=>{n=o({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:L,length:U,parent:n})},onObjectEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onArrayBegin:(I,L)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onLiteralValue:(I,L,U)=>{o({type:m(I),offset:L,length:U,parent:n,value:I}),s(L+U)},onSeparator:(I,L,U)=>{n.type==="property"&&(I===":"?n.colonOffset=L:I===","&&s(L))},onError:(I,L,U)=>{r.push({error:I,offset:L,length:U})}},t);const S=n.children[0];return S&&delete S.parent,S}function y(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function R(i){if(!i.parent||!i.parent.children)return[];const r=R(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}function g(i){switch(i.type){case"array":return i.children.map(g);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=g(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}function w(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=w(n[s],r,t);if(o)return o}return i}}function $(i,r,t=j.DEFAULT){const n=N(i,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),S=o(r.onObjectProperty),I=s(r.onObjectEnd),L=s(r.onArrayBegin),U=s(r.onArrayEnd),z=o(r.onLiteralValue),V=o(r.onSeparator),Q=s(r.onComment),se=o(r.onError),te=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function he(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:te||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:te?ce(10):Q();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],C=[]){if(se(Y),_.length+C.length>0){let F=n.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){he();break}else if(C.indexOf(F)!==-1)break;F=he()}}}function B(Y){const _=n.getTokenValue();return Y?z(_):S(_),he(),!0}function X(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}z(Y);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return he(),!0}function q(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(V(":"),he(),Z()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function T(){u(),he();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ce(4,[],[]),V(","),he(),n.getToken()===2&&ue)break}else Y&&ce(6,[],[]);q()||ce(4,[],[2,5]),Y=!0}return I(),n.getToken()!==2?ce(7,[2],[]):he(),!0}function x(){L(),he();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ce(4,[],[]),V(","),he(),n.getToken()===4&&ue)break}else Y&&ce(6,[],[]);Z()||ce(4,[],[4,5]),Y=!0}return U(),n.getToken()!==4?ce(8,[4],[]):he(),!0}function Z(){switch(n.getToken()){case 3:return x();case 1:return T();case 10:return B(!0);default:return X()}}return he(),n.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Z()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function h(i,r){const t=N(i),n=[];let s,o=0,u;do switch(u=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==u&&n.push(i.substring(o,u)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}function m(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[73],re([0,1,38]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=O,e.$Fn=k,e.$Gn=E,e.$Hn=l;function O(a,b,v){let d,p,y,R,g;if(b){for(R=b.offset,g=R+b.length,y=R;y>0&&!l(a,y-1);)y--;let u=g;for(;u<a.length&&!l(a,u);)u++;p=a.substring(y,u),d=N(p,v)}else p=a,d=0,y=0,R=0,g=a.length;const c=E(v,a);let w=!1,$=0,h;v.insertSpaces?h=j(" ",v.tabSize||4):h="	";const m=(0,D.$sn)(p,!1);let i=!1;function r(){return c+j(h,d+$)}function t(){let u=m.scan();for(w=!1;u===15||u===14;)w=w||u===14,u=m.scan();return i=u===16||m.getTokenError()!==0,u}const n=[];function s(u,S,I){!i&&S<g&&I>R&&a.substring(S,I)!==u&&n.push({offset:S,length:I-S,content:u})}let o=t();if(o!==17){const u=m.getTokenOffset()+y,S=j(h,d);s(S,y,u)}for(;o!==17;){let u=m.getTokenOffset()+m.getTokenLength()+y,S=t(),I="";for(;!w&&(S===12||S===13);){const U=m.getTokenOffset()+y;s(" ",u,U),u=m.getTokenOffset()+m.getTokenLength()+y,I=S===12?r():"",S=t()}if(S===2)o!==1&&($--,I=r());else if(S===4)o!==3&&($--,I=r());else{switch(o){case 3:case 1:$++,I=r();break;case 5:case 12:I=r();break;case 13:w?I=r():I=" ";break;case 6:I=" ";break;case 10:if(S===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?I=" ":S!==5&&S!==17&&(i=!0);break;case 16:i=!0;break}w&&(S===12||S===13)&&(I=r())}const L=m.getTokenOffset()+y;s(I,u,L),o=S}return n}function k(a,b){const v=JSON.stringify(a,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}function j(a,b){let v="";for(let d=0;d<b;d++)v+=a;return v}function N(a,b){let v=0,d=0;const p=b.tabSize||4;for(;v<a.length;){const y=a.charAt(v);if(y===" ")d++;else if(y==="	")d+=p;else break;v++}return Math.floor(d/p)}function E(a,b){for(let v=0;v<b.length;v++){const d=b.charAt(v);if(d==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function l(a,b){return`\r
`.indexOf(a.charAt(b))!==-1}}),define(ne[74],re([0,1,38,73]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=k,e.$Jn=j,e.$Kn=N,e.$Ln=E,e.$Mn=l;function k(a,b,v){return j(a,b,void 0,v)}function j(a,b,v,d,p){const y=b.slice(),R=[],g=(0,D.$vn)(a,R);let c,w;for(;y.length>0&&(w=y.pop(),c=(0,D.$wn)(g,y),c===void 0&&v!==void 0);)typeof w=="string"?v={[w]:v}:v=[v];if(c)if(c.type==="object"&&typeof w=="string"&&Array.isArray(c.children)){const $=(0,D.$wn)(c,[w]);if($!==void 0)if(v===void 0){if(!$.parent)throw new Error("Malformed AST");const h=c.children.indexOf($.parent);let m,i=$.parent.offset+$.parent.length;if(h>0){const r=c.children[h-1];m=r.offset+r.length}else m=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return N(a,{offset:m,length:i-m,content:""},d)}else return N(a,{offset:$.offset,length:$.length,content:JSON.stringify(v)},d);else{if(v===void 0)return[];const h=`${JSON.stringify(w)}: ${JSON.stringify(v)}`,m=p?p(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(m>0){const r=c.children[m-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return N(a,i,d)}}else if(c.type==="array"&&typeof w=="number"&&Array.isArray(c.children))if(v!==void 0){const $=`${JSON.stringify(v)}`;let h;if(c.children.length===0||w===0)h={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const m=w===-1||w>c.children.length?c.children.length:w,i=c.children[m-1];h={offset:i.offset+i.length,length:0,content:","+$}}return N(a,h,d)}else{const $=w,h=c.children[$];let m;if(c.children.length===1)m={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const i=c.children[$-1],r=i.offset+i.length,t=c.offset+c.length;m={offset:r,length:t-2-r,content:""}}else m={offset:h.offset,length:c.children[$+1].offset-h.offset,content:""};return N(a,m,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${c.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return N(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(v)},d)}}function N(a,b,v){let d=E(a,b),p=b.offset,y=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;p>0&&!(0,O.$Hn)(d,p-1);)p--;for(;y<d.length&&!(0,O.$Hn)(d,y);)y++}const R=(0,O.$En)(d,{offset:p,length:y-p},v);for(let c=R.length-1;c>=0;c--){const w=R[c];d=E(d,w),p=Math.min(p,w.offset),y=Math.max(y,w.offset+w.length),y+=w.content.length-w.length}const g=a.length-(d.length-y)-p;return[{offset:p,length:g,content:d.substring(p,y)}]}function E(a,b){return a.substring(0,b.offset)+b.content+a.substring(b.offset+b.length)}function l(a,b){const v=b.slice(0).sort((p,y)=>{const R=p.offset-y.offset;return R===0?p.length-y.length:R});let d=a.length;for(let p=v.length-1;p>=0;p--){const y=v[p];if(y.offset+y.length<=d)a=E(a,y);else throw new Error("Overlapping edit");d=y.offset}return a}}),define(ne[75],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=D,e.rot=O;function D(E,l,a){return Math.min(Math.max(E,l),a)}function O(E,l){return(l+E%l)%l}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$om=k;class j{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=j;class N{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const a=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=N}),function(){function J(k){const j=[];typeof k=="number"&&j.push("code/timeOrigin",k);function N(l){j.push(l,Date.now())}function E(){const l=[];for(let a=0;a<j.length;a+=2)l.push({name:j[a],startTime:j[a+1]});return l}return{mark:N,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))j.push({name:N.name,startTime:Math.round(k+N.startTime)});return j}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:J)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function D(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return J[O].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=J,D.c=e,D.d=function(O,k,j){D.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:j})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,k){if(1&k&&(O=D(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var j=Object.create(null);if(D.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var N in O)D.d(j,N,function(E){return O[E]}.bind(null,N));return j},D.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(k,"a",k),k},D.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},D.p="",D(D.s=0)}([function(J,e,D){(function(O){var k;e=J.exports=C,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],l=e.src=[],a=0,b=a++;l[b]="0|[1-9]\\d*";var v=a++;l[v]="[0-9]+";var d=a++;l[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;l[p]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var y=a++;l[y]="("+l[v]+")\\.("+l[v]+")\\.("+l[v]+")";var R=a++;l[R]="(?:"+l[b]+"|"+l[d]+")";var g=a++;l[g]="(?:"+l[v]+"|"+l[d]+")";var c=a++;l[c]="(?:-("+l[R]+"(?:\\."+l[R]+")*))";var w=a++;l[w]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var $=a++;l[$]="[0-9A-Za-z-]+";var h=a++;l[h]="(?:\\+("+l[$]+"(?:\\."+l[$]+")*))";var m=a++,i="v?"+l[p]+l[c]+"?"+l[h]+"?";l[m]="^"+i+"$";var r="[v=\\s]*"+l[y]+l[w]+"?"+l[h]+"?",t=a++;l[t]="^"+r+"$";var n=a++;l[n]="((?:<|>)?=?)";var s=a++;l[s]=l[v]+"|x|X|\\*";var o=a++;l[o]=l[b]+"|x|X|\\*";var u=a++;l[u]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[h]+"?)?)?";var S=a++;l[S]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[w]+")?"+l[h]+"?)?)?";var I=a++;l[I]="^"+l[n]+"\\s*"+l[u]+"$";var L=a++;l[L]="^"+l[n]+"\\s*"+l[S]+"$";var U=a++;l[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=a++;l[z]="(?:~>?)";var V=a++;l[V]="(\\s*)"+l[z]+"\\s+",E[V]=new RegExp(l[V],"g");var Q=a++;l[Q]="^"+l[z]+l[u]+"$";var se=a++;l[se]="^"+l[z]+l[S]+"$";var te=a++;l[te]="(?:\\^)";var ue=a++;l[ue]="(\\s*)"+l[te]+"\\s+",E[ue]=new RegExp(l[ue],"g");var he=a++;l[he]="^"+l[te]+l[u]+"$";var ce=a++;l[ce]="^"+l[te]+l[S]+"$";var B=a++;l[B]="^"+l[n]+"\\s*("+r+")$|^$";var X=a++;l[X]="^"+l[n]+"\\s*("+i+")$|^$";var q=a++;l[q]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[u]+")",E[q]=new RegExp(l[q],"g");var T=a++;l[T]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var x=a++;l[x]="^\\s*("+l[S]+")\\s+-\\s+("+l[S]+")\\s*$";var Z=a++;l[Z]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,l[Y]),E[Y]||(E[Y]=new RegExp(l[Y]));function _(W,K){if(W instanceof C)return W;if(typeof W!="string"||W.length>j||!(K?E[t]:E[m]).test(W))return null;try{return new C(W,K)}catch{return null}}function C(W,K){if(W instanceof C){if(W.loose===K)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof C))return new C(W,K);k("SemVer",W,K),this.loose=K;var ee=W.trim().match(K?E[t]:E[m]);if(!ee)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<N)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(W,K){var ee=_(W,K);return ee?ee.version:null},e.clean=function(W,K){var ee=_(W.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(W){return k("SemVer.compare",this.version,this.loose,W),W instanceof C||(W=new C(W,this.loose)),this.compareMain(W)||this.comparePre(W)},C.prototype.compareMain=function(W){return W instanceof C||(W=new C(W,this.loose)),f(this.major,W.major)||f(this.minor,W.minor)||f(this.patch,W.patch)},C.prototype.comparePre=function(W){if(W instanceof C||(W=new C(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=W.prerelease[K];if(k("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++K)},C.prototype.inc=function(W,K){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new C(W,ee).inc(K,ge).version}catch{return null}},e.diff=function(W,K){if(H(W,K))return null;var ee=_(W),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=f;var F=/^[0-9]+$/;function f(W,K){var ee=F.test(W),ge=F.test(K);return ee&&ge&&(W=+W,K=+K),ee&&!ge?-1:ge&&!ee?1:W<K?-1:W>K?1:0}function P(W,K,ee){return new C(W,ee).compare(new C(K,ee))}function A(W,K,ee){return P(W,K,ee)>0}function M(W,K,ee){return P(W,K,ee)<0}function H(W,K,ee){return P(W,K,ee)===0}function G(W,K,ee){return P(W,K,ee)!==0}function ie(W,K,ee){return P(W,K,ee)>=0}function ae(W,K,ee){return P(W,K,ee)<=0}function le(W,K,ee,ge){var ve;switch(K){case"===":typeof W=="object"&&(W=W.version),typeof ee=="object"&&(ee=ee.version),ve=W===ee;break;case"!==":typeof W=="object"&&(W=W.version),typeof ee=="object"&&(ee=ee.version),ve=W!==ee;break;case"":case"=":case"==":ve=H(W,ee,ge);break;case"!=":ve=G(W,ee,ge);break;case">":ve=A(W,ee,ge);break;case">=":ve=ie(W,ee,ge);break;case"<":ve=M(W,ee,ge);break;case"<=":ve=ae(W,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(W,K){if(W instanceof pe){if(W.loose===K)return W;W=W.value}if(!(this instanceof pe))return new pe(W,K);k("comparator",W,K),this.loose=K,this.parse(W),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(W,K){return f(K,W)},e.major=function(W,K){return new C(W,K).major},e.minor=function(W,K){return new C(W,K).minor},e.patch=function(W,K){return new C(W,K).patch},e.compare=P,e.compareLoose=function(W,K){return P(W,K,!0)},e.rcompare=function(W,K,ee){return P(K,W,ee)},e.sort=function(W,K){return W.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(W,K){return W.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=A,e.lt=M,e.eq=H,e.neq=G,e.gte=ie,e.lte=ae,e.cmp=le,e.Comparator=pe;var ye={};function fe(W,K){if(W instanceof fe)return W.loose===K?W:new fe(W.raw,K);if(W instanceof pe)return new fe(W.value,K);if(!(this instanceof fe))return new fe(W,K);if(this.loose=K,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function me(W){return!W||W.toLowerCase()==="x"||W==="*"}function de(W,K,ee,ge,ve,Ne,Se,Le,Re,je,Ce,De,Ae){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(Re)?"":me(je)?"<"+(+Re+1)+".0.0":me(Ce)?"<"+Re+"."+(+je+1)+".0":De?"<="+Re+"."+je+"."+Ce+"-"+De:"<="+Le)).trim()}function we(W,K){for(var ee=0;ee<W.length;ee++)if(!W[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<W.length;ee++)if(k(W[ee].semver),W[ee].semver!==ye&&W[ee].semver.prerelease.length>0){var ge=W[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(W,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(W)}function ke(W,K,ee,ge){var ve,Ne,Se,Le,Re;switch(W=new C(W,ge),K=new fe(K,ge),ee){case">":ve=A,Ne=ae,Se=M,Le=">",Re=">=";break;case"<":ve=M,Ne=ie,Se=A,Le="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(W,K,ge))return!1;for(var je=0;je<K.set.length;++je){var Ce=K.set[je],De=null,Ae=null;if(Ce.forEach(function(Ue){Ue.semver===ye&&(Ue=new pe(">=0.0.0")),De=De||Ue,Ae=Ae||Ue,ve(Ue.semver,De.semver,ge)?De=Ue:Se(Ue.semver,Ae.semver,ge)&&(Ae=Ue)}),De.operator===Le||De.operator===Re||(!Ae.operator||Ae.operator===Le)&&Ne(W,Ae.semver)||Ae.operator===Re&&Se(W,Ae.semver))return!1}return!0}pe.prototype.parse=function(W){var K=this.loose?E[B]:E[X],ee=W.match(K);if(!ee)throw new TypeError("Invalid comparator: "+W);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new C(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(W){return k("Comparator.test",W,this.loose),this.semver===ye||(typeof W=="string"&&(W=new C(W,this.loose)),le(W,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(W,K){if(!(W instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(W.value,K),Ee(this.value,ee,K);if(W.operator==="")return ee=new fe(this.value,K),Ee(W.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ne=this.semver.version===W.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Le=le(this.semver,"<",W.semver,K)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Re=le(this.semver,">",W.semver,K)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return ge||ve||Ne&&Se||Le||Re},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(W){var K=this.loose;W=W.trim(),k("range",W,K);var ee=K?E[x]:E[T];W=W.replace(ee,de),k("hyphen replace",W),W=W.replace(E[q],"$1$2$3"),k("comparator trim",W,E[q]),W=(W=(W=W.replace(E[V],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var ge=K?E[B]:E[X],ve=W.split(" ").map(function(Ne){return function(Se,Le){return k("comp",Se),Se=function(Re,je){return Re.trim().split(/\s+/).map(function(Ce){return function(De,Ae){k("caret",De,Ae);var Ue=Ae?E[ce]:E[he];return De.replace(Ue,function(Fe,be,Pe,Ie,Oe){var ze;return k("caret",De,Fe,be,Pe,Ie,Oe),me(be)?ze="":me(Pe)?ze=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?ze=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Oe?(k("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+Oe+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+Oe+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+Oe+" <"+(+be+1)+".0.0"):(k("no pr"),ze=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ie+" <"+be+"."+Pe+"."+(+Ie+1):">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",ze),ze})}(Ce,je)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Re,je){return Re.trim().split(/\s+/).map(function(Ce){return function(De,Ae){var Ue=Ae?E[se]:E[Q];return De.replace(Ue,function(Fe,be,Pe,Ie,Oe){var ze;return k("tilde",De,Fe,be,Pe,Ie,Oe),me(be)?ze="":me(Pe)?ze=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?ze=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Oe?(k("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),ze=">="+be+"."+Pe+"."+Ie+Oe+" <"+be+"."+(+Pe+1)+".0"):ze=">="+be+"."+Pe+"."+Ie+" <"+be+"."+(+Pe+1)+".0",k("tilde return",ze),ze})}(Ce,je)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Re,je){return k("replaceXRanges",Re,je),Re.split(/\s+/).map(function(Ce){return function(De,Ae){De=De.trim();var Ue=Ae?E[L]:E[I];return De.replace(Ue,function(Fe,be,Pe,Ie,Oe,ze){k("xRange",De,Fe,be,Pe,Ie,Oe,ze);var qe=me(Pe),Me=qe||me(Ie),Te=Me||me(Oe);return be==="="&&Te&&(be=""),qe?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Me&&(Ie=0),Te&&(Oe=0),be===">"?(be=">=",Me?(Pe=+Pe+1,Ie=0,Oe=0):Te&&(Ie=+Ie+1,Oe=0)):be==="<="&&(be="<",Me?Pe=+Pe+1:Ie=+Ie+1),Fe=be+Pe+"."+Ie+"."+Oe):Me?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Te&&(Fe=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0"),k("xRange return",Fe),Fe})}(Ce,je)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Re,je){return k("replaceStars",Re,je),Re.trim().replace(E[Z],"")}(Se,Le),k("stars",Se),Se}(Ne,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Ne){return!!Ne.match(ge)})),ve=ve.map(function(Ne){return new pe(Ne,K)})},fe.prototype.intersects=function(W,K){if(!(W instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return W.set.some(function(ve){return ve.every(function(Ne){return ge.intersects(Ne,K)})})})})},e.toComparators=function(W,K){return new fe(W,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new C(W,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],W))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(W,K,ee){var ge=null,ve=null;try{var Ne=new fe(K,ee)}catch{return null}return W.forEach(function(Se){Ne.test(Se)&&(ge&&ve.compare(Se)!==-1||(ve=new C(ge=Se,ee)))}),ge},e.minSatisfying=function(W,K,ee){var ge=null,ve=null;try{var Ne=new fe(K,ee)}catch{return null}return W.forEach(function(Se){Ne.test(Se)&&(ge&&ve.compare(Se)!==1||(ve=new C(ge=Se,ee)))}),ge},e.validRange=function(W,K){try{return new fe(W,K).range||"*"}catch{return null}},e.ltr=function(W,K,ee){return ke(W,K,"<",ee)},e.gtr=function(W,K,ee){return ke(W,K,">",ee)},e.outside=ke,e.prerelease=function(W,K){var ee=_(W,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(W,K,ee){return W=new fe(W,ee),K=new fe(K,ee),W.intersects(K)},e.coerce=function(W){if(W instanceof C)return W;if(typeof W!="string")return null;var K=W.match(E[U]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function(J,e){var D,O,k=J.exports={};function j(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function E(g){if(D===setTimeout)return setTimeout(g,0);if((D===j||!D)&&setTimeout)return D=setTimeout,setTimeout(g,0);try{return D(g,0)}catch{try{return D.call(null,g,0)}catch{return D.call(this,g,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:j}catch{D=j}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var l,a=[],b=!1,v=-1;function d(){b&&l&&(b=!1,l.length?a=l.concat(a):v=-1,a.length&&p())}function p(){if(!b){var g=E(d);b=!0;for(var c=a.length;c;){for(l=a,a=[];++v<c;)l&&l[v].run();v=-1,c=a.length}l=null,b=!1,function(w){if(O===clearTimeout)return clearTimeout(w);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(w);try{O(w)}catch{try{return O.call(null,w)}catch{return O.call(this,w)}}}(g)}}function y(g,c){this.fun=g,this.array=c}function R(){}k.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)c[w-1]=arguments[w];a.push(new y(g,c)),a.length!==1||b||E(p)},y.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=R,k.addListener=R,k.once=R,k.off=R,k.removeListener=R,k.removeAllListeners=R,k.emit=R,k.prependListener=R,k.prependOnceListener=R,k.listeners=function(g){return[]},k.binding=function(g){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(g){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[76],re([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class O{constructor(E,l,a){this.level=E,this.key=l,this.value=a,this.forward=[]}}const k=void 0;class j{constructor(E,l=2**16){this.comparator=E,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(l)|0),this.e=new O(this.c,k,k)}get size(){return this.f}clear(){this.e=new O(this.c,k,k),this.f=0}has(E){return!!j.g(this,E,this.comparator)}get(E){return j.g(this,E,this.comparator)?.value}set(E,l){return j.h(this,E,l,this.comparator)&&(this.f+=1),this}delete(E){const l=j.k(this,E,this.comparator);return l&&(this.f-=1),l}forEach(E,l){let a=this.e.forward[0];for(;a;)E.call(l,a.value,a.key,this),a=a.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",l=this.e.forward[0];for(;l;)E+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return E}static g(E,l,a){let b=E.e;for(let v=E.d-1;v>=0;v--)for(;b.forward[v]&&a(b.forward[v].key,l)<0;)b=b.forward[v];if(b=b.forward[0],b&&a(b.key,l)===0)return b}static h(E,l,a,b){const v=[];let d=E.e;for(let p=E.d-1;p>=0;p--){for(;d.forward[p]&&b(d.forward[p].key,l)<0;)d=d.forward[p];v[p]=d}if(d=d.forward[0],d&&b(d.key,l)===0)return d.value=a,!1;{const p=j.j(E);if(p>E.d){for(let y=E.d;y<p;y++)v[y]=E.e;E.d=p}d=new O(p,l,a);for(let y=0;y<p;y++)d.forward[y]=v[y].forward[y],v[y].forward[y]=d;return!0}}static j(E,l=.5){let a=1;for(;Math.random()<l&&a<E.c;)a+=1;return a}static k(E,l,a){const b=[];let v=E.e;for(let d=E.d-1;d>=0;d--){for(;v.forward[d]&&a(v.forward[d].key,l)<0;)v=v.forward[d];b[d]=v}if(v=v.forward[0],!v||a(v.key,l)!==0)return!1;for(let d=0;d<E.d&&b[d].forward[d]===v;d++)b[d].forward[d]=v.forward[d];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$gs=j}),define(ne[46],re([0,1,8,2]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=k,e.$ge=j,e.$he=N,e.$ie=E,e.$je=a,e.$ke=b,e.$le=v,e.$me=d,e.$ne=p,e.$oe=y,e.$pe=R,e.$qe=g,e.$re=c,e.$se=w,e.$te=$;function k(h){const m=h;return m?typeof m.read=="function":!1}function j(h){const m=h;return m?[m.on,m.pause,m.resume,m.destroy].every(i=>typeof i=="function"):!1}function N(h){const m=h;return m?j(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}function E(h,m){return new l(h,m)}class l{constructor(m,i){this.e=m,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(i=>i(m))}h(m){this.c.error.length===0?(0,D.$1)(m):this.c.error.slice(0).forEach(i=>i(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,i){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(m,i){if(this.a.destroyed)return;let r;switch(m){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,m){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return m(i)}function b(h,m,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}function v(h,m){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{m&&t.push(n)},onError:n=>{m?r(n):i(void 0)},onEnd:()=>{i(m?m(t):void 0)}})})}function d(h,m,i){h.on("error",r=>{i?.isCancellationRequested||m.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||m.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||m.onData(r)})}function p(h,m){return new Promise((i,r)=>{const t=new O.$Tc,n=[],s=S=>{if(n.push(S),n.length>m)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=S=>(t.dispose(),r(S)),u=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,O.$Sc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,O.$Sc)(()=>h.removeListener("end",u))),h.on("end",u),t.add((0,O.$Sc)(()=>h.removeListener("data",s))),h.on("data",s)})}function y(h,m){const i=E(m);return i.end(h),i}function R(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}function g(h){let m=!1;return{read:()=>m?null:(m=!0,h)}}function c(h,m,i){const r=E(i);return d(h,{onData:t=>r.write(m.data(t)),onError:t=>r.error(m.error?m.error(t):t),onEnd:()=>r.end()}),r}function w(h,m,i){let r=!1;return{read:()=>{const t=m.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}function $(h,m,i){let r=!1;const t=E(i);return d(m,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}}),define(ne[14],re([0,1,168,46]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=a,e.$we=b,e.$xe=v,e.$ye=d,e.$ze=p,e.$Ae=y,e.$Be=R,e.$Ce=g,e.$De=c,e.$Ee=w,e.$Fe=$,e.$Ge=h,e.$He=m,e.$Ie=i,e.$Je=r,e.$Ke=t,e.$Le=n,e.$Me=s,e.$Ne=o,e.$Oe=I;const k=typeof Buffer<"u",j=new D.$V(()=>new Uint8Array(256));let N,E;class l{static alloc(U){return k?new l(Buffer.allocUnsafe(U)):new l(new Uint8Array(U))}static wrap(U){return k&&!Buffer.isBuffer(U)&&(U=Buffer.from(U.buffer,U.byteOffset,U.byteLength)),new l(U)}static fromString(U,z){return!(z?.dontUseNodeBuffer||!1)&&k?new l(Buffer.from(U)):(N||(N=new TextEncoder),new l(N.encode(U)))}static fromByteArray(U){const z=l.alloc(U.length);for(let V=0,Q=U.length;V<Q;V++)z.buffer[V]=U[V];return z}static concat(U,z){if(typeof z>"u"){z=0;for(let se=0,te=U.length;se<te;se++)z+=U[se].byteLength}const V=l.alloc(z);let Q=0;for(let se=0,te=U.length;se<te;se++){const ue=U[se];V.set(ue,Q),Q+=ue.byteLength}return V}constructor(U){this.buffer=U,this.byteLength=this.buffer.byteLength}clone(){const U=l.alloc(this.byteLength);return U.set(this),U}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(U,z){return new l(this.buffer.subarray(U,z))}set(U,z){if(U instanceof l)this.buffer.set(U.buffer,z);else if(U instanceof Uint8Array)this.buffer.set(U,z);else if(U instanceof ArrayBuffer)this.buffer.set(new Uint8Array(U),z);else if(ArrayBuffer.isView(U))this.buffer.set(new Uint8Array(U.buffer,U.byteOffset,U.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(U){return d(this.buffer,U)}writeUInt32BE(U,z){p(this.buffer,U,z)}readUInt32LE(U){return y(this.buffer,U)}writeUInt32LE(U,z){R(this.buffer,U,z)}readUInt8(U){return g(this.buffer,U)}writeUInt8(U,z){c(this.buffer,U,z)}indexOf(U,z=0){return a(this.buffer,U instanceof l?U.buffer:U,z)}}e.$ue=l;function a(L,U,z=0){const V=U.byteLength,Q=L.byteLength;if(V===0)return 0;if(V===1)return L.indexOf(U[0]);if(V>Q-z)return-1;const se=j.value;se.fill(U.length);for(let ce=0;ce<U.length;ce++)se[U[ce]]=U.length-ce-1;let te=z+U.length-1,ue=te,he=-1;for(;te<Q;)if(L[te]===U[ue]){if(ue===0){he=te;break}te--,ue--}else te+=Math.max(U.length-ue,se[L[te]]),ue=U.length-1;return he}function b(L,U){return L[U+0]<<0>>>0|L[U+1]<<8>>>0}function v(L,U,z){L[z+0]=U&255,U=U>>>8,L[z+1]=U&255}function d(L,U){return L[U]*2**24+L[U+1]*2**16+L[U+2]*2**8+L[U+3]}function p(L,U,z){L[z+3]=U,U=U>>>8,L[z+2]=U,U=U>>>8,L[z+1]=U,U=U>>>8,L[z]=U}function y(L,U){return L[U+0]<<0>>>0|L[U+1]<<8>>>0|L[U+2]<<16>>>0|L[U+3]<<24>>>0}function R(L,U,z){L[z+0]=U&255,U=U>>>8,L[z+1]=U&255,U=U>>>8,L[z+2]=U&255,U=U>>>8,L[z+3]=U&255}function g(L,U){return L[U]}function c(L,U,z){L[z]=U}function w(L){return O.$je(L,U=>l.concat(U))}function $(L){return O.$qe(L)}function h(L){return O.$le(L,U=>l.concat(U))}async function m(L){return L.ended?l.concat(L.buffer):l.concat([...L.buffer,await h(L.stream)])}function i(L){return O.$oe(L,U=>l.concat(U))}function r(L){return O.$re(L,{data:U=>typeof U=="string"?l.fromString(U):l.wrap(U)},U=>l.concat(U))}function t(L){return O.$ie(U=>l.concat(U),L)}function n(L,U){return O.$se(L,U,z=>l.concat(z))}function s(L,U){return O.$te(L,U,z=>l.concat(z))}function o(L){let U=0,z=0,V=0;const Q=new Uint8Array(Math.floor(L.length/4*3)),se=ue=>{switch(z){case 3:Q[V++]=U|ue,z=0;break;case 2:Q[V++]=U|ue>>>2,U=ue<<6,z=3;break;case 1:Q[V++]=U|ue>>>4,U=ue<<4,z=2;break;default:U=ue<<2,z=1}};for(let ue=0;ue<L.length;ue++){const he=L.charCodeAt(ue);if(he>=65&&he<=90)se(he-65);else if(he>=97&&he<=122)se(he-97+26);else if(he>=48&&he<=57)se(he-48+52);else if(he===43||he===45)se(62);else if(he===47||he===95)se(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ue]}`)}}const te=V;for(;z>0;)se(0);return l.wrap(Q).slice(0,te)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:L},U=!0,z=!1){const V=z?S:u;let Q="";const se=L.byteLength%3;let te=0;for(;te<L.byteLength-se;te+=3){const ue=L[te+0],he=L[te+1],ce=L[te+2];Q+=V[ue>>>2],Q+=V[(ue<<4|he>>>4)&63],Q+=V[(he<<2|ce>>>6)&63],Q+=V[ce&63]}if(se===1){const ue=L[te+0];Q+=V[ue>>>2],Q+=V[ue<<4&63],U&&(Q+="==")}else if(se===2){const ue=L[te+0],he=L[te+1];Q+=V[ue>>>2],Q+=V[(ue<<4|he>>>4)&63],Q+=V[he<<2&63],U&&(Q+="=")}return Q}}),define(ne[43],re([0,1,30]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=O,e.$9i=k,e.$0i=j,e.$$i=E,e.$aj=R;function O(c){return k(c,0)}function k(c,w){switch(typeof c){case"object":return c===null?j(349,w):Array.isArray(c)?l(c,w):a(c,w);case"string":return E(c,w);case"boolean":return N(c,w);case"number":return j(c,w);case"undefined":return j(937,w);default:return j(617,w)}}function j(c,w){return(w<<5)-w+c|0}function N(c,w){return j(c?433:863,w)}function E(c,w){w=j(149417,w);for(let $=0,h=c.length;$<h;$++)w=j(c.charCodeAt($),w);return w}function l(c,w){return w=j(104579,w),c.reduce(($,h)=>k(h,$),w)}function a(c,w){return w=j(181387,w),Object.keys(c).sort().reduce(($,h)=>($=E(h,$),k(c[h],$)),w)}class b{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=k(w,this.g),this.g}}e.$_i=b;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function d(c,w,$=32){const h=$-w,m=~((1<<h)-1);return(c<<w|(m&c)>>>h)>>>0}function p(c,w=0,$=c.byteLength,h=0){for(let m=0;m<$;m++)c[w+m]=h}function y(c,w,$="0"){for(;c.length<w;)c=$+c;return c}function R(c,w=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),w/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const $=w.length;if($===0)return;const h=this.p;let m=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=w.charCodeAt(0),t=0);;){let n=r;if(D.$pf(r))if(t+1<$){const s=w.charCodeAt(t+1);D.$qf(s)?(t++,n=D.$rf(r,s)):n=65533}else{i=r;break}else D.$qf(r)&&(n=65533);if(m=this.w(h,m,n),t++,t<$)r=w.charCodeAt(t);else break}this.r=m,this.u=i}w(w,$,h){return h<128?w[$++]=h:h<2048?(w[$++]=192|(h&1984)>>>6,w[$++]=128|(h&63)>>>0):h<65536?(w[$++]=224|(h&61440)>>>12,w[$++]=128|(h&4032)>>>6,w[$++]=128|(h&63)>>>0):(w[$++]=240|(h&1835008)>>>18,w[$++]=128|(h&258048)>>>12,w[$++]=128|(h&4032)>>>6,w[$++]=128|(h&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,w[0]=w[64],w[1]=w[65],w[2]=w[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,$=this.q;for(let u=0;u<64;u+=4)w.setUint32(u,$.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)w.setUint32(u,d(w.getUint32(u-12,!1)^w.getUint32(u-32,!1)^w.getUint32(u-56,!1)^w.getUint32(u-64,!1),1),!1);let h=this.h,m=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let u=0;u<80;u++)u<20?(n=m&i|~m&r,s=1518500249):u<40?(n=m^i^r,s=1859775393):u<60?(n=m&i|m&r|i&r,s=2400959708):(n=m^i^r,s=3395469782),o=d(h,5)+n+t+s+w.getUint32(u*4,!1)&4294967295,t=r,r=i,i=d(m,30),m=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+m&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$bj=g}),define(ne[54],re([0,1,30]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const j="error",N="warning",E="warn",l="info",a="ignore";function b(d){return d?D.$lf(j,d)?k.Error:D.$lf(N,d)||D.$lf(E,d)?k.Warning:D.$lf(l,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=b;function v(d){switch(d){case k.Error:return j;case k.Warning:return N;case k.Info:return l;default:return a}}k.toString=v}(O||(O={})),e.default=O}),define(ne[27],re([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=O,e.$On=k,e.$Pn=N,e.$Qn=l,e.$Rn=a,e.$Sn=b,e.$Tn=v,e.$Un=d,e.$Vn=p,e.$Wn=y,e.$Xn=R,e.$Yn=g;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const w=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,h])=>{w[$]=h&&typeof h=="object"?O(h):h}),w}function k(c){if(!c||typeof c!="object")return c;const w=[c];for(;w.length>0;){const $=w.shift();Object.freeze($);for(const h in $)if(j.call($,h)){const m=$[h];typeof m=="object"&&!Object.isFrozen(m)&&!(0,D.$Xf)(m)&&w.push(m)}}return c}const j=Object.prototype.hasOwnProperty;function N(c,w){return E(c,w,new Set)}function E(c,w,$){if((0,D.$4f)(c))return c;const h=w(c);if(typeof h<"u")return h;if(Array.isArray(c)){const m=[];for(const i of c)m.push(E(i,w,$));return m}if((0,D.$Wf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const m={};for(const i in c)j.call(c,i)&&(m[i]=E(c[i],w,$));return $.delete(c),m}return c}function l(c,w,$=!0){return(0,D.$Wf)(c)?((0,D.$Wf)(w)&&Object.keys(w).forEach(h=>{h in c?$&&((0,D.$Wf)(c[h])&&(0,D.$Wf)(w[h])?l(c[h],w[h],$):c[h]=w[h]):c[h]=w[h]}),c):w}function a(c,w){if(c===w)return!0;if(c==null||w===null||w===void 0||typeof c!=typeof w||typeof c!="object"||Array.isArray(c)!==Array.isArray(w))return!1;let $,h;if(Array.isArray(c)){if(c.length!==w.length)return!1;for($=0;$<c.length;$++)if(!a(c[$],w[$]))return!1}else{const m=[];for(h in c)m.push(h);m.sort();const i=[];for(h in w)i.push(h);if(i.sort(),!a(m,i))return!1;for($=0;$<m.length;$++)if(!a(c[m[$]],w[m[$]]))return!1}return!0}function b(c){const w=new Set;return JSON.stringify(c,($,h)=>{if((0,D.$Wf)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}function v(c,w){const $=Object.create(null);return!c||!w||Object.keys(w).forEach(m=>{const i=c[m],r=w[m];a(i,r)||($[m]=r)}),$}function d(c,w){const $=w.toLowerCase(),h=Object.keys(c).find(m=>m.toLowerCase()===$);return h?c[h]:c[w]}function p(c,w){const $=Object.create(null);for(const[h,m]of Object.entries(c))w(h,m)&&($[h]=m);return $}function y(c){let w=[];for(;Object.prototype!==c;)w=w.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return w}function R(c){const w=[];for(const $ of y(c))typeof c[$]=="function"&&w.push($);return w}function g(c,w){const $=m=>function(){const i=Array.prototype.slice.call(arguments,0);return w(m,i)},h={};for(const m of c)h[m]=$(m);return h}}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=O;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return D.test(k)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let l=0;l<E.length;l++)E[l]=Math.floor(Math.random()*256);return E};const j=new Uint8Array(16),N=[];for(let E=0;E<256;E++)N.push(E.toString(16).padStart(2,"0"));return function(){k(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let l=0,a="";return a+=N[j[l++]],a+=N[j[l++]],a+=N[j[l++]],a+=N[j[l++]],a+="-",a+=N[j[l++]],a+=N[j[l++]],a+="-",a+=N[j[l++]],a+=N[j[l++]],a+="-",a+=N[j[l++]],a+=N[j[l++]],a+="-",a+=N[j[l++]],a+=N[j[l++]],a+=N[j[l++]],a+=N[j[l++]],a+=N[j[l++]],a+=N[j[l++]],a}}()}),define(ne[77],re([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=j;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const E=N.replace(/\-/g,":").toLowerCase();return!O.has(E)}function j(){const N=(0,D.networkInterfaces)();for(const E in N){const l=N[E];if(l){for(const{mac:a}of l)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[78],re([7,4]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[79],re([0,1,78]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=a,e.$Nm=b,e.$Om=v;const O=60,k=O*60,j=k*24,N=j*7,E=j*30,l=j*365;function a(d,p,y,R){typeof d!="number"&&(d=d.getTime());const g=Math.round((new Date().getTime()-d)/1e3);if(g<-30)return(0,D.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!R&&g<30)return(0,D.localize)(1,null);let c;return g<O?(c=g,p?c===1?y?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):y?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c):c===1?y?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):y?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):g<k?(c=Math.floor(g/O),p?c===1?y?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):y?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c):c===1?y?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):y?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):g<j?(c=Math.floor(g/k),p?c===1?y?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):y?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c):c===1?y?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):y?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):g<N?(c=Math.floor(g/j),p?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c)):g<E?(c=Math.floor(g/N),p?c===1?y?(0,D.localize)(30,null,c):(0,D.localize)(31,null,c):y?(0,D.localize)(32,null,c):(0,D.localize)(33,null,c):c===1?y?(0,D.localize)(34,null,c):(0,D.localize)(35,null,c):y?(0,D.localize)(36,null,c):(0,D.localize)(37,null,c)):g<l?(c=Math.floor(g/E),p?c===1?y?(0,D.localize)(38,null,c):(0,D.localize)(39,null,c):y?(0,D.localize)(40,null,c):(0,D.localize)(41,null,c):c===1?y?(0,D.localize)(42,null,c):(0,D.localize)(43,null,c):y?(0,D.localize)(44,null,c):(0,D.localize)(45,null,c)):(c=Math.floor(g/l),p?c===1?y?(0,D.localize)(46,null,c):(0,D.localize)(47,null,c):y?(0,D.localize)(48,null,c):(0,D.localize)(49,null,c):c===1?y?(0,D.localize)(50,null,c):(0,D.localize)(51,null,c):y?(0,D.localize)(52,null,c):(0,D.localize)(53,null,c))}function b(d,p){const y=Math.abs(d/1e3);return y<1?p?(0,D.localize)(54,null,d):(0,D.localize)(55,null,d):y<O?p?(0,D.localize)(56,null,Math.round(d)/1e3):(0,D.localize)(57,null,Math.round(d)/1e3):y<k?p?(0,D.localize)(58,null,Math.round(d/(1e3*O))):(0,D.localize)(59,null,Math.round(d/(1e3*O))):y<j?p?(0,D.localize)(60,null,Math.round(d/(1e3*k))):(0,D.localize)(61,null,Math.round(d/(1e3*k))):(0,D.localize)(62,null,Math.round(d/(1e3*j)))}function v(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[80],re([7,4]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,80]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=l,e.$6i=a,e.$7i=b;function j(v,d){return d&&(v.stack||v.stacktrace)?k.localize(0,null,E(v),N(v.stack)||N(v.stacktrace)):E(v)}function N(v){return Array.isArray(v)?v.join(`
`):v}function E(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function l(v=null,d=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const p=D.$Hb(v),y=l(p[0],d);return p.length>1?k.localize(4,null,y,p.length):y}if(O.$Uf(v))return v;if(v.detail){const p=v.detail;if(p.error)return j(p.error,d);if(p.exception)return j(p.exception,d)}return v.stack?j(v,d):v.message?v.message:k.localize(5,null)}function a(v){const d=v;return d instanceof Error&&Array.isArray(d.actions)}function b(v,d){let p;return typeof v=="string"?p=new Error(v):p=v,p.actions=d,p}}),define(ne[81],re([7,4]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[82],re([0,1,81]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=O;function O(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ne[55],re([0,1,12]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=j,e.$$l=N;var O;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(O||(e.Source=O={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function j(E,...l){const a=l.reduce((d,p)=>(d[p]=!0,d),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(d=>!a[d]).forEach(d=>{for(let p=0;p<b.length;p++)if(d.search(b[p])!==-1){delete E[d];break}})}function N(E){E&&(delete E.DEBUG,D.$j&&delete E.DYLD_LIBRARY_PATH,D.$k&&delete E.LD_PRELOAD)}}),define(ne[83],re([0,1,11]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=O,e.$Eq=k,e.$Fq=j,e.log=E;function O(a){const b=a;return b&&typeof b.type=="string"&&typeof b.severity=="string"}function k(a){const b=[];let v;try{const d=JSON.parse(a.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),v=p.__$stack),b.push(...d)}catch{b.push("Unable to log remote console arguments",a.arguments)}return{args:b,stack:v}}function j(a){if(typeof a!="string")return j(k(a).stack);const b=a;if(b){const v=N(b),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function N(a){if(!a)return a;const b=a.indexOf(`
`);return b===-1?a:a.substring(0,b)}function E(a,b){const{args:v,stack:d}=k(a),p=typeof v[0]=="string"&&v.length===1;let y=N(d);y&&(y=`(${y.trim()})`);let R=[];if(typeof v[0]=="string"?y&&p?R=[`%c[${b}] %c${v[0]} %c${y}`,l("blue"),l(""),l("grey")]:R=[`%c[${b}] %c${v[0]}`,l("blue"),l(""),...v.slice(1)]:R=[`%c[${b}]%`,l("blue"),...v],y&&!p&&R.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function l(a){return`color: ${a}`}}),define(ne[47],re([0,1,14,11]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=k,e.$Ph=j,e.$Qh=E;function k(l){return JSON.stringify(l,N)}function j(l){let a=JSON.parse(l);return a=E(a),a}function N(l,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return O.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof D.$ue||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let b=0;b<l.length;++b)l[b]=E(l[b],a+1);else for(const b in l)Object.hasOwnProperty.call(l,b)&&(l[b]=E(l[b],a+1))}return l}}),define(ne[84],re([0,1,71,15,12,11]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CD=b;class N{constructor(d,p,y){this.id=d,this.dependencies=p,this.callback=y}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,p,y)=>{typeof d!="string"&&(y=p,p=d,d=null),(typeof p!="object"||!Array.isArray(p))&&(y=p,p=null),this.c.push(new N(d,p,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const p=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!p)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(d){return new Promise((p,y)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const g=()=>{R.removeEventListener("load",c),R.removeEventListener("error",w)},c=$=>{g(),p(this.c.pop())},w=$=>{g(),y($)};R.addEventListener("load",c),R.addEventListener("error",w),this.f&&(d=this.f.createScriptURL(d)),R.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(d){return new Promise((p,y)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),p(this.c.pop())}catch(R){y(R)}})}async j(d){try{const p=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,g=j.URI.parse(d).fsPath,c=p.readFileSync(g).toString(),w=R.wrap(c.replace(/^#!.*/,""));return new y.Script(w).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const l=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function b(v,d,p){if(D.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const y=`${v}/${d}`;if(l.has(y))return l.get(y);let R;if(/^\w[\w\d+.-]*:\/\//.test(y))R=y;else{const $=`${p&&!k.$o?O.$yg:O.$xg}/${y}`;R=O.$Bg.asBrowserUri($).toString(!0)}const g=E.INSTANCE.load(R);return l.set(y,g),g}else return await new Promise((y,R)=>{J([v],y,R)})}}),define(ne[85],re([0,1,33,48,28,77,12]),function(J,e,D,O,k,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$qn=l,e.$rn=v,e.$pn=new class{c(d){return this.a||(this.a=O.$ni.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,p=0;const y=(0,D.networkInterfaces)();for(const R in y){const g=y[R];if(g)for(const{mac:c,internal:w}of g)w||(p+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=p>0?d/p:0}return this.b}};let E;async function l(d){return E||(E=(async()=>await a(d)||k.$Dg())()),E}async function a(d){try{const p=await new Promise((R,g)=>{J(["crypto"],R,g)}),y=(0,j.$on)();return p.createHash("sha256").update(y,"utf8").digest("hex")}catch(p){d(p);return}}const b="Software\\Microsoft\\SQMClient";async function v(d){if(N.$i){const p=await new Promise((y,R)=>{J(["@vscode/windows-registry"],y,R)});try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",b,"MachineId")||""}catch(y){return d(y),""}}return""}}),define(ne[86],re([0,1,33,16,24]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=w,e.$9l=$;const j=/^\d+$/,N=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var l;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(l||(l={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(m,i,r){this.exePath=m,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:h=!1,findPreview:m=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=O.$kc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const u of await k.Promises.readdir(r)){let S=-1;if(m){const L=u.indexOf("-");if(L<0)continue;const U=u.substring(0,L);if(!j.test(U)||u.substring(L+1)!=="preview")continue;S=parseInt(U,10)}else{if(!j.test(u))continue;S=parseInt(u,10)}if(S<=t)continue;const I=O.$kc(r,u,"pwsh.exe");await k.SymlinkSupport.existsFile(I)&&(n=I,t=S)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=m?" Preview":"";return new v(n,`PowerShell${o}${s}`,!0)}async function y({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const m=O.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(m))if(i.test(t)){const n=O.$kc(m,t,"pwsh.exe");return new v(n,r)}return null}function R(){const h=O.$kc(D.homedir(),".dotnet","tools","pwsh.exe");return new v(h,".NET Core PowerShell Global Tool")}function g(){const h=O.$kc(process.env.windir,a===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(h,"Windows PowerShell",!0)}async function*c(){let h=await p();h&&(yield h),h=await p({useAlternateBitness:!0}),h&&(yield h),h=await y(),h&&(yield h),h=R(),h&&(yield h),h=await p({findPreview:!0}),h&&(yield h),h=await y({findPreview:!0}),h&&(yield h),h=await p({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=g(),h&&(yield h)}async function*w(){for await(const h of c())await h.exists()&&(yield h)}async function $(){for await(const h of w())return h;return null}}),define(ne[56],re([0,1,16,12,35,55,3,24]),function(J,e,D,O,k,j,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=l,e.$am=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function l(v=k.env){return v.comspec||"cmd.exe"}function a(v){let d=[],p=!1;const y=function(R){if(p){d.push(R);return}(!v.send(R,c=>{if(c&&console.error(c),p=!1,d.length>0){const w=d.slice(0);d=[],w.forEach($=>y($))}})||O.$i)&&(p=!0)};return{send:y}}var b;(function(v){async function d(p,y,R){if(D.$jc(p))return p;if(y===void 0&&(y=k.cwd()),D.$nc(p)!=="."||(R===void 0&&N.$Uf(k.env.PATH)&&(R=k.env.PATH.split(D.$uc)),R===void 0||R.length===0))return D.$kc(y,p);async function c(w){if(await E.Promises.exists(w)){let $;try{$=await E.Promises.stat(w)}catch(h){h.message.startsWith("EACCES")&&($=await E.Promises.lstat(w))}return $?!$.isDirectory():!1}return!1}for(const w of R){let $;if(D.$jc(w)?$=D.$kc(w,p):$=D.$kc(y,w,p),await c($))return $;let h=$+".com";if(await c(h)||(h=$+".exe",await c(h)))return h}return D.$kc(y,p)}v.findExecutable=d})(b||(e.win32=b={}))}),define(ne[87],re([0,1,33,12,86,56]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=N;async function N(v,d){return v===1?O.$i?b():j.$_l(d):l(v,d)}let E=null;function l(v,d){if(O.$k&&v===2||O.$j&&v===3)return"/bin/bash";if(!E){let p;if(O.$i)p="/bin/bash";else{if(p=d.SHELL,!p)try{p=(0,D.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}E=p}return E}let a=null;async function b(){return a||(a=(await(0,k.$9l)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,D,O){var k=arguments.length,j=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(J,e,D,O);else for(var E=J.length-1;E>=0;E--)(N=J[E])&&(j=(k<3?N(j):k>3?N(e,D,j):N(e,D))||j);return k>3&&j&&Object.defineProperty(e,D,j),j};define(ne[57],re([0,1,19,9,14,20,53,8,5,2,47,30,3]),function(J,e,D,O,k,j,N,E,l,a,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=o,e.$Uh=u,e.$Zh=V,e.$1h=Q;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p||(p={}));function y(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(R||(R={}));function g(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(c||(c={}));function w(q){let T=0;for(let x=0;;x+=7){const Z=q.read(1);if(T|=(Z.buffer[0]&127)<<x,!(Z.buffer[0]&128))return T}}const $=t(0);function h(q,T){if(T===0){q.write($);return}let x=0;for(let Y=T;Y!==0;Y=Y>>>7)x++;const Z=k.$ue.alloc(x);for(let Y=0;T!==0;Y++)Z.buffer[Y]=T&127,T=T>>>7,T>0&&(Z.buffer[Y]|=128);q.write(Z)}class m{constructor(T){this.b=T,this.a=0}read(T){const x=this.b.slice(this.a,this.a+T);return this.a+=x.byteLength,x}}e.$Rh=m;class i{constructor(){this.a=[]}get buffer(){return k.$ue.concat(this.a)}write(T){this.a.push(T)}}e.$Sh=i;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const T=k.$ue.alloc(1);return T.writeUInt8(q,0),T}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(q,T){if(typeof T>"u")q.write(n.Undefined);else if(typeof T=="string"){const x=k.$ue.fromString(T);q.write(n.String),h(q,x.byteLength),q.write(x)}else if(s&&Buffer.isBuffer(T)){const x=k.$ue.wrap(T);q.write(n.Buffer),h(q,x.byteLength),q.write(x)}else if(T instanceof k.$ue)q.write(n.VSBuffer),h(q,T.byteLength),q.write(T);else if(Array.isArray(T)){q.write(n.Array),h(q,T.length);for(const x of T)o(q,x)}else if(typeof T=="number"&&(T|0)===T)q.write(n.Uint),h(q,T);else{const x=k.$ue.fromString(JSON.stringify(T));q.write(n.Object),h(q,x.byteLength),q.write(x)}}function u(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(w(q)).toString();case r.Buffer:return q.read(w(q)).buffer;case r.VSBuffer:return q.read(w(q));case r.Array:{const x=w(q),Z=[];for(let Y=0;Y<x;Y++)Z.push(u(q));return Z}case r.Object:return JSON.parse(q.read(w(q)).toString());case r.Int:return w(q)}}class S{constructor(T,x,Z=null,Y=1e3){this.h=T,this.j=x,this.k=Z,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,x){this.b.set(T,x),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const x=this.o([T.type]);this.k?.logOutgoing(x,0,1,g(T.type));return}case 201:case 202:case 204:case 203:{const x=this.o([T.type,T.id],T.data);this.k?.logOutgoing(x,T.id,1,g(T.type),T.data);return}}}o(T,x=void 0){const Z=new i;return o(Z,T),o(Z,x),this.p(Z.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const x=new m(T),Z=u(x),Y=u(x),_=Z[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Z[1],1,`${y(_)}: ${Z[2]}.${Z[3]}`,Y),this.s({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case 102:return this.k?.logIncoming(T.byteLength,Z[1],1,`${y(_)}: ${Z[2]}.${Z[3]}`,Y),this.t({type:_,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case 101:return this.k?.logIncoming(T.byteLength,Z[1],1,`${y(_)}`),this.u({type:_,id:Z[1]});case 103:return this.k?.logIncoming(T.byteLength,Z[1],1,`${y(_)}`),this.u({type:_,id:Z[1]})}}s(T){const x=this.b.get(T.channelName);if(!x){this.v(T);return}const Z=new j.$ee;let Y;try{Y=x.call(this.j,T.name,T.arg,Z.token)}catch(F){Y=Promise.reject(F)}const _=T.id;Y.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{C.dispose(),this.d.delete(T.id)});const C=(0,a.$Sc)(()=>Z.cancel());this.d.set(T.id,C)}t(T){const x=this.b.get(T.channelName);if(!x){this.v(T);return}const Z=T.id,_=x.listen(this.j,T.name,T.arg)(C=>this.m({id:Z,data:C,type:204}));this.d.set(T.id,_)}u(T){const x=this.d.get(T.id);x&&(x.dispose(),this.d.delete(T.id))}v(T){let x=this.g.get(T.channelName);x||(x=[],this.g.set(T.channelName,x));const Z=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:T,timeoutTimer:Z})}w(T){const x=this.g.get(T);if(x){for(const Z of x)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=S;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class L{constructor(T,x=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=x}getChannel(T){const x=this;return{call(Z,Y,_){return x.a?Promise.reject(new E.$5):x.m(T,Z,Y,_)},listen(Z,Y){return x.a?l.Event.None:x.o(T,Z,Y)}}}m(T,x,Z,Y=j.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:T,name:x,arg:Z};if(Y.isCancellationRequested)return Promise.reject(new E.$5);let f;return new Promise((A,M)=>{if(Y.isCancellationRequested)return M(new E.$5);const H=()=>{const le=pe=>{switch(pe.type){case 201:this.f.delete(_),A(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,M(ye);break}case 203:this.f.delete(_),M(pe.data);break}};this.f.set(_,le),this.p(F)};let G=null;this.b===c.Idle?H():(G=(0,O.$7g)(le=>this.u()),G.then(()=>{G=null,H()}));const ie=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),M(new E.$5)},ae=Y.onCancellationRequested(ie);f=(0,a.$Rc)((0,a.$Sc)(ie),ae),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(T,x,Z){const Y=this.g++,C={id:Y,type:102,channelName:T,name:x,arg:Z};let F=null;const f=new l.$7d({onWillAddFirstListener:()=>{F=(0,O.$7g)(A=>this.u()),F.then(()=>{F=null,this.d.add(f),this.p(C)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(f),this.p({id:Y,type:103}))}}),P=A=>f.fire(A.data);return this.f.set(Y,P),f.event}p(T){switch(T.type){case 100:case 102:{const x=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(x,T.id,0,`${y(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const x=this.q([T.type,T.id]);this.j?.logOutgoing(x,T.id,0,y(T.type));return}}}q(T,x=void 0){const Z=new i;return o(Z,T),o(Z,x),this.r(Z.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const x=new m(T),Z=u(x),Y=u(x),_=Z[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,g(_)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Z[1],0,g(_),Y),this.t({type:Z[0],id:Z[1],data:Y})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=L,$e([N.$Lh],L.prototype,"onDidInitializePromise",null);class U{get connections(){const T=[];return this.f.forEach(x=>T.push(x)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new l.$7d,this.onDidAddConnection=this.g.event,this.h=new l.$7d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(T(({protocol:x,onDidClientDisconnect:Z})=>{const Y=l.Event.once(x.onMessage);this.j.add(Y(_=>{const C=new m(_),F=u(C),f=new S(x,F),P=new L(x);this.a.forEach((M,H)=>f.registerChannel(H,M));const A={channelServer:f,channelClient:P,ctx:F};this.f.add(A),this.g.fire(A),this.j.add(Z(()=>{f.dispose(),P.dispose(),this.f.delete(A),this.h.fire(A)}))}))}))}getChannel(T,x){const Z=this;return{call(Y,_,C){let F;if((0,d.$9f)(x)){const P=(0,D.$4b)(Z.connections.filter(x));F=P?Promise.resolve(P):l.Event.toPromise(l.Event.filter(Z.onDidAddConnection,x))}else F=x.routeCall(Z,Y,_);const f=F.then(P=>P.channelClient.getChannel(T));return V(f).call(Y,_,C)},listen(Y,_){if((0,d.$9f)(x))return Z.k(T,x,Y,_);const C=x.routeEvent(Z,Y,_).then(F=>F.channelClient.getChannel(T));return V(C).listen(Y,_)}}}k(T,x,Z,Y){const _=this;let C;const F=new l.$7d({onWillAddFirstListener:()=>{C=new a.$Tc;const f=new l.$ae,P=new Map,A=H=>{const ie=H.channelClient.getChannel(T).listen(Z,Y),ae=f.add(ie);P.set(H,ae)},M=H=>{const G=P.get(H);G&&(G.dispose(),P.delete(H))};_.connections.filter(x).forEach(A),l.Event.filter(_.onDidAddConnection,x)(A,void 0,C),_.onDidRemoveConnection(M,void 0,C),f.event(F.fire,F,C),C.add(f)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return F.event}registerChannel(T,x){this.a.set(T,x);for(const Z of this.f)Z.channelServer.registerChannel(T,x)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=U;class z{constructor(T,x,Z=null){const Y=new i;o(Y,x),T.send(Y.buffer),this.a=new L(T,Z),this.d=new S(T,x,Z)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,x){this.d.registerChannel(T,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=z;function V(q){return{call(T,x,Z){return q.then(Y=>Y.call(T,x,Z))},listen(T,x){const Z=new l.$de;return q.then(Y=>Z.input=Y.listen(T,x)),Z.event}}}function Q(q){let T=!1;return{call(x,Z,Y){return T?q.call(x,Z,Y):(0,O.$ih)(0).then(()=>T=!0).then(()=>q.call(x,Z,Y))},listen(x,Z){if(T)return q.listen(x,Z);const Y=new l.$de;return(0,O.$ih)(0).then(()=>T=!0).then(()=>Y.input=q.listen(x,Z)),Y.event}}}class se{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const x of T.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await l.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$2h=se;var te;(function(q){function T(_,C,F){const f=_,P=F&&F.disableMarshalling,A=new Map;for(const M in f)Z(M)&&A.set(M,l.Event.buffer(f[M],!0,void 0,C));return new class{listen(M,H,G){const ie=A.get(H);if(ie)return ie;const ae=f[H];if(typeof ae=="function"){if(Y(H))return ae.call(f,G);if(Z(H))return A.set(H,l.Event.buffer(f[H],!0,void 0,C)),A.get(H)}throw new E.$bb(`Event not found: ${H}`)}call(M,H,G){const ie=f[H];if(typeof ie=="function"){if(!P&&Array.isArray(G))for(let le=0;le<G.length;le++)G[le]=(0,b.$Qh)(G[le]);let ae=ie.apply(f,G);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${H}`)}}}q.fromService=T;function x(_,C){const F=C&&C.disableMarshalling;return new Proxy({},{get(f,P){if(typeof P=="string")return C?.properties?.has(P)?C.properties.get(P):Y(P)?function(A){return _.listen(P,A)}:Z(P)?_.listen(P):async function(...A){let M;C&&!(0,d.$4f)(C.context)?M=[C.context,...A]:M=A;const H=await _.call(P,M);return F?H:(0,b.$Qh)(H)};throw new E.$bb(`Property not found: ${String(P)}`)}})}q.toService=x;function Z(_){return _[0]==="o"&&_[1]==="n"&&v.$kf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&v.$kf(_.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const T=q.toString();if(T!=="[object Object]")return T}return q}function ce(q){return Array.isArray(q)?q.map(he):he(q)}function B(q,T,x,Z,Y,_,C){C=ce(C);const F=ue[Y],f=F[Z%F.length];let P=[`%c[${q}]%c[${String(T).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(P=P.concat(C),P.push(")")):P.push(C),console.log.apply(console,P)}class X{constructor(T,x){this.d=T,this.f=x,this.a=0,this.b=0}logOutgoing(T,x,Z,Y,_){this.b+=T,B(this.d,this.b,T,x,Z,Y,_)}logIncoming(T,x,Z,Y,_){this.a+=T,B(this.f,this.a,T,x,Z,Y,_)}}e.$3h=X}),define(ne[88],re([0,1,58,9,14,20,83,8,5,2,27,56,55,57]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;class y extends p.$Vh{constructor(c){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",w=>k.$ue.wrap(Buffer.from(w,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Hq=y;class R{constructor(c,w){this.i=c,this.j=w,this.c=new Set,this.g=new Map,this.h=new l.$7d,this.onDidProcessExit=this.h.event;const $=w&&w.timeout?w.timeout:6e4;this.b=new O.$eh($),this.d=null,this.f=null}getChannel(c){const w=this;return{call($,h,m){return w.k(c,$,h,m)},listen($,h){return w.l(c,$,h)}}}k(c,w,$,h=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const m=this.n(c),i=(0,O.$7g)(n=>m.call(w,$,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Sc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,w,$){if(!this.b)return l.Event.None;this.b.cancel();let h;const m=new l.$7d({onWillAddFirstListener:()=>{h=this.n(c).listen(w,$)(m.fire,m),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,b.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$$l)(w.env),this.d=(0,D.fork)(this.i,c,w);const $=new l.$7d;l.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,N.$Dq)(s)){(0,N.log)(s,`IPC Library: ${this.j.serverName}`);return}$.fire(k.$ue.wrap(Buffer.from(s,"base64")))});const m=this.j.useQueue?(0,v.$am)(this.d):this.d,i=s=>this.d&&this.d.connected&&m.send(s.buffer.toString("base64")),r=$.event,t={send:i,onMessage:r};this.f=new p.$Wh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(u=>(0,a.$Pc)(u)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let w=this.g.get(c);return w||(w=this.m.getChannel(c),this.g.set(c,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Iq=R}),define(ne[89],re([0,1,9,5,2,47,3]),function(J,e,D,O,k,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=l;var E;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function l(d){const p=d;return p?.changed instanceof Map||p?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class b extends k.$Uc{static{this.a=100}constructor(p,y=Object.create(null)){super(),this.r=p,this.s=y,this.b=this.B(new O.$0d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new D.$fh(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((y,R)=>this.w(R,y)),p.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(p,y){if(this.c===a.Closed)return;let R=!1;(0,N.$4f)(y)?R=this.f.delete(p):this.f.get(p)!==y&&(this.f.set(p,y),R=!0),R&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,y){const R=this.f.get(p);return(0,N.$4f)(R)?y:R}getBoolean(p,y){const R=this.get(p);return(0,N.$4f)(R)?y:R==="true"}getNumber(p,y){const R=this.get(p);return(0,N.$4f)(R)?y:parseInt(R,10)}getObject(p,y){const R=this.get(p);return(0,N.$4f)(R)?y:(0,j.$Ph)(R)}async set(p,y,R=!1){if(this.c===a.Closed)return;if((0,N.$4f)(y))return this.delete(p,R);const g=(0,N.$Wf)(y)||Array.isArray(y)?(0,j.$Oh)(y):String(y);if(this.f.get(p)!==g)return this.f.set(p,g),this.j.set(p,g),this.h.delete(p),this.b.fire({key:p,external:R}),this.D()}async delete(p,y=!1){if(!(this.c===a.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(this.z)return this.D(p)}async D(p){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Hp=b;class v{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((y,R)=>this.a.set(R,y)),p.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Ip=v}),define(ne[90],re([7,4]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[49],re([0,1,59,9,16,3,24,90]),function(J,e,D,O,k,j,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0,e.zip=g,e.$6p=c,e.$7p=$,e.$3p="end of central directory record signature not found";const l=new RegExp(e.$3p);class a extends Error{constructor(m,i){let r=i.message;switch(m){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=m,this.cause=i}}e.$4p=a;function b(h){const m=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>m&i).reduce((i,r)=>i+r,m&61440)}function v(h){if(h instanceof a)return h;let m;return l.test(h.message)&&(m="CorruptZip"),new a(m,h)}function d(h,m,i,r,t,n){const s=k.$nc(m),o=k.$kc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,m)));const u=k.$kc(r,m);let S;return n.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(N.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,L)=>{if(!n.isCancellationRequested)try{S=(0,D.createWriteStream)(u,{mode:i}),S.once("close",()=>I()),S.once("error",L),h.once("error",L),h.pipe(S)}catch(U){L(U)}}))}function p(h,m,i,r){let t=(0,O.$7g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,u)=>{const S=new O.$ch,I=L=>{L.isCancellationRequested||(n++,h.readEntry())};h.once("error",u),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():u(new a("Incomplete",new Error(E.localize(1,null,n,h.entryCount))))},u)),h.readEntry(),h.on("entry",L=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(L.fileName)){I(r);return}const U=L.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const Q=k.$kc(m,U);t=(0,O.$7g)(se=>N.Promises.mkdir(Q,{recursive:!0}).then(()=>I(se)).then(void 0,u));return}const z=R(h,L),V=b(L);t=(0,O.$7g)(Q=>S.queue(()=>z.then(se=>d(se,U,V,m,i,Q).then(()=>I(Q)))).then(null,u))})}).finally(()=>s.dispose())}async function y(h,m=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,m?{lazyEntries:!0}:void 0,(n,s)=>{n?t(v(n)):r((0,j.$6f)(s))})})}function R(h,m){return new Promise((i,r)=>{h.openReadStream(m,(t,n)=>{t?r(v(t)):i((0,j.$6f)(n))})})}async function g(h,m){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;m.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,D.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}function c(h,m,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=y(h,!0);return i.overwrite&&(n=n.then(s=>N.Promises.rm(m).then(()=>s))),n.then(s=>p(s,m,{sourcePathRegex:t},r))}function w(h,m){return y(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===m&&R(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(E.localize(2,null,m))))}))}function $(h,m){return w(h,m).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}}),define(ne[91],re([7,4]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[92],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[93],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[94],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[95],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[96],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[97],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[98],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[99],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[100],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[101],re([7,4]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[102],re([7,4]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[103],re([7,4]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[104],re([7,4]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[105],re([7,4]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[106],re([7,4]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(ne[107],re([7,4]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[108],re([7,4]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[109],re([7,4]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[110],re([7,4]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[111],re([7,4]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[112],re([0,1,8,93]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function j(...a){switch(a.length){case 1:return(0,O.localize)(0,null,a[0]);case 2:return(0,O.localize)(1,null,a[0],a[1]);case 3:return(0,O.localize)(2,null,a[0],a[1],a[2]);default:return}}const N=(0,O.localize)(3,null),E=(0,O.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const v=this.d,d=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:d};this.g.push({offset:v,lexeme:d,additionalInfo:b}),this.f.push(p)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const v=this.c.substring(this.d,this.e),d=l.b.get(v);d?this.k(d):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,v=!1,d=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(E);return}const y=this.c.charCodeAt(b);if(v)v=!1;else if(y===47&&!d){b++;break}else y===91?d=!0:y===92?v=!0:y===93&&(d=!1);b++}for(;b<this.c.length&&l.a.has(this.c.charCodeAt(b));)b++;this.e=b;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=l}),define(ne[113],re([0,1,79,53,15,16,35,17,11]),function(J,e,D,O,k,j,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Rm=b,e.$Sm=v,e.$Pm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,j.$nc)(k.$Bg.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,j.$kc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,D.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$kc)(this.userDataPath,"logs",p)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Ug)(l.URI.file((0,j.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=N.env.VSCODE_PORTABLE;return p?l.URI.file((0,j.$kc)(p,"argv.json")):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,j.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,j.$lc)(p):(0,j.$ic)((0,j.$kc)(k.$Bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?l.URI.file((0,j.$lc)(p)):l.URI.file((0,j.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,j.$lc)(p);const y=N.env.VSCODE_EXTENSIONS;if(y)return y;const R=N.env.VSCODE_PORTABLE;return R?(0,j.$kc)(R,"extensions"):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(y=>/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,j.$ic)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,j.$ic)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$Pm.test(p))}get extensionLogLevel(){const p=[];for(const y of this.args.log||[]){const R=e.$Pm.exec(y);R&&R[1]&&R[2]&&p.push([R[1],R[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,E.$Ug)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=N.env.VSCODE_PORTABLE;return p?l.URI.file((0,j.$kc)(p,"policy.json")):(0,E.$Ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,y,R){this.a=p,this.b=y,this.c=R,this.editSessionId=this.args.editSessionId}}e.$Qm=a,$e([O.$Lh],a.prototype,"appRoot",null),$e([O.$Lh],a.prototype,"userHome",null),$e([O.$Lh],a.prototype,"userDataPath",null),$e([O.$Lh],a.prototype,"appSettingsHome",null),$e([O.$Lh],a.prototype,"tmpDir",null),$e([O.$Lh],a.prototype,"cacheHome",null),$e([O.$Lh],a.prototype,"stateResource",null),$e([O.$Lh],a.prototype,"userRoamingDataHome",null),$e([O.$Lh],a.prototype,"userDataSyncHome",null),$e([O.$Lh],a.prototype,"sync",null),$e([O.$Lh],a.prototype,"machineSettingsResource",null),$e([O.$Lh],a.prototype,"workspaceStorageHome",null),$e([O.$Lh],a.prototype,"localHistoryHome",null),$e([O.$Lh],a.prototype,"keyboardLayoutResource",null),$e([O.$Lh],a.prototype,"argvResource",null),$e([O.$Lh],a.prototype,"isExtensionDevelopment",null),$e([O.$Lh],a.prototype,"untitledWorkspacesHome",null),$e([O.$Lh],a.prototype,"builtinExtensionsPath",null),$e([O.$Lh],a.prototype,"extensionsPath",null),$e([O.$Lh],a.prototype,"extensionDevelopmentLocationURI",null),$e([O.$Lh],a.prototype,"extensionDevelopmentKind",null),$e([O.$Lh],a.prototype,"extensionTestsLocationURI",null),$e([O.$Lh],a.prototype,"debugExtensionHost",null),$e([O.$Lh],a.prototype,"logLevel",null),$e([O.$Lh],a.prototype,"extensionLogLevel",null),$e([O.$Lh],a.prototype,"serviceMachineIdResource",null),$e([O.$Lh],a.prototype,"disableTelemetry",null),$e([O.$Lh],a.prototype,"disableWorkspaceTrust",null),$e([O.$Lh],a.prototype,"useInMemorySecretStorage",null),$e([O.$Lh],a.prototype,"policyFile",null);function b(d,p){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,p,d.debugId,d.extensionEnvironment)}function v(d,p,y,R,g,c){const $=Number(p||d)||(R?null:y),h=$?!!p:!1;let m;if(c)try{m=JSON.parse(c)}catch{}return{port:$,break:h,debugId:g,env:m}}}),function(){"use strict";function J(e,D,O){function k(N,E){const l=j(N,E),a=[l];return e.isAbsolute(l)||a.unshift(O),e.resolve(...a)}function j(N,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const b=N["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(D.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[114],re([169,33,35]),function(e,D,O){return J(e,D,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=J(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[115],re([0,1,33,113,114]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0,e.$Um=N,e.$Vm=E;class j extends O.$Qm{constructor(a,b){super(a,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,b.nameShort)},b)}}e.$Tm=j;function N(l,a){return(0,O.$Sm)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,a,l.extensionEnvironment)}function E(l,a){return(0,O.$Sm)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,a,l.extensionEnvironment)}}),define(ne[116],re([0,1,3,97]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=k;function k(N,E,l,a){try{j(N,E,l,a)}catch(b){N.error(b?.message??b)}return E}function j(N,E,l,a){const b=(v,d,p)=>{const y=v[d];if((0,D.$Uf)(y)){const R=y,g=R.length;if(g>1&&R[0]==="%"&&R[g-1]==="%"){const c=R.substr(1,g-2);let w=l[c];w===void 0&&a&&(w=a[c]);const $=typeof w=="string"?w:w?.message,h=a?.[c],m=typeof h=="string"?h:h?.message;if(!$){m||N.warn(`[${E.name}]: ${(0,O.localize)(0,null,c)}`);return}if(p&&(d==="title"||d==="category")&&m&&m!==$){const i={value:$,original:m};v[d]=i}else v[d]=$}}else if((0,D.$Wf)(y))for(const R in y)y.hasOwnProperty(R)&&(R==="commands"?b(y,R,!0):b(y,R,p));else if(Array.isArray(y))for(let R=0;R<y.length;R++)b(y,R,p)};for(const v in E)E.hasOwnProperty(v)&&b(E,v)}}),define(ne[117],re([0,1,49,100]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=k;function k(j){return(0,D.$7p)(j,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}}),define(ne[50],re([0,1,17,54,101,44]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=l,e.$sp=a,e.$tp=b,e.$up=v,e.$vp=d,e.$wp=p,e.$xp=y;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function l(c){return c=c.trim(),c==="*"||N.test(c)}function a(c){if(!l(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=c.match(N);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function b(c){if(!c)return null;const w=c.majorBase,$=c.majorMustEqual,h=c.minorBase;let m=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(w===0||(m=!1),r=!1);let t=0;if(c.preRelease){const n=E.exec(c.preRelease);if(n){const[,s,o,u]=n;t=Date.UTC(Number(s),Number(o)-1,Number(u))}}return{majorBase:w,majorMustEqual:$,minorBase:h,minorMustEqual:m,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,w,$){let h;typeof c=="string"?h=b(a(c)):h=c;let m;w instanceof Date?m=w.getTime():typeof w=="string"&&(m=new Date(w).getTime());let i;if(typeof $=="string"?i=b(a($)):i=$,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,u=i.patchBase;const S=i.notBefore;let I=i.majorMustEqual,L=i.minorMustEqual,U=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||m&&m<S?!1:n>=u:(r===1&&s===0&&(!I||!L||!U)&&(s=1,o=0,u=0,I=!0,L=!1,U=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!L:n<u?!1:n>u?!U:!(m&&m<S))}function d(c,w,$,h,m){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([O.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([O.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([O.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([O.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([O.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!g(h.extensionDependencies))return i.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!g(h.activationEvents))return i.push([O.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([O.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([O.default.Error,k.localize(9,null,"main")]),i;{const n=(0,D.$Ug)($,h.main);(0,D.$Og)(n,$)||i.push([O.default.Warning,k.localize(10,null,n.path,$.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([O.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,D.$Ug)($,h.browser);(0,D.$Og)(n,$)||i.push([O.default.Warning,k.localize(12,null,n.path,$.path)])}}if(!j.valid(h.version))return i.push([O.default.Error,k.localize(13,null)]),i;const r=[];if(!p(c,w,h,m,r))for(const n of r)i.push([O.default.Error,n]);return i}function p(c,w,$,h,m){return h||typeof $.main>"u"&&typeof $.browser>"u"?!0:R(c,w,$.engines.vscode,m)}function y(c,w,$){return c==="*"||R(w,$,c)}function R(c,w,$,h=[]){const m=b(a($));if(!m)return h.push(k.localize(14,null,$)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return h.push(k.localize(15,null,$)),!1}else if(!m.majorMustEqual)return h.push(k.localize(16,null,$)),!1;return v(c,w,m)?!0:(h.push(k.localize(17,null,c,$)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let w=0,$=c.length;w<$;w++)if(typeof c[w]!="string")return!1;return!0}}),define(ne[118],re([0,1,14,28]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=k;async function k(j,N,E){let l=E&&E.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const b=(await N.readFile(j.serviceMachineIdResource)).value.toString();l=(0,O.$Cg)(b)?b:null}catch{l=null}if(!l){l=(0,O.$Dg)();try{await N.writeFile(j.serviceMachineIdResource,D.$ue.fromString(l))}catch{}}return E?.store("storage.serviceMachineId",l,-1,1),l}}),define(ne[119],re([0,1,59,2,5,11]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class N extends O.$Uc{constructor(){super(...arguments),this.a=this.B(new k.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$4c),this.f=new Set,this.g=new Set}async watch(l){this.f=new Set([...l]);const a=new Set;for(const b of l)typeof b.correlationId=="number"&&(a.add(b.correlationId),this.c.has(b.correlationId)||this.c.set(b.correlationId,this.m(b)));for(const[b]of this.c)a.has(b)||this.c.deleteAndDispose(b);for(const b of this.g)this.f.has(b)||this.g.delete(b);return this.j()}j(){return this.t(Array.from(this.f).filter(l=>!this.g.has(l)))}m(l){if(typeof l.correlationId!="number")return O.$Uc.None;const a=this,b=j.URI.file(l.path);let v=!1,d=!1;const p=(y,R)=>{if(v)return;const g=this.n(y),c=this.n(R),w=d;if(d=g,c&&!g||w&&!g&&!c){this.u(`fs.watchFile() detected ${l.path} exists again, resuming watcher (correlationId: ${l.correlationId})`);const $={resource:b,type:1,cId:l.correlationId};a.a.fire([$]),this.s($,l),this.g.delete(l),this.j()}else if(g){if(this.u(`fs.watchFile() detected ${l.path} not found, suspending watcher (correlationId: ${l.correlationId})`),!c){const $={resource:b,type:2,cId:l.correlationId};a.a.fire([$]),this.s($,l)}this.g.add(l),this.j()}};this.u(`starting fs.watchFile() on ${l.path} (correlationId: ${l.correlationId})`);try{(0,D.watchFile)(l.path,{persistent:!1,interval:this.h},p)}catch(y){return this.w(`fs.watchFile() failed with error ${y} on path ${l.path} (correlationId: ${l.correlationId})`),O.$Uc.None}return(0,O.$Sc)(()=>{this.u(`stopping fs.watchFile() on ${l.path} (correlationId: ${l.correlationId})`),v=!0,this.g.delete(l);try{(0,D.unwatchFile)(l.path,p)}catch(y){this.w(`fs.unwatchFile() failed with error ${y} on path ${l.path} (correlationId: ${l.correlationId})`)}})}n(l){return l.ctimeMs===0&&l.ino===0}async stop(){this.c.clearAndDisposeAll(),this.g.clear()}r(l){return typeof l.correlationId!="number"}s(l,a){const b=` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`;this.u(typeof a.correlationId=="number"?`${b} (correlationId: ${a.correlationId})`:b)}}e.$Kq=N}),define(ne[51],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class D{constructor(k,j=[],N=!1){this.ctor=k,this.staticArguments=j,this.supportsDelayedInstantiation=N}}e.$ei=D}),define(ne[120],re([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$es=j,e.$fs=N;const O=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function j(E,l,a){l instanceof D.$ei||(l=new D.$ei(l,[],!!a)),O.push([E,l])}function N(){return O}}),define(ne[121],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class D{constructor(j,N){this.key=j,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$Uq=D;class O{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const N of this.a.values())N.outgoing.size===0&&j.push(N);return j}insertEdge(j,N){const E=this.lookupOrInsertNode(j),l=this.lookupOrInsertNode(N);E.outgoing.set(l.key,l),l.incoming.set(E.key,E)}removeNode(j){const N=this.b(j);this.a.delete(N);for(const E of this.a.values())E.outgoing.delete(N),E.incoming.delete(N)}lookupOrInsertNode(j){const N=this.b(j);let E=this.a.get(N);return E||(E=new D(N,j),this.a.set(N,E)),E}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[N,E]of this.a)j.push(`${N}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,N]of this.a){const E=new Set([j]),l=this.c(N,E);if(l)return l}}c(j,N){for(const[E,l]of j.outgoing){if(N.has(E))return[...N,E].join(" -> ");N.add(E);const a=this.c(l,N);if(a)return a;N.delete(E)}}}e.$Vq=O}),define(ne[29],re([0,1,3,11,10]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=j,e.$Pi=N,e.$Qi=l,e.$Ri=a,e.$Si=b,e.$Ti=v,e.$Ui=d,e.$Vi=y,e.$Wi=R,e.$Xi=g,e.$Ni=(0,k.$hi)("configurationService");function j(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function l(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function b(c,w){const $=Object.create(null);for(const h in c)v($,h,c[h],w);return $}function v(c,w,$,h){const m=w.split("."),i=m.pop();let r=c;for(let t=0;t<m.length;t++){const n=m[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${w} as ${m.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=$}catch{h(`Ignoring ${w} as ${m.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${w} as ${m.join(".")} is ${JSON.stringify(r)}`)}function d(c,w){const $=w.split(".");p(c,$)}function p(c,w){const $=w.shift();if(w.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const h=c[$];typeof h=="object"&&!Array.isArray(h)&&(p(h,w),Object.keys(h).length===0&&delete c[$])}}function y(c,w,$){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const m=w.split("."),i=h(c,m);return typeof i>"u"?$:i}function R(c,w,$){Object.keys(w).forEach(h=>{h!=="__proto__"&&(h in c?D.$Wf(c[h])&&D.$Wf(w[h])?R(c[h],w[h],$):$&&(c[h]=w[h]):c[h]=w[h])})}function g(c){return c.replace(/[\[\]]/g,"")}}),define(ne[122],re([0,1,12,30,112,10,92,8]),function(J,e,D,O,k,j,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=a,e.$gj=r,e.$hj=t,e.$Aj=Y;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",D.$j),l.set("isLinux",D.$k),l.set("isWindows",D.$i),l.set("isWeb",D.$o),l.set("isMacNative",D.$j&&!D.$o),l.set("isEdge",D.$H),l.set("isFirefox",D.$F),l.set("isChrome",D.$E),l.set("isSafari",D.$G);function a(F,f){if(l.get(F)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(F,f)}const b=Object.prototype.hasOwnProperty;var v;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const d={regexParsingWithErrorRecovery:!0},p=(0,N.localize)(0,null),y=(0,N.localize)(1,null),R=(0,N.localize)(2,null),g=(0,N.localize)(3,null),c=(0,N.localize)(4,null),w=(0,N.localize)(5,null),$=(0,N.localize)(6,null),h=(0,N.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new k.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const A=this.D(),M=A.type===17?w:void 0;throw this.h.push({message:c,offset:A.offset,lexeme:k.$cj.getLexeme(A),additionalInfo:M}),m.c}return P}catch(P){if(P!==m.c)throw P;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const P=this.o();f.push(P)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const P=this.s();f.push(P)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,g),P?.negate()}case 17:return this.z(),z.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const P=this.l();return this.A(1,g),P}case 17:{const P=f.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const H=M.lexeme,G=H.lastIndexOf("/"),ie=G===H.length-1?void 0:this.w(H.substring(G+1));let ae;try{ae=new RegExp(H.substring(1,G),ie)}catch{throw this.B("REGEX",M)}return he.create(P,ae)}switch(M.type){case 10:case 19:{const H=[M.lexeme];this.z();let G=this.D(),ie=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?ie++:M.lexeme.charCodeAt(fe)===41&&ie--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let fe=0;fe<G.lexeme.length;fe++)G.lexeme.charCodeAt(fe)===40?ie++:M.lexeme.charCodeAt(fe)===41&&ie--}if(ie<0)break;H.push(k.$cj.getLexeme(G)),this.z(),G=this.D()}const ae=H.join(""),le=ae.lastIndexOf("/"),pe=le===ae.length-1?void 0:this.w(ae.substring(le+1));let ye;try{ye=new RegExp(ae.substring(1,le),pe)}catch{throw this.B("REGEX",M)}return i.regex(P,ye)}case 18:{const H=M.lexeme;this.z();let G=null;if(!(0,O.$Ue)(H)){const ie=H.indexOf("/"),ae=H.lastIndexOf("/");if(ie!==ae&&ie>=0){const le=H.slice(ie+1,ae),pe=H[ae+1]==="i"?"i":"";try{G=new RegExp(le,pe)}catch{throw this.B("REGEX",M)}}}if(G===null)throw this.B("REGEX",M);return he.create(P,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const M=this.u();return i.notIn(P,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return i.equals(P,M);switch(M){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return i.notEquals(P,M);switch(M){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,M)}}case 5:return this.z(),te.create(P,this.u());case 6:return this.z(),ue.create(P,this.u());case 7:return this.z(),Q.create(P,this.u());case 8:return this.z(),se.create(P,this.u());case 13:return this.z(),i.in(P,this.u());default:return i.has(P)}}case 20:throw this.h.push({message:$,offset:f.offset,lexeme:"",additionalInfo:h}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,P){if(this.C(f))return this.z();throw this.B(P,this.D())}B(f,P,A){const M=(0,N.localize)(8,null,f,k.$cj.getLexeme(P)),H=P.offset,G=k.$cj.getLexeme(P);return this.h.push({message:M,offset:H,lexeme:G,additionalInfo:A}),m.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=m;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return u.create(f)}static equals(f,P){return S.create(f,P)}static notEquals(f,P){return U.create(f,P)}static regex(f,P){return he.create(f,P)}static in(f,P){return I.create(f,P)}static notIn(f,P){return L.create(f,P)}static not(f){return z.create(f)}static and(...f){return X.create(f,null,!0)}static or(...f){return q.create(f,null,!0)}static greater(f,P){return Q.create(f,P)}static greaterEquals(f,P){return se.create(f,P)}static smaller(f,P){return te.create(f,P)}static smallerEquals(f,P){return ue.create(f,P)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$fj=i;function r(F){const f=new m({regexParsingWithErrorRecovery:!1});return F.map(P=>(f.parse(P),f.lexingErrors.length>0?f.lexingErrors.map(A=>({errorMessage:A.additionalInfo?(0,N.localize)(9,null,A.additionalInfo):(0,N.localize)(10,null),offset:A.offset,length:A.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(A=>({errorMessage:A.additionalInfo?`${A.message}. ${A.additionalInfo}`:A.message,offset:A.offset,length:A.lexeme.length})):[]))}function t(F,f){const P=F?F.substituteConstants():void 0,A=f?f.substituteConstants():void 0;return!P&&!A?!0:!P||!A?!1:P.equals(A)}function n(F,f){return F.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$ij=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$jj=o;class u{static create(f,P=null){const A=l.get(f);return typeof A=="boolean"?A?o.INSTANCE:s.INSTANCE:new u(f,P)}constructor(f,P){this.key=f,this.c=P,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:x(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=l.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=z.create(this.key,this)),this.c}}e.$kj=u;class S{static create(f,P,A=null){if(typeof P=="boolean")return P?u.create(f,A):z.create(f,A);const M=l.get(f);return typeof M=="boolean"?P===(M?"true":"false")?o.INSTANCE:s.INSTANCE:new S(f,P,A)}constructor(f,P,A){this.c=f,this.d=P,this.f=A,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=l.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$lj=S;class I{static create(f,P){return new I(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.f),A=f.getValue(this.d);return Array.isArray(P)?P.includes(A):typeof A=="string"&&typeof P=="object"&&P!==null?b.call(P,A):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$mj=I;class L{static create(f,P){return new L(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=11,this.c=I.create(f,P)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=L;class U{static create(f,P,A=null){if(typeof P=="boolean")return P?z.create(f,A):u.create(f,A);const M=l.get(f);return typeof M=="boolean"?P===(M?"true":"false")?s.INSTANCE:o.INSTANCE:new U(f,P,A)}constructor(f,P,A){this.c=f,this.d=P,this.f=A,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=l.get(this.c);if(typeof f=="boolean"){const P=f?"true":"false";return this.d===P?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$oj=U;class z{static create(f,P=null){const A=l.get(f);return typeof A=="boolean"?A?s.INSTANCE:o.INSTANCE:new z(f,P)}constructor(f,P){this.c=f,this.d=P,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:x(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=l.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$pj=z;function V(F,f){if(typeof F=="string"){const P=parseFloat(F);isNaN(P)||(F=P)}return typeof F=="string"||typeof F=="number"?f(F):s.INSTANCE}class Q{static create(f,P,A=null){return V(P,M=>new Q(f,M,A))}constructor(f,P,A){this.c=f,this.d=P,this.f=A,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$qj=Q;class se{static create(f,P,A=null){return V(P,M=>new se(f,M,A))}constructor(f,P,A){this.c=f,this.d=P,this.f=A,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$rj=se;class te{static create(f,P,A=null){return V(P,M=>new te(f,M,A))}constructor(f,P,A){this.c=f,this.d=P,this.f=A,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$sj=te;class ue{static create(f,P,A=null){return V(P,M=>new ue(f,M,A))}constructor(f,P,A){this.c=f,this.d=P,this.f=A,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Z(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$tj=ue;class he{static create(f,P){return new he(f,P)}constructor(f,P){this.d=f,this.f=P,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const P=this.f?this.f.source:"",A=f.f?f.f.source:"";return P<A?-1:P>A?1:0}equals(f){if(f.type===this.type){const P=this.f?this.f.source:"",A=f.f?f.f.source:"";return this.d===f.d&&P===A}return!1}substituteConstants(){return this}evaluate(f){const P=f.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$uj=he;class ce{static create(f){return new ce(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ce(this.c.map(f))}negate(){return this.c}}e.$vj=ce;function B(F){let f=null;for(let P=0,A=F.length;P<A;P++){const M=F[P].substituteConstants();if(F[P]!==M&&f===null){f=[];for(let H=0;H<P;H++)f[H]=F[H]}f!==null&&(f[P]=M)}return f===null?F:f}class X{static create(f,P,A){return X.d(f,P,A)}constructor(f,P){this.expr=f,this.c=P,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,A=this.expr.length;P<A;P++){const M=n(this.expr[P],f.expr[P]);if(M!==0)return M}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,A=this.expr.length;P<A;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let P=0,A=this.expr.length;P<A;P++)if(!this.expr[P].evaluate(f))return!1;return!0}static d(f,P,A){const M=[];let H=!1;for(const G of f)if(G){if(G.type===1){H=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&H)return o.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const ie=M.pop(),ae=M.length===0,le=q.create(G.expr.map(pe=>X.create([pe,ie],null,A)),null,ae);le&&(M.push(le),M.sort(n))}if(M.length===1)return M[0];if(A){for(let G=0;G<M.length;G++)for(let ie=G+1;ie<M.length;ie++)if(M[G].negate().equals(M[ie]))return s.INSTANCE;if(M.length===1)return M[0]}return new X(M,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new X(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());this.c=q.create(f,this,!0)}return this.c}}e.$wj=X;class q{static create(f,P,A){return q.d(f,P,A)}constructor(f,P){this.expr=f,this.c=P,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let P=0,A=this.expr.length;P<A;P++){const M=n(this.expr[P],f.expr[P]);if(M!==0)return M}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let P=0,A=this.expr.length;P<A;P++)if(!this.expr[P].equals(f.expr[P]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:q.create(f,this.c,!1)}evaluate(f){for(let P=0,A=this.expr.length;P<A;P++)if(this.expr[P].evaluate(f))return!0;return!1}static d(f,P,A){let M=[],H=!1;if(f){for(let G=0,ie=f.length;G<ie;G++){const ae=f[G];if(ae){if(ae.type===0){H=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&H)return s.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];if(A){for(let G=0;G<M.length;G++)for(let ie=G+1;ie<M.length;ie++)if(M[G].negate().equals(M[ie]))return o.INSTANCE;if(M.length===1)return M[0]}return new q(M,P)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const P of this.expr)f.push(...P.keys());return f}map(f){return new q(this.expr.map(P=>P.map(f)),null)}negate(){if(!this.c){const f=[];for(const P of this.expr)f.push(P.negate());for(;f.length>1;){const P=f.shift(),A=f.shift(),M=[];for(const H of C(P))for(const G of C(A))M.push(X.create([H,G],null,!1));f.unshift(q.create(M,null,!1))}this.c=q.create(f,this,!0)}return this.c}}e.$xj=q;class T extends u{static{this.d=[]}static all(){return T.d.values()}constructor(f,P,A){super(f,null),this.f=P,typeof A=="object"?T.d.push({...A,key:f}):A!==!0&&T.d.push({key:f,description:A,type:P!=null?typeof P:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return S.create(this.key,f)}notEqualsTo(f){return U.create(this.key,f)}}e.$yj=T,e.$zj=(0,j.$hi)("contextKeyService");function x(F,f){return F<f?-1:F>f?1:0}function Z(F,f,P,A){return F<P?-1:F>P?1:f<A?-1:f>A?1:0}function Y(F,f){if(F.type===0||f.type===1)return!0;if(F.type===9)return f.type===9?_(F.expr,f.expr):!1;if(f.type===9){for(const P of f.expr)if(Y(F,P))return!0;return!1}if(F.type===6){if(f.type===6)return _(f.expr,F.expr);for(const P of F.expr)if(Y(P,f))return!0;return!1}return F.equals(f)}function _(F,f){let P=0,A=0;for(;P<F.length&&A<f.length;){const M=F[P].cmp(f[A]);if(M<0)return!1;M===0&&P++,A++}return P===F.length}function C(F){return F.type===9?F.expr:[F]}}),define(ne[60],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,e.$vo=(0,D.$hi)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,D.$hi)("environmentService"),e.$pi=(0,D.$ii)(e.$oi)}),define(ne[21],re([0,1,95,10]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=k,e.$Lo=j,e.$Mo=N,e.$No=E,e.$Oo=l,e.$Po=a,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function k($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function N($,h){switch($){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E($,h){return h==="web"&&!$.includes("web")}function l($,h,m){return E(h,m)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===m}function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}var b;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var v;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function($){$.Install="install",$.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var p;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Qo=(0,O.$hi)("extensionGalleryService");var y;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var R;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(R||(e.ExtensionSignaturetErrorCode=R={}));class g extends Error{constructor(h,m){super(h),this.code=m,this.name=m}}e.$Ro=g;var c;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class w extends Error{constructor(h,m){super(h),this.code=m,this.name=m}}e.$So=w,e.$To=(0,O.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,O.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,O.$hi)("IExtensionTipsService"),e.$Yo=(0,D.localize2)(0,"Extensions"),e.$Zo=(0,D.localize2)(1,"Preferences")}),define(ne[61],re([0,1,14,8,103,13]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=N;async function N(b,v,d,p,y,R){let g;try{await E(b,v,d,p,y,R)}catch(c){g=c}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&d.error(g),d.end()}}async function E(b,v,d,p,y,R){l(R);const g=await b.open(v,{create:!1});try{l(R);let c=0,w=0,$=y&&typeof y.length=="number"?y.length:void 0,h=D.$ue.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),m=y&&typeof y.position=="number"?y.position:0,i=0;do w=await b.read(g,m,h.buffer,i,h.byteLength-i),m+=w,i+=w,c+=w,typeof $=="number"&&($-=w),i===h.byteLength&&(await d.write(p(h)),h=D.$ue.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),i=0);while(w>0&&(typeof $!="number"||$>0)&&l(R)&&a(c,y));if(i>0){let r=i;typeof $=="number"&&(r=Math.min(i,$)),d.write(p(h.slice(0,r)))}}catch(c){throw(0,j.$2k)(c)}finally{await b.close(g)}}function l(b){if(b.isCancellationRequested)throw(0,O.$6)();return!0}function a(b,v){if(typeof v?.limits?.size=="number"&&b>v.limits.size)throw(0,j.$1k)((0,k.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[123],re([0,1,5,170,119,12,171]),function(J,e,D,O,k,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class E extends k.$Kq{constructor(){super(...arguments),this.onDidError=D.Event.None,this.y=new Map,this.z=!1}async t(a){const b=this.G(a),v=b.filter(p=>{const y=this.y.get(p.path);return y?!(0,O.$fk)(y.request.excludes,p.excludes)||!(0,O.$fk)(y.request.includes,p.includes):!0}),d=Array.from(this.y.values()).filter(({request:p})=>!b.find(y=>y.path===p.path&&(0,O.$fk)(y.excludes,p.excludes)&&(0,O.$fk)(y.includes,p.includes))).map(({request:p})=>p.path);v.length&&this.u(`Request to start watching: ${v.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"}, correlationId: ${typeof p.correlationId=="number"?p.correlationId:"<none>"})`).join(",")}`),d.length&&this.u(`Request to stop watching: ${d.join(",")}`);for(const p of d)this.F(p);for(const p of v)this.D(p)}D(a){const b=new N.$Pq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.z),v={request:a,instance:b};this.y.set(a.path,v)}async stop(){await super.stop();for(const[a]of this.y)this.F(a);this.y.clear()}F(a){const b=this.y.get(a);b&&(this.y.delete(a),b.instance.dispose())}G(a){const b=new Map;for(const v of a){const d=j.$k?v.path:v.path.toLowerCase();let p=b.get(v.correlationId);p||(p=new Map,b.set(v.correlationId,p)),p.set(d,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(a){this.z=a;for(const[,b]of this.y)b.instance.setVerboseLogging(a)}u(a){this.z&&this.b.fire({type:"trace",message:this.J(a)})}w(a){this.z&&this.b.fire({type:"warn",message:this.J(a)})}J(a){return`[File Watcher (node.js)] ${a}`}}e.$Rq=E}),define(ne[124],re([0,1,62,123]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class k extends D.$wq{constructor(N,E,l){super(N,E,l),this.s()}r(N){return N.add(new O.$Rq)}}e.$Sq=k}),define(ne[125],re([0,1,15,57,88,62]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class N extends j.$xq{constructor(l,a,b){super(l,a,b),this.s()}r(l){const a=l.add(new k.$Iq(D.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(a.onDidProcessExit(({code:b,signal:v})=>this.t(`terminated by itself with code ${b}, signal: ${v}`))),O.ProxyChannel.toService((0,O.$1h)(a.getChannel("watcher")))}}e.$Jq=N}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class D{constructor(...k){this.a=new Map;for(const[j,N]of k)this.set(j,N)}set(k,j){const N=this.a.get(k);return this.a.set(k,j),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$fi=D}),define(ne[126],re([0,1,9,8,2,51,121,10,63,172]),function(J,e,D,O,k,j,N,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;const b=!1;class v extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class d{constructor(g=new l.$fi,c=!1,w,$=b){this.f=g,this.g=c,this.h=w,this.i=$,this.o=new Set,this.f.set(E.$gi,this),this._globalGraph=$?w?._globalGraph??new N.$Vq(h=>h):void 0}createChild(g){return new d(g,this.g,this,this.i)}invokeFunction(g,...c){const w=y.traceInvocation(this.i,g);let $=!1;try{return g({get:m=>{if($)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(m,w);if(!i)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...c)}finally{$=!0,w.stop()}}createInstance(g,...c){let w,$;return g instanceof j.$ei?(w=y.traceCreation(this.i,g.ctor),$=this.j(g.ctor,g.staticArguments.concat(c),w)):(w=y.traceCreation(this.i,g),$=this.j(g,c,w)),w.stop(),$}j(g,c=[],w){const $=E._util.getServiceDependencies(g).sort((i,r)=>i.index-r.index),h=[];for(const i of $){const r=this.m(i.id,w);r||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const m=$.length>0?$[0].index:c.length;if(c.length!==m){console.trace(`[createInstance] First service dependency of ${g.name} at position ${m+1} conflicts with ${c.length} static arguments`);const i=m-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,m)}return Reflect.construct(g,c.concat(h))}k(g,c){if(this.f.get(g)instanceof j.$ei)this.f.set(g,c);else if(this.h)this.h.k(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const c=this.f.get(g);return!c&&this.h?this.h.l(g):c}m(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const w=this.l(g);return w instanceof j.$ei?this.q(g,w,c.branch(g,!0)):(c.branch(g,!1),w)}q(g,c,w){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,c,w)}finally{this.o.delete(g)}}r(g,c,w){const $=new N.$Vq(i=>i.id.toString());let h=0;const m=[{id:g,desc:c,_trace:w}];for(;m.length;){const i=m.pop();if($.lookupOrInsertNode(i),h++>1e3)throw new v($);for(const r of E._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof j.$ei){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};$.insertEdge(i,n),m.push(n)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new v($);break}for(const{data:r}of i){if(this.l(r.id)instanceof j.$ei){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}$.removeNode(r)}}return this.l(g)}s(g,c,w=[],$,h){if(this.f.get(g)instanceof j.$ei)return this.t(g,c,w,$,h);if(this.h)return this.h.s(g,c,w,$,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(g,c,w=[],$,h){if($){const m=new d(void 0,this.g,this,this.i);m.c=String(g);const i=new Map,r=new D.$Ah(()=>{const t=m.j(c,w,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const u of s)u.disposable=o.apply(t,u.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let u=i.get(n);return u||(u=new a.$5c,i.set(n,u)),(I,L,U)=>{if(r.isInitialized)return r.value[n](I,L,U);{const z={listener:[I,L,U],disposable:void 0},V=u.push(z);return(0,k.$Sc)(()=>{V(),z.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,w,h)}u(g,c){if(c&&console.warn(g),this.g)throw new Error(g)}}e.$Wq=d;var p;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(p||(p={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(g,c){return g?new y(1,c.name):y.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const w=new y(3,g.toString());return this.h.push([g,c,w]),w}stop(){const g=Date.now()-this.g;y.f+=g;let c=!1;function w(h,m){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of m.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=w(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(g>2||c)&&y.all.add($.join(`
`))}}e.$Xq=y});var oe=this&&this.__param||function(J,e){return function(D,O){e(D,O,J)}};define(ne[64],re([0,1,20,2,12,105,21,10]),function(J,e,D,O,k,j,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0,e.$yr=l;function l(b){return b.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$zr=(0,E.$hi)("languagePackService");let a=class extends O.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new D.$ee;setTimeout(()=>v.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const y=d.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(g=>g.startsWith("lp-"))).map(R=>{const g=R.properties.localizedLanguages?.[0],c=l(R);return{...this.f(c,g,R),extensionId:R.identifier.id,galleryExtension:R}});return y.push(this.f("en","English")),y}f(v,d,p){const y=d??v;let R;if(y!==v&&(R=`(${v})`),v.toLowerCase()===k.$w.toLowerCase()&&(R??="",R+=(0,j.localize)(0,null)),p?.installCount){R??="";const g=p.installCount;let c;g>1e6?c=`${Math.floor(g/1e5)/10}M`:g>1e3?c=`${Math.floor(g/1e3)}K`:c=String(g),R+=` $(cloud-download) ${c}`}return{id:v,label:y,description:R}}};e.$Ar=a,e.$Ar=a=$e([oe(0,N.$Qo)],a)}),define(ne[6],re([0,1,106,34,5,43,2,31,12,17,3,11,122,10]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=R,e.log=c,e.$2j=u,e.$3j=S,e.$4j=I,e.$5j=L,e.$Nj=(0,p.$hi)("logService"),e.$Oj=(0,p.$hi)("loggerService");function y(){return new Date().toISOString()}function R(U){return(0,b.$Yf)(U)}var g;(function(U){U[U.Off=0]="Off",U[U.Trace=1]="Trace",U[U.Debug=2]="Debug",U[U.Info=3]="Info",U[U.Warning=4]="Warning",U[U.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$Qj=g.Info;function c(U,z,V){switch(z){case g.Trace:U.trace(V);break;case g.Debug:U.debug(V);break;case g.Info:U.info(V);break;case g.Warning:U.warn(V);break;case g.Error:U.error(V);break;case g.Off:break;default:throw new Error(`Invalid log level ${z}`)}}function w(U,z=!1){let V="";for(let Q=0;Q<U.length;Q++){let se=U[Q];if(se instanceof Error&&(se=(0,O.$5i)(se,z)),typeof se=="object")try{se=JSON.stringify(se)}catch{}V+=(Q>0?" ":"")+se}return V}class $ extends N.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new k.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(z){this.b!==z&&(this.b=z,this.c.fire(this.b))}getLevel(){return this.b}f(z){return this.b!==g.Off&&this.b<=z}}e.$Sj=$;class h extends ${constructor(z){super(),this.h=z}f(z){return this.h||super.f(z)}trace(z,...V){this.f(g.Trace)&&this.g(g.Trace,w([z,...V],!0))}debug(z,...V){this.f(g.Debug)&&this.g(g.Debug,w([z,...V]))}info(z,...V){this.f(g.Info)&&this.g(g.Info,w([z,...V]))}warn(z,...V){this.f(g.Warning)&&this.g(g.Warning,w([z,...V]))}error(z,...V){if(this.f(g.Error))if(z instanceof Error){const Q=Array.prototype.slice.call(arguments);Q[0]=z.stack,this.g(g.Error,w(Q))}else this.g(g.Error,w([z,...V]))}flush(){}}e.$Tj=h;class m extends ${constructor(z=e.$Qj){super(),this.setLevel(z),this.g=!l.$i}trace(z,...V){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,z,...V):console.log(`[main ${y()}]`,z,...V))}debug(z,...V){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,z,...V):console.log(`[main ${y()}]`,z,...V))}info(z,...V){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,z,...V):console.log(`[main ${y()}]`,z,...V))}warn(z,...V){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,z,...V):console.warn(`[main ${y()}]`,z,...V))}error(z,...V){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,z,...V):console.error(`[main ${y()}]`,z,...V))}flush(){}}e.$Uj=m;class i extends ${constructor(z=e.$Qj,V=!0){super(),this.g=V,this.setLevel(z)}trace(z,...V){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",z,...V):console.log(z,...V))}debug(z,...V){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",z,...V):console.log(z,...V))}info(z,...V){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",z,...V):console.log(z,...V))}warn(z,...V){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",z,...V):console.log(z,...V))}error(z,...V){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",z,...V):console.error(z,...V))}flush(){}}e.$Vj=i;class r extends ${constructor(z,V=e.$Qj){super(),this.g=z,this.setLevel(V)}trace(z,...V){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(z),...V])}debug(z,...V){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(z),...V])}info(z,...V){this.f(g.Info)&&this.g.log(g.Info,[this.h(z),...V])}warn(z,...V){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(z),...V])}error(z,...V){this.f(g.Error)&&this.g.log(g.Error,[this.h(z),...V])}h(z){return typeof z=="string"?z:(0,O.$5i)(z,this.f(g.Trace))}flush(){}}e.$Wj=r;class t extends ${constructor(z){super(),this.g=z,z.length&&this.setLevel(z[0].getLevel())}setLevel(z){for(const V of this.g)V.setLevel(z);super.setLevel(z)}trace(z,...V){for(const Q of this.g)Q.trace(z,...V)}debug(z,...V){for(const Q of this.g)Q.debug(z,...V)}info(z,...V){for(const Q of this.g)Q.info(z,...V)}warn(z,...V){for(const Q of this.g)Q.warn(z,...V)}error(z,...V){for(const Q of this.g)Q.error(z,...V)}flush(){for(const z of this.g)z.flush()}dispose(){for(const z of this.g)z.dispose();super.dispose()}}e.$Xj=t;class n extends N.$Uc{constructor(z,V,Q){if(super(),this.h=z,this.j=V,this.b=new E.$Bc,this.c=this.B(new k.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$7d),this.onDidChangeVisibility=this.g.event,Q)for(const se of Q)this.b.set(se.resource,{logger:void 0,info:se})}m(z){return(0,b.$Uf)(z)?[...this.b.values()].find(V=>V.info.id===z):this.b.get(z)}getLogger(z){return this.m(z)?.logger}createLogger(z,V){const Q=this.n(z),se=(0,b.$Uf)(z)?z:V?.id??(0,j.$8i)(Q.toString()).toString(16);let te=this.b.get(Q)?.logger;const ue=V?.logLevel==="always"?g.Trace:V?.logLevel;te||(te=this.s(Q,ue??this.getLogLevel(Q)??this.h,{...V,id:se}));const he={logger:te,info:{resource:Q,id:se,logLevel:ue,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(he.info),this.b.set(Q,he),te}n(z){return(0,b.$Uf)(z)?(0,a.$Ug)(this.j,`${z}.log`):z}setLogLevel(z,V){if(v.URI.isUri(z)){const Q=z,se=V,te=this.b.get(Q);te&&se!==te.info.logLevel&&(te.info.logLevel=se===this.h?void 0:se,te.logger?.setLevel(se),this.b.set(te.info.resource,te),this.f.fire([Q,se]))}else{this.h=z;for(const[Q,se]of this.b.entries())this.b.get(Q)?.info.logLevel===void 0&&se.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(z,V){const Q=this.m(z);Q&&V!==!Q.info.hidden&&(Q.info.hidden=!V,this.b.set(Q.info.resource,Q),this.g.fire([Q.info.resource,V]))}getLogLevel(z){let V;return z&&(V=this.b.get(z)?.info.logLevel),V??this.h}registerLogger(z){const V=this.b.get(z.resource);V?V.info.hidden!==z.hidden&&this.setVisibility(z.resource,!z.hidden):(this.b.set(z.resource,{info:z,logger:void 0}),this.c.fire({added:[z],removed:[]}))}deregisterLogger(z){const V=this.b.get(z);V&&(V.logger&&V.logger.dispose(),this.b.delete(z),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const z of this.b.values())yield z.info}getRegisteredLogger(z){return this.b.get(z)?.info}dispose(){this.b.forEach(z=>z.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=n;class s{constructor(){this.onDidChangeLogLevel=new k.$7d().event}setLevel(z){}getLevel(){return g.Info}trace(z,...V){}debug(z,...V){}info(z,...V){}warn(z,...V){}error(z,...V){}critical(z,...V){}dispose(){}flush(){}}e.$Zj=s;class o extends s{}e.$1j=o;function u(U){if(U.verbose)return g.Trace;if(typeof U.logLevel=="string"){const z=L(U.logLevel.toLowerCase());if(z!==void 0)return z}return e.$Qj}function S(U){switch(U){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function I(U){switch(U){case g.Trace:return{original:"Trace",value:D.localize(0,null)};case g.Debug:return{original:"Debug",value:D.localize(1,null)};case g.Info:return{original:"Info",value:D.localize(2,null)};case g.Warning:return{original:"Warning",value:D.localize(3,null)};case g.Error:return{original:"Error",value:D.localize(4,null)};case g.Off:return{original:"Off",value:D.localize(5,null)}}}function L(U){switch(U){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$6j=new d.$yj("logLevel",S(g.Info))}),define(ne[65],re([0,1,8,10,6]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Wp=(0,O.$hi)("IExtensionSignatureVerificationService");let j=class{constructor(E){this.b=E}c(){return this.a||(this.a=new Promise((E,l)=>J(["@vscode/vsce-sign"],async a=>E(a),l))),this.a}async verify(E,l,a){let b;try{b=await this.c()}catch(v){return this.b.error("Could not load vsce-sign module",(0,D.$0)(v)),!1}return b.verify(E,l,a)}};e.$Xp=j,e.$Xp=j=$e([oe(0,k.$Nj)],j)}),define(ne[127],re([0,1,19,9,8,5,2,16,62,6]),function(J,e,D,O,k,j,N,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class b extends N.$Uc{constructor(d,p){super(),this.a=d,this.b=p,this.c=this.B(new j.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$fh(0)),this.w=[],this.y=this.B(new O.$fh(0))}watch(d,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(d,p):this.z(d,p)}n(d,p){const y={path:this.H(d),excludes:p.excludes,includes:p.includes,recursive:p.recursive,correlationId:p.correlationId},R=(0,D.$Ub)(this.j,y);return this.r(),(0,N.$Sc)(()=>{R(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,k.$1)(d))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,l.$yq)(p)),p=>this.G(p),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const p of this.j)(0,l.$uq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const p of this.j)(0,l.$uq)(p)&&d.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,p){const y={path:this.H(d),excludes:p.excludes,includes:p.includes,recursive:!1,correlationId:p.correlationId},R=(0,D.$Ub)(this.w,y);return this.C(),(0,N.$Sc)(()=>{R(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,k.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,l.$yq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,E.$ic)(d.fsPath)}}e.$Cq=b}),define(ne[128],re([0,1,19,9,14,20,5,43,66,2,48,15,129,17,46,102,13,61,6,8]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let m=class extends a.$Uc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new N.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$7d),this.Y=this.B(new N.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new O.$qh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new g.$7k(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await O.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return l.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,p.$Yg)(r))throw new g.$9k((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new $.$bb;throw n.message=(0,R.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,g.$Tk)(t)||(0,g.$Qk)(t)||(0,g.$Uk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,g.$Tk)(t)||(0,g.$Qk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,g.$4k)(n)===g.FileSystemProviderErrorCode.FileNotFound?new g.$9k((0,R.localize)(2,null,this.sb(r)),1):(0,g.$2k)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,u=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,I=await n.stat(r);let L;return this.t(n,r,I,void 0,!!S,(U,z)=>(L||(L=b.$ni.forUris(()=>!s),L.set(r,!0),o&&L.fill(!0,o)),L.get(U.resource)||L.findSuperstr(U.resource.with({query:null,fragment:null}))?!0:U.isDirectory&&u?z===1:!1))}async t(r,t,n,s,o,u){const{providerExtUri:S}=this.R(r),I={resource:t,name:S.basename(t),isFile:(n.type&g.FileType.File)!==0,isDirectory:(n.type&g.FileType.Directory)!==0,isSymbolicLink:(n.type&g.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&g.FilePermission.Locked),etag:(0,g.$hl)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&u(I,s)){try{const L=await r.readdir(t),U=await O.Promises.settled(L.map(async([z,V])=>{try{const Q=S.joinPath(t,z),se=o?await r.stat(Q):{type:V};return await this.t(r,Q,se,L.length,o,u)}catch(Q){return this.b.trace(Q),null}}));I.children=(0,D.$Hb)(U)}catch(L){this.b.trace(L),I.children=[]}return I}return I}async resolveAll(r){return O.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new g.$9k((0,R.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$ue.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new g.$6k(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let u=n;if((0,g.$Wk)(s)&&!u?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(u={...n,atomic:S})}try{await this.w(s,r,u)||await this.U(s,o.dirname(r));let I;if((0,g.$Qk)(s)&&!(t instanceof k.$ue))if((0,y.$ge)(t)){const L=await(0,y.$ne)(t,3);L.ended?I=k.$ue.concat(L.buffer):I=L}else I=(0,y.$ke)(t,L=>k.$ue.concat(L),3);else I=t;!(0,g.$Tk)(s)||(0,g.$Qk)(s)&&I instanceof k.$ue||(0,g.$Qk)(s)&&(0,g.$Wk)(s)&&u?.atomic?await this.hb(s,r,u,I):await this.db(s,r,u,I instanceof k.$ue?(0,k.$Fe)(I):I),this.r.fire(new g.$6k(r,4))}catch(S){throw new g.$9k((0,R.localize)(4,null,this.sb(r),(0,g.$2k)(S).toString()),(0,g.$5k)(S),u)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(t)));if(s)throw new Error((0,R.localize)(8,null,this.sb(t)))}let u;try{u=await r.stat(t)}catch{return}if(u.type&g.FileType.Directory)throw new g.$9k((0,R.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,u),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==g.$gl&&typeof u.mtime=="number"&&typeof u.size=="number"&&n.mtime<u.mtime&&n.etag!==(0,g.$hl)({mtime:n.mtime,size:u.size}))throw new g.$9k((0,R.localize)(10,null),3,n);return u}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,u)=>{this.cb.queueFor(t,async()=>{try{const S=await this.C(r,t,n,s);o(S)}catch(S){u(S)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Ge)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new j.$ee(s);let u=n;(0,g.$Vk)(r)&&r.enforceAtomicReadFile?.(t)&&(u={...n,atomic:!0});const S=this.J(t,u).then(L=>L,L=>{throw o.dispose(!0),L});let I;try{return typeof u?.etag=="string"&&u.etag!==g.$gl&&await S,u?.atomic&&(0,g.$Vk)(r)||!((0,g.$Tk)(r)||(0,g.$Uk)(r))||(0,g.$Qk)(r)&&u?.preferUnbuffered?I=this.I(r,t,u):(0,g.$Uk)(r)?I=this.G(r,t,o.token,u):I=this.H(r,t,o.token,u),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await S,value:I}}catch(L){throw I&&await(0,y.$le)(I),this.F(L,t,u)}}F(r,t,n){const s=(0,R.localize)(11,null,this.sb(t),(0,g.$2k)(r).toString());return r instanceof g.$$k?new g.$$k(s,r.stat,n):r instanceof g.$0k?new g.$0k(s,r.fileOperationResult,r.size,r.options):new g.$9k(s,(0,g.$5k)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,y.$re)(o,{data:u=>u instanceof k.$ue?u:k.$ue.wrap(u),error:u=>this.F(u,t,s)},u=>k.$ue.concat(u))}H(r,t,n,s=Object.create(null)){const o=(0,k.$Ke)();return(0,c.$sq)(r,t,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.F(u,t,s)},n),o}I(r,t,n){const s=(0,y.$ie)(o=>k.$ue.concat(o));return(async()=>{try{let o;n?.atomic&&(0,g.$Vk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(k.$ue.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new g.$9k((0,R.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==g.$gl&&t.etag===n.etag)throw new g.$$k((0,R.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new g.$0k((0,R.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),u=this.qb(await this.n(t),t);await this.Q(o,r,u,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),u=await this.N(s,r,o,t,"move",!!n),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$6k(r,u==="move"?2:3,S)),S}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),u=await this.N(s,r,o,t,"copy",!!n),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new g.$6k(r,u==="copy"?3:2,S)),S}async N(r,t,n,s,o,u){if(t.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,u);if(S&&!I&&u&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,g.$Rk)(r))await r.copy(t,s,{overwrite:u});else{const L=await this.resolve(t);L.isDirectory?await this.P(r,L,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:u}),o):(await this.N(r,t,n,s,"copy",u),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,g.$Tk)(r)&&(0,g.$Tk)(n))return this.jb(r,t,n,s);if((0,g.$Tk)(r)&&(0,g.$Qk)(n))return this.pb(r,t,n,s);if((0,g.$Qk)(r)&&(0,g.$Tk)(n))return this.nb(r,t,n,s);if((0,g.$Qk)(r)&&(0,g.$Qk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await O.Promises.settled(t.children.map(async o=>{const u=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,u):this.O(r,o.resource,n,u)}))}async Q(r,t,n,s,o,u){let S=!1;if(r===n){const{providerExtUri:L,isPathCaseSensitive:U}=this.R(r);if(U||(S=L.isEqual(t,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(t),this.sb(s)));if(!S&&L.isEqualOrParent(s,t))throw new Error((0,R.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!S){if(!u)throw new g.$9k((0,R.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:L}=this.R(r);if(L.isEqualOrParent(t,s))throw new Error((0,R.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:S}}R(r){const t=this.S(r);return{providerExtUri:t?p.$Kg:p.$Mg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$6k(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&g.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(t)));break}catch(o){if((0,g.$4k)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(u){if((0,g.$4k)(u)!==g.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let u;try{u=await n.stat(r)}catch{}if(u)this.rb(r,u);else throw new g.$9k((0,R.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,g.$Xk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,u=!!s?.recursive,S=s?.atomic??!1;await n.delete(r,{recursive:u,useTrash:o,atomic:S}),this.r.fire(new g.$6k(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,g.$Sk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,g.$Rk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Tc;let s=!1,o=()=>{s=!0};n.add((0,a.$Sc)(()=>o())),(async()=>{try{const S=await this.bb(r,t);s?(0,a.$Pc)(S):o=()=>(0,a.$Pc)(S)}catch(S){this.b.error(S)}})();const u=t.correlationId;if(typeof u=="number"){const S=n.add(new N.$7d);return n.add(this.X.event(L=>{L.correlates(u)&&S.fire(L)})),{onDidChange:S.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,E.$8i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,y.$ge)(s)||(0,y.$he)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(u){throw(0,g.$2k)(u)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,y.$he)(n)){if(n.buffer.length>0){const u=k.$ue.concat(n.buffer);await this.gb(r,t,u,u.byteLength,s,0),s+=u.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((u,S)=>{(0,y.$me)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(L){return S(L)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>S(I),onEnd:()=>u()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,u){let S=0;for(;S<s;){const I=await r.write(t,o+S,n.buffer,u+S,s-S);S+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof k.$ue?o=s:(0,y.$ge)(s)?o=await(0,k.$Ge)(s):(0,y.$he)(s)?o=await(0,k.$He)(s):o=(0,k.$Ee)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,u;try{o=await r.open(t,{create:!1}),u=await n.open(s,{create:!0,unlock:!1});const S=k.$ue.alloc(this.a);let I=0,L=0,U=0;do U=await r.read(o,I,S.buffer,L,S.byteLength-L),await this.gb(n,u,S,U,I,L),I+=U,L+=U,L===S.byteLength&&(L=0);while(U>0)}catch(S){throw(0,g.$2k)(S)}finally{await O.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof u=="number"?n.close(u):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const u=await r.readFile(t);await this.gb(n,o,k.$ue.wrap(u),u.byteLength,0,0)}catch(u){throw(0,g.$2k)(u)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,k.$Ge)(this.H(r,t,j.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new g.$9k((0,R.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&g.FilePermission.Readonly)throw new g.$9k((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$tq=m,e.$tq=m=h=$e([oe(0,w.$Nj)],m)}),define(ne[130],re([0,1,59,173,9,31,14,5,174,2,16,12,17,46,24,104,13,61,127,34,125,124]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$5i)(r)}`)}})();class i extends w.$Cq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=E.Event.None,this.N=new j.$Bc(s=>d.$Lg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await y.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:g.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await y.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,d.$Ug)(t,o.name))).type:u=this.M(o),s.push([o.name,u])}catch(u){this.a.trace(u)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=g.FileType.Unknown:t.isFile()?s=g.FileType.File:t.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,n&&(s|=g.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new k.$gh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await y.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,p.$ie)(u=>N.$ue.concat(u.map(S=>N.$ue.wrap(S))).buffer);return(0,c.$sq)(this,t,o,u=>u.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Ug)((0,d.$Tg)(t),`${(0,d.$Rg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await y.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const u=new a.$Tc;try{u.add(await this.O(t)),u.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(S){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{u.dispose()}}async S(t,n,s,o){let u;try{const S=this.H(t);if(!s.create||!s.overwrite){if(await y.Promises.exists(S)){if(!s.overwrite)throw(0,g.$1k)((0,R.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$1k)((0,R.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(u,0,n,0,n.byteLength)}catch(S){throw await this.gb(t,S)}finally{typeof u=="number"&&await this.close(u)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let u;(0,g.$Ok)(n)&&!s&&(u=await this.O(t));let S;try{if((0,g.$Ok)(n)&&n.unlock)try{const{stat:L}=await y.SymlinkSupport.stat(o);L.mode&128||await y.Promises.chmod(o,L.mode|128)}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}let I;if((0,g.$Ok)(n)){if(v.$i)try{await y.Promises.truncate(o,0),I="r+"}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}I||(I="w")}else I="r";S=await y.Promises.open(o,I)}catch(I){throw u?.dispose(),(0,g.$Ok)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(S,0),(0,g.$Ok)(n)&&this.X.set(S,t),u){const I=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.W.set(S,u),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),I.dispose())}return S}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await y.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await y.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,u){const S=this.Z(t,n);let I=null;try{I=(await y.Promises.read(t,s,o,u,S)).bytesRead}catch(L){throw this.fb(L)}finally{this.$(t,S,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,u){return(0,k.$Bh)(()=>this.ab(t,n,s,o,u),100,3)}async ab(t,n,s,o,u){const S=this.Z(t,n);let I=null;try{I=(await y.Promises.write(t,s,o,u,S)).bytesWritten}catch(L){throw await this.gb(this.X.get(t),L)}finally{this.$(t,S,I)}return I}async mkdir(t){try{await y.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,b.$kc)((0,b.$nc)(s),`${(0,b.$oc)(s)}${n.atomic.postfix}`)),await y.Promises.rm(s,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let u=!1;try{const{stat:S,symbolicLink:I}=await y.SymlinkSupport.stat(s);u=S.isDirectory()&&!I}catch{}if(u)await y.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),u=this.H(n);if(o!==u)try{await this.bb(t,n,"move",s.overwrite),await y.Promises.rename(o,u)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(2,null,(0,b.$oc)(o),(0,b.$oc)((0,b.$nc)(u)),S.toString()))),this.fb(S)}}async copy(t,n,s){const o=this.H(t),u=this.H(n);if(o!==u)try{await this.bb(t,n,"copy",s.overwrite),await y.Promises.copy(o,u,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(3,null,(0,b.$oc)(o),(0,b.$oc)((0,b.$nc)(u)),S.toString()))),this.fb(S)}}async bb(t,n,s,o){const u=this.H(t),S=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,l.$gg)(u,S,!0)),I){if(s==="copy")throw(0,g.$1k)((0,R.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const U=await this.L(t);if(!U)throw(0,g.$1k)((0,R.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const z=await this.L(n);if(z){if(!o)throw(0,g.$1k)((0,R.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);U.type&g.FileType.File&&z.type&g.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),u=this.H(n),S=!!(this.capabilities&1024);if((0,l.$gg)(o,u,!S))return;const I=new a.$Tc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await y.Promises.mkdir((0,b.$nc)(u),{recursive:!0}),await y.Promises.copyFile(o,u)}catch(L){if(L.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(L)}finally{I.dispose()}}t(t,n,s){return new h.$Jq(o=>t(o),o=>n(o),s)}F(t,n,s){return new m.$Sq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof g.$Zk)return t;let n=t,s;switch(t.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$1k)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,g.$1k)(n,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Tq=i}),define(ne[131],re([0,1,2,6]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;class k extends D.$Uc{constructor(N,E=[]){super(),this.a=new O.$Xj([N,...E]),this.B(N.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...E){this.a.trace(N,...E)}debug(N,...E){this.a.debug(N,...E)}info(N,...E){this.a.info(N,...E)}warn(N,...E){this.a.warn(N,...E)}error(N,...E){this.a.error(N,...E)}flush(){this.a.flush()}}e.$YP=k}),define(ne[132],re([0,1,13,6]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function j(a,b,v,d,p){try{const y=await new Promise((g,c)=>{J(["@vscode/spdlog"],g,c)});y.setFlushOn(k.Trace);const R=await y.createAsyncRotatingLogger(a,b,v,d);return p?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(y){console.error(y)}return null}function N(a,b,v){switch(b){case O.LogLevel.Trace:a.trace(v);break;case O.LogLevel.Debug:a.debug(v);break;case O.LogLevel.Info:a.info(v);break;case O.LogLevel.Warning:a.warn(v);break;case O.LogLevel.Error:a.error(v);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function E(a,b){switch(b){case O.LogLevel.Trace:a.setLevel(k.Trace);break;case O.LogLevel.Debug:a.setLevel(k.Debug);break;case O.LogLevel.Info:a.setLevel(k.Info);break;case O.LogLevel.Warning:a.setLevel(k.Warning);break;case O.LogLevel.Error:a.setLevel(k.Error);break;case O.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class l extends O.$Tj{constructor(b,v,d,p,y){super(),this.m=[],this.setLevel(y),this.n=this.s(b,v,d,p),this.B(this.onDidChangeLogLevel(R=>{this.r&&E(this.r,R)}))}async s(b,v,d,p){const y=d?6:1,R=30/y*D.$jl.MB,g=await j(b,v,R,y,p);if(g){this.r=g,E(this.r,this.getLevel());for(const{level:c,message:w}of this.m)N(this.r,c,w);this.m=[]}}g(b,v){this.r?N(this.r,b,v):this.getLevel()<=b&&this.m.push({level:b,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NP=l}),define(ne[133],re([0,1,28,6,132]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=void 0;class j extends O.$Yj{s(E,l,a){return new k.$NP((0,D.$Dg)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,l)}}e.$OP=j}),define(ne[39],re([0,1,5,66,2,10]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=void 0,e.$2n=(0,j.$hi)("policy");class N extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const b=Object.keys(this.f).length;return this.f={...a,...this.f},b!==Object.keys(this.f).length&&await this.j(a),O.Iterable.reduce(this.g.entries(),(v,[d,p])=>({...v,[d]:p}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(a,[b,v])=>({...a,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.$3n=N;class E{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$4n=E}),define(ne[134],re([0,1,9,5,66,3,13,6,39]),function(J,e,D,O,k,j,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;function a(v,d){const p=[];for(const y of new Set(k.Iterable.concat(v.keys(),d.keys())))v.get(y)!==d.get(y)&&p.push(y);return p}let b=class extends l.$3n{constructor(d,p,y){super(),this.m=d,this.n=p,this.s=y,this.c=this.B(new D.$fh(500));const R=O.Event.filter(p.onDidFilesChange,g=>g.affects(d));this.B(p.watch(d)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const p=await this.n.readFile(this.m),y=JSON.parse(p.value.toString());if(!(0,j.$Wf)(y))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(y))this.f[R]&&d.set(R,y[R])}catch(p){p.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",p)}return d}async w(){const d=await this.u(),p=a(this.g,d);this.g=d,p.length>0&&this.h.fire(p)}};e.$tbc=b,e.$tbc=b=$e([oe(1,N.$Nk),oe(2,E.$Nj)],b)}),define(ne[135],re([0,1,39,9,2,6]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=void 0;let N=class extends D.$3n{constructor(l,a){super(),this.m=l,this.n=a,this.a=new O.$bh,this.b=this.B(new k.$Vc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`);const{createWatcher:a}=await new Promise((b,v)=>{J(["@vscode/policy-watcher"],b,v)});await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=a(this.n,l,d=>{this.t(d),b()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),v(d)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const a in l){const b=l[a];b===void 0?this.g.delete(a):this.g.set(a,b)}this.h.fire(Object.keys(l))}};e.$sbc=N,e.$sbc=N=$e([oe(0,j.$Nj)],N)}),define(ne[32],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,D.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,72,3]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class k{constructor(){this.a=new Map}add(N,E){D.ok(O.$Uf(N)),D.ok(O.$Wf(E)),D.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,E)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$Zn=new k}),define(ne[136],re([0,1,5,36]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class j{constructor(){this.b=new D.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,a){this.a[k(l)]=a,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const N=new j;O.$Zn.add(e.$1n.JSONContribution,N)}),define(ne[40],re([0,1,19,5,3,91,29,136,36]),function(J,e,D,O,k,j,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=R,e.$eo=g,e.$fo=c,e.$go=$,e.$ho=h;var a;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$5n={Configuration:"base.contributions.configuration"};var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const v=l.$Zn.as(E.$1n.JSONContribution);class d{constructor(){this.h=new Set,this.i=new O.$7d,this.onDidSchemaChange=this.i.event,this.j=new O.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),v.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),v.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),v.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$co.test(o)){const u=this.a.get(o),S=u?.valuesSources??new Map;if(s)for(const z of Object.keys(n[o]))S.set(z,s);const I={...u?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:S});const L=(0,N.$Xi)(o),U={type:"object",default:I,description:j.localize(1,null,L),$ref:e.$_n,defaultDefaultValue:I,source:k.$Uf(s)?void 0:s,defaultValueSource:s};t.push(...R(o)),this.d[o]=U,this.b.properties[o]=U}else{this.a.set(o,{value:n[o],source:s});const u=this.d[o];u&&(this.w(o,u),this.r(o,u))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),u=k.$Uf(n)?n:n?.id,S=k.$Uf(o?.source)?o?.source:o?.source?.id;if(u===S)if(r.add(s),this.a.delete(s),e.$co.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=k.$4f(i.scope)?s:i.scope;const u=i.properties;if(u)for(const I in u){const L=u[I];if(r&&$(I,L)){delete u[I];continue}if(L.source=t,L.defaultDefaultValue=u[I].default,this.w(I,L),e.$co.test(I)?L.scope=void 0:(L.scope=k.$4f(L.scope)?s:L.scope,L.restricted=k.$4f(L.restricted)?!!n?.includes(I):L.restricted),u[I].hasOwnProperty("included")&&!u[I].included){this.f[I]=u[I],delete u[I];continue}else this.d[I]=u[I],u[I].policy?.name&&this.e.set(u[I].policy.name,I);!u[I].deprecationMessage&&u[I].markdownDeprecationMessage&&(u[I].deprecationMessage=u[I].markdownDeprecationMessage),o.add(I)}const S=i.allOf;if(S)for(const I of S)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$6n.properties[i]=r,r.scope){case 1:e.$7n.properties[i]=r;break;case 2:e.$8n.properties[i]=r;break;case 6:e.$9n.properties[i]=r;break;case 3:e.$0n.properties[i]=r;break;case 4:e.$$n.properties[i]=r;break;case 5:e.$$n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$6n.properties[i],r.scope){case 1:delete e.$7n.properties[i];break;case 2:delete e.$8n.properties[i];break;case 6:delete e.$9n.properties[i];break;case 3:delete e.$0n.properties[i];break;case 4:case 5:delete e.$$n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$_n};this.w(r,t),e.$6n.properties[r]=t,e.$7n.properties[r]=t,e.$8n.properties[r]=t,e.$9n.properties[r]=t,e.$0n.properties[r]=t,e.$$n.properties[r]=t}}v(){const i={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=i,e.$7n.patternProperties[e.$bo]=i,e.$8n.patternProperties[e.$bo]=i,e.$9n.patternProperties[e.$bo]=i,e.$0n.patternProperties[e.$bo]=i,e.$$n.patternProperties[e.$bo]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;k.$2f(n)&&(n=r.defaultDefaultValue,s=void 0),k.$2f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",y=new RegExp(p,"g");e.$bo=`^(${p})+$`,e.$co=new RegExp(e.$bo);function R(m){const i=[];if(e.$co.test(m)){let r=y.exec(m);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=y.exec(m)}}return(0,D.$Mb)(i)}function g(m){return m.reduce((i,r)=>`${i}[${r}]`,"")}function c(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new d;l.$Zn.add(e.$5n.Configuration,w);function $(m,i){return m.trim()?e.$co.test(m)?j.localize(7,null,m):w.getConfigurationProperties()[m]!==void 0?j.localize(8,null,m):i.policy?.name&&w.getPolicyConfigurations().get(i.policy?.name)!==void 0?j.localize(9,null,m,i.policy?.name,w.getPolicyConfigurations().get(i.policy?.name)):null:j.localize(6,null)}function h(){const m=[],i=w.getConfigurationProperties();for(const r of Object.keys(i))m.push([r,i[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}}),define(ne[67],re([0,1,19,5,38,2,31,27,3,11,29,40,36]),function(J,e,D,O,k,j,N,E,l,a,b,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=$;function p(r){return Object.isFrozen(r)?r:E.$On(r)}class y{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof y)return n;const s=new R("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,b.$Vi)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return p(s.rawConfiguration.getValue(t))},get override(){return n?p(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return p(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:S,keys:I}of s.rawConfiguration.overrides){const L=new y(u,I).getValue(t);L!==void 0&&o.push({identifiers:S,value:L})}return o.length?p(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,b.$Vi)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return D.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return D.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=E.$Nn(this.contents),s=E.$Nn(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const S of t)if(u.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(n,S.contents);for(const I of S.overrides){const[L]=s.filter(U=>D.$ub(U.identifiers,I.identifiers));L?(this.h(L.contents,I.contents),L.keys.push(...I.keys),L.keys=D.$Mb(L.keys)):s.push(E.$Nn(I))}for(const I of S.keys)o.indexOf(I)===-1&&o.push(I)}return new y(n,o,s,u.every(S=>S instanceof y)?void 0:u)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[o];const S=n[o];S&&(typeof u=="object"&&typeof S=="object"?(u=E.$Nn(u),this.h(u,S)):u=S),s[o]=u}return new y(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&l.$Wf(t[s])&&l.$Wf(n[s])){this.h(t[s],n[s]);continue}t[s]=E.$Nn(n[s])}}i(t){let n=null,s=null;const o=u=>{u&&(s?this.h(s,u):s=E.$Nn(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?n=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,b.$Ui)(this.contents,t),v.$co.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>D.$ub(s.identifiers,(0,v.$do)(t))),1))}j(t,n,s){(0,b.$Ti)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$co.test(t)&&this.overrides.push({identifiers:(0,v.$do)(t),keys:Object.keys(this.contents[t]),contents:(0,b.$Si)(this.contents[t],o=>console.error(o))})}}e.$io=y;class R{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!l.$4f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:u,restricted:S,hasExcludedProperties:I}=this.h(t,n);this.b=new y(s,o,u,I?[t]:void 0),this.c=S||[]}g(t){let n={},s=null,o=[];const u=[],S=[];function I(U){Array.isArray(o)?o.push(U):s!==null&&(o[s]=U)}const L={onObjectBegin:()=>{const U={};I(U),u.push(o),o=U,s=null},onObjectProperty:U=>{s=U},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const U=[];I(U),u.push(o),o=U,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:I,onError:(U,z,V)=>{S.push({error:U,offset:z,length:V})}};if(t)try{k.$Bn(t,L),n=o[0]||{}}catch(U){console.error(`Error while parsing settings file ${this.f}: ${U}`),this.d=[U]}return n}h(t,n){const s=d.$Zn.as(v.$5n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const u=(0,b.$Si)(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),S=Object.keys(t),I=this.j(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:u,keys:S,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const S={},I=[];for(const L in t)if(v.$co.test(L)&&s){const U=this.i(t[L],n,!1,o);S[L]=U.raw,u=u||U.hasExcludedProperties,I.push(...U.restricted)}else{const U=n[L],z=U?typeof U.scope<"u"?U.scope:3:void 0;U?.restricted&&I.push(L),!o.exclude?.includes(L)&&(o.include?.includes(L)||(z===void 0||o.scopes===void 0||o.scopes.includes(z))&&!(o.skipRestricted&&U?.restricted))?S[L]=t[L]:u=!0}return{raw:S,restricted:I,hasExcludedProperties:u}}j(t,n){const s=[];for(const o of Object.keys(t))if(v.$co.test(o)){const u={};for(const S in t[o])u[S]=t[o][S];s.push({identifiers:(0,v.$do)(o),keys:Object.keys(u),contents:(0,b.$Si)(u,n)})}return s}}e.$jo=R;class g extends j.$Uc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new O.$7d),this.onDidChange=this.b.event,this.a=new R(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,u=>u.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&s.isEqual(u.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=g;class c{constructor(t,n,s,o,u,S,I,L,U,z,V,Q,se){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=u,this.f=S,this.g=I,this.h=L,this.i=U,this.j=z,this.k=V,this.l=Q,this.m=se}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class w{constructor(t,n,s,o,u=new y,S=new y,I=new N.$Bc,L=new y,U=new N.$Bc){this.c=t,this.d=n,this.f=s,this.g=o,this.h=u,this.i=S,this.j=I,this.l=L,this.m=U,this.a=null,this.b=new N.$Bc,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new y,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),u=this.t(n.resource,s),S=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const L of o.overrides)for(const U of L.identifiers)o.getOverrideValue(t,U)!==void 0&&I.add(U);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,u||void 0,S)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:u,removed:S}=m(this.c,t);n=[...o,...u,...S]}for(const o of n)for(const u of(0,v.$do)(o)){const S=this.c.getKeysForOverrideIdentifier(u),I=t.getKeysForOverrideIdentifier(u),L=[...I.filter(U=>S.indexOf(U)===-1),...S.filter(U=>I.indexOf(U)===-1),...S.filter(U=>!E.$Rn(this.c.override(u).getValue(U),t.override(u).getValue(U)))];s.push([u,L])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=m(this.d,t),u=[...n,...s,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=m(this.applicationConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=m(this.localUserConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=m(this.remoteUserConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:u}=m(this.workspaceConfiguration,t),S=[...n,...s,...o];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:u,removed:S,overrides:I}=m(s,n),L=[...o,...u,...S];return(L.length||!s)&&this.updateFolderConfiguration(t,n),{keys:L,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:u,overrides:S}=m(n,void 0);return{keys:[...s,...o,...u],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const u=this.m.get(t);u&&(s=s.merge(u))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:u}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),u=this.w(t.user),S=this.w(t.workspace),I=t.folders.reduce((L,U)=>(L.set(a.URI.revive(U[0]),this.w(U[1])),L),new N.$Bc);return new w(n,s,o,u,new y,S,I,new y,new N.$Bc)}static w(t){return new y(t.contents,t.keys,t.overrides)}}e.$lo=w;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,S])=>{const I=(0,N.$yc)(n,u,new Set);S.forEach(L=>I.add(L))});const s=[];return n.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...t.values()],overrides:s}}class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const u of t.keys)this.affectedKeys.add(u);for(const[,u]of t.overrides)for(const S of u)this.affectedKeys.add(S);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=w.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const u=o+s.length;if(u>=this.d.length)return!1;const S=this.d.charCodeAt(u);if(S!==this.b&&S!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,L=this.g.getValue(t,n,this.h);return!E.$Rn(I,L)}return!0}}e.$no=h;function m(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),u=[],S=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const L=I.filter(U=>!S.includes(U));for(const U of L)u.push([U,t.getKeysForOverrideIdentifier(U)])}if(r){const L=S.filter(U=>!I.includes(U));for(const U of L)u.push([U,r.getKeysForOverrideIdentifier(U)])}if(t&&r){for(const L of S)if(I.includes(L)){const U=i({contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)},{contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)});u.push([L,[...U.added,...U.removed,...U.updated]])}}return{added:n,removed:s,updated:o,overrides:u}}function i(r,t){const n=r?t?r.keys.filter(u=>t.keys.indexOf(u)===-1):[...r.keys]:[],s=t?r?t.keys.filter(u=>r.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(r&&t){for(const u of t.keys)if(r.keys.indexOf(u)!==-1){const S=(0,b.$Vi)(t.contents,u),I=(0,b.$Vi)(r.contents,u);E.$Rn(S,I)||o.push(u)}}return{added:n,removed:s,updated:o}}}),define(ne[137],re([0,1,19,5,2,27,3,67,40,6,39,36]),function(J,e,D,O,k,j,N,E,l,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0;class d extends k.$Uc{constructor(){super(...arguments),this.a=this.B(new O.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$io}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$Zn.as(l.$5n.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.c(Array.from(g),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,c){this.h(g,v.$Zn.as(l.$5n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new E.$io;const g=v.$Zn.as(l.$5n.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,c){const w=this.f();for(const $ of g){const h=w[$],m=c[$];h!==void 0?this.b.addValue($,h):m?this.b.addValue($,m.default):this.b.removeValue($)}}}e.$oo=d;class p{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new E.$io}async initialize(){return this.configurationModel}}e.$po=p;let y=class extends k.$Uc{get configurationModel(){return this.b}constructor(g,c,w){super(),this.c=g,this.f=c,this.g=w,this.a=this.B(new O.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$io}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const c={},w=[],$=v.$Zn.as(l.$5n.Configuration).getConfigurationProperties();for(const h of g){const m=$[h];if(!m){w.push(h);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}w.push(h),c[m.policy.name]={type:m.type}}}return(0,N.$8f)(c)||await this.f.updatePolicyDefinitions(c),w}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const c=v.$Zn.as(l.$5n.Configuration).getPolicyConfigurations(),w=(0,D.$Hb)(g.map($=>c.get($)));this.m(w,!0)}m(g,c){this.g.trace("PolicyConfiguration#update",g);const w=v.$Zn.as(l.$5n.Configuration).getConfigurationProperties(),$=[],h=this.b.isEmpty();for(const m of g){const i=w[m]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,j.$Rn)(this.b.getValue(m),r))&&$.push([m,r])}else this.b.getValue(m)!==void 0&&$.push([m,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const m=this.b;this.b=new E.$io;for(const i of m.keys)this.b.setValue(i,m.getValue(i));for(const[i,r]of $)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$qo=y,e.$qo=y=$e([oe(1,b.$2n),oe(2,a.$Nj)],y)}),define(ne[138],re([0,1,19,9,14,5,38,74,2,27,12,17,29,67,40,137,39]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0;class c extends l.$Uc{constructor(h,m,i,r){super(),this.m=h,this.h=this.B(new j.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new R.$oo),this.c=i instanceof g.$4n?new R.$po:this.B(new R.$qo(this.b,i,r)),this.f=this.B(new p.$ko(this.m,{},v.$Lg,m)),this.a=new p.$lo(this.b.configurationModel,this.c.configurationModel,new p.$io,new p.$io),this.j=new w(h,m,this),this.g=this.B(new O.$th(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,m,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$lo(h,m,new p.$io,i)}getConfigurationData(){return this.a.toData()}getValue(h,m){const i=typeof h=="string"?h:void 0,r=(0,d.$Oi)(h)?h:(0,d.$Oi)(m)?m:{};return this.a.getValue(i,r,void 0)}async updateValue(h,m,i,r,t){const n=(0,d.$Pi)(i)?i:(0,d.$Oi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,D.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$Rn)(m,o.defaultValue)&&(m=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const S=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(L=>(0,D.$ub)([...L.identifiers].sort(),S));I&&(n.overrideIdentifiers=I.identifiers)}const u=n?.overrideIdentifiers?.length?[(0,y.$eo)(n.overrideIdentifiers),h]:[h];await this.j.write(u,m),await this.reloadConfiguration()}inspect(h,m={}){return this.a.inspect(h,m,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const m=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,m,2)}r(h,m){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,m);this.t(r,i,7)}s(h){const m=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,m,7)}t(h,m,i){const r=new p.$no(h,{data:m},this.a);r.source=i,this.h.fire(r)}}e.$ro=c;class w{constructor(h,m,i){this.b=h,this.c=m,this.d=i,this.a=new O.$oh}write(h,m){return this.a.queue(()=>this.e(h,m))}async e(h,m){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,N.$un)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,m);i=(0,E.$Mn)(i,t),await this.c.writeFile(this.b,k.$ue.fromString(i))}f(h,m,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!m.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$Jn)(h,m,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=b.OS===3||b.OS===2?`
`:`\r
`;const m=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});m&&typeof m=="string"&&m!=="auto"&&(h=m),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ne[68],re([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=O,e.$tm=k,e.$um=j,e.$vm=N;function O(l){return l.scheme===D.Schemas.vscodeRemote?l.authority:void 0}function k(l){if(!l)return;const a=l.indexOf("+");return a<0?l:l.substr(0,a)}function j(l){const{host:a,port:b}=E(l);if(typeof b>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:b}}function N(l,a){let{host:b,port:v}=E(l);return typeof v>"u"&&(v=a),{host:b,port:v}}function E(l){const a=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const b=l.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(ne[37],re([0,1,30,10,68]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=j,e.$Fm=v,e.$Gm=d,e.$Hm=p,e.$Im=y,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function j(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(N||(e.ExtensionType=N={}));var E;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class l{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const w=typeof g=="string"?g:g.value,$=typeof c=="string"?c:c.value;return D.$lf(w,$)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Cm=l;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(l.toKey(g))}delete(g){return this.c.delete(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}}e.$Dm=a;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(l.toKey(g))}get(g){return this.c.get(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}set(g,c){this.c.set(l.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=b;function v(R){return d(R)}function d(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function p(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function y(R,g){if(g){const c=`onResolveRemoteAuthority:${(0,k.$tm)(g)}`;return!!R.activationEvents?.includes(c)}return!1}e.$Jm=(0,O.$hi)("IBuiltinExtensionsScannerService")}),define(ne[139],re([0,1,2,37,13]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class j extends D.$Uc{constructor(E,l,a,b,v){super(),this.a=E,this.b=l,this.c=a,this.f=v,this.B(b.onDidInstallExtensions(d=>this.g(d))),this.B(b.onDidUninstallExtension(d=>this.h(d)))}g(E){for(const l of E)l.local&&this.invalidate(l.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const l of this.a.profiles)this.c.extUri.isEqual(l.extensionsResource,E)&&await this.j(l);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,O.$wm))}catch(l){(0,k.$5k)(l)!==1&&this.f.error(l)}}}e.$mq=j}),define(ne[45],re([0,1,14,8,2,107,40,10,6,36]),function(J,e,D,O,k,j,N,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=void 0,e.$Ap=d,e.$Bp=p,e.$Cp=y,e.$Dp=R,e.$Ep=g,e.$Fp=c,e.$yp=(0,E.$hi)("requestService");class b{constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?m[i]="*****":m[i]=this.b[i];this.a=m}return this.a}}class v extends k.$Uc{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,j.localize)(0,null),when:l.$6j.isEqualTo((0,l.$3j)(l.LogLevel.Trace)).serialize()})}async c(m,i,r){const t=`${m} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new b(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,O.$0)(n)),n}}}e.$zp=v;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function p(h){return h.res.statusCode===204}async function y(h){return p(h)?null:(await(0,D.$Ge)(h.stream)).toString()}async function R(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return y(h)}async function g(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const i=(await(0,D.$Ge)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function c(h){$(h)}let w;function $(h){const m=a.$Zn.as(N.$5n.Configuration),i=w;w={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},m.updateConfigurations({add:[w],remove:i?[i]:[]})}$(1)}),define(ne[140],re([0,1,20,15,13,45]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;let N=class{constructor(l,a){this.a=l,this.b=a}async download(l,a,b=D.CancellationToken.None){if(l.scheme===O.Schemas.file||l.scheme===O.Schemas.vscodeRemote){await this.b.copy(l,a);return}const v={type:"GET",url:l.toString(!0)},d=await this.a.request(v,b);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const p=await(0,j.$Dp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};e.$bQ=N,e.$bQ=N=$e([oe(0,j.$yp),oe(1,k.$Nk)],N)}),define(ne[141],re([0,1,142,3]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=j;function k(N,E){return N.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:N.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function j(N,E,l={}){const a=(0,D.parse)(N),b=l.proxyUrl||k(a,E);if(!b)return null;const v=(0,D.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const d={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,O.$1f)(l.strictSSL)?l.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((p,y)=>{J(["http-proxy-agent"],p,y)})).HttpProxyAgent(b,d):new(await new Promise((p,y)=>{J(["https-proxy-agent"],p,y)})).HttpsProxyAgent(b,d)}}),define(ne[143],re([0,1,58,16,108,20,34,8,12,28,87,175,9,75]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=R;let y;async function R(c,w,$,h){return $["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$lm)(h)&&!$["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$lm)(h)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=d.Promises.withAsyncBody(async(m,i)=>{const r=new j.$ee;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,p.$mm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{m(await g(w,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,N.$5i)(o)))):m({})}finally{clearTimeout(s),r.dispose()}})),y)}async function g(c,w){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const m=(0,a.$Dg)().replace(/-/g,"").substr(0,12),i=new RegExp(m+"({.*})"+m),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,b.$bm)(l.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(w.isCancellationRequested)return s(new E.$5);const o=(0,O.$oc)(t);let u,S;const I="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${I} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,S=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${I} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,S=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${m}", json.dumps(dict(os.environ)), "${m}")`,S=["-i","-l","-c"]):(u=`'${process.execPath}' ${I} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),u);const L=(0,D.spawn)(t,[...S,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(L.kill(),s(new E.$5))),L.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,N.$5i)(V)),s(V)});const U=[];L.stdout.on("data",V=>U.push(V));const z=[];L.stderr.on("data",V=>z.push(V)),L.on("close",(V,Q)=>{const se=Buffer.concat(U).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const te=Buffer.concat(z).toString("utf8");if(te.trim()&&c.trace("getUnixShellEnvironment#stderr",te),V||Q)return s(new Error((0,k.localize)(2,null,V,Q)));const ue=i.exec(se),he=ue?ue[1]:"{}";try{const ce=JSON.parse(he);$?ce.ELECTRON_RUN_AS_NODE=$:delete ce.ELECTRON_RUN_AS_NODE,h?ce.ELECTRON_NO_ATTACH_CONSOLE=h:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,N.$5i)(ce)),s(ce)}})})}}),define(ne[144],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=void 0,e.$PP=(0,D.$hi)("stateReadService"),e.$QP=(0,D.$hi)("stateService")}),define(ne[69],re([0,1,9,14,2,3,18,13,6]),function(J,e,D,O,k,j,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=e.$SP=e.$RP=e.SaveStrategy=void 0;var a;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class b extends k.$Uc{constructor(y,R,g,c){super(),this.h=y,this.j=R,this.m=g,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new D.$fh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,R){const g=this.a[y];return(0,j.$4f)(g)?R:g}setItem(y,R){this.setItems([{key:y,data:R}])}setItems(y){let R=!1;for(const{key:g,data:c}of y)this.a[g]!==c&&((0,j.$4f)(c)?(0,j.$2f)(this.a[g])||(this.a[g]=void 0,R=!0):(this.a[g]=c,R=!0));R&&this.s()}removeItem(y){(0,j.$2f)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,O.$ue.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$RP=b;let v=class extends k.$Uc{constructor(y,R,g,c){super(),this.a=this.B(new b(R.stateResource,y,g,c))}async init(){await this.a.init()}getItem(y,R){return this.a.getItem(y,R)}};e.$SP=v,e.$SP=v=$e([oe(1,N.$oi),oe(2,l.$Nj),oe(3,E.$Nk)],v);class d extends v{setItem(y,R){this.a.setItem(y,R)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$TP=d}),define(ne[70],re([0,1,12,35,28]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=N,e.$2o=E;function j(l){if(D.$u===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}function N(l,a,b,v,d,p,y,R,g){const c=Object.create(null);c["common.machineId"]=p,c["common.sqmId"]=y,c.sessionID=(0,k.$Dg)()+Date.now(),c.commitHash=v,c.version=d,c["common.platformVersion"]=(l||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$h)(D.$u),c["common.nodePlatform"]=O.$ec,c["common.nodeArch"]=b,c["common.product"]=g||"desktop",R&&(c["common.msftInternal"]=R);let w=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),D.$l&&(c["common.snap"]="true");const h=j(a);return h&&(c["common.platformDetail"]=h),c}function E(l){const a=O.env.USERDNSDOMAIN;if(!a)return!1;const b=a.toLowerCase();return l.some(v=>b===v)}}),define(ne[25],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,D.$hi)("telemetryService"),e.$Nl=(0,D.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var O;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var k;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[41],re([0,1,27,3,68,70,25]),function(J,e,D,O,k,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=b,e.$$o=v,e.$_o=d,e.$ap=p,e.$bp=R,e.$cp=c,e.$dp=w,e.$ep=m;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$3o=E;class l{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=l,e.$5o=new l;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$6o=a,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function v(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const r=i.getValue(N.$Ul),t=i.getValue(N.$Vl);if(i.getValue(N.$Wl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function p(i){const r={},t={},n={};g(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(i){if(!i)return"none";const r=(0,k.$tm)(i);return y.has(r)?r:"other"}function g(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],u=n?n+s:s;Array.isArray(o)?r[u]=(0,D.$Sn)(o):o instanceof Date?r[u]=o.toISOString():(0,O.$Wf)(o)?t<2?g(o,r,t+1,u+"."):r[u]=(0,D.$Sn)(o):r[u]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,j.$2o)(t)||n}function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function $(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const S of r)for(;;){const I=S.exec(i);if(!I)break;n.push([I.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(t="";;){const S=o.exec(i);if(!S)break;const I=n.some(([L,U])=>S.index<U&&L<o.lastIndex);!s.test(S[0])&&!I&&(t+=i.substring(u,S.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<i.length&&(t+=i.substr(u)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function m(i,r){return(0,D.$Pn)(i,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=$(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}}),define(ne[26],re([0,1,30,21,37,12,11,8,35,41]),function(J,e,D,O,k,j,N,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=b,e.$hp=y,e.$ip=R,e.$jp=g,e.$kp=c,e.$lp=w,e.$mp=$,e.$np=h,e.$pp=m,e.$qp=r;function b(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,D.$gf)(t.id,n.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=v.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?b(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$gp=d;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(t){const n=p.exec(t);return n&&n[1]?[g(n[1]),n[2]]:[g(t),void 0]}function R(t,n){return`${t}.${n}`}function g(t){return t.toLowerCase()}function c(t,n){return g(R(t??k.$ym,n))}function w(t,n){const s=[],o=u=>{for(const S of s)if(S.some(I=>b(n(I),n(u))))return S;return null};for(const u of t){const S=o(u);S?S.push(u):s.push([u])}return s}function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function h(t){return{id:new a.$3o(t.identifier.id),name:new a.$3o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$op=new k.$Cm("pprice.better-merge");function m(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every(S=>!b(S.identifier,{id:u}))){const S=t.filter(I=>b(I.identifier,{id:u}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function i(t,n){if(!j.$k)return!1;let s;try{s=(await t.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){n.debug("Error while getting the os-release file.",(0,E.$0)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,O.$Mo)(s?"alpine":j.$u,l.$fc);return n.debug("ComputeTargetPlatform:",o),o}}),define(ne[145],re([0,1,20,8,15,17,44,11,96,21,26,37]),function(J,e,D,O,k,j,N,E,l,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;const d=R=>(0,l.localize)(0,null,R),p=(0,l.localize)(1,null,"ms-dotnettools.csharp");let y=class{constructor(g,c,w){this.a=g,this.b=c,this.d=w}get f(){}async listExtensions(g,c,w){let $=await this.b.getInstalled(1,w);const h=v.$Bm.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,l.localize)(2,null,this.f)),$=$.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let m;for(const i of $)m!==i.identifier.id&&(m=i.identifier.id,this.a.info(g?`${m}@${i.manifest.version}`:m))}async installExtensions(g,c,w,$){const h=[];try{g.length&&this.a.info(this.f?(0,l.localize)(3,null,this.f):(0,l.localize)(4,null));const m=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...w,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||w.installPreReleaseVersion}})};for(const n of g)if(n instanceof E.URI)m.push({vsix:n,installOptions:w});else{const[s,o]=(0,b.$hp)(n);r(s,o,!1)}for(const n of c)if(n instanceof E.URI)m.push({vsix:n,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,b.$hp)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,w.profileLocation);if(m.length&&await Promise.all(m.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,$,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,$);h.push(...n)}}catch(m){throw this.a.error((0,l.localize)(5,null,(0,O.$0)(m))),m}if(h.length)throw new Error((0,l.localize)(6,null,h.join(", ")))}async updateExtensions(g){const c=await this.b.getInstalled(1,g),w=[];for(const i of c)i.identifier.uuid&&w.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,l.localize)(7,null,w.length));const $=await this.d.getExtensions(w,{compatible:!0},D.CancellationToken.None),h=[];for(const i of $)for(const r of c)(0,b.$fp)(r.identifier,i.identifier)&&(0,N.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,l.localize)(8,null));return}this.a.info((0,l.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const m=await this.b.installGalleryExtensions(h);for(const i of m)i.error?this.a.error((0,l.localize)(10,null,i.identifier.id,(0,O.$0)(i.error))):this.a.info((0,l.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(g,c,w){if(g=g.filter(({id:i,version:r})=>{const t=c.find(n=>(0,b.$fp)(n.identifier,{id:i}));if(t){if(!w&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,l.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,l.localize)(13,null,`${i}@${r}`)),!1}return!0}),!g.length)return[];const $=[],h=[],m=await this.j(g);if(await Promise.all(g.map(async({id:i,version:r,installOptions:t})=>{const n=m.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${p}`),$.push(i);return}try{const o=await this.d.getManifest(n,D.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(i);return}const s=c.find(o=>(0,b.$fp)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,l.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,l.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,l.localize)(16,null,i,r):(0,l.localize)(17,null,i)):this.a.info(r?(0,l.localize)(18,null,i,r):(0,l.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,l.localize)(20,null,r.identifier.id,(0,O.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,l.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(g,c,w,$){const h=await this.b.getManifest(g);if(!h)throw new Error("Invalid vsix");if(await this.l(h,w,c.profileLocation,$))try{await this.b.install(g,c),this.a.info((0,l.localize)(22,null,(0,j.$Rg)(g)))}catch(i){if((0,O.$4)(i))this.a.info((0,l.localize)(23,null,(0,j.$Rg)(g)));else throw i}}async j(g){const c=new Map,w=g.some(m=>m.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),h=[];for(const m of g)a.$Fo.test(m.id)&&h.push({...m,preRelease:w});if(h.length){const m=await this.d.getExtensions(h,{targetPlatform:$},D.CancellationToken.None);for(const i of m)c.set(i.identifier.id.toLowerCase(),i)}return c}k(g){return!0}async l(g,c,w,$){if(!c){const h={id:(0,b.$kp)(g.publisher,g.name)},m=$.find(i=>(0,b.$fp)(h,i.identifier)&&(0,N.gt)(i.manifest.version,g.version));if(m)return this.a.info((0,l.localize)(24,null,m.identifier.id,m.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,c,w){const $=async m=>{if(m instanceof E.URI){const i=await this.b.getManifest(m);return(0,b.$ip)(i.publisher,i.name)}return m},h=[];for(const m of g){const i=await $(m),t=(await this.b.getInstalled(void 0,w)).filter(n=>(0,b.$fp)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${p}`);if(t.some(n=>n.type===0)){this.a.info((0,l.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,l.localize)(26,null,i));return}this.a.info((0,l.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:w}),h.push(n);this.f?this.a.info((0,l.localize)(28,null,i,this.f)):this.a.info((0,l.localize)(29,null,i))}}async locateExtension(g){const c=await this.b.getInstalled();g.forEach(w=>{c.forEach($=>{if($.identifier.id===w&&$.location.scheme===k.Schemas.file){this.a.info($.location.fsPath);return}})})}m(g){return this.f?(0,l.localize)(30,null,g,this.f):(0,l.localize)(31,null,g)}};e.$Yp=y,e.$Yp=y=$e([oe(1,a.$To),oe(2,a.$Qo)],y)}),define(ne[146],re([0,1,9,8,2,15,17,44,3,28,24,49,29,18,21,26,65,13,6]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;let h=class extends k.$Uc{static{$=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,N.$Ug)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new y.$Ro(o.message,y.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===w.LogLevel.Trace)}catch(u){const S=u;if(s=S.code,S.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${S.output}`),s===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new y.$Ro(v.$3p,y.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(u){this.r.error(u)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,l.$1f)(r)?r:!0}async u(i){await this.g;const r=(0,N.$Ug)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new y.$Ro(t.message,y.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==j.Schemas.file){await t(r);return}const n=(0,N.$Ug)(this.extensionsDownloadDir,`.${(0,a.$Dg)()}`);await this.h.exists(n)||await t(n);try{await b.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,O.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const u of i.children)if(u.name.endsWith($.c))n.push(u.resource);else{const S=R.$gp.parse(u.name);S&&t.push([S,u])}const s=(0,R.$lp)(t,([u])=>u),o=[];for(const u of s)u.sort((S,I)=>E.rcompare(S[0].version,I[0].version)),r.push(...u.slice(1).map(S=>S[1].resource)),o.push(u[0][1]);o.sort((u,S)=>u.mtime-S.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(u=>u.resource)),r.push(...n),await D.Promises.settled(r.map(u=>(this.r.trace("Deleting from cache",u.path),this.h.del(u))))}}catch(i){this.r.error(i)}}z(i){return this.f?R.$gp.create(i).toString().toLowerCase():(0,a.$Dg)()}};e.$jq=h,e.$jq=h=$=$e([oe(0,p.$pi),oe(1,c.$Nk),oe(2,y.$Qo),oe(3,d.$Ni),oe(4,g.$Wp),oe(5,w.$Nj)],h)}),define(ne[147],re([0,1,5,2,31,26,37]),function(J,e,D,O,k,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class E extends O.$Uc{constructor(a,b,v,d,p,y,R){super(),this.f=a,this.g=b,this.h=v,this.j=d,this.m=p,this.n=y,this.r=R,this.a=this.B(new D.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$4c),this.s().then(null,g=>R.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(b=>(this.c.set(b.id,(0,O.$Rc)(this.n.watch(this.m.extUri.dirname(b.extensionsResource)),this.n.watch(b.extensionsResource))),this.G(b.extensionsResource))))}catch(b){throw this.r.error(b),b}}async w(a){for(const b of a.extensions)this.I(this.L(b.identifier,b.version),a.profileLocation)}async y(a){for(const b of a.extensions){const v=this.L(b.identifier,b.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const b of a.extensions)this.J(this.L(b.identifier,b.version),a.profileLocation)}async C(a){const b=[],v=[];for(const d of a.extensions){const p=this.L(d.identifier,d.version);a.error?this.I(p,a.profileLocation):(this.J(p,a.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),v.push(this.f.scanInstalledExtensionAtLocation(d.location).then(y=>{y?b.push(y):this.r.info("Extension not found at the location",d.location.toString())},y=>this.r.error(y)))))}try{await Promise.all(v),b.length&&await this.H(b)}catch(d){this.r.error(d)}}D(a){for(const b of this.h.profiles)a.contains(b.extensionsResource,0,1)&&this.F(b.extensionsResource)}async F(a){const b=[],v=[],d=await this.j.scanProfileExtensions(a),p=new Set,y=new Set;for(const[R,g]of this.b)g.has(a)&&y.add(R);for(const R of d){const g=this.L(R.identifier,R.version);p.add(g),y.has(g)||(b.push(R.identifier),this.I(g,a))}for(const R of y)if(!p.has(R)){const g=this.M(R);g&&(v.push(g.identifier),this.J(R,a))}(b.length||v.length)&&this.a.fire({added:b.length?{extensions:b,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const b=await this.j.scanProfileExtensions(a);for(const v of b)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,b){let v=this.b.get(a);v||this.b.set(a,v=new k.$Cc(d=>this.m.extUri.getComparisonKey(d))),v.add(b)}J(a,b){const v=this.b.get(a);v&&v.delete(b),v?.size||this.b.delete(a)}L(a,b){return`${N.$Cm.toKey(a.id)}@${b}`}M(a){const[b,v]=(0,j.$hp)(a);return v?{identifier:{id:b},version:v}:void 0}}e.$nq=E}),define(ne[148],re([0,1,118,41]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=k;async function k(j,N,E,l,a,b,v){const d={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${N.nameShort})`};if((0,O.$0o)(N,E)&&(0,O.$_o)(l)===3){const p=await(0,D.$Rp)(E,a,b);d["X-Market-User-Id"]=p,d["VSCode-SessionId"]=v.machineId||p}return d}}),define(ne[149],re([0,1,176,19,9,2,15,16,24,18,21,26,6,64,11]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;let R=class extends p.$Ar{constructor($,h,m,i){super(m),this.h=$,this.j=i,this.g=this.B(new g(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[$];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),h=Object.keys($).map(m=>{const i=$[m];return{...this.f(m,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((m,i)=>m.label.localeCompare(i.label)),h}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const h=await this.g.getLanguagePacks();Object.keys(h).some(m=>h[m]&&h[m].extensions.some(i=>(0,v.$fp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),m=await this.g.update(h);return!(0,O.$ub)(Object.keys($),Object.keys(m))}};e.$Br=R,e.$Br=R=$e([oe(0,b.$To),oe(1,a.$pi),oe(2,b.$Qo),oe(3,d.$Nj)],R);let g=class extends j.$Uc{constructor($,h){super(),this.j=h,this.c={},this.f=(0,E.$kc)($.userDataPath,"languagepacks.json"),this.g=new k.$oh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(h=>{Object.keys(h).forEach(m=>delete h[m]),this.m(h,...$)}).then(()=>this.c)}m($,...h){for(const m of h)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.n($,m);Object.keys($).forEach(m=>this.r($[m]))}n($,h){const m=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===N.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const n=t.extensions.filter(s=>(0,v.$fp)(s.extensionIdentifier,m))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:m,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$kc)(h.location.fsPath,s.path)}}r($){if($){const h=(0,D.createHash)("md5");for(const m of $.extensions)h.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);$.hash=h.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let h=null;return l.Promises.readFile(this.f,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(h=$(m),m)).then(m=>{for(const r of Object.keys(m))m[r]||delete m[r];this.c=m,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),l.Promises.writeFile(this.f,i)}).then(()=>h,m=>this.j.error(m))})}};g=$e([oe(0,a.$pi),oe(1,d.$Nj)],g);function c(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const $ of w.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(ne[150],re([0,1,84,8,27,41]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function l(b,v,d){const p=await(0,D.$CD)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,D.$CD)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new p.AppInsightsCore,g=new y.PostChannel,c={instrumentationKey:b,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(d){c.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[g.identifier]=w}return R.initialize(c,[]),R.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),R}class a{constructor(v,d,p,y,R){this.e=v,this.f=d,this.g=p,this.h=R,this.c=N,this.d=E,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=l(this.a,this.e,this.h)),this.b.then(d=>{v(d)},d=>{(0,O.$1)(d),console.error(d)})}}log(v,d){if(!this.a)return;d=(0,k.$Qn)(d,this.g),d=(0,j.$ap)(d);const p=this.f+"/"+v;try{this.i(y=>{y.pluginVersionString=d?.properties.version??"Unknown",y.track({name:p,baseData:{name:p,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$LP=a}),define(ne[151],re([0,1,2,27,12,30,109,29,40,152,32,36,25,41]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,w,$){this.k=w,this.l=$,this.d={},this.i=new D.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,j.$Ze)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Ze)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Ul)||h.affectsConfiguration(d.$Wl)||h.affectsConfiguration(d.$Vl))&&this.m()}))}setExperimentProperty(c,w){this.d[c]=w}m(){let c=(0,p.$_o)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const $=w.usage?3:w.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,w,$){this.g<w||($=(0,O.$Qn)($,this.d),$=(0,p.$ep)($,this.j),$=(0,O.$Qn)($,this.c),this.b.forEach(h=>h.log(c,$)))}publicLog(c,w){this.n(c,3,w)}publicLog2(c,w){this.publicLog(c,w)}publicLogError(c,w){this.h&&this.n(c,2,w)}publicLogError2(c,w){this.publicLogError(c,w)}};e.$Hr=y,e.$Hr=y=$e([oe(1,E.$Ni),oe(2,b.$7j)],y);function R(){const g=(0,N.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=k.$o?"":(0,N.localize)(3,null),$=(0,N.localize)(4,null),h=(0,N.localize)(5,null),m=(0,N.localize)(6,null),i=(0,N.localize)(7,null),r=`
|       | ${$} | ${h} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${g} ${c} ${w}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}v.$Zn.as(l.$5n.Configuration).registerConfiguration({id:d.$Tl,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[d.$Ul]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$Zn.as(l.$5n.Configuration).registerConfiguration({id:d.$Tl,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[d.$Wl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,N.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,N.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${d.$Ul}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[153],re([0,1,14,20,177,150]),function(J,e,D,O,k,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=void 0;async function N(b,v){const d=await v.request(b,O.CancellationToken.None),p=(await(0,D.$Ge)(d.stream)).toString(),y=d.res.statusCode??200;return{headers:d.res.headers,statusCode:y,responseData:p}}async function E(b){const v={method:b.type,headers:b.headers};return new Promise((p,y)=>{const R=k.request(b.url??"",v,g=>{g.on("data",function(c){p({headers:g.headers,statusCode:g.statusCode??200,responseData:c.toString()})}),g.on("error",function(c){y(c)})});R.write(b.data,g=>{g&&y(g)}),R.end()})}async function l(b,v,d){const p=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),y={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:p};try{const R=b?await N(y,b):await E(y);d(R.statusCode,R.headers,R.responseData)}catch{d(0,{})}}class a extends j.$LP{constructor(v,d,p,y,R){const g={sendPOST:(c,w)=>{l(v,c,w)}};super(d,p,y,R,g)}}e.$MP=a}),define(ne[154],re([0,1,16,24]),function(J,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=k;async function k(j,N){const E=Object.create(null),l=(b,v)=>{const d=JSON.parse(b);E[v]=d};if(N){const b=[],v=await O.Promises.readdir(N);for(const p of v)try{(await O.Promises.stat((0,D.$kc)(N,p))).isDirectory()&&b.push(p)}catch{}const d=[];for(const p of b)(await O.Promises.readdir((0,D.$kc)(N,p))).filter(R=>R==="telemetry.json").length===1&&d.push(p);for(const p of d){const y=(await O.Promises.readFile((0,D.$kc)(N,p,"telemetry.json"))).toString();l(y,p)}}let a=(await O.Promises.readFile((0,D.$kc)(j,"telemetry-core.json"))).toString();return l(a,"vscode-core"),a=(await O.Promises.readFile((0,D.$kc)(j,"telemetry-extensions.json"))).toString(),l(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(ne[155],re([0,1,12,85,25]),function(J,e,D,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=j,e.$0ac=N;async function j(E,l){let a=E.getItem(k.$Rl);return(typeof a!="string"||D.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,O.$qn)(l.error.bind(l))),a}async function N(E,l){let a=E.getItem(k.$Sl);return typeof a!="string"&&(a=await(0,O.$rn)(l.error.bind(l))),a}}),define(ne[22],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,D.$hi)("IUriIdentityService")}),define(ne[156],re([0,1,22,120,13,17,76,5,2]),function(J,e,D,O,k,j,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let b=class{constructor(d){this.g=d,this.c=new l.$Tc,this.f=2**16;const p=new Map,y=R=>{let g=p.get(R.scheme);return g===void 0&&(g=d.hasProvider(R)&&!this.g.hasCapability(R,1024),p.set(R.scheme,g)),g};this.c.add(E.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(R=>{p.delete(R.scheme)})),this.extUri=new j.$Jg(y),this.d=new N.$gs((R,g)=>this.extUri.compare(R,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,j.$Vg)(d));const p=this.d.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((y,R)=>y[1].time<R[1].time?1:y[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const p=this.f*.5;for(let y=0;y<p;y++)this.d.set(d[y][0],d[y][1].touch())}};e.$hs=b,e.$hs=b=$e([oe(0,k.$Nk)],b),(0,O.$es)(D.$ll,b,1)}),define(ne[157],re([0,1,5,2,13,48,31]),function(J,e,D,O,k,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class E extends O.$Uc{constructor(a,b,v,d,p,y){super(),this.f=a,this.g=b,this.h=v,this.j=d,this.m=p,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$7d),this.onDidChangeFile=this.a.event,this.b=j.$ni.forUris(()=>!(this.capabilities&1024)),this.c=new N.$Cc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,b){return this.g.open(this.t(a),b)}close(a){return this.g.close(a)}read(a,b,v,d,p){return this.g.read(a,b,v,d,p)}write(a,b,v,d,p){return this.g.write(a,b,v,d,p)}watch(a,b){this.b.set(a,a);const v=this.g.watch(this.t(a),b);return(0,O.$Sc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,b,v){return this.g.rename(this.t(a),this.t(b),v)}readFile(a,b){return this.g.readFile(this.t(a),b)}readFileStream(a,b,v){return this.g.readFileStream(this.t(a),b,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,b,v){return this.g.writeFile(this.t(a),b,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,b){return this.g.delete(this.t(a),b)}copy(a,b,v){if((0,k.$Rk)(this.g))return this.g.copy(this.t(a),this.t(b),v);throw new Error("copy not supported")}cloneFile(a,b){if((0,k.$Sk)(this.g))return this.g.cloneFile(this.t(a),this.t(b));throw new Error("clone not supported")}s(a){const b=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const d=this.u(v.resource);this.b.findSubstr(d)&&b.push({resource:d,type:v.type,cId:v.cId})}b.length&&(this.n.debug("User data changed"),this.a.fire(b))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$ubc=E}),define(ne[158],re([0,1,111,16,48,17,11,10,15]),function(J,e,D,O,k,j,N,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=a,e.$si=b,e.$vi=v,e.$wi=d,e.$xi=p,e.$yi=R,e.$zi=g,e.$Ci=$,e.$Hi=h,e.$Ii=m,e.$Ki=i,e.$Li=r,e.$Mi=t,e.$qi=(0,E.$hi)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}function b(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function v(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.$oc)(n)}:s?e.$ti:e.$ui;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const s=n;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}function p(n){const s=n;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:N.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function R(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(n){const s=n;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,u,S,I){this.h=s,this.j=u,this.k=S,this.l=I,this.c=k.$ni.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$ni.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=c;class w{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,j.$Ug)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=w;function $(n){return new w({uri:n,index:0,name:(0,j.$Qg)(n)},{uri:n.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,D.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function h(n,s){return j.$Lg.isEqualOrParent(n,s.untitledWorkspacesHome)}function m(n){let s;return N.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===l.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Ji}function r(n,s){return!h(n,s)&&!m(n)}function t(n){return(typeof n=="string"?(0,O.$pc)(n):(0,j.$Sg)(n))===e.$Ei}}),define(ne[23],re([0,1,43,5,2,17,11,110,18,13,10,6,158,31,22,9,28,30,3]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=h,e.$ol=m,e.$pl=i;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&N.URI.isUri(s.location)&&N.URI.isUri(s.globalStorageHome)&&N.URI.isUri(s.settingsResource)&&N.URI.isUri(s.keybindingsResource)&&N.URI.isUri(s.tasksResource)&&N.URI.isUri(s.snippetsHome)&&N.URI.isUri(s.extensionsResource))}e.$nl=(0,b.$hi)("IUserDataProfilesService");function m(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:N.URI.revive(n.location).with({scheme:s}),globalStorageHome:N.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:N.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:N.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:N.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:N.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:N.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:N.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,s,o,u,S,I){return{id:n,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:I&&S?.useDefaultFlags?.globalState?I.globalStorageHome:(0,j.$Ug)(o,"globalStorage"),settingsResource:I&&S?.useDefaultFlags?.settings?I.settingsResource:(0,j.$Ug)(o,"settings.json"),keybindingsResource:I&&S?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,j.$Ug)(o,"keybindings.json"),tasksResource:I&&S?.useDefaultFlags?.tasks?I.tasksResource:(0,j.$Ug)(o,"tasks.json"),snippetsHome:I&&S?.useDefaultFlags?.snippets?I.snippetsHome:(0,j.$Ug)(o,"snippets"),extensionsResource:I&&S?.useDefaultFlags?.extensions?I.extensionsResource:(0,j.$Ug)(o,"extensions.json"),cacheHome:(0,j.$Ug)(u,n),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,u,S){super(),this.t=s,this.u=o,this.w=u,this.y=S,this.f=!0,this.h=this.B(new O.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Bc,emptyWindows:new Map},this.profilesHome=(0,j.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,w.$Uf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,j.$Rg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const u=new p.$Bc,S=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[L,U]of Object.entries(I.workspaces)){const z=N.URI.parse(L),V=o.find(Q=>Q.id===U);V&&u.set(z,V)}if(I.emptyWindows)for(const[L,U]of Object.entries(I.emptyWindows)){const z=o.find(V=>V.id===U);z&&S.set(L,z)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:u,emptyWindows:S}}return this.z}D(){const s=i("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,c.$Ze)(o)}\\s(\\d+)`);let S=0;for(const L of this.profiles){const U=u.exec(L.name),z=U?parseInt(U[1]):0;S=z>S?z:S}const I=`${o} ${S+1}`;return this.createProfile((0,D.$8i)((0,g.$Dg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,D.$8i)((0,g.$Dg)()).toString(16),s,o,u)}async createProfile(s,o,u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,u);return S&&await this.setProfileForWorkspace(S,I),I}async F(s,o,u){if(!(0,w.$Uf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{const I=this.profiles.find(z=>z.name===o||z.id===s);if(I)return I;const L=i(s,o,(0,j.$Ug)(this.profilesHome,s),this.g,u,this.defaultProfile);await this.u.createFolder(L.location);const U=[];return this.j.fire({profile:L,join(z){U.push(z)}}),await R.Promises.settled(U),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(S=>S.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=i(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.m.fire({profile:o,join(S){u.push(S)}});try{await Promise.allSettled(u)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$5k)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(S=>S.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return N.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$ri)(s)?s.uri:(0,d.$wi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,u){const S=[...this.profiles,...s],I=[];this.s.profiles=[];for(let L of S)L.isDefault||o.some(U=>L.id===U.id)||(L=u.find(U=>L.id===U.id)??L,L.isTransient?this.s.profiles.push(L):I.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,u)}J(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}L(s,o,u){u=o?.isTransient?!0:u,u||this.L(s,void 0,!0);const S=this.G(s),I=u?this.s:this.C;N.URI.isUri(S)?(I.workspaces.delete(S),o&&I.workspaces.set(S,o)):(I.emptyWindows.delete(S),o&&I.emptyWindows.set(S,o)),u||this.M()}M(){const s={};for(const[u,S]of this.C.workspaces.entries())s[u.toString()]=S.id;const o={};for(const[u,S]of this.C.emptyWindows.entries())o[u.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},u=this.D();if(s.workspaces)for(const[I,L]of Object.entries(s.workspaces)){const U=N.URI.parse(L);o[I]=this.w.extUri.isEqual(U,u.location)?u.id:this.w.extUri.basename(U)}const S={};if(s.emptyWindows)for(const[I,L]of Object.entries(s.emptyWindows)){const U=N.URI.parse(L);S[I]=this.w.extUri.isEqual(U,u.location)?u.id:this.w.extUri.basename(U)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$ql=r,e.$ql=r=$e([oe(0,l.$oi),oe(1,a.$Nk),oe(2,y.$ll),oe(3,v.$Nj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$rl=t}),define(ne[159],re([0,1,19,9,20,8,5,2,12,3,11,94,21,26,37,6,32,25,22,23]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$8p=void 0,e.$9p=m,e.$0p=i;let h=class extends E.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,u,S,I,L){super(),this.z=s,this.C=o,this.D=u,this.F=S,this.G=I,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$7d),this.s=this.B(new N.$7d),this.t=this.B(new N.$7d),this.u=this.B(new N.$7d),this.w=this.B(new N.$7d),this.y=[],this.B((0,E.$Sc)(()=>{this.j.forEach(({task:U})=>U.cancel()),this.m.forEach(U=>U.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(u=>(0,d.$Oo)(u,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const S=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,p.$fp)(I,s.identifier));if(S?.local)return S?.local;throw S?.error?S.error:new d.$Ro(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(u){throw i(u)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Ro(v.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];await Promise.allSettled(s.map(async({extension:S,options:I})=>{try{const L=await this.N(S,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});u.push({...L,options:I})}catch(L){o.push({identifier:S.identifier,operation:2,source:S,error:L})}})),u.length&&o.push(...await this.I(u));for(const S of o)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!b.URI.isUri(S.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,p.$np)(S.source),error:S.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,y.$Fm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let u=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const S of this.H.profiles){const I=(await this.getInstalled(1,S.extensionsResource)).find(L=>(0,p.$fp)(L.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:S.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:2,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],u=new Map,S=[],I=[],L=(z,V)=>`${p.$gp.create(z).toString()}-${V.toString()}`,U=(z,V,Q)=>{const se=this.Y(z,V,Q),te=b.URI.isUri(V)?V.path:`${V.identifier.id.toLowerCase()}-${Q.profileLocation.toString()}`;u.set(te,{task:se,manifest:z}),this.n.fire({identifier:se.identifier,source:V,profileLocation:Q.profileLocation}),this.F.info("Installing extension:",se.identifier.id),b.URI.isUri(V)||this.j.set(L(V,Q.profileLocation),{task:se,waitingTasks:[]})};try{for(const{manifest:z,extension:V,options:Q}of s){const se=Q.isApplicationScoped||Q.isBuiltin||(0,y.$Fm)(z),te={...Q,installOnlyNewlyAddedFromExtensionPack:Q.installOnlyNewlyAddedFromExtensionPack??!b.URI.isUri(V),isApplicationScoped:se,profileLocation:se?this.H.defaultProfile.extensionsResource:Q.profileLocation??this.X(),productVersion:Q.productVersion??{version:this.G.version,date:this.G.date}},ue=b.URI.isUri(V)?void 0:this.j.get(L(V,te.profileLocation));ue?(this.F.info("Extension is already requested to install",ue.task.identifier.id),S.push(ue.task.waitUntilTaskIsFinished())):U(z,V,te)}await Promise.all([...u.values()].map(async({task:z,manifest:V})=>{if(z.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const Q=await this.M(z.identifier,V,!!z.options.installOnlyNewlyAddedFromExtensionPack,!!z.options.installPreReleaseVersion,z.options.profileLocation,z.options.productVersion),se=await this.getInstalled(void 0,z.options.profileLocation,z.options.productVersion),te={...z.options,donotIncludePackAndDependencies:!0,context:{...z.options.context,[d.$Jo]:!0}};for(const{gallery:ue,manifest:he}of(0,D.$Mb)(Q,({gallery:ce})=>ce.identifier.id)){if(u.has(`${ue.identifier.id.toLowerCase()}-${te.profileLocation.toString()}`))continue;const ce=this.j.get(L(ue,te.profileLocation));if(ce){if(this.J(z,ce.task)){const B=ce.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,z.identifier.id),ce.waitingTasks.push(z),S.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,X=>X.some(q=>(0,p.$fp)(q.identifier,B)))).then(X=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,z.identifier.id),!X.find(T=>(0,p.$fp)(T.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else se.some(({identifier:B})=>(0,p.$fp)(B,ue.identifier))||U(he,ue,te)}}catch(Q){if(b.URI.isUri(z.source))(0,D.$Lb)(V.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,Q.message),(0,D.$Lb)(V.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,Q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),Q}})),await this.L([...u.values()].map(async({task:z})=>{const V=new Date().getTime();try{const Q=await z.run();if(await this.L(this.y.map(se=>se.postInstall(Q,z.source,z.options,k.CancellationToken.None))),!b.URI.isUri(z.source)){const se=z.operation===3,te=se?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(r(this.C,se?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$np)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:te}),l.$o&&z.operation!==3)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}I.push({local:Q,identifier:z.identifier,operation:z.operation,source:z.source,context:z.options.context,profileLocation:z.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw this.F.error("Error while installing the extension",z.identifier.id,(0,j.$0)(Q)),Q}})),S.length&&await this.L(S);for(const z of I)this.F.info("Extension installed successfully:",z.identifier.id),o.push(z);return o}catch(z){I.length&&await Promise.allSettled(I.map(async({local:V,profileLocation:Q})=>{try{await this.Z(V,{versionOnly:!0,profileLocation:Q}).run(),this.F.info("Rollback: Uninstalled extension",V.identifier.id)}catch(se){this.F.warn("Rollback: Error while uninstalling extension",V.identifier.id,(0,j.$0)(se))}}));for(const{task:V}of u.values())V.cancel(),o.push({identifier:V.identifier,operation:2,source:V.source,context:V.options.context,profileLocation:V.profileLocation,error:z});throw z}finally{for(const{task:z}of u.values())z.source&&!b.URI.isUri(z.source)&&this.j.delete(L(z.source,z.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:u,waitingTasks:S}]of this.j.entries())if(u===s&&(S.includes(o)||S.some(I=>this.J(I,o)))||u===o&&S[0]&&!this.J(s,S[0]))return!1;return!0}async L(s){const o=[],u=[],S=await Promise.allSettled(s);for(const I of S)I.status==="fulfilled"?o.push(I.value):u.push(I.reason);if(u.length)throw m(u);return o}async M(s,o,u,S,I,L){if(!this.z.isEnabled())return[];const U=await this.getInstalled(void 0,I,L),z=[],V=[],Q=async(se,te)=>{z.push(se);const ue=te.extensionDependencies||[],he=[...ue];if(te.extensionPack){const ce=u?U.find(B=>(0,p.$fp)(B.identifier,se)):void 0;for(const B of te.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(X=>(0,p.$fp)({id:X},{id:B}))||he.every(X=>!(0,p.$fp)({id:X},{id:B}))&&he.push(B)}if(he.length){const ce=he.filter(B=>z.every(X=>!(0,p.$fp)(X,{id:B})));if(ce.length){const B=await this.z.getExtensions(ce.map(X=>({id:X,preRelease:S})),k.CancellationToken.None);for(const X of B){if(z.find(x=>(0,p.$fp)(x,X.identifier)))continue;const q=ue.some(x=>(0,p.$fp)({id:x},X.identifier));let T;try{T=await this.N(X,!1,S,L)}catch(x){if(q)throw x;this.F.info("Skipping the packed extension as it cannot be installed",X.identifier.id,(0,j.$0)(x));continue}V.push({gallery:T.extension,manifest:T.manifest}),await Q(T.extension.identifier,T.manifest)}}}};return await Q(s,o),V}async N(s,o,u,S){let I;const L=await this.getExtensionsControlManifest();if(L.malicious.some(V=>(0,p.$fp)(s.identifier,V)))throw new d.$Ro(v.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const U=L.deprecated[s.identifier.id.toLowerCase()];if(U?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${U.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:U.extension.id,preRelease:U.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:S},k.CancellationToken.None))[0],!I)throw new d.$Ro(v.localize(2,null,s.identifier.id,U.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const V=await this.getTargetPlatform();throw new d.$Ro(v.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Ko)(V)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,o,u,S),!I)throw!u&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],k.CancellationToken.None))[0]?new d.$Ro(v.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Ro(v.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const z=await this.z.getManifest(I,k.CancellationToken.None);if(z===null)throw new d.$Ro(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(z.version!==I.version)throw new d.$Ro(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:z}}async O(s,o,u,S){const I=await this.getTargetPlatform();let L=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==u&&(L=(await this.z.getExtensions([{...s.identifier,preRelease:u}],{targetPlatform:I,compatible:!0,productVersion:S},k.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(s,u,I,S)&&(L=s),L||(o?L=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:S},k.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(s,u,I,S)),L}async P(s,o){const u={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},S=Q=>`${Q.id.toLowerCase()}${u.versionOnly?`-${s.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,I=this.m.get(S(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const L=Q=>{const se=this.Z(Q,u);return this.m.set(S(se.extension.identifier),se),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this.t.fire({identifier:Q.identifier,profileLocation:u.profileLocation,applicationScoped:Q.isApplicationScoped}),se},U=(Q,se)=>{se?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,u.profileLocation.toString(),se.message):this.F.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,se.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$mp)(Q),error:se}),this.u.fire({identifier:Q.identifier,error:se?.code,profileLocation:u.profileLocation,applicationScoped:Q.isApplicationScoped})},z=[],V=[];try{z.push(L(s));const Q=await this.getInstalled(1,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const se=this.S(s,Q);for(const te of se)this.m.has(S(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):z.push(L(te))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(z.map(se=>se.extension),Q,s),await this.L(z.map(async se=>{try{if(await se.run(),await this.L(this.y.map(te=>te.postUninstall(se.extension,u,k.CancellationToken.None))),se.extension.identifier.uuid)try{await this.z.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}U(se.extension)}catch(te){const ue=te instanceof d.$Ro?te:new d.$Ro((0,j.$0)(te),d.ExtensionManagementErrorCode.Internal);throw U(se.extension,ue),ue}finally{V.push(se)}}))}catch(Q){const se=Q instanceof d.$Ro?Q:new d.$Ro((0,j.$0)(Q),d.ExtensionManagementErrorCode.Internal);for(const te of z){try{te.cancel()}catch{}V.includes(te)||U(te.extension,se)}throw se}finally{for(const Q of z)this.m.delete(S(Q.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}Q(s,o,u){for(const S of s){const I=this.U(S,o);if(I.length){const L=I.filter(U=>!s.some(z=>(0,p.$fp)(z.identifier,U.identifier)));if(L.length)throw new Error(this.R(S,L,u))}}}R(s,o,u){return u===s?o.length===1?v.localize(6,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(7,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(8,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?v.localize(9,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(10,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(11,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,u=[]){if(u.indexOf(s)!==-1)return[];u.push(s);const S=s.manifest.extensionPack?s.manifest.extensionPack:[];if(S.length){const I=o.filter(U=>!U.isBuiltin&&S.some(z=>(0,p.$fp)({id:z},U.identifier))),L=[];for(const U of I)L.push(...this.S(U,o,u));return[...I,...L]}return[]}U(s,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(S=>(0,p.$fp)({id:S},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$8p=h,e.$8p=h=$e([oe(0,d.$Qo),oe(1,c.$Ml),oe(2,w.$ll),oe(3,R.$Nj),oe(4,g.$7j),oe(5,$.$nl)],h);function m(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}function i(n){if(n instanceof d.$Ro)return n;if(n instanceof d.$So){const o=new d.$Ro(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Ro(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function r(n,s,{extensionData:o,verificationStatus:u,duration:S,error:I,durationSinceUpdate:L}){let U,z;(0,a.$3f)(u)&&(u===!0?u="Verified":(u===!1||(U=d.ExtensionManagementErrorCode.Signature,z=u),u="Unverified")),I&&(I instanceof d.$Ro||I instanceof d.$So?(U=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(z=I.message)):U=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:u,success:!I,duration:S,errorcode:U,errorcodeDetail:z,durationSinceUpdate:L})}class t{constructor(){this.d=new O.$gh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.$7g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$7g)(s=>new Promise((o,u)=>{const S=s.onCancellationRequested(()=>{S.dispose(),u(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$$p=t}),define(ne[42],re([0,1,9,14,2,5,31,11,21,26,13,10,6,23,22,3,8,25]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class $ extends Error{constructor(t,n){super(t),this.code=n}}e.$_p=$,e.$aq=(0,v.$hi)("IExtensionsProfileScannerService");let h=class extends k.$Uc{constructor(t,n,s,o,u,S){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=u,this.t=S,this.b=this.B(new j.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new j.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new N.$Bc}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n,s){const o=[],u=[];try{return await this.u(n,S=>{const I=[];if(s)I.push(...S);else for(const L of S)t.some(([U])=>(0,a.$fp)(U.identifier,L.identifier)&&U.manifest.version!==L.version)?o.push(L):I.push(L);for(const[L,U]of t){const z=I.findIndex(Q=>(0,a.$fp)(Q.identifier,L.identifier)&&Q.version===L.manifest.version),V={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:U};z===-1?(u.push(V),I.push(V)):I.splice(z,1,V)}return u.length&&this.b.fire({extensions:u,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),u.length&&this.c.fire({extensions:u,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),u}catch(S){throw u.length&&this.c.fire({extensions:u,error:S,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:n}),S}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const u=[];for(const S of o){const I=t.find(([L])=>(0,a.$fp)(L.identifier,S.identifier)&&L.manifest.version===S.version);I&&(S.metadata={...S.metadata,...I[1]},s.push(S)),u.push(S)}return u}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const u=[];for(const S of o)(0,a.$fp)(S.identifier,t.identifier)?s.push(S):u.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:n}),u}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],u;try{const S=await this.m.readFile(t);u=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,b.$5k)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&s?.bailOutWhenFileNotFound)throw new $((0,g.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.w(t);let S=!1;for(const I of u){m(I)||this.w(t);let L;if((0,R.$Uf)(I.relativeLocation)&&I.relativeLocation)L=this.z(I.relativeLocation);else if((0,R.$Uf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{L=E.URI.revive(I.location);const U=this.y(L);U&&(S=!0,I.relativeLocation=U)}(0,R.$2f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(S=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:L,version:I.version,metadata:I.metadata})}S&&await this.m.writeFile(t,O.$ue.fromString(JSON.stringify(u)))}if(n){o=n(o);const S=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,O.$ue.fromString(JSON.stringify(S)))}return o})}w(t){const n=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(u){if((0,b.$5k)(u)===1)return;throw u}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(S=>m(S))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$ue.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,b.$5k)(u)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(t)}catch(u){(0,b.$5k)(u)!==1&&this.t.error(u)}try{await this.m.del(n)}catch(u){(0,b.$5k)(u)!==1&&this.t.error(u)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new D.$oh,this.h.set(t,n)),n}};e.$bq=h,e.$bq=h=$e([oe(1,b.$Nk),oe(2,p.$nl),oe(3,y.$ll),oe(4,c.$Ml),oe(5,d.$Nj)],h);function m(r){return(0,R.$Wf)(r)&&(0,l.$Po)(r.identifier)&&(i(r.location)||(0,R.$Uf)(r.location)&&r.location)&&((0,R.$2f)(r.relativeLocation)||(0,R.$Uf)(r.relativeLocation))&&r.version&&(0,R.$Uf)(r.version)}function i(r){return r?(0,R.$Uf)(r.path)&&(0,R.$Uf)(r.scheme):!1}}),define(ne[52],re([0,1,19,9,27,14,8,38,82,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,6,32,5,47,42,23,22,116]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$,h,m,i,r,t,n,s,o,u,S,I,L,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.$fq=e.$eq=e.Translations=void 0,e.$hq=ue;var z;(function(ce){function B(X,q){if(X===q)return!0;const T=Object.keys(X),x=new Set;for(const Z of Object.keys(q))x.add(Z);if(T.length!==x.size)return!1;for(const Z of T){if(X[Z]!==q[Z])return!1;x.delete(Z)}return x.size===0}ce.equals=B})(z||(e.Translations=z={})),e.$eq=(0,t.$hi)("IExtensionsScannerService");let V=class extends a.$Uc{constructor(B,X,q,T,x,Z,Y,_,C,F,f,P){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=q,this.s=T,this.t=x,this.u=Z,this.w=Y,this.y=_,this.z=C,this.C=F,this.D=f,this.F=P,this.g=this.B(new o.$7d),this.onDidChangeCache=this.g.event,this.h=(0,p.$Ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$qp)(this.w,this.y)),this.G}async scanAllExtensions(B,X,q){const[T,x]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),Z=q?await this.scanExtensionsUnderDevelopment(B,[...T,...x]):[];return this.L(T,x,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[q,T]=await Promise.all(X);return this.J([...q,...T],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const q=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,q,B.productVersion??this.R()),x=B.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Z;try{Z=await x.scanExtensions(T)}catch(Y){if(Y instanceof S.$_p&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Z=await x.scanExtensions(T);else throw Y}return Z=await this.J(Z,1,B,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===b.Schemas.file).map(async T=>{const x=await this.P(T,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(x)).map(Y=>(Y.type=X.find(_=>(0,h.$fp)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,x)))}))).flat();return this.J(q,"development",B,!0)}return[]}async scanExistingExtension(B,X,q){const T=await this.P(B,!1,X,!0,q.language,!0,void 0,q.productVersion??this.R()),x=await this.n.scanExtension(T);return!x||!q.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(B,X,q){const T=await this.P(B,!1,X,!0,q.language,!0,void 0,q.productVersion??this.R()),x=await this.n.scanOneOrMultipleExtensions(T);return this.J(x,X,q,!0)}async scanMetadata(B){const X=(0,p.$Ug)(B,"package.json"),q=(await this.w.readFile(X)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(B,X){const q=(0,p.$Ug)(B,"package.json"),T=(await this.w.readFile(q)).value.toString(),x=JSON.parse(T);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,x.__metadata={...x.__metadata,...X},await this.w.writeFile((0,p.$Ug)(B,"package.json"),j.$ue.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof S.$_p&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$ue.fromString(JSON.stringify([])))}catch(X){(0,r.$5k)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,q,T){return q.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),T)),q.includeInvalid||(B=B.filter(x=>x.isValid)),B.sort((x,Z)=>{const Y=v.$oc(x.location.fsPath),_=v.$oc(Z.location.fsPath);return Y<_?-1:Y>_?1:0})}L(B,X,q,T,x){const Z=(_,C,F)=>{if(_.isValid&&!C.isValid)return!1;if(_.isValid===C.isValid){if(x&&y.gt(_.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(y.eq(_.manifest.version,C.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${C.location.path}.`),!0},Y=new m.$Em;return B?.forEach(_=>{const C=Y.get(_.identifier.id);(!C||Z(C,_,!1))&&Y.set(_.identifier.id,_)}),X?.forEach(_=>{const C=Y.get(_.identifier.id);if(!C&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!C||Z(C,_,!1))&&Y.set(_.identifier.id,_)}),q?.forEach(_=>{const C=Y.get(_.identifier.id);(!C||Z(C,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0,this.R()),x=await(B&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",x.length),x}async N(B,X){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const T=X?await this.O():{},x=[],Z=c.URI.file(v.$ic(v.$kc(b.$Bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of q){const C=T[_.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":x.push((0,p.$Ug)(Z,_.name));break;default:x.push(c.URI.file(C));break}}const Y=await Promise.all(x.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,D.$Hb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,q,T,x,Z,Y,_){const C=await this.f(x??d.$w),F=await this.Q(B),f=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=f?await this.Q(f):void 0;return new Q(B,F,f,P,X,Y,q,T,Z,_.version,_.date,this.C.commit,!this.z.isBuilt,x,C)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$fq=V,e.$fq=V=$e([oe(4,I.$nl),oe(5,S.$aq),oe(6,r.$Nk),oe(7,n.$Nj),oe(8,$.$oi),oe(9,s.$7j),oe(10,L.$ll),oe(11,t.$gi)],V);class Q{constructor(B,X,q,T,x,Z,Y,_,C,F,f,P,A,M,H){this.location=B,this.mtime=X,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=T,this.profile=x,this.profileScanOptions=Z,this.type=Y,this.excludeObsolete=_,this.validate=C,this.productVersion=F,this.productDate=f,this.productCommit=P,this.devMode=A,this.language=M,this.translations=H}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,p.$Ng)(B.location,X.location)&&B.mtime===X.mtime&&(0,p.$Ng)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&k.$Rn(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&z.equals(B.translations,X.translations)}}e.$gq=Q;let se=class extends a.$Uc{constructor(B,X,q,T,x){super(),this.f=B,this.g=X,this.h=q,this.j=T,this.m=x}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let q={};if(B.excludeObsolete&&B.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(T)}catch{}return(0,g.$8f)(q)?X:X.filter(T=>!q[h.$gp.create(T).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const q=await Promise.all(X.children.map(async T=>{if(!T.isDirectory||B.type===1&&(0,p.$Rg)(T.resource).indexOf(".")===0)return null;const x=new Q(T.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(x)}));return(0,D.$Hb)(q).sort((T,x)=>T.location.path<x.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(T=>!T.metadata?.isApplicationScoped);const q=await this.s(B.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,B);X.push(...q)}return X}async s(B,X,q){const T=await this.g.scanProfileExtensions(B,q.profileScanOptions);if(!T.length)return[];const x=await Promise.all(T.map(async Z=>{if(X(Z)){const Y=new Q(Z.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Y,Z.metadata)}return null}));return(0,D.$Hb)(x)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,p.$Ug)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,N.$0)(X)),[]}}async scanExtension(B,X){try{let q=await this.scanExtensionManifest(B.location);if(q){q.publisher||(q.publisher=m.$ym),X=X??q.__metadata,delete q.__metadata;const T=(0,h.$kp)(q.publisher,q.name),x=X?.id?{id:T,uuid:X.id}:{id:T},Z=X?.isSystem?0:B.type,Y=Z===0||!!X?.isBuiltin;q=await this.t(B.location,q,Q.createNlsConfiguration(B));const _={type:Z,identifier:x,manifest:q,location:B.location,isBuiltin:Y,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(q){B.type!==0&&this.m.error(q)}return null}validate(B,X){let q=!0;const T=(0,i.$vp)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[x,Z]of T)x===R.default.Error&&(q=!1,this.m.error(this.z(X.location,Z)));return B.isValid=q,B.validations=T,B}async scanExtensionManifest(B){const X=(0,p.$Ug)(B,"package.json");let q;try{q=(await this.j.readFile(X)).value.toString()}catch(x){return(0,r.$5k)(x)!==1&&this.m.error(this.z(B,(0,w.localize)(0,null,X.path,x.message))),null}let T;try{T=JSON.parse(q)}catch{const Z=[];(0,E.$un)(q,Z);for(const Y of Z)this.m.error(this.z(B,(0,w.localize)(1,null,X.path,Y.offset,Y.length,(0,l.$cq)(Y.error))));return null}return(0,E.$Dn)(T)!=="object"?(this.m.error(this.z(B,(0,w.localize)(2,null,X.path))),null):T}async t(B,X,q){const T=await this.u(B,X,q);if(T)try{const x=[],Z=await this.w(T.default,x);if(x.length>0)return x.forEach(_=>{this.m.error(this.z(B,(0,w.localize)(3,null,T.default?.path,(0,l.$cq)(_.error))))}),X;if((0,E.$Dn)(T)!=="object")return this.m.error(this.z(B,(0,w.localize)(4,null,T.default?.path))),X;const Y=T.values||Object.create(null);return(0,U.$dq)(this.m,X,Y,Z)}catch{}return X}async u(B,X,q){const T=(0,p.$Ug)(B,"package.nls.json"),x=(C,F)=>{F.forEach(f=>{this.m.error(this.z(B,(0,w.localize)(5,null,C?.path,(0,l.$cq)(f.error))))})},Z=C=>{this.m.error(this.z(B,(0,w.localize)(6,null,C?.path)))},Y=`${X.publisher}.${X.name}`,_=q.translations[Y];if(_)try{const C=c.URI.file(_),F=(await this.j.readFile(C)).value.toString(),f=[],P=(0,E.$un)(F,f);return f.length>0?(x(C,f),{values:void 0,default:T}):(0,E.$Dn)(P)!=="object"?(Z(C),{values:void 0,default:T}):{values:P.contents?P.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let F;try{F=await this.y(B,q)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const f=(await this.j.readFile(F.localized)).value.toString(),P=[],A=(0,E.$un)(f,P);return P.length>0?(x(F.localized,P),{values:void 0,default:F.original}):(0,E.$Dn)(A)!=="object"?(Z(F.localized),{values:void 0,default:F.original}):{values:A,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,X){if(B)try{const q=(await this.j.readFile(B)).value.toString();return(0,E.$un)(q,X)}catch{}}y(B,X){return new Promise((q,T)=>{const x=Z=>{const Y=(0,p.$Ug)(B,`package.nls.${Z}.json`);this.j.exists(Y).then(_=>{_&&q({localized:Y,original:(0,p.$Ug)(B,"package.nls.json")});const C=Z.lastIndexOf("-");C===-1?q({localized:(0,p.$Ug)(B,"package.nls.json"),original:null}):(Z=Z.substring(0,C),x(Z))})};if(X.devMode||X.pseudo||!X.language)return q({localized:(0,p.$Ug)(B,"package.nls.json"),original:null});x(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};se=$e([oe(1,S.$aq),oe(2,L.$ll),oe(3,r.$Nk),oe(4,n.$Nj)],se);let te=class extends se{constructor(B,X,q,T,x,Z,Y){super(X,T,x,Z,Y),this.G=B,this.H=q,this.D=this.B(new O.$fh(3e3)),this.F=this.B(new o.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),q=await this.I(X);if(this.C=B,q&&q.input&&Q.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),q.result.map(x=>(x.location=c.URI.revive(x.location),x));const T=await super.scanExtensions(B);return await this.J(X,{input:B,result:T}),T}async I(B){try{const X=await this.j.readFile(B),q=JSON.parse(X.value.toString());return{result:q.result,input:(0,u.$Qh)(q.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,N.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,j.$ue.fromString(JSON.stringify(X)))}catch(q){this.m.debug("Error while writing the extension cache file:",B.path,(0,N.$0)(q))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const q=X.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$Rn(T,q))try{this.m.info("Invalidating Cache",q,T),await this.j.del(B),this.F.fire()}catch(x){this.m.error(x)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?m.$xm:m.$wm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};te=$e([oe(2,I.$nl),oe(3,S.$aq),oe(4,L.$ll),oe(5,r.$Nk),oe(6,n.$Nj)],te);function ue(ce,B){const X=(0,h.$ip)(ce.manifest.publisher,ce.manifest.name);return{id:X,identifier:new m.$Cm(X),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:B,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}class he extends V{constructor(B,X,q,T,x,Z,Y,_,C,F,f,P){super(B,X,(0,p.$Ug)(q,".vscode-oss-dev","extensions","control.json"),T,x,Z,Y,_,C,F,f,P),this.S=(async()=>{if(d.$z)try{const A=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(A.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$iq=he}),define(ne[160],re([0,1,58,9,34,5,2,15,16,24,6,23]),function(J,e,D,O,k,j,N,E,l,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let d=class extends N.$Uc{constructor(y,R){super(),this.b=y,this.f=R,this.a=new O.$nh(5)}async postUninstall(y){const R=this.g(y,"uninstall");R&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m(y))}catch(g){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(g)}}g(y,R){const g=`vscode:${R}`;if(y.location.scheme===E.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[g]=="string"){const c=y.manifest.scripts[g].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${g} should be a node script`),null):{script:(0,l.$kc)(y.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(y,R,g,c,w){return new Promise(($,h)=>{const m=this.j(y,R,g,w);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):$(void 0)};m.on("error",t=>{r((0,k.$5i)(t)||"Unknown")}),m.on("exit",(t,n)=>{r(t?`post-${R} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,m.kill(),h("timed out")},5e3))})}j(y,R,g,c){const w={silent:!0,execArgv:void 0},$=(0,D.fork)(y,[`--type=extension-post-${R}`,...g],w);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const h=j.Event.fromNodeEventEmitter($.stdout,"data"),m=j.Event.fromNodeEventEmitter($.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${R}`,t)),m(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${R}`,t));const i=j.Event.any(j.Event.map(h,t=>({data:`%c${t}`,format:[""]})),j.Event.map(m,t=>({data:`%c${t}`,format:["color: red"]})));return j.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(y){return(0,l.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};e.$kq=d,e.$kq=d=$e([oe(0,v.$nl),oe(1,b.$Nj)],d)}),define(ne[161],re([0,1,9,14,20,34,8,5,43,2,31,15,16,17,44,3,11,28,24,49,99,60,18,159,21,26,42,52,146,160,117,139,147,50,13,10,6,32,25,22,23]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$,h,m,i,r,t,n,s,o,u,S,I,L,U,z,V,Q,se,te,ue,he,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.$oq=void 0,e.$oq=(0,Q.$ii)(t.$To);const B=".vsctmp";let X=class extends r.$8p{constructor(C,F,f,P,A,M,H,G,ie,ae,le,pe){super(C,F,le,f,ae,pe),this.eb=A,this.fb=M,this.gb=H,this.hb=ie,this.db=new Map,this.qb=new b.$Cc;const ye=this.B(G.createInstance(S.$kq));this.ab=this.B(G.createInstance(q,me=>ye.postUninstall(me))),this.bb=this.B(new L.$mq(pe,ie,le,this,this.F)),this.cb=this.B(G.createInstance(u.$jq));const fe=this.B(new U.$nq(this,this.eb,pe,M,le,ie,f));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$qp)(this.hb,this.F)),this.ib}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const F=await this.ob(C),f=await(0,$.zip)((0,p.$Ug)(this.cb.extensionsDownloadDir,(0,c.$Dg)()).fsPath,F);return g.URI.file(f)}async unzip(C){return this.F.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:F,cleanup:f}=await this.kb(C),P=d.$lc(F.fsPath);try{return await(0,I.$lq)(P)}finally{await f()}}getInstalled(C,F=this.H.defaultProfile.extensionsResource,f={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(C??null,F,f)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.ab.scanUserExtensionAtLocation(C)}async install(C,F={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:f,cleanup:P}=await this.kb(C);try{const A=await(0,I.$lq)(d.$lc(f.fsPath)),M=(0,n.$kp)(A.publisher,A.name);if(A.engines&&A.engines.vscode&&!(0,z.$xp)(A.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,M,this.G.version));const G=(await this.I([{manifest:A,extension:f,options:F}])).find(({identifier:ie})=>(0,n.$fp)(ie,{id:M}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$0p)(new Error(`Unknown error while installing extension ${M}`))}finally{await P()}}async installFromLocation(C,F){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const f=await this.ab.scanUserExtensionAtLocation(C);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.tb([[f,void 0]],F),this.F.info("Successfully installed extension",f.identifier.id,F.toString()),f}async installExtensionsFromProfile(C,F,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,F.toString(),f.toString());const P=(await this.getInstalled(1,F)).filter(A=>C.some(M=>(0,n.$fp)(M,A.identifier)));if(P.length){const A=await Promise.all(P.map(M=>this.ab.scanMetadata(M,F)));await this.tb(P.map((M,H)=>[M,A[H]]),f),this.F.info("Successfully installed extensions",P.map(M=>M.identifier.id),f.toString())}return P}async updateMetadata(C,F,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),C=await this.ab.updateMetadata(C,F,f),this.bb.invalidate(f),this.w.fire(C),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const F=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(C);try{await this.ab.removeUninstalledExtension(C)}catch(P){throw new Error(h.localize(3,null,(0,j.$5i)(P)))}return this.installFromGallery(f)}$(C,F,f,P){return this.ab.copyExtension(C,F,f,P)}copyExtensions(C,F){return this.ab.copyExtensions(C,F,{version:this.G.version,date:this.G.date})}markAsUninstalled(...C){return this.ab.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(C){this.F.error(C)}}async download(C,F,f){const{location:P}=await this.cb.download(C,F,!f);return P}async kb(C){if(C.scheme===v.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const F=(0,p.$Ug)(this.cb.extensionsDownloadDir,(0,c.$Dg)());return await this.gb.download(C,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(P){this.F.error(P)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(C,F,f){if(g.URI.isUri(F))return new Z(C,F,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const P=n.$gp.create(F).toString();let A=this.db.get(P);return A||(this.db.set(P,A=new x(C,F,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),A.waitUntilTaskIsFinished().finally(()=>this.db.delete(P))),A}Z(C,F){return new Y(C,F.profileLocation,this.fb)}async ob(C){const F=async P=>{let A=await w.Promises.readdir(P);A=A.map(G=>d.$kc(P,G));const M=await Promise.all(A.map(G=>w.Promises.stat(G)));let H=Promise.resolve([]);return M.forEach((G,ie)=>{const ae=A[ie];G.isFile()&&(H=H.then(le=>[...le,ae])),G.isDirectory()&&(H=H.then(le=>F(ae).then(pe=>[...le,...pe])))}),H};return(await F(C.location.fsPath)).map(P=>({path:`extension/${d.$mc(C.location.fsPath,P)}`,localPath:P}))}async pb({added:C,removed:F}){if(F){const f=C&&this.D.extUri.isEqual(F.profileLocation,C.profileLocation)?F.extensions.filter(P=>C.extensions.every(A=>!(0,n.$fp)(A,P))):F.extensions;for(const P of f)this.F.info("Extensions removed from another source",P.id,F.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:F.profileLocation})}if(C){const P=(await this.getInstalled(1,C.profileLocation)).filter(A=>C.extensions.some(M=>(0,n.$fp)(M,A.identifier)));this.s.fire(P.map(A=>(this.F.info("Extensions added from another source",A.identifier.id,C.profileLocation.toString()),{identifier:A.identifier,local:A,profileLocation:C.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const C=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of C.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(C){if(!C.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const f of C.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const P=await this.ab.scanUserExtensionAtLocation(f);P&&P.installedTimestamp===void 0&&(this.qb.add(f),F.push(P))}F.length&&(await this.tb(F.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(f=>f.identifier.id)))}async tb(C,F){const f=C.map(P=>P[0]);await this.ub(f),await this.fb.addExtensionsToProfile(C,F),this.s.fire(f.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:F})))}async ub(C){const F=await this.ab.getUninstalledExtensions();for(const f of C){const P=n.$gp.create(f);F[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.ab.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$pq=X,e.$pq=X=$e([oe(0,t.$Qo),oe(1,ue.$Ml),oe(2,se.$Nj),oe(3,i.$pi),oe(4,o.$eq),oe(5,s.$aq),oe(6,m.$vo),oe(7,Q.$gi),oe(8,V.$Nk),oe(9,te.$7j),oe(10,he.$ll),oe(11,ce.$nl)],X);let q=class extends a.$Uc{constructor(C,F,f,P,A,M){super(),this.j=C,this.m=F,this.n=f,this.s=P,this.t=A,this.u=M,this.h=this.B(new E.$7d),this.onExtract=this.h.event,this.c=(0,p.$Ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$oh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(C,F,f){const P={includeInvalid:!0,profileLocation:F,productVersion:f};let A=[];return C===null||C===0?A.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):C===1&&A.push(...await this.n.scanUserExtensions(P)),A=C!==null?A.filter(M=>M.type===C):A,Promise.all(A.map(M=>this.F(M)))}async scanAllUserExtensions(C){const F=await this.n.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(F.map(f=>this.F(f)))}async scanUserExtensionAtLocation(C){try{const F=await this.n.scanExistingExtension(C,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(C,F,f,P,A){const M=C.toString(),H=g.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Dg)()}`)),G=g.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,M));let ie=await this.m.exists(G);if(ie&&P){try{await this.y(C.id,G,"removeExisting")}catch{throw new t.$Ro(h.localize(4,null,G.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${G.fsPath}`),await(0,$.$6p)(F,H.fsPath,{sourcePath:"extension",overwrite:!0},A),this.u.info(`Extracted extension to ${G}:`,C.id)}catch(ae){let le=t.ExtensionManagementErrorCode.Extract;throw ae instanceof $.$4p&&(ae.type==="CorruptZip"?le=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(le=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Ro(ae.message,le)}await this.n.updateMetadata(H,f);try{this.u.trace(`Started renaming the extension from ${H.fsPath} to ${G.fsPath}`),await this.C(H.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.u.info(`Rename failed because of ${(0,N.$0)(ae)}. Deleted from extracted location`,H),ae}this.h.fire(G)}catch(ae){try{await this.m.del(H,{recursive:!0})}catch{}throw ae}return this.D(G,1)}async scanMetadata(C,F){return F?(await this.w(C,F))?.metadata:this.n.scanMetadata(C.location)}async w(C,F){return(await this.s.scanProfileExtensions(F)).find(P=>(0,n.$fp)(P.identifier,C.identifier))}async updateMetadata(C,F,f){return f?await this.s.updateMetadata([[C,F]],f):await this.n.updateMetadata(C.location,F),this.D(C.location,C.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...C){const F=C.map(f=>n.$gp.create(f));await this.z(f=>F.forEach(P=>{f[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(C){await this.z(F=>delete F[C.toString()])}async removeExtension(C,F){if(this.t.extUri.isEqualOrParent(C.location,this.n.userExtensionsLocation))return this.y(C.identifier.id,C.location,F)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.z(F=>delete F[n.$gp.create(C).toString()])}async copyExtension(C,F,f,P){const A=await this.w(C,F),M=await this.w(C,f);if(P={...A?.metadata,...P},M)if(this.t.extUri.isEqual(M.location,C.location))await this.s.updateMetadata([[C,{...M.metadata,...P}]],f);else{const H=await this.D(M.location,C.type,f);await this.s.removeExtensionFromProfile(H,f),await this.s.addExtensionsToProfile([[C,{...M.metadata,...P}]],f)}else await this.s.addExtensionsToProfile([[C,P]],f);return this.D(C.location,C.type,f)}async copyExtensions(C,F,f){const P=await this.scanExtensions(1,C,f),A=await Promise.all(P.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,C)]));await this.s.addExtensionsToProfile(A,F)}async y(C,F,f){this.u.trace(`Deleting ${f} extension from disk`,C,F.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,l.$8i)((0,c.$Dg)()).toString(16)}${B}`);await this.C(F.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,C,F.fsPath)}async z(C){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,V.$5k)(P)!==1)throw P}let f={};if(F)try{f=JSON.parse(F)}catch{}return C&&(C(f),Object.keys(f).length?await this.m.writeFile(this.c,O.$ue.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(C,F){try{await w.Promises.rename(C,F,2*60*1e3)}catch(f){throw new t.$Ro(f.message||h.localize(5,null,C,F),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(C,F,f){if(f){const A=(await this.n.scanUserExtensions({profileLocation:f})).find(M=>this.t.extUri.isEqual(M.location,C));if(A)return this.F(A)}else{const P=await this.n.scanExistingExtension(C,F,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(h.localize(6,null,C.path))}async F(C){const F=await this.m.resolve(C.location);let f,P;return F.children&&(f=F.children.find(({name:A})=>/^readme(\.txt|\.md|)$/i.test(A))?.resource,P=F.children.find(({name:A})=>/^changelog(\.txt|\.md|)$/i.test(A))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:f,changelogUrl:P,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!C.metadata?.hasPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async G(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(C));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const A of F)C[n.$gp.create(A).toString()]||f.add(A.identifier.id.toLowerCase());try{const A=(0,n.$lp)(F,M=>M.identifier);await D.Promises.settled(A.map(async M=>{const H=M.sort((G,ie)=>y.rcompare(G.manifest.version,ie.manifest.version))[0];f.has(H.identifier.id.toLowerCase())||await this.j(await this.F(H))}))}catch(A){this.u.error(A)}const P=F.filter(A=>A.metadata&&C[n.$gp.create(A).toString()]);await Promise.allSettled(P.map(A=>this.removeUninstalledExtension(A)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,V.$5k)(F)!==1&&this.u.error(F);return}if(C?.children)try{await Promise.allSettled(C.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(f){(0,V.$5k)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$qq=q,e.$qq=q=$e([oe(1,V.$Nk),oe(2,o.$eq),oe(3,s.$aq),oe(4,he.$ll),oe(5,se.$Nj)],q);class T extends r.$$p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.$2f)(this.options.operation)?this.l:this.options.operation}constructor(C,F,f,P,A,M,H,G,ie){super(),this.identifier=C,this.source=F,this.options=f,this.m=P,this.n=A,this.o=M,this.p=H,this.q=G,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[F,f]=await this.x(C);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,f]],this.j,!F.isValid),F}async u({zipPath:C,key:F,metadata:f},P,A){let M=await this.v(F);return M?M=await this.m.updateMetadata(M,f):(this.s.trace("Extracting extension...",F.id),M=await this.m.extractUserExtension(F,C,f,P,A),this.s.info("Extracting extension completed.",F.id)),M}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$gp.create(P).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class x extends T{constructor(C,F,f,P,A,M,H,G,ie,ae){super(F.identifier,F,f,A,M,H,G,ie,ae),this.y=F,this.z=P}async x(C){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(H){throw new t.$Ro(H,t.ExtensionManagementErrorCode.Scanning)}const f=F.find(H=>(0,n.$fp)(H.identifier,this.y.identifier));f&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,R.$1f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,P),P]}catch(H){throw new t.$Ro((0,N.$0)(H),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:A,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(A.fsPath),[await this.u({zipPath:A.fsPath,key:n.$gp.create(this.y),metadata:P},!1,C),P]}catch(H){try{await this.z.delete(A)}catch(G){this.s.warn("Error while deleting the downloaded file",A.toString(),(0,N.$0)(G))}throw H}}async B(C){try{await(0,I.$lq)(C)}catch(F){throw new t.$Ro((0,r.$9p)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$rq=x;class Z extends T{constructor(C,F,f,P,A,M,H,G,ie,ae){super({id:(0,n.$kp)(C.publisher,C.name)},F,f,A,M,H,G,ie,ae),this.y=C,this.z=F,this.A=P}async h(C){const F=await super.h(C);return this.D(F,C),F}async x(C){const F=new n.$gp(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(H=>(0,n.$fp)(this.identifier,H.identifier)),A={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned};if(P)if(this.l=3,F.equals(new n.$gp(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&y.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const H=await this.v(F);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$lc(this.z.fsPath),key:F,metadata:A},!0,C),A]}async D(C,F){try{let[f]=await this.A.getExtensions([{id:C.identifier.id,version:C.manifest.version}],F);if(f||([f]=await this.A.getExtensions([{id:C.identifier.id}],F)),f){const P={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:C.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,P,this.options.profileLocation)}}catch{}}}class Y extends r.$$p{constructor(C,F,f){super(),this.extension=C,this.j=F,this.k=f}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[162],re([0,1,6,23,22,25,42,13,18,11]),function(J,e,D,O,k,j,N,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;let b=class extends N.$bq{constructor(d,p,y,R,g,c){super(a.URI.file(d.extensionsPath),p,y,R,g,c)}};e.$XP=b,e.$XP=b=$e([oe(0,l.$pi),oe(1,E.$Nk),oe(2,O.$nl),oe(3,k.$ll),oe(4,j.$Ml),oe(5,D.$Nj)],b)}),define(ne[163],re([0,1,11,18,42,52,13,10,6,32,22,23]),function(J,e,D,O,k,j,N,E,l,a,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;let d=class extends j.$iq{constructor(y,R,g,c,w,$,h,m){super(D.URI.file(w.builtinExtensionsPath),D.URI.file(w.extensionsPath),w.userHome,y.defaultProfile,y,R,g,c,w,$,h,m)}};e.$6ac=d,e.$6ac=d=$e([oe(0,v.$nl),oe(1,k.$aq),oe(2,N.$Nk),oe(3,l.$Nj),oe(4,O.$pi),oe(5,a.$7j),oe(6,b.$ll),oe(7,E.$gi)],d)}),define(ne[164],re([0,1,9,5,2,129,3,89,10,23]),function(J,e,D,O,k,j,N,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=p,e.$Op=R,e.$Qp=c,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,l.$hi)("storageService");var b;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var v;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var d;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function p(w){const $=w.get(e.$Kp);if($)try{return JSON.parse($)}catch{}return Object.create(null)}class y extends k.$Uc{static{this.a=60*1e3}constructor($={flushInterval:y.a}){super(),this.m=$,this.b=this.B(new O.$0d),this.c=this.B(new O.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new D.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,h,m){return O.Event.filter(this.b.event,i=>i.scope===$&&(h===void 0||i.key===h),m)}n(){this.j.value=(0,D.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,h){const{key:m,external:i}=h;if(m===e.$Kp){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:m,target:this.J($)[m],external:i})}w($){this.f.fire({reason:$})}get($,h,m){return this.P(h)?.get($,m)}getBoolean($,h,m){return this.P(h)?.getBoolean($,m)}getNumber($,h,m){return this.P(h)?.getNumber($,m)}getObject($,h,m){return this.P(h)?.getObject($,m)}storeAll($,h){this.y(()=>{for(const m of $)this.store(m.key,m.value,m.scope,m.target,h)})}store($,h,m,i,r=!1){if((0,N.$4f)(h)){this.remove($,m,r);return}this.y(()=>{this.z($,m,i),this.P(m)?.set($,h,r)})}remove($,h,m=!1){this.y(()=>{this.z($,h,void 0),this.P(h)?.delete($,m)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,h){const m=[],i=this.J($);for(const r of Object.keys(i))i[r]===h&&m.push(r);return m}z($,h,m,i=!1){const r=this.J(h);typeof m=="number"?r[$]!==m&&(r[$]=m,this.P(h)?.set(e.$Kp,JSON.stringify(r),i)):typeof r[$]=="number"&&(delete r[$],this.P(h)?.set(e.$Kp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const h=this.P($);return h?p(h):Object.create(null)}isNew($){return this.getBoolean(e.$Jp,$)===!0}async flush($=b.NONE){this.f.fire({reason:$});const h=this.P(-1),m=this.P(0),i=this.P(1);switch($){case b.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,m=this.P(1)?.items??new Map;return c($,h,m,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,h){return this.w(b.NONE),(0,a.$ml)($)?this.R($,h):this.S($,h)}M($,h){return!($.id===h.id||R(h)&&R($))}N($,h,m){this.y(()=>{const i=new Set;for(const[r,t]of $)i.add(r),h.get(r)!==t&&this.u(m,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(m,{key:r,external:!0})})}}e.$Np=y;function R(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class g extends y{constructor(){super(),this.U=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Hp(new E.$Ip,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Pp=g;async function c(w,$,h,m,i,r){const t=z=>{try{return JSON.parse(z)}catch{return z}},n=new Map,s=new Map;w.forEach((z,V)=>{n.set(V,z),s.set(V,t(z))});const o=new Map,u=new Map;$.forEach((z,V)=>{o.set(V,z),u.set(V,t(z))});const S=new Map,I=new Map;h.forEach((z,V)=>{S.set(V,z),I.set(V,t(z))}),console.group(m!==i?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const L=[];if(n.forEach((z,V)=>{L.push({key:V,value:z})}),console.table(L),console.groupEnd(),console.log(s),m!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const z=[];o.forEach((V,Q)=>{z.push({key:Q,value:V})}),console.table(z),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${r})`);const U=[];S.forEach((z,V)=>{U.push({key:V,value:z})}),console.table(U),console.groupEnd(),console.log(I)}}),define(ne[165],re([0,1,19,20,8,12,35,3,11,29,18,21,26,50,13,6,32,45,148,164,25,178]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0,e.$Tp=Z;const i=j.$o?"web":(0,v.$Mo)(j.$u,N.$fc),r="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...P){return String(P.reduce((A,M)=>A|M,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class L{constructor(A=I){this.d=A}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(A,M=this.d.pageSize){return new L({...this.d,pageNumber:A,pageSize:M})}withFilter(A,...M){const H=[...this.d.criteria,...M.length?M.map(G=>({filterType:A,value:G})):[{filterType:A}]];return new L({...this.d,criteria:H})}withSortBy(A){return new L({...this.d,sortBy:A})}withSortOrder(A){return new L({...this.d,sortOrder:A})}withFlags(...A){return new L({...this.d,flags:A.reduce((M,H)=>M|H,0)})}withAssetTypes(...A){return new L({...this.d,assetTypes:A})}withSource(A){return new L({...this.d,source:A})}get raw(){const{criteria:A,pageNumber:M,pageSize:H,sortBy:G,sortOrder:ie,flags:ae,assetTypes:le}=this.d;return{filters:[{criteria:A,pageNumber:M,pageSize:H,sortBy:G,sortOrder:ie}],assetTypes:le,flags:ae}}get searchText(){const A=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(A=>String(A.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function U(P,A){const M=(P||[]).filter(H=>H.statisticName===A)[0];return M?M.value:0}function z(P){const A="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(H=>H.assetType.indexOf(A)===0).reduce((H,G)=>{const ie=se(P,G.assetType);return ie&&H.push([G.assetType.substring(A.length),ie]),H},[])}function V(P){if(P.properties){const A=P.properties.filter(G=>G.key===o.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=A.filter(G=>M.test(G.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return se(P,o.Repository)}function Q(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function se(P,A){return P.files.filter(H=>H.assetType===A)[0]?{uri:`${P.assetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${A}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function te(P,A){const M=P.properties?P.properties.filter(G=>G.key===A):[],H=M.length>0&&M[0].value;return H?H.split(",").map(G=>(0,d.$jp)(G)):[]}function ue(P){const A=P.properties?P.properties.filter(M=>M.key===u.Engine):[];return A.length>0&&A[0].value||""}function he(P){const A=P.properties?P.properties.filter(M=>M.key===u.PreRelease):[];return A.length>0&&A[0].value==="true"}function ce(P){const A=P.properties?P.properties.filter(H=>H.key===u.LocalizedLanguages):[],M=A.length>0&&A[0].value||"";return M?M.split(","):[]}function B(P){return P.properties?.find(A=>A.key===u.SponsorLink)?.value}function X(P){return P.properties?.find(A=>A.key===u.SupportLink)?.value}function q(P){return P.indexOf("preview")!==-1}function T(P){return P.targetPlatform?(0,v.$Lo)(P.targetPlatform):"undefined"}function x(P){const A=(0,D.$Mb)(P.versions.map(T)),M=!!P.tags?.includes(v.$Go),H=A.indexOf("web");return M?H===-1&&A.push("web"):H!==-1&&A.splice(H,1),A}function Z(P,A){for(let M=0;M<P.length;M++){const H=P[M];if(H.version===P[M-1]?.version){let G=M;if(T(H)===A)for(;G>0&&P[G-1].version===H.version;)G--;G!==M&&(P.splice(M,1),P.splice(G,0,H))}}return P}function Y(P,A,M){P.telemetryData={index:A,querySource:M,queryActivityId:P.queryContext?.[r]}}function _(P,A,M,H){const G=P.versions[0],ie={manifest:se(A,o.Manifest),readme:se(A,o.Details),changelog:se(A,o.Changelog),license:se(A,o.License),repository:V(A),download:Q(A),icon:se(A,o.Icon),signature:se(A,o.Signature),coreTranslations:z(A)};return{identifier:{id:(0,d.$kp)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:A.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:P.shortDescription??"",installCount:U(P.statistics,"install"),rating:U(P.statistics,"averagerating"),ratingCount:U(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:M,assets:ie,properties:{dependencies:te(A,u.Dependency),extensionPack:te(A,u.ExtensionPack),engine:ue(A),localizedLanguages:ce(A),targetPlatform:T(A),isPreReleaseVersion:he(A)},hasPreReleaseVersion:he(G),hasReleaseVersion:!0,preview:q(P.flags),isSigned:!!ie.signature,queryContext:H,supportLink:X(G)}}let C=class{constructor(A,M,H,G,ie,ae,le,pe){this.k=M,this.l=H,this.n=G,this.o=ie,this.q=ae,this.u=le,this.w=pe;const ye=le.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,w.$Sp)(le.version,le,this.n,this.w,this.q,A,this.o)}x(A=""){return`${this.d}${A}`}isEnabled(){return!!this.d}async getExtensions(A,M,H){const G=O.CancellationToken.isCancellationToken(M)?{}:M,ie=O.CancellationToken.isCancellationToken(M)?M:H,ae=[],le=[],pe=[],ye=[];let fe=!0;for(const we of A){we.uuid?le.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!le.length&&!ae.length)return[];let me=new L().withPage(1,A.length);le.length&&(me=me.withFilter(s.ExtensionId,...le)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(G.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:de}=await this.z(me,{targetPlatform:G.targetPlatform??i,includePreRelease:pe,versions:ye,compatible:!!G.compatible,productVersion:G.productVersion??{version:this.u.version,date:this.u.date}},ie);return G.source&&de.forEach((we,Ee)=>Y(we,Ee,G.source)),de}async getCompatibleExtension(A,M,H,G={version:this.u.version,date:this.u.date}){if((0,v.$No)(A.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(A,M,H))return A;const ie=new L().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,A.identifier.uuid),{extensions:ae}=await this.z(ie,{targetPlatform:H,compatible:!0,includePreRelease:M,productVersion:G},O.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(A,M,H,G={version:this.u.version,date:this.u.date}){if(!(0,v.$Oo)(A.properties.targetPlatform,A.allTargetPlatforms,H)||!M&&A.properties.isPreReleaseVersion)return!1;let ie=A.properties.engine;if(!ie){const ae=await this.getManifest(A,O.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return(0,p.$xp)(ie,G.version,G.date)}async y(A,M,H,G,ie,ae,le={version:this.u.version,date:this.u.date}){if(!(0,v.$Oo)(T(M),ie,ae)||H!=="any"&&he(M)!==(H==="prerelease"))return!1;if(G)try{const pe=await this.E(A,M);if(!(0,p.$xp)(pe,le.version,le.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,k.$0)(pe)),!1}return!0}async query(A,M){let H=A.text||"";const G=A.pageSize??50;let ie=new L().withPage(1,G);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(ie=ie.withFilter(s.Category,de||me),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(ie=ie.withFilter(s.Tag,de||me),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(s.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),ie=ie.withFilter(s.SearchText,H)),ie=ie.withSortBy(0)):A.ids?ie=ie.withFilter(s.ExtensionId,...A.ids):A.names?ie=ie.withFilter(s.ExtensionName,...A.names):ie=ie.withSortBy(4),typeof A.sortBy=="number"&&(ie=ie.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(ie=ie.withSortOrder(A.sortOrder)),A.source&&(ie=ie.withSource(A.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!A.includePreRelease,productVersion:A.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+ke,A.source)),{extensions:de,total:we}},{extensions:le,total:pe}=await ae(ie,M),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ae(ie.withPage(fe+1),me);return de};return{firstPage:le,total:pe,pageSize:ie.pageSize,getPage:ye}}async z(A,M,H){const G=A.flags;A.flags&t.IncludeLatestVersionOnly&&A.flags&t.IncludeVersions&&(A=A.withFlags(A.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(A.flags&t.IncludeLatestVersionOnly)&&!(A.flags&t.IncludeVersions)&&(A=A.withFlags(A.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(A=A.withFlags(A.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),A=A.withFlags(A.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ie,total:ae,context:le}=await this.B(A,H);if(!(A.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of ie){const we=await this.A(de,M,le);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<ie.length;me++){const de=ie[me],we={id:(0,d.$kp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$1f)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(W=>(0,d.$fp)(W,we))?.includePreRelease;if(M.compatible&&(0,v.$No)(x(de),M.targetPlatform))continue;const ke=await this.A(de,M,le);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new m.$3d,de=new L().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,M,H);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(A,M,H){const G={id:(0,d.$kp)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},ie=M.versions?.find(ye=>(0,d.$fp)(ye,G))?.version,ae=(0,E.$1f)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ye=>(0,d.$fp)(ye,G))?.includePreRelease,le=x(A),pe=Z(A.versions,M.targetPlatform);if(M.compatible&&(0,v.$No)(le,M.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(ie&&fe.version!==ie)){if(await this.y((0,d.$kp)(A.publisher.publisherName,A.extensionName),fe,ae?"any":"release",M.compatible,le,M.targetPlatform,M.productVersion))return _(A,fe,le,H);if(ie&&fe.version===ie)return null}}return ie||M.compatible?null:_(A,A.versions[0],le)}async B(A,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const H=await this.j,G=JSON.stringify(A.raw),ie={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ae=new m.$3d;let le,pe,ye=0;try{if(le=await this.k.request({type:"POST",url:this.g&&A.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:ie},M),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Ep)(le);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:le.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?v.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw pe=new v.$So((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(G.length),duration:ae.elapsed(),success:!!le&&(0,c.$Ap)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(A,M,H,G){if(!this.isEnabled())return;const ie=j.$o?this.x(`/itemName/${A}.${M}/version/${H}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${A}/extensions/${M}/${H}/stats?statType=${G}`),ae=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:ie,headers:pe},O.CancellationToken.None)}catch{}}async download(A,M,H){this.l.trace("ExtensionGalleryService#download",A.identifier.id);const G=(0,d.$np)(A),ie=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),le=H===2?"install":H===3?"update":"",pe=le?{uri:`${A.assets.download.uri}${l.URI.parse(A.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${A.assets.download.fallbackUri}${l.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:A.assets.download,ye=A.queryContext?.[r]?{[r]:A.queryContext[r]}:void 0,fe=await this.D(A.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(M,fe.stream),ae(new Date().getTime()-ie)}async downloadSignatureArchive(A,M){if(!A.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const H=await this.D(A.identifier.id,A.assets.signature,o.Signature);await this.q.writeFile(M,H.stream)}async getReadme(A,M){if(A.assets.readme){const H=await this.D(A.identifier.id,A.assets.readme,o.Details,{},M);return await(0,c.$Dp)(H)||""}return""}async getManifest(A,M){if(A.assets.manifest){const H=await this.D(A.identifier.id,A.assets.manifest,o.Manifest,{},M),G=await(0,c.$Dp)(H);return G?JSON.parse(G):null}return null}async C(A,M,H){const G=se(M,o.Manifest);if(!G)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},ae=await this.D(A,G,o.Manifest,{headers:ie});return await(0,c.$Ep)(ae)}async getCoreTranslation(A,M){const H=A.assets.coreTranslations.filter(G=>G[0]===M.toUpperCase())[0];if(H){const G=await this.D(A.identifier.id,H[1],H[0]),ie=await(0,c.$Dp)(G);return ie?JSON.parse(ie):null}return null}async getChangelog(A,M){if(A.assets.changelog){const H=await this.D(A.identifier.id,A.assets.changelog,o.Changelog,{},M);return await(0,c.$Dp)(H)||""}return""}async getAllCompatibleVersions(A,M,H){let G=new L().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?G=G.withFilter(s.ExtensionId,A.identifier.uuid):G=G.withFilter(s.ExtensionName,A.identifier.id);const{galleryExtensions:ie}=await this.B(G,O.CancellationToken.None);if(!ie.length)return[];const ae=x(ie[0]);if((0,v.$No)(ae,H))return[];const le=[];await Promise.all(ie[0].versions.map(async fe=>{try{await this.y(A.identifier.id,fe,M?"any":"release",!0,ae,H)&&le.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Z(le,H))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:he(fe)}));return pe}async D(A,M,H,G={},ie=O.CancellationToken.None){const ae=await this.j,le={type:"GET"},pe={...ae,...G.headers||{}};G={...G,...le,headers:pe};const ye=M.uri,fe=M.fallbackUri,me={...G,url:ye};try{const de=await this.k.request(me,ie);if(de.res.statusCode===200)return de;const we=await(0,c.$Dp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:A,assetType:H,message:we});const Ee={...G,url:fe};return this.k.request(Ee,ie)}}async E(A,M){let H=ue(M);if(!H){const G=await this.C(A,M,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");H=G.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const A=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.$Ep)(A),H=[],G={},ie=[];if(M){for(const ae of M.malicious)H.push({id:ae});if(M.migrateToPreRelease)for(const[ae,le]of Object.entries(M.migrateToPreRelease))(!le.engine||(0,p.$xp)(le.engine,this.u.version,this.u.date))&&(G[ae.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ae,le]of Object.entries(M.deprecated))le&&(G[ae.toLowerCase()]=(0,E.$1f)(le)?{}:le);if(M.search)for(const ae of M.search)ie.push(ae)}return{malicious:H,deprecated:G,search:ie}}};C=$e([oe(1,c.$yp),oe(2,R.$Nj),oe(3,b.$oi),oe(4,h.$Ml),oe(5,y.$Nk),oe(6,g.$7j),oe(7,a.$Ni)],C);let F=class extends C{constructor(A,M,H,G,ie,ae,le,pe){super(A,M,H,G,ie,ae,le,pe)}};e.$Up=F,e.$Up=F=$e([oe(0,$.$Lp),oe(1,c.$yp),oe(2,R.$Nj),oe(3,b.$oi),oe(4,h.$Ml),oe(5,y.$Nk),oe(6,g.$7j),oe(7,a.$Ni)],F);let f=class extends C{constructor(A,M,H,G,ie,ae,le){super(void 0,A,M,H,G,ie,ae,le)}};e.$Vp=f,e.$Vp=f=$e([oe(0,c.$yp),oe(1,R.$Nj),oe(2,b.$oi),oe(3,h.$Ml),oe(4,y.$Nk),oe(5,g.$7j),oe(6,a.$Ni)],f)}),define(ne[166],re([0,1,11,18,13,6,144,22,23,3,69]),function(J,e,D,O,k,j,N,E,l,a,b){"use strict";var v,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=e.$UP=void 0;let p=class extends l.$ql{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,w,$,h,m){super($,h,w,m),this.U=c,this.W=$}O(){return this.U.getItem(v.b,[]).map(w=>({...w,location:(0,a.$Uf)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):D.URI.revive(w.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$UP=p,e.$UP=p=v=$e([oe(0,N.$PP),oe(1,E.$ll),oe(2,O.$pi),oe(3,k.$Nk),oe(4,j.$Nj)],p);let y=d=class extends p{constructor(c,w,$,h,m){super(c,w,$,h,m),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",w=this.$.getItem(c,void 0);if(w){this.$.removeItem(c);const h=w.reduce((m,{workspace:i,profile:r})=>(m[D.URI.revive(i).toString()]=D.URI.revive(r).toString(),m),{});this.$.setItem(d.c,{workspaces:h})}const $=super.Q();return this.$.getItem(d.a,!1)||(this.R($),this.$.setItem(d.a,!0)),$}};e.$VP=y,e.$VP=y=d=$e([oe(0,N.$QP),oe(1,E.$ll),oe(2,O.$pi),oe(3,k.$Nk),oe(4,j.$Nj)],y);let R=class extends y{constructor(c,w,$,h){super(new b.$TP(0,w,h,$),c,w,$,h)}async init(){return await this.$.init(),super.init()}};e.$WP=R,e.$WP=R=$e([oe(0,E.$ll),oe(1,O.$pi),oe(2,k.$Nk),oe(3,j.$Nj)],R)}),define(ne[167],re([0,1,142,9,14,8,3,29,18,143,6,45,141,179]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0,e.$Gr=g;let y=class extends v.$zp{constructor(w,$,h,m){super(m),this.m=w,this.n=$,this.r=h,this.s(),this.B(w.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,$){const{f:h,g:m}=this;let i;try{i=await(0,a.$rm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,j.$0)(n)))}const r={...process.env,...i},t=w.agent?w.agent:await(0,d.$Er)(w.url||"",r,{proxyUrl:h,strictSSL:m});return w.agent=t,w.strictSSL=m,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>g(w,$))}async resolveProxy(w){}async loadCertificates(){return(await new Promise(($,h)=>{J(["@vscode/proxy-agent"],$,h)})).loadSystemCertificates({log:this.r})}};e.$Fr=y,e.$Fr=y=$e([oe(0,E.$Ni),oe(1,l.$pi),oe(2,b.$Nj),oe(3,b.$Oj)],y);async function R(c){return((0,D.parse)(c.url).protocol==="https:"?await new Promise((h,m)=>{J(["https"],h,m)}):await new Promise((h,m)=>{J(["http"],h,m)})).request}async function g(c,w){return O.Promises.withAsyncBody(async($,h)=>{const m=(0,D.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await R(c),r={hostname:m.hostname,port:m.port?parseInt(m.port):m.protocol==="https:"?443:80,protocol:m.protocol,path:m.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,N.$1f)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,N.$Yf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)g({...c,url:n.headers.location,followRedirects:s-1},w).then($,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,p.createGunzip)())),$({res:n,stream:(0,k.$Je)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),w.onCancellationRequested(()=>{t.abort(),h(new j.$5)})})}}),define(ne[180],re([0,1,33,9,34,8,2,15,16,12,35,11,24,29,138,60,140,18,115,165,21,65,145,42,52,161,163,13,128,130,51,126,63,64,149,6,134,39,135,152,32,45,167,69,70,25,151,41,153,154,22,156,23,166,155,162,131,133,4,157,181]),function(J,e,D,O,k,j,N,E,l,a,b,v,d,p,y,R,g,c,w,$,h,m,i,r,t,n,s,o,u,S,I,L,U,z,V,Q,se,te,ue,he,ce,B,X,q,T,x,Z,Y,_,C,F,f,P,A,M,H,G,ie,ae,le,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends N.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(Q.$Nj),W=Ee.get(o.$Nk),K=Ee.get(c.$pi),ee=Ee.get(P.$nl);ke.info("CLI main",this.b),this.h(ke),await this.j(K,W,ee,de),await Promise.all(we.map(ge=>{(0,O.$$g)(ge.flush(),1e3)}))})}async f(){const de=new U.$fi,we={_serviceBrand:void 0,...he.default};de.set(ce.$7j,we);const Ee=new w.$Tm(this.b,we);de.set(c.$pi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?d.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new ie.$OP((0,Q.$2j)(Ee),Ee.logsHome);de.set(Q.$Oj,ke);const W=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];ke.getLogLevel()===Q.LogLevel.Trace&&K.push(new Q.$Vj(ke.getLogLevel()));const ee=this.B(new G.$YP(W,K));de.set(Q.$Nj,ee);const ge=this.B(new u.$tq(ee));de.set(o.$Nk,ge);const ve=this.B(new S.$Tq(ee));ge.registerProvider(E.Schemas.file,ve);const Ne=new f.$hs(ge);de.set(F.$ll,Ne);const Se=new q.$SP(1,Ee,ee,ge),Le=new A.$UP(Se,Ne,Ee,ge,ee);de.set(P.$nl,Le),ge.registerProvider(E.Schemas.vscodeUserData,new le.$ubc(E.Schemas.file,ve,E.Schemas.vscodeUserData,Le,Ne,ee));const Re=a.$i&&we.win32RegValueName?this.B(new ue.$sbc(ee,we.win32RegValueName)):Ee.policyFile?this.B(new se.$tbc(Ee.policyFile,ge,ee)):new te.$4n;de.set(te.$2n,Re);const je=this.B(new y.$ro(Le.defaultProfile.settingsResource,ge,Re,ee));de.set(p.$Ni,je),await Promise.all([Se.init(),je.initialize()]);let Ce;try{Ce=await(0,M.$9ac)(Se,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const De=await(0,M.$0ac)(Se,ee);Le.init(),de.set(F.$ll,new f.$hs(ge));const Ae=new X.$Fr(je,Ee,ee,ke);de.set(B.$yp,Ae),de.set(R.$vo,new I.$ei(g.$bQ,void 0,!0)),de.set(r.$aq,new I.$ei(H.$XP,void 0,!0)),de.set(t.$eq,new I.$ei(s.$6ac,void 0,!0)),de.set(m.$Wp,new I.$ei(m.$Xp,void 0,!0)),de.set(n.$oq,new I.$ei(n.$pq,void 0,!0)),de.set(h.$Qo,new I.$ei($.$Vp,void 0,!0)),de.set(z.$zr,new I.$ei(V.$Br,void 0,!1));const Ue=[],Fe=(0,Y.$cp)(we,je);if((0,Y.$0o)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&Ue.push(new _.$MP(Ae,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,T.$1o)((0,D.release)(),(0,D.hostname)(),process.arch,we.commit,we.version,Ce,De,Fe),piiPaths:(0,Y.$dp)(Ee)};de.set(x.$Ml,new I.$ei(Z.$Hr,[be],!1))}else de.set(x.$Ml,Y.$5o);return[new L.$Wq(de),Ue]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,j.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$5i)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,j.$Z)(we)||(0,j.$1)(we)}),process.on("unhandledRejection",we=>(0,j.$1)(we))}async j(de,we,Ee,ke){let W;if(de.args.profile&&(W=Ee.profiles.find(ee=>ee.name===de.args.profile),!W))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(W??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Yp,new Q.$Vj(Q.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return ke.createInstance(i.$Yp,new Q.$Vj(Q.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Yp,new Q.$Vj(Q.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return ke.createInstance(i.$Yp,new Q.$Vj(Q.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return ke.createInstance(i.$Yp,new Q.$Vj(Q.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$Sbc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,l.$jc)(we)?we:(0,l.$kc)((0,b.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c3cc8b9948d52f04836997a7de01dbd9bb2a7bf/core/vs/code/node/cliProcessMain.js.map
