/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/buffer","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/files/node/watcher/baseWatcher","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","fs/promises","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],I=0,A=se.length;I<A;I++)e[I]=le[se[I]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const j=new Map,L=new Map,O=new Map,R=new Map;function S(f,u){f.has(u.detail)||f.set(u.detail,-u.timestamp)}function g(f,u){const b=f.get(u.detail);b&&(b>=0||f.set(u.detail,b+u.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((f,u)=>f.timestamp-u.timestamp));for(const f of C)switch(f.type){case 10:S(j,f);break;case 11:case 12:g(j,f);break;case 21:S(L,f);break;case 22:g(L,f);break;case 33:S(O,f);break;case 34:g(O,f);break;case 31:S(R,f);break;case 32:g(R,f);break}let P=0;O.forEach(f=>P+=f);function p(f){const u=[];return f.forEach((b,$)=>u.push([$,b])),u}return{amdLoad:p(j),amdInvoke:p(L),nodeRequire:p(O),nodeEval:p(R),nodeRequireTotal:P}}static toMarkdownTable(j,L){let O="";const R=[];return j.forEach((S,g)=>{R[g]=S.length}),L.forEach(S=>{S.forEach((g,C)=>{typeof g>"u"&&(g=S[C]="-");const P=g.toString().length;R[C]=Math.max(P,R[C])})}),j.forEach((S,g)=>{O+=`| ${S+" ".repeat(R[g]-S.toString().length)} `}),O+=`|
`,j.forEach((S,g)=>{O+=`| ${"-".repeat(R[g])} `}),O+=`|
`,L.forEach(S=>{S.forEach((g,C)=>{typeof g<"u"&&(O+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),O+=`|
`}),O}}e.$U=I}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=I,e.$gb=A,e.$hb=j,e.$ib=L,e.$jb=O,e.$kb=R,e.$lb=S,e.$nb=C,e.$ob=P,e.$pb=p,e.$qb=f,e.$rb=u;function I(b,$,l){const d=A(b,$);if(d!==-1)return b[d]}function A(b,$,l=b.length-1){for(let d=l;d>=0;d--){const h=b[d];if($(h))return d}return-1}function j(b,$){const l=L(b,$);return l===-1?void 0:b[l]}function L(b,$,l=0,d=b.length){let h=l,c=d;for(;h<c;){const m=Math.floor((h+c)/2);$(b[m])?h=m+1:c=m}return h-1}function O(b,$){const l=R(b,$);return l===b.length?void 0:b[l]}function R(b,$,l=0,d=b.length){let h=l,c=d;for(;h<c;){const m=Math.floor((h+c)/2);$(b[m])?c=m:h=m+1}return h}function S(b,$,l=0,d=b.length){const h=R(b,$,l,d);return h===b.length?-1:h}class g{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(g.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!$(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const l=L(this.e,$,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function C(b,$){if(b.length===0)return;let l=b[0];for(let d=1;d<b.length;d++){const h=b[d];$(h,l)>0&&(l=h)}return l}function P(b,$){if(b.length===0)return;let l=b[0];for(let d=1;d<b.length;d++){const h=b[d];$(h,l)>=0&&(l=h)}return l}function p(b,$){return C(b,(l,d)=>-$(l,d))}function f(b,$){if(b.length===0)return-1;let l=0;for(let d=1;d<b.length;d++){const h=b[d];$(h,b[l])>0&&(l=d)}return l}function u(b,$){for(const l of b){const d=$(l);if(d!==void 0)return d}}}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=I,e.$L=A,e.$M=j,e.$N=L;function I(O,R){const S=Object.create(null);for(const g of O){const C=R(g);let P=S[C];P||(P=S[C]=[]),P.push(g)}return S}function A(O,R){const S=[],g=[];for(const C of O)R.has(C)||S.push(C);for(const C of R)O.has(C)||g.push(C);return{removed:S,added:g}}function j(O,R){const S=[],g=[];for(const[C,P]of O)R.has(C)||S.push(P);for(const[C,P]of R)O.has(C)||g.push(P);return{removed:S,added:g}}function L(O,R){const S=new Set;for(const g of R)O.has(g)&&S.add(g);return S}}),define(le[84],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=A,e.$Mh=j,e.$Nh=L;function I(O){return(R,S,g)=>{let C=null,P=null;if(typeof g.value=="function"?(C="value",P=g.value):typeof g.get=="function"&&(C="get",P=g.get),!P)throw new Error("not supported");g[C]=O(P,S)}}function A(O,R,S){let g=null,C=null;if(typeof S.value=="function"?(g="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(g="get",C=S.get),!C)throw new Error("not supported");const P=`$memoize$${R}`;S[g]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,p)}),this[P]}}function j(O,R,S){return I((g,C)=>{const P=`$debounce$${C}`,p=`$debounce$result$${C}`;return function(...f){this[p]||(this[p]=S?S():void 0),clearTimeout(this[P]),R&&(this[p]=R(this[p],...f),f=[this[p]]),this[P]=setTimeout(()=>{g.apply(this,f),this[p]=S?S():void 0},O)}})}function L(O,R,S){return I((g,C)=>{const P=`$throttle$timer$${C}`,p=`$throttle$result$${C}`,f=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...b){if(this[p]||(this[p]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),R&&(this[p]=R(this[p],...b)),this[u])return;const $=this[f]+O;$<=Date.now()?(this[f]=Date.now(),g.apply(this,[this[p]]),this[p]=S?S():void 0):(this[u]=!0,this[P]=setTimeout(()=>{this[u]=!1,this[f]=Date.now(),g.apply(this,[this[p]]),this[p]=S?S():void 0},$-Date.now()))}})}}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=A,e.$Z=j,e.$1=L,e.$2=O,e.$3=R,e.$4=g,e.$6=P,e.$7=p,e.$8=f,e.$0=b;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?h.isErrorNoTelemetry(i)?new h(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=I,e.$X=new I;function A(m){e.$X.setUnexpectedErrorHandler(m)}function j(m){if(!m||typeof m!="object")return!1;const i=m;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function L(m){g(m)||e.$X.onUnexpectedError(m)}function O(m){g(m)||e.$X.onUnexpectedExternalError(m)}function R(m){if(m instanceof Error){const{name:i,message:o}=m,n=m.stacktrace||m.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:h.isErrorNoTelemetry(m)}}return m}const S="Canceled";function g(m){return m instanceof C?!0:m instanceof Error&&m.name===S&&m.message===S}class C extends Error{constructor(){super(S),this.name=this.message}}e.$5=C;function P(){const m=new Error(S);return m.name=m.message,m}function p(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}function f(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}class u extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=u;function b(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=$;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class h extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof h)return i;const o=new h;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=h;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=j,e.$tb=L,e.$ub=O,e.$vb=R,e.$wb=S,e.$xb=g,e.$yb=C,e.$zb=P,e.$Ab=p,e.$Bb=f,e.$Cb=u,e.$Db=b,e.$Eb=$,e.top=l,e.$Gb=d,e.$Hb=c,e.$Ib=m,e.$Jb=i,e.$Kb=o,e.$Lb=n,e.$Mb=s,e.$Nb=t,e.$Ob=r,e.$Pb=a,e.$Qb=v,e.$Rb=y,e.$Sb=w,e.$Tb=k,e.$Ub=E,e.$Vb=D,e.$Wb=U,e.$Xb=F,e.$Yb=T,e.$Zb=_,e.$1b=X,e.$2b=ee,e.$3b=H,e.$4b=K,e.$5b=W,e.$6b=B,e.$7b=te,e.$8b=ce,e.$$b=N;function j(J,x=0){return J[J.length-(1+x)]}function L(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function O(J,x,Y=(V,ie)=>V===ie){if(J===x)return!0;if(!J||!x||J.length!==x.length)return!1;for(let V=0,ie=J.length;V<ie;V++)if(!Y(J[V],x[V]))return!1;return!0}function R(J,x){const Y=J.length-1;x<Y&&(J[x]=J[Y]),J.pop()}function S(J,x,Y){return g(J.length,V=>Y(J[V],x))}function g(J,x){let Y=0,V=J-1;for(;Y<=V;){const ie=(Y+V)/2|0,re=x(ie);if(re<0)Y=ie+1;else if(re>0)V=ie-1;else return ie}return-(Y+1)}function C(J,x,Y){if(J=J|0,J>=x.length)throw new TypeError("invalid index");const V=x[Math.floor(x.length*Math.random())],ie=[],re=[],ue=[];for(const de of x){const me=Y(de,V);me<0?ie.push(de):me>0?re.push(de):ue.push(de)}return J<ie.length?C(J,ie,Y):J<ie.length+ue.length?ue[0]:C(J-(ie.length+ue.length),re,Y)}function P(J,x){const Y=[];let V;for(const ie of J.slice(0).sort(x))!V||x(V[0],ie)!==0?(V=[ie],Y.push(V)):V.push(ie);return Y}function*p(J,x){let Y,V;for(const ie of J)V!==void 0&&x(V,ie)?Y.push(ie):(Y&&(yield Y),Y=[ie]),V=ie;Y&&(yield Y)}function f(J,x){for(let Y=0;Y<=J.length;Y++)x(Y===0?void 0:J[Y-1],Y===J.length?void 0:J[Y])}function u(J,x){for(let Y=0;Y<J.length;Y++)x(Y===0?void 0:J[Y-1],J[Y],Y+1===J.length?void 0:J[Y+1])}function b(J,x,Y){const V=[];function ie(de,me,Ee){if(me===0&&Ee.length===0)return;const ke=V[V.length-1];ke&&ke.start+ke.deleteCount===de?(ke.deleteCount+=me,ke.toInsert.push(...Ee)):V.push({start:de,deleteCount:me,toInsert:Ee})}let re=0,ue=0;for(;;){if(re===J.length){ie(re,0,x.slice(ue));break}if(ue===x.length){ie(re,J.length-re,[]);break}const de=J[re],me=x[ue],Ee=Y(de,me);Ee===0?(re+=1,ue+=1):Ee<0?(ie(re,1,[]),re+=1):Ee>0&&(ie(re,0,[me]),ue+=1)}return V}function $(J,x,Y){const V=b(J,x,Y),ie=[],re=[];for(const ue of V)ie.push(...J.slice(ue.start,ue.start+ue.deleteCount)),re.push(...ue.toInsert);return{removed:ie,added:re}}function l(J,x,Y){if(Y===0)return[];const V=J.slice(0,Y).sort(x);return h(J,x,V,Y,J.length),V}function d(J,x,Y,V,ie){return Y===0?Promise.resolve([]):new Promise((re,ue)=>{(async()=>{const de=J.length,me=J.slice(0,Y).sort(x);for(let Ee=Y,ke=Math.min(Y+V,de);Ee<de;Ee=ke,ke=Math.min(ke+V,de)){if(Ee>Y&&await new Promise(Ie=>setTimeout(Ie)),ie&&ie.isCancellationRequested)throw new I.$5;h(J,x,me,Ee,ke)}return me})().then(re,ue)})}function h(J,x,Y,V,ie){for(const re=Y.length;V<ie;V++){const ue=J[V];if(x(ue,Y[re-1])<0){Y.pop();const de=(0,A.$kb)(Y,me=>x(ue,me)<0);Y.splice(de,0,ue)}}}function c(J){return J.filter(x=>!!x)}function m(J){let x=0;for(let Y=0;Y<J.length;Y++)J[Y]&&(J[x]=J[Y],x+=1);J.length=x}function i(J,x,Y){J.splice(Y,0,J.splice(x,1)[0])}function o(J){return!Array.isArray(J)||J.length===0}function n(J){return Array.isArray(J)&&J.length>0}function s(J,x=Y=>Y){const Y=new Set;return J.filter(V=>{const ie=x(V);return Y.has(ie)?!1:(Y.add(ie),!0)})}function t(J){const x=new Set;return Y=>{const V=J(Y);return x.has(V)?!1:(x.add(V),!0)}}function r(J,x){return J.length>0?J[0]:x}function a(J,x){return J.length>0?J[J.length-1]:x}function v(J,x,Y=(V,ie)=>V===ie){let V=0;for(let ie=0,re=Math.min(J.length,x.length);ie<re&&Y(J[ie],x[ie]);ie++)V++;return V}function y(J){return[].concat(...J)}function w(J,x){let Y=typeof x=="number"?J:0;typeof x=="number"?Y=J:(Y=0,x=J);const V=[];if(Y<=x)for(let ie=Y;ie<x;ie++)V.push(ie);else for(let ie=Y;ie>x;ie--)V.push(ie);return V}function k(J,x,Y){return J.reduce((V,ie)=>(V[x(ie)]=Y?Y(ie):ie,V),Object.create(null))}function E(J,x){return J.push(x),()=>D(J,x)}function D(J,x){const Y=J.indexOf(x);if(Y>-1)return J.splice(Y,1),x}function U(J,x,Y){const V=J.slice(0,x),ie=J.slice(x);return V.concat(Y,ie)}function F(J,x){let Y;if(typeof x=="number"){let V=x;Y=()=>{const ie=Math.sin(V++)*179426549;return ie-Math.floor(ie)}}else Y=Math.random;for(let V=J.length-1;V>0;V-=1){const ie=Math.floor(Y()*(V+1)),re=J[V];J[V]=J[ie],J[ie]=re}}function T(J,x){const Y=J.indexOf(x);Y>-1&&(J.splice(Y,1),J.unshift(x))}function _(J,x){const Y=J.indexOf(x);Y>-1&&(J.splice(Y,1),J.push(x))}function X(J,x){for(const Y of x)J.push(Y)}function ee(J,x){return Array.isArray(J)?J.map(x):x(J)}function H(J){return Array.isArray(J)?J:[J]}function K(J){return J[Math.floor(Math.random()*J.length)]}function W(J,x,Y){const V=ne(J,x),ie=J.length,re=Y.length;J.length=ie+re;for(let ue=ie-1;ue>=V;ue--)J[ue+re]=J[ue];for(let ue=0;ue<re;ue++)J[ue+V]=Y[ue]}function B(J,x,Y,V){const ie=ne(J,x);let re=J.splice(ie,Y);return re===void 0&&(re=[]),W(J,ie,V),re}function ne(J,x){return x<0?Math.max(x+J.length,0):Math.min(x,J.length)}var oe;(function(J){function x(re){return re<0}J.isLessThan=x;function Y(re){return re<=0}J.isLessThanOrEqual=Y;function V(re){return re>0}J.isGreaterThan=V;function ie(re){return re===0}J.isNeitherLessOrGreaterThan=ie,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function te(J,x){return(Y,V)=>x(J(Y),J(V))}function ce(...J){return(x,Y)=>{for(const V of J){const ie=V(x,Y);if(!oe.isNeitherLessOrGreaterThan(ie))return ie}return oe.neitherLessOrGreaterThan}}const G=(J,x)=>J-x;e.$9b=G;const q=(J,x)=>(0,e.$9b)(J?1:0,x?1:0);e.$0b=q;function N(J){return(x,Y)=>-J(x,Y)}class M{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let Y=this.c;for(;Y<this.g.length&&x(this.g[Y]);)Y++;const V=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,V}takeFromEndWhile(x){let Y=this.d;for(;Y>=0&&x(this.g[Y]);)Y--;const V=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,V}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const Y=this.g.slice(this.c,this.c+x);return this.c+=x,Y}}e.$_b=M;class z{static{this.empty=new z(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(Y=>(x(Y),!0))}toArray(){const x=[];return this.iterate(Y=>(x.push(Y),!0)),x}filter(x){return new z(Y=>this.iterate(V=>x(V)?Y(V):!0))}map(x){return new z(Y=>this.iterate(V=>Y(x(V))))}some(x){let Y=!1;return this.iterate(V=>(Y=x(V),!Y)),Y}findFirst(x){let Y;return this.iterate(V=>x(V)?(Y=V,!1):!0),Y}findLast(x){let Y;return this.iterate(V=>(x(V)&&(Y=V),!0)),Y}findLastMaxBy(x){let Y,V=!0;return this.iterate(ie=>((V||oe.isGreaterThan(x(ie,Y)))&&(V=!1,Y=ie),!0)),Y}}e.$ac=z;class Z{constructor(x){this.c=x}static createSortPermutation(x,Y){const V=Array.from(x.keys()).sort((ie,re)=>Y(x[ie],x[re]));return new Z(V)}apply(x){return x.map((Y,V)=>x[this.c[V]])}inverse(){const x=this.c.slice();for(let Y=0;Y<this.c.length;Y++)x[this.c[Y]]=Y;return new Z(x)}}e.$bc=Z}),define(le[127],he([0,1,7]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=A,e.$0c=j,e.$$c=L,e.$_c=O,e.$ad=R,e.$bd=S;function A(g,C){if(!g)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function j(g,C="Unreachable"){throw new Error(C)}function L(g){if(!g)throw new I.$cb("Assertion Failed")}function O(g){g||(0,I.$1)(new I.$cb("Soft Assertion Failed"))}function R(g){if(!g()){debugger;g(),(0,I.$1)(new I.$cb("Assertion Failed"))}}function S(g,C){let P=0;for(;P<g.length-1;){const p=g[P],f=g[P+1];if(!C(p,f))return!1;P++}return!0}}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=I;function I(A,j){const L=this;let O=!1,R;return function(){if(O)return R;if(O=!0,j)try{R=A.apply(L,arguments)}finally{j()}else R=A.apply(L,arguments);return R}}}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(A){function j(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=j;const L=Object.freeze([]);function O(){return L}A.empty=O;function*R(i){yield i}A.single=R;function S(i){return j(i)?i:R(i)}A.wrap=S;function g(i){return i||L}A.from=g;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}A.reverse=C;function P(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=P;function p(i){return i[Symbol.iterator]().next().value}A.first=p;function f(i,o){for(const n of i)if(o(n))return!0;return!1}A.some=f;function u(i,o){for(const n of i)if(o(n))return n}A.find=u;function*b(i,o){for(const n of i)o(n)&&(yield n)}A.filter=b;function*$(i,o){let n=0;for(const s of i)yield o(s,n++)}A.map=$;function*l(...i){for(const o of i)yield*o}A.concat=l;function d(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}A.reduce=d;function*h(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}A.slice=h;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,A.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}A.consume=c;async function m(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}A.asyncToArray=m})(I||(e.Iterable=I={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=O,e.$tn=P,e.$un=p,e.$vn=f,e.$wn=u,e.$xn=b,e.$yn=$,e.$zn=l,e.$An=d,e.$Bn=h,e.$Cn=c,e.$Dn=m;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var j;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function O(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,v=0;function y(T){let _=0,X=0;for(;_<T;){const ee=i.charCodeAt(n);if(ee>=48&&ee<=57)X=X*16+ee-48;else if(ee>=65&&ee<=70)X=X*16+ee-65+10;else if(ee>=97&&ee<=102)X=X*16+ee-97+10;else break;n++,_++}return _<T&&(X=-1),X}function w(T){n=T,t="",r=0,a=16,v=0}function k(){const T=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return v=3,i.substring(T,n);let _=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;_=n}else v=3;return i.substring(T,_)}function E(){let T="",_=n;for(;;){if(n>=s){T+=i.substring(_,n),v=2;break}const X=i.charCodeAt(n);if(X===34){T+=i.substring(_,n),n++;break}if(X===92){if(T+=i.substring(_,n),n++,n>=s){v=2;break}switch(i.charCodeAt(n++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const H=y(4);H>=0?T+=String.fromCharCode(H):v=4;break}default:v=5}_=n;continue}if(X>=0&&X<=31)if(S(X)){T+=i.substring(_,n),v=2;break}else v=6;n++}return T}function D(){if(t="",v=0,r=n,n>=s)return r=s,a=17;let T=i.charCodeAt(n);if(R(T)){do n++,t+=String.fromCharCode(T),T=i.charCodeAt(n);while(R(T));return a=15}if(S(T))return n++,t+=String.fromCharCode(T),T===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(T){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=E(),a=10;case 47:{const _=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!S(i.charCodeAt(n));)n++;return t=i.substring(_,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const X=s-1;let ee=!1;for(;n<X;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,ee=!0;break}n++}return ee||(n++,v=1),t=i.substring(_,n),a=13}return t+=String.fromCharCode(T),n++,a=16}case 45:if(t+=String.fromCharCode(T),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=k(),a=11;default:for(;n<s&&U(T);)n++,T=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(T),n++,a=16}}function U(T){if(R(T)||S(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let T;do T=D();while(T>=12&&T<=15);return T}return{setPosition:w,getPosition:()=>n,scan:o?F:D,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function P(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(y,w,k,E){r.value=y,r.offset=w,r.length=k,r.type=E,r.colonOffset=void 0,t=r}try{h(i,{onObjectBegin:(y,w)=>{if(o<=y)throw s;t=void 0,a=o>y,n.push("")},onObjectProperty:(y,w,k)=>{if(o<w||(v(y,w,k,"property"),n[n.length-1]=y,o<=w+k))throw s},onObjectEnd:(y,w)=>{if(o<=y)throw s;t=void 0,n.pop()},onArrayBegin:(y,w)=>{if(o<=y)throw s;t=void 0,n.push(0)},onArrayEnd:(y,w)=>{if(o<=y)throw s;t=void 0,n.pop()},onLiteralValue:(y,w,k)=>{if(o<w||(v(y,w,k,m(y)),o<=w+k))throw s},onSeparator:(y,w,k)=>{if(o<=w)throw s;if(y===":"&&t&&t.type==="property")t.colonOffset=w,a=!1,t=void 0;else if(y===","){const E=n[n.length-1];typeof E=="number"?n[n.length-1]=E+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(y){if(y!==s)throw y}return{path:n,previousNode:t,isAtPropertyKey:a,matches:y=>{let w=0;for(let k=0;w<y.length&&k<n.length;k++)if(y[w]===n[k]||y[w]==="*")w++;else if(y[w]!=="**")return!1;return w===y.length}}}function p(i,o=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(y){Array.isArray(t)?t.push(y):s!==null&&(t[s]=y)}return h(i,{onObjectBegin:()=>{const y={};a(y),r.push(t),t=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const y=[];a(y),r.push(t),t=y,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(y,w,k)=>{o.push({error:y,offset:w,length:k})}},n),t[0]}function f(i,o=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(y){s.type==="property"&&(s.length=y-s.offset,s=s.parent)}function r(y){return s.children.push(y),y}h(i,{onObjectBegin:y=>{s=r({type:"object",offset:y,length:-1,parent:s,children:[]})},onObjectProperty:(y,w,k)=>{s=r({type:"property",offset:w,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:y,offset:w,length:k,parent:s})},onObjectEnd:(y,w)=>{s.length=y+w-s.offset,s=s.parent,t(y+w)},onArrayBegin:(y,w)=>{s=r({type:"array",offset:y,length:-1,parent:s,children:[]})},onArrayEnd:(y,w)=>{s.length=y+w-s.offset,s=s.parent,t(y+w)},onLiteralValue:(y,w,k)=>{r({type:m(y),offset:w,length:k,parent:s,value:y}),t(w+k)},onSeparator:(y,w,k)=>{s.type==="property"&&(y===":"?s.colonOffset=w:y===","&&t(w))},onError:(y,w,k)=>{o.push({error:y,offset:w,length:k})}},n);const v=s.children[0];return v&&delete v.parent,v}function u(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}function $(i){switch(i.type){case"array":return i.children.map($);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=$(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function l(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}function d(i,o,n=!1){if(l(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=d(s[t],o,n);if(r)return r}return i}}function h(i,o,n=L.DEFAULT){const s=O(i,!1);function t(te){return te?()=>te(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(te){return te?ce=>te(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),y=t(o.onObjectEnd),w=t(o.onArrayBegin),k=t(o.onArrayEnd),E=r(o.onLiteralValue),D=r(o.onSeparator),U=t(o.onComment),F=r(o.onError),T=n&&n.disallowComments,_=n&&n.allowTrailingComma;function X(){for(;;){const te=s.scan();switch(s.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:T||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(te){case 12:case 13:T?ee(10):U();break;case 16:ee(1);break;case 15:case 14:break;default:return te}}}function ee(te,ce=[],G=[]){if(F(te),ce.length+G.length>0){let q=s.getToken();for(;q!==17;){if(ce.indexOf(q)!==-1){X();break}else if(G.indexOf(q)!==-1)break;q=X()}}}function H(te){const ce=s.getTokenValue();return te?E(ce):v(ce),X(),!0}function K(){switch(s.getToken()){case 11:{let te=0;try{te=JSON.parse(s.getTokenValue()),typeof te!="number"&&(ee(2),te=0)}catch{ee(2)}E(te);break}case 7:E(null);break;case 8:E(!0);break;case 9:E(!1);break;default:return!1}return X(),!0}function W(){return s.getToken()!==10?(ee(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(D(":"),X(),oe()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function B(){a(),X();let te=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(te||ee(4,[],[]),D(","),X(),s.getToken()===2&&_)break}else te&&ee(6,[],[]);W()||ee(4,[],[2,5]),te=!0}return y(),s.getToken()!==2?ee(7,[2],[]):X(),!0}function ne(){w(),X();let te=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(te||ee(4,[],[]),D(","),X(),s.getToken()===4&&_)break}else te&&ee(6,[],[]);oe()||ee(4,[],[4,5]),te=!0}return k(),s.getToken()!==4?ee(8,[4],[]):X(),!0}function oe(){switch(s.getToken()){case 3:return ne();case 1:return B();case 10:return H(!0);default:return K()}}return X(),s.getToken()===17?n.allowEmptyContent?!0:(ee(4,[],[]),!1):oe()?(s.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}function c(i,o){const n=O(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}function m(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[42],he([0,1,34]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=A,e.$Fn=j,e.$Gn=R,e.$Hn=S;function A(g,C,P){let p,f,u,b,$;if(C){for(b=C.offset,$=b+C.length,u=b;u>0&&!S(g,u-1);)u--;let a=$;for(;a<g.length&&!S(g,a);)a++;f=g.substring(u,a),p=O(f,P)}else f=g,p=0,u=0,b=0,$=g.length;const l=R(P,g);let d=!1,h=0,c;P.insertSpaces?c=L(" ",P.tabSize||4):c="	";const m=(0,I.$sn)(f,!1);let i=!1;function o(){return l+L(c,p+h)}function n(){let a=m.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=m.scan();return i=a===16||m.getTokenError()!==0,a}const s=[];function t(a,v,y){!i&&v<$&&y>b&&g.substring(v,y)!==a&&s.push({offset:v,length:y-v,content:a})}let r=n();if(r!==17){const a=m.getTokenOffset()+u,v=L(c,p);t(v,u,a)}for(;r!==17;){let a=m.getTokenOffset()+m.getTokenLength()+u,v=n(),y="";for(;!d&&(v===12||v===13);){const k=m.getTokenOffset()+u;t(" ",a,k),a=m.getTokenOffset()+m.getTokenLength()+u,y=v===12?o():"",v=n()}if(v===2)r!==1&&(h--,y=o());else if(v===4)r!==3&&(h--,y=o());else{switch(r){case 3:case 1:h++,y=o();break;case 5:case 12:y=o();break;case 13:d?y=o():y=" ";break;case 6:y=" ";break;case 10:if(v===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?y=" ":v!==5&&v!==17&&(i=!0);break;case 16:i=!0;break}d&&(v===12||v===13)&&(y=o())}const w=m.getTokenOffset()+u;t(y,a,w),r=v}return s}function j(g,C){const P=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?P.replace(/\r\n|\r|\n/g,C.eol):P}function L(g,C){let P="";for(let p=0;p<C;p++)P+=g;return P}function O(g,C){let P=0,p=0;const f=C.tabSize||4;for(;P<g.length;){const u=g.charAt(P);if(u===" ")p++;else if(u==="	")p+=f;else break;P++}return Math.floor(p/f)}function R(g,C){for(let P=0;P<C.length;P++){const p=C.charAt(P);if(p==="\r")return P+1<C.length&&C.charAt(P+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return g&&g.eol||`
`}function S(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}}),define(le[62],he([0,1,34,42]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=j,e.$Jn=L,e.$Kn=O,e.$Ln=R,e.$Mn=S;function j(g,C,P){return L(g,C,void 0,P)}function L(g,C,P,p,f){const u=C.slice(),b=[],$=(0,I.$vn)(g,b);let l,d;for(;u.length>0&&(d=u.pop(),l=(0,I.$wn)($,u),l===void 0&&P!==void 0);)typeof d=="string"?P={[d]:P}:P=[P];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const h=(0,I.$wn)(l,[d]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const c=l.children.indexOf(h.parent);let m,i=h.parent.offset+h.parent.length;if(c>0){const o=l.children[c-1];m=o.offset+o.length}else m=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return O(g,{offset:m,length:i-m,content:""},p)}else return O(g,{offset:h.offset,length:h.length,content:JSON.stringify(P)},p);else{if(P===void 0)return[];const c=`${JSON.stringify(d)}: ${JSON.stringify(P)}`,m=f?f(l.children.map(o=>o.children[0].value)):l.children.length;let i;if(m>0){const o=l.children[m-1];i={offset:o.offset+o.length,length:0,content:","+c}}else l.children.length===0?i={offset:l.offset+1,length:0,content:c}:i={offset:l.offset+1,length:0,content:c+","};return O(g,i,p)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let c;if(l.children.length===0||d===0)c={offset:l.offset+1,length:0,content:l.children.length===0?h:h+","};else{const m=d===-1||d>l.children.length?l.children.length:d,i=l.children[m-1];c={offset:i.offset+i.length,length:0,content:","+h}}return O(g,c,p)}else{const h=d,c=l.children[h];let m;if(l.children.length===1)m={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===h){const i=l.children[h-1],o=i.offset+i.length,n=l.offset+l.length;m={offset:o,length:n-2-o,content:""}}else m={offset:c.offset,length:l.children[h+1].offset-c.offset,content:""};return O(g,m,p)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return O(g,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(P)},p)}}function O(g,C,P){let p=R(g,C),f=C.offset,u=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;f>0&&!(0,A.$Hn)(p,f-1);)f--;for(;u<p.length&&!(0,A.$Hn)(p,u);)u++}const b=(0,A.$En)(p,{offset:f,length:u-f},P);for(let l=b.length-1;l>=0;l--){const d=b[l];p=R(p,d),f=Math.min(f,d.offset),u=Math.max(u,d.offset+d.length),u+=d.content.length-d.length}const $=g.length-(p.length-u)-f;return[{offset:f,length:$,content:p.substring(f,u)}]}function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}function S(g,C){const P=C.slice(0).sort((f,u)=>{const b=f.offset-u.offset;return b===0?f.length-u.length:b});let p=g.length;for(let f=P.length-1;f>=0;f--){const u=P[f];if(u.offset+u.length<=p)g=R(g,u);else throw new Error("Overlapping edit");p=u.offset}return g}}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class A{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const O=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=O}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,O){const R=new I(L);if(this.a===I.Undefined)this.a=R,this.b=R;else if(O){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const O=L.prev;O.next=L.next,L.next.prev=O}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$5c=A}),define(le[35],he([0,1]),function(se,e){"use strict";var I,A,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=L,e.$zc=O,e.$Ac=R,e.$Ic=d;function L(h,c,m){let i=h.get(c);return i===void 0&&(i=m,h.set(c,i)),i}function O(h){const c=[];return h.forEach((m,i)=>{c.push(`${i} => ${m}`)}),`Map(${h.size}) {${c.join(", ")}}`}function R(h){const c=[];return h.forEach(m=>{c.push(m)}),`Set(${h.size}) {${c.join(", ")}}`}class S{constructor(c,m){this.uri=c,this.value=m}}function g(h){return Array.isArray(h)}class C{static{this.c=c=>c.toString()}constructor(c,m){if(this[I]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=m??C.c;else if(g(c)){this.d=new Map,this.e=m??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,m){return this.d.set(this.e(c),new S(c,m)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,m){typeof m<"u"&&(c=c.bind(m));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Bc=C;class P{constructor(c,m){this[A]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C(m),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,m){this.c.forEach((i,o)=>c.call(m,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var p;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class f{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,m=0){const i=this.c.get(c);if(i)return m!==0&&this.l(i,m),i.value}set(c,m,i=0){let o=this.c.get(c);if(o)o.value=m,i!==0&&this.l(o,i);else{switch(o={key:c,value:m,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const m=this.c.get(c);if(m)return this.c.delete(c),this.k(m),this.f--,m.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,m){const i=this.g;let o=this.d;for(;o;){if(m?c.bind(m)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,m=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==m)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,m=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==m)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,m=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==m)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let m=this.d,i=this.size;for(;m&&i>c;)this.c.delete(m.key),m=m.next,i--;this.d=m,this.f=i,m&&(m.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const m=c.next,i=c.previous;if(!m||!i)throw new Error("Invalid list");m.previous=i,i.next=m}c.next=void 0,c.previous=void 0,this.g++}l(c,m){if(!this.d||!this.e)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(m===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((m,i)=>{c.push([i,m])}),c}fromJSON(c){this.clear();for(const[m,i]of c)this.set(m,i)}}e.$Dc=f;class u extends f{constructor(c,m=1){super(),this.m=c,this.n=Math.min(Math.max(0,m),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,m=2){return super.get(c,m)}peek(c){return super.get(c,0)}set(c,m){return super.set(c,m,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=u;class b{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let m=this.c.get(c)||0;return m===0?!1:(m--,m===0?this.c.delete(c):this.c.set(c,m),!0)}has(c){return this.c.has(c)}}e.$Fc=b;class ${constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[m,i]of c)this.set(m,i)}clear(){this.c.clear(),this.d.clear()}set(c,m){this.c.set(c,m),this.d.set(m,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const m=this.c.get(c);return m===void 0?!1:(this.c.delete(c),this.d.delete(m),!0)}forEach(c,m){this.c.forEach((i,o)=>{c.call(m,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=$;class l{constructor(){this.c=new Map}add(c,m){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(m)}delete(c,m){const i=this.c.get(c);i&&(i.delete(m),i.size===0&&this.c.delete(c))}forEach(c,m){const i=this.c.get(c);i&&i.forEach(m)}get(c){const m=this.c.get(c);return m||new Set}}e.$Hc=l;function d(h,c){if(h===c)return!0;if(h.size!==c.size)return!1;for(const[m,i]of h)if(!c.has(m)||c.get(m)!==i)return!1;for(const[m]of c)if(!h.has(m))return!1;return!0}}),define(le[2],he([0,1,17,126,35,85,61]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=C,e.$Lc=P,e.$Mc=p,e.$Nc=b,e.$Oc=$,e.$Pc=l,e.$Qc=d,e.$Rc=h,e.$Sc=c,e.$3c=y;const R=!1;let S=null;class g{constructor(){this.b=new Map}static{this.a=0}c(E){let D=this.b.get(E);return D||(D={parent:null,source:null,isSingleton:!1,value:E,idx:g.a++},this.b.set(E,D)),D}trackDisposable(E){const D=this.c(E);D.source||(D.source=new Error().stack)}setParent(E,D){const U=this.c(E);U.parent=D}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,D){const U=D.get(E);if(U)return U;const F=E.parent?this.f(this.c(E.parent),D):E;return D.set(E,F),F}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,E).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(E=10,D){let U;if(D)U=D;else{const ee=new Map,H=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,ee).isSingleton);if(H.length===0)return;const K=new Set(H.map(W=>W.value));if(U=H.filter(W=>!(W.parent&&K.has(W.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(ee){function H(W,B){for(;W.length>0&&B.some(ne=>typeof ne=="string"?ne===W[0]:W[0].match(ne));)W.shift()}const K=ee.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return H(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const T=new j.$Hc;for(const ee of U){const H=F(ee);for(let K=0;K<=H.length;K++)T.add(H.slice(0,K).join(`
`),ee)}U.sort((0,I.$7b)(ee=>ee.idx,I.$9b));let _="",X=0;for(const ee of U.slice(0,E)){X++;const H=F(ee),K=[];for(let W=0;W<H.length;W++){let B=H[W];B=`(shared with ${T.get(H.slice(0,W+1).join(`
`)).size}/${U.length} leaks) at ${B}`;const oe=T.get(H.slice(0,W).join(`
`)),te=(0,A.$K)([...oe].map(ce=>F(ce)[W]),ce=>ce);delete te[H[W]];for(const[ce,G]of Object.entries(te))K.unshift(`    - stacktraces of ${G.length} other leaks continue with ${ce}`);K.unshift(B)}_+=`


==================== Leaking disposable ${X}/${U.length}: ${ee.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return U.length>E&&(_+=`


... and ${U.length-E} more leaking disposables

`),{leaks:U,details:_}}}e.$Jc=g;function C(k){S=k}if(R){const k="__is_disposable_tracked__";C(new class{trackDisposable(E){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[k]||console.log(D)},3e3)}setParent(E,D){if(E&&E!==i.None)try{E[k]=!0}catch{}}markAsDisposed(E){if(E&&E!==i.None)try{E[k]=!0}catch{}}markAsSingleton(E){}})}function P(k){return S?.trackDisposable(k),k}function p(k){S?.markAsDisposed(k)}function f(k,E){S?.setParent(k,E)}function u(k,E){if(S)for(const D of k)S.setParent(D,E)}function b(k){return S?.markAsSingleton(k),k}function $(k){return typeof k.dispose=="function"&&k.dispose.length===0}function l(k){if(O.Iterable.is(k)){const E=[];for(const D of k)if(D)try{D.dispose()}catch(U){E.push(U)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function d(k){for(const E of k)$(E)&&E.dispose();return[]}function h(...k){const E=c(()=>l(k));return u(k,E),E}function c(k){const E=P({dispose:(0,L.$db)(()=>{p(E),k()})});return E}class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return f(E,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),f(E,null))}}e.$Tc=m;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,P(this),f(this.q,this)}dispose(){p(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}e.$Uc=i;class o{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&f(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&f(E,null),E}}e.$Vc=o;class n{constructor(E){this.a=new o,this.b=!1,this.a.value=E}get value(){return this.a.value}set value(E){this.b||E===this.a.value||(this.a.value=E)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(E){let D=E;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,p(this))},this}}e.$Yc=t;class r{constructor(){this.a=new Map}acquire(E,...D){let U=this.a.get(E);U||(U={counter:0,object:this.b(E,...D)},this.a.set(E,U));const{object:F}=U,T=(0,L.$db)(()=>{--U.counter===0&&(this.c(E,U.object),this.a.delete(E))});return U.counter++,{object:F,dispose:T}}}e.$Zc=r;class a{constructor(E){this.a=E}async acquire(E,...D){const U=this.a.acquire(E,...D);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$1c=a;class v{constructor(E){this.object=E}dispose(){}}e.$2c=v;function y(k){const E=new m;try{k(E)}finally{E.dispose()}}class w{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,D,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(E)?.dispose(),this.a.set(E,D)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=w}),define(le[87],he([0,1,35]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=void 0,e.$Yl=j,e.$Zl=O;const A=new I.$Ec(1e4);function j(g){return S(g,"NFC",A)}const L=new I.$Ec(1e4);function O(g){return S(g,"NFD",L)}const R=/[^\u0000-\u0080]/;function S(g,C,P){if(!g)return g;const p=P.get(g);if(p)return p;let f;return R.test(g)?f=g.normalize(C):f=g,P.set(g,f),f}e.$1l=function(){const g=/[\u0300-\u036f]/g;return function(C){return O(C).replace(g,"")}}()}),function(){function se(j){const L=[];typeof j=="number"&&L.push("code/timeOrigin",j);function O(S){L.push(S,Date.now())}function R(){const S=[];for(let g=0;g<L.length;g+=2)S.push({name:L[g],startTime:L[g+1]});return S}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const O of performance.getEntriesByType("mark"))L.push({name:O.name,startTime:Math.round(j+O.startTime)});return L}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function I(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=I(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var A in I)(typeof exports=="object"?exports:se)[A]=I[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function I(A){if(e[A])return e[A].exports;var j=e[A]={i:A,l:!1,exports:{}};return se[A].call(j.exports,j,j.exports,I),j.l=!0,j.exports}return I.m=se,I.c=e,I.d=function(A,j,L){I.o(A,j)||Object.defineProperty(A,j,{enumerable:!0,get:L})},I.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},I.t=function(A,j){if(1&j&&(A=I(A)),8&j||4&j&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&j&&typeof A!="string")for(var O in A)I.d(L,O,function(R){return A[R]}.bind(null,O));return L},I.n=function(A){var j=A&&A.__esModule?function(){return A.default}:function(){return A};return I.d(j,"a",j),j},I.o=function(A,j){return Object.prototype.hasOwnProperty.call(A,j)},I.p="",I(I.s=0)}([function(se,e,I){(function(A){var j;e=se.exports=G,j=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var fe=Array.prototype.slice.call(arguments,0);fe.unshift("SEMVER"),console.log.apply(console,fe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],g=0,C=g++;S[C]="0|[1-9]\\d*";var P=g++;S[P]="[0-9]+";var p=g++;S[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=g++;S[f]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var u=g++;S[u]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var b=g++;S[b]="(?:"+S[C]+"|"+S[p]+")";var $=g++;S[$]="(?:"+S[P]+"|"+S[p]+")";var l=g++;S[l]="(?:-("+S[b]+"(?:\\."+S[b]+")*))";var d=g++;S[d]="(?:-?("+S[$]+"(?:\\."+S[$]+")*))";var h=g++;S[h]="[0-9A-Za-z-]+";var c=g++;S[c]="(?:\\+("+S[h]+"(?:\\."+S[h]+")*))";var m=g++,i="v?"+S[f]+S[l]+"?"+S[c]+"?";S[m]="^"+i+"$";var o="[v=\\s]*"+S[u]+S[d]+"?"+S[c]+"?",n=g++;S[n]="^"+o+"$";var s=g++;S[s]="((?:<|>)?=?)";var t=g++;S[t]=S[P]+"|x|X|\\*";var r=g++;S[r]=S[C]+"|x|X|\\*";var a=g++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[l]+")?"+S[c]+"?)?)?";var v=g++;S[v]="[v=\\s]*("+S[t]+")(?:\\.("+S[t]+")(?:\\.("+S[t]+")(?:"+S[d]+")?"+S[c]+"?)?)?";var y=g++;S[y]="^"+S[s]+"\\s*"+S[a]+"$";var w=g++;S[w]="^"+S[s]+"\\s*"+S[v]+"$";var k=g++;S[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=g++;S[E]="(?:~>?)";var D=g++;S[D]="(\\s*)"+S[E]+"\\s+",R[D]=new RegExp(S[D],"g");var U=g++;S[U]="^"+S[E]+S[a]+"$";var F=g++;S[F]="^"+S[E]+S[v]+"$";var T=g++;S[T]="(?:\\^)";var _=g++;S[_]="(\\s*)"+S[T]+"\\s+",R[_]=new RegExp(S[_],"g");var X=g++;S[X]="^"+S[T]+S[a]+"$";var ee=g++;S[ee]="^"+S[T]+S[v]+"$";var H=g++;S[H]="^"+S[s]+"\\s*("+o+")$|^$";var K=g++;S[K]="^"+S[s]+"\\s*("+i+")$|^$";var W=g++;S[W]="(\\s*)"+S[s]+"\\s*("+o+"|"+S[a]+")",R[W]=new RegExp(S[W],"g");var B=g++;S[B]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var ne=g++;S[ne]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var oe=g++;S[oe]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)j(te,S[te]),R[te]||(R[te]=new RegExp(S[te]));function ce(fe,$e){if(fe instanceof G)return fe;if(typeof fe!="string"||fe.length>L||!($e?R[n]:R[m]).test(fe))return null;try{return new G(fe,$e)}catch{return null}}function G(fe,$e){if(fe instanceof G){if(fe.loose===$e)return fe;fe=fe.version}else if(typeof fe!="string")throw new TypeError("Invalid Version: "+fe);if(fe.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof G))return new G(fe,$e);j("SemVer",fe,$e),this.loose=$e;var we=fe.trim().match($e?R[n]:R[m]);if(!we)throw new TypeError("Invalid Version: "+fe);if(this.raw=fe,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Re=+Ce;if(Re>=0&&Re<O)return Re}return Ce}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ce,e.valid=function(fe,$e){var we=ce(fe,$e);return we?we.version:null},e.clean=function(fe,$e){var we=ce(fe.trim().replace(/^[=v]+/,""),$e);return we?we.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(fe){return j("SemVer.compare",this.version,this.loose,fe),fe instanceof G||(fe=new G(fe,this.loose)),this.compareMain(fe)||this.comparePre(fe)},G.prototype.compareMain=function(fe){return fe instanceof G||(fe=new G(fe,this.loose)),N(this.major,fe.major)||N(this.minor,fe.minor)||N(this.patch,fe.patch)},G.prototype.comparePre=function(fe){if(fe instanceof G||(fe=new G(fe,this.loose)),this.prerelease.length&&!fe.prerelease.length)return-1;if(!this.prerelease.length&&fe.prerelease.length)return 1;if(!this.prerelease.length&&!fe.prerelease.length)return 0;var $e=0;do{var we=this.prerelease[$e],Ce=fe.prerelease[$e];if(j("prerelease compare",$e,we,Ce),we===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(we===void 0)return-1;if(we!==Ce)return N(we,Ce)}while(++$e)},G.prototype.inc=function(fe,$e){switch(fe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+fe)}return this.format(),this.raw=this.version,this},e.inc=function(fe,$e,we,Ce){typeof we=="string"&&(Ce=we,we=void 0);try{return new G(fe,we).inc($e,Ce).version}catch{return null}},e.diff=function(fe,$e){if(J(fe,$e))return null;var we=ce(fe),Ce=ce($e);if(we.prerelease.length||Ce.prerelease.length){for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return"pre"+Re;return"prerelease"}for(var Re in we)if((Re==="major"||Re==="minor"||Re==="patch")&&we[Re]!==Ce[Re])return Re},e.compareIdentifiers=N;var q=/^[0-9]+$/;function N(fe,$e){var we=q.test(fe),Ce=q.test($e);return we&&Ce&&(fe=+fe,$e=+$e),we&&!Ce?-1:Ce&&!we?1:fe<$e?-1:fe>$e?1:0}function M(fe,$e,we){return new G(fe,we).compare(new G($e,we))}function z(fe,$e,we){return M(fe,$e,we)>0}function Z(fe,$e,we){return M(fe,$e,we)<0}function J(fe,$e,we){return M(fe,$e,we)===0}function x(fe,$e,we){return M(fe,$e,we)!==0}function Y(fe,$e,we){return M(fe,$e,we)>=0}function V(fe,$e,we){return M(fe,$e,we)<=0}function ie(fe,$e,we,Ce){var Re;switch($e){case"===":typeof fe=="object"&&(fe=fe.version),typeof we=="object"&&(we=we.version),Re=fe===we;break;case"!==":typeof fe=="object"&&(fe=fe.version),typeof we=="object"&&(we=we.version),Re=fe!==we;break;case"":case"=":case"==":Re=J(fe,we,Ce);break;case"!=":Re=x(fe,we,Ce);break;case">":Re=z(fe,we,Ce);break;case">=":Re=Y(fe,we,Ce);break;case"<":Re=Z(fe,we,Ce);break;case"<=":Re=V(fe,we,Ce);break;default:throw new TypeError("Invalid operator: "+$e)}return Re}function re(fe,$e){if(fe instanceof re){if(fe.loose===$e)return fe;fe=fe.value}if(!(this instanceof re))return new re(fe,$e);j("comparator",fe,$e),this.loose=$e,this.parse(fe),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(fe,$e){return N($e,fe)},e.major=function(fe,$e){return new G(fe,$e).major},e.minor=function(fe,$e){return new G(fe,$e).minor},e.patch=function(fe,$e){return new G(fe,$e).patch},e.compare=M,e.compareLoose=function(fe,$e){return M(fe,$e,!0)},e.rcompare=function(fe,$e,we){return M($e,fe,we)},e.sort=function(fe,$e){return fe.sort(function(we,Ce){return e.compare(we,Ce,$e)})},e.rsort=function(fe,$e){return fe.sort(function(we,Ce){return e.rcompare(we,Ce,$e)})},e.gt=z,e.lt=Z,e.eq=J,e.neq=x,e.gte=Y,e.lte=V,e.cmp=ie,e.Comparator=re;var ue={};function de(fe,$e){if(fe instanceof de)return fe.loose===$e?fe:new de(fe.raw,$e);if(fe instanceof re)return new de(fe.value,$e);if(!(this instanceof de))return new de(fe,$e);if(this.loose=$e,this.raw=fe,this.set=fe.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+fe);this.format()}function me(fe){return!fe||fe.toLowerCase()==="x"||fe==="*"}function Ee(fe,$e,we,Ce,Re,Me,De,ze,Ue,Te,qe,je,ae){return(($e=me(we)?"":me(Ce)?">="+we+".0.0":me(Re)?">="+we+"."+Ce+".0":">="+$e)+" "+(ze=me(Ue)?"":me(Te)?"<"+(+Ue+1)+".0.0":me(qe)?"<"+Ue+"."+(+Te+1)+".0":je?"<="+Ue+"."+Te+"."+qe+"-"+je:"<="+ze)).trim()}function ke(fe,$e){for(var we=0;we<fe.length;we++)if(!fe[we].test($e))return!1;if($e.prerelease.length){for(we=0;we<fe.length;we++)if(j(fe[we].semver),fe[we].semver!==ue&&fe[we].semver.prerelease.length>0){var Ce=fe[we].semver;if(Ce.major===$e.major&&Ce.minor===$e.minor&&Ce.patch===$e.patch)return!0}return!1}return!0}function Ie(fe,$e,we){try{$e=new de($e,we)}catch{return!1}return $e.test(fe)}function Ae(fe,$e,we,Ce){var Re,Me,De,ze,Ue;switch(fe=new G(fe,Ce),$e=new de($e,Ce),we){case">":Re=z,Me=V,De=Z,ze=">",Ue=">=";break;case"<":Re=Z,Me=Y,De=z,ze="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(fe,$e,Ce))return!1;for(var Te=0;Te<$e.set.length;++Te){var qe=$e.set[Te],je=null,ae=null;if(qe.forEach(function(ge){ge.semver===ue&&(ge=new re(">=0.0.0")),je=je||ge,ae=ae||ge,Re(ge.semver,je.semver,Ce)?je=ge:De(ge.semver,ae.semver,Ce)&&(ae=ge)}),je.operator===ze||je.operator===Ue||(!ae.operator||ae.operator===ze)&&Me(fe,ae.semver)||ae.operator===Ue&&De(fe,ae.semver))return!1}return!0}re.prototype.parse=function(fe){var $e=this.loose?R[H]:R[K],we=fe.match($e);if(!we)throw new TypeError("Invalid comparator: "+fe);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new G(we[2],this.loose):this.semver=ue},re.prototype.toString=function(){return this.value},re.prototype.test=function(fe){return j("Comparator.test",fe,this.loose),this.semver===ue||(typeof fe=="string"&&(fe=new G(fe,this.loose)),ie(fe,this.operator,this.semver,this.loose))},re.prototype.intersects=function(fe,$e){if(!(fe instanceof re))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new de(fe.value,$e),Ie(this.value,we,$e);if(fe.operator==="")return we=new de(this.value,$e),Ie(fe.semver,we,$e);var Ce=!(this.operator!==">="&&this.operator!==">"||fe.operator!==">="&&fe.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||fe.operator!=="<="&&fe.operator!=="<"),Me=this.semver.version===fe.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||fe.operator!==">="&&fe.operator!=="<="),ze=ie(this.semver,"<",fe.semver,$e)&&(this.operator===">="||this.operator===">")&&(fe.operator==="<="||fe.operator==="<"),Ue=ie(this.semver,">",fe.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(fe.operator===">="||fe.operator===">");return Ce||Re||Me&&De||ze||Ue},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(fe){return fe.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(fe){var $e=this.loose;fe=fe.trim(),j("range",fe,$e);var we=$e?R[ne]:R[B];fe=fe.replace(we,Ee),j("hyphen replace",fe),fe=fe.replace(R[W],"$1$2$3"),j("comparator trim",fe,R[W]),fe=(fe=(fe=fe.replace(R[D],"$1~")).replace(R[_],"$1^")).split(/\s+/).join(" ");var Ce=$e?R[H]:R[K],Re=fe.split(" ").map(function(Me){return function(De,ze){return j("comp",De),De=function(Ue,Te){return Ue.trim().split(/\s+/).map(function(qe){return function(je,ae){j("caret",je,ae);var ge=ae?R[ee]:R[X];return je.replace(ge,function(be,pe,ve,Pe,Oe){var Le;return j("caret",je,be,pe,ve,Pe,Oe),me(pe)?Le="":me(ve)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":me(Pe)?Le=pe==="0"?">="+pe+"."+ve+".0 <"+pe+"."+(+ve+1)+".0":">="+pe+"."+ve+".0 <"+(+pe+1)+".0.0":Oe?(j("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Le=pe==="0"?ve==="0"?">="+pe+"."+ve+"."+Pe+Oe+" <"+pe+"."+ve+"."+(+Pe+1):">="+pe+"."+ve+"."+Pe+Oe+" <"+pe+"."+(+ve+1)+".0":">="+pe+"."+ve+"."+Pe+Oe+" <"+(+pe+1)+".0.0"):(j("no pr"),Le=pe==="0"?ve==="0"?">="+pe+"."+ve+"."+Pe+" <"+pe+"."+ve+"."+(+Pe+1):">="+pe+"."+ve+"."+Pe+" <"+pe+"."+(+ve+1)+".0":">="+pe+"."+ve+"."+Pe+" <"+(+pe+1)+".0.0"),j("caret return",Le),Le})}(qe,Te)}).join(" ")}(De,ze),j("caret",De),De=function(Ue,Te){return Ue.trim().split(/\s+/).map(function(qe){return function(je,ae){var ge=ae?R[F]:R[U];return je.replace(ge,function(be,pe,ve,Pe,Oe){var Le;return j("tilde",je,be,pe,ve,Pe,Oe),me(pe)?Le="":me(ve)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":me(Pe)?Le=">="+pe+"."+ve+".0 <"+pe+"."+(+ve+1)+".0":Oe?(j("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Le=">="+pe+"."+ve+"."+Pe+Oe+" <"+pe+"."+(+ve+1)+".0"):Le=">="+pe+"."+ve+"."+Pe+" <"+pe+"."+(+ve+1)+".0",j("tilde return",Le),Le})}(qe,Te)}).join(" ")}(De,ze),j("tildes",De),De=function(Ue,Te){return j("replaceXRanges",Ue,Te),Ue.split(/\s+/).map(function(qe){return function(je,ae){je=je.trim();var ge=ae?R[w]:R[y];return je.replace(ge,function(be,pe,ve,Pe,Oe,Le){j("xRange",je,be,pe,ve,Pe,Oe,Le);var Ve=me(ve),Be=Ve||me(Pe),Fe=Be||me(Oe);return pe==="="&&Fe&&(pe=""),Ve?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Fe?(Be&&(Pe=0),Fe&&(Oe=0),pe===">"?(pe=">=",Be?(ve=+ve+1,Pe=0,Oe=0):Fe&&(Pe=+Pe+1,Oe=0)):pe==="<="&&(pe="<",Be?ve=+ve+1:Pe=+Pe+1),be=pe+ve+"."+Pe+"."+Oe):Be?be=">="+ve+".0.0 <"+(+ve+1)+".0.0":Fe&&(be=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0"),j("xRange return",be),be})}(qe,Te)}).join(" ")}(De,ze),j("xrange",De),De=function(Ue,Te){return j("replaceStars",Ue,Te),Ue.trim().replace(R[oe],"")}(De,ze),j("stars",De),De}(Me,$e)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Me){return!!Me.match(Ce)})),Re=Re.map(function(Me){return new re(Me,$e)})},de.prototype.intersects=function(fe,$e){if(!(fe instanceof de))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ce){return fe.set.some(function(Re){return Re.every(function(Me){return Ce.intersects(Me,$e)})})})})},e.toComparators=function(fe,$e){return new de(fe,$e).set.map(function(we){return we.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(fe){if(!fe)return!1;typeof fe=="string"&&(fe=new G(fe,this.loose));for(var $e=0;$e<this.set.length;$e++)if(ke(this.set[$e],fe))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(fe,$e,we){var Ce=null,Re=null;try{var Me=new de($e,we)}catch{return null}return fe.forEach(function(De){Me.test(De)&&(Ce&&Re.compare(De)!==-1||(Re=new G(Ce=De,we)))}),Ce},e.minSatisfying=function(fe,$e,we){var Ce=null,Re=null;try{var Me=new de($e,we)}catch{return null}return fe.forEach(function(De){Me.test(De)&&(Ce&&Re.compare(De)!==1||(Re=new G(Ce=De,we)))}),Ce},e.validRange=function(fe,$e){try{return new de(fe,$e).range||"*"}catch{return null}},e.ltr=function(fe,$e,we){return Ae(fe,$e,"<",we)},e.gtr=function(fe,$e,we){return Ae(fe,$e,">",we)},e.outside=Ae,e.prerelease=function(fe,$e){var we=ce(fe,$e);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(fe,$e,we){return fe=new de(fe,we),$e=new de($e,we),fe.intersects($e)},e.coerce=function(fe){if(fe instanceof G)return fe;if(typeof fe!="string")return null;var $e=fe.match(R[k]);return $e==null?null:ce(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,I(1))},function(se,e){var I,A,j=se.exports={};function L(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R($){if(I===setTimeout)return setTimeout($,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout($,0);try{return I($,0)}catch{try{return I.call(null,$,0)}catch{return I.call(this,$,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{A=typeof clearTimeout=="function"?clearTimeout:O}catch{A=O}})();var S,g=[],C=!1,P=-1;function p(){C&&S&&(C=!1,S.length?g=S.concat(g):P=-1,g.length&&f())}function f(){if(!C){var $=R(p);C=!0;for(var l=g.length;l;){for(S=g,g=[];++P<l;)S&&S[P].run();P=-1,l=g.length}S=null,C=!1,function(d){if(A===clearTimeout)return clearTimeout(d);if((A===O||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(d);try{A(d)}catch{try{return A.call(null,d)}catch{return A.call(this,d)}}}($)}}function u($,l){this.fun=$,this.array=l}function b(){}j.nextTick=function($){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];g.push(new u($,l)),g.length!==1||C||R(f)},u.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=b,j.addListener=b,j.once=b,j.off=b,j.removeListener=b,j.removeAllListeners=b,j.emit=b,j.prependListener=b,j.prependOnceListener=b,j.listeners=function($){return[]},j.binding=function($){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function($){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class A{constructor(R,S,g){this.level=R,this.key=S,this.value=g,this.forward=[]}}const j=void 0;class L{constructor(R,S=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new A(this.c,j,j)}get size(){return this.f}clear(){this.e=new A(this.c,j,j),this.f=0}has(R){return!!L.g(this,R,this.comparator)}get(R){return L.g(this,R,this.comparator)?.value}set(R,S){return L.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=L.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let g=this.e.forward[0];for(;g;)R.call(S,g.value,g.key,this),g=g.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,g){let C=R.e;for(let P=R.d-1;P>=0;P--)for(;C.forward[P]&&g(C.forward[P].key,S)<0;)C=C.forward[P];if(C=C.forward[0],C&&g(C.key,S)===0)return C}static h(R,S,g,C){const P=[];let p=R.e;for(let f=R.d-1;f>=0;f--){for(;p.forward[f]&&C(p.forward[f].key,S)<0;)p=p.forward[f];P[f]=p}if(p=p.forward[0],p&&C(p.key,S)===0)return p.value=g,!1;{const f=L.j(R);if(f>R.d){for(let u=R.d;u<f;u++)P[u]=R.e;R.d=f}p=new A(f,S,g);for(let u=0;u<f;u++)p.forward[u]=P[u].forward[u],P[u].forward[u]=p;return!0}}static j(R,S=.5){let g=1;for(;Math.random()<S&&g<R.c;)g+=1;return g}static k(R,S,g){const C=[];let P=R.e;for(let p=R.d-1;p>=0;p--){for(;P.forward[p]&&g(P.forward[p].key,S)<0;)P=P.forward[p];C[p]=P}if(P=P.forward[0],!P||g(P.key,S)!==0)return!1;for(let p=0;p<R.d&&C[p].forward[p]===P;p++)C[p].forward[p]=P.forward[p];for(;R.d>0&&R.e.forward[R.d-1]===j;)R.d-=1;return!0}}e.$gs=L}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(L){return new A(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=A}),define(le[3],he([0,1,7,85,2,86,63]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=p;const R=!1,S=!1;var g;(function(y){y.None=()=>j.$Uc.None;function w(V){if(S){const{onDidAddListener:ie}=V,re=u.create();let ue=0;V.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),ie?.()}}}function k(V,ie){return K(V,()=>{},0,void 0,!0,void 0,ie)}y.defer=k;function E(V){return(ie,re=null,ue)=>{let de=!1,me;return me=V(Ee=>{if(!de)return me?me.dispose():de=!0,ie.call(re,Ee)},null,ue),de&&me.dispose(),me}}y.once=E;function D(V,ie,re){return ee((ue,de=null,me)=>V(Ee=>ue.call(de,ie(Ee)),null,me),re)}y.map=D;function U(V,ie,re){return ee((ue,de=null,me)=>V(Ee=>{ie(Ee),ue.call(de,Ee)},null,me),re)}y.forEach=U;function F(V,ie,re){return ee((ue,de=null,me)=>V(Ee=>ie(Ee)&&ue.call(de,Ee),null,me),re)}y.filter=F;function T(V){return V}y.signal=T;function _(...V){return(ie,re=null,ue)=>{const de=(0,j.$Rc)(...V.map(me=>me(Ee=>ie.call(re,Ee))));return H(de,ue)}}y.any=_;function X(V,ie,re,ue){let de=re;return D(V,me=>(de=ie(de,me),de),ue)}y.reduce=X;function ee(V,ie){let re;const ue={onWillAddFirstListener(){re=V(de.fire,de)},onDidRemoveLastListener(){re?.dispose()}};ie||w(ue);const de=new h(ue);return ie?.add(de),de.event}function H(V,ie){return ie instanceof Array?ie.push(V):ie&&ie.add(V),V}function K(V,ie,re=100,ue=!1,de=!1,me,Ee){let ke,Ie,Ae,fe=0,$e;const we={leakWarningThreshold:me,onWillAddFirstListener(){ke=V(Re=>{fe++,Ie=ie(Ie,Re),ue&&!Ae&&(Ce.fire(Ie),Ie=void 0),$e=()=>{const Me=Ie;Ie=void 0,Ae=void 0,(!ue||fe>1)&&Ce.fire(Me),fe=0},typeof re=="number"?(clearTimeout(Ae),Ae=setTimeout($e,re)):Ae===void 0&&(Ae=0,queueMicrotask($e))})},onWillRemoveListener(){de&&fe>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,ke.dispose()}};Ee||w(we);const Ce=new h(we);return Ee?.add(Ce),Ce.event}y.debounce=K;function W(V,ie=0,re){return y.debounce(V,(ue,de)=>ue?(ue.push(de),ue):[de],ie,void 0,!0,void 0,re)}y.accumulate=W;function B(V,ie=(ue,de)=>ue===de,re){let ue=!0,de;return F(V,me=>{const Ee=ue||!ie(me,de);return ue=!1,de=me,Ee},re)}y.latch=B;function ne(V,ie,re){return[y.filter(V,ie,re),y.filter(V,ue=>!ie(ue),re)]}y.split=ne;function oe(V,ie=!1,re=[],ue){let de=re.slice(),me=V(Ie=>{de?de.push(Ie):ke.fire(Ie)});ue&&ue.add(me);const Ee=()=>{de?.forEach(Ie=>ke.fire(Ie)),de=null},ke=new h({onWillAddFirstListener(){me||(me=V(Ie=>ke.fire(Ie)),ue&&ue.add(me))},onDidAddFirstListener(){de&&(ie?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return ue&&ue.add(ke),ke.event}y.buffer=oe;function te(V,ie){return(ue,de,me)=>{const Ee=ie(new G);return V(function(ke){const Ie=Ee.evaluate(ke);Ie!==ce&&ue.call(de,Ie)},void 0,me)}}y.chain=te;const ce=Symbol("HaltChainable");class G{constructor(){this.f=[]}map(ie){return this.f.push(ie),this}forEach(ie){return this.f.push(re=>(ie(re),re)),this}filter(ie){return this.f.push(re=>ie(re)?re:ce),this}reduce(ie,re){let ue=re;return this.f.push(de=>(ue=ie(ue,de),ue)),this}latch(ie=(re,ue)=>re===ue){let re=!0,ue;return this.f.push(de=>{const me=re||!ie(de,ue);return re=!1,ue=de,me?de:ce}),this}evaluate(ie){for(const re of this.f)if(ie=re(ie),ie===ce)break;return ie}}function q(V,ie,re=ue=>ue){const ue=(...ke)=>Ee.fire(re(...ke)),de=()=>V.on(ie,ue),me=()=>V.removeListener(ie,ue),Ee=new h({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}y.fromNodeEventEmitter=q;function N(V,ie,re=ue=>ue){const ue=(...ke)=>Ee.fire(re(...ke)),de=()=>V.addEventListener(ie,ue),me=()=>V.removeEventListener(ie,ue),Ee=new h({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}y.fromDOMEventEmitter=N;function M(V){return new Promise(ie=>E(V)(ie))}y.toPromise=M;function z(V){const ie=new h;return V.then(re=>{ie.fire(re)},()=>{ie.fire(void 0)}).finally(()=>{ie.dispose()}),ie.event}y.fromPromise=z;function Z(V,ie,re){return ie(re),V(ue=>ie(ue))}y.runAndSubscribe=Z;class J{constructor(ie,re){this._observable=ie,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{ie.addObserver(this)},onDidRemoveLastListener:()=>{ie.removeObserver(this)}};re||w(ue),this.emitter=new h(ue),re&&re.add(this.emitter)}beginUpdate(ie){this.f++}handlePossibleChange(ie){}handleChange(ie,re){this.g=!0}endUpdate(ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function x(V,ie){return new J(V,ie).emitter.event}y.fromObservable=x;function Y(V){return(ie,re,ue)=>{let de=0,me=!1;const Ee={beginUpdate(){de++},endUpdate(){de--,de===0&&(V.reportChanges(),me&&(me=!1,ie.call(re)))},handlePossibleChange(){},handleChange(){me=!0}};V.addObserver(Ee),V.reportChanges();const ke={dispose(){V.removeObserver(Ee)}};return ue instanceof j.$Tc?ue.add(ke):Array.isArray(ue)&&ue.push(ke),ke}}y.fromObservableLight=Y})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${C.f++}`,C.all.add(this)}start(w){this.g=new O.$3d,this.listenerCount=w}stop(){if(this.g){const w=this.g.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.g=void 0}}}e.$5d=C;let P=-1;function p(y){const w=P;return P=y,{dispose(){P=w}}}class f{constructor(w,k=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=k,this.g=0}dispose(){this.f?.clear()}check(w,k){const E=this.threshold;if(E<=0||k<E)return;this.f||(this.f=new Map);const D=this.f.get(w.value)||0;if(this.f.set(w.value,D+1),this.g-=1,this.g<=0){this.g=E*.5;let U,F=0;for(const[T,_]of this.f)(!U||F<_)&&(U=T,F=_);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${F}):`),console.warn(U)}return()=>{const U=this.f.get(w.value)||0;this.f.set(w.value,U-1)}}}class u{static create(){return new u(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class ${constructor(w){this.value=w,this.id=b++}}const l=2,d=(y,w)=>{if(y instanceof $)w(y);else for(let k=0;k<y.length;k++){const E=y[k];E&&w(E)}};class h{constructor(w){this.w=0,this.f=w,this.g=P>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const w=this.t;queueMicrotask(()=>{d(w,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(w,k,E)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Uc.None;if(this.m)return j.$Uc.None;k&&(w=w.bind(k));const D=new $(w);let U,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(D.stack=u.create(),U=this.g.check(D.stack,this.w+1)),R&&(D.stack=F??u.create()),this.t?this.t instanceof $?(this.u??=new m,this.t=[this.t,D]):this.t.push(D):(this.f?.onWillAddFirstListener?.(this),this.t=D,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,j.$Sc)(()=>{U?.(),this.x(D)});return E instanceof j.$Tc?E.add(T):Array.isArray(E)&&E.push(T),T},this.q}x(w){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,E=k.indexOf(w);if(E===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[E]=void 0;const D=this.u.current===this;if(this.w*l<=k.length){let U=0;for(let F=0;F<k.length;F++)k[F]?k[U++]=k[F]:D&&(this.u.end--,U<this.u.i&&this.u.i--);k.length=U}}y(w,k){if(!w)return;const E=this.f?.onListenerError||I.$1;if(!E){w.value(k);return}try{w.value(k)}catch(D){E(D)}}z(w){const k=w.current.t;for(;w.i<w.end;)this.y(k[w.i++],w.value);w.reset()}fire(w){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,w);else{const k=this.u;k.enqueue(this,w,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=h;const c=()=>new m;e.$8d=c;class m{constructor(){this.i=-1,this.end=0}enqueue(w,k,E){this.i=0,this.end=E,this.current=w,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends h{async fireAsync(w,k,E){if(this.t)for(this.h||(this.h=new L.$5c),d(this.t,D=>this.h.push([D.value,w]));this.h.size>0&&!k.isCancellationRequested;){const[D,U]=this.h.shift(),F=[],T={...U,token:k,waitUntil:_=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");E&&(_=E(_,D)),F.push(_)}};try{D(T)}catch(_){(0,I.$1)(_);continue}Object.freeze(F),await Promise.allSettled(F).then(_=>{for(const X of _)X.status==="rejected"&&(0,I.$1)(X.reason)})}}}e.$9d=i;class o extends h{get isPaused(){return this.h!==0}constructor(w){super(w),this.h=0,this.s=new L.$5c,this.A=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.A(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.w&&(this.h!==0?this.s.push(w):super.fire(w))}}e.$0d=o;class n extends o{constructor(w){super(w),this.k=w.delay??100}fire(w){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(w)}}e.$$d=n;class s extends h{constructor(w){super(w),this.h=[],this.k=w?.merge}fire(w){this.hasListeners()&&(this.h.push(w),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$_d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(w){const k={event:w,listener:null};this.h.push(k),this.g&&this.m(k);const E=()=>{this.g&&this.o(k);const D=this.h.indexOf(k);this.h.splice(D,1)};return(0,j.$Sc)((0,A.$db)(E))}j(){this.g=!0,this.h.forEach(w=>this.m(w))}k(){this.g=!1,this.h.forEach(w=>this.o(w))}m(w){w.listener=w.event(k=>this.f.fire(k))}o(w){w.listener?.dispose(),w.listener=null}dispose(){this.f.dispose();for(const w of this.h)w.listener?.dispose();this.h=[]}}e.$ae=t;class r{constructor(w,k,E,D){this.f=new j.$Tc;const U=this.f.add(new t),F=this.f.add(new j.$4c);function T(_){F.set(_,U.add(D(_)))}for(const _ of w)T(_);this.f.add(k(_=>{T(_)})),this.f.add(E(_=>{F.deleteAndDispose(_)})),this.event=U.event}dispose(){this.f.dispose()}}e.$be=r;class a{constructor(){this.f=[]}wrapEvent(w){return(k,E,D)=>w(U=>{const F=this.f[this.f.length-1];F?F.push(()=>k.call(E,U)):k.call(E,U)},void 0,D)}bufferEvents(w){const k=[];this.f.push(k);const E=w();return this.f.pop(),k.forEach(D=>D()),E}}e.$ce=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=j.$Uc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(w){this.g=w,this.f&&(this.h.dispose(),this.h=w(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=v}),define(le[26],he([0,1,3]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const A=Object.freeze(function(R,S){const g=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(g)}}});var j;(function(R){function S(g){return g===R.None||g===R.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(j||(e.CancellationToken=j={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new I.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=j.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=j.None}}e.$ee=O}),define(le[129],he([0,1,26]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$ee,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Pe=A;class j{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$Qe=j;class L{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$Re=L}),define(le[48],he([0,1,7,2]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=j,e.$ge=L,e.$he=O,e.$ie=R,e.$je=g,e.$ke=C,e.$le=P,e.$me=p,e.$ne=f,e.$oe=u,e.$pe=b,e.$qe=$,e.$re=l,e.$se=d,e.$te=h;function j(c){const m=c;return m?typeof m.read=="function":!1}function L(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(i=>typeof i=="function"):!1}function O(c){const m=c;return m?L(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}function R(c,m){return new S(c,m)}class S{constructor(m,i){this.e=m,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(i=>i(m))}h(m){this.c.error.length===0?(0,I.$1)(m):this.c.error.slice(0).forEach(i=>i(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,i){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(m,i){if(this.a.destroyed)return;let o;switch(m){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(c,m){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return m(i)}function C(c,m,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?m(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}function P(c,m){return new Promise((i,o)=>{const n=[];p(c,{onData:s=>{m&&n.push(s)},onError:s=>{m?o(s):i(void 0)},onEnd:()=>{i(m?m(n):void 0)}})})}function p(c,m,i){c.on("error",o=>{i?.isCancellationRequested||m.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||m.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||m.onData(o)})}function f(c,m){return new Promise((i,o)=>{const n=new A.$Tc,s=[],t=v=>{if(s.push(v),s.length>m)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,A.$Sc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,A.$Sc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,A.$Sc)(()=>c.removeListener("data",t))),c.on("data",t)})}function u(c,m){const i=R(m);return i.end(c),i}function b(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}function $(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}function l(c,m,i){const o=R(i);return p(c,{onData:n=>o.write(m.data(n)),onError:n=>o.error(m.error?m.error(n):n),onEnd:()=>o.end()}),o}function d(c,m,i){let o=!1;return{read:()=>{const n=m.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}function h(c,m,i){let o=!1;const n=R(i);return p(m,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}}),define(le[14],he([0,1,53,48]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=g,e.$we=C,e.$xe=P,e.$ye=p,e.$ze=f,e.$Ae=u,e.$Be=b,e.$Ce=$,e.$De=l,e.$Ee=d,e.$Fe=h,e.$Ge=c,e.$He=m,e.$Ie=i,e.$Je=o,e.$Ke=n,e.$Le=s,e.$Me=t,e.$Ne=r,e.$Oe=y;const j=typeof Buffer<"u",L=new I.$V(()=>new Uint8Array(256));let O,R;class S{static alloc(k){return j?new S(Buffer.allocUnsafe(k)):new S(new Uint8Array(k))}static wrap(k){return j&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new S(k)}static fromString(k,E){return!(E?.dontUseNodeBuffer||!1)&&j?new S(Buffer.from(k)):(O||(O=new TextEncoder),new S(O.encode(k)))}static fromByteArray(k){const E=S.alloc(k.length);for(let D=0,U=k.length;D<U;D++)E.buffer[D]=k[D];return E}static concat(k,E){if(typeof E>"u"){E=0;for(let F=0,T=k.length;F<T;F++)E+=k[F].byteLength}const D=S.alloc(E);let U=0;for(let F=0,T=k.length;F<T;F++){const _=k[F];D.set(_,U),U+=_.byteLength}return D}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=S.alloc(this.byteLength);return k.set(this),k}toString(){return j?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(k,E){return new S(this.buffer.subarray(k,E))}set(k,E){if(k instanceof S)this.buffer.set(k.buffer,E);else if(k instanceof Uint8Array)this.buffer.set(k,E);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),E);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return p(this.buffer,k)}writeUInt32BE(k,E){f(this.buffer,k,E)}readUInt32LE(k){return u(this.buffer,k)}writeUInt32LE(k,E){b(this.buffer,k,E)}readUInt8(k){return $(this.buffer,k)}writeUInt8(k,E){l(this.buffer,k,E)}indexOf(k,E=0){return g(this.buffer,k instanceof S?k.buffer:k,E)}}e.$ue=S;function g(w,k,E=0){const D=k.byteLength,U=w.byteLength;if(D===0)return 0;if(D===1)return w.indexOf(k[0]);if(D>U-E)return-1;const F=L.value;F.fill(k.length);for(let ee=0;ee<k.length;ee++)F[k[ee]]=k.length-ee-1;let T=E+k.length-1,_=T,X=-1;for(;T<U;)if(w[T]===k[_]){if(_===0){X=T;break}T--,_--}else T+=Math.max(k.length-_,F[w[T]]),_=k.length-1;return X}function C(w,k){return w[k+0]<<0>>>0|w[k+1]<<8>>>0}function P(w,k,E){w[E+0]=k&255,k=k>>>8,w[E+1]=k&255}function p(w,k){return w[k]*2**24+w[k+1]*2**16+w[k+2]*2**8+w[k+3]}function f(w,k,E){w[E+3]=k,k=k>>>8,w[E+2]=k,k=k>>>8,w[E+1]=k,k=k>>>8,w[E]=k}function u(w,k){return w[k+0]<<0>>>0|w[k+1]<<8>>>0|w[k+2]<<16>>>0|w[k+3]<<24>>>0}function b(w,k,E){w[E+0]=k&255,k=k>>>8,w[E+1]=k&255,k=k>>>8,w[E+2]=k&255,k=k>>>8,w[E+3]=k&255}function $(w,k){return w[k]}function l(w,k,E){w[E]=k}function d(w){return A.$je(w,k=>S.concat(k))}function h(w){return A.$qe(w)}function c(w){return A.$le(w,k=>S.concat(k))}async function m(w){return w.ended?S.concat(w.buffer):S.concat([...w.buffer,await c(w.stream)])}function i(w){return A.$oe(w,k=>S.concat(k))}function o(w){return A.$re(w,{data:k=>typeof k=="string"?S.fromString(k):S.wrap(k)},k=>S.concat(k))}function n(w){return A.$ie(k=>S.concat(k),w)}function s(w,k){return A.$se(w,k,E=>S.concat(E))}function t(w,k){return A.$te(w,k,E=>S.concat(E))}function r(w){let k=0,E=0,D=0;const U=new Uint8Array(Math.floor(w.length/4*3)),F=_=>{switch(E){case 3:U[D++]=k|_,E=0;break;case 2:U[D++]=k|_>>>2,k=_<<6,E=3;break;case 1:U[D++]=k|_>>>4,k=_<<4,E=2;break;default:k=_<<2,E=1}};for(let _=0;_<w.length;_++){const X=w.charCodeAt(_);if(X>=65&&X<=90)F(X-65);else if(X>=97&&X<=122)F(X-97+26);else if(X>=48&&X<=57)F(X-48+52);else if(X===43||X===45)F(62);else if(X===47||X===95)F(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${w[_]}`)}}const T=D;for(;E>0;)F(0);return S.wrap(U).slice(0,T)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:w},k=!0,E=!1){const D=E?v:a;let U="";const F=w.byteLength%3;let T=0;for(;T<w.byteLength-F;T+=3){const _=w[T+0],X=w[T+1],ee=w[T+2];U+=D[_>>>2],U+=D[(_<<4|X>>>4)&63],U+=D[(X<<2|ee>>>6)&63],U+=D[ee&63]}if(F===1){const _=w[T+0];U+=D[_>>>2],U+=D[_<<4&63],k&&(U+="==")}else if(F===2){const _=w[T+0],X=w[T+1];U+=D[_>>>2],U+=D[(_<<4|X>>>4)&63],U+=D[X<<2&63],k&&(U+="=")}return U}}),define(le[27],he([0,1,129,53]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.GraphemeBreakType=e.$Hf=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=j,e.$Ve=O,e.$We=S,e.$Xe=g,e.$Ye=C,e.$Ze=P,e.$1e=p,e.$2e=f,e.$3e=u,e.$4e=b,e.$5e=$,e.$6e=l,e.$7e=d,e.$8e=h,e.$9e=c,e.$0e=m,e.$$e=i,e.$_e=o,e.$af=n,e.$bf=s,e.$cf=t,e.$df=r,e.$ef=a,e.$ff=v,e.$gf=y,e.$hf=w,e.$if=k,e.$jf=E,e.$kf=D,e.$lf=U,e.$mf=F,e.$nf=T,e.$of=_,e.$pf=X,e.$qf=ee,e.$rf=H,e.$sf=K,e.$vf=oe,e.$wf=te,e.$xf=ce,e.$yf=G,e.$zf=M,e.$Af=Z,e.$Cf=J,e.$Df=x,e.$Ef=Y,e.$Ff=V,e.$Gf=ue,e.$If=de,e.$Jf=me,e.$Kf=Ee,e.$Lf=ke,e.$Mf=Ie,e.$Nf=Ae,e.$Of=fe,e.$Pf=$e,e.$Qf=De;function j(ae){return!ae||typeof ae!="string"?!0:ae.trim().length===0}const L=/{(\d+)}/g;function O(ae,...ge){return ge.length===0?ae:ae.replace(L,function(be,pe){const ve=parseInt(pe,10);return isNaN(ve)||ve<0||ve>=ge.length?be:ge[ve]})}const R=/{([^}]+)}/g;function S(ae,ge){return Object.keys(ge).length===0?ae:ae.replace(R,(be,pe)=>ge[pe]??be)}function g(ae){return ae.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function C(ae){return ae.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function P(ae){return ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(ae,ge){let be=0;const pe=ge.charCodeAt(0);for(let ve=ae.length-1;ve>=0;ve--)ae.charCodeAt(ve)===pe&&be++;return be}function f(ae,ge,be="\u2026"){return ae.length<=ge?ae:`${ae.substr(0,ge)}${be}`}function u(ae,ge,be="\u2026"){if(ae.length<=ge)return ae;const pe=Math.ceil(ge/2)-be.length/2,ve=Math.floor(ge/2)-be.length/2;return`${ae.substr(0,pe)}${be}${ae.substr(ae.length-ve)}`}function b(ae,ge=" "){const be=$(ae,ge);return l(be,ge)}function $(ae,ge){if(!ae||!ge)return ae;const be=ge.length;if(be===0||ae.length===0)return ae;let pe=0;for(;ae.indexOf(ge,pe)===pe;)pe=pe+be;return ae.substring(pe)}function l(ae,ge){if(!ae||!ge)return ae;const be=ge.length,pe=ae.length;if(be===0||pe===0)return ae;let ve=pe,Pe=-1;for(;Pe=ae.lastIndexOf(ge,ve-1),!(Pe===-1||Pe+be!==ve);){if(Pe===0)return"";ve=Pe}return ae.substring(0,ve)}function d(ae){return ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(ae){return ae.replace(/\*/g,"")}function c(ae,ge,be={}){if(!ae)throw new Error("Cannot create regex from empty string");ge||(ae=P(ae)),be.wholeWord&&(/\B/.test(ae.charAt(0))||(ae="\\b"+ae),/\B/.test(ae.charAt(ae.length-1))||(ae=ae+"\\b"));let pe="";return be.global&&(pe+="g"),be.matchCase||(pe+="i"),be.multiline&&(pe+="m"),be.unicode&&(pe+="u"),new RegExp(ae,pe)}function m(ae){return ae.source==="^"||ae.source==="^$"||ae.source==="$"||ae.source==="^\\s*$"?!1:!!(ae.exec("")&&ae.lastIndex===0)}function i(ae){return ae.split(/\r\n|\r|\n/)}function o(ae){const ge=[],be=ae.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(be.length/2);pe++)ge.push(be[2*pe]+(be[2*pe+1]??""));return ge}function n(ae){for(let ge=0,be=ae.length;ge<be;ge++){const pe=ae.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}function s(ae,ge=0,be=ae.length){for(let pe=ge;pe<be;pe++){const ve=ae.charCodeAt(pe);if(ve!==32&&ve!==9)return ae.substring(ge,pe)}return ae.substring(ge,be)}function t(ae,ge=ae.length-1){for(let be=ge;be>=0;be--){const pe=ae.charCodeAt(be);if(pe!==32&&pe!==9)return be}return-1}function r(ae,ge,be){const pe=[];let ve=0;for(const Pe of ae.matchAll(ge)){if(pe.push(ae.slice(ve,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");ve=Pe.index+Pe[0].length,pe.push(be(Pe[0],...Pe.slice(1),Pe.index,ae,Pe.groups))}return pe.push(ae.slice(ve)),Promise.all(pe).then(Pe=>Pe.join(""))}function a(ae,ge){return ae<ge?-1:ae>ge?1:0}function v(ae,ge,be=0,pe=ae.length,ve=0,Pe=ge.length){for(;be<pe&&ve<Pe;be++,ve++){const Ve=ae.charCodeAt(be),Be=ge.charCodeAt(ve);if(Ve<Be)return-1;if(Ve>Be)return 1}const Oe=pe-be,Le=Pe-ve;return Oe<Le?-1:Oe>Le?1:0}function y(ae,ge){return w(ae,ge,0,ae.length,0,ge.length)}function w(ae,ge,be=0,pe=ae.length,ve=0,Pe=ge.length){for(;be<pe&&ve<Pe;be++,ve++){let Ve=ae.charCodeAt(be),Be=ge.charCodeAt(ve);if(Ve===Be)continue;if(Ve>=128||Be>=128)return v(ae.toLowerCase(),ge.toLowerCase(),be,pe,ve,Pe);E(Ve)&&(Ve-=32),E(Be)&&(Be-=32);const Fe=Ve-Be;if(Fe!==0)return Fe}const Oe=pe-be,Le=Pe-ve;return Oe<Le?-1:Oe>Le?1:0}function k(ae){return ae>=48&&ae<=57}function E(ae){return ae>=97&&ae<=122}function D(ae){return ae>=65&&ae<=90}function U(ae,ge){return ae.length===ge.length&&w(ae,ge)===0}function F(ae,ge){const be=ge.length;return ge.length>ae.length?!1:w(ae,ge,0,be)===0}function T(ae,ge){const be=Math.min(ae.length,ge.length);let pe;for(pe=0;pe<be;pe++)if(ae.charCodeAt(pe)!==ge.charCodeAt(pe))return pe;return be}function _(ae,ge){const be=Math.min(ae.length,ge.length);let pe;const ve=ae.length-1,Pe=ge.length-1;for(pe=0;pe<be;pe++)if(ae.charCodeAt(ve-pe)!==ge.charCodeAt(Pe-pe))return pe;return be}function X(ae){return 55296<=ae&&ae<=56319}function ee(ae){return 56320<=ae&&ae<=57343}function H(ae,ge){return(ae-55296<<10)+(ge-56320)+65536}function K(ae,ge,be){const pe=ae.charCodeAt(be);if(X(pe)&&be+1<ge){const ve=ae.charCodeAt(be+1);if(ee(ve))return H(pe,ve)}return pe}function W(ae,ge){const be=ae.charCodeAt(ge-1);if(ee(be)&&ge>1){const pe=ae.charCodeAt(ge-2);if(X(pe))return H(pe,be)}return be}class B{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=W(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=K(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$tf=B;class ne{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new B(ge,be)}nextGraphemeLength(){const ge=Re.getInstance(),be=this.c,pe=be.offset;let ve=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Pe=be.offset,Oe=ge.getGraphemeBreakType(be.nextCodePoint());if(we(ve,Oe)){be.setOffset(Pe);break}ve=Oe}return be.offset-pe}prevGraphemeLength(){const ge=Re.getInstance(),be=this.c,pe=be.offset;let ve=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Pe=be.offset,Oe=ge.getGraphemeBreakType(be.prevCodePoint());if(we(Oe,ve)){be.setOffset(Pe);break}ve=Oe}return pe-be.offset}eol(){return this.c.eol()}}e.$uf=ne;function oe(ae,ge){return new ne(ae,ge).nextGraphemeLength()}function te(ae,ge){return new ne(ae,ge).prevGraphemeLength()}function ce(ae,ge){ge>0&&ee(ae.charCodeAt(ge))&&ge--;const be=ge+oe(ae,ge);return[be-te(ae,be),be]}function G(ae){const ge=new ne(ae);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}let q;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(ae){return q||(q=N()),q.test(ae)}const z=/^[\t\n\r\x20-\x7E]*$/;function Z(ae){return z.test(ae)}e.$Bf=/[\u2028\u2029]/;function J(ae){return e.$Bf.test(ae)}function x(ae){return ae>=11904&&ae<=55215||ae>=63744&&ae<=64255||ae>=65281&&ae<=65374}function Y(ae){return ae>=127462&&ae<=127487||ae===8986||ae===8987||ae===9200||ae===9203||ae>=9728&&ae<=10175||ae===11088||ae===11093||ae>=127744&&ae<=128591||ae>=128640&&ae<=128764||ae>=128992&&ae<=129008||ae>=129280&&ae<=129535||ae>=129648&&ae<=129782}function V(ae,ge,be=""){const pe=ae.trimStart();if(pe.length<ge)return pe;const ve=/\b/g;let Pe=0;for(;ve.test(pe)&&!(pe.length-ve.lastIndex<ge);)Pe=ve.lastIndex,ve.lastIndex+=1;return Pe===0?pe:be+pe.substring(Pe).trimStart()}const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function ue(ae){return ae&&(ae=ae.replace(ie,"").replace(re,"")),ae}e.$Hf="\uFEFF";function de(ae){return!!(ae&&ae.length>0&&ae.charCodeAt(0)===65279)}function me(ae){return de(ae)?ae.substr(1):ae}function Ee(ae,ge){if(!ae||!ge||ae.length<ge.length)return!1;const be=ge.length,pe=ae.toLowerCase();let ve=0,Pe=-1;for(;ve<be;){const Oe=pe.indexOf(ge[ve],Pe+1);if(Oe<0)return!1;Pe=Oe,ve++}return!0}function ke(ae,ge=!1){return ae?(ge&&(ae=ae.replace(/\\./g,"")),ae.toLowerCase()!==ae):!1}function Ie(ae){return ae.charAt(0).toUpperCase()+ae.slice(1)}function Ae(ae,ge=1){if(ge===0)return"";let be=-1;do be=ae.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?ae:(ae[be-1]==="\r"&&be--,ae.substr(0,be))}function fe(ae){return ae=ae%(2*26),ae<26?String.fromCharCode(97+ae):String.fromCharCode(65+ae-26)}function $e(ae){return Re.getInstance().getGraphemeBreakType(ae)}function we(ae,ge){return ae===0?ge!==5&&ge!==7:ae===2&&ge===3?!1:ae===4||ae===2||ae===3||ge===4||ge===2||ge===3?!0:!(ae===8&&(ge===8||ge===9||ge===11||ge===12)||(ae===11||ae===9)&&(ge===9||ge===10)||(ae===12||ae===10)&&ge===10||ge===5||ge===13||ge===7||ae===1||ae===13&&ge===14||ae===6&&ge===6)}var Ce;(function(ae){ae[ae.Other=0]="Other",ae[ae.Prepend=1]="Prepend",ae[ae.CR=2]="CR",ae[ae.LF=3]="LF",ae[ae.Control=4]="Control",ae[ae.Extend=5]="Extend",ae[ae.Regional_Indicator=6]="Regional_Indicator",ae[ae.SpacingMark=7]="SpacingMark",ae[ae.L=8]="L",ae[ae.V=9]="V",ae[ae.T=10]="T",ae[ae.LV=11]="LV",ae[ae.LVT=12]="LVT",ae[ae.ZWJ=13]="ZWJ",ae[ae.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(e.GraphemeBreakType=Ce={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Me()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const be=this.d,pe=be.length/3;let ve=1;for(;ve<=pe;)if(ge<be[3*ve])ve=2*ve;else if(ge>be[3*ve+1])ve=2*ve+1;else return be[3*ve+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ae,ge){if(ae===0)return 0;const be=ze(ae,ge);if(be!==void 0)return be;const pe=new B(ge,ae);return pe.prevCodePoint(),pe.offset}function ze(ae,ge){const be=new B(ge,ae);let pe=be.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(be.offset===0)return;pe=be.prevCodePoint()}if(!Y(pe))return;let ve=be.offset;return ve>0&&be.prevCodePoint()===8205&&(ve=be.offset),ve}function Ue(ae){return 127995<=ae&&ae<=127999}var Te;(function(ae){ae[ae.zwj=8205]="zwj",ae[ae.emojiVariantSelector=65039]="emojiVariantSelector",ae[ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.$Rf="\xA0";class qe{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Qe(ge=>{function be(Fe){const Ke=new Map;for(let Ge=0;Ge<Fe.length;Ge+=2)Ke.set(Fe[Ge],Fe[Ge+1]);return Ke}function pe(Fe,Ke){const Ge=new Map(Fe);for(const[_e,tt]of Ke)Ge.set(_e,tt);return Ge}function ve(Fe,Ke){if(!Fe)return Ke;const Ge=new Map;for(const[_e,tt]of Fe)Ke.has(_e)&&Ge.set(_e,tt);return Ge}const Pe=this.c.value;let Oe=ge.filter(Fe=>!Fe.startsWith("_")&&Fe in Pe);Oe.length===0&&(Oe=["_default"]);let Le;for(const Fe of Oe){const Ke=be(Pe[Fe]);Le=ve(Le,Ke)}const Ve=be(Pe._common),Be=pe(Ve,Le);return new qe(Be)})}static getInstance(ge){return qe.d.get(Array.from(ge))}static{this.e=new A.$V(()=>Object.keys(qe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return qe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Sf=qe;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ge){return je.e().has(ge)}static get codePoints(){return je.e()}}e.$Tf=je}),define(le[54],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=A,e.$9i=j,e.$0i=L,e.$$i=R,e.$aj=b;function A(l){return j(l,0)}function j(l,d){switch(typeof l){case"object":return l===null?L(349,d):Array.isArray(l)?S(l,d):g(l,d);case"string":return R(l,d);case"boolean":return O(l,d);case"number":return L(l,d);case"undefined":return L(937,d);default:return L(617,d)}}function L(l,d){return(d<<5)-d+l|0}function O(l,d){return L(l?433:863,d)}function R(l,d){d=L(149417,d);for(let h=0,c=l.length;h<c;h++)d=L(l.charCodeAt(h),d);return d}function S(l,d){return d=L(104579,d),l.reduce((h,c)=>j(c,h),d)}function g(l,d){return d=L(181387,d),Object.keys(l).sort().reduce((h,c)=>(h=R(c,h),j(l[c],h)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=j(d,this.g),this.g}}e.$_i=C;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(l,d,h=32){const c=h-d,m=~((1<<c)-1);return(l<<d|(m&l)>>>c)>>>0}function f(l,d=0,h=l.byteLength,c=0){for(let m=0;m<h;m++)l[d+m]=c}function u(l,d,h="0"){for(;l.length<d;)l=h+l;return l}function b(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(h=>h.toString(16).padStart(2,"0")).join(""):u((l>>>0).toString(16),d/4)}class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const h=d.length;if(h===0)return;const c=this.p;let m=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=d.charCodeAt(0),n=0);;){let s=o;if(I.$pf(o))if(n+1<h){const t=d.charCodeAt(n+1);I.$qf(t)?(n++,s=I.$rf(o,t)):s=65533}else{i=o;break}else I.$qf(o)&&(s=65533);if(m=this.w(c,m,s),n++,n<h)o=d.charCodeAt(n);else break}this.r=m,this.u=i}w(d,h,c){return c<128?d[h++]=c:c<2048?(d[h++]=192|(c&1984)>>>6,d[h++]=128|(c&63)>>>0):c<65536?(d[h++]=224|(c&61440)>>>12,d[h++]=128|(c&4032)>>>6,d[h++]=128|(c&63)>>>0):(d[h++]=240|(c&1835008)>>>18,d[h++]=128|(c&258048)>>>12,d[h++]=128|(c&4032)>>>6,d[h++]=128|(c&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=$.g,h=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,p(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let c=this.h,m=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=m&i|~m&o,t=1518500249):a<40?(s=m^i^o,t=1859775393):a<60?(s=m&i|m&o|i&o,t=2400959708):(s=m^i^o,t=3395469782),r=p(c,5)+s+n+t+d.getUint32(a*4,!1)&4294967295,n=o,o=i,i=p(m,30),m=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+m&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$bj=$}),define(le[88],he([0,1,27]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(A||(A={})),function(j){const L="error",O="warning",R="warn",S="info",g="ignore";function C(p){return p?I.$lf(L,p)?j.Error:I.$lf(O,p)||I.$lf(R,p)?j.Warning:I.$lf(S,p)?j.Info:j.Ignore:j.Ignore}j.fromValue=C;function P(p){switch(p){case j.Error:return L;case j.Warning:return O;case j.Info:return S;default:return g}}j.toString=P}(A||(A={})),e.default=A}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(le[49],he([0,1,17,27]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class j{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const u=f.charCodeAt(0),b=this.b.charCodeAt(this.c);return u-b}value(){return this.b[this.c]}}e.$ji=j;class L{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.$ff)(f,this.b,0,f.length,this.c,this.d):(0,A.$hf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=L;class O{constructor(f=!0,u=!0){this.f=f,this.g=u}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let u=f.length-1;u>=0;u--,this.c--){const b=this.b.charCodeAt(u);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===47||this.f&&u===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.$ff)(f,this.b,0,f.length,this.d,this.e):(0,A.$hf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=O;var R;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(f,u){this.f=f,this.g=u,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.$gf)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.$gf)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.$ef)(f,this.c.query);if(this.d[this.e]===5)return(0,A.$ef)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(C||(C={}));class P{static forUris(f=()=>!1,u=()=>!1){return new P(new S(f,u))}static forPaths(f=!1){return new P(new O(void 0,!f))}static forStrings(){return new P(new j)}static forConfigKeys(){return new P(new L)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,u){if(u){const b=u.slice(0);(0,I.$Xb)(b);for(const $ of b)this.set($,f)}else{const b=f.slice(0);(0,I.$Xb)(b);for(const $ of b)this.set($[0],$[1])}}set(f,u){const b=this.b.reset(f);let $;this.c||(this.c=new g,this.c.segment=b.value());const l=[];for($=this.c;;){const h=b.cmp($.segment);if(h>0)$.left||($.left=new g,$.left.segment=b.value()),l.push([-1,$]),$=$.left;else if(h<0)$.right||($.right=new g,$.right.segment=b.value()),l.push([1,$]),$=$.right;else if(b.hasNext())b.next(),$.mid||($.mid=new g,$.mid.segment=b.value()),l.push([0,$]),$=$.mid;else break}const d=$.value;$.value=u,$.key=f;for(let h=l.length-1;h>=0;h--){const c=l[h][1];c.updateHeight();const m=c.balanceFactor();if(m<-1||m>1){const i=l[h][0],o=l[h+1][0];if(i===1&&o===1)l[h][1]=c.rotateLeft();else if(i===-1&&o===-1)l[h][1]=c.rotateRight();else if(i===1&&o===-1)c.right=l[h+1][1]=l[h+1][1].rotateRight(),l[h][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=l[h+1][1]=l[h+1][1].rotateLeft(),l[h][1]=c.rotateRight();else throw new Error;if(h>0)switch(l[h-1][0]){case-1:l[h-1][1].left=l[h][1];break;case 1:l[h-1][1].right=l[h][1];break;case 0:l[h-1][1].mid=l[h][1];break}else this.c=l[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const u=this.b.reset(f);let b=this.c;for(;b;){const $=u.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(u.hasNext())u.next(),b=b.mid;else break}return b}has(f){const u=this.d(f);return!(u?.value===void 0&&u?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,u){const b=this.b.reset(f),$=[];let l=this.c;for(;l;){const d=b.cmp(l.segment);if(d>0)$.push([-1,l]),l=l.left;else if(d<0)$.push([1,l]),l=l.right;else if(b.hasNext())b.next(),$.push([0,l]),l=l.mid;else break}if(l){if(u?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:h,value:c,segment:m}=d;this.e(d.key,!1),l.key=h,l.value=c,l.segment=m}}else{const d=l.left??l.right;if($.length>0){const[h,c]=$[$.length-1];switch(h){case-1:c.left=d;break;case 0:c.mid=d;break;case 1:c.right=d;break}}else this.c=d}for(let d=$.length-1;d>=0;d--){const h=$[d][1];h.updateHeight();const c=h.balanceFactor();if(c>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),$[d][1]=h.rotateLeft()):c<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),$[d][1]=h.rotateRight()),d>0)switch($[d-1][0]){case-1:$[d-1][1].left=$[d][1];break;case 1:$[d-1][1].right=$[d][1];break;case 0:$[d-1][1].mid=$[d][1];break}else this.c=$[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const u=this.b.reset(f);let b=this.c,$;for(;b;){const l=u.cmp(b.segment);if(l>0)b=b.left;else if(l<0)b=b.right;else if(u.hasNext())u.next(),$=b.value||$,b=b.mid;else break}return b&&b.value||$}findSuperstr(f){return this.g(f,!1)}g(f,u){const b=this.b.reset(f);let $=this.c;for(;$;){const l=b.cmp($.segment);if(l>0)$=$.left;else if(l<0)$=$.right;else if(b.hasNext())b.next(),$=$.mid;else return $.mid?this.h($.mid):u?$.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[u,b]of this)f(b,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const u=[];return this.j(f,u),u[Symbol.iterator]()}j(f,u){f&&(f.left&&this.j(f.left,u),f.value&&u.push([f.key,f.value]),f.mid&&this.j(f.mid,u),f.right&&this.j(f.right,u))}_isBalanced(){const f=u=>{if(!u)return!0;const b=u.balanceFactor();return b<-1||b>1?!1:f(u.left)&&f(u.right)};return f(this.c)}}e.$ni=P}),define(le[13],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=I,e.$Vf=A,e.$Wf=j,e.$Xf=L,e.$Yf=O,e.$Zf=R,e.$1f=S,e.$2f=g,e.$3f=C,e.$4f=P,e.$5f=p,e.$6f=f,e.$7f=u,e.$8f=$,e.$9f=l,e.$0f=d,e.$$f=h,e.$_f=c;function I(m){return typeof m=="string"}function A(m){return Array.isArray(m)&&m.every(i=>I(i))}function j(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}function L(m){const i=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof i}function O(m){return typeof m=="number"&&!isNaN(m)}function R(m){return!!m&&typeof m[Symbol.iterator]=="function"}function S(m){return m===!0||m===!1}function g(m){return typeof m>"u"}function C(m){return!P(m)}function P(m){return g(m)||m===null}function p(m,i){if(!m)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function f(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}function u(...m){const i=[];for(let o=0;o<m.length;o++){const n=m[o];if(P(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}const b=Object.prototype.hasOwnProperty;function $(m){if(!j(m))return!1;for(const i in m)if(b.call(m,i))return!1;return!0}function l(m){return typeof m=="function"}function d(...m){return m.length>0&&m.every(l)}function h(m,i){const o=Math.min(m.length,i.length);for(let n=0;n<o;n++)c(m[n],i[n])}function c(m,i){if(I(i)){if(typeof m!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(l(i)){try{if(m instanceof i)return}catch{}if(!P(m)&&m.constructor===i||i.length===1&&i.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=A,e.$On=j,e.$Pn=O,e.$Qn=S,e.$Rn=g,e.$Sn=C,e.$Tn=P,e.$Un=p,e.$Vn=f,e.$Wn=u,e.$Xn=b,e.$Yn=$;function A(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([h,c])=>{d[h]=c&&typeof c=="object"?A(c):c}),d}function j(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const h=d.shift();Object.freeze(h);for(const c in h)if(L.call(h,c)){const m=h[c];typeof m=="object"&&!Object.isFrozen(m)&&!(0,I.$Xf)(m)&&d.push(m)}}return l}const L=Object.prototype.hasOwnProperty;function O(l,d){return R(l,d,new Set)}function R(l,d,h){if((0,I.$4f)(l))return l;const c=d(l);if(typeof c<"u")return c;if(Array.isArray(l)){const m=[];for(const i of l)m.push(R(i,d,h));return m}if((0,I.$Wf)(l)){if(h.has(l))throw new Error("Cannot clone recursive data-structure");h.add(l);const m={};for(const i in l)L.call(l,i)&&(m[i]=R(l[i],d,h));return h.delete(l),m}return l}function S(l,d,h=!0){return(0,I.$Wf)(l)?((0,I.$Wf)(d)&&Object.keys(d).forEach(c=>{c in l?h&&((0,I.$Wf)(l[c])&&(0,I.$Wf)(d[c])?S(l[c],d[c],h):l[c]=d[c]):l[c]=d[c]}),l):d}function g(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let h,c;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(h=0;h<l.length;h++)if(!g(l[h],d[h]))return!1}else{const m=[];for(c in l)m.push(c);m.sort();const i=[];for(c in d)i.push(c);if(i.sort(),!g(m,i))return!1;for(h=0;h<m.length;h++)if(!g(l[m[h]],d[m[h]]))return!1}return!0}function C(l){const d=new Set;return JSON.stringify(l,(h,c)=>{if((0,I.$Wf)(c)||Array.isArray(c)){if(d.has(c))return"[Circular]";d.add(c)}return c})}function P(l,d){const h=Object.create(null);return!l||!d||Object.keys(d).forEach(m=>{const i=l[m],o=d[m];g(i,o)||(h[m]=o)}),h}function p(l,d){const h=d.toLowerCase(),c=Object.keys(l).find(m=>m.toLowerCase()===h);return c?l[c]:l[d]}function f(l,d){const h=Object.create(null);for(const[c,m]of Object.entries(l))d(c,m)&&(h[c]=m);return h}function u(l){let d=[];for(;Object.prototype!==l;)d=d.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return d}function b(l){const d=[];for(const h of u(l))typeof l[h]=="function"&&d.push(h);return d}function $(l,d){const h=m=>function(){const i=Array.prototype.slice.call(arguments,0);return d(m,i)},c={};for(const m of l)c[m]=h(m);return c}}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=A;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(j){return I.test(j)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){j(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,g="";return g+=O[L[S++]],g+=O[L[S++]],g+=O[L[S++]],g+=O[L[S++]],g+="-",g+=O[L[S++]],g+=O[L[S++]],g+="-",g+=O[L[S++]],g+=O[L[S++]],g+="-",g+=O[L[S++]],g+=O[L[S++]],g+="-",g+=O[L[S++]],g+=O[L[S++]],g+=O[L[S++]],g+=O[L[S++]],g+=O[L[S++]],g+=O[L[S++]],g}}()}),define(le[131],he([0,1,37]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=L;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(O){const R=O.replace(/\-/g,":").toLowerCase();return!A.has(R)}function L(){const O=(0,I.networkInterfaces)();for(const R in O){const S=O[R];if(S){for(const{mac:g}of S)if(j(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[132],he([0,1,271,14]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UV=void 0;class j extends I.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,S){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,A.$ve)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),S()}_flush(O){this.a&&this.push(this.a),O()}}e.$UV=j}),define(le[133],he([0,1,64]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=void 0,e.$Fg=A,e.$Hg=L;function A(R,S,g,C=1){let P=!1;return new Promise(p=>{const f=setTimeout(()=>{if(!P)return P=!0,p(0)},g);j(R,S,C,u=>{if(!P)return P=!0,clearTimeout(f),p(u)})})}function j(R,S,g,C){if(S===0)return C(0);const P=new I.Socket;P.once("connect",()=>(O(P),j(R+g,S-1,g,C))),P.once("data",()=>{}),P.once("error",p=>(O(P),p.code!=="ECONNREFUSED"?j(R+g,S-1,g,C):C(R))),P.connect(R,"127.0.0.1")}e.$Gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,S,g,C="127.0.0.1"){let P=!1,p,f=1;const u=I.createServer({pauseOnConnect:!0});function b($,l){P||(P=!0,u.removeAllListeners(),u.close(),p&&clearTimeout(p),l($))}return new Promise($=>{p=setTimeout(()=>{b(0,$)},g),u.on("listening",()=>{b(R,$)}),u.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&f<S?(R++,f++,u.listen(R,C)):b(0,$)}),u.on("close",()=>{b(0,$)}),u.listen(R,C)})}function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$V=I;function I(A){return!!A.parentPort}}),define(le[135],he([11,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=g,e.$Nm=C,e.$Om=P;const A=60,j=A*60,L=j*24,O=L*7,R=L*30,S=L*365;function g(p,f,u,b){typeof p!="number"&&(p=p.getTime());const $=Math.round((new Date().getTime()-p)/1e3);if($<-30)return(0,I.localize)(0,null,g(new Date().getTime()+$*1e3,!1));if(!b&&$<30)return(0,I.localize)(1,null);let l;return $<A?(l=$,f?l===1?u?(0,I.localize)(2,null,l):(0,I.localize)(3,null,l):u?(0,I.localize)(4,null,l):(0,I.localize)(5,null,l):l===1?u?(0,I.localize)(6,null,l):(0,I.localize)(7,null,l):u?(0,I.localize)(8,null,l):(0,I.localize)(9,null,l)):$<j?(l=Math.floor($/A),f?l===1?u?(0,I.localize)(10,null,l):(0,I.localize)(11,null,l):u?(0,I.localize)(12,null,l):(0,I.localize)(13,null,l):l===1?u?(0,I.localize)(14,null,l):(0,I.localize)(15,null,l):u?(0,I.localize)(16,null,l):(0,I.localize)(17,null,l)):$<L?(l=Math.floor($/j),f?l===1?u?(0,I.localize)(18,null,l):(0,I.localize)(19,null,l):u?(0,I.localize)(20,null,l):(0,I.localize)(21,null,l):l===1?u?(0,I.localize)(22,null,l):(0,I.localize)(23,null,l):u?(0,I.localize)(24,null,l):(0,I.localize)(25,null,l)):$<O?(l=Math.floor($/L),f?l===1?(0,I.localize)(26,null,l):(0,I.localize)(27,null,l):l===1?(0,I.localize)(28,null,l):(0,I.localize)(29,null,l)):$<R?(l=Math.floor($/O),f?l===1?u?(0,I.localize)(30,null,l):(0,I.localize)(31,null,l):u?(0,I.localize)(32,null,l):(0,I.localize)(33,null,l):l===1?u?(0,I.localize)(34,null,l):(0,I.localize)(35,null,l):u?(0,I.localize)(36,null,l):(0,I.localize)(37,null,l)):$<S?(l=Math.floor($/R),f?l===1?u?(0,I.localize)(38,null,l):(0,I.localize)(39,null,l):u?(0,I.localize)(40,null,l):(0,I.localize)(41,null,l):l===1?u?(0,I.localize)(42,null,l):(0,I.localize)(43,null,l):u?(0,I.localize)(44,null,l):(0,I.localize)(45,null,l)):(l=Math.floor($/S),f?l===1?u?(0,I.localize)(46,null,l):(0,I.localize)(47,null,l):u?(0,I.localize)(48,null,l):(0,I.localize)(49,null,l):l===1?u?(0,I.localize)(50,null,l):(0,I.localize)(51,null,l):u?(0,I.localize)(52,null,l):(0,I.localize)(53,null,l))}function C(p,f){const u=Math.abs(p/1e3);return u<1?f?(0,I.localize)(54,null,p):(0,I.localize)(55,null,p):u<A?f?(0,I.localize)(56,null,Math.round(p)/1e3):(0,I.localize)(57,null,Math.round(p)/1e3):u<j?f?(0,I.localize)(58,null,Math.round(p/(1e3*A))):(0,I.localize)(59,null,Math.round(p/(1e3*A))):u<L?f?(0,I.localize)(60,null,Math.round(p/(1e3*j))):(0,I.localize)(61,null,Math.round(p/(1e3*j))):(0,I.localize)(62,null,Math.round(p/(1e3*L)))}function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[136],he([11,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,13,136]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=S,e.$6i=g,e.$7i=C;function L(P,p){return p&&(P.stack||P.stacktrace)?j.localize(0,null,R(P),O(P.stack)||O(P.stacktrace)):R(P)}function O(P){return Array.isArray(P)?P.join(`
`):P}function R(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?j.localize(1,null,P.message):P.message||j.localize(2,null)}function S(P=null,p=!1){if(!P)return j.localize(3,null);if(Array.isArray(P)){const f=I.$Hb(P),u=S(f[0],p);return f.length>1?j.localize(4,null,u,f.length):u}if(A.$Uf(P))return P;if(P.detail){const f=P.detail;if(f.error)return L(f.error,p);if(f.exception)return L(f.exception,p)}return P.stack?L(P,p):P.message?P.message:j.localize(5,null)}function g(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}function C(P,p){let f;return typeof P=="string"?f=new Error(P):f=P,f.actions=p,f}}),define(le[137],he([11,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=A;function A(j){switch(j){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}}),define(le[139],he([11,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=v,e.$J=y,e.$g="en";let A=!1,j=!1,L=!1,O=!1,R=!1,S=!1,g=!1,C=!1,P=!1,p=!1,f,u=e.$g,b=e.$g,$,l;const d=globalThis;let h;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?h=d.vscode.process:typeof process<"u"&&(h=process);const c=typeof h?.versions?.electron=="string",m=c&&h?.type==="renderer";if(typeof h=="object"){A=h.platform==="win32",j=h.platform==="darwin",L=h.platform==="linux",O=L&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,g=c,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,u=e.$g;const w=h.env.VSCODE_NLS_CONFIG;if(w)try{const k=JSON.parse(w),E=k.availableLanguages["*"];f=k.locale,b=k.osLocale,u=E||e.$g,$=k._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!m?(l=navigator.userAgent,A=l.indexOf("Windows")>=0,j=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=l.indexOf("Linux")>=0,p=l?.indexOf("Mobi")>=0,S=!0,f=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,u=f,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;j?n=1:A?n=3:L&&(n=2),e.$i=A,e.$j=j,e.$k=L,e.$l=O,e.$m=R,e.$n=g,e.$o=S,e.$p=S&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=C,e.$s=p,e.$t=P,e.$u=n,e.$v=l,e.$w=u;var s;(function(w){function k(){return e.$w}w.value=k;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=E;function D(){return e.$w==="en"}w.isDefault=D})(s||(e.Language=s={})),e.$x=f,e.$y=b,e.$z=$,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const w=[];d.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let D=0,U=w.length;D<U;D++){const F=w[D];if(F.id===E.data.vscodeScheduleAsyncWork){w.splice(D,1),F.callback();return}}});let k=0;return E=>{const D=++k;w.push({id:D,callback:E}),d.postMessage({vscodeScheduleAsyncWork:D},"*")}}return w=>setTimeout(w)})();var t;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=j||C?2:A?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,r=new Uint16Array(w.buffer)[0]===513}return r}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function y(w){return parseFloat(w)>=20}}),define(le[36],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let A;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const L=j.process;A={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$ec=A.platform,e.$fc=A.arch}),define(le[140],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BV=O;var A;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(A||(A={}));const j="XDG_CURRENT_DESKTOP",L="KDE_SESSION_VERSION";function O(){const R=I.env[j];if(R){const g=R.split(":").map(C=>C.trim()).filter(C=>C.length>0);for(const C of g)switch(C){case"Unity":{const P=I.env.DESKTOP_SESSION;return P&&P.includes("gnome-fallback")?A.GNOME:A.UNITY}case"Deepin":return A.DEEPIN;case"GNOME":return A.GNOME;case"X-Cinnamon":return A.CINNAMON;case"KDE":{const P=I.env[L];return P==="5"?A.KDE5:P==="6"?A.KDE6:A.KDE4}case"Pantheon":return A.PANTHEON;case"XFCE":return A.XFCE;case"UKUI":return A.UKUI;case"LXQt":return A.LXQT}}const S=I.env.DESKTOP_SESSION;if(S)switch(S){case"deepin":return A.DEEPIN;case"gnome":case"mate":return A.GNOME;case"kde4":case"kde-plasma":return A.KDE4;case"kde":return L in I.env?A.KDE4:A.KDE3;case"xfce":case"xubuntu":return A.XFCE;case"ukui":return A.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?A.GNOME:"KDE_FULL_SESSION"in I.env?L in I.env?A.KDE4:A.KDE3:A.UNKNOWN}}),define(le[15],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const A=65,j=97,L=90,O=122,R=46,S=47,g=92,C=58,P=63;class p extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new p(o,"Object",i)}function u(i,o){if(typeof i!="string")throw new p(o,"string",i)}const b=I.$ec==="win32";function $(i){return i===S||i===g}function l(i){return i===S}function d(i){return i>=A&&i<=L||i>=j&&i<=O}function h(i,o,n,s){let t="",r=0,a=-1,v=0,y=0;for(let w=0;w<=i.length;++w){if(w<i.length)y=i.charCodeAt(w);else{if(s(y))break;y=S}if(s(y)){if(!(a===w-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const k=t.lastIndexOf(n);k===-1?(t="",r=0):(t=t.slice(0,k),r=t.length-1-t.lastIndexOf(n)),a=w,v=0;continue}else if(t.length!==0){t="",r=0,a=w,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,w)}`:t=i.slice(a+1,w),r=w-a-1;a=w,v=0}else y===R&&v!==-1?++v:v=-1}return t}function c(i,o){f(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$gc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],u(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,y="",w=!1;const k=r.charCodeAt(0);if(a===1)$(k)&&(v=1,w=!0);else if($(k))if(w=!0,$(r.charCodeAt(1))){let E=2,D=E;for(;E<a&&!$(r.charCodeAt(E));)E++;if(E<a&&E!==D){const U=r.slice(D,E);for(D=E;E<a&&$(r.charCodeAt(E));)E++;if(E<a&&E!==D){for(D=E;E<a&&!$(r.charCodeAt(E));)E++;(E===a||E!==D)&&(y=`\\\\${U}\\${r.slice(D,E)}`,v=E)}}}else v=1;else d(k)&&r.charCodeAt(1)===C&&(y=r.slice(0,2),v=2,a>2&&$(r.charCodeAt(2))&&(w=!0,v=3));if(y.length>0)if(o.length>0){if(y.toLowerCase()!==o.toLowerCase())continue}else o=y;if(s){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,s=w,w&&o.length>0)break}return n=h(n,!s,"\\",$),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){u(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return l(r)?"\\":i;if($(r))if(t=!0,$(i.charCodeAt(1))){let v=2,y=v;for(;v<o&&!$(i.charCodeAt(v));)v++;if(v<o&&v!==y){const w=i.slice(y,v);for(y=v;v<o&&$(i.charCodeAt(v));)v++;if(v<o&&v!==y){for(y=v;v<o&&!$(i.charCodeAt(v));)v++;if(v===o)return`\\\\${w}\\${i.slice(y)}\\`;v!==y&&(s=`\\\\${w}\\${i.slice(y,v)}`,n=v)}}}else n=1;else d(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&$(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?h(i.slice(n),!t,"\\",$):"";return a.length===0&&!t&&(a="."),a.length>0&&$(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){u(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return $(n)||o>2&&d(n)&&i.charCodeAt(1)===C&&$(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];u(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&$(n.charCodeAt(0))){++t;const r=n.length;r>1&&$(n.charCodeAt(1))&&(++t,r>2&&($(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&$(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$gc.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o)return"";const n=e.$gc.resolve(i),s=e.$gc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let y=o.length;for(;y-1>v&&o.charCodeAt(y-1)===g;)y--;const w=y-v,k=a<w?a:w;let E=-1,D=0;for(;D<k;D++){const F=i.charCodeAt(t+D);if(F!==o.charCodeAt(v+D))break;F===g&&(E=D)}if(D!==k){if(E===-1)return s}else{if(w>k){if(o.charCodeAt(v+D)===g)return s.slice(v+D+1);if(D===2)return s.slice(v+D)}a>k&&(i.charCodeAt(t+D)===g?E=D:D===2&&(E=3)),E===-1&&(E=0)}let U="";for(D=t+E+1;D<=r;++D)(D===r||i.charCodeAt(D)===g)&&(U+=U.length===0?"..":"\\..");return v+=E,U.length>0?`${U}${s.slice(v,y)}`:(s.charCodeAt(v)===g&&++v,s.slice(v,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$gc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==P&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){u(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return $(t)?i:".";if($(t)){if(n=s=1,$(i.charCodeAt(1))){let v=2,y=v;for(;v<o&&!$(i.charCodeAt(v));)v++;if(v<o&&v!==y){for(y=v;v<o&&$(i.charCodeAt(v));)v++;if(v<o&&v!==y){for(y=v;v<o&&!$(i.charCodeAt(v));)v++;if(v===o)return i;v!==y&&(n=s=v+1)}}}}else d(t)&&i.charCodeAt(1)===C&&(n=o>2&&$(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let v=o-1;v>=s;--v)if($(i.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=n;--r){const y=i.charCodeAt(r);if($(y)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(y===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if($(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){u(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&d(i.charCodeAt(0))&&(o=s=2);for(let v=i.length-1;v>=o;--v){const y=i.charCodeAt(v);if($(y)){if(!r){s=v+1;break}continue}t===-1&&(r=!1,t=v+1),y===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return $(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if($(t)){if(s=1,$(i.charCodeAt(1))){let E=2,D=E;for(;E<n&&!$(i.charCodeAt(E));)E++;if(E<n&&E!==D){for(D=E;E<n&&$(i.charCodeAt(E));)E++;if(E<n&&E!==D){for(D=E;E<n&&!$(i.charCodeAt(E));)E++;E===n?s=E:E!==D&&(s=E+1)}}}}else if(d(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,$(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,v=-1,y=!0,w=i.length-1,k=0;for(;w>=s;--w){if(t=i.charCodeAt(w),$(t)){if(!y){a=w+1;break}continue}v===-1&&(y=!1,v=w+1),t===R?r===-1?r=w:k!==1&&(k=1):r!==-1&&(k=-1)}return v!==-1&&(r===-1||k===0||k===1&&r===v-1&&r===a+1?o.base=o.name=i.slice(a,v):(o.name=i.slice(a,r),o.base=i.slice(a,v),o.ext=i.slice(r,v))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(b){const i=/\\/g;return()=>{const o=I.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$hc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:m();u(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===S)}return o=h(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S,n=i.charCodeAt(i.length-1)===S;return i=h(i,!o,"/",l),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return u(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];u(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$hc.normalize(o)},relative(i,o){if(u(i,"from"),u(o,"to"),i===o||(i=e.$hc.resolve(i),o=e.$hc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,v=t<a?t:a;let y=-1,w=0;for(;w<v;w++){const E=i.charCodeAt(n+w);if(E!==o.charCodeAt(r+w))break;E===S&&(y=w)}if(w===v)if(a>v){if(o.charCodeAt(r+w)===S)return o.slice(r+w+1);if(w===0)return o.slice(r+w)}else t>v&&(i.charCodeAt(n+w)===S?y=w:w===0&&(y=0));let k="";for(w=n+y+1;w<=s;++w)(w===s||i.charCodeAt(w)===S)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(r+y)}`},toNamespacedPath(i){return i},dirname(i){if(u(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===S;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===S){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&u(o,"ext"),u(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=0;--r){const y=i.charCodeAt(r);if(y===S){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(y===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===S){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){u(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const v=i.charCodeAt(a);if(v===S){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){u(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===S;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,v=!0,y=i.length-1,w=0;for(;y>=s;--y){const k=i.charCodeAt(y);if(k===S){if(!v){r=y+1;break}continue}a===-1&&(v=!1,a=y+1),k===R?t===-1?t=y:w!==1&&(w=1):t!==-1&&(w=-1)}if(a!==-1){const k=r===0&&n?1:r;t===-1||w===0||w===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(k,a):(o.name=i.slice(k,t),o.base=i.slice(k,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=b?e.$gc.normalize:e.$hc.normalize,e.$jc=b?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=b?e.$gc.join:e.$hc.join,e.$lc=b?e.$gc.resolve:e.$hc.resolve,e.$mc=b?e.$gc.relative:e.$hc.relative,e.$nc=b?e.$gc.dirname:e.$hc.dirname,e.$oc=b?e.$gc.basename:e.$hc.basename,e.$pc=b?e.$gc.extname:e.$hc.extname,e.$qc=b?e.$gc.format:e.$hc.format,e.$rc=b?e.$gc.parse:e.$hc.parse,e.$sc=b?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=b?e.$gc.sep:e.$hc.sep,e.$uc=b?e.$gc.delimiter:e.$hc.delimiter}),define(le[50],he([0,1,15,5,27,13]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=O,e.$bg=R,e.$cg=S,e.$dg=g,e.$eg=C,e.$fg=u,e.$gg=b,e.$hg=$,e.$ig=l,e.$jg=d,e.$kg=h,e.$lg=c,e.$mg=m,e.$ng=i,e.$og=o,e.$pg=t;function O(r){return r===47||r===92}function R(r){return r.replace(/[\\/]/g,I.$hc.sep)}function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}function g(r,a=I.$hc.sep){if(!r)return"";const v=r.length,y=r.charCodeAt(0);if(O(y)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let k=3;const E=k;for(;k<v&&!O(r.charCodeAt(k));k++);if(E!==k&&!O(r.charCodeAt(k+1))){for(k+=1;k<v;k++)if(O(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,a)}}return a}else if(l(y)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<v;w++)if(O(r.charCodeAt(w)))return r.slice(0,w+1)}return""}function C(r){if(!A.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const y=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(y===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}const P=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(r,a=A.$i){const v=a?P:p;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&f.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}function b(r,a,v){const y=r===a;return!v||y?y:!r||!a?!1:(0,j.$lf)(r,a)}function $(r,a,v,y=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,j.$mf)(r,a))return!1;if(a.length===r.length)return!0;let k=a.length;return a.charAt(a.length-1)===y&&k--,r.charAt(k)===y}return a.charAt(a.length-1)!==y&&(a+=y),r.indexOf(a)===0}function l(r){return r>=65&&r<=90||r>=97&&r<=122}function d(r,a){return A.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$jc)(r)||(r=(0,I.$kc)(a,r)),r=(0,I.$ic)(r),A.$i?(r=(0,j.$6e)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,j.$6e)(r,I.sep),r||(r=I.sep)),r}function h(r){const a=(0,I.$ic)(r);return A.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$hc.sep}function c(r,a=A.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}function m(r,a=A.$i){return c(r,a)?r[0]:void 0}function i(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}function o(r){const a=r.split(":");let v,y,w;for(const k of a){const E=Number(k);(0,L.$Yf)(E)?y===void 0?y=E:w===void 0&&(w=E):v=v?[v,k].join(":"):k}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:y!==void 0?y:void 0,column:w!==void 0?w:y!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let y="";for(let k=0;k<v;k++){let E;k===0&&A.$i&&!a&&(v===3||v===4)?E=s:E=n,y+=E.charAt(Math.floor(Math.random()*E.length))}let w;return a?w=`${a}-${y}`:w=y,r?(0,I.$kc)(r,w):w}}),define(le[141],he([0,1,15]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0,e.$ys=L,e.$zs=O,e.$As=R,e.$Bs=g,e.$xs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(C){const P=(0,I.$pc)(C),p=A[P.toLowerCase()];return p!==void 0?p:O(C)}function O(C){const P=(0,I.$pc)(C);return j[P.toLowerCase()]}function R(C){for(const P in j)if(j[P]===C)return P}const S=/^(.+)\/(.+?)(;.+)?$/;function g(C,P){const p=S.exec(C);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:P?void 0:C}}),define(le[89],he([0,1,5]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=L,e.$$l=O;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A||(e.Source=A={}));var j;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function L(R,...S){const g=S.reduce((p,f)=>(p[f]=!0,p),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(p=>!g[p]).forEach(p=>{for(let f=0;f<C.length;f++)if(p.search(C[f])!==-1){delete R[p];break}})}function O(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}}),define(le[8],he([0,1,15,5]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=u,e.$xc=c;const j=/^\w[\w\d+.-]*$/,L=/^\//,O=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!j.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==P&&(t=P+t):t=P;break}return t}const C="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,y,w=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=S(t,w),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=y||C,R(this,w))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:y,fragment:w}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),y===void 0?y=this.query:y===null&&(y=C),w===void 0?w=this.fragment:w===null&&(w=C),r===this.scheme&&a===this.authority&&v===this.path&&y===this.query&&w===this.fragment?this:new $(r,a,v,y,w)}static parse(t,r=!1){const a=p.exec(t);return a?new $(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new $(C,C,C,C,C)}static file(t){let r=C;if(A.$i&&(t=t.replace(/\\/g,P)),t[0]===P&&t[1]===P){const a=t.indexOf(P,2);a===-1?(r=t.substring(2),t=P):(r=t.substring(2,a),t=t.substring(a)||P)}return new $("file",r,t,C,C)}static from(t,r){return new $(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.$i&&t.scheme==="file"?a=f.file(I.$gc.join(c(t,!0),...r)).path:a=I.$hc.join(t.path,...r),t.with({path:a})}toString(t=!1){return m(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const r=new $(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=f;function u(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const b=A.$i?1:void 0;class $ extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(s,t,r){let a,v=-1;for(let y=0;y<s.length;y++){const w=s.charCodeAt(y);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||t&&w===47||r&&w===91||r&&w===93||r&&w===58)v!==-1&&(a+=encodeURIComponent(s.substring(v,y)),v=-1),a!==void 0&&(a+=s.charAt(y));else{a===void 0&&(a=s.substr(0,y));const k=l[w];k!==void 0?(v!==-1&&(a+=encodeURIComponent(s.substring(v,y)),v=-1),a+=k):v===-1&&(v=y)}}return v!==-1&&(a+=encodeURIComponent(s.substring(v))),a!==void 0?a:s}function h(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=l[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.$i&&(r=r.replace(/\//g,"\\")),r}function m(s,t){const r=t?h:d;let a="",{scheme:v,authority:y,path:w,query:k,fragment:E}=s;if(v&&(a+=v,a+=":"),(y||v==="file")&&(a+=P,a+=P),y){let D=y.indexOf("@");if(D!==-1){const U=y.substr(0,D);y=y.substr(D+1),D=U.lastIndexOf(":"),D===-1?a+=r(U,!1,!1):(a+=r(U.substr(0,D),!1,!1),a+=":",a+=r(U.substr(D+1),!1,!0)),a+="@"}y=y.toLowerCase(),D=y.lastIndexOf(":"),D===-1?a+=r(y,!1,!0):(a+=r(y.substr(0,D),!1,!0),a+=y.substr(D))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const D=w.charCodeAt(1);D>=65&&D<=90&&(w=`/${String.fromCharCode(D+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const D=w.charCodeAt(0);D>=65&&D<=90&&(w=`${String.fromCharCode(D+32)}:${w.substr(2)}`)}a+=r(w,!0,!1)}return k&&(a+="?",a+=r(k,!1,!1)),E&&(a+="#",a+=t?E:d(E,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[142],he([0,1,8]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=A,e.$Eq=j,e.$Fq=L,e.log=R;function A(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function j(g){const C=[];let P;try{const p=JSON.parse(g.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),P=f.__$stack),C.push(...p)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:P}}function L(g){if(typeof g!="string")return L(j(g).stack);const C=g;if(C){const P=O(C),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:I.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function O(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:P,stack:p}=j(g),f=typeof P[0]=="string"&&P.length===1;let u=O(p);u&&(u=`(${u.trim()})`);let b=[];if(typeof P[0]=="string"?u&&f?b=[`%c[${C}] %c${P[0]} %c${u}`,S("blue"),S(""),S("grey")]:b=[`%c[${C}] %c${P[0]}`,S("blue"),S(""),...P.slice(1)]:b=[`%c[${C}]%`,S("blue"),...P],u&&!f&&b.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}function S(g){return`color: ${g}`}}),define(le[66],he([0,1,14,8]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=j,e.$Ph=L,e.$Qh=R;function j(S){return JSON.stringify(S,O)}function L(S){let g=JSON.parse(S);return g=R(g),g}function O(S,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(S,g=0){if(!S||g>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return A.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 17:return new Date(S.source)}if(S instanceof I.$ue||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=R(S[C],g+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=R(S[C],g+1))}return S}}),define(le[23],he([0,1,7,5,27,8,15]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=S,e.$rg=g,e.$vg=P;var R;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.codeSetting="code-setting"})(R||(e.Schemas=R={}));function S(u,b){return L.URI.isUri(u)?(0,j.$lf)(u.scheme,b):(0,j.$mf)(u,b+":")}function g(u,...b){return b.some($=>S(u,$))}e.$sg="vscode-tkn",e.$tg="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,$){this.f=P(b,$)}getServerRootPath(){return this.f}get g(){return O.$hc.join(this.f,R.vscodeRemoteResource)}set(b,$,l){this.a[b]=$,this.b[b]=l}setConnectionToken(b,$){this.c[b]=$}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(m){return I.$1(m),b}const $=b.authority;let l=this.a[$];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const d=this.b[$],h=this.c[$];let c=`path=${encodeURIComponent(b.path)}`;return typeof h=="string"&&(c+=`&${e.$tg}=${encodeURIComponent(h)}`),L.URI.from({scheme:A.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${d}`,path:this.g,query:c})}}e.$ug=new C;function P(u,b){return O.$hc.join(b??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class p{static{this.a=e.$Ag}asBrowserUri(b){const $=this.b(b,se);return this.uriToBrowserUri($)}uriToBrowserUri(b){return b.scheme===R.vscodeRemote?e.$ug.rewrite(b):b.scheme===R.file&&(A.$m||A.$q===`${R.vscodeFileResource}://${p.a}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||p.a,query:null,fragment:null}):b}asFileUri(b){const $=this.b(b,se);return this.uriToFileUri($)}uriToFileUri(b){return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==p.a?b.authority:null,query:null,fragment:null}):b}b(b,$){return L.URI.isUri(b)?b:L.URI.parse($.toUrl(b))}}e.$Bg=new p;var f;(function(u){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(b.get("3"));const $="vscode-coi";function l(h){let c;typeof h=="string"?c=new URL(h).searchParams:h instanceof URL?c=h.searchParams:L.URI.isUri(h)&&(c=new URL(h.toString(!0)).searchParams);const m=c?.get($);if(m)return b.get(m)}u.getHeadersFromQuery=l;function d(h,c,m){if(!globalThis.crossOriginIsolated)return;const i=c&&m?"3":m?"2":"1";h instanceof URLSearchParams?h.set($,i):h[$]=i}u.addSearchParam=d})(f||(e.COI=f={}))}),define(le[143],he([0,1,124,23,5,8]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CD=C;class O{constructor(p,f,u){this.id=p,this.dependencies=f,this.callback=u}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,f,u)=>{typeof p!="string"&&(u=f,f=p,p=null),(typeof f!="object"||!Array.isArray(f))&&(u=f,f=null),this.c.push(new O(p,f,u))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const f=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!f)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(p){return new Promise((f,u)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const $=()=>{b.removeEventListener("load",l),b.removeEventListener("error",d)},l=h=>{$(),f(this.c.pop())},d=h=>{$(),u(h)};b.addEventListener("load",l),b.addEventListener("error",d),this.f&&(p=this.f.createScriptURL(p)),b.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(p){return new Promise((f,u)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),f(this.c.pop())}catch(b){u(b)}})}async j(p){try{const f=globalThis._VSCODE_NODE_MODULES.fs,u=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,$=L.URI.parse(p).fsPath,l=f.readFileSync($).toString(),d=b.wrap(l.replace(/^#!.*/,""));return new u.Script(d).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const S=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(P,p,f){if(I.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[P]&&(P=g[P]);const u=`${P}/${p}`;if(S.has(u))return S.get(u);let b;if(/^\w[\w\d+.-]*:\/\//.test(u))b=u;else{const h=`${f&&!j.$o?A.$yg:A.$xg}/${u}`;b=A.$Bg.asBrowserUri(h).toString(!0)}const $=R.INSTANCE.load(b);return S.set(u,$),$}else return await new Promise((u,b)=>{se([P],u,b)})}}),define(le[20],he([0,1,50,23,15,5,27,8]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=S,e.$4g=C,e.$5g=p;function S(f){return(0,R.$xc)(f,!0)}class g{constructor(u){this.a=u}compare(u,b,$=!1){return u===b?0:(0,O.$ef)(this.getComparisonKey(u,$),this.getComparisonKey(b,$))}isEqual(u,b,$=!1){return u===b?!0:!u||!b?!1:this.getComparisonKey(u,$)===this.getComparisonKey(b,$)}getComparisonKey(u,b=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,b,$=!1){if(u.scheme===b.scheme){if(u.scheme===A.Schemas.file)return I.$hg(S(u),S(b),this.a(u))&&u.query===b.query&&($||u.fragment===b.fragment);if((0,e.$Zg)(u.authority,b.authority))return I.$hg(u.path,b.path,this.a(u),"/")&&u.query===b.query&&($||u.fragment===b.fragment)}return!1}joinPath(u,...b){return R.URI.joinPath(u,...b)}basenameOrAuthority(u){return(0,e.$Rg)(u)||u.authority}basename(u){return j.$hc.basename(u.path)}extname(u){return j.$hc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let b;return u.scheme===A.Schemas.file?b=R.URI.file(j.$nc(S(u))).path:(b=j.$hc.dirname(u.path),u.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),b="/")),u.with({path:b})}normalizePath(u){if(!u.path.length)return u;let b;return u.scheme===A.Schemas.file?b=R.URI.file(j.$ic(S(u))).path:b=j.$hc.normalize(u.path),u.with({path:b})}relativePath(u,b){if(u.scheme!==b.scheme||!(0,e.$Zg)(u.authority,b.authority))return;if(u.scheme===A.Schemas.file){const d=j.$mc(S(u),S(b));return L.$i?I.$bg(d):d}let $=u.path||"/";const l=b.path||"/";if(this.a(u)){let d=0;for(const h=Math.min($.length,l.length);d<h&&!($.charCodeAt(d)!==l.charCodeAt(d)&&$.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);$=l.substr(0,d)+$.substr(d)}return j.$hc.relative($,l)}resolvePath(u,b){if(u.scheme===A.Schemas.file){const $=R.URI.file(j.$lc(S(u),b));return u.with({authority:$.authority,path:$.path})}return b=I.$cg(b),u.with({path:j.$hc.resolve(u.path,b)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,b){return u===b||u!==void 0&&b!==void 0&&(0,O.$lf)(u,b)}hasTrailingPathSeparator(u,b=j.sep){if(u.scheme===A.Schemas.file){const $=S(u);return $.length>I.$dg($).length&&$[$.length-1]===b}else{const $=u.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,b=j.sep){return(0,e.$1g)(u,b)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,b=j.sep){let $=!1;if(u.scheme===A.Schemas.file){const l=S(u);$=l!==void 0&&l.length===I.$dg(l).length&&l[l.length-1]===b}else{b="/";const l=u.path;$=l.length===1&&l.charCodeAt(l.length-1)===47}return!$&&!(0,e.$1g)(u,b)?u.with({path:u.path+"/"}):u}}e.$Jg=g,e.$Kg=new g(()=>!1),e.$Lg=new g(f=>f.scheme===A.Schemas.file?!L.$k:!0),e.$Mg=new g(f=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function C(f,u){const b=[];for(let $=0;$<f.length;$++){const l=u(f[$]);f.some((d,h)=>h===$?!1:(0,e.$Og)(l,u(d)))||b.push(f[$])}return b}var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function u(b){const $=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(h=>{const[c,m]=h.split(":");c&&m&&$.set(c,m)});const d=b.path.substring(0,b.path.indexOf(";"));return d&&$.set(f.META_DATA_MIME,d),$}f.parseMetaData=u})(P||(e.DataUri=P={}));function p(f,u,b){if(u){let $=f.path;return $&&$[0]!==j.$hc.sep&&($=j.$hc.sep+$),f.with({scheme:b,authority:u,path:$})}return f.with({scheme:b})}}),define(le[6],he([0,1,26,7,3,2,20,5,130,53]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=C,e.$7g=P,e.$8g=p,e.$9g=f,e.$0g=u,e.$$g=b,e.$_g=$,e.$ah=l,e.$ih=r,e.$jh=a,e.$kh=v,e.$lh=y,e.$mh=w,e.$Bh=B,e.$Jh=J;function C(Y){return!!Y&&typeof Y.then=="function"}function P(Y){const V=new I.$ee,ie=Y(V.token),re=new Promise((ue,de)=>{const me=V.token.onCancellationRequested(()=>{me.dispose(),de(new A.$5)});Promise.resolve(ie).then(Ee=>{me.dispose(),V.dispose(),ue(Ee)},Ee=>{me.dispose(),V.dispose(),de(Ee)})});return new class{cancel(){V.cancel(),V.dispose()}then(ue,de){return re.then(ue,de)}catch(ue){return this.then(void 0,ue)}finally(ue){return re.finally(ue)}}}function p(Y,V,ie){return new Promise((re,ue)=>{const de=V.onCancellationRequested(()=>{de.dispose(),re(ie)});Y.then(re,ue).finally(()=>de.dispose())})}function f(Y,V){return new Promise((ie,re)=>{const ue=V.onCancellationRequested(()=>{ue.dispose(),re(new A.$5)});Y.then(ie,re).finally(()=>ue.dispose())})}async function u(Y){let V=-1;const ie=Y.map((re,ue)=>re.then(de=>(V=ue,de)));try{return await Promise.race(ie)}finally{Y.forEach((re,ue)=>{ue!==V&&re.cancel()})}}function b(Y,V,ie){let re;const ue=setTimeout(()=>{re?.(void 0),ie?.()},V);return Promise.race([Y.finally(()=>clearTimeout(ue)),new Promise(de=>re=de)])}function $(Y){return new Promise((V,ie)=>{const re=Y();C(re)?re.then(V,ie):V(re)})}function l(){let Y,V;return{promise:new Promise((re,ue)=>{Y=re,V=ue}),resolve:Y,reject:V}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const ie=()=>{if(this.b=null,this.f)return;const re=this.queue(this.d);return this.d=null,re};this.b=new Promise(re=>{this.a.then(ie,ie).then(re)})}return new Promise((ie,re)=>{this.b.then(ie,re)})}return this.a=V(),new Promise((ie,re)=>{this.a.then(ue=>{this.a=null,ie(ue)},ue=>{this.a=null,re(ue)})})}dispose(){this.f=!0}}e.$bh=d;class h{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$ch=h;class c{constructor(){this.a=new Map}queue(V,ie){const ue=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(V)===ue&&this.a.delete(V)});return this.a.set(V,ue),ue}}e.$dh=c;const m=(Y,V)=>{let ie=!0;const re=setTimeout(()=>{ie=!1,V()},Y);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(re),ie=!1}}},i=Y=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,Y())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class o{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,ie=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((ue,de)=>{this.d=ue,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const re=()=>{this.a=null,this.d?.(null)};return this.a=ie===S.$4d?i(re):m(ie,re),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=o;class n{constructor(V){this.a=new o(V),this.b=new d}trigger(V,ie){return this.a.trigger(()=>this.b.queue(V),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=n;class s{constructor(){this.a=!1,this.b=new Promise((V,ie)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=s;class t extends s{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$hh=t;function r(Y,V){return V?new Promise((ie,re)=>{const ue=setTimeout(()=>{de.dispose(),ie()},Y),de=V.onCancellationRequested(()=>{clearTimeout(ue),de.dispose(),re(new A.$5)})}):P(ie=>r(Y,ie))}function a(Y,V=0,ie){const re=setTimeout(()=>{Y(),ie&&ue.dispose()},V),ue=(0,L.$Sc)(()=>{clearTimeout(re),ie?.deleteAndLeak(ue)});return ie?.add(ue),ue}function v(Y){const V=[];let ie=0;const re=Y.length;function ue(){return ie<re?Y[ie++]():null}function de(me){me!=null&&V.push(me);const Ee=ue();return Ee?Ee.then(de):Promise.resolve(V)}return Promise.resolve(null).then(de)}function y(Y,V=re=>!!re,ie=null){let re=0;const ue=Y.length,de=()=>{if(re>=ue)return Promise.resolve(ie);const me=Y[re++];return Promise.resolve(me()).then(ke=>V(ke)?Promise.resolve(ke):de())};return de()}function w(Y,V=re=>!!re,ie=null){if(Y.length===0)return Promise.resolve(ie);let re=Y.length;const ue=()=>{re=-1;for(const de of Y)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of Y)Ee.then(ke=>{--re>=0&&V(ke)?(ue(),de(ke)):re===0&&de(ie)}).catch(ke=>{--re>=0&&(ue(),me(ke))})})}class k{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new j.$7d}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ie,re)=>{this.g.push({factory:V,c:ie,e:re}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const ie=V.factory();ie.then(V.c,V.e),ie.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=k;class E extends k{constructor(){super(1)}}e.$oh=E;class D{constructor(){this.a=new ne,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$ph=D;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new ce;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,ie=O.$Kg){const re=ie.getComparisonKey(V);return this.a.get(re)?.size??0}queueFor(V,ie,re=O.$Kg){const ue=re.getComparisonKey(V);let de=this.a.get(ue);if(!de){de=new E;const me=this.f++,Ee=j.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$4c),this.d.set(me,Ee),this.a.set(ue,de)}return de.queue(ie)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=U;class F{constructor(V,ie){this.a=-1,typeof V=="function"&&typeof ie=="number"&&this.setIfNotSet(V,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},ie)}setIfNotSet(V,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},ie))}}e.$rh=F;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,ie,re=globalThis){this.cancel();const ue=re.setInterval(()=>{V()},ie);this.d=(0,L.$Sc)(()=>{re.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$sh=T;class _{constructor(V,ie){this.b=-1,this.a=V,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=_;class X{constructor(V,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=V,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=X;class ee extends _{constructor(V,ie){super(V,ie),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$vh=ee;class H extends L.$Uc{constructor(V,ie){super(),this.g=V,this.h=ie,this.a=[],this.b=this.B(new L.$Vc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of V)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(Y,V)=>{(0,R.$B)(()=>{if(ie)return;const re=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,re-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$yh=(Y,V,ie)=>{const re=Y.requestIdleCallback(V,typeof ie=="number"?{timeout:ie}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,Y.cancelIdleCallback(re))}}},e.$xh=Y=>(0,e.$yh)(globalThis,Y)}();class K{constructor(V,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(re){this.l=re}finally{this.g=!0}},this.f=(0,e.$yh)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=K;class W extends K{constructor(V){super(globalThis,V)}}e.$Ah=W;async function B(Y,V,ie){let re;for(let ue=0;ue<ie;ue++)try{return await Y()}catch(de){re=de,await r(V)}throw re}class ne{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,ie,re){return this.a={taskId:V,cancel:()=>re?.(),promise:ie},ie.then(()=>this.d(V),()=>this.d(V)),ie}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:ie,resolve:re,reject:ue}=l();this.b={run:V,promise:ie,promiseResolve:re,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=ne;class oe{constructor(V,ie=()=>Date.now()){this.d=V,this.f=ie,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$Dh=oe;var te;(function(Y){Y[Y.Resolved=0]="Resolved",Y[Y.Rejected=1]="Rejected"})(te||(te={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,ie)=>{this.a=V,this.b=ie})}complete(V){return new Promise(ie=>{this.a(V),this.d={outcome:0,value:V},ie()})}error(V){return new Promise(ie=>{this.b(V),this.d={outcome:1,value:V},ie()})}cancel(){return this.error(new A.$5)}}e.$Eh=ce;var G;(function(Y){async function V(re){let ue;const de=await Promise.all(re.map(me=>me.then(Ee=>Ee,Ee=>{ue||(ue=Ee)})));if(typeof ue<"u")throw ue;return de}Y.settled=V;function ie(re){return new Promise(async(ue,de)=>{try{await re(ue,de)}catch(me){de(me)}})}Y.withAsyncBody=ie})(G||(e.Promises=G={}));class q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=q;class N{constructor(V){this.b=V,this.a=new g.$V(()=>new q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=N;var M;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(M||(M={}));class z{static fromArray(V){return new z(ie=>{ie.emitMany(V)})}static fromPromise(V){return new z(async ie=>{ie.emitMany(await V)})}static fromPromises(V){return new z(async ie=>{await Promise.all(V.map(async re=>ie.emitOne(await re)))})}static merge(V){return new z(async ie=>{await Promise.all(V.map(async re=>{for await(const ue of re)ie.emitOne(ue)}))})}static{this.EMPTY=z.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new j.$7d,queueMicrotask(async()=>{const ie={emitOne:re=>this.g(re),emitMany:re=>this.h(re),reject:re=>this.k(re)};try{await Promise.resolve(V(ie)),this.j()}catch(re){this.k(re)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(V,ie){return new z(async re=>{for await(const ue of V)re.emitOne(ie(ue))})}map(V){return z.map(this,V)}static filter(V,ie){return new z(async re=>{for await(const ue of V)ie(ue)&&re.emitOne(ue)})}filter(V){return z.filter(this,V)}static coalesce(V){return z.filter(V,ie=>!!ie)}coalesce(){return z.coalesce(this)}static async toPromise(V){const ie=[];for await(const re of V)ie.push(re);return ie}toPromise(){return z.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$Hh=z;class Z extends z{constructor(V,ie){super(ie),this.l=V}cancel(){this.l.cancel()}}e.$Ih=Z;function J(Y){const V=new I.$ee,ie=Y(V.token);return new Z(V,async re=>{const ue=V.token.onCancellationRequested(()=>{ue.dispose(),V.dispose(),re.reject(new A.$5)});try{for await(const de of ie){if(V.token.isCancellationRequested)return;re.emitOne(de)}ue.dispose(),V.dispose()}catch(de){ue.dispose(),V.dispose(),re.reject(de)}})}class x{constructor(){this.a=new ce,this.b=new z(re=>{if(V){re.reject(V);return}return ie&&re.emitMany(ie),this.d=ue=>re.reject(ue),this.f=ue=>re.emitOne(ue),this.a.p});let V,ie;this.f=re=>{ie||(ie=[]),ie.push(re)},this.d=re=>{V||(V=re)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$Kh=x}),define(le[90],he([0,1,17,6,50,35,15,5,27]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=g,e.$_j=u,e.$ak=E,e.$bk=D,e.$ck=U,e.$dk=F,e.$ek=T,e.$fk=H;function g(){return Object.create(null)}e.$0j="**",e.$$j="/";const C="[/\\\\]",P="[^/\\\\]",p=/\//g;function f(K,W){switch(K){case 0:return"";case 1:return`${P}*?`;default:return`(?:${C}|${P}+${C}${W?`|${C}${P}+`:""})*?`}}function u(K,W){if(!K)return[];const B=[];let ne=!1,oe=!1,te="";for(const ce of K){switch(ce){case W:if(!ne&&!oe){B.push(te),te="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}te+=ce}return te&&B.push(te),B}function b(K){if(!K)return"";let W="";const B=u(K,e.$$j);if(B.every(ne=>ne===e.$0j))W=".*";else{let ne=!1;B.forEach((oe,te)=>{if(oe===e.$0j){if(ne)return;W+=f(2,te===B.length-1)}else{let ce=!1,G="",q=!1,N="";for(const M of oe){if(M!=="}"&&ce){G+=M;continue}if(q&&(M!=="]"||!N)){let z;M==="-"?z=M:(M==="^"||M==="!")&&!N?z="^":M===e.$$j?z="":z=(0,S.$Ze)(M),N+=z;continue}switch(M){case"{":ce=!0;continue;case"[":q=!0;continue;case"}":{const Z=`(?:${u(G,",").map(J=>b(J)).join("|")})`;W+=Z,ce=!1,G="";break}case"]":{W+="["+N+"]",q=!1,N="";break}case"?":W+=P;continue;case"*":W+=f(1);continue;default:W+=(0,S.$Ze)(M)}}te<B.length-1&&(B[te+1]!==e.$0j||te+2<B.length)&&(W+=C)}ne=oe===e.$0j})}return W}const $=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Ec(1e4),o=function(){return!1},n=function(){return null};function s(K,W){if(!K)return n;let B;typeof K!="string"?B=K.pattern:B=K,B=B.trim();const ne=`${B}_${!!W.trimForExclusions}`;let oe=i.get(ne);if(oe)return t(oe,K);let te;return $.test(B)?oe=a(B.substr(4),B):(te=l.exec(r(B,W)))?oe=v(te[1],B):(W.trimForExclusions?h:d).test(B)?oe=y(B,W):(te=c.exec(r(B,W)))?oe=w(te[1].substr(1),B,!0):(te=m.exec(r(B,W)))?oe=w(te[1],B,!1):oe=k(B),i.set(ne,oe),t(oe,K)}function t(K,W){if(typeof W=="string")return K;const B=function(ne,oe){return(0,j.$hg)(ne,W.base,!R.$k)?K((0,S.$5e)(ne.substr(W.base.length),O.sep),oe):null};return B.allBasenames=K.allBasenames,B.allPaths=K.allPaths,B.basenames=K.basenames,B.patterns=K.patterns,B}function r(K,W){return W.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,W){return function(B,ne){return typeof B=="string"&&B.endsWith(K)?W:null}}function v(K,W){const B=`/${K}`,ne=`\\${K}`,oe=function(ce,G){return typeof ce!="string"?null:G?G===K?W:null:ce===K||ce.endsWith(B)||ce.endsWith(ne)?W:null},te=[K];return oe.basenames=te,oe.patterns=[W],oe.allBasenames=te,oe}function y(K,W){const B=ee(K.slice(1,-1).split(",").map(G=>s(G,W)).filter(G=>G!==n),K),ne=B.length;if(!ne)return n;if(ne===1)return B[0];const oe=function(G,q){for(let N=0,M=B.length;N<M;N++)if(B[N](G,q))return K;return null},te=B.find(G=>!!G.allBasenames);te&&(oe.allBasenames=te.allBasenames);const ce=B.reduce((G,q)=>q.allPaths?G.concat(q.allPaths):G,[]);return ce.length&&(oe.allPaths=ce),oe}function w(K,W,B){const ne=O.sep===O.$hc.sep,oe=ne?K:K.replace(p,O.sep),te=O.sep+oe,ce=O.$hc.sep+K;let G;return B?G=function(q,N){return typeof q=="string"&&(q===oe||q.endsWith(te)||!ne&&(q===K||q.endsWith(ce)))?W:null}:G=function(q,N){return typeof q=="string"&&(q===oe||!ne&&q===K)?W:null},G.allPaths=[(B?"*/":"./")+K],G}function k(K){try{const W=new RegExp(`^${b(K)}$`);return function(B){return W.lastIndex=0,typeof B=="string"&&W.test(B)?K:null}}catch{return n}}function E(K,W,B){return!K||typeof W!="string"?!1:D(K)(W,void 0,B)}function D(K,W={}){if(!K)return o;if(typeof K=="string"||U(K)){const B=s(K,W);if(B===n)return o;const ne=function(oe,te){return!!B(oe,te)};return B.allBasenames&&(ne.allBasenames=B.allBasenames),B.allPaths&&(ne.allPaths=B.allPaths),ne}return _(K,W)}function U(K){const W=K;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function F(K){return K.allBasenames||[]}function T(K){return K.allPaths||[]}function _(K,W){const B=ee(Object.getOwnPropertyNames(K).map(G=>X(G,K[G],W)).filter(G=>G!==n)),ne=B.length;if(!ne)return n;if(!B.some(G=>!!G.requiresSiblings)){if(ne===1)return B[0];const G=function(M,z){let Z;for(let J=0,x=B.length;J<x;J++){const Y=B[J](M,z);if(typeof Y=="string")return Y;(0,A.$6g)(Y)&&(Z||(Z=[]),Z.push(Y))}return Z?(async()=>{for(const J of Z){const x=await J;if(typeof x=="string")return x}return null})():null},q=B.find(M=>!!M.allBasenames);q&&(G.allBasenames=q.allBasenames);const N=B.reduce((M,z)=>z.allPaths?M.concat(z.allPaths):M,[]);return N.length&&(G.allPaths=N),G}const oe=function(G,q,N){let M,z;for(let Z=0,J=B.length;Z<J;Z++){const x=B[Z];x.requiresSiblings&&N&&(q||(q=(0,O.$oc)(G)),M||(M=q.substr(0,q.length-(0,O.$pc)(G).length)));const Y=x(G,q,M,N);if(typeof Y=="string")return Y;(0,A.$6g)(Y)&&(z||(z=[]),z.push(Y))}return z?(async()=>{for(const Z of z){const J=await Z;if(typeof J=="string")return J}return null})():null},te=B.find(G=>!!G.allBasenames);te&&(oe.allBasenames=te.allBasenames);const ce=B.reduce((G,q)=>q.allPaths?G.concat(q.allPaths):G,[]);return ce.length&&(oe.allPaths=ce),oe}function X(K,W,B){if(W===!1)return n;const ne=s(K,B);if(ne===n)return n;if(typeof W=="boolean")return ne;if(W){const oe=W.when;if(typeof oe=="string"){const te=(ce,G,q,N)=>{if(!N||!ne(ce,G))return null;const M=oe.replace("$(basename)",()=>q),z=N(M);return(0,A.$6g)(z)?z.then(Z=>Z?K:null):z?K:null};return te.requiresSiblings=!0,te}}return ne}function ee(K,W){const B=K.filter(G=>!!G.basenames);if(B.length<2)return K;const ne=B.reduce((G,q)=>{const N=q.basenames;return N?G.concat(N):G},[]);let oe;if(W){oe=[];for(let G=0,q=ne.length;G<q;G++)oe.push(W)}else oe=B.reduce((G,q)=>{const N=q.patterns;return N?G.concat(N):G},[]);const te=function(G,q){if(typeof G!="string")return null;if(!q){let M;for(M=G.length;M>0;M--){const z=G.charCodeAt(M-1);if(z===47||z===92)break}q=G.substr(M)}const N=ne.indexOf(q);return N!==-1?oe[N]:null};te.basenames=ne,te.patterns=oe,te.allBasenames=ne;const ce=K.filter(G=>!G.basenames);return ce.push(te),ce}function H(K,W){return(0,I.$ub)(K,W,(B,ne)=>typeof B=="string"&&typeof ne=="string"?B===ne:typeof B!="string"&&typeof ne!="string"?B.base===ne.base&&B.pattern===ne.pattern:!1)}}),define(le[91],he([0,1,14,8]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=R,e.$mn=g,e.$nn=C;function j(P){return P.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const f=this.a.transformIncoming(p);return f===p?p:j(A.URI.from(f))}transformOutgoing(p){const f=this.a.transformOutgoing(p);return f===p?p:j(A.URI.from(f))}transformOutgoingURI(p){const f=this.a.transformOutgoing(p);return f===p?p:A.URI.from(f)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$jn=L,e.$kn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function O(P,p,f){if(!P||f>200)return null;if(typeof P=="object"){if(P instanceof A.URI)return p.transformOutgoing(P);for(const u in P)if(Object.hasOwnProperty.call(P,u)){const b=O(P[u],p,f+1);b!==null&&(P[u]=b)}}return null}function R(P,p){const f=O(P,p,0);return f===null?P:f}function S(P,p,f,u){if(!P||u>200)return null;if(typeof P=="object"){if(P.$mid===1)return f?A.URI.revive(p.transformIncoming(P)):p.transformIncoming(P);if(P instanceof I.$ue)return null;for(const b in P)if(Object.hasOwnProperty.call(P,b)){const $=S(P[b],p,f,u+1);$!==null&&(P[b]=$)}}return null}function g(P,p){const f=S(P,p,!1,0);return f===null?P:f}function C(P,p){const f=S(P,p,!0,0);return f===null?P:f}}),define(le[144],he([0,1,37,49,32,131,5]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=void 0,e.$qn=S,e.$rn=P,e.$pn=new class{c(p){return this.a||(this.a=A.$ni.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,f=0;const u=(0,I.networkInterfaces)();for(const b in u){const $=u[b];if($)for(const{mac:l,internal:d}of $)d||(f+=1,this.c(l.toUpperCase())&&(p+=1))}this.b=f>0?p/f:0}return this.b}};let R;async function S(p){return R||(R=(async()=>await g(p)||j.$Dg())()),R}async function g(p){try{const f=await new Promise((b,$)=>{se(["crypto"],b,$)}),u=(0,L.$on)();return f.createHash("sha256").update(u,"utf8").digest("hex")}catch(f){p(f);return}}const C="Software\\Microsoft\\SQMClient";async function P(p){if(O.$i){const f=await new Promise((u,b)=>{se(["@vscode/windows-registry"],u,b)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(u){return p(u),""}}return""}}),define(le[145],he([0,1,43,272,273,5]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=O;async function O(R){if(L.$j||L.$i)return;let S;for(const g of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{S=await(0,A.open)(g,I.constants.R_OK);break}catch{}if(!S){R("Unable to retrieve release information from known identifier paths.");return}try{const g=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const P of(0,j.createInterface)({input:S.createReadStream(),crlfDelay:1/0})){if(!P.includes("="))continue;const p=P.split("=")[0].toUpperCase().trim();if(g.has(p)){const f=P.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?C.id=f:p==="ID_LIKE"?C.id_like=f:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(C.version_id=f)}}return C}catch(g){R(g)}}}),define(le[31],he([0,1,43,37,274,6,50,87,15,5,20,8]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=h,e.whenDeleted=i,e.configureFlushOnWrite=r,e.writeFileSync=v;var p;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function f(X,ee=p.UNLINK,H){if((0,O.$kg)(X))throw new Error("rimraf - will refuse to recursively delete root");return ee===p.UNLINK?b(X):u(X,H)}async function u(X,ee=(0,O.$pg)((0,A.tmpdir)())){try{try{await I.promises.rename(X,ee)}catch(H){return H.code==="ENOENT"?void 0:b(X)}b(ee).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function b(X){return(0,j.promisify)(I.rm)(X,{recursive:!0,force:!0,maxRetries:3})}function $(X){if((0,O.$kg)(X))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}async function l(X,ee){return c(await(ee?d(X):(0,j.promisify)(I.readdir)(X)))}async function d(X){try{return await(0,j.promisify)(I.readdir)(X,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ee=[],H=await l(X);for(const K of H){let W=!1,B=!1,ne=!1;try{const oe=await e.Promises.lstat((0,S.$kc)(X,K));W=oe.isFile(),B=oe.isDirectory(),ne=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}ee.push({name:K,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>ne})}return ee}function h(X){return c(I.readdirSync(X))}function c(X){return X.map(ee=>typeof ee=="string"?g.$j?(0,R.$Yl)(ee):ee:(ee.name=g.$j?(0,R.$Yl)(ee.name):ee.name,ee))}async function m(X){const ee=await l(X),H=[];for(const K of ee)await o.existsDirectory((0,S.$kc)(X,K))&&H.push(K);return H}function i(X,ee=1e3){return new Promise(H=>{let K=!1;const W=setInterval(()=>{K||(K=!0,I.access(X,B=>{K=!1,B&&(clearInterval(W),H(void 0))}))},ee)})}var o;(function(X){async function ee(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ne){if(ne.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(g.$i&&ne.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw oe}throw ne}}X.stat=ee;async function H(W){try{const{stat:B,symbolicLink:ne}=await X.stat(W);return B.isFile()&&ne?.dangling!==!0}catch{}return!1}X.existsFile=H;async function K(W){try{const{stat:B,symbolicLink:ne}=await X.stat(W);return B.isDirectory()&&ne?.dangling!==!0}catch{}return!1}X.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const n=new L.$qh;function s(X,ee,H){return n.queueFor(P.URI.file(X),()=>{const K=y(H);return new Promise((W,B)=>a(X,ee,K,ne=>ne?B(ne):W()))},C.$Lg)}let t=!0;function r(X){t=X}function a(X,ee,H,K){if(!t)return I.writeFile(X,ee,{mode:H.mode,flag:H.flag},K);I.open(X,H.flag,H.mode,(W,B)=>{if(W)return K(W);I.writeFile(B,ee,ne=>{if(ne)return I.close(B,()=>K(ne));I.fdatasync(B,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),I.close(B,te=>K(te))))})})}function v(X,ee,H){const K=y(H);if(!t)return I.writeFileSync(X,ee,{mode:K.mode,flag:K.flag});const W=I.openSync(X,K.flag,K.mode);try{I.writeFileSync(W,ee);try{I.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{I.closeSync(W)}}function y(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function w(X,ee,H=6e4){if(X!==ee)try{g.$i&&typeof H=="number"?await k(X,ee,Date.now(),H):await(0,j.promisify)(I.rename)(X,ee)}catch(K){if(X.toLowerCase()!==ee.toLowerCase()&&K.code==="EXDEV"||X.endsWith("."))await E(X,ee,{preserveSymlinks:!1}),await f(X,p.MOVE);else throw K}}async function k(X,ee,H,K,W=0){try{return await(0,j.promisify)(I.rename)(X,ee)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-H>=K)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${B}`),B;if(W===0){let ne=!1;try{const{stat:oe}=await o.stat(ee);oe.isFile()||(ne=!0)}catch{}if(ne)throw B}return await(0,L.$ih)(Math.min(100,W*10)),k(X,ee,H,K,W+1)}}async function E(X,ee,H){return U(X,ee,{root:{source:X,target:ee},options:H,handledSourcePaths:new Set})}const D=511;async function U(X,ee,H){if(H.handledSourcePaths.has(X))return;H.handledSourcePaths.add(X);const{stat:K,symbolicLink:W}=await o.stat(X);if(W){if(H.options.preserveSymlinks)try{return await _(X,ee,H)}catch{}if(W.dangling)return}return K.isDirectory()?F(X,ee,K.mode&D,H):T(X,ee,K.mode&D)}async function F(X,ee,H,K){await e.Promises.mkdir(ee,{recursive:!0,mode:H});const W=await l(X);for(const B of W)await U((0,S.$kc)(X,B),(0,S.$kc)(ee,B),K)}async function T(X,ee,H){await e.Promises.copyFile(X,ee),await e.Promises.chmod(ee,H)}async function _(X,ee,H){let K=await e.Promises.readlink(X);(0,O.$hg)(K,H.root.source,!g.$k)&&(K=(0,S.$kc)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,ee)}e.Promises=new class{get access(){return(0,j.promisify)(I.access)}get stat(){return(0,j.promisify)(I.stat)}get lstat(){return(0,j.promisify)(I.lstat)}get utimes(){return(0,j.promisify)(I.utimes)}get read(){return(X,ee,H,K,W)=>new Promise((B,ne)=>{I.read(X,ee,H,K,W,(oe,te,ce)=>oe?ne(oe):B({bytesRead:te,buffer:ce}))})}get readFile(){return(0,j.promisify)(I.readFile)}get write(){return(X,ee,H,K,W)=>new Promise((B,ne)=>{I.write(X,ee,H,K,W,(oe,te,ce)=>oe?ne(oe):B({bytesWritten:te,buffer:ce}))})}get appendFile(){return(0,j.promisify)(I.appendFile)}get fdatasync(){return(0,j.promisify)(I.fdatasync)}get truncate(){return(0,j.promisify)(I.truncate)}get copyFile(){return(0,j.promisify)(I.copyFile)}get open(){return(0,j.promisify)(I.open)}get close(){return(0,j.promisify)(I.close)}get symlink(){return(0,j.promisify)(I.symlink)}get readlink(){return(0,j.promisify)(I.readlink)}get chmod(){return(0,j.promisify)(I.chmod)}get mkdir(){return(0,j.promisify)(I.mkdir)}get unlink(){return(0,j.promisify)(I.unlink)}get rmdir(){return(0,j.promisify)(I.rmdir)}get realpath(){return(0,j.promisify)(I.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return m}get writeFile(){return s}get rm(){return f}get rename(){return w}get copy(){return E}}}),define(le[146],he([0,1,43,15,5,27,31]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=R,e.$Mq=S,e.$Nq=g,e.$Oq=C;function R(p){if(j.$k)return p;const f=(0,A.$nc)(p);if(p===f)return p;const u=((0,A.$oc)(p)||p).toLowerCase();try{const $=(0,O.readdirSync)(f).filter(l=>l.toLowerCase()===u);if($.length===1){const l=R(f);if(l)return(0,A.$kc)(l,$[0])}else if($.length>1){const l=$.indexOf(u);if(l>=0){const d=R(f);if(d)return(0,A.$kc)(d,$[l])}}}catch{}return null}async function S(p){if(j.$k)return p;const f=(0,A.$nc)(p);if(p===f)return p;const u=((0,A.$oc)(p)||p).toLowerCase();try{const $=(await O.Promises.readdir(f)).filter(l=>l.toLowerCase()===u);if($.length===1){const l=await S(f);if(l)return(0,A.$kc)(l,$[0])}else if($.length>1){const l=$.indexOf(u);if(l>=0){const d=await S(f);if(d)return(0,A.$kc)(d,$[l])}}}catch{}return null}async function g(p){try{return await O.Promises.realpath(p)}catch{const u=P(p);return await O.Promises.access(u,I.constants.R_OK),u}}function C(p){try{return I.realpathSync(p)}catch{const u=P(p);return I.accessSync(u,I.constants.R_OK),u}}function P(p){return(0,L.$6e)((0,A.$ic)(p),A.sep)}}),define(le[147],he([0,1,15,5,36,89,13,31]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=S,e.$am=g,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(P=j.env){return P.comspec||"cmd.exe"}function g(P){let p=[],f=!1;const u=function(b){if(f){p.push(b);return}(!P.send(b,l=>{if(l&&console.error(l),f=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(h=>u(h))}})||A.$i)&&(f=!0)};return{send:u}}var C;(function(P){async function p(f,u,b){if(I.$jc(f))return f;if(u===void 0&&(u=j.cwd()),I.$nc(f)!=="."||(b===void 0&&O.$Uf(j.env.PATH)&&(b=j.env.PATH.split(I.$uc)),b===void 0||b.length===0))return I.$kc(u,f);async function l(d){if(await R.Promises.exists(d)){let h;try{h=await R.Promises.stat(d)}catch(c){c.message.startsWith("EACCES")&&(h=await R.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(const d of b){let h;if(I.$jc(d)?h=I.$kc(d,f):h=I.$kc(u,d,f),await l(h))return h;let c=h+".com";if(await l(c)||(c=h+".exe",await l(c)))return c}return I.$kc(u,f)}P.findExecutable=p})(C||(e.win32=C={}))}),define(le[148],he([0,1,67,23]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=j;function j(O){return new Promise((R,S)=>{let g;const C=new Map;function P(f,u,b,$,l){const d=C.get(u);if(f===O||d){const h={name:p(b),cmd:b,pid:f,ppid:u,load:$,mem:l};C.set(f,h),f===O&&(g=h),d&&(d.children||(d.children=[]),d.children.push(h),d.children.length>1&&(d.children=d.children.sort((c,m)=>c.pid-m.pid)))}}function p(f){const u=/--utility-sub-type=network/i,b=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(b.exec(f))return"electron-crash-reporter";if($.exec(f))return"winpty-agent";if(l.exec(f))return"conpty-agent";let h=d.exec(f);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?u.exec(f)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const c=/[a-zA-Z-]+\.js/g;let m="";do h=c.exec(f),h&&(m+=h+" ");while(h);return m&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${m})`:f}if(process.platform==="win32"){const f=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,b)=>{se(["@vscode/windows-process-tree"],u,b)}).then(u=>{u.getProcessList(O,b=>{if(!b){S(new Error(`Root process ${O} not found`));return}u.getProcessCpuUsage(b,$=>{const l=new Map;$.forEach(d=>{const h=f(d.commandLine||"");l.set(d.pid,{name:p(h),cmd:h,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),g=l.get(O),g?(l.forEach(d=>{const h=l.get(d.ppid);h&&(h.children||(h.children=[]),h.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((h,c)=>h.pid-c.pid))}),R(g)):S(new Error(`Root process ${O} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let f=function(){let u=[g];const b=[];for(;u.length;){const l=u.shift();l&&(b.push(l.pid),l.children&&(u=u.concat(l.children)))}let $=JSON.stringify(A.$Bg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+b.join(" "),(0,I.exec)($,{},(l,d,h)=>{if(l||h)S(l||new Error(h.toString()));else{const c=d.toString().split(`
`);for(let m=0;m<b.length;m++){const i=C.get(b[m]);i.load=parseFloat(c[m])}if(!g){S(new Error(`Root process ${O} not found`));return}R(g)}})};(0,I.exec)("which ps",{},(u,b,$)=>{if(u||$)if(process.platform!=="linux")S(u||new Error($.toString()));else{const l=JSON.stringify(A.$Bg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(l,{},(d,h,c)=>{d||c?S(d||new Error(c.toString())):(L(h,P),f())})}else{const l=b.toString().trim();(0,I.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,c,m)=>{h||m&&!m.includes("screen size is bogus")?S(h||new Error(m.toString())):(L(c,P),process.platform==="linux"?f():g?R(g):S(new Error(`Root process ${O} not found`)))})}})}})}function L(O,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=O.toString().split(`
`);for(const C of g){const P=S.exec(C.trim());P&&P.length===6&&R(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}});var ye=this&&this.__decorate||function(se,e,I,A){var j=arguments.length,L=j<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,I):A,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(se,e,I,A);else for(var R=se.length-1;R>=0;R--)(O=se[R])&&(L=(j<3?O(L):j>3?O(e,I,L):O(e,I))||L);return j>3&&L&&Object.defineProperty(e,I,L),L};define(le[40],he([0,1,17,6,14,26,84,7,3,2,66,27,13]),function(se,e,I,A,j,L,O,R,S,g,C,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=r,e.$Uh=a,e.$Zh=D,e.$1h=U;var f;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(f||(f={}));function u(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(b||(b={}));function $(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(l||(l={}));function d(W){let B=0;for(let ne=0;;ne+=7){const oe=W.read(1);if(B|=(oe.buffer[0]&127)<<ne,!(oe.buffer[0]&128))return B}}const h=n(0);function c(W,B){if(B===0){W.write(h);return}let ne=0;for(let te=B;te!==0;te=te>>>7)ne++;const oe=j.$ue.alloc(ne);for(let te=0;B!==0;te++)oe.buffer[te]=B&127,B=B>>>7,B>0&&(oe.buffer[te]|=128);W.write(oe)}class m{constructor(B){this.b=B,this.a=0}read(B){const ne=this.b.slice(this.a,this.a+B);return this.a+=ne.byteLength,ne}}e.$Rh=m;class i{constructor(){this.a=[]}get buffer(){return j.$ue.concat(this.a)}write(B){this.a.push(B)}}e.$Sh=i;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function n(W){const B=j.$ue.alloc(1);return B.writeUInt8(W,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(W,B){if(typeof B>"u")W.write(s.Undefined);else if(typeof B=="string"){const ne=j.$ue.fromString(B);W.write(s.String),c(W,ne.byteLength),W.write(ne)}else if(t&&Buffer.isBuffer(B)){const ne=j.$ue.wrap(B);W.write(s.Buffer),c(W,ne.byteLength),W.write(ne)}else if(B instanceof j.$ue)W.write(s.VSBuffer),c(W,B.byteLength),W.write(B);else if(Array.isArray(B)){W.write(s.Array),c(W,B.length);for(const ne of B)r(W,ne)}else if(typeof B=="number"&&(B|0)===B)W.write(s.Uint),c(W,B);else{const ne=j.$ue.fromString(JSON.stringify(B));W.write(s.Object),c(W,ne.byteLength),W.write(ne)}}function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(d(W)).toString();case o.Buffer:return W.read(d(W)).buffer;case o.VSBuffer:return W.read(d(W));case o.Array:{const ne=d(W),oe=[];for(let te=0;te<ne;te++)oe.push(a(W));return oe}case o.Object:return JSON.parse(W.read(d(W)).toString());case o.Int:return d(W)}}class v{constructor(B,ne,oe=null,te=1e3){this.h=B,this.j=ne,this.k=oe,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(B,ne){this.b.set(B,ne),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ne=this.o([B.type]);this.k?.logOutgoing(ne,0,1,$(B.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ne,B.id,1,$(B.type),B.data);return}}}o(B,ne=void 0){const oe=new i;return r(oe,B),r(oe,ne),this.p(oe.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ne=new m(B),oe=a(ne),te=a(ne),ce=oe[0];switch(ce){case 100:return this.k?.logIncoming(B.byteLength,oe[1],1,`${u(ce)}: ${oe[2]}.${oe[3]}`,te),this.s({type:ce,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 102:return this.k?.logIncoming(B.byteLength,oe[1],1,`${u(ce)}: ${oe[2]}.${oe[3]}`,te),this.t({type:ce,id:oe[1],channelName:oe[2],name:oe[3],arg:te});case 101:return this.k?.logIncoming(B.byteLength,oe[1],1,`${u(ce)}`),this.u({type:ce,id:oe[1]});case 103:return this.k?.logIncoming(B.byteLength,oe[1],1,`${u(ce)}`),this.u({type:ce,id:oe[1]})}}s(B){const ne=this.b.get(B.channelName);if(!ne){this.v(B);return}const oe=new L.$ee;let te;try{te=ne.call(this.j,B.name,B.arg,oe.token)}catch(q){te=Promise.reject(q)}const ce=B.id;te.then(q=>{this.m({id:ce,data:q,type:201})},q=>{q instanceof Error?this.m({id:ce,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ce,data:q,type:203})}).finally(()=>{G.dispose(),this.d.delete(B.id)});const G=(0,g.$Sc)(()=>oe.cancel());this.d.set(B.id,G)}t(B){const ne=this.b.get(B.channelName);if(!ne){this.v(B);return}const oe=B.id,ce=ne.listen(this.j,B.name,B.arg)(G=>this.m({id:oe,data:G,type:204}));this.d.set(B.id,ce)}u(B){const ne=this.d.get(B.id);ne&&(ne.dispose(),this.d.delete(B.id))}v(B){let ne=this.g.get(B.channelName);ne||(ne=[],this.g.set(B.channelName,ne));const oe=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:B,timeoutTimer:oe})}w(B){const ne=this.g.get(B);if(ne){for(const oe of ne)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=v;var y;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class w{constructor(B,ne=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ne}getChannel(B){const ne=this;return{call(oe,te,ce){return ne.a?Promise.reject(new R.$5):ne.m(B,oe,te,ce)},listen(oe,te){return ne.a?S.Event.None:ne.o(B,oe,te)}}}m(B,ne,oe,te=L.CancellationToken.None){const ce=this.g++,q={id:ce,type:100,channelName:B,name:ne,arg:oe};if(te.isCancellationRequested)return Promise.reject(new R.$5);let N;return new Promise((z,Z)=>{if(te.isCancellationRequested)return Z(new R.$5);const J=()=>{const ie=re=>{switch(re.type){case 201:this.f.delete(ce),z(re.data);break;case 202:{this.f.delete(ce);const ue=new Error(re.data.message);ue.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,ue.name=re.data.name,Z(ue);break}case 203:this.f.delete(ce),Z(re.data);break}};this.f.set(ce,ie),this.p(q)};let x=null;this.b===l.Idle?J():(x=(0,A.$7g)(ie=>this.u()),x.then(()=>{x=null,J()}));const Y=()=>{x?(x.cancel(),x=null):this.p({id:ce,type:101}),Z(new R.$5)},V=te.onCancellationRequested(Y);N=(0,g.$Rc)((0,g.$Sc)(Y),V),this.d.add(N)}).finally(()=>{N.dispose(),this.d.delete(N)})}o(B,ne,oe){const te=this.g++,G={id:te,type:102,channelName:B,name:ne,arg:oe};let q=null;const N=new S.$7d({onWillAddFirstListener:()=>{q=(0,A.$7g)(z=>this.u()),q.then(()=>{q=null,this.d.add(N),this.p(G)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(N),this.p({id:te,type:103}))}}),M=z=>N.fire(z.data);return this.f.set(te,M),N.event}p(B){switch(B.type){case 100:case 102:{const ne=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ne,B.id,0,`${u(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ne=this.q([B.type,B.id]);this.j?.logOutgoing(ne,B.id,0,u(B.type));return}}}q(B,ne=void 0){const oe=new i;return r(oe,B),r(oe,ne),this.r(oe.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ne=new m(B),oe=a(ne),te=a(ne),ce=oe[0];switch(ce){case 200:return this.j?.logIncoming(B.byteLength,0,0,$(ce)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,oe[1],0,$(ce),te),this.t({type:oe[0],id:oe[1],data:te})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=w,ye([O.$Lh],w.prototype,"onDidInitializePromise",null);class k{get connections(){const B=[];return this.f.forEach(ne=>B.push(ne)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new S.$7d,this.onDidAddConnection=this.g.event,this.h=new S.$7d,this.onDidRemoveConnection=this.h.event,this.j=new g.$Tc,this.j.add(B(({protocol:ne,onDidClientDisconnect:oe})=>{const te=S.Event.once(ne.onMessage);this.j.add(te(ce=>{const G=new m(ce),q=a(G),N=new v(ne,q),M=new w(ne);this.a.forEach((Z,J)=>N.registerChannel(J,Z));const z={channelServer:N,channelClient:M,ctx:q};this.f.add(z),this.g.fire(z),this.j.add(oe(()=>{N.dispose(),M.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(B,ne){const oe=this;return{call(te,ce,G){let q;if((0,p.$9f)(ne)){const M=(0,I.$4b)(oe.connections.filter(ne));q=M?Promise.resolve(M):S.Event.toPromise(S.Event.filter(oe.onDidAddConnection,ne))}else q=ne.routeCall(oe,te,ce);const N=q.then(M=>M.channelClient.getChannel(B));return D(N).call(te,ce,G)},listen(te,ce){if((0,p.$9f)(ne))return oe.k(B,ne,te,ce);const G=ne.routeEvent(oe,te,ce).then(q=>q.channelClient.getChannel(B));return D(G).listen(te,ce)}}}k(B,ne,oe,te){const ce=this;let G;const q=new S.$7d({onWillAddFirstListener:()=>{G=new g.$Tc;const N=new S.$ae,M=new Map,z=J=>{const Y=J.channelClient.getChannel(B).listen(oe,te),V=N.add(Y);M.set(J,V)},Z=J=>{const x=M.get(J);x&&(x.dispose(),M.delete(J))};ce.connections.filter(ne).forEach(z),S.Event.filter(ce.onDidAddConnection,ne)(z,void 0,G),ce.onDidRemoveConnection(Z,void 0,G),N.event(q.fire,q,G),G.add(N)},onDidRemoveLastListener:()=>{G?.dispose(),G=void 0}});return q.event}registerChannel(B,ne){this.a.set(B,ne);for(const oe of this.f)oe.channelServer.registerChannel(B,ne)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=k;class E{constructor(B,ne,oe=null){const te=new i;r(te,ne),B.send(te.buffer),this.a=new w(B,oe),this.d=new v(B,ne,oe)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ne){this.d.registerChannel(B,ne)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=E;function D(W){return{call(B,ne,oe){return W.then(te=>te.call(B,ne,oe))},listen(B,ne){const oe=new S.$de;return W.then(te=>oe.input=te.listen(B,ne)),oe.event}}}function U(W){let B=!1;return{call(ne,oe,te){return B?W.call(ne,oe,te):(0,A.$ih)(0).then(()=>B=!0).then(()=>W.call(ne,oe,te))},listen(ne,oe){if(B)return W.listen(ne,oe);const te=new S.$de;return(0,A.$ih)(0).then(()=>B=!0).then(()=>te.input=W.listen(ne,oe)),te.event}}}class F{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ne of B.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await S.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$2h=F;var T;(function(W){function B(ce,G,q){const N=ce,M=q&&q.disableMarshalling,z=new Map;for(const Z in N)oe(Z)&&z.set(Z,S.Event.buffer(N[Z],!0,void 0,G));return new class{listen(Z,J,x){const Y=z.get(J);if(Y)return Y;const V=N[J];if(typeof V=="function"){if(te(J))return V.call(N,x);if(oe(J))return z.set(J,S.Event.buffer(N[J],!0,void 0,G)),z.get(J)}throw new R.$bb(`Event not found: ${J}`)}call(Z,J,x){const Y=N[J];if(typeof Y=="function"){if(!M&&Array.isArray(x))for(let ie=0;ie<x.length;ie++)x[ie]=(0,C.$Qh)(x[ie]);let V=Y.apply(N,x);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new R.$bb(`Method not found: ${J}`)}}}W.fromService=B;function ne(ce,G){const q=G&&G.disableMarshalling;return new Proxy({},{get(N,M){if(typeof M=="string")return G?.properties?.has(M)?G.properties.get(M):te(M)?function(z){return ce.listen(M,z)}:oe(M)?ce.listen(M):async function(...z){let Z;G&&!(0,p.$4f)(G.context)?Z=[G.context,...z]:Z=z;const J=await ce.call(M,Z);return q?J:(0,C.$Qh)(J)};throw new R.$bb(`Property not found: ${String(M)}`)}})}W.toService=ne;function oe(ce){return ce[0]==="o"&&ce[1]==="n"&&P.$kf(ce.charCodeAt(2))}function te(ce){return/^onDynamic/.test(ce)&&P.$kf(ce.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function ee(W){return Array.isArray(W)?W.map(X):X(W)}function H(W,B,ne,oe,te,ce,G){G=ee(G);const q=_[te],N=q[oe%q.length];let M=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(ce)?(M=M.concat(G),M.push(")")):M.push(G),console.log.apply(console,M)}class K{constructor(B,ne){this.d=B,this.f=ne,this.a=0,this.b=0}logOutgoing(B,ne,oe,te,ce){this.b+=B,H(this.d,this.b,B,ne,oe,te,ce)}logIncoming(B,ne,oe,te,ce){this.a+=B,H(this.f,this.a,B,ne,oe,te,ce)}}e.$3h=K}),define(le[68],he([0,1,14,3,2,40]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.ProtocolConstants=e.$4h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(y,w){if(!t.has(y)){const k=String(++r);t.set(y,k)}return t.get(y)}function v(y,w,k,E){if(!s.enableDiagnostics)return;const D=a(y,w);if(E instanceof I.$ue||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const U=I.$ue.alloc(E.byteLength);U.set(E),s.records.push({timestamp:Date.now(),id:D,label:w,type:k,buff:U})}else s.records.push({timestamp:Date.now(),id:D,label:w,type:k,data:E})}s.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let g=null;function C(){return g||(g=I.$ue.alloc(0)),g}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const w=this.a[0];return r&&(this.a.shift(),this.b-=t),w}if(this.a[0].byteLength>t){const w=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),w}const a=I.$ue.alloc(t);let v=0,y=0;for(;t>0;){const w=this.a[y];if(w.byteLength>t){const k=w.slice(0,t);a.set(k,v),v+=t,r&&(this.a[y]=w.slice(t),this.b-=t),t-=t}else a.set(w,v),v+=w.byteLength,r?(this.a.shift(),this.b-=w.byteLength):y++,t-=w.byteLength}return a}}e.$4h=P;var p;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(p||(p={}));function f(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var u;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(u||(e.ProtocolConstants=u={}));class b{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends j.$Uc{constructor(t){super(),this.f=this.B(new A.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new P,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,v,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$ue.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=I.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends j.$Uc{constructor(t){super(),this.f=new A.$7d,this.onMessage=this.f.event,this.g=new A.$7d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$5h=d;class h extends L.$Yh{static fromSocket(t,r){return new h(new d(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$6h=h;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$7h=c;class m{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new m(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Tc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,C());this.p.write(t)}sendResume(){const t=new b(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new j.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,C());this.p.write(t)}}e.$8h=n}),define(le[92],he([0,1,67,6,14,26,142,7,3,2,30,147,89,40]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;class u extends f.$Vh{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",d=>j.$ue.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Hq=u;class b{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new S.$7d,this.onDidProcessExit=this.h.event;const h=d&&d.timeout?d.timeout:6e4;this.b=new A.$eh(h),this.d=null,this.f=null}getChannel(l){const d=this;return{call(h,c,m){return d.k(l,h,c,m)},listen(h,c){return d.l(l,h,c)}}}k(l,d,h,c=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const m=this.n(l),i=(0,A.$7g)(s=>m.call(d,h,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,g.$Sc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,d,h){if(!this.b)return S.Event.None;this.b.cancel();let c;const m=new S.$7d({onWillAddFirstListener:()=>{c=this.n(l).listen(d,h)(m.fire,m),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,p.$$l)(d.env),this.d=(0,I.fork)(this.i,l,d);const h=new S.$7d;S.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$Dq)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}h.fire(j.$ue.wrap(Buffer.from(t,"base64")))});const m=this.j.useQueue?(0,P.$am)(this.d):this.d,i=t=>this.d&&this.d.connected&&m.send(t.buffer.toString("base64")),o=h.event,n={send:i,onMessage:o};this.f=new f.$Wh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Pc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Iq=b}),define(le[149],he([0,1,134,14,40,3,13,17]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_V=void 0,e.$aW=C;class S{constructor(p){this.a=p,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",f=>f.data?A.$ue.wrap(f.data):A.$ue.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}class g extends j.$Xh{static b(p){(0,O.$5f)((0,I.$$V)(process),"Electron Utility Process");const f=new L.$7d;return process.parentPort.on("message",u=>{if(p?.handledClientConnection(u))return;const b=(0,R.$Ob)(u.ports);b&&f.fire(b)}),L.Event.map(f.event,u=>({protocol:new S(u),onDidClientDisconnect:L.Event.fromNodeEventEmitter(u,"close")}))}constructor(p){super(g.b(p))}}e.$_V=g;function C(P,p,f){const u=b=>{b.data===p&&(P.removeListener("message",u),f())};P.on("message",u)}}),define(le[69],he([0,1,6,3,2,66,13]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=S;var R;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}var g;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends j.$Uc{static{this.a=100}constructor(f,u=Object.create(null)){super(),this.r=f,this.s=u,this.b=this.B(new A.$0d),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$fh(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((u,b)=>this.w(b,u)),f.deleted?.forEach(u=>this.w(u,void 0))}finally{this.b.resume()}}w(f,u){if(this.c===g.Closed)return;let b=!1;(0,O.$4f)(u)?b=this.f.delete(f):this.f.get(f)!==u&&(this.f.set(f,u),b=!0),b&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,u){const b=this.f.get(f);return(0,O.$4f)(b)?u:b}getBoolean(f,u){const b=this.get(f);return(0,O.$4f)(b)?u:b==="true"}getNumber(f,u){const b=this.get(f);return(0,O.$4f)(b)?u:parseInt(b,10)}getObject(f,u){const b=this.get(f);return(0,O.$4f)(b)?u:(0,L.$Ph)(b)}async set(f,u,b=!1){if(this.c===g.Closed)return;if((0,O.$4f)(u))return this.delete(f,b);const $=(0,O.$Wf)(u)||Array.isArray(u)?(0,L.$Oh)(u):String(u);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:b}),this.D()}async delete(f,u=!1){if(!(this.c===g.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:u}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Hp=C;class P{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((u,b)=>this.a.set(b,u)),f.delete?.forEach(u=>this.a.delete(u))}async optimize(){}async close(){}}e.$Ip=P}),define(le[150],he([11,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,43,6,15,13,31,150]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0,e.zip=$,e.$6p=l,e.$7p=h,e.$3p="end of central directory record signature not found";const S=new RegExp(e.$3p);class g extends Error{constructor(m,i){let o=i.message;switch(m){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=m,this.cause=i}}e.$4p=g;function C(c){const m=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>m&i).reduce((i,o)=>i+o,m&61440)}function P(c){if(c instanceof g)return c;let m;return S.test(c.message)&&(m="CorruptZip"),new g(m,c)}function p(c,m,i,o,n,s){const t=j.$nc(m),r=j.$kc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,m)));const a=j.$kc(o,m);let v;return s.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,w)=>{if(!s.isCancellationRequested)try{v=(0,I.createWriteStream)(a,{mode:i}),v.once("close",()=>y()),v.once("error",w),c.once("error",w),c.pipe(v)}catch(k){w(k)}}))}function f(c,m,i,o){let n=(0,A.$7g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const v=new A.$ch,y=w=>{w.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new g("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",w=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(w.fileName)){y(o);return}const k=w.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(k)){const U=j.$kc(m,k);n=(0,A.$7g)(F=>O.Promises.mkdir(U,{recursive:!0}).then(()=>y(F)).then(void 0,a));return}const E=b(c,w),D=C(w);n=(0,A.$7g)(U=>v.queue(()=>E.then(F=>p(F,k,D,m,i,U).then(()=>y(U)))).then(null,a))})}).finally(()=>t.dispose())}async function u(c,m=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,m?{lazyEntries:!0}:void 0,(s,t)=>{s?n(P(s)):o((0,L.$6f)(t))})})}function b(c,m){return new Promise((i,o)=>{c.openReadStream(m,(n,s)=>{n?o(P(n)):i((0,L.$6f)(s))})})}async function $(c,m){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;m.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,I.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}function l(c,m,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=u(c,!0);return i.overwrite&&(s=s.then(t=>O.Promises.rm(m).then(()=>t))),s.then(t=>f(t,m,{sourcePathRegex:n},o))}function d(c,m){return u(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===m&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,m))))}))}function h(c,m){return d(c,m).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}}),define(le[151],he([11,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[152],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[153],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[154],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[155],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[156],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[157],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[158],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[159],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[160],he([11,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[161],he([11,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[162],he([11,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[163],he([11,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[164],he([11,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[165],he([11,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[166],he([11,10]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[167],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[168],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[169],he([11,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[170],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[171],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[172],he([11,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[173],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[174],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[175],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[176],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[177],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[178],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[179],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[180],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[181],he([11,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[182],he([0,1,7,153]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var j;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(j||(e.TokenType=j={}));function L(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const O=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const P=this.d,p=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:p};this.g.push({offset:P,lexeme:p,additionalInfo:C}),this.f.push(f)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const P=this.c.substring(this.d,this.e),p=S.b.get(P);p?this.k(p):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,P=!1,p=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const u=this.c.charCodeAt(C);if(P)P=!1;else if(u===47&&!p){C++;break}else u===91?p=!0:u===92?P=!0:u===93&&(p=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=S}),define(le[183],he([0,1,65,84,23,15,36,20,8]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Rm=C,e.$Sm=P,e.$Pm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,L.$nc)(j.$Bg.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,L.$kc)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Ug)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Ug)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,I.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$kc)(this.userDataPath,"logs",f)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Ug)(S.URI.file((0,L.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Ug)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Ug)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Ug)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=O.env.VSCODE_PORTABLE;return f?S.URI.file((0,L.$kc)(f,"argv.json")):(0,R.$Ug)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,L.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,L.$lc)(f):(0,L.$ic)((0,L.$kc)(j.$Bg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?S.URI.file((0,L.$lc)(f)):S.URI.file((0,L.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,L.$lc)(f);const u=O.env.VSCODE_EXTENSIONS;if(u)return u;const b=O.env.VSCODE_PORTABLE;return b?(0,L.$kc)(b,"extensions"):(0,R.$Ug)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(u=>/^[^:/?#]+?:\/\//.test(u)?S.URI.parse(u):S.URI.file((0,L.$ic)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?S.URI.parse(f):S.URI.file((0,L.$ic)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$Pm.test(f))}get extensionLogLevel(){const f=[];for(const u of this.args.log||[]){const b=e.$Pm.exec(u);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,R.$Ug)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=O.env.VSCODE_PORTABLE;return f?S.URI.file((0,L.$kc)(f,"policy.json")):(0,R.$Ug)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,u,b){this.a=f,this.b=u,this.c=b,this.editSessionId=this.args.editSessionId}}e.$Qm=g,ye([A.$Lh],g.prototype,"appRoot",null),ye([A.$Lh],g.prototype,"userHome",null),ye([A.$Lh],g.prototype,"userDataPath",null),ye([A.$Lh],g.prototype,"appSettingsHome",null),ye([A.$Lh],g.prototype,"tmpDir",null),ye([A.$Lh],g.prototype,"cacheHome",null),ye([A.$Lh],g.prototype,"stateResource",null),ye([A.$Lh],g.prototype,"userRoamingDataHome",null),ye([A.$Lh],g.prototype,"userDataSyncHome",null),ye([A.$Lh],g.prototype,"sync",null),ye([A.$Lh],g.prototype,"machineSettingsResource",null),ye([A.$Lh],g.prototype,"workspaceStorageHome",null),ye([A.$Lh],g.prototype,"localHistoryHome",null),ye([A.$Lh],g.prototype,"keyboardLayoutResource",null),ye([A.$Lh],g.prototype,"argvResource",null),ye([A.$Lh],g.prototype,"isExtensionDevelopment",null),ye([A.$Lh],g.prototype,"untitledWorkspacesHome",null),ye([A.$Lh],g.prototype,"builtinExtensionsPath",null),ye([A.$Lh],g.prototype,"extensionsPath",null),ye([A.$Lh],g.prototype,"extensionDevelopmentLocationURI",null),ye([A.$Lh],g.prototype,"extensionDevelopmentKind",null),ye([A.$Lh],g.prototype,"extensionTestsLocationURI",null),ye([A.$Lh],g.prototype,"debugExtensionHost",null),ye([A.$Lh],g.prototype,"logLevel",null),ye([A.$Lh],g.prototype,"extensionLogLevel",null),ye([A.$Lh],g.prototype,"serviceMachineIdResource",null),ye([A.$Lh],g.prototype,"disableTelemetry",null),ye([A.$Lh],g.prototype,"disableWorkspaceTrust",null),ye([A.$Lh],g.prototype,"useInMemorySecretStorage",null),ye([A.$Lh],g.prototype,"policyFile",null);function C(p,f){return P(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}function P(p,f,u,b,$,l){const h=Number(f||p)||(b?null:u),c=h?!!f:!1;let m;if(l)try{m=JSON.parse(l)}catch{}return{port:h,break:c,debugId:$,env:m}}}),function(){"use strict";function se(e,I,A){function j(O,R){const S=L(O,R),g=[S];return e.isAbsolute(S)||g.unshift(A),e.resolve(...g)}function L(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(P,"AppData","Roaming")}break;case"darwin":g=e.join(I.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:j}}if(typeof define=="function")define(le[184],he([275,37,36]),function(e,I,A){return se(e,I,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=se(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[185],he([0,1,37,183,184]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=void 0,e.$Um=O,e.$Vm=R;class L extends A.$Qm{constructor(g,C){super(g,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,j.getUserDataPath)(g,C.nameShort)},C)}}e.$Tm=L;function O(S,g){return(0,A.$Sm)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,g,S.extensionEnvironment)}function R(S,g){return(0,A.$Sm)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,g,S.extensionEnvironment)}}),define(le[186],he([0,1,13,156]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=j;function j(O,R,S,g){try{L(O,R,S,g)}catch(C){O.error(C?.message??C)}return R}function L(O,R,S,g){const C=(P,p,f)=>{const u=P[p];if((0,I.$Uf)(u)){const b=u,$=b.length;if($>1&&b[0]==="%"&&b[$-1]==="%"){const l=b.substr(1,$-2);let d=S[l];d===void 0&&g&&(d=g[l]);const h=typeof d=="string"?d:d?.message,c=g?.[l],m=typeof c=="string"?c:c?.message;if(!h){m||O.warn(`[${R.name}]: ${(0,A.localize)(0,null,l)}`);return}if(f&&(p==="title"||p==="category")&&m&&m!==h){const i={value:h,original:m};P[p]=i}else P[p]=h}}else if((0,I.$Wf)(u))for(const b in u)u.hasOwnProperty(b)&&(b==="commands"?C(u,b,!0):C(u,b,f));else if(Array.isArray(u))for(let b=0;b<u.length;b++)C(u,b,f)};for(const P in R)R.hasOwnProperty(P)&&C(R,P)}}),define(le[187],he([0,1,70,159]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=j;function j(L){return(0,I.$7p)(L,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}}),define(le[188],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=e.$ncc=void 0;class I{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$ncc=I;class A{constructor(L){this.a=L}listen(L,O){throw new Error(`Event not found: ${O}`)}call(L,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$occ=A}),define(le[71],he([0,1,20,88,160,55]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=S,e.$sp=g,e.$tp=C,e.$up=P,e.$vp=p,e.$wp=f,e.$xp=u;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||O.test(l)}function g(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function C(l){if(!l)return null;const d=l.majorBase,h=l.majorMustEqual,c=l.minorBase;let m=l.minorMustEqual;const i=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(d===0||(m=!1),o=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:d,majorMustEqual:h,minorBase:c,minorMustEqual:m,patchBase:i,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}function P(l,d,h){let c;typeof l=="string"?c=C(g(l)):c=l;let m;d instanceof Date?m=d.getTime():typeof d=="string"&&(m=new Date(d).getTime());let i;if(typeof h=="string"?i=C(g(h)):i=h,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const v=i.notBefore;let y=i.majorMustEqual,w=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||m&&m<v?!1:s>=a:(o===1&&t===0&&(!y||!w||!k)&&(t=1,r=0,a=0,y=!0,w=!1,k=!1),o<t?!1:o>t?!y:n<r?!1:n>r?!w:s<a?!1:s>a?!k:!(m&&m<v))}function p(l,d,h,c,m){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([A.default.Error,j.localize(0,null)]),i;if(typeof c.name!="string")return i.push([A.default.Error,j.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([A.default.Error,j.localize(2,null,"version")]),i;if(!c.engines)return i.push([A.default.Error,j.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([A.default.Error,j.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!$(c.extensionDependencies))return i.push([A.default.Error,j.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!$(c.activationEvents))return i.push([A.default.Error,j.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([A.default.Error,j.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([A.default.Warning,j.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([A.default.Error,j.localize(9,null,"main")]),i;{const s=(0,I.$Ug)(h,c.main);(0,I.$Og)(s,h)||i.push([A.default.Warning,j.localize(10,null,s.path,h.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([A.default.Error,j.localize(11,null,"browser")]),i;{const s=(0,I.$Ug)(h,c.browser);(0,I.$Og)(s,h)||i.push([A.default.Warning,j.localize(12,null,s.path,h.path)])}}if(!L.valid(c.version))return i.push([A.default.Error,j.localize(13,null)]),i;const o=[];if(!f(l,d,c,m,o))for(const s of o)i.push([A.default.Error,s]);return i}function f(l,d,h,c,m){return c||typeof h.main>"u"&&typeof h.browser>"u"?!0:b(l,d,h.engines.vscode,m)}function u(l,d,h){return l==="*"||b(d,h,l)}function b(l,d,h,c=[]){const m=C(g(h));if(!m)return c.push(j.localize(14,null,h)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return c.push(j.localize(15,null,h)),!1}else if(!m.majorMustEqual)return c.push(j.localize(16,null,h)),!1;return P(l,d,m)?!0:(c.push(j.localize(17,null,l,h)),!1)}function $(l){if(!Array.isArray(l))return!1;for(let d=0,h=l.length;d<h;d++)if(typeof l[d]!="string")return!1;return!0}}),define(le[44],he([0,1,14,32]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=j;async function j(L,O,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await O.readFile(L.serviceMachineIdResource)).value.toString();S=(0,A.$Cg)(C)?C:null}catch{S=null}if(!S){S=(0,A.$Dg)();try{await O.writeFile(L.serviceMachineIdResource,I.$ue.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}}),define(le[189],he([0,1,43,2,3,8]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class O extends A.$Uc{constructor(){super(...arguments),this.a=this.B(new j.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$4c),this.f=new Set,this.g=new Set}async watch(S){this.f=new Set([...S]);const g=new Set;for(const C of S)typeof C.correlationId=="number"&&(g.add(C.correlationId),this.c.has(C.correlationId)||this.c.set(C.correlationId,this.m(C)));for(const[C]of this.c)g.has(C)||this.c.deleteAndDispose(C);for(const C of this.g)this.f.has(C)||this.g.delete(C);return this.j()}j(){return this.t(Array.from(this.f).filter(S=>!this.g.has(S)))}m(S){if(typeof S.correlationId!="number")return A.$Uc.None;const g=this,C=L.URI.file(S.path);let P=!1,p=!1;const f=(u,b)=>{if(P)return;const $=this.n(u),l=this.n(b),d=p;if(p=$,l&&!$||d&&!$&&!l){this.u(`fs.watchFile() detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const h={resource:C,type:1,cId:S.correlationId};g.a.fire([h]),this.s(h,S),this.g.delete(S),this.j()}else if($){if(this.u(`fs.watchFile() detected ${S.path} not found, suspending watcher (correlationId: ${S.correlationId})`),!l){const h={resource:C,type:2,cId:S.correlationId};g.a.fire([h]),this.s(h,S)}this.g.add(S),this.j()}};this.u(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,I.watchFile)(S.path,{persistent:!1,interval:this.h},f)}catch(u){return this.w(`fs.watchFile() failed with error ${u} on path ${S.path} (correlationId: ${S.correlationId})`),A.$Uc.None}return(0,A.$Sc)(()=>{this.u(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`),P=!0,this.g.delete(S);try{(0,I.unwatchFile)(S.path,f)}catch(u){this.w(`fs.unwatchFile() failed with error ${u} on path ${S.path} (correlationId: ${S.correlationId})`)}})}n(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.c.clearAndDisposeAll(),this.g.clear()}r(S){return typeof S.correlationId!="number"}s(S,g){const C=` >> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.u(typeof g.correlationId=="number"?`${C} (correlationId: ${g.correlationId})`:C)}}e.$Kq=O}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class I{constructor(j,L=[],O=!1){this.ctor=j,this.staticArguments=L,this.supportsDelayedInstantiation=O}}e.$ei=I}),define(le[190],he([0,1,72]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$es=L,e.$fs=O;const A=[];var j;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function L(R,S,g){S instanceof I.$ei||(S=new I.$ei(S,[],!!g)),A.push([R,S])}function O(){return A}}),define(le[191],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class I{constructor(L,O){this.key=L,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$Uq=I;class A{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const O of this.a.values())O.outgoing.size===0&&L.push(O);return L}insertEdge(L,O){const R=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(O);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(L){const O=this.b(L);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(L){const O=this.b(L);let R=this.a.get(O);return R||(R=new I(O,L),this.a.set(O,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[O,R]of this.a)L.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,O]of this.a){const R=new Set([L]),S=this.c(O,R);if(S)return S}}c(L,O){for(const[R,S]of L.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const g=this.c(S,O);if(g)return g;O.delete(R)}}}e.$Vq=A}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=j,e.$ii=L;var I;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(I||(e._util=I={})),e.$gi=j("instantiationService");function A(O,R,S){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:O,index:S}):(R[I.DI_DEPENDENCIES]=[{id:O,index:S}],R[I.DI_TARGET]=R)}function j(O){if(I.serviceIds.has(O))return I.serviceIds.get(O);const R=function(S,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,S,C)};return R.toString=()=>O,I.serviceIds.set(O,R),R}function L(O){return O}}),define(le[192],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0,e.$Zbc=(0,I.$hi)("checksumService")}),define(le[21],he([0,1,13,8,4]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=L,e.$Pi=O,e.$Qi=S,e.$Ri=g,e.$Si=C,e.$Ti=P,e.$Ui=p,e.$Vi=u,e.$Wi=b,e.$Xi=$,e.$Ni=(0,j.$hi)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof A.URI)}function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof A.URI)}var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function C(l,d){const h=Object.create(null);for(const c in l)P(h,c,l[c],d);return h}function P(l,d,h,c){const m=d.split("."),i=m.pop();let o=l;for(let n=0;n<m.length;n++){const s=m[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${d} as ${m.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=h}catch{c(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${d} as ${m.join(".")} is ${JSON.stringify(o)}`)}function p(l,d){const h=d.split(".");f(l,h)}function f(l,d){const h=d.shift();if(d.length===0){delete l[h];return}if(Object.keys(l).indexOf(h)!==-1){const c=l[h];typeof c=="object"&&!Array.isArray(c)&&(f(c,d),Object.keys(c).length===0&&delete l[h])}}function u(l,d,h){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const m=d.split("."),i=c(l,m);return typeof i>"u"?h:i}function b(l,d,h){Object.keys(d).forEach(c=>{c!=="__proto__"&&(c in l?I.$Wf(l[c])&&I.$Wf(d[c])?b(l[c],d[c],h):h&&(l[c]=d[c]):l[c]=d[c])})}function $(l){return l.replace(/[\[\]]/g,"")}}),define(le[93],he([0,1,5,27,182,4,152,7]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=g,e.$gj=o,e.$hj=n,e.$Aj=te;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",I.$j),S.set("isLinux",I.$k),S.set("isWindows",I.$i),S.set("isWeb",I.$o),S.set("isMacNative",I.$j&&!I.$o),S.set("isEdge",I.$H),S.set("isFirefox",I.$F),S.set("isChrome",I.$E),S.set("isSafari",I.$G);function g(q,N){if(S.get(q)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(q,N)}const C=Object.prototype.hasOwnProperty;var P;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const p={regexParsingWithErrorRecovery:!0},f=(0,O.localize)(0,null),u=(0,O.localize)(1,null),b=(0,O.localize)(2,null),$=(0,O.localize)(3,null),l=(0,O.localize)(4,null),d=(0,O.localize)(5,null),h=(0,O.localize)(6,null),c=(0,O.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=p){this.k=N,this.d=new j.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:u});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const z=this.D(),Z=z.type===17?d:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:j.$cj.getLexeme(z),additionalInfo:Z}),m.c}return M}catch(M){if(M!==m.c)throw M;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const M=this.o();N.push(M)}return N.length===1?N[0]:i.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const M=this.s();N.push(M)}return N.length===1?N[0]:i.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,$),M?.negate()}case 17:return this.z(),E.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const M=this.l();return this.A(1,$),M}case 17:{const M=N.lexeme;if(this.z(),this.y(9)){const Z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Z.type!==10)throw this.B("REGEX",Z);const J=Z.lexeme,x=J.lastIndexOf("/"),Y=x===J.length-1?void 0:this.w(J.substring(x+1));let V;try{V=new RegExp(J.substring(1,x),Y)}catch{throw this.B("REGEX",Z)}return X.create(M,V)}switch(Z.type){case 10:case 19:{const J=[Z.lexeme];this.z();let x=this.D(),Y=0;for(let de=0;de<Z.lexeme.length;de++)Z.lexeme.charCodeAt(de)===40?Y++:Z.lexeme.charCodeAt(de)===41&&Y--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let de=0;de<x.lexeme.length;de++)x.lexeme.charCodeAt(de)===40?Y++:Z.lexeme.charCodeAt(de)===41&&Y--}if(Y<0)break;J.push(j.$cj.getLexeme(x)),this.z(),x=this.D()}const V=J.join(""),ie=V.lastIndexOf("/"),re=ie===V.length-1?void 0:this.w(V.substring(ie+1));let ue;try{ue=new RegExp(V.substring(1,ie),re)}catch{throw this.B("REGEX",Z)}return i.regex(M,ue)}case 18:{const J=Z.lexeme;this.z();let x=null;if(!(0,A.$Ue)(J)){const Y=J.indexOf("/"),V=J.lastIndexOf("/");if(Y!==V&&Y>=0){const ie=J.slice(Y+1,V),re=J[V+1]==="i"?"i":"";try{x=new RegExp(ie,re)}catch{throw this.B("REGEX",Z)}}}if(x===null)throw this.B("REGEX",Z);return X.create(M,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const Z=this.u();return i.notIn(M,Z)}switch(this.D().type){case 3:{this.z();const Z=this.u();if(this.x().type===18)return i.equals(M,Z);switch(Z){case"true":return i.has(M);case"false":return i.not(M);default:return i.equals(M,Z)}}case 4:{this.z();const Z=this.u();if(this.x().type===18)return i.notEquals(M,Z);switch(Z){case"true":return i.not(M);case"false":return i.has(M);default:return i.notEquals(M,Z)}}case 5:return this.z(),T.create(M,this.u());case 6:return this.z(),_.create(M,this.u());case 7:return this.z(),U.create(M,this.u());case 8:return this.z(),F.create(M,this.u());case 13:return this.z(),i.in(M,this.u());default:return i.has(M)}}case 20:throw this.h.push({message:h,offset:N.offset,lexeme:"",additionalInfo:c}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,M){if(this.C(N))return this.z();throw this.B(M,this.D())}B(N,M,z){const Z=(0,O.localize)(8,null,N,j.$cj.getLexeme(M)),J=M.offset,x=j.$cj.getLexeme(M);return this.h.push({message:Z,offset:J,lexeme:x,additionalInfo:z}),m.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=m;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(N){return a.create(N)}static equals(N,M){return v.create(N,M)}static notEquals(N,M){return k.create(N,M)}static regex(N,M){return X.create(N,M)}static in(N,M){return y.create(N,M)}static notIn(N,M){return w.create(N,M)}static not(N){return E.create(N)}static and(...N){return K.create(N,null,!0)}static or(...N){return W.create(N,null,!0)}static greater(N,M){return U.create(N,M)}static greaterEquals(N,M){return F.create(N,M)}static smaller(N,M){return T.create(N,M)}static smallerEquals(N,M){return _.create(N,M)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$fj=i;function o(q){const N=new m({regexParsingWithErrorRecovery:!1});return q.map(M=>(N.parse(M),N.lexingErrors.length>0?N.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,O.localize)(9,null,z.additionalInfo):(0,O.localize)(10,null),offset:z.offset,length:z.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function n(q,N){const M=q?q.substituteConstants():void 0,z=N?N.substituteConstants():void 0;return!M&&!z?!0:!M||!z?!1:M.equals(z)}function s(q,N){return q.cmp(N)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return r.INSTANCE}}e.$ij=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return t.INSTANCE}}e.$jj=r;class a{static create(N,M=null){const z=S.get(N);return typeof z=="boolean"?z?r.INSTANCE:t.INSTANCE:new a(N,M)}constructor(N,M){this.key=N,this.c=M,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=S.get(this.key);return typeof N=="boolean"?N?r.INSTANCE:t.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=E.create(this.key,this)),this.c}}e.$kj=a;class v{static create(N,M,z=null){if(typeof M=="boolean")return M?a.create(N,z):E.create(N,z);const Z=S.get(N);return typeof Z=="boolean"?M===(Z?"true":"false")?r.INSTANCE:t.INSTANCE:new v(N,M,z)}constructor(N,M,z){this.c=N,this.d=M,this.f=z,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=S.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?r.INSTANCE:t.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$lj=v;class y{static create(N,M){return new y(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.f),z=N.getValue(this.d);return Array.isArray(M)?M.includes(z):typeof z=="string"&&typeof M=="object"&&M!==null?C.call(M,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$mj=y;class w{static create(N,M){return new w(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=11,this.c=y.create(N,M)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=w;class k{static create(N,M,z=null){if(typeof M=="boolean")return M?E.create(N,z):a.create(N,z);const Z=S.get(N);return typeof Z=="boolean"?M===(Z?"true":"false")?t.INSTANCE:r.INSTANCE:new k(N,M,z)}constructor(N,M,z){this.c=N,this.d=M,this.f=z,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=S.get(this.c);if(typeof N=="boolean"){const M=N?"true":"false";return this.d===M?t.INSTANCE:r.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$oj=k;class E{static create(N,M=null){const z=S.get(N);return typeof z=="boolean"?z?t.INSTANCE:r.INSTANCE:new E(N,M)}constructor(N,M){this.c=N,this.d=M,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:ne(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=S.get(this.c);return typeof N=="boolean"?N?t.INSTANCE:r.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$pj=E;function D(q,N){if(typeof q=="string"){const M=parseFloat(q);isNaN(M)||(q=M)}return typeof q=="string"||typeof q=="number"?N(q):t.INSTANCE}class U{static create(N,M,z=null){return D(M,Z=>new U(N,Z,z))}constructor(N,M,z){this.c=N,this.d=M,this.f=z,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$qj=U;class F{static create(N,M,z=null){return D(M,Z=>new F(N,Z,z))}constructor(N,M,z){this.c=N,this.d=M,this.f=z,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$rj=F;class T{static create(N,M,z=null){return D(M,Z=>new T(N,Z,z))}constructor(N,M,z){this.c=N,this.d=M,this.f=z,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$sj=T;class _{static create(N,M,z=null){return D(M,Z=>new _(N,Z,z))}constructor(N,M,z){this.c=N,this.d=M,this.f=z,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:oe(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$tj=_;class X{static create(N,M){return new X(N,M)}constructor(N,M){this.d=N,this.f=M,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const M=this.f?this.f.source:"",z=N.f?N.f.source:"";return M<z?-1:M>z?1:0}equals(N){if(N.type===this.type){const M=this.f?this.f.source:"",z=N.f?N.f.source:"";return this.d===N.d&&M===z}return!1}substituteConstants(){return this}evaluate(N){const M=N.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$uj=X;class ee{static create(N){return new ee(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new ee(this.c.map(N))}negate(){return this.c}}e.$vj=ee;function H(q){let N=null;for(let M=0,z=q.length;M<z;M++){const Z=q[M].substituteConstants();if(q[M]!==Z&&N===null){N=[];for(let J=0;J<M;J++)N[J]=q[J]}N!==null&&(N[M]=Z)}return N===null?q:N}class K{static create(N,M,z){return K.d(N,M,z)}constructor(N,M){this.expr=N,this.c=M,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const Z=s(this.expr[M],N.expr[M]);if(Z!==0)return Z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=H(this.expr);return N===this.expr?this:K.create(N,this.c,!1)}evaluate(N){for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].evaluate(N))return!1;return!0}static d(N,M,z){const Z=[];let J=!1;for(const x of N)if(x){if(x.type===1){J=!0;continue}if(x.type===0)return t.INSTANCE;if(x.type===6){Z.push(...x.expr);continue}Z.push(x)}if(Z.length===0&&J)return r.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(s);for(let x=1;x<Z.length;x++)Z[x-1].equals(Z[x])&&(Z.splice(x,1),x--);if(Z.length===1)return Z[0];for(;Z.length>1;){const x=Z[Z.length-1];if(x.type!==9)break;Z.pop();const Y=Z.pop(),V=Z.length===0,ie=W.create(x.expr.map(re=>K.create([re,Y],null,z)),null,V);ie&&(Z.push(ie),Z.sort(s))}if(Z.length===1)return Z[0];if(z){for(let x=0;x<Z.length;x++)for(let Y=x+1;Y<Z.length;Y++)if(Z[x].negate().equals(Z[Y]))return t.INSTANCE;if(Z.length===1)return Z[0]}return new K(Z,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new K(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());this.c=W.create(N,this,!0)}return this.c}}e.$wj=K;class W{static create(N,M,z){return W.d(N,M,z)}constructor(N,M){this.expr=N,this.c=M,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const Z=s(this.expr[M],N.expr[M]);if(Z!==0)return Z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(N.expr[M]))return!1;return!0}return!1}substituteConstants(){const N=H(this.expr);return N===this.expr?this:W.create(N,this.c,!1)}evaluate(N){for(let M=0,z=this.expr.length;M<z;M++)if(this.expr[M].evaluate(N))return!0;return!1}static d(N,M,z){let Z=[],J=!1;if(N){for(let x=0,Y=N.length;x<Y;x++){const V=N[x];if(V){if(V.type===0){J=!0;continue}if(V.type===1)return r.INSTANCE;if(V.type===9){Z=Z.concat(V.expr);continue}Z.push(V)}}if(Z.length===0&&J)return t.INSTANCE;Z.sort(s)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let x=1;x<Z.length;x++)Z[x-1].equals(Z[x])&&(Z.splice(x,1),x--);if(Z.length===1)return Z[0];if(z){for(let x=0;x<Z.length;x++)for(let Y=x+1;Y<Z.length;Y++)if(Z[x].negate().equals(Z[Y]))return r.INSTANCE;if(Z.length===1)return Z[0]}return new W(Z,M)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const M of this.expr)N.push(...M.keys());return N}map(N){return new W(this.expr.map(M=>M.map(N)),null)}negate(){if(!this.c){const N=[];for(const M of this.expr)N.push(M.negate());for(;N.length>1;){const M=N.shift(),z=N.shift(),Z=[];for(const J of G(M))for(const x of G(z))Z.push(K.create([J,x],null,!1));N.unshift(W.create(Z,null,!1))}this.c=W.create(N,this,!0)}return this.c}}e.$xj=W;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(N,M,z){super(N,null),this.f=M,typeof z=="object"?B.d.push({...z,key:N}):z!==!0&&B.d.push({key:N,description:z,type:M!=null?typeof M:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return v.create(this.key,N)}notEqualsTo(N){return k.create(this.key,N)}}e.$yj=B,e.$zj=(0,L.$hi)("contextKeyService");function ne(q,N){return q<N?-1:q>N?1:0}function oe(q,N,M,z){return q<M?-1:q>M?1:N<z?-1:N>z?1:0}function te(q,N){if(q.type===0||N.type===1)return!0;if(q.type===9)return N.type===9?ce(q.expr,N.expr):!1;if(N.type===9){for(const M of N.expr)if(te(q,M))return!0;return!1}if(q.type===6){if(N.type===6)return ce(N.expr,q.expr);for(const M of q.expr)if(te(M,N))return!0;return!1}return q.equals(N)}function ce(q,N){let M=0,z=0;for(;M<q.length&&z<N.length;){const Z=q[M].cmp(N[z]);if(Z<0)return!1;Z===0&&M++,z++}return M===q.length}function G(q){return q.type===9?q.expr:[q]}}),define(le[94],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$1m=e.ID=void 0,e.$2m=A,e.ID="diagnosticsService",e.$1m=(0,I.$hi)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}class j{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$3m=j}),define(le[95],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=void 0,e.$vo=(0,I.$hi)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,I.$hi)("environmentService"),e.$pi=(0,I.$ii)(e.$oi)}),define(le[29],he([0,1,155,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=j,e.$Lo=L,e.$Mo=O,e.$No=R,e.$Oo=S,e.$Po=g,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function j(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function O(h,c){switch(h){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(h,c){return c==="web"&&!h.includes("web")}function S(h,c,m){return R(c,m)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===m}function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var P;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var p;(function(h){h.Install="install",h.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$Qo=(0,A.$hi)("extensionGalleryService");var u;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));var b;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class $ extends Error{constructor(c,m){super(c),this.code=m,this.name=m}}e.$Ro=$;var l;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class d extends Error{constructor(c,m){super(c),this.code=m,this.name=m}}e.$So=d,e.$To=(0,A.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,A.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,A.$hi)("IExtensionTipsService"),e.$Yo=(0,I.localize2)(0,"Extensions"),e.$Zo=(0,I.localize2)(1,"Preferences")}),define(le[193],he([0,1,3,2,30,8,91,29]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=void 0;function S($,l){return $?L.URI.revive(l?l.transformIncoming($):$):void 0}function g($,l){return l?l.transformOutgoingURI($):$}function C($,l){l=l||O.$kn;const d=$.manifest;return{...(0,O.$nn)({...$,manifest:void 0},l),manifest:d}}function P($,l){return $?.profileLocation?(0,O.$nn)($,l??O.$kn):$}function p($,l){return l?(0,j.$Pn)($,d=>d instanceof L.URI?l.transformOutgoingURI(d):void 0):$}class f{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=I.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,d){const h=this.b(l);switch(d){case"onInstallExtension":return I.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,h):c.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,c=>c.map(m=>({...m,local:m.local?p(m.local,h):m.local,profileLocation:m.profileLocation?g(m.profileLocation,h):m.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,h):c.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,h):c.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,c=>p(c,h))}throw new Error("Invalid listen")}async call(l,d,h){const c=this.b(l);switch(d){case"zip":{const m=C(h[0],c),i=await this.a.zip(m);return g(i,c)}case"unzip":return this.a.unzip(S(h[0],c));case"install":return this.a.install(S(h[0],c),P(h[1],c));case"installFromLocation":return this.a.installFromLocation(S(h[0],c),S(h[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],S(h[1],c),S(h[2],c));case"getManifest":return this.a.getManifest(S(h[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],P(h[1],c));case"installGalleryExtensions":{const m=h[0];return this.a.installGalleryExtensions(m.map(({extension:i,options:o})=>({extension:i,options:P(o,c)??{}})))}case"uninstall":return this.a.uninstall(C(h[0],c),P(h[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(h[0],c));case"getInstalled":return(await this.a.getInstalled(h[0],S(h[1],c),h[2])).map(i=>p(i,c));case"toggleAppliationScope":{const m=await this.a.toggleAppliationScope(C(h[0],c),S(h[1],c));return p(m,c)}case"copyExtensions":return this.a.copyExtensions(S(h[0],c),S(h[1],c));case"updateMetadata":{const m=await this.a.updateMetadata(C(h[0],c),h[1],S(h[2],c));return p(m,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Zp=f;class u extends A.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new I.$7d),this.f=this.B(new I.$7d),this.g=this.B(new I.$7d),this.h=this.B(new I.$7d),this.j=this.B(new I.$7d),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?L.URI.revive(h.source):h.source,profileLocation:L.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:L.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(C(d,null))))}n(l,d){l.fire(d)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(h=>(0,R.$Oo)(h,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(d=>L.URI.revive(d)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,d){return Promise.resolve(this.m.call("install",[l,d])).then(h=>C(h,null))}installFromLocation(l,d){return Promise.resolve(this.m.call("installFromLocation",[l,d])).then(h=>C(h,null))}async installExtensionsFromProfile(l,d,h){return(await this.m.call("installExtensionsFromProfile",[l,d,h])).map(m=>C(m,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.m.call("installFromGallery",[l,d])).then(h=>C(h,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(h=>({...h,local:h.local?C(h.local,null):h.local,source:this.r(h.source)?L.URI.revive(h.source):h.source,profileLocation:L.URI.revive(h.profileLocation)}))}uninstall(l,d){return Promise.resolve(this.m.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(d=>C(d,null))}getInstalled(l=null,d,h){return Promise.resolve(this.m.call("getInstalled",[l,d,h])).then(c=>c.map(m=>C(m,null)))}updateMetadata(l,d,h){return Promise.resolve(this.m.call("updateMetadata",[l,d,h])).then(c=>C(c,null))}toggleAppliationScope(l,d){return this.m.call("toggleAppliationScope",[l,d]).then(h=>C(h,null))}copyExtensions(l,d){return this.m.call("copyExtensions",[l,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,d,h){const c=await this.m.call("download",[l,d,h]);return L.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$1p=u;class b{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,h){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$2p=b}),define(le[96],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m2b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$l2b=j;var A;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function j(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var L;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$m2b=(0,I.$hi)("IExtensionRecommendationNotificationService")}),define(le[12],he([0,1,49,15,27,13,8,162,4,5,23,53]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=p,e.$Pk=b,e.$Qk=l,e.$Rk=d,e.$Sk=h,e.$Tk=c,e.$Uk=m,e.$Vk=i,e.$Wk=o,e.$Xk=n,e.$Yk=s,e.$1k=a,e.$2k=v,e.$3k=y,e.$4k=w,e.$5k=k,e.$8k=T,e.$hl=W,e.$il=B,e.$kl=oe,e.$Nk=(0,S.$hi)("fileService");function p(te){return te.create===!0}var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var u;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(u||(e.FilePermission=u={}));function b(te){const ce=te;return!!ce&&typeof ce.onDidChange=="function"}var $;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function l(te){return!!(te.capabilities&2)}function d(te){return!!(te.capabilities&8)}function h(te){return!!(te.capabilities&131072)}function c(te){return!!(te.capabilities&4)}function m(te){return!!(te.capabilities&16)}function i(te){return l(te)?!!(te.capabilities&16384):!1}function o(te){return l(te)?!!(te.capabilities&32768):!1}function n(te){return!!(te.capabilities&65536)}function s(te){return!!(te.capabilities&2048)}var t;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ce,G){const q=new r(ce.toString(),G);return y(q,G),q}constructor(ce,G){super(ce),this.code=G}}e.$Zk=r;function a(te,ce){return r.create(te,ce)}function v(te){return te||a((0,R.localize)(0,null),t.Unknown)}function y(te,ce){return te.name=ce?`${ce} (FileSystemError)`:"FileSystemError",te}function w(te){if(!te)return t.Unknown;if(te instanceof r)return te.code;const ce=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ce)return t.Unknown;switch(ce[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}function k(te){if(te instanceof _)return te.fileOperationResult;switch(w(te)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}var E;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class D{constructor(ce,G,q){this.resource=ce,this.operation=G,this.target=q}isOperation(ce){return this.operation===ce}}e.$6k=D;var U;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class F{static{this.a=null}constructor(ce,G){this.c=G,this.b=void 0,this.d=new P.$V(()=>{const q=I.$ni.forUris(()=>this.c);return q.fill(this.rawAdded.map(N=>[N,!0])),q}),this.f=new P.$V(()=>{const q=I.$ni.forUris(()=>this.c);return q.fill(this.rawUpdated.map(N=>[N,!0])),q}),this.g=new P.$V(()=>{const q=I.$ni.forUris(()=>this.c);return q.fill(this.rawDeleted.map(N=>[N,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ce){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==F.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...G){return this.h(ce,{includeChildren:!1},...G)}affects(ce,...G){return this.h(ce,{includeChildren:!0},...G)}h(ce,G,...q){if(!ce)return!1;const N=q.length>0;return!!((!N||q.includes(1))&&(this.d.value.get(ce)||G.includeChildren&&this.d.value.findSuperstr(ce))||(!N||q.includes(0))&&(this.f.value.get(ce)||G.includeChildren&&this.f.value.findSuperstr(ce))||(!N||q.includes(2))&&(this.g.value.findSubstr(ce)||G.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$7k=F;function T(te,ce,G){return!te||!ce||te===ce||ce.length>te.length?!1:(ce.charAt(ce.length-1)!==A.sep&&(ce+=A.sep),G?(0,j.$mf)(te,ce):te.indexOf(ce)===0)}class _ extends Error{constructor(ce,G,q){super(ce),this.fileOperationResult=G,this.options=q}}e.$9k=_;class X extends _{constructor(ce,G,q,N){super(ce,G,N),this.fileOperationResult=G,this.size=q}}e.$0k=X;class ee extends _{constructor(ce,G,q){super(ce,2,q),this.stat=G}}e.$$k=ee;var H;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var K;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$gl="";function W(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function B(te,ce){if(!ce.hasProvider(O.URI.from({scheme:te.scheme})))return new Promise(G=>{const q=ce.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===te.scheme&&N.added&&(q.dispose(),G())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(ce){return(0,L.$Yf)(ce)||(ce=0),ce<ne.KB?(0,R.localize)(1,null,ce.toFixed(0)):ce<ne.MB?(0,R.localize)(2,null,(ce/ne.KB).toFixed(2)):ce<ne.GB?(0,R.localize)(3,null,(ce/ne.MB).toFixed(2)):ce<ne.TB?(0,R.localize)(4,null,(ce/ne.GB).toFixed(2)):(0,R.localize)(5,null,(ce/ne.TB).toFixed(2))}}e.$jl=ne;function oe(te){const ce=typeof te=="string"||te?.scheme===C.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===C.Schemas.file?1024*ne.MB:ce?10*ne.MB:g.$o?50*ne.MB:1024*ne.MB}});var Q=this&&this.__param||function(se,e){return function(I,A){e(I,A,se)}};define(le[194],he([0,1,73,48,12]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;let L=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const P=(0,I.createHash)("sha256");(0,A.$me)(S,{onData:p=>P.update(p.buffer),onError:p=>C(p),onEnd:()=>g(P.digest("base64").replace(/=+$/,""))})})}};e.$1bc=L,e.$1bc=L=ye([Q(0,j.$Nk)],L)}),define(le[97],he([0,1,14,7,163,12]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=O;async function O(C,P,p,f,u,b){let $;try{await R(C,P,p,f,u,b)}catch(l){$=l}finally{$&&u.errorTransformer&&($=u.errorTransformer($)),typeof $<"u"&&p.error($),p.end()}}async function R(C,P,p,f,u,b){S(b);const $=await C.open(P,{create:!1});try{S(b);let l=0,d=0,h=u&&typeof u.length=="number"?u.length:void 0,c=I.$ue.alloc(Math.min(u.bufferSize,typeof h=="number"?h:u.bufferSize)),m=u&&typeof u.position=="number"?u.position:0,i=0;do d=await C.read($,m,c.buffer,i,c.byteLength-i),m+=d,i+=d,l+=d,typeof h=="number"&&(h-=d),i===c.byteLength&&(await p.write(f(c)),c=I.$ue.alloc(Math.min(u.bufferSize,typeof h=="number"?h:u.bufferSize)),i=0);while(d>0&&(typeof h!="number"||h>0)&&S(b)&&g(l,u));if(i>0){let o=i;typeof h=="number"&&(o=Math.min(i,h)),p.write(f(c.slice(0,o)))}}catch(l){throw(0,L.$2k)(l)}finally{await C.close($)}}function S(C){if(C.isCancellationRequested)throw(0,A.$6)();return!0}function g(C,P){if(typeof P?.limits?.size=="number"&&C>P.limits.size)throw(0,L.$1k)((0,j.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[51],he([0,1,90,2,15,5,8,12]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=void 0,e.$uq=S,e.$yq=p,e.$zq=f,e.$Aq=u,e.$Bq=b;function S(l){return l.recursive===!0}class g extends A.$Uc{static{this.a=5}constructor(d,h,c,m){super(),this.h=d,this.j=h,this.m=c,this.n=m,this.c=this.B(new A.$Vc),this.f=void 0,this.g=0}s(){const d=new A.$Tc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(h=>this.h(h))),d.add(this.b.onDidLogMessage(h=>this.j(h))),d.add(this.b.onDidError(h=>this.t(h)))}t(d){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$vq=g;class C extends g{constructor(d,h,c){super(d,h,c,{type:"node.js",restartOnError:!1})}}e.$wq=C;class P extends g{constructor(d,h,c){super(d,h,c,{type:"universal",restartOnError:!0})}}e.$xq=P;function p(l){return l.map(d=>({type:d.type,resource:O.URI.revive(d.resource),cId:d.cId}))}function f(l){const d=new $;for(const h of l)d.processEvent(h);return d.coalesce()}function u(l,d){return typeof d=="string"&&!d.startsWith(I.$0j)&&!(0,j.$jc)(d)?{base:l,pattern:d}:d}function b(l,d){const h=[];for(const c of d)h.push((0,I.$bk)(u(l,c)));return h}class ${constructor(){this.a=new Set,this.b=new Map}c(d){return L.$k?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const h=this.b.get(this.c(d));let c=!1;if(h){const m=h.type,i=d.type;h.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?c=!0:m===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(h)):m===2&&i===1?h.type=0:m===1&&i===0||(h.type=i)}else c=!0;c&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],h=[];return Array.from(this.a).filter(c=>c.type!==2?(d.push(c),!1):!0).sort((c,m)=>c.resource.fsPath.length-m.resource.fsPath.length).filter(c=>h.some(m=>(0,R.$8k)(c.resource.fsPath,m,!L.$k))?!1:(h.push(c.resource.fsPath),!0)).concat(d)}}}),define(le[195],he([0,1,14,38,7,3,2,48,32,12,51]),function(se,e,I,A,j,L,O,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=e.$GP=void 0,e.$GP="localFilesystem";class P extends O.$Uc{constructor(f,u){super(),this.a=f,this.b=u,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$7d),this.onDidWatchError=this.g.event,this.h=(0,S.$Dg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,u){const{buffer:b}=await this.a.call("readFile",[f,u]);return b}readFileStream(f,u,b){const $=(0,R.$ie)(d=>I.$ue.concat(d.map(h=>I.$ue.wrap(h))).buffer),l=new O.$Tc;return l.add(this.a.listen("readFileStream",[f,u])(d=>{if(d instanceof I.$ue)$.write(d.buffer);else{if(d==="end")$.end();else{let h;if(d instanceof Error)h=d;else{const c=d;h=(0,g.$1k)(c.message??(0,A.$5i)(c),c.code??g.FileSystemProviderErrorCode.Unknown)}$.error(h),$.end()}l.dispose()}})),l.add(b.onCancellationRequested(()=>{$.error((0,j.$6)()),$.end(),l.dispose()})),$}writeFile(f,u,b){return this.a.call("writeFile",[f,I.$ue.wrap(u),b])}open(f,u){return this.a.call("open",[f,u])}close(f){return this.a.call("close",[f])}async read(f,u,b,$,l){const[d,h]=await this.a.call("read",[f,u,l]);return b.set(d.buffer.slice(0,h),$),h}write(f,u,b,$,l){return this.a.call("write",[f,u,I.$ue.wrap(b),$,l])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,u){return this.a.call("delete",[f,u])}rename(f,u,b){return this.a.call("rename",[f,u,b])}copy(f,u,b){return this.a.call("copy",[f,u,b])}cloneFile(f,u){return this.a.call("cloneFile",[f,u])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const u=f;this.f.fire((0,C.$yq)(u))}else{const u=f;this.g.fire(u)}}))}watch(f,u){const b=(0,S.$Dg)();return this.a.call("watch",[this.h,b,f,u]),(0,O.$Sc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$HP=P}),define(le[196],he([0,1,43,6,26,50,2,87,15,5,20,8,146,31,51]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0,e.$Qq=$;class b extends O.$Uc{static{this.a=100}static{this.b=75}constructor(d,h,c,m){super(),this.m=d,this.n=h,this.r=c,this.s=m,this.c=this.B(new A.$wh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$vh(i=>this.z(i),b.b)),this.g=(0,u.$Bq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,u.$Bq)(this.m.path,this.m.includes):void 0,this.j=new j.$ee,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await f.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await f.Promises.realpath(d.path),d.path===h&&(h=await(0,p.$Mq)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(g.$j&&(0,L.$hg)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Uc.None;const c=new j.$ee(this.j.token),m=new O.$Tc;try{const i=P.URI.file(this.m.path),o=(0,S.$oc)(d),n=(0,I.watch)(d);m.add((0,O.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${d}'`);const s=new Set;if(h)try{for(const r of await f.Promises.readdir(d))s.add(r)}catch(r){this.D(r)}const t=new Map;m.add((0,O.$Sc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$j&&(v=(0,R.$Yl)(v))),!(!v||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){t.get(v)?.dispose();const y=setTimeout(async()=>{if(t.delete(v),v===o&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const w=await this.C((0,S.$kc)(d,v));if(c.token.isCancellationRequested)return;let k;w?s.has(v)?k=0:(k=1,s.add(v)):(s.delete(v),k=2),this.y({resource:(0,C.$Ug)(i,v),type:k,cId:this.m.correlationId})},b.a);t.set(v,(0,O.$Sc)(()=>clearTimeout(y)))}else{let y;s.has(v)?y=0:(y=1,s.add(v)),this.y({resource:(0,C.$Ug)(i,v),type:y,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const y=setTimeout(async()=>{const w=await f.Promises.exists(d);c.token.isCancellationRequested||(w?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),m.add(await this.w(d,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);m.clear(),m.add((0,O.$Sc)(()=>clearTimeout(y)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(d)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${i.toString()})`)}return(0,O.$Sc)(()=>{c.dispose(!0),m.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!h&&this.g.some(c=>c(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(c=>c(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const h=(0,u.$zq)(d);if(h.length>0){if(this.s)for(const m of h)this.G(` >> normalized ${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(g.$k)return f.Promises.exists(d);try{const h=(0,S.$oc)(d);return(await f.Promises.readdir((0,S.$nc)(d))).some(m=>m===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Pq=b;async function $(l,d,h,c,m=512){const i=await f.Promises.open(l,"r"),o=Buffer.allocUnsafe(m),n=new j.$ee(c);let s,t=!1;const r={path:l,excludes:[],recursive:!1},a=new b(r,v=>{(async()=>{for(const{type:y}of v)if(y===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:w}=await f.Promises.read(i,o,0,m,null);if(!w||n.token.isCancellationRequested)break;d(o.slice(0,w))}}catch(w){s=new Error(w),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,h(),new Promise((v,y)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await f.Promises.close(i)}catch(w){s=new Error(w)}s?y(s):v()})})}}),define(le[197],he([0,1,3,90,189,5,196]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class R extends j.$Kq{constructor(){super(...arguments),this.onDidError=I.Event.None,this.y=new Map,this.z=!1}async t(g){const C=this.G(g),P=C.filter(f=>{const u=this.y.get(f.path);return u?!(0,A.$fk)(u.request.excludes,f.excludes)||!(0,A.$fk)(u.request.includes,f.includes):!0}),p=Array.from(this.y.values()).filter(({request:f})=>!C.find(u=>u.path===f.path&&(0,A.$fk)(u.excludes,f.excludes)&&(0,A.$fk)(u.includes,f.includes))).map(({request:f})=>f.path);P.length&&this.u(`Request to start watching: ${P.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),p.length&&this.u(`Request to stop watching: ${p.join(",")}`);for(const f of p)this.F(f);for(const f of P)this.D(f)}D(g){const C=new O.$Pq(g,p=>this.a.fire(p),p=>this.b.fire(p),this.z),P={request:g,instance:C};this.y.set(g.path,P)}async stop(){await super.stop();for(const[g]of this.y)this.F(g);this.y.clear()}F(g){const C=this.y.get(g);C&&(this.y.delete(g),C.instance.dispose())}G(g){const C=new Map;for(const P of g){const p=L.$k?P.path:P.path.toLowerCase();let f=C.get(P.correlationId);f||(f=new Map,C.set(P.correlationId,f)),f.set(p,P)}return Array.from(C.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(g){this.z=g;for(const[,C]of this.y)C.instance.setVerboseLogging(g)}u(g){this.z&&this.b.fire({type:"trace",message:this.J(g)})}w(g){this.z&&this.b.fire({type:"warn",message:this.J(g)})}J(g){return`[File Watcher (node.js)] ${g}`}}e.$Rq=R}),define(le[198],he([0,1,51,197]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class j extends I.$wq{constructor(O,R,S){super(O,R,S),this.s()}r(O){return O.add(new A.$Rq)}}e.$Sq=j}),define(le[199],he([0,1,23,40,92,51]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class O extends L.$xq{constructor(S,g,C){super(S,g,C),this.s()}r(S){const g=S.add(new j.$Iq(I.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(g.onDidProcessExit(({code:C,signal:P})=>this.t(`terminated by itself with code ${C}, signal: ${P}`))),A.ProxyChannel.toService((0,A.$1h)(g.getChannel("watcher")))}}e.$Jq=O}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class I{constructor(...j){this.a=new Map;for(const[L,O]of j)this.set(L,O)}set(j,L){const O=this.a.get(j);return this.a.set(j,L),O}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$fi=I}),define(le[200],he([0,1,6,7,2,72,191,4,74,86]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;const C=!1;class P extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class p{constructor($=new S.$fi,l=!1,d,h=C){this.f=$,this.g=l,this.h=d,this.i=h,this.o=new Set,this.f.set(R.$gi,this),this._globalGraph=h?d?._globalGraph??new O.$Vq(c=>c):void 0}createChild($){return new p($,this.g,this,this.i)}invokeFunction($,...l){const d=u.traceInvocation(this.i,$);let h=!1;try{return $({get:m=>{if(h)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(m,d);if(!i)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...l)}finally{h=!0,d.stop()}}createInstance($,...l){let d,h;return $ instanceof L.$ei?(d=u.traceCreation(this.i,$.ctor),h=this.j($.ctor,$.staticArguments.concat(l),d)):(d=u.traceCreation(this.i,$),h=this.j($,l,d)),d.stop(),h}j($,l=[],d){const h=R._util.getServiceDependencies($).sort((i,o)=>i.index-o.index),c=[];for(const i of h){const o=this.m(i.id,d);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const m=h.length>0?h[0].index:l.length;if(l.length!==m){console.trace(`[createInstance] First service dependency of ${$.name} at position ${m+1} conflicts with ${l.length} static arguments`);const i=m-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,m)}return Reflect.construct($,l.concat(c))}k($,l){if(this.f.get($)instanceof L.$ei)this.f.set($,l);else if(this.h)this.h.k($,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const l=this.f.get($);return!l&&this.h?this.h.l($):l}m($,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const d=this.l($);return d instanceof L.$ei?this.q($,d,l.branch($,!0)):(l.branch($,!1),d)}q($,l,d){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,l,d)}finally{this.o.delete($)}}r($,l,d){const h=new O.$Vq(i=>i.id.toString());let c=0;const m=[{id:$,desc:l,_trace:d}];for(;m.length;){const i=m.pop();if(h.lookupOrInsertNode(i),c++>1e3)throw new P(h);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof L.$ei){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};h.insertEdge(i,s),m.push(s)}}}for(;;){const i=h.roots();if(i.length===0){if(!h.isEmpty())throw new P(h);break}for(const{data:o}of i){if(this.l(o.id)instanceof L.$ei){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}h.removeNode(o)}}return this.l($)}s($,l,d=[],h,c){if(this.f.get($)instanceof L.$ei)return this.t($,l,d,h,c);if(this.h)return this.h.s($,l,d,h,c);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t($,l,d=[],h,c){if(h){const m=new p(void 0,this.g,this,this.i);m.c=String($);const i=new Map,o=new I.$Ah(()=>{const n=m.j(l,d,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$5c,i.set(s,a)),(y,w,k)=>{if(o.isInitialized)return o.value[s](y,w,k);{const E={listener:[y,w,k],disposable:void 0},D=a.push(E);return(0,j.$Sc)(()=>{D(),E.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,d,c)}u($,l){if(l&&console.warn($),this.g)throw new Error($)}}e.$Wq=p;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class u{static{this.all=new Set}static{this.c=new class extends u{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,l){return $?new u(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u.c}static traceCreation($,l){return $?new u(1,l.name):u.c}static{this.f=0}constructor($,l){this.type=$,this.name=l,this.g=Date.now(),this.h=[]}branch($,l){const d=new u(3,$.toString());return this.h.push([$,l,d]),d}stop(){const $=Date.now()-this.g;u.f+=$;let l=!1;function d(c,m){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of m.h)if(s&&t){l=!0,i.push(`${o}CREATES -> ${n}`);const r=d(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${u.f.toFixed(2)}ms)`];($>2||l)&&u.all.add(h.join(`
`))}}e.$Xq=u}),define(le[56],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=void 0,e.$vbc=(0,I.$hi)("mainProcessService");class A{constructor(L,O){this.a=L,this.b=O}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,O){this.a.registerChannel(L,O)}}e.$wbc=A}),define(le[75],he([0,1,26,2,5,165,29,4]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0,e.$yr=S;function S(C){return C.tags.find(P=>P.startsWith("lp-"))?.split("lp-")[1]}e.$zr=(0,R.$hi)("languagePackService");let g=class extends A.$Uc{constructor(P){super(),this.c=P}async getAvailableLanguages(){const P=new I.$ee;setTimeout(()=>P.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},P.token)}catch{return[]}const u=p.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some($=>$.startsWith("lp-"))).map(b=>{const $=b.properties.localizedLanguages?.[0],l=S(b);return{...this.f(l,$,b),extensionId:b.identifier.id,galleryExtension:b}});return u.push(this.f("en","English")),u}f(P,p,f){const u=p??P;let b;if(u!==P&&(b=`(${P})`),P.toLowerCase()===j.$w.toLowerCase()&&(b??="",b+=(0,L.localize)(0,null)),f?.installCount){b??="";const $=f.installCount;let l;$>1e6?l=`${Math.floor($/1e5)/10}M`:$>1e3?l=`${Math.floor($/1e3)}K`:l=String($),b+=` $(cloud-download) ${l}`}return{id:P,label:u,description:b}}};e.$Ar=g,e.$Ar=g=ye([Q(0,O.$Qo)],g)}),define(le[201],he([0,1,2,75]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;let j=class extends I.$Uc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$Wbc=j,e.$Wbc=j=ye([Q(0,A.$zr)],j)}),define(le[9],he([0,1,166,38,3,54,2,35,5,20,13,8,93,4]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=b,e.log=l,e.$2j=a,e.$3j=v,e.$4j=y,e.$5j=w,e.$Nj=(0,f.$hi)("logService"),e.$Oj=(0,f.$hi)("loggerService");function u(){return new Date().toISOString()}function b(k){return(0,C.$Yf)(k)}var $;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})($||(e.LogLevel=$={})),e.$Qj=$.Info;function l(k,E,D){switch(E){case $.Trace:k.trace(D);break;case $.Debug:k.debug(D);break;case $.Info:k.info(D);break;case $.Warning:k.warn(D);break;case $.Error:k.error(D);break;case $.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function d(k,E=!1){let D="";for(let U=0;U<k.length;U++){let F=k[U];if(F instanceof Error&&(F=(0,A.$5i)(F,E)),typeof F=="object")try{F=JSON.stringify(F)}catch{}D+=(U>0?" ":"")+F}return D}class h extends O.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new j.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==$.Off&&this.b<=E}}e.$Sj=h;class c extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...D){this.f($.Trace)&&this.g($.Trace,d([E,...D],!0))}debug(E,...D){this.f($.Debug)&&this.g($.Debug,d([E,...D]))}info(E,...D){this.f($.Info)&&this.g($.Info,d([E,...D]))}warn(E,...D){this.f($.Warning)&&this.g($.Warning,d([E,...D]))}error(E,...D){if(this.f($.Error))if(E instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=E.stack,this.g($.Error,d(U))}else this.g($.Error,d([E,...D]))}flush(){}}e.$Tj=c;class m extends h{constructor(E=e.$Qj){super(),this.setLevel(E),this.g=!S.$i}trace(E,...D){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...D):console.log(`[main ${u()}]`,E,...D))}debug(E,...D){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...D):console.log(`[main ${u()}]`,E,...D))}info(E,...D){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...D):console.log(`[main ${u()}]`,E,...D))}warn(E,...D){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...D):console.warn(`[main ${u()}]`,E,...D))}error(E,...D){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...D):console.error(`[main ${u()}]`,E,...D))}flush(){}}e.$Uj=m;class i extends h{constructor(E=e.$Qj,D=!0){super(),this.g=D,this.setLevel(E)}trace(E,...D){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...D):console.log(E,...D))}debug(E,...D){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...D):console.log(E,...D))}info(E,...D){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...D):console.log(E,...D))}warn(E,...D){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...D):console.log(E,...D))}error(E,...D){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...D):console.error(E,...D))}flush(){}}e.$Vj=i;class o extends h{constructor(E,D=e.$Qj){super(),this.g=E,this.setLevel(D)}trace(E,...D){this.f($.Trace)&&this.g.log($.Trace,[this.h(E),...D])}debug(E,...D){this.f($.Debug)&&this.g.log($.Debug,[this.h(E),...D])}info(E,...D){this.f($.Info)&&this.g.log($.Info,[this.h(E),...D])}warn(E,...D){this.f($.Warning)&&this.g.log($.Warning,[this.h(E),...D])}error(E,...D){this.f($.Error)&&this.g.log($.Error,[this.h(E),...D])}h(E){return typeof E=="string"?E:(0,A.$5i)(E,this.f($.Trace))}flush(){}}e.$Wj=o;class n extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const D of this.g)D.setLevel(E);super.setLevel(E)}trace(E,...D){for(const U of this.g)U.trace(E,...D)}debug(E,...D){for(const U of this.g)U.debug(E,...D)}info(E,...D){for(const U of this.g)U.info(E,...D)}warn(E,...D){for(const U of this.g)U.warn(E,...D)}error(E,...D){for(const U of this.g)U.error(E,...D)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$Xj=n;class s extends O.$Uc{constructor(E,D,U){if(super(),this.h=E,this.j=D,this.b=new R.$Bc,this.c=this.B(new j.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$7d),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(E){return(0,C.$Uf)(E)?[...this.b.values()].find(D=>D.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,D){const U=this.n(E),F=(0,C.$Uf)(E)?E:D?.id??(0,L.$8i)(U.toString()).toString(16);let T=this.b.get(U)?.logger;const _=D?.logLevel==="always"?$.Trace:D?.logLevel;T||(T=this.s(U,_??this.getLogLevel(U)??this.h,{...D,id:F}));const X={logger:T,info:{resource:U,id:F,logLevel:_,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(X.info),this.b.set(U,X),T}n(E){return(0,C.$Uf)(E)?(0,g.$Ug)(this.j,`${E}.log`):E}setLogLevel(E,D){if(P.URI.isUri(E)){const U=E,F=D,T=this.b.get(U);T&&F!==T.info.logLevel&&(T.info.logLevel=F===this.h?void 0:F,T.logger?.setLevel(F),this.b.set(T.info.resource,T),this.f.fire([U,F]))}else{this.h=E;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,D){const U=this.m(E);U&&D!==!U.info.hidden&&(U.info.hidden=!D,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,D]))}getLogLevel(E){let D;return E&&(D=this.b.get(E)?.info.logLevel),D??this.h}registerLogger(E){const D=this.b.get(E.resource);D?D.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const D=this.b.get(E);D&&(D.logger&&D.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=s;class t{constructor(){this.onDidChangeLogLevel=new j.$7d().event}setLevel(E){}getLevel(){return $.Info}trace(E,...D){}debug(E,...D){}info(E,...D){}warn(E,...D){}error(E,...D){}critical(E,...D){}dispose(){}flush(){}}e.$Zj=t;class r extends t{}e.$1j=r;function a(k){if(k.verbose)return $.Trace;if(typeof k.logLevel=="string"){const E=w(k.logLevel.toLowerCase());if(E!==void 0)return E}return e.$Qj}function v(k){switch(k){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}function y(k){switch(k){case $.Trace:return{original:"Trace",value:I.localize(0,null)};case $.Debug:return{original:"Debug",value:I.localize(1,null)};case $.Info:return{original:"Info",value:I.localize(2,null)};case $.Warning:return{original:"Warning",value:I.localize(3,null)};case $.Error:return{original:"Error",value:I.localize(4,null)};case $.Off:return{original:"Off",value:I.localize(5,null)}}}function w(k){switch(k){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$6j=new p.$yj("logLevel",v($.Info))}),define(le[202],he([0,1,6,7,2,23,15,20,31,16,9]),function(se,e,I,A,j,L,O,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;let P=class extends j.$Uc{constructor(f,u){super(),this.a=f,this.b=u,this.B(new I.$th(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const f=(0,R.$Rg)(this.a.logsHome),u=(0,R.$Tg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,l=(await S.Promises.readdir(u)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==f),d=l.slice(0,Math.max(0,l.length-9));d.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(h=>S.Promises.rm((0,O.$kc)(u,h)))))}catch(f){(0,A.$1)(f)}}};e.$Xbc=P,e.$Xbc=P=ye([Q(0,g.$oi),Q(1,C.$Nj)],P)}),define(le[98],he([0,1,7,4,9]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Wp=(0,A.$hi)("IExtensionSignatureVerificationService");let L=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,S)=>se(["@vscode/vsce-sign"],async g=>R(g),S))),this.a}async verify(R,S,g){let C;try{C=await this.c()}catch(P){return this.b.error("Could not load vsce-sign module",(0,I.$0)(P)),!1}return C.verify(R,S,g)}};e.$Xp=L,e.$Xp=L=ye([Q(0,j.$Nj)],L)}),define(le[203],he([0,1,17,6,7,3,2,15,51,9]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class C extends O.$Uc{constructor(p,f){super(),this.a=p,this.b=f,this.c=this.B(new L.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$fh(0)),this.w=[],this.y=this.B(new A.$fh(0))}watch(p,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(p,f):this.z(p,f)}n(p,f){const u={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},b=(0,I.$Ub)(this.j,u);return this.r(),(0,O.$Sc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,j.$1)(p))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,S.$yq)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const f of this.j)(0,S.$uq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const f of this.j)(0,S.$uq)(f)&&p.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,f){const u={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},b=(0,I.$Ub)(this.w,u);return this.C(),(0,O.$Sc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,j.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,S.$yq)(p)),p=>this.G(p),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,R.$ic)(p.fsPath)}}e.$Cq=C}),define(le[204],he([0,1,17,6,14,26,3,54,61,2,49,23,99,20,48,161,12,97,9,7]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let m=class extends g.$Uc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$7d),this.Y=this.B(new O.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$qh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${o}`);const s=new g.$Tc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new $.$7k(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Pc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await A.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return S.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,f.$Yg)(o))throw new $.$9k((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new h.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,$.$Tk)(n)||(0,$.$Qk)(n)||(0,$.$Uk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,$.$Tk)(n)||(0,$.$Qk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,$.$4k)(s)===$.FileSystemProviderErrorCode.FileNotFound?new $.$9k((0,b.localize)(2,null,this.sb(o)),1):(0,$.$2k)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,y=await s.stat(o);let w;return this.t(s,o,y,void 0,!!v,(k,E)=>(w||(w=C.$ni.forUris(()=>!t),w.set(o,!0),r&&w.fill(!0,r)),w.get(k.resource)||w.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?E===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:v}=this.R(o),y={resource:n,name:v.basename(n),isFile:(s.type&$.FileType.File)!==0,isDirectory:(s.type&$.FileType.Directory)!==0,isSymbolicLink:(s.type&$.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&$.FilePermission.Locked),etag:(0,$.$hl)({mtime:s.mtime,size:s.size}),children:void 0};if(y.isDirectory&&a(y,t)){try{const w=await o.readdir(n),k=await A.Promises.settled(w.map(async([E,D])=>{try{const U=v.joinPath(n,E),F=r?await o.stat(U):{type:D};return await this.t(o,U,F,w.length,r,a)}catch(U){return this.b.trace(U),null}}));y.children=(0,I.$Hb)(k)}catch(w){this.b.trace(w),y.children=[]}return y}return y}async resolveAll(o){return A.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new $.$9k((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=j.$ue.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new $.$6k(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,$.$Wk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...s,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let y;if((0,$.$Qk)(t)&&!(n instanceof j.$ue))if((0,u.$ge)(n)){const w=await(0,u.$ne)(n,3);w.ended?y=j.$ue.concat(w.buffer):y=w}else y=(0,u.$ke)(n,w=>j.$ue.concat(w),3);else y=n;!(0,$.$Tk)(t)||(0,$.$Qk)(t)&&y instanceof j.$ue||(0,$.$Qk)(t)&&(0,$.$Wk)(t)&&a?.atomic?await this.hb(t,o,a,y):await this.db(t,o,a,y instanceof j.$ue?(0,j.$Fe)(y):y),this.r.fire(new $.$6k(o,4))}catch(v){throw new $.$9k((0,b.localize)(4,null,this.sb(o),(0,$.$2k)(v).toString()),(0,$.$5k)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&$.FileType.Directory)throw new $.$9k((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==$.$gl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,$.$hl)({mtime:s.mtime,size:a.size}))throw new $.$9k((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const v=await this.C(o,n,s,t);r(v)}catch(v){a(v)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,j.$Ge)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new L.$ee(t);let a=s;(0,$.$Vk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const v=this.J(n,a).then(w=>w,w=>{throw r.dispose(!0),w});let y;try{return typeof a?.etag=="string"&&a.etag!==$.$gl&&await v,a?.atomic&&(0,$.$Vk)(o)||!((0,$.$Tk)(o)||(0,$.$Uk)(o))||(0,$.$Qk)(o)&&a?.preferUnbuffered?y=this.I(o,n,a):(0,$.$Uk)(o)?y=this.G(o,n,r.token,a):y=this.H(o,n,r.token,a),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await v,value:y}}catch(w){throw y&&await(0,u.$le)(y),this.F(w,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,$.$2k)(o).toString());return o instanceof $.$$k?new $.$$k(t,o.stat,s):o instanceof $.$0k?new $.$0k(t,o.fileOperationResult,o.size,o.options):new $.$9k(t,(0,$.$5k)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,u.$re)(r,{data:a=>a instanceof j.$ue?a:j.$ue.wrap(a),error:a=>this.F(a,n,t)},a=>j.$ue.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,j.$Ke)();return(0,l.$sq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,u.$ie)(r=>j.$ue.concat(r));return(async()=>{try{let r;s?.atomic&&(0,$.$Vk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(j.$ue.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new $.$9k((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==$.$gl&&n.etag===s.etag)throw new $.$$k((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new $.$0k((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new $.$6k(o,a==="move"?2:3,v)),v}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new $.$6k(o,a==="copy"?3:2,v)),v}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:y}=await this.Q(o,n,s,t,r,a);if(v&&!y&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,$.$Rk)(o))await o.copy(n,t,{overwrite:a});else{const w=await this.resolve(n);w.isDirectory?await this.P(o,w,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,$.$Tk)(o)&&(0,$.$Tk)(s))return this.jb(o,n,s,t);if((0,$.$Tk)(o)&&(0,$.$Qk)(s))return this.pb(o,n,s,t);if((0,$.$Qk)(o)&&(0,$.$Tk)(s))return this.nb(o,n,s,t);if((0,$.$Qk)(o)&&(0,$.$Qk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let v=!1;if(o===s){const{providerExtUri:w,isPathCaseSensitive:k}=this.R(o);if(k||(v=w.isEqual(n,t)),v&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&w.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const y=await this.exists(t);if(y&&!v){if(!a)throw new $.$9k((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?f.$Kg:f.$Mg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$6k(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&$.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,$.$4k)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,$.$4k)(a)!==$.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new $.$9k((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,$.$Xk)(s)&&!t?.atomic){const y=s.enforceAtomicDelete?.(o);y&&(t={...n,atomic:y})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new $.$6k(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,$.$Sk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,$.$Rk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Tc;let t=!1,r=()=>{t=!0};s.add((0,g.$Sc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,g.$Pc)(v):r=()=>(0,g.$Pc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=s.add(new O.$7d);return s.add(this.X.event(w=>{w.correlates(a)&&v.fire(w)})),{onDidChange:v.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$8i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Sc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Pc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Pc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,u.$ge)(t)||(0,u.$he)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,$.$2k)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,u.$he)(s)){if(s.buffer.length>0){const a=j.$ue.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,v)=>{(0,u.$me)(r,{onData:async y=>{r.pause();try{await this.gb(o,n,y,y.byteLength,t,0)}catch(w){return v(w)}t+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>v(y),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let v=0;for(;v<t;){const y=await o.write(n,r+v,s.buffer,a+v,t-v);v+=y}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof j.$ue?r=t:(0,u.$ge)(t)?r=await(0,j.$Ge)(t):(0,u.$he)(t)?r=await(0,j.$He)(t):r=(0,j.$Ee)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const v=j.$ue.alloc(this.a);let y=0,w=0,k=0;do k=await o.read(r,y,v.buffer,w,v.byteLength-w),await this.gb(s,a,v,k,y,w),y+=k,w+=k,w===v.byteLength&&(w=0);while(k>0)}catch(v){throw(0,$.$2k)(v)}finally{await A.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,j.$ue.wrap(a),a.byteLength,0,0)}catch(a){throw(0,$.$2k)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,j.$Ge)(this.H(o,n,L.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new $.$9k((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&$.FilePermission.Readonly)throw new $.$9k((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===P.Schemas.file?o.fsPath:o.toString(!0)}};e.$tq=m,e.$tq=m=c=ye([Q(0,d.$Nj)],m)}),define(le[205],he([0,1,43,276,6,35,14,3,50,2,15,5,20,48,31,164,12,97,203,38,199,198]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0,(()=>{try{(0,A.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$5i)(o)}`)}})();class i extends d.$Cq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new L.$Bc(t=>p.$Lg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await u.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:$.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await u.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,p.$Ug)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=$.FileType.Unknown:n.isFile()?t=$.FileType.File:n.isDirectory()?t=$.FileType.Directory:t=$.FileType.Unknown,s&&(t|=$.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new j.$gh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await u.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,f.$ie)(a=>O.$ue.concat(a.map(v=>O.$ue.wrap(v))).buffer);return(0,l.$sq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,p.$Ug)((0,p.$Tg)(n),`${(0,p.$Rg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await u.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Tc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(v){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await u.Promises.exists(v)){if(!t.overwrite)throw(0,$.$1k)((0,b.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,$.$1k)((0,b.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,$.$Ok)(s)&&!t&&(a=await this.O(n));let v;try{if((0,$.$Ok)(s)&&s.unlock)try{const{stat:w}=await u.SymlinkSupport.stat(r);w.mode&128||await u.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let y;if((0,$.$Ok)(s)){if(P.$i)try{await u.Promises.truncate(r,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}y||(y="w")}else y="r";v=await u.Promises.open(r,y)}catch(y){throw a?.dispose(),(0,$.$Ok)(s)?await this.gb(n,y):this.fb(y)}if(this.U.set(v,0),(0,$.$Ok)(s)&&this.X.set(v,n),a){const y=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),y.dispose())}return v}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await u.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await u.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const v=this.Z(n,s);let y=null;try{y=(await u.Promises.read(n,t,r,a,v)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(n,v,y)}return y}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,j.$Bh)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const v=this.Z(n,s);let y=null;try{y=(await u.Promises.write(n,t,r,a,v)).bytesWritten}catch(w){throw await this.gb(this.X.get(n),w)}finally{this.$(n,v,y)}return y}async mkdir(n){try{await u.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$kc)((0,C.$nc)(t),`${(0,C.$oc)(t)}${s.atomic.postfix}`)),await u.Promises.rm(t,u.RimRafMode.MOVE,r)}else try{await u.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:y}=await u.SymlinkSupport.stat(t);a=v.isDirectory()&&!y}catch{}if(a)await u.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await u.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,b.localize)(2,null,(0,C.$oc)(r),(0,C.$oc)((0,C.$nc)(a)),v.toString()))),this.fb(v)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await u.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,b.localize)(3,null,(0,C.$oc)(r),(0,C.$oc)((0,C.$nc)(a)),v.toString()))),this.fb(v)}}async bb(n,s,t,r){const a=this.H(n),v=this.H(s);let y=!1;if(!!(this.capabilities&1024)||(y=(0,S.$gg)(a,v,!0)),y){if(t==="copy")throw(0,$.$1k)((0,b.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const k=await this.L(n);if(!k)throw(0,$.$1k)((0,b.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const E=await this.L(s);if(E){if(!r)throw(0,$.$1k)((0,b.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);k.type&$.FileType.File&&E.type&$.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),v=!!(this.capabilities&1024);if((0,S.$gg)(r,a,!v))return;const y=new g.$Tc;try{y.add(await this.O(n)),y.add(await this.O(s)),t&&await u.Promises.mkdir((0,C.$nc)(a),{recursive:!0}),await u.Promises.copyFile(r,a)}catch(w){if(w.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(w)}finally{y.dispose()}}t(n,s,t){return new c.$Jq(r=>n(r),r=>s(r),t)}F(n,s,t){return new m.$Sq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof $.$Zk)return n;let s=n,t;switch(n.code){case"ENOENT":t=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=$.FileSystemProviderErrorCode.Unknown;break;default:t=$.FileSystemProviderErrorCode.Unknown}return(0,$.$1k)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await u.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,$.$1k)(s,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Tq=i}),define(le[100],he([0,1,3,2,4,9]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=void 0,e.$kcc=(0,j.$hi)("sharedProcessLifecycleService");let O=class extends A.$Uc{constructor(S){super(),this.b=S,this.a=this.B(new I.$7d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$lcc=O,e.$lcc=O=ye([Q(0,L.$Nj)],O)}),define(le[206],he([0,1,8,3,9,2]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=void 0;class O extends j.$Yj{constructor(P,p,f,u,b){super(p,f,u),this.r=P,this.t=b,this.B(b.listen("onDidChangeLogLevel",P)($=>{(0,j.$Pj)($)?super.setLogLevel($):super.setLogLevel(I.URI.revive($[0]),$[1])})),this.B(b.listen("onDidChangeVisibility",P)(([$,l])=>super.setVisibility(I.URI.revive($),l))),this.B(b.listen("onDidChangeLoggers",P)(({added:$,removed:l})=>{for(const d of $)super.registerLogger({...d,resource:I.URI.revive(d.resource)});for(const d of l)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new j.$Wj({log:(P,p)=>{this.t.call("consoleLog",[P,p])}})}registerLogger(P){super.registerLogger(P),this.t.call("registerLogger",[P,this.r])}deregisterLogger(P){super.deregisterLogger(P),this.t.call("deregisterLogger",[P,this.r])}setLogLevel(P,p){super.setLogLevel(P,p),this.t.call("setLogLevel",[P,p])}setVisibility(P,p){super.setVisibility(P,p),this.t.call("setVisibility",[this.n(P),p])}s(P,p,f){return new R(this.t,P,p,f,this.r)}static setLogLevel(P,p,f){return P.call("setLogLevel",[p,f])}}e.$Sr=O;class R extends j.$Tj{constructor(P,p,f,u,b){super(u?.logLevel==="always"),this.r=P,this.s=p,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[p,u,b]).then(()=>{this.u(this.n),this.m=!0})}g(P,p){const f=[[P,p]];this.m?this.u(f):this.n.push(...f)}u(P){this.r.call("log",[this.s,P])}}class S{constructor(P,p){this.a=P,this.b=p}listen(P,p){const f=this.b(P);switch(p){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,u=>({added:[...u.added].map(b=>this.c(b,f)),removed:[...u.removed].map(b=>this.c(b,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,u=>[f.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,u=>(0,j.$Pj)(u)?u:[f.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${p}`)}async call(P,p,f){const u=this.b(P);switch(p){case"setLogLevel":return(0,j.$Pj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(I.URI.revive(u.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,u)))}throw new Error(`Call not found: ${p}`)}c(P,p){return{...P,resource:p.transformOutgoingURI(P.resource)}}}e.$Tr=S;class g extends L.$Uc{constructor(P,p){super(),p.call("setLogLevel",[P.getLogLevel()]),this.B(P.onDidChangeLogLevel(f=>p.call("setLogLevel",[f]))),p.call("getRegisteredLoggers").then(f=>{for(const u of f)P.registerLogger({...u,resource:I.URI.revive(u.resource)})}),this.B(p.listen("onDidChangeVisibility")(([f,u])=>P.setVisibility(I.URI.revive(f),u))),this.B(p.listen("onDidChangeLoggers")(({added:f,removed:u})=>{for(const b of f)P.registerLogger({...b,resource:I.URI.revive(b.resource)});for(const b of u)P.deregisterLogger(b.resource)}))}}e.$Ur=g}),define(le[207],he([0,1,2,9]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;class j extends I.$Uc{constructor(O,R=[]){super(),this.a=new A.$Xj([O,...R]),this.B(O.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$YP=j}),define(le[57],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0,e.$gac=(0,I.$hi)("nativeHostService")}),define(le[208],he([0,1,40,56]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;let j=class{constructor(O,R){return this.windowId=O,I.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const S=new Map;return S.set("windowId",O),S})()})}};e.$Bbc=j,e.$Bbc=j=ye([Q(1,A.$vbc)],j)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=e.$2n=void 0,e.$2n=(0,L.$hi)("policy");class O extends j.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),A.Iterable.reduce(this.g.entries(),(P,[p,f])=>({...P,[p]:f}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(g,[C,P])=>({...g,[C]:{definition:P,value:this.g.get(C)}}),{})}}e.$3n=O;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$4n=R}),define(le[209],he([0,1,3,2,58]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0;class L{constructor(S){this.b=S,this.a=new A.$Tc}listen(S,g){switch(g){case"onDidChange":return I.Event.map(this.b.onDidChange,C=>C.reduce((P,p)=>({...P,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(S,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$4ac=L;class O extends j.$3n{constructor(S,g){super(),this.a=g;for(const C in S){const{definition:P,value:p}=S[C];this.f[C]=P,p!==void 0&&this.g.set(C,p)}this.a.listen("onDidChange")(C=>{for(const P in C){const p=C[P];p===null?this.g.delete(P):this.g.set(P,p)}this.h.fire(Object.keys(C))})}async j(S){const g=await this.a.call("updatePolicyDefinitions",S);for(const C in g)this.g.set(C,g[C])}}e.$5ac=O}),define(le[101],he([0,1,36]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.context<"u"){const L=j.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(le[24],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,I.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"}),define(le[210],he([0,1,6,7,2,15,31,9,24]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;let g=class extends j.$Uc{constructor(P,p,f){super(),this.b=p,this.c=f,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,P&&this.B(new I.$th(()=>{this.f(P)},3e4)).schedule()}async f(P){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),f=(0,L.$nc)(P),u=(0,L.$oc)(P),b=await O.Promises.readdir(f);await Promise.all(b.map(async $=>{if($===u)return;const l=(0,L.$kc)(f,$),d=await O.Promises.stat(l);if(d.isDirectory()&&p-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${$}.`),O.Promises.rm(l)}))}catch(p){(0,A.$1)(p)}}};e.$Ubc=g,e.$Ubc=g=ye([Q(1,S.$7j),Q(2,R.$Nj)],g)}),define(le[211],he([0,1,6,7,2,15,31,16,9,24]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;let C=class extends j.$Uc{constructor(p,f,u){super(),this.b=p,this.c=f,this.f=u,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$th(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),f=JSON.parse(await O.Promises.readFile((0,L.$kc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(f)){const h=f[d];p[`${h.hash}.${d}`]=!0}const u=(0,L.$kc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(u))return;const $=await O.Promises.readdir(u);for(const d of $){if(p[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,L.$kc)(u,d))}const l=Date.now();for(const d of Object.keys(p)){const h=(0,L.$kc)(u,d),c=await O.Promises.readdir(h);for(const m of c){if(m==="tcf.json")continue;const i=(0,L.$kc)(h,m),o=await O.Promises.stat(i);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$kc)(d,m)}`),await O.Promises.rm(i))}}}catch(p){(0,A.$1)(p)}}};e.$Vbc=C,e.$Vbc=C=ye([Q(0,R.$pi),Q(1,S.$Nj),Q(2,g.$7j)],C)}),define(le[212],he([0,1,15,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$LF=void 0,e.$LF=(0,A.$hi)("IV8InspectProfilingService");var j;(function(L){function O(S){return!!(S.samples&&S.timeDeltas)}L.isValidProfile=O;function R(S,g="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,I.$jc)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,I.$kc)(g,(0,I.$oc)(C.callFrame.url)));return S}L.rewriteAbsolutePaths=R})(j||(e.Utils=j={}))}),define(le[213],he([0,1,32]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class A{constructor(){this.a=new Map}async startProfiling(L){const R=await(await new Promise((g,C)=>{se(["v8-inspect-profiler"],g,C)})).startProfiling({port:L.port,checkForPaused:!0}),S=(0,I.$Dg)();return this.a.set(S,R),S}async stopProfiling(L){const O=this.a.get(L);if(!O)throw new Error(`UNKNOWN session '${L}'`);const R=await O.stop();return this.a.delete(L),R.profile}}e.$acc=A}),define(le[41],he([0,1,127,13]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class j{constructor(){this.a=new Map}add(O,R){I.ok(A.$Uf(O)),I.ok(A.$Wf(R)),I.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$Zn=new j}),define(le[102],he([0,1,3,41]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function j(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new I.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,g){this.a[j(S)]=g,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const O=new L;A.$Zn.add(e.$1n.JSONContribution,O)}),define(le[45],he([0,1,17,3,13,151,21,102,41]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=b,e.$eo=$,e.$fo=l,e.$go=h,e.$ho=c;var g;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$5n={Configuration:"base.contributions.configuration"};var C;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const P=S.$Zn.as(R.$1n.JSONContribution);class p{constructor(){this.h=new Set,this.i=new A.$7d,this.onDidSchemaChange=this.i.event,this.j=new A.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),P.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),P.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),P.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$co.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const E of Object.keys(s[r]))v.set(E,t);const y={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:y,valuesSources:v});const w=(0,O.$Xi)(r),k={type:"object",default:y,description:L.localize(1,null,w),$ref:e.$_n,defaultDefaultValue:y,source:j.$Uf(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=k,this.b.properties[r]=k}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=j.$Uf(s)?s:s?.id,v=j.$Uf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$co.test(t))delete this.d[t],delete this.b.properties[t];else{const y=this.d[t];y&&(this.w(t,y),this.r(t,y))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=j.$4f(i.scope)?t:i.scope;const a=i.properties;if(a)for(const y in a){const w=a[y];if(o&&h(y,w)){delete a[y];continue}if(w.source=n,w.defaultDefaultValue=a[y].default,this.w(y,w),e.$co.test(y)?w.scope=void 0:(w.scope=j.$4f(w.scope)?t:w.scope,w.restricted=j.$4f(w.restricted)?!!s?.includes(y):w.restricted),a[y].hasOwnProperty("included")&&!a[y].included){this.f[y]=a[y],delete a[y];continue}else this.d[y]=a[y],a[y].policy?.name&&this.e.set(a[y].policy.name,y);!a[y].deprecationMessage&&a[y].markdownDeprecationMessage&&(a[y].deprecationMessage=a[y].markdownDeprecationMessage),r.add(y)}const v=i.allOf;if(v)for(const y of v)this.p(y,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$6n.properties[i]=o,o.scope){case 1:e.$7n.properties[i]=o;break;case 2:e.$8n.properties[i]=o;break;case 6:e.$9n.properties[i]=o;break;case 3:e.$0n.properties[i]=o;break;case 4:e.$$n.properties[i]=o;break;case 5:e.$$n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$6n.properties[i],o.scope){case 1:delete e.$7n.properties[i];break;case 2:delete e.$8n.properties[i];break;case 6:delete e.$9n.properties[i];break;case 3:delete e.$0n.properties[i];break;case 4:case 5:delete e.$$n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$_n};this.w(o,n),e.$6n.properties[o]=n,e.$7n.properties[o]=n,e.$8n.properties[o]=n,e.$9n.properties[o]=n,e.$0n.properties[o]=n,e.$$n.properties[o]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=i,e.$7n.patternProperties[e.$bo]=i,e.$8n.patternProperties[e.$bo]=i,e.$9n.patternProperties[e.$bo]=i,e.$0n.patternProperties[e.$bo]=i,e.$$n.patternProperties[e.$bo]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;j.$2f(s)&&(s=o.defaultDefaultValue,t=void 0),j.$2f(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",u=new RegExp(f,"g");e.$bo=`^(${f})+$`,e.$co=new RegExp(e.$bo);function b(m){const i=[];if(e.$co.test(m)){let o=u.exec(m);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=u.exec(m)}}return(0,I.$Mb)(i)}function $(m){return m.reduce((i,o)=>`${i}[${o}]`,"")}function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new p;S.$Zn.add(e.$5n.Configuration,d);function h(m,i){return m.trim()?e.$co.test(m)?L.localize(7,null,m):d.getConfigurationProperties()[m]!==void 0?L.localize(8,null,m):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,m,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}function c(){const m=[],i=d.getConfigurationProperties();for(const o of Object.keys(i))m.push([o,i[o].scope]);return m.push(["launch",4]),m.push(["task",4]),m}}),define(le[76],he([0,1,17,3,34,2,35,30,13,8,21,45,41]),function(se,e,I,A,j,L,O,R,S,g,C,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=h;function f(o){return Object.isFrozen(o)?o:R.$On(o)}class u{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof u)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Vi)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return f(t.rawConfiguration.getValue(n))},get override(){return s?f(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return f(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:v,keys:y}of t.rawConfiguration.overrides){const w=new u(a,y).getValue(n);w!==void 0&&r.push({identifiers:v,value:w})}return r.length?f(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Vi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return I.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Nn(this.contents),t=R.$Nn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(s,v.contents);for(const y of v.overrides){const[w]=t.filter(k=>I.$ub(k.identifiers,y.identifiers));w?(this.h(w.contents,y.contents),w.keys.push(...y.keys),w.keys=I.$Mb(w.keys)):t.push(R.$Nn(y))}for(const y of v.keys)r.indexOf(y)===-1&&r.push(y)}return new u(s,r,t,a.every(v=>v instanceof u)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of I.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const v=s[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$Nn(a),this.h(a,v)):a=v),t[r]=a}return new u(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&S.$Wf(n[t])&&S.$Wf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Nn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Nn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Ui)(this.contents,n),P.$co.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>I.$ub(t.identifiers,(0,P.$do)(n))),1))}j(n,s,t){(0,C.$Ti)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),P.$co.test(n)&&this.overrides.push({identifiers:(0,P.$do)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Si)(this.contents[n],r=>console.error(r))})}}e.$io=u;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new u}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!S.$4f(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:y}=this.h(n,s);this.b=new u(t,r,a,y?[n]:void 0),this.c=v||[]}g(n){let s={},t=null,r=[];const a=[],v=[];function y(k){Array.isArray(r)?r.push(k):t!==null&&(r[t]=k)}const w={onObjectBegin:()=>{const k={};y(k),a.push(r),r=k,t=null},onObjectProperty:k=>{t=k},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const k=[];y(k),a.push(r),r=k,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:y,onError:(k,E,D)=>{v.push({error:k,offset:E,length:D})}};if(n)try{j.$Bn(n,w),s=r[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}h(n,s){const t=p.$Zn.as(P.$5n.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Si)(n,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),v=Object.keys(n),y=this.j(n,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:a,keys:v,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},y=[];for(const w in n)if(P.$co.test(w)&&t){const k=this.i(n[w],s,!1,r);v[w]=k.raw,a=a||k.hasExcludedProperties,y.push(...k.restricted)}else{const k=s[w],E=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&y.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(E===void 0||r.scopes===void 0||r.scopes.includes(E))&&!(r.skipRestricted&&k?.restricted))?v[w]=n[w]:a=!0}return{raw:v,restricted:y,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(P.$co.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,P.$do)(r),keys:Object.keys(a),contents:(0,C.$Si)(a,s)})}return t}}e.$jo=b;class $ extends L.$Uc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new A.$7d),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new u}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=$;class l{constructor(n,s,t,r,a,v,y,w,k,E,D,U,F){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=y,this.h=w,this.i=k,this.j=E,this.k=D,this.l=U,this.m=F}get value(){return f(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(n,s,t,r,a=new u,v=new u,y=new O.$Bc,w=new u,k=new O.$Bc){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=v,this.j=y,this.l=w,this.m=k,this.a=null,this.b=new O.$Bc,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new u,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),v=s.resource?this.m.get(s.resource)||this.l:this.l,y=new Set;for(const w of r.overrides)for(const k of w.identifiers)r.getOverrideValue(n,k)!==void 0&&y.add(k);return new l(n,s,r.getValue(n),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:v}=m(this.c,n);s=[...r,...a,...v]}for(const r of s)for(const a of(0,P.$do)(r)){const v=this.c.getKeysForOverrideIdentifier(a),y=n.getKeysForOverrideIdentifier(a),w=[...y.filter(k=>v.indexOf(k)===-1),...v.filter(k=>y.indexOf(k)===-1),...v.filter(k=>!R.$Rn(this.c.override(a).getValue(k),n.override(a).getValue(k)))];t.push([a,w])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=m(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.applicationConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.localUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.remoteUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=m(this.workspaceConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:y}=m(t,s),w=[...r,...a,...v];return(w.length||!t)&&this.updateFolderConfiguration(n,s),{keys:w,overrides:y}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=m(s,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),y=n.folders.reduce((w,k)=>(w.set(g.URI.revive(k[0]),this.w(k[1])),w),new O.$Bc);return new d(s,t,r,a,new u,v,y,new u,new O.$Bc)}static w(n){return new u(n.contents,n.keys,n.overrides)}}e.$lo=d;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const y=(0,O.$yc)(s,a,new Set);v.forEach(w=>y.add(w))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(s){const y=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,w=this.g.getValue(n,s,this.h);return!R.$Rn(y,w)}return!0}}e.$no=c;function m(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const w=y.filter(k=>!v.includes(k));for(const k of w)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(o){const w=v.filter(k=>!y.includes(k));for(const k of w)a.push([k,o.getKeysForOverrideIdentifier(k)])}if(n&&o){for(const w of v)if(y.includes(w)){const k=i({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:n.getOverrideValue(void 0,w)||{},keys:n.getKeysForOverrideIdentifier(w)});a.push([w,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$Vi)(n.contents,a),y=(0,C.$Vi)(o.contents,a);R.$Rn(v,y)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[214],he([0,1,17,3,2,30,13,76,45,9,58,41]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=void 0;class p extends j.$Uc{constructor(){super(...arguments),this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$io}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(P.$Zn.as(S.$5n.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:l})=>this.c(Array.from($),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,l){this.h($,P.$Zn.as(S.$5n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new R.$io;const $=P.$Zn.as(S.$5n.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,l){const d=this.f();for(const h of $){const c=d[h],m=l[h];c!==void 0?this.b.addValue(h,c):m?this.b.addValue(h,m.default):this.b.removeValue(h)}}}e.$oo=p;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.$io}async initialize(){return this.configurationModel}}e.$po=f;let u=class extends j.$Uc{get configurationModel(){return this.b}constructor($,l,d){super(),this.c=$,this.f=l,this.g=d,this.a=this.B(new A.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$io}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const l={},d=[],h=P.$Zn.as(S.$5n.Configuration).getConfigurationProperties();for(const c of $){const m=h[c];if(!m){d.push(c);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}d.push(c),l[m.policy.name]={type:m.type}}}return(0,O.$8f)(l)||await this.f.updatePolicyDefinitions(l),d}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const l=P.$Zn.as(S.$5n.Configuration).getPolicyConfigurations(),d=(0,I.$Hb)($.map(h=>l.get(h)));this.m(d,!0)}m($,l){this.g.trace("PolicyConfiguration#update",$);const d=P.$Zn.as(S.$5n.Configuration).getConfigurationProperties(),h=[],c=this.b.isEmpty();for(const m of $){const i=d[m]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,L.$Rn)(this.b.getValue(m),o))&&h.push([m,o])}else this.b.getValue(m)!==void 0&&h.push([m,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const m=this.b;this.b=new R.$io;for(const i of m.keys)this.b.setValue(i,m.getValue(i));for(const[i,o]of h)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);l&&this.a.fire(this.b)}}};e.$qo=u,e.$qo=u=ye([Q(1,C.$2n),Q(2,g.$Nj)],u)}),define(le[215],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,45,214,58]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0;class l extends S.$Uc{constructor(c,m,i,o){super(),this.m=c,this.h=this.B(new L.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$oo),this.c=i instanceof $.$4n?new b.$po:this.B(new b.$qo(this.b,i,o)),this.f=this.B(new f.$ko(this.m,{},P.$Lg,m)),this.a=new f.$lo(this.b.configurationModel,this.c.configurationModel,new f.$io,new f.$io),this.j=new d(c,m,this),this.g=this.B(new A.$th(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,m,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$lo(c,m,new f.$io,i)}getConfigurationData(){return this.a.toData()}getValue(c,m){const i=typeof c=="string"?c:void 0,o=(0,p.$Oi)(c)?c:(0,p.$Oi)(m)?m:{};return this.a.getValue(i,o,void 0)}async updateValue(c,m,i,o,n){const s=(0,p.$Pi)(i)?i:(0,p.$Oi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,I.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,g.$Rn)(m,r.defaultValue)&&(m=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const v=s.overrideIdentifiers.sort(),y=this.a.localUserConfiguration.overrides.find(w=>(0,I.$ub)([...w.identifiers].sort(),v));y&&(s.overrideIdentifiers=y.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,u.$eo)(s.overrideIdentifiers),c]:[c];await this.j.write(a,m),await this.reloadConfiguration()}inspect(c,m={}){return this.a.inspect(c,m,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const m=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,m,2)}r(c,m){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,m);this.t(o,i,7)}s(c){const m=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,m,7)}t(c,m,i){const o=new f.$no(c,{data:m},this.a);o.source=i,this.h.fire(o)}}e.$ro=l;class d{constructor(c,m,i){this.b=c,this.c=m,this.d=i,this.a=new A.$oh}write(c,m){return this.a.queue(()=>this.e(c,m))}async e(c,m){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,O.$un)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,m);i=(0,R.$Mn)(i,n),await this.c.writeFile(this.b,j.$ue.fromString(i))}f(c,m,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!m.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$Jn)(c,m,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const m=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});m&&typeof m=="string"&&m!=="auto"&&(c=m),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[216],he([0,1,14,3,2,68]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Utb=e.$Stb=e.$Rtb=void 0,e.$Ttb=R;const O=(g,C,P)=>{const p=new Uint8Array(16);for(let b=0;b<16;b++)p[b]=Math.round(Math.random()*256);const f=(0,I.$Oe)(I.$ue.wrap(p));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`].join(`\r
`)+`\r
\r
`};e.$Rtb=O,e.$Stb=I.$ue.fromString(`\r
\r
`);async function R(g,C,P,p,f){g.write(I.$ue.fromString((0,e.$Rtb)(C,P,p)));const u=new j.$Tc;try{return await new Promise((b,$)=>{let l;u.add(g.onData(d=>{l?l=I.$ue.concat([l,d],l.byteLength+d.byteLength):l=d;const h=l.indexOf(e.$Stb);if(h===-1)return;b(g),g.pauseData();const c=l.slice(h+e.$Stb.byteLength);c.byteLength&&f.onData.fire(c)})),u.add(g.onClose(d=>$(d??new Error("socket closed")))),u.add(g.onEnd(()=>$(new Error("socket ended"))))})}catch(b){throw g.dispose(),b}finally{u.dispose()}}class S extends j.$Uc{constructor(C,P){super(),this.g=C,this.a=this.B(new A.$0d),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new A.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(p=>this.a.fire(p))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,P){L.SocketDiagnostics.traceSocketEvent(this,this.g,C,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Utb=S}),define(le[217],he([0,1,7,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=g,e.$sl=(0,A.$hi)("remoteAuthorityResolverService");var j;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class L{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=L;class O{constructor(P,p){this.host=P,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends I.$bb{static isNotAvailable(P){return P instanceof S&&P._code===R.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof S&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof S&&P._code===R.NoResolverFound}static isInvalidAuthority(P){return P instanceof S&&P._code===R.InvalidAuthority}static isHandled(P){return P instanceof S&&P.isHandled}constructor(P,p=R.Unknown,f){super(P),this._message=P,this._code=p,this._detail=f,this.isHandled=p===R.NotAvailable&&f===!0,Object.setPrototypeOf(this,S.prototype)}}e.$vl=S;function g(C){const P=C.indexOf("+");return P===-1?C:C.substring(0,P)}}),define(le[218],he([0,1,6,14,26,7,3,2,23,99,63,32,68,217]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Bl=v,e.$Cl=y,e.$Dl=k;const u=30*1e3;var b;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function $(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(q){const N=new j.$ee;return setTimeout(()=>N.cancel(),q),N.token}function d(q,N){if(q.isCancellationRequested||N.isCancellationRequested)return j.CancellationToken.Cancelled;const M=new j.$ee;return q.onCancellationRequested(()=>M.cancel()),N.onCancellationRequested(()=>M.cancel()),M.token}class h{get didTimeout(){return this.c==="timedout"}constructor(N){this.c="pending",this.d=new R.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$ah)(),N.isCancellationRequested?this.h():this.d.add(N.onCancellationRequested(()=>this.h()))}registerDisposable(N){this.c==="pending"?this.d.add(N):N.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(N))}reject(N){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(N))}}function c(q,N){const M=new h(N);return M.registerDisposable(q.onControlMessage(z=>{const Z=JSON.parse(z.toString()),J=B(Z);J?M.reject(J):M.resolve(Z)})),M.promise}function m(q,N,M,z,Z,J,x,Y){const V=new h(Y),ie=C.$3d.create(!1);return q.info(`Creating a socket (${x})...`),g.mark(`code/willCreateSocket/${J}`),N.connect(M,z,Z,x).then(re=>{V.didTimeout?(g.mark(`code/didCreateSocketError/${J}`),q.info(`Creating a socket (${x}) finished after ${ie.elapsed()} ms, but this is too late and has timed out already.`),re?.dispose()):(g.mark(`code/didCreateSocketOK/${J}`),q.info(`Creating a socket (${x}) was successful after ${ie.elapsed()} ms.`),V.resolve(re))},re=>{g.mark(`code/didCreateSocketError/${J}`),q.info(`Creating a socket (${x}) returned an error after ${ie.elapsed()} ms.`),q.error(re),V.reject(re)}),V.promise}function i(q,N){const M=new h(N);return q.then(z=>{M.didTimeout||M.resolve(z)},z=>{M.didTimeout||M.reject(z)}),M.promise}async function o(q,N,M,z){const Z=ce(q,N);q.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let J;try{J=await m(q.logService,q.remoteSocketFactoryService,q.connectTo,S.$ug.getServerRootPath(),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,$(N),`renderer-${$(N)}-${q.reconnectionToken}`,z)}catch(re){throw q.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),q.logService.error(re),re}q.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let x,Y;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(J,null),x=q.reconnectionProtocol,Y=!1):(x=new p.$8h({socket:J}),Y=!0),q.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const V=await i(q.signService.createNewMessage((0,P.$Dg)()),z),ie={type:"auth",auth:q.connectionToken||"00000000000000000000",data:V.data};x.sendControl(A.$ue.fromString(JSON.stringify(ie)));try{const re=await c(x,d(z,l(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(q.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await i(q.signService.validate(V,re.signedData),z)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(q.signService.sign(re.data),z),me={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:N};return M&&(me.args=M),q.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(A.$ue.fromString(JSON.stringify(me))),{protocol:x,ownsProtocol:Y}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(q.logService.error(`${Z} the handshake timed out. Error:`),q.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${Z} received error control message when negotiating connection. Error:`),q.logService.error(re)),Y&&W(x),re}}async function n(q,N,M,z){const Z=Date.now(),J=ce(q,N),{protocol:x,ownsProtocol:Y}=await o(q,N,M,z),V=new h(z);return V.registerDisposable(x.onControlMessage(ie=>{const re=JSON.parse(ie.toString()),ue=B(re);ue?(q.logService.error(`${J} received error control message when negotiating connection. Error:`),q.logService.error(ue),Y&&W(x),V.reject(ue)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${G(Z)}!`),V.resolve({protocol:x,firstMessage:re}))})),V.promise}async function s(q,N){const{protocol:M}=await n(q,1,void 0,N);return{protocol:M}}async function t(q,N,M){const{protocol:z,firstMessage:Z}=await n(q,2,N,M),J=Z&&Z.debugPort;return{protocol:z,debugPort:J}}async function r(q,N,M){const z=Date.now(),Z=ce(q,3),{protocol:J}=await o(q,3,N,M);return q.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(z)}!`),J}async function a(q,N,M){const{connectTo:z,connectionToken:Z}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:z,connectionToken:Z,reconnectionToken:N,reconnectionProtocol:M,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,N,M){return w(q,async z=>{const{protocol:Z}=await s(z,j.CancellationToken.None);return new H(q,N,M,z.reconnectionToken,Z)})}async function y(q,N){return w(q,async M=>{const{protocol:z,debugPort:Z}=await t(M,N,j.CancellationToken.None);return new K(q,N,M.reconnectionToken,z,Z)})}async function w(q,N){for(let z=1;;z++)try{const Z=(0,P.$Dg)(),J=await a(q,Z,null);return await N(J)}catch(Z){if(z<5)q.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(Z);else throw q.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(Z),ee.triggerPermanentFailure(0,0,f.$vl.isHandled(Z)),Z}}async function k(q,N,M){const z=await a(q,(0,P.$Dg)(),null);return await r(z,{host:N,port:M},j.CancellationToken.None)}function E(q){return(0,I.$7g)(N=>new Promise((M,z)=>{const Z=setTimeout(M,q*1e3);N.onCancellationRequested(()=>{clearTimeout(Z),M()})}))}var D;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(D||(e.PersistentConnectionEventType=D={}));class U{constructor(N,M){this.reconnectionToken=N,this.millisSinceLastIncomingData=M,this.type=0}}e.$El=U;class F{constructor(N,M,z,Z){this.reconnectionToken=N,this.millisSinceLastIncomingData=M,this.durationSeconds=z,this.c=Z,this.type=1}skipWait(){this.c.cancel()}}e.$Fl=F;class T{constructor(N,M,z){this.reconnectionToken=N,this.millisSinceLastIncomingData=M,this.attempt=z,this.type=2}}e.$Gl=T;class _{constructor(N,M,z){this.reconnectionToken=N,this.millisSinceLastIncomingData=M,this.attempt=z,this.type=4}}e.$Hl=_;class X{constructor(N,M,z,Z){this.reconnectionToken=N,this.millisSinceLastIncomingData=M,this.attempt=z,this.handled=Z,this.type=3}}e.$Il=X;class ee extends R.$Uc{static triggerPermanentFailure(N,M,z){this._permanentFailure=!0,this.f=N,this.g=M,this.h=z,this.j.forEach(Z=>Z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(N=>N.y())}static debugPauseSocketWriting(){this.j.forEach(N=>N.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ee._permanentFailure}constructor(N,M,z,Z,J){super(),this.t=N,this.u=M,this.reconnectionToken=z,this.protocol=Z,this.w=J,this.m=this.B(new O.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new _(this.reconnectionToken,0,0)),this.B(Z.onSocketClose(x=>{const Y=te(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${Y} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${Y} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${Y} received socket close event.`),this.y()})),this.B(Z.onSocketTimeout(x=>{const Y=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),ee.j.push(this),this.B((0,R.$Sc)(()=>{const x=ee.j.indexOf(this);x>=0&&ee.j.splice(x,1)})),this.n&&this.D(ee.f,ee.g,ee.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const N=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const Z=z<M.length?M[z]:M[M.length-1];try{if(Z>0){const x=E(Z);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,x)),this.u.logService.info(`${N} waiting for ${Z} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.u.logService.info(`${N} resolving connection...`);const J=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${N} connecting to ${J.connectTo}...`),await this.G(J,l(u)),this.u.logService.info(`${N} reconnected!`),this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.u.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(f.$vl.isTemporarilyNotAvailable(J)){this.u.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,L.$4)(J)){this.u.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof f.$vl){this.u.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,f.$vl.isHandled(J));break}this.u.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.n&&!this.s)}C(N,M,z){this.w?ee.triggerPermanentFailure(N,M,z):this.D(N,M,z)}D(N,M,z){this.m.fire(new X(this.reconnectionToken,N,M,z)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Jl=ee;class H extends ee{constructor(N,M,z,Z,J){super(1,N,Z,J,!0),this.client=this.B(new p.$6h(J,{remoteAuthority:M,clientId:z},N.ipcLogger))}async G(N,M){await s(N,M)}}e.$Kl=H;class K extends ee{constructor(N,M,z,Z,J){super(2,N,z,Z,!1),this.H=M,this.debugPort=J}async G(N,M){await t(N,this.H,M)}}e.$Ll=K;function W(q){try{q.acceptDisconnect();const N=q.getSocket();q.dispose(),N.dispose()}catch(N){(0,L.$1)(N)}}function B(q){if(q&&q.type==="error"){const N=new Error(`Connection error: ${q.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function ne(q,N){for(;q.length<N;)q+=" ";return q}function oe(q,N){return`[remote-connection][${ne($(q),13)}][${N.substr(0,5)}\u2026]`}function te(q,N,M){return`${oe(q,N)}[${M?"reconnect":"initial"}]`}function ce(q,N){return`${te(N,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function G(q){return`${Date.now()-q} ms`}}),define(le[103],he([0,1,23]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=A,e.$tm=j,e.$um=L,e.$vm=O;function A(S){return S.scheme===I.Schemas.vscodeRemote?S.authority:void 0}function j(S){if(!S)return;const g=S.indexOf("+");return g<0?S:S.substr(0,g)}function L(S){const{host:g,port:C}=R(S);if(typeof C>"u")throw new Error(`Invalid remote authority: ${S}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:C}}function O(S,g){let{host:C,port:P}=R(S);return typeof P>"u"&&(P=g),{host:C,port:P}}function R(S){const g=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const C=S.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const P=S.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:S,port:void 0}}}),define(le[46],he([0,1,27,4,103]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=L,e.$Fm=P,e.$Gm=p,e.$Hm=f,e.$Im=u,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function L(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,l){if(typeof $>"u"||$===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof $=="string"||typeof l=="string"){const d=typeof $=="string"?$:$.value,h=typeof l=="string"?l:l.value;return I.$lf(d,h)}return $._lower===l._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Cm=S;class g{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const l of $)this.add(l)}add($){this.c.add(S.toKey($))}delete($){return this.c.delete(S.toKey($))}has($){return this.c.has(S.toKey($))}}e.$Dm=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(S.toKey($))}get($){return this.c.get(S.toKey($))}has($){return this.c.has(S.toKey($))}set($,l){this.c.set(S.toKey($),l)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=C;function P(b){return p(b)}function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function u(b,$){if($){const l=`onResolveRemoteAuthority:${(0,j.$tm)($)}`;return!!b.activationEvents?.includes(l)}return!1}e.$Jm=(0,A.$hi)("IBuiltinExtensionsScannerService")}),define(le[219],he([0,1,2,46,12]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class L extends I.$Uc{constructor(R,S,g,C,P){super(),this.a=R,this.b=S,this.c=g,this.f=P,this.B(C.onDidInstallExtensions(p=>this.g(p))),this.B(C.onDidUninstallExtension(p=>this.h(p)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.j(S);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,A.$wm))}catch(S){(0,j.$5k)(S)!==1&&this.f.error(S)}}}e.$mq=L}),define(le[104],he([0,1,2,4]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0,e.$xl=(0,A.$hi)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,I.$Sc)(()=>{const S=this.a[O]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[O]?.splice(S,1)})}b(O){return(this.a[O.type]||[]).find(S=>S.supports(O))}connect(O,R,S,g){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,S,g)}}e.$yl=j}),define(le[220],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0,e.$0bc=(0,I.$hi)("sharedProcessTunnelService"),e.$$bc="sharedProcessTunnel"}),define(le[105],he([0,1,4,167]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=e.$hcc=e.$gcc=e.$fcc=e.$ecc=e.TunnelStates=e.$dcc=e.$ccc=void 0,e.$ccc=(0,I.$hi)("IRemoteTunnelService"),e.$dcc={active:!1};var j;(function(L){L.disconnected=O=>({type:"disconnected",onTokenFailed:O}),L.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),L.connecting=O=>({type:"connecting",progress:O}),L.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$ecc="remote.tunnels.access",e.$fcc=e.$ecc+".hostNameOverride",e.$gcc=e.$ecc+".preventSleep",e.$hcc="remoteTunnelService",e.$icc=(0,A.localize)(0,null)}),define(le[59],he([0,1,14,7,2,169,45,4,9,41]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=void 0,e.$Ap=p,e.$Bp=f,e.$Cp=u,e.$Dp=b,e.$Ep=$,e.$Fp=l,e.$yp=(0,R.$hi)("requestService");class C{constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?m[i]="*****":m[i]=this.b[i];this.a=m}return this.a}}class P extends j.$Uc{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,L.localize)(0,null),when:S.$6j.isEqualTo((0,S.$3j)(S.LogLevel.Trace)).serialize()})}async c(m,i,o){const n=`${m} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,A.$0)(s)),s}}}e.$zp=P;function p(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function f(c){return c.res.statusCode===204}async function u(c){return f(c)?null:(await(0,I.$Ge)(c.stream)).toString()}async function b(c){if(!p(c))throw new Error("Server returned "+c.res.statusCode);return u(c)}async function $(c){if(!p(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const i=(await(0,I.$Ge)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}function l(c){h(c)}let d;function h(c){const m=g.$Zn.as(O.$5n.Configuration),i=d;d={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},m.updateConfigurations({add:[d],remove:i?[i]:[]})}h(1)}),define(le[221],he([0,1,26,23,12,59]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;let O=class{constructor(S,g){this.a=S,this.b=g}async download(S,g,C=I.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.b.copy(S,g);return}const P={type:"GET",url:S.toString(!0)},p=await this.a.request(P,C);if(p.res.statusCode===200)await this.b.writeFile(g,p.stream);else{const f=await(0,L.$Dp)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${f}`)}}};e.$bQ=O,e.$bQ=O=ye([Q(0,L.$yp),Q(1,j.$Nk)],O)}),define(le[222],he([0,1,14,26]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=void 0;class j{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,g,C=A.CancellationToken.None){switch(S){case"request":return this.a.request(g[0],C).then(async({res:P,stream:p})=>{const f=await(0,I.$Ge)(p);return[{statusCode:P.statusCode,headers:P.headers},f]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Cr=j;class L{constructor(R){this.a=R}async request(R,S){const[g,C]=await this.a.call("request",[R],S);return{res:g,stream:(0,I.$Ie)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Dr=L}),define(le[223],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.$Cac=e.$Bac=void 0,e.$Bac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Cac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Dac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[224],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const L=await this.c();if(L){const O=String(I.a++);return this.b.set(O,L),{id:O,data:L.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,L){if(!j.id)return!0;const O=this.b.get(j.id);if(!O)return!1;this.b.delete(j.id);try{return O.validate(L)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$x9b=I}),define(le[106],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0,e.$zl="signService",e.$Al=(0,I.$hi)(e.$zl)}),define(le[225],he([0,1,224]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;class A extends I.$x9b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(O=>new O.signer().sign(L))}h(){return new Promise((L,O)=>se(["vsda"],L,O))}}e.$rbc=A}),define(le[77],he([0,1,3,2]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mIb=e.$lIb=e.$kIb=e.$jIb=void 0;class j extends A.$Uc{constructor(P,p,f){super(),this.a=P,this.b=p,this.c=f}async getItems(){const P={profile:this.b,workspace:this.c},p=await this.a.call("getItems",P);return new Map(p)}updateItems(P){const p={profile:this.b,workspace:this.c};return P.insert&&(p.insert=Array.from(P.insert.entries())),P.delete&&(p.delete=Array.from(P.delete.values())),this.a.call("updateItems",p)}optimize(){const P={profile:this.b,workspace:this.c};return this.a.call("optimize",P)}}class L extends j{constructor(P,p){super(P,p,void 0),this.f=this.B(new I.$7d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(P=>this.h(P)))}h(P){(Array.isArray(P.changed)||Array.isArray(P.deleted))&&this.f.fire({changed:P.changed?new Map(P.changed):void 0,deleted:P.deleted?new Set(P.deleted):void 0})}}class O extends L{constructor(P){super(P,void 0)}async close(){this.dispose()}}e.$jIb=O;class R extends L{constructor(P,p){super(P,p)}async close(){this.dispose()}}e.$kIb=R;class S extends j{constructor(P,p){super(P,void 0,p),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$lIb=S;class g{constructor(P){this.a=P}isUsed(P){const p={payload:P,profile:void 0,workspace:void 0};return this.a.call("isUsed",p)}}e.$mIb=g}),define(le[107],he([0,1,5,36,32]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=O,e.$2o=R;function L(S){if(I.$u===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function O(S,g,C,P,p,f,u,b,$){const l=Object.create(null);l["common.machineId"]=f,l["common.sqmId"]=u,l.sessionID=(0,j.$Dg)()+Date.now(),l.commitHash=P,l.version=p,l["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,I.$h)(I.$u),l["common.nodePlatform"]=A.$ec,l["common.nodeArch"]=C,l["common.product"]=$||"desktop",b&&(l["common.msftInternal"]=b);let d=0;const h=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),I.$l&&(l["common.snap"]="true");const c=L(g);return c&&(l["common.platformDetail"]=c),l}function R(S){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return S.some(P=>C===P)}}),define(le[22],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,I.$hi)("telemetryService"),e.$Nl=(0,I.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var j;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(le[226],he([0,1,37,6,34,23,15,5,8,144,31,148,94,12,24,22]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=void 0,e.$ls=l,e.$ms=h,e.$ns=c;const $=new Map;async function l(i,o){const n=`${i}::${o.join(":")}`,s=$.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function y(k,E,D,U){const F=E.substring(k.length+1);return A.Promises.withAsyncBody(async T=>{let _;try{_=await C.Promises.readdir(E,{withFileTypes:!0})}catch{T();return}if(U.count>=v){U.count+=_.length,U.maxReached=!0,T();return}let X=_.length;if(X===0){T();return}let ee=_;U.count+_.length>v&&(U.maxReached=!0,X=v-U.count,ee=_.slice(0,X)),U.count+=_.length;for(const H of ee)if(H.isDirectory()){if(D.includes(H.name)||await y(k,(0,O.$kc)(E,H.name),D,U),--X===0){T();return}}else{const K=H.name.lastIndexOf(".");if(K>=0){const W=H.name.substring(K+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of t)W.relativePathPattern?.test(F)!==!1&&W.filePattern.test(H.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--X===0){T();return}}})}const w=A.Promises.withAsyncBody(async k=>{const E={count:0,maxReached:!1};await y(i,i,o,E);const D=await c(i);k({configFiles:d(a),fileTypes:d(r),fileCount:E.count,maxFilesReached:E.maxReached,launchConfigFiles:D})});return $.set(n,w),w}function d(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function h(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/f.$jl.GB).toFixed(2)}GB (${(I.freemem()/f.$jl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$pn.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}async function c(i){try{const o=new Map,n=(0,O.$kc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,j.$un)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$Dn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return d(o)}catch{return[]}}let m=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/f.$jl.GB).toFixed(2)}GB (${(I.freemem()/f.$jl.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$pn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,P.$ks)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(v=>{if((0,p.$2m)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const y of Object.keys(v.workspaceMetadata)){const w=v.workspaceMetadata[y];let k=`${w.fileCount} files`;w.maxFilesReached&&(k=`more than ${k}`),r+=`|    Folder (${y}): ${k}`,r+=this.h(w)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=h(),v={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${I.loadavg().map(y=>Math.round(y)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const s=[];return(0,P.$ks)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,p.$2m)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let y=`${v.fileCount} files`;v.maxFilesReached&&(y=`more than ${y}`),s.push(`Folder (${a}): ${y}`),s.push(this.h(v))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(w,k)=>{const E=` ${w}(${k})`;t+E.length>60?(n.push(a),a="|                 ",t=a.length):t+=E.length,a+=E};let a="|      File types:";const v=10,y=o.fileTypes.length>v?v:o.fileTypes.length;for(let w=0;w<y;w++){const k=o.fileTypes[w];r(k.name,k.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(w=>{r(w.name,w.count)}),n.push(a)),o.launchConfigFiles.length>0){let w="|      Launch Configs:";o.launchConfigFiles.forEach(k=>{const E=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;w+=E}),n.push(w)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===L.Schemas.file){const v=a.fsPath;s.push(l(v,["node_modules",".git"]).then(y=>{let w=`${y.fileCount} files`;y.maxFilesReached&&(w=`more than ${w}`),n.push(`|    Folder (${(0,O.$oc)(v)}): ${w}`),n.push(this.h(y))}).catch(y=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${y.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const y=process.platform==="win32"?t.mem:I.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(y/f.$jl.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(w=>this.n(o,n,s,w,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=S.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=S.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$os=m,e.$os=m=ye([Q(0,b.$Ml),Q(1,u.$7j)],m)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=e.$Gac=void 0;class I{constructor(L){this.b=L}listen(L,O){throw new Error(`Event not found: ${O}`)}call(L,O,{eventName:R,data:S}){return this.b.forEach(g=>g.log(R,S)),Promise.resolve(null)}}e.$Gac=I;class A{constructor(L){this.b=L}log(L,O){return this.b.call("log",{eventName:L,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Hac=A}),define(le[47],he([0,1,30,13,103,107,22]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=C,e.$$o=P,e.$_o=p,e.$ap=f,e.$bp=b,e.$cp=l,e.$dp=d,e.$ep=m;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$3o=R;class S{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=S,e.$5o=new S;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$6o=g,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}function P(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function p(i){const o=i.getValue(O.$Ul),n=i.getValue(O.$Vl);if(i.getValue(O.$Wl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function f(i){const o={},n={},s={};$(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,j.$tm)(i);return u.has(o)?o:"other"}function $(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,I.$Sn)(r):r instanceof Date?o[a]=r.toISOString():(0,A.$Wf)(r)?n<2?$(r,o,n+1,a+"."):o[a]=(0,I.$Sn)(r):o[a]=r}}function l(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,L.$2o)(n)||s}function d(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function h(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const v of o)for(;;){const y=v.exec(i);if(!y)break;s.push([y.index,v.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const v=r.exec(i);if(!v)break;const y=s.some(([w,k])=>v.index<k&&w<r.lastIndex);!t.test(v[0])&&!y&&(n+=i.substring(a,v.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function m(i,o){return(0,I.$Pn)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=h(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}}),define(le[33],he([0,1,27,29,46,5,8,7,36,47]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=C,e.$hp=u,e.$ip=b,e.$jp=$,e.$kp=l,e.$lp=d,e.$mp=h,e.$np=c,e.$pp=m,e.$qp=o;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$gf)(n.id,s.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new p(s.identifier,t,r)}static parse(s){const t=P.exec(s);return t&&t[1]&&t[2]?new p({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof p?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$gp=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(n){const s=f.exec(n);return s&&s[1]?[$(s[1]),s[2]]:[$(n),void 0]}function b(n,s){return`${n}.${s}`}function $(n){return n.toLowerCase()}function l(n,s){return $(b(n??j.$ym,s))}function d(n,s){const t=[],r=a=>{for(const v of t)if(v.some(y=>C(s(y),s(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function c(n){return{id:new g.$3o(n.identifier.id),name:new g.$3o(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$op=new j.$Cm("pprice.better-merge");function m(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(y=>C(y.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,A.$Mo)(t?"alpine":L.$u,S.$fc);return s.debug("ComputeTargetPlatform:",r),r}}),define(le[227],he([0,1,17,2,20,8,12,24,6,3,15,5,36,33]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=void 0;let u=class extends A.$Uc{constructor(h,c){super(),this.b=h,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const c=[];for(const[m,i]of this.a)if(!(i.configScheme&&i.configScheme!==h.scheme))try{const o=(await this.b.readFile((0,j.$Ug)(h,m))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$E$b=u,e.$E$b=u=ye([Q(0,O.$Nk),Q(1,R.$7j)],u);const b="extensionTips/promptedExecutableTips",$="extensionTips/lastPromptedMediumImpExeTime";class l extends u{constructor(h,c,m,i,o,n,s,t){super(s,t),this.r=h,this.s=c,this.t=m,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],y=[],w=[];Object.entries(a.recommendations).forEach(([k,E])=>{E.important?a.important?v.push({extensionId:k,extensionName:E.name,isExtensionPack:!!E.isExtensionPack}):y.push({extensionId:k,extensionName:E.name,isExtensionPack:!!E.isExtensionPack}):w.push({extensionId:k,extensionName:E.name,isExtensionPack:!!E.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),y.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),w.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w})}),(0,S.$jh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),c=await this.O(this.h);return[...h,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),c=await this.O(this.h),m=await this.u.getInstalled();this.m=this.D(h,m),this.n=this.D(c,m)}D(h,c){const m=new Map;h.forEach(t=>m.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...m.keys()],c);for(const t of i){const r=m.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=m.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=m.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[h,c]=[...this.m.entries()][0];this.H(c).then(m=>{switch(m){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new A.$Vc);i.value=(0,S.$jh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),c=Date.now()-h,m=7*24*60*60*1e3;if(c<m){const n=this.B(new A.$Vc);n.value=(0,S.$jh)(()=>{n.dispose(),this.G()},m-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new A.$Vc);s.value=(0,S.$jh)(()=>{s.dispose(),this.G()},m);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new A.$Vc);s.value=(0,S.$jh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const c=await this.u.getInstalled(1),m=h.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,f.$fp)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:m,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber($,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store($,h,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(h,c){const m=this.L();m[h]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify(m),-1,0)}N(h,c){const m=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{o.has(n.toLowerCase())?m.push(n):i.push(n)}),{installed:m,uninstalled:i}}async O(h){const c=[],m=new Map;for(const i of h.keys()){const o=h.get(i);if(!o||!(0,I.$Lb)(o.recommendations))continue;const n=[];P.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>p.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>p.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>p.env.ProgramFiles).replace("%APPDATA%",()=>p.env.APPDATA).replace("%WINDIR%",()=>p.env.WINDIR)):(n.push((0,C.$kc)("/usr/local/bin",i)),n.push((0,C.$kc)("/usr/bin",i)),n.push((0,C.$kc)(this.r.fsPath,i)));for(const s of n){let t=m.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),m.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:y}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:y})}}return c}}e.$F$b=l}),define(le[228],he([0,1,26,33]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C2b=j;async function j(L,O,R,S,g){try{const C=await L.getExtensionsControlManifest();if(!C.deprecated)return;const P=await L.getInstalled(1);for(const[p,f]of Object.entries(C.deprecated)){if(!f?.extension)continue;const{id:u,autoMigrate:b,preRelease:$}=f.extension;if(!b)continue;const l=P.find(h=>(0,A.$fp)(h.identifier,{id:p}));if(!l)continue;const d=(await O.getExtensions([{id:u,preRelease:$}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!d){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${u}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${u}' extension...`);const h=!S.getDisabledExtensions().some(m=>(0,A.$fp)(m,l.identifier));await L.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let c=P.find(m=>(0,A.$fp)(m.identifier,{id:u}));(!c||!c.isPreReleaseVersion&&h)&&(c=await L.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${c.identifier.id}'`),h||(await S.disableExtension(c.identifier),g.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),b.storage&&(R.addToMigrationList((0,A.$ip)(l.manifest.publisher,l.manifest.name),(0,A.$ip)(c.manifest.publisher,c.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${u}' extension.`)}catch(h){g.error(h)}}}catch(C){g.error(C)}}}),define(le[229],he([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,98,12,9]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;let c=class extends j.$Uc{static{h=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,O.$Ug)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new u.$Ro(r.message,u.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${v.output}`),t===u.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===u.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(y){this.r.error(y)}throw new u.$Ro(P.$3p,u.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,S.$1f)(o)?o:!0}async u(i){await this.g;const o=(0,O.$Ug)(this.extensionsDownloadDir,`${this.z(i)}${h.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new u.$Ro(n.message,u.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==L.Schemas.file){await n(o);return}const s=(0,O.$Ug)(this.extensionsDownloadDir,`.${(0,g.$Dg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(h.c))s.push(a.resource);else{const v=b.$gp.parse(a.name);v&&n.push([v,a])}const t=(0,b.$lp)(n,([a])=>a),r=[];for(const a of t)a.sort((v,y)=>R.rcompare(v[0].version,y[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await I.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$gp.create(i).toString().toLowerCase():(0,g.$Dg)()}};e.$jq=c,e.$jq=c=h=ye([Q(0,f.$pi),Q(1,l.$Nk),Q(2,u.$Qo),Q(3,p.$Ni),Q(4,$.$Wp),Q(5,d.$Nj)],c)}),define(le[230],he([0,1,3,2,35,33,46]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class R extends A.$Uc{constructor(g,C,P,p,f,u,b){super(),this.f=g,this.g=C,this.h=P,this.j=p,this.m=f,this.n=u,this.r=b,this.a=this.B(new I.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$4c),this.s().then(null,$=>b.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,A.$Rc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const P=this.L(C.identifier,C.version);g.error?this.J(P,g.profileLocation):this.I(P,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],P=[];for(const p of g.extensions){const f=this.L(p.identifier,p.version);g.error?this.I(f,g.profileLocation):(this.J(f,g.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),P.push(this.f.scanInstalledExtensionAtLocation(p.location).then(u=>{u?C.push(u):this.r.info("Extension not found at the location",p.location.toString())},u=>this.r.error(u)))))}try{await Promise.all(P),C.length&&await this.H(C)}catch(p){this.r.error(p)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],P=[],p=await this.j.scanProfileExtensions(g),f=new Set,u=new Set;for(const[b,$]of this.b)$.has(g)&&u.add(b);for(const b of p){const $=this.L(b.identifier,b.version);f.add($),u.has($)||(C.push(b.identifier),this.I($,g))}for(const b of u)if(!f.has(b)){const $=this.M(b);$&&(P.push($.identifier),this.J(b,g))}(C.length||P.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:P.length?{extensions:P,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const P of C)this.I(this.L(P.identifier,P.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(P=>!this.b.has(this.L(P.identifier,P.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let P=this.b.get(g);P||this.b.set(g,P=new j.$Cc(p=>this.m.extUri.getComparisonKey(p))),P.add(C)}J(g,C){const P=this.b.get(g);P&&P.delete(C),P?.size||this.b.delete(g)}L(g,C){return`${O.$Cm.toKey(g.id)}@${C}`}M(g){const[C,P]=(0,L.$hp)(g);return P?{identifier:{id:C},version:P}:void 0}}e.$nq=R}),define(le[231],he([0,1,44,47]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=j;async function j(L,O,R,S,g,C,P){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,A.$0o)(O,R)&&(0,A.$_o)(S)===3){const f=await(0,I.$Rp)(R,g,C);p["X-Market-User-Id"]=f,p["VSCode-SessionId"]=P.machineId||f}return p}}),define(le[232],he([0,1,73,17,6,2,23,15,31,16,29,33,9,75,8]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;let b=class extends f.$Ar{constructor(h,c,m,i){super(m),this.h=h,this.j=i,this.g=this.B(new $(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(h,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[h];return o?u.URI.file(o):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),c=Object.keys(h).map(m=>{const i=h[m];return{...this.f(m,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((m,i)=>m.label.localeCompare(i.label)),c}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const c=await this.g.getLanguagePacks();Object.keys(c).some(m=>c[m]&&c[m].extensions.some(i=>(0,P.$fp)(i.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),m=await this.g.update(c);return!(0,A.$ub)(Object.keys(h),Object.keys(m))}};e.$Br=b,e.$Br=b=ye([Q(0,C.$To),Q(1,g.$pi),Q(2,C.$Qo),Q(3,p.$Nj)],b);let $=class extends L.$Uc{constructor(h,c){super(),this.j=c,this.c={},this.f=(0,R.$kc)(h.userDataPath,"languagepacks.json"),this.g=new j.$oh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(c=>{Object.keys(c).forEach(m=>delete c[m]),this.m(c,...h)}).then(()=>this.c)}m(h,...c){for(const m of c)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.n(h,m);Object.keys(h).forEach(m=>this.r(h[m]))}n(h,c){const m=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===O.Schemas.file&&l(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},h[o.languageId]=n);const s=n.extensions.filter(t=>(0,P.$fp)(t.extensionIdentifier,m))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:m,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$kc)(c.location.fsPath,t.path)}}r(h){if(h){const c=(0,I.createHash)("md5");for(const m of h.extensions)c.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);h.hash=c.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let c=null;return S.Promises.readFile(this.f,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(c=h(m),m)).then(m=>{for(const o of Object.keys(m))m[o]||delete m[o];this.c=m,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),S.Promises.writeFile(this.f,i)}).then(()=>c,m=>this.j.error(m))})}};$=ye([Q(0,g.$pi),Q(1,p.$Nj)],$);function l(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const h of d.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(le[233],he([0,1,143,7,30,47]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(C,P,p){const f=await(0,I.$CD)("@microsoft/1ds-core-js","dist/ms.core.js"),u=await(0,I.$CD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new f.AppInsightsCore,$=new u.PostChannel,l={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(p){l.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};l.extensionConfig[$.identifier]=d}return b.initialize(l,[]),b.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',P&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),b}class g{constructor(P,p,f,u,b){this.e=P,this.f=p,this.g=f,this.h=b,this.c=O,this.d=R,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(P){if(this.a){if(typeof this.a!="string"){P(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(p=>{P(p)},p=>{(0,A.$1)(p),console.error(p)})}}log(P,p){if(!this.a)return;p=(0,j.$Qn)(p,this.g),p=(0,L.$ap)(p);const f=this.f+"/"+P;try{this.i(u=>{u.pluginVersionString=p?.properties.version??"Unknown",u.track({name:f,baseData:{name:f,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(P=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,P(void 0)})})}):Promise.resolve(void 0)}}e.$LP=g}),define(le[109],he([0,1,2,170,16,9,24,47]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=void 0;let S=class extends I.$Uc{constructor(C,P,p,f,u=""){super(),this.b=u;const b=P.getLogger(R.$7o);if(b)this.a=this.B(b);else{const l=(0,R.$$o)(f,p)?" (Not Sent)":"",d=()=>(0,R.$0o)(f,p)&&C.getLevel()===L.LogLevel.Trace;this.a=this.B(P.createLogger(R.$7o,{name:(0,A.localize)(0,null,l),hidden:!d()})),this.B(C.onDidChangeLogLevel(()=>P.setVisibility(R.$7o,d()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,P){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$ap)(P))}};e.$50b=S,e.$50b=S=ye([Q(0,L.$Nj),Q(1,L.$Oj),Q(2,j.$oi),Q(3,O.$7j)],S)}),define(le[110],he([0,1,2,30,5,27,171,21,45,101,24,41,22,47]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;let u=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,d,h){this.k=d,this.l=h,this.d={},this.i=new I.$Tc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,L.$Ze)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Ze)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(p.$Ul)||c.affectsConfiguration(p.$Wl)||c.affectsConfiguration(p.$Vl))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,f.$_o)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;l=Math.min(l,h)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,d,h){this.g<d||(h=(0,A.$Qn)(h,this.d),h=(0,f.$ep)(h,this.j),h=(0,A.$Qn)(h,this.c),this.b.forEach(c=>c.log(l,h)))}publicLog(l,d){this.n(l,3,d)}publicLog2(l,d){this.publicLog(l,d)}publicLogError(l,d){this.h&&this.n(l,2,d)}publicLogError2(l,d){this.publicLogError(l,d)}};e.$Hr=u,e.$Hr=u=ye([Q(1,R.$Ni),Q(2,C.$7j)],u);function b(){const $=(0,O.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=j.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),c=(0,O.localize)(5,null),m=(0,O.localize)(6,null),i=(0,O.localize)(7,null),o=`
|       | ${h} | ${c} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${$} ${l} ${d}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}P.$Zn.as(S.$5n.Configuration).registerConfiguration({id:p.$Tl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[p.$Ul]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.$Zn.as(S.$5n.Configuration).registerConfiguration({id:p.$Tl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[p.$Wl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,O.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,O.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${p.$Ul}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[234],he([0,1,14,26,277,233]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=void 0;async function O(C,P){const p=await P.request(C,A.CancellationToken.None),f=(await(0,I.$Ge)(p.stream)).toString(),u=p.res.statusCode??200;return{headers:p.res.headers,statusCode:u,responseData:f}}async function R(C){const P={method:C.type,headers:C.headers};return new Promise((f,u)=>{const b=j.request(C.url??"",P,$=>{$.on("data",function(l){f({headers:$.headers,statusCode:$.statusCode??200,responseData:l.toString()})}),$.on("error",function(l){u(l)})});b.write(C.data,$=>{$&&u($)}),b.end()})}async function S(C,P,p){const f=typeof P.data=="string"?P.data:new TextDecoder().decode(P.data),u={type:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data).toString()},url:P.urlString,data:f};try{const b=C?await O(u,C):await R(u);p(b.statusCode,b.headers,b.responseData)}catch{p(0,{})}}class g extends L.$LP{constructor(P,p,f,u,b){const $={sendPOST:(l,d)=>{S(P,l,d)}};super(p,f,u,b,$)}}e.$MP=g}),define(le[235],he([0,1,23,92,21,16,9,24,22,108,109,110]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;let p=class{constructor(u,b,$,l,d,h){this.b=u,this.c=b,this.d=$,this.e=l,this.f=d,this.g=h,this.a=new Map}h(u){if(!this.a.has(u.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const $=[u.id,JSON.stringify(b),u.aiKey],d=new A.$Iq(I.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:$,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new g.$Hac(d),new C.$50b(this.d,this.e,this.f,this.g,`[${u.id}] `)];this.a.set(u.id,new P.$Hr({appenders:h,sendErrorTelemetry:u.sendErrorTelemetry},this.b,this.g))}return this.a.get(u.id)}publicLog(u,b,$){this.h(u).publicLog(b,$)}publicLogError(u,b,$){this.h(u).publicLogError(b,$)}};e.$2bc=p,e.$2bc=p=ye([Q(0,j.$Ni),Q(1,S.$Ml),Q(2,O.$Nj),Q(3,O.$Oj),Q(4,L.$oi),Q(5,R.$7j)],p)}),define(le[78],he([0,1,3,8,21,4,9]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$2v=e.$Zv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Vv=e.$Uv=void 0,e.$Wv=g,e.$Xv=P,e.$Yv=p,e.$1v=f,e.$3v=u,e.$4v=b,e.$Uv=(0,L.$hi)("tunnelService"),e.$Vv=(0,L.$hi)("sharedTunnelsService");var R;(function(d){d.Http="http",d.Https="https"})(R||(e.TunnelProtocol=R={}));var S;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(S||(e.TunnelPrivacyId=S={}));function g(d){return!!d.forwardPort}var C;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function P(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(h)return{address:h[1],port:+h[2]}}function p(d){if(d.scheme!=="http"&&d.scheme!=="https"||!d.query)return;const h=d.query.split("&");for(const c of h){const m=c.split("=")[1];if(/^https?:/.exec(m)){const i=P(A.URI.parse(m));if(i)return i}}}e.$Zv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function f(d){return e.$Zv.indexOf(d)>=0}e.$2v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(d){return e.$2v.indexOf(d)>=0}function b(d,h,c,m){if(c===1)return!1;if(c===2&&u(h)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(i?.length===4&&parseInt(i[1])>=18)return!1}return d<1024}class ${constructor(h,c,m){this.remoteAddress=h,this.localAddress=c,this.b=m,this.a=new I.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5v=$;let l=class{constructor(h,c){this.k=h,this.l=c,this.a=new I.$7d,this.onTunnelOpened=this.a.event,this.b=new I.$7d,this.onTunnelClosed=this.b.event,this.c=new I.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],c=Array.from(this.e.values());for(const m of c){const i=Array.from(m.values());for(const o of i){const n=await o.value;n&&typeof n!="string"&&h.push(n)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:c}of h.values())await c.then(m=>typeof m!="string"?m?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,c,m,i,o){this.q(h,c,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:c,localAddress:m,privacy:i,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,c){(u(h)||f(h))&&(h=e.$Zv[0]);const m=this.s(h,c);if(m)return++m.refcount,m.value}openTunnel(h,c,m,i,o,n=!1,s,t){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${m} on local port ${o}.`);const r=this.f??h;if(!r)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(m)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(r,c,m,i,o,n,s,t);return a?a.then(v=>{if(v){if(typeof v=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,m),v}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,m);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const y=this.o(v);return(v.tunnelRemoteHost!==c||v.tunnelRemotePort!==m)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&v.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(y),y}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const c=this.e.get(h.tunnelRemoteHost);if(c){const m=c.get(h.tunnelRemotePort);m&&(m.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,m))}}}}async p(h,c,m){if(m.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${c}.`);const i=m.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(c),i}}async closeTunnel(h,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${c} `);const m=this.e.get(h);if(m&&m.has(c)){const i=m.get(c);i.refcount=0,await this.p(h,c,i)}}q(h,c,m){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(c,{refcount:1,value:m})}async r(h,c){const m=this.e.get(h);if(m){const i=m.get(c),o=i?await i.value:void 0;(!o||typeof o=="string")&&m.delete(c),m.size===0&&this.e.delete(h)}}s(h,c){const m=[h];f(h)?(m.push(...e.$Zv),m.push(...e.$2v)):u(h)&&m.push(...e.$2v);const i=m.map(o=>this.e.get(o));for(const o of i){const n=o?.get(c);if(n)return n}}canTunnel(h){return!!P(h)}u(h,c,m,i,o,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${m} on local port ${i}.`);const t=m;this.j.add(t);const r=i===void 0?m:i,a={elevationRequired:o?this.isPortPrivileged(r):!1},v={remoteAddress:{host:c,port:m},localAddressPort:i,privacy:n,public:n?n!==S.Private:void 0,protocol:s},y=h.forwardPort(v,a);return y?(this.q(c,m,y),y.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(t)})):this.j.delete(t),y}};e.$6v=l,e.$6v=l=ye([Q(0,O.$Nj),Q(1,j.$Ni)],l)}),define(le[236],he([0,1,9,78,2,7,6]),function(se,e,I,A,j,L,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class S extends j.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Eh),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.B(P)}}let g=class extends j.$Uc{static{R=this}static{this.a=0}constructor(P,p){super(),this.f=P,this.g=p,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(P,p,f,u,b,$,l){const d=new S,h=await Promise.resolve(this.f.openTunnel(P,d,f,u,b,$,l));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${u} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this.c.has(p))throw this.c.delete(p),d.dispose(),await h.dispose(),(0,L.$6)();return d.setTunnel(h),this.b.set(p,d),this.g.info(`[SharedProcessTunnelService] Created tunnel ${p}: ${h.localAddress} (local) to ${f}:${u} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(P,p){const f=this.b.get(P);f&&f.setAddress(p)}async destroyTunnel(P){const p=this.b.get(P);if(p){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await p.dispose();return}this.c.add(P)}};e.$_bc=g,e.$_bc=g=R=ye([Q(0,A.$Vv),Q(1,I.$Nj)],g)}),define(le[28],he([0,1,4]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,I.$hi)("IUriIdentityService")}),define(le[237],he([0,1,28,190,12,20,128,3,2]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class g{static{this._clock=0}constructor(p){this.uri=p,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(p){this.g=p,this.c=new S.$Tc,this.f=2**16;const f=new Map,u=b=>{let $=f.get(b.scheme);return $===void 0&&($=p.hasProvider(b)&&!this.g.hasCapability(b,1024),f.set(b.scheme,$)),$};this.c.add(R.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new L.$Jg(u),this.d=new O.$gs((b,$)=>this.extUri.compare(b,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.$Vg)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new g(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((u,b)=>u[1].time<b[1].time?1:u[1].time>b[1].time?-1:0);g._clock=0,this.d.clear();const f=this.f*.5;for(let u=0;u<f;u++)this.d.set(p[u][0],p[u][1].touch())}};e.$hs=C,e.$hs=C=ye([Q(0,j.$Nk)],C),(0,A.$es)(I.$ll,C,1)}),define(le[238],he([0,1,3,2,12,49,35]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class R extends A.$Uc{constructor(g,C,P,p,f,u){super(),this.f=g,this.g=C,this.h=P,this.j=p,this.m=f,this.n=u,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$7d),this.onDidChangeFile=this.a.event,this.b=L.$ni.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Cc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,P,p,f){return this.g.read(g,C,P,p,f)}write(g,C,P,p,f){return this.g.write(g,C,P,p,f)}watch(g,C){this.b.set(g,g);const P=this.g.watch(this.t(g),C);return(0,A.$Sc)(()=>{this.b.delete(g),P.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,P){return this.g.rename(this.t(g),this.t(C),P)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,P){return this.g.readFileStream(this.t(g),C,P)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,P){return this.g.writeFile(this.t(g),C,P)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,P){if((0,j.$Rk)(this.g))return this.g.copy(this.t(g),this.t(C),P);throw new Error("copy not supported")}cloneFile(g,C){if((0,j.$Sk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const P of g){if(P.resource.scheme!==this.f)continue;const p=this.u(P.resource);this.b.findSubstr(p)&&C.push({resource:p,type:P.type,cId:P.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$ubc=R}),define(le[79],he([0,1,62]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=A,e.$2Hb=j,e.$3Hb=L;function A(O,R,S,g){const C=(0,I.$Jn)(O,R,S,g)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}function j(O,R,S){let g=S;for(;g>=0;){if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&O.charAt(g)===R.charAt(0))return g+2}return 0}function L(O,R,S){let g=S;for(;g>=0;)if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&O.charAt(g)===R.charAt(1)))return g;return O.length-1}}),define(le[239],he([0,1,30,55,13]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=L;function L(f,u,b,$,l,d){const h=[],c=[],m=[];if(!u){const T=f.filter(({identifier:_})=>l.every(X=>X.toLowerCase()!==_.id.toLowerCase()));return{local:{added:h,removed:c,updated:m},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}f=f.map(P),u=u.map(P),b=b?b.map(P):null;const i=new Map,o=T=>{T.uuid&&i.set(T.id.toLowerCase(),T.uuid)};f.forEach(({identifier:T})=>o(T)),u.forEach(({identifier:T})=>o(T)),b?.forEach(({identifier:T})=>o(T)),$?.forEach(({identifier:T})=>o(T)),d?.forEach(T=>o(T));const n=T=>{const _=T.identifier.uuid||i.get(T.identifier.id.toLowerCase());return _?`uuid:${_}`:`id:${T.identifier.id.toLowerCase()}`},s=(T,_)=>(T.set(n(_),_),T),t=f.reduce(s,new Map),r=u.reduce(s,new Map),a=u.reduce((T,_)=>s(T,(0,I.$Nn)(_)),new Map),v=b?b.reduce(s,new Map):null,y=$.reduce(s,new Map),w=l.reduce((T,_)=>{const X=i.get(_.toLowerCase());return T.add(X?`uuid:${X}`:`id:${_.toLowerCase()}`)},new Set),k=d?d.reduce((T,{id:_,uuid:X})=>(X=X??i.get(_.toLowerCase()),T.add(X?`uuid:${X}`:`id:${_.toLowerCase()}`)),new Set):null,E=O(t,r,w,!1);if(E.added.size>0||E.removed.size>0||E.updated.size>0){const T=O(v,t,w,!1),_=O(v,r,w,!0),X=(ee,H,K,W)=>{let B,ne,oe;return H.installed?(B=W.pinned,oe=W.preRelease,B&&(ne=W.version)):(B=K.pinned,oe=K.preRelease,B&&(ne=K.version)),B===void 0&&(B=H.pinned,B&&(ne=H.version)),oe===void 0&&(oe=H.preRelease),{...W,installed:H.installed||K.installed,pinned:B,preRelease:oe,version:ne??(K.version&&(!H.installed||A.gt(K.version,H.version))?K.version:H.version),state:S(H,K,v?.get(ee))}};for(const ee of _.removed.values()){const H=t.get(ee);if(!H)continue;const K=(0,j.$6f)(v?.get(ee)),W=k&&!k.has(ee)&&K.installed;H.installed&&W?c.push(H.identifier):a.set(ee,H)}for(const ee of _.added.values()){const H=(0,j.$6f)(r.get(ee)),K=t.get(ee);if(K){if(E.updated.has(ee)){const W=X(ee,K,H,H);R(K,H,!1,!1)||m.push(p(W,ee)),a.set(ee,W)}}else H.installed&&h.push(p(H,ee))}for(const ee of _.updated.values()){const H=(0,j.$6f)(r.get(ee)),K=(0,j.$6f)(v?.get(ee)),W=t.get(ee);if(W)if(k&&!k.has(ee)&&K.installed&&W.installed&&!H.installed)c.push(W.identifier);else{const ne=X(ee,W,H,H);m.push(p(ne,ee)),a.set(ee,ne)}else H.installed&&h.push(p(H,ee))}for(const ee of T.added.values())_.added.has(ee)||a.set(ee,(0,j.$6f)(t.get(ee)));for(const ee of T.updated.values()){if(_.removed.has(ee)||_.updated.has(ee))continue;const H=(0,j.$6f)(t.get(ee)),K=(0,j.$6f)(r.get(ee));a.set(ee,X(ee,H,K,H))}for(const ee of T.removed.values())_.updated.has(ee)||_.removed.has(ee)||y.has(ee)||(0,j.$6f)(r.get(ee)).installed&&k&&(k.has(ee)||!(0,j.$6f)(v?.get(ee)).installed||a.delete(ee))}const D=[],U=O(r,a,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&a.forEach((T,_)=>D.push(p(T,_))),{local:{added:h,removed:c,updated:m},remote:F?{added:[...U.added].map(T=>a.get(T)),updated:[...U.updated].map(T=>a.get(T)),removed:[...U.removed].map(T=>r.get(T)),all:D}:null}}function O(f,u,b,$){const l=f?[...f.keys()].filter(i=>!b.has(i)):[],d=[...u.keys()].filter(i=>!b.has(i)),h=d.filter(i=>!l.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=l.filter(i=>!d.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),m=new Set;for(const i of l){if(c.has(i))continue;const o=f.get(i),n=u.get(i);(!n||!R(o,n,$,!0))&&m.add(i)}return{added:h,removed:c,updated:m}}function R(f,u,b,$){return!(f.disabled!==u.disabled||!!f.isApplicationScoped!=!!u.isApplicationScoped||$&&f.installed!==u.installed||f.installed&&u.installed&&(f.preRelease!==u.preRelease||f.pinned!==u.pinned||u.pinned&&f.version!==u.version)||!C(f.state,u.state)||b&&f.version!==u.version)}function S(f,u,b){const $=f.state,l=u.state,d=b?.state;if(!u.version||$&&A.gt(f.version,u.version))return $;if(l&&A.gt(u.version,f.version)||!$)return l;if(!l)return $;const h=(0,I.$Nn)($),c=d?g(d,l):{added:Object.keys(l).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},m=d?g(d,$):{added:Object.keys($).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])h[i]=l[i];for(const i of c.removed.values())m.updated.has(i)||delete h[i];return h}function g(f,u){const b=Object.keys(f),$=Object.keys(u),l=$.filter(c=>!b.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),d=b.filter(c=>!$.includes(c)).reduce((c,m)=>(c.add(m),c),new Set),h=new Set;for(const c of b){if(d.has(c))continue;const m=f[c],i=u[c];(0,I.$Rn)(m,i)||h.add(c)}return{added:l,removed:d,updated:h}}function C(f={},u={}){const{added:b,removed:$,updated:l}=g(f,u);return b.size===0&&$.size===0&&l.size===0}function P(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function p(f,u){const b={...f,identifier:{id:f.identifier.id,uuid:u.startsWith("uuid:")?u.substring(5):void 0},preRelease:!!f.preRelease,pinned:!!f.pinned};return f.disabled||delete b.disabled,f.installed||delete b.installed,f.state||delete b.state,f.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Jb=e.$9Jb=void 0,e.$9Jb=(0,j.$hi)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),S&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),S&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const S=R.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),g=this.b().map(p=>p.toLowerCase()),C=[],P=[];if(Array.isArray(g))for(const p of g)p.startsWith("-")?P.push(p.substring(1)):C.push(p);return(0,I.$Mb)([...S,...C].filter(p=>!P.includes(p)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$0Jb=L,e.$0Jb=L=ye([Q(0,A.$Ni)],L)}),define(le[240],he([0,1,17,34,30,93,79]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=S;function R(c){return(0,A.$un)(c)||[]}async function S(c,m,i,o,n){const s=R(c),t=R(m),r=i?R(i):null,a=[...s,...t,...r||[]].map(X=>X.key),v=await n.resolveUserBindings(a),y=C(s,t,r,v);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const w=p(s),k=p(t),E=r?p(r):null,D=u(w,k,v),U=E?u(E,w,v):{added:[...w.keys()].reduce((X,ee)=>(X.add(ee),X),new Set),removed:new Set,updated:new Set},F=E?u(E,k,v):{added:[...k.keys()].reduce((X,ee)=>(X.add(ee),X),new Set),removed:new Set,updated:new Set},T=g(D,U,F);let _=c;for(const X of T.removed.values())T.conflicts.has(X)||(_=d(_,X,o));for(const X of T.added.values()){if(T.conflicts.has(X))continue;const ee=k.get(X);if(ee.some(H=>H.command!==`-${X}`&&y.conflicts.has(v[H.key]))){T.conflicts.add(X);continue}_=l(_,ee,o)}for(const X of T.updated.values()){if(T.conflicts.has(X))continue;const ee=k.get(X);if(ee.some(H=>H.command!==`-${X}`&&y.conflicts.has(v[H.key]))){T.conflicts.add(X);continue}_=h(_,X,ee,o)}return{mergeContent:_,hasChanges:!0,hasConflicts:T.conflicts.size>0}}function g(c,m,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of m.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(m.updated.has(r)?t.add(r):n.add(r));for(const r of m.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(m.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of m.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(m.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,m,i,o){const n=new Set,s=P(c,o),t=P(m,o),r=i?P(i,o):null,a=f(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?f(r,s):{added:[...s.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?f(r,t):{added:[...t.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:w,removed:k,updated:E,conflicts:D}=g(a,v,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:w,removed:k,updated:E,conflicts:D}}function P(c,m){const i=new Map;for(const o of c){const n=m[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function p(c){const m=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=m.get(o);n||(n=[],m.set(o,n)),n.push(i)}return m}function f(c,m){const i=[...c.keys()],o=[...m.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(y=>({...y,key:r})),v=m.get(r).map(y=>({...y,key:r}));(0,I.$ub)(a,v,(y,w)=>$(y,w))||t.add(r)}return{added:n,removed:s,updated:t}}function u(c,m,i){const o=[...c.keys()],n=[...m.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=c.get(a).map(w=>({...w,key:i[w.key]})),y=m.get(a).map(w=>({...w,key:i[w.key]}));b(v,y)||r.add(a)}return{added:s,removed:t,updated:r}}function b(c,m){return!(!(0,I.$ub)(c.filter(({command:i})=>i[0]!=="-"),m.filter(({command:i})=>i[0]!=="-"),(i,o)=>$(i,o))||!(0,I.$ub)(c.filter(({command:i})=>i[0]==="-"),m.filter(({command:i})=>i[0]==="-"),(i,o)=>$(i,o)))}function $(c,m){if(c.command!==m.command||c.key!==m.key)return!1;const i=L.$fj.deserialize(c.when),o=L.$fj.deserialize(m.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!j.$Rn(c.args,m.args))}function l(c,m,i){for(const o of m)c=O.edit(c,[-1],o,i);return c}function d(c,m,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===m||o[n].command===`-${m}`)&&(c=O.edit(c,[n],void 0,i));return c}function h(c,m,i,o){const n=R(c),s=n.findIndex(t=>t.command===m||t.command===`-${m}`);for(let t=n.length-1;t>=0;t--)(n[t].command===m||n[t].command===`-${m}`)&&(c=O.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=O.edit(c,[s],i[t],o);return c}}),define(le[241],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9b=I,e.$Y9b=j;function I(L,O,R){const S={},g={},C=new Set;if(!O)return{local:{added:S,updated:g,removed:[...C.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const P=A(L,O);if(P.added.size===0&&P.removed.size===0&&P.updated.size===0)return{local:{added:S,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=A(R,L),f=A(R,O),u={},b={},$=new Set,l=new Set;for(const d of p.removed.values())f.updated.has(d)?S[d]=O[d]:$.add(d);for(const d of f.removed.values())l.has(d)||(p.updated.has(d)?l.add(d):C.add(d));for(const d of p.updated.values())l.has(d)||(f.updated.has(d)?P.updated.has(d)&&l.add(d):b[d]=L[d]);for(const d of f.updated.values())l.has(d)||(p.updated.has(d)?P.updated.has(d)&&l.add(d):L[d]!==void 0&&(g[d]=O[d]));for(const d of p.added.values())l.has(d)||(f.added.has(d)?P.updated.has(d)&&l.add(d):u[d]=L[d]);for(const d of f.added.values())l.has(d)||(p.added.has(d)?P.updated.has(d)&&l.add(d):S[d]=O[d]);return{local:{added:S,removed:[...C.values()],updated:g},remote:{added:u,removed:[...$.values()],updated:b},conflicts:[...l.values()]}}function A(L,O){const R=L?Object.keys(L):[],S=O?Object.keys(O):[],g=S.filter(p=>!R.includes(p)).reduce((p,f)=>(p.add(f),p),new Set),C=R.filter(p=>!S.includes(p)).reduce((p,f)=>(p.add(f),p),new Set),P=new Set;for(const p of R){if(C.has(p))continue;const f=L[p],u=O[p];f!==u&&P.add(p)}return{added:g,removed:C,updated:P}}function j(L,O){const{added:R,removed:S,updated:g}=A(L,O);return R.size===0&&S.size===0&&g.size===0}}),define(le[242],he([0,1,30]),function(se,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=A;function A(L,O,R,S){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const p=L.filter(({id:f})=>!S.includes(f));return p.length?C.added=p:C=null,{local:g,remote:C}}const P=j(L,O,S);if(P.added.length>0||P.removed.length>0||P.updated.length>0){const p=j(R,L,S),f=j(R,O,S);for(const u of f.removed){const b=L.find($=>$.id===u);b&&g.removed.push(b)}for(const u of f.added){const b=O.find($=>$.id===u);p.added.includes(u)?P.updated.includes(u)&&g.updated.push(b):g.added.push(b)}for(const u of f.updated)g.updated.push(O.find(b=>b.id===u));for(const u of p.added)f.added.includes(u)||C.added.push(L.find(b=>b.id===u));for(const u of p.updated)f.removed.includes(u)||f.updated.includes(u)||C.updated.push(L.find(b=>b.id===u));for(const u of p.removed){const b=O.find($=>$.id===u);b&&C.removed.push(b)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}function j(L,O,R){L=L?L.filter(({id:f})=>!R.includes(f)):[],O=O.filter(({id:f})=>!R.includes(f));const S=L.map(({id:f})=>f),g=O.map(({id:f})=>f),C=g.filter(f=>!S.includes(f)),P=S.filter(f=>!g.includes(f)),p=[];for(const{id:f,name:u,shortName:b,icon:$,useDefaultFlags:l}of L){if(P.includes(f))continue;const d=O.find(h=>h.id===f);(!d||d.name!==u||d.shortName!==b||d.icon!==$||!(0,I.$Rn)(d.useDefaultFlags,l))&&p.push(f)}return{added:C,removed:P,updated:p}}}),define(le[25],he([0,1,17,13,177,45,29,4,102,41]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpb=e.$Ppb=e.$Opb=e.$Npb=e.$Mpb=e.$Lpb=e.$Kpb=e.$Jpb=e.$Ipb=e.$Gpb=e.MergeState=e.Change=e.SyncStatus=e.$Fpb=e.$Epb=e.$Dpb=e.UserDataSyncErrorCode=e.$Bpb=e.$Apb=e.$zpb=e.$ypb=e.$xpb=e.$upb=e.SyncResource=e.$rpb=e.$qpb=void 0,e.$opb=C,e.$ppb=P,e.$spb=p,e.$tpb=f,e.$vpb=b,e.$wpb=$,e.$Cpb=l,e.$Hpb=s;function C(){const t=g.$Zn.as(L.$5n.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}function P(){const t=g.$Zn.as(L.$5n.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(y=>!!t[y].ignoreSync),a=Object.keys(t).filter(y=>t[y].scope===2||t[y].scope===6),v=C();return(0,I.$Mb)([...r,...a,...v])}e.$qpb="settingsSync",e.$rpb="settingsSync.keybindingsPerPlatform";function p(){const t="vscode://schemas/ignoredSettings",r=g.$Zn.as(L.$5n.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$rpb]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:O.$Eo,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Zn.as(S.$1n.JSONContribution),v=()=>{const y=C(),w=P(),k=Object.keys(L.$6n.properties).filter(U=>!w.includes(U)),E=w.filter(U=>!y.includes(U)),D={items:{type:"string",enum:[...k,...E.map(U=>`-${U}`)]}};a.registerSchema(t,D)};return r.onDidUpdateConfiguration(()=>v())}function f(t){return t&&(0,A.$Wf)(t)&&(0,A.$Uf)(t.id)&&Array.isArray(t.scopes)}var u;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(u||(e.SyncResource=u={})),e.$upb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}function $(t,r,a,v){return v.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$xpb=(0,R.$hi)("IUserDataSyncStoreManagementService"),e.$ypb=(0,R.$hi)("IUserDataSyncStoreService"),e.$zpb=(0,R.$hi)("IUserDataSyncLocalStoreService"),e.$Apb="x-operation-id",e.$Bpb="X-Execution-Id";function l(t){const r={};return r[e.$Bpb]=t,r}var d;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(d||(e.UserDataSyncErrorCode=d={}));class h extends Error{constructor(r,a,v,y){super(r),this.code=a,this.resource=v,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Dpb=h;class c extends h{constructor(r,a,v,y,w){super(r,v,void 0,w),this.url=a,this.serverCode=y}}e.$Epb=c;class m extends h{constructor(r,a){super(r,a)}}e.$Fpb=m,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const y=v[2]==="unknown"?void 0:v[2],w=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],y,w)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(h||(e.$Dpb=h={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Gpb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Ipb=(0,R.$hi)("IUserDataSyncEnablementService"),e.$Jpb=(0,R.$hi)("IUserDataSyncService"),e.$Kpb=(0,R.$hi)("IUserDataSyncResourceProviderService"),e.$Lpb=(0,R.$hi)("IUserDataAutoSyncService"),e.$Mpb=(0,R.$hi)("IUserDataSyncUtilService"),e.$Npb=(0,R.$hi)("IUserDataSyncLogService"),e.$Opb="userDataSync",e.$Ppb="vscode-userdata-sync",e.$Qpb="preview"}),define(le[243],he([0,1,30,25]),function(se,e,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJb=j;function j(O,R,S,g,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const P=L(O,R);if(P.added.size===0&&P.removed.size===0&&P.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=S?L(S,R):{added:Object.keys(R).reduce((d,h)=>(d.add(h),d),new Set),removed:new Set,updated:new Set},f=S?L(S,O):{added:Object.keys(O).reduce((d,h)=>(d.add(h),d),new Set),removed:new Set,updated:new Set},u={added:{},removed:[],updated:{}},b=I.$Nn(R),$=!S;for(const d of f.added.values())d!==A.$Gpb&&$&&p.added.has(d)||(b[d]=O[d]);for(const d of f.updated.values())b[d]=O[d];for(const d of f.removed.values())g.unregistered.includes(d)||delete b[d];for(const d of p.added.values()){const h=R[d];if(g.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(S&&f.added.has(d))continue;const c=O[d];c&&c.value===h.value||d===A.$Gpb&&$&&f.added.has(d)||(c?u.updated[d]=h:u.added[d]=h)}for(const d of p.updated.values()){const h=R[d];if(g.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(d)||f.removed.has(d))continue;const c=O[d];c&&c.value===h.value||(u.updated[d]=h)}for(const d of p.removed.values()){if(g.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}f.updated.has(d)||f.removed.has(d)||u.removed.push(d)}const l=L(R,b);return{local:u,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:b}}}function L(O,R){const S=Object.keys(O),g=Object.keys(R),C=g.filter(f=>!S.includes(f)).reduce((f,u)=>(f.add(u),f),new Set),P=S.filter(f=>!g.includes(f)).reduce((f,u)=>(f.add(u),f),new Set),p=new Set;for(const f of S){if(P.has(f))continue;const u=O[f],b=R[f];I.$Rn(u,b)||p.add(f)}return{added:C,removed:P,updated:p}}}),define(le[244],he([0,1,17,34,62,42,30,79,25]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Hb=g,e.$5Hb=p,e.$6Hb=f,e.$7Hb=u,e.$8Hb=$,e.$9Hb=d;function g(a,v,y){let w=[];y?w=P(y):w=C(v);const k=[],E=[...(0,S.$opb)()];if(Array.isArray(w))for(const D of w)D.startsWith("-")?E.push(D.substring(1)):k.push(D);return(0,I.$Mb)([...a,...k].filter(D=>!E.includes(D)))}function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function P(a){const v=(0,A.$un)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function p(a,v){const y=(0,A.$un)(a)||{};let w="{}";for(const k of Object.keys(y)){const E=(0,j.$Jn)(w,[k],y[k],v);w=(0,j.$Mn)(w,E)}return w}function f(a,v,y,w){if(y.length){const k=r(v),E=(0,A.$un)(v)||{},D=(0,A.$un)(a);if(!D)return a;const U=[];for(const F of y){const T=E[F],_=D[F];T===void 0?a=R.edit(a,[F],void 0,w):_!==void 0?a=R.edit(a,[F],T,w):U.push(i(F,k))}U.sort((F,T)=>F.startOffset-T.startOffset),U.forEach(F=>a=d(F.setting.key,v,a,w))}return a}function u(a,v,y,w,k,E){const D=f(a,v,w,E),U=y!==D,F=y!==v;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:D,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:f(v,a,w,E),remoteContent:null,hasConflicts:!1};if(y===null&&$(a)){const M=b(a,v,w)?null:f(v,a,w,E);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let T=a,_=v;const X=(0,A.$un)(a),ee=(0,A.$un)(v),H=y?(0,A.$un)(y):null,K=w.reduce((M,z)=>(M.add(z),M),new Set),W=l(X,ee,K),B=l(H,X,K),ne=l(H,ee,K),oe=new Map,te=new Set,ce=M=>{te.add(M);const z=k.filter(({key:Z})=>Z===M)[0];z?(T=R.edit(T,[M],z.value,E),_=R.edit(_,[M],z.value,E)):oe.set(M,{key:M,localValue:X[M],remoteValue:ee[M]})};for(const M of B.removed.values())ne.updated.has(M)?ce(M):_=R.edit(_,[M],void 0,E);for(const M of ne.removed.values())te.has(M)||(B.updated.has(M)?ce(M):T=R.edit(T,[M],void 0,E));for(const M of B.updated.values())te.has(M)||(ne.updated.has(M)?W.updated.has(M)&&ce(M):_=R.edit(_,[M],X[M],E));for(const M of ne.updated.values())te.has(M)||(B.updated.has(M)?W.updated.has(M)&&ce(M):T=R.edit(T,[M],ee[M],E));for(const M of B.added.values())te.has(M)||(ne.added.has(M)?W.updated.has(M)&&ce(M):_=d(M,T,_,E));for(const M of ne.added.values())te.has(M)||(B.added.has(M)?W.updated.has(M)&&ce(M):T=d(M,_,T,E));const G=oe.size>0||!b(T,_,w),q=G||!b(T,a,[]),N=G||!b(_,v,[]);return{localContent:q?T:null,remoteContent:N?_:null,conflictsSettings:[...oe.values()],hasConflicts:G}}function b(a,v,y){if(a===v)return!0;const w=(0,A.$un)(a),k=(0,A.$un)(v),E=y.reduce((F,T)=>(F.add(T),F),new Set),D=r(a).filter(F=>!(F.setting&&E.has(F.setting.key))),U=r(v).filter(F=>!(F.setting&&E.has(F.setting.key)));if(D.length!==U.length)return!1;for(let F=0;F<D.length;F++){const T=D[F],_=U[F];if(T.setting&&_.setting){if(T.setting.key!==_.setting.key||!O.$Rn(w[T.setting.key],k[T.setting.key]))return!1}else if(!T.setting&&!_.setting){if(T.value!==_.value)return!1}else return!1}return!0}function $(a){return a?r(a).length===0:!0}function l(a,v,y){const w=a?Object.keys(a).filter(F=>!y.has(F)):[],k=Object.keys(v).filter(F=>!y.has(F)),E=k.filter(F=>!w.includes(F)).reduce((F,T)=>(F.add(T),F),new Set),D=w.filter(F=>!k.includes(F)).reduce((F,T)=>(F.add(T),F),new Set),U=new Set;if(a)for(const F of w){if(D.has(F))continue;const T=a[F],_=v[F];O.$Rn(T,_)||U.add(F)}return{added:E,removed:D,updated:U}}function d(a,v,y,w){const k=(0,A.$un)(v),E=r(v),D=r(y),U=h(a,E,D);return c(y,a,k[a],U,D,w)}function h(a,v,y){const w=v.findIndex(E=>E.setting?.key===a),k=v[w-1];if(k){if(k.setting){const D=i(k.setting.key,y);if(D)return{index:y.indexOf(D),insertAfter:!0}}else{const D=o(w,v);if(D){const U=i(D.setting.key,y);if(U){const F=n(y.indexOf(U),y),T=s(v,D,v[w]);if(F){const _=s(y,U,F),X=t(T,_);return X?{index:y.indexOf(X),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const _=s(y,U,y[y.length-1]),X=t(T,_);return X?{index:y.indexOf(X),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const E=v[w+1];if(E)if(E.setting){const D=i(E.setting.key,y);if(D)return{index:y.indexOf(D),insertAfter:!1}}else{const D=n(w,v);if(D){const U=i(D.setting.key,y);if(U){const F=o(y.indexOf(U),y),T=s(v,v[w],D);if(F){const _=s(y,F,U),X=t(T.reverse(),_.reverse());return X?{index:y.indexOf(X),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const _=s(y,y[0],U),X=t(T.reverse(),_.reverse());return X?{index:y.indexOf(X),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function c(a,v,y,w,k,E){let D;return w.index===-1?D=(0,j.$Jn)(a,[v],y,E):D=m(a,v,y,w,k,E).map(U=>(0,j.$Kn)(a,U,E)[0]),(0,j.$Mn)(a,D)}function m(a,v,y,w,k,E){const D=`${JSON.stringify(v)}: ${JSON.stringify(y)}`,U=(0,L.$Gn)(E,a),F=k[w.index];if(w.insertAfter){const T=[];if(F.setting)T.push({offset:F.endOffset,length:0,content:","+D});else{const _=n(w.index,k),X=o(w.index,k),ee=X?.setting?.commaOffset;X&&ee===void 0&&T.push({offset:X.endOffset,length:0,content:","});const H=ee!==void 0&&ee>F.endOffset;T.push({offset:H?ee+1:F.endOffset,length:0,content:_?U+D+",":U+D})}return T}else{if(F.setting)return[{offset:F.startOffset,length:0,content:D+","}];const T=(k[w.index-1]&&!k[w.index-1].setting?U:"")+D+(n(w.index,k)?",":"")+U;return[{offset:F.startOffset,length:0,content:T}]}}function i(a,v){return v.filter(y=>y.setting?.key===a)[0]}function o(a,v){for(let y=a-1;y>=0;y--)if(v[y].setting)return v[y]}function n(a,v){for(let y=a+1;y<v.length;y++)if(v[y].setting)return v[y]}function s(a,v,y){const w=a.indexOf(v),k=a.indexOf(y);return a.filter((E,D)=>w<D&&D<k)}function t(a,v){if(a.length&&v.length){let y=0;for(;y<v.length&&y<a.length;y++)if(a[y].value!==v[y].value)return v[y-1];return v[y-1]}}function r(a){const v=[];let y=-1,w,k;const E={onObjectBegin:D=>{y++},onObjectProperty:(D,U,F)=>{y===0&&(w=U,k=D)},onObjectEnd:(D,U)=>{y--,y===0&&v.push({startOffset:w,endOffset:D+U,value:a.substring(w,D+U),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(D,U)=>{y++},onArrayEnd:(D,U)=>{y--,y===0&&v.push({startOffset:w,endOffset:D+U,value:a.substring(w,D+U),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(D,U,F)=>{y===0&&v.push({startOffset:w,endOffset:U+F,value:a.substring(w,U+F),setting:{key:k,commaOffset:void 0}})},onSeparator:(D,U,F)=>{if(y===0&&D===","){let T=v.length-1;for(;T>=0&&!v[T].setting;T--);const _=v[T];_&&v.splice(T,1,{startOffset:_.startOffset,endOffset:_.endOffset,value:_.value,setting:{key:_.setting.key,commaOffset:U}})}},onComment:(D,U)=>{y===0&&v.push({startOffset:D,endOffset:D+U,value:a.substring(D,D+U)})}};return(0,A.$Bn)(a,E),v}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OHb=e.$NHb=void 0,e.$NHb=(0,j.$hi)("IUserDataSyncAccountService");let O=class extends A.$Uc{get account(){return this.a}constructor(S,g){super(),this.g=S,this.h=g,this.b=this.B(new I.$7d),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$7d),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$OHb=O,e.$OHb=O=ye([Q(0,L.$ypb),Q(1,L.$Npb)],O)}),define(le[245],he([0,1,20,178,16,9,25]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Jb=void 0;let R=class extends L.$Sj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,I.$Ug)(C.logsHome,`${O.$Opb}.log`),{id:O.$Opb,name:(0,A.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$$Jb=R,e.$$Jb=R=ye([Q(0,L.$Oj),Q(1,j.$oi)],R)}),define(le[246],he([0,1,6,3,2]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class L extends j.$Uc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:S,getActiveWindowId:g}){super(),this.a=this.B(new j.$Tc),A.Event.latch(A.Event.any(R,S))(this.f,this,this.a),this.b=(0,I.$7g)(()=>g()),(async()=>{try{const P=await this.b;this.c=typeof this.c=="number"?this.c:P}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$2ac=L}),define(le[112],he([0,1,181,15,49,20,8,4,23]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=g,e.$si=C,e.$vi=P,e.$wi=p,e.$xi=f,e.$yi=b,e.$zi=$,e.$Ci=h,e.$Hi=c,e.$Ii=m,e.$Ki=i,e.$Li=o,e.$Mi=n,e.$qi=(0,R.$hi)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}function C(s){return typeof s?.id=="string"&&!g(s)&&!p(s)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function P(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.$oc)(s)}:t?e.$ti:e.$ui;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function p(s){const t=s;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}function f(s){const t=s;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}var u;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(u||(e.WorkbenchState=u={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}function $(s){const t=s;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}class l{constructor(t,r,a,v,y){this.h=t,this.j=a,this.k=v,this.l=y,this.c=j.$ni.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=j.$ni.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=l;class d{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$Ug)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=d;function h(s){return new d({uri:s,index:0,name:(0,L.$Qg)(s)},{uri:s.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,I.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function c(s,t){return L.$Lg.isEqualOrParent(s,t.untitledWorkspacesHome)}function m(s){let t;return O.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===S.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ji}function o(s,t){return!c(s,t)&&!m(s)}function n(s){return(typeof s=="string"?(0,A.$pc)(s):(0,L.$Sg)(s))===e.$Ei}}),define(le[18],he([0,1,54,3,2,20,8,172,16,12,4,9,112,35,28,6,32,27,13]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=c,e.$ol=m,e.$pl=i;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$nl=(0,C.$hi)("IUserDataProfilesService");function m(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:t}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function i(s,t,r,a,v,y){return{id:s,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:y&&v?.useDefaultFlags?.globalState?y.globalStorageHome:(0,L.$Ug)(r,"globalStorage"),settingsResource:y&&v?.useDefaultFlags?.settings?y.settingsResource:(0,L.$Ug)(r,"settings.json"),keybindingsResource:y&&v?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,L.$Ug)(r,"keybindings.json"),tasksResource:y&&v?.useDefaultFlags?.tasks?y.tasksResource:(0,L.$Ug)(r,"tasks.json"),snippetsHome:y&&v?.useDefaultFlags?.snippets?y.snippetsHome:(0,L.$Ug)(r,"snippets"),extensionsResource:y&&v?.useDefaultFlags?.extensions?y.extensionsResource:(0,L.$Ug)(r,"extensions.json"),cacheHome:(0,L.$Ug)(a,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let o=class extends j.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new A.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Bc,emptyWindows:new Map},this.profilesHome=(0,L.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,d.$Uf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(i((0,L.$Rg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},t))}}catch(y){this.y.error(y)}const a=new f.$Bc,v=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[w,k]of Object.entries(y.workspaces)){const E=O.URI.parse(w),D=r.find(U=>U.id===k);D&&a.set(E,D)}if(y.emptyWindows)for(const[w,k]of Object.entries(y.emptyWindows)){const E=r.find(D=>D.id===k);E&&v.set(w,E)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Ze)(r)}\\s(\\d+)`);let v=0;for(const w of this.profiles){const k=a.exec(w.name),E=k?parseInt(k[1]):0;v=E>v?E:v}const y=`${r} ${v+1}`;return this.createProfile((0,I.$8i)((0,$.$Dg)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,I.$8i)((0,$.$Dg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,y),y}async F(t,r,a){if(!(0,d.$Uf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const y=this.profiles.find(E=>E.name===r||E.id===t);if(y)return y;const w=i(t,r,(0,L.$Ug)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(w.location);const k=[];return this.j.fire({profile:w,join(E){k.push(E)}}),await b.Promises.settled(k),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$5k)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,p.$ri)(t)?t.uri:(0,p.$wi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],y=[];this.s.profiles=[];for(let w of v)w.isDefault||r.some(k=>w.id===k.id)||(w=a.find(k=>w.id===k.id)??w,w.isTransient?this.s.profiles.push(w):y.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(y),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),y=a?this.s:this.C;O.URI.isUri(v)?(y.workspaces.delete(v),r&&y.workspaces.set(v,r)):(y.emptyWindows.delete(v),r&&y.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[y,w]of Object.entries(t.workspaces)){const k=O.URI.parse(w);r[y]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}const v={};if(t.emptyWindows)for(const[y,w]of Object.entries(t.emptyWindows)){const k=O.URI.parse(w);v[y]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$ql=o,e.$ql=o=ye([Q(0,S.$oi),Q(1,g.$Nk),Q(2,u.$ll),Q(3,P.$Nj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$rl=n}),define(le[247],he([0,1,6,2,18]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;let L=class extends A.$Uc{constructor(R){super(),this.B(new I.$th(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$bcc=L,e.$bcc=L=ye([Q(0,j.$nl)],L)}),define(le[248],he([0,1,17,6,26,7,3,2,5,13,8,154,29,33,46,9,24,22,28,18]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$8p=void 0,e.$9p=m,e.$0p=i;let c=class extends R.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,y,w){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=y,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$7d),this.s=this.B(new O.$7d),this.t=this.B(new O.$7d),this.u=this.B(new O.$7d),this.w=this.B(new O.$7d),this.y=[],this.B((0,R.$Sc)(()=>{this.j.forEach(({task:k})=>k.cancel()),this.m.forEach(k=>k.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,p.$Oo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:y})=>(0,f.$fp)(y,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:new p.$Ro(`Unknown error while installing extension ${t.identifier.id}`,p.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new p.$Ro(P.localize(0,null),p.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:y})=>{try{const w=await this.N(v,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.G.version,date:this.G.date});a.push({...w,options:y})}catch(w){r.push({identifier:v.identifier,operation:2,source:v,error:w})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$np)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,u.$Fm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const y=(await this.getInstalled(1,v.extensionsResource)).find(w=>(0,f.$fp)(w.identifier,t.identifier));y?this.w.fire(y):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,v=[],y=[],w=(E,D)=>`${f.$gp.create(E).toString()}-${D.toString()}`,k=(E,D,U)=>{const F=this.Y(E,D,U),T=C.URI.isUri(D)?D.path:`${D.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`;a.set(T,{task:F,manifest:E}),this.n.fire({identifier:F.identifier,source:D,profileLocation:U.profileLocation}),this.F.info("Installing extension:",F.identifier.id),C.URI.isUri(D)||this.j.set(w(D,U.profileLocation),{task:F,waitingTasks:[]})};try{for(const{manifest:E,extension:D,options:U}of t){const F=U.isApplicationScoped||U.isBuiltin||(0,u.$Fm)(E),T={...U,installOnlyNewlyAddedFromExtensionPack:U.installOnlyNewlyAddedFromExtensionPack??!C.URI.isUri(D),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:U.profileLocation??this.X(),productVersion:U.productVersion??{version:this.G.version,date:this.G.date}},_=C.URI.isUri(D)?void 0:this.j.get(w(D,T.profileLocation));_?(this.F.info("Extension is already requested to install",_.task.identifier.id),v.push(_.task.waitUntilTaskIsFinished())):k(E,D,T)}await Promise.all([...a.values()].map(async({task:E,manifest:D})=>{if(E.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",E.identifier.id);else try{const U=await this.M(E.identifier,D,!!E.options.installOnlyNewlyAddedFromExtensionPack,!!E.options.installPreReleaseVersion,E.options.profileLocation,E.options.productVersion),F=await this.getInstalled(void 0,E.options.profileLocation,E.options.productVersion),T={...E.options,donotIncludePackAndDependencies:!0,context:{...E.options.context,[p.$Jo]:!0}};for(const{gallery:_,manifest:X}of(0,I.$Mb)(U,({gallery:ee})=>ee.identifier.id)){if(a.has(`${_.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`))continue;const ee=this.j.get(w(_,T.profileLocation));if(ee){if(this.J(E,ee.task)){const H=ee.task.identifier;this.F.info("Waiting for already requested installing extension",H.id,E.identifier.id),ee.waitingTasks.push(E),v.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,K=>K.some(W=>(0,f.$fp)(W.identifier,H)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",H.id,E.identifier.id),!K.find(B=>(0,f.$fp)(B.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else F.some(({identifier:H})=>(0,f.$fp)(H,_.identifier))||k(X,_,T)}}catch(U){if(C.URI.isUri(E.source))(0,I.$Lb)(D.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",E.identifier.id,U.message),(0,I.$Lb)(D.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",E.identifier.id,U.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",E.identifier.id),U}})),await this.L([...a.values()].map(async({task:E})=>{const D=new Date().getTime();try{const U=await E.run();if(await this.L(this.y.map(F=>F.postInstall(U,E.source,E.options,j.CancellationToken.None))),!C.URI.isUri(E.source)){const F=E.operation===3,T=F?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(o(this.C,F?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$np)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-D,durationSinceUpdate:T}),S.$o&&E.operation!==3)try{await this.z.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}}y.push({local:U,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.profileLocation,applicationScoped:U.isApplicationScoped})}catch(U){throw this.F.error("Error while installing the extension",E.identifier.id,(0,L.$0)(U)),U}})),v.length&&await this.L(v);for(const E of y)this.F.info("Extension installed successfully:",E.identifier.id),r.push(E);return r}catch(E){y.length&&await Promise.allSettled(y.map(async({local:D,profileLocation:U})=>{try{await this.Z(D,{versionOnly:!0,profileLocation:U}).run(),this.F.info("Rollback: Uninstalled extension",D.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",D.identifier.id,(0,L.$0)(F))}}));for(const{task:D}of a.values())D.cancel(),r.push({identifier:D.identifier,operation:2,source:D.source,context:D.options.context,profileLocation:D.profileLocation,error:E});throw E}finally{for(const{task:E}of a.values())E.source&&!C.URI.isUri(E.source)&&this.j.delete(w(E.source,E.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(y=>this.J(y,r)))||a===r&&v[0]&&!this.J(t,v[0]))return!1;return!0}async L(t){const r=[],a=[],v=await Promise.allSettled(t);for(const y of v)y.status==="fulfilled"?r.push(y.value):a.push(y.reason);if(a.length)throw m(a);return r}async M(t,r,a,v,y,w){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,y,w),E=[],D=[],U=async(F,T)=>{E.push(F);const _=T.extensionDependencies||[],X=[..._];if(T.extensionPack){const ee=a?k.find(H=>(0,f.$fp)(H.identifier,F)):void 0;for(const H of T.extensionPack)ee&&ee.manifest.extensionPack&&ee.manifest.extensionPack.some(K=>(0,f.$fp)({id:K},{id:H}))||X.every(K=>!(0,f.$fp)({id:K},{id:H}))&&X.push(H)}if(X.length){const ee=X.filter(H=>E.every(K=>!(0,f.$fp)(K,{id:H})));if(ee.length){const H=await this.z.getExtensions(ee.map(K=>({id:K,preRelease:v})),j.CancellationToken.None);for(const K of H){if(E.find(ne=>(0,f.$fp)(ne,K.identifier)))continue;const W=_.some(ne=>(0,f.$fp)({id:ne},K.identifier));let B;try{B=await this.N(K,!1,v,w)}catch(ne){if(W)throw ne;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,L.$0)(ne));continue}D.push({gallery:B.extension,manifest:B.manifest}),await U(B.extension.identifier,B.manifest)}}}};return await U(t,r),D}async N(t,r,a,v){let y;const w=await this.getExtensionsControlManifest();if(w.malicious.some(D=>(0,f.$fp)(t.identifier,D)))throw new p.$Ro(P.localize(1,null,t.identifier.id),p.ExtensionManagementErrorCode.Malicious);const k=w.deprecated[t.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),y=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:v},j.CancellationToken.None))[0],!y)throw new p.$Ro(P.localize(2,null,t.identifier.id,k.extension.id),p.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new p.$Ro(P.localize(3,null,t.identifier.id,this.G.nameLong,(0,p.$Ko)(D)),p.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.O(t,r,a,v),!y)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],j.CancellationToken.None))[0]?new p.$Ro(P.localize(4,null,t.displayName??t.identifier.id),p.ExtensionManagementErrorCode.ReleaseVersionNotFound):new p.$Ro(P.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),p.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",y.identifier.id);const E=await this.z.getManifest(y,j.CancellationToken.None);if(E===null)throw new p.$Ro(`Missing manifest for extension ${y.identifier.id}`,p.ExtensionManagementErrorCode.Invalid);if(E.version!==y.version)throw new p.$Ro(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,p.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:E}}async O(t,r,a,v){const y=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:y,compatible:!0,productVersion:v},j.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,y,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:y,compatible:!0,productVersion:v},j.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,y,v)),w}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},v=U=>`${U.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,y=this.m.get(v(t.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const w=U=>{const F=this.Z(U,a);return this.m.set(v(F.extension.identifier),F),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this.t.fire({identifier:U.identifier,profileLocation:a.profileLocation,applicationScoped:U.isApplicationScoped}),F},k=(U,F)=>{F?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,a.profileLocation.toString(),F.message):this.F.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,F.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$mp)(U),error:F}),this.u.fire({identifier:U.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:U.isApplicationScoped})},E=[],D=[];try{E.push(w(t));const U=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const F=this.S(t,U);for(const T of F)this.m.has(v(T.identifier))?this.F.info("Extensions is already requested to uninstall",T.identifier.id):E.push(w(T))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(E.map(F=>F.extension),U,t),await this.L(E.map(async F=>{try{if(await F.run(),await this.L(this.y.map(T=>T.postUninstall(F.extension,a,j.CancellationToken.None))),F.extension.identifier.uuid)try{await this.z.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}k(F.extension)}catch(T){const _=T instanceof p.$Ro?T:new p.$Ro((0,L.$0)(T),p.ExtensionManagementErrorCode.Internal);throw k(F.extension,_),_}finally{D.push(F)}}))}catch(U){const F=U instanceof p.$Ro?U:new p.$Ro((0,L.$0)(U),p.ExtensionManagementErrorCode.Internal);for(const T of E){try{T.cancel()}catch{}D.includes(T)||k(T.extension,F)}throw F}finally{for(const U of E)this.m.delete(v(U.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}Q(t,r,a){for(const v of t){const y=this.U(v,r);if(y.length){const w=y.filter(k=>!t.some(E=>(0,f.$fp)(E.identifier,k.identifier)));if(w.length)throw new Error(this.R(v,w,a))}}}R(t,r,a){return a===t?r.length===1?P.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const y=r.filter(k=>!k.isBuiltin&&v.some(E=>(0,f.$fp)({id:E},k.identifier))),w=[];for(const k of y)w.push(...this.S(k,r,a));return[...y,...w]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,f.$fp)({id:v},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$8p=c,e.$8p=c=ye([Q(0,p.$Qo),Q(1,l.$Ml),Q(2,d.$ll),Q(3,b.$Nj),Q(4,$.$7j),Q(5,h.$nl)],c);function m(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}function i(s){if(s instanceof p.$Ro)return s;if(s instanceof p.$So){const r=new p.$Ro(s.message,p.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new p.$Ro(s.message,p.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function o(s,t,{extensionData:r,verificationStatus:a,duration:v,error:y,durationSinceUpdate:w}){let k,E;(0,g.$3f)(a)&&(a===!0?a="Verified":(a===!1||(k=p.ExtensionManagementErrorCode.Signature,E=a),a="Unverified")),y&&(y instanceof p.$Ro||y instanceof p.$So?(k=y.code,y.code===p.ExtensionManagementErrorCode.Signature&&(E=y.message)):k=p.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!y,duration:v,errorcode:k,errorcodeDetail:E,durationSinceUpdate:w})}class n{constructor(){this.d=new A.$gh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$7g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$7g)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$$p=n}),define(le[52],he([0,1,6,14,2,3,35,8,29,33,12,4,9,18,28,13,7,22]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class h extends Error{constructor(n,s){super(n),this.code=s}}e.$_p=h,e.$aq=(0,P.$hi)("IExtensionsProfileScannerService");let c=class extends j.$Uc{constructor(n,s,t,r,a,v){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new L.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new L.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Bc}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,t){const r=[],a=[];try{return await this.u(s,v=>{const y=[];if(t)y.push(...v);else for(const w of v)n.some(([k])=>(0,g.$fp)(k.identifier,w.identifier)&&k.manifest.version!==w.version)?r.push(w):y.push(w);for(const[w,k]of n){const E=y.findIndex(U=>(0,g.$fp)(U.identifier,w.identifier)&&U.version===w.manifest.version),D={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:k};E===-1?(a.push(D),y.push(D)):y.splice(E,1,D)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),r.length&&this.f.fire({extensions:r,profileLocation:s}),y}),a.length&&this.c.fire({extensions:a,profileLocation:s}),r.length&&this.g.fire({extensions:r,profileLocation:s}),a}catch(v){throw a.length&&this.c.fire({extensions:a,error:v,profileLocation:s}),r.length&&this.g.fire({extensions:r,error:v,profileLocation:s}),v}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const v of r){const y=n.find(([w])=>(0,g.$fp)(w.identifier,v.identifier)&&w.manifest.version===v.version);y&&(v.metadata={...v.metadata,...y[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const v of r)(0,g.$fp)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$5k)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new h((0,$.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const y of a){m(y)||this.w(n);let w;if((0,b.$Uf)(y.relativeLocation)&&y.relativeLocation)w=this.z(y.relativeLocation);else if((0,b.$Uf)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{w=R.URI.revive(y.location);const k=this.y(w);k&&(v=!0,y.relativeLocation=k)}(0,b.$2f)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(v=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:w,version:y.version,metadata:y.metadata})}v&&await this.m.writeFile(n,A.$ue.fromString(JSON.stringify(a)))}if(s){r=s(r);const v=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,A.$ue.fromString(JSON.stringify(v)))}return r})}w(n){const s=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$5k)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>m(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ue.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$5k)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$5k)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$5k)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new I.$oh,this.h.set(n,s)),s}};e.$bq=c,e.$bq=c=ye([Q(1,C.$Nk),Q(2,f.$nl),Q(3,u.$ll),Q(4,l.$Ml),Q(5,p.$Nj)],c);function m(o){return(0,b.$Wf)(o)&&(0,S.$Po)(o.identifier)&&(i(o.location)||(0,b.$Uf)(o.location)&&o.location)&&((0,b.$2f)(o.relativeLocation)||(0,b.$Uf)(o.relativeLocation))&&o.version&&(0,b.$Uf)(o.version)}function i(o){return o?(0,b.$Uf)(o.path)&&(0,b.$Uf)(o.scheme):!1}}),define(le[81],he([0,1,17,6,30,14,7,34,138,2,23,15,5,20,55,88,13,8,157,16,33,46,71,12,4,9,24,3,66,52,18,28,186]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a,v,y,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$gq=e.$fq=e.$eq=e.Translations=void 0,e.$hq=_;var E;(function(ee){function H(K,W){if(K===W)return!0;const B=Object.keys(K),ne=new Set;for(const oe of Object.keys(W))ne.add(oe);if(B.length!==ne.size)return!1;for(const oe of B){if(K[oe]!==W[oe])return!1;ne.delete(oe)}return ne.size===0}ee.equals=H})(E||(e.Translations=E={})),e.$eq=(0,n.$hi)("IExtensionsScannerService");let D=class extends g.$Uc{constructor(H,K,W,B,ne,oe,te,ce,G,q,N,M){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=K,this.r=W,this.s=B,this.t=ne,this.u=oe,this.w=te,this.y=ce,this.z=G,this.C=q,this.D=N,this.F=M,this.g=this.B(new r.$7d),this.onDidChangeCache=this.g.event,this.h=(0,f.$Ug)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(T,this.s,this.h)),this.m=this.B(this.F.createInstance(T,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$qp)(this.w,this.y)),this.G}async scanAllExtensions(H,K,W){const[B,ne]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(K)]),oe=W?await this.scanExtensionsUnderDevelopment(H,[...B,...ne]):[];return this.L(B,ne,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const K=[];K.push(this.M(!!H.useCache,H.language)),K.push(this.N(H.language,!!H.checkControlFile));const[W,B]=await Promise.all(K);return this.J([...W,...B],0,H,!1)}async scanUserExtensions(H){const K=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const W=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(K,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,W,H.productVersion??this.R()),ne=H.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let oe;try{oe=await ne.scanExtensions(B)}catch(te){if(te instanceof v.$_p&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await ne.scanExtensions(B);else throw te}return oe=await this.J(oe,1,H,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(H,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===C.Schemas.file).map(async B=>{const ne=await this.P(B,!1,1,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ne)).map(te=>(te.type=K.find(ce=>(0,c.$fp)(ce.identifier,te.identifier))?.type??te.type,this.n.validate(te,ne)))}))).flat();return this.J(W,"development",H,!0)}return[]}async scanExistingExtension(H,K,W){const B=await this.P(H,!1,K,!0,W.language,!0,void 0,W.productVersion??this.R()),ne=await this.n.scanExtension(B);return!ne||!W.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(H,K,W){const B=await this.P(H,!1,K,!0,W.language,!0,void 0,W.productVersion??this.R()),ne=await this.n.scanOneOrMultipleExtensions(B);return this.J(ne,K,W,!0)}async scanMetadata(H){const K=(0,f.$Ug)(H,"package.json"),W=(await this.w.readFile(K)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(H,K){const W=(0,f.$Ug)(H,"package.json"),B=(await this.w.readFile(W)).value.toString(),ne=JSON.parse(B);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,ne.__metadata={...ne.__metadata,...K},await this.w.writeFile((0,f.$Ug)(H,"package.json"),L.$ue.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof v.$_p&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ue.fromString(JSON.stringify([])))}catch(K){(0,o.$5k)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,K,W,B){return W.includeAllVersions||(H=this.L(K===0?H:void 0,K===1?H:void 0,K==="development"?H:void 0,await this.getTargetPlatform(),B)),W.includeInvalid||(H=H.filter(ne=>ne.isValid)),H.sort((ne,oe)=>{const te=P.$oc(ne.location.fsPath),ce=P.$oc(oe.location.fsPath);return te<ce?-1:te>ce?1:0})}L(H,K,W,B,ne){const oe=(ce,G,q)=>{if(ce.isValid&&!G.isValid)return!1;if(ce.isValid===G.isValid){if(ne&&u.gt(ce.manifest.version,G.manifest.version))return this.y.debug(`Skipping extension ${G.location.path} with lower version ${G.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(u.eq(ce.manifest.version,G.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${G.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===B)return this.y.debug(`Skipping extension ${G.location.path} from different target platform ${G.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ce.location.path} with ${G.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${G.location.path}.`),!0},te=new m.$Em;return H?.forEach(ce=>{const G=te.get(ce.identifier.id);(!G||oe(G,ce,!1))&&te.set(ce.identifier.id,ce)}),K?.forEach(ce=>{const G=te.get(ce.identifier.id);if(!G&&H&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!G||oe(G,ce,!1))&&te.set(ce.identifier.id,ce)}),W?.forEach(ce=>{const G=te.get(ce.identifier.id);(!G||oe(G,ce,!0))&&te.set(ce.identifier.id,ce),te.set(ce.identifier.id,ce)}),[...te.values()]}async M(H,K){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),ne=await(H&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",ne.length),ne}async N(H,K){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const B=K?await this.O():{},ne=[],oe=l.URI.file(P.$ic(P.$kc(C.$Bg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of W){const G=B[ce.name]||"marketplace";switch(G){case"disabled":break;case"marketplace":ne.push((0,f.$Ug)(oe,ce.name));break;default:ne.push(l.URI.file(G));break}}const te=await Promise.all(ne.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,I.$Hb)(te)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,K,W,B,ne,oe,te,ce){const G=await this.f(ne??p.$w),q=await this.Q(H),N=K&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=N?await this.Q(N):void 0;return new U(H,q,N,M,K,te,W,B,oe,ce.version,ce.date,this.C.commit,!this.z.isBuilt,ne,G)}async Q(H){try{const K=await this.w.stat(H);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$fq=D,e.$fq=D=ye([Q(4,y.$nl),Q(5,v.$aq),Q(6,o.$Nk),Q(7,s.$Nj),Q(8,h.$oi),Q(9,t.$7j),Q(10,w.$ll),Q(11,n.$gi)],D);class U{constructor(H,K,W,B,ne,oe,te,ce,G,q,N,M,z,Z,J){this.location=H,this.mtime=K,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=B,this.profile=ne,this.profileScanOptions=oe,this.type=te,this.excludeObsolete=ce,this.validate=G,this.productVersion=q,this.productDate=N,this.productCommit=M,this.devMode=z,this.language=Z,this.translations=J}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,K){return(0,f.$Ng)(H.location,K.location)&&H.mtime===K.mtime&&(0,f.$Ng)(H.applicationExtensionslocation,K.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&H.profile===K.profile&&j.$Rn(H.profileScanOptions,K.profileScanOptions)&&H.type===K.type&&H.excludeObsolete===K.excludeObsolete&&H.validate===K.validate&&H.productVersion===K.productVersion&&H.productDate===K.productDate&&H.productCommit===K.productCommit&&H.devMode===K.devMode&&H.language===K.language&&E.equals(H.translations,K.translations)}}e.$gq=U;let F=class extends g.$Uc{constructor(H,K,W,B,ne){super(),this.f=H,this.g=K,this.h=W,this.j=B,this.m=ne}async scanExtensions(H){const K=H.profile?await this.r(H):await this.n(H);let W={};if(H.excludeObsolete&&H.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(B)}catch{}return(0,$.$8f)(W)?K:K.filter(B=>!W[c.$gp.create(B).toString()])}async n(H){const K=await this.j.resolve(H.location);if(!K.children?.length)return[];const W=await Promise.all(K.children.map(async B=>{if(!B.isDirectory||H.type===1&&(0,f.$Rg)(B.resource).indexOf(".")===0)return null;const ne=new U(B.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne)}));return(0,I.$Hb)(W).sort((B,ne)=>B.location.path<ne.location.path?-1:1)}async r(H){let K=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){K=K.filter(B=>!B.metadata?.isApplicationScoped);const W=await this.s(H.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,H);K.push(...W)}return K}async s(H,K,W){const B=await this.g.scanProfileExtensions(H,W.profileScanOptions);if(!B.length)return[];const ne=await Promise.all(B.map(async oe=>{if(K(oe)){const te=new U(oe.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(te,oe.metadata)}return null}));return(0,I.$Hb)(ne)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,f.$Ug)(H.location,"package.json"))){const K=await this.scanExtension(H);return K?[K]:[]}else return await this.scanExtensions(H)}catch(K){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,O.$0)(K)),[]}}async scanExtension(H,K){try{let W=await this.scanExtensionManifest(H.location);if(W){W.publisher||(W.publisher=m.$ym),K=K??W.__metadata,delete W.__metadata;const B=(0,c.$kp)(W.publisher,W.name),ne=K?.id?{id:B,uuid:K.id}:{id:B},oe=K?.isSystem?0:H.type,te=oe===0||!!K?.isBuiltin;W=await this.t(H.location,W,U.createNlsConfiguration(H));const ce={type:oe,identifier:ne,manifest:W,location:H.location,isBuiltin:te,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return H.validate?this.validate(ce,H):ce}}catch(W){H.type!==0&&this.m.error(W)}return null}validate(H,K){let W=!0;const B=(0,i.$vp)(K.productVersion,K.productDate,K.location,H.manifest,H.isBuiltin);for(const[ne,oe]of B)ne===b.default.Error&&(W=!1,this.m.error(this.z(K.location,oe)));return H.isValid=W,H.validations=B,H}async scanExtensionManifest(H){const K=(0,f.$Ug)(H,"package.json");let W;try{W=(await this.j.readFile(K)).value.toString()}catch(ne){return(0,o.$5k)(ne)!==1&&this.m.error(this.z(H,(0,d.localize)(0,null,K.path,ne.message))),null}let B;try{B=JSON.parse(W)}catch{const oe=[];(0,R.$un)(W,oe);for(const te of oe)this.m.error(this.z(H,(0,d.localize)(1,null,K.path,te.offset,te.length,(0,S.$cq)(te.error))));return null}return(0,R.$Dn)(B)!=="object"?(this.m.error(this.z(H,(0,d.localize)(2,null,K.path))),null):B}async t(H,K,W){const B=await this.u(H,K,W);if(B)try{const ne=[],oe=await this.w(B.default,ne);if(ne.length>0)return ne.forEach(ce=>{this.m.error(this.z(H,(0,d.localize)(3,null,B.default?.path,(0,S.$cq)(ce.error))))}),K;if((0,R.$Dn)(B)!=="object")return this.m.error(this.z(H,(0,d.localize)(4,null,B.default?.path))),K;const te=B.values||Object.create(null);return(0,k.$dq)(this.m,K,te,oe)}catch{}return K}async u(H,K,W){const B=(0,f.$Ug)(H,"package.nls.json"),ne=(G,q)=>{q.forEach(N=>{this.m.error(this.z(H,(0,d.localize)(5,null,G?.path,(0,S.$cq)(N.error))))})},oe=G=>{this.m.error(this.z(H,(0,d.localize)(6,null,G?.path)))},te=`${K.publisher}.${K.name}`,ce=W.translations[te];if(ce)try{const G=l.URI.file(ce),q=(await this.j.readFile(G)).value.toString(),N=[],M=(0,R.$un)(q,N);return N.length>0?(ne(G,N),{values:void 0,default:B}):(0,R.$Dn)(M)!=="object"?(oe(G),{values:void 0,default:B}):{values:M.contents?M.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let q;try{q=await this.y(H,W)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const N=(await this.j.readFile(q.localized)).value.toString(),M=[],z=(0,R.$un)(N,M);return M.length>0?(ne(q.localized,M),{values:void 0,default:q.original}):(0,R.$Dn)(z)!=="object"?(oe(q.localized),{values:void 0,default:q.original}):{values:z,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,K){if(H)try{const W=(await this.j.readFile(H)).value.toString();return(0,R.$un)(W,K)}catch{}}y(H,K){return new Promise((W,B)=>{const ne=oe=>{const te=(0,f.$Ug)(H,`package.nls.${oe}.json`);this.j.exists(te).then(ce=>{ce&&W({localized:te,original:(0,f.$Ug)(H,"package.nls.json")});const G=oe.lastIndexOf("-");G===-1?W({localized:(0,f.$Ug)(H,"package.nls.json"),original:null}):(oe=oe.substring(0,G),ne(oe))})};if(K.devMode||K.pseudo||!K.language)return W({localized:(0,f.$Ug)(H,"package.nls.json"),original:null});ne(K.language)})}z(H,K){return`[${H.path}]: ${K}`}};F=ye([Q(1,v.$aq),Q(2,w.$ll),Q(3,o.$Nk),Q(4,s.$Nj)],F);let T=class extends F{constructor(H,K,W,B,ne,oe,te){super(K,B,ne,oe,te),this.G=H,this.H=W,this.D=this.B(new A.$fh(3e3)),this.F=this.B(new r.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(H){const K=this.M(H),W=await this.I(K);if(this.C=H,W&&W.input&&U.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),W.result.map(ne=>(ne.location=l.URI.revive(ne.location),ne));const B=await super.scanExtensions(H);return await this.J(K,{input:H,result:B}),B}async I(H){try{const K=await this.j.readFile(H),W=JSON.parse(K.value.toString());return{result:W.result,input:(0,a.$Qh)(W.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",H.path,(0,O.$0)(K))}return null}async J(H,K){try{await this.j.writeFile(H,L.$ue.fromString(JSON.stringify(K)))}catch(W){this.m.debug("Error while writing the extension cache file:",H.path,(0,O.$0)(W))}}async L(){if(!this.C)return;const H=this.M(this.C),K=await this.I(H);if(!K)return;const W=K.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$Rn(B,W))try{this.m.info("Invalidating Cache",W,B),await this.j.del(H),this.F.fire()}catch(ne){this.m.error(ne)}}M(H){const K=this.N(H);return this.h.extUri.joinPath(K.cacheHome,H.type===0?m.$xm:m.$wm)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(H.location,K.extensionsResource))??this.G:this.H.defaultProfile}};T=ye([Q(2,y.$nl),Q(3,v.$aq),Q(4,w.$ll),Q(5,o.$Nk),Q(6,s.$Nj)],T);function _(ee,H){const K=(0,c.$ip)(ee.manifest.publisher,ee.manifest.name);return{id:K,identifier:new m.$Cm(K),isBuiltin:ee.type===0,isUserBuiltin:ee.type===1&&ee.isBuiltin,isUnderDevelopment:H,extensionLocation:ee.location,uuid:ee.identifier.uuid,targetPlatform:ee.targetPlatform,...ee.manifest}}class X extends D{constructor(H,K,W,B,ne,oe,te,ce,G,q,N,M){super(H,K,(0,f.$Ug)(W,".vscode-oss-dev","extensions","control.json"),B,ne,oe,te,ce,G,q,N,M),this.S=(async()=>{if(p.$z)try{const z=await this.w.readFile(l.URI.file(p.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$iq=X}),define(le[249],he([0,1,67,6,38,3,2,23,15,31,9,18]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let p=class extends O.$Uc{constructor(u,b){super(),this.b=u,this.f=b,this.a=new A.$nh(5)}async postUninstall(u){const b=this.g(u,"uninstall");b&&(this.f.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,u),this.f.info("Finished running post uninstall script",u.identifier.id,u.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",u.identifier.id,u.manifest.version),this.f.error($)}}));try{await g.Promises.rm(this.m(u))}catch($){this.f.error("Error while removing extension storage path",u.identifier.id),this.f.error($)}}g(u,b){const $=`vscode:${b}`;if(u.location.scheme===R.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[$]=="string"){const l=u.manifest.scripts[$].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(u.identifier.id,u.manifest.version,`${$} should be a node script`),null):{script:(0,S.$kc)(u.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(u,b,$,l,d){return new Promise((h,c)=>{const m=this.j(u,b,$,d);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):h(void 0)};m.on("error",n=>{o((0,j.$5i)(n)||"Unknown")}),m.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),l&&(i=setTimeout(()=>{i=null,m.kill(),c("timed out")},5e3))})}j(u,b,$,l){const d={silent:!0,execArgv:void 0},h=(0,I.fork)(u,[`--type=extension-post-${b}`,...$],d);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(h.stdout,"data"),m=L.Event.fromNodeEventEmitter(h.stderr,"data");c(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${b}`,n)),m(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${b}`,n));const i=L.Event.any(L.Event.map(c,n=>({data:`%c${n}`,format:[""]})),L.Event.map(m,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(u){return(0,S.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};e.$kq=p,e.$kq=p=ye([Q(0,P.$nl),Q(1,C.$Nj)],p)}),define(le[113],he([0,1,6,14,26,38,7,3,54,2,35,23,15,20,55,13,8,32,31,70,158,95,16,248,29,33,52,81,229,249,187,219,230,71,12,4,9,24,22,28,18]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a,v,y,w,k,E,D,U,F,T,_,X,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.$oq=void 0,e.$oq=(0,U.$ii)(n.$To);const H=".vsctmp";let K=class extends o.$8p{constructor(G,q,N,M,z,Z,J,x,Y,V,ie,re){super(G,q,ie,N,V,re),this.eb=z,this.fb=Z,this.gb=J,this.hb=Y,this.db=new Map,this.qb=new C.$Cc;const ue=this.B(x.createInstance(v.$kq));this.ab=this.B(x.createInstance(W,me=>ue.postUninstall(me))),this.bb=this.B(new w.$mq(re,Y,ie,this,this.F)),this.cb=this.B(x.createInstance(a.$jq));const de=this.B(new k.$nq(this,this.eb,re,Z,ie,Y,N));this.B(de.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$qp)(this.hb,this.F)),this.ib}async zip(G){this.F.trace("ExtensionManagementService#zip",G.identifier.id);const q=await this.ob(G),N=await(0,h.zip)((0,f.$Ug)(this.cb.extensionsDownloadDir,(0,l.$Dg)()).fsPath,q);return $.URI.file(N)}async unzip(G){return this.F.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const{location:q,cleanup:N}=await this.kb(G),M=p.$lc(q.fsPath);try{return await(0,y.$lq)(M)}finally{await N()}}getInstalled(G,q=this.H.defaultProfile.extensionsResource,N={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(G??null,q,N)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(G){return this.ab.scanUserExtensionAtLocation(G)}async install(G,q={}){this.F.trace("ExtensionManagementService#install",G.toString());const{location:N,cleanup:M}=await this.kb(G);try{const z=await(0,y.$lq)(p.$lc(N.fsPath)),Z=(0,s.$kp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,E.$xp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,Z,this.G.version));const x=(await this.I([{manifest:z,extension:N,options:q}])).find(({identifier:Y})=>(0,s.$fp)(Y,{id:Z}));if(x?.local)return x.local;throw x?.error?x.error:(0,o.$0p)(new Error(`Unknown error while installing extension ${Z}`))}finally{await M()}}async installFromLocation(G,q){this.F.trace("ExtensionManagementService#installFromLocation",G.toString());const N=await this.ab.scanUserExtensionAtLocation(G);if(!N||!N.manifest.name||!N.manifest.version)throw new Error(`Cannot find a valid extension from the location ${G.toString()}`);return await this.tb([[N,void 0]],q),this.F.info("Successfully installed extension",N.identifier.id,q.toString()),N}async installExtensionsFromProfile(G,q,N){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",G,q.toString(),N.toString());const M=(await this.getInstalled(1,q)).filter(z=>G.some(Z=>(0,s.$fp)(Z,z.identifier)));if(M.length){const z=await Promise.all(M.map(Z=>this.ab.scanMetadata(Z,q)));await this.tb(M.map((Z,J)=>[Z,z[J]]),N),this.F.info("Successfully installed extensions",M.map(Z=>Z.identifier.id),N.toString())}return M}async updateMetadata(G,q,N=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",G.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),G=await this.ab.updateMetadata(G,q,N),this.bb.invalidate(N),this.w.fire(G),G}async reinstallFromGallery(G){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",G.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const q=await this.getTargetPlatform(),[N]=await this.z.getExtensions([{...G.identifier,preRelease:G.preRelease}],{targetPlatform:q,compatible:!0},j.CancellationToken.None);if(!N)throw new Error(c.localize(2,null));await this.ab.setUninstalled(G);try{await this.ab.removeUninstalledExtension(G)}catch(M){throw new Error(c.localize(3,null,(0,L.$5i)(M)))}return this.installFromGallery(N)}$(G,q,N,M){return this.ab.copyExtension(G,q,N,M)}copyExtensions(G,q){return this.ab.copyExtensions(G,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...G){return this.ab.setUninstalled(...G)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(G){this.F.error(G)}}async download(G,q,N){const{location:M}=await this.cb.download(G,q,!N);return M}async kb(G){if(G.scheme===P.Schemas.file)return{location:G,async cleanup(){}};this.F.trace("Downloading extension from",G.toString());const q=(0,f.$Ug)(this.cb.extensionsDownloadDir,(0,l.$Dg)());return await this.gb.download(G,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.hb.del(q)}catch(M){this.F.error(M)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(G,q,N){if($.URI.isUri(q))return new oe(G,q,N,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const M=s.$gp.create(q).toString();let z=this.db.get(M);return z||(this.db.set(M,z=new ne(G,q,N,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(M))),z}Z(G,q){return new te(G,q.profileLocation,this.fb)}async ob(G){const q=async M=>{let z=await d.Promises.readdir(M);z=z.map(x=>p.$kc(M,x));const Z=await Promise.all(z.map(x=>d.Promises.stat(x)));let J=Promise.resolve([]);return Z.forEach((x,Y)=>{const V=z[Y];x.isFile()&&(J=J.then(ie=>[...ie,V])),x.isDirectory()&&(J=J.then(ie=>q(V).then(re=>[...ie,...re])))}),J};return(await q(G.location.fsPath)).map(M=>({path:`extension/${p.$mc(G.location.fsPath,M)}`,localPath:M}))}async pb({added:G,removed:q}){if(q){const N=G&&this.D.extUri.isEqual(q.profileLocation,G.profileLocation)?q.extensions.filter(M=>G.extensions.every(z=>!(0,s.$fp)(z,M))):q.extensions;for(const M of N)this.F.info("Extensions removed from another source",M.id,q.profileLocation.toString()),this.u.fire({identifier:M,profileLocation:q.profileLocation})}if(G){const M=(await this.getInstalled(1,G.profileLocation)).filter(z=>G.extensions.some(Z=>(0,s.$fp)(Z,z.identifier)));this.s.fire(M.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,G.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:G.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(q=>this.qb.add(q)));const G=await this.hb.resolve(this.eb.userExtensionsLocation);for(const q of G.children??[])q.isDirectory&&this.qb.add(q.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(q=>this.sb(q)))}async sb(G){if(!G.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const N of G.rawAdded){if(this.qb.has(N)||!this.D.extUri.isEqual(this.D.extUri.dirname(N),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(N,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(N).startsWith(".")||!(await this.hb.stat(N)).isDirectory)continue;const M=await this.ab.scanUserExtensionAtLocation(N);M&&M.installedTimestamp===void 0&&(this.qb.add(N),q.push(M))}q.length&&(await this.tb(q.map(N=>[N,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(N=>N.identifier.id)))}async tb(G,q){const N=G.map(M=>M[0]);await this.ub(N),await this.fb.addExtensionsToProfile(G,q),this.s.fire(N.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:q})))}async ub(G){const q=await this.ab.getUninstalledExtensions();for(const N of G){const M=s.$gp.create(N);q[M.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",M.id),await this.ab.setInstalled(M),this.F.info("Removed the extension from uninstalled list:",M.id))}}};e.$pq=K,e.$pq=K=ye([Q(0,n.$Qo),Q(1,_.$Ml),Q(2,F.$Nj),Q(3,i.$pi),Q(4,r.$eq),Q(5,t.$aq),Q(6,m.$vo),Q(7,U.$gi),Q(8,D.$Nk),Q(9,T.$7j),Q(10,X.$ll),Q(11,ee.$nl)],K);let W=class extends g.$Uc{constructor(G,q,N,M,z,Z){super(),this.j=G,this.m=q,this.n=N,this.s=M,this.t=z,this.u=Z,this.h=this.B(new R.$7d),this.onExtract=this.h.event,this.c=(0,f.$Ug)(this.n.userExtensionsLocation,".obsolete"),this.g=new I.$oh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(G,q,N){const M={includeInvalid:!0,profileLocation:q,productVersion:N};let z=[];return G===null||G===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},M,!1)):G===1&&z.push(...await this.n.scanUserExtensions(M)),z=G!==null?z.filter(Z=>Z.type===G):z,Promise.all(z.map(Z=>this.F(Z)))}async scanAllUserExtensions(G){const q=await this.n.scanUserExtensions({includeAllVersions:!G,includeInvalid:!0});return Promise.all(q.map(N=>this.F(N)))}async scanUserExtensionAtLocation(G){try{const q=await this.n.scanExistingExtension(G,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(G,q,N,M,z){const Z=G.toString(),J=$.URI.file(p.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Dg)()}`)),x=$.URI.file(p.$kc(this.n.userExtensionsLocation.fsPath,Z));let Y=await this.m.exists(x);if(Y&&M){try{await this.y(G.id,x,"removeExisting")}catch{throw new n.$Ro(c.localize(4,null,x.fsPath,G.id),n.ExtensionManagementErrorCode.Delete)}Y=!1}if(Y)await this.n.updateMetadata(x,N);else try{try{this.u.trace(`Started extracting the extension from ${q} to ${x.fsPath}`),await(0,h.$6p)(q,J.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${x}:`,G.id)}catch(V){let ie=n.ExtensionManagementErrorCode.Extract;throw V instanceof h.$4p&&(V.type==="CorruptZip"?ie=n.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(ie=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Ro(V.message,ie)}await this.n.updateMetadata(J,N);try{this.u.trace(`Started renaming the extension from ${J.fsPath} to ${x.fsPath}`),await this.C(J.fsPath,x.fsPath),this.u.info("Renamed to",x.fsPath)}catch(V){if(V.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",G.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(V)}. Deleted from extracted location`,J),V}this.h.fire(x)}catch(V){try{await this.m.del(J,{recursive:!0})}catch{}throw V}return this.D(x,1)}async scanMetadata(G,q){return q?(await this.w(G,q))?.metadata:this.n.scanMetadata(G.location)}async w(G,q){return(await this.s.scanProfileExtensions(q)).find(M=>(0,s.$fp)(M.identifier,G.identifier))}async updateMetadata(G,q,N){return N?await this.s.updateMetadata([[G,q]],N):await this.n.updateMetadata(G.location,q),this.D(G.location,G.type,N)}getUninstalledExtensions(){return this.z()}async setUninstalled(...G){const q=G.map(N=>s.$gp.create(N));await this.z(N=>q.forEach(M=>{N[M.toString()]=!0,this.u.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(G){await this.z(q=>delete q[G.toString()])}async removeExtension(G,q){if(this.t.extUri.isEqualOrParent(G.location,this.n.userExtensionsLocation))return this.y(G.identifier.id,G.location,q)}async removeUninstalledExtension(G){await this.removeExtension(G,"uninstalled"),await this.z(q=>delete q[s.$gp.create(G).toString()])}async copyExtension(G,q,N,M){const z=await this.w(G,q),Z=await this.w(G,N);if(M={...z?.metadata,...M},Z)if(this.t.extUri.isEqual(Z.location,G.location))await this.s.updateMetadata([[G,{...Z.metadata,...M}]],N);else{const J=await this.D(Z.location,G.type,N);await this.s.removeExtensionFromProfile(J,N),await this.s.addExtensionsToProfile([[G,{...Z.metadata,...M}]],N)}else await this.s.addExtensionsToProfile([[G,M]],N);return this.D(G.location,G.type,N)}async copyExtensions(G,q,N){const M=await this.scanExtensions(1,G,N),z=await Promise.all(M.filter(Z=>!Z.isApplicationScoped).map(async Z=>[Z,await this.scanMetadata(Z,G)]));await this.s.addExtensionsToProfile(z,q)}async y(G,q,N){this.u.trace(`Deleting ${N} extension from disk`,G,q.fsPath);const M=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,S.$8i)((0,l.$Dg)()).toString(16)}${H}`);await this.C(q.fsPath,M.fsPath),await this.m.del(M,{recursive:!0}),this.u.info(`Deleted ${N} extension from disk`,G,q.fsPath)}async z(G){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(M){if((0,D.$5k)(M)!==1)throw M}let N={};if(q)try{N=JSON.parse(q)}catch{}return G&&(G(N),Object.keys(N).length?await this.m.writeFile(this.c,A.$ue.fromString(JSON.stringify(N))):await this.m.del(this.c)),N})}async C(G,q){try{await d.Promises.rename(G,q,2*60*1e3)}catch(N){throw new n.$Ro(N.message||c.localize(5,null,G,q),N.code||n.ExtensionManagementErrorCode.Rename)}}async D(G,q,N){if(N){const z=(await this.n.scanUserExtensions({profileLocation:N})).find(Z=>this.t.extUri.isEqual(Z.location,G));if(z)return this.F(z)}else{const M=await this.n.scanExistingExtension(G,q,{includeInvalid:!0});if(M)return this.F(M)}throw new Error(c.localize(6,null,G.path))}async F(G){const q=await this.m.resolve(G.location);let N,M;return q.children&&(N=q.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,M=q.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:G.identifier,type:G.type,isBuiltin:G.isBuiltin||!!G.metadata?.isBuiltin,location:G.location,manifest:G.manifest,targetPlatform:G.targetPlatform,validations:G.validations,isValid:G.isValid,readmeUrl:N,changelogUrl:M,publisherDisplayName:G.metadata?.publisherDisplayName||null,publisherId:G.metadata?.publisherId||null,isApplicationScoped:!!G.metadata?.isApplicationScoped,isMachineScoped:!!G.metadata?.isMachineScoped,isPreReleaseVersion:!!G.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!G.metadata?.hasPreReleaseVersion,preRelease:!!G.metadata?.preRelease,installedTimestamp:G.metadata?.installedTimestamp,updated:!!G.metadata?.updated,pinned:!!G.metadata?.pinned}}async G(){const G=await this.getUninstalledExtensions();if(Object.keys(G).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(G));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const z of q)G[s.$gp.create(z).toString()]||N.add(z.identifier.id.toLowerCase());try{const z=(0,s.$lp)(q,Z=>Z.identifier);await I.Promises.settled(z.map(async Z=>{const J=Z.sort((x,Y)=>u.rcompare(x.manifest.version,Y.manifest.version))[0];N.has(J.identifier.id.toLowerCase())||await this.j(await this.F(J))}))}catch(z){this.u.error(z)}const M=q.filter(z=>z.metadata&&G[s.$gp.create(z).toString()]);await Promise.allSettled(M.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let G;try{G=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,D.$5k)(q)!==1&&this.u.error(q);return}if(G?.children)try{await Promise.allSettled(G.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(N){(0,D.$5k)(N)!==1&&this.u.error(N)}}}))}catch{}}};e.$qq=W,e.$qq=W=ye([Q(1,D.$Nk),Q(2,r.$eq),Q(3,t.$aq),Q(4,X.$ll),Q(5,F.$Nj)],W);class B extends o.$$p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$2f)(this.options.operation)?this.l:this.options.operation}constructor(G,q,N,M,z,Z,J,x,Y){super(),this.identifier=G,this.source=q,this.options=N,this.m=M,this.n=z,this.o=Z,this.p=J,this.q=x,this.s=Y,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(G){const[q,N]=await this.x(G);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,N]],this.j,!q.isValid),q}async u({zipPath:G,key:q,metadata:N},M,z){let Z=await this.v(q);return Z?Z=await this.m.updateMetadata(Z,N):(this.s.trace("Extracting extension...",q.id),Z=await this.m.extractUserExtension(q,G,N,M,z),this.s.info("Extracting extension completed.",q.id)),Z}async v(G){return await this.w(G)?(this.s.trace("Removing the extension from uninstalled list:",G.id),await this.m.setInstalled(G),this.s.info("Removed the extension from uninstalled list:",G.id),(await this.m.scanAllUserExtensions(!0)).find(M=>s.$gp.create(M).equals(G))):void 0}async w(G){return!!(await this.m.getUninstalledExtensions())[G.toString()]}}class ne extends B{constructor(G,q,N,M,z,Z,J,x,Y,V){super(q.identifier,q,N,z,Z,J,x,Y,V),this.y=q,this.z=M}async x(G){let q;try{q=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(J){throw new n.$Ro(J,n.ExtensionManagementErrorCode.Scanning)}const N=q.find(J=>(0,s.$fp)(J.identifier,this.y.identifier));N&&(this.l=3);const M={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:N?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??N?.pinned,preRelease:(0,b.$1f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||N?.preRelease};if(N?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(N,M),M]}catch(J){throw new n.$Ro((0,O.$0)(J),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:Z}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=Z,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:s.$gp.create(this.y),metadata:M},!1,G),M]}catch(J){try{await this.z.delete(z)}catch(x){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,O.$0)(x))}throw J}}async B(G){try{await(0,y.$lq)(G)}catch(q){throw new n.$Ro((0,o.$9p)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$rq=ne;class oe extends B{constructor(G,q,N,M,z,Z,J,x,Y,V){super({id:(0,s.$kp)(G.publisher,G.name)},q,N,z,Z,J,x,Y,V),this.y=G,this.z=q,this.A=M}async h(G){const q=await super.h(G);return this.D(q,G),q}async x(G){const q=new s.$gp(this.identifier,this.y.version),M=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(J=>(0,s.$fp)(this.identifier,J.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned};if(M)if(this.l=3,q.equals(new s.$gp(M.identifier,M.manifest.version)))try{await this.m.removeExtension(M,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&u.gt(M.manifest.version,this.y.version)&&await this.m.setUninstalled(M);else{const J=await this.v(q);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:p.$lc(this.z.fsPath),key:q,metadata:z},!0,G),z]}async D(G,q){try{let[N]=await this.A.getExtensions([{id:G.identifier.id,version:G.manifest.version}],q);if(N||([N]=await this.A.getExtensions([{id:G.identifier.id}],q)),N){const M={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,hasPreReleaseVersion:G.hasPreReleaseVersion||N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(G,M,this.options.profileLocation)}}catch{}}}class te extends o.$$p{constructor(G,q,N){super(),this.extension=G,this.j=q,this.k=N}async h(G){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[250],he([0,1,9,18,28,22,52,12,16,8]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=void 0;let C=class extends O.$bq{constructor(p,f,u,b,$,l){super(g.URI.file(p.extensionsPath),f,u,b,$,l)}};e.$XP=C,e.$XP=C=ye([Q(0,S.$pi),Q(1,R.$Nk),Q(2,A.$nl),Q(3,j.$ll),Q(4,L.$Ml),Q(5,I.$Nj)],C)}),define(le[251],he([0,1,8,16,52,81,12,4,9,24,28,18]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;let p=class extends L.$iq{constructor(u,b,$,l,d,h,c,m){super(I.URI.file(d.builtinExtensionsPath),I.URI.file(d.extensionsPath),d.userHome,u.defaultProfile,u,b,$,l,d,h,c,m)}};e.$6ac=p,e.$6ac=p=ye([Q(0,P.$nl),Q(1,j.$aq),Q(2,O.$Nk),Q(3,S.$Nj),Q(4,A.$pi),Q(5,g.$7j),Q(6,C.$ll),Q(7,R.$gi)],p)}),define(le[19],he([0,1,6,3,2,99,13,69,4,18]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=f,e.$Op=b,e.$Qp=l,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,S.$hi)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var P;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var p;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f(d){const h=d.get(e.$Kp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class u extends j.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:u.a}){super(),this.m=h,this.b=this.B(new A.$0d),this.c=this.B(new A.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new I.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,c,m){return A.Event.filter(this.b.event,i=>i.scope===h&&(c===void 0||i.key===c),m)}n(){this.j.value=(0,I.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,c){const{key:m,external:i}=c;if(m===e.$Kp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:m,target:this.J(h)[m],external:i})}w(h){this.f.fire({reason:h})}get(h,c,m){return this.P(c)?.get(h,m)}getBoolean(h,c,m){return this.P(c)?.getBoolean(h,m)}getNumber(h,c,m){return this.P(c)?.getNumber(h,m)}getObject(h,c,m){return this.P(c)?.getObject(h,m)}storeAll(h,c){this.y(()=>{for(const m of h)this.store(m.key,m.value,m.scope,m.target,c)})}store(h,c,m,i,o=!1){if((0,O.$4f)(c)){this.remove(h,m,o);return}this.y(()=>{this.z(h,m,i),this.P(m)?.set(h,c,o)})}remove(h,c,m=!1){this.y(()=>{this.z(h,c,void 0),this.P(c)?.delete(h,m)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,c){const m=[],i=this.J(h);for(const o of Object.keys(i))i[o]===c&&m.push(o);return m}z(h,c,m,i=!1){const o=this.J(c);typeof m=="number"?o[h]!==m&&(o[h]=m,this.P(c)?.set(e.$Kp,JSON.stringify(o),i)):typeof o[h]=="number"&&(delete o[h],this.P(c)?.set(e.$Kp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const c=this.P(h);return c?f(c):Object.create(null)}isNew(h){return this.getBoolean(e.$Jp,h)===!0}async flush(h=C.NONE){this.f.fire({reason:h});const c=this.P(-1),m=this.P(0),i=this.P(1);switch(h){case C.NONE:await I.Promises.settled([c?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await I.Promises.settled([c?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,m=this.P(1)?.items??new Map;return l(h,c,m,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,c){return this.w(C.NONE),(0,g.$ml)(h)?this.R(h,c):this.S(h,c)}M(h,c){return!(h.id===c.id||b(c)&&b(h))}N(h,c,m){this.y(()=>{const i=new Set;for(const[o,n]of h)i.add(o),c.get(o)!==n&&this.u(m,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(m,{key:o,external:!0})})}}e.$Np=u;function b(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class $ extends u{constructor(){super(),this.U=this.B(new R.$Hp(new R.$Ip,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Hp(new R.$Ip,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Hp(new R.$Ip,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$Pp=$;async function l(d,h,c,m,i,o){const n=E=>{try{return JSON.parse(E)}catch{return E}},s=new Map,t=new Map;d.forEach((E,D)=>{s.set(D,E),t.set(D,n(E))});const r=new Map,a=new Map;h.forEach((E,D)=>{r.set(D,E),a.set(D,n(E))});const v=new Map,y=new Map;c.forEach((E,D)=>{v.set(D,E),y.set(D,n(E))}),console.group(m!==i?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const w=[];if(s.forEach((E,D)=>{w.push({key:D,value:E})}),console.table(w),console.groupEnd(),console.log(t),m!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const E=[];r.forEach((D,U)=>{E.push({key:U,value:D})}),console.table(E),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const k=[];v.forEach((E,D)=>{k.push({key:D,value:E})}),console.table(k),console.groupEnd(),console.log(y)}}),define(le[114],he([0,1,3,2,13,29,33,19]),function(se,e,I,A,j,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MHb=e.$LHb=void 0;let S=class extends A.$Uc{constructor(P,p){super(),this.a=new I.$7d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(P)),this.B(this.b.onDidChange(f=>this.a.fire({extensions:f,source:"storage"}))),this.B(p.onDidInstallExtensions(f=>f.forEach(({local:u,operation:b})=>{u&&b===4&&this.f(u.identifier)})))}async enableExtension(P,p){return this.f(P)?(this.a.fire({extensions:[P],source:p}),!0):!1}async disableExtension(P,p){return this.c(P)?(this.a.fire({extensions:[P],source:p}),!0):!1}getDisabledExtensions(){return this.h(L.$Uo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(P){const p=this.getDisabledExtensions();return p.every(f=>!(0,O.$fp)(f,P))?(p.push(P),this.g(p),!0):!1}f(P){const p=this.getDisabledExtensions();for(let f=0;f<p.length;f++){const u=p[f];if((0,O.$fp)(u,P))return p.splice(f,1),this.g(p),!0}return!1}g(P){this.j(L.$Uo,P)}h(P){return this.b.get(P,0)}j(P,p){this.b.set(P,p,0)}};e.$LHb=S,e.$LHb=S=ye([Q(0,R.$Lp),Q(1,L.$To)],S);class g extends A.$Uc{constructor(P){super(),this.c=P,this.a=Object.create(null),this.b=this.B(new I.$7d),this.onDidChange=this.b.event,this.B(P.onDidChangeValue(0,void 0,this.B(new A.$Tc))(p=>this.f(p)))}get(P,p){let f;return p===0?((0,j.$4f)(this.a[P])&&(this.a[P]=this.g(P,p)),f=this.a[P]):f=this.g(P,p),JSON.parse(f)}set(P,p,f){const u=JSON.stringify(p.map(({id:$,uuid:l})=>({id:$,uuid:l})));this.g(P,f)!==u&&(f===0&&(p.length?this.a[P]=u:delete this.a[P]),this.h(P,p.length?u:void 0,f))}f(P){if(!(0,j.$4f)(this.a[P.key])&&this.g(P.key,P.scope)!==this.a[P.key]){const f=this.get(P.key,P.scope);delete this.a[P.key];const u=this.get(P.key,P.scope),b=f.filter(l=>!u.some(d=>(0,O.$fp)(l,d))),$=u.filter(l=>!f.some(d=>(0,O.$fp)(d,l)));(b.length||$.length)&&this.b.fire([...b,...$])}}g(P,p){return this.c.get(P,p,"[]")}h(P,p,f){p?this.c.store(P,p,f,1):this.c.remove(P,f)}}e.$MHb=g}),define(le[252],he([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,231,19,22,63]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0,e.$Tp=oe;const i=L.$o?"web":(0,P.$Mo)(L.$u,O.$fc),o="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce((z,Z)=>z|Z,0))}var t;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class w{constructor(z=y){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,Z=this.d.pageSize){return new w({...this.d,pageNumber:z,pageSize:Z})}withFilter(z,...Z){const J=[...this.d.criteria,...Z.length?Z.map(x=>({filterType:z,value:x})):[{filterType:z}]];return new w({...this.d,criteria:J})}withSortBy(z){return new w({...this.d,sortBy:z})}withSortOrder(z){return new w({...this.d,sortOrder:z})}withFlags(...z){return new w({...this.d,flags:z.reduce((Z,J)=>Z|J,0)})}withAssetTypes(...z){return new w({...this.d,assetTypes:z})}withSource(z){return new w({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:Z,pageSize:J,sortBy:x,sortOrder:Y,flags:V,assetTypes:ie}=this.d;return{filters:[{criteria:z,pageNumber:Z,pageSize:J,sortBy:x,sortOrder:Y}],assetTypes:ie,flags:V}}get searchText(){const z=this.d.criteria.filter(Z=>Z.filterType===t.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(M,z){const Z=(M||[]).filter(J=>J.statisticName===z)[0];return Z?Z.value:0}function E(M){const z="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(J=>J.assetType.indexOf(z)===0).reduce((J,x)=>{const Y=F(M,x.assetType);return Y&&J.push([x.assetType.substring(z.length),Y]),J},[])}function D(M){if(M.properties){const z=M.properties.filter(x=>x.key===r.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=z.filter(x=>Z.test(x.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return F(M,r.Repository)}function U(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,z){return M.files.filter(J=>J.assetType===z)[0]?{uri:`${M.assetUri}/${z}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${z}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function T(M,z){const Z=M.properties?M.properties.filter(x=>x.key===z):[],J=Z.length>0&&Z[0].value;return J?J.split(",").map(x=>(0,p.$jp)(x)):[]}function _(M){const z=M.properties?M.properties.filter(Z=>Z.key===a.Engine):[];return z.length>0&&z[0].value||""}function X(M){const z=M.properties?M.properties.filter(Z=>Z.key===a.PreRelease):[];return z.length>0&&z[0].value==="true"}function ee(M){const z=M.properties?M.properties.filter(J=>J.key===a.LocalizedLanguages):[],Z=z.length>0&&z[0].value||"";return Z?Z.split(","):[]}function H(M){return M.properties?.find(z=>z.key===a.SponsorLink)?.value}function K(M){return M.properties?.find(z=>z.key===a.SupportLink)?.value}function W(M){return M.indexOf("preview")!==-1}function B(M){return M.targetPlatform?(0,P.$Lo)(M.targetPlatform):"undefined"}function ne(M){const z=(0,I.$Mb)(M.versions.map(B)),Z=!!M.tags?.includes(P.$Go),J=z.indexOf("web");return Z?J===-1&&z.push("web"):J!==-1&&z.splice(J,1),z}function oe(M,z){for(let Z=0;Z<M.length;Z++){const J=M[Z];if(J.version===M[Z-1]?.version){let x=Z;if(B(J)===z)for(;x>0&&M[x-1].version===J.version;)x--;x!==Z&&(M.splice(Z,1),M.splice(x,0,J))}}return M}function te(M,z,Z){M.telemetryData={index:z,querySource:Z,queryActivityId:M.queryContext?.[o]}}function ce(M,z,Z,J){const x=M.versions[0],Y={manifest:F(z,r.Manifest),readme:F(z,r.Details),changelog:F(z,r.Changelog),license:F(z,r.License),repository:D(z),download:U(z),icon:F(z,r.Icon),signature:F(z,r.Signature),coreTranslations:E(z)};return{identifier:{id:(0,p.$kp)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:z.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(x),description:M.shortDescription??"",installCount:k(M.statistics,"install"),rating:k(M.statistics,"averagerating"),ratingCount:k(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:Z,assets:Y,properties:{dependencies:T(z,a.Dependency),extensionPack:T(z,a.ExtensionPack),engine:_(z),localizedLanguages:ee(z),targetPlatform:B(z),isPreReleaseVersion:X(z)},hasPreReleaseVersion:X(x),hasReleaseVersion:!0,preview:W(M.flags),isSigned:!!Y.signature,queryContext:J,supportLink:K(x)}}let G=class{constructor(z,Z,J,x,Y,V,ie,re){this.k=Z,this.l=J,this.n=x,this.o=Y,this.q=V,this.u=ie,this.w=re;const ue=ie.extensionsGallery,de=ue?.servicePPEUrl&&re.getValue("_extensionsGallery.enablePPE");this.d=de?ue.servicePPEUrl:ue?.serviceUrl,this.g=de?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,d.$Sp)(ie.version,ie,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,Z,J){const x=A.CancellationToken.isCancellationToken(Z)?{}:Z,Y=A.CancellationToken.isCancellationToken(Z)?Z:J,V=[],ie=[],re=[],ue=[];let de=!0;for(const ke of z){ke.uuid?ie.push(ke.uuid):V.push(ke.id);const Ie=!!(ke.version||ke.preRelease);re.push({id:ke.id,uuid:ke.uuid,includePreRelease:Ie}),ke.version&&ue.push({id:ke.id,uuid:ke.uuid,version:ke.version}),de=de&&!!ke.hasPreRelease&&!Ie}if(!ie.length&&!V.length)return[];let me=new w().withPage(1,z.length);ie.length&&(me=me.withFilter(t.ExtensionId,...ie)),V.length&&(me=me.withFilter(t.ExtensionName,...V)),(x.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),x.source&&(me=me.withSource(x.source));const{extensions:Ee}=await this.z(me,{targetPlatform:x.targetPlatform??i,includePreRelease:re,versions:ue,compatible:!!x.compatible,productVersion:x.productVersion??{version:this.u.version,date:this.u.date}},Y);return x.source&&Ee.forEach((ke,Ie)=>te(ke,Ie,x.source)),Ee}async getCompatibleExtension(z,Z,J,x={version:this.u.version,date:this.u.date}){if((0,P.$No)(z.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(z,Z,J))return z;const Y=new w().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,z.identifier.uuid),{extensions:V}=await this.z(Y,{targetPlatform:J,compatible:!0,includePreRelease:Z,productVersion:x},A.CancellationToken.None);return V[0]||null}async isExtensionCompatible(z,Z,J,x={version:this.u.version,date:this.u.date}){if(!(0,P.$Oo)(z.properties.targetPlatform,z.allTargetPlatforms,J)||!Z&&z.properties.isPreReleaseVersion)return!1;let Y=z.properties.engine;if(!Y){const V=await this.getManifest(z,A.CancellationToken.None);if(!V)throw new Error("Manifest was not found");Y=V.engines.vscode}return(0,f.$xp)(Y,x.version,x.date)}async y(z,Z,J,x,Y,V,ie={version:this.u.version,date:this.u.date}){if(!(0,P.$Oo)(B(Z),Y,V)||J!=="any"&&X(Z)!==(J==="prerelease"))return!1;if(x)try{const re=await this.E(z,Z);if(!(0,f.$xp)(re,ie.version,ie.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${Z.version}.`,(0,j.$0)(re)),!1}return!0}async query(z,Z){let J=z.text||"";const x=z.pageSize??50;let Y=new w().withPage(1,x);J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(Y=Y.withFilter(t.Category,Ee||me),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(Y=Y.withFilter(t.Tag,Ee||me),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(t.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),Y=Y.withFilter(t.SearchText,J)),Y=Y.withSortBy(0)):z.ids?Y=Y.withFilter(t.ExtensionId,...z.ids):z.names?Y=Y.withFilter(t.ExtensionName,...z.names):Y=Y.withSortBy(4),typeof z.sortBy=="number"&&(Y=Y.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(Y=Y.withSortOrder(z.sortOrder)),z.source&&(Y=Y.withSource(z.source));const V=async(de,me)=>{const{extensions:Ee,total:ke}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},me);return Ee.forEach((Ie,Ae)=>te(Ie,(de.pageNumber-1)*de.pageSize+Ae,z.source)),{extensions:Ee,total:ke}},{extensions:ie,total:re}=await V(Y,Z),ue=async(de,me)=>{if(me.isCancellationRequested)throw new j.$5;const{extensions:Ee}=await V(Y.withPage(de+1),me);return Ee};return{firstPage:ie,total:re,pageSize:Y.pageSize,getPage:ue}}async z(z,Z,J){const x=z.flags;z.flags&n.IncludeLatestVersionOnly&&z.flags&n.IncludeVersions&&(z=z.withFlags(z.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(z.flags&n.IncludeLatestVersionOnly)&&!(z.flags&n.IncludeVersions)&&(z=z.withFlags(z.flags,n.IncludeLatestVersionOnly)),Z.versions?.length&&(z=z.withFlags(z.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),z=z.withFlags(z.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Y,total:V,context:ie}=await this.B(z,J);if(!(z.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of Y){const ke=await this.A(Ee,Z,ie);ke&&me.push(ke)}return{extensions:me,total:V}}const ue=[],de=new Map;for(let me=0;me<Y.length;me++){const Ee=Y[me],ke={id:(0,p.$kp)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Ie=(0,R.$1f)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(fe=>(0,p.$fp)(fe,ke))?.includePreRelease;if(Z.compatible&&(0,P.$No)(ne(Ee),Z.targetPlatform))continue;const Ae=await this.A(Ee,Z,ie);!Ae||Ae.properties.isPreReleaseVersion&&(!Ie||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==Z.targetPlatform&&Ae.hasPreReleaseVersion?de.set(Ee.extensionId,me):ue.push([me,Ae])}if(de.size){const me=new m.$3d,Ee=new w().withFlags(x&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:ke}=await this.z(Ee,Z,J);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Ie of ke){const Ae=de.get(Ie.identifier.uuid);ue.push([Ae,Ie])}}return{extensions:ue.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:V}}async A(z,Z,J){const x={id:(0,p.$kp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},Y=Z.versions?.find(ue=>(0,p.$fp)(ue,x))?.version,V=(0,R.$1f)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(ue=>(0,p.$fp)(ue,x))?.includePreRelease,ie=ne(z),re=oe(z.versions,Z.targetPlatform);if(Z.compatible&&(0,P.$No)(ie,Z.targetPlatform))return null;for(let ue=0;ue<re.length;ue++){const de=re[ue];if(!(Y&&de.version!==Y)){if(await this.y((0,p.$kp)(z.publisher.publisherName,z.extensionName),de,V?"any":"release",Z.compatible,ie,Z.targetPlatform,Z.productVersion))return ce(z,de,ie,J);if(Y&&de.version===Y)return null}}return Y||Z.compatible?null:ce(z,z.versions[0],ie)}async B(z,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const J=await this.j,x=JSON.stringify(z.raw),Y={...J,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},V=new m.$3d;let ie,re,ue=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&z.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:Y},Z),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,l.$Ep)(ie);if(de){const me=de.results[0],Ee=me.extensions,ke=me.resultMetadata&&me.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return ue=ke&&ke.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue,context:{[o]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){const me=(0,j.$4)(de)?P.ExtensionGalleryErrorCode.Cancelled:(0,j.$0)(de).startsWith("XHR timeout")?P.ExtensionGalleryErrorCode.Timeout:P.ExtensionGalleryErrorCode.Failed;throw re=new P.$So((0,j.$0)(de),me),re}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(x.length),duration:V.elapsed(),success:!!ie&&(0,l.$Ap)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:re?.code,count:String(ue)})}}async reportStatistic(z,Z,J,x){if(!this.isEnabled())return;const Y=L.$o?this.x(`/itemName/${z}.${Z}/version/${J}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${Z}/${J}/stats?statType=${x}`),V=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.j,Accept:V};try{await this.k.request({type:"POST",url:Y,headers:re},A.CancellationToken.None)}catch{}}async download(z,Z,J){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const x=(0,p.$np)(z),Y=new Date().getTime(),V=me=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:me}),ie=J===2?"install":J===3?"update":"",re=ie?{uri:`${z.assets.download.uri}${S.URI.parse(z.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${z.assets.download.fallbackUri}${S.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:z.assets.download,ue=z.queryContext?.[o]?{[o]:z.queryContext[o]}:void 0,de=await this.D(z.identifier.id,re,r.VSIX,ue?{headers:ue}:void 0);await this.q.writeFile(Z,de.stream),V(new Date().getTime()-Y)}async downloadSignatureArchive(z,Z){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const J=await this.D(z.identifier.id,z.assets.signature,r.Signature);await this.q.writeFile(Z,J.stream)}async getReadme(z,Z){if(z.assets.readme){const J=await this.D(z.identifier.id,z.assets.readme,r.Details,{},Z);return await(0,l.$Dp)(J)||""}return""}async getManifest(z,Z){if(z.assets.manifest){const J=await this.D(z.identifier.id,z.assets.manifest,r.Manifest,{},Z),x=await(0,l.$Dp)(J);return x?JSON.parse(x):null}return null}async C(z,Z,J){const x=F(Z,r.Manifest);if(!x)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},V=await this.D(z,x,r.Manifest,{headers:Y});return await(0,l.$Ep)(V)}async getCoreTranslation(z,Z){const J=z.assets.coreTranslations.filter(x=>x[0]===Z.toUpperCase())[0];if(J){const x=await this.D(z.identifier.id,J[1],J[0]),Y=await(0,l.$Dp)(x);return Y?JSON.parse(Y):null}return null}async getChangelog(z,Z){if(z.assets.changelog){const J=await this.D(z.identifier.id,z.assets.changelog,r.Changelog,{},Z);return await(0,l.$Dp)(J)||""}return""}async getAllCompatibleVersions(z,Z,J){let x=new w().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?x=x.withFilter(t.ExtensionId,z.identifier.uuid):x=x.withFilter(t.ExtensionName,z.identifier.id);const{galleryExtensions:Y}=await this.B(x,A.CancellationToken.None);if(!Y.length)return[];const V=ne(Y[0]);if((0,P.$No)(V,J))return[];const ie=[];await Promise.all(Y[0].versions.map(async de=>{try{await this.y(z.identifier.id,de,Z?"any":"release",!0,V,J)&&ie.push(de)}catch{}}));const re=[],ue=new Set;for(const de of oe(ie,J))ue.has(de.version)||(ue.add(de.version),re.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:X(de)}));return re}async D(z,Z,J,x={},Y=A.CancellationToken.None){const V=await this.j,ie={type:"GET"},re={...V,...x.headers||{}};x={...x,...ie,headers:re};const ue=Z.uri,de=Z.fallbackUri,me={...x,url:ue};try{const Ee=await this.k.request(me,Y);if(Ee.res.statusCode===200)return Ee;const ke=await(0,l.$Dp)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${ke}`)}catch(Ee){if((0,j.$4)(Ee))throw Ee;const ke=(0,j.$0)(Ee);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:J,message:ke});const Ie={...x,url:de};return this.k.request(Ie,Y)}}async E(z,Z){let J=_(Z);if(!J){const x=await this.C(z,Z,A.CancellationToken.None);if(!x)throw new Error("Manifest was not found");J=x.engines.vscode}return J}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,l.$Ep)(z),J=[],x={},Y=[];if(Z){for(const V of Z.malicious)J.push({id:V});if(Z.migrateToPreRelease)for(const[V,ie]of Object.entries(Z.migrateToPreRelease))(!ie.engine||(0,f.$xp)(ie.engine,this.u.version,this.u.date))&&(x[V.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[V,ie]of Object.entries(Z.deprecated))ie&&(x[V.toLowerCase()]=(0,R.$1f)(ie)?{}:ie);if(Z.search)for(const V of Z.search)Y.push(V)}return{malicious:J,deprecated:x,search:Y}}};G=ye([Q(1,l.$yp),Q(2,b.$Nj),Q(3,C.$oi),Q(4,c.$Ml),Q(5,u.$Nk),Q(6,$.$7j),Q(7,g.$Ni)],G);let q=class extends G{constructor(z,Z,J,x,Y,V,ie,re){super(z,Z,J,x,Y,V,ie,re)}};e.$Up=q,e.$Up=q=ye([Q(0,h.$Lp),Q(1,l.$yp),Q(2,b.$Nj),Q(3,C.$oi),Q(4,c.$Ml),Q(5,u.$Nk),Q(6,$.$7j),Q(7,g.$Ni)],q);let N=class extends G{constructor(z,Z,J,x,Y,V,ie){super(void 0,z,Z,J,x,Y,V,ie)}};e.$Vp=N,e.$Vp=N=ye([Q(0,l.$yp),Q(1,b.$Nj),Q(2,C.$oi),Q(3,c.$Ml),Q(4,u.$Nk),Q(5,$.$7j),Q(6,g.$Ni)],N)}),define(le[82],he([0,1,4,3,2,19,33,24,17,9,13]),function(se,e,I,A,j,L,O,R,S,g,C){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=void 0,e.$Gv=(0,I.$hi)("IExtensionStorageService");const p=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class extends j.$Uc{static{P=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,O.$jp)(b.id)}@${b.version}`}static c(b){const $=p.exec(b);if($&&$[1])return{id:$[1],version:$[2]}}static async removeOutdatedExtensionVersions(b,$){const l=await b.getInstalled(),d=[];for(const[h,c]of P.f($)){const m=l.find(i=>(0,O.$fp)(i.identifier,{id:h}))?.manifest.version;for(const i of c)m!==i&&d.push(P.b({id:h,version:i}))}for(const h of d)$.remove(h,0)}static f(b){const $=new Map,l=b.keys(0,1);for(const d of l){const h=P.c(d);if(h){let c=$.get(h.id.toLowerCase());c||$.set(h.id.toLowerCase(),c=[]),c.push(h.version)}}return $}constructor(b,$,l){super(),this.j=b,this.m=$,this.n=l,this.g=this.B(new A.$7d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=P.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Tc))(d=>this.r(d)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const $=P.c(b.key);if($){if(this.j.get(b.key,0)===void 0)this.h.delete($.id.toLowerCase());else{let l=this.h.get($.id.toLowerCase());l||this.h.set($.id.toLowerCase(),l=[]),l.push($.version),this.g.fire()}return}}s(b){if((0,C.$Uf)(b))return b;const $=b.manifest?b.manifest.publisher:b.publisher,l=b.manifest?b.manifest.name:b.name;return(0,O.$ip)($,l)}getExtensionState(b,$){const l=this.s(b),d=this.getExtensionStateRaw(b,$);if(d)try{return JSON.parse(d)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${$}): ${h}`)}}getExtensionStateRaw(b,$){const l=this.s(b),d=this.j.get(l,$?0:1);return d&&d?.length>P.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${$}): ${d.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),d}setExtensionState(b,$,l){const d=this.s(b);$===void 0?this.j.remove(d,l?0:1):this.j.store(d,JSON.stringify($),l?0:1,1)}setKeysForSync(b,$){this.j.store(P.b(b),JSON.stringify($),0,1)}getKeysForSync(b){const $=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],l=this.j.get(P.b(b),0),d=l?JSON.parse(l):void 0;return d&&$?(0,S.$Mb)([...d,...$]):d||$}addToMigrationList(b,$){if(b!==$){const l=this.t.filter(d=>!d.includes(b)&&!d.includes($));l.push([b,$]),this.t=l}}getSourceExtensionToMigrate(b){const $=this.t.find(([,l])=>b===l);return $?$[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const $=JSON.parse(b);if(Array.isArray($))return $}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Hv=f,e.$Hv=f=P=ye([Q(0,L.$Lp),Q(1,R.$7j),Q(2,g.$Nj)],f)}),define(le[253],he([0,1,2,29,82,228,113,9,19]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;let g=class extends I.$Uc{constructor(P,p,f,u,b,$){super(),P.cleanUp(),(0,L.$C2b)(P,p,f,u,$),j.$Hv.removeOutdatedExtensionVersions(P,b)}};e.$jcc=g,e.$jcc=g=ye([Q(0,O.$oq),Q(1,A.$Qo),Q(2,j.$Gv),Q(3,A.$Wo),Q(4,S.$Lp),Q(5,R.$Nj)],g)}),define(le[254],he([0,1,29,12,24,16,96,57,19,22,227]),function(se,e,I,A,j,L,O,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;let P=class extends C.$F$b{constructor(f,u,b,$,l,d,h,c){super(f.userHome,l,u,b,$,d,h,c)}};e.$qcc=P,e.$qcc=P=ye([Q(0,L.$pi),Q(1,g.$Ml),Q(2,I.$To),Q(3,S.$Lp),Q(4,R.$gac),Q(5,O.$m2b),Q(6,A.$Nk),Q(7,j.$7j)],P)}),define(le[255],he([0,1,105,3,22,16,2,9,15,67,24,5,6,100,21,168,37,19,13,132,20]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;const m=[I.$fcc,I.$gcc],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends O.$Uc{constructor(a,v,y,w,k,E,D){super(),this.y=a,this.z=v,this.C=y,this.D=E,this.F=D,this.f=new A.$7d,this.onDidTokenFailed=this.f.event,this.g=new A.$7d,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$7d,this.onDidChangeMode=this.h.event,this.n=I.$dcc,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(w.createLogger((0,c.$Ug)(y.logsHome,`${I.$hcc}.log`),{id:I.$hcc,name:I.$icc})),this.t=new p.$eh(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,R.$3j)(U)))),this.B(k.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(U=>{m.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;P.$j?a=this.C.appRoot:a=(0,S.$nc)((0,S.$nc)(this.C.appRoot)),this.u=(0,S.$kc)(a,"bin",`${this.z.tunnelApplicationName}${P.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$dcc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const y=(F,T)=>{T?this.j.error(F):a+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,b.localize)(0,null)))},w=this.O("status",["status"],y);this.r=w;try{if(await w,this.r!==w)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(T=>T.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(v=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(I.TunnelStates.disconnected());return}finally{this.r===w&&(this.r=void 0)}const k=this.n.active?this.n.session:void 0;if(k&&k.token){const F=k.token;this.G(I.TunnelStates.connecting((0,b.localize)(1,null,k.accountLabel,k.providerId)));const T=(X,ee)=>{X=X.replaceAll(F,"*".repeat(4)),y(X,ee)},_=this.O("login",["user","login","--provider",k.providerId,"--access-token",F,"--log",(0,R.$3j)(this.j.getLevel())],T);this.r=_;try{if(await _,this.r!==_)return}catch(X){this.j.error(X),this.r=void 0,this.f.fire(k),this.G(I.TunnelStates.disconnected(k));return}}const E=this.Q();E?this.G(I.TunnelStates.connecting((0,b.localize)(2,null,E))):this.G(I.TunnelStates.connecting((0,b.localize)(3,null)));const D=["--accept-server-license-terms","--log",(0,R.$3j)(this.j.getLevel())];E?D.push("--name",E):D.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!v&&(U=await this.M(D)===!1),this.N(k,D,U)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(y){this.j.error(y),v=1}if(v!==0){const y=(0,b.localize)(4,null);return this.j.warn(y),this.G(I.TunnelStates.connecting(y)),!1}return!0}async N(a,v,y){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let w=!1;const k=this.O("tunnel",v,(E,D)=>{D?this.j.error(E):this.j.info(E),E.includes("Connected to an existing tunnel process")&&(w=!0);const U=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:w};this.G(I.TunnelStates.connected(F,y))}else E.match(/error refreshing token/)&&(k.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=k,k.finally(()=>{k===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$dcc,this.G(I.TunnelStates.disconnected()))})}O(a,v,y=this.I){return(0,p.$7g)(w=>new Promise((k,E)=>{w.isCancellationRequested&&k(-1);let D;const U=["ignore","pipe","pipe"];if(w.onCancellationRequested(()=>{D&&(this.j.info(`${a} terminating(${D.pid})`),D.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),D=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,S.$kc)(this.C.appRoot,"cli"),stdio:U});else{y(`Running tunnel CLI
`,!1);const F=this.J();y(`${a} Spawning: ${F} tunnel ${v.join(" ")}
`,!1),D=(0,g.spawn)(F,["tunnel",...v],{cwd:(0,$.homedir)(),stdio:U})}D.stdout.pipe(new h.$UV(`
`)).on("data",F=>{if(D){const T=F.toString();y(T,!1)}}),D.stderr.pipe(new h.$UV(`
`)).on("data",F=>{if(D){const T=F.toString();y(T,!0)}}),D.on("exit",F=>{D&&(y(`${a} exit(${D.pid}): + ${F} `,!1),D=void 0,k(F||0))}),D.on("error",F=>{D&&(y(`${a} error(${D.pid}): + ${F} `,!0),D=void 0,E())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$gcc)}Q(){let a=this.D.getValue(I.$fcc)||(0,$.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),v=this.F.getBoolean(o,-1,!1);if(a){const y=JSON.parse(a);if(y&&(0,d.$Uf)(y.accountLabel)&&(0,d.$Uf)(y.sessionId)&&(0,d.$Uf)(y.providerId))return{active:!0,session:y,asService:v};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$dcc}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$mcc=n,e.$mcc=n=ye([Q(0,j.$Ml),Q(1,C.$7j),Q(2,L.$pi),Q(3,R.$Oj),Q(4,f.$kcc),Q(5,u.$Ni),Q(6,l.$Lp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[256],he([0,1,6,2,23,20,69,19,77,18]),function(se,e,I,A,j,L,O,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class C extends R.$Np{constructor(p,f,u,b){super(),this.bb=p,this.cb=f,this.db=u,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Tc),this.ab=this.hb(this.bb)}fb(){const p=this.B(new S.$jIb(this.db.getChannel("storage"))),f=this.B(new O.$Hp(p));return this.B(f.onDidChangeStorage(u=>this.u(-1,u))),f}gb(p){this.X.clear(),this.W=p;let f;if((0,R.$Op)(p))f=this.U;else{const u=this.X.add(new S.$kIb(this.db.getChannel("storage"),p));f=this.X.add(new O.$Hp(u))}return this.X.add(f.onDidChangeStorage(u=>this.u(0,u))),f}hb(p){this.$.clear(),this.Z=p?.id;let f;if(p){const u=this.$.add(new S.$lIb(this.db.getChannel("storage"),p));f=this.$.add(new O.$Hp(u)),this.$.add(f.onDidChangeStorage(b=>this.u(1,b)))}return f}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(p){switch(p){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(p){switch(p){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$Ug)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(p){if(!this.M(this.W,p))return;const f=this.Y,u=f.items;f!==this.U&&await f.close(),this.Y=this.gb(p),await this.Y.init(),this.N(u,this.Y,0)}async S(p,f){const u=this.ab,b=u?.items??new Map;await u?.close(),this.ab=this.hb(p),await this.ab.init(),this.N(b,this.ab,1)}hasScope(p){return(0,g.$ml)(p)?this.W.id===p.id:this.Z===p.id}}e.$rcc=C}),define(le[257],he([0,1,3,2,18,91]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0;class O{constructor(g,C){this.a=g,this.b=C}listen(g,C){const P=this.b(g);switch(C){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(f=>(0,L.$ln)({...f},P)),added:p.added.map(f=>(0,L.$ln)({...f},P)),removed:p.removed.map(f=>(0,L.$ln)({...f},P)),updated:p.updated.map(f=>(0,L.$ln)({...f},P))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,P){const p=this.b(g);switch(C){case"createProfile":{const f=await this.a.createProfile(P[0],P[1],P[2]);return(0,L.$ln)({...f},p)}case"updateProfile":{let f=(0,j.$ol)((0,L.$mn)(P[0],p),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,P[1]),(0,L.$ln)({...f},p)}case"removeProfile":{const f=(0,j.$ol)((0,L.$mn)(P[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${C}`)}}e.$5P=O;class R extends A.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,P){super(),this.profilesHome=C,this.f=P,this.a=[],this.b=this.B(new I.$7d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(p=>(0,j.$ol)(p,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(p=>{const f=p.added.map($=>(0,j.$ol)($,this.profilesHome.scheme)),u=p.removed.map($=>(0,j.$ol)($,this.profilesHome.scheme)),b=p.updated.map($=>(0,j.$ol)($,this.profilesHome.scheme));this.a=p.all.map($=>(0,j.$ol)($,this.profilesHome.scheme)),this.b.fire({added:f,removed:u,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,P){const p=await this.f.call("createNamedProfile",[g,C,P]);return(0,j.$ol)(p,this.profilesHome.scheme)}async createProfile(g,C,P,p){const f=await this.f.call("createProfile",[g,C,P,p]);return(0,j.$ol)(f,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,j.$ol)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const P=await this.f.call("updateProfile",[g,C]);return(0,j.$ol)(P,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$6P=R}),define(le[60],he([0,1,2,69,4,19,3,77,18]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pIb=e.$oIb=e.$nIb=void 0,e.$nIb=(0,j.$hi)("IUserDataProfileStorageService");let g=class extends I.$Uc{constructor(f){super(),this.a=f}async readStorageData(f){return this.withProfileScopedStorageService(f,async u=>this.b(u))}async updateStorageData(f,u,b){return this.withProfileScopedStorageService(f,async $=>this.c($,u,b))}async withProfileScopedStorageService(f,u){if(this.a.hasScope(f))return u(this.a);const b=await this.g(f),$=new P(b);try{await $.initialize();const l=await u($);return await $.flush(),l}finally{$.dispose(),await this.f(b)}}b(f){const u=new Map,b=$=>{for(const l of f.keys(0,$))u.set(l,{value:f.get(l,0),target:$})};return b(0),b(1),u}c(f,u,b){f.storeAll(Array.from(u.entries()).map(([$,l])=>({key:$,value:l,scope:0,target:b})),!0)}async f(f){try{await f.close()}finally{(0,I.$Oc)(f)&&f.dispose()}}};e.$oIb=g,e.$oIb=g=ye([Q(0,L.$Lp)],g);class C extends g{constructor(f,u,b,$){super(b),this.j=f;const l=f.getChannel("profileStorageListener"),d=this.B(new I.$Vc);this.h=this.B(new O.$7d({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(h=>{$.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(c=>(0,S.$ol)(c,u.profilesHome.scheme)),valueChanges:h.valueChanges.map(c=>({...c,profile:(0,S.$ol)(c.profile,u.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.h.event}async g(f){const u=this.j.getChannel("storage");return(0,L.$Op)(f)?new R.$jIb(u):new R.$kIb(u,f)}}e.$pIb=C;class P extends L.$Np{constructor(f){super({flushInterval:100}),this.s=this.B(new A.$Hp(f))}O(){return this.s.init()}P(f){return f===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[258],he([0,1,19,9,18,56,60]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;let R=class extends O.$pIb{constructor(g,C,P,p){super(g,C,P,p)}};e.$9bc=R,e.$9bc=R=ye([Q(0,L.$vbc),Q(1,j.$nl),Q(2,I.$Lp),Q(3,A.$Nj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,13,173,21,16,12,9,44,19,22,28,25,18]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJb=e.$nJb=e.$mJb=e.$lJb=void 0,e.$iJb=i,e.$jJb=o,e.$kJb=n;function i(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}function n(v,y){return`${(0,g.$Mf)(v)}${y.isDefault?"":` (${y.name})`}`}let s=class extends S.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,w,k,E,D,U,F,T,_,X,ee,H){super(),this.syncResource=y,this.collection=w,this.G=k,this.H=E,this.I=D,this.J=U,this.L=F,this.M=T,this.N=_,this.O=X,this.P=ee,this.c=null,this.m="idle",this.n=this.B(new O.$7d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$7d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$fh(50)),this.w=this.B(new O.$7d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(E.userDataSyncHome,...(0,c.$vpb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,c.$Qpb),this.y=(0,c.$wpb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,E,this.h),this.j=(0,$.$Rp)(E,k,D)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const w=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(w)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,w={}){await this.U(y,!0,this.ob(),w)}async preview(y,w,k={}){return this.U(y,!1,w,k)}async apply(y,w={}){try{this.F={...w};const k=await this.ab(y);return this.S(k),this.c}finally{this.F={}}}async U(y,w,k,E){try{if(this.F={...E},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let D="idle";try{const U=await this.getLastSyncUserData(),F=await this.X(y,U);return D=await this.Y(F,U,w,k),D==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):D==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(D)}}finally{this.F={}}}async replace(y){const w=this.kb(y);if(!w)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const k=await this.getLastSyncUserData(),E=await this.X(null,k),D=await this.W(E),U=await this.qb({ref:E.ref,syncData:w},k,D,this.ob(),L.CancellationToken.None),F=[];for(const T of U){const _=await this.sb(T,T.remoteResource,void 0,L.CancellationToken.None),{remoteChange:X}=await this.sb(T,T.previewResource,T.remoteContent,L.CancellationToken.None);F.push([T,{..._,remoteChange:X!==0?X:2}])}await this.tb(E,k,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const w=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===w}async X(y,w){if(w){const k=y?y[this.resource]:void 0;if(w.ref===k||k===void 0&&w.syncData===null)return w}return this.getRemoteUserData(w)}async Y(y,w,k,E){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$Dpb((0,P.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,w,k,E)}catch(D){if(D instanceof c.$Dpb)switch(D.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,w,k,E);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),w=await this.getLastSyncUserData(),this.Y(y,w,k,E)}throw D}}async Z(y,w,k,E){try{const D=await this.W(y),U=!D&&w===null&&this.gb()!==void 0,F=k&&!U;this.c||(this.c=(0,A.$7g)(_=>this.eb(y,w,D,F,E,_)));let T=await this.c;if(k&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const _ of T.resourcePreviews)T=await this.accept(_.remoteResource)||T}return this.cb(T.resourcePreviews),T.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":k?await this.ab(!1):"syncing"}catch(D){throw this.c=null,D}}async merge(y){return await this.$(y,async w=>{const k=await this.rb(w,L.CancellationToken.None);await this.G.writeFile(w.previewResource,j.$ue.fromString(k?.content||""));const E=k&&!k.hasConflicts?await this.sb(w,w.previewResource,void 0,L.CancellationToken.None):void 0;return w.acceptResult=E,w.mergeState=k.hasConflicts?"conflict":E?"accepted":"preview",w.localChange=E?E.localChange:k.localChange,w.remoteChange=E?E.remoteChange:k.remoteChange,w}),this.c}async accept(y,w){return await this.$(y,async k=>{const E=await this.sb(k,y,w,L.CancellationToken.None);return k.acceptResult=E,k.mergeState="accepted",k.localChange=E.localChange,k.remoteChange=E.remoteChange,k}),this.c}async discard(y){return await this.$(y,async w=>{const k=await this.rb(w,L.CancellationToken.None);return await this.G.writeFile(w.previewResource,j.$ue.fromString(k.content||"")),w.acceptResult=void 0,w.mergeState="preview",w.localChange=k.localChange,w.remoteChange=k.remoteChange,w}),this.c}async $(y,w){if(!this.c)return;let k=await this.c;const E=k.resourcePreviews.findIndex(({localResource:D,remoteResource:U,previewResource:F})=>this.h.isEqual(D,y)||this.h.isEqual(U,y)||this.h.isEqual(F,y));E!==-1&&(this.c=(0,A.$7g)(async D=>{const U=[...k.resourcePreviews];return U[E]=await w(U[E]),{...k,resourcePreviews:U}}),k=await this.c,this.cb(k.resourcePreviews),k.resourcePreviews.some(({mergeState:D})=>D==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const w=await this.c;return w.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":w.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.tb(w.remoteUserData,w.lastSyncUserData,w.resourcePreviews.map(k=>[k,k.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const w=y.filter(({mergeState:k})=>k==="conflict");(0,I.$ub)(this.s,w,(k,E)=>this.h.isEqual(k.previewResource,E.previewResource))||(this.s=w,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const w=this.c?await this.c:null;if(w)for(const k of w.resourcePreviews){if(this.h.isEqual(k.acceptedResource,y))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,y))return k.remoteContent;if(this.h.isEqual(k.localResource,y))return k.localContent;if(this.h.isEqual(k.baseResource,y))return k.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,u.$5k)(y)!==1&&this.O.error(y)}}async eb(y,w,k,E,D,U){const F=await this.qb(y,w,k,D,U),T=[];for(const _ of F){const X=_.previewResource.with({scheme:c.$Ppb,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)T.push({..._,acceptedResource:X,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const ee=E?await this.rb(_,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(_.previewResource,j.$ue.fromString(ee?.content||""));const H=ee&&!ee.hasConflicts?await this.sb(_,_.previewResource,void 0,U):void 0;T.push({..._,acceptResult:H,mergeState:ee?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:ee?ee.localChange:_.localChange,remoteChange:H?H.remoteChange:ee?ee.remoteChange:_.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:w,resourcePreviews:T,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const w=JSON.parse(y),k=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!w.version&&!!k&&w.version!==k,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${w.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let E,D=1;for(;E===void 0&&D++<6;)try{const U=await this.hb();U&&(U.ref===w.ref?E=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof u.$9k&&U.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof c.$Dpb)throw U;this.O.error(U,D)}}if(E===void 0)try{const U=await this.J.resolveResourceContent(this.resource,w.ref,this.collection,this.F);E=U===null?null:this.kb(U),await this.ib({ref:w.ref,syncData:E})}catch(U){if(U instanceof c.$Dpb&&U.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return E===void 0?null:{...w,syncData:E}}async fb(y,w={}){if(w.ref||w.version)throw new Error("Cannot have core properties as additional");const k=this.M.getResourceSyncStateVersion(this.resource),E={ref:y.ref,version:k,...w};this.I.store(this.z,JSON.stringify(E),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const w=y?JSON.parse(y):void 0;if(i(w))return w}catch(w){this.O.error(w)}}async ib(y){await this.G.writeFile(this.y,j.$ue.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),w=JSON.parse(y.value.toString());await this.G.del(this.y),w.ref&&w.content!==void 0?(this.I.store(this.z,JSON.stringify({...w,content:void 0}),-1,1),await this.ib({ref:w.ref,syncData:w.content===null?null:JSON.parse(w.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,w)}catch(y){y instanceof u.$9k&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:w,content:k}=await this.lb(y);let E=null;return k!==null&&(E=this.kb(k)),{ref:w,syncData:E}}kb(y){try{const w=JSON.parse(y);if(o(w))return w}catch(w){this.O.error(w)}throw new c.$Dpb((0,P.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const w=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,w,this.collection,this.F)}async mb(y,w){const k=await this.j,E={version:this.pb,machineId:k,content:y};try{return w=await this.J.writeResource(this.resource,JSON.stringify(E),w,this.collection,this.F),{ref:w,syncData:E}}catch(D){throw D instanceof c.$Dpb&&D.code==="TooLarge"&&(D=new c.$Dpb(D.message,D.code,this.resource)),D}}async nb(y){const w={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(w),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$qpb)}};e.$lJb=s,e.$lJb=s=ye([Q(2,u.$Nk),Q(3,f.$oi),Q(4,l.$Lp),Q(5,c.$ypb),Q(6,c.$zpb),Q(7,c.$Ipb),Q(8,d.$Ml),Q(9,c.$Npb),Q(10,p.$Ni),Q(11,h.$ll)],s);let t=class extends s{constructor(y,w,k,E,D,U,F,T,_,X,ee,H,K){super(w,k,E,D,U,F,T,_,X,ee,H,K),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,w,k){try{w?await this.G.writeFile(this.r,j.$ue.fromString(y),k?void 0:w):await this.G.createFile(this.r,j.$ue.fromString(y),{overwrite:k})}catch(E){throw E instanceof u.$9k&&E.fileOperationResult===1||E instanceof u.$9k&&E.fileOperationResult===3?new c.$Dpb(E.message,"LocalPreconditionFailed"):E}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof u.$9k&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$mJb=t,e.$mJb=t=ye([Q(3,u.$Nk),Q(4,f.$oi),Q(5,l.$Lp),Q(6,c.$ypb),Q(7,c.$zpb),Q(8,c.$Ipb),Q(9,d.$Ml),Q(10,c.$Npb),Q(11,p.$Ni),Q(12,h.$ll)],t);let r=class extends t{constructor(y,w,k,E,D,U,F,T,_,X,ee,H,K,W){super(y,w,k,E,D,U,F,T,_,X,ee,K,W),this.zb=H,this.Bb=void 0}Ab(y,w){const k=[],E=(0,R.$un)(y,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,C.$2f)(E)&&w!==Array.isArray(E)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$nJb=r,e.$nJb=r=ye([Q(3,u.$Nk),Q(4,f.$oi),Q(5,l.$Lp),Q(6,c.$ypb),Q(7,c.$zpb),Q(8,c.$Ipb),Q(9,d.$Ml),Q(10,c.$Npb),Q(11,c.$Mpb),Q(12,p.$Ni),Q(13,h.$ll)],r);let a=class{constructor(y,w,k,E,D,U,F){this.resource=y,this.g=w,this.h=k,this.j=E,this.k=D,this.l=U,this.d=F.extUri,this.f=(0,c.$wpb)(void 0,this.resource,k,this.d)}async initialize({ref:y,content:w}){if(!w){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(w);if(k)try{await this.o({ref:y,syncData:k})}catch(E){this.j.error(E)}}m(y){try{const w=JSON.parse(y);if(o(w))return w}catch(w){this.j.error(w)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,w={}){if(w.ref||w.version)throw new Error("Cannot have core properties as additional");const k={ref:y.ref,version:void 0,...w};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,j.$ue.fromString(JSON.stringify(y)))}};e.$oJb=a,e.$oJb=a=ye([Q(1,m.$nl),Q(2,f.$oi),Q(3,b.$Nj),Q(4,u.$Nk),Q(5,l.$Lp),Q(6,h.$ll)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,16,114,29,33,82,46,12,4,74,9,19,22,28,18,39,239,111,25,60]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=e.$O9b=e.$N9b=void 0,e.$L9b=y,e.$M9b=w;async function v(U,F){const T=JSON.parse(U.content);if(U.version===1||U.version===2){const _=(await F.getInstalled(0)).filter(X=>X.isBuiltin);for(const X of T)U.version===1&&(X.enabled===!1&&(X.disabled=!0),delete X.enabled),U.version===2&&_.every(ee=>!(0,f.$fp)(ee.identifier,X.identifier))&&(X.installed=!0)}return T}function y(U){return JSON.parse(U.content)}function w(U,F){return U.sort((T,_)=>!T.identifier.uuid&&_.identifier.uuid?-1:T.identifier.uuid&&!_.identifier.uuid?1:(0,S.$ef)(T.identifier.id,_.identifier.id)),F?(0,O.$Fn)(U,{}):JSON.stringify(U)}let k=class extends n.$lJb{constructor(F,T,_,X,ee,H,K,W,B,ne,oe,te,ce,G,q,N,M){super({syncResource:"extensions",profile:F},T,X,_,ee,H,K,te,ce,ne,oe,q),this.Cb=W,this.Db=B,this.Eb=M,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Ppb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Ppb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Ppb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Ppb,authority:"accepted"}),this.Bb=this.Eb.createInstance(E),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,z=>z.some(({local:Z})=>!!Z)),L.Event.filter(this.Cb.onDidUninstallExtension,z=>!z.error),L.Event.filter(N.onDidChange,z=>z.valueChanges.some(({profile:Z,changes:J})=>this.syncResource.profile.id===Z.id&&J.some(x=>x.key===p.$Uo))),G.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,T){const _=F.syncData?await v(F.syncData,this.Cb):null,X=T?.skippedExtensions??[],ee=T?.builtinExtensions??null,H=T?.syncData?await v(T.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);_?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ne}=(0,s.$K9b)(K,_,H,X,W,ee),oe={local:B,remote:ne,content:this.Hb(K,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ne!==null?2:0},te=this.Ob(K,!1);return[{skippedExtensions:X,builtinExtensions:ee,baseResource:this.xb,baseContent:H?this.Ob(H,!1):te,localResource:this.yb,localContent:te,localExtensions:K,remoteResource:this.zb,remoteExtensions:_,remoteContent:_?this.Ob(_,!1):null,previewResource:this.wb,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.Ab}]}async ub(F){const T=F.syncData?await v(F.syncData,this.Cb):null,{localExtensions:_,ignoredExtensions:X}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:ee}=(0,s.$K9b)(_,T,T,F.skippedExtensions||[],X,F.builtinExtensions||[]);return ee!==null}Hb(F,T,_,X){const ee=[...T,..._],H=new Set,K=W=>{H.add(W.id.toLowerCase()),W.uuid&&H.add(W.uuid)};ee.forEach(({identifier:W})=>K(W)),X.forEach(K);for(const W of F)H.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&H.has(W.identifier.uuid)||ee.push(W);return this.Ob(ee,!1)}async rb(F,T){return{...F.previewResult,hasConflicts:!1}}async sb(F,T,_,X){if(this.h.isEqual(T,this.yb))return this.Kb(F);if(this.h.isEqual(T,this.zb))return this.Lb(F);if(this.h.isEqual(T,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Kb(F){const T=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(T),X=(0,s.$K9b)(F.localExtensions,null,null,F.skippedExtensions,_,F.builtinExtensions),{local:ee,remote:H}=X;return{content:F.localContent,local:ee,remote:H,localChange:ee.added.length>0||ee.removed.length>0||ee.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(F){const T=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),_=this.Db.getIgnoredExtensions(T),X=F.remoteContent?JSON.parse(F.remoteContent):null;if(X!==null){const ee=(0,s.$K9b)(F.localExtensions,X,F.localExtensions,[],_,F.builtinExtensions),{local:H,remote:K}=ee;return{content:F.remoteContent,local:H,remote:K,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(F,T,_,X){let{skippedExtensions:ee,builtinExtensions:H,localExtensions:K}=_[0][0];const{local:W,remote:B,localChange:ne,remoteChange:oe}=_[0][1];if(ne===0&&oe===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ne!==0&&(await this.nb(JSON.stringify(K)),ee=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,ee,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const te=JSON.stringify(B.all);F=await this.mb(te,X?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ce=>ce.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ce=>ce.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ce=>ce.identifier.id))}.`:""}`)}T?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(K,H),await this.fb(F,{skippedExtensions:ee,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${ee.length?` Skipped: ${JSON.stringify(ee.map(te=>te.identifier.id))}.`:""}`))}Nb(F,T){const _=new Set,X=[];for(const ee of F)_.add(ee.identifier.id.toLowerCase()),ee.installed||X.push(ee.identifier);if(T)for(const ee of T)_.has(ee.id.toLowerCase())||X.push(ee);return X}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const T=await this.db(F);return T&&this.Ob(JSON.parse(T),!0)}return null}Ob(F,T){return w(F,T)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(T=>T.installed||T.disabled))return!0}catch{}return!1}};e.$N9b=k,e.$N9b=k=ye([Q(2,C.$oi),Q(3,$.$Nk),Q(4,c.$Lp),Q(5,r.$ypb),Q(6,r.$zpb),Q(7,p.$To),Q(8,t.$9Jb),Q(9,r.$Npb),Q(10,g.$Ni),Q(11,r.$Ipb),Q(12,m.$Ml),Q(13,u.$Gv),Q(14,i.$ll),Q(15,a.$nIb),Q(16,l.$gi)],k);let E=class{constructor(F,T,_,X,ee,H){this.a=F,this.b=T,this.c=_,this.d=X,this.f=ee,this.g=H}async getLocalExtensions(F){const T=await this.a.getInstalled(void 0,F.extensionsResource),_=this.d.getIgnoredExtensions(T);return{localExtensions:await this.j(F,async(ee,H)=>{const K=ee.getDisabledExtensions();return T.map(W=>{const{identifier:B,isBuiltin:ne,manifest:oe,preRelease:te,pinned:ce,isApplicationScoped:G}=W,q={identifier:B,preRelease:te,version:oe.version,pinned:!!ce};G&&!(0,b.$Fm)(oe)&&(q.isApplicationScoped=G),K.some(N=>(0,f.$fp)(N,B))&&(q.disabled=!0),ne||(q.installed=!0);try{const N=H.getKeysForSync({id:B.id,version:oe.version});if(N){const M=H.getExtensionState(W,!0)||{};q.state=Object.keys(M).reduce((z,Z)=>(N.includes(Z)&&(z[Z]=M[Z]),z),{})}}catch(N){this.g.info(`${(0,n.$kJb)("extensions",F)}: Error while parsing extension state`,(0,j.$0)(N))}return q})}),ignoredExtensions:_}}async updateLocalExtensions(F,T,_,X,ee){const H=(0,n.$kJb)("extensions",ee),K=[],W=new Map,B=[],ne=[],oe=await this.a.getInstalled(void 0,ee.extensionsResource);if((F.length||_.length)&&await this.j(ee,async(G,q)=>{await I.Promises.settled([...F,..._].map(async N=>{const M=oe.find(J=>(0,f.$fp)(J.identifier,N.identifier));if(M&&M.isBuiltin){N.state&&M.manifest.version===N.version&&this.h(N.state,M,M.manifest.version,q),G.getDisabledExtensions().some(x=>(0,f.$fp)(x,N.identifier))!==!!N.disabled&&(N.disabled?(this.g.trace(`${H}: Disabling extension...`,N.identifier.id),await G.disableExtension(N.identifier),this.g.info(`${H}: Disabled extension`,N.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,N.identifier.id),await G.enableExtension(N.identifier),this.g.info(`${H}: Enabled extension`,N.identifier.id))),B.push(N.identifier);return}const z=N.pinned?N.version:void 0,Z=(await this.c.getExtensions([{...N.identifier,version:z,preRelease:z?void 0:N.preRelease}],A.CancellationToken.None))[0];if(N.state&&(M?M.manifest.version===N.version:Z)&&this.h(N.state,M||Z,M?.manifest.version,q),Z)try{G.getDisabledExtensions().some(x=>(0,f.$fp)(x,N.identifier))!==!!N.disabled&&(N.disabled?(this.g.trace(`${H}: Disabling extension...`,N.identifier.id,Z.version),await G.disableExtension(Z.identifier),this.g.info(`${H}: Disabled extension`,N.identifier.id,Z.version)):(this.g.trace(`${H}: Enabling extension...`,N.identifier.id,Z.version),await G.enableExtension(Z.identifier),this.g.info(`${H}: Enabled extension`,N.identifier.id,Z.version))),(!M||M.preRelease!==N.preRelease||M.pinned!==N.pinned||z&&M.manifest.version!==z)&&(await this.a.canInstall(Z)?(K.push({extension:Z,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:N.pinned&&!!N.version,installPreReleaseVersion:N.preRelease,profileLocation:ee.extensionsResource,isApplicationScoped:N.isApplicationScoped,context:{[p.$Ho]:!0,[p.$Io]:!0}}}),W.set(Z.identifier.id.toLowerCase(),N)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,Z.displayName||Z.identifier.id),ne.push(N)))}catch(J){ne.push(N),this.g.error(J),this.g.info(`${H}: Skipped synchronizing extension`,Z.displayName||Z.identifier.id)}else ne.push(N),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}))}),T.length){const G=oe.filter(({identifier:q,isBuiltin:N})=>!N&&T.some(M=>(0,f.$fp)(q,M)));await I.Promises.settled(G.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:ee.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),B.push(q.identifier)}))}const te=await this.a.installGalleryExtensions(K);for(const{identifier:G,local:q,error:N,source:M}of te){const z=M;if(q)this.g.info(`${H}: Installed extension.`,G.id,z.version),B.push(G);else{const Z=W.get(G.id.toLowerCase());Z&&(ne.push(Z),this.g.info(`${H}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),N instanceof p.$Ro&&[p.ExtensionManagementErrorCode.Incompatible,p.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(N.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):N&&this.g.error(N)}}const ce=[];for(const G of X)B.some(q=>(0,f.$fp)(q,G.identifier))||ce.push(G);for(const G of ne)ce.some(q=>(0,f.$fp)(q.identifier,G.identifier))||ce.push(G);return ce}h(F,T,_,X){const ee=X.getExtensionState(T,!0)||{},H=_?X.getKeysForSync({id:T.identifier.id,version:_}):void 0;H?H.forEach(K=>{ee[K]=F[K]}):Object.keys(F).forEach(K=>ee[K]=F[K]),X.setExtensionState(T,ee,!0)}async j(F,T){return this.b.withProfileScopedStorageService(F,async _=>{const X=new R.$Tc,ee=this.f.createChild(new d.$fi([c.$Lp,_])),H=X.add(ee.createInstance(P.$LHb)),K=X.add(ee.createInstance(u.$Hv));try{return await T(H,K)}finally{X.dispose()}})}};e.$O9b=E,e.$O9b=E=ye([Q(0,p.$To),Q(1,a.$nIb),Q(2,p.$Qo),Q(3,t.$9Jb),Q(4,l.$gi),Q(5,r.$Npb)],E);let D=class extends n.$oJb{constructor(F,T,_,X,ee,H,K,W){super("extensions",X,ee,H,_,K,W),this.p=F,this.q=T}async t(F){return F.syncData?await v(F.syncData,this.p):null}u(F,T){const _=[],X=[],ee=[];for(const H of F){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const K=T.find(W=>(0,f.$fp)(W.identifier,H.identifier));K?(_.push(K),H.disabled&&ee.push(H.identifier)):H.installed&&(X.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&ee.push(H.identifier))}return{installedExtensions:_,newExtensions:X,disabledExtensions:ee,remoteExtensions:F}}};e.$P9b=D,e.$P9b=D=ye([Q(0,p.$To),Q(1,t.$9Jb),Q(2,$.$Nk),Q(3,o.$nl),Q(4,C.$oi),Q(5,h.$Nj),Q(6,c.$Lp),Q(7,i.$ll)],D)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,16,12,9,44,19,22,28,39,79,243,25,18,60,4]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJb=e.$tJb=e.$sJb=e.$rJb=void 0,e.$qJb=t;const n="globalState.argv.",s=["locale"];function t(k,E){const D=k.storage?Object.keys(k.storage).sort():[],U={};return D.forEach(F=>U[F]=k.storage[F]),k.storage=U,E?(0,O.$Fn)(k,{}):JSON.stringify(k)}const r=1;let a=class extends l.$lJb{constructor(E,D,U,F,T,_,X,ee,H,K,W,B,ne,oe){super({syncResource:"globalState",profile:E},D,F,ee,B,T,_,H,K,X,W,ne),this.Bb=U,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$Ppb,authority:"base"}),this.xb=this.vb.with({scheme:c.$Ppb,authority:"local"}),this.yb=this.vb.with({scheme:c.$Ppb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$Ppb,authority:"accepted"}),this.Ab=oe.createInstance(v),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(F.onDidFilesChange,te=>te.contains(this.H.argvResource)),j.Event.filter(U.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:G})=>this.syncResource.profile.id===ce.id&&G.some(q=>q.target===0)))))(()=>this.Q()))}async qb(E,D,U){const F=E.syncData?JSON.parse(E.syncData.content):null;D=D===null&&U?E:D;const T=D&&D.syncData?JSON.parse(D.syncData.content):null,_=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const X=await this.Jb(T),{local:ee,remote:H}=(0,h.$pJb)(_.storage,F?F.storage:null,T?T.storage:null,X,this.O),K={content:null,local:ee,remote:H,localChange:Object.keys(ee.added).length>0||Object.keys(ee.updated).length>0||ee.removed.length>0?2:0,remoteChange:H.all!==null?2:0},W=t(_,!1);return[{baseResource:this.wb,baseContent:T?t(T,!1):W,localResource:this.xb,localContent:W,localUserData:_,remoteResource:this.yb,remoteContent:F?t(F,!1):null,previewResource:this.vb,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.zb,storageKeys:X}]}async ub(E){const D=E.syncData?JSON.parse(E.syncData.content):null;if(D===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(D),{remote:T}=(0,h.$pJb)(U.storage,D.storage,D.storage,F,this.O);return T.all!==null}async rb(E,D){return{...E.previewResult,hasConflicts:!1}}async sb(E,D,U,F){if(this.h.isEqual(D,this.xb))return this.Gb(E);if(this.h.isEqual(D,this.yb))return this.Hb(E);if(this.h.isEqual(D,this.vb))return E.previewResult;throw new Error(`Invalid Resource: ${D.toString()}`)}async Gb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:0,remoteChange:2}}async Hb(E){if(E.remoteContent!==null){const D=JSON.parse(E.remoteContent),{local:U,remote:F}=(0,h.$pJb)(E.localUserData.storage,D.storage,null,E.storageKeys,this.O);return{content:E.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(E,D,U,F){const{localUserData:T}=U[0][0],{local:_,remote:X,localChange:ee,remoteChange:H}=U[0][1];if(ee===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),ee!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(T)),await this.Ab.writeLocalGlobalState(_,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const K=JSON.stringify({storage:X.all});E=await this.mb(K,F?null:E.ref),this.O.info(`${this.D}: Updated remote ui state.${X.added.length?` Added: ${X.added}.`:""}${X.updated.length?` Updated: ${X.updated}.`:""}${X.removed.length?` Removed: ${X.removed}.`:""}`)}D?.ref!==E.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(E),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.yb,E)||this.h.isEqual(this.wb,E)||this.h.isEqual(this.xb,E)||this.h.isEqual(this.zb,E)){const D=await this.db(E);return D&&t(JSON.parse(D),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(E){const D=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[X,ee]of D)ee.target===0?U.push(X):ee.target===1&&F.push(X);const T=[...U,...F],_=E?.storage?Object.keys(E.storage).filter(X=>!X.startsWith(n)&&!T.includes(X)&&D.get(X)!==void 0):[];if(!R.$o){const X=[...c.$upb.map(ee=>(0,c.$Hpb)(ee)),c.$Gpb];_.push(...X),F.push(...X)}return{user:U,machine:F,unregistered:_}}};e.$rJb=a,e.$rJb=a=ye([Q(2,i.$nIb),Q(3,P.$Nk),Q(4,c.$ypb),Q(5,c.$zpb),Q(6,c.$Npb),Q(7,C.$oi),Q(8,c.$Ipb),Q(9,b.$Ml),Q(10,g.$Ni),Q(11,u.$Lp),Q(12,$.$ll),Q(13,o.$gi)],a);let v=class{constructor(E,D,U,F){this.a=E,this.b=D,this.c=U,this.d=F}async getLocalGlobalState(E){const D={};if(E.isDefault){const F=await this.f(),T=(0,L.$un)(F);for(const _ of s)T[_]!==void 0&&(D[`${n}${_}`]={version:1,value:T[_]})}const U=await this.c.readStorageData(E);for(const[F,T]of U)T.value&&T.target===0&&(D[F]={version:1,value:T.value});return{storage:D}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,A.$0)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:D,updated:U},F){const T=(0,l.$kJb)("globalState",F),_={},X=new Map,ee=await this.c.readStorageData(F),H=(K,W)=>{for(const B of K){if(B.startsWith(n)){_[B.substring(n.length)]=W?W[B].value:void 0;continue}if(W){const ne=W[B];ne.value!==ee.get(B)?.value&&X.set(B,ne.value)}else ee.get(B)!==void 0&&X.set(B,void 0)}};if(H(Object.keys(E),E),H(Object.keys(U),U),H(D),Object.keys(_).length){this.d.trace(`${T}: Updating locale...`);const K=await this.f();let W=K;for(const B of Object.keys(_))W=(0,d.edit)(W,[B],_[B],{});K!==W&&(this.d.trace(`${T}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$ue.fromString(W)),this.d.info(`${T}: Updated locale.`)),this.d.info(`${T}: Updated locale`)}X.size&&(this.d.trace(`${T}: Updating global state...`),await this.c.updateStorageData(F,X,0),this.d.info(`${T}: Updated global state`,[...X.keys()]))}};e.$sJb=v,e.$sJb=v=ye([Q(0,P.$Nk),Q(1,C.$oi),Q(2,i.$nIb),Q(3,c.$Npb)],v);let y=class extends l.$oJb{constructor(E,D,U,F,T,_){super("globalState",U,F,T,D,E,_)}async o(E){const D=E.syncData?JSON.parse(E.syncData.content):null;if(!D){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const T of Object.keys(D.storage))T.startsWith(n)?U[T.substring(n.length)]=D.storage[T].value:this.l.get(T,0)===void 0&&(F[T]=D.storage[T].value);if(Object.keys(U).length){let T="{}";try{T=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const _ of Object.keys(U))T=(0,d.edit)(T,[_],U[_],{});await this.k.writeFile(this.h.argvResource,I.$ue.fromString(T))}if(Object.keys(F).length){const T=[];for(const _ of Object.keys(F))T.push({key:_,value:F[_],scope:0,target:0});this.l.storeAll(T,!0)}}};e.$tJb=y,e.$tJb=y=ye([Q(0,u.$Lp),Q(1,P.$Nk),Q(2,m.$nl),Q(3,C.$oi),Q(4,c.$Npb),Q(5,$.$ll)],y);let w=class{constructor(E,D,U,F,T){this.a=E,this.b=D,this.c=U,this.d=F,this.f=T}getSyncStoreType(E){return this.h(E)?.storage[c.$Gpb]?.value}async sync(E){const D=(0,c.$Cpb)((0,S.$Dg)());try{return await this.g(E,D)}catch(U){if(U instanceof c.$Dpb)switch(U.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,D)}throw U}}async g(E,D){const U=await this.a.readResource("globalState",null,void 0,D),F=this.h(U)||{storage:{}};F.storage[c.$Gpb]={value:E,version:r};const T=await(0,f.$Rp)(this.c,this.d,this.b),_={version:r,machineId:T,content:t(F,!1)};await this.a.writeResource("globalState",JSON.stringify(_),U.ref,void 0,D)}h({content:E}){if(!E)return null;const D=JSON.parse(E);if((0,l.$jJb)(D))return D?JSON.parse(D.content):null;throw new Error("Invalid remote data")}};e.$uJb=w,e.$uJb=w=ye([Q(1,u.$Lp),Q(2,C.$oi),Q(3,P.$Nk),Q(4,p.$Nj)],w)}),define(le[117],he([0,1,17,14,3,34,5,13,174,21,16,12,19,22,28,18,39,240,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=e.$S9b=void 0,e.$R9b=h;function h(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$2f)(s.all)?null:s.all;switch(O.OS){case 2:return(0,R.$2f)(s.mac)?null:s.mac;case 3:return(0,R.$2f)(s.linux)?null:s.linux;case 1:return(0,R.$2f)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let c=class extends $.$nJb{constructor(o,n,s,t,r,a,v,y,w,k,E,D,U){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,y,w,k,s,t,v,D,r,E,a,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:d.$Ppb,authority:"base"}),this.Gb=this.Eb.with({scheme:d.$Ppb,authority:"local"}),this.Hb=this.Eb.with({scheme:d.$Ppb,authority:"remote"}),this.Ib=this.Eb.with({scheme:d.$Ppb,authority:"accepted"}),this.B(j.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?h(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,v=await this.vb(),y=await this.Cb();let w=null,k=!1,E=!1,D=!1;if(r){let T=v?v.value.toString():"[]";if(T=T||"[]",this.Ab(T,!0))throw new d.$Dpb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==T||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const _=await(0,l.$Q9b)(T,r,a,y,this.zb);_.hasChanges&&(w=_.mergeContent,D=_.hasConflicts,k=D||_.mergeContent!==T,E=D||_.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),w=v.value.toString(),E=!0);const U={content:D?a:w,localChange:k?v?2:1:0,remoteChange:E?2:0,hasConflicts:D},F=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,l.$Q9b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:v,remoteChange:y}=s[0][1];if(v===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new d.$Dpb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const w=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(w,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,L.$un)(o.value.toString());if((0,I.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:h(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,O.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(d.$rpb)}};e.$S9b=c,e.$S9b=c=ye([Q(2,d.$ypb),Q(3,d.$zpb),Q(4,d.$Npb),Q(5,g.$Ni),Q(6,d.$Ipb),Q(7,P.$Nk),Q(8,C.$oi),Q(9,p.$Lp),Q(10,d.$Mpb),Q(11,f.$Ml),Q(12,u.$ll)],c);let m=class extends $.$oJb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$ue.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$un)(o.value.toString());return!(0,I.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return h(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$T9b=m,e.$T9b=m=ye([Q(0,P.$Nk),Q(1,b.$nl),Q(2,C.$oi),Q(3,d.$Npb),Q(4,p.$Lp),Q(5,u.$ll)],m)}),define(le[118],he([0,1,14,3,175,21,76,16,29,12,19,22,28,18,39,244,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=e.$V9b=void 0,e.$U9b=d;function l(m){return m&&m.settings&&typeof m.settings=="string"&&Object.keys(m).length===1}function d(m){const i=JSON.parse(m);return l(i)?i:{settings:m}}let h=class extends u.$nJb{constructor(i,o,n,s,t,r,a,v,y,w,k,E,D,U){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,k,E,v,y,w,U),this.Eb=D,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:$.$Ppb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Ppb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Ppb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Ppb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new O.$jo($.$qpb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue($.$qpb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,v=await this.Pb();let y=null,w=!1,k=!1,E=!1;if(r){let T=s?s.value.toString().trim():"{}";T=T||"{}",this.Qb(T),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const _=(0,b.$7Hb)(T,r.settings,a?a.settings:null,v,[],t);y=_.localContent||_.remoteContent,w=_.localContent!==null,k=_.remoteContent!==null,E=_.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=s.value.toString().trim()||"{}",this.Qb(y),k=!0);const D=s?s.value.toString():null,U=a?.settings??null,F={content:E?U:y,localChange:w?2:0,remoteChange:k?2:0,hasConflicts:E};return[{fileContent:s,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:D,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$7Hb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$6Hb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$6Hb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$6Hb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$6Hb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const y=await this.Cb(),w=this.Lb(i),k=await this.Pb(r);r=(0,b.$6Hb)(r,w?w.settings:"{}",k,y),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$8Hb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$6Hb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return d(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$4Hb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new $.$Dpb((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$V9b=h,e.$V9b=h=ye([Q(2,g.$Nk),Q(3,R.$oi),Q(4,C.$Lp),Q(5,$.$ypb),Q(6,$.$zpb),Q(7,$.$Npb),Q(8,$.$Mpb),Q(9,L.$Ni),Q(10,$.$Ipb),Q(11,P.$Ml),Q(12,S.$To),Q(13,p.$ll)],h);let c=class extends u.$oJb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$ue.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$8Hb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return d(i)}catch(o){this.j.error(o)}return null}};e.$W9b=c,e.$W9b=c=ye([Q(0,g.$Nk),Q(1,f.$nl),Q(2,R.$oi),Q(3,$.$Npb),Q(4,C.$Lp),Q(5,p.$ll)],c)}),define(le[119],he([0,1,14,3,30,21,16,12,19,22,28,18,39,241,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=e.$19b=void 0,e.$Z9b=b;function b(d){return JSON.parse(d.content)}let $=class extends p.$lJb{constructor(h,c,m,i,o,n,s,t,r,a,v,y){super({syncResource:"snippets",profile:h},c,i,m,o,n,s,a,v,t,r,y),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(m.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,w=>w.affects(this.vb))(()=>this.Q()))}async qb(h,c,m){const i=await this.Hb(),o=this.Gb(i),n=h.syncData?this.Fb(h.syncData):null;c=c===null&&m?h:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,f.$X9b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(h){const c=h.syncData?this.Fb(h.syncData):null;if(c===null)return!0;const m=await this.Hb(),i=this.Gb(m),o=(0,f.$X9b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(h,c){return h.previewResult}async sb(h,c,m,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:u.$Ppb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:u.$Ppb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return m===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:m,localChange:m===null?h.fileContent!==null?3:0:2,remoteChange:m===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(h,c,m,i){const o=m.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(o,h,i)),c?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(h,c,m,i){const o=new Map;for(const n of Object.keys(h.local.added)){const s={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const s={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of h.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const s={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const s={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of h.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:m[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of h.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:m[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:m[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"remote"}),remoteContent:m[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:u.$Ppb,authority:"accepted"})})}return[...o.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:u.$Ppb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:u.$Ppb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:u.$Ppb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:u.$Ppb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const c={};for(const m of h)m.fileContent&&(c[this.h.basename(m.localResource)]=m.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(h,c){for(const{fileContent:m,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of h)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$ue.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$ue.fromString(i.content),c?void 0:m),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(h,c,m){const i=c.syncData?this.Fb(c.syncData):{},o=(0,j.$Nn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of h)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,f.$Y9b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),m?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(h){return b(h)}Gb(h){const c={};for(const m of Object.keys(h))c[m]=h[m].value.toString();return c}async Hb(){const h={};let c;try{c=await this.G.resolve(this.vb)}catch(m){if(m instanceof R.$9k&&m.fileOperationResult===1)return h;throw m}for(const m of c.children||[]){const i=m.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);h[n]=s}}return h}};e.$19b=$,e.$19b=$=ye([Q(2,O.$oi),Q(3,R.$Nk),Q(4,S.$Lp),Q(5,u.$ypb),Q(6,u.$zpb),Q(7,u.$Npb),Q(8,L.$Ni),Q(9,u.$Ipb),Q(10,g.$Ml),Q(11,C.$ll)],$);let l=class extends p.$oJb{constructor(h,c,m,i,o,n){super("snippets",c,m,i,h,o,n)}async o(h){const c=h.syncData?JSON.parse(h.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,I.$ue.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$29b=l,e.$29b=l=ye([Q(0,R.$Nk),Q(1,P.$nl),Q(2,O.$oi),Q(3,u.$Npb),Q(4,S.$Lp),Q(5,C.$ll)],l)}),define(le[120],he([0,1,14,21,16,12,19,22,28,18,39,25]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=e.$49b=void 0,e.$39b=p;function p($,l){try{return JSON.parse($).tasks??null}catch(d){return l.error(d),null}}let f=class extends C.$mJb{constructor(l,d,h,c,m,i,o,n,s,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,n,s,t,h,c,o,r,m,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:P.$Ppb,authority:"base"}),this.Cb=this.Ab.with({scheme:P.$Ppb,authority:"local"}),this.Db=this.Ab.with({scheme:P.$Ppb,authority:"remote"}),this.Eb=this.Ab.with({scheme:P.$Ppb,authority:"accepted"})}async qb(l,d,h,c){const m=l.syncData?p(l.syncData.content,this.O):null;d=d===null&&h?l:d;const i=d?.syncData?p(d.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(l.syncData){const y=o?o.value.toString():null;if(!i||i!==y||i!==m){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const w=b(y,m,i);n=w.content,r=w.hasConflicts,s=w.hasLocalChanged,t=w.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:m,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const d=l?.syncData?p(l.syncData.content,this.O):null;if(d===null)return!0;const h=await this.vb(),c=h?h.value.toString():null,m=b(c,d,d);return m.hasLocalChanged||m.hasRemoteChanged}async rb(l,d){return l.previewResult}async sb(l,d,h,c){if(this.h.isEqual(d,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.Ab))return h===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async tb(l,d,h,c){const{fileContent:m}=h[0][0],{content:i,localChange:o,remoteChange:n}=h[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),m&&await this.nb(JSON.stringify(this.Kb(m.value.toString()))),i?await this.wb(i,m,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));l=await this.mb(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}d?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$49b=f,e.$49b=f=ye([Q(2,P.$ypb),Q(3,P.$zpb),Q(4,P.$Npb),Q(5,A.$Ni),Q(6,P.$Ipb),Q(7,L.$Nk),Q(8,j.$oi),Q(9,O.$Lp),Q(10,R.$Ml),Q(11,S.$ll)],f);let u=class extends C.$oJb{constructor(l,d,h,c,m,i){super("tasks",d,h,c,l,m,i),this.c=this.g.defaultProfile.tasksResource}async o(l){const d=l.syncData?p(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$ue.fromString(d)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$59b=u,e.$59b=u=ye([Q(0,L.$Nk),Q(1,g.$nl),Q(2,j.$oi),Q(3,P.$Npb),Q(4,O.$Lp),Q(5,S.$ll)],u);function b($,l,d){if($===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if($===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=d!==$,c=d!==l;return!h&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!c?{content:$,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!h?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:$,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,16,12,19,22,28,18,39,242,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J$b=void 0,e.$K$b=u,e.$L$b=b;let f=class extends C.$lJb{constructor(l,d,h,c,m,i,o,n,s,t,r,a,v){super({syncResource:"profiles",profile:l},d,c,m,i,o,n,r,a,s,t,v),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.$Ppb,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.$Ppb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.$Ppb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.$Ppb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?b(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),h=await this.X(l,d);return h?.syncData?b(h.syncData):null}async qb(l,d,h){if(!this.vb.isEnabled())throw new p.$Dpb("Cannot sync profiles because they are disabled","LocalError");const c=l.syncData?b(l.syncData):null,m=d?.syncData?b(d.syncData):null,i=this.Db(),{local:o,remote:n}=(0,P.$I$b)(i,c,m,[]),s={local:o,remote:n,content:m?this.Eb(m):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=u(i,!1);return[{baseResource:this.baseResource,baseContent:m?this.Eb(m):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const d=l?.syncData?b(l.syncData):null,h=this.Db(),{remote:c}=(0,P.$I$b)(h,d,d,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(l,d){return{...l.previewResult,hasConflicts:!1}}async sb(l,d,h,c){if(this.h.isEqual(d,this.localResource))return this.Ab(l);if(this.h.isEqual(d,this.remoteResource))return this.Bb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async Ab(l){const d=this.Db(),h=(0,P.$I$b)(d,null,null,[]),{local:c,remote:m}=h;return{content:l.localContent,local:c,remote:m,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:m!==null?2:0}}async Bb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,h=[],c=[];for(const m of this.Db()){const i=d?.find(o=>o.id===m.id);i&&(h.push({id:m.id,name:m.name,collection:i.collection}),c.push(m))}if(d!==null){const m=(0,P.$I$b)(c,d,h,[]),{local:i,remote:o}=m;return{content:l.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,d,h,c){const{local:m,remote:i,localChange:o,remoteChange:n}=h[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=h[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new p.$Dpb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb(u(this.Db(),!1));const t=[];for(const r of m.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of m.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of m.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),s.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:v})=>a.id===v),1);for(const a of i?.updated||[]){const v=s.find(({id:y})=>a.id===y);v&&s.splice(s.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}d?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.mb(this.Eb(l),d)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.db(l);return d&&(0,I.$Fn)(JSON.parse(d),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((d,h)=>d.name.localeCompare(h.name)))}};e.$J$b=f,e.$J$b=f=ye([Q(2,g.$nl),Q(3,L.$Nk),Q(4,j.$oi),Q(5,O.$Lp),Q(6,p.$ypb),Q(7,p.$zpb),Q(8,p.$Npb),Q(9,A.$Ni),Q(10,p.$Ipb),Q(11,R.$Ml),Q(12,S.$ll)],f);function u($,l){const d=[...$].sort((h,c)=>h.name.localeCompare(c.name)).map(h=>({id:h.id,name:h.name}));return l?(0,I.$Fn)(d,{}):JSON.stringify(d)}function b($){return JSON.parse($.content)}}),define(le[259],he([0,1,3,2,5,16,19,22,25]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=void 0;const g="sync.enable";let C=class extends A.$Uc{constructor(p,f,u,b){super(),this.c=p,this.f=f,this.g=u,this.h=b,this.a=new I.$7d,this.onDidChangeEnablement=this.a.event,this.b=new I.$7d,this.onDidChangeResourceEnablement=this.b.event,this.B(p.onDidChangeValue(-1,void 0,this.B(new A.$Tc))($=>this.m($)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:p}),this.c.store(g,p,-1,1))}isResourceEnabled(p){return this.c.getBoolean((0,S.$Hpb)(p),-1,!0)}setResourceEnablement(p,f){if(this.isResourceEnabled(p)!==f){const u=(0,S.$Hpb)(p);this.j(u,f)}}getResourceSyncStateVersion(p){}j(p,f){this.c.store(p,f,-1,j.$o?0:1)}m(p){if(g===p.key){this.a.fire(this.isEnabled());return}const f=S.$upb.filter(u=>(0,S.$Hpb)(u)===p.key)[0];if(f){this.b.fire([f,this.isResourceEnabled(f)]);return}}};e.$w$b=C,e.$w$b=C=ye([Q(0,O.$Lp),Q(1,R.$Ml),Q(2,L.$oi),Q(3,S.$xpb)],C)}),define(le[260],he([0,1,6,14,65,2,20,21,16,12,18,25]),function(se,e,I,A,j,L,O,R,S,g,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;let p=class extends L.$Uc{constructor(u,b,$,l,d){super(),this.a=u,this.b=b,this.c=$,this.f=l,this.g=d,this.h()}async h(){for(const b of this.g.profiles)for(const $ of P.$upb)try{await this.m(this.j($,b.isDefault?void 0:b.id))}catch(l){this.f.error(l)}let u;try{u=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,g.$5k)(b)!==1&&this.f.error(b);return}if(u.children){for(const b of u.children)if(b.isDirectory&&!this.g.profiles.some($=>$.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch($){this.f.error($)}}}async getAllResourceRefs(u,b,$){const l=this.j(u,b,$);try{const d=await this.b.resolve(l);if(d.children)return d.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(d){if((0,g.$5k)(d)!==1)throw d}return[]}async resolveResourceContent(u,b,$,l){const d=this.j(u,$,l),h=(0,O.$Ug)(d,b);try{return(await this.b.readFile(h)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource(u,b,$,l,d){const h=this.j(u,l,d),c=(0,O.$Ug)(h,`${(0,j.$Om)($).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,A.$ue.fromString(b))}catch(m){this.f.error(m)}}j(u,b,$=this.a.userDataSyncHome){return(0,O.$Ug)($,...b?[b,u]:[u])}async m(u){try{try{if(!await this.b.exists(u))return}catch{return}const b=await this.b.resolve(u);if(b.children){const $=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=$.filter(c=>Date.now()-this.n(c)>l);const h=$.length-d.length;h<10&&(d=d.slice(10-h)),await I.Promises.settled(d.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(b){this.f.error(b)}}n(u){return new Date(parseInt(u.name.substring(0,4)),parseInt(u.name.substring(4,6))-1,parseInt(u.name.substring(6,8)),parseInt(u.name.substring(9,11)),parseInt(u.name.substring(11,13)),parseInt(u.name.substring(13,15))).getTime()}};e.$H$b=p,e.$H$b=p=ye([Q(0,S.$oi),Q(1,g.$Nk),Q(2,R.$Ni),Q(3,P.$Npb),Q(4,C.$nl)],p)}),define(le[83],he([0,1,3,2,5,27,179,16,12,4,24,44,19,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$npb=e.$lpb=void 0,e.$mpb=m,e.$lpb=(0,g.$hi)("IUserDataSyncMachinesService");const b="sync.currentMachineName",$="Safari",l="Chrome",d="Edge",h="Firefox",c="Android";function m(n){switch(n){case $:case l:case d:case h:case c:case(0,j.$h)(0):return!0}return!1}function i(){return j.$G?$:j.$E?l:j.$H?d:j.$F?h:j.$I?c:(0,j.$h)(j.$o?0:j.$u)}let o=class extends A.$Uc{static{u=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,v,y){super(),this.h=r,this.j=a,this.m=v,this.n=y,this.c=this.B(new I.$7d),this.onDidChange=this.c.event,this.g=null,this.f=(0,P.$Rp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),v=a.machines.find(({id:y})=>y===s);if(v){v.name=t,await this.t(a);const y=await this.f;s===y&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const v=t.machines.find(y=>y.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$Ze)(r)}\\s#(\\d+)`);let v=0;for(const y of s){const w=a.exec(y.name),k=w?parseInt(w[1]):0;v=k>v?k:v}return`${r} #${v+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==u.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(u.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[u.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(u.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:u.a,machines:[]}}};e.$npb=o,e.$npb=o=u=ye([Q(0,R.$oi),Q(1,S.$Nk),Q(2,p.$Lp),Q(3,f.$ypb),Q(4,f.$Npb),Q(5,C.$7j)],o)}),define(le[261],he([0,1,6,65,38,7,3,2,5,20,8,176,24,19,22,25,80,83]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0;const d="sync.disableMachineEventually",h="sync.sessionId",c="sync.storeUrl",m="sync.productQuality";let i=class extends R.$Uc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(m,-1)}set s(s){s?this.H.store(m,s,-1,1):this.H.remove(m,-1)}constructor(s,t,r,a,v,y,w,k,E,D){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=y,this.D=w,this.F=k,this.G=E,this.H=D,this.a=this.B(new R.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$7d),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$fh(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Ng)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(w.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$Om)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$Dpb.toUserDataSyncError(s);t instanceof b.$Fpb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?S.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(d,!0,-1,1),await(0,I.$ih)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(d,-1,!1)}R(){this.H.remove(d,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$N$b=i,e.$N$b=i=ye([Q(0,p.$7j),Q(1,b.$xpb),Q(2,b.$ypb),Q(3,b.$Ipb),Q(4,b.$Jpb),Q(5,b.$Npb),Q(6,$.$NHb),Q(7,u.$Ml),Q(8,l.$lpb),Q(9,f.$Lp)],i);class o extends R.$Uc{static{this.a="Interval"}constructor(s,t,r,a,v,y,w,k,E){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=v,this.w=y,this.y=w,this.z=k,this.C=E,this.b=this.B(new R.$Vc),this.c=this.B(new O.$7d),this.onDidStartSync=this.c.event,this.f=this.B(new O.$7d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,I.$jh)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,I.$7g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$4)(v))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Ng)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Ng)(t.defaultUrl,s.defaultUrl)||!(0,g.$Ng)(t.insidersUrl,s.insidersUrl)||!(0,g.$Ng)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,b.$Dpb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(y){this.y.error(y),a=y}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$Fpb((0,P.localize)(0,null),"DefaultServiceChanged"):new b.$Fpb((0,P.localize)(1,null),"ServiceChanged"):new b.$Fpb((0,P.localize)(2,null),"TurnedOff");const r=this.C.get(h,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$Fpb((0,P.localize)(3,null),"DefaultServiceChanged"):new b.$Fpb((0,P.localize)(4,null),"ServiceChanged"):new b.$Fpb((0,P.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(w=>w.isCurrent);if(v?.disabled)throw new b.$Fpb((0,P.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(w){throw new b.$Fpb((0,j.$5i)(w),w instanceof b.$Dpb?w.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(h,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[262],he([0,1,8,180,16,12,44,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,y,w,k,E,D,U){this.e=t,this.f=r,this.g=a,this.h=y,this.i=w,this.j=k,this.k=E,this.l=D,this.n=U,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$L$b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,c.$L$b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:y})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:y,ref:w})=>({created:y,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:w,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$Rp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,y){if(t){const{content:w}=await this.M(r,v,a);return w}return this.f.resolveResourceContent(r,v,a,y)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,f.$U9b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,u.$R9b)(t.content,!!this.l.getValue(g.$rpb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,$.$39b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const y=(0,p.$Z9b)(v),w=[];for(const k of Object.keys(y)){const E=this.d.joinPath(t,k),D=r?this.d.joinPath(r.snippetsHome,k):this.d.joinPath(t,o.a);w.push({resource:E,comparableResource:D})}return w}}return[]}z(t,r){return(0,p.$Z9b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$M9b)((0,l.$L9b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$O9b).getLocalExtensions(t);return(0,l.$M9b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,d.$qJb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(d.$sJb).getLocalGlobalState(t);return(0,d.$qJb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,m.$Fn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$K$b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$4e)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(I.URI.from({scheme:g.$Ppb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$Ppb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,y;const w=[];let k,E,D,U,F;for(;r.length;){const T=r.shift();T.startsWith("scheme:")?v=T.substring(7):T.startsWith("authority:")?y=T.substring(10):T.startsWith("syncResource:")?k=T.substring(13):T.startsWith("profile:")?E=T.substring(8):T.startsWith("collection:")?D=T.substring(11):T.startsWith("ref:")?U=T.substring(4):k?F=T:w.push(T)}return{remote:a,syncResource:k,profile:E,collection:D,ref:U,node:F,location:v&&y!==void 0?this.d.joinPath(I.URI.from({scheme:v,authority:y,query:t.query,fragment:t.fragment,path:"/"}),...w):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,P.$jJb)(a))return a}catch(a){this.g.error(a)}throw new g.$Dpb((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$j_b=n,e.$j_b=n=o=ye([Q(0,g.$ypb),Q(1,g.$zpb),Q(2,g.$Npb),Q(3,S.$ll),Q(4,j.$oi),Q(5,R.$Lp),Q(6,L.$Nk),Q(7,C.$nl),Q(8,b.$Ni),Q(9,h.$gi)],n)}),define(le[263],he([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(k,E,D,U,F,T,_,X,ee,H,K){super(),this.C=k,this.D=E,this.F=D,this.G=U,this.H=F,this.I=T,this.J=_,this.L=X,this.M=ee,this.N=H,this.O=K,this.f="uninitialized",this.g=this.B(new O.$7d),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$7d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$7d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$7d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$7d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$7d),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$7d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=D.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Sc)(()=>this.bb()))}async createSyncTask(k,E){this.cb(),this.H.info("Sync started.");const D=new Date().getTime(),U=(0,C.$Dg)();try{const X=(0,s.$Cpb)(U);E&&(X["Cache-Control"]="no-cache"),k=await this.D.manifest(k,X)}catch(X){const ee=s.$Dpb.toUserDataSyncError(X);throw y(ee,U,this.F,this.I),ee}const F=!1,T=this;let _;return{manifest:k,async run(){if(F)throw new Error("Can run a task only once");_=(0,A.$7g)(X=>T.P(k,!1,U,X)),await _.finally(()=>_=void 0),T.H.info(`Sync done. Took ${new Date().getTime()-D}ms`),T.$()},stop(){return _?.cancel(),T.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Dpb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const k=new Date().getTime(),E=(0,C.$Dg)(),D=(0,s.$Cpb)(E);let U;try{U=await this.D.manifest(null,D)}catch(_){const X=s.$Dpb.toUserDataSyncError(_);throw y(X,E,this.F,this.I),X}await this.resetLocal();const F=this,T=new j.$ee;return{id:E,async merge(){return F.P(U,!0,E,T.token)},async apply(){try{try{await F.R(U,E,T.token)}catch(_){if(s.$Dpb.toUserDataSyncError(_).code==="MethodNotFound")F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,E,T.token);else throw _}}catch(_){throw F.H.error(_),_}F.H.info(`Sync done. Took ${new Date().getTime()-k}ms`),F.$()},async stop(){T.cancel(),await F.U(),await F.resetLocal()}}}async P(k,E,D,U){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,k,E,D,U));const T=F.enabled.find(_=>_.resource==="profiles");if(T){const _=await T.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(_,k,E,D,U)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(k,E,D,U,F){for(const T of k){if(F.isCancellationRequested)return;const _=this.M.profiles.find(ee=>ee.id===T.id);if(!_){this.H.error(`Profile with id:${T.id} and name: ${T.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",T.name);const X=this.getOrCreateActiveProfileSynchronizer(_,T);this.n.push(...await this.S(X,E,D,U,F))}for(const[T,_]of this.z.entries())this.M.profiles.some(X=>X.id===_[0].profile.id)||(_[1].dispose(),this.z.delete(T))}async R(k,E,D){const U=this.ab();for(const ee of U){if(D.isCancellationRequested)return;await ee.apply(E,D)}const F=U.find(ee=>ee.profile.isDefault);if(!F)return;const T=F.enabled.find(ee=>ee.resource==="profiles");if(!T)return;const X=(await T.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(ee=>U.every(H=>H.profile.id!==ee.id));X.length&&await this.Q(X,k,!1,E,D)}async S(k,E,D,U,F){return(await k.sync(E,D,U,F)).map(([_,X])=>({profile:k.profile,syncResource:_,error:X}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(k=>k.stop()))}async resolveContent(k){const E=await this.N.resolveContent(k);if(E)return E;for(const D of this.ab())for(const U of D.enabled){const F=await U.resolveContent(k);if(F)return F}return null}async replace(k){this.cb();const E=this.N.resolveUserDataSyncResource(k);if(!E)return;const D=await this.resolveContent(k.uri);D&&await this.W(E.profile,async U=>{if(E.syncResource===U.resource)return await U.replace(D),!0})}async accept(k,E,D,U){this.cb(),await this.W(k.profile,async F=>{if(k.syncResource===F.resource)return await F.accept(E,D),U&&await F.apply((0,g.$1f)(U)?!1:U.force,(0,s.$Cpb)((0,C.$Dg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async E=>{if(E.resource!=="globalState"&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(k){this.H.error(k)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[k]of this.z.values())try{await k.resetLocal()}catch(E){this.H.error(E)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const k=await this.N.getRemoteSyncedProfiles(),E=k.map(T=>T.collection),D=await this.D.getAllCollections(),U=D.filter(T=>!E.includes(T));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(T=>this.D.deleteCollection(T))),this.H.info("Deleted redundant collections on server"));const F=k.filter(T=>D.includes(T.collection));if(F.length!==k.length){const T=this.G.createInstance(n.$J$b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await T.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await T.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{T.dispose()}}}async saveRemoteActivityData(k){this.cb();const E=await this.D.getActivityData();await this.C.writeFile(k,E)}async extractActivityData(k,E){const D=(await this.C.readFile(k)).value.toString(),U=JSON.parse(D);if(U.resources)for(const F in U.resources)for(const T of U.resources[F])await this.O.writeResource(F,T.content,new Date(T.created*1e3),void 0,E);if(U.collections)for(const F in U.collections)for(const T in U.collections[F].resources)for(const _ of U.collections[F].resources?.[T]??[])await this.O.writeResource(T,_.content,new Date(_.created*1e3),F,E)}async W(k,E){const D=new R.$Tc;try{const U=this.z.get(k.id);if(U){const ee=await this.X(U[0],E,D);return(0,g.$2f)(ee)?null:ee}if(k.isDefault){const ee=D.add(this.G.createInstance(a,k,void 0)),H=await this.X(ee,E,D);return(0,g.$2f)(H)?null:H}if(this.M.isEnabled())return null;const F=D.add(this.G.createInstance(n.$J$b,k,void 0)),T=await this.D.manifest(null),X=(await F.getRemoteSyncedProfiles(T?.latest??null)||[]).find(ee=>ee.id===k.id);if(X){const ee=D.add(this.G.createInstance(a,k,X.collection)),H=await this.X(ee,E,D);return(0,g.$2f)(H)?null:H}return null}finally{D.dispose()}}async X(k,E,D){const U=[...k.enabled,...k.disabled.reduce((F,T)=>(T!=="workspaceState"&&F.push(D.add(k.createSynchronizer(T))),F),[])];for(const F of U){const T=await E(F);if(!(0,g.$2f)(T))return T}}Y(k){const E=this.f;this.f!==k&&(this.f=k,this.g.fire(k),E==="hasConflicts"&&this.$())}Z(){const k=this.ab().map(E=>E.conflicts).flat();(0,I.$ub)(this.j,k,(E,D)=>E.profile.id===D.profile.id&&E.syncResource===D.syncResource&&(0,I.$ub)(E.conflicts,D.conflicts,(U,F)=>(0,S.$Ng)(U.previewResource,F.previewResource)))||(this.j=k,this.m.fire(k))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(k,E){let D=this.z.get(k.id);if(D&&D[0].collection!==E?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.z.delete(k.id)),!D){const U=new R.$Tc,F=U.add(this.G.createInstance(a,k,E?.collection));U.add(F.onDidChangeStatus(T=>this.Y(T))),U.add(F.onDidChangeConflicts(T=>this.Z())),U.add(F.onDidChangeLocal(T=>this.h.fire(T))),this.z.set(k.id,D=[F,U])}return D[0]}ab(){const k=[];for(const[E]of this.z.values())k.push(E);return k}bb(){this.z.forEach(([,k])=>k.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$M$b=r,e.$M$b=r=ye([Q(0,f.$Nk),Q(1,s.$ypb),Q(2,s.$xpb),Q(3,u.$gi),Q(4,s.$Npb),Q(5,$.$Ml),Q(6,b.$Lp),Q(7,s.$Ipb),Q(8,l.$nl),Q(9,s.$Kpb),Q(10,s.$zpb)],r);let a=class extends R.$Uc{get enabled(){return this.f.sort((k,E)=>k[1]-E[1]).map(([k])=>k)}get disabled(){return s.$upb.filter(k=>!this.r.isResourceEnabled(k))}get status(){return this.g}get conflicts(){return this.m}constructor(k,E,D,U,F,T,_,X,ee,H){super(),this.profile=k,this.collection=E,this.r=D,this.t=U,this.u=F,this.w=T,this.y=_,this.z=X,this.C=ee,this.D=H,this.f=[],this.g="idle",this.h=this.B(new O.$7d),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$7d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$7d),this.onDidChangeConflicts=this.n.event,this.B(D.onDidChangeResourceEnablement(([K,W])=>this.F(K,W))),this.B((0,R.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of s.$upb)D.isResourceEnabled(K)&&this.G(K)}F(k,E){E?this.G(k):this.H(k)}G(k){if(this.f.some(([F])=>F.resource===k))return;if(k==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||k==="workspaceState")return;if(k!=="profiles"&&this.profile.useDefaultFlags?.[k]){this.z.debug(`Skipping syncing ${k} in ${this.profile.name} because it is already synced by default profile`);return}const E=new R.$Tc,D=E.add(this.createSynchronizer(k));E.add(D.onDidChangeStatus(()=>this.L())),E.add(D.onDidChangeConflicts(()=>this.M())),E.add(D.onDidChangeLocal(()=>this.j.fire(k)));const U=this.N(k);this.f.push([D,U,E])}H(k){const E=this.f.findIndex(([D])=>D.resource===k);if(E!==-1){const[[D,,U]]=this.f.splice(E,1);U.dispose(),this.L(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(k){switch(k){case"settings":return this.t.createInstance(m.$V9b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$S9b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$19b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$49b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$rJb,this.profile,this.collection);case"extensions":return this.t.createInstance(d.$N9b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$J$b,this.profile,this.collection)}}async sync(k,E,D,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const T=[],_=(0,s.$Cpb)(D),X=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,ee=E?await this.I(X):{};for(const H of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(E){const K=await H.preview(X,ee,_);if(K)for(const W of K.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await H.merge(W.previewResource)}else await H.sync(X,_)}catch(K){const W=s.$Dpb.toUserDataSyncError(K);if(y(W,D,this.w,this.y),v(K))throw W;this.z.error(K),this.z.error(`${H.resource}: ${(0,L.$5i)(K)}`),T.push([H.resource,W])}}return T}finally{this.L()}}async apply(k,E){const D=(0,s.$Cpb)(k);for(const U of this.enabled){if(E.isCancellationRequested)return;try{await U.apply(!1,D)}catch(F){const T=s.$Dpb.toUserDataSyncError(F);if(y(T,k,this.w,this.y),v(F))throw T;this.z.error(F),this.z.error(`${U.resource}: ${(0,L.$5i)(F)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(E){this.z.error(E)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(E){this.z.error(`${k.resource}: ${(0,L.$5i)(E)}`),this.z.error(E)}}async I(k){if(!this.profile.isDefault)return{};const E=this.D.getValue(s.$qpb),D=this.enabled.find(U=>U instanceof m.$V9b);if(D){const U=await D.getRemoteUserDataSyncConfiguration(k);return{...E,...U}}return E}J(k){this.g!==k&&(this.g=k,this.h.fire(k))}L(){return this.M(),this.enabled.some(k=>k.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const k=this.enabled.filter(E=>E.status==="hasConflicts").filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,I.$ub)(this.m,k,(E,D)=>E.syncResource===D.syncResource&&(0,I.$ub)(E.conflicts,D.conflicts,(U,F)=>(0,S.$Ng)(U.previewResource,F.previewResource)))||(this.m=k,this.n.fire(k))}N(k){switch(k){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([Q(2,s.$Ipb),Q(3,u.$gi),Q(4,p.$Qo),Q(5,s.$xpb),Q(6,$.$Ml),Q(7,s.$Npb),Q(8,l.$nl),Q(9,P.$Ni)],a);function v(w){if(w instanceof s.$Dpb)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(w,k,E,D){D.publicLog2("sync/error",{code:w.code,serverCode:w instanceof s.$Epb?String(w.serverCode):void 0,url:w instanceof s.$Epb?w.url:void 0,resource:w.resource,executionId:k,service:E.userDataSyncStore.url.toString()})}}),define(le[264],he([0,1,3,2,8,18,25]),function(se,e,I,A,j,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0;function R(p,f){return{...p,profile:(0,L.$ol)(p.profile,f.profilesHome.scheme)}}function S(p){return{created:p.created,uri:j.URI.revive(p.uri)}}class g{constructor(f,u,b){this.c=f,this.d=u,this.f=b,this.a=new Map,this.b=new I.$7d}listen(f,u){switch(u){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${u}`)}async call(f,u,b){try{return await this.g(f,u,b)}catch($){throw this.f.error($),$}}async g(f,u,b){switch(u){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(b[0]));case"accept":return this.c.accept(R(b[0],this.d),j.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(S(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(b[0]),j.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(u.startsWith("manualSync/")){const $=u.substring(11),l=b[0],d=this.h(l);switch(b=b.slice(1),$){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(f){const u=this.a.get(this.j(f));if(!u)throw new Error(`Manual sync taks not found: ${f}`);return u}async i(){const f=await this.c.createManualSyncTask();return this.a.set(this.j(f.id),f),f.id}j(f){return`manualSyncTask-${f}`}}e.$7bc=g;let C=class extends A.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(f,u){super(),this.n=u,this.b="uninitialized",this.c=this.B(new I.$7d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$7d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$7d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$7d),this.onSyncErrors=this.m.event,this.a={call(b,$,l){return f.call(b,$,l).then(null,d=>{throw O.$Dpb.toUserDataSyncError(d)})},listen(b,$){return f.listen(b,$)}},this.a.call("_getInitialData").then(([b,$,l])=>{this.s(b),this.t($),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.s(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.u(d)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map($=>({...$,error:O.$Dpb.toUserDataSyncError($.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const f=await this.a.call("createManualSyncTask"),u=this;return new P(f,{async call($,l,d){return u.a.call(`manualSync/${$}`,[f,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(f,u,b,$){return this.a.call("accept",[f,u,b,$])}resolveContent(f){return this.a.call("resolveContent",[f])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(f){return this.a.call("replace",[f])}saveRemoteActivityData(f){return this.a.call("getRemoteActivityData",[f])}extractActivityData(f,u){return this.a.call("extractActivityData",[f,u])}async s(f){this.b=f,this.c.fire(f)}async t(f){this.f=f.map(u=>({syncResource:u.syncResource,profile:(0,L.$ol)(u.profile,this.n.profilesHome.scheme),conflicts:u.conflicts.map(b=>({...b,baseResource:j.URI.revive(b.baseResource),localResource:j.URI.revive(b.localResource),remoteResource:j.URI.revive(b.remoteResource),previewResource:j.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(f){this.h!==f&&(this.h=f,this.j.fire(f))}};e.$8bc=C,e.$8bc=C=ye([Q(1,L.$nl)],C);class P extends A.$Uc{constructor(f,u){super(),this.id=f,this.a=u}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,44,19,25]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hJb=e.$gJb=e.$fJb=e.$eJb=e.$dJb=void 0;const m="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$Gpb,-1)}set c(D){this.h.store(c.$Gpb,D,-1,S.$o?0:1)}constructor(D,U,F){super(),this.f=D,this.g=U,this.h=F,this.a=this.B(new L.$7d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const T=this.B(new O.$Tc);this.B(L.Event.filter(F.onDidChangeValue(-1,c.$Gpb,T),()=>this.c!==this.userDataSyncStore?.type,T)(()=>this.j()))}j(){this.b=this.m(this.f[m]),this.a.fire()}m(D){if(D&&(D=S.$o&&D.web?{...D,...D.web}:D,(0,C.$Uf)(D.url)&&(0,C.$Wf)(D.authenticationProviders)&&Object.keys(D.authenticationProviders).every(U=>Array.isArray(D.authenticationProviders[U].scopes)))){const U=D,F=!!U.canSwitch,T=U.url===U.insidersUrl?"insiders":"stable",_=(F?this.c:void 0)||T,X=_==="insiders"?U.insidersUrl:_==="stable"?U.stableUrl:U.url;return{url:P.URI.parse(X),type:_,defaultType:T,defaultUrl:P.URI.parse(U.url),stableUrl:P.URI.parse(U.stableUrl),insidersUrl:P.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((ee,H)=>(ee.push({id:H,scopes:U.authenticationProviders[H].scopes}),ee),[])}}}};e.$dJb=a,e.$dJb=a=ye([Q(0,$.$7j),Q(1,f.$Ni),Q(2,h.$Lp)],a);let v=class extends a{constructor(D,U,F){super(D,U,F);const T=this.h.get(i,-1);T&&(this.n=JSON.parse(T));const _=this.f[m];_?this.h.store(i,JSON.stringify(_),-1,1):this.h.remove(i,-1)}async switch(D){D!==this.c&&(this.c=D,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$eJb=v,e.$eJb=v=ye([Q(0,$.$7j),Q(1,f.$Ni),Q(2,h.$Lp)],v);let y=class extends O.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(D,U,F,T,_,X,ee){super(),this.n=F,this.r=T,this.s=ee,this.g=this.B(new L.$7d),this.onTokenFailed=this.g.event,this.h=this.B(new L.$7d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$7d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(D),this.c=(0,d.$Rp)(_,X,ee).then(H=>{const K={"X-Client-Name":`${U.applicationName}${S.$o?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(K["X-Client-Commit"]=U.commit),K}),this.f=new k(t,r,this.n,this.r),this.u(),this.B((0,O.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(D,U){this.b={token:D,type:U}}t(D){this.a=D?(0,g.$Ug)(D,"v1"):void 0}u(){const D=this.s.getNumber(o,-1);D&&Date.now()<D&&this.y(new Date(D))}y(D){this.j?.getTime()!==D?.getTime()&&(this.j=D,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,I.$7g)(U=>(0,I.$ih)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$Ug)(this.a,"collection").toString();D={...D},D["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:D},[],A.CancellationToken.None);return(await(0,l.$Ep)(F))?.map(({id:T})=>T)||[]}async createCollection(D={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,g.$Ug)(this.a,"collection").toString();D={...D},D["Content-Type"]=R.$xs.text;const F=await this.D(U,{type:"POST",headers:D},[],A.CancellationToken.None),T=await(0,l.$Dp)(F);if(!T)throw new c.$Epb("Server did not return the collection id",U,"NoCollection",F.res.statusCode,F.res.headers[c.$Apb]);return T}async deleteCollection(D,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=D?(0,g.$Ug)(this.a,"collection",D).toString():(0,g.$Ug)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],A.CancellationToken.None)}async getAllResourceRefs(D,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,D),T={},_=await this.D(F.toString(),{type:"GET",headers:T},[],A.CancellationToken.None);return(await(0,l.$Ep)(_)||[]).map(({url:ee,created:H})=>({ref:(0,g.$Wg)(F,F.with({path:ee})),created:H*1e3}))}async resolveResourceContent(D,U,F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,g.$Ug)(this.z(this.a,F,D),U).toString();T={...T},T["Cache-Control"]="no-cache";const X=await this.D(_,{type:"GET",headers:T},[],A.CancellationToken.None);return await(0,l.$Dp)(X)}async deleteResource(D,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const T=U!==null?(0,g.$Ug)(this.z(this.a,F,D),U).toString():this.z(this.a,F,D).toString(),_={};await this.D(T,{type:"DELETE",headers:_},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,g.$Ug)(this.a,"resource").toString(),U={"Content-Type":R.$xs.text};await this.D(D,{type:"DELETE",headers:U},[],A.CancellationToken.None)}async readResource(D,U,F,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const _=(0,g.$Ug)(this.z(this.a,F,D),"latest").toString();T={...T},T["Cache-Control"]="no-cache",U&&(T["If-None-Match"]=U.ref);const X=await this.D(_,{type:"GET",headers:T},[304],A.CancellationToken.None);let ee=null;if(X.res.statusCode===304&&(ee=U),ee===null){const H=X.res.headers.etag;if(!H)throw new c.$Epb("Server did not return the ref",_,"NoRef",X.res.statusCode,X.res.headers[c.$Apb]);const K=await(0,l.$Dp)(X);if(!K&&X.res.statusCode===304)throw new c.$Epb("Empty response",_,"EmptyResponse",X.res.statusCode,X.res.headers[c.$Apb]);ee={ref:H,content:K}}return ee}async writeResource(D,U,F,T,_={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=this.z(this.a,T,D).toString();_={..._},_["Content-Type"]=R.$xs.text,F&&(_["If-Match"]=F);const ee=await this.D(X,{type:"POST",data:U,headers:_},[],A.CancellationToken.None),H=ee.res.headers.etag;if(!H)throw new c.$Epb("Server did not return the ref",X,"NoRef",ee.res.statusCode,ee.res.headers[c.$Apb]);return H}async manifest(D,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Ug)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",D&&(U["If-None-Match"]=D.ref);const T=await this.D(F,{type:"GET",headers:U},[304],A.CancellationToken.None);let _=null;if(T.res.statusCode===304&&(_=D),!_){const ee=T.res.headers.etag;if(!ee)throw new c.$Epb("Server did not return the ref",F,"NoRef",T.res.statusCode,T.res.headers[c.$Apb]);const H=await(0,l.$Dp)(T);if(!H&&T.res.statusCode===304)throw new c.$Epb("Empty response",F,"EmptyResponse",T.res.statusCode,T.res.headers[c.$Apb]);H&&(_={...JSON.parse(H),ref:ee})}const X=this.s.get(n,-1);return X&&_&&X!==_.session&&this.C(),_===null&&X&&this.C(),_&&this.s.store(n,_.session,-1,1),_}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const D=(0,g.$Ug)(this.a,"download").toString(),U={},F=await this.D(D,{type:"GET",headers:U},[],A.CancellationToken.None);if(!(0,l.$Ap)(F))throw new c.$Epb("Server returned "+F.res.statusCode,D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$Apb]);if((0,l.$Bp)(F))throw new c.$Epb("Empty response",D,"EmptyResponse",F.res.statusCode,F.res.headers[c.$Apb]);return F.stream}z(D,U,F){return U?(0,g.$Ug)(D,"collection",U,"resource",F):(0,g.$Ug)(D,"resource",F)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(D,U,F,T){if(!this.b)throw new c.$Epb("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$Epb(`${U.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const _=await this.c;U.headers={...U.headers||{},..._,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:D,type:U.type,headers:{...U.headers,authorization:void 0}});let X;try{X=await this.f.request(D,U,T)}catch(B){if(!(B instanceof c.$Epb)){let ne="RequestFailed";const oe=(0,j.$0)(B).toLowerCase();oe.includes("xhr timeout")?ne="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?ne="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?ne="RequestPathNotEscaped":oe.includes("headers must be an object")?ne="RequestHeadersNotObject":(0,j.$4)(B)&&(ne="RequestCanceled"),B=new c.$Epb(`Connection refused for the request '${D}'.`,D,ne,void 0,void 0)}throw this.r.info("Request failed",D),B}const ee=X.res.headers[c.$Apb],H={url:D,status:X.res.statusCode,"execution-id":U.headers[c.$Bpb],"operation-id":ee},K=(0,l.$Ap)(X)||X.res.statusCode&&F.includes(X.res.statusCode);let W="";if(K?this.r.trace("Request succeeded",H):(W=await(0,l.$Cp)(X)||"",this.r.info("Request failed",H,W)),X.res.statusCode===401||X.res.statusCode===403){if(this.b=void 0,X.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$Epb(`${U.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",X.res.statusCode,ee);if(X.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$Epb(`${U.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",X.res.statusCode,ee)}if(this.h.fire(),X.res.statusCode===404)throw new c.$Epb(`${U.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",X.res.statusCode,ee);if(X.res.statusCode===405)throw new c.$Epb(`${U.type} request '${D}' failed because the requested endpoint is not found (405). ${W}`,D,"MethodNotFound",X.res.statusCode,ee);if(X.res.statusCode===409)throw new c.$Epb(`${U.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",X.res.statusCode,ee);if(X.res.statusCode===410)throw new c.$Epb(`${U.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",X.res.statusCode,ee);if(X.res.statusCode===412)throw new c.$Epb(`${U.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",X.res.statusCode,ee);if(X.res.statusCode===413)throw new c.$Epb(`${U.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",X.res.statusCode,ee);if(X.res.statusCode===426)throw new c.$Epb(`${U.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",X.res.statusCode,ee);if(X.res.statusCode===429){const B=X.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new c.$Epb(`${U.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",X.res.statusCode,ee)):new c.$Epb(`${U.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",X.res.statusCode,ee)}if(!K)throw new c.$Epb("Server returned "+X.res.statusCode,D,"Unknown",X.res.statusCode,ee);return X}F(D){let U=this.s.get(s,-1);U===void 0&&(U=(0,p.$Dg)(),this.s.store(s,U,-1,1)),D["X-Machine-Session-Id"]=U;const F=this.s.get(n,-1);F!==void 0&&(D["X-User-Session-Id"]=F)}};e.$fJb=y,e.$fJb=y=ye([Q(1,$.$7j),Q(2,l.$yp),Q(3,c.$Npb),Q(4,u.$oi),Q(5,b.$Nk),Q(6,h.$Lp)],y);let w=class extends y{constructor(D,U,F,T,_,X,ee){super(D.userDataSyncStore?.url,U,F,T,_,X,ee),this.B(D.onDidChangeUserDataSyncStore(()=>this.t(D.userDataSyncStore?.url)))}};e.$gJb=w,e.$gJb=w=ye([Q(0,c.$xpb),Q(1,$.$7j),Q(2,l.$yp),Q(3,c.$Npb),Q(4,u.$oi),Q(5,b.$Nk),Q(6,h.$Lp)],w);class k{constructor(D,U,F,T){this.c=D,this.d=U,this.f=F,this.g=T,this.a=[],this.b=void 0}request(D,U,F){if(this.h()&&this.i(),U.url=D,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$Epb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(D),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$hJb=k}),define(le[265],he([0,1,3,2,8,21,24,19,122]),function(se,e,I,A,j,L,O,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=e.$4bc=e.$3bc=void 0;class g{constructor(u){this.a=u}listen(u,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(u,b,$){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$3bc=g;class C extends A.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(u){super(),this.c=u,this.b=this.B(new I.$7d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")($=>{this.a=$,this.b.fire($)}))})}updateAccount(u){return this.c.call("updateAccount",u)}}e.$4bc=C;class P{constructor(u){this.a=u}listen(u,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(u,b,$){switch(b){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$5bc=P;let p=class extends S.$dJb{constructor(u,b,$,l){super(b,$,l),this.n=u,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(u){return this.n.call("switch",[u])}async getPreviousUserDataSyncStore(){const u=await this.n.call("getPreviousUserDataSyncStore");return this.r(u)}r(u){return{url:j.URI.revive(u.url),type:u.type,defaultUrl:j.URI.revive(u.defaultUrl),insidersUrl:j.URI.revive(u.insidersUrl),stableUrl:j.URI.revive(u.stableUrl),canSwitch:u.canSwitch,authenticationProviders:u.authenticationProviders}}};e.$6bc=p,e.$6bc=p=ye([Q(1,O.$7j),Q(2,L.$Ni),Q(3,R.$Lp)],p)}),define(le[266],he([0,1,3,57,24,19,22,261,25,80,83]),function(se,e,I,A,j,L,O,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;let P=class extends R.$N$b{constructor(f,u,b,$,l,d,h,c,m,i,o){super(f,u,b,$,l,h,c,m,i,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(d.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(d.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$pcc=P,e.$pcc=P=ye([Q(0,j.$7j),Q(1,S.$xpb),Q(2,S.$ypb),Q(3,S.$Ipb),Q(4,S.$Jpb),Q(5,A.$gac),Q(6,S.$Npb),Q(7,g.$NHb),Q(8,O.$Ml),Q(9,C.$lpb),Q(10,L.$Lp)],P)}),define(le[267],he([0,1,73,23,5,20]),function(se,e,I,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0,e.$H_b=O,e.$I_b=R,e.$J_b=S,e.$G_b=128/4;function O(g){function C(){let P=g.scheme===A.Schemas.file?(0,L.$Ig)(g):g.toString();return j.$k||(P=P.toLowerCase()),(0,I.createHash)("md5").update(P).digest("hex")}return{id:C(),configPath:g}}function R(g,C){function P(){if(g.scheme!==A.Schemas.file)return(0,I.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let f;return j.$k?f=C.ino:j.$j?f=C.birthtime.getTime():j.$i&&(typeof C.birthtimeMs=="number"?f=Math.floor(C.birthtimeMs):f=C.birthtime.getTime()),(0,I.createHash)("md5").update(g.fsPath).update(f?String(f):"").digest("hex")}const p=P();if(typeof p=="string")return{id:p,uri:g}}function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[268],he([0,1,6,7,2,15,31,16,9,77,112,267,57,56,23]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=void 0;let b=class extends j.$Uc{constructor(l,d,h,c){super(),this.a=l,this.b=d,this.c=h,this.f=c,this.B(new I.$th(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:u.Schemas.file}).fsPath,d=await O.Promises.readdir(l),h=new g.$mIb(this.f.getChannel("storage"));await Promise.all(d.map(async c=>{const m=(0,L.$kc)(l,c);c.length===P.$G_b||c===C.$ti.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await h.isUsed(m)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await O.Promises.rm(m))}))}catch(l){(0,A.$1)(l)}}};e.$Ybc=b,e.$Ybc=b=ye([Q(0,R.$pi),Q(1,S.$Nj),Q(2,p.$gac),Q(3,f.$vbc)],b)}),define(le[123],he([0,1,73,64,37,278,14,7,3,2,15,5,32,40,68]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$$h=e.$0h=e.$9h=void 0,e.$_h=n,e.$ai=s,e.$ci=a,e.$di=v;class b{traceSocketEvent(w,k){u.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,k)}constructor(w,k=""){this.f=!0,this.debugLabel=k,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,R.$1)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const k=E=>{this.traceSocketEvent("read",E),w(O.$ue.wrap(E))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(w){const k=E=>{w({type:0,hadError:E,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(w){const k=()=>{w()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,R.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,R.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.$9h=b;var $;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var l;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(l||(l={}));class d extends g.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,k){this.socket.traceSocketEvent(w,k)}constructor(w,k,E,D){super(),this.f=this.B(new S.$7d),this.g=this.B(new S.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:E?.byteLength||0,recordInflateBytes:D}),this.a=this.B(new h(this,k,E,D,this.f,(U,F)=>this.m(U,F))),this.B(this.a.onError(U=>{console.error(U),(0,R.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new u.$4h,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let k=0;for(;k<w.byteLength;)this.a.writeMessage(w.slice(k,Math.min(k+262144,w.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(w,{compressed:k,opcode:E}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let D=2;w.byteLength<126?D+=0:w.byteLength<2**16?D+=2:D+=8;const U=O.$ue.alloc(D),F=k?64:0,T=E&15;if(U.writeUInt8(128|F|T,0),w.byteLength<126)U.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){U.writeUInt8(126,1);let _=1;U.writeUInt8(w.byteLength>>>8&255,++_),U.writeUInt8(w.byteLength>>>0&255,++_)}else{U.writeUInt8(127,1);let _=1;U.writeUInt8(0,++_),U.writeUInt8(0,++_),U.writeUInt8(0,++_),U.writeUInt8(0,++_),U.writeUInt8(w.byteLength>>>24&255,++_),U.writeUInt8(w.byteLength>>>16&255,++_),U.writeUInt8(w.byteLength>>>8&255,++_),U.writeUInt8(w.byteLength>>>0&255,++_)}this.socket.write(O.$ue.concat([U,w]))}end(){this.h=!0,this.socket.end()}n(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),E=k.readUInt8(0),D=(E&128)>>>7,U=(E&64)>>>6,F=E&15,T=k.readUInt8(1),_=(T&128)>>>7,X=T&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(X===126?2:0)+(X===127?8:0),this.j.fin=D,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!D,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),E=k.readUInt8(1),D=(E&128)>>>7;let U=E&127,F=1;U===126?U=k.readUInt8(++F)*2**8+k.readUInt8(++F):U===127&&(U=k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F));let T=0;D&&(T=k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F)),this.j.state=3,this.j.readLen=U,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),i(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$0h=d;class h extends g.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$ue.alloc(0)}constructor(w,k,E,D,U,F){super(),this.n=w,this.r=U,this.s=F,this.a=this.B(new S.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new S.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new c(this.n,D,E,{windowBits:15})),this.f=this.B(new m(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(w,k){this.g.push({data:w,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:w,options:k}=this.g.shift();if(this.f&&k.compressed){const E=await this.w(this.f,w);this.s(E,k)}else this.s(w,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(w,k){return new Promise((E,D)=>{w.write(k),w.flush(U=>E(U))})}acceptFrame(w,k,E){this.h.push({data:w,isCompressed:k,isLastFrameOfMessage:E}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const k=await this.C(this.b,w.data,w.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(w.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(w,k,E){return new Promise((D,U)=>{w.write(k),E&&w.write(O.$ue.fromByteArray([0,0,255,255])),w.flush(F=>D(F))})}}class c extends g.$Uc{get recordedInflateBytes(){return this.j?O.$ue.concat(this.f):O.$ue.alloc(0)}constructor(w,k,E,D){super(),this.h=w,this.j=k,this.a=this.B(new S.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(D),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(O.$ue.wrap(U))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent("zlibInflateWrite",w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=O.$ue.concat(this.g);this.g.length=0,w(k)})}}class m extends g.$Uc{constructor(w,k){super(),this.g=w,this.a=this.B(new S.$7d),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(O.$ue.wrap(E))})}write(w){this.g.traceSocketEvent("zlibDeflateWrite",w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=O.$ue.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),w(k)})}}function i(y,w){if(w===0)return;const k=y.byteLength>>>2;for(let _=0;_<k;_++){const X=y.readUInt32BE(_*4);y.writeUInt32BE(X^w,_*4)}const E=k*4,D=y.byteLength-E,U=w>>>24&255,F=w>>>16&255,T=w>>>8&255;D>=1&&y.writeUInt8(y.readUInt8(E)^U,E),D>=2&&y.writeUInt8(y.readUInt8(E+1)^F,E+1),D>=3&&y.writeUInt8(y.readUInt8(E+2)^T,E+2)}e.$$h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const y=(0,p.$Dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const w=process.platform!=="darwin"&&e.$$h?e.$$h:(0,j.tmpdir)(),k=(0,C.$kc)(w,`vscode-ipc-${y}.sock`);return t(k),k}function s(y,w,k){const D=(0,I.createHash)("sha256").update(y).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${k}-${w}-sock`;const U=k.substr(0,4),F=w.substr(0,6);let T;return process.platform!=="darwin"&&e.$$h&&!process.env.VSCODE_PORTABLE?T=(0,C.$kc)(e.$$h,`vscode-${D}-${U}-${F}.sock`):T=(0,C.$kc)(y,`${U}-${F}.sock`),t(T),T}function t(y){const w=o[P.$u];typeof w=="number"&&y.length>=w&&console.warn(`WARNING: IPC handle "${y}" is longer than ${w} chars, try a shorter --user-data-dir`)}class r extends f.$Xh{static b(w){const k=S.Event.fromNodeEventEmitter(w,"connection");return S.Event.map(k,E=>({protocol:new u.$5h(new b(E,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(E,"close"))}))}constructor(w){super(r.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$bi=r;function a(y){return new Promise((w,k)=>{const E=(0,A.createServer)();E.on("error",k),E.listen(y,()=>{E.removeListener("error",k),w(new r(E))})})}function v(y,w){return new Promise((k,E)=>{const D=(0,A.createConnection)(y,()=>{D.removeListener("error",E),k(u.$6h.fromSocket(new b(D,`ipc-client${w}`),w))});D.once("error",E)})}}),define(le[269],he([0,1,64,123,216]),function(se,e,I,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0,e.$scc=new class{supports(L){return!0}connect({host:L,port:O},R,S,g){return new Promise((C,P)=>{const p=I.createConnection({host:L,port:O},()=>{p.removeListener("error",P),p.write((0,j.$Rtb)(R,S,g));const f=u=>{u.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",f),C(new A.$9h(p,g)))};p.on("data",f)});p.setNoDelay(!0),p.once("error",P)})}}}),define(le[270],he([0,1,64,37,133,123,6,2,5,21,9,24,218,104,106,78,14]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=e.$nbc=e.$mbc=void 0;async function l(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new d(i,o,n,s,t).waitForReady(),!(t&&j.$Gg[t]||!j.$Gg[r.tunnelLocalPort]));a--);return r}class d extends R.$Uc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=I.createServer(),this.c=new O.$gh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$3v)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,j.$Hg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$1v)(this.tunnelRemoteHost)||(0,b.$3v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,p.$Dl)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof L.$9h?t.socket.destroy():t.end()}),t instanceof L.$9h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write($.$ue.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$mbc=d;let h=class extends b.$6v{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$4v)(o,this.m,S.OS,A.release())}t(o,n,s,t,r,a,v,y){const w=this.s(n,s);if(w)return++w.refcount,w.value;if((0,b.$Wv)(o))return this.u(o,n,s,r,a,v,y);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},E=l(k,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,E),E}}};e.$nbc=h,e.$nbc=h=ye([Q(0,f.$xl),Q(1,C.$Nj),Q(2,u.$Al),Q(3,P.$7j),Q(4,g.$Ni)],h);let c=class extends h{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$obc=c,e.$obc=c=ye([Q(0,f.$xl),Q(1,C.$Nj),Q(2,u.$Al),Q(3,P.$7j),Q(4,g.$Ni)],c);let m=class extends R.$Uc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,v,y,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const k=new c(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(o,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,v,y,w)}};e.$pbc=m,e.$pbc=m=ye([Q(0,f.$xl),Q(1,C.$Nj),Q(2,P.$7j),Q(3,u.$Al),Q(4,g.$Ni)],m)}),define(le[279],he([0,1,37,38,7,2,23,8,17,3,40,149,210,211,201,202,268,192,194,21,215,94,226,95,221,16,114,252,29,98,193,113,96,12,204,205,72,4,200,74,75,232,9,206,101,24,59,19,107,22,108,109,110,47,235,82,111,25,80,260,265,245,83,259,263,264,122,60,258,246,106,225,78,270,220,236,28,237,5,238,195,213,212,81,251,18,52,209,58,257,234,247,105,262,253,10,207,100,255,250,222,188,57,208,266,254,56,256,104,269,185,223,145,140]),function(se,e,I,A,j,L,O,R,S,g,C,P,p,f,u,b,$,l,d,h,c,m,i,o,n,s,t,r,a,v,y,w,k,E,D,U,F,T,_,X,ee,H,K,W,B,ne,oe,te,ce,G,q,N,M,z,Z,J,x,Y,V,ie,re,ue,de,me,Ee,ke,Ie,Ae,fe,$e,we,Ce,Re,Me,De,ze,Ue,Te,qe,je,ae,ge,be,pe,ve,Pe,Oe,Le,Ve,Be,Fe,Ke,Ge,_e,tt,Et,St,gt,kt,Pt,Ct,Rt,It,Ot,Dt,Nt,$t,jt,mt,Lt,At,st,Ut,Mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class Ft extends L.$Uc{constructor(Se){super(),this.f=Se,this.a=this.B(new P.$_V(this)),this.b=void 0,this.c=this.B(new g.$7d),this.g()}g(){let Se=!1;const Ne=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,P.$aW)(process.parentPort,st.$Bac.exit,Ne)}async init(){const Se=await this.h();(0,Y.$spb)(),Se.invokeFunction(Ne=>{const He=Ne.get(K.$Nj),We=Ne.get(G.$Ml),Ze=Ne.get(Pe.$nl);He.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ne),this.m(He),this.n(We,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(We,Ze))),this.r(We,He)}),this.B((0,L.$Rc)(Se.createInstance(p.$Ubc,this.f.codeCachePath),Se.createInstance(f.$Vbc),Se.createInstance($.$Ybc),Se.createInstance(b.$Xbc),Se.createInstance(u.$Wbc),Se.createInstance(tt.$jcc),Se.createInstance(Ke.$bcc)))}async h(){const Se=new X.$fi,Ne={_serviceBrand:void 0,...B.default};Se.set(ne.$7j,Ne);const He=new C.$2h(Je=>Je==="main"),We=new $t.$wbc(this.a,He);Se.set($t.$vbc,We);const Ze=this.f.policiesData?new Le.$5ac(this.f.policiesData,We.getChannel("policy")):new Ve.$4n;Se.set(Ve.$2n,Ze);const Qe=new At.$Tm(this.f.args,Ne);Se.set(s.$pi,Qe);const et=new W.$Sr(void 0,this.f.logLevel,Qe.logsHome,this.f.loggers.map(Je=>({...Je,resource:R.URI.revive(Je.resource)})),We.getChannel("logger"));Se.set(K.$Oj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new K.$Vj(ot.getLevel())),Xe=this.B(new St.$YP(ot,[ht]));Se.set(K.$Nj,Xe),this.b=this.B(new gt.$lcc(Xe)),Se.set(gt.$kcc,this.b);const Ye=this.B(new D.$tq(Xe));Se.set(E.$Nk,Ye);const ut=this.B(new U.$Tq(Xe));Ye.registerProvider(O.Schemas.file,ut);const at=new Te.$hs(Ye);Se.set(Ue.$ll,at);const xe=this.B(new Be.$6P(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Qe.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Se.set(Pe.$nl,xe);const ft=this.B(new je.$ubc(O.Schemas.file,this.B(new ae.$HP(We.getChannel(ae.$GP),{pathCaseSensitive:qe.$k})),O.Schemas.vscodeUserData,xe,at,Xe));Ye.registerProvider(O.Schemas.vscodeUserData,ft);const it=this.B(new c.$ro(xe.defaultProfile.settingsResource,Ye,Ze,Xe));Se.set(h.$Ni,it);const dt=new jt.$rcc(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},We,Qe);Se.set(te.$Lp,dt),this.B((0,L.$Sc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const wt=new Ct.$Dr(We.getChannel("request"));Se.set(oe.$yp,wt),Se.set(l.$Zbc,new F.$ei(d.$1bc,void 0,!1)),Se.set(be.$LF,new F.$ei(ge.$acc,void 0,!1));const bt=new Ot.$Bbc(-1,We);Se.set(It.$gac,bt),Se.set(o.$vo,new F.$ei(n.$bQ,void 0,!0));const qt=this.B(new $e.$2ac(bt)),zt=new C.$2h(Je=>qt.getActiveClientId().then(lt=>Je===lt));Se.set(k.$m2b,new Rt.$ncc(this.a.getChannel("extensionRecommendationNotification",zt)));let ct;const nt=[],yt=(0,z.$cp)(Ne,it);if((0,z.$0o)(Ne,Qe)){const Je=new N.$50b(Xe,et,Qe,Ne);if(nt.push(Je),!(0,z.$$o)(Ne,Qe)&&Ne.aiConfig?.ariaKey){const lt=new Fe.$MP(wt,yt,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,L.$Sc)(()=>lt.flush())),nt.push(lt)}ct=new M.$Hr({appenders:nt,commonProperties:(0,ce.$1o)((0,I.release)(),(0,I.hostname)(),process.arch,Ne.commit,Ne.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,z.$dp)(Qe)},it,Ne)}else{ct=z.$5o;const Je=z.$9o;nt.push(Je)}this.a.registerChannel("telemetryAppender",new q.$Gac(nt)),Se.set(G.$Ml,ct);const Bt=new Z.$2bc(it,ct,Xe,et,Qe,Ne);Se.set(G.$Nl,Bt),Se.set(Oe.$aq,new F.$ei(Pt.$XP,void 0,!0)),Se.set(pe.$eq,new F.$ei(ve.$6ac,void 0,!0)),Se.set(v.$Wp,new F.$ei(v.$Xp,void 0,!0)),Se.set(w.$oq,new F.$ei(w.$pq,void 0,!0)),Se.set(a.$Qo,new F.$ei(r.$Up,void 0,!0)),Se.set(a.$Xo,new F.$ei(Nt.$qcc,void 0,!1)),Se.set(ee.$zr,new F.$ei(H.$Br,void 0,!1)),Se.set(m.$1m,new F.$ei(i.$os,void 0,!1)),Se.set(V.$NHb,new F.$ei(V.$OHb,void 0,!0)),Se.set(Y.$Npb,new F.$ei(ue.$$Jb,void 0,!0)),Se.set(Y.$Mpb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),Se.set(a.$Wo,new F.$ei(t.$LHb,void 0,!1)),Se.set(x.$9Jb,new F.$ei(x.$0Jb,void 0,!0)),Se.set(J.$Gv,new F.$ei(J.$Hv)),Se.set(Y.$xpb,new F.$ei(Ie.$eJb,void 0,!0)),Se.set(Y.$ypb,new F.$ei(Ie.$gJb,void 0,!0)),Se.set(de.$lpb,new F.$ei(de.$npb,void 0,!0)),Se.set(Y.$zpb,new F.$ei(ie.$H$b,void 0,!1)),Se.set(Y.$Ipb,new F.$ei(me.$w$b,void 0,!0)),Se.set(Y.$Jpb,new F.$ei(Ee.$M$b,void 0,!1)),Se.set(Ae.$nIb,new F.$ei(fe.$9bc,void 0,!0)),Se.set(Y.$Kpb,new F.$ei(_e.$j_b,void 0,!0)),Se.set(we.$Al,new F.$ei(Ce.$rbc,void 0,!1));const vt=new mt.$yl;return Se.set(mt.$xl,vt),vt.register(0,Lt.$scc),Se.set(Re.$Vv,new F.$ei(Me.$pbc)),Se.set(De.$0bc,new F.$ei(ze.$_bc)),Se.set(Ge.$ccc,new F.$ei(kt.$mcc)),new _.$Wq(Se)}j(Se){const Ne=new y.$Zp(Se.get(a.$To),()=>null);this.a.registerChannel("extensions",Ne);const He=C.ProxyChannel.fromService(Se.get(ee.$zr),this.q);this.a.registerChannel("languagePacks",He);const We=C.ProxyChannel.fromService(Se.get(m.$1m),this.q);this.a.registerChannel("diagnostics",We);const Ze=new y.$2p(Se.get(a.$Xo));this.a.registerChannel("extensionTipsService",Ze);const Qe=C.ProxyChannel.fromService(Se.get(l.$Zbc),this.q);this.a.registerChannel("checksum",Qe);const et=C.ProxyChannel.fromService(Se.get(be.$LF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(Se.get(de.$lpb),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(Se.get(G.$Nl),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Xe=new re.$3bc(Se.get(V.$NHb));this.a.registerChannel("userDataSyncAccount",Xe);const Ye=new re.$5bc(Se.get(Y.$xpb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new ke.$7bc(Se.get(Y.$Jpb),Se.get(Pe.$nl),Se.get(K.$Nj));this.a.registerChannel("userDataSync",ut);const at=this.B(Se.get(T.$gi).createInstance(Dt.$pcc));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(Y.$Kpb),this.q));const xe=C.ProxyChannel.fromService(Se.get(De.$0bc),this.q);this.a.registerChannel(De.$$bc,xe);const ft=C.ProxyChannel.fromService(Se.get(Ge.$ccc),this.q);this.a.registerChannel("remoteTunnel",ft)}m(Se){process.on("uncaughtException",Ne=>(0,j.$1)(Ne)),process.on("unhandledRejection",Ne=>(0,j.$1)(Ne)),(0,j.setUnexpectedErrorHandler)(Ne=>{const He=(0,A.$5i)(Ne,!0);He&&Se.error(`[uncaught exception in sharedProcess]: ${He}`)})}n(Se,Ne){Se.publicLog2("profilesInfo",{count:Ne.profiles.length})}async r(Se,Ne){if(qe.$k){const He=await(0,Ut.$Eg)(Ne.error.bind(Ne)),We=(0,Mt.$BV)();He&&Se.publicLog2("clientPlatformInfo",{platformId:He.id,platformVersionId:He.version_id,platformIdLike:He.id_like,desktopEnvironment:We})}}handledClientConnection(Se){if(Se.data!==st.$Dac.response)return!1;const Ne=(0,S.$Ob)(Se.ports);return Ne?(this.c.fire(Ne),!0):!1}}async function pt(rt){try{const Se=new Ft(rt);process.parentPort.postMessage(st.$Bac.ipcReady),await Se.init(),process.parentPort.postMessage(st.$Bac.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}const Tt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout(Tt),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c3cc8b9948d52f04836997a7de01dbd9bb2a7bf/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
