/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/baseWatcher","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(de){for(var e=[],u=0,N=de.length;u<N;u++)e[u]=ke[de[u]];return e};define(ke[161],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const M=new Map,P=new Map,A=new Map,b=new Map;function $(S,k){S.has(k.detail)||S.set(k.detail,-k.timestamp)}function E(S,k){const c=S.get(k.detail);c&&(c>=0||S.set(k.detail,c+k.timestamp))}let R=[];typeof de=="function"&&typeof de.getStats=="function"&&(R=de.getStats().slice(0).sort((S,k)=>S.timestamp-k.timestamp));for(const S of R)switch(S.type){case 10:$(M,S);break;case 11:case 12:E(M,S);break;case 21:$(P,S);break;case 22:E(P,S);break;case 33:$(A,S);break;case 34:E(A,S);break;case 31:$(b,S);break;case 32:E(b,S);break}let I=0;A.forEach(S=>I+=S);function w(S){const k=[];return S.forEach((c,m)=>k.push([m,c])),k}return{amdLoad:w(M),amdInvoke:w(P),nodeRequire:w(A),nodeEval:w(b),nodeRequireTotal:I}}static toMarkdownTable(M,P){let A="";const b=[];return M.forEach(($,E)=>{b[E]=$.length}),P.forEach($=>{$.forEach((E,R)=>{typeof E>"u"&&(E=$[R]="-");const I=E.toString().length;b[R]=Math.max(I,b[R])})}),M.forEach(($,E)=>{A+=`| ${$+" ".repeat(b[E]-$.toString().length)} `}),A+=`|
`,M.forEach(($,E)=>{A+=`| ${"-".repeat(b[E])} `}),A+=`|
`,P.forEach($=>{$.forEach((E,R)=>{typeof E<"u"&&(A+=`| ${E+" ".repeat(b[R]-E.toString().length)} `)}),A+=`|
`}),A}}e.$U=u}),define(ke[162],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=N,e.$hb=M,e.$ib=P,e.$jb=A,e.$kb=b,e.$lb=$,e.$nb=R,e.$ob=I,e.$pb=w,e.$qb=S,e.$rb=k;function u(c,m,a){const n=N(c,m);if(n!==-1)return c[n]}function N(c,m,a=c.length-1){for(let n=a;n>=0;n--){const i=c[n];if(m(i))return n}return-1}function M(c,m){const a=P(c,m);return a===-1?void 0:c[a]}function P(c,m,a=0,n=c.length){let i=a,s=n;for(;i<s;){const o=Math.floor((i+s)/2);m(c[o])?i=o+1:s=o}return i-1}function A(c,m){const a=b(c,m);return a===c.length?void 0:c[a]}function b(c,m,a=0,n=c.length){let i=a,s=n;for(;i<s;){const o=Math.floor((i+s)/2);m(c[o])?s=o:i=o+1}return i}function $(c,m,a=0,n=c.length){const i=b(c,m,a,n);return i===c.length?-1:i}class E{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const a=P(this.e,m,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=E;function R(c,m){if(c.length===0)return;let a=c[0];for(let n=1;n<c.length;n++){const i=c[n];m(i,a)>0&&(a=i)}return a}function I(c,m){if(c.length===0)return;let a=c[0];for(let n=1;n<c.length;n++){const i=c[n];m(i,a)>=0&&(a=i)}return a}function w(c,m){return R(c,(a,n)=>-m(a,n))}function S(c,m){if(c.length===0)return-1;let a=0;for(let n=1;n<c.length;n++){const i=c[n];m(i,c[a])>0&&(a=n)}return a}function k(c,m){for(const a of c){const n=m(a);if(n!==void 0)return n}}}),define(ke[72],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=N,e.$M=M,e.$N=P;function u(A,b){const $=Object.create(null);for(const E of A){const R=b(E);let I=$[R];I||(I=$[R]=[]),I.push(E)}return $}function N(A,b){const $=[],E=[];for(const R of A)b.has(R)||$.push(R);for(const R of b)A.has(R)||E.push(R);return{removed:$,added:E}}function M(A,b){const $=[],E=[];for(const[R,I]of A)b.has(R)||$.push(I);for(const[R,I]of b)A.has(R)||E.push(I);return{removed:$,added:E}}function P(A,b){const $=new Set;for(const E of b)A.has(E)&&$.add(E);return $}}),define(ke[54],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=N,e.$Mh=M,e.$Nh=P;function u(A){return(b,$,E)=>{let R=null,I=null;if(typeof E.value=="function"?(R="value",I=E.value):typeof E.get=="function"&&(R="get",I=E.get),!I)throw new Error("not supported");E[R]=A(I,$)}}function N(A,b,$){let E=null,R=null;if(typeof $.value=="function"?(E="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(E="get",R=$.get),!R)throw new Error("not supported");const I=`$memoize$${b}`;$[E]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[I]}}function M(A,b,$){return u((E,R)=>{const I=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...S){this[w]||(this[w]=$?$():void 0),clearTimeout(this[I]),b&&(this[w]=b(this[w],...S),S=[this[w]]),this[I]=setTimeout(()=>{E.apply(this,S),this[w]=$?$():void 0},A)}})}function P(A,b,$){return u((E,R)=>{const I=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,k=`$throttle$pending$${R}`;return function(...c){if(this[w]||(this[w]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[w]=b(this[w],...c)),this[k])return;const m=this[S]+A;m<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[w]]),this[w]=$?$():void 0):(this[k]=!0,this[I]=setTimeout(()=>{this[k]=!1,this[S]=Date.now(),E.apply(this,[this[w]]),this[w]=$?$():void 0},m-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=M,e.$1=P,e.$2=A,e.$3=b,e.$4=E,e.$6=I,e.$7=w,e.$8=S,e.$0=c;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(d=>{d(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function N(o){e.$X.setUnexpectedErrorHandler(o)}function M(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function P(o){E(o)||e.$X.onUnexpectedError(o)}function A(o){E(o)||e.$X.onUnexpectedExternalError(o)}function b(o){if(o instanceof Error){const{name:t,message:d}=o,h=o.stacktrace||o.stack;return{$isError:!0,name:t,message:d,stack:h,noTelemetry:i.isErrorNoTelemetry(o)}}return o}const $="Canceled";function E(o){return o instanceof R?!0:o instanceof Error&&o.name===$&&o.message===$}class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function I(){const o=new Error($);return o.name=o.message,o}function w(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function S(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function c(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const d=new i;return d.message=t.message,d.stack=t.stack,d}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class s extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$cb=s}),define(ke[19],Ee([1,0,13,162]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=M,e.$tb=P,e.$ub=A,e.$vb=b,e.$wb=$,e.$xb=E,e.$yb=R,e.$zb=I,e.$Ab=w,e.$Bb=S,e.$Cb=k,e.$Db=c,e.$Eb=m,e.top=a,e.$Gb=n,e.$Hb=s,e.$Ib=o,e.$Jb=t,e.$Kb=d,e.$Lb=h,e.$Mb=l,e.$Nb=r,e.$Ob=g,e.$Pb=f,e.$Qb=D,e.$Rb=p,e.$Sb=v,e.$Tb=y,e.$Ub=C,e.$Vb=O,e.$Wb=z,e.$Xb=T,e.$Yb=B,e.$Zb=j,e.$1b=F,e.$2b=L,e.$3b=G,e.$4b=te,e.$5b=Z,e.$6b=x,e.$7b=X,e.$8b=$e,e.$$b=U;function M(le,ae=0){return le[le.length-(1+ae)]}function P(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}function A(le,ae,ce=(H,Q)=>H===Q){if(le===ae)return!0;if(!le||!ae||le.length!==ae.length)return!1;for(let H=0,Q=le.length;H<Q;H++)if(!ce(le[H],ae[H]))return!1;return!0}function b(le,ae){const ce=le.length-1;ae<ce&&(le[ae]=le[ce]),le.pop()}function $(le,ae,ce){return E(le.length,H=>ce(le[H],ae))}function E(le,ae){let ce=0,H=le-1;for(;ce<=H;){const Q=(ce+H)/2|0,he=ae(Q);if(he<0)ce=Q+1;else if(he>0)H=Q-1;else return Q}return-(ce+1)}function R(le,ae,ce){if(le=le|0,le>=ae.length)throw new TypeError("invalid index");const H=ae[Math.floor(ae.length*Math.random())],Q=[],he=[],fe=[];for(const Pe of ae){const be=ce(Pe,H);be<0?Q.push(Pe):be>0?he.push(Pe):fe.push(Pe)}return le<Q.length?R(le,Q,ce):le<Q.length+fe.length?fe[0]:R(le-(Q.length+fe.length),he,ce)}function I(le,ae){const ce=[];let H;for(const Q of le.slice(0).sort(ae))!H||ae(H[0],Q)!==0?(H=[Q],ce.push(H)):H.push(Q);return ce}function*w(le,ae){let ce,H;for(const Q of le)H!==void 0&&ae(H,Q)?ce.push(Q):(ce&&(yield ce),ce=[Q]),H=Q;ce&&(yield ce)}function S(le,ae){for(let ce=0;ce<=le.length;ce++)ae(ce===0?void 0:le[ce-1],ce===le.length?void 0:le[ce])}function k(le,ae){for(let ce=0;ce<le.length;ce++)ae(ce===0?void 0:le[ce-1],le[ce],ce+1===le.length?void 0:le[ce+1])}function c(le,ae,ce){const H=[];function Q(Pe,be,Ae){if(be===0&&Ae.length===0)return;const Ne=H[H.length-1];Ne&&Ne.start+Ne.deleteCount===Pe?(Ne.deleteCount+=be,Ne.toInsert.push(...Ae)):H.push({start:Pe,deleteCount:be,toInsert:Ae})}let he=0,fe=0;for(;;){if(he===le.length){Q(he,0,ae.slice(fe));break}if(fe===ae.length){Q(he,le.length-he,[]);break}const Pe=le[he],be=ae[fe],Ae=ce(Pe,be);Ae===0?(he+=1,fe+=1):Ae<0?(Q(he,1,[]),he+=1):Ae>0&&(Q(he,0,[be]),fe+=1)}return H}function m(le,ae,ce){const H=c(le,ae,ce),Q=[],he=[];for(const fe of H)Q.push(...le.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:Q,added:he}}function a(le,ae,ce){if(ce===0)return[];const H=le.slice(0,ce).sort(ae);return i(le,ae,H,ce,le.length),H}function n(le,ae,ce,H,Q){return ce===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const Pe=le.length,be=le.slice(0,ce).sort(ae);for(let Ae=ce,Ne=Math.min(ce+H,Pe);Ae<Pe;Ae=Ne,Ne=Math.min(Ne+H,Pe)){if(Ae>ce&&await new Promise(Be=>setTimeout(Be)),Q&&Q.isCancellationRequested)throw new u.$5;i(le,ae,be,Ae,Ne)}return be})().then(he,fe)})}function i(le,ae,ce,H,Q){for(const he=ce.length;H<Q;H++){const fe=le[H];if(ae(fe,ce[he-1])<0){ce.pop();const Pe=(0,N.$kb)(ce,be=>ae(fe,be)<0);ce.splice(Pe,0,fe)}}}function s(le){return le.filter(ae=>!!ae)}function o(le){let ae=0;for(let ce=0;ce<le.length;ce++)le[ce]&&(le[ae]=le[ce],ae+=1);le.length=ae}function t(le,ae,ce){le.splice(ce,0,le.splice(ae,1)[0])}function d(le){return!Array.isArray(le)||le.length===0}function h(le){return Array.isArray(le)&&le.length>0}function l(le,ae=ce=>ce){const ce=new Set;return le.filter(H=>{const Q=ae(H);return ce.has(Q)?!1:(ce.add(Q),!0)})}function r(le){const ae=new Set;return ce=>{const H=le(ce);return ae.has(H)?!1:(ae.add(H),!0)}}function g(le,ae){return le.length>0?le[0]:ae}function f(le,ae){return le.length>0?le[le.length-1]:ae}function D(le,ae,ce=(H,Q)=>H===Q){let H=0;for(let Q=0,he=Math.min(le.length,ae.length);Q<he&&ce(le[Q],ae[Q]);Q++)H++;return H}function p(le){return[].concat(...le)}function v(le,ae){let ce=typeof ae=="number"?le:0;typeof ae=="number"?ce=le:(ce=0,ae=le);const H=[];if(ce<=ae)for(let Q=ce;Q<ae;Q++)H.push(Q);else for(let Q=ce;Q>ae;Q--)H.push(Q);return H}function y(le,ae,ce){return le.reduce((H,Q)=>(H[ae(Q)]=ce?ce(Q):Q,H),Object.create(null))}function C(le,ae){return le.push(ae),()=>O(le,ae)}function O(le,ae){const ce=le.indexOf(ae);if(ce>-1)return le.splice(ce,1),ae}function z(le,ae,ce){const H=le.slice(0,ae),Q=le.slice(ae);return H.concat(ce,Q)}function T(le,ae){let ce;if(typeof ae=="number"){let H=ae;ce=()=>{const Q=Math.sin(H++)*179426549;return Q-Math.floor(Q)}}else ce=Math.random;for(let H=le.length-1;H>0;H-=1){const Q=Math.floor(ce()*(H+1)),he=le[H];le[H]=le[Q],le[Q]=he}}function B(le,ae){const ce=le.indexOf(ae);ce>-1&&(le.splice(ce,1),le.unshift(ae))}function j(le,ae){const ce=le.indexOf(ae);ce>-1&&(le.splice(ce,1),le.push(ae))}function F(le,ae){for(const ce of ae)le.push(ce)}function L(le,ae){return Array.isArray(le)?le.map(ae):ae(le)}function G(le){return Array.isArray(le)?le:[le]}function te(le){return le[Math.floor(Math.random()*le.length)]}function Z(le,ae,ce){const H=_(le,ae),Q=le.length,he=ce.length;le.length=Q+he;for(let fe=Q-1;fe>=H;fe--)le[fe+he]=le[fe];for(let fe=0;fe<he;fe++)le[fe+H]=ce[fe]}function x(le,ae,ce,H){const Q=_(le,ae);let he=le.splice(Q,ce);return he===void 0&&(he=[]),Z(le,Q,H),he}function _(le,ae){return ae<0?Math.max(ae+le.length,0):Math.min(ae,le.length)}var ue;(function(le){function ae(he){return he<0}le.isLessThan=ae;function ce(he){return he<=0}le.isLessThanOrEqual=ce;function H(he){return he>0}le.isGreaterThan=H;function Q(he){return he===0}le.isNeitherLessOrGreaterThan=Q,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ue||(e.CompareResult=ue={}));function X(le,ae){return(ce,H)=>ae(le(ce),le(H))}function $e(...le){return(ae,ce)=>{for(const H of le){const Q=H(ae,ce);if(!ue.isNeitherLessOrGreaterThan(Q))return Q}return ue.neitherLessOrGreaterThan}}const se=(le,ae)=>le-ae;e.$9b=se;const re=(le,ae)=>(0,e.$9b)(le?1:0,ae?1:0);e.$0b=re;function U(le){return(ae,ce)=>-le(ae,ce)}class ie{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let ce=this.c;for(;ce<this.g.length&&ae(this.g[ce]);)ce++;const H=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,H}takeFromEndWhile(ae){let ce=this.d;for(;ce>=0&&ae(this.g[ce]);)ce--;const H=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const ce=this.g.slice(this.c,this.c+ae);return this.c+=ae,ce}}e.$_b=ie;class ve{static{this.empty=new ve(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(ce=>(ae(ce),!0))}toArray(){const ae=[];return this.iterate(ce=>(ae.push(ce),!0)),ae}filter(ae){return new ve(ce=>this.iterate(H=>ae(H)?ce(H):!0))}map(ae){return new ve(ce=>this.iterate(H=>ce(ae(H))))}some(ae){let ce=!1;return this.iterate(H=>(ce=ae(H),!ce)),ce}findFirst(ae){let ce;return this.iterate(H=>ae(H)?(ce=H,!1):!0),ce}findLast(ae){let ce;return this.iterate(H=>(ae(H)&&(ce=H),!0)),ce}findLastMaxBy(ae){let ce,H=!0;return this.iterate(Q=>((H||ue.isGreaterThan(ae(Q,ce)))&&(H=!1,ce=Q),!0)),ce}}e.$ac=ve;class Ie{constructor(ae){this.c=ae}static createSortPermutation(ae,ce){const H=Array.from(ae.keys()).sort((Q,he)=>ce(ae[Q],ae[he]));return new Ie(H)}apply(ae){return ae.map((ce,H)=>ae[this.c[H]])}inverse(){const ae=this.c.slice();for(let ce=0;ce<this.c.length;ce++)ae[this.c[ce]]=ce;return new Ie(ae)}}e.$bc=Ie}),define(ke[61],Ee([1,0,13]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$0c=M,e.$$c=P,e.$_c=A,e.$ad=b,e.$bd=$;function N(E,R){if(!E)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function M(E,R="Unreachable"){throw new Error(R)}function P(E){if(!E)throw new u.$cb("Assertion Failed")}function A(E){E||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function $(E,R){let I=0;for(;I<E.length-1;){const w=E[I],S=E[I+1];if(!R(w,S))return!1;I++}return!0}}),define(ke[73],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(N,M){const P=this;let A=!1,b;return function(){if(A)return b;if(A=!0,M)try{b=N.apply(P,arguments)}finally{M()}else b=N.apply(P,arguments);return b}}}),define(ke[124],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0;class u{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$FO=u,e.$GO=new u("id#")}),define(ke[43],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(N){function M(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=M;const P=Object.freeze([]);function A(){return P}N.empty=A;function*b(t){yield t}N.single=b;function $(t){return M(t)?t:b(t)}N.wrap=$;function E(t){return t||P}N.from=E;function*R(t){for(let d=t.length-1;d>=0;d--)yield t[d]}N.reverse=R;function I(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=I;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function S(t,d){for(const h of t)if(d(h))return!0;return!1}N.some=S;function k(t,d){for(const h of t)if(d(h))return h}N.find=k;function*c(t,d){for(const h of t)d(h)&&(yield h)}N.filter=c;function*m(t,d){let h=0;for(const l of t)yield d(l,h++)}N.map=m;function*a(...t){for(const d of t)yield*d}N.concat=a;function n(t,d,h){let l=h;for(const r of t)l=d(l,r);return l}N.reduce=n;function*i(t,d,h=t.length){for(d<0&&(d+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);d<h;d++)yield t[d]}N.slice=i;function s(t,d=Number.POSITIVE_INFINITY){const h=[];if(d===0)return[h,t];const l=t[Symbol.iterator]();for(let r=0;r<d;r++){const g=l.next();if(g.done)return[h,N.empty()];h.push(g.value)}return[h,{[Symbol.iterator](){return l}}]}N.consume=s;async function o(t){const d=[];for await(const h of t)d.push(h);return Promise.resolve(d)}N.asyncToArray=o})(u||(e.Iterable=u={}))}),define(ke[163],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=A,e.$tn=I,e.$un=w,e.$vn=S,e.$wn=k,e.$xn=c,e.$yn=m,e.$zn=a,e.$An=n,e.$Bn=i,e.$Cn=s,e.$Dn=o;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,d=!1){let h=0;const l=t.length;let r="",g=0,f=16,D=0;function p(B){let j=0,F=0;for(;j<B;){const L=t.charCodeAt(h);if(L>=48&&L<=57)F=F*16+L-48;else if(L>=65&&L<=70)F=F*16+L-65+10;else if(L>=97&&L<=102)F=F*16+L-97+10;else break;h++,j++}return j<B&&(F=-1),F}function v(B){h=B,r="",g=0,f=16,D=0}function y(){const B=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&E(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&E(t.charCodeAt(h)))for(h++;h<t.length&&E(t.charCodeAt(h));)h++;else return D=3,t.substring(B,h);let j=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&E(t.charCodeAt(h))){for(h++;h<t.length&&E(t.charCodeAt(h));)h++;j=h}else D=3;return t.substring(B,j)}function C(){let B="",j=h;for(;;){if(h>=l){B+=t.substring(j,h),D=2;break}const F=t.charCodeAt(h);if(F===34){B+=t.substring(j,h),h++;break}if(F===92){if(B+=t.substring(j,h),h++,h>=l){D=2;break}switch(t.charCodeAt(h++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const G=p(4);G>=0?B+=String.fromCharCode(G):D=4;break}default:D=5}j=h;continue}if(F>=0&&F<=31)if($(F)){B+=t.substring(j,h),D=2;break}else D=6;h++}return B}function O(){if(r="",D=0,g=h,h>=l)return g=l,f=17;let B=t.charCodeAt(h);if(b(B)){do h++,r+=String.fromCharCode(B),B=t.charCodeAt(h);while(b(B));return f=15}if($(B))return h++,r+=String.fromCharCode(B),B===13&&t.charCodeAt(h)===10&&(h++,r+=`
`),f=14;switch(B){case 123:return h++,f=1;case 125:return h++,f=2;case 91:return h++,f=3;case 93:return h++,f=4;case 58:return h++,f=6;case 44:return h++,f=5;case 34:return h++,r=C(),f=10;case 47:{const j=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<l&&!$(t.charCodeAt(h));)h++;return r=t.substring(j,h),f=12}if(t.charCodeAt(h+1)===42){h+=2;const F=l-1;let L=!1;for(;h<F;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,L=!0;break}h++}return L||(h++,D=1),r=t.substring(j,h),f=13}return r+=String.fromCharCode(B),h++,f=16}case 45:if(r+=String.fromCharCode(B),h++,h===l||!E(t.charCodeAt(h)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=y(),f=11;default:for(;h<l&&z(B);)h++,B=t.charCodeAt(h);if(g!==h){switch(r=t.substring(g,h),r){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return r+=String.fromCharCode(B),h++,f=16}}function z(B){if(b(B)||$(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let B;do B=O();while(B>=12&&B<=15);return B}return{setPosition:v,getPosition:()=>h,scan:d?T:O,getToken:()=>f,getTokenValue:()=>r,getTokenOffset:()=>g,getTokenLength:()=>h-g,getTokenError:()=>D}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,d){const h=[],l=new Object;let r;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function D(p,v,y,C){g.value=p,g.offset=v,g.length=y,g.type=C,g.colonOffset=void 0,r=g}try{i(t,{onObjectBegin:(p,v)=>{if(d<=p)throw l;r=void 0,f=d>p,h.push("")},onObjectProperty:(p,v,y)=>{if(d<v||(D(p,v,y,"property"),h[h.length-1]=p,d<=v+y))throw l},onObjectEnd:(p,v)=>{if(d<=p)throw l;r=void 0,h.pop()},onArrayBegin:(p,v)=>{if(d<=p)throw l;r=void 0,h.push(0)},onArrayEnd:(p,v)=>{if(d<=p)throw l;r=void 0,h.pop()},onLiteralValue:(p,v,y)=>{if(d<v||(D(p,v,y,o(p)),d<=v+y))throw l},onSeparator:(p,v,y)=>{if(d<=v)throw l;if(p===":"&&r&&r.type==="property")r.colonOffset=v,f=!1,r=void 0;else if(p===","){const C=h[h.length-1];typeof C=="number"?h[h.length-1]=C+1:(f=!0,h[h.length-1]=""),r=void 0}}})}catch(p){if(p!==l)throw p}return{path:h,previousNode:r,isAtPropertyKey:f,matches:p=>{let v=0;for(let y=0;v<p.length&&y<h.length;y++)if(p[v]===h[y]||p[v]==="*")v++;else if(p[v]!=="**")return!1;return v===p.length}}}function w(t,d=[],h=P.DEFAULT){let l=null,r=[];const g=[];function f(p){Array.isArray(r)?r.push(p):l!==null&&(r[l]=p)}return i(t,{onObjectBegin:()=>{const p={};f(p),g.push(r),r=p,l=null},onObjectProperty:p=>{l=p},onObjectEnd:()=>{r=g.pop()},onArrayBegin:()=>{const p=[];f(p),g.push(r),r=p,l=null},onArrayEnd:()=>{r=g.pop()},onLiteralValue:f,onError:(p,v,y)=>{d.push({error:p,offset:v,length:y})}},h),r[0]}function S(t,d=[],h=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(p){l.type==="property"&&(l.length=p-l.offset,l=l.parent)}function g(p){return l.children.push(p),p}i(t,{onObjectBegin:p=>{l=g({type:"object",offset:p,length:-1,parent:l,children:[]})},onObjectProperty:(p,v,y)=>{l=g({type:"property",offset:v,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:p,offset:v,length:y,parent:l})},onObjectEnd:(p,v)=>{l.length=p+v-l.offset,l=l.parent,r(p+v)},onArrayBegin:(p,v)=>{l=g({type:"array",offset:p,length:-1,parent:l,children:[]})},onArrayEnd:(p,v)=>{l.length=p+v-l.offset,l=l.parent,r(p+v)},onLiteralValue:(p,v,y)=>{g({type:o(p),offset:v,length:y,parent:l,value:p}),r(v+y)},onSeparator:(p,v,y)=>{l.type==="property"&&(p===":"?l.colonOffset=v:p===","&&r(v))},onError:(p,v,y)=>{d.push({error:p,offset:v,length:y})}},h);const D=l.children[0];return D&&delete D.parent,D}function k(t,d){if(!t)return;let h=t;for(const l of d)if(typeof l=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let r=!1;for(const g of h.children)if(Array.isArray(g.children)&&g.children[0].value===l){h=g.children[1],r=!0;break}if(!r)return}else{const r=l;if(h.type!=="array"||r<0||!Array.isArray(h.children)||r>=h.children.length)return;h=h.children[r]}return h}function c(t){if(!t.parent||!t.parent.children)return[];const d=c(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;d.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&d.push(h)}return d}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const d=Object.create(null);for(const h of t.children){const l=h.children[1];l&&(d[h.children[0].value]=m(l))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,d,h=!1){return d>=t.offset&&d<t.offset+t.length||h&&d===t.offset+t.length}function n(t,d,h=!1){if(a(t,d,h)){const l=t.children;if(Array.isArray(l))for(let r=0;r<l.length&&l[r].offset<=d;r++){const g=n(l[r],d,h);if(g)return g}return t}}function i(t,d,h=P.DEFAULT){const l=A(t,!1);function r(X){return X?()=>X(l.getTokenOffset(),l.getTokenLength()):()=>!0}function g(X){return X?$e=>X($e,l.getTokenOffset(),l.getTokenLength()):()=>!0}const f=r(d.onObjectBegin),D=g(d.onObjectProperty),p=r(d.onObjectEnd),v=r(d.onArrayBegin),y=r(d.onArrayEnd),C=g(d.onLiteralValue),O=g(d.onSeparator),z=r(d.onComment),T=g(d.onError),B=h&&h.disallowComments,j=h&&h.allowTrailingComma;function F(){for(;;){const X=l.scan();switch(l.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:B||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(X){case 12:case 13:B?L(10):z();break;case 16:L(1);break;case 15:case 14:break;default:return X}}}function L(X,$e=[],se=[]){if(T(X),$e.length+se.length>0){let re=l.getToken();for(;re!==17;){if($e.indexOf(re)!==-1){F();break}else if(se.indexOf(re)!==-1)break;re=F()}}}function G(X){const $e=l.getTokenValue();return X?C($e):D($e),F(),!0}function te(){switch(l.getToken()){case 11:{let X=0;try{X=JSON.parse(l.getTokenValue()),typeof X!="number"&&(L(2),X=0)}catch{L(2)}C(X);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return F(),!0}function Z(){return l.getToken()!==10?(L(3,[],[2,5]),!1):(G(!1),l.getToken()===6?(O(":"),F(),ue()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function x(){f(),F();let X=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(X||L(4,[],[]),O(","),F(),l.getToken()===2&&j)break}else X&&L(6,[],[]);Z()||L(4,[],[2,5]),X=!0}return p(),l.getToken()!==2?L(7,[2],[]):F(),!0}function _(){v(),F();let X=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(X||L(4,[],[]),O(","),F(),l.getToken()===4&&j)break}else X&&L(6,[],[]);ue()||L(4,[],[4,5]),X=!0}return y(),l.getToken()!==4?L(8,[4],[]):F(),!0}function ue(){switch(l.getToken()){case 3:return _();case 1:return x();case 10:return G(!0);default:return te()}}return F(),l.getToken()===17?h.allowEmptyContent?!0:(L(4,[],[]),!1):ue()?(l.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}function s(t,d){const h=A(t),l=[];let r,g=0,f;do switch(f=h.getPosition(),r=h.scan(),r){case 12:case 13:case 17:g!==f&&l.push(t.substring(g,f)),d!==void 0&&l.push(h.getTokenValue().replace(/[^\r\n]/g,d)),g=h.getPosition();break}while(r!==17);return l.join("")}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[44],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[74],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(P){this.element=P,this.next=u.Undefined,this.prev=u.Undefined}}class N{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let P=this.a;for(;P!==u.Undefined;){const A=P.next;P.prev=u.Undefined,P.next=u.Undefined,P=A}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const b=new u(P);if(this.a===u.Undefined)this.a=b,this.b=b;else if(A){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==u.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==u.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==u.Undefined&&P.next!==u.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===u.Undefined&&P.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):P.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):P.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==u.Undefined;)yield P.element,P=P.next}}e.$5c=N}),define(ke[28],Ee([1,0]),function(de,e){"use strict";var u,N,M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=P,e.$zc=A,e.$Ac=b,e.$Ic=n;function P(i,s,o){let t=i.get(s);return t===void 0&&(t=o,i.set(s,t)),t}function A(i){const s=[];return i.forEach((o,t)=>{s.push(`${t} => ${o}`)}),`Map(${i.size}) {${s.join(", ")}}`}function b(i){const s=[];return i.forEach(o=>{s.push(o)}),`Set(${i.size}) {${s.join(", ")}}`}class ${constructor(s,o){this.uri=s,this.value=o}}function E(i){return Array.isArray(i)}class R{static{this.c=s=>s.toString()}constructor(s,o){if(this[u]="ResourceMap",s instanceof R)this.d=new Map(s.d),this.e=o??R.c;else if(E(s)){this.d=new Map,this.e=o??R.c;for(const[t,d]of s)this.set(t,d)}else this.d=new Map,this.e=s??R.c}set(s,o){return this.d.set(this.e(s),new $(s,o)),this}get(s){return this.d.get(this.e(s))?.value}has(s){return this.d.has(this.e(s))}get size(){return this.d.size}clear(){this.d.clear()}delete(s){return this.d.delete(this.e(s))}forEach(s,o){typeof o<"u"&&(s=s.bind(o));for(const[t,d]of this.d)s(d.value,d.uri,this)}*values(){for(const s of this.d.values())yield s.value}*keys(){for(const s of this.d.values())yield s.uri}*entries(){for(const s of this.d.values())yield[s.uri,s.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.d)yield[s.uri,s.value]}}e.$Bc=R;class I{constructor(s,o){this[N]="ResourceSet",!s||typeof s=="function"?this.c=new R(s):(this.c=new R(o),s.forEach(this.add,this))}get size(){return this.c.size}add(s){return this.c.set(s,s),this}clear(){this.c.clear()}delete(s){return this.c.delete(s)}forEach(s,o){this.c.forEach((t,d)=>s.call(o,d,d,this))}has(s){return this.c.has(s)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=I;var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class S{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(s){return this.c.has(s)}get(s,o=0){const t=this.c.get(s);if(t)return o!==0&&this.l(t,o),t.value}set(s,o,t=0){let d=this.c.get(s);if(d)d.value=o,t!==0&&this.l(d,t);else{switch(d={key:s,value:o,next:void 0,previous:void 0},t){case 0:this.j(d);break;case 1:this.i(d);break;case 2:this.j(d);break;default:this.j(d);break}this.c.set(s,d),this.f++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this.c.get(s);if(o)return this.c.delete(s),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const s=this.d;return this.c.delete(s.key),this.k(s),this.f--,s.value}forEach(s,o){const t=this.g;let d=this.d;for(;d;){if(o?s.bind(o)(d.value,d.key,this):s(d.value,d.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const s=this,o=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.key,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return d}values(){const s=this,o=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.value,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return d}entries(){const s=this,o=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(s.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:[t.key,t.value],done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return d}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this.d,t=this.size;for(;o&&t>s;)this.c.delete(o.key),o=o.next,t--;this.d=o,this.f=t,o&&(o.previous=void 0),this.g++}i(s){if(!this.d&&!this.e)this.e=s;else if(this.d)s.next=this.d,this.d.previous=s;else throw new Error("Invalid list");this.d=s,this.g++}j(s){if(!this.d&&!this.e)this.d=s;else if(this.e)s.previous=this.e,this.e.next=s;else throw new Error("Invalid list");this.e=s,this.g++}k(s){if(s===this.d&&s===this.e)this.d=void 0,this.e=void 0;else if(s===this.d){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.d=s.next}else if(s===this.e){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.e=s.previous}else{const o=s.next,t=s.previous;if(!o||!t)throw new Error("Invalid list");o.previous=t,t.next=o}s.next=void 0,s.previous=void 0,this.g++}l(s,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this.d)return;const t=s.next,d=s.previous;s===this.e?(d.next=void 0,this.e=d):(t.previous=d,d.next=t),s.previous=void 0,s.next=this.d,this.d.previous=s,this.d=s,this.g++}else if(o===2){if(s===this.e)return;const t=s.next,d=s.previous;s===this.d?(t.previous=void 0,this.d=t):(t.previous=d,d.next=t),s.next=void 0,s.previous=this.e,this.e.next=s,this.e=s,this.g++}}}toJSON(){const s=[];return this.forEach((o,t)=>{s.push([t,o])}),s}fromJSON(s){this.clear();for(const[o,t]of s)this.set(o,t)}}e.$Dc=S;class k extends S{constructor(s,o=1){super(),this.m=s,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(s){this.m=s,this.o()}get ratio(){return this.n}set ratio(s){this.n=Math.min(Math.max(0,s),1),this.o()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=k;class c{constructor(){this.c=new Map}add(s){return this.c.set(s,(this.c.get(s)||0)+1),this}delete(s){let o=this.c.get(s)||0;return o===0?!1:(o--,o===0?this.c.delete(s):this.c.set(s,o),!0)}has(s){return this.c.has(s)}}e.$Fc=c;class m{constructor(s){if(this.c=new Map,this.d=new Map,s)for(const[o,t]of s)this.set(o,t)}clear(){this.c.clear(),this.d.clear()}set(s,o){this.c.set(s,o),this.d.set(o,s)}get(s){return this.c.get(s)}getKey(s){return this.d.get(s)}delete(s){const o=this.c.get(s);return o===void 0?!1:(this.c.delete(s),this.d.delete(o),!0)}forEach(s,o){this.c.forEach((t,d)=>{s.call(o,t,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class a{constructor(){this.c=new Map}add(s,o){let t=this.c.get(s);t||(t=new Set,this.c.set(s,t)),t.add(o)}delete(s,o){const t=this.c.get(s);t&&(t.delete(o),t.size===0&&this.c.delete(s))}forEach(s,o){const t=this.c.get(s);t&&t.forEach(o)}get(s){const o=this.c.get(s);return o||new Set}}e.$Hc=a;function n(i,s){if(i===s)return!0;if(i.size!==s.size)return!1;for(const[o,t]of i)if(!s.has(o)||s.get(o)!==t)return!1;for(const[o]of s)if(!i.has(o))return!1;return!0}}),define(ke[3],Ee([1,0,19,72,28,73,43]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=R,e.$Lc=I,e.$Mc=w,e.$Nc=c,e.$Oc=m,e.$Pc=a,e.$Qc=n,e.$Rc=i,e.$Sc=s,e.$3c=p;const b=!1;let $=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let O=this.b.get(C);return O||(O={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,O)),O}trackDisposable(C){const O=this.c(C);O.source||(O.source=new Error().stack)}setParent(C,O){const z=this.c(C);z.parent=O}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,O){const z=O.get(C);if(z)return z;const T=C.parent?this.f(this.c(C.parent),O):C;return O.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,C).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(C=10,O){let z;if(O)z=O;else{const L=new Map,G=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,L).isSingleton);if(G.length===0)return;const te=new Set(G.map(Z=>Z.value));if(z=G.filter(Z=>!(Z.parent&&te.has(Z.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function T(L){function G(Z,x){for(;Z.length>0&&x.some(_=>typeof _=="string"?_===Z[0]:Z[0].match(_));)Z.shift()}const te=L.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return G(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const B=new M.$Hc;for(const L of z){const G=T(L);for(let te=0;te<=G.length;te++)B.add(G.slice(0,te).join(`
`),L)}z.sort((0,u.$7b)(L=>L.idx,u.$9b));let j="",F=0;for(const L of z.slice(0,C)){F++;const G=T(L),te=[];for(let Z=0;Z<G.length;Z++){let x=G[Z];x=`(shared with ${B.get(G.slice(0,Z+1).join(`
`)).size}/${z.length} leaks) at ${x}`;const ue=B.get(G.slice(0,Z).join(`
`)),X=(0,N.$K)([...ue].map($e=>T($e)[Z]),$e=>$e);delete X[G[Z]];for(const[$e,se]of Object.entries(X))te.unshift(`    - stacktraces of ${se.length} other leaks continue with ${$e}`);te.unshift(x)}j+=`


==================== Leaking disposable ${F}/${z.length}: ${L.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return z.length>C&&(j+=`


... and ${z.length-C} more leaking disposables

`),{leaks:z,details:j}}}e.$Jc=E;function R(y){$=y}if(b){const y="__is_disposable_tracked__";R(new class{trackDisposable(C){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[y]||console.log(O)},3e3)}setParent(C,O){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsSingleton(C){}})}function I(y){return $?.trackDisposable(y),y}function w(y){$?.markAsDisposed(y)}function S(y,C){$?.setParent(y,C)}function k(y,C){if($)for(const O of y)$.setParent(O,C)}function c(y){return $?.markAsSingleton(y),y}function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}function a(y){if(A.Iterable.is(y)){const C=[];for(const O of y)if(O)try{O.dispose()}catch(z){C.push(z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const C of y)m(C)&&C.dispose();return[]}function i(...y){const C=s(()=>a(y));return k(y,C),C}function s(y){const C=I({dispose:(0,P.$db)(()=>{w(C),y()})});return C}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return S(C,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),S(C,null))}}e.$Tc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,I(this),S(this.q,this)}dispose(){w(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class d{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&S(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&S(C,null),C}}e.$Vc=d;class h{constructor(C){this.a=new d,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=h;class l{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(C){let O=C;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,w(this))},this}}e.$Yc=r;class g{constructor(){this.a=new Map}acquire(C,...O){let z=this.a.get(C);z||(z={counter:0,object:this.b(C,...O)},this.a.set(C,z));const{object:T}=z,B=(0,P.$db)(()=>{--z.counter===0&&(this.c(C,z.object),this.a.delete(C))});return z.counter++,{object:T,dispose:B}}}e.$Zc=g;class f{constructor(C){this.a=C}async acquire(C,...O){const z=this.a.acquire(C,...O);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(T){throw z.dispose(),T}}}e.$1c=f;class D{constructor(C){this.object=C}dispose(){}}e.$2c=D;function p(y){const C=new o;try{y(C)}finally{C.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,O,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(C)?.dispose(),this.a.set(C,O)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=v}),function(de,e){typeof define=="function"&&define.amd?define(ke[164],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(de=typeof globalThis<"u"?globalThis:de||self,e(de.marked={}))}(this,function(de){"use strict";function e(le,ae){for(var ce=0;ce<ae.length;ce++){var H=ae[ce];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(le,H.key,H)}}function u(le,ae,ce){return ae&&e(le.prototype,ae),ce&&e(le,ce),Object.defineProperty(le,"prototype",{writable:!1}),le}function N(le,ae){if(le){if(typeof le=="string")return M(le,ae);var ce=Object.prototype.toString.call(le).slice(8,-1);if(ce==="Object"&&le.constructor&&(ce=le.constructor.name),ce==="Map"||ce==="Set")return Array.from(le);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return M(le,ae)}}function M(le,ae){(ae==null||ae>le.length)&&(ae=le.length);for(var ce=0,H=new Array(ae);ce<ae;ce++)H[ce]=le[ce];return H}function P(le,ae){var ce=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(ce)return(ce=ce.call(le)).next.bind(ce);if(Array.isArray(le)||(ce=N(le))||ae&&le&&typeof le.length=="number"){ce&&(le=ce);var H=0;return function(){return H>=le.length?{done:!0}:{done:!1,value:le[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}de.defaults=A();function b(le){de.defaults=le}var $=/[&<>"']/,E=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ae){return w[ae]};function k(le,ae){if(ae){if($.test(le))return le.replace(E,S)}else if(R.test(le))return le.replace(I,S);return le}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(le){return le.replace(c,function(ae,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(le,ae){le=typeof le=="string"?le:le.source,ae=ae||"";var ce={replace:function(Q,he){return he=he.source||he,he=he.replace(a,"$1"),le=le.replace(Q,he),ce},getRegex:function(){return new RegExp(le,ae)}};return ce}var i=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(le,ae,ce){if(le){var H;try{H=decodeURIComponent(m(ce)).replace(i,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}ae&&!s.test(ce)&&(ce=r(ae,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch{return null}return ce}var t={},d=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(le,ae){t[" "+le]||(d.test(le)?t[" "+le]=le+"/":t[" "+le]=p(le,"/",!0)),le=t[" "+le];var ce=le.indexOf(":")===-1;return ae.substring(0,2)==="//"?ce?ae:le.replace(h,"$1")+ae:ae.charAt(0)==="/"?ce?ae:le.replace(l,"$1")+ae:le+ae}var g={exec:function(){}};function f(le){for(var ae=1,ce,H;ae<arguments.length;ae++){ce=arguments[ae];for(H in ce)Object.prototype.hasOwnProperty.call(ce,H)&&(le[H]=ce[H])}return le}function D(le,ae){var ce=le.replace(/\|/g,function(he,fe,Pe){for(var be=!1,Ae=fe;--Ae>=0&&Pe[Ae]==="\\";)be=!be;return be?"|":" |"}),H=ce.split(/ \|/),Q=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>ae)H.splice(ae);else for(;H.length<ae;)H.push("");for(;Q<H.length;Q++)H[Q]=H[Q].trim().replace(/\\\|/g,"|");return H}function p(le,ae,ce){var H=le.length;if(H===0)return"";for(var Q=0;Q<H;){var he=le.charAt(H-Q-1);if(he===ae&&!ce)Q++;else if(he!==ae&&ce)Q++;else break}return le.slice(0,H-Q)}function v(le,ae){if(le.indexOf(ae[1])===-1)return-1;for(var ce=le.length,H=0,Q=0;Q<ce;Q++)if(le[Q]==="\\")Q++;else if(le[Q]===ae[0])H++;else if(le[Q]===ae[1]&&(H--,H<0))return Q;return-1}function y(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(le,ae){if(ae<1)return"";for(var ce="";ae>1;)ae&1&&(ce+=le),ae>>=1,le+=le;return ce+le}function O(le,ae,ce,H){var Q=ae.href,he=ae.title?k(ae.title):null,fe=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){H.state.inLink=!0;var Pe={type:"link",raw:ce,href:Q,title:he,text:fe,tokens:H.inlineTokens(fe)};return H.state.inLink=!1,Pe}return{type:"image",raw:ce,href:Q,title:he,text:k(fe)}}function z(le,ae){var ce=le.match(/^(\s+)(?:```)/);if(ce===null)return ae;var H=ce[1];return ae.split(`
`).map(function(Q){var he=Q.match(/^\s+/);if(he===null)return Q;var fe=he[0];return fe.length>=H.length?Q.slice(H.length):Q}).join(`
`)}var T=function(){function le(ce){this.options=ce||de.defaults}var ae=le.prototype;return ae.space=function(H){var Q=this.rules.block.newline.exec(H);if(Q&&Q[0].length>0)return{type:"space",raw:Q[0]}},ae.code=function(H){var Q=this.rules.block.code.exec(H);if(Q){var he=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?he:p(he,`
`)}}},ae.fences=function(H){var Q=this.rules.block.fences.exec(H);if(Q){var he=Q[0],fe=z(he,Q[3]||"");return{type:"code",raw:he,lang:Q[2]?Q[2].trim():Q[2],text:fe}}},ae.heading=function(H){var Q=this.rules.block.heading.exec(H);if(Q){var he=Q[2].trim();if(/#$/.test(he)){var fe=p(he,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(he=fe.trim())}return{type:"heading",raw:Q[0],depth:Q[1].length,text:he,tokens:this.lexer.inline(he)}}},ae.hr=function(H){var Q=this.rules.block.hr.exec(H);if(Q)return{type:"hr",raw:Q[0]}},ae.blockquote=function(H){var Q=this.rules.block.blockquote.exec(H);if(Q){var he=Q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Q[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ae.list=function(H){var Q=this.rules.block.list.exec(H);if(Q){var he,fe,Pe,be,Ae,Ne,Be,V,q,Y,J,ge,we=Q[1].trim(),Te=we.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(ge=!1,!(!(Q=Xe.exec(H))||this.rules.block.hr.test(H)));){if(he=Q[0],H=H.substring(he.length),V=Q[2].split(`
`,1)[0],q=H.split(`
`,1)[0],this.options.pedantic?(be=2,J=V.trimLeft()):(be=Q[2].search(/[^ ]/),be=be>4?1:be,J=V.slice(be),be+=Q[1].length),Ne=!1,!V&&/^ *$/.test(q)&&(he+=q+`
`,H=H.substring(q.length+1),ge=!0),!ge)for(var tt=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,be-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,be-1)+"}#");H&&(Y=H.split(`
`,1)[0],V=Y,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(V)||rt.test(V)||tt.test(V)||nt.test(H)));){if(V.search(/[^ ]/)>=be||!V.trim())J+=`
`+V.slice(be);else if(!Ne)J+=`
`+V;else break;!Ne&&!V.trim()&&(Ne=!0),he+=Y+`
`,H=H.substring(Y.length+1)}He.loose||(Be?He.loose=!0:/\n *\n *$/.test(he)&&(Be=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(J),fe&&(Pe=fe[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:he,task:!!fe,checked:Pe,loose:!1,text:J}),He.raw+=he}He.items[He.items.length-1].raw=he.trimRight(),He.items[He.items.length-1].text=J.trimRight(),He.raw=He.raw.trimRight();var Ce=He.items.length;for(Ae=0;Ae<Ce;Ae++){this.lexer.state.top=!1,He.items[Ae].tokens=this.lexer.blockTokens(He.items[Ae].text,[]);var ze=He.items[Ae].tokens.filter(function(Ge){return Ge.type==="space"}),Me=ze.every(function(Ge){for(var ne=Ge.raw.split(""),oe=0,De=P(ne),Ke;!(Ke=De()).done;){var xe=Ke.value;if(xe===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&ze.length&&Me&&(He.loose=!0,He.items[Ae].loose=!0)}return He}},ae.html=function(H){var Q=this.rules.block.html.exec(H);if(Q){var he={type:"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:Q[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(Q[0]):k(Q[0]);he.type="paragraph",he.text=fe,he.tokens=this.lexer.inline(fe)}return he}},ae.def=function(H){var Q=this.rules.block.def.exec(H);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var he=Q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Q[0],href:Q[2],title:Q[3]}}},ae.table=function(H){var Q=this.rules.block.table.exec(H);if(Q){var he={type:"table",header:D(Q[1]).map(function(Be){return{text:Be}}),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Q[3]&&Q[3].trim()?Q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Q[0];var fe=he.align.length,Pe,be,Ae,Ne;for(Pe=0;Pe<fe;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(fe=he.rows.length,Pe=0;Pe<fe;Pe++)he.rows[Pe]=D(he.rows[Pe],he.header.length).map(function(Be){return{text:Be}});for(fe=he.header.length,be=0;be<fe;be++)he.header[be].tokens=this.lexer.inline(he.header[be].text);for(fe=he.rows.length,be=0;be<fe;be++)for(Ne=he.rows[be],Ae=0;Ae<Ne.length;Ae++)Ne[Ae].tokens=this.lexer.inline(Ne[Ae].text);return he}}},ae.lheading=function(H){var Q=this.rules.block.lheading.exec(H);if(Q)return{type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1],tokens:this.lexer.inline(Q[1])}},ae.paragraph=function(H){var Q=this.rules.block.paragraph.exec(H);if(Q){var he=Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1];return{type:"paragraph",raw:Q[0],text:he,tokens:this.lexer.inline(he)}}},ae.text=function(H){var Q=this.rules.block.text.exec(H);if(Q)return{type:"text",raw:Q[0],text:Q[0],tokens:this.lexer.inline(Q[0])}},ae.escape=function(H){var Q=this.rules.inline.escape.exec(H);if(Q)return{type:"escape",raw:Q[0],text:k(Q[1])}},ae.tag=function(H){var Q=this.rules.inline.tag.exec(H);if(Q)return!this.lexer.state.inLink&&/^<a /i.test(Q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):k(Q[0]):Q[0]}},ae.link=function(H){var Q=this.rules.inline.link.exec(H);if(Q){var he=Q[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var fe=p(he.slice(0,-1),"\\");if((he.length-fe.length)%2===0)return}else{var Pe=v(Q[2],"()");if(Pe>-1){var be=Q[0].indexOf("!")===0?5:4,Ae=be+Q[1].length+Pe;Q[2]=Q[2].substring(0,Pe),Q[0]=Q[0].substring(0,Ae).trim(),Q[3]=""}}var Ne=Q[2],Be="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);V&&(Ne=V[1],Be=V[3])}else Be=Q[3]?Q[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(he)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),O(Q,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},Q[0],this.lexer)}},ae.reflink=function(H,Q){var he;if((he=this.rules.inline.reflink.exec(H))||(he=this.rules.inline.nolink.exec(H))){var fe=(he[2]||he[1]).replace(/\s+/g," ");if(fe=Q[fe.toLowerCase()],!fe||!fe.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return O(he,fe,he[0],this.lexer)}},ae.emStrong=function(H,Q,he){he===void 0&&(he="");var fe=this.rules.inline.emStrong.lDelim.exec(H);if(fe&&!(fe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=fe[1]||fe[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var be=fe[0].length-1,Ae,Ne,Be=be,V=0,q=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,Q=Q.slice(-1*H.length+be);(fe=q.exec(Q))!=null;)if(Ae=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ae){if(Ne=Ae.length,fe[3]||fe[4]){Be+=Ne;continue}else if((fe[5]||fe[6])&&be%3&&!((be+Ne)%3)){V+=Ne;continue}if(Be-=Ne,!(Be>0)){if(Ne=Math.min(Ne,Ne+Be+V),Math.min(be,Ne)%2){var Y=H.slice(1,be+fe.index+Ne);return{type:"em",raw:H.slice(0,be+fe.index+Ne+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var J=H.slice(2,be+fe.index+Ne-1);return{type:"strong",raw:H.slice(0,be+fe.index+Ne+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ae.codespan=function(H){var Q=this.rules.inline.code.exec(H);if(Q){var he=Q[2].replace(/\n/g," "),fe=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return fe&&Pe&&(he=he.substring(1,he.length-1)),he=k(he,!0),{type:"codespan",raw:Q[0],text:he}}},ae.br=function(H){var Q=this.rules.inline.br.exec(H);if(Q)return{type:"br",raw:Q[0]}},ae.del=function(H){var Q=this.rules.inline.del.exec(H);if(Q)return{type:"del",raw:Q[0],text:Q[2],tokens:this.lexer.inlineTokens(Q[2])}},ae.autolink=function(H,Q){var he=this.rules.inline.autolink.exec(H);if(he){var fe,Pe;return he[2]==="@"?(fe=k(this.options.mangle?Q(he[1]):he[1]),Pe="mailto:"+fe):(fe=k(he[1]),Pe=fe),{type:"link",raw:he[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ae.url=function(H,Q){var he;if(he=this.rules.inline.url.exec(H)){var fe,Pe;if(he[2]==="@")fe=k(this.options.mangle?Q(he[0]):he[0]),Pe="mailto:"+fe;else{var be;do be=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(be!==he[0]);fe=k(he[0]),he[1]==="www."?Pe="http://"+fe:Pe=fe}return{type:"link",raw:he[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ae.inlineText=function(H,Q){var he=this.rules.inline.text.exec(H);if(he){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):k(he[0]):he[0]:fe=k(this.options.smartypants?Q(he[0]):he[0]),{type:"text",raw:he[0],text:fe}}},le}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=n(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=n(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=n(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=n(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=n(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=n(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=f({},B),B.gfm=f({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=n(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=n(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=f({},B.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=n(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=n(B._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=n(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=n(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=n(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=n(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=n(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=n(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=n(j.reflink).replace("label",j._label).replace("ref",B._label).getRegex(),j.nolink=n(j.nolink).replace("ref",B._label).getRegex(),j.reflinkSearch=n(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=f({},j),j.pedantic=f({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=f({},j.normal,{escape:n(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=n(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=f({},j.gfm,{br:n(j.br).replace("{2,}","*").getRegex(),text:n(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function L(le){var ae="",ce,H,Q=le.length;for(ce=0;ce<Q;ce++)H=le.charCodeAt(ce),Math.random()>.5&&(H="x"+H.toString(16)),ae+="&#"+H+";";return ae}var G=function(){function le(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||de.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:B.normal,inline:j.normal};this.options.pedantic?(H.block=B.pedantic,H.inline=j.pedantic):this.options.gfm&&(H.block=B.gfm,this.options.breaks?H.inline=j.breaks:H.inline=j.gfm),this.tokenizer.rules=H}le.lex=function(H,Q){var he=new le(Q);return he.lex(H)},le.lexInline=function(H,Q){var he=new le(Q);return he.inlineTokens(H)};var ae=le.prototype;return ae.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var Q;Q=this.inlineQueue.shift();)this.inlineTokens(Q.src,Q.tokens);return this.tokens},ae.blockTokens=function(H,Q){var he=this;Q===void 0&&(Q=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Be,V,q){return V+"    ".repeat(q.length)});for(var fe,Pe,be,Ae;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Be){return(fe=Be.call({lexer:he},H,Q))?(H=H.substring(fe.raw.length),Q.push(fe),!0):!1}))){if(fe=this.tokenizer.space(H)){H=H.substring(fe.raw.length),fe.raw.length===1&&Q.length>0?Q[Q.length-1].raw+=`
`:Q.push(fe);continue}if(fe=this.tokenizer.code(H)){H=H.substring(fe.raw.length),Pe=Q[Q.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Q.push(fe);continue}if(fe=this.tokenizer.fences(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.heading(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.hr(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.blockquote(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.list(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.html(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.def(H)){H=H.substring(fe.raw.length),Pe=Q[Q.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.lheading(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(be=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Be=1/0,V=H.slice(1),q=void 0;he.options.extensions.startBlock.forEach(function(Y){q=Y.call({lexer:this},V),typeof q=="number"&&q>=0&&(Be=Math.min(Be,q))}),Be<1/0&&Be>=0&&(be=H.substring(0,Be+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(be))){Pe=Q[Q.length-1],Ae&&Pe.type==="paragraph"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Q.push(fe),Ae=be.length!==H.length,H=H.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(H)){H=H.substring(fe.raw.length),Pe=Q[Q.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Q.push(fe);continue}if(H){var Ne="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return this.state.top=!0,Q},ae.inline=function(H,Q){return Q===void 0&&(Q=[]),this.inlineQueue.push({src:H,tokens:Q}),Q},ae.inlineTokens=function(H,Q){var he=this;Q===void 0&&(Q=[]);var fe,Pe,be,Ae=H,Ne,Be,V;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)q.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Ne.index)+"["+C("a",Ne[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Ne.index)+"["+C("a",Ne[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Ne.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Be||(V=""),Be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(fe=J.call({lexer:he},H,Q))?(H=H.substring(fe.raw.length),Q.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.tag(H)){H=H.substring(fe.raw.length),Pe=Q[Q.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):Q.push(fe);continue}if(fe=this.tokenizer.link(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(fe.raw.length),Pe=Q[Q.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):Q.push(fe);continue}if(fe=this.tokenizer.emStrong(H,Ae,V)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.codespan(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.br(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.del(H)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(fe=this.tokenizer.autolink(H,L)){H=H.substring(fe.raw.length),Q.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(H,L))){H=H.substring(fe.raw.length),Q.push(fe);continue}if(be=H,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,ge=H.slice(1),we=void 0;he.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},ge),typeof we=="number"&&we>=0&&(J=Math.min(J,we))}),J<1/0&&J>=0&&(be=H.substring(0,J+1))}(),fe=this.tokenizer.inlineText(be,F)){H=H.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(V=fe.raw.slice(-1)),Be=!0,Pe=Q[Q.length-1],Pe&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):Q.push(fe);continue}if(H){var Y="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return Q},u(le,null,[{key:"rules",get:function(){return{block:B,inline:j}}}]),le}(),te=function(){function le(ce){this.options=ce||de.defaults}var ae=le.prototype;return ae.code=function(H,Q,he){var fe=(Q||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(H,fe);Pe!=null&&Pe!==H&&(he=!0,H=Pe)}return H=H.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+k(fe,!0)+'">'+(he?H:k(H,!0))+`</code></pre>
`:"<pre><code>"+(he?H:k(H,!0))+`</code></pre>
`},ae.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},ae.html=function(H){return H},ae.heading=function(H,Q,he,fe){if(this.options.headerIds){var Pe=this.options.headerPrefix+fe.slug(he);return"<h"+Q+' id="'+Pe+'">'+H+"</h"+Q+`>
`}return"<h"+Q+">"+H+"</h"+Q+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(H,Q,he){var fe=Q?"ol":"ul",Pe=Q&&he!==1?' start="'+he+'"':"";return"<"+fe+Pe+`>
`+H+"</"+fe+`>
`},ae.listitem=function(H){return"<li>"+H+`</li>
`},ae.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(H){return"<p>"+H+`</p>
`},ae.table=function(H,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+Q+`</table>
`},ae.tablerow=function(H){return`<tr>
`+H+`</tr>
`},ae.tablecell=function(H,Q){var he=Q.header?"th":"td",fe=Q.align?"<"+he+' align="'+Q.align+'">':"<"+he+">";return fe+H+("</"+he+`>
`)},ae.strong=function(H){return"<strong>"+H+"</strong>"},ae.em=function(H){return"<em>"+H+"</em>"},ae.codespan=function(H){return"<code>"+H+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(H){return"<del>"+H+"</del>"},ae.link=function(H,Q,he){if(H=o(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var fe='<a href="'+k(H)+'"';return Q&&(fe+=' title="'+Q+'"'),fe+=">"+he+"</a>",fe},ae.image=function(H,Q,he){if(H=o(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var fe='<img src="'+H+'" alt="'+he+'"';return Q&&(fe+=' title="'+Q+'"'),fe+=this.options.xhtml?"/>":">",fe},ae.text=function(H){return H},le}(),Z=function(){function le(){}var ae=le.prototype;return ae.strong=function(H){return H},ae.em=function(H){return H},ae.codespan=function(H){return H},ae.del=function(H){return H},ae.html=function(H){return H},ae.text=function(H){return H},ae.link=function(H,Q,he){return""+he},ae.image=function(H,Q,he){return""+he},ae.br=function(){return""},le}(),x=function(){function le(){this.seen={}}var ae=le.prototype;return ae.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(H,Q){var he=H,fe=0;if(this.seen.hasOwnProperty(he)){fe=this.seen[H];do fe++,he=H+"-"+fe;while(this.seen.hasOwnProperty(he))}return Q||(this.seen[H]=fe,this.seen[he]=0),he},ae.slug=function(H,Q){Q===void 0&&(Q={});var he=this.serialize(H);return this.getNextSafeSlug(he,Q.dryrun)},le}(),_=function(){function le(ce){this.options=ce||de.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new x}le.parse=function(H,Q){var he=new le(Q);return he.parse(H)},le.parseInline=function(H,Q){var he=new le(Q);return he.parseInline(H)};var ae=le.prototype;return ae.parse=function(H,Q){Q===void 0&&(Q=!0);var he="",fe,Pe,be,Ae,Ne,Be,V,q,Y,J,ge,we,Te,He,Xe,tt,nt,at,rt,Ce=H.length;for(fe=0;fe<Ce;fe++){if(J=H[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(rt=this.options.extensions.renderers[J.type].call({parser:this},J),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){he+=rt||"";continue}switch(J.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(q="",V="",Ae=J.header.length,Pe=0;Pe<Ae;Pe++)V+=this.renderer.tablecell(this.parseInline(J.header[Pe].tokens),{header:!0,align:J.align[Pe]});for(q+=this.renderer.tablerow(V),Y="",Ae=J.rows.length,Pe=0;Pe<Ae;Pe++){for(Be=J.rows[Pe],V="",Ne=Be.length,be=0;be<Ne;be++)V+=this.renderer.tablecell(this.parseInline(Be[be].tokens),{header:!1,align:J.align[be]});Y+=this.renderer.tablerow(V)}he+=this.renderer.table(q,Y);continue}case"blockquote":{Y=this.parse(J.tokens),he+=this.renderer.blockquote(Y);continue}case"list":{for(ge=J.ordered,we=J.start,Te=J.loose,Ae=J.items.length,Y="",Pe=0;Pe<Ae;Pe++)Xe=J.items[Pe],tt=Xe.checked,nt=Xe.task,He="",Xe.task&&(at=this.renderer.checkbox(tt),Te?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=at+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=at+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(Xe.tokens,Te),Y+=this.renderer.listitem(He,nt,tt);he+=this.renderer.list(Y,ge,we);continue}case"html":{he+=this.renderer.html(J.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Y=J.tokens?this.parseInline(J.tokens):J.text;fe+1<Ce&&H[fe+1].type==="text";)J=H[++fe],Y+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);he+=Q?this.renderer.paragraph(Y):Y;continue}default:{var ze='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return he},ae.parseInline=function(H,Q){Q=Q||this.renderer;var he="",fe,Pe,be,Ae=H.length;for(fe=0;fe<Ae;fe++){if(Pe=H[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(be=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=be||"";continue}switch(Pe.type){case"escape":{he+=Q.text(Pe.text);break}case"html":{he+=Q.html(Pe.text);break}case"link":{he+=Q.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Q));break}case"image":{he+=Q.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=Q.strong(this.parseInline(Pe.tokens,Q));break}case"em":{he+=Q.em(this.parseInline(Pe.tokens,Q));break}case"codespan":{he+=Q.codespan(Pe.text);break}case"br":{he+=Q.br();break}case"del":{he+=Q.del(this.parseInline(Pe.tokens,Q));break}case"text":{he+=Q.text(Pe.text);break}default:{var Ne='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return he},le}();function ue(le,ae,ce){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ae=="function"&&(ce=ae,ae=null),ae=f({},ue.defaults,ae||{}),y(ae),ce){var H=ae.highlight,Q;try{Q=G.lex(le,ae)}catch(Ae){return ce(Ae)}var he=function(Ne){var Be;if(!Ne)try{ae.walkTokens&&ue.walkTokens(Q,ae.walkTokens),Be=_.parse(Q,ae)}catch(V){Ne=V}return ae.highlight=H,Ne?ce(Ne):ce(null,Be)};if(!H||H.length<3||(delete ae.highlight,!Q.length))return he();var fe=0;ue.walkTokens(Q,function(Ae){Ae.type==="code"&&(fe++,setTimeout(function(){H(Ae.text,Ae.lang,function(Ne,Be){if(Ne)return he(Ne);Be!=null&&Be!==Ae.text&&(Ae.text=Be,Ae.escaped=!0),fe--,fe===0&&he()})},0))}),fe===0&&he();return}function Pe(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+k(Ae.message+"",!0)+"</pre>";throw Ae}try{var be=G.lex(le,ae);if(ae.walkTokens){if(ae.async)return Promise.all(ue.walkTokens(be,ae.walkTokens)).then(function(){return _.parse(be,ae)}).catch(Pe);ue.walkTokens(be,ae.walkTokens)}return _.parse(be,ae)}catch(Ae){Pe(Ae)}}ue.options=ue.setOptions=function(le){return f(ue.defaults,le),b(ue.defaults),ue},ue.getDefaults=A,ue.defaults=de.defaults,ue.use=function(){for(var le=arguments.length,ae=new Array(le),ce=0;ce<le;ce++)ae[ce]=arguments[ce];var H=f.apply(void 0,[{}].concat(ae)),Q=ue.defaults.extensions||{renderers:{},childTokens:{}},he;ae.forEach(function(fe){if(fe.extensions&&(he=!0,fe.extensions.forEach(function(be){if(!be.name)throw new Error("extension name required");if(be.renderer){var Ae=Q.renderers?Q.renderers[be.name]:null;Ae?Q.renderers[be.name]=function(){for(var Ne=arguments.length,Be=new Array(Ne),V=0;V<Ne;V++)Be[V]=arguments[V];var q=be.renderer.apply(this,Be);return q===!1&&(q=Ae.apply(this,Be)),q}:Q.renderers[be.name]=be.renderer}if(be.tokenizer){if(!be.level||be.level!=="block"&&be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[be.level]?Q[be.level].unshift(be.tokenizer):Q[be.level]=[be.tokenizer],be.start&&(be.level==="block"?Q.startBlock?Q.startBlock.push(be.start):Q.startBlock=[be.start]:be.level==="inline"&&(Q.startInline?Q.startInline.push(be.start):Q.startInline=[be.start]))}be.childTokens&&(Q.childTokens[be.name]=be.childTokens)})),fe.renderer&&function(){var be=ue.defaults.renderer||new te,Ae=function(V){var q=be[V];be[V]=function(){for(var Y=arguments.length,J=new Array(Y),ge=0;ge<Y;ge++)J[ge]=arguments[ge];var we=fe.renderer[V].apply(be,J);return we===!1&&(we=q.apply(be,J)),we}};for(var Ne in fe.renderer)Ae(Ne);H.renderer=be}(),fe.tokenizer&&function(){var be=ue.defaults.tokenizer||new T,Ae=function(V){var q=be[V];be[V]=function(){for(var Y=arguments.length,J=new Array(Y),ge=0;ge<Y;ge++)J[ge]=arguments[ge];var we=fe.tokenizer[V].apply(be,J);return we===!1&&(we=q.apply(be,J)),we}};for(var Ne in fe.tokenizer)Ae(Ne);H.tokenizer=be}(),fe.walkTokens){var Pe=ue.defaults.walkTokens;H.walkTokens=function(be){var Ae=[];return Ae.push(fe.walkTokens.call(this,be)),Pe&&(Ae=Ae.concat(Pe.call(this,be))),Ae}}he&&(H.extensions=Q),ue.setOptions(H)})},ue.walkTokens=function(le,ae){for(var ce=[],H=function(){var Pe=he.value;switch(ce=ce.concat(ae.call(ue,Pe)),Pe.type){case"table":{for(var be=P(Pe.header),Ae;!(Ae=be()).done;){var Ne=Ae.value;ce=ce.concat(ue.walkTokens(Ne.tokens,ae))}for(var Be=P(Pe.rows),V;!(V=Be()).done;)for(var q=V.value,Y=P(q),J;!(J=Y()).done;){var ge=J.value;ce=ce.concat(ue.walkTokens(ge.tokens,ae))}break}case"list":{ce=ce.concat(ue.walkTokens(Pe.items,ae));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Pe.type]?ue.defaults.extensions.childTokens[Pe.type].forEach(function(we){ce=ce.concat(ue.walkTokens(Pe[we],ae))}):Pe.tokens&&(ce=ce.concat(ue.walkTokens(Pe.tokens,ae)))}},Q=P(le),he;!(he=Q()).done;)H();return ce},ue.parseInline=function(le,ae){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ae=f({},ue.defaults,ae||{}),y(ae);try{var ce=G.lexInline(le,ae);return ae.walkTokens&&ue.walkTokens(ce,ae.walkTokens),_.parseInline(ce,ae)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+k(H.message+"",!0)+"</pre>";throw H}},ue.Parser=_,ue.parser=_.parse,ue.Renderer=te,ue.TextRenderer=Z,ue.Lexer=G,ue.lexer=G.lex,ue.Tokenizer=T,ue.Slugger=x,ue.parse=ue;var X=ue.options,$e=ue.setOptions,se=ue.use,re=ue.walkTokens,U=ue.parseInline,ie=ue,ve=_.parse,Ie=G.lex;de.Lexer=G,de.Parser=_,de.Renderer=te,de.Slugger=x,de.TextRenderer=Z,de.Tokenizer=T,de.getDefaults=A,de.lexer=Ie,de.marked=ue,de.options=X,de.parse=ie,de.parseInline=U,de.parser=ve,de.setOptions=$e,de.use=se,de.walkTokens=re,Object.defineProperty(de,"__esModule",{value:!0})}),define(ke[165],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=u;function u(c){const m=P(c);if(m&&m.length>0)return new Uint32Array(m)}let N=0;const M=new Uint32Array(10);function P(c){if(N=0,A(c,I,4352),N>0||(A(c,w,4449),N>0)||(A(c,S,4520),N>0)||(A(c,k,12593),N))return M.subarray(0,N);if(c>=44032&&c<=55203){const m=c-44032,a=m%588,n=Math.floor(m/588),i=Math.floor(a/28),s=a%28-1;if(n<I.length?A(n,I,0):4352+n-12593<k.length&&A(4352+n,k,12593),i<w.length?A(i,w,0):4449+i-12593<k.length&&A(4449+i-12593,k,12593),s>=0&&(s<S.length?A(s,S,0):4520+s-12593<k.length&&A(4520+s-12593,k,12593)),N>0)return M.subarray(0,N)}}function A(c,m,a){c>=a&&c<a+m.length&&b(m[c-a])}function b(c){c!==0&&(M[N++]=c&255,c>>8&&(M[N++]=c>>8&255),c>>16&&(M[N++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var E;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(E||(E={}));var R;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(R||(R={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[75],Ee([1,0,28]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=void 0,e.$Yl=M,e.$Zl=A;const N=new u.$Ec(1e4);function M(E){return $(E,"NFC",N)}const P=new u.$Ec(1e4);function A(E){return $(E,"NFD",P)}const b=/[^\u0000-\u0080]/;function $(E,R,I){if(!E)return E;const w=I.get(E);if(w)return w;let S;return b.test(E)?S=E.normalize(R):S=E,I.set(E,S),S}e.$1l=function(){const E=/[\u0300-\u036f]/g;return function(R){return A(R).replace(E,"")}}()}),define(ke[125],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=u,e.rot=N;function u(b,$,E){return Math.min(Math.max(b,$),E)}function N(b,$){return($+b%$)%$}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$om=M;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=P;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const E=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=A}),function(){function de(M){const P=[];typeof M=="number"&&P.push("code/timeOrigin",M);function A($){P.push($,Date.now())}function b(){const $=[];for(let E=0;E<P.length;E+=2)$.push({name:P[E],startTime:P[E+1]});return $}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?de():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(M+A.startTime)});return P}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return de(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),de()}function u(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=u(N))}(),define(ke[166],Ee([1,0,43]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;const N=Symbol("unset");class M{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert($,E,R){this.d($,I=>I._value=E,R)}mutate($,E){this.d($,R=>R._value=E(R._value===N?void 0:R._value))}delete($){const E=this.c($);if(!E)return;let R=E.length-1;const I=E[R].node._value;if(I!==N){for(this.b--,E[R].node._value=N;R>0;R--){const{node:w,part:S}=E[R];if(w.children?.size||w._value!==N)break;E[R-1].node.children.delete(S)}return I}}*deleteRecursive($){const E=this.c($);if(!E)return;const R=E[E.length-1].node;for(let I=E.length-1;I>0;I--){const w=E[I-1];if(w.node.children.delete(E[I].part),w.node.children.size>0||w.node._value!==N)break}for(const I of P(R))I._value!==N&&(this.b--,yield I._value)}find($){let E=this.a;for(const R of $){const I=E.children?.get(R);if(!I)return;E=I}return E._value===N?void 0:E._value}hasKeyOrParent($){let E=this.a;for(const R of $){const I=E.children?.get(R);if(!I)return!1;if(I._value!==N)return!0;E=I}return!1}hasKeyOrChildren($){let E=this.a;for(const R of $){const I=E.children?.get(R);if(!I)return!1;E=I}return!0}hasKey($){let E=this.a;for(const R of $){const I=E.children?.get(R);if(!I)return!1;E=I}return E._value!==N}c($){const E=[{part:"",node:this.a}];let R=0;for(const I of $){const w=E[R].node.children?.get(I);if(!w)return;E.push({part:I,node:w}),R++}return E}d($,E,R){let I=this.a;for(const k of $){if(I.children)if(I.children.has(k))I=I.children.get(k);else{const c=new A;I.children.set(k,c),I=c}else{const c=new A;I.children=new Map([[k,c]]),I=c}R?.(I)}const w=I._value===N?0:1;E(I);const S=I._value===N?0:1;this.b+=S-w}*values(){for(const{_value:$}of P(this.a))$!==N&&(yield $)}}e.$pO=M;function*P(b){const $=[b];for(;$.length>0;){const E=$.pop();if(yield E,E.children)for(const R of E.children.values())$.push(R)}}class A{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value($){this._value=$===void 0?N:$}}}),function(de,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var N in u)(typeof exports=="object"?exports:de)[N]=u[N]}}(typeof self<"u"?self:this,function(){return function(de){var e={};function u(N){if(e[N])return e[N].exports;var M=e[N]={i:N,l:!1,exports:{}};return de[N].call(M.exports,M,M.exports,u),M.l=!0,M.exports}return u.m=de,u.c=e,u.d=function(N,M,P){u.o(N,M)||Object.defineProperty(N,M,{enumerable:!0,get:P})},u.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},u.t=function(N,M){if(1&M&&(N=u(N)),8&M||4&M&&typeof N=="object"&&N&&N.__esModule)return N;var P=Object.create(null);if(u.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:N}),2&M&&typeof N!="string")for(var A in N)u.d(P,A,function(b){return N[b]}.bind(null,A));return P},u.n=function(N){var M=N&&N.__esModule?function(){return N.default}:function(){return N};return u.d(M,"a",M),M},u.o=function(N,M){return Object.prototype.hasOwnProperty.call(N,M)},u.p="",u(u.s=0)}([function(de,e,u){(function(N){var M;e=de.exports=se,M=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],E=0,R=E++;$[R]="0|[1-9]\\d*";var I=E++;$[I]="[0-9]+";var w=E++;$[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;$[S]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var k=E++;$[k]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var c=E++;$[c]="(?:"+$[R]+"|"+$[w]+")";var m=E++;$[m]="(?:"+$[I]+"|"+$[w]+")";var a=E++;$[a]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var n=E++;$[n]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var i=E++;$[i]="[0-9A-Za-z-]+";var s=E++;$[s]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var o=E++,t="v?"+$[S]+$[a]+"?"+$[s]+"?";$[o]="^"+t+"$";var d="[v=\\s]*"+$[k]+$[n]+"?"+$[s]+"?",h=E++;$[h]="^"+d+"$";var l=E++;$[l]="((?:<|>)?=?)";var r=E++;$[r]=$[I]+"|x|X|\\*";var g=E++;$[g]=$[R]+"|x|X|\\*";var f=E++;$[f]="[v=\\s]*("+$[g]+")(?:\\.("+$[g]+")(?:\\.("+$[g]+")(?:"+$[a]+")?"+$[s]+"?)?)?";var D=E++;$[D]="[v=\\s]*("+$[r]+")(?:\\.("+$[r]+")(?:\\.("+$[r]+")(?:"+$[n]+")?"+$[s]+"?)?)?";var p=E++;$[p]="^"+$[l]+"\\s*"+$[f]+"$";var v=E++;$[v]="^"+$[l]+"\\s*"+$[D]+"$";var y=E++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;$[C]="(?:~>?)";var O=E++;$[O]="(\\s*)"+$[C]+"\\s+",b[O]=new RegExp($[O],"g");var z=E++;$[z]="^"+$[C]+$[f]+"$";var T=E++;$[T]="^"+$[C]+$[D]+"$";var B=E++;$[B]="(?:\\^)";var j=E++;$[j]="(\\s*)"+$[B]+"\\s+",b[j]=new RegExp($[j],"g");var F=E++;$[F]="^"+$[B]+$[f]+"$";var L=E++;$[L]="^"+$[B]+$[D]+"$";var G=E++;$[G]="^"+$[l]+"\\s*("+d+")$|^$";var te=E++;$[te]="^"+$[l]+"\\s*("+t+")$|^$";var Z=E++;$[Z]="(\\s*)"+$[l]+"\\s*("+d+"|"+$[f]+")",b[Z]=new RegExp($[Z],"g");var x=E++;$[x]="^\\s*("+$[f]+")\\s+-\\s+("+$[f]+")\\s*$";var _=E++;$[_]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ue=E++;$[ue]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)M(X,$[X]),b[X]||(b[X]=new RegExp($[X]));function $e(q,Y){if(q instanceof se)return q;if(typeof q!="string"||q.length>P||!(Y?b[h]:b[o]).test(q))return null;try{return new se(q,Y)}catch{return null}}function se(q,Y){if(q instanceof se){if(q.loose===Y)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof se))return new se(q,Y);M("SemVer",q,Y),this.loose=Y;var J=q.trim().match(Y?b[h]:b[o]);if(!J)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var we=+ge;if(we>=0&&we<A)return we}return ge}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=$e,e.valid=function(q,Y){var J=$e(q,Y);return J?J.version:null},e.clean=function(q,Y){var J=$e(q.trim().replace(/^[=v]+/,""),Y);return J?J.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return M("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),U(this.major,q.major)||U(this.minor,q.minor)||U(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Y=0;do{var J=this.prerelease[Y],ge=q.prerelease[Y];if(M("prerelease compare",Y,J,ge),J===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(J===void 0)return-1;if(J!==ge)return U(J,ge)}while(++Y)},se.prototype.inc=function(q,Y){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Y,J,ge){typeof J=="string"&&(ge=J,J=void 0);try{return new se(q,J).inc(Y,ge).version}catch{return null}},e.diff=function(q,Y){if(le(q,Y))return null;var J=$e(q),ge=$e(Y);if(J.prerelease.length||ge.prerelease.length){for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==ge[we])return"pre"+we;return"prerelease"}for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==ge[we])return we},e.compareIdentifiers=U;var re=/^[0-9]+$/;function U(q,Y){var J=re.test(q),ge=re.test(Y);return J&&ge&&(q=+q,Y=+Y),J&&!ge?-1:ge&&!J?1:q<Y?-1:q>Y?1:0}function ie(q,Y,J){return new se(q,J).compare(new se(Y,J))}function ve(q,Y,J){return ie(q,Y,J)>0}function Ie(q,Y,J){return ie(q,Y,J)<0}function le(q,Y,J){return ie(q,Y,J)===0}function ae(q,Y,J){return ie(q,Y,J)!==0}function ce(q,Y,J){return ie(q,Y,J)>=0}function H(q,Y,J){return ie(q,Y,J)<=0}function Q(q,Y,J,ge){var we;switch(Y){case"===":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),we=q===J;break;case"!==":typeof q=="object"&&(q=q.version),typeof J=="object"&&(J=J.version),we=q!==J;break;case"":case"=":case"==":we=le(q,J,ge);break;case"!=":we=ae(q,J,ge);break;case">":we=ve(q,J,ge);break;case">=":we=ce(q,J,ge);break;case"<":we=Ie(q,J,ge);break;case"<=":we=H(q,J,ge);break;default:throw new TypeError("Invalid operator: "+Y)}return we}function he(q,Y){if(q instanceof he){if(q.loose===Y)return q;q=q.value}if(!(this instanceof he))return new he(q,Y);M("comparator",q,Y),this.loose=Y,this.parse(q),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(q,Y){return U(Y,q)},e.major=function(q,Y){return new se(q,Y).major},e.minor=function(q,Y){return new se(q,Y).minor},e.patch=function(q,Y){return new se(q,Y).patch},e.compare=ie,e.compareLoose=function(q,Y){return ie(q,Y,!0)},e.rcompare=function(q,Y,J){return ie(Y,q,J)},e.sort=function(q,Y){return q.sort(function(J,ge){return e.compare(J,ge,Y)})},e.rsort=function(q,Y){return q.sort(function(J,ge){return e.rcompare(J,ge,Y)})},e.gt=ve,e.lt=Ie,e.eq=le,e.neq=ae,e.gte=ce,e.lte=H,e.cmp=Q,e.Comparator=he;var fe={};function Pe(q,Y){if(q instanceof Pe)return q.loose===Y?q:new Pe(q.raw,Y);if(q instanceof he)return new Pe(q.value,Y);if(!(this instanceof Pe))return new Pe(q,Y);if(this.loose=Y,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function be(q){return!q||q.toLowerCase()==="x"||q==="*"}function Ae(q,Y,J,ge,we,Te,He,Xe,tt,nt,at,rt,Ce){return((Y=be(J)?"":be(ge)?">="+J+".0.0":be(we)?">="+J+"."+ge+".0":">="+Y)+" "+(Xe=be(tt)?"":be(nt)?"<"+(+tt+1)+".0.0":be(at)?"<"+tt+"."+(+nt+1)+".0":rt?"<="+tt+"."+nt+"."+at+"-"+rt:"<="+Xe)).trim()}function Ne(q,Y){for(var J=0;J<q.length;J++)if(!q[J].test(Y))return!1;if(Y.prerelease.length){for(J=0;J<q.length;J++)if(M(q[J].semver),q[J].semver!==fe&&q[J].semver.prerelease.length>0){var ge=q[J].semver;if(ge.major===Y.major&&ge.minor===Y.minor&&ge.patch===Y.patch)return!0}return!1}return!0}function Be(q,Y,J){try{Y=new Pe(Y,J)}catch{return!1}return Y.test(q)}function V(q,Y,J,ge){var we,Te,He,Xe,tt;switch(q=new se(q,ge),Y=new Pe(Y,ge),J){case">":we=ve,Te=H,He=Ie,Xe=">",tt=">=";break;case"<":we=Ie,Te=ce,He=ve,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Be(q,Y,ge))return!1;for(var nt=0;nt<Y.set.length;++nt){var at=Y.set[nt],rt=null,Ce=null;if(at.forEach(function(ze){ze.semver===fe&&(ze=new he(">=0.0.0")),rt=rt||ze,Ce=Ce||ze,we(ze.semver,rt.semver,ge)?rt=ze:He(ze.semver,Ce.semver,ge)&&(Ce=ze)}),rt.operator===Xe||rt.operator===tt||(!Ce.operator||Ce.operator===Xe)&&Te(q,Ce.semver)||Ce.operator===tt&&He(q,Ce.semver))return!1}return!0}he.prototype.parse=function(q){var Y=this.loose?b[G]:b[te],J=q.match(Y);if(!J)throw new TypeError("Invalid comparator: "+q);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new se(J[2],this.loose):this.semver=fe},he.prototype.toString=function(){return this.value},he.prototype.test=function(q){return M("Comparator.test",q,this.loose),this.semver===fe||(typeof q=="string"&&(q=new se(q,this.loose)),Q(q,this.operator,this.semver,this.loose))},he.prototype.intersects=function(q,Y){if(!(q instanceof he))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Pe(q.value,Y),Be(this.value,J,Y);if(q.operator==="")return J=new Pe(this.value,Y),Be(q.semver,J,Y);var ge=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Te=this.semver.version===q.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Xe=Q(this.semver,"<",q.semver,Y)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),tt=Q(this.semver,">",q.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return ge||we||Te&&He||Xe||tt},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(q){var Y=this.loose;q=q.trim(),M("range",q,Y);var J=Y?b[_]:b[x];q=q.replace(J,Ae),M("hyphen replace",q),q=q.replace(b[Z],"$1$2$3"),M("comparator trim",q,b[Z]),q=(q=(q=q.replace(b[O],"$1~")).replace(b[j],"$1^")).split(/\s+/).join(" ");var ge=Y?b[G]:b[te],we=q.split(" ").map(function(Te){return function(He,Xe){return M("comp",He),He=function(tt,nt){return tt.trim().split(/\s+/).map(function(at){return function(rt,Ce){M("caret",rt,Ce);var ze=Ce?b[L]:b[F];return rt.replace(ze,function(Me,Ge,ne,oe,De){var Ke;return M("caret",rt,Me,Ge,ne,oe,De),be(Ge)?Ke="":be(ne)?Ke=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":be(oe)?Ke=Ge==="0"?">="+Ge+"."+ne+".0 <"+Ge+"."+(+ne+1)+".0":">="+Ge+"."+ne+".0 <"+(+Ge+1)+".0.0":De?(M("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ke=Ge==="0"?ne==="0"?">="+Ge+"."+ne+"."+oe+De+" <"+Ge+"."+ne+"."+(+oe+1):">="+Ge+"."+ne+"."+oe+De+" <"+Ge+"."+(+ne+1)+".0":">="+Ge+"."+ne+"."+oe+De+" <"+(+Ge+1)+".0.0"):(M("no pr"),Ke=Ge==="0"?ne==="0"?">="+Ge+"."+ne+"."+oe+" <"+Ge+"."+ne+"."+(+oe+1):">="+Ge+"."+ne+"."+oe+" <"+Ge+"."+(+ne+1)+".0":">="+Ge+"."+ne+"."+oe+" <"+(+Ge+1)+".0.0"),M("caret return",Ke),Ke})}(at,nt)}).join(" ")}(He,Xe),M("caret",He),He=function(tt,nt){return tt.trim().split(/\s+/).map(function(at){return function(rt,Ce){var ze=Ce?b[T]:b[z];return rt.replace(ze,function(Me,Ge,ne,oe,De){var Ke;return M("tilde",rt,Me,Ge,ne,oe,De),be(Ge)?Ke="":be(ne)?Ke=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":be(oe)?Ke=">="+Ge+"."+ne+".0 <"+Ge+"."+(+ne+1)+".0":De?(M("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ke=">="+Ge+"."+ne+"."+oe+De+" <"+Ge+"."+(+ne+1)+".0"):Ke=">="+Ge+"."+ne+"."+oe+" <"+Ge+"."+(+ne+1)+".0",M("tilde return",Ke),Ke})}(at,nt)}).join(" ")}(He,Xe),M("tildes",He),He=function(tt,nt){return M("replaceXRanges",tt,nt),tt.split(/\s+/).map(function(at){return function(rt,Ce){rt=rt.trim();var ze=Ce?b[v]:b[p];return rt.replace(ze,function(Me,Ge,ne,oe,De,Ke){M("xRange",rt,Me,Ge,ne,oe,De,Ke);var xe=be(ne),st=xe||be(oe),je=st||be(De);return Ge==="="&&je&&(Ge=""),xe?Me=Ge===">"||Ge==="<"?"<0.0.0":"*":Ge&&je?(st&&(oe=0),je&&(De=0),Ge===">"?(Ge=">=",st?(ne=+ne+1,oe=0,De=0):je&&(oe=+oe+1,De=0)):Ge==="<="&&(Ge="<",st?ne=+ne+1:oe=+oe+1),Me=Ge+ne+"."+oe+"."+De):st?Me=">="+ne+".0.0 <"+(+ne+1)+".0.0":je&&(Me=">="+ne+"."+oe+".0 <"+ne+"."+(+oe+1)+".0"),M("xRange return",Me),Me})}(at,nt)}).join(" ")}(He,Xe),M("xrange",He),He=function(tt,nt){return M("replaceStars",tt,nt),tt.trim().replace(b[ue],"")}(He,Xe),M("stars",He),He}(Te,Y)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(ge)})),we=we.map(function(Te){return new he(Te,Y)})},Pe.prototype.intersects=function(q,Y){if(!(q instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ge){return q.set.some(function(we){return we.every(function(Te){return ge.intersects(Te,Y)})})})})},e.toComparators=function(q,Y){return new Pe(q,Y).set.map(function(J){return J.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Ne(this.set[Y],q))return!0;return!1},e.satisfies=Be,e.maxSatisfying=function(q,Y,J){var ge=null,we=null;try{var Te=new Pe(Y,J)}catch{return null}return q.forEach(function(He){Te.test(He)&&(ge&&we.compare(He)!==-1||(we=new se(ge=He,J)))}),ge},e.minSatisfying=function(q,Y,J){var ge=null,we=null;try{var Te=new Pe(Y,J)}catch{return null}return q.forEach(function(He){Te.test(He)&&(ge&&we.compare(He)!==1||(we=new se(ge=He,J)))}),ge},e.validRange=function(q,Y){try{return new Pe(q,Y).range||"*"}catch{return null}},e.ltr=function(q,Y,J){return V(q,Y,"<",J)},e.gtr=function(q,Y,J){return V(q,Y,">",J)},e.outside=V,e.prerelease=function(q,Y){var J=$e(q,Y);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(q,Y,J){return q=new Pe(q,J),Y=new Pe(Y,J),q.intersects(Y)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var Y=q.match(b[y]);return Y==null?null:$e((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,u(1))},function(de,e){var u,N,M=de.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(m){if(u===setTimeout)return setTimeout(m,0);if((u===P||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:P}catch{u=P}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var $,E=[],R=!1,I=-1;function w(){R&&$&&(R=!1,$.length?E=$.concat(E):I=-1,E.length&&S())}function S(){if(!R){var m=b(w);R=!0;for(var a=E.length;a;){for($=E,E=[];++I<a;)$&&$[I].run();I=-1,a=E.length}$=null,R=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(m)}}function k(m,a){this.fun=m,this.array=a}function c(){}M.nextTick=function(m){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];E.push(new k(m,a)),E.length!==1||R||b(S)},k.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=c,M.addListener=c,M.once=c,M.off=c,M.removeListener=c,M.removeAllListeners=c,M.emit=c,M.prependListener=c,M.prependOnceListener=c,M.listeners=function(m){return[]},M.binding=function(m){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(m){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(ke[38],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(P){return new N(P)}constructor(P){this.c=u&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=N}),define(ke[4],Ee([1,0,13,73,3,74,38]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=w;const b=!1,$=!1;var E;(function(p){p.None=()=>M.$Uc.None;function v(H){if($){const{onDidAddListener:Q}=H,he=k.create();let fe=0;H.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),Q?.()}}}function y(H,Q){return te(H,()=>{},0,void 0,!0,void 0,Q)}p.defer=y;function C(H){return(Q,he=null,fe)=>{let Pe=!1,be;return be=H(Ae=>{if(!Pe)return be?be.dispose():Pe=!0,Q.call(he,Ae)},null,fe),Pe&&be.dispose(),be}}p.once=C;function O(H,Q,he){return L((fe,Pe=null,be)=>H(Ae=>fe.call(Pe,Q(Ae)),null,be),he)}p.map=O;function z(H,Q,he){return L((fe,Pe=null,be)=>H(Ae=>{Q(Ae),fe.call(Pe,Ae)},null,be),he)}p.forEach=z;function T(H,Q,he){return L((fe,Pe=null,be)=>H(Ae=>Q(Ae)&&fe.call(Pe,Ae),null,be),he)}p.filter=T;function B(H){return H}p.signal=B;function j(...H){return(Q,he=null,fe)=>{const Pe=(0,M.$Rc)(...H.map(be=>be(Ae=>Q.call(he,Ae))));return G(Pe,fe)}}p.any=j;function F(H,Q,he,fe){let Pe=he;return O(H,be=>(Pe=Q(Pe,be),Pe),fe)}p.reduce=F;function L(H,Q){let he;const fe={onWillAddFirstListener(){he=H(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};Q||v(fe);const Pe=new i(fe);return Q?.add(Pe),Pe.event}function G(H,Q){return Q instanceof Array?Q.push(H):Q&&Q.add(H),H}function te(H,Q,he=100,fe=!1,Pe=!1,be,Ae){let Ne,Be,V,q=0,Y;const J={leakWarningThreshold:be,onWillAddFirstListener(){Ne=H(we=>{q++,Be=Q(Be,we),fe&&!V&&(ge.fire(Be),Be=void 0),Y=()=>{const Te=Be;Be=void 0,V=void 0,(!fe||q>1)&&ge.fire(Te),q=0},typeof he=="number"?(clearTimeout(V),V=setTimeout(Y,he)):V===void 0&&(V=0,queueMicrotask(Y))})},onWillRemoveListener(){Pe&&q>0&&Y?.()},onDidRemoveLastListener(){Y=void 0,Ne.dispose()}};Ae||v(J);const ge=new i(J);return Ae?.add(ge),ge.event}p.debounce=te;function Z(H,Q=0,he){return p.debounce(H,(fe,Pe)=>fe?(fe.push(Pe),fe):[Pe],Q,void 0,!0,void 0,he)}p.accumulate=Z;function x(H,Q=(fe,Pe)=>fe===Pe,he){let fe=!0,Pe;return T(H,be=>{const Ae=fe||!Q(be,Pe);return fe=!1,Pe=be,Ae},he)}p.latch=x;function _(H,Q,he){return[p.filter(H,Q,he),p.filter(H,fe=>!Q(fe),he)]}p.split=_;function ue(H,Q=!1,he=[],fe){let Pe=he.slice(),be=H(Be=>{Pe?Pe.push(Be):Ne.fire(Be)});fe&&fe.add(be);const Ae=()=>{Pe?.forEach(Be=>Ne.fire(Be)),Pe=null},Ne=new i({onWillAddFirstListener(){be||(be=H(Be=>Ne.fire(Be)),fe&&fe.add(be))},onDidAddFirstListener(){Pe&&(Q?setTimeout(Ae):Ae())},onDidRemoveLastListener(){be&&be.dispose(),be=null}});return fe&&fe.add(Ne),Ne.event}p.buffer=ue;function X(H,Q){return(fe,Pe,be)=>{const Ae=Q(new se);return H(function(Ne){const Be=Ae.evaluate(Ne);Be!==$e&&fe.call(Pe,Be)},void 0,be)}}p.chain=X;const $e=Symbol("HaltChainable");class se{constructor(){this.f=[]}map(Q){return this.f.push(Q),this}forEach(Q){return this.f.push(he=>(Q(he),he)),this}filter(Q){return this.f.push(he=>Q(he)?he:$e),this}reduce(Q,he){let fe=he;return this.f.push(Pe=>(fe=Q(fe,Pe),fe)),this}latch(Q=(he,fe)=>he===fe){let he=!0,fe;return this.f.push(Pe=>{const be=he||!Q(Pe,fe);return he=!1,fe=Pe,be?Pe:$e}),this}evaluate(Q){for(const he of this.f)if(Q=he(Q),Q===$e)break;return Q}}function re(H,Q,he=fe=>fe){const fe=(...Ne)=>Ae.fire(he(...Ne)),Pe=()=>H.on(Q,fe),be=()=>H.removeListener(Q,fe),Ae=new i({onWillAddFirstListener:Pe,onDidRemoveLastListener:be});return Ae.event}p.fromNodeEventEmitter=re;function U(H,Q,he=fe=>fe){const fe=(...Ne)=>Ae.fire(he(...Ne)),Pe=()=>H.addEventListener(Q,fe),be=()=>H.removeEventListener(Q,fe),Ae=new i({onWillAddFirstListener:Pe,onDidRemoveLastListener:be});return Ae.event}p.fromDOMEventEmitter=U;function ie(H){return new Promise(Q=>C(H)(Q))}p.toPromise=ie;function ve(H){const Q=new i;return H.then(he=>{Q.fire(he)},()=>{Q.fire(void 0)}).finally(()=>{Q.dispose()}),Q.event}p.fromPromise=ve;function Ie(H,Q,he){return Q(he),H(fe=>Q(fe))}p.runAndSubscribe=Ie;class le{constructor(Q,he){this._observable=Q,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};he||v(fe),this.emitter=new i(fe),he&&he.add(this.emitter)}beginUpdate(Q){this.f++}handlePossibleChange(Q){}handleChange(Q,he){this.g=!0}endUpdate(Q){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ae(H,Q){return new le(H,Q).emitter.event}p.fromObservable=ae;function ce(H){return(Q,he,fe)=>{let Pe=0,be=!1;const Ae={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(H.reportChanges(),be&&(be=!1,Q.call(he)))},handlePossibleChange(){},handleChange(){be=!0}};H.addObserver(Ae),H.reportChanges();const Ne={dispose(){H.removeObserver(Ae)}};return fe instanceof M.$Tc?fe.add(Ne):Array.isArray(fe)&&fe.push(Ne),Ne}}p.fromObservableLight=ce})(E||(e.Event=E={}));class R{static{this.all=new Set}static{this.f=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${R.f++}`,R.all.add(this)}start(v){this.g=new A.$3d,this.listenerCount=v}stop(){if(this.g){const v=this.g.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.g=void 0}}}e.$5d=R;let I=-1;function w(p){const v=I;return I=p,{dispose(){I=v}}}class S{constructor(v,y=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=y,this.g=0}dispose(){this.f?.clear()}check(v,y){const C=this.threshold;if(C<=0||y<C)return;this.f||(this.f=new Map);const O=this.f.get(v.value)||0;if(this.f.set(v.value,O+1),this.g-=1,this.g<=0){this.g=C*.5;let z,T=0;for(const[B,j]of this.f)(!z||T<j)&&(z=B,T=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${T}):`),console.warn(z)}return()=>{const z=this.f.get(v.value)||0;this.f.set(v.value,z-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class m{constructor(v){this.value=v,this.id=c++}}const a=2,n=(p,v)=>{if(p instanceof m)v(p);else for(let y=0;y<p.length;y++){const C=p[y];C&&v(C)}};class i{constructor(v){this.w=0,this.f=v,this.g=I>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const v=this.t;queueMicrotask(()=>{n(v,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(v,y,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Uc.None;if(this.m)return M.$Uc.None;y&&(v=v.bind(y));const O=new m(v);let z,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=k.create(),z=this.g.check(O.stack,this.w+1)),b&&(O.stack=T??k.create()),this.t?this.t instanceof m?(this.u??=new o,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const B=(0,M.$Sc)(()=>{z?.(),this.x(O)});return C instanceof M.$Tc?C.add(B):Array.isArray(C)&&C.push(B),B},this.q}x(v){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,C=y.indexOf(v);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[C]=void 0;const O=this.u.current===this;if(this.w*a<=y.length){let z=0;for(let T=0;T<y.length;T++)y[T]?y[z++]=y[T]:O&&(this.u.end--,z<this.u.i&&this.u.i--);y.length=z}}y(v,y){if(!v)return;const C=this.f?.onListenerError||u.$1;if(!C){v.value(y);return}try{v.value(y)}catch(O){C(O)}}z(v){const y=v.current.t;for(;v.i<v.end;)this.y(y[v.i++],v.value);v.reset()}fire(v){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,v);else{const y=this.u;y.enqueue(this,v,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=i;const s=()=>new o;e.$8d=s;class o{constructor(){this.i=-1,this.end=0}enqueue(v,y,C){this.i=0,this.end=C,this.current=v,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends i{async fireAsync(v,y,C){if(this.t)for(this.h||(this.h=new P.$5c),n(this.t,O=>this.h.push([O.value,v]));this.h.size>0&&!y.isCancellationRequested;){const[O,z]=this.h.shift(),T=[],B={...z,token:y,waitUntil:j=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");C&&(j=C(j,O)),T.push(j)}};try{O(B)}catch(j){(0,u.$1)(j);continue}Object.freeze(T),await Promise.allSettled(T).then(j=>{for(const F of j)F.status==="rejected"&&(0,u.$1)(F.reason)})}}}e.$9d=t;class d extends i{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new P.$5c,this.A=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.A(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.w&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$0d=d;class h extends d{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$$d=h;class l extends i{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$_d=l;class r{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(v){const y={event:v,listener:null};this.h.push(y),this.g&&this.m(y);const C=()=>{this.g&&this.o(y);const O=this.h.indexOf(y);this.h.splice(O,1)};return(0,M.$Sc)((0,N.$db)(C))}j(){this.g=!0,this.h.forEach(v=>this.m(v))}k(){this.g=!1,this.h.forEach(v=>this.o(v))}m(v){v.listener=v.event(y=>this.f.fire(y))}o(v){v.listener?.dispose(),v.listener=null}dispose(){this.f.dispose();for(const v of this.h)v.listener?.dispose();this.h=[]}}e.$ae=r;class g{constructor(v,y,C,O){this.f=new M.$Tc;const z=this.f.add(new r),T=this.f.add(new M.$4c);function B(j){T.set(j,z.add(O(j)))}for(const j of v)B(j);this.f.add(y(j=>{B(j)})),this.f.add(C(j=>{T.deleteAndDispose(j)})),this.event=z.event}dispose(){this.f.dispose()}}e.$be=g;class f{constructor(){this.f=[]}wrapEvent(v){return(y,C,O)=>v(z=>{const T=this.f[this.f.length-1];T?T.push(()=>y.call(C,z)):y.call(C,z)},void 0,O)}bufferEvents(v){const y=[];this.f.push(y);const C=v();return this.f.pop(),y.forEach(O=>O()),C}}e.$ce=f;class D{constructor(){this.f=!1,this.g=E.None,this.h=M.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(v){this.g=v,this.f&&(this.h.dispose(),this.h=v(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=D}),define(ke[22],Ee([1,0,4]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const N=Object.freeze(function(b,$){const E=setTimeout(b.bind($),0);return{dispose(){clearTimeout(E)}}});var M;(function(b){function $(E){return E===b.None||E===b.Cancelled||E instanceof P?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(M||(e.CancellationToken=M={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new u.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=M.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=M.None}}e.$ee=A}),define(ke[167],Ee([1,0,22]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class N{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new u.$ee,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Pe=N;class M{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Qe=M;class P{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Re=P}),define(ke[98],Ee([1,0,13,3]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=M,e.$ge=P,e.$he=A,e.$ie=b,e.$je=E,e.$ke=R,e.$le=I,e.$me=w,e.$ne=S,e.$oe=k,e.$pe=c,e.$qe=m,e.$re=a,e.$se=n,e.$te=i;function M(s){const o=s;return o?typeof o.read=="function":!1}function P(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}function A(s){const o=s;return o?P(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function b(s,o){return new $(s,o)}class ${constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,u.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let d;switch(o){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const h=d.indexOf(t);h>=0&&d.splice(h,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(s,o){const t=[];let d;for(;(d=s.read())!==null;)t.push(d);return o(t)}function R(s,o,t){const d=[];let h;for(;(h=s.read())!==null&&d.length<t;)d.push(h);return h===null&&d.length>0?o(d):{read:()=>{if(d.length>0)return d.shift();if(typeof h<"u"){const l=h;return h=void 0,l}return s.read()}}}function I(s,o){return new Promise((t,d)=>{const h=[];w(s,{onData:l=>{o&&h.push(l)},onError:l=>{o?d(l):t(void 0)},onEnd:()=>{t(o?o(h):void 0)}})})}function w(s,o,t){s.on("error",d=>{t?.isCancellationRequested||o.onError(d)}),s.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),s.on("data",d=>{t?.isCancellationRequested||o.onData(d)})}function S(s,o){return new Promise((t,d)=>{const h=new N.$Tc,l=[],r=D=>{if(l.push(D),l.length>o)return h.dispose(),s.pause(),t({stream:s,buffer:l,ended:!1})},g=D=>(h.dispose(),d(D)),f=()=>(h.dispose(),t({stream:s,buffer:l,ended:!0}));h.add((0,N.$Sc)(()=>s.removeListener("error",g))),s.on("error",g),h.add((0,N.$Sc)(()=>s.removeListener("end",f))),s.on("end",f),h.add((0,N.$Sc)(()=>s.removeListener("data",r))),s.on("data",r)})}function k(s,o){const t=b(o);return t.end(s),t}function c(){const s=b(()=>{throw new Error("not supported")});return s.end(),s}function m(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}function a(s,o,t){const d=b(t);return w(s,{onData:h=>d.write(o.data(h)),onError:h=>d.error(o.error?o.error(h):h),onEnd:()=>d.end()}),d}function n(s,o,t){let d=!1;return{read:()=>{const h=o.read();return d?h:(d=!0,h!==null?t([s,h]):s)}}}function i(s,o,t){let d=!1;const h=b(t);return w(o,{onData:l=>d?h.write(l):(d=!0,h.write(t([s,l]))),onError:l=>h.error(l),onEnd:()=>{d||(d=!0,h.write(s)),h.end()}}),h}}),define(ke[21],Ee([1,0,44,98]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=E,e.$we=R,e.$xe=I,e.$ye=w,e.$ze=S,e.$Ae=k,e.$Be=c,e.$Ce=m,e.$De=a,e.$Ee=n,e.$Fe=i,e.$Ge=s,e.$He=o,e.$Ie=t,e.$Je=d,e.$Ke=h,e.$Le=l,e.$Me=r,e.$Ne=g,e.$Oe=p;const M=typeof Buffer<"u",P=new u.$V(()=>new Uint8Array(256));let A,b;class ${static alloc(y){return M?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return M&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&M?new $(Buffer.from(y)):(A||(A=new TextEncoder),new $(A.encode(y)))}static fromByteArray(y){const C=$.alloc(y.length);for(let O=0,z=y.length;O<z;O++)C.buffer[O]=y[O];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let T=0,B=y.length;T<B;T++)C+=y[T].byteLength}const O=$.alloc(C);let z=0;for(let T=0,B=y.length;T<B;T++){const j=y[T];O.set(j,z),z+=j.byteLength}return O}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return M?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(y,C){return new $(this.buffer.subarray(y,C))}set(y,C){if(y instanceof $)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return w(this.buffer,y)}writeUInt32BE(y,C){S(this.buffer,y,C)}readUInt32LE(y){return k(this.buffer,y)}writeUInt32LE(y,C){c(this.buffer,y,C)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,C){a(this.buffer,y,C)}indexOf(y,C=0){return E(this.buffer,y instanceof $?y.buffer:y,C)}}e.$ue=$;function E(v,y,C=0){const O=y.byteLength,z=v.byteLength;if(O===0)return 0;if(O===1)return v.indexOf(y[0]);if(O>z-C)return-1;const T=P.value;T.fill(y.length);for(let L=0;L<y.length;L++)T[y[L]]=y.length-L-1;let B=C+y.length-1,j=B,F=-1;for(;B<z;)if(v[B]===y[j]){if(j===0){F=B;break}B--,j--}else B+=Math.max(y.length-j,T[v[B]]),j=y.length-1;return F}function R(v,y){return v[y+0]<<0>>>0|v[y+1]<<8>>>0}function I(v,y,C){v[C+0]=y&255,y=y>>>8,v[C+1]=y&255}function w(v,y){return v[y]*2**24+v[y+1]*2**16+v[y+2]*2**8+v[y+3]}function S(v,y,C){v[C+3]=y,y=y>>>8,v[C+2]=y,y=y>>>8,v[C+1]=y,y=y>>>8,v[C]=y}function k(v,y){return v[y+0]<<0>>>0|v[y+1]<<8>>>0|v[y+2]<<16>>>0|v[y+3]<<24>>>0}function c(v,y,C){v[C+0]=y&255,y=y>>>8,v[C+1]=y&255,y=y>>>8,v[C+2]=y&255,y=y>>>8,v[C+3]=y&255}function m(v,y){return v[y]}function a(v,y,C){v[C]=y}function n(v){return N.$je(v,y=>$.concat(y))}function i(v){return N.$qe(v)}function s(v){return N.$le(v,y=>$.concat(y))}async function o(v){return v.ended?$.concat(v.buffer):$.concat([...v.buffer,await s(v.stream)])}function t(v){return N.$oe(v,y=>$.concat(y))}function d(v){return N.$re(v,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}function h(v){return N.$ie(y=>$.concat(y),v)}function l(v,y){return N.$se(v,y,C=>$.concat(C))}function r(v,y){return N.$te(v,y,C=>$.concat(C))}function g(v){let y=0,C=0,O=0;const z=new Uint8Array(Math.floor(v.length/4*3)),T=j=>{switch(C){case 3:z[O++]=y|j,C=0;break;case 2:z[O++]=y|j>>>2,y=j<<6,C=3;break;case 1:z[O++]=y|j>>>4,y=j<<4,C=2;break;default:y=j<<2,C=1}};for(let j=0;j<v.length;j++){const F=v.charCodeAt(j);if(F>=65&&F<=90)T(F-65);else if(F>=97&&F<=122)T(F-97+26);else if(F>=48&&F<=57)T(F-48+52);else if(F===43||F===45)T(62);else if(F===47||F===95)T(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${v[j]}`)}}const B=O;for(;C>0;)T(0);return $.wrap(z).slice(0,B)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:v},y=!0,C=!1){const O=C?D:f;let z="";const T=v.byteLength%3;let B=0;for(;B<v.byteLength-T;B+=3){const j=v[B+0],F=v[B+1],L=v[B+2];z+=O[j>>>2],z+=O[(j<<4|F>>>4)&63],z+=O[(F<<2|L>>>6)&63],z+=O[L&63]}if(T===1){const j=v[B+0];z+=O[j>>>2],z+=O[j<<4&63],y&&(z+="==")}else if(T===2){const j=v[B+0],F=v[B+1];z+=O[j>>>2],z+=O[(j<<4|F>>>4)&63],z+=O[F<<2&63],y&&(z+="=")}return z}}),define(ke[14],Ee([1,0,167,44]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.GraphemeBreakType=e.$Hf=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=M,e.$Ve=A,e.$We=$,e.$Xe=E,e.$Ye=R,e.$Ze=I,e.$1e=w,e.$2e=S,e.$3e=k,e.$4e=c,e.$5e=m,e.$6e=a,e.$7e=n,e.$8e=i,e.$9e=s,e.$0e=o,e.$$e=t,e.$_e=d,e.$af=h,e.$bf=l,e.$cf=r,e.$df=g,e.$ef=f,e.$ff=D,e.$gf=p,e.$hf=v,e.$if=y,e.$jf=C,e.$kf=O,e.$lf=z,e.$mf=T,e.$nf=B,e.$of=j,e.$pf=F,e.$qf=L,e.$rf=G,e.$sf=te,e.$vf=ue,e.$wf=X,e.$xf=$e,e.$yf=se,e.$zf=ie,e.$Af=Ie,e.$Cf=le,e.$Df=ae,e.$Ef=ce,e.$Ff=H,e.$Gf=fe,e.$If=Pe,e.$Jf=be,e.$Kf=Ae,e.$Lf=Ne,e.$Mf=Be,e.$Nf=V,e.$Of=q,e.$Pf=Y,e.$Qf=He;function M(Ce){return!Ce||typeof Ce!="string"?!0:Ce.trim().length===0}const P=/{(\d+)}/g;function A(Ce,...ze){return ze.length===0?Ce:Ce.replace(P,function(Me,Ge){const ne=parseInt(Ge,10);return isNaN(ne)||ne<0||ne>=ze.length?Me:ze[ne]})}const b=/{([^}]+)}/g;function $(Ce,ze){return Object.keys(ze).length===0?Ce:Ce.replace(b,(Me,Ge)=>ze[Ge]??Me)}function E(Ce){return Ce.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function R(Ce){return Ce.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function I(Ce){return Ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(Ce,ze){let Me=0;const Ge=ze.charCodeAt(0);for(let ne=Ce.length-1;ne>=0;ne--)Ce.charCodeAt(ne)===Ge&&Me++;return Me}function S(Ce,ze,Me="\u2026"){return Ce.length<=ze?Ce:`${Ce.substr(0,ze)}${Me}`}function k(Ce,ze,Me="\u2026"){if(Ce.length<=ze)return Ce;const Ge=Math.ceil(ze/2)-Me.length/2,ne=Math.floor(ze/2)-Me.length/2;return`${Ce.substr(0,Ge)}${Me}${Ce.substr(Ce.length-ne)}`}function c(Ce,ze=" "){const Me=m(Ce,ze);return a(Me,ze)}function m(Ce,ze){if(!Ce||!ze)return Ce;const Me=ze.length;if(Me===0||Ce.length===0)return Ce;let Ge=0;for(;Ce.indexOf(ze,Ge)===Ge;)Ge=Ge+Me;return Ce.substring(Ge)}function a(Ce,ze){if(!Ce||!ze)return Ce;const Me=ze.length,Ge=Ce.length;if(Me===0||Ge===0)return Ce;let ne=Ge,oe=-1;for(;oe=Ce.lastIndexOf(ze,ne-1),!(oe===-1||oe+Me!==ne);){if(oe===0)return"";ne=oe}return Ce.substring(0,ne)}function n(Ce){return Ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Ce){return Ce.replace(/\*/g,"")}function s(Ce,ze,Me={}){if(!Ce)throw new Error("Cannot create regex from empty string");ze||(Ce=I(Ce)),Me.wholeWord&&(/\B/.test(Ce.charAt(0))||(Ce="\\b"+Ce),/\B/.test(Ce.charAt(Ce.length-1))||(Ce=Ce+"\\b"));let Ge="";return Me.global&&(Ge+="g"),Me.matchCase||(Ge+="i"),Me.multiline&&(Ge+="m"),Me.unicode&&(Ge+="u"),new RegExp(Ce,Ge)}function o(Ce){return Ce.source==="^"||Ce.source==="^$"||Ce.source==="$"||Ce.source==="^\\s*$"?!1:!!(Ce.exec("")&&Ce.lastIndex===0)}function t(Ce){return Ce.split(/\r\n|\r|\n/)}function d(Ce){const ze=[],Me=Ce.split(/(\r\n|\r|\n)/);for(let Ge=0;Ge<Math.ceil(Me.length/2);Ge++)ze.push(Me[2*Ge]+(Me[2*Ge+1]??""));return ze}function h(Ce){for(let ze=0,Me=Ce.length;ze<Me;ze++){const Ge=Ce.charCodeAt(ze);if(Ge!==32&&Ge!==9)return ze}return-1}function l(Ce,ze=0,Me=Ce.length){for(let Ge=ze;Ge<Me;Ge++){const ne=Ce.charCodeAt(Ge);if(ne!==32&&ne!==9)return Ce.substring(ze,Ge)}return Ce.substring(ze,Me)}function r(Ce,ze=Ce.length-1){for(let Me=ze;Me>=0;Me--){const Ge=Ce.charCodeAt(Me);if(Ge!==32&&Ge!==9)return Me}return-1}function g(Ce,ze,Me){const Ge=[];let ne=0;for(const oe of Ce.matchAll(ze)){if(Ge.push(Ce.slice(ne,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ne=oe.index+oe[0].length,Ge.push(Me(oe[0],...oe.slice(1),oe.index,Ce,oe.groups))}return Ge.push(Ce.slice(ne)),Promise.all(Ge).then(oe=>oe.join(""))}function f(Ce,ze){return Ce<ze?-1:Ce>ze?1:0}function D(Ce,ze,Me=0,Ge=Ce.length,ne=0,oe=ze.length){for(;Me<Ge&&ne<oe;Me++,ne++){const xe=Ce.charCodeAt(Me),st=ze.charCodeAt(ne);if(xe<st)return-1;if(xe>st)return 1}const De=Ge-Me,Ke=oe-ne;return De<Ke?-1:De>Ke?1:0}function p(Ce,ze){return v(Ce,ze,0,Ce.length,0,ze.length)}function v(Ce,ze,Me=0,Ge=Ce.length,ne=0,oe=ze.length){for(;Me<Ge&&ne<oe;Me++,ne++){let xe=Ce.charCodeAt(Me),st=ze.charCodeAt(ne);if(xe===st)continue;if(xe>=128||st>=128)return D(Ce.toLowerCase(),ze.toLowerCase(),Me,Ge,ne,oe);C(xe)&&(xe-=32),C(st)&&(st-=32);const je=xe-st;if(je!==0)return je}const De=Ge-Me,Ke=oe-ne;return De<Ke?-1:De>Ke?1:0}function y(Ce){return Ce>=48&&Ce<=57}function C(Ce){return Ce>=97&&Ce<=122}function O(Ce){return Ce>=65&&Ce<=90}function z(Ce,ze){return Ce.length===ze.length&&v(Ce,ze)===0}function T(Ce,ze){const Me=ze.length;return ze.length>Ce.length?!1:v(Ce,ze,0,Me)===0}function B(Ce,ze){const Me=Math.min(Ce.length,ze.length);let Ge;for(Ge=0;Ge<Me;Ge++)if(Ce.charCodeAt(Ge)!==ze.charCodeAt(Ge))return Ge;return Me}function j(Ce,ze){const Me=Math.min(Ce.length,ze.length);let Ge;const ne=Ce.length-1,oe=ze.length-1;for(Ge=0;Ge<Me;Ge++)if(Ce.charCodeAt(ne-Ge)!==ze.charCodeAt(oe-Ge))return Ge;return Me}function F(Ce){return 55296<=Ce&&Ce<=56319}function L(Ce){return 56320<=Ce&&Ce<=57343}function G(Ce,ze){return(Ce-55296<<10)+(ze-56320)+65536}function te(Ce,ze,Me){const Ge=Ce.charCodeAt(Me);if(F(Ge)&&Me+1<ze){const ne=Ce.charCodeAt(Me+1);if(L(ne))return G(Ge,ne)}return Ge}function Z(Ce,ze){const Me=Ce.charCodeAt(ze-1);if(L(Me)&&ze>1){const Ge=Ce.charCodeAt(ze-2);if(F(Ge))return G(Ge,Me)}return Me}class x{get offset(){return this.e}constructor(ze,Me=0){this.c=ze,this.d=ze.length,this.e=Me}setOffset(ze){this.e=ze}prevCodePoint(){const ze=Z(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=te(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$tf=x;class _{get offset(){return this.c.offset}constructor(ze,Me=0){this.c=new x(ze,Me)}nextGraphemeLength(){const ze=we.getInstance(),Me=this.c,Ge=Me.offset;let ne=ze.getGraphemeBreakType(Me.nextCodePoint());for(;!Me.eol();){const oe=Me.offset,De=ze.getGraphemeBreakType(Me.nextCodePoint());if(J(ne,De)){Me.setOffset(oe);break}ne=De}return Me.offset-Ge}prevGraphemeLength(){const ze=we.getInstance(),Me=this.c,Ge=Me.offset;let ne=ze.getGraphemeBreakType(Me.prevCodePoint());for(;Me.offset>0;){const oe=Me.offset,De=ze.getGraphemeBreakType(Me.prevCodePoint());if(J(De,ne)){Me.setOffset(oe);break}ne=De}return Ge-Me.offset}eol(){return this.c.eol()}}e.$uf=_;function ue(Ce,ze){return new _(Ce,ze).nextGraphemeLength()}function X(Ce,ze){return new _(Ce,ze).prevGraphemeLength()}function $e(Ce,ze){ze>0&&L(Ce.charCodeAt(ze))&&ze--;const Me=ze+ue(Ce,ze);return[Me-X(Ce,Me),Me]}function se(Ce){const ze=new _(Ce);let Me=0;for(;!ze.eol();)Me++,ze.nextGraphemeLength();return Me}let re;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(Ce){return re||(re=U()),re.test(Ce)}const ve=/^[\t\n\r\x20-\x7E]*$/;function Ie(Ce){return ve.test(Ce)}e.$Bf=/[\u2028\u2029]/;function le(Ce){return e.$Bf.test(Ce)}function ae(Ce){return Ce>=11904&&Ce<=55215||Ce>=63744&&Ce<=64255||Ce>=65281&&Ce<=65374}function ce(Ce){return Ce>=127462&&Ce<=127487||Ce===8986||Ce===8987||Ce===9200||Ce===9203||Ce>=9728&&Ce<=10175||Ce===11088||Ce===11093||Ce>=127744&&Ce<=128591||Ce>=128640&&Ce<=128764||Ce>=128992&&Ce<=129008||Ce>=129280&&Ce<=129535||Ce>=129648&&Ce<=129782}function H(Ce,ze,Me=""){const Ge=Ce.trimStart();if(Ge.length<ze)return Ge;const ne=/\b/g;let oe=0;for(;ne.test(Ge)&&!(Ge.length-ne.lastIndex<ze);)oe=ne.lastIndex,ne.lastIndex+=1;return oe===0?Ge:Me+Ge.substring(oe).trimStart()}const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function fe(Ce){return Ce&&(Ce=Ce.replace(Q,"").replace(he,"")),Ce}e.$Hf="\uFEFF";function Pe(Ce){return!!(Ce&&Ce.length>0&&Ce.charCodeAt(0)===65279)}function be(Ce){return Pe(Ce)?Ce.substr(1):Ce}function Ae(Ce,ze){if(!Ce||!ze||Ce.length<ze.length)return!1;const Me=ze.length,Ge=Ce.toLowerCase();let ne=0,oe=-1;for(;ne<Me;){const De=Ge.indexOf(ze[ne],oe+1);if(De<0)return!1;oe=De,ne++}return!0}function Ne(Ce,ze=!1){return Ce?(ze&&(Ce=Ce.replace(/\\./g,"")),Ce.toLowerCase()!==Ce):!1}function Be(Ce){return Ce.charAt(0).toUpperCase()+Ce.slice(1)}function V(Ce,ze=1){if(ze===0)return"";let Me=-1;do Me=Ce.indexOf(`
`,Me+1),ze--;while(ze>0&&Me>=0);return Me===-1?Ce:(Ce[Me-1]==="\r"&&Me--,Ce.substr(0,Me))}function q(Ce){return Ce=Ce%(2*26),Ce<26?String.fromCharCode(97+Ce):String.fromCharCode(65+Ce-26)}function Y(Ce){return we.getInstance().getGraphemeBreakType(Ce)}function J(Ce,ze){return Ce===0?ze!==5&&ze!==7:Ce===2&&ze===3?!1:Ce===4||Ce===2||Ce===3||ze===4||ze===2||ze===3?!0:!(Ce===8&&(ze===8||ze===9||ze===11||ze===12)||(Ce===11||Ce===9)&&(ze===9||ze===10)||(Ce===12||Ce===10)&&ze===10||ze===5||ze===13||ze===7||Ce===1||Ce===13&&ze===14||Ce===6&&ze===6)}var ge;(function(Ce){Ce[Ce.Other=0]="Other",Ce[Ce.Prepend=1]="Prepend",Ce[Ce.CR=2]="CR",Ce[Ce.LF=3]="LF",Ce[Ce.Control=4]="Control",Ce[Ce.Extend=5]="Extend",Ce[Ce.Regional_Indicator=6]="Regional_Indicator",Ce[Ce.SpacingMark=7]="SpacingMark",Ce[Ce.L=8]="L",Ce[Ce.V=9]="V",Ce[Ce.T=10]="T",Ce[Ce.LV=11]="LV",Ce[Ce.LVT=12]="LVT",Ce[Ce.ZWJ=13]="ZWJ",Ce[Ce.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Te()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Me=this.d,Ge=Me.length/3;let ne=1;for(;ne<=Ge;)if(ze<Me[3*ne])ne=2*ne;else if(ze>Me[3*ne+1])ne=2*ne+1;else return Me[3*ne+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ce,ze){if(Ce===0)return 0;const Me=Xe(Ce,ze);if(Me!==void 0)return Me;const Ge=new x(ze,Ce);return Ge.prevCodePoint(),Ge.offset}function Xe(Ce,ze){const Me=new x(ze,Ce);let Ge=Me.prevCodePoint();for(;tt(Ge)||Ge===65039||Ge===8419;){if(Me.offset===0)return;Ge=Me.prevCodePoint()}if(!ce(Ge))return;let ne=Me.offset;return ne>0&&Me.prevCodePoint()===8205&&(ne=Me.offset),ne}function tt(Ce){return 127995<=Ce&&Ce<=127999}var nt;(function(Ce){Ce[Ce.zwj=8205]="zwj",Ce[Ce.emojiVariantSelector=65039]="emojiVariantSelector",Ce[Ce.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Rf="\xA0";class at{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Qe(ze=>{function Me(je){const bt=new Map;for(let vt=0;vt<je.length;vt+=2)bt.set(je[vt],je[vt+1]);return bt}function Ge(je,bt){const vt=new Map(je);for(const[Lt,Bt]of bt)vt.set(Lt,Bt);return vt}function ne(je,bt){if(!je)return bt;const vt=new Map;for(const[Lt,Bt]of je)bt.has(Lt)&&vt.set(Lt,Bt);return vt}const oe=this.c.value;let De=ze.filter(je=>!je.startsWith("_")&&je in oe);De.length===0&&(De=["_default"]);let Ke;for(const je of De){const bt=Me(oe[je]);Ke=ne(Ke,bt)}const xe=Me(oe._common),st=Ge(xe,Ke);return new at(st)})}static getInstance(ze){return at.d.get(Array.from(ze))}static{this.e=new N.$V(()=>Object.keys(at.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return at.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Sf=at;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(ze){return rt.e().has(ze)}static get codePoints(){return rt.e()}}e.$Tf=rt}),define(ke[126],Ee([1,0,28,165,14]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.FuzzyScore=e.$jk=e.$ik=void 0,e.or=P,e.$kk=b,e.$lk=$,e.$mk=I,e.$nk=g,e.$ok=f,e.$pk=O,e.$qk=z,e.$rk=T,e.$sk=B,e.$tk=ie,e.$vk=ae,e.$wk=Q,e.$xk=he;function P(...be){return function(Ae,Ne){for(let Be=0,V=be.length;Be<V;Be++){const q=be[Be](Ae,Ne);if(q)return q}return null}}e.$ik=A.bind(void 0,!1),e.$jk=A.bind(void 0,!0);function A(be,Ae,Ne){if(!Ne||Ne.length<Ae.length)return null;let Be;return be?Be=M.$mf(Ne,Ae):Be=Ne.indexOf(Ae)===0,Be?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function b(be,Ae){const Ne=Ae.toLowerCase().indexOf(be.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+be.length}]}function $(be,Ae){return E(be.toLowerCase(),Ae.toLowerCase(),0,0)}function E(be,Ae,Ne,Be){if(Ne===be.length)return[];if(Be===Ae.length)return null;if(be[Ne]===Ae[Be]){let V=null;return(V=E(be,Ae,Ne+1,Be+1))?s({start:Be,end:Be+1},V):null}return E(be,Ae,Ne,Be+1)}function R(be){return 97<=be&&be<=122}function I(be){return 65<=be&&be<=90}function w(be){return 48<=be&&be<=57}function S(be){return be===32||be===9||be===10||be===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(be=>k.add(be.charCodeAt(0)));function c(be){return S(be)||k.has(be)}function m(be,Ae){return be===Ae||c(be)&&c(Ae)}const a=new Map;function n(be){if(a.has(be))return a.get(be);let Ae;const Ne=(0,N.$gk)(be);return Ne&&(Ae=Ne),a.set(be,Ae),Ae}function i(be){return R(be)||I(be)||w(be)}function s(be,Ae){return Ae.length===0?Ae=[be]:be.end===Ae[0].start?Ae[0].start=be.start:Ae.unshift(be),Ae}function o(be,Ae){for(let Ne=Ae;Ne<be.length;Ne++){const Be=be.charCodeAt(Ne);if(I(Be)||w(Be)||Ne>0&&!i(be.charCodeAt(Ne-1)))return Ne}return be.length}function t(be,Ae,Ne,Be){if(Ne===be.length)return[];if(Be===Ae.length)return null;if(be[Ne]!==Ae[Be].toLowerCase())return null;{let V=null,q=Be+1;for(V=t(be,Ae,Ne+1,Be+1);!V&&(q=o(Ae,q))<Ae.length;)V=t(be,Ae,Ne+1,q),q++;return V===null?null:s({start:Be,end:Be+1},V)}}function d(be){let Ae=0,Ne=0,Be=0,V=0,q=0;for(let Te=0;Te<be.length;Te++)q=be.charCodeAt(Te),I(q)&&Ae++,R(q)&&Ne++,i(q)&&Be++,w(q)&&V++;const Y=Ae/be.length,J=Ne/be.length,ge=Be/be.length,we=V/be.length;return{upperPercent:Y,lowerPercent:J,alphaPercent:ge,numericPercent:we}}function h(be){const{upperPercent:Ae,lowerPercent:Ne}=be;return Ne===0&&Ae>.6}function l(be){const{upperPercent:Ae,lowerPercent:Ne,alphaPercent:Be,numericPercent:V}=be;return Ne>.2&&Ae<.8&&Be>.6&&V<.2}function r(be){let Ae=0,Ne=0,Be=0,V=0;for(let q=0;q<be.length;q++)Be=be.charCodeAt(q),I(Be)&&Ae++,R(Be)&&Ne++,S(Be)&&V++;return(Ae===0||Ne===0)&&V===0?be.length<=30:Ae<=5}function g(be,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!r(be))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Ne=d(Ae);if(!l(Ne)){if(!h(Ne))return null;Ae=Ae.toLowerCase()}let Be=null,V=0;for(be=be.toLowerCase();V<Ae.length&&(Be=t(be,Ae,0,V))===null;)V=o(Ae,V+1);return Be}function f(be,Ae,Ne=!1){if(!Ae||Ae.length===0)return null;let Be=null,V=0;for(be=be.toLowerCase(),Ae=Ae.toLowerCase();V<Ae.length&&(Be=D(be,Ae,0,V,Ne),Be===null);)V=p(Ae,V+1);return Be}function D(be,Ae,Ne,Be,V){let q=0;if(Ne===be.length)return[];if(Be===Ae.length)return null;if(!m(be.charCodeAt(Ne),Ae.charCodeAt(Be))){const ge=n(be.charCodeAt(Ne));if(!ge)return null;for(let we=0;we<ge.length;we++)if(!m(ge[we],Ae.charCodeAt(Be+we)))return null;q+=ge.length-1}let Y=null,J=Be+q+1;if(Y=D(be,Ae,Ne+1,J,V),!V)for(;!Y&&(J=p(Ae,J))<Ae.length;)Y=D(be,Ae,Ne+1,J,V),J++;if(!Y)return null;if(be.charCodeAt(Ne)!==Ae.charCodeAt(Be)){const ge=n(be.charCodeAt(Ne));if(!ge)return Y;for(let we=0;we<ge.length;we++)if(ge[we]!==Ae.charCodeAt(Be+we))return Y}return s({start:Be,end:Be+q+1},Y)}function p(be,Ae){for(let Ne=Ae;Ne<be.length;Ne++)if(c(be.charCodeAt(Ne))||Ne>0&&c(be.charCodeAt(Ne-1)))return Ne;return be.length}const v=P(e.$jk,g,b),y=P(e.$jk,g,$),C=new u.$Ec(1e4);function O(be,Ae,Ne=!1){if(typeof be!="string"||typeof Ae!="string")return null;let Be=C.get(be);Be||(Be=new RegExp(M.$7e(be),"i"),C.set(be,Be));const V=Be.exec(Ae);return V?[{start:V.index,end:V.index+V[0].length}]:Ne?y(be,Ae):v(be,Ae)}function z(be,Ae){const Ne=ae(be,be.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?B(Ne):null}function T(be,Ae,Ne,Be,V,q){const Y=Math.min(13,be.length);for(;Ne<Y;Ne++){const J=ae(be,Ae,Ne,Be,V,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,q]}function B(be){if(typeof be>"u")return[];const Ae=[],Ne=be[1];for(let Be=be.length-1;Be>1;Be--){const V=be[Be]+Ne,q=Ae[Ae.length-1];q&&q.end===V?q.end=V+1:Ae.push({start:V,end:V+1})}return Ae}const j=128;function F(){const be=[],Ae=[];for(let Ne=0;Ne<=j;Ne++)Ae[Ne]=0;for(let Ne=0;Ne<=j;Ne++)be.push(Ae.slice(0));return be}function L(be){const Ae=[];for(let Ne=0;Ne<=be;Ne++)Ae[Ne]=0;return Ae}const G=L(2*j),te=L(2*j),Z=F(),x=F(),_=F(),ue=!1;function X(be,Ae,Ne,Be,V){function q(J,ge,we=" "){for(;J.length<ge;)J=we+J;return J}let Y=` |   |${Be.split("").map(J=>q(J,3)).join("|")}
`;for(let J=0;J<=Ne;J++)J===0?Y+=" |":Y+=`${Ae[J-1]}|`,Y+=be[J].slice(0,V+1).map(ge=>q(ge.toString(),3)).join("|")+`
`;return Y}function $e(be,Ae,Ne,Be){be=be.substr(Ae),Ne=Ne.substr(Be),console.log(X(x,be,be.length,Ne,Ne.length)),console.log(X(_,be,be.length,Ne,Ne.length)),console.log(X(Z,be,be.length,Ne,Ne.length))}function se(be,Ae){if(Ae<0||Ae>=be.length)return!1;const Ne=be.codePointAt(Ae);switch(Ne){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Ef(Ne)}}function re(be,Ae){if(Ae<0||Ae>=be.length)return!1;switch(be.charCodeAt(Ae)){case 32:case 9:return!0;default:return!1}}function U(be,Ae,Ne){return Ae[be]!==Ne[be]}function ie(be,Ae,Ne,Be,V,q,Y=!1){for(;Ae<Ne&&V<q;)be[Ae]===Be[V]&&(Y&&(G[Ae]=V),Ae+=1),V+=1;return Ae===Ne}var ve;(function(be){be[be.Diag=1]="Diag",be[be.Left=2]="Left",be[be.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Ie;(function(be){be.Default=[-100,0];function Ae(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}be.isDefault=Ae})(Ie||(e.FuzzyScore=Ie={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Ne){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Ne}}e.$uk=le;function ae(be,Ae,Ne,Be,V,q,Y=le.default){const J=be.length>j?j:be.length,ge=Be.length>j?j:Be.length;if(Ne>=J||q>=ge||J-Ne>ge-q||!ie(Ae,Ne,J,V,q,ge,!0))return;ce(J,ge,Ne,q,Ae,V);let we=1,Te=1,He=Ne,Xe=q;const tt=[!1];for(we=1,He=Ne;He<J;we++,He++){const ze=G[He],Me=te[He],Ge=He+1<J?te[He+1]:ge;for(Te=ze-q+1,Xe=ze;Xe<Ge;Te++,Xe++){let ne=Number.MIN_SAFE_INTEGER,oe=!1;Xe<=Me&&(ne=H(be,Ae,He,Ne,Be,V,Xe,ge,q,Z[we-1][Te-1]===0,tt));let De=0;ne!==Number.MAX_SAFE_INTEGER&&(oe=!0,De=ne+x[we-1][Te-1]);const Ke=Xe>ze,xe=Ke?x[we][Te-1]+(Z[we][Te-1]>0?-5:0):0,st=Xe>ze+1&&Z[we][Te-1]>0,je=st?x[we][Te-2]+(Z[we][Te-2]>0?-5:0):0;if(st&&(!Ke||je>=xe)&&(!oe||je>=De))x[we][Te]=je,_[we][Te]=3,Z[we][Te]=0;else if(Ke&&(!oe||xe>=De))x[we][Te]=xe,_[we][Te]=2,Z[we][Te]=0;else if(oe)x[we][Te]=De,_[we][Te]=1,Z[we][Te]=Z[we-1][Te-1]+1;else throw new Error("not possible")}}if(ue&&$e(be,Ne,Be,q),!tt[0]&&!Y.firstMatchCanBeWeak)return;we--,Te--;const nt=[x[we][Te],q];let at=0,rt=0;for(;we>=1;){let ze=Te;do{const Me=_[we][ze];if(Me===3)ze=ze-2;else if(Me===2)ze=ze-1;else break}while(ze>=1);at>1&&Ae[Ne+we-1]===V[q+Te-1]&&!U(ze+q-1,Be,V)&&at+1>Z[we][ze]&&(ze=Te),ze===Te?at++:at=1,rt||(rt=ze),we--,Te=ze-1,nt.push(Te)}ge===J&&Y.boostFullMatch&&(nt[0]+=2);const Ce=rt-J;return nt[0]-=Ce,nt}function ce(be,Ae,Ne,Be,V,q){let Y=be-1,J=Ae-1;for(;Y>=Ne&&J>=Be;)V[Y]===q[J]&&(te[Y]=J,Y--),J--}function H(be,Ae,Ne,Be,V,q,Y,J,ge,we,Te){if(Ae[Ne]!==q[Y])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return Y===Ne-Be?He=be[Ne]===V[Y]?7:5:U(Y,V,q)&&(Y===0||!U(Y-1,V,q))?(He=be[Ne]===V[Y]?7:5,Xe=!0):se(q,Y)&&(Y===0||!se(q,Y-1))?He=5:(se(q,Y-1)||re(q,Y-1))&&(He=5,Xe=!0),He>1&&Ne===Be&&(Te[0]=!0),Xe||(Xe=U(Y,V,q)||se(q,Y-1)||re(q,Y-1)),Ne===Be?Y>ge&&(He-=Xe?3:5):we?He+=Xe?2:0:He+=Xe?0:1,Y+1===J&&(He-=Xe?3:5),He}function Q(be,Ae,Ne,Be,V,q,Y){return fe(be,Ae,Ne,Be,V,q,!0,Y)}function he(be,Ae,Ne,Be,V,q,Y){return fe(be,Ae,Ne,Be,V,q,!1,Y)}function fe(be,Ae,Ne,Be,V,q,Y,J){let ge=ae(be,Ae,Ne,Be,V,q,J);if(ge&&!Y)return ge;if(be.length>=3){const we=Math.min(7,be.length-1);for(let Te=Ne+1;Te<we;Te++){const He=Pe(be,Te);if(He){const Xe=ae(He,He.toLowerCase(),Ne,Be,V,q,J);Xe&&(Xe[0]-=3,(!ge||Xe[0]>ge[0])&&(ge=Xe))}}}return ge}function Pe(be,Ae){if(Ae+1>=be.length)return;const Ne=be[Ae],Be=be[Ae+1];if(Ne!==Be)return be.slice(0,Ae)+Be+Ne+be.slice(Ae+2)}}),define(ke[55],Ee([1,0,14]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$_i=void 0,e.$8i=N,e.$9i=M,e.$0i=P,e.$$i=b,e.$aj=c;function N(a){return M(a,0)}function M(a,n){switch(typeof a){case"object":return a===null?P(349,n):Array.isArray(a)?$(a,n):E(a,n);case"string":return b(a,n);case"boolean":return A(a,n);case"number":return P(a,n);case"undefined":return P(937,n);default:return P(617,n)}}function P(a,n){return(n<<5)-n+a|0}function A(a,n){return P(a?433:863,n)}function b(a,n){n=P(149417,n);for(let i=0,s=a.length;i<s;i++)n=P(a.charCodeAt(i),n);return n}function $(a,n){return n=P(104579,n),a.reduce((i,s)=>M(s,i),n)}function E(a,n){return n=P(181387,n),Object.keys(a).sort().reduce((i,s)=>(i=b(s,i),M(a[s],i)),n)}class R{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=M(n,this.g),this.g}}e.$_i=R;var I;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(a,n,i=32){const s=i-n,o=~((1<<s)-1);return(a<<n|(o&a)>>>s)>>>0}function S(a,n=0,i=a.byteLength,s=0){for(let o=0;o<i;o++)a[n+o]=s}function k(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function c(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):k((a>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const s=this.p;let o=this.r,t=this.u,d,h;for(t!==0?(d=t,h=-1,t=0):(d=n.charCodeAt(0),h=0);;){let l=d;if(u.$pf(d))if(h+1<i){const r=n.charCodeAt(h+1);u.$qf(r)?(h++,l=u.$rf(d,r)):l=65533}else{t=d;break}else u.$qf(d)&&(l=65533);if(o=this.w(s,o,l),h++,h<i)d=n.charCodeAt(h);else break}this.r=o,this.u=t}w(n,i,s){return s<128?n[i++]=s:s<2048?(n[i++]=192|(s&1984)>>>6,n[i++]=128|(s&63)>>>0):s<65536?(n[i++]=224|(s&61440)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0):(n[i++]=240|(s&1835008)>>>18,n[i++]=128|(s&258048)>>>12,n[i++]=128|(s&4032)>>>6,n[i++]=128|(s&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let f=0;f<64;f+=4)n.setUint32(f,i.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)n.setUint32(f,w(n.getUint32(f-12,!1)^n.getUint32(f-32,!1)^n.getUint32(f-56,!1)^n.getUint32(f-64,!1),1),!1);let s=this.h,o=this.l,t=this.m,d=this.n,h=this.o,l,r,g;for(let f=0;f<80;f++)f<20?(l=o&t|~o&d,r=1518500249):f<40?(l=o^t^d,r=1859775393):f<60?(l=o&t|o&d|t&d,r=2400959708):(l=o^t^d,r=3395469782),g=w(s,5)+l+h+r+n.getUint32(f*4,!1)&4294967295,h=d,d=t,t=w(o,30),o=s,s=g;this.h=this.h+s&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+d&4294967295,this.o=this.o+h&4294967295}}e.$bj=m}),define(ke[39],Ee([1,0,14]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(N||(N={})),function(M){const P="error",A="warning",b="warn",$="info",E="ignore";function R(w){return w?u.$lf(P,w)?M.Error:u.$lf(A,w)||u.$lf(b,w)?M.Warning:u.$lf($,w)?M.Info:M.Ignore:M.Ignore}M.fromValue=R;function I(w){switch(w){case M.Error:return P;case M.Warning:return A;case M.Info:return $;default:return E}}M.toString=I}(N||(N={})),e.default=N}),define(ke[168],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(ke[76],Ee([1,0,19,14]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class M{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const k=S.charCodeAt(0),c=this.b.charCodeAt(this.c);return k-c}value(){return this.b[this.c]}}e.$ji=M;class P{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,N.$ff)(S,this.b,0,S.length,this.c,this.d):(0,N.$hf)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=P;class A{constructor(S=!0,k=!0){this.f=S,this.g=k}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let k=S.length-1;k>=0;k--,this.c--){const c=this.b.charCodeAt(k);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,N.$ff)(S,this.b,0,S.length,this.d,this.e):(0,N.$hf)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=A;var b;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(S,k){this.f=S,this.g=k,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,N.$gf)(S,this.c.scheme);if(this.d[this.e]===2)return(0,N.$gf)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,N.$ef)(S,this.c.query);if(this.d[this.e]===5)return(0,N.$ef)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=$;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(R||(R={}));class I{static forUris(S=()=>!1,k=()=>!1){return new I(new $(S,k))}static forPaths(S=!1){return new I(new A(void 0,!S))}static forStrings(){return new I(new M)}static forConfigKeys(){return new I(new P)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,k){if(k){const c=k.slice(0);(0,u.$Xb)(c);for(const m of c)this.set(m,S)}else{const c=S.slice(0);(0,u.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(S,k){const c=this.b.reset(S);let m;this.c||(this.c=new E,this.c.segment=c.value());const a=[];for(m=this.c;;){const i=c.cmp(m.segment);if(i>0)m.left||(m.left=new E,m.left.segment=c.value()),a.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new E,m.right.segment=c.value()),a.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new E,m.mid.segment=c.value()),a.push([0,m]),m=m.mid;else break}const n=m.value;m.value=k,m.key=S;for(let i=a.length-1;i>=0;i--){const s=a[i][1];s.updateHeight();const o=s.balanceFactor();if(o<-1||o>1){const t=a[i][0],d=a[i+1][0];if(t===1&&d===1)a[i][1]=s.rotateLeft();else if(t===-1&&d===-1)a[i][1]=s.rotateRight();else if(t===1&&d===-1)s.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=s.rotateLeft();else if(t===-1&&d===1)s.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=s.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(S){return this.d(S)?.value}d(S){const k=this.b.reset(S);let c=this.c;for(;c;){const m=k.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(k.hasNext())k.next(),c=c.mid;else break}return c}has(S){const k=this.d(S);return!(k?.value===void 0&&k?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,k){const c=this.b.reset(S),m=[];let a=this.c;for(;a;){const n=c.cmp(a.segment);if(n>0)m.push([-1,a]),a=a.left;else if(n<0)m.push([1,a]),a=a.right;else if(c.hasNext())c.next(),m.push([0,a]),a=a.mid;else break}if(a){if(k?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:s,segment:o}=n;this.e(n.key,!1),a.key=i,a.value=s,a.segment=o}}else{const n=a.left??a.right;if(m.length>0){const[i,s]=m[m.length-1];switch(i){case-1:s.left=n;break;case 0:s.mid=n;break;case 1:s.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const s=i.balanceFactor();if(s>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):s<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const k=this.b.reset(S);let c=this.c,m;for(;c;){const a=k.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(k.hasNext())k.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(S){return this.g(S,!1)}g(S,k){const c=this.b.reset(S);let m=this.c;for(;m;){const a=c.cmp(m.segment);if(a>0)m=m.left;else if(a<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):k?m.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[k,c]of this)S(c,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const k=[];return this.j(S,k),k[Symbol.iterator]()}j(S,k){S&&(S.left&&this.j(S.left,k),S.value&&k.push([S.key,S.value]),S.mid&&this.j(S.mid,k),S.right&&this.j(S.right,k))}_isBalanced(){const S=k=>{if(!k)return!0;const c=k.balanceFactor();return c<-1||c>1?!1:S(k.left)&&S(k.right)};return S(this.c)}}e.$ni=I}),define(ke[18],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=u,e.$Vf=N,e.$Wf=M,e.$Xf=P,e.$Yf=A,e.$Zf=b,e.$1f=$,e.$2f=E,e.$3f=R,e.$4f=I,e.$5f=w,e.$6f=S,e.$7f=k,e.$8f=m,e.$9f=a,e.$0f=n,e.$$f=i,e.$_f=s;function u(o){return typeof o=="string"}function N(o){return Array.isArray(o)&&o.every(t=>u(t))}function M(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function P(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}function A(o){return typeof o=="number"&&!isNaN(o)}function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}function $(o){return o===!0||o===!1}function E(o){return typeof o>"u"}function R(o){return!I(o)}function I(o){return E(o)||o===null}function w(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function S(o){if(I(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function k(...o){const t=[];for(let d=0;d<o.length;d++){const h=o[d];if(I(h))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);t.push(h)}return t}const c=Object.prototype.hasOwnProperty;function m(o){if(!M(o))return!1;for(const t in o)if(c.call(o,t))return!1;return!0}function a(o){return typeof o=="function"}function n(...o){return o.length>0&&o.every(a)}function i(o,t){const d=Math.min(o.length,t.length);for(let h=0;h<d;h++)s(o[h],t[h])}function s(o,t){if(u(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!I(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=M,e.$Cj=P;const N=Object.create(null);function M(A,b){if((0,u.$Uf)(b)){const $=N[b];if($===void 0)throw new Error(`${A} references an unknown codicon: ${b}`);b=$}return N[A]=b,{id:A}}function P(){return N}}),define(ke[169],Ee([1,0,99]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dj=void 0,e.$Dj={add:(0,u.$Bj)("add",6e4),plus:(0,u.$Bj)("plus",6e4),gistNew:(0,u.$Bj)("gist-new",6e4),repoCreate:(0,u.$Bj)("repo-create",6e4),lightbulb:(0,u.$Bj)("lightbulb",60001),lightBulb:(0,u.$Bj)("light-bulb",60001),repo:(0,u.$Bj)("repo",60002),repoDelete:(0,u.$Bj)("repo-delete",60002),gistFork:(0,u.$Bj)("gist-fork",60003),repoForked:(0,u.$Bj)("repo-forked",60003),gitPullRequest:(0,u.$Bj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Bj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Bj)("record-keys",60005),keyboard:(0,u.$Bj)("keyboard",60005),tag:(0,u.$Bj)("tag",60006),gitPullRequestLabel:(0,u.$Bj)("git-pull-request-label",60006),tagAdd:(0,u.$Bj)("tag-add",60006),tagRemove:(0,u.$Bj)("tag-remove",60006),person:(0,u.$Bj)("person",60007),personFollow:(0,u.$Bj)("person-follow",60007),personOutline:(0,u.$Bj)("person-outline",60007),personFilled:(0,u.$Bj)("person-filled",60007),gitBranch:(0,u.$Bj)("git-branch",60008),gitBranchCreate:(0,u.$Bj)("git-branch-create",60008),gitBranchDelete:(0,u.$Bj)("git-branch-delete",60008),sourceControl:(0,u.$Bj)("source-control",60008),mirror:(0,u.$Bj)("mirror",60009),mirrorPublic:(0,u.$Bj)("mirror-public",60009),star:(0,u.$Bj)("star",60010),starAdd:(0,u.$Bj)("star-add",60010),starDelete:(0,u.$Bj)("star-delete",60010),starEmpty:(0,u.$Bj)("star-empty",60010),comment:(0,u.$Bj)("comment",60011),commentAdd:(0,u.$Bj)("comment-add",60011),alert:(0,u.$Bj)("alert",60012),warning:(0,u.$Bj)("warning",60012),search:(0,u.$Bj)("search",60013),searchSave:(0,u.$Bj)("search-save",60013),logOut:(0,u.$Bj)("log-out",60014),signOut:(0,u.$Bj)("sign-out",60014),logIn:(0,u.$Bj)("log-in",60015),signIn:(0,u.$Bj)("sign-in",60015),eye:(0,u.$Bj)("eye",60016),eyeUnwatch:(0,u.$Bj)("eye-unwatch",60016),eyeWatch:(0,u.$Bj)("eye-watch",60016),circleFilled:(0,u.$Bj)("circle-filled",60017),primitiveDot:(0,u.$Bj)("primitive-dot",60017),closeDirty:(0,u.$Bj)("close-dirty",60017),debugBreakpoint:(0,u.$Bj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Bj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Bj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Bj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Bj)("primitive-square",60018),edit:(0,u.$Bj)("edit",60019),pencil:(0,u.$Bj)("pencil",60019),info:(0,u.$Bj)("info",60020),issueOpened:(0,u.$Bj)("issue-opened",60020),gistPrivate:(0,u.$Bj)("gist-private",60021),gitForkPrivate:(0,u.$Bj)("git-fork-private",60021),lock:(0,u.$Bj)("lock",60021),mirrorPrivate:(0,u.$Bj)("mirror-private",60021),close:(0,u.$Bj)("close",60022),removeClose:(0,u.$Bj)("remove-close",60022),x:(0,u.$Bj)("x",60022),repoSync:(0,u.$Bj)("repo-sync",60023),sync:(0,u.$Bj)("sync",60023),clone:(0,u.$Bj)("clone",60024),desktopDownload:(0,u.$Bj)("desktop-download",60024),beaker:(0,u.$Bj)("beaker",60025),microscope:(0,u.$Bj)("microscope",60025),vm:(0,u.$Bj)("vm",60026),deviceDesktop:(0,u.$Bj)("device-desktop",60026),file:(0,u.$Bj)("file",60027),fileText:(0,u.$Bj)("file-text",60027),more:(0,u.$Bj)("more",60028),ellipsis:(0,u.$Bj)("ellipsis",60028),kebabHorizontal:(0,u.$Bj)("kebab-horizontal",60028),mailReply:(0,u.$Bj)("mail-reply",60029),reply:(0,u.$Bj)("reply",60029),organization:(0,u.$Bj)("organization",60030),organizationFilled:(0,u.$Bj)("organization-filled",60030),organizationOutline:(0,u.$Bj)("organization-outline",60030),newFile:(0,u.$Bj)("new-file",60031),fileAdd:(0,u.$Bj)("file-add",60031),newFolder:(0,u.$Bj)("new-folder",60032),fileDirectoryCreate:(0,u.$Bj)("file-directory-create",60032),trash:(0,u.$Bj)("trash",60033),trashcan:(0,u.$Bj)("trashcan",60033),history:(0,u.$Bj)("history",60034),clock:(0,u.$Bj)("clock",60034),folder:(0,u.$Bj)("folder",60035),fileDirectory:(0,u.$Bj)("file-directory",60035),symbolFolder:(0,u.$Bj)("symbol-folder",60035),logoGithub:(0,u.$Bj)("logo-github",60036),markGithub:(0,u.$Bj)("mark-github",60036),github:(0,u.$Bj)("github",60036),terminal:(0,u.$Bj)("terminal",60037),console:(0,u.$Bj)("console",60037),repl:(0,u.$Bj)("repl",60037),zap:(0,u.$Bj)("zap",60038),symbolEvent:(0,u.$Bj)("symbol-event",60038),error:(0,u.$Bj)("error",60039),stop:(0,u.$Bj)("stop",60039),variable:(0,u.$Bj)("variable",60040),symbolVariable:(0,u.$Bj)("symbol-variable",60040),array:(0,u.$Bj)("array",60042),symbolArray:(0,u.$Bj)("symbol-array",60042),symbolModule:(0,u.$Bj)("symbol-module",60043),symbolPackage:(0,u.$Bj)("symbol-package",60043),symbolNamespace:(0,u.$Bj)("symbol-namespace",60043),symbolObject:(0,u.$Bj)("symbol-object",60043),symbolMethod:(0,u.$Bj)("symbol-method",60044),symbolFunction:(0,u.$Bj)("symbol-function",60044),symbolConstructor:(0,u.$Bj)("symbol-constructor",60044),symbolBoolean:(0,u.$Bj)("symbol-boolean",60047),symbolNull:(0,u.$Bj)("symbol-null",60047),symbolNumeric:(0,u.$Bj)("symbol-numeric",60048),symbolNumber:(0,u.$Bj)("symbol-number",60048),symbolStructure:(0,u.$Bj)("symbol-structure",60049),symbolStruct:(0,u.$Bj)("symbol-struct",60049),symbolParameter:(0,u.$Bj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Bj)("symbol-type-parameter",60050),symbolKey:(0,u.$Bj)("symbol-key",60051),symbolText:(0,u.$Bj)("symbol-text",60051),symbolReference:(0,u.$Bj)("symbol-reference",60052),goToFile:(0,u.$Bj)("go-to-file",60052),symbolEnum:(0,u.$Bj)("symbol-enum",60053),symbolValue:(0,u.$Bj)("symbol-value",60053),symbolRuler:(0,u.$Bj)("symbol-ruler",60054),symbolUnit:(0,u.$Bj)("symbol-unit",60054),activateBreakpoints:(0,u.$Bj)("activate-breakpoints",60055),archive:(0,u.$Bj)("archive",60056),arrowBoth:(0,u.$Bj)("arrow-both",60057),arrowDown:(0,u.$Bj)("arrow-down",60058),arrowLeft:(0,u.$Bj)("arrow-left",60059),arrowRight:(0,u.$Bj)("arrow-right",60060),arrowSmallDown:(0,u.$Bj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Bj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Bj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Bj)("arrow-small-up",60064),arrowUp:(0,u.$Bj)("arrow-up",60065),bell:(0,u.$Bj)("bell",60066),bold:(0,u.$Bj)("bold",60067),book:(0,u.$Bj)("book",60068),bookmark:(0,u.$Bj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Bj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Bj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Bj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Bj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Bj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Bj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Bj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Bj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Bj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Bj)("briefcase",60076),broadcast:(0,u.$Bj)("broadcast",60077),browser:(0,u.$Bj)("browser",60078),bug:(0,u.$Bj)("bug",60079),calendar:(0,u.$Bj)("calendar",60080),caseSensitive:(0,u.$Bj)("case-sensitive",60081),check:(0,u.$Bj)("check",60082),checklist:(0,u.$Bj)("checklist",60083),chevronDown:(0,u.$Bj)("chevron-down",60084),chevronLeft:(0,u.$Bj)("chevron-left",60085),chevronRight:(0,u.$Bj)("chevron-right",60086),chevronUp:(0,u.$Bj)("chevron-up",60087),chromeClose:(0,u.$Bj)("chrome-close",60088),chromeMaximize:(0,u.$Bj)("chrome-maximize",60089),chromeMinimize:(0,u.$Bj)("chrome-minimize",60090),chromeRestore:(0,u.$Bj)("chrome-restore",60091),circleOutline:(0,u.$Bj)("circle-outline",60092),circle:(0,u.$Bj)("circle",60092),debugBreakpointUnverified:(0,u.$Bj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Bj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Bj)("circle-slash",60093),circuitBoard:(0,u.$Bj)("circuit-board",60094),clearAll:(0,u.$Bj)("clear-all",60095),clippy:(0,u.$Bj)("clippy",60096),closeAll:(0,u.$Bj)("close-all",60097),cloudDownload:(0,u.$Bj)("cloud-download",60098),cloudUpload:(0,u.$Bj)("cloud-upload",60099),code:(0,u.$Bj)("code",60100),collapseAll:(0,u.$Bj)("collapse-all",60101),colorMode:(0,u.$Bj)("color-mode",60102),commentDiscussion:(0,u.$Bj)("comment-discussion",60103),creditCard:(0,u.$Bj)("credit-card",60105),dash:(0,u.$Bj)("dash",60108),dashboard:(0,u.$Bj)("dashboard",60109),database:(0,u.$Bj)("database",60110),debugContinue:(0,u.$Bj)("debug-continue",60111),debugDisconnect:(0,u.$Bj)("debug-disconnect",60112),debugPause:(0,u.$Bj)("debug-pause",60113),debugRestart:(0,u.$Bj)("debug-restart",60114),debugStart:(0,u.$Bj)("debug-start",60115),debugStepInto:(0,u.$Bj)("debug-step-into",60116),debugStepOut:(0,u.$Bj)("debug-step-out",60117),debugStepOver:(0,u.$Bj)("debug-step-over",60118),debugStop:(0,u.$Bj)("debug-stop",60119),debug:(0,u.$Bj)("debug",60120),deviceCameraVideo:(0,u.$Bj)("device-camera-video",60121),deviceCamera:(0,u.$Bj)("device-camera",60122),deviceMobile:(0,u.$Bj)("device-mobile",60123),diffAdded:(0,u.$Bj)("diff-added",60124),diffIgnored:(0,u.$Bj)("diff-ignored",60125),diffModified:(0,u.$Bj)("diff-modified",60126),diffRemoved:(0,u.$Bj)("diff-removed",60127),diffRenamed:(0,u.$Bj)("diff-renamed",60128),diff:(0,u.$Bj)("diff",60129),diffSidebyside:(0,u.$Bj)("diff-sidebyside",60129),discard:(0,u.$Bj)("discard",60130),editorLayout:(0,u.$Bj)("editor-layout",60131),emptyWindow:(0,u.$Bj)("empty-window",60132),exclude:(0,u.$Bj)("exclude",60133),extensions:(0,u.$Bj)("extensions",60134),eyeClosed:(0,u.$Bj)("eye-closed",60135),fileBinary:(0,u.$Bj)("file-binary",60136),fileCode:(0,u.$Bj)("file-code",60137),fileMedia:(0,u.$Bj)("file-media",60138),filePdf:(0,u.$Bj)("file-pdf",60139),fileSubmodule:(0,u.$Bj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Bj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Bj)("file-symlink-file",60142),fileZip:(0,u.$Bj)("file-zip",60143),files:(0,u.$Bj)("files",60144),filter:(0,u.$Bj)("filter",60145),flame:(0,u.$Bj)("flame",60146),foldDown:(0,u.$Bj)("fold-down",60147),foldUp:(0,u.$Bj)("fold-up",60148),fold:(0,u.$Bj)("fold",60149),folderActive:(0,u.$Bj)("folder-active",60150),folderOpened:(0,u.$Bj)("folder-opened",60151),gear:(0,u.$Bj)("gear",60152),gift:(0,u.$Bj)("gift",60153),gistSecret:(0,u.$Bj)("gist-secret",60154),gist:(0,u.$Bj)("gist",60155),gitCommit:(0,u.$Bj)("git-commit",60156),gitCompare:(0,u.$Bj)("git-compare",60157),compareChanges:(0,u.$Bj)("compare-changes",60157),gitMerge:(0,u.$Bj)("git-merge",60158),githubAction:(0,u.$Bj)("github-action",60159),githubAlt:(0,u.$Bj)("github-alt",60160),globe:(0,u.$Bj)("globe",60161),grabber:(0,u.$Bj)("grabber",60162),graph:(0,u.$Bj)("graph",60163),gripper:(0,u.$Bj)("gripper",60164),heart:(0,u.$Bj)("heart",60165),home:(0,u.$Bj)("home",60166),horizontalRule:(0,u.$Bj)("horizontal-rule",60167),hubot:(0,u.$Bj)("hubot",60168),inbox:(0,u.$Bj)("inbox",60169),issueReopened:(0,u.$Bj)("issue-reopened",60171),issues:(0,u.$Bj)("issues",60172),italic:(0,u.$Bj)("italic",60173),jersey:(0,u.$Bj)("jersey",60174),json:(0,u.$Bj)("json",60175),kebabVertical:(0,u.$Bj)("kebab-vertical",60176),key:(0,u.$Bj)("key",60177),law:(0,u.$Bj)("law",60178),lightbulbAutofix:(0,u.$Bj)("lightbulb-autofix",60179),linkExternal:(0,u.$Bj)("link-external",60180),link:(0,u.$Bj)("link",60181),listOrdered:(0,u.$Bj)("list-ordered",60182),listUnordered:(0,u.$Bj)("list-unordered",60183),liveShare:(0,u.$Bj)("live-share",60184),loading:(0,u.$Bj)("loading",60185),location:(0,u.$Bj)("location",60186),mailRead:(0,u.$Bj)("mail-read",60187),mail:(0,u.$Bj)("mail",60188),markdown:(0,u.$Bj)("markdown",60189),megaphone:(0,u.$Bj)("megaphone",60190),mention:(0,u.$Bj)("mention",60191),milestone:(0,u.$Bj)("milestone",60192),gitPullRequestMilestone:(0,u.$Bj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Bj)("mortar-board",60193),move:(0,u.$Bj)("move",60194),multipleWindows:(0,u.$Bj)("multiple-windows",60195),mute:(0,u.$Bj)("mute",60196),noNewline:(0,u.$Bj)("no-newline",60197),note:(0,u.$Bj)("note",60198),octoface:(0,u.$Bj)("octoface",60199),openPreview:(0,u.$Bj)("open-preview",60200),package:(0,u.$Bj)("package",60201),paintcan:(0,u.$Bj)("paintcan",60202),pin:(0,u.$Bj)("pin",60203),play:(0,u.$Bj)("play",60204),run:(0,u.$Bj)("run",60204),plug:(0,u.$Bj)("plug",60205),preserveCase:(0,u.$Bj)("preserve-case",60206),preview:(0,u.$Bj)("preview",60207),project:(0,u.$Bj)("project",60208),pulse:(0,u.$Bj)("pulse",60209),question:(0,u.$Bj)("question",60210),quote:(0,u.$Bj)("quote",60211),radioTower:(0,u.$Bj)("radio-tower",60212),reactions:(0,u.$Bj)("reactions",60213),references:(0,u.$Bj)("references",60214),refresh:(0,u.$Bj)("refresh",60215),regex:(0,u.$Bj)("regex",60216),remoteExplorer:(0,u.$Bj)("remote-explorer",60217),remote:(0,u.$Bj)("remote",60218),remove:(0,u.$Bj)("remove",60219),replaceAll:(0,u.$Bj)("replace-all",60220),replace:(0,u.$Bj)("replace",60221),repoClone:(0,u.$Bj)("repo-clone",60222),repoForcePush:(0,u.$Bj)("repo-force-push",60223),repoPull:(0,u.$Bj)("repo-pull",60224),repoPush:(0,u.$Bj)("repo-push",60225),report:(0,u.$Bj)("report",60226),requestChanges:(0,u.$Bj)("request-changes",60227),rocket:(0,u.$Bj)("rocket",60228),rootFolderOpened:(0,u.$Bj)("root-folder-opened",60229),rootFolder:(0,u.$Bj)("root-folder",60230),rss:(0,u.$Bj)("rss",60231),ruby:(0,u.$Bj)("ruby",60232),saveAll:(0,u.$Bj)("save-all",60233),saveAs:(0,u.$Bj)("save-as",60234),save:(0,u.$Bj)("save",60235),screenFull:(0,u.$Bj)("screen-full",60236),screenNormal:(0,u.$Bj)("screen-normal",60237),searchStop:(0,u.$Bj)("search-stop",60238),server:(0,u.$Bj)("server",60240),settingsGear:(0,u.$Bj)("settings-gear",60241),settings:(0,u.$Bj)("settings",60242),shield:(0,u.$Bj)("shield",60243),smiley:(0,u.$Bj)("smiley",60244),sortPrecedence:(0,u.$Bj)("sort-precedence",60245),splitHorizontal:(0,u.$Bj)("split-horizontal",60246),splitVertical:(0,u.$Bj)("split-vertical",60247),squirrel:(0,u.$Bj)("squirrel",60248),starFull:(0,u.$Bj)("star-full",60249),starHalf:(0,u.$Bj)("star-half",60250),symbolClass:(0,u.$Bj)("symbol-class",60251),symbolColor:(0,u.$Bj)("symbol-color",60252),symbolConstant:(0,u.$Bj)("symbol-constant",60253),symbolEnumMember:(0,u.$Bj)("symbol-enum-member",60254),symbolField:(0,u.$Bj)("symbol-field",60255),symbolFile:(0,u.$Bj)("symbol-file",60256),symbolInterface:(0,u.$Bj)("symbol-interface",60257),symbolKeyword:(0,u.$Bj)("symbol-keyword",60258),symbolMisc:(0,u.$Bj)("symbol-misc",60259),symbolOperator:(0,u.$Bj)("symbol-operator",60260),symbolProperty:(0,u.$Bj)("symbol-property",60261),wrench:(0,u.$Bj)("wrench",60261),wrenchSubaction:(0,u.$Bj)("wrench-subaction",60261),symbolSnippet:(0,u.$Bj)("symbol-snippet",60262),tasklist:(0,u.$Bj)("tasklist",60263),telescope:(0,u.$Bj)("telescope",60264),textSize:(0,u.$Bj)("text-size",60265),threeBars:(0,u.$Bj)("three-bars",60266),thumbsdown:(0,u.$Bj)("thumbsdown",60267),thumbsup:(0,u.$Bj)("thumbsup",60268),tools:(0,u.$Bj)("tools",60269),triangleDown:(0,u.$Bj)("triangle-down",60270),triangleLeft:(0,u.$Bj)("triangle-left",60271),triangleRight:(0,u.$Bj)("triangle-right",60272),triangleUp:(0,u.$Bj)("triangle-up",60273),twitter:(0,u.$Bj)("twitter",60274),unfold:(0,u.$Bj)("unfold",60275),unlock:(0,u.$Bj)("unlock",60276),unmute:(0,u.$Bj)("unmute",60277),unverified:(0,u.$Bj)("unverified",60278),verified:(0,u.$Bj)("verified",60279),versions:(0,u.$Bj)("versions",60280),vmActive:(0,u.$Bj)("vm-active",60281),vmOutline:(0,u.$Bj)("vm-outline",60282),vmRunning:(0,u.$Bj)("vm-running",60283),watch:(0,u.$Bj)("watch",60284),whitespace:(0,u.$Bj)("whitespace",60285),wholeWord:(0,u.$Bj)("whole-word",60286),window:(0,u.$Bj)("window",60287),wordWrap:(0,u.$Bj)("word-wrap",60288),zoomIn:(0,u.$Bj)("zoom-in",60289),zoomOut:(0,u.$Bj)("zoom-out",60290),listFilter:(0,u.$Bj)("list-filter",60291),listFlat:(0,u.$Bj)("list-flat",60292),listSelection:(0,u.$Bj)("list-selection",60293),selection:(0,u.$Bj)("selection",60293),listTree:(0,u.$Bj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Bj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Bj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Bj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Bj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Bj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Bj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Bj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Bj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Bj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Bj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Bj)("symbol-string",60301),debugReverseContinue:(0,u.$Bj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Bj)("debug-step-back",60303),debugRestartFrame:(0,u.$Bj)("debug-restart-frame",60304),debugAlt:(0,u.$Bj)("debug-alt",60305),callIncoming:(0,u.$Bj)("call-incoming",60306),callOutgoing:(0,u.$Bj)("call-outgoing",60307),menu:(0,u.$Bj)("menu",60308),expandAll:(0,u.$Bj)("expand-all",60309),feedback:(0,u.$Bj)("feedback",60310),gitPullRequestReviewer:(0,u.$Bj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Bj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Bj)("ungroup-by-ref-type",60312),account:(0,u.$Bj)("account",60313),gitPullRequestAssignee:(0,u.$Bj)("git-pull-request-assignee",60313),bellDot:(0,u.$Bj)("bell-dot",60314),debugConsole:(0,u.$Bj)("debug-console",60315),library:(0,u.$Bj)("library",60316),output:(0,u.$Bj)("output",60317),runAll:(0,u.$Bj)("run-all",60318),syncIgnored:(0,u.$Bj)("sync-ignored",60319),pinned:(0,u.$Bj)("pinned",60320),githubInverted:(0,u.$Bj)("github-inverted",60321),serverProcess:(0,u.$Bj)("server-process",60322),serverEnvironment:(0,u.$Bj)("server-environment",60323),pass:(0,u.$Bj)("pass",60324),issueClosed:(0,u.$Bj)("issue-closed",60324),stopCircle:(0,u.$Bj)("stop-circle",60325),playCircle:(0,u.$Bj)("play-circle",60326),record:(0,u.$Bj)("record",60327),debugAltSmall:(0,u.$Bj)("debug-alt-small",60328),vmConnect:(0,u.$Bj)("vm-connect",60329),cloud:(0,u.$Bj)("cloud",60330),merge:(0,u.$Bj)("merge",60331),export:(0,u.$Bj)("export",60332),graphLeft:(0,u.$Bj)("graph-left",60333),magnet:(0,u.$Bj)("magnet",60334),notebook:(0,u.$Bj)("notebook",60335),redo:(0,u.$Bj)("redo",60336),checkAll:(0,u.$Bj)("check-all",60337),pinnedDirty:(0,u.$Bj)("pinned-dirty",60338),passFilled:(0,u.$Bj)("pass-filled",60339),circleLargeFilled:(0,u.$Bj)("circle-large-filled",60340),circleLarge:(0,u.$Bj)("circle-large",60341),circleLargeOutline:(0,u.$Bj)("circle-large-outline",60341),combine:(0,u.$Bj)("combine",60342),gather:(0,u.$Bj)("gather",60342),table:(0,u.$Bj)("table",60343),variableGroup:(0,u.$Bj)("variable-group",60344),typeHierarchy:(0,u.$Bj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Bj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Bj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Bj)("git-pull-request-create",60348),runAbove:(0,u.$Bj)("run-above",60349),runBelow:(0,u.$Bj)("run-below",60350),notebookTemplate:(0,u.$Bj)("notebook-template",60351),debugRerun:(0,u.$Bj)("debug-rerun",60352),workspaceTrusted:(0,u.$Bj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Bj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Bj)("workspace-unknown",60355),terminalCmd:(0,u.$Bj)("terminal-cmd",60356),terminalDebian:(0,u.$Bj)("terminal-debian",60357),terminalLinux:(0,u.$Bj)("terminal-linux",60358),terminalPowershell:(0,u.$Bj)("terminal-powershell",60359),terminalTmux:(0,u.$Bj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Bj)("terminal-ubuntu",60361),terminalBash:(0,u.$Bj)("terminal-bash",60362),arrowSwap:(0,u.$Bj)("arrow-swap",60363),copy:(0,u.$Bj)("copy",60364),personAdd:(0,u.$Bj)("person-add",60365),filterFilled:(0,u.$Bj)("filter-filled",60366),wand:(0,u.$Bj)("wand",60367),debugLineByLine:(0,u.$Bj)("debug-line-by-line",60368),inspect:(0,u.$Bj)("inspect",60369),layers:(0,u.$Bj)("layers",60370),layersDot:(0,u.$Bj)("layers-dot",60371),layersActive:(0,u.$Bj)("layers-active",60372),compass:(0,u.$Bj)("compass",60373),compassDot:(0,u.$Bj)("compass-dot",60374),compassActive:(0,u.$Bj)("compass-active",60375),azure:(0,u.$Bj)("azure",60376),issueDraft:(0,u.$Bj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Bj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Bj)("git-pull-request-draft",60379),debugAll:(0,u.$Bj)("debug-all",60380),debugCoverage:(0,u.$Bj)("debug-coverage",60381),runErrors:(0,u.$Bj)("run-errors",60382),folderLibrary:(0,u.$Bj)("folder-library",60383),debugContinueSmall:(0,u.$Bj)("debug-continue-small",60384),beakerStop:(0,u.$Bj)("beaker-stop",60385),graphLine:(0,u.$Bj)("graph-line",60386),graphScatter:(0,u.$Bj)("graph-scatter",60387),pieChart:(0,u.$Bj)("pie-chart",60388),bracket:(0,u.$Bj)("bracket",60175),bracketDot:(0,u.$Bj)("bracket-dot",60389),bracketError:(0,u.$Bj)("bracket-error",60390),lockSmall:(0,u.$Bj)("lock-small",60391),azureDevops:(0,u.$Bj)("azure-devops",60392),verifiedFilled:(0,u.$Bj)("verified-filled",60393),newline:(0,u.$Bj)("newline",60394),layout:(0,u.$Bj)("layout",60395),layoutActivitybarLeft:(0,u.$Bj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Bj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Bj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Bj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Bj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Bj)("layout-panel-right",60401),layoutPanel:(0,u.$Bj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Bj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Bj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Bj)("layout-statusbar",60405),layoutMenubar:(0,u.$Bj)("layout-menubar",60406),layoutCentered:(0,u.$Bj)("layout-centered",60407),target:(0,u.$Bj)("target",60408),indent:(0,u.$Bj)("indent",60409),recordSmall:(0,u.$Bj)("record-small",60410),errorSmall:(0,u.$Bj)("error-small",60411),terminalDecorationError:(0,u.$Bj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Bj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Bj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Bj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Bj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Bj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Bj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Bj)("layout-sidebar-left-off",60418),blank:(0,u.$Bj)("blank",60419),heartFilled:(0,u.$Bj)("heart-filled",60420),map:(0,u.$Bj)("map",60421),mapFilled:(0,u.$Bj)("map-filled",60422),circleSmall:(0,u.$Bj)("circle-small",60423),bellSlash:(0,u.$Bj)("bell-slash",60424),bellSlashDot:(0,u.$Bj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Bj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Bj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Bj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Bj)("search-fuzzy",60429),commentDraft:(0,u.$Bj)("comment-draft",60430),send:(0,u.$Bj)("send",60431),sparkle:(0,u.$Bj)("sparkle",60432),insert:(0,u.$Bj)("insert",60433),mic:(0,u.$Bj)("mic",60434),thumbsdownFilled:(0,u.$Bj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Bj)("thumbsup-filled",60436),coffee:(0,u.$Bj)("coffee",60437),snake:(0,u.$Bj)("snake",60438),game:(0,u.$Bj)("game",60439),vr:(0,u.$Bj)("vr",60440),chip:(0,u.$Bj)("chip",60441),piano:(0,u.$Bj)("piano",60442),music:(0,u.$Bj)("music",60443),micFilled:(0,u.$Bj)("mic-filled",60444),repoFetch:(0,u.$Bj)("repo-fetch",60445),copilot:(0,u.$Bj)("copilot",60446),lightbulbSparkle:(0,u.$Bj)("lightbulb-sparkle",60447),robot:(0,u.$Bj)("robot",60448),sparkleFilled:(0,u.$Bj)("sparkle-filled",60449),diffSingle:(0,u.$Bj)("diff-single",60450),diffMultiple:(0,u.$Bj)("diff-multiple",60451),surroundWith:(0,u.$Bj)("surround-with",60452),share:(0,u.$Bj)("share",60453),gitStash:(0,u.$Bj)("git-stash",60454),gitStashApply:(0,u.$Bj)("git-stash-apply",60455),gitStashPop:(0,u.$Bj)("git-stash-pop",60456),vscode:(0,u.$Bj)("vscode",60457),vscodeInsiders:(0,u.$Bj)("vscode-insiders",60458),codeOss:(0,u.$Bj)("code-oss",60459),runCoverage:(0,u.$Bj)("run-coverage",60460),runAllCoverage:(0,u.$Bj)("run-all-coverage",60461),coverage:(0,u.$Bj)("coverage",60462),githubProject:(0,u.$Bj)("github-project",60463)}}),define(ke[77],Ee([1,0,99,169]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Ej=M;function M(){return Object.values(e.$Gj)}e.$Fj={dialogError:(0,u.$Bj)("dialog-error","error"),dialogWarning:(0,u.$Bj)("dialog-warning","warning"),dialogInfo:(0,u.$Bj)("dialog-info","info"),dialogClose:(0,u.$Bj)("dialog-close","close"),treeItemExpanded:(0,u.$Bj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Bj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Bj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Bj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Bj)("tree-item-loading","loading"),menuSelection:(0,u.$Bj)("menu-selection","check"),menuSubmenu:(0,u.$Bj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Bj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Bj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Bj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Bj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Bj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Bj)("toolbar-more","more"),quickInputBack:(0,u.$Bj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Bj)("drop-down-button",60084),symbolCustomColor:(0,u.$Bj)("symbol-customcolor",60252),exportIcon:(0,u.$Bj)("export",60332),workspaceUnspecified:(0,u.$Bj)("workspace-unspecified",60355),newLine:(0,u.$Bj)("newline",60394),thumbsDownFilled:(0,u.$Bj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Bj)("thumbsup-filled",60436),gitFetch:(0,u.$Bj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Bj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Bj)("debug-breakpoint-pending",60377)},e.$Gj={...N.$Dj,...e.$Fj}}),define(ke[24],Ee([1,0,18]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=N,e.$On=M,e.$Pn=A,e.$Qn=$,e.$Rn=E,e.$Sn=R,e.$Tn=I,e.$Un=w,e.$Vn=S,e.$Wn=k,e.$Xn=c,e.$Yn=m;function N(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const n=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([i,s])=>{n[i]=s&&typeof s=="object"?N(s):s}),n}function M(a){if(!a||typeof a!="object")return a;const n=[a];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const s in i)if(P.call(i,s)){const o=i[s];typeof o=="object"&&!Object.isFrozen(o)&&!(0,u.$Xf)(o)&&n.push(o)}}return a}const P=Object.prototype.hasOwnProperty;function A(a,n){return b(a,n,new Set)}function b(a,n,i){if((0,u.$4f)(a))return a;const s=n(a);if(typeof s<"u")return s;if(Array.isArray(a)){const o=[];for(const t of a)o.push(b(t,n,i));return o}if((0,u.$Wf)(a)){if(i.has(a))throw new Error("Cannot clone recursive data-structure");i.add(a);const o={};for(const t in a)P.call(a,t)&&(o[t]=b(a[t],n,i));return i.delete(a),o}return a}function $(a,n,i=!0){return(0,u.$Wf)(a)?((0,u.$Wf)(n)&&Object.keys(n).forEach(s=>{s in a?i&&((0,u.$Wf)(a[s])&&(0,u.$Wf)(n[s])?$(a[s],n[s],i):a[s]=n[s]):a[s]=n[s]}),a):n}function E(a,n){if(a===n)return!0;if(a==null||n===null||n===void 0||typeof a!=typeof n||typeof a!="object"||Array.isArray(a)!==Array.isArray(n))return!1;let i,s;if(Array.isArray(a)){if(a.length!==n.length)return!1;for(i=0;i<a.length;i++)if(!E(a[i],n[i]))return!1}else{const o=[];for(s in a)o.push(s);o.sort();const t=[];for(s in n)t.push(s);if(t.sort(),!E(o,t))return!1;for(i=0;i<o.length;i++)if(!E(a[o[i]],n[o[i]]))return!1}return!0}function R(a){const n=new Set;return JSON.stringify(a,(i,s)=>{if((0,u.$Wf)(s)||Array.isArray(s)){if(n.has(s))return"[Circular]";n.add(s)}return s})}function I(a,n){const i=Object.create(null);return!a||!n||Object.keys(n).forEach(o=>{const t=a[o],d=n[o];E(t,d)||(i[o]=d)}),i}function w(a,n){const i=n.toLowerCase(),s=Object.keys(a).find(o=>o.toLowerCase()===i);return s?a[s]:a[n]}function S(a,n){const i=Object.create(null);for(const[s,o]of Object.entries(a))n(s,o)&&(i[s]=o);return i}function k(a){let n=[];for(;Object.prototype!==a;)n=n.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return n}function c(a){const n=[];for(const i of k(a))typeof a[i]=="function"&&n.push(i);return n}function m(a,n){const i=o=>function(){const t=Array.prototype.slice.call(arguments,0);return n(o,t)},s={};for(const o of a)s[o]=i(o);return s}}),define(ke[56],Ee([1,0,77]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Hj=M;var N;(function(A){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=b})(N||(e.ThemeColor=N={}));function M(A){return{id:A}}var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(u.$Gj.error);const[,s,o]=i,t=["codicon","codicon-"+s];return o&&t.push("codicon-modifier-"+o.substring(1)),t}A.asClassNameArray=$;function E(n){return $(n).join(" ")}A.asClassName=E;function R(n){return"."+$(n).join(".")}A.asCSSSelector=R;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}A.isThemeIcon=I;const w=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(n){const i=w.exec(n);if(!i)return;const[,s]=i;return{id:s}}A.fromString=S;function k(n){return{id:n}}A.fromId=k;function c(n,i){let s=n.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),i&&(s=`${s}~${i}`),{id:s}}A.modify=c;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=m;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=a})(P||(e.ThemeIcon=P={}))}),define(ke[170],Ee([1,0,126,14,56]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=$,e.$zk=R,e.$Ak=w,e.$Bk=S,e.$Ck=c,e.$Dk=m;const P="$(",A=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${A.source}`,"g");function $(a){return a.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(E,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function w(a){return a.indexOf(P)===-1?a:a.replace(I,(n,i,s,o)=>s?n:i||o||"")}function S(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const k=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(a){k.lastIndex=0;let n="";const i=[];let s=0;for(;;){const o=k.lastIndex,t=k.exec(a),d=a.substring(o,t?.index);if(d.length>0){n+=d;for(let h=0;h<d.length;h++)i.push(s)}if(!t)break;s+=t[0].length}return{text:n,iconOffsets:i}}function m(a,n,i=!1){const{text:s,iconOffsets:o}=n;if(!o||o.length===0)return(0,u.$pk)(a,s,i);const t=(0,N.$5e)(s," "),d=s.length-t.length,h=(0,u.$pk)(a,t,i);if(h)for(const l of h){const r=o[l.start+d]+d;l.start+=r,l.end+=r}return h}}),define(ke[127],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Se=N,e.$Te=M;var u;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function N(P){return P<0?0:P>255?255:P|0}function M(P){return P<0?0:P>4294967295?4294967295:P|0}}),define(ke[30],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=N;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(M){return u.test(M)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const P=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){M(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,E="";return E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+="-",E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E+=A[P[$++]],E}}()}),define(ke[171],Ee([1,0,19,43,30]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.$Ht=void 0,e.$Ft=P,e.$Gt=A,e.$It=E;function P(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function A(I,w,S){const k={id:(0,M.$Dg)(),name:I,uri:w,data:S};return{asString:async()=>"",asFile:()=>k,value:void 0}}class b{constructor(){this.a=new Map}get size(){let w=0;for(const S of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const S=[...this.a.keys()];return N.Iterable.some(this,([k,c])=>c.asFile())&&S.push("files"),R($(w),S)}get(w){return this.a.get(this.b(w))?.[0]}append(w,S){const k=this.a.get(w);k?k.push(S):this.a.set(this.b(w),[S])}replace(w,S){this.a.set(this.b(w),[S])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,S]of this.a)for(const k of S)yield[w,k]}b(w){return $(w)}}e.$Ht=b;function $(I){return I.toLowerCase()}function E(I,w){return R($(I),w.map($))}function R(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[k,c,m]=S;return m==="*"?w.some(a=>a.startsWith(c+"/")):!1}e.$Jt=Object.freeze({create:I=>(0,u.$Mb)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Jt.split(I).filter(w=>!w.startsWith("#"))})}),define(ke[172],Ee([1,0,62]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=void 0,e.$Fg=N,e.$Hg=P;function N(b,$,E,R=1){let I=!1;return new Promise(w=>{const S=setTimeout(()=>{if(!I)return I=!0,w(0)},E);M(b,$,R,k=>{if(!I)return I=!0,clearTimeout(S),w(k)})})}function M(b,$,E,R){if($===0)return R(0);const I=new u.Socket;I.once("connect",()=>(A(I),M(b+E,$-1,E,R))),I.once("data",()=>{}),I.once("error",w=>(A(I),w.code!=="ECONNREFUSED"?M(b+E,$-1,E,R):R(b))),I.connect(b,"127.0.0.1")}e.$Gg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(b,$,E,R="127.0.0.1"){let I=!1,w,S=1;const k=u.createServer({pauseOnConnect:!0});function c(m,a){I||(I=!0,k.removeAllListeners(),k.close(),w&&clearTimeout(w),a(m))}return new Promise(m=>{w=setTimeout(()=>{c(0,m)},E),k.on("listening",()=>{c(b,m)}),k.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&S<$?(b++,S++,k.listen(b,R)):c(0,m)}),k.on("close",()=>{c(0,m)}),k.listen(b,R)})}function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[128],Ee([1,0,127]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=e.$xt=void 0;class N{constructor(b){const $=(0,u.$Se)(b);this.c=$,this.a=N.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const E=(0,u.$Se)($);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$xt=N;var M;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(M||(M={}));class P{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$yt=P}),define(ke[173],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Mt=N;var u;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function N(M){let P=0,A=0,b=0,$=0;for(let E=0,R=M.length;E<R;E++){const I=M.charCodeAt(E);I===13?(P===0&&(A=E),P++,E+1<R&&M.charCodeAt(E+1)===10?($|=2,E++):$|=3,b=E+1):I===10&&($|=1,P===0&&(A=E),P++,b=E+1)}return P===0&&(A=M.length),[P,A,M.length-b,$]}}),define(ke[49],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=void 0;class u{constructor(M,P){this.lineNumber=M,this.column=P}with(M=this.lineNumber,P=this.column){return M===this.lineNumber&&P===this.column?this:new u(M,P)}delta(M=0,P=0){return this.with(this.lineNumber+M,this.column+P)}equals(M){return u.equals(this,M)}static equals(M,P){return!M&&!P?!0:!!M&&!!P&&M.lineNumber===P.lineNumber&&M.column===P.column}isBefore(M){return u.isBefore(this,M)}static isBefore(M,P){return M.lineNumber<P.lineNumber?!0:P.lineNumber<M.lineNumber?!1:M.column<P.column}isBeforeOrEqual(M){return u.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,P){return M.lineNumber<P.lineNumber?!0:P.lineNumber<M.lineNumber?!1:M.column<=P.column}static compare(M,P){const A=M.lineNumber|0,b=P.lineNumber|0;if(A===b){const $=M.column|0,E=P.column|0;return $-E}return A-b}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new u(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$_s=u}),define(ke[29],Ee([1,0,49]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0;class N{constructor(P,A,b,$){P>b||P===b&&A>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return N.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return N.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return N.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return N.plusRange(this,P)}static plusRange(P,A){let b,$,E,R;return A.startLineNumber<P.startLineNumber?(b=A.startLineNumber,$=A.startColumn):A.startLineNumber===P.startLineNumber?(b=A.startLineNumber,$=Math.min(A.startColumn,P.startColumn)):(b=P.startLineNumber,$=P.startColumn),A.endLineNumber>P.endLineNumber?(E=A.endLineNumber,R=A.endColumn):A.endLineNumber===P.endLineNumber?(E=A.endLineNumber,R=Math.max(A.endColumn,P.endColumn)):(E=P.endLineNumber,R=P.endColumn),new N(b,$,E,R)}intersectRanges(P){return N.intersectRanges(this,P)}static intersectRanges(P,A){let b=P.startLineNumber,$=P.startColumn,E=P.endLineNumber,R=P.endColumn;const I=A.startLineNumber,w=A.startColumn,S=A.endLineNumber,k=A.endColumn;return b<I?(b=I,$=w):b===I&&($=Math.max($,w)),E>S?(E=S,R=k):E===S&&(R=Math.min(R,k)),b>E||b===E&&$>R?null:new N(b,$,E,R)}equalsRange(P){return N.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(P){return new u.$_s(P.endLineNumber,P.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(P){return new u.$_s(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new N(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new N(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(P){return new N(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(P){return new N(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new N(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new N(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new N(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const E=P.startLineNumber|0,R=A.startLineNumber|0;if(E===R){const I=P.startColumn|0,w=A.startColumn|0;if(I===w){const S=P.endLineNumber|0,k=A.endLineNumber|0;if(S===k){const c=P.endColumn|0,m=A.endColumn|0;return c-m}return S-k}return I-w}return E-R}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$at=N}),define(ke[174],Ee([1,0,29]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class N{static insert(P,A){return{range:new u.$at(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$bt=N}),define(ke[175],Ee([1,0,49,29]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.SelectionDirection=void 0;var M;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(M||(e.SelectionDirection=M={}));class P extends N.$at{constructor(b,$,E,R){super(b,$,E,R),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=E,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return P.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,b,$):new P(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new u.$_s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$_s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new P(b,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new P(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new P(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new P(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new P(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let E=0,R=b.length;E<R;E++)if(!this.selectionsEqual(b[E],$[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,E,R,I){return I===0?new P(b,$,E,R):new P(E,R,b,$)}}e.$ct=P}),define(ke[176],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0,e.$Ks={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[177],Ee([1,0,128]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.WordCharacterClass=void 0;var N;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class M extends u.$xt{constructor(b){super(0);for(let $=0,E=b.length;$<E;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$zt=M;function P(A){const b={};return $=>(b.hasOwnProperty($)||(b[$]=A($)),b[$])}e.$At=P(A=>new M(A))}),define(ke[129],Ee([1,0,43,3,74]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=e.$Ls=void 0,e.$Ns=A,e.$Os=$,e.$Ps=E,e.$Ls="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Ls)I.indexOf(S)>=0||(w+="\\"+S);return w+="\\s]+)",new RegExp(w,"g")}e.$Ms=P();function A(I){let w=e.$Ms;if(I&&I instanceof RegExp)if(I.global)w=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),w=new RegExp(I.source,S)}return w.lastIndex=0,w}const b=new M.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const w=b.unshift(I);return(0,N.$Sc)(w)}function E(I,w,S,k,c){if(w=A(w),c||(c=u.Iterable.first(b)),S.length>c.maxLen){let s=I-c.maxLen/2;return s<0?s=0:k+=s,S=S.substring(s,I+c.maxLen/2),E(I,w,S,k,c)}const m=Date.now(),a=I-1-k;let n=-1,i=null;for(let s=1;!(Date.now()-m>=c.timeBudget);s++){const o=a-c.windowSize*s;w.lastIndex=Math.max(0,o);const t=R(w,S,a,n);if(!t&&i||(i=t,o<=0))break;n=o}if(i){const s={word:i[0],startColumn:k+1+i.index,endColumn:k+1+i.index+i[0].length};return w.lastIndex=0,s}return null}function R(I,w,S,k){let c;for(;c=I.exec(w);){const m=c.index||0;if(m<=S&&I.lastIndex>=S)return c;if(k>0&&m>k)return null}return null}}),define(ke[178],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=e.$_t=e.IndentAction=void 0;var u;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,E=b.notIn.length;$<E;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset($-2),R=b.getStandardTokenType(E);return this.isOK(R)}g(b,$){for(let E=b;E<=$;E++){const R=String.fromCharCode(E);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$_t=N;class M{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$au=M;function P(A,b,$){A.has(b)?A.get(b).push($):A.set(b,[$])}}),define(ke[179],Ee([1,0,128]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k2=e.$j2=e.State=void 0,e.$l2=w;var N;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class M{constructor(k,c,m){const a=new Uint8Array(k*c);for(let n=0,i=k*c;n<i;n++)a[n]=m;this.a=a,this.rows=k,this.cols=c}get(k,c){return this.a[k*this.cols+c]}set(k,c,m){this.a[k*this.cols+c]=m}}class P{constructor(k){let c=0,m=0;for(let n=0,i=k.length;n<i;n++){const[s,o,t]=k[n];o>c&&(c=o),s>m&&(m=s),t>m&&(m=t)}c++,m++;const a=new M(m,c,0);for(let n=0,i=k.length;n<i;n++){const[s,o,t]=k[n];a.set(s,o,t)}this.a=a,this.b=c}nextState(k,c){return c<0||c>=this.b?0:this.a.get(k,c)}}e.$j2=P;let A=null;function b(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var $;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})($||($={}));let E=null;function R(){if(E===null){E=new u.$xt(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<S.length;c++)E.set(S.charCodeAt(c),1);const k=".,;:";for(let c=0;c<k.length;c++)E.set(k.charCodeAt(c),2)}return E}class I{static a(k,c,m,a,n){let i=n-1;do{const s=c.charCodeAt(i);if(k.get(s)!==2)break;i--}while(i>a);if(a>0){const s=c.charCodeAt(a-1),o=c.charCodeAt(i);(s===40&&o===41||s===91&&o===93||s===123&&o===125)&&i--}return{range:{startLineNumber:m,startColumn:a+1,endLineNumber:m,endColumn:i+2},url:c.substring(a,i+1)}}static computeLinks(k,c=b()){const m=R(),a=[];for(let n=1,i=k.getLineCount();n<=i;n++){const s=k.getLineContent(n),o=s.length;let t=0,d=0,h=0,l=1,r=!1,g=!1,f=!1,D=!1;for(;t<o;){let p=!1;const v=s.charCodeAt(t);if(l===13){let y;switch(v){case 40:r=!0,y=0;break;case 41:y=r?0:1;break;case 91:f=!0,g=!0,y=0;break;case 93:f=!1,y=g?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:h===v?y=1:h===39||h===34||h===96?y=0:y=1;break;case 42:y=h===42?1:0;break;case 124:y=h===124?1:0;break;case 32:y=f?0:1;break;default:y=m.get(v)}y===1&&(a.push(I.a(m,s,n,d,t)),p=!0)}else if(l===12){let y;v===91?(g=!0,y=0):y=m.get(v),y===1?p=!0:l=13}else l=c.nextState(l,v),l===0&&(p=!0);p&&(l=1,r=!1,g=!1,D=!1,d=t+1,h=v),t++}l===13&&a.push(I.a(m,s,n,d,o))}return a}}e.$k2=I;function w(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}}),define(ke[78],Ee([1,0,24]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=e.$xv=e.$wv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$uv=e.$tv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$vv=S,e.$zv=i;var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var M;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(M||(e.GlyphMarginLane=M={}));var P;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var b;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var E;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,u.$Rn)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$tv=R;class I{constructor(o,t){this._findMatchBrand=void 0,this.range=o,this.matches=t}}e.$uv=I;var w;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function S(s){return s&&typeof s.read=="function"}var k;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var c;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class m{constructor(o,t,d,h,l,r){this.identifier=o,this.range=t,this.text=d,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=l,this._isTracked=r}}e.$wv=m;class a{constructor(o,t,d){this.regex=o,this.wordSeparators=t,this.simpleSearch=d}}e.$xv=a;class n{constructor(o,t,d){this.reverseEdits=o,this.changes=t,this.trimAutoWhitespaceLineNumbers=d}}e.$yv=n;function i(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[180],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.NodeColor=e.$bC=void 0,e.$dC=M,e.$eC=P,e.$fC=E,e.$gC=R,e.$hC=I,e.$iC=w,e.$jC=S,e.$kC=k;class u{constructor(m,a){this.piece=m,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$cC)return M(this.right);let m=this;for(;m.parent!==e.$cC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$cC?e.$cC:m.parent}prev(){if(this.left!==e.$cC)return P(this.left);let m=this;for(;m.parent!==e.$cC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$cC?e.$cC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$bC=u;var N;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$cC=new u(null,0),e.$cC.parent=e.$cC,e.$cC.left=e.$cC,e.$cC.right=e.$cC,e.$cC.color=0;function M(c){for(;c.left!==e.$cC;)c=c.left;return c}function P(c){for(;c.right!==e.$cC;)c=c.right;return c}function A(c){return c===e.$cC?0:c.size_left+c.piece.length+A(c.right)}function b(c){return c===e.$cC?0:c.lf_left+c.piece.lineFeedCnt+b(c.right)}function $(){e.$cC.parent=e.$cC}function E(c,m){const a=m.right;a.size_left+=m.size_left+(m.piece?m.piece.length:0),a.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=a.left,a.left!==e.$cC&&(a.left.parent=m),a.parent=m.parent,m.parent===e.$cC?c.root=a:m.parent.left===m?m.parent.left=a:m.parent.right=a,a.left=m,m.parent=a}function R(c,m){const a=m.left;m.left=a.right,a.right!==e.$cC&&(a.right.parent=m),a.parent=m.parent,m.size_left-=a.size_left+(a.piece?a.piece.length:0),m.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),m.parent===e.$cC?c.root=a:m===m.parent.right?m.parent.right=a:m.parent.left=a,a.right=m,m.parent=a}function I(c,m){let a,n;if(m.left===e.$cC?(n=m,a=n.right):m.right===e.$cC?(n=m,a=n.left):(n=M(m.right),a=n.right),n===c.root){c.root=a,a.color=0,m.detach(),$(),c.root.parent=e.$cC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===m?(a.parent=n.parent,k(c,a)):(n.parent===m?a.parent=n:a.parent=n.parent,k(c,a),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===c.root?c.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$cC&&(n.left.parent=n),n.right!==e.$cC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,k(c,n)),m.detach(),a.parent.left===a){const o=A(a),t=b(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const d=o-a.parent.size_left,h=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,S(c,a.parent,d,h)}}if(k(c,a.parent),i){$();return}let s;for(;a!==c.root&&a.color===0;)a===a.parent.left?(s=a.parent.right,s.color===1&&(s.color=0,a.parent.color=1,E(c,a.parent),s=a.parent.right),s.left.color===0&&s.right.color===0?(s.color=1,a=a.parent):(s.right.color===0&&(s.left.color=0,s.color=1,R(c,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=0,s.right.color=0,E(c,a.parent),a=c.root)):(s=a.parent.left,s.color===1&&(s.color=0,a.parent.color=1,R(c,a.parent),s=a.parent.left),s.left.color===0&&s.right.color===0?(s.color=1,a=a.parent):(s.left.color===0&&(s.right.color=0,s.color=1,E(c,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=0,s.left.color=0,R(c,a.parent),a=c.root));a.color=0,$()}function w(c,m){for(k(c,m);m!==c.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const a=m.parent.parent.right;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,E(c,m)),m.parent.color=0,m.parent.parent.color=1,R(c,m.parent.parent))}else{const a=m.parent.parent.left;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,R(c,m)),m.parent.color=0,m.parent.parent.color=1,E(c,m.parent.parent))}c.root.color=0}function S(c,m,a,n){for(;m!==c.root&&m!==e.$cC;)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=n),m=m.parent}function k(c,m){let a=0,n=0;if(m!==c.root){for(;m!==c.root&&m===m.parent.right;)m=m.parent;if(m!==c.root)for(m=m.parent,a=A(m.left)-m.size_left,n=b(m.left)-m.lf_left,m.size_left+=a,m.lf_left+=n;m!==c.root&&(a!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=n),m=m.parent}}}),define(ke[181],Ee([1,0,19,127]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=void 0;class M{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,E){$=(0,N.$Te)($);const R=this.a,I=this.b,w=E.length;return w===0?!1:(this.a=new Uint32Array(R.length+w),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+w),this.a.set(E,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,E){return $=(0,N.$Te)($),E=(0,N.$Te)(E),this.a[$]===E?!1:(this.a[$]=E,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,E){$=(0,N.$Te)($),E=(0,N.$Te)(E);const R=this.a,I=this.b;if($>=R.length)return!1;const w=R.length-$;return E>=w&&(E=w),E===0?!1:(this.a=new Uint32Array(R.length-E),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+E),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$Te)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),$>=this.a.length&&($=this.a.length-1);for(let R=E;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let E=0,R=this.a.length-1,I=0,w=0,S=0;for(;E<=R;)if(I=E+(R-E)/2|0,w=this.b[I],S=w-this.a[I],$<S)R=I-1;else if($>=w)E=I+1;else break;return new A(I,$-S)}}e.$Cv=M;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const E=this.e[$],R=E>0?this.d[E-1]:0;return new A(E,$-R)}removeValues($,E){this.a.splice($,E),this.f($)}insertValues($,E){this.a=(0,u.$Wb)(this.a,$,E),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,E=this.a.length;$<E;$++){const R=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+R;for(let w=0;w<R;w++)this.e[I+w]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,E){this.a[$]!==E&&(this.a[$]=E,this.f($))}}e.$Dv=P;class A{constructor($,E){this.index=$,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=E}}e.$Ev=A}),define(ke[182],Ee([1,0,14,49,181]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=void 0;class P{constructor(b,$,E,R){this.d=b,this.f=$,this.g=E,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const E of $)this.o(E.range),this.p(new N.$_s(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,E=new Uint32Array($);for(let R=0;R<$;R++)E[R]=this.f[R].length+b;this.j=new M.$Cv(E)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const E=(0,u.$$e)($);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const R=new Uint32Array(E.length-1);for(let I=1;I<E.length;I++)this.f.splice(b.lineNumber+I-1,0,E[I]),R[I-1]=E[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,R)}}e.$Fv=P}),define(ke[100],Ee([1,0,14,177,49,29,78]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$oC=e.$lC=void 0,e.$mC=E,e.$nC=R,e.$pC=c;const b=999;class ${constructor(n,i,s,o){this.searchString=n,this.isRegex=i,this.matchCase=s,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let s=!this.isRegex&&!n;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new A.$xv(i,this.wordSeparators?(0,N.$At)(this.wordSeparators):null,s?this.searchString:null)}}e.$lC=$;function E(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const s=a.charCodeAt(n);if(s===10)return!0;if(s===92){if(n++,n>=i)break;const o=a.charCodeAt(n);if(o===110||o===114||o===87)return!0}}return!1}function R(a,n,i){if(!i)return new A.$uv(a,null);const s=[];for(let o=0,t=n.length;o<t;o++)s[o]=n[o];return new A.$uv(a,s)}class I{constructor(n){const i=[];let s=0;for(let o=0,t=n.length;o<t;o++)n.charCodeAt(o)===10&&(i[s++]=o);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let s=0,o=i.length-1;if(o===-1||n<=i[0])return 0;for(;s<o;){const t=s+((o-s)/2>>0);i[t]>=n?o=t-1:i[t+1]>=n?(s=t,o=t):s=t+1}return s+1}}class w{static findMatches(n,i,s,o,t){const d=i.parseSearchRequest();return d?d.regex.multiline?this.b(n,s,new m(d.wordSeparators,d.regex),o,t):this.c(n,s,d,o,t):[]}static a(n,i,s,o,t,d){let h,l=0;o?(l=o.findLineFeedCountBeforeOffset(t),h=i+t+l):h=i+t;let r;if(o){const p=o.findLineFeedCountBeforeOffset(t+d.length)-l;r=h+d.length+p}else r=h+d.length;const g=n.getPositionAt(h),f=n.getPositionAt(r);return new P.$at(g.lineNumber,g.column,f.lineNumber,f.column)}static b(n,i,s,o,t){const d=n.getOffsetAt(i.getStartPosition()),h=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new I(h):null,r=[];let g=0,f;for(s.reset(0);f=s.next(h);)if(r[g++]=R(this.a(n,d,h,l,f.index,f[0]),f,o),g>=t)return r;return r}static c(n,i,s,o,t){const d=[];let h=0;if(i.startLineNumber===i.endLineNumber){const r=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return h=this.d(s,r,i.startLineNumber,i.startColumn-1,h,d,o,t),d}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);h=this.d(s,l,i.startLineNumber,i.startColumn-1,h,d,o,t);for(let r=i.startLineNumber+1;r<i.endLineNumber&&h<t;r++)h=this.d(s,n.getLineContent(r),r,0,h,d,o,t);if(h<t){const r=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);h=this.d(s,r,i.endLineNumber,0,h,d,o,t)}return d}static d(n,i,s,o,t,d,h,l){const r=n.wordSeparators;if(!h&&n.simpleSearch){const D=n.simpleSearch,p=D.length,v=i.length;let y=-p;for(;(y=i.indexOf(D,y+p))!==-1;)if((!r||c(r,i,v,y,p))&&(d[t++]=new A.$uv(new P.$at(s,y+1+o,s,y+1+p+o),null),t>=l))return t;return t}const g=new m(n.wordSeparators,n.regex);let f;g.reset(0);do if(f=g.next(i),f&&(d[t++]=R(new P.$at(s,f.index+1+o,s,f.index+1+f[0].length+o),f,h),t>=l))return t;while(f);return t}static findNextMatch(n,i,s,o){const t=i.parseSearchRequest();if(!t)return null;const d=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,s,d,o):this.f(n,s,d,o)}static e(n,i,s,o){const t=new M.$_s(i.lineNumber,1),d=n.getOffsetAt(t),h=n.getLineCount(),l=n.getValueInRange(new P.$at(t.lineNumber,t.column,h,n.getLineMaxColumn(h)),1),r=n.getEOL()===`\r
`?new I(l):null;s.reset(i.column-1);const g=s.next(l);return g?R(this.a(n,d,l,r,g.index,g[0]),g,o):i.lineNumber!==1||i.column!==1?this.e(n,new M.$_s(1,1),s,o):null}static f(n,i,s,o){const t=n.getLineCount(),d=i.lineNumber,h=n.getLineContent(d),l=this.g(s,h,d,i.column,o);if(l)return l;for(let r=1;r<=t;r++){const g=(d+r-1)%t,f=n.getLineContent(g+1),D=this.g(s,f,g+1,1,o);if(D)return D}return null}static g(n,i,s,o,t){n.reset(o-1);const d=n.next(i);return d?R(new P.$at(s,d.index+1,s,d.index+1+d[0].length),d,t):null}static findPreviousMatch(n,i,s,o){const t=i.parseSearchRequest();if(!t)return null;const d=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,s,d,o):this.j(n,s,d,o)}static h(n,i,s,o){const t=this.b(n,new P.$at(1,1,i.lineNumber,i.column),s,o,10*b);if(t.length>0)return t[t.length-1];const d=n.getLineCount();return i.lineNumber!==d||i.column!==n.getLineMaxColumn(d)?this.h(n,new M.$_s(d,n.getLineMaxColumn(d)),s,o):null}static j(n,i,s,o){const t=n.getLineCount(),d=i.lineNumber,h=n.getLineContent(d).substring(0,i.column-1),l=this.k(s,h,d,o);if(l)return l;for(let r=1;r<=t;r++){const g=(t+d-r-1)%t,f=n.getLineContent(g+1),D=this.k(s,f,g+1,o);if(D)return D}return null}static k(n,i,s,o){let t=null,d;for(n.reset(0);d=n.next(i);)t=R(new P.$at(s,d.index+1,s,d.index+1+d[0].length),d,o);return t}}e.$oC=w;function S(a,n,i,s,o){if(s===0)return!0;const t=n.charCodeAt(s-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const d=n.charCodeAt(s);if(a.get(d)!==0)return!0}return!1}function k(a,n,i,s,o){if(s+o===i)return!0;const t=n.charCodeAt(s+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const d=n.charCodeAt(s+o-1);if(a.get(d)!==0)return!0}return!1}function c(a,n,i,s,o){return S(a,n,i,s,o)&&k(a,n,i,s,o)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let s;do{if(this.b+this.c===i||(s=this.a.exec(n),!s))return null;const o=s.index,t=s[0].length;if(o===this.b&&t===this.c){if(t===0){u.$sf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||c(this._wordSeparators,n,i,o,t))return s}while(s);return null}}e.$qC=m}),define(ke[130],Ee([1,0,49,29,78,180,100]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.$tC=void 0,e.$rC=R,e.$sC=I;const b=65535;function $(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class E{constructor(n,i,s,o,t){this.lineStarts=n,this.cr=i,this.lf=s,this.crlf=o,this.isBasicASCII=t}}function R(a,n=!0){const i=[0];let s=1;for(let o=0,t=a.length;o<t;o++){const d=a.charCodeAt(o);d===13?o+1<t&&a.charCodeAt(o+1)===10?(i[s++]=o+2,o++):i[s++]=o+1:d===10&&(i[s++]=o+1)}return n?$(i):i}function I(a,n){a.length=0,a[0]=0;let i=1,s=0,o=0,t=0,d=!0;for(let l=0,r=n.length;l<r;l++){const g=n.charCodeAt(l);g===13?l+1<r&&n.charCodeAt(l+1)===10?(t++,a[i++]=l+2,l++):(s++,a[i++]=l+1):g===10?(o++,a[i++]=l+1):d&&g!==9&&(g<32||g>126)&&(d=!1)}const h=new E($(a),s,o,t,d);return a.length=0,h}class w{constructor(n,i,s,o,t){this.bufferIndex=n,this.start=i,this.end=s,this.lineFeedCnt=o,this.length=t}}e.$tC=w;class S{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$uC=S;class k{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==P.$cC&&n.iterate(n.root,s=>(s!==P.$cC&&this.a.push(s.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartOffset<=n&&s.nodeStartOffset+s.node.piece.length>=n)return s}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const s=this.b[i];if(s.nodeStartLineNumber&&s.nodeStartLineNumber<n&&s.nodeStartLineNumber+s.node.piece.lineFeedCnt>=n)return s}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const s=this.b;for(let o=0;o<s.length;o++){const t=s[o];if(t.node.parent===null||t.nodeStartOffset>=n){s[o]=null,i=!0;continue}}if(i){const o=[];for(const t of s)t!==null&&o.push(t);this.b=o}}}class m{constructor(n,i,s){this.create(n,i,s)}create(n,i,s){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=P.$cC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=s;let o=null;for(let t=0,d=n.length;t<d;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=R(n[t].buffer));const h=new w(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),o=this.S(o,h)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,s=i-Math.floor(i/3),o=s*2;let t="",d=0;const h=[];if(this.iterate(this.root,l=>{const r=this.R(l),g=r.length;if(d<=s||d+g<o)return t+=r,d+=g,!0;const f=t.replace(/\r\n|\r|\n/g,n);return h.push(new S(f,R(f))),t=r,d=g,!0}),d>0){const l=t.replace(/\r\n|\r|\n/g,n);h.push(new S(l,R(l)))}this.create(h,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new k(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,o=>{if(o===P.$cC)return!0;const t=this.R(o),d=t.length,h=n.G(i),l=n.G(i+d),r=n.getValueInRange2(h,l);return i+=d,t===r})}getOffsetAt(n,i){let s=0,o=this.root;for(;o!==P.$cC;)if(o.left!==P.$cC&&o.lf_left+1>=n)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=n){s+=o.size_left;const t=this.B(o,n-o.lf_left-2);return s+=t+i-1}else n-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right;return s}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,s=0;const o=n;for(;i!==P.$cC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(s+=i.lf_left+t.index,t.index===0){const d=this.getOffsetAt(s+1,1),h=o-d;return new u.$_s(s+1,h+1)}return new u.$_s(s+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,s+=i.lf_left+i.piece.lineFeedCnt,i.right===P.$cC){const t=this.getOffsetAt(s+1,1),d=o-n-t;return new u.$_s(s+1,d+1)}else i=i.right;return new u.$_s(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const s=this.H(n.startLineNumber,n.startColumn),o=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(s,o);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const h=n.node,l=this.a[h.piece.bufferIndex].buffer,r=this.u(h.piece.bufferIndex,h.piece.start);return l.substring(r+n.remainder,r+i.remainder)}let s=n.node;const o=this.a[s.piece.bufferIndex].buffer,t=this.u(s.piece.bufferIndex,s.piece.start);let d=o.substring(t+n.remainder,t+s.piece.length);for(s=s.next();s!==P.$cC;){const h=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);if(s===i.node){d+=h.substring(l,l+i.remainder);break}else d+=h.substr(l,s.piece.length);s=s.next()}return d}getLinesContent(){const n=[];let i=0,s="",o=!1;return this.iterate(this.root,t=>{if(t===P.$cC)return!0;const d=t.piece;let h=d.length;if(h===0)return!0;const l=this.a[d.bufferIndex].buffer,r=this.a[d.bufferIndex].lineStarts,g=d.start.line,f=d.end.line;let D=r[g]+d.start.column;if(o&&(l.charCodeAt(D)===10&&(D++,h--),n[i++]=s,s="",o=!1,h===0))return!0;if(g===f)return!this.f&&l.charCodeAt(D+h-1)===13?(o=!0,s+=l.substr(D,h-1)):s+=l.substr(D,h),!0;s+=this.f?l.substring(D,Math.max(D,r[g+1]-this.e)):l.substring(D,r[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;for(let p=g+1;p<f;p++)s=this.f?l.substring(r[p],r[p+1]-this.e):l.substring(r[p],r[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=s;return!this.f&&l.charCodeAt(r[f]+d.end.column-1)===13?(o=!0,d.end.column===0?i--:s=l.substr(r[f],d.end.column-1)):s=l.substr(r[f],d.end.column),!0}),o&&(n[i++]=s,s=""),n[i++]=s,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const s=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start);return s.buffer.charCodeAt(o)}else{const i=this.a[n.node.piece.bufferIndex],o=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(o)}}getLineCharCode(n,i){const s=this.H(n,i+1);return this.l(s)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,s,o,t,d,h,l,r,g,f){const D=this.a[n.piece.bufferIndex],p=this.u(n.piece.bufferIndex,n.piece.start),v=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,d);let C;const O={line:0,column:0};let z,T;i._wordSeparators?(z=D.buffer.substring(v,y),T=B=>B+v,i.reset(0)):(z=D.buffer,T=B=>B,i.reset(v));do if(C=i.next(z),C){if(T(C.index)>=y)return g;this.s(n,T(C.index)-p,O);const B=this.t(n.piece.bufferIndex,t,O),j=O.line===t.line?O.column-t.column+o:O.column+1,F=j+C[0].length;if(f[g++]=(0,A.$nC)(new N.$at(s+B,j,s+B,F),C,l),T(C.index)+C[0].length>=y||g>=r)return g}while(C);return g}findMatchesLineByLine(n,i,s,o){const t=[];let d=0;const h=new A.$qC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const r=this.H(n.endLineNumber,n.endColumn);if(r===null)return[];let g=this.s(l.node,l.remainder);const f=this.s(r.node,r.remainder);if(l.node===r.node)return this.findMatchesInNode(l.node,h,n.startLineNumber,n.startColumn,g,f,i,s,o,d,t),t;let D=n.startLineNumber,p=l.node;for(;p!==r.node;){const y=this.t(p.piece.bufferIndex,g,p.piece.end);if(y>=1){const O=this.a[p.piece.bufferIndex].lineStarts,z=this.u(p.piece.bufferIndex,p.piece.start),T=O[g.line+y],B=D===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(p,h,D,B,g,this.s(p,T-z),i,s,o,d,t),d>=o)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const O=this.getLineContent(D).substring(C,n.endColumn-1);return d=this.n(i,h,O,n.endLineNumber,C,d,t,s,o),t}if(d=this.n(i,h,this.getLineContent(D).substr(C),D,C,d,t,s,o),d>=o)return t;D++,l=this.H(D,1),p=l.node,g=this.s(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return d=this.n(i,h,C,n.endLineNumber,y,d,t,s,o),t}const v=D===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(r.node,h,D,v,g,f,i,s,o,d,t),t}n(n,i,s,o,t,d,h,l,r){const g=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,p=D.length,v=s.length;let y=-p;for(;(y=s.indexOf(D,y+p))!==-1;)if((!g||(0,A.$pC)(g,s,v,y,p))&&(h[d++]=new M.$uv(new N.$at(o,y+1+t,o,y+1+p+t),null),d>=r))return d;return d}let f;i.reset(0);do if(f=i.next(s),f&&(h[d++]=(0,A.$nC)(new N.$at(o,f.index+1+t,o,f.index+1+f[0].length+t),f,l),d>=r))return d;while(f);return d}insert(n,i,s=!1){if(this.f=this.f&&s,this.j.lineNumber=0,this.j.value="",this.root!==P.$cC){const{node:o,remainder:t,nodeStartOffset:d}=this.G(n),h=o.piece,l=h.bufferIndex,r=this.s(o,t);if(o.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&d+h.length===n&&i.length<b){this.F(o,i),this.y();return}if(d===n)this.o(i,o),this.h.validate(n);else if(d+o.piece.length>n){const g=[];let f=new w(h.bufferIndex,r,h.end,this.t(h.bufferIndex,r,h.end),this.u(l,h.end)-this.u(l,r));if(this.K()&&this.M(i)&&this.I(o,t)===10){const y={line:f.start.line+1,column:0};f=new w(f.bufferIndex,y,f.end,this.t(f.bufferIndex,y,f.end),f.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(o,t-1)===13){const y=this.s(o,t-1);this.C(o,y),i="\r"+i,o.piece.length===0&&g.push(o)}else this.C(o,r);else this.C(o,r);const D=this.w(i);f.length>0&&this.S(o,f);let p=o;for(let v=0;v<D.length;v++)p=this.S(p,D[v]);this.v(g)}else this.q(i,o)}else{const o=this.w(i);let t=this.T(null,o[0]);for(let d=1;d<o.length;d++)t=this.S(t,o[d])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===P.$cC)return;const s=this.G(n),o=this.G(n+i),t=s.node,d=o.node;if(t===d){const D=this.s(t,s.remainder),p=this.s(t,o.remainder);if(s.nodeStartOffset===n){if(i===t.piece.length){const v=t.next();(0,P.$hC)(this,t),this.N(v),this.y();return}this.D(t,p),this.h.validate(n),this.N(t),this.y();return}if(s.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,p),this.y();return}const h=[],l=this.s(t,s.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&h.push(t);const r=this.s(d,o.remainder);this.D(d,r),d.piece.length===0&&h.push(d);const g=t.next();for(let D=g;D!==P.$cC&&D!==d;D=D.next())h.push(D);const f=t.piece.length===0?t.prev():t;this.v(h),this.O(f),this.y()}o(n,i){const s=[];if(this.K()&&this.M(n)&&this.L(i)){const d=i.piece,h={line:d.start.line+1,column:0},l=new w(d.bufferIndex,h,d.end,this.t(d.bufferIndex,h,d.end),d.length-1);i.piece=l,n+=`
`,(0,P.$jC)(this,i,-1,-1),i.piece.length===0&&s.push(i)}const o=this.w(n);let t=this.T(i,o[o.length-1]);for(let d=o.length-2;d>=0;d--)t=this.T(t,o[d]);this.N(t),this.v(s)}q(n,i){this.Q(n,i)&&(n+=`
`);const s=this.w(n),o=this.S(i,s[0]);let t=o;for(let d=1;d<s.length;d++)t=this.S(t,s[d]);this.N(o)}s(n,i,s){const o=n.piece,t=n.piece.bufferIndex,d=this.a[t].lineStarts,l=d[o.start.line]+o.start.column+i;let r=o.start.line,g=o.end.line,f=0,D=0,p=0;for(;r<=g&&(f=r+(g-r)/2|0,p=d[f],f!==g);)if(D=d[f+1],l<p)g=f-1;else if(l>=D)r=f+1;else break;return s?(s.line=f,s.column=l-p,null):{line:f,column:l-p}}t(n,i,s){if(s.column===0)return s.line-i.line;const o=this.a[n].lineStarts;if(s.line===o.length-1)return s.line-i.line;const t=o[s.line+1],d=o[s.line]+s.column;if(t>d+1)return s.line-i.line;const h=d-1;return this.a[n].buffer.charCodeAt(h)===13?s.line-i.line+1:s.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,P.$hC)(this,n[i])}w(n){if(n.length>b){const g=[];for(;n.length>b;){const D=n.charCodeAt(b-1);let p;D===13||D>=55296&&D<=56319?(p=n.substring(0,b-1),n=n.substring(b-1)):(p=n.substring(0,b),n=n.substring(b));const v=R(p);g.push(new w(this.a.length,{line:0,column:0},{line:v.length-1,column:p.length-v[v.length-1]},v.length-1,p.length)),this.a.push(new S(p,v))}const f=R(n);return g.push(new w(this.a.length,{line:0,column:0},{line:f.length-1,column:n.length-f[f.length-1]},f.length-1,n.length)),this.a.push(new S(n,f)),g}let i=this.a[0].buffer.length;const s=R(n,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let g=0;g<s.length;g++)s[g]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let g=0;g<s.length;g++)s[g]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[d],l={line:d,column:h},r=new w(0,o,l,this.t(0,o,l),t-i);return this.g=l,[r]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let s=this.root,o="";const t=this.h.get2(n);if(t){s=t.node;const d=this.B(s,n-t.nodeStartLineNumber-1),h=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);if(t.nodeStartLineNumber+s.piece.lineFeedCnt===n)o=h.substring(l+d,l+s.piece.length);else{const r=this.B(s,n-t.nodeStartLineNumber);return h.substring(l+d,l+r-i)}}else{let d=0;const h=n;for(;s!==P.$cC;)if(s.left!==P.$cC&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const l=this.B(s,n-s.lf_left-2),r=this.B(s,n-s.lf_left-1),g=this.a[s.piece.bufferIndex].buffer,f=this.u(s.piece.bufferIndex,s.piece.start);return d+=s.size_left,this.h.set({node:s,nodeStartOffset:d,nodeStartLineNumber:h-(n-1-s.lf_left)}),g.substring(f+l,f+r-i)}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const l=this.B(s,n-s.lf_left-2),r=this.a[s.piece.bufferIndex].buffer,g=this.u(s.piece.bufferIndex,s.piece.start);o=r.substring(g+l,g+s.piece.length);break}else n-=s.lf_left+s.piece.lineFeedCnt,d+=s.size_left+s.piece.length,s=s.right}for(s=s.next();s!==P.$cC;){const d=this.a[s.piece.bufferIndex].buffer;if(s.piece.lineFeedCnt>0){const h=this.B(s,0),l=this.u(s.piece.bufferIndex,s.piece.start);return o+=d.substring(l,l+h-i),o}else{const h=this.u(s.piece.bufferIndex,s.piece.start);o+=d.substr(h,s.piece.length)}s=s.next()}return o}y(){let n=this.root,i=1,s=0;for(;n!==P.$cC;)i+=n.lf_left+n.piece.lineFeedCnt,s+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=s,this.h.validate(this.c)}A(n,i){const s=n.piece,o=this.s(n,i),t=o.line-s.start.line;if(this.u(s.bufferIndex,s.end)-this.u(s.bufferIndex,s.start)===i){const d=this.t(n.piece.bufferIndex,s.start,o);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:o.column}}B(n,i){if(i<0)return 0;const s=n.piece,o=this.a[s.bufferIndex].lineStarts,t=s.start.line+i+1;return t>s.end.line?o[s.end.line]+s.end.column-o[s.start.line]-s.start.column:o[t]-o[s.start.line]-s.start.column}C(n,i){const s=n.piece,o=s.lineFeedCnt,t=this.u(s.bufferIndex,s.end),d=i,h=this.u(s.bufferIndex,d),l=this.t(s.bufferIndex,s.start,d),r=l-o,g=h-t,f=s.length+g;n.piece=new w(s.bufferIndex,s.start,d,l,f),(0,P.$jC)(this,n,g,r)}D(n,i){const s=n.piece,o=s.lineFeedCnt,t=this.u(s.bufferIndex,s.start),d=i,h=this.t(s.bufferIndex,d,s.end),l=this.u(s.bufferIndex,d),r=h-o,g=t-l,f=s.length+g;n.piece=new w(s.bufferIndex,d,s.end,h,f),(0,P.$jC)(this,n,g,r)}E(n,i,s){const o=n.piece,t=o.start,d=o.end,h=o.length,l=o.lineFeedCnt,r=i,g=this.t(o.bufferIndex,o.start,r),f=this.u(o.bufferIndex,i)-this.u(o.bufferIndex,t);n.piece=new w(o.bufferIndex,o.start,r,g,f),(0,P.$jC)(this,n,f-h,g-l);const D=new w(o.bufferIndex,s,d,this.t(o.bufferIndex,s,d),this.u(o.bufferIndex,d)-this.u(o.bufferIndex,s)),p=this.S(n,D);this.N(p)}F(n,i){this.Q(i,n)&&(i+=`
`);const s=this.K()&&this.L(i)&&this.M(n),o=this.a[0].buffer.length;this.a[0].buffer+=i;const t=R(i,!1);for(let p=0;p<t.length;p++)t[p]+=o;if(s){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[d],l={line:d,column:h},r=n.piece.length+i.length,g=n.piece.lineFeedCnt,f=this.t(0,n.piece.start,l),D=f-g;n.piece=new w(n.piece.bufferIndex,n.piece.start,l,f,r),this.g=l,(0,P.$jC)(this,n,i.length,D)}G(n){let i=this.root;const s=this.h.get(n);if(s)return{node:s.node,nodeStartOffset:s.nodeStartOffset,remainder:n-s.nodeStartOffset};let o=0;for(;i!==P.$cC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){o+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:o};return this.h.set(t),t}else n-=i.size_left+i.piece.length,o+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let s=this.root,o=0;for(;s!==P.$cC;)if(s.left!==P.$cC&&s.lf_left>=n-1)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt>n-1){const t=this.B(s,n-s.lf_left-2),d=this.B(s,n-s.lf_left-1);return o+=s.size_left,{node:s,remainder:Math.min(t+i-1,d),nodeStartOffset:o}}else if(s.lf_left+s.piece.lineFeedCnt===n-1){const t=this.B(s,n-s.lf_left-2);if(t+i-1<=s.piece.length)return{node:s,remainder:t+i-1,nodeStartOffset:o};i-=s.piece.length-t;break}else n-=s.lf_left+s.piece.lineFeedCnt,o+=s.size_left+s.piece.length,s=s.right;for(s=s.next();s!==P.$cC;){if(s.piece.lineFeedCnt>0){const t=this.B(s,0),d=this.J(s);return{node:s,remainder:Math.min(i-1,t),nodeStartOffset:d}}else if(s.piece.length>=i-1){const t=this.J(s);return{node:s,remainder:i-1,nodeStartOffset:t}}else i-=s.piece.length;s=s.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const s=this.a[n.piece.bufferIndex],o=this.u(n.piece.bufferIndex,n.piece.start)+i;return s.buffer.charCodeAt(o)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===P.$cC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,s=this.a[i.bufferIndex].lineStarts,o=i.start.line,t=s[o]+i.start.column;return o===s.length-1||s[o+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===P.$cC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const s=[],o=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:o[n.piece.end.line]-o[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,h=n.piece.lineFeedCnt-1;n.piece=new w(n.piece.bufferIndex,n.piece.start,t,h,d),(0,P.$jC)(this,n,-1,-1),n.piece.length===0&&s.push(n);const l={line:i.piece.start.line+1,column:0},r=i.piece.length-1,g=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new w(i.piece.bufferIndex,l,i.piece.end,g,r),(0,P.$jC)(this,i,-1,-1),i.piece.length===0&&s.push(i);const f=this.w(`\r
`);this.S(n,f[0]);for(let D=0;D<s.length;D++)(0,P.$hC)(this,s[D])}Q(n,i){if(this.K()&&this.M(n)){const s=i.next();if(this.L(s)){if(n+=`
`,s.piece.length===1)(0,P.$hC)(this,s);else{const o=s.piece,t={line:o.start.line+1,column:0},d=o.length-1,h=this.t(o.bufferIndex,t,o.end);s.piece=new w(o.bufferIndex,t,o.end,h,d),(0,P.$jC)(this,s,-1,-1)}return!0}}return!1}iterate(n,i){if(n===P.$cC)return i(P.$cC);const s=this.iterate(n.left,i);return s&&i(n)&&this.iterate(n.right,i)}R(n){if(n===P.$cC)return"";const i=this.a[n.piece.bufferIndex],s=n.piece,o=this.u(s.bufferIndex,s.start),t=this.u(s.bufferIndex,s.end);return i.buffer.substring(o,t)}getPieceContent(n){const i=this.a[n.bufferIndex],s=this.u(n.bufferIndex,n.start),o=this.u(n.bufferIndex,n.end);return i.buffer.substring(s,o)}S(n,i){const s=new P.$bC(i,1);if(s.left=P.$cC,s.right=P.$cC,s.parent=P.$cC,s.size_left=0,s.lf_left=0,this.root===P.$cC)this.root=s,s.color=0;else if(n.right===P.$cC)n.right=s,s.parent=n;else{const t=(0,P.$dC)(n.right);t.left=s,s.parent=t}return(0,P.$iC)(this,s),s}T(n,i){const s=new P.$bC(i,1);if(s.left=P.$cC,s.right=P.$cC,s.parent=P.$cC,s.size_left=0,s.lf_left=0,this.root===P.$cC)this.root=s,s.color=0;else if(n.left===P.$cC)n.left=s,s.parent=n;else{const o=(0,P.$eC)(n.left);o.right=s,s.parent=o}return(0,P.$iC)(this,s),s}U(n){let i="";return this.iterate(n,s=>(i+=this.R(s),!0)),i}}e.$vC=m}),define(ke[183],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9=e.$W9=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const A=this.a.get(P);return this.a.delete(P),A}}addDragOperationTransfer(P,A){this.a.set(P,A)}}e.$W9=u;class N{constructor(P){this.identifier=P}}e.$X9=N}),define(ke[184],Ee([1,0,4,3]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,N.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const E=new P(this,b,$);return this.b.set(b,E),(0,N.$Sc)(()=>{const R=this.b.get(b);!R||R!==E||(this.b.delete(b),R.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Lt=M;class P extends N.$Uc{get isResolved(){return this.c}constructor(b,$,E){super(),this.f=b,this.g=$,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[185],Ee([9,10]),function(de,e){return de.create("vs/base/common/actions",e)}),define(ke[186],Ee([1,0,4,3,185]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=void 0,e.$4i=R;class P extends N.$Uc{constructor(w,S="",k="",c=!0,m){super(),this.h=this.B(new u.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=S,this.u=k,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,S){this.C&&await this.C(w)}}e.$Yi=P;class A extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$7d),this.onWillRun=this.f.event,this.m=this.B(new u.$7d),this.onDidRun=this.m.event}async run(w,S){if(!w.enabled)return;this.f.fire({action:w});let k;try{await this.u(w,S)}catch(c){k=c}this.m.fire({action:w,error:k})}async u(w,S){await w.run(S)}}e.$Zi=A;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let S=[];for(const k of w)k.length&&(S.length?S=[...S,new b,...k]:S=k);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$1i=b;class ${get actions(){return this.a}constructor(w,S,k,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=S,this.class=c,this.a=k}async run(){}}e.$2i=$;class E extends P{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,M.localize(0,null),void 0,!1)}}e.$3i=E;function R(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...w)=>I.run(...w),tooltip:I.label}}}),define(ke[187],Ee([9,10]),function(de,e){return de.create("vs/base/common/date",e)}),define(ke[188],Ee([1,0,187]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=E,e.$Nm=R,e.$Om=I;const N=60,M=N*60,P=M*24,A=P*7,b=P*30,$=P*365;function E(w,S,k,c){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,u.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(!c&&m<30)return(0,u.localize)(1,null);let a;return m<N?(a=m,S?a===1?k?(0,u.localize)(2,null,a):(0,u.localize)(3,null,a):k?(0,u.localize)(4,null,a):(0,u.localize)(5,null,a):a===1?k?(0,u.localize)(6,null,a):(0,u.localize)(7,null,a):k?(0,u.localize)(8,null,a):(0,u.localize)(9,null,a)):m<M?(a=Math.floor(m/N),S?a===1?k?(0,u.localize)(10,null,a):(0,u.localize)(11,null,a):k?(0,u.localize)(12,null,a):(0,u.localize)(13,null,a):a===1?k?(0,u.localize)(14,null,a):(0,u.localize)(15,null,a):k?(0,u.localize)(16,null,a):(0,u.localize)(17,null,a)):m<P?(a=Math.floor(m/M),S?a===1?k?(0,u.localize)(18,null,a):(0,u.localize)(19,null,a):k?(0,u.localize)(20,null,a):(0,u.localize)(21,null,a):a===1?k?(0,u.localize)(22,null,a):(0,u.localize)(23,null,a):k?(0,u.localize)(24,null,a):(0,u.localize)(25,null,a)):m<A?(a=Math.floor(m/P),S?a===1?(0,u.localize)(26,null,a):(0,u.localize)(27,null,a):a===1?(0,u.localize)(28,null,a):(0,u.localize)(29,null,a)):m<b?(a=Math.floor(m/A),S?a===1?k?(0,u.localize)(30,null,a):(0,u.localize)(31,null,a):k?(0,u.localize)(32,null,a):(0,u.localize)(33,null,a):a===1?k?(0,u.localize)(34,null,a):(0,u.localize)(35,null,a):k?(0,u.localize)(36,null,a):(0,u.localize)(37,null,a)):m<$?(a=Math.floor(m/b),S?a===1?k?(0,u.localize)(38,null,a):(0,u.localize)(39,null,a):k?(0,u.localize)(40,null,a):(0,u.localize)(41,null,a):a===1?k?(0,u.localize)(42,null,a):(0,u.localize)(43,null,a):k?(0,u.localize)(44,null,a):(0,u.localize)(45,null,a)):(a=Math.floor(m/$),S?a===1?k?(0,u.localize)(46,null,a):(0,u.localize)(47,null,a):k?(0,u.localize)(48,null,a):(0,u.localize)(49,null,a):a===1?k?(0,u.localize)(50,null,a):(0,u.localize)(51,null,a):k?(0,u.localize)(52,null,a):(0,u.localize)(53,null,a))}function R(w,S){const k=Math.abs(w/1e3);return k<1?S?(0,u.localize)(54,null,w):(0,u.localize)(55,null,w):k<N?S?(0,u.localize)(56,null,Math.round(w)/1e3):(0,u.localize)(57,null,Math.round(w)/1e3):k<M?S?(0,u.localize)(58,null,Math.round(w/(1e3*N))):(0,u.localize)(59,null,Math.round(w/(1e3*N))):k<P?S?(0,u.localize)(60,null,Math.round(w/(1e3*M))):(0,u.localize)(61,null,Math.round(w/(1e3*M))):(0,u.localize)(62,null,Math.round(w/(1e3*P)))}function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[189],Ee([9,10]),function(de,e){return de.create("vs/base/common/errorMessage",e)}),define(ke[45],Ee([1,0,19,18,189]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=$,e.$6i=E,e.$7i=R;function P(I,w){return w&&(I.stack||I.stacktrace)?M.localize(0,null,b(I),A(I.stack)||A(I.stacktrace)):b(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?M.localize(1,null,I.message):I.message||M.localize(2,null)}function $(I=null,w=!1){if(!I)return M.localize(3,null);if(Array.isArray(I)){const S=u.$Hb(I),k=$(S[0],w);return S.length>1?M.localize(4,null,k,S.length):k}if(N.$Uf(I))return I;if(I.detail){const S=I.detail;if(S.error)return P(S.error,w);if(S.exception)return P(S.exception,w)}return I.stack?P(I,w):I.message?I.message:M.localize(5,null)}function E(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}function R(I,w){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=w,S}}),define(ke[190],Ee([9,10]),function(de,e){return de.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,190]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=d,e.$D=D,e.$J=p,e.$g="en";let N=!1,M=!1,P=!1,A=!1,b=!1,$=!1,E=!1,R=!1,I=!1,w=!1,S,k=e.$g,c=e.$g,m,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&(i=process);const s=typeof i?.versions?.electron=="string",o=s&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",M=i.platform==="darwin",P=i.platform==="linux",A=P&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=s,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,k=e.$g;const v=i.env.VSCODE_NLS_CONFIG;if(v)try{const y=JSON.parse(v),C=y.availableLanguages["*"];S=y.locale,c=y.osLocale,k=C||e.$g,m=y._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,N=a.indexOf("Windows")>=0,M=a.indexOf("Macintosh")>=0,R=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=a.indexOf("Linux")>=0,w=a?.indexOf("Mobi")>=0,$=!0,S=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,k=S,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function d(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let h=0;M?h=1:N?h=3:P&&(h=2),e.$i=N,e.$j=M,e.$k=P,e.$l=A,e.$m=b,e.$n=E,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=R,e.$s=w,e.$t=I,e.$u=h,e.$v=a,e.$w=k;var l;(function(v){function y(){return e.$w}v.value=y;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=C;function O(){return e.$w==="en"}v.isDefault=O})(l||(e.Language=l={})),e.$x=S,e.$y=c,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const v=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let O=0,z=v.length;O<z;O++){const T=v[O];if(T.id===C.data.vscodeScheduleAsyncWork){v.splice(O,1),T.callback();return}}});let y=0;return C=>{const O=++y;v.push({id:O,callback:C}),n.postMessage({vscodeScheduleAsyncWork:O},"*")}}return v=>setTimeout(v)})();var r;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=M||R?2:N?1:3;let g=!0,f=!1;function D(){if(!f){f=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,g=new Uint16Array(v.buffer)[0]===513}return g}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function p(v){return parseFloat(v)>=20}}),define(ke[50],Ee([1,0,11]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const P=M.process;N={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Ee([1,0,50]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,M=97,P=90,A=122,b=46,$=47,E=92,R=58,I=63;class w extends Error{constructor(d,h,l){let r;typeof h=="string"&&h.indexOf("not ")===0?(r="must not be",h=h.replace(/^not /,"")):r="must be";const g=d.indexOf(".")!==-1?"property":"argument";let f=`The "${d}" ${g} ${r} of type ${h}`;f+=`. Received type ${typeof l}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,d){if(t===null||typeof t!="object")throw new w(d,"Object",t)}function k(t,d){if(typeof t!="string")throw new w(d,"string",t)}const c=u.$ec==="win32";function m(t){return t===$||t===E}function a(t){return t===$}function n(t){return t>=N&&t<=P||t>=M&&t<=A}function i(t,d,h,l){let r="",g=0,f=-1,D=0,p=0;for(let v=0;v<=t.length;++v){if(v<t.length)p=t.charCodeAt(v);else{if(l(p))break;p=$}if(l(p)){if(!(f===v-1||D===1))if(D===2){if(r.length<2||g!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const y=r.lastIndexOf(h);y===-1?(r="",g=0):(r=r.slice(0,y),g=r.length-1-r.lastIndexOf(h)),f=v,D=0;continue}else if(r.length!==0){r="",g=0,f=v,D=0;continue}}d&&(r+=r.length>0?`${h}..`:"..",g=2)}else r.length>0?r+=`${h}${t.slice(f+1,v)}`:r=t.slice(f+1,v),g=v-f-1;f=v,D=0}else p===b&&D!==-1?++D:D=-1}return r}function s(t,d){S(d,"pathObject");const h=d.dir||d.root,l=d.base||`${d.name||""}${d.ext||""}`;return h?h===d.root?`${h}${l}`:`${h}${t}${l}`:l}e.$gc={resolve(...t){let d="",h="",l=!1;for(let r=t.length-1;r>=-1;r--){let g;if(r>=0){if(g=t[r],k(g,"path"),g.length===0)continue}else d.length===0?g=u.cwd():(g=u.env[`=${d}`]||u.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==d.toLowerCase()&&g.charCodeAt(2)===E)&&(g=`${d}\\`));const f=g.length;let D=0,p="",v=!1;const y=g.charCodeAt(0);if(f===1)m(y)&&(D=1,v=!0);else if(m(y))if(v=!0,m(g.charCodeAt(1))){let C=2,O=C;for(;C<f&&!m(g.charCodeAt(C));)C++;if(C<f&&C!==O){const z=g.slice(O,C);for(O=C;C<f&&m(g.charCodeAt(C));)C++;if(C<f&&C!==O){for(O=C;C<f&&!m(g.charCodeAt(C));)C++;(C===f||C!==O)&&(p=`\\\\${z}\\${g.slice(O,C)}`,D=C)}}}else D=1;else n(y)&&g.charCodeAt(1)===R&&(p=g.slice(0,2),D=2,f>2&&m(g.charCodeAt(2))&&(v=!0,D=3));if(p.length>0)if(d.length>0){if(p.toLowerCase()!==d.toLowerCase())continue}else d=p;if(l){if(d.length>0)break}else if(h=`${g.slice(D)}\\${h}`,l=v,v&&d.length>0)break}return h=i(h,!l,"\\",m),l?`${d}\\${h}`:`${d}${h}`||"."},normalize(t){k(t,"path");const d=t.length;if(d===0)return".";let h=0,l,r=!1;const g=t.charCodeAt(0);if(d===1)return a(g)?"\\":t;if(m(g))if(r=!0,m(t.charCodeAt(1))){let D=2,p=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==p){const v=t.slice(p,D);for(p=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==p){for(p=D;D<d&&!m(t.charCodeAt(D));)D++;if(D===d)return`\\\\${v}\\${t.slice(p)}\\`;D!==p&&(l=`\\\\${v}\\${t.slice(p,D)}`,h=D)}}}else h=1;else n(g)&&t.charCodeAt(1)===R&&(l=t.slice(0,2),h=2,d>2&&m(t.charCodeAt(2))&&(r=!0,h=3));let f=h<d?i(t.slice(h),!r,"\\",m):"";return f.length===0&&!r&&(f="."),f.length>0&&m(t.charCodeAt(d-1))&&(f+="\\"),l===void 0?r?`\\${f}`:f:r?`${l}\\${f}`:`${l}${f}`},isAbsolute(t){k(t,"path");const d=t.length;if(d===0)return!1;const h=t.charCodeAt(0);return m(h)||d>2&&n(h)&&t.charCodeAt(1)===R&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let d,h;for(let g=0;g<t.length;++g){const f=t[g];k(f,"path"),f.length>0&&(d===void 0?d=h=f:d+=`\\${f}`)}if(d===void 0)return".";let l=!0,r=0;if(typeof h=="string"&&m(h.charCodeAt(0))){++r;const g=h.length;g>1&&m(h.charCodeAt(1))&&(++r,g>2&&(m(h.charCodeAt(2))?++r:l=!1))}if(l){for(;r<d.length&&m(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.$gc.normalize(d)},relative(t,d){if(k(t,"from"),k(d,"to"),t===d)return"";const h=e.$gc.resolve(t),l=e.$gc.resolve(d);if(h===l||(t=h.toLowerCase(),d=l.toLowerCase(),t===d))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===E;)r++;let g=t.length;for(;g-1>r&&t.charCodeAt(g-1)===E;)g--;const f=g-r;let D=0;for(;D<d.length&&d.charCodeAt(D)===E;)D++;let p=d.length;for(;p-1>D&&d.charCodeAt(p-1)===E;)p--;const v=p-D,y=f<v?f:v;let C=-1,O=0;for(;O<y;O++){const T=t.charCodeAt(r+O);if(T!==d.charCodeAt(D+O))break;T===E&&(C=O)}if(O!==y){if(C===-1)return l}else{if(v>y){if(d.charCodeAt(D+O)===E)return l.slice(D+O+1);if(O===2)return l.slice(D+O)}f>y&&(t.charCodeAt(r+O)===E?C=O:O===2&&(C=3)),C===-1&&(C=0)}let z="";for(O=r+C+1;O<=g;++O)(O===g||t.charCodeAt(O)===E)&&(z+=z.length===0?"..":"\\..");return D+=C,z.length>0?`${z}${l.slice(D,p)}`:(l.charCodeAt(D)===E&&++D,l.slice(D,p))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const d=e.$gc.resolve(t);if(d.length<=2)return t;if(d.charCodeAt(0)===E){if(d.charCodeAt(1)===E){const h=d.charCodeAt(2);if(h!==I&&h!==b)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(n(d.charCodeAt(0))&&d.charCodeAt(1)===R&&d.charCodeAt(2)===E)return`\\\\?\\${d}`;return t},dirname(t){k(t,"path");const d=t.length;if(d===0)return".";let h=-1,l=0;const r=t.charCodeAt(0);if(d===1)return m(r)?t:".";if(m(r)){if(h=l=1,m(t.charCodeAt(1))){let D=2,p=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==p){for(p=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==p){for(p=D;D<d&&!m(t.charCodeAt(D));)D++;if(D===d)return t;D!==p&&(h=l=D+1)}}}}else n(r)&&t.charCodeAt(1)===R&&(h=d>2&&m(t.charCodeAt(2))?3:2,l=h);let g=-1,f=!0;for(let D=d-1;D>=l;--D)if(m(t.charCodeAt(D))){if(!f){g=D;break}}else f=!1;if(g===-1){if(h===-1)return".";g=h}return t.slice(0,g)},basename(t,d){d!==void 0&&k(d,"ext"),k(t,"path");let h=0,l=-1,r=!0,g;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(h=2),d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let f=d.length-1,D=-1;for(g=t.length-1;g>=h;--g){const p=t.charCodeAt(g);if(m(p)){if(!r){h=g+1;break}}else D===-1&&(r=!1,D=g+1),f>=0&&(p===d.charCodeAt(f)?--f===-1&&(l=g):(f=-1,l=D))}return h===l?l=D:l===-1&&(l=t.length),t.slice(h,l)}for(g=t.length-1;g>=h;--g)if(m(t.charCodeAt(g))){if(!r){h=g+1;break}}else l===-1&&(r=!1,l=g+1);return l===-1?"":t.slice(h,l)},extname(t){k(t,"path");let d=0,h=-1,l=0,r=-1,g=!0,f=0;t.length>=2&&t.charCodeAt(1)===R&&n(t.charCodeAt(0))&&(d=l=2);for(let D=t.length-1;D>=d;--D){const p=t.charCodeAt(D);if(m(p)){if(!g){l=D+1;break}continue}r===-1&&(g=!1,r=D+1),p===b?h===-1?h=D:f!==1&&(f=1):h!==-1&&(f=-1)}return h===-1||r===-1||f===0||f===1&&h===r-1&&h===l+1?"":t.slice(h,r)},format:s.bind(null,"\\"),parse(t){k(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const h=t.length;let l=0,r=t.charCodeAt(0);if(h===1)return m(r)?(d.root=d.dir=t,d):(d.base=d.name=t,d);if(m(r)){if(l=1,m(t.charCodeAt(1))){let C=2,O=C;for(;C<h&&!m(t.charCodeAt(C));)C++;if(C<h&&C!==O){for(O=C;C<h&&m(t.charCodeAt(C));)C++;if(C<h&&C!==O){for(O=C;C<h&&!m(t.charCodeAt(C));)C++;C===h?l=C:C!==O&&(l=C+1)}}}}else if(n(r)&&t.charCodeAt(1)===R){if(h<=2)return d.root=d.dir=t,d;if(l=2,m(t.charCodeAt(2))){if(h===3)return d.root=d.dir=t,d;l=3}}l>0&&(d.root=t.slice(0,l));let g=-1,f=l,D=-1,p=!0,v=t.length-1,y=0;for(;v>=l;--v){if(r=t.charCodeAt(v),m(r)){if(!p){f=v+1;break}continue}D===-1&&(p=!1,D=v+1),r===b?g===-1?g=v:y!==1&&(y=1):g!==-1&&(y=-1)}return D!==-1&&(g===-1||y===0||y===1&&g===D-1&&g===f+1?d.base=d.name=t.slice(f,D):(d.name=t.slice(f,g),d.base=t.slice(f,D),d.ext=t.slice(g,D))),f>0&&f!==l?d.dir=t.slice(0,f-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(c){const t=/\\/g;return()=>{const d=u.cwd().replace(t,"/");return d.slice(d.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let d="",h=!1;for(let l=t.length-1;l>=-1&&!h;l--){const r=l>=0?t[l]:o();k(r,"path"),r.length!==0&&(d=`${r}/${d}`,h=r.charCodeAt(0)===$)}return d=i(d,!h,"/",a),h?`/${d}`:d.length>0?d:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===$,h=t.charCodeAt(t.length-1)===$;return t=i(t,!d,"/",a),t.length===0?d?"/":h?"./":".":(h&&(t+="/"),d?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let d;for(let h=0;h<t.length;++h){const l=t[h];k(l,"path"),l.length>0&&(d===void 0?d=l:d+=`/${l}`)}return d===void 0?".":e.$hc.normalize(d)},relative(t,d){if(k(t,"from"),k(d,"to"),t===d||(t=e.$hc.resolve(t),d=e.$hc.resolve(d),t===d))return"";const h=1,l=t.length,r=l-h,g=1,f=d.length-g,D=r<f?r:f;let p=-1,v=0;for(;v<D;v++){const C=t.charCodeAt(h+v);if(C!==d.charCodeAt(g+v))break;C===$&&(p=v)}if(v===D)if(f>D){if(d.charCodeAt(g+v)===$)return d.slice(g+v+1);if(v===0)return d.slice(g+v)}else r>D&&(t.charCodeAt(h+v)===$?p=v:v===0&&(p=0));let y="";for(v=h+p+1;v<=l;++v)(v===l||t.charCodeAt(v)===$)&&(y+=y.length===0?"..":"/..");return`${y}${d.slice(g+p)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===$;let h=-1,l=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===$){if(!l){h=r;break}}else l=!1;return h===-1?d?"/":".":d&&h===1?"//":t.slice(0,h)},basename(t,d){d!==void 0&&k(d,"ext"),k(t,"path");let h=0,l=-1,r=!0,g;if(d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let f=d.length-1,D=-1;for(g=t.length-1;g>=0;--g){const p=t.charCodeAt(g);if(p===$){if(!r){h=g+1;break}}else D===-1&&(r=!1,D=g+1),f>=0&&(p===d.charCodeAt(f)?--f===-1&&(l=g):(f=-1,l=D))}return h===l?l=D:l===-1&&(l=t.length),t.slice(h,l)}for(g=t.length-1;g>=0;--g)if(t.charCodeAt(g)===$){if(!r){h=g+1;break}}else l===-1&&(r=!1,l=g+1);return l===-1?"":t.slice(h,l)},extname(t){k(t,"path");let d=-1,h=0,l=-1,r=!0,g=0;for(let f=t.length-1;f>=0;--f){const D=t.charCodeAt(f);if(D===$){if(!r){h=f+1;break}continue}l===-1&&(r=!1,l=f+1),D===b?d===-1?d=f:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||l===-1||g===0||g===1&&d===l-1&&d===h+1?"":t.slice(d,l)},format:s.bind(null,"/"),parse(t){k(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const h=t.charCodeAt(0)===$;let l;h?(d.root="/",l=1):l=0;let r=-1,g=0,f=-1,D=!0,p=t.length-1,v=0;for(;p>=l;--p){const y=t.charCodeAt(p);if(y===$){if(!D){g=p+1;break}continue}f===-1&&(D=!1,f=p+1),y===b?r===-1?r=p:v!==1&&(v=1):r!==-1&&(v=-1)}if(f!==-1){const y=g===0&&h?1:g;r===-1||v===0||v===1&&r===f-1&&r===g+1?d.base=d.name=t.slice(y,f):(d.name=t.slice(y,r),d.base=t.slice(y,f),d.ext=t.slice(r,f))}return g>0?d.dir=t.slice(0,g-1):h&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=c?e.$gc.normalize:e.$hc.normalize,e.$jc=c?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=c?e.$gc.join:e.$hc.join,e.$lc=c?e.$gc.resolve:e.$hc.resolve,e.$mc=c?e.$gc.relative:e.$hc.relative,e.$nc=c?e.$gc.dirname:e.$hc.dirname,e.$oc=c?e.$gc.basename:e.$hc.basename,e.$pc=c?e.$gc.extname:e.$hc.extname,e.$qc=c?e.$gc.format:e.$hc.format,e.$rc=c?e.$gc.parse:e.$hc.parse,e.$sc=c?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=c?e.$gc.sep:e.$hc.sep,e.$uc=c?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,44,17]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=b,e.$2q=$,e.$3q=E,e.$4q=R,e.$5q=I,e.$6q=w,e.$7q=S,e.$8q=k,e.$9q=c,e.$0q=m,e.$$q=r,e.$_q=g,e.$ar=f;const M=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),P=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,p,v=!1){const y=D||"",C=p||"",O=M.value.collator.compare(y,C);return M.value.collatorIsNumeric&&O===0&&y!==C?y<C?-1:1:O}function $(D,p){const v=P.value.collator;return D=D||"",p=p||"",s(v,D,p)}function E(D,p){const v=P.value.collator;return D=D||"",p=p||"",h(D,p)||s(v,D,p)}function R(D,p){const v=P.value.collator;return D=D||"",p=p||"",d(D,p)||s(v,D,p)}function I(D,p){return D=D||"",p=p||"",D===p?0:D<p?-1:1}function w(D,p){const[v,y]=n(D),[C,O]=n(p);let z=M.value.collator.compare(y,O);if(z===0){if(M.value.collatorIsNumeric&&y!==O)return y<O?-1:1;if(z=M.value.collator.compare(v,C),M.value.collatorIsNumeric&&z===0&&v!==C)return v<C?-1:1}return z}function S(D,p){D=D||"",p=p||"";const v=i(D),y=i(p),C=P.value.collator,O=A.value.collator;return s(O,v,y)||s(C,D,p)}function k(D,p){D=D||"",p=p||"";const v=i(D),y=i(p),C=P.value.collator,O=A.value.collator;return s(O,v,y)||h(D,p)||s(C,D,p)}function c(D,p){D=D||"",p=p||"";const v=i(D),y=i(p),C=P.value.collator,O=A.value.collator;return s(O,v,y)||d(D,p)||s(C,D,p)}function m(D,p){D=D||"",p=p||"";const v=i(D).toLowerCase(),y=i(p).toLowerCase();return v!==y?v<y?-1:1:D!==p?D<p?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(D,p=!1){const v=D?a.exec(D):[];let y=[v&&v[1]||"",v&&v[3]||""];return p&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const p=D?a.exec(D):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function s(D,p,v){const y=D.compare(p,v);return y!==0?y:p.length!==v.length?p.length<v.length?-1:1:0}function o(D){const p=D.charAt(0);return p.toLocaleUpperCase()!==p}function t(D){const p=D.charAt(0);return p.toLocaleLowerCase()!==p}function d(D,p){return o(D)&&t(p)?-1:t(D)&&o(p)?1:0}function h(D,p){return t(D)&&o(p)?-1:o(D)&&t(p)?1:0}function l(D,p,v=!1){return v||(D=D&&D.toLowerCase(),p=p&&p.toLowerCase()),D===p?0:D<p?-1:1}function r(D,p,v=!1){const y=D.split(N.sep),C=p.split(N.sep),O=y.length-1,z=C.length-1;let T,B;for(let j=0;;j++){if(T=O===j,B=z===j,T&&B)return b(y[j],C[j],v);if(T)return-1;if(B)return 1;const F=l(y[j],C[j],v);if(F!==0)return F}}function g(D,p,v){const y=D.toLowerCase(),C=p.toLowerCase(),O=f(D,p,v);if(O)return O;const z=y.endsWith(v),T=C.endsWith(v);if(z!==T)return z?-1:1;const B=b(y,C);return B!==0?B:y.localeCompare(C)}function f(D,p,v){const y=D.toLowerCase(),C=p.toLowerCase(),O=y.startsWith(v),z=C.startsWith(v);if(O!==z)return O?-1:1;if(O&&z){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=A,e.$bg=b,e.$cg=$,e.$dg=E,e.$eg=R,e.$fg=k,e.$gg=c,e.$hg=m,e.$ig=a,e.$jg=n,e.$kg=i,e.$lg=s,e.$mg=o,e.$ng=t,e.$og=d,e.$pg=r;function A(g){return g===47||g===92}function b(g){return g.replace(/[\\/]/g,u.$hc.sep)}function $(g){return g.indexOf("/")===-1&&(g=b(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}function E(g,f=u.$hc.sep){if(!g)return"";const D=g.length,p=g.charCodeAt(0);if(A(p)){if(A(g.charCodeAt(1))&&!A(g.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!A(g.charCodeAt(y));y++);if(C!==y&&!A(g.charCodeAt(y+1))){for(y+=1;y<D;y++)if(A(g.charCodeAt(y)))return g.slice(0,y+1).replace(/[\\/]/g,f)}}return f}else if(a(p)&&g.charCodeAt(1)===58)return A(g.charCodeAt(2))?g.slice(0,2)+f:g.slice(0,2);let v=g.indexOf("://");if(v!==-1){for(v+=3;v<D;v++)if(A(g.charCodeAt(v)))return g.slice(0,v+1)}return""}function R(g){if(!N.$i||!g||g.length<5)return!1;let f=g.charCodeAt(0);if(f!==92||(f=g.charCodeAt(1),f!==92))return!1;let D=2;const p=D;for(;D<g.length&&(f=g.charCodeAt(D),f!==92);D++);return!(p===D||(f=g.charCodeAt(D+1),isNaN(f)||f===92))}const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(g,f=N.$i){const D=f?I:w;return!(!g||g.length===0||/^\s+$/.test(g)||(D.lastIndex=0,D.test(g))||f&&S.test(g)||g==="."||g===".."||f&&g[g.length-1]==="."||f&&g.length!==g.trim().length||g.length>255)}function c(g,f,D){const p=g===f;return!D||p?p:!g||!f?!1:(0,M.$lf)(g,f)}function m(g,f,D,p=u.sep){if(g===f)return!0;if(!g||!f||f.length>g.length)return!1;if(D){if(!(0,M.$mf)(g,f))return!1;if(f.length===g.length)return!0;let y=f.length;return f.charAt(f.length-1)===p&&y--,g.charAt(y)===p}return f.charAt(f.length-1)!==p&&(f+=p),g.indexOf(f)===0}function a(g){return g>=65&&g<=90||g>=97&&g<=122}function n(g,f){return N.$i&&g.endsWith(":")&&(g+=u.sep),(0,u.$jc)(g)||(g=(0,u.$kc)(f,g)),g=(0,u.$ic)(g),N.$i?(g=(0,M.$6e)(g,u.sep),g.endsWith(":")&&(g+=u.sep)):(g=(0,M.$6e)(g,u.sep),g||(g=u.sep)),g}function i(g){const f=(0,u.$ic)(g);return N.$i?g.length>3?!1:s(f)&&(g.length===2||f.charCodeAt(2)===92):f===u.$hc.sep}function s(g,f=N.$i){return f?a(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}function o(g,f=N.$i){return s(g,f)?g[0]:void 0}function t(g,f,D){return f.length>g.length?-1:g===f?0:(D&&(g=g.toLowerCase(),f=f.toLowerCase()),g.indexOf(f))}function d(g){const f=g.split(":");let D,p,v;for(const y of f){const C=Number(y);(0,P.$Yf)(C)?p===void 0?p=C:v===void 0&&(v=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(g,f,D=8){let p="";for(let y=0;y<D;y++){let C;y===0&&N.$i&&!f&&(D===3||D===4)?C=l:C=h,p+=C.charAt(Math.floor(Math.random()*C.length))}let v;return f?v=`${f}-${p}`:v=p,g?(0,u.$kc)(g,v):v}}),define(ke[132],Ee([1,0,131,126,55,17,11,14]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=R,e.$cr=m,e.$dr=h,e.$er=v,e.$fr=B,e.$gr=F;const $=0,E=[$,[]];function R(L,G,te,Z){if(!L||!G)return E;const x=L.length,_=G.length;if(x<_)return E;const ue=L.toLowerCase();return I(G,te,_,L,ue,x,Z)}function I(L,G,te,Z,x,_,ue){const X=[],$e=[];for(let ie=0;ie<te;ie++){const ve=ie*_,Ie=ve-_,le=ie>0,ae=L[ie],ce=G[ie];for(let H=0;H<_;H++){const Q=H>0,he=ve+H,fe=he-1,Pe=Ie+H-1,be=Q?X[fe]:0,Ae=le&&Q?X[Pe]:0,Ne=le&&Q?$e[Pe]:0;let Be;!Ae&&le?Be=0:Be=w(ae,ce,Z,x,H,Ne),Be&&Ae+Be>=be&&(ue||le||x.startsWith(G,H))?($e[he]=Ne+1,X[he]=Ae+Be):($e[he]=$,X[he]=be)}}const se=[];let re=te-1,U=_-1;for(;re>=0&&U>=0;){const ie=re*_+U;$e[ie]===$||(se.push(U),re--),U--}return[X[te*_-1],se.reverse()]}function w(L,G,te,Z,x,_){let ue=0;if(!S(G,Z[x]))return ue;if(ue+=1,_>0&&(ue+=_*5),L===te[x]&&(ue+=1),x===0)ue+=8;else{const X=k(te.charCodeAt(x-1));X?ue+=X:(0,N.$mk)(te.charCodeAt(x))&&_===0&&(ue+=2)}return ue}function S(L,G){return L===G?!0:L==="/"||L==="\\"?G==="/"||G==="\\":!1}function k(L){switch(L){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(L,G,te=0,Z=0){const x=G;return x.values&&x.values.length>1?a(L,x.values,te,Z):n(L,G,te,Z)}function a(L,G,te,Z){let x=0;const _=[];for(const ue of G){const[X,$e]=n(L,ue,te,Z);if(typeof X!="number")return c;x+=X,_.push(...$e)}return[x,D(_)]}function n(L,G,te,Z){const x=(0,N.$vk)(G.original,G.originalLowercase,te,L,L.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?[x[0],(0,N.$sk)(x)]:c}const i=Object.freeze({score:0}),s=1<<18,o=1<<17,t=65536;function d(L,G,te,Z){const x=Z.values?Z.values:[Z];return(0,M.$8i)({[Z.normalized]:{values:x.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:L,description:G,allowNonContiguousMatches:te}})}function h(L,G,te,Z,x){if(!L||!G.normalized)return i;const _=Z.getItemLabel(L);if(!_)return i;const ue=Z.getItemDescription(L),X=d(_,ue,te,G),$e=x[X];if($e)return $e;const se=l(_,ue,Z.getItemPath(L),G,te);return x[X]=se,se}function l(L,G,te,Z,x){const _=!te||!Z.containsPathSeparator;return te&&(A.$k?Z.pathNormalized===te:(0,b.$lf)(Z.pathNormalized,te))?{score:s,labelMatch:[{start:0,end:L.length}],descriptionMatch:G?[{start:0,end:G.length}]:void 0}:Z.values&&Z.values.length>1?r(L,G,te,Z.values,_,x):g(L,G,te,Z,_,x)}function r(L,G,te,Z,x,_){let ue=0;const X=[],$e=[];for(const se of Z){const{score:re,labelMatch:U,descriptionMatch:ie}=g(L,G,te,se,x,_);if(re===$)return i;ue+=re,U&&X.push(...U),ie&&$e.push(...ie)}return{score:ue,labelMatch:D(X),descriptionMatch:D($e)}}function g(L,G,te,Z,x,_){if(x||!G){const[ue,X]=R(L,Z.normalized,Z.normalizedLowercase,_&&!Z.expectContiguousMatch);if(ue){const $e=(0,N.$jk)(Z.normalized,L);let se;if($e){se=o;const re=Math.round(Z.normalized.length/L.length*100);se+=re}else se=t;return{score:se+ue,labelMatch:$e||f(X)}}}if(G){let ue=G;te&&(ue=`${G}${P.sep}`);const X=ue.length,$e=`${ue}${L}`,[se,re]=R($e,Z.normalized,Z.normalizedLowercase,_&&!Z.expectContiguousMatch);if(se){const U=f(re),ie=[],ve=[];return U.forEach(Ie=>{Ie.start<X&&Ie.end>X?(ie.push({start:0,end:Ie.end-X}),ve.push({start:Ie.start,end:X})):Ie.start>=X?ie.push({start:Ie.start-X,end:Ie.end-X}):ve.push(Ie)}),{score:se,labelMatch:ie,descriptionMatch:ve}}}return i}function f(L){const G=[];if(!L)return G;let te;for(const Z of L)te&&te.end===Z?te.end+=1:(te={start:Z,end:Z+1},G.push(te));return G}function D(L){const G=L.sort((x,_)=>x.start-_.start),te=[];let Z;for(const x of G)!Z||!p(Z,x)?(Z=x,te.push(x)):(Z.start=Math.min(Z.start,x.start),Z.end=Math.max(Z.end,x.end));return te}function p(L,G){return!(L.end<G.start||G.end<L.start)}function v(L,G,te,Z,x,_){const ue=h(L,te,Z,x,_),X=h(G,te,Z,x,_),$e=ue.score,se=X.score;if(($e===s||se===s)&&$e!==se)return $e===s?-1:1;if($e>t||se>t){if($e!==se)return $e>se?-1:1;if($e<o&&se<o){const ae=C(ue.labelMatch,X.labelMatch);if(ae!==0)return ae}const Ie=x.getItemLabel(L)||"",le=x.getItemLabel(G)||"";if(Ie.length!==le.length)return Ie.length-le.length}if($e!==se)return $e>se?-1:1;const re=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,U=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(re&&!U)return-1;if(U&&!re)return 1;const ie=y(L,ue,x),ve=y(G,X,x);return ie&&ve&&ie!==ve?ve>ie?-1:1:O(L,G,te,x)}function y(L,G,te){let Z=-1,x=-1;if(G.descriptionMatch&&G.descriptionMatch.length?Z=G.descriptionMatch[0].start:G.labelMatch&&G.labelMatch.length&&(Z=G.labelMatch[0].start),G.labelMatch&&G.labelMatch.length){if(x=G.labelMatch[G.labelMatch.length-1].end,G.descriptionMatch&&G.descriptionMatch.length){const _=te.getItemDescription(L);_&&(x+=_.length)}}else G.descriptionMatch&&G.descriptionMatch.length&&(x=G.descriptionMatch[G.descriptionMatch.length-1].end);return x-Z}function C(L,G){if(!L&&!G||(!L||!L.length)&&(!G||!G.length))return 0;if(!G||!G.length)return-1;if(!L||!L.length)return 1;const te=L[0].start,x=L[L.length-1].end-te,_=G[0].start,X=G[G.length-1].end-_;return x===X?0:X<x?1:-1}function O(L,G,te,Z){const x=Z.getItemLabel(L)||"",_=Z.getItemLabel(G)||"",ue=Z.getItemDescription(L),X=Z.getItemDescription(G),$e=x.length+(ue?ue.length:0),se=_.length+(X?X.length:0);if($e!==se)return $e-se;const re=Z.getItemPath(L),U=Z.getItemPath(G);return re&&U&&re.length!==U.length?re.length-U.length:x!==_?(0,u.$_q)(x,_,te.normalized):ue&&X&&ue!==X?(0,u.$_q)(ue,X,te.normalized):re&&U&&re!==U?(0,u.$_q)(re,U,te.normalized):0}function z(L){return L.startsWith('"')&&L.endsWith('"')}const T=" ";function B(L){typeof L!="string"&&(L="");const G=L.toLowerCase(),{pathNormalized:te,normalized:Z,normalizedLowercase:x}=j(L),_=te.indexOf(P.sep)>=0,ue=z(L);let X;const $e=L.split(T);if($e.length>1)for(const se of $e){const re=z(se),{pathNormalized:U,normalized:ie,normalizedLowercase:ve}=j(se);ie&&(X||(X=[]),X.push({original:se,originalLowercase:se.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:ve,expectContiguousMatch:re}))}return{original:L,originalLowercase:G,pathNormalized:te,normalized:Z,normalizedLowercase:x,values:X,containsPathSeparator:_,expectContiguousMatch:ue}}function j(L){let G;A.$i?G=L.replace(/\//g,P.sep):G=L.replace(/\\/g,P.sep);const te=(0,b.$8e)(G).replace(/\s|"/g,"");return{pathNormalized:G,normalized:te,normalizedLowercase:te.toLowerCase()}}function F(L){return Array.isArray(L)?B(L.map(G=>G.original).join(T)):B(L.original)}}),define(ke[101],Ee([1,0,17]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0,e.$ys=P,e.$zs=A,e.$As=b,e.$Bs=E,e.$xs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const I=(0,u.$pc)(R),w=N[I.toLowerCase()];return w!==void 0?w:A(R)}function A(R){const I=(0,u.$pc)(R);return M[I.toLowerCase()]}function b(R){for(const I in M)if(M[I]===R)return I}const $=/^(.+)\/(.+?)(;.+)?$/;function E(R,I){const w=$.exec(R);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:R}}),define(ke[102],Ee([1,0,11]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$0l=P,e.$$l=A;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var M;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(M||(e.TerminateResponseCode=M={}));function P(b,...$){const E=$.reduce((w,S)=>(w[S]=!0,w),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(w=>!E[w]).forEach(w=>{for(let S=0;S<R.length;S++)if(w.search(R[S])!==-1){delete b[w];break}})}function A(b){b&&(delete b.DEBUG,u.$j&&delete b.DYLD_LIBRARY_PATH,u.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=k,e.$xc=s;const M=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function b(l,r){if(!l.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!M.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!P.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,r){return!l&&!r?"file":l}function E(l,r){switch(l){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const R="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(r){return r instanceof S?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,g,f,D,p,v=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=$(r,v),this.authority=g||R,this.path=E(this.scheme,f||R),this.query=D||R,this.fragment=p||R,b(this,v))}get fsPath(){return s(this,!1)}with(r){if(!r)return this;let{scheme:g,authority:f,path:D,query:p,fragment:v}=r;return g===void 0?g=this.scheme:g===null&&(g=R),f===void 0?f=this.authority:f===null&&(f=R),D===void 0?D=this.path:D===null&&(D=R),p===void 0?p=this.query:p===null&&(p=R),v===void 0?v=this.fragment:v===null&&(v=R),g===this.scheme&&f===this.authority&&D===this.path&&p===this.query&&v===this.fragment?this:new m(g,f,D,p,v)}static parse(r,g=!1){const f=w.exec(r);return f?new m(f[2]||R,h(f[4]||R),h(f[5]||R),h(f[7]||R),h(f[9]||R),g):new m(R,R,R,R,R)}static file(r){let g=R;if(N.$i&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const f=r.indexOf(I,2);f===-1?(g=r.substring(2),r=I):(g=r.substring(2,f),r=r.substring(f)||I)}return new m("file",g,r,R,R)}static from(r,g){return new m(r.scheme,r.authority,r.path,r.query,r.fragment,g)}static joinPath(r,...g){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return N.$i&&r.scheme==="file"?f=S.file(u.$gc.join(s(r,!0),...g)).path:f=u.$hc.join(r.path,...g),r.with({path:f})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof S)return r;{const g=new m(r);return g._formatted=r.external??null,g._fsPath=r._sep===c?r.fsPath??null:null,g}}else return r}}e.URI=S;function k(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const c=N.$i?1:void 0;class m extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=c),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,r,g){let f,D=-1;for(let p=0;p<l.length;p++){const v=l.charCodeAt(p);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||r&&v===47||g&&v===91||g&&v===93||g&&v===58)D!==-1&&(f+=encodeURIComponent(l.substring(D,p)),D=-1),f!==void 0&&(f+=l.charAt(p));else{f===void 0&&(f=l.substr(0,p));const y=a[v];y!==void 0?(D!==-1&&(f+=encodeURIComponent(l.substring(D,p)),D=-1),f+=y):D===-1&&(D=p)}}return D!==-1&&(f+=encodeURIComponent(l.substring(D))),f!==void 0?f:l}function i(l){let r;for(let g=0;g<l.length;g++){const f=l.charCodeAt(g);f===35||f===63?(r===void 0&&(r=l.substr(0,g)),r+=a[f]):r!==void 0&&(r+=l[g])}return r!==void 0?r:l}function s(l,r){let g;return l.authority&&l.path.length>1&&l.scheme==="file"?g=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?r?g=l.path.substr(1):g=l.path[1].toLowerCase()+l.path.substr(2):g=l.path,N.$i&&(g=g.replace(/\//g,"\\")),g}function o(l,r){const g=r?i:n;let f="",{scheme:D,authority:p,path:v,query:y,fragment:C}=l;if(D&&(f+=D,f+=":"),(p||D==="file")&&(f+=I,f+=I),p){let O=p.indexOf("@");if(O!==-1){const z=p.substr(0,O);p=p.substr(O+1),O=z.lastIndexOf(":"),O===-1?f+=g(z,!1,!1):(f+=g(z.substr(0,O),!1,!1),f+=":",f+=g(z.substr(O+1),!1,!0)),f+="@"}p=p.toLowerCase(),O=p.lastIndexOf(":"),O===-1?f+=g(p,!1,!0):(f+=g(p.substr(0,O),!1,!0),f+=p.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}f+=g(v,!0,!1)}return y&&(f+="?",f+=g(y,!1,!1)),C&&(f+="#",f+=r?C:n(C,!1,!1)),f}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(l){return l.match(d)?l.replace(d,r=>t(r)):l}}),define(ke[191],Ee([1,0,2]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=N,e.$Eq=M,e.$Fq=P,e.log=b;function N(E){const R=E;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function M(E){const R=[];let I;try{const w=JSON.parse(E.arguments),S=w[w.length-1];S&&S.__$stack&&(w.pop(),I=S.__$stack),R.push(...w)}catch{R.push("Unable to log remote console arguments",E.arguments)}return{args:R,stack:I}}function P(E){if(typeof E!="string")return P(M(E).stack);const R=E;if(R){const I=A(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:u.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function A(E){if(!E)return E;const R=E.indexOf(`
`);return R===-1?E:E.substring(0,R)}function b(E,R){const{args:I,stack:w}=M(E),S=typeof I[0]=="string"&&I.length===1;let k=A(w);k&&(k=`(${k.trim()})`);let c=[];if(typeof I[0]=="string"?k&&S?c=[`%c[${R}] %c${I[0]} %c${k}`,$("blue"),$(""),$("grey")]:c=[`%c[${R}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:c=[`%c[${R}]%`,$("blue"),...I],k&&!S&&c.push(k),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,c)}function $(E){return`color: ${E}`}}),define(ke[57],Ee([1,0,21,2]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=M,e.$Ph=P,e.$Qh=b;function M($){return JSON.stringify($,A)}function P($){let E=JSON.parse($);return E=b(E),E}function A($,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b($,E=0){if(!$||E>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof u.$ue||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=b($[R],E+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=b($[R],E+1))}return $}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=$,e.$rg=E,e.$vg=I;var b;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeManagedRemoteResource="vscode-managed-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.vscodeChatCodeBlock="vscode-chat-code-block",k.vscodeChatSesssion="vscode-chat-editor",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm",k.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(k,c){return P.URI.isUri(k)?(0,M.$lf)(k.scheme,c):(0,M.$mf)(k,c+":")}function E(k,...c){return c.some(m=>$(k,m))}e.$sg="vscode-tkn",e.$tg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,m){this.f=I(c,m)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,b.vscodeRemoteResource)}set(c,m,a){this.a[c]=m,this.b[c]=a}setConnectionToken(c,m){this.c[c]=m}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(o){return u.$1(o),c}const m=c.authority;let a=this.a[m];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[m],i=this.c[m];let s=`path=${encodeURIComponent(c.path)}`;return typeof i=="string"&&(s+=`&${e.$tg}=${encodeURIComponent(i)}`),P.URI.from({scheme:N.$o?this.d:b.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:s})}}e.$ug=new R;function I(k,c){return A.$hc.join(c??"/",`${k.quality??"oss"}-${k.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class w{static{this.a=e.$Ag}asBrowserUri(c){const m=this.b(c,de);return this.uriToBrowserUri(m)}uriToBrowserUri(c){return c.scheme===b.vscodeRemote?e.$ug.rewrite(c):c.scheme===b.file&&(N.$m||N.$q===`${b.vscodeFileResource}://${w.a}`)?c.with({scheme:b.vscodeFileResource,authority:c.authority||w.a,query:null,fragment:null}):c}asFileUri(c){const m=this.b(c,de);return this.uriToFileUri(m)}uriToFileUri(c){return c.scheme===b.vscodeFileResource?c.with({scheme:b.file,authority:c.authority!==w.a?c.authority:null,query:null,fragment:null}):c}b(c,m){return P.URI.isUri(c)?c:P.URI.parse(m.toUrl(c))}}e.$Bg=new w;var S;(function(k){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(c.get("3"));const m="vscode-coi";function a(i){let s;typeof i=="string"?s=new URL(i).searchParams:i instanceof URL?s=i.searchParams:P.URI.isUri(i)&&(s=new URL(i.toString(!0)).searchParams);const o=s?.get(m);if(o)return c.get(o)}k.getHeadersFromQuery=a;function n(i,s,o){if(!globalThis.crossOriginIsolated)return;const t=s&&o?"3":o?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}k.addSearchParam=n})(S||(e.COI=S={}))}),define(ke[192],Ee([1,0,161,15,11,2]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CD=R;class A{constructor(w,S,k){this.id=w,this.dependencies=S,this.callback=k}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,S,k)=>{typeof w!="string"&&(k=S,S=w,w=null),(typeof S!="object"||!Array.isArray(S))&&(k=S,S=null),this.c.push(new A(w,S,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const S=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!S)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(w){return new Promise((S,k)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",a),c.removeEventListener("error",n)},a=i=>{m(),S(this.c.pop())},n=i=>{m(),k(i)};c.addEventListener("load",a),c.addEventListener("error",n),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((S,k)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),S(this.c.pop())}catch(c){k(c)}})}async j(w){try{const S=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(w).fsPath,a=S.readFileSync(m).toString(),n=c.wrap(a.replace(/^#!.*/,""));return new k.Script(n).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const $=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function R(I,w,S){if(u.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[I]&&(I=E[I]);const k=`${I}/${w}`;if($.has(k))return $.get(k);let c;if(/^\w[\w\d+.-]*:\/\//.test(k))c=k;else{const i=`${S&&!M.$o?N.$yg:N.$xg}/${k}`;c=N.$Bg.asBrowserUri(i).toString(!0)}const m=b.INSTANCE.load(c);return $.set(k,m),m}else return await new Promise((k,c)=>{de([I],k,c)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=$,e.$4g=R,e.$5g=w;function $(S){return(0,b.$xc)(S,!0)}class E{constructor(k){this.a=k}compare(k,c,m=!1){return k===c?0:(0,A.$ef)(this.getComparisonKey(k,m),this.getComparisonKey(c,m))}isEqual(k,c,m=!1){return k===c?!0:!k||!c?!1:this.getComparisonKey(k,m)===this.getComparisonKey(c,m)}getComparisonKey(k,c=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,c,m=!1){if(k.scheme===c.scheme){if(k.scheme===N.Schemas.file)return u.$hg($(k),$(c),this.a(k))&&k.query===c.query&&(m||k.fragment===c.fragment);if((0,e.$Zg)(k.authority,c.authority))return u.$hg(k.path,c.path,this.a(k),"/")&&k.query===c.query&&(m||k.fragment===c.fragment)}return!1}joinPath(k,...c){return b.URI.joinPath(k,...c)}basenameOrAuthority(k){return(0,e.$Rg)(k)||k.authority}basename(k){return M.$hc.basename(k.path)}extname(k){return M.$hc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let c;return k.scheme===N.Schemas.file?c=b.URI.file(M.$nc($(k))).path:(c=M.$hc.dirname(k.path),k.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),c="/")),k.with({path:c})}normalizePath(k){if(!k.path.length)return k;let c;return k.scheme===N.Schemas.file?c=b.URI.file(M.$ic($(k))).path:c=M.$hc.normalize(k.path),k.with({path:c})}relativePath(k,c){if(k.scheme!==c.scheme||!(0,e.$Zg)(k.authority,c.authority))return;if(k.scheme===N.Schemas.file){const n=M.$mc($(k),$(c));return P.$i?u.$bg(n):n}let m=k.path||"/";const a=c.path||"/";if(this.a(k)){let n=0;for(const i=Math.min(m.length,a.length);n<i&&!(m.charCodeAt(n)!==a.charCodeAt(n)&&m.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);m=a.substr(0,n)+m.substr(n)}return M.$hc.relative(m,a)}resolvePath(k,c){if(k.scheme===N.Schemas.file){const m=b.URI.file(M.$lc($(k),c));return k.with({authority:m.authority,path:m.path})}return c=u.$cg(c),k.with({path:M.$hc.resolve(k.path,c)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,c){return k===c||k!==void 0&&c!==void 0&&(0,A.$lf)(k,c)}hasTrailingPathSeparator(k,c=M.sep){if(k.scheme===N.Schemas.file){const m=$(k);return m.length>u.$dg(m).length&&m[m.length-1]===c}else{const m=k.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,c=M.sep){return(0,e.$1g)(k,c)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,c=M.sep){let m=!1;if(k.scheme===N.Schemas.file){const a=$(k);m=a!==void 0&&a.length===u.$dg(a).length&&a[a.length-1]===c}else{c="/";const a=k.path;m=a.length===1&&a.charCodeAt(a.length-1)===47}return!m&&!(0,e.$1g)(k,c)?k.with({path:k.path+"/"}):k}}e.$Jg=E,e.$Kg=new E(()=>!1),e.$Lg=new E(S=>S.scheme===N.Schemas.file?!P.$k:!0),e.$Mg=new E(S=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function R(S,k){const c=[];for(let m=0;m<S.length;m++){const a=k(S[m]);S.some((n,i)=>i===m?!1:(0,e.$Og)(a,k(n)))||c.push(S[m])}return c}var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function k(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(i=>{const[s,o]=i.split(":");s&&o&&m.set(s,o)});const n=c.path.substring(0,c.path.indexOf(";"));return n&&m.set(S.META_DATA_MIME,n),m}S.parseMetaData=k})(I||(e.DataUri=I={}));function w(S,k,c){if(k){let m=S.path;return m&&m[0]!==M.$hc.sep&&(m=M.$hc.sep+m),S.with({scheme:c,authority:k,path:m})}return S.with({scheme:c})}}),define(ke[8],Ee([1,0,22,13,4,3,23,11,168,44]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=R,e.$7g=I,e.$8g=w,e.$9g=S,e.$0g=k,e.$$g=c,e.$_g=m,e.$ah=a,e.$ih=g,e.$jh=f,e.$kh=D,e.$lh=p,e.$mh=v,e.$Bh=x,e.$Jh=le;function R(ce){return!!ce&&typeof ce.then=="function"}function I(ce){const H=new u.$ee,Q=ce(H.token),he=new Promise((fe,Pe)=>{const be=H.token.onCancellationRequested(()=>{be.dispose(),Pe(new N.$5)});Promise.resolve(Q).then(Ae=>{be.dispose(),H.dispose(),fe(Ae)},Ae=>{be.dispose(),H.dispose(),Pe(Ae)})});return new class{cancel(){H.cancel(),H.dispose()}then(fe,Pe){return he.then(fe,Pe)}catch(fe){return this.then(void 0,fe)}finally(fe){return he.finally(fe)}}}function w(ce,H,Q){return new Promise((he,fe)=>{const Pe=H.onCancellationRequested(()=>{Pe.dispose(),he(Q)});ce.then(he,fe).finally(()=>Pe.dispose())})}function S(ce,H){return new Promise((Q,he)=>{const fe=H.onCancellationRequested(()=>{fe.dispose(),he(new N.$5)});ce.then(Q,he).finally(()=>fe.dispose())})}async function k(ce){let H=-1;const Q=ce.map((he,fe)=>he.then(Pe=>(H=fe,Pe)));try{return await Promise.race(Q)}finally{ce.forEach((he,fe)=>{fe!==H&&he.cancel()})}}function c(ce,H,Q){let he;const fe=setTimeout(()=>{he?.(void 0),Q?.()},H);return Promise.race([ce.finally(()=>clearTimeout(fe)),new Promise(Pe=>he=Pe)])}function m(ce){return new Promise((H,Q)=>{const he=ce();R(he)?he.then(H,Q):H(he)})}function a(){let ce,H;return{promise:new Promise((he,fe)=>{ce=he,H=fe}),resolve:ce,reject:H}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const Q=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Q,Q).then(he)})}return new Promise((Q,he)=>{this.b.then(Q,he)})}return this.a=H(),new Promise((Q,he)=>{this.a.then(fe=>{this.a=null,Q(fe)},fe=>{this.a=null,he(fe)})})}dispose(){this.f=!0}}e.$bh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$ch=i;class s{constructor(){this.a=new Map}queue(H,Q){const fe=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(H)===fe&&this.a.delete(H)});return this.a.set(H,fe),fe}}e.$dh=s;const o=(ce,H)=>{let Q=!0;const he=setTimeout(()=>{Q=!1,H()},ce);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(he),Q=!1}}},t=ce=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,ce())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class d{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,Q=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((fe,Pe)=>{this.d=fe,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Q===$.$4d?t(he):o(Q,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=d;class h{constructor(H){this.a=new d(H),this.b=new n}trigger(H,Q){return this.a.trigger(()=>this.b.queue(H),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=h;class l{constructor(){this.a=!1,this.b=new Promise((H,Q)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=l;class r extends l{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$hh=r;function g(ce,H){return H?new Promise((Q,he)=>{const fe=setTimeout(()=>{Pe.dispose(),Q()},ce),Pe=H.onCancellationRequested(()=>{clearTimeout(fe),Pe.dispose(),he(new N.$5)})}):I(Q=>g(ce,Q))}function f(ce,H=0,Q){const he=setTimeout(()=>{ce(),Q&&fe.dispose()},H),fe=(0,P.$Sc)(()=>{clearTimeout(he),Q?.deleteAndLeak(fe)});return Q?.add(fe),fe}function D(ce){const H=[];let Q=0;const he=ce.length;function fe(){return Q<he?ce[Q++]():null}function Pe(be){be!=null&&H.push(be);const Ae=fe();return Ae?Ae.then(Pe):Promise.resolve(H)}return Promise.resolve(null).then(Pe)}function p(ce,H=he=>!!he,Q=null){let he=0;const fe=ce.length,Pe=()=>{if(he>=fe)return Promise.resolve(Q);const be=ce[he++];return Promise.resolve(be()).then(Ne=>H(Ne)?Promise.resolve(Ne):Pe())};return Pe()}function v(ce,H=he=>!!he,Q=null){if(ce.length===0)return Promise.resolve(Q);let he=ce.length;const fe=()=>{he=-1;for(const Pe of ce)Pe.cancel?.()};return new Promise((Pe,be)=>{for(const Ae of ce)Ae.then(Ne=>{--he>=0&&H(Ne)?(fe(),Pe(Ne)):he===0&&Pe(Q)}).catch(Ne=>{--he>=0&&(fe(),be(Ne))})})}class y{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new M.$7d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,he)=>{this.g.push({factory:H,c:Q,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const Q=H.factory();Q.then(H.c,H.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=y;class C extends y{constructor(){super(1)}}e.$oh=C;class O{constructor(){this.a=new _,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$ph=O;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new $e;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,Q=A.$Kg){const he=Q.getComparisonKey(H);return this.a.get(he)?.size??0}queueFor(H,Q,he=A.$Kg){const fe=he.getComparisonKey(H);let Pe=this.a.get(fe);if(!Pe){Pe=new C;const be=this.f++,Ae=M.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$4c),this.d.set(be,Ae),this.a.set(fe,Pe)}return Pe.queue(Q)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=z;class T{constructor(H,Q){this.a=-1,typeof H=="function"&&typeof Q=="number"&&this.setIfNotSet(H,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},Q)}setIfNotSet(H,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},Q))}}e.$rh=T;class B{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,Q,he=globalThis){this.cancel();const fe=he.setInterval(()=>{H()},Q);this.d=(0,P.$Sc)(()=>{he.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$sh=B;class j{constructor(H,Q){this.b=-1,this.a=H,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=j;class F{constructor(H,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=H,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=F;class L extends j{constructor(H,Q){super(H,Q),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$vh=L;class G extends P.$Uc{constructor(H,Q){super(),this.g=H,this.h=Q,this.a=[],this.b=this.B(new P.$Vc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of H)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(ce,H)=>{(0,b.$B)(()=>{if(Q)return;const he=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$yh=(ce,H,Q)=>{const he=ce.requestIdleCallback(H,typeof Q=="number"?{timeout:Q}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ce.cancelIdleCallback(he))}}},e.$xh=ce=>(0,e.$yh)(globalThis,ce)}();class te{constructor(H,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$yh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=te;class Z extends te{constructor(H){super(globalThis,H)}}e.$Ah=Z;async function x(ce,H,Q){let he;for(let fe=0;fe<Q;fe++)try{return await ce()}catch(Pe){he=Pe,await g(H)}throw he}class _{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,Q,he){return this.a={taskId:H,cancel:()=>he?.(),promise:Q},Q.then(()=>this.d(H),()=>this.d(H)),Q}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:Q,resolve:he,reject:fe}=a();this.b={run:H,promise:Q,promiseResolve:he,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=_;class ue{constructor(H,Q=()=>Date.now()){this.d=H,this.f=Q,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Dh=ue;var X;(function(ce){ce[ce.Resolved=0]="Resolved",ce[ce.Rejected=1]="Rejected"})(X||(X={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,Q)=>{this.a=H,this.b=Q})}complete(H){return new Promise(Q=>{this.a(H),this.d={outcome:0,value:H},Q()})}error(H){return new Promise(Q=>{this.b(H),this.d={outcome:1,value:H},Q()})}cancel(){return this.error(new N.$5)}}e.$Eh=$e;var se;(function(ce){async function H(he){let fe;const Pe=await Promise.all(he.map(be=>be.then(Ae=>Ae,Ae=>{fe||(fe=Ae)})));if(typeof fe<"u")throw fe;return Pe}ce.settled=H;function Q(he){return new Promise(async(fe,Pe)=>{try{await he(fe,Pe)}catch(be){Pe(be)}})}ce.withAsyncBody=Q})(se||(e.Promises=se={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=re;class U{constructor(H){this.b=H,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=U;var ie;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(ie||(ie={}));class ve{static fromArray(H){return new ve(Q=>{Q.emitMany(H)})}static fromPromise(H){return new ve(async Q=>{Q.emitMany(await H)})}static fromPromises(H){return new ve(async Q=>{await Promise.all(H.map(async he=>Q.emitOne(await he)))})}static merge(H){return new ve(async Q=>{await Promise.all(H.map(async he=>{for await(const fe of he)Q.emitOne(fe)}))})}static{this.EMPTY=ve.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new M.$7d,queueMicrotask(async()=>{const Q={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(H(Q)),this.j()}catch(he){this.k(he)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(H,Q){return new ve(async he=>{for await(const fe of H)he.emitOne(Q(fe))})}map(H){return ve.map(this,H)}static filter(H,Q){return new ve(async he=>{for await(const fe of H)Q(fe)&&he.emitOne(fe)})}filter(H){return ve.filter(this,H)}static coalesce(H){return ve.filter(H,Q=>!!Q)}coalesce(){return ve.coalesce(this)}static async toPromise(H){const Q=[];for await(const he of H)Q.push(he);return Q}toPromise(){return ve.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$Hh=ve;class Ie extends ve{constructor(H,Q){super(Q),this.l=H}cancel(){this.l.cancel()}}e.$Ih=Ie;function le(ce){const H=new u.$ee,Q=ce(H.token);return new Ie(H,async he=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),he.reject(new N.$5)});try{for await(const Pe of Q){if(H.token.isCancellationRequested)return;he.emitOne(Pe)}fe.dispose(),H.dispose()}catch(Pe){fe.dispose(),H.dispose(),he.reject(Pe)}})}class ae{constructor(){this.a=new $e,this.b=new ve(he=>{if(H){he.reject(H);return}return Q&&he.emitMany(Q),this.d=fe=>he.reject(fe),this.f=fe=>he.emitOne(fe),this.a.p});let H,Q;this.f=he=>{Q||(Q=[]),Q.push(he)},this.d=he=>{H||(H=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$Kh=ae}),define(ke[35],Ee([1,0,19,8,34,28,17,11,14]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=E,e.$_j=k,e.$ak=C,e.$bk=O,e.$ck=z,e.$dk=T,e.$ek=B,e.$fk=G;function E(){return Object.create(null)}e.$0j="**",e.$$j="/";const R="[/\\\\]",I="[^/\\\\]",w=/\//g;function S(te,Z){switch(te){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${Z?`|${R}${I}+`:""})*?`}}function k(te,Z){if(!te)return[];const x=[];let _=!1,ue=!1,X="";for(const $e of te){switch($e){case Z:if(!_&&!ue){x.push(X),X="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}X+=$e}return X&&x.push(X),x}function c(te){if(!te)return"";let Z="";const x=k(te,e.$$j);if(x.every(_=>_===e.$0j))Z=".*";else{let _=!1;x.forEach((ue,X)=>{if(ue===e.$0j){if(_)return;Z+=S(2,X===x.length-1)}else{let $e=!1,se="",re=!1,U="";for(const ie of ue){if(ie!=="}"&&$e){se+=ie;continue}if(re&&(ie!=="]"||!U)){let ve;ie==="-"?ve=ie:(ie==="^"||ie==="!")&&!U?ve="^":ie===e.$$j?ve="":ve=(0,$.$Ze)(ie),U+=ve;continue}switch(ie){case"{":$e=!0;continue;case"[":re=!0;continue;case"}":{const Ie=`(?:${k(se,",").map(le=>c(le)).join("|")})`;Z+=Ie,$e=!1,se="";break}case"]":{Z+="["+U+"]",re=!1,U="";break}case"?":Z+=I;continue;case"*":Z+=S(1);continue;default:Z+=(0,$.$Ze)(ie)}}X<x.length-1&&(x[X+1]!==e.$0j||X+2<x.length)&&(Z+=R)}_=ue===e.$0j})}return Z}const m=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Ec(1e4),d=function(){return!1},h=function(){return null};function l(te,Z){if(!te)return h;let x;typeof te!="string"?x=te.pattern:x=te,x=x.trim();const _=`${x}_${!!Z.trimForExclusions}`;let ue=t.get(_);if(ue)return r(ue,te);let X;return m.test(x)?ue=f(x.substr(4),x):(X=a.exec(g(x,Z)))?ue=D(X[1],x):(Z.trimForExclusions?i:n).test(x)?ue=p(x,Z):(X=s.exec(g(x,Z)))?ue=v(X[1].substr(1),x,!0):(X=o.exec(g(x,Z)))?ue=v(X[1],x,!1):ue=y(x),t.set(_,ue),r(ue,te)}function r(te,Z){if(typeof Z=="string")return te;const x=function(_,ue){return(0,M.$hg)(_,Z.base,!b.$k)?te((0,$.$5e)(_.substr(Z.base.length),A.sep),ue):null};return x.allBasenames=te.allBasenames,x.allPaths=te.allPaths,x.basenames=te.basenames,x.patterns=te.patterns,x}function g(te,Z){return Z.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function f(te,Z){return function(x,_){return typeof x=="string"&&x.endsWith(te)?Z:null}}function D(te,Z){const x=`/${te}`,_=`\\${te}`,ue=function($e,se){return typeof $e!="string"?null:se?se===te?Z:null:$e===te||$e.endsWith(x)||$e.endsWith(_)?Z:null},X=[te];return ue.basenames=X,ue.patterns=[Z],ue.allBasenames=X,ue}function p(te,Z){const x=L(te.slice(1,-1).split(",").map(se=>l(se,Z)).filter(se=>se!==h),te),_=x.length;if(!_)return h;if(_===1)return x[0];const ue=function(se,re){for(let U=0,ie=x.length;U<ie;U++)if(x[U](se,re))return te;return null},X=x.find(se=>!!se.allBasenames);X&&(ue.allBasenames=X.allBasenames);const $e=x.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return $e.length&&(ue.allPaths=$e),ue}function v(te,Z,x){const _=A.sep===A.$hc.sep,ue=_?te:te.replace(w,A.sep),X=A.sep+ue,$e=A.$hc.sep+te;let se;return x?se=function(re,U){return typeof re=="string"&&(re===ue||re.endsWith(X)||!_&&(re===te||re.endsWith($e)))?Z:null}:se=function(re,U){return typeof re=="string"&&(re===ue||!_&&re===te)?Z:null},se.allPaths=[(x?"*/":"./")+te],se}function y(te){try{const Z=new RegExp(`^${c(te)}$`);return function(x){return Z.lastIndex=0,typeof x=="string"&&Z.test(x)?te:null}}catch{return h}}function C(te,Z,x){return!te||typeof Z!="string"?!1:O(te)(Z,void 0,x)}function O(te,Z={}){if(!te)return d;if(typeof te=="string"||z(te)){const x=l(te,Z);if(x===h)return d;const _=function(ue,X){return!!x(ue,X)};return x.allBasenames&&(_.allBasenames=x.allBasenames),x.allPaths&&(_.allPaths=x.allPaths),_}return j(te,Z)}function z(te){const Z=te;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}function T(te){return te.allBasenames||[]}function B(te){return te.allPaths||[]}function j(te,Z){const x=L(Object.getOwnPropertyNames(te).map(se=>F(se,te[se],Z)).filter(se=>se!==h)),_=x.length;if(!_)return h;if(!x.some(se=>!!se.requiresSiblings)){if(_===1)return x[0];const se=function(ie,ve){let Ie;for(let le=0,ae=x.length;le<ae;le++){const ce=x[le](ie,ve);if(typeof ce=="string")return ce;(0,N.$6g)(ce)&&(Ie||(Ie=[]),Ie.push(ce))}return Ie?(async()=>{for(const le of Ie){const ae=await le;if(typeof ae=="string")return ae}return null})():null},re=x.find(ie=>!!ie.allBasenames);re&&(se.allBasenames=re.allBasenames);const U=x.reduce((ie,ve)=>ve.allPaths?ie.concat(ve.allPaths):ie,[]);return U.length&&(se.allPaths=U),se}const ue=function(se,re,U){let ie,ve;for(let Ie=0,le=x.length;Ie<le;Ie++){const ae=x[Ie];ae.requiresSiblings&&U&&(re||(re=(0,A.$oc)(se)),ie||(ie=re.substr(0,re.length-(0,A.$pc)(se).length)));const ce=ae(se,re,ie,U);if(typeof ce=="string")return ce;(0,N.$6g)(ce)&&(ve||(ve=[]),ve.push(ce))}return ve?(async()=>{for(const Ie of ve){const le=await Ie;if(typeof le=="string")return le}return null})():null},X=x.find(se=>!!se.allBasenames);X&&(ue.allBasenames=X.allBasenames);const $e=x.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return $e.length&&(ue.allPaths=$e),ue}function F(te,Z,x){if(Z===!1)return h;const _=l(te,x);if(_===h)return h;if(typeof Z=="boolean")return _;if(Z){const ue=Z.when;if(typeof ue=="string"){const X=($e,se,re,U)=>{if(!U||!_($e,se))return null;const ie=ue.replace("$(basename)",()=>re),ve=U(ie);return(0,N.$6g)(ve)?ve.then(Ie=>Ie?te:null):ve?te:null};return X.requiresSiblings=!0,X}}return _}function L(te,Z){const x=te.filter(se=>!!se.basenames);if(x.length<2)return te;const _=x.reduce((se,re)=>{const U=re.basenames;return U?se.concat(U):se},[]);let ue;if(Z){ue=[];for(let se=0,re=_.length;se<re;se++)ue.push(Z)}else ue=x.reduce((se,re)=>{const U=re.patterns;return U?se.concat(U):se},[]);const X=function(se,re){if(typeof se!="string")return null;if(!re){let ie;for(ie=se.length;ie>0;ie--){const ve=se.charCodeAt(ie-1);if(ve===47||ve===92)break}re=se.substr(ie)}const U=_.indexOf(re);return U!==-1?ue[U]:null};X.basenames=_,X.patterns=ue,X.allBasenames=_;const $e=te.filter(se=>!se.basenames);return $e.push(X),$e}function G(te,Z){return(0,u.$ub)(te,Z,(x,_)=>typeof x=="string"&&typeof _=="string"?x===_:typeof x!="string"&&typeof _!="string"?x.base===_.base&&x.pattern===_.pattern:!1)}}),define(ke[79],Ee([1,0,13,170,23,14,2]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.MarkdownStringTextNewlineStyle=void 0,e.$Fk=E,e.$Gk=R,e.$Hk=I,e.$Ik=w,e.$Jk=S,e.$Kk=k,e.$Lk=c,e.$Mk=m;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=w(this.supportThemeIcons?(0,N.$yk)(n):n).replace(/([ \t]+)/g,(s,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${S(i,n)}
`,this}appendLink(n,i,s){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(n,i){const s=new RegExp((0,P.$Ze)(i),"g");return n.replace(s,(o,t)=>n.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$Ek=$;function E(a){return R(a)?!a.value:Array.isArray(a)?a.every(E):!0}function R(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function I(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,M.$Ng)(A.URI.from(a.baseUri),A.URI.from(n.baseUri)))}function w(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(a,n){const i=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,s=i>=3?i+1:3;return[`${"`".repeat(s)}${n}`,a,`${"`".repeat(s)}`].join(`
`)}function k(a){return a.replace(/"/g,"&quot;")}function c(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(a){const n=[],i=a.split("|").map(o=>o.trim());a=i[0];const s=i[1];if(s){const o=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),d=o?o[1]:"",h=t?t[1]:"",l=isFinite(parseInt(h)),r=isFinite(parseInt(d));l&&n.push(`width="${h}"`),r&&n.push(`height="${d}"`)}return{href:a,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=$,e.$fw=R,e.$gw=w,e.$hw=S,e.$iw=a,e.$jw=i,e.$kw=s,e.$lw=o,e.$mw=t,e.$nw=d;function $(l,r){const{os:g,tildify:f,relative:D}=r;if(D){const y=E(l,D,g);if(typeof y=="string")return y}let p=l.fsPath;if(g===1&&!P.$i?p=p.replace(/\//g,"\\"):g!==1&&P.$i&&(p=p.replace(/\\/g,"/")),g!==1&&f?.userHome){const y=f.userHome.fsPath;let C;l.scheme!==f.userHome.scheme&&l.path[0]===M.$hc.sep&&l.path[1]!==M.$hc.sep?C=f.userHome.with({path:l.path}).fsPath:C=p,p=w(C,y,g)}return(g===1?M.$gc:M.$hc).normalize(R(p,g===1))}function E(l,r,g){const f=g===1?M.$gc:M.$hc,D=g===3?A.$Kg:A.$Mg,p=r.getWorkspace(),v=(0,u.$Ob)(p.folders);if(!v)return;l.scheme!==v.uri.scheme&&l.path[0]===M.$hc.sep&&l.path[1]!==M.$hc.sep&&(l=v.uri.with({path:l.path}));const y=r.getWorkspaceFolder(l);if(!y)return;let C;if(D.isEqual(y.uri,l)?C="":C=D.relativePath(y.uri,l)??"",C&&(C=f.normalize(C)),p.folders.length>1&&!r.noPrefix){const O=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${O} \u2022 ${C}`:O}return C}function R(l,r=P.$i){return(0,N.$lg)(l,r)?l.charAt(0).toUpperCase()+l.slice(1):l}let I=Object.create(null);function w(l,r,g=P.OS){if(g===1||!l||!r)return l;let f=I.original===r?I.normalized:void 0;f||(f=r,P.$i&&(f=(0,N.$bg)(f)),f=`${(0,b.$6e)(f,M.$hc.sep)}${M.$hc.sep}`,I={original:r,normalized:f});let D=l;return P.$i&&(D=(0,N.$bg)(D)),(g===3?D.startsWith(f):(0,b.$mf)(D,f))?`~/${D.substr(f.length)}`:l}function S(l,r){return l.replace(/^~($|\/|\\)/,`${r}$1`)}const k="\u2026",c="\\\\",m="~";function a(l,r=M.sep){const g=new Array(l.length);let f=!1;for(let D=0;D<l.length;D++){const p=l[D];if(p===""){g[D]=`.${r}`;continue}if(!p){g[D]=p;continue}f=!0;let v="",y=p;y.indexOf(c)===0?(v=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(r)===0?(v=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(m)===0&&(v=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const C=y.split(r);for(let O=1;f&&O<=C.length;O++)for(let z=C.length-O;f&&z>=0;z--){f=!1;let T=C.slice(z,z+O).join(r);for(let B=0;!f&&B<l.length;B++)if(B!==D&&l[B]&&l[B].indexOf(T)>-1){const j=z+O===C.length,F=z>0&&l[B].indexOf(r)>-1?r+T:T,L=l[B].endsWith(F);f=!j||L}if(!f){let B="";(C[0].endsWith(":")||v!=="")&&(z===1&&(z=0,O++,T=C[0]+r+T),z>0&&(B=C[0]+r),B=v+B),z>0&&(B=B+k+r),B=B+T,z+O<C.length&&(B=B+r+k),g[D]=B}}f&&(g[D]=p)}return g}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,r=Object.create(null)){const g=[];let f=!1,D="";for(const p of l)if(p==="$"||f&&p==="{")D&&g.push({value:D,type:n.TEXT}),D="",f=!0;else if(p==="}"&&f){const v=r[D];if(typeof v=="string")v.length&&g.push({value:v,type:n.VARIABLE});else if(v){const y=g[g.length-1];(!y||y.type!==n.SEPARATOR)&&g.push({value:v.label,type:n.SEPARATOR})}D="",f=!1}else D+=p;return D&&!f&&g.push({value:D,type:n.TEXT}),g.filter((p,v)=>{if(p.type===n.SEPARATOR){const y=g[v-1],C=g[v+1];return[y,C].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(p=>p.value).join("")}function s(l,r){return P.$j||r?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):l.replace(/&&|&/g,g=>g==="&"?"&&":"&")}function o(l,r){return P.$j||r?l.replace(/\(&&\w\)|&&/g,""):P.$i?l.replace(/&&|&/g,g=>g==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function d(l){if(l.endsWith("]")){const r=l.lastIndexOf(" [",l.length-2);if(r!==-1){const g=h(l.substring(0,r)),f=l.substring(r);return{name:g.name+f,parentPath:g.parentPath}}}return h(l)}function h(l){const r=l.indexOf("/")!==-1?M.$hc:M.$gc,g=r.basename(l),f=r.dirname(l);return g.length?{name:g,parentPath:f}:{name:f,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=b,e.$mn=E,e.$nn=R;function M(I){return I.toJSON()}class P{constructor(w){this.a=w}transformIncoming(w){const S=this.a.transformIncoming(w);return S===w?w:M(N.URI.from(S))}transformOutgoing(w){const S=this.a.transformOutgoing(w);return S===w?w:M(N.URI.from(S))}transformOutgoingURI(w){const S=this.a.transformOutgoing(w);return S===w?w:N.URI.from(S)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$jn=P,e.$kn=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,w,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof N.URI)return w.transformOutgoing(I);for(const k in I)if(Object.hasOwnProperty.call(I,k)){const c=A(I[k],w,S+1);c!==null&&(I[k]=c)}}return null}function b(I,w){const S=A(I,w,0);return S===null?I:S}function $(I,w,S,k){if(!I||k>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?N.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof u.$ue)return null;for(const c in I)if(Object.hasOwnProperty.call(I,c)){const m=$(I[c],w,S,k+1);m!==null&&(I[c]=m)}}return null}function E(I,w){const S=$(I,w,!1,0);return S===null?I:S}function R(I,w){const S=$(I,w,!0,0);return S===null?I:S}}),define(ke[31],Ee([1,0,51,63,394,8,34,75,17,11,23,2]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=g,e.writeFileSync=D;var w;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function S(F,L=w.UNLINK,G){if((0,A.$kg)(F))throw new Error("rimraf - will refuse to recursively delete root");return L===w.UNLINK?c(F):k(F,G)}async function k(F,L=(0,A.$pg)((0,N.tmpdir)())){try{try{await u.promises.rename(F,L)}catch(G){return G.code==="ENOENT"?void 0:c(F)}c(L).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function c(F){return(0,M.promisify)(u.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,A.$kg)(F))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function a(F,L){return s(await(L?n(F):(0,M.promisify)(u.readdir)(F)))}async function n(F){try{return await(0,M.promisify)(u.readdir)(F,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const L=[],G=await a(F);for(const te of G){let Z=!1,x=!1,_=!1;try{const ue=await e.Promises.lstat((0,$.$kc)(F,te));Z=ue.isFile(),x=ue.isDirectory(),_=ue.isSymbolicLink()}catch(ue){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ue)}L.push({name:te,isFile:()=>Z,isDirectory:()=>x,isSymbolicLink:()=>_})}return L}function i(F){return s(u.readdirSync(F))}function s(F){return F.map(L=>typeof L=="string"?E.$j?(0,b.$Yl)(L):L:(L.name=E.$j?(0,b.$Yl)(L.name):L.name,L))}async function o(F){const L=await a(F),G=[];for(const te of L)await d.existsDirectory((0,$.$kc)(F,te))&&G.push(te);return G}function t(F,L=1e3){return new Promise(G=>{let te=!1;const Z=setInterval(()=>{te||(te=!0,u.access(F,x=>{te=!1,x&&(clearInterval(Z),G(void 0))}))},L)})}var d;(function(F){async function L(Z){let x;try{if(x=await e.Promises.lstat(Z),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.$i&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(ue){if(ue.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw ue}throw _}}F.stat=L;async function G(Z){try{const{stat:x,symbolicLink:_}=await F.stat(Z);return x.isFile()&&_?.dangling!==!0}catch{}return!1}F.existsFile=G;async function te(Z){try{const{stat:x,symbolicLink:_}=await F.stat(Z);return x.isDirectory()&&_?.dangling!==!0}catch{}return!1}F.existsDirectory=te})(d||(e.SymlinkSupport=d={}));const h=new P.$qh;function l(F,L,G){return h.queueFor(I.URI.file(F),()=>{const te=p(G);return new Promise((Z,x)=>f(F,L,te,_=>_?x(_):Z()))},R.$Lg)}let r=!0;function g(F){r=F}function f(F,L,G,te){if(!r)return u.writeFile(F,L,{mode:G.mode,flag:G.flag},te);u.open(F,G.flag,G.mode,(Z,x)=>{if(Z)return te(Z);u.writeFile(x,L,_=>{if(_)return u.close(x,()=>te(_));u.fdatasync(x,ue=>(ue&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ue),g(!1)),u.close(x,X=>te(X))))})})}function D(F,L,G){const te=p(G);if(!r)return u.writeFileSync(F,L,{mode:te.mode,flag:te.flag});const Z=u.openSync(F,te.flag,te.mode);try{u.writeFileSync(Z,L);try{u.fdatasyncSync(Z)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),g(!1)}}finally{u.closeSync(Z)}}function p(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function v(F,L,G=6e4){if(F!==L)try{E.$i&&typeof G=="number"?await y(F,L,Date.now(),G):await(0,M.promisify)(u.rename)(F,L)}catch(te){if(F.toLowerCase()!==L.toLowerCase()&&te.code==="EXDEV"||F.endsWith("."))await C(F,L,{preserveSymlinks:!1}),await S(F,w.MOVE);else throw te}}async function y(F,L,G,te,Z=0){try{return await(0,M.promisify)(u.rename)(F,L)}catch(x){if(x.code!=="EACCES"&&x.code!=="EPERM"&&x.code!=="EBUSY")throw x;if(Date.now()-G>=te)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${x}`),x;if(Z===0){let _=!1;try{const{stat:ue}=await d.stat(L);ue.isFile()||(_=!0)}catch{}if(_)throw x}return await(0,P.$ih)(Math.min(100,Z*10)),y(F,L,G,te,Z+1)}}async function C(F,L,G){return z(F,L,{root:{source:F,target:L},options:G,handledSourcePaths:new Set})}const O=511;async function z(F,L,G){if(G.handledSourcePaths.has(F))return;G.handledSourcePaths.add(F);const{stat:te,symbolicLink:Z}=await d.stat(F);if(Z){if(G.options.preserveSymlinks)try{return await j(F,L,G)}catch{}if(Z.dangling)return}return te.isDirectory()?T(F,L,te.mode&O,G):B(F,L,te.mode&O)}async function T(F,L,G,te){await e.Promises.mkdir(L,{recursive:!0,mode:G});const Z=await a(F);for(const x of Z)await z((0,$.$kc)(F,x),(0,$.$kc)(L,x),te)}async function B(F,L,G){await e.Promises.copyFile(F,L),await e.Promises.chmod(L,G)}async function j(F,L,G){let te=await e.Promises.readlink(F);(0,A.$hg)(te,G.root.source,!E.$k)&&(te=(0,$.$kc)(G.root.target,te.substr(G.root.source.length+1))),await e.Promises.symlink(te,L)}e.Promises=new class{get access(){return(0,M.promisify)(u.access)}get stat(){return(0,M.promisify)(u.stat)}get lstat(){return(0,M.promisify)(u.lstat)}get utimes(){return(0,M.promisify)(u.utimes)}get read(){return(F,L,G,te,Z)=>new Promise((x,_)=>{u.read(F,L,G,te,Z,(ue,X,$e)=>ue?_(ue):x({bytesRead:X,buffer:$e}))})}get readFile(){return(0,M.promisify)(u.readFile)}get write(){return(F,L,G,te,Z)=>new Promise((x,_)=>{u.write(F,L,G,te,Z,(ue,X,$e)=>ue?_(ue):x({bytesWritten:X,buffer:$e}))})}get appendFile(){return(0,M.promisify)(u.appendFile)}get fdatasync(){return(0,M.promisify)(u.fdatasync)}get truncate(){return(0,M.promisify)(u.truncate)}get copyFile(){return(0,M.promisify)(u.copyFile)}get open(){return(0,M.promisify)(u.open)}get close(){return(0,M.promisify)(u.close)}get symlink(){return(0,M.promisify)(u.symlink)}get readlink(){return(0,M.promisify)(u.readlink)}get chmod(){return(0,M.promisify)(u.chmod)}get mkdir(){return(0,M.promisify)(u.mkdir)}get unlink(){return(0,M.promisify)(u.unlink)}get rmdir(){return(0,M.promisify)(u.rmdir)}get realpath(){return(0,M.promisify)(u.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return l}get rm(){return S}get rename(){return v}get copy(){return C}}}),define(ke[104],Ee([1,0,51,17,11,14,31]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=b,e.$Mq=$,e.$Nq=E,e.$Oq=R;function b(w){if(M.$k)return w;const S=(0,N.$nc)(w);if(w===S)return w;const k=((0,N.$oc)(w)||w).toLowerCase();try{const m=(0,A.readdirSync)(S).filter(a=>a.toLowerCase()===k);if(m.length===1){const a=b(S);if(a)return(0,N.$kc)(a,m[0])}else if(m.length>1){const a=m.indexOf(k);if(a>=0){const n=b(S);if(n)return(0,N.$kc)(n,m[a])}}}catch{}return null}async function $(w){if(M.$k)return w;const S=(0,N.$nc)(w);if(w===S)return w;const k=((0,N.$oc)(w)||w).toLowerCase();try{const m=(await A.Promises.readdir(S)).filter(a=>a.toLowerCase()===k);if(m.length===1){const a=await $(S);if(a)return(0,N.$kc)(a,m[0])}else if(m.length>1){const a=m.indexOf(k);if(a>=0){const n=await $(S);if(n)return(0,N.$kc)(n,m[a])}}}catch{}return null}async function E(w){try{return await A.Promises.realpath(w)}catch{const k=I(w);return await A.Promises.access(k,u.constants.R_OK),k}}function R(w){try{return u.realpathSync(w)}catch{const k=I(w);return u.accessSync(k,u.constants.R_OK),k}}function I(w){return(0,P.$6e)((0,N.$ic)(w),N.sep)}}),define(ke[105],Ee([1,0,17,11,50,102,18,31]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$_l=$,e.$am=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(I=M.env){return I.comspec||"cmd.exe"}function E(I){let w=[],S=!1;const k=function(c){if(S){w.push(c);return}(!I.send(c,a=>{if(a&&console.error(a),S=!1,w.length>0){const n=w.slice(0);w=[],n.forEach(i=>k(i))}})||N.$i)&&(S=!0)};return{send:k}}var R;(function(I){async function w(S,k,c){if(u.$jc(S))return S;if(k===void 0&&(k=M.cwd()),u.$nc(S)!=="."||(c===void 0&&A.$Uf(M.env.PATH)&&(c=M.env.PATH.split(u.$uc)),c===void 0||c.length===0))return u.$kc(k,S);async function a(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(s){s.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of c){let i;if(u.$jc(n)?i=u.$kc(n,S):i=u.$kc(k,n,S),await a(i))return i;let s=i+".com";if(await a(s)||(s=i+".exe",await a(s)))return s}return u.$kc(k,S)}I.findExecutable=w})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(de,e,u,N){var M=arguments.length,P=M<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,u):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(de,e,u,N);else for(var b=de.length-1;b>=0;b--)(A=de[b])&&(P=(M<3?A(P):M>3?A(e,u,P):A(e,u))||P);return M>3&&P&&Object.defineProperty(e,u,P),P};define(ke[80],Ee([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.ProxyChannel=e.$2h=e.$Yh=e.$Xh=e.$Wh=e.RequestInitiator=e.$Vh=e.$Sh=e.$Rh=void 0,e.$Th=g,e.$Uh=f,e.$Zh=O,e.$1h=z;var S;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(S||(S={}));function k(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(c||(c={}));function m(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(a||(a={}));function n(Z){let x=0;for(let _=0;;_+=7){const ue=Z.read(1);if(x|=(ue.buffer[0]&127)<<_,!(ue.buffer[0]&128))return x}}const i=h(0);function s(Z,x){if(x===0){Z.write(i);return}let _=0;for(let X=x;X!==0;X=X>>>7)_++;const ue=M.$ue.alloc(_);for(let X=0;x!==0;X++)ue.buffer[X]=x&127,x=x>>>7,x>0&&(ue.buffer[X]|=128);Z.write(ue)}class o{constructor(x){this.b=x,this.a=0}read(x){const _=this.b.slice(this.a,this.a+x);return this.a+=_.byteLength,_}}e.$Rh=o;class t{constructor(){this.a=[]}get buffer(){return M.$ue.concat(this.a)}write(x){this.a.push(x)}}e.$Sh=t;var d;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(d||(d={}));function h(Z){const x=M.$ue.alloc(1);return x.writeUInt8(Z,0),x}const l={Undefined:h(d.Undefined),String:h(d.String),Buffer:h(d.Buffer),VSBuffer:h(d.VSBuffer),Array:h(d.Array),Object:h(d.Object),Uint:h(d.Int)},r=typeof Buffer<"u";function g(Z,x){if(typeof x>"u")Z.write(l.Undefined);else if(typeof x=="string"){const _=M.$ue.fromString(x);Z.write(l.String),s(Z,_.byteLength),Z.write(_)}else if(r&&Buffer.isBuffer(x)){const _=M.$ue.wrap(x);Z.write(l.Buffer),s(Z,_.byteLength),Z.write(_)}else if(x instanceof M.$ue)Z.write(l.VSBuffer),s(Z,x.byteLength),Z.write(x);else if(Array.isArray(x)){Z.write(l.Array),s(Z,x.length);for(const _ of x)g(Z,_)}else if(typeof x=="number"&&(x|0)===x)Z.write(l.Uint),s(Z,x);else{const _=M.$ue.fromString(JSON.stringify(x));Z.write(l.Object),s(Z,_.byteLength),Z.write(_)}}function f(Z){switch(Z.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return Z.read(n(Z)).toString();case d.Buffer:return Z.read(n(Z)).buffer;case d.VSBuffer:return Z.read(n(Z));case d.Array:{const _=n(Z),ue=[];for(let X=0;X<_;X++)ue.push(f(Z));return ue}case d.Object:return JSON.parse(Z.read(n(Z)).toString());case d.Int:return n(Z)}}class D{constructor(x,_,ue=null,X=1e3){this.h=x,this.j=_,this.k=ue,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(x,_){this.b.set(x,_),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const _=this.o([x.type]);this.k?.logOutgoing(_,0,1,m(x.type));return}case 201:case 202:case 204:case 203:{const _=this.o([x.type,x.id],x.data);this.k?.logOutgoing(_,x.id,1,m(x.type),x.data);return}}}o(x,_=void 0){const ue=new t;return g(ue,x),g(ue,_),this.p(ue.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const _=new o(x),ue=f(_),X=f(_),$e=ue[0];switch($e){case 100:return this.k?.logIncoming(x.byteLength,ue[1],1,`${k($e)}: ${ue[2]}.${ue[3]}`,X),this.s({type:$e,id:ue[1],channelName:ue[2],name:ue[3],arg:X});case 102:return this.k?.logIncoming(x.byteLength,ue[1],1,`${k($e)}: ${ue[2]}.${ue[3]}`,X),this.t({type:$e,id:ue[1],channelName:ue[2],name:ue[3],arg:X});case 101:return this.k?.logIncoming(x.byteLength,ue[1],1,`${k($e)}`),this.u({type:$e,id:ue[1]});case 103:return this.k?.logIncoming(x.byteLength,ue[1],1,`${k($e)}`),this.u({type:$e,id:ue[1]})}}s(x){const _=this.b.get(x.channelName);if(!_){this.v(x);return}const ue=new P.$ee;let X;try{X=_.call(this.j,x.name,x.arg,ue.token)}catch(re){X=Promise.reject(re)}const $e=x.id;X.then(re=>{this.m({id:$e,data:re,type:201})},re=>{re instanceof Error?this.m({id:$e,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split?re.stack.split(`
`):re.stack:void 0},type:202}):this.m({id:$e,data:re,type:203})}).finally(()=>{se.dispose(),this.d.delete(x.id)});const se=(0,E.$Sc)(()=>ue.cancel());this.d.set(x.id,se)}t(x){const _=this.b.get(x.channelName);if(!_){this.v(x);return}const ue=x.id,$e=_.listen(this.j,x.name,x.arg)(se=>this.m({id:ue,data:se,type:204}));this.d.set(x.id,$e)}u(x){const _=this.d.get(x.id);_&&(_.dispose(),this.d.delete(x.id))}v(x){let _=this.g.get(x.channelName);_||(_=[],this.g.set(x.channelName,_));const ue=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);_.push({request:x,timeoutTimer:ue})}w(x){const _=this.g.get(x);if(_){for(const ue of _)switch(clearTimeout(ue.timeoutTimer),ue.request.type){case 100:this.s(ue.request);break;case 102:this.t(ue.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$Vh=D;var p;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(p||(e.RequestInitiator=p={}));class v{constructor(x,_=null){this.l=x,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ue=>this.s(ue)),this.j=_}getChannel(x){const _=this;return{call(ue,X,$e){return _.a?Promise.reject(new b.$5):_.m(x,ue,X,$e)},listen(ue,X){return _.a?$.Event.None:_.o(x,ue,X)}}}m(x,_,ue,X=P.CancellationToken.None){const $e=this.g++,re={id:$e,type:100,channelName:x,name:_,arg:ue};if(X.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((ve,Ie)=>{if(X.isCancellationRequested)return Ie(new b.$5);const le=()=>{const Q=he=>{switch(he.type){case 201:this.f.delete($e),ve(he.data);break;case 202:{this.f.delete($e);const fe=new Error(he.data.message);fe.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,fe.name=he.data.name,Ie(fe);break}case 203:this.f.delete($e),Ie(he.data);break}};this.f.set($e,Q),this.p(re)};let ae=null;this.b===a.Idle?le():(ae=(0,N.$7g)(Q=>this.u()),ae.then(()=>{ae=null,le()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.p({id:$e,type:101}),Ie(new b.$5)},H=X.onCancellationRequested(ce);U=(0,E.$Rc)((0,E.$Sc)(ce),H),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(x,_,ue){const X=this.g++,se={id:X,type:102,channelName:x,name:_,arg:ue};let re=null;const U=new $.$7d({onWillAddFirstListener:()=>{re=(0,N.$7g)(ve=>this.u()),re.then(()=>{re=null,this.d.add(U),this.p(se)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(U),this.p({id:X,type:103}))}}),ie=ve=>U.fire(ve.data);return this.f.set(X,ie),U.event}p(x){switch(x.type){case 100:case 102:{const _=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(_,x.id,0,`${k(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const _=this.q([x.type,x.id]);this.j?.logOutgoing(_,x.id,0,k(x.type));return}}}q(x,_=void 0){const ue=new t;return g(ue,x),g(ue,_),this.r(ue.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const _=new o(x),ue=f(_),X=f(_),$e=ue[0];switch($e){case 200:return this.j?.logIncoming(x.byteLength,0,0,m($e)),this.t({type:ue[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ue[1],0,m($e),X),this.t({type:ue[0],id:ue[1],data:X})}}t(x){if(x.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=v,Je([A.$Lh],v.prototype,"onDidInitializePromise",null);class y{get connections(){const x=[];return this.f.forEach(_=>x.push(_)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new $.$7d,this.onDidAddConnection=this.g.event,this.h=new $.$7d,this.onDidRemoveConnection=this.h.event,this.j=new E.$Tc,this.j.add(x(({protocol:_,onDidClientDisconnect:ue})=>{const X=$.Event.once(_.onMessage);this.j.add(X($e=>{const se=new o($e),re=f(se),U=new D(_,re),ie=new v(_);this.a.forEach((Ie,le)=>U.registerChannel(le,Ie));const ve={channelServer:U,channelClient:ie,ctx:re};this.f.add(ve),this.g.fire(ve),this.j.add(ue(()=>{U.dispose(),ie.dispose(),this.f.delete(ve),this.h.fire(ve)}))}))}))}getChannel(x,_){const ue=this;return{call(X,$e,se){let re;if((0,w.$9f)(_)){const ie=(0,u.$4b)(ue.connections.filter(_));re=ie?Promise.resolve(ie):$.Event.toPromise($.Event.filter(ue.onDidAddConnection,_))}else re=_.routeCall(ue,X,$e);const U=re.then(ie=>ie.channelClient.getChannel(x));return O(U).call(X,$e,se)},listen(X,$e){if((0,w.$9f)(_))return ue.k(x,_,X,$e);const se=_.routeEvent(ue,X,$e).then(re=>re.channelClient.getChannel(x));return O(se).listen(X,$e)}}}k(x,_,ue,X){const $e=this;let se;const re=new $.$7d({onWillAddFirstListener:()=>{se=new E.$Tc;const U=new $.$ae,ie=new Map,ve=le=>{const ce=le.channelClient.getChannel(x).listen(ue,X),H=U.add(ce);ie.set(le,H)},Ie=le=>{const ae=ie.get(le);ae&&(ae.dispose(),ie.delete(le))};$e.connections.filter(_).forEach(ve),$.Event.filter($e.onDidAddConnection,_)(ve,void 0,se),$e.onDidRemoveConnection(Ie,void 0,se),U.event(re.fire,re,se),se.add(U)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return re.event}registerChannel(x,_){this.a.set(x,_);for(const ue of this.f)ue.channelServer.registerChannel(x,_)}dispose(){this.j.dispose();for(const x of this.f)x.channelClient.dispose(),x.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Xh=y;class C{constructor(x,_,ue=null){const X=new t;g(X,_),x.send(X.buffer),this.a=new v(x,ue),this.d=new D(x,_,ue)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,_){this.d.registerChannel(x,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Yh=C;function O(Z){return{call(x,_,ue){return Z.then(X=>X.call(x,_,ue))},listen(x,_){const ue=new $.$de;return Z.then(X=>ue.input=X.listen(x,_)),ue.event}}}function z(Z){let x=!1;return{call(_,ue,X){return x?Z.call(_,ue,X):(0,N.$ih)(0).then(()=>x=!0).then(()=>Z.call(_,ue,X))},listen(_,ue){if(x)return Z.listen(_,ue);const X=new $.$de;return(0,N.$ih)(0).then(()=>x=!0).then(()=>X.input=Z.listen(_,ue)),X.event}}}class T{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const _ of x.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await $.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.$2h=T;var B;(function(Z){function x($e,se,re){const U=$e,ie=re&&re.disableMarshalling,ve=new Map;for(const Ie in U)ue(Ie)&&ve.set(Ie,$.Event.buffer(U[Ie],!0,void 0,se));return new class{listen(Ie,le,ae){const ce=ve.get(le);if(ce)return ce;const H=U[le];if(typeof H=="function"){if(X(le))return H.call(U,ae);if(ue(le))return ve.set(le,$.Event.buffer(U[le],!0,void 0,se)),ve.get(le)}throw new b.$bb(`Event not found: ${le}`)}call(Ie,le,ae){const ce=U[le];if(typeof ce=="function"){if(!ie&&Array.isArray(ae))for(let Q=0;Q<ae.length;Q++)ae[Q]=(0,R.$Qh)(ae[Q]);let H=ce.apply(U,ae);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new b.$bb(`Method not found: ${le}`)}}}Z.fromService=x;function _($e,se){const re=se&&se.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return se?.properties?.has(ie)?se.properties.get(ie):X(ie)?function(ve){return $e.listen(ie,ve)}:ue(ie)?$e.listen(ie):async function(...ve){let Ie;se&&!(0,w.$4f)(se.context)?Ie=[se.context,...ve]:Ie=ve;const le=await $e.call(ie,Ie);return re?le:(0,R.$Qh)(le)};throw new b.$bb(`Property not found: ${String(ie)}`)}})}Z.toService=_;function ue($e){return $e[0]==="o"&&$e[1]==="n"&&I.$kf($e.charCodeAt(2))}function X($e){return/^onDynamic/.test($e)&&I.$kf($e.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const x=Z.toString();if(x!=="[object Object]")return x}return Z}function L(Z){return Array.isArray(Z)?Z.map(F):F(Z)}function G(Z,x,_,ue,X,$e,se){se=L(se);const re=j[X],U=re[ue%re.length];let ie=[`%c[${Z}]%c[${String(x).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ue).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test($e)?(ie=ie.concat(se),ie.push(")")):ie.push(se),console.log.apply(console,ie)}class te{constructor(x,_){this.d=x,this.f=_,this.a=0,this.b=0}logOutgoing(x,_,ue,X,$e){this.b+=x,G(this.d,this.b,x,_,ue,X,$e)}logIncoming(x,_,ue,X,$e){this.a+=x,G(this.f,this.a,x,_,ue,X,$e)}}e.$3h=te}),define(ke[81],Ee([1,0,21,4,3,80]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.ProtocolConstants=e.$4h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const r=new WeakMap;let g=0;function f(p,v){if(!r.has(p)){const y=String(++g);r.set(p,y)}return r.get(p)}function D(p,v,y,C){if(!l.enableDiagnostics)return;const O=f(p,v);if(C instanceof u.$ue||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=u.$ue.alloc(C.byteLength);z.set(C),l.records.push({timestamp:Date.now(),id:O,label:v,type:y,buff:z})}else l.records.push({timestamp:Date.now(),id:O,label:v,type:y,data:C})}l.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let E=null;function R(){return E||(E=u.$ue.alloc(0)),E}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,g){if(r===0)return R();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const v=this.a[0];return g&&(this.a.shift(),this.b-=r),v}if(this.a[0].byteLength>r){const v=this.a[0].slice(0,r);return g&&(this.a[0]=this.a[0].slice(r),this.b-=r),v}const f=u.$ue.alloc(r);let D=0,p=0;for(;r>0;){const v=this.a[p];if(v.byteLength>r){const y=v.slice(0,r);f.set(y,D),D+=r,g&&(this.a[p]=v.slice(r),this.b-=r),r-=r}else f.set(v,D),D+=v.byteLength,g?(this.a.shift(),this.b-=v.byteLength):p++,r-=v.byteLength}return f}}e.$4h=I;var w;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(w||(w={}));function S(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class c{constructor(r,g,f,D){this.type=r,this.id=g,this.ack=f,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends M.$Uc{constructor(r){super(),this.f=this.B(new N.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new I,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,D=this.g.id,p=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new c(f,D,p,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=u.$ue.alloc(13);g.writeUInt8(r.type,0),g.writeUInt32BE(r.id,1),g.writeUInt32BE(r.ack,5),g.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(g,r.data)}g(r,g){const f=this.f===0;return this.d.push(r,g),this.f+=r.byteLength+g.byteLength,f}h(){const r=u.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,g){this.g(r,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class n extends M.$Uc{constructor(r){super(),this.f=new N.$7d,this.onMessage=this.f.event,this.g=new N.$7d,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new a(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new c(1,0,0,r))}}e.$5h=n;class i extends P.$Yh{static fromSocket(r,g){return new i(new n(r),g)}get onDidDispose(){return this.b.onDidDispose}constructor(r,g,f=null){super(r,g,f),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$6h=i;class s{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$7h=s;class o{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,g=this.a;for(;g;)g=g.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let g=0,f=this.a;for(;f;)r[g++]=f.data,f=f.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const g=new o(r);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class d{static{this.a=10}static{this.b=null}static getInstance(){return d.b||(d.b=new d),d.b}constructor(){this.c=[];const r=Date.now();for(let g=0;g<d.a;g++)this.c[g]=r-1e3*g;setInterval(()=>{for(let g=d.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),g=(1+d.a)*1e3;let f=0;for(let D=0;D<d.a;D++)r-this.c[D]<=g&&f++;return 1-f/d.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new s,this.onControlMessage=this.u.event,this.v=new s,this.onMessage=this.v.event,this.w=new s,this.onDidDispose=this.w.event,this.x=new s,this.onSocketClose=this.x.event,this.y=new s,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??d.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new M.$Tc,this.o=r.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new c(5,0,0,R());this.p.write(r),this.p.flush()}sendPause(){const r=new c(7,0,0,R());this.p.write(r)}sendResume(){const r=new c(8,0,0,R());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,g){this.a=!0,this.r.dispose(),this.r=new M.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new c(3,0,this.h,R());this.p.write(r);const g=this.b.toArray();for(let f=0,D=g.length;f<D;f++)this.p.write(g[f]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const g=this.b.peek();if(g&&g.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new c(6,0,0,R())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let f=0,D=g.length;f<D;f++)this.p.write(g[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const g=++this.c;this.h=this.g;const f=new c(1,g,this.h,r);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(r){const g=new c(2,0,0,r);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),g=Date.now()-r.writtenTime,f=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(g>=2e4&&f>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:f});return}const p=Math.max(2e4-g,2e4-f,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},p)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new c(3,0,this.h,R());this.p.write(r)}D(){this.h=this.g;const r=new c(9,0,this.h,R());this.p.write(r)}}e.$8h=h}),define(ke[193],Ee([1,0,52,8,21,22,191,13,4,3,24,105,102,80]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;class k extends S.$Vh{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>M.$ue.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$Hq=k;class c{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$7d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$eh(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,s,o){return n.k(a,i,s,o)},listen(i,s){return n.l(a,i,s)}}}k(a,n,i,s=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const o=this.n(a),t=(0,N.$7g)(l=>o.call(n,i,l)),d=s.onCancellationRequested(()=>t.cancel()),h=(0,E.$Sc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{d.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return $.Event.None;this.b.cancel();let s;const o=new $.$7d({onWillAddFirstListener:()=>{s=this.n(a).listen(n,i)(o.fire,o),this.c.add(s)},onDidRemoveLastListener:()=>{this.c.delete(s),s.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,R.$Nn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,w.$$l)(n.env),this.d=(0,u.fork)(this.i,a,n);const i=new $.$7d;$.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.$Dq)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}i.fire(M.$ue.wrap(Buffer.from(r,"base64")))});const o=this.j.useQueue?(0,I.$am)(this.d):this.d,t=r=>this.d&&this.d.connected&&o.send(r.buffer.toString("base64")),d=i.event,h={send:t,onMessage:d};this.f=new S.$Wh(h);const l=()=>this.o();process.once("exit",l),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,g)=>{process.removeListener("exit",l),this.c.forEach(f=>(0,E.$Pc)(f)),this.c.clear(),r!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:g})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Iq=c}),define(ke[194],Ee([1,0,8,4,3,57,18]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.StorageState=e.StorageHint=void 0,e.$Gp=$;var b;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(w){const S=w;return S?.changed instanceof Map||S?.deleted instanceof Set}var E;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(E||(e.StorageState=E={}));class R extends M.$Uc{static{this.a=100}constructor(S,k=Object.create(null)){super(),this.r=S,this.s=k,this.b=this.B(new N.$0d),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new u.$fh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((k,c)=>this.w(c,k)),S.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(S,k){if(this.c===E.Closed)return;let c=!1;(0,A.$4f)(k)?c=this.f.delete(S):this.f.get(S)!==k&&(this.f.set(S,k),c=!0),c&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,k){const c=this.f.get(S);return(0,A.$4f)(c)?k:c}getBoolean(S,k){const c=this.get(S);return(0,A.$4f)(c)?k:c==="true"}getNumber(S,k){const c=this.get(S);return(0,A.$4f)(c)?k:parseInt(c,10)}getObject(S,k){const c=this.get(S);return(0,A.$4f)(c)?k:(0,P.$Ph)(c)}async set(S,k,c=!1){if(this.c===E.Closed)return;if((0,A.$4f)(k))return this.delete(S,c);const m=(0,A.$Wf)(k)||Array.isArray(k)?(0,P.$Oh)(k):String(k);if(this.f.get(S)!==m)return this.f.set(S,m),this.j.set(S,m),this.h.delete(S),this.b.fire({key:S,external:c}),this.D()}async delete(S,k=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:k}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Hp=R;class I{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((k,c)=>this.a.set(c,k)),S.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$Ip=I}),define(ke[195],Ee([1,0,14,11,21]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0,e.$st=R,e.$tt=I;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function R(){return E||(E=N.$D()?A():$()),E}function I(k,c,m){const a=new Uint16Array(k.buffer,c,m);return m>0&&(a[0]===65279||a[0]===65534)?w(k,c,m):A().decode(a)}function w(k,c,m){const a=[];let n=0;for(let i=0;i<m;i++){const s=M.$we(k,c);c+=2,a[n++]=String.fromCharCode(s)}return a.join("")}class S{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return R().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const m=this.a-this.d;m<=1&&(m===0||u.$pf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const m=c.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=c;return}for(let a=0;a<m;a++)this.b[this.d++]=c.charCodeAt(a)}}e.$ut=S}),define(ke[196],Ee([1,0,21,195]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$wt=A;function M($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,R,I,w){this.oldPosition=E,this.oldText=R,this.newPosition=I,this.newText=w}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,R,I){const w=R.length;u.$ze(E,w,I),I+=4;for(let S=0;S<w;S++)u.$xe(E,R.charCodeAt(S),I),I+=2;return I}static d(E,R){const I=u.$ye(E,R);return R+=4,(0,N.$tt)(E,R,I)}writeSize(){return 8+P.a(this.oldText)+P.a(this.newText)}write(E,R){return u.$ze(E,this.oldPosition,R),R+=4,u.$ze(E,this.newPosition,R),R+=4,R=P.c(E,this.oldText,R),R=P.c(E,this.newText,R),R}static read(E,R,I){const w=u.$ye(E,R);R+=4;const S=u.$ye(E,R);R+=4;const k=P.d(E,R);R+=P.a(k);const c=P.d(E,R);return R+=P.a(c),I.push(new P(w,k,S,c)),R}}e.$vt=P;function A($,E){return $===null||$.length===0?E:new b($,E).compress()}class b{constructor(E,R){this.a=E,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,R=0,I=this.n(E),w=this.l(R);for(;E<this.f||R<this.h;){if(I===null){this.k(w),w=this.l(++R);continue}if(w===null){this.m(I),I=this.n(++E);continue}if(w.oldEnd<=I.newPosition){this.k(w),w=this.l(++R);continue}if(I.newEnd<=w.oldPosition){this.m(I),I=this.n(++E);continue}if(w.oldPosition<I.newPosition){const[a,n]=b.r(w,I.newPosition-w.oldPosition);this.k(a),w=n;continue}if(I.newPosition<w.oldPosition){const[a,n]=b.q(I,w.oldPosition-I.newPosition);this.m(a),I=n;continue}let c,m;if(w.oldEnd===I.newEnd)c=I,m=w,I=this.n(++E),w=this.l(++R);else if(w.oldEnd<I.newEnd){const[a,n]=b.q(I,w.oldLength);c=a,m=w,I=n,w=this.l(++R)}else{const[a,n]=b.r(w,I.newLength);c=I,m=a,I=this.n(++E),w=n}this.d[this.e++]=new P(c.oldPosition,c.oldText,m.newPosition,m.newText),this.g+=c.newLength-c.oldLength,this.j+=m.newLength-m.oldLength}const S=b.s(this.d);return b.t(S)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,R){return new P(R.oldPosition-E,R.oldText,R.newPosition,R.newText)}static p(E,R){return new P(R.oldPosition,R.oldText,R.newPosition+E,R.newText)}static q(E,R){const I=E.newText.substr(0,R),w=E.newText.substr(R);return[new P(E.oldPosition,E.oldText,E.newPosition,I),new P(E.oldEnd,"",E.newPosition+R,w)]}static r(E,R){const I=E.oldText.substr(0,R),w=E.oldText.substr(R);return[new P(E.oldPosition,I,E.newPosition,E.newText),new P(E.oldPosition+R,w,E.newEnd,"")]}static s(E){if(E.length===0)return E;const R=[];let I=0,w=E[0];for(let S=1;S<E.length;S++){const k=E[S];w.oldEnd===k.oldPosition?w=new P(w.oldPosition,w.oldText+k.oldText,w.newPosition,w.newText+k.newText):(R[I++]=w,w=k)}return R[I++]=w,R}static t(E){if(E.length===0)return E;const R=[];let I=0;for(let w=0;w<E.length;w++){const S=E[w];S.oldText!==S.newText&&(R[I++]=S)}return R}}}),define(ke[197],Ee([1,0,35,17]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=M,e.$Ut=P;function M(A,b,$,E,R,I){if(Array.isArray(A)){let w=0;for(const S of A){const k=M(S,b,$,E,R,I);if(k===10)return k;k>w&&(w=k)}return w}else{if(typeof A=="string")return E?A==="*"?5:A===$?10:0:0;if(A){const{language:w,pattern:S,scheme:k,hasAccessToAllModels:c,notebookType:m}=A;if(!E&&!c)return 0;m&&R&&(b=R);let a=0;if(k)if(k===b.scheme)a=10;else if(k==="*")a=5;else return 0;if(w)if(w===$)a=10;else if(w==="*")a=Math.max(a,5);else return 0;if(m)if(m===I)a=10;else if(m==="*"&&I!==void 0)a=Math.max(a,5);else return 0;if(S){let n;if(typeof S=="string"?n=S:n={...S,base:(0,N.$ic)(S.base)},n===b.fsPath||(0,u.$ak)(n,b.fsPath))a=10;else return 0}return a}else return 0}}function P(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(P):!!A.notebookType}}),define(ke[198],Ee([1,0,4,14,29,78,130,173,196,3]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=void 0;class R extends E.$Uc{constructor(w,S,k,c,m,a,n){super(),this.m=this.B(new u.$7d),this.onDidChangeContent=this.m.event,this.f=S,this.j=!a,this.g=c,this.h=m,this.c=new A.$vC(w,k,n)}equals(w){return!(w instanceof R)||this.f!==w.f||this.getEOL()!==w.getEOL()?!1:this.c.equal(w.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(w){return this.c.createSnapshot(w?this.f:"")}getOffsetAt(w,S){return this.c.getOffsetAt(w,S)}getPositionAt(w){return this.c.getPositionAt(w)}getRangeAt(w,S){const k=w+S,c=this.getPositionAt(w),m=this.getPositionAt(k);return new M.$at(c.lineNumber,c.column,m.lineNumber,m.column)}getValueInRange(w,S=0){if(w.isEmpty())return"";const k=this.n(S);return this.c.getValueInRange(w,k)}getValueLengthInRange(w,S=0){if(w.isEmpty())return 0;if(w.startLineNumber===w.endLineNumber)return w.endColumn-w.startColumn;const k=this.getOffsetAt(w.startLineNumber,w.startColumn),c=this.getOffsetAt(w.endLineNumber,w.endColumn);let m=0;const a=this.n(S),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,s=w.endLineNumber-w.startLineNumber;m=i*s}return c-k+m}getCharacterCountInRange(w,S=0){if(this.j){let k=0;const c=w.startLineNumber,m=w.endLineNumber;for(let a=c;a<=m;a++){const n=this.getLineContent(a),i=a===c?w.startColumn-1:0,s=a===m?w.endColumn-1:n.length;for(let o=i;o<s;o++)N.$pf(n.charCodeAt(o))?(k=k+1,o=o+1):k=k+1}return k+=this.n(S).length*(m-c),k}return this.getValueLengthInRange(w,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(w){return this.c.getLineContent(w)}getLineCharCode(w,S){return this.c.getLineCharCode(w,S)}getCharCode(w){return this.c.getCharCode(w)}getLineLength(w){return this.c.getLineLength(w)}getLineMinColumn(w){return 1}getLineMaxColumn(w){return this.getLineLength(w)+1}getLineFirstNonWhitespaceColumn(w){const S=N.$af(this.getLineContent(w));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(w){const S=N.$cf(this.getLineContent(w));return S===-1?0:S+2}n(w){switch(w){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(w){this.c.setEOL(w)}applyEdits(w,S,k){let c=this.g,m=this.h,a=this.j,n=!0,i=[];for(let r=0;r<w.length;r++){const g=w[r];n&&g._isTracked&&(n=!1);const f=g.range;if(g.text){let C=!0;a||(C=!N.$Af(g.text),a=C),!c&&C&&(c=N.$zf(g.text)),!m&&C&&(m=N.$Cf(g.text))}let D="",p=0,v=0,y=0;if(g.text){let C;[p,v,y,C]=(0,b.$Mt)(g.text);const O=this.getEOL();C===0||C===(O===`\r
`?2:1)?D=g.text:D=g.text.replace(/\r\n|\r|\n/g,O)}i[r]={sortIndex:r,identifier:g.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:D,eolCount:p,firstLineLength:v,lastLineLength:y,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}i.sort(R.u);let s=!1;for(let r=0,g=i.length-1;r<g;r++){const f=i[r].range.getEndPosition(),D=i[r+1].range.getStartPosition();if(D.isBeforeOrEqual(f)){if(D.isBefore(f))throw new Error("Overlapping ranges are not allowed!");s=!0}}n&&(i=this.s(i));const o=k||S?R._getInverseEditRanges(i):[],t=[];if(S)for(let r=0;r<i.length;r++){const g=i[r],f=o[r];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let D=f.startLineNumber;D<=f.endLineNumber;D++){let p="";D===f.startLineNumber&&(p=this.getLineContent(g.range.startLineNumber),N.$af(p)!==-1)||t.push({lineNumber:D,oldContent:p})}}let d=null;if(k){let r=0;d=[];for(let g=0;g<i.length;g++){const f=i[g],D=o[g],p=this.getValueInRange(f.range),v=f.rangeOffset+r;r+=f.text.length-p.length,d[g]={sortIndex:f.sortIndex,identifier:f.identifier,range:D,text:p,textChange:new $.$vt(f.rangeOffset,p,v,f.text)}}s||d.sort((g,f)=>g.sortIndex-f.sortIndex)}this.g=c,this.h=m,this.j=a;const h=this.t(i);let l=null;if(S&&t.length>0){t.sort((r,g)=>g.lineNumber-r.lineNumber),l=[];for(let r=0,g=t.length;r<g;r++){const f=t[r].lineNumber;if(r>0&&t[r-1].lineNumber===f)continue;const D=t[r].oldContent,p=this.getLineContent(f);p.length===0||p===D||N.$af(p)!==-1||l.push(f)}}return this.m.fire(),new P.$yv(d,h,l)}s(w){return w.length<1e3?w:[this._toSingleEditOperation(w)]}_toSingleEditOperation(w){let S=!1;const k=w[0].range,c=w[w.length-1].range,m=new M.$at(k.startLineNumber,k.startColumn,c.endLineNumber,c.endColumn);let a=k.startLineNumber,n=k.startColumn;const i=[];for(let h=0,l=w.length;h<l;h++){const r=w[h],g=r.range;S=S||r.forceMoveMarkers,i.push(this.getValueInRange(new M.$at(a,n,g.startLineNumber,g.startColumn))),r.text.length>0&&i.push(r.text),a=g.endLineNumber,n=g.endColumn}const s=i.join(""),[o,t,d]=(0,b.$Mt)(s);return{sortIndex:0,identifier:w[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:s,eolCount:o,firstLineLength:t,lastLineLength:d,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(w){w.sort(R.w);const S=[];for(let k=0;k<w.length;k++){const c=w[k],m=c.range.startLineNumber,a=c.range.startColumn,n=c.range.endLineNumber,i=c.range.endColumn;if(m===n&&a===i&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const s=new M.$at(m,a,n,i);S.push({range:s,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return S}findMatchesLineByLine(w,S,k,c){return this.c.findMatchesLineByLine(w,S,k,c)}getPieceTree(){return this.c}static _getInverseEditRange(w,S){const k=w.startLineNumber,c=w.startColumn,[m,a,n]=(0,b.$Mt)(S);let i;if(S.length>0){const s=m+1;s===1?i=new M.$at(k,c,k,c+a):i=new M.$at(k,c,k+s-1,n+1)}else i=new M.$at(k,c,k,c);return i}static _getInverseEditRanges(w){const S=[];let k=0,c=0,m=null;for(let a=0,n=w.length;a<n;a++){const i=w[a];let s,o;m?m.range.endLineNumber===i.range.startLineNumber?(s=k,o=c+(i.range.startColumn-m.range.endColumn)):(s=k+(i.range.startLineNumber-m.range.endLineNumber),o=i.range.startColumn):(s=i.range.startLineNumber,o=i.range.startColumn);let t;if(i.text.length>0){const d=i.eolCount+1;d===1?t=new M.$at(s,o,s,o+i.firstLineLength):t=new M.$at(s,o,s+d-1,i.lastLineLength+1)}else t=new M.$at(s,o,s,o);k=t.endLineNumber,c=t.endColumn,S.push(t),m=i}return S}static u(w,S){const k=M.$at.compareRangesUsingEnds(w.range,S.range);return k===0?w.sortIndex-S.sortIndex:k}static w(w,S){const k=M.$at.compareRangesUsingEnds(w.range,S.range);return k===0?S.sortIndex-w.sortIndex:-k}}e.$wC=R}),define(ke[199],Ee([1,0,14,130,198]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=void 0;class P{constructor($,E,R,I,w,S,k,c,m){this.a=$,this.b=E,this.c=R,this.d=I,this.e=w,this.f=S,this.g=k,this.h=c,this.j=m}k($){const E=this.c+this.d+this.e,R=this.c+this.e;return E===0?$===1?`
`:`\r
`:R>E/2?`\r
`:`
`}create($){const E=this.k($),R=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let w=0,S=R.length;w<S;w++){const k=R[w].buffer.replace(/\r\n|\r|\n/g,E),c=(0,N.$rC)(k);R[w]=new N.$uC(k,c)}const I=new M.$wC(R,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&u.$If($)&&(this.b=u.$Hf,$=$.substr(1));const E=$.charCodeAt($.length-1);E===13||E>=55296&&E<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=E):(this.m($,!1),this.c=!1,this.d=E)}m($,E){!E&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const E=(0,N.$sC)(this.e,$);this.a.push(new N.$uC($,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=u.$zf($)),this.k||(this.k=u.$Cf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const E=(0,N.$rC)($.buffer);$.lineStarts=E,this.d===13&&this.f++}}}e.$xC=A}),define(ke[134],Ee([1,0,21,11]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qab=$,e.$rab=R;var M;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(M||(M={}));function P(I){for(let w=0,S=I.length;w<S;w+=4){const k=I[w+0],c=I[w+1],m=I[w+2],a=I[w+3];I[w+0]=a,I[w+1]=m,I[w+2]=c,I[w+3]=k}}function A(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return N.$D()||P(w),u.$ue.wrap(w)}function b(I){const w=I.buffer;if(N.$D()||P(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const S=new Uint8Array(w.byteLength);return S.set(w),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(I){const w=new Uint32Array(E(I));let S=0;if(w[S++]=I.id,I.type==="full")w[S++]=1,w[S++]=I.data.length,w.set(I.data,S),S+=I.data.length;else{w[S++]=2,w[S++]=I.deltas.length;for(const k of I.deltas)w[S++]=k.start,w[S++]=k.deleteCount,k.data?(w[S++]=k.data.length,w.set(k.data,S),S+=k.data.length):w[S++]=0}return A(w)}function E(I){let w=0;if(w+=2,I.type==="full")w+=1+I.data.length;else{w+=1,w+=3*I.deltas.length;for(const S of I.deltas)S.data&&(w+=S.data.length)}return w}function R(I){const w=b(I);let S=0;const k=w[S++];if(w[S++]===1){const n=w[S++],i=w.subarray(S,S+n);return S+=n,{id:k,type:"full",data:i}}const m=w[S++],a=[];for(let n=0;n<m;n++){const i=w[S++],s=w[S++],o=w[S++];let t;o>0&&(t=w.subarray(S,S+o),S+=o),a[n]={start:i,deleteCount:s,data:t}}return{id:k,type:"delta",deltas:a}}}),define(ke[200],Ee([9,10]),function(de,e){return de.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,176,129,200]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=s,e.stringSet=d,e.cursorStyleToString=y,e.filterValidationDecorations=fe;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=E;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(oe,De,Ke,xe){this.id=oe,this.name=De,this.defaultValue=Ke,this.schema=xe}applyUpdate(oe,De){return S(oe,De)}compute(oe,De,Ke){return Ke}}class w{constructor(oe,De){this.newValue=oe,this.didChange=De}}e.ApplyUpdateResult=w;function S(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new w(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const Ke=Array.isArray(ne)&&Array.isArray(oe)&&u.$ub(ne,oe);return new w(oe,!Ke)}let De=!1;for(const Ke in oe)if(oe.hasOwnProperty(Ke)){const xe=S(ne[Ke],oe[Ke]);xe.didChange&&(ne[Ke]=xe.newValue,De=!0)}return new w(ne,De)}class k{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,De){return S(oe,De)}validate(oe){return this.defaultValue}}class c{constructor(oe,De,Ke,xe){this.id=oe,this.name=De,this.defaultValue=Ke,this.schema=xe}applyUpdate(oe,De){return S(oe,De)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,De,Ke){return Ke}}function m(ne,oe){return typeof ne>"u"?oe:ne==="false"?!1:!!ne}class a extends c{constructor(oe,De,Ke,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ke),super(oe,De,Ke,xe)}validate(oe){return m(oe,this.defaultValue)}}function n(ne,oe,De,Ke){if(typeof ne>"u")return oe;let xe=parseInt(ne,10);return isNaN(xe)?oe:(xe=Math.max(De,xe),xe=Math.min(Ke,xe),xe|0)}class i extends c{static clampedInt(oe,De,Ke,xe){return n(oe,De,Ke,xe)}constructor(oe,De,Ke,xe,st,je=void 0){typeof je<"u"&&(je.type="integer",je.default=Ke,je.minimum=xe,je.maximum=st),super(oe,De,Ke,je),this.minimum=xe,this.maximum=st}validate(oe){return i.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function s(ne,oe,De,Ke){if(typeof ne>"u")return oe;const xe=o.float(ne,oe);return o.clamp(xe,De,Ke)}class o extends c{static clamp(oe,De,Ke){return oe<De?De:oe>Ke?Ke:oe}static float(oe,De){if(typeof oe=="number")return oe;if(typeof oe>"u")return De;const Ke=parseFloat(oe);return isNaN(Ke)?De:Ke}constructor(oe,De,Ke,xe,st){typeof st<"u"&&(st.type="number",st.default=Ke),super(oe,De,Ke,st),this.validationFn=xe}validate(oe){return this.validationFn(o.float(oe,this.defaultValue))}}class t extends c{static string(oe,De){return typeof oe!="string"?De:oe}constructor(oe,De,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ke),super(oe,De,Ke,xe)}validate(oe){return t.string(oe,this.defaultValue)}}function d(ne,oe,De,Ke){return typeof ne!="string"?oe:Ke&&ne in Ke?Ke[ne]:De.indexOf(ne)===-1?oe:ne}class h extends c{constructor(oe,De,Ke,xe,st=void 0){typeof st<"u"&&(st.type="string",st.enum=xe,st.default=Ke),super(oe,De,Ke,st),this.c=xe}validate(oe){return d(oe,this.defaultValue,this.c)}}class l extends I{constructor(oe,De,Ke,xe,st,je,bt=void 0){typeof bt<"u"&&(bt.type="string",bt.enum=st,bt.default=xe),super(oe,De,Ke,bt),this.c=st,this.d=je}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function r(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,De,Ke){return Ke===0?oe.accessibilitySupport:Ke}}class f extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:b.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{insertSpace:m(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function p(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(v||(e.TextEditorCursorStyle=v={}));function y(ne){switch(ne){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}function C(ne){switch(ne){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class O extends k{constructor(){super(141)}compute(oe,De,Ke){const xe=["monaco-editor"];return De.get(39)&&xe.push(De.get(39)),oe.extraEditorClassName&&xe.push(oe.extraEditorClassName),De.get(74)==="default"?xe.push("mouse-default"):De.get(74)==="copy"&&xe.push("mouse-copy"),De.get(111)&&xe.push("showUnused"),De.get(139)&&xe.push("showDeprecated"),xe.join(" ")}}class z extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(oe,De,Ke){return Ke&&oe.emptySelectionClipboard}}class T extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:b.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:b.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{cursorMoveOnType:m(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":d(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":d(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(De.loop,this.defaultValue.loop)}}}class B extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"||oe.length===0?B.OFF:oe==="true"?B.ON:oe:oe?B.ON:B.OFF}}e.EditorFontLigatures=B;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?j.OFF:oe==="true"?j.TRANSLATE:oe:oe?j.TRANSLATE:j.OFF}compute(oe,De,Ke){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class F extends k{constructor(){super(50)}compute(oe,De,Ke){return oe.fontInfo}}class L extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(oe){const De=o.float(oe,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(De,6,100)}compute(oe,De,Ke){return oe.fontInfo.fontSize}}class G extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(i.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class te extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{multiple:d(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??d(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??d(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??d(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??d(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??d(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends I{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:b.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),delay:i.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:m(De.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(De.above,this.defaultValue.above)}}}var x;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(x||(e.RenderMinimap=x={}));class _ extends k{constructor(){super(144)}compute(oe,De,Ke){return _.computeLayout(De,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const De=oe.height/oe.lineHeight,Ke=Math.floor(oe.paddingTop/oe.lineHeight);let xe=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(xe=Math.max(xe,De-1));const st=(Ke+oe.viewLineCount+xe)/(oe.pixelRatio*oe.height),je=Math.floor(oe.viewLineCount/st);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:xe,desiredRatio:st,minimapLineCount:je}}static c(oe,De){const Ke=oe.outerWidth,xe=oe.outerHeight,st=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const je=De.stableMinimapLayoutInput,bt=je&&oe.outerHeight===je.outerHeight&&oe.lineHeight===je.lineHeight&&oe.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&oe.pixelRatio===je.pixelRatio&&oe.scrollBeyondLastLine===je.scrollBeyondLastLine&&oe.paddingTop===je.paddingTop&&oe.paddingBottom===je.paddingBottom&&oe.minimap.enabled===je.minimap.enabled&&oe.minimap.side===je.minimap.side&&oe.minimap.size===je.minimap.size&&oe.minimap.showSlider===je.minimap.showSlider&&oe.minimap.renderCharacters===je.minimap.renderCharacters&&oe.minimap.maxColumn===je.minimap.maxColumn&&oe.minimap.scale===je.minimap.scale&&oe.verticalScrollbarWidth===je.verticalScrollbarWidth&&oe.isViewportWrapping===je.isViewportWrapping,vt=oe.lineHeight,Lt=oe.typicalHalfwidthCharacterWidth,Bt=oe.scrollBeyondLastLine,Ut=oe.minimap.renderCharacters;let Ct=st>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const ti=oe.minimap.maxColumn,Wt=oe.minimap.size,ri=oe.minimap.side,ii=oe.verticalScrollbarWidth,et=oe.viewLineCount,Xt=oe.remainingWidth,qt=oe.isViewportWrapping,ht=Ut?2:3;let mt=Math.floor(st*xe);const ni=mt/st;let Vt=!1,Ht=!1,dt=ht*Ct,It=Ct/st,si=1;if(Wt==="fill"||Wt==="fit"){const{typicalViewportLineCount:At,extraLinesBeforeFirstLine:Rt,extraLinesBeyondLastLine:jt,desiredRatio:oi,minimapLineCount:Jt}=_.computeContainedMinimapLineCount({viewLineCount:et,scrollBeyondLastLine:Bt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:xe,lineHeight:vt,pixelRatio:st});if(et/Jt>1)Vt=!0,Ht=!0,Ct=1,dt=1,It=Ct/st;else{let Et=!1,Mt=Ct+1;if(Wt==="fit"){const Qt=Math.ceil((Rt+et+jt)*dt);qt&&bt&&Xt<=De.stableFitRemainingWidth?(Et=!0,Mt=De.stableFitMaxMinimapScale):Et=Qt>mt}if(Wt==="fill"||Et){Vt=!0;const Qt=Ct;dt=Math.min(vt*st,Math.max(1,Math.floor(1/oi))),qt&&bt&&Xt<=De.stableFitRemainingWidth&&(Mt=De.stableFitMaxMinimapScale),Ct=Math.min(Mt,Math.max(1,Math.floor(dt/ht))),Ct>Qt&&(si=Math.min(2,Ct/Qt)),It=Ct/st/si,mt=Math.ceil(Math.max(At,Rt+et+jt)*dt),qt?(De.stableMinimapLayoutInput=oe,De.stableFitRemainingWidth=Xt,De.stableFitMaxMinimapScale=Ct):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const _t=Math.floor(ti*It),Ye=Math.min(_t,Math.max(0,Math.floor((Xt-ii-2)*It/(Lt+It)))+e.MINIMAP_GUTTER_WIDTH);let Gt=Math.floor(st*Ye);const zt=Gt/st;Gt=Math.floor(Gt*si);const Kt=Ut?1:2,$t=ri==="left"?0:Ke-Ye-ii;return{renderMinimap:Kt,minimapLeft:$t,minimapWidth:Ye,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Ht,minimapScale:Ct,minimapLineHeight:dt,minimapCanvasInnerWidth:Gt,minimapCanvasInnerHeight:mt,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:ni}}static computeLayout(oe,De){const Ke=De.outerWidth|0,xe=De.outerHeight|0,st=De.lineHeight|0,je=De.lineNumbersDigitCount|0,bt=De.typicalHalfwidthCharacterWidth,vt=De.maxDigitWidth,Lt=De.pixelRatio,Bt=De.viewLineCount,Ut=oe.get(136),Ct=Ut==="inherit"?oe.get(135):Ut,ti=Ct==="inherit"?oe.get(131):Ct,Wt=oe.get(134),ri=De.isDominatedByLongLines,ii=oe.get(57),et=oe.get(68).renderType!==0,Xt=oe.get(69),qt=oe.get(105),ht=oe.get(84),mt=oe.get(73),ni=oe.get(103),Vt=ni.verticalScrollbarSize,Ht=ni.verticalHasArrows,dt=ni.arrowSize,It=ni.horizontalScrollbarSize,si=oe.get(43),_t=oe.get(110)!=="never";let Ye=oe.get(66);si&&_t&&(Ye+=16);let Gt=0;if(et){const St=Math.max(je,Xt);Gt=Math.round(St*vt)}let zt=0;ii&&(zt=st*De.glyphMarginDecorationLaneCount);let Kt=0,$t=Kt+zt,At=$t+Gt,Rt=At+Ye;const jt=Ke-zt-Gt-Ye;let oi=!1,Jt=!1,Yt=-1;Ct==="inherit"&&ri?(oi=!0,Jt=!0):ti==="on"||ti==="bounded"?Jt=!0:ti==="wordWrapColumn"&&(Yt=Wt);const Et=_.c({outerWidth:Ke,outerHeight:xe,lineHeight:st,typicalHalfwidthCharacterWidth:bt,pixelRatio:Lt,scrollBeyondLastLine:qt,paddingTop:ht.top,paddingBottom:ht.bottom,minimap:mt,verticalScrollbarWidth:Vt,viewLineCount:Bt,remainingWidth:jt,isViewportWrapping:Jt},De.memory||new R);Et.renderMinimap!==0&&Et.minimapLeft===0&&(Kt+=Et.minimapWidth,$t+=Et.minimapWidth,At+=Et.minimapWidth,Rt+=Et.minimapWidth);const Mt=jt-Et.minimapWidth,Qt=Math.max(1,Math.floor((Mt-Vt-2)/bt)),Ft=Ht?dt:0;return Jt&&(Yt=Math.max(1,Qt),ti==="bounded"&&(Yt=Math.min(Yt,Wt))),{width:Ke,height:xe,glyphMarginLeft:Kt,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:$t,lineNumbersWidth:Gt,decorationsLeft:At,decorationsWidth:Ye,contentLeft:Rt,contentWidth:Mt,minimap:Et,viewportColumn:Qt,isWordWrapMinified:oi,isViewportWrapping:Jt,wrappingColumn:Yt,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:It,overviewRuler:{top:Ft,width:Vt,height:xe-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=_;class ue extends I{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(oe){return d(oe,"simple",["simple","advanced"])}compute(oe,De,Ke){return De.get(2)===2?"advanced":Ke}}var X;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(X||(e.ShowLightbulbIconMode=X={}));class $e extends I{constructor(){const oe={enabled:X.OnCode};super(65,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[X.Off,X.OnCode,X.On],default:oe.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:d(oe.enabled,this.defaultValue.enabled,[X.Off,X.OnCode,X.On])}}}class se extends I{constructor(){const oe={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:b.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:d(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:b.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:d(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),padding:m(De.padding,this.defaultValue.padding)}}}class U extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):i.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,De,Ke){return Ke<0?i.clampedInt(-Ke*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ie extends o{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>o.clamp(oe,0,150),{markdownDescription:b.localize(66,null)})}compute(oe,De,Ke){return oe.fontInfo.lineHeight}}class ve extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:oe.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:b.localize(77,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),autohide:m(De.autohide,this.defaultValue.autohide),size:d(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(De.side,this.defaultValue.side,["right","left"]),showSlider:d(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(De.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(De.scale,1,1,3),maxColumn:i.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ie(ne){return ne==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class le extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(79,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{top:i.clampedInt(De.top,0,0,1e3),bottom:i.clampedInt(De.bottom,0,0,1e3)}}}class ae extends I{constructor(){const oe={enabled:!0,cycle:!0};super(86,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:b.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:b.localize(81,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),cycle:m(De.cycle,this.defaultValue.cycle)}}}class ce extends k{constructor(){super(142)}compute(oe,De,Ke){return oe.pixelRatio}}class H extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(82,null),b.localize(83,null),b.localize(84,null)]}];super(89,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:oe.strings,description:b.localize(85,null)},comments:{anyOf:De,default:oe.comments,description:b.localize(86,null)},other:{anyOf:De,default:oe.other,description:b.localize(87,null)}},default:oe,markdownDescription:b.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Lt=oe?"on":"off";return{comments:Lt,strings:Lt,other:Lt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:De,comments:Ke,strings:xe}=oe,st=["on","inline","off"];let je,bt,vt;return typeof De=="boolean"?je=De?"on":"off":je=d(De,this.defaultValue.other,st),typeof Ke=="boolean"?bt=Ke?"on":"off":bt=d(Ke,this.defaultValue.comments,st),typeof xe=="boolean"?vt=xe?"on":"off":vt=d(xe,this.defaultValue.strings,st),{other:je,comments:bt,strings:vt}}}var Q;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Q||(e.RenderLineNumbersType=Q={}));class he extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(89,null),b.localize(90,null),b.localize(91,null),b.localize(92,null)],default:"on",description:b.localize(93,null)})}validate(oe){let De=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(De=4,Ke=oe):oe==="interval"?De=3:oe==="relative"?De=2:oe==="on"?De=1:De=0),{renderType:De,renderFn:Ke}}}function fe(ne){const oe=ne.get(98);return oe==="editable"?ne.get(91):oe!=="on"}class Pe extends I{constructor(){const oe=[],De={type:"number",description:b.localize(94,null)};super(102,"rulers",oe,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:b.localize(95,null),format:"color-hex"}}}]},default:oe,description:b.localize(96,null)})}validate(oe){if(Array.isArray(oe)){const De=[];for(const Ke of oe)if(typeof Ke=="number")De.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const xe=Ke;De.push({column:i.clampedInt(xe.column,0,0,1e4),color:xe.color})}return De.sort((Ke,xe)=>Ke.column-xe.column),De}return this.defaultValue}}class be extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Ae(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ne extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(97,null),b.localize(98,null),b.localize(99,null)],default:"auto",description:b.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(101,null),b.localize(102,null),b.localize(103,null)],default:"auto",description:b.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:b.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:b.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:b.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:oe.ignoreHorizontalScrollbarInContentHeight,description:b.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe,Ke=i.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=i.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(De.vertical,this.defaultValue.vertical),horizontal:Ae(De.horizontal,this.defaultValue.horizontal),useShadows:m(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(De.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:i.clampedInt(De.verticalSliderSize,xe,0,1e3),scrollByPage:m(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Be extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:b.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:b.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:b.localize(115,null)}})}applyUpdate(oe,De){let Ke=!1;De.allowedCharacters&&oe&&(N.$Rn(oe.allowedCharacters,De.allowedCharacters)||(oe={...oe,allowedCharacters:De.allowedCharacters},Ke=!0)),De.allowedLocales&&oe&&(N.$Rn(oe.allowedLocales,De.allowedLocales)||(oe={...oe,allowedLocales:De.allowedLocales},Ke=!0));const xe=super.applyUpdate(oe,De);return Ke?new w(xe.newValue,!0):xe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{nonBasicASCII:ge(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,De){if(typeof oe!="object"||!oe)return De;const Ke={};for(const[xe,st]of Object.entries(oe))st===!0&&(Ke[xe]=!0);return Ke}}class V extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:b.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(117,null),b.localize(118,null),b.localize(119,null)],description:b.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:b.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:oe.fontFamily,description:b.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),mode:d(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily)}}}class q extends I{constructor(){const oe={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",oe,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:oe.enabled,description:b.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],description:b.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:oe.fontFamily,description:b.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:oe.backgroundColoring,description:b.localize(129,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),showToolbar:d(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Y extends I{constructor(){const oe={enabled:P.$Ks.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$Ks.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:b.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:b.localize(131,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null)],default:oe.bracketPairs,description:b.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(136,null),b.localize(137,null),b.localize(138,null)],default:oe.bracketPairsHorizontal,description:b.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:b.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:b.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(142,null),b.localize(143,null),b.localize(144,null)],default:oe.highlightActiveIndentation,description:b.localize(145,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{bracketPairs:ge(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(ne,oe,De){const Ke=De.indexOf(ne);return Ke===-1?oe:De[Ke]}class we extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(146,null),b.localize(147,null)],default:oe.insertMode,description:b.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:b.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:b.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:b.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(152,null),b.localize(153,null),b.localize(154,null),b.localize(155,null)],default:oe.selectionMode,markdownDescription:b.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:b.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:b.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:b.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:b.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:b.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{insertMode:d(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(De.showIcons,this.defaultValue.showIcons),showStatusBar:m(De.showStatusBar,this.defaultValue.showStatusBar),preview:m(De.preview,this.defaultValue.preview),previewMode:d(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(De.showMethods,this.defaultValue.showMethods),showFunctions:m(De.showFunctions,this.defaultValue.showFunctions),showConstructors:m(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(De.showFields,this.defaultValue.showFields),showVariables:m(De.showVariables,this.defaultValue.showVariables),showClasses:m(De.showClasses,this.defaultValue.showClasses),showStructs:m(De.showStructs,this.defaultValue.showStructs),showInterfaces:m(De.showInterfaces,this.defaultValue.showInterfaces),showModules:m(De.showModules,this.defaultValue.showModules),showProperties:m(De.showProperties,this.defaultValue.showProperties),showEvents:m(De.showEvents,this.defaultValue.showEvents),showOperators:m(De.showOperators,this.defaultValue.showOperators),showUnits:m(De.showUnits,this.defaultValue.showUnits),showValues:m(De.showValues,this.defaultValue.showValues),showConstants:m(De.showConstants,this.defaultValue.showConstants),showEnums:m(De.showEnums,this.defaultValue.showEnums),showEnumMembers:m(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(De.showKeywords,this.defaultValue.showKeywords),showWords:m(De.showWords,this.defaultValue.showWords),showColors:m(De.showColors,this.defaultValue.showColors),showFiles:m(De.showFiles,this.defaultValue.showFiles),showReferences:m(De.showReferences,this.defaultValue.showReferences),showFolders:m(De.showFolders,this.defaultValue.showFolders),showTypeParameters:m(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(De.showSnippets,this.defaultValue.showSnippets),showUsers:m(De.showUsers,this.defaultValue.showUsers),showIssues:m(De.showIssues,this.defaultValue.showIssues)}}}class Te extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(195,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Xe extends I{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(196,null),b.localize(197,null),b.localize(198,null),b.localize(199,null)],description:b.localize(200,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,De,Ke){return De.get(2)===2?0:Ke}}class tt extends k{constructor(){super(145)}compute(oe,De,Ke){const xe=De.get(144);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class nt extends I{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:b.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(203,null),b.localize(204,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),showDropSelector:d(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends I{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:b.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(207,null),b.localize(208,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const De=oe;return{enabled:m(De.enabled,this.defaultValue.enabled),showPasteSelector:d(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ce="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?Ce:M.$k?ze:rt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ge;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSeparators=130]="wordSeparators",ne[ne.wordWrap=131]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=134]="wordWrapColumn",ne[ne.wordWrapOverride1=135]="wordWrapOverride1",ne[ne.wordWrapOverride2=136]="wordWrapOverride2",ne[ne.wrappingIndent=137]="wrappingIndent",ne[ne.wrappingStrategy=138]="wrappingStrategy",ne[ne.showDeprecated=139]="showDeprecated",ne[ne.inlayHints=140]="inlayHints",ne[ne.editorClassName=141]="editorClassName",ne[ne.pixelRatio=142]="pixelRatio",ne[ne.tabFocusMode=143]="tabFocusMode",ne[ne.layoutInfo=144]="layoutInfo",ne[ne.wrappingInfo=145]="wrappingInfo",ne[ne.defaultColorDecorators=146]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ge||(e.EditorOption=Ge={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(209,null)})),acceptSuggestionOnEnter:Me(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(210,null),""],markdownDescription:b.localize(211,null)})),accessibilitySupport:Me(new g),accessibilityPageSize:Me(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(212,null),tags:["accessibility"]})),ariaLabel:Me(new t(4,"ariaLabel",b.localize(213,null))),ariaRequired:Me(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Me(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Me(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(215,null),b.localize(216,null),""],description:b.localize(217,null)})),autoClosingComments:Me(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(218,null),b.localize(219,null),""],description:b.localize(220,null)})),autoClosingDelete:Me(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(221,null),""],description:b.localize(222,null)})),autoClosingOvertype:Me(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(223,null),""],description:b.localize(224,null)})),autoClosingQuotes:Me(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(225,null),b.localize(226,null),""],description:b.localize(227,null)})),autoIndent:Me(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[b.localize(228,null),b.localize(229,null),b.localize(230,null),b.localize(231,null),b.localize(232,null)],description:b.localize(233,null)})),automaticLayout:Me(new a(13,"automaticLayout",!1)),autoSurround:Me(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(234,null),b.localize(235,null),b.localize(236,null),""],description:b.localize(237,null)})),bracketPairColorization:Me(new Y),bracketPairGuides:Me(new J),stickyTabStops:Me(new a(116,"stickyTabStops",!1,{description:b.localize(238,null)})),codeLens:Me(new a(17,"codeLens",!0,{description:b.localize(239,null)})),codeLensFontFamily:Me(new t(18,"codeLensFontFamily","",{description:b.localize(240,null)})),codeLensFontSize:Me(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(241,null)})),colorDecorators:Me(new a(20,"colorDecorators",!0,{description:b.localize(242,null)})),colorDecoratorActivatedOn:Me(new h(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(243,null),b.localize(244,null),b.localize(245,null)],description:b.localize(246,null)})),colorDecoratorsLimit:Me(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(247,null)})),columnSelection:Me(new a(22,"columnSelection",!1,{description:b.localize(248,null)})),comments:Me(new f),contextmenu:Me(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(249,null)})),cursorBlinking:Me(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:b.localize(250,null)})),cursorSmoothCaretAnimation:Me(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(251,null),b.localize(252,null),b.localize(253,null)],description:b.localize(254,null)})),cursorStyle:Me(new l(28,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(255,null)})),cursorSurroundingLines:Me(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(256,null)})),cursorSurroundingLinesStyle:Me(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(257,null),b.localize(258,null)],markdownDescription:b.localize(259,null)})),cursorWidth:Me(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(260,null)})),disableLayerHinting:Me(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new a(34,"domReadOnly",!1)),dragAndDrop:Me(new a(35,"dragAndDrop",!0,{description:b.localize(261,null)})),emptySelectionClipboard:Me(new z),dropIntoEditor:Me(new nt),stickyScroll:Me(new se),experimentalWhitespaceRendering:Me(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(262,null),b.localize(263,null),b.localize(264,null)],description:b.localize(265,null)})),extraEditorClassName:Me(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Me(new o(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(266,null)})),find:Me(new T),fixedOverflowWidgets:Me(new a(42,"fixedOverflowWidgets",!1)),folding:Me(new a(43,"folding",!0,{description:b.localize(267,null)})),foldingStrategy:Me(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),foldingHighlight:Me(new a(45,"foldingHighlight",!0,{description:b.localize(271,null)})),foldingImportsByDefault:Me(new a(46,"foldingImportsByDefault",!1,{description:b.localize(272,null)})),foldingMaximumRegions:Me(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(273,null)})),unfoldOnClickAfterEndOfLine:Me(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(274,null)})),fontFamily:Me(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(275,null)})),fontInfo:Me(new F),fontLigatures2:Me(new B),fontSize:Me(new L),fontWeight:Me(new G),fontVariations:Me(new j),formatOnPaste:Me(new a(55,"formatOnPaste",!1,{description:b.localize(276,null)})),formatOnType:Me(new a(56,"formatOnType",!1,{description:b.localize(277,null)})),glyphMargin:Me(new a(57,"glyphMargin",!0,{description:b.localize(278,null)})),gotoLocation:Me(new te),hideCursorInOverviewRuler:Me(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(279,null)})),hover:Me(new Z),inDiffEditor:Me(new a(61,"inDiffEditor",!1)),letterSpacing:Me(new o(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>o.clamp(ne,-5,20),{description:b.localize(280,null)})),lightbulb:Me(new $e),lineDecorationsWidth:Me(new U),lineHeight:Me(new ie),lineNumbers:Me(new he),lineNumbersMinChars:Me(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new a(70,"linkedEditing",!1,{description:b.localize(281,null)})),links:Me(new a(71,"links",!0,{description:b.localize(282,null)})),matchBrackets:Me(new h(72,"matchBrackets","always",["always","near","never"],{description:b.localize(283,null)})),minimap:Me(new ve),mouseStyle:Me(new h(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new o(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(284,null)})),mouseWheelZoom:Me(new a(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?b.localize(285,null):b.localize(286,null)})),multiCursorMergeOverlapping:Me(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(287,null)})),multiCursorModifier:Me(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ie,{markdownEnumDescriptions:[b.localize(288,null),b.localize(289,null)],markdownDescription:b.localize(290,null)})),multiCursorPaste:Me(new h(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(291,null),b.localize(292,null)],markdownDescription:b.localize(293,null)})),multiCursorLimit:Me(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(294,null)})),occurrencesHighlight:Me(new h(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(295,null),b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),overviewRulerBorder:Me(new a(82,"overviewRulerBorder",!0,{description:b.localize(299,null)})),overviewRulerLanes:Me(new i(83,"overviewRulerLanes",3,0,3)),padding:Me(new le),pasteAs:Me(new at),parameterHints:Me(new ae),peekWidgetDefaultFocus:Me(new h(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(300,null),b.localize(301,null)],description:b.localize(302,null)})),definitionLinkOpensInPeek:Me(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(303,null)})),quickSuggestions:Me(new H),quickSuggestionsDelay:Me(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(304,null)})),readOnly:Me(new a(91,"readOnly",!1)),readOnlyMessage:Me(new be),renameOnType:Me(new a(93,"renameOnType",!1,{description:b.localize(305,null),markdownDeprecationMessage:b.localize(306,null)})),renderControlCharacters:Me(new a(94,"renderControlCharacters",!0,{description:b.localize(307,null),restricted:!0})),renderFinalNewline:Me(new h(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(308,null)})),renderLineHighlight:Me(new h(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(309,null)],description:b.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Me(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(311,null)})),renderValidationDecorations:Me(new h(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new h(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(312,null),b.localize(313,null),b.localize(314,null),""],description:b.localize(315,null)})),revealHorizontalRightPadding:Me(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new a(101,"roundedSelection",!0,{description:b.localize(316,null)})),rulers:Me(new Pe),scrollbar:Me(new Ne),scrollBeyondLastColumn:Me(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(317,null)})),scrollBeyondLastLine:Me(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(318,null)})),scrollPredominantAxis:Me(new a(106,"scrollPredominantAxis",!0,{description:b.localize(319,null)})),selectionClipboard:Me(new a(107,"selectionClipboard",!0,{description:b.localize(320,null),included:M.$k})),selectionHighlight:Me(new a(108,"selectionHighlight",!0,{description:b.localize(321,null)})),selectOnLineNumbers:Me(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:Me(new h(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(322,null),b.localize(323,null),b.localize(324,null)],description:b.localize(325,null)})),showUnused:Me(new a(111,"showUnused",!0,{description:b.localize(326,null)})),showDeprecated:Me(new a(139,"showDeprecated",!0,{description:b.localize(327,null)})),inlayHints:Me(new re),snippetSuggestions:Me(new h(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(328,null),b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),smartSelect:Me(new Te),smoothScrolling:Me(new a(114,"smoothScrolling",!1,{description:b.localize(333,null)})),stopRenderingLineAfter:Me(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new we),inlineSuggest:Me(new V),inlineEdit:Me(new q),inlineCompletionsAccessibilityVerbose:Me(new a(148,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(334,null)})),suggestFontSize:Me(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(337,null)})),suggestSelection:Me(new h(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),tabCompletion:Me(new h(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(342,null),b.localize(343,null),b.localize(344,null)],description:b.localize(345,null)})),tabIndex:Me(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Be),unusualLineTerminators:Me(new h(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(346,null),b.localize(347,null),b.localize(348,null)],description:b.localize(349,null)})),useShadowDOM:Me(new a(127,"useShadowDOM",!0)),useTabStops:Me(new a(128,"useTabStops",!0,{description:b.localize(350,null)})),wordBreak:Me(new h(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(351,null),b.localize(352,null)],description:b.localize(353,null)})),wordSeparators:Me(new t(130,"wordSeparators",A.$Ls,{description:b.localize(354,null)})),wordWrap:Me(new h(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(355,null),b.localize(356,null),b.localize(357,null),b.localize(358,null)],description:b.localize(359,null)})),wordWrapBreakAfterCharacters:Me(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new i(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(360,null)})),wordWrapOverride1:Me(new h(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new h(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new O),defaultColorDecorators:Me(new a(146,"defaultColorDecorators",!1,{markdownDescription:b.localize(361,null)})),pixelRatio:Me(new ce),tabFocusMode:Me(new a(143,"tabFocusMode",!1,{markdownDescription:b.localize(362,null)})),layoutInfo:Me(new _),wrappingInfo:Me(new tt),wrappingIndent:Me(new Xe),wrappingStrategy:Me(new ue)}}),define(ke[201],Ee([9,10]),function(de,e){return de.create("vs/editor/common/languages",e)}),define(ke[82],Ee([1,0,77,2,174,29,184,201]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$7t=e.$6t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$5t=e.$4t=e.SymbolKinds=e.SymbolTag=e.$2t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Zt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Yt=e.$Xt=e.$Wt=void 0,e.$1t=d,e.$3t=l;class ${constructor(G,te,Z){this.offset=G,this.type=te,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Wt=$;class E{constructor(G,te){this.tokens=G,this.endState=te,this._tokenizationResultBrand=void 0}}e.$Xt=E;class R{constructor(G,te){this.tokens=G,this.endState=te,this._encodedTokenizationResultBrand=void 0}}e.$Yt=R;var I;(function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue",L[L.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var w;(function(L){const G=new Map;G.set(0,u.$Gj.symbolMethod),G.set(1,u.$Gj.symbolFunction),G.set(2,u.$Gj.symbolConstructor),G.set(3,u.$Gj.symbolField),G.set(4,u.$Gj.symbolVariable),G.set(5,u.$Gj.symbolClass),G.set(6,u.$Gj.symbolStruct),G.set(7,u.$Gj.symbolInterface),G.set(8,u.$Gj.symbolModule),G.set(9,u.$Gj.symbolProperty),G.set(10,u.$Gj.symbolEvent),G.set(11,u.$Gj.symbolOperator),G.set(12,u.$Gj.symbolUnit),G.set(13,u.$Gj.symbolValue),G.set(15,u.$Gj.symbolEnum),G.set(14,u.$Gj.symbolConstant),G.set(15,u.$Gj.symbolEnum),G.set(16,u.$Gj.symbolEnumMember),G.set(17,u.$Gj.symbolKeyword),G.set(27,u.$Gj.symbolSnippet),G.set(18,u.$Gj.symbolText),G.set(19,u.$Gj.symbolColor),G.set(20,u.$Gj.symbolFile),G.set(21,u.$Gj.symbolReference),G.set(22,u.$Gj.symbolCustomColor),G.set(23,u.$Gj.symbolFolder),G.set(24,u.$Gj.symbolTypeParameter),G.set(25,u.$Gj.account),G.set(26,u.$Gj.issues);function te(_){let ue=G.get(_);return ue||(console.info("No codicon found for CompletionItemKind "+_),ue=u.$Gj.symbolProperty),ue}L.toIcon=te;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function x(_,ue){let X=Z.get(_);return typeof X>"u"&&!ue&&(X=9),X}L.fromString=x})(w||(e.CompletionItemKinds=w={}));var S;(function(L){L[L.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var k;(function(L){L[L.None=0]="None",L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var c;(function(L){L[L.Word=0]="Word",L[L.Line=1]="Line",L[L.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var m;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var a;(function(L){L[L.Automatic=0]="Automatic",L[L.Explicit=1]="Explicit"})(a||(e.InlineCompletionTriggerKind=a={}));class n{constructor(G,te,Z,x){this.range=G,this.text=te,this.completionKind=Z,this.isSnippetText=x}equals(G){return P.$at.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Zt=n;var i;(function(L){L[L.Invoke=1]="Invoke",L[L.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var s;(function(L){L[L.Automatic=0]="Automatic",L[L.PasteAs=1]="PasteAs"})(s||(e.DocumentPasteTriggerKind=s={}));var o;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var t;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function d(L){return L&&N.URI.isUri(L.uri)&&P.$at.isIRange(L.range)&&(P.$at.isIRange(L.originSelectionRange)||P.$at.isIRange(L.targetSelectionRange))}var h;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(h||(e.SymbolKind=h={})),e.$2t={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function l(L,G){return(0,b.localize)(26,null,L,e.$2t[G])}var r;(function(L){L[L.Deprecated=1]="Deprecated"})(r||(e.SymbolTag=r={}));var g;(function(L){const G=new Map;G.set(0,u.$Gj.symbolFile),G.set(1,u.$Gj.symbolModule),G.set(2,u.$Gj.symbolNamespace),G.set(3,u.$Gj.symbolPackage),G.set(4,u.$Gj.symbolClass),G.set(5,u.$Gj.symbolMethod),G.set(6,u.$Gj.symbolProperty),G.set(7,u.$Gj.symbolField),G.set(8,u.$Gj.symbolConstructor),G.set(9,u.$Gj.symbolEnum),G.set(10,u.$Gj.symbolInterface),G.set(11,u.$Gj.symbolFunction),G.set(12,u.$Gj.symbolVariable),G.set(13,u.$Gj.symbolConstant),G.set(14,u.$Gj.symbolString),G.set(15,u.$Gj.symbolNumber),G.set(16,u.$Gj.symbolBoolean),G.set(17,u.$Gj.symbolArray),G.set(18,u.$Gj.symbolObject),G.set(19,u.$Gj.symbolKey),G.set(20,u.$Gj.symbolNull),G.set(21,u.$Gj.symbolEnumMember),G.set(22,u.$Gj.symbolStruct),G.set(23,u.$Gj.symbolEvent),G.set(24,u.$Gj.symbolOperator),G.set(25,u.$Gj.symbolTypeParameter);function te(Z){let x=G.get(Z);return x||(console.info("No codicon found for SymbolKind "+Z),x=u.$Gj.symbolProperty),x}L.toIcon=te})(g||(e.SymbolKinds=g={}));class f{static asEditOperation(G){return M.$bt.replace(P.$at.lift(G.range),G.text)}}e.$4t=f;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(G){switch(G){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(G)}constructor(G){this.value=G}}e.$5t=D;var p;(function(L){L[L.AIGenerated=1]="AIGenerated"})(p||(e.NewSymbolNameTag=p={}));var v;(function(L){function G(te){return!te||typeof te!="object"?!1:typeof te.id=="string"&&typeof te.title=="string"}L.is=G})(v||(e.Command=v={}));var y;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var C;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})(C||(e.CommentThreadState=C={}));var O;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(O||(e.CommentMode=O={}));var z;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(z||(e.CommentState=z={}));var T;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class B{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$6t=B,e.$7t=new A.$Lt;var j;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}));var F;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(F||(e.InlineEditTriggerKind=F={}))}),define(ke[202],Ee([9,10]),function(de,e){return de.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[203],Ee([9,10]),function(de,e){return de.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[204],Ee([9,10]),function(de,e){return de.create("vs/platform/contextkey/common/scanner",e)}),define(ke[205],Ee([9,10]),function(de,e){return de.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[206],Ee([9,10]),function(de,e){return de.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[207],Ee([9,10]),function(de,e){return de.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[208],Ee([9,10]),function(de,e){return de.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[209],Ee([9,10]),function(de,e){return de.create("vs/platform/files/common/files",e)}),define(ke[210],Ee([9,10]),function(de,e){return de.create("vs/platform/files/common/io",e)}),define(ke[211],Ee([9,10]),function(de,e){return de.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[212],Ee([9,10]),function(de,e){return de.create("vs/platform/log/common/log",e)}),define(ke[213],Ee([9,10]),function(de,e){return de.create("vs/platform/markers/common/markers",e)}),define(ke[214],Ee([9,10]),function(de,e){return de.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[215],Ee([9,10]),function(de,e){return de.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[216],Ee([9,10]),function(de,e){return de.create("vs/platform/workspace/common/workspace",e)}),define(ke[217],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[218],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[219],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[220],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[221],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[222],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[223],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[224],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[225],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[226],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[227],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[228],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[229],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[230],Ee([9,10]),function(de,e){return de.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[231],Ee([9,10]),function(de,e){return de.create("vs/workbench/common/configuration",e)}),define(ke[232],Ee([9,10]),function(de,e){return de.create("vs/workbench/common/editor",e)}),define(ke[233],Ee([9,10]),function(de,e){return de.create("vs/workbench/common/views",e)}),define(ke[234],Ee([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[235],Ee([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[236],Ee([9,10]),function(de,e){return de.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[237],Ee([9,10]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[238],Ee([9,10]),function(de,e){return de.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[239],Ee([9,10]),function(de,e){return de.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[240],Ee([9,10]),function(de,e){return de.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[241],Ee([9,10]),function(de,e){return de.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[242],Ee([9,10]),function(de,e){return de.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[243],Ee([9,10]),function(de,e){return de.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[244],Ee([1,0,13,204]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var M;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(M||(e.TokenType=M={}));function P(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,w=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:R}),this.f.push(S)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),w=$.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,w=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(b);return}const k=this.c.charCodeAt(R);if(I)I=!1;else if(k===47&&!w){R++;break}else k===91?w=!0:k===92?I=!0:k===93&&(w=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=$}),define(ke[245],Ee([1,0,23,39,207,395]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=$,e.$sp=E,e.$tp=R,e.$up=I,e.$vp=w,e.$wp=S,e.$xp=k;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||A.test(a)}function E(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function R(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,s=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let d=a.patchMustEqual;a.hasCaret&&(n===0||(o=!1),d=!1);let h=0;if(a.preRelease){const l=b.exec(a.preRelease);if(l){const[,r,g,f]=l;h=Date.UTC(Number(r),Number(g)-1,Number(f))}}return{majorBase:n,majorMustEqual:i,minorBase:s,minorMustEqual:o,patchBase:t,patchMustEqual:d,isMinimum:a.hasGreaterEquals,notBefore:h}}function I(a,n,i){let s;typeof a=="string"?s=R(E(a)):s=a;let o;n instanceof Date?o=n.getTime():typeof n=="string"&&(o=new Date(n).getTime());let t;if(typeof i=="string"?t=R(E(i)):t=i,!s||!t)return!1;const d=s.majorBase,h=s.minorBase,l=s.patchBase;let r=t.majorBase,g=t.minorBase,f=t.patchBase;const D=t.notBefore;let p=t.majorMustEqual,v=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?d>r?!0:d<r?!1:h>g?!0:h<g||o&&o<D?!1:l>=f:(d===1&&r===0&&(!p||!v||!y)&&(r=1,g=0,f=0,p=!0,v=!1,y=!1),d<r?!1:d>r?!p:h<g?!1:h>g?!v:l<f?!1:l>f?!y:!(o&&o<D))}function w(a,n,i,s,o){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([N.default.Error,M.localize(0,null)]),t;if(typeof s.name!="string")return t.push([N.default.Error,M.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([N.default.Error,M.localize(2,null,"version")]),t;if(!s.engines)return t.push([N.default.Error,M.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([N.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!m(s.extensionDependencies))return t.push([N.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!m(s.activationEvents))return t.push([N.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([N.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([N.default.Warning,M.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([N.default.Error,M.localize(9,null,"main")]),t;{const l=(0,u.$Ug)(i,s.main);(0,u.$Og)(l,i)||t.push([N.default.Warning,M.localize(10,null,l.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([N.default.Error,M.localize(11,null,"browser")]),t;{const l=(0,u.$Ug)(i,s.browser);(0,u.$Og)(l,i)||t.push([N.default.Warning,M.localize(12,null,l.path,i.path)])}}if(!P.valid(s.version))return t.push([N.default.Error,M.localize(13,null)]),t;const d=[];if(!S(a,n,s,o,d))for(const l of d)t.push([N.default.Error,l]);return t}function S(a,n,i,s,o){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:c(a,n,i.engines.vscode,o)}function k(a,n,i){return a==="*"||c(n,i,a)}function c(a,n,i,s=[]){const o=R(E(i));if(!o)return s.push(M.localize(14,null,i)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return s.push(M.localize(15,null,i)),!1}else if(!o.majorMustEqual)return s.push(M.localize(16,null,i)),!1;return I(a,n,o)?!0:(s.push(M.localize(17,null,a,i)),!1)}function m(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(ke[246],Ee([1,0,51,3,4,2]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;class A extends N.$Uc{constructor(){super(...arguments),this.a=this.B(new M.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new N.$4c),this.f=new Set,this.g=new Set}async watch($){this.f=new Set([...$]);const E=new Set;for(const R of $)typeof R.correlationId=="number"&&(E.add(R.correlationId),this.c.has(R.correlationId)||this.c.set(R.correlationId,this.m(R)));for(const[R]of this.c)E.has(R)||this.c.deleteAndDispose(R);for(const R of this.g)this.f.has(R)||this.g.delete(R);return this.j()}j(){return this.t(Array.from(this.f).filter($=>!this.g.has($)))}m($){if(typeof $.correlationId!="number")return N.$Uc.None;const E=this,R=P.URI.file($.path);let I=!1,w=!1;const S=(k,c)=>{if(I)return;const m=this.n(k),a=this.n(c),n=w;if(w=m,a&&!m||n&&!m&&!a){this.u(`fs.watchFile() detected ${$.path} exists again, resuming watcher (correlationId: ${$.correlationId})`);const i={resource:R,type:1,cId:$.correlationId};E.a.fire([i]),this.s(i,$),this.g.delete($),this.j()}else if(m){if(this.u(`fs.watchFile() detected ${$.path} not found, suspending watcher (correlationId: ${$.correlationId})`),!a){const i={resource:R,type:2,cId:$.correlationId};E.a.fire([i]),this.s(i,$)}this.g.add($),this.j()}};this.u(`starting fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`);try{(0,u.watchFile)($.path,{persistent:!1,interval:this.h},S)}catch(k){return this.w(`fs.watchFile() failed with error ${k} on path ${$.path} (correlationId: ${$.correlationId})`),N.$Uc.None}return(0,N.$Sc)(()=>{this.u(`stopping fs.watchFile() on ${$.path} (correlationId: ${$.correlationId})`),I=!0,this.g.delete($);try{(0,u.unwatchFile)($.path,S)}catch(k){this.w(`fs.unwatchFile() failed with error ${k} on path ${$.path} (correlationId: ${$.correlationId})`)}})}n($){return $.ctimeMs===0&&$.ino===0}async stop(){this.c.clearAndDisposeAll(),this.g.clear()}r($){return typeof $.correlationId!="number"}s($,E){const R=` >> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.resource.fsPath}`;this.u(typeof E.correlationId=="number"?`${R} (correlationId: ${E.correlationId})`:R)}}e.$Kq=A}),define(ke[106],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class u{constructor(M,P=[],A=!1){this.ctor=M,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$ei=u}),define(ke[83],Ee([1,0,106]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$es=P,e.$fs=A;const N=[];var M;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function P(b,$,E){$ instanceof u.$ei||($=new u.$ei($,[],!!E)),N.push([b,$])}function A(){return N}}),define(ke[247],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class u{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Uq=u;class N{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const b=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(A);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let b=this.a.get(A);return b||(b=new u(A,P),this.a.set(A,b)),b}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,b]of this.a)P.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const b=new Set([P]),$=this.c(A,b);if($)return $}}c(P,A){for(const[b,$]of P.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const E=this.c($,A);if(E)return E;A.delete(b)}}}e.$Vq=N}),define(ke[5],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=M,e.$ii=P;var u;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(u||(e._util=u={})),e.$gi=M("instantiationService");function N(A,b,$){b[u.DI_TARGET]===b?b[u.DI_DEPENDENCIES].push({id:A,index:$}):(b[u.DI_DEPENDENCIES]=[{id:A,index:$}],b[u.DI_TARGET]=b)}function M(A){if(u.serviceIds.has(A))return u.serviceIds.get(A);const b=function($,E,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,$,R)};return b.toString=()=>A,u.serviceIds.set(A,b),b}function P(A){return A}}),define(ke[53],Ee([1,0,18,2,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=P,e.$Pi=A,e.$Qi=$,e.$Ri=E,e.$Si=R,e.$Ti=I,e.$Ui=w,e.$Vi=k,e.$Wi=c,e.$Xi=m,e.$Ni=(0,M.$hi)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function R(a,n){const i=Object.create(null);for(const s in a)I(i,s,a[s],n);return i}function I(a,n,i,s){const o=n.split("."),t=o.pop();let d=a;for(let h=0;h<o.length;h++){const l=o[h];let r=d[l];switch(typeof r){case"undefined":r=d[l]=Object.create(null);break;case"object":break;default:s(`Ignoring ${n} as ${o.slice(0,h+1).join(".")} is ${JSON.stringify(r)}`);return}d=r}if(typeof d=="object"&&d!==null)try{d[t]=i}catch{s(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(d)}`)}else s(`Ignoring ${n} as ${o.join(".")} is ${JSON.stringify(d)}`)}function w(a,n){const i=n.split(".");S(a,i)}function S(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const s=a[i];typeof s=="object"&&!Array.isArray(s)&&(S(s,n),Object.keys(s).length===0&&delete a[i])}}function k(a,n,i){function s(d,h){let l=d;for(const r of h){if(typeof l!="object"||l===null)return;l=l[r]}return l}const o=n.split("."),t=s(a,o);return typeof t>"u"?i:t}function c(a,n,i){Object.keys(n).forEach(s=>{s!=="__proto__"&&(s in a?u.$Wf(a[s])&&u.$Wf(n[s])?c(a[s],n[s],i):i&&(a[s]=n[s]):a[s]=n[s])})}function m(a){return a.replace(/[\[\]]/g,"")}}),define(ke[46],Ee([1,0,11,14,244,5,203,13]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=E,e.$gj=d,e.$hj=h,e.$Aj=X;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",u.$j),$.set("isLinux",u.$k),$.set("isWindows",u.$i),$.set("isWeb",u.$o),$.set("isMacNative",u.$j&&!u.$o),$.set("isEdge",u.$H),$.set("isFirefox",u.$F),$.set("isChrome",u.$E),$.set("isSafari",u.$G);function E(re,U){if($.get(re)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(re,U)}const R=Object.prototype.hasOwnProperty;var I;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),k=(0,A.localize)(1,null),c=(0,A.localize)(2,null),m=(0,A.localize)(3,null),a=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),s=(0,A.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=w){this.k=U,this.d=new M.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ve=this.D(),Ie=ve.type===17?n:void 0;throw this.h.push({message:a,offset:ve.offset,lexeme:M.$cj.getLexeme(ve),additionalInfo:Ie}),o.c}return ie}catch(ie){if(ie!==o.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const Ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ie.type!==10)throw this.B("REGEX",Ie);const le=Ie.lexeme,ae=le.lastIndexOf("/"),ce=ae===le.length-1?void 0:this.w(le.substring(ae+1));let H;try{H=new RegExp(le.substring(1,ae),ce)}catch{throw this.B("REGEX",Ie)}return F.create(ie,H)}switch(Ie.type){case 10:case 19:{const le=[Ie.lexeme];this.z();let ae=this.D(),ce=0;for(let Pe=0;Pe<Ie.lexeme.length;Pe++)Ie.lexeme.charCodeAt(Pe)===40?ce++:Ie.lexeme.charCodeAt(Pe)===41&&ce--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let Pe=0;Pe<ae.lexeme.length;Pe++)ae.lexeme.charCodeAt(Pe)===40?ce++:Ie.lexeme.charCodeAt(Pe)===41&&ce--}if(ce<0)break;le.push(M.$cj.getLexeme(ae)),this.z(),ae=this.D()}const H=le.join(""),Q=H.lastIndexOf("/"),he=Q===H.length-1?void 0:this.w(H.substring(Q+1));let fe;try{fe=new RegExp(H.substring(1,Q),he)}catch{throw this.B("REGEX",Ie)}return t.regex(ie,fe)}case 18:{const le=Ie.lexeme;this.z();let ae=null;if(!(0,N.$Ue)(le)){const ce=le.indexOf("/"),H=le.lastIndexOf("/");if(ce!==H&&ce>=0){const Q=le.slice(ce+1,H),he=le[H+1]==="i"?"i":"";try{ae=new RegExp(Q,he)}catch{throw this.B("REGEX",Ie)}}}if(ae===null)throw this.B("REGEX",Ie);return F.create(ie,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Ie=this.u();return t.notIn(ie,Ie)}switch(this.D().type){case 3:{this.z();const Ie=this.u();if(this.x().type===18)return t.equals(ie,Ie);switch(Ie){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Ie)}}case 4:{this.z();const Ie=this.u();if(this.x().type===18)return t.notEquals(ie,Ie);switch(Ie){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Ie)}}case 5:return this.z(),B.create(ie,this.u());case 6:return this.z(),j.create(ie,this.u());case 7:return this.z(),z.create(ie,this.u());case 8:return this.z(),T.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:s}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,ve){const Ie=(0,A.localize)(8,null,U,M.$cj.getLexeme(ie)),le=ie.offset,ae=M.$cj.getLexeme(ie);return this.h.push({message:Ie,offset:le,lexeme:ae,additionalInfo:ve}),o.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=o;class t{static false(){return r.INSTANCE}static true(){return g.INSTANCE}static has(U){return f.create(U)}static equals(U,ie){return D.create(U,ie)}static notEquals(U,ie){return y.create(U,ie)}static regex(U,ie){return F.create(U,ie)}static in(U,ie){return p.create(U,ie)}static notIn(U,ie){return v.create(U,ie)}static not(U){return C.create(U)}static and(...U){return te.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,ie){return z.create(U,ie)}static greaterEquals(U,ie){return T.create(U,ie)}static smaller(U,ie){return B.create(U,ie)}static smallerEquals(U,ie){return j.create(U,ie)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$fj=t;function d(re){const U=new o({regexParsingWithErrorRecovery:!1});return re.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,A.localize)(9,null,ve.additionalInfo):(0,A.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function h(re,U){const ie=re?re.substituteConstants():void 0,ve=U?U.substituteConstants():void 0;return!ie&&!ve?!0:!ie||!ve?!1:ie.equals(ve)}function l(re,U){return re.cmp(U)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return g.INSTANCE}}e.$ij=r;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return r.INSTANCE}}e.$jj=g;class f{static create(U,ie=null){const ve=$.get(U);return typeof ve=="boolean"?ve?g.INSTANCE:r.INSTANCE:new f(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:_(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?g.INSTANCE:r.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$kj=f;class D{static create(U,ie,ve=null){if(typeof ie=="boolean")return ie?f.create(U,ve):C.create(U,ve);const Ie=$.get(U);return typeof Ie=="boolean"?ie===(Ie?"true":"false")?g.INSTANCE:r.INSTANCE:new D(U,ie,ve)}constructor(U,ie,ve){this.c=U,this.d=ie,this.f=ve,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?g.INSTANCE:r.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$lj=D;class p{static create(U,ie){return new p(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),ve=U.getValue(this.d);return Array.isArray(ie)?ie.includes(ve):typeof ve=="string"&&typeof ie=="object"&&ie!==null?R.call(ie,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$mj=p;class v{static create(U,ie){return new v(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=p.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=v;class y{static create(U,ie,ve=null){if(typeof ie=="boolean")return ie?C.create(U,ve):f.create(U,ve);const Ie=$.get(U);return typeof Ie=="boolean"?ie===(Ie?"true":"false")?r.INSTANCE:g.INSTANCE:new y(U,ie,ve)}constructor(U,ie,ve){this.c=U,this.d=ie,this.f=ve,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?r.INSTANCE:g.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$oj=y;class C{static create(U,ie=null){const ve=$.get(U);return typeof ve=="boolean"?ve?r.INSTANCE:g.INSTANCE:new C(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?r.INSTANCE:g.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$pj=C;function O(re,U){if(typeof re=="string"){const ie=parseFloat(re);isNaN(ie)||(re=ie)}return typeof re=="string"||typeof re=="number"?U(re):r.INSTANCE}class z{static create(U,ie,ve=null){return O(ie,Ie=>new z(U,Ie,ve))}constructor(U,ie,ve){this.c=U,this.d=ie,this.f=ve,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$qj=z;class T{static create(U,ie,ve=null){return O(ie,Ie=>new T(U,Ie,ve))}constructor(U,ie,ve){this.c=U,this.d=ie,this.f=ve,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$rj=T;class B{static create(U,ie,ve=null){return O(ie,Ie=>new B(U,Ie,ve))}constructor(U,ie,ve){this.c=U,this.d=ie,this.f=ve,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$sj=B;class j{static create(U,ie,ve=null){return O(ie,Ie=>new j(U,Ie,ve))}constructor(U,ie,ve){this.c=U,this.d=ie,this.f=ve,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$tj=j;class F{static create(U,ie){return new F(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",ve=U.f?U.f.source:"";return ie<ve?-1:ie>ve?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",ve=U.f?U.f.source:"";return this.d===U.d&&ie===ve}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=L.create(this)),this.c}}e.$uj=F;class L{static create(U){return new L(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new L(this.c.map(U))}negate(){return this.c}}e.$vj=L;function G(re){let U=null;for(let ie=0,ve=re.length;ie<ve;ie++){const Ie=re[ie].substituteConstants();if(re[ie]!==Ie&&U===null){U=[];for(let le=0;le<ie;le++)U[le]=re[le]}U!==null&&(U[ie]=Ie)}return U===null?re:U}class te{static create(U,ie,ve){return te.d(U,ie,ve)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const Ie=l(this.expr[ie],U.expr[ie]);if(Ie!==0)return Ie}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=G(this.expr);return U===this.expr?this:te.create(U,this.c,!1)}evaluate(U){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,ve){const Ie=[];let le=!1;for(const ae of U)if(ae){if(ae.type===1){le=!0;continue}if(ae.type===0)return r.INSTANCE;if(ae.type===6){Ie.push(...ae.expr);continue}Ie.push(ae)}if(Ie.length===0&&le)return g.INSTANCE;if(Ie.length!==0){if(Ie.length===1)return Ie[0];Ie.sort(l);for(let ae=1;ae<Ie.length;ae++)Ie[ae-1].equals(Ie[ae])&&(Ie.splice(ae,1),ae--);if(Ie.length===1)return Ie[0];for(;Ie.length>1;){const ae=Ie[Ie.length-1];if(ae.type!==9)break;Ie.pop();const ce=Ie.pop(),H=Ie.length===0,Q=Z.create(ae.expr.map(he=>te.create([he,ce],null,ve)),null,H);Q&&(Ie.push(Q),Ie.sort(l))}if(Ie.length===1)return Ie[0];if(ve){for(let ae=0;ae<Ie.length;ae++)for(let ce=ae+1;ce<Ie.length;ce++)if(Ie[ae].negate().equals(Ie[ce]))return r.INSTANCE;if(Ie.length===1)return Ie[0]}return new te(Ie,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new te(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$wj=te;class Z{static create(U,ie,ve){return Z.d(U,ie,ve)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const Ie=l(this.expr[ie],U.expr[ie]);if(Ie!==0)return Ie}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=G(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,ve){let Ie=[],le=!1;if(U){for(let ae=0,ce=U.length;ae<ce;ae++){const H=U[ae];if(H){if(H.type===0){le=!0;continue}if(H.type===1)return g.INSTANCE;if(H.type===9){Ie=Ie.concat(H.expr);continue}Ie.push(H)}}if(Ie.length===0&&le)return r.INSTANCE;Ie.sort(l)}if(Ie.length!==0){if(Ie.length===1)return Ie[0];for(let ae=1;ae<Ie.length;ae++)Ie[ae-1].equals(Ie[ae])&&(Ie.splice(ae,1),ae--);if(Ie.length===1)return Ie[0];if(ve){for(let ae=0;ae<Ie.length;ae++)for(let ce=ae+1;ce<Ie.length;ce++)if(Ie[ae].negate().equals(Ie[ce]))return g.INSTANCE;if(Ie.length===1)return Ie[0]}return new Z(Ie,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Z(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),ve=U.shift(),Ie=[];for(const le of se(ie))for(const ae of se(ve))Ie.push(te.create([le,ae],null,!1));U.unshift(Z.create(Ie,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$xj=Z;class x extends f{static{this.d=[]}static all(){return x.d.values()}constructor(U,ie,ve){super(U,null),this.f=ie,typeof ve=="object"?x.d.push({...ve,key:U}):ve!==!0&&x.d.push({key:U,description:ve,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$yj=x,e.$zj=(0,P.$hi)("contextKeyService");function _(re,U){return re<U?-1:re>U?1:0}function ue(re,U,ie,ve){return re<ie?-1:re>ie?1:U<ve?-1:U>ve?1:0}function X(re,U){if(re.type===0||U.type===1)return!0;if(re.type===9)return U.type===9?$e(re.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(X(re,ie))return!0;return!1}if(re.type===6){if(U.type===6)return $e(U.expr,re.expr);for(const ie of re.expr)if(X(ie,U))return!0;return!1}return re.equals(U)}function $e(re,U){let ie=0,ve=0;for(;ie<re.length&&ve<U.length;){const Ie=re[ie].cmp(U[ve]);if(Ie<0)return!1;Ie===0&&ie++,ve++}return ie===re.length}function se(re){return re.type===9?re.expr:[re]}}),define(ke[248],Ee([1,0,23,39,205,5,103,11,24]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$qw=e.$pw=e.$ow=void 0,e.$rw=S,e.$sw=k,e.$ow=(0,P.$hi)("dialogService");var E;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(E||(E={}));class R{a(m){return this.d(m,E.Confirmation)}b(m){return this.d(m,E.Prompt)}c(m){return this.d(m,E.Input)}d(m,a){const n=[];switch(a){case E.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(1,null));break}case E.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(s=>s.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,M.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,M.localize)(3,null))),n.length===0&&n.push((0,M.localize)(4,null));break}case E.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===N.default.Info?"info":m===N.default.Error?"error":m===N.default.Warning?"warning":"none"}f(m,a,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let s=i[a]?.run({checkboxChecked:n});return s instanceof Promise||(s=Promise.resolve(s)),{result:s,checkboxChecked:n}}}e.$pw=R,e.$qw=(0,P.$hi)("fileDialogService");var I;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const w=10;function S(c){const m=[];return m.push(...c.slice(0,w).map(a=>typeof a=="string"?a:(0,u.$Rg)(a))),c.length>w&&(c.length-w===1?m.push((0,M.localize)(7,null)):m.push((0,M.localize)(8,null,c.length-w))),m.push(""),m.join(`
`)}function k(c,m){const a=(0,$.$Nn)(c);let n=(a.buttons??[]).map(t=>(0,A.$lw)(t)),i=(c.buttons||[]).map((t,d)=>d),s=0,o=a.cancelId??n.length-1;if(n.length>1){const t=typeof o=="number"?n[o]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&o!==1){n.splice(o,1),n.splice(1,0,t);const d=i[o];i.splice(o,1),i.splice(1,0,d),o=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),s=n.length-1,typeof t=="string"&&(o=s-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&o!==n.length-1){n.splice(o,1),n.push(t);const d=i[o];i.splice(o,1),i.push(d),o=n.length-1}}return a.buttons=n,a.defaultId=s,a.cancelId=o,a.noLink=!0,a.title=a.title||m.nameLong,{options:a,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,u.$hi)("environmentService"),e.$pi=(0,u.$ii)(e.$oi)}),define(ke[137],Ee([1,0,206,5]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=M,e.$Lo=P,e.$Mo=A,e.$No=b,e.$Oo=$,e.$Po=E,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,s){switch(i){case 3:return s==="x64"?"win32-x64":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,s){return s==="web"&&!i.includes("web")}function $(i,s,o){return b(s,o)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===o}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var R;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var w;(function(i){i.Install="install",i.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var S;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Qo=(0,N.$hi)("extensionGalleryService");var k;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var c;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(s,o){super(s),this.code=o,this.name=o}}e.$Ro=m;var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class n extends Error{constructor(s,o){super(s),this.code=o,this.name=o}}e.$So=n,e.$To=(0,N.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,N.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,N.$hi)("IExtensionTipsService"),e.$Yo=(0,u.localize2)(0,"Extensions"),e.$Zo=(0,u.localize2)(1,"Preferences")}),define(ke[249],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c5b=e.$b5b=void 0,e.$b5b=(0,u.$hi)("externalTerminal"),e.$c5b="Terminal.app"}),define(ke[250],Ee([1,0,52,54,15,17,11,102,31,105,208,249]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=e.$dac=e.$cac=void 0;const w=R.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends S{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(u,o,E.$_l(),t)}spawnTerminal(o,t,d,h){const l=t.windowsExec||k.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const r=P.$oc(l,".exe").toLowerCase();if(r==="cmder")return o.spawn(l,h?[h]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return l.indexOf(" ")>=0&&g.push('""'),g.push(l),r==="wt"&&g.push("-d ."),new Promise((f,D)=>{const p=a(process),v=o.spawn(d,g,{cwd:h,env:p,detached:!0});v.on("error",D),v.on("exit",()=>f())})}async runInTerminal(o,t,d,h,l){const r="windowsExec"in l&&l.windowsExec?l.windowsExec:k.getDefaultTerminalWindows(),g=await k.f();return new Promise((f,D)=>{const p=`"${t} - ${w}"`,v=`"${d.join('" "')}" & pause`,y=Object.assign({},a(process),h);Object.keys(y).filter(B=>y[B]===null).forEach(B=>delete y[B]);const C={cwd:t,env:y,windowsVerbatimArguments:!0};let O,z;P.$oc(r,".exe")==="wt"?(O=r,z=["-d",".",k.b,"/c",v]):g?(O=g,z=["-d",".",r,"/c",v]):(O=k.b,z=["/c","start",p,"/wait",r,"/c",`"${v}"`]),u.spawn(O,z,C).on("error",B=>{D(n(B))}),f(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return k.d}static async f(){try{const o=await E.win32.findExecutable("wt");return await $.Promises.exists(o)?o:void 0}catch{return}}}e.$cac=k,Je([N.$Lh],k,"f",null);class c extends S{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(u,o,t)}runInTerminal(o,t,d,h,l){const r=l.osxExec||I.$c5b;return new Promise((g,f)=>{if(r===I.$c5b||r==="iTerm.app"){const D=r===I.$c5b?"TerminalHelper":"iTermHelper",v=[M.$Bg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",o||w,"-w",t];for(const O of d)v.push("-a"),v.push(O);if(h){const O=Object.assign({},a(process),h);for(const z in O){const T=O[z];T===null?(v.push("-u"),v.push(z)):(v.push("-e"),v.push(`${z}=${T}`))}}let y="";const C=u.spawn(c.b,v);C.on("error",O=>{f(n(O))}),C.stderr.on("data",O=>{y+=O.toString()}),C.on("exit",O=>{if(O===0)g(void 0);else if(y){const z=y.split(`
`,1);f(new Error(z[0]))}else f(new Error(R.localize(1,null,D,O)))})}else f(new Error(R.localize(2,null,r)))})}spawnTerminal(o,t,d){const h=t.osxExec||I.$c5b;return new Promise((l,r)=>{const g=["-a",h];d&&g.push(d);const f=a(process),D=o.spawn("/usr/bin/open",g,{cwd:d,env:f});D.on("error",r),D.on("exit",()=>l())})}}e.$dac=c;class m extends S{static{this.b=R.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(u,o,t)}runInTerminal(o,t,d,h,l){const r=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((g,f)=>{const D=[];r.then(p=>{p.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const v=`${i(d)}; echo; read -p "${m.b}" -n1;`;D.push(`''${v}''`);const y=Object.assign({},a(process),h);Object.keys(y).filter(T=>y[T]===null).forEach(T=>delete y[T]);const C={cwd:t,env:y};let O="";const z=u.spawn(p,D,C);z.on("error",T=>{f(n(T))}),z.stderr.on("data",T=>{O+=T.toString()}),z.on("exit",T=>{if(T===0)g(void 0);else if(O){const B=O.split(`
`,1);f(new Error(B[0]))}else f(new Error(R.localize(4,null,p,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!A.$k)m.d=Promise.resolve("xterm");else{const o=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(o,t,d){const h=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,r)=>{h.then(g=>{const f=a(process),D=o.spawn(g,[],{cwd:d,env:f});D.on("error",r),D.on("exit",()=>l())})})}}e.$eac=m;function a(s){const o={...s.env};return(0,b.$0l)(o),o}function n(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(R.localize(5,null,s.path)):s}function i(s){let o="";for(const t of s)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(ke[32],Ee([1,0,76,17,14,18,2,209,5,11,15,44]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=w,e.$Pk=c,e.$Qk=a,e.$Rk=n,e.$Sk=i,e.$Tk=s,e.$Uk=o,e.$Vk=t,e.$Wk=d,e.$Xk=h,e.$Yk=l,e.$1k=f,e.$2k=D,e.$3k=p,e.$4k=v,e.$5k=y,e.$8k=B,e.$hl=Z,e.$il=x,e.$kl=ue,e.$Nk=(0,$.$hi)("fileService");function w(X){return X.create===!0}var S;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var k;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function c(X){const $e=X;return!!$e&&typeof $e.onDidChange=="function"}var m;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function a(X){return!!(X.capabilities&2)}function n(X){return!!(X.capabilities&8)}function i(X){return!!(X.capabilities&131072)}function s(X){return!!(X.capabilities&4)}function o(X){return!!(X.capabilities&16)}function t(X){return a(X)?!!(X.capabilities&16384):!1}function d(X){return a(X)?!!(X.capabilities&32768):!1}function h(X){return!!(X.capabilities&65536)}function l(X){return!!(X.capabilities&2048)}var r;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class g extends Error{static create($e,se){const re=new g($e.toString(),se);return p(re,se),re}constructor($e,se){super($e),this.code=se}}e.$Zk=g;function f(X,$e){return g.create(X,$e)}function D(X){return X||f((0,b.localize)(0,null),r.Unknown)}function p(X,$e){return X.name=$e?`${$e} (FileSystemError)`:"FileSystemError",X}function v(X){if(!X)return r.Unknown;if(X instanceof g)return X.code;const $e=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!$e)return r.Unknown;switch($e[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function y(X){if(X instanceof j)return X.fileOperationResult;switch(v(X)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}var C;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class O{constructor($e,se,re){this.resource=$e,this.operation=se,this.target=re}isOperation($e){return this.operation===$e}}e.$6k=O;var z;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class T{static{this.a=null}constructor($e,se){this.c=se,this.b=void 0,this.d=new I.$V(()=>{const re=u.$ni.forUris(()=>this.c);return re.fill(this.rawAdded.map(U=>[U,!0])),re}),this.f=new I.$V(()=>{const re=u.$ni.forUris(()=>this.c);return re.fill(this.rawUpdated.map(U=>[U,!0])),re}),this.g=new I.$V(()=>{const re=u.$ni.forUris(()=>this.c);return re.fill(this.rawDeleted.map(U=>[U,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of $e){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==T.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains($e,...se){return this.h($e,{includeChildren:!1},...se)}affects($e,...se){return this.h($e,{includeChildren:!0},...se)}h($e,se,...re){if(!$e)return!1;const U=re.length>0;return!!((!U||re.includes(1))&&(this.d.value.get($e)||se.includeChildren&&this.d.value.findSuperstr($e))||(!U||re.includes(0))&&(this.f.value.get($e)||se.includeChildren&&this.f.value.findSuperstr($e))||(!U||re.includes(2))&&(this.g.value.findSubstr($e)||se.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$7k=T;function B(X,$e,se){return!X||!$e||X===$e||$e.length>X.length?!1:($e.charAt($e.length-1)!==N.sep&&($e+=N.sep),se?(0,M.$mf)(X,$e):X.indexOf($e)===0)}class j extends Error{constructor($e,se,re){super($e),this.fileOperationResult=se,this.options=re}}e.$9k=j;class F extends j{constructor($e,se,re,U){super($e,se,U),this.fileOperationResult=se,this.size=re}}e.$0k=F;class L extends j{constructor($e,se,re){super($e,2,re),this.stat=se}}e.$$k=L;var G;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var te;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$gl="";function Z(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}async function x(X,$e){if(!$e.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(se=>{const re=$e.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===X.scheme&&U.added&&(re.dispose(),se())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize($e){return(0,P.$Yf)($e)||($e=0),$e<_.KB?(0,b.localize)(1,null,$e.toFixed(0)):$e<_.MB?(0,b.localize)(2,null,($e/_.KB).toFixed(2)):$e<_.GB?(0,b.localize)(3,null,($e/_.MB).toFixed(2)):$e<_.TB?(0,b.localize)(4,null,($e/_.GB).toFixed(2)):(0,b.localize)(5,null,($e/_.TB).toFixed(2))}}e.$jl=_;function ue(X){const $e=typeof X=="string"||X?.scheme===R.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===R.Schemas.file?1024*_.MB:$e?10*_.MB:E.$o?50*_.MB:1024*_.MB}}),define(ke[251],Ee([1,0,21,13,210,32]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=A;async function A(R,I,w,S,k,c){let m;try{await b(R,I,w,S,k,c)}catch(a){m=a}finally{m&&k.errorTransformer&&(m=k.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}async function b(R,I,w,S,k,c){$(c);const m=await R.open(I,{create:!1});try{$(c);let a=0,n=0,i=k&&typeof k.length=="number"?k.length:void 0,s=u.$ue.alloc(Math.min(k.bufferSize,typeof i=="number"?i:k.bufferSize)),o=k&&typeof k.position=="number"?k.position:0,t=0;do n=await R.read(m,o,s.buffer,t,s.byteLength-t),o+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===s.byteLength&&(await w.write(S(s)),s=u.$ue.alloc(Math.min(k.bufferSize,typeof i=="number"?i:k.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(c)&&E(a,k));if(t>0){let d=t;typeof i=="number"&&(d=Math.min(t,i)),w.write(S(s.slice(0,d)))}}catch(a){throw(0,P.$2k)(a)}finally{await R.close(m)}}function $(R){if(R.isCancellationRequested)throw(0,N.$6)();return!0}function E(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,P.$1k)((0,M.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Ee([1,0,35,3,17,11,2,32]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=void 0,e.$uq=$,e.$yq=w,e.$zq=S,e.$Aq=k,e.$Bq=c;function $(a){return a.recursive===!0}class E extends N.$Uc{static{this.a=5}constructor(n,i,s,o){super(),this.h=n,this.j=i,this.m=s,this.n=o,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const n=new N.$Tc;this.c.value=n,this.b=this.r(n),this.b.setVerboseLogging(this.m),n.add(this.b.onDidChangeFile(i=>this.h(i))),n.add(this.b.onDidLogMessage(i=>this.j(i))),n.add(this.b.onDidError(i=>this.t(i)))}t(n){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${n}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${n}`):this.w(n)}u(n){this.g++,this.s(),this.watch(n)}async watch(n){this.f=n,await this.b?.watch(n)}async setVerboseLogging(n){this.m=n,await this.b?.setVerboseLogging(n)}w(n){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${n}`})}y(n){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${n}`})}dispose(){return this.b=void 0,super.dispose()}}e.$vq=E;class R extends E{constructor(n,i,s){super(n,i,s,{type:"node.js",restartOnError:!1})}}e.$wq=R;class I extends E{constructor(n,i,s){super(n,i,s,{type:"universal",restartOnError:!0})}}e.$xq=I;function w(a){return a.map(n=>({type:n.type,resource:A.URI.revive(n.resource),cId:n.cId}))}function S(a){const n=new m;for(const i of a)n.processEvent(i);return n.coalesce()}function k(a,n){return typeof n=="string"&&!n.startsWith(u.$0j)&&!(0,M.$jc)(n)?{base:a,pattern:n}:n}function c(a,n){const i=[];for(const s of n)i.push((0,u.$bk)(k(a,s)));return i}class m{constructor(){this.a=new Set,this.b=new Map}c(n){return P.$k?n.resource.fsPath:n.resource.fsPath.toLowerCase()}processEvent(n){const i=this.b.get(this.c(n));let s=!1;if(i){const o=i.type,t=n.type;i.resource.fsPath!==n.resource.fsPath&&(n.type===2||n.type===1)?s=!0:o===1&&t===2?(this.b.delete(this.c(n)),this.a.delete(i)):o===2&&t===1?i.type=0:o===1&&t===0||(i.type=t)}else s=!0;s&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],i=[];return Array.from(this.a).filter(s=>s.type!==2?(n.push(s),!1):!0).sort((s,o)=>s.resource.fsPath.length-o.resource.fsPath.length).filter(s=>i.some(o=>(0,b.$8k)(s.resource.fsPath,o,!P.$k))?!1:(i.push(s.resource.fsPath),!0)).concat(n)}}}),define(ke[252],Ee([1,0,51,8,22,34,3,75,17,11,23,2,104,31,84]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0,e.$Qq=m;class c extends A.$Uc{static{this.a=100}static{this.b=75}constructor(n,i,s,o){super(),this.m=n,this.n=i,this.r=s,this.s=o,this.c=this.B(new N.$wh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$vh(t=>this.z(t),c.b)),this.g=(0,k.$Bq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Bq)(this.m.path,this.m.includes):void 0,this.j=new M.$ee,this.ready=this.t()}async t(){try{const n=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const i=await S.Promises.stat(n);this.B(await this.w(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.D(n):this.G(n)}}async u(n){let i=n.path;try{i=await S.Promises.realpath(n.path),n.path===i&&(i=await(0,w.$Mq)(n.path)??n.path),n.path!==i&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async w(n,i){if(E.$j&&(0,P.$hg)(n,"/Volumes/",!0))return this.D(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Uc.None;const s=new M.$ee(this.j.token),o=new A.$Tc;try{const t=I.URI.file(this.m.path),d=(0,$.$oc)(n),h=(0,u.watch)(n);o.add((0,A.$Sc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${n}'`);const l=new Set;if(i)try{for(const g of await S.Promises.readdir(n))l.add(g)}catch(g){this.D(g)}const r=new Map;o.add((0,A.$Sc)(()=>{for(const[,g]of r)g.dispose();r.clear()})),h.on("error",(g,f)=>{this.D(`Failed to watch ${n} for changes using fs.watch() (${g}, ${f})`),this.dispose()}),h.on("change",(g,f)=>{if(s.token.isCancellationRequested)return;this.G(`[raw] ["${g}"] ${f}`);let D="";if(f&&(D=f.toString(),E.$j&&(D=(0,b.$Yl)(D))),!(!D||g!=="change"&&g!=="rename"))if(i)if(g==="rename"){r.get(D)?.dispose();const p=setTimeout(async()=>{if(r.delete(D),D===d&&!await S.Promises.exists(n)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.C((0,$.$kc)(n,D));if(s.token.isCancellationRequested)return;let y;v?l.has(D)?y=0:(y=1,l.add(D)):(l.delete(D),y=2),this.y({resource:(0,R.$Ug)(t,D),type:y,cId:this.m.correlationId})},c.a);r.set(D,(0,A.$Sc)(()=>clearTimeout(p)))}else{let p;l.has(D)?p=0:(p=1,l.add(D)),this.y({resource:(0,R.$Ug)(t,D),type:p,cId:this.m.correlationId})}else if(g==="rename"||D!==d){const p=setTimeout(async()=>{const v=await S.Promises.exists(n);s.token.isCancellationRequested||(v?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),o.add(await this.w(n,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);o.clear(),o.add((0,A.$Sc)(()=>clearTimeout(p)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(n)&&!s.token.isCancellationRequested&&this.D(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Sc)(()=>{s.dispose(!0),o.dispose()})}y(n,i=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(s=>s(n.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(s=>s(n.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}z(n){const i=(0,k.$zq)(n);if(i.length>0){if(this.s)for(const o of i)this.G(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(n){if(E.$k)return S.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await S.Promises.readdir((0,$.$nc)(n))).some(o=>o===i)}catch(i){return this.G(i),!1}}setVerboseLogging(n){this.s=n}D(n){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}F(n){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}G(n){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Pq=c;async function m(a,n,i,s,o=512){const t=await S.Promises.open(a,"r"),d=Buffer.allocUnsafe(o),h=new M.$ee(s);let l,r=!1;const g={path:a,excludes:[],recursive:!1},f=new c(g,D=>{(async()=>{for(const{type:p}of D)if(p===0){if(r)return;r=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:v}=await S.Promises.read(t,d,0,o,null);if(!v||h.token.isCancellationRequested)break;n(d.slice(0,v))}}catch(v){l=new Error(v),h.dispose(!0)}finally{r=!1}}})()});return await f.ready,i(),new Promise((D,p)=>{h.token.onCancellationRequested(async()=>{f.dispose();try{await S.Promises.close(t)}catch(v){l=new Error(v)}l?p(l):D()})})}}),define(ke[253],Ee([1,0,4,35,246,11,252]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class b extends M.$Kq{constructor(){super(...arguments),this.onDidError=u.Event.None,this.y=new Map,this.z=!1}async t(E){const R=this.G(E),I=R.filter(S=>{const k=this.y.get(S.path);return k?!(0,N.$fk)(k.request.excludes,S.excludes)||!(0,N.$fk)(k.request.includes,S.includes):!0}),w=Array.from(this.y.values()).filter(({request:S})=>!R.find(k=>k.path===S.path&&(0,N.$fk)(k.excludes,S.excludes)&&(0,N.$fk)(k.includes,S.includes))).map(({request:S})=>S.path);I.length&&this.u(`Request to start watching: ${I.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),w.length&&this.u(`Request to stop watching: ${w.join(",")}`);for(const S of w)this.F(S);for(const S of I)this.D(S)}D(E){const R=new A.$Pq(E,w=>this.a.fire(w),w=>this.b.fire(w),this.z),I={request:E,instance:R};this.y.set(E.path,I)}async stop(){await super.stop();for(const[E]of this.y)this.F(E);this.y.clear()}F(E){const R=this.y.get(E);R&&(this.y.delete(E),R.instance.dispose())}G(E){const R=new Map;for(const I of E){const w=P.$k?I.path:I.path.toLowerCase();let S=R.get(I.correlationId);S||(S=new Map,R.set(I.correlationId,S)),S.set(w,I)}return Array.from(R.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(E){this.z=E;for(const[,R]of this.y)R.instance.setVerboseLogging(E)}u(E){this.z&&this.b.fire({type:"trace",message:this.J(E)})}w(E){this.z&&this.b.fire({type:"warn",message:this.J(E)})}J(E){return`[File Watcher (node.js)] ${E}`}}e.$Rq=b}),define(ke[254],Ee([1,0,84,253]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;class M extends u.$wq{constructor(A,b,$){super(A,b,$),this.s()}r(A){return A.add(new N.$Rq)}}e.$Sq=M}),define(ke[255],Ee([1,0,15,80,193,84]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class A extends P.$xq{constructor($,E,R){super($,E,R),this.s()}r($){const E=$.add(new M.$Iq(u.$Bg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(E.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),N.ProxyChannel.toService((0,N.$1h)(E.getChannel("watcher")))}}e.$Jq=A}),define(ke[107],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class u{constructor(...M){this.a=new Map;for(const[P,A]of M)this.set(P,A)}set(M,P){const A=this.a.get(M);return this.a.set(M,P),A}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$fi=u}),define(ke[256],Ee([1,0,8,13,3,106,247,5,107,74]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;const R=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new $.$fi,a=!1,n,i=R){this.f=m,this.g=a,this.h=n,this.i=i,this.o=new Set,this.f.set(b.$gi,this),this._globalGraph=i?n?._globalGraph??new A.$Vq(s=>s):void 0}createChild(m){return new w(m,this.g,this,this.i)}invokeFunction(m,...a){const n=k.traceInvocation(this.i,m);let i=!1;try{return m({get:o=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(o,n);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(m,...a){let n,i;return m instanceof P.$ei?(n=k.traceCreation(this.i,m.ctor),i=this.j(m.ctor,m.staticArguments.concat(a),n)):(n=k.traceCreation(this.i,m),i=this.j(m,a,n)),n.stop(),i}j(m,a=[],n){const i=b._util.getServiceDependencies(m).sort((t,d)=>t.index-d.index),s=[];for(const t of i){const d=this.m(t.id,n);d||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(d)}const o=i.length>0?i[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${m.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(m,a.concat(s))}k(m,a){if(this.f.get(m)instanceof P.$ei)this.f.set(m,a);else if(this.h)this.h.k(m,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const a=this.f.get(m);return!a&&this.h?this.h.l(m):a}m(m,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.l(m);return n instanceof P.$ei?this.q(m,n,a.branch(m,!0)):(a.branch(m,!1),n)}q(m,a,n){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,a,n)}finally{this.o.delete(m)}}r(m,a,n){const i=new A.$Vq(t=>t.id.toString());let s=0;const o=[{id:m,desc:a,_trace:n}];for(;o.length;){const t=o.pop();if(i.lookupOrInsertNode(t),s++>1e3)throw new I(i);for(const d of b._util.getServiceDependencies(t.desc.ctor)){const h=this.l(d.id);if(h||this.u(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),h instanceof P.$ei){const l={id:d.id,desc:h,_trace:t._trace.branch(d.id,!0)};i.insertEdge(t,l),o.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:d}of t){if(this.l(d.id)instanceof P.$ei){const l=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,l)}i.removeNode(d)}}return this.l(m)}s(m,a,n=[],i,s){if(this.f.get(m)instanceof P.$ei)return this.t(m,a,n,i,s);if(this.h)return this.h.s(m,a,n,i,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(m,a,n=[],i,s){if(i){const o=new w(void 0,this.g,this,this.i);o.c=String(m);const t=new Map,d=new u.$Ah(()=>{const h=o.j(a,n,s);for(const[l,r]of t){const g=h[l];if(typeof g=="function")for(const f of r)f.disposable=g.apply(h,f.listener)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,l){if(!d.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let f=t.get(l);return f||(f=new E.$5c,t.set(l,f)),(p,v,y)=>{if(d.isInitialized)return d.value[l](p,v,y);{const C={listener:[p,v,y],disposable:void 0},O=f.push(C);return(0,M.$Sc)(()=>{O(),C.disposable?.dispose()})}}}if(l in h)return h[l];const r=d.value;let g=r[l];return typeof g!="function"||(g=g.bind(r),h[l]=g),g},set(h,l,r){return d.value[l]=r,!0},getPrototypeOf(h){return a.prototype}})}else return this.j(a,n,s)}u(m,a){if(a&&console.warn(m),this.g)throw new Error(m)}}e.$Wq=w;var S;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(S||(S={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,a){return m?new k(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(m,a){return m?new k(1,a.name):k.c}static{this.f=0}constructor(m,a){this.type=m,this.name=a,this.g=Date.now(),this.h=[]}branch(m,a){const n=new k(3,m.toString());return this.h.push([m,a,n]),n}stop(){const m=Date.now()-this.g;k.f+=m;let a=!1;function n(s,o){const t=[],d=new Array(s+1).join("	");for(const[h,l,r]of o.h)if(l&&r){a=!0,t.push(`${d}CREATES -> ${h}`);const g=n(s+1,r);g&&t.push(g)}else t.push(`${d}uses -> ${h}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(m>2||a)&&k.all.add(i.join(`
`))}}e.$Xq=k}),define(ke[12],Ee([1,0,212,45,4,55,3,28,11,23,18,2,46,5]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=c,e.log=a,e.$2j=f,e.$3j=D,e.$4j=p,e.$5j=v,e.$Nj=(0,S.$hi)("logService"),e.$Oj=(0,S.$hi)("loggerService");function k(){return new Date().toISOString()}function c(y){return(0,R.$Yf)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Qj=m.Info;function a(y,C,O){switch(C){case m.Trace:y.trace(O);break;case m.Debug:y.debug(O);break;case m.Info:y.info(O);break;case m.Warning:y.warn(O);break;case m.Error:y.error(O);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let O="";for(let z=0;z<y.length;z++){let T=y[z];if(T instanceof Error&&(T=(0,N.$5i)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}O+=(z>0?" ":"")+T}return O}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new M.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$Sj=i;class s extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...O){this.f(m.Trace)&&this.g(m.Trace,n([C,...O],!0))}debug(C,...O){this.f(m.Debug)&&this.g(m.Debug,n([C,...O]))}info(C,...O){this.f(m.Info)&&this.g(m.Info,n([C,...O]))}warn(C,...O){this.f(m.Warning)&&this.g(m.Warning,n([C,...O]))}error(C,...O){if(this.f(m.Error))if(C instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=C.stack,this.g(m.Error,n(z))}else this.g(m.Error,n([C,...O]))}flush(){}}e.$Tj=s;class o extends i{constructor(C=e.$Qj){super(),this.setLevel(C),this.g=!$.$i}trace(C,...O){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,C,...O):console.log(`[main ${k()}]`,C,...O))}debug(C,...O){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,C,...O):console.log(`[main ${k()}]`,C,...O))}info(C,...O){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,C,...O):console.log(`[main ${k()}]`,C,...O))}warn(C,...O){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,C,...O):console.warn(`[main ${k()}]`,C,...O))}error(C,...O){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,C,...O):console.error(`[main ${k()}]`,C,...O))}flush(){}}e.$Uj=o;class t extends i{constructor(C=e.$Qj,O=!0){super(),this.g=O,this.setLevel(C)}trace(C,...O){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...O):console.log(C,...O))}debug(C,...O){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...O):console.log(C,...O))}info(C,...O){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...O):console.log(C,...O))}warn(C,...O){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...O):console.log(C,...O))}error(C,...O){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...O):console.error(C,...O))}flush(){}}e.$Vj=t;class d extends i{constructor(C,O=e.$Qj){super(),this.g=C,this.setLevel(O)}trace(C,...O){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...O])}debug(C,...O){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...O])}info(C,...O){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...O])}warn(C,...O){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...O])}error(C,...O){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...O])}h(C){return typeof C=="string"?C:(0,N.$5i)(C,this.f(m.Trace))}flush(){}}e.$Wj=d;class h extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const O of this.g)O.setLevel(C);super.setLevel(C)}trace(C,...O){for(const z of this.g)z.trace(C,...O)}debug(C,...O){for(const z of this.g)z.debug(C,...O)}info(C,...O){for(const z of this.g)z.info(C,...O)}warn(C,...O){for(const z of this.g)z.warn(C,...O)}error(C,...O){for(const z of this.g)z.error(C,...O)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$Xj=h;class l extends A.$Uc{constructor(C,O,z){if(super(),this.h=C,this.j=O,this.b=new b.$Bc,this.c=this.B(new M.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$7d),this.onDidChangeVisibility=this.g.event,z)for(const T of z)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,R.$Uf)(C)?[...this.b.values()].find(O=>O.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,O){const z=this.n(C),T=(0,R.$Uf)(C)?C:O?.id??(0,P.$8i)(z.toString()).toString(16);let B=this.b.get(z)?.logger;const j=O?.logLevel==="always"?m.Trace:O?.logLevel;B||(B=this.s(z,j??this.getLogLevel(z)??this.h,{...O,id:T}));const F={logger:B,info:{resource:z,id:T,logLevel:j,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(F.info),this.b.set(z,F),B}n(C){return(0,R.$Uf)(C)?(0,E.$Ug)(this.j,`${C}.log`):C}setLogLevel(C,O){if(I.URI.isUri(C)){const z=C,T=O,B=this.b.get(z);B&&T!==B.info.logLevel&&(B.info.logLevel=T===this.h?void 0:T,B.logger?.setLevel(T),this.b.set(B.info.resource,B),this.f.fire([z,T]))}else{this.h=C;for(const[z,T]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,O){const z=this.m(C);z&&O!==!z.info.hidden&&(z.info.hidden=!O,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,O]))}getLogLevel(C){let O;return C&&(O=this.b.get(C)?.info.logLevel),O??this.h}registerLogger(C){const O=this.b.get(C.resource);O?O.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const O=this.b.get(C);O&&(O.logger&&O.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=l;class r{constructor(){this.onDidChangeLogLevel=new M.$7d().event}setLevel(C){}getLevel(){return m.Info}trace(C,...O){}debug(C,...O){}info(C,...O){}warn(C,...O){}error(C,...O){}critical(C,...O){}dispose(){}flush(){}}e.$Zj=r;class g extends r{}e.$1j=g;function f(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const C=v(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Qj}function D(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function p(y){switch(y){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function v(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$6j=new w.$yj("logLevel",D(m.Info))}),define(ke[257],Ee([1,0,19,8,13,4,3,17,84,12]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class R extends A.$Uc{constructor(w,S){super(),this.a=w,this.b=S,this.c=this.B(new P.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$fh(0)),this.w=[],this.y=this.B(new N.$fh(0))}watch(w,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(w,S):this.z(w,S)}n(w,S){const k={path:this.H(w),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},c=(0,u.$Ub)(this.j,k);return this.r(),(0,A.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,M.$1)(w))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,$.$yq)(S)),S=>this.G(S),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const S of this.j)(0,$.$uq)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const S of this.j)(0,$.$uq)(S)&&w.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,S){const k={path:this.H(w),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},c=(0,u.$Ub)(this.w,k);return this.C(),(0,A.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,M.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,$.$yq)(w)),w=>this.G(w),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,b.$ic)(w.fsPath)}}e.$Cq=R}),define(ke[258],Ee([1,0,51,396,8,28,21,4,34,3,17,11,23,98,31,211,32,251,257,45,255,254]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0,(()=>{try{(0,N.gracefulify)(u)}catch(d){console.error(`Error enabling graceful-fs: ${(0,i.$5i)(d)}`)}})();class t extends n.$Cq{static{this.I=!1}constructor(h,l){super(h,l),this.onDidChangeCapabilities=b.Event.None,this.N=new P.$Bc(r=>w.$Lg.getComparisonKey(r)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(h){try{const{stat:l,symbolicLink:r}=await k.SymlinkSupport.stat(this.H(h));return{type:this.M(l,r),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const l=await k.Promises.readdir(this.H(h),{withFileTypes:!0}),r=[];return await Promise.all(l.map(async g=>{try{let f;g.isSymbolicLink()?f=(await this.stat((0,w.$Ug)(h,g.name))).type:f=this.M(g),r.push([g.name,f])}catch(f){this.a.trace(f)}})),r}catch(l){throw this.fb(l)}}M(h,l){let r;return l?.dangling?r=m.FileType.Unknown:h.isFile()?r=m.FileType.File:h.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,l&&(r|=m.FileType.SymbolicLink),r}async O(h){const l=this.H(h);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let r;for(;r=this.N.get(h);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await r.wait();const g=new M.$gh;return this.N.set(h,g),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,E.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(h)===g&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(h)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),g.open()})}async readFile(h,l){let r;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(h)})`),r=await this.O(h));const g=this.H(h);return await k.Promises.readFile(g)}catch(g){throw this.fb(g)}finally{r?.dispose()}}P(h){t.I&&this.a.trace(h)}readFileStream(h,l,r){const g=(0,S.$ie)(f=>A.$ue.concat(f.map(D=>A.$ue.wrap(D))).buffer);return(0,a.$sq)(this,h,g,f=>f.buffer,{...l,bufferSize:256*1024},r),g}async writeFile(h,l,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.Q(h)?this.R(h,(0,w.$Ug)((0,w.$Tg)(h),`${(0,w.$Rg)(h)}${r.atomic.postfix}`),l,r):this.S(h,l,r)}async Q(h){try{const l=this.H(h),{symbolicLink:r}=await k.SymlinkSupport.stat(l);if(r)return!1}catch{}return!0}async R(h,l,r,g){const f=new E.$Tc;try{f.add(await this.O(h)),f.add(await this.O(l)),await this.S(l,r,g,!0);try{await this.rename(l,h,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{f.dispose()}}async S(h,l,r,g){let f;try{const D=this.H(h);if(!r.create||!r.overwrite){if(await k.Promises.exists(D)){if(!r.overwrite)throw(0,m.$1k)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.$1k)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(h,{create:!0,unlock:r.unlock},g),await this.write(f,0,l,0,l.byteLength)}catch(D){throw await this.gb(h,D)}finally{typeof f=="number"&&await this.close(f)}}static{this.Y=!0}static configureFlushOnWrite(h){t.Y=h}async open(h,l,r){const g=this.H(h);let f;(0,m.$Ok)(l)&&!r&&(f=await this.O(h));let D;try{if((0,m.$Ok)(l)&&l.unlock)try{const{stat:v}=await k.SymlinkSupport.stat(g);v.mode&128||await k.Promises.chmod(g,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let p;if((0,m.$Ok)(l)){if(I.$i)try{await k.Promises.truncate(g,0),p="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}p||(p="w")}else p="r";D=await k.Promises.open(g,p)}catch(p){throw f?.dispose(),(0,m.$Ok)(l)?await this.gb(h,p):this.fb(p)}if(this.U.set(D,0),(0,m.$Ok)(l)&&this.X.set(D,h),f){const p=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${g})`),this.W.set(D,f),p&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${g})`),p.dispose())}return D}async close(h){const l=this.W.get(h);try{if(this.U.delete(h),this.X.delete(h)&&t.Y)try{await k.Promises.fdatasync(h)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await k.Promises.close(h)}catch(r){throw this.fb(r)}finally{l&&(this.W.get(h)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.W.delete(h)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),l.dispose())}}async read(h,l,r,g,f){const D=this.Z(h,l);let p=null;try{p=(await k.Promises.read(h,r,g,f,D)).bytesRead}catch(v){throw this.fb(v)}finally{this.$(h,D,p)}return p}Z(h,l){return l===this.U.get(h)?null:l}$(h,l,r){const g=this.U.get(h);typeof g=="number"&&(typeof l=="number"||(typeof r=="number"?this.U.set(h,g+r):this.U.delete(h)))}async write(h,l,r,g,f){return(0,M.$Bh)(()=>this.ab(h,l,r,g,f),100,3)}async ab(h,l,r,g,f){const D=this.Z(h,l);let p=null;try{p=(await k.Promises.write(h,r,g,f,D)).bytesWritten}catch(v){throw await this.gb(this.X.get(h),v)}finally{this.$(h,D,p)}return p}async mkdir(h){try{await k.Promises.mkdir(this.H(h))}catch(l){throw this.fb(l)}}async delete(h,l){try{const r=this.H(h);if(l.recursive){let g;l?.atomic!==!1&&l.atomic.postfix&&(g=(0,R.$kc)((0,R.$nc)(r),`${(0,R.$oc)(r)}${l.atomic.postfix}`)),await k.Promises.rm(r,k.RimRafMode.MOVE,g)}else try{await k.Promises.unlink(r)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let f=!1;try{const{stat:D,symbolicLink:p}=await k.SymlinkSupport.stat(r);f=D.isDirectory()&&!p}catch{}if(f)await k.Promises.rmdir(r);else throw g}else throw g}}catch(r){throw this.fb(r)}}async rename(h,l,r){const g=this.H(h),f=this.H(l);if(g!==f)try{await this.bb(h,l,"move",r.overwrite),await k.Promises.rename(g,f)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,c.localize)(2,null,(0,R.$oc)(g),(0,R.$oc)((0,R.$nc)(f)),D.toString()))),this.fb(D)}}async copy(h,l,r){const g=this.H(h),f=this.H(l);if(g!==f)try{await this.bb(h,l,"copy",r.overwrite),await k.Promises.copy(g,f,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,c.localize)(3,null,(0,R.$oc)(g),(0,R.$oc)((0,R.$nc)(f)),D.toString()))),this.fb(D)}}async bb(h,l,r,g){const f=this.H(h),D=this.H(l);let p=!1;if(!!(this.capabilities&1024)||(p=(0,$.$gg)(f,D,!0)),p){if(r==="copy")throw(0,m.$1k)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const y=await this.L(h);if(!y)throw(0,m.$1k)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(l);if(C){if(!g)throw(0,m.$1k)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&C.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,l){return this.cb(h,l,!1)}async cb(h,l,r){const g=this.H(h),f=this.H(l),D=!!(this.capabilities&1024);if((0,$.$gg)(g,f,!D))return;const p=new E.$Tc;try{p.add(await this.O(h)),p.add(await this.O(l)),r&&await k.Promises.mkdir((0,R.$nc)(f),{recursive:!0}),await k.Promises.copyFile(g,f)}catch(v){if(v.code==="ENOENT"&&!r)return this.cb(h,l,!0);throw this.fb(v)}finally{p.dispose()}}t(h,l,r){return new s.$Jq(g=>h(g),g=>l(g),r)}F(h,l,r){return new o.$Sq(g=>h(g),g=>l(g),r)}fb(h){if(h instanceof m.$Zk)return h;let l=h,r;switch(h.code){case"ENOENT":r=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=m.FileSystemProviderErrorCode.Unknown;break;default:r=m.FileSystemProviderErrorCode.Unknown}return(0,m.$1k)(l,r)}async gb(h,l){let r=this.fb(l);if(h&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await k.SymlinkSupport.stat(this.H(h));g.mode&128||(r=(0,m.$1k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return r}}e.$Tq=t}),define(ke[259],Ee([1,0,3,12]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;class M extends u.$Uc{constructor(A,b=[]){super(),this.a=new N.$Xj([A,...b]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$YP=M}),define(ke[260],Ee([1,0,32,12]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;var M;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(M||(M={}));async function P(E,R,I,w,S){try{const k=await new Promise((m,a)=>{de(["@vscode/spdlog"],m,a)});k.setFlushOn(M.Trace);const c=await k.createAsyncRotatingLogger(E,R,I,w);return S?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(k){console.error(k)}return null}function A(E,R,I){switch(R){case N.LogLevel.Trace:E.trace(I);break;case N.LogLevel.Debug:E.debug(I);break;case N.LogLevel.Info:E.info(I);break;case N.LogLevel.Warning:E.warn(I);break;case N.LogLevel.Error:E.error(I);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function b(E,R){switch(R){case N.LogLevel.Trace:E.setLevel(M.Trace);break;case N.LogLevel.Debug:E.setLevel(M.Debug);break;case N.LogLevel.Info:E.setLevel(M.Info);break;case N.LogLevel.Warning:E.setLevel(M.Warning);break;case N.LogLevel.Error:E.setLevel(M.Error);break;case N.LogLevel.Off:E.setLevel(M.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends N.$Tj{constructor(R,I,w,S,k){super(),this.m=[],this.setLevel(k),this.n=this.s(R,I,w,S),this.B(this.onDidChangeLogLevel(c=>{this.r&&b(this.r,c)}))}async s(R,I,w,S){const k=w?6:1,c=30/k*u.$jl.MB,m=await P(R,I,c,k,S);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:a,message:n}of this.m)A(this.r,a,n);this.m=[]}}g(R,I){this.r?A(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NP=$}),define(ke[138],Ee([1,0,39,213,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function E(k,c){return c-k}$.compare=E;const R=Object.create(null);R[$.Error]=(0,N.localize)(0,null),R[$.Warning]=(0,N.localize)(1,null),R[$.Info]=(0,N.localize)(2,null);function I(k){return R[k]||""}$.toString=I;function w(k){switch(k){case u.default.Error:return $.Error;case u.default.Warning:return $.Warning;case u.default.Info:return $.Info;case u.default.Ignore:return $.Hint}}$.fromSeverity=w;function S(k){switch(k){case $.Error:return u.default.Error;case $.Warning:return u.default.Warning;case $.Info:return u.default.Info;case $.Hint:return u.default.Ignore}}$.toSeverity=S}(A||(e.MarkerSeverity=A={}));var b;(function($){const E="";function R(w){return I(w,!0)}$.makeKey=R;function I(w,S){const k=[E];return w.source?k.push(w.source.replace("\xA6","\\\xA6")):k.push(E),w.code?typeof w.code=="string"?k.push(w.code.replace("\xA6","\\\xA6")):k.push(w.code.value.replace("\xA6","\\\xA6")):k.push(E),w.severity!==void 0&&w.severity!==null?k.push(A.toString(w.severity)):k.push(E),w.message&&S?k.push(w.message.replace("\xA6","\\\xA6")):k.push(E),w.startLineNumber!==void 0&&w.startLineNumber!==null?k.push(w.startLineNumber.toString()):k.push(E),w.startColumn!==void 0&&w.startColumn!==null?k.push(w.startColumn.toString()):k.push(E),w.endLineNumber!==void 0&&w.endLineNumber!==null?k.push(w.endLineNumber.toString()):k.push(E),w.endColumn!==void 0&&w.endColumn!==null?k.push(w.endColumn.toString()):k.push(E),k.push(E),k.join("\xA6")}$.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$St=(0,M.$hi)("markerService")}),define(ke[261],Ee([1,0,4,39,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Jv=e.Severity=void 0,e.$Kv=b,e.Severity=N.default,e.$Jv=(0,M.$hi)("notificationService");var P;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function b(I){if(I){const w=I;return typeof w.id=="string"&&typeof w.label=="string"}return!1}var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new R,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.$Lv=E;class R{infinite(){}done(){}total(w){}worked(w){}}e.$Mv=R}),define(ke[262],Ee([1,0,50]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.context<"u"){const P=M.context.configuration();if(P)N=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:P.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,u.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(de,e){return function(u,N){e(u,N,de)}};define(ke[108],Ee([1,0,8,22,3,5]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.ProgressLocation=e.$Nv=void 0,e.$Nv=(0,P.$hi)("progressService");var A;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Ov=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.$Pv=b;class ${get value(){return this.a}constructor(w){this.e=w}report(w){this.b?this.b.push(w):this.b=[w],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const w=this.b.shift();this.a=w,await this.e(this.a)}}finally{this.c=!1;const w=this.d;this.d=void 0,w?.()}}drain(){return this.c?new Promise(w=>{const S=this.d;this.d=()=>{S?.(),w()}}):Promise.resolve()}}e.$Qv=$;let E=class extends M.$Uc{constructor(w,S){super(),this.a=new u.$Eh,S.withProgress(w,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.$Rv=E,e.$Rv=E=Je([Ve(1,e.$Nv)],E);class R extends M.$Uc{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new M.$Tc)}start(w){this.stop();const S=++this.a,k=new N.$ee;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>k.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:k.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.$Sv=R,e.$Tv=(0,P.$hi)("editorProgressService")}),define(ke[37],Ee([1,0,61,18]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class M{constructor(){this.a=new Map}add(A,b){u.ok(N.$Uf(A)),u.ok(N.$Wf(b)),u.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Zn=new M}),define(ke[109],Ee([1,0,4,37]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function M(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class P{constructor(){this.b=new u.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,E){this.a[M($)]=E,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;N.$Zn.add(e.$1n.JSONContribution,A)}),define(ke[85],Ee([1,0,19,4,18,202,53,109,37]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=c,e.$eo=m,e.$fo=a,e.$go=i,e.$ho=s;var E;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$5n={Configuration:"base.contributions.configuration"};var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const I=$.$Zn.as(b.$1n.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$7d,this.onDidSchemaChange=this.i.event,this.j=new N.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const h=new Set;this.n(t,d,h),I.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const d=new Set;this.o(t,d),I.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const h=new Set;this.o(d,h),this.n(t,!1,h),I.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const h=[];for(const{overrides:l,source:r}of t)for(const g in l)if(d.add(g),e.$co.test(g)){const f=this.a.get(g),D=f?.valuesSources??new Map;if(r)for(const C of Object.keys(l[g]))D.set(C,r);const p={...f?.value||{},...l[g]};this.a.set(g,{source:r,value:p,valuesSources:D});const v=(0,A.$Xi)(g),y={type:"object",default:p,description:P.localize(1,null,v),$ref:e.$_n,defaultDefaultValue:p,source:M.$Uf(r)?void 0:r,defaultValueSource:r};h.push(...c(g)),this.d[g]=y,this.b.properties[g]=y}else{this.a.set(g,{value:l[g],source:r});const f=this.d[g];f&&(this.w(g,f),this.r(g,f))}this.m(h)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:h,source:l}of t)for(const r in h){const g=this.a.get(r),f=M.$Uf(l)?l:l?.id,D=M.$Uf(g?.source)?g?.source:g?.source?.id;if(f===D)if(d.add(r),this.a.delete(r),e.$co.test(r))delete this.d[r],delete this.b.properties[r];else{const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}}this.u()}deltaConfiguration(t){let d=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,h){t.forEach(l=>{this.p(l,d,l.extensionInfo,l.restrictedProperties,void 0,h),this.c.push(l),this.q(l)})}o(t,d){const h=l=>{if(l.properties)for(const r in l.properties){d.add(r);const g=this.d[r];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[r],this.s(r,l.properties[r])}l.allOf?.forEach(r=>h(r))};for(const l of t){h(l);const r=this.c.indexOf(l);r!==-1&&this.c.splice(r,1)}}p(t,d=!0,h,l,r=3,g){r=M.$4f(t.scope)?r:t.scope;const f=t.properties;if(f)for(const p in f){const v=f[p];if(d&&i(p,v)){delete f[p];continue}if(v.source=h,v.defaultDefaultValue=f[p].default,this.w(p,v),e.$co.test(p)?v.scope=void 0:(v.scope=M.$4f(v.scope)?r:v.scope,v.restricted=M.$4f(v.restricted)?!!l?.includes(p):v.restricted),f[p].hasOwnProperty("included")&&!f[p].included){this.f[p]=f[p],delete f[p];continue}else this.d[p]=f[p],f[p].policy?.name&&this.e.set(f[p].policy.name,p);!f[p].deprecationMessage&&f[p].markdownDeprecationMessage&&(f[p].deprecationMessage=f[p].markdownDeprecationMessage),g.add(p)}const D=t.allOf;if(D)for(const p of D)this.p(p,d,h,l,r,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=h=>{const l=h.properties;if(l)for(const g in l)this.r(g,l[g]);h.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$6n.properties[t]=d,d.scope){case 1:e.$7n.properties[t]=d;break;case 2:e.$8n.properties[t]=d;break;case 6:e.$9n.properties[t]=d;break;case 3:e.$0n.properties[t]=d;break;case 4:e.$$n.properties[t]=d;break;case 5:e.$$n.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$6n.properties[t],d.scope){case 1:delete e.$7n.properties[t];break;case 2:delete e.$8n.properties[t];break;case 6:delete e.$9n.properties[t];break;case 3:delete e.$0n.properties[t];break;case 4:case 5:delete e.$$n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,h={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$_n};this.w(d,h),e.$6n.properties[d]=h,e.$7n.properties[d]=h,e.$8n.properties[d]=h,e.$9n.properties[d]=h,e.$0n.properties[d]=h,e.$$n.properties[d]=h}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=t,e.$7n.patternProperties[e.$bo]=t,e.$8n.patternProperties[e.$bo]=t,e.$9n.patternProperties[e.$bo]=t,e.$0n.patternProperties[e.$bo]=t,e.$$n.patternProperties[e.$bo]=t,this.i.fire()}w(t,d){const h=this.a.get(t);let l=h?.value,r=h?.source;M.$2f(l)&&(l=d.defaultDefaultValue,r=void 0),M.$2f(l)&&(l=a(d.type)),d.default=l,d.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",k=new RegExp(S,"g");e.$bo=`^(${S})+$`,e.$co=new RegExp(e.$bo);function c(o){const t=[];if(e.$co.test(o)){let d=k.exec(o);for(;d?.length;){const h=d[1].trim();h&&t.push(h),d=k.exec(o)}}return(0,u.$Mb)(t)}function m(o){return o.reduce((t,d)=>`${t}[${d}]`,"")}function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new w;$.$Zn.add(e.$5n.Configuration,n);function i(o,t){return o.trim()?e.$co.test(o)?P.localize(7,null,o):n.getConfigurationProperties()[o]!==void 0?P.localize(8,null,o):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,o,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}function s(){const o=[],t=n.getConfigurationProperties();for(const d of Object.keys(t))o.push([d,t[d].scope]);return o.push(["launch",4]),o.push(["task",4]),o}}),define(ke[263],Ee([1,0,19,4,163,3,28,24,18,2,53,85,37]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=i;function S(d){return Object.isFrozen(d)?d:b.$On(d)}class k{constructor(h={},l=[],r=[],g){this.b=h,this.c=l,this.d=r,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const h=this.raw.map(l=>{if(l instanceof k)return l;const r=new c("");return r.parseRaw(l),r.configurationModel});this.f=h.reduce((l,r)=>r===l?r:l.merge(r),h[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,R.$Vi)(this.contents,h):this.contents}inspect(h,l){const r=this;return{get value(){return S(r.rawConfiguration.getValue(h))},get override(){return l?S(r.rawConfiguration.getOverrideValue(h,l)):void 0},get merged(){return S(l?r.rawConfiguration.override(l).getValue(h):r.rawConfiguration.getValue(h))},get overrides(){const g=[];for(const{contents:f,identifiers:D,keys:p}of r.rawConfiguration.overrides){const v=new k(f,p).getValue(h);v!==void 0&&g.push({identifiers:D,value:v})}return g.length?S(g):void 0}}}getOverrideValue(h,l){const r=this.i(l);return r?h?(0,R.$Vi)(r,h):r:void 0}getKeysForOverrideIdentifier(h){const l=[];for(const r of this.overrides)r.identifiers.includes(h)&&l.push(...r.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const h=[];for(const l of this.overrides)h.push(...l.identifiers);return u.$Mb(h)}override(h){let l=this.a.get(h);return l||(l=this.g(h),this.a.set(h,l)),l}merge(...h){const l=b.$Nn(this.contents),r=b.$Nn(this.overrides),g=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const D of h)if(f.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(l,D.contents);for(const p of D.overrides){const[v]=r.filter(y=>u.$ub(y.identifiers,p.identifiers));v?(this.h(v.contents,p.contents),v.keys.push(...p.keys),v.keys=u.$Mb(v.keys)):r.push(b.$Nn(p))}for(const p of D.keys)g.indexOf(p)===-1&&g.push(p)}return new k(l,g,r,f.every(D=>D instanceof k)?void 0:f)}g(h){const l=this.i(h);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const r={};for(const g of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let f=this.contents[g];const D=l[g];D&&(typeof f=="object"&&typeof D=="object"?(f=b.$Nn(f),this.h(f,D)):f=D),r[g]=f}return new k(r,this.keys,this.overrides)}h(h,l){for(const r of Object.keys(l)){if(r in h&&$.$Wf(h[r])&&$.$Wf(l[r])){this.h(h[r],l[r]);continue}h[r]=b.$Nn(l[r])}}i(h){let l=null,r=null;const g=f=>{f&&(r?this.h(r,f):r=b.$Nn(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===h?l=f.contents:f.identifiers.includes(h)&&g(f.contents);return g(l),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,l){this.j(h,l,!0)}setValue(h,l){this.j(h,l,!1)}removeValue(h){const l=this.keys.indexOf(h);l!==-1&&(this.keys.splice(l,1),(0,R.$Ui)(this.contents,h),I.$co.test(h)&&this.overrides.splice(this.overrides.findIndex(r=>u.$ub(r.identifiers,(0,I.$do)(h))),1))}j(h,l,r){(0,R.$Ti)(this.contents,h,l,g=>console.error(g)),r=r||this.keys.indexOf(h)===-1,r&&this.keys.push(h),I.$co.test(h)&&this.overrides.push({identifiers:(0,I.$do)(h),keys:Object.keys(this.contents[h]),contents:(0,R.$Si)(this.contents[h],g=>console.error(g))})}}e.$io=k;class c{constructor(h){this.f=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,l){if(!$.$4f(h)){const r=this.g(h);this.parseRaw(r,l)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,l){this.a=h;const{contents:r,keys:g,overrides:f,restricted:D,hasExcludedProperties:p}=this.h(h,l);this.b=new k(r,g,f,p?[h]:void 0),this.c=D||[]}g(h){let l={},r=null,g=[];const f=[],D=[];function p(y){Array.isArray(g)?g.push(y):r!==null&&(g[r]=y)}const v={onObjectBegin:()=>{const y={};p(y),f.push(g),g=y,r=null},onObjectProperty:y=>{r=y},onObjectEnd:()=>{g=f.pop()},onArrayBegin:()=>{const y=[];p(y),f.push(g),g=y,r=null},onArrayEnd:()=>{g=f.pop()},onLiteralValue:p,onError:(y,C,O)=>{D.push({error:y,offset:C,length:O})}};if(h)try{M.$Bn(h,v),l=g[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}h(h,l){const r=w.$Zn.as(I.$5n.Configuration).getConfigurationProperties(),g=this.i(h,r,!0,l);h=g.raw;const f=(0,R.$Si)(h,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),D=Object.keys(h),p=this.j(h,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:f,keys:D,overrides:p,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(h,l,r,g){let f=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:f};const D={},p=[];for(const v in h)if(I.$co.test(v)&&r){const y=this.i(h[v],l,!1,g);D[v]=y.raw,f=f||y.hasExcludedProperties,p.push(...y.restricted)}else{const y=l[v],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&p.push(v),!g.exclude?.includes(v)&&(g.include?.includes(v)||(C===void 0||g.scopes===void 0||g.scopes.includes(C))&&!(g.skipRestricted&&y?.restricted))?D[v]=h[v]:f=!0}return{raw:D,restricted:p,hasExcludedProperties:f}}j(h,l){const r=[];for(const g of Object.keys(h))if(I.$co.test(g)){const f={};for(const D in h[g])f[D]=h[g][D];r.push({identifiers:(0,I.$do)(g),keys:Object.keys(f),contents:(0,R.$Si)(f,l)})}return r}}e.$jo=c;class m extends P.$Uc{constructor(h,l,r,g){super(),this.c=h,this.f=l,this.g=g,this.b=this.B(new N.$7d),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&r.isEqual(f.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=m;class a{constructor(h,l,r,g,f,D,p,v,y,C,O,z,T){this.a=h,this.b=l,this.c=r,this.overrideIdentifiers=g,this.d=f,this.f=D,this.g=p,this.h=v,this.i=y,this.j=C,this.k=O,this.l=z,this.m=T}get value(){return S(this.c)}n(h){return h?.value!==void 0||h?.override!==void 0||h?.overrides!==void 0?h:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(h,l,r,g,f=new k,D=new k,p=new A.$Bc,v=new k,y=new A.$Bc){this.c=h,this.d=l,this.f=r,this.g=g,this.h=f,this.i=D,this.j=p,this.l=v,this.m=y,this.a=null,this.b=new A.$Bc,this.n=null}getValue(h,l,r){return this.p(h,l,r).getValue(h)}updateValue(h,l,r={}){let g;r.resource?(g=this.m.get(r.resource),g||(g=new k,this.m.set(r.resource,g))):g=this.l,l===void 0?g.removeValue(h):g.setValue(h,l),r.resource||(this.a=null)}inspect(h,l,r){const g=this.p(h,l,r),f=this.t(l.resource,r),D=l.resource?this.m.get(l.resource)||this.l:this.l,p=new Set;for(const v of g.overrides)for(const y of v.identifiers)g.getOverrideValue(h,y)!==void 0&&p.add(y);return new a(h,l,g.getValue(h),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,f||void 0,D)}keys(h){const l=this.t(void 0,h);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(h){this.c=h,this.a=null,this.b.clear()}updatePolicyConfiguration(h){this.d=h}updateApplicationConfiguration(h){this.f=h,this.a=null,this.b.clear()}updateLocalUserConfiguration(h){this.g=h,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(h){this.h=h,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(h){this.i=h,this.a=null,this.b.clear()}updateFolderConfiguration(h,l){this.j.set(h,l),this.b.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.b.delete(h)}compareAndUpdateDefaultConfiguration(h,l){const r=[];if(!l){const{added:g,updated:f,removed:D}=o(this.c,h);l=[...g,...f,...D]}for(const g of l)for(const f of(0,I.$do)(g)){const D=this.c.getKeysForOverrideIdentifier(f),p=h.getKeysForOverrideIdentifier(f),v=[...p.filter(y=>D.indexOf(y)===-1),...D.filter(y=>p.indexOf(y)===-1),...D.filter(y=>!b.$Rn(this.c.override(f).getValue(y),h.override(f).getValue(y)))];r.push([f,v])}return this.updateDefaultConfiguration(h),{keys:l,overrides:r}}compareAndUpdatePolicyConfiguration(h){const{added:l,updated:r,removed:g}=o(this.d,h),f=[...l,...r,...g];return f.length&&this.updatePolicyConfiguration(h),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:l,updated:r,removed:g,overrides:f}=o(this.applicationConfiguration,h),D=[...l,...r,...g];return D.length&&this.updateApplicationConfiguration(h),{keys:D,overrides:f}}compareAndUpdateLocalUserConfiguration(h){const{added:l,updated:r,removed:g,overrides:f}=o(this.localUserConfiguration,h),D=[...l,...r,...g];return D.length&&this.updateLocalUserConfiguration(h),{keys:D,overrides:f}}compareAndUpdateRemoteUserConfiguration(h){const{added:l,updated:r,removed:g,overrides:f}=o(this.remoteUserConfiguration,h),D=[...l,...r,...g];return D.length&&this.updateRemoteUserConfiguration(h),{keys:D,overrides:f}}compareAndUpdateWorkspaceConfiguration(h){const{added:l,updated:r,removed:g,overrides:f}=o(this.workspaceConfiguration,h),D=[...l,...r,...g];return D.length&&this.updateWorkspaceConfiguration(h),{keys:D,overrides:f}}compareAndUpdateFolderConfiguration(h,l){const r=this.folderConfigurations.get(h),{added:g,updated:f,removed:D,overrides:p}=o(r,l),v=[...g,...f,...D];return(v.length||!r)&&this.updateFolderConfiguration(h,l),{keys:v,overrides:p}}compareAndDeleteFolderConfiguration(h){const l=this.folderConfigurations.get(h);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:r,updated:g,removed:f,overrides:D}=o(l,void 0);return{keys:[...r,...g,...f],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(h,l,r){let g=this.q(l,r);return l.overrideIdentifier&&(g=g.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(h)!==void 0&&(g=g.merge(this.d)),g}q({resource:h},l){let r=this.r();if(l&&h){const g=l.getFolder(h);g&&(r=this.s(g.uri)||r);const f=this.m.get(h);f&&(r=r.merge(f))}return r}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(h){let l=this.b.get(h);if(!l){const r=this.r(),g=this.j.get(h);g?(l=r.merge(g),this.b.set(h,l)):l=r}return l}t(h,l){if(l&&h){const r=l.getFolder(h);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((h,l)=>{const{contents:r,overrides:g,keys:f}=this.j.get(l);return h.push([l,{contents:r,overrides:g,keys:f}]),h},[])}}allKeys(){const h=new Set;return this.c.keys.forEach(l=>h.add(l)),this.userConfiguration.keys.forEach(l=>h.add(l)),this.i.keys.forEach(l=>h.add(l)),this.j.forEach(l=>l.keys.forEach(r=>h.add(r))),[...h.values()]}u(){const h=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>h.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>h.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>h.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(r=>h.add(r))),[...h.values()]}v(h){const l=new Set;return this.c.getKeysForOverrideIdentifier(h).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(r=>l.add(r)),this.i.getKeysForOverrideIdentifier(h).forEach(r=>l.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(h).forEach(g=>l.add(g))),[...l.values()]}static parse(h){const l=this.w(h.defaults),r=this.w(h.policy),g=this.w(h.application),f=this.w(h.user),D=this.w(h.workspace),p=h.folders.reduce((v,y)=>(v.set(E.URI.revive(y[0]),this.w(y[1])),v),new A.$Bc);return new n(l,r,g,f,new k,D,p,new k,new A.$Bc)}static w(h){return new k(h.contents,h.keys,h.overrides)}}e.$lo=n;function i(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const h=new Set,l=new Map;for(const g of d)g.keys.forEach(f=>h.add(f)),g.overrides.forEach(([f,D])=>{const p=(0,A.$yc)(l,f,new Set);D.forEach(v=>p.add(v))});const r=[];return l.forEach((g,f)=>r.push([f,[...g.values()]])),{keys:[...h.values()],overrides:r}}class s{constructor(h,l,r,g){this.change=h,this.f=l,this.g=r,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const f of h.keys)this.affectedKeys.add(f);for(const[,f]of h.overrides)for(const D of f)this.affectedKeys.add(D);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(h,l){const r=this.a+h,g=this.d.indexOf(r);if(g<0)return!1;const f=g+r.length;if(f>=this.d.length)return!1;const D=this.d.charCodeAt(f);if(D!==this.b&&D!==this.c)return!1;if(l){const p=this.previousConfiguration?this.previousConfiguration.getValue(h,l,this.f?.workspace):void 0,v=this.g.getValue(h,l,this.h);return!b.$Rn(p,v)}return!0}}e.$no=s;function o(d,h){const{added:l,removed:r,updated:g}=t(h?.rawConfiguration,d?.rawConfiguration),f=[],D=d?.getAllOverrideIdentifiers()||[],p=h?.getAllOverrideIdentifiers()||[];if(h){const v=p.filter(y=>!D.includes(y));for(const y of v)f.push([y,h.getKeysForOverrideIdentifier(y)])}if(d){const v=D.filter(y=>!p.includes(y));for(const y of v)f.push([y,d.getKeysForOverrideIdentifier(y)])}if(h&&d){for(const v of D)if(p.includes(v)){const y=t({contents:d.getOverrideValue(void 0,v)||{},keys:d.getKeysForOverrideIdentifier(v)},{contents:h.getOverrideValue(void 0,v)||{},keys:h.getKeysForOverrideIdentifier(v)});f.push([v,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:r,updated:g,overrides:f}}function t(d,h){const l=d?h?d.keys.filter(f=>h.keys.indexOf(f)===-1):[...d.keys]:[],r=h?d?h.keys.filter(f=>d.keys.indexOf(f)===-1):[...h.keys]:[],g=[];if(d&&h){for(const f of h.keys)if(d.keys.indexOf(f)!==-1){const D=(0,R.$Vi)(h.contents,f),p=(0,R.$Vi)(d.contents,f);b.$Rn(D,p)||g.push(f)}}return{added:l,removed:r,updated:g}}}),define(ke[264],Ee([1,0,21,4,3,81]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Utb=e.$Stb=e.$Rtb=void 0,e.$Ttb=b;const A=(E,R,I)=>{const w=new Uint8Array(16);for(let c=0;c<16;c++)w[c]=Math.round(Math.random()*256);const S=(0,u.$Oe)(u.$ue.wrap(w));return[`GET ws://localhost${E}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Rtb=A,e.$Stb=u.$ue.fromString(`\r
\r
`);async function b(E,R,I,w,S){E.write(u.$ue.fromString((0,e.$Rtb)(R,I,w)));const k=new M.$Tc;try{return await new Promise((c,m)=>{let a;k.add(E.onData(n=>{a?a=u.$ue.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$Stb);if(i===-1)return;c(E),E.pauseData();const s=a.slice(i+e.$Stb.byteLength);s.byteLength&&S.onData.fire(s)})),k.add(E.onClose(n=>m(n??new Error("socket closed")))),k.add(E.onEnd(()=>m(new Error("socket ended"))))})}catch(c){throw E.dispose(),c}finally{k.dispose()}}class $ extends M.$Uc{constructor(R,I){super(),this.g=R,this.a=this.B(new N.$0d),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(w=>this.a.fire(w))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Utb=$}),define(ke[64],Ee([1,0,13,5]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=E,e.$sl=(0,N.$hi)("remoteAuthorityResolverService");var M;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class P{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=P;class A{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=A;var b;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends u.$bb{static isNotAvailable(I){return I instanceof $&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,w=b.Unknown,S){super(I),this._message=I,this._code=w,this._detail=S,this.isHandled=w===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$vl=$;function E(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}}),define(ke[265],Ee([1,0,8,21,22,13,4,3,15,58,38,30,81,64]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Bl=D,e.$Cl=p,e.$Dl=y;const k=30*1e3;var c;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function m(re){switch(re){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(re){const U=new M.$ee;return setTimeout(()=>U.cancel(),re),U.token}function n(re,U){if(re.isCancellationRequested||U.isCancellationRequested)return M.CancellationToken.Cancelled;const ie=new M.$ee;return re.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$ah)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function s(re,U){const ie=new i(U);return ie.registerDisposable(re.onControlMessage(ve=>{const Ie=JSON.parse(ve.toString()),le=x(Ie);le?ie.reject(le):ie.resolve(Ie)})),ie.promise}function o(re,U,ie,ve,Ie,le,ae,ce){const H=new i(ce),Q=R.$3d.create(!1);return re.info(`Creating a socket (${ae})...`),E.mark(`code/willCreateSocket/${le}`),U.connect(ie,ve,Ie,ae).then(he=>{H.didTimeout?(E.mark(`code/didCreateSocketError/${le}`),re.info(`Creating a socket (${ae}) finished after ${Q.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(E.mark(`code/didCreateSocketOK/${le}`),re.info(`Creating a socket (${ae}) was successful after ${Q.elapsed()} ms.`),H.resolve(he))},he=>{E.mark(`code/didCreateSocketError/${le}`),re.info(`Creating a socket (${ae}) returned an error after ${Q.elapsed()} ms.`),re.error(he),H.reject(he)}),H.promise}function t(re,U){const ie=new i(U);return re.then(ve=>{ie.didTimeout||ie.resolve(ve)},ve=>{ie.didTimeout||ie.reject(ve)}),ie.promise}async function d(re,U,ie,ve){const Ie=$e(re,U);re.logService.trace(`${Ie} 1/6. invoking socketFactory.connect().`);let le;try{le=await o(re.logService,re.remoteSocketFactoryService,re.connectTo,$.$ug.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${re.reconnectionToken}`,ve)}catch(he){throw re.logService.error(`${Ie} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${Ie} 2/6. socketFactory.connect() was successful.`);let ae,ce;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(le,null),ae=re.reconnectionProtocol,ce=!1):(ae=new w.$8h({socket:le}),ce=!0),re.logService.trace(`${Ie} 3/6. sending AuthRequest control message.`);const H=await t(re.signService.createNewMessage((0,I.$Dg)()),ve),Q={type:"auth",auth:re.connectionToken||"00000000000000000000",data:H.data};ae.sendControl(N.$ue.fromString(JSON.stringify(Q)));try{const he=await s(ae,n(ve,a(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(re.logService.trace(`${Ie} 4/6. received SignRequest control message.`),!await t(re.signService.validate(H,he.signedData),ve)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Pe=await t(re.signService.sign(he.data),ve),be={type:"connectionType",commit:re.commit,signedData:Pe,desiredConnectionType:U};return ie&&(be.args=ie),re.logService.trace(`${Ie} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(N.$ue.fromString(JSON.stringify(be))),{protocol:ae,ownsProtocol:ce}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${Ie} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${Ie} received error control message when negotiating connection. Error:`),re.logService.error(he)),ce&&Z(ae),he}}async function h(re,U,ie,ve){const Ie=Date.now(),le=$e(re,U),{protocol:ae,ownsProtocol:ce}=await d(re,U,ie,ve),H=new i(ve);return H.registerDisposable(ae.onControlMessage(Q=>{const he=JSON.parse(Q.toString()),fe=x(he);fe?(re.logService.error(`${le} received error control message when negotiating connection. Error:`),re.logService.error(fe),ce&&Z(ae),H.reject(fe)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${se(Ie)}!`),H.resolve({protocol:ae,firstMessage:he}))})),H.promise}async function l(re,U){const{protocol:ie}=await h(re,1,void 0,U);return{protocol:ie}}async function r(re,U,ie){const{protocol:ve,firstMessage:Ie}=await h(re,2,U,ie),le=Ie&&Ie.debugPort;return{protocol:ve,debugPort:le}}async function g(re,U,ie){const ve=Date.now(),Ie=$e(re,3),{protocol:le}=await d(re,3,U,ie);return re.logService.trace(`${Ie} 6/6. handshake finished, connection is up and running after ${se(ve)}!`),le}async function f(re,U,ie){const{connectTo:ve,connectionToken:Ie}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:ve,connectionToken:Ie,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function D(re,U,ie){return v(re,async ve=>{const{protocol:Ie}=await l(ve,M.CancellationToken.None);return new G(re,U,ie,ve.reconnectionToken,Ie)})}async function p(re,U){return v(re,async ie=>{const{protocol:ve,debugPort:Ie}=await r(ie,U,M.CancellationToken.None);return new te(re,U,ie.reconnectionToken,ve,Ie)})}async function v(re,U){for(let ve=1;;ve++)try{const Ie=(0,I.$Dg)(),le=await f(re,Ie,null);return await U(le)}catch(Ie){if(ve<5)re.logService.error(`[remote-connection][attempt ${ve}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(Ie);else throw re.logService.error(`[remote-connection][attempt ${ve}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(Ie),L.triggerPermanentFailure(0,0,S.$vl.isHandled(Ie)),Ie}}async function y(re,U,ie){const ve=await f(re,(0,I.$Dg)(),null);return await g(ve,{host:U,port:ie},M.CancellationToken.None)}function C(re){return(0,u.$7g)(U=>new Promise((ie,ve)=>{const Ie=setTimeout(ie,re*1e3);U.onCancellationRequested(()=>{clearTimeout(Ie),ie()})}))}var O;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class z{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$El=z;class T{constructor(U,ie,ve,Ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=ve,this.c=Ie,this.type=1}skipWait(){this.c.cancel()}}e.$Fl=T;class B{constructor(U,ie,ve){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=ve,this.type=2}}e.$Gl=B;class j{constructor(U,ie,ve){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=ve,this.type=4}}e.$Hl=j;class F{constructor(U,ie,ve,Ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=ve,this.handled=Ie,this.type=3}}e.$Il=F;class L extends b.$Uc{static triggerPermanentFailure(U,ie,ve){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=ve,this.j.forEach(Ie=>Ie.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||L._permanentFailure}constructor(U,ie,ve,Ie,le){super(),this.t=U,this.u=ie,this.reconnectionToken=ve,this.protocol=Ie,this.w=le,this.m=this.B(new A.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(Ie.onSocketClose(ae=>{const ce=X(this.t,this.reconnectionToken,!0);ae?ae.type===0?(this.u.logService.info(`${ce} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${ce} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${ce} received socket close event.`),this.y()})),this.B(Ie.onSocketTimeout(ae=>{const ce=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),L.j.push(this),this.B((0,b.$Sc)(()=>{const ae=L.j.indexOf(this);ae>=0&&L.j.splice(ae,1)})),this.n&&this.D(L.f,L.g,L.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ve=-1;do{ve++;const Ie=ve<ie.length?ie[ve]:ie[ie.length-1];try{if(Ie>0){const ae=C(Ie);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ie,ae)),this.u.logService.info(`${U} waiting for ${Ie} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve+1)),this.u.logService.info(`${U} resolving connection...`);const le=await f(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${le.connectTo}...`),await this.G(le,a(k)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ve+1));break}catch(le){if(le.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}if(ve>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}if(S.$vl.isTemporarilyNotAvailable(le)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if((le.code==="ETIMEDOUT"||le.code==="ENETUNREACH"||le.code==="ECONNREFUSED"||le.code==="ECONNRESET")&&le.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if((0,P.$4)(le)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(le);continue}if(le instanceof S.$vl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,S.$vl.isHandled(le));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(le),this.C(this.protocol.getMillisSinceLastIncomingData(),ve+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,ve){this.w?L.triggerPermanentFailure(U,ie,ve):this.D(U,ie,ve)}D(U,ie,ve){this.m.fire(new F(this.reconnectionToken,U,ie,ve)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Jl=L;class G extends L{constructor(U,ie,ve,Ie,le){super(1,U,Ie,le,!0),this.client=this.B(new w.$6h(le,{remoteAuthority:ie,clientId:ve},U.ipcLogger))}async G(U,ie){await l(U,ie)}}e.$Kl=G;class te extends L{constructor(U,ie,ve,Ie,le){super(2,U,ve,Ie,!1),this.H=ie,this.debugPort=le}async G(U,ie){await r(U,this.H,ie)}}e.$Ll=te;function Z(re){try{re.acceptDisconnect();const U=re.getSocket();re.dispose(),U.dispose()}catch(U){(0,P.$1)(U)}}function x(re){if(re&&re.type==="error"){const U=new Error(`Connection error: ${re.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function _(re,U){for(;re.length<U;)re+=" ";return re}function ue(re,U){return`[remote-connection][${_(m(re),13)}][${U.substr(0,5)}\u2026]`}function X(re,U,ie){return`${ue(re,U)}[${ie?"reconnect":"initial"}]`}function $e(re,U){return`${X(U,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function se(re){return`${Date.now()-re} ms`}}),define(ke[86],Ee([1,0,15]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=N,e.$tm=M,e.$um=P,e.$vm=A;function N($){return $.scheme===u.Schemas.vscodeRemote?$.authority:void 0}function M($){if(!$)return;const E=$.indexOf("+");return E<0?$:$.substr(0,E)}function P($){const{host:E,port:R}=b($);if(typeof R>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:R}}function A($,E){let{host:R,port:I}=b($);return typeof I>"u"&&(I=E),{host:R,port:I}}function b($){const E=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const R=$.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const I=$.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:$,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=P,e.$Fm=I,e.$Gm=w,e.$Hm=S,e.$Im=k,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const n=typeof m=="string"?m:m.value,i=typeof a=="string"?a:a.value;return u.$lf(n,i)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Cm=$;class E{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const a of m)this.add(a)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$Dm=E;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,a){this.c.set($.toKey(m),a)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=R;function I(c){return w(c)}function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function k(c,m){if(m){const a=`onResolveRemoteAuthority:${(0,M.$tm)(m)}`;return!!c.activationEvents?.includes(a)}return!1}e.$Jm=(0,N.$hi)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(A,b){this.a.set(A,b)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const b=Object.create(null);for(const $ of A){const E=this.readActivationEvents($);E.length>0&&(b[N.$Cm.toKey($.identifier)]=E)}return b}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const b=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${N.$Cm.toKey(A.identifier)}`);if(!A.contributes)return b;for(const $ in A.contributes){const E=this.a.get($);if(!E)continue;const R=A.contributes[$],I=Array.isArray(R)?R:[R];try{E(I,b)}catch(w){(0,u.$1)(w)}}return b}}e.$JF=M,e.$KF=new M}),define(ke[266],Ee([1,0,3,5]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0,e.$xl=(0,N.$hi)("remoteSocketFactoryService");class M{constructor(){this.a={}}register(A,b){return this.a[A]??=[],this.a[A].push(b),(0,u.$Sc)(()=>{const $=this.a[A]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find($=>$.supports(A))}connect(A,b,$,E){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,b,$,E)}}e.$yl=M}),define(ke[267],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(M){try{const P=await this.c();if(P){const A=String(u.a++);return this.b.set(A,P),{id:A,data:P.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,P){if(!M.id)return!0;const A=this.b.get(M.id);if(!A)return!1;this.b.delete(M.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(M){try{return await this.d(M)}catch{}return M}}e.$x9b=u}),define(ke[110],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0,e.$zl="signService",e.$Al=(0,u.$hi)(e.$zl)}),define(ke[141],Ee([1,0,267]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;class N extends u.$x9b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(A=>new A.signer().sign(P))}h(){return new Promise((P,A)=>de(["vsda"],P,A))}}e.$rbc=N}),define(ke[268],Ee([1,0,11,50,30]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=A,e.$2o=b;function P($){if(u.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,E,R,I,w,S,k,c,m){const a=Object.create(null);a["common.machineId"]=S,a["common.sqmId"]=k,a.sessionID=(0,M.$Dg)()+Date.now(),a.commitHash=I,a.version=w,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,u.$h)(u.$u),a["common.nodePlatform"]=N.$ec,a["common.nodeArch"]=R,a["common.product"]=m||"desktop",c&&(a["common.msftInternal"]=c);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(a["common.snap"]="true");const s=P(E);return s&&(a["common.platformDetail"]=s),a}function b($){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const R=E.toLowerCase();return $.some(I=>R===I)}}),define(ke[269],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,u.$hi)("telemetryService"),e.$Nl=(0,u.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var N;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var M;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(ke[87],Ee([1,0,24,18,86,268,269]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=R,e.$$o=I,e.$_o=w,e.$ap=S,e.$bp=c,e.$cp=a,e.$dp=n,e.$ep=o;class b{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$3o=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=$,e.$5o=new $;class E{async publicLog(d,h,l){}async publicLogError(d,h,l){}}e.$6o=E,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}function I(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const d=t.getValue(A.$Ul),h=t.getValue(A.$Vl);if(t.getValue(A.$Wl)===!1||h===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(t){const d={},h={},l={};m(t,l);for(let r in l){r=r.length>150?r.substr(r.length-149):r;const g=l[r];typeof g=="number"?h[r]=g:typeof g=="boolean"?h[r]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${g.length}`),d[r]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(d[r]=g)}return{properties:d,measurements:h}}const k=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const d=(0,M.$tm)(t);return k.has(d)?d:"other"}function m(t,d,h=0,l){if(t)for(const r of Object.getOwnPropertyNames(t)){const g=t[r],f=l?l+r:r;Array.isArray(g)?d[f]=(0,u.$Sn)(g):g instanceof Date?d[f]=g.toISOString():(0,N.$Wf)(g)?h<2?m(g,d,h+1,f+"."):d[f]=(0,u.$Sn)(g):d[f]=g}}function a(t,d){const h=t.msftInternalDomains||[],l=d.getValue("telemetry.internalTesting");return(0,P.$2o)(h)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const l=[];for(const D of d)for(;;){const p=D.exec(t);if(!p)break;l.push([p.index,D.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(h="";;){const D=g.exec(t);if(!D)break;const p=l.some(([v,y])=>D.index<y&&v<g.lastIndex);!r.test(D[0])&&!p&&(h+=t.substring(f,D.index)+"<REDACTED: user-file-path>",f=g.lastIndex)}return f<t.length&&(h+=t.substr(f)),h}function s(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of d)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function o(t,d){return(0,u.$Pn)(t,h=>{if(h instanceof b||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let l=h.replaceAll("%20"," ");l=i(l,d);for(const r of d)l=l.replace(r,"");return l=s(l),l}})}}),define(ke[270],Ee([1,0,14,137,25,11,2,13,50,87]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=R,e.$hp=k,e.$ip=c,e.$jp=m,e.$kp=a,e.$lp=n,e.$mp=i,e.$np=s,e.$pp=o,e.$qp=d;function R(h,l){return h.uuid&&l.uuid?h.uuid===l.uuid:h.id===l.id?!0:(0,u.$gf)(h.id,l.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(l){const r=l.manifest?l.manifest.version:l.version,g=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new w(l.identifier,r,g)}static parse(l){const r=I.exec(l);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}constructor(l,r,g="undefined"){this.version=r,this.targetPlatform=g,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof w?R(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$gp=w;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(h){const l=S.exec(h);return l&&l[1]?[m(l[1]),l[2]]:[m(h),void 0]}function c(h,l){return`${h}.${l}`}function m(h){return h.toLowerCase()}function a(h,l){return m(c(h??M.$ym,l))}function n(h,l){const r=[],g=f=>{for(const D of r)if(D.some(p=>R(l(p),l(f))))return D;return null};for(const f of h){const D=g(f);D?D.push(f):r.push([f])}return r}function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function s(h){return{id:new E.$3o(h.identifier.id),name:new E.$3o(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$op=new M.$Cm("pprice.better-merge");function o(h,l){const r=[],g=l.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const f=g.shift();if(f&&r.every(D=>!R(D.identifier,{id:f}))){const D=h.filter(p=>R(p.identifier,{id:f}));D.length===1&&(r.push(D[0]),g.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function t(h,l){if(!P.$k)return!1;let r;try{r=(await h.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await h.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){l.debug("Error while getting the os-release file.",(0,b.$0)(f))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(h,l){const r=await t(h,l),g=(0,N.$Mo)(r?"alpine":P.$u,$.$fc);return l.debug("ComputeTargetPlatform:",g),g}}),define(ke[271],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=u,e.$6r=N,e.$7r=M,e.$8r=P,e.$9r=A,e.$0r=b;function u($){return[...$.entries()]}function N($){return $?[...$.entries()]:[]}function M($){return new Map($)}function P($){return new Map($??[])}function A($){return Array.from($.entries()).map(E=>[E[0],u(E[1].map),N(E[1].descriptionMap)])}function b($){return new Map($.map(E=>[E[0],{map:M(E[1]),descriptionMap:P(E[2])}]))}}),define(ke[272],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=void 0;class u{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,P,A=5){const b=P($=>{const E=typeof $=="string"?$:$.data;let R=this.a.get(M);if(R){R.data.push(E);return}const I=setTimeout(()=>this.flushBuffer(M),A);R={data:[E],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(M),b.dispose()}},this.a.set(M,R)});return b}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const P=this.a.get(M);P&&(this.a.delete(M),this.b(M,P.data.join("")))}}e.$_tb=u}),define(ke[273],Ee([1,0,8,77,99,56,4,18,2,214,109,37]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.$Vw=e.$Uw=e.IconFontDefinition=e.IconContribution=e.$Rw=void 0,e.$Sw=m,e.$Tw=a,e.$Rw={IconContribution:"base.contributions.icons"};var w;(function(o){function t(d,h){let l=d.defaults;for(;P.ThemeIcon.isThemeIcon(l);){const r=c.getIcon(l.id);if(!r)return;l=r.defaults}return l}o.getDefinition=t})(w||(e.IconContribution=w={}));var S;(function(o){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(l=>({format:l.format,location:l.location.toString()}))}}o.toJSONObject=t;function d(h){const l=r=>(0,b.$Uf)(r)?r:void 0;if(h&&Array.isArray(h.src)&&h.src.every(r=>(0,b.$Uf)(r.format)&&(0,b.$Uf)(r.location)))return{weight:l(h.weight),style:l(h.style),src:h.src.map(r=>({format:r.format,location:$.URI.parse(r.location)}))}}o.fromJSONObject=d})(S||(e.IconFontDefinition=S={}));class k{constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,d,h,l){const r=this.b[t];if(r){if(h&&!r.description){r.description=h,this.d.properties[t].markdownDescription=`${h} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=h),this.a.fire()}return r}const g={id:t,description:h,defaults:d,deprecationMessage:l};this.b[t]=g;const f={$ref:"#/definitions/icons"};return l&&(f.deprecationMessage=l),h&&(f.markdownDescription=`${h}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const d=this.e.enum.indexOf(t);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,d){const h=this.f[t];return h||(this.f[t]=d,this.a.fire(),d)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(r,g)=>r.id.localeCompare(g.id),d=r=>{for(;P.ThemeIcon.isThemeIcon(r.defaults);)r=this.b[r.defaults.id];return`codicon codicon-${r?r.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(r=>this.b[r]);for(const r of l.filter(g=>!!g.description).sort(t))h.push(`|<i class="${d(r)}"></i>|${r.id}|${P.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const r of l.filter(g=>!P.ThemeIcon.isThemeIcon(g.defaults)).sort(t))h.push(`|<i class="${d(r)}"></i>|${r.id}|`);return h.join(`
`)}}const c=new k;I.$Zn.add(e.$Rw.IconContribution,c);function m(o,t,d,h){return c.registerIcon(o,t,d,h)}function a(){return c}function n(){const o=(0,M.$Cj)();for(const t in o){const d="\\"+o[t].toString(16);c.registerIcon(t,{fontCharacter:d})}}n(),e.$Uw="vscode://schemas/icons";const i=I.$Zn.as(R.$1n.JSONContribution);i.registerSchema(e.$Uw,c.getIconSchema());const s=new u.$th(()=>i.notifySchemaChanged(e.$Uw),200);c.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$Vw=m("widget-close",N.$Gj.close,(0,E.localize)(2,null)),e.$Ww=m("goto-previous-location",N.$Gj.arrowUp,(0,E.localize)(3,null)),e.$Xw=m("goto-next-location",N.$Gj.arrowDown,(0,E.localize)(4,null)),e.$Yw=P.ThemeIcon.modify(N.$Gj.sync,"spin"),e.$Zw=P.ThemeIcon.modify(N.$Gj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,53,5,12]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$2v=e.$Zv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Vv=e.$Uv=void 0,e.$Wv=E,e.$Xv=I,e.$Yv=w,e.$1v=S,e.$3v=k,e.$4v=c,e.$Uv=(0,P.$hi)("tunnelService"),e.$Vv=(0,P.$hi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(n){return!!n.forwardPort}var R;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(R||(e.ProvidedOnAutoForward=R={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function w(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const s of i){const o=s.split("=")[1];if(/^https?:/.exec(o)){const t=I(N.URI.parse(o));if(t)return t}}}e.$Zv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(n){return e.$Zv.indexOf(n)>=0}e.$2v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(n){return e.$2v.indexOf(n)>=0}function c(n,i,s,o){if(s===1)return!1;if(s===2&&k(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,s,o){this.remoteAddress=i,this.localAddress=s,this.b=o,this.a=new u.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5v=m;let a=class{constructor(i,s){this.k=i,this.l=s,this.a=new u.$7d,this.onTunnelOpened=this.a.event,this.b=new u.$7d,this.onTunnelClosed=this.b.event,this.c=new u.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],s=Array.from(this.e.values());for(const o of s){const t=Array.from(o.values());for(const d of t){const h=await d.value;h&&typeof h!="string"&&i.push(h)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,o,t,d){this.q(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:o,privacy:t,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(k(i)||S(i))&&(i=e.$Zv[0]);const o=this.s(i,s);if(o)return++o.refcount,o.value}openTunnel(i,s,o,t,d,h=!1,l,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${o} on local port ${d}.`);const g=this.f??i;if(!g)return;if(s||(s="localhost"),t||(t=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(g,s,o,t,d,h,l,r);return f?f.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(s,o),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(s,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(D);return(D.tunnelRemoteHost!==s||D.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const o=s.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,s,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const t=o.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),t}}async closeTunnel(i,s){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const o=this.e.get(i);if(o&&o.has(s)){const t=o.get(s);t.refcount=0,await this.p(i,s,t)}}q(i,s,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:o})}async r(i,s){const o=this.e.get(i);if(o){const t=o.get(s),d=t?await t.value:void 0;(!d||typeof d=="string")&&o.delete(s),o.size===0&&this.e.delete(i)}}s(i,s){const o=[i];S(i)?(o.push(...e.$Zv),o.push(...e.$2v)):k(i)&&o.push(...e.$2v);const t=o.map(d=>this.e.get(d));for(const d of t){const h=d?.get(s);if(h)return h}}canTunnel(i){return!!I(i)}u(i,s,o,t,d,h,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${o} on local port ${t}.`);const r=o;this.j.add(r);const g=t===void 0?o:t,f={elevationRequired:d?this.isPortPrivileged(g):!1},D={remoteAddress:{host:s,port:o},localAddressPort:t,privacy:h,public:h?h!==$.Private:void 0,protocol:l},p=i.forwardPort(D,f);return p?(this.q(s,o,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),p}};e.$6v=a,e.$6v=a=Je([Ve(0,A.$Nj),Ve(1,M.$Ni)],a)}),define(ke[274],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=void 0,e.$ll=(0,u.$hi)("IUriIdentityService")}),define(ke[275],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$7v=void 0,e.$7v=(0,u.$hi)("editSessionIdentityService");var N;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[276],Ee([1,0,15]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=N,e.$QL=M,e.$RL=P,e.$SL=A,e.$TL=b;function N($){return $.scheme!==u.Schemas.file&&$.scheme!==u.Schemas.vscodeRemote}function M($){if($.folders.length)return $.folders.every(E=>N(E.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}function P($){return M($)?.scheme}function A($){return M($)?.authority}function b($){return M($)!==void 0}}),define(ke[40],Ee([1,0,216,17,76,23,2,5,15]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=E,e.$si=R,e.$vi=I,e.$wi=w,e.$xi=S,e.$yi=c,e.$zi=m,e.$Ci=i,e.$Hi=s,e.$Ii=o,e.$Ki=t,e.$Li=d,e.$Mi=h,e.$qi=(0,b.$hi)("contextService");function E(l){const r=l;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}function R(l){return typeof l?.id=="string"&&!E(l)&&!w(l)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function I(l,r){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,N.$oc)(l)}:r?e.$ti:e.$ui;const g=l;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}function w(l){const r=l;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}function S(l){const r=l;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const g=l;if(g?.configPath)return{id:g.id,configPath:A.URI.revive(g.configPath)};if(l?.id)return{id:l.id}}var k;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function c(l){const r=l;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function m(l){const r=l;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class a{constructor(r,g,f,D,p){this.h=r,this.j=f,this.k=D,this.l=p,this.c=M.$ni.forUris(this.l,()=>!0),this.folders=g}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=M.$ni.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=a;class n{constructor(r,g){this.raw=g,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,P.$Ug)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=n;function i(l){return new n({uri:l,index:0,name:(0,P.$Qg)(l)},{uri:l.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,u.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function s(l,r){return P.$Lg.isEqualOrParent(l,r.untitledWorkspacesHome)}function o(l){let r;return A.URI.isUri(l)?r=l:r=l.configuration,r?.scheme===$.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Ji}function d(l,r){return!s(l,r)&&!o(l)}function h(l){return(typeof l=="string"?(0,N.$pc)(l):(0,P.$Sg)(l))===e.$Ei}}),define(ke[277],Ee([1,0,55,4,3,23,2,215,136,32,5,12,40,28,274,8,30,14,18]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$nl=e.ProfileResourceType=void 0,e.$ml=s,e.$ol=o,e.$pl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function s(l){const r=l;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&A.URI.isUri(r.location)&&A.URI.isUri(r.globalStorageHome)&&A.URI.isUri(r.settingsResource)&&A.URI.isUri(r.keybindingsResource)&&A.URI.isUri(r.tasksResource)&&A.URI.isUri(r.snippetsHome)&&A.URI.isUri(r.extensionsResource))}e.$nl=(0,R.$hi)("IUserDataProfilesService");function o(l,r){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:r}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:r}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:r}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:r}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:r}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:r}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:r}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:r}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,r,g,f,D,p){return{id:l,name:r,location:g,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:p&&D?.useDefaultFlags?.globalState?p.globalStorageHome:(0,P.$Ug)(g,"globalStorage"),settingsResource:p&&D?.useDefaultFlags?.settings?p.settingsResource:(0,P.$Ug)(g,"settings.json"),keybindingsResource:p&&D?.useDefaultFlags?.keybindings?p.keybindingsResource:(0,P.$Ug)(g,"keybindings.json"),tasksResource:p&&D?.useDefaultFlags?.tasks?p.tasksResource:(0,P.$Ug)(g,"tasks.json"),snippetsHome:p&&D?.useDefaultFlags?.snippets?p.snippetsHome:(0,P.$Ug)(g,"snippets"),extensionsResource:p&&D?.useDefaultFlags?.extensions?p.extensionsResource:(0,P.$Ug)(g,"extensions.json"),cacheHome:(0,P.$Ug)(f,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let d=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,g,f,D){super(),this.t=r,this.u=g,this.w=f,this.y=D,this.f=!0,this.h=this.B(new N.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Bc,emptyWindows:new Map},this.profilesHome=(0,P.$Ug)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Ug)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),g=[r];if(this.f)try{for(const p of this.O()){if(!p.name||!(0,n.$Uf)(p.name)||!p.location){this.y.warn("Skipping the invalid stored profile",p.location||p.name);continue}g.push(t((0,P.$Rg)(p.location),p.name,p.location,this.g,{shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags},r))}}catch(p){this.y.error(p)}const f=new S.$Bc,D=new Map;if(g.length)try{const p=this.Q();if(p.workspaces)for(const[v,y]of Object.entries(p.workspaces)){const C=A.URI.parse(v),O=g.find(z=>z.id===y);O&&f.set(C,O)}if(p.emptyWindows)for(const[v,y]of Object.entries(p.emptyWindows)){const C=g.find(O=>O.id===y);C&&D.set(v,C)}}catch(p){this.y.error(p)}this.z={profiles:g,workspaces:f,emptyWindows:D}}return this.z}D(){const r=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const g="Temp",f=new RegExp(`${(0,a.$Ze)(g)}\\s(\\d+)`);let D=0;for(const v of this.profiles){const y=f.exec(v.name),C=y?parseInt(y[1]):0;D=C>D?C:D}const p=`${g} ${D+1}`;return this.createProfile((0,u.$8i)((0,m.$Dg)()).toString(16),p,{transient:!0},r)}async createNamedProfile(r,g,f){return this.createProfile((0,u.$8i)((0,m.$Dg)()).toString(16),r,g,f)}async createProfile(r,g,f,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=await this.F(r,g,f);return D&&await this.setProfileForWorkspace(D,p),p}async F(r,g,f){if(!(0,n.$Uf)(g)||!g)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(g);return D||(D=(async()=>{try{const p=this.profiles.find(C=>C.name===g||C.id===r);if(p)return p;const v=t(r,g,(0,P.$Ug)(this.profilesHome,r),this.g,f,this.defaultProfile);await this.u.createFolder(v.location);const y=[];return this.j.fire({profile:v,join(C){y.push(C)}}),await c.Promises.settled(y),this.I([v],[],[]),v}finally{this.r.delete(g)}})(),this.r.set(g,D)),D}async updateProfile(r,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(D=>D.id===r.id);if(!f)throw new Error(`Profile '${r.name}' does not exist`);return f=t(f.id,g.name??f.name,f.location,this.g,{shortName:g.shortName??f.shortName,icon:g.icon===null?void 0:g.icon??f.icon,transient:g.transient??f.isTransient,useDefaultFlags:g.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const g=this.profiles.find(D=>D.id===r.id);if(!g)throw new Error(`Profile '${r.name}' does not exist`);const f=[];this.m.fire({profile:g,join(D){f.push(D)}});try{await Promise.allSettled(f)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])g.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])g.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[g],[]);try{await this.u.del(g.cacheHome,{recursive:!0})}catch(D){(0,E.$5k)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(r,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(D=>D.id===g.id);if(!f)throw new Error(`Profile '${g.name}' does not exist`);this.L(r,f)}unsetWorkspace(r,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,g)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(g=>g.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,g.resource))).map(g=>this.u.del(g.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(g=>!this.H(g));await Promise.allSettled(r.map(g=>this.removeProfile(g)))}getProfileForWorkspace(r){const g=this.G(r);return A.URI.isUri(g)?this.s.workspaces.get(g)??this.C.workspaces.get(g):this.s.emptyWindows.get(g)??this.C.emptyWindows.get(g)}G(r){return(0,w.$ri)(r)?r.uri:(0,w.$wi)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,r.location))||[...this.s.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,r.location))||[...this.C.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,r.location))||[...this.C.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,r.location)))}I(r,g,f){const D=[...this.profiles,...r],p=[];this.s.profiles=[];for(let v of D)v.isDefault||g.some(y=>v.id===y.id)||(v=f.find(y=>v.id===y.id)??v,v.isTransient?this.s.profiles.push(v):p.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(p),this.z=void 0,this.J(r,g,f)}J(r,g,f){this.h.fire({added:r,removed:g,updated:f,all:this.profiles})}L(r,g,f){f=g?.isTransient?!0:f,f||this.L(r,void 0,!0);const D=this.G(r),p=f?this.s:this.C;A.URI.isUri(D)?(p.workspaces.delete(D),g&&p.workspaces.set(D,g)):(p.emptyWindows.delete(D),g&&p.emptyWindows.set(D,g)),f||this.M()}M(){const r={};for(const[f,D]of this.C.workspaces.entries())r[f.toString()]=D.id;const g={};for(const[f,D]of this.C.emptyWindows.entries())g[f.toString()]=D.id;this.R({workspaces:r,emptyWindows:g}),this.z=void 0}N(r){const g={},f=this.D();if(r.workspaces)for(const[p,v]of Object.entries(r.workspaces)){const y=A.URI.parse(v);g[p]=this.w.extUri.isEqual(y,f.location)?f.id:this.w.extUri.basename(y)}const D={};if(r.emptyWindows)for(const[p,v]of Object.entries(r.emptyWindows)){const y=A.URI.parse(v);D[p]=this.w.extUri.isEqual(y,f.location)?f.id:this.w.extUri.basename(y)}return{workspaces:g,emptyWindows:D}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$ql=d,e.$ql=d=Je([Ve(0,$.$oi),Ve(1,E.$Nk),Ve(2,k.$ll),Ve(3,I.$Nj)],d);class h extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$rl=h}),define(ke[278],Ee([1,0,8,4,3,58,18,194,5,277]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Np=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Lp=e.$Kp=e.$Jp=void 0,e.$Mp=S,e.$Op=c,e.$Qp=a,e.$Jp="__$__isNewStorageMarker",e.$Kp="__$__targetStorageMarker",e.$Lp=(0,$.$hi)("storageService");var R;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var w;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function S(n){const i=n.get(e.$Kp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class k extends M.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:k.a}){super(),this.m=i,this.b=this.B(new N.$0d),this.c=this.B(new N.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$th(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,s,o){return N.Event.filter(this.b.event,t=>t.scope===i&&(s===void 0||t.key===s),o)}n(){this.j.value=(0,u.$xh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,s){const{key:o,external:t}=s;if(o===e.$Kp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:o,target:this.J(i)[o],external:t})}w(i){this.f.fire({reason:i})}get(i,s,o){return this.P(s)?.get(i,o)}getBoolean(i,s,o){return this.P(s)?.getBoolean(i,o)}getNumber(i,s,o){return this.P(s)?.getNumber(i,o)}getObject(i,s,o){return this.P(s)?.getObject(i,o)}storeAll(i,s){this.y(()=>{for(const o of i)this.store(o.key,o.value,o.scope,o.target,s)})}store(i,s,o,t,d=!1){if((0,A.$4f)(s)){this.remove(i,o,d);return}this.y(()=>{this.z(i,o,t),this.P(o)?.set(i,s,d)})}remove(i,s,o=!1){this.y(()=>{this.z(i,s,void 0),this.P(s)?.delete(i,o)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,s){const o=[],t=this.J(i);for(const d of Object.keys(t))t[d]===s&&o.push(d);return o}z(i,s,o,t=!1){const d=this.J(s);typeof o=="number"?d[i]!==o&&(d[i]=o,this.P(s)?.set(e.$Kp,JSON.stringify(d),t)):typeof d[i]=="number"&&(delete d[i],this.P(s)?.set(e.$Kp,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const s=this.P(i);return s?S(s):Object.create(null)}isNew(i){return this.getBoolean(e.$Jp,i)===!0}async flush(i=R.NONE){this.f.fire({reason:i});const s=this.P(-1),o=this.P(0),t=this.P(1);switch(i){case R.NONE:await u.Promises.settled([s?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await u.Promises.settled([s?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,s=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(i,s,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,s){return this.w(R.NONE),(0,E.$ml)(i)?this.R(i,s):this.S(i,s)}M(i,s){return!(i.id===s.id||c(s)&&c(i))}N(i,s,o){this.y(()=>{const t=new Set;for(const[d,h]of i)t.add(d),s.get(d)!==h&&this.u(o,{key:d,external:!0});for(const[d]of s.items)t.has(d)||this.u(o,{key:d,external:!0})})}}e.$Np=k;function c(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends k{constructor(){super(),this.U=this.B(new b.$Hp(new b.$Ip,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Hp(new b.$Ip,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Hp(new b.$Ip,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Pp=m;async function a(n,i,s,o,t,d){const h=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,r=new Map;n.forEach((C,O)=>{l.set(O,C),r.set(O,h(C))});const g=new Map,f=new Map;i.forEach((C,O)=>{g.set(O,C),f.set(O,h(C))});const D=new Map,p=new Map;s.forEach((C,O)=>{D.set(O,C),p.set(O,h(C))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const v=[];if(l.forEach((C,O)=>{v.push({key:O,value:C})}),console.table(v),console.groupEnd(),console.log(r),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];g.forEach((O,z)=>{C.push({key:z,value:O})}),console.table(C),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${d})`);const y=[];D.forEach((C,O)=>{y.push({key:O,value:C})}),console.table(y),console.groupEnd(),console.log(p)}}),define(ke[111],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class u{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const P=this.c++;return this.b.set(P,M),this.e(),P}get(M,P){return this.b.has(M)?this.b.get(M)[P]:void 0}delete(M){this.b.delete(M),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Aic=u}),define(ke[59],Ee([1,0,15,23,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;class P{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new N.$Jg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Fic=P,e.$Gic=(0,M.$hi)("IExtHostFileSystemInfo")}),define(ke[27],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=void 0,e.$QO=(0,u.$hi)("IExtHostInitDataService")}),define(ke[279],Ee([1,0,222,12,259,27]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;let A=class extends M.$YP{constructor($,E,R){const I=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",w=R.remote.isRemote?(0,u.localize)(0,null):$?(0,u.localize)(1,null):(0,u.localize)(2,null);super(E.createLogger(I,{name:w}))}};e.$Mkc=A,e.$Mkc=A=Je([Ve(1,N.$Oj),Ve(2,P.$QO)],A)}),define(ke[280],Ee([1,0,8]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=void 0;class N{constructor(A,b,$){this.h=new Map,this.a=A,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new u.$th(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of E.values())R.complete()}catch(R){for(const I of E.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,b){let $=this.f[A];return typeof $>"u"&&($=b),$}update(A,b){this.f[A]=b;const $=this.h.get(A);if($!==void 0)return $.p;const E=new u.$Eh;return this.h.set(A,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$ojc=N;class M extends N{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,b){super(A.identifier.value,!0,b),this.j=A}}e.$pjc=M}),define(ke[281],Ee([1,0,4,2]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class M{constructor(A){this.c=A,this.a=new u.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,b,$,E){const I=this.c.getNotebookDocument(N.URI.revive(A)).acceptModelChanged(b.value,$,E);this.b.fire(I)}$acceptDirtyStateChanged(A,b){this.c.getNotebookDocument(N.URI.revive(A)).acceptDirty(b)}$acceptModelSaved(A){const b=this.c.getNotebookDocument(N.URI.revive(A));this.a.fire(b.apiNotebook)}}e.$ckc=M}),define(ke[20],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=void 0,e.$AO=(0,u.$hi)("IExtHostRpcService");class N{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$BO=N}),define(ke[282],Ee([1,0,25,4]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class M{#e;constructor(A,b){this.b=new N.$7d,this.onDidChange=this.b.event,this.a=u.$Cm.toKey(A.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,b){return this.#e.store(this.a,A,b)}delete(A){return this.#e.delete(this.a,A)}}e.$wjc=M}),define(ke[65],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Yic=void 0,e.$Yic=(0,u.$hi)("IURITransformerService");class N{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Zic=N}),define(ke[283],Ee([1,0,21]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enb=M,e.$Fnb=A;class N{constructor(){this.buffers=[]}add($){let E=this.buffers.indexOf($);return E<0&&(E=this.buffers.length,this.buffers.push($)),E}}function M(b,$){if($.serializeBuffersForPostMessage){const E=new N,I=JSON.stringify(b,(S,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(k)};if(ArrayBuffer.isView(k)){const c=P(k);if(c)return{$$vscode_array_buffer_reference$$:!0,index:E.add(k.buffer),view:{type:c,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),w=E.buffers.map(S=>{const k=new Uint8Array(S);return u.$ue.wrap(k)});return{message:I,buffers:w}}else return{message:JSON.stringify(b),buffers:[]}}function P(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(b,$){const E=$.map(w=>{const S=new ArrayBuffer(w.byteLength);return new Uint8Array(S).set(w.buffer),S}),R=$.length?(w,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const k=S,{index:c}=k,m=E[c];if(k.view)switch(k.view.type){case 1:return new Int8Array(m,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return S}:void 0;return{message:JSON.parse(b,R),arrayBuffers:E}}}),define(ke[284],Ee([1,0,285,397,398,62,2,12,399]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=R;const E=!1;function R(i,s,o,t,d,h){const l=h.environment.useHostProxy,r=typeof l=="boolean"?l:!h.remote.isRemote,g={resolveProxy:p=>i.resolveProxy(p),lookupProxyAuthorization:m.bind(void 0,t,d,s,{},h.remote.isRemote),getProxyURL:()=>s.getConfiguration("http").get("proxy"),getProxySupport:()=>s.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>w(s),addCertificatesV2:()=>S(s),log:t,getLogLevel:()=>{const p=t.getLevel();switch(p){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return v(p)}function v(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,loadAdditionalCertificates:async()=>{const p=[];if(h.remote.isRemote&&p.push((0,$.loadSystemCertificates)({log:t})),r){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const v=i.loadCertificates();v.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),p.push(v)}return(await Promise.all(p)).flat()},env:process.env},f=(0,$.createProxyResolver)(g),D=I(g,f);return c(o,D)}function I(i,s){return{http:Object.assign(u,(0,$.createHttpPatch)(i,u,s)),https:Object.assign(N,(0,$.createHttpPatch)(i,N,s)),net:Object.assign(P,(0,$.createNetPatch)(i,P)),tls:Object.assign(M,(0,$.createTlsPatch)(i,M))}}function w(i){const s=i.getConfiguration("http");return!s.get("experimental.systemCertificatesV2",E)&&!!s.get("systemCertificates")}function S(i){const s=i.getConfiguration("http");return!!s.get("experimental.systemCertificatesV2",E)&&!!s.get("systemCertificates")}const k=new Map;function c(i,s){return i.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,d=t._load;t._load=function(l,r,g){if(l==="net")return s.net;if(l==="tls")return s.tls;if(l!=="http"&&l!=="https")return d.apply(this,arguments);const f=o.findSubstr(A.URI.file(r.filename));let D=k.get(f);if(D||k.set(f,D={}),!D[l]){const p=s[l];D[l]={...p}}return D[l]}})}async function m(i,s,o,t,d,h,l,r){const g=t[h];l&&(t[h]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${g}`);const f=l||g,D=Array.isArray(f)?f:typeof f=="string"?[f]:[];if(n(s,D,d),D.some(p=>/^(Negotiate|Kerberos)( |$)/i.test(p))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const p=await new Promise((z,T)=>{de(["kerberos"],z,T)}),v=new URL(h),y=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${v.hostname}`:`HTTP@${v.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${y}`),"Negotiate "+await(await p.initializeClient(y)).step("")}catch(p){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",p)}}let a=!1;function n(i,s,o){a||!s.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:s.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(ke[286],Ee([1,0,133]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=M;function N(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function M(P){return new u.$jn(N(P))}}),define(ke[142],Ee([1,0,232,18,2,3,5,37,32,15,45,186,39]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$lF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$cF=e.EditorInputCapabilities=e.$bF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0,e.$6E=c,e.$7E=m,e.$8E=a,e.$9E=n,e.$0E=i,e.$$E=s,e.$_E=o,e.$aF=t,e.$dF=f,e.$eF=p,e.$fF=v,e.$gF=y,e.$hF=C,e.$iF=O,e.$jF=z,e.$kF=G,e.$mF=x,e.$nF=ue,e.$oF=X,e.$pF=$e,e.$1E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$2E={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$3E="workbench.editor.sidebysideEditor",e.$4E="workbench.editors.textDiffEditor",e.$5E="workbench.editors.binaryResourceDiffEditor";var S;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var k;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function c(se){const re=se;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}function m(se,re,U){for(const ie of U.visibleEditorPanes)if(ie.group.id===re&&se.matches(ie.input))return ie.getViewState()}function a(se){if(f(se))return!1;const re=se;return M.URI.isUri(re?.resource)}function n(se){if(f(se))return!1;const re=se;return re?.original!==void 0&&re.modified!==void 0}function i(se){if(f(se))return!1;const re=se;return!re||re.resources&&!Array.isArray(re.resources)?!1:!!re.resources||!!re.multiDiffSource}function s(se){if(f(se)||n(se))return!1;const re=se;return re?.primary!==void 0&&re.secondary!==void 0}function o(se){if(f(se))return!1;const re=se;return re?re.resource===void 0||re.resource.scheme===E.Schemas.untitled||re.forceUntitled===!0:!1}function t(se){if(f(se))return!1;const re=se;return M.URI.isUri(re?.base?.resource)&&M.URI.isUri(re?.input1?.resource)&&M.URI.isUri(re?.input2?.resource)&&M.URI.isUri(re?.result?.resource)}var d;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var h;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class l{constructor(){this.a=new Map}registerSource(re,U){let ie=this.a.get(re);return ie||(ie={source:re,label:U},this.a.set(re,ie)),ie.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.$bF=new l;var r;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(r||(e.EditorInputCapabilities=r={}));class g extends P.$Uc{}e.$cF=g;function f(se){return se instanceof g}function D(se){const re=se;return M.URI.isUri(re?.preferredResource)}function p(se){const re=se;return f(re?.primary)&&f(re?.secondary)}function v(se){const re=se;return f(re?.modified)&&f(re?.original)}function y(se,re,U,ie,ve){return $e(ie,[(0,I.$4i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const Ie={...U,limits:{size:Number.MAX_VALUE}};se.openEditor(re,Ie)}}),(0,I.$4i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}function C(se){return f(se?.editor)}function O(se){const re=se;return C(se)&&re?.group!==void 0}function z(se){const re=se;return typeof re?.groupId=="number"&&f(re.editor)}var T;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var B;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",se[se.EDITOR_STICKY=12]="EDITOR_STICKY",se[se.EDITOR_DIRTY=13]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var j;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class F{getOriginalUri(re,U){if(!re)return;if(t(re))return e.$lF.getOriginalUri(re.result,U);if(U?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(re);if(ve&&Ie){if(U?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(Ie,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===j.ANY)return this.getOriginalUri(ve,{filterByScheme:U.filterByScheme})??this.getOriginalUri(Ie,{filterByScheme:U.filterByScheme});re=U.supportSideBySide===j.PRIMARY?ve:Ie}}if(n(re)||i(re)||s(re)||t(re))return;const ie=D(re)?re.preferredResource:re.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}a(re){return p(re)||s(re)?{primary:re.primary,secondary:re.secondary}:v(re)||n(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,U){if(!re)return;if(t(re))return e.$lF.getCanonicalUri(re.result,U);if(U?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(re);if(ve&&Ie){if(U?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(Ie,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===j.ANY)return this.getCanonicalUri(ve,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(Ie,{filterByScheme:U.filterByScheme});re=U.supportSideBySide===j.PRIMARY?ve:Ie}}if(n(re)||i(re)||s(re)||t(re))return;const ie=re.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}b(re,U){if(Array.isArray(U)){if(U.some(ie=>re.scheme===ie))return re}else if(U===re.scheme)return re}}var L;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(L||(e.EditorCloseMethod=L={}));function G(se,re,U,ie){if(!se.isSticky(re))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return U===L.MOUSE||U===L.KEYBOARD;case"mouse":return U===L.MOUSE;case"keyboard":return U===L.KEYBOARD}return!1}e.$lF=new F;var te;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(re){const U=this.a=re.get(A.$gi);for(const[ie,ve]of this.c)this.e(ie,ve,U);this.c.clear()}e(re,U,ie){const ve=ie.createInstance(U);this.d.set(re,ve)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,N.$6f)(this.b)}registerEditorSerializer(re,U){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,U,this.a):this.c.set(re,U),(0,P.$Sc)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}b.$Zn.add(e.$1E.EditorFactory,new Z);async function x(se,re,U){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const ve=M.URI.revive(ie.fileUri);if(!ve){U.info("Cannot resolve the path because it is not valid.",ie);return}if(!await re.canHandleResource(ve)){U.info("Cannot resolve the path because it cannot be handled",ie);return}let le=ie.exists,ae=ie.type;if(typeof le!="boolean"||typeof ae!="number")try{ae=(await re.stat(ve)).isDirectory?$.FileType.Directory:$.FileType.Unknown,le=!0}catch(H){U.error(H),le=!1}if(!le&&ie.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ie);return}if(ae===$.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ie);return}const ce={...ie.options,pinned:!0};return le?{resource:ve,options:ce}:{resource:ve,options:ce,forceUntitled:!0}}))}var _;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(_||(e.EditorsOrder=_={}));function ue(se){const re=se;if(!re)return!1;const U=re;if(U.modified)return ue(U.modified);const ie=re;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}function X(se){return(0,R.$6i)(se)}function $e(se,re,U){const ie=(0,R.$7i)(se,re);return ie.forceMessage=U?.forceMessage,ie.forceSeverity=U?.forceSeverity,ie.allowDialog=U?.allowDialog,ie}}),define(ke[287],Ee([1,0,4,233,5,3,28,37,19,24,77,273]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$vF=e.ViewContentGroups=e.$tF=e.ViewContainerLocation=e.Extensions=e.$sF=e.$rF=e.$qF=void 0,e.$uF=k,e.$qF="views",e.$rF=(0,N.localize)(0,null),e.$sF=(0,I.$Sw)("default-view-icon",R.$Gj.window,(0,N.localize)(1,null));var w;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var S;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$tF=[0,1,2];function k(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class c extends P.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onDidRegister=this.c.event,this.f=this.B(new u.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(h,l,r){const g=this.get(h.id);if(g)return g;const f=h;return f.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,A.$yc)(this.g,l,[]).push(f),r?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:l}),f}deregisterViewContainer(h){for(const l of this.g.keys()){const r=this.g.get(l),g=r?.indexOf(h);if(g!==-1){r?.splice(g,1),r.length===0&&this.g.delete(l),this.f.fire({viewContainer:h,viewContainerLocation:l});return}}}get(h){return this.all.filter(l=>l.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(r=>r?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(l=>this.getViewContainerLocation(l)===h)}}b.$Zn.add(w.ViewContainersRegistry,new c);var m;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(m||(e.ViewContentGroups=m={}));function a(d,h){const l=d.group??m.More,r=h.group??m.More;return l!==r?l.localeCompare(r):(d.order??5)-(h.order??5)}class n extends P.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(h,l){this.registerViews2([{views:h,viewContainer:l}])}registerViews2(h){h.forEach(({views:l,viewContainer:r})=>this.r(l,r)),this.c.fire(h)}deregisterViews(h,l){const r=this.s(h,l);r.length&&this.f.fire({views:r,viewContainer:l})}moveViews(h,l){for(const r of this.m.keys())if(r!==l){const g=this.s(h,r);g.length&&(this.r(g,l),this.g.fire({views:g,from:r,to:l}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const l of this.j){const r=(this.m.get(l)||[]).filter(g=>g.id===h)[0];if(r)return r}return null}getViewContainer(h){for(const l of this.j)if((this.m.get(l)||[]).filter(g=>g.id===h)[0])return l;return null}registerViewWelcomeContent(h,l){return this.n.add(h,l),this.h.fire(h),(0,P.$Sc)(()=>{this.n.delete(h,l),this.h.fire(h)})}registerViewWelcomeContent2(h,l){const r=new Map;for(const[g,f]of l)this.n.add(h,f),r.set(g,(0,P.$Sc)(()=>{this.n.delete(h,f),this.h.fire(h)}));return this.h.fire(h),r}getViewWelcomeContent(h){const l=[];return this.n.forEach(h,r=>l.push(r)),l.sort(a)}r(h,l){let r=this.m.get(l);r||(r=[],this.m.set(l,r),this.j.push(l));for(const g of h){if(this.getView(g.id)!==null)throw new Error((0,N.localize)(2,null,g.id));r.push(g)}}s(h,l){const r=this.m.get(l);if(!r)return[];const g=[],f=[];for(const D of r)h.includes(D)?g.push(D):f.push(D);return g.length&&(f.length?this.m.set(l,f):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),g}}b.$Zn.add(w.ViewsRegistry,new n),e.$vF=(0,M.$hi)("viewDescriptorService");var i;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var s;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(s||(e.TreeItemCollapsibleState=s={}));class o{constructor(h,l){this.c=!1,this.d=!1,(0,E.$Qn)(this,h),this.d=!!l,this.resolve=async r=>{if(l&&!this.c){const g=await l(r);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}r.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$wF=o;class t extends Error{constructor(h){super((0,N.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$xF=t}),define(ke[288],Ee([1,0,2,29,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=e.$HF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$FF=P,e.$GF=A;function P(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof u.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$at.isIRange)}function A(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(P)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$HF=(0,M.$hi)("IChatService"),e.$IF="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,8,234]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nb=void 0;class P{constructor(){this.f=new Map,this.m=[],this.n=new u.$7d,this.o=new u.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,E,R){const I={command:b};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const k={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,M.localize)(0,null,R,b)};S(k)}},R)}return E&&this.f.set(I.seq,E),I.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,N.$ih)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,E=this.f.get($.request_seq);E&&(this.f.delete($.request_seq),E($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,E)=>b.set(E,$)),await(0,N.$ih)(500),b.forEach(($,E)=>{$({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$$nb=P}),define(ke[289],Ee([1,0,2,235,46,5]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$LI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$KI=e.MemoryRangeType=e.State=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=void 0,e.$JI=$,e.$yH="workbench.view.debug",e.$zH="workbench.debug.variablesView",e.$AH="workbench.debug.watchExpressionsView",e.$BH="workbench.debug.callStackView",e.$CH="workbench.debug.loadedScriptsView",e.$DH="workbench.debug.breakPointsView",e.$EH="workbench.debug.disassemblyView",e.$FH="workbench.panel.repl",e.$GH="workbench.panel.repl.view",e.$HH=new M.$yj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$IH=new M.$yj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$JH=new M.$yj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$KH="debugUx",e.$LH=new M.$yj(e.$KH,"default",{type:"string",description:N.localize(3,null)}),e.$MH=new M.$yj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$NH=new M.$yj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$OH=new M.$yj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$PH=new M.$yj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$QH=new M.$yj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$RH=new M.$yj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$SH=new M.$yj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$TH=new M.$yj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$UH=new M.$yj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$VH=new M.$yj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$WH=new M.$yj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$XH=new M.$yj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$YH=new M.$yj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$ZH=new M.$yj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$1H=new M.$yj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$2H=new M.$yj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$3H=new M.$yj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$4H=new M.$yj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$5H=new M.$yj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$6H=new M.$yj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$7H=new M.$yj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$8H=new M.$yj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$9H=new M.$yj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$0H=new M.$yj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$$H=new M.$yj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$_H=new M.$yj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$aI=new M.$yj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$bI=new M.$yj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$cI=new M.$yj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$dI=new M.$yj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$eI=new M.$yj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$fI=new M.$yj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$gI=new M.$yj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$hI=new M.$yj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$iI=new M.$yj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$jI=new M.$yj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$kI=new M.$yj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$lI=new M.$yj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$mI=new M.$yj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$nI=new M.$yj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$oI=new M.$yj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$pI=new M.$yj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$qI=new M.$yj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$rI=new M.$yj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$sI=new M.$yj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$tI=new M.$yj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$uI=new M.$yj("variableName",!1,{type:"string",description:N.localize(50,null)}),e.$vI=new M.$yj("variableLanguage",!1,{type:"string",description:N.localize(51,null)}),e.$wI=new M.$yj("variableExtensionId",!1,{type:"string",description:N.localize(52,null)}),e.$xI=new M.$yj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(53,null)}),e.$yI=new M.$yj("multiSessionRepl",!1,{type:"boolean",description:N.localize(54,null)}),e.$zI=new M.$yj("multiSessionDebug",!1,{type:"boolean",description:N.localize(55,null)}),e.$AI=new M.$yj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(56,null)}),e.$BI=new M.$yj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(57,null)}),e.$CI=new M.$yj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(58,null)}),e.$DI=new M.$yj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(59,null)});const A=n=>N.localize(60,null,n);e.$EI=A,e.$FI="editor.contrib.debug",e.$GI="editor.contrib.breakpoint",e.$HI="debug",e.$II={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(61,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$KI="vscode-debug-memory";var R;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(R||(e.DataBreakpointSetType=R={}));var I;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(I||(e.DebugConfigurationProviderTriggerKind=I={}));var w;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$LI=(0,P.$hi)("debugService");var S;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(S||(e.BreakpointWidgetContext=S={}));var k;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(k||(e.DebugVisualizationType=k={}));var c;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(c||(e.DebugTreeItemCollapsibleState=c={}));var m;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(m||(e.IDebugVisualizationTreeItem=m={}));var a;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:u.URI.revive(i.iconPath.light),dark:u.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(a||(e.IDebugVisualization=a={}))}),define(ke[290],Ee([1,0,14,2,17,24,15,29,22,19]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=void 0,e.$AG=I,e.$BG=w,e.$CG=S,e.$DG=k,e.$EG=c,e.$FG=m,e.$GG=a,e.$HG=i,e.$IG=t,e.$JG=d,e.$KG=l,e.$LG=g;const R=/{([^}]+)}/g;function I(D,p,v){return D.replace(R,function(y,C){return p&&C.length>0&&C[0]!=="_"?y:v&&v.hasOwnProperty(C)?v[C]:y})}function w(D){const p={};for(const v of Object.keys(D))v.startsWith("!")||(p[v]=D[v]);return p}function S(D){return D.configuration.request==="attach"&&!k(D)&&(!D.parentSession||S(D.parentSession))}function k(D){let p=D.configuration.type;if(p)return p==="vslsShare"&&(p=D.configuration.adapterProxy.configuration.type),(0,u.$lf)(p,"extensionhost")||(0,u.$lf)(p,"pwa-extensionhost")?D:D.parentSession?k(D.parentSession):void 0}function c(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,p,v){let y,C=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=O.exec(D);){const T=z.index+1,B=T+z[0].length;if(T<=p&&B>=v){y=z[0],C=T;break}}if(y){const T=/\w+/g;let B=null;for(;(B=T.exec(y))&&!(B.index+1+C+B[0].length>=v););B&&(y=y.substring(0,T.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function a(D,p,v,y){if(D.evaluatableExpressionProvider.has(p)){const C=D.evaluatableExpressionProvider.ordered(p),O=(0,E.$Hb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression(p,v,y??$.CancellationToken.None)}catch{return}})));if(O.length>0){let z=O[0].expression;const T=O[0].range;return z||(z=p.getLineContent(v.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:z}}}else{const C=p.getLineContent(v.lineNumber),{start:O,end:z}=m(C,v.column,v.column),T=C.substring(O-1,z);return{matchingExpression:T,range:new b.$at(v.lineNumber,O,v.lineNumber,O+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function s(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,M.$jc)(D.path))return N.URI.file(D.path)}return D.path}function o(D){if(typeof D.path=="object"){const p=N.URI.revive(D.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return D.path}function t(D,p){const v=p?s:o,y=(0,P.$Nn)(D);return h(y,(C,O)=>{C&&O&&(O.path=v(O))}),y}function d(D,p){const v=p?s:o,y=(0,P.$Nn)(D);return h(y,(C,O)=>{!C&&O&&(O.path=v(O))}),y}function h(D,p){switch(D.type){case"event":{const v=D;switch(v.event){case"output":p(!1,v.body.source);break;case"loadedSource":p(!1,v.body.source);break;case"breakpoint":p(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=D;switch(v.command){case"setBreakpoints":p(!0,v.arguments.source);break;case"breakpointLocations":p(!0,v.arguments.source);break;case"source":p(!0,v.arguments.source);break;case"gotoTargets":p(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(y=>p(!1,y));break;default:break}break}case"response":{const v=D;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(y=>p(!1,y.source));break;case"loadedSources":v.body.sources.forEach(y=>p(!1,y));break;case"scopes":v.body.scopes.forEach(y=>p(!1,y.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(y=>p(!1,y.source));break;case"setBreakpoints":v.body.breakpoints.forEach(y=>p(!1,y.source));break;case"disassemble":v.body?.instructions.forEach(C=>p(!1,C.location));break;default:break}break}}}function l(D){return D.filter(p=>!p.presentation?.hidden).sort((p,v)=>p.presentation?v.presentation?p.presentation.group?v.presentation.group?p.presentation.group!==v.presentation.group?p.presentation.group.localeCompare(v.presentation.group):r(p.presentation.order,v.presentation.order):-1:v.presentation.group?1:r(p.presentation.order,v.presentation.order):-1:v.presentation?1:0)}function r(D,p){return typeof D!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:D-p}async function g(D,p){const v=D.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(v!=="none"&&(await p.saveAll(),v==="allEditorsInActiveGroup")){const y=p.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const f=(D,p)=>!D||!p?D===p:D.name===p.name&&D.path===p.path&&D.sourceReference===p.sourceReference;e.$MG=f}),define(ke[291],Ee([1,0,52,62,24,17,11,14,31,236,143]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=e.$Ukc=e.$Tkc=e.$Skc=void 0;class I extends R.$$nb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const s=this.p.toString("utf8",0,n).split(I.b);for(const o of s){const t=o.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$Skc=I;class w extends I{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",s=>{i?this.n.fire(s):n(s)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Tkc=w;class S extends w{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$Ukc=S;class k extends w{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.path,a)}}e.$Vkc=k;class c extends I{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(P.$jc(a)){if(!await $.Promises.exists(a))throw new Error(E.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let s=process.env;if(i.env&&Object.keys(i.env).length>0&&(s=M.$Qn(M.$Nn(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:s,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const d=u.fork(n[0],n.slice(1),t);if(!d.pid)throw new Error(E.localize(2,null,n[0]));this.x=d}else throw new Error(E.localize(3,null));else{const o={env:s};i.cwd&&(o.cwd=i.cwd),this.x=u.spawn(a,n,o)}this.x.on("error",o=>{this.n.fire(o)}),this.x.on("exit",(o,t)=>{this.o.fire(o)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.n.fire(o)}),this.x.stdin.on("error",o=>{this.n.fire(o)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(s){this.n.fire(s)}}async stopSession(){return this.x?(await this.w(),A.$i?new Promise((a,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(s,o,t){if(s)return n(s)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=P.$kc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(P.$jc(a.program)?i.program=a.program:i.program=P.$kc(n,a.program)),a.args&&(i.args=a.args);const s=a;return s.win&&(i.win=c.A(s.win,n)),s.winx86&&(i.winx86=c.A(s.winx86,n)),s.windows&&(i.windows=c.A(s.windows,n)),s.osx&&(i.osx=c.A(s.osx,n)),s.linux&&(i.linux=c.A(s.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const l of a)if(l.contributes){const r=l.contributes.debuggers;r&&r.length>0&&r.filter(g=>typeof g.type=="string"&&b.$lf(g.type,n)).forEach(g=>{const f=c.A(g,l.extensionLocation.fsPath);i=M.$Qn(i,f,l.isBuiltin)})}let s;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?s=i.winx86||i.win||i.windows:A.$i?s=i.win||i.windows:A.$j?s=i.osx:A.$k&&(s=i.linux),s=s||i;const o=s.program||i.program,t=s.args||i.args,d=s.runtime||i.runtime,h=s.runtimeArgs||i.runtimeArgs;if(d)return{type:"executable",command:d,args:(h||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$Wkc=c}),define(ke[292],Ee([1,0,52,34,11]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=A,e.$Ykc=$;function P(E,R){return new Promise((I,w)=>{let S="";const k=u.spawn(E,R);k.pid&&k.stdout.on("data",c=>{S+=c.toString()}),k.on("error",c=>{w(c)}),k.on("close",c=>{I(S)})})}async function A(E){if(E)if(M.$i){const R=await new Promise((I,w)=>{de(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{R.getProcessTree(E,w=>{I(!!w&&w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(E)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function $(E,R,I,w){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:M.$i?S=0:S=2;let k,c=" ";switch(S){case 1:if(k=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),w){const m=(0,N.$mg)(w);m&&(c+=`${m}:; `),c+=`cd ${k(w)}; `}if(R.length>0){const m=R.shift(),a=I?m:k(m);c+=a[0]==="'"?`& ${a} `:`${a} `;for(const n of R)c+=n==="<"||n===">"||I?n:k(n),c+=" "}break;case 0:if(k=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>m.includes(a))||m.length===0?`"${m}"`:m),w){const m=(0,N.$mg)(w);m&&(c+=`${m}: && `),c+=`cd ${k(w)} && `}for(const m of R)c+=m==="<"||m===">"||I?m:k(m),c+=" ";break;case 2:{k=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),w&&(c+=`cd ${k(w)} ; `);for(const m of R)c+=m==="<"||m===">"||I?m:k(m),c+=" ";break}}return c}}),define(ke[293],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.CellExecutionUpdateType=void 0;var N;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$YJ=(0,u.$hi)("INotebookExecutionService")}),define(ke[294],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhb=e.$mhb=e.ProxyKernelState=e.$lhb=void 0,e.$lhb=100;var N;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$mhb=(0,u.$hi)("INotebookKernelService"),e.$nhb=(0,u.$hi)("INotebookKernelHistoryService")}),define(ke[295],Ee([1,0,3,29,199,100]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Tb=void 0;class A extends u.$Uc{constructor($,E,R){super(),this._source=$,this.b=E,this.c=R,this.a=void 0}f($){const E=$.getLineCount();return new N.$at(1,1,E,this.g($,E))}g($,E){if(E<1||E>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const $=new M.$xC;$.acceptChunk(this._source);const E=$.finish(!0),{textBuffer:R,disposable:I}=E.create(1);this.b=R,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const E=new M.$xC;E.acceptChunk($);const R=E.finish(!0),{textBuffer:I,disposable:w}=R.create(1);return this.B(w),I})),this.a}findInInputs($){const R=new P.$lC($,!1,!1,null).parseSearchRequest();if(!R)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,R,!0,5e3)}findInOutputs($){const R=new P.$lC($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(I=>{const w=I.findMatchesLineByLine(this.f(I),R,!0,5e3);if(w.length!==0)return{textBuffer:I,matches:w}}).filter(I=>!!I):[]}}e.$2Tb=A}),define(ke[66],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var N;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class M{static fromExtHostTestItem(A,b,$=A.parent){if(A._isRoot)return new M([b]);const E=[A.id];for(let R=$;R&&R.id!==b;R=R.parent)E.push(R.id);return E.push(b),new M(E.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const b=A.indexOf("\0");return b===-1?A:A.slice(0,b)}static fromString(A){return new M(A.split("\0"))}static join(A,b){return new M([...A.path,b])}static joinToString(A,b){return A.toString()+"\0"+b}static parentId(A){const b=A.lastIndexOf("\0");return b===-1?void 0:A.slice(0,b)}static localId(A){const b=A.lastIndexOf("\0");return b===-1?A:A.slice(b+1)}static isChild(A,b){return b.startsWith(A)&&b[A.length]==="\0"}static compare(A,b){return A===b?0:M.isChild(A,b)?2:M.isChild(b,A)?3:1}constructor(A,b=A.length){if(this.path=A,this.d=b,A.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new M(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new M(this.path,A)}compare(A){if(typeof A=="string")return M.compare(this.toString(),A);for(let b=0;b<A.d&&b<this.d;b++)if(A.path[b]!==this.path[b])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$5K=M}),define(ke[89],Ee([1,0,2,49,29,66]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$aL=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$_K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$K=e.$0K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$8K=e.$7K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$6K=e.TestResultState=void 0;var A;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$6K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(j){j[j.Run=2]="Run",j[j.Debug=4]="Debug",j[j.Coverage=8]="Coverage",j[j.HasNonDefaultProfile=16]="HasNonDefaultProfile",j[j.HasConfigurable=32]="HasConfigurable",j[j.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$7K=[2,4,8,16,32,64];const E=j=>"runId"in j;e.$8K=E;var R;(function(j){j.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),j.deserialize=(F,L)=>({range:M.$at.lift(L.range),uri:F.asCanonicalUri(u.URI.revive(L.uri))})})(R||(e.IRichLocation=R={}));var I;(function(j){j[j.Error=0]="Error",j[j.Output=1]="Output"})(I||(e.TestMessageType=I={}));var w;(function(j){j.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.serialize(F.location)}),j.deserialize=(F,L)=>({message:L.message,type:0,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&R.deserialize(F,L.location)})})(w||(e.ITestErrorMessage=w={}));const S=(j,F)=>`${F?"s":"e"}${j}`;e.$9K=S;var k;(function(j){j.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&R.serialize(F.location)}),j.deserialize=(F,L)=>({message:L.message,type:1,offset:L.offset,length:L.length,location:L.location&&R.deserialize(F,L.location)})})(k||(e.ITestOutputMessage=k={}));var c;(function(j){j.serialize=F=>F.type===0?w.serialize(F):k.serialize(F),j.deserialize=(F,L)=>L.type===0?w.deserialize(F,L):k.deserialize(F,L)})(c||(e.ITestMessage=c={}));var m;(function(j){j.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),j.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(c.serialize)}),j.deserialize=(F,L)=>({state:L.state,duration:L.duration,messages:L.messages.map(G=>c.deserialize(F,G))})})(m||(e.ITestTaskState=m={}));const a="\0",n=(j,F)=>j+a+F;e.$0K=n;const i=j=>{const F=j.indexOf(a);return{ctrlId:j.slice(0,F),tagId:j.slice(F+1)}};e.$$K=i;var s;(function(j){j.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),j.deserialize=(F,L)=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?F.asCanonicalUri(u.URI.revive(L.uri)):void 0,range:L.range?M.$at.lift(L.range):null,description:L.description,error:L.error,sortText:L.sortText})})(s||(e.ITestItem=s={}));var o;(function(j){j[j.NotExpandable=0]="NotExpandable",j[j.Expandable=1]="Expandable",j[j.BusyExpanding=2]="BusyExpanding",j[j.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(j){j.serialize=F=>({expand:F.expand,item:s.serialize(F.item)}),j.deserialize=(F,L)=>({controllerId:P.$5K.root(L.item.extId),expand:L.expand,item:s.deserialize(F,L.item)})})(t||(e.InternalTestItem=t={}));var d;(function(j){j.serialize=F=>{let L;return F.item&&(L={},F.item.label!==void 0&&(L.label=F.item.label),F.item.tags!==void 0&&(L.tags=F.item.tags),F.item.busy!==void 0&&(L.busy=F.item.busy),F.item.uri!==void 0&&(L.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(L.range=F.item.range?.toJSON()),F.item.description!==void 0&&(L.description=F.item.description),F.item.error!==void 0&&(L.error=F.item.error),F.item.sortText!==void 0&&(L.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:L}},j.deserialize=F=>{let L;return F.item&&(L={},F.item.label!==void 0&&(L.label=F.item.label),F.item.tags!==void 0&&(L.tags=F.item.tags),F.item.busy!==void 0&&(L.busy=F.item.busy),F.item.range!==void 0&&(L.range=F.item.range?M.$at.lift(F.item.range):null),F.item.description!==void 0&&(L.description=F.item.description),F.item.error!==void 0&&(L.error=F.item.error),F.item.sortText!==void 0&&(L.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:L}}})(d||(e.ITestItemUpdate=d={}));const h=(j,F)=>{F.expand!==void 0&&(j.expand=F.expand),F.item!==void 0&&(j.item=j.item?Object.assign(j.item,F.item):F.item)};e.$_K=h;var l;(function(j){j.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(m.serializeWithoutMessages)}),j.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(m.serialize)}),j.deserialize=(F,L)=>({...t.deserialize(F,L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(G=>m.deserialize(F,G)),retired:!0})})(l||(e.TestResultItem=l={}));var r;(function(j){j.empty=()=>({covered:0,total:0}),j.sum=(F,L)=>{F.covered+=L.covered,F.total+=L.total}})(r||(e.ICoveredCount=r={}));var g;(function(j){j.serialize=F=>({statement:F.statement,branch:F.branch,declaration:F.declaration,details:F.details?.map(v.serialize),uri:F.uri.toJSON()}),j.deserialize=(F,L)=>({statement:L.statement,branch:L.branch,declaration:L.declaration,details:L.details?.map(v.deserialize),uri:F.asCanonicalUri(u.URI.revive(L.uri))})})(g||(e.IFileCoverage=g={}));function f(j){return{...j,location:j.location?.toJSON()}}function D(j){return j.location=j.location?N.$_s.isIPosition(j.location)?N.$_s.lift(j.location):M.$at.lift(j.location):void 0,j}e.$aL=3;var p;(function(j){j[j.Declaration=0]="Declaration",j[j.Statement=1]="Statement",j[j.Branch=2]="Branch"})(p||(e.DetailType=p={}));var v;(function(j){j.serialize=F=>F.type===0?C.serialize(F):O.serialize(F),j.deserialize=F=>F.type===0?C.deserialize(F):O.deserialize(F)})(v||(e.CoverageDetails=v={}));var y;(function(j){j.serialize=f,j.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(j){j.serialize=f,j.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var O;(function(j){j.serialize=F=>({...f(F),branches:F.branches?.map(y.serialize)}),j.deserialize=F=>({...D(F),branches:F.branches?.map(y.deserialize)})})(O||(e.IStatementCoverage=O={}));var z;(function(j){j[j.Add=0]="Add",j[j.Update=1]="Update",j[j.DocumentSynced=2]="DocumentSynced",j[j.Remove=3]="Remove",j[j.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",j[j.Retire=5]="Retire",j[j.AddTag=6]="AddTag",j[j.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var T;(function(j){j.deserialize=(F,L)=>L.op===0?{op:L.op,item:t.deserialize(F,L.item)}:L.op===1?{op:L.op,item:d.deserialize(L.item)}:L.op===2?{op:L.op,uri:F.asCanonicalUri(u.URI.revive(L.uri)),docv:L.docv}:L,j.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:d.serialize(F.item)}:F})(T||(e.TestsDiffOp=T={}));class B{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const L=this.v();for(const G of F)switch(G.op){case 0:this.l(t.deserialize(this.k,G.item),L);break;case 1:this.o(d.deserialize(G.item),L);break;case 3:this.p(G.itemId,L);break;case 5:this.q(G.itemId);break;case 4:this.updatePendingRoots(G.amount);break;case 6:this.c.set(G.tag.id,G.tag);break;case 7:this.c.delete(G.id);break}L.complete?.()}l(F,L){const G=P.$5K.parentId(F.item.extId)?.toString();let te;if(!G)te=this.w(F),this.g.add(te),this.f.set(F.item.extId,te);else if(this.f.has(G)){const Z=this.f.get(G);Z.children.add(F.item.extId),te=this.w(F,Z),this.f.set(F.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return L.add?.(te),F.expand===2&&this.h++,te}o(F,L){const G=this.f.get(F.extId);if(G)return F.expand!==void 0&&(G.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$_K)(G,F),L.update?.(G),G}p(F,L){const G=this.f.get(F);if(!G)return;const te=P.$5K.parentId(G.item.extId)?.toString();te?this.f.get(te).children.delete(G.item.extId):this.g.delete(G);const Z=[[F]];for(;Z.length;)for(const x of Z.pop()){const _=this.f.get(x);_&&(Z.push(_.children),this.f.delete(x),L.remove?.(_,_!==G),_.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$bL=B}),define(ke[112],Ee([1,0,8,4,3,61,89,66]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const E=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(s=>!i.includes(s)))}),w=(n,i)=>{let s;for(const[o,t]of I)t(n[o],i[o])||(s?s[o]=i[o]:s={[o]:i[o]});return s};class S extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$th(()=>this.flushDiff(),200)),this.g=this.B(new N.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const s of this.m)if(s.op===2&&s.uri===i.uri){s.docv=i.docv;return}break}case 1:{const s=this.m[this.m.length-1];if(s){if(s.op===1&&s.item.extId===i.item.extId){(0,A.$_K)(s.item,i.item);return}if(s.op===0&&s.item.item.extId===i.item.extId){(0,A.$_K)(s.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,s){const o=this.tree.get(i);if(o){if((o.expandLevels===void 0||s>o.expandLevels)&&(o.expandLevels=s),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,s-1):t.wait().then(()=>this.L(o,s-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,s-1)):this.L(o,s-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,s){switch(s.op){case 3:this.O(b.$5K.joinToString(i.fullId,s.id));break;case 0:this.z(s.item,i);break;case 5:for(const o of s.ops)this.w(i,o);break;case 1:this.C(s.new,s.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:s.update}});break;case 6:this.y(i.actual.uri);break;default:(0,P.$0c)(s)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,s){const o=b.$5K.fromExtHostTestItem(i,this.root.id,s?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(i.id);let d=this.tree.get(o.toString());if(!d){d={fullId:o,actual:i,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(i,s),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(i)}}),this.I(i,d,s);return}if(d.actual===i){this.H(i,d,s);return}if(d.actual.uri?.toString()!==i.uri?.toString())return this.O(o.toString()),this.z(i,s);const h=this.s.getChildren(d.actual),l=d.actual,r=w(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,d.actual=i,d.expand=0,r&&(r.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,o.toString()),delete r.tags),this.w(d,{op:4,update:r})),this.I(i,d,s);for(const[g,f]of h)this.s.getChildren(i).get(f.id)||this.O(b.$5K.joinToString(o,f.id));this.y(d.actual.uri)}C(i,s,o){const t=new Set(s.map(d=>d.id));for(const d of i)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:o,item:{tags:i.map(d=>(0,A.$0K)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(i){const s=this.j.get(i.id);s?s.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$0K)(this.s.controllerId,i.id)}}))}F(i){const s=this.j.get(i);s&&!--s.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$0K)(this.s.controllerId,i)}))}G(i,s){this.s.getApiFor(i).parent=s&&s.actual!==this.root?s.actual:void 0}H(i,s,o){this.G(i,o);const t=this.s.getApiFor(i);t.parent=o?.actual,t.listener=d=>this.w(s,d),this.J(s)}I(i,s,o){this.H(i,s,o);for(const[t,d]of this.s.getChildren(i))this.z(d,s)}J(i){let s;this.h?i.resolveBarrier?s=i.resolveBarrier.isOpen()?3:2:s=i.actual.canResolveChildren?1:0:s=0,s!==i.expand&&(i.expand=s,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:s}}),s===1&&i.expandLevels!==void 0&&this.M(i))}L(i,s){if(s<0)return;const o=[];for(const[t,d]of this.s.getChildren(i.actual)){const h=this.expand(b.$5K.joinToString(i.fullId,d.id),s);(0,u.$6g)(h)&&o.push(h)}if(o.length)return Promise.all(o).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const d=new u.$gh;return d.open(),d}i.expand=2,this.N(i);const s=i.resolveBarrier=new u.$gh,o=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(d){o(d)}return(0,u.$6g)(t)?t.catch(o).then(()=>{s.open(),this.J(i)}):(s.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const s=this.tree.get(i);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const o=[s];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,h]of this.s.getChildren(t.actual))o.push(this.tree.get(b.$5K.joinToString(t.fullId,h.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$qO=S;class k extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$rO=k;class c extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sO=c;class m extends Error{constructor(i,s,o){super(`TestItem with ID "${i}" is from controller "${s}" and cannot be added as a child of an item from controller "${o}".`)}}e.$tO=m;const a=(n,i,s)=>{let o=new Map;return{get size(){return o.size},forEach(t,d){for(const h of o.values())t.call(d,h,this)},[Symbol.iterator](){return o.entries()},replace(t){const d=new Map,h=new Set(o.keys()),l={op:5,ops:[]};for(const r of t){if(!(r instanceof s))throw new c(r.id);const g=i(r).controllerId;if(g!==n.controllerId)throw new m(r.id,g,n.controllerId);if(d.has(r.id))throw new k(r.id);d.set(r.id,r),h.delete(r.id),l.ops.push({op:0,item:r})}for(const r of h.keys())l.ops.push({op:3,id:r});n.listener?.(l),o=d},add(t){if(!(t instanceof s))throw new c(t.id);o.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){o.delete(t)&&n.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$uO=a}),define(ke[144],Ee([1,0,112]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.$vO=void 0;const N=new WeakMap,M=(A,b)=>{const $={controllerId:b};return N.set(A,$),$};e.$vO=M;const P=A=>{const b=N.get(A);if(!b)throw new u.$sO(A?.id||"<unknown>");return b};e.$wO=P}),define(ke[113],Ee([1,0,15,2]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fyb=e.$Eyb=e.$Dyb=void 0,e.$Gyb=M,e.$Hyb=A,e.$Dyb="vscode-cdn.net",e.$Eyb=`vscode-resource.${e.$Dyb}`,e.$Fyb=`'self' https://*.${e.$Dyb}`;function M(b,$){return b.scheme===u.Schemas.http||b.scheme===u.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===u.Schemas.file&&(b=N.URI.from({scheme:u.Schemas.vscodeRemote,authority:$.authority,path:b.path})),N.URI.from({scheme:u.Schemas.https,authority:`${b.scheme}+${P(b.authority)}.${e.$Eyb}`,path:b.path,fragment:b.fragment,query:b.query}))}function P(b){return b.replace(/./g,$=>{const E=$.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?$:"-"+E.toString(16).padStart(4,"0")})}function A(b){return b.replace(/-([0-9a-f]{4})/g,($,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[296],Ee([1,0,4,3,113]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class P{constructor(b,$,E){this.d=b,this.e=$,this.f=E,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,E,R,I){let w;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){w=i;break}if(!w)throw new Error("not a visible editor");const S=this,k=this.a++,c=new u.$7d,m=new u.$7d,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$Gyb)(i,S.f)}get cspSource(){return M.$Fyb}set options(i){this.b=i,S.d.$setOptions(k,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(k,i)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(i){return S.d.$postMessage(k,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=E,this.webview=a,this.onDidDispose=m.event}dispose(){S.c.has(k)&&(S.c.delete(k),S.d.$disposeEditorInset(k),m.fire(),m.dispose(),c.dispose())}};return this.d.$createEditorInset(k,w.id,w.value.document.uri,$+1,E,R||{},I.identifier,I.extensionLocation),this.c.set(k,{editor:b,inset:n,onDidReceiveMessage:c}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Wic=P}),define(ke[145],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=void 0,e.$iL="__",e.$jL=(0,u.$hi)("IAuthenticationService"),e.$kL=(0,u.$hi)("IAuthenticationExtensionsService")}),define(ke[297],Ee([1,0,5]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.VariableKind=e.$mP=void 0,e.$mP=(0,u.$hi)("configurationResolverService");var N;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class M extends Error{constructor(A,b){super(b),this.variable=A}}e.$nP=M}),define(ke[298],Ee([1,0,17,50,18,24,11,103,239,297,14]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,k,c,m){this.h=new Map,this.a=S,this.b=k,this.g=c,m&&(this.c=m.then(a=>this.i(a)))}i(S){if(A.$i){const k=Object.create(null);return Object.keys(S).forEach(c=>{k[c.toLowerCase()]=S[c]}),k}return S}resolveWithEnvironment(S,k,c){return this.l({env:this.i(S),userHome:void 0},k?k.uri:void 0,c)}async resolveAsync(S,k){const c={env:await this.c,userHome:await this.g};return this.l(c,S?S.uri:void 0,k)}async j(S,k,c,m){const a=P.$Nn(k);A.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):A.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):A.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,a,c,m)}async resolveAnyAsync(S,k,c){return this.j(S,k,c)}async resolveAnyMap(S,k,c){const m=new Map;return{newConfig:await this.j(S,k,c,m),resolvedVariables:m}}resolveWithInteractionReplace(S,k,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,k,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,k){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,k)}async l(S,k,c,m,a){if(M.$Uf(c))return this.m(S,k,c,m,a);if(Array.isArray(c))return Promise.all(c.map(n=>this.l(S,k,n,m,a)));if(M.$Wf(c)){const n=Object.create(null),i=await Promise.all(Object.keys(c).map(async s=>[await this.m(S,k,s,m,a),await this.l(S,k,c[s],m,a)]));for(const[s,o]of i)n[s]=o;return n}return c}m(S,k,c,m,a){return(0,R.$df)(c,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let s=await this.o(S,n,i,k,m);return a?.set(i,s),s!==n&&M.$Uf(s)&&s.match(I.VARIABLE_REGEXP)&&(s=await this.m(S,k,s,m,a)),s})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,k,c,m,a){let n;const i=c.split(":");i.length>1&&(c=i[0],n=i[1]);const s=d=>{const h=this.a.getFilePath();if(h)return(0,b.$fw)(h);throw new E.$nP(d,(0,$.localize)(0,null,k))},o=d=>{const h=s(d);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$fw)(l)}throw new E.$nP(d,(0,$.localize)(1,null,k,u.$oc(h)))},t=d=>{if(n){const h=this.a.getFolderUri(n);if(h)return h;throw new E.$nP(d,(0,$.localize)(2,null,k,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new E.$nP(d,(0,$.localize)(3,null,k)):new E.$nP(d,(0,$.localize)(4,null,k))};switch(c){case"env":if(n){if(S.env){const d=S.env[A.$i?n.toLowerCase():n];if(M.$Uf(d))return d}return""}throw new E.$nP(E.VariableKind.Env,(0,$.localize)(5,null,k));case"config":if(n){const d=this.a.getConfigurationValue(m,n);if(M.$4f(d))throw new E.$nP(E.VariableKind.Config,(0,$.localize)(6,null,k,n));if(M.$Wf(d))throw new E.$nP(E.VariableKind.Config,(0,$.localize)(7,null,k,n));return d}throw new E.$nP(E.VariableKind.Config,(0,$.localize)(8,null,k));case"command":return this.p(E.VariableKind.Command,k,n,a,"command");case"input":return this.p(E.VariableKind.Input,k,n,a,"input");case"extensionInstallFolder":if(n){const d=await this.a.getExtension(n);if(!d)throw new E.$nP(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,k,n));return this.n(d.extensionLocation)}throw new E.$nP(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,k));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,b.$fw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,b.$fw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$fw)(u.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$nP(E.VariableKind.UserHome,(0,$.localize)(11,null,k))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new E.$nP(E.VariableKind.LineNumber,(0,$.localize)(12,null,k))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new E.$nP(E.VariableKind.SelectedText,(0,$.localize)(13,null,k))}case"file":return s(E.VariableKind.File);case"fileWorkspaceFolder":return o(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(o(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(E.VariableKind.RelativeFile)),s(E.VariableKind.RelativeFile)):s(E.VariableKind.RelativeFile);case"relativeFileDirname":{const d=u.$nc(s(E.VariableKind.RelativeFileDirname));if(m||n){const h=u.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),d);return h.length===0?".":h}return d}case"fileDirname":return u.$nc(s(E.VariableKind.FileDirname));case"fileExtname":return u.$pc(s(E.VariableKind.FileExtname));case"fileBasename":return u.$oc(s(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=u.$oc(s(E.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-u.$pc(d).length)}case"fileDirnameBasename":return u.$oc(u.$nc(s(E.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||k}case"execInstallFolder":{const d=this.a.getAppRoot();return d||k}case"pathSeparator":case"/":return u.sep;default:try{const d=n?`${c}:${n}`:c;return this.p(E.VariableKind.Unknown,k,d,a,void 0)}catch{return k}}}}p(S,k,c,m,a){if(c&&m){const n=a===void 0?m[c]:m[a+":"+c];if(typeof n=="string")return n;throw new E.$nP(S,(0,$.localize)(14,null,k))}return k}}e.$CP=I}),define(ke[146],Ee([1,0,5,142]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$tD=void 0,e.$uD=E,e.$vD=w,e.$wD=S,e.$tD=(0,u.$hi)("editorGroupsService");var M;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var P;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var b;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function E(k){const c=k;return(0,N.$dF)(c?.editor)&&(0,N.$dF)(c?.replacement)}var R;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(k){const c=k;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function S(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[299],Ee([1,0,5,146]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=e.$zD=e.$yD=e.$xD=void 0,e.$BD=M,e.$xD=(0,u.$hi)("editorService"),e.$yD=-1,e.$zD=-2,e.$AD=-3;function M(P){const A=P;return typeof P=="number"||(0,N.$vD)(A)}}),define(ke[147],Ee([1,0,5,136]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=void 0,e.$DL=(0,u.$ii)(N.$oi)}),define(ke[148],Ee([1,0,25,4,17,3,8]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=e.$z0b=e.$y0b=e.$x0b=e.$w0b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$w0b=b;class ${static isHostExtension(n,i,s){if(i.getExtensionDescription(n))return!1;const o=s.getExtensionDescription(n);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(c),this.f=new u.$Em,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const s of i)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const s=$.l(this.e);return this.e=m(this.e,s.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,s)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,l){this.addNode(h),this.addNode(l),this.c.has(h)?this.c.get(h).push(l):this.c.set(h,[l])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,l){const r=i.getArcs(h);for(let g=0;g<r.length;g++)if(!l.has(r[g]))return!1;return!0}getNodes(){return this.e}},s=new u.$Em;for(const h of n)if(s.set(h.identifier,h),h.extensionDependencies)for(const l of h.extensionDependencies)i.addArc(u.$Cm.toKey(h.identifier),u.$Cm.toKey(l));const o=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>o.add(h));const t=i.getNodes().filter(h=>!o.has(h));let d;do{d=!1;for(let h=0;h<t.length;h++){const l=t[h];i.hasOnlyGoodArcs(l,o)&&(t.splice(h,1),h--,o.add(l),d=!0)}}while(d);return t.map(h=>s.get(h))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$x0b=$;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$y0b=E;class R{constructor(n){this.d=new S,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,s){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$z0b=R;class I extends P.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$A0b=I;class w{constructor(n){this.name=n;const i=(0,A.$ah)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class S{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new w(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};n.resolve((0,P.$Sc)(o))}}var k;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(k||(k={}));function c(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,s=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==s)return i-s;const o=M.$hc.basename(a.extensionLocation.path),t=M.$hc.basename(n.extensionLocation.path);return o<t?-1:o>t?1:0}function m(a,n){const i=new u.$Dm(n);return a.filter(s=>!i.has(s.identifier))}}),define(ke[300],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.ExtHostConnectionType=void 0,e.$$m=b,e.$_m=$;var u;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[N.ENV_KEY]=this.pipeName}}e.$8m=N;class M{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[M.ENV_KEY]="1"}}e.$9m=M;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[P.ENV_KEY]="1"}}e.$0m=P;function A(R){delete R[N.ENV_KEY],delete R[M.ENV_KEY],delete R[P.ENV_KEY]}function b(R,I){A(I),R.serialize(I)}function $(R){if(R[N.ENV_KEY])return E(R,new N(R[N.ENV_KEY]));if(R[M.ENV_KEY])return E(R,new M);if(R[P.ENV_KEY])return E(R,new P);throw new Error("No connection information defined in environment!")}function E(R,I){return A(R),I}}),define(ke[114],Ee([1,0,21]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Km=A,e.$Lm=b;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var M;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var P;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(E){const R=u.$ue.alloc(1);switch(E){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}function b(E,R){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}var $;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Ee([1,0,5,4,12,27,114,86,87,24,2,3,225]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$SO=e.$RO=void 0,e.$TO=c;let S=class extends I.$Uc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new N.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$8o,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Pj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const s=this.getTelemetryDetails(),o=new k(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$tm)((0,$.$bp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,s)=>{const o=i.filter(t=>!t.isDisposed);o.length===0?this.r.delete(s):this.r.set(s,o)}),this.r.forEach(i=>{for(const s of i)s.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const s=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!s)return this.r.delete(a.value),!1;let o=!1;for(const t of s)t.ignoreUnhandledExtHostErrors||(t.logError(n),o=!0);return o}};e.$RO=S,e.$RO=S=Je([Ve(0,P.$QO),Ve(1,M.$Oj)],S);class k{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,s,o,t,d){this.g=i,this.h=s,this.i=o,this.j=t,this.a=new N.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,$.$ep)(n,[]),this.c&&(n=(0,E.$Qn)(n,this.c)),this.b||(n=(0,E.$Qn)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},s=(0,$.$ep)(i,[]),o=new Error(s.message,{cause:s.cause});o.stack=s.stack,o.name=s.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(o,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$SO=k;function c(m){const a=Date.now()-new Date(m).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$UO=(0,u.$hi)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,270,140,25,5]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=e.ActivationKind=e.$8F=e.$7F=e.$4F=e.ExtensionHostStartup=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$5F=w,e.$6F=S,e.$9F=a,e.$0F=n,e.$ZF=Object.freeze({identifier:new A.$Cm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$1F="extensions.webWorker",e.$2F=(0,b.$hi)("extensionService");class ${constructor(o){this.dependency=o}}e.$3F=$;var E;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,d){this.c=o,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$KF.createActivationEventsMap(this.d)}}set(o,t,d){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const h=[],l=[],r=[],g=[],f=I(this.d),D=I(t),p=(z,T)=>z.extensionLocation.toString()===T.extensionLocation.toString()||z.isBuiltin===T.isBuiltin||z.isUserBuiltin===T.isUserBuiltin||z.isUnderDevelopment===T.isUnderDevelopment;for(const z of this.d){const T=D.get(z.identifier);if(!T){h.push(z.identifier),f.delete(z.identifier);continue}if(!p(z,T)){h.push(z.identifier),f.delete(z.identifier);continue}}for(const z of t){const T=f.get(z.identifier);if(!T){l.push(z);continue}if(!p(T,z)){h.push(T.identifier),f.delete(T.identifier);continue}}const v=new A.$Dm(this.e),y=new A.$Dm(d);for(const z of this.e)y.has(z)||r.push(z);for(const z of d)v.has(z)||g.push(z);const C=P.$KF.createActivationEventsMap(l),O={versionId:o,toRemove:h,toAdd:l,addActivationEvents:C,myToRemove:r,myToAdd:g};return this.delta(O),O}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:h,myToAdd:l}=o,r=new A.$Dm(t),g=new A.$Dm(h);for(let f=0;f<this.d.length;f++)r.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)g.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of d)this.d.push(f);for(const f of l)this.e.push(f);return this.f=null,o}containsExtension(o){for(const t of this.e)if(A.$Cm.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=P.$KF.readActivationEvents(t);for(const h of d)o.add(h)}return o}}e.$4F=R;function I(s){const o=new A.$Em;for(const t of s)o.set(t.identifier,t);return o}function w(s,o){return s.enabledApiProposals?s.enabledApiProposals.includes(o):!1}function S(s,o){if(!w(s,o))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class k{constructor(o,t,d,h){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=h}}e.$7F=k;class c{constructor(o,t){this.description=o,this.value=t}}e.$8F=c;var m;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function a(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,M.$kp)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function n(s,o){return{identifier:new A.$Cm((0,M.$ip)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!o,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$$F=i}),define(ke[301],Ee([1,0,13,148,25,26,12,8]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=e.$kjc=e.$jjc=e.$ijc=e.$hjc=e.$gjc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,n,i,s){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=s}}e.$gjc=$;class E{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$hjc=E;class R{constructor(a,n,i,s,o,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=s,this.exports=o,this.subscriptions=t}}e.$ijc=R;class I extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$jjc=I;class w extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$kjc=w;class S extends R{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(a,n,i,s){this.g=s,this.a=a,this.b=n,this.c=i,this.d=new M.$Em,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(s=>({id:s.identifier,reason:{startup:n,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new S(o));return this.c.onExtensionActivationError(a.id,o,new P.$3F(a.id.value)),t}const i=[],s=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const o of s){if(this.m(o))continue;const t=this.d.get(o);if(t){i.push(t);continue}if(this.l(o)){i.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const d=this.a.getExtensionDescription(o);if(d){if(!d.main&&!d.browser)continue;i.push(this.j({id:d.identifier,reason:a.reason}));continue}const h=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${o}'`),r=this.k(a,n.displayName,[],new S(l));return this.c.onExtensionActivationError(n.identifier,l,new P.$3F(o)),r}return this.k(a,n.displayName,i,null)}k(a,n,i,s){const o=new c(a.id,n,a.reason,i,s,this.c,this.g);return this.d.set(a.id,o),o}l(a){return N.$x0b.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$ljc=k,e.$ljc=k=Je([Ve(3,A.$Nj)],k);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,s,o,t,d){this.c=a,this.d=n,this.f=i,this.g=s,this.h=o,this.j=t,this.k=d,this.a=new b.$gh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new S(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new S(n),this.b&&u.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};c=Je([Ve(6,A.$Nj)],c)}),define(ke[302],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[303],Ee([1,0,241,13,39,137,109,37,25,302,139,140]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const w=b.$Zn.as(A.$1n.JSONContribution);class S{constructor(o,t,d){this.a=o,this.b=t,this.c=d}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(M.default.Error,o)}warn(o){this.d(M.default.Warning,o)}info(o){this.d(M.default.Info,o)}}e.$TF=S;class k{static a(o){const t=new $.$Dm;for(let d=0,h=o.length;d<h;d++)t.add(o[d].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new k(t,[]);if(!t||!t.length)return new k([],o);const d=this.a(o),h=this.a(t),l=t.filter(g=>!d.has(g.description.identifier)),r=o.filter(g=>!h.has(g.description.identifier));return new k(l,r)}constructor(o,t){this.added=o,this.removed=t}}e.$UF=k;class c{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=k.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,N.$1)(o)}}}e.$VF=c;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Bm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$Eo}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$Eo}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new c(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&I.$KF.register(o.extensionPoint,o.activationEventsGenerator),e.$WF.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,w.registerSchema(a,e.$WF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$Zn.add(i.ExtensionsRegistry,new n),e.$YF=b.$Zn.as(i.ExtensionsRegistry),w.registerSchema(a,e.$WF),w.registerSchema(R.$8j,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[304],Ee([1,0,237,18,24,303,46,4]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var E;(function(w){function S(k,c,m){if(!k)return;const a=N.$Uf(k.type)?k.type:void 0;if(!a||a.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(k.required))for(const i of k.required)N.$Uf(i)&&n.push(i);return{extensionId:c.value,taskType:a,required:n,properties:k.properties?M.$Nn(k.properties):{},when:k.when?A.$fj.deserialize(k.when):void 0}}w.from=S})(E||(E={}));const R=P.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,S)=>{for(const k of w)k.type&&S.push(`onTaskType:${k.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new b.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,k)=>{R.setHandler((c,m)=>{this.c=void 0;try{for(const a of m.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of m.added){const n=a.value;for(const i of n){const s=E.from(i,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const k of this.all()){const c={type:"object",additionalProperties:!1};k.required.length>0&&(c.required=k.required.slice(0)),k.properties!==void 0?c.properties=M.$Nn(k.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[k.taskType]},S.push(c)}this.c={oneOf:S}}return this.c}}e.$nH=new I}),define(ke[305],Ee([1,0,238,18,23,24,46,304]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$xH=e.JsonSchemaVersion=e.ExecutionEngine=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$rH=e.ShellQuoting=e.$qH=e.$pH=e.$oH=void 0,e.$oH="settings",e.$pH=new A.$yj("taskRunning",!1,u.localize(0,null)),e.$qH=u.localize2(2,"Tasks");var $;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$rH="$customized",function(j){function F(L){if(!L)return j.Strong;switch(L.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=F}($||(e.ShellQuoting=$={}));var E;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var R;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(R||(e.RevealKind=R={})),function(j){function F(L){switch(L.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=F}(R||(e.RevealKind=R={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function F(L){switch(L.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=F}(I||(e.RevealProblemKind=I={}));var w;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(w||(e.PanelKind=w={})),function(j){function F(L){switch(L.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=F}(w||(e.PanelKind=w={}));var S;(function(j){j.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var k;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(j){function F(G){switch(G.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=F;function L(G){switch(G){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=L}(k||(e.RuntimeType=k={}));var c;(function(j){function F(L){return N.$Uf(L)?L:L.value}j.value=F})(c||(e.CommandString=c={}));var m;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function F(G){return G===j.Clean._id||G===j.Build._id||G===j.Rebuild._id||G===j.Test._id}j.is=F;function L(G){if(G!==void 0)return N.$Uf(G)?F(G)?{_id:G,isDefault:!1}:void 0:G}j.from=L})(m||(e.TaskGroup=m={}));var a;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function F(L){switch(L){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var i;(function(j){j.parallel="parallel",j.sequence="sequence"})(i||(e.DependsOrder=i={}));var s;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(s||(e.RunOnOptions=s={}));var o;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:s.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(F,L,G,te,Z,x){this._label="",this._id=F,L&&(this._label=L),G&&(this.type=G),this.runOptions=te,this.configurationProperties=Z,this._source=x}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,L=!1){if(F===void 0)return!1;if(N.$Uf(F))return F===this._label||F===this.configurationProperties.identifier||L&&F===this._id;const G=this.getDefinition(!0);return G!==void 0&&G._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$sH=t;class d extends t{constructor(F,L,G,te,Z,x,_,ue){super(F,G,void 0,_,ue,L),this.command={},this._source=L,this.hasDefinedMatchers=x,Z&&(this.command=Z)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let L;switch(this.command?this.command.runtime:void 0){case k.Shell:L="shell";break;case k.Process:L="process";break;case k.CustomExecution:L="customExecution";break;case void 0:L="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:L,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$oH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let L=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(L+=this._source.kind);const G={type:e.$rH,folder:F,id:L};return JSON.stringify(G)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$tH=d;class h extends t{constructor(F,L,G,te,Z,x,_){super(F,G,te,x,_,L),this._source=L,this.configures=Z}static is(F){return F instanceof h}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$oH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let L=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(L+=this._source.kind);const G={type:e.$rH,folder:F,id:L};return JSON.stringify(G)}}e.$uH=h;class l extends t{constructor(F,L,G,te,Z,x,_,ue,X){super(F,G,te,ue,X,L),this.defines=Z,this.hasDefinedMatchers=_,this.command=x,this.icon=X.icon,this.hide=X.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof l}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new l(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$vH=l;class r extends t{constructor(F,L,G,te,Z,x){super(F,G,te,Z,x,L),this._source=L}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new r(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$wH=r;var g;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(j){j._default=j.Terminal}(g||(e.ExecutionEngine=g={}));var f;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class D{constructor(F){this.c=new Map;for(let L=0;L<F.length;L++)this.c.set(F[L].uri.toString(),L)}compare(F,L){const G=F.getWorkspaceFolder(),te=L.getWorkspaceFolder();if(G&&te){let Z=this.c.get(G.uri.toString());Z=Z===void 0?0:Z+1;let x=this.c.get(te.uri.toString());return x=x===void 0?0:x+1,Z===x?F._label.localeCompare(L._label):Z-x}else return!G&&te?-1:G&&!te?1:0}}e.$xH=D;var p;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(p||(e.TaskEventKind=p={}));var v;(function(j){j.SingleRun="singleRun",j.Background="background"})(v||(e.TaskRunType=v={}));var y;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(j){function F(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function L(ue,X,$e){return{...F(ue),kind:"start",terminalId:X,resolvedVariables:$e}}j.start=L;function G(ue,X,$e){return{...F(ue),kind:"processStarted",terminalId:X,processId:$e}}j.processStarted=G;function te(ue,X,$e){return{...F(ue),kind:"processEnded",terminalId:X,exitCode:$e}}j.processEnded=te;function Z(ue,X,$e){return{...F(ue),kind:"terminated",exitReason:$e,terminalId:X}}j.terminated=Z;function x(ue,X,$e){return{...F(X),kind:ue,terminalId:$e}}j.general=x;function _(){return{kind:"changed"}}j.changed=_})(C||(e.TaskEvent=C={}));var O;(function(j){function F(G){const te=Object.keys(G).sort();let Z="";for(const x of te){let _=G[x];_ instanceof Object?_=F(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),Z+=x+","+_+","}return Z}function L(G){const Z={_key:F(G),type:G.taskType};return Object.assign(Z,G),Z}j.create=L})(O||(e.KeyedTaskIdentifier=O={}));var z;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var T;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var B;(function(j){function F(L,G){const te=b.$nH.get(L.type);if(te===void 0){const ue=P.$Nn(L);return delete ue._key,O.create(ue)}const Z=Object.create(null);Z.type=te.taskType;const x=new Set;te.required.forEach(ue=>x.add(ue));const _=te.properties;for(const ue of Object.keys(_)){const X=L[ue];if(X!=null)Z[ue]=X;else if(x.has(ue)){const $e=_[ue];if($e.default!==void 0)Z[ue]=P.$Nn($e.default);else switch($e.type){case"boolean":Z[ue]=!1;break;case"number":case"integer":Z[ue]=0;break;case"string":Z[ue]="";break;default:G.error(u.localize(1,null,JSON.stringify(L,void 0,0),ue));return}}}return O.create(Z)}j.createTaskIdentifier=F})(B||(e.TaskDefinition=B={}))}),define(ke[306],Ee([1,0,13]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=e.$B0b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,b)=>{this.b=A,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,u.$1)(A))}then(A,b){return this.j().then(A,b)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$B0b=N;class M extends N{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$C0b=M}),define(ke[67],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=e.$_v=void 0,e.$aw=M,e.$bw=P;class u{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++u.count}}e.$_v=u;const N=[];function M(b){const $=new u(b);return N[$.nid]=$,$}function P(b){return N[b].sid}class A{constructor($){this.value=$}}e.$cw=A}),define(ke[6],Ee([1,0,67]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var M;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(M||(e.TabInputKind=M={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var b;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var E;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var R;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(m){return m._id=I.a++,m}}e.$fM=I;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var S;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var k;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$gM={MainThreadAuthentication:(0,u.$aw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$aw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$aw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$aw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$aw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$aw)("MainThreadClipboard"),MainThreadCommands:(0,u.$aw)("MainThreadCommands"),MainThreadComments:(0,u.$aw)("MainThreadComments"),MainThreadConfiguration:(0,u.$aw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$aw)("MainThreadConsole"),MainThreadDebugService:(0,u.$aw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$aw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$aw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$aw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$aw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$aw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$aw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$aw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$aw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$aw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$aw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$aw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$aw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$aw)("MainThreadLanguages"),MainThreadLogger:(0,u.$aw)("MainThreadLogger"),MainThreadMessageService:(0,u.$aw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$aw)("MainThreadOutputService"),MainThreadProgress:(0,u.$aw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$aw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$aw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$aw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$aw)("MainThreadSecretState"),MainThreadStorage:(0,u.$aw)("MainThreadStorage"),MainThreadSpeech:(0,u.$aw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$aw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$aw)("MainThreadTerminalService"),MainThreadWebviews:(0,u.$aw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$aw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$aw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$aw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$aw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$aw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$aw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$aw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$aw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$aw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$aw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$aw)("MainThreadSCM"),MainThreadSearch:(0,u.$aw)("MainThreadSearch"),MainThreadShare:(0,u.$aw)("MainThreadShare"),MainThreadTask:(0,u.$aw)("MainThreadTask"),MainThreadWindow:(0,u.$aw)("MainThreadWindow"),MainThreadLabelService:(0,u.$aw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$aw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$aw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$aw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$aw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$aw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$aw)("MainThreadInteractive"),MainThreadChat:(0,u.$aw)("MainThreadChat"),MainThreadInlineChat:(0,u.$aw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$aw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$aw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$aw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$aw)("MainThreadTimeline"),MainThreadTesting:(0,u.$aw)("MainThreadTesting"),MainThreadLocalization:(0,u.$aw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$aw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$aw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,u.$aw)("MainThreadIssueReporter")},e.$hM={ExtHostCommands:(0,u.$aw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$aw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$aw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$aw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$aw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$aw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$aw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$aw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$aw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$aw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$aw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$aw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$aw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$aw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$aw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$aw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$aw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$aw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$aw)("ExtHostStatusBar"),ExtHostShare:(0,u.$aw)("ExtHostShare"),ExtHostExtensionService:(0,u.$aw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$aw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$aw)("ExtHostTerminalService"),ExtHostSCM:(0,u.$aw)("ExtHostSCM"),ExtHostSearch:(0,u.$aw)("ExtHostSearch"),ExtHostTask:(0,u.$aw)("ExtHostTask"),ExtHostWorkspace:(0,u.$aw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$aw)("ExtHostWindow"),ExtHostWebviews:(0,u.$aw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$aw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$aw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$aw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$aw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$aw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$aw)("ExtHostProgress"),ExtHostComments:(0,u.$aw)("ExtHostComments"),ExtHostSecretState:(0,u.$aw)("ExtHostSecretState"),ExtHostStorage:(0,u.$aw)("ExtHostStorage"),ExtHostUrls:(0,u.$aw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$aw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$aw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$aw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$aw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$aw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$aw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$aw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$aw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$aw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$aw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$aw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$aw)("ExtHostInlineChatShape"),ExtHostChat:(0,u.$aw)("ExtHostChat"),ExtHostChatAgents2:(0,u.$aw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$aw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$aw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$aw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$aw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$aw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$aw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$aw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$aw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$aw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$aw)("ExtHostTimeline"),ExtHostTesting:(0,u.$aw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$aw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$aw)("ExtHostLocalization"),ExtHostIssueReporter:(0,u.$aw)("ExtHostIssueReporter")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=e.$Cic=void 0,e.$Cic=(0,u.$hi)("IExtHostApiDeprecationService");let A=class{constructor($,E){this.c=E,this.a=new Set,this.b=$.getProxy(M.$gM.MainThreadTelemetry)}report($,E,R){const I=this.d($,E);this.a.has(I)||(this.a.add(I),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:$}))}d($,E){return`${$}-${E.identifier.value}`}};e.$Dic=A,e.$Dic=A=Je([Ve(0,P.$AO),Ve(1,N.$Nj)],A),e.$Eic=Object.freeze(new class{report(b,$,E){}})}),define(ke[307],Ee([1,0,43,3,6]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;class P{static{this.a=0}constructor($,E){this.extension=$,this.provider=E,this.handle=P.a++}}class A{static{this.a=0}constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(M.$gM.MainThreadChat)}registerChatProvider($,E,R){const I=new P($,R);return this.b.set(I.handle,I),this.d.$registerChatProvider(I.handle,E),(0,N.$Sc)(()=>{this.d.$unregisterChatProvider(I.handle),this.b.delete(I.handle)})}transferChatSession($,E){const R=u.Iterable.find(this.c.keys(),I=>this.c.get(I)===$)??0;typeof R=="number"&&this.d.$transferChatSession(R,E)}async $prepareChat($,E){const R=this.b.get($);if(!R)return;const I=await R.provider.prepareSession(E);if(!I)return;const w=A.a++;return this.c.set(w,I),{id:w}}$releaseSession($){this.c.delete($)}}e.$Pic=A}),define(ke[308],Ee([1,0,6]),function(de,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;class N{constructor(P){const A=P.getProxy(u.$gM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(b){return A.$writeText(b)}})}}e.$Uic=N}),define(ke[309],Ee([1,0,24,6,27,20]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;let A=class{constructor(R,I){this.a=R.getProxy(N.$gM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,I){const w=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){w.e(R,I,S,arguments)}})}e(R,I,w,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(S,this.b)}),this.c&&this.f(R,w,S)}};e.$Lkc=A,e.$Lkc=A=Je([Ve(0,P.$AO),Ve(1,M.$QO)],A);const b=1e5;function $(E,R){const I=[];if(E.length)for(let w=0;w<E.length;w++){let S=E[w];if(typeof S>"u")S="undefined";else if(S instanceof Error){const k=S;k.stack?S=k.stack:S=k.toString()}I.push(S)}if(R){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,u.$Sn)(I);return w.length>b?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(ke[310],Ee([1,0,2,6,26]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class P{constructor(b){this.a=b.getProxy(N.$gM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,M.$6F)(b,"showLocal"),this.a.$showOpenDialog($).then(E=>E?E.map(R=>u.URI.revive(R)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?u.URI.revive($):void 0)}}e.$Pjc=P}),define(ke[311],Ee([1,0,3,6]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class M{constructor(A){this.b=0,this.a=A.getProxy(N.$gM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,A),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$$jc=M}),define(ke[115],Ee([1,0,11,14,2,5,12,6,27,20]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=e.$xjc=void 0;let R=class{constructor(w,S,k){this.f=k,this.d=new Map,this.a=S.getProxy(b.$gM.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===u.$g}getMessage(w,S){const{message:k,args:c,comment:m}=S;if(this.c)return(0,N.$We)(k,c??{});let a=k;m&&m.length>0&&(a+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get(w)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,N.$We)(n??k,c??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let S;const k=await this.g(w);if(!k){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(k),m=JSON.parse(c);S=w.isBuiltin?m.contents?.bundle:m}catch(c){this.f.error(`Failed to load translations for ${w.identifier.value} from ${k}: ${c.message}`);return}S&&this.d.set(w.identifier.value,{contents:S,uri:k})}async g(w){if(w.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return M.URI.revive(S)}return w.l10n?M.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$xjc=R,e.$xjc=R=Je([Ve(0,$.$QO),Ve(1,E.$AO),Ve(2,A.$Nj)],R),e.$yjc=(0,P.$hi)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,27,20,2,57]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;let $=class extends u.$Yj{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(S=>(0,b.$Qh)(S))),this.r=I.getProxy(N.$gM.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(A.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.r.$setVisibility(I,w)}s(I,w,S){return new E(this.r,I,w,S)}};e.$Kkc=$,e.$Kkc=$=Je([Ve(0,P.$AO),Ve(1,M.$QO)],$);class E extends u.$Tj{constructor(I,w,S,k){super(k?.logLevel==="always"),this.r=I,this.s=w,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(w,k).then(()=>{this.u(this.n),this.m=!0})}g(I,w){const S=[[I,w]];this.m?this.u(S):this.n.push(...S)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=e.$zjc=void 0,e.$zjc=(0,N.$hi)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(u.$gM.MainThreadManagedSockets)}setFactory(I,w){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,S=await this.c.makeConnection(),k=new M.$Tc;return this.d.set(w,new E(w,S,k)),k.add((0,M.$Sc)(()=>this.d.delete(w))),k.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),k.dispose()})),k.add(S.onDidClose(c=>{this.a.$onDidManagedSocketClose(w,c?.stack??c?.message),k.dispose()})),k.add(S.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(w,A.$ue.wrap(c)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Ajc=b,e.$Ajc=b=Je([Ve(0,P.$AO)],b);class ${constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class E extends M.$Uc{constructor(I,w,S){super(),this.socketId=I,this.actual=w,this.B(S)}}}),define(ke[312],Ee([1,0,6,12,26]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;function P(b){return b&&b.title}let A=class{constructor($,E){this.b=E,this.a=$.getProxy(u.$gM.MainThreadMessageService)}showMessage($,E,R,I,w){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let k;typeof I=="string"||P(I)?k=[I,...w]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,k=w),S.useCustom&&(0,M.$6F)($,"resolvers");const c=[];let m=!1;for(let a=0;a<k.length;a++){const n=k[a];if(typeof n=="string")c.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:s}=n;c.push({title:i,isCloseAffordance:!!s,handle:a}),s&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,R,S,c).then(a=>{if(typeof a=="number")return k[a]})}};e.$akc=A,e.$akc=A=Je([Ve(1,N.$Nj)],A)}),define(ke[313],Ee([1,0,3,18,2,26,6]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(A.$gM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,R,I){if((0,P.$6F)(E,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,E.identifier.value),(0,u.$Sc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(E,R,I,w){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(R,I,w)}async $readProfile(E,R,I){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.readProfile((0,N.$Uf)(R)?R:M.URI.revive(R),I)}}e.$jkc=b}),define(ke[117],Ee([1,0,6,4,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0;class P{constructor(b){this.b=new N.$7d,this.onDidChangePassword=this.b.event,this.a=b.getProxy(u.$gM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,E){return this.a.$setPassword(b,$,E)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$ujc=P,e.$vjc=(0,M.$hi)("IExtHostSecretState")}),define(ke[314],Ee([1,0,22,3,6]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;class P{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(M.$gM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,E){const R=this.c.get(b);if(!R)return;const I=new N.$Tc,w=new u.$ee;this.d.set($,w);const S=I.add(R.provideSpeechToTextSession(w.token,E?{language:E}:void 0));I.add(S.onDidChange(k=>{w.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,k)})),I.add(w.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,$){const E=this.c.get(b);if(!E)return;const R=new N.$Tc,I=new u.$ee;this.d.set($,I);const w=R.add(E.provideKeywordRecognitionSession(I.token));R.add(w.onDidChange(S=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),R.add(I.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,E){const R=P.a++;return this.c.set(R,E),this.b.$registerProvider(R,$,{extension:b,displayName:b.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$qkc=P}),define(ke[118],Ee([1,0,6,4,5]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=e.$mjc=void 0;class P{constructor(b,$){this.c=$,this.b=new N.$7d,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(u.$gM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,E){const R=await this.a.$initializeExtensionStorage(b,$);let I;return R&&(I=this.d(b,$,R)),I||E}setValue(b,$,E){return this.a.$setValue(b,$,E)}$acceptValue(b,$,E){const R=this.d(b,$,E);R&&this.b.fire({shared:b,key:$,value:R})}d(b,$,E){try{return JSON.parse(E)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${R}`)}}}e.$mjc=P,e.$njc=(0,M.$hi)("IExtHostStorage")}),define(ke[315],Ee([1,0,3,15,2,6]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;class A{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$gM.MainThreadUriOpeners)}registerExternalUriOpener($,E,R,I){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const w=I.schemes.find(S=>!A.a.has(S));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(E,R),this.b.$registerUriOpener(E,I.schemes,$,I.label),(0,u.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri($,E,R){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const w=M.URI.revive(E);return I.canOpenExternalUri(w,R)}async $openUri($,E,R){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(M.URI.revive(E.resolvedUri),{sourceUri:M.URI.revive(E.sourceUri)},R)}}e.$Ekc=A}),define(ke[316],Ee([1,0,6,2,3,13,25]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class b{static{this.a=0}constructor(E){this.c=new A.$Dm,this.d=new Map,this.b=E.getProxy(u.$gM.MainThreadUrls)}registerUriHandler(E,R){const I=E.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=b.a++;return this.c.add(I),this.d.set(w,R),this.b.$registerUriHandler(w,I,E.displayName||E.name),(0,M.$Sc)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(E,R){const I=this.d.get(E);if(!I)return Promise.resolve(void 0);try{I.handleUri(N.URI.revive(R))}catch(w){(0,P.$1)(w)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$Fkc=b}),define(ke[92],Ee([1,0,4,3,15,24,2,245,283,113,6]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=e.$0ic=void 0,e.$$ic=w,e.$ajc=c,e.$bjc=m;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,o,t,d,h,l,r){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$7d,this._onDidDispose=this.#h.event,this.#e=s,this.#t=o,this.#o=t,this.#n=d,this.#s=h,this.#r=l,this.#l=w(l),this.#d=S(l),this.#i=r}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,E.$Gyb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===M.Schemas.https||s.scheme===M.Schemas.http){let o=s.toString();return o.endsWith("/")||(o+="/"),o+" "+E.$Fyb}return E.$Fyb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),P.$Rn(this.#o,s)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const o=(0,$.$Enb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const o=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,h,l,r,g,f)=>{const D=A.URI.from({scheme:r||"file",path:decodeURIComponent(g)}),p=(0,E.$Gyb)(D,{isRemote:o,authority:t}).toString();return`${h}${p}${f}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,h,l,r,g,f)=>{const D=A.URI.from({scheme:r||"file",path:decodeURIComponent(g)}),p=(0,E.$Gyb)(D,{isRemote:o,authority:t}).toString();return`${h}${p}${f}`})}}e.$0ic=I;function w(i){try{const s=(0,b.$tp)((0,b.$sp)(i.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function S(i){try{const s=(0,b.$tp)((0,b.$sp)(i.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class k extends N.$Uc{constructor(s,o,t,d,h){super(),this.c=o,this.f=t,this.g=d,this.h=h,this.b=new Map,this.a=s.getProxy(R.$gM.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,o,t){const d=this.j(s);if(d){const{message:h}=(0,$.$Fnb)(o,t.value);d._onMessageEmitter.fire(h)}}$onMissingCsp(s,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,o,t){const d=new I(s,this.a,a(o),this.c,this.f,t,this.h);this.b.set(s,d);const h=d._onDidDispose(()=>{h.dispose(),this.deleteWebview(s)});return d}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$_ic=k;function c(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,s,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||n(i,s)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(s=>A.URI.from(s))}}function n(i,s){return[...(s?.getWorkspaceFolders()||[]).map(o=>o.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(de,e,u,N,M,P,A,b,$,E){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(S){const k=this.d;return{get focused(){return k.focused},get active(){return(0,E.$6F)(S,"windowActivity"),k.active}}}constructor(S){this.c=new u.$7d,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=S.getProxy(N.$gM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:c})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,k){k!==this.d[S]&&(this.d={...this.d,[S]:k},this.c.fire(this.d))}openUri(S,k){let c;if(typeof S=="string"){c=S;try{S=M.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.$Ue)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,c,k)}async asExternalUri(S,k){if((0,A.$Ue)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(S,k);return M.URI.from(c)}};e.$Hkc=I,e.$Hkc=I=R=Je([Ve(0,$.$AO)],I),e.$Ikc=(0,b.$hi)("IExtHostWindow")}),define(ke[317],Ee([1,0,309,27,20]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;const P=1024*1024;let A=class extends u.$Lkc{constructor($,E){super($,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,E,R){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),E.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,E){const R=process[$],I=R.write;let w="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(S,k,c)=>{if(!this.g){w+=S.toString(k);const m=w.length>P?w.length:w.lastIndexOf(`
`);m!==-1&&(console[E](w.slice(0,m)),w=w.slice(m+1))}I.call(R,S,k,c)}})}};e.$klc=A,e.$klc=A=Je([Ve(0,M.$AO),Ve(1,N.$QO)],A)}),define(ke[318],Ee([1,0,149,15,260,30]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class A extends u.$Kkc{s($,E,R){return $.scheme===N.Schemas.file?new M.$NP(R?.name||(0,P.$Dg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,E):super.s($,E,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$wlc=A}),define(ke[319],Ee([1,0,8,21,22,13,4,3,133,306,67]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=e.ResponsiveState=e.RequestInitiator=void 0,e.$D0b=m,e.$E0b=a;function w(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const S="$$ref$$",k={[S]:-1};class c{constructor(C,O){this.jsonString=C,this.referencedBuffers=O}}function m(y,C=null,O=!1){const z=[];return{jsonString:(O?w:JSON.stringify)(y,(B,j)=>{if(typeof j>"u")return k;if(typeof j=="object"){if(j instanceof N.$ue){const F=z.push(j)-1;return{[S]:F}}if(C)return C(B,j)}return j}),referencedBuffers:z}}function a(y,C,O){return JSON.parse(y,(z,T)=>{if(T){const B=T[S];if(typeof B=="number")return C[B];if(O&&T.$mid===1)return O.transformIncoming(T)}return T})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,O)=>O&&O.$mid===1?y.transformOutgoing(O):O:null}var s;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(s||(e.RequestInitiator=s={}));var o;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},d=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class l extends b.$Uc{static{I=d}static{this.a=3*1e3}constructor(C,O=null,z=null){super(),this[I]=!0,this.b=this.B(new A.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=O,this.g=z,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,B=R.$_v.count;T<B;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$th(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const O=this.w[C];delete this.w[C],O.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$mn)(C,this.g):C}getProxy(C){const{nid:O,sid:z}=C;return this.s[O]||(this.s[O]=this.J(O,z)),this.s[O]}J(C,O){const z={get:(T,B)=>(typeof B=="string"&&!T[B]&&B.charCodeAt(0)===36&&(T[B]=(...j)=>this.U(C,B,j)),B===h?O:T[B])};return new Proxy(Object.create(null),z)}set(C,O){return this.m[C.nid]=O,O}assertRegistered(C){for(let O=0,z=C.length;O<z;O++){const T=C[O];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(C){if(this.j)return;const O=C.byteLength,z=g.read(C,0),T=z.readUInt8(),B=z.readUInt32();switch(T){case 1:case 2:{let{rpcId:j,method:F,args:L}=D.deserializeRequestJSONArgs(z);this.g&&(L=(0,$.$mn)(L,this.g)),this.M(O,B,j,F,L,T===2);break}case 3:case 4:{let{rpcId:j,method:F,args:L}=D.deserializeRequestMixedArgs(z);this.g&&(L=(0,$.$mn)(L,this.g)),this.M(O,B,j,F,L,T===4);break}case 5:{this.f?.logIncoming(O,B,0,"ack"),this.G(B);break}case 6:{this.N(O,B);break}case 7:{this.O(O,B,void 0);break}case 9:{let j=D.deserializeReplyOKJSON(z);this.g&&(j=(0,$.$mn)(j,this.g)),this.O(O,B,j);break}case 10:{const j=D.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(O,B,j);break}case 8:{const j=D.deserializeReplyOKVSBuffer(z);this.O(O,B,j);break}case 11:{let j=D.deserializeReplyErrError(z);this.g&&(j=(0,$.$mn)(j,this.g)),this.P(O,B,j);break}case 12:{this.P(O,B,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,O,z,T,B,j){this.f?.logIncoming(C,O,1,`receiveRequest ${(0,R.$bw)(z)}.${T}(`,B);const F=String(O);let L,G;if(j){const Z=new M.$ee;B.push(Z.token),L=this.Q(z,T,B),G=()=>Z.cancel()}else L=this.Q(z,T,B),G=t;this.u[F]=G;const te=D.serializeAcknowledged(O);this.f?.logOutgoing(te.byteLength,O,1,"ack"),this.c.send(te),L.then(Z=>{delete this.u[F];const x=D.serializeReplyOK(O,Z,this.h);this.f?.logOutgoing(x.byteLength,O,1,"reply:",Z),this.c.send(x)},Z=>{delete this.u[F];const x=D.serializeReplyErr(O,Z);this.f?.logOutgoing(x.byteLength,O,1,"replyErr:",Z),this.c.send(x)})}N(C,O){this.f?.logIncoming(C,O,1,"receiveCancel");const z=String(O);this.u[z]?.()}O(C,O,z){this.f?.logIncoming(C,O,0,"receiveReply:",z);const T=String(O);if(!this.w.hasOwnProperty(T))return;const B=this.w[T];delete this.w[T],B.resolveOk(z)}P(C,O,z){this.f?.logIncoming(C,O,0,"receiveReplyErr:",z);const T=String(O);if(!this.w.hasOwnProperty(T))return;const B=this.w[T];delete this.w[T];let j;z&&(z.$isError?(j=new Error,j.name=z.name,j.message=z.message,j.stack=z.stack):j=z),B.resolveErr(j)}Q(C,O,z){try{return Promise.resolve(this.S(C,O,z))}catch(T){return Promise.reject(T)}}S(C,O,z){const T=this.m[C];if(!T)throw new Error("Unknown actor "+(0,R.$bw)(C));const B=T[O];if(typeof B!="function")throw new Error("Unknown method "+O+" on actor "+(0,R.$bw)(C));return B.apply(T,z)}U(C,O,z){if(this.j)return new E.$C0b;let T=null;if(z.length>0&&M.CancellationToken.isCancellationToken(z[z.length-1])&&(T=z.pop()),T&&T.isCancellationRequested)return Promise.reject(P.$6());const B=D.serializeRequestArguments(z,this.h),j=++this.t,F=String(j),L=new E.$B0b,G=new b.$Tc;T&&G.add(T.onCancellationRequested(()=>{const Z=D.serializeCancel(j);this.f?.logOutgoing(Z.byteLength,j,0,"cancel"),this.c.send(D.serializeCancel(j))})),this.w[F]=new r(L,G),this.F(j);const te=D.serializeRequest(j,C,O,B,!!T);return this.f?.logOutgoing(te.byteLength,j,0,`request: ${(0,R.$bw)(C)}.${O}(`,z),this.c.send(te),L}}e.$F0b=l;class r{constructor(C,O){this.a=C,this.b=O}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class g{static alloc(C,O,z){const T=new g(N.$ue.alloc(z+1+4),0);return T.writeUInt8(C),T.writeUInt32(O),T}static read(C,O){return new g(C,O)}get buffer(){return this.a}constructor(C,O){this.a=C,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+C);return this.b+=C,O}static sizeMixedArray(C){let O=0;O+=1;for(let z=0,T=C.length;z<T;z++){const B=C[z];switch(O+=1,B.type){case 1:O+=this.sizeLongString(B.value);break;case 2:O+=this.sizeVSBuffer(B.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(B.value);for(let j=0;j<B.buffers.length;++j)O+=this.sizeVSBuffer(B.buffers[j]);break;case 4:break}}return O}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let O=0,z=C.length;O<z;O++){const T=C[O];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let B=0;B<T.buffers.length;++B)this.writeBuffer(T.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const O=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:O[z]=this.readLongString();break;case 2:O[z]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),j=this.readLongString(),F=[];for(let L=0;L<B;++L)F.push(this.readVSBuffer());O[z]=new R.$cw(a(j,F,null));break}case 4:O[z]=void 0;break}return O}}var f;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(f||(f={}));class D{static a(C){for(let O=0,z=C.length;O<z;O++)if(C[O]instanceof N.$ue||C[O]instanceof R.$cw||typeof C[O]>"u")return!0;return!1}static serializeRequestArguments(C,O){if(this.a(C)){const z=[];for(let T=0,B=C.length;T<B;T++){const j=C[T];if(j instanceof N.$ue)z[T]={type:2,value:j};else if(typeof j>"u")z[T]={type:4};else if(j instanceof R.$cw){const{jsonString:F,referencedBuffers:L}=m(j.value,O);z[T]={type:3,value:N.$ue.fromString(F),buffers:L}}else z[T]={type:1,value:N.$ue.fromString(n(j,O))}}return{type:1,args:z}}return{type:0,args:n(C,O)}}static serializeRequest(C,O,z,T,B){switch(T.type){case 0:return this.b(C,O,z,T.args,B);case 1:return this.c(C,O,z,T.args,B)}}static b(C,O,z,T,B){const j=N.$ue.fromString(z),F=N.$ue.fromString(T);let L=0;L+=g.sizeUInt8(),L+=g.sizeShortString(j),L+=g.sizeLongString(F);const G=g.alloc(B?2:1,C,L);return G.writeUInt8(O),G.writeShortString(j),G.writeLongString(F),G.buffer}static deserializeRequestJSONArgs(C){const O=C.readUInt8(),z=C.readShortString(),T=C.readLongString();return{rpcId:O,method:z,args:JSON.parse(T)}}static c(C,O,z,T,B){const j=N.$ue.fromString(z);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(j),F+=g.sizeMixedArray(T);const L=g.alloc(B?4:3,C,F);return L.writeUInt8(O),L.writeShortString(j),L.writeMixedArray(T),L.buffer}static deserializeRequestMixedArgs(C){const O=C.readUInt8(),z=C.readShortString(),T=C.readMixedArray(),B=new Array(T.length);for(let j=0,F=T.length;j<F;j++){const L=T[j];typeof L=="string"?B[j]=JSON.parse(L):B[j]=L}return{rpcId:O,method:z,args:B}}static serializeAcknowledged(C){return g.alloc(5,C,0).buffer}static serializeCancel(C){return g.alloc(6,C,0).buffer}static serializeReplyOK(C,O,z){if(typeof O>"u")return this.d(C);if(O instanceof N.$ue)return this.e(C,O);if(O instanceof R.$cw){const{jsonString:T,referencedBuffers:B}=m(O.value,z,!0);return this.g(C,T,B)}else return this.f(C,w(O,z))}static d(C){return g.alloc(7,C,0).buffer}static e(C,O){let z=0;z+=g.sizeVSBuffer(O);const T=g.alloc(8,C,z);return T.writeVSBuffer(O),T.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,O){const z=N.$ue.fromString(O);let T=0;T+=g.sizeLongString(z);const B=g.alloc(9,C,T);return B.writeLongString(z),B.buffer}static g(C,O,z){const T=N.$ue.fromString(O);let B=0;B+=g.sizeUInt32,B+=g.sizeLongString(T);for(const F of z)B+=g.sizeVSBuffer(F);const j=g.alloc(10,C,B);j.writeUInt32(z.length),j.writeLongString(T);for(const F of z)j.writeBuffer(F);return j.buffer}static deserializeReplyOKJSON(C){const O=C.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(C,O){const z=C.readUInt32(),T=C.readLongString(),B=[];for(let j=0;j<z;++j)B.push(C.readVSBuffer());return new R.$cw(a(T,B,O))}static serializeReplyErr(C,O){const z=O?w(P.$3(O),null):void 0;if(typeof z!="string")return this.h(C);const T=N.$ue.fromString(z);let B=0;B+=g.sizeLongString(T);const j=g.alloc(11,C,B);return j.writeLongString(T),j.buffer}static deserializeReplyErrError(C){const O=C.readLongString();return JSON.parse(O)}static h(C){return g.alloc(12,C,0).buffer}}var p;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(v||(v={}))}),define(ke[320],Ee([1,0,21,28,15,83,5]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$UJ=void 0,e.$VJ=R,e.$WJ=I,e.$UJ=(0,A.$hi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),E=7;function R(S){if(S.scheme!==M.Schemas.vscodeNotebookCell)return;const k=S.fragment.indexOf("s");if(k<0)return;const c=parseInt(S.fragment.substring(0,k).replace($,""),E),m=(0,u.$Ne)(S.fragment.substring(k+1)).toString();if(!isNaN(c))return{handle:c,notebook:S.with({scheme:m,fragment:null})}}function I(S,k){const c=k.toString(E),a=`${c.length<b.length?b[c.length-1]:"z"}${c}s${(0,u.$Oe)(u.$ue.fromString(S.scheme),!0,!0)}`;return S.with({scheme:M.Schemas.vscodeNotebookCell,fragment:a})}class w{constructor(){this.a=new N.$Bc}getNotebook(k){if(k.scheme===M.Schemas.vscodeNotebookCell){const c=R(k);if(c){const m=this.a.get(c.notebook);if(m)return m}}return this.a.get(k)}addNotebookDocument(k){this.a.set(k.uri,k)}removeNotebookDocument(k){this.a.delete(k.uri)}}e.$XJ=w,(0,P.$es)(e.$UJ,w,1)}),define(ke[119],Ee([1,0,21,35,43,101,15,17,11,46,320]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$cK=e.CellStatusbarAlignment=e.$bK=e.NotebookEditorPriority=e.$$J=e.$0J=e.$8J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$7J=e.$6J=e.$5J=e.$4J=e.CellKind=e.$3J=e.$2J=e.$1J=void 0,e.$9J=d,e.$_J=l,e.$aK=r,e.$dK=D,e.$eK=v,e.$1J="workbench.editor.notebook",e.$2J="workbench.editor.notebookTextDiffEditor",e.$3J="workbench.editor.interactive";var I;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(I||(e.CellKind=I={})),e.$4J=["application/json","application/javascript","text/html","image/svg+xml",P.$xs.latex,P.$xs.markdown,"image/png","image/jpeg",P.$xs.text],e.$5J=[P.$xs.latex,P.$xs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$xs.text],e.$6J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$7J="_notAvailable";var w;(function(L){L[L.Running=1]="Running",L[L.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var S;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var k;(function(L){L[L.Unconfirmed=1]="Unconfirmed",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var c;(function(L){L[L.WithHardKernelDependency=0]="WithHardKernelDependency",L[L.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",L[L.Pure=2]="Pure",L[L.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var m;(function(L){L.Always="always",L.Never="never",L.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var a;(function(L){L[L.ModelChange=1]="ModelChange",L[L.Move=2]="Move",L[L.ChangeCellLanguage=5]="ChangeCellLanguage",L[L.Initialize=6]="Initialize",L[L.ChangeCellMetadata=7]="ChangeCellMetadata",L[L.Output=8]="Output",L[L.OutputItem=9]="OutputItem",L[L.ChangeCellContent=10]="ChangeCellContent",L[L.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",L[L.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",L[L.ChangeCellMime=13]="ChangeCellMime",L[L.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(L){L[L.Handle=0]="Handle",L[L.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(L){L[L.Replace=1]="Replace",L[L.Output=2]="Output",L[L.Metadata=3]="Metadata",L[L.CellLanguage=4]="CellLanguage",L[L.DocumentMetadata=5]="DocumentMetadata",L[L.Move=6]="Move",L[L.OutputItems=7]="OutputItems",L[L.PartialMetadata=8]="PartialMetadata",L[L.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var s;(function(L){L.scheme=A.Schemas.vscodeNotebookCell;function G(X,$e){return(0,R.$WJ)(X,$e)}L.generate=G;function te(X){return(0,R.$VJ)(X)}L.parse=te;function Z(X,$e){return X.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${X.scheme!==A.Schemas.file?X.scheme:""}`})}L.generateCellOutputUri=Z;function x(X){if(X.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(X.fragment);if(!$e)return;const se=$e[1]&&$e[1]!==""?$e[1]:void 0,re=$e[2];return{outputId:se,notebook:X.with({scheme:re||A.Schemas.file,fragment:null})}}L.parseCellOutputUri=x;function _(X,$e,se){return L.generate(X,$e).with({scheme:se})}L.generateCellPropertyUri=_;function ue(X,$e){if(X.scheme===$e)return L.parse(X.with({scheme:L.scheme}))}L.parseCellPropertyUri=ue})(s||(e.CellUri=s={}));const o=L=>$.$i?L.replace(/\//g,"\\"):L;class t{constructor(G=[],te=e.$4J){this.e=te,this.d=[...new Set(G)].map(Z=>({pattern:Z,matches:N.$bk(o(Z))}))}sort(G){const te=new Map(M.Iterable.map(G,x=>[x,o(x)]));let Z=[];for(const{matches:x}of this.d)for(const[_,ue]of te)if(x(ue)){Z.push(_),te.delete(_);break}return te.size&&(Z=Z.concat([...te.keys()].sort((x,_)=>this.e.indexOf(x)-this.e.indexOf(_)))),Z}prioritize(G,te){const Z=this.f(G);if(Z===-1){this.d.unshift({pattern:G,matches:N.$bk(o(G))});return}const x=new Set(te.map(ue=>this.f(ue,Z)));x.delete(-1);const _=Array.from(x).sort();this.d.splice(Z+1,0,..._.map(ue=>this.d[ue]));for(let ue=_.length-1;ue>=0;ue--)this.d.splice(_[ue],1)}toArray(){return this.d.map(G=>G.pattern)}f(G,te=this.d.length){const Z=o(G);for(let x=0;x<te;x++)if(this.d[x].matches(Z))return x;return-1}}e.$8J=t;function d(L,G,te,Z=(x,_)=>x===_){const x=[];function _($e,se,re){if(se===0&&re.length===0)return;const U=x[x.length-1];U&&U.start+U.deleteCount===$e?(U.deleteCount+=se,U.toInsert.push(...re)):x.push({start:$e,deleteCount:se,toInsert:re})}let ue=0,X=0;for(;;){if(ue===L.length){_(ue,0,G.slice(X));break}if(X===G.length){_(ue,L.length-ue,[]);break}const $e=L[ue],se=G[X];if(Z($e,se)){ue+=1,X+=1;continue}te(se)?(_(ue,1,[]),ue+=1):(_(ue,0,[se]),X+=1)}return x}e.$0J=new E.$yj("notebookEditorCursorAtBoundary","none"),e.$$J=new E.$yj("notebookEditorCursorAtLineBoundary","none");var h;(function(L){L.default="default",L.option="option"})(h||(e.NotebookEditorPriority=h={}));function l(L){const G=L;return!!((typeof G.include=="string"||N.$ck(G.include))&&(typeof G.exclude=="string"||N.$ck(G.exclude)))}function r(L,G,te){if(Array.isArray(L.viewType)&&L.viewType.indexOf(G)>=0||L.viewType===G)return!0;if(L.filenamePattern){const Z=l(L.filenamePattern)?L.filenamePattern.include:L.filenamePattern,x=l(L.filenamePattern)?L.filenamePattern.exclude:void 0;if(N.$ak(Z,(0,b.$oc)(te.fsPath).toLowerCase()))return!(x&&N.$ak(x,(0,b.$oc)(te.fsPath).toLowerCase()))}return!1}e.$bK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose"};var g;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class f{static{this.d="notebook/"}static create(G){return`${f.d}${G}`}static parse(G){if(G.startsWith(f.d))return G.substring(f.d.length)}}e.$cK=f;function D(L){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(L)}const p=new TextDecoder;function v(L){const G=[];let te=!1;for(const ue of L)(G.length===0||te)&&(G.push(ue),te=!0);let Z=O(G);const x=u.$ue.concat(G.map(ue=>u.$ue.wrap(ue))),_=F(x);return Z=Z||_.byteLength!==x.byteLength,{data:_,didCompression:Z}}e.$fK="\x1B[A";const y=e.$fK.split("").map(L=>L.charCodeAt(0)),C=10;function O(L){let G=!1;return L.forEach((te,Z)=>{if(Z===0||te.length<e.$fK.length)return;const x=L[Z-1],_=te.subarray(0,e.$fK.length);if(_[0]===y[0]&&_[1]===y[1]&&_[2]===y[2]){const ue=x.lastIndexOf(C);if(ue===-1)return;G=!0,L[Z-1]=x.subarray(0,ue),L[Z]=te.subarray(e.$fK.length)}}),G}function z(L){let G=L;do L=G,G=L.replace(/[^\n]\x08/gm,"");while(G.length<L.length);return L}function T(L){for(L=L.replace(/\r+\n/gm,`
`);L.search(/\r[^$]/g)>-1;){const G=L.match(/^(.*)\r+/m)[1];let te=L.match(/\r+(.*)$/m)[1];te=te+G.slice(te.length,G.length),L=L.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return L}const B=8,j=13;function F(L){return!L.buffer.includes(B)&&!L.buffer.includes(j)?L:u.$ue.fromString(T(z(p.decode(L.buffer))))}}),define(ke[7],Ee([1,0,19,13,79,28,101,14,18,2,30,25,32,64,119]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k){"use strict";var c,m,a,n,i,s,o,t,d,h,l,r,g,f,D,p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$oO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$bO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.TestRunProfileKind=e.TestResultState=e.$TN=e.$SN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$RN=e.NotebookVariablesRequestKind=e.$QN=e.$PN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ON=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.ColorThemeKind=e.$IN=e.$HN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$GN=e.$FN=e.DebugConsoleMode=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$zN=e.$yN=e.FileChangeType=e.$xN=e.NewSymbolNameTag=e.$wN=e.$vN=e.$uN=e.$tN=e.InlineCompletionTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$gN=e.ConfigurationTarget=e.$fN=e.$eN=e.$dN=e.$cN=e.DocumentPasteTriggerKind=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$8M=e.ViewBadge=e.ProgressLocation=e.$7M=e.$6M=e.TaskScope=e.ShellQuoting=e.$5M=e.$4M=e.$3M=e.TaskPanelKind=e.TaskRevealKind=e.$2M=e.TerminalLocation=e.$1M=e.$ZM=e.$YM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$XM=e.$WM=e.$VM=e.$UM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$SM=e.$RM=e.$QM=e.$PM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$OM=e.$NM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.LanguageStatusSeverity=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.CodeActionTriggerKind=e.$BM=e.$AM=e.SymbolTag=e.SymbolKind=e.$zM=e.$yM=e.DocumentHighlightKind=e.$xM=e.$wM=e.$vM=e.$uM=e.DiagnosticSeverity=e.DiagnosticTag=e.$tM=e.$sM=e.FileEditType=e.$rM=e.$qM=e.$pM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$TM=bt,e.$hN=qe;function y(K){return Object.assign(K,{apply:function(...pe){if(pe.length===0)return Reflect.construct(K,[]);{const Le=pe.length===1?[]:pe[1];return Reflect.construct(K,Le,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(K,[]);{const[Le,...Ze]=pe;return Reflect.construct(K,Ze,Le.constructor)}}})}var C;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var O;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let z=c=class{static from(...W){let pe=W;return new c(function(){if(pe){for(const Le of pe)Le&&typeof Le.dispose=="function"&&Le.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iM=z,e.$iM=z=c=Je([y],z);let T=m=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Le=1;Le<W.length;Le++){const Ze=W[Le];Ze.isBefore(pe)&&(pe=Ze)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Le=1;Le<W.length;Le++){const Ze=W[Le];Ze.isAfter(pe)&&(pe=Ze)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof m)return!0;const{line:pe,character:Le}=W;return typeof pe=="number"&&typeof Le=="number"}static of(W){if(W instanceof m)return W;if(this.isPosition(W))return new m(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,N.$7)("line must be non-negative");if(pe<0)throw(0,N.$7)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,N.$7)();let Le;return typeof W>"u"?Le=0:typeof W=="number"?Le=W:(Le=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Le===0&&pe===0?this:new m(this.line+Le,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,N.$7)();let Le;return typeof W>"u"?Le=this.line:typeof W=="number"?Le=W:(Le=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Le===this.line&&pe===this.character?this:new m(Le,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$jM=T,e.$jM=T=m=Je([y],T);let B=a=class{static isRange(W){return W instanceof a?!0:W?T.isPosition(W.start)&&T.isPosition(W.end):!1}static of(W){if(W instanceof a)return W;if(this.isRange(W))return new a(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Le,Ze){let it,lt;if(typeof W=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(it=new T(W,pe),lt=new T(Le,Ze)):T.isPosition(W)&&T.isPosition(pe)&&(it=T.of(W),lt=T.of(pe)),!it||!lt)throw new Error("Invalid arguments");it.isBefore(lt)?(this.c=it,this.e=lt):(this.c=lt,this.e=it)}contains(W){return a.isRange(W)?this.contains(W.start)&&this.contains(W.end):T.isPosition(W)?!(T.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=T.Max(W.start,this.c),Le=T.Min(W.end,this.e);if(!pe.isAfter(Le))return new a(pe,Le)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=T.Min(W.start,this.c),Le=T.Max(W.end,this.end);return new a(pe,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,N.$7)();let Le;return W?T.isPosition(W)?Le=W:(Le=W.start||this.start,pe=W.end||this.end):Le=this.start,Le.isEqual(this.c)&&pe.isEqual(this.end)?this:new a(Le,pe)}toJSON(){return[this.start,this.end]}};e.$kM=B,e.$kM=B=a=Je([y],B);let j=n=class extends B{static isSelection(W){return W instanceof n?!0:W?B.isRange(W)&&T.isPosition(W.anchor)&&T.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Le,Ze){let it,lt;if(typeof W=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(it=new T(W,pe),lt=new T(Le,Ze)):T.isPosition(W)&&T.isPosition(pe)&&(it=T.of(W),lt=T.of(pe)),!it||!lt)throw new Error("Invalid arguments");super(it,lt),this.f=it,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lM=j,e.$lM=j=n=Je([y],j);const F=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,N.$7)("connectionToken")};class L{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Le){if(typeof W!="string"||W.length===0)throw(0,N.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,N.$7)("port");typeof Le<"u"&&F(Le),this.host=W,this.port=Math.round(pe),this.connectionToken=Le}}e.$mM=L;class G{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&F(pe)}}e.$nM=G;class te extends Error{static NotAvailable(W,pe){return new te(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new te(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Le){super(W),this._message=W,this._code=pe,this._detail=Le,Object.setPrototypeOf(this,te.prototype)}}e.$oM=te;var Z;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var x;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(x||(e.EnvironmentVariableMutatorType=x={}));let _=i=class{static isTextEdit(W){return W instanceof i?!0:W?B.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new i(W,pe)}static insert(W,pe){return i.replace(new B(W,W),pe)}static delete(W){return i.replace(W,"")}static setEndOfLine(W){const pe=new i(new B(new T(0,0),new T(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!B.isRange(W))throw(0,N.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,N.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,N.$7)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pM=_,e.$pM=_=i=Je([y],_);let ue=s=class{static isNotebookCellEdit(W){return W instanceof s?!0:W?di.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new s(W,pe)}static insertCells(W,pe){return new s(new di(W,W),pe)}static deleteCells(W){return new s(W,[])}static updateCellMetadata(W,pe){const Le=new s(new di(W,W),[]);return Le.newCellMetadata=pe,Le}static updateNotebookMetadata(W){const pe=new s(new di(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$qM=ue,e.$qM=ue=s=Je([y],ue);class X{static isSnippetTextEdit(W){return W instanceof X?!0:W?B.isRange(W.range)&&re.isSnippetString(W.snippet):!1}static replace(W,pe){return new X(W,pe)}static insert(W,pe){return X.replace(new B(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$rM=X;var $e;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Le,Ze){this.c.push({_type:1,from:W,to:pe,options:Le,metadata:Ze})}createFile(W,pe,Le){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Le})}deleteFile(W,pe,Le){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Le})}e(W,pe,Le){this.c.push({_type:3,metadata:Le,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Le,Ze){const it=pe.start,lt=pe.end;(it!==lt||Le.length>0)&&this.c.push({_type:5,uri:W,index:it,count:lt-it,cells:Le,metadata:Ze})}g(W,pe,Le,Ze){this.c.push({_type:3,metadata:Ze,uri:W,edit:{editType:3,index:pe,metadata:Le}})}replace(W,pe,Le,Ze){this.c.push({_type:2,uri:W,edit:new _(pe,Le),metadata:Ze})}insert(W,pe,Le,Ze){this.replace(W,new B(pe,pe),Le,Ze)}delete(W,pe,Le){this.replace(W,pe,"",Le)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Le of pe){if(!Le)continue;let Ze,it;Array.isArray(Le)?(Ze=Le[0],it=Le[1]):Ze=Le,ue.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(W,Ze.range.start,Ze.newCellMetadata,it):Ze.newNotebookMetadata?this.e(W,Ze.newNotebookMetadata,it):this.f(W,Ze.range,Ze.newCells,it):X.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:W,range:Ze.range,edit:Ze.snippet,metadata:it}):this.c.push({_type:2,uri:W,edit:Ze,metadata:it})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===W.toString()&&(this.c[Le]=void 0);break}}(0,u.$Ib)(this.c)}}get(W){const pe=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===W.toString()&&pe.push(Le.edit);return pe}entries(){const W=new P.$Bc;for(const pe of this.c)if(pe._type===2){let Le=W.get(pe.uri);Le||(Le=[pe.uri,[]],W.set(pe.uri,Le)),Le[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sM=se,e.$sM=se=Je([y],se);let re=o=class{static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=o.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Le=new o;Le.e=this.e,W(Le),this.e=Le.e,W=Le.value}else W=o.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Le=W.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Le=new o;Le.e=this.e,pe(Le),this.e=Le.e,pe=Le.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$tM=re,e.$tM=re=o=Je([y],re);var U;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ie;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ve=t=class{static isLocation(W){return W instanceof t?!0:W?B.isRange(W.range)&&E.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(B.isRange(pe))this.range=B.of(pe);else if(T.isPosition(pe))this.range=new B(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uM=ve,e.$uM=ve=t=Je([y],ve);let Ie=class{static is(W){return W?typeof W.message=="string"&&W.location&&B.isRange(W.location.range)&&E.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$vM=Ie,e.$vM=Ie=Je([y],Ie);let le=class{constructor(W,pe,Le=ie.Error){if(!B.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Le}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,u.$ub)(W.tags,pe.tags)&&(0,u.$ub)(W.relatedInformation,pe.relatedInformation,Ie.isEqual)}};e.$wM=le,e.$wM=le=Je([y],le);let ae=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$xM=ae,e.$xM=ae=Je([y],ae);var ce;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ce||(e.DocumentHighlightKind=ce={}));let H=class{constructor(W,pe=ce.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:ce[this.kind]}}};e.$yM=H,e.$yM=H=Je([y],H);let Q=class{constructor(W,pe){this.uri=W,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(W=>W.toJSON())}}};e.$zM=Q,e.$zM=Q=Je([y],Q);var he;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var fe;(function(K){K[K.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Pe=d=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Le,Ze,it){this.name=W,this.kind=pe,this.containerName=it,typeof Le=="string"&&(this.containerName=Le),Ze instanceof ve?this.location=Ze:Le instanceof B&&(this.location=new ve(Ze,Le)),d.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$AM=Pe,e.$AM=Pe=d=Je([y],Pe);let be=h=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(h.validate)}constructor(W,pe,Le,Ze,it){this.name=W,this.detail=pe,this.kind=Le,this.range=Ze,this.selectionRange=it,this.children=[],h.validate(this)}};e.$BM=be,e.$BM=be=h=Je([y],be);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Ae||(e.CodeActionTriggerKind=Ae={}));let Ne=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$CM=Ne,e.$CM=Ne=Je([y],Ne);let Be=class{static{l=this}static{this.c="."}constructor(W){this.value=W}append(W){return new l(this.value?this.value+l.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+l.c)}};e.$DM=Be,e.$DM=Be=l=Je([y],Be),Be.Empty=new Be(""),Be.QuickFix=Be.Empty.append("quickfix"),Be.Refactor=Be.Empty.append("refactor"),Be.RefactorExtract=Be.Refactor.append("extract"),Be.RefactorInline=Be.Refactor.append("inline"),Be.RefactorMove=Be.Refactor.append("move"),Be.RefactorRewrite=Be.Refactor.append("rewrite"),Be.Source=Be.Empty.append("source"),Be.SourceOrganizeImports=Be.Source.append("organizeImports"),Be.SourceFixAll=Be.Source.append("fixAll"),Be.Notebook=Be.Empty.append("notebook");let V=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$EM=V,e.$EM=V=Je([y],V);class q{constructor(W,pe,Le,Ze,it,lt){this.kind=W,this.name=pe,this.detail=Le,this.uri=Ze,this.range=it,this.selectionRange=lt}}e.$FM=q;class Y{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$GM=Y;class J{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$HM=J;var ge;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(ge||(e.LanguageStatusSeverity=ge={}));let we=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$IM=we,e.$IM=we=Je([y],we);let Te=r=class{#e;static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new M.$Ek(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$JM=Te,e.$JM=Te=r=Je([y],Te);let He=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$KM=He,e.$KM=He=Je([y],He);let Xe=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$LM=Xe,e.$LM=Xe=Je([y],Xe);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$MM=tt,e.$MM=tt=Je([y],tt);var nt;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var at;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let rt=class{constructor(W){this.value=W}};e.$NM=rt,e.$NM=rt=Je([y],rt);let Ce=class{constructor(W,pe,Le){this.position=W,this.label=pe,this.kind=Le}};e.$OM=Ce,e.$OM=Ce=Je([y],Ce);var ze;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var Me;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Me||(e.CompletionItemKind=Me={}));var Ge;(function(K){K[K.Deprecated=1]="Deprecated"})(Ge||(e.CompletionItemTag=Ge={}));let ne=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$PM=ne,e.$PM=ne=Je([y],ne);let oe=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$QM=oe,e.$QM=oe=Je([y],oe);let De=class{constructor(W,pe,Le){this.insertText=W,this.range=pe,this.command=Le}};e.$RM=De,e.$RM=De=Je([y],De);let Ke=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$SM=Ke,e.$SM=Ke=Je([y],Ke);var xe;(function(K){K[K.Unknown=0]="Unknown",K[K.Word=1]="Word",K[K.Line=2]="Line",K[K.Suggest=3]="Suggest"})(xe||(e.PartialAcceptTriggerKind=xe={}));var st;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var je;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(je||(e.StatusBarAlignment=je={}));function bt(K,W){return`${I.$Cm.toKey(K)}.${W}`}var vt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})(vt||(e.TextEditorLineNumbersStyle=vt={}));var Lt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var Bt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Bt||(e.TextEditorRevealType=Bt={}));var Ut;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Ct;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Ct||(e.TextDocumentChangeReason=Ct={}));var ti;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(ti||(e.DecorationRangeBehavior=ti={})),function(K){function W(pe){switch(pe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=W}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Wt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(K){function W(pe){switch(pe){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=W}(Wt||(e.SyntaxTokenType=Wt={}));let ri=class{constructor(W,pe){if(pe&&!E.URI.isUri(pe))throw(0,N.$7)("target");if(!B.isRange(W)||W.isEmpty)throw(0,N.$7)("range");this.range=W,this.target=pe}};e.$UM=ri,e.$UM=ri=Je([y],ri);let ii=class{constructor(W,pe,Le,Ze){this.red=W,this.green=pe,this.blue=Le,this.alpha=Ze}};e.$VM=ii,e.$VM=ii=Je([y],ii);let et=class{constructor(W,pe){if(pe&&!(pe instanceof ii))throw(0,N.$7)("color");if(!B.isRange(W)||W.isEmpty)throw(0,N.$7)("range");this.range=W,this.color=pe}};e.$WM=et,e.$WM=et=Je([y],et);let Xt=class{constructor(W){if(!W||typeof W!="string")throw(0,N.$7)("label");this.label=W}};e.$XM=Xt,e.$XM=Xt=Je([y],Xt);var qt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var ht;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ht||(e.SourceControlInputBoxValidationType=ht={}));var mt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(mt||(e.TerminalExitReason=mt={}));class ni{constructor(W,pe,Le){if(this.startIndex=W,this.length=pe,this.tooltip=Le,typeof W!="number"||W<0)throw(0,N.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,N.$7)("length");if(Le!==void 0&&typeof Le!="string")throw(0,N.$7)("tooltip")}}e.$YM=ni;class Vt{constructor(W){this.uri=W}}e.$ZM=Vt;class Ht{constructor(W){this.terminalCommand=W}}e.$1M=Ht;var dt;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(dt||(e.TerminalLocation=dt={}));class It{constructor(W){if(this.options=W,typeof W!="object")throw(0,N.$7)("options")}}e.$2M=It;var si;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(si||(e.TaskRevealKind=si={}));var _t;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let Ye=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(W){switch(W){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,N.$7)("name");this.c=W}get id(){return this.c}};e.$3M=Ye,e.$3M=Ye=g=Je([y],Ye);function Gt(K){let W="";for(let pe=0;pe<K.length;pe++)W+=K[pe].replace(/,/g,",,")+",";return W}let zt=class{constructor(W,pe,Le){if(typeof W!="string")throw(0,N.$7)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Le):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,N.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Gt(W)}};e.$4M=zt,e.$4M=zt=Je([y],zt);let Kt=class{constructor(W,pe,Le){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,N.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,N.$7)("command");this.e=W,this.f=pe,this.g=Le}else{if(typeof W!="string")throw(0,N.$7)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,N.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,N.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Gt(W)}};e.$5M=Kt,e.$5M=Kt=Je([y],Kt);var $t;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var At;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(At||(e.TaskScope=At={}));class Rt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$Dg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$6M=Rt;let jt=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Le,Ze,it,lt){this.k=!1,this.l=this.definition=W;let gt;typeof pe=="string"?(this.o=this.name=pe,this.w=this.source=Le,this.execution=Ze,gt=it,this.k=!0):pe===At.Global||pe===At.Workspace?(this.target=pe,this.o=this.name=Le,this.w=this.source=Ze,this.execution=it,gt=lt):(this.target=pe,this.o=this.name=Le,this.w=this.source=Ze,this.execution=it,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(W){this.j=W}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof zt?this.l={type:f.e,id:this.q.computeId()}:this.q instanceof Kt?this.l={type:f.f,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:f.c,id:this.q.computeId()}:this.l={type:f.g,id:(0,R.$Dg)()}}get definition(){return this.l}set definition(W){if(W==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=W}get scope(){return this.m}set target(W){this.B(),this.m=W}get name(){return this.o}set name(W){if(typeof W!="string")throw(0,N.$7)("name");this.B(),this.o=W}get execution(){return this.q}set execution(W){W===null&&(W=void 0),this.B(),this.q=W;const pe=this.l.type;(f.g===pe||f.e===pe||f.f===pe||f.c===pe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(W){if(Array.isArray(W))this.B(),this.r=W,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.B(),this.u=W}get source(){return this.w}set source(W){if(typeof W!="string"||W.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=W}get group(){return this.x}set group(W){W===null&&(W=void 0),this.B(),this.x=W}get detail(){return this.A}set detail(W){W===null&&(W=void 0),this.A=W}get presentationOptions(){return this.y}set presentationOptions(W){W==null&&(W=Object.create(null)),this.B(),this.y=W}get runOptions(){return this.z}set runOptions(W){W==null&&(W=Object.create(null)),this.B(),this.z=W}};e.$7M=jt,e.$7M=jt=f=Je([y],jt);var oi;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var Jt;(function(K){function W(pe){const Le=pe;return(0,$.$Yf)(Le.value)?Le.tooltip&&!(0,$.$Uf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=W})(Jt||(e.ViewBadge=Jt={}));let Yt=D=class{static isTreeItem(W,pe){const Le=W;if(Le.checkboxState!==void 0){const Ze=(0,$.$Yf)(Le.checkboxState)?Le.checkboxState:(0,$.$Wf)(Le.checkboxState)&&(0,$.$Yf)(Le.checkboxState.state)?Le.checkboxState.state:void 0,it=!(0,$.$Yf)(Le.checkboxState)&&(0,$.$Wf)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Mt.Checked&&Ze!==Mt.Unchecked||it!==void 0&&!(0,$.$Uf)(it))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(W instanceof D)return!0;if(Le.label!==void 0&&!(0,$.$Uf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$Uf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$Uf)(Le.iconPath)&&!E.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$Uf)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,$.$Uf)(Ze.light)&&!E.URI.isUri(Ze.light)&&!(0,$.$Uf)(Ze.dark)&&!E.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$Uf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!E.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$Uf)(Le.tooltip)&&!(Le.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<Et.None&&Le.collapsibleState>Et.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$Uf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(W,pe=Et.None){this.collapsibleState=pe,E.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$8M=Yt,e.$8M=Yt=D=Je([y],Yt);var Et;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Et||(e.TreeItemCollapsibleState=Et={}));var Mt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Mt||(e.TreeItemCheckboxState=Mt={}));let Qt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$9M=Qt,e.$9M=Qt=Je([y],Qt);class Ft extends Qt{}e.$0M=Ft;class St extends Ft{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$$M=St;class Pt{constructor(W,pe,Le,Ze){this.name=W,this.uri=pe,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$_M=Pt;let Dt=class{#e=new Map;constructor(W){for(const[pe,Le]of W??[]){const Ze=this.#e.get(this.#t(pe));Ze?Ze.push(Le):this.#e.set(this.#t(pe),[Le])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Le,Ze]of this.#e)for(const it of Ze)W.call(pe,it,Le,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Le of pe)yield[W,Le]}#t(W){return W.toLowerCase()}};e.$aN=Dt,e.$aN=Dt=Je([y],Dt);let li=class{constructor(W,pe,Le){this.insertText=W,this.title=pe,this.kind=Le}};e.$bN=li,e.$bN=li=Je([y],li);var ei;(function(K){K[K.Automatic=0]="Automatic",K[K.PasteAs=1]="PasteAs"})(ei||(e.DocumentPasteTriggerKind=ei={}));class ai{static{this.c="."}constructor(W){this.value=W}append(...W){return new ai((this.value?[this.value,...W]:W).join(ai.c))}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+ai.c)}}e.$cN=ai,ai.Empty=new ai("");let hi=class{constructor(W,pe,Le){this.title=pe,this.insertText=W,this.kind=Le}};e.$dN=hi,e.$dN=hi=Je([y],hi);let Re=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$eN=Re,e.$eN=Re=Je([y],Re),Re.File=new Re("file"),Re.Folder=new Re("folder");let Fe=class{constructor(W){this.id=W}};e.$fN=Fe,e.$fN=Fe=Je([y],Fe);var Se;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Se||(e.ConfigurationTarget=Se={}));let ee=class{get base(){return this.c}set base(W){this.c=W,this.e=E.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!E.URI.isUri(W)&&!E.URI.isUri(W.uri)))throw(0,N.$7)("base");if(typeof pe!="string")throw(0,N.$7)("pattern");typeof W=="string"?this.baseUri=E.URI.file(W):E.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$gN=ee,e.$gN=ee=Je([y],ee);const Oe=new WeakMap;function qe(K,W){Oe.set(K,W)}let _e=class{constructor(W,pe,Le,Ze,it){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Oe.get(this)??(0,R.$Dg)()),this.c}};e.$iN=_e,e.$iN=_e=Je([y],_e);let Qe=class extends _e{constructor(W,pe,Le,Ze,it,lt){if(super(pe,Le,Ze,it,lt),W===null)throw(0,N.$7)("location");this.location=W}};e.$jN=Qe,e.$jN=Qe=Je([y],Qe);let ut=class extends _e{constructor(W,pe,Le,Ze,it,lt){super(pe,Le,Ze,it,lt),this.functionName=W}};e.$kN=ut,e.$kN=ut=Je([y],ut);let yt=class extends _e{constructor(W,pe,Le,Ze,it,lt,gt,Zt){if(super(Ze,it,lt,gt,Zt),!pe)throw(0,N.$7)("dataId");this.label=W,this.dataId=pe,this.canPersist=Le}};e.$lN=yt,e.$lN=yt=Je([y],yt);let kt=class{constructor(W,pe,Le){this.command=W,this.args=pe||[],this.options=Le}};e.$mN=kt,e.$mN=kt=Je([y],kt);let xt=class{constructor(W,pe){this.port=W,this.host=pe}};e.$nN=xt,e.$nN=xt=Je([y],xt);let Ot=class{constructor(W){this.path=W}};e.$oN=Ot,e.$oN=Ot=Je([y],Ot);let Tt=class{constructor(W){this.implementation=W}};e.$pN=Tt,e.$pN=Tt=Je([y],Tt);class yi{constructor(W,pe,Le){this.session=W,this.threadId=pe,this.frameId=Le}}e.$qN=yi;class ft{constructor(W,pe){this.session=W,this.threadId=pe}}e.$rN=ft;let Ri=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$sN=Ri,e.$sN=Ri=Je([y],Ri);var gi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let pi=class{constructor(W,pe){this.range=W,this.text=pe}};e.$tN=pi,e.$tN=pi=Je([y],pi);let ki=class{constructor(W,pe,Le=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Le}};e.$uN=ki,e.$uN=ki=Je([y],ki);let Mi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$vN=Mi,e.$vN=Mi=Je([y],Mi);let Oi=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$wN=Oi,e.$wN=Oi=Je([y],Oi);var Ji;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Ji||(e.NewSymbolNameTag=Ji={}));class Yi{constructor(W,pe){this.newSymbolName=W,this.tags=pe}}e.$xN=Yi;var Qi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ei=p=class extends Error{static FileExists(W){return new p(W,w.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(W){return new p(W,w.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(W){return new p(W,w.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(W){return new p(W,w.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(W){return new p(W,w.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(W){return new p(W,w.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(W,pe=w.FileSystemProviderErrorCode.Unknown,Le){super(E.URI.isUri(W)?W.toString(!0):W),this.code=Le?.name??"Unknown",(0,w.$3k)(this,pe),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$yN=Ei,e.$yN=Ei=p=Je([y],Ei);let Ni=class{constructor(W,pe,Le){this.start=W,this.end=pe,this.kind=Le}};e.$zN=Ni,e.$zN=Ni=Je([y],Ni);var Si;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Si||(e.FoldingRangeKind=Si={}));var Di;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Di||(e.CommentThreadCollapsibleState=Di={}));var Zi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Xi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var wi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class ln{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$AN=ln;function hn(K){return typeof K>"u"||(0,$.$Vf)(K)}class Li{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,W){this.m=!0;for(let pe=0,Le=W.tokenTypes.length;pe<Le;pe++)this.k.set(W.tokenTypes[pe],pe);for(let pe=0,Le=W.tokenModifiers.length;pe<Le;pe++)this.l.set(W.tokenModifiers[pe],pe)}}push(W,pe,Le,Ze,it){if(typeof W=="number"&&typeof pe=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(W,pe,Le,Ze,it);if(B.isRange(W)&&typeof pe=="string"&&hn(Le))return this.o(W,pe,Le);throw(0,N.$7)()}o(W,pe,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,it=W.start.character,lt=W.end.character-W.start.character,gt=this.k.get(pe);let Zt=0;if(Le)for(const ui of Le){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ui);Zt|=1<<fi>>>0}this.q(Ze,it,lt,gt,Zt)}q(W,pe,Le,Ze,it){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const Zt=this.g.length/5|0;let ui=0,fi=0;for(let $i=0;$i<Zt;$i++){let bi=this.g[5*$i],Gi=this.g[5*$i+1];bi===0?(bi=ui,Gi+=fi):bi+=ui,this.g[5*$i]=bi,this.g[5*$i+1]=Gi,ui=bi,fi=Gi}}let lt=W,gt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=it,this.c=W,this.e=pe}static r(W){const pe=[],Le=W.length/5|0;for(let gt=0;gt<Le;gt++)pe[gt]=gt;pe.sort((gt,Zt)=>{const ui=W[5*gt],fi=W[5*Zt];if(ui===fi){const $i=W[5*gt+1],bi=W[5*Zt+1];return $i-bi}return ui-fi});const Ze=new Uint32Array(W.length);let it=0,lt=0;for(let gt=0;gt<Le;gt++){const Zt=5*pe[gt],ui=W[Zt+0],fi=W[Zt+1],$i=W[Zt+2],bi=W[Zt+3],Gi=W[Zt+4],Mn=ui-it,ir=Mn===0?fi-lt:fi,Ki=5*gt;Ze[Ki+0]=Mn,Ze[Ki+1]=ir,Ze[Ki+2]=$i,Ze[Ki+3]=bi,Ze[Ki+4]=Gi,it=ui,lt=fi}return Ze}build(W){return this.f?new ji(new Uint32Array(this.g),W):new ji(Li.r(this.g),W)}}e.$BN=Li;class ji{constructor(W,pe){this.resultId=pe,this.data=W}}e.$CN=ji;class dn{constructor(W,pe,Le){this.start=W,this.deleteCount=pe,this.data=Le}}e.$DN=dn;class xi{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$EN=xi;var Fi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Fi||(e.DebugConsoleMode=Fi={}));class fn{constructor(W){this.name=W}}e.$FN=fn;let Ci=class{static{this.Back={iconPath:new Re("arrow-left")}}constructor(){}};e.$GN=Ci,e.$GN=Ci=Je([y],Ci);var Ti;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ti||(e.QuickPickItemKind=Ti={}));var _i;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var en;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(en||(e.ExtensionKind=en={}));class gn{static validate(W){if(typeof W.badge=="string"){let pe=(0,b.$vf)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,b.$vf)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Re.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Le){this.badge=W,this.tooltip=pe,this.color=Le}}e.$HN=gn;let Bi=class{constructor(W){this.kind=W}};e.$IN=Bi,e.$IN=Bi=Je([y],Bi);var Ii;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Ii||(e.ColorThemeKind=Ii={}));class di{static isNotebookRange(W){return W instanceof di?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,N.$7)("start must be positive");if(pe<0)throw(0,N.$7)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Le=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Le=W.end),pe===this.c&&Le===this.e?this:new di(pe,Le)}}e.$JN=di;class Ue{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>Ue.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Le,Ze,it,lt,gt){this.kind=W,this.value=pe,this.languageId=Le,this.mime=Ze,this.outputs=it??[],this.metadata=lt,this.executionSummary=gt,Ue.validate(this)}}e.$KN=Ue;class mi{constructor(W){this.cells=W}}e.$LN=mi;class ci{static isNotebookCellOutputItem(W){return W instanceof ci?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return ci.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return ci.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return ci.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new ci(W,pe)}static#e=new TextEncoder;static text(W,pe=A.$xs.text){const Le=ci.#e.encode(String(W));return new ci(Le,pe)}static json(W,pe="text/x-json"){const Le=JSON.stringify(W,void 0,"	");return ci.text(Le,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Le=(0,A.$Bs)(pe,!0);if(!Le)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$MN=ci;class ot{static isNotebookCellOutput(W){return W instanceof ot?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Le=new Set,Ze=new Set;for(let it=0;it<W.length;it++){const lt=W[it],gt=(0,A.$Bs)(lt.mime);if(!Le.has(gt)||(0,k.$dK)(gt)){Le.add(gt);continue}Ze.add(it),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?W:W.filter((it,lt)=>!Ze.has(lt))}constructor(W,pe,Le){this.items=ot.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Le):(this.id=(0,R.$Dg)(),this.metadata=pe??Le)}}e.$NN=ot;var pt;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(pt||(e.NotebookCellKind=pt={}));var tn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var zi;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(zi||(e.NotebookEditorRevealType=zi={}));class mn{constructor(W,pe){this.text=W,this.alignment=pe}}e.$ON=mn;var vi;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(vi||(e.NotebookControllerAffinity=vi={}));var rn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class $n{constructor(W,pe=[]){this.uri=W,this.provides=(0,u.$3b)(pe)}}e.$PN=$n;class pn{constructor(W){this.label=W}}e.$QN=pn;var Ui;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(Ui||(e.NotebookVariablesRequestKind=Ui={}));let Wi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$RN=Wi,e.$RN=Wi=Je([y],Wi);var sn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(sn||(e.ExtensionMode=sn={}));var on;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(on||(e.ExtensionRuntime=on={}));var an;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class bn{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$SN=bn;class wn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$TN=wn;var cn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let qi=class{constructor(W=void 0,pe=void 0,Le=void 0,Ze=!1){this.include=W,this.exclude=pe,this.profile=Le,this.continuous=Ze}};e.$UN=qi,e.$UN=qi=Je([y],qi);let Vi=v=class{static diff(W,pe,Le){const Ze=new v(W);return Ze.expectedOutput=pe,Ze.actualOutput=Le,Ze}constructor(W){this.message=W}};e.$VN=Vi,e.$VN=Vi=v=Je([y],Vi);let Hi=class{constructor(W){this.id=W}};e.$WN=Hi,e.$WN=Hi=Je([y],Hi);class me{constructor(W,pe){this.covered=W,this.total=pe}}e.$XN=me;const ye=K=>{if(K&&K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`)};class We{static fromDetails(W,pe){const Le=new me(0,0),Ze=new me(0,0),it=new me(0,0);for(const gt of pe)if("branches"in gt){Le.total+=1,Le.covered+=gt.executed?1:0;for(const Zt of gt.branches)Ze.total+=1,Ze.covered+=Zt.executed?1:0}else it.total+=1,it.covered+=gt.executed?1:0;const lt=new We(W,Le,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return lt.detailedCoverage=pe,lt}constructor(W,pe,Le,Ze){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Le,this.declarationCoverage=Ze,ye(pe),ye(Le),ye(Ze)}}e.$YN=We;class ct{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,pe,Le=[]){this.executed=W,this.location=pe,this.branches=Le}}e.$ZN=ct;class wt{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,pe,Le){this.executed=W,this.location=pe,this.label=Le}}e.$1N=wt;class Nt{get executionCount(){return+this.executed}set executionCount(W){this.executed=W}constructor(W,pe,Le){this.name=W,this.executed=pe,this.location=Le}}e.$2N=Nt;var Pi;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Pi||(e.ExternalUriOpenerPriority=Pi={}));var vn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var yn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn||(e.PortAutoForwardAction=yn={}));class On{constructor(W,pe,Le,Ze,it,lt){this.kind=W,this.name=pe,this.detail=Le,this.uri=Ze,this.range=it,this.selectionRange=lt}}e.$3N=On;class Nn{constructor(W){this.uri=W}}e.$4N=Nn;class Ln{constructor(W,pe){this.original=W,this.modified=pe}}e.$5N=Ln;class jn{constructor(W,pe,Le,Ze){this.base=W,this.input1=pe,this.input2=Le,this.result=Ze}}e.$6N=jn;class Fn{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$7N=Fn;class Tn{constructor(W){this.viewType=W}}e.$8N=Tn;class Bn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$9N=Bn;class zn{constructor(W,pe,Le){this.original=W,this.modified=pe,this.notebookType=Le}}e.$0N=zn;class Un{constructor(){}}e.$$N=Un;class Wn{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$_N=Wn;class qn{constructor(W){this.providerId=W}}e.$aO=qn;var kn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var En;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var Sn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Vn{constructor(W,pe){this.label=W,this.values=pe}}e.$bO=Vn;var Dn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Cn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Hn{constructor(W){this.value=typeof W=="string"?new Te(W):W}}e.$cO=Hn;class Gn{constructor(W,pe){this.value=W,this.baseUri=pe}}e.$dO=Gn;class Kn{constructor(W,pe){this.value=W,this.title=pe}}e.$eO=Kn;class Jn{constructor(W){this.value=W}}e.$fO=Jn;class Yn{constructor(W){this.value=W}}e.$gO=Yn;class Qn{constructor(W){this.value=W}}e.$hO=Qn;class Zn{constructor(W,pe,Le,Ze){this.prompt=W,this.command=pe,this.variables=Le,this.participant=Ze}}e.$iO=Zn;class Xn{constructor(W,pe,Le,Ze){this.response=W,this.result=pe,this.participant=Le,this.command=Ze}}e.$jO=Xn;class xn{constructor(W){this.content=W}}e.$kO=xn;class _n{constructor(W,pe){this.content=W,this.name=pe}}e.$lO=_n;class er{constructor(W){this.content=W}}e.$mO=er;class Ai extends Error{static NotFound(W){return new Ai(W,Ai.NotFound.name)}static NoPermissions(W){return new Ai(W,Ai.NoPermissions.name)}constructor(W,pe,Le){super(W,{cause:Le}),this.name="LanguageModelError",this.code=pe??""}}e.$nO=Ai;var In;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(In||(e.RelatedInformationType=In={}));var Pn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Pn||(e.SpeechToTextStatus=Pn={}));var An;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class tr{constructor(W,pe){this.text=W,this.range=pe}}e.$oO=tr;var Rn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(ke[321],Ee([1,0,6,7]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(u.$gM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(A);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,$)??[]}getRelatedInformation(A,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(A,b,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiRelatedInformationProvider(E,b),new N.$iM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Bic=M}),define(ke[120],Ee([1,0,4,6,7,25,145,5,20]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0,e.$Mic=(0,b.$hi)("IExtHostAuthentication");let E=class{constructor(w){this.b=new Map,this.c=new u.$7d,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=w.getProxy(N.$gM.MainThreadAuthentication)}async getSession(w,S,k,c={}){const m=P.$Cm.toKey(w.identifier),a=[...k].sort().join(" ");return await this.d.getOrCreate(`${m} ${S} ${a}`,async()=>{await this.a.$ensureProvider(S);const n=w.displayName||w.name;return this.a.$getSession(S,k,m,n,c)})}async getSessions(w,S,k){const c=P.$Cm.toKey(w.identifier),m=[...k].sort().join(" ");return await this.f.getOrCreate(`${c} ${m}`,async()=>{await this.a.$ensureProvider(S);const a=w.displayName||w.name;return this.a.$getSessions(S,k,c,a)})}async removeSession(w,S){const k=this.b.get(w);return k?k.provider.removeSession(S):this.a.$removeSession(w,S)}registerAuthenticationProvider(w,S,k,c){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:S,provider:k,options:c??{supportsMultipleAccounts:!1}});const m=k.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(w,a));return this.a.$registerAuthenticationProvider(w,S,c?.supportsMultipleAccounts??!1),new M.$iM(()=>{m.dispose(),this.b.delete(w),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,S,k){const c=this.b.get(w);if(c)return Promise.resolve(c.provider.createSession(S,k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,S){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,S){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,S){return w.startsWith(A.$iL)||this.c.fire({provider:{id:w,label:S}}),Promise.resolve()}};e.$Nic=E,e.$Nic=E=Je([Ve(0,$.$AO)],E);class R{constructor(){this.a=new Map}getOrCreate(w,S){const k=this.a.get(w);if(k)return k;const c=S().finally(()=>this.a.delete(w));return this.a.set(w,c),c}}}),define(ke[151],Ee([1,0,2,6,7,5,20,12,19,14,17,26]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=e.$Njc=void 0;let S=class{static{w=this}static{this.c=0}static{this.d=250}constructor(c,m){this.h=m,this.f=new Map,this.g=c.getProxy(N.$gM.MainThreadDecorations)}registerFileDecorationProvider(c,m){const a=w.c++;this.f.set(a,{provider:c,extensionDescription:m}),this.g.$registerDecorationProvider(a,m.identifier.value);const n=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const s=(0,$.$3b)(i);if(s.length<=w.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,s.length);const o=s.map(h=>({uri:h,rank:(0,E.$1e)(h.path,"/")})),t=(0,$.$zb)(o,(h,l)=>h.rank-l.rank||(0,E.$ef)(h.uri.path,l.uri.path)),d=[];e:for(const h of t){let l;for(const r of h){const g=(0,R.$nc)(r.uri.path);if(l!==g&&(l=g,d.push(r.uri)>=w.d))break e}}this.g.$onDidChange(a,d)});return new M.$iM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(c,m,a){if(!this.f.has(c))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:s}=this.f.get(c);return await Promise.all(m.map(async o=>{try{const{uri:t,id:d}=o,h=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),a));if(!h)return;try{M.$HN.validate(h),h.badge&&typeof h.badge!="string"&&(0,I.$6F)(s,"codiconDecoration"),n[d]=[h.propagate,h.tooltip,h.badge,h.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$Njc=S,e.$Njc=S=w=Je([Ve(0,A.$AO),Ve(1,b.$Nj)],S),e.$Ojc=(0,P.$hi)("IExtHostDecorations")}),define(ke[322],Ee([1,0,13,2,7,6,15,22,14]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class E{static{this.a=0}constructor(I,w,S){this.d=w,this.e=S,this.b=new Map,this.c=I.getProxy(P.$gM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=E.a++;this.b.set(S,w),this.c.$registerTextContentProvider(S,I);let k;if(typeof w.onDidChange=="function"){let c;k=w.onDidChange(async m=>{if(m.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;c&&await c;const a=this.$provideTextDocumentContent(S,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const s=(0,$.$$e)(n);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{c===a&&(c=void 0)});c=a})}return new M.$iM(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(I,w){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(N.URI.revive(w),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$Qjc=E}),define(ke[152],Ee([1,0,61,15,14,182,129,7,19]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=e.$DO=void 0,e.$CO=R;const E=new Map;function R(k,c){c?E.set(k,c):E.delete(k)}function I(k){return E.get(k)}class w extends P.$Fv{constructor(c,m,a,n,i,s,o){super(m,a,n,i),this.c=c,this.m=s,this.q=o,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===N.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(m){return m?c.s(m):c.getText()},get eol(){return c.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(m){return c.t(m)},offsetAt(m){return c.u(m)},positionAt(m){return c.v(m)},validateRange(m){return c.w(m)},validatePosition(m){return c.x(m)},getWordRangeAtPosition(m,a){return c.y(m,a)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,u.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,u.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const m=this.w(c);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const a=this.g,n=m.start.line,i=m.end.line,s=[];s.push(this.f[n].substring(m.start.character));for(let o=n+1;o<i;o++)s.push(this.f[o]);return s.push(this.f[i].substring(0,m.end.character)),s.join(a)}t(c){let m;if(c instanceof b.$jM?m=c.line:typeof c=="number"&&(m=c),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new S(m,this.f[m],m===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const m=this.j.getIndexOf(c),a=this.f[m.index].length;return new b.$jM(m.index,Math.min(m.remainder,a))}w(c){if(!(c instanceof b.$kM))throw new Error("Invalid argument");const m=this.x(c.start),a=this.x(c.end);return m===c.start&&a===c.end?c:new b.$kM(m.line,m.character,a.line,a.character)}x(c){if(!(c instanceof b.$jM))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:m,character:a}=c,n=!1;if(m<0)m=0,a=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,a=this.f[m].length,n=!0;else{const i=this.f[m].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new b.$jM(m,a):c}y(c,m){const a=this.x(c);if(!m)m=I(this.m);else if((0,M.$0e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,A.$Ps)(a.character+1,(0,A.$Ns)(m),this.f[a.line],0);if(n)return new b.$kM(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$DO=w;class S{constructor(c,m,a){this.a=c,this.b=m,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$kM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$kM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EO=S}),define(ke[323],Ee([1,0,6,7]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(u.$gM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(A);if(!E)throw new Error("Embedding vector provider not found");const R=await E.provideEmbeddingVector(b,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,b,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiEmbeddingVectorProvider(b,E),new N.$iM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$Sjc=M}),define(ke[68],Ee([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0;let k=S=class{constructor(m,a){this.b=new Map,this.c=new R.$qh,this.a=m.getProxy(u.$gM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let s;const o=n.b.get(i.scheme);return o?(await n.a.$ensureActivation(i.scheme),s=await o.impl.stat(i)):s=await n.a.$stat(i),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===N.FilePermission.Readonly?1:void 0}}catch(s){S.e(s)}},async readDirectory(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(s){return S.e(s)}},async createDirectory(i){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,i)):await n.a.$mkdir(i)}catch(s){return S.e(s)}},async readFile(i){try{const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),(await s.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(s){return S.e(s)}},async writeFile(i,s){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(o.impl,o.extUri,o.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(o.impl.writeFile(i,s,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,P.$ue.wrap(s))}catch(o){return S.e(o)}},async delete(i,s){try{const o=n.b.get(i.scheme);return o&&!o.isReadonly&&!s?.useTrash?(await n.a.$ensureActivation(i.scheme),await o.impl.delete(i,{recursive:!1,...s})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(o){return S.e(o)}},async rename(i,s,o){try{return await n.a.$rename(i,s,{overwrite:!1,...o})}catch(t){return S.e(t)}},async copy(i,s,o){try{return await n.a.$copy(i,s,{overwrite:!1,...o})}catch(t){return S.e(t)}},isWritableFileSystem(i){const s=a.getCapabilities(i);if(typeof s=="number")return!(s&2048)}})}async d(m,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await m.stat(n)).type&N.FileType.Directory))throw M.$yN.FileExists(`Unable to create folder '${n.scheme===w.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(N.$4k(s)!==N.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(a.basename(n)),n=a.dirname(n)}for(let s=i.length-1;s>=0;s--){n=a.joinPath(n,i[s]);try{await m.createDirectory(n)}catch(o){if(N.$4k(o)!==N.FileSystemProviderErrorCode.FileExists)throw o}}}static e(m){if(m instanceof M.$yN)throw m;if(m instanceof N.$Zk)switch(m.code){case N.FileSystemProviderErrorCode.FileExists:throw M.$yN.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw M.$yN.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw M.$yN.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw M.$yN.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw M.$yN.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw M.$yN.Unavailable(m.message);default:throw new M.$yN(m.message,m.name)}if(!(m instanceof Error))throw new M.$yN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw M.$yN.Unavailable(m.message);switch(m.name){case N.FileSystemProviderErrorCode.FileExists:throw M.$yN.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw M.$yN.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw M.$yN.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw M.$yN.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw M.$yN.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw M.$yN.Unavailable(m.message);default:throw new M.$yN(m.message,m.name)}}addFileSystemProvider(m,a,n){return this.b.set(m,{impl:a,extUri:n?.isCaseSensitive?I.$Kg:I.$Mg,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??I.$Kg}};e.$6ic=k,e.$6ic=k=S=Je([Ve(0,b.$AO),Ve(1,$.$Gic)],k),e.$7ic=(0,A.$hi)("IExtHostConsumerFileSystem")}),define(ke[324],Ee([1,0,6,7]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class M{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(u.$gM.MainThreadIssueReporter)}async $getIssueReporterUri(A,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(A);if(!$)throw new Error("Issue request handler not found");const E=await $.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(A,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const E=await $.provideIssueData(b);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(A,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const E=await $.provideIssueTemplate(b);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(A,b){const $=A.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new N.$iM(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(A,b){const $=A.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new N.$iM(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$0jc=M}),define(ke[93],Ee([1,0,5,27,12,68,2]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=e.$8ic=void 0,e.$8ic=(0,u.$hi)("IExtensionStoragePaths");let b=class{constructor(E,R,I){this.d=R,this.f=I,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(E){return A.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,R=await this.g(E);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(E){if(this.c)return A.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return A.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$9ic=b,e.$9ic=b=Je([Ve(0,N.$QO),Ve(1,M.$Nj),Ve(2,P.$7ic)],b)}),define(ke[325],Ee([1,0,7,20,4]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;let P=class{constructor(b){this.a=new u.$IN(u.ColorThemeKind.Dark),this.b=new M.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=u.ColorThemeKind.Light;break;case"hcDark":$=u.ColorThemeKind.HighContrast;break;case"hcLight":$=u.ColorThemeKind.HighContrastLight;break;default:$=u.ColorThemeKind.Dark}this.a=new u.$IN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Akc=P,e.$Akc=P=Je([Ve(0,N.$AO)],P)}),define(ke[69],Ee([1,0,22,4,3,228,5,12,88,6,27,20,7]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ab=e.$9Ab=e.TunnelDtoConverter=void 0;class S extends $.$5v{}var k;(function(m){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(k||(e.TunnelDtoConverter=k={})),e.$9Ab=(0,A.$hi)("IExtHostTunnelService");let c=class extends M.$Uc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(E.$gM.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const s=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new w.$iM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,s,o){const t=[];for(const h of a){const l=this.r.get(h);if(!l)return[];t.push(...await Promise.all(n.map(async r=>{let g;try{g=await l.provider.providePortAttributes({port:r,pid:i,commandLine:s},o)}catch{g=await l.provider.providePortAttributes(r,i,s,o)}return{providedAttributes:g,port:r}})))}const d=t.filter(h=>!!h.providedAttributes);return d.length>0?d.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,o)=>await a.provideTunnel(s,o,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const s=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:o}),k.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),i=a.filter((s,o)=>n[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${i.map(s=>s.port).join(", ")}`),i}};e.$0Ab=c,e.$0Ab=c=Je([Ve(0,I.$AO),Ve(1,R.$QO),Ve(2,b.$Nj)],c)}),define(ke[16],Ee([1,0,19,21,171,73,79,28,164,57,101,24,166,23,18,2,29,82,138,144,142,119,66,89,299,26,7]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d,h,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$xO=F,e.$yO=G,e.$zO=te;var g;(function(Re){function Fe(ee){const{selectionStartLineNumber:Oe,selectionStartColumn:qe,positionLineNumber:_e,positionColumn:Qe}=ee,ut=new r.$jM(Oe-1,qe-1),yt=new r.$jM(_e-1,Qe-1);return new r.$lM(ut,yt)}Re.to=Fe;function Se(ee){const{anchor:Oe,active:qe}=ee;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Re.from=Se})(g||(e.Selection=g={}));var f;(function(Re){function Fe(ee){if(!ee)return;const{start:Oe,end:qe}=ee;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Re.from=Fe;function Se(ee){if(!ee)return;const{startLineNumber:Oe,startColumn:qe,endLineNumber:_e,endColumn:Qe}=ee;return new r.$kM(Oe-1,qe-1,_e-1,Qe-1)}Re.to=Se})(f||(e.Range=f={}));var D;(function(Re){function Fe(ee){return{uri:ee.uri,range:f.from(ee.range)}}Re.from=Fe;function Se(ee){return new r.$uM(c.URI.revive(ee.uri),f.to(ee.range))}Re.to=Se})(D||(e.Location=D={}));var p;(function(Re){function Fe(Se){switch(Se){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Re.to=Fe})(p||(e.TokenType=p={}));var v;(function(Re){function Fe(ee){return new r.$jM(ee.lineNumber-1,ee.column-1)}Re.to=Fe;function Se(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Re.from=Se})(v||(e.Position=v={}));var y;(function(Re){function Fe(Oe,qe,_e){return(0,u.$Hb)((0,u.$3b)(Oe).map(Qe=>Se(Qe,qe,_e)))}Re.from=Fe;function Se(Oe,qe,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:ee(Oe.scheme,qe),pattern:De.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Oe,qe){return qe&&typeof Oe=="string"?qe.transformOutgoingScheme(Oe):Oe}})(y||(e.DocumentSelector=y={}));var C;(function(Re){function Fe(ee){switch(ee){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Re.from=Fe;function Se(ee){switch(ee){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(C||(e.DiagnosticTag=C={}));var O;(function(Re){function Fe(ee){let Oe;return ee.code&&((0,k.$Uf)(ee.code)||(0,k.$Yf)(ee.code)?Oe=String(ee.code):Oe={value:String(ee.code.value),target:ee.code.target}),{...f.from(ee.range),message:ee.message,source:ee.source,code:Oe,severity:T.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(z.from),tags:Array.isArray(ee.tags)?(0,u.$Hb)(ee.tags.map(C.from)):void 0}}Re.from=Fe;function Se(ee){const Oe=new r.$wM(f.to(ee),ee.message,T.to(ee.severity));return Oe.source=ee.source,Oe.code=(0,k.$Uf)(ee.code)?ee.code:ee.code?.value,Oe.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(z.to),Oe.tags=ee.tags&&(0,u.$Hb)(ee.tags.map(C.to)),Oe}Re.to=Se})(O||(e.Diagnostic=O={}));var z;(function(Re){function Fe(ee){return{...f.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Re.from=Fe;function Se(ee){return new r.$vM(new r.$uM(ee.resource,f.to(ee)),ee.message)}Re.to=Se})(z||(e.DiagnosticRelatedInformation=z={}));var T;(function(Re){function Fe(ee){switch(ee){case r.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Re.from=Fe;function Se(ee){switch(ee){case n.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Re.to=Se})(T||(e.DiagnosticSeverity=T={}));var B;(function(Re){function Fe(ee){return typeof ee=="number"&&ee>=r.ViewColumn.One?ee-1:ee===r.ViewColumn.Beside?h.$zD:h.$yD}Re.from=Fe;function Se(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(B||(e.ViewColumn=B={}));function j(Re){return typeof Re.range<"u"}function F(Re){return Re.length===0?!0:!!j(Re[0])}var L;(function(Re){function Fe(Qe){return Qe.map(Re.from)}Re.fromMany=Fe;function Se(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ee(Qe){let ut;if(Se(Qe)){const{language:Ot,value:Tt}=Qe;ut={value:"```"+Ot+`
`+Tt+"\n```\n"}}else r.$JM.isMarkdownString(Qe)?ut={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ut={value:Qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const kt=Ot=>{try{let Tt=c.URI.parse(Ot,!0);Tt=Tt.with({query:Oe(Tt.query,yt)}),yt[Ot]=Tt}catch{}return""},xt=new $.marked.Renderer;return xt.link=kt,xt.image=Ot=>typeof Ot=="string"?kt(A.$Mk(Ot).href):"",(0,$.marked)(ut.value,{renderer:xt}),ut}Re.from=ee;function Oe(Qe,ut){if(!Qe)return Qe;let yt;try{yt=(0,E.$Ph)(Qe)}catch{}if(!yt)return Qe;let kt=!1;return yt=(0,I.$Pn)(yt,xt=>{if(c.URI.isUri(xt)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ot]=xt,kt=!0,Ot}else return}),kt?JSON.stringify(yt):Qe}function qe(Qe){const ut=new r.$JM(Qe.value,Qe.supportThemeIcons);return ut.isTrusted=Qe.isTrusted,ut.supportHtml=Qe.supportHtml,ut.baseUri=Qe.baseUri?c.URI.from(Qe.baseUri):void 0,ut}Re.to=qe;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=_e})(L||(e.MarkdownString=L={}));function G(Re){return F(Re)?Re.map(Fe=>({range:f.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?L.fromMany(Fe.hoverMessage):Fe.hoverMessage?L.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Re.map(Fe=>({range:f.from(Fe)}))}function te(Re){return typeof Re>"u"?Re:typeof Re=="string"?c.URI.file(Re):Re}var Z;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?te(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Fe})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var x;(function(Re){function Fe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?te(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?Z.from(Se.before):void 0,after:Se.after?Z.from(Se.after):void 0}}Re.from=Fe})(x||(e.ThemableDecorationRenderOptions=x={}));var _;(function(Re){function Fe(Se){if(typeof Se>"u")return Se;switch(Se){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Fe})(_||(e.DecorationRangeBehavior=_={}));var ue;(function(Re){function Fe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?_.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?x.from(Se.light):void 0,dark:Se.dark?x.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?te(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?Z.from(Se.before):void 0,after:Se.after?Z.from(Se.after):void 0}}Re.from=Fe})(ue||(e.DecorationRenderOptions=ue={}));var X;(function(Re){function Fe(ee){return{text:ee.newText,eol:ee.newEol&&ze.from(ee.newEol),range:f.from(ee.range)}}Re.from=Fe;function Se(ee){const Oe=new r.$pM(f.to(ee.range),ee.text);return Oe.newEol=typeof ee.eol>"u"?void 0:ze.to(ee.eol),Oe}Re.to=Se})(X||(e.TextEdit=X={}));var $e;(function(Re){function Fe(ee,Oe){const qe={edits:[]};if(ee instanceof r.$sM){const _e=new b.$Cc;for(const Qe of ee._allEntries())Qe._type===1&&c.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of ee._allEntries())if(Qe._type===1){let ut;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ut={type:"base64",value:(0,N.$Oe)(N.$ue.wrap(Qe.options.contents))}:ut={type:"dataTransferItem",id:Qe.options.contents._itemId}),qe.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ut},metadata:Qe.metadata})}else Qe._type===2?qe.edits.push({resource:Qe.uri,textEdit:X.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?qe.edits.push({resource:Qe.uri,textEdit:{range:f.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Bt.from)}})}return qe}Re.from=Fe;function Se(ee){const Oe=new r.$sM,qe=new b.$Bc;for(const _e of ee.edits)if(_e.textEdit){const Qe=_e,ut=c.URI.revive(Qe.resource),yt=f.to(Qe.textEdit.range),kt=Qe.textEdit.text,xt=Qe.textEdit.insertAsSnippet;let Ot;xt?Ot=r.$rM.replace(yt,new r.$tM(kt)):Ot=r.$pM.replace(yt,kt);const Tt=qe.get(ut);Tt?Tt.push(Ot):qe.set(ut,[Ot])}else Oe.renameFile(c.URI.revive(_e.oldResource),c.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of qe)Oe.set(_e,Qe);return Oe}Re.to=Se})($e||(e.WorkspaceEdit=$e={}));var se;(function(Re){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function Se(Oe){return typeof Fe[Oe]=="number"?Fe[Oe]:6}Re.from=Se;function ee(Oe){for(const qe in Fe)if(Fe[qe]===Oe)return Number(qe);return r.SymbolKind.Property}Re.to=ee})(se||(e.SymbolKind=se={}));var re;(function(Re){function Fe(ee){switch(ee){case r.SymbolTag.Deprecated:return 1}}Re.from=Fe;function Se(ee){switch(ee){case 1:return r.SymbolTag.Deprecated}}Re.to=Se})(re||(e.SymbolTag=re={}));var U;(function(Re){function Fe(ee){return{name:ee.name,kind:se.from(ee.kind),tags:ee.tags&&ee.tags.map(re.from),containerName:ee.containerName,location:ae.from(ee.location)}}Re.from=Fe;function Se(ee){const Oe=new r.$AM(ee.name,se.to(ee.kind),ee.containerName,ae.to(ee.location));return Oe.tags=ee.tags&&ee.tags.map(re.to),Oe}Re.to=Se})(U||(e.WorkspaceSymbol=U={}));var ie;(function(Re){function Fe(ee){const Oe={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),kind:se.from(ee.kind),tags:ee.tags?.map(re.from)??[]};return ee.children&&(Oe.children=ee.children.map(Fe)),Oe}Re.from=Fe;function Se(ee){const Oe=new r.$BM(ee.name,ee.detail,se.to(ee.kind),f.to(ee.range),f.to(ee.selectionRange));return(0,u.$Lb)(ee.tags)&&(Oe.tags=ee.tags.map(re.to)),ee.children&&(Oe.children=ee.children.map(Se)),Oe}Re.to=Se})(ie||(e.DocumentSymbol=ie={}));var ve;(function(Re){function Fe(ee){const Oe=new r.$FM(se.to(ee.kind),ee.name,ee.detail||"",c.URI.revive(ee.uri),f.to(ee.range),f.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Re.to=Fe;function Se(ee,Oe,qe){if(Oe=Oe??ee._sessionId,qe=qe??ee._itemId,Oe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:qe,name:ee.name,detail:ee.detail,kind:se.from(ee.kind),uri:ee.uri,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),tags:ee.tags?.map(re.from)}}Re.from=Se})(ve||(e.CallHierarchyItem=ve={}));var Ie;(function(Re){function Fe(Se){return new r.$GM(ve.to(Se.from),Se.fromRanges.map(ee=>f.to(ee)))}Re.to=Fe})(Ie||(e.CallHierarchyIncomingCall=Ie={}));var le;(function(Re){function Fe(Se){return new r.$HM(ve.to(Se.to),Se.fromRanges.map(ee=>f.to(ee)))}Re.to=Fe})(le||(e.CallHierarchyOutgoingCall=le={}));var ae;(function(Re){function Fe(ee){return{range:ee.range&&f.from(ee.range),uri:ee.uri}}Re.from=Fe;function Se(ee){return new r.$uM(c.URI.revive(ee.uri),f.to(ee.range))}Re.to=Se})(ae||(e.location=ae={}));var ce;(function(Re){function Fe(ee){const Oe=ee,qe=ee;return{originSelectionRange:Oe.originSelectionRange?f.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:qe.uri,range:f.from(Oe.targetRange?Oe.targetRange:qe.range),targetSelectionRange:Oe.targetSelectionRange?f.from(Oe.targetSelectionRange):void 0}}Re.from=Fe;function Se(ee){return{targetUri:c.URI.revive(ee.uri),targetRange:f.to(ee.range),targetSelectionRange:ee.targetSelectionRange?f.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?f.to(ee.originSelectionRange):void 0}}Re.to=Se})(ce||(e.DefinitionLink=ce={}));var H;(function(Re){function Fe(ee){return{range:f.from(ee.range),contents:L.fromMany(ee.contents)}}Re.from=Fe;function Se(ee){return new r.$xM(ee.contents.map(L.to),f.to(ee.range))}Re.to=Se})(H||(e.Hover=H={}));var Q;(function(Re){function Fe(ee){return{range:f.from(ee.range),expression:ee.expression}}Re.from=Fe;function Se(ee){return new r.$sN(f.to(ee.range),ee.expression)}Re.to=Se})(Q||(e.EvaluatableExpression=Q={}));var he;(function(Re){function Fe(ee){if(ee instanceof r.$tN)return{type:"text",range:f.from(ee.range),text:ee.text};if(ee instanceof r.$uN)return{type:"variable",range:f.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof r.$vN)return{type:"expression",range:f.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Fe;function Se(ee){switch(ee.type){case"text":return{range:f.to(ee.range),text:ee.text};case"variable":return{range:f.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:f.to(ee.range),expression:ee.expression}}}Re.to=Se})(he||(e.InlineValue=he={}));var fe;(function(Re){function Fe(ee){return{frameId:ee.frameId,stoppedLocation:f.from(ee.stoppedLocation)}}Re.from=Fe;function Se(ee){return new r.$wN(ee.frameId,f.to(ee.stoppedLocation))}Re.to=Se})(fe||(e.InlineValueContext=fe={}));var Pe;(function(Re){function Fe(ee){return{range:f.from(ee.range),kind:ee.kind}}Re.from=Fe;function Se(ee){return new r.$yM(f.to(ee.range),ee.kind)}Re.to=Se})(Pe||(e.DocumentHighlight=Pe={}));var be;(function(Re){function Fe(ee){return{uri:ee.uri,highlights:ee.highlights.map(Pe.from)}}Re.from=Fe;function Se(ee){return new r.$zM(c.URI.revive(ee.uri),ee.highlights.map(Pe.to))}Re.to=Se})(be||(e.MultiDocumentHighlight=be={}));var Ae;(function(Re){function Fe(Se){switch(Se){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Re.to=Fe})(Ae||(e.CompletionTriggerKind=Ae={}));var Ne;(function(Re){function Fe(Se){return{triggerKind:Ae.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Fe})(Ne||(e.CompletionContext=Ne={}));var Be;(function(Re){function Fe(ee){switch(ee){case r.CompletionItemTag.Deprecated:return 1}}Re.from=Fe;function Se(ee){switch(ee){case 1:return r.CompletionItemTag.Deprecated}}Re.to=Se})(Be||(e.CompletionItemTag=Be={}));var V;(function(Re){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Se(qe){return Fe.get(qe)??9}Re.from=Se;const ee=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Oe(qe){return ee.get(qe)??r.CompletionItemKind.Property}Re.to=Oe})(V||(e.CompletionItemKind=V={}));var q;(function(Re){function Fe(Se,ee){const Oe=new r.$PM(Se.label);return Oe.insertText=Se.insertText,Oe.kind=V.to(Se.kind),Oe.tags=Se.tags?.map(Be.to),Oe.detail=Se.detail,Oe.documentation=A.$Gk(Se.documentation)?L.to(Se.documentation):Se.documentation,Oe.sortText=Se.sortText,Oe.filterText=Se.filterText,Oe.preselect=Se.preselect,Oe.commitCharacters=Se.commitCharacters,m.$at.isIRange(Se.range)?Oe.range=f.to(Se.range):typeof Se.range=="object"&&(Oe.range={inserting:f.to(Se.range.insert),replacing:f.to(Se.range.replace)}),Oe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Oe.insertText=new r.$tM(Se.insertText):(Oe.insertText=Se.insertText,Oe.textEdit=Oe.range instanceof r.$kM?new r.$pM(Oe.range,Oe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Oe.additionalTextEdits=Se.additionalTextEdits.map(qe=>X.to(qe))),Oe.command=ee&&Se.command?ee.fromInternal(Se.command):void 0,Oe}Re.to=Fe})(q||(e.CompletionItem=q={}));var Y;(function(Re){function Fe(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:L.fromStrict(ee.documentation)}}Re.from=Fe;function Se(ee){return{label:ee.label,documentation:A.$Gk(ee.documentation)?L.to(ee.documentation):ee.documentation}}Re.to=Se})(Y||(e.ParameterInformation=Y={}));var J;(function(Re){function Fe(ee){return{label:ee.label,documentation:L.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(Y.from):[],activeParameter:ee.activeParameter}}Re.from=Fe;function Se(ee){return{label:ee.label,documentation:A.$Gk(ee.documentation)?L.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(Y.to):[],activeParameter:ee.activeParameter}}Re.to=Se})(J||(e.SignatureInformation=J={}));var ge;(function(Re){function Fe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(J.from):[]}}Re.from=Fe;function Se(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(J.to):[]}}Re.to=Se})(ge||(e.SignatureHelp=ge={}));var we;(function(Re){function Fe(Se,ee){const Oe=new r.$OM(v.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(Te.to.bind(void 0,Se)),ee.kind&&He.to(ee.kind));return Oe.textEdits=ee.textEdits&&ee.textEdits.map(X.to),Oe.tooltip=A.$Gk(ee.tooltip)?L.to(ee.tooltip):ee.tooltip,Oe.paddingLeft=ee.paddingLeft,Oe.paddingRight=ee.paddingRight,Oe}Re.to=Fe})(we||(e.InlayHint=we={}));var Te;(function(Re){function Fe(Se,ee){const Oe=new r.$NM(ee.label);return Oe.tooltip=A.$Gk(ee.tooltip)?L.to(ee.tooltip):ee.tooltip,a.Command.is(ee.command)&&(Oe.command=Se.fromInternal(ee.command)),ee.location&&(Oe.location=ae.to(ee.location)),Oe}Re.to=Fe})(Te||(e.InlayHintLabelPart=Te={}));var He;(function(Re){function Fe(ee){return ee}Re.from=Fe;function Se(ee){return ee}Re.to=Se})(He||(e.InlayHintKind=He={}));var Xe;(function(Re){function Fe(ee){return{range:f.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Re.from=Fe;function Se(ee){let Oe;if(ee.url)try{Oe=typeof ee.url=="string"?c.URI.parse(ee.url,!0):c.URI.revive(ee.url)}catch{}return new r.$UM(f.to(ee.range),Oe)}Re.to=Se})(Xe||(e.DocumentLink=Xe={}));var tt;(function(Re){function Fe(ee){const Oe=new r.$XM(ee.label);return ee.textEdit&&(Oe.textEdit=X.to(ee.textEdit)),ee.additionalTextEdits&&(Oe.additionalTextEdits=ee.additionalTextEdits.map(qe=>X.to(qe))),Oe}Re.to=Fe;function Se(ee){return{label:ee.label,textEdit:ee.textEdit?X.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Oe=>X.from(Oe)):void 0}}Re.from=Se})(tt||(e.ColorPresentation=tt={}));var nt;(function(Re){function Fe(ee){return new r.$VM(ee[0],ee[1],ee[2],ee[3])}Re.to=Fe;function Se(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Re.from=Se})(nt||(e.Color=nt={}));var at;(function(Re){function Fe(ee){return{range:f.from(ee.range)}}Re.from=Fe;function Se(ee){return new r.$EM(f.to(ee.range))}Re.to=Se})(at||(e.SelectionRange=at={}));var rt;(function(Re){function Fe(Se){switch(Se){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Re.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var Ce;(function(Re){function Fe(ee){switch(ee){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.Interval:return 3;case r.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Fe;function Se(ee){switch(ee){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 3:return r.TextEditorLineNumbersStyle.Interval;case 1:default:return r.TextEditorLineNumbersStyle.On}}Re.to=Se})(Ce||(e.TextEditorLineNumbersStyle=Ce={}));var ze;(function(Re){function Fe(ee){if(ee===r.EndOfLine.CRLF)return 1;if(ee===r.EndOfLine.LF)return 0}Re.from=Fe;function Se(ee){if(ee===1)return r.EndOfLine.CRLF;if(ee===0)return r.EndOfLine.LF}Re.to=Se})(ze||(e.EndOfLine=ze={}));var Me;(function(Re){function Fe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Fe})(Me||(e.ProgressLocation=Me={}));var Ge;(function(Re){function Fe(ee){const Oe={start:ee.start+1,end:ee.end+1};return ee.kind&&(Oe.kind=ne.from(ee.kind)),Oe}Re.from=Fe;function Se(ee){const Oe={start:ee.start-1,end:ee.end-1};return ee.kind&&(Oe.kind=ne.to(ee.kind)),Oe}Re.to=Se})(Ge||(e.FoldingRange=Ge={}));var ne;(function(Re){function Fe(ee){if(ee)switch(ee){case r.FoldingRangeKind.Comment:return a.$5t.Comment;case r.FoldingRangeKind.Imports:return a.$5t.Imports;case r.FoldingRangeKind.Region:return a.$5t.Region}}Re.from=Fe;function Se(ee){if(ee)switch(ee.value){case a.$5t.Comment.value:return r.FoldingRangeKind.Comment;case a.$5t.Imports.value:return r.FoldingRangeKind.Imports;case a.$5t.Region.value:return r.FoldingRangeKind.Region}}Re.to=Se})(ne||(e.FoldingRangeKind=ne={}));var oe;(function(Re){function Fe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?f.from(Se.selection):void 0,override:typeof Se.override=="boolean"?s.$2E.id:void 0}}Re.from=Fe})(oe||(e.TextEditorOpenOptions=oe={}));var De;(function(Re){function Fe(qe){return qe instanceof r.$gN?qe.toJSON():typeof qe=="string"?qe:Se(qe)||ee(qe)?new r.$gN(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Re.from=Fe;function Se(qe){const _e=qe;return _e?c.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(qe){const _e=qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(qe){return typeof qe=="string"?qe:new r.$gN(c.URI.revive(qe.baseUri),qe.pattern)}Re.to=Oe})(De||(e.GlobPattern=De={}));var Ke;(function(Re){function Fe(Se){if(Se){if(Array.isArray(Se))return Se.map(Fe);if(typeof Se=="string")return Se;{const ee=Se;return{language:ee.language,scheme:ee.scheme,pattern:De.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Re.from=Fe})(Ke||(e.LanguageSelector=Ke={}));var xe;(function(Re){function Fe(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&c.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(_e=>_e instanceof r.$kM)))}Re.is=Fe;function Se(ee){return{documents:ee.documents.map(Oe=>Oe.map(qe=>({uri:c.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>f.from(_e))})))}}Re.from=Se})(xe||(e.MappedEditsContext=xe={}));var st;(function(Re){function Fe(ee){return{start:ee.start,end:ee.end}}Re.from=Fe;function Se(ee){return new r.$JN(ee.start,ee.end)}Re.to=Se})(st||(e.NotebookRange=st={}));var je;(function(Re){function Fe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Re.to=Fe;function Se(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Re.from=Se})(je||(e.NotebookCellExecutionSummary=je={}));var bt;(function(Re){function Fe(Se){if(Se===o.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Se===o.NotebookCellExecutionState.Pending)return;if(Se===o.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Fe})(bt||(e.NotebookCellExecutionState=bt={}));var vt;(function(Re){function Fe(ee){switch(ee){case r.NotebookCellKind.Markup:return o.CellKind.Markup;case r.NotebookCellKind.Code:default:return o.CellKind.Code}}Re.from=Fe;function Se(ee){switch(ee){case o.CellKind.Markup:return r.NotebookCellKind.Markup;case o.CellKind.Code:default:return r.NotebookCellKind.Code}}Re.to=Se})(vt||(e.NotebookCellKind=vt={}));var Lt;(function(Re){function Fe(ee){const Oe={metadata:ee.metadata??Object.create(null),cells:[]};for(const qe of ee.cells)r.$KN.validate(qe),Oe.cells.push(Bt.from(qe));return Oe}Re.from=Fe;function Se(ee){const Oe=new r.$LN(ee.cells.map(Bt.to));return(0,k.$8f)(ee.metadata)||(Oe.metadata=ee.metadata),Oe}Re.to=Se})(Lt||(e.NotebookData=Lt={}));var Bt;(function(Re){function Fe(ee){return{cellKind:vt.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:je.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(Ct.from):[]}}Re.from=Fe;function Se(ee){return new r.$KN(vt.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(Ct.to):void 0,ee.metadata,ee.internalMetadata?je.to(ee.internalMetadata):void 0)}Re.to=Se})(Bt||(e.NotebookCellData=Bt={}));var Ut;(function(Re){function Fe(ee){return{mime:ee.mime,valueBytes:N.$ue.wrap(ee.data)}}Re.from=Fe;function Se(ee){return new r.$MN(ee.valueBytes.buffer,ee.mime)}Re.to=Se})(Ut||(e.NotebookCellOutputItem=Ut={}));var Ct;(function(Re){function Fe(ee){return{outputId:ee.id,items:ee.items.map(Ut.from),metadata:ee.metadata}}Re.from=Fe;function Se(ee){const Oe=ee.items.map(Ut.to);return new r.$NN(Oe,ee.outputId,ee.metadata)}Re.to=Se})(Ct||(e.NotebookCellOutput=Ct={}));var ti;(function(Re){function Fe(Oe){return ee(Oe)?{include:De.from(Oe.include)??void 0,exclude:De.from(Oe.exclude)??void 0}:De.from(Oe)??void 0}Re.from=Fe;function Se(Oe){return ee(Oe)?{include:De.to(Oe.include),exclude:De.to(Oe.exclude)}:De.to(Oe)}Re.to=Se;function ee(Oe){const qe=Oe;return qe?!(0,k.$4f)(qe.include)&&!(0,k.$4f)(qe.exclude):!1}})(ti||(e.NotebookExclusiveDocumentPattern=ti={}));var Wt;(function(Re){function Fe(Se,ee,Oe){const qe=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(qe,Oe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Fe})(Wt||(e.NotebookStatusBarItem=Wt={}));var ri;(function(Re){function Fe(Se,ee,Oe){const qe=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ee.toInternal(qe,Oe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Fe})(ri||(e.NotebookKernelSourceAction=ri={}));var ii;(function(Re){function Fe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Fe})(ii||(e.NotebookDocumentContentOptions=ii={}));var et;(function(Re){function Fe(ee){return{uri:ee.uri,provides:ee.provides}}Re.from=Fe;function Se(ee){return new r.$PN(c.URI.revive(ee.uri),ee.provides)}Re.to=Se})(et||(e.NotebookRendererScript=et={}));var Xt;(function(Re){function Fe(ee){return{message:L.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:f.from(ee.location.range),uri:ee.location.uri}}}Re.from=Fe;function Se(ee){const Oe=new r.$VN(typeof ee.message=="string"?ee.message:L.to(ee.message));return Oe.actualOutput=ee.actual,Oe.expectedOutput=ee.expected,Oe.contextValue=ee.contextValue,Oe.location=ee.location?ae.to(ee.location):void 0,Oe}Re.to=Se})(Xt||(e.TestMessage=Xt={}));var qt;(function(Re){Re.namespace=d.$0K,Re.denamespace=d.$$K})(qt||(e.TestTag=qt={}));var ht;(function(Re){function Fe(ee){const Oe=(0,i.$wO)(ee).controllerId;return{extId:t.$5K.fromExtHostTestItem(ee,Oe).toString(),label:ee.label,uri:c.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(qe=>qt.namespace(Oe,qe.id)),range:m.$at.lift(f.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&L.fromStrict(ee.error)||null}}Re.from=Fe;function Se(ee){return{parent:void 0,error:void 0,id:t.$5K.fromString(ee.extId).localId,label:ee.label,uri:c.URI.revive(ee.uri),tags:(ee.tags||[]).map(Oe=>{const{tagId:qe}=qt.denamespace(Oe);return new r.$WN(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:f.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Re.toPlain=Se})(ht||(e.TestItem=ht={})),function(Re){function Fe(ee){return{id:ee.id}}Re.from=Fe;function Se(ee){return new r.$WN(ee.id)}Re.to=Se}(qt||(e.TestTag=qt={}));var mt;(function(Re){const Fe=(ee,Oe)=>{const qe=ee.value;if(!qe)return;const _e={...ht.toPlain(qe.item),parent:Oe,taskStates:qe.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ut=>ut.type===0).map(Xt.to)})),children:[]};if(ee.children)for(const Qe of ee.children.values()){const ut=Fe(Qe,_e);ut&&_e.children.push(ut)}return _e};function Se(ee){const Oe=new w.$pO;for(const Qe of ee.items)Oe.insert(t.$5K.fromString(Qe.item.extId).path,Qe);const qe=[Oe.nodes],_e=[];for(;qe.length;)for(const Qe of qe.pop())Qe.value?_e.push(Qe):Qe.children&&qe.push(Qe.children.values());return{completedAt:ee.completedAt,results:_e.map(Qe=>Fe(Qe)).filter(k.$3f)}}Re.to=Se})(mt||(e.TestResults=mt={}));var ni;(function(Re){function Fe(qe){return{covered:qe.covered,total:qe.total}}function Se(qe){return"line"in qe?v.from(qe):f.from(qe)}function ee(qe){return"branches"in qe?{count:qe.executed,location:Se(qe.location),type:1,branches:qe.branches.length?qe.branches.map(_e=>({count:_e.executed,location:_e.location&&Se(_e.location),label:_e.label})):void 0}:{type:0,name:qe.name,count:qe.executed,location:Se(qe.location)}}Re.fromDetailed=ee;function Oe(qe){return{uri:qe.uri,statement:Fe(qe.statementCoverage),branch:qe.branchCoverage&&Fe(qe.branchCoverage),declaration:qe.declarationCoverage&&Fe(qe.declarationCoverage),details:qe.detailedCoverage?.map(ee)}}Re.fromFile=Oe})(ni||(e.TestCoverage=ni={}));var Vt;(function(Re){function Fe(Se){switch(Se){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Re.to=Fe})(Vt||(e.CodeActionTriggerKind=Vt={}));var Ht;(function(Re){function Fe(ee){const Oe=new r.$3N(se.to(ee.kind),ee.name,ee.detail||"",c.URI.revive(ee.uri),f.to(ee.range),f.to(ee.selectionRange));return Oe._sessionId=ee._sessionId,Oe._itemId=ee._itemId,Oe}Re.to=Fe;function Se(ee,Oe,qe){if(Oe=Oe??ee._sessionId,qe=qe??ee._itemId,Oe===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:qe,kind:se.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:f.from(ee.range),selectionRange:f.from(ee.selectionRange),tags:ee.tags?.map(re.from)}}Re.from=Se})(Ht||(e.TypeHierarchyItem=Ht={}));var dt;(function(Re){function Fe(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Fe})(dt||(e.ViewBadge=dt={}));var It;(function(Re){function Fe(qe,_e,Qe){const ut=_e.fileData;return ut?new r.$$M(new r.$_M(ut.name,c.URI.revive(ut.uri),ut.id,(0,P.$db)(()=>Qe(ut.id)))):qe===R.$xs.uriList&&_e.uriListData?new r.$0M(Oe(_e.uriListData)):new r.$0M(_e.asString)}Re.to=Fe;async function Se(qe,_e){const Qe=await _e.asString();if(qe===R.$xs.uriList)return{asString:Qe,fileData:void 0,uriListData:ee(Qe)};const ut=_e.asFile();return{asString:Qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}Re.from=Se;function ee(qe){return M.$Jt.split(qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return c.URI.parse(_e)}catch{}return _e})}function Oe(qe){return M.$Jt.create(qe.map(_e=>typeof _e=="string"?_e:c.URI.revive(_e)))}})(It||(e.DataTransferItem=It={}));var si;(function(Re){function Fe(ee,Oe){const qe=ee.items.map(([_e,Qe])=>[_e,It.to(_e,Qe,Oe)]);return new r.$aN(qe)}Re.toDataTransfer=Fe;async function Se(ee){const Oe={items:[]},qe=[];for(const[_e,Qe]of ee)qe.push((async()=>{Oe.items.push([_e,await It.from(_e,Qe)])})());return await Promise.all(qe),Oe}Re.from=Se})(si||(e.DataTransfer=si={}));var _t;(function(Re){function Fe(ee,Oe){return{kind:"reply",agentId:ee.participant??Oe?.agentId??"",subCommand:ee.command??Oe?.command,message:ee.prompt,title:ee.label}}Re.from=Fe;function Se(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Re.to=Se})(_t||(e.ChatFollowup=_t={}));var Ye;(function(Re){function Fe(Se){return"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:{kind:"reply",message:Se.message,title:Se.title,tooltip:Se.tooltip}}Re.from=Fe})(Ye||(e.ChatInlineFollowup=Ye={}));var Gt;(function(Re){function Fe(ee){switch(ee.role){case 0:return new r.$kO(ee.content);case 1:return new r.$lO(ee.content);case 2:return new r.$mO(ee.content)}}Re.to=Fe;function Se(ee){if(ee instanceof r.$kO)return{role:0,content:ee.content};if(ee instanceof r.$lO)return{role:1,content:ee.content};if(ee instanceof r.$mO)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Re.from=Se})(Gt||(e.LanguageModelMessage=Gt={}));var zt;(function(Re){function Fe(Oe){const qe={};for(const _e of Object.keys(Oe))qe[_e]=Oe[_e].map(Re.to);return qe}Re.objectTo=Fe;function Se(Oe){return{level:Kt.to(Oe.level),kind:Oe.kind,value:(0,c.$wc)(Oe.value)?c.URI.revive(Oe.value):Oe.value,description:Oe.description}}Re.to=Se;function ee(Oe){return{level:Kt.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Re.from=ee})(zt||(e.ChatVariable=zt={}));var Kt;(function(Re){function Fe(ee){switch(ee){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Re.to=Fe;function Se(ee){switch(ee){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Re.from=Se})(Kt||(e.ChatVariableLevel=Kt={}));var $t;(function(Re){function Fe(Se){switch(Se){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Fe})($t||(e.InteractiveEditorResponseFeedbackKind=$t={}));var At;(function(Re){function Fe(ee){return{kind:"markdownContent",content:L.from(ee.value)}}Re.to=Fe;function Se(ee){return new r.$cO(L.to(ee.content))}Re.from=Se})(At||(e.ChatResponseMarkdownPart=At={}));var Rt;(function(Re){function Fe(ee){const{value:Oe,baseUri:qe}=ee;function _e(Qe,ut){return Qe.map(yt=>{const kt=c.URI.joinPath(ut,yt.name);return{label:yt.name,uri:kt,children:yt.children&&_e(yt.children,kt)}})}return{kind:"treeData",treeData:{label:(0,S.$Rg)(qe),uri:qe,children:_e(Oe,qe)}}}Re.to=Fe;function Se(ee){const Oe=(0,E.$Qh)(ee.treeData);function qe(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&qe(yt.children)}))}const _e=Oe.uri,Qe=Oe.children?qe(Oe.children):[];return new r.$dO(Qe,_e)}Re.from=Se})(Rt||(e.ChatResponseFilesPart=Rt={}));var jt;(function(Re){function Fe(ee){return{kind:"inlineReference",name:ee.title,inlineReference:c.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Re.to=Fe;function Se(ee){const Oe=(0,E.$Qh)(ee);return new r.$eO(c.URI.isUri(Oe.inlineReference)?Oe.inlineReference:D.to(Oe.inlineReference),ee.name)}Re.from=Se})(jt||(e.ChatResponseAnchorPart=jt={}));var oi;(function(Re){function Fe(ee){return{kind:"progressMessage",content:L.from(ee.value)}}Re.to=Fe;function Se(ee){return new r.$fO(ee.content.value)}Re.from=Se})(oi||(e.ChatResponseProgressPart=oi={}));var Jt;(function(Re){function Fe(ee,Oe,qe){return{kind:"command",command:Oe.toInternal(ee.value,qe)??{command:ee.value.command,title:ee.value.title}}}Re.to=Fe;function Se(ee,Oe){return new r.$gO(Oe.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Re.from=Se})(Jt||(e.ChatResponseCommandButtonPart=Jt={}));var Yt;(function(Re){function Fe(ee){return{kind:"reference",reference:c.URI.isUri(ee.value)?ee.value:D.from(ee.value)}}Re.to=Fe;function Se(ee){const Oe=(0,E.$Qh)(ee);return new r.$hO(c.URI.isUri(Oe.reference)?Oe.reference:D.to(Oe.reference))}Re.from=Se})(Yt||(e.ChatResponseReferencePart=Yt={}));var Et;(function(Re){function Fe(Oe){return Oe instanceof r.$cO?At.to(Oe):Oe instanceof r.$eO?jt.to(Oe):Oe instanceof r.$hO?Yt.to(Oe):Oe instanceof r.$fO?oi.to(Oe):Oe instanceof r.$dO?Rt.to(Oe):{kind:"content",content:""}}Re.to=Fe;function Se(Oe,qe){switch(Oe.kind){case"reference":return Yt.from(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Oe,qe)}}Re.from=Se;function ee(Oe,qe){switch(Oe.kind){case"markdownContent":return At.from(Oe);case"inlineReference":return jt.from(Oe);case"progressMessage":return;case"treeData":return Rt.from(Oe);case"command":return Jt.from(Oe,qe)}}Re.fromContent=ee})(Et||(e.ChatResponsePart=Et={}));var Mt;(function(Re){function Fe(Oe,qe){return"markdownContent"in qe?((0,l.$6F)(Oe,"chatParticipantAdditions"),{content:L.from(qe.markdownContent),kind:"markdownContent"}):"content"in qe?"vulnerabilities"in qe&&qe.vulnerabilities?((0,l.$6F)(Oe,"chatParticipantAdditions"),{content:qe.content,vulnerabilities:qe.vulnerabilities,kind:"vulnerability"}):typeof qe.content=="string"?{content:qe.content,kind:"content"}:((0,l.$6F)(Oe,"chatParticipantAdditions"),{content:L.from(qe.content),kind:"markdownContent"}):"documents"in qe?{documents:qe.documents.map(_e=>({uri:_e.uri,version:_e.version,ranges:_e.ranges.map(Qe=>f.from(Qe))})),kind:"usedContext"}:"reference"in qe?{reference:"uri"in qe.reference?{uri:qe.reference.uri,range:f.from(qe.reference.range)}:qe.reference,kind:"reference"}:"inlineReference"in qe?{inlineReference:"uri"in qe.inlineReference?{uri:qe.inlineReference.uri,range:f.from(qe.inlineReference.range)}:qe.inlineReference,name:qe.title,kind:"inlineReference"}:"participant"in qe?((0,l.$6F)(Oe,"chatParticipantAdditions"),{agentName:qe.participant,command:qe.command,kind:"agentDetection"}):"message"in qe?{content:L.from(qe.message),kind:"progressMessage"}:void 0}Re.from=Fe;function Se(Oe){switch(Oe.kind){case"markdownContent":case"inlineReference":case"treeData":return Re.to(Oe);case"content":return{content:Oe.content};case"usedContext":return{documents:Oe.documents.map(qe=>({uri:c.URI.revive(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>f.to(_e))}))};case"reference":return{reference:(0,c.$wc)(Oe.reference)?c.URI.revive(Oe.reference):D.to(Oe.reference)};case"agentDetection":return;case"progressMessage":return{message:Oe.content.value};case"vulnerability":return{content:Oe.content,vulnerabilities:Oe.vulnerabilities};default:return}}Re.to=Se;function ee(Oe,qe){switch(Oe.kind){case"markdownContent":return{content:Oe.content.value};case"inlineReference":return{inlineReference:(0,c.$wc)(Oe.inlineReference)?c.URI.revive(Oe.inlineReference):D.to(Oe.inlineReference),title:Oe.name};case"command":return{command:qe.fromInternal(Oe.command)??{command:Oe.command.id,title:Oe.command.title}};default:return}}Re.toProgressContent=ee})(Mt||(e.ChatResponseProgress=Mt={}));var Qt;(function(Re){function Fe(Se){return{prompt:Se.message,command:Se.command,variables:Se.variables.variables.map(Ft.to)}}Re.to=Fe})(Qt||(e.ChatAgentRequest=Qt={}));var Ft;(function(Re){function Fe(Se){return{name:Se.name,range:[Se.range.start,Se.range.endExclusive],values:Se.values.map(zt.to)}}Re.to=Fe})(Ft||(e.ChatAgentResolvedVariable=Ft={}));var St;(function(Re){function Fe(Se){return{label:Se.label,values:Se.values.map(zt.from),insertText:Se.insertText,detail:Se.detail,documentation:Se.documentation}}Re.from=Fe})(St||(e.ChatAgentCompletionItem=St={}));var Pt;(function(Re){function Fe(Se){return{errorDetails:Se.errorDetails,metadata:Se.metadata}}Re.to=Fe})(Pt||(e.ChatAgentResult=Pt={}));var Dt;(function(Re){function Fe(Se,ee,Oe){if(ee.action.kind==="vote")return;const qe=Pt.to(Se);return ee.action.kind==="command"?{action:{kind:"command",commandButton:Mt.toProgressContent(ee.action.commandButton,Oe)},result:qe}:ee.action.kind==="followUp"?{action:{kind:"followUp",followup:_t.to(ee.action.followup)},result:qe}:{action:ee.action,result:qe}}Re.to=Fe})(Dt||(e.ChatAgentUserActionEvent=Dt={}));var li;(function(Re){function Fe(Se,ee,Oe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand,shouldExecute:Se.shouldExecute}:"uri"in Se?{uri:Se.uri}:ee.toInternal(Se,Oe)}Re.from=Fe})(li||(e.TerminalQuickFix=li={}));var ei;(function(Re){function Fe(Se){return{kind:ai.to(Se.kind)}}Re.to=Fe})(ei||(e.PartialAcceptInfo=ei={}));var ai;(function(Re){function Fe(Se){switch(Se){case 0:return r.PartialAcceptTriggerKind.Word;case 1:return r.PartialAcceptTriggerKind.Line;case 2:return r.PartialAcceptTriggerKind.Suggest;default:return r.PartialAcceptTriggerKind.Unknown}}Re.to=Fe})(ai||(e.PartialAcceptTriggerKind=ai={}));var hi;(function(Re){function Fe(Se,ee){return{id:ee,label:Se.label,description:Se.description,canEdit:Se.canEdit,collapsibleState:Se.collapsibleState||0,contextValue:Se.contextValue}}Re.from=Fe})(hi||(e.DebugTreeItem=hi={}))}),define(ke[326],Ee([1,0,6,20,16]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;let P=class{constructor(b,$){this.a=b.getProxy(u.$gM.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>$.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,E){const R=M.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,E?.isRefactoring??!1)}};e.$Oic=P,e.$Oic=P=Je([Ve(0,N.$AO)],P)}),define(ke[327],Ee([1,0,19,8,45,4,43,3,38,18,2,217,25,6,16,7,288,26]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class n{constructor(t,d,h,l,r,g){this.i=t,this.j=d,this.k=h,this.l=l,this.m=r,this.n=g,this.b=$.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let d=function(l){if(t.c){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,l),r}};const t=this;this.b.reset();const h=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){d(this.markdown);const r=new c.$cO(l),g=k.ChatResponseMarkdownPart.to(r);return h(g),this},filetree(l,r){d(this.filetree);const g=new c.$dO(l,r),f=k.ChatResponseFilesPart.to(g);return h(f),this},anchor(l,r){d(this.anchor);const g=new c.$eO(l,r),f=k.ChatResponseAnchorPart.to(g);return h(f),this},button(l){d(this.anchor);const r=new c.$gO(l),g=k.ChatResponseCommandButtonPart.to(r,t.m,t.n);return h(g),this},progress(l){d(this.progress);const r=new c.$fO(l),g=k.ChatResponseProgressPart.to(r);return h(g),this},reference(l){d(this.reference);const r=new c.$hO(l),g=k.ChatResponseReferencePart.to(r);return h(g),this},push(l){d(this.push);const r=k.ChatResponsePart.to(l);return h(r),this},report(l){if(d(this.report),"placeholder"in l&&"resolvedContent"in l)return;const r=k.ChatResponseProgress.from(t.i,l);if(!r){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return h(r),this}}}return this.g}}class i{static{this.b=0}constructor(t,d,h){this.i=d,this.j=h,this.c=new Map,this.g=new b.$4c,this.d=t.getProxy(S.$gM.MainThreadChatAgents2)}createChatAgent(t,d,h){const l=i.b++,r=new s(t,d,this.d,l,h);return this.c.set(l,r),this.d.$registerAgent(l,t.identifier,d,{},(0,a.$5F)(t,"chatParticipantAdditions")),r.apiAgent}async $invokeAgent(t,d,h,l){const r=this.c.get(t);if(!r)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let g=this.g.get(d.sessionId);g||(g=new b.$Tc,this.g.set(d.sessionId,g));const f=new n(r.extension,d,this.d,this.i,this.j.converter,g);try{const D=await this.k(d.agentId,h),p=r.invoke(k.ChatAgentRequest.to(d),{history:D},f.apiObject,l);return await(0,N.$8g)(Promise.resolve(p).then(v=>{if(v?.metadata)try{JSON.stringify(v.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${r.extension.identifier.value}] [@${r.id}] ${C}`,r.extension),{errorDetails:{message:C},timings:f.timings}}return{errorDetails:v?.errorDetails,timings:f.timings,metadata:v?.metadata}}),l)}catch(D){return this.i.error(D,r.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,M.$5i)(D)),responseIsIncomplete:!0}}}finally{f.close()}}async k(t,d){const h=[];for(const l of d.history){const r=k.ChatAgentResult.to(l.result),g=t===l.request.agentId?r:{...r,metadata:void 0};h.push(new c.$iO(l.request.message,l.request.command,l.request.variables.variables.map(k.ChatAgentResolvedVariable.to),{extensionId:"",name:l.request.agentId}));const f=(0,u.$Hb)(l.response.map(D=>k.ChatResponsePart.fromContent(D,this.j.converter)));h.push(new c.$jO(f,g,{extensionId:"",name:l.request.agentId},l.request.command))}return h}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,d,h,l,r){const g=this.c.get(d);if(!g)return Promise.resolve([]);const f=await this.k(g.id,l),D=k.ChatAgentResult.to(h);return(await g.provideFollowups(D,{history:f},r)).filter(p=>{const v=!p.participant||A.Iterable.some(this.c.values(),y=>y.id===p.participant&&w.$Cm.equals(y.extension.identifier,g.extension.identifier));return v||this.i.warn(`[@${g.id}] ChatFollowup refers to an unknown participant: ${p.participant}`),v}).map(p=>k.ChatFollowup.from(p,t))}$acceptFeedback(t,d,h,l){const r=this.c.get(t);if(!r)return;const g=k.ChatAgentResult.to(d);let f;switch(h){case m.InteractiveSessionVoteDirection.Down:f=c.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:f=c.ChatResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze(l?{result:g,kind:f,reportIssue:l}:{result:g,kind:f}))}$acceptAction(t,d,h){const l=this.c.get(t);if(!l||h.action.kind==="vote")return;const r=k.ChatAgentUserActionEvent.to(d,h,this.j.converter);r&&l.acceptAction(Object.freeze(r))}async $invokeCompletionProvider(t,d,h){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(d,h)).map(k.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,d){const h=this.c.get(t);if(h)return await h.provideWelcomeMessage(d)}async $provideSampleQuestions(t,d){const h=this.c.get(t);if(h)return(await h.provideSampleQuestions(d)).map(l=>k.ChatFollowup.from(l,void 0))}}e.$Qic=i;class s{constructor(t,d,h,l,r){this.extension=t,this.id=d,this.x=h,this.y=l,this.z=r,this.o=new P.$7d,this.p=new P.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,d){return this.s?await this.s.provider.provideCompletionItems(t,d)??[]:[]}async provideFollowups(t,d,h){if(!this.b)return[];const l=await this.b.provideFollowups(t,d,h);return l?l.filter(r=>!(r&&"commandId"in r)).filter(r=>!(r&&"message"in r)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const d=await this.t.provideWelcomeMessage(t);return d?d.map(h=>typeof h=="string"?h:k.MarkdownString.from(h)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const d=await this.t.provideSampleQuestions(t);return d||[]}get apiAgent(){let t=!1,d=!1;const h=()=>{t||d||(d=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof R.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof c.$eN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:k.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),d=!1}))},l=this;return{get name(){return l.id},get description(){return l.c??""},set description(r){l.c=r,h()},get fullName(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.d??l.extension.displayName??l.extension.name},set fullName(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.d=r,h()},get iconPath(){return l.g},set iconPath(r){l.g=r,h()},get requestHandler(){return l.z},set requestHandler(r){(0,E.$5f)(typeof r=="function","Invalid request handler"),l.z=r},get followupProvider(){return l.b},set followupProvider(r){l.b=r,h()},get isDefault(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.i},set isDefault(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.i=r,h()},get helpTextPrefix(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.j},set helpTextPrefix(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.j=r,h()},get helpTextVariablesPrefix(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.k},set helpTextVariablesPrefix(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.k=r,h()},get helpTextPostfix(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.l},set helpTextPostfix(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.l=r,h()},get isSecondary(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.n},set isSecondary(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.n=r,h()},get sampleRequest(){return l.m},set sampleRequest(r){l.m=r,h()},get supportIssueReporting(){return(0,a.$6F)(l.extension,"chatParticipantAdditions"),l.q},set supportIssueReporting(r){(0,a.$6F)(l.extension,"chatParticipantAdditions"),l.q=r,h()},get onDidReceiveFeedback(){return l.o.event},set participantVariableProvider(r){if((0,a.$6F)(l.extension,"chatParticipantAdditions"),l.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");l.x.$registerAgentCompletionsProvider(l.y,r.triggerCharacters)}else l.x.$unregisterAgentCompletionsProvider(l.y)},get participantVariableProvider(){return(0,a.$6F)(l.extension,"chatParticipantAdditions"),l.s},set welcomeMessageProvider(r){(0,a.$6F)(l.extension,"defaultChatParticipant"),l.t=r,h()},get welcomeMessageProvider(){return(0,a.$6F)(l.extension,"defaultChatParticipant"),l.t},onDidPerformAction:(0,a.$5F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return l.u},set isSticky(r){l.u=r,h()},set requester(r){l.w=r,h()},get requester(){return l.w},dispose(){t=!0,l.b=void 0,l.o.dispose(),l.x.$unregisterAgent(l.y)}}}invoke(t,d,h,l){return this.z(t,d,h,l)}}}),define(ke[328],Ee([1,0,13,3,6,16,7,26]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;class ${static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(M.$gM.MainThreadChatVariables)}async $resolveVariable(I,w,S,k){const c=this.b.get(I);if(c)try{if(c.resolver.resolve2){(0,b.$6F)(c.extension,"chatParticipantAdditions");const m=new E(w,this.c),a=await c.resolver.resolve2(c.data.name,{prompt:S},m.apiObject,k);if(a)return a.map(P.ChatVariable.from)}else{const m=await c.resolver.resolve(c.data.name,{prompt:S},k);if(m)return m.map(P.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(I,w,S,k){const c=$.a++;return this.b.set(c,{extension:I,data:{name:w,description:S},resolver:k}),this.c.$registerVariable(c,{name:w,description:S}),(0,N.$Sc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$Tic=$;class E{constructor(I,w){this.c=I,this.d=w,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let w=function(k){if(I.a){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,k),c}};const I=this,S=k=>{this.d.$handleProgressChunk(this.c,k)};this.b={progress(k){w(this.progress);const c=new A.$fO(k),m=P.ChatResponseProgressPart.to(c);return S(m),this},reference(k){w(this.reference);const c=new A.$hO(k),m=P.ChatResponseReferencePart.to(c);return S(m),this},push(k){w(this.push);const c=P.ChatResponsePart.to(k);return S(c),this}}}return this.b}}}),define(ke[329],Ee([1,0,8,54,4,3,2,82,25,16,7,6,26]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=S;function S(k,c,m){const a=k.getProxy(I.$gM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Em,c.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const f=this.b.get(g.handle);return f?f.value:g}else if(g&&g.$mid===7){const f=g,D=this.b.get(f.commentControlHandle);if(!D)return f;const p=D.getCommentThread(f.commentThreadHandle);return p?p.value:f}else if(g&&(g.$mid===9||g.$mid===8)){const f=this.b.get(g.thread.commentControlHandle);if(!f)return g;const D=f.getCommentThread(g.thread.commentThreadHandle);return D?g.$mid===8?D.value:{thread:D.value,text:g.text}:g}else if(g&&g.$mid===10){const f=this.b.get(g.thread.commentControlHandle);if(!f)return g;const D=f.getCommentThread(g.thread.commentThreadHandle);if(!D)return g;const p=g.commentUniqueId,v=D.getCommentByUniqueId(p);return v||g}else if(g&&g.$mid===11){const f=this.b.get(g.thread.commentControlHandle);if(!f)return g;const D=f.getCommentThread(g.thread.commentThreadHandle);if(!D)return g;const p=g.text,v=g.commentUniqueId,y=D.getCommentByUniqueId(v);return y?(typeof y.body=="string"?y.body=p:y.body=new R.$JM(p),y):g}return g}})}createCommentController(g,f,D){const p=n.a++,v=new s(g,p,f,D);this.b.set(v.handle,v);const y=this.c.get(g.identifier)||[];return y.push(v),this.c.set(g.identifier,y),v.value}async $createCommentThreadTemplate(g,f,D){const p=this.b.get(g);p&&p.$createCommentThreadTemplate(f,D)}async $setActiveComment(g,f){const D=this.b.get(g);D&&D.$setActiveComment(f??void 0)}async $updateCommentThreadTemplate(g,f,D){const p=this.b.get(g);p&&p.$updateCommentThreadTemplate(f,D)}$deleteCommentThread(g,f){this.b.get(g)?.$deleteCommentThread(f)}async $provideCommentingRanges(g,f,D){const p=this.b.get(g);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await m.ensureDocumentData(A.URI.revive(f));return(0,u.$_g)(async()=>{const y=await p.commentingRangeProvider.provideCommentingRanges(v.document,D);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(O=>E.Range.from(O)),fileComments:y.fileComments}),C})}$toggleReaction(g,f,D,p,v){const y=this.b.get(g);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,u.$_g)(()=>{const C=y.getCommentThread(f);if(C){const O=C.getCommentByUniqueId(p.uniqueIdInThread);if(y!==void 0&&O&&y.reactionHandler)return y.reactionHandler(O,d(v))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,f,D,p,v,y,C,O){this.m=f,this.n=D,this.o=p,this.p=v,this.q=y,this.extensionDescription=C,this.r=O,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Vc,this.l.value=new P.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),a.$createCommentThread(f,this.handle,this.n,this.o,E.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{a.$deleteCommentThread(f,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(T){z.range=T},get comments(){return z.comments},set comments(T){z.comments=T},get collapsibleState(){return z.collapsibleState},set collapsibleState(T){z.collapsibleState=T},get canReply(){return z.canReply},set canReply(T){z.canReply=T},get contextValue(){return z.contextValue},set contextValue(T){z.contextValue=T},get label(){return z.label},set label(T){z.label=T},get state(){return z.state},set state(T){z.state=T},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Tc);const g=D=>Object.prototype.hasOwnProperty.call(this.b,D),f={};g("range")&&(f.range=E.Range.from(this.p)),g("label")&&(f.label=this.label),g("contextValue")&&(f.contextValue=this.contextValue??null),g("comments")&&(f.comments=this.q.map(D=>o(this,D,this.k,this.extensionDescription))),g("collapsibleState")&&(f.collapseState=h(this.g)),g("canReply")&&(f.canReply=this.canReply),g("state")&&(f.state=l(this.h)),g("isTemplate")&&(f.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,f)}getCommentByUniqueId(g){for(const f of this.k){const D=f[0],p=f[1];if(g===p)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Je([(0,N.$Mh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class s{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,w.$6F)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,w.$6F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,w.$6F)(this.h,"activeComment"),this.f}constructor(g,f,D,p){this.h=g,this.i=f,this.j=D,this.k=p,this.a=new Map,a.$registerCommentController(this.handle,D,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(y){v.options=y},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(y){v.commentingRangeProvider=y},get reactionHandler(){return v.reactionHandler},set reactionHandler(y){v.reactionHandler=y},get activeCommentThread(){return v.activeCommentThread},createCommentThread(y,C,O){return v.createCommentThread(y,C,O).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(g,f,D){f===void 0&&(0,w.$6F)(this.h,"fileComments");const p=new i(this.id,this.handle,void 0,g,f,D,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const f=this.a.get(g.commentThreadHandle);f&&(this.e=g.uniqueIdInThread?f.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=f)}$createCommentThreadTemplate(g,f){const D=new i(this.id,this.handle,void 0,A.URI.revive(g),E.Range.to(f),[],this.h,!0);return D.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(g,f){const D=this.a.get(g);D&&(D.range=E.Range.to(f))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function o(r,g,f,D){let p=f.get(g);return p||(p=++r.commentHandle,f.set(g,p)),g.state!==void 0&&(0,w.$6F)(D,"commentsDraftState"),g.reactions?.some(v=>v.reactors!==void 0)&&(0,w.$6F)(D,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:p,body:typeof g.body=="string"?g.body:E.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(v=>t(v)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(r){return{label:r.label,iconPath:r.iconPath?E.$zO(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted,reactors:r.reactors&&r.reactors.length>0&&typeof r.reactors[0]!="string"?r.reactors.map(g=>g.name):r.reactors}}function d(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1,reactors:r.reactors?.map(g=>({name:g}))}}function h(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new n}}),define(ke[330],Ee([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class S{constructor(d,h){this.document=d,this.b=h,this.a=1,this.c=new R.$Aic("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,h){await this.f(d).undo(),h||this.disposeBackup()}async redo(d,h){await this.f(d).redo(),h||this.disposeBackup()}disposeEdits(d){for(const h of d)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=o(this.document.uri)+this.a++;return(0,A.$Ug)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const h=this.c.get(d,0);if(!h)throw new Error("No edit found");return h}}class k{constructor(){this.a=new Map}get(d,h){return this.a.get(this.b(d,h))}add(d,h,l){const r=this.b(d,h.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${d} resource:${h.uri}`);const g=new S(h,l);return this.a.set(r,g),g}delete(d,h){const l=this.b(d,h.uri);this.a.delete(l)}b(d,h){return`${d}@@@${h}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class m{constructor(){this.a=new Map}addTextProvider(d,h,l){return this.b(0,d,h,l)}addCustomProvider(d,h,l){return this.b(1,d,h,l)}get(d){return this.a.get(d)}b(d,h,l,r){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:d,extension:l,provider:r}),new w.$iM(()=>this.a.delete(h))}}class a{constructor(d,h,l,r,g){this.d=h,this.f=l,this.g=r,this.h=g,this.b=new m,this.c=new k,this.a=d.getProxy(I.$gM.MainThreadCustomEditors)}registerCustomEditorProvider(d,h,l,r){const g=new M.$Tc;return i(l)?(g.add(this.b.addTextProvider(h,d,l)),this.a.$registerTextEditorProvider((0,E.$ajc)(d),h,r.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,E.$$ic)(d))):(g.add(this.b.addCustomProvider(h,d,l)),n(l)&&g.add(l.onDidChangeCustomDocument(f=>{const D=this.i(h,f.document.uri);if(s(f)){const p=D.addEdit(f);this.a.$onDidEdit(f.document.uri,h,p,f.label)}else this.a.$onContentChange(f.document.uri,h)})),this.a.$registerCustomEditorProvider((0,E.$ajc)(d),h,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,E.$$ic)(d))),w.$iM.from(g,new w.$iM(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(d,h,l,r,g){const f=this.b.get(h);if(!f)throw new Error(`No provider found for '${h}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${h}'`);const D=b.URI.revive(d),p=await f.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:r?.buffer},g);let v;return n(f.provider)&&this.f&&(v=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(h,p,v),{editable:n(f.provider)}}async $disposeCustomDocument(d,h){const l=this.b.get(h);if(!l)throw new Error(`No provider found for '${h}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${h}'`);const r=b.URI.revive(d),{document:g}=this.i(h,r);this.c.delete(h,g),g.dispose()}async $resolveCustomEditor(d,h,l,r,g,f){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const p=$.ViewColumn.to(g),v=this.g.createNewWebview(h,r.contentOptions,D.extension),y=this.h.createNewWebviewPanel(h,l,r.title,p,r.options,v,r.active),C=b.URI.revive(d);switch(D.type){case 1:{const{document:O}=this.i(l,C);return D.provider.resolveCustomEditor(O,y,f)}case 0:{const O=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(O,y,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,h,l){this.i(h,d).disposeEdits(l)}async $onMoveCustomEditor(d,h,l){const r=this.b.get(l);if(!r)throw new Error(`No provider found for '${l}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const g=this.h.getWebviewPanel(d);if(!g)throw new Error("No webview found");const f=b.URI.revive(h),D=this.d.getDocument(f);await r.provider.moveCustomTextEditor(D,g,u.CancellationToken.None)}async $undo(d,h,l,r){return this.i(h,d).undo(l,r)}async $redo(d,h,l,r){return this.i(h,d).redo(l,r)}async $revert(d,h,l){const r=this.i(h,d);await this.j(h).revertCustomDocument(r.document,l),r.disposeBackup()}async $onSave(d,h,l){const r=this.i(h,d);await this.j(h).saveCustomDocument(r.document,l),r.disposeBackup()}async $onSaveAs(d,h,l,r){const g=this.i(h,d);return this.j(h).saveCustomDocumentAs(g.document,b.URI.revive(l),r)}async $backup(d,h,l){const r=this.i(h,d),f=await this.j(h).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},l);return r.updateBackup(f),f.id}i(d,h){const l=this.c.get(d,b.URI.revive(h));if(!l)throw new Error("No custom document found");return l}j(d){const l=this.b.get(d)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$djc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const d=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,N.$8i)(d)+""}}),define(ke[331],Ee([1,0,218,138,2,6,7,16,4,12,28,59]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0;class S{#e;#t;#i;constructor(m,a,n,i,s,o,t,d){this.d=m,this.e=a,this.f=n,this.g=i,this.h=s,this.c=!1,this.f=Math.max(i,n),this.#i=new R.$Bc(h=>o.getComparisonKey(h)),this.#e=t,this.#t=d}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,a){if(!m){this.clear();return}this.j();let n=[];if(M.URI.isUri(m)){if(!a){this.delete(m);return}this.#i.set(m,a.slice()),n=[m]}else if(Array.isArray(m)){n=[];let o;m=[...m].sort(S.k);for(const t of m){const[d,h]=t;if((!o||d.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=d,n.push(d),this.#i.set(d,[])),h)this.#i.get(d)?.push(...h);else{const l=this.#i.get(d);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let s=0;for(const o of n){let t=[];const d=this.#i.get(o);if(d)if(d.length>this.g){t=[];const h=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const r of d)if(r.severity===h[l]&&t.push({...b.Diagnostic.from(r),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,u.localize)(0,null,d.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(h=>({...b.Diagnostic.from(h),modelVersionId:this.h(o)}));if(i.push([o,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,a){this.j();for(const[n,i]of this)m.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const a=this.#i.get(m);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,a){return m[0].toString()<a[0].toString()?-1:m[0].toString()>a[0].toString()?1:0}}e.$Hic=S;let k=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(m){const a=new R.$Bc;for(const n of m)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(m,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new $.$$d({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,w._mapper),this.f=m.getProxy(P.$gM.MainThreadDiagnostics)}createDiagnosticCollection(m,a){const{g:n,f:i,h:s,j:o,k:t,l:d}=this,h=new class{$changeMany(g,f){i.$changeMany(g,f),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,g,f.length===0?"CLEARING":f)}$clear(g){i.$clear(g),o.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,g)}dispose(){i.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+w.c++,l=a;else if(!n.has(a))l=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+w.c++;while(n.has(l))}return new class extends S{constructor(){super(a,l,w.e,w.d,g=>d.getDocument(g)?.version,t.extUri,h,s),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((s,o)=>{let t=a.get(s.toString());typeof t>"u"&&(t=n.length,a.set(s.toString(),t),n.push([s,[]])),n[t][1]=n[t][1].concat(...o)});return n}}m(m){let a=[];for(const n of this.g.values())n.has(m)&&(a=a.concat(n.get(m)));return a}$acceptMarkersChange(m){if(!this.n){const a="_generated_mirror",n=new S(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of m)this.n.set(M.URI.revive(a),n.map(b.Diagnostic.to))}};e.$Iic=k,e.$Iic=k=w=Je([Ve(1,E.$Nj),Ve(2,I.$Gic)],k)}),define(ke[332],Ee([1,0,2,13,7,16,74]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class b{constructor(E,R,I,w={timeout:1500,errors:3}){this.c=E,this.d=R,this.f=I,this.g=w,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(R,I,w)=>{const k={dispose:this.a.push([R,I,E])};return Array.isArray(w)&&w.push(k),k}}async $participateInSave(E,R){const I=u.URI.revive(E);let w=!1;const S=setTimeout(()=>w=!0,this.g.timeout),k=[];try{for(const c of[...this.a]){if(w)break;const m=this.d.getDocument(I),a=await this.h(c,{document:m,reason:P.TextDocumentSaveReason.to(R)});k.push(a)}}finally{clearTimeout(S)}return k}h([E,R,I],w){const S=this.b.get(E);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(I,E,R,w).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const c=this.b.get(E);this.b.set(E,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,R,I,w){const S=[],k=Date.now(),{document:c,reason:m}=w,{version:a}=c,n=Object.freeze({document:c,reason:m,waitUntil(i){if(Object.isFrozen(S))throw(0,N.$8)("waitUntil can not be called async");S.push(Promise.resolve(i))}});try{R.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(S),new Promise((i,s)=>{const o=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(o),i(t)}).catch(t=>{clearTimeout(o),s(t)})}).then(i=>{const s={edits:[]};for(const o of i)if(Array.isArray(o)&&o.every(t=>t instanceof M.$pM))for(const{newText:t,newEol:d,range:h}of o)s.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:h&&P.Range.from(h),text:t,eol:d&&P.EndOfLine.from(d)}});if(s.edits.length!==0)return a===c.version?this.f.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.$Rjc=b}),define(ke[333],Ee([1,0,4,3,2,6,152,16,18,24,7]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class I{constructor(S,k){this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=S.getProxy(P.$gM.MainThreadDocuments),this.g=k,this.g.onDidRemoveDocuments(c=>{for(const m of c)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const m of c)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const k=this.g.getDocument(S);if(k)return k}getDocument(S){const k=this.getDocumentData(S);if(!k?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return k.document}ensureDocumentData(S){const k=this.g.getDocument(S);if(k)return Promise.resolve(k);let c=this.h.get(S.toString());return c||(c=this.f.$tryOpenDocument(S).then(m=>{this.h.delete(S.toString());const a=M.URI.revive(m);return(0,$.$6f)(this.g.getDocument(a))},m=>(this.h.delete(S.toString()),Promise.reject(m))),this.h.set(S.toString(),c)),c}createDocumentData(S){return this.f.$tryCreateDocument(S).then(k=>M.URI.revive(k))}$acceptModelLanguageChanged(S,k){const c=M.URI.revive(S),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(k),this.a.fire(m.document)}$acceptModelSaved(S){const k=M.URI.revive(S),c=this.g.getDocument(k);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(S,k){const c=M.URI.revive(S),m=this.g.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(k),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,k,c){const m=M.URI.revive(S),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");a._acceptIsDirty(c),a.onEvents(k);let n;k.isUndoing?n=R.TextDocumentChangeReason.Undo:k.isRedoing&&(n=R.TextDocumentChangeReason.Redo),this.c.fire((0,E.$On)({document:a.document,contentChanges:k.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(S,k){(0,A.$CO)(S,k)}}e.$Jic=I}),define(ke[70],Ee([1,0,72,4,18,2,5,6,20,16,7]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=e.$ejc=void 0,e.$ejc=(0,A.$hi)("IExtHostEditorTabs");class I{constructor(m,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$4N(P.URI.revive(this.b.input.uri));case 2:return new R.$5N(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$6N(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$7N(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$8N(this.b.input.viewType);case 4:return new R.$9N(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$0N(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$$N;case 9:return new R.$_N(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$aO(this.b.input.providerId);default:return}}}class w{constructor(m,a){this.c=[],this.d="",this.b=m,this.e=a;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return E.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new I(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const a=this.c.find(n=>n.tabId===m.tabDto.id);if(!a)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(m.tabDto),a}activeTabId(){return this.d}}let S=class{constructor(m){this.b=new N.$7d,this.c=new N.$7d,this.e=[],this.a=m.getProxy(b.$gM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,a={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,M.$6f)(m.e.find(s=>s.groupId===n)?.apiObject)},close:async(n,i)=>{const s=Array.isArray(n)?n:[n];return s.length?k(s[0])?this.j(s,i):this.i(s,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(m){const a=new Set(this.e.map(h=>h.groupId)),n=new Set(m.map(h=>h.groupId)),i=(0,u.$L)(a,n),s=this.e.filter(h=>i.removed.includes(h.groupId)).map(h=>h.apiObject),o=[],t=[];this.e=m.map(h=>{const l=new w(h,()=>this.d);return i.added.includes(l.groupId)?o.push(l.apiObject):t.push(l.apiObject),l});const d=(0,M.$6f)(m.find(h=>h.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:o,closed:s,changed:t}))}$acceptTabGroupUpdate(m){const a=this.e.find(n=>n.groupId===m.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const a=this.e.find(i=>i.groupId===m.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(a=>a.apiObject===m)}async i(m,a){const n=[];for(const i of m){const s=this.g(i);if(!s)throw new Error("Tab close: Invalid tab not found!");n.push(s.tabId)}return this.a.$closeTab(n,a)}async j(m,a){const n=[];for(const i of m){const s=this.h(i);if(!s)throw new Error("Group close: Invalid group not found!");n.push(s.groupId)}return this.a.$closeGroup(n,a)}};e.$fjc=S,e.$fjc=S=Je([Ve(0,$.$AO)],S);function k(c){return c.tabs!==void 0}}),define(ke[334],Ee([1,0,2,6,3,7,16,179,14,21,26,79]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class w{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const m=this.a.indexOf(c);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),m=[];let a,n,i=14,s=14;for(const o of c){let t=a?(0,$.$nf)(a,o):0;for(t===0?n=1:n=s;t<o.length;t++)t+1===o.length?(i=s,s=9):s+=1,m.push([n,o.toUpperCase().charCodeAt(t),s]),m.push([n,o.toLowerCase().charCodeAt(t),s]),n=s;a=o,s=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new b.$j2(m)}}provideDocumentLinks(c){this.c();const m=[],a=b.$k2.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of a){const i=A.DocumentLink.to(n);i.target&&m.push(i)}return m}}class S{constructor(c,m){this.i=m,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(N.$gM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,m,a,n={}){if(S.j(a),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,a);let s=2;n.isCaseSensitive&&(s+=1024),n.isReadonly&&(s+=2048),typeof a.copy=="function"&&(s+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,R.$6F)(c,"fsChunks"),s+=4);let o;n.isReadonly&&(0,I.$Gk)(n.isReadonly)&&n.isReadonly.value!==""&&(o={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,s,o).catch(d=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${m}`),console.error(d)});const t=a.onDidChangeFile(d=>{const h=[];for(const l of d){const{uri:r,type:g}=l;if(r.scheme!==m)continue;let f;switch(g){case P.FileChangeType.Changed:f=0;break;case P.FileChangeType.Created:f=1;break;case P.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:r,type:f})}this.a.$onFileSystemChange(i,h)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:m,ctime:a,mtime:n,size:i,permissions:s}=c;return{type:m,ctime:a,mtime:n,size:i,permissions:s}}$stat(c,m){return Promise.resolve(this.l(c).stat(u.URI.revive(m))).then(a=>S.k(a))}$readdir(c,m){return Promise.resolve(this.l(c).readDirectory(u.URI.revive(m)))}$readFile(c,m){return Promise.resolve(this.l(c).readFile(u.URI.revive(m))).then(a=>E.$ue.wrap(a))}$writeFile(c,m,a,n){return Promise.resolve(this.l(c).writeFile(u.URI.revive(m),a.buffer,n))}$delete(c,m,a){return Promise.resolve(this.l(c).delete(u.URI.revive(m),a))}$rename(c,m,a,n){return Promise.resolve(this.l(c).rename(u.URI.revive(m),u.URI.revive(a),n))}$copy(c,m,a,n){const i=this.l(c);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(a),n))}$mkdir(c,m){return Promise.resolve(this.l(c).createDirectory(u.URI.revive(m)))}$watch(c,m,a,n){const i=this.l(c).watch(u.URI.revive(a),n);this.f.set(m,i)}$unwatch(c,m){const a=this.f.get(m);a&&(a.dispose(),this.f.delete(m))}$open(c,m,a){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),a))}$close(c,m){const a=this.l(c);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(m))}$read(c,m,a,n){const i=this.l(c);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const s=E.$ue.alloc(n);return Promise.resolve(i.read(m,a,s.buffer,0,n)).then(o=>s.slice(0,o))}$write(c,m,a,n){const i=this.l(c);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,a,n.buffer,0,n.byteLength))}l(c){const m=this.c.get(c);if(!m){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return m}}e.$Tjc=S}),define(ke[335],Ee([1,0,4,35,2,6,16,7,44]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,k,c,m,a,n){this.a=Math.random(),this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$bk)(a),s=typeof a=="string",o=n?.correlate,t=m(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(o&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const h of d.created){const l=M.URI.revive(h);i(l.fsPath)&&(!s||k.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const h of d.changed){const l=M.URI.revive(h);i(l.fsPath)&&(!s||k.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const h of d.deleted){const l=M.URI.revive(h);i(l.fsPath)&&(!s||k.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$iM.from(this.i(S,c,a,n,n?.correlate),this.b,this.c,this.d,t)}i(S,k,c,m,a){const n=b.$iM.from();if(typeof c=="string")return n;const i=S.getProxy(P.$gM.MainThreadFileSystemEventService);let s=!1;return(c.pattern.includes(N.$0j)||c.pattern.includes(N.$$j))&&(s=!0),i.$watch(k.identifier.value,this.a,c.baseUri,{recursive:s,excludes:m?.excludes??[]},!!a),b.$iM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(S){this.a=S,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(M.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(S,k,c){this.j=S,this.k=k,this.l=c,this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.g=new u.$9d,this.h=new u.$9d,this.i=new u.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,k,c,m){return new E(this.j,S,k,this.a.event,A.GlobPattern.from(c),m)}$onFileEvent(S){this.a.fire(new R(S))}$onDidRunFileOperation(S,k){switch(S){case 2:this.b.fire(Object.freeze({files:k.map(c=>({oldUri:M.URI.revive(c.source),newUri:M.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(c=>M.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(c=>M.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,k){return(c,m,a)=>{const n=function(s){c.call(m,s)};return n.extension=S,k.event(n,void 0,a)}}async $onWillRunFileOperation(S,k,c,m){switch(S){case 2:return await this.n(this.g,{files:k.map(a=>({oldUri:M.URI.revive(a.source),newUri:M.URI.revive(a.target)}))},c,m);case 1:return await this.n(this.i,{files:k.map(a=>M.URI.revive(a.target))},c,m);case 0:case 3:return await this.n(this.h,{files:k.map(a=>M.URI.revive(a.target))},c,m)}}async n(S,k,c,m){const a=new Set,n=[];if(await S.fireAsync(k,m,async(s,o)=>{const t=Date.now(),d=await Promise.resolve(s);d instanceof b.$sM&&(n.push([o.extension,d]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",o.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,s]of n){const{edits:o}=A.WorkspaceEdit.from(s,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(o)}return{edit:i,extensionNames:Array.from(a)}}}e.$Ujc=I}),define(ke[336],Ee([1,0,19,8,22,13,124,3,24,38,14,18,2,29,175,82,134,220,25,16,7,26,111,6]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class h{constructor(V,q){this.d=V,this.e=q}async provideDocumentSymbols(V,q){const Y=this.d.getDocument(V),J=await this.e.provideDocumentSymbols(Y,q);if(!(0,u.$Kb)(J))return J[0]instanceof s.$BM?J.map(i.DocumentSymbol.from):h.f(J)}static f(V){V=V.slice(0).sort((J,ge)=>{let we=J.location.range.start.compareTo(ge.location.range.start);return we===0&&(we=ge.location.range.end.compareTo(J.location.range.end)),we});const q=[],Y=[];for(const J of V){const ge={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Y.length===0){Y.push(ge),q.push(ge);break}const we=Y[Y.length-1];if(S.$at.containsRange(we.range,ge.range)&&!S.$at.equalsRange(we.range,ge.range)){we.children?.push(ge),Y.push(ge);break}Y.pop()}}return q}}class l{constructor(V,q,Y,J,ge,we){this.f=V,this.g=q,this.h=Y,this.j=J,this.k=ge,this.l=we,this.d=new t.$Aic("CodeLens"),this.e=new Map}async provideCodeLenses(V,q){const Y=this.f.getDocument(V),J=await this.h.provideCodeLenses(Y,q);if(!J||q.isCancellationRequested)return;const ge=this.d.add(J),we=new b.$Tc;this.e.set(ge,we);const Te={cacheId:ge,lenses:[]};for(let He=0;He<J.length;He++)Te.lenses.push({cacheId:[ge,He],range:i.Range.from(J[He].range),command:this.g.toInternal(J[He].command,we)});return Te}async resolveCodeLens(V,q){const Y=V.cacheId&&this.d.get(...V.cacheId);if(!Y)return;let J;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?J=Y:J=await this.h.resolveCodeLens(Y,q),J||(J=Y),q.isCancellationRequested)return;const ge=V.cacheId&&this.e.get(V.cacheId[0]);if(ge){if(!J.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return V.command=this.g.toInternal(J.command,ge),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function r(Be){return Array.isArray(Be)?Be.map(i.DefinitionLink.from):Be?[i.DefinitionLink.from(Be)]:[]}class g{constructor(V,q){this.d=V,this.e=q}async provideDefinition(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideDefinition(J,ge,Y);return r(we)}}class f{constructor(V,q){this.d=V,this.e=q}async provideDeclaration(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideDeclaration(J,ge,Y);return r(we)}}class D{constructor(V,q){this.d=V,this.e=q}async provideImplementation(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideImplementation(J,ge,Y);return r(we)}}class p{constructor(V,q){this.d=V,this.e=q}async provideTypeDefinition(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideTypeDefinition(J,ge,Y);return r(we)}}class v{constructor(V,q){this.d=V,this.e=q}async provideHover(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideHover(J,ge,Y);if(!(!we||(0,u.$Kb)(we.contents)))return we.range||(we.range=J.getWordRangeAtPosition(ge)),we.range||(we.range=new s.$kM(ge,ge)),i.Hover.from(we)}}class y{constructor(V,q){this.d=V,this.e=q}async provideEvaluatableExpression(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideEvaluatableExpression(J,ge,Y);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(V,q){this.d=V,this.e=q}async provideInlineValues(V,q,Y,J){const ge=this.d.getDocument(V),we=await this.e.provideInlineValues(ge,i.Range.to(q),i.InlineValueContext.to(Y),J);if(Array.isArray(we))return we.map(Te=>i.InlineValue.from(Te))}}class O{constructor(V,q){this.d=V,this.e=q}async provideDocumentHighlights(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideDocumentHighlights(J,ge,Y);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class z{constructor(V,q){this.d=V,this.e=q}async provideMultiDocumentHighlights(V,q,Y,J){const ge=this.d.getDocument(V),we=Y.map(Xe=>this.d.getDocument(Xe)),Te=i.Position.to(q),He=await this.e.provideMultiDocumentHighlights(ge,Te,we,J);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class T{constructor(V,q){this.d=V,this.e=q}async provideLinkedEditingRanges(V,q,Y){const J=this.d.getDocument(V),ge=i.Position.to(q),we=await this.e.provideLinkedEditingRanges(J,ge,Y);if(we&&Array.isArray(we.ranges))return{ranges:(0,u.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class B{constructor(V,q){this.d=V,this.e=q}async provideReferences(V,q,Y,J){const ge=this.d.getDocument(V),we=i.Position.to(q),Te=await this.e.provideReferences(ge,we,Y,J);if(Array.isArray(Te))return Te.map(i.location.from)}}class j{static{this.d=1e3}constructor(V,q,Y,J,ge,we,Te){this.g=V,this.h=q,this.j=Y,this.k=J,this.l=ge,this.m=we,this.n=Te,this.e=new t.$Aic("CodeAction"),this.f=new Map}async provideCodeActions(V,q,Y,J){const ge=this.g.getDocument(V),we=k.$ct.isISelection(q)?i.Selection.to(q):i.Range.to(q),Te=[];for(const rt of this.j.getDiagnostics(V))if(we.intersection(rt.range)&&Te.push(rt)>j.d)break;const He={diagnostics:Te,only:Y.only?new s.$DM(Y.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Y.trigger)},Xe=await this.k.provideCodeActions(ge,we,He,J);if(!(0,u.$Lb)(Xe)||J.isCancellationRequested)return;const tt=this.e.add(Xe),nt=new b.$Tc;this.f.set(tt,nt);const at=[];for(let rt=0;rt<Xe.length;rt++){const Ce=Xe[rt];if(Ce)if(j.o(Ce))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Ce.title,command:this.h.toInternal(Ce,nt)});else{He.only&&(Ce.kind?He.only.contains(Ce.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Ce.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ze=Ce.ranges??[];at.push({cacheId:[tt,rt],title:Ce.title,command:Ce.command&&this.h.toInternal(Ce.command,nt),diagnostics:Ce.diagnostics&&Ce.diagnostics.map(i.Diagnostic.from),edit:Ce.edit&&i.WorkspaceEdit.from(Ce.edit,void 0),kind:Ce.kind&&Ce.kind.value,isPreferred:Ce.isPreferred,isAI:(0,o.$5F)(this.m,"codeActionAI")?Ce.isAI:!1,ranges:(0,o.$5F)(this.m,"codeActionRanges")?(0,u.$Hb)(ze.map(i.Range.from)):void 0,disabled:Ce.disabled?.reason})}}return{cacheId:tt,actions:at}}async resolveCodeAction(V,q){const[Y,J]=V,ge=this.e.get(Y,J);if(!ge||j.o(ge))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(ge,q)??ge;let Te;we.edit&&(Te=i.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const Xe=this.f.get(Y);Xe&&(He=this.h.toInternal(we.command,Xe))}return{edit:Te,command:He}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class F{constructor(V,q,Y,J,ge){this.e=V,this.f=q,this.g=Y,this.h=J,this.j=ge,this.d=new t.$Aic("DocumentPasteEdit")}async prepareDocumentPaste(V,q,Y,J){if(!this.g.prepareDocumentPaste)return;const ge=this.f.getDocument(V),we=q.map(Xe=>i.Range.to(Xe)),Te=i.DataTransfer.toDataTransfer(Y,()=>{throw new P.$$});if(await this.g.prepareDocumentPaste(ge,we,Te,J),J.isCancellationRequested)return;const He=Array.from(Te).filter(([,Xe])=>!(Xe instanceof s.$0M));return i.DataTransfer.from(He)}async providePasteEdits(V,q,Y,J,ge,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(q),He=Y.map(at=>i.Range.to(at)),Xe=i.DataTransfer.toDataTransfer(J,async at=>(await this.e.$resolvePasteFileData(this.h,V,at)).buffer),tt=await this.g.provideDocumentPasteEdits(Te,He,Xe,{only:ge.only?new s.$cN(ge.only):void 0,triggerKind:ge.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const nt=this.d.add(tt);return tt.map((at,rt)=>({_cacheId:[nt,rt],title:at.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,detail:this.j.displayName||this.j.name,yieldTo:at.yieldTo?.map(Ce=>"mimeType"in Ce?Ce:{kind:Ce.kind.value}),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,q){const[Y,J]=V,ge=this.d.get(Y,J);if(!ge||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(ge,q)??ge;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class L{constructor(V,q){this.d=V,this.e=q}async provideDocumentFormattingEdits(V,q,Y){const J=this.d.getDocument(V),ge=await this.e.provideDocumentFormattingEdits(J,q,Y);if(Array.isArray(ge))return ge.map(i.TextEdit.from)}}class G{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeFormattingEdits(V,q,Y,J){const ge=this.d.getDocument(V),we=i.Range.to(q),Te=await this.e.provideDocumentRangeFormattingEdits(ge,we,Y,J);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,q,Y,J){(0,I.$5f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ge=this.d.getDocument(V),we=q.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(ge,we,Y,J);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class te{constructor(V,q){this.d=V,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,q,Y,J,ge){const we=this.d.getDocument(V),Te=i.Position.to(q),He=await this.e.provideOnTypeFormattingEdits(we,Te,Y,J,ge);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class Z{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Aic("WorkspaceSymbols")}async provideWorkspaceSymbols(V,q){const Y=await this.e.provideWorkspaceSymbols(V,q);if(!(0,u.$Lb)(Y))return{symbols:[]};const J=this.d.add(Y),ge={cacheId:J,symbols:[]};for(let we=0;we<Y.length;we++){const Te=Y[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}ge.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[J,we]})}return ge}async resolveWorkspaceSymbol(V,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const Y=this.d.get(...V.cacheId);if(Y){const J=await this.e.resolveWorkspaceSymbol(Y,q);return J&&(0,$.$Qn)(V,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class x{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,q,Y){this.d=V,this.e=q,this.f=Y}async provideRenameEdits(V,q,Y,J){const ge=this.d.getDocument(V),we=i.Position.to(q);try{const Te=await this.e.provideRenameEdits(ge,we,Y,J);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=x.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(V,q,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(V),ge=i.Position.to(q);try{const we=await this.e.prepareRename(J,ge,Y);let Te,He;if(s.$kM.isRange(we)?(Te=we,He=J.getText(we)):(0,I.$Wf)(we)&&(Te=we.range,He=we.placeholder),!Te||!He)return;if(Te.start.line>ge.line||Te.end.line<ge.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(we){const Te=x.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class _{constructor(V,q,Y){this.d=V,this.e=q,this.f=Y}async provideNewSymbolNames(V,q,Y){const J=this.d.getDocument(V),ge=i.Range.to(q);try{const we=await this.e.provideNewSymbolNames(J,ge,Y);return we?we.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(we){this.f.error(_.g(we)??JSON.stringify(we,null,"	"));return}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class ue{constructor(V,q){this.resultId=V,this.tokens=q}}class X{constructor(V,q){this.f=V,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,q,Y){const J=this.f.getDocument(V),ge=q!==0?this.d.get(q):null;let we=typeof ge?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,ge.resultId,Y):await this.g.provideDocumentSemanticTokens(J,Y);return ge&&this.d.delete(q),we?(we=X.h(we),this.o(X.n(ge,we),we)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return X.j(V)?X.k(V)?V:new s.$CN(new Uint32Array(V.data),V.resultId):X.l(V)?X.m(V)?V:new s.$EN(V.edits.map(q=>new s.$DN(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const q of V.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(V,q){if(!X.j(q)||!V||!V.tokens)return q;const Y=V.tokens,J=Y.length,ge=q.data,we=ge.length;let Te=0;const He=Math.min(J,we);for(;Te<He&&Y[Te]===ge[Te];)Te++;if(Te===J&&Te===we)return new s.$EN([],q.resultId);let Xe=0;const tt=He-Te;for(;Xe<tt&&Y[J-Xe-1]===ge[we-Xe-1];)Xe++;return new s.$EN([{start:Te,deleteCount:J-Te-Xe,data:ge.subarray(Te,we-Xe)}],q.resultId)}o(V,q){if(X.j(V)){const Y=this.e++;return this.d.set(Y,new ue(V.resultId,V.data)),(0,m.$qab)({id:Y,type:"full",data:V.data})}if(X.l(V)){const Y=this.e++;return X.j(q)?this.d.set(Y,new ue(q.resultId,q.data)):this.d.set(Y,new ue(V.resultId)),(0,m.$qab)({id:Y,type:"delta",deltas:(V.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class $e{constructor(V,q){this.d=V,this.e=q}async provideDocumentRangeSemanticTokens(V,q,Y){const J=this.d.getDocument(V),ge=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(q),Y);return ge?this.f(ge):null}f(V){return(0,m.$qab)({id:0,type:"full",data:V.data})}}class se{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,q,Y,J,ge){this.f=V,this.g=q,this.h=Y,this.j=J,this.k=ge,this.d=new t.$Aic("CompletionItem"),this.e=new Map}async provideCompletionItems(V,q,Y,J){const ge=this.f.getDocument(V),we=i.Position.to(q),Te=ge.getWordRangeAtPosition(we)||new s.$kM(we,we),He=Te.with({end:we}),Xe=new E.$3d,tt=await this.h.provideCompletionItems(ge,we,J,i.CompletionContext.to(Y));if(!tt||J.isCancellationRequested)return;const nt=Array.isArray(tt)?new s.$QM(tt):tt,at=se.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new b.$Tc;this.e.set(at,rt);const Ce=[],ze={x:at,b:Ce,a:{replace:i.Range.from(Te),insert:i.Range.from(He)},c:nt.isIncomplete||void 0,d:Xe.elapsed()};for(let Me=0;Me<nt.items.length;Me++){const Ge=nt.items[Me],ne=this.l(Ge,[at,Me],He,Te);Ce.push(ne)}return ze}async resolveCompletionItem(V,q){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...V);if(!Y)return;const J=this.l(Y,V),ge=await this.h.resolveCompletionItem(Y,q);if(!ge)return;const we=this.l(ge,V);return(J.h!==we.h||J.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==we.n||J.o!==we.o||!(0,$.$Rn)(J.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q,Y,J){const ge=this.e.get(q[0]);if(!ge)throw Error("DisposableStore is missing...");const we=this.g.toInternal(V.command,ge),Te={x:q,a:V.label,b:V.kind!==void 0?i.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(i.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:i.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=V.textEdit.newText):typeof V.insertText=="string"?Te.h=V.insertText:V.insertText instanceof s.$tM&&(Te.h=V.insertText.value,Te.i|=4);let He;return V.textEdit?He=V.textEdit.range:V.range&&(He=V.range),s.$kM.isRange(He)?Te.j=i.Range.from(He):He&&(!Y?.isEqual(He.inserting)||!J?.isEqual(He.replacing))&&(Te.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class re{async provideInlineCompletions(V,q,Y,J){}disposeCompletions(V){}handleDidShowCompletionItem(V,q,Y){}handlePartialAccept(V,q,Y,J){}}class U extends re{constructor(V,q,Y,J){super(),this.f=V,this.g=q,this.h=Y,this.j=J,this.d=new ve,this.e=(0,o.$5F)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,o.$5F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,q,Y,J){const ge=this.g.getDocument(V),we=i.Position.to(q),Te=await this.h.provideInlineCompletionItems(ge,we,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:i.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},J);if(!Te||J.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],tt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:He}),items:He.map((rt,Ce)=>{let ze;rt.command&&(nt||(nt=new b.$Tc),ze=this.j.toInternal(rt.command,nt));const Me=rt.insertText;return{insertText:typeof Me=="string"?Me:{snippet:Me.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:ze,idx:Ce,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Xe.map(rt=>(nt||(nt=new b.$Tc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,q,Y){const J=this.d.get(V)?.items[q];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Y)}handlePartialAccept(V,q,Y,J){const ge=this.d.get(V)?.items[q];ge&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ge,Y),this.h.handleDidPartiallyAcceptCompletionItem(ge,i.PartialAcceptInfo.to(J)))}}class ie{async provideInlineEdits(V,q,Y){const J=this.f.getDocument(V),ge=await this.g.provideInlineEdit(J,{triggerKind:this.e[q.triggerKind]},Y);if(!ge||Y.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:ge});let He;ge.accepted&&(we||(we=new b.$Tc),He=this.h.toInternal(ge.accepted,we));let Xe;return ge.rejected&&(we||(we=new b.$Tc),Xe=this.h.toInternal(ge.rejected,we)),{pid:Te,text:ge.text,range:i.Range.from(ge.range),accepted:He,rejected:Xe}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,q,Y,J){this.f=q,this.g=Y,this.h=J,this.d=new ve,this.e={[c.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const q=this.e++;return this.d.set(q,V),q}disposeReferenceId(V){const q=this.d.get(V);return this.d.delete(V),q}get(V){return this.d.get(V)}}class Ie{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Aic("SignatureHelp")}async provideSignatureHelp(V,q,Y,J){const ge=this.e.getDocument(V),we=i.Position.to(q),Te=this.g(Y),He=await this.f.provideSignatureHelp(ge,we,J,Te);if(He){const Xe=this.d.add([He]);return{...i.SignatureHelp.from(He),id:Xe}}}g(V){let q;if(V.activeSignatureHelp){const Y=i.SignatureHelp.to(V.activeSignatureHelp),J=this.d.get(V.activeSignatureHelp.id,0);J?(q=J,q.activeSignature=Y.activeSignature,q.activeParameter=Y.activeParameter):q=Y}return{...V,activeSignatureHelp:q}}releaseSignatureHelp(V){this.d.delete(V)}}class le{constructor(V,q,Y,J,ge){this.f=V,this.g=q,this.h=Y,this.j=J,this.k=ge,this.d=new t.$Aic("InlayHints"),this.e=new Map}async provideInlayHints(V,q,Y){const J=this.f.getDocument(V),ge=i.Range.to(q),we=await this.h.provideInlayHints(J,ge,Y);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Y.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new b.$Tc);const He={hints:[],cacheId:Te};for(let Xe=0;Xe<we.length;Xe++)this.l(we[Xe],ge)&&He.hints.push(this.m(we[Xe],[Te,Xe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),He}async resolveInlayHint(V,q){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...V);if(!Y)return;const J=await this.h.resolveInlayHint(Y,q);if(J&&this.l(J))return this.m(J,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,q){return V.label.length===0||Array.isArray(V.label)&&V.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(q&&!q.contains(V.position))}m(V,q){const Y=this.e.get(q[0]);if(!Y)throw Error("DisposableStore is missing...");const J={label:"",cacheId:q,tooltip:i.MarkdownString.fromStrict(V.tooltip),position:i.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(i.TextEdit.from),kind:V.kind&&i.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")J.label=V.label;else{const ge=[];J.label=ge;for(const we of V.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};s.$uM.isLocation(we.location)&&(Te.location=i.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,Y)),ge.push(Te)}}return J}}class ae{constructor(V,q){this.e=V,this.f=q,this.d=new t.$Aic("DocumentLink")}async provideLinks(V,q){const Y=this.e.getDocument(V),J=await this.f.provideDocumentLinks(Y,q);if(!(!Array.isArray(J)||J.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ae.g).map(i.DocumentLink.from)};{const ge=this.d.add(J),we={links:[],cacheId:ge};for(let Te=0;Te<J.length;Te++){if(!ae.g(J[Te]))continue;const He=i.DocumentLink.from(J[Te]);He.cacheId=[ge,Te],we.links.push(He)}return we}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,q){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...V);if(!Y)return;const J=await this.f.resolveDocumentLink(Y,q);if(!(!J||!ae.g(J)))return i.DocumentLink.from(J)}releaseLinks(V){this.d.delete(V)}}class ce{constructor(V,q){this.d=V,this.e=q}async provideColors(V,q){const Y=this.d.getDocument(V),J=await this.e.provideDocumentColors(Y,q);return Array.isArray(J)?J.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(V,q,Y){const J=this.d.getDocument(V),ge=i.Range.to(q.range),we=i.Color.to(q.color),Te=await this.e.provideColorPresentations(we,{document:J,range:ge},Y);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class H{constructor(V,q){this.d=V,this.e=q}async provideFoldingRanges(V,q,Y){const J=this.d.getDocument(V),ge=await this.e.provideFoldingRanges(J,q,Y);if(Array.isArray(ge))return ge.map(i.FoldingRange.from)}}class Q{constructor(V,q,Y){this.d=V,this.e=q,this.f=Y}async provideSelectionRanges(V,q,Y){const J=this.d.getDocument(V),ge=q.map(i.Position.to),we=await this.e.provideSelectionRanges(J,ge,Y);if(!(0,u.$Lb)(we))return[];if(we.length!==ge.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<ge.length;He++){const Xe=[];Te.push(Xe);let tt=ge[He],nt=we[He];for(;;){if(!nt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(i.SelectionRange.from(nt)),!nt.parent)break;tt=nt.range,nt=nt.parent}}return Te}}class he{constructor(V,q){this.f=V,this.g=q,this.d=new A.$FO(""),this.e=new Map}async prepareSession(V,q,Y){const J=this.f.getDocument(V),ge=i.Position.to(q),we=await this.g.prepareCallHierarchy(J,ge,Y);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideCallsTo(V,q,Y){const J=this.j(V,q);if(!J)throw new Error("missing call hierarchy item");const ge=await this.g.provideCallHierarchyIncomingCalls(J,Y);if(ge)return ge.map(we=>({from:this.h(V,we.from),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(V,q,Y){const J=this.j(V,q);if(!J)throw new Error("missing call hierarchy item");const ge=await this.g.provideCallHierarchyOutgoingCalls(J,Y);if(ge)return ge.map(we=>({to:this.h(V,we.to),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(V){this.e.delete(V)}h(V,q){const Y=this.e.get(V),J=i.CallHierarchyItem.from(q,V,Y.size.toString(36));return Y.set(J._itemId,q),J}j(V,q){return this.e.get(V)?.get(q)}}class fe{constructor(V,q){this.f=V,this.g=q,this.d=new A.$FO(""),this.e=new Map}async prepareSession(V,q,Y){const J=this.f.getDocument(V),ge=i.Position.to(q),we=await this.g.prepareTypeHierarchy(J,ge,Y);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideSupertypes(V,q,Y){const J=this.j(V,q);if(!J)throw new Error("missing type hierarchy item");const ge=await this.g.provideTypeHierarchySupertypes(J,Y);if(ge)return ge.map(we=>this.h(V,we))}async provideSubtypes(V,q,Y){const J=this.j(V,q);if(!J)throw new Error("missing type hierarchy item");const ge=await this.g.provideTypeHierarchySubtypes(J,Y);if(ge)return ge.map(we=>this.h(V,we))}releaseSession(V){this.e.delete(V)}h(V,q){const Y=this.e.get(V),J=i.TypeHierarchyItem.from(q,V,Y.size.toString(36));return Y.set(J._itemId,q),J}j(V,q){return this.e.get(V)?.get(q)}}class Pe{constructor(V,q,Y,J,ge){this.d=V,this.e=q,this.f=Y,this.g=J,this.h=ge}async provideDocumentOnDropEdits(V,q,Y,J,ge){const we=this.e.getDocument(q),Te=i.Position.to(Y),He=i.DataTransfer.toDataTransfer(J,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,V,tt)).buffer),Xe=await this.f.provideDocumentDropEdits(we,Te,He,ge);if(Xe)return(0,u.$3b)(Xe).map(tt=>({title:tt.title??(0,a.localize)(1,null,this.h.displayName||this.h.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>"mimeType"in nt?nt:{kind:nt.kind.value}),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?i.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}}class be{constructor(V,q){this.d=V,this.e=q}async provideMappedEdits(V,q,Y,J){const ge=w.URI.revive(V),we=this.d.getDocument(ge),Te=Y.documents.map(tt=>tt.map(nt=>({uri:w.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(at=>i.Range.to(at))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(we,q,He,J);return Xe?i.WorkspaceEdit.from(Xe):null}}class Ae{constructor(V,q){this.adapter=V,this.extension=q}}class Ne{static{this.d=0}constructor(V,q,Y,J,ge,we,Te,He){this.g=q,this.h=Y,this.j=J,this.k=ge,this.l=we,this.m=Te,this.n=He,this.f=new Map,this.e=V.getProxy(d.$gM.MainThreadLanguageFeatures)}o(V,q){return i.DocumentSelector.from(V,this.g,q)}p(V){return new s.$iM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ne.d++}async s(V,q,Y,J,ge,we=!1){const Te=this.f.get(V);if(!Te||!(Te.adapter instanceof q))return J;const He=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Xe=Y(Te.adapter,Te.extension);return Promise.resolve(Xe).catch(tt=>{(0,P.$4)(tt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Te.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),M.CancellationToken.isCancellationToken(ge)?(0,N.$9g)(Xe,ge):Xe}t(V,q){const Y=this.q();return this.f.set(Y,new Ae(V,q)),Y}static u(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,q,Y,J){const ge=this.t(new h(this.h,Y),V),we=J&&J.label||Ne.u(V);return this.e.$registerDocumentSymbolProvider(ge,this.o(q,V),we),this.p(ge)}$provideDocumentSymbols(V,q,Y){return this.s(V,h,J=>J.provideDocumentSymbols(w.URI.revive(q),Y),void 0,Y)}registerCodeLensProvider(V,q,Y){const J=this.q(),ge=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ae(new l(this.h,this.j.converter,Y,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(J,this.o(q,V),ge);let we=this.p(J);if(ge!==void 0){const Te=Y.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(ge));we=s.$iM.from(we,Te)}return we}$provideCodeLenses(V,q,Y){return this.s(V,l,J=>J.provideCodeLenses(w.URI.revive(q),Y),void 0,Y)}$resolveCodeLens(V,q,Y){return this.s(V,l,J=>J.resolveCodeLens(q,Y),void 0,void 0)}$releaseCodeLenses(V,q){this.s(V,l,Y=>Promise.resolve(Y.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(V,q,Y){const J=this.t(new g(this.h,Y),V);return this.e.$registerDefinitionSupport(J,this.o(q,V)),this.p(J)}$provideDefinition(V,q,Y,J){return this.s(V,g,ge=>ge.provideDefinition(w.URI.revive(q),Y,J),[],J)}registerDeclarationProvider(V,q,Y){const J=this.t(new f(this.h,Y),V);return this.e.$registerDeclarationSupport(J,this.o(q,V)),this.p(J)}$provideDeclaration(V,q,Y,J){return this.s(V,f,ge=>ge.provideDeclaration(w.URI.revive(q),Y,J),[],J)}registerImplementationProvider(V,q,Y){const J=this.t(new D(this.h,Y),V);return this.e.$registerImplementationSupport(J,this.o(q,V)),this.p(J)}$provideImplementation(V,q,Y,J){return this.s(V,D,ge=>ge.provideImplementation(w.URI.revive(q),Y,J),[],J)}registerTypeDefinitionProvider(V,q,Y){const J=this.t(new p(this.h,Y),V);return this.e.$registerTypeDefinitionSupport(J,this.o(q,V)),this.p(J)}$provideTypeDefinition(V,q,Y,J){return this.s(V,p,ge=>ge.provideTypeDefinition(w.URI.revive(q),Y,J),[],J)}registerHoverProvider(V,q,Y,J){const ge=this.t(new v(this.h,Y),V);return this.e.$registerHoverProvider(ge,this.o(q,V)),this.p(ge)}$provideHover(V,q,Y,J){return this.s(V,v,ge=>ge.provideHover(w.URI.revive(q),Y,J),void 0,J)}registerEvaluatableExpressionProvider(V,q,Y,J){const ge=this.t(new y(this.h,Y),V);return this.e.$registerEvaluatableExpressionProvider(ge,this.o(q,V)),this.p(ge)}$provideEvaluatableExpression(V,q,Y,J){return this.s(V,y,ge=>ge.provideEvaluatableExpression(w.URI.revive(q),Y,J),void 0,J)}registerInlineValuesProvider(V,q,Y,J){const ge=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,Y),V);this.e.$registerInlineValuesProvider(we,this.o(q,V),ge);let Te=this.p(we);if(ge!==void 0){const He=Y.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(ge));Te=s.$iM.from(Te,He)}return Te}$provideInlineValues(V,q,Y,J,ge){return this.s(V,C,we=>we.provideInlineValues(w.URI.revive(q),Y,J,ge),void 0,ge)}registerDocumentHighlightProvider(V,q,Y){const J=this.t(new O(this.h,Y),V);return this.e.$registerDocumentHighlightProvider(J,this.o(q,V)),this.p(J)}registerMultiDocumentHighlightProvider(V,q,Y){const J=this.t(new z(this.h,Y),V);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(q,V)),this.p(J)}$provideDocumentHighlights(V,q,Y,J){return this.s(V,O,ge=>ge.provideDocumentHighlights(w.URI.revive(q),Y,J),void 0,J)}$provideMultiDocumentHighlights(V,q,Y,J,ge){return this.s(V,z,we=>we.provideMultiDocumentHighlights(w.URI.revive(q),Y,J.map(Te=>w.URI.revive(Te)),ge),void 0,ge)}registerLinkedEditingRangeProvider(V,q,Y){const J=this.t(new T(this.h,Y),V);return this.e.$registerLinkedEditingRangeProvider(J,this.o(q,V)),this.p(J)}$provideLinkedEditingRanges(V,q,Y,J){return this.s(V,T,async ge=>{const we=await ge.provideLinkedEditingRanges(w.URI.revive(q),Y,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ne.w(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(V,q,Y){const J=this.t(new B(this.h,Y),V);return this.e.$registerReferenceSupport(J,this.o(q,V)),this.p(J)}$provideReferences(V,q,Y,J,ge){return this.s(V,B,we=>we.provideReferences(w.URI.revive(q),Y,J,ge),void 0,ge)}registerCodeActionProvider(V,q,Y,J){const ge=new b.$Tc,we=this.t(new j(this.h,this.j.converter,this.k,Y,this.l,V,this.m),V);return this.e.$registerQuickFixSupport(we,this.o(q,V),{providedKinds:J?.providedCodeActionKinds?.map(Te=>Te.value),documentation:J?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,ge)}))},Ne.u(V),!!Y.resolveCodeAction),ge.add(this.p(we)),ge}$provideCodeActions(V,q,Y,J,ge){return this.s(V,j,we=>we.provideCodeActions(w.URI.revive(q),Y,J,ge),void 0,ge)}$resolveCodeAction(V,q,Y){return this.s(V,j,J=>J.resolveCodeAction(q,Y),{},void 0)}$releaseCodeActions(V,q){this.s(V,j,Y=>Promise.resolve(Y.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(V,q,Y){const J=this.t(new L(this.h,Y),V);return this.e.$registerDocumentFormattingSupport(J,this.o(q,V),V.identifier,V.displayName||V.name),this.p(J)}$provideDocumentFormattingEdits(V,q,Y,J){return this.s(V,L,ge=>ge.provideDocumentFormattingEdits(w.URI.revive(q),Y,J),void 0,J)}registerDocumentRangeFormattingEditProvider(V,q,Y){const J=typeof Y.provideDocumentRangesFormattingEdits=="function",ge=this.t(new G(this.h,Y),V);return this.e.$registerRangeFormattingSupport(ge,this.o(q,V),V.identifier,V.displayName||V.name,J),this.p(ge)}$provideDocumentRangeFormattingEdits(V,q,Y,J,ge){return this.s(V,G,we=>we.provideDocumentRangeFormattingEdits(w.URI.revive(q),Y,J,ge),void 0,ge)}$provideDocumentRangesFormattingEdits(V,q,Y,J,ge){return this.s(V,G,we=>we.provideDocumentRangesFormattingEdits(w.URI.revive(q),Y,J,ge),void 0,ge)}registerOnTypeFormattingEditProvider(V,q,Y,J){const ge=this.t(new te(this.h,Y),V);return this.e.$registerOnTypeFormattingSupport(ge,this.o(q,V),J,V.identifier),this.p(ge)}$provideOnTypeFormattingEdits(V,q,Y,J,ge,we){return this.s(V,te,Te=>Te.provideOnTypeFormattingEdits(w.URI.revive(q),Y,J,ge,we),void 0,we)}registerWorkspaceSymbolProvider(V,q){const Y=this.t(new Z(q,this.l),V);return this.e.$registerNavigateTypeSupport(Y,typeof q.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(V,q,Y){return this.s(V,Z,J=>J.provideWorkspaceSymbols(q,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(V,q,Y){return this.s(V,Z,J=>J.resolveWorkspaceSymbol(q,Y),void 0,void 0)}$releaseWorkspaceSymbols(V,q){this.s(V,Z,Y=>Y.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(V,q,Y){const J=this.t(new x(this.h,Y,this.l),V);return this.e.$registerRenameSupport(J,this.o(q,V),x.supportsResolving(Y)),this.p(J)}$provideRenameEdits(V,q,Y,J,ge){return this.s(V,x,we=>we.provideRenameEdits(w.URI.revive(q),Y,J,ge),void 0,ge)}$resolveRenameLocation(V,q,Y,J){return this.s(V,x,ge=>ge.resolveRenameLocation(w.URI.revive(q),Y,J),void 0,J)}registerNewSymbolNamesProvider(V,q,Y){const J=this.t(new _(this.h,Y,this.l),V);return this.e.$registerNewSymbolNamesProvider(J,this.o(q,V)),this.p(J)}$provideNewSymbolNames(V,q,Y,J){return this.s(V,_,ge=>ge.provideNewSymbolNames(w.URI.revive(q),Y,J),void 0,J)}registerDocumentSemanticTokensProvider(V,q,Y,J){const ge=this.t(new X(this.h,Y),V),we=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ge,this.o(q,V),J,we);let Te=this.p(ge);if(we){const He=Y.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(we));Te=s.$iM.from(Te,He)}return Te}$provideDocumentSemanticTokens(V,q,Y,J){return this.s(V,X,ge=>ge.provideDocumentSemanticTokens(w.URI.revive(q),Y,J),null,J)}$releaseDocumentSemanticTokens(V,q){this.s(V,X,Y=>Y.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,q,Y,J){const ge=this.t(new $e(this.h,Y),V);return this.e.$registerDocumentRangeSemanticTokensProvider(ge,this.o(q,V),J),this.p(ge)}$provideDocumentRangeSemanticTokens(V,q,Y,J){return this.s(V,$e,ge=>ge.provideDocumentRangeSemanticTokens(w.URI.revive(q),Y,J),null,J)}registerCompletionItemProvider(V,q,Y,J){const ge=this.t(new se(this.h,this.j.converter,Y,this.m,V),V);return this.e.$registerCompletionsProvider(ge,this.o(q,V),J,se.supportsResolving(Y),V.identifier),this.p(ge)}$provideCompletionItems(V,q,Y,J,ge){return this.s(V,se,we=>we.provideCompletionItems(w.URI.revive(q),Y,J,ge),void 0,ge)}$resolveCompletionItem(V,q,Y){return this.s(V,se,J=>J.resolveCompletionItem(q,Y),void 0,Y)}$releaseCompletionItems(V,q){this.s(V,se,Y=>Y.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(V,q,Y,J){const ge=new U(V,this.h,Y,this.j.converter),we=this.t(ge,V);return this.e.$registerInlineCompletionsSupport(we,this.o(q,V),ge.supportsHandleEvents,n.$Cm.toKey(V.identifier.value),J?.yieldTo?.map(Te=>n.$Cm.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(V,q,Y,J,ge){return this.s(V,re,we=>we.provideInlineCompletions(w.URI.revive(q),Y,J,ge),void 0,ge)}$handleInlineCompletionDidShow(V,q,Y,J){this.s(V,re,async ge=>{ge.handleDidShowCompletionItem(q,Y,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,q,Y,J,ge){this.s(V,re,async we=>{we.handlePartialAccept(q,Y,J,ge)},void 0,void 0)}$freeInlineCompletionsList(V,q){this.s(V,re,async Y=>{Y.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(V,q,Y){const J=new ie(V,this.h,Y,this.j.converter),ge=this.t(J,V);return this.e.$registerInlineEditProvider(ge,this.o(q,V),V.identifier),this.p(ge)}$provideInlineEdit(V,q,Y,J){return this.s(V,ie,ge=>ge.provideInlineEdits(w.URI.revive(q),Y,J),void 0,J)}$freeInlineEdit(V,q){this.s(V,ie,async Y=>{Y.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(V,q,Y,J){const ge=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this.t(new Ie(this.h,Y),V);return this.e.$registerSignatureHelpProvider(we,this.o(q,V),ge),this.p(we)}$provideSignatureHelp(V,q,Y,J,ge){return this.s(V,Ie,we=>we.provideSignatureHelp(w.URI.revive(q),Y,J,ge),void 0,ge)}$releaseSignatureHelp(V,q){this.s(V,Ie,Y=>Y.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(V,q,Y){const J=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,ge=this.t(new le(this.h,this.j.converter,Y,this.l,V),V);this.e.$registerInlayHintsProvider(ge,this.o(q,V),typeof Y.resolveInlayHint=="function",J,Ne.u(V));let we=this.p(ge);if(J!==void 0){const Te=Y.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(J));we=s.$iM.from(we,Te)}return we}$provideInlayHints(V,q,Y,J){return this.s(V,le,ge=>ge.provideInlayHints(w.URI.revive(q),Y,J),void 0,J)}$resolveInlayHint(V,q,Y){return this.s(V,le,J=>J.resolveInlayHint(q,Y),void 0,Y)}$releaseInlayHints(V,q){this.s(V,le,Y=>Y.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(V,q,Y){const J=this.t(new ae(this.h,Y),V);return this.e.$registerDocumentLinkProvider(J,this.o(q,V),typeof Y.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(V,q,Y){return this.s(V,ae,J=>J.provideLinks(w.URI.revive(q),Y),void 0,Y,q.scheme==="output")}$resolveDocumentLink(V,q,Y){return this.s(V,ae,J=>J.resolveLink(q,Y),void 0,void 0,!0)}$releaseDocumentLinks(V,q){this.s(V,ae,Y=>Y.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(V,q,Y){const J=this.t(new ce(this.h,Y),V);return this.e.$registerDocumentColorProvider(J,this.o(q,V)),this.p(J)}$provideDocumentColors(V,q,Y){return this.s(V,ce,J=>J.provideColors(w.URI.revive(q),Y),[],Y)}$provideColorPresentations(V,q,Y,J){return this.s(V,ce,ge=>ge.provideColorPresentations(w.URI.revive(q),Y,J),void 0,J)}registerFoldingRangeProvider(V,q,Y){const J=this.q(),ge=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ae(new H(this.h,Y),V)),this.e.$registerFoldingRangeProvider(J,this.o(q,V),V.identifier,ge);let we=this.p(J);if(ge!==void 0){const Te=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ge));we=s.$iM.from(we,Te)}return we}$provideFoldingRanges(V,q,Y,J){return this.s(V,H,ge=>ge.provideFoldingRanges(w.URI.revive(q),Y,J),void 0,J)}registerSelectionRangeProvider(V,q,Y){const J=this.t(new Q(this.h,Y,this.l),V);return this.e.$registerSelectionRangeProvider(J,this.o(q,V)),this.p(J)}$provideSelectionRanges(V,q,Y,J){return this.s(V,Q,ge=>ge.provideSelectionRanges(w.URI.revive(q),Y,J),[],J)}registerCallHierarchyProvider(V,q,Y){const J=this.t(new he(this.h,Y),V);return this.e.$registerCallHierarchyProvider(J,this.o(q,V)),this.p(J)}$prepareCallHierarchy(V,q,Y,J){return this.s(V,he,ge=>Promise.resolve(ge.prepareSession(w.URI.revive(q),Y,J)),void 0,J)}$provideCallHierarchyIncomingCalls(V,q,Y,J){return this.s(V,he,ge=>ge.provideCallsTo(q,Y,J),void 0,J)}$provideCallHierarchyOutgoingCalls(V,q,Y,J){return this.s(V,he,ge=>ge.provideCallsFrom(q,Y,J),void 0,J)}$releaseCallHierarchy(V,q){this.s(V,he,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(V,q,Y){const J=this.t(new fe(this.h,Y),V);return this.e.$registerTypeHierarchyProvider(J,this.o(q,V)),this.p(J)}$prepareTypeHierarchy(V,q,Y,J){return this.s(V,fe,ge=>Promise.resolve(ge.prepareSession(w.URI.revive(q),Y,J)),void 0,J)}$provideTypeHierarchySupertypes(V,q,Y,J){return this.s(V,fe,ge=>ge.provideSupertypes(q,Y,J),void 0,J)}$provideTypeHierarchySubtypes(V,q,Y,J){return this.s(V,fe,ge=>ge.provideSubtypes(q,Y,J),void 0,J)}$releaseTypeHierarchy(V,q){this.s(V,fe,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(V,q,Y,J){const ge=this.q();return this.f.set(ge,new Ae(new Pe(this.e,this.h,Y,ge,V),V)),this.e.$registerDocumentOnDropEditProvider(ge,this.o(q,V),(0,o.$5F)(V,"dropMetadata")?J:void 0),this.p(ge)}$provideDocumentOnDropEdits(V,q,Y,J,ge,we){return this.s(V,Pe,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(q,w.URI.revive(Y),J,ge,we)),void 0,void 0)}registerMappedEditsProvider(V,q,Y){const J=this.t(new be(this.h,Y),V);return this.e.$registerMappedEditsProvider(J,this.o(q,V)),this.p(J)}$provideMappedEdits(V,q,Y,J,ge){return this.s(V,be,we=>Promise.resolve(we.provideMappedEdits(q,Y,J,ge)),null,ge)}registerDocumentPasteEditProvider(V,q,Y,J){const ge=this.q();return this.f.set(ge,new Ae(new F(this.e,this.h,Y,ge,V),V)),this.e.$registerPasteEditProvider(ge,this.o(q,V),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(ge)}$prepareDocumentPaste(V,q,Y,J,ge){return this.s(V,F,we=>we.prepareDocumentPaste(w.URI.revive(q),Y,J,ge),void 0,ge)}$providePasteEdits(V,q,Y,J,ge,we,Te){return this.s(V,F,He=>He.providePasteEdits(q,w.URI.revive(Y),J,ge,we,Te),void 0,Te)}$resolvePasteEdit(V,q,Y){return this.s(V,F,J=>J.resolvePasteEdit(q,Y),{},void 0)}$releasePasteEdits(V,q){this.s(V,F,Y=>Promise.resolve(Y.releasePasteEdits(q)),void 0,void 0)}static w(V){return{pattern:V.source,flags:V.flags}}static y(V){return{decreaseIndentPattern:Ne.w(V.decreaseIndentPattern),increaseIndentPattern:Ne.w(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ne.w(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ne.w(V.unIndentedLinePattern):void 0}}static z(V){return{beforeText:Ne.w(V.beforeText),afterText:V.afterText?Ne.w(V.afterText):void 0,previousLineText:V.previousLineText?Ne.w(V.previousLineText):void 0,action:V.action}}static B(V){return V.map(Ne.z)}static C(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(q=>s.SyntaxTokenType.toString(q)):void 0}}static D(V){return V.map(Ne.C)}setLanguageConfiguration(V,q,Y){const{wordPattern:J}=Y;if(J&&(0,R.$0e)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(q,J):this.h.setWordDefinitionFor(q,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const ge=this.q(),we={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Ne.w(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Ne.y(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Ne.B(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Ne.D(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ge,q,we),this.p(ge)}$setWordDefinitions(V){for(const q of V)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Kic=Ne}),define(ke[121],Ee([1,0,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=void 0,e.$Ric=(0,S.$hi)("IExtHostLanguageModels");class n{constructor(t,d){this.option=t,this.stream=new $.$Kh,this.stream=d??new $.$Kh}}class i{constructor(){this.a=new Map,this.b=new $.$Kh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let d=this.a.get(t.index);d||(this.a.size===0?d=new n(t.index,this.b):d=new n(t.index),this.a.set(t.index,d)),d.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const d of this.f())d.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let s=class{static{a=this}static{this.a=1}constructor(t,d,h){this.j=d,this.k=h,this.c=new E.$7d,this.d=new E.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Em,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$gM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,d,h,l){const r=a.a++;this.f.set(r,{extension:t.identifier,provider:h,languageModelId:d});let g;return l.auth&&(g={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(r,d,{extension:t.identifier,identifier:d,model:l.name??"",auth:g}),(0,u.$Sc)(()=>{this.f.delete(r),this.b.$unregisterProvider(r)})}async $provideLanguageModelResponse(t,d,h,l,r,g){const f=this.f.get(t);if(!f)return;const D=new A.$Pv(async p=>{if(g.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(d,{index:p.index,part:p.part})});return f.provider.provideLanguageModelResponse2(l.map(M.LanguageModelMessage.to),r,b.$Cm.toKey(h),D,g)}$updateLanguageModels(t){const d=[],h=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),d.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),h.push(l);for(const[r,g]of this.i)g.languageModelId===l&&(g.res.reject(new w.$5),this.i.delete(r))}this.d.fire(Object.freeze({added:Object.freeze(d),removed:Object.freeze(h)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const d=new Array;for(const{from:h,to:l,enabled:r}of t){const g=this.h.get(h)??new b.$Dm;if(g.has(l)!==r){r?g.add(l):g.delete(l),this.h.set(h,g);const D={from:h,to:l};d.push(D),this.c.fire(D)}}}async sendChatRequest(t,d,h,l,r){const g=t.identifier,f=await this.b.$prepareChatAccess(g,d,l.justification);if(!f||!this.g.has(d))throw P.$nO.NotFound(`Language model '${d}' is unknown.`);if(this.m(g,f)&&(!await this.l(t,{identifier:f.extension,displayName:f.auth.providerLabel},l.justification,l.silent)||!this.h.get(g)?.has(f.extension)))throw P.$nO.NoPermissions(`Language model '${d}' cannot be used by '${g.value}'.`);const D=Math.random()*1e6|0,p=this.b.$fetchResponse(g,d,D,h.map(M.LanguageModelMessage.from),l.modelOptions??{},r),v=new $.$gh,y=new i;this.i.set(D,{languageModelId:d,res:y});let C;if(p.catch(O=>{v.isOpen()?y.reject(O):C=O}).finally(()=>{this.i.delete(D),y.resolve(),v.open()}),await v.wait(),C)throw new P.$nO(`Language model '${d}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,d){const h=this.i.get(t);h&&h.res.handleFragment(d)}async l(t,d,h,l){const r=I.$iL+d.identifier.value;if(await this.k.getSession(t,r,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:d.identifier,enabled:!0}]),!0;if(l)return!1;try{const f=h?(0,R.localize)(0,null,d.displayName,h):(0,R.localize)(1,null,d.displayName);return await this.k.getSession(t,r,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:t.identifier,to:d.identifier,enabled:!0}]),!0}catch{return!1}}m(t,d){return!!d.auth&&!b.$Cm.equals(d.extension,t)}async n(t){for(const d of this.o)try{await this.l(d,{identifier:t.extension,displayName:""},void 0,!0)}catch(h){this.j.error("Fake Auth request failed"),this.j.error(h)}}createLanguageModelAccessInformation(t){this.o.add(t);const d=this,h=E.Event.signal(E.Event.filter(this.c.event,r=>b.$Cm.equals(r.from,t.identifier))),l=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(h,l)},canSendRequest(r){const g=d.g.get(r);if(!g)return;if(!d.m(t.identifier,g))return!0;const f=d.h.get(t.identifier);if(f)return f.has(g.extension)}}}};e.$Sic=s,e.$Sic=s=a=Je([Ve(0,k.$AO),Ve(1,m.$Nj),Ve(2,c.$Mic)],s)}),define(ke[337],Ee([1,0,6,16,7,39,8,3,26]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class E{constructor(I,w,S,k){this.c=w,this.d=S,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(u.$gM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,w){await this.a.$changeLanguage(I,w);const S=this.c.getDocumentData(I);if(!S)throw new Error(`document '${I.toString()}' NOT found`);return S.document}async tokenAtPosition(I,w){const S=I.version,k=N.Position.from(w),c=await this.a.$tokensAtPosition(I.uri,k),m={type:M.StandardTokenType.Other,range:I.getWordRangeAtPosition(w)??new M.$kM(w.line,w.character,w.line,w.character)};if(!c)return m;const a={range:N.Range.to(c.range),type:N.TokenType.to(c.type)};return!a.range.contains(w)||S!==I.version?m:a}createLanguageStatusItem(I,w,S){const k=this.f++,c=this.a,m=this.g,a=`${I.identifier.value}/${w}`;if(m.has(a))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);m.add(a);const n={selector:S,id:w,name:I.displayName??I.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const s=new b.$Tc,o=()=>{if(i?.dispose(),!m.has(a)){console.warn(`LanguageStatusItem (${w}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$jh)(()=>{s.clear(),this.a.$setLanguageStatus(k,{id:a,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?P.default.Error:n.severity===M.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:n.command&&this.d.toInternal(n.command,s),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){s.dispose(),i?.dispose(),c.$removeLanguageStatus(k),m.delete(a)},get id(){return n.id},get name(){return n.name},set name(d){n.name=d,o()},get selector(){return n.selector},set selector(d){n.selector=d,o()},get text(){return n.text},set text(d){n.text=d,o()},set text2(d){(0,$.$6F)(I,"languageStatusText"),n.text=d,o()},get text2(){return(0,$.$6F)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(d){n.detail=d,o()},get severity(){return n.severity},set severity(d){n.severity=d,o()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(d){n.accessibilityInformation=d,o()},get command(){return n.command},set command(d){n.command=d,o()},get busy(){return n.busy},set busy(d){n.busy=d,o()}};return o(),t}}e.$_jc=E}),define(ke[338],Ee([1,0,15,2,16,7,119]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Wjc=void 0;class b{constructor(I,w,S,k){this.start=I,this.deletedCount=w,this.deletedItems=S,this.items=k}asApiEvent(){return{range:new P.$JN(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,w,S){this.notebook=I,this.h=w,this.j=S,this.handle=S.handle,this.uri=N.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(M.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(k){I.g=k},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(M.NotebookCellOutput.to)}setOutputItems(I,w,S){const k=S.map(M.NotebookCellOutputItem.to),c=this.a.find(m=>m.id===I);if(c&&(w||(c.items.length=0),c.items.push(...k),c.items.length>1&&c.items.every(m=>A.$dK(m.mime)))){const m=new Map,a=[];c.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),c.items.length=0,a.forEach(n=>{const i=A.$eK(m.get(n));c.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$Wjc=$;class E{static{this.a=0}constructor(I,w,S,k,c){this.k=I,this.l=w,this.m=S,this.uri=k,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(c=>c.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,S){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:S});const k={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},c=[];for(const a of I.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,k.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,k.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),c.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),c.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),c.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const m=new Map;for(let a=0;a<c.length;a++){const n=c[a],i=m.get(n.cell);if(i===void 0){const s=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,s-1)}else k.cellChanges[i]={...k.cellChanges[i],...n}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,S=I.end|0;return w<0&&(w=0),S>this.b.length&&(S=this.b.length),I.with({start:w,end:S})}p(I){I=this.o(I);const w=[];for(let S=I.start;S<I.end;S++)w.push(this.b[S]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,S){if(this.j)return;const k=[],c=[],m=[];if(I.reverse().forEach(a=>{const i=a[2].map(t=>{const d=new $(this,this.l,t);return w||c.push($.asModelAddData(t)),d}),s=new b(a[0],a[1],[],i),o=this.b.splice(a[0],a[1],...i);for(const t of o)m.push(t.uri),s.deletedItems.push(t.apiCell);k.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:m}),S)for(const a of k)S.push(a.asApiEvent())}s(I,w,S,k){const c=this.b.splice(I,w);this.b.splice(S,0,...c);const m=[new b(I,w,c.map(a=>a.apiCell),[]),new b(S,0,[],c)];for(const a of m)k.push(a.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,S,k){this.b[I].setOutputItems(w,S,k)}v(I,w){const S=this.b[I];S.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(S.uri,w)}w(I,w){const S=this.b[I];S.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$Xjc=E}),define(ke[339],Ee([1,0,4,2,16,7]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;class A{constructor($,E,R,I={timeout:1500,errors:3}){this.b=$,this.c=E,this.d=R,this.f=I,this.a=new u.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(E,R,I)=>{const w=function(k){E.call(R,k)};return w.extension=$,this.a.event(w,void 0,I)}}async $participateInSave($,E,R){const I=N.URI.revive($),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:M.TextDocumentSaveReason.to(E)},R,async(c,m)=>{const a=Date.now(),n=await await Promise.resolve(c);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof P.$sM?S.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(S.length===0)return!0;const k={edits:[]};for(const c of S){const{edits:m}=M.WorkspaceEdit.from(c);k.edits=k.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$bkc=A}),define(ke[153],Ee([1,0,13,16,7]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,E,R,I,w){this.id=b,this.f=$,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=w}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(M.$JN.isNotebookRange))throw(0,u.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,E){b.f.$tryRevealRange(b.id,N.NotebookRange.from($),E??M.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Yjc=P}),define(ke[340],Ee([1,0,4,12,16]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;let P=class{constructor(b,$){this.c=b,this.d=$,this.a=new u.$7d,this.b=new u.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const E=this.d.getEditorById(b);$.visibleRanges&&E._acceptVisibleRanges($.visibleRanges.ranges.map(M.NotebookRange.to)),$.selections&&E._acceptSelections($.selections.selections.map(M.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(M.ViewColumn.to(b[$]))}};e.$dkc=P,e.$dkc=P=Je([Ve(0,N.$Nj)],P)}),define(ke[341],Ee([1,0,4,6,153]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class P{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(N.$gM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,E){const R=this.c.getEditorById(b);this.a.get($)?.fire({editor:R.apiEditor,message:E})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,I,w)=>this.d($).event(R,I,w),postMessage:(R,I)=>{M.$Yjc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const w=I&&M.$Yjc.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,$,R)}}}d(b){let $=this.a.get(b);return $||($=new u.$7d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$gkc=P}),define(ke[342],Ee([1,0,16,108,22,54,13]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class b{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,w,S){const k=this.b++,{title:c,location:m,cancellable:a}=w,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(k,{location:u.ProgressLocation.from(m),title:c,source:n,cancellable:a},I.isUnderDevelopment?void 0:I.identifier.value).catch(A.$2),this.d(k,S,!!a)}d(I,w,S){let k;S&&(k=new M.$ee,this.c.set(I,k));const c=a=>{this.a.$progressEnd(a),this.c.delete(a),k?.dispose()};let m;try{m=w(new E(this.a,I),S&&k?k.token:M.CancellationToken.None)}catch(a){throw c(I),a}return m.then(a=>c(I),a=>c(I)),m}$acceptProgressCanceled(I){const w=this.c.get(I);w&&(w.cancel(),this.c.delete(I))}}e.$kkc=b;function $(R,I){return R.message=I.message,typeof I.increment=="number"&&(typeof R.increment=="number"?R.increment+=I.increment:R.increment=I.increment),R}class E extends N.$Pv{constructor(I,w){super(S=>this.throttledReport(S)),this.c=I,this.d=w}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,P.$Nh)(100,(R,I)=>$(R,I),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[343],Ee([1,0,2,6,8,16]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;class A{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(N.$gM.MainThreadQuickDiff)}$provideOriginalResource($,E,R){const I=u.URI.revive(E),w=this.c.get($);return w?(0,M.$_g)(()=>w.provideOriginalResource(I,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,E,R,I){const w=A.a++;return this.c.set(w,E),this.b.$registerQuickDiffProvider(w,P.DocumentSelector.from($,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$lkc=A}),define(ke[344],Ee([1,0,22,4,3,6,2,7,13,19,39,56,26,16]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=k;function k(c,m,a){const n=c.getProxy(P.$gM.MainThreadQuickOpen);class i{constructor(f,D){this.e=new Map,this.f=0,this.a=f,this.b=D}showQuickPick(f,D,p,v=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,O=n.$show(C,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},v),z={},T=O.then(()=>z);return Promise.race([T,y]).then(B=>{if(B===z)return;const j=(0,w.$5F)(f,"quickPickItemTooltip");return y.then(F=>{const L=[];for(let G=0;G<F.length;G++){const te=F[G];if(typeof te=="string")L.push({label:te,handle:G});else if(te.kind===b.QuickPickItemKind.Separator)L.push({type:"separator",label:te.label});else{te.tooltip&&!j&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const Z=te.iconPath?h(te.iconPath):void 0;L.push({label:te.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:j?S.MarkdownString.fromStrict(te.tooltip):void 0,handle:G})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=G=>{p.onDidSelectItem(F[G])}),n.$setItems(C,L),O.then(G=>{if(typeof G=="number")return F[G];if(Array.isArray(G))return G.map(te=>F[te])})})}).then(void 0,B=>{if(!(0,$.$4)(B))return n.$setError(C,B),Promise.reject(B)})}$onItemSelected(f){this.c?.(f)}showInput(f,D=u.CancellationToken.None){return this.d=f?.validateInput,n.$input(f,typeof this.d=="function",D).then(void 0,p=>{if(!(0,$.$4)(p))return Promise.reject(p)})}async $validateInput(f){if(!this.d)return;const D=await this.d(f);if(!D||typeof D=="string")return D;let p;switch(D.severity){case b.InputBoxValidationSeverity.Info:p=R.default.Info;break;case b.InputBoxValidationSeverity.Warning:p=R.default.Warning;break;case b.InputBoxValidationSeverity.Error:p=R.default.Error;break;default:p=D.message?R.default.Error:R.default.Ignore;break}return{content:D.message,severity:p}}async showWorkspaceFolderPick(f,D=u.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!p)return;const v=await this.a.getWorkspaceFolders2();if(v)return v.find(y=>y.uri.toString()===p.uri.toString())}createQuickPick(f){const D=new l(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(f){const D=new r(f,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(f,D){this.e.get(f)?._fireDidChangeValue(D)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,D){const p=this.e.get(f);p instanceof l&&p._fireDidChangeActive(D)}$onDidChangeSelection(f,D){const p=this.e.get(f);p instanceof l&&p._fireDidChangeSelection(D)}$onDidTriggerButton(f,D){this.e.get(f)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(f,D,p){const v=this.e.get(f);v instanceof l&&v._fireDidTriggerItemButton(D,p)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class s{static{this.a=1}constructor(f,D){this.x=f,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$7d,this.q=new N.$7d,this.r=new N.$7d,this.s=new N.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((D,p)=>{const v=D===b.$GN.Back?-1:p;this.o.set(v,D)}),this.z({buttons:f.map((D,p)=>({...h(D.iconPath),tooltip:D.tooltip,handle:D===b.$GN.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const D=this.o.get(f);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(f){if(!this.v){for(const D of Object.keys(f)){const p=f[D];this.u[D]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function o(g){if(g instanceof b.$eN)return{id:g.id};const f=d(g),D=t(g);return{dark:typeof f=="string"?A.URI.file(f):f,light:typeof D=="string"?A.URI.file(D):D}}function t(g){return typeof g=="object"&&"light"in g?g.light:g}function d(g){return typeof g=="object"&&"dark"in g?g.dark:g}function h(g){const f=o(g);let D,p;return"id"in f?p=I.ThemeIcon.asClassName(f):D=f,{iconPath:D,iconClass:p}}class l extends s{constructor(f,D){super(f.identifier,D),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$7d,this.L=[],this.M=new N.$7d,this.N=new N.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((v,y)=>{this.C.set(y,v),this.D.set(v,y)});const D=(0,w.$5F)(this.O,"quickPickItemTooltip"),p=[];for(let v=0;v<f.length;v++){const y=f[v];if(y.kind===b.QuickPickItemKind.Separator)p.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?h(y.iconPath):void 0;p.push({handle:v,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((O,z)=>({...h(O.iconPath),tooltip:O.tooltip,handle:z}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(f){const D=(0,E.$Hb)(f.map(p=>this.C.get(p)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(f){const D=(0,E.$Hb)(f.map(p=>this.C.get(p)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(f,D){const p=this.C.get(f);if(!p||!p.buttons||!p.buttons.length)return;const v=p.buttons[D];v&&this.N.fire({button:v,item:p})}}class r extends s{constructor(f,D){super(f.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:R.default.Error}):this.z({validationMessage:f.message,severity:f.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new i(m,a)}}),define(ke[345],Ee([1,0,2,4,54,3,8,6,19,131,12,25,56,16,26,15,11]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=void 0;function n(C){return C instanceof u.URI}function i(C,O){return C.scheme===c.Schemas.file&&O.scheme===c.Schemas.file&&m.$k?C.toString()===O.toString():C.toString().toLowerCase()===O.toString().toLowerCase()}function s(C){if(C)return typeof C.iconPath=="string"?u.URI.file(C.iconPath):u.URI.isUri(C.iconPath)||w.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function o(C){if(C.icon){if(u.URI.isUri(C.icon))return C.icon;if(w.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const O=C.icon;return{light:O.light,dark:O.dark}}}else return}function t(C,O){if(!C.iconPath&&!O.iconPath)return 0;if(C.iconPath){if(!O.iconPath)return 1}else return-1;const z=typeof C.iconPath=="string"?C.iconPath:u.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,T=typeof O.iconPath=="string"?O.iconPath:u.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,E.$$q)(z,T)}function d(C,O){let z=0;if(C.strikeThrough!==O.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==O.faded)return C.faded?1:-1;if(C.tooltip!==O.tooltip)return(C.tooltip||"").localeCompare(O.tooltip||"");if(z=t(C,O),z!==0)return z;if(C.light&&O.light)z=t(C.light,O.light);else{if(C.light)return 1;if(O.light)return-1}if(z!==0)return z;if(C.dark&&O.dark)z=t(C.dark,O.dark);else{if(C.dark)return 1;if(O.dark)return-1}return z}function h(C,O){if(C.command!==O.command)return C.command<O.command?-1:1;if(C.title!==O.title)return C.title<O.title?-1:1;if(C.tooltip!==O.tooltip){if(C.tooltip!==void 0&&O.tooltip!==void 0)return C.tooltip<O.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(C.arguments===O.arguments)return 0;if(C.arguments)if(O.arguments){if(C.arguments.length!==O.arguments.length)return C.arguments.length-O.arguments.length}else return 1;else return-1;for(let z=0;z<C.arguments.length;z++){const T=C.arguments[z],B=O.arguments[z];if(T!==B&&!(n(T)&&n(B)&&i(T,B)))return T<B?-1:1}return 0}function l(C,O){let z=(0,E.$$q)(C.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(z!==0)return z;if(C.command&&O.command)z=h(C.command,O.command);else{if(C.command)return 1;if(O.command)return-1}if(z!==0)return z;if(C.decorations&&O.decorations)z=d(C.decorations,O.decorations);else{if(C.decorations)return 1;if(O.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)z=(0,E.$$q)(C.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)z=(0,E.$$q)(C.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return z}function r(C,O){for(let z=0;z<C.length;z++)if(C[z]!==O[z])return!1;return!0}function g(C,O){return C.command===O.command&&C.title===O.title&&C.tooltip===O.tooltip&&(C.arguments&&O.arguments?r(C.arguments,O.arguments):C.arguments===O.arguments)}function f(C,O){return(0,$.$ub)(C,O,g)}class D{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,k.$6F)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,k.$6F)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,k.$6F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,z,T,B,j){this.k=O,this.l=B,this.m=j,this.d="",this.e=new N.$7d,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=T}showValidationMessage(O,z){(0,k.$6F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,z)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$nkc=D;class p{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,z,T,B,j,F,L){this.q=O,this.s=z,this.t=T,this.u=B,this.v=j,this.multiDiffEditorEnableViewChanges=F,this.w=L,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=p.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,z){const T=this.h.get(O);return T?(0,A.$_g)(()=>this.s.executeCommand(T.command,...T.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(l),T=(0,$.$Db)(this.o,O,l).map(F=>{const L=F.toInsert.map(G=>{const te=this.e++;this.g.set(te,G);const Z=G.resourceUri;let x;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const ce=new P.$Tc;x=this.s.converter.toInternal(G.command,ce),this.j.set(te,ce)}else this.h.set(te,G.command);const _=(0,k.$5F)(this.w,"scmMultiDiffEditor"),ue=_?G.multiDiffEditorOriginalUri:void 0,X=_?G.multiFileDiffEditorModifiedUri:void 0,$e=s(G.decorations),se=G.decorations&&s(G.decorations.light)||$e,re=G.decorations&&s(G.decorations.dark)||$e,U=[se,re],ie=G.decorations&&G.decorations.tooltip||"",ve=G.decorations&&!!G.decorations.strikeThrough,Ie=G.decorations&&!!G.decorations.faded,le=G.contextValue||"";return{rawResource:[te,Z,U,ie,ve,Ie,le,x,ue,X],handle:te}});return{start:F.start,deleteCount:F.deleteCount,toInsert:L}}),B=T.map(({start:F,deleteCount:L,toInsert:G})=>[F,L,G.map(te=>te.rawResource)]),j=T.reverse();for(const{start:F,deleteCount:L,toInsert:G}of j){const te=G.map(x=>x.handle),Z=this.n.splice(F,L,...te);for(const x of Z)this.g.delete(x),this.h.delete(x),this.j.get(x)?.dispose(),this.j.delete(x)}return this.o=O,B}dispose(){this.l=!0,this.m.fire()}}class v{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let z;(0,k.$5F)(this.x,"quickDiffProvider")&&(z=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:z})}get historyProvider(){return(0,k.$6F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,k.$6F)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new P.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new P.$Tc,this.o=O;const z=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,k.$6F)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,k.$6F)(this.x,"scmActionButton"),this.p.value=new P.$Tc,this.q=O;const z=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(T=>T.map(B=>this.y.converter.toInternal(B,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&f(this.t,O))return;this.s.value=new P.$Tc,this.t=O;const z=(O||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(O,z,T,B,j,F,L){this.x=O,this.y=B,this.z=j,this.A=F,this.B=L,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Vc,this.m=void 0,this.n=new P.$Vc,this.o=void 0,this.p=new P.$Vc,this.s=new P.$Vc,this.t=void 0,this.u=!1,this.v=new N.$7d,this.onDidChangeSelection=this.v.event,this.w=v.d++,this.C=new Map,this.D=new Set,this.#e=T;const G=u.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${j}/scm${this.w}/input`,query:L?`rootUri=${encodeURIComponent(L.toString())}`:void 0});this.f=new D(O,z,this.#e,this.w,G),this.#e.$registerSourceControl(this.w,j,F,L,G)}createResourceGroup(O,z,T){const B=(0,k.$5F)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,j=new p(this.#e,this.y,this.w,O,z,B,this.x),F=N.Event.once(j.onDidDispose)(()=>this.C.delete(j));return this.C.set(j,F),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const O=[],z=[];for(const[T,B]of this.C){B.dispose();const j=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});N.Event.once(T.onDidDispose)(()=>{this.D.delete(T),j.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),O.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const F=T._takeResourceStateSnapshot();F.length>0&&z.push([T.handle,F]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,O,z),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(z=>{const T=z._takeResourceStateSnapshot();T.length!==0&&O.push([z.handle,T])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Mh)(100)],v.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Mh)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,z,T,B){this.l=z,this.m=T,this.n=B,this.g=new Map,this.h=new I.$Em,this.j=new N.$7d,this.e=O.getProxy(b.$gM.MainThreadSCM),this.f=O.getProxy(b.$gM.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const F=this.g.get(j.sourceControlHandle);if(!F)return j;const L=F.getResourceGroup(j.groupHandle);return L?L.getResourceState(j.handle):j}else if(j&&j.$mid===4){const F=this.g.get(j.sourceControlHandle);return F?F.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const F=this.g.get(j.handle);return F||j}return j}})}createSourceControl(O,z,T,B){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,z,T,B),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const j=a.d++,F=new v(O,this.m,this.e,this.l,z,T,B);this.g.set(j,F);const L=this.h.get(O.identifier)||[];return L.push(F),this.h.set(O.identifier,L),F}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const z=this.h.get(O.identifier),T=z&&z[z.length-1];return T&&T.inputBox}$provideOriginalResource(O,z,T){const B=u.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",O,B.toString());const j=this.g.get(O);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$_g)(()=>j.quickDiffProvider.provideOriginalResource(B,T)).then(F=>F||null)}$onInputBoxValueChange(O,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const T=this.g.get(O);return T&&T.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(O,z,T,B){this.n.trace("ExtHostSCM#$executeResourceCommand",O,z,T);const j=this.g.get(O);if(!j)return Promise.resolve(void 0);const F=j.getResourceGroup(z);return F?F.$executeResourceCommand(T,B):Promise.resolve(void 0)}$validateInput(O,z,T){this.n.trace("ExtHostSCM#$validateInput",O);const B=this.g.get(O);return!B||!B.inputBox.validateInput?Promise.resolve(void 0):(0,A.$_g)(()=>B.inputBox.validateInput(z,T)).then(j=>{if(!j)return Promise.resolve(void 0);const F=S.MarkdownString.fromStrict(j.message);return F?Promise.resolve([F,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,z,T,B){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,T,B)??void 0}async $provideHistoryItems(O,z,T,B){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(z,T,B))?.map(L=>({...L,icon:o(L)}))??void 0}async $provideHistoryItemSummary(O,z,T,B){const j=this.g.get(O)?.historyProvider;if(typeof j?.provideHistoryItemSummary!="function")return;const F=await j.provideHistoryItemSummary(z,T,B);return F?{...F,icon:o(F)}:void 0}async $provideHistoryItemChanges(O,z,T,B){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(z,T,B)??void 0}};e.$okc=y,e.$okc=y=a=Je([Ve(3,R.$Nj)],y)}),define(ke[346],Ee([1,0,6,16,2]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class P{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(u.$gM.MainThreadShare)}async $provideShare(b,$,E){return await this.c.get(b)?.provideShare({selection:N.Range.to($.selection),resourceUri:M.URI.revive($.resourceUri)},E)??void 0}registerShareProvider(b,$){const E=P.a++;return this.c.set(E,$),this.b.$registerShareProvider(E,N.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$pkc=P}),define(ke[347],Ee([1,0,7,6,224,3,16,18]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$fN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$fN("statusBarItem.warningForeground")]])}#e;#t;constructor(w,S,k,c,m,a=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new P.$Tc,this.#e=w,this.#t=S,m&&c){this.c=(0,u.$TM)(c.identifier,m);const i=k.get(this.c);i&&(a=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=m,this.g=a,this.h=this.u(n)}u(w){if((0,b.$Yf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!$.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new P.$Tc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let S;this.m?S=this.m:S=(0,M.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=$.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,S,this.k,c,this.r?.internal,k,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$rkc=$;class E{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const S={message:w};return this.b.unshift(S),this.c(),new u.$iM(()=>{const k=this.b.indexOf(S);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(w,S){this.e=new Map,this.a=w.getProxy(N.$gM.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries(w){for(const S of w)this.e.set(S.entryId,S)}createStatusBarEntry(w,S,k,c){return new $(this.a,this.b,this.e,w,S,k,c)}setStatusBarMessage(w,S){const k=this.c.setMessage(w);let c;return typeof S=="number"?c=setTimeout(()=>k.dispose(),S):typeof S<"u"&&S.then(()=>k.dispose(),()=>k.dispose()),new u.$iM(()=>{k.dispose(),clearTimeout(c)})}}e.$skc=R}),define(ke[154],Ee([1,0,29,144,66,112,89,16,2]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=e.$NO=e.$MO=void 0;const E=(i,s,o,t)=>{let d=s;return{enumerable:!0,configurable:!1,get(){return d},set(h){if(!o(d,h)){const l=d;d=h,i.listener?.(t(h,l))}}}},R=(i,s)=>i===s,I={range:(i,s)=>i===s?!0:!i||!s?!1:i.isEqual(s),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(i,s)=>!(i.length!==s.length||i.some(o=>!s.find(t=>o.id===t.id)))},w=i=>s=>({op:4,update:i(s)}),S=(i,s)=>({range:(()=>{let o;const t=w(d=>({range:u.$at.lift(b.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return o},set(d){i.listener?.({op:6}),I.range(o,d)||(o=d,i.listener?.(t(d)))}}})(),label:E(i,s,I.label,w(o=>({label:o}))),description:E(i,void 0,I.description,w(o=>({description:o}))),sortText:E(i,void 0,I.sortText,w(o=>({sortText:o}))),canResolveChildren:E(i,!1,I.canResolveChildren,o=>({op:2,state:o})),busy:E(i,!1,I.busy,w(o=>({busy:o}))),error:E(i,void 0,I.error,w(o=>({error:b.MarkdownString.fromStrict(o)||null}))),tags:E(i,[],I.tags,(o,t)=>({op:1,new:o.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),k=i=>{const s=M.$5K.fromString(i.extId),o=new m(s.controllerId,s.localId,i.label,$.URI.revive(i.uri)||void 0);return o.range=b.Range.to(i.range||void 0),o.description=i.description||void 0,o.sortText=i.sortText||void 0,o.tags=i.tags.map(t=>b.TestTag.to({id:(0,A.$$K)(t).tagId})),o},c=i=>{let s;for(const o of i.tests){const t=k(o.item);(0,N.$wO)(t).parent=s,s=t}return s};e.$MO=c;class m{constructor(s,o,t,d){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const h=(0,N.$vO)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof a?void 0:h.parent}},children:{value:(0,P.$uO)(h,N.$wO,m),enumerable:!0,writable:!1},...S(h,t)})}}e.$NO=m;class a extends m{constructor(s,o){super(s,s,o,void 0),this._isRoot=!0}}e.$OO=a;class n extends P.$qO{constructor(s,o,t){super({controllerId:s,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:N.$wO,getChildren:d=>d.children,root:new a(s,o),toITestItem:b.TestItem.from})}}e.$PO=n}),define(ke[33],Ee([1,0,18,7,16,24,6,19,12,57,29,49,2,3,5,20,154,21,67,45,38,87,90,30]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=void 0;let h=class{#e;#t;#i;constructor(p,v,y){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$gM.MainThreadCommands),this.d=v,this.#i=y,this.#t=p.getProxy(A.$gM.MainThreadTelemetry),this.converter=new l(this,C=>{const O=this.c.get(C);return O?.result===g.Void?O:void 0},v),this.f=[{processArgument(C){return(0,E.$Qh)(C)}},{processArgument(C){return(0,P.$Pn)(C,function(O){if(R.$at.isIRange(O))return M.Range.to(O);if(I.$_s.isIPosition(O))return M.Position.to(O);if(R.$at.isIRange(O.range)&&w.URI.isUri(O.uri))return M.location.to(O);if(O instanceof a.$ue)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const v=this.registerCommand(!1,p.id,async(...y)=>{const C=p.args.map((z,T)=>{if(!z.validate(y[T]))throw new Error(`Invalid argument '${z.name}' when running '${p.id}', received: ${typeof y[T]=="object"?JSON.stringify(y[T],null,"	"):y[T]} `);return z.convert(y[T])}),O=await this.executeCommand(p.internalId,...C);return p.result.convert(O,y,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new N.$iM(()=>{v.dispose(),this.c.delete(p.id)})}registerCommand(p,v,y,C,O,z){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:y,thisArg:C,metadata:O,extension:z}),p&&this.#e.$registerCommand(v),new N.$iM(()=>{this.b.delete(v)&&p&&this.#e.$unregisterCommand(v)})}executeCommand(p,...v){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,v,!0)}async g(p,v,y){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,v,!1);{let C=!1;const O=(0,P.$Pn)(v,function(z){if(z instanceof N.$jM)return M.Position.from(z);if(z instanceof N.$kM)return M.Range.from(z);if(z instanceof N.$uM)return M.location.from(z);if(N.$JN.isNotebookRange(z))return M.NotebookRange.from(z);if(z instanceof ArrayBuffer)return C=!0,a.$ue.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return C=!0,a.$ue.wrap(z);if(z instanceof a.$ue)return C=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(p,C?new n.$cw(O):O,y);return(0,E.$Qh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(p,v,!1);throw z}}}async h(p,v,y){const C=this.b.get(p);if(!C)throw new Error("Unknown command");const{callback:O,thisArg:z,metadata:T}=C;if(T?.args)for(let j=0;j<T.args.length;j++)try{(0,u.$_f)(v[j],T.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${T.args[j].name}' - ${T.args[j].description}`)}const B=s.$3d.create();try{return await O.apply(z,v)}catch(j){if(p===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...v);F&&(p=F.command)}if(this.d.error(j,p,C.extension?.identifier),!y)throw j;if(C.extension?.identifier){const F=this.#i.onExtensionError(C.extension.identifier,j);this.d.trace("forwarded error to extension?",F,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$5i)(j)),this.id=p,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,p,B.elapsed())}}j(p,v,y){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new o.$3o(v),duration:y})}$executeContributedCommand(p,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const y=this.b.get(p);return y?(v=v.map(C=>this.f.reduce((O,z)=>z.processArgument(O,y.extension?.identifier),C)),this.h(p,v,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(v=>(p&&(v=v.filter(y=>y[0]!=="_")),v))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[v,y]of this.b){const{metadata:C}=y;C&&(p[v]=C)}return Promise.resolve(p)}};e.$VO=h,e.$VO=h=Je([Ve(0,c.$AO),Ve(1,$.$Nj),Ve(2,t.$UO)],h),e.$WO=(0,k.$hi)("IExtHostCommands");class l{constructor(p,v,y){this.d=p,this.f=v,this.g=y,this.delegatingCommandId=`__vsc${(0,d.$Dg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,v){if(!p)return;const y={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return y;const C=this.f(p.command);if(C)y.id=C.internalId,y.arguments=C.args.map((O,z)=>O.convert(p.arguments&&p.arguments[z]));else if((0,b.$Lb)(p.arguments)){const O=`${p.command} /${++this.c}`;this.b.set(O,p),v.add((0,S.$Sc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),y.$ident=O,y.id=this.delegatingCommandId,y.arguments=[O],this.g.trace("CommandsConverter#CREATE",p.command,O)}return y}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const v=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$XO=l;class r{static{this.Uri=new r("uri","Uri of a text document",p=>w.URI.isUri(p),p=>p)}static{this.Position=new r("position","A position in a text document",p=>N.$jM.isPosition(p),M.Position.from)}static{this.Range=new r("range","A range in a text document",p=>N.$kM.isRange(p),M.Range.from)}static{this.Selection=new r("selection","A selection in a text document",p=>N.$lM.isSelection(p),M.Selection.from)}static{this.Number=new r("number","",p=>typeof p=="number",p=>p)}static{this.String=new r("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=r.Arr(r.String)}static Arr(p){return new r(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,v=>Array.isArray(v)&&v.every(y=>p.validate(y)),v=>v.map(y=>p.convert(y)))}static{this.CallHierarchyItem=new r("item","A call hierarchy item",p=>p instanceof N.$FM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new r("item","A type hierarchy item",p=>p instanceof N.$3N,M.TypeHierarchyItem.from)}static{this.TestItem=new r("testItem","A VS Code TestItem",p=>p instanceof m.$NO,M.TestItem.from)}constructor(p,v,y,C){this.name=p,this.description=v,this.validate=y,this.convert=C}optional(){return new r(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,v){return new r(p??this.name,v??this.description,this.validate,this.convert)}}e.$YO=r;class g{static{this.Void=new g("no result",p=>p)}constructor(p,v){this.description=p,this.convert=v}}e.$ZO=g;class f{constructor(p,v,y,C,O){this.id=p,this.internalId=v,this.description=y,this.args=C,this.result=O}}e.$1O=f}),define(ke[348],Ee([1,0,19,15,2,82,134,46,33,16,7]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;const I=[new $.$1O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new $.$1O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$YO.Uri],new $.$ZO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,m)=>{if((0,u.$Kb)(c))return;class a extends R.$AM{static to(i){const s=new a(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new R.$uM(m[0],E.Range.to(i.range)));return s.detail=i.detail,s.range=s.location.range,s.selectionRange=E.Range.to(i.selectionRange),s.children=i.children?i.children.map(a.to):[],s}}return c.map(a.to)})),new $.$1O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$YO.Uri,new $.$YO("options","Formatting options",c=>!0,c=>c)],new $.$ZO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$1O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$YO.Uri,$.$YO.Range,new $.$YO("options","Formatting options",c=>!0,c=>c)],new $.$ZO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$1O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$YO.Uri,$.$YO.Position,new $.$YO("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$YO("options","Formatting options",c=>!0,c=>c)],new $.$ZO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$1O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$1O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$1O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$1O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of Location or LocationLink instances.",k)),new $.$1O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of Location-instances.",S(E.location.to))),new $.$1O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new $.$1O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$YO.Uri,new $.$YO("position","A position in a text document",c=>Array.isArray(c)&&c.every(m=>R.$jM.isPosition(m)),c=>c.map(E.Position.from))],new $.$ZO("A promise that resolves to an array of ranges.",c=>c.map(m=>{let a;for(const n of m.reverse())a=new R.$EM(E.Range.to(n),a);return a}))),new $.$1O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$YO.String.with("query","Search string")],new $.$ZO("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(E.WorkspaceSymbol.to))),new $.$1O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(E.CallHierarchyItem.to))),new $.$1O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$YO.CallHierarchyItem],new $.$ZO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(E.CallHierarchyIncomingCall.to))),new $.$1O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$YO.CallHierarchyItem],new $.$ZO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(E.CallHierarchyOutgoingCall.to))),new $.$1O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:E.Range.to(c.range),placeholder:c.text}})),new $.$1O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$YO.Uri,$.$YO.Position,$.$YO.String.with("newName","The new symbol name")],new $.$ZO("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return E.WorkspaceEdit.to(c)}})),new $.$1O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$YO.Uri,$.$YO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$ZO("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(E.DocumentLink.to))),new $.$1O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$YO.Uri],new $.$ZO("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$AN(c.tokenTypes,c.tokenModifiers)})),new $.$1O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$YO.Uri],new $.$ZO("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$rab)(c);if(m.type==="full")return new R.$CN(m.data,void 0)})),new $.$1O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$YO.Uri,$.$YO.Range.optional()],new $.$ZO("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new R.$AN(c.tokenTypes,c.tokenModifiers)})),new $.$1O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$YO.Uri,$.$YO.Range],new $.$ZO("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const m=(0,A.$rab)(c);if(m.type==="full")return new R.$CN(m.data,void 0)})),new $.$1O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$YO.Uri,$.$YO.Position,$.$YO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$YO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$ZO("A promise that resolves to a CompletionList-instance.",(c,m,a)=>{if(!c)return new R.$QM([]);const n=c.suggestions.map(i=>E.CompletionItem.to(i,a));return new R.$QM(n,c.incomplete)})),new $.$1O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$YO.Uri,$.$YO.Position,$.$YO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$ZO("A promise that resolves to SignatureHelp.",c=>{if(c)return E.SignatureHelp.to(c)})),new $.$1O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$YO.Uri,$.$YO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$ZO("A promise that resolves to an array of CodeLens-instances.",(c,m,a)=>S(n=>new R.$IM(E.Range.to(n.range),n.command&&a.fromInternal(n.command)))(c))),new $.$1O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$YO.Uri,new $.$YO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.$kM.isRange(c),c=>R.$lM.isSelection(c)?E.Selection.from(c):E.Range.from(c)),$.$YO.String.with("kind","Code action kind to return code actions for").optional(),$.$YO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$ZO("A promise that resolves to an array of Command-instances.",(c,m,a)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new R.$CM(n.title,n.kind?new R.$DM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(c))),new $.$1O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$YO.Uri],new $.$ZO("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(m=>new R.$WM(E.Range.to(m.range),E.Color.to(m.color))):[])),new $.$1O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$YO("color","The color to show and insert",c=>c instanceof R.$VM,E.Color.from),new $.$YO("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:E.Range.from(c.range)}))],new $.$ZO("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(E.ColorPresentation.to):[])),new $.$1O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$YO.Uri,$.$YO.Range],new $.$ZO("A promise that resolves to an array of Inlay objects",(c,m,a)=>c.map(E.InlayHint.to.bind(void 0,a)))),new $.$1O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$YO.Uri],new $.$ZO("A promise that resolves to an array of FoldingRange objects",(c,m)=>{if(c)return c.map(E.FoldingRange.to)})),new $.$1O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$ZO("A promise that resolves to an array of NotebookContentProvider static info objects.",S(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(m=>E.NotebookExclusiveDocumentPattern.to(m))})))),new $.$1O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$YO.Uri,$.$YO.Range,new $.$YO("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof R.$kM,c=>E.InlineValueContext.from(c))],new $.$ZO("A promise that resolves to an array of InlineValue objects",c=>c.map(E.InlineValue.to))),new $.$1O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$YO("uriOrString","Uri-instance or string (only http/https)",c=>M.URI.isUri(c)||typeof c=="string"&&(0,N.$rg)(c,N.Schemas.http,N.Schemas.https),c=>c),new $.$YO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[E.ViewColumn.from(c),void 0]:[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)])).optional(),$.$YO.String.with("label","").optional()],$.$ZO.Void),new $.$1O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$YO.Uri.with("resource","Resource to open"),$.$YO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$YO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[E.ViewColumn.from(c),void 0]:[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)])).optional()],$.$ZO.Void),new $.$1O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$YO.Uri.with("left","Left-hand side resource of the diff editor"),$.$YO.Uri.with("right","Right-hand side resource of the diff editor"),$.$YO.String.with("title","Human readable title for the diff editor").optional(),new $.$YO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[E.ViewColumn.from(c.viewColumn),E.TextEditorOpenOptions.from(c)]).optional()],$.$ZO.Void),new $.$1O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$YO.String.with("title","Human readable title for the changes editor"),new $.$YO("resourceList","List of resources to compare",c=>{for(const m of c){if(m.length!==3)return!1;const[a,n,i]=m;if(!M.URI.isUri(a)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},c=>c)],$.$ZO.Void),new $.$1O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$YO.Uri,$.$YO.Position],new $.$ZO("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$1O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$YO.TypeHierarchyItem],new $.$ZO("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$1O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$YO.TypeHierarchyItem],new $.$ZO("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(E.TypeHierarchyItem.to))),new $.$1O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$YO.TestItem],$.$ZO.Void),new $.$1O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$YO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$ZO.Void),new $.$1O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$YO.String.with("name","The context key name"),new $.$YO("value","The context key value",()=>!0,c=>c)],$.$ZO.Void),new $.$1O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$YO.Uri,$.$YO.StringArray,new $.$YO("MappedEditsContext","Mapped Edits Context",c=>E.MappedEditsContext.is(c),c=>E.MappedEditsContext.from(c))],new $.$ZO("A promise that resolves to a workspace edit or null",c=>c?E.WorkspaceEdit.to(c):null))];class w{static register(m){I.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",b.$gj)}}e.$Lic=w;function S(c){return m=>{if(Array.isArray(m))return m.map(c)}}function k(c){if(!Array.isArray(c))return;const m=[];for(const a of c)P.$1t(a)?m.push(E.DefinitionLink.to(a)):m.push(E.location.to(a));return m}}),define(ke[349],Ee([1,0,8,3,2,6,33,16,7]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;class E{static{this.a=0}constructor(S,k){this.extension=S,this.provider=k,this.handle=E.a++}}class R{constructor(S){this.session=S,this.responses=[]}}class I{static{this.a=0}constructor(S,k,c,m){this.f=c,this.g=m,this.b=new Map,this.d=new Map,this.e=S.getProxy(P.$gM.MainThreadInlineChat),k.registerApiCommand(new A.$1O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$YO("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?b.Range.from(a.initialRange):void 0,initialSelection:$.$lM.isSelection(a.initialSelection)?b.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?b.Position.from(a.position):void 0}})],A.$ZO.Void))}registerProvider(S,k,c){const m=new E(S,k);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,c?.label??S.displayName??S.name,S.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",c?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(S,k,c,m){const a=this.b.get(S);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(k)),i=b.Selection.to(c),s=await a.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!s)return;if(s.wholeRange&&!s.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=I.a++;return this.d.set(o,new R(s)),{id:o,placeholder:s.placeholder,input:s.input,slashCommands:s.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(s.wholeRange),message:s.message}}async $provideResponse(S,k,c,m){const a=this.b.get(S);if(!a)return;const n=this.d.get(k.id);if(!n)return;const i={prompt:c.prompt,selection:b.Selection.to(c.selection),wholeRange:b.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,previewDocument:this.f.getDocument(M.URI.revive(c.previewDocument)),withIntentDetection:c.withIntentDetection};let s=!1;const o={report:async D=>{if(!c.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");s||m.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:D.message,edits:D.edits?.map(b.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:$.$JM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(n.session,i,o,m));let d;try{d=await(0,u.$8g)(t,m)}finally{s=!0}if(!d)return;const h=n.responses.push(d)-1,l={wholeRange:b.Range.from(d.wholeRange),placeholder:d.placeholder};if(!I.h(d))return{...l,id:h,type:"editorEdit",message:b.MarkdownString.from(d.contents),edits:[]};const{edits:r,contents:g}=d,f=g!==void 0?b.MarkdownString.from(g):void 0;return r instanceof $.$sM?{...l,id:h,type:"bulkEdit",edits:b.WorkspaceEdit.from(r),message:f}:{...l,id:h,type:"editorEdit",edits:r.map(b.TextEdit.from),message:f}}async $provideFollowups(S,k,c,m){const a=this.b.get(S),n=this.d.get(k),i=n?.responses[c];if(a&&i&&a.provider.provideFollowups){const s=Promise.resolve(a.provider.provideFollowups(n.session,i,m));return(await(0,u.$8g)(s,m))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(S,k,c,m){const a=this.b.get(S),n=this.d.get(k),i=n?.responses[c];if(a&&i){const s=b.InteractiveEditorResponseFeedbackKind.to(m);a.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,s)}}$releaseSession(S,k){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$Vjc=I}),define(ke[350],Ee([1,0,2,33]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class M{constructor(A,b,$,E,R){this.a=b,this.b=$,this.c=E;const I=new N.$1O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$YO("showOptions","Show Options",w=>!0,w=>w),new N.$YO("resource","Interactive resource Uri",w=>!0,w=>w),new N.$YO("controllerId","Notebook controller Id",w=>!0,w=>w),new N.$YO("title","Interactive editor title",w=>!0,w=>w)],new N.$ZO("Notebook and input URI",w=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const S=this.a.getEditorById(w.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:u.URI.revive(w.notebookUri),inputUri:u.URI.revive(w.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:u.URI.revive(w.notebookUri),inputUri:u.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,b,$,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$9jc=M}),define(ke[351],Ee([1,0,19,8,22,4,3,28,2,25,12,6,33,16,7,113,293,26,67,294]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0,e.$fkc=r;let s=class{constructor(f,D,p,v,y){this.m=D,this.n=p,this.o=v,this.q=y,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(I.$gM.MainThreadNotebookKernels);const C=new w.$1O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$YO("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const T=this.n.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:T}}else if(z&&"notebookEditor"in z){const T=this.n.getIdByEditor(z.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return z})],w.$ZO.Void),O=new w.$1O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[w.$YO.Uri],new w.$ZO("A promise that resolves to an array of variables",(z,T)=>z.map(B=>({name:B.name,value:B.value,type:B.type,editable:!1}))));this.o.registerApiCommand(C),this.o.registerApiCommand(O)}createNotebookController(f,D,p,v,y,C){for(const $e of this.j.values())if($e.controller.id===D&&E.$Cm.equals(f.identifier,$e.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const O=this.k++,z=this;this.q.trace(`NotebookController[${O}], CREATED by ${f.identifier.value}, ${D}`);const T=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${f.identifier}'`);let B=!1;const j=new P.$7d,F=new P.$7d,L={id:r(f.identifier,D),notebookType:p,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:v||f.identifier.value,preloads:C?C.map(S.NotebookRendererScript.from):[]};let G=y??T,te,Z;this.a.$addKernel(O,L).catch($e=>{console.log($e),B=!0});let x=0;const _=()=>{if(B)return;const $e=++x;Promise.resolve().then(()=>{$e===x&&this.a.$updateKernel(O,L)})},ue=new b.$Bc,X={get id(){return D},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return L.label},set label($e){L.label=$e??f.displayName??f.name,_()},get detail(){return L.detail??""},set detail($e){L.detail=$e,_()},get description(){return L.description??""},set description($e){L.description=$e,_()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages($e){L.supportedLanguages=$e,_()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder($e){L.supportsExecutionOrder=$e,_()},get rendererScripts(){return L.preloads?L.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler($e){G=$e??T},get interruptHandler(){return te},set interruptHandler($e){te=$e,L.supportsInterrupt=!!$e,_()},set variableProvider($e){(0,a.$6F)(f,"notebookVariableProvider"),Z=$e,L.hasVariableProvider=!!$e,$e?.onDidChangeVariables(se=>z.a.$variablesUpdated(se.uri)),_()},get variableProvider(){return Z},createNotebookCellExecution($e){if(B)throw new Error("notebook controller is DISPOSED");if(!ue.has($e.notebook.uri))throw z.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return z._createNotebookCellExecution($e,r(f.identifier,this.id))},createNotebookExecution($e){if((0,a.$6F)(f,"notebookExecution"),B)throw new Error("notebook controller is DISPOSED");if(!ue.has($e.uri))throw z.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return z._createNotebookExecution($e,r(f.identifier,this.id))},dispose:()=>{B||(this.q.trace(`NotebookController[${O}], DISPOSED`),B=!0,this.j.delete(O),j.dispose(),F.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity($e,se){se===k.NotebookControllerAffinity2.Hidden&&(0,a.$6F)(f,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(O,$e.uri,se)},onDidReceiveMessage:F.event,postMessage($e,se){return(0,a.$6F)(f,"notebookMessaging"),z.a.$postMessage(O,se&&z.n.getIdByEditor(se),$e)},asWebviewUri($e){return(0,a.$6F)(f,"notebookMessaging"),(0,c.$Gyb)($e,z.m.remote)}};return this.j.set(O,{extensionId:f.identifier,controller:X,onDidReceiveMessage:F,onDidChangeSelection:j,associatedNotebooks:ue}),X}getIdByController(f){for(const[D,p]of this.j)if(p.controller===f)return r(p.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,D){const p=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(p,D);const y={dispose:()=>{this.f.delete(p),v.a.$removeKernelDetectionTask(p)}};return this.f.set(p,y),y}registerKernelSourceActionProvider(f,D,p){const v=this.i++,y=typeof p.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,C=this;this.h.set(v,p),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,D);let O;return y!==void 0&&(O=p.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(v),C.a.$removeKernelSourceActionProvider(v,v),O?.dispose()}}}async $provideKernelSourceActions(f,D){const p=this.h.get(f);if(p){const v=new A.$Tc;return(await p.provideNotebookKernelSourceActions(D)??[]).map(C=>S.NotebookKernelSourceAction.from(C,this.o.converter,v))}return[]}$acceptNotebookAssociation(f,D,p){const v=this.j.get(f);if(v){const y=this.n.getNotebookDocument($.URI.revive(D));p?v.associatedNotebooks.set(y.uri,!0):v.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),p),v.onDidChangeSelection.fire({selected:p,notebook:y.apiNotebook})}}async $executeCells(f,D,p){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument($.URI.revive(D)),C=[];for(const O of p){const z=y.getCell(O);z&&C.push(z.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),C.length),await v.controller.executeHandler.call(v.controller,C,y.apiNotebook,v.controller)}catch(O){this.q.error(`NotebookController[${f}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(f,D,p){const v=this.j.get(f);if(!v)return;const y=this.n.getNotebookDocument($.URI.revive(D));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,y.apiNotebook);else for(const C of p){const O=y.getCell(C);O&&this.b.get(O.uri)?.cancel()}if(v.controller.interruptHandler){const C=this.c.get(y.uri);p.length&&Array.isArray(C)&&C.length&&C.forEach(O=>O.dispose())}}async $provideVariables(f,D,p,v,y,C,O){const z=this.j.get(f);if(!z)return;const T=this.n.getNotebookDocument($.URI.revive(p)),B=z.controller.variableProvider;if(!B)return;let j;if(v!==void 0){if(j=this.s[v],!j)return}else this.s={};const F=y==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,L=B.provideVariables(T.apiNotebook,j,F,C,O);let G=0;for await(const te of L){if(O.isCancellationRequested)return;const Z={id:this.r++,name:te.variable.name,value:te.variable.value,type:te.variable.type,language:te.variable.language,expression:te.variable.expression,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[Z.id]=te.variable,this.a.$receiveVariable(D,Z),G++>=i.$lhb)return}}$acceptKernelMessageFromRenderer(f,D,p){const v=this.j.get(f);if(!v)return;const y=this.n.getEditorById(D);v.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:p}))}$cellExecutionChanged(f,D,p){const y=this.n.getNotebookDocument($.URI.revive(f)).getCell(D);if(y){const C=p?S.NotebookCellExecutionState.to(p):k.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(f,D){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const y=new t(D,v,this.a);this.b.set(v.uri,y);const C=y.onDidChangeState(()=>{y.state===o.Resolved&&(y.dispose(),C.dispose(),this.b.delete(v.uri))});return y.asApiObject()}_createNotebookExecution(f,D){const p=this.n.getNotebookDocument(f.uri),v=f.getCells().find(O=>{const z=p.getCellFromApiCell(O);return z&&this.b.has(z.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(p.uri))throw new Error(`duplicate notebook execution for ${p.uri}`);const y=new h(D,p,this.a),C=y.onDidChangeState(()=>{y.state===d.Resolved&&(y.dispose(),C.dispose(),this.c.delete(p.uri))});return this.c.set(p.uri,[y,C]),y.asApiObject()}};e.$ekc=s,e.$ekc=s=Je([Ve(4,R.$Nj)],s);var o;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(o||(o={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(f,D,p){super(),this.m=D,this.n=p,this.b=t.a++,this.c=new P.$7d,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new M.$ee),this.h=new l(10,v=>this.s(v)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const D=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$cw(D))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let D=this.m;if(f&&(D=this.m.notebook.getCellFromApiCell(f)),!D)throw new Error("INVALID cell");return D.handle}y(f){return f.map(D=>{const p=k.$NN.ensureUniqueMimeTypes(D.items,!0);return p===D.items?S.NotebookCellOutput.from(D):S.NotebookCellOutput.from({items:p,id:D.id,metadata:D.metadata})})}async z(f,D,p){const v=this.w(D),y=this.y((0,u.$3b)(f));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:v,append:p,outputs:y})}async C(f,D,p){return f=k.$NN.ensureUniqueMimeTypes((0,u.$3b)(f),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:f.map(S.NotebookCellOutputItem.from),outputId:D.id,append:p})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(p){f.j=p,f.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(p){if(f.f===o.Resolved||f.f===o.Started)throw new Error("Cannot call start again");f.f=o.Started,f.c.fire(),f.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:p})},end(p,v,y){if(f.f===o.Resolved)throw new Error("Cannot call resolve twice");f.f=o.Resolved,f.c.fire(),f.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;f.n.$completeExecution(f.b,new n.$cw({runEndTime:v,lastRunSuccess:p,error:C}))},clearOutput(p){return f.t(),f.z([],p,!1)},appendOutput(p,v){return f.t(),f.z(p,v,!0)},replaceOutput(p,v){return f.t(),f.z(p,v,!1)},appendOutputItems(p,v){return f.t(),f.C(p,v,!0)},replaceOutputItems(p,v){return f.t(),f.C(p,v,!1)}})}}var d;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(d||(d={}));class h extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(f,D,p){super(),this.h=D,this.j=p,this.b=h.a++,this.c=new P.$7d,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new M.$ee),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(f,D){this.f=f,this.g=D,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new N.$Eh,this.b=Date.now(),(0,N.$ih)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>f.complete())}}function r(g,f){return`${g.value}/${f}`}}),define(ke[47],Ee([1,0,4,6,5,2,20,3,7,226,13,271,22,30,272,56,8,16,33]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=e.$rjc=e.$qjc=void 0,e.$qjc=(0,M.$hi)("IExtHostTerminalService");class i{constructor(p,v,y,C){this.l=p,this._id=v,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(z,T=!0){O.q(),O.l.$sendText(O._id,z,T)},show(z){O.q(),O.l.$show(O._id,z)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:r(p.iconPath)??void 0,color:c.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.o(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,y,C,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:C,color:c.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.o(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:a.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,v){this.h=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.d&&v===this.g||p===0||v===0?!1:(this.d=p,this.g=v,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$rjc=i;class s{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new u.$7d,this.onProcessData=this.a.event,this.b=new u.$7d,this.d=new u.$7d,this.onDidChangeProperty=this.d.event,this.f=new u.$7d,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:"overrideDimensions",value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:"title",value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,y){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$7d,this.onDidCloseTerminal=this.H.event,this.I=new u.$7d,this.onDidOpenTerminal=this.I.event,this.J=new u.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$7d,this.onDidChangeShell=this.N.event,this.O=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$gM.MainThreadTerminalService),this.y=new k.$_tb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:C=>{const O=z=>{const T=z;return this.W(T.instanceId)?.value};switch(C?.$mid){case 15:return O(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=O(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,O]of this.g)O.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const y=new i(this.a,(0,S.$Dg)(),p,p.name),C=new s(p.pty);return y.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,r(p.iconPath),g(p.color)).then(O=>{const z=this.S(O,C);this.h[O]=z}),this.f.push(y),y.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const y=p.location.parentTerminal;if(y){const C=this.f.find(O=>O.value===y);C&&(v.resolvedExtHostIdentifier=C._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const C=new s(v),O=this.S(p,C);this.h[p]=O}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const y=this.W(p);y&&(this.b=y,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const y=this.W(p);y&&this.O.fire({terminal:y.value,data:v})}async $acceptTerminalDimensions(p,v,y){const C=this.W(p);C&&C.setDimensions(v,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(p,v){const y=this.W(p);y&&this.P.fire({terminal:y.value,...v})}async $acceptTerminalMaximumDimensions(p,v,y){this.g.get(p)?.resize(v,y)}async $acceptTerminalTitleChange(p,v){const y=this.W(p);y&&(y.name=v)}async $acceptTerminalClosed(p,v,y){const C=this.Y(this.f,p);if(C!==null){const O=this.f.splice(C,1)[0];O.setExitStatus(v,y),this.H.fire(O.value)}}$acceptTerminalOpened(p,v,y,C){if(v){const T=this.Y(this.f,v);if(T!==null){this.f[T]._id=p,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const O={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:P.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new i(this.a,p,O,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(p,v){this.W(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const y=this.W(p);if(!y)return{message:(0,E.localize)(0,null,p)};y.isOpen||await new Promise(O=>{const z=this.onDidOpenTerminal(async T=>{T===y.value&&(z.dispose(),O())})});const C=this.g.get(p);C?C.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const y=new b.$Tc;y.add(v.onProcessReady(O=>this.a.$sendProcessReady(p,O.pid,O.cwd,O.windowsPty))),y.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty(p,O))),this.y.startBuffering(p,v.onProcessData),y.add(v.onProcessExit(O=>this.U(p,O))),this.g.set(p,v);const C=this.j[p];return C&&v instanceof s&&(v.startSendingEvents(C.initialDimensions),delete this.j[p]),y}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.W(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.W(p)?.setSelection(v)}$acceptProcessResize(p,v,y){try{this.g.get(p)?.resize(v,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:"cwd",value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$iM(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,y){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,y),this.a.$registerProfileProvider(v,p.identifier.value),new $.$iM(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,y){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,y),this.a.$registerQuickFixProvider(p,v),new $.$iM(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const y=new w.$ee().token;if(y.isCancellationRequested)return;const C=this.D.get(p);if(!C)return;const O=await C.provideTerminalQuickFixes(v,y);if(O===null||Array.isArray(O)&&O.length===0)return;const z=new b.$Tc;if(this.w.value=z,!Array.isArray(O))return O?a.TerminalQuickFix.from(O,this.Q.converter,z):void 0;const T=[];for(const B of O){const j=a.TerminalQuickFix.from(B,this.Q.converter,z);j&&T.push(j)}return T}async $createContributedProfileTerminal(p,v){const y=new w.$ee().token;let C=await this.C.get(p)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,v);return}this.createTerminalFromOptions(C.options,v)}}async $provideLinks(p,v){const y=this.W(p);if(!y)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const O=new w.$ee;this.G.set(p,O);const z=[],T={terminal:y.value,line:v},B=[];for(const L of this.z)B.push(m.Promises.withAsyncBody(async G=>{O.token.onCancellationRequested(()=>G({provider:L,links:[]}));const te=await L.provideTerminalLinks(T,O.token)||[];O.token.isCancellationRequested||G({provider:L,links:te})}));const j=await Promise.all(B);if(O.token.isCancellationRequested)return[];const F=new Map;for(const L of j)L&&L.links.length>0&&z.push(...L.links.map(G=>{const te={id:o++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return F.set(te.id,{provider:L.provider,link:G}),te}));return this.F.set(p,F),z}$activateLink(p,v){const y=this.F.get(p)?.get(v);y&&y.provider.handleTerminalLink(y.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const y=this.h[p];y&&(y.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}W(p){return this.X(this.f,p)}X(p,v){const y=this.Y(p,v);return y!==null?p[y]:null}Y(p,v){const y=p.findIndex(C=>C._id===v);return y===-1?null:y}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=new d,this.$(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Z(p,v){const y=(0,I.$5r)(v.map),C=(0,I.$6r)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const y=v[0],C=new d(v[1]);this.$(y,C)})}$acceptDefaultProfile(p,v){const y=this.s;this.s=p,this.u=v,y?.path!==p.path&&this.N.fire(p.path)}$(p,v){this.n.set(p,v),v.onDidChangeCollection(()=>{this.Z(p,v)})}};e.$sjc=t,e.$sjc=t=Je([Ve(1,n.$WO),Ve(2,A.$AO)],t);class d{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$7d,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.h(p);let y=this.a.get(v);return y||(y=new h(this,p),this.a.set(v,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(p,v,y,C){this.f(p,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(p,v,y,C){this.f(p,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(p,v,y,C){this.f(p,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(p,v.scope),C=this.map.get(y),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==v.value||C.type!==v.type||C.options?.applyAtProcessCreation!==O.applyAtProcessCreation||C.options?.applyAtShellIntegration!==O.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const z=this.g(p,v.scope),T={variable:p,...v,options:O};this.map.set(z,T),this.d.fire()}}get(p,v){const y=this.g(p,v),C=this.map.get(y);return C?f(C):void 0}g(p,v){const y=this.h(v);return y.length?`${p}:::${y}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(p)&&v.set(C.variable,f(C));return v}delete(p,v){const y=this.g(p,v);this.map.delete(y),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[v,y]of this.map)y.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,v){const y=this.h(v),C=this.descriptionMap.get(y);if(!C||C.description!==p){let O;typeof p=="string"?O=p:O=p?.value.split(`

`)[0];const z={description:O,scope:v};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(p){const v=this.h(p);return this.descriptionMap.get(v)?.description}k(p){const v=this.h(p);this.descriptionMap.delete(v)}}class h{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new u.$7d}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,y){this.b.replace(p,v,y,this.d)}append(p,v,y){this.b.append(p,v,y,this.d)}prepend(p,v,y){this.b.prepend(p,v,y,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((y,C)=>p.call(v,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(p,v){super(!1,p,v)}createTerminal(p,v,y){throw new R.$_}createTerminalFromOptions(p,v){throw new R.$_}};e.$tjc=l,e.$tjc=l=Je([Ve(0,n.$WO),Ve(1,A.$AO)],l);function r(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function g(D){return c.ThemeColor.isThemeColor(D)?D:void 0}function f(D){const p={...D};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(ke[352],Ee([1,0,8,21,22,4,73,55,3,18,30,12,6,20,154,16,7,66,112,89,26]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=e.$ykc=e.$xkc=e.$wkc=void 0;let o=class extends $.$Uc{constructor(T,B,j,F){super(),this.w=F,this.f=this.B(new P.$7d),this.g=new Map,this.s=this.B(new P.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(w.$gM.MainThreadTesting),this.m=new v(this.h),this.j=new l(this.h,B),j.registerArgumentProcessor({processArgument:L=>{switch(L?.$mid){case 16:{const G=L,te=G.tests[G.tests.length-1].item.extId;return this.g.get(a.$5K.root(te))?.collection.tree.get(te)?.actual??(0,k.$MO)(L)}case 18:{const{test:G,message:te}=L,Z=G.item.extId;return{test:this.g.get(a.$5K.root(Z))?.collection.tree.get(Z)?.actual??(0,k.$MO)({$mid:16,tests:[G]}),message:c.TestMessage.to(te)}}default:return L}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const L=await j.executeCommand("_testing.getExplorerSelection"),G=te=>{const Z=this.g.get(a.$5K.root(te));if(Z)return a.$5K.isRoot(te)?Z.controller:Z.collection.tree.get(te)?.actual};return{include:L?.include.map(G).filter(E.$3f)||[],exclude:L?.exclude.map(G).filter(E.$3f)||[]}})}createTestController(T,B,j,F){if(this.g.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const L=new $.$Tc,G=L.add(new k.$PO(B,j,this.w));G.root.label=j;const te=new Map,Z=new Set,x=this.h,_={items:G.root.children,get label(){return j},set label(X){j=X,G.root.label=X,x.$updateController(B,{label:j})},get refreshHandler(){return F},set refreshHandler(X){F=X,x.$updateController(B,{canRefresh:!!X})},get id(){return B},createRunProfile:(X,$e,se,re,U,ie)=>{let ve=(0,b.$8i)(X);for(;te.has(ve);)ve++;return new C(this.h,te,Z,this.s.event,B,ve,X,$e,se,re,U,ie)},createTestItem(X,$e,se){return new k.$NO(B,X,$e,se)},createTestRun:(X,$e,se=!0)=>this.j.createTestRun(T,B,G,X,$e,se),invalidateTestResults:X=>{if(X===void 0)this.h.$markTestRetired(void 0);else{const $e=X instanceof Array?X:[X];this.h.$markTestRetired($e.map(se=>a.$5K.fromExtHostTestItem(se,B).toString()))}},set resolveHandler(X){G.resolveHandler=X},get resolveHandler(){return G.resolveHandler},dispose:()=>{L.dispose()}};x.$registerTestController(B,j,!!F),L.add((0,$.$Sc)(()=>x.$unregisterTestController(B)));const ue={controller:_,collection:G,profiles:te,extension:T,activeProfiles:Z};return this.g.set(B,ue),L.add((0,$.$Sc)(()=>this.g.delete(B))),L.add(G.onDidGenerateDiff(X=>x.$publishDiff(B,X.map(i.TestsDiffOp.serialize)))),_}createTestObserver(){return this.m.checkout()}async runTests(T,B=M.CancellationToken.None){const j=r(T);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.g.get(j.controllerId);if(!F)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(L=>a.$5K.fromExtHostTestItem(L,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:O[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:T.exclude?.map(L=>L.id)},B)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $provideFileCoverage(T,B,j){return await this.j.getCoverageReport(T,B)?.provideFileCoverage(j)??[]}async $resolveFileCoverage(T,B,j,F){return await this.j.getCoverageReport(T,B)?.resolveFileCoverage(j,F)??[]}$configureRunProfile(T,B){this.g.get(T)?.profiles.get(B)?.configureHandler?.()}$setDefaultRunProfiles(T){const B=new Map;for(const[j,F]of Object.entries(T)){const L=this.g.get(j);if(!L)continue;const G=new Map,te=F.filter(x=>!L.activeProfiles.has(x)),Z=[...L.activeProfiles].filter(x=>!F.includes(x));for(const x of te)G.set(x,!0),L.activeProfiles.add(x);for(const x of Z)G.set(x,!1),L.activeProfiles.delete(x);G.size&&B.set(j,G)}this.s.fire(B)}async $refreshTests(T,B){await this.g.get(T)?.controller.refreshHandler?.(B)}$publishTestResults(T){this.results=Object.freeze(T.map(c.TestResults.to).concat(this.results).sort((B,j)=>j.completedAt-B.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,B){const j=this.g.get(a.$5K.fromString(T).controllerId)?.collection;j&&(await j.expand(T,B<0?1/0:B),j.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(B=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},B)))}async $runControllerTests(T,B){return Promise.all(T.map(j=>this.y(j,!1,B)))}async $startContinuousRun(T,B){const j=new M.$ee(B),F=await Promise.all(T.map(L=>this.y(L,!0,j.token)));return!B.isCancellationRequested&&!F.some(L=>L.error)&&await new Promise(L=>B.onCancellationRequested(L)),j.dispose(!0),F}async y(T,B,j){const F=this.g.get(T.controllerId);if(!F)return{};const{collection:L,profiles:G,extension:te}=F,Z=G.get(T.profileId);if(!Z)return{};const x=T.testIds.map($e=>L.tree.get($e)).filter(E.$3f),_=T.excludeExtIds.map($e=>F.collection.tree.get($e)).filter(E.$3f).filter($e=>x.some(se=>se.fullId.compare($e.fullId)===2));if(!x.length)return{};const ue=new m.$UN(x.some($e=>$e.actual instanceof k.$OO)?void 0:x.map($e=>$e.actual),_.map($e=>$e.actual),Z,B),X=(0,i.$8K)(T)&&this.j.prepareForMainThreadTestRun(ue,g.fromInternal(T,F.collection),te,j);try{return await Z.runHandler(ue,j),{}}catch($e){return{error:String($e)}}finally{X&&(X.hasRunningTasks&&!j.isCancellationRequested&&await P.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$wkc=o,e.$wkc=o=Je([Ve(0,S.$AO),Ve(1,I.$Nj)],o);const t=1e4;var d;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(d||(d={}));class h extends $.$Uc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(T,B,j,F,L){super(),this.s=T,this.w=B,this.y=j,this.z=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$7d),this.m=this.B(new P.$7d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new M.$ee(L));const G=this.B(new u.$th(()=>this.C(),t));this.B(this.h.token.onCancellationRequested(()=>G.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(T){const B=this.s.id,j=this.s.controllerId,F=(0,R.$Dg)(),L=this.y,G=this.m;let te;const Z=X=>($e,...se)=>{if(_){this.z.warn(`Setting the state of test "${$e.id}" is a no-op after the run ends.`);return}this.s.isIncluded($e)&&(this.F($e),X($e,...se))},x=(X,$e)=>{const se=$e instanceof Array?$e.map(c.TestMessage.from):[c.TestMessage.from($e)];if(X.uri&&X.range){const re={range:c.Range.from(X.range),uri:X.uri};for(const U of se)U.location=U.location||re}this.w.$appendTestMessagesInRun(B,F,a.$5K.fromExtHostTestItem(X,j).toString(),se)};let _=!1;const ue={isPersisted:this.s.isPersisted,token:this.h.token,name:T,get coverageProvider(){return te?.provider},set coverageProvider(X){(0,s.$6F)(L,"testCoverage"),te=X&&new f(X),G.fire({taskId:F,runId:B,coverage:te})},enqueued:Z(X=>{this.w.$updateTestStateInRun(B,F,a.$5K.fromExtHostTestItem(X,j).toString(),1)}),skipped:Z(X=>{this.w.$updateTestStateInRun(B,F,a.$5K.fromExtHostTestItem(X,j).toString(),5)}),started:Z(X=>{this.w.$updateTestStateInRun(B,F,a.$5K.fromExtHostTestItem(X,j).toString(),2)}),errored:Z((X,$e,se)=>{x(X,$e),this.w.$updateTestStateInRun(B,F,a.$5K.fromExtHostTestItem(X,j).toString(),6,se)}),failed:Z((X,$e,se)=>{x(X,$e),this.w.$updateTestStateInRun(B,F,a.$5K.fromExtHostTestItem(X,j).toString(),4,se)}),passed:Z((X,$e)=>{this.w.$updateTestStateInRun(B,F,a.$5K.fromExtHostTestItem(X,this.s.controllerId).toString(),3,$e)}),appendOutput:(X,$e,se)=>{_||(se&&(this.s.isIncluded(se)?this.F(se):se=void 0),this.w.$appendOutputToRun(B,F,N.$ue.fromString(X),$e&&c.location.from($e),se&&a.$5K.fromExtHostTestItem(se,j).toString()))},end:()=>{_||(_=!0,this.w.$finishedTestRunTask(B,F),this.f.delete(F),this.f.size||this.D())}};return this.f.set(F,{run:ue}),this.w.$startedTestRunTask(B,{id:F,name:T,running:!0}),ue}C(){for(const{run:T}of this.f.values())T.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(T){if(!(T instanceof k.$NO))throw new n.$sO(T.id);if(this.g.has(a.$5K.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const B=[],j=this.s.colllection.root;for(;;){const F=c.TestItem.from(T);if(B.unshift(F),this.g.has(F.extId)||(this.g.add(F.extId),T===j))break;T=T.parent||j}this.w.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(T,B){this.g=T,this.h=B,this.c=new Map,this.f=[]}getCoverageReport(T,B){return this.f.find(j=>j.runId===T)?.coverage.get(B)}prepareForMainThreadTestRun(T,B,j,F){return this.j(T,B,j,F)}cancelRunById(T){for(const B of this.c.values())if(B.id===T){B.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,B,j,F,L,G){const te=this.c.get(F);if(te)return te.createRun(L);const Z=g.fromPublic(B,j,F,G),x=r(F);this.g.$startedExtensionTestRun({controllerId:B,continuous:!!F.continuous,profile:x&&{group:O[x.kind],id:x.profileId},exclude:F.exclude?.map(ue=>a.$5K.fromExtHostTestItem(ue,j.root.id).toString())??[],id:Z.id,include:F.include?.map(ue=>a.$5K.fromExtHostTestItem(ue,j.root.id).toString())??[j.root.id],persist:G});const _=this.j(F,Z,T);return P.Event.once(_.onEnd)(()=>{this.g.$finishedExtensionTestRun(Z.id),_.dispose()}),_.createRun(L)}j(T,B,j,F){const L=new h(B,this.g,j,this.h,F);this.c.set(T,L);let G;const te=L.onDidCoverage(({runId:Z,taskId:x,coverage:_})=>{G||(G={runId:Z,coverage:new Map},this.f.unshift(G),this.f.length>i.$aL&&this.f.pop()),G.coverage.set(x,_),this.g.$signalCoverageAvailable(Z,x,!!_)});return P.Event.once(L.onEnd)(()=>{this.c.delete(T),te.dispose()}),L}}e.$xkc=l;const r=z=>{if(z.profile){if(!(z.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class g{static fromPublic(T,B,j,F){return new g(T,(0,R.$Dg)(),j.include?.map(L=>a.$5K.fromExtHostTestItem(L,T).toString())??[T],j.exclude?.map(L=>a.$5K.fromExtHostTestItem(L,T).toString())??[],F,B)}static fromInternal(T,B){return new g(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,B)}constructor(T,B,j,F,L,G){this.controllerId=T,this.id=B,this.isPersisted=L,this.colllection=G,this.c=j.map(te=>te+"\0"),this.f=F.map(te=>te+"\0")}isIncluded(T){const B=a.$5K.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const j of this.f)if(B===j||B.startsWith(j))return!1;for(const j of this.c)if(B===j||B.startsWith(j))return!0;return!1}}e.$ykc=g;class f{constructor(T){this.provider=T}async provideFileCoverage(T){this.c||(this.c=(async()=>this.provider.provideFileCoverage(T))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(B){throw this.c=void 0,B}}async resolveFileCoverage(T,B){const j=await this.c;let F=j?.[T];return!this.provider||!j||!F?[]:(F.detailedCoverage||(F=j[T]=await this.provider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class D{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,c.TestItem.toPlain(T.item)),this.c.has(T)||this.f.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.f.delete(T);const B=a.$5K.parentId(T.item.extId);if(B&&this.h.has(B.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{c:T,f:B,g:j}=this;return{get added(){return[...T].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...j].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class p extends i.$bL{constructor(){super(...arguments),this.s=new P.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}w(T,B){return{...T,revived:c.TestItem.toPlain(T.item),depth:B?B.depth+1:0,children:new Set}}v(){return new D(this.s)}}class v{constructor(T){this.f=T}checkout(){this.c||(this.c=this.g());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(B=>B.revived)},dispose:(0,A.$db)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}g(){const T=new p({asCanonicalUri:B=>B});return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}const y=(z,T,B,j)=>{B?Object.assign(B,j):T.$updateTestRunConfig(z.controllerId,z.profileId,j)};class C{#e;#t;#i;#n;#s;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,y(this,this.#e,this.#n,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,y(this,this.#e,this.#n,{supportsContinuousRun:T}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?this.#t.add(this.profileId):this.#t.delete(this.profileId),y(this,this.#e,this.#n,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,y(this,this.#e,this.#n,{tag:T?c.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,y(this,this.#e,this.#n,{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return P.Event.chain(this.#i,T=>T.map(B=>B.get(this.controllerId)?.get(this.profileId)).filter(E.$3f))}constructor(T,B,j,F,L,G,te,Z,x,_=!1,ue=void 0,X=!1){this.controllerId=L,this.profileId=G,this.f=te,this.kind=Z,this.runHandler=x,this._tag=ue,this.g=X,this.#e=T,this.#s=B,this.#t=j,this.#i=F,B.set(G,this);const $e=O[Z];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);_&&j.add(G),this.#n={profileId:G,controllerId:L,tag:ue?c.TestTag.namespace(this.controllerId,ue.id):null,label:te,group:$e,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:X},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$zkc=C;const O={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ke[155],Ee([1,0,61,13,124,16,7]),function(de,e,u,N,M,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=void 0;class b{static{this.c=new M.$FO("TextEditorDecorationType")}constructor(w,S,k){const c=b.c.nextId();w.$registerTextEditorDecorationType(S.identifier,c,P.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:c,dispose(){w.$removeTextEditorDecorationType(c)}})}}e.$HO=b;class ${constructor(w,S){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,S){this.k();let k=null;if(w instanceof A.$jM)k=new A.$kM(w,w);else if(w instanceof A.$kM)k=w;else throw new Error("Unrecognized location");this.l(k,S,!1)}insert(w,S){this.k(),this.l(new A.$kM(w,w),S,!0)}delete(w){this.k();let S=null;if(w instanceof A.$kM)S=w;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(w,S,k){const c=this.c.validateRange(w);this.g.push({range:c,text:S,forceMoveMarkers:k})}setEndOfLine(w){if(this.k(),w!==A.EndOfLine.LF&&w!==A.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=w}}class E{constructor(w,S,k,c){this.c=w,this.d=S,this._accept(k),this.e=c;const m=this;this.value={get tabSize(){return m.f},set tabSize(a){m.n(a)},get indentSize(){return m.g},set indentSize(a){m.p(a)},get insertSpaces(){return m.j},set insertSpaces(a){m.s(a)},get cursorStyle(){return m.k},set cursorStyle(a){m.t(a)},get lineNumbers(){return m.l},set lineNumbers(a){m.u(a)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.originalIndentSize,this.j=w.insertSpaces,this.k=w.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(w.lineNumbers)}m(w){if(w==="auto")return"auto";if(typeof w=="number"){const S=Math.floor(w);return S>0?S:null}if(typeof w=="string"){const S=parseInt(w,10);return isNaN(S)?null:S>0?S:null}return null}n(w){const S=this.m(w);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const S=Math.floor(w);return S>0?S:null}if(typeof w=="string"){const S=parseInt(w,10);return isNaN(S)?null:S>0?S:null}return null}p(w){const S=this.o(w);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(w){return w==="auto"?"auto":w==="false"?!1:!!w}s(w){const S=this.q(w);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(w){this.k!==w&&(this.k=w,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}u(w){this.l!==w&&(this.l=w,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(w)})))}assign(w){const S={};let k=!1;if(typeof w.tabSize<"u"){const c=this.m(w.tabSize);c==="auto"?(k=!0,S.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,k=!0,S.tabSize=c)}if(typeof w.indentSize<"u"){const c=this.o(w.indentSize);c==="tabSize"?(k=!0,S.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,k=!0,S.indentSize=c)}if(typeof w.insertSpaces<"u"){const c=this.q(w.insertSpaces);c==="auto"?(k=!0,S.insertSpaces=c):this.j!==c&&(this.j=c,k=!0,S.insertSpaces=c)}typeof w.cursorStyle<"u"&&this.k!==w.cursorStyle&&(this.k=w.cursorStyle,k=!0,S.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.l!==w.lineNumbers&&(this.l=w.lineNumbers,k=!0,S.lineNumbers=P.TextEditorLineNumbersStyle.from(w.lineNumbers)),k&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(w,S){S.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(k)})}}e.$IO=E;class R{constructor(w,S,k,c,m,a,n,i){this.id=w,this.j=S,this.k=k,this.g=!1,this.h=new Set,this.c=m,this.d=new E(this.j,this.id,a,k),this.e=n,this.f=i;const s=this;this.value=Object.freeze({get document(){return c.value},set document(o){throw new N.$9("document")},get selection(){return s.c&&s.c[0]},set selection(o){if(!(o instanceof A.$lM))throw(0,N.$7)("selection");s.c=[o],s.l()},get selections(){return s.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof A.$lM)))throw(0,N.$7)("selections");s.c=o,s.l()},get visibleRanges(){return s.e},set visibleRanges(o){throw new N.$9("visibleRanges")},get options(){return s.d.value},set options(o){s.g||s.d.assign(o)},get viewColumn(){return s.f},set viewColumn(o){throw new N.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new $(c.value,t);return o(d),s.m(d)},insertSnippet(o,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=s.c.map(l=>P.Range.from(l));else if(t instanceof A.$jM){const{lineNumber:l,column:r}=P.Position.from(t);h=[{startLineNumber:l,startColumn:r,endLineNumber:l,endColumn:r}]}else if(t instanceof A.$kM)h=[P.Range.from(t)];else{h=[];for(const l of t)if(l instanceof A.$kM)h.push(P.Range.from(l));else{const{lineNumber:r,column:g}=P.Position.from(l);h.push({startLineNumber:r,startColumn:g,endLineNumber:r,endColumn:g})}}return S.$tryInsertSnippet(w,c.value.version,o.value,h,d)},setDecorations(o,t){const d=t.length===0;d&&!s.h.has(o.key)||(d?s.h.delete(o.key):s.h.add(o.key),s.n(()=>{if(P.$xO(t))return S.$trySetDecorations(w,o.key,P.$yO(t));{const h=new Array(4*t.length);for(let l=0,r=t.length;l<r;l++){const g=t[l];h[4*l]=g.start.line+1,h[4*l+1]=g.start.character+1,h[4*l+2]=g.end.line+1,h[4*l+3]=g.end.character+1}return S.$trySetDecorationsFast(w,o.key,h)}}))},revealRange(o,t){s.n(()=>S.$tryRevealRange(w,P.Range.from(o),t||A.TextEditorRevealType.Default))},show(o){S.$tryShowEditor(w,P.ViewColumn.from(o))},hide(){S.$tryHideEditor(w)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,u.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,u.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,u.ok)(!this.g),this.f=w}_acceptSelections(w){(0,u.ok)(!this.g),this.c=w}async l(){const w=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const S=w.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const k=S.edits.map(m=>m.range);k.sort((m,a)=>m.end.line===a.end.line?m.end.character===a.end.character?m.start.line===a.start.line?m.start.character-a.start.character:m.start.line-a.start.line:m.end.character-a.end.character:m.end.line-a.end.line);for(let m=0,a=k.length-1;m<a;m++){const n=k[m].end;if(k[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=S.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,c,{setEndOfLine:typeof S.setEndOfLine=="number"?P.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$JO=R}),define(ke[71],Ee([1,0,61,4,3,2,5,6,152,20,155,16,12,28,15,43,44]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=void 0;class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(s,o){this.h=s,this.i=o,this.a=null,this.b=new Map,this.c=new S.$Bc,this.d=new N.$7d,this.e=new N.$7d,this.f=new N.$7d,this.g=new N.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const o=[],t=[],d=[];if(s.removedDocuments)for(const h of s.removedDocuments){const l=P.URI.revive(h),r=this.c.get(l);r?.unref()&&(this.c.delete(l),o.push(r.value))}if(s.addedDocuments)for(const h of s.addedDocuments){const l=P.URI.revive(h.uri);let r=this.c.get(l);if(r&&l.scheme!==k.Schemas.vscodeNotebookCell&&l.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);r||(r=new a(new $.$DO(this.h.getProxy(b.$gM.MainThreadDocuments),l,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this.c.set(l,r),t.push(r.value)),r.ref()}if(s.removedEditors)for(const h of s.removedEditors){const l=this.b.get(h);this.b.delete(h),l&&d.push(l)}if(s.addedEditors)for(const h of s.addedEditors){const l=P.URI.revive(h.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const r=this.c.get(l).value,g=new R.$JO(h.id,this.h.getProxy(b.$gM.MainThreadTextEditors),this.i,new m.$V(()=>r.document),h.selections.map(I.Selection.to),h.options,h.visibleRanges.map(f=>I.Range.to(f)),typeof h.editorPosition=="number"?I.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,g)}s.newActiveEditor!==void 0&&(u.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,M.$Pc)(o),(0,M.$Pc)(d),s.removedDocuments&&this.e.fire(o),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return c.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const o=this.b.get(this.a);return s?o:o?.value}allEditors(){return[...this.b.values()]}};e.$KO=n,e.$KO=n=Je([Ve(0,E.$AO),Ve(1,w.$Nj)],n),e.$LO=(0,A.$hi)("IExtHostDocumentsAndEditors")}),define(ke[353],Ee([1,0,19,4,6,155,16,7]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;class ${constructor(R,I){this.i=I,this.a=new N.$7d,this.b=new N.$7d,this.c=new N.$7d,this.d=new N.$7d,this.f=new N.$7d,this.g=new N.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(M.$gM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const I=this.i.allEditors();return R?I:I.map(w=>w.value)}async showTextDocument(R,I,w){let S;typeof I=="number"?S={position:A.ViewColumn.from(I),preserveFocus:w}:typeof I=="object"?S={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:S={preserveFocus:!1};const k=await this.h.$tryShowTextDocument(R.uri,S),c=k&&this.i.getEditor(k);if(c)return c.value;throw k?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,I){return new P.$HO(this.h,R,I).value}$acceptEditorPropertiesChanged(R,I){const w=this.i.getEditor(R);if(!w)throw new Error("unknown text editor");if(I.options&&w._acceptOptions(I.options),I.selections){const S=I.selections.selections.map(A.Selection.to);w._acceptSelections(S)}if(I.visibleRanges){const S=u.$Hb(I.visibleRanges.map(A.Range.to));w._acceptVisibleRanges(S)}if(I.options&&this.b.fire({textEditor:w.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const S=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),k=I.selections.selections.map(A.Selection.to);this.a.fire({textEditor:w.value,selections:k,kind:S})}if(I.visibleRanges){const S=u.$Hb(I.visibleRanges.map(A.Range.to));this.c.fire({textEditor:w.value,visibleRanges:S})}}$acceptEditorPositionData(R){for(const I in R){const w=this.i.getEditor(I);if(!w)throw new Error("Unknown text editor");const S=A.ViewColumn.to(R[I]);w.value.viewColumn!==S&&(w._acceptViewColumn(S),this.d.fire({textEditor:w.value,viewColumn:S}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$Vic=$}),define(ke[354],Ee([1,0,2,5,6,3,7,16,25,18]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=void 0,e.$Bkc=(0,N.$hi)("IExtHostTimeline");class R{constructor(S,k){this.b=new Map,this.c=new Map,this.a=S.getProxy(M.$gM.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(c,m)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&$.$Cm.equals(m,this.b.get(c.source)?.extension)){const a=c.uri===void 0?void 0:u.URI.revive(c.uri);return this.c.get(c.source)?.get(I(a))?.get(c.handle)}else return;return c}})}async $getTimeline(S,k,c,m){return this.b.get(S)?.provider.provideTimeline(u.URI.revive(k),c,m)}registerTimelineProvider(S,k,c,m){const a=new P.$Tc,n=this.d(k.id,m,a).bind(this);let i;k.onDidChange&&(i=k.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:k.id}),this));const s=this.c;return this.f({...k,scheme:S,onDidChange:void 0,async provideTimeline(o,t,d){t?.resetCache&&(a.clear(),s.get(k.id)?.clear());const h=await k.provideTimeline(o,t,d);if(h==null)return;const l=n(o,t);return{...h,source:k.id,items:h.items.map(l)}},dispose(){for(const o of s.values())o.get(k.id)?.clear();i?.dispose(),a.dispose()}},c)}d(S,k,c){return(m,a)=>{let n;if(a?.cacheResults){let i=this.c.get(S);i===void 0&&(i=new Map,this.c.set(S,i));const s=I(m);n=i.get(s),n===void 0&&(n=new Map,i.set(s,n))}return i=>{const{iconPath:s,...o}=i,t=`${S}|${i.id??i.timestamp}`;n?.set(t,i);let d,h,l;i.iconPath&&(s instanceof A.$eN?l={id:s.id,color:s.color}:u.URI.isUri(s)?(d=s,h=s):{light:d,dark:h}=s);let r;return A.$JM.isMarkdownString(o.tooltip)?r=b.MarkdownString.from(o.tooltip):(0,E.$Uf)(o.tooltip)?r=o.tooltip:A.$JM.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=b.MarkdownString.from(o.detail)):(0,E.$Uf)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=o.detail),{...o,id:o.id??void 0,handle:t,source:S,command:i.command?k.toInternal(i.command,c):void 0,icon:d,iconDark:h,themeIcon:l,tooltip:r,accessibilityInformation:i.accessibilityInformation}}}}f(S,k){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:k}),(0,P.$Sc)(()=>{for(const m of this.c.values())m.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Ckc=R;function I(w){return w?.toString()}}),define(ke[355],Ee([1,0,227,23,2,4,3,287,8,7,18,19,16,79,22,183,26]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;function a(s,o){if((0,R.$Uf)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class n extends A.$Uc{constructor(o,t,d){super(),this.f=o,this.g=t,this.h=d,this.a=new Map,this.b=new c.$W9;function h(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>h(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(r=>h(r)?this.r(r):r):l})}registerTreeDataProvider(o,t,d){const h=this.createTreeView(o,{treeDataProvider:t},d);return{dispose:()=>h.dispose()}}createTreeView(o,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,g=!!t.dragAndDropController?.handleDrop,f=this.m(o,t,d),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:l,hasHandleDrag:r,hasHandleDrop:g,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(o,D),v={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,m.$6F)(d,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,m.$6F)(d,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(y){(0,S.$Gk)(y)&&(0,m.$6F)(d,"treeViewMarkdownMessage"),f.message=y},get title(){return f.title},set title(y){f.title=y},get description(){return f.description},set description(y){f.description=y},get badge(){return f.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?f.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(f.badge=void 0)},reveal:(y,C)=>f.reveal(y,C),dispose:async()=>{await p,this.a.delete(o),f.dispose()}};return this.B(v),v}$getChildren(o,t){const d=this.a.get(o);return d?d.getChildren(t):Promise.reject(new b.$xF(o))}async $handleDrop(o,t,d,h,l,r,g,f){const D=this.a.get(o);if(!D)return Promise.reject(new b.$xF(o));const p=w.DataTransfer.toDataTransfer(d,async v=>(await this.f.$resolveDropFileData(o,t,v)).buffer);return g===o&&f&&await this.j(p,D,f,l,r),D.onDrop(p,h,l)}async j(o,t,d,h,l){const r=this.b.removeDragOperationTransfer(l);if(r)(await r)?.forEach((g,f)=>{g&&o.set(f,g)});else if(l&&t.handleDrag){const g=t.handleDrag(d,o,h);this.b.addDragOperationTransfer(l,g),await g}return o}async $handleDrag(o,t,d,h){const l=this.a.get(o);if(!l)return Promise.reject(new b.$xF(o));const r=await this.j(new E.$aN,l,t,h,d);if(!(!r||h.isCancellationRequested))return w.DataTransfer.from(r)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new b.$xF(o);return t.hasResolve}$resolve(o,t,d){const h=this.a.get(o);if(!h)throw new b.$xF(o);return h.resolveTreeItem(t,d)}$setExpanded(o,t,d){const h=this.a.get(o);if(!h)throw new b.$xF(o);h.setExpanded(t,d)}$setSelectionAndFocus(o,t,d){const h=this.a.get(o);if(!h)throw new b.$xF(o);h.setSelectionAndFocus(t,d)}$setVisible(o,t){const d=this.a.get(o);if(!d){if(!t)return;throw new b.$xF(o)}d.setVisible(t)}$changeCheckboxState(o,t){const d=this.a.get(o);if(!d)throw new b.$xF(o);d.setCheckboxState(t)}m(o,t,d){const h=this.B(new i(o,t,this.f,this.g.converter,this.h,d));return this.a.set(o,h),h}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$Dkc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,R.$4f)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,d,h,l,r){if(super(),this.I=o,this.J=d,this.L=h,this.M=l,this.N=r,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$ee,r.contributes&&r.contributes.views)for(const p in r.contributes.views)for(const v of r.contributes.views[p])v.id===o&&(this.P=v.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let g,f;const D=P.Event.debounce(this.F.event,(p,v)=>(p||(p={message:!1,elements:[]}),v.element!==!1&&(g||(g=new Promise(y=>f=y),this.G=this.G.then(()=>g)),Array.isArray(v.element)?p.elements.push(...v.element):p.elements.push(v.element)),v.message&&(p.message=!0),p),200,!0);this.B(D(({message:p,elements:v})=>{v.length&&(this.H=this.H.then(()=>{const y=f;return g=null,this.$(v).then(()=>y())})),p&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let d=this.X(o);return d||(d=await this.Y(t)),d?d.map(h=>h.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const d=(0,R.$4f)(t.select)?!0:t.select,h=(0,R.$4f)(t.focus)?!1:t.focus,l=(0,R.$4f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(r=>this.W(o,r[r.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:r.map(f=>f.item)},{select:d,focus:h,expand:l})),r=>this.M.error(r)):this.J.$reveal(this.I,void 0,{select:d,focus:h,expand:l})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=w.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const d=this.getExtensionElement(o);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(o,t){const d=!(0,I.$ub)(this.s,o);this.s=o;const h=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async d=>{const h=this.getExtensionElement(d.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(o,t,d){const h=[];for(const l of o){const r=this.getExtensionElement(l);r&&h.push(r)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,d){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,$.$_g)(()=>this.g?.handleDrop?this.g.handleDrop(h,o,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(o);if(d){const h=this.m.get(d);if(h){const l=await this.f.resolveTreeItem(h.extensionItem,d,t)??h.extensionItem;return this.hb(l),h.item.tooltip=this.eb(l.tooltip),h.item.command=this.fb(h.disposableStore,l.command),h.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(h=>(d.push(h),d))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$_g)(()=>this.f.getParent(o))}W(o,t){const d=this.m.get(o);return d?Promise.resolve(d):(0,$.$_g)(()=>this.f.getTreeItem(o)).then(h=>this.kb(o,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(h);if(l){const r=this.m.get(l);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const d=this.getExtensionElement(o);t=d?this.m.get(d):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new k.$ee(this.Z.token);try{const d=o?this.m.get(o):void 0,h=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const l=(0,I.$Hb)(h||[]),r=await Promise.all((0,I.$Hb)(l).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const g=r.map((f,D)=>f?this.db(l[D],f,d):null);return(0,I.$Hb)(g)}finally{t.dispose()}}$(o){if(o.some(d=>!d))return this.Z.dispose(!0),this.Z=new k.$ee,this.tb(),this.J.$refresh(this.I);{const d=this.ab(o);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(o){const t=new Set,d=o.map(l=>this.m.get(l));for(const l of d)if(l&&!t.has(l.item.handle)){let r=l;for(;r&&r.parent&&d.findIndex(g=>r&&r.parent&&g&&g.item.handle===r.parent.item.handle)===-1;){const g=this.j.get(r.parent.item.handle);r=g?this.m.get(g):void 0}r&&!r.parent&&t.add(l.item.handle)}const h=[];return t.forEach(l=>{const r=this.j.get(l);if(r){const g=this.m.get(r);g&&(!g.parent||!t.has(g.parent.item.handle))&&h.push(l)}}),h}bb(o){const t={};return Promise.all(o.map(d=>this.cb(d).then(h=>{h&&(t[d]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,$.$_g)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const l=this.ib(t,h,d.parent);return this.pb(t,l,d,d.parent),d.dispose(),l}return null})}return Promise.resolve(null)}db(o,t,d){const h=this.ib(o,t,d);if(t.id&&this.j.has(h.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(o,h),this.qb(h,d),h}eb(o){return E.$JM.isMarkdownString(o)?w.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,d,h;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,d=o.checkboxState.tooltip,h=o.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:h}}hb(o){if(!E.$8M.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,d){this.hb(t);const h=this.B(new A.$Tc),l=this.kb(o,t,d),r=this.lb(t);return{item:{handle:l,parentHandle:d?d.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:r,iconDark:this.mb(t)||r,themeIcon:this.jb(t),collapsibleState:(0,R.$4f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(o){return o.iconPath instanceof E.$eN?o.iconPath:void 0}kb(o,{id:t,label:d,resourceUri:h},l,r){if(t)return`${i.b}/${t}`;const g=a(d,this.N),f=l?l.item.handle:i.a;let D=g?g.label:h?(0,N.$Rg)(h):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const p=this.m.has(o)?this.m.get(o).item.handle:void 0,v=this.X(l)||[];let y,C=0;do{if(y=`${f}/${C}:${D}`,r||!this.j.has(y)||p===y)break;C++}while(C<=v.length);return y}lb(o){if(o.iconPath&&!(o.iconPath instanceof E.$eN))return typeof o.iconPath=="string"||M.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof E.$eN)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return M.URI.isUri(o)?o:M.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,d,h){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(o,t);const l=this.X(h)||[],r=l.filter(g=>g.item.handle===d.item.handle)[0];r&&l.splice(l.indexOf(r),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const d of t.children){const h=this.j.get(d.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const d of t.children){const h=this.j.get(d.item.handle);h&&this.sb(h)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[356],Ee([1,0,4,3,2,30,16,92,6,7]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;class R extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(k,c,m,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$7d),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=c,this.#n=m,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(k){this.c(),this.#r!==k&&(this.#r=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,M.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#o=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:A.ViewColumn.from(k),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends N.$Uc{static c(){return(0,P.$Dg)()}constructor(k,c,m){super(),this.j=c,this.m=m,this.g=new Map,this.h=new Map,this.f=k.getProxy($.$gM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,c,m,a,n={}){const i=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,b.$$ic)(k),t=I.c();this.f.$createWebviewPanel((0,b.$ajc)(k),t,c,{title:m,panelOptions:w(n),webviewOptions:(0,b.$bjc)(k,this.m,n),serializeBuffersForPostMessage:o},s);const d=this.j.createNewWebview(t,n,k);return this.createNewWebviewPanel(t,c,m,i,n,d,!0)}$onDidChangeWebviewPanelViewStates(k){const c=Object.keys(k);c.sort((m,a)=>{const n=k[m],i=k[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of c){const a=this.getWebviewPanel(m);if(!a)continue;const n=k[m];a._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,c,m){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:m,extension:k}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,b.$$ic)(k)}),new E.$iM(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(k,c,m,a){const n=this.h.get(c);if(!n)throw new Error(`No serializer found for '${c}'`);const{serializer:i,extension:s}=n,o=this.j.createNewWebview(k,m.webviewOptions,s),t=this.createNewWebviewPanel(k,c,m.title,a,m.panelOptions,o,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(k,c,m,a,n,i,s){const o=new R(k,this.f,i,{viewType:c,title:m,viewColumn:a,panelOptions:n,active:s});return this.g.set(k,o),o}getWebviewPanel(k){return this.g.get(k)}}e.$cjc=I;function w(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ke[357],Ee([1,0,4,3,92,16,6,7]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class $ extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,w,S,k,c,m){super(),this.#s=!1,this.#u=this.B(new u.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$7d),this.onDidDispose=this.#l.event,this.#i=S,this.#a=k,this.#e=I,this.#t=w,this.#n=c,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(I,w){this.d=w,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$gM.MainThreadWebviewViews)}registerWebviewViewProvider(I,w,S,k){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:S,extension:I}),this.a.$registerWebviewViewProvider((0,M.$ajc)(I),w,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$$ic)(I)}),new b.$iM(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(I,w,S,k,c){const m=this.b.get(w);if(!m)throw new Error(`No view provider found for '${w}'`);const{provider:a,extension:n}=m,i=this.d.createNewWebview(I,{},n),s=new $(I,this.a,w,S,i,!0);this.c.set(I,s),await a.resolveWebviewView(s,{state:k},c)}async $onDidChangeWebviewViewVisibility(I,w){this.e(I)._setVisible(w)}async $disposeWebviewView(I){const w=this.e(I);this.c.delete(I),w.dispose(),this.d.deleteWebview(I)}e(I){const w=this.c.get(I);if(!w)throw new Error("No webview found");return w}}e.$Gkc=E}),define(ke[358],Ee([1,0,68,15,12,258,32,11]),function(de,e,u,N,M,P,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;let $=class{constructor(I,w){I.addFileSystemProvider(N.Schemas.file,new E(w),{isCaseSensitive:b.$k})}};e.$llc=$,e.$llc=$=Je([Ve(0,u.$7ic),Ve(1,M.$Nj)],$);class E{constructor(I){this.b=I,this.a=new P.$Tq(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,S){return this.a.writeFile(I,w,{...S,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,S){return this.a.rename(I,w,S)}copy(I,w,S){return this.a.copy(I,w,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(ke[359],Ee([1,0,17,63,30,33,3,6,2,20]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;let R=class extends A.$Uc{constructor(w,S){super();const k=w.getProxy(b.$gM.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async c=>{const m=$.URI.file((0,u.$kc)((0,N.tmpdir)(),(0,M.$Dg)()));return await k.$download(c,m),m})}};e.$jlc=R,e.$jlc=R=Je([Ve(0,E.$AO),Ve(1,P.$WO)],R)}),define(ke[360],Ee([1,0,51,17,2,93,3,15,8,31]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class R extends P.$9ic{constructor(){super(...arguments),this.i=null}async g(t){const d=await super.g(t);if(d.scheme!==b.Schemas.file)return d;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const h=d.fsPath;let l=0;do{let r;l===0?r=h:r=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${l}`:`${h}-${l}`,await I(r);const g=N.$kc(r,"vscode.lock"),f=await c(this.d,g,!1);if(f)return this.i=f,process.on("exit",()=>{f.dispose()}),M.URI.file(r);l++}while(l<10);return d}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$vlc=R;async function I(o){try{await E.Promises.stat(o);return}catch{}try{await E.Promises.mkdir(o,{recursive:!0})}catch{}}const w=1e3,S=10*60*1e3;class k extends A.$Uc{constructor(t,d){super(),this.b=t,this.c=d,this.a=this.B(new $.$sh),this.a.cancelAndSet(async()=>{const h=await m(t,d);(!h||h.pid!==process.pid)&&(t.info(`Lock '${d}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(d,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${d}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(d),{flag:"w"})}catch(d){this.b.error(d)}}}async function c(o,t,d){try{const l={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){o.error(l)}const h=await m(o,t);return!h||h.pid!==process.pid?d?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new k(o,t))}async function m(o,t){let d;try{d=await E.Promises.readFile(t)}catch(h){return o.error(h),null}try{return JSON.parse(String(d))}catch(h){return o.error(h),null}}async function a(o,t){let d;try{d=await E.Promises.stat(t)}catch(h){return o.error(h),0}return d.mtime.getTime()}function n(o){try{return process.kill(o,0),!0}catch{return!1}}async function i(o,t){const d=await m(o,t);if(!d)return o.info(`Lock '${t}': Could not read pid of lock holder.`),s(o,t);if(d.willReleaseAt){let f=d.willReleaseAt-Date.now();if(f<5e3){for(f>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${f} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,$.$ih)(Math.min(100,f)),await a(o,t)===0)return s(o,t);f=d.willReleaseAt-Date.now()}return s(o,t)}}if(!n(d.pid))return o.info(`Lock '${t}': The pid ${d.pid} appears to be gone.`),s(o,t);const h=await a(o,t),l=Date.now()-h;if(l<=S)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$ih)(2e3);const r=await a(o,t),g=Date.now()-r;return g<=S?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),s(o,t))}async function s(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return c(o,t,!0)}}),define(ke[361],Ee([1,0,30,20,47,33]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;let A=class extends M.$sjc{constructor($,E){super(!0,$,E)}createTerminal($,E,R){return this.createTerminalFromOptions({name:$,shellPath:E,shellArgs:R})}createTerminalFromOptions($,E){const R=new M.$rjc(this.a,(0,u.$Dg)(),$,$.name);return this.f.push(R),R.create($,this.R($,E)),R.value}};e.$Qkc=A,e.$Qkc=A=Je([Ve(0,P.$WO),Ve(1,N.$AO)],A)}),define(ke[362],Ee([1,0,4,37,46,5]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$BL=e.OutputChannelUpdateMode=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=void 0,e.$oL="text/x-code-output",e.$pL="output",e.$qL="Log",e.$rL="text/x-code-log-output",e.$sL="log",e.$tL="workbench.panel.output",e.$uL=new M.$yj("inOutput",!1),e.$vL=new M.$yj("activeLogOutput",!1),e.$wL=new M.$yj("activeLogOutput.levelSettable",!1),e.$xL=new M.$yj("activeLogOutput.level",""),e.$yL=new M.$yj("activeLogOutput.levelIsDefault",!1),e.$zL=new M.$yj("outputView.scrollLock",!1),e.$AL=(0,P.$hi)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$BL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new u.$7d,this.onDidRegisterChannel=this.b.event,this.c=new u.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(R=>E.push(R)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$Zn.add(e.$BL.OutputChannels,new b),e.$CL=new M.$yj("activeOutputChannel","")}),define(ke[156],Ee([1,0,6,5,20,25,12,362,68,27,59,188,21,18,32,4,3]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0;class a extends A.$Tj{get disposed(){return this.n}constructor(o,t,d,h,l){super(),this.id=o,this.name=t,this.r=d,this.s=h,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=w.$ue.fromString(t).byteLength,(0,A.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(o){this.append(o)}}let i=class{constructor(o,t,d,h,l,r){this.i=t,this.j=d,this.k=h,this.l=l,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(u.$gM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(o,t,d){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,l=(0,S.$Uf)(t)?t:void 0;if((0,S.$Uf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const g=this.i.environment.extensionLogLevel?.find(([D])=>P.$Cm.equals(d.identifier,D))?.[1];g&&(r=(0,A.$5j)(g));const f=h?this.o(o,r,d):this.n(o,l,d);return f.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),h?this.r(o,r??this.m.getLevel(),f):this.q(o,f)}async n(o,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,l=this.k.extUri.joinPath(h,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(o,l,t,d.identifier.value);return new a(g,o,r,this.a,d)}async o(o,t,d){const h=await this.p(d),l=o.replace(/[\\/:\*\?"<>\|]/g,""),r=this.k.extUri.joinPath(h,`${l}.log`),g=`${d.identifier.value}.${l}`,f=this.l.createLogger(r,{id:g,name:o,logLevel:t,extensionId:d.identifier.value});return new n(g,o,f,this.a,d)}p(o){let t=this.d.get(o.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(h){if((0,k.$4k)(h)!==k.FileSystemProviderErrorCode.FileExists)throw h}return d})())}return t}q(o,t){let d=!1;const h=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return o},append(l){h(),t.then(r=>r.append(l))},appendLine(l){h(),t.then(r=>r.appendLine(l))},clear(){h(),t.then(l=>l.clear())},replace(l){h(),t.then(r=>r.replace(l))},show(l,r){h(),t.then(g=>g.show(l,r))},hide(){h(),t.then(l=>l.hide())},dispose(){d=!0,t.then(l=>l.dispose())}}}r(o,t,d){const h=new m.$Tc,l=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},r=h.add(new c.$7d);function g(f){t=f,r.fire(f)}return d.then(f=>{h.add(f),f.logLevel!==t&&g(f.logLevel),h.add(f.onDidChangeLogLevel(D=>g(D)))}),{...this.q(o,d),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(f,...D){l(),d.then(p=>p.trace(f,...D))},debug(f,...D){l(),d.then(p=>p.debug(f,...D))},info(f,...D){l(),d.then(p=>p.info(f,...D))},warn(f,...D){l(),d.then(p=>p.warn(f,...D))},error(f,...D){l(),d.then(p=>p.error(f,...D))},dispose(){h.dispose()}}}};e.$hkc=i,e.$hkc=i=Je([Ve(0,M.$AO),Ve(1,E.$QO),Ve(2,$.$7ic),Ve(3,R.$Gic),Ve(4,A.$Oj),Ve(5,A.$Nj)],i),e.$ikc=(0,N.$hi)("IExtHostOutputService")}),define(ke[157],Ee([1,0,5,8]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$4m=(0,u.$hi)("remoteAgentService"),e.$5m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let P=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await M.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,N.$ih)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[363],Ee([1,0,231,85,37,40,53,3,4,157,11,24,8]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=void 0,e.$TI=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$UI=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$VI=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$WI=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$XI={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new $.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const k=new S;M.$Zn.add(e.$XI.ConfigurationMigration,k);let c=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async s=>{for(const o of s.added)await this.f(o,k.migrations)})),this.c(k.migrations),this.B(k.onDidRegisterConfigurationMigration(s=>this.c(s)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(s=>this.g(s,n?.uri))])}async g(n,i){const s=this.a.inspect(n.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of o){const h=s[t];if(!h)continue;const l=[];if(h.value!==void 0){const r=await this.h(n,t,h.value,i,void 0);for(const g of r??[])l.push([g,[]])}for(const{identifiers:r,value:g}of h.overrides??[])if(g!==void 0){const f=await this.h(n,t,g,i,r);for(const D of f??[])l.push([D,r])}l.length&&await Promise.allSettled(l.map(async([[r,g],f])=>this.a.updateValue(r,g.value,{resource:i,overrideIdentifiers:f},d)))}}async h(n,i,s,o,t){const d=l=>{const g=this.a.inspect(l,{resource:o})[i];if(g)return t?g.overrides?.find(({identifiers:f})=>(0,I.$Rn)(f,t))?.value:g.value},h=await n.migrateFn(s,d);return Array.isArray(h)?h:[[n.key,h]]}};e.$YI=c,e.$YI=c=Je([Ve(0,A.$Ni),Ve(1,P.$qi)],c);let m=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new w.$Eh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$Zn.as(N.$5n.Configuration).registerConfiguration({...e.$VI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$ZI=m,e.$ZI=m=Je([Ve(0,E.$4m)],m)}),define(ke[364],Ee([1,0,35,15,17,23,240,363,85,5,37]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kfb=e.$jfb=void 0,e.$lfb=c,e.$mfb=m,e.$jfb=(0,E.$hi)("editorResolverService"),e.$kfb="workbench.editorAssociations";const I=R.$Zn.as($.$5n.Configuration),w={...b.$UI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(w);var S;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(S||(e.RegisteredEditorPriority=S={}));var k;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function c(a){switch(a){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function m(a,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const o=typeof a=="string"&&a.indexOf(M.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,P.$Rg)(n);return u.$ak(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}}),define(ke[365],Ee([1,0,34,15,17,11,23,2,5,276,40,147,157]),function(de,e,u,N,M,P,A,b,$,E,R,I,w){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,$.$hi)("pathService");let k=S=class{constructor(m,a,n,i){this.d=m,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??m})()}hasValidBasename(m,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(m,i,a)):this.h(m,a,n)}h(m,a,n){return m.scheme===N.Schemas.file||m.scheme===N.Schemas.vscodeRemote?(0,u.$fg)(n??(0,A.$Rg)(m),a===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,E.$RL)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:N.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?M.$gc:M.$hc)}async fileURI(m){let a="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(a=m.substring(2),m="/"):(a=m.substring(2,i),m=m.substring(i)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:a,path:m,query:"",fragment:""})}};e.$VL=k,e.$VL=k=S=Je([Ve(1,w.$4m),Ve(2,I.$DL),Ve(3,R.$qi)],k)}),define(ke[366],Ee([1,0,242,19,54,4,55,3,2,53,248,12,64,278,88,40,147,26,22,18,24,46]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.OnPortForward=e.$IL=e.$HL=e.TunnelSource=e.TunnelCloseReason=e.$FL=e.$EL=void 0,e.$GL=r,e.$JL=D,e.$KL=p,e.$LL=v,e.$ML=C;const t=10*1e3,d="remote.tunnels.toRestore",h="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$EL="onTunnel",e.$FL=new o.$yj("forwardedPortsViewEnabled",!1,u.localize(0,null));function r(T){const B=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(B)return{host:B[1]?.substring(0,B[1].length-1)||"localhost",port:Number(B[2])}}var g;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(g||(e.TunnelCloseReason=g={}));var f;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(f||(e.TunnelSource=f={})),e.$HL={source:f.User,description:u.localize(1,null)},e.$IL={source:f.Auto,description:u.localize(2,null)};function D(T,B,j){const F=T.get(v(B,j));if(F)return F;if((0,k.$1v)(B))for(const L of k.$Zv){const G=v(L,j);if(T.has(G))return T.get(G)}else if((0,k.$3v)(B))for(const L of k.$2v){const G=v(L,j);if(T.has(G))return T.get(G)}}function p(T,B,j){const F=D(T,B,j);if(F)return F;const L=(0,k.$3v)(B)?"localhost":(0,k.$1v)(B)?"0.0.0.0":void 0;if(L)return D(T,L,j)}function v(T,B){return T+":"+B}var y;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})(y||(e.OnPortForward=y={}));function C(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}class O extends b.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(B){super(),this.r=B,this.j=[],this.n=new P.$7d,this.onDidChangeAttributes=this.n.event,this.B(B.onDidChangeConfiguration(j=>{(j.affectsConfiguration(O.c)||j.affectsConfiguration(O.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(B,j,F){let L=this.w(B,j,F,this.j,0);const G={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;L>=0;){const te=this.j[L];te.key===B?(G.onAutoForward=te.onAutoForward??G.onAutoForward,G.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:G.elevateIfNeeded,G.label=te.label??G.label,G.requireLocalPort=te.requireLocalPort,G.protocol=te.protocol):(G.onAutoForward=G.onAutoForward??te.onAutoForward,G.elevateIfNeeded=G.elevateIfNeeded!==void 0?G.elevateIfNeeded:te.elevateIfNeeded,G.label=G.label??te.label,G.requireLocalPort=G.requireLocalPort!==void 0?G.requireLocalPort:void 0,G.protocol=G.protocol??te.protocol),L=this.w(B,j,F,this.j,L+1)}return G.onAutoForward!==void 0||G.elevateIfNeeded!==void 0||G.label!==void 0||G.requireLocalPort!==void 0||G.protocol!==void 0?G:this.C()}t(B){return B.start!==void 0&&B.end!==void 0}u(B){return B.host!==void 0&&B.port!==void 0&&(0,i.$Uf)(B.host)&&(0,i.$Yf)(B.port)}w(B,j,F,L,G){if(G>=L.length)return-1;const te=!(0,k.$1v)(j)&&!(0,k.$3v)(j),x=L.slice(G).findIndex(_=>(0,i.$Yf)(_.key)?te?!1:_.key===B:this.t(_.key)?te?!1:B>=_.key.start&&B<=_.key.end:this.u(_.key)?B===_.key.port&&j===_.key.host:F?_.key.test(F):!1);return x>=0?x+G:-1}y(){const B=this.r.getValue(O.c);if(!B||!(0,i.$Wf)(B))return[];const j=[];for(const L in B){if(L===void 0)continue;const G=B[L];let te;if(Number(L))te=Number(L);else if((0,i.$Uf)(L))if(O.g.test(L)){const Z=L.match(O.g);te={start:Number(Z[1]),end:Number(Z[2])}}else if(O.h.test(L)){const Z=L.match(O.h);te={host:Z[1],port:Number(Z[2])}}else{let Z;try{Z=RegExp(L)}catch{}Z&&(te=Z)}te&&j.push({key:te,elevateIfNeeded:G.elevateIfNeeded,onAutoForward:G.onAutoForward,label:G.label,requireLocalPort:G.requireLocalPort,protocol:G.protocol})}const F=this.r.getValue(O.f);return F&&(this.m={elevateIfNeeded:F.elevateIfNeeded,label:F.label,onAutoForward:F.onAutoForward,requireLocalPort:F.requireLocalPort,protocol:F.protocol}),this.z(j)}z(B){function j(F,L){return(0,i.$Yf)(F.key)?F.key:L.t(F.key)?F.key.start:L.u(F.key)?F.key.port:Number.MAX_VALUE}return B.sort((F,L)=>j(F,this)-j(L,this))}C(){return this.m}static providedActionToAction(B){switch(B){case k.ProvidedOnAutoForward.Notify:return y.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case k.ProvidedOnAutoForward.Silent:return y.Silent;case k.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(B,j,F){const G=this.r.inspect(O.c).userRemoteValue;let te;!G||!(0,i.$Wf)(G)?te={}:te=(0,s.$Nn)(G),te[`${B}`]||(te[`${B}`]={});for(const Z in j)te[`${B}`][Z]=j[Z];return this.r.updateValue(O.c,te,F)}}e.$NL=O;let z=class extends b.$Uc{constructor(B,j,F,L,G,te,Z,x,_,ue){super(),this.H=B,this.I=j,this.J=F,this.L=L,this.M=G,this.N=te,this.O=Z,this.P=x,this.Q=_,this.R=ue,this.c=new Map,this.g=new P.$7d,this.onForwardPort=this.g.event,this.h=new P.$7d,this.onClosePort=this.h.event,this.j=new P.$7d,this.onPortName=this.j.event,this.n=new P.$7d,this.onCandidatesChanged=this.n.event,this.t=new P.$7d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$7d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new O(F),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const $e=await this.getAttributes(X.map(se=>({port:se.tunnelRemotePort,host:se.tunnelRemoteHost})));for(const se of X)if(se.localAddress){const re=v(se.tunnelRemoteHost,se.tunnelRemotePort),U=p(this.m??new Map,se.tunnelRemoteHost,se.tunnelRemotePort);this.forwarded.set(re,{remotePort:se.tunnelRemotePort,remoteHost:se.tunnelRemoteHost,localAddress:se.localAddress,protocol:$e?.get(se.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(se.localAddress,$e?.get(se.tunnelRemotePort)),localPort:se.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:se.privacy,source:e.$HL}),this.f.set(re,se)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const $e=v(X.tunnelRemoteHost,X.tunnelRemotePort);if(!p(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!p(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!p(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const se=p(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),re=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set($e,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:re?.protocol??k.TunnelProtocol.Http,localUri:await this.X(X.localAddress,re),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:se?.detail,hasRunningProcess:!!se,pid:se?.pid,privacy:X.privacy,source:e.$HL})}await this.cb(),this.f.set($e,X),this.g.fire(this.forwarded.get($e))})),this.B(this.H.onTunnelClosed(X=>this.W(X,g.Other))),this.U()}S(){return this.Q.extensions.find(B=>B.activationEvents?.includes(e.$EL))?(this.R.createKey(e.$FL.key,!0),!0):!1}U(){if(this.S())return;const B=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&B.dispose()}))}async W(B,j){const F=v(B.host,B.port);this.forwarded.has(F)&&(this.forwarded.delete(F),await this.cb(),this.h.fire(B))}X(B,j){if(B.startsWith("http"))return $.URI.parse(B);const F=j?.protocol??"http";return $.URI.parse(`${F}://${B}`)}async Y(B){const j=this.N.getWorkspace(),F=j.configuration?(0,A.$8i)(j.configuration.path):j.folders.length>0?(0,A.$8i)(j.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${B}.${this.L.remoteAuthority}.${F}`}async Z(){return this.Y(d)}async $(){return this.Y(h)}async ab(){const B=this.I.get(d,1);if(B)return this.I.remove(d,1),await this.cb(),B;const j=await this.Z();if(j)return this.I.get(j,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const B=await this.s;if(B&&B!==this.y){const j=JSON.parse(B)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(F=>F.remotePort).join(", ")}`);for(const F of j){const L=p(this.detected,F.remoteHost,F.remotePort);F.source.source!==f.Extension&&!L||F.source.source===f.Extension&&L?await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,elevateIfNeeded:!0,source:F.source}):F.source.source===f.Extension&&!L&&this.D.set(v(F.remoteHost,F.remotePort),F)}}}if(this.z=!0,this.C.fire(),!this.w){const B=await this.Z();this.w=this.B(new b.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async j=>{j.key===B&&(this.s=Promise.resolve(this.I.get(B,0)),await this.restoreForwarded())}))}}bb(){const B=this.I.keys(0,0).filter(j=>j.startsWith(h));for(const j of B){const F=this.I.getNumber(j,0);if(F&&F<Date.now()){this.s=Promise.resolve(void 0);const L=j.replace(h,d);this.I.remove(j,0),this.I.remove(L,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const B=Array.from(this.forwarded.values()),j=B.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let F;B.length>0&&(F=JSON.stringify(j));const L=await this.Z(),G=await this.$();!F&&L&&G?(this.I.remove(L,0),this.I.remove(G,0)):F!==this.y&&L&&G&&(this.I.store(L,F,0,0),this.I.store(G,Date.now()+l,0,0)),this.y=F}}async eb(B,j,F){if(!B.tunnelLocalPort||!F?.requireLocalPort||B.tunnelLocalPort===j)return;const L=new Date;if(this.db.getTime()+t>L.getTime())return;this.db=L;const G=u.localize(3,null,j,B.tunnelRemotePort,B.tunnelLocalPort);return this.P.info(G)}async forward(B,j){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(B,j)}async fb(B,j){await this.Q.activateByEvent(e.$EL);const F=p(this.forwarded,B.remote.host,B.remote.port);j=j??(j!==null?(await this.getAttributes([B.remote]))?.get(B.remote.port):void 0);const L=B.local!==void 0?B.local:B.remote.port;let G;if(F)return this.hb(F,B,j);{const te=this.L.remoteAuthority,Z=te?{getAddress:async()=>(await this.M.resolveAuthority(te)).authority}:void 0,x=v(B.remote.host,B.remote.port);this.c.set(x,!0),B=this.gb(x,B);const _=await this.H.openTunnel(Z,B.remote.host,B.remote.port,void 0,L,B.elevateIfNeeded?B.elevateIfNeeded:j?.elevateIfNeeded,B.privacy,j?.protocol);if(typeof _=="string")G=_;else if(_&&_.localAddress){const ue=p(this.m??new Map,B.remote.host,B.remote.port),X=_.protocol?_.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:j?.protocol??k.TunnelProtocol.Http,$e={remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localPort:_.tunnelLocalPort,name:j?.label??B.name,closeable:!0,localAddress:_.localAddress,protocol:X,localUri:await this.X(_.localAddress,j),runningProcess:ue?.detail,hasRunningProcess:!!ue,pid:ue?.pid,source:B.source??e.$HL,privacy:_.privacy};return this.forwarded.set(x,$e),this.f.set(x,_),this.c.delete(x),await this.cb(),await this.eb(_,L,j),this.g.fire($e),_}this.c.delete(x)}return G}gb(B,j){const F=this.D.has(B)?this.D:this.F.has(B)?this.F:void 0;if(F){const L=F.get(B);F.delete(B),L&&(j.name=L.name??j.name,j.local=("local"in L?L.local:"localPort"in L?L.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(B,j,F){const L=F?.label??j.name;let G;(function(Z){Z[Z.None=0]="None",Z[Z.Fire=1]="Fire",Z[Z.Reopen=2]="Reopen"})(G||(G={}));let te=G.None;switch(L!==B.name&&(B.name=L,te=G.Fire),(F?.protocol||B.protocol!==k.TunnelProtocol.Http)&&F?.protocol!==B.protocol&&(j.source=B.source,te=G.Reopen),j.privacy&&B.privacy!==j.privacy&&(te=G.Reopen),te){case G.Fire:{this.g.fire();break}case G.Reopen:await this.close(B.remoteHost,B.remotePort,g.User),await this.fb(j,F)}return p(this.f,j.remote.host,j.remote.port)}async name(B,j,F){const L=p(this.forwarded,B,j),G=v(B,j);if(L){L.name=F,await this.cb(),this.j.fire({host:B,port:j});return}else this.detected.has(G)&&(this.detected.get(G).name=F,this.j.fire({host:B,port:j}))}async close(B,j,F){const L=v(B,j),G=this.forwarded.get(L);return F===g.AutoForwardEnd&&G&&G.source.source===f.Auto&&this.F.set(L,{local:G.localPort,name:G.name,privacy:G.privacy}),await this.H.closeTunnel(B,j),this.W({host:B,port:j},F)}address(B,j){const F=v(B,j);return(this.forwarded.get(F)||this.detected.get(F))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(B){if(B)for(const j of B){const F=p(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),L=typeof j.localAddress=="string"?j.localAddress:v(j.localAddress.host,j.localAddress.port);this.detected.set(v(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:L,protocol:k.TunnelProtocol.Http,localUri:this.X(L),closeable:!1,runningProcess:F?.detail,hasRunningProcess:!!F,pid:F?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:f.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,L,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(B){this.r=B}async setCandidates(B){let j=B;this.r&&(j=await this.r(B));const F=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(F.values()).map(L=>L.port).join(", ")}`),this.n.fire(F)}ib(B){const j=this.m??new Map,F=new Map;return this.m=F,B.forEach(L=>{const G=v(L.host,L.port);F.set(G,{host:L.host,port:L.port,detail:L.detail,pid:L.pid}),j.has(G)&&j.delete(G);const te=p(this.forwarded,L.host,L.port);te&&(te.runningProcess=L.detail,te.hasRunningProcess=!0,te.pid=L.pid)}),j.forEach((L,G)=>{const te=r(G);if(!te)return;const Z=p(this.forwarded,te.host,te.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0);const x=p(this.detected,te.host,te.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const B=Array.from(this.forwarded.values()),j=await this.getAttributes(B.map(F=>({port:F.remotePort,host:F.remoteHost})),!1);if(j)for(const F of B){const L=j.get(F.remotePort);(L?.protocol||F.protocol!==k.TunnelProtocol.Http)&&L?.protocol!==F.protocol&&await this.fb({remote:{host:F.remoteHost,port:F.remotePort},local:F.localPort,name:F.name,source:F.source},L),L&&L.label&&L.label!==F.name&&await this.name(F.remoteHost,F.remotePort,L.label)}}async getAttributes(B,j=!0){const F=new Map,L=new Map;B.forEach(_=>{const ue=p(this.m??new Map,k.$Zv[0],_.port)??_;if(ue){F.set(_.port,ue);const X=C(ue)?ue.pid:void 0;L.has(X)||L.set(X,[]),L.get(X)?.push(_.port)}});const G=new Map;if(B.forEach(_=>{const ue=this.configPortsAttributes.getAttributes(_.port,_.host,F.get(_.port)?.detail);ue&&G.set(_.port,ue)}),this.G.length===0||!j)return G.size>0?G:void 0;const te=await Promise.all((0,N.$Rb)(this.G.map(_=>Array.from(L.entries()).map(ue=>{const X=ue[1],$e=F.get(X[0]);return _.providePortAttributes(X,$e?.pid,$e?.detail,n.CancellationToken.None)})))),Z=new Map;if(te.forEach(_=>_.forEach(ue=>{ue&&Z.set(ue.port,ue)})),!G&&!Z)return;const x=new Map;return B.forEach(_=>{const ue=G.get(_.port),X=Z.get(_.port);x.set(_.port,{elevateIfNeeded:ue?.elevateIfNeeded,label:ue?.label,onAutoForward:ue?.onAutoForward??O.providedActionToAction(X?.autoForwardAction),requireLocalPort:ue?.requireLocalPort,protocol:ue?.protocol})}),x}addAttributesProvider(B){this.G.push(B)}};e.$OL=z,Je([(0,M.$Mh)(1e3)],z.prototype,"cb",null),e.$OL=z=Je([Ve(0,k.$Uv),Ve(1,S.$Lp),Ve(2,E.$Ni),Ve(3,m.$DL),Ve(4,w.$sl),Ve(5,c.$qi),Ve(6,I.$Nj),Ve(7,R.$ow),Ve(8,a.$2F),Ve(9,o.$zj)],z)}),define(ke[94],Ee([1,0]),function(de,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oK=e.$nK=void 0;class u{constructor(A,b){this.line=A,this.character=b}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,b){return new u(0,0)}with(A){return new u(0,0)}}e.$nK=u;class N{constructor(A,b,$,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(A,b),this.end=new u($,E)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new N(0,0,0,0)}with(A){return new N(0,0,0,0)}}e.$oK=N;var M;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,8]),function(de,e,u,N,M,P,A,b,$,E,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$LK=e.$EK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$BK=e.$AK=e.$zK=e.$yK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.TextSearchCompleteMessageType=void 0,e.$vK=a,e.$wK=n,e.$xK=i,e.$CK=f,e.$DK=D,e.$FK=y,e.$GK=C,e.$HK=O,e.$IK=z,e.$JK=T,e.$KK=B,e.$MK=F,e.$OK=te,e.$PK=Z,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$pK="workbench.view.search",e.$qK="workbench.panel.search",e.$rK="workbench.view.search",e.$sK="search-result",e.$tK="search.exclude";const w="\u27EA ",S=" characters skipped \u27EB",k=(w.length+S.length+5)*2;e.$uK=(0,b.$hi)("searchService");var c;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var m;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(m||(e.QueryType=m={}));function a(_){return!!_.preview}function n(_){return!!_.resource}function i(_){return!!_.message}var s;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class o{constructor(ue){this.resource=ue,this.results=[]}}e.$yK=o;class t{constructor(ue,X,$e,se){this.ranges=X,this.webviewIndex=se;const re=Array.isArray(X)?X:[X];if($e&&$e.matchLines===1&&d(re)){ue=(0,A.$Nf)(ue,$e.matchLines);let U="",ie=0,ve=0;const Ie=Math.floor($e.charsPerLine/5),le=[];for(const ae of re){const ce=Math.max(ae.startColumn-Ie,0),H=ae.startColumn+$e.charsPerLine;if(ce>ve+Ie+k){const Q=w+(ce-ve)+S;U+=Q+ue.slice(ce,H),ie+=ce-(ve+Q.length)}else U+=ue.slice(ve,H);le.push(new l(0,ae.startColumn-ie,ae.endColumn-ie)),ve=H}this.preview={text:U,matches:Array.isArray(this.ranges)?le:le[0]}}else{const U=Array.isArray(X)?X[0].startLineNumber:X.startLineNumber;this.preview={text:ue,matches:(0,u.$2b)(X,ie=>new h(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$zK=t;function d(_){const ue=_[0].startLineNumber;for(const X of _)if(X.startLineNumber!==ue||X.endLineNumber!==ue)return!1;return!0}class h{constructor(ue,X,$e,se){this.startLineNumber=ue,this.startColumn=X,this.endLineNumber=$e,this.endColumn=se}}e.$AK=h;class l extends h{constructor(ue,X,$e){super(ue,X,ue,$e)}}e.$BK=l;var r;(function(_){_.List="list",_.Tree="tree"})(r||(e.ViewMode=r={}));var g;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function f(_,ue=!0){const X=_&&_.files&&_.files.exclude,$e=ue&&_&&_.search&&_.search.exclude;if(!X&&!$e)return;if(!X||!$e)return X||$e;let se=Object.create(null);return se=M.$Qn(se,M.$Nn(X)),se=M.$Qn(se,M.$Nn($e),!0),se}function D(_,ue){return _.excludePattern&&N.$ak(_.excludePattern,ue)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&N.$ak(_.includePattern,ue)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(X=>{const $e=X.folder.fsPath;if(P.$hg(ue,$e)){const se=$.$mc($e,ue);return!X.includePattern||!!N.$ak(X.includePattern,se)}else return!1}):!1:!0}var p;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class v extends Error{constructor(ue,X){super(ue),this.code=X}}e.$EK=v;function y(_){const ue=_.message;if((0,E.$4)(_))return new v(ue,p.canceled);try{const X=JSON.parse(ue);return new v(X.message,X.code)}catch{return new v(ue,p.other)}}function C(_){const ue={message:_.message,code:_.code};return new Error(JSON.stringify(ue))}function O(_){return _.type==="error"?!0:_.type==="success"}function z(_){return _.type==="success"}function T(_){return!!_.path}function B(_,ue,X=!0){const $e=_.searchPath?_.searchPath:_.relativePath;return X?(0,A.$Kf)($e,ue):N.$ak(ue,$e)}class j{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LK=j;function F(_,ue){const X={..._||{},...ue||{}};return Object.keys(X).filter($e=>{const se=X[$e];return typeof se=="boolean"&&se})}class L{constructor(ue,X){this.c=null,this.a={...ue.excludePattern||{},...X.excludePattern||{}},this.b=N.$bk(this.a);let $e=ue.includePattern;X.includePattern&&($e?$e={...$e,...X.includePattern}:$e=X.includePattern),$e&&(this.c=N.$bk($e))}matchesExcludesSync(ue,X,$e){return!!(this.b&&this.b(ue,X,$e))}includedInQuerySync(ue,X,$e){return!(this.b&&this.b(ue,X,$e)||this.c&&!this.c(ue,X,$e))}includedInQuery(ue,X,$e){const se=this.b(ue,X,$e),re=()=>this.c?!!this.c(ue,X,$e):!0;return(0,I.$6g)(se)?se.then(U=>U?!1:re()):re()}hasSiblingExcludeClauses(){return G(this.a)}}e.$NK=L;function G(_){for(const ue in _)if(typeof _[ue]!="boolean")return!0;return!1}function te(_){if(!_)return;let ue;return X=>(ue||(ue=(_()||Promise.resolve([])).then($e=>$e?x($e):{})),ue.then($e=>!!$e[X]))}function Z(_){if(!_)return;let ue;return X=>{if(!ue){const $e=_();ue=$e?x($e):{}}return!!ue[X]}}function x(_){const ue={};for(const X of _)ue[X]=!0;return ue}}),define(ke[41],Ee([1,0,19,8,22,4,3,76,15,125,23,14,2,229,5,12,261,40,59,27,20,16,7,65,36,6,57]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d,h,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0;function g(z,T,B){return new R.$Jg(j=>v(j,B)).isEqual(z,T)}function f(z,T,B){return g(z.uri,T.uri,B)?0:(0,I.$ef)(z.uri.toString(),T.uri.toString())}function D(z,T,B){return z.index!==T.index?z.index<T.index?-1:1:g(z.uri,T.uri,B)?(0,I.$ef)(z.name,T.name):(0,I.$ef)(z.uri.toString(),T.uri.toString())}function p(z,T,B,j){const F=z.slice(0).sort((G,te)=>B(G,te,j)),L=T.slice(0).sort((G,te)=>B(G,te,j));return(0,u.$Eb)(F,L,(G,te)=>B(G,te,j))}function v(z,T){const B=T.getCapabilities(z.scheme);return!(B&&B&1024)}class y extends a.$Ai{static toExtHostWorkspace(T,B,j,F){if(!T)return{workspace:null,added:[],removed:[]};const{id:L,name:G,folders:te,configuration:Z,transient:x,isUntitled:_}=T,ue=[],X=B;B?te.forEach((U,ie)=>{const ve=w.URI.revive(U.uri),Ie=y.o(j||B,ve,F);Ie?(Ie.name=U.name,Ie.index=U.index,ue.push(Ie)):ue.push({uri:ve,name:U.name,index:ie})}):ue.push(...te.map(({uri:U,name:ie,index:ve})=>({uri:w.URI.revive(U),name:ie,index:ve}))),ue.sort((U,ie)=>U.index<ie.index?-1:1);const $e=new y(L,G,ue,!!x,Z?w.URI.revive(Z):null,!!_,U=>v(U,F)),{added:se,removed:re}=p(X?X.workspaceFolders:[],$e.workspaceFolders,f,F);return{workspace:$e,added:se,removed:re}}static o(T,B,j){for(let F=0;F<T.folders.length;F++){const L=T.workspaceFolders[F];if(g(L.uri,B,j))return L}}constructor(T,B,j,F,L,G,te){super(T,j.map(Z=>new a.$Bi(Z)),F,L,te),this.t=B,this.u=G,this.q=[],this.s=b.$ni.forUris(te),j.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,B){return B&&this.s.get(T)&&(T=(0,R.$Tg)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let C=class{constructor(T,B,j,F,L){this.c=new P.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new P.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new P.$9d,this.C=new Map,this.h=F,this.s=j,this.t=L,this.j=new E.$om,this.k=new N.$gh,this.o=T.getProxy(l.$gM.MainThreadWorkspace),this.q=T.getProxy(l.$gM.MainThreadMessageService);const G=B.workspace;this.l=G?new y(G.id,G.name,[],!!G.transient,G.configuration?w.URI.revive(G.configuration):null,!!G.isUntitled,te=>v(te,j)):void 0}$initializeWorkspace(T,B){this.v=B,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Rg)((0,R.$Tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,B,j,...F){const L=[];if(Array.isArray(F)&&F.forEach(_=>{w.URI.isUri(_.uri)&&!L.some(ue=>g(ue.uri,_.uri,this.s))&&L.push({uri:_.uri,name:_.name||(0,R.$Qg)(_.uri)})}),this.n||[B,j].some(_=>typeof _!="number"||_<0)||j===0&&L.length===0)return!1;const G=this.x?this.x.workspaceFolders:[];if(B+j>G.length)return!1;const te=G.slice(0);te.splice(B,j,...L.map(_=>({uri:_.uri,name:_.name||(0,R.$Qg)(_.uri),index:void 0})));for(let _=0;_<te.length;_++){const ue=te[_];if(te.some((X,$e)=>$e!==_&&g(ue.uri,X.uri,this.s)))return!1}te.forEach((_,ue)=>_.index=ue);const{added:Z,removed:x}=p(G,te,D,this.s);if(Z.length===0&&x.length===0)return!1;if(this.o){const _=T.displayName||T.name;this.o.$updateWorkspaceFolders(_,B,j,L).then(void 0,ue=>{this.n=void 0;const X={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(m.Severity.Error,(0,S.localize)(0,null,_,ue.toString()),X,[])})}return this.y(te),!0}getWorkspaceFolder(T,B){if(this.x)return this.x.getWorkspaceFolder(T,B)}async getWorkspaceFolder2(T,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,B)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,B){let j,F="";if(typeof T=="string"?(j=w.URI.file(T),F=T):typeof T<"u"&&(j=T,F=T.fsPath),!j)return F;const L=this.getWorkspaceFolder(j,!0);if(!L)return F;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let G=(0,R.$Wg)(L.uri,j);return B&&L.name&&(G=`${L.name}/${G}`),G}y(T){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:B,added:j,removed:F}=y.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:F}))}findFiles(T,B,j,F,L=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let G="",te=!0;return B===null?te=!1:B!==void 0&&(typeof B=="string"?G=B:G=B.pattern),this.z(T,void 0,{exclude:G,maxResults:j,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},L)}findFiles2(T,B={},j,F=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,T,B,F)}async z(T,B,j,F=M.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const L=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,G={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:L,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let te;if(T){const{includePattern:Z,folder:x}=O(o.GlobPattern.from(T));te=x,G.includePattern=Z}else{const{includePattern:Z,folder:x}=O(o.GlobPattern.from(B));te=x,G.filePattern=Z}return this.o.$startFileSearch(te??null,G,F).then(Z=>Array.isArray(Z)?Z.map(x=>w.URI.revive(x)):[])}async findTextInFiles(T,B,j,F,L=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const G=this.j.getNext(),te=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:Z,folder:x}=O(o.GlobPattern.from(B.include)),_=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ue={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:te,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:Z,excludePattern:_},X=!1;if(this.u[G]=$e=>{if(X)return;const se=w.URI.revive($e.resource);$e.results.forEach(re=>{const U=(0,r.$Qh)(re);(0,h.$vK)(U)?j({uri:se,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ie=>new t.$kM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(U.ranges,ie=>new t.$kM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):j({uri:se,text:U.text,lineNumber:U.lineNumber})})},L.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(T,x??null,ue,G,L);return delete this.u[G],$e||{}}catch($e){throw delete this.u[G],$e}}$handleTextSearchResult(T,B){this.u[B]?.(T)}async save(T){const B=await this.o.$save(T,{saveAs:!1});return w.URI.revive(B)}async saveAs(T){const B=await this.o.$save(T,{saveAs:!0});return w.URI.revive(B)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,B){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,B);const j=this.t.transformOutgoingScheme(T),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,j),(0,A.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(T,B){this.h.info("Getting edit session identifier for workspaceFolder",T);const j=await this.resolveWorkspaceFolder(w.URI.revive(T));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const F=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!F),!F)return;const L=await F.provideEditSessionIdentity(j,B);if(this.h.info("Provider returned edit session identifier: ",L),!!L)return L}async $provideEditSessionIdentityMatch(T,B,j,F){this.h.info("Getting edit session identifier for workspaceFolder",T);const L=await this.resolveWorkspaceFolder(w.URI.revive(T));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const G=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!G),!G)return;const te=await G.provideEditSessionIdentityMatch?.(B,j,F);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(T){return(B,j,F)=>{const L=function(te){B.call(j,te)};return L.extension=T,this.B.event(L,void 0,F)}}async $onWillCreateEditSessionIdentity(T,B,j){const F=await this.resolveWorkspaceFolder(w.URI.revive(T));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},B,async(L,G)=>{const te=Date.now();await Promise.resolve(L),Date.now()-te>j&&this.h.warn("SLOW edit session create-participant",G.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(T,B){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,B);const j=this.t.transformOutgoingScheme(T),F=this.A++;return this.o.$registerCanonicalUriProvider(F,j),(0,A.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(T,B,j){const F=this.C.get(T.scheme);if(!F)return;const L=await F.provideCanonicalUri?.(w.URI.revive(T),B,j);if(L)return L}async $provideCanonicalUri(T,B,j){return this.provideCanonicalUri(w.URI.revive(T),{targetScheme:B},j)}};e.$1ic=C,e.$1ic=C=Je([Ve(0,s.$AO),Ve(1,i.$QO),Ve(2,n.$Gic),Ve(3,c.$Nj),Ve(4,d.$Yic)],C),e.$2ic=(0,k.$hi)("IExtHostWorkspace");function O(z){let T,B;return z&&(typeof z=="string"?T=z:(T=z.pattern,B=w.URI.revive(z.baseUri))),{includePattern:T,folder:B}}}),define(ke[42],Ee([1,0,24,4,41,6,7,263,85,18,8,5,20,12,2]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=e.$4ic=e.$3ic=void 0;function c(d,h){if(h){const l=h.split(".");let r=d;for(let g=0;r&&g<l.length;g++)r=r[l[g]];return r}}function m(d){return d instanceof k.URI}function a(d){return d&&d.uri instanceof k.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&d.uri instanceof k.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function s(d){if(m(d))return{resource:d};if(a(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(i(d))return{resource:d.uri};if(d===null)return{resource:null}}let o=class{constructor(h,l,r){this.a=h.getProxy(P.$gM.MainThreadConfiguration),this.c=l,this.b=r,this.d=new R.$gh,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,l){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(h,l))}};e.$3ic=o,e.$3ic=o=Je([Ve(0,w.$AO),Ve(1,M.$2ic),Ve(2,S.$Nj)],o);class t{constructor(h,l,r,g){this.a=new N.$7d,this.b=h,this.f=g,this.c=l,this.e=b.$lo.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,l){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$lo.parse(h),this.d=this.k(h.configurationScopes),this.a.fire(this.j(l,r))}getConfiguration(h,l,r){const g=s(l)||{},f=this.g(h?c(this.e.getValue(void 0,g,this.c.workspace),h):this.e.getValue(void 0,g,this.c.workspace));h&&this.h(h,g,r?.identifier);function D(v){if(v==null)return null;if(typeof v=="boolean")return v?2:5;switch(v){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(v){return typeof c(f,v)<"u"},get:(v,y)=>{this.h(h?`${h}.${v}`:v,g,r?.identifier);let C=c(f,v);if(typeof C>"u")C=y;else{let O;const z=(T,B)=>{if((0,E.$Wf)(T)){let j;const F=()=>{O=O||(0,u.$Nn)(f),j=j||c(O,B)};return new Proxy(T,{get:(L,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return F(),()=>j;if(O)return j=j||c(O,B),j[G];const te=L[G];return typeof G=="string"?z(te,`${B}.${G}`):te},set:(L,G,te)=>(F(),j&&(j[G]=te),!0),deleteProperty:(L,G)=>(F(),j&&delete j[G],!0),defineProperty:(L,G,te)=>(F(),j&&Object.defineProperty(j,G,te),!0)})}return Array.isArray(T)?(0,u.$Nn)(T):T};C=z(C,v)}return C},update:(v,y,C,O)=>{v=h?`${h}.${v}`:v;const z=D(C);return y!==void 0?this.b.$updateConfigurationOption(z,v,y,g,O):this.b.$removeConfigurationOption(z,v,g,O)},inspect:v=>{v=h?`${h}.${v}`:v;const y=this.e.inspect(v,g,this.c.workspace);if(y)return{key:v,defaultValue:(0,u.$Nn)(y.policy?.value??y.default?.value),globalValue:(0,u.$Nn)(y.user?.value??y.application?.value),workspaceValue:(0,u.$Nn)(y.workspace?.value),workspaceFolderValue:(0,u.$Nn)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$Nn)(y.default?.override),globalLanguageValue:(0,u.$Nn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$Nn)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$Nn)(y.workspaceFolder?.override),languageIds:(0,u.$Nn)(y.overrideIdentifiers)}}};return typeof f=="object"&&(0,u.$Qn)(p,f,!1),Object.freeze(p)}g(h){const l=r=>(0,E.$Wf)(r)?new Proxy(r,{get:(g,f)=>l(g[f]),set:(g,f,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(g,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(g,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return l(h)}h(h,l,r){const g=$.$co.test(h)?4:this.d.get(h),f=r?`[${r.value}] `:"";if(g===4){typeof l?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){l?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,l){const r=new b.$no(h,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,f)=>r.affectsConfiguration(g,s(f))})}k(h){return h.reduce((l,r)=>(l.set(r[0],r[1]),l),new Map)}}e.$4ic=t,e.$5ic=(0,I.$hi)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,8,4,6,7,41,71,42,22,47,20,27,5,15,11,12,91,305,13]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$ukc=e.$tkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(z){function T(j){if(j!=null)return j}z.from=T;function B(j){if(j!=null)return j}z.to=B})(o||(o={}));var t;(function(z){function T(j){if(j!=null)return j}z.from=T;function B(j){if(j!=null)return j}z.to=B})(t||(t={}));var d;(function(z){function T(j){if(j!=null)return j}z.from=T;function B(j){if(j!=null)return j}z.to=B})(d||(d={}));var h;(function(z){function T(F){if(F){const L=F;return L&&!!L.process}else return!1}z.is=T;function B(F){if(F==null)return;const L={process:F.process,args:F.args};return F.options&&(L.options=d.from(F.options)),L}z.from=B;function j(F){if(F!=null)return new A.$4M(F.process,F.args,F.options)}z.to=j})(h||(h={}));var l;(function(z){function T(j){if(j!=null)return j}z.from=T;function B(j){if(j!=null)return j}z.to=B})(l||(l={}));var r;(function(z){function T(F){if(F){const L=F;return L&&(!!L.commandLine||!!L.command)}else return!1}z.is=T;function B(F){if(F==null)return;const L={};return F.commandLine!==void 0?L.commandLine=F.commandLine:(L.command=F.command,L.args=F.args),F.options&&(L.options=l.from(F.options)),L}z.from=B;function j(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$5M(F.commandLine,F.options):new A.$5M(F.command,F.args?F.args:[],F.options)}z.to=j})(r||(r={}));var g;(function(z){function T(F){if(F){const L=F;return L&&L.customExecution==="customExecution"}else return!1}z.is=T;function B(F){return{customExecution:"customExecution"}}z.from=B;function j(F,L){return L.get(F)}z.to=j})(g||(e.CustomExecutionDTO=g={}));var f;(function(z){function T(B,j){let F;return B.scope!==void 0&&typeof B.scope!="number"?F=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?F=j.workspaceFile:F=i.$oH),{id:B._id,workspaceFolder:F}}z.from=T})(f||(e.TaskHandleDTO=f={}));var D;(function(z){function T(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}z.from=T})(D||(D={}));var p;(function(z){function T(F,L){if(F==null)return[];const G=[];for(const te of F){const Z=B(te,L);Z&&G.push(Z)}return G}z.fromMany=T;function B(F,L){if(F==null)return;let G;F.execution instanceof A.$4M?G=h.from(F.execution):F.execution instanceof A.$5M?G=r.from(F.execution):F.execution&&F.execution instanceof A.$6M&&(G=g.from(F.execution));const te=o.from(F.definition);let Z;return F.scope?typeof F.scope=="number"?Z=F.scope:Z=F.scope.uri:Z=A.TaskScope.Workspace,!te||!Z?void 0:{_id:F._id,definition:te,name:F.name,source:{extensionId:L.identifier.value,label:F.source,scope:Z},execution:G,isBackground:F.isBackground,group:D.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}z.from=B;async function j(F,L,G){if(F==null)return;let te;h.is(F.execution)?te=h.to(F.execution):r.is(F.execution)?te=r.to(F.execution):g.is(F.execution)&&(te=g.to(F._id,G));const Z=o.to(F.definition);let x;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?x=F.source.scope:x=await L.resolveWorkspaceFolder(u.URI.revive(F.source.scope)):x=A.TaskScope.Workspace),!Z||!x)return;const _=new A.$7M(Z,x,F.name,F.source.label,te,F.problemMatchers);return F.isBackground!==void 0&&(_.isBackground=F.isBackground),F.group!==void 0&&(_.group=A.$3M.from(F.group._id),_.group&&F.group.isDefault&&(_.group=new A.$3M(_.group.id,_.group.label),F.group.isDefault===!0&&(_.group.isDefault=F.group.isDefault))),F.presentationOptions&&(_.presentationOptions=t.to(F.presentationOptions)),F._id&&(_._id=F._id),F.detail&&(_.detail=F.detail),_}z.to=j})(p||(e.TaskDTO=p={}));var v;(function(z){function T(j){return j}z.from=T;function B(j){if(j)return Object.assign(Object.create(null),j)}z.to=B})(v||(v={}));class y{#e;constructor(T,B,j){this._id=B,this.a=j,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let C=class{constructor(T,B,j,F,L,G,te,Z){this.q=new M.$7d,this.r=new M.$7d,this.s=new M.$7d,this.u=new M.$7d,this.a=T.getProxy(P.$gM.MainThreadTask),this.b=j,this.c=F,this.d=L,this.e=G,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=te,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,B,j){if(!j)return new A.$iM(()=>{});const F=this.x();return this.j.set(F,{type:B,provider:j,extension:T}),this.a.$registerTaskProvider(F,B),new A.$iM(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(T,B){this.a.$registerTaskSystem(T,B)}fetchTasks(T){return this.a.$fetchTasks(v.from(T)).then(async B=>{const j=[];for(const F of B){const L=await p.to(F,this.b,this.m);L&&j.push(L)}return j})}get taskExecutions(){const T=[];return this.k.forEach(B=>T.push(B)),T}terminateTask(T){if(!(T instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,B,j){const F=this.m.get(T.id);F&&(this.o.set(T.id,F),this.e.attachPtyToTerminal(B,await F.callback(j))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const B=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const B=await this.z(T.id);this.s.fire({execution:B,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const B=await this.z(T.id);this.u.fire({execution:B,exitCode:T.exitCode})}$provideTasks(T,B){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));const F=[],L=(0,N.$_g)(()=>j.provider.provideTasks(R.CancellationToken.None)).then(G=>this.v(B,F,j,G));return new Promise(G=>{L.then(te=>{Promise.all(F).then(()=>{G(te)})})})}async $resolveTask(T,B){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));if(B.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${j.type}].`);const F=await p.to(B,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const L=await j.provider.resolveTask(F,R.CancellationToken.None);if(!L)return;this.A(L,j);const G=p.from(L,j.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(G.execution)&&await this.y(G,L,!0),await this.w(G)}x(){return this.h++}async y(T,B,j){const F=await this.a.$createTaskId(T);!j&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,B.execution)),this.m.set(F,B.execution)}async z(T,B){if(typeof T=="string"){const L=this.l.get(T);if(!L)throw new s.$bb("Unexpected: The specified task is missing an execution");return L}const j=this.l.get(T.id);if(j)return j;let F;return B?F=Promise.resolve(new y(this,T.id,B)):F=p.to(T.task,this.b,this.m).then(L=>{if(!L)throw new s.$bb("Unexpected: Task does not exist.");return new y(this,T.id,L)}),this.l.set(T.id,F),F.then(L=>(this.k.set(T.id,L),L))}A(T,B){T._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const j=this.n.values();let F=j.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=j.next()}};e.$tkc=C,e.$tkc=C=Je([Ve(0,w.$AO),Ve(1,S.$QO),Ve(2,b.$2ic),Ve(3,$.$LO),Ve(4,E.$5ic),Ve(5,I.$qjc),Ve(6,a.$Nj),Ve(7,n.$Cic)],C);let O=class extends C{constructor(T,B,j,F,L,G,te,Z){super(T,B,j,F,L,G,te,Z),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(T,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const j=p.from(B,T);if(j===void 0)throw new Error("Task is not valid");if(g.is(j.execution))await this.y(j,B,!1);else throw new s.$_;const F=await this.z(await this.a.$getTaskExecution(j),B);return this.a.$executeTask(j).catch(L=>{throw new Error(L)}),F}v(T,B,j,F){const L=[];if(F)for(const G of F){if(this.A(G,j),!G.definition||!T[G.definition.type]){const Z=G.source?G.source:"No task source";this.f.warn(`The task [${Z}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=p.from(G,j.extension);te&&g.is(te.execution)?(L.push(te),B.push(this.y(te,G,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:L,extension:j.extension}}async w(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,B,j){}};e.$ukc=O,e.$ukc=O=Je([Ve(0,w.$AO),Ve(1,S.$QO),Ve(2,b.$2ic),Ve(3,$.$LO),Ve(4,E.$5ic),Ve(5,I.$qjc),Ve(6,a.$Nj),Ve(7,n.$Cic)],O),e.$vkc=(0,k.$hi)("IExtHostTask")}),define(ke[367],Ee([1,0,36,29]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=void 0,e.$VK=M,e.$XK=P;function M(A){return"cellResults"in A}e.$WK="rawCell#";function P(A,b){let $=-1;const E=[];let R=[];return A.forEach(w=>{w.range.startLineNumber!==$&&R.length>0&&(E.push([...R]),R=[]),R.push(w),$=w.range.endLineNumber}),R.length>0&&E.push([...R]),E.map(w=>{const S=[],k=w[0].range.startLineNumber,c=w[w.length-1].range.endLineNumber;for(let m=k;m<=c;m++)S.push(b.getLineContent(m));return new u.$zK(S.join(`
`)+`
`,w.map(m=>new N.$at(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[368],Ee([1,0,223,21,4,3,28,14,18,2,32,111,6,33,16,7,67,338,153,24,15,295,367,364]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,g,f,D,p,v){this.q=f,this.r=D,this.s=p,this.t=v,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new M.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Aic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=r.getProxy(w.$gM.MainThreadNotebook),this.c=r.getProxy(w.$gM.MainThreadNotebookDocuments),this.d=r.getProxy(w.$gM.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,O=y.cell.handle,T=this.g.get(C)?.getCell(O);if(T)return T.apiCell}if(y&&y.$mid===14){const C=y.uri,O=this.g.get(C);if(O)return O.apiNotebook}return y}}),h.B(g)}getEditorById(r){const g=this.h.get(r);if(!g)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(r){for(const[g,f]of this.h)if(f.apiEditor===r)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,g){const f=this.g.get(r);if(!f&&!g)throw new Error(`NO notebook document for '${r}'`);return f}static u(r,g){if(!g)return;const f=g.filenamePattern.map(D=>k.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(g.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:g.displayName,filenamePattern:f,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,g,f){const D=h.a++,p=typeof f.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(D,f),this.b.$registerNotebookCellStatusBarItemProvider(D,p,g);let v;return p!==void 0&&(v=f.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(p))),new c.$iM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,p),v?.dispose()})}async createNotebookDocument(r){const g=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&k.NotebookData.from(r.content)});return E.URI.revive(g)}async openNotebookDocument(r){const g=this.g.get(r);if(g)return g.apiNotebook;const f=await this.c.$tryOpenNotebook(r),D=this.g.get(E.URI.revive(f));return(0,$.$6f)(D?.apiNotebook)}async showNotebookDocument(r,g){E.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let f;typeof g=="object"?f={position:k.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(k.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:f={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,f),p=D&&this.h.get(D)?.apiEditor;if(p)return p;throw D?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,g,f,D){const p=this.f.get(r),v=E.URI.revive(g),y=this.g.get(v);if(!y||!p)return;const C=y.getCellFromIndex(f);if(!C)return;const O=await p.provideCellStatusBarItems(C.apiCell,D);if(!O)return;const z=new P.$Tc,T=this.p.add([z]),j=(Array.isArray(O)?O:[O]).map(F=>k.NotebookStatusBarItem.from(F,this.i,z));return{cacheId:T,items:j}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,g,f,D,p){if((0,b.$Ue)(g))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:g,serializer:f,options:D}),this.b.$registerNotebookSerializer(v,{id:r.identifier,location:r.extensionLocation},g,k.NotebookDocumentContentOptions.from(D),h.u(r,p)),(0,P.$Sc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(r,g,f){const D=this.x.get(r);if(!D)throw new Error("NO serializer found");const p=await D.serializer.deserializeNotebook(g.buffer,f);return new m.$cw(k.NotebookData.from(p))}async $notebookToData(r,g,f){const D=this.x.get(r);if(!D)throw new Error("NO serializer found");const p=await D.serializer.serializeNotebook(k.NotebookData.to(g.value),f);return N.$ue.wrap(p)}async $saveNotebook(r,g,f,D,p){const v=E.URI.revive(g),y=this.x.get(r);if(!y)throw new Error("NO serializer found");const C=this.g.get(v);if(!C)throw new Error("Document NOT found");if(C.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new R.$9k((0,u.localize)(0,null,this.z(v)),6);await this.y(v,D);const O={metadata:(0,i.$Vn)(C.apiNotebook.metadata,F=>!(y.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of C.apiNotebook.getCells()){const L=new c.$KN(F.kind,F.document.getText(),F.document.languageId,F.mime,y.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);L.metadata=(0,i.$Vn)(F.metadata,G=>!(y.options?.transientCellMetadata??{})[G]),O.cells.push(L)}const z=await y.serializer.serializeNotebook(O,p);await this.s.value.writeFile(v,z);const T=this.s.getFileSystemProviderExtUri(v.scheme),B=await this.s.value.stat(v);return{name:T.basename(v),isFile:(B.type&R.FileType.File)!==0,isDirectory:(B.type&R.FileType.Directory)!==0,isSymbolicLink:(B.type&R.FileType.SymbolicLink)!==0,mtime:B.mtime,ctime:B.ctime,size:B.size,readonly:!!((B.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((B.permissions??0)&R.FilePermission.Locked),etag:R.$hl({mtime:B.mtime,size:B.size}),children:void 0}}async $searchInNotebooks(r,g,f,D,p){const v=this.x.get(r)?.serializer;if(!v)return{limitHit:!1,results:[]};const y=new A.$Cc;await(async(B,j,F)=>{await Promise.all(B.map(async L=>await Promise.all(L.filenamePatterns.map(G=>{const te={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:G};return this.t.doInternalFileSearchWithCustomCallback(te,j,Z=>{Z.forEach(x=>{y.has(x)||D.some(ue=>L.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(X=>(0,d.$mfb)(X,x)))||y.add(x)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(f,p,g);const O=new A.$Bc;let z=!1;const T=Array.from(y).map(async B=>{const j=[];try{if(p.isCancellationRequested)return;if(g.maxResults&&[...O.values()].reduce((te,Z)=>te+Z.cellResults.length,0)>g.maxResults){z=!0;return}const F=[],L=this.g.get(B);if(L)L.apiNotebook.getCells().forEach(Z=>F.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(x=>x.items.map(_=>_.data.toString()))}));else{const te=await this.s.value.readFile(B),Z=N.$ue.fromString(te.toString()),x=await v.deserializeNotebook(Z.buffer,p);if(p.isCancellationRequested)return;k.NotebookData.from(x).cells.forEach(ue=>F.push({input:ue.source,outputs:ue.outputs.flatMap(X=>X.items.map($e=>$e.valueBytes.toString()))}))}if(p.isCancellationRequested)return;F.forEach((te,Z)=>{const x=g.contentPattern.pattern,_=new o.$2Tb(te.input,void 0,te.outputs),ue=_.findInInputs(x),X=_.findInOutputs(x),$e=X.flatMap(se=>(0,t.$XK)(se.matches,se.textBuffer)).map((se,re)=>(se.webviewIndex=re,se));if(ue.length>0||X.length>0){const se={index:Z,contentResults:(0,t.$XK)(ue,_.inputTextBuffer),webviewResults:$e};j.push(se)}});const G={resource:B,cellResults:j};O.set(B,G);return}catch{return}});return await Promise.all(T),{limitHit:z,results:[...O.values()]}}async y(r,g){const f=await this.s.value.stat(r);if(typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==R.$gl&&typeof f.mtime=="number"&&typeof f.size=="number"&&g.mtime<f.mtime&&g.etag!==R.$hl({mtime:g.mtime,size:f.size}))throw new R.$9k((0,u.localize)(1,null),3,g)}z(r){return r.scheme===s.Schemas.file?r.fsPath:r.toString()}A(r,g,f){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const D=new n.$Yjc(g,this.d,r,f.visibleRanges.map(k.NotebookRange.to),f.selections.map(k.NotebookRange.to),typeof f.viewColumn=="number"?k.ViewColumn.to(f.viewColumn):void 0);this.h.set(g,D)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const f of r.value.removedDocuments){const D=E.URI.revive(f),p=this.g.get(D);p&&(p.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===D.toString()&&this.h.delete(v.id)}if(r.value.addedDocuments){const f=[];for(const D of r.value.addedDocuments){const p=E.URI.revive(D.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new a.$Xjc(this.c,this.q,this.r,p,D);f.push(...D.cells.map(y=>a.$Wjc.asModelAddData(y))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(v.apiNotebook)}}if(r.value.addedEditors)for(const f of r.value.addedEditors){if(this.h.has(f.id))return;const D=E.URI.revive(f.documentUri),p=this.g.get(D);p&&this.A(p,f.id,f)}const g=[];if(r.value.removedEditors)for(const f of r.value.removedEditors){const D=this.h.get(f);D&&(this.h.delete(f),this.k?.id===D.id&&(this.k=void 0),g.push(D))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const f=new Set;this.l.forEach(D=>f.add(D.id));for(const D of this.h.values()){const p=f.has(D.id);D._acceptVisibility(p)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(r){const g=S.$YO.String.with("notebookType","A notebook type"),f=new S.$1O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new S.$YO("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>N.$ue.wrap(p))],new S.$ZO("Notebook Data",p=>k.NotebookData.to(p.value))),D=new S.$1O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new S.$YO("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new m.$cw(k.NotebookData.from(p)))],new S.$ZO("Bytes",p=>p.buffer));r.registerApiCommand(f),r.registerApiCommand(D)}}e.$8jc=h}),define(ke[369],Ee([1,0,17,22,45,35,23,38,36]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class E{constructor(w,S,k){this.k=w,this.l=S,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&P.$bk(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&P.$bk(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const S=this.k.folderQueries||[];return new Promise((k,c)=>{const m=a=>{this.f++,w(a)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:a,basename:i})}),Promise.all(S.map(a=>this.p(a,m))).then(a=>{k({limitHit:this.e,stats:a[0]||void 0})},a=>{c(new Error((0,M.$5i)(a)))})})}async p(w,S){const k=new N.$ee,c=this.q(w),m=this.r(),a=new $.$NK(this.k,w),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(k),i=b.$3d.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,k.token),o=i.elapsed(),t=b.$3d.create();return this.g&&!this.e||(s&&s.forEach(d=>{const h=u.$hc.relative(w.folder.path,d.path);if(n){const l=u.$oc(d.path);this.v(S,{base:w.folder,relativePath:h,basename:l});return}this.s(m,w.folder,h,S)}),this.g&&!this.e)?null:(this.u(m,a,S),{providerTime:o,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(w){const S=(0,$.$MK)(this.k.includePattern,w.includePattern),k=(0,$.$MK)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:k,includes:S,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},S,k,c){if(k===this.a){const a=u.$oc(this.a);this.v(c,{base:S,relativePath:this.a,basename:a})}function m(a){const n=u.$oc(a),i=u.$nc(a);let s=w[i];s||(s=w[i]=[],m(i)),s.push({base:S,relativePath:a,basename:n})}m(k)}u({rootEntries:w,pathToEntries:S},k,c){const m=this,a=this.a;function n(i){const s=(0,$.$PK)(()=>i.map(o=>o.basename));for(let o=0,t=i.length;o<t;o++){const d=i[o],{relativePath:h,basename:l}=d;if(k.matchesExcludesSync(h,l,a!==l?s:void 0))continue;const r=S[h];if(r)n(r);else{if(h===a)continue;m.v(c,d)}if(m.e)break}}n(w)}v(w,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(S))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,S,k,c){const m=this.c(w.cacheKey),a=new E(w,S,m&&m.token);let n=0;const i=s=>{n+=s.length,k(s.map(o=>this.d(o)))};return this.e(a,R.a,i,c).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:s.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new N.$ee),this.b.get(w)}d(w){return w.relativePath?{resource:A.$Ug(w.base,w.relativePath)}:{resource:w.base}}e(w,S,k,c){const m=c.onCancellationRequested(()=>{w.cancel()}),a=i=>{i&&(n.push(i),S>0&&n.length>=S&&(k(n),n=[]))};let n=[];return w.search(a).then(i=>(n.length&&k(n),m.dispose(),i),i=>(n.length&&k(n),m.dispose(),Promise.reject(i)))}}e.$Zjc=R}),define(ke[370],Ee([1,0,19,72,35,103,28,15,17,23,14,18,2,100,243,53,12,40,146,365,36]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=void 0,e.$XL=D;let o=class{constructor(v,y,C,O,z){this.a=v,this.b=y,this.c=C,this.d=O,this.e=z}text(v,y,C={}){v=this.f(v,C);const O=this.a.getValue(),z=y&&y.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(y?.map(a.$Ci),C),type:2,contentPattern:v,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:O.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(v,y){const C=this.a.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const O={...v,wordSeparators:C.editor.wordSeparators};return this.j(v,y)&&(O.isCaseSensitive=!0),this.k(v)&&(O.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),O}file(v,y={}){return{...this.h(v,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(v,y){return v?(v=Array.isArray(v)?v.map(r):r(v),y?this.parseSearchPaths(v):{pattern:d(...Array.isArray(v)?v:[v])}):{}}h(v=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),O=this.g(y.excludePattern,y.expandPatterns),z=v.length>1,T=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(F=>this.q(F,y,O)):v.map(F=>this.r(F,y,O,z))).filter(F=>!!F),B={_reason:y._reason,folderQueries:T,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:O.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const F=u.$Hb(u.$Rb(this.c.groups.map(te=>te.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const L=F.filter(te=>(0,s.$DK)(B,te.fsPath)),G=this.i(L);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(G)),{...B,...G}}const j=y.extraFileResources&&y.extraFileResources.filter(F=>(0,s.$DK)(B,F.fsPath));return B.extraFileResources=j&&j.length?j:void 0,B}i(v){const y=[],C=new A.$Bc,O={};let z=!1;return v.forEach(T=>{if(T.scheme===b.Schemas.walkThrough)return;if((0,E.$Yg)(T)){const j=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$nc(T.fsPath)});let F=C.get(j);F||(z=!0,F={folder:j,includePattern:{}},y.push(F),C.set(j,F));const L=$.$mc(j.fsPath,T.fsPath);(0,I.$6f)(F.includePattern)[L.replace(/\\/g,"/")]=!0}else T.fsPath&&(z=!0,O[T.fsPath]=!0)}),{folderQueries:y,includePattern:O,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(v,y){if(y.isSmartCase){if(v.isRegExp){if(R.$Lf(v.pattern,!0))return!0}else if(R.$Lf(v.pattern))return!0}return!!v.isCaseSensitive}k(v){return v.isMultiline||v.isRegExp&&(0,S.$mC)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const y=G=>$.$jc(G)||/^\.\.?([\/\\]|$)/.test(G),O=(Array.isArray(v)?v:h(v)).map(G=>{const te=this.e.resolvedUserHome;return te?(0,P.$hw)(G,te.scheme===b.Schemas.file?te.fsPath:te.path):G}),z=N.$K(O,G=>y(G)?"searchPaths":"exprSegments"),T=(z.exprSegments||[]).map(G=>R.$6e(G,"/")).map(G=>R.$6e(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),l(G))),B={},j=this.m(z.searchPaths||[]);j&&j.length&&(B.searchPaths=j);const F=u.$Rb(T),L=d(...F);return L&&(B.pattern=L),B}l(v,y){return y.disregardExcludeSettings?void 0:(0,s.$CK)(v,!y.disregardSearchExcludeSettings)}m(v){if(!v||!v.length)return[];const y=v.flatMap(O=>{let{pathPortion:z,globPortion:T}=t(O);return T&&(T=g(T)),this.n(z).flatMap(j=>this.o(j,T))}),C=new Map;return y.forEach(O=>{const z=O.searchPath.toString(),T=C.get(z);T?O.pattern&&(T.pattern=T.pattern||{},T.pattern[O.pattern]=!0):C.set(z,{searchPath:O.searchPath,pattern:O.pattern?d(O.pattern):void 0})}),Array.from(C.values())}n(v){if($.$jc(v)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==b.Schemas.file?[{searchPath:y[0].uri.with({path:v})}]:[{searchPath:w.URI.file($.$ic(v))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(v=r(v),v.startsWith("../")||v===".."){const O=$.$hc.resolve(y.path,v);return[{searchPath:y.with({path:O})}]}const C=g(v);return[{searchPath:y,pattern:C}]}else{if(v==="./"||v===".\\")return[];{const y=v.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(z=>{const T=y.match(new RegExp(`^${R.$Ze(z.name)}(?:/(.*)|$)`));return T?{match:T,folder:z}:null}).filter(I.$3f);if(O.length)return O.map(z=>{const T=z.match[1];return{searchPath:z.folder.uri,pattern:T&&g(T)}});{const z=v.match(/\.[\/\\](.+)[\/\\]?/),T=z?z[1]:v,B=k.localize(0,null,T);throw new Error(B)}}}}o(v,y){const C=v.pattern&&y?`${v.pattern}/${y}`:v.pattern||y,O=[{searchPath:v.searchPath,pattern:C}];return C&&!C.endsWith("**")&&O.push({searchPath:v.searchPath,pattern:C+"/**"}),O}q(v,y,C){const O=this.r((0,a.$Ci)(v.searchPath),y,C,!1);return O?{...O,includePattern:v.pattern}:null}r(v,y,C,O){let z;const T=w.URI.isUri(v)?v:v.uri;if(C.searchPaths){const G=C.searchPaths.filter(te=>(0,E.$Ng)(te.searchPath,T))[0];if(G&&!G.pattern)return null;G&&(z=G.pattern)}const B=this.a.getValue({resource:T}),F={...this.l(B,y)||{},...z||{}},L=w.URI.isUri(v)?(0,E.$Rg)(v):v.name;return{folder:T,folderName:O?L:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!B.search.followSymlinks}}};e.$WL=o,e.$WL=o=Je([Ve(0,c.$Ni),Ve(1,a.$qi),Ve(2,n.$tD),Ve(3,m.$Nj),Ve(4,i.$UL)],o);function t(p){const v=p.match(/[\*\{\}\(\)\[\]\?]/);if(v){const y=v.index,C=p.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let O=p.substr(0,C.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:p.substr((C.index||0)+1)}}}return{pathPortion:p}}function d(...p){return p.length?p.reduce((v,y)=>(v[y]=!0,v),Object.create(null)):void 0}function h(p){return M.$_j(p,",").map(v=>v.trim()).filter(v=>!!v.length)}function l(p){return[`**/${p}/**`,`**/${p}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function g(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(p){return p.replace(/([?*[\]])/g,"[$1]")}function D(p,v){p=u.$Mb(p,O=>O.toString());const y=[],C=v.getWorkspace();return p&&p.forEach(O=>{let z;if(v.getWorkbenchState()===2)z=(0,E.$Wg)(C.folders[0].uri,O),z&&z!=="."&&(z="./"+z);else{const T=v.getWorkspaceFolder(O);if(T){const B=T.name;if(C.folders.filter(F=>F.name===B).length===1){const F=(0,E.$Wg)(T.uri,O);F===""?z=`./${T.name}`:z=`./${T.name}/${F}`}else z=O.fsPath}}z&&y.push(f(z))}),y}}),define(ke[371],Ee([1,0,23,2,22,13,5,370,36,40,8]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rub=w,e.$Sub=c;const I=7e3;function w(m,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],s=[];for(const r of n)if(/^workspaceContains:/.test(r)){const g=r.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||m.forceUsingSearch?s.push(g):i.push(g)}if(i.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,R.$ah)(),d=r=>t({activationEvent:r}),h=Promise.all(i.map(r=>S(m,r,d))).then(()=>{}),l=k(m,a.identifier,s,d);return Promise.all([h,l]).then(()=>{t(void 0)}),o}async function S(m,a,n){for(const i of m.folders)if(await m.exists(u.$Ug(N.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function k(m,a,n,i){if(n.length===0)return Promise.resolve(void 0);const s=new M.$ee,o=m.checkExists(m.folders,n,s.token),t=setTimeout(async()=>{s.cancel(),m.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let d=!1;try{d=await o}catch(h){P.$4(h)||P.$1(h)}s.dispose(),clearTimeout(t),d&&i(`workspaceContains:${n.join(",")}`)}function c(m,a,n,i){const s=m.get(A.$gi),o=m.get($.$uK),d=s.createInstance(b.$WL).file(a.map(h=>(0,E.$Ci)(N.URI.revive(h))),{_reason:"checkExists",includePattern:n,exists:!0});return o.fileSearch(d,i).then(h=>!!h.limitHit,h=>P.$4(h)?!1:Promise.reject(h))}}),define(ke[48],Ee([1,0,219,17,58,23,8,3,76,2,12,6,42,301,118,41,26,148,13,25,21,280,7,64,5,27,93,20,107,69,47,121,4,371,117,282,15,115,38,11,116]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d,h,l,r,g,f,D,p,v,y,C,O,z,T,B,j,F,L){"use strict";var G;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=e.$Djc=e.$Cjc=e.$Bjc=void 0,e.$Bjc=(0,h.$hi)("IHostUtils");let te=G=class extends b.$Uc{constructor(U,ie,ve,Ie,le,ae,ce,H,Q,he,fe,Pe,be){super(),this.X=Pe,this.Y=be,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ie,this.g=ve,this.f=ce,this.j=Ie,this.m=le,this.s=ae,this.t=Q,this.u=he,this.w=fe,this.y=this.g.getProxy(I.$gM.MainThreadWorkspace),this.z=this.g.getProxy(I.$gM.MainThreadTelemetry),this.C=this.g.getProxy(I.$gM.MainThreadExtensionService),this.D=new A.$gh,this.F=new A.$gh,this.G=new A.$gh,this.H=new A.$gh,this.I=new se(this.f.extensions.activationEvents),this.L=new a.$x0b(this.I,this.f.extensions.allExtensions);const Ae=new i.$Dm(this.f.extensions.myExtensions);this.J=new a.$x0b(this.I,X(this.L,Ae)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new k.$mjc(this.g,this.s),this.N=new O.$ujc(this.g),this.O=H,this.h=U.createChild(new f.$fi([k.$njc,this.M],[O.$vjc,this.N])),this.P=this.B(new S.$ljc(this.J,this.L,{onExtensionActivationError:(Ne,Be,V)=>{this.C.$onExtensionActivationError(Ne,n.$3(Be),V)},actualActivateExtension:async(Ne,Be)=>{if(a.$x0b.isHostExtension(Ne,this.J,this.L))return await this.C.$activateExtension(Ne,Be),new S.$kjc;const V=this.J.getExtensionDescription(Ne);return this.eb(V,Be)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(U){n.$1(U)}}async Z(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.db(le))}catch{}await Promise.all(U)}terminate(U,ie=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ve=this.Z();Promise.race([(0,A.$ih)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ie=await this.C.$getExtension(U);return ie&&{...ie,identifier:new i.$Cm(ie.identifier.value),extensionLocation:E.URI.revive(ie.extensionLocation)}}$(U,ie){return this.P.activateByEvent(U,ie)}ab(U,ie){return this.P.activateById(U,ie)}activateByIdWithErrors(U,ie){return this.ab(U,ie).then(()=>{const ve=this.P.getActivatedExtension(U);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async bb(U){if(U.scheme===T.Schemas.file&&this.c.fsRealpath){const ie=await this.c.fsRealpath(U.fsPath);return E.URI.file(ie)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(U=>new $e(U))),this.Q}async cb(U){const ie=$.$ni.forUris(ve=>P.$Lg.ignorePathCasing(ve));return await Promise.all(U.map(async ve=>{if(this.vb(ve)){const Ie=await this.bb(ve.extensionLocation);ie.set(Ie,ve)}})),ie}db(U){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ie;const ve=this.P.getActivatedExtension(U);if(!ve)return ie;try{typeof ve.module.deactivate=="function"&&(ie=Promise.resolve(ve.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Ie)}try{(0,b.$Pc)(ve.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Ie)}return ie}async eb(U,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.gb(U,ie).then(ve=>{const Ie=ve.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,ie),this.fb(U,ie,"success",Ie),ve},ve=>{throw this.fb(U,ie,"failure"),ve})}fb(U,ie,ve,Ie){const le=x(U,ie);this.z.$publicLog2("extensionActivationTimes",{...le,...Ie||{},outcome:ve})}gb(U,ie){const ve=x(U,ie);this.z.$publicLog2("activatePlugin",ve);const Ie=this.vb(U);if(!Ie)return Promise.resolve(new S.$jjc(S.$gjc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${U.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const le=new S.$hjc(ie.startup);return Promise.all([this.wb(U,(0,P.$Ug)(U.extensionLocation,Ie),le),this.hb(U)]).then(ae=>(M.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),G.ib(this.s,U.identifier,ae[0],ae[1],le))).then(ae=>(M.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ae))}hb(U){const ie=this.Y.createLanguageModelAccessInformation(U),ve=new o.$pjc(U,this.M),Ie=new o.$ojc(U.identifier.value,!1,this.M),le=new z.$wjc(U,this.N),ae=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ce=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([ve.whenReady,Ie.whenReady,this.O.whenReady]).then(()=>{const H=this;let Q,he;const fe=(0,m.$5F)(U,"ipc")?this.f.messagePorts?.get(i.$Cm.toKey(U.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Ie,secrets:le,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Pe){return N.$kc(U.extensionLocation.fsPath,Pe)},get storagePath(){return H.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return H.O.globalValue(U).fsPath},get logPath(){return N.$kc(H.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(H.f.logsLocation,U.identifier.value)},get storageUri(){return H.O.workspaceValue(U)},get globalStorageUri(){return H.O.globalValue(U)},get extensionMode(){return ae},get extension(){return Q===void 0&&(Q=new ue(H,U.identifier,U,ce,!1)),Q},get extensionRuntime(){return(0,m.$6F)(U,"extensionRuntime"),H.extensionRuntime},get environmentVariableCollection(){return H.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!he){if(!fe)return;const Pe=y.Event.buffer(y.Event.fromDOMEventEmitter(fe,"message",be=>be.data));fe.start(),he={onDidReceiveMessage:Pe,postMessage:fe.postMessage.bind(fe)}}return he}})})}static ib(U,ie,ve,Ie,le){return ve=ve||{activate:void 0,deactivate:void 0},this.jb(U,ie,ve,Ie,le).then(ae=>new S.$ijc(!1,null,le.build(),ve,ae,Ie.subscriptions))}static jb(U,ie,ve,Ie,le){if(typeof ve.activate=="function")try{le.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ae=typeof global=="object"?global:self,ce=ve.activate.apply(ae,[Ie]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ce).then(H=>(le.activateResolveStop(),H))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(ve)}kb(U,ie){this.ab(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ie}).then(void 0,ve=>{this.s.error(ve)})}lb(U,ie=0){const Ie=Date.now();(0,F.$B)(()=>{for(let le=ie;le<U.length;le+=1){const ae=U[le];for(const ce of ae.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-Ie>50){this.lb(U,le);break}else this.kb(ae,ce)}})}mb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(U=>{const ie=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(ie)this.lb(ve);else for(const Ie of ve)if(Ie.activationEvents)for(const le of Ie.activationEvents)le==="onStartupFinished"&&this.kb(Ie,le)})}nb(){const U=this.$("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.ob(ae.added)));const ie=this.j.workspace?this.j.workspace.folders:[],ve=this.ob(ie),Ie=this.qb(),le=Promise.all([Ie,U,ve]).then(()=>{});return Promise.race([le,(0,A.$ih)(1e4)]).then(()=>{this.mb()}),le}ob(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.pb(U,ie))).then(()=>{})}async pb(U,ie){if(this.isActivated(ie.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:U.map(ae=>ae.uri),forceUsingSearch:ve||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,ce,H)=>this.y.$checkExists(ae,ce,H)},le=await(0,C.$Rub)(Ie,ie);if(le)return this.ab(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:le.activationEvent}).then(void 0,ae=>this.s.error(ae))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(U){throw console.error(U),U}}async rb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ie}=this.f.environment;if(!U||!ie)throw new Error(u.localize(0,null));const ve=await this.wb(null,ie,new S.$hjc(!1));if(!ve||typeof ve.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((Ie,le)=>{const ae=(Q,he)=>{Q?(F.$t&&this.s.error("Test runner called back with error",Q),le(Q)):(F.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof he=="number"&&he>0?1:0))},ce=(0,P.$Ig)(ie),H=ve.run(ce,ae);H&&H.then&&H.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{F.$t&&this.s.error("Test runner finished with error",Q),le(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$ih)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ie){return this.R[U]=ie,(0,b.$Sc)(()=>{delete this.R[U]})}async getRemoteExecServer(U){const{resolver:ie}=await this.tb(U);return ie?.resolveExecServer?.(U,{resolveAttempt:0})}async tb(U){const ie=U.indexOf("+");if(ie===-1)throw new t.$oM("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=U.substr(0,ie);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.R[ve]}}async $resolveAuthority(U,ie){const ve=j.$3d.create(!1),Ie=()=>`[resolveAuthority(${(0,d.$wl)(U)},${ie})][${ve.elapsed()}ms] `,le=q=>this.s.info(`${Ie()}${q}`),ae=q=>this.s.warn(`${Ie()}${q}`),ce=(q,Y=void 0)=>this.s.error(`${Ie()}${q}`,Y),H=q=>{if(q instanceof t.$oM)return{type:"error",error:{code:q._code,message:q._message,detail:q._detail}};throw q},Q=async q=>{le(`activating resolver for ${q}...`);const{resolver:Y,authorityPrefix:J}=await this.tb(q);if(!Y)throw ce(`no resolver for ${J}`),new t.$oM(`No remote extension installed to resolve ${J}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:J,remoteAuthority:q}},he=U.split(/@|%40/g).reverse();le(`activating remote resolvers ${he.join(" -> ")}`);let fe;try{fe=await Promise.all(he.map(Q)).catch(async q=>{if(!(q instanceof t.$oM)||q._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw q;return ae(`resolving nested authorities failed: ${q.message}`),[await Q(U)]})}catch(q){return H(q)}const Pe=new A.$sh;Pe.cancelAndSet(()=>le("waiting..."),1e3);let be,Ae;for(const[q,{authorityPrefix:Y,resolver:J,remoteAuthority:ge}]of fe.entries())try{if(q===fe.length-1)le("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${Y}`),be=await J.resolve(ge,{resolveAttempt:ie,execServer:Ae}),M.mark(`code/extHost/didResolveAuthorityOK/${Y}`),le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$nM.isManagedResolvedAuthority(be)?be:void 0));else{if(le(`invoking resolveExecServer() for ${ge}`),M.mark(`code/extHost/willResolveExecServer/${Y}`),Ae=await J.resolveExecServer?.(ge,{resolveAttempt:ie,execServer:Ae}),!Ae)throw new t.$oM(`Exec server was not available for ${ge}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(we){return M.mark(`code/extHost/didResolveAuthorityError/${Y}`),ce("returned an error",we),Pe.dispose(),H(we)}Pe.dispose();const Ne={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures?{elevation:be.tunnelFeatures.elevation,privacyOptions:be.tunnelFeatures.privacyOptions,protocol:be.tunnelFeatures.protocol===void 0?!0:be.tunnelFeatures.protocol}:void 0},Be={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${t.$nM.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let V;if(t.$nM.isManagedResolvedAuthority(be)){const q=ie;this.X.setFactory(q,be.makeConnection),V={authority:U,connectTo:new d.$tl(q),connectionToken:be.connectionToken}}else V={authority:U,connectTo:new d.$ul(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:V,options:Be,tunnelInformation:Ne}}}async $getCanonicalURI(U,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$wl)(U)})`);const{resolver:ve}=await this.tb(U);if(!ve)return null;const Ie=E.URI.revive(ie);if(typeof ve.getCanonicalURI>"u")return Ie;const le=await(0,A.$_g)(()=>ve.getCanonicalURI(Ie));return le||Ie}$startExtensionHost(U){U.toAdd.forEach(Ie=>Ie.extensionLocation=E.URI.revive(Ie.extensionLocation));const{globalRegistry:ie,myExtensions:ve}=Z(this.I,this.L,this.J,U);return this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ve),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.sb()}$activateByEvent(U,ie){return ie===1?this.D.wait().then(ve=>this.$(U,!1)):this.G.wait().then(ve=>this.$(U,!1))}async $activate(U,ie){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.ab(U,ie),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ae=>ae.extensionLocation=E.URI.revive(ae.extensionLocation));const{globalRegistry:ie,myExtensions:ve}=Z(this.I,this.L,this.J,U),Ie=await this.cb(ve);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ve),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ie=s.$ue.alloc(U),ve=Math.random()%256;for(let Ie=0;Ie<U;Ie++)ie.writeUInt8(ve,Ie);return ie}async $updateRemoteConnectionData(U){this.W=U,this.a.fire()}};e.$Cjc=te,e.$Cjc=te=G=Je([Ve(0,h.$gi),Ve(1,e.$Bjc),Ve(2,g.$AO),Ve(3,c.$2ic),Ve(4,w.$5ic),Ve(5,R.$Nj),Ve(6,l.$QO),Ve(7,r.$8ic),Ve(8,D.$9Ab),Ve(9,p.$qjc),Ve(10,B.$yjc),Ve(11,L.$zjc),Ve(12,v.$Ric)],te);function Z(re,U,ie,ve){re.addActivationEvents(ve.addActivationEvents);const Ie=new a.$x0b(re,U.getAllExtensionDescriptions());Ie.deltaExtensions(ve.toAdd,ve.toRemove);const le=new i.$Dm(ie.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ve.myToRemove)le.delete(ce);for(const ce of ve.myToAdd)le.add(ce);const ae=X(Ie,le);return{globalRegistry:Ie,myExtensions:ae}}function x(re,U){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function _(re){return re.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$Djc=(0,h.$hi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(U,ie,ve,Ie,le){this.#e=U,this.#t=ie,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=N.$ic((0,P.$Ig)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Ie,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ejc=ue;function X(re,U){return re.getAllExtensionDescriptions().filter(ie=>U.has(ie.identifier))}class $e{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$Fjc=$e;class se{constructor(U){this.a=new i.$Em,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ie of Object.keys(U))this.a.set(ie,U[ie])}}}),define(ke[372],Ee([1,0,58,2,6,42,26,25,20,27,5,48,12,14]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;let c=class{constructor(s,o,t,d,h,l,r){this.c=s,this.d=o,this.e=t,this.f=d,this.g=h,this.h=l,this.i=r,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,s,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,o,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const o of s.nodeModuleName)this.a.set(o,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(o=>s.alternativeModuleName(o))}};e.$Nkc=c,e.$Nkc=c=Je([Ve(2,R.$gi),Ve(3,P.$5ic),Ve(4,I.$Djc),Ve(5,E.$QO),Ve(6,w.$Nj)],c);let m=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&k.a.size){const o=(0,S.$Ze)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${h}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const o=this.b.exec(this.c(s));if(!o)return;const[,t,d,h]=o,l=k.a.get(d);if(l!==void 0)return console.warn(`${d} as been renamed to ${l}, please update your imports`),t+l+h}c(s){return s.replace(/\\/g,"/")}};m=k=Je([Ve(0,E.$QO)],m);class a{constructor(s,o,t,d,h){this.c=s,this.d=o,this.e=t,this.f=d,this.g=h,this.nodeModuleName="vscode",this.a=new b.$Em}load(s,o){const t=this.d.findSubstr(o);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((h,l)=>d+=`	${l} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${d}`),this.b=this.c(A.$ZF,this.e,this.f)}return this.b}}let n=class{constructor(s,o,t){this.e=s,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$gM.MainThreadTelemetry);const d=t.getProxy(M.$gM.MainThreadWindow);this.c=(h,l)=>{const r=N.URI.parse(h);return l?this.g(h,l):r.scheme==="http"||r.scheme==="https"?d.$openUri(r,h,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this.f?d.$openUri(r,h,{}):this.g(h,l)}}load(s,o,t){const d=this.e.findSubstr(o);return d&&(this.a=d.identifier.value,this.h()),this.b=t(s),this.c}g(s,o){return this.i(),this.b(s,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([Ve(2,$.$AO)],n)}),define(ke[60],Ee([1,0,44,3,17,50,5,71,70,48,7,41,298,42]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=e.$Gjc=void 0,e.$Gjc=(0,A.$hi)("IExtHostVariableResolverProvider");class k extends w.$CP{constructor(a,n,i,s,o,t,d){function h(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const r=s.tabGroups.all.find(g=>g.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.$5N||r.input instanceof R.$0N)return r.input.modified;if(r.input instanceof R.$4N||r.input instanceof R.$9N||r.input instanceof R.$7N)return r.input.uri}}}super({getFolderUri:l=>{const r=t.folders.filter(g=>g.name===l);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,r)=>o.getConfiguration(void 0,l).get(r),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=h();if(l)return M.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=h();if(l){const r=n.getWorkspaceFolder(l);if(r)return M.$ic(r.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(P.env))}}let c=class extends N.$Uc{constructor(a,n,i,s,o){super(),this.b=a,this.c=n,this.g=i,this.h=s,this.j=o,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$Hjc=c,e.$Hjc=c=Je([Ve(0,E.$Djc),Ve(1,I.$2ic),Ve(2,b.$LO),Ve(3,S.$5ic),Ve(4,$.$ejc)],c)}),define(ke[96],Ee([1,0,8,4,2,25,5,6,70,48,20,7,41,143,290,42,60,3,56,33,16]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=e.$Ljc=e.$Kjc=e.$Jjc=e.$Ijc=void 0,e.$Ijc=(0,A.$hi)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,D,p,v,y,C,O){this.N=D,this.O=p,this.P=v,this.Q=y,this.R=C,this.S=O,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$7d,this.o=new N.$7d,this.q=new N.$7d,this.w=new N.$7d,this.l=f.getProxy(b.$gM.MainThreadDebugService),this.A=new N.$7d,this.C=new N.$7d,this.y=new d(this.l),this.z=new Map,this.O.getExtensionRegistry().then(z=>{z.onDidChange(T=>{this.V(z)}),this.V(z)})}async $getVisualizerTreeItem(f,D){const p=this.W(D);if(!p)return;const v=await this.H.get(f)?.getTreeItem?.(p);return v?this.U(f,v):void 0}registerDebugVisualizationTree(f,D,p){const v=P.$Cm.toKey(f.identifier),y=this.jb(v,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,p),this.l.$registerDebugVisualizerTree(y,!!p.editItem),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(f,D){const p=this.J.get(D)?.item;return p?(await this.H.get(f)?.getChildren?.(p))?.map(y=>this.U(f,y))||[]:[]}async $editVisualizerTreeItem(f,D){const p=this.J.get(f);if(!p)return;const v=await this.H.get(p.provider)?.editItem?.(p.item,D);return this.U(p.provider,v||p.item)}$disposeVisualizedTree(f){const D=this.J.get(f);if(!D)return;const p=[D.children];for(const v of p)if(v)for(const y of v)p.push(this.J.get(y)?.children),this.J.delete(y)}U(f,D){let p=this.I.get(D);return p||(p=this.F++,this.I.set(D,p),this.J.set(p,{provider:f,item:D})),s.DebugTreeItem.from(D,p)}asDebugSourceUri(f,D){const p=f;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let v=`debug:${encodeURIComponent(p.path||"")}`,y="?";return D&&(v+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),v+=`${y}ref=${p.sourceReference}`,M.URI.parse(v)}else{if(p.path)return M.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const D=[];for(const p of f.getAllExtensionDescriptions())if(p.contributes){const v=p.contributes.debuggers;if(v&&v.length>0)for(const y of v)(0,k.$EG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(D=>f.push(D)),f}async $resolveDebugVisualizer(f,D){const p=this.L.get(f);if(!p)throw new Error(`No debug visualizer found with id '${f}'`);let{v,provider:y,extensionId:C}=p;if(v.visualization||(v=await y.resolveDebugVisualization?.(v,D)||v,p.v=v),!v.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,v.visualization)}async $executeDebugVisualizerCommand(f){const D=this.L.get(f);if(!D)throw new Error(`No debug visualizer found with id '${f}'`);const p=D.v.visualization;p&&"command"in p&&this.S.executeCommand(p.command,...p.arguments||[])}W(f){const D=this.m.get(f.sessionId);return D&&{session:D.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,D,p,v){const y=this.W(p),C=this.jb(f,D),O=this.G.get(C);if(!y||!O)return[];const z=await O.provideDebugVisualization(y,v);return z?z.map(T=>{const B=++this.M;this.L.set(B,{v:T,provider:O,extensionId:f});const j=T.iconPath?this.lb(T.iconPath):void 0;return{id:B,name:T.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(f,T.visualization)}}):[]}$disposeDebugVisualizers(f){for(const D of f)this.L.delete(D)}registerDebugVisualizationProvider(f,D,p){if(!f.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const v=P.$Cm.toKey(f.identifier),y=this.jb(v,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,p),this.l.$registerDebugVisualizer(v,D),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizer(v,D),this.G.delete(D)})}addBreakpoints(f){const D=f.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const p=[],v=new Map;for(const y of D)if(y instanceof I.$jN){let C=v.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},v.set(y.location.uri.toString(),C),p.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof I.$kN&&p.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(p)}removeBreakpoints(f){const D=f.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const p=D.filter(C=>C instanceof I.$jN).map(C=>C.id),v=D.filter(C=>C instanceof I.$kN).map(C=>C.id),y=D.filter(C=>C instanceof I.$lN).map(C=>C.id);return this.l.$unregisterBreakpoints(p,v,y)}startDebugging(f,D,p){return this.l.$startDebugging(f?f.uri:void 0,D,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,D,p){if(!D)return new I.$iM(()=>{});const v=this.d++;return this.f.push({type:f,handle:v,provider:D}),this.l.$registerDebugConfigurationProvider(f,p,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,v),new I.$iM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(f,D,p){if(!p)return new I.$iM(()=>{});if(!this.cb(f,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:D,handle:v,factory:p}),this.l.$registerDebugAdapterDescriptorFactory(D,v),new I.$iM(()=>{this.h=this.h.filter(y=>y.factory!==p),this.l.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(f,D){if(!D)return new I.$iM(()=>{});const p=this.j++;return this.k.push({type:f,handle:p,factory:D}),new I.$iM(()=>{this.k=this.k.filter(v=>v.factory!==D)})}async $runInTerminal(f,D){return Promise.resolve(void 0)}async $substituteVariables(f,D){let p;const v=await this.ib(f);return v&&(p={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(p,D)}X(f,D){if(f.type==="implementation")return new l(f.implementation)}Y(){}async $startDASession(f,D){const p=this,v=await this.hb(D);return this.eb(this.$(v.type),v).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const C=this.Z(y),O=this.X(C,v);if(!O)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const z=O;return this.D.set(f,z),this.db(v).then(T=>(T&&this.E.set(f,T),z.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const j=B,F={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const L=await this.K.sign(j.arguments.value);F.body={signature:L},z.sendResponse(F)}else throw new Error("no signer")}catch(L){F.success=!1,F.message=L.message,z.sendResponse(F)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(B),B=(0,k.$JG)(B,!0),p.l.$acceptDAMessage(f,B)}),z.onError(B=>{T&&T.onError&&T.onError(B),this.l.$acceptDAError(f,B.name,B.message,B.stack)}),z.onExit(B=>{T&&T.onExit&&T.onExit(B??void 0,void 0),this.l.$acceptDAExit(f,B??void 0,void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),z.startSession()))})}$sendDAMessage(f,D){D=(0,k.$IG)(D,!1);const p=this.E.get(f);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(D),this.D.get(f)?.sendMessage(D)}$stopDASession(f){const D=this.E.get(f);this.E.delete(f),D&&D.onWillStopSession&&D.onWillStopSession();const p=this.D.get(f);return this.D.delete(f),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const D=[],p=[],v=[];if(f.added)for(const y of f.added){const C=y.id;if(C&&!this.z.has(C)){let O;if(y.type==="function")O=new I.$kN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")O=new I.$lN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const z=M.URI.revive(y.uri);O=new I.$jN(new I.$uM(z,new I.$jM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,I.$hN)(O,C),this.z.set(C,O),D.push(O)}}if(f.removed)for(const y of f.removed){const C=this.z.get(y);C&&(this.z.delete(y),p.push(C))}if(f.changed){for(const y of f.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof I.$kN&&y.type==="function"){const O=C;O.enabled=y.enabled,O.condition=y.condition,O.hitCondition=y.hitCondition,O.logMessage=y.logMessage,O.functionName=y.functionName}else if(C instanceof I.$jN&&y.type==="source"){const O=C;O.enabled=y.enabled,O.condition=y.condition,O.hitCondition=y.hitCondition,O.logMessage=y.logMessage,O.location=new I.$uM(M.URI.revive(y.uri),new I.$jM(y.line,y.character))}v.push(C)}}}this.gb(D,p,v)}async $acceptStackFrameFocus(f){let D;if(f){const p=await this.hb(f.sessionId);f.kind==="thread"?D=new I.$rN(p.api,f.threadId):D=new I.$qN(p.api,f.threadId,f.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(f,D,p){return(0,u.$_g)(async()=>{const v=this.bb(f);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return v.provideDebugConfigurations(y,p)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(f,D,p,v){return(0,u.$_g)(async()=>{const y=this.bb(f);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,p,v)})}$resolveDebugConfigurationWithSubstitutedVariables(f,D,p,v){return(0,u.$_g)(async()=>{const y=this.bb(f);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,p,v)})}async $provideDebugAdapter(f,D){const p=this.ab(f);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.hb(D);return this.eb(p,v).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(f){const D=await this.hb(f);this.n.fire(D.api)}async $acceptDebugSessionTerminated(f){const D=await this.hb(f);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,D){(await this.hb(f))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(f,D){const v={session:(await this.hb(f)).api,event:D.event,body:D.body};this.w.fire(v)}Z(f){if(f instanceof I.$mN)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof I.$nN)return{type:"server",port:f.port,host:f.host};if(f instanceof I.$oN)return{type:"pipeServer",path:f.path};if(f instanceof I.$pN)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const D=this.h.filter(p=>p.type===f);if(D.length>0)return D[0].factory}ab(f){const D=this.h.filter(p=>p.handle===f);if(D.length>0)return D[0].factory}bb(f){const D=this.f.filter(p=>p.handle===f);if(D.length>0)return D[0].provider}cb(f,D){if(f.contributes){const p=f.contributes.debuggers;if(p&&p.length>0){for(const v of p)if(v.label&&v.type&&v.type===D)return!0}}return!1}db(f){const p=f.configuration.type,v=this.k.filter(y=>y.type===p||y.type==="*").map(y=>(0,u.$_g)(()=>y.factory.createDebugAdapterTracker(f.api)).then(C=>C,C=>null));return Promise.race([Promise.all(v).then(y=>{const C=y.filter(O=>!!O);if(C.length>0)return new h(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(f,D){const p=D.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new I.$nN(p));if(f){const y=await this.O.getExtensionRegistry();return(0,u.$_g)(()=>f.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const v=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,v))}fb(f,D){}gb(f,D,p){(f.length>0||D.length>0||p.length>0)&&this.A.fire(Object.freeze({added:f,removed:D,changed:p}))}async hb(f){if(f)if(typeof f=="string"){const D=this.m.get(f);if(D)return D}else{let D=this.m.get(f.id);if(!D){const p=await this.ib(f.folderUri),v=f.parent?this.m.get(f.parent):void 0;D=new t(this.l,f.id,f.type,f.name,p,f.configuration,v?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(f){if(f){const D=M.URI.revive(f);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(f,D){return`${f}\0${D}`}kb(f,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${f}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const D=this.mb(f);let p,v;return"id"in D?v=n.ThemeIcon.asClassName(D):p=D,{iconPath:p,iconClass:v}}mb(f){if(f instanceof I.$eN)return{id:f.id};const D=typeof f=="object"&&"dark"in f?f.dark:f,p=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof D=="string"?M.URI.file(D):D,light:typeof p=="string"?M.URI.file(p):p}}};e.$Jjc=o,e.$Jjc=o=Je([Ve(0,R.$AO),Ve(1,w.$2ic),Ve(2,E.$Djc),Ve(3,c.$5ic),Ve(4,$.$ejc),Ve(5,m.$Gjc),Ve(6,i.$WO)],o);class t{constructor(f,D,p,v,y,C,O){this.f=f,this.g=D,this.h=p,this.j=v,this.k=y,this.l=C,this.m=O}get api(){const f=this;return this.d??=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(D){f.j=D,f.f.$setDebugSessionName(f.g,D)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(D,p){return f.f.$customDebugAdapterRequest(f.g,D,p)},getDebugProtocolBreakpoint(D){return f.f.$getDebugProtocolBreakpoint(f.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$Kjc=t;class d{constructor(f){this.value=Object.freeze({append(D){f.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$Ljc=d;class h{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(D=>D.onError?D.onError(f):void 0)}onExit(f,D){this.d.forEach(p=>p.onExit?p.onExit(f,D):void 0)}}class l extends S.$$nb{constructor(f){super(),this.h=f,f.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends o{constructor(f,D,p,v,y,C,O){super(f,D,p,v,y,C,O)}};e.$Mjc=r,e.$Mjc=r=Je([Ve(0,R.$AO),Ve(1,w.$2ic),Ve(2,E.$Djc),Ve(3,c.$5ic),Ve(4,$.$ejc),Ve(5,m.$Gjc),Ve(6,i.$WO)],r)}),define(ke[373],Ee([1,0,13,58,2,6,319,12,83,107,27,256,20,65,48,90]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const s=i.get(b.$Nj),t=i.get(w.$AO).getProxy(P.$gM.MainThreadErrors);u.setUnexpectedErrorHandler(d=>{s.error(d);const h=u.$3(d);t.$onUnexpectedError(h)})}static async installFullHandler(i){const s=i.get(b.$Nj),o=i.get(w.$AO),t=i.get(k.$Djc),d=i.get(c.$UO),h=o.getProxy(P.$gM.MainThreadExtensionService),l=o.getProxy(P.$gM.MainThreadErrors),r=await t.getExtensionPathIndex(),g=new WeakMap;function f(v,y){if(g.has(v))return g.get(v).stack;let C="",O,z;for(const B of y)C+=`
	at ${B.toString()}`,z=B.getFileName(),!O&&z&&(O=r.findSubstr(M.URI.file(z)));const T=`${v.name||"Error"}: ${v.message||""}${C}`;return g.set(v,{extensionIdentifier:O?.identifier,stack:T}),T}const D=Symbol("prepareStackTrace wrapped");let p=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(v){if(v===f||!v||v[D]){p=v||f;return}p=function(y,C){return f(y,C),v.call(Error,y,C)},Object.assign(p,{[D]:!0})}}),u.setUnexpectedErrorHandler(v=>{s.error(v);const y=u.$3(v),C=g.get(v);if(!C?.extensionIdentifier){l.$onUnexpectedError(y);return}h.$onExtensionRuntimeError(C.extensionIdentifier,y);const O=d.onExtensionError(C.extensionIdentifier,v);s.trace("forwarded error to extension?",O,C)})}}e.$Okc=m;class a{constructor(i,s,o,t,d){this.a=o,this.b=new A.$F0b(i,null,t),s=a.e(s,this.b);const h=new E.$fi(...(0,$.$fs)());h.set(R.$QO,{_serviceBrand:void 0,...s,messagePorts:d}),h.set(w.$AO,new w.$BO(this.b)),h.set(S.$Yic,new S.$Zic(t)),h.set(k.$Bjc,o);const l=new I.$Wq(h,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(r=>r.get(b.$Nj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(r=>r.get(k.$Djc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const s=this.b.getProxy(P.$gM.MainThreadExtensionService);return M.URI.revive(await s.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,s){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(s.transformIncomingURIs(i.environment.appRoot));const o=i.environment.extensionDevelopmentLocationURI;return o&&(i.environment.extensionDevelopmentLocationURI=o.map(t=>M.URI.revive(s.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(s.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(s.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(s.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(s.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(s.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(s.transformIncomingURIs(i.logsLocation)),i.workspace=s.transformIncomingURIs(i.workspace),i}}e.$Pkc=a}),define(ke[374],Ee([1,0,8,11,230,250,141,96,70,48,20,47,7,60,41,291,292,42,33,375]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=void 0;let s=class extends b.$Jjc{constructor(r,g,f,D,p,v,y,C){super(r,g,f,D,v,y,C),this.pb=p,this.nb=new h}X(r,g){switch(r.type){case"server":return new c.$Ukc(r);case"pipeServer":return new c.$Vkc(r);case"executable":return new c.$Wkc(r,g.type)}return super.X(r,g)}fb(r,g){const f=c.$Wkc.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(f)return new w.$mN(f.command,f.args,f.options)}Y(){return new A.$rbc}async $runInTerminal(r,g){if(r.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(F=>{this.nb.onTerminalClosed(F)}));const f=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),p=this.pb.getDefaultShellArgs(!0),v=r.title||M.localize(0,null),y=o(D,p,r);let C=await this.nb.checkout(y,v,!0),O,z=!1;if(C)O=r.cwd;else{const F={shellPath:D,shellArgs:p,cwd:r.cwd,name:v,iconPath:new w.$eN("debug"),env:r.env};z=!0,C=this.pb.createTerminalFromOptions(F,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,y)}C.show(!0);const T=await C.processId;z?await new Promise(F=>setTimeout(F,1e3)):(C.state.isInteractedWith&&C.sendText(""),f.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?C.sendText("cls"):D.indexOf("bash")>=0?C.sendText("clear"):N.$i?C.sendText("cls"):C.sendText("clear")));const B=(0,m.$Ykc)(D,r.args,!!r.argsCanBeInterpretedByShell,O);C.sendText(B);const j=this.onDidTerminateDebugSession(F=>{F.id===g&&(this.nb.free(C),j.dispose())});return T}else if(r.kind==="external")return d(r,await this.P.getConfigProvider());return super.$runInTerminal(r,g)}};e.$Zkc=s,e.$Zkc=s=Je([Ve(0,R.$AO),Ve(1,k.$2ic),Ve(2,E.$Djc),Ve(3,a.$5ic),Ve(4,I.$qjc),Ve(5,$.$ejc),Ve(6,S.$Gjc),Ve(7,n.$WO)],s);function o(l,r,g){const f=(0,i.createHash)("sha256");return f.update(JSON.stringify({shell:l,shellArgs:r})),f.update(JSON.stringify(Object.entries(g.env||{}).sort(([D],[p])=>D.localeCompare(p)))),f.digest("base64")}let t;function d(l,r){if(!t)if(N.$i)t=new P.$cac;else if(N.$j)t=new P.$dac;else if(N.$k)t=new P.$eac;else throw new Error("external terminals not supported on this platform");const g=r.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},g.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,g,f=!1){const p=[...this.b.entries()].map(([v,y])=>(0,u.$7g)(async C=>{if(v.name!==g||y.lastUsedAt!==-1&&await(0,m.$Xkc)(await v.processId))return null;const O=Date.now();return y.lastUsedAt+h.a>O||C.isCancellationRequested?null:y.config!==r?(f&&v.dispose(),null):(y.lastUsedAt=O,v)}));return await(0,u.$mh)(p,v=>!!v)}insert(r,g){this.b.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this.b.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[376],Ee([1,0,17,2,105,41,71,42,40,47,20,27,95,15,12,91,23,63,60]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;let i=class extends w.$tkc{constructor(o,t,d,h,l,r,g,f,D){super(o,t,d,h,l,r,g,f),this.C=d,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const d=t;if(!t.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const h=w.TaskHandleDTO.from(d,this.C),l=await this.a.$getTaskExecution(h);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.z(l,t);return this.a.$executeTask(h).catch(()=>{}),r}else{const h=w.TaskDTO.from(t,o);if(h===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(h.execution)&&await this.y(h,t,!1);const l=await this.z(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),l}}v(o,t,d,h){const l=[];if(h)for(const r of h){this.A(r,d),(!r.definition||!o[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const g=w.TaskDTO.from(r,d.extension);g&&(l.push(g),w.CustomExecutionDTO.is(g.execution)&&t.push(this.y(g,r,!0)))}return{tasks:l,extension:d.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const d=N.URI.file((0,a.homedir)());t=new $.$Bi({uri:d,name:m.$Rg(d),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const d=N.URI.revive(o),h={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(d),r=await this.b.getWorkspaceFolders2()??[],g=await this.D.getResolver(),f=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(r);for(const D of t.variables)h.variables[D]=await g.resolveAsync(f,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let p=0;p<D.length;p++)D[p]=await g.resolveAsync(f,D[p])}h.process=await M.win32.findExecutable(await g.resolveAsync(f,t.process.name),t.process.cwd!==void 0?await g.resolveAsync(f,t.process.cwd):void 0,D)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,d){return M.win32.findExecutable(o,t,d)}};e.$Rkc=i,e.$Rkc=i=Je([Ve(0,R.$AO),Ve(1,I.$QO),Ve(2,P.$2ic),Ve(3,A.$LO),Ve(4,b.$5ic),Ve(5,E.$qjc),Ve(6,k.$Nj),Ve(7,c.$Cic),Ve(8,n.$Gjc)],i)}),define(ke[377],Ee([1,0,63,60]),function(de,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;class M extends N.$Hjc{m(){return(0,u.homedir)()}}e.$xlc=M}),define(ke[158],Ee([1,0,19,8,22,45,15,17,23,2,36]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$2jc=e.$1jc=void 0,e.$3jc=c;class I{constructor(n,i,s){this.d=n,this.e=i,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const s=this.g.folderQueries||[],o=new M.$ee(i);return new Promise((t,d)=>{this.a=new S(n);let h=!1;const l=(r,g)=>{if(!h&&!this.b){const f=this.h(r);c(r)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,h=!0,o.cancel(),r=this.j(r,this.g.maxResults-this.c));const D=this.h(r);this.c+=D,(D>0||!c(r))&&this.a.add(r,g)}};Promise.all(s.map((r,g)=>this.k(r,f=>l(f,g),o.token))).then(r=>{o.dispose(),this.a.flush();const g=r.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||g,messages:(0,u.$Rb)(r.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},r=>{o.dispose();const g=(0,P.$5i)(r);d(new Error(g))})})}h(n){return c(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const s=Array.isArray(n.ranges)?n.ranges:[n.ranges],o=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:s.slice(0,i),preview:{matches:o.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,s){const o=new R.$NK(this.g,n),t=[],d={report:r=>{if(!this.l(r))return;const g=n.folder.scheme===A.Schemas.file?(0,R.$OK)(()=>this.e.readdir($.$Tg(r.uri))):void 0,f=$.$Wg(n.folder,r.uri);if(f){const D=o.includedInQuery(f,b.$oc(f),g);(0,N.$6g)(D)?t.push(D.then(p=>{p&&i(r)})):D&&i(r)}}},h=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,h,d,s):l=await this.d.provider.provideTextSearchResults(w(this.d.query.contentPattern),h,d,s),t.length&&await Promise.all(t),l}l(n){if(c(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,R.$MK)(this.g.includePattern,n.includePattern),s=(0,R.$MK)(this.g.excludePattern,n.excludePattern),o={folder:E.URI.from(n.folder),excludes:s,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(o.usePCRE2=this.g.usePCRE2),o}}e.$1jc=I;function w(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class S{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Ng(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(k(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$2jc=S;function k(a){return c(a)?{preview:{matches:(0,u.$2b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,u.$2b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function c(a){return!!a.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$4jc=m}),define(ke[97],Ee([1,0,3,6,5,369,20,65,12,2,158]),function(de,e,u,N,M,P,A,b,$,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=void 0,e.$7jc=w,e.$5jc=(0,M.$hi)("IExtHostSearch");let I=class{constructor(c,m,a){this.n=c,this.o=m,this.q=a,this.c=this.n.getProxy(N.$gM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new P.$Zjc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,m){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const a=this.d++;return this.e.set(a,m),this.c.$registerTextSearchProvider(a,this.s(c)),(0,u.$Sc)(()=>{this.g.delete(c),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(c,m){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const a=this.d++;return this.h.set(a,m),this.c.$registerAITextSearchProvider(a,this.s(c)),(0,u.$Sc)(()=>{this.i.delete(c),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(c,m){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const a=this.d++;return this.j.set(a,m),this.c.$registerFileSearchProvider(a,this.s(c)),(0,u.$Sc)(()=>{this.k.delete(c),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(c,m,a,n){const i=w(a),s=this.j.get(c);if(s)return this.l.fileSearch(i,s,o=>{this.c.$handleFileMatch(c,m,o.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,m,a){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,m,a,n){const i=this.e.get(c);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${c}`);const s=w(a);return this.t(s,i).search(t=>this.c.$handleTextMatch(c,m,t),n)}$provideAITextSearchResults(c,m,a,n){const i=this.h.get(c);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${c}`);const s=w(a);return this.v(s,i).search(t=>this.c.$handleTextMatch(c,m,t),n)}$enableExtensionHostSearch(){}t(c,m){return new R.$1jc({query:c,provider:m},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(c,m){return new R.$1jc({query:c,provider:m},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$6jc=I,e.$6jc=I=Je([Ve(0,A.$AO),Ve(1,b.$Yic),Ve(2,$.$Nj)],I);function w(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(S),extraFileResources:k.extraFileResources&&k.extraFileResources.map(c=>E.URI.revive(c))}}function S(k){return{...k,folder:E.URI.revive(k.folder)}}}),define(ke[378],Ee([1,0,22,13,4,3,15,39,2,135,197,178,78,25,32,12,86,87,275,6,321,348,91,120,326,307,327,121,328,308,296,33,329,42,330,96,151,331,310,322,332,333,71,70,323,48,334,68,335,59,27,349,350,324,311,336,337,115,116,312,368,339,281,340,351,341,156,313,342,343,344,20,345,97,117,346,314,347,118,93,95,90,47,352,353,325,354,355,69,16,7,315,65,316,92,356,357,150,41,289,114,26,94]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d,h,l,r,g,f,D,p,v,y,C,O,z,T,B,j,F,L,G,te,Z,x,_,ue,X,$e,se,re,U,ie,ve,Ie,le,ae,ce,H,Q,he,fe,Pe,be,Ae,Ne,Be,V,q,Y,J,ge,we,Te,He,Xe,tt,nt,at,rt,Ce,ze,Me,Ge,ne,oe,De,Ke,xe,st,je,bt,vt,Lt,Bt,Ut,Ct,ti,Wt,ri,ii,et,Xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=qt;function qt(ht){const mt=ht.get(re.$QO),ni=ht.get(se.$Gic),Vt=ht.get(X.$7ic),Ht=ht.get(_.$Djc),dt=ht.get(Wt.$2ic),It=ht.get(ze.$UO),si=ht.get(C.$5ic),_t=ht.get(vt.$Yic),Ye=ht.get(ge.$AO),Gt=ht.get(at.$njc),zt=ht.get(rt.$8ic),Kt=ht.get(c.$Oj),$t=ht.get(c.$Nj),At=ht.get(xe.$9Ab),Rt=ht.get(t.$Cic),jt=ht.get(ti.$Ikc),oi=ht.get(He.$vjc),Jt=ht.get(Z.$ejc),Yt=ht.get(H.$zjc),Et=ht.get(d.$Mic),Mt=ht.get(g.$Ric);Ye.set(i.$hM.ExtHostFileSystemInfo,ni),Ye.set(i.$hM.ExtHostLogLevelServiceShape,Kt),Ye.set(i.$hM.ExtHostWorkspace,dt),Ye.set(i.$hM.ExtHostConfiguration,si),Ye.set(i.$hM.ExtHostExtensionService,Ht),Ye.set(i.$hM.ExtHostStorage,Gt),Ye.set(i.$hM.ExtHostTunnelService,At),Ye.set(i.$hM.ExtHostWindow,jt),Ye.set(i.$hM.ExtHostSecretState,oi),Ye.set(i.$hM.ExtHostTelemetry,It),Ye.set(i.$hM.ExtHostEditorTabs,Jt),Ye.set(i.$hM.ExtHostManagedSockets,Yt),Ye.set(i.$hM.ExtHostAuthentication,Et),Ye.set(i.$hM.ExtHostChatProvider,Mt);const Qt=Ye.set(i.$hM.ExtHostDecorations,ht.get(T.$Ojc)),Ft=Ye.set(i.$hM.ExtHostDocumentsAndEditors,ht.get(te.$LO)),St=Ye.set(i.$hM.ExtHostCommands,ht.get(v.$WO)),Pt=Ye.set(i.$hM.ExtHostTerminalService,ht.get(Me.$qjc)),Dt=Ye.set(i.$hM.ExtHostDebugService,ht.get(z.$Ijc)),li=Ye.set(i.$hM.ExtHostSearch,ht.get(Te.$5jc)),ei=Ye.set(i.$hM.ExtHostTask,ht.get(Ce.$vkc)),ai=Ye.set(i.$hM.ExtHostOutputService,ht.get(Be.$ikc)),hi=Ye.set(i.$hM.ExtHostLocalization,ht.get(ce.$yjc)),Re=Ye.set(i.$hM.ExtHostUrls,new Lt.$Fkc(Ye)),Fe=Ye.set(i.$hM.ExtHostDocuments,new G.$Jic(Ye,Ft)),Se=Ye.set(i.$hM.ExtHostDocumentContentProviders,new F.$Qjc(Ye,Ft,$t)),ee=Ye.set(i.$hM.ExtHostDocumentSaveParticipant,new L.$Rjc($t,Fe,Ye.getProxy(i.$gM.MainThreadBulkEdits))),Oe=Ye.set(i.$hM.ExtHostNotebook,new he.$8jc(Ye,St,Ft,Fe,Vt,li)),qe=Ye.set(i.$hM.ExtHostNotebookDocuments,new Pe.$ckc(Oe)),_e=Ye.set(i.$hM.ExtHostNotebookEditors,new be.$dkc($t,Oe)),Qe=Ye.set(i.$hM.ExtHostNotebookKernels,new Ae.$ekc(Ye,mt,Oe,St,$t)),ut=Ye.set(i.$hM.ExtHostNotebookRenderers,new Ne.$gkc(Ye,Oe)),yt=Ye.set(i.$hM.ExtHostNotebookDocumentSaveParticipant,new fe.$bkc($t,Oe,Ye.getProxy(i.$gM.MainThreadBulkEdits))),kt=Ye.set(i.$hM.ExtHostEditors,new ne.$Vic(Ye,Ft)),xt=Ye.set(i.$hM.ExtHostTreeViews,new Ke.$Dkc(Ye.getProxy(i.$gM.MainThreadTreeViews),St,$t)),Ot=Ye.set(i.$hM.ExtHostEditorInsets,new p.$Wic(Ye.getProxy(i.$gM.MainThreadEditorInsets),kt,mt.remote)),Tt=Ye.set(i.$hM.ExtHostDiagnostics,new B.$Iic(Ye,$t,ni,Ft)),yi=Ye.set(i.$hM.ExtHostLanguages,new ae.$_jc(Ye,Fe,St.converter,_t)),ft=Ye.set(i.$hM.ExtHostLanguageFeatures,new le.$Kic(Ye,_t,Fe,St,Tt,$t,Rt,It)),Ri=Ye.set(i.$hM.ExtHostFileSystem,new ue.$Tjc(Ye,ft)),gi=Ye.set(i.$hM.ExtHostFileSystemEventService,new $e.$Ujc(Ye,$t,Ft)),pi=Ye.set(i.$hM.ExtHostQuickOpen,(0,J.$mkc)(Ye,dt,St)),ki=Ye.set(i.$hM.ExtHostSCM,new we.$okc(Ye,St,Fe,$t)),Mi=Ye.set(i.$hM.ExtHostQuickDiff,new Y.$lkc(Ye,_t)),Oi=Ye.set(i.$hM.ExtHostShare,new Xe.$pkc(Ye,_t)),Ji=Ye.set(i.$hM.ExtHostComments,(0,y.$Xic)(Ye,St,Fe)),Yi=Ye.set(i.$hM.ExtHostProgress,new q.$kkc(Ye.getProxy(i.$gM.MainThreadProgress))),Qi=Ye.set(i.$hM.ExtHostLabelService,new Ie.$$jc(Ye)),Ei=Ye.set(i.$hM.ExtHostTheming,new oe.$Akc(Ye)),Ni=Ye.set(i.$hM.ExtHostTimeline,new De.$Ckc(Ye,St)),Si=Ye.set(i.$hM.ExtHostWebviews,new Bt.$_ic(Ye,mt.remote,dt,$t,Rt)),Di=Ye.set(i.$hM.ExtHostWebviewPanels,new Ut.$cjc(Ye,Si,dt)),Zi=Ye.set(i.$hM.ExtHostCustomEditors,new O.$djc(Ye,Fe,zt,Si,Di)),Xi=Ye.set(i.$hM.ExtHostWebviewViews,new Ct.$Gkc(Ye,Si)),wi=Ye.set(i.$hM.ExtHostTesting,new Ge.$wkc(Ye,$t,St,Ft)),ln=Ye.set(i.$hM.ExtHostUriOpeners,new bt.$Ekc(Ye)),hn=Ye.set(i.$hM.ExtHostProfileContentHandlers,new V.$jkc(Ye));Ye.set(i.$hM.ExtHostInteractive,new ie.$9jc(Ye,Oe,Ft,St,$t));const Li=Ye.set(i.$hM.ExtHostInlineChat,new U.$Vjc(Ye,St,Fe,$t)),ji=Ye.set(i.$hM.ExtHostChatAgents2,new r.$Qic(Ye,$t,St)),dn=Ye.set(i.$hM.ExtHostChatVariables,new f.$Tic(Ye)),xi=Ye.set(i.$hM.ExtHostChat,new l.$Pic(Ye)),Fi=Ye.set(i.$hM.ExtHostAiRelatedInformation,new s.$Bic(Ye)),fn=Ye.set(i.$hM.ExtHostAiEmbeddingVector,new x.$Sjc(Ye)),Ci=Ye.set(i.$hM.ExtHostIssueReporter,new ve.$0jc(Ye)),Ti=Ye.set(i.$hM.ExtHostStatusBar,new nt.$skc(Ye,St.converter)),_i=Ye.set(i.$hM.ExtHostSpeech,new tt.$qkc(Ye)),en=Object.values(i.$hM);Ye.assertRegistered(en);const gn=new h.$Oic(Ye,Ft),Bi=new D.$Uic(Ye),Ii=new Q.$akc(Ye,$t),di=new j.$Pjc(Ye);return o.$Lic.register(St),function(Ue,mi,ci){function ot(me){return(ye,We,ct)=>{const wt=me(Nt=>{try{ye.call(We,Nt)}catch(Pi){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),It.onExtensionError(Ue.identifier,Pi)}});return ct?.push(wt),wt}}const pt=function(){let me=!Ue.isUnderDevelopment;function ye(){me||($t.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function We(ct){if(Array.isArray(ct))ct.forEach(We);else if(typeof ct=="string")ye();else{const wt=ct;typeof wt.scheme>"u"&&ye(),typeof wt.exclusive=="boolean"&&(0,et.$6F)(Ue,"documentFiltersExclusive")}return ct}}(),tn={getSession(me,ye,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,et.$6F)(Ue,"authLearnMore"),Et.getSession(Ue,me,ye,We)},getSessions(me,ye){return(0,et.$6F)(Ue,"authGetSessions"),Et.getSessions(Ue,me,ye)},async hasSession(me,ye){return(0,et.$6F)(Ue,"authSession"),!!await Et.getSession(Ue,me,ye,{silent:!0})},get onDidChangeSessions(){return ot(Et.onDidChangeSessions)},registerAuthenticationProvider(me,ye,We,ct){return Et.registerAuthenticationProvider(me,ye,We,ct)}},nn={registerCommand(me,ye,We){return St.registerCommand(!0,me,ye,We,void 0,Ue)},registerTextEditorCommand(me,ye,We){return St.registerCommand(!0,me,(...ct)=>{const wt=kt.getActiveTextEditor();if(!wt){$t.warn("Cannot execute "+me+" because there is no active text editor.");return}return wt.edit(Nt=>{ye.apply(We,[wt,Nt,...ct])}).then(Nt=>{Nt||$t.warn("Edits from command "+me+" were not applied.")},Nt=>{$t.warn("An error occurred while running command "+me,Nt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(me,ye,We)=>((0,et.$6F)(Ue,"diffCommand"),St.registerCommand(!0,me,async(...ct)=>{const wt=Ft.activeEditor(!0);if(!wt){$t.warn("Cannot execute "+me+" because there is no active text editor.");return}const Nt=await kt.getDiffInformation(wt.id);ye.apply(We,[Nt,...ct])},void 0,void 0,Ue)),executeCommand(me,...ye){return St.executeCommand(me,...ye)},getCommands(me=!1){return St.getCommands(me)}},zi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Bi.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return ot(Pt.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$6F)(Ue,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$6F)(Ue,"telemetry"),ot(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ze.$TO)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me,ye){return ze.$SO.validateSender(me),It.instantiateLogger(Ue,me,ye)},openExternal(me,ye){return jt.openUri(me,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===mt.environment.appUriScheme)return Re.createAppUri(me);try{return await jt.asExternalUri(me,{allowTunneling:!!mt.remote.authority})}catch(ye){if((0,A.$qg)(me,A.Schemas.http)||(0,A.$qg)(me,A.Schemas.https))return me;throw ye}},get remoteName(){return(0,m.$tm)(mt.remote.authority)},get remoteAuthority(){return(0,et.$6F)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return ot($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(me){return(0,et.$6F)(Ue,"handleIssueUri"),Ci.registerIssueUriRequestHandler(Ue,me)},registerIssueDataProvider(me){return(0,et.$6F)(Ue,"handleIssueUri"),Ci.registerIssueDataProvider(Ue,me)},get appQuality(){return(0,et.$6F)(Ue,"resolvers"),mt.quality},get appCommit(){return(0,et.$6F)(Ue,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(zi);const mn={createTestController(me,ye,We){return wi.createTestController(Ue,me,ye,We)},createTestObserver(){return(0,et.$6F)(Ue,"testObserver"),wi.createTestObserver()},runTests(me){return(0,et.$6F)(Ue,"testObserver"),wi.runTests(me)},get onDidChangeTestResults(){return(0,et.$6F)(Ue,"testObserver"),ot(wi.onResultsChanged)},get testResults(){return(0,et.$6F)(Ue,"testObserver"),wi.results}},vi=mt.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,rn={getExtension(me,ye){(0,et.$5F)(Ue,"extensionsAny")||(ye=!1);const We=mi.mine.getExtensionDescription(me);if(We)return new _.$Ejc(Ht,Ue.identifier,We,vi,!1);if(ye){const ct=mi.all.getExtensionDescription(me);if(ct)return new _.$Ejc(Ht,Ue.identifier,ct,vi,!0)}},get all(){const me=[];for(const ye of mi.mine.getAllExtensionDescriptions())me.push(new _.$Ejc(Ht,Ue.identifier,ye,vi,!1));return me},get allAcrossExtensionHosts(){(0,et.$6F)(Ue,"extensionsAny");const me=new S.$Dm(mi.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ye=[];for(const We of mi.all.getAllExtensionDescriptions()){const ct=!me.has(We.identifier);ye.push(new _.$Ejc(Ht,Ue.identifier,We,vi,ct))}return ye},get onDidChange(){return(0,et.$5F)(Ue,"extensionsAny")?ot(M.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):ot(mi.mine.onDidChange)}},$n={createDiagnosticCollection(me){return Tt.createDiagnosticCollection(Ue.identifier,me)},get onDidChangeDiagnostics(){return ot(Tt.onDidChangeDiagnostics)},getDiagnostics:me=>Tt.getDiagnostics(me),getLanguages(){return yi.getLanguages()},setTextDocumentLanguage(me,ye){return yi.changeLanguage(me.uri,ye)},match(me,ye){const We=st.LanguageSelector.from(me);let ct;return(0,R.$Ut)(We)&&(ct=Oe.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(Nt=>Nt.document===ye))?.apiNotebook),(0,R.$Tt)(We,ye.uri,ye.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(me,ye,We){return ft.registerCodeActionProvider(Ue,pt(me),ye,We)},registerDocumentPasteEditProvider(me,ye,We){return(0,et.$6F)(Ue,"documentPaste"),ft.registerDocumentPasteEditProvider(Ue,pt(me),ye,We)},registerCodeLensProvider(me,ye){return ft.registerCodeLensProvider(Ue,pt(me),ye)},registerDefinitionProvider(me,ye){return ft.registerDefinitionProvider(Ue,pt(me),ye)},registerDeclarationProvider(me,ye){return ft.registerDeclarationProvider(Ue,pt(me),ye)},registerImplementationProvider(me,ye){return ft.registerImplementationProvider(Ue,pt(me),ye)},registerTypeDefinitionProvider(me,ye){return ft.registerTypeDefinitionProvider(Ue,pt(me),ye)},registerHoverProvider(me,ye){return ft.registerHoverProvider(Ue,pt(me),ye,Ue.identifier)},registerEvaluatableExpressionProvider(me,ye){return ft.registerEvaluatableExpressionProvider(Ue,pt(me),ye,Ue.identifier)},registerInlineValuesProvider(me,ye){return ft.registerInlineValuesProvider(Ue,pt(me),ye,Ue.identifier)},registerDocumentHighlightProvider(me,ye){return ft.registerDocumentHighlightProvider(Ue,pt(me),ye)},registerMultiDocumentHighlightProvider(me,ye){return ft.registerMultiDocumentHighlightProvider(Ue,pt(me),ye)},registerLinkedEditingRangeProvider(me,ye){return ft.registerLinkedEditingRangeProvider(Ue,pt(me),ye)},registerReferenceProvider(me,ye){return ft.registerReferenceProvider(Ue,pt(me),ye)},registerRenameProvider(me,ye){return ft.registerRenameProvider(Ue,pt(me),ye)},registerNewSymbolNamesProvider(me,ye){return(0,et.$6F)(Ue,"newSymbolNamesProvider"),ft.registerNewSymbolNamesProvider(Ue,pt(me),ye)},registerDocumentSymbolProvider(me,ye,We){return ft.registerDocumentSymbolProvider(Ue,pt(me),ye,We)},registerWorkspaceSymbolProvider(me){return ft.registerWorkspaceSymbolProvider(Ue,me)},registerDocumentFormattingEditProvider(me,ye){return ft.registerDocumentFormattingEditProvider(Ue,pt(me),ye)},registerDocumentRangeFormattingEditProvider(me,ye){return ft.registerDocumentRangeFormattingEditProvider(Ue,pt(me),ye)},registerOnTypeFormattingEditProvider(me,ye,We,...ct){return ft.registerOnTypeFormattingEditProvider(Ue,pt(me),ye,[We].concat(ct))},registerDocumentSemanticTokensProvider(me,ye,We){return ft.registerDocumentSemanticTokensProvider(Ue,pt(me),ye,We)},registerDocumentRangeSemanticTokensProvider(me,ye,We){return ft.registerDocumentRangeSemanticTokensProvider(Ue,pt(me),ye,We)},registerSignatureHelpProvider(me,ye,We,...ct){return typeof We=="object"?ft.registerSignatureHelpProvider(Ue,pt(me),ye,We):ft.registerSignatureHelpProvider(Ue,pt(me),ye,typeof We>"u"?[]:[We,...ct])},registerCompletionItemProvider(me,ye,...We){return ft.registerCompletionItemProvider(Ue,pt(me),ye,We)},registerInlineCompletionItemProvider(me,ye,We){return ye.handleDidShowCompletionItem&&(0,et.$6F)(Ue,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.$6F)(Ue,"inlineCompletionsAdditions"),We&&(0,et.$6F)(Ue,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(Ue,pt(me),ye,We)},registerInlineEditProvider(me,ye){return(0,et.$6F)(Ue,"inlineEdit"),ft.registerInlineEditProvider(Ue,pt(me),ye)},registerDocumentLinkProvider(me,ye){return ft.registerDocumentLinkProvider(Ue,pt(me),ye)},registerColorProvider(me,ye){return ft.registerColorProvider(Ue,pt(me),ye)},registerFoldingRangeProvider(me,ye){return ft.registerFoldingRangeProvider(Ue,pt(me),ye)},registerSelectionRangeProvider(me,ye){return ft.registerSelectionRangeProvider(Ue,me,ye)},registerCallHierarchyProvider(me,ye){return ft.registerCallHierarchyProvider(Ue,me,ye)},registerTypeHierarchyProvider(me,ye){return ft.registerTypeHierarchyProvider(Ue,me,ye)},setLanguageConfiguration:(me,ye)=>ft.setLanguageConfiguration(Ue,me,ye),getTokenInformationAtPosition(me,ye){return(0,et.$6F)(Ue,"tokenInformation"),yi.tokenAtPosition(me,ye)},registerInlayHintsProvider(me,ye){return ft.registerInlayHintsProvider(Ue,me,ye)},createLanguageStatusItem(me,ye){return yi.createLanguageStatusItem(Ue,me,ye)},registerDocumentDropEditProvider(me,ye,We){return ft.registerDocumentOnDropEditProvider(Ue,me,ye,(0,et.$5F)(Ue,"dropMetadata")?We:void 0)}},pn={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(me,ye,We){$.URI.isUri(me)&&me.scheme===A.Schemas.vscodeRemote&&!me.authority&&Rt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(me)?Promise.resolve(Ui.openTextDocument(me)):Promise.resolve(me));return kt.showTextDocument(ct,ye,We)},createTextEditorDecorationType(me){return kt.createTextEditorDecorationType(Ue,me)},onDidChangeActiveTextEditor(me,ye,We){return ot(kt.onDidChangeActiveTextEditor)(me,ye,We)},onDidChangeVisibleTextEditors(me,ye,We){return ot(kt.onDidChangeVisibleTextEditors)(me,ye,We)},onDidChangeTextEditorSelection(me,ye,We){return ot(kt.onDidChangeTextEditorSelection)(me,ye,We)},onDidChangeTextEditorOptions(me,ye,We){return ot(kt.onDidChangeTextEditorOptions)(me,ye,We)},onDidChangeTextEditorVisibleRanges(me,ye,We){return ot(kt.onDidChangeTextEditorVisibleRanges)(me,ye,We)},onDidChangeTextEditorViewColumn(me,ye,We){return ot(kt.onDidChangeTextEditorViewColumn)(me,ye,We)},onDidCloseTerminal(me,ye,We){return ot(Pt.onDidCloseTerminal)(me,ye,We)},onDidOpenTerminal(me,ye,We){return ot(Pt.onDidOpenTerminal)(me,ye,We)},onDidChangeActiveTerminal(me,ye,We){return ot(Pt.onDidChangeActiveTerminal)(me,ye,We)},onDidChangeTerminalDimensions(me,ye,We){return(0,et.$6F)(Ue,"terminalDimensions"),ot(Pt.onDidChangeTerminalDimensions)(me,ye,We)},onDidChangeTerminalState(me,ye,We){return ot(Pt.onDidChangeTerminalState)(me,ye,We)},onDidWriteTerminalData(me,ye,We){return(0,et.$6F)(Ue,"terminalDataWriteEvent"),ot(Pt.onDidWriteTerminalData)(me,ye,We)},onDidExecuteTerminalCommand(me,ye,We){return(0,et.$6F)(Ue,"terminalExecuteCommandEvent"),ot(Pt.onDidExecuteTerminalCommand)(me,ye,We)},get state(){return jt.getState(Ue)},onDidChangeWindowState(me,ye,We){return ot(jt.onDidChangeWindowState)(me,ye,We)},showInformationMessage(me,...ye){return Ii.showMessage(Ue,b.default.Info,me,ye[0],ye.slice(1))},showWarningMessage(me,...ye){return Ii.showMessage(Ue,b.default.Warning,me,ye[0],ye.slice(1))},showErrorMessage(me,...ye){return Ii.showMessage(Ue,b.default.Error,me,ye[0],ye.slice(1))},showQuickPick(me,ye,We){return pi.showQuickPick(Ue,me,ye,We)},showWorkspaceFolderPick(me){return pi.showWorkspaceFolderPick(me)},showInputBox(me,ye){return pi.showInput(me,ye)},showOpenDialog(me){return di.showOpenDialog(Ue,me)},showSaveDialog(me){return di.showSaveDialog(me)},createStatusBarItem(me,ye,We){let ct,wt,Nt;return typeof me=="string"?(ct=me,wt=ye,Nt=We):(wt=me,Nt=ye),Ti.createStatusBarEntry(Ue,ct,wt,Nt)},setStatusBarMessage(me,ye){return Ti.setStatusBarMessage(me,ye)},withScmProgress(me){return Rt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Yi.withProgress(Ue,{location:je.ProgressLocation.SourceControl},(ye,We)=>me({report(ct){}}))},withProgress(me,ye){return Yi.withProgress(Ue,me,ye)},createOutputChannel(me,ye){return ai.createOutputChannel(me,ye,Ue)},createWebviewPanel(me,ye,We,ct){return Di.createWebviewPanel(Ue,me,ye,We,ct)},createWebviewTextEditorInset(me,ye,We,ct){return(0,et.$6F)(Ue,"editorInsets"),Ot.createWebviewEditorInset(me,ye,We,ct,Ue)},createTerminal(me,ye,We){return typeof me=="object"?"pty"in me?Pt.createExtensionTerminal(me):Pt.createTerminalFromOptions(me):Pt.createTerminal(me,ye,We)},registerTerminalLinkProvider(me){return Pt.registerLinkProvider(me)},registerTerminalProfileProvider(me,ye){return Pt.registerProfileProvider(Ue,me,ye)},registerTerminalQuickFixProvider(me,ye){return(0,et.$6F)(Ue,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(me,Ue.identifier.value,ye)},registerTreeDataProvider(me,ye){return xt.registerTreeDataProvider(me,ye,Ue)},createTreeView(me,ye){return xt.createTreeView(me,ye,Ue)},registerWebviewPanelSerializer:(me,ye)=>Di.registerWebviewPanelSerializer(Ue,me,ye),registerCustomEditorProvider:(me,ye,We={})=>Zi.registerCustomEditorProvider(Ue,me,ye,We),registerFileDecorationProvider(me){return Qt.registerFileDecorationProvider(me,Ue)},registerUriHandler(me){return Re.registerUriHandler(Ue,me)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(me,ye,We){return ot(Ei.onDidChangeActiveColorTheme)(me,ye,We)},registerWebviewViewProvider(me,ye,We){return Xi.registerWebviewViewProvider(Ue,me,ye,We?.webviewOptions)},get activeNotebookEditor(){return Oe.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,ye,We){return ot(Oe.onDidChangeActiveNotebookEditor)(me,ye,We)},get visibleNotebookEditors(){return Oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(me,ye,We){return ot(_e.onDidChangeNotebookEditorSelection)(me,ye,We)},onDidChangeNotebookEditorVisibleRanges(me,ye,We){return ot(_e.onDidChangeNotebookEditorVisibleRanges)(me,ye,We)},showNotebookDocument(me,ye){return Oe.showNotebookDocument(me,ye)},registerExternalUriOpener(me,ye,We){return(0,et.$6F)(Ue,"externalUriOpener"),ln.registerExternalUriOpener(Ue.identifier,me,ye,We)},registerProfileContentHandler(me,ye){return(0,et.$6F)(Ue,"profileContentHandlers"),hn.registerProfileContentHandler(Ue,me,ye)},registerQuickDiffProvider(me,ye,We,ct){return(0,et.$6F)(Ue,"quickDiffProvider"),Mi.registerQuickDiffProvider(pt(me),ye,We,ct)},get tabGroups(){return Jt.tabGroups},registerShareProvider(me,ye){return(0,et.$6F)(Ue,"shareProvider"),Oi.registerShareProvider(pt(me),ye)}},Ui={get rootPath(){return Rt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(me){throw new N.$9("rootPath")},getWorkspaceFolder(me){return dt.getWorkspaceFolder(me)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(me){throw new N.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(me){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(me,ye,...We)=>dt.updateWorkspaceFolders(Ue,me,ye||0,...We),onDidChangeWorkspaceFolders:function(me,ye,We){return ot(dt.onDidChangeWorkspace)(me,ye,We)},asRelativePath:(me,ye)=>dt.getRelativePath(me,ye),findFiles:(me,ye,We,ct)=>dt.findFiles(me,ye,We,Ue.identifier,ct),findFiles2:(me,ye,We)=>((0,et.$6F)(Ue,"findFiles2"),dt.findFiles2(me,ye,Ue.identifier,We)),findTextInFiles:(me,ye,We,ct)=>{(0,et.$6F)(Ue,"findTextInFiles");let wt,Nt;return typeof ye=="object"?(wt=ye,Nt=We):(wt={},Nt=ye,ct=We),dt.findTextInFiles(me,wt||{},Nt,Ue.identifier,ct)},save:me=>dt.save(me),saveAs:me=>dt.saveAs(me),saveAll:me=>dt.saveAll(me),applyEdit(me,ye){return gn.applyWorkspaceEdit(me,Ue,ye)},createFileSystemWatcher:(me,ye,We,ct)=>{let wt;return typeof ye=="boolean"?wt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!ct,correlate:!1}:ye&&((0,et.$6F)(Ue,"createFileSystemWatcher"),wt={...ye,correlate:!0}),gi.createFileSystemWatcher(dt,Ue,me,wt)},get textDocuments(){return Fe.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw new N.$9("textDocuments")},openTextDocument(me){let ye;const We=me;if(typeof me=="string")ye=Promise.resolve($.URI.file(me));else if($.URI.isUri(me))ye=Promise.resolve(me);else if(!We||typeof We=="object")ye=Fe.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ct=>(ct.scheme===A.Schemas.vscodeRemote&&!ct.authority&&Rt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Fe.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:(me,ye,We)=>ot(Fe.onDidAddDocument)(me,ye,We),onDidCloseTextDocument:(me,ye,We)=>ot(Fe.onDidRemoveDocument)(me,ye,We),onDidChangeTextDocument:(me,ye,We)=>ot(Fe.onDidChangeDocument)(me,ye,We),onDidSaveTextDocument:(me,ye,We)=>ot(Fe.onDidSaveDocument)(me,ye,We),onWillSaveTextDocument:(me,ye,We)=>ot(ee.getOnWillSaveTextDocumentEvent(Ue))(me,ye,We),get notebookDocuments(){return Oe.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,ye){let We;if($.URI.isUri(me))We=me,await Oe.openNotebookDocument(me);else if(typeof me=="string")We=$.URI.revive(await Oe.createNotebookDocument({viewType:me,content:ye}));else throw new Error("Invalid arguments");return Oe.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(me,ye,We){return ot(qe.onDidSaveNotebookDocument)(me,ye,We)},onDidChangeNotebookDocument(me,ye,We){return ot(qe.onDidChangeNotebookDocument)(me,ye,We)},onWillSaveNotebookDocument(me,ye,We){return ot(yt.getOnWillSaveNotebookDocumentEvent(Ue))(me,ye,We)},get onDidOpenNotebookDocument(){return ot(Oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Oe.onDidCloseNotebookDocument)},registerNotebookSerializer(me,ye,We,ct){return Oe.registerNotebookSerializer(Ue,me,ye,We,(0,et.$5F)(Ue,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(me,ye,We)=>ot(ci.onDidChangeConfiguration)(me,ye,We),getConfiguration(me,ye){return ye=arguments.length===1?void 0:ye,ci.getConfiguration(me,ye,Ue)},registerTextDocumentContentProvider(me,ye){return Se.registerTextDocumentContentProvider(me,ye)},registerTaskProvider:(me,ye)=>(Rt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),ei.registerTaskProvider(Ue,me,ye)),registerFileSystemProvider(me,ye,We){return(0,P.$Rc)(Ri.registerFileSystemProvider(Ue,me,ye,We),Vt.addFileSystemProvider(me,ye,We))},get fs(){return Vt.value},registerFileSearchProvider:(me,ye)=>((0,et.$6F)(Ue,"fileSearchProvider"),li.registerFileSearchProvider(me,ye)),registerTextSearchProvider:(me,ye)=>((0,et.$6F)(Ue,"textSearchProvider"),li.registerTextSearchProvider(me,ye)),registerAITextSearchProvider:(me,ye)=>((0,et.$6F)(Ue,"aiTextSearchProvider"),(0,et.$6F)(Ue,"textSearchProvider"),li.registerAITextSearchProvider(me,ye)),registerRemoteAuthorityResolver:(me,ye)=>((0,et.$6F)(Ue,"resolvers"),Ht.registerRemoteAuthorityResolver(me,ye)),registerResourceLabelFormatter:me=>((0,et.$6F)(Ue,"resolvers"),Qi.$registerResourceLabelFormatter(me)),getRemoteExecServer:me=>((0,et.$6F)(Ue,"resolvers"),Ht.getRemoteExecServer(me)),onDidCreateFiles:(me,ye,We)=>ot(gi.onDidCreateFile)(me,ye,We),onDidDeleteFiles:(me,ye,We)=>ot(gi.onDidDeleteFile)(me,ye,We),onDidRenameFiles:(me,ye,We)=>ot(gi.onDidRenameFile)(me,ye,We),onWillCreateFiles:(me,ye,We)=>ot(gi.getOnWillCreateFileEvent(Ue))(me,ye,We),onWillDeleteFiles:(me,ye,We)=>ot(gi.getOnWillDeleteFileEvent(Ue))(me,ye,We),onWillRenameFiles:(me,ye,We)=>ot(gi.getOnWillRenameFileEvent(Ue))(me,ye,We),openTunnel:me=>((0,et.$6F)(Ue,"tunnels"),At.openTunnel(Ue,me).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.$6F)(Ue,"tunnels"),At.getTunnels()},onDidChangeTunnels:(me,ye,We)=>((0,et.$6F)(Ue,"tunnels"),ot(At.onDidChangeTunnels)(me,ye,We)),registerPortAttributesProvider:(me,ye)=>((0,et.$6F)(Ue,"portsAttributes"),At.registerPortsAttributesProvider(me,ye)),registerTunnelProvider:(me,ye)=>((0,et.$6F)(Ue,"tunnelFactory"),At.registerTunnelProvider(me,ye)),registerTimelineProvider:(me,ye)=>((0,et.$6F)(Ue,"timeline"),Ni.registerTimelineProvider(me,ye,Ue.identifier,St.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:me=>((0,et.$6F)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,ye,We)=>ot(dt.onDidGrantWorkspaceTrust)(me,ye,We),registerEditSessionIdentityProvider:(me,ye)=>((0,et.$6F)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(me,ye)),onWillCreateEditSessionIdentity:(me,ye,We)=>((0,et.$6F)(Ue,"editSessionIdentityProvider"),ot(dt.getOnWillCreateEditSessionIdentityEvent(Ue))(me,ye,We)),registerCanonicalUriProvider:(me,ye)=>((0,et.$6F)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(me,ye)),getCanonicalUri:(me,ye,We)=>((0,et.$6F)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(me,ye,We))},Wi={get inputBox(){return Rt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(Ue)},createSourceControl(me,ye,We){return ki.createSourceControl(Ue,me,ye,We)}},sn={createCommentController(me,ye){return Ji.createCommentController(Ue,me,ye)}},on={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){if((0,et.$5F)(Ue,"debugFocus"))return Dt.activeStackItem},registerDebugVisualizationProvider(me,ye){return(0,et.$6F)(Ue,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ue,me,ye)},registerDebugVisualizationTreeProvider(me,ye){return(0,et.$6F)(Ue,"debugVisualization"),Dt.registerDebugVisualizationTree(Ue,me,ye)},onDidStartDebugSession(me,ye,We){return ot(Dt.onDidStartDebugSession)(me,ye,We)},onDidTerminateDebugSession(me,ye,We){return ot(Dt.onDidTerminateDebugSession)(me,ye,We)},onDidChangeActiveDebugSession(me,ye,We){return ot(Dt.onDidChangeActiveDebugSession)(me,ye,We)},onDidReceiveDebugSessionCustomEvent(me,ye,We){return ot(Dt.onDidReceiveDebugSessionCustomEvent)(me,ye,We)},onDidChangeBreakpoints(me,ye,We){return ot(Dt.onDidChangeBreakpoints)(me,ye,We)},onDidChangeActiveStackItem(me,ye,We){return(0,et.$6F)(Ue,"debugFocus"),ot(Dt.onDidChangeActiveStackItem)(me,ye,We)},registerDebugConfigurationProvider(me,ye,We){return Dt.registerDebugConfigurationProvider(me,ye,We||ri.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,ye){return Dt.registerDebugAdapterDescriptorFactory(Ue,me,ye)},registerDebugAdapterTrackerFactory(me,ye){return Dt.registerDebugAdapterTrackerFactory(me,ye)},startDebugging(me,ye,We){return!We||typeof We=="object"&&"configuration"in We?Dt.startDebugging(me,ye,{parentSession:We}):Dt.startDebugging(me,ye,We||{})},stopDebugging(me){return Dt.stopDebugging(me)},addBreakpoints(me){return Dt.addBreakpoints(me)},removeBreakpoints(me){return Dt.removeBreakpoints(me)},asDebugSourceUri(me,ye){return Dt.asDebugSourceUri(me,ye)}},an={registerTaskProvider:(me,ye)=>ei.registerTaskProvider(Ue,me,ye),fetchTasks:me=>ei.fetchTasks(me),executeTask:me=>ei.executeTask(Ue,me),get taskExecutions(){return ei.taskExecutions},onDidStartTask:(me,ye,We)=>ot(ei.onDidStartTask)(me,ye,We),onDidEndTask:(me,ye,We)=>ot(ei.onDidEndTask)(me,ye,We),onDidStartTaskProcess:(me,ye,We)=>ot(ei.onDidStartTaskProcess)(me,ye,We),onDidEndTaskProcess:(me,ye,We)=>ot(ei.onDidEndTaskProcess)(me,ye,We)},bn={createNotebookController(me,ye,We,ct,wt){return Qe.createNotebookController(Ue,me,ye,We,ct,(0,et.$5F)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(me,ye)=>Oe.registerNotebookCellStatusBarItemProvider(Ue,me,ye),createRendererMessaging(me){return ut.createRendererMessaging(Ue,me)},createNotebookControllerDetectionTask(me){return(0,et.$6F)(Ue,"notebookKernelSource"),Qe.createNotebookControllerDetectionTask(Ue,me)},registerKernelSourceActionProvider(me,ye){return(0,et.$6F)(Ue,"notebookKernelSource"),Qe.registerKernelSourceActionProvider(Ue,me,ye)},onDidChangeNotebookCellExecutionState(me,ye,We){return(0,et.$6F)(Ue,"notebookCellExecutionState"),ot(Qe.onDidChangeNotebookCellExecutionState)(me,ye,We)}},wn={t(...me){if(typeof me[0]=="string"){const ye=me.shift(),We=!me||typeof me[0]!="object"?me:me[0];return hi.getMessage(Ue.identifier.value,{message:ye,args:We})}return hi.getMessage(Ue.identifier.value,me[0])},get bundle(){return hi.getBundle(Ue.identifier.value)},get uri(){return hi.getBundleUri(Ue.identifier.value)}},cn={_version:1,registerInteractiveEditorSessionProvider(me,ye){return(0,et.$6F)(Ue,"interactive"),Li.registerProvider(Ue,me,ye)},registerInteractiveSessionProvider(me,ye){return(0,et.$6F)(Ue,"interactive"),xi.registerChatProvider(Ue,me,ye)},transferChatSession(me,ye){return(0,et.$6F)(Ue,"interactive"),xi.transferChatSession(me,ye)}},un={getRelatedInformation(me,ye){return(0,et.$6F)(Ue,"aiRelatedInformation"),Fi.getRelatedInformation(Ue,me,ye)},registerRelatedInformationProvider(me,ye){return(0,et.$6F)(Ue,"aiRelatedInformation"),Fi.registerRelatedInformationProvider(Ue,me,ye)},registerEmbeddingVectorProvider(me,ye){return(0,et.$6F)(Ue,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(Ue,me,ye)}},qi={registerChatResponseProvider(me,ye,We){return(0,et.$6F)(Ue,"chatProvider"),Mt.registerLanguageModel(Ue,me,ye,We)},registerChatVariableResolver(me,ye,We){return(0,et.$6F)(Ue,"chatVariableResolver"),dn.registerVariableResolver(Ue,me,ye,We)},registerMappedEditsProvider(me,ye){return(0,et.$6F)(Ue,"mappedEditsProvider"),ft.registerMappedEditsProvider(Ue,me,ye)},createChatParticipant(me,ye){return(0,et.$6F)(Ue,"chatParticipant"),ji.createChatAgent(Ue,me,ye)}},Vi={get languageModels(){return(0,et.$6F)(Ue,"languageModels"),Mt.getLanguageModelIds()},onDidChangeLanguageModels:(me,ye,We)=>((0,et.$6F)(Ue,"languageModels"),Mt.onDidChangeProviders(me,ye,We)),sendChatRequest(me,ye,We,ct){return(0,et.$6F)(Ue,"languageModels"),Mt.sendChatRequest(Ue,me,ye,We,ct)}},Hi={registerSpeechProvider(me,ye){return(0,et.$6F)(Ue,"speech"),_i.registerProvider(Ue.identifier,me,ye)}};return{version:mt.version,ai:un,authentication:tn,commands:nn,comments:sn,chat:qi,debug:on,env:zi,extensions:rn,interactive:cn,l10n:wn,languages:$n,lm:Vi,notebooks:bn,scm:Wi,speech:Hi,tasks:an,tests:mn,window:pn,workspace:Ui,Breakpoint:je.$iN,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatResultFeedbackKind:je.ChatResultFeedbackKind,ChatVariableLevel:je.ChatVariableLevel,ChatCompletionItem:je.$bO,CallHierarchyIncomingCall:je.$GM,CallHierarchyItem:je.$FM,CallHierarchyOutgoingCall:je.$HM,CancellationError:N.$5,CancellationTokenSource:u.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:je.$CM,CodeActionKind:je.$DM,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$IM,Color:je.$VM,ColorInformation:je.$WM,ColorPresentation:je.$XM,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$PM,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$QM,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$6M,DebugAdapterExecutable:je.$mN,DebugAdapterInlineImplementation:je.$pN,DebugAdapterNamedPipeServer:je.$oN,DebugAdapterServer:je.$nN,DebugConfigurationProviderTriggerKind:ri.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DebugVisualization:je.$FN,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$wM,DiagnosticRelatedInformation:je.$vM,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$iM,DocumentHighlight:je.$yM,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$zM,DocumentLink:je.$UM,DocumentSymbol:je.$BM,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$sN,InlineValueText:je.$tN,InlineValueVariableLookup:je.$uN,InlineValueEvaluatableExpression:je.$vN,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:M.$7d,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$HN,FileDecoration2:je.$HN,FileSystemError:je.$yN,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:je.$zN,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$kN,InlineCompletionItem:je.$RM,InlineCompletionList:je.$SM,Hover:je.$xM,IndentAction:I.IndentAction,Location:je.$uM,MarkdownString:je.$JM,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:je.$KM,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$jM,ProcessExecution:je.$4M,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$GN,Range:je.$kM,RelativePattern:je.$gN,Selection:je.$lM,SelectionRange:je.$EM,SemanticTokens:je.$CN,SemanticTokensBuilder:je.$BN,SemanticTokensEdit:je.$DN,SemanticTokensEdits:je.$EN,SemanticTokensLegend:je.$AN,ShellExecution:je.$5M,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$MM,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$LM,SnippetString:je.$tM,SourceBreakpoint:je.$jN,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$AM,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$7M,TaskGroup:je.$3M,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$YM,TerminalQuickFixTerminalCommand:je.$1M,TerminalQuickFixOpener:je.$ZM,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$2M,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$pM,SnippetTextEdit:je.$rM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$fN,ThemeIcon:je.$eN,TreeItem:je.$8M,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$3N,UIKind:ii.UIKind,Uri:$.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$sM,DocumentPasteTriggerKind:je.DocumentPasteTriggerKind,DocumentDropEdit:je.$bN,DocumentPasteEditKind:je.$cN,DocumentPasteEdit:je.$dN,InlayHint:je.$OM,InlayHintLabelPart:je.$NM,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$oM,ResolvedAuthority:je.$mM,ManagedResolvedAuthority:je.$nM,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$RN,NotebookRange:je.$JN,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$KN,NotebookData:je.$LN,NotebookRendererScript:je.$PN,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$NN,NotebookCellOutputItem:je.$MN,NotebookCellStatusBarItem:je.$ON,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$qM,NotebookKernelSourceAction:je.$QN,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$TN,LinkedEditingRanges:je.$SN,TestResultState:je.TestResultState,TestRunRequest:je.$UN,TestMessage:je.$VN,TestTag:je.$WN,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:Xt.TextSearchCompleteMessageType,DataTransfer:je.$aN,DataTransferItem:je.$9M,CoveredCount:je.$XN,FileCoverage:je.$YN,StatementCoverage:je.$ZN,BranchCoverage:je.$1N,DeclarationCoverage:je.$2N,FunctionCoverage:je.$2N,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$4N,TabInputTextDiff:je.$5N,TabInputTextMerge:je.$6N,TabInputCustom:je.$7N,TabInputNotebook:je.$9N,TabInputNotebookDiff:je.$0N,TabInputWebview:je.$8N,TabInputTerminal:je.$$N,TabInputInteractiveWindow:je.$_N,TabInputChat:je.$aO,TelemetryTrustedValue:a.$3o,LogLevel:c.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,ChatCopyKind:je.ChatCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrame:je.$qN,Thread:je.$rN,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus,PartialAcceptTriggerKind:je.PartialAcceptTriggerKind,KeywordRecognitionStatus:je.KeywordRecognitionStatus,ChatResponseMarkdownPart:je.$cO,ChatResponseFileTreePart:je.$dO,ChatResponseAnchorPart:je.$eO,ChatResponseProgressPart:je.$fO,ChatResponseReferencePart:je.$hO,ChatResponseCommandButtonPart:je.$gO,ChatRequestTurn:je.$iO,ChatResponseTurn:je.$jO,LanguageModelChatSystemMessage:je.$kO,LanguageModelChatUserMessage:je.$lO,LanguageModelChatAssistantMessage:je.$mO,LanguageModelSystemMessage:je.$kO,LanguageModelUserMessage:je.$lO,LanguageModelAssistantMessage:je.$mO,LanguageModelError:je.$nO,NewSymbolName:je.$xN,NewSymbolNameTag:je.NewSymbolNameTag,InlineEdit:je.$oO,InlineEditTriggerKind:je.InlineEditTriggerKind}}}}),define(ke[379],Ee([1,0,83,156,41,151,42,33,71,47,95,96,97,118,69,91,150,68,59,117,90,70,149,12,60,115,116,120,121]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d,h,l,r,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$es)(l.$yjc,l.$xjc,1),(0,u.$es)(d.$Oj,t.$Kkc,1),(0,u.$es)(c.$Cic,c.$Dic,1),(0,u.$es)(b.$WO,b.$VO,0),(0,u.$es)(g.$Mic,g.$Nic,0),(0,u.$es)(f.$Ric,f.$Sic,0),(0,u.$es)(A.$5ic,A.$3ic,0),(0,u.$es)(a.$7ic,a.$6ic,0),(0,u.$es)(I.$Ijc,I.$Mjc,0),(0,u.$es)(P.$Ojc,P.$Njc,0),(0,u.$es)($.$LO,$.$KO,0),(0,u.$es)(r.$zjc,r.$Ajc,0),(0,u.$es)(n.$Gic,n.$Fic,0),(0,u.$es)(N.$ikc,N.$hkc,1),(0,u.$es)(w.$5jc,w.$6jc,0),(0,u.$es)(S.$njc,S.$mjc,0),(0,u.$es)(R.$vkc,R.$ukc,0),(0,u.$es)(E.$qjc,E.$tjc,0),(0,u.$es)(k.$9Ab,k.$0Ab,0),(0,u.$es)(m.$Ikc,m.$Hkc,0),(0,u.$es)(M.$2ic,M.$1ic,0),(0,u.$es)(i.$vjc,i.$ujc,0),(0,u.$es)(s.$UO,s.$RO,0),(0,u.$es)(o.$ejc,o.$fjc,0),(0,u.$es)(h.$Gjc,h.$Hjc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=void 0,e.$1kc=A,e.$2kc=b;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,w,S,k){const c=(0,u.$2b)(S,$),m=new M.$zK(w,c,k),a=m.preview.matches;return{ranges:(0,u.$2b)(c,E),uri:I,preview:{text:m.preview.text,matches:(0,u.$2b)(a,E)}}}function $(I){return new M.$AK(I.start.line,I.start.character,I.end.line,I.end.character)}function E(I){return new P.$oK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(w,S){this.a=w,this.b=S}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$3kc=R,e.$3kc=R=Je([Ve(1,N.$Nj)],R)}),define(ke[380],Ee([1,0,52,17,75,34,11,14,122,381]),function(de,e,u,N,M,P,A,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=I,e.$5kc=m,e.$6kc=n;const R=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,s,o,t){const d=w(i,s,o,t),h=s.folder.fsPath;return{cmd:u.spawn(R,d.args,{cwd:h}),rgDiskPath:R,siblingClauses:d.siblingClauses,rgArgs:d,cwd:h}}function w(i,s,o,t){const d=["--files","--hidden","--case-sensitive","--no-require-git"];k([s],o,!1).forEach(l=>{const r=(0,$.$1kc)(l);if(d.push("-g",r),A.$j){const g=(0,M.$Zl)(r);g!==r&&d.push("-g",g)}});const h=S([s],t,void 0,!1);return h.globArgs.forEach(l=>{const r=`!${(0,$.$1kc)(l)}`;if(d.push("-g",r),A.$j){const g=(0,M.$Zl)(r);g!==r&&d.push("-g",g)}}),s.disregardIgnoreFiles!==!1?d.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),s.ignoreSymlinks||d.push("--follow"),i.exists&&d.push("--quiet"),d.push("--no-config"),s.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:h.siblingClauses}}function S(i,s,o,t=!0){const d=[];let h={};return i.forEach(l=>{const r=Object.assign({},l.excludePattern||{},s||{}),g=c(r,t?l.folder.fsPath:void 0,o);d.push(...g.globArgs),g.siblingClauses&&(h=Object.assign(h,g.siblingClauses))}),{globArgs:d,siblingClauses:h}}function k(i,s,o=!0){const t=[];return i.forEach(d=>{const h=Object.assign({},s||{},d.includePattern||{}),l=c(h,o?d.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function c(i,s,o){const t=[],d={};return Object.keys(i).forEach(h=>{if(o&&o.has(h)||!h)return;const l=i[h];h=a(s?m(s,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof l=="boolean"&&l?(h.startsWith("\\\\")&&(h+="**"),t.push(n(h))):l&&l.when&&(d[h]=l)}),{globArgs:t,siblingClauses:d}}function m(i,s){return N.$jc(s)?s:N.$kc(i,s)}function a(i){return i=b.$6e(i,"\\"),b.$6e(i,"/")}function n(i){return P.$dg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[382],Ee([1,0,52,51,17,383,19,45,35,75,34,11,38,14,18,31,36,380,132]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=e.$7kc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(h=>h())});class s{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$bk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$fr)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$bk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(r=>{const g=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),f=r.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==f).forEach(D=>{(0,R.$hg)(D,f)&&(g[M.$mc(f,D)]=!0)}),this.t.set(f,new t(g,f))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,r,g,f,D){if(this.m=w.$3d.create(!1),this.l)return D(null,this.j);r.forEach(p=>{const v=M.$oc(p.fsPath);this.u&&this.u(p.fsPath,v)||this.J(g,{relativePath:p.fsPath,searchPath:void 0})}),this.r=w.$3d.create(!1),this.w(l,(p,v)=>{this.x(this.y,this,p,g,f,y=>{if(y){const C=(0,b.$5i)(y);console.error(C),this.q.push(C),v(y,void 0)}else v(null,void 0)})},(p,v)=>{this.m.stop();const y=p?A.$Hb(p)[0]:null;D(y,this.j)})}w(l,r,g){const f=new Array(l.length),D=new Array(l.length);let p=!1,v=0;if(l.length===0)return g(null,[]);l.forEach((y,C)=>{r(y,(O,z)=>{if(O?(p=!0,f[C]=null,D[C]=O):(f[C]=z,D[C]=null),++v===l.length)return g(p?D:null,f)})})}x(l,r,...g){try{l.apply(r,g)}catch(f){g[g.length-1](f)}}y(l,r,g,f){const D=l.folder.fsPath,p=I.$j,v=()=>T&&T.kill();i.add(v);let y=L=>{i.delete(v),y=()=>{},f(L)},C="";const O=this.D(),z=(0,a.$4kc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),T=z.cmd,B=!Object.keys(z.siblingClauses).length,j=z.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let F=`${z.rgDiskPath} ${j}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),g({message:F}),this.s=0,this.z(T,"utf8",g,(L,G,te)=>{if(L){y(L);return}if(this.j){y();return}const x=(C+(p?E.$Yl(G||""):G)).split(`
`);if(te){const _=x.length;x[_-1]=x[_-1].trim(),x[_-1]||x.pop()}else C=x.pop()||"";if(x.length&&x[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=x.length,B){for(const _ of x)if(this.J(r,{base:D,relativePath:_,searchPath:this.N(l,_)}),this.j){v();break}(te||this.j)&&y();return}this.G(l,O,D,x,r),te&&(this.H(O,D,r),y())})}spawnFindCmd(l){const r=this.t.get(l.folder.fsPath),g=r.getBasenameTerms(),f=r.getPathTerms(),D=["-L","."];if(g.length||f.length){D.push("-not","(","(");for(const p of g)D.push("-name",p),D.push("-o");for(const p of f)D.push("-path",p),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,r,g){let f="";this.z(l,r,()=>{},(D,p,v)=>{if(D){g(D);return}f+=p,v&&g(null,f)})}z(l,r,g,f){let D=(y,C,O)=>{(y||O)&&(D=()=>{},this.r?.stop()),f(y,C,O)},p=!1;l.stdout?(this.A(l.stdout,r,D),l.stdout.once("data",()=>p=!0)):g({message:"stdout is null"});let v;l.stderr?v=this.B(l.stderr):g({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let C;!p&&(C=this.C(v,r))&&d(C)?D(new Error(`command failed with error code ${y}: ${this.C(v,r)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(l,r,g){const f=new P.StringDecoder(r);return l.on("data",D=>{g(null,f.write(D))}),f}B(l){const r=[];return l.on("data",g=>{r.push(g)}),r}C(l,r){const g=new P.StringDecoder(r);return l.map(f=>g.write(f)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:r},g,f,D){f.indexOf(this.b)!==-1&&this.J(D,{base:g,relativePath:this.b,searchPath:this.N(l,this.b)});const p=v=>{const y=M.$oc(v),C=M.$nc(v);let O=r[C];O||(O=r[C]=[],p(C)),O.push({base:g,relativePath:v,basename:y,searchPath:this.N(l,v)})};f.forEach(p)}H({rootEntries:l,pathToEntries:r},g,f){const D=this,p=this.t.get(g),v=this.b;function y(C){D.o++;const O=(0,m.$PK)(()=>C.map(z=>z.basename));for(let z=0,T=C.length;z<T;z++){const B=C[z],{relativePath:j,basename:F}=B;if(p.test(j,F,v!==F?O:void 0))continue;const L=r[j];if(L)y(L);else{if(D.p++,j===v)continue;D.J(f,B)}if(D.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,r,g,f,D){const p=l.folder,v=(0,m.$PK)(()=>g);this.w(g,(y,C)=>{if(this.l||this.j)return C(null);const O=r?[r,y].join(M.sep):y;if(this.t.get(l.folder.fsPath).test(O,y,this.a.filePattern!==y?v:void 0))return C(null);const z=[p.fsPath,O].join(M.sep);N.lstat(z,(T,B)=>{if(T||this.l||this.j)return C(null);this.L(z,B,(j,F)=>j||this.l||this.j?C(null):F.isDirectory()?(this.o++,this.M(z,B,(L,G)=>L||this.l||this.j||(G=G||"",this.v[G])?C(null):(this.v[G]=!0,c.Promises.readdir(z).then(te=>{if(this.l||this.j)return C(null);this.I(l,O,te,f,Z=>C(Z||null))},te=>{C(null)})))):(this.p++,O===this.b||this.h&&k.$Yf(F.size)&&F.size>this.h||this.J(f,{base:p.fsPath,relativePath:O,searchPath:this.N(l,O)}),C(null,void 0)))})},y=>{const C=y&&A.$Hb(y);return D(C&&C.length>0?C[0]:void 0)})}J(l,r){this.K(r)&&(!this.d||this.d(r.relativePath,M.$oc(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(r))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$KK)(l,this.c);if(this.b)return(0,m.$KK)(l,this.b,!1)}return!0}L(l,r,g){return r.isSymbolicLink()?N.stat(l,g):g(null,r)}M(l,r,g){return r.isSymbolicLink()?N.realpath(l,(f,D)=>f?g(f):g(null,D)):g(null,l)}N(l,r){return l.folderName?M.$kc(l.folderName,r):r}}e.$7kc=s;class o{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new s(l)}search(l,r,g){this.c.walk(this.a,this.b,l,r,(f,D)=>{g(f,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$8kc=o;class t{constructor(l,r){this.expression=l,this.c=r,this.d(l)}d(l){let r,g;Object.keys(l).filter(f=>l[f]).forEach(f=>{M.$jc(f)?(r=r||$.$9j(),r[f]=l[f]):(g=g||$.$9j(),g[f]=l[f])}),this.a=r&&$.$bk(r,{trimForExclusions:!0}),this.b=g&&$.$bk(g,{trimForExclusions:!0})}test(l,r,g){return this.b&&this.b(l,r,g)||this.a&&this.a(M.$kc(this.c,l),r,g)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$dk(this.a)),this.b&&l.push(...$.$dk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$ek(this.a)),this.b&&l.push(...$.$ek(this.b)),l}}function d(h){const l=h.trim().split(`
`),r=l[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return S.$Mf(l[l.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(ke[384],Ee([1,0,98,21,192,22]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TD=e.$LD=e.DecodeStreamErrorKind=e.$KD=e.$JD=e.$ID=e.$GD=e.$FD=e.$ED=e.$DD=void 0,e.$HD=A,e.$MD=k,e.$ND=c,e.$OD=m,e.$PD=a,e.$QD=n,e.$RD=h,e.$SD=l,e.$DD="utf8",e.$ED="utf8bom",e.$FD="utf16be",e.$GD="utf16le";function A(r){return[e.$DD,e.$ED,e.$FD,e.$GD].some(g=>g===r)}e.$ID=[254,255],e.$JD=[255,254],e.$KD=[239,187,191];const b=512,$=512,E=512*8,R=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class w extends Error{constructor(g,f){super(g),this.decodeStreamErrorKind=f}}e.$LD=w;class S{static async create(g){let f;if(g!==e.$DD)f=(await(0,M.$CD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(g));else{const D=new TextDecoder;f={write(p){return D.decode(p,{stream:!0})},end(){return D.decode()}}}return new S(f)}constructor(g){this.a=g}write(g){return this.a.write(g)}end(){return this.a.end()}}function k(r,g){const f=g.minBytesRequiredForDetection??g.guessEncoding?E:$;return new Promise((D,p)=>{const v=(0,u.$ie)(B=>B.join("")),y=[];let C=0,O;const z=new P.$ee,T=async()=>{try{const B=await l({buffer:N.$ue.concat(y),bytesRead:C},g.guessEncoding);if(B.seemsBinary&&g.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);B.encoding=await g.overwriteEncoding(B.encoding),O=await S.create(B.encoding);const j=O.write(N.$ue.concat(y).buffer);v.write(j),y.length=0,C=0,D({stream:v,detected:B})}catch(B){z.cancel(),v.destroy(),p(B)}};(0,u.$me)(r,{onData:async B=>{O?v.write(O.write(B.buffer)):(y.push(B),C+=B.byteLength,C>=f&&(r.pause(),await T(),setTimeout(()=>r.resume())))},onError:B=>v.error(B),onEnd:async()=>{O||await T(),v.end(O?.end())}},z.token)})}async function c(r,g,f){const p=(await(0,M.$CD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(g),f);let v=!1,y=!1;return{read(){if(y)return null;const C=r.read();if(typeof C!="string"){if(y=!0,!v&&f?.addBOM)switch(g){case e.$DD:case e.$ED:return N.$ue.wrap(Uint8Array.from(e.$KD));case e.$FD:return N.$ue.wrap(Uint8Array.from(e.$ID));case e.$GD:return N.$ue.wrap(Uint8Array.from(e.$JD))}const O=p.end();return O&&O.length>0?(v=!0,N.$ue.wrap(O)):null}return v=!0,N.$ue.wrap(p.write(C))}}}async function m(r){return(await(0,M.$CD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(r))}function a(r){return r===e.$ED||r===null?e.$DD:r}function n(r,g){if(!r||g<e.$ID.length)return null;const f=r.readUInt8(0),D=r.readUInt8(1);if(f===e.$ID[0]&&D===e.$ID[1])return e.$FD;if(f===e.$JD[0]&&D===e.$JD[1])return e.$GD;if(g<e.$KD.length)return null;const p=r.readUInt8(2);return f===e.$KD[0]&&D===e.$KD[1]&&p===e.$KD[2]?e.$ED:null}const i=["ascii","utf-16","utf-32"];async function s(r){const g=await(0,M.$CD)("jschardet","dist/jschardet.min.js"),f=r.slice(0,R),D=d(f.buffer),p=g.detect(D);if(!p||!p.encoding)return null;const v=p.encoding.toLowerCase();return 0<=i.indexOf(v)?null:t(p.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(r){const g=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[g]||g}function d(r){let g="";for(let f=0;f<r.length;f++)g+=String.fromCharCode(r[f]);return g}function h(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const g=r.match(/windows(\d+)/);return g?"windows-"+g[1]:r}}}function l({buffer:r,bytesRead:g},f){let D=n(r,g),p=!1;if(D!==e.$FD&&D!==e.$GD&&r){let v=!0,y=!0,C=!1;for(let O=0;O<g&&O<b;O++){const z=O%2===1,T=r.readUInt8(O)===0;if(T&&(C=!0),v&&(z&&!T||!z&&T)&&(v=!1),y&&(z&&T||!z&&!T)&&(y=!1),T&&!v&&!y)break}C&&(v?D=e.$GD:y?D=e.$FD:p=!0)}return f&&!p&&!D&&r?s(r.slice(0,g)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:p,encoding:D}}e.$TD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[159],Ee([1,0,384,31,158]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class P extends M.$1jc{constructor(b,$,E=N,R="searchProcess"){super({query:b,provider:$},{readdir:I=>E.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.$RD)(I)},R)}}e.$dlc=P}),define(ke[160],Ee([1,0,52,400,383,19,72,35,14,2,36,94,401,381,122]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=e.$9kc=void 0,e.$$kc=t,e.$_kc=h,e.$alc=r,e.$blc=g,e.$clc=D;const c=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(v){this.a=v}provideTextSearchResults(v,y,C,O){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,T)=>{O.onCancellationRequested(()=>x());const B=t(v,y),j=y.folder.fsPath,F=B.map(se=>se.match(/^-/)?se:`'${se}'`).join(" ");this.a.appendLine(`${c} ${F}
 - cwd: ${j}`);let L=u.spawn(c,B,{cwd:j});L.on("error",se=>{console.error(se),this.a.appendLine("Error: "+(se&&se.message)),T((0,R.$GK)(new R.$EK(se&&se.message,R.SearchErrorCode.rgProcessError)))});let G=!1;const te=new i(y.maxResults,y.folder,y.previewOptions);te.on("result",se=>{G=!0,ue="",C.report(se)});let Z=!1;const x=()=>{Z=!0,L?.kill(),te?.cancel()};let _=!1;te.on("hitLimit",()=>{_=!0,x()});let ue="";L.stdout.on("data",se=>{te.handleData(se),G||(ue+=se)});let X=!1;L.stdout.once("data",()=>X=!0);let $e="";L.stderr.on("data",se=>{const re=se.toString();this.a.appendLine(re),$e.length+re.length<1e6&&($e+=re)}),L.on("close",()=>{if(this.a.appendLine(X?"Got data from stdout":"No data from stdout"),this.a.appendLine(G?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),Z)z({limitHit:_});else{te.flush(),L=null;let se;$e&&!X&&(se=a($e))?T((0,R.$GK)(new R.$EK(se.message,se.code))):z({limitHit:_})}})})}}e.$9kc=m;function a(p){const v=p.split(`
`),y=v[0].trim();if(v.some(O=>O.startsWith("regex parse error")))return new R.$EK(n(v),R.SearchErrorCode.regexParseError);const C=y.match(/grep config error: unknown encoding: (.*)/);if(C)return new R.$EK(`Unknown encoding: ${C[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$EK(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$EK(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$EK(y,R.SearchErrorCode.regexParseError)}function n(p){const v=["Regex parse error"],y=p.filter(C=>C.startsWith("PCRE2:"));if(y.length>=1){const C=y[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const O=C.split(":")[1];v.push(":"+O)}}return v.join("")}class i extends N.EventEmitter{constructor(v,y,C){super(),this.g=v,this.h=y,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new M.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,y){return super.on(v,y),this}handleData(v){if(this.b)return;const y=typeof v=="string"?v:this.d.write(v);this.k(y)}k(v){let y=v.indexOf(`
`);const C=this.a+v;if(y>=0)y+=this.a.length;else{this.a=C;return}let O=0;for(;y>=0;)this.m(C.substring(O,y).trim()),O=y+1,y=C.indexOf(`
`,O);this.a=C.substring(O)}m(v){if(this.b||!v)return;let y;try{y=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(y.type==="match"){const C=s(y.data.path),O=E.URI.joinPath(this.h,C),z=this.n(y.data,O);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const C=s(y.data.path),O=E.URI.joinPath(this.h,C);this.o(y.data,O).forEach(T=>this.p(T))}}n(v,y){const C=v.line_number-1,O=s(v.lines),z=Buffer.from(O);let T=0,B=0,j=C;v.submatches.length===0&&v.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.$Hb)(v.submatches.map((L,G)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=s(L.match),Z=z.slice(T,L.start).toString(),x=o(Z),_=x.numLines>0?x.lastLineLength:x.lastLineLength+B,ue=o(te),X=x.numLines+j,$e=ue.numLines+X,se=ue.numLines>0?ue.lastLineLength:ue.lastLineLength+_;return T=L.end,B=se,j=$e,new I.$oK(X,_,$e,se)}));return(0,k.$2kc)(y,O,F,this.j)}o(v,y){const C=s(v.lines),O=v.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((z,T)=>({text:z,uri:y,lineNumber:O+T}))}p(v){this.emit("result",v)}}e.$0kc=i;function s(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function o(p){const v=/\n/g;let y=0,C=-1,O;for(;O=v.exec(p);)y++,C=O.index;const z=C>=0?p.length-C-1:p.length;return{numLines:y,lastLineLength:z}}function t(p,v){const y=["--hidden","--no-require-git"];y.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:O}=(0,A.$K)(v.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const T=new Set;O.forEach(B=>{T.add(B)}),y.push("-g","!*"),T.forEach(B=>{d(B).map(k.$1kc).forEach(j=>{y.push("-g",j)})})}C&&C.length&&C.forEach(T=>{y.push("-g",T)}),v.excludes.map(k.$1kc).forEach(T=>y.push("-g",`!${T}`)),v.maxFileSize&&y.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),v.followSymlinks&&y.push("--follow"),v.encoding&&v.encoding!=="utf8"&&y.push("--encoding",v.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,$.$Ze)(p.pattern),p.isRegExp=!0),v.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),p.isRegExp&&(p.pattern=h(p.pattern),y.push("--engine","auto"));let z;if(p.isWordMatch){const B=(0,$.$9e)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",B)}else if(p.isRegExp){let T=r(p.pattern);T=g(T),y.push("--regexp",T)}else z=p.pattern,y.push("--fixed-strings");return y.push("--no-config"),v.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),p.isMultiline&&y.push("--multiline"),v.beforeContext&&y.push("--before-context",v.beforeContext+""),v.afterContext&&y.push("--after-context",v.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}function d(p){return D(p).flatMap(y=>{const C=(0,b.$_j)(y,"/");return C.map((O,z)=>C.slice(0,z+1).join("/"))})}function h(p){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(v);)p=p.replace(v,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(y);)p=p.replace(y,"$1\\x{$2}");return p}const l=p=>p.type==="Assertion"&&p.kind==="lookbehind";function r(p){let v;try{v=new w.RegExpParser().parsePattern(p)}catch{return p}let y="",C=0;const O=(B,j,F)=>{y+=p.slice(C,B)+F,C=j},z=[];return new w.RegExpVisitor({onCharacterEnter(B){if(B.raw!=="\\n")return;const j=z[0];if(!j)O(B.start,B.end,"\\r?\\n");else if(!z.some(l))if(j.type==="CharacterClass")if(j.negate){const F=p.slice(j.start+2,B.start)+p.slice(B.end,j.end-1);j.parent?.type==="Quantifier"?O(j.start,j.end,F?`[^${F}]`:"."):O(j.start,j.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=p.slice(j.start+1,B.start)+p.slice(B.end,j.end-1);O(j.start,j.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else j.type==="Quantifier"&&O(B.start,B.end,"(?:\\r?\\n)")},onQuantifierEnter(B){z.unshift(B)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(B){z.unshift(B)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(B){z.unshift(B)},onCharacterClassLeave(){z.shift()},onAssertionEnter(B){l(B)&&z.push(B)},onAssertionLeave(B){z[0]===B&&z.shift()}}).visit(v),y+=p.slice(C),y}function g(p){return p.replace(/\n/g,"\\r?\\n")}function f(p){let v=!1,y=!1,C="",O="";for(let z=0;z<p.length;z++){const T=p[z];switch(T){case"\\":y?(v?O+="\\"+T:C+="\\"+T,y=!1):y=!0;break;case"{":if(y)v?O+=T:C+=T,y=!1;else{if(v)return{strInBraces:C+"{"+O+"{"+p.substring(z+1)};v=!0}break;case"}":if(y)v?O+=T:C+=T,y=!1;else{if(v)return{fixedStart:C,strInBraces:O,fixedEnd:p.substring(z+1)};C+=T}break;default:v?O+=(y?"\\":"")+T:C+=(y?"\\":"")+T,y=!1;break}}return{strInBraces:C+(v?"{"+O:"")}}function D(p){const{fixedStart:v,strInBraces:y,fixedEnd:C}=f(p);if(v===void 0||C===void 0)return[y];let O=(0,b.$_j)(y,",");O.length||(O=[""]);const z=D(C);return O.flatMap(T=>{const B=v+T;return z.map(j=>B+j)})}}),define(ke[385],Ee([1,0,22,160,108,15]),function(de,e,u,N,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class A{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,R,I,w){const S=new N.$9kc(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const k={...R,folder:R.folder.with({scheme:P.Schemas.file})},c=new M.$Pv(m=>I.report({...m,uri:m.uri.with({scheme:R.folder.scheme})}));return this.c(w,m=>S.provideTextSearchResults(E,k,c,m))}else return this.c(w,k=>S.provideTextSearchResults(E,R,I,k))}async c(E,R){const I=b(E);this.a.add(I);const w=await R(I.token);return this.a.delete(I),w}d(){this.a.forEach(E=>E.cancel())}}e.$glc=A;function b($){const E=new u.$ee;return $.onCancellationRequested(()=>E.cancel()),E}}),define(ke[386],Ee([1,0,31,160,159]),function(de,e,u,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class P{constructor($){this.a=$}search($,E,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){R({message:S})}},w=new M.$dlc(this.a,new N.$9kc(I),u);return new Promise((S,k)=>w.search(c=>{E(c.map(A))},$).then(c=>S({limitHit:c.limitHit,type:"success",stats:c.stats}),k))}}e.$elc=P;function A(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,E)=>{if(E.ranges){const R=E;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(ke[387],Ee([1,0,19,8,13,4,132,17,38,2,32,36,382,386]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class k{static{this.a=512}constructor(s="searchProcess"){this.d=s,this.b=Object.create(null)}fileSearch(s){let o;const t=a(s),d=new P.$7d({onDidAddFirstListener:()=>{o=(0,N.$7g)(h=>this.doFileSearchWithEngine(w.$8kc,t,l=>d.fire(l),h)),o.then(h=>d.fire(h),h=>d.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return d.event}textSearch(s){let o;const t=a(s),d=new P.$7d({onDidAddFirstListener:()=>{o=(0,N.$7g)(h=>this.f(t,l=>d.fire(l),h)),o.then(h=>d.fire(h),h=>d.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return d.event}f(s,o,t){return s.maxFileSize=this.g().maxFileSize,new S.$elc(s).search(t,o,o)}g(){return{maxFileSize:16*R.$jl.GB}}doFileSearch(s,o,t){return this.doFileSearchWithEngine(w.$8kc,s,o,t)}doFileSearchWithEngine(s,o,t,d,h=k.a){let l=0;const r=f=>{Array.isArray(f)?(l+=f.length,t(f.map(D=>this.h(D)))):f.relativePath?(l++,t(this.h(f))):t(f)};if(o.sortByScore){let f=this.l(o,r,d);if(!f){const D=o.maxResults?Object.assign({},o,{maxResults:null}):o,p=new s(D);f=this.j(p,o,t,r,d)}return new Promise((D,p)=>{f.then(([v,y])=>{const C=y.map(O=>this.h(O));this.o(C,t,h),D(v)},p)})}const g=new s(o);return this.r(g,r,h,d).then(f=>({limitHit:f.limitHit,type:"success",stats:{detailStats:f.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(s){return{path:s.base?(0,b.$kc)(s.base,s.relativePath):s.relativePath}}j(s,o,t,d,h){const l=new P.$7d;let r=(0,N.$7g)(f=>{let D=[];const p=v=>{Array.isArray(v)?D=v:(d(v),l.fire(v))};return this.r(s,p,-1,f).then(v=>[v,D])}),g;if(o.cacheKey){g=this.k(o.cacheKey);const f={promise:r,event:l.event,resolved:!1};g.resultsToSearchCache[o.filePattern||""]=f,r.then(()=>{f.resolved=!0},D=>{delete g.resultsToSearchCache[o.filePattern||""]}),r=this.s(r)}return r.then(([f,D])=>{const p=g?g.scorerCache:Object.create(null),v=(typeof o.maxResults!="number"||o.maxResults>0)&&$.$3d.create(!1);return this.n(o,D,p,h).then(y=>{const C=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:f.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:y.length},messages:f.messages,limitHit:f.limitHit||typeof o.maxResults=="number"&&D.length>o.maxResults},y]})})}k(s){const o=this.b[s];return o||(this.b[s]=new c)}l(s,o,t){const d=s.cacheKey&&this.b[s.cacheKey];if(!d)return;const h=this.q(d,s.filePattern||"",o,t);if(h)return h.then(([l,r,g])=>{const f=$.$3d.create(!1);return this.n(s,r,d.scorerCache,t).then(D=>{const p=f.elapsed(),v={fromCache:!0,detailStats:g,type:this.d,resultCount:r.length,sortingTime:p};return[{type:"success",limitHit:l.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults,stats:v},D]})})}n(s,o,t,d){const h=(0,A.$fr)(s.filePattern||""),l=(g,f)=>(0,A.$er)(g,f,h,!0,m,t),r=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return u.$Gb(o,l,r,1e4,d)}o(s,o,t){if(t&&t>0)for(let d=0;d<s.length;d+=t)o(s.slice(d,d+t));else o(s)}q(s,o,t,d){const h=$.$3d.create(!1),l=o.indexOf(b.sep)>=0;let r;for(const p in s.resultsToSearchCache)if(o.startsWith(p)){if(l&&p.indexOf(b.sep)<0&&p!=="")continue;const v=s.resultsToSearchCache[p];r={promise:this.s(v.promise),event:v.event,resolved:v.resolved};break}if(!r)return null;const g=h.elapsed(),f=$.$3d.create(!1),D=r.event(t);return d&&d.onCancellationRequested(()=>{D.dispose()}),r.promise.then(([p,v])=>{if(d&&d.isCancellationRequested)throw(0,M.$6)();const y=[],C=(0,A.$fr)(o).normalizedLowercase;for(const O of v)(0,I.$KK)(O,C)&&y.push(O);return[p,y,{cacheWasResolved:r.resolved,cacheLookupTime:g,cacheFilterTime:f.elapsed(),cacheEntryCount:v.length}]})}r(s,o,t,d){return new Promise((h,l)=>{let r=[];d?.onCancellationRequested(()=>s.cancel()),s.search(g=>{g&&(t?(r.push(g),t>0&&r.length>=t&&(o(r),r=[])):o(g))},g=>{o(g)},(g,f)=>{r.length&&o(r),g?(o({message:"Search finished. Error: "+g.message}),l(g)):(o({message:"Search finished. Stats: "+JSON.stringify(f.stats)}),h(f))})})}clearCache(s){return delete this.b[s],Promise.resolve(void 0)}s(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return s.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return s.finally(o)}}}}e.$flc=k;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(s=>E.URI.revive(s))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[388],Ee([1,0,3,15,2,31,12,27,20,97,65,36,387,385,122,159]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;let m=class extends E.$6jc{constructor(n,i,s,o){super(n,s,o),this.w=P,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new k.$3kc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new S.$glc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new k.$3kc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new S.$glc(n))),this.A.add(this.C(N.Schemas.file,new w.$flc("fileSearchProvider")))}C(n,i){const s=this.d++;return this.y=i,this.x=s,this.c.$registerFileSearchProvider(s,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,i,s,o){const t=(0,E.$7jc)(s);if(n===this.x){const d=Date.now();return this.D(n,i,t,o).then(h=>{const l=Date.now()-d;return this.q.debug(`Ext host file search time: ${l}ms`),h})}return super.$provideFileSearchResults(n,i,s,o)}doInternalFileSearchWithCustomCallback(n,i,s){const o=t=>{if((0,I.$JK)(t)&&(t=[t]),Array.isArray(t)){s(t.map(d=>M.URI.file(d.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,o,i)}async D(n,i,s,o){return this.doInternalFileSearchWithCustomCallback(s,o,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new c.$dlc(n,i,void 0,"textSearchProvider")}};e.$hlc=m,e.$hlc=m=Je([Ve(0,$.$AO),Ve(1,b.$QO),Ve(2,R.$Yic),Ve(3,A.$Nj)],m)}),define(ke[123],Ee([1,0,375,62,63,402,21,13,4,3,17,11,30,80,81]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$$h=e.$0h=e.$9h=void 0,e.$_h=h,e.$ai=l,e.$ci=f,e.$di=D;class c{traceSocketEvent(v,y){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,y)}constructor(v,y=""){this.f=!0,this.debugLabel=y,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const y=C=>{this.traceSocketEvent("read",C),v(A.$ue.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(v){const y=C=>{v({type:0,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(v){const y=()=>{v()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,b.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$9h=c;var m;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize",p[p.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var a;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(a||(a={}));class n extends E.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,y){this.socket.traceSocketEvent(v,y)}constructor(v,y,C,O){super(),this.f=this.B(new $.$7d),this.g=this.B(new $.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new i(this,y,C,O,this.f,(z,T)=>this.m(z,T))),this.B(this.a.onError(z=>{console.error(z),(0,b.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new k.$4h,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let y=0;for(;y<v.byteLength;)this.a.writeMessage(v.slice(y,Math.min(y+262144,v.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(v,{compressed:y,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let O=2;v.byteLength<126?O+=0:v.byteLength<2**16?O+=2:O+=8;const z=A.$ue.alloc(O),T=y?64:0,B=C&15;if(z.writeUInt8(128|T|B,0),v.byteLength<126)z.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){z.writeUInt8(126,1);let j=1;z.writeUInt8(v.byteLength>>>8&255,++j),z.writeUInt8(v.byteLength>>>0&255,++j)}else{z.writeUInt8(127,1);let j=1;z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(v.byteLength>>>24&255,++j),z.writeUInt8(v.byteLength>>>16&255,++j),z.writeUInt8(v.byteLength>>>8&255,++j),z.writeUInt8(v.byteLength>>>0&255,++j)}this.socket.write(A.$ue.concat([z,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),O=(C&128)>>>7,z=(C&64)>>>6,T=C&15,B=y.readUInt8(1),j=(B&128)>>>7,F=B&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),O=(C&128)>>>7;let z=C&127,T=1;z===126?z=y.readUInt8(++T)*2**8+y.readUInt8(++T):z===127&&(z=y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*2**24+y.readUInt8(++T)*2**16+y.readUInt8(++T)*2**8+y.readUInt8(++T));let B=0;O&&(B=y.readUInt8(++T)*2**24+y.readUInt8(++T)*2**16+y.readUInt8(++T)*2**8+y.readUInt8(++T)),this.j.state=3,this.j.readLen=z,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$0h=n;class i extends E.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ue.alloc(0)}constructor(v,y,C,O,z,T){super(),this.n=v,this.r=z,this.s=T,this.a=this.B(new $.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new s(this.n,O,C,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(v,y){this.g.push({data:v,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:y}=this.g.shift();if(this.f&&y.compressed){const C=await this.w(this.f,v);this.s(C,y)}else this.s(v,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,y){return new Promise((C,O)=>{v.write(y),v.flush(z=>C(z))})}acceptFrame(v,y,C){this.h.push({data:v,isCompressed:y,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const y=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,y,C){return new Promise((O,z)=>{v.write(y),C&&v.write(A.$ue.fromByteArray([0,0,255,255])),v.flush(T=>O(T))})}}class s extends E.$Uc{get recordedInflateBytes(){return this.j?A.$ue.concat(this.f):A.$ue.alloc(0)}constructor(v,y,C,O){super(),this.h=v,this.j=y,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(O),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(A.$ue.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$ue.concat(this.g);this.g.length=0,v(y)})}}class o extends E.$Uc{constructor(v,y){super(),this.g=v,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(A.$ue.wrap(C))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$ue.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),v(y)})}}function t(p,v){if(v===0)return;const y=p.byteLength>>>2;for(let j=0;j<y;j++){const F=p.readUInt32BE(j*4);p.writeUInt32BE(F^v,j*4)}const C=y*4,O=p.byteLength-C,z=v>>>24&255,T=v>>>16&255,B=v>>>8&255;O>=1&&p.writeUInt8(p.readUInt8(C)^z,C),O>=2&&p.writeUInt8(p.readUInt8(C+1)^T,C+1),O>=3&&p.writeUInt8(p.readUInt8(C+2)^B,C+2)}e.$$h=process.env.XDG_RUNTIME_DIR;const d={2:107,1:103};function h(){const p=(0,w.$Dg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;const v=process.platform!=="darwin"&&e.$$h?e.$$h:(0,M.tmpdir)(),y=(0,R.$kc)(v,`vscode-ipc-${p}.sock`);return r(y),y}function l(p,v,y){const O=(0,u.createHash)("sha256").update(p).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${y}-${v}-sock`;const z=y.substr(0,4),T=v.substr(0,6);let B;return process.platform!=="darwin"&&e.$$h&&!process.env.VSCODE_PORTABLE?B=(0,R.$kc)(e.$$h,`vscode-${O}-${z}-${T}.sock`):B=(0,R.$kc)(p,`${z}-${T}.sock`),r(B),B}function r(p){const v=d[I.$u];typeof v=="number"&&p.length>=v&&console.warn(`WARNING: IPC handle "${p}" is longer than ${v} chars, try a shorter --user-data-dir`)}class g extends S.$Xh{static b(v){const y=$.Event.fromNodeEventEmitter(v,"connection");return $.Event.map(y,C=>({protocol:new k.$5h(new c(C,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(C,"close"))}))}constructor(v){super(g.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$bi=g;function f(p){return new Promise((v,y)=>{const C=(0,N.createServer)();C.on("error",y),C.listen(p,()=>{C.removeListener("error",y),v(new g(C))})})}function D(p,v){return new Promise((y,C)=>{const O=(0,N.createConnection)(p,()=>{O.removeListener("error",C),y(k.$6h.fromSocket(new c(O,`ipc-client${v}`),v))});O.once("error",C)})}}),define(ke[389],Ee([1,0,62,63,172,123,8,3,11,53,12,139,265,266,110,88,21]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=e.$nbc=e.$mbc=void 0;async function a(t,d,h,l,r){let g;for(let f=3;f&&(g?.dispose(),g=await new n(t,d,h,l,r).waitForReady(),!(r&&M.$Gg[r]||!M.$Gg[g.tunnelLocalPort]));f--);return g}class n extends b.$Uc{constructor(d,h,l,r,g){super(),this.m=h,this.n=g,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=d,this.b=u.createServer(),this.c=new A.$gh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=f=>this.r(f),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const d=this.n??this.tunnelRemotePort,h=(0,c.$3v)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,M.$Hg)(d,2,1e3,h),r=null;return this.b.listen(l,this.m),await this.c.wait(),r=this.b.address(),r||(l=0,this.b.listen(l,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(d){d.pause();const h=(0,c.$1v)(this.tunnelRemoteHost)||(0,c.$3v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,w.$Dl)(this.a,h,this.tunnelRemotePort),r=l.getSocket(),g=l.readEntireBuffer();l.dispose(),g.byteLength>0&&d.write(g.buffer),d.on("end",()=>{d.localAddress&&this.j.delete(d.localAddress),r.end()}),d.on("close",()=>r.end()),d.on("error",()=>{d.localAddress&&this.j.delete(d.localAddress),r instanceof P.$9h?r.socket.destroy():r.end()}),r instanceof P.$9h?this.t(d,r):this.s(d,r),d.localAddress&&this.j.set(d.localAddress,()=>{d.end(),r.end()})}s(d,h){h.onClose(()=>d.destroy()),h.onEnd(()=>d.end()),h.onData(l=>d.write(l.buffer)),d.on("data",l=>h.write(m.$ue.wrap(l))),d.resume()}t(d,h){const l=h.socket;l.on("end",()=>d.end()),l.on("close",()=>d.end()),l.on("error",()=>{d.destroy()}),l.pipe(d),d.pipe(l)}}e.$mbc=n;let i=class extends c.$6v{constructor(d,h,l,r,g){super(h,g),this.v=d,this.w=l,this.y=r}isPortPrivileged(d){return(0,c.$4v)(d,this.m,$.OS,N.release())}t(d,h,l,r,g,f,D,p){const v=this.s(h,l);if(v)return++v.refcount,v.value;if((0,c.$Wv)(d))return this.u(d,h,l,g,f,D,p);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${l} on local port ${g}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:d,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=a(y,r,h,l,g);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(h,l,C),C}}};e.$nbc=i,e.$nbc=i=Je([Ve(0,S.$xl),Ve(1,R.$Nj),Ve(2,k.$Al),Ve(3,I.$7j),Ve(4,E.$Ni)],i);let s=class extends i{constructor(d,h,l,r,g){super(d,h,l,r,g)}};e.$obc=s,e.$obc=s=Je([Ve(0,S.$xl),Ve(1,R.$Nj),Ve(2,k.$Al),Ve(3,I.$7j),Ve(4,E.$Ni)],s);let o=class extends b.$Uc{constructor(d,h,l,r,g){super(),this.b=d,this.c=h,this.f=l,this.g=r,this.h=g,this.a=new Map}async openTunnel(d,h,l,r,g,f,D,p,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${f}.`),!this.a.has(d)){const y=new s(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(d,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(d))})}return this.a.get(d).openTunnel(h,l,r,g,f,D,p,v)}};e.$pbc=o,e.$pbc=o=Je([Ve(0,S.$xl),Ve(1,R.$Nj),Ve(2,I.$7j),Ve(3,k.$Al),Ve(4,E.$Ni)],o)}),define(ke[390],Ee([1,0,123,285,51,33,2,12,40]),function(de,e,u,N,M,P,A,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=void 0;class E{constructor(w,S,k){this.b=w,this.c=S,this.f=k,this.a=N.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(S.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,S){const k=(m,a)=>{S.writeHead(m,{"content-type":"application/json"}),S.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},c=[];w.setEncoding("utf8"),w.on("data",m=>c.push(m)),w.on("end",async()=>{try{const m=JSON.parse(c.join(""));let a;switch(m.type){case"open":a=await this.i(m);break;case"openExternal":a=await this.j(m);break;case"status":a=await this.l(m);break;case"extensionManagement":a=await this.k(m);break;default:k(404,`Unknown message type: ${m.type}`);break}k(200,a)}catch(m){const a=m instanceof Error?m.message:JSON.stringify(m);k(500,a),this.c.error("Error while processing pipe request",m)}})}async i(w){const{fileURIs:S,folderURIs:k,forceNewWindow:c,diffMode:m,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:s,waitMarkerFilePath:o,remoteAuthority:t}=w,d=[];if(Array.isArray(k))for(const g of k)try{d.push({folderUri:A.URI.parse(g)})}catch{}if(Array.isArray(S))for(const g of S)try{(0,$.$Mi)(g)?d.push({workspaceUri:A.URI.parse(g)}):d.push({fileUri:A.URI.parse(g)})}catch{}const h=o?A.URI.file(o):void 0,r={forceNewWindow:c,diffMode:m,mergeMode:a,addMode:n,gotoLineMode:s,forceReuseWindow:i,preferNewWindow:!i&&!h&&!n,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",d,r)}async j(w){for(const S of w.uris){const k=A.URI.parse(S),c=k.scheme==="file"?k:S;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const S=c=>c?.map(m=>/\.vsix$/i.test(m)?A.URI.parse(m):m),k={list:w.list,install:S(w.install),uninstall:S(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&M.existsSync(this.f)&&M.unlinkSync(this.f)}}e.$2O=E;let R=class extends E{constructor(w,S){super(w,S,(0,u.$_h)())}};e.$3O=R,e.$3O=R=Je([Ve(0,P.$WO),Ve(1,b.$Nj)],R)}),define(ke[391],Ee([1,0,58,378,372,284,48,359,2,15,7,390,104,317,358]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mlc=void 0;class c extends M.$Nkc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(h,l,r){return h=t(h),n.a.has(h)?n.a.get(h).load(h,$.URI.file((0,w.$Oq)(l.filename)),g=>s.apply(this,[g,l,r])):s.apply(this,arguments)};const o=i._resolveLookupPaths;i._resolveLookupPaths=(d,h)=>o.call(this,t(d),h);const t=d=>{for(const h of n.b){const l=h(d);if(l){d=l;break}}return d}}}class m extends A.$Cjc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async ub(){this.h.createInstance(S.$klc);const n=this.h.invokeFunction(N.$Jkc);if(this.h.createInstance(b.$jlc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(I.$3O);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(k.$llc),await this.h.createInstance(c,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const s=await this.m.getConfigProvider();await(0,P.$ilc)(this.j,s,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}vb(n){return n.main}async wb(n,i,s){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),o=de.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),s.codeLoadingStop()}return o}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const s=n[i];s===null?delete process.env[i]:process.env[i]=s}}}e.$mlc=m}),define(ke[392],Ee([1,0,52,21,4,3,125,11,23,2,31,12,264,64,110,88,389,27,20,69,366]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0,e.$nlc=o,e.$olc=t,e.$plc=d,e.$qlc=h,e.$rlc=r,e.$slc=g,e.$tlc=f;function o(v){const y=v.trim().split(`
`),C=[];return y.forEach(z=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);T&&T.length>=3&&C.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),C.reduce((z,T)=>(z[T.socket]=T,z),{})}function t(...v){const y=[].concat(...v.map(h));return[...new Map(y.filter(C=>C.st==="0A").map(C=>{const O=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:d(O[0]),port:parseInt(O[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function d(v){let y="";if(v.length===8)for(let C=v.length-2;C>=0;C-=2)y+=parseInt(v.substr(C,2),16),C!==0&&(y+=".");else for(let C=0;C<v.length;C+=8){const O=v.substring(C,C+8);let z="";for(let T=8;T>=2;T-=2)z+=O.substring(T-2,T),(T===6||T===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",C+T!==v.length-6&&(y+=":"))}return y}function h(v){const y=v.trim().split(`
`),C=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((T,B,j)=>(T[C[j]||j]=B,T),{}))}function l(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function r(v){const y=v.trim().split(`
`),C=[];return y.forEach(O=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}async function g(v,y,C){const O=C.reduce((T,B)=>(T[B.pid]=B,T),{}),z=[];return v.forEach(({socket:T,ip:B,port:j})=>{const F=y[T]?y[T].pid:void 0,L=F?O[F]?.cmd:void 0;F&&L&&!l(L)&&z.push({host:B,port:j,detail:L,pid:F})}),z}function f(v,y,C){const O=new Map,z=r(y);for(const T of v){const B=C.get(T.port);if(B){O.set(T.port,B);continue}const j=z.find(F=>F.cmd.includes(`${T.port}`));if(j){let F=j,L;do L=z.find(G=>G.ppid===F.pid),L&&(F=L);while(L);O.set(T.port,{host:T.ip,port:T.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else O.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return O}let D=class extends i.$0Ab{constructor(y,C,O,z){super(y,C,O),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new A.$pm;let z=0;for(;this.C;){const T=new Date().getTime(),B=(await this.I()).filter(L=>(0,c.$1v)(L.host)||(0,c.$3v)(L.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${B.map(L=>L.port).join(", ")}`);const j=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),z++>3&&O.update(j),(!C||JSON.stringify(C)!==JSON.stringify(B))&&(C=B,await this.a.$onFoundNewCandidates(C));const F=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(L=>setTimeout(()=>L(),F))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",C="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),C=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(y,C),z=await new Promise(Z=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,_,ue)=>{Z(_)})}),T=o(z),B=await R.Promises.readdir("/proc"),j=[];for(const Z of B)try{const x=Number(Z),_=$.$Ug(E.URI.file("/proc"),Z);if((await R.Promises.stat(_.fsPath)).isDirectory()&&!isNaN(x)){const X=await R.Promises.readlink($.$Ug(_,"cwd").fsPath),$e=await R.Promises.readFile($.$Ug(_,"cmdline").fsPath,"utf8");j.push({pid:x,cwd:X,cmd:$e})}}catch{}const F=[],L=O.filter(Z=>{const x=T[Z.socket];return x||F.push(Z),x}),G=g(L,T,j);let te;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const Z=await new Promise(x=>{(0,u.exec)("ps -F -A -l | grep root",(_,ue,X)=>{x(ue)})});this.z=f(F,Z,this.z),te=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(x=>x.port).join(", ")}`)}return G.then(Z=>te?Z.concat(te):Z)}w(y){return async C=>{const O=new m.$mbc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,B,j,F){const L=await y.makeConnection();return p.connect(L,B,j,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$tl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await O.waitForReady();const z=new M.$7d;return{localAddress:(0,s.$GL)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{O.dispose(),z.fire(),z.dispose()}}}}};e.$ulc=D,e.$ulc=D=Je([Ve(0,n.$AO),Ve(1,a.$QO),Ve(2,I.$Nj),Ve(3,k.$Al)],D);class p extends w.$Utb{static connect(y,C,O,z){const T=new P.$Tc,B={onClose:T.add(new M.$7d),onData:T.add(new M.$7d),onEnd:T.add(new M.$7d)};T.add(y.onDidReceiveMessage(F=>B.onData.fire(N.$ue.wrap(F)))),T.add(y.onDidEnd(()=>B.onEnd.fire())),T.add(y.onDidClose(F=>B.onClose.fire({type:0,error:F,hadError:!!F})));const j=new p(y,z,B);return j.B(T),(0,w.$Ttb)(j,C,O,z,B)}constructor(y,C,O){super(C,O),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[393],Ee([1,0,83,361,376,374,388,391,392,96,48,97,95,47,69,93,360,318,12,377,60,279,106,110,141]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a,n,i,s,o,t,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$es)(R.$Djc,b.$mlc,0),(0,u.$es)(n.$Oj,a.$wlc,1),(0,u.$es)(n.$Nj,new t.$ei(o.$Mkc,[!1],!0)),(0,u.$es)(d.$Al,h.$rbc,1),(0,u.$es)(c.$8ic,m.$vlc,0),(0,u.$es)(E.$Ijc,P.$Zkc,0),(0,u.$es)(I.$5jc,A.$hlc,0),(0,u.$es)(w.$vkc,M.$Rkc,0),(0,u.$es)(S.$qjc,N.$Qkc,0),(0,u.$es)(k.$9Ab,$.$ulc,0),(0,u.$es)(s.$Gjc,i.$xlc,0)}),define(ke[403],Ee([1,0,62,404,58,13,81,123,262,114,373,21,31,104,8,135,286,300,379,393]),function(de,e,u,N,M,P,A,b,$,E,R,I,w,S,k,c,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let f=0;f<process.execArgv.length;f++)process.execArgv[f]==="--inspect-port=0"&&(process.execArgv.splice(f,1),f--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,f=g._load;g._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return f.apply(this,arguments)}})();const i=process.exit.bind(process),s=process.on.bind(process);function o(g){process.exit=function(f){if(g)i(f);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const f=new Error("An extension called process.crash() and this was prevented.");console.warn(f.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(f,D){f==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),s(f,D)}}let t=function(g){i()};function d(){const g=(0,a.$_m)(process.env);if(g.type===3)return new Promise((f,D)=>{const p=v=>{const y=v[0],C=new A.$7h;y.on("message",O=>C.fire(I.$ue.wrap(O.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),f({onMessage:C.event,send:O=>y.postMessage(O.buffer)})};process.parentPort.on("message",v=>p(v.ports))});if(g.type===2)return new Promise((f,D)=>{let p=null;const v=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,C=3e5,O=new k.$uh(()=>t("renderer disconnected for too long (1)"),y),z=new k.$uh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(B,j)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const F=I.$ue.wrap(Buffer.from(B.initialDataChunk,"base64"));let L;if(B.skipWebSocketFrames)L=new b.$9h(j,"extHost-socket");else{const G=I.$ue.wrap(Buffer.from(B.inflateBytes,"base64"));L=new b.$0h(new b.$9h(j,"extHost-socket"),B.permessageDeflate,G,!1)}p?(O.cancel(),z.cancel(),p.beginAcceptReconnection(L,F),p.endAcceptReconnection(),p.sendResume()):(clearTimeout(v),p=new A.$8h({socket:L,initialChunk:F}),p.sendResume(),p.onDidDispose(()=>t("renderer disconnected")),f(p),p.onSocketClose(()=>{O.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;O.isScheduled()&&z.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const f=g.pipeName;return new Promise((D,p)=>{const v=u.createConnection(f,()=>{v.removeListener("error",p);const y=new A.$8h({socket:new b.$9h(v,"extHost-renderer")});y.sendResume(),D(y)});v.once("error",p),v.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const g=await d();return new class{constructor(){this.a=new A.$7h,this.onMessage=this.a.event,this.b=!1,g.onMessage(f=>{(0,E.$Lm)(f,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(f)})}send(f){this.b||g.send(f)}async drain(){if(g.drain)return g.drain()}}}function l(g){return new Promise(f=>{const D=g.onMessage(p=>{D.dispose();const v=JSON.parse(p.toString()),y=v.commit,C=$.default.commit;if(y&&C&&y!==C&&i(55),v.parentPid){let O=0;setInterval(function(){try{process.kill(v.parentPid,0),O=0}catch(T){T&&T.code==="EPERM"?(O++,O>=3&&t(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${v.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(v.parentPid)}catch(T){(0,P.$1)(T)}}g.send((0,E.$Km)(0)),f({protocol:g,initData:v})});g.send((0,E.$Km)(1))})}async function r(){const g=[];process.on("unhandledRejection",(O,z)=>{g.push(z),setTimeout(()=>{const T=g.indexOf(z);T>=0&&z.catch(B=>{g.splice(T,1),(0,P.$4)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),O&&(0,P.$1)(O))})},1e3)}),process.on("rejectionHandled",O=>{const z=g.indexOf(O);z>=0&&g.splice(z,1)}),process.on("uncaughtException",function(O){(0,P.$Z)(O)||(0,P.$1)(O)}),M.mark("code/extHost/willConnectToRenderer");const f=await h();M.mark("code/extHost/didConnectToRenderer");const D=await l(f);M.mark("code/extHost/didWaitForInitData");const{initData:p}=D;o(!!p.environment.extensionTestsLocationURI),p.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,p.environment.skipWorkspaceStorageLock=(0,c.boolean)(n.skipWorkspaceStorageLock,!1);const v=new class{constructor(){this.pid=process.pid}exit(z){i(z)}fsExists(z){return w.Promises.exists(z)}fsRealpath(z){return(0,S.$Nq)(z)}};let y=null;p.remote.authority&&n.transformURIs&&(y=(0,m.$is)(p.remote.authority));const C=new R.$Pkc(D.protocol,p,v,y);t=O=>C.terminate(O)}r().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c3cc8b9948d52f04836997a7de01dbd9bb2a7bf/core/vs/workbench/api/node/extensionHostProcess.js.map
