/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Me=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(me){for(var e=[],S=0,F=me.length;S<F;S++)e[S]=Me[me[S]];return e};define(Me[68],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=F,e.$Mh=M,e.$Nh=N;function S(R){return(m,d,k)=>{let O=null,E=null;if(typeof k.value=="function"?(O="value",E=k.value):typeof k.get=="function"&&(O="get",E=k.get),!E)throw new Error("not supported");k[O]=R(E,d)}}function F(R,m,d){let k=null,O=null;if(typeof d.value=="function"?(k="value",O=d.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(k="get",O=d.get),!O)throw new Error("not supported");const E=`$memoize$${m}`;d[k]=function(...l){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,l)}),this[E]}}function M(R,m,d){return S((k,O)=>{const E=`$debounce$${O}`,l=`$debounce$result$${O}`;return function(...w){this[l]||(this[l]=d?d():void 0),clearTimeout(this[E]),m&&(this[l]=m(this[l],...w),w=[this[l]]),this[E]=setTimeout(()=>{k.apply(this,w),this[l]=d?d():void 0},R)}})}function N(R,m,d){return S((k,O)=>{const E=`$throttle$timer$${O}`,l=`$throttle$result$${O}`,w=`$throttle$lastRun$${O}`,p=`$throttle$pending$${O}`;return function(...r){if(this[l]||(this[l]=d?d():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[p])return;const o=this[w]+R;o<=Date.now()?(this[w]=Date.now(),k.apply(this,[this[l]]),this[l]=d?d():void 0):(this[p]=!0,this[E]=setTimeout(()=>{this[p]=!1,this[w]=Date.now(),k.apply(this,[this[l]]),this[l]=d?d():void 0},o-Date.now()))}})}}),define(Me[90],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0;class S{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$FO=S,e.$GO=new S("id#")}),define(Me[122],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$sn=R,e.$tn=E,e.$un=l,e.$vn=w,e.$wn=p,e.$xn=r,e.$yn=o,e.$zn=s,e.$An=n,e.$Bn=i,e.$Cn=c,e.$Dn=h;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,v=!1){let u=0;const g=t.length;let a="",b=0,f=16,I=0;function $(V){let P=0,L=0;for(;P<V;){const q=t.charCodeAt(u);if(q>=48&&q<=57)L=L*16+q-48;else if(q>=65&&q<=70)L=L*16+q-65+10;else if(q>=97&&q<=102)L=L*16+q-97+10;else break;u++,P++}return P<V&&(L=-1),L}function D(V){u=V,a="",b=0,f=16,I=0}function y(){const V=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&k(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&k(t.charCodeAt(u)))for(u++;u<t.length&&k(t.charCodeAt(u));)u++;else return I=3,t.substring(V,u);let P=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&k(t.charCodeAt(u))){for(u++;u<t.length&&k(t.charCodeAt(u));)u++;P=u}else I=3;return t.substring(V,P)}function C(){let V="",P=u;for(;;){if(u>=g){V+=t.substring(P,u),I=2;break}const L=t.charCodeAt(u);if(L===34){V+=t.substring(P,u),u++;break}if(L===92){if(V+=t.substring(P,u),u++,u>=g){I=2;break}switch(t.charCodeAt(u++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const re=$(4);re>=0?V+=String.fromCharCode(re):I=4;break}default:I=5}P=u;continue}if(L>=0&&L<=31)if(d(L)){V+=t.substring(P,u),I=2;break}else I=6;u++}return V}function A(){if(a="",I=0,b=u,u>=g)return b=g,f=17;let V=t.charCodeAt(u);if(m(V)){do u++,a+=String.fromCharCode(V),V=t.charCodeAt(u);while(m(V));return f=15}if(d(V))return u++,a+=String.fromCharCode(V),V===13&&t.charCodeAt(u)===10&&(u++,a+=`
`),f=14;switch(V){case 123:return u++,f=1;case 125:return u++,f=2;case 91:return u++,f=3;case 93:return u++,f=4;case 58:return u++,f=6;case 44:return u++,f=5;case 34:return u++,a=C(),f=10;case 47:{const P=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<g&&!d(t.charCodeAt(u));)u++;return a=t.substring(P,u),f=12}if(t.charCodeAt(u+1)===42){u+=2;const L=g-1;let q=!1;for(;u<L;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,q=!0;break}u++}return q||(u++,I=1),a=t.substring(P,u),f=13}return a+=String.fromCharCode(V),u++,f=16}case 45:if(a+=String.fromCharCode(V),u++,u===g||!k(t.charCodeAt(u)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=y(),f=11;default:for(;u<g&&G(V);)u++,V=t.charCodeAt(u);if(b!==u){switch(a=t.substring(b,u),a){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return a+=String.fromCharCode(V),u++,f=16}}function G(V){if(m(V)||d(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let V;do V=A();while(V>=12&&V<=15);return V}return{setPosition:D,getPosition:()=>u,scan:v?T:A,getToken:()=>f,getTokenValue:()=>a,getTokenOffset:()=>b,getTokenLength:()=>u-b,getTokenError:()=>I}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function E(t,v){const u=[],g=new Object;let a;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function I($,D,y,C){b.value=$,b.offset=D,b.length=y,b.type=C,b.colonOffset=void 0,a=b}try{i(t,{onObjectBegin:($,D)=>{if(v<=$)throw g;a=void 0,f=v>$,u.push("")},onObjectProperty:($,D,y)=>{if(v<D||(I($,D,y,"property"),u[u.length-1]=$,v<=D+y))throw g},onObjectEnd:($,D)=>{if(v<=$)throw g;a=void 0,u.pop()},onArrayBegin:($,D)=>{if(v<=$)throw g;a=void 0,u.push(0)},onArrayEnd:($,D)=>{if(v<=$)throw g;a=void 0,u.pop()},onLiteralValue:($,D,y)=>{if(v<D||(I($,D,y,h($)),v<=D+y))throw g},onSeparator:($,D,y)=>{if(v<=D)throw g;if($===":"&&a&&a.type==="property")a.colonOffset=D,f=!1,a=void 0;else if($===","){const C=u[u.length-1];typeof C=="number"?u[u.length-1]=C+1:(f=!0,u[u.length-1]=""),a=void 0}}})}catch($){if($!==g)throw $}return{path:u,previousNode:a,isAtPropertyKey:f,matches:$=>{let D=0;for(let y=0;D<$.length&&y<u.length;y++)if($[D]===u[y]||$[D]==="*")D++;else if($[D]!=="**")return!1;return D===$.length}}}function l(t,v=[],u=N.DEFAULT){let g=null,a=[];const b=[];function f($){Array.isArray(a)?a.push($):g!==null&&(a[g]=$)}return i(t,{onObjectBegin:()=>{const $={};f($),b.push(a),a=$,g=null},onObjectProperty:$=>{g=$},onObjectEnd:()=>{a=b.pop()},onArrayBegin:()=>{const $=[];f($),b.push(a),a=$,g=null},onArrayEnd:()=>{a=b.pop()},onLiteralValue:f,onError:($,D,y)=>{v.push({error:$,offset:D,length:y})}},u),a[0]}function w(t,v=[],u=N.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a($){g.type==="property"&&(g.length=$-g.offset,g=g.parent)}function b($){return g.children.push($),$}i(t,{onObjectBegin:$=>{g=b({type:"object",offset:$,length:-1,parent:g,children:[]})},onObjectProperty:($,D,y)=>{g=b({type:"property",offset:D,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:$,offset:D,length:y,parent:g})},onObjectEnd:($,D)=>{g.length=$+D-g.offset,g=g.parent,a($+D)},onArrayBegin:($,D)=>{g=b({type:"array",offset:$,length:-1,parent:g,children:[]})},onArrayEnd:($,D)=>{g.length=$+D-g.offset,g=g.parent,a($+D)},onLiteralValue:($,D,y)=>{b({type:h($),offset:D,length:y,parent:g,value:$}),a(D+y)},onSeparator:($,D,y)=>{g.type==="property"&&($===":"?g.colonOffset=D:$===","&&a(D))},onError:($,D,y)=>{v.push({error:$,offset:D,length:y})}},u);const I=g.children[0];return I&&delete I.parent,I}function p(t,v){if(!t)return;let u=t;for(const g of v)if(typeof g=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let a=!1;for(const b of u.children)if(Array.isArray(b.children)&&b.children[0].value===g){u=b.children[1],a=!0;break}if(!a)return}else{const a=g;if(u.type!=="array"||a<0||!Array.isArray(u.children)||a>=u.children.length)return;u=u.children[a]}return u}function r(t){if(!t.parent||!t.parent.children)return[];const v=r(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;v.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&v.push(u)}return v}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const v=Object.create(null);for(const u of t.children){const g=u.children[1];g&&(v[u.children[0].value]=o(g))}return v}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,v,u=!1){return v>=t.offset&&v<t.offset+t.length||u&&v===t.offset+t.length}function n(t,v,u=!1){if(s(t,v,u)){const g=t.children;if(Array.isArray(g))for(let a=0;a<g.length&&g[a].offset<=v;a++){const b=n(g[a],v,u);if(b)return b}return t}}function i(t,v,u=N.DEFAULT){const g=R(t,!1);function a(_){return _?()=>_(g.getTokenOffset(),g.getTokenLength()):()=>!0}function b(_){return _?ve=>_(ve,g.getTokenOffset(),g.getTokenLength()):()=>!0}const f=a(v.onObjectBegin),I=b(v.onObjectProperty),$=a(v.onObjectEnd),D=a(v.onArrayBegin),y=a(v.onArrayEnd),C=b(v.onLiteralValue),A=b(v.onSeparator),G=a(v.onComment),T=b(v.onError),V=u&&u.disallowComments,P=u&&u.allowTrailingComma;function L(){for(;;){const _=g.scan();switch(g.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:V||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(_){case 12:case 13:V?q(10):G();break;case 16:q(1);break;case 15:case 14:break;default:return _}}}function q(_,ve=[],ne=[]){if(T(_),ve.length+ne.length>0){let fe=g.getToken();for(;fe!==17;){if(ve.indexOf(fe)!==-1){L();break}else if(ne.indexOf(fe)!==-1)break;fe=L()}}}function re(_){const ve=g.getTokenValue();return _?C(ve):I(ve),L(),!0}function ue(){switch(g.getToken()){case 11:{let _=0;try{_=JSON.parse(g.getTokenValue()),typeof _!="number"&&(q(2),_=0)}catch{q(2)}C(_);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return L(),!0}function ye(){return g.getToken()!==10?(q(3,[],[2,5]),!1):(re(!1),g.getToken()===6?(A(":"),L(),we()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Se(){f(),L();let _=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(_||q(4,[],[]),A(","),L(),g.getToken()===2&&P)break}else _&&q(6,[],[]);ye()||q(4,[],[2,5]),_=!0}return $(),g.getToken()!==2?q(7,[2],[]):L(),!0}function le(){D(),L();let _=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(_||q(4,[],[]),A(","),L(),g.getToken()===4&&P)break}else _&&q(6,[],[]);we()||q(4,[],[4,5]),_=!0}return y(),g.getToken()!==4?q(8,[4],[]):L(),!0}function we(){switch(g.getToken()){case 3:return le();case 1:return Se();case 10:return re(!0);default:return ue()}}return L(),g.getToken()===17?u.allowEmptyContent?!0:(q(4,[],[]),!1):we()?(g.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}function c(t,v){const u=R(t),g=[];let a,b=0,f;do switch(f=u.getPosition(),a=u.scan(),a){case 12:case 13:case 17:b!==f&&g.push(t.substring(b,f)),v!==void 0&&g.push(u.getTokenValue().replace(/[^\r\n]/g,v)),b=u.getPosition();break}while(a!==17);return g.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(me,e){typeof define=="function"&&define.amd?define(Me[123],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Ie,pe){for(var ge=0;ge<pe.length;ge++){var J=pe[ge];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Ie,J.key,J)}}function S(Ie,pe,ge){return pe&&e(Ie.prototype,pe),ge&&e(Ie,ge),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function F(Ie,pe){if(Ie){if(typeof Ie=="string")return M(Ie,pe);var ge=Object.prototype.toString.call(Ie).slice(8,-1);if(ge==="Object"&&Ie.constructor&&(ge=Ie.constructor.name),ge==="Map"||ge==="Set")return Array.from(Ie);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return M(Ie,pe)}}function M(Ie,pe){(pe==null||pe>Ie.length)&&(pe=Ie.length);for(var ge=0,J=new Array(pe);ge<pe;ge++)J[ge]=Ie[ge];return J}function N(Ie,pe){var ge=typeof Symbol<"u"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ge)return(ge=ge.call(Ie)).next.bind(ge);if(Array.isArray(Ie)||(ge=F(Ie))||pe&&Ie&&typeof Ie.length=="number"){ge&&(Ie=ge);var J=0;return function(){return J>=Ie.length?{done:!0}:{done:!1,value:Ie[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function m(Ie){me.defaults=Ie}var d=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(pe){return l[pe]};function p(Ie,pe){if(pe){if(d.test(Ie))return Ie.replace(k,w)}else if(O.test(Ie))return Ie.replace(E,w);return Ie}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ie){return Ie.replace(r,function(pe,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(Ie,pe){Ie=typeof Ie=="string"?Ie:Ie.source,pe=pe||"";var ge={replace:function(X,ce){return ce=ce.source||ce,ce=ce.replace(s,"$1"),Ie=Ie.replace(X,ce),ge},getRegex:function(){return new RegExp(Ie,pe)}};return ge}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ie,pe,ge){if(Ie){var J;try{J=decodeURIComponent(o(ge)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}pe&&!c.test(ge)&&(ge=a(pe,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},v=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(Ie,pe){t[" "+Ie]||(v.test(Ie)?t[" "+Ie]=Ie+"/":t[" "+Ie]=$(Ie,"/",!0)),Ie=t[" "+Ie];var ge=Ie.indexOf(":")===-1;return pe.substring(0,2)==="//"?ge?pe:Ie.replace(u,"$1")+pe:pe.charAt(0)==="/"?ge?pe:Ie.replace(g,"$1")+pe:Ie+pe}var b={exec:function(){}};function f(Ie){for(var pe=1,ge,J;pe<arguments.length;pe++){ge=arguments[pe];for(J in ge)Object.prototype.hasOwnProperty.call(ge,J)&&(Ie[J]=ge[J])}return Ie}function I(Ie,pe){var ge=Ie.replace(/\|/g,function(ce,de,Oe){for(var he=!1,Ce=de;--Ce>=0&&Oe[Ce]==="\\";)he=!he;return he?"|":" |"}),J=ge.split(/ \|/),X=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>pe)J.splice(pe);else for(;J.length<pe;)J.push("");for(;X<J.length;X++)J[X]=J[X].trim().replace(/\\\|/g,"|");return J}function $(Ie,pe,ge){var J=Ie.length;if(J===0)return"";for(var X=0;X<J;){var ce=Ie.charAt(J-X-1);if(ce===pe&&!ge)X++;else if(ce!==pe&&ge)X++;else break}return Ie.slice(0,J-X)}function D(Ie,pe){if(Ie.indexOf(pe[1])===-1)return-1;for(var ge=Ie.length,J=0,X=0;X<ge;X++)if(Ie[X]==="\\")X++;else if(Ie[X]===pe[0])J++;else if(Ie[X]===pe[1]&&(J--,J<0))return X;return-1}function y(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Ie,pe){if(pe<1)return"";for(var ge="";pe>1;)pe&1&&(ge+=Ie),pe>>=1,Ie+=Ie;return ge+Ie}function A(Ie,pe,ge,J){var X=pe.href,ce=pe.title?p(pe.title):null,de=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){J.state.inLink=!0;var Oe={type:"link",raw:ge,href:X,title:ce,text:de,tokens:J.inlineTokens(de)};return J.state.inLink=!1,Oe}return{type:"image",raw:ge,href:X,title:ce,text:p(de)}}function G(Ie,pe){var ge=Ie.match(/^(\s+)(?:```)/);if(ge===null)return pe;var J=ge[1];return pe.split(`
`).map(function(X){var ce=X.match(/^\s+/);if(ce===null)return X;var de=ce[0];return de.length>=J.length?X.slice(J.length):X}).join(`
`)}var T=function(){function Ie(ge){this.options=ge||me.defaults}var pe=Ie.prototype;return pe.space=function(J){var X=this.rules.block.newline.exec(J);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},pe.code=function(J){var X=this.rules.block.code.exec(J);if(X){var ce=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:$(ce,`
`)}}},pe.fences=function(J){var X=this.rules.block.fences.exec(J);if(X){var ce=X[0],de=G(ce,X[3]||"");return{type:"code",raw:ce,lang:X[2]?X[2].trim():X[2],text:de}}},pe.heading=function(J){var X=this.rules.block.heading.exec(J);if(X){var ce=X[2].trim();if(/#$/.test(ce)){var de=$(ce,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ce=de.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:ce,tokens:this.lexer.inline(ce)}}},pe.hr=function(J){var X=this.rules.block.hr.exec(J);if(X)return{type:"hr",raw:X[0]}},pe.blockquote=function(J){var X=this.rules.block.blockquote.exec(J);if(X){var ce=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(ce,[]),text:ce}}},pe.list=function(J){var X=this.rules.block.list.exec(J);if(X){var ce,de,Oe,he,Ce,Ae,Le,U,z,K,H,ee,se=X[1].trim(),Ne=se.length>1,Ve={type:"list",raw:"",ordered:Ne,start:Ne?+se.slice(0,-1):"",loose:!1,items:[]};se=Ne?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Ne?se:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ee=!1,!(!(X=Ye.exec(J))||this.rules.block.hr.test(J)));){if(ce=X[0],J=J.substring(ce.length),U=X[2].split(`
`,1)[0],z=J.split(`
`,1)[0],this.options.pedantic?(he=2,H=U.trimLeft()):(he=X[2].search(/[^ ]/),he=he>4?1:he,H=U.slice(he),he+=X[1].length),Ae=!1,!U&&/^ *$/.test(z)&&(ce+=z+`
`,J=J.substring(z.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");J&&(K=J.split(`
`,1)[0],U=K,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(U)||rt.test(U)||xe.test(U)||et.test(J)));){if(U.search(/[^ ]/)>=he||!U.trim())H+=`
`+U.slice(he);else if(!Ae)H+=`
`+U;else break;!Ae&&!U.trim()&&(Ae=!0),ce+=K+`
`,J=J.substring(K.length+1)}Ve.loose||(Le?Ve.loose=!0:/\n *\n *$/.test(ce)&&(Le=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(H),de&&(Oe=de[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ce,task:!!de,checked:Oe,loose:!1,text:H}),Ve.raw+=ce}Ve.items[Ve.items.length-1].raw=ce.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var tt=Ve.items.length;for(Ce=0;Ce<tt;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var st=Ve.items[Ce].tokens.filter(function(it){return it.type==="space"}),Be=st.every(function(it){for(var Q=it.raw.split(""),Z=0,$e=N(Q),We;!(We=$e()).done;){var Qe=We.value;if(Qe===`
`&&(Z+=1),Z>1)return!0}return!1});!Ve.loose&&st.length&&Be&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},pe.html=function(J){var X=this.rules.block.html.exec(J);if(X){var ce={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(X[0]):p(X[0]);ce.type="paragraph",ce.text=de,ce.tokens=this.lexer.inline(de)}return ce}},pe.def=function(J){var X=this.rules.block.def.exec(J);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var ce=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ce,raw:X[0],href:X[2],title:X[3]}}},pe.table=function(J){var X=this.rules.block.table.exec(J);if(X){var ce={type:"table",header:I(X[1]).map(function(Le){return{text:Le}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=X[0];var de=ce.align.length,Oe,he,Ce,Ae;for(Oe=0;Oe<de;Oe++)/^ *-+: *$/.test(ce.align[Oe])?ce.align[Oe]="right":/^ *:-+: *$/.test(ce.align[Oe])?ce.align[Oe]="center":/^ *:-+ *$/.test(ce.align[Oe])?ce.align[Oe]="left":ce.align[Oe]=null;for(de=ce.rows.length,Oe=0;Oe<de;Oe++)ce.rows[Oe]=I(ce.rows[Oe],ce.header.length).map(function(Le){return{text:Le}});for(de=ce.header.length,he=0;he<de;he++)ce.header[he].tokens=this.lexer.inline(ce.header[he].text);for(de=ce.rows.length,he=0;he<de;he++)for(Ae=ce.rows[he],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return ce}}},pe.lheading=function(J){var X=this.rules.block.lheading.exec(J);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},pe.paragraph=function(J){var X=this.rules.block.paragraph.exec(J);if(X){var ce=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:ce,tokens:this.lexer.inline(ce)}}},pe.text=function(J){var X=this.rules.block.text.exec(J);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},pe.escape=function(J){var X=this.rules.inline.escape.exec(J);if(X)return{type:"escape",raw:X[0],text:p(X[1])}},pe.tag=function(J){var X=this.rules.inline.tag.exec(J);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):p(X[0]):X[0]}},pe.link=function(J){var X=this.rules.inline.link.exec(J);if(X){var ce=X[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var de=$(ce.slice(0,-1),"\\");if((ce.length-de.length)%2===0)return}else{var Oe=D(X[2],"()");if(Oe>-1){var he=X[0].indexOf("!")===0?5:4,Ce=he+X[1].length+Oe;X[2]=X[2].substring(0,Oe),X[0]=X[0].substring(0,Ce).trim(),X[3]=""}}var Ae=X[2],Le="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);U&&(Ae=U[1],Le=U[3])}else Le=X[3]?X[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ce)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),A(X,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},pe.reflink=function(J,X){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var de=(ce[2]||ce[1]).replace(/\s+/g," ");if(de=X[de.toLowerCase()],!de||!de.href){var Oe=ce[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return A(ce,de,ce[0],this.lexer)}},pe.emStrong=function(J,X,ce){ce===void 0&&(ce="");var de=this.rules.inline.emStrong.lDelim.exec(J);if(de&&!(de[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=de[1]||de[2]||"";if(!Oe||Oe&&(ce===""||this.rules.inline.punctuation.exec(ce))){var he=de[0].length-1,Ce,Ae,Le=he,U=0,z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,X=X.slice(-1*J.length+he);(de=z.exec(X))!=null;)if(Ce=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ce){if(Ae=Ce.length,de[3]||de[4]){Le+=Ae;continue}else if((de[5]||de[6])&&he%3&&!((he+Ae)%3)){U+=Ae;continue}if(Le-=Ae,!(Le>0)){if(Ae=Math.min(Ae,Ae+Le+U),Math.min(he,Ae)%2){var K=J.slice(1,he+de.index+Ae);return{type:"em",raw:J.slice(0,he+de.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=J.slice(2,he+de.index+Ae-1);return{type:"strong",raw:J.slice(0,he+de.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},pe.codespan=function(J){var X=this.rules.inline.code.exec(J);if(X){var ce=X[2].replace(/\n/g," "),de=/[^ ]/.test(ce),Oe=/^ /.test(ce)&&/ $/.test(ce);return de&&Oe&&(ce=ce.substring(1,ce.length-1)),ce=p(ce,!0),{type:"codespan",raw:X[0],text:ce}}},pe.br=function(J){var X=this.rules.inline.br.exec(J);if(X)return{type:"br",raw:X[0]}},pe.del=function(J){var X=this.rules.inline.del.exec(J);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},pe.autolink=function(J,X){var ce=this.rules.inline.autolink.exec(J);if(ce){var de,Oe;return ce[2]==="@"?(de=p(this.options.mangle?X(ce[1]):ce[1]),Oe="mailto:"+de):(de=p(ce[1]),Oe=de),{type:"link",raw:ce[0],text:de,href:Oe,tokens:[{type:"text",raw:de,text:de}]}}},pe.url=function(J,X){var ce;if(ce=this.rules.inline.url.exec(J)){var de,Oe;if(ce[2]==="@")de=p(this.options.mangle?X(ce[0]):ce[0]),Oe="mailto:"+de;else{var he;do he=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(he!==ce[0]);de=p(ce[0]),ce[1]==="www."?Oe="http://"+de:Oe=de}return{type:"link",raw:ce[0],text:de,href:Oe,tokens:[{type:"text",raw:de,text:de}]}}},pe.inlineText=function(J,X){var ce=this.rules.inline.text.exec(J);if(ce){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):p(ce[0]):ce[0]:de=p(this.options.smartypants?X(ce[0]):ce[0]),{type:"text",raw:ce[0],text:de}}},Ie}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=n(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=n(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=n(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=n(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=n(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=n(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=f({},V),V.gfm=f({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=n(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=n(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=f({},V.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:n(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=n(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=n(V._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=n(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=n(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=n(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=n(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=n(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=n(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=n(P.reflink).replace("label",P._label).replace("ref",V._label).getRegex(),P.nolink=n(P.nolink).replace("ref",V._label).getRegex(),P.reflinkSearch=n(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=f({},P),P.pedantic=f({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=f({},P.normal,{escape:n(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=n(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=f({},P.gfm,{br:n(P.br).replace("{2,}","*").getRegex(),text:n(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Ie){var pe="",ge,J,X=Ie.length;for(ge=0;ge<X;ge++)J=Ie.charCodeAt(ge),Math.random()>.5&&(J="x"+J.toString(16)),pe+="&#"+J+";";return pe}var re=function(){function Ie(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:V.normal,inline:P.normal};this.options.pedantic?(J.block=V.pedantic,J.inline=P.pedantic):this.options.gfm&&(J.block=V.gfm,this.options.breaks?J.inline=P.breaks:J.inline=P.gfm),this.tokenizer.rules=J}Ie.lex=function(J,X){var ce=new Ie(X);return ce.lex(J)},Ie.lexInline=function(J,X){var ce=new Ie(X);return ce.inlineTokens(J)};var pe=Ie.prototype;return pe.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},pe.blockTokens=function(J,X){var ce=this;X===void 0&&(X=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Le,U,z){return U+"    ".repeat(z.length)});for(var de,Oe,he,Ce;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Le){return(de=Le.call({lexer:ce},J,X))?(J=J.substring(de.raw.length),X.push(de),!0):!1}))){if(de=this.tokenizer.space(J)){J=J.substring(de.raw.length),de.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(de);continue}if(de=this.tokenizer.code(J)){J=J.substring(de.raw.length),Oe=X[X.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+de.raw,Oe.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):X.push(de);continue}if(de=this.tokenizer.fences(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.heading(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.hr(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.blockquote(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.list(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.html(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.def(J)){J=J.substring(de.raw.length),Oe=X[X.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+de.raw,Oe.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.lheading(J)){J=J.substring(de.raw.length),X.push(de);continue}if(he=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Le=1/0,U=J.slice(1),z=void 0;ce.options.extensions.startBlock.forEach(function(K){z=K.call({lexer:this},U),typeof z=="number"&&z>=0&&(Le=Math.min(Le,z))}),Le<1/0&&Le>=0&&(he=J.substring(0,Le+1))}(),this.state.top&&(de=this.tokenizer.paragraph(he))){Oe=X[X.length-1],Ce&&Oe.type==="paragraph"?(Oe.raw+=`
`+de.raw,Oe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):X.push(de),Ce=he.length!==J.length,J=J.substring(de.raw.length);continue}if(de=this.tokenizer.text(J)){J=J.substring(de.raw.length),Oe=X[X.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+de.raw,Oe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):X.push(de);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,X},pe.inline=function(J,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:J,tokens:X}),X},pe.inlineTokens=function(J,X){var ce=this;X===void 0&&(X=[]);var de,Oe,he,Ce=J,Ae,Le,U;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)z.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Le||(U=""),Le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(de=H.call({lexer:ce},J,X))?(J=J.substring(de.raw.length),X.push(de),!0):!1}))){if(de=this.tokenizer.escape(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.tag(J)){J=J.substring(de.raw.length),Oe=X[X.length-1],Oe&&de.type==="text"&&Oe.type==="text"?(Oe.raw+=de.raw,Oe.text+=de.text):X.push(de);continue}if(de=this.tokenizer.link(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(de.raw.length),Oe=X[X.length-1],Oe&&de.type==="text"&&Oe.type==="text"?(Oe.raw+=de.raw,Oe.text+=de.text):X.push(de);continue}if(de=this.tokenizer.emStrong(J,Ce,U)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.codespan(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.br(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.del(J)){J=J.substring(de.raw.length),X.push(de);continue}if(de=this.tokenizer.autolink(J,q)){J=J.substring(de.raw.length),X.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(J,q))){J=J.substring(de.raw.length),X.push(de);continue}if(he=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=J.slice(1),se=void 0;ce.options.extensions.startInline.forEach(function(Ne){se=Ne.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(he=J.substring(0,H+1))}(),de=this.tokenizer.inlineText(he,L)){J=J.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(U=de.raw.slice(-1)),Le=!0,Oe=X[X.length-1],Oe&&Oe.type==="text"?(Oe.raw+=de.raw,Oe.text+=de.text):X.push(de);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return X},S(Ie,null,[{key:"rules",get:function(){return{block:V,inline:P}}}]),Ie}(),ue=function(){function Ie(ge){this.options=ge||me.defaults}var pe=Ie.prototype;return pe.code=function(J,X,ce){var de=(X||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(J,de);Oe!=null&&Oe!==J&&(ce=!0,J=Oe)}return J=J.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+p(de,!0)+'">'+(ce?J:p(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:p(J,!0))+`</code></pre>
`},pe.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},pe.html=function(J){return J},pe.heading=function(J,X,ce,de){if(this.options.headerIds){var Oe=this.options.headerPrefix+de.slug(ce);return"<h"+X+' id="'+Oe+'">'+J+"</h"+X+`>
`}return"<h"+X+">"+J+"</h"+X+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(J,X,ce){var de=X?"ol":"ul",Oe=X&&ce!==1?' start="'+ce+'"':"";return"<"+de+Oe+`>
`+J+"</"+de+`>
`},pe.listitem=function(J){return"<li>"+J+`</li>
`},pe.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(J){return"<p>"+J+`</p>
`},pe.table=function(J,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+X+`</table>
`},pe.tablerow=function(J){return`<tr>
`+J+`</tr>
`},pe.tablecell=function(J,X){var ce=X.header?"th":"td",de=X.align?"<"+ce+' align="'+X.align+'">':"<"+ce+">";return de+J+("</"+ce+`>
`)},pe.strong=function(J){return"<strong>"+J+"</strong>"},pe.em=function(J){return"<em>"+J+"</em>"},pe.codespan=function(J){return"<code>"+J+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(J){return"<del>"+J+"</del>"},pe.link=function(J,X,ce){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var de='<a href="'+p(J)+'"';return X&&(de+=' title="'+X+'"'),de+=">"+ce+"</a>",de},pe.image=function(J,X,ce){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var de='<img src="'+J+'" alt="'+ce+'"';return X&&(de+=' title="'+X+'"'),de+=this.options.xhtml?"/>":">",de},pe.text=function(J){return J},Ie}(),ye=function(){function Ie(){}var pe=Ie.prototype;return pe.strong=function(J){return J},pe.em=function(J){return J},pe.codespan=function(J){return J},pe.del=function(J){return J},pe.html=function(J){return J},pe.text=function(J){return J},pe.link=function(J,X,ce){return""+ce},pe.image=function(J,X,ce){return""+ce},pe.br=function(){return""},Ie}(),Se=function(){function Ie(){this.seen={}}var pe=Ie.prototype;return pe.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(J,X){var ce=J,de=0;if(this.seen.hasOwnProperty(ce)){de=this.seen[J];do de++,ce=J+"-"+de;while(this.seen.hasOwnProperty(ce))}return X||(this.seen[J]=de,this.seen[ce]=0),ce},pe.slug=function(J,X){X===void 0&&(X={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,X.dryrun)},Ie}(),le=function(){function Ie(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Se}Ie.parse=function(J,X){var ce=new Ie(X);return ce.parse(J)},Ie.parseInline=function(J,X){var ce=new Ie(X);return ce.parseInline(J)};var pe=Ie.prototype;return pe.parse=function(J,X){X===void 0&&(X=!0);var ce="",de,Oe,he,Ce,Ae,Le,U,z,K,H,ee,se,Ne,Ve,Ye,xe,et,ot,rt,tt=J.length;for(de=0;de<tt;de++){if(H=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(rt=this.options.extensions.renderers[H.type].call({parser:this},H),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){ce+=rt||"";continue}switch(H.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(z="",U="",Ce=H.header.length,Oe=0;Oe<Ce;Oe++)U+=this.renderer.tablecell(this.parseInline(H.header[Oe].tokens),{header:!0,align:H.align[Oe]});for(z+=this.renderer.tablerow(U),K="",Ce=H.rows.length,Oe=0;Oe<Ce;Oe++){for(Le=H.rows[Oe],U="",Ae=Le.length,he=0;he<Ae;he++)U+=this.renderer.tablecell(this.parseInline(Le[he].tokens),{header:!1,align:H.align[he]});K+=this.renderer.tablerow(U)}ce+=this.renderer.table(z,K);continue}case"blockquote":{K=this.parse(H.tokens),ce+=this.renderer.blockquote(K);continue}case"list":{for(ee=H.ordered,se=H.start,Ne=H.loose,Ce=H.items.length,K="",Oe=0;Oe<Ce;Oe++)Ye=H.items[Oe],xe=Ye.checked,et=Ye.task,Ve="",Ye.task&&(ot=this.renderer.checkbox(xe),Ne?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=ot+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=ot+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:ot}):Ve+=ot),Ve+=this.parse(Ye.tokens,Ne),K+=this.renderer.listitem(Ve,et,xe);ce+=this.renderer.list(K,ee,se);continue}case"html":{ce+=this.renderer.html(H.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;de+1<tt&&J[de+1].type==="text";)H=J[++de],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);ce+=X?this.renderer.paragraph(K):K;continue}default:{var st='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return ce},pe.parseInline=function(J,X){X=X||this.renderer;var ce="",de,Oe,he,Ce=J.length;for(de=0;de<Ce;de++){if(Oe=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(he=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){ce+=he||"";continue}switch(Oe.type){case"escape":{ce+=X.text(Oe.text);break}case"html":{ce+=X.html(Oe.text);break}case"link":{ce+=X.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,X));break}case"image":{ce+=X.image(Oe.href,Oe.title,Oe.text);break}case"strong":{ce+=X.strong(this.parseInline(Oe.tokens,X));break}case"em":{ce+=X.em(this.parseInline(Oe.tokens,X));break}case"codespan":{ce+=X.codespan(Oe.text);break}case"br":{ce+=X.br();break}case"del":{ce+=X.del(this.parseInline(Oe.tokens,X));break}case"text":{ce+=X.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ce},Ie}();function we(Ie,pe,ge){if(typeof Ie>"u"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof pe=="function"&&(ge=pe,pe=null),pe=f({},we.defaults,pe||{}),y(pe),ge){var J=pe.highlight,X;try{X=re.lex(Ie,pe)}catch(Ce){return ge(Ce)}var ce=function(Ae){var Le;if(!Ae)try{pe.walkTokens&&we.walkTokens(X,pe.walkTokens),Le=le.parse(X,pe)}catch(U){Ae=U}return pe.highlight=J,Ae?ge(Ae):ge(null,Le)};if(!J||J.length<3||(delete pe.highlight,!X.length))return ce();var de=0;we.walkTokens(X,function(Ce){Ce.type==="code"&&(de++,setTimeout(function(){J(Ce.text,Ce.lang,function(Ae,Le){if(Ae)return ce(Ae);Le!=null&&Le!==Ce.text&&(Ce.text=Le,Ce.escaped=!0),de--,de===0&&ce()})},0))}),de===0&&ce();return}function Oe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+p(Ce.message+"",!0)+"</pre>";throw Ce}try{var he=re.lex(Ie,pe);if(pe.walkTokens){if(pe.async)return Promise.all(we.walkTokens(he,pe.walkTokens)).then(function(){return le.parse(he,pe)}).catch(Oe);we.walkTokens(he,pe.walkTokens)}return le.parse(he,pe)}catch(Ce){Oe(Ce)}}we.options=we.setOptions=function(Ie){return f(we.defaults,Ie),m(we.defaults),we},we.getDefaults=R,we.defaults=me.defaults,we.use=function(){for(var Ie=arguments.length,pe=new Array(Ie),ge=0;ge<Ie;ge++)pe[ge]=arguments[ge];var J=f.apply(void 0,[{}].concat(pe)),X=we.defaults.extensions||{renderers:{},childTokens:{}},ce;pe.forEach(function(de){if(de.extensions&&(ce=!0,de.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=X.renderers?X.renderers[he.name]:null;Ce?X.renderers[he.name]=function(){for(var Ae=arguments.length,Le=new Array(Ae),U=0;U<Ae;U++)Le[U]=arguments[U];var z=he.renderer.apply(this,Le);return z===!1&&(z=Ce.apply(this,Le)),z}:X.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[he.level]?X[he.level].unshift(he.tokenizer):X[he.level]=[he.tokenizer],he.start&&(he.level==="block"?X.startBlock?X.startBlock.push(he.start):X.startBlock=[he.start]:he.level==="inline"&&(X.startInline?X.startInline.push(he.start):X.startInline=[he.start]))}he.childTokens&&(X.childTokens[he.name]=he.childTokens)})),de.renderer&&function(){var he=we.defaults.renderer||new ue,Ce=function(U){var z=he[U];he[U]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=de.renderer[U].apply(he,H);return se===!1&&(se=z.apply(he,H)),se}};for(var Ae in de.renderer)Ce(Ae);J.renderer=he}(),de.tokenizer&&function(){var he=we.defaults.tokenizer||new T,Ce=function(U){var z=he[U];he[U]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=de.tokenizer[U].apply(he,H);return se===!1&&(se=z.apply(he,H)),se}};for(var Ae in de.tokenizer)Ce(Ae);J.tokenizer=he}(),de.walkTokens){var Oe=we.defaults.walkTokens;J.walkTokens=function(he){var Ce=[];return Ce.push(de.walkTokens.call(this,he)),Oe&&(Ce=Ce.concat(Oe.call(this,he))),Ce}}ce&&(J.extensions=X),we.setOptions(J)})},we.walkTokens=function(Ie,pe){for(var ge=[],J=function(){var Oe=ce.value;switch(ge=ge.concat(pe.call(we,Oe)),Oe.type){case"table":{for(var he=N(Oe.header),Ce;!(Ce=he()).done;){var Ae=Ce.value;ge=ge.concat(we.walkTokens(Ae.tokens,pe))}for(var Le=N(Oe.rows),U;!(U=Le()).done;)for(var z=U.value,K=N(z),H;!(H=K()).done;){var ee=H.value;ge=ge.concat(we.walkTokens(ee.tokens,pe))}break}case"list":{ge=ge.concat(we.walkTokens(Oe.items,pe));break}default:we.defaults.extensions&&we.defaults.extensions.childTokens&&we.defaults.extensions.childTokens[Oe.type]?we.defaults.extensions.childTokens[Oe.type].forEach(function(se){ge=ge.concat(we.walkTokens(Oe[se],pe))}):Oe.tokens&&(ge=ge.concat(we.walkTokens(Oe.tokens,pe)))}},X=N(Ie),ce;!(ce=X()).done;)J();return ge},we.parseInline=function(Ie,pe){if(typeof Ie>"u"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");pe=f({},we.defaults,pe||{}),y(pe);try{var ge=re.lexInline(Ie,pe);return pe.walkTokens&&we.walkTokens(ge,pe.walkTokens),le.parseInline(ge,pe)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+p(J.message+"",!0)+"</pre>";throw J}},we.Parser=le,we.parser=le.parse,we.Renderer=ue,we.TextRenderer=ye,we.Lexer=re,we.lexer=re.lex,we.Tokenizer=T,we.Slugger=Se,we.parse=we;var _=we.options,ve=we.setOptions,ne=we.use,fe=we.walkTokens,W=we.parseInline,te=we,Ee=le.parse,Te=re.lex;me.Lexer=re,me.Parser=le,me.Renderer=ue,me.Slugger=Se,me.TextRenderer=ye,me.Tokenizer=T,me.getDefaults=R,me.lexer=Te,me.marked=we,me.options=_,me.parse=te,me.parseInline=W,me.parser=Ee,me.setOptions=ve,me.use=ne,me.walkTokens=fe,Object.defineProperty(me,"__esModule",{value:!0})}),define(Me[124],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=S;function S(r){const o=N(r);if(o&&o.length>0)return new Uint32Array(o)}let F=0;const M=new Uint32Array(10);function N(r){if(F=0,R(r,E,4352),F>0||(R(r,l,4449),F>0)||(R(r,w,4520),F>0)||(R(r,p,12593),F))return M.subarray(0,F);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,n=Math.floor(o/588),i=Math.floor(s/28),c=s%28-1;if(n<E.length?R(n,E,0):4352+n-12593<p.length&&R(4352+n,p,12593),i<l.length?R(i,l,0):4449+i-12593<p.length&&R(4449+i-12593,p,12593),c>=0&&(c<w.length?R(c,w,0):4520+c-12593<p.length&&R(4520+c-12593,p,12593)),F>0)return M.subarray(0,F)}}function R(r,o,s){r>=s&&r<s+o.length&&m(o[r-s])}function m(r){r!==0&&(M[F++]=r&255,r>>8&&(M[F++]=r>>8&255),r>>16&&(M[F++]=r>>16&255))}var d;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var k;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(k||(k={}));var O;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(O||(O={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Me[125],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$mm=S,e.rot=F;function S(m,d,k){return Math.min(Math.max(m,d),k)}function F(m,d){return(d+m%d)%d}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$om=M;class N{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$pm=N;class R{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const k=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$qm=R}),function(){function me(M){const N=[];typeof M=="number"&&N.push("code/timeOrigin",M);function R(d){N.push(d,Date.now())}function m(){const d=[];for(let k=0;k<N.length;k+=2)d.push({name:N[k],startTime:N[k+1]});return d}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(M+R.startTime)});return N}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),define(Me[126],Re([1,0,45]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;const F=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||S.Iterable.empty()}insert(d,k,O){this.d(d,E=>E._value=k,O)}mutate(d,k){this.d(d,O=>O._value=k(O._value===F?void 0:O._value))}delete(d){const k=this.c(d);if(!k)return;let O=k.length-1;const E=k[O].node._value;if(E!==F){for(this.b--,k[O].node._value=F;O>0;O--){const{node:l,part:w}=k[O];if(l.children?.size||l._value!==F)break;k[O-1].node.children.delete(w)}return E}}*deleteRecursive(d){const k=this.c(d);if(!k)return;const O=k[k.length-1].node;for(let E=k.length-1;E>0;E--){const l=k[E-1];if(l.node.children.delete(k[E].part),l.node.children.size>0||l.node._value!==F)break}for(const E of N(O))E._value!==F&&(this.b--,yield E._value)}find(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return;k=E}return k._value===F?void 0:k._value}hasKeyOrParent(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return!1;if(E._value!==F)return!0;k=E}return!1}hasKeyOrChildren(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return!1;k=E}return!0}hasKey(d){let k=this.a;for(const O of d){const E=k.children?.get(O);if(!E)return!1;k=E}return k._value!==F}c(d){const k=[{part:"",node:this.a}];let O=0;for(const E of d){const l=k[O].node.children?.get(E);if(!l)return;k.push({part:E,node:l}),O++}return k}d(d,k,O){let E=this.a;for(const p of d){if(E.children)if(E.children.has(p))E=E.children.get(p);else{const r=new R;E.children.set(p,r),E=r}else{const r=new R;E.children=new Map([[p,r]]),E=r}O?.(E)}const l=E._value===F?0:1;k(E);const w=E._value===F?0:1;this.b+=w-l}*values(){for(const{_value:d}of N(this.a))d!==F&&(yield d)}}e.$pO=M;function*N(m){const d=[m];for(;d.length>0;){const k=d.pop();if(yield k,k.children)for(const O of k.children.values())d.push(O)}}class R{constructor(){this._value=F}get value(){return this._value===F?void 0:this._value}set value(d){this._value=d===void 0?F:d}}}),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:me)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(F){if(e[F])return e[F].exports;var M=e[F]={i:F,l:!1,exports:{}};return me[F].call(M.exports,M,M.exports,S),M.l=!0,M.exports}return S.m=me,S.c=e,S.d=function(F,M,N){S.o(F,M)||Object.defineProperty(F,M,{enumerable:!0,get:N})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,M){if(1&M&&(F=S(F)),8&M||4&M&&typeof F=="object"&&F&&F.__esModule)return F;var N=Object.create(null);if(S.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:F}),2&M&&typeof F!="string")for(var R in F)S.d(N,R,function(m){return F[m]}.bind(null,R));return N},S.n=function(F){var M=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(M,"a",M),M},S.o=function(F,M){return Object.prototype.hasOwnProperty.call(F,M)},S.p="",S(S.s=0)}([function(me,e,S){(function(F){var M;e=me.exports=ne,M=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],d=e.src=[],k=0,O=k++;d[O]="0|[1-9]\\d*";var E=k++;d[E]="[0-9]+";var l=k++;d[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=k++;d[w]="("+d[O]+")\\.("+d[O]+")\\.("+d[O]+")";var p=k++;d[p]="("+d[E]+")\\.("+d[E]+")\\.("+d[E]+")";var r=k++;d[r]="(?:"+d[O]+"|"+d[l]+")";var o=k++;d[o]="(?:"+d[E]+"|"+d[l]+")";var s=k++;d[s]="(?:-("+d[r]+"(?:\\."+d[r]+")*))";var n=k++;d[n]="(?:-?("+d[o]+"(?:\\."+d[o]+")*))";var i=k++;d[i]="[0-9A-Za-z-]+";var c=k++;d[c]="(?:\\+("+d[i]+"(?:\\."+d[i]+")*))";var h=k++,t="v?"+d[w]+d[s]+"?"+d[c]+"?";d[h]="^"+t+"$";var v="[v=\\s]*"+d[p]+d[n]+"?"+d[c]+"?",u=k++;d[u]="^"+v+"$";var g=k++;d[g]="((?:<|>)?=?)";var a=k++;d[a]=d[E]+"|x|X|\\*";var b=k++;d[b]=d[O]+"|x|X|\\*";var f=k++;d[f]="[v=\\s]*("+d[b]+")(?:\\.("+d[b]+")(?:\\.("+d[b]+")(?:"+d[s]+")?"+d[c]+"?)?)?";var I=k++;d[I]="[v=\\s]*("+d[a]+")(?:\\.("+d[a]+")(?:\\.("+d[a]+")(?:"+d[n]+")?"+d[c]+"?)?)?";var $=k++;d[$]="^"+d[g]+"\\s*"+d[f]+"$";var D=k++;d[D]="^"+d[g]+"\\s*"+d[I]+"$";var y=k++;d[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;d[C]="(?:~>?)";var A=k++;d[A]="(\\s*)"+d[C]+"\\s+",m[A]=new RegExp(d[A],"g");var G=k++;d[G]="^"+d[C]+d[f]+"$";var T=k++;d[T]="^"+d[C]+d[I]+"$";var V=k++;d[V]="(?:\\^)";var P=k++;d[P]="(\\s*)"+d[V]+"\\s+",m[P]=new RegExp(d[P],"g");var L=k++;d[L]="^"+d[V]+d[f]+"$";var q=k++;d[q]="^"+d[V]+d[I]+"$";var re=k++;d[re]="^"+d[g]+"\\s*("+v+")$|^$";var ue=k++;d[ue]="^"+d[g]+"\\s*("+t+")$|^$";var ye=k++;d[ye]="(\\s*)"+d[g]+"\\s*("+v+"|"+d[f]+")",m[ye]=new RegExp(d[ye],"g");var Se=k++;d[Se]="^\\s*("+d[f]+")\\s+-\\s+("+d[f]+")\\s*$";var le=k++;d[le]="^\\s*("+d[I]+")\\s+-\\s+("+d[I]+")\\s*$";var we=k++;d[we]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)M(_,d[_]),m[_]||(m[_]=new RegExp(d[_]));function ve(z,K){if(z instanceof ne)return z;if(typeof z!="string"||z.length>N||!(K?m[u]:m[h]).test(z))return null;try{return new ne(z,K)}catch{return null}}function ne(z,K){if(z instanceof ne){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof ne))return new ne(z,K);M("SemVer",z,K),this.loose=K;var H=z.trim().match(K?m[u]:m[h]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<R)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=ve,e.valid=function(z,K){var H=ve(z,K);return H?H.version:null},e.clean=function(z,K){var H=ve(z.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(z){return M("SemVer.compare",this.version,this.loose,z),z instanceof ne||(z=new ne(z,this.loose)),this.compareMain(z)||this.comparePre(z)},ne.prototype.compareMain=function(z){return z instanceof ne||(z=new ne(z,this.loose)),W(this.major,z.major)||W(this.minor,z.minor)||W(this.patch,z.patch)},ne.prototype.comparePre=function(z){if(z instanceof ne||(z=new ne(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ee=z.prerelease[K];if(M("prerelease compare",K,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return W(H,ee)}while(++K)},ne.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,K,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new ne(z,H).inc(K,ee).version}catch{return null}},e.diff=function(z,K){if(Ie(z,K))return null;var H=ve(z),ee=ve(K);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=W;var fe=/^[0-9]+$/;function W(z,K){var H=fe.test(z),ee=fe.test(K);return H&&ee&&(z=+z,K=+K),H&&!ee?-1:ee&&!H?1:z<K?-1:z>K?1:0}function te(z,K,H){return new ne(z,H).compare(new ne(K,H))}function Ee(z,K,H){return te(z,K,H)>0}function Te(z,K,H){return te(z,K,H)<0}function Ie(z,K,H){return te(z,K,H)===0}function pe(z,K,H){return te(z,K,H)!==0}function ge(z,K,H){return te(z,K,H)>=0}function J(z,K,H){return te(z,K,H)<=0}function X(z,K,H,ee){var se;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),se=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),se=z!==H;break;case"":case"=":case"==":se=Ie(z,H,ee);break;case"!=":se=pe(z,H,ee);break;case">":se=Ee(z,H,ee);break;case">=":se=ge(z,H,ee);break;case"<":se=Te(z,H,ee);break;case"<=":se=J(z,H,ee);break;default:throw new TypeError("Invalid operator: "+K)}return se}function ce(z,K){if(z instanceof ce){if(z.loose===K)return z;z=z.value}if(!(this instanceof ce))return new ce(z,K);M("comparator",z,K),this.loose=K,this.parse(z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(z,K){return W(K,z)},e.major=function(z,K){return new ne(z,K).major},e.minor=function(z,K){return new ne(z,K).minor},e.patch=function(z,K){return new ne(z,K).patch},e.compare=te,e.compareLoose=function(z,K){return te(z,K,!0)},e.rcompare=function(z,K,H){return te(K,z,H)},e.sort=function(z,K){return z.sort(function(H,ee){return e.compare(H,ee,K)})},e.rsort=function(z,K){return z.sort(function(H,ee){return e.rcompare(H,ee,K)})},e.gt=Ee,e.lt=Te,e.eq=Ie,e.neq=pe,e.gte=ge,e.lte=J,e.cmp=X,e.Comparator=ce;var de={};function Oe(z,K){if(z instanceof Oe)return z.loose===K?z:new Oe(z.raw,K);if(z instanceof ce)return new Oe(z.value,K);if(!(this instanceof Oe))return new Oe(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function he(z){return!z||z.toLowerCase()==="x"||z==="*"}function Ce(z,K,H,ee,se,Ne,Ve,Ye,xe,et,ot,rt,tt){return((K=he(H)?"":he(ee)?">="+H+".0.0":he(se)?">="+H+"."+ee+".0":">="+K)+" "+(Ye=he(xe)?"":he(et)?"<"+(+xe+1)+".0.0":he(ot)?"<"+xe+"."+(+et+1)+".0":rt?"<="+xe+"."+et+"."+ot+"-"+rt:"<="+Ye)).trim()}function Ae(z,K){for(var H=0;H<z.length;H++)if(!z[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<z.length;H++)if(M(z[H].semver),z[H].semver!==de&&z[H].semver.prerelease.length>0){var ee=z[H].semver;if(ee.major===K.major&&ee.minor===K.minor&&ee.patch===K.patch)return!0}return!1}return!0}function Le(z,K,H){try{K=new Oe(K,H)}catch{return!1}return K.test(z)}function U(z,K,H,ee){var se,Ne,Ve,Ye,xe;switch(z=new ne(z,ee),K=new Oe(K,ee),H){case">":se=Ee,Ne=J,Ve=Te,Ye=">",xe=">=";break;case"<":se=Te,Ne=ge,Ve=Ee,Ye="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(z,K,ee))return!1;for(var et=0;et<K.set.length;++et){var ot=K.set[et],rt=null,tt=null;if(ot.forEach(function(st){st.semver===de&&(st=new ce(">=0.0.0")),rt=rt||st,tt=tt||st,se(st.semver,rt.semver,ee)?rt=st:Ve(st.semver,tt.semver,ee)&&(tt=st)}),rt.operator===Ye||rt.operator===xe||(!tt.operator||tt.operator===Ye)&&Ne(z,tt.semver)||tt.operator===xe&&Ve(z,tt.semver))return!1}return!0}ce.prototype.parse=function(z){var K=this.loose?m[re]:m[ue],H=z.match(K);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ne(H[2],this.loose):this.semver=de},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(z){return M("Comparator.test",z,this.loose),this.semver===de||(typeof z=="string"&&(z=new ne(z,this.loose)),X(z,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(z,K){if(!(z instanceof ce))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Oe(z.value,K),Le(this.value,H,K);if(z.operator==="")return H=new Oe(this.value,K),Le(z.semver,H,K);var ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ne=this.semver.version===z.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ye=X(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),xe=X(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ee||se||Ne&&Ve||Ye||xe},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),M("range",z,K);var H=K?m[le]:m[Se];z=z.replace(H,Ce),M("hyphen replace",z),z=z.replace(m[ye],"$1$2$3"),M("comparator trim",z,m[ye]),z=(z=(z=z.replace(m[A],"$1~")).replace(m[P],"$1^")).split(/\s+/).join(" ");var ee=K?m[re]:m[ue],se=z.split(" ").map(function(Ne){return function(Ve,Ye){return M("comp",Ve),Ve=function(xe,et){return xe.trim().split(/\s+/).map(function(ot){return function(rt,tt){M("caret",rt,tt);var st=tt?m[q]:m[L];return rt.replace(st,function(Be,it,Q,Z,$e){var We;return M("caret",rt,Be,it,Q,Z,$e),he(it)?We="":he(Q)?We=">="+it+".0.0 <"+(+it+1)+".0.0":he(Z)?We=it==="0"?">="+it+"."+Q+".0 <"+it+"."+(+Q+1)+".0":">="+it+"."+Q+".0 <"+(+it+1)+".0.0":$e?(M("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),We=it==="0"?Q==="0"?">="+it+"."+Q+"."+Z+$e+" <"+it+"."+Q+"."+(+Z+1):">="+it+"."+Q+"."+Z+$e+" <"+it+"."+(+Q+1)+".0":">="+it+"."+Q+"."+Z+$e+" <"+(+it+1)+".0.0"):(M("no pr"),We=it==="0"?Q==="0"?">="+it+"."+Q+"."+Z+" <"+it+"."+Q+"."+(+Z+1):">="+it+"."+Q+"."+Z+" <"+it+"."+(+Q+1)+".0":">="+it+"."+Q+"."+Z+" <"+(+it+1)+".0.0"),M("caret return",We),We})}(ot,et)}).join(" ")}(Ve,Ye),M("caret",Ve),Ve=function(xe,et){return xe.trim().split(/\s+/).map(function(ot){return function(rt,tt){var st=tt?m[T]:m[G];return rt.replace(st,function(Be,it,Q,Z,$e){var We;return M("tilde",rt,Be,it,Q,Z,$e),he(it)?We="":he(Q)?We=">="+it+".0.0 <"+(+it+1)+".0.0":he(Z)?We=">="+it+"."+Q+".0 <"+it+"."+(+Q+1)+".0":$e?(M("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),We=">="+it+"."+Q+"."+Z+$e+" <"+it+"."+(+Q+1)+".0"):We=">="+it+"."+Q+"."+Z+" <"+it+"."+(+Q+1)+".0",M("tilde return",We),We})}(ot,et)}).join(" ")}(Ve,Ye),M("tildes",Ve),Ve=function(xe,et){return M("replaceXRanges",xe,et),xe.split(/\s+/).map(function(ot){return function(rt,tt){rt=rt.trim();var st=tt?m[D]:m[$];return rt.replace(st,function(Be,it,Q,Z,$e,We){M("xRange",rt,Be,it,Q,Z,$e,We);var Qe=he(Q),at=Qe||he(Z),Fe=at||he($e);return it==="="&&Fe&&(it=""),Qe?Be=it===">"||it==="<"?"<0.0.0":"*":it&&Fe?(at&&(Z=0),Fe&&($e=0),it===">"?(it=">=",at?(Q=+Q+1,Z=0,$e=0):Fe&&(Z=+Z+1,$e=0)):it==="<="&&(it="<",at?Q=+Q+1:Z=+Z+1),Be=it+Q+"."+Z+"."+$e):at?Be=">="+Q+".0.0 <"+(+Q+1)+".0.0":Fe&&(Be=">="+Q+"."+Z+".0 <"+Q+"."+(+Z+1)+".0"),M("xRange return",Be),Be})}(ot,et)}).join(" ")}(Ve,Ye),M("xrange",Ve),Ve=function(xe,et){return M("replaceStars",xe,et),xe.trim().replace(m[we],"")}(Ve,Ye),M("stars",Ve),Ve}(Ne,K)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Ne){return!!Ne.match(ee)})),se=se.map(function(Ne){return new ce(Ne,K)})},Oe.prototype.intersects=function(z,K){if(!(z instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return z.set.some(function(se){return se.every(function(Ne){return ee.intersects(Ne,K)})})})})},e.toComparators=function(z,K){return new Oe(z,K).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new ne(z,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],z))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(z,K,H){var ee=null,se=null;try{var Ne=new Oe(K,H)}catch{return null}return z.forEach(function(Ve){Ne.test(Ve)&&(ee&&se.compare(Ve)!==-1||(se=new ne(ee=Ve,H)))}),ee},e.minSatisfying=function(z,K,H){var ee=null,se=null;try{var Ne=new Oe(K,H)}catch{return null}return z.forEach(function(Ve){Ne.test(Ve)&&(ee&&se.compare(Ve)!==1||(se=new ne(ee=Ve,H)))}),ee},e.validRange=function(z,K){try{return new Oe(z,K).range||"*"}catch{return null}},e.ltr=function(z,K,H){return U(z,K,"<",H)},e.gtr=function(z,K,H){return U(z,K,">",H)},e.outside=U,e.prerelease=function(z,K){var H=ve(z,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(z,K,H){return z=new Oe(z,H),K=new Oe(K,H),z.intersects(K)},e.coerce=function(z){if(z instanceof ne)return z;if(typeof z!="string")return null;var K=z.match(m[y]);return K==null?null:ve((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(me,e){var S,F,M=me.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(o){if(S===setTimeout)return setTimeout(o,0);if((S===N||!S)&&setTimeout)return S=setTimeout,setTimeout(o,0);try{return S(o,0)}catch{try{return S.call(null,o,0)}catch{return S.call(this,o,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:N}catch{S=N}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var d,k=[],O=!1,E=-1;function l(){O&&d&&(O=!1,d.length?k=d.concat(k):E=-1,k.length&&w())}function w(){if(!O){var o=m(l);O=!0;for(var s=k.length;s;){for(d=k,k=[];++E<s;)d&&d[E].run();E=-1,s=k.length}d=null,O=!1,function(n){if(F===clearTimeout)return clearTimeout(n);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(n);try{F(n)}catch{try{return F.call(null,n)}catch{return F.call(this,n)}}}(o)}}function p(o,s){this.fun=o,this.array=s}function r(){}M.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];k.push(new p(o,s)),k.length!==1||O||m(w)},p.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(o){return[]},M.binding=function(o){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(o){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Me[127],Re([1,0,14,6]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=M,e.$ge=N,e.$he=R,e.$ie=m,e.$je=k,e.$ke=O,e.$le=E,e.$me=l,e.$ne=w,e.$oe=p,e.$pe=r,e.$qe=o,e.$re=s,e.$se=n,e.$te=i;function M(c){const h=c;return h?typeof h.read=="function":!1}function N(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function R(c){const h=c;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(c,h){return new d(c,h)}class d{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let v;switch(h){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const u=v.indexOf(t);u>=0&&v.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(c,h){const t=[];let v;for(;(v=c.read())!==null;)t.push(v);return h(t)}function O(c,h,t){const v=[];let u;for(;(u=c.read())!==null&&v.length<t;)v.push(u);return u===null&&v.length>0?h(v):{read:()=>{if(v.length>0)return v.shift();if(typeof u<"u"){const g=u;return u=void 0,g}return c.read()}}}function E(c,h){return new Promise((t,v)=>{const u=[];l(c,{onData:g=>{h&&u.push(g)},onError:g=>{h?v(g):t(void 0)},onEnd:()=>{t(h?h(u):void 0)}})})}function l(c,h,t){c.on("error",v=>{t?.isCancellationRequested||h.onError(v)}),c.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),c.on("data",v=>{t?.isCancellationRequested||h.onData(v)})}function w(c,h){return new Promise((t,v)=>{const u=new F.$Tc,g=[],a=I=>{if(g.push(I),g.length>h)return u.dispose(),c.pause(),t({stream:c,buffer:g,ended:!1})},b=I=>(u.dispose(),v(I)),f=()=>(u.dispose(),t({stream:c,buffer:g,ended:!0}));u.add((0,F.$Sc)(()=>c.removeListener("error",b))),c.on("error",b),u.add((0,F.$Sc)(()=>c.removeListener("end",f))),c.on("end",f),u.add((0,F.$Sc)(()=>c.removeListener("data",a))),c.on("data",a)})}function p(c,h){const t=m(h);return t.end(c),t}function r(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function s(c,h,t){const v=m(t);return l(c,{onData:u=>v.write(h.data(u)),onError:u=>v.error(h.error?h.error(u):u),onEnd:()=>v.end()}),v}function n(c,h,t){let v=!1;return{read:()=>{const u=h.read();return v?u:(v=!0,u!==null?t([c,u]):c)}}}function i(c,h,t){let v=!1;const u=m(t);return l(h,{onData:g=>v?u.write(g):(v=!0,u.write(t([c,g]))),onError:g=>u.error(g),onEnd:()=>{v||(v=!0,u.write(c)),u.end()}}),u}}),define(Me[23],Re([1,0,39,127]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=k,e.$we=O,e.$xe=E,e.$ye=l,e.$ze=w,e.$Ae=p,e.$Be=r,e.$Ce=o,e.$De=s,e.$Ee=n,e.$Fe=i,e.$Ge=c,e.$He=h,e.$Ie=t,e.$Je=v,e.$Ke=u,e.$Le=g,e.$Me=a,e.$Ne=b,e.$Oe=$;const M=typeof Buffer<"u",N=new S.$V(()=>new Uint8Array(256));let R,m;class d{static alloc(y){return M?new d(Buffer.allocUnsafe(y)):new d(new Uint8Array(y))}static wrap(y){return M&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new d(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&M?new d(Buffer.from(y)):(R||(R=new TextEncoder),new d(R.encode(y)))}static fromByteArray(y){const C=d.alloc(y.length);for(let A=0,G=y.length;A<G;A++)C.buffer[A]=y[A];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let T=0,V=y.length;T<V;T++)C+=y[T].byteLength}const A=d.alloc(C);let G=0;for(let T=0,V=y.length;T<V;T++){const P=y[T];A.set(P,G),G+=P.byteLength}return A}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=d.alloc(this.byteLength);return y.set(this),y}toString(){return M?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,C){return new d(this.buffer.subarray(y,C))}set(y,C){if(y instanceof d)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return l(this.buffer,y)}writeUInt32BE(y,C){w(this.buffer,y,C)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,C){r(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return k(this.buffer,y instanceof d?y.buffer:y,C)}}e.$ue=d;function k(D,y,C=0){const A=y.byteLength,G=D.byteLength;if(A===0)return 0;if(A===1)return D.indexOf(y[0]);if(A>G-C)return-1;const T=N.value;T.fill(y.length);for(let q=0;q<y.length;q++)T[y[q]]=y.length-q-1;let V=C+y.length-1,P=V,L=-1;for(;V<G;)if(D[V]===y[P]){if(P===0){L=V;break}V--,P--}else V+=Math.max(y.length-P,T[D[V]]),P=y.length-1;return L}function O(D,y){return D[y+0]<<0>>>0|D[y+1]<<8>>>0}function E(D,y,C){D[C+0]=y&255,y=y>>>8,D[C+1]=y&255}function l(D,y){return D[y]*2**24+D[y+1]*2**16+D[y+2]*2**8+D[y+3]}function w(D,y,C){D[C+3]=y,y=y>>>8,D[C+2]=y,y=y>>>8,D[C+1]=y,y=y>>>8,D[C]=y}function p(D,y){return D[y+0]<<0>>>0|D[y+1]<<8>>>0|D[y+2]<<16>>>0|D[y+3]<<24>>>0}function r(D,y,C){D[C+0]=y&255,y=y>>>8,D[C+1]=y&255,y=y>>>8,D[C+2]=y&255,y=y>>>8,D[C+3]=y&255}function o(D,y){return D[y]}function s(D,y,C){D[C]=y}function n(D){return F.$je(D,y=>d.concat(y))}function i(D){return F.$qe(D)}function c(D){return F.$le(D,y=>d.concat(y))}async function h(D){return D.ended?d.concat(D.buffer):d.concat([...D.buffer,await c(D.stream)])}function t(D){return F.$oe(D,y=>d.concat(y))}function v(D){return F.$re(D,{data:y=>typeof y=="string"?d.fromString(y):d.wrap(y)},y=>d.concat(y))}function u(D){return F.$ie(y=>d.concat(y),D)}function g(D,y){return F.$se(D,y,C=>d.concat(C))}function a(D,y){return F.$te(D,y,C=>d.concat(C))}function b(D){let y=0,C=0,A=0;const G=new Uint8Array(Math.floor(D.length/4*3)),T=P=>{switch(C){case 3:G[A++]=y|P,C=0;break;case 2:G[A++]=y|P>>>2,y=P<<6,C=3;break;case 1:G[A++]=y|P>>>4,y=P<<4,C=2;break;default:y=P<<2,C=1}};for(let P=0;P<D.length;P++){const L=D.charCodeAt(P);if(L>=65&&L<=90)T(L-65);else if(L>=97&&L<=122)T(L-97+26);else if(L>=48&&L<=57)T(L-48+52);else if(L===43||L===45)T(62);else if(L===47||L===95)T(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${D[P]}`)}}const V=A;for(;C>0;)T(0);return d.wrap(G).slice(0,V)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:D},y=!0,C=!1){const A=C?I:f;let G="";const T=D.byteLength%3;let V=0;for(;V<D.byteLength-T;V+=3){const P=D[V+0],L=D[V+1],q=D[V+2];G+=A[P>>>2],G+=A[(P<<4|L>>>4)&63],G+=A[(L<<2|q>>>6)&63],G+=A[q&63]}if(T===1){const P=D[V+0];G+=A[P>>>2],G+=A[P<<4&63],y&&(G+="==")}else if(T===2){const P=D[V+0],L=D[V+1];G+=A[P>>>2],G+=A[(P<<4|L>>>4)&63],G+=A[L<<2&63],y&&(G+="=")}return G}}),define(Me[128],Re([1,0,28,124,15]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.FuzzyScore=e.$jk=e.$ik=void 0,e.or=N,e.$kk=m,e.$lk=d,e.$mk=E,e.$nk=b,e.$ok=f,e.$pk=A,e.$qk=G,e.$rk=T,e.$sk=V,e.$tk=te,e.$vk=pe,e.$wk=X,e.$xk=ce;function N(...he){return function(Ce,Ae){for(let Le=0,U=he.length;Le<U;Le++){const z=he[Le](Ce,Ae);if(z)return z}return null}}e.$ik=R.bind(void 0,!1),e.$jk=R.bind(void 0,!0);function R(he,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let Le;return he?Le=M.$mf(Ae,Ce):Le=Ae.indexOf(Ce)===0,Le?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(he,Ce){const Ae=Ce.toLowerCase().indexOf(he.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+he.length}]}function d(he,Ce){return k(he.toLowerCase(),Ce.toLowerCase(),0,0)}function k(he,Ce,Ae,Le){if(Ae===he.length)return[];if(Le===Ce.length)return null;if(he[Ae]===Ce[Le]){let U=null;return(U=k(he,Ce,Ae+1,Le+1))?c({start:Le,end:Le+1},U):null}return k(he,Ce,Ae,Le+1)}function O(he){return 97<=he&&he<=122}function E(he){return 65<=he&&he<=90}function l(he){return 48<=he&&he<=57}function w(he){return he===32||he===9||he===10||he===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>p.add(he.charCodeAt(0)));function r(he){return w(he)||p.has(he)}function o(he,Ce){return he===Ce||r(he)&&r(Ce)}const s=new Map;function n(he){if(s.has(he))return s.get(he);let Ce;const Ae=(0,F.$gk)(he);return Ae&&(Ce=Ae),s.set(he,Ce),Ce}function i(he){return O(he)||E(he)||l(he)}function c(he,Ce){return Ce.length===0?Ce=[he]:he.end===Ce[0].start?Ce[0].start=he.start:Ce.unshift(he),Ce}function h(he,Ce){for(let Ae=Ce;Ae<he.length;Ae++){const Le=he.charCodeAt(Ae);if(E(Le)||l(Le)||Ae>0&&!i(he.charCodeAt(Ae-1)))return Ae}return he.length}function t(he,Ce,Ae,Le){if(Ae===he.length)return[];if(Le===Ce.length)return null;if(he[Ae]!==Ce[Le].toLowerCase())return null;{let U=null,z=Le+1;for(U=t(he,Ce,Ae+1,Le+1);!U&&(z=h(Ce,z))<Ce.length;)U=t(he,Ce,Ae+1,z),z++;return U===null?null:c({start:Le,end:Le+1},U)}}function v(he){let Ce=0,Ae=0,Le=0,U=0,z=0;for(let Ne=0;Ne<he.length;Ne++)z=he.charCodeAt(Ne),E(z)&&Ce++,O(z)&&Ae++,i(z)&&Le++,l(z)&&U++;const K=Ce/he.length,H=Ae/he.length,ee=Le/he.length,se=U/he.length;return{upperPercent:K,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function u(he){const{upperPercent:Ce,lowerPercent:Ae}=he;return Ae===0&&Ce>.6}function g(he){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:Le,numericPercent:U}=he;return Ae>.2&&Ce<.8&&Le>.6&&U<.2}function a(he){let Ce=0,Ae=0,Le=0,U=0;for(let z=0;z<he.length;z++)Le=he.charCodeAt(z),E(Le)&&Ce++,O(Le)&&Ae++,w(Le)&&U++;return(Ce===0||Ae===0)&&U===0?he.length<=30:Ce<=5}function b(he,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!a(he))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=v(Ce);if(!g(Ae)){if(!u(Ae))return null;Ce=Ce.toLowerCase()}let Le=null,U=0;for(he=he.toLowerCase();U<Ce.length&&(Le=t(he,Ce,0,U))===null;)U=h(Ce,U+1);return Le}function f(he,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let Le=null,U=0;for(he=he.toLowerCase(),Ce=Ce.toLowerCase();U<Ce.length&&(Le=I(he,Ce,0,U,Ae),Le===null);)U=$(Ce,U+1);return Le}function I(he,Ce,Ae,Le,U){let z=0;if(Ae===he.length)return[];if(Le===Ce.length)return null;if(!o(he.charCodeAt(Ae),Ce.charCodeAt(Le))){const ee=n(he.charCodeAt(Ae));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],Ce.charCodeAt(Le+se)))return null;z+=ee.length-1}let K=null,H=Le+z+1;if(K=I(he,Ce,Ae+1,H,U),!U)for(;!K&&(H=$(Ce,H))<Ce.length;)K=I(he,Ce,Ae+1,H,U),H++;if(!K)return null;if(he.charCodeAt(Ae)!==Ce.charCodeAt(Le)){const ee=n(he.charCodeAt(Ae));if(!ee)return K;for(let se=0;se<ee.length;se++)if(ee[se]!==Ce.charCodeAt(Le+se))return K}return c({start:Le,end:Le+z+1},K)}function $(he,Ce){for(let Ae=Ce;Ae<he.length;Ae++)if(r(he.charCodeAt(Ae))||Ae>0&&r(he.charCodeAt(Ae-1)))return Ae;return he.length}const D=N(e.$jk,b,m),y=N(e.$jk,b,d),C=new S.$Ec(1e4);function A(he,Ce,Ae=!1){if(typeof he!="string"||typeof Ce!="string")return null;let Le=C.get(he);Le||(Le=new RegExp(M.$7e(he),"i"),C.set(he,Le));const U=Le.exec(Ce);return U?[{start:U.index,end:U.index+U[0].length}]:Ae?y(he,Ce):D(he,Ce)}function G(he,Ce){const Ae=pe(he,he.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?V(Ae):null}function T(he,Ce,Ae,Le,U,z){const K=Math.min(13,he.length);for(;Ae<K;Ae++){const H=pe(he,Ce,Ae,Le,U,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,z]}function V(he){if(typeof he>"u")return[];const Ce=[],Ae=he[1];for(let Le=he.length-1;Le>1;Le--){const U=he[Le]+Ae,z=Ce[Ce.length-1];z&&z.end===U?z.end=U+1:Ce.push({start:U,end:U+1})}return Ce}const P=128;function L(){const he=[],Ce=[];for(let Ae=0;Ae<=P;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=P;Ae++)he.push(Ce.slice(0));return he}function q(he){const Ce=[];for(let Ae=0;Ae<=he;Ae++)Ce[Ae]=0;return Ce}const re=q(2*P),ue=q(2*P),ye=L(),Se=L(),le=L(),we=!1;function _(he,Ce,Ae,Le,U){function z(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let K=` |   |${Le.split("").map(H=>z(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?K+=" |":K+=`${Ce[H-1]}|`,K+=he[H].slice(0,U+1).map(ee=>z(ee.toString(),3)).join("|")+`
`;return K}function ve(he,Ce,Ae,Le){he=he.substr(Ce),Ae=Ae.substr(Le),console.log(_(Se,he,he.length,Ae,Ae.length)),console.log(_(le,he,he.length,Ae,Ae.length)),console.log(_(ye,he,he.length,Ae,Ae.length))}function ne(he,Ce){if(Ce<0||Ce>=he.length)return!1;const Ae=he.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Ef(Ae)}}function fe(he,Ce){if(Ce<0||Ce>=he.length)return!1;switch(he.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function W(he,Ce,Ae){return Ce[he]!==Ae[he]}function te(he,Ce,Ae,Le,U,z,K=!1){for(;Ce<Ae&&U<z;)he[Ce]===Le[U]&&(K&&(re[Ce]=U),Ce+=1),U+=1;return Ce===Ae}var Ee;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Te;(function(he){he.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}he.isDefault=Ce})(Te||(e.FuzzyScore=Te={}));class Ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$uk=Ie;function pe(he,Ce,Ae,Le,U,z,K=Ie.default){const H=he.length>P?P:he.length,ee=Le.length>P?P:Le.length;if(Ae>=H||z>=ee||H-Ae>ee-z||!te(Ce,Ae,H,U,z,ee,!0))return;ge(H,ee,Ae,z,Ce,U);let se=1,Ne=1,Ve=Ae,Ye=z;const xe=[!1];for(se=1,Ve=Ae;Ve<H;se++,Ve++){const st=re[Ve],Be=ue[Ve],it=Ve+1<H?ue[Ve+1]:ee;for(Ne=st-z+1,Ye=st;Ye<it;Ne++,Ye++){let Q=Number.MIN_SAFE_INTEGER,Z=!1;Ye<=Be&&(Q=J(he,Ce,Ve,Ae,Le,U,Ye,ee,z,ye[se-1][Ne-1]===0,xe));let $e=0;Q!==Number.MAX_SAFE_INTEGER&&(Z=!0,$e=Q+Se[se-1][Ne-1]);const We=Ye>st,Qe=We?Se[se][Ne-1]+(ye[se][Ne-1]>0?-5:0):0,at=Ye>st+1&&ye[se][Ne-1]>0,Fe=at?Se[se][Ne-2]+(ye[se][Ne-2]>0?-5:0):0;if(at&&(!We||Fe>=Qe)&&(!Z||Fe>=$e))Se[se][Ne]=Fe,le[se][Ne]=3,ye[se][Ne]=0;else if(We&&(!Z||Qe>=$e))Se[se][Ne]=Qe,le[se][Ne]=2,ye[se][Ne]=0;else if(Z)Se[se][Ne]=$e,le[se][Ne]=1,ye[se][Ne]=ye[se-1][Ne-1]+1;else throw new Error("not possible")}}if(we&&ve(he,Ae,Le,z),!xe[0]&&!K.firstMatchCanBeWeak)return;se--,Ne--;const et=[Se[se][Ne],z];let ot=0,rt=0;for(;se>=1;){let st=Ne;do{const Be=le[se][st];if(Be===3)st=st-2;else if(Be===2)st=st-1;else break}while(st>=1);ot>1&&Ce[Ae+se-1]===U[z+Ne-1]&&!W(st+z-1,Le,U)&&ot+1>ye[se][st]&&(st=Ne),st===Ne?ot++:ot=1,rt||(rt=st),se--,Ne=st-1,et.push(Ne)}ee===H&&K.boostFullMatch&&(et[0]+=2);const tt=rt-H;return et[0]-=tt,et}function ge(he,Ce,Ae,Le,U,z){let K=he-1,H=Ce-1;for(;K>=Ae&&H>=Le;)U[K]===z[H]&&(ue[K]=H,K--),H--}function J(he,Ce,Ae,Le,U,z,K,H,ee,se,Ne){if(Ce[Ae]!==z[K])return Number.MIN_SAFE_INTEGER;let Ve=1,Ye=!1;return K===Ae-Le?Ve=he[Ae]===U[K]?7:5:W(K,U,z)&&(K===0||!W(K-1,U,z))?(Ve=he[Ae]===U[K]?7:5,Ye=!0):ne(z,K)&&(K===0||!ne(z,K-1))?Ve=5:(ne(z,K-1)||fe(z,K-1))&&(Ve=5,Ye=!0),Ve>1&&Ae===Le&&(Ne[0]=!0),Ye||(Ye=W(K,U,z)||ne(z,K-1)||fe(z,K-1)),Ae===Le?K>ee&&(Ve-=Ye?3:5):se?Ve+=Ye?2:0:Ve+=Ye?0:1,K+1===H&&(Ve-=Ye?3:5),Ve}function X(he,Ce,Ae,Le,U,z,K){return de(he,Ce,Ae,Le,U,z,!0,K)}function ce(he,Ce,Ae,Le,U,z,K){return de(he,Ce,Ae,Le,U,z,!1,K)}function de(he,Ce,Ae,Le,U,z,K,H){let ee=pe(he,Ce,Ae,Le,U,z,H);if(ee&&!K)return ee;if(he.length>=3){const se=Math.min(7,he.length-1);for(let Ne=Ae+1;Ne<se;Ne++){const Ve=Oe(he,Ne);if(Ve){const Ye=pe(Ve,Ve.toLowerCase(),Ae,Le,U,z,H);Ye&&(Ye[0]-=3,(!ee||Ye[0]>ee[0])&&(ee=Ye))}}}return ee}function Oe(he,Ce){if(Ce+1>=he.length)return;const Ae=he[Ce],Le=he[Ce+1];if(Ae!==Le)return he.slice(0,Ce)+Le+Ae+he.slice(Ce+2)}}),define(Me[32],Re([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(F||(F={})),function(M){const N="error",R="warning",m="warn",d="info",k="ignore";function O(l){return l?S.$lf(N,l)?M.Error:S.$lf(R,l)||S.$lf(m,l)?M.Warning:S.$lf(d,l)?M.Info:M.Ignore:M.Ignore}M.fromValue=O;function E(l){switch(l){case M.Error:return N;case M.Warning:return R;case M.Info:return d;default:return k}}M.toString=E}(F||(F={})),e.default=F}),define(Me[129],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Me[51],Re([1,0,18,15]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=void 0;class M{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const p=w.charCodeAt(0),r=this.b.charCodeAt(this.c);return p-r}value(){return this.b[this.c]}}e.$ji=M;class N{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,F.$ff)(w,this.b,0,w.length,this.c,this.d):(0,F.$hf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ki=N;class R{constructor(w=!0,p=!0){this.f=w,this.g=p}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let p=w.length-1;p>=0;p--,this.c--){const r=this.b.charCodeAt(p);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,F.$ff)(w,this.b,0,w.length,this.d,this.e):(0,F.$hf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$li=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class d{constructor(w,p){this.f=w,this.g=p,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,F.$gf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,F.$gf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,F.$ef)(w,this.c.query);if(this.d[this.e]===5)return(0,F.$ef)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$mi=d;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(O||(O={}));class E{static forUris(w=()=>!1,p=()=>!1){return new E(new d(w,p))}static forPaths(w=!1){return new E(new R(void 0,!w))}static forStrings(){return new E(new M)}static forConfigKeys(){return new E(new N)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,p){if(p){const r=p.slice(0);(0,S.$Xb)(r);for(const o of r)this.set(o,w)}else{const r=w.slice(0);(0,S.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(w,p){const r=this.b.reset(w);let o;this.c||(this.c=new k,this.c.segment=r.value());const s=[];for(o=this.c;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new k,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new k,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new k,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=p,o.key=w;for(let i=s.length-1;i>=0;i--){const c=s[i][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const t=s[i][0],v=s[i+1][0];if(t===1&&v===1)s[i][1]=c.rotateLeft();else if(t===-1&&v===-1)s[i][1]=c.rotateRight();else if(t===1&&v===-1)c.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=c.rotateLeft();else if(t===-1&&v===1)c.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return n}get(w){return this.d(w)?.value}d(w){const p=this.b.reset(w);let r=this.c;for(;r;){const o=p.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else break}return r}has(w){const p=this.d(w);return!(p?.value===void 0&&p?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,p){const r=this.b.reset(w),o=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(p?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:i,value:c,segment:h}=n;this.e(n.key,!1),s.key=i,s.value=c,s.segment=h}}else{const n=s.left??s.right;if(o.length>0){const[i,c]=o[o.length-1];switch(i){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const i=o[n][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[n][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[n][1]=i.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const p=this.b.reset(w);let r=this.c,o;for(;r;){const s=p.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(p.hasNext())p.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(w){return this.g(w,!1)}g(w,p){const r=this.b.reset(w);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):p?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[p,r]of this)w(r,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const p=[];return this.j(w,p),p[Symbol.iterator]()}j(w,p){w&&(w.left&&this.j(w.left,p),w.value&&p.push([w.key,w.value]),w.mid&&this.j(w.mid,p),w.right&&this.j(w.right,p))}_isBalanced(){const w=p=>{if(!p)return!0;const r=p.balanceFactor();return r<-1||r>1?!1:w(p.left)&&w(p.right)};return w(this.c)}}e.$ni=E}),define(Me[40],Re([1,0,91]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Hj=M;var F;(function(R){function m(d){return d&&typeof d=="object"&&typeof d.id=="string"}R.isThemeColor=m})(F||(e.ThemeColor=F={}));function M(R){return{id:R}}var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function d(n){const i=m.exec(n.id);if(!i)return d(S.$Gj.error);const[,c,h]=i,t=["codicon","codicon-"+c];return h&&t.push("codicon-modifier-"+h.substring(1)),t}R.asClassNameArray=d;function k(n){return d(n).join(" ")}R.asClassName=k;function O(n){return"."+d(n).join(".")}R.asCSSSelector=O;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||F.isThemeColor(n.color))}R.isThemeIcon=E;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(n){const i=l.exec(n);if(!i)return;const[,c]=i;return{id:c}}R.fromString=w;function p(n){return{id:n}}R.fromId=p;function r(n,i){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),i&&(c=`${c}~${i}`),{id:c}}R.modify=r;function o(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=o;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Me[130],Re([1,0,128,15,40]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=d,e.$zk=O,e.$Ak=l,e.$Bk=w,e.$Ck=r,e.$Dk=o;const N="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function d(s){return s.replace(m,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${R.source}`,"g");function O(s){return s.replace(k,n=>`\\${n}`)}const E=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(s){return s.indexOf(N)===-1?s:s.replace(E,(n,i,c,h)=>c?n:i||h||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const p=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){p.lastIndex=0;let n="";const i=[];let c=0;for(;;){const h=p.lastIndex,t=p.exec(s),v=s.substring(h,t?.index);if(v.length>0){n+=v;for(let u=0;u<v.length;u++)i.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:i}}function o(s,n,i=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,S.$pk)(s,c,i);const t=(0,F.$5e)(c," "),v=c.length-t.length,u=(0,S.$pk)(s,t,i);if(u)for(const g of u){const a=h[g.start+v]+v;g.start+=a,g.end+=a}return u}}),define(Me[33],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dg=void 0,e.$Cg=F;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(M){return S.test(M)}e.$Dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(m){for(let d=0;d<m.length;d++)m[d]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){M(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let d=0,k="";return k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+="-",k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k+=R[N[d++]],k}}()}),define(Me[131],Re([1,0,18,45,33]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.$Ht=void 0,e.$Ft=N,e.$Gt=R,e.$It=k;function N(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function R(E,l,w){const p={id:(0,M.$Dg)(),name:E,uri:l,data:w};return{asString:async()=>"",asFile:()=>p,value:void 0}}class m{constructor(){this.a=new Map}get size(){let l=0;for(const w of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const w=[...this.a.keys()];return F.Iterable.some(this,([p,r])=>r.asFile())&&w.push("files"),O(d(l),w)}get(l){return this.a.get(this.b(l))?.[0]}append(l,w){const p=this.a.get(l);p?p.push(w):this.a.set(this.b(l),[w])}replace(l,w){this.a.set(this.b(l),[w])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,w]of this.a)for(const p of w)yield[l,p]}b(l){return d(l)}}e.$Ht=m;function d(E){return E.toLowerCase()}function k(E,l){return O(d(E),l.map(d))}function O(E,l){if(E==="*/*")return l.length>0;if(l.includes(E))return!0;const w=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[p,r,o]=w;return o==="*"?l.some(s=>s.startsWith(r+"/")):!1}e.$Jt=Object.freeze({create:E=>(0,S.$Mb)(E.map(l=>l.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Jt.split(E).filter(l=>!l.startsWith("#"))})}),define(Me[132],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Mt=F;var S;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function F(M){let N=0,R=0,m=0,d=0;for(let k=0,O=M.length;k<O;k++){const E=M.charCodeAt(k);E===13?(N===0&&(R=k),N++,k+1<O&&M.charCodeAt(k+1)===10?(d|=2,k++):d|=3,m=k+1):E===10&&(d|=1,N===0&&(R=k),N++,m=k+1)}return N===0&&(R=M.length),[N,R,M.length-m,d]}}),define(Me[133],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0,e.$Ks={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Me[134],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$au=e.$_t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let d=0,k=m.notIn.length;d<k;d++)switch(m.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,d){if(m.getTokenCount()===0)return!0;const k=m.findTokenIndexAtOffset(d-2),O=m.getStandardTokenType(k);return this.isOK(O)}g(m,d){for(let k=m;k<=d;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$_t=F;class M{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of m)N(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),N(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),N(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),N(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&N(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$au=M;function N(R,m,d){R.has(m)?R.get(m).push(d):R.set(m,[d])}}),define(Me[135],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.NodeColor=e.$bC=void 0,e.$dC=M,e.$eC=N,e.$fC=k,e.$gC=O,e.$hC=E,e.$iC=l,e.$jC=w,e.$kC=p;class S{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$cC)return M(this.right);let o=this;for(;o.parent!==e.$cC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$cC?e.$cC:o.parent}prev(){if(this.left!==e.$cC)return N(this.left);let o=this;for(;o.parent!==e.$cC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$cC?e.$cC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$bC=S;var F;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$cC=new S(null,0),e.$cC.parent=e.$cC,e.$cC.left=e.$cC,e.$cC.right=e.$cC,e.$cC.color=0;function M(r){for(;r.left!==e.$cC;)r=r.left;return r}function N(r){for(;r.right!==e.$cC;)r=r.right;return r}function R(r){return r===e.$cC?0:r.size_left+r.piece.length+R(r.right)}function m(r){return r===e.$cC?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function d(){e.$cC.parent=e.$cC}function k(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$cC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$cC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function O(r,o){const s=o.left;o.left=s.right,s.right!==e.$cC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$cC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function E(r,o){let s,n;if(o.left===e.$cC?(n=o,s=n.right):o.right===e.$cC?(n=o,s=n.left):(n=M(o.right),s=n.right),n===r.root){r.root=s,s.color=0,o.detach(),d(),r.root.parent=e.$cC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===o?(s.parent=n.parent,p(r,s)):(n.parent===o?s.parent=n:s.parent=n.parent,p(r,s),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$cC&&(n.left.parent=n),n.right!==e.$cC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,p(r,n)),o.detach(),s.parent.left===s){const h=R(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const v=h-s.parent.size_left,u=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,w(r,s.parent,v,u)}}if(p(r,s.parent),i){d();return}let c;for(;s!==r.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,k(r,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,O(r,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,k(r,s.parent),s=r.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,O(r,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,k(r,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,O(r,s.parent),s=r.root));s.color=0,d()}function l(r,o){for(p(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(r,o)),o.parent.color=0,o.parent.parent.color=1,O(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,O(r,o)),o.parent.color=0,o.parent.parent.color=1,k(r,o.parent.parent))}r.root.color=0}function w(r,o,s,n){for(;o!==r.root&&o!==e.$cC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}function p(r,o){let s=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=R(o.left)-o.size_left,n=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=n;o!==r.root&&(s!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}}}),define(Me[92],Re([1,0,93,29,94,135,95]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.$tC=void 0,e.$rC=O,e.$sC=E;const m=65535;function d(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class k{constructor(n,i,c,h,t){this.lineStarts=n,this.cr=i,this.lf=c,this.crlf=h,this.isBasicASCII=t}}function O(s,n=!0){const i=[0];let c=1;for(let h=0,t=s.length;h<t;h++){const v=s.charCodeAt(h);v===13?h+1<t&&s.charCodeAt(h+1)===10?(i[c++]=h+2,h++):i[c++]=h+1:v===10&&(i[c++]=h+1)}return n?d(i):i}function E(s,n){s.length=0,s[0]=0;let i=1,c=0,h=0,t=0,v=!0;for(let g=0,a=n.length;g<a;g++){const b=n.charCodeAt(g);b===13?g+1<a&&n.charCodeAt(g+1)===10?(t++,s[i++]=g+2,g++):(c++,s[i++]=g+1):b===10?(h++,s[i++]=g+1):v&&b!==9&&(b<32||b>126)&&(v=!1)}const u=new k(d(s),c,h,t,v);return s.length=0,u}class l{constructor(n,i,c,h,t){this.bufferIndex=n,this.start=i,this.end=c,this.lineFeedCnt=h,this.length=t}}e.$tC=l;class w{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$uC=w;class p{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$cC&&n.iterate(n.root,c=>(c!==N.$cC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const c=this.b;for(let h=0;h<c.length;h++){const t=c[h];if(t.node.parent===null||t.nodeStartOffset>=n){c[h]=null,i=!0;continue}}if(i){const h=[];for(const t of c)t!==null&&h.push(t);this.b=h}}}class o{constructor(n,i,c){this.create(n,i,c)}create(n,i,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=N.$cC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let h=null;for(let t=0,v=n.length;t<v;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=O(n[t].buffer));const u=new l(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,u)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=m,c=i-Math.floor(i/3),h=c*2;let t="",v=0;const u=[];if(this.iterate(this.root,g=>{const a=this.R(g),b=a.length;if(v<=c||v+b<h)return t+=a,v+=b,!0;const f=t.replace(/\r\n|\r|\n/g,n);return u.push(new w(f,O(f))),t=a,v=b,!0}),v>0){const g=t.replace(/\r\n|\r|\n/g,n);u.push(new w(g,O(g)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$cC)return!0;const t=this.R(h),v=t.length,u=n.G(i),g=n.G(i+v),a=n.getValueInRange2(u,g);return i+=v,t===a})}getOffsetAt(n,i){let c=0,h=this.root;for(;h!==N.$cC;)if(h.left!==N.$cC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const t=this.B(h,n-h.lf_left-2);return c+=t+i-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,c=0;const h=n;for(;i!==N.$cC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const v=this.getOffsetAt(c+1,1),u=h-v;return new S.$_s(c+1,u+1)}return new S.$_s(c+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$cC){const t=this.getOffsetAt(c+1,1),v=h-n-t;return new S.$_s(c+1,v+1)}else i=i.right;return new S.$_s(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const u=n.node,g=this.a[u.piece.bufferIndex].buffer,a=this.u(u.piece.bufferIndex,u.piece.start);return g.substring(a+n.remainder,a+i.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let v=h.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==N.$cC;){const u=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){v+=u.substring(g,g+i.remainder);break}else v+=u.substr(g,c.piece.length);c=c.next()}return v}getLinesContent(){const n=[];let i=0,c="",h=!1;return this.iterate(this.root,t=>{if(t===N.$cC)return!0;const v=t.piece;let u=v.length;if(u===0)return!0;const g=this.a[v.bufferIndex].buffer,a=this.a[v.bufferIndex].lineStarts,b=v.start.line,f=v.end.line;let I=a[b]+v.start.column;if(h&&(g.charCodeAt(I)===10&&(I++,u--),n[i++]=c,c="",h=!1,u===0))return!0;if(b===f)return!this.f&&g.charCodeAt(I+u-1)===13?(h=!0,c+=g.substr(I,u-1)):c+=g.substr(I,u),!0;c+=this.f?g.substring(I,Math.max(I,a[b+1]-this.e)):g.substring(I,a[b+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;for(let $=b+1;$<f;$++)c=this.f?g.substring(a[$],a[$+1]-this.e):g.substring(a[$],a[$+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;return!this.f&&g.charCodeAt(a[f]+v.end.column-1)===13?(h=!0,v.end.column===0?i--:c=g.substr(a[f],v.end.column-1)):c=g.substr(a[f],v.end.column),!0}),h&&(n[i++]=c,c=""),n[i++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(h)}else{const i=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(n,i){const c=this.H(n,i+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,c,h,t,v,u,g,a,b,f){const I=this.a[n.piece.bufferIndex],$=this.u(n.piece.bufferIndex,n.piece.start),D=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,v);let C;const A={line:0,column:0};let G,T;i._wordSeparators?(G=I.buffer.substring(D,y),T=V=>V+D,i.reset(0)):(G=I.buffer,T=V=>V,i.reset(D));do if(C=i.next(G),C){if(T(C.index)>=y)return b;this.s(n,T(C.index)-$,A);const V=this.t(n.piece.bufferIndex,t,A),P=A.line===t.line?A.column-t.column+h:A.column+1,L=P+C[0].length;if(f[b++]=(0,R.$nC)(new F.$at(c+V,P,c+V,L),C,g),T(C.index)+C[0].length>=y||b>=a)return b}while(C);return b}findMatchesLineByLine(n,i,c,h){const t=[];let v=0;const u=new R.$qC(i.wordSeparators,i.regex);let g=this.H(n.startLineNumber,n.startColumn);if(g===null)return[];const a=this.H(n.endLineNumber,n.endColumn);if(a===null)return[];let b=this.s(g.node,g.remainder);const f=this.s(a.node,a.remainder);if(g.node===a.node)return this.findMatchesInNode(g.node,u,n.startLineNumber,n.startColumn,b,f,i,c,h,v,t),t;let I=n.startLineNumber,$=g.node;for(;$!==a.node;){const y=this.t($.piece.bufferIndex,b,$.piece.end);if(y>=1){const A=this.a[$.piece.bufferIndex].lineStarts,G=this.u($.piece.bufferIndex,$.piece.start),T=A[b.line+y],V=I===n.startLineNumber?n.startColumn:1;if(v=this.findMatchesInNode($,u,I,V,b,this.s($,T-G),i,c,h,v,t),v>=h)return t;I+=y}const C=I===n.startLineNumber?n.startColumn-1:0;if(I===n.endLineNumber){const A=this.getLineContent(I).substring(C,n.endColumn-1);return v=this.n(i,u,A,n.endLineNumber,C,v,t,c,h),t}if(v=this.n(i,u,this.getLineContent(I).substr(C),I,C,v,t,c,h),v>=h)return t;I++,g=this.H(I,1),$=g.node,b=this.s(g.node,g.remainder)}if(I===n.endLineNumber){const y=I===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(I).substring(y,n.endColumn-1);return v=this.n(i,u,C,n.endLineNumber,y,v,t,c,h),t}const D=I===n.startLineNumber?n.startColumn:1;return v=this.findMatchesInNode(a.node,u,I,D,b,f,i,c,h,v,t),t}n(n,i,c,h,t,v,u,g,a){const b=n.wordSeparators;if(!g&&n.simpleSearch){const I=n.simpleSearch,$=I.length,D=c.length;let y=-$;for(;(y=c.indexOf(I,y+$))!==-1;)if((!b||(0,R.$pC)(b,c,D,y,$))&&(u[v++]=new M.$uv(new F.$at(h,y+1+t,h,y+1+$+t),null),v>=a))return v;return v}let f;i.reset(0);do if(f=i.next(c),f&&(u[v++]=(0,R.$nC)(new F.$at(h,f.index+1+t,h,f.index+1+f[0].length+t),f,g),v>=a))return v;while(f);return v}insert(n,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==N.$cC){const{node:h,remainder:t,nodeStartOffset:v}=this.G(n),u=h.piece,g=u.bufferIndex,a=this.s(h,t);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&v+u.length===n&&i.length<m){this.F(h,i),this.y();return}if(v===n)this.o(i,h),this.h.validate(n);else if(v+h.piece.length>n){const b=[];let f=new l(u.bufferIndex,a,u.end,this.t(u.bufferIndex,a,u.end),this.u(g,u.end)-this.u(g,a));if(this.K()&&this.M(i)&&this.I(h,t)===10){const y={line:f.start.line+1,column:0};f=new l(f.bufferIndex,y,f.end,this.t(f.bufferIndex,y,f.end),f.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),i="\r"+i,h.piece.length===0&&b.push(h)}else this.C(h,a);else this.C(h,a);const I=this.w(i);f.length>0&&this.S(h,f);let $=h;for(let D=0;D<I.length;D++)$=this.S($,I[D]);this.v(b)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let v=1;v<h.length;v++)t=this.S(t,h[v])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$cC)return;const c=this.G(n),h=this.G(n+i),t=c.node,v=h.node;if(t===v){const I=this.s(t,c.remainder),$=this.s(t,h.remainder);if(c.nodeStartOffset===n){if(i===t.piece.length){const D=t.next();(0,N.$hC)(this,t),this.N(D),this.y();return}this.D(t,$),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+i){this.C(t,I),this.O(t),this.y();return}this.E(t,I,$),this.y();return}const u=[],g=this.s(t,c.remainder);this.C(t,g),this.h.validate(n),t.piece.length===0&&u.push(t);const a=this.s(v,h.remainder);this.D(v,a),v.piece.length===0&&u.push(v);const b=t.next();for(let I=b;I!==N.$cC&&I!==v;I=I.next())u.push(I);const f=t.piece.length===0?t.prev():t;this.v(u),this.O(f),this.y()}o(n,i){const c=[];if(this.K()&&this.M(n)&&this.L(i)){const v=i.piece,u={line:v.start.line+1,column:0},g=new l(v.bufferIndex,u,v.end,this.t(v.bufferIndex,u,v.end),v.length-1);i.piece=g,n+=`
`,(0,N.$jC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const h=this.w(n);let t=this.T(i,h[h.length-1]);for(let v=h.length-2;v>=0;v--)t=this.T(t,h[v]);this.N(t),this.v(c)}q(n,i){this.Q(n,i)&&(n+=`
`);const c=this.w(n),h=this.S(i,c[0]);let t=h;for(let v=1;v<c.length;v++)t=this.S(t,c[v]);this.N(h)}s(n,i,c){const h=n.piece,t=n.piece.bufferIndex,v=this.a[t].lineStarts,g=v[h.start.line]+h.start.column+i;let a=h.start.line,b=h.end.line,f=0,I=0,$=0;for(;a<=b&&(f=a+(b-a)/2|0,$=v[f],f!==b);)if(I=v[f+1],g<$)b=f-1;else if(g>=I)a=f+1;else break;return c?(c.line=f,c.column=g-$,null):{line:f,column:g-$}}t(n,i,c){if(c.column===0)return c.line-i.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-i.line;const t=h[c.line+1],v=h[c.line]+c.column;if(t>v+1)return c.line-i.line;const u=v-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-i.line+1:c.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$hC)(this,n[i])}w(n){if(n.length>m){const b=[];for(;n.length>m;){const I=n.charCodeAt(m-1);let $;I===13||I>=55296&&I<=56319?($=n.substring(0,m-1),n=n.substring(m-1)):($=n.substring(0,m),n=n.substring(m));const D=O($);b.push(new l(this.a.length,{line:0,column:0},{line:D.length-1,column:$.length-D[D.length-1]},D.length-1,$.length)),this.a.push(new w($,D))}const f=O(n);return b.push(new l(this.a.length,{line:0,column:0},{line:f.length-1,column:n.length-f[f.length-1]},f.length-1,n.length)),this.a.push(new w(n,f)),b}let i=this.a[0].buffer.length;const c=O(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let b=0;b<c.length;b++)c[b]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let b=0;b<c.length;b++)c[b]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,u=t-this.a[0].lineStarts[v],g={line:v,column:u},a=new l(0,h,g,this.t(0,h,g),t-i);return this.g=g,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let c=this.root,h="";const t=this.h.get2(n);if(t){c=t.node;const v=this.B(c,n-t.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(g+v,g+c.piece.length);else{const a=this.B(c,n-t.nodeStartLineNumber);return u.substring(g+v,g+a-i)}}else{let v=0;const u=n;for(;c!==N.$cC;)if(c.left!==N.$cC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const g=this.B(c,n-c.lf_left-2),a=this.B(c,n-c.lf_left-1),b=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);return v+=c.size_left,this.h.set({node:c,nodeStartOffset:v,nodeStartLineNumber:u-(n-1-c.lf_left)}),b.substring(f+g,f+a-i)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const g=this.B(c,n-c.lf_left-2),a=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);h=a.substring(b+g,b+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,v+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==N.$cC;){const v=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),g=this.u(c.piece.bufferIndex,c.piece.start);return h+=v.substring(g,g+u-i),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=v.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,i=1,c=0;for(;n!==N.$cC;)i+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=c,this.h.validate(this.c)}A(n,i){const c=n.piece,h=this.s(n,i),t=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const v=this.t(n.piece.bufferIndex,c.start,h);if(v!==t)return{index:v,remainder:0}}return{index:t,remainder:h.column}}B(n,i){if(i<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[t]-h[c.start.line]-c.start.column}C(n,i){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),v=i,u=this.u(c.bufferIndex,v),g=this.t(c.bufferIndex,c.start,v),a=g-h,b=u-t,f=c.length+b;n.piece=new l(c.bufferIndex,c.start,v,g,f),(0,N.$jC)(this,n,b,a)}D(n,i){const c=n.piece,h=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),v=i,u=this.t(c.bufferIndex,v,c.end),g=this.u(c.bufferIndex,v),a=u-h,b=t-g,f=c.length+b;n.piece=new l(c.bufferIndex,v,c.end,u,f),(0,N.$jC)(this,n,b,a)}E(n,i,c){const h=n.piece,t=h.start,v=h.end,u=h.length,g=h.lineFeedCnt,a=i,b=this.t(h.bufferIndex,h.start,a),f=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);n.piece=new l(h.bufferIndex,h.start,a,b,f),(0,N.$jC)(this,n,f-u,b-g);const I=new l(h.bufferIndex,c,v,this.t(h.bufferIndex,c,v),this.u(h.bufferIndex,v)-this.u(h.bufferIndex,c)),$=this.S(n,I);this.N($)}F(n,i){this.Q(i,n)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=O(i,!1);for(let $=0;$<t.length;$++)t[$]+=h;if(c){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const v=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[v],g={line:v,column:u},a=n.piece.length+i.length,b=n.piece.lineFeedCnt,f=this.t(0,n.piece.start,g),I=f-b;n.piece=new l(n.piece.bufferIndex,n.piece.start,g,f,a),this.g=g,(0,N.$jC)(this,n,i.length,I)}G(n){let i=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;i!==N.$cC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){h+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let c=this.root,h=0;for(;c!==N.$cC;)if(c.left!==N.$cC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),v=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(t+i-1,v),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:h};i-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==N.$cC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),v=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:v}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+i;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$cC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,c=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=c[h]+i.start.column;return h===c.length-1||c[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$cC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const v=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,t,u,v),(0,N.$jC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const g={line:i.piece.start.line+1,column:0},a=i.piece.length-1,b=this.t(i.piece.bufferIndex,g,i.piece.end);i.piece=new l(i.piece.bufferIndex,g,i.piece.end,b,a),(0,N.$jC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const f=this.w(`\r
`);this.S(n,f[0]);for(let I=0;I<c.length;I++)(0,N.$hC)(this,c[I])}Q(n,i){if(this.K()&&this.M(n)){const c=i.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,N.$hC)(this,c);else{const h=c.piece,t={line:h.start.line+1,column:0},v=h.length-1,u=this.t(h.bufferIndex,t,h.end);c.piece=new l(h.bufferIndex,t,h.end,u,v),(0,N.$jC)(this,c,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$cC)return i(N.$cC);const c=this.iterate(n.left,i);return c&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$cC)return"";const i=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(h,t)}getPieceContent(n){const i=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return i.buffer.substring(c,h)}S(n,i){const c=new N.$bC(i,1);if(c.left=N.$cC,c.right=N.$cC,c.parent=N.$cC,c.size_left=0,c.lf_left=0,this.root===N.$cC)this.root=c,c.color=0;else if(n.right===N.$cC)n.right=c,c.parent=n;else{const t=(0,N.$dC)(n.right);t.left=c,c.parent=t}return(0,N.$iC)(this,c),c}T(n,i){const c=new N.$bC(i,1);if(c.left=N.$cC,c.right=N.$cC,c.parent=N.$cC,c.size_left=0,c.lf_left=0,this.root===N.$cC)this.root=c,c.color=0;else if(n.left===N.$cC)n.left=c,c.parent=n;else{const h=(0,N.$eC)(n.left);h.right=c,c.parent=h}return(0,N.$iC)(this,c),c}U(n){let i="";return this.iterate(n,c=>(i+=this.R(c),!0)),i}}e.$vC=o}),define(Me[136],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X9=e.$W9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$W9=S;class F{constructor(N){this.identifier=N}}e.$X9=F}),define(Me[137],Re([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Me[138],Re([1,0,5,6,137]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=void 0,e.$4i=O;class N extends F.$Uc{constructor(l,w="",p="",r=!0,o){super(),this.h=this.B(new S.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=w,this.u=p,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,w){this.C&&await this.C(l)}}e.$Yi=N;class R extends F.$Uc{constructor(){super(...arguments),this.f=this.B(new S.$7d),this.onWillRun=this.f.event,this.m=this.B(new S.$7d),this.onDidRun=this.m.event}async run(l,w){if(!l.enabled)return;this.f.fire({action:l});let p;try{await this.u(l,w)}catch(r){p=r}this.m.fire({action:l,error:p})}async u(l,w){await l.run(w)}}e.$Zi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const p of l)p.length&&(w.length?w=[...w,new m,...p]:w=p);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$1i=m;class d{get actions(){return this.a}constructor(l,w,p,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=r,this.a=p}async run(){}}e.$2i=d;class k extends N{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,M.localize(0,null),void 0,!1)}}e.$3i=k;function O(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...l)=>E.run(...l),tooltip:E.label}}}),define(Me[139],Re([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Me[140],Re([1,0,139]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=k,e.$Nm=O,e.$Om=E;const F=60,M=F*60,N=M*24,R=N*7,m=N*30,d=N*365;function k(l,w,p,r){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,S.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,S.localize)(1,null);let s;return o<F?(s=o,w?s===1?p?(0,S.localize)(2,null,s):(0,S.localize)(3,null,s):p?(0,S.localize)(4,null,s):(0,S.localize)(5,null,s):s===1?p?(0,S.localize)(6,null,s):(0,S.localize)(7,null,s):p?(0,S.localize)(8,null,s):(0,S.localize)(9,null,s)):o<M?(s=Math.floor(o/F),w?s===1?p?(0,S.localize)(10,null,s):(0,S.localize)(11,null,s):p?(0,S.localize)(12,null,s):(0,S.localize)(13,null,s):s===1?p?(0,S.localize)(14,null,s):(0,S.localize)(15,null,s):p?(0,S.localize)(16,null,s):(0,S.localize)(17,null,s)):o<N?(s=Math.floor(o/M),w?s===1?p?(0,S.localize)(18,null,s):(0,S.localize)(19,null,s):p?(0,S.localize)(20,null,s):(0,S.localize)(21,null,s):s===1?p?(0,S.localize)(22,null,s):(0,S.localize)(23,null,s):p?(0,S.localize)(24,null,s):(0,S.localize)(25,null,s)):o<R?(s=Math.floor(o/N),w?s===1?(0,S.localize)(26,null,s):(0,S.localize)(27,null,s):s===1?(0,S.localize)(28,null,s):(0,S.localize)(29,null,s)):o<m?(s=Math.floor(o/R),w?s===1?p?(0,S.localize)(30,null,s):(0,S.localize)(31,null,s):p?(0,S.localize)(32,null,s):(0,S.localize)(33,null,s):s===1?p?(0,S.localize)(34,null,s):(0,S.localize)(35,null,s):p?(0,S.localize)(36,null,s):(0,S.localize)(37,null,s)):o<d?(s=Math.floor(o/m),w?s===1?p?(0,S.localize)(38,null,s):(0,S.localize)(39,null,s):p?(0,S.localize)(40,null,s):(0,S.localize)(41,null,s):s===1?p?(0,S.localize)(42,null,s):(0,S.localize)(43,null,s):p?(0,S.localize)(44,null,s):(0,S.localize)(45,null,s)):(s=Math.floor(o/d),w?s===1?p?(0,S.localize)(46,null,s):(0,S.localize)(47,null,s):p?(0,S.localize)(48,null,s):(0,S.localize)(49,null,s):s===1?p?(0,S.localize)(50,null,s):(0,S.localize)(51,null,s):p?(0,S.localize)(52,null,s):(0,S.localize)(53,null,s))}function O(l,w){const p=Math.abs(l/1e3);return p<1?w?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):p<F?w?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):p<M?w?(0,S.localize)(58,null,Math.round(l/(1e3*F))):(0,S.localize)(59,null,Math.round(l/(1e3*F))):p<N?w?(0,S.localize)(60,null,Math.round(l/(1e3*M))):(0,S.localize)(61,null,Math.round(l/(1e3*M))):(0,S.localize)(62,null,Math.round(l/(1e3*N)))}function E(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Me[141],Re([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Me[41],Re([1,0,18,16,141]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=d,e.$6i=k,e.$7i=O;function N(E,l){return l&&(E.stack||E.stacktrace)?M.localize(0,null,m(E),R(E.stack)||R(E.stacktrace)):m(E)}function R(E){return Array.isArray(E)?E.join(`
`):E}function m(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?M.localize(1,null,E.message):E.message||M.localize(2,null)}function d(E=null,l=!1){if(!E)return M.localize(3,null);if(Array.isArray(E)){const w=S.$Hb(E),p=d(w[0],l);return w.length>1?M.localize(4,null,p,w.length):p}if(F.$Uf(E))return E;if(E.detail){const w=E.detail;if(w.error)return N(w.error,l);if(w.exception)return N(w.exception,l)}return E.stack?N(E,l):E.message?E.message:M.localize(5,null)}function k(E){const l=E;return l instanceof Error&&Array.isArray(l.actions)}function O(E,l){let w;return typeof E=="string"?w=new Error(E):w=E,w.actions=l,w}}),define(Me[142],Re([1,0,39,19]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=m,e.$2q=d,e.$3q=k,e.$4q=O,e.$5q=E,e.$6q=l,e.$7q=w,e.$8q=p,e.$9q=r,e.$0q=o,e.$$q=a,e.$_q=b,e.$ar=f;const M=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),N=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(I,$,D=!1){const y=I||"",C=$||"",A=M.value.collator.compare(y,C);return M.value.collatorIsNumeric&&A===0&&y!==C?y<C?-1:1:A}function d(I,$){const D=N.value.collator;return I=I||"",$=$||"",c(D,I,$)}function k(I,$){const D=N.value.collator;return I=I||"",$=$||"",u(I,$)||c(D,I,$)}function O(I,$){const D=N.value.collator;return I=I||"",$=$||"",v(I,$)||c(D,I,$)}function E(I,$){return I=I||"",$=$||"",I===$?0:I<$?-1:1}function l(I,$){const[D,y]=n(I),[C,A]=n($);let G=M.value.collator.compare(y,A);if(G===0){if(M.value.collatorIsNumeric&&y!==A)return y<A?-1:1;if(G=M.value.collator.compare(D,C),M.value.collatorIsNumeric&&G===0&&D!==C)return D<C?-1:1}return G}function w(I,$){I=I||"",$=$||"";const D=i(I),y=i($),C=N.value.collator,A=R.value.collator;return c(A,D,y)||c(C,I,$)}function p(I,$){I=I||"",$=$||"";const D=i(I),y=i($),C=N.value.collator,A=R.value.collator;return c(A,D,y)||u(I,$)||c(C,I,$)}function r(I,$){I=I||"",$=$||"";const D=i(I),y=i($),C=N.value.collator,A=R.value.collator;return c(A,D,y)||v(I,$)||c(C,I,$)}function o(I,$){I=I||"",$=$||"";const D=i(I).toLowerCase(),y=i($).toLowerCase();return D!==y?D<y?-1:1:I!==$?I<$?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(I,$=!1){const D=I?s.exec(I):[];let y=[D&&D[1]||"",D&&D[3]||""];return $&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(I){const $=I?s.exec(I):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function c(I,$,D){const y=I.compare($,D);return y!==0?y:$.length!==D.length?$.length<D.length?-1:1:0}function h(I){const $=I.charAt(0);return $.toLocaleUpperCase()!==$}function t(I){const $=I.charAt(0);return $.toLocaleLowerCase()!==$}function v(I,$){return h(I)&&t($)?-1:t(I)&&h($)?1:0}function u(I,$){return t(I)&&h($)?-1:h(I)&&t($)?1:0}function g(I,$,D=!1){return D||(I=I&&I.toLowerCase(),$=$&&$.toLowerCase()),I===$?0:I<$?-1:1}function a(I,$,D=!1){const y=I.split(F.sep),C=$.split(F.sep),A=y.length-1,G=C.length-1;let T,V;for(let P=0;;P++){if(T=A===P,V=G===P,T&&V)return m(y[P],C[P],D);if(T)return-1;if(V)return 1;const L=g(y[P],C[P],D);if(L!==0)return L}}function b(I,$,D){const y=I.toLowerCase(),C=$.toLowerCase(),A=f(I,$,D);if(A)return A;const G=y.endsWith(D),T=C.endsWith(D);if(G!==T)return G?-1:1;const V=m(y,C);return V!==0?V:y.localeCompare(C)}function f(I,$,D){const y=I.toLowerCase(),C=$.toLowerCase(),A=y.startsWith(D),G=C.startsWith(D);if(A!==G)return A?-1:1;if(A&&G){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Me[46],Re([1,0,19,21,15,16]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=R,e.$bg=m,e.$cg=d,e.$dg=k,e.$eg=O,e.$fg=p,e.$gg=r,e.$hg=o,e.$ig=s,e.$jg=n,e.$kg=i,e.$lg=c,e.$mg=h,e.$ng=t,e.$og=v,e.$pg=a;function R(b){return b===47||b===92}function m(b){return b.replace(/[\\/]/g,S.$hc.sep)}function d(b){return b.indexOf("/")===-1&&(b=m(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function k(b,f=S.$hc.sep){if(!b)return"";const I=b.length,$=b.charCodeAt(0);if(R($)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let y=3;const C=y;for(;y<I&&!R(b.charCodeAt(y));y++);if(C!==y&&!R(b.charCodeAt(y+1))){for(y+=1;y<I;y++)if(R(b.charCodeAt(y)))return b.slice(0,y+1).replace(/[\\/]/g,f)}}return f}else if(s($)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+f:b.slice(0,2);let D=b.indexOf("://");if(D!==-1){for(D+=3;D<I;D++)if(R(b.charCodeAt(D)))return b.slice(0,D+1)}return""}function O(b){if(!F.$i||!b||b.length<5)return!1;let f=b.charCodeAt(0);if(f!==92||(f=b.charCodeAt(1),f!==92))return!1;let I=2;const $=I;for(;I<b.length&&(f=b.charCodeAt(I),f!==92);I++);return!($===I||(f=b.charCodeAt(I+1),isNaN(f)||f===92))}const E=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(b,f=F.$i){const I=f?E:l;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||f&&w.test(b)||b==="."||b===".."||f&&b[b.length-1]==="."||f&&b.length!==b.trim().length||b.length>255)}function r(b,f,I){const $=b===f;return!I||$?$:!b||!f?!1:(0,M.$lf)(b,f)}function o(b,f,I,$=S.sep){if(b===f)return!0;if(!b||!f||f.length>b.length)return!1;if(I){if(!(0,M.$mf)(b,f))return!1;if(f.length===b.length)return!0;let y=f.length;return f.charAt(f.length-1)===$&&y--,b.charAt(y)===$}return f.charAt(f.length-1)!==$&&(f+=$),b.indexOf(f)===0}function s(b){return b>=65&&b<=90||b>=97&&b<=122}function n(b,f){return F.$i&&b.endsWith(":")&&(b+=S.sep),(0,S.$jc)(b)||(b=(0,S.$kc)(f,b)),b=(0,S.$ic)(b),F.$i?(b=(0,M.$6e)(b,S.sep),b.endsWith(":")&&(b+=S.sep)):(b=(0,M.$6e)(b,S.sep),b||(b=S.sep)),b}function i(b){const f=(0,S.$ic)(b);return F.$i?b.length>3?!1:c(f)&&(b.length===2||f.charCodeAt(2)===92):f===S.$hc.sep}function c(b,f=F.$i){return f?s(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function h(b,f=F.$i){return c(b,f)?b[0]:void 0}function t(b,f,I){return f.length>b.length?-1:b===f?0:(I&&(b=b.toLowerCase(),f=f.toLowerCase()),b.indexOf(f))}function v(b){const f=b.split(":");let I,$,D;for(const y of f){const C=Number(y);(0,N.$Yf)(C)?$===void 0?$=C:D===void 0&&(D=C):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:$!==void 0?$:void 0,column:D!==void 0?D:$!==void 0?1:void 0}}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(b,f,I=8){let $="";for(let y=0;y<I;y++){let C;y===0&&F.$i&&!f&&(I===3||I===4)?C=g:C=u,$+=C.charAt(Math.floor(Math.random()*C.length))}let D;return f?D=`${f}-${$}`:D=$,b?(0,S.$kc)(b,D):D}}),define(Me[69],Re([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0,e.$ys=N,e.$zs=R,e.$As=m,e.$Bs=k,e.$xs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const E=(0,S.$pc)(O),l=F[E.toLowerCase()];return l!==void 0?l:R(O)}function R(O){const E=(0,S.$pc)(O);return M[E.toLowerCase()]}function m(O){for(const E in M)if(M[E]===O)return E}const d=/^(.+)\/(.+?)(;.+)?$/;function k(O,E){const l=d.exec(O);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:E?void 0:O}}),define(Me[52],Re([1,0,23,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=M,e.$Ph=N,e.$Qh=m;function M(d){return JSON.stringify(d,R)}function N(d){let k=JSON.parse(d);return k=m(k),k}function R(d,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function m(d,k=0){if(!d||k>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return F.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof S.$ue||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let O=0;O<d.length;++O)d[O]=m(d[O],k+1);else for(const O in d)Object.hasOwnProperty.call(d,O)&&(d[O]=m(d[O],k+1))}return d}}),define(Me[12],Re([1,0,14,21,15,2,19]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$ug=e.$tg=e.$sg=e.Schemas=void 0,e.$qg=d,e.$rg=k,e.$vg=E;var m;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatCodeBlock="vscode-chat-code-block",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm",p.codeSetting="code-setting"})(m||(e.Schemas=m={}));function d(p,r){return N.URI.isUri(p)?(0,M.$lf)(p.scheme,r):(0,M.$mf)(p,r+":")}function k(p,...r){return r.some(o=>d(p,o))}e.$sg="vscode-tkn",e.$tg="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=E(r,o)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,m.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return S.$1(h),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[o],i=this.c[o];let c=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(c+=`&${e.$tg}=${encodeURIComponent(i)}`),N.URI.from({scheme:F.$o?this.d:m.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:c})}}e.$ug=new O;function E(p,r){return R.$hc.join(r??"/",`${p.quality??"oss"}-${p.commit??"dev"}`)}e.$wg="vs/../../extensions",e.$xg="vs/../../node_modules",e.$yg="vs/../../node_modules.asar",e.$zg="vs/../../node_modules.asar.unpacked",e.$Ag="vscode-app";class l{static{this.a=e.$Ag}asBrowserUri(r){const o=this.b(r,me);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===m.vscodeRemote?e.$ug.rewrite(r):r.scheme===m.file&&(F.$m||F.$q===`${m.vscodeFileResource}://${l.a}`)?r.with({scheme:m.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,me);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===m.vscodeFileResource?r.with({scheme:m.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return N.URI.isUri(r)?r:N.URI.parse(o.toUrl(r))}}e.$Bg=new l;var w;(function(p){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:N.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const h=c?.get(o);if(h)return r.get(h)}p.getHeadersFromQuery=s;function n(i,c,h){if(!globalThis.crossOriginIsolated)return;const t=c&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}p.addSearchParam=n})(w||(e.COI=w={}))}),define(Me[24],Re([1,0,46,12,19,21,15,2]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0,e.$Ig=d,e.$4g=O,e.$5g=l;function d(w){return(0,m.$xc)(w,!0)}class k{constructor(p){this.a=p}compare(p,r,o=!1){return p===r?0:(0,R.$ef)(this.getComparisonKey(p,o),this.getComparisonKey(r,o))}isEqual(p,r,o=!1){return p===r?!0:!p||!r?!1:this.getComparisonKey(p,o)===this.getComparisonKey(r,o)}getComparisonKey(p,r=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,r,o=!1){if(p.scheme===r.scheme){if(p.scheme===F.Schemas.file)return S.$hg(d(p),d(r),this.a(p))&&p.query===r.query&&(o||p.fragment===r.fragment);if((0,e.$Zg)(p.authority,r.authority))return S.$hg(p.path,r.path,this.a(p),"/")&&p.query===r.query&&(o||p.fragment===r.fragment)}return!1}joinPath(p,...r){return m.URI.joinPath(p,...r)}basenameOrAuthority(p){return(0,e.$Rg)(p)||p.authority}basename(p){return M.$hc.basename(p.path)}extname(p){return M.$hc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let r;return p.scheme===F.Schemas.file?r=m.URI.file(M.$nc(d(p))).path:(r=M.$hc.dirname(p.path),p.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),r="/")),p.with({path:r})}normalizePath(p){if(!p.path.length)return p;let r;return p.scheme===F.Schemas.file?r=m.URI.file(M.$ic(d(p))).path:r=M.$hc.normalize(p.path),p.with({path:r})}relativePath(p,r){if(p.scheme!==r.scheme||!(0,e.$Zg)(p.authority,r.authority))return;if(p.scheme===F.Schemas.file){const n=M.$mc(d(p),d(r));return N.$i?S.$bg(n):n}let o=p.path||"/";const s=r.path||"/";if(this.a(p)){let n=0;for(const i=Math.min(o.length,s.length);n<i&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return M.$hc.relative(o,s)}resolvePath(p,r){if(p.scheme===F.Schemas.file){const o=m.URI.file(M.$lc(d(p),r));return p.with({authority:o.authority,path:o.path})}return r=S.$cg(r),p.with({path:M.$hc.resolve(p.path,r)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,r){return p===r||p!==void 0&&r!==void 0&&(0,R.$lf)(p,r)}hasTrailingPathSeparator(p,r=M.sep){if(p.scheme===F.Schemas.file){const o=d(p);return o.length>S.$dg(o).length&&o[o.length-1]===r}else{const o=p.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,r=M.sep){return(0,e.$1g)(p,r)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,r=M.sep){let o=!1;if(p.scheme===F.Schemas.file){const s=d(p);o=s!==void 0&&s.length===S.$dg(s).length&&s[s.length-1]===r}else{r="/";const s=p.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$1g)(p,r)?p.with({path:p.path+"/"}):p}}e.$Jg=k,e.$Kg=new k(()=>!1),e.$Lg=new k(w=>w.scheme===F.Schemas.file?!N.$k:!0),e.$Mg=new k(w=>!0),e.$Ng=e.$Kg.isEqual.bind(e.$Kg),e.$Og=e.$Kg.isEqualOrParent.bind(e.$Kg),e.$Pg=e.$Kg.getComparisonKey.bind(e.$Kg),e.$Qg=e.$Kg.basenameOrAuthority.bind(e.$Kg),e.$Rg=e.$Kg.basename.bind(e.$Kg),e.$Sg=e.$Kg.extname.bind(e.$Kg),e.$Tg=e.$Kg.dirname.bind(e.$Kg),e.$Ug=e.$Kg.joinPath.bind(e.$Kg),e.$Vg=e.$Kg.normalizePath.bind(e.$Kg),e.$Wg=e.$Kg.relativePath.bind(e.$Kg),e.$Xg=e.$Kg.resolvePath.bind(e.$Kg),e.$Yg=e.$Kg.isAbsolutePath.bind(e.$Kg),e.$Zg=e.$Kg.isEqualAuthority.bind(e.$Kg),e.$1g=e.$Kg.hasTrailingPathSeparator.bind(e.$Kg),e.$2g=e.$Kg.removeTrailingPathSeparator.bind(e.$Kg),e.$3g=e.$Kg.addTrailingPathSeparator.bind(e.$Kg);function O(w,p){const r=[];for(let o=0;o<w.length;o++){const s=p(w[o]);w.some((n,i)=>i===o?!1:(0,e.$Og)(s,p(n)))||r.push(w[o])}return r}var E;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function p(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,h]=i.split(":");c&&h&&o.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(w.META_DATA_MIME,n),o}w.parseMetaData=p})(E||(e.DataUri=E={}));function l(w,p,r){if(p){let o=w.path;return o&&o[0]!==M.$hc.sep&&(o=M.$hc.sep+o),w.with({scheme:r,authority:p,path:o})}return w.with({scheme:r})}}),define(Me[11],Re([1,0,25,14,5,6,24,21,129,39]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.Promises=e.$Eh=e.$Dh=e.$Ch=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=void 0,e.$6g=O,e.$7g=E,e.$8g=l,e.$9g=w,e.$0g=p,e.$$g=r,e.$_g=o,e.$ah=s,e.$ih=b,e.$jh=f,e.$kh=I,e.$lh=$,e.$mh=D,e.$Bh=Se,e.$Jh=Ie;function O(ge){return!!ge&&typeof ge.then=="function"}function E(ge){const J=new S.$ee,X=ge(J.token),ce=new Promise((de,Oe)=>{const he=J.token.onCancellationRequested(()=>{he.dispose(),Oe(new F.$5)});Promise.resolve(X).then(Ce=>{he.dispose(),J.dispose(),de(Ce)},Ce=>{he.dispose(),J.dispose(),Oe(Ce)})});return new class{cancel(){J.cancel(),J.dispose()}then(de,Oe){return ce.then(de,Oe)}catch(de){return this.then(void 0,de)}finally(de){return ce.finally(de)}}}function l(ge,J,X){return new Promise((ce,de)=>{const Oe=J.onCancellationRequested(()=>{Oe.dispose(),ce(X)});ge.then(ce,de).finally(()=>Oe.dispose())})}function w(ge,J){return new Promise((X,ce)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ce(new F.$5)});ge.then(X,ce).finally(()=>de.dispose())})}async function p(ge){let J=-1;const X=ge.map((ce,de)=>ce.then(Oe=>(J=de,Oe)));try{return await Promise.race(X)}finally{ge.forEach((ce,de)=>{de!==J&&ce.cancel()})}}function r(ge,J,X){let ce;const de=setTimeout(()=>{ce?.(void 0),X?.()},J);return Promise.race([ge.finally(()=>clearTimeout(de)),new Promise(Oe=>ce=Oe)])}function o(ge){return new Promise((J,X)=>{const ce=ge();O(ce)?ce.then(J,X):J(ce)})}function s(){let ge,J;return{promise:new Promise((ce,de)=>{ge=ce,J=de}),resolve:ge,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const X=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(X,X).then(ce)})}return new Promise((X,ce)=>{this.b.then(X,ce)})}return this.a=J(),new Promise((X,ce)=>{this.a.then(de=>{this.a=null,X(de)},de=>{this.a=null,ce(de)})})}dispose(){this.f=!0}}e.$bh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$ch=i;class c{constructor(){this.a=new Map}queue(J,X){const de=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(J)===de&&this.a.delete(J)});return this.a.set(J,de),de}}e.$dh=c;const h=(ge,J)=>{let X=!0;const ce=setTimeout(()=>{X=!1,J()},ge);return{isTriggered:()=>X,dispose:()=>{clearTimeout(ce),X=!1}}},t=ge=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ge())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class v{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,X=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((de,Oe)=>{this.d=de,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=X===d.$4d?t(ce):h(X,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$eh=v;class u{constructor(J){this.a=new v(J),this.b=new n}trigger(J,X){return this.a.trigger(()=>this.b.queue(J),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$fh=u;class g{constructor(){this.a=!1,this.b=new Promise((J,X)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$gh=g;class a extends g{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$hh=a;function b(ge,J){return J?new Promise((X,ce)=>{const de=setTimeout(()=>{Oe.dispose(),X()},ge),Oe=J.onCancellationRequested(()=>{clearTimeout(de),Oe.dispose(),ce(new F.$5)})}):E(X=>b(ge,X))}function f(ge,J=0,X){const ce=setTimeout(()=>{ge(),X&&de.dispose()},J),de=(0,N.$Sc)(()=>{clearTimeout(ce),X?.deleteAndLeak(de)});return X?.add(de),de}function I(ge){const J=[];let X=0;const ce=ge.length;function de(){return X<ce?ge[X++]():null}function Oe(he){he!=null&&J.push(he);const Ce=de();return Ce?Ce.then(Oe):Promise.resolve(J)}return Promise.resolve(null).then(Oe)}function $(ge,J=ce=>!!ce,X=null){let ce=0;const de=ge.length,Oe=()=>{if(ce>=de)return Promise.resolve(X);const he=ge[ce++];return Promise.resolve(he()).then(Ae=>J(Ae)?Promise.resolve(Ae):Oe())};return Oe()}function D(ge,J=ce=>!!ce,X=null){if(ge.length===0)return Promise.resolve(X);let ce=ge.length;const de=()=>{ce=-1;for(const Oe of ge)Oe.cancel?.()};return new Promise((Oe,he)=>{for(const Ce of ge)Ce.then(Ae=>{--ce>=0&&J(Ae)?(de(),Oe(Ae)):ce===0&&Oe(X)}).catch(Ae=>{--ce>=0&&(de(),he(Ae))})})}class y{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new M.$7d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,ce)=>{this.g.push({factory:J,c:X,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const X=J.factory();X.then(J.c,J.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$nh=y;class C extends y{constructor(){super(1)}}e.$oh=C;class A{constructor(){this.a=new le,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$ph=A;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ve;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,X=R.$Kg){const ce=X.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,X,ce=R.$Kg){const de=ce.getComparisonKey(J);let Oe=this.a.get(de);if(!Oe){Oe=new C;const he=this.f++,Ce=M.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(he,Ce),this.a.set(de,Oe)}return Oe.queue(X)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$qh=G;class T{constructor(J,X){this.a=-1,typeof J=="function"&&typeof X=="number"&&this.setIfNotSet(J,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},X)}setIfNotSet(J,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},X))}}e.$rh=T;class V{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,X,ce=globalThis){this.cancel();const de=ce.setInterval(()=>{J()},X);this.d=(0,N.$Sc)(()=>{ce.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$sh=V;class P{constructor(J,X){this.b=-1,this.a=J,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$th=P;class L{constructor(J,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=J,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$uh=L;class q extends P{constructor(J,X){super(J,X),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$vh=q;class re extends N.$Uc{constructor(J,X){super(),this.g=J,this.h=X,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of J)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new P(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$wh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$yh=(ge,J)=>{(0,m.$B)(()=>{if(X)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$yh=(ge,J,X)=>{const ce=ge.requestIdleCallback(J,typeof X=="number"?{timeout:X}:void 0);let de=!1;return{dispose(){de||(de=!0,ge.cancelIdleCallback(ce))}}},e.$xh=ge=>(0,e.$yh)(globalThis,ge)}();class ue{constructor(J,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$yh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$zh=ue;class ye extends ue{constructor(J){super(globalThis,J)}}e.$Ah=ye;async function Se(ge,J,X){let ce;for(let de=0;de<X;de++)try{return await ge()}catch(Oe){ce=Oe,await b(J)}throw ce}class le{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,X,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:X},X.then(()=>this.d(J),()=>this.d(J)),X}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:X,resolve:ce,reject:de}=s();this.b={run:J,promise:X,promiseResolve:ce,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ch=le;class we{constructor(J,X=()=>Date.now()){this.d=J,this.f=X,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Dh=we;var _;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(_||(_={}));class ve{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,X)=>{this.a=J,this.b=X})}complete(J){return new Promise(X=>{this.a(J),this.d={outcome:0,value:J},X()})}error(J){return new Promise(X=>{this.b(J),this.d={outcome:1,value:J},X()})}cancel(){return this.error(new F.$5)}}e.$Eh=ve;var ne;(function(ge){async function J(ce){let de;const Oe=await Promise.all(ce.map(he=>he.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de<"u")throw de;return Oe}ge.settled=J;function X(ce){return new Promise(async(de,Oe)=>{try{await ce(de,Oe)}catch(he){Oe(he)}})}ge.withAsyncBody=X})(ne||(e.Promises=ne={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Fh=fe;class W{constructor(J){this.b=J,this.a=new k.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Gh=W;var te;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(te||(te={}));class Ee{static fromArray(J){return new Ee(X=>{X.emitMany(J)})}static fromPromise(J){return new Ee(async X=>{X.emitMany(await J)})}static fromPromises(J){return new Ee(async X=>{await Promise.all(J.map(async ce=>X.emitOne(await ce)))})}static merge(J){return new Ee(async X=>{await Promise.all(J.map(async ce=>{for await(const de of ce)X.emitOne(de)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new M.$7d,queueMicrotask(async()=>{const X={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(X)),this.j()}catch(ce){this.k(ce)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(J,X){return new Ee(async ce=>{for await(const de of J)ce.emitOne(X(de))})}map(J){return Ee.map(this,J)}static filter(J,X){return new Ee(async ce=>{for await(const de of J)X(de)&&ce.emitOne(de)})}filter(J){return Ee.filter(this,J)}static coalesce(J){return Ee.filter(J,X=>!!X)}coalesce(){return Ee.coalesce(this)}static async toPromise(J){const X=[];for await(const ce of J)X.push(ce);return X}toPromise(){return Ee.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Hh=Ee;class Te extends Ee{constructor(J,X){super(X),this.l=J}cancel(){this.l.cancel()}}e.$Ih=Te;function Ie(ge){const J=new S.$ee,X=ge(J.token);return new Te(J,async ce=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),J.dispose(),ce.reject(new F.$5)});try{for await(const Oe of X){if(J.token.isCancellationRequested)return;ce.emitOne(Oe)}de.dispose(),J.dispose()}catch(Oe){de.dispose(),J.dispose(),ce.reject(Oe)}})}class pe{constructor(){this.a=new ve,this.b=new Ee(ce=>{if(J){ce.reject(J);return}return X&&ce.emitMany(X),this.d=de=>ce.reject(de),this.f=de=>ce.emitOne(de),this.a.p});let J,X;this.f=ce=>{X||(X=[]),X.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Kh=pe}),define(Me[34],Re([1,0,18,11,46,28,19,21,15]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=void 0,e.$9j=k,e.$_j=p,e.$ak=C,e.$bk=A,e.$ck=G,e.$dk=T,e.$ek=V,e.$fk=re;function k(){return Object.create(null)}e.$0j="**",e.$$j="/";const O="[/\\\\]",E="[^/\\\\]",l=/\//g;function w(ue,ye){switch(ue){case 0:return"";case 1:return`${E}*?`;default:return`(?:${O}|${E}+${O}${ye?`|${O}${E}+`:""})*?`}}function p(ue,ye){if(!ue)return[];const Se=[];let le=!1,we=!1,_="";for(const ve of ue){switch(ve){case ye:if(!le&&!we){Se.push(_),_="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":we=!0;break;case"]":we=!1;break}_+=ve}return _&&Se.push(_),Se}function r(ue){if(!ue)return"";let ye="";const Se=p(ue,e.$$j);if(Se.every(le=>le===e.$0j))ye=".*";else{let le=!1;Se.forEach((we,_)=>{if(we===e.$0j){if(le)return;ye+=w(2,_===Se.length-1)}else{let ve=!1,ne="",fe=!1,W="";for(const te of we){if(te!=="}"&&ve){ne+=te;continue}if(fe&&(te!=="]"||!W)){let Ee;te==="-"?Ee=te:(te==="^"||te==="!")&&!W?Ee="^":te===e.$$j?Ee="":Ee=(0,d.$Ze)(te),W+=Ee;continue}switch(te){case"{":ve=!0;continue;case"[":fe=!0;continue;case"}":{const Te=`(?:${p(ne,",").map(Ie=>r(Ie)).join("|")})`;ye+=Te,ve=!1,ne="";break}case"]":{ye+="["+W+"]",fe=!1,W="";break}case"?":ye+=E;continue;case"*":ye+=w(1);continue;default:ye+=(0,d.$Ze)(te)}}_<Se.length-1&&(Se[_+1]!==e.$0j||_+2<Se.length)&&(ye+=O)}le=we===e.$0j})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),v=function(){return!1},u=function(){return null};function g(ue,ye){if(!ue)return u;let Se;typeof ue!="string"?Se=ue.pattern:Se=ue,Se=Se.trim();const le=`${Se}_${!!ye.trimForExclusions}`;let we=t.get(le);if(we)return a(we,ue);let _;return o.test(Se)?we=f(Se.substr(4),Se):(_=s.exec(b(Se,ye)))?we=I(_[1],Se):(ye.trimForExclusions?i:n).test(Se)?we=$(Se,ye):(_=c.exec(b(Se,ye)))?we=D(_[1].substr(1),Se,!0):(_=h.exec(b(Se,ye)))?we=D(_[1],Se,!1):we=y(Se),t.set(le,we),a(we,ue)}function a(ue,ye){if(typeof ye=="string")return ue;const Se=function(le,we){return(0,M.$hg)(le,ye.base,!m.$k)?ue((0,d.$5e)(le.substr(ye.base.length),R.sep),we):null};return Se.allBasenames=ue.allBasenames,Se.allPaths=ue.allPaths,Se.basenames=ue.basenames,Se.patterns=ue.patterns,Se}function b(ue,ye){return ye.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function f(ue,ye){return function(Se,le){return typeof Se=="string"&&Se.endsWith(ue)?ye:null}}function I(ue,ye){const Se=`/${ue}`,le=`\\${ue}`,we=function(ve,ne){return typeof ve!="string"?null:ne?ne===ue?ye:null:ve===ue||ve.endsWith(Se)||ve.endsWith(le)?ye:null},_=[ue];return we.basenames=_,we.patterns=[ye],we.allBasenames=_,we}function $(ue,ye){const Se=q(ue.slice(1,-1).split(",").map(ne=>g(ne,ye)).filter(ne=>ne!==u),ue),le=Se.length;if(!le)return u;if(le===1)return Se[0];const we=function(ne,fe){for(let W=0,te=Se.length;W<te;W++)if(Se[W](ne,fe))return ue;return null},_=Se.find(ne=>!!ne.allBasenames);_&&(we.allBasenames=_.allBasenames);const ve=Se.reduce((ne,fe)=>fe.allPaths?ne.concat(fe.allPaths):ne,[]);return ve.length&&(we.allPaths=ve),we}function D(ue,ye,Se){const le=R.sep===R.$hc.sep,we=le?ue:ue.replace(l,R.sep),_=R.sep+we,ve=R.$hc.sep+ue;let ne;return Se?ne=function(fe,W){return typeof fe=="string"&&(fe===we||fe.endsWith(_)||!le&&(fe===ue||fe.endsWith(ve)))?ye:null}:ne=function(fe,W){return typeof fe=="string"&&(fe===we||!le&&fe===ue)?ye:null},ne.allPaths=[(Se?"*/":"./")+ue],ne}function y(ue){try{const ye=new RegExp(`^${r(ue)}$`);return function(Se){return ye.lastIndex=0,typeof Se=="string"&&ye.test(Se)?ue:null}}catch{return u}}function C(ue,ye,Se){return!ue||typeof ye!="string"?!1:A(ue)(ye,void 0,Se)}function A(ue,ye={}){if(!ue)return v;if(typeof ue=="string"||G(ue)){const Se=g(ue,ye);if(Se===u)return v;const le=function(we,_){return!!Se(we,_)};return Se.allBasenames&&(le.allBasenames=Se.allBasenames),Se.allPaths&&(le.allPaths=Se.allPaths),le}return P(ue,ye)}function G(ue){const ye=ue;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function T(ue){return ue.allBasenames||[]}function V(ue){return ue.allPaths||[]}function P(ue,ye){const Se=q(Object.getOwnPropertyNames(ue).map(ne=>L(ne,ue[ne],ye)).filter(ne=>ne!==u)),le=Se.length;if(!le)return u;if(!Se.some(ne=>!!ne.requiresSiblings)){if(le===1)return Se[0];const ne=function(te,Ee){let Te;for(let Ie=0,pe=Se.length;Ie<pe;Ie++){const ge=Se[Ie](te,Ee);if(typeof ge=="string")return ge;(0,F.$6g)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const Ie of Te){const pe=await Ie;if(typeof pe=="string")return pe}return null})():null},fe=Se.find(te=>!!te.allBasenames);fe&&(ne.allBasenames=fe.allBasenames);const W=Se.reduce((te,Ee)=>Ee.allPaths?te.concat(Ee.allPaths):te,[]);return W.length&&(ne.allPaths=W),ne}const we=function(ne,fe,W){let te,Ee;for(let Te=0,Ie=Se.length;Te<Ie;Te++){const pe=Se[Te];pe.requiresSiblings&&W&&(fe||(fe=(0,R.$oc)(ne)),te||(te=fe.substr(0,fe.length-(0,R.$pc)(ne).length)));const ge=pe(ne,fe,te,W);if(typeof ge=="string")return ge;(0,F.$6g)(ge)&&(Ee||(Ee=[]),Ee.push(ge))}return Ee?(async()=>{for(const Te of Ee){const Ie=await Te;if(typeof Ie=="string")return Ie}return null})():null},_=Se.find(ne=>!!ne.allBasenames);_&&(we.allBasenames=_.allBasenames);const ve=Se.reduce((ne,fe)=>fe.allPaths?ne.concat(fe.allPaths):ne,[]);return ve.length&&(we.allPaths=ve),we}function L(ue,ye,Se){if(ye===!1)return u;const le=g(ue,Se);if(le===u)return u;if(typeof ye=="boolean")return le;if(ye){const we=ye.when;if(typeof we=="string"){const _=(ve,ne,fe,W)=>{if(!W||!le(ve,ne))return null;const te=we.replace("$(basename)",()=>fe),Ee=W(te);return(0,F.$6g)(Ee)?Ee.then(Te=>Te?ue:null):Ee?ue:null};return _.requiresSiblings=!0,_}}return le}function q(ue,ye){const Se=ue.filter(ne=>!!ne.basenames);if(Se.length<2)return ue;const le=Se.reduce((ne,fe)=>{const W=fe.basenames;return W?ne.concat(W):ne},[]);let we;if(ye){we=[];for(let ne=0,fe=le.length;ne<fe;ne++)we.push(ye)}else we=Se.reduce((ne,fe)=>{const W=fe.patterns;return W?ne.concat(W):ne},[]);const _=function(ne,fe){if(typeof ne!="string")return null;if(!fe){let te;for(te=ne.length;te>0;te--){const Ee=ne.charCodeAt(te-1);if(Ee===47||Ee===92)break}fe=ne.substr(te)}const W=le.indexOf(fe);return W!==-1?we[W]:null};_.basenames=le,_.patterns=we,_.allBasenames=le;const ve=ue.filter(ne=>!ne.basenames);return ve.push(_),ve}function re(ue,ye){return(0,S.$ub)(ue,ye,(Se,le)=>typeof Se=="string"&&typeof le=="string"?Se===le:typeof Se!="string"&&typeof le!="string"?Se.base===le.base&&Se.pattern===le.pattern:!1)}}),define(Me[53],Re([1,0,14,130,24,15,2]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=e.MarkdownStringTextNewlineStyle=void 0,e.$Fk=k,e.$Gk=O,e.$Hk=E,e.$Ik=l,e.$Jk=w,e.$Kk=p,e.$Lk=r,e.$Mk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class d{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,S.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=l(this.supportThemeIcons?(0,F.$yk)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${w(i,n)}
`,this}appendLink(n,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,i){const c=new RegExp((0,N.$Ze)(i),"g");return n.replace(c,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Ek=d;function k(s){return O(s)?!s.value:Array.isArray(s)?s.every(k):!0}function O(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function E(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,M.$Ng)(R.URI.from(s.baseUri),R.URI.from(n.baseUri)))}function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,n){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${n}`,s,`${"`".repeat(c)}`].join(`
`)}function p(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const n=[],i=s.split("|").map(h=>h.trim());s=i[0];const c=i[1];if(c){const h=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),v=h?h[1]:"",u=t?t[1]:"",g=isFinite(parseInt(u)),a=isFinite(parseInt(v));g&&n.push(`width="${u}"`),a&&n.push(`height="${v}"`)}return{href:s,dimensions:n}}}),define(Me[96],Re([1,0,18,46,19,21,24,15]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=d,e.$fw=O,e.$gw=l,e.$hw=w,e.$iw=s,e.$jw=i,e.$kw=c,e.$lw=h,e.$mw=t,e.$nw=v;function d(g,a){const{os:b,tildify:f,relative:I}=a;if(I){const y=k(g,I,b);if(typeof y=="string")return y}let $=g.fsPath;if(b===1&&!N.$i?$=$.replace(/\//g,"\\"):b!==1&&N.$i&&($=$.replace(/\\/g,"/")),b!==1&&f?.userHome){const y=f.userHome.fsPath;let C;g.scheme!==f.userHome.scheme&&g.path[0]===M.$hc.sep&&g.path[1]!==M.$hc.sep?C=f.userHome.with({path:g.path}).fsPath:C=$,$=l(C,y,b)}return(b===1?M.$gc:M.$hc).normalize(O($,b===1))}function k(g,a,b){const f=b===1?M.$gc:M.$hc,I=b===3?R.$Kg:R.$Mg,$=a.getWorkspace(),D=(0,S.$Ob)($.folders);if(!D)return;g.scheme!==D.uri.scheme&&g.path[0]===M.$hc.sep&&g.path[1]!==M.$hc.sep&&(g=D.uri.with({path:g.path}));const y=a.getWorkspaceFolder(g);if(!y)return;let C;if(I.isEqual(y.uri,g)?C="":C=I.relativePath(y.uri,g)??"",C&&(C=f.normalize(C)),$.folders.length>1&&!a.noPrefix){const A=y.name?y.name:I.basenameOrAuthority(y.uri);C=C?`${A} \u2022 ${C}`:A}return C}function O(g,a=N.$i){return(0,F.$lg)(g,a)?g.charAt(0).toUpperCase()+g.slice(1):g}let E=Object.create(null);function l(g,a,b=N.OS){if(b===1||!g||!a)return g;let f=E.original===a?E.normalized:void 0;f||(f=a,N.$i&&(f=(0,F.$bg)(f)),f=`${(0,m.$6e)(f,M.$hc.sep)}${M.$hc.sep}`,E={original:a,normalized:f});let I=g;return N.$i&&(I=(0,F.$bg)(I)),(b===3?I.startsWith(f):(0,m.$mf)(I,f))?`~/${I.substr(f.length)}`:g}function w(g,a){return g.replace(/^~($|\/|\\)/,`${a}$1`)}const p="\u2026",r="\\\\",o="~";function s(g,a=M.sep){const b=new Array(g.length);let f=!1;for(let I=0;I<g.length;I++){const $=g[I];if($===""){b[I]=`.${a}`;continue}if(!$){b[I]=$;continue}f=!0;let D="",y=$;y.indexOf(r)===0?(D=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(a)===0?(D=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(o)===0&&(D=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(a);for(let A=1;f&&A<=C.length;A++)for(let G=C.length-A;f&&G>=0;G--){f=!1;let T=C.slice(G,G+A).join(a);for(let V=0;!f&&V<g.length;V++)if(V!==I&&g[V]&&g[V].indexOf(T)>-1){const P=G+A===C.length,L=G>0&&g[V].indexOf(a)>-1?a+T:T,q=g[V].endsWith(L);f=!P||q}if(!f){let V="";(C[0].endsWith(":")||D!=="")&&(G===1&&(G=0,A++,T=C[0]+a+T),G>0&&(V=C[0]+a),V=D+V),G>0&&(V=V+p+a),V=V+T,G+A<C.length&&(V=V+a+p),b[I]=V}}f&&(b[I]=$)}return b}var n;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(g,a=Object.create(null)){const b=[];let f=!1,I="";for(const $ of g)if($==="$"||f&&$==="{")I&&b.push({value:I,type:n.TEXT}),I="",f=!0;else if($==="}"&&f){const D=a[I];if(typeof D=="string")D.length&&b.push({value:D,type:n.VARIABLE});else if(D){const y=b[b.length-1];(!y||y.type!==n.SEPARATOR)&&b.push({value:D.label,type:n.SEPARATOR})}I="",f=!1}else I+=$;return I&&!f&&b.push({value:I,type:n.TEXT}),b.filter(($,D)=>{if($.type===n.SEPARATOR){const y=b[D-1],C=b[D+1];return[y,C].every(A=>A&&(A.type===n.VARIABLE||A.type===n.TEXT)&&A.value.length>0)}return!0}).map($=>$.value).join("")}function c(g,a){return N.$j||a?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):g.replace(/&&|&/g,b=>b==="&"?"&&":"&")}function h(g,a){return N.$j||a?g.replace(/\(&&\w\)|&&/g,""):N.$i?g.replace(/&&|&/g,b=>b==="&"?"&&":"&"):g.replace(/&&/g,"_")}function t(g){return g.replace(/&/g,"&&")}function v(g){if(g.endsWith("]")){const a=g.lastIndexOf(" [",g.length-2);if(a!==-1){const b=u(g.substring(0,a)),f=g.substring(a);return{name:b.name+f,parentPath:b.parentPath}}}return u(g)}function u(g){const a=g.indexOf("/")!==-1?M.$hc:M.$gc,b=a.basename(g),f=a.dirname(g);return b.length?{name:b,parentPath:f}:{name:f,parentPath:""}}}),define(Me[143],Re([1,0,23,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=void 0,e.$ln=m,e.$mn=k,e.$nn=O;function M(E){return E.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const w=this.a.transformIncoming(l);return w===l?l:M(F.URI.from(w))}transformOutgoing(l){const w=this.a.transformOutgoing(l);return w===l?l:M(F.URI.from(w))}transformOutgoingURI(l){const w=this.a.transformOutgoing(l);return w===l?l:F.URI.from(w)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$jn=N,e.$kn=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function R(E,l,w){if(!E||w>200)return null;if(typeof E=="object"){if(E instanceof F.URI)return l.transformOutgoing(E);for(const p in E)if(Object.hasOwnProperty.call(E,p)){const r=R(E[p],l,w+1);r!==null&&(E[p]=r)}}return null}function m(E,l){const w=R(E,l,0);return w===null?E:w}function d(E,l,w,p){if(!E||p>200)return null;if(typeof E=="object"){if(E.$mid===1)return w?F.URI.revive(l.transformIncoming(E)):l.transformIncoming(E);if(E instanceof S.$ue)return null;for(const r in E)if(Object.hasOwnProperty.call(E,r)){const o=d(E[r],l,w,p+1);o!==null&&(E[r]=o)}}return null}function k(E,l){const w=d(E,l,!1,0);return w===null?E:w}function O(E,l){const w=d(E,l,!0,0);return w===null?E:w}}),define(Me[144],Re([1,0,15,21,23]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0,e.$st=O,e.$tt=E;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function d(){return m||(m=new TextDecoder("UTF-16BE")),m}let k;function O(){return k||(k=F.$D()?R():d()),k}function E(p,r,o){const s=new Uint16Array(p.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?l(p,r,o):R().decode(s)}function l(p,r,o){const s=[];let n=0;for(let i=0;i<o;i++){const c=M.$we(p,r);r+=2,s[n++]=String.fromCharCode(c)}return s.join("")}class w{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return O().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||S.$pf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$ut=w}),define(Me[145],Re([1,0,23,144]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$wt=R;function M(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,O,E,l){this.oldPosition=k,this.oldText=O,this.newPosition=E,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,O,E){const l=O.length;S.$ze(k,l,E),E+=4;for(let w=0;w<l;w++)S.$xe(k,O.charCodeAt(w),E),E+=2;return E}static d(k,O){const E=S.$ye(k,O);return O+=4,(0,F.$tt)(k,O,E)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(k,O){return S.$ze(k,this.oldPosition,O),O+=4,S.$ze(k,this.newPosition,O),O+=4,O=N.c(k,this.oldText,O),O=N.c(k,this.newText,O),O}static read(k,O,E){const l=S.$ye(k,O);O+=4;const w=S.$ye(k,O);O+=4;const p=N.d(k,O);O+=N.a(p);const r=N.d(k,O);return O+=N.a(r),E.push(new N(l,p,w,r)),O}}e.$vt=N;function R(d,k){return d===null||d.length===0?k:new m(d,k).compress()}class m{constructor(k,O){this.a=k,this.c=O,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,O=0,E=this.n(k),l=this.l(O);for(;k<this.f||O<this.h;){if(E===null){this.k(l),l=this.l(++O);continue}if(l===null){this.m(E),E=this.n(++k);continue}if(l.oldEnd<=E.newPosition){this.k(l),l=this.l(++O);continue}if(E.newEnd<=l.oldPosition){this.m(E),E=this.n(++k);continue}if(l.oldPosition<E.newPosition){const[s,n]=m.r(l,E.newPosition-l.oldPosition);this.k(s),l=n;continue}if(E.newPosition<l.oldPosition){const[s,n]=m.q(E,l.oldPosition-E.newPosition);this.m(s),E=n;continue}let r,o;if(l.oldEnd===E.newEnd)r=E,o=l,E=this.n(++k),l=this.l(++O);else if(l.oldEnd<E.newEnd){const[s,n]=m.q(E,l.oldLength);r=s,o=l,E=n,l=this.l(++O)}else{const[s,n]=m.r(l,E.newLength);r=E,o=s,E=this.n(++k),l=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const w=m.s(this.d);return m.t(w)}k(k){this.d[this.e++]=m.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=m.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,O){return new N(O.oldPosition-k,O.oldText,O.newPosition,O.newText)}static p(k,O){return new N(O.oldPosition,O.oldText,O.newPosition+k,O.newText)}static q(k,O){const E=k.newText.substr(0,O),l=k.newText.substr(O);return[new N(k.oldPosition,k.oldText,k.newPosition,E),new N(k.oldEnd,"",k.newPosition+O,l)]}static r(k,O){const E=k.oldText.substr(0,O),l=k.oldText.substr(O);return[new N(k.oldPosition,E,k.newPosition,k.newText),new N(k.oldPosition+O,l,k.newEnd,"")]}static s(k){if(k.length===0)return k;const O=[];let E=0,l=k[0];for(let w=1;w<k.length;w++){const p=k[w];l.oldEnd===p.oldPosition?l=new N(l.oldPosition,l.oldText+p.oldText,l.newPosition,l.newText+p.newText):(O[E++]=l,l=p)}return O[E++]=l,O}static t(k){if(k.length===0)return k;const O=[];let E=0;for(let l=0;l<k.length;l++){const w=k[l];w.oldText!==w.newText&&(O[E++]=w)}return O}}}),define(Me[146],Re([1,0,34,19]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=M,e.$Ut=N;function M(R,m,d,k,O,E){if(Array.isArray(R)){let l=0;for(const w of R){const p=M(w,m,d,k,O,E);if(p===10)return p;p>l&&(l=p)}return l}else{if(typeof R=="string")return k?R==="*"?5:R===d?10:0:0;if(R){const{language:l,pattern:w,scheme:p,hasAccessToAllModels:r,notebookType:o}=R;if(!k&&!r)return 0;o&&O&&(m=O);let s=0;if(p)if(p===m.scheme)s=10;else if(p==="*")s=5;else return 0;if(l)if(l===d)s=10;else if(l==="*")s=Math.max(s,5);else return 0;if(o)if(o===E)s=10;else if(o==="*"&&E!==void 0)s=Math.max(s,5);else return 0;if(w){let n;if(typeof w=="string"?n=w:n={...w,base:(0,F.$ic)(w.base)},n===m.fsPath||(0,S.$ak)(n,m.fsPath))s=10;else return 0}return s}else return 0}}function N(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(N):!!R.notebookType}}),define(Me[147],Re([1,0,5,15,29,94,92,132,145,6]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=void 0;class O extends k.$Uc{constructor(l,w,p,r,o,s,n){super(),this.m=this.B(new S.$7d),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=r,this.h=o,this.c=new R.$vC(l,p,n)}equals(l){return!(l instanceof O)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,w){return this.c.getOffsetAt(l,w)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,w){const p=l+w,r=this.getPositionAt(l),o=this.getPositionAt(p);return new M.$at(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const p=this.n(w);return this.c.getValueInRange(l,p)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const p=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const s=this.n(w),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,c=l.endLineNumber-l.startLineNumber;o=i*c}return r-p+o}getCharacterCountInRange(l,w=0){if(this.j){let p=0;const r=l.startLineNumber,o=l.endLineNumber;for(let s=r;s<=o;s++){const n=this.getLineContent(s),i=s===r?l.startColumn-1:0,c=s===o?l.endColumn-1:n.length;for(let h=i;h<c;h++)F.$pf(n.charCodeAt(h))?(p=p+1,h=h+1):p=p+1}return p+=this.n(w).length*(o-r),p}return this.getValueLengthInRange(l,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,w){return this.c.getLineCharCode(l,w)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=F.$af(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=F.$cf(this.getLineContent(l));return w===-1?0:w+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,w,p){let r=this.g,o=this.h,s=this.j,n=!0,i=[];for(let a=0;a<l.length;a++){const b=l[a];n&&b._isTracked&&(n=!1);const f=b.range;if(b.text){let C=!0;s||(C=!F.$Af(b.text),s=C),!r&&C&&(r=F.$zf(b.text)),!o&&C&&(o=F.$Cf(b.text))}let I="",$=0,D=0,y=0;if(b.text){let C;[$,D,y,C]=(0,m.$Mt)(b.text);const A=this.getEOL();C===0||C===(A===`\r
`?2:1)?I=b.text:I=b.text.replace(/\r\n|\r|\n/g,A)}i[a]={sortIndex:a,identifier:b.identifier||null,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f),text:I,eolCount:$,firstLineLength:D,lastLineLength:y,forceMoveMarkers:!!b.forceMoveMarkers,isAutoWhitespaceEdit:b.isAutoWhitespaceEdit||!1}}i.sort(O.u);let c=!1;for(let a=0,b=i.length-1;a<b;a++){const f=i[a].range.getEndPosition(),I=i[a+1].range.getStartPosition();if(I.isBeforeOrEqual(f)){if(I.isBefore(f))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(i=this.s(i));const h=p||w?O._getInverseEditRanges(i):[],t=[];if(w)for(let a=0;a<i.length;a++){const b=i[a],f=h[a];if(b.isAutoWhitespaceEdit&&b.range.isEmpty())for(let I=f.startLineNumber;I<=f.endLineNumber;I++){let $="";I===f.startLineNumber&&($=this.getLineContent(b.range.startLineNumber),F.$af($)!==-1)||t.push({lineNumber:I,oldContent:$})}}let v=null;if(p){let a=0;v=[];for(let b=0;b<i.length;b++){const f=i[b],I=h[b],$=this.getValueInRange(f.range),D=f.rangeOffset+a;a+=f.text.length-$.length,v[b]={sortIndex:f.sortIndex,identifier:f.identifier,range:I,text:$,textChange:new d.$vt(f.rangeOffset,$,D,f.text)}}c||v.sort((b,f)=>b.sortIndex-f.sortIndex)}this.g=r,this.h=o,this.j=s;const u=this.t(i);let g=null;if(w&&t.length>0){t.sort((a,b)=>b.lineNumber-a.lineNumber),g=[];for(let a=0,b=t.length;a<b;a++){const f=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===f)continue;const I=t[a].oldContent,$=this.getLineContent(f);$.length===0||$===I||F.$af($)!==-1||g.push(f)}}return this.m.fire(),new N.$yv(v,u,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const p=l[0].range,r=l[l.length-1].range,o=new M.$at(p.startLineNumber,p.startColumn,r.endLineNumber,r.endColumn);let s=p.startLineNumber,n=p.startColumn;const i=[];for(let u=0,g=l.length;u<g;u++){const a=l[u],b=a.range;w=w||a.forceMoveMarkers,i.push(this.getValueInRange(new M.$at(s,n,b.startLineNumber,b.startColumn))),a.text.length>0&&i.push(a.text),s=b.endLineNumber,n=b.endColumn}const c=i.join(""),[h,t,v]=(0,m.$Mt)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:t,lastLineLength:v,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(l){l.sort(O.w);const w=[];for(let p=0;p<l.length;p++){const r=l[p],o=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(o===n&&s===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new M.$at(o,s,n,i);w.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,p,r){return this.c.findMatchesLineByLine(l,w,p,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,w){const p=l.startLineNumber,r=l.startColumn,[o,s,n]=(0,m.$Mt)(w);let i;if(w.length>0){const c=o+1;c===1?i=new M.$at(p,r,p,r+s):i=new M.$at(p,r,p+c-1,n+1)}else i=new M.$at(p,r,p,r);return i}static _getInverseEditRanges(l){const w=[];let p=0,r=0,o=null;for(let s=0,n=l.length;s<n;s++){const i=l[s];let c,h;o?o.range.endLineNumber===i.range.startLineNumber?(c=p,h=r+(i.range.startColumn-o.range.endColumn)):(c=p+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(c=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const v=i.eolCount+1;v===1?t=new M.$at(c,h,c,h+i.firstLineLength):t=new M.$at(c,h,c+v-1,i.lastLineLength+1)}else t=new M.$at(c,h,c,h);p=t.endLineNumber,r=t.endColumn,w.push(t),o=i}return w}static u(l,w){const p=M.$at.compareRangesUsingEnds(l.range,w.range);return p===0?l.sortIndex-w.sortIndex:p}static w(l,w){const p=M.$at.compareRangesUsingEnds(l.range,w.range);return p===0?w.sortIndex-l.sortIndex:-p}}e.$wC=O}),define(Me[148],Re([1,0,15,92,147]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xC=void 0;class N{constructor(d,k,O,E,l,w,p,r,o){this.a=d,this.b=k,this.c=O,this.d=E,this.e=l,this.f=w,this.g=p,this.h=r,this.j=o}k(d){const k=this.c+this.d+this.e,O=this.c+this.e;return k===0?d===1?`
`:`\r
`:O>k/2?`\r
`:`
`}create(d){const k=this.k(d),O=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let l=0,w=O.length;l<w;l++){const p=O[l].buffer.replace(/\r\n|\r|\n/g,k),r=(0,F.$rC)(p);O[l]=new F.$uC(p,r)}const E=new M.$wC(O,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&S.$If(d)&&(this.b=S.$Hf,d=d.substr(1));const k=d.charCodeAt(d.length-1);k===13||k>=55296&&k<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=k):(this.m(d,!1),this.c=!1,this.d=k)}m(d,k){!k&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const k=(0,F.$sC)(this.e,d);this.a.push(new F.$uC(d,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=S.$zf(d)),this.k||(this.k=S.$Cf(d)))}finish(d=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const k=(0,F.$rC)(d.buffer);d.lineStarts=k,this.d===13&&this.f++}}}e.$xC=R}),define(Me[97],Re([1,0,23,21]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qab=d,e.$rab=O;var M;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(M||(M={}));function N(E){for(let l=0,w=E.length;l<w;l+=4){const p=E[l+0],r=E[l+1],o=E[l+2],s=E[l+3];E[l+0]=s,E[l+1]=o,E[l+2]=r,E[l+3]=p}}function R(E){const l=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return F.$D()||N(l),S.$ue.wrap(l)}function m(E){const l=E.buffer;if(F.$D()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function d(E){const l=new Uint32Array(k(E));let w=0;if(l[w++]=E.id,E.type==="full")l[w++]=1,l[w++]=E.data.length,l.set(E.data,w),w+=E.data.length;else{l[w++]=2,l[w++]=E.deltas.length;for(const p of E.deltas)l[w++]=p.start,l[w++]=p.deleteCount,p.data?(l[w++]=p.data.length,l.set(p.data,w),w+=p.data.length):l[w++]=0}return R(l)}function k(E){let l=0;if(l+=2,E.type==="full")l+=1+E.data.length;else{l+=1,l+=3*E.deltas.length;for(const w of E.deltas)w.data&&(l+=w.data.length)}return l}function O(E){const l=m(E);let w=0;const p=l[w++];if(l[w++]===1){const n=l[w++],i=l.subarray(w,w+n);return w+=n,{id:p,type:"full",data:i}}const o=l[w++],s=[];for(let n=0;n<o;n++){const i=l[w++],c=l[w++],h=l[w++];let t;h>0&&(t=l.subarray(w,w+h),w+=h),s[n]={start:i,deleteCount:c,data:t}}return{id:p,type:"delta",deltas:s}}}),define(Me[149],Re([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Me[150],Re([1,0,18,26,21,133,151,149]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=c,e.stringSet=v,e.cursorStyleToString=y,e.filterValidationDecorations=de;var d;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class E{constructor(Z,$e,We,Qe){this.id=Z,this.name=$e,this.defaultValue=We,this.schema=Qe}applyUpdate(Z,$e){return w(Z,$e)}compute(Z,$e,We){return We}}class l{constructor(Z,$e){this.newValue=Z,this.didChange=$e}}e.ApplyUpdateResult=l;function w(Q,Z){if(typeof Q!="object"||typeof Z!="object"||!Q||!Z)return new l(Z,Q!==Z);if(Array.isArray(Q)||Array.isArray(Z)){const We=Array.isArray(Q)&&Array.isArray(Z)&&S.$ub(Q,Z);return new l(Z,!We)}let $e=!1;for(const We in Z)if(Z.hasOwnProperty(We)){const Qe=w(Q[We],Z[We]);Qe.didChange&&(Q[We]=Qe.newValue,$e=!0)}return new l(Q,$e)}class p{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,$e){return w(Z,$e)}validate(Z){return this.defaultValue}}class r{constructor(Z,$e,We,Qe){this.id=Z,this.name=$e,this.defaultValue=We,this.schema=Qe}applyUpdate(Z,$e){return w(Z,$e)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,$e,We){return We}}function o(Q,Z){return typeof Q>"u"?Z:Q==="false"?!1:!!Q}class s extends r{constructor(Z,$e,We,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=We),super(Z,$e,We,Qe)}validate(Z){return o(Z,this.defaultValue)}}function n(Q,Z,$e,We){if(typeof Q>"u")return Z;let Qe=parseInt(Q,10);return isNaN(Qe)?Z:(Qe=Math.max($e,Qe),Qe=Math.min(We,Qe),Qe|0)}class i extends r{static clampedInt(Z,$e,We,Qe){return n(Z,$e,We,Qe)}constructor(Z,$e,We,Qe,at,Fe=void 0){typeof Fe<"u"&&(Fe.type="integer",Fe.default=We,Fe.minimum=Qe,Fe.maximum=at),super(Z,$e,We,Fe),this.minimum=Qe,this.maximum=at}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(Q,Z,$e,We){if(typeof Q>"u")return Z;const Qe=h.float(Q,Z);return h.clamp(Qe,$e,We)}class h extends r{static clamp(Z,$e,We){return Z<$e?$e:Z>We?We:Z}static float(Z,$e){if(typeof Z=="number")return Z;if(typeof Z>"u")return $e;const We=parseFloat(Z);return isNaN(We)?$e:We}constructor(Z,$e,We,Qe,at){typeof at<"u"&&(at.type="number",at.default=We),super(Z,$e,We,at),this.validationFn=Qe}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class t extends r{static string(Z,$e){return typeof Z!="string"?$e:Z}constructor(Z,$e,We,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=We),super(Z,$e,We,Qe)}validate(Z){return t.string(Z,this.defaultValue)}}function v(Q,Z,$e,We){return typeof Q!="string"?Z:We&&Q in We?We[Q]:$e.indexOf(Q)===-1?Z:Q}class u extends r{constructor(Z,$e,We,Qe,at=void 0){typeof at<"u"&&(at.type="string",at.enum=Qe,at.default=We),super(Z,$e,We,at),this.c=Qe}validate(Z){return v(Z,this.defaultValue,this.c)}}class g extends E{constructor(Z,$e,We,Qe,at,Fe,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=at,Ct.default=Qe),super(Z,$e,We,Ct),this.c=at,this.d=Fe}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function a(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,$e,We){return We===0?Z.accessibilitySupport:We}}class f extends E{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function $(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var D;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(D||(e.TextEditorCursorStyle=D={}));function y(Q){switch(Q){case D.Line:return"line";case D.Block:return"block";case D.Underline:return"underline";case D.LineThin:return"line-thin";case D.BlockOutline:return"block-outline";case D.UnderlineThin:return"underline-thin"}}function C(Q){switch(Q){case"line":return D.Line;case"block":return D.Block;case"underline":return D.Underline;case"line-thin":return D.LineThin;case"block-outline":return D.BlockOutline;case"underline-thin":return D.UnderlineThin}}class A extends p{constructor(){super(141)}compute(Z,$e,We){const Qe=["monaco-editor"];return $e.get(39)&&Qe.push($e.get(39)),Z.extraEditorClassName&&Qe.push(Z.extraEditorClassName),$e.get(74)==="default"?Qe.push("mouse-default"):$e.get(74)==="copy"&&Qe.push("mouse-copy"),$e.get(111)&&Qe.push("showUnused"),$e.get(139)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,$e,We){return We&&Z.emptySelectionClipboard}}class T extends E{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":v($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":v($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class V extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?V.OFF:Z==="true"?V.ON:Z:Z?V.ON:V.OFF}}e.EditorFontLigatures=V;class P extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?P.OFF:Z==="true"?P.TRANSLATE:Z:Z?P.TRANSLATE:P.OFF}compute(Z,$e,We){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=P;class L extends p{constructor(){super(50)}compute(Z,$e,We){return Z.fontInfo}}class q extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Z){const $e=h.float(Z,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(Z,$e,We){return Z.fontInfo.fontSize}}class re extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ue extends E{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{multiple:v($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??v($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??v($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??v($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??v($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??v($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends E{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:m.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:i.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var Se;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class le extends p{constructor(){super(144)}compute(Z,$e,We){return le.computeLayout($e,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const $e=Z.height/Z.lineHeight,We=Math.floor(Z.paddingTop/Z.lineHeight);let Qe=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Qe=Math.max(Qe,$e-1));const at=(We+Z.viewLineCount+Qe)/(Z.pixelRatio*Z.height),Fe=Math.floor(Z.viewLineCount/at);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Qe,desiredRatio:at,minimapLineCount:Fe}}static c(Z,$e){const We=Z.outerWidth,Qe=Z.outerHeight,at=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(at*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const Fe=$e.stableMinimapLayoutInput,Ct=Fe&&Z.outerHeight===Fe.outerHeight&&Z.lineHeight===Fe.lineHeight&&Z.typicalHalfwidthCharacterWidth===Fe.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Fe.pixelRatio&&Z.scrollBeyondLastLine===Fe.scrollBeyondLastLine&&Z.paddingTop===Fe.paddingTop&&Z.paddingBottom===Fe.paddingBottom&&Z.minimap.enabled===Fe.minimap.enabled&&Z.minimap.side===Fe.minimap.side&&Z.minimap.size===Fe.minimap.size&&Z.minimap.showSlider===Fe.minimap.showSlider&&Z.minimap.renderCharacters===Fe.minimap.renderCharacters&&Z.minimap.maxColumn===Fe.minimap.maxColumn&&Z.minimap.scale===Fe.minimap.scale&&Z.verticalScrollbarWidth===Fe.verticalScrollbarWidth&&Z.isViewportWrapping===Fe.isViewportWrapping,Lt=Z.lineHeight,Xt=Z.typicalHalfwidthCharacterWidth,ei=Z.scrollBeyondLastLine,zt=Z.minimap.renderCharacters;let Dt=at>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const ti=Z.minimap.maxColumn,Ut=Z.minimap.size,ri=Z.minimap.side,ii=Z.verticalScrollbarWidth,Xe=Z.viewLineCount,Qt=Z.remainingWidth,Bt=Z.isViewportWrapping,ht=zt?2:3;let mt=Math.floor(at*Qe);const ni=mt/at;let Vt=!1,Wt=!1,dt=ht*Dt,St=Dt/at,si=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:Pt,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Ot,desiredRatio:oi,minimapLineCount:Kt}=le.computeContainedMinimapLineCount({viewLineCount:Xe,scrollBeyondLastLine:ei,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Qe,lineHeight:Lt,pixelRatio:at});if(Xe/Kt>1)Vt=!0,Wt=!0,Dt=1,dt=1,St=Dt/at;else{let yt=!1,Rt=Dt+1;if(Ut==="fit"){const Jt=Math.ceil((Mt+Xe+Ot)*dt);Bt&&Ct&&Qt<=$e.stableFitRemainingWidth?(yt=!0,Rt=$e.stableFitMaxMinimapScale):yt=Jt>mt}if(Ut==="fill"||yt){Vt=!0;const Jt=Dt;dt=Math.min(Lt*at,Math.max(1,Math.floor(1/oi))),Bt&&Ct&&Qt<=$e.stableFitRemainingWidth&&(Rt=$e.stableFitMaxMinimapScale),Dt=Math.min(Rt,Math.max(1,Math.floor(dt/ht))),Dt>Jt&&(si=Math.min(2,Dt/Jt)),St=Dt/at/si,mt=Math.ceil(Math.max(Pt,Mt+Xe+Ot)*dt),Bt?($e.stableMinimapLayoutInput=Z,$e.stableFitRemainingWidth=Qt,$e.stableFitMaxMinimapScale=Dt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const xt=Math.floor(ti*St),He=Math.min(xt,Math.max(0,Math.floor((Qt-ii-2)*St/(Xt+St)))+e.MINIMAP_GUTTER_WIDTH);let qt=Math.floor(at*He);const jt=qt/at;qt=Math.floor(qt*si);const Ht=zt?1:2,$t=ri==="left"?0:We-He-ii;return{renderMinimap:Ht,minimapLeft:$t,minimapWidth:He,minimapHeightIsEditorHeight:Vt,minimapIsSampling:Wt,minimapScale:Dt,minimapLineHeight:dt,minimapCanvasInnerWidth:qt,minimapCanvasInnerHeight:mt,minimapCanvasOuterWidth:jt,minimapCanvasOuterHeight:ni}}static computeLayout(Z,$e){const We=$e.outerWidth|0,Qe=$e.outerHeight|0,at=$e.lineHeight|0,Fe=$e.lineNumbersDigitCount|0,Ct=$e.typicalHalfwidthCharacterWidth,Lt=$e.maxDigitWidth,Xt=$e.pixelRatio,ei=$e.viewLineCount,zt=Z.get(136),Dt=zt==="inherit"?Z.get(135):zt,ti=Dt==="inherit"?Z.get(131):Dt,Ut=Z.get(134),ri=$e.isDominatedByLongLines,ii=Z.get(57),Xe=Z.get(68).renderType!==0,Qt=Z.get(69),Bt=Z.get(105),ht=Z.get(84),mt=Z.get(73),ni=Z.get(103),Vt=ni.verticalScrollbarSize,Wt=ni.verticalHasArrows,dt=ni.arrowSize,St=ni.horizontalScrollbarSize,si=Z.get(43),xt=Z.get(110)!=="never";let He=Z.get(66);si&&xt&&(He+=16);let qt=0;if(Xe){const kt=Math.max(Fe,Qt);qt=Math.round(kt*Lt)}let jt=0;ii&&(jt=at*$e.glyphMarginDecorationLaneCount);let Ht=0,$t=Ht+jt,Pt=$t+qt,Mt=Pt+He;const Ot=We-jt-qt-He;let oi=!1,Kt=!1,Gt=-1;Dt==="inherit"&&ri?(oi=!0,Kt=!0):ti==="on"||ti==="bounded"?Kt=!0:ti==="wordWrapColumn"&&(Gt=Ut);const yt=le.c({outerWidth:We,outerHeight:Qe,lineHeight:at,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Xt,scrollBeyondLastLine:Bt,paddingTop:ht.top,paddingBottom:ht.bottom,minimap:mt,verticalScrollbarWidth:Vt,viewLineCount:ei,remainingWidth:Ot,isViewportWrapping:Kt},$e.memory||new O);yt.renderMinimap!==0&&yt.minimapLeft===0&&(Ht+=yt.minimapWidth,$t+=yt.minimapWidth,Pt+=yt.minimapWidth,Mt+=yt.minimapWidth);const Rt=Ot-yt.minimapWidth,Jt=Math.max(1,Math.floor((Rt-Vt-2)/Ct)),Nt=Wt?dt:0;return Kt&&(Gt=Math.max(1,Jt),ti==="bounded"&&(Gt=Math.min(Gt,Ut))),{width:We,height:Qe,glyphMarginLeft:Ht,glyphMarginWidth:jt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:$t,lineNumbersWidth:qt,decorationsLeft:Pt,decorationsWidth:He,contentLeft:Mt,contentWidth:Rt,minimap:yt,viewportColumn:Jt,isWordWrapMinified:oi,isViewportWrapping:Kt,wrappingColumn:Gt,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:St,overviewRuler:{top:Nt,width:Vt,height:Qe-2*Nt,right:0}}}}e.EditorLayoutInfoComputer=le;class we extends E{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Z){return v(Z,"simple",["simple","advanced"])}compute(Z,$e,We){return $e.get(2)===2?"advanced":We}}var _;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class ve extends E{constructor(){const Z={enabled:_.OnCode};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:Z.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:v(Z.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class ne extends E{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:m.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class fe extends E{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:m.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:v($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class W extends E{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,$e,We){return We<0?i.clampedInt(-We*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class te extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:m.localize(66,null)})}compute(Z,$e,We){return Z.fontInfo.lineHeight}}class Ee extends E{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Z.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(77,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:v($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:v($e.side,this.defaultValue.side,["right","left"]),showSlider:v($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt($e.scale,1,1,3),maxColumn:i.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Q){return Q==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class Ie extends E{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{top:i.clampedInt($e.top,0,0,1e3),bottom:i.clampedInt($e.bottom,0,0,1e3)}}}class pe extends E{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(81,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class ge extends p{constructor(){super(142)}compute(Z,$e,We){return Z.pixelRatio}}class J extends E{constructor(){const Z={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Z.strings,description:m.localize(85,null)},comments:{anyOf:$e,default:Z.comments,description:m.localize(86,null)},other:{anyOf:$e,default:Z.other,description:m.localize(87,null)}},default:Z,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Xt=Z?"on":"off";return{comments:Xt,strings:Xt,other:Xt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:$e,comments:We,strings:Qe}=Z,at=["on","inline","off"];let Fe,Ct,Lt;return typeof $e=="boolean"?Fe=$e?"on":"off":Fe=v($e,this.defaultValue.other,at),typeof We=="boolean"?Ct=We?"on":"off":Ct=v(We,this.defaultValue.comments,at),typeof Qe=="boolean"?Lt=Qe?"on":"off":Lt=v(Qe,this.defaultValue.strings,at),{other:Fe,comments:Ct,strings:Lt}}}var X;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class ce extends E{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(Z){let $e=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?($e=4,We=Z):Z==="interval"?$e=3:Z==="relative"?$e=2:Z==="on"?$e=1:$e=0),{renderType:$e,renderFn:We}}}function de(Q){const Z=Q.get(98);return Z==="editable"?Q.get(91):Z!=="on"}class Oe extends E{constructor(){const Z=[],$e={type:"number",description:m.localize(94,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:Z,description:m.localize(96,null)})}validate(Z){if(Array.isArray(Z)){const $e=[];for(const We of Z)if(typeof We=="number")$e.push({column:i.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Qe=We;$e.push({column:i.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return $e.sort((We,Qe)=>We.column-Qe.column),$e}return this.defaultValue}}class he extends E{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(Q,Z){if(typeof Q!="string")return Z;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends E{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z,We=i.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=i.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce($e.vertical,this.defaultValue.vertical),horizontal:Ce($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:i.clampedInt($e.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:i.clampedInt($e.verticalSliderSize,Qe,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Le extends E{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:m.localize(115,null)}})}applyUpdate(Z,$e){let We=!1;$e.allowedCharacters&&Z&&(F.$Rn(Z.allowedCharacters,$e.allowedCharacters)||(Z={...Z,allowedCharacters:$e.allowedCharacters},We=!0)),$e.allowedLocales&&Z&&(F.$Rn(Z.allowedLocales,$e.allowedLocales)||(Z={...Z,allowedLocales:$e.allowedLocales},We=!0));const Qe=super.applyUpdate(Z,$e);return We?new l(Qe.newValue,!0):Qe}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,$e){if(typeof Z!="object"||!Z)return $e;const We={};for(const[Qe,at]of Object.entries(Z))at===!0&&(We[Qe]=!0);return We}}class U extends E{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(122,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:v($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily)}}}class z extends E{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:m.localize(129,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),showToolbar:v($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends E{constructor(){const Z={enabled:N.$Ks.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Ks.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends E{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:Z.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:Z.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Z.highlightActiveIndentation,description:m.localize(145,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Q,Z,$e){const We=$e.indexOf(Q);return We===-1?Z:$e[We]}class se extends E{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:Z.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:Z.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{insertMode:v($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:v($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Ne extends E{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class Ye extends E{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(196,null),m.localize(197,null),m.localize(198,null),m.localize(199,null)],description:m.localize(200,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,$e,We){return $e.get(2)===2?0:We}}class xe extends p{constructor(){super(145)}compute(Z,$e,We){const Qe=$e.get(144);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class et extends E{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(203,null),m.localize(204,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:v($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends E{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(207,null),m.localize(208,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const $e=Z;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:v($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?tt:M.$k?st:rt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var it;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=89]="quickSuggestions",Q[Q.quickSuggestionsDelay=90]="quickSuggestionsDelay",Q[Q.readOnly=91]="readOnly",Q[Q.readOnlyMessage=92]="readOnlyMessage",Q[Q.renameOnType=93]="renameOnType",Q[Q.renderControlCharacters=94]="renderControlCharacters",Q[Q.renderFinalNewline=95]="renderFinalNewline",Q[Q.renderLineHighlight=96]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=98]="renderValidationDecorations",Q[Q.renderWhitespace=99]="renderWhitespace",Q[Q.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Q[Q.roundedSelection=101]="roundedSelection",Q[Q.rulers=102]="rulers",Q[Q.scrollbar=103]="scrollbar",Q[Q.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=105]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=106]="scrollPredominantAxis",Q[Q.selectionClipboard=107]="selectionClipboard",Q[Q.selectionHighlight=108]="selectionHighlight",Q[Q.selectOnLineNumbers=109]="selectOnLineNumbers",Q[Q.showFoldingControls=110]="showFoldingControls",Q[Q.showUnused=111]="showUnused",Q[Q.snippetSuggestions=112]="snippetSuggestions",Q[Q.smartSelect=113]="smartSelect",Q[Q.smoothScrolling=114]="smoothScrolling",Q[Q.stickyScroll=115]="stickyScroll",Q[Q.stickyTabStops=116]="stickyTabStops",Q[Q.stopRenderingLineAfter=117]="stopRenderingLineAfter",Q[Q.suggest=118]="suggest",Q[Q.suggestFontSize=119]="suggestFontSize",Q[Q.suggestLineHeight=120]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Q[Q.suggestSelection=122]="suggestSelection",Q[Q.tabCompletion=123]="tabCompletion",Q[Q.tabIndex=124]="tabIndex",Q[Q.unicodeHighlighting=125]="unicodeHighlighting",Q[Q.unusualLineTerminators=126]="unusualLineTerminators",Q[Q.useShadowDOM=127]="useShadowDOM",Q[Q.useTabStops=128]="useTabStops",Q[Q.wordBreak=129]="wordBreak",Q[Q.wordSeparators=130]="wordSeparators",Q[Q.wordWrap=131]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=134]="wordWrapColumn",Q[Q.wordWrapOverride1=135]="wordWrapOverride1",Q[Q.wordWrapOverride2=136]="wordWrapOverride2",Q[Q.wrappingIndent=137]="wrappingIndent",Q[Q.wrappingStrategy=138]="wrappingStrategy",Q[Q.showDeprecated=139]="showDeprecated",Q[Q.inlayHints=140]="inlayHints",Q[Q.editorClassName=141]="editorClassName",Q[Q.pixelRatio=142]="pixelRatio",Q[Q.tabFocusMode=143]="tabFocusMode",Q[Q.layoutInfo=144]="layoutInfo",Q[Q.wrappingInfo=145]="wrappingInfo",Q[Q.defaultColorDecorators=146]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(it||(e.EditorOption=it={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(209,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(210,null),""],markdownDescription:m.localize(211,null)})),accessibilitySupport:Be(new b),accessibilityPageSize:Be(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",m.localize(213,null))),ariaRequired:Be(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),""],description:m.localize(217,null)})),autoClosingComments:Be(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoClosingDelete:Be(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(221,null),""],description:m.localize(222,null)})),autoClosingOvertype:Be(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingQuotes:Be(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(225,null),m.localize(226,null),""],description:m.localize(227,null)})),autoIndent:Be(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),automaticLayout:Be(new s(13,"automaticLayout",!1)),autoSurround:Be(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),""],description:m.localize(237,null)})),bracketPairColorization:Be(new K),bracketPairGuides:Be(new H),stickyTabStops:Be(new s(116,"stickyTabStops",!1,{description:m.localize(238,null)})),codeLens:Be(new s(17,"codeLens",!0,{description:m.localize(239,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:m.localize(240,null)})),codeLensFontSize:Be(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(241,null)})),colorDecorators:Be(new s(20,"colorDecorators",!0,{description:m.localize(242,null)})),colorDecoratorActivatedOn:Be(new u(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),colorDecoratorsLimit:Be(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(247,null)})),columnSelection:Be(new s(22,"columnSelection",!1,{description:m.localize(248,null)})),comments:Be(new f),contextmenu:Be(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(249,null)})),cursorBlinking:Be(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:m.localize(250,null)})),cursorSmoothCaretAnimation:Be(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),cursorStyle:Be(new g(28,"cursorStyle",D.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:m.localize(255,null)})),cursorSurroundingLines:Be(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(256,null)})),cursorSurroundingLinesStyle:Be(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],markdownDescription:m.localize(259,null)})),cursorWidth:Be(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(260,null)})),disableLayerHinting:Be(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(34,"domReadOnly",!1)),dragAndDrop:Be(new s(35,"dragAndDrop",!0,{description:m.localize(261,null)})),emptySelectionClipboard:Be(new G),dropIntoEditor:Be(new et),stickyScroll:Be(new ne),experimentalWhitespaceRendering:Be(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new h(40,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:m.localize(266,null)})),find:Be(new T),fixedOverflowWidgets:Be(new s(42,"fixedOverflowWidgets",!1)),folding:Be(new s(43,"folding",!0,{description:m.localize(267,null)})),foldingStrategy:Be(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),foldingHighlight:Be(new s(45,"foldingHighlight",!0,{description:m.localize(271,null)})),foldingImportsByDefault:Be(new s(46,"foldingImportsByDefault",!1,{description:m.localize(272,null)})),foldingMaximumRegions:Be(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(274,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(275,null)})),fontInfo:Be(new L),fontLigatures2:Be(new V),fontSize:Be(new q),fontWeight:Be(new re),fontVariations:Be(new P),formatOnPaste:Be(new s(55,"formatOnPaste",!1,{description:m.localize(276,null)})),formatOnType:Be(new s(56,"formatOnType",!1,{description:m.localize(277,null)})),glyphMargin:Be(new s(57,"glyphMargin",!0,{description:m.localize(278,null)})),gotoLocation:Be(new ue),hideCursorInOverviewRuler:Be(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new s(61,"inDiffEditor",!1)),letterSpacing:Be(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>h.clamp(Q,-5,20),{description:m.localize(280,null)})),lightbulb:Be(new ve),lineDecorationsWidth:Be(new W),lineHeight:Be(new te),lineNumbers:Be(new ce),lineNumbersMinChars:Be(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(70,"linkedEditing",!1,{description:m.localize(281,null)})),links:Be(new s(71,"links",!0,{description:m.localize(282,null)})),matchBrackets:Be(new u(72,"matchBrackets","always",["always","near","never"],{description:m.localize(283,null)})),minimap:Be(new Ee),mouseStyle:Be(new u(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new h(75,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:m.localize(284,null)})),mouseWheelZoom:Be(new s(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?m.localize(285,null):m.localize(286,null)})),multiCursorMergeOverlapping:Be(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(287,null)})),multiCursorModifier:Be(new g(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),multiCursorPaste:Be(new u(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(291,null),m.localize(292,null)],markdownDescription:m.localize(293,null)})),multiCursorLimit:Be(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(294,null)})),occurrencesHighlight:Be(new u(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(295,null),m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),overviewRulerBorder:Be(new s(82,"overviewRulerBorder",!0,{description:m.localize(299,null)})),overviewRulerLanes:Be(new i(83,"overviewRulerLanes",3,0,3)),padding:Be(new Ie),pasteAs:Be(new ot),parameterHints:Be(new pe),peekWidgetDefaultFocus:Be(new u(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(300,null),m.localize(301,null)],description:m.localize(302,null)})),definitionLinkOpensInPeek:Be(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(303,null)})),quickSuggestions:Be(new J),quickSuggestionsDelay:Be(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(304,null)})),readOnly:Be(new s(91,"readOnly",!1)),readOnlyMessage:Be(new he),renameOnType:Be(new s(93,"renameOnType",!1,{description:m.localize(305,null),markdownDeprecationMessage:m.localize(306,null)})),renderControlCharacters:Be(new s(94,"renderControlCharacters",!0,{description:m.localize(307,null),restricted:!0})),renderFinalNewline:Be(new u(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(308,null)})),renderLineHighlight:Be(new u(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(309,null)],description:m.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(311,null)})),renderValidationDecorations:Be(new u(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(312,null),m.localize(313,null),m.localize(314,null),""],description:m.localize(315,null)})),revealHorizontalRightPadding:Be(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(101,"roundedSelection",!0,{description:m.localize(316,null)})),rulers:Be(new Oe),scrollbar:Be(new Ae),scrollBeyondLastColumn:Be(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(317,null)})),scrollBeyondLastLine:Be(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(318,null)})),scrollPredominantAxis:Be(new s(106,"scrollPredominantAxis",!0,{description:m.localize(319,null)})),selectionClipboard:Be(new s(107,"selectionClipboard",!0,{description:m.localize(320,null),included:M.$k})),selectionHighlight:Be(new s(108,"selectionHighlight",!0,{description:m.localize(321,null)})),selectOnLineNumbers:Be(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),showUnused:Be(new s(111,"showUnused",!0,{description:m.localize(326,null)})),showDeprecated:Be(new s(139,"showDeprecated",!0,{description:m.localize(327,null)})),inlayHints:Be(new fe),snippetSuggestions:Be(new u(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(328,null),m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),smartSelect:Be(new Ne),smoothScrolling:Be(new s(114,"smoothScrolling",!1,{description:m.localize(333,null)})),stopRenderingLineAfter:Be(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new se),inlineSuggest:Be(new U),inlineEdit:Be(new z),inlineCompletionsAccessibilityVerbose:Be(new s(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(334,null)})),suggestFontSize:Be(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(337,null)})),suggestSelection:Be(new u(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),tabCompletion:Be(new u(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(342,null),m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),tabIndex:Be(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new Le),unusualLineTerminators:Be(new u(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(346,null),m.localize(347,null),m.localize(348,null)],description:m.localize(349,null)})),useShadowDOM:Be(new s(127,"useShadowDOM",!0)),useTabStops:Be(new s(128,"useTabStops",!0,{description:m.localize(350,null)})),wordBreak:Be(new u(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(351,null),m.localize(352,null)],description:m.localize(353,null)})),wordSeparators:Be(new t(130,"wordSeparators",R.$Ls,{description:m.localize(354,null)})),wordWrap:Be(new u(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(355,null),m.localize(356,null),m.localize(357,null),m.localize(358,null)],description:m.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new i(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(360,null)})),wordWrapOverride1:Be(new u(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new A),defaultColorDecorators:Be(new s(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new s(143,"tabFocusMode",!1,{markdownDescription:m.localize(362,null)})),layoutInfo:Be(new le),wrappingInfo:Be(new xe),wrappingIndent:Be(new Ye),wrappingStrategy:Be(new we)}}),define(Me[152],Re([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Me[153],Re([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Me[154],Re([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Me[155],Re([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Me[156],Re([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Me[157],Re([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Me[158],Re([9,10]),function(me,e){return me.create("vs/platform/log/common/log",e)}),define(Me[159],Re([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Me[160],Re([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Me[161],Re([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Me[162],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Me[163],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Me[164],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Me[165],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Me[166],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Me[167],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Me[168],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Me[169],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Me[170],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Me[171],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Me[172],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Me[173],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Me[174],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Me[175],Re([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Me[176],Re([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Me[177],Re([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Me[178],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Me[179],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Me[180],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Me[181],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Me[182],Re([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Me[183],Re([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Me[184],Re([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Me[185],Re([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Me[186],Re([1,0,14,154]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.TokenType=void 0;var M;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(M||(e.TokenType=M={}));function N(...k){switch(k.length){case 1:return(0,F.localize)(0,null,k[0]);case 2:return(0,F.localize)(1,null,k[0],k[1]);case 3:return(0,F.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,F.localize)(3,null),m=(0,F.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const E=this.d,l=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:l};this.g.push({offset:E,lexeme:l,additionalInfo:O}),this.f.push(w)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const E=this.c.substring(this.d,this.e),l=d.b.get(E);l?this.k(l):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,E=!1,l=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(m);return}const p=this.c.charCodeAt(O);if(E)E=!1;else if(p===47&&!l){O++;break}else p===91?l=!0:p===92?E=!0:p===93&&(l=!1);O++}for(;O<this.c.length&&d.a.has(this.c.charCodeAt(O));)O++;this.e=O;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$cj=d}),define(Me[187],Re([1,0,24,32,156,299]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=d,e.$sp=k,e.$tp=O,e.$up=E,e.$vp=l,e.$wp=w,e.$xp=p;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||R.test(s)}function k(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function O(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,c=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let v=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),v=!1);let u=0;if(s.preRelease){const g=m.exec(s.preRelease);if(g){const[,a,b,f]=g;u=Date.UTC(Number(a),Number(b)-1,Number(f))}}return{majorBase:n,majorMustEqual:i,minorBase:c,minorMustEqual:h,patchBase:t,patchMustEqual:v,isMinimum:s.hasGreaterEquals,notBefore:u}}function E(s,n,i){let c;typeof s=="string"?c=O(k(s)):c=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof i=="string"?t=O(k(i)):t=i,!c||!t)return!1;const v=c.majorBase,u=c.minorBase,g=c.patchBase;let a=t.majorBase,b=t.minorBase,f=t.patchBase;const I=t.notBefore;let $=t.majorMustEqual,D=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?v>a?!0:v<a?!1:u>b?!0:u<b||h&&h<I?!1:g>=f:(v===1&&a===0&&(!$||!D||!y)&&(a=1,b=0,f=0,$=!0,D=!1,y=!1),v<a?!1:v>a?!$:u<b?!1:u>b?!D:g<f?!1:g>f?!y:!(h&&h<I))}function l(s,n,i,c,h){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([F.default.Error,M.localize(0,null)]),t;if(typeof c.name!="string")return t.push([F.default.Error,M.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([F.default.Error,M.localize(2,null,"version")]),t;if(!c.engines)return t.push([F.default.Error,M.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([F.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return t.push([F.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return t.push([F.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([F.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([F.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([F.default.Error,M.localize(9,null,"main")]),t;{const g=(0,S.$Ug)(i,c.main);(0,S.$Og)(g,i)||t.push([F.default.Warning,M.localize(10,null,g.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([F.default.Error,M.localize(11,null,"browser")]),t;{const g=(0,S.$Ug)(i,c.browser);(0,S.$Og)(g,i)||t.push([F.default.Warning,M.localize(12,null,g.path,i.path)])}}if(!N.valid(c.version))return t.push([F.default.Error,M.localize(13,null)]),t;const v=[];if(!w(s,n,c,h,v))for(const g of v)t.push([F.default.Error,g]);return t}function w(s,n,i,c,h){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,h)}function p(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,c=[]){const h=O(k(i));if(!h)return c.push(M.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(M.localize(15,null,i)),!1}else if(!h.majorMustEqual)return c.push(M.localize(16,null,i)),!1;return E(s,n,h)?!0:(c.push(M.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Me[70],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class S{constructor(M,N=[],R=!1){this.ctor=M,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$ei=S}),define(Me[54],Re([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$es=N,e.$fs=R;const F=[];var M;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function N(m,d,k){d instanceof S.$ei||(d=new S.$ei(d,[],!!k)),F.push([m,d])}function R(){return F}}),define(Me[188],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=e.$Uq=void 0;class S{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Uq=S;class F{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const m=this.lookupOrInsertNode(N),d=this.lookupOrInsertNode(R);m.outgoing.set(d.key,d),d.incoming.set(m.key,m)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let m=this.a.get(R);return m||(m=new S(R,N),this.a.set(R,m)),m}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,m]of this.a)N.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const m=new Set([N]),d=this.c(R,m);if(d)return d}}c(N,R){for(const[m,d]of N.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const k=this.c(d,R);if(k)return k;R.delete(m)}}}e.$Vq=F}),define(Me[3],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e._util=void 0,e.$hi=M,e.$ii=N;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(d){return d[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(S||(e._util=S={})),e.$gi=M("instantiationService");function F(R,m,d){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:R,index:d}):(m[S.DI_DEPENDENCIES]=[{id:R,index:d}],m[S.DI_TARGET]=m)}function M(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const m=function(d,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(m,d,O)};return m.toString=()=>R,S.serviceIds.set(R,m),m}function N(R){return R}}),define(Me[47],Re([1,0,16,2,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Ni=void 0,e.$Oi=N,e.$Pi=R,e.$Qi=d,e.$Ri=k,e.$Si=O,e.$Ti=E,e.$Ui=l,e.$Vi=p,e.$Wi=r,e.$Xi=o,e.$Ni=(0,M.$hi)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function O(s,n){const i=Object.create(null);for(const c in s)E(i,c,s[c],n);return i}function E(s,n,i,c){const h=n.split("."),t=h.pop();let v=s;for(let u=0;u<h.length;u++){const g=h[u];let a=v[g];switch(typeof a){case"undefined":a=v[g]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(a)}`);return}v=a}if(typeof v=="object"&&v!==null)try{v[t]=i}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}function l(s,n){const i=n.split(".");w(s,i)}function w(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const c=s[i];typeof c=="object"&&!Array.isArray(c)&&(w(c,n),Object.keys(c).length===0&&delete s[i])}}function p(s,n,i){function c(v,u){let g=v;for(const a of u){if(typeof g!="object"||g===null)return;g=g[a]}return g}const h=n.split("."),t=c(s,h);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?S.$Wf(s[c])&&S.$Wf(n[c])?r(s[c],n[c],i):i&&(s[c]=n[c]):s[c]=n[c])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Me[35],Re([1,0,21,15,186,3,153,14]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$fj=e.$ej=e.ContextKeyExprType=void 0,e.$dj=k,e.$gj=v,e.$hj=u,e.$Aj=_;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",S.$j),d.set("isLinux",S.$k),d.set("isWindows",S.$i),d.set("isWeb",S.$o),d.set("isMacNative",S.$j&&!S.$o),d.set("isEdge",S.$H),d.set("isFirefox",S.$F),d.set("isChrome",S.$E),d.set("isSafari",S.$G);function k(fe,W){if(d.get(fe)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(fe,W)}const O=Object.prototype.hasOwnProperty;var E;(function(fe){fe[fe.False=0]="False",fe[fe.True=1]="True",fe[fe.Defined=2]="Defined",fe[fe.Not=3]="Not",fe[fe.Equals=4]="Equals",fe[fe.NotEquals=5]="NotEquals",fe[fe.And=6]="And",fe[fe.Regex=7]="Regex",fe[fe.NotRegex=8]="NotRegex",fe[fe.Or=9]="Or",fe[fe.In=10]="In",fe[fe.NotIn=11]="NotIn",fe[fe.Greater=12]="Greater",fe[fe.GreaterEquals=13]="GreaterEquals",fe[fe.Smaller=14]="Smaller",fe[fe.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const l={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),p=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=l){this.k=W,this.d=new M.$cj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const Ee=this.D(),Te=Ee.type===17?n:void 0;throw this.h.push({message:s,offset:Ee.offset,lexeme:M.$cj.getLexeme(Ee),additionalInfo:Te}),h.c}return te}catch(te){if(te!==h.c)throw te;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const te=this.o();W.push(te)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const te=this.s();W.push(te)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const te=this.l();return this.A(1,o),te?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const te=this.l();return this.A(1,o),te}case 17:{const te=W.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Ie=Te.lexeme,pe=Ie.lastIndexOf("/"),ge=pe===Ie.length-1?void 0:this.w(Ie.substring(pe+1));let J;try{J=new RegExp(Ie.substring(1,pe),ge)}catch{throw this.B("REGEX",Te)}return L.create(te,J)}switch(Te.type){case 10:case 19:{const Ie=[Te.lexeme];this.z();let pe=this.D(),ge=0;for(let Oe=0;Oe<Te.lexeme.length;Oe++)Te.lexeme.charCodeAt(Oe)===40?ge++:Te.lexeme.charCodeAt(Oe)===41&&ge--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Oe=0;Oe<pe.lexeme.length;Oe++)pe.lexeme.charCodeAt(Oe)===40?ge++:Te.lexeme.charCodeAt(Oe)===41&&ge--}if(ge<0)break;Ie.push(M.$cj.getLexeme(pe)),this.z(),pe=this.D()}const J=Ie.join(""),X=J.lastIndexOf("/"),ce=X===J.length-1?void 0:this.w(J.substring(X+1));let de;try{de=new RegExp(J.substring(1,X),ce)}catch{throw this.B("REGEX",Te)}return t.regex(te,de)}case 18:{const Ie=Te.lexeme;this.z();let pe=null;if(!(0,F.$Ue)(Ie)){const ge=Ie.indexOf("/"),J=Ie.lastIndexOf("/");if(ge!==J&&ge>=0){const X=Ie.slice(ge+1,J),ce=Ie[J+1]==="i"?"i":"";try{pe=new RegExp(X,ce)}catch{throw this.B("REGEX",Te)}}}if(pe===null)throw this.B("REGEX",Te);return L.create(te,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(te,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(te,Te);switch(Te){case"true":return t.has(te);case"false":return t.not(te);default:return t.equals(te,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(te,Te);switch(Te){case"true":return t.not(te);case"false":return t.has(te);default:return t.notEquals(te,Te)}}case 5:return this.z(),V.create(te,this.u());case 6:return this.z(),P.create(te,this.u());case 7:return this.z(),G.create(te,this.u());case 8:return this.z(),T.create(te,this.u());case 13:return this.z(),t.in(te,this.u());default:return t.has(te)}}case 20:throw this.h.push({message:i,offset:W.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,te){if(this.C(W))return this.z();throw this.B(te,this.D())}B(W,te,Ee){const Te=(0,R.localize)(8,null,W,M.$cj.getLexeme(te)),Ie=te.offset,pe=M.$cj.getLexeme(te);return this.h.push({message:Te,offset:Ie,lexeme:pe,additionalInfo:Ee}),h.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ej=h;class t{static false(){return a.INSTANCE}static true(){return b.INSTANCE}static has(W){return f.create(W)}static equals(W,te){return I.create(W,te)}static notEquals(W,te){return y.create(W,te)}static regex(W,te){return L.create(W,te)}static in(W,te){return $.create(W,te)}static notIn(W,te){return D.create(W,te)}static not(W){return C.create(W)}static and(...W){return ue.create(W,null,!0)}static or(...W){return ye.create(W,null,!0)}static greater(W,te){return G.create(W,te)}static greaterEquals(W,te){return T.create(W,te)}static smaller(W,te){return V.create(W,te)}static smallerEquals(W,te){return P.create(W,te)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$fj=t;function v(fe){const W=new h({regexParsingWithErrorRecovery:!1});return fe.map(te=>(W.parse(te),W.lexingErrors.length>0?W.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,R.localize)(9,null,Ee.additionalInfo):(0,R.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}function u(fe,W){const te=fe?fe.substituteConstants():void 0,Ee=W?W.substituteConstants():void 0;return!te&&!Ee?!0:!te||!Ee?!1:te.equals(Ee)}function g(fe,W){return fe.cmp(W)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return b.INSTANCE}}e.$ij=a;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return a.INSTANCE}}e.$jj=b;class f{static create(W,te=null){const Ee=d.get(W);return typeof Ee=="boolean"?Ee?b.INSTANCE:a.INSTANCE:new f(W,te)}constructor(W,te){this.key=W,this.c=te,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:le(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=d.get(this.key);return typeof W=="boolean"?W?b.INSTANCE:a.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$kj=f;class I{static create(W,te,Ee=null){if(typeof te=="boolean")return te?f.create(W,Ee):C.create(W,Ee);const Te=d.get(W);return typeof Te=="boolean"?te===(Te?"true":"false")?b.INSTANCE:a.INSTANCE:new I(W,te,Ee)}constructor(W,te,Ee){this.c=W,this.d=te,this.f=Ee,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=d.get(this.c);if(typeof W=="boolean"){const te=W?"true":"false";return this.d===te?b.INSTANCE:a.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$lj=I;class ${static create(W,te){return new $(W,te)}constructor(W,te){this.d=W,this.f=te,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:we(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const te=W.getValue(this.f),Ee=W.getValue(this.d);return Array.isArray(te)?te.includes(Ee):typeof Ee=="string"&&typeof te=="object"&&te!==null?O.call(te,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$mj=$;class D{static create(W,te){return new D(W,te)}constructor(W,te){this.d=W,this.f=te,this.type=11,this.c=$.create(W,te)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$nj=D;class y{static create(W,te,Ee=null){if(typeof te=="boolean")return te?C.create(W,Ee):f.create(W,Ee);const Te=d.get(W);return typeof Te=="boolean"?te===(Te?"true":"false")?a.INSTANCE:b.INSTANCE:new y(W,te,Ee)}constructor(W,te,Ee){this.c=W,this.d=te,this.f=Ee,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=d.get(this.c);if(typeof W=="boolean"){const te=W?"true":"false";return this.d===te?a.INSTANCE:b.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$oj=y;class C{static create(W,te=null){const Ee=d.get(W);return typeof Ee=="boolean"?Ee?a.INSTANCE:b.INSTANCE:new C(W,te)}constructor(W,te){this.c=W,this.d=te,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:le(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=d.get(this.c);return typeof W=="boolean"?W?a.INSTANCE:b.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$pj=C;function A(fe,W){if(typeof fe=="string"){const te=parseFloat(fe);isNaN(te)||(fe=te)}return typeof fe=="string"||typeof fe=="number"?W(fe):a.INSTANCE}class G{static create(W,te,Ee=null){return A(te,Te=>new G(W,Te,Ee))}constructor(W,te,Ee){this.c=W,this.d=te,this.f=Ee,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$qj=G;class T{static create(W,te,Ee=null){return A(te,Te=>new T(W,Te,Ee))}constructor(W,te,Ee){this.c=W,this.d=te,this.f=Ee,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$rj=T;class V{static create(W,te,Ee=null){return A(te,Te=>new V(W,Te,Ee))}constructor(W,te,Ee){this.c=W,this.d=te,this.f=Ee,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$sj=V;class P{static create(W,te,Ee=null){return A(te,Te=>new P(W,Te,Ee))}constructor(W,te,Ee){this.c=W,this.d=te,this.f=Ee,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:we(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$tj=P;class L{static create(W,te){return new L(W,te)}constructor(W,te){this.d=W,this.f=te,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const te=this.f?this.f.source:"",Ee=W.f?W.f.source:"";return te<Ee?-1:te>Ee?1:0}equals(W){if(W.type===this.type){const te=this.f?this.f.source:"",Ee=W.f?W.f.source:"";return this.d===W.d&&te===Ee}return!1}substituteConstants(){return this}evaluate(W){const te=W.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$uj=L;class q{static create(W){return new q(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new q(this.c.map(W))}negate(){return this.c}}e.$vj=q;function re(fe){let W=null;for(let te=0,Ee=fe.length;te<Ee;te++){const Te=fe[te].substituteConstants();if(fe[te]!==Te&&W===null){W=[];for(let Ie=0;Ie<te;Ie++)W[Ie]=fe[Ie]}W!==null&&(W[te]=Te)}return W===null?fe:W}class ue{static create(W,te,Ee){return ue.d(W,te,Ee)}constructor(W,te){this.expr=W,this.c=te,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let te=0,Ee=this.expr.length;te<Ee;te++){const Te=g(this.expr[te],W.expr[te]);if(Te!==0)return Te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let te=0,Ee=this.expr.length;te<Ee;te++)if(!this.expr[te].equals(W.expr[te]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:ue.create(W,this.c,!1)}evaluate(W){for(let te=0,Ee=this.expr.length;te<Ee;te++)if(!this.expr[te].evaluate(W))return!1;return!0}static d(W,te,Ee){const Te=[];let Ie=!1;for(const pe of W)if(pe){if(pe.type===1){Ie=!0;continue}if(pe.type===0)return a.INSTANCE;if(pe.type===6){Te.push(...pe.expr);continue}Te.push(pe)}if(Te.length===0&&Ie)return b.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(g);for(let pe=1;pe<Te.length;pe++)Te[pe-1].equals(Te[pe])&&(Te.splice(pe,1),pe--);if(Te.length===1)return Te[0];for(;Te.length>1;){const pe=Te[Te.length-1];if(pe.type!==9)break;Te.pop();const ge=Te.pop(),J=Te.length===0,X=ye.create(pe.expr.map(ce=>ue.create([ce,ge],null,Ee)),null,J);X&&(Te.push(X),Te.sort(g))}if(Te.length===1)return Te[0];if(Ee){for(let pe=0;pe<Te.length;pe++)for(let ge=pe+1;ge<Te.length;ge++)if(Te[pe].negate().equals(Te[ge]))return a.INSTANCE;if(Te.length===1)return Te[0]}return new ue(Te,te)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const te of this.expr)W.push(...te.keys());return W}map(W){return new ue(this.expr.map(te=>te.map(W)),null)}negate(){if(!this.c){const W=[];for(const te of this.expr)W.push(te.negate());this.c=ye.create(W,this,!0)}return this.c}}e.$wj=ue;class ye{static create(W,te,Ee){return ye.d(W,te,Ee)}constructor(W,te){this.expr=W,this.c=te,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let te=0,Ee=this.expr.length;te<Ee;te++){const Te=g(this.expr[te],W.expr[te]);if(Te!==0)return Te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let te=0,Ee=this.expr.length;te<Ee;te++)if(!this.expr[te].equals(W.expr[te]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:ye.create(W,this.c,!1)}evaluate(W){for(let te=0,Ee=this.expr.length;te<Ee;te++)if(this.expr[te].evaluate(W))return!0;return!1}static d(W,te,Ee){let Te=[],Ie=!1;if(W){for(let pe=0,ge=W.length;pe<ge;pe++){const J=W[pe];if(J){if(J.type===0){Ie=!0;continue}if(J.type===1)return b.INSTANCE;if(J.type===9){Te=Te.concat(J.expr);continue}Te.push(J)}}if(Te.length===0&&Ie)return a.INSTANCE;Te.sort(g)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let pe=1;pe<Te.length;pe++)Te[pe-1].equals(Te[pe])&&(Te.splice(pe,1),pe--);if(Te.length===1)return Te[0];if(Ee){for(let pe=0;pe<Te.length;pe++)for(let ge=pe+1;ge<Te.length;ge++)if(Te[pe].negate().equals(Te[ge]))return b.INSTANCE;if(Te.length===1)return Te[0]}return new ye(Te,te)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const te of this.expr)W.push(...te.keys());return W}map(W){return new ye(this.expr.map(te=>te.map(W)),null)}negate(){if(!this.c){const W=[];for(const te of this.expr)W.push(te.negate());for(;W.length>1;){const te=W.shift(),Ee=W.shift(),Te=[];for(const Ie of ne(te))for(const pe of ne(Ee))Te.push(ue.create([Ie,pe],null,!1));W.unshift(ye.create(Te,null,!1))}this.c=ye.create(W,this,!0)}return this.c}}e.$xj=ye;class Se extends f{static{this.d=[]}static all(){return Se.d.values()}constructor(W,te,Ee){super(W,null),this.f=te,typeof Ee=="object"?Se.d.push({...Ee,key:W}):Ee!==!0&&Se.d.push({key:W,description:Ee,type:te!=null?typeof te:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return I.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$yj=Se,e.$zj=(0,N.$hi)("contextKeyService");function le(fe,W){return fe<W?-1:fe>W?1:0}function we(fe,W,te,Ee){return fe<te?-1:fe>te?1:W<Ee?-1:W>Ee?1:0}function _(fe,W){if(fe.type===0||W.type===1)return!0;if(fe.type===9)return W.type===9?ve(fe.expr,W.expr):!1;if(W.type===9){for(const te of W.expr)if(_(fe,te))return!0;return!1}if(fe.type===6){if(W.type===6)return ve(W.expr,fe.expr);for(const te of fe.expr)if(_(te,W))return!0;return!1}return fe.equals(W)}function ve(fe,W){let te=0,Ee=0;for(;te<fe.length&&Ee<W.length;){const Te=fe[te].cmp(W[Ee]);if(Te<0)return!1;Te===0&&te++,Ee++}return te===fe.length}function ne(fe){return fe.type===9?fe.expr:[fe]}}),define(Me[189],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=void 0,e.$oi=(0,S.$hi)("environmentService"),e.$pi=(0,S.$ii)(e.$oi)}),define(Me[98],Re([1,0,155,3]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.ExtensionGalleryErrorCode=e.$Ro=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Qo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0,e.$Ko=M,e.$Lo=N,e.$Mo=R,e.$No=m,e.$Oo=d,e.$Po=k,e.$Eo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fo=new RegExp(e.$Eo),e.$Go="__web_extension",e.$Ho="skipWalkthrough",e.$Io="extensionsSync",e.$Jo="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,c){switch(i){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,c){return c==="web"&&!i.includes("web")}function d(i,c,h){return m(c,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var O;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var E;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Qo=(0,F.$hi)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$Ro=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(c,h){super(c),this.code=h,this.name=h}}e.$So=n,e.$To=(0,F.$hi)("extensionManagementService"),e.$Uo="extensionsIdentifiers/disabled",e.$Vo="extensionsIdentifiers/enabled",e.$Wo=(0,F.$hi)("IGlobalExtensionEnablementService"),e.$Xo=(0,F.$hi)("IExtensionTipsService"),e.$Yo=(0,S.localize2)(0,"Extensions"),e.$Zo=(0,S.localize2)(1,"Preferences")}),define(Me[42],Re([1,0,51,19,15,16,2,157,3,21,12,39]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$gl=e.FileKind=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileOperationResult=e.$$k=e.$0k=e.$9k=e.$7k=e.FileChangeType=e.$6k=e.FileOperation=e.$Zk=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Nk=void 0,e.$Ok=l,e.$Pk=r,e.$Qk=s,e.$Rk=n,e.$Sk=i,e.$Tk=c,e.$Uk=h,e.$Vk=t,e.$Wk=v,e.$Xk=u,e.$Yk=g,e.$1k=f,e.$2k=I,e.$3k=$,e.$4k=D,e.$5k=y,e.$8k=V,e.$hl=ye,e.$il=Se,e.$kl=we,e.$Nk=(0,d.$hi)("fileService");function l(_){return _.create===!0}var w;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var p;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function r(_){const ve=_;return!!ve&&typeof ve.onDidChange=="function"}var o;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(_){return!!(_.capabilities&2)}function n(_){return!!(_.capabilities&8)}function i(_){return!!(_.capabilities&131072)}function c(_){return!!(_.capabilities&4)}function h(_){return!!(_.capabilities&16)}function t(_){return s(_)?!!(_.capabilities&16384):!1}function v(_){return s(_)?!!(_.capabilities&32768):!1}function u(_){return!!(_.capabilities&65536)}function g(_){return!!(_.capabilities&2048)}var a;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class b extends Error{static create(ve,ne){const fe=new b(ve.toString(),ne);return $(fe,ne),fe}constructor(ve,ne){super(ve),this.code=ne}}e.$Zk=b;function f(_,ve){return b.create(_,ve)}function I(_){return _||f((0,m.localize)(0,null),a.Unknown)}function $(_,ve){return _.name=ve?`${ve} (FileSystemError)`:"FileSystemError",_}function D(_){if(!_)return a.Unknown;if(_ instanceof b)return _.code;const ve=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ve)return a.Unknown;switch(ve[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}function y(_){if(_ instanceof P)return _.fileOperationResult;switch(D(_)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}var C;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class A{constructor(ve,ne,fe){this.resource=ve,this.operation=ne,this.target=fe}isOperation(ve){return this.operation===ve}}e.$6k=A;var G;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class T{static{this.a=null}constructor(ve,ne){this.c=ne,this.b=void 0,this.d=new E.$V(()=>{const fe=S.$ni.forUris(()=>this.c);return fe.fill(this.rawAdded.map(W=>[W,!0])),fe}),this.f=new E.$V(()=>{const fe=S.$ni.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(W=>[W,!0])),fe}),this.g=new E.$V(()=>{const fe=S.$ni.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(W=>[W,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of ve){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==T.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(ve,...ne){return this.h(ve,{includeChildren:!1},...ne)}affects(ve,...ne){return this.h(ve,{includeChildren:!0},...ne)}h(ve,ne,...fe){if(!ve)return!1;const W=fe.length>0;return!!((!W||fe.includes(1))&&(this.d.value.get(ve)||ne.includeChildren&&this.d.value.findSuperstr(ve))||(!W||fe.includes(0))&&(this.f.value.get(ve)||ne.includeChildren&&this.f.value.findSuperstr(ve))||(!W||fe.includes(2))&&(this.g.value.findSubstr(ve)||ne.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$7k=T;function V(_,ve,ne){return!_||!ve||_===ve||ve.length>_.length?!1:(ve.charAt(ve.length-1)!==F.sep&&(ve+=F.sep),ne?(0,M.$mf)(_,ve):_.indexOf(ve)===0)}class P extends Error{constructor(ve,ne,fe){super(ve),this.fileOperationResult=ne,this.options=fe}}e.$9k=P;class L extends P{constructor(ve,ne,fe,W){super(ve,ne,W),this.fileOperationResult=ne,this.size=fe}}e.$0k=L;class q extends P{constructor(ve,ne,fe){super(ve,2,fe),this.stat=ne}}e.$$k=q;var re;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$_k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$al={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$bl="files.associations",e.$cl="files.exclude",e.$dl="files.readonlyInclude",e.$el="files.readonlyExclude",e.$fl="files.readonlyFromPermissions";var ue;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$gl="";function ye(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}async function Se(_,ve){if(!ve.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(ne=>{const fe=ve.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===_.scheme&&W.added&&(fe.dispose(),ne())})})}class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(ve){return(0,N.$Yf)(ve)||(ve=0),ve<le.KB?(0,m.localize)(1,null,ve.toFixed(0)):ve<le.MB?(0,m.localize)(2,null,(ve/le.KB).toFixed(2)):ve<le.GB?(0,m.localize)(3,null,(ve/le.MB).toFixed(2)):ve<le.TB?(0,m.localize)(4,null,(ve/le.GB).toFixed(2)):(0,m.localize)(5,null,(ve/le.TB).toFixed(2))}}e.$jl=le;function we(_){const ve=typeof _=="string"||_?.scheme===O.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===O.Schemas.file?1024*le.MB:ve?10*le.MB:k.$o?50*le.MB:1024*le.MB}}),define(Me[71],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class S{constructor(...M){this.a=new Map;for(const[N,R]of M)this.set(N,R)}set(M,N){const R=this.a.get(M);return this.a.set(M,N),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$fi=S}),define(Me[190],Re([1,0,11,14,6,70,188,3,71,191]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;const O=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new d.$fi,s=!1,n,i=O){this.f=o,this.g=s,this.h=n,this.i=i,this.o=new Set,this.f.set(m.$gi,this),this._globalGraph=i?n?._globalGraph??new R.$Vq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...s){const n=p.traceInvocation(this.i,o);let i=!1;try{return o({get:h=>{if(i)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(o,...s){let n,i;return o instanceof N.$ei?(n=p.traceCreation(this.i,o.ctor),i=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=p.traceCreation(this.i,o),i=this.j(o,s,n)),n.stop(),i}j(o,s=[],n){const i=m._util.getServiceDependencies(o).sort((t,v)=>t.index-v.index),c=[];for(const t of i){const v=this.m(t.id,n);v||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(v)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(c))}k(o,s){if(this.f.get(o)instanceof N.$ei)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof N.$ei?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const i=new R.$Vq(t=>t.id.toString());let c=0;const h=[{id:o,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new E(i);for(const v of m._util.getServiceDependencies(t.desc.ctor)){const u=this.l(v.id);if(u||this.u(`[createInstance] ${o} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(v.id)),u instanceof N.$ei){const g={id:v.id,desc:u,_trace:t._trace.branch(v.id,!0)};i.insertEdge(t,g),h.push(g)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:v}of t){if(this.l(v.id)instanceof N.$ei){const g=this.s(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.k(v.id,g)}i.removeNode(v)}}return this.l(o)}s(o,s,n=[],i,c){if(this.f.get(o)instanceof N.$ei)return this.t(o,s,n,i,c);if(this.h)return this.h.s(o,s,n,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],i,c){if(i){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,v=new S.$Ah(()=>{const u=h.j(s,n,c);for(const[g,a]of t){const b=u[g];if(typeof b=="function")for(const f of a)f.disposable=b.apply(u,f.listener)}return t.clear(),u});return new Proxy(Object.create(null),{get(u,g){if(!v.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let f=t.get(g);return f||(f=new k.$5c,t.set(g,f)),($,D,y)=>{if(v.isInitialized)return v.value[g]($,D,y);{const C={listener:[$,D,y],disposable:void 0},A=f.push(C);return(0,M.$Sc)(()=>{A(),C.disposable?.dispose()})}}}if(g in u)return u[g];const a=v.value;let b=a[g];return typeof b!="function"||(b=b.bind(a),u[g]=b),b},set(u,g,a){return v.value[g]=a,!0},getPrototypeOf(u){return s.prototype}})}else return this.j(s,n,c)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$Wq=l;var w;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(w||(w={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new p(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(o,s){return o?new p(1,s.name):p.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new p(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;p.f+=o;let s=!1;function n(c,h){const t=[],v=new Array(c+1).join("	");for(const[u,g,a]of h.h)if(g&&a){s=!0,t.push(`${v}CREATES -> ${u}`);const b=n(c+1,a);b&&t.push(b)}else t.push(`${v}uses -> ${u}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(o>2||s)&&p.all.add(i.join(`
`))}}e.$Xq=p}),define(Me[13],Re([1,0,158,41,5,99,6,28,21,24,16,2,35,3]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Qj=e.LogLevel=e.$Oj=e.$Nj=void 0,e.$Pj=r,e.log=s,e.$2j=f,e.$3j=I,e.$4j=$,e.$5j=D,e.$Nj=(0,w.$hi)("logService"),e.$Oj=(0,w.$hi)("loggerService");function p(){return new Date().toISOString()}function r(y){return(0,O.$Yf)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Qj=o.Info;function s(y,C,A){switch(C){case o.Trace:y.trace(A);break;case o.Debug:y.debug(A);break;case o.Info:y.info(A);break;case o.Warning:y.warn(A);break;case o.Error:y.error(A);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let A="";for(let G=0;G<y.length;G++){let T=y[G];if(T instanceof Error&&(T=(0,F.$5i)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}A+=(G>0?" ":"")+T}return A}class i extends R.$Uc{constructor(){super(...arguments),this.b=e.$Qj,this.c=this.B(new M.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$Sj=i;class c extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...A){this.f(o.Trace)&&this.g(o.Trace,n([C,...A],!0))}debug(C,...A){this.f(o.Debug)&&this.g(o.Debug,n([C,...A]))}info(C,...A){this.f(o.Info)&&this.g(o.Info,n([C,...A]))}warn(C,...A){this.f(o.Warning)&&this.g(o.Warning,n([C,...A]))}error(C,...A){if(this.f(o.Error))if(C instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=C.stack,this.g(o.Error,n(G))}else this.g(o.Error,n([C,...A]))}flush(){}}e.$Tj=c;class h extends i{constructor(C=e.$Qj){super(),this.setLevel(C),this.g=!d.$i}trace(C,...A){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...A):console.log(`[main ${p()}]`,C,...A))}debug(C,...A){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...A):console.log(`[main ${p()}]`,C,...A))}info(C,...A){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,C,...A):console.log(`[main ${p()}]`,C,...A))}warn(C,...A){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,C,...A):console.warn(`[main ${p()}]`,C,...A))}error(C,...A){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,C,...A):console.error(`[main ${p()}]`,C,...A))}flush(){}}e.$Uj=h;class t extends i{constructor(C=e.$Qj,A=!0){super(),this.g=A,this.setLevel(C)}trace(C,...A){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...A):console.log(C,...A))}debug(C,...A){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...A):console.log(C,...A))}info(C,...A){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...A):console.log(C,...A))}warn(C,...A){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...A):console.log(C,...A))}error(C,...A){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...A):console.error(C,...A))}flush(){}}e.$Vj=t;class v extends i{constructor(C,A=e.$Qj){super(),this.g=C,this.setLevel(A)}trace(C,...A){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...A])}debug(C,...A){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...A])}info(C,...A){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...A])}warn(C,...A){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...A])}error(C,...A){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...A])}h(C){return typeof C=="string"?C:(0,F.$5i)(C,this.f(o.Trace))}flush(){}}e.$Wj=v;class u extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const A of this.g)A.setLevel(C);super.setLevel(C)}trace(C,...A){for(const G of this.g)G.trace(C,...A)}debug(C,...A){for(const G of this.g)G.debug(C,...A)}info(C,...A){for(const G of this.g)G.info(C,...A)}warn(C,...A){for(const G of this.g)G.warn(C,...A)}error(C,...A){for(const G of this.g)G.error(C,...A)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$Xj=u;class g extends R.$Uc{constructor(C,A,G){if(super(),this.h=C,this.j=A,this.b=new m.$Bc,this.c=this.B(new M.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$7d),this.onDidChangeVisibility=this.g.event,G)for(const T of G)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,O.$Uf)(C)?[...this.b.values()].find(A=>A.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,A){const G=this.n(C),T=(0,O.$Uf)(C)?C:A?.id??(0,N.$8i)(G.toString()).toString(16);let V=this.b.get(G)?.logger;const P=A?.logLevel==="always"?o.Trace:A?.logLevel;V||(V=this.s(G,P??this.getLogLevel(G)??this.h,{...A,id:T}));const L={logger:V,info:{resource:G,id:T,logLevel:P,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(L.info),this.b.set(G,L),V}n(C){return(0,O.$Uf)(C)?(0,k.$Ug)(this.j,`${C}.log`):C}setLogLevel(C,A){if(E.URI.isUri(C)){const G=C,T=A,V=this.b.get(G);V&&T!==V.info.logLevel&&(V.info.logLevel=T===this.h?void 0:T,V.logger?.setLevel(T),this.b.set(V.info.resource,V),this.f.fire([G,T]))}else{this.h=C;for(const[G,T]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,A){const G=this.m(C);G&&A!==!G.info.hidden&&(G.info.hidden=!A,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,A]))}getLogLevel(C){let A;return C&&(A=this.b.get(C)?.info.logLevel),A??this.h}registerLogger(C){const A=this.b.get(C.resource);A?A.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const A=this.b.get(C);A&&(A.logger&&A.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Yj=g;class a{constructor(){this.onDidChangeLogLevel=new M.$7d().event}setLevel(C){}getLevel(){return o.Info}trace(C,...A){}debug(C,...A){}info(C,...A){}warn(C,...A){}error(C,...A){}critical(C,...A){}dispose(){}flush(){}}e.$Zj=a;class b extends a{}e.$1j=b;function f(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=D(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Qj}function I(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function $(y){switch(y){case o.Trace:return{original:"Trace",value:S.localize(0,null)};case o.Debug:return{original:"Debug",value:S.localize(1,null)};case o.Info:return{original:"Info",value:S.localize(2,null)};case o.Warning:return{original:"Warning",value:S.localize(3,null)};case o.Error:return{original:"Error",value:S.localize(4,null)};case o.Off:return{original:"Off",value:S.localize(5,null)}}}function D(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$6j=new l.$yj("logLevel",I(o.Info))}),define(Me[192],Re([1,0,6,13]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=void 0;class M extends S.$Uc{constructor(R,m=[]){super(),this.a=new F.$Xj([R,...m]),this.B(R.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$YP=M}),define(Me[100],Re([1,0,32,159,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(d){function k(p,r){return r-p}d.compare=k;const O=Object.create(null);O[d.Error]=(0,F.localize)(0,null),O[d.Warning]=(0,F.localize)(1,null),O[d.Info]=(0,F.localize)(2,null);function E(p){return O[p]||""}d.toString=E;function l(p){switch(p){case S.default.Error:return d.Error;case S.default.Warning:return d.Warning;case S.default.Info:return d.Info;case S.default.Ignore:return d.Hint}}d.fromSeverity=l;function w(p){switch(p){case d.Error:return S.default.Error;case d.Warning:return S.default.Warning;case d.Info:return S.default.Info;case d.Hint:return S.default.Ignore}}d.toSeverity=w}(R||(e.MarkerSeverity=R={}));var m;(function(d){const k="";function O(l){return E(l,!0)}d.makeKey=O;function E(l,w){const p=[k];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(k),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(k),l.severity!==void 0&&l.severity!==null?p.push(R.toString(l.severity)):p.push(k),l.message&&w?p.push(l.message.replace("\xA6","\\\xA6")):p.push(k),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(k),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(k),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(k),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(k),p.push(k),p.join("\xA6")}d.makeKeyOptionalMessage=E})(m||(e.IMarkerData=m={})),e.$St=(0,M.$hi)("markerService")}),define(Me[193],Re([1,0,5,32,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Jv=e.Severity=void 0,e.$Kv=m,e.Severity=F.default,e.$Jv=(0,M.$hi)("notificationService");var N;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(E){if(E){const l=E;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var d;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class k{constructor(){this.progress=new O,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Lv=k;class O{infinite(){}done(){}total(l){}worked(l){}}e.$Mv=O}),define(Me[194],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=void 0,e.$7j=(0,S.$hi)("productService"),e.$8j="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(me,e,S,F){var M=arguments.length,N=M<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(me,e,S,F);else for(var m=me.length-1;m>=0;m--)(R=me[m])&&(N=(M<3?R(N):M>3?R(e,S,N):R(e,S))||N);return M>3&&N&&Object.defineProperty(e,S,N),N},qe=this&&this.__param||function(me,e){return function(S,F){e(S,F,me)}};define(Me[101],Re([1,0,11,25,6,3]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.ProgressLocation=e.$Nv=void 0,e.$Nv=(0,N.$hi)("progressService");var R;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Ov=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Pv=m;class d{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const w=this.d;this.d=()=>{w?.(),l()}}):Promise.resolve()}}e.$Qv=d;let k=class extends M.$Uc{constructor(l,w){super(),this.a=new S.$Eh,w.withProgress(l,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Rv=k,e.$Rv=k=Je([qe(1,e.$Nv)],k);class O extends M.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new M.$Tc)}start(l){this.stop();const w=++this.a,p=new F.$ee;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>p.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:p.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Sv=O,e.$Tv=(0,N.$hi)("editorProgressService")}),define(Me[30],Re([1,0,55,16]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=void 0;class M{constructor(){this.a=new Map}add(R,m){S.ok(F.$Uf(R)),S.ok(F.$Wf(m)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Zn=new M}),define(Me[72],Re([1,0,5,30]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0,e.$1n={JSONContribution:"base.contributions.json"};function M(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this.b=new S.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,k){this.a[M(d)]=k,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const R=new N;F.$Zn.add(e.$1n.JSONContribution,R)}),define(Me[56],Re([1,0,18,5,16,152,47,72,30]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.ConfigurationScope=e.$5n=e.EditPresentationTypes=void 0,e.$do=r,e.$eo=o,e.$fo=s,e.$go=i,e.$ho=c;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$5n={Configuration:"base.contributions.configuration"};var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n="vscode://schemas/settings/resourceLanguage",e.$ao="vscode://schemas/settings/configurationDefaults";const E=d.$Zn.as(m.$1n.JSONContribution);class l{constructor(){this.h=new Set,this.i=new F.$7d,this.onDidSchemaChange=this.i.event,this.j=new F.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$_n,this.g),this.v()}registerConfiguration(t,v=!0){this.registerConfigurations([t],v)}registerConfigurations(t,v=!0){const u=new Set;this.n(t,v,u),E.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(t){const v=new Set;this.o(t,v),E.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:t,remove:v}){const u=new Set;this.o(v,u),this.n(t,!1,u),E.registerSchema(e.$_n,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(t){const v=new Set;this.k(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(t,v){const u=[];for(const{overrides:g,source:a}of t)for(const b in g)if(v.add(b),e.$co.test(b)){const f=this.a.get(b),I=f?.valuesSources??new Map;if(a)for(const C of Object.keys(g[b]))I.set(C,a);const $={...f?.value||{},...g[b]};this.a.set(b,{source:a,value:$,valuesSources:I});const D=(0,R.$Xi)(b),y={type:"object",default:$,description:N.localize(1,null,D),$ref:e.$_n,defaultDefaultValue:$,source:M.$Uf(a)?void 0:a,defaultValueSource:a};u.push(...r(b)),this.d[b]=y,this.b.properties[b]=y}else{this.a.set(b,{value:g[b],source:a});const f=this.d[b];f&&(this.w(b,f),this.r(b,f))}this.m(u)}deregisterDefaultConfigurations(t){const v=new Set;this.l(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(t,v){for(const{overrides:u,source:g}of t)for(const a in u){const b=this.a.get(a),f=M.$Uf(g)?g:g?.id,I=M.$Uf(b?.source)?b?.source:b?.source?.id;if(f===I)if(v.add(a),this.a.delete(a),e.$co.test(a))delete this.d[a],delete this.b.properties[a];else{const $=this.d[a];$&&(this.w(a,$),this.r(a,$))}}this.u()}deltaConfiguration(t){let v=!1;const u=new Set;t.removedDefaults&&(this.l(t.removedDefaults,u),v=!0),t.addedDefaults&&(this.k(t.addedDefaults,u),v=!0),t.removedConfigurations&&this.o(t.removedConfigurations,u),t.addedConfigurations&&this.n(t.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const v of t)this.h.add(v);this.u()}n(t,v,u){t.forEach(g=>{this.p(g,v,g.extensionInfo,g.restrictedProperties,void 0,u),this.c.push(g),this.q(g)})}o(t,v){const u=g=>{if(g.properties)for(const a in g.properties){v.add(a);const b=this.d[a];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[a],this.s(a,g.properties[a])}g.allOf?.forEach(a=>u(a))};for(const g of t){u(g);const a=this.c.indexOf(g);a!==-1&&this.c.splice(a,1)}}p(t,v=!0,u,g,a=3,b){a=M.$4f(t.scope)?a:t.scope;const f=t.properties;if(f)for(const $ in f){const D=f[$];if(v&&i($,D)){delete f[$];continue}if(D.source=u,D.defaultDefaultValue=f[$].default,this.w($,D),e.$co.test($)?D.scope=void 0:(D.scope=M.$4f(D.scope)?a:D.scope,D.restricted=M.$4f(D.restricted)?!!g?.includes($):D.restricted),f[$].hasOwnProperty("included")&&!f[$].included){this.f[$]=f[$],delete f[$];continue}else this.d[$]=f[$],f[$].policy?.name&&this.e.set(f[$].policy.name,$);!f[$].deprecationMessage&&f[$].markdownDeprecationMessage&&(f[$].deprecationMessage=f[$].markdownDeprecationMessage),b.add($)}const I=t.allOf;if(I)for(const $ of I)this.p($,v,u,g,a,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const v=u=>{const g=u.properties;if(g)for(const b in g)this.r(b,g[b]);u.allOf?.forEach(v)};v(t)}r(t,v){switch(e.$6n.properties[t]=v,v.scope){case 1:e.$7n.properties[t]=v;break;case 2:e.$8n.properties[t]=v;break;case 6:e.$9n.properties[t]=v;break;case 3:e.$0n.properties[t]=v;break;case 4:e.$$n.properties[t]=v;break;case 5:e.$$n.properties[t]=v,this.g.properties[t]=v;break}}s(t,v){switch(delete e.$6n.properties[t],v.scope){case 1:delete e.$7n.properties[t];break;case 2:delete e.$8n.properties[t];break;case 6:delete e.$9n.properties[t];break;case 3:delete e.$0n.properties[t];break;case 4:case 5:delete e.$$n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const v=`[${t}]`,u={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$_n};this.w(v,u),e.$6n.properties[v]=u,e.$7n.properties[v]=u,e.$8n.properties[v]=u,e.$9n.properties[v]=u,e.$0n.properties[v]=u,e.$$n.properties[v]=u}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$_n};e.$6n.patternProperties[e.$bo]=t,e.$7n.patternProperties[e.$bo]=t,e.$8n.patternProperties[e.$bo]=t,e.$9n.patternProperties[e.$bo]=t,e.$0n.patternProperties[e.$bo]=t,e.$$n.patternProperties[e.$bo]=t,this.i.fire()}w(t,v){const u=this.a.get(t);let g=u?.value,a=u?.source;M.$2f(g)&&(g=v.defaultDefaultValue,a=void 0),M.$2f(g)&&(g=s(v.type)),v.default=g,v.defaultValueSource=a}}const w="\\[([^\\]]+)\\]",p=new RegExp(w,"g");e.$bo=`^(${w})+$`,e.$co=new RegExp(e.$bo);function r(h){const t=[];if(e.$co.test(h)){let v=p.exec(h);for(;v?.length;){const u=v[1].trim();u&&t.push(u),v=p.exec(h)}}return(0,S.$Mb)(t)}function o(h){return h.reduce((t,v)=>`${t}[${v}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new l;d.$Zn.add(e.$5n.Configuration,n);function i(h,t){return h.trim()?e.$co.test(h)?N.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function c(){const h=[],t=n.getConfigurationProperties();for(const v of Object.keys(t))h.push([v,t[v].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Me[195],Re([1,0,18,5,122,6,28,26,16,2,47,56,30]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$lo=e.$ko=e.$jo=e.$io=void 0,e.$mo=i;function w(v){return Object.isFrozen(v)?v:m.$On(v)}class p{constructor(u={},g=[],a=[],b){this.b=u,this.c=g,this.d=a,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(g=>{if(g instanceof p)return g;const a=new r("");return a.parseRaw(g),a.configurationModel});this.f=u.reduce((g,a)=>a===g?a:g.merge(a),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,O.$Vi)(this.contents,u):this.contents}inspect(u,g){const a=this;return{get value(){return w(a.rawConfiguration.getValue(u))},get override(){return g?w(a.rawConfiguration.getOverrideValue(u,g)):void 0},get merged(){return w(g?a.rawConfiguration.override(g).getValue(u):a.rawConfiguration.getValue(u))},get overrides(){const b=[];for(const{contents:f,identifiers:I,keys:$}of a.rawConfiguration.overrides){const D=new p(f,$).getValue(u);D!==void 0&&b.push({identifiers:I,value:D})}return b.length?w(b):void 0}}}getOverrideValue(u,g){const a=this.i(g);return a?u?(0,O.$Vi)(a,u):a:void 0}getKeysForOverrideIdentifier(u){const g=[];for(const a of this.overrides)a.identifiers.includes(u)&&g.push(...a.keys);return S.$Mb(g)}getAllOverrideIdentifiers(){const u=[];for(const g of this.overrides)u.push(...g.identifiers);return S.$Mb(u)}override(u){let g=this.a.get(u);return g||(g=this.g(u),this.a.set(u,g)),g}merge(...u){const g=m.$Nn(this.contents),a=m.$Nn(this.overrides),b=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const I of u)if(f.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(g,I.contents);for(const $ of I.overrides){const[D]=a.filter(y=>S.$ub(y.identifiers,$.identifiers));D?(this.h(D.contents,$.contents),D.keys.push(...$.keys),D.keys=S.$Mb(D.keys)):a.push(m.$Nn($))}for(const $ of I.keys)b.indexOf($)===-1&&b.push($)}return new p(g,b,a,f.every(I=>I instanceof p)?void 0:f)}g(u){const g=this.i(u);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const a={};for(const b of S.$Mb([...Object.keys(this.contents),...Object.keys(g)])){let f=this.contents[b];const I=g[b];I&&(typeof f=="object"&&typeof I=="object"?(f=m.$Nn(f),this.h(f,I)):f=I),a[b]=f}return new p(a,this.keys,this.overrides)}h(u,g){for(const a of Object.keys(g)){if(a in u&&d.$Wf(u[a])&&d.$Wf(g[a])){this.h(u[a],g[a]);continue}u[a]=m.$Nn(g[a])}}i(u){let g=null,a=null;const b=f=>{f&&(a?this.h(a,f):a=m.$Nn(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===u?g=f.contents:f.identifiers.includes(u)&&b(f.contents);return b(g),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,g){this.j(u,g,!0)}setValue(u,g){this.j(u,g,!1)}removeValue(u){const g=this.keys.indexOf(u);g!==-1&&(this.keys.splice(g,1),(0,O.$Ui)(this.contents,u),E.$co.test(u)&&this.overrides.splice(this.overrides.findIndex(a=>S.$ub(a.identifiers,(0,E.$do)(u))),1))}j(u,g,a){(0,O.$Ti)(this.contents,u,g,b=>console.error(b)),a=a||this.keys.indexOf(u)===-1,a&&this.keys.push(u),E.$co.test(u)&&this.overrides.push({identifiers:(0,E.$do)(u),keys:Object.keys(this.contents[u]),contents:(0,O.$Si)(this.contents[u],b=>console.error(b))})}}e.$io=p;class r{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,g){if(!d.$4f(u)){const a=this.g(u);this.parseRaw(a,g)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,g){this.a=u;const{contents:a,keys:b,overrides:f,restricted:I,hasExcludedProperties:$}=this.h(u,g);this.b=new p(a,b,f,$?[u]:void 0),this.c=I||[]}g(u){let g={},a=null,b=[];const f=[],I=[];function $(y){Array.isArray(b)?b.push(y):a!==null&&(b[a]=y)}const D={onObjectBegin:()=>{const y={};$(y),f.push(b),b=y,a=null},onObjectProperty:y=>{a=y},onObjectEnd:()=>{b=f.pop()},onArrayBegin:()=>{const y=[];$(y),f.push(b),b=y,a=null},onArrayEnd:()=>{b=f.pop()},onLiteralValue:$,onError:(y,C,A)=>{I.push({error:y,offset:C,length:A})}};if(u)try{M.$Bn(u,D),g=b[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return g}h(u,g){const a=l.$Zn.as(E.$5n.Configuration).getConfigurationProperties(),b=this.i(u,a,!0,g);u=b.raw;const f=(0,O.$Si)(u,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),I=Object.keys(u),$=this.j(u,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:f,keys:I,overrides:$,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(u,g,a,b){let f=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:f};const I={},$=[];for(const D in u)if(E.$co.test(D)&&a){const y=this.i(u[D],g,!1,b);I[D]=y.raw,f=f||y.hasExcludedProperties,$.push(...y.restricted)}else{const y=g[D],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&$.push(D),!b.exclude?.includes(D)&&(b.include?.includes(D)||(C===void 0||b.scopes===void 0||b.scopes.includes(C))&&!(b.skipRestricted&&y?.restricted))?I[D]=u[D]:f=!0}return{raw:I,restricted:$,hasExcludedProperties:f}}j(u,g){const a=[];for(const b of Object.keys(u))if(E.$co.test(b)){const f={};for(const I in u[b])f[I]=u[b][I];a.push({identifiers:(0,E.$do)(b),keys:Object.keys(f),contents:(0,O.$Si)(f,g)})}return a}}e.$jo=r;class o extends N.$Uc{constructor(u,g,a,b){super(),this.c=u,this.f=g,this.g=b,this.b=this.B(new F.$7d),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&a.isEqual(f.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$ko=o;class s{constructor(u,g,a,b,f,I,$,D,y,C,A,G,T){this.a=u,this.b=g,this.c=a,this.overrideIdentifiers=b,this.d=f,this.f=I,this.g=$,this.h=D,this.i=y,this.j=C,this.k=A,this.l=G,this.m=T}get value(){return w(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,g,a,b,f=new p,I=new p,$=new R.$Bc,D=new p,y=new R.$Bc){this.c=u,this.d=g,this.f=a,this.g=b,this.h=f,this.i=I,this.j=$,this.l=D,this.m=y,this.a=null,this.b=new R.$Bc,this.n=null}getValue(u,g,a){return this.p(u,g,a).getValue(u)}updateValue(u,g,a={}){let b;a.resource?(b=this.m.get(a.resource),b||(b=new p,this.m.set(a.resource,b))):b=this.l,g===void 0?b.removeValue(u):b.setValue(u,g),a.resource||(this.a=null)}inspect(u,g,a){const b=this.p(u,g,a),f=this.t(g.resource,a),I=g.resource?this.m.get(g.resource)||this.l:this.l,$=new Set;for(const D of b.overrides)for(const y of D.identifiers)b.getOverrideValue(u,y)!==void 0&&$.add(y);return new s(u,g,b.getValue(u),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,f||void 0,I)}keys(u){const g=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,g){this.j.set(u,g),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,g){const a=[];if(!g){const{added:b,updated:f,removed:I}=h(this.c,u);g=[...b,...f,...I]}for(const b of g)for(const f of(0,E.$do)(b)){const I=this.c.getKeysForOverrideIdentifier(f),$=u.getKeysForOverrideIdentifier(f),D=[...$.filter(y=>I.indexOf(y)===-1),...I.filter(y=>$.indexOf(y)===-1),...I.filter(y=>!m.$Rn(this.c.override(f).getValue(y),u.override(f).getValue(y)))];a.push([f,D])}return this.updateDefaultConfiguration(u),{keys:g,overrides:a}}compareAndUpdatePolicyConfiguration(u){const{added:g,updated:a,removed:b}=h(this.d,u),f=[...g,...a,...b];return f.length&&this.updatePolicyConfiguration(u),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:g,updated:a,removed:b,overrides:f}=h(this.applicationConfiguration,u),I=[...g,...a,...b];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:f}}compareAndUpdateLocalUserConfiguration(u){const{added:g,updated:a,removed:b,overrides:f}=h(this.localUserConfiguration,u),I=[...g,...a,...b];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:f}}compareAndUpdateRemoteUserConfiguration(u){const{added:g,updated:a,removed:b,overrides:f}=h(this.remoteUserConfiguration,u),I=[...g,...a,...b];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:f}}compareAndUpdateWorkspaceConfiguration(u){const{added:g,updated:a,removed:b,overrides:f}=h(this.workspaceConfiguration,u),I=[...g,...a,...b];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:f}}compareAndUpdateFolderConfiguration(u,g){const a=this.folderConfigurations.get(u),{added:b,updated:f,removed:I,overrides:$}=h(a,g),D=[...b,...f,...I];return(D.length||!a)&&this.updateFolderConfiguration(u,g),{keys:D,overrides:$}}compareAndDeleteFolderConfiguration(u){const g=this.folderConfigurations.get(u);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:a,updated:b,removed:f,overrides:I}=h(g,void 0);return{keys:[...a,...b,...f],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,g,a){let b=this.q(g,a);return g.overrideIdentifier&&(b=b.override(g.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(b=b.merge(this.d)),b}q({resource:u},g){let a=this.r();if(g&&u){const b=g.getFolder(u);b&&(a=this.s(b.uri)||a);const f=this.m.get(u);f&&(a=a.merge(f))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let g=this.b.get(u);if(!g){const a=this.r(),b=this.j.get(u);b?(g=a.merge(b),this.b.set(u,g)):g=a}return g}t(u,g){if(g&&u){const a=g.getFolder(u);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,g)=>{const{contents:a,overrides:b,keys:f}=this.j.get(g);return u.push([g,{contents:a,overrides:b,keys:f}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(g=>u.add(g)),this.userConfiguration.keys.forEach(g=>u.add(g)),this.i.keys.forEach(g=>u.add(g)),this.j.forEach(g=>g.keys.forEach(a=>u.add(a))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(g=>u.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>u.add(g)),this.i.getAllOverrideIdentifiers().forEach(g=>u.add(g)),this.j.forEach(g=>g.getAllOverrideIdentifiers().forEach(a=>u.add(a))),[...u.values()]}v(u){const g=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(a=>g.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(a=>g.add(a)),this.i.getKeysForOverrideIdentifier(u).forEach(a=>g.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(u).forEach(b=>g.add(b))),[...g.values()]}static parse(u){const g=this.w(u.defaults),a=this.w(u.policy),b=this.w(u.application),f=this.w(u.user),I=this.w(u.workspace),$=u.folders.reduce((D,y)=>(D.set(k.URI.revive(y[0]),this.w(y[1])),D),new R.$Bc);return new n(g,a,b,f,new p,I,$,new p,new R.$Bc)}static w(u){return new p(u.contents,u.keys,u.overrides)}}e.$lo=n;function i(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const u=new Set,g=new Map;for(const b of v)b.keys.forEach(f=>u.add(f)),b.overrides.forEach(([f,I])=>{const $=(0,R.$yc)(g,f,new Set);I.forEach(D=>$.add(D))});const a=[];return g.forEach((b,f)=>a.push([f,[...b.values()]])),{keys:[...u.values()],overrides:a}}class c{constructor(u,g,a,b){this.change=u,this.f=g,this.g=a,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const f of u.keys)this.affectedKeys.add(f);for(const[,f]of u.overrides)for(const I of f)this.affectedKeys.add(I);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,g){const a=this.a+u,b=this.d.indexOf(a);if(b<0)return!1;const f=b+a.length;if(f>=this.d.length)return!1;const I=this.d.charCodeAt(f);if(I!==this.b&&I!==this.c)return!1;if(g){const $=this.previousConfiguration?this.previousConfiguration.getValue(u,g,this.f?.workspace):void 0,D=this.g.getValue(u,g,this.h);return!m.$Rn($,D)}return!0}}e.$no=c;function h(v,u){const{added:g,removed:a,updated:b}=t(u?.rawConfiguration,v?.rawConfiguration),f=[],I=v?.getAllOverrideIdentifiers()||[],$=u?.getAllOverrideIdentifiers()||[];if(u){const D=$.filter(y=>!I.includes(y));for(const y of D)f.push([y,u.getKeysForOverrideIdentifier(y)])}if(v){const D=I.filter(y=>!$.includes(y));for(const y of D)f.push([y,v.getKeysForOverrideIdentifier(y)])}if(u&&v){for(const D of I)if($.includes(D)){const y=t({contents:v.getOverrideValue(void 0,D)||{},keys:v.getKeysForOverrideIdentifier(D)},{contents:u.getOverrideValue(void 0,D)||{},keys:u.getKeysForOverrideIdentifier(D)});f.push([D,[...y.added,...y.removed,...y.updated]])}}return{added:g,removed:a,updated:b,overrides:f}}function t(v,u){const g=v?u?v.keys.filter(f=>u.keys.indexOf(f)===-1):[...v.keys]:[],a=u?v?u.keys.filter(f=>v.keys.indexOf(f)===-1):[...u.keys]:[],b=[];if(v&&u){for(const f of u.keys)if(v.keys.indexOf(f)!==-1){const I=(0,O.$Vi)(u.contents,f),$=(0,O.$Vi)(v.contents,f);m.$Rn(I,$)||b.push(f)}}return{added:g,removed:a,updated:b}}}),define(Me[102],Re([1,0,14,3]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.RemoteAuthorityResolverErrorCode=e.$ul=e.$tl=e.RemoteConnectionType=e.$sl=void 0,e.$wl=k,e.$sl=(0,F.$hi)("remoteAuthorityResolverService");var M;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class N{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$tl=N;class R{constructor(E,l){this.host=E,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$ul=R;var m;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound",O.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class d extends S.$bb{static isNotAvailable(E){return E instanceof d&&E._code===m.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof d&&E._code===m.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof d&&E._code===m.NoResolverFound}static isInvalidAuthority(E){return E instanceof d&&E._code===m.InvalidAuthority}static isHandled(E){return E instanceof d&&E.isHandled}constructor(E,l=m.Unknown,w){super(E),this._message=E,this._code=l,this._detail=w,this.isHandled=l===m.NotAvailable&&w===!0,Object.setPrototypeOf(this,d.prototype)}}e.$vl=d;function k(O){const E=O.indexOf("+");return E===-1?O:O.substring(0,E)}}),define(Me[57],Re([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=F,e.$tm=M,e.$um=N,e.$vm=R;function F(d){return d.scheme===S.Schemas.vscodeRemote?d.authority:void 0}function M(d){if(!d)return;const k=d.indexOf("+");return k<0?d:d.substr(0,k)}function N(d){const{host:k,port:O}=m(d);if(typeof O>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:O}}function R(d,k){let{host:O,port:E}=m(d);return typeof E>"u"&&(E=k),{host:O,port:E}}function m(d){const k=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const O=d.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const E=d.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:d,port:void 0}}}),define(Me[20],Re([1,0,15,3,57]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Em=e.$Dm=e.$Cm=e.TargetPlatform=e.ExtensionType=e.$Bm=e.$zm=e.$ym=e.$xm=e.$wm=void 0,e.$Am=N,e.$Fm=E,e.$Gm=l,e.$Hm=w,e.$Im=p,e.$wm="extensions.user.cache",e.$xm="extensions.builtin.cache",e.$ym="undefined_publisher",e.$zm=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Bm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class d{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return S.$lf(n,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Cm=d;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(d.toKey(o))}delete(o){return this.c.delete(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}}e.$Dm=k;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(d.toKey(o))}get(o){return this.c.get(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}set(o,s){this.c.set(d.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Em=O;function E(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function w(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function p(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,M.$tm)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Jm=(0,F.$hi)("IBuiltinExtensionsScannerService")}),define(Me[103],Re([1,0,14,20]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const d of R){const k=this.readActivationEvents(d);k.length>0&&(m[F.$Cm.toKey(d.identifier)]=k)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let d=0;d<m.length;d++)m[d]==="onUri"&&(m[d]=`onUri:${F.$Cm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const d in R.contributes){const k=this.a.get(d);if(!k)continue;const O=R.contributes[d],E=Array.isArray(O)?O:[O];try{k(E,m)}catch(l){(0,S.$1)(l)}}return m}}e.$JF=M,e.$KF=new M}),define(Me[196],Re([1,0,21,73,33]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=R,e.$2o=m;function N(d){if(S.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function R(d,k,O,E,l,w,p,r,o){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=p,s.sessionID=(0,M.$Dg)()+Date.now(),s.commitHash=E,s.version=l,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,S.$h)(S.$u),s["common.nodePlatform"]=F.$ec,s["common.nodeArch"]=O,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),S.$l&&(s["common.snap"]="true");const c=N(k);return c&&(s["common.platformDetail"]=c),s}function m(d){const k=F.env.USERDNSDOMAIN;if(!k)return!1;const O=k.toLowerCase();return d.some(E=>O===E)}}),define(Me[197],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0,e.$Ml=(0,S.$hi)("telemetryService"),e.$Nl=(0,S.$hi)("customEndpointTelemetryService"),e.$Ol="telemetry.currentSessionDate",e.$Pl="telemetry.firstSessionDate",e.$Ql="telemetry.lastSessionDate",e.$Rl="telemetry.machineId",e.$Sl="telemetry.sqmId",e.$Tl="telemetry",e.$Ul="telemetry.telemetryLevel",e.$Vl="telemetry.enableCrashReporter",e.$Wl="telemetry.enableTelemetry";var F;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var M;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Me[58],Re([1,0,26,16,57,196,197]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0,e.$0o=O,e.$$o=E,e.$_o=l,e.$ap=w,e.$bp=r,e.$cp=s,e.$dp=n,e.$ep=h;class m{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$3o=m;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$4o=d,e.$5o=new d;class k{async publicLog(v,u,g){}async publicLogError(v,u,g){}}e.$6o=k,e.$7o="telemetry",e.$8o="extensionTelemetryLog",e.$9o={log:()=>null,flush:()=>Promise.resolve(null)};function O(t,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!t.enableTelemetry)}function E(t,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const v=t.getValue(R.$Ul),u=t.getValue(R.$Vl);if(t.getValue(R.$Wl)===!1||u===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const v={},u={},g={};o(t,g);for(let a in g){a=a.length>150?a.substr(a.length-149):a;const b=g[a];typeof b=="number"?u[a]=b:typeof b=="boolean"?u[a]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${b.length}`),v[a]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(v[a]=b)}return{properties:v,measurements:u}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const v=(0,M.$tm)(t);return p.has(v)?v:"other"}function o(t,v,u=0,g){if(t)for(const a of Object.getOwnPropertyNames(t)){const b=t[a],f=g?g+a:a;Array.isArray(b)?v[f]=(0,S.$Sn)(b):b instanceof Date?v[f]=b.toISOString():(0,F.$Wf)(b)?u<2?o(b,v,u+1,f+"."):v[f]=(0,S.$Sn)(b):v[f]=b}}function s(t,v){const u=t.msftInternalDomains||[],g=v.getValue("telemetry.internalTesting");return(0,N.$2o)(u)||g}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,v){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let u=t;const g=[];for(const I of v)for(;;){const $=I.exec(t);if(!$)break;g.push([$.index,I.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(u="";;){const I=b.exec(t);if(!I)break;const $=g.some(([D,y])=>I.index<y&&D<b.lastIndex);!a.test(I[0])&&!$&&(u+=t.substring(f,I.index)+"<REDACTED: user-file-path>",f=b.lastIndex)}return f<t.length&&(u+=t.substr(f)),u}function c(t){if(!t)return t;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of v)if(u.regex.test(t))return`<REDACTED: ${u.label}>`;return t}function h(t,v){return(0,S.$Pn)(t,u=>{if(u instanceof m||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let g=u.replaceAll("%20"," ");g=i(g,v);for(const a of v)g=g.replace(a,"");return g=c(g),g}})}}),define(Me[198],Re([1,0,15,98,20,21,2,14,73,58]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$gp=void 0,e.$fp=O,e.$hp=p,e.$ip=r,e.$jp=o,e.$kp=s,e.$lp=n,e.$mp=i,e.$np=c,e.$pp=h,e.$qp=v;function O(u,g){return u.uuid&&g.uuid?u.uuid===g.uuid:u.id===g.id?!0:(0,S.$gf)(u.id,g.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const a=g.manifest?g.manifest.version:g.version,b=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,a,b)}static parse(g){const a=E.exec(g);return a&&a[1]&&a[2]?new l({id:a[1]},a[2],a[4]||void 0):null}constructor(g,a,b="undefined"){this.version=a,this.targetPlatform=b,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?O(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$gp=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(u){const g=w.exec(u);return g&&g[1]?[o(g[1]),g[2]]:[o(u),void 0]}function r(u,g){return`${u}.${g}`}function o(u){return u.toLowerCase()}function s(u,g){return o(r(u??M.$ym,g))}function n(u,g){const a=[],b=f=>{for(const I of a)if(I.some($=>O(g($),g(f))))return I;return null};for(const f of u){const I=b(f);I?I.push(f):a.push([f])}return a}function i(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}function c(u){return{id:new k.$3o(u.identifier.id),name:new k.$3o(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$op=new M.$Cm("pprice.better-merge");function h(u,g){const a=[],b=g.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const f=b.shift();if(f&&a.every(I=>!O(I.identifier,{id:f}))){const I=u.filter($=>O($.identifier,{id:f}));I.length===1&&(a.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function t(u,g){if(!N.$k)return!1;let a;try{a=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){g.debug("Error while getting the os-release file.",(0,m.$0)(f))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(u,g){const a=await t(u,g),b=(0,F.$Mo)(a?"alpine":N.$u,d.$fc);return g.debug("ComputeTargetPlatform:",b),b}}),define(Me[199],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=S,e.$6r=F,e.$7r=M,e.$8r=N,e.$9r=R,e.$0r=m;function S(d){return[...d.entries()]}function F(d){return d?[...d.entries()]:[]}function M(d){return new Map(d)}function N(d){return new Map(d??[])}function R(d){return Array.from(d.entries()).map(k=>[k[0],S(k[1].map),F(k[1].descriptionMap)])}function m(d){return new Map(d.map(k=>[k[0],{map:M(k[1]),descriptionMap:N(k[2])}]))}}),define(Me[200],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=void 0;class S{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,N,R=5){const m=N(d=>{const k=typeof d=="string"?d:d.data;let O=this.a.get(M);if(O){O.data.push(k);return}const E=setTimeout(()=>this.flushBuffer(M),R);O={data:[k],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(M),m.dispose()}},this.a.set(M,O)});return m}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const N=this.a.get(M);N&&(this.a.delete(M),this.b(M,N.data.join("")))}}e.$_tb=S}),define(Me[201],Re([1,0,11,91,300,40,5,16,2,160,72,30]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.$Vw=e.$Uw=e.IconFontDefinition=e.IconContribution=e.$Rw=void 0,e.$Sw=o,e.$Tw=s,e.$Rw={IconContribution:"base.contributions.icons"};var l;(function(h){function t(v,u){let g=v.defaults;for(;N.ThemeIcon.isThemeIcon(g);){const a=r.getIcon(g.id);if(!a)return;g=a.defaults}return g}h.getDefinition=t})(l||(e.IconContribution=l={}));var w;(function(h){function t(u){return{weight:u.weight,style:u.style,src:u.src.map(g=>({format:g.format,location:g.location.toString()}))}}h.toJSONObject=t;function v(u){const g=a=>(0,m.$Uf)(a)?a:void 0;if(u&&Array.isArray(u.src)&&u.src.every(a=>(0,m.$Uf)(a.format)&&(0,m.$Uf)(a.location)))return{weight:g(u.weight),style:g(u.style),src:u.src.map(a=>({format:a.format,location:d.URI.parse(a.location)}))}}h.fromJSONObject=v})(w||(e.IconFontDefinition=w={}));class p{constructor(){this.a=new R.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,v,u,g){const a=this.b[t];if(a){if(u&&!a.description){a.description=u,this.d.properties[t].markdownDescription=`${u} $(${t})`;const I=this.e.enum.indexOf(t);I!==-1&&(this.e.enumDescriptions[I]=u),this.a.fire()}return a}const b={id:t,description:u,defaults:v,deprecationMessage:g};this.b[t]=b;const f={$ref:"#/definitions/icons"};return g&&(f.deprecationMessage=g),u&&(f.markdownDescription=`${u}: $(${t})`),this.d.properties[t]=f,this.e.enum.push(t),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enum.splice(v,1),this.e.enumDescriptions.splice(v,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,v){const u=this.f[t];return u||(this.f[t]=v,this.a.fire(),v)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(a,b)=>a.id.localeCompare(b.id),v=a=>{for(;N.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.b).map(a=>this.b[a]);for(const a of g.filter(b=>!!b.description).sort(t))u.push(`|<i class="${v(a)}"></i>|${a.id}|${N.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const a of g.filter(b=>!N.ThemeIcon.isThemeIcon(b.defaults)).sort(t))u.push(`|<i class="${v(a)}"></i>|${a.id}|`);return u.join(`
`)}}const r=new p;E.$Zn.add(e.$Rw.IconContribution,r);function o(h,t,v,u){return r.registerIcon(h,t,v,u)}function s(){return r}function n(){const h=(0,M.$Cj)();for(const t in h){const v="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:v})}}n(),e.$Uw="vscode://schemas/icons";const i=E.$Zn.as(O.$1n.JSONContribution);i.registerSchema(e.$Uw,r.getIconSchema());const c=new S.$th(()=>i.notifySchemaChanged(e.$Uw),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$Vw=o("widget-close",F.$Gj.close,(0,k.localize)(2,null)),e.$Ww=o("goto-previous-location",F.$Gj.arrowUp,(0,k.localize)(3,null)),e.$Xw=o("goto-next-location",F.$Gj.arrowDown,(0,k.localize)(4,null)),e.$Yw=N.ThemeIcon.modify(F.$Gj.sync,"spin"),e.$Zw=N.ThemeIcon.modify(F.$Gj.loading,"spin")}),define(Me[202],Re([1,0,5,2,47,3,13]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.$2v=e.$Zv=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Vv=e.$Uv=void 0,e.$Wv=k,e.$Xv=E,e.$Yv=l,e.$1v=w,e.$3v=p,e.$4v=r,e.$Uv=(0,N.$hi)("tunnelService"),e.$Vv=(0,N.$hi)("sharedTunnelsService");var m;(function(n){n.Http="http",n.Https="https"})(m||(e.TunnelProtocol=m={}));var d;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(d||(e.TunnelPrivacyId=d={}));function k(n){return!!n.forwardPort}var O;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(O||(e.ProvidedOnAutoForward=O={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function l(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const c of i){const h=c.split("=")[1];if(/^https?:/.exec(h)){const t=E(F.URI.parse(h));if(t)return t}}}e.$Zv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(n){return e.$Zv.indexOf(n)>=0}e.$2v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(n){return e.$2v.indexOf(n)>=0}function r(n,i,c,h){if(c===1)return!1;if(c===2&&p(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class o{constructor(i,c,h){this.remoteAddress=i,this.localAddress=c,this.b=h,this.a=new S.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5v=o;let s=class{constructor(i,c){this.k=i,this.l=c,this.a=new S.$7d,this.onTunnelOpened=this.a.event,this.b=new S.$7d,this.onTunnelClosed=this.b.event,this.c=new S.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const h of c){const t=Array.from(h.values());for(const v of t){const u=await v.value;u&&typeof u!="string"&&i.push(u)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,h,t,v){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:h,privacy:t,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(p(i)||w(i))&&(i=e.$Zv[0]);const h=this.s(i,c);if(h)return++h.refcount,h.value}openTunnel(i,c,h,t,v,u=!1,g,a){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${v}.`);const b=this.f??i;if(!b)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const f=this.t(b,c,h,t,v,u,g,a);return f?f.then(I=>{if(I){if(typeof I=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),I}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(I);return(I.tunnelRemoteHost!==c||I.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),g&&I.privacy!==g&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),f)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const h=c.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=h.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const h=this.e.get(i);if(h&&h.has(c)){const t=h.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:h})}async r(i,c){const h=this.e.get(i);if(h){const t=h.get(c),v=t?await t.value:void 0;(!v||typeof v=="string")&&h.delete(c),h.size===0&&this.e.delete(i)}}s(i,c){const h=[i];w(i)?(h.push(...e.$Zv),h.push(...e.$2v)):p(i)&&h.push(...e.$2v);const t=h.map(v=>this.e.get(v));for(const v of t){const u=v?.get(c);if(u)return u}}canTunnel(i){return!!E(i)}u(i,c,h,t,v,u,g){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${t}.`);const a=h;this.j.add(a);const b=t===void 0?h:t,f={elevationRequired:v?this.isPortPrivileged(b):!1},I={remoteAddress:{host:c,port:h},localAddressPort:t,privacy:u,public:u?u!==d.Private:void 0,protocol:g},$=i.forwardPort(I,f);return $?(this.q(c,h,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(a)})):this.j.delete(a),$}};e.$6v=s,e.$6v=s=Je([qe(0,R.$Nj),qe(1,M.$Ni)],s)}),define(Me[203],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$7v=void 0,e.$7v=(0,S.$hi)("editSessionIdentityService");var F;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Me[204],Re([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=F,e.$QL=M,e.$RL=N,e.$SL=R,e.$TL=m;function F(d){return d.scheme!==S.Schemas.file&&d.scheme!==S.Schemas.vscodeRemote}function M(d){if(d.folders.length)return d.folders.every(k=>F(k.uri))?d.folders[0].uri:void 0;if(d.configuration&&F(d.configuration))return d.configuration}function N(d){return M(d)?.scheme}function R(d){return M(d)?.authority}function m(d){return M(d)!==void 0}}),define(Me[48],Re([1,0,161,19,51,24,2,3,12]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Bi=e.$Ai=e.WorkbenchState=e.$ui=e.$ti=e.$qi=void 0,e.$ri=k,e.$si=O,e.$vi=E,e.$wi=l,e.$xi=w,e.$yi=r,e.$zi=o,e.$Ci=i,e.$Hi=c,e.$Ii=h,e.$Ki=t,e.$Li=v,e.$Mi=u,e.$qi=(0,m.$hi)("contextService");function k(g){const a=g;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}function O(g){return typeof g?.id=="string"&&!k(g)&&!l(g)}e.$ti={id:"ext-dev"},e.$ui={id:"empty-window"};function E(g,a){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,F.$oc)(g)}:a?e.$ti:e.$ui;const b=g;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}function l(g){const a=g;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}function w(g){const a=g;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const b=g;if(b?.configPath)return{id:b.id,configPath:R.URI.revive(b.configPath)};if(g?.id)return{id:g.id}}var p;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function r(g){const a=g;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function o(g){const a=g;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class s{constructor(a,b,f,I,$){this.h=a,this.j=f,this.k=I,this.l=$,this.c=M.$ni.forUris(this.l,()=>!0),this.folders=b}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=M.$ni.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ai=s;class n{constructor(a,b){this.raw=b,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,N.$Ug)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Bi=n;function i(g){return new n({uri:g,index:0,name:(0,N.$Qg)(g)},{uri:g.toString()})}e.$Di="code-workspace",e.$Ei=`.${e.$Di}`,e.$Fi=[{name:(0,S.localize)(0,null),extensions:[e.$Di]}],e.$Gi="workspace.json";function c(g,a){return N.$Lg.isEqualOrParent(g,a.untitledWorkspacesHome)}function h(g){let a;return R.URI.isUri(g)?a=g:a=g.configuration,a?.scheme===d.Schemas.tmp}e.$Ji="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(g){return g.id===e.$Ji}function v(g,a){return!c(g,a)&&!h(g)}function u(g){return(typeof g=="string"?(0,F.$pc)(g):(0,N.$Sg)(g))===e.$Ei}}),define(Me[74],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class S{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const N=this.c++;return this.b.set(N,M),this.e(),N}get(M,N){return this.b.has(M)?this.b.get(M)[N]:void 0}delete(M){this.b.delete(M),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Aic=S}),define(Me[43],Re([1,0,12,24,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;class N{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new F.$Jg(m=>{const d=this.b.get(m.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(m,d){d===null?this.b.delete(m.scheme):this.b.set(m.scheme,d)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Fic=N,e.$Gic=(0,M.$hi)("IExtHostFileSystemInfo")}),define(Me[27],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=void 0,e.$QO=(0,S.$hi)("IExtHostInitDataService")}),define(Me[205],Re([1,0,167,13,192,27]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;let R=class extends M.$YP{constructor(d,k,O){const E=O.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",l=O.remote.isRemote?(0,S.localize)(0,null):d?(0,S.localize)(1,null):(0,S.localize)(2,null);super(k.createLogger(E,{name:l}))}};e.$Mkc=R,e.$Mkc=R=Je([qe(1,F.$Oj),qe(2,N.$QO)],R)}),define(Me[206],Re([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=void 0;class F{constructor(R,m,d){this.h=new Map,this.a=R,this.b=m,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new S.$th(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const E of k.values())E.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let d=this.f[R];return typeof d>"u"&&(d=m),d}update(R,m){this.f[R]=m;const d=this.h.get(R);if(d!==void 0)return d.p;const k=new S.$Eh;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$ojc=F;class M extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$pjc=M}),define(Me[207],Re([1,0,5,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class M{constructor(R){this.c=R,this.a=new S.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,d,k){const E=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(m.value,d,k);this.b.fire(E)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$ckc=M}),define(Me[17],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=void 0,e.$AO=(0,S.$hi)("IExtHostRpcService");class F{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$BO=F}),define(Me[208],Re([1,0,20,5]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class M{#e;constructor(R,m){this.b=new F.$7d,this.onDidChange=this.b.event,this.a=S.$Cm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$wjc=M}),define(Me[59],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Yic=void 0,e.$Yic=(0,S.$hi)("IURITransformerService");class F{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Zic=F}),define(Me[209],Re([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enb=M,e.$Fnb=R;class F{constructor(){this.buffers=[]}add(d){let k=this.buffers.indexOf(d);return k<0&&(k=this.buffers.length,this.buffers.push(d)),k}}function M(m,d){if(d.serializeBuffersForPostMessage){const k=new F,E=JSON.stringify(m,(w,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(p)};if(ArrayBuffer.isView(p)){const r=N(p);if(r)return{$$vscode_array_buffer_reference$$:!0,index:k.add(p.buffer),view:{type:r,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),l=k.buffers.map(w=>{const p=new Uint8Array(w);return S.$ue.wrap(p)});return{message:E,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,d){const k=d.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),O=d.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const p=w,{index:r}=p,o=k[r];if(p.view)switch(p.view.type){case 1:return new Int8Array(o,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(m,O),arrayBuffers:k}}}),define(Me[104],Re([1,0,176,16,2,6,3,30,42,12,41,138,32]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$lF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$cF=e.EditorInputCapabilities=e.$bF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0,e.$6E=r,e.$7E=o,e.$8E=s,e.$9E=n,e.$0E=i,e.$$E=c,e.$_E=h,e.$aF=t,e.$dF=f,e.$eF=$,e.$fF=D,e.$gF=y,e.$hF=C,e.$iF=A,e.$jF=G,e.$kF=re,e.$mF=Se,e.$nF=we,e.$oF=_,e.$pF=ve,e.$1E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$2E={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$3E="workbench.editor.sidebysideEditor",e.$4E="workbench.editors.textDiffEditor",e.$5E="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var p;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function r(ne){const fe=ne;return!!fe&&typeof fe.getSelection=="function"&&!!fe.onDidChangeSelection}function o(ne,fe,W){for(const te of W.visibleEditorPanes)if(te.group.id===fe&&ne.matches(te.input))return te.getViewState()}function s(ne){if(f(ne))return!1;const fe=ne;return M.URI.isUri(fe?.resource)}function n(ne){if(f(ne))return!1;const fe=ne;return fe?.original!==void 0&&fe.modified!==void 0}function i(ne){if(f(ne))return!1;const fe=ne;return!fe||fe.resources&&!Array.isArray(fe.resources)?!1:!!fe.resources||!!fe.multiDiffSource}function c(ne){if(f(ne)||n(ne))return!1;const fe=ne;return fe?.primary!==void 0&&fe.secondary!==void 0}function h(ne){if(f(ne))return!1;const fe=ne;return fe?fe.resource===void 0||fe.resource.scheme===k.Schemas.untitled||fe.forceUntitled===!0:!1}function t(ne){if(f(ne))return!1;const fe=ne;return M.URI.isUri(fe?.base?.resource)&&M.URI.isUri(fe?.input1?.resource)&&M.URI.isUri(fe?.input2?.resource)&&M.URI.isUri(fe?.result?.resource)}var v;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(v||(e.Verbosity=v={}));var u;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class g{constructor(){this.a=new Map}registerSource(fe,W){let te=this.a.get(fe);return te||(te={source:fe,label:W},this.a.set(fe,te)),te.source}getSourceLabel(fe){return this.a.get(fe)?.label??fe}}e.$bF=new g;var a;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad",ne[ne.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class b extends N.$Uc{}e.$cF=b;function f(ne){return ne instanceof b}function I(ne){const fe=ne;return M.URI.isUri(fe?.preferredResource)}function $(ne){const fe=ne;return f(fe?.primary)&&f(fe?.secondary)}function D(ne){const fe=ne;return f(fe?.modified)&&f(fe?.original)}function y(ne,fe,W,te,Ee){return ve(te,[(0,E.$4i)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Te={...W,limits:{size:Number.MAX_VALUE}};ne.openEditor(fe,Te)}}),(0,E.$4i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function C(ne){return f(ne?.editor)}function A(ne){const fe=ne;return C(ne)&&fe?.group!==void 0}function G(ne){const fe=ne;return typeof fe?.groupId=="number"&&f(fe.editor)}var T;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var V;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(V||(e.GroupModelChangeKind=V={}));var P;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(P||(e.SideBySideEditor=P={}));class L{getOriginalUri(fe,W){if(!fe)return;if(t(fe))return e.$lF.getOriginalUri(fe.result,W);if(W?.supportSideBySide){const{primary:Ee,secondary:Te}=this.a(fe);if(Ee&&Te){if(W?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===P.ANY)return this.getOriginalUri(Ee,{filterByScheme:W.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:W.filterByScheme});fe=W.supportSideBySide===P.PRIMARY?Ee:Te}}if(n(fe)||i(fe)||c(fe)||t(fe))return;const te=I(fe)?fe.preferredResource:fe.resource;return!te||!W||!W.filterByScheme?te:this.b(te,W.filterByScheme)}a(fe){return $(fe)||c(fe)?{primary:fe.primary,secondary:fe.secondary}:D(fe)||n(fe)?{primary:fe.modified,secondary:fe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(fe,W){if(!fe)return;if(t(fe))return e.$lF.getCanonicalUri(fe.result,W);if(W?.supportSideBySide){const{primary:Ee,secondary:Te}=this.a(fe);if(Ee&&Te){if(W?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===P.ANY)return this.getCanonicalUri(Ee,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:W.filterByScheme});fe=W.supportSideBySide===P.PRIMARY?Ee:Te}}if(n(fe)||i(fe)||c(fe)||t(fe))return;const te=fe.resource;return!te||!W||!W.filterByScheme?te:this.b(te,W.filterByScheme)}b(fe,W){if(Array.isArray(W)){if(W.some(te=>fe.scheme===te))return fe}else if(W===fe.scheme)return fe}}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(q||(e.EditorCloseMethod=q={}));function re(ne,fe,W,te){if(!ne.isSticky(fe))return!1;switch(te.preventPinnedEditorClose){case"keyboardAndMouse":return W===q.MOUSE||W===q.KEYBOARD;case"mouse":return W===q.MOUSE;case"keyboard":return W===q.KEYBOARD}return!1}e.$lF=new L;var ue;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(fe){const W=this.a=fe.get(R.$gi);for(const[te,Ee]of this.c)this.e(te,Ee,W);this.c.clear()}e(fe,W,te){const Ee=te.createInstance(W);this.d.set(fe,Ee)}registerFileEditorFactory(fe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=fe}getFileEditorFactory(){return(0,F.$6f)(this.b)}registerEditorSerializer(fe,W){if(this.c.has(fe)||this.d.has(fe))throw new Error(`A editor serializer with type ID '${fe}' was already registered.`);return this.a?this.e(fe,W,this.a):this.c.set(fe,W),(0,N.$Sc)(()=>{this.c.delete(fe),this.d.delete(fe)})}getEditorSerializer(fe){return this.d.get(typeof fe=="string"?fe:fe.typeId)}}m.$Zn.add(e.$1E.EditorFactory,new ye);async function Se(ne,fe,W){return!ne||!ne.length?[]:await Promise.all(ne.map(async te=>{const Ee=M.URI.revive(te.fileUri);if(!Ee){W.info("Cannot resolve the path because it is not valid.",te);return}if(!await fe.canHandleResource(Ee)){W.info("Cannot resolve the path because it cannot be handled",te);return}let Ie=te.exists,pe=te.type;if(typeof Ie!="boolean"||typeof pe!="number")try{pe=(await fe.stat(Ee)).isDirectory?d.FileType.Directory:d.FileType.Unknown,Ie=!0}catch(J){W.error(J),Ie=!1}if(!Ie&&te.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",te);return}if(pe===d.FileType.Directory){W.info("Cannot resolve the path because it is a directory",te);return}const ge={...te.options,pinned:!0};return Ie?{resource:Ee,options:ge}:{resource:Ee,options:ge,forceUntitled:!0}}))}var le;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function we(ne){const fe=ne;if(!fe)return!1;const W=fe;if(W.modified)return we(W.modified);const te=fe;return!!(te.contributionsState&&te.viewState&&Array.isArray(te.cursorState))}function _(ne){return(0,O.$6i)(ne)}function ve(ne,fe,W){const te=(0,O.$7i)(ne,fe);return te.forceMessage=W?.forceMessage,te.forceSeverity=W?.forceSeverity,te.allowDialog=W?.allowDialog,te}}),define(Me[210],Re([1,0,5,177,3,6,28,30,18,26,91,201]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$vF=e.ViewContentGroups=e.$tF=e.ViewContainerLocation=e.Extensions=e.$sF=e.$rF=e.$qF=void 0,e.$uF=p,e.$qF="views",e.$rF=(0,F.localize)(0,null),e.$sF=(0,E.$Sw)("default-view-icon",O.$Gj.window,(0,F.localize)(1,null));var l;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var w;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$tF=[0,1,2];function p(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new S.$7d),this.onDidRegister=this.c.event,this.f=this.B(new S.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(u,g,a){const b=this.get(u.id);if(b)return b;const f=u;return f.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,R.$yc)(this.g,g,[]).push(f),a?.isDefault&&this.h.push(f),this.c.fire({viewContainer:f,viewContainerLocation:g}),f}deregisterViewContainer(u){for(const g of this.g.keys()){const a=this.g.get(g),b=a?.indexOf(u);if(b!==-1){a?.splice(b,1),a.length===0&&this.g.delete(g),this.f.fire({viewContainer:u,viewContainerLocation:g});return}}}get(u){return this.all.filter(g=>g.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(a=>a?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(g=>this.getViewContainerLocation(g)===u)}}m.$Zn.add(l.ViewContainersRegistry,new r);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(v,u){const g=v.group??o.More,a=u.group??o.More;return g!==a?g.localeCompare(a):(v.order??5)-(u.order??5)}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new S.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(u,g){this.registerViews2([{views:u,viewContainer:g}])}registerViews2(u){u.forEach(({views:g,viewContainer:a})=>this.r(g,a)),this.c.fire(u)}deregisterViews(u,g){const a=this.s(u,g);a.length&&this.f.fire({views:a,viewContainer:g})}moveViews(u,g){for(const a of this.m.keys())if(a!==g){const b=this.s(u,a);b.length&&(this.r(b,g),this.g.fire({views:b,from:a,to:g}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const g of this.j){const a=(this.m.get(g)||[]).filter(b=>b.id===u)[0];if(a)return a}return null}getViewContainer(u){for(const g of this.j)if((this.m.get(g)||[]).filter(b=>b.id===u)[0])return g;return null}registerViewWelcomeContent(u,g){return this.n.add(u,g),this.h.fire(u),(0,N.$Sc)(()=>{this.n.delete(u,g),this.h.fire(u)})}registerViewWelcomeContent2(u,g){const a=new Map;for(const[b,f]of g)this.n.add(u,f),a.set(b,(0,N.$Sc)(()=>{this.n.delete(u,f),this.h.fire(u)}));return this.h.fire(u),a}getViewWelcomeContent(u){const g=[];return this.n.forEach(u,a=>g.push(a)),g.sort(s)}r(u,g){let a=this.m.get(g);a||(a=[],this.m.set(g,a),this.j.push(g));for(const b of u){if(this.getView(b.id)!==null)throw new Error((0,F.localize)(2,null,b.id));a.push(b)}}s(u,g){const a=this.m.get(g);if(!a)return[];const b=[],f=[];for(const I of a)u.includes(I)?b.push(I):f.push(I);return b.length&&(f.length?this.m.set(g,f):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),b}}m.$Zn.add(l.ViewsRegistry,new n),e.$vF=(0,M.$hi)("viewDescriptorService");var i;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var c;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,g){this.c=!1,this.d=!1,(0,k.$Qn)(this,u),this.d=!!g,this.resolve=async a=>{if(g&&!this.c){const b=await g(a);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$wF=h;class t extends Error{constructor(u){super((0,F.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$xF=t}),define(Me[211],Re([1,0,2,29,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=e.$HF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$FF=N,e.$GF=R;function N(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof S.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(F.$at.isIRange)}function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(N)}var m;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var d;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(d||(e.ChatCopyKind=d={})),e.$HF=(0,M.$hi)("IChatService"),e.$IF="accessibility.voice.keywordActivation"}),define(Me[212],Re([1,0,5,11,178]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new S.$7d,this.o=new S.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,d,k,O){const E={command:m};if(d&&Object.keys(d).length>0&&(E.arguments=d),this.u("request",E),typeof O=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.f.get(E.seq);if(w){this.f.delete(E.seq);const p={type:"response",seq:0,request_seq:E.seq,success:!1,command:m,message:(0,M.localize)(0,null,O,m)};w(p)}},O)}return k&&this.f.set(E.seq,k),E.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,d){return m.type!=="event"||d.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,F.$ih)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const d=m,k=this.f.get(d.request_seq);k&&(this.f.delete(d.request_seq),k(d));break}}}}u(m,d){d.type=m,d.seq=this.d++,this.sendMessage(d)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((d,k)=>m.set(k,d)),await(0,F.$ih)(500),m.forEach((d,k)=>{d({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$$nb=N}),define(Me[213],Re([1,0,2,179,35,3]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$LI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$KI=e.MemoryRangeType=e.State=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=void 0,e.$JI=d,e.$yH="workbench.view.debug",e.$zH="workbench.debug.variablesView",e.$AH="workbench.debug.watchExpressionsView",e.$BH="workbench.debug.callStackView",e.$CH="workbench.debug.loadedScriptsView",e.$DH="workbench.debug.breakPointsView",e.$EH="workbench.debug.disassemblyView",e.$FH="workbench.panel.repl",e.$GH="workbench.panel.repl.view",e.$HH=new M.$yj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$IH=new M.$yj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$JH=new M.$yj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$KH="debugUx",e.$LH=new M.$yj(e.$KH,"default",{type:"string",description:F.localize(3,null)}),e.$MH=new M.$yj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$NH=new M.$yj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$OH=new M.$yj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$PH=new M.$yj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$QH=new M.$yj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$RH=new M.$yj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$SH=new M.$yj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$TH=new M.$yj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$UH=new M.$yj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$VH=new M.$yj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$WH=new M.$yj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$XH=new M.$yj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$YH=new M.$yj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$ZH=new M.$yj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$1H=new M.$yj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$2H=new M.$yj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$3H=new M.$yj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$4H=new M.$yj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$5H=new M.$yj("breakpointItemBytes",void 0,{type:"boolean",description:F.localize(22,null)}),e.$6H=new M.$yj("breakpointHasModes",!1,{type:"boolean",description:F.localize(23,null)}),e.$7H=new M.$yj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(24,null)}),e.$8H=new M.$yj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(25,null)}),e.$9H=new M.$yj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(26,null)}),e.$0H=new M.$yj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(27,null)}),e.$$H=new M.$yj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(28,null)}),e.$_H=new M.$yj("stepBackSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.$aI=new M.$yj("restartFrameSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.$bI=new M.$yj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(31,null)}),e.$cI=new M.$yj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.$dI=new M.$yj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(33,null)}),e.$eI=new M.$yj("breakpointsExist",!1,{type:"boolean",description:F.localize(34,null)}),e.$fI=new M.$yj("debuggersAvailable",!1,{type:"boolean",description:F.localize(35,null)}),e.$gI=new M.$yj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(36,null)}),e.$hI=new M.$yj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(37,null)}),e.$iI=new M.$yj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$jI=new M.$yj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$kI=new M.$yj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$lI=new M.$yj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$mI=new M.$yj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$nI=new M.$yj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.$oI=new M.$yj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(44,null)}),e.$pI=new M.$yj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(45,null)}),e.$qI=new M.$yj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(46,null)}),e.$rI=new M.$yj("variableIsReadonly",!1,{type:"boolean",description:F.localize(47,null)}),e.$sI=new M.$yj("variableValue",!1,{type:"string",description:F.localize(48,null)}),e.$tI=new M.$yj("variableType",!1,{type:"string",description:F.localize(49,null)}),e.$uI=new M.$yj("variableName",!1,{type:"string",description:F.localize(50,null)}),e.$vI=new M.$yj("variableLanguage",!1,{type:"string",description:F.localize(51,null)}),e.$wI=new M.$yj("variableExtensionId",!1,{type:"string",description:F.localize(52,null)}),e.$xI=new M.$yj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(53,null)}),e.$yI=new M.$yj("multiSessionRepl",!1,{type:"boolean",description:F.localize(54,null)}),e.$zI=new M.$yj("multiSessionDebug",!1,{type:"boolean",description:F.localize(55,null)}),e.$AI=new M.$yj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(56,null)}),e.$BI=new M.$yj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(57,null)}),e.$CI=new M.$yj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(58,null)}),e.$DI=new M.$yj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(59,null)});const R=n=>F.localize(60,null,n);e.$EI=R,e.$FI="editor.contrib.debug",e.$GI="editor.contrib.breakpoint",e.$HI="debug",e.$II={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(61,null)};var m;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(m||(e.State=m={}));function d(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$KI="vscode-debug-memory";var O;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(O||(e.DataBreakpointSetType=O={}));var E;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(E||(e.DebugConfigurationProviderTriggerKind=E={}));var l;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(l||(e.DebuggerString=l={})),e.$LI=(0,N.$hi)("debugService");var w;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var p;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(p||(e.DebugVisualizationType=p={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:S.URI.revive(i.iconPath.light),dark:S.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Me[214],Re([1,0,15,2,19,26,12,29,25,18]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MG=void 0,e.$AG=E,e.$BG=l,e.$CG=w,e.$DG=p,e.$EG=r,e.$FG=o,e.$GG=s,e.$HG=i,e.$IG=t,e.$JG=v,e.$KG=g,e.$LG=b;const O=/{([^}]+)}/g;function E(I,$,D){return I.replace(O,function(y,C){return $&&C.length>0&&C[0]!=="_"?y:D&&D.hasOwnProperty(C)?D[C]:y})}function l(I){const $={};for(const D of Object.keys(I))D.startsWith("!")||($[D]=I[D]);return $}function w(I){return I.configuration.request==="attach"&&!p(I)&&(!I.parentSession||w(I.parentSession))}function p(I){let $=I.configuration.type;if($)return $==="vslsShare"&&($=I.configuration.adapterProxy.configuration.type),(0,S.$lf)($,"extensionhost")||(0,S.$lf)($,"pwa-extensionhost")?I:I.parentSession?p(I.parentSession):void 0}function r(I){return I.type&&(I.label||I.program||I.runtime)}function o(I,$,D){let y,C=0;const A=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=A.exec(I);){const T=G.index+1,V=T+G[0].length;if(T<=$&&V>=D){y=G[0],C=T;break}}if(y){const T=/\w+/g;let V=null;for(;(V=T.exec(y))&&!(V.index+1+C+V[0].length>=D););V&&(y=y.substring(0,T.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(I,$,D,y){if(I.evaluatableExpressionProvider.has($)){const C=I.evaluatableExpressionProvider.ordered($),A=(0,k.$Hb)(await Promise.all(C.map(async G=>{try{return await G.provideEvaluatableExpression($,D,y??d.CancellationToken.None)}catch{return}})));if(A.length>0){let G=A[0].expression;const T=A[0].range;return G||(G=$.getLineContent(D.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:G}}}else{const C=$.getLineContent(D.lineNumber),{start:A,end:G}=o(C,D.column,D.column),T=C.substring(A-1,G);return{matchingExpression:T,range:new m.$at(D.lineNumber,A,D.lineNumber,A+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(I){return!!(I&&I.match(n))}function c(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(i(I.path))return F.URI.parse(I.path);if((0,M.$jc)(I.path))return F.URI.file(I.path)}return I.path}function h(I){if(typeof I.path=="object"){const $=F.URI.revive(I.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return I.path}function t(I,$){const D=$?c:h,y=(0,N.$Nn)(I);return u(y,(C,A)=>{C&&A&&(A.path=D(A))}),y}function v(I,$){const D=$?c:h,y=(0,N.$Nn)(I);return u(y,(C,A)=>{!C&&A&&(A.path=D(A))}),y}function u(I,$){switch(I.type){case"event":{const D=I;switch(D.event){case"output":$(!1,D.body.source);break;case"loadedSource":$(!1,D.body.source);break;case"breakpoint":$(!1,D.body.breakpoint.source);break;default:break}break}case"request":{const D=I;switch(D.command){case"setBreakpoints":$(!0,D.arguments.source);break;case"breakpointLocations":$(!0,D.arguments.source);break;case"source":$(!0,D.arguments.source);break;case"gotoTargets":$(!0,D.arguments.source);break;case"launchVSCode":D.arguments.args.forEach(y=>$(!1,y));break;default:break}break}case"response":{const D=I;if(D.success&&D.body)switch(D.command){case"stackTrace":D.body.stackFrames.forEach(y=>$(!1,y.source));break;case"loadedSources":D.body.sources.forEach(y=>$(!1,y));break;case"scopes":D.body.scopes.forEach(y=>$(!1,y.source));break;case"setFunctionBreakpoints":D.body.breakpoints.forEach(y=>$(!1,y.source));break;case"setBreakpoints":D.body.breakpoints.forEach(y=>$(!1,y.source));break;case"disassemble":D.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function g(I){return I.filter($=>!$.presentation?.hidden).sort(($,D)=>$.presentation?D.presentation?$.presentation.group?D.presentation.group?$.presentation.group!==D.presentation.group?$.presentation.group.localeCompare(D.presentation.group):a($.presentation.order,D.presentation.order):-1:D.presentation.group?1:a($.presentation.order,D.presentation.order):-1:D.presentation?1:0)}function a(I,$){return typeof I!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:I-$}async function b(I,$){const D=I.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(D!=="none"&&(await $.saveAll(),D==="allEditorsInActiveGroup")){const y=$.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}const f=(I,$)=>!I||!$?I===$:I.name===$.name&&I.path===$.path&&I.sourceReference===$.sourceReference;e.$MG=f}),define(Me[215],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.CellExecutionUpdateType=void 0;var F;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$YJ=(0,S.$hi)("INotebookExecutionService")}),define(Me[216],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhb=e.$mhb=e.ProxyKernelState=e.$lhb=void 0,e.$lhb=100;var F;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$mhb=(0,S.$hi)("INotebookKernelService"),e.$nhb=(0,S.$hi)("INotebookKernelHistoryService")}),define(Me[217],Re([1,0,6,29,148,95]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Tb=void 0;class R extends S.$Uc{constructor(d,k,O){super(),this._source=d,this.b=k,this.c=O,this.a=void 0}f(d){const k=d.getLineCount();return new F.$at(1,1,k,this.g(d,k))}g(d,k){if(k<1||k>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const d=new M.$xC;d.acceptChunk(this._source);const k=d.finish(!0),{textBuffer:O,disposable:E}=k.create(1);this.b=O,this.B(E)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const k=new M.$xC;k.acceptChunk(d);const O=k.finish(!0),{textBuffer:E,disposable:l}=O.create(1);return this.B(l),E})),this.a}findInInputs(d){const O=new N.$lC(d,!1,!1,null).parseSearchRequest();if(!O)return[];const E=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(E,O,!0,5e3)}findInOutputs(d){const O=new N.$lC(d,!1,!1,null).parseSearchRequest();return O?this.outputTextBuffers.map(E=>{const l=E.findMatchesLineByLine(this.f(E),O,!0,5e3);if(l.length!==0)return{textBuffer:E,matches:l}}).filter(E=>!!E):[]}}e.$2Tb=R}),define(Me[49],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(N){N.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class M{static fromExtHostTestItem(R,m,d=R.parent){if(R._isRoot)return new M([m]);const k=[R.id];for(let O=d;O&&O.id!==m;O=O.parent)k.push(O.id);return k.push(m),new M(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new M(R.split("\0"))}static join(R,m){return new M([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:M.isChild(R,m)?2:M.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$5K=M}),define(Me[60],Re([1,0,2,93,29,49]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$aL=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$_K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$K=e.$0K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$8K=e.$7K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$6K=e.TestResultState=void 0;var R;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$6K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var d;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$7K=[2,4,8,16,32,64];const k=P=>"runId"in P;e.$8K=k;var O;(function(P){P.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),P.deserialize=(L,q)=>({range:M.$at.lift(q.range),uri:L.asCanonicalUri(S.URI.revive(q.uri))})})(O||(e.IRichLocation=O={}));var E;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(E||(e.TestMessageType=E={}));var l;(function(P){P.serialize=L=>({message:L.message,type:0,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&O.serialize(L.location)}),P.deserialize=(L,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&O.deserialize(L,q.location)})})(l||(e.ITestErrorMessage=l={}));const w=(P,L)=>`${L?"s":"e"}${P}`;e.$9K=w;var p;(function(P){P.serialize=L=>({message:L.message,type:1,offset:L.offset,length:L.length,location:L.location&&O.serialize(L.location)}),P.deserialize=(L,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&O.deserialize(L,q.location)})})(p||(e.ITestOutputMessage=p={}));var r;(function(P){P.serialize=L=>L.type===0?l.serialize(L):p.serialize(L),P.deserialize=(L,q)=>q.type===0?l.deserialize(L,q):p.deserialize(L,q)})(r||(e.ITestMessage=r={}));var o;(function(P){P.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),P.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(r.serialize)}),P.deserialize=(L,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(re=>r.deserialize(L,re))})})(o||(e.ITestTaskState=o={}));const s="\0",n=(P,L)=>P+s+L;e.$0K=n;const i=P=>{const L=P.indexOf(s);return{ctrlId:P.slice(0,L),tagId:P.slice(L+1)}};e.$$K=i;var c;(function(P){P.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),P.deserialize=(L,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?L.asCanonicalUri(S.URI.revive(q.uri)):void 0,range:q.range?M.$at.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(c||(e.ITestItem=c={}));var h;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(P){P.serialize=L=>({expand:L.expand,item:c.serialize(L.item)}),P.deserialize=(L,q)=>({controllerId:N.$5K.root(q.item.extId),expand:q.expand,item:c.deserialize(L,q.item)})})(t||(e.InternalTestItem=t={}));var v;(function(P){P.serialize=L=>{let q;return L.item&&(q={},L.item.label!==void 0&&(q.label=L.item.label),L.item.tags!==void 0&&(q.tags=L.item.tags),L.item.busy!==void 0&&(q.busy=L.item.busy),L.item.uri!==void 0&&(q.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(q.range=L.item.range?.toJSON()),L.item.description!==void 0&&(q.description=L.item.description),L.item.error!==void 0&&(q.error=L.item.error),L.item.sortText!==void 0&&(q.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:q}},P.deserialize=L=>{let q;return L.item&&(q={},L.item.label!==void 0&&(q.label=L.item.label),L.item.tags!==void 0&&(q.tags=L.item.tags),L.item.busy!==void 0&&(q.busy=L.item.busy),L.item.range!==void 0&&(q.range=L.item.range?M.$at.lift(L.item.range):null),L.item.description!==void 0&&(q.description=L.item.description),L.item.error!==void 0&&(q.error=L.item.error),L.item.sortText!==void 0&&(q.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:q}}})(v||(e.ITestItemUpdate=v={}));const u=(P,L)=>{L.expand!==void 0&&(P.expand=L.expand),L.item!==void 0&&(P.item=P.item?Object.assign(P.item,L.item):L.item)};e.$_K=u;var g;(function(P){P.serializeWithoutMessages=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serializeWithoutMessages)}),P.serialize=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serialize)}),P.deserialize=(L,q)=>({...t.deserialize(L,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(re=>o.deserialize(L,re)),retired:!0})})(g||(e.TestResultItem=g={}));var a;(function(P){P.empty=()=>({covered:0,total:0}),P.sum=(L,q)=>{L.covered+=q.covered,L.total+=q.total}})(a||(e.ICoveredCount=a={}));var b;(function(P){P.serialize=L=>({statement:L.statement,branch:L.branch,declaration:L.declaration,details:L.details?.map(D.serialize),uri:L.uri.toJSON()}),P.deserialize=(L,q)=>({statement:q.statement,branch:q.branch,declaration:q.declaration,details:q.details?.map(D.deserialize),uri:L.asCanonicalUri(S.URI.revive(q.uri))})})(b||(e.IFileCoverage=b={}));function f(P){return{...P,location:P.location?.toJSON()}}function I(P){return P.location=P.location?F.$_s.isIPosition(P.location)?F.$_s.lift(P.location):M.$at.lift(P.location):void 0,P}e.$aL=3;var $;(function(P){P[P.Declaration=0]="Declaration",P[P.Statement=1]="Statement",P[P.Branch=2]="Branch"})($||(e.DetailType=$={}));var D;(function(P){P.serialize=L=>L.type===0?C.serialize(L):A.serialize(L),P.deserialize=L=>L.type===0?C.deserialize(L):A.deserialize(L)})(D||(e.CoverageDetails=D={}));var y;(function(P){P.serialize=f,P.deserialize=I})(y||(e.IBranchCoverage=y={}));var C;(function(P){P.serialize=f,P.deserialize=I})(C||(e.IDeclarationCoverage=C={}));var A;(function(P){P.serialize=L=>({...f(L),branches:L.branches?.map(y.serialize)}),P.deserialize=L=>({...I(L),branches:L.branches?.map(y.deserialize)})})(A||(e.IStatementCoverage=A={}));var G;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var T;(function(P){P.deserialize=(L,q)=>q.op===0?{op:q.op,item:t.deserialize(L,q.item)}:q.op===1?{op:q.op,item:v.deserialize(q.item)}:q.op===2?{op:q.op,uri:L.asCanonicalUri(S.URI.revive(q.uri)),docv:q.docv}:q,P.serialize=L=>L.op===0?{op:L.op,item:t.serialize(L.item)}:L.op===1?{op:L.op,item:v.serialize(L.item)}:L})(T||(e.TestsDiffOp=T={}));class V{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const q=this.v();for(const re of L)switch(re.op){case 0:this.l(t.deserialize(this.k,re.item),q);break;case 1:this.o(v.deserialize(re.item),q);break;case 3:this.p(re.itemId,q);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}q.complete?.()}l(L,q){const re=N.$5K.parentId(L.item.extId)?.toString();let ue;if(!re)ue=this.w(L),this.g.add(ue),this.f.set(L.item.extId,ue);else if(this.f.has(re)){const ye=this.f.get(re);ye.children.add(L.item.extId),ue=this.w(L,ye),this.f.set(L.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return q.add?.(ue),L.expand===2&&this.h++,ue}o(L,q){const re=this.f.get(L.extId);if(re)return L.expand!==void 0&&(re.expand===2&&this.h--,L.expand===2&&this.h++),(0,e.$_K)(re,L),q.update?.(re),re}p(L,q){const re=this.f.get(L);if(!re)return;const ue=N.$5K.parentId(re.item.extId)?.toString();ue?this.f.get(ue).children.delete(re.item.extId):this.g.delete(re);const ye=[[L]];for(;ye.length;)for(const Se of ye.pop()){const le=this.f.get(Se);le&&(ye.push(le.children),this.f.delete(Se),q.remove?.(le,le!==re),le.expand===2&&this.h--)}}q(L){}updatePendingRoots(L){this.j+=L}v(){return{}}}e.$bL=V}),define(Me[75],Re([1,0,11,5,6,55,60,49]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.TestItemEventOp=void 0;var d;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const k=(n,i)=>n===i,E=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(c=>!i.includes(c)))}),l=(n,i)=>{let c;for(const[h,t]of E)t(n[h],i[h])||(c?c[h]=i[h]:c={[h]:i[h]});return c};class w extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new S.$th(()=>this.flushDiff(),200)),this.g=this.B(new F.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,R.$_K)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,R.$_K)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,c-1):t.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O(m.$5K.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const h of c.ops)this.w(i,h);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$0c)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const h=m.$5K.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(i)}}),this.I(i,v,c);return}if(v.actual===i){this.H(i,v,c);return}if(v.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,c);const u=this.s.getChildren(v.actual),g=v.actual,a=l(this.s.toITestItem(g),this.s.toITestItem(i));this.s.getApiFor(g).listener=void 0,v.actual=i,v.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(i.tags,g.tags,h.toString()),delete a.tags),this.w(v,{op:4,update:a})),this.I(i,v,c);for(const[b,f]of u)this.s.getChildren(i).get(f.id)||this.O(m.$5K.joinToString(h,f.id));this.y(v.actual.uri)}C(i,c,h){const t=new Set(c.map(v=>v.id));for(const v of i)t.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(v=>(0,R.$0K)(this.s.controllerId,v.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$0K)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,R.$0K)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=v=>this.w(c,v),this.J(c)}I(i,c,h){this.H(i,c,h);for(const[t,v]of this.s.getChildren(i))this.z(v,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const h=[];for(const[t,v]of this.s.getChildren(i.actual)){const u=this.expand(m.$5K.joinToString(i.fullId,v.id),c);(0,S.$6g)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const v=new S.$gh;return v.open(),v}i.expand=2,this.N(i);const c=i.resolveBarrier=new S.$gh,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(v){h(v)}return(0,S.$6g)(t)?t.catch(h).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[c];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const v of t.actual.tags)this.F(v.id);this.tree.delete(t.fullId.toString());for(const[v,u]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$5K.joinToString(t.fullId,u.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$qO=w;class p extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$rO=p;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sO=r;class o extends Error{constructor(i,c,h){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$tO=o;const s=(n,i,c)=>{let h=new Map;return{get size(){return h.size},forEach(t,v){for(const u of h.values())t.call(v,u,this)},[Symbol.iterator](){return h.entries()},replace(t){const v=new Map,u=new Set(h.keys()),g={op:5,ops:[]};for(const a of t){if(!(a instanceof c))throw new r(a.id);const b=i(a).controllerId;if(b!==n.controllerId)throw new o(a.id,b,n.controllerId);if(v.has(a.id))throw new p(a.id);v.set(a.id,a),u.delete(a.id),g.ops.push({op:0,item:a})}for(const a of u.keys())g.ops.push({op:3,id:a});n.listener?.(g),h=v},add(t){if(!(t instanceof c))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$uO=s}),define(Me[105],Re([1,0,75]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.$vO=void 0;const F=new WeakMap,M=(R,m)=>{const d={controllerId:m};return F.set(R,d),d};e.$vO=M;const N=R=>{const m=F.get(R);if(!m)throw new S.$sO(R?.id||"<unknown>");return m};e.$wO=N}),define(Me[76],Re([1,0,12,2]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fyb=e.$Eyb=e.$Dyb=void 0,e.$Gyb=M,e.$Hyb=R,e.$Dyb="vscode-cdn.net",e.$Eyb=`vscode-resource.${e.$Dyb}`,e.$Fyb=`'self' https://*.${e.$Dyb}`;function M(m,d){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(d&&d.authority&&d.isRemote&&m.scheme===S.Schemas.file&&(m=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:d.authority,path:m.path})),F.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.$Eyb}`,path:m.path,fragment:m.fragment,query:m.query}))}function N(m){return m.replace(/./g,d=>{const k=d.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?d:"-"+k.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(d,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Me[218],Re([1,0,5,6,76]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class N{constructor(m,d,k){this.d=m,this.e=d,this.f=k,this.a=0,this.b=new F.$Tc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const O=d.getVisibleTextEditors();for(const E of this.c.values())O.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,d,k,O,E){let l;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){l=i;break}if(!l)throw new Error("not a visible editor");const w=this,p=this.a++,r=new S.$7d,o=new S.$7d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$Gyb)(i,w.f)}get cspSource(){return M.$Fyb}set options(i){this.b=i,w.d.$setOptions(p,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(p,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return w.d.$postMessage(p,i)}},n=new class{constructor(){this.editor=m,this.line=d,this.height=k,this.webview=s,this.onDidDispose=o.event}dispose(){w.c.has(p)&&(w.c.delete(p),w.d.$disposeEditorInset(p),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(p,l.id,l.value.document.uri,d+1,k,O||{},E.identifier,E.extensionLocation),this.c.set(p,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const d=this.c.get(m);d&&d.inset.dispose()}$onDidReceiveMessage(m,d){this.c.get(m)?.onDidReceiveMessage.fire(d)}}e.$Wic=N}),define(Me[106],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$jL=e.$iL=void 0,e.$iL="__",e.$jL=(0,S.$hi)("IAuthenticationService"),e.$kL=(0,S.$hi)("IAuthenticationExtensionsService")}),define(Me[219],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.VariableKind=e.$mP=void 0,e.$mP=(0,S.$hi)("configurationResolverService");var F;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class M extends Error{constructor(R,m){super(m),this.variable=R}}e.$nP=M}),define(Me[220],Re([1,0,19,73,16,26,21,96,182,219,15]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,p,r,o){this.h=new Map,this.a=w,this.b=p,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(w){if(R.$i){const p=Object.create(null);return Object.keys(w).forEach(r=>{p[r.toLowerCase()]=w[r]}),p}return w}resolveWithEnvironment(w,p,r){return this.l({env:this.i(w),userHome:void 0},p?p.uri:void 0,r)}async resolveAsync(w,p){const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,p)}async j(w,p,r,o){const s=N.$Nn(p);R.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):R.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):R.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,s,r,o)}async resolveAnyAsync(w,p,r){return this.j(w,p,r)}async resolveAnyMap(w,p,r){const o=new Map;return{newConfig:await this.j(w,p,r,o),resolvedVariables:o}}resolveWithInteractionReplace(w,p,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,p,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,p){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,p)}async l(w,p,r,o,s){if(M.$Uf(r))return this.m(w,p,r,o,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(w,p,n,o,s)));if(M.$Wf(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async c=>[await this.m(w,p,c,o,s),await this.l(w,p,r[c],o,s)]));for(const[c,h]of i)n[c]=h;return n}return r}m(w,p,r,o,s){return(0,O.$df)(r,E.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(E.VARIABLE_LHS))return n;let c=await this.o(w,n,i,p,o);return s?.set(i,c),c!==n&&M.$Uf(c)&&c.match(E.VARIABLE_REGEXP)&&(c=await this.m(w,p,c,o,s)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,p,r,o,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const c=v=>{const u=this.a.getFilePath();if(u)return(0,m.$fw)(u);throw new k.$nP(v,(0,d.localize)(0,null,p))},h=v=>{const u=c(v);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,m.$fw)(g)}throw new k.$nP(v,(0,d.localize)(1,null,p,S.$oc(u)))},t=v=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new k.$nP(v,(0,d.localize)(2,null,p,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$nP(v,(0,d.localize)(3,null,p)):new k.$nP(v,(0,d.localize)(4,null,p))};switch(r){case"env":if(n){if(w.env){const v=w.env[R.$i?n.toLowerCase():n];if(M.$Uf(v))return v}return""}throw new k.$nP(k.VariableKind.Env,(0,d.localize)(5,null,p));case"config":if(n){const v=this.a.getConfigurationValue(o,n);if(M.$4f(v))throw new k.$nP(k.VariableKind.Config,(0,d.localize)(6,null,p,n));if(M.$Wf(v))throw new k.$nP(k.VariableKind.Config,(0,d.localize)(7,null,p,n));return v}throw new k.$nP(k.VariableKind.Config,(0,d.localize)(8,null,p));case"command":return this.p(k.VariableKind.Command,p,n,s,"command");case"input":return this.p(k.VariableKind.Input,p,n,s,"input");case"extensionInstallFolder":if(n){const v=await this.a.getExtension(n);if(!v)throw new k.$nP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,p,n));return this.n(v.extensionLocation)}throw new k.$nP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,p));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$fw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.$fw)(this.n(t(k.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$fw)(S.$oc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new k.$nP(k.VariableKind.UserHome,(0,d.localize)(11,null,p))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new k.$nP(k.VariableKind.LineNumber,(0,d.localize)(12,null,p))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new k.$nP(k.VariableKind.SelectedText,(0,d.localize)(13,null,p))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?S.$mc(this.n(t(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const v=S.$nc(c(k.VariableKind.RelativeFileDirname));if(o||n){const u=S.$mc(this.n(t(k.VariableKind.RelativeFileDirname)),v);return u.length===0?".":u}return v}case"fileDirname":return S.$nc(c(k.VariableKind.FileDirname));case"fileExtname":return S.$pc(c(k.VariableKind.FileExtname));case"fileBasename":return S.$oc(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=S.$oc(c(k.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-S.$pc(v).length)}case"fileDirnameBasename":return S.$oc(S.$nc(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||p}case"execInstallFolder":{const v=this.a.getAppRoot();return v||p}case"pathSeparator":case"/":return S.sep;default:try{const v=n?`${r}:${n}`:r;return this.p(k.VariableKind.Unknown,p,v,s,void 0)}catch{return p}}}}p(w,p,r,o,s){if(r&&o){const n=s===void 0?o[r]:o[s+":"+r];if(typeof n=="string")return n;throw new k.$nP(w,(0,d.localize)(14,null,p))}return p}}e.$CP=E}),define(Me[107],Re([1,0,3,104]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$tD=void 0,e.$uD=k,e.$vD=l,e.$wD=w,e.$tD=(0,S.$hi)("editorGroupsService");var M;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var N;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var d;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function k(p){const r=p;return(0,F.$dF)(r?.editor)&&(0,F.$dF)(r?.replacement)}var O;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var E;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function l(p){const r=p;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function w(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Me[221],Re([1,0,3,107]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AD=e.$zD=e.$yD=e.$xD=void 0,e.$BD=M,e.$xD=(0,S.$hi)("editorService"),e.$yD=-1,e.$zD=-2,e.$AD=-3;function M(N){const R=N;return typeof N=="number"||(0,F.$vD)(R)}}),define(Me[222],Re([1,0,3,189]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=void 0,e.$DL=(0,S.$ii)(F.$oi)}),define(Me[108],Re([1,0,20,5,19,6,11]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=e.$z0b=e.$y0b=e.$x0b=e.$w0b=void 0;class m{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$w0b=m;class d{static isHostExtension(n,i,c){if(i.getExtensionDescription(n))return!1;const h=c.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,i){this.j=n,this.c=new F.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new S.$Em,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=o(this.e,i),this.e=this.e.concat(n);const c=d.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,c)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,g){this.addNode(u),this.addNode(g),this.c.has(u)?this.c.get(u).push(g):this.c.set(u,[g])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,g){const a=i.getArcs(u);for(let b=0;b<a.length;b++)if(!g.has(a[b]))return!1;return!0}getNodes(){return this.e}},c=new S.$Em;for(const u of n)if(c.set(u.identifier,u),u.extensionDependencies)for(const g of u.extensionDependencies)i.addArc(S.$Cm.toKey(u.identifier),S.$Cm.toKey(g));const h=new Set;i.getNodes().filter(u=>i.getArcs(u).length===0).forEach(u=>h.add(u));const t=i.getNodes().filter(u=>!h.has(u));let v;do{v=!1;for(let u=0;u<t.length;u++){const g=t[u];i.hasOnlyGoodArcs(g,h)&&(t.splice(u,1),u--,h.add(g),v=!0)}}while(v);return t.map(u=>c.get(u))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$x0b=d;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$y0b=k;class O{constructor(n){this.d=new w,this.c=new d(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new E(this,i)}deltaExtensions(n,i,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$z0b=O;class E extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$A0b=E;class l{constructor(n){this.name=n;const i=(0,R.$ah)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class w{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new l(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(h))}}var p;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(p||(p={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==c)return i-c;const h=M.$hc.basename(s.extensionLocation.path),t=M.$hc.basename(n.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,n){const i=new S.$Dm(n);return s.filter(c=>!i.has(c.identifier))}}),define(Me[77],Re([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Km=R,e.$Lm=m;var F;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(F||(e.UIKind=F={}));var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var N;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(k){const O=S.$ue.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}function m(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}var d;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Me[61],Re([1,0,3,5,13,27,77,57,58,26,2,6,170]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$SO=e.$RO=void 0,e.$TO=r;let w=class extends E.$Uc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new F.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=O.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:d.$8o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Pj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,i){const c=this.getTelemetryDetails(),h=new p(n,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this.f=s,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$tm)((0,d.$bp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((i,c)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const c=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(s.value),!1;let h=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$RO=w,e.$RO=w=Je([qe(0,N.$QO),qe(1,M.$Oj)],w);class p{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,c,h,t,v){this.g=i,this.h=c,this.i=h,this.j=t,this.a=new F.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,d.$ep)(n,[]),this.c&&(n=(0,k.$Qn)(n,this.c)),this.b||(n=(0,k.$Qn)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,d.$ep)(i,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$SO=p;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$UO=(0,S.$hi)("IExtHostTelemetry")}),define(Me[22],Re([1,0,5,2,198,103,20,3]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=e.ActivationKind=e.$8F=e.$7F=e.$4F=e.ExtensionHostStartup=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$5F=l,e.$6F=w,e.$9F=s,e.$0F=n,e.$ZF=Object.freeze({identifier:new R.$Cm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$1F="extensions.webWorker",e.$2F=(0,m.$hi)("extensionService");class d{constructor(h){this.dependency=h}}e.$3F=d;var k;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class O{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,v){this.c=h,this.d=t.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$KF.createActivationEventsMap(this.d)}}set(h,t,v){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],g=[],a=[],b=[],f=E(this.d),I=E(t),$=(G,T)=>G.extensionLocation.toString()===T.extensionLocation.toString()||G.isBuiltin===T.isBuiltin||G.isUserBuiltin===T.isUserBuiltin||G.isUnderDevelopment===T.isUnderDevelopment;for(const G of this.d){const T=I.get(G.identifier);if(!T){u.push(G.identifier),f.delete(G.identifier);continue}if(!$(G,T)){u.push(G.identifier),f.delete(G.identifier);continue}}for(const G of t){const T=f.get(G.identifier);if(!T){g.push(G);continue}if(!$(T,G)){u.push(T.identifier),f.delete(T.identifier);continue}}const D=new R.$Dm(this.e),y=new R.$Dm(v);for(const G of this.e)y.has(G)||a.push(G);for(const G of v)D.has(G)||b.push(G);const C=N.$KF.createActivationEventsMap(g),A={versionId:h,toRemove:u,toAdd:g,addActivationEvents:C,myToRemove:a,myToAdd:b};return this.delta(A),A}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:v,myToRemove:u,myToAdd:g}=h,a=new R.$Dm(t),b=new R.$Dm(u);for(let f=0;f<this.d.length;f++)a.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)b.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of v)this.d.push(f);for(const f of g)this.e.push(f);return this.f=null,h}containsExtension(h){for(const t of this.e)if(R.$Cm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const v=N.$KF.readActivationEvents(t);for(const u of v)h.add(u)}return h}}e.$4F=O;function E(c){const h=new R.$Em;for(const t of c)h.set(t.identifier,t);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function w(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class p{constructor(h,t,v,u){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=v,this.activationReason=u}}e.$7F=p;class r{constructor(h,t){this.description=h,this.value=t}}e.$8F=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$kp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,h){return{identifier:new R.$Cm((0,M.$ip)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$$F=i}),define(Me[223],Re([1,0,14,108,20,22,13,11]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=e.$kjc=e.$jjc=e.$ijc=e.$hjc=e.$gjc=void 0;class d{static{this.NONE=new d(!1,-1,-1,-1)}constructor(s,n,i,c){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=c}}e.$gjc=d;class k{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$hjc=k;class O{constructor(s,n,i,c,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=c,this.exports=h,this.subscriptions=t}}e.$ijc=O;class E extends O{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$jjc=E;class l extends O{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$kjc=l;class w extends O{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(s,n,i,c){this.g=c,this.a=s,this.b=n,this.c=i,this.d=new M.$Em,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(h));return this.c.onExtensionActivationError(s.id,h,new N.$3F(s.id.value)),t}const i=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const v=this.a.getExtensionDescription(h);if(v){if(!v.main&&!v.browser)continue;i.push(this.j({id:v.identifier,reason:s.reason}));continue}const u=n.displayName||n.identifier.value,g=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),a=this.k(s,n.displayName,[],new w(g));return this.c.onExtensionActivationError(n.identifier,g,new N.$3F(h)),a}return this.k(s,n.displayName,i,null)}k(s,n,i,c){const h=new r(s.id,n,s.reason,i,c,this.c,this.g);return this.d.set(s.id,h),h}l(s){return F.$x0b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$ljc=p,e.$ljc=p=Je([qe(3,R.$Nj)],p);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,i,c,h,t,v){this.c=s,this.d=n,this.f=i,this.g=c,this.h=h,this.j=t,this.k=v,this.a=new m.$gh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new w(n),this.b&&S.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([qe(6,R.$Nj)],r)}),define(Me[224],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Me[225],Re([1,0,184,14,32,98,72,30,20,224,194,103]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const l=m.$Zn.as(R.$1n.JSONContribution);class w{constructor(h,t,v){this.a=h,this.b=t,this.c=v}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(M.default.Error,h)}warn(h){this.d(M.default.Warning,h)}info(h){this.d(M.default.Info,h)}}e.$TF=w;class p{static a(h){const t=new d.$Dm;for(let v=0,u=h.length;v<u;v++)t.add(h[v].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new p(t,[]);if(!t||!t.length)return new p([],h);const v=this.a(h),u=this.a(t),g=t.filter(b=>!v.has(b.description.identifier)),a=h.filter(b=>!u.has(b.description.identifier));return new p(g,a)}constructor(h,t){this.added=h,this.removed=t}}e.$UF=p;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=p.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,F.$1)(h)}}}e.$VF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$Bm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Eo}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Eo}},extensionKind:{description:S.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&E.$KF.register(h.extensionPoint,h.activationEventsGenerator),e.$WF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(s,e.$WF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$Zn.add(i.ExtensionsRegistry,new n),e.$YF=m.$Zn.as(i.ExtensionsRegistry),l.registerSchema(s,e.$WF),l.registerSchema(O.$8j,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Me[226],Re([1,0,180,16,26,225,35,5]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nH=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var k;(function(l){function w(p,r,o){if(!p)return;const s=F.$Uf(p.type)?p.type:void 0;if(!s||s.length===0){o.error(S.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const i of p.required)F.$Uf(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:p.properties?M.$Nn(p.properties):{},when:p.when?R.$fj.deserialize(p.when):void 0}}l.from=w})(k||(k={}));const O=N.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const p of l)p.type&&w.push(`onTaskType:${p.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:d}});class E{constructor(){this.d=new m.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,p)=>{O.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const n=s.value;for(const i of n){const c=k.from(i,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const p of this.all()){const r={type:"object",additionalProperties:!1};p.required.length>0&&(r.required=p.required.slice(0)),p.properties!==void 0?r.properties=M.$Nn(p.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[p.taskType]},w.push(r)}this.c={oneOf:w}}return this.c}}e.$nH=new E}),define(Me[227],Re([1,0,181,16,24,26,35,226]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$xH=e.JsonSchemaVersion=e.ExecutionEngine=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$rH=e.ShellQuoting=e.$qH=e.$pH=e.$oH=void 0,e.$oH="settings",e.$pH=new R.$yj("taskRunning",!1,S.localize(0,null)),e.$qH=S.localize2(2,"Tasks");var d;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$rH="$customized",function(P){function L(q){if(!q)return P.Strong;switch(q.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=L}(d||(e.ShellQuoting=d={}));var k;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var O;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(O||(e.RevealKind=O={})),function(P){function L(q){switch(q.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=L}(O||(e.RevealKind=O={}));var E;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(P){function L(q){switch(q.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=L}(E||(e.RevealProblemKind=E={}));var l;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(l||(e.PanelKind=l={})),function(P){function L(q){switch(q.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=L}(l||(e.PanelKind=l={}));var w;(function(P){P.defaults={echo:!0,reveal:O.Always,revealProblems:E.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var p;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(P){function L(re){switch(re.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=L;function q(re){switch(re){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=q}(p||(e.RuntimeType=p={}));var r;(function(P){function L(q){return F.$Uf(q)?q:q.value}P.value=L})(r||(e.CommandString=r={}));var o;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function L(re){return re===P.Clean._id||re===P.Build._id||re===P.Rebuild._id||re===P.Test._id}P.is=L;function q(re){if(re!==void 0)return F.$Uf(re)?L(re)?{_id:re,isDefault:!1}:void 0:re}P.from=q})(o||(e.TaskGroup=o={}));var s;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function L(q){switch(q){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=L})(n||(e.TaskSourceKind=n={}));var i;(function(P){P.parallel="parallel",P.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(L,q,re,ue,ye,Se){this._label="",this._id=L,q&&(this._label=q),re&&(this.type=re),this.runOptions=ue,this.configurationProperties=ye,this._source=Se}getDefinition(L){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,q=!1){if(L===void 0)return!1;if(F.$Uf(L))return L===this._label||L===this.configurationProperties.identifier||q&&L===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.$sH=t;class v extends t{constructor(L,q,re,ue,ye,Se,le,we){super(L,re,void 0,le,we,q),this.command={},this._source=q,this.hasDefinedMatchers=Se,ye&&(this.command=ye)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case p.Shell:q="shell";break;case p.Process:q="process";break;case p.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(L){return L instanceof v}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$oH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const L=this.d();if(!L)return;let q=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(q+=this._source.kind);const re={type:e.$rH,folder:L,id:q};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new v(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$tH=v;class u extends t{constructor(L,q,re,ue,ye,Se,le){super(L,re,ue,Se,le,q),this._source=q,this.configures=ye}static is(L){return L instanceof u}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$oH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const L=this.d();if(!L)return;let q=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(q+=this._source.kind);const re={type:e.$rH,folder:L,id:q};return JSON.stringify(re)}}e.$uH=u;class g extends t{constructor(L,q,re,ue,ye,Se,le,we,_){super(L,re,ue,we,_,q),this.defines=ye,this.hasDefinedMatchers=le,this.command=Se,this.icon=_.icon,this.hide=_.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof g}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new g(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$vH=g;class a extends t{constructor(L,q,re,ue,ye,Se){super(L,re,ue,ye,Se,q),this._source=q}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new a(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.$wH=a;var b;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(P){P._default=P.Terminal}(b||(e.ExecutionEngine=b={}));var f;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(f||(e.JsonSchemaVersion=f={}));class I{constructor(L){this.c=new Map;for(let q=0;q<L.length;q++)this.c.set(L[q].uri.toString(),q)}compare(L,q){const re=L.getWorkspaceFolder(),ue=q.getWorkspaceFolder();if(re&&ue){let ye=this.c.get(re.uri.toString());ye=ye===void 0?0:ye+1;let Se=this.c.get(ue.uri.toString());return Se=Se===void 0?0:Se+1,ye===Se?L._label.localeCompare(q._label):ye-Se}else return!re&&ue?-1:re&&!ue?1:0}}e.$xH=I;var $;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})($||(e.TaskEventKind=$={}));var D;(function(P){P.SingleRun="singleRun",P.Background="background"})(D||(e.TaskRunType=D={}));var y;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(P){function L(we){return{taskId:we._id,taskName:we.configurationProperties.name,runType:we.configurationProperties.isBackground?"background":"singleRun",group:we.configurationProperties.group,__task:we}}function q(we,_,ve){return{...L(we),kind:"start",terminalId:_,resolvedVariables:ve}}P.start=q;function re(we,_,ve){return{...L(we),kind:"processStarted",terminalId:_,processId:ve}}P.processStarted=re;function ue(we,_,ve){return{...L(we),kind:"processEnded",terminalId:_,exitCode:ve}}P.processEnded=ue;function ye(we,_,ve){return{...L(we),kind:"terminated",exitReason:ve,terminalId:_}}P.terminated=ye;function Se(we,_,ve){return{...L(_),kind:we,terminalId:ve}}P.general=Se;function le(){return{kind:"changed"}}P.changed=le})(C||(e.TaskEvent=C={}));var A;(function(P){function L(re){const ue=Object.keys(re).sort();let ye="";for(const Se of ue){let le=re[Se];le instanceof Object?le=L(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),ye+=Se+","+le+","}return ye}function q(re){const ye={_key:L(re),type:re.taskType};return Object.assign(ye,re),ye}P.create=q})(A||(e.KeyedTaskIdentifier=A={}));var G;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection",P.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var T;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var V;(function(P){function L(q,re){const ue=m.$nH.get(q.type);if(ue===void 0){const we=N.$Nn(q);return delete we._key,A.create(we)}const ye=Object.create(null);ye.type=ue.taskType;const Se=new Set;ue.required.forEach(we=>Se.add(we));const le=ue.properties;for(const we of Object.keys(le)){const _=q[we];if(_!=null)ye[we]=_;else if(Se.has(we)){const ve=le[we];if(ve.default!==void 0)ye[we]=N.$Nn(ve.default);else switch(ve.type){case"boolean":ye[we]=!1;break;case"number":case"integer":ye[we]=0;break;case"string":ye[we]="";break;default:re.error(S.localize(1,null,JSON.stringify(q,void 0,0),we));return}}}return A.create(ye)}P.createTaskIdentifier=L})(V||(e.TaskDefinition=V={}))}),define(Me[228],Re([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=e.$B0b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$B0b=F;class M extends F{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$C0b=M}),define(Me[50],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=e.$_v=void 0,e.$aw=M,e.$bw=N;class S{static{this.count=0}constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++S.count}}e.$_v=S;const F=[];function M(m){const d=new S(m);return F[d.nid]=d,d}function N(m){return F[m].sid}class R{constructor(d){this.value=d}}e.$cw=R}),define(Me[4],Re([1,0,50]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$fM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(M||(e.TabInputKind=M={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var d;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var O;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class E{static{this.a=0}static mixin(o){return o._id=E.a++,o}}e.$fM=E;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var p;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$gM={MainThreadAuthentication:(0,S.$aw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$aw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.$aw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,S.$aw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$aw)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$aw)("MainThreadClipboard"),MainThreadCommands:(0,S.$aw)("MainThreadCommands"),MainThreadComments:(0,S.$aw)("MainThreadComments"),MainThreadConfiguration:(0,S.$aw)("MainThreadConfiguration"),MainThreadConsole:(0,S.$aw)("MainThreadConsole"),MainThreadDebugService:(0,S.$aw)("MainThreadDebugService"),MainThreadDecorations:(0,S.$aw)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$aw)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$aw)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$aw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$aw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$aw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$aw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$aw)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$aw)("MainThreadErrors"),MainThreadTreeViews:(0,S.$aw)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$aw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$aw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$aw)("MainThreadLanguages"),MainThreadLogger:(0,S.$aw)("MainThreadLogger"),MainThreadMessageService:(0,S.$aw)("MainThreadMessageService"),MainThreadOutputService:(0,S.$aw)("MainThreadOutputService"),MainThreadProgress:(0,S.$aw)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$aw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$aw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$aw)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$aw)("MainThreadSecretState"),MainThreadStorage:(0,S.$aw)("MainThreadStorage"),MainThreadSpeech:(0,S.$aw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$aw)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$aw)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$aw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$aw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$aw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$aw)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$aw)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$aw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$aw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$aw)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$aw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$aw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$aw)("MainThreadExtensionService"),MainThreadSCM:(0,S.$aw)("MainThreadSCM"),MainThreadSearch:(0,S.$aw)("MainThreadSearch"),MainThreadShare:(0,S.$aw)("MainThreadShare"),MainThreadTask:(0,S.$aw)("MainThreadTask"),MainThreadWindow:(0,S.$aw)("MainThreadWindow"),MainThreadLabelService:(0,S.$aw)("MainThreadLabelService"),MainThreadNotebook:(0,S.$aw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$aw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$aw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$aw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$aw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$aw)("MainThreadInteractive"),MainThreadChat:(0,S.$aw)("MainThreadChat"),MainThreadInlineChat:(0,S.$aw)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$aw)("MainThreadTheming"),MainThreadTunnelService:(0,S.$aw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$aw)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$aw)("MainThreadTimeline"),MainThreadTesting:(0,S.$aw)("MainThreadTesting"),MainThreadLocalization:(0,S.$aw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$aw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$aw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$aw)("MainThreadIssueReporter")},e.$hM={ExtHostCommands:(0,S.$aw)("ExtHostCommands"),ExtHostConfiguration:(0,S.$aw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$aw)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$aw)("ExtHostDebugService"),ExtHostDecorations:(0,S.$aw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$aw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$aw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$aw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$aw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$aw)("ExtHostEditors"),ExtHostTreeViews:(0,S.$aw)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$aw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$aw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$aw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$aw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$aw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$aw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$aw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$aw)("ExtHostStatusBar"),ExtHostShare:(0,S.$aw)("ExtHostShare"),ExtHostExtensionService:(0,S.$aw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$aw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$aw)("ExtHostTerminalService"),ExtHostSCM:(0,S.$aw)("ExtHostSCM"),ExtHostSearch:(0,S.$aw)("ExtHostSearch"),ExtHostTask:(0,S.$aw)("ExtHostTask"),ExtHostWorkspace:(0,S.$aw)("ExtHostWorkspace"),ExtHostWindow:(0,S.$aw)("ExtHostWindow"),ExtHostWebviews:(0,S.$aw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$aw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$aw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$aw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$aw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$aw)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$aw)("ExtHostProgress"),ExtHostComments:(0,S.$aw)("ExtHostComments"),ExtHostSecretState:(0,S.$aw)("ExtHostSecretState"),ExtHostStorage:(0,S.$aw)("ExtHostStorage"),ExtHostUrls:(0,S.$aw)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$aw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$aw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$aw)("ExtHostOutputService"),ExtHostLabelService:(0,S.$aw)("ExtHostLabelService"),ExtHostNotebook:(0,S.$aw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$aw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$aw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$aw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$aw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$aw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$aw)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$aw)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$aw)("ExtHostChat"),ExtHostChatAgents2:(0,S.$aw)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$aw)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$aw)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$aw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$aw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$aw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$aw)("ExtHostTheming"),ExtHostTunnelService:(0,S.$aw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$aw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$aw)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$aw)("ExtHostTimeline"),ExtHostTesting:(0,S.$aw)("ExtHostTesting"),ExtHostTelemetry:(0,S.$aw)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$aw)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$aw)("ExtHostIssueReporter")}}),define(Me[78],Re([1,0,3,13,4,17]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=e.$Cic=void 0,e.$Cic=(0,S.$hi)("IExtHostApiDeprecationService");let R=class{constructor(d,k){this.c=k,this.a=new Set,this.b=d.getProxy(M.$gM.MainThreadTelemetry)}report(d,k,O){const E=this.d(d,k);this.a.has(E)||(this.a.add(E),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:d}))}d(d,k){return`${d}-${k.identifier.value}`}};e.$Dic=R,e.$Dic=R=Je([qe(0,N.$AO),qe(1,F.$Nj)],R),e.$Eic=Object.freeze(new class{report(m,d,k){}})}),define(Me[229],Re([1,0,45,6,4]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;class N{static{this.a=0}constructor(d,k){this.extension=d,this.provider=k,this.handle=N.a++}}class R{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(M.$gM.MainThreadChat)}registerChatProvider(d,k,O){const E=new N(d,O);return this.b.set(E.handle,E),this.d.$registerChatProvider(E.handle,k),(0,F.$Sc)(()=>{this.d.$unregisterChatProvider(E.handle),this.b.delete(E.handle)})}transferChatSession(d,k){const O=S.Iterable.find(this.c.keys(),E=>this.c.get(E)===d)??0;typeof O=="number"&&this.d.$transferChatSession(O,k)}async $prepareChat(d,k){const O=this.b.get(d);if(!O)return;const E=await O.provider.prepareSession(k);if(!E)return;const l=R.a++;return this.c.set(l,E),{id:l}}$releaseSession(d){this.c.delete(d)}}e.$Pic=R}),define(Me[230],Re([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;class F{constructor(N){const R=N.getProxy(S.$gM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$Uic=F}),define(Me[231],Re([1,0,26,4,27,17]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;let R=class{constructor(O,E){this.a=O.getProxy(F.$gM.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(O,E){const l=this,w=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){l.e(O,E,w,arguments)}})}e(O,E,l,w){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:d(w,this.b)}),this.c&&this.f(O,l,w)}};e.$Lkc=R,e.$Lkc=R=Je([qe(0,N.$AO),qe(1,M.$QO)],R);const m=1e5;function d(k,O){const E=[];if(k.length)for(let l=0;l<k.length;l++){let w=k[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const p=w;p.stack?w=p.stack:w=p.toString()}E.push(w)}if(O){const l=new Error().stack;l&&E.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Sn)(E);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Me[232],Re([1,0,2,4,22]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class N{constructor(m){this.a=m.getProxy(F.$gM.MainThreadDialogs)}showOpenDialog(m,d){return d?.allowUIResources&&(0,M.$6F)(m,"showLocal"),this.a.$showOpenDialog(d).then(k=>k?k.map(O=>S.URI.revive(O)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(d=>d?S.URI.revive(d):void 0)}}e.$Pjc=N}),define(Me[233],Re([1,0,6,4]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(F.$gM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,S.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$$jc=M}),define(Me[79],Re([1,0,21,15,2,3,13,4,27,17]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=e.$xjc=void 0;let O=class{constructor(l,w,p){this.f=p,this.d=new Map,this.a=w.getProxy(m.$gM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,w){const{message:p,args:r,comment:o}=w;if(this.c)return(0,F.$We)(p,r??{});let s=p;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(l)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$We)(n??p,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let w;const p=await this.g(l);if(!p){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(p),o=JSON.parse(r);w=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${p}: ${r.message}`);return}w&&this.d.set(l.identifier.value,{contents:w,uri:p})}async g(l){if(l.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return M.URI.revive(w)}return l.l10n?M.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$xjc=O,e.$xjc=O=Je([qe(0,d.$QO),qe(1,k.$AO),qe(2,R.$Nj)],O),e.$yjc=(0,N.$hi)("IExtHostLocalizationService")}),define(Me[234],Re([1,0,13,4,27,17,2,52]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;let d=class extends S.$Yj{constructor(E,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,m.$Qh)(w))),this.r=E.getProxy(F.$gM.MainThreadLogger)}$setLogLevel(E,l){l?this.setLogLevel(R.URI.revive(l),E):this.setLogLevel(E)}setVisibility(E,l){super.setVisibility(E,l),this.r.$setVisibility(E,l)}s(E,l,w){return new k(this.r,E,l,w)}};e.$Kkc=d,e.$Kkc=d=Je([qe(0,N.$AO),qe(1,M.$QO)],d);class k extends S.$Tj{constructor(E,l,w,p){super(p?.logLevel==="always"),this.r=E,this.s=l,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(l,p).then(()=>{this.u(this.n),this.m=!0})}g(E,l){const w=[[E,l]];this.m?this.u(w):this.n.push(...w)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Me[80],Re([1,0,4,3,6,17,23]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=e.$zjc=void 0,e.$zjc=(0,F.$hi)("IExtHostManagedSockets");let m=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(S.$gM.MainThreadManagedSockets)}setFactory(E,l){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(E,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const l=++this.b,w=await this.c.makeConnection(),p=new M.$Tc;return this.d.set(l,new k(l,w,p)),p.add((0,M.$Sc)(()=>this.d.delete(l))),p.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),p.dispose()})),p.add(w.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),p.dispose()})),p.add(w.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ue.wrap(r)))),l}$remoteSocketWrite(E,l){this.d.get(E)?.actual.send(l.buffer)}$remoteSocketEnd(E){const l=this.d.get(E);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$Ajc=m,e.$Ajc=m=Je([qe(0,N.$AO)],m);class d{constructor(E,l){this.socketFactoryId=E,this.makeConnection=l}}class k extends M.$Uc{constructor(E,l,w){super(),this.socketId=E,this.actual=l,this.B(w)}}}),define(Me[235],Re([1,0,4,13,22]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;function N(m){return m&&m.title}let R=class{constructor(d,k){this.b=k,this.a=d.getProxy(S.$gM.MainThreadMessageService)}showMessage(d,k,O,E,l){const w={source:{identifier:d.identifier,label:d.displayName||d.name}};let p;typeof E=="string"||N(E)?p=[E,...l]:(w.modal=E?.modal,w.useCustom=E?.useCustom,w.detail=E?.detail,p=l),w.useCustom&&(0,M.$6F)(d,"resolvers");const r=[];let o=!1;for(let s=0;s<p.length;s++){const n=p[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:c}=n;r.push({title:i,isCloseAffordance:!!c,handle:s}),c&&(o?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,O,w,r).then(s=>{if(typeof s=="number")return p[s]})}};e.$akc=R,e.$akc=R=Je([qe(1,F.$Nj)],R)}),define(Me[236],Re([1,0,6,16,2,22,4]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;class m{constructor(k){this.b=new Map,this.a=k.getProxy(R.$gM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,O,E){if((0,N.$6F)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,E),this.a.$registerProfileContentHandler(O,E.name,E.description,k.identifier.value),(0,S.$Sc)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,E,l){const w=this.b.get(k);if(!w)throw new Error(`Unknown handler with id: ${k}`);return w.saveProfile(O,E,l)}async $readProfile(k,O,E){const l=this.b.get(k);if(!l)throw new Error(`Unknown handler with id: ${k}`);return l.readProfile((0,F.$Uf)(O)?O:M.URI.revive(O),E)}}e.$jkc=m}),define(Me[81],Re([1,0,4,5,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=e.$ujc=void 0;class N{constructor(m){this.b=new F.$7d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$gM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,d){return this.a.$getPassword(m,d)}store(m,d,k){return this.a.$setPassword(m,d,k)}delete(m,d){return this.a.$deletePassword(m,d)}}e.$ujc=N,e.$vjc=(0,M.$hi)("IExtHostSecretState")}),define(Me[237],Re([1,0,25,6,4]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=void 0;class N{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(M.$gM.MainThreadSpeech)}async $createSpeechToTextSession(m,d,k){const O=this.c.get(m);if(!O)return;const E=new F.$Tc,l=new S.$ee;this.d.set(d,l);const w=E.add(O.provideSpeechToTextSession(l.token,k?{language:k}:void 0));E.add(w.onDidChange(p=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,p)})),E.add(l.token.onCancellationRequested(()=>E.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,d){const k=this.c.get(m);if(!k)return;const O=new F.$Tc,E=new S.$ee;this.d.set(d,E);const l=O.add(k.provideKeywordRecognitionSession(E.token));O.add(l.onDidChange(w=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,w)})),O.add(E.token.onCancellationRequested(()=>O.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,d,k){const O=N.a++;return this.c.set(O,k),this.b.$registerProvider(O,d,{extension:m,displayName:m.value}),(0,F.$Sc)(()=>{this.b.$unregisterProvider(O),this.c.delete(O)})}}e.$qkc=N}),define(Me[82],Re([1,0,4,5,3]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=e.$mjc=void 0;class N{constructor(m,d){this.c=d,this.b=new F.$7d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$gM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,d){this.a.$registerExtensionStorageKeysToSync(m,d)}async initializeExtensionStorage(m,d,k){const O=await this.a.$initializeExtensionStorage(m,d);let E;return O&&(E=this.d(m,d,O)),E||k}setValue(m,d,k){return this.a.$setValue(m,d,k)}$acceptValue(m,d,k){const O=this.d(m,d,k);O&&this.b.fire({shared:m,key:d,value:O})}d(m,d,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${O}`)}}}e.$mjc=N,e.$njc=(0,M.$hi)("IExtHostStorage")}),define(Me[238],Re([1,0,6,12,2,4]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(d){this.c=new Map,this.b=d.getProxy(N.$gM.MainThreadUriOpeners)}registerExternalUriOpener(d,k,O,E){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const l=E.schemes.find(w=>!R.a.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,E.schemes,d,E.label),(0,S.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(d,k,O){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener with id: ${d}`);const l=M.URI.revive(k);return E.canOpenExternalUri(l,O)}async $openUri(d,k,O){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener id: '${d}'`);return E.openExternalUri(M.URI.revive(k.resolvedUri),{sourceUri:M.URI.revive(k.sourceUri)},O)}}e.$Ekc=R}),define(Me[239],Re([1,0,4,2,6,14,20]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class m{static{this.a=0}constructor(k){this.c=new R.$Dm,this.d=new Map,this.b=k.getProxy(S.$gM.MainThreadUrls)}registerUriHandler(k,O){const E=k.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const l=m.a++;return this.c.add(E),this.d.set(l,O),this.b.$registerUriHandler(l,E,k.displayName||k.name),(0,M.$Sc)(()=>{this.c.delete(E),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(k,O){const E=this.d.get(k);if(!E)return Promise.resolve(void 0);try{E.handleUri(F.URI.revive(O))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this.b.$createAppUri(k))}}e.$Fkc=m}),define(Me[62],Re([1,0,5,6,12,26,2,187,209,76,4]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=e.$0ic=void 0,e.$$ic=l,e.$ajc=r,e.$bjc=o;class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,t,v,u,g,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$7d,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=t,this.#n=v,this.#s=u,this.#r=g,this.#l=l(g),this.#d=w(g),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,k.$Gyb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$Fyb}return k.$Fyb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),N.$Rn(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,d.$Enb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,u,g,a,b,f)=>{const I=R.URI.from({scheme:a||"file",path:decodeURIComponent(b)}),$=(0,k.$Gyb)(I,{isRemote:h,authority:t}).toString();return`${u}${$}${f}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,u,g,a,b,f)=>{const I=R.URI.from({scheme:a||"file",path:decodeURIComponent(b)}),$=(0,k.$Gyb)(I,{isRemote:h,authority:t}).toString();return`${u}${$}${f}`})}}e.$0ic=E;function l(i){try{const c=(0,m.$tp)((0,m.$sp)(i.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(i){try{const c=(0,m.$tp)((0,m.$sp)(i.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class p extends F.$Uc{constructor(c,h,t,v,u){super(),this.c=h,this.f=t,this.g=v,this.h=u,this.b=new Map,this.a=c.getProxy(O.$gM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,t){const v=this.j(c);if(v){const{message:u}=(0,d.$Fnb)(h,t.value);v._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,t){const v=new E(c,this.a,s(h),this.c,this.f,t,this.h);this.b.set(c,v);const u=v._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return v}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$_ic=p;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(i,c)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(c=>R.URI.from(c))}}function n(i,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Me[109],Re([1,0,5,4,2,12,15,3,17,22]),function(me,e,S,F,M,N,R,m,d,k){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;let E=class{static{O=this}static{this.a={focused:!0,active:!0}}getState(w){const p=this.d;return{get focused(){return p.focused},get active(){return(0,k.$6F)(w,"windowActivity"),p.active}}}constructor(w){this.c=new S.$7d,this.onDidChangeWindowState=this.c.event,this.d=O.a,this.b=w.getProxy(F.$gM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:r})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,p){p!==this.d[w]&&(this.d={...this.d,[w]:p},this.c.fire(this.d))}openUri(w,p){let r;if(typeof w=="string"){r=w;try{w=M.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.$Ue)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,r,p)}async asExternalUri(w,p){if((0,R.$Ue)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(w,p);return M.URI.from(r)}};e.$Hkc=E,e.$Hkc=E=O=Je([qe(0,d.$AO)],E),e.$Ikc=(0,m.$hi)("IExtHostWindow")}),define(Me[240],Re([1,0,231,27,17]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0;let N=class extends S.$Lkc{constructor(m,d){super(m,d)}f(m,d,k){d.apply(console,k)}};e.$Tmc=N,e.$Tmc=N=Je([qe(0,M.$AO),qe(1,F.$QO)],N)}),define(Me[241],Re([1,0,11,23,25,14,5,6,143,228,50]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=e.ResponsiveState=e.RequestInitiator=void 0,e.$D0b=o,e.$E0b=s;function l(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const w="$$ref$$",p={[w]:-1};class r{constructor(C,A){this.jsonString=C,this.referencedBuffers=A}}function o(y,C=null,A=!1){const G=[];return{jsonString:(A?l:JSON.stringify)(y,(V,P)=>{if(typeof P>"u")return p;if(typeof P=="object"){if(P instanceof F.$ue){const L=G.push(P)-1;return{[w]:L}}if(C)return C(V,P)}return P}),referencedBuffers:G}}function s(y,C,A){return JSON.parse(y,(G,T)=>{if(T){const V=T[w];if(typeof V=="number")return C[V];if(A&&T.$mid===1)return A.transformIncoming(T)}return T})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,A)=>A&&A.$mid===1?y.transformOutgoing(A):A:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},v=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class g extends m.$Uc{static{E=v}static{this.a=3*1e3}constructor(C,A=null,G=null){super(),this[E]=!0,this.b=this.B(new R.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=A,this.g=G,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,V=O.$_v.count;T<V;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$th(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const A=this.w[C];delete this.w[C],A.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,d.$mn)(C,this.g):C}getProxy(C){const{nid:A,sid:G}=C;return this.s[A]||(this.s[A]=this.J(A,G)),this.s[A]}J(C,A){const G={get:(T,V)=>(typeof V=="string"&&!T[V]&&V.charCodeAt(0)===36&&(T[V]=(...P)=>this.U(C,V,P)),V===u?A:T[V])};return new Proxy(Object.create(null),G)}set(C,A){return this.m[C.nid]=A,A}assertRegistered(C){for(let A=0,G=C.length;A<G;A++){const T=C[A];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(C){if(this.j)return;const A=C.byteLength,G=b.read(C,0),T=G.readUInt8(),V=G.readUInt32();switch(T){case 1:case 2:{let{rpcId:P,method:L,args:q}=I.deserializeRequestJSONArgs(G);this.g&&(q=(0,d.$mn)(q,this.g)),this.M(A,V,P,L,q,T===2);break}case 3:case 4:{let{rpcId:P,method:L,args:q}=I.deserializeRequestMixedArgs(G);this.g&&(q=(0,d.$mn)(q,this.g)),this.M(A,V,P,L,q,T===4);break}case 5:{this.f?.logIncoming(A,V,0,"ack"),this.G(V);break}case 6:{this.N(A,V);break}case 7:{this.O(A,V,void 0);break}case 9:{let P=I.deserializeReplyOKJSON(G);this.g&&(P=(0,d.$mn)(P,this.g)),this.O(A,V,P);break}case 10:{const P=I.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(A,V,P);break}case 8:{const P=I.deserializeReplyOKVSBuffer(G);this.O(A,V,P);break}case 11:{let P=I.deserializeReplyErrError(G);this.g&&(P=(0,d.$mn)(P,this.g)),this.P(A,V,P);break}case 12:{this.P(A,V,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,A,G,T,V,P){this.f?.logIncoming(C,A,1,`receiveRequest ${(0,O.$bw)(G)}.${T}(`,V);const L=String(A);let q,re;if(P){const ye=new M.$ee;V.push(ye.token),q=this.Q(G,T,V),re=()=>ye.cancel()}else q=this.Q(G,T,V),re=t;this.u[L]=re;const ue=I.serializeAcknowledged(A);this.f?.logOutgoing(ue.byteLength,A,1,"ack"),this.c.send(ue),q.then(ye=>{delete this.u[L];const Se=I.serializeReplyOK(A,ye,this.h);this.f?.logOutgoing(Se.byteLength,A,1,"reply:",ye),this.c.send(Se)},ye=>{delete this.u[L];const Se=I.serializeReplyErr(A,ye);this.f?.logOutgoing(Se.byteLength,A,1,"replyErr:",ye),this.c.send(Se)})}N(C,A){this.f?.logIncoming(C,A,1,"receiveCancel");const G=String(A);this.u[G]?.()}O(C,A,G){this.f?.logIncoming(C,A,0,"receiveReply:",G);const T=String(A);if(!this.w.hasOwnProperty(T))return;const V=this.w[T];delete this.w[T],V.resolveOk(G)}P(C,A,G){this.f?.logIncoming(C,A,0,"receiveReplyErr:",G);const T=String(A);if(!this.w.hasOwnProperty(T))return;const V=this.w[T];delete this.w[T];let P;G&&(G.$isError?(P=new Error,P.name=G.name,P.message=G.message,P.stack=G.stack):P=G),V.resolveErr(P)}Q(C,A,G){try{return Promise.resolve(this.S(C,A,G))}catch(T){return Promise.reject(T)}}S(C,A,G){const T=this.m[C];if(!T)throw new Error("Unknown actor "+(0,O.$bw)(C));const V=T[A];if(typeof V!="function")throw new Error("Unknown method "+A+" on actor "+(0,O.$bw)(C));return V.apply(T,G)}U(C,A,G){if(this.j)return new k.$C0b;let T=null;if(G.length>0&&M.CancellationToken.isCancellationToken(G[G.length-1])&&(T=G.pop()),T&&T.isCancellationRequested)return Promise.reject(N.$6());const V=I.serializeRequestArguments(G,this.h),P=++this.t,L=String(P),q=new k.$B0b,re=new m.$Tc;T&&re.add(T.onCancellationRequested(()=>{const ye=I.serializeCancel(P);this.f?.logOutgoing(ye.byteLength,P,0,"cancel"),this.c.send(I.serializeCancel(P))})),this.w[L]=new a(q,re),this.F(P);const ue=I.serializeRequest(P,C,A,V,!!T);return this.f?.logOutgoing(ue.byteLength,P,0,`request: ${(0,O.$bw)(C)}.${A}(`,G),this.c.send(ue),q}}e.$F0b=g;class a{constructor(C,A){this.a=C,this.b=A}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class b{static alloc(C,A,G){const T=new b(F.$ue.alloc(G+1+4),0);return T.writeUInt8(C),T.writeUInt32(A),T}static read(C,A){return new b(C,A)}get buffer(){return this.a}constructor(C,A){this.a=C,this.b=A}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+C).toString();return this.b+=C,G}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+C).toString();return this.b+=C,G}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const A=this.a.slice(this.b,this.b+C);return this.b+=C,A}static sizeMixedArray(C){let A=0;A+=1;for(let G=0,T=C.length;G<T;G++){const V=C[G];switch(A+=1,V.type){case 1:A+=this.sizeLongString(V.value);break;case 2:A+=this.sizeVSBuffer(V.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(V.value);for(let P=0;P<V.buffers.length;++P)A+=this.sizeVSBuffer(V.buffers[P]);break;case 4:break}}return A}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let A=0,G=C.length;A<G;A++){const T=C[A];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let V=0;V<T.buffers.length;++V)this.writeBuffer(T.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const A=new Array(C);for(let G=0;G<C;G++)switch(this.readUInt8()){case 1:A[G]=this.readLongString();break;case 2:A[G]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),P=this.readLongString(),L=[];for(let q=0;q<V;++q)L.push(this.readVSBuffer());A[G]=new O.$cw(s(P,L,null));break}case 4:A[G]=void 0;break}return A}}var f;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(f||(f={}));class I{static a(C){for(let A=0,G=C.length;A<G;A++)if(C[A]instanceof F.$ue||C[A]instanceof O.$cw||typeof C[A]>"u")return!0;return!1}static serializeRequestArguments(C,A){if(this.a(C)){const G=[];for(let T=0,V=C.length;T<V;T++){const P=C[T];if(P instanceof F.$ue)G[T]={type:2,value:P};else if(typeof P>"u")G[T]={type:4};else if(P instanceof O.$cw){const{jsonString:L,referencedBuffers:q}=o(P.value,A);G[T]={type:3,value:F.$ue.fromString(L),buffers:q}}else G[T]={type:1,value:F.$ue.fromString(n(P,A))}}return{type:1,args:G}}return{type:0,args:n(C,A)}}static serializeRequest(C,A,G,T,V){switch(T.type){case 0:return this.b(C,A,G,T.args,V);case 1:return this.c(C,A,G,T.args,V)}}static b(C,A,G,T,V){const P=F.$ue.fromString(G),L=F.$ue.fromString(T);let q=0;q+=b.sizeUInt8(),q+=b.sizeShortString(P),q+=b.sizeLongString(L);const re=b.alloc(V?2:1,C,q);return re.writeUInt8(A),re.writeShortString(P),re.writeLongString(L),re.buffer}static deserializeRequestJSONArgs(C){const A=C.readUInt8(),G=C.readShortString(),T=C.readLongString();return{rpcId:A,method:G,args:JSON.parse(T)}}static c(C,A,G,T,V){const P=F.$ue.fromString(G);let L=0;L+=b.sizeUInt8(),L+=b.sizeShortString(P),L+=b.sizeMixedArray(T);const q=b.alloc(V?4:3,C,L);return q.writeUInt8(A),q.writeShortString(P),q.writeMixedArray(T),q.buffer}static deserializeRequestMixedArgs(C){const A=C.readUInt8(),G=C.readShortString(),T=C.readMixedArray(),V=new Array(T.length);for(let P=0,L=T.length;P<L;P++){const q=T[P];typeof q=="string"?V[P]=JSON.parse(q):V[P]=q}return{rpcId:A,method:G,args:V}}static serializeAcknowledged(C){return b.alloc(5,C,0).buffer}static serializeCancel(C){return b.alloc(6,C,0).buffer}static serializeReplyOK(C,A,G){if(typeof A>"u")return this.d(C);if(A instanceof F.$ue)return this.e(C,A);if(A instanceof O.$cw){const{jsonString:T,referencedBuffers:V}=o(A.value,G,!0);return this.g(C,T,V)}else return this.f(C,l(A,G))}static d(C){return b.alloc(7,C,0).buffer}static e(C,A){let G=0;G+=b.sizeVSBuffer(A);const T=b.alloc(8,C,G);return T.writeVSBuffer(A),T.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,A){const G=F.$ue.fromString(A);let T=0;T+=b.sizeLongString(G);const V=b.alloc(9,C,T);return V.writeLongString(G),V.buffer}static g(C,A,G){const T=F.$ue.fromString(A);let V=0;V+=b.sizeUInt32,V+=b.sizeLongString(T);for(const L of G)V+=b.sizeVSBuffer(L);const P=b.alloc(10,C,V);P.writeUInt32(G.length),P.writeLongString(T);for(const L of G)P.writeBuffer(L);return P.buffer}static deserializeReplyOKJSON(C){const A=C.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(C,A){const G=C.readUInt32(),T=C.readLongString(),V=[];for(let P=0;P<G;++P)V.push(C.readVSBuffer());return new O.$cw(s(T,V,A))}static serializeReplyErr(C,A){const G=A?l(N.$3(A),null):void 0;if(typeof G!="string")return this.h(C);const T=F.$ue.fromString(G);let V=0;V+=b.sizeLongString(T);const P=b.alloc(11,C,V);return P.writeLongString(T),P.buffer}static deserializeReplyErrError(C){const A=C.readLongString();return JSON.parse(A)}static h(C){return b.alloc(12,C,0).buffer}}var $;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var D;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(D||(D={}))}),define(Me[242],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;const S=function(N){const R=m=>{globalThis.removeEventListener("message",R);const d=m.data;Object.defineProperties(globalThis,{postMessage:{value(k,O){d.postMessage(k,O)}},onmessage:{get(){return d.onmessage},set(k){d.onmessage=k}}}),d.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(N,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${S})('${R}'))`,k=new Blob([d],{type:"application/javascript"}),O=URL.createObjectURL(k),E=new MessageChannel,l=O,w={type:"_newWorker",id:l,port:E.port2,url:O,options:m};N(w,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(O),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(p){E.port1.onmessage=p}},onmessageerror:{get(){return E.port1.onmessageerror},set(p){E.port1.onmessageerror=p}}}),E.port1.addEventListener("messageerror",p=>{const r=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(r)}),E.port1.addEventListener("message",p=>{const r=new MessageEvent("message",{data:p.data});this.dispatchEvent(r)}),E.port1.start()}}e.$Vmc=F}),define(Me[243],Re([1,0,23,28,12,54,3]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XJ=e.$UJ=void 0,e.$VJ=O,e.$WJ=E,e.$UJ=(0,R.$hi)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${m.join("")}]+`),k=7;function O(w){if(w.scheme!==M.Schemas.vscodeNotebookCell)return;const p=w.fragment.indexOf("s");if(p<0)return;const r=parseInt(w.fragment.substring(0,p).replace(d,""),k),o=(0,S.$Ne)(w.fragment.substring(p+1)).toString();if(!isNaN(r))return{handle:r,notebook:w.with({scheme:o,fragment:null})}}function E(w,p){const r=p.toString(k),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,S.$Oe)(S.$ue.fromString(w.scheme),!0,!0)}`;return w.with({scheme:M.Schemas.vscodeNotebookCell,fragment:s})}class l{constructor(){this.a=new F.$Bc}getNotebook(p){if(p.scheme===M.Schemas.vscodeNotebookCell){const r=O(p);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$XJ=l,(0,N.$es)(e.$UJ,l,1)}),define(Me[83],Re([1,0,23,34,45,69,12,19,21,35,243]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$cK=e.CellStatusbarAlignment=e.$bK=e.NotebookEditorPriority=e.$$J=e.$0J=e.$8J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$7J=e.$6J=e.$5J=e.$4J=e.CellKind=e.$3J=e.$2J=e.$1J=void 0,e.$9J=v,e.$_J=g,e.$aK=a,e.$dK=I,e.$eK=D,e.$1J="workbench.editor.notebook",e.$2J="workbench.editor.notebookTextDiffEditor",e.$3J="workbench.editor.interactive";var E;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(E||(e.CellKind=E={})),e.$4J=["application/json","application/javascript","text/html","image/svg+xml",N.$xs.latex,N.$xs.markdown,"image/png","image/jpeg",N.$xs.text],e.$5J=[N.$xs.latex,N.$xs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$xs.text],e.$6J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$7J="_notAvailable";var l;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var p;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var r;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(q){q.scheme=R.Schemas.vscodeNotebookCell;function re(_,ve){return(0,O.$WJ)(_,ve)}q.generate=re;function ue(_){return(0,O.$VJ)(_)}q.parse=ue;function ye(_,ve){return _.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ve??""},${_.scheme!==R.Schemas.file?_.scheme:""}`})}q.generateCellOutputUri=ye;function Se(_){if(_.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ve=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ve)return;const ne=ve[1]&&ve[1]!==""?ve[1]:void 0,fe=ve[2];return{outputId:ne,notebook:_.with({scheme:fe||R.Schemas.file,fragment:null})}}q.parseCellOutputUri=Se;function le(_,ve,ne){return q.generate(_,ve).with({scheme:ne})}q.generateCellPropertyUri=le;function we(_,ve){if(_.scheme===ve)return q.parse(_.with({scheme:q.scheme}))}q.parseCellPropertyUri=we})(c||(e.CellUri=c={}));const h=q=>d.$i?q.replace(/\//g,"\\"):q;class t{constructor(re=[],ue=e.$4J){this.e=ue,this.d=[...new Set(re)].map(ye=>({pattern:ye,matches:F.$bk(h(ye))}))}sort(re){const ue=new Map(M.Iterable.map(re,Se=>[Se,h(Se)]));let ye=[];for(const{matches:Se}of this.d)for(const[le,we]of ue)if(Se(we)){ye.push(le),ue.delete(le);break}return ue.size&&(ye=ye.concat([...ue.keys()].sort((Se,le)=>this.e.indexOf(Se)-this.e.indexOf(le)))),ye}prioritize(re,ue){const ye=this.f(re);if(ye===-1){this.d.unshift({pattern:re,matches:F.$bk(h(re))});return}const Se=new Set(ue.map(we=>this.f(we,ye)));Se.delete(-1);const le=Array.from(Se).sort();this.d.splice(ye+1,0,...le.map(we=>this.d[we]));for(let we=le.length-1;we>=0;we--)this.d.splice(le[we],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ue=this.d.length){const ye=h(re);for(let Se=0;Se<ue;Se++)if(this.d[Se].matches(ye))return Se;return-1}}e.$8J=t;function v(q,re,ue,ye=(Se,le)=>Se===le){const Se=[];function le(ve,ne,fe){if(ne===0&&fe.length===0)return;const W=Se[Se.length-1];W&&W.start+W.deleteCount===ve?(W.deleteCount+=ne,W.toInsert.push(...fe)):Se.push({start:ve,deleteCount:ne,toInsert:fe})}let we=0,_=0;for(;;){if(we===q.length){le(we,0,re.slice(_));break}if(_===re.length){le(we,q.length-we,[]);break}const ve=q[we],ne=re[_];if(ye(ve,ne)){we+=1,_+=1;continue}ue(ne)?(le(we,1,[]),we+=1):(le(we,0,[ne]),_+=1)}return Se}e.$0J=new k.$yj("notebookEditorCursorAtBoundary","none"),e.$$J=new k.$yj("notebookEditorCursorAtLineBoundary","none");var u;(function(q){q.default="default",q.option="option"})(u||(e.NotebookEditorPriority=u={}));function g(q){const re=q;return!!((typeof re.include=="string"||F.$ck(re.include))&&(typeof re.exclude=="string"||F.$ck(re.exclude)))}function a(q,re,ue){if(Array.isArray(q.viewType)&&q.viewType.indexOf(re)>=0||q.viewType===re)return!0;if(q.filenamePattern){const ye=g(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,Se=g(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(F.$ak(ye,(0,m.$oc)(ue.fsPath).toLowerCase()))return!(Se&&F.$ak(Se,(0,m.$oc)(ue.fsPath).toLowerCase()))}return!1}e.$bK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose"};var b;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class f{static{this.d="notebook/"}static create(re){return`${f.d}${re}`}static parse(re){if(re.startsWith(f.d))return re.substring(f.d.length)}}e.$cK=f;function I(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const $=new TextDecoder;function D(q){const re=[];let ue=!1;for(const we of q)(re.length===0||ue)&&(re.push(we),ue=!0);let ye=A(re);const Se=S.$ue.concat(re.map(we=>S.$ue.wrap(we))),le=L(Se);return ye=ye||le.byteLength!==Se.byteLength,{data:le,didCompression:ye}}e.$fK="\x1B[A";const y=e.$fK.split("").map(q=>q.charCodeAt(0)),C=10;function A(q){let re=!1;return q.forEach((ue,ye)=>{if(ye===0||ue.length<e.$fK.length)return;const Se=q[ye-1],le=ue.subarray(0,e.$fK.length);if(le[0]===y[0]&&le[1]===y[1]&&le[2]===y[2]){const we=Se.lastIndexOf(C);if(we===-1)return;re=!0,q[ye-1]=Se.subarray(0,we),q[ye]=ue.subarray(e.$fK.length)}}),re}function G(q){let re=q;do q=re,re=q.replace(/[^\n]\x08/gm,"");while(re.length<q.length);return q}function T(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const re=q.match(/^(.*)\r+/m)[1];let ue=q.match(/\r+(.*)$/m)[1];ue=ue+re.slice(ue.length,re.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return q}const V=8,P=13;function L(q){return!q.buffer.includes(V)&&!q.buffer.includes(P)?q:S.$ue.fromString(T(G($.decode(q.buffer))))}}),define(Me[7],Re([1,0,18,14,53,28,69,15,16,2,33,20,42,102,83]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p){"use strict";var r,o,s,n,i,c,h,t,v,u,g,a,b,f,I,$,D;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$oO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$bO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.TestRunProfileKind=e.TestResultState=e.$TN=e.$SN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$RN=e.NotebookVariablesRequestKind=e.$QN=e.$PN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ON=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.ColorThemeKind=e.$IN=e.$HN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$GN=e.$FN=e.DebugConsoleMode=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$zN=e.$yN=e.FileChangeType=e.$xN=e.NewSymbolNameTag=e.$wN=e.$vN=e.$uN=e.$tN=e.InlineCompletionTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.$gN=e.ConfigurationTarget=e.$fN=e.$eN=e.$dN=e.$cN=e.DocumentPasteTriggerKind=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$8M=e.ViewBadge=e.ProgressLocation=e.$7M=e.$6M=e.TaskScope=e.ShellQuoting=e.$5M=e.$4M=e.$3M=e.TaskPanelKind=e.TaskRevealKind=e.$2M=e.TerminalLocation=e.$1M=e.$ZM=e.$YM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$XM=e.$WM=e.$VM=e.$UM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$SM=e.$RM=e.$QM=e.$PM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$OM=e.$NM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.LanguageStatusSeverity=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.CodeActionTriggerKind=e.$BM=e.$AM=e.SymbolTag=e.SymbolKind=e.$zM=e.$yM=e.DocumentHighlightKind=e.$xM=e.$wM=e.$vM=e.$uM=e.DiagnosticSeverity=e.DiagnosticTag=e.$tM=e.$sM=e.FileEditType=e.$rM=e.$qM=e.$pM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$TM=Ct,e.$hN=Ue;function y(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const De=ie.length===1?[]:ie[1];return Reflect.construct(B,De,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=ie;return Reflect.construct(B,Ge,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var A;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(A||(e.TerminalQuickFixType=A={}));let G=r=class{static from(...j){let ie=j;return new r(function(){if(ie){for(const De of ie)De&&typeof De.dispose=="function"&&De.dispose();ie=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$iM=G,e.$iM=G=r=Je([y],G);let T=o=class{static Min(...j){if(j.length===0)throw new TypeError;let ie=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...j){if(j.length===0)throw new TypeError;let ie=j[0];for(let De=1;De<j.length;De++){const Ge=j[De];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:ie,character:De}=j;return typeof ie=="number"&&typeof De=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,ie){if(j<0)throw(0,F.$7)("line must be non-negative");if(ie<0)throw(0,F.$7)("character must be non-negative");this.c=j,this.e=ie}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,ie=0){if(j===null||ie===null)throw(0,F.$7)();let De;return typeof j>"u"?De=0:typeof j=="number"?De=j:(De=typeof j.lineDelta=="number"?j.lineDelta:0,ie=typeof j.characterDelta=="number"?j.characterDelta:0),De===0&&ie===0?this:new o(this.line+De,this.character+ie)}with(j,ie=this.character){if(j===null||ie===null)throw(0,F.$7)();let De;return typeof j>"u"?De=this.line:typeof j=="number"?De=j:(De=typeof j.line=="number"?j.line:this.line,ie=typeof j.character=="number"?j.character:this.character),De===this.line&&ie===this.character?this:new o(De,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$jM=T,e.$jM=T=o=Je([y],T);let V=s=class{static isRange(j){return j instanceof s?!0:j?T.isPosition(j.start)&&T.isPosition(j.end):!1}static of(j){if(j instanceof s)return j;if(this.isRange(j))return new s(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,ie,De,Ge){let _e,lt;if(typeof j=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new T(j,ie),lt=new T(De,Ge)):T.isPosition(j)&&T.isPosition(ie)&&(_e=T.of(j),lt=T.of(ie)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(j){return s.isRange(j)?this.contains(j.start)&&this.contains(j.end):T.isPosition(j)?!(T.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const ie=T.Max(j.start,this.c),De=T.Min(j.end,this.e);if(!ie.isAfter(De))return new s(ie,De)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const ie=T.Min(j.start,this.c),De=T.Max(j.end,this.end);return new s(ie,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,ie=this.end){if(j===null||ie===null)throw(0,F.$7)();let De;return j?T.isPosition(j)?De=j:(De=j.start||this.start,ie=j.end||this.end):De=this.start,De.isEqual(this.c)&&ie.isEqual(this.end)?this:new s(De,ie)}toJSON(){return[this.start,this.end]}};e.$kM=V,e.$kM=V=s=Je([y],V);let P=n=class extends V{static isSelection(j){return j instanceof n?!0:j?V.isRange(j)&&T.isPosition(j.anchor)&&T.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,ie,De,Ge){let _e,lt;if(typeof j=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new T(j,ie),lt=new T(De,Ge)):T.isPosition(j)&&T.isPosition(ie)&&(_e=T.of(j),lt=T.of(ie)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$lM=P,e.$lM=P=n=Je([y],P);const L=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$7)("connectionToken")};class q{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ie,De){if(typeof j!="string"||j.length===0)throw(0,F.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,F.$7)("port");typeof De<"u"&&L(De),this.host=j,this.port=Math.round(ie),this.connectionToken=De}}e.$mM=q;class re{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,ie){this.makeConnection=j,this.connectionToken=ie,typeof ie<"u"&&L(ie)}}e.$nM=re;class ue extends Error{static NotAvailable(j,ie){return new ue(j,w.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(j){return new ue(j,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,ie=w.RemoteAuthorityResolverErrorCode.Unknown,De){super(j),this._message=j,this._code=ie,this._detail=De,Object.setPrototypeOf(this,ue.prototype)}}e.$oM=ue;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Se;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Se||(e.EnvironmentVariableMutatorType=Se={}));let le=i=class{static isTextEdit(j){return j instanceof i?!0:j?V.isRange(j)&&typeof j.newText=="string":!1}static replace(j,ie){return new i(j,ie)}static insert(j,ie){return i.replace(new V(j,j),ie)}static delete(j){return i.replace(j,"")}static setEndOfLine(j){const ie=new i(new V(new T(0,0),new T(0,0)),"");return ie.newEol=j,ie}get range(){return this.c}set range(j){if(j&&!V.isRange(j))throw(0,F.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,F.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,F.$7)("newEol");this.f=j}constructor(j,ie){this.c=j,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$pM=le,e.$pM=le=i=Je([y],le);let we=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?di.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,ie){return new c(j,ie)}static insertCells(j,ie){return new c(new di(j,j),ie)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,ie){const De=new c(new di(j,j),[]);return De.newCellMetadata=ie,De}static updateNotebookMetadata(j){const ie=new c(new di(0,0),[]);return ie.newNotebookMetadata=j,ie}constructor(j,ie){this.range=j,this.newCells=ie}};e.$qM=we,e.$qM=we=c=Je([y],we);class _{static isSnippetTextEdit(j){return j instanceof _?!0:j?V.isRange(j.range)&&fe.isSnippetString(j.snippet):!1}static replace(j,ie){return new _(j,ie)}static insert(j,ie){return _.replace(new V(j,j),ie)}constructor(j,ie){this.range=j,this.snippet=ie}}e.$rM=_;var ve;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,ie,De,Ge){this.c.push({_type:1,from:j,to:ie,options:De,metadata:Ge})}createFile(j,ie,De){this.c.push({_type:1,from:void 0,to:j,options:ie,metadata:De})}deleteFile(j,ie,De){this.c.push({_type:1,from:j,to:void 0,options:ie,metadata:De})}e(j,ie,De){this.c.push({_type:3,metadata:De,uri:j,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(j,ie,De,Ge){const _e=ie.start,lt=ie.end;(_e!==lt||De.length>0)&&this.c.push({_type:5,uri:j,index:_e,count:lt-_e,cells:De,metadata:Ge})}g(j,ie,De,Ge){this.c.push({_type:3,metadata:Ge,uri:j,edit:{editType:3,index:ie,metadata:De}})}replace(j,ie,De,Ge){this.c.push({_type:2,uri:j,edit:new le(ie,De),metadata:Ge})}insert(j,ie,De,Ge){this.replace(j,new V(ie,ie),De,Ge)}delete(j,ie,De){this.replace(j,ie,"",De)}has(j){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===j.toString())}set(j,ie){if(ie)for(const De of ie){if(!De)continue;let Ge,_e;Array.isArray(De)?(Ge=De[0],_e=De[1]):Ge=De,we.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(j,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(j,Ge.newNotebookMetadata,_e):this.f(j,Ge.range,Ge.newCells,_e):_.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:j,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:j,edit:Ge,metadata:_e})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===j.toString()&&(this.c[De]=void 0);break}}(0,S.$Ib)(this.c)}}get(j){const ie=[];for(const De of this.c)De._type===2&&De.uri.toString()===j.toString()&&ie.push(De.edit);return ie}entries(){const j=new N.$Bc;for(const ie of this.c)if(ie._type===2){let De=j.get(ie.uri);De||(De=[ie.uri,[]],j.set(ie.uri,De)),De[1].push(ie.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$sM=ne,e.$sM=ne=Je([y],ne);let fe=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,ie=this.e++){if(typeof j=="function"){const De=new h;De.e=this.e,j(De),this.e=De.e,j=De.value}else j=h.c(j);return this.value+="${",this.value+=ie,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,ie=this.e++){const De=j.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(j,ie){if(typeof ie=="function"){const De=new h;De.e=this.e,ie(De),this.e=De.e,ie=De.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$tM=fe,e.$tM=fe=h=Je([y],fe);var W;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var te;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(te||(e.DiagnosticSeverity=te={}));let Ee=t=class{static isLocation(j){return j instanceof t?!0:j?V.isRange(j.range)&&k.URI.isUri(j.uri):!1}constructor(j,ie){if(this.uri=j,ie)if(V.isRange(ie))this.range=V.of(ie);else if(T.isPosition(ie))this.range=new V(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$uM=Ee,e.$uM=Ee=t=Je([y],Ee);let Te=class{static is(j){return j?typeof j.message=="string"&&j.location&&V.isRange(j.location.range)&&k.URI.isUri(j.location.uri):!1}constructor(j,ie){this.location=j,this.message=ie}static isEqual(j,ie){return j===ie?!0:!j||!ie?!1:j.message===ie.message&&j.location.range.isEqual(ie.location.range)&&j.location.uri.toString()===ie.location.uri.toString()}};e.$vM=Te,e.$vM=Te=Je([y],Te);let Ie=class{constructor(j,ie,De=te.Error){if(!V.isRange(j))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=j,this.message=ie,this.severity=De}toJSON(){return{severity:te[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,ie){return j===ie?!0:!j||!ie?!1:j.message===ie.message&&j.severity===ie.severity&&j.code===ie.code&&j.severity===ie.severity&&j.source===ie.source&&j.range.isEqual(ie.range)&&(0,S.$ub)(j.tags,ie.tags)&&(0,S.$ub)(j.relatedInformation,ie.relatedInformation,Te.isEqual)}};e.$wM=Ie,e.$wM=Ie=Je([y],Ie);let pe=class{constructor(j,ie){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=ie}};e.$xM=pe,e.$xM=pe=Je([y],pe);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let J=class{constructor(j,ie=ge.Text){this.range=j,this.kind=ie}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$yM=J,e.$yM=J=Je([y],J);let X=class{constructor(j,ie){this.uri=j,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$zM=X,e.$zM=X=Je([y],X);var ce;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ce||(e.SymbolKind=ce={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Oe=v=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,ie,De,Ge,_e){this.name=j,this.kind=ie,this.containerName=_e,typeof De=="string"&&(this.containerName=De),Ge instanceof Ee?this.location=Ge:De instanceof V&&(this.location=new Ee(Ge,De)),v.validate(this)}toJSON(){return{name:this.name,kind:ce[this.kind],location:this.location,containerName:this.containerName}}};e.$AM=Oe,e.$AM=Oe=v=Je([y],Oe);let he=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,ie,De,Ge,_e){this.name=j,this.detail=ie,this.kind=De,this.range=Ge,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$BM=he,e.$BM=he=u=Je([y],he);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Ae=class{constructor(j,ie){this.title=j,this.kind=ie}};e.$CM=Ae,e.$CM=Ae=Je([y],Ae);let Le=class{static{g=this}static{this.c="."}constructor(j){this.value=j}append(j){return new g(this.value?this.value+g.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+g.c)}};e.$DM=Le,e.$DM=Le=g=Je([y],Le),Le.Empty=new Le(""),Le.QuickFix=Le.Empty.append("quickfix"),Le.Refactor=Le.Empty.append("refactor"),Le.RefactorExtract=Le.Refactor.append("extract"),Le.RefactorInline=Le.Refactor.append("inline"),Le.RefactorMove=Le.Refactor.append("move"),Le.RefactorRewrite=Le.Refactor.append("rewrite"),Le.Source=Le.Empty.append("source"),Le.SourceOrganizeImports=Le.Source.append("organizeImports"),Le.SourceFixAll=Le.Source.append("fixAll"),Le.Notebook=Le.Empty.append("notebook");let U=class{constructor(j,ie){if(this.range=j,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$EM=U,e.$EM=U=Je([y],U);class z{constructor(j,ie,De,Ge,_e,lt){this.kind=j,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$FM=z;class K{constructor(j,ie){this.fromRanges=ie,this.from=j}}e.$GM=K;class H{constructor(j,ie){this.fromRanges=ie,this.to=j}}e.$HM=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(j,ie){this.range=j,this.command=ie}get isResolved(){return!!this.command}};e.$IM=se,e.$IM=se=Je([y],se);let Ne=a=class{#e;static isMarkdownString(j){return j instanceof a?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,ie=!1){this.#e=new M.$Ek(j,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,ie){return this.#e.appendCodeblock(ie??"",j),this}};e.$JM=Ne,e.$JM=Ne=a=Je([y],Ne);let Ve=class{constructor(j,ie){this.label=j,this.documentation=ie}};e.$KM=Ve,e.$KM=Ve=Je([y],Ve);let Ye=class{constructor(j,ie){this.label=j,this.documentation=ie,this.parameters=[]}};e.$LM=Ye,e.$LM=Ye=Je([y],Ye);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$MM=xe,e.$MM=xe=Je([y],xe);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var ot;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let rt=class{constructor(j){this.value=j}};e.$NM=rt,e.$NM=rt=Je([y],rt);let tt=class{constructor(j,ie,De){this.position=j,this.label=ie,this.kind=De}};e.$OM=tt,e.$OM=tt=Je([y],tt);var st;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var it;(function(B){B[B.Deprecated=1]="Deprecated"})(it||(e.CompletionItemTag=it={}));let Q=class{constructor(j,ie){this.label=j,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$PM=Q,e.$PM=Q=Je([y],Q);let Z=class{constructor(j=[],ie=!1){this.items=j,this.isIncomplete=ie}};e.$QM=Z,e.$QM=Z=Je([y],Z);let $e=class{constructor(j,ie,De){this.insertText=j,this.range=ie,this.command=De}};e.$RM=$e,e.$RM=$e=Je([y],$e);let We=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$SM=We,e.$SM=We=Je([y],We);var Qe;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Qe||(e.PartialAcceptTriggerKind=Qe={}));var at;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(at||(e.ViewColumn=at={}));var Fe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Fe||(e.StatusBarAlignment=Fe={}));function Ct(B,j){return`${E.$Cm.toKey(B)}.${j}`}var Lt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Lt||(e.TextEditorLineNumbersStyle=Lt={}));var Xt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var ei;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ei||(e.TextEditorRevealType=ei={}));var zt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var Dt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Dt||(e.TextDocumentChangeReason=Dt={}));var ti;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ti||(e.DecorationRangeBehavior=ti={})),function(B){function j(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Ut;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ut||(e.SyntaxTokenType=Ut={})),function(B){function j(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Ut||(e.SyntaxTokenType=Ut={}));let ri=class{constructor(j,ie){if(ie&&!k.URI.isUri(ie))throw(0,F.$7)("target");if(!V.isRange(j)||j.isEmpty)throw(0,F.$7)("range");this.range=j,this.target=ie}};e.$UM=ri,e.$UM=ri=Je([y],ri);let ii=class{constructor(j,ie,De,Ge){this.red=j,this.green=ie,this.blue=De,this.alpha=Ge}};e.$VM=ii,e.$VM=ii=Je([y],ii);let Xe=class{constructor(j,ie){if(ie&&!(ie instanceof ii))throw(0,F.$7)("color");if(!V.isRange(j)||j.isEmpty)throw(0,F.$7)("range");this.range=j,this.color=ie}};e.$WM=Xe,e.$WM=Xe=Je([y],Xe);let Qt=class{constructor(j){if(!j||typeof j!="string")throw(0,F.$7)("label");this.label=j}};e.$XM=Qt,e.$XM=Qt=Je([y],Qt);var Bt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var ht;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ht||(e.SourceControlInputBoxValidationType=ht={}));var mt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(mt||(e.TerminalExitReason=mt={}));class ni{constructor(j,ie,De){if(this.startIndex=j,this.length=ie,this.tooltip=De,typeof j!="number"||j<0)throw(0,F.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,F.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,F.$7)("tooltip")}}e.$YM=ni;class Vt{constructor(j){this.uri=j}}e.$ZM=Vt;class Wt{constructor(j){this.terminalCommand=j}}e.$1M=Wt;var dt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(dt||(e.TerminalLocation=dt={}));class St{constructor(j){if(this.options=j,typeof j!="object")throw(0,F.$7)("options")}}e.$2M=St;var si;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(si||(e.TaskRevealKind=si={}));var xt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(xt||(e.TaskPanelKind=xt={}));let He=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(j){switch(j){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(j,ie){if(this.label=ie,typeof j!="string"||typeof ie!="string")throw(0,F.$7)("name");this.c=j}get id(){return this.c}};e.$3M=He,e.$3M=He=b=Je([y],He);function qt(B){let j="";for(let ie=0;ie<B.length;ie++)j+=B[ie].replace(/,/g,",,")+",";return j}let jt=class{constructor(j,ie,De){if(typeof j!="string")throw(0,F.$7)("process");this.e=[],this.c=j,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=De):this.f=ie)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,F.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)j.push(ie);return qt(j)}};e.$4M=jt,e.$4M=jt=Je([y],jt);let Ht=class{constructor(j,ie,De){if(this.f=[],Array.isArray(ie)){if(!j)throw(0,F.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,F.$7)("command");this.e=j,this.f=ie,this.g=De}else{if(typeof j!="string")throw(0,F.$7)("commandLine");this.c=j,this.g=ie}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,F.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,F.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)j.push(typeof ie=="string"?ie:ie.value);return qt(j)}};e.$5M=Ht,e.$5M=Ht=Je([y],Ht);var $t;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var Pt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Pt||(e.TaskScope=Pt={}));class Mt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,O.$Dg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$6M=Mt;let Ot=class{static{f=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,ie,De,Ge,_e,lt){this.k=!1,this.l=this.definition=j;let gt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=De,this.execution=Ge,gt=_e,this.k=!0):ie===Pt.Global||ie===Pt.Workspace?(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=lt):(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof jt?this.l={type:f.e,id:this.q.computeId()}:this.q instanceof Ht?this.l={type:f.f,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:f.c,id:this.q.computeId()}:this.l={type:f.g,id:(0,O.$Dg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=j}get scope(){return this.m}set target(j){this.B(),this.m=j}get name(){return this.o}set name(j){if(typeof j!="string")throw(0,F.$7)("name");this.B(),this.o=j}get execution(){return this.q}set execution(j){j===null&&(j=void 0),this.B(),this.q=j;const ie=this.l.type;(f.g===ie||f.e===ie||f.f===ie||f.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(j){if(Array.isArray(j))this.B(),this.r=j,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.B(),this.u=j}get source(){return this.w}set source(j){if(typeof j!="string"||j.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=j}get group(){return this.x}set group(j){j===null&&(j=void 0),this.B(),this.x=j}get detail(){return this.A}set detail(j){j===null&&(j=void 0),this.A=j}get presentationOptions(){return this.y}set presentationOptions(j){j==null&&(j=Object.create(null)),this.B(),this.y=j}get runOptions(){return this.z}set runOptions(j){j==null&&(j=Object.create(null)),this.B(),this.z=j}};e.$7M=Ot,e.$7M=Ot=f=Je([y],Ot);var oi;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var Kt;(function(B){function j(ie){const De=ie;return(0,d.$Yf)(De.value)?De.tooltip&&!(0,d.$Uf)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=j})(Kt||(e.ViewBadge=Kt={}));let Gt=I=class{static isTreeItem(j,ie){const De=j;if(De.checkboxState!==void 0){const Ge=(0,d.$Yf)(De.checkboxState)?De.checkboxState:(0,d.$Wf)(De.checkboxState)&&(0,d.$Yf)(De.checkboxState.state)?De.checkboxState.state:void 0,_e=!(0,d.$Yf)(De.checkboxState)&&(0,d.$Wf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Rt.Checked&&Ge!==Rt.Unchecked||_e!==void 0&&!(0,d.$Uf)(_e))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(j instanceof I)return!0;if(De.label!==void 0&&!(0,d.$Uf)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,d.$Uf)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,d.$Uf)(De.iconPath)&&!k.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,d.$Uf)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,d.$Uf)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,d.$Uf)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,d.$Uf)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!k.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,d.$Uf)(De.tooltip)&&!(De.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<yt.None&&De.collapsibleState>yt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,d.$Uf)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(j,ie=yt.None){this.collapsibleState=ie,k.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$8M=Gt,e.$8M=Gt=I=Je([y],Gt);var yt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(yt||(e.TreeItemCollapsibleState=yt={}));var Rt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Rt||(e.TreeItemCheckboxState=Rt={}));let Jt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$9M=Jt,e.$9M=Jt=Je([y],Jt);class Nt extends Jt{}e.$0M=Nt;class kt extends Nt{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$$M=kt;class It{constructor(j,ie,De,Ge){this.name=j,this.uri=ie,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$_M=It;let Et=class{#e=new Map;constructor(j){for(const[ie,De]of j??[]){const Ge=this.#e.get(this.#t(ie));Ge?Ge.push(De):this.#e.set(this.#t(ie),[De])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,ie){this.#e.set(this.#t(j),[ie])}forEach(j,ie){for(const[De,Ge]of this.#e)for(const _e of Ge)j.call(ie,_e,De,this)}*[Symbol.iterator](){for(const[j,ie]of this.#e)for(const De of ie)yield[j,De]}#t(j){return j.toLowerCase()}};e.$aN=Et,e.$aN=Et=Je([y],Et);let li=class{constructor(j,ie,De){this.insertText=j,this.title=ie,this.kind=De}};e.$bN=li,e.$bN=li=Je([y],li);var _t;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(_t||(e.DocumentPasteTriggerKind=_t={}));class ai{static{this.c="."}constructor(j){this.value=j}append(...j){return new ai((this.value?[this.value,...j]:j).join(ai.c))}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+ai.c)}}e.$cN=ai,ai.Empty=new ai("");let hi=class{constructor(j,ie,De){this.title=ie,this.insertText=j,this.kind=De}};e.$dN=hi,e.$dN=hi=Je([y],hi);let be=class{constructor(j,ie){this.id=j,this.color=ie}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$eN=be,e.$eN=be=Je([y],be),be.File=new be("file"),be.Folder=new be("folder");let Pe=class{constructor(j){this.id=j}};e.$fN=Pe,e.$fN=Pe=Je([y],Pe);var ae;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ae||(e.ConfigurationTarget=ae={}));let Y=class{get base(){return this.c}set base(j){this.c=j,this.e=k.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,ie){if(typeof j!="string"&&(!j||!k.URI.isUri(j)&&!k.URI.isUri(j.uri)))throw(0,F.$7)("base");if(typeof ie!="string")throw(0,F.$7)("pattern");typeof j=="string"?this.baseUri=k.URI.file(j):k.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$gN=Y,e.$gN=Y=Je([y],Y);const ke=new WeakMap;function Ue(B,j){ke.set(B,j)}let Ze=class{constructor(j,ie,De,Ge,_e){this.enabled=typeof j=="boolean"?j:!0,typeof ie=="string"&&(this.condition=ie),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=ke.get(this)??(0,O.$Dg)()),this.c}};e.$iN=Ze,e.$iN=Ze=Je([y],Ze);let Ke=class extends Ze{constructor(j,ie,De,Ge,_e,lt){if(super(ie,De,Ge,_e,lt),j===null)throw(0,F.$7)("location");this.location=j}};e.$jN=Ke,e.$jN=Ke=Je([y],Ke);let ut=class extends Ze{constructor(j,ie,De,Ge,_e,lt){super(ie,De,Ge,_e,lt),this.functionName=j}};e.$kN=ut,e.$kN=ut=Je([y],ut);let wt=class extends Ze{constructor(j,ie,De,Ge,_e,lt,gt,Yt){if(super(Ge,_e,lt,gt,Yt),!ie)throw(0,F.$7)("dataId");this.label=j,this.dataId=ie,this.canPersist=De}};e.$lN=wt,e.$lN=wt=Je([y],wt);let bt=class{constructor(j,ie,De){this.command=j,this.args=ie||[],this.options=De}};e.$mN=bt,e.$mN=bt=Je([y],bt);let Zt=class{constructor(j,ie){this.port=j,this.host=ie}};e.$nN=Zt,e.$nN=Zt=Je([y],Zt);let At=class{constructor(j){this.path=j}};e.$oN=At,e.$oN=At=Je([y],At);let Tt=class{constructor(j){this.implementation=j}};e.$pN=Tt,e.$pN=Tt=Je([y],Tt);class yi{constructor(j,ie,De){this.session=j,this.threadId=ie,this.frameId=De}}e.$qN=yi;class ft{constructor(j,ie){this.session=j,this.threadId=ie}}e.$rN=ft;let Ri=class{constructor(j,ie){this.range=j,this.expression=ie}};e.$sN=Ri,e.$sN=Ri=Je([y],Ri);var gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let pi=class{constructor(j,ie){this.range=j,this.text=ie}};e.$tN=pi,e.$tN=pi=Je([y],pi);let ki=class{constructor(j,ie,De=!0){this.range=j,this.variableName=ie,this.caseSensitiveLookup=De}};e.$uN=ki,e.$uN=ki=Je([y],ki);let Ai=class{constructor(j,ie){this.range=j,this.expression=ie}};e.$vN=Ai,e.$vN=Ai=Je([y],Ai);let Fi=class{constructor(j,ie){this.frameId=j,this.stoppedLocation=ie}};e.$wN=Fi,e.$wN=Fi=Je([y],Fi);var Ji;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ji||(e.NewSymbolNameTag=Ji={}));class Yi{constructor(j,ie){this.newSymbolName=j,this.tags=ie}}e.$xN=Yi;var Qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ei=$=class extends Error{static FileExists(j){return new $(j,l.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(j){return new $(j,l.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(j){return new $(j,l.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(j){return new $(j,l.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(j){return new $(j,l.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(j){return new $(j,l.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(j,ie=l.FileSystemProviderErrorCode.Unknown,De){super(k.URI.isUri(j)?j.toString(!0):j),this.code=De?.name??"Unknown",(0,l.$3k)(this,ie),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$yN=Ei,e.$yN=Ei=$=Je([y],Ei);let Oi=class{constructor(j,ie,De){this.start=j,this.end=ie,this.kind=De}};e.$zN=Oi,e.$zN=Oi=Je([y],Oi);var Di;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Di||(e.FoldingRangeKind=Di={}));var Si;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Si||(e.CommentThreadCollapsibleState=Si={}));var Zi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Xi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class ln{constructor(j,ie=[]){this.tokenTypes=j,this.tokenModifiers=ie}}e.$AN=ln;function hn(B){return typeof B>"u"||(0,d.$Vf)(B)}class Ni{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let ie=0,De=j.tokenTypes.length;ie<De;ie++)this.k.set(j.tokenTypes[ie],ie);for(let ie=0,De=j.tokenModifiers.length;ie<De;ie++)this.l.set(j.tokenModifiers[ie],ie)}}push(j,ie,De,Ge,_e){if(typeof j=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(j,ie,De,Ge,_e);if(V.isRange(j)&&typeof ie=="string"&&hn(De))return this.o(j,ie,De);throw(0,F.$7)()}o(j,ie,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=j.start.line,_e=j.start.character,lt=j.end.character-j.start.character,gt=this.k.get(ie);let Yt=0;if(De)for(const ui of De){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ui);Yt|=1<<fi>>>0}this.q(Ge,_e,lt,gt,Yt)}q(j,ie,De,Ge,_e){if(this.f&&(j<this.c||j===this.c&&ie<this.e)){this.f=!1;const Yt=this.g.length/5|0;let ui=0,fi=0;for(let $i=0;$i<Yt;$i++){let vi=this.g[5*$i],Ki=this.g[5*$i+1];vi===0?(vi=ui,Ki+=fi):vi+=ui,this.g[5*$i]=vi,this.g[5*$i+1]=Ki,ui=vi,fi=Ki}}let lt=j,gt=ie;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=j,this.e=ie}static r(j){const ie=[],De=j.length/5|0;for(let gt=0;gt<De;gt++)ie[gt]=gt;ie.sort((gt,Yt)=>{const ui=j[5*gt],fi=j[5*Yt];if(ui===fi){const $i=j[5*gt+1],vi=j[5*Yt+1];return $i-vi}return ui-fi});const Ge=new Uint32Array(j.length);let _e=0,lt=0;for(let gt=0;gt<De;gt++){const Yt=5*ie[gt],ui=j[Yt+0],fi=j[Yt+1],$i=j[Yt+2],vi=j[Yt+3],Ki=j[Yt+4],An=ui-_e,ir=An===0?fi-lt:fi,Gi=5*gt;Ge[Gi+0]=An,Ge[Gi+1]=ir,Ge[Gi+2]=$i,Ge[Gi+3]=vi,Ge[Gi+4]=Ki,_e=ui,lt=fi}return Ge}build(j){return this.f?new Ti(new Uint32Array(this.g),j):new Ti(Ni.r(this.g),j)}}e.$BN=Ni;class Ti{constructor(j,ie){this.resultId=ie,this.data=j}}e.$CN=Ti;class dn{constructor(j,ie,De){this.start=j,this.deleteCount=ie,this.data=De}}e.$DN=dn;class xi{constructor(j,ie){this.resultId=ie,this.edits=j}}e.$EN=xi;var Li;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Li||(e.DebugConsoleMode=Li={}));class fn{constructor(j){this.name=j}}e.$FN=fn;let Ii=class{static{this.Back={iconPath:new be("arrow-left")}}constructor(){}};e.$GN=Ii,e.$GN=Ii=Je([y],Ii);var ji;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var _i;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(_i||(e.InputBoxValidationSeverity=_i={}));var en;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(en||(e.ExtensionKind=en={}));class gn{static validate(j){if(typeof j.badge=="string"){let ie=(0,m.$vf)(j.badge,0);if(ie<j.badge.length&&(ie+=(0,m.$vf)(j.badge,ie)),j.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!be.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,ie,De){this.badge=j,this.tooltip=ie,this.color=De}}e.$HN=gn;let zi=class{constructor(j){this.kind=j}};e.$IN=zi,e.$IN=zi=Je([y],zi);var Ci;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ci||(e.ColorThemeKind=Ci={}));class di{static isNotebookRange(j){return j instanceof di?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,ie){if(j<0)throw(0,F.$7)("start must be positive");if(ie<0)throw(0,F.$7)("end must be positive");j<=ie?(this.c=j,this.e=ie):(this.c=ie,this.e=j)}with(j){let ie=this.c,De=this.e;return j.start!==void 0&&(ie=j.start),j.end!==void 0&&(De=j.end),ie===this.c&&De===this.e?this:new di(ie,De)}}e.$JN=di;class je{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(ie=>je.isNotebookCellData(ie))}static isNotebookCellData(j){return!0}constructor(j,ie,De,Ge,_e,lt,gt){this.kind=j,this.value=ie,this.languageId=De,this.mime=Ge,this.outputs=_e??[],this.metadata=lt,this.executionSummary=gt,je.validate(this)}}e.$KN=je;class mi{constructor(j){this.cells=j}}e.$LN=mi;class ci{static isNotebookCellOutputItem(j){return j instanceof ci?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const ie={name:j.name,message:j.message,stack:j.stack};return ci.json(ie,"application/vnd.code.notebook.error")}static stdout(j){return ci.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return ci.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,ie="application/octet-stream"){return new ci(j,ie)}static#e=new TextEncoder;static text(j,ie=R.$xs.text){const De=ci.#e.encode(String(j));return new ci(De,ie)}static json(j,ie="text/x-json"){const De=JSON.stringify(j,void 0,"	");return ci.text(De,ie)}constructor(j,ie){this.data=j,this.mime=ie;const De=(0,R.$Bs)(ie,!0);if(!De)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$MN=ci;class nt{static isNotebookCellOutput(j){return j instanceof nt?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,ie=!1){const De=new Set,Ge=new Set;for(let _e=0;_e<j.length;_e++){const lt=j[_e],gt=(0,R.$Bs)(lt.mime);if(!De.has(gt)||(0,p.$dK)(gt)){De.add(gt);continue}Ge.add(_e),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?j:j.filter((_e,lt)=>!Ge.has(lt))}constructor(j,ie,De){this.items=nt.ensureUniqueMimeTypes(j,!0),typeof ie=="string"?(this.id=ie,this.metadata=De):(this.id=(0,O.$Dg)(),this.metadata=ie??De)}}e.$NN=nt;var pt;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(pt||(e.NotebookCellKind=pt={}));var tn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ui;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ui||(e.NotebookEditorRevealType=Ui={}));class mn{constructor(j,ie){this.text=j,this.alignment=ie}}e.$ON=mn;var bi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(bi||(e.NotebookControllerAffinity=bi={}));var rn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(rn||(e.NotebookControllerAffinity2=rn={}));class $n{constructor(j,ie=[]){this.uri=j,this.provides=(0,S.$3b)(ie)}}e.$PN=$n;class pn{constructor(j){this.label=j}}e.$QN=pn;var Bi;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(Bi||(e.NotebookVariablesRequestKind=Bi={}));let Vi=class{constructor(j,ie){this.label=j,this.timestamp=ie}};e.$RN=Vi,e.$RN=Vi=Je([y],Vi);var sn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(sn||(e.ExtensionMode=sn={}));var on;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(on||(e.ExtensionRuntime=on={}));var an;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class vn{constructor(j,ie){this.ranges=j,this.wordPattern=ie}}e.$SN=vn;class wn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$TN=wn;var cn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Wi=class{constructor(j=void 0,ie=void 0,De=void 0,Ge=!1){this.include=j,this.exclude=ie,this.profile=De,this.continuous=Ge}};e.$UN=Wi,e.$UN=Wi=Je([y],Wi);let qi=D=class{static diff(j,ie,De){const Ge=new D(j);return Ge.expectedOutput=ie,Ge.actualOutput=De,Ge}constructor(j){this.message=j}};e.$VN=qi,e.$VN=qi=D=Je([y],qi);let Hi=class{constructor(j){this.id=j}};e.$WN=Hi,e.$WN=Hi=Je([y],Hi);class x{constructor(j,ie){this.covered=j,this.total=ie}}e.$XN=x;const oe=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class ze{static fromDetails(j,ie){const De=new x(0,0),Ge=new x(0,0),_e=new x(0,0);for(const gt of ie)if("branches"in gt){De.total+=1,De.covered+=gt.executed?1:0;for(const Yt of gt.branches)Ge.total+=1,Ge.covered+=Yt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const lt=new ze(j,De,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=ie,lt}constructor(j,ie,De,Ge){this.uri=j,this.statementCoverage=ie,this.branchCoverage=De,this.declarationCoverage=Ge,oe(ie),oe(De),oe(Ge)}}e.$YN=ze;class ct{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,De=[]){this.executed=j,this.location=ie,this.branches=De}}e.$ZN=ct;class vt{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,De){this.executed=j,this.location=ie,this.label=De}}e.$1N=vt;class Ft{get executionCount(){return+this.executed}set executionCount(j){this.executed=j}constructor(j,ie,De){this.name=j,this.executed=ie,this.location=De}}e.$2N=Ft;var Pi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Pi||(e.ExternalUriOpenerPriority=Pi={}));var bn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(bn||(e.WorkspaceTrustState=bn={}));var yn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(yn||(e.PortAutoForwardAction=yn={}));class Fn{constructor(j,ie,De,Ge,_e,lt){this.kind=j,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$3N=Fn;class On{constructor(j){this.uri=j}}e.$4N=On;class Nn{constructor(j,ie){this.original=j,this.modified=ie}}e.$5N=Nn;class Tn{constructor(j,ie,De,Ge){this.base=j,this.input1=ie,this.input2=De,this.result=Ge}}e.$6N=Tn;class Ln{constructor(j,ie){this.uri=j,this.viewType=ie}}e.$7N=Ln;class jn{constructor(j){this.viewType=j}}e.$8N=jn;class zn{constructor(j,ie){this.uri=j,this.notebookType=ie}}e.$9N=zn;class Un{constructor(j,ie,De){this.original=j,this.modified=ie,this.notebookType=De}}e.$0N=Un;class Bn{constructor(){}}e.$$N=Bn;class Vn{constructor(j,ie){this.uri=j,this.inputBoxUri=ie}}e.$_N=Vn;class Wn{constructor(j){this.providerId=j}}e.$aO=Wn;var kn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var En;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var Dn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class qn{constructor(j,ie){this.label=j,this.values=ie}}e.$bO=qn;var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(In||(e.ChatResultFeedbackKind=In={}));class Hn{constructor(j){this.value=typeof j=="string"?new Ne(j):j}}e.$cO=Hn;class Kn{constructor(j,ie){this.value=j,this.baseUri=ie}}e.$dO=Kn;class Gn{constructor(j,ie){this.value=j,this.title=ie}}e.$eO=Gn;class Jn{constructor(j){this.value=j}}e.$fO=Jn;class Yn{constructor(j){this.value=j}}e.$gO=Yn;class Qn{constructor(j){this.value=j}}e.$hO=Qn;class Zn{constructor(j,ie,De,Ge){this.prompt=j,this.command=ie,this.variables=De,this.participant=Ge}}e.$iO=Zn;class Xn{constructor(j,ie,De,Ge){this.response=j,this.result=ie,this.participant=De,this.command=Ge}}e.$jO=Xn;class xn{constructor(j){this.content=j}}e.$kO=xn;class _n{constructor(j,ie){this.content=j,this.name=ie}}e.$lO=_n;class er{constructor(j){this.content=j}}e.$mO=er;class Mi extends Error{static NotFound(j){return new Mi(j,Mi.NotFound.name)}static NoPermissions(j){return new Mi(j,Mi.NoPermissions.name)}constructor(j,ie,De){super(j,{cause:De}),this.name="LanguageModelError",this.code=ie??""}}e.$nO=Mi;var Cn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var Pn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Pn||(e.SpeechToTextStatus=Pn={}));var Mn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Mn||(e.KeywordRecognitionStatus=Mn={}));class tr{constructor(j,ie){this.text=j,this.range=ie}}e.$oO=tr;var Rn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(Me[244],Re([1,0,4,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$gM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,d){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(m,d)??[]}getRelatedInformation(R,m,d){return this.c.$getAiRelatedInformation(m,d)}registerRelatedInformationProvider(R,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiRelatedInformationProvider(k,m),new F.$iM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Bic=M}),define(Me[84],Re([1,0,5,4,7,20,106,3,17]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0,e.$Mic=(0,m.$hi)("IExtHostAuthentication");let k=class{constructor(l){this.b=new Map,this.c=new S.$7d,this.onDidChangeSessions=this.c.event,this.d=new O,this.f=new O,this.a=l.getProxy(F.$gM.MainThreadAuthentication)}async getSession(l,w,p,r={}){const o=N.$Cm.toKey(l.identifier),s=[...p].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const n=l.displayName||l.name;return this.a.$getSession(w,p,o,n,r)})}async getSessions(l,w,p){const r=N.$Cm.toKey(l.identifier),o=[...p].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(w);const s=l.displayName||l.name;return this.a.$getSessions(w,p,r,s)})}async removeSession(l,w){const p=this.b.get(l);return p?p.provider.removeSession(w):this.a.$removeSession(l,w)}registerAuthenticationProvider(l,w,p,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:w,provider:p,options:r??{supportsMultipleAccounts:!1}});const o=p.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(l,s));return this.a.$registerAuthenticationProvider(l,w,r?.supportsMultipleAccounts??!1),new M.$iM(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,w,p){const r=this.b.get(l);if(r)return Promise.resolve(r.provider.createSession(w,p));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,w){const p=this.b.get(l);if(p)return Promise.resolve(p.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,w){const p=this.b.get(l);if(p)return Promise.resolve(p.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,w){return l.startsWith(R.$iL)||this.c.fire({provider:{id:l,label:w}}),Promise.resolve()}};e.$Nic=k,e.$Nic=k=Je([qe(0,d.$AO)],k);class O{constructor(){this.a=new Map}getOrCreate(l,w){const p=this.a.get(l);if(p)return p;const r=w().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(Me[110],Re([1,0,2,4,7,3,17,13,18,15,19,22]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=e.$Njc=void 0;let w=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(F.$gM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=l.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const c=(0,d.$3b)(i);if(c.length<=l.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,k.$1e)(u.path,"/")})),t=(0,d.$zb)(h,(u,g)=>u.rank-g.rank||(0,k.$ef)(u.uri.path,g.uri.path)),v=[];e:for(const u of t){let g;for(const a of u){const b=(0,O.$nc)(a.uri.path);if(g!==b&&(g=b,v.push(a.uri)>=l.d))break e}}this.g.$onDidChange(s,v)});return new M.$iM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:t,id:v}=h,u=await Promise.resolve(i.provideFileDecoration(S.URI.revive(t),s));if(!u)return;try{M.$HN.validate(u),u.badge&&typeof u.badge!="string"&&(0,E.$6F)(c,"codiconDecoration"),n[v]=[u.propagate,u.tooltip,u.badge,u.color]}catch(g){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${g}`)}}catch(t){this.h.error(t)}})),n}};e.$Njc=w,e.$Njc=w=l=Je([qe(0,R.$AO),qe(1,m.$Nj)],w),e.$Ojc=(0,N.$hi)("IExtHostDecorations")}),define(Me[245],Re([1,0,14,2,7,4,12,25,15]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class k{static{this.a=0}constructor(E,l,w){this.d=l,this.e=w,this.b=new Map,this.c=E.getProxy(N.$gM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,l){if(Object.keys(R.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const w=k.a++;this.b.set(w,l),this.c.$registerTextContentProvider(w,E);let p;if(typeof l.onDidChange=="function"){let r;p=l.onDidChange(async o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(w,o).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(o);if(!i)return;const c=(0,d.$$e)(n);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(S.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new M.$iM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(E,l){const w=this.b.get(E);return w?Promise.resolve(w.provideTextDocumentContent(F.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Qjc=k}),define(Me[111],Re([1,0,55,12,15,301,151,7,18]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=e.$DO=void 0,e.$CO=O;const k=new Map;function O(p,r){r?k.set(p,r):k.delete(p)}function E(p){return k.get(p)}class l extends N.$Fv{constructor(r,o,s,n,i,c,h){super(o,s,n,i),this.c=r,this.m=c,this.q=h,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,d.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===F.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,S.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,S.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,i=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<i;h++)c.push(this.f[h]);return c.push(this.f[i].substring(0,o.end.character)),c.join(s)}t(r){let o;if(r instanceof m.$jM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new m.$jM(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof m.$kM))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new m.$kM(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof m.$jM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const i=this.f[o].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new m.$jM(o,s):r}y(r,o){const s=this.x(r);if(!o)o=E(this.m);else if((0,M.$0e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$Ps)(s.character+1,(0,R.$Ns)(o),this.f[s.line],0);if(n)return new m.$kM(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$DO=l;class w{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$kM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$kM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EO=w}),define(Me[246],Re([1,0,4,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$gM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const O=await k.provideEmbeddingVector(m,d);if(!O)throw new Error("Embedding vector provider returned undefined");return O}registerEmbeddingVectorProvider(R,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiEmbeddingVectorProvider(m,k),new F.$iM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Sjc=M}),define(Me[63],Re([1,0,4,42,7,23,3,17,43,6,11,24,12]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0;let p=w=class{constructor(o,s){this.b=new Map,this.c=new O.$qh,this.a=o.getProxy(S.$gM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let c;const h=n.b.get(i.scheme);return h?(await n.a.$ensureActivation(i.scheme),c=await h.impl.stat(i)):c=await n.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===F.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(c){return w.e(c)}},async createDirectory(i){try{const c=n.b.get(i.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(c.impl,c.extUri,i)):await n.a.$mkdir(i)}catch(c){return w.e(c)}},async readFile(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(c){return w.e(c)}},async writeFile(i,c){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$ue.wrap(c))}catch(h){return w.e(h)}},async delete(i,c){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...c})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return w.e(h)}},async rename(i,c,h){try{return await n.a.$rename(i,c,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(i,c,h){try{return await n.a.$copy(i,c,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(i){const c=s.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(o,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&F.FileType.Directory))throw M.$yN.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(F.$4k(c)!==F.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(s.basename(n)),n=s.dirname(n)}for(let c=i.length-1;c>=0;c--){n=s.joinPath(n,i[c]);try{await o.createDirectory(n)}catch(h){if(F.$4k(h)!==F.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof M.$yN)throw o;if(o instanceof F.$Zk)switch(o.code){case F.FileSystemProviderErrorCode.FileExists:throw M.$yN.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw M.$yN.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw M.$yN.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw M.$yN.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw M.$yN.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw M.$yN.Unavailable(o.message);default:throw new M.$yN(o.message,o.name)}if(!(o instanceof Error))throw new M.$yN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw M.$yN.Unavailable(o.message);switch(o.name){case F.FileSystemProviderErrorCode.FileExists:throw M.$yN.FileExists(o.message);case F.FileSystemProviderErrorCode.FileNotFound:throw M.$yN.FileNotFound(o.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw M.$yN.FileNotADirectory(o.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw M.$yN.FileIsADirectory(o.message);case F.FileSystemProviderErrorCode.NoPermissions:throw M.$yN.NoPermissions(o.message);case F.FileSystemProviderErrorCode.Unavailable:throw M.$yN.Unavailable(o.message);default:throw new M.$yN(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?E.$Kg:E.$Mg,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$Kg}};e.$6ic=p,e.$6ic=p=w=Je([qe(0,m.$AO),qe(1,d.$Gic)],p),e.$7ic=(0,R.$hi)("IExtHostConsumerFileSystem")}),define(Me[247],Re([1,0,4,7]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class M{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$gM.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(R);if(!d)throw new Error("Issue request handler not found");const k=await d.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(R);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueData(m);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(R);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueTemplate(m);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(R,m){const d=R.identifier.value;return this.a.set(d,m),this.c.$registerIssueUriRequestHandler(d),new F.$iM(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(R,m){const d=R.identifier.value;return this.b.set(d,m),this.c.$registerIssueDataProvider(d),new F.$iM(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$0jc=M}),define(Me[85],Re([1,0,3,27,13,63,2]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=e.$8ic=void 0,e.$8ic=(0,S.$hi)("IExtensionStoragePaths");let m=class{constructor(k,O,E){this.d=O,this.f=E,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$9ic=m,e.$9ic=m=Je([qe(0,F.$QO),qe(1,M.$Nj),qe(2,N.$7ic)],m)}),define(Me[248],Re([1,0,7,17,5]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;let N=class{constructor(m){this.a=new S.$IN(S.ColorThemeKind.Dark),this.b=new M.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let d;switch(m){case"light":d=S.ColorThemeKind.Light;break;case"hcDark":d=S.ColorThemeKind.HighContrast;break;case"hcLight":d=S.ColorThemeKind.HighContrastLight;break;default:d=S.ColorThemeKind.Dark}this.a=new S.$IN(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Akc=N,e.$Akc=N=Je([qe(0,F.$AO)],N)}),define(Me[86],Re([1,0,25,5,6,173,3,13,202,4,27,17,7]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Ab=e.$9Ab=e.TunnelDtoConverter=void 0;class w extends d.$5v{}var p;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==d.TunnelPrivacyId.ConstantPrivate&&i.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$9Ab=(0,R.$hi)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(s,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(k.$gM.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,s.displayName);if(i){const c=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,i),new l.$iM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,c,h){const t=[];for(const u of s){const g=this.r.get(u);if(!g)return[];t.push(...await Promise.all(n.map(async a=>{let b;try{b=await g.provider.providePortAttributes({port:a,pid:i,commandLine:c},h)}catch{b=await g.provider.providePortAttributes(a,i,c,h)}return{providedAttributes:b,port:a}})))}const v=t.filter(u=>!!u.providedAttributes);return v.length>0?v.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await s.provideTunnel(c,h,S.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:h}),p.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),i=s.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$0Ab=r,e.$0Ab=r=Je([qe(0,E.$AO),qe(1,O.$QO),qe(2,m.$Nj)],r)}),define(Me[8],Re([1,0,18,23,131,249,53,28,123,52,69,26,126,24,16,2,29,87,100,105,104,83,49,60,221,22,7]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v,u,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$xO=L,e.$yO=re,e.$zO=ue;var b;(function(be){function Pe(Y){const{selectionStartLineNumber:ke,selectionStartColumn:Ue,positionLineNumber:Ze,positionColumn:Ke}=Y,ut=new a.$jM(ke-1,Ue-1),wt=new a.$jM(Ze-1,Ke-1);return new a.$lM(ut,wt)}be.to=Pe;function ae(Y){const{anchor:ke,active:Ue}=Y;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}be.from=ae})(b||(e.Selection=b={}));var f;(function(be){function Pe(Y){if(!Y)return;const{start:ke,end:Ue}=Y;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}be.from=Pe;function ae(Y){if(!Y)return;const{startLineNumber:ke,startColumn:Ue,endLineNumber:Ze,endColumn:Ke}=Y;return new a.$kM(ke-1,Ue-1,Ze-1,Ke-1)}be.to=ae})(f||(e.Range=f={}));var I;(function(be){function Pe(Y){return{uri:Y.uri,range:f.from(Y.range)}}be.from=Pe;function ae(Y){return new a.$uM(r.URI.revive(Y.uri),f.to(Y.range))}be.to=ae})(I||(e.Location=I={}));var $;(function(be){function Pe(ae){switch(ae){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}be.to=Pe})($||(e.TokenType=$={}));var D;(function(be){function Pe(Y){return new a.$jM(Y.lineNumber-1,Y.column-1)}be.to=Pe;function ae(Y){return{lineNumber:Y.line+1,column:Y.character+1}}be.from=ae})(D||(e.Position=D={}));var y;(function(be){function Pe(ke,Ue,Ze){return(0,S.$Hb)((0,S.$3b)(ke).map(Ke=>ae(Ke,Ue,Ze)))}be.from=Pe;function ae(ke,Ue,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:Y(ke.scheme,Ue),pattern:$e.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function Y(ke,Ue){return Ue&&typeof ke=="string"?Ue.transformOutgoingScheme(ke):ke}})(y||(e.DocumentSelector=y={}));var C;(function(be){function Pe(Y){switch(Y){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}be.from=Pe;function ae(Y){switch(Y){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}be.to=ae})(C||(e.DiagnosticTag=C={}));var A;(function(be){function Pe(Y){let ke;return Y.code&&((0,p.$Uf)(Y.code)||(0,p.$Yf)(Y.code)?ke=String(Y.code):ke={value:String(Y.code.value),target:Y.code.target}),{...f.from(Y.range),message:Y.message,source:Y.source,code:ke,severity:T.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(G.from),tags:Array.isArray(Y.tags)?(0,S.$Hb)(Y.tags.map(C.from)):void 0}}be.from=Pe;function ae(Y){const ke=new a.$wM(f.to(Y),Y.message,T.to(Y.severity));return ke.source=Y.source,ke.code=(0,p.$Uf)(Y.code)?Y.code:Y.code?.value,ke.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(G.to),ke.tags=Y.tags&&(0,S.$Hb)(Y.tags.map(C.to)),ke}be.to=ae})(A||(e.Diagnostic=A={}));var G;(function(be){function Pe(Y){return{...f.from(Y.location.range),message:Y.message,resource:Y.location.uri}}be.from=Pe;function ae(Y){return new a.$vM(new a.$uM(Y.resource,f.to(Y)),Y.message)}be.to=ae})(G||(e.DiagnosticRelatedInformation=G={}));var T;(function(be){function Pe(Y){switch(Y){case a.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}be.from=Pe;function ae(Y){switch(Y){case n.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}be.to=ae})(T||(e.DiagnosticSeverity=T={}));var V;(function(be){function Pe(Y){return typeof Y=="number"&&Y>=a.ViewColumn.One?Y-1:Y===a.ViewColumn.Beside?u.$zD:u.$yD}be.from=Pe;function ae(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(V||(e.ViewColumn=V={}));function P(be){return typeof be.range<"u"}function L(be){return be.length===0?!0:!!P(be[0])}var q;(function(be){function Pe(Ke){return Ke.map(be.from)}be.fromMany=Pe;function ae(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Y(Ke){let ut;if(ae(Ke)){const{language:At,value:Tt}=Ke;ut={value:"```"+At+`
`+Tt+"\n```\n"}}else a.$JM.isMarkdownString(Ke)?ut={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ut={value:Ke}:ut={value:""};const wt=Object.create(null);ut.uris=wt;const bt=At=>{try{let Tt=r.URI.parse(At,!0);Tt=Tt.with({query:ke(Tt.query,wt)}),wt[At]=Tt}catch{}return""},Zt=new d.marked.Renderer;return Zt.link=bt,Zt.image=At=>typeof At=="string"?bt(R.$Mk(At).href):"",(0,d.marked)(ut.value,{renderer:Zt}),ut}be.from=Y;function ke(Ke,ut){if(!Ke)return Ke;let wt;try{wt=(0,k.$Ph)(Ke)}catch{}if(!wt)return Ke;let bt=!1;return wt=(0,E.$Pn)(wt,Zt=>{if(r.URI.isUri(Zt)){const At=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[At]=Zt,bt=!0,At}else return}),bt?JSON.stringify(wt):Ke}function Ue(Ke){const ut=new a.$JM(Ke.value,Ke.supportThemeIcons);return ut.isTrusted=Ke.isTrusted,ut.supportHtml=Ke.supportHtml,ut.baseUri=Ke.baseUri?r.URI.from(Ke.baseUri):void 0,ut}be.to=Ue;function Ze(Ke){if(Ke)return typeof Ke=="string"?Ke:be.from(Ke)}be.fromStrict=Ze})(q||(e.MarkdownString=q={}));function re(be){return L(be)?be.map(Pe=>({range:f.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?q.fromMany(Pe.hoverMessage):Pe.hoverMessage?q.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):be.map(Pe=>({range:f.from(Pe)}))}function ue(be){return typeof be>"u"?be:typeof be=="string"?r.URI.file(be):be}var ye;(function(be){function Pe(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ue(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Pe})(ye||(e.ThemableDecorationAttachmentRenderOptions=ye={}));var Se;(function(be){function Pe(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ue(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ye.from(ae.before):void 0,after:ae.after?ye.from(ae.after):void 0}}be.from=Pe})(Se||(e.ThemableDecorationRenderOptions=Se={}));var le;(function(be){function Pe(ae){if(typeof ae>"u")return ae;switch(ae){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Pe})(le||(e.DecorationRangeBehavior=le={}));var we;(function(be){function Pe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?le.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?Se.from(ae.light):void 0,dark:ae.dark?Se.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ue(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?ye.from(ae.before):void 0,after:ae.after?ye.from(ae.after):void 0}}be.from=Pe})(we||(e.DecorationRenderOptions=we={}));var _;(function(be){function Pe(Y){return{text:Y.newText,eol:Y.newEol&&st.from(Y.newEol),range:f.from(Y.range)}}be.from=Pe;function ae(Y){const ke=new a.$pM(f.to(Y.range),Y.text);return ke.newEol=typeof Y.eol>"u"?void 0:st.to(Y.eol),ke}be.to=ae})(_||(e.TextEdit=_={}));var ve;(function(be){function Pe(Y,ke){const Ue={edits:[]};if(Y instanceof a.$sM){const Ze=new m.$Cc;for(const Ke of Y._allEntries())Ke._type===1&&r.URI.isUri(Ke.to)&&Ke.from===void 0&&Ze.add(Ke.to);for(const Ke of Y._allEntries())if(Ke._type===1){let ut;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ut={type:"base64",value:(0,F.$Oe)(F.$ue.wrap(Ke.options.contents))}:ut={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ue.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ut},metadata:Ke.metadata})}else Ke._type===2?Ue.edits.push({resource:Ke.uri,textEdit:_.from(Ke.edit),versionId:Ze.has(Ke.uri)?void 0:ke?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ue.edits.push({resource:Ke.uri,textEdit:{range:f.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ke.uri)?void 0:ke?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(ei.from)}})}return Ue}be.from=Pe;function ae(Y){const ke=new a.$sM,Ue=new m.$Bc;for(const Ze of Y.edits)if(Ze.textEdit){const Ke=Ze,ut=r.URI.revive(Ke.resource),wt=f.to(Ke.textEdit.range),bt=Ke.textEdit.text,Zt=Ke.textEdit.insertAsSnippet;let At;Zt?At=a.$rM.replace(wt,new a.$tM(bt)):At=a.$pM.replace(wt,bt);const Tt=Ue.get(ut);Tt?Tt.push(At):Ue.set(ut,[At])}else ke.renameFile(r.URI.revive(Ze.oldResource),r.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ke]of Ue)ke.set(Ze,Ke);return ke}be.to=ae})(ve||(e.WorkspaceEdit=ve={}));var ne;(function(be){const Pe=Object.create(null);Pe[a.SymbolKind.File]=0,Pe[a.SymbolKind.Module]=1,Pe[a.SymbolKind.Namespace]=2,Pe[a.SymbolKind.Package]=3,Pe[a.SymbolKind.Class]=4,Pe[a.SymbolKind.Method]=5,Pe[a.SymbolKind.Property]=6,Pe[a.SymbolKind.Field]=7,Pe[a.SymbolKind.Constructor]=8,Pe[a.SymbolKind.Enum]=9,Pe[a.SymbolKind.Interface]=10,Pe[a.SymbolKind.Function]=11,Pe[a.SymbolKind.Variable]=12,Pe[a.SymbolKind.Constant]=13,Pe[a.SymbolKind.String]=14,Pe[a.SymbolKind.Number]=15,Pe[a.SymbolKind.Boolean]=16,Pe[a.SymbolKind.Array]=17,Pe[a.SymbolKind.Object]=18,Pe[a.SymbolKind.Key]=19,Pe[a.SymbolKind.Null]=20,Pe[a.SymbolKind.EnumMember]=21,Pe[a.SymbolKind.Struct]=22,Pe[a.SymbolKind.Event]=23,Pe[a.SymbolKind.Operator]=24,Pe[a.SymbolKind.TypeParameter]=25;function ae(ke){return typeof Pe[ke]=="number"?Pe[ke]:6}be.from=ae;function Y(ke){for(const Ue in Pe)if(Pe[Ue]===ke)return Number(Ue);return a.SymbolKind.Property}be.to=Y})(ne||(e.SymbolKind=ne={}));var fe;(function(be){function Pe(Y){switch(Y){case a.SymbolTag.Deprecated:return 1}}be.from=Pe;function ae(Y){switch(Y){case 1:return a.SymbolTag.Deprecated}}be.to=ae})(fe||(e.SymbolTag=fe={}));var W;(function(be){function Pe(Y){return{name:Y.name,kind:ne.from(Y.kind),tags:Y.tags&&Y.tags.map(fe.from),containerName:Y.containerName,location:pe.from(Y.location)}}be.from=Pe;function ae(Y){const ke=new a.$AM(Y.name,ne.to(Y.kind),Y.containerName,pe.to(Y.location));return ke.tags=Y.tags&&Y.tags.map(fe.to),ke}be.to=ae})(W||(e.WorkspaceSymbol=W={}));var te;(function(be){function Pe(Y){const ke={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:f.from(Y.range),selectionRange:f.from(Y.selectionRange),kind:ne.from(Y.kind),tags:Y.tags?.map(fe.from)??[]};return Y.children&&(ke.children=Y.children.map(Pe)),ke}be.from=Pe;function ae(Y){const ke=new a.$BM(Y.name,Y.detail,ne.to(Y.kind),f.to(Y.range),f.to(Y.selectionRange));return(0,S.$Lb)(Y.tags)&&(ke.tags=Y.tags.map(fe.to)),Y.children&&(ke.children=Y.children.map(ae)),ke}be.to=ae})(te||(e.DocumentSymbol=te={}));var Ee;(function(be){function Pe(Y){const ke=new a.$FM(ne.to(Y.kind),Y.name,Y.detail||"",r.URI.revive(Y.uri),f.to(Y.range),f.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}be.to=Pe;function ae(Y,ke,Ue){if(ke=ke??Y._sessionId,Ue=Ue??Y._itemId,ke===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ue,name:Y.name,detail:Y.detail,kind:ne.from(Y.kind),uri:Y.uri,range:f.from(Y.range),selectionRange:f.from(Y.selectionRange),tags:Y.tags?.map(fe.from)}}be.from=ae})(Ee||(e.CallHierarchyItem=Ee={}));var Te;(function(be){function Pe(ae){return new a.$GM(Ee.to(ae.from),ae.fromRanges.map(Y=>f.to(Y)))}be.to=Pe})(Te||(e.CallHierarchyIncomingCall=Te={}));var Ie;(function(be){function Pe(ae){return new a.$HM(Ee.to(ae.to),ae.fromRanges.map(Y=>f.to(Y)))}be.to=Pe})(Ie||(e.CallHierarchyOutgoingCall=Ie={}));var pe;(function(be){function Pe(Y){return{range:Y.range&&f.from(Y.range),uri:Y.uri}}be.from=Pe;function ae(Y){return new a.$uM(r.URI.revive(Y.uri),f.to(Y.range))}be.to=ae})(pe||(e.location=pe={}));var ge;(function(be){function Pe(Y){const ke=Y,Ue=Y;return{originSelectionRange:ke.originSelectionRange?f.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ue.uri,range:f.from(ke.targetRange?ke.targetRange:Ue.range),targetSelectionRange:ke.targetSelectionRange?f.from(ke.targetSelectionRange):void 0}}be.from=Pe;function ae(Y){return{targetUri:r.URI.revive(Y.uri),targetRange:f.to(Y.range),targetSelectionRange:Y.targetSelectionRange?f.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?f.to(Y.originSelectionRange):void 0}}be.to=ae})(ge||(e.DefinitionLink=ge={}));var J;(function(be){function Pe(Y){return{range:f.from(Y.range),contents:q.fromMany(Y.contents)}}be.from=Pe;function ae(Y){return new a.$xM(Y.contents.map(q.to),f.to(Y.range))}be.to=ae})(J||(e.Hover=J={}));var X;(function(be){function Pe(Y){return{range:f.from(Y.range),expression:Y.expression}}be.from=Pe;function ae(Y){return new a.$sN(f.to(Y.range),Y.expression)}be.to=ae})(X||(e.EvaluatableExpression=X={}));var ce;(function(be){function Pe(Y){if(Y instanceof a.$tN)return{type:"text",range:f.from(Y.range),text:Y.text};if(Y instanceof a.$uN)return{type:"variable",range:f.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof a.$vN)return{type:"expression",range:f.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Pe;function ae(Y){switch(Y.type){case"text":return{range:f.to(Y.range),text:Y.text};case"variable":return{range:f.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:f.to(Y.range),expression:Y.expression}}}be.to=ae})(ce||(e.InlineValue=ce={}));var de;(function(be){function Pe(Y){return{frameId:Y.frameId,stoppedLocation:f.from(Y.stoppedLocation)}}be.from=Pe;function ae(Y){return new a.$wN(Y.frameId,f.to(Y.stoppedLocation))}be.to=ae})(de||(e.InlineValueContext=de={}));var Oe;(function(be){function Pe(Y){return{range:f.from(Y.range),kind:Y.kind}}be.from=Pe;function ae(Y){return new a.$yM(f.to(Y.range),Y.kind)}be.to=ae})(Oe||(e.DocumentHighlight=Oe={}));var he;(function(be){function Pe(Y){return{uri:Y.uri,highlights:Y.highlights.map(Oe.from)}}be.from=Pe;function ae(Y){return new a.$zM(r.URI.revive(Y.uri),Y.highlights.map(Oe.to))}be.to=ae})(he||(e.MultiDocumentHighlight=he={}));var Ce;(function(be){function Pe(ae){switch(ae){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}be.to=Pe})(Ce||(e.CompletionTriggerKind=Ce={}));var Ae;(function(be){function Pe(ae){return{triggerKind:Ce.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Pe})(Ae||(e.CompletionContext=Ae={}));var Le;(function(be){function Pe(Y){switch(Y){case a.CompletionItemTag.Deprecated:return 1}}be.from=Pe;function ae(Y){switch(Y){case 1:return a.CompletionItemTag.Deprecated}}be.to=ae})(Le||(e.CompletionItemTag=Le={}));var U;(function(be){const Pe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ae(Ue){return Pe.get(Ue)??9}be.from=ae;const Y=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function ke(Ue){return Y.get(Ue)??a.CompletionItemKind.Property}be.to=ke})(U||(e.CompletionItemKind=U={}));var z;(function(be){function Pe(ae,Y){const ke=new a.$PM(ae.label);return ke.insertText=ae.insertText,ke.kind=U.to(ae.kind),ke.tags=ae.tags?.map(Le.to),ke.detail=ae.detail,ke.documentation=R.$Gk(ae.documentation)?q.to(ae.documentation):ae.documentation,ke.sortText=ae.sortText,ke.filterText=ae.filterText,ke.preselect=ae.preselect,ke.commitCharacters=ae.commitCharacters,o.$at.isIRange(ae.range)?ke.range=f.to(ae.range):typeof ae.range=="object"&&(ke.range={inserting:f.to(ae.range.insert),replacing:f.to(ae.range.replace)}),ke.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?ke.insertText=new a.$tM(ae.insertText):(ke.insertText=ae.insertText,ke.textEdit=ke.range instanceof a.$kM?new a.$pM(ke.range,ke.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ke.additionalTextEdits=ae.additionalTextEdits.map(Ue=>_.to(Ue))),ke.command=Y&&ae.command?Y.fromInternal(ae.command):void 0,ke}be.to=Pe})(z||(e.CompletionItem=z={}));var K;(function(be){function Pe(Y){if(typeof Y.label!="string"&&!Array.isArray(Y.label))throw new TypeError("Invalid label");return{label:Y.label,documentation:q.fromStrict(Y.documentation)}}be.from=Pe;function ae(Y){return{label:Y.label,documentation:R.$Gk(Y.documentation)?q.to(Y.documentation):Y.documentation}}be.to=ae})(K||(e.ParameterInformation=K={}));var H;(function(be){function Pe(Y){return{label:Y.label,documentation:q.fromStrict(Y.documentation),parameters:Array.isArray(Y.parameters)?Y.parameters.map(K.from):[],activeParameter:Y.activeParameter}}be.from=Pe;function ae(Y){return{label:Y.label,documentation:R.$Gk(Y.documentation)?q.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(K.to):[],activeParameter:Y.activeParameter}}be.to=ae})(H||(e.SignatureInformation=H={}));var ee;(function(be){function Pe(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(H.from):[]}}be.from=Pe;function ae(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(H.to):[]}}be.to=ae})(ee||(e.SignatureHelp=ee={}));var se;(function(be){function Pe(ae,Y){const ke=new a.$OM(D.to(Y.position),typeof Y.label=="string"?Y.label:Y.label.map(Ne.to.bind(void 0,ae)),Y.kind&&Ve.to(Y.kind));return ke.textEdits=Y.textEdits&&Y.textEdits.map(_.to),ke.tooltip=R.$Gk(Y.tooltip)?q.to(Y.tooltip):Y.tooltip,ke.paddingLeft=Y.paddingLeft,ke.paddingRight=Y.paddingRight,ke}be.to=Pe})(se||(e.InlayHint=se={}));var Ne;(function(be){function Pe(ae,Y){const ke=new a.$NM(Y.label);return ke.tooltip=R.$Gk(Y.tooltip)?q.to(Y.tooltip):Y.tooltip,s.Command.is(Y.command)&&(ke.command=ae.fromInternal(Y.command)),Y.location&&(ke.location=pe.to(Y.location)),ke}be.to=Pe})(Ne||(e.InlayHintLabelPart=Ne={}));var Ve;(function(be){function Pe(Y){return Y}be.from=Pe;function ae(Y){return Y}be.to=ae})(Ve||(e.InlayHintKind=Ve={}));var Ye;(function(be){function Pe(Y){return{range:f.from(Y.range),url:Y.target,tooltip:Y.tooltip}}be.from=Pe;function ae(Y){let ke;if(Y.url)try{ke=typeof Y.url=="string"?r.URI.parse(Y.url,!0):r.URI.revive(Y.url)}catch{}return new a.$UM(f.to(Y.range),ke)}be.to=ae})(Ye||(e.DocumentLink=Ye={}));var xe;(function(be){function Pe(Y){const ke=new a.$XM(Y.label);return Y.textEdit&&(ke.textEdit=_.to(Y.textEdit)),Y.additionalTextEdits&&(ke.additionalTextEdits=Y.additionalTextEdits.map(Ue=>_.to(Ue))),ke}be.to=Pe;function ae(Y){return{label:Y.label,textEdit:Y.textEdit?_.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(ke=>_.from(ke)):void 0}}be.from=ae})(xe||(e.ColorPresentation=xe={}));var et;(function(be){function Pe(Y){return new a.$VM(Y[0],Y[1],Y[2],Y[3])}be.to=Pe;function ae(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}be.from=ae})(et||(e.Color=et={}));var ot;(function(be){function Pe(Y){return{range:f.from(Y.range)}}be.from=Pe;function ae(Y){return new a.$EM(f.to(Y.range))}be.to=ae})(ot||(e.SelectionRange=ot={}));var rt;(function(be){function Pe(ae){switch(ae){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}be.to=Pe})(rt||(e.TextDocumentSaveReason=rt={}));var tt;(function(be){function Pe(Y){switch(Y){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.Interval:return 3;case a.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Pe;function ae(Y){switch(Y){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 3:return a.TextEditorLineNumbersStyle.Interval;case 1:default:return a.TextEditorLineNumbersStyle.On}}be.to=ae})(tt||(e.TextEditorLineNumbersStyle=tt={}));var st;(function(be){function Pe(Y){if(Y===a.EndOfLine.CRLF)return 1;if(Y===a.EndOfLine.LF)return 0}be.from=Pe;function ae(Y){if(Y===1)return a.EndOfLine.CRLF;if(Y===0)return a.EndOfLine.LF}be.to=ae})(st||(e.EndOfLine=st={}));var Be;(function(be){function Pe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Pe})(Be||(e.ProgressLocation=Be={}));var it;(function(be){function Pe(Y){const ke={start:Y.start+1,end:Y.end+1};return Y.kind&&(ke.kind=Q.from(Y.kind)),ke}be.from=Pe;function ae(Y){const ke={start:Y.start-1,end:Y.end-1};return Y.kind&&(ke.kind=Q.to(Y.kind)),ke}be.to=ae})(it||(e.FoldingRange=it={}));var Q;(function(be){function Pe(Y){if(Y)switch(Y){case a.FoldingRangeKind.Comment:return s.$5t.Comment;case a.FoldingRangeKind.Imports:return s.$5t.Imports;case a.FoldingRangeKind.Region:return s.$5t.Region}}be.from=Pe;function ae(Y){if(Y)switch(Y.value){case s.$5t.Comment.value:return a.FoldingRangeKind.Comment;case s.$5t.Imports.value:return a.FoldingRangeKind.Imports;case s.$5t.Region.value:return a.FoldingRangeKind.Region}}be.to=ae})(Q||(e.FoldingRangeKind=Q={}));var Z;(function(be){function Pe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?f.from(ae.selection):void 0,override:typeof ae.override=="boolean"?c.$2E.id:void 0}}be.from=Pe})(Z||(e.TextEditorOpenOptions=Z={}));var $e;(function(be){function Pe(Ue){return Ue instanceof a.$gN?Ue.toJSON():typeof Ue=="string"?Ue:ae(Ue)||Y(Ue)?new a.$gN(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}be.from=Pe;function ae(Ue){const Ze=Ue;return Ze?r.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Y(Ue){const Ze=Ue;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(Ue){return typeof Ue=="string"?Ue:new a.$gN(r.URI.revive(Ue.baseUri),Ue.pattern)}be.to=ke})($e||(e.GlobPattern=$e={}));var We;(function(be){function Pe(ae){if(ae){if(Array.isArray(ae))return ae.map(Pe);if(typeof ae=="string")return ae;{const Y=ae;return{language:Y.language,scheme:Y.scheme,pattern:$e.from(Y.pattern),exclusive:Y.exclusive,notebookType:Y.notebookType}}}else return}be.from=Pe})(We||(e.LanguageSelector=We={}));var Qe;(function(be){function Pe(Y){return!!Y&&typeof Y=="object"&&"documents"in Y&&Array.isArray(Y.documents)&&Y.documents.every(ke=>Array.isArray(ke)&&ke.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&r.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ze=>Ze instanceof a.$kM)))}be.is=Pe;function ae(Y){return{documents:Y.documents.map(ke=>ke.map(Ue=>({uri:r.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>f.from(Ze))})))}}be.from=ae})(Qe||(e.MappedEditsContext=Qe={}));var at;(function(be){function Pe(Y){return{start:Y.start,end:Y.end}}be.from=Pe;function ae(Y){return new a.$JN(Y.start,Y.end)}be.to=ae})(at||(e.NotebookRange=at={}));var Fe;(function(be){function Pe(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}be.to=Pe;function ae(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}be.from=ae})(Fe||(e.NotebookCellExecutionSummary=Fe={}));var Ct;(function(be){function Pe(ae){if(ae===h.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ae===h.NotebookCellExecutionState.Pending)return;if(ae===h.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Pe})(Ct||(e.NotebookCellExecutionState=Ct={}));var Lt;(function(be){function Pe(Y){switch(Y){case a.NotebookCellKind.Markup:return h.CellKind.Markup;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=Pe;function ae(Y){switch(Y){case h.CellKind.Markup:return a.NotebookCellKind.Markup;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}be.to=ae})(Lt||(e.NotebookCellKind=Lt={}));var Xt;(function(be){function Pe(Y){const ke={metadata:Y.metadata??Object.create(null),cells:[]};for(const Ue of Y.cells)a.$KN.validate(Ue),ke.cells.push(ei.from(Ue));return ke}be.from=Pe;function ae(Y){const ke=new a.$LN(Y.cells.map(ei.to));return(0,p.$8f)(Y.metadata)||(ke.metadata=Y.metadata),ke}be.to=ae})(Xt||(e.NotebookData=Xt={}));var ei;(function(be){function Pe(Y){return{cellKind:Lt.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Fe.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(Dt.from):[]}}be.from=Pe;function ae(Y){return new a.$KN(Lt.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(Dt.to):void 0,Y.metadata,Y.internalMetadata?Fe.to(Y.internalMetadata):void 0)}be.to=ae})(ei||(e.NotebookCellData=ei={}));var zt;(function(be){function Pe(Y){return{mime:Y.mime,valueBytes:F.$ue.wrap(Y.data)}}be.from=Pe;function ae(Y){return new a.$MN(Y.valueBytes.buffer,Y.mime)}be.to=ae})(zt||(e.NotebookCellOutputItem=zt={}));var Dt;(function(be){function Pe(Y){return{outputId:Y.id,items:Y.items.map(zt.from),metadata:Y.metadata}}be.from=Pe;function ae(Y){const ke=Y.items.map(zt.to);return new a.$NN(ke,Y.outputId,Y.metadata)}be.to=ae})(Dt||(e.NotebookCellOutput=Dt={}));var ti;(function(be){function Pe(ke){return Y(ke)?{include:$e.from(ke.include)??void 0,exclude:$e.from(ke.exclude)??void 0}:$e.from(ke)??void 0}be.from=Pe;function ae(ke){return Y(ke)?{include:$e.to(ke.include),exclude:$e.to(ke.exclude)}:$e.to(ke)}be.to=ae;function Y(ke){const Ue=ke;return Ue?!(0,p.$4f)(Ue.include)&&!(0,p.$4f)(Ue.exclude):!1}})(ti||(e.NotebookExclusiveDocumentPattern=ti={}));var Ut;(function(be){function Pe(ae,Y,ke){const Ue=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(Ue,ke),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Pe})(Ut||(e.NotebookStatusBarItem=Ut={}));var ri;(function(be){function Pe(ae,Y,ke){const Ue=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Y.toInternal(Ue,ke),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Pe})(ri||(e.NotebookKernelSourceAction=ri={}));var ii;(function(be){function Pe(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Pe})(ii||(e.NotebookDocumentContentOptions=ii={}));var Xe;(function(be){function Pe(Y){return{uri:Y.uri,provides:Y.provides}}be.from=Pe;function ae(Y){return new a.$PN(r.URI.revive(Y.uri),Y.provides)}be.to=ae})(Xe||(e.NotebookRendererScript=Xe={}));var Qt;(function(be){function Pe(Y){return{message:q.fromStrict(Y.message)||"",type:0,expected:Y.expectedOutput,actual:Y.actualOutput,contextValue:Y.contextValue,location:Y.location&&{range:f.from(Y.location.range),uri:Y.location.uri}}}be.from=Pe;function ae(Y){const ke=new a.$VN(typeof Y.message=="string"?Y.message:q.to(Y.message));return ke.actualOutput=Y.actual,ke.expectedOutput=Y.expected,ke.contextValue=Y.contextValue,ke.location=Y.location?pe.to(Y.location):void 0,ke}be.to=ae})(Qt||(e.TestMessage=Qt={}));var Bt;(function(be){be.namespace=v.$0K,be.denamespace=v.$$K})(Bt||(e.TestTag=Bt={}));var ht;(function(be){function Pe(Y){const ke=(0,i.$wO)(Y).controllerId;return{extId:t.$5K.fromExtHostTestItem(Y,ke).toString(),label:Y.label,uri:r.URI.revive(Y.uri),busy:Y.busy,tags:Y.tags.map(Ue=>Bt.namespace(ke,Ue.id)),range:o.$at.lift(f.from(Y.range)),description:Y.description||null,sortText:Y.sortText||null,error:Y.error&&q.fromStrict(Y.error)||null}}be.from=Pe;function ae(Y){return{parent:void 0,error:void 0,id:t.$5K.fromString(Y.extId).localId,label:Y.label,uri:r.URI.revive(Y.uri),tags:(Y.tags||[]).map(ke=>{const{tagId:Ue}=Bt.denamespace(ke);return new a.$WN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:f.to(Y.range||void 0),canResolveChildren:!1,busy:Y.busy,description:Y.description||void 0,sortText:Y.sortText||void 0}}be.toPlain=ae})(ht||(e.TestItem=ht={})),function(be){function Pe(Y){return{id:Y.id}}be.from=Pe;function ae(Y){return new a.$WN(Y.id)}be.to=ae}(Bt||(e.TestTag=Bt={}));var mt;(function(be){const Pe=(Y,ke)=>{const Ue=Y.value;if(!Ue)return;const Ze={...ht.toPlain(Ue.item),parent:ke,taskStates:Ue.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ut=>ut.type===0).map(Qt.to)})),children:[]};if(Y.children)for(const Ke of Y.children.values()){const ut=Pe(Ke,Ze);ut&&Ze.children.push(ut)}return Ze};function ae(Y){const ke=new l.$pO;for(const Ke of Y.items)ke.insert(t.$5K.fromString(Ke.item.extId).path,Ke);const Ue=[ke.nodes],Ze=[];for(;Ue.length;)for(const Ke of Ue.pop())Ke.value?Ze.push(Ke):Ke.children&&Ue.push(Ke.children.values());return{completedAt:Y.completedAt,results:Ze.map(Ke=>Pe(Ke)).filter(p.$3f)}}be.to=ae})(mt||(e.TestResults=mt={}));var ni;(function(be){function Pe(Ue){return{covered:Ue.covered,total:Ue.total}}function ae(Ue){return"line"in Ue?D.from(Ue):f.from(Ue)}function Y(Ue){return"branches"in Ue?{count:Ue.executed,location:ae(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:ae(Ue.location)}}be.fromDetailed=Y;function ke(Ue){return{uri:Ue.uri,statement:Pe(Ue.statementCoverage),branch:Ue.branchCoverage&&Pe(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Pe(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(Y)}}be.fromFile=ke})(ni||(e.TestCoverage=ni={}));var Vt;(function(be){function Pe(ae){switch(ae){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}be.to=Pe})(Vt||(e.CodeActionTriggerKind=Vt={}));var Wt;(function(be){function Pe(Y){const ke=new a.$3N(ne.to(Y.kind),Y.name,Y.detail||"",r.URI.revive(Y.uri),f.to(Y.range),f.to(Y.selectionRange));return ke._sessionId=Y._sessionId,ke._itemId=Y._itemId,ke}be.to=Pe;function ae(Y,ke,Ue){if(ke=ke??Y._sessionId,Ue=Ue??Y._itemId,ke===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ue,kind:ne.from(Y.kind),name:Y.name,detail:Y.detail??"",uri:Y.uri,range:f.from(Y.range),selectionRange:f.from(Y.selectionRange),tags:Y.tags?.map(fe.from)}}be.from=ae})(Wt||(e.TypeHierarchyItem=Wt={}));var dt;(function(be){function Pe(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Pe})(dt||(e.ViewBadge=dt={}));var St;(function(be){function Pe(Ue,Ze,Ke){const ut=Ze.fileData;return ut?new a.$$M(new a.$_M(ut.name,r.URI.revive(ut.uri),ut.id,(0,N.$db)(()=>Ke(ut.id)))):Ue===O.$xs.uriList&&Ze.uriListData?new a.$0M(ke(Ze.uriListData)):new a.$0M(Ze.asString)}be.to=Pe;async function ae(Ue,Ze){const Ke=await Ze.asString();if(Ue===O.$xs.uriList)return{asString:Ke,fileData:void 0,uriListData:Y(Ke)};const ut=Ze.asFile();return{asString:Ke,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}be.from=ae;function Y(Ue){return M.$Jt.split(Ue).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return r.URI.parse(Ze)}catch{}return Ze})}function ke(Ue){return M.$Jt.create(Ue.map(Ze=>typeof Ze=="string"?Ze:r.URI.revive(Ze)))}})(St||(e.DataTransferItem=St={}));var si;(function(be){function Pe(Y,ke){const Ue=Y.items.map(([Ze,Ke])=>[Ze,St.to(Ze,Ke,ke)]);return new a.$aN(Ue)}be.toDataTransfer=Pe;async function ae(Y){const ke={items:[]},Ue=[];for(const[Ze,Ke]of Y)Ue.push((async()=>{ke.items.push([Ze,await St.from(Ze,Ke)])})());return await Promise.all(Ue),ke}be.from=ae})(si||(e.DataTransfer=si={}));var xt;(function(be){function Pe(Y,ke){return{kind:"reply",agentId:Y.participant??ke?.agentId??"",subCommand:Y.command??ke?.command,message:Y.prompt,title:Y.label}}be.from=Pe;function ae(Y){return{prompt:Y.message,label:Y.title,participant:Y.agentId,command:Y.subCommand}}be.to=ae})(xt||(e.ChatFollowup=xt={}));var He;(function(be){function Pe(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Pe})(He||(e.ChatInlineFollowup=He={}));var qt;(function(be){function Pe(Y){switch(Y.role){case 0:return new a.$kO(Y.content);case 1:return new a.$lO(Y.content);case 2:return new a.$mO(Y.content)}}be.to=Pe;function ae(Y){if(Y instanceof a.$kO)return{role:0,content:Y.content};if(Y instanceof a.$lO)return{role:1,content:Y.content};if(Y instanceof a.$mO)return{role:2,content:Y.content};throw new Error("Invalid LanguageModelMessage")}be.from=ae})(qt||(e.LanguageModelMessage=qt={}));var jt;(function(be){function Pe(ke){const Ue={};for(const Ze of Object.keys(ke))Ue[Ze]=ke[Ze].map(be.to);return Ue}be.objectTo=Pe;function ae(ke){return{level:Ht.to(ke.level),kind:ke.kind,value:(0,r.$wc)(ke.value)?r.URI.revive(ke.value):ke.value,description:ke.description}}be.to=ae;function Y(ke){return{level:Ht.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}be.from=Y})(jt||(e.ChatVariable=jt={}));var Ht;(function(be){function Pe(Y){switch(Y){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}be.to=Pe;function ae(Y){switch(Y){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}be.from=ae})(Ht||(e.ChatVariableLevel=Ht={}));var $t;(function(be){function Pe(ae){switch(ae){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return a.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Pe})($t||(e.InteractiveEditorResponseFeedbackKind=$t={}));var Pt;(function(be){function Pe(Y){return{kind:"markdownContent",content:q.from(Y.value)}}be.to=Pe;function ae(Y){return new a.$cO(q.to(Y.content))}be.from=ae})(Pt||(e.ChatResponseMarkdownPart=Pt={}));var Mt;(function(be){function Pe(Y){const{value:ke,baseUri:Ue}=Y;function Ze(Ke,ut){return Ke.map(wt=>{const bt=r.URI.joinPath(ut,wt.name);return{label:wt.name,uri:bt,children:wt.children&&Ze(wt.children,bt)}})}return{kind:"treeData",treeData:{label:(0,w.$Rg)(Ue),uri:Ue,children:Ze(ke,Ue)}}}be.to=Pe;function ae(Y){const ke=(0,k.$Qh)(Y.treeData);function Ue(ut){return ut.map(wt=>({name:wt.label,children:wt.children&&Ue(wt.children)}))}const Ze=ke.uri,Ke=ke.children?Ue(ke.children):[];return new a.$dO(Ke,Ze)}be.from=ae})(Mt||(e.ChatResponseFilesPart=Mt={}));var Ot;(function(be){function Pe(Y){return{kind:"inlineReference",name:Y.title,inlineReference:r.URI.isUri(Y.value)?Y.value:I.from(Y.value)}}be.to=Pe;function ae(Y){const ke=(0,k.$Qh)(Y);return new a.$eO(r.URI.isUri(ke.inlineReference)?ke.inlineReference:I.to(ke.inlineReference),Y.name)}be.from=ae})(Ot||(e.ChatResponseAnchorPart=Ot={}));var oi;(function(be){function Pe(Y){return{kind:"progressMessage",content:q.from(Y.value)}}be.to=Pe;function ae(Y){return new a.$fO(Y.content.value)}be.from=ae})(oi||(e.ChatResponseProgressPart=oi={}));var Kt;(function(be){function Pe(Y,ke,Ue){return{kind:"command",command:ke.toInternal(Y.value,Ue)??{command:Y.value.command,title:Y.value.title}}}be.to=Pe;function ae(Y,ke){return new a.$gO(ke.fromInternal(Y.command)??{command:Y.command.id,title:Y.command.title})}be.from=ae})(Kt||(e.ChatResponseCommandButtonPart=Kt={}));var Gt;(function(be){function Pe(Y){return{kind:"reference",reference:r.URI.isUri(Y.value)?Y.value:I.from(Y.value)}}be.to=Pe;function ae(Y){const ke=(0,k.$Qh)(Y);return new a.$hO(r.URI.isUri(ke.reference)?ke.reference:I.to(ke.reference))}be.from=ae})(Gt||(e.ChatResponseReferencePart=Gt={}));var yt;(function(be){function Pe(ke){return ke instanceof a.$cO?Pt.to(ke):ke instanceof a.$eO?Ot.to(ke):ke instanceof a.$hO?Gt.to(ke):ke instanceof a.$fO?oi.to(ke):ke instanceof a.$dO?Mt.to(ke):{kind:"content",content:""}}be.to=Pe;function ae(ke,Ue){switch(ke.kind){case"reference":return Gt.from(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Y(ke,Ue)}}be.from=ae;function Y(ke,Ue){switch(ke.kind){case"markdownContent":return Pt.from(ke);case"inlineReference":return Ot.from(ke);case"progressMessage":return;case"treeData":return Mt.from(ke);case"command":return Kt.from(ke,Ue)}}be.fromContent=Y})(yt||(e.ChatResponsePart=yt={}));var Rt;(function(be){function Pe(ke,Ue){return"markdownContent"in Ue?((0,g.$6F)(ke,"chatParticipantAdditions"),{content:q.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,g.$6F)(ke,"chatParticipantAdditions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,g.$6F)(ke,"chatParticipantAdditions"),{content:q.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Ke=>f.from(Ke))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:f.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:f.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"participant"in Ue?((0,g.$6F)(ke,"chatParticipantAdditions"),{agentName:Ue.participant,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:q.from(Ue.message),kind:"progressMessage"}:void 0}be.from=Pe;function ae(ke){switch(ke.kind){case"markdownContent":case"inlineReference":case"treeData":return be.to(ke);case"content":return{content:ke.content};case"usedContext":return{documents:ke.documents.map(Ue=>({uri:r.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>f.to(Ze))}))};case"reference":return{reference:(0,r.$wc)(ke.reference)?r.URI.revive(ke.reference):I.to(ke.reference)};case"agentDetection":return;case"progressMessage":return{message:ke.content.value};case"vulnerability":return{content:ke.content,vulnerabilities:ke.vulnerabilities};default:return}}be.to=ae;function Y(ke,Ue){switch(ke.kind){case"markdownContent":return{content:ke.content.value};case"inlineReference":return{inlineReference:(0,r.$wc)(ke.inlineReference)?r.URI.revive(ke.inlineReference):I.to(ke.inlineReference),title:ke.name};case"command":return{command:Ue.fromInternal(ke.command)??{command:ke.command.id,title:ke.command.title}};default:return}}be.toProgressContent=Y})(Rt||(e.ChatResponseProgress=Rt={}));var Jt;(function(be){function Pe(ae){return{prompt:ae.message,command:ae.command,variables:ae.variables.variables.map(Nt.to)}}be.to=Pe})(Jt||(e.ChatAgentRequest=Jt={}));var Nt;(function(be){function Pe(ae){return{name:ae.name,range:[ae.range.start,ae.range.endExclusive],values:ae.values.map(jt.to)}}be.to=Pe})(Nt||(e.ChatAgentResolvedVariable=Nt={}));var kt;(function(be){function Pe(ae){return{label:ae.label,values:ae.values.map(jt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Pe})(kt||(e.ChatAgentCompletionItem=kt={}));var It;(function(be){function Pe(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}be.to=Pe})(It||(e.ChatAgentResult=It={}));var Et;(function(be){function Pe(ae,Y,ke){if(Y.action.kind==="vote")return;const Ue=It.to(ae);return Y.action.kind==="command"?{action:{kind:"command",commandButton:Rt.toProgressContent(Y.action.commandButton,ke)},result:Ue}:Y.action.kind==="followUp"?{action:{kind:"followUp",followup:xt.to(Y.action.followup)},result:Ue}:{action:Y.action,result:Ue}}be.to=Pe})(Et||(e.ChatAgentUserActionEvent=Et={}));var li;(function(be){function Pe(ae,Y,ke){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Y.toInternal(ae,ke)}be.from=Pe})(li||(e.TerminalQuickFix=li={}));var _t;(function(be){function Pe(ae){return{kind:ai.to(ae.kind)}}be.to=Pe})(_t||(e.PartialAcceptInfo=_t={}));var ai;(function(be){function Pe(ae){switch(ae){case 0:return a.PartialAcceptTriggerKind.Word;case 1:return a.PartialAcceptTriggerKind.Line;case 2:return a.PartialAcceptTriggerKind.Suggest;default:return a.PartialAcceptTriggerKind.Unknown}}be.to=Pe})(ai||(e.PartialAcceptTriggerKind=ai={}));var hi;(function(be){function Pe(ae,Y){return{id:Y,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}be.from=Pe})(hi||(e.DebugTreeItem=hi={}))}),define(Me[250],Re([1,0,4,17,8]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;let N=class{constructor(m,d){this.a=m.getProxy(S.$gM.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>d.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,d,k){const O=M.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};e.$Oic=N,e.$Oic=N=Je([qe(0,F.$AO)],N)}),define(Me[251],Re([1,0,18,11,41,5,45,6,64,16,2,162,20,4,8,7,211,22]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class n{constructor(t,v,u,g,a,b){this.i=t,this.j=v,this.k=u,this.l=g,this.m=a,this.n=b,this.b=d.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let v=function(g){if(t.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,g),a}};const t=this;this.b.reset();const u=g=>{typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,g)};this.g={markdown(g){v(this.markdown);const a=new r.$cO(g),b=p.ChatResponseMarkdownPart.to(a);return u(b),this},filetree(g,a){v(this.filetree);const b=new r.$dO(g,a),f=p.ChatResponseFilesPart.to(b);return u(f),this},anchor(g,a){v(this.anchor);const b=new r.$eO(g,a),f=p.ChatResponseAnchorPart.to(b);return u(f),this},button(g){v(this.anchor);const a=new r.$gO(g),b=p.ChatResponseCommandButtonPart.to(a,t.m,t.n);return u(b),this},progress(g){v(this.progress);const a=new r.$fO(g),b=p.ChatResponseProgressPart.to(a);return u(b),this},reference(g){v(this.reference);const a=new r.$hO(g),b=p.ChatResponseReferencePart.to(a);return u(b),this},push(g){v(this.push);const a=p.ChatResponsePart.to(g);return u(a),this},report(g){if(v(this.report),"placeholder"in g&&"resolvedContent"in g)return;const a=p.ChatResponseProgress.from(t.i,g);if(!a){t.l.error("Unknown progress type: "+JSON.stringify(g));return}return u(a),this}}}return this.g}}class i{static{this.b=0}constructor(t,v,u){this.i=v,this.j=u,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(w.$gM.MainThreadChatAgents2)}createChatAgent(t,v,u){const g=i.b++,a=new c(t,v,this.d,g,u);return this.c.set(g,a),this.d.$registerAgent(g,t.identifier,v,{},(0,s.$5F)(t,"chatParticipantAdditions")),a.apiAgent}async $invokeAgent(t,v,u,g){const a=this.c.get(t);if(!a)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let b=this.g.get(v.sessionId);b||(b=new m.$Tc,this.g.set(v.sessionId,b));const f=new n(a.extension,v,this.d,this.i,this.j.converter,b);try{const I=await this.k(v.agentId,u),$=a.invoke(p.ChatAgentRequest.to(v),{history:I},f.apiObject,g);return await(0,F.$8g)(Promise.resolve($).then(D=>{if(D?.metadata)try{JSON.stringify(D.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${a.extension.identifier.value}] [@${a.id}] ${C}`,a.extension),{errorDetails:{message:C},timings:f.timings}}return{errorDetails:D?.errorDetails,timings:f.timings,metadata:D?.metadata}}),g)}catch(I){return this.i.error(I,a.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,M.$5i)(I)),responseIsIncomplete:!0}}}finally{f.close()}}async k(t,v){const u=[];for(const g of v.history){const a=p.ChatAgentResult.to(g.result),b=t===g.request.agentId?a:{...a,metadata:void 0};u.push(new r.$iO(g.request.message,g.request.command,g.request.variables.variables.map(p.ChatAgentResolvedVariable.to),{extensionId:"",name:g.request.agentId}));const f=(0,S.$Hb)(g.response.map(I=>p.ChatResponsePart.fromContent(I,this.j.converter)));u.push(new r.$jO(f,b,{extensionId:"",name:g.request.agentId},g.request.command))}return u}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,v,u,g,a){const b=this.c.get(v);if(!b)return Promise.resolve([]);const f=await this.k(b.id,g),I=p.ChatAgentResult.to(u);return(await b.provideFollowups(I,{history:f},a)).filter($=>{const D=!$.participant||R.Iterable.some(this.c.values(),y=>y.id===$.participant&&l.$Cm.equals(y.extension.identifier,b.extension.identifier));return D||this.i.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),D}).map($=>p.ChatFollowup.from($,t))}$acceptFeedback(t,v,u,g){const a=this.c.get(t);if(!a)return;const b=p.ChatAgentResult.to(v);let f;switch(u){case o.InteractiveSessionVoteDirection.Down:f=r.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:f=r.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(g?{result:b,kind:f,reportIssue:g}:{result:b,kind:f}))}$acceptAction(t,v,u){const g=this.c.get(t);if(!g||u.action.kind==="vote")return;const a=p.ChatAgentUserActionEvent.to(v,u,this.j.converter);a&&g.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(t,v,u){const g=this.c.get(t);return g?(await g.invokeCompletionProvider(v,u)).map(p.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,v){const u=this.c.get(t);if(u)return await u.provideWelcomeMessage(v)}async $provideSampleQuestions(t,v){const u=this.c.get(t);if(u)return(await u.provideSampleQuestions(v)).map(g=>p.ChatFollowup.from(g,void 0))}}e.$Qic=i;class c{constructor(t,v,u,g,a){this.extension=t,this.id=v,this.x=u,this.y=g,this.z=a,this.o=new N.$7d,this.p=new N.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,v){return this.s?await this.s.provider.provideCompletionItems(t,v)??[]:[]}async provideFollowups(t,v,u){if(!this.b)return[];const g=await this.b.provideFollowups(t,v,u);return g?g.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const v=await this.t.provideWelcomeMessage(t);return v?v.map(u=>typeof u=="string"?u:p.MarkdownString.from(u)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const v=await this.t.provideSampleQuestions(t);return v||[]}get apiAgent(){let t=!1,v=!1;const u=()=>{t||v||(v=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof O.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof r.$eN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:p.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:p.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:p.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),v=!1}))},g=this;return{get name(){return g.id},get description(){return g.c??""},set description(a){g.c=a,u()},get fullName(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.d??g.extension.displayName??g.extension.name},set fullName(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.d=a,u()},get iconPath(){return g.g},set iconPath(a){g.g=a,u()},get requestHandler(){return g.z},set requestHandler(a){(0,k.$5f)(typeof a=="function","Invalid request handler"),g.z=a},get followupProvider(){return g.b},set followupProvider(a){g.b=a,u()},get isDefault(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.i},set isDefault(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.i=a,u()},get helpTextPrefix(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.j},set helpTextPrefix(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.j=a,u()},get helpTextVariablesPrefix(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.k},set helpTextVariablesPrefix(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.k=a,u()},get helpTextPostfix(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.l},set helpTextPostfix(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.l=a,u()},get isSecondary(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.n},set isSecondary(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.n=a,u()},get sampleRequest(){return g.m},set sampleRequest(a){g.m=a,u()},get supportIssueReporting(){return(0,s.$6F)(g.extension,"chatParticipantAdditions"),g.q},set supportIssueReporting(a){(0,s.$6F)(g.extension,"chatParticipantAdditions"),g.q=a,u()},get onDidReceiveFeedback(){return g.o.event},set participantVariableProvider(a){if((0,s.$6F)(g.extension,"chatParticipantAdditions"),g.s=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");g.x.$registerAgentCompletionsProvider(g.y,a.triggerCharacters)}else g.x.$unregisterAgentCompletionsProvider(g.y)},get participantVariableProvider(){return(0,s.$6F)(g.extension,"chatParticipantAdditions"),g.s},set welcomeMessageProvider(a){(0,s.$6F)(g.extension,"defaultChatParticipant"),g.t=a,u()},get welcomeMessageProvider(){return(0,s.$6F)(g.extension,"defaultChatParticipant"),g.t},onDidPerformAction:(0,s.$5F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return g.u},set isSticky(a){g.u=a,u()},set requester(a){g.w=a,u()},get requester(){return g.w},dispose(){t=!0,g.b=void 0,g.o.dispose(),g.x.$unregisterAgent(g.y)}}}invoke(t,v,u,g){return this.z(t,v,u,g)}}}),define(Me[252],Re([1,0,14,6,4,8,7,22]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;class d{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(M.$gM.MainThreadChatVariables)}async $resolveVariable(E,l,w,p){const r=this.b.get(E);if(r)try{if(r.resolver.resolve2){(0,m.$6F)(r.extension,"chatParticipantAdditions");const o=new k(l,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:w},o.apiObject,p);if(s)return s.map(N.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:w},p);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,S.$2)(o)}}registerVariableResolver(E,l,w,p){const r=d.a++;return this.b.set(r,{extension:E,data:{name:l,description:w},resolver:p}),this.c.$registerVariable(r,{name:l,description:w}),(0,F.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$Tic=d;class k{constructor(E,l){this.c=E,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(p){if(E.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,p),r}};const E=this,w=p=>{this.d.$handleProgressChunk(this.c,p)};this.b={progress(p){l(this.progress);const r=new R.$fO(p),o=N.ChatResponseProgressPart.to(r);return w(o),this},reference(p){l(this.reference);const r=new R.$hO(p),o=N.ChatResponseReferencePart.to(r);return w(o),this},push(p){l(this.push);const r=N.ChatResponsePart.to(p);return w(r),this}}}return this.b}}}),define(Me[253],Re([1,0,11,68,5,6,2,87,20,8,7,4,22]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=w;function w(p,r,o){const s=p.getProxy(E.$gM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new d.$Em,r.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const f=this.b.get(b.handle);return f?f.value:b}else if(b&&b.$mid===7){const f=b,I=this.b.get(f.commentControlHandle);if(!I)return f;const $=I.getCommentThread(f.commentThreadHandle);return $?$.value:f}else if(b&&(b.$mid===9||b.$mid===8)){const f=this.b.get(b.thread.commentControlHandle);if(!f)return b;const I=f.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const f=this.b.get(b.thread.commentControlHandle);if(!f)return b;const I=f.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const $=b.commentUniqueId,D=I.getCommentByUniqueId($);return D||b}else if(b&&b.$mid===11){const f=this.b.get(b.thread.commentControlHandle);if(!f)return b;const I=f.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const $=b.text,D=b.commentUniqueId,y=I.getCommentByUniqueId(D);return y?(typeof y.body=="string"?y.body=$:y.body=new O.$JM($),y):b}return b}})}createCommentController(b,f,I){const $=n.a++,D=new c(b,$,f,I);this.b.set(D.handle,D);const y=this.c.get(b.identifier)||[];return y.push(D),this.c.set(b.identifier,y),D.value}async $createCommentThreadTemplate(b,f,I){const $=this.b.get(b);$&&$.$createCommentThreadTemplate(f,I)}async $setActiveComment(b,f){const I=this.b.get(b);I&&I.$setActiveComment(f??void 0)}async $updateCommentThreadTemplate(b,f,I){const $=this.b.get(b);$&&$.$updateCommentThreadTemplate(f,I)}$deleteCommentThread(b,f){this.b.get(b)?.$deleteCommentThread(f)}async $provideCommentingRanges(b,f,I){const $=this.b.get(b);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const D=await o.ensureDocumentData(R.URI.revive(f));return(0,S.$_g)(async()=>{const y=await $.commentingRangeProvider.provideCommentingRanges(D.document,I);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(A=>k.Range.from(A)),fileComments:y.fileComments}),C})}$toggleReaction(b,f,I,$,D){const y=this.b.get(b);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,S.$_g)(()=>{const C=y.getCommentThread(f);if(C){const A=C.getCommentByUniqueId($.uniqueIdInThread);if(y!==void 0&&A&&y.reactionHandler)return y.reactionHandler(A,v(D))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,f,I,$,D,y,C,A){this.m=f,this.n=I,this.o=$,this.p=D,this.q=y,this.extensionDescription=C,this.r=A,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${b}.${this.handle}`),s.$createCommentThread(f,this.handle,this.n,this.o,k.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{s.$deleteCommentThread(f,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(T){G.range=T},get comments(){return G.comments},set comments(T){G.comments=T},get collapsibleState(){return G.collapsibleState},set collapsibleState(T){G.collapsibleState=T},get canReply(){return G.canReply},set canReply(T){G.canReply=T},get contextValue(){return G.contextValue},set contextValue(T){G.contextValue=T},get label(){return G.label},set label(T){G.label=T},get state(){return G.state},set state(T){G.state=T},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const b=I=>Object.prototype.hasOwnProperty.call(this.b,I),f={};b("range")&&(f.range=k.Range.from(this.p)),b("label")&&(f.label=this.label),b("contextValue")&&(f.contextValue=this.contextValue??null),b("comments")&&(f.comments=this.q.map(I=>h(this,I,this.k,this.extensionDescription))),b("collapsibleState")&&(f.collapseState=u(this.g)),b("canReply")&&(f.canReply=this.canReply),b("state")&&(f.state=g(this.h)),b("isTemplate")&&(f.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,f)}getCommentByUniqueId(b){for(const f of this.k){const I=f[0],$=f[1];if(b===$)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Je([(0,F.$Mh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,l.$6F)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$6F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$6F)(this.h,"activeComment"),this.f}constructor(b,f,I,$){this.h=b,this.i=f,this.j=I,this.k=$,this.a=new Map,s.$registerCommentController(this.handle,I,$,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(y){D.options=y},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(y){D.commentingRangeProvider=y},get reactionHandler(){return D.reactionHandler},set reactionHandler(y){D.reactionHandler=y},get activeCommentThread(){return D.activeCommentThread},createCommentThread(y,C,A){return D.createCommentThread(y,C,A).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(b,f,I){f===void 0&&(0,l.$6F)(this.h,"fileComments");const $=new i(this.id,this.handle,void 0,b,f,I,this.h,!1);return this.a.set($.handle,$),$}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const f=this.a.get(b.commentThreadHandle);f&&(this.e=b.uniqueIdInThread?f.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=f)}$createCommentThreadTemplate(b,f){const I=new i(this.id,this.handle,void 0,R.URI.revive(b),k.Range.to(f),[],this.h,!0);return I.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(b,f){const I=this.a.get(b);I&&(I.range=k.Range.to(f))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function h(a,b,f,I){let $=f.get(b);return $||($=++a.commentHandle,f.set(b,$)),b.state!==void 0&&(0,l.$6F)(I,"commentsDraftState"),b.reactions?.some(D=>D.reactors!==void 0)&&(0,l.$6F)(I,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:$,body:typeof b.body=="string"?b.body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(D=>t(D)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?k.$zO(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors&&a.reactors.length>0&&typeof a.reactors[0]!="string"?a.reactors.map(b=>b.name):a.reactors}}function v(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?R.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors?.map(b=>({name:b}))}}function u(a){if(a!==void 0)switch(a){case O.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function g(a){if(a!==void 0)switch(a){case O.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}}),define(Me[254],Re([1,0,25,99,6,12,24,2,8,62,74,4,7]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class w{constructor(v,u){this.document=v,this.b=u,this.a=1,this.c=new O.$Aic("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,u){await this.f(v).undo(),u||this.disposeBackup()}async redo(v,u){await this.f(v).redo(),u||this.disposeBackup()}disposeEdits(v){for(const u of v)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=h(this.document.uri)+this.a++;return(0,R.$Ug)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const u=this.c.get(v,0);if(!u)throw new Error("No edit found");return u}}class p{constructor(){this.a=new Map}get(v,u){return this.a.get(this.b(v,u))}add(v,u,g){const a=this.b(v,u.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${v} resource:${u.uri}`);const b=new w(u,g);return this.a.set(a,b),b}delete(v,u){const g=this.b(v,u.uri);this.a.delete(g)}b(v,u){return`${v}@@@${u}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(v,u,g){return this.b(0,v,u,g)}addCustomProvider(v,u,g){return this.b(1,v,u,g)}get(v){return this.a.get(v)}b(v,u,g,a){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:v,extension:g,provider:a}),new l.$iM(()=>this.a.delete(u))}}class s{constructor(v,u,g,a,b){this.d=u,this.f=g,this.g=a,this.h=b,this.b=new o,this.c=new p,this.a=v.getProxy(E.$gM.MainThreadCustomEditors)}registerCustomEditorProvider(v,u,g,a){const b=new M.$Tc;return i(g)?(b.add(this.b.addTextProvider(u,v,g)),this.a.$registerTextEditorProvider((0,k.$ajc)(v),u,a.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,k.$$ic)(v))):(b.add(this.b.addCustomProvider(u,v,g)),n(g)&&b.add(g.onDidChangeCustomDocument(f=>{const I=this.i(u,f.document.uri);if(c(f)){const $=I.addEdit(f);this.a.$onDidEdit(f.document.uri,u,$,f.label)}else this.a.$onContentChange(f.document.uri,u)})),this.a.$registerCustomEditorProvider((0,k.$ajc)(v),u,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,k.$$ic)(v))),l.$iM.from(b,new l.$iM(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(v,u,g,a,b){const f=this.b.get(u);if(!f)throw new Error(`No provider found for '${u}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=m.URI.revive(v),$=await f.provider.openCustomDocument(I,{backupId:g,untitledDocumentData:a?.buffer},b);let D;return n(f.provider)&&this.f&&(D=this.f.workspaceValue(f.extension)??this.f.globalValue(f.extension)),this.c.add(u,$,D),{editable:n(f.provider)}}async $disposeCustomDocument(v,u){const g=this.b.get(u);if(!g)throw new Error(`No provider found for '${u}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${u}'`);const a=m.URI.revive(v),{document:b}=this.i(u,a);this.c.delete(u,b),b.dispose()}async $resolveCustomEditor(v,u,g,a,b,f){const I=this.b.get(g);if(!I)throw new Error(`No provider found for '${g}'`);const $=d.ViewColumn.to(b),D=this.g.createNewWebview(u,a.contentOptions,I.extension),y=this.h.createNewWebviewPanel(u,g,a.title,$,a.options,D,a.active),C=m.URI.revive(v);switch(I.type){case 1:{const{document:A}=this.i(g,C);return I.provider.resolveCustomEditor(A,y,f)}case 0:{const A=this.d.getDocument(C);return I.provider.resolveCustomTextEditor(A,y,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,u,g){this.i(u,v).disposeEdits(g)}async $onMoveCustomEditor(v,u,g){const a=this.b.get(g);if(!a)throw new Error(`No provider found for '${g}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const b=this.h.getWebviewPanel(v);if(!b)throw new Error("No webview found");const f=m.URI.revive(u),I=this.d.getDocument(f);await a.provider.moveCustomTextEditor(I,b,S.CancellationToken.None)}async $undo(v,u,g,a){return this.i(u,v).undo(g,a)}async $redo(v,u,g,a){return this.i(u,v).redo(g,a)}async $revert(v,u,g){const a=this.i(u,v);await this.j(u).revertCustomDocument(a.document,g),a.disposeBackup()}async $onSave(v,u,g){const a=this.i(u,v);await this.j(u).saveCustomDocument(a.document,g),a.disposeBackup()}async $onSaveAs(v,u,g,a){const b=this.i(u,v);return this.j(u).saveCustomDocumentAs(b.document,m.URI.revive(g),a)}async $backup(v,u,g){const a=this.i(u,v),f=await this.j(u).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},g);return a.updateBackup(f),f.id}i(v,u){const g=this.c.get(v,m.URI.revive(u));if(!g)throw new Error("No custom document found");return g}j(v){const g=this.b.get(v)?.provider;if(!g||!n(g))throw new Error("Custom document is not editable");return g}}e.$djc=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const v=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,F.$8i)(v)+""}}),define(Me[255],Re([1,0,163,100,2,4,7,8,5,13,28,43]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0;class w{#e;#t;#i;constructor(o,s,n,i,c,h,t,v){this.d=o,this.e=s,this.f=n,this.g=i,this.h=c,this.c=!1,this.f=Math.max(i,n),this.#i=new O.$Bc(u=>h.getComparisonKey(u)),this.#e=t,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(M.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(w.k);for(const t of o){const[v,u]=t;if((!h||v.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=v,n.push(v),this.#i.set(v,[])),u)this.#i.get(v)?.push(...u);else{const g=this.#i.get(v);g&&(g.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let c=0;for(const h of n){let t=[];const v=this.#i.get(h);if(v)if(v.length>this.g){t=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const a of v)if(a.severity===u[g]&&t.push({...m.Diagnostic.from(a),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,v.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=v.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(i.push([h,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,i]of this)o.call(s,n,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$Hic=w;let p=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const s=new O.$Bc;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,i){this.j=s,this.k=n,this.l=i,this.g=new Map,this.h=new d.$$d({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,l._mapper),this.f=o.getProxy(N.$gM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:i,h:c,j:h,k:t,l:v}=this,u=new class{$changeMany(b,f){i.$changeMany(b,f),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,b,f.length===0?"CLEARING":f)}$clear(b){i.$clear(b),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,b)}dispose(){i.dispose()}};let g;if(!s)s="_generated_diagnostic_collection_name_#"+l.c++,g=s;else if(!n.has(s))g=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do g=s+l.c++;while(n.has(g))}return new class extends w{constructor(){super(s,g,l.e,l.d,b=>v.getDocument(b)?.version,t.extUri,u,c),n.set(g,this)}dispose(){super.dispose(),n.delete(g)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const i of this.g.values())i.forEach((c,h)=>{let t=s.get(c.toString());typeof t>"u"&&(t=n.length,s.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(M.URI.revive(s),n.map(m.Diagnostic.to))}};e.$Iic=p,e.$Iic=p=l=Je([qe(1,k.$Nj),qe(2,E.$Gic)],p)}),define(Me[256],Re([1,0,2,14,7,8,191]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=void 0;class m{constructor(k,O,E,l={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=E,this.g=l,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,E,l)=>{const p={dispose:this.a.push([O,E,k])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(k,O){const E=S.URI.revive(k);let l=!1;const w=setTimeout(()=>l=!0,this.g.timeout),p=[];try{for(const r of[...this.a]){if(l)break;const o=this.d.getDocument(E),s=await this.h(r,{document:o,reason:N.TextDocumentSaveReason.to(O)});p.push(s)}}finally{clearTimeout(w)}return p}h([k,O,E],l){const w=this.b.get(k);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(E,k,O,l).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const r=this.b.get(k);this.b.set(k,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,E,l){const w=[],p=Date.now(),{document:r,reason:o}=l,{version:s}=r,n=Object.freeze({document:r,reason:o,waitUntil(i){if(Object.isFrozen(w))throw(0,F.$8)("waitUntil can not be called async");w.push(Promise.resolve(i))}});try{O.apply(E,[n])}catch(i){return Promise.reject(i)}return Object.freeze(w),new Promise((i,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(w).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(h),i(t)}).catch(t=>{clearTimeout(h),c(t)})}).then(i=>{const c={edits:[]};for(const h of i)if(Array.isArray(h)&&h.every(t=>t instanceof M.$pM))for(const{newText:t,newEol:v,range:u}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:u&&N.Range.from(u),text:t,eol:v&&N.EndOfLine.from(v)}});if(c.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$Rjc=m}),define(Me[257],Re([1,0,5,6,2,4,111,8,16,26,7]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=void 0;class E{constructor(w,p){this.a=new S.$7d,this.b=new S.$7d,this.c=new S.$7d,this.d=new S.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Tc,this.h=new Map,this.f=w.getProxy(N.$gM.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const p=this.g.getDocument(w);if(p)return p}getDocument(w){const p=this.getDocumentData(w);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return p.document}ensureDocumentData(w){const p=this.g.getDocument(w);if(p)return Promise.resolve(p);let r=this.h.get(w.toString());return r||(r=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const s=M.URI.revive(o);return(0,d.$6f)(this.g.getDocument(s))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),r)),r}createDocumentData(w){return this.f.$tryCreateDocument(w).then(p=>M.URI.revive(p))}$acceptModelLanguageChanged(w,p){const r=M.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(p),this.a.fire(o.document)}$acceptModelSaved(w){const p=M.URI.revive(w),r=this.g.getDocument(p);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(w,p){const r=M.URI.revive(w),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(p),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,p,r){const o=M.URI.revive(w),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(p);let n;p.isUndoing?n=O.TextDocumentChangeReason.Undo:p.isRedoing&&(n=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.$On)({document:s.document,contentChanges:p.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(w,p){(0,R.$CO)(w,p)}}e.$Jic=E}),define(Me[65],Re([1,0,258,5,16,2,3,4,17,8,7]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=e.$ejc=void 0,e.$ejc=(0,R.$hi)("IExtHostEditorTabs");class E{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.$4N(N.URI.revive(this.b.input.uri));case 2:return new O.$5N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new O.$6N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new O.$7N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.$8N(this.b.input.viewType);case 4:return new O.$9N(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.$0N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.$$N;case 9:return new O.$_N(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new O.$aO(this.b.input.providerId);default:return}}}class l{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new E(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new F.$7d,this.c=new F.$7d,this.e=[],this.a=o.getProxy(m.$gM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,M.$6f)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,i)=>{const c=Array.isArray(n)?n:[n];return c.length?p(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(u=>u.groupId)),n=new Set(o.map(u=>u.groupId)),i=(0,S.$L)(s,n),c=this.e.filter(u=>i.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],t=[];this.e=o.map(u=>{const g=new l(u,()=>this.d);return i.added.includes(g.groupId)?h.push(g.apiObject):t.push(g.apiObject),g});const v=(0,M.$6f)(o.find(u=>u.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:h,closed:c,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const i of o){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const i of o){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,s)}};e.$fjc=w,e.$fjc=w=Je([qe(0,d.$AO)],w);function p(r){return r.tabs!==void 0}}),define(Me[259],Re([1,0,2,4,6,7,8,302,15,23,22,53]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,n,i=14,c=14;for(const h of r){let t=s?(0,d.$nf)(s,h):0;for(t===0?n=1:n=c;t<h.length;t++)t+1===h.length?(i=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(t),c]),o.push([n,h.toLowerCase().charCodeAt(t),c]),n=c;s=h,c=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$j2(o)}}provideDocumentLinks(r){this.c();const o=[],s=m.$k2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const i=R.DocumentLink.to(n);i.target&&o.push(i)}return o}}class w{constructor(r,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(F.$gM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,n={}){if(w.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,O.$6F)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,E.$Gk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,c,h).catch(v=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(v)});const t=s.onDidChangeFile(v=>{const u=[];for(const g of v){const{uri:a,type:b}=g;if(a.scheme!==o)continue;let f;switch(b){case N.FileChangeType.Changed:f=0;break;case N.FileChangeType.Created:f=1;break;case N.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:a,type:f})}this.a.$onFileSystemChange(i,u)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:n,size:i,permissions:c}=r;return{type:o,ctime:s,mtime:n,size:i,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(S.URI.revive(o))).then(s=>w.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(S.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(S.URI.revive(o))).then(s=>k.$ue.wrap(s))}$writeFile(r,o,s,n){return Promise.resolve(this.l(r).writeFile(S.URI.revive(o),s.buffer,n))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(S.URI.revive(o),s))}$rename(r,o,s,n){return Promise.resolve(this.l(r).rename(S.URI.revive(o),S.URI.revive(s),n))}$copy(r,o,s,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(S.URI.revive(o),S.URI.revive(s),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(S.URI.revive(o)))}$watch(r,o,s,n){const i=this.l(r).watch(S.URI.revive(s),n);this.f.set(o,i)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(S.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=k.$ue.alloc(n);return Promise.resolve(i.read(o,s,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,o,s,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$Tjc=w}),define(Me[260],Re([1,0,5,34,2,4,8,7,39]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,p,r,o,s,n){this.a=Math.random(),this.b=new S.$7d,this.c=new S.$7d,this.d=new S.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,F.$bk)(s),c=typeof s=="string",h=n?.correlate,t=o(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(h&&typeof v.session>"u")){if(!n?.ignoreCreateEvents)for(const u of v.created){const g=M.URI.revive(u);i(g.fsPath)&&(!c||p.getWorkspaceFolder(g))&&this.b.fire(g)}if(!n?.ignoreChangeEvents)for(const u of v.changed){const g=M.URI.revive(u);i(g.fsPath)&&(!c||p.getWorkspaceFolder(g))&&this.c.fire(g)}if(!n?.ignoreDeleteEvents)for(const u of v.deleted){const g=M.URI.revive(u);i(g.fsPath)&&(!c||p.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=m.$iM.from(this.i(w,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(w,p,r,o,s){const n=m.$iM.from();if(typeof r=="string")return n;const i=w.getProxy(N.$gM.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(F.$0j)||r.pattern.includes(F.$$j))&&(c=!0),i.$watch(p.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[]},!!s),m.$iM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class O{constructor(w){this.a=w,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(M.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class E{constructor(w,p,r){this.j=w,this.k=p,this.l=r,this.a=new S.$7d,this.b=new S.$7d,this.c=new S.$7d,this.d=new S.$7d,this.g=new S.$9d,this.h=new S.$9d,this.i=new S.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,p,r,o){return new k(this.j,w,p,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(w){this.a.fire(new O(w))}$onDidRunFileOperation(w,p){switch(w){case 2:this.b.fire(Object.freeze({files:p.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,p){return(r,o,s)=>{const n=function(c){r.call(o,c)};return n.extension=w,p.event(n,void 0,s)}}async $onWillRunFileOperation(w,p,r,o){switch(w){case 2:return await this.n(this.g,{files:p.map(s=>({oldUri:M.URI.revive(s.source),newUri:M.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:p.map(s=>M.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:p.map(s=>M.URI.revive(s.target))},r,o)}}async n(w,p,r,o){const s=new Set,n=[];if(await w.fireAsync(p,o,async(c,h)=>{const t=Date.now(),v=await Promise.resolve(c);v instanceof m.$sM&&(n.push([h.extension,v]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$Ujc=E}),define(Me[261],Re([1,0,18,11,25,14,90,6,26,64,15,16,2,29,303,87,97,165,20,8,7,22,74,4]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class u{constructor(U,z){this.d=U,this.e=z}async provideDocumentSymbols(U,z){const K=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(K,z);if(!(0,S.$Kb)(H))return H[0]instanceof c.$BM?H.map(i.DocumentSymbol.from):u.f(H)}static f(U){U=U.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const z=[],K=[];for(const H of U){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ee),z.push(ee);break}const se=K[K.length-1];if(w.$at.containsRange(se.range,ee.range)&&!w.$at.equalsRange(se.range,ee.range)){se.children?.push(ee),K.push(ee);break}K.pop()}}return z}}class g{constructor(U,z,K,H,ee,se){this.f=U,this.g=z,this.h=K,this.j=H,this.k=ee,this.l=se,this.d=new t.$Aic("CodeLens"),this.e=new Map}async provideCodeLenses(U,z){const K=this.f.getDocument(U),H=await this.h.provideCodeLenses(K,z);if(!H||z.isCancellationRequested)return;const ee=this.d.add(H),se=new m.$Tc;this.e.set(ee,se);const Ne={cacheId:ee,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Ne.lenses.push({cacheId:[ee,Ve],range:i.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,se)});return Ne}async resolveCodeLens(U,z){const K=U.cacheId&&this.d.get(...U.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,z),H||(H=K),z.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return U.command=this.g.toInternal(H.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function a(Le){return Array.isArray(Le)?Le.map(i.DefinitionLink.from):Le?[i.DefinitionLink.from(Le)]:[]}class b{constructor(U,z){this.d=U,this.e=z}async provideDefinition(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideDefinition(H,ee,K);return a(se)}}class f{constructor(U,z){this.d=U,this.e=z}async provideDeclaration(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideDeclaration(H,ee,K);return a(se)}}class I{constructor(U,z){this.d=U,this.e=z}async provideImplementation(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideImplementation(H,ee,K);return a(se)}}class ${constructor(U,z){this.d=U,this.e=z}async provideTypeDefinition(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideTypeDefinition(H,ee,K);return a(se)}}class D{constructor(U,z){this.d=U,this.e=z}async provideHover(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideHover(H,ee,K);if(!(!se||(0,S.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new c.$kM(ee,ee)),i.Hover.from(se)}}class y{constructor(U,z){this.d=U,this.e=z}async provideEvaluatableExpression(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideEvaluatableExpression(H,ee,K);if(se)return i.EvaluatableExpression.from(se)}}class C{constructor(U,z){this.d=U,this.e=z}async provideInlineValues(U,z,K,H){const ee=this.d.getDocument(U),se=await this.e.provideInlineValues(ee,i.Range.to(z),i.InlineValueContext.to(K),H);if(Array.isArray(se))return se.map(Ne=>i.InlineValue.from(Ne))}}class A{constructor(U,z){this.d=U,this.e=z}async provideDocumentHighlights(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideDocumentHighlights(H,ee,K);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class G{constructor(U,z){this.d=U,this.e=z}async provideMultiDocumentHighlights(U,z,K,H){const ee=this.d.getDocument(U),se=K.map(Ye=>this.d.getDocument(Ye)),Ne=i.Position.to(z),Ve=await this.e.provideMultiDocumentHighlights(ee,Ne,se,H);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class T{constructor(U,z){this.d=U,this.e=z}async provideLinkedEditingRanges(U,z,K){const H=this.d.getDocument(U),ee=i.Position.to(z),se=await this.e.provideLinkedEditingRanges(H,ee,K);if(se&&Array.isArray(se.ranges))return{ranges:(0,S.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class V{constructor(U,z){this.d=U,this.e=z}async provideReferences(U,z,K,H){const ee=this.d.getDocument(U),se=i.Position.to(z),Ne=await this.e.provideReferences(ee,se,K,H);if(Array.isArray(Ne))return Ne.map(i.location.from)}}class P{static{this.d=1e3}constructor(U,z,K,H,ee,se,Ne){this.g=U,this.h=z,this.j=K,this.k=H,this.l=ee,this.m=se,this.n=Ne,this.e=new t.$Aic("CodeAction"),this.f=new Map}async provideCodeActions(U,z,K,H){const ee=this.g.getDocument(U),se=p.$ct.isISelection(z)?i.Selection.to(z):i.Range.to(z),Ne=[];for(const rt of this.j.getDiagnostics(U))if(se.intersection(rt.range)&&Ne.push(rt)>P.d)break;const Ve={diagnostics:Ne,only:K.only?new c.$DM(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Ye=await this.k.provideCodeActions(ee,se,Ve,H);if(!(0,S.$Lb)(Ye)||H.isCancellationRequested)return;const xe=this.e.add(Ye),et=new m.$Tc;this.f.set(xe,et);const ot=[];for(let rt=0;rt<Ye.length;rt++){const tt=Ye[rt];if(tt)if(P.o(tt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:tt.title,command:this.h.toInternal(tt,et)});else{Ve.only&&(tt.kind?Ve.only.contains(tt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const st=tt.ranges??[];ot.push({cacheId:[xe,rt],title:tt.title,command:tt.command&&this.h.toInternal(tt.command,et),diagnostics:tt.diagnostics&&tt.diagnostics.map(i.Diagnostic.from),edit:tt.edit&&i.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,isAI:(0,h.$5F)(this.m,"codeActionAI")?tt.isAI:!1,ranges:(0,h.$5F)(this.m,"codeActionRanges")?(0,S.$Hb)(st.map(i.Range.from)):void 0,disabled:tt.disabled?.reason})}}return{cacheId:xe,actions:ot}}async resolveCodeAction(U,z){const[K,H]=U,ee=this.e.get(K,H);if(!ee||P.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,z)??ee;let Ne;se.edit&&(Ne=i.WorkspaceEdit.from(se.edit,void 0));let Ve;if(se.command){const Ye=this.f.get(K);Ye&&(Ve=this.h.toInternal(se.command,Ye))}return{edit:Ne,command:Ve}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class L{constructor(U,z,K,H,ee){this.e=U,this.f=z,this.g=K,this.h=H,this.j=ee,this.d=new t.$Aic("DocumentPasteEdit")}async prepareDocumentPaste(U,z,K,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),se=z.map(Ye=>i.Range.to(Ye)),Ne=i.DataTransfer.toDataTransfer(K,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(ee,se,Ne,H),H.isCancellationRequested)return;const Ve=Array.from(Ne).filter(([,Ye])=>!(Ye instanceof c.$0M));return i.DataTransfer.from(Ve)}async providePasteEdits(U,z,K,H,ee,se){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(z),Ve=K.map(ot=>i.Range.to(ot)),Ye=i.DataTransfer.toDataTransfer(H,async ot=>(await this.e.$resolvePasteFileData(this.h,U,ot)).buffer),xe=await this.g.provideDocumentPasteEdits(Ne,Ve,Ye,{only:ee.only?new c.$cN(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const et=this.d.add(xe);return xe.map((ot,rt)=>({_cacheId:[et,rt],title:ot.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,detail:this.j.displayName||this.j.name,yieldTo:ot.yieldTo?.map(tt=>"mimeType"in tt?tt:{kind:tt.kind.value}),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,z){const[K,H]=U,ee=this.d.get(K,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(ee,z)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class q{constructor(U,z){this.d=U,this.e=z}async provideDocumentFormattingEdits(U,z,K){const H=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(H,z,K);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class re{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeFormattingEdits(U,z,K,H){const ee=this.d.getDocument(U),se=i.Range.to(z),Ne=await this.e.provideDocumentRangeFormattingEdits(ee,se,K,H);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,z,K,H){(0,E.$5f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),se=z.map(i.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(ee,se,K,H);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}}class ue{constructor(U,z){this.d=U,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,z,K,H,ee){const se=this.d.getDocument(U),Ne=i.Position.to(z),Ve=await this.e.provideOnTypeFormattingEdits(se,Ne,K,H,ee);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class ye{constructor(U,z){this.e=U,this.f=z,this.d=new t.$Aic("WorkspaceSymbols")}async provideWorkspaceSymbols(U,z){const K=await this.e.provideWorkspaceSymbols(U,z);if(!(0,S.$Lb)(K))return{symbols:[]};const H=this.d.add(K),ee={cacheId:H,symbols:[]};for(let se=0;se<K.length;se++){const Ne=K[se];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Ne),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(U,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const K=this.d.get(...U.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,z);return H&&(0,d.$Qn)(U,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Se{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,z,K){this.d=U,this.e=z,this.f=K}async provideRenameEdits(U,z,K,H){const ee=this.d.getDocument(U),se=i.Position.to(z);try{const Ne=await this.e.provideRenameEdits(ee,se,K,H);return Ne?i.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ve=Se.g(Ne);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(U,z,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ee=i.Position.to(z);try{const se=await this.e.prepareRename(H,ee,K);let Ne,Ve;if(c.$kM.isRange(se)?(Ne=se,Ve=H.getText(se)):(0,E.$Wf)(se)&&(Ne=se.range,Ve=se.placeholder),!Ne||!Ve)return;if(Ne.start.line>ee.line||Ne.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ne),text:Ve}}catch(se){const Ne=Se.g(se);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(se)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class le{constructor(U,z,K){this.d=U,this.e=z,this.f=K}async provideNewSymbolNames(U,z,K){const H=this.d.getDocument(U),ee=i.Range.to(z);try{const se=await this.e.provideNewSymbolNames(H,ee,K);return se?se.map(Ne=>typeof Ne=="string"?{newSymbolName:Ne}:{newSymbolName:Ne.newSymbolName,tags:Ne.tags}):void 0}catch(se){this.f.error(le.g(se)??JSON.stringify(se,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class we{constructor(U,z){this.resultId=U,this.tokens=z}}class _{constructor(U,z){this.f=U,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,z,K){const H=this.f.getDocument(U),ee=z!==0?this.d.get(z):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ee&&this.d.delete(z),se?(se=_.h(se),this.o(_.n(ee,se),se)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return _.j(U)?_.k(U)?U:new c.$CN(new Uint32Array(U.data),U.resultId):_.l(U)?_.m(U)?U:new c.$EN(U.edits.map(z=>new c.$DN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const z of U.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(U,z){if(!_.j(z)||!U||!U.tokens)return z;const K=U.tokens,H=K.length,ee=z.data,se=ee.length;let Ne=0;const Ve=Math.min(H,se);for(;Ne<Ve&&K[Ne]===ee[Ne];)Ne++;if(Ne===H&&Ne===se)return new c.$EN([],z.resultId);let Ye=0;const xe=Ve-Ne;for(;Ye<xe&&K[H-Ye-1]===ee[se-Ye-1];)Ye++;return new c.$EN([{start:Ne,deleteCount:H-Ne-Ye,data:ee.subarray(Ne,se-Ye)}],z.resultId)}o(U,z){if(_.j(U)){const K=this.e++;return this.d.set(K,new we(U.resultId,U.data)),(0,o.$qab)({id:K,type:"full",data:U.data})}if(_.l(U)){const K=this.e++;return _.j(z)?this.d.set(K,new we(z.resultId,z.data)):this.d.set(K,new we(U.resultId)),(0,o.$qab)({id:K,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class ve{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeSemanticTokens(U,z,K){const H=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(z),K);return ee?this.f(ee):null}f(U){return(0,o.$qab)({id:0,type:"full",data:U.data})}}class ne{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,z,K,H,ee){this.f=U,this.g=z,this.h=K,this.j=H,this.k=ee,this.d=new t.$Aic("CompletionItem"),this.e=new Map}async provideCompletionItems(U,z,K,H){const ee=this.f.getDocument(U),se=i.Position.to(z),Ne=ee.getWordRangeAtPosition(se)||new c.$kM(se,se),Ve=Ne.with({end:se}),Ye=new k.$3d,xe=await this.h.provideCompletionItems(ee,se,H,i.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const et=Array.isArray(xe)?new c.$QM(xe):xe,ot=ne.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),rt=new m.$Tc;this.e.set(ot,rt);const tt=[],st={x:ot,b:tt,a:{replace:i.Range.from(Ne),insert:i.Range.from(Ve)},c:et.isIncomplete||void 0,d:Ye.elapsed()};for(let Be=0;Be<et.items.length;Be++){const it=et.items[Be],Q=this.l(it,[ot,Be],Ve,Ne);tt.push(Q)}return st}async resolveCompletionItem(U,z){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...U);if(!K)return;const H=this.l(K,U),ee=await this.h.resolveCompletionItem(K,z);if(!ee)return;const se=this.l(ee,U);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,d.$Rn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z,K,H){const ee=this.e.get(z[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(U.command,ee),Ne={x:z,a:U.label,b:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(i.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=U.textEdit.newText):typeof U.insertText=="string"?Ne.h=U.insertText:U.insertText instanceof c.$tM&&(Ne.h=U.insertText.value,Ne.i|=4);let Ve;return U.textEdit?Ve=U.textEdit.range:U.range&&(Ve=U.range),c.$kM.isRange(Ve)?Ne.j=i.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Ne.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Ne}}class fe{async provideInlineCompletions(U,z,K,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,z,K){}handlePartialAccept(U,z,K,H){}}class W extends fe{constructor(U,z,K,H){super(),this.f=U,this.g=z,this.h=K,this.j=H,this.d=new Ee,this.e=(0,h.$5F)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$5F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,z,K,H){const ee=this.g.getDocument(U),se=i.Position.to(z),Ne=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Ne||H.isCancellationRequested)return;const Ve=Array.isArray(Ne)?Ne:Ne.items,Ye=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],xe=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Ve}),items:Ve.map((rt,tt)=>{let st;rt.command&&(et||(et=new m.$Tc),st=this.j.toInternal(rt.command,et));const Be=rt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:rt.filterText,range:rt.range?i.Range.from(rt.range):void 0,command:st,idx:tt,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Ye.map(rt=>(et||(et=new m.$Tc),this.j.toInternal(rt,et))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,z,K){const H=this.d.get(U)?.items[z];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(U,z,K,H){const ee=this.d.get(U)?.items[z];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,K),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class te{async provideInlineEdits(U,z,K){const H=this.f.getDocument(U),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[z.triggerKind]},K);if(!ee||K.isCancellationRequested)return;let se;const Ne=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Ve;ee.accepted&&(se||(se=new m.$Tc),Ve=this.h.toInternal(ee.accepted,se));let Ye;return ee.rejected&&(se||(se=new m.$Tc),Ye=this.h.toInternal(ee.rejected,se)),{pid:Ne,text:ee.text,range:i.Range.from(ee.range),accepted:Ve,rejected:Ye}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,z,K,H){this.f=z,this.g=K,this.h=H,this.d=new Ee,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class Ee{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const z=this.e++;return this.d.set(z,U),z}disposeReferenceId(U){const z=this.d.get(U);return this.d.delete(U),z}get(U){return this.d.get(U)}}class Te{constructor(U,z){this.e=U,this.f=z,this.d=new t.$Aic("SignatureHelp")}async provideSignatureHelp(U,z,K,H){const ee=this.e.getDocument(U),se=i.Position.to(z),Ne=this.g(K),Ve=await this.f.provideSignatureHelp(ee,se,H,Ne);if(Ve){const Ye=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ye}}}g(U){let z;if(U.activeSignatureHelp){const K=i.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(z=H,z.activeSignature=K.activeSignature,z.activeParameter=K.activeParameter):z=K}return{...U,activeSignatureHelp:z}}releaseSignatureHelp(U){this.d.delete(U)}}class Ie{constructor(U,z,K,H,ee){this.f=U,this.g=z,this.h=K,this.j=H,this.k=ee,this.d=new t.$Aic("InlayHints"),this.e=new Map}async provideInlayHints(U,z,K){const H=this.f.getDocument(U),ee=i.Range.to(z),se=await this.h.provideInlayHints(H,ee,K);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(K.isCancellationRequested)return;const Ne=this.d.add(se);this.e.set(Ne,new m.$Tc);const Ve={hints:[],cacheId:Ne};for(let Ye=0;Ye<se.length;Ye++)this.l(se[Ye],ee)&&Ve.hints.push(this.m(se[Ye],[Ne,Ye]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Ve}async resolveInlayHint(U,z){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...U);if(!K)return;const H=await this.h.resolveInlayHint(K,z);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(z&&!z.contains(U.position))}m(U,z){const K=this.e.get(z[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:z,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ee=[];H.label=ee;for(const se of U.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};c.$uM.isLocation(se.location)&&(Ne.location=i.location.from(se.location)),se.command&&(Ne.command=this.g.toInternal(se.command,K)),ee.push(Ne)}}return H}}class pe{constructor(U,z){this.e=U,this.f=z,this.d=new t.$Aic("DocumentLink")}async provideLinks(U,z){const K=this.e.getDocument(U),H=await this.f.provideDocumentLinks(K,z);if(!(!Array.isArray(H)||H.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(pe.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Ne=0;Ne<H.length;Ne++){if(!pe.g(H[Ne]))continue;const Ve=i.DocumentLink.from(H[Ne]);Ve.cacheId=[ee,Ne],se.links.push(Ve)}return se}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,z){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...U);if(!K)return;const H=await this.f.resolveDocumentLink(K,z);if(!(!H||!pe.g(H)))return i.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,z){this.d=U,this.e=z}async provideColors(U,z){const K=this.d.getDocument(U),H=await this.e.provideDocumentColors(K,z);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(U,z,K){const H=this.d.getDocument(U),ee=i.Range.to(z.range),se=i.Color.to(z.color),Ne=await this.e.provideColorPresentations(se,{document:H,range:ee},K);if(Array.isArray(Ne))return Ne.map(i.ColorPresentation.from)}}class J{constructor(U,z){this.d=U,this.e=z}async provideFoldingRanges(U,z,K){const H=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(H,z,K);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class X{constructor(U,z,K){this.d=U,this.e=z,this.f=K}async provideSelectionRanges(U,z,K){const H=this.d.getDocument(U),ee=z.map(i.Position.to),se=await this.e.provideSelectionRanges(H,ee,K);if(!(0,S.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ve=0;Ve<ee.length;Ve++){const Ye=[];Ne.push(Ye);let xe=ee[Ve],et=se[Ve];for(;;){if(!et.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(i.SelectionRange.from(et)),!et.parent)break;xe=et.range,et=et.parent}}return Ne}}class ce{constructor(U,z){this.f=U,this.g=z,this.d=new R.$FO(""),this.e=new Map}async prepareSession(U,z,K){const H=this.f.getDocument(U),ee=i.Position.to(z),se=await this.g.prepareCallHierarchy(H,ee,K);if(!se)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(se)?se.map(Ve=>this.h(Ne,Ve)):[this.h(Ne,se)]}async provideCallsTo(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ee)return ee.map(se=>({from:this.h(U,se.from),fromRanges:se.fromRanges.map(Ne=>i.Range.from(Ne))}))}async provideCallsFrom(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ee)return ee.map(se=>({to:this.h(U,se.to),fromRanges:se.fromRanges.map(Ne=>i.Range.from(Ne))}))}releaseSession(U){this.e.delete(U)}h(U,z){const K=this.e.get(U),H=i.CallHierarchyItem.from(z,U,K.size.toString(36));return K.set(H._itemId,z),H}j(U,z){return this.e.get(U)?.get(z)}}class de{constructor(U,z){this.f=U,this.g=z,this.d=new R.$FO(""),this.e=new Map}async prepareSession(U,z,K){const H=this.f.getDocument(U),ee=i.Position.to(z),se=await this.g.prepareTypeHierarchy(H,ee,K);if(!se)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(se)?se.map(Ve=>this.h(Ne,Ve)):[this.h(Ne,se)]}async provideSupertypes(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,K);if(ee)return ee.map(se=>this.h(U,se))}async provideSubtypes(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,K);if(ee)return ee.map(se=>this.h(U,se))}releaseSession(U){this.e.delete(U)}h(U,z){const K=this.e.get(U),H=i.TypeHierarchyItem.from(z,U,K.size.toString(36));return K.set(H._itemId,z),H}j(U,z){return this.e.get(U)?.get(z)}}class Oe{constructor(U,z,K,H,ee){this.d=U,this.e=z,this.f=K,this.g=H,this.h=ee}async provideDocumentOnDropEdits(U,z,K,H,ee){const se=this.e.getDocument(z),Ne=i.Position.to(K),Ve=i.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,xe)).buffer),Ye=await this.f.provideDocumentDropEdits(se,Ne,Ve,ee);if(Ye)return(0,S.$3b)(Ye).map(xe=>({title:xe.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:xe.kind?.value,yieldTo:xe.yieldTo?.map(et=>"mimeType"in et?et:{kind:et.kind.value}),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?i.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}))}}class he{constructor(U,z){this.d=U,this.e=z}async provideMappedEdits(U,z,K,H){const ee=l.URI.revive(U),se=this.d.getDocument(ee),Ne=K.documents.map(xe=>xe.map(et=>({uri:l.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(ot=>i.Range.to(ot))}))),Ve={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(se,z,Ve,H);return Ye?i.WorkspaceEdit.from(Ye):null}}class Ce{constructor(U,z){this.adapter=U,this.extension=z}}class Ae{static{this.d=0}constructor(U,z,K,H,ee,se,Ne,Ve){this.g=z,this.h=K,this.j=H,this.k=ee,this.l=se,this.m=Ne,this.n=Ve,this.f=new Map,this.e=U.getProxy(v.$gM.MainThreadLanguageFeatures)}o(U,z){return i.DocumentSelector.from(U,this.g,z)}p(U){return new c.$iM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ae.d++}async s(U,z,K,H,ee,se=!1){const Ne=this.f.get(U);if(!Ne||!(Ne.adapter instanceof z))return H;const Ve=Date.now();se||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ye=K(Ne.adapter,Ne.extension);return Promise.resolve(Ye).catch(xe=>{(0,N.$4)(xe)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Ne.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),M.CancellationToken.isCancellationToken(ee)?(0,F.$9g)(Ye,ee):Ye}t(U,z){const K=this.q();return this.f.set(K,new Ce(U,z)),K}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,z,K,H){const ee=this.t(new u(this.h,K),U),se=H&&H.label||Ae.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(z,U),se),this.p(ee)}$provideDocumentSymbols(U,z,K){return this.s(U,u,H=>H.provideDocumentSymbols(l.URI.revive(z),K),void 0,K)}registerCodeLensProvider(U,z,K){const H=this.q(),ee=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new g(this.h,this.j.converter,K,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(z,U),ee);let se=this.p(H);if(ee!==void 0){const Ne=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(ee));se=c.$iM.from(se,Ne)}return se}$provideCodeLenses(U,z,K){return this.s(U,g,H=>H.provideCodeLenses(l.URI.revive(z),K),void 0,K)}$resolveCodeLens(U,z,K){return this.s(U,g,H=>H.resolveCodeLens(z,K),void 0,void 0)}$releaseCodeLenses(U,z){this.s(U,g,K=>Promise.resolve(K.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(U,z,K){const H=this.t(new b(this.h,K),U);return this.e.$registerDefinitionSupport(H,this.o(z,U)),this.p(H)}$provideDefinition(U,z,K,H){return this.s(U,b,ee=>ee.provideDefinition(l.URI.revive(z),K,H),[],H)}registerDeclarationProvider(U,z,K){const H=this.t(new f(this.h,K),U);return this.e.$registerDeclarationSupport(H,this.o(z,U)),this.p(H)}$provideDeclaration(U,z,K,H){return this.s(U,f,ee=>ee.provideDeclaration(l.URI.revive(z),K,H),[],H)}registerImplementationProvider(U,z,K){const H=this.t(new I(this.h,K),U);return this.e.$registerImplementationSupport(H,this.o(z,U)),this.p(H)}$provideImplementation(U,z,K,H){return this.s(U,I,ee=>ee.provideImplementation(l.URI.revive(z),K,H),[],H)}registerTypeDefinitionProvider(U,z,K){const H=this.t(new $(this.h,K),U);return this.e.$registerTypeDefinitionSupport(H,this.o(z,U)),this.p(H)}$provideTypeDefinition(U,z,K,H){return this.s(U,$,ee=>ee.provideTypeDefinition(l.URI.revive(z),K,H),[],H)}registerHoverProvider(U,z,K,H){const ee=this.t(new D(this.h,K),U);return this.e.$registerHoverProvider(ee,this.o(z,U)),this.p(ee)}$provideHover(U,z,K,H){return this.s(U,D,ee=>ee.provideHover(l.URI.revive(z),K,H),void 0,H)}registerEvaluatableExpressionProvider(U,z,K,H){const ee=this.t(new y(this.h,K),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(z,U)),this.p(ee)}$provideEvaluatableExpression(U,z,K,H){return this.s(U,y,ee=>ee.provideEvaluatableExpression(l.URI.revive(z),K,H),void 0,H)}registerInlineValuesProvider(U,z,K,H){const ee=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new C(this.h,K),U);this.e.$registerInlineValuesProvider(se,this.o(z,U),ee);let Ne=this.p(se);if(ee!==void 0){const Ve=K.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(ee));Ne=c.$iM.from(Ne,Ve)}return Ne}$provideInlineValues(U,z,K,H,ee){return this.s(U,C,se=>se.provideInlineValues(l.URI.revive(z),K,H,ee),void 0,ee)}registerDocumentHighlightProvider(U,z,K){const H=this.t(new A(this.h,K),U);return this.e.$registerDocumentHighlightProvider(H,this.o(z,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,z,K){const H=this.t(new G(this.h,K),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(z,U)),this.p(H)}$provideDocumentHighlights(U,z,K,H){return this.s(U,A,ee=>ee.provideDocumentHighlights(l.URI.revive(z),K,H),void 0,H)}$provideMultiDocumentHighlights(U,z,K,H,ee){return this.s(U,G,se=>se.provideMultiDocumentHighlights(l.URI.revive(z),K,H.map(Ne=>l.URI.revive(Ne)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,z,K){const H=this.t(new T(this.h,K),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(z,U)),this.p(H)}$provideLinkedEditingRanges(U,z,K,H){return this.s(U,T,async ee=>{const se=await ee.provideLinkedEditingRanges(l.URI.revive(z),K,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ae.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,z,K){const H=this.t(new V(this.h,K),U);return this.e.$registerReferenceSupport(H,this.o(z,U)),this.p(H)}$provideReferences(U,z,K,H,ee){return this.s(U,V,se=>se.provideReferences(l.URI.revive(z),K,H,ee),void 0,ee)}registerCodeActionProvider(U,z,K,H){const ee=new m.$Tc,se=this.t(new P(this.h,this.j.converter,this.k,K,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(se,this.o(z,U),{providedKinds:H?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:H?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,ee)}))},Ae.u(U),!!K.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(U,z,K,H,ee){return this.s(U,P,se=>se.provideCodeActions(l.URI.revive(z),K,H,ee),void 0,ee)}$resolveCodeAction(U,z,K){return this.s(U,P,H=>H.resolveCodeAction(z,K),{},void 0)}$releaseCodeActions(U,z){this.s(U,P,K=>Promise.resolve(K.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,z,K){const H=this.t(new q(this.h,K),U);return this.e.$registerDocumentFormattingSupport(H,this.o(z,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,z,K,H){return this.s(U,q,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(z),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,z,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ee=this.t(new re(this.h,K),U);return this.e.$registerRangeFormattingSupport(ee,this.o(z,U),U.identifier,U.displayName||U.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(U,z,K,H,ee){return this.s(U,re,se=>se.provideDocumentRangeFormattingEdits(l.URI.revive(z),K,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,z,K,H,ee){return this.s(U,re,se=>se.provideDocumentRangesFormattingEdits(l.URI.revive(z),K,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,z,K,H){const ee=this.t(new ue(this.h,K),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(z,U),H,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,z,K,H,ee,se){return this.s(U,ue,Ne=>Ne.provideOnTypeFormattingEdits(l.URI.revive(z),K,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(U,z){const K=this.t(new ye(z,this.l),U);return this.e.$registerNavigateTypeSupport(K,typeof z.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(U,z,K){return this.s(U,ye,H=>H.provideWorkspaceSymbols(z,K),{symbols:[]},K)}$resolveWorkspaceSymbol(U,z,K){return this.s(U,ye,H=>H.resolveWorkspaceSymbol(z,K),void 0,void 0)}$releaseWorkspaceSymbols(U,z){this.s(U,ye,K=>K.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(U,z,K){const H=this.t(new Se(this.h,K,this.l),U);return this.e.$registerRenameSupport(H,this.o(z,U),Se.supportsResolving(K)),this.p(H)}$provideRenameEdits(U,z,K,H,ee){return this.s(U,Se,se=>se.provideRenameEdits(l.URI.revive(z),K,H,ee),void 0,ee)}$resolveRenameLocation(U,z,K,H){return this.s(U,Se,ee=>ee.resolveRenameLocation(l.URI.revive(z),K,H),void 0,H)}registerNewSymbolNamesProvider(U,z,K){const H=this.t(new le(this.h,K,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(z,U)),this.p(H)}$provideNewSymbolNames(U,z,K,H){return this.s(U,le,ee=>ee.provideNewSymbolNames(l.URI.revive(z),K,H),void 0,H)}registerDocumentSemanticTokensProvider(U,z,K,H){const ee=this.t(new _(this.h,K),U),se=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(z,U),H,se);let Ne=this.p(ee);if(se){const Ve=K.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(se));Ne=c.$iM.from(Ne,Ve)}return Ne}$provideDocumentSemanticTokens(U,z,K,H){return this.s(U,_,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(z),K,H),null,H)}$releaseDocumentSemanticTokens(U,z){this.s(U,_,K=>K.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,z,K,H){const ee=this.t(new ve(this.h,K),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(z,U),H),this.p(ee)}$provideDocumentRangeSemanticTokens(U,z,K,H){return this.s(U,ve,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(z),K,H),null,H)}registerCompletionItemProvider(U,z,K,H){const ee=this.t(new ne(this.h,this.j.converter,K,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(z,U),H,ne.supportsResolving(K),U.identifier),this.p(ee)}$provideCompletionItems(U,z,K,H,ee){return this.s(U,ne,se=>se.provideCompletionItems(l.URI.revive(z),K,H,ee),void 0,ee)}$resolveCompletionItem(U,z,K){return this.s(U,ne,H=>H.resolveCompletionItem(z,K),void 0,K)}$releaseCompletionItems(U,z){this.s(U,ne,K=>K.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(U,z,K,H){const ee=new W(U,this.h,K,this.j.converter),se=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(se,this.o(z,U),ee.supportsHandleEvents,n.$Cm.toKey(U.identifier.value),H?.yieldTo?.map(Ne=>n.$Cm.toKey(Ne))||[]),this.p(se)}$provideInlineCompletions(U,z,K,H,ee){return this.s(U,fe,se=>se.provideInlineCompletions(l.URI.revive(z),K,H,ee),void 0,ee)}$handleInlineCompletionDidShow(U,z,K,H){this.s(U,fe,async ee=>{ee.handleDidShowCompletionItem(z,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,z,K,H,ee){this.s(U,fe,async se=>{se.handlePartialAccept(z,K,H,ee)},void 0,void 0)}$freeInlineCompletionsList(U,z){this.s(U,fe,async K=>{K.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(U,z,K){const H=new te(U,this.h,K,this.j.converter),ee=this.t(H,U);return this.e.$registerInlineEditProvider(ee,this.o(z,U),U.identifier),this.p(ee)}$provideInlineEdit(U,z,K,H){return this.s(U,te,ee=>ee.provideInlineEdits(l.URI.revive(z),K,H),void 0,H)}$freeInlineEdit(U,z){this.s(U,te,async K=>{K.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(U,z,K,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Te(this.h,K),U);return this.e.$registerSignatureHelpProvider(se,this.o(z,U),ee),this.p(se)}$provideSignatureHelp(U,z,K,H,ee){return this.s(U,Te,se=>se.provideSignatureHelp(l.URI.revive(z),K,H,ee),void 0,ee)}$releaseSignatureHelp(U,z){this.s(U,Te,K=>K.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(U,z,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ie(this.h,this.j.converter,K,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(z,U),typeof K.resolveInlayHint=="function",H,Ae.u(U));let se=this.p(ee);if(H!==void 0){const Ne=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));se=c.$iM.from(se,Ne)}return se}$provideInlayHints(U,z,K,H){return this.s(U,Ie,ee=>ee.provideInlayHints(l.URI.revive(z),K,H),void 0,H)}$resolveInlayHint(U,z,K){return this.s(U,Ie,H=>H.resolveInlayHint(z,K),void 0,K)}$releaseInlayHints(U,z){this.s(U,Ie,K=>K.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(U,z,K){const H=this.t(new pe(this.h,K),U);return this.e.$registerDocumentLinkProvider(H,this.o(z,U),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,z,K){return this.s(U,pe,H=>H.provideLinks(l.URI.revive(z),K),void 0,K,z.scheme==="output")}$resolveDocumentLink(U,z,K){return this.s(U,pe,H=>H.resolveLink(z,K),void 0,void 0,!0)}$releaseDocumentLinks(U,z){this.s(U,pe,K=>K.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(U,z,K){const H=this.t(new ge(this.h,K),U);return this.e.$registerDocumentColorProvider(H,this.o(z,U)),this.p(H)}$provideDocumentColors(U,z,K){return this.s(U,ge,H=>H.provideColors(l.URI.revive(z),K),[],K)}$provideColorPresentations(U,z,K,H){return this.s(U,ge,ee=>ee.provideColorPresentations(l.URI.revive(z),K,H),void 0,H)}registerFoldingRangeProvider(U,z,K){const H=this.q(),ee=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new J(this.h,K),U)),this.e.$registerFoldingRangeProvider(H,this.o(z,U),U.identifier,ee);let se=this.p(H);if(ee!==void 0){const Ne=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=c.$iM.from(se,Ne)}return se}$provideFoldingRanges(U,z,K,H){return this.s(U,J,ee=>ee.provideFoldingRanges(l.URI.revive(z),K,H),void 0,H)}registerSelectionRangeProvider(U,z,K){const H=this.t(new X(this.h,K,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(z,U)),this.p(H)}$provideSelectionRanges(U,z,K,H){return this.s(U,X,ee=>ee.provideSelectionRanges(l.URI.revive(z),K,H),[],H)}registerCallHierarchyProvider(U,z,K){const H=this.t(new ce(this.h,K),U);return this.e.$registerCallHierarchyProvider(H,this.o(z,U)),this.p(H)}$prepareCallHierarchy(U,z,K,H){return this.s(U,ce,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(z),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,z,K,H){return this.s(U,ce,ee=>ee.provideCallsTo(z,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,z,K,H){return this.s(U,ce,ee=>ee.provideCallsFrom(z,K,H),void 0,H)}$releaseCallHierarchy(U,z){this.s(U,ce,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(U,z,K){const H=this.t(new de(this.h,K),U);return this.e.$registerTypeHierarchyProvider(H,this.o(z,U)),this.p(H)}$prepareTypeHierarchy(U,z,K,H){return this.s(U,de,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(z),K,H)),void 0,H)}$provideTypeHierarchySupertypes(U,z,K,H){return this.s(U,de,ee=>ee.provideSupertypes(z,K,H),void 0,H)}$provideTypeHierarchySubtypes(U,z,K,H){return this.s(U,de,ee=>ee.provideSubtypes(z,K,H),void 0,H)}$releaseTypeHierarchy(U,z){this.s(U,de,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,z,K,H){const ee=this.q();return this.f.set(ee,new Ce(new Oe(this.e,this.h,K,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(z,U),(0,h.$5F)(U,"dropMetadata")?H:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,z,K,H,ee,se){return this.s(U,Oe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(z,l.URI.revive(K),H,ee,se)),void 0,void 0)}registerMappedEditsProvider(U,z,K){const H=this.t(new he(this.h,K),U);return this.e.$registerMappedEditsProvider(H,this.o(z,U)),this.p(H)}$provideMappedEdits(U,z,K,H,ee){return this.s(U,he,se=>Promise.resolve(se.provideMappedEdits(z,K,H,ee)),null,ee)}registerDocumentPasteEditProvider(U,z,K,H){const ee=this.q();return this.f.set(ee,new Ce(new L(this.e,this.h,K,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(z,U),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,z,K,H,ee){return this.s(U,L,se=>se.prepareDocumentPaste(l.URI.revive(z),K,H,ee),void 0,ee)}$providePasteEdits(U,z,K,H,ee,se,Ne){return this.s(U,L,Ve=>Ve.providePasteEdits(z,l.URI.revive(K),H,ee,se,Ne),void 0,Ne)}$resolvePasteEdit(U,z,K){return this.s(U,L,H=>H.resolvePasteEdit(z,K),{},void 0)}$releasePasteEdits(U,z){this.s(U,L,K=>Promise.resolve(K.releasePasteEdits(z)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Ae.w(U.decreaseIndentPattern),increaseIndentPattern:Ae.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ae.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ae.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Ae.w(U.beforeText),afterText:U.afterText?Ae.w(U.afterText):void 0,previousLineText:U.previousLineText?Ae.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Ae.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(z=>c.SyntaxTokenType.toString(z)):void 0}}static D(U){return U.map(Ae.C)}setLanguageConfiguration(U,z,K){const{wordPattern:H}=K;if(H&&(0,O.$0e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(z,H):this.h.setWordDefinitionFor(z,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),se={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,z,se),this.p(ee)}$setWordDefinitions(U){for(const z of U)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Kic=Ae}),define(Me[88],Re([1,0,6,4,8,7,101,20,11,5,166,106,14,3,17,84,13]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=void 0,e.$Ric=(0,w.$hi)("IExtHostLanguageModels");class n{constructor(t,v){this.option=t,this.stream=new d.$Kh,this.stream=v??new d.$Kh}}class i{constructor(){this.a=new Map,this.b=new d.$Kh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let v=this.a.get(t.index);v||(this.a.size===0?v=new n(t.index,this.b):v=new n(t.index),this.a.set(t.index,v)),v.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const v of this.f())v.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let c=class{static{s=this}static{this.a=1}constructor(t,v,u){this.j=v,this.k=u,this.c=new k.$7d,this.d=new k.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Em,this.i=new Map,this.o=new Set,this.b=t.getProxy(F.$gM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,v,u,g){const a=s.a++;this.f.set(a,{extension:t.identifier,provider:u,languageModelId:v});let b;return g.auth&&(b={providerLabel:t.displayName||t.name,accountLabel:typeof g.auth=="object"?g.auth.label:void 0}),this.b.$registerLanguageModelProvider(a,v,{extension:t.identifier,identifier:v,model:g.name??"",auth:b}),(0,S.$Sc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(t,v,u,g,a,b){const f=this.f.get(t);if(!f)return;const I=new R.$Pv(async $=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:$.index,part:$.part})});return f.provider.provideLanguageModelResponse2(g.map(M.LanguageModelMessage.to),a,m.$Cm.toKey(u),I,b)}$updateLanguageModels(t){const v=[],u=[];if(t.added)for(const g of t.added)this.g.set(g.identifier,g),v.push(g.model);if(t.removed)for(const g of t.removed){this.g.delete(g),u.push(g);for(const[a,b]of this.i)b.languageModelId===g&&(b.res.reject(new l.$5),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(v),removed:Object.freeze(u)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const v=new Array;for(const{from:u,to:g,enabled:a}of t){const b=this.h.get(u)??new m.$Dm;if(b.has(g)!==a){a?b.add(g):b.delete(g),this.h.set(u,b);const I={from:u,to:g};v.push(I),this.c.fire(I)}}}async sendChatRequest(t,v,u,g,a){const b=t.identifier,f=await this.b.$prepareChatAccess(b,v,g.justification);if(!f||!this.g.has(v))throw N.$nO.NotFound(`Language model '${v}' is unknown.`);if(this.m(b,f)&&(!await this.l(t,{identifier:f.extension,displayName:f.auth.providerLabel},g.justification,g.silent)||!this.h.get(b)?.has(f.extension)))throw N.$nO.NoPermissions(`Language model '${v}' cannot be used by '${b.value}'.`);const I=Math.random()*1e6|0,$=this.b.$fetchResponse(b,v,I,u.map(M.LanguageModelMessage.from),g.modelOptions??{},a),D=new d.$gh,y=new i;this.i.set(I,{languageModelId:v,res:y});let C;if($.catch(A=>{D.isOpen()?y.reject(A):C=A}).finally(()=>{this.i.delete(I),y.resolve(),D.open()}),await D.wait(),C)throw new N.$nO(`Language model '${v}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,v){const u=this.i.get(t);u&&u.res.handleFragment(v)}async l(t,v,u,g){const a=E.$iL+v.identifier.value;if(await this.k.getSession(t,a,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0;if(g)return!1;try{const f=u?(0,O.localize)(0,null,v.displayName,u):(0,O.localize)(1,null,v.displayName);return await this.k.getSession(t,a,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0}catch{return!1}}m(t,v){return!!v.auth&&!m.$Cm.equals(v.extension,t)}async n(t){for(const v of this.o)try{await this.l(v,{identifier:t.extension,displayName:""},void 0,!0)}catch(u){this.j.error("Fake Auth request failed"),this.j.error(u)}}createLanguageModelAccessInformation(t){this.o.add(t);const v=this,u=k.Event.signal(k.Event.filter(this.c.event,a=>m.$Cm.equals(a.from,t.identifier))),g=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(u,g)},canSendRequest(a){const b=v.g.get(a);if(!b)return;if(!v.m(t.identifier,b))return!0;const f=v.h.get(t.identifier);if(f)return f.has(b.extension)}}}};e.$Sic=c,e.$Sic=c=s=Je([qe(0,p.$AO),qe(1,o.$Nj),qe(2,r.$Mic)],c)}),define(Me[262],Re([1,0,4,8,7,32,11,6,22]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;class k{constructor(E,l,w,p){this.c=l,this.d=w,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(S.$gM.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,l){await this.a.$changeLanguage(E,l);const w=this.c.getDocumentData(E);if(!w)throw new Error(`document '${E.toString()}' NOT found`);return w.document}async tokenAtPosition(E,l){const w=E.version,p=F.Position.from(l),r=await this.a.$tokensAtPosition(E.uri,p),o={type:M.StandardTokenType.Other,range:E.getWordRangeAtPosition(l)??new M.$kM(l.line,l.character,l.line,l.character)};if(!r)return o;const s={range:F.Range.to(r.range),type:F.TokenType.to(r.type)};return!s.range.contains(l)||w!==E.version?o:s}createLanguageStatusItem(E,l,w){const p=this.f++,r=this.a,o=this.g,s=`${E.identifier.value}/${l}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(s);const n={selector:w,id:l,name:E.displayName??E.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${l}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$jh)(()=>{c.clear(),this.a.$setLanguageStatus(p,{id:s,name:n.name??E.displayName??E.name,source:E.displayName??E.name,selector:F.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?N.default.Error:n.severity===M.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),r.$removeLanguageStatus(p),o.delete(s)},get id(){return n.id},get name(){return n.name},set name(v){n.name=v,h()},get selector(){return n.selector},set selector(v){n.selector=v,h()},get text(){return n.text},set text(v){n.text=v,h()},set text2(v){(0,d.$6F)(E,"languageStatusText"),n.text=v,h()},get text2(){return(0,d.$6F)(E,"languageStatusText"),n.text},get detail(){return n.detail},set detail(v){n.detail=v,h()},get severity(){return n.severity},set severity(v){n.severity=v,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(v){n.accessibilityInformation=v,h()},get command(){return n.command},set command(v){n.command=v,h()},get busy(){return n.busy},set busy(v){n.busy=v,h()}};return h(),t}}e.$_jc=k}),define(Me[263],Re([1,0,12,2,8,7,83]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Wjc=void 0;class m{constructor(E,l,w,p){this.start=E,this.deletedCount=l,this.deletedItems=w,this.items=p}asApiEvent(){return{range:new N.$JN(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,l,w){this.notebook=E,this.h=l,this.j=w,this.handle=w.handle,this.uri=F.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(M.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return E.g},set mime(p){E.g=p},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(w)}return this.f}setOutputs(E){this.a=E.map(M.NotebookCellOutput.to)}setOutputItems(E,l,w){const p=w.map(M.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===E);if(r&&(l||(r.items.length=0),r.items.push(...p),r.items.length>1&&r.items.every(o=>R.$dK(o.mime)))){const o=new Map,s=[];r.items.forEach(n=>{let i;o.has(n.mime)?i=o.get(n.mime):(i=[],o.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=R.$eK(o.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Wjc=d;class k{static{this.a=0}constructor(E,l,w,p,r){this.k=E,this.l=l,this.m=w,this.uri=p,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,l={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===S.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(w){return w=E.n(w),E.b[w].apiCell},getCells(w){return(w?E.p(w):E.b).map(r=>r.apiCell)},save(){return E.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,l,w){this.g=E.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:w});const p={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},r=[];for(const s of E.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,p.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,p.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=o.get(n.cell);if(i===void 0){const c=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else p.cellChanges[i]={...p.cellChanges[i],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let l=E.start|0,w=E.end|0;return l<0&&(l=0),w>this.b.length&&(w=this.b.length),E.with({start:l,end:w})}p(E){E=this.o(E);const l=[];for(let w=E.start;w<E.end;w++)l.push(this.b[w]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,l,w){if(this.j)return;const p=[],r=[],o=[];if(E.reverse().forEach(s=>{const i=s[2].map(t=>{const v=new d(this,this.l,t);return l||r.push(d.asModelAddData(t)),v}),c=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),c.deletedItems.push(t.apiCell);p.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),w)for(const s of p)w.push(s.asApiEvent())}s(E,l,w,p){const r=this.b.splice(E,l);this.b.splice(w,0,...r);const o=[new m(E,l,r.map(s=>s.apiCell),[]),new m(w,0,[],r)];for(const s of o)p.push(s.asApiEvent())}t(E,l){this.b[E].setOutputs(l)}u(E,l,w,p){this.b[E].setOutputItems(l,w,p)}v(E,l){const w=this.b[E];w.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(w.uri,l)}w(E,l){const w=this.b[E];w.apiCell.mime=l}x(E,l){this.b[E].setMetadata(l)}y(E,l){this.b[E].setInternalMetadata(l)}getCellFromApiCell(E){return this.b.find(l=>l.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(l=>l.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Xjc=k}),define(Me[264],Re([1,0,5,2,8,7]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;class R{constructor(d,k,O,E={timeout:1500,errors:3}){this.b=d,this.c=k,this.d=O,this.f=E,this.a=new S.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(k,O,E)=>{const l=function(p){k.call(O,p)};return l.extension=d,this.a.event(l,void 0,E)}}async $participateInSave(d,k,O){const E=F.URI.revive(d),l=this.c.getNotebookDocument(E);if(!l)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:M.TextDocumentSaveReason.to(k)},O,async(r,o)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!O.isCancellationRequested&&n&&(n instanceof N.$sM?w.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(w.length===0)return!0;const p={edits:[]};for(const r of w){const{edits:o}=M.WorkspaceEdit.from(r);p.edits=p.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$bkc=R}),define(Me[112],Re([1,0,14,8,7]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,d,k,O,E,l){this.id=m,this.f=d,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=O,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(d){this.selections=[d]},get selections(){return m.a},set selections(d){if(!Array.isArray(d)||!d.every(M.$JN.isNotebookRange))throw(0,S.$7)("selections");m.a=d,m.g(d)},get visibleRanges(){return m.b},revealRange(d,k){m.f.$tryRevealRange(m.id,F.NotebookRange.from(d),k??M.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(F.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Yjc=N}),define(Me[265],Re([1,0,5,13,8]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;let N=class{constructor(m,d){this.c=m,this.d=d,this.a=new S.$7d,this.b=new S.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,d);const k=this.d.getEditorById(m);d.visibleRanges&&k._acceptVisibleRanges(d.visibleRanges.ranges.map(M.NotebookRange.to)),d.selections&&k._acceptSelections(d.selections.selections.map(M.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const d in m)this.d.getEditorById(d)._acceptViewColumn(M.ViewColumn.to(m[d]))}};e.$dkc=N,e.$dkc=N=Je([qe(0,F.$Nj)],N)}),define(Me[266],Re([1,0,5,4,112]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class N{constructor(m,d){this.c=d,this.a=new Map,this.b=m.getProxy(F.$gM.MainThreadNotebookRenderers)}$postRendererMessage(m,d,k){const O=this.c.getEditorById(m);this.a.get(d)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(m,d){if(!m.contributes?.notebookRenderer?.some(O=>O.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(O,E,l)=>this.d(d).event(O,E,l),postMessage:(O,E)=>{M.$Yjc.apiEditorsToExtHost.has(O)&&([O,E]=[E,O]);const l=E&&M.$Yjc.apiEditorsToExtHost.get(E);return this.b.$postMessage(l?.id,d,O)}}}d(m){let d=this.a.get(m);return d||(d=new S.$7d({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(m)}}),this.a.set(m,d),d)}}e.$gkc=N}),define(Me[267],Re([1,0,8,101,25,68,14]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class m{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,l,w){const p=this.b++,{title:r,location:o,cancellable:s}=l,n={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(p,{location:S.ProgressLocation.from(o),title:r,source:n,cancellable:s},E.isUnderDevelopment?void 0:E.identifier.value).catch(R.$2),this.d(p,w,!!s)}d(E,l,w){let p;w&&(p=new M.$ee,this.c.set(E,p));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),p?.dispose()};let o;try{o=l(new k(this.a,E),w&&p?p.token:M.CancellationToken.None)}catch(s){throw r(E),s}return o.then(s=>r(E),s=>r(E)),o}$acceptProgressCanceled(E){const l=this.c.get(E);l&&(l.cancel(),this.c.delete(E))}}e.$kkc=m;function d(O,E){return O.message=E.message,typeof E.increment=="number"&&(typeof O.increment=="number"?O.increment+=E.increment:O.increment=E.increment),O}class k extends F.$Pv{constructor(E,l){super(w=>this.throttledReport(w)),this.c=E,this.d=l}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,N.$Nh)(100,(O,E)=>d(O,E),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Me[268],Re([1,0,2,4,11,8]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;class R{static{this.a=0}constructor(d,k){this.d=k,this.c=new Map,this.b=d.getProxy(F.$gM.MainThreadQuickDiff)}$provideOriginalResource(d,k,O){const E=S.URI.revive(k),l=this.c.get(d);return l?(0,M.$_g)(()=>l.provideOriginalResource(E,O)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(d,k,O,E){const l=R.a++;return this.c.set(l,k),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(d,this.d),O,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$lkc=R}),define(Me[269],Re([1,0,25,5,6,4,2,7,14,18,32,40,22,8]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=p;function p(r,o,s){const n=r.getProxy(N.$gM.MainThreadQuickOpen);class i{constructor(f,I){this.e=new Map,this.f=0,this.a=f,this.b=I}showQuickPick(f,I,$,D=S.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),C=++this.f,A=n.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},D),G={},T=A.then(()=>G);return Promise.race([T,y]).then(V=>{if(V===G)return;const P=(0,l.$5F)(f,"quickPickItemTooltip");return y.then(L=>{const q=[];for(let re=0;re<L.length;re++){const ue=L[re];if(typeof ue=="string")q.push({label:ue,handle:re});else if(ue.kind===m.QuickPickItemKind.Separator)q.push({type:"separator",label:ue.label});else{ue.tooltip&&!P&&console.warn(`Extension '${f.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`);const ye=ue.iconPath?u(ue.iconPath):void 0;q.push({label:ue.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:P?w.MarkdownString.fromStrict(ue.tooltip):void 0,handle:re})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=re=>{$.onDidSelectItem(L[re])}),n.$setItems(C,q),A.then(re=>{if(typeof re=="number")return L[re];if(Array.isArray(re))return re.map(ue=>L[ue])})})}).then(void 0,V=>{if(!(0,d.$4)(V))return n.$setError(C,V),Promise.reject(V)})}$onItemSelected(f){this.c?.(f)}showInput(f,I=S.CancellationToken.None){return this.d=f?.validateInput,n.$input(f,typeof this.d=="function",I).then(void 0,$=>{if(!(0,d.$4)($))return Promise.reject($)})}async $validateInput(f){if(!this.d)return;const I=await this.d(f);if(!I||typeof I=="string")return I;let $;switch(I.severity){case m.InputBoxValidationSeverity.Info:$=O.default.Info;break;case m.InputBoxValidationSeverity.Warning:$=O.default.Warning;break;case m.InputBoxValidationSeverity.Error:$=O.default.Error;break;default:$=I.message?O.default.Error:O.default.Ignore;break}return{content:I.message,severity:$}}async showWorkspaceFolderPick(f,I=S.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[f]);if(!$)return;const D=await this.a.getWorkspaceFolders2();if(D)return D.find(y=>y.uri.toString()===$.uri.toString())}createQuickPick(f){const I=new g(f,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(f){const I=new a(f,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(f,I){this.e.get(f)?._fireDidChangeValue(I)}$onDidAccept(f){this.e.get(f)?._fireDidAccept()}$onDidChangeActive(f,I){const $=this.e.get(f);$ instanceof g&&$._fireDidChangeActive(I)}$onDidChangeSelection(f,I){const $=this.e.get(f);$ instanceof g&&$._fireDidChangeSelection(I)}$onDidTriggerButton(f,I){this.e.get(f)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(f,I,$){const D=this.e.get(f);D instanceof g&&D._fireDidTriggerItemButton(I,$)}$onDidHide(f){this.e.get(f)?._fireDidHide()}}class c{static{this.a=1}constructor(f,I){this.x=f,this.y=I,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$7d,this.q=new F.$7d,this.r=new F.$7d,this.s=new F.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(f){this.b=f,this.z({title:f})}get step(){return this.c}set step(f){this.c=f,this.z({step:f})}get totalSteps(){return this.d}set totalSteps(f){this.d=f,this.z({totalSteps:f})}get enabled(){return this.g}set enabled(f){this.g=f,this.z({enabled:f})}get busy(){return this.j}set busy(f){this.j=f,this.z({busy:f})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(f){this.k=f,this.z({ignoreFocusOut:f})}get value(){return this.l}set value(f){this.l=f,this.z({value:f})}get placeholder(){return this.m}set placeholder(f){this.m=f,this.z({placeholder:f})}get buttons(){return this.n}set buttons(f){this.n=f.slice(),this.o.clear(),f.forEach((I,$)=>{const D=I===m.$GN.Back?-1:$;this.o.set(D,I)}),this.z({buttons:f.map((I,$)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===m.$GN.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(f){this.l=f,this.q.fire(f)}_fireDidTriggerButton(f){const I=this.o.get(f);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(f){if(!this.v){for(const I of Object.keys(f)){const $=f[I];this.u[I]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(b){if(b instanceof m.$eN)return{id:b.id};const f=v(b),I=t(b);return{dark:typeof f=="string"?R.URI.file(f):f,light:typeof I=="string"?R.URI.file(I):I}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function v(b){return typeof b=="object"&&"dark"in b?b.dark:b}function u(b){const f=h(b);let I,$;return"id"in f?$=E.ThemeIcon.asClassName(f):I=f,{iconPath:I,iconClass:$}}class g extends c{constructor(f,I){super(f.identifier,I),this.O=f,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$7d,this.L=[],this.M=new F.$7d,this.N=new F.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(f){this.B=f.slice(),this.C.clear(),this.D.clear(),f.forEach((D,y)=>{this.C.set(y,D),this.D.set(D,y)});const I=(0,l.$5F)(this.O,"quickPickItemTooltip"),$=[];for(let D=0;D<f.length;D++){const y=f[D];if(y.kind===m.QuickPickItemKind.Separator)$.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?u(y.iconPath):void 0;$.push({handle:D,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?w.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((A,G)=>({...u(A.iconPath),tooltip:A.tooltip,handle:G}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(f){this.E=f,this.z({canSelectMany:f})}get matchOnDescription(){return this.F}set matchOnDescription(f){this.F=f,this.z({matchOnDescription:f})}get matchOnDetail(){return this.G}set matchOnDetail(f){this.G=f,this.z({matchOnDetail:f})}get sortByLabel(){return this.H}set sortByLabel(f){this.H=f,this.z({sortByLabel:f})}get keepScrollPosition(){return this.I}set keepScrollPosition(f){this.I=f,this.z({keepScrollPosition:f})}get activeItems(){return this.J}set activeItems(f){this.J=f.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(f){this.L=f.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(f){const I=(0,k.$Hb)(f.map($=>this.C.get($)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(f){const I=(0,k.$Hb)(f.map($=>this.C.get($)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(f,I){const $=this.C.get(f);if(!$||!$.buttons||!$.buttons.length)return;const D=$.buttons[I];D&&this.N.fire({button:D,item:$})}}class a extends c{constructor(f,I){super(f.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(f){this.B=f,this.z({password:f})}get prompt(){return this.C}set prompt(f){this.C=f,this.z({prompt:f})}get valueSelection(){return this.D}set valueSelection(f){this.D=f,this.z({valueSelection:f})}get validationMessage(){return this.E}set validationMessage(f){this.E=f,f?typeof f=="string"?this.z({validationMessage:f,severity:O.default.Error}):this.z({validationMessage:f.message,severity:f.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new i(o,s)}}),define(Me[270],Re([1,0,2,5,68,6,11,4,18,142,13,20,40,8,22,12,21]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=void 0;function n(C){return C instanceof S.URI}function i(C,A){return C.scheme===r.Schemas.file&&A.scheme===r.Schemas.file&&o.$k?C.toString()===A.toString():C.toString().toLowerCase()===A.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?S.URI.file(C.iconPath):S.URI.isUri(C.iconPath)||l.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(S.URI.isUri(C.icon))return C.icon;if(l.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const A=C.icon;return{light:A.light,dark:A.dark}}}else return}function t(C,A){if(!C.iconPath&&!A.iconPath)return 0;if(C.iconPath){if(!A.iconPath)return 1}else return-1;const G=typeof C.iconPath=="string"?C.iconPath:S.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,T=typeof A.iconPath=="string"?A.iconPath:S.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id;return(0,k.$$q)(G,T)}function v(C,A){let G=0;if(C.strikeThrough!==A.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==A.faded)return C.faded?1:-1;if(C.tooltip!==A.tooltip)return(C.tooltip||"").localeCompare(A.tooltip||"");if(G=t(C,A),G!==0)return G;if(C.light&&A.light)G=t(C.light,A.light);else{if(C.light)return 1;if(A.light)return-1}if(G!==0)return G;if(C.dark&&A.dark)G=t(C.dark,A.dark);else{if(C.dark)return 1;if(A.dark)return-1}return G}function u(C,A){if(C.command!==A.command)return C.command<A.command?-1:1;if(C.title!==A.title)return C.title<A.title?-1:1;if(C.tooltip!==A.tooltip){if(C.tooltip!==void 0&&A.tooltip!==void 0)return C.tooltip<A.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(A.tooltip!==void 0)return-1}if(C.arguments===A.arguments)return 0;if(C.arguments)if(A.arguments){if(C.arguments.length!==A.arguments.length)return C.arguments.length-A.arguments.length}else return 1;else return-1;for(let G=0;G<C.arguments.length;G++){const T=C.arguments[G],V=A.arguments[G];if(T!==V&&!(n(T)&&n(V)&&i(T,V)))return T<V?-1:1}return 0}function g(C,A){let G=(0,k.$$q)(C.resourceUri.fsPath,A.resourceUri.fsPath,!0);if(G!==0)return G;if(C.command&&A.command)G=u(C.command,A.command);else{if(C.command)return 1;if(A.command)return-1}if(G!==0)return G;if(C.decorations&&A.decorations)G=v(C.decorations,A.decorations);else{if(C.decorations)return 1;if(A.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&A.multiFileDiffEditorModifiedUri)G=(0,k.$$q)(C.multiFileDiffEditorModifiedUri.fsPath,A.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(A.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&A.multiDiffEditorOriginalUri)G=(0,k.$$q)(C.multiDiffEditorOriginalUri.fsPath,A.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(A.multiDiffEditorOriginalUri)return-1}return G}function a(C,A){for(let G=0;G<C.length;G++)if(C[G]!==A[G])return!1;return!0}function b(C,A){return C.command===A.command&&C.title===A.title&&C.tooltip===A.tooltip&&(C.arguments&&A.arguments?a(C.arguments,A.arguments):C.arguments===A.arguments)}function f(C,A){return(0,d.$ub)(C,A,b)}class I{#e;#t;get value(){return this.d}set value(A){A=A??"",this.#e.$setInputBoxValue(this.l,A),this.n(A)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(A){this.#e.$setInputBoxPlaceholder(this.l,A),this.f=A}get validateInput(){return(0,p.$6F)(this.k,"scmValidation"),this.g}set validateInput(A){if((0,p.$6F)(this.k,"scmValidation"),A&&typeof A!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=A,this.#e.$setValidationProviderIsEnabled(this.l,!!A)}get enabled(){return this.h}set enabled(A){A=!!A,this.h!==A&&(this.h=A,this.#e.$setInputBoxEnablement(this.l,A))}get visible(){return this.j}set visible(A){A=!!A,this.j!==A&&(this.j=A,this.#e.$setInputBoxVisibility(this.l,A))}get document(){return(0,p.$6F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(A,G,T,V,P){this.k=A,this.l=V,this.m=P,this.d="",this.e=new F.$7d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=T}showValidationMessage(A,G){(0,p.$6F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,A,G)}$onInputBoxValueChange(A){this.n(A)}n(A){this.d=A,this.e.fire(A)}}e.$nkc=I;class ${static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(A){this.v=A,this.q.$updateGroupLabel(this.t,this.handle,A)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(A){this.p=A,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(A){this.f=[...A],this.k.fire()}constructor(A,G,T,V,P,L,q){this.q=A,this.s=G,this.t=T,this.u=V,this.v=P,this.multiDiffEditorEnableViewChanges=L,this.w=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(A){return this.g.get(A)}$executeResourceCommand(A,G){const T=this.h.get(A);return T?(0,R.$_g)(()=>this.s.executeCommand(T.command,...T.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const A=[...this.f].sort(g),T=(0,d.$Db)(this.o,A,g).map(L=>{const q=L.toInsert.map(re=>{const ue=this.e++;this.g.set(ue,re);const ye=re.resourceUri;let Se;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const ge=new N.$Tc;Se=this.s.converter.toInternal(re.command,ge),this.j.set(ue,ge)}else this.h.set(ue,re.command);const le=(0,p.$5F)(this.w,"scmMultiDiffEditor"),we=le?re.multiDiffEditorOriginalUri:void 0,_=le?re.multiFileDiffEditorModifiedUri:void 0,ve=c(re.decorations),ne=re.decorations&&c(re.decorations.light)||ve,fe=re.decorations&&c(re.decorations.dark)||ve,W=[ne,fe],te=re.decorations&&re.decorations.tooltip||"",Ee=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,Ie=re.contextValue||"";return{rawResource:[ue,ye,W,te,Ee,Te,Ie,Se,we,_],handle:ue}});return{start:L.start,deleteCount:L.deleteCount,toInsert:q}}),V=T.map(({start:L,deleteCount:q,toInsert:re})=>[L,q,re.map(ue=>ue.rawResource)]),P=T.reverse();for(const{start:L,deleteCount:q,toInsert:re}of P){const ue=re.map(Se=>Se.handle),ye=this.n.splice(L,q,...ue);for(const Se of ye)this.g.delete(Se),this.h.delete(Se),this.j.get(Se)?.dispose(),this.j.delete(Se)}return this.o=A,V}dispose(){this.l=!0,this.m.fire()}}class D{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(A){this.g!==A&&(this.g=A,this.#e.$updateSourceControl(this.w,{count:A}))}get quickDiffProvider(){return this.h}set quickDiffProvider(A){this.h=A;let G;(0,p.$5F)(this.x,"quickDiffProvider")&&(G=A?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!A,quickDiffLabel:G})}get historyProvider(){return(0,p.$6F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(A){(0,p.$6F)(this.x,"scmHistoryProvider"),this.j=A,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!A}),A&&this.k.value.add(A.onDidChangeCurrentHistoryItemGroup(()=>{this.l=A?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(A){A!==this.m&&(this.m=A,this.#e.$updateSourceControl(this.w,{commitTemplate:A}))}get acceptInputCommand(){return this.o}set acceptInputCommand(A){this.n.value=new N.$Tc,this.o=A;const G=this.y.converter.toInternal(A,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,p.$6F)(this.x,"scmActionButton"),this.q}set actionButton(A){(0,p.$6F)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=A;const G=A!==void 0?{command:this.y.converter.toInternal(A.command,this.p.value),secondaryCommands:A.secondaryCommands?.map(T=>T.map(V=>this.y.converter.toInternal(V,this.p.value))),description:A.description,enabled:A.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(A){if(this.t&&A&&f(this.t,A))return;this.s.value=new N.$Tc,this.t=A;const G=(A||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(A,G,T,V,P,L,q){this.x=A,this.y=V,this.z=P,this.A=L,this.B=q,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new F.$7d,this.onDidChangeSelection=this.v.event,this.w=D.d++,this.C=new Map,this.D=new Set,this.#e=T;const re=S.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${P}/scm${this.w}/input`,query:q?`rootUri=${encodeURIComponent(q.toString())}`:void 0});this.f=new I(A,G,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,P,L,q,re)}createResourceGroup(A,G,T){const V=(0,p.$5F)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,P=new $(this.#e,this.y,this.w,A,G,V,this.x),L=F.Event.once(P.onDidDispose)(()=>this.C.delete(P));return this.C.set(P,L),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const A=[],G=[];for(const[T,V]of this.C){V.dispose();const P=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});F.Event.once(T.onDidDispose)(()=>{this.D.delete(T),P.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),A.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const L=T._takeResourceStateSnapshot();L.length>0&&G.push([T.handle,L]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,A,G),this.C.clear()}eventuallyUpdateResourceStates(){const A=[];this.D.forEach(G=>{const T=G._takeResourceStateSnapshot();T.length!==0&&A.push([G.handle,T])}),A.length>0&&this.#e.$spliceResourceStates(this.w,A),this.D.clear()}getResourceGroup(A){return this.e.get(A)}setSelectionState(A){this.u=A,this.v.fire(A)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(A=>A.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Mh)(100)],D.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Mh)(100)],D.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(A,G,T,V){this.l=G,this.m=T,this.n=V,this.g=new Map,this.h=new E.$Em,this.j=new F.$7d,this.e=A.getProxy(m.$gM.MainThreadSCM),this.f=A.getProxy(m.$gM.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const L=this.g.get(P.sourceControlHandle);if(!L)return P;const q=L.getResourceGroup(P.groupHandle);return q?q.getResourceState(P.handle):P}else if(P&&P.$mid===4){const L=this.g.get(P.sourceControlHandle);return L?L.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const L=this.g.get(P.handle);return L||P}return P}})}createSourceControl(A,G,T,V){this.n.trace("ExtHostSCM#createSourceControl",A.identifier.value,G,T,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:A.identifier.value});const P=s.d++,L=new D(A,this.m,this.e,this.l,G,T,V);this.g.set(P,L);const q=this.h.get(A.identifier)||[];return q.push(L),this.h.set(A.identifier,q),L}getLastInputBox(A){this.n.trace("ExtHostSCM#getLastInputBox",A.identifier.value);const G=this.h.get(A.identifier),T=G&&G[G.length-1];return T&&T.inputBox}$provideOriginalResource(A,G,T){const V=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",A,V.toString());const P=this.g.get(A);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$_g)(()=>P.quickDiffProvider.provideOriginalResource(V,T)).then(L=>L||null)}$onInputBoxValueChange(A,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",A);const T=this.g.get(A);return T&&T.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(A,G,T,V){this.n.trace("ExtHostSCM#$executeResourceCommand",A,G,T);const P=this.g.get(A);if(!P)return Promise.resolve(void 0);const L=P.getResourceGroup(G);return L?L.$executeResourceCommand(T,V):Promise.resolve(void 0)}$validateInput(A,G,T){this.n.trace("ExtHostSCM#$validateInput",A);const V=this.g.get(A);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,R.$_g)(()=>V.inputBox.validateInput(G,T)).then(P=>{if(!P)return Promise.resolve(void 0);const L=w.MarkdownString.fromStrict(P.message);return L?Promise.resolve([L,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(A){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",A),A!==void 0&&this.g.get(A)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=A,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(A,G,T,V){return await this.g.get(A)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,T,V)??void 0}async $provideHistoryItems(A,G,T,V){return(await this.g.get(A)?.historyProvider?.provideHistoryItems(G,T,V))?.map(q=>({...q,icon:h(q)}))??void 0}async $provideHistoryItemSummary(A,G,T,V){const P=this.g.get(A)?.historyProvider;if(typeof P?.provideHistoryItemSummary!="function")return;const L=await P.provideHistoryItemSummary(G,T,V);return L?{...L,icon:h(L)}:void 0}async $provideHistoryItemChanges(A,G,T,V){return await this.g.get(A)?.historyProvider?.provideHistoryItemChanges(G,T,V)??void 0}};e.$okc=y,e.$okc=y=s=Je([qe(3,O.$Nj)],y)}),define(Me[271],Re([1,0,4,8,2]),function(me,e,S,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=void 0;class N{static{this.a=0}constructor(m,d){this.d=d,this.c=new Map,this.b=m.getProxy(S.$gM.MainThreadShare)}async $provideShare(m,d,k){return await this.c.get(m)?.provideShare({selection:F.Range.to(d.selection),resourceUri:M.URI.revive(d.resourceUri)},k)??void 0}registerShareProvider(m,d){const k=N.a++;return this.c.set(k,d),this.b.$registerShareProvider(k,F.DocumentSelector.from(m,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$pkc=N}),define(Me[272],Re([1,0,7,4,169,6,8,16]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0;class d{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$fN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$fN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,w,p,r,o,s=S.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=l,this.#t=w,o&&r){this.c=(0,S.$TM)(r.identifier,o);const i=p.get(this.c);i&&(s=i.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(d.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(n)}u(l){if((0,m.$Yf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!d.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let w;this.m?w=this.m:w=(0,M.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=d.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,w,this.k,r,this.r?.internal,p,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$rkc=d;class k{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const w={message:l};return this.b.unshift(w),this.c(),new S.$iM(()=>{const p=this.b.indexOf(w);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class O{constructor(l,w){this.e=new Map,this.a=l.getProxy(F.$gM.MainThreadStatusBar),this.b=w,this.c=new k(this)}$acceptStaticEntries(l){for(const w of l)this.e.set(w.entryId,w)}createStatusBarEntry(l,w,p,r){return new d(this.a,this.b,this.e,l,w,p,r)}setStatusBarMessage(l,w){const p=this.c.setMessage(l);let r;return typeof w=="number"?r=setTimeout(()=>p.dispose(),w):typeof w<"u"&&w.then(()=>p.dispose(),()=>p.dispose()),new S.$iM(()=>{p.dispose(),clearTimeout(r)})}}e.$skc=O}),define(Me[113],Re([1,0,29,105,49,75,60,8,2]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=e.$NO=e.$MO=void 0;const k=(i,c,h,t)=>{let v=c;return{enumerable:!0,configurable:!1,get(){return v},set(u){if(!h(v,u)){const g=v;v=u,i.listener?.(t(u,g))}}}},O=(i,c)=>i===c,E={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(i,c)=>!(i.length!==c.length||i.some(h=>!c.find(t=>h.id===t.id)))},l=i=>c=>({op:4,update:i(c)}),w=(i,c)=>({range:(()=>{let h;const t=l(v=>({range:S.$at.lift(m.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return h},set(v){i.listener?.({op:6}),E.range(h,v)||(h=v,i.listener?.(t(v)))}}})(),label:k(i,c,E.label,l(h=>({label:h}))),description:k(i,void 0,E.description,l(h=>({description:h}))),sortText:k(i,void 0,E.sortText,l(h=>({sortText:h}))),canResolveChildren:k(i,!1,E.canResolveChildren,h=>({op:2,state:h})),busy:k(i,!1,E.busy,l(h=>({busy:h}))),error:k(i,void 0,E.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:k(i,[],E.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),p=i=>{const c=M.$5K.fromString(i.extId),h=new o(c.controllerId,c.localId,i.label,d.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,R.$$K)(t).tagId})),h},r=i=>{let c;for(const h of i.tests){const t=p(h.item);(0,F.$wO)(t).parent=c,c=t}return c};e.$MO=r;class o{constructor(c,h,t,v){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,F.$vO)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof s?void 0:u.parent}},children:{value:(0,N.$uO)(u,F.$wO,o),enumerable:!0,writable:!1},...w(u,t)})}}e.$NO=o;class s extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$OO=s;class n extends N.$qO{constructor(c,h,t){super({controllerId:c,getDocumentVersion:v=>v&&t.getDocument(v)?.version,getApiFor:F.$wO,getChildren:v=>v.children,root:new s(c,h),toITestItem:m.TestItem.from})}}e.$PO=n}),define(Me[31],Re([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,23,50,41,64,58,61,33]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=void 0;let u=class{#e;#t;#i;constructor($,D,y){this.b=new Map,this.c=new Map,this.#e=$.getProxy(R.$gM.MainThreadCommands),this.d=D,this.#i=y,this.#t=$.getProxy(R.$gM.MainThreadTelemetry),this.converter=new g(this,C=>{const A=this.c.get(C);return A?.result===b.Void?A:void 0},D),this.f=[{processArgument(C){return(0,k.$Qh)(C)}},{processArgument(C){return(0,N.$Pn)(C,function(A){if(O.$at.isIRange(A))return M.Range.to(A);if(E.$_s.isIPosition(A))return M.Position.to(A);if(O.$at.isIRange(A.range)&&l.URI.isUri(A.uri))return M.location.to(A);if(A instanceof s.$ue)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor($){this.f.push($)}registerApiCommand($){const D=this.registerCommand(!1,$.id,async(...y)=>{const C=$.args.map((G,T)=>{if(!G.validate(y[T]))throw new Error(`Invalid argument '${G.name}' when running '${$.id}', received: ${typeof y[T]=="object"?JSON.stringify(y[T],null,"	"):y[T]} `);return G.convert(y[T])}),A=await this.executeCommand($.internalId,...C);return $.result.convert(A,y,this.converter)},void 0,{description:$.description,args:$.args,returns:$.result.description});return this.c.set($.id,$),new F.$iM(()=>{D.dispose(),this.c.delete($.id)})}registerCommand($,D,y,C,A,G){if(this.d.trace("ExtHostCommands#registerCommand",D),!D.trim().length)throw new Error("invalid id");if(this.b.has(D))throw new Error(`command '${D}' already exists`);return this.b.set(D,{callback:y,thisArg:C,metadata:A,extension:G}),$&&this.#e.$registerCommand(D),new F.$iM(()=>{this.b.delete(D)&&$&&this.#e.$unregisterCommand(D)})}executeCommand($,...D){return this.d.trace("ExtHostCommands#executeCommand",$),this.g($,D,!0)}async g($,D,y){if(this.b.has($))return this.#e.$fireCommandActivationEvent($),this.h($,D,!1);{let C=!1;const A=(0,N.$Pn)(D,function(G){if(G instanceof F.$jM)return M.Position.from(G);if(G instanceof F.$kM)return M.Range.from(G);if(G instanceof F.$uM)return M.location.from(G);if(F.$JN.isNotebookRange(G))return M.NotebookRange.from(G);if(G instanceof ArrayBuffer)return C=!0,s.$ue.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return C=!0,s.$ue.wrap(G);if(G instanceof s.$ue)return C=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand($,C?new n.$cw(A):A,y);return(0,k.$Qh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g($,D,!1);throw G}}}async h($,D,y){const C=this.b.get($);if(!C)throw new Error("Unknown command");const{callback:A,thisArg:G,metadata:T}=C;if(T?.args)for(let P=0;P<T.args.length;P++)try{(0,S.$_f)(D[P],T.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${$}' failed. Illegal argument '${T.args[P].name}' - ${T.args[P].description}`)}const V=c.$3d.create();try{return await A.apply(G,D)}catch(P){if($===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...D);L&&($=L.command)}if(this.d.error(P,$,C.extension?.identifier),!y)throw P;if(C.extension?.identifier){const L=this.#i.onExtensionError(C.extension.identifier,P);this.d.trace("forwarded error to extension?",L,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$5i)(P)),this.id=$,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,$,V.elapsed())}}j($,D,y){$.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:$.extension.identifier.value,id:new h.$3o(D),duration:y})}$executeContributedCommand($,...D){this.d.trace("ExtHostCommands#$executeContributedCommand",$);const y=this.b.get($);return y?(D=D.map(C=>this.f.reduce((A,G)=>G.processArgument(A,y.extension?.identifier),C)),this.h($,D,!0)):Promise.reject(new Error(`Contributed command '${$}' does not exist.`))}getCommands($=!1){return this.d.trace("ExtHostCommands#getCommands",$),this.#e.$getCommands().then(D=>($&&(D=D.filter(y=>y[0]!=="_")),D))}$getContributedCommandMetadata(){const $=Object.create(null);for(const[D,y]of this.b){const{metadata:C}=y;C&&($[D]=C)}return Promise.resolve($)}};e.$VO=u,e.$VO=u=Je([qe(0,r.$AO),qe(1,d.$Nj),qe(2,t.$UO)],u),e.$WO=(0,p.$hi)("IExtHostCommands");class g{constructor($,D,y){this.d=$,this.f=D,this.g=y,this.delegatingCommandId=`__vsc${(0,v.$Dg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal($,D){if(!$)return;const y={$ident:void 0,id:$.command,title:$.title,tooltip:$.tooltip};if(!$.command)return y;const C=this.f($.command);if(C)y.id=C.internalId,y.arguments=C.args.map((A,G)=>A.convert($.arguments&&$.arguments[G]));else if((0,m.$Lb)($.arguments)){const A=`${$.command} /${++this.c}`;this.b.set(A,$),D.add((0,w.$Sc)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),y.$ident=A,y.id=this.delegatingCommandId,y.arguments=[A],this.g.trace("CommandsConverter#CREATE",$.command,A)}return y}fromInternal($){return typeof $.$ident=="string"?this.b.get($.$ident):{command:$.id,title:$.title,arguments:$.arguments}}getActualCommand(...$){return this.b.get($[0])}h(...$){const D=this.getActualCommand(...$);return this.g.trace("CommandsConverter#EXECUTE",$[0],D?D.command:"MISSING"),D?this.d.executeCommand(D.command,...D.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${$[0]}`)}}e.$XO=g;class a{static{this.Uri=new a("uri","Uri of a text document",$=>l.URI.isUri($),$=>$)}static{this.Position=new a("position","A position in a text document",$=>F.$jM.isPosition($),M.Position.from)}static{this.Range=new a("range","A range in a text document",$=>F.$kM.isRange($),M.Range.from)}static{this.Selection=new a("selection","A selection in a text document",$=>F.$lM.isSelection($),M.Selection.from)}static{this.Number=new a("number","",$=>typeof $=="number",$=>$)}static{this.String=new a("string","",$=>typeof $=="string",$=>$)}static{this.StringArray=a.Arr(a.String)}static Arr($){return new a(`${$.name}_array`,`Array of ${$.name}, ${$.description}`,D=>Array.isArray(D)&&D.every(y=>$.validate(y)),D=>D.map(y=>$.convert(y)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",$=>$ instanceof F.$FM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",$=>$ instanceof F.$3N,M.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",$=>$ instanceof o.$NO,M.TestItem.from)}constructor($,D,y,C){this.name=$,this.description=D,this.validate=y,this.convert=C}optional(){return new a(this.name,`(optional) ${this.description}`,$=>$==null||this.validate($),$=>$===void 0?void 0:$===null?null:this.convert($))}with($,D){return new a($??this.name,D??this.description,this.validate,this.convert)}}e.$YO=a;class b{static{this.Void=new b("no result",$=>$)}constructor($,D){this.description=$,this.convert=D}}e.$ZO=b;class f{constructor($,D,y,C,A){this.id=$,this.internalId=D,this.description=y,this.args=C,this.result=A}}e.$1O=f}),define(Me[273],Re([1,0,18,12,2,87,97,35,31,8,7]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;const E=[new d.$1O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of DocumentHighlight-instances.",w(k.DocumentHighlight.to))),new d.$1O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$YO.Uri],new d.$ZO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,S.$Kb)(r))return;class s extends O.$AM{static to(i){const c=new s(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new O.$uM(o[0],k.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=k.Range.to(i.selectionRange),c.children=i.children?i.children.map(s.to):[],c}}return r.map(s.to)})),new d.$1O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$YO.Uri,new d.$YO("options","Formatting options",r=>!0,r=>r)],new d.$ZO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new d.$1O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$YO.Uri,d.$YO.Range,new d.$YO("options","Formatting options",r=>!0,r=>r)],new d.$ZO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new d.$1O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$YO.Uri,d.$YO.Position,new d.$YO("ch","Trigger character",r=>typeof r=="string",r=>r),new d.$YO("options","Formatting options",r=>!0,r=>r)],new d.$ZO("A promise that resolves to an array of TextEdits.",w(k.TextEdit.to))),new d.$1O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$1O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$1O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$1O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$1O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of Location-instances.",w(k.location.to))),new d.$1O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of Hover-instances.",w(k.Hover.to))),new d.$1O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$YO.Uri,new d.$YO("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>O.$jM.isPosition(o)),r=>r.map(k.Position.from))],new d.$ZO("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const n of o.reverse())s=new O.$EM(k.Range.to(n),s);return s}))),new d.$1O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$YO.String.with("query","Search string")],new d.$ZO("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(k.WorkspaceSymbol.to))),new d.$1O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(k.CallHierarchyItem.to))),new d.$1O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$YO.CallHierarchyItem],new d.$ZO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(k.CallHierarchyIncomingCall.to))),new d.$1O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$YO.CallHierarchyItem],new d.$ZO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(k.CallHierarchyOutgoingCall.to))),new d.$1O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:k.Range.to(r.range),placeholder:r.text}})),new d.$1O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$YO.Uri,d.$YO.Position,d.$YO.String.with("newName","The new symbol name")],new d.$ZO("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new d.$1O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$YO.Uri,d.$YO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$ZO("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new d.$1O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$YO.Uri],new d.$ZO("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new O.$AN(r.tokenTypes,r.tokenModifiers)})),new d.$1O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$YO.Uri],new d.$ZO("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$rab)(r);if(o.type==="full")return new O.$CN(o.data,void 0)})),new d.$1O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$YO.Uri,d.$YO.Range.optional()],new d.$ZO("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new O.$AN(r.tokenTypes,r.tokenModifiers)})),new d.$1O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$YO.Uri,d.$YO.Range],new d.$ZO("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$rab)(r);if(o.type==="full")return new O.$CN(o.data,void 0)})),new d.$1O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$YO.Uri,d.$YO.Position,d.$YO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$YO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$ZO("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new O.$QM([]);const n=r.suggestions.map(i=>k.CompletionItem.to(i,s));return new O.$QM(n,r.incomplete)})),new d.$1O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$YO.Uri,d.$YO.Position,d.$YO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$ZO("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new d.$1O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$YO.Uri,d.$YO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$ZO("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>w(n=>new O.$IM(k.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new d.$1O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$YO.Uri,new d.$YO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>O.$kM.isRange(r),r=>O.$lM.isSelection(r)?k.Selection.from(r):k.Range.from(r)),d.$YO.String.with("kind","Code action kind to return code actions for").optional(),d.$YO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$ZO("A promise that resolves to an array of Command-instances.",(r,o,s)=>w(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new O.$CM(n.title,n.kind?new O.$DM(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new d.$1O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$YO.Uri],new d.$ZO("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new O.$WM(k.Range.to(o.range),k.Color.to(o.color))):[])),new d.$1O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$YO("color","The color to show and insert",r=>r instanceof O.$VM,k.Color.from),new d.$YO("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new d.$ZO("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new d.$1O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$YO.Uri,d.$YO.Range],new d.$ZO("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(k.InlayHint.to.bind(void 0,s)))),new d.$1O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$YO.Uri],new d.$ZO("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(k.FoldingRange.to)})),new d.$1O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$ZO("A promise that resolves to an array of NotebookContentProvider static info objects.",w(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new d.$1O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$YO.Uri,d.$YO.Range,new d.$YO("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof O.$kM,r=>k.InlineValueContext.from(r))],new d.$ZO("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new d.$1O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$YO("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,F.$rg)(r,F.Schemas.http,F.Schemas.https),r=>r),new d.$YO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),d.$YO.String.with("label","").optional()],d.$ZO.Void),new d.$1O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$YO.Uri.with("resource","Resource to open"),d.$YO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$YO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],d.$ZO.Void),new d.$1O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$YO.Uri.with("left","Left-hand side resource of the diff editor"),d.$YO.Uri.with("right","Right-hand side resource of the diff editor"),d.$YO.String.with("title","Human readable title for the diff editor").optional(),new d.$YO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],d.$ZO.Void),new d.$1O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$YO.String.with("title","Human readable title for the changes editor"),new d.$YO("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,n,i]=o;if(!M.URI.isUri(s)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],d.$ZO.Void),new d.$1O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$YO.Uri,d.$YO.Position],new d.$ZO("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$1O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$YO.TypeHierarchyItem],new d.$ZO("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$1O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$YO.TypeHierarchyItem],new d.$ZO("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$1O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$YO.TestItem],d.$ZO.Void),new d.$1O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$YO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$ZO.Void),new d.$1O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$YO.String.with("name","The context key name"),new d.$YO("value","The context key value",()=>!0,r=>r)],d.$ZO.Void),new d.$1O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$YO.Uri,d.$YO.StringArray,new d.$YO("MappedEditsContext","Mapped Edits Context",r=>k.MappedEditsContext.is(r),r=>k.MappedEditsContext.from(r))],new d.$ZO("A promise that resolves to a workspace edit or null",r=>r?k.WorkspaceEdit.to(r):null))];class l{static register(o){E.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$gj)}}e.$Lic=l;function w(r){return o=>{if(Array.isArray(o))return o.map(r)}}function p(r){if(!Array.isArray(r))return;const o=[];for(const s of r)N.$1t(s)?o.push(k.DefinitionLink.to(s)):o.push(k.location.to(s));return o}}),define(Me[274],Re([1,0,11,6,2,4,31,8,7]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;class k{static{this.a=0}constructor(w,p){this.extension=w,this.provider=p,this.handle=k.a++}}class O{constructor(w){this.session=w,this.responses=[]}}class E{static{this.a=0}constructor(w,p,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(N.$gM.MainThreadInlineChat),p.registerApiCommand(new R.$1O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$YO("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:d.$lM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],R.$ZO.Void))}registerProvider(w,p,r){const o=new k(w,p);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??w.displayName??w.name,w.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",r?.supportReportIssue??!1),(0,F.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,p,r,o){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(p)),i=m.Selection.to(r),c=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=E.a++;return this.d.set(h,new O(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,p,r,o){const s=this.b.get(w);if(!s)return;const n=this.d.get(p.id);if(!n)return;const i={prompt:r.prompt,selection:m.Selection.to(r.selection),wholeRange:m.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(M.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let c=!1;const h={report:async I=>{if(!r.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:I.message,edits:I.edits?.map(m.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:d.$JM.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,h,o));let v;try{v=await(0,S.$8g)(t,o)}finally{c=!0}if(!v)return;const u=n.responses.push(v)-1,g={wholeRange:m.Range.from(v.wholeRange),placeholder:v.placeholder};if(!E.h(v))return{...g,id:u,type:"editorEdit",message:m.MarkdownString.from(v.contents),edits:[]};const{edits:a,contents:b}=v,f=b!==void 0?m.MarkdownString.from(b):void 0;return a instanceof d.$sM?{...g,id:u,type:"bulkEdit",edits:m.WorkspaceEdit.from(a),message:f}:{...g,id:u,type:"editorEdit",edits:a.map(m.TextEdit.from),message:f}}async $provideFollowups(w,p,r,o){const s=this.b.get(w),n=this.d.get(p),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const c=Promise.resolve(s.provider.provideFollowups(n.session,i,o));return(await(0,S.$8g)(c,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(w,p,r,o){const s=this.b.get(w),n=this.d.get(p),i=n?.responses[r];if(s&&i){const c=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,c)}}$releaseSession(w,p){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$Vjc=E}),define(Me[275],Re([1,0,2,31]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class M{constructor(R,m,d,k,O){this.a=m,this.b=d,this.c=k;const E=new F.$1O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$YO("showOptions","Show Options",l=>!0,l=>l),new F.$YO("resource","Interactive resource Uri",l=>!0,l=>l),new F.$YO("controllerId","Notebook controller Id",l=>!0,l=>l),new F.$YO("title","Interactive editor title",l=>!0,l=>l)],new F.$ZO("Notebook and input URI",l=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this.a.getEditorById(l.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(R,m,d,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:d,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$9jc=M}),define(Me[276],Re([1,0,18,11,25,5,6,28,2,20,13,4,31,8,7,76,215,22,50,216]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0,e.$fkc=a;let c=class{constructor(f,I,$,D,y){this.m=I,this.n=$,this.o=D,this.q=y,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=f.getProxy(E.$gM.MainThreadNotebookKernels);const C=new l.$1O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$YO("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const T=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:T}}else if(G&&"notebookEditor"in G){const T=this.n.getIdByEditor(G.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return G})],l.$ZO.Void),A=new l.$1O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$YO.Uri],new l.$ZO("A promise that resolves to an array of variables",(G,T)=>G.map(V=>({name:V.name,value:V.value,type:V.type,editable:!1}))));this.o.registerApiCommand(C),this.o.registerApiCommand(A)}createNotebookController(f,I,$,D,y,C){for(const ve of this.j.values())if(ve.controller.id===I&&k.$Cm.equals(f.identifier,ve.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const A=this.k++,G=this;this.q.trace(`NotebookController[${A}], CREATED by ${f.identifier.value}, ${I}`);const T=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${f.identifier}'`);let V=!1;const P=new N.$7d,L=new N.$7d,q={id:a(f.identifier,I),notebookType:$,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:D||f.identifier.value,preloads:C?C.map(w.NotebookRendererScript.from):[]};let re=y??T,ue,ye;this.a.$addKernel(A,q).catch(ve=>{console.log(ve),V=!0});let Se=0;const le=()=>{if(V)return;const ve=++Se;Promise.resolve().then(()=>{ve===Se&&this.a.$updateKernel(A,q)})},we=new m.$Bc,_={get id(){return I},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:P.event,get label(){return q.label},set label(ve){q.label=ve??f.displayName??f.name,le()},get detail(){return q.detail??""},set detail(ve){q.detail=ve,le()},get description(){return q.description??""},set description(ve){q.description=ve,le()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ve){q.supportedLanguages=ve,le()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ve){q.supportsExecutionOrder=ve,le()},get rendererScripts(){return q.preloads?q.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ve){re=ve??T},get interruptHandler(){return ue},set interruptHandler(ve){ue=ve,q.supportsInterrupt=!!ve,le()},set variableProvider(ve){(0,s.$6F)(f,"notebookVariableProvider"),ye=ve,q.hasVariableProvider=!!ve,ve?.onDidChangeVariables(ne=>G.a.$variablesUpdated(ne.uri)),le()},get variableProvider(){return ye},createNotebookCellExecution(ve){if(V)throw new Error("notebook controller is DISPOSED");if(!we.has(ve.notebook.uri))throw G.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(we.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.notebook.uri.toString()}`);return G._createNotebookCellExecution(ve,a(f.identifier,this.id))},createNotebookExecution(ve){if((0,s.$6F)(f,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!we.has(ve.uri))throw G.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(we.keys()).map(ne=>ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.uri.toString()}`);return G._createNotebookExecution(ve,a(f.identifier,this.id))},dispose:()=>{V||(this.q.trace(`NotebookController[${A}], DISPOSED`),V=!0,this.j.delete(A),P.dispose(),L.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(ve,ne){ne===p.NotebookControllerAffinity2.Hidden&&(0,s.$6F)(f,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(A,ve.uri,ne)},onDidReceiveMessage:L.event,postMessage(ve,ne){return(0,s.$6F)(f,"notebookMessaging"),G.a.$postMessage(A,ne&&G.n.getIdByEditor(ne),ve)},asWebviewUri(ve){return(0,s.$6F)(f,"notebookMessaging"),(0,r.$Gyb)(ve,G.m.remote)}};return this.j.set(A,{extensionId:f.identifier,controller:_,onDidReceiveMessage:L,onDidChangeSelection:P,associatedNotebooks:we}),_}getIdByController(f){for(const[I,$]of this.j)if($.controller===f)return a($.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,I){const $=this.g++,D=this;this.q.trace(`NotebookControllerDetectionTask[${$}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask($,I);const y={dispose:()=>{this.f.delete($),D.a.$removeKernelDetectionTask($)}};return this.f.set($,y),y}registerKernelSourceActionProvider(f,I,$){const D=this.i++,y=typeof $.onDidChangeNotebookKernelSourceActions=="function"?D:void 0,C=this;this.h.set(D,$),this.q.trace(`NotebookKernelSourceActionProvider[${D}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(D,D,I);let A;return y!==void 0&&(A=$.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(D),C.a.$removeKernelSourceActionProvider(D,D),A?.dispose()}}}async $provideKernelSourceActions(f,I){const $=this.h.get(f);if($){const D=new R.$Tc;return(await $.provideNotebookKernelSourceActions(I)??[]).map(C=>w.NotebookKernelSourceAction.from(C,this.o.converter,D))}return[]}$acceptNotebookAssociation(f,I,$){const D=this.j.get(f);if(D){const y=this.n.getNotebookDocument(d.URI.revive(I));$?D.associatedNotebooks.set(y.uri,!0):D.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),$),D.onDidChangeSelection.fire({selected:$,notebook:y.apiNotebook})}}async $executeCells(f,I,$){const D=this.j.get(f);if(!D)return;const y=this.n.getNotebookDocument(d.URI.revive(I)),C=[];for(const A of $){const G=y.getCell(A);G&&C.push(G.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),C.length),await D.controller.executeHandler.call(D.controller,C,y.apiNotebook,D.controller)}catch(A){this.q.error(`NotebookController[${f}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(f,I,$){const D=this.j.get(f);if(!D)return;const y=this.n.getNotebookDocument(d.URI.revive(I));if(D.controller.interruptHandler)await D.controller.interruptHandler.call(D.controller,y.apiNotebook);else for(const C of $){const A=y.getCell(C);A&&this.b.get(A.uri)?.cancel()}if(D.controller.interruptHandler){const C=this.c.get(y.uri);$.length&&Array.isArray(C)&&C.length&&C.forEach(A=>A.dispose())}}async $provideVariables(f,I,$,D,y,C,A){const G=this.j.get(f);if(!G)return;const T=this.n.getNotebookDocument(d.URI.revive($)),V=G.controller.variableProvider;if(!V)return;let P;if(D!==void 0){if(P=this.s[D],!P)return}else this.s={};const L=y==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,q=V.provideVariables(T.apiNotebook,P,L,C,A);let re=0;for await(const ue of q){if(A.isCancellationRequested)return;const ye={id:this.r++,name:ue.variable.name,value:ue.variable.value,type:ue.variable.type,language:ue.variable.language,expression:ue.variable.expression,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=ue.variable,this.a.$receiveVariable(I,ye),re++>=i.$lhb)return}}$acceptKernelMessageFromRenderer(f,I,$){const D=this.j.get(f);if(!D)return;const y=this.n.getEditorById(I);D.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:$}))}$cellExecutionChanged(f,I,$){const y=this.n.getNotebookDocument(d.URI.revive(f)).getCell(I);if(y){const C=$?w.NotebookCellExecutionState.to($):p.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(f,I){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const D=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!D)throw new Error("invalid cell");if(this.b.has(D.uri))throw new Error(`duplicate execution for ${D.uri}`);const y=new t(I,D,this.a);this.b.set(D.uri,y);const C=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),C.dispose(),this.b.delete(D.uri))});return y.asApiObject()}_createNotebookExecution(f,I){const $=this.n.getNotebookDocument(f.uri),D=f.getCells().find(A=>{const G=$.getCellFromApiCell(A);return G&&this.b.has(G.uri)});if(D)throw new Error(`duplicate cell execution for ${D.document.uri}`);if(this.c.has($.uri))throw new Error(`duplicate notebook execution for ${$.uri}`);const y=new u(I,$,this.a),C=y.onDidChangeState(()=>{y.state===v.Resolved&&(y.dispose(),C.dispose(),this.c.delete($.uri))});return this.c.set($.uri,[y,C]),y.asApiObject()}};e.$ekc=c,e.$ekc=c=Je([qe(4,O.$Nj)],c);var h;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(h||(h={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(f,I,$){super(),this.m=I,this.n=$,this.b=t.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new M.$ee),this.h=new g(10,D=>this.s(D)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const I=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$cw(I))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let I=this.m;if(f&&(I=this.m.notebook.getCellFromApiCell(f)),!I)throw new Error("INVALID cell");return I.handle}y(f){return f.map(I=>{const $=p.$NN.ensureUniqueMimeTypes(I.items,!0);return $===I.items?w.NotebookCellOutput.from(I):w.NotebookCellOutput.from({items:$,id:I.id,metadata:I.metadata})})}async z(f,I,$){const D=this.w(I),y=this.y((0,S.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:D,append:$,outputs:y})}async C(f,I,$){return f=p.$NN.ensureUniqueMimeTypes((0,S.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(w.NotebookCellOutputItem.from),outputId:I.id,append:$})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder($){f.j=$,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start($){if(f.f===h.Resolved||f.f===h.Started)throw new Error("Cannot call start again");f.f=h.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:$})},end($,D,y){if(f.f===h.Resolved)throw new Error("Cannot call resolve twice");f.f=h.Resolved,f.c.fire(),f.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;f.n.$completeExecution(f.b,new n.$cw({runEndTime:D,lastRunSuccess:$,error:C}))},clearOutput($){return f.t(),f.z([],$,!1)},appendOutput($,D){return f.t(),f.z($,D,!0)},replaceOutput($,D){return f.t(),f.z($,D,!1)},appendOutputItems($,D){return f.t(),f.C($,D,!0)},replaceOutputItems($,D){return f.t(),f.C($,D,!1)}})}}var v;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(v||(v={}));class u extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(f,I,$){super(),this.h=I,this.j=$,this.b=u.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new M.$ee),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class g{constructor(f,I){this.f=f,this.g=I,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new F.$Eh,this.b=Date.now(),(0,F.$ih)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>f.complete())}}function a(b,f){return`${b.value}/${f}`}}),define(Me[66],Re([1,0,5,4,3,2,17,6,7,171,14,199,25,33,200,40,11,8,31]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=e.$rjc=e.$qjc=void 0,e.$qjc=(0,M.$hi)("IExtHostTerminalService");class i{constructor($,D,y,C){this.l=$,this._id=D,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const A=this;this.value={get name(){return A.n||""},get processId(){return A.b},get creationOptions(){return A.m},get exitStatus(){return A.h},get state(){return A.j},get selection(){return A.k},sendText(G,T=!0){A.q(),A.l.$sendText(A._id,G,T)},show(G){A.q(),A.l.$show(A._id,G)},hide(){A.q(),A.l.$hide(A._id)},dispose(){A.a||(A.a=!0,A.l.$dispose(A._id))},get dimensions(){if(!(A.d===void 0||A.g===void 0))return{columns:A.d,rows:A.g}}}}async create($,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??D?.cwd??void 0,env:$.env??void 0,icon:a($.iconPath)??void 0,color:r.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,forceShellIntegration:D?.forceShellIntegration??void 0,isFeatureTerminal:D?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:D?.useShellEnvironment??void 0,location:D?.location||this.o($.location,D?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,D,y,C,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(A)?A.id:void 0,location:D?.location||this.o($,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,D){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&D?{parentTerminal:D}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,D){this.h=Object.freeze({code:$,reason:D})}setDimensions($,D){return $===this.d&&D===this.g||$===0||D===0?!1:(this.d=$,this.g=D,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(D=>{D!==$&&(this.b=Promise.resolve($))})}}e.$rjc=i;class c{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new S.$7d,this.onProcessData=this.a.event,this.b=new S.$7d,this.d=new S.$7d,this.onDidChangeProperty=this.d.event,this.f=new S.$7d,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,D){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${D}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,D){this.g.setDimensions?.({columns:$,rows:D})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(D=>this.a.fire(D)),this.g.onDidClose?.((D=void 0)=>{this.f.fire(D===void 0?void 0:D)}),this.g.onDidOverrideDimensions?.(D=>{D&&this.d.fire({type:"overrideDimensions",value:{cols:D.columns,rows:D.rows}})}),this.g.onDidChangeName?.(D=>{this.d.fire({type:"title",value:D})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,D,y){super(),this.Q=D,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$7d,this.onDidCloseTerminal=this.H.event,this.I=new S.$7d,this.onDidOpenTerminal=this.I.event,this.J=new S.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$7d,this.onDidChangeShell=this.N.event,this.O=new S.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(F.$gM.MainThreadTerminalService),this.y=new p.$_tb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const A=G=>{const T=G;return this.W(T.instanceId)?.value};switch(C?.$mid){case 15:return A(C);default:{if(Array.isArray(C))for(let G=0;G<C.length&&C[G].$mid===15;G++)C[G]=A(C[G]);return C}}}}),this.B({dispose:()=>{for(const[C,A]of this.g)A.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,D){const y=new i(this.a,(0,w.$Dg)(),$,$.name),C=new c($.pty);return y.createExtensionTerminal($.location,D,this.R($,D).resolvedExtHostIdentifier,a($.iconPath),b($.color)).then(A=>{const G=this.S(A,C);this.h[A]=G}),this.f.push(y),y.value}R($,D){if(D=D||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const y=$.location.parentTerminal;if(y){const C=this.f.find(A=>A.value===y);C&&(D.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?D.location=$.location:D.location&&typeof D.location=="object"&&"splitActiveTerminal"in D.location&&(D.location={splitActiveTerminal:!0});return D}attachPtyToTerminal($,D){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new c(D),A=this.S($,C);this.h[$]=A}async $acceptActiveTerminalChanged($){const D=this.b;if($===null){this.b=void 0,D!==this.b&&this.J.fire(this.b);return}const y=this.W($);y&&(this.b=y,D!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,D){const y=this.W($);y&&this.O.fire({terminal:y.value,data:D})}async $acceptTerminalDimensions($,D,y){const C=this.W($);C&&C.setDimensions(D,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,D){const y=this.W($);y&&this.P.fire({terminal:y.value,...D})}async $acceptTerminalMaximumDimensions($,D,y){this.g.get($)?.resize(D,y)}async $acceptTerminalTitleChange($,D){const y=this.W($);y&&(y.name=D)}async $acceptTerminalClosed($,D,y){const C=this.Y(this.f,$);if(C!==null){const A=this.f.splice(C,1)[0];A.setExitStatus(D,y),this.H.fire(A.value)}}$acceptTerminalOpened($,D,y,C){if(D){const T=this.Y(this.f,D);if(T!==null){this.f[T]._id=$,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const A={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:N.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},G=new i(this.a,$,A,y);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId($,D){this.W($)?._setProcessId(D)}async $startExtensionTerminal($,D){const y=this.W($);if(!y)return{message:(0,k.localize)(0,null,$)};y.isOpen||await new Promise(A=>{const G=this.onDidOpenTerminal(async T=>{T===y.value&&(G.dispose(),A())})});const C=this.g.get($);C?C.startSendingEvents(D):this.j[$]={initialDimensions:D}}S($,D){const y=new m.$Tc;y.add(D.onProcessReady(A=>this.a.$sendProcessReady($,A.pid,A.cwd,A.windowsPty))),y.add(D.onDidChangeProperty(A=>this.a.$sendProcessProperty($,A))),this.y.startBuffering($,D.onProcessData),y.add(D.onProcessExit(A=>this.U($,A))),this.g.set($,D);const C=this.j[$];return C&&D instanceof c&&(D.startSendingEvents(C.initialDimensions),delete this.j[$]),y}$acceptProcessAckDataEvent($,D){this.g.get($)?.acknowledgeDataEvent(D)}$acceptProcessInput($,D){this.g.get($)?.input(D)}$acceptTerminalInteraction($){const D=this.W($);D?.setInteractedWith()&&this.M.fire(D.value)}$acceptTerminalSelection($,D){this.W($)?.setSelection(D)}$acceptProcessResize($,D,y){try{this.g.get($)?.resize(D,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,D){this.g.get($)?.shutdown(D)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(D=>this.a.$sendProcessProperty($,{type:"initialCwd",value:D}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(D=>this.a.$sendProcessProperty($,{type:"cwd",value:D}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new d.$iM(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,D,y){if(this.C.has(D))throw new Error(`Terminal profile provider "${D}" already registered`);return this.C.set(D,y),this.a.$registerProfileProvider(D,$.identifier.value),new d.$iM(()=>{this.C.delete(D),this.a.$unregisterProfileProvider(D)})}registerTerminalQuickFixProvider($,D,y){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,y),this.a.$registerQuickFixProvider($,D),new d.$iM(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,D){const y=new l.$ee().token;if(y.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const A=await C.provideTerminalQuickFixes(D,y);if(A===null||Array.isArray(A)&&A.length===0)return;const G=new m.$Tc;if(this.w.value=G,!Array.isArray(A))return A?s.TerminalQuickFix.from(A,this.Q.converter,G):void 0;const T=[];for(const V of A){const P=s.TerminalQuickFix.from(V,this.Q.converter,G);P&&T.push(P)}return T}async $createContributedProfileTerminal($,D){const y=new l.$ee().token;let C=await this.C.get($)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,D);return}this.createTerminalFromOptions(C.options,D)}}async $provideLinks($,D){const y=this.W($);if(!y)return[];this.F.delete($),this.G.get($)?.dispose(!0);const A=new l.$ee;this.G.set($,A);const G=[],T={terminal:y.value,line:D},V=[];for(const q of this.z)V.push(o.Promises.withAsyncBody(async re=>{A.token.onCancellationRequested(()=>re({provider:q,links:[]}));const ue=await q.provideTerminalLinks(T,A.token)||[];A.token.isCancellationRequested||re({provider:q,links:ue})}));const P=await Promise.all(V);if(A.token.isCancellationRequested)return[];const L=new Map;for(const q of P)q&&q.links.length>0&&G.push(...q.links.map(re=>{const ue={id:h++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return L.set(ue.id,{provider:q.provider,link:re}),ue}));return this.F.set($,L),G}$activateLink($,D){const y=this.F.get($)?.get(D);y&&y.provider.handleTerminalLink(y.link)}U($,D){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const y=this.h[$];y&&(y.dispose(),delete this.h[$]),this.a.$sendProcessExit($,D)}W($){return this.X(this.f,$)}X($,D){const y=this.Y($,D);return y!==null?$[y]:null}Y($,D){const y=$.findIndex(C=>C._id===D);return y===-1?null:y}getEnvironmentVariableCollection($){let D=this.n.get($.identifier.value);return D||(D=new v,this.$($.identifier.value,D)),D.getScopedEnvironmentVariableCollection(void 0)}Z($,D){const y=(0,E.$5r)(D.map),C=(0,E.$6r)(D.descriptionMap);this.a.$setEnvironmentVariableCollection($,D.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections($){$.forEach(D=>{const y=D[0],C=new v(D[1]);this.$(y,C)})}$acceptDefaultProfile($,D){const y=this.s;this.s=$,this.u=D,y?.path!==$.path&&this.N.fire($.path)}$($,D){this.n.set($,D),D.onDidChangeCollection(()=>{this.Z($,D)})}};e.$sjc=t,e.$sjc=t=Je([qe(1,n.$WO),qe(2,R.$AO)],t);class v{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$7d,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const D=this.h($);let y=this.a.get(D);return y||(y=new u(this,$),this.a.set(D,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace($,D,y,C){this.f($,{value:D,type:d.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append($,D,y,C){this.f($,{value:D,type:d.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend($,D,y,C){this.f($,{value:D,type:d.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f($,D){if(D.options&&D.options.applyAtProcessCreation===!1&&!D.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g($,D.scope),C=this.map.get(y),A=D.options?{applyAtProcessCreation:D.options.applyAtProcessCreation??!1,applyAtShellIntegration:D.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==D.value||C.type!==D.type||C.options?.applyAtProcessCreation!==A.applyAtProcessCreation||C.options?.applyAtShellIntegration!==A.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==D.scope?.workspaceFolder?.index){const G=this.g($,D.scope),T={variable:$,...D,options:A};this.map.set(G,T),this.d.fire()}}get($,D){const y=this.g($,D),C=this.map.get(y);return C?f(C):void 0}g($,D){const y=this.h(D);return y.length?`${$}:::${y}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const D=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h($)&&D.set(C.variable,f(C));return D}delete($,D){const y=this.g($,D);this.map.delete(y),this.d.fire()}clear($){if($?.workspaceFolder){for(const[D,y]of this.map)y.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(D);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,D){const y=this.h(D),C=this.descriptionMap.get(y);if(!C||C.description!==$){let A;typeof $=="string"?A=$:A=$?.value.split(`

`)[0];const G={description:A,scope:D};this.descriptionMap.set(y,G),this.d.fire()}}getDescription($){const D=this.h($);return this.descriptionMap.get(D)?.description}k($){const D=this.h($);this.descriptionMap.delete(D)}}class u{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,D){this.b=$,this.d=D,this.a=new S.$7d}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,D,y){this.b.replace($,D,y,this.d)}append($,D,y){this.b.append($,D,y,this.d)}prepend($,D,y){this.b.prepend($,D,y,this.d)}get($){return this.b.get($,this.d)}forEach($,D){this.b.getVariableMap(this.d).forEach((y,C)=>$.call(D,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends t{constructor($,D){super(!1,$,D)}createTerminal($,D,y){throw new O.$_}createTerminalFromOptions($,D){throw new O.$_}};e.$tjc=g,e.$tjc=g=Je([qe(0,n.$WO),qe(1,R.$AO)],g);function a(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return r.ThemeColor.isThemeColor(I)?I:void 0}function f(I){const $={...I};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Me[277],Re([1,0,11,23,25,5,249,99,6,16,33,13,4,17,113,8,7,49,75,60,22]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=e.$ykc=e.$xkc=e.$wkc=void 0;let h=class extends d.$Uc{constructor(T,V,P,L){super(),this.w=L,this.f=this.B(new N.$7d),this.g=new Map,this.s=this.B(new N.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(l.$gM.MainThreadTesting),this.m=new D(this.h),this.j=new g(this.h,V),P.registerArgumentProcessor({processArgument:q=>{switch(q?.$mid){case 16:{const re=q,ue=re.tests[re.tests.length-1].item.extId;return this.g.get(s.$5K.root(ue))?.collection.tree.get(ue)?.actual??(0,p.$MO)(q)}case 18:{const{test:re,message:ue}=q,ye=re.item.extId;return{test:this.g.get(s.$5K.root(ye))?.collection.tree.get(ye)?.actual??(0,p.$MO)({$mid:16,tests:[re]}),message:r.TestMessage.to(ue)}}default:return q}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const q=await P.executeCommand("_testing.getExplorerSelection"),re=ue=>{const ye=this.g.get(s.$5K.root(ue));if(ye)return s.$5K.isRoot(ue)?ye.controller:ye.collection.tree.get(ue)?.actual};return{include:q?.include.map(re).filter(k.$3f)||[],exclude:q?.exclude.map(re).filter(k.$3f)||[]}})}createTestController(T,V,P,L){if(this.g.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const q=new d.$Tc,re=q.add(new p.$PO(V,P,this.w));re.root.label=P;const ue=new Map,ye=new Set,Se=this.h,le={items:re.root.children,get label(){return P},set label(_){P=_,re.root.label=_,Se.$updateController(V,{label:P})},get refreshHandler(){return L},set refreshHandler(_){L=_,Se.$updateController(V,{canRefresh:!!_})},get id(){return V},createRunProfile:(_,ve,ne,fe,W,te)=>{let Ee=(0,m.$8i)(_);for(;ue.has(Ee);)Ee++;return new C(this.h,ue,ye,this.s.event,V,Ee,_,ve,ne,fe,W,te)},createTestItem(_,ve,ne){return new p.$NO(V,_,ve,ne)},createTestRun:(_,ve,ne=!0)=>this.j.createTestRun(T,V,re,_,ve,ne),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const ve=_ instanceof Array?_:[_];this.h.$markTestRetired(ve.map(ne=>s.$5K.fromExtHostTestItem(ne,V).toString()))}},set resolveHandler(_){re.resolveHandler=_},get resolveHandler(){return re.resolveHandler},dispose:()=>{q.dispose()}};Se.$registerTestController(V,P,!!L),q.add((0,d.$Sc)(()=>Se.$unregisterTestController(V)));const we={controller:le,collection:re,profiles:ue,extension:T,activeProfiles:ye};return this.g.set(V,we),q.add((0,d.$Sc)(()=>this.g.delete(V))),q.add(re.onDidGenerateDiff(_=>Se.$publishDiff(V,_.map(i.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(T,V=M.CancellationToken.None){const P=a(T);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.g.get(P.controllerId);if(!L)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(q=>s.$5K.fromExtHostTestItem(q,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:A[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:T.exclude?.map(q=>q.id)},V)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $provideFileCoverage(T,V,P){return await this.j.getCoverageReport(T,V)?.provideFileCoverage(P)??[]}async $resolveFileCoverage(T,V,P,L){return await this.j.getCoverageReport(T,V)?.resolveFileCoverage(P,L)??[]}$configureRunProfile(T,V){this.g.get(T)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(T){const V=new Map;for(const[P,L]of Object.entries(T)){const q=this.g.get(P);if(!q)continue;const re=new Map,ue=L.filter(Se=>!q.activeProfiles.has(Se)),ye=[...q.activeProfiles].filter(Se=>!L.includes(Se));for(const Se of ue)re.set(Se,!0),q.activeProfiles.add(Se);for(const Se of ye)re.set(Se,!1),q.activeProfiles.delete(Se);re.size&&V.set(P,re)}this.s.fire(V)}async $refreshTests(T,V){await this.g.get(T)?.controller.refreshHandler?.(V)}$publishTestResults(T){this.results=Object.freeze(T.map(r.TestResults.to).concat(this.results).sort((V,P)=>P.completedAt-V.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,V){const P=this.g.get(s.$5K.fromString(T).controllerId)?.collection;P&&(await P.expand(T,V<0?1/0:V),P.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(V=>i.TestsDiffOp.deserialize({asCanonicalUri:P=>P},V)))}async $runControllerTests(T,V){return Promise.all(T.map(P=>this.y(P,!1,V)))}async $startContinuousRun(T,V){const P=new M.$ee(V),L=await Promise.all(T.map(q=>this.y(q,!0,P.token)));return!V.isCancellationRequested&&!L.some(q=>q.error)&&await new Promise(q=>V.onCancellationRequested(q)),P.dispose(!0),L}async y(T,V,P){const L=this.g.get(T.controllerId);if(!L)return{};const{collection:q,profiles:re,extension:ue}=L,ye=re.get(T.profileId);if(!ye)return{};const Se=T.testIds.map(ve=>q.tree.get(ve)).filter(k.$3f),le=T.excludeExtIds.map(ve=>L.collection.tree.get(ve)).filter(k.$3f).filter(ve=>Se.some(ne=>ne.fullId.compare(ve.fullId)===2));if(!Se.length)return{};const we=new o.$UN(Se.some(ve=>ve.actual instanceof p.$OO)?void 0:Se.map(ve=>ve.actual),le.map(ve=>ve.actual),ye,V),_=(0,i.$8K)(T)&&this.j.prepareForMainThreadTestRun(we,b.fromInternal(T,L.collection),ue,P);try{return await ye.runHandler(we,P),{}}catch(ve){return{error:String(ve)}}finally{_&&(_.hasRunningTasks&&!P.isCancellationRequested&&await N.Event.toPromise(_.onEnd),_.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$wkc=h,e.$wkc=h=Je([qe(0,w.$AO),qe(1,E.$Nj)],h);const t=1e4;var v;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(v||(v={}));class u extends d.$Uc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(T,V,P,L,q){super(),this.s=T,this.w=V,this.y=P,this.z=L,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new N.$7d),this.m=this.B(new N.$7d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new M.$ee(q));const re=this.B(new S.$th(()=>this.C(),t));this.B(this.h.token.onCancellationRequested(()=>re.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(T){const V=this.s.id,P=this.s.controllerId,L=(0,O.$Dg)(),q=this.y,re=this.m;let ue;const ye=_=>(ve,...ne)=>{if(le){this.z.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ve)&&(this.F(ve),_(ve,...ne))},Se=(_,ve)=>{const ne=ve instanceof Array?ve.map(r.TestMessage.from):[r.TestMessage.from(ve)];if(_.uri&&_.range){const fe={range:r.Range.from(_.range),uri:_.uri};for(const W of ne)W.location=W.location||fe}this.w.$appendTestMessagesInRun(V,L,s.$5K.fromExtHostTestItem(_,P).toString(),ne)};let le=!1;const we={isPersisted:this.s.isPersisted,token:this.h.token,name:T,get coverageProvider(){return ue?.provider},set coverageProvider(_){(0,c.$6F)(q,"testCoverage"),ue=_&&new f(_),re.fire({taskId:L,runId:V,coverage:ue})},enqueued:ye(_=>{this.w.$updateTestStateInRun(V,L,s.$5K.fromExtHostTestItem(_,P).toString(),1)}),skipped:ye(_=>{this.w.$updateTestStateInRun(V,L,s.$5K.fromExtHostTestItem(_,P).toString(),5)}),started:ye(_=>{this.w.$updateTestStateInRun(V,L,s.$5K.fromExtHostTestItem(_,P).toString(),2)}),errored:ye((_,ve,ne)=>{Se(_,ve),this.w.$updateTestStateInRun(V,L,s.$5K.fromExtHostTestItem(_,P).toString(),6,ne)}),failed:ye((_,ve,ne)=>{Se(_,ve),this.w.$updateTestStateInRun(V,L,s.$5K.fromExtHostTestItem(_,P).toString(),4,ne)}),passed:ye((_,ve)=>{this.w.$updateTestStateInRun(V,L,s.$5K.fromExtHostTestItem(_,this.s.controllerId).toString(),3,ve)}),appendOutput:(_,ve,ne)=>{le||(ne&&(this.s.isIncluded(ne)?this.F(ne):ne=void 0),this.w.$appendOutputToRun(V,L,F.$ue.fromString(_),ve&&r.location.from(ve),ne&&s.$5K.fromExtHostTestItem(ne,P).toString()))},end:()=>{le||(le=!0,this.w.$finishedTestRunTask(V,L),this.f.delete(L),this.f.size||this.D())}};return this.f.set(L,{run:we}),this.w.$startedTestRunTask(V,{id:L,name:T,running:!0}),we}C(){for(const{run:T}of this.f.values())T.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(T){if(!(T instanceof p.$NO))throw new n.$sO(T.id);if(this.g.has(s.$5K.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const V=[],P=this.s.colllection.root;for(;;){const L=r.TestItem.from(T);if(V.unshift(L),this.g.has(L.extId)||(this.g.add(L.extId),T===P))break;T=T.parent||P}this.w.$addTestsToRun(this.s.controllerId,this.s.id,V)}dispose(){this.D(),super.dispose()}}class g{get trackers(){return this.c.values()}constructor(T,V){this.g=T,this.h=V,this.c=new Map,this.f=[]}getCoverageReport(T,V){return this.f.find(P=>P.runId===T)?.coverage.get(V)}prepareForMainThreadTestRun(T,V,P,L){return this.j(T,V,P,L)}cancelRunById(T){for(const V of this.c.values())if(V.id===T){V.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,V,P,L,q,re){const ue=this.c.get(L);if(ue)return ue.createRun(q);const ye=b.fromPublic(V,P,L,re),Se=a(L);this.g.$startedExtensionTestRun({controllerId:V,continuous:!!L.continuous,profile:Se&&{group:A[Se.kind],id:Se.profileId},exclude:L.exclude?.map(we=>s.$5K.fromExtHostTestItem(we,P.root.id).toString())??[],id:ye.id,include:L.include?.map(we=>s.$5K.fromExtHostTestItem(we,P.root.id).toString())??[P.root.id],persist:re});const le=this.j(L,ye,T);return N.Event.once(le.onEnd)(()=>{this.g.$finishedExtensionTestRun(ye.id),le.dispose()}),le.createRun(q)}j(T,V,P,L){const q=new u(V,this.g,P,this.h,L);this.c.set(T,q);let re;const ue=q.onDidCoverage(({runId:ye,taskId:Se,coverage:le})=>{re||(re={runId:ye,coverage:new Map},this.f.unshift(re),this.f.length>i.$aL&&this.f.pop()),re.coverage.set(Se,le),this.g.$signalCoverageAvailable(ye,Se,!!le)});return N.Event.once(q.onEnd)(()=>{this.c.delete(T),ue.dispose()}),q}}e.$xkc=g;const a=G=>{if(G.profile){if(!(G.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class b{static fromPublic(T,V,P,L){return new b(T,(0,O.$Dg)(),P.include?.map(q=>s.$5K.fromExtHostTestItem(q,T).toString())??[T],P.exclude?.map(q=>s.$5K.fromExtHostTestItem(q,T).toString())??[],L,V)}static fromInternal(T,V){return new b(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,V)}constructor(T,V,P,L,q,re){this.controllerId=T,this.id=V,this.isPersisted=q,this.colllection=re,this.c=P.map(ue=>ue+"\0"),this.f=L.map(ue=>ue+"\0")}isIncluded(T){const V=s.$5K.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const P of this.f)if(V===P||V.startsWith(P))return!1;for(const P of this.c)if(V===P||V.startsWith(P))return!0;return!1}}e.$ykc=b;class f{constructor(T){this.provider=T}async provideFileCoverage(T){this.c||(this.c=(async()=>this.provider.provideFileCoverage(T))());try{return(await this.c)?.map(r.TestCoverage.fromFile)??[]}catch(V){throw this.c=void 0,V}}async resolveFileCoverage(T,V){const P=await this.c;let L=P?.[T];return!this.provider||!P||!L?[]:(L.detailedCoverage||(L=P[T]=await this.provider.resolveFileCoverage?.(L,V)??L),L.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class I{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,r.TestItem.toPlain(T.item)),this.c.has(T)||this.f.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.f.delete(T);const V=s.$5K.parentId(T.item.extId);if(V&&this.h.has(V.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{c:T,f:V,g:P}=this;return{get added(){return[...T].map(L=>L.revived)},get updated(){return[...V].map(L=>L.revived)},get removed(){return[...P].map(L=>L.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class $ extends i.$bL{constructor(){super(...arguments),this.s=new N.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}w(T,V){return{...T,revived:r.TestItem.toPlain(T.item),depth:V?V.depth+1:0,children:new Set}}v(){return new I(this.s)}}class D{constructor(T){this.f=T}checkout(){this.c||(this.c=this.g());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(V=>V.revived)},dispose:(0,R.$db)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}g(){const T=new $({asCanonicalUri:V=>V});return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}const y=(G,T,V,P)=>{V?Object.assign(V,P):T.$updateTestRunConfig(G.controllerId,G.profileId,P)};class C{#e;#t;#i;#n;#s;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,y(this,this.#e,this.#n,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,y(this,this.#e,this.#n,{supportsContinuousRun:T}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?this.#t.add(this.profileId):this.#t.delete(this.profileId),y(this,this.#e,this.#n,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,y(this,this.#e,this.#n,{tag:T?r.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,y(this,this.#e,this.#n,{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return N.Event.chain(this.#i,T=>T.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(k.$3f))}constructor(T,V,P,L,q,re,ue,ye,Se,le=!1,we=void 0,_=!1){this.controllerId=q,this.profileId=re,this.f=ue,this.kind=ye,this.runHandler=Se,this._tag=we,this.g=_,this.#e=T,this.#s=V,this.#t=P,this.#i=L,V.set(re,this);const ve=A[ye];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);le&&P.add(re),this.#n={profileId:re,controllerId:q,tag:we?r.TestTag.namespace(this.controllerId,we.id):null,label:ue,group:ve,isDefault:le,hasConfigurationHandler:!1,supportsContinuousRun:_},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$zkc=C;const A={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Me[114],Re([1,0,55,14,90,8,7]),function(me,e,S,F,M,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=void 0;class m{static{this.c=new M.$FO("TextEditorDecorationType")}constructor(l,w,p){const r=m.c.nextId();l.$registerTextEditorDecorationType(w.identifier,r,N.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$HO=m;class d{constructor(l,w){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,w){this.k();let p=null;if(l instanceof R.$jM)p=new R.$kM(l,l);else if(l instanceof R.$kM)p=l;else throw new Error("Unrecognized location");this.l(p,w,!1)}insert(l,w){this.k(),this.l(new R.$kM(l,l),w,!0)}delete(l){this.k();let w=null;if(l instanceof R.$kM)w=l;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(l,w,p){const r=this.c.validateRange(l);this.g.push({range:r,text:w,forceMoveMarkers:p})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=l}}class k{constructor(l,w,p,r){this.c=l,this.d=w,this._accept(p),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}n(l){const w=this.m(l);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}p(l){const w=this.o(l);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const w=this.q(l);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let p=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(p=!0,w.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,p=!0,w.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(p=!0,w.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,p=!0,w.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(p=!0,w.insertSpaces=r):this.j!==r&&(this.j=r,p=!0,w.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,p=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,p=!0,w.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(l,w){w.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(p)})}}e.$IO=k;class O{constructor(l,w,p,r,o,s,n,i){this.id=l,this.j=w,this.k=p,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,s,p),this.e=n,this.f=i;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new F.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$lM))throw(0,F.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof R.$lM)))throw(0,F.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new F.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new F.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new d(r.value,t);return h(v),c.m(v)},insertSnippet(h,t,v={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=c.c.map(g=>N.Range.from(g));else if(t instanceof R.$jM){const{lineNumber:g,column:a}=N.Position.from(t);u=[{startLineNumber:g,startColumn:a,endLineNumber:g,endColumn:a}]}else if(t instanceof R.$kM)u=[N.Range.from(t)];else{u=[];for(const g of t)if(g instanceof R.$kM)u.push(N.Range.from(g));else{const{lineNumber:a,column:b}=N.Position.from(g);u.push({startLineNumber:a,startColumn:b,endLineNumber:a,endColumn:b})}}return w.$tryInsertSnippet(l,r.value.version,h.value,u,v)},setDecorations(h,t){const v=t.length===0;v&&!c.h.has(h.key)||(v?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(N.$xO(t))return w.$trySetDecorations(l,h.key,N.$yO(t));{const u=new Array(4*t.length);for(let g=0,a=t.length;g<a;g++){const b=t[g];u[4*g]=b.start.line+1,u[4*g+1]=b.start.character+1,u[4*g+2]=b.end.line+1,u[4*g+3]=b.end.character+1}return w.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,t){c.n(()=>w.$tryRevealRange(l,N.Range.from(h),t||R.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(l,N.ViewColumn.from(h))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const p=w.edits.map(o=>o.range);p.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=p.length-1;o<s;o++){const n=p[o].end;if(p[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=w.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,r,{setEndOfLine:typeof w.setEndOfLine=="number"?N.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$JO=O}),define(Me[67],Re([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,45,39]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new F.$7d,this.e=new F.$7d,this.f=new F.$7d,this.g=new F.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],t=[],v=[];if(c.removedDocuments)for(const u of c.removedDocuments){const g=N.URI.revive(u),a=this.c.get(g);a?.unref()&&(this.c.delete(g),h.push(a.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const g=N.URI.revive(u.uri);let a=this.c.get(g);if(a&&g.scheme!==p.Schemas.vscodeNotebookCell&&g.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);a||(a=new s(new d.$DO(this.h.getProxy(m.$gM.MainThreadDocuments),g,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this.c.set(g,a),t.push(a.value)),a.ref()}if(c.removedEditors)for(const u of c.removedEditors){const g=this.b.get(u);this.b.delete(u),g&&v.push(g)}if(c.addedEditors)for(const u of c.addedEditors){const g=N.URI.revive(u.documentUri);S.ok(this.c.has(g),`document '${g}' does not exist`),S.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const a=this.c.get(g).value,b=new O.$JO(u.id,this.h.getProxy(m.$gM.MainThreadTextEditors),this.i,new o.$V(()=>a.document),u.selections.map(E.Selection.to),u.options,u.visibleRanges.map(f=>E.Range.to(f)),typeof u.editorPosition=="number"?E.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,b)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Pc)(h),(0,M.$Pc)(v),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$KO=n,e.$KO=n=Je([qe(0,k.$AO),qe(1,l.$Nj)],n),e.$LO=(0,R.$hi)("IExtHostDocumentsAndEditors")}),define(Me[278],Re([1,0,18,5,4,114,8,7]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;class d{constructor(O,E){this.i=E,this.a=new F.$7d,this.b=new F.$7d,this.c=new F.$7d,this.d=new F.$7d,this.f=new F.$7d,this.g=new F.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(M.$gM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const E=this.i.allEditors();return O?E:E.map(l=>l.value)}async showTextDocument(O,E,l){let w;typeof E=="number"?w={position:R.ViewColumn.from(E),preserveFocus:l}:typeof E=="object"?w={position:R.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?R.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:w={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(O.uri,w),r=p&&this.i.getEditor(p);if(r)return r.value;throw p?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,E){return new N.$HO(this.h,O,E).value}$acceptEditorPropertiesChanged(O,E){const l=this.i.getEditor(O);if(!l)throw new Error("unknown text editor");if(E.options&&l._acceptOptions(E.options),E.selections){const w=E.selections.selections.map(R.Selection.to);l._acceptSelections(w)}if(E.visibleRanges){const w=S.$Hb(E.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(w)}if(E.options&&this.b.fire({textEditor:l.value,options:{...E.options,lineNumbers:R.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const w=m.TextEditorSelectionChangeKind.fromValue(E.selections.source),p=E.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:p,kind:w})}if(E.visibleRanges){const w=S.$Hb(E.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(O){for(const E in O){const l=this.i.getEditor(E);if(!l)throw new Error("Unknown text editor");const w=R.ViewColumn.to(O[E]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this.d.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.$Vic=d}),define(Me[279],Re([1,0,2,3,4,6,7,8,20,16]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=void 0,e.$Bkc=(0,F.$hi)("IExtHostTimeline");class O{constructor(w,p){this.b=new Map,this.c=new Map,this.a=w.getProxy(M.$gM.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&d.$Cm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:S.URI.revive(r.uri);return this.c.get(r.source)?.get(E(s))?.get(r.handle)}else return;return r}})}async $getTimeline(w,p,r,o){return this.b.get(w)?.provider.provideTimeline(S.URI.revive(p),r,o)}registerTimelineProvider(w,p,r,o){const s=new N.$Tc,n=this.d(p.id,o,s).bind(this);let i;p.onDidChange&&(i=p.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:p.id}),this));const c=this.c;return this.f({...p,scheme:w,onDidChange:void 0,async provideTimeline(h,t,v){t?.resetCache&&(s.clear(),c.get(p.id)?.clear());const u=await p.provideTimeline(h,t,v);if(u==null)return;const g=n(h,t);return{...u,source:p.id,items:u.items.map(g)}},dispose(){for(const h of c.values())h.get(p.id)?.clear();i?.dispose(),s.dispose()}},r)}d(w,p,r){return(o,s)=>{let n;if(s?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const c=E(o);n=i.get(c),n===void 0&&(n=new Map,i.set(c,n))}return i=>{const{iconPath:c,...h}=i,t=`${w}|${i.id??i.timestamp}`;n?.set(t,i);let v,u,g;i.iconPath&&(c instanceof R.$eN?g={id:c.id,color:c.color}:S.URI.isUri(c)?(v=c,u=c):{light:v,dark:u}=c);let a;return R.$JM.isMarkdownString(h.tooltip)?a=m.MarkdownString.from(h.tooltip):(0,k.$Uf)(h.tooltip)?a=h.tooltip:R.$JM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=m.MarkdownString.from(h.detail)):(0,k.$Uf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:i.command?p.toInternal(i.command,r):void 0,icon:v,iconDark:u,themeIcon:g,tooltip:a,accessibilityInformation:i.accessibilityInformation}}}}f(w,p){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:p}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Ckc=O;function E(l){return l?.toString()}}),define(Me[280],Re([1,0,172,24,2,5,6,210,11,7,16,18,8,53,25,136,22]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;function s(c,h){if((0,O.$Uf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends R.$Uc{constructor(h,t,v){super(),this.f=h,this.g=t,this.h=v,this.a=new Map,this.b=new r.$W9;function u(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:g=>u(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(a=>u(a)?this.r(a):a):g})}registerTreeDataProvider(h,t,v){const u=this.createTreeView(h,{treeDataProvider:t},v);return{dispose:()=>u.dispose()}}createTreeView(h,t,v){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=t.dragAndDropController?.dropMimeTypes??[],g=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,f=this.m(h,t,v),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:u,dragMimeTypes:g,hasHandleDrag:a,hasHandleDrop:b,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(h,I),D={get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get activeItem(){return(0,o.$6F)(v,"treeViewActiveItem"),f.focusedElement},get onDidChangeActiveItem(){return(0,o.$6F)(v,"treeViewActiveItem"),f.onDidChangeActiveItem},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return f.onDidChangeCheckboxState},get message(){return f.message},set message(y){(0,w.$Gk)(y)&&(0,o.$6F)(v,"treeViewMarkdownMessage"),f.message=y},get title(){return f.title},set title(y){f.title=y},get description(){return f.description},set description(y){f.description=y},get badge(){return f.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?f.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(f.badge=void 0)},reveal:(y,C)=>f.reveal(y,C),dispose:async()=>{await $,this.a.delete(h),f.dispose()}};return this.B(D),D}$getChildren(h,t){const v=this.a.get(h);return v?v.getChildren(t):Promise.reject(new m.$xF(h))}async $handleDrop(h,t,v,u,g,a,b,f){const I=this.a.get(h);if(!I)return Promise.reject(new m.$xF(h));const $=l.DataTransfer.toDataTransfer(v,async D=>(await this.f.$resolveDropFileData(h,t,D)).buffer);return b===h&&f&&await this.j($,I,f,g,a),I.onDrop($,u,g)}async j(h,t,v,u,g){const a=this.b.removeDragOperationTransfer(g);if(a)(await a)?.forEach((b,f)=>{b&&h.set(f,b)});else if(g&&t.handleDrag){const b=t.handleDrag(v,h,u);this.b.addDragOperationTransfer(g,b),await b}return h}async $handleDrag(h,t,v,u){const g=this.a.get(h);if(!g)return Promise.reject(new m.$xF(h));const a=await this.j(new k.$aN,g,t,u,v);if(!(!a||u.isCancellationRequested))return l.DataTransfer.from(a)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$xF(h);return t.hasResolve}$resolve(h,t,v){const u=this.a.get(h);if(!u)throw new m.$xF(h);return u.resolveTreeItem(t,v)}$setExpanded(h,t,v){const u=this.a.get(h);if(!u)throw new m.$xF(h);u.setExpanded(t,v)}$setSelectionAndFocus(h,t,v){const u=this.a.get(h);if(!u)throw new m.$xF(h);u.setSelectionAndFocus(t,v)}$setVisible(h,t){const v=this.a.get(h);if(!v){if(!t)return;throw new m.$xF(h)}v.setVisible(t)}$changeCheckboxState(h,t){const v=this.a.get(h);if(!v)throw new m.$xF(h);v.setCheckboxState(t)}m(h,t,v){const u=this.B(new i(h,t,this.f,this.g.converter,this.h,v));return this.a.set(h,u),u}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Dkc=n;class i extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,O.$4f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,v,u,g,a){if(super(),this.I=h,this.J=v,this.L=u,this.M=g,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$ee,a.contributes&&a.contributes.views)for(const $ in a.contributes.views)for(const D of a.contributes.views[$])D.id===h&&(this.P=D.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let b,f;const I=N.Event.debounce(this.F.event,($,D)=>($||($={message:!1,elements:[]}),D.element!==!1&&(b||(b=new Promise(y=>f=y),this.G=this.G.then(()=>b)),Array.isArray(D.element)?$.elements.push(...D.element):$.elements.push(D.element)),D.message&&($.message=!0),$),200,!0);this.B(I(({message:$,elements:D})=>{D.length&&(this.H=this.H.then(()=>{const y=f;return b=null,this.$(D).then(()=>y())})),$&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let v=this.X(h);return v||(v=await this.Y(t)),v?v.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const v=(0,O.$4f)(t.select)?!0:t.select,u=(0,O.$4f)(t.focus)?!1:t.focus,g=(0,O.$4f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(a=>this.W(h,a[a.length-1]).then(b=>this.J.$reveal(this.I,{item:b.item,parentChain:a.map(f=>f.item)},{select:v,focus:u,expand:g})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:v,focus:u,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const v=this.getExtensionElement(h);v&&(t?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(h,t){const v=!(0,E.$ub)(this.s,h);this.s=h;const u=this.t!==t;this.t=t,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async v=>{const u=this.getExtensionElement(v.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:v.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);t.forEach(v=>{v.treeItem.checkboxState=v.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(v=>[v.extensionItem,v.newState])})}async handleDrag(h,t,v){const u=[];for(const g of h){const a=this.getExtensionElement(g);a&&u.push(a)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,t,v),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,v){const u=t?this.getExtensionElement(t):void 0;if(!(!u&&t||!this.g?.handleDrop))return(0,d.$_g)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const v=this.j.get(h);if(v){const u=this.m.get(v);if(u){const g=await this.f.resolveTreeItem(u.extensionItem,v,t)??u.extensionItem;return this.hb(g),u.item.tooltip=this.eb(g.tooltip),u.item.command=this.fb(u.disposableStore,g.command),u.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(v=>this.W(t,v[v.length-1]).then(u=>(v.push(u),v))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$_g)(()=>this.f.getParent(h))}W(h,t){const v=this.m.get(h);return v?Promise.resolve(v):(0,d.$_g)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,t,!0)).then(u=>this.getChildren(t?t.item.handle:void 0).then(()=>{const g=this.getExtensionElement(u);if(g){const a=this.m.get(g);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const v=this.getExtensionElement(h);t=v?this.m.get(v):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new p.$ee(this.Z.token);try{const v=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const g=(0,E.$Hb)(u||[]),a=await Promise.all((0,E.$Hb)(g).map(f=>this.f.getTreeItem(f)));if(t.token.isCancellationRequested)return;const b=a.map((f,I)=>f?this.db(g[I],f,v):null);return(0,E.$Hb)(b)}finally{t.dispose()}}$(h){if(h.some(v=>!v))return this.Z.dispose(!0),this.Z=new p.$ee,this.tb(),this.J.$refresh(this.I);{const v=this.ab(h);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(h){const t=new Set,v=h.map(g=>this.m.get(g));for(const g of v)if(g&&!t.has(g.item.handle)){let a=g;for(;a&&a.parent&&v.findIndex(b=>a&&a.parent&&b&&b.item.handle===a.parent.item.handle)===-1;){const b=this.j.get(a.parent.item.handle);a=b?this.m.get(b):void 0}a&&!a.parent&&t.add(g.item.handle)}const u=[];return t.forEach(g=>{const a=this.j.get(g);if(a){const b=this.m.get(a);b&&(!b.parent||!t.has(b.parent.item.handle))&&u.push(g)}}),u}bb(h){const t={};return Promise.all(h.map(v=>this.cb(v).then(u=>{u&&(t[v]=u.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const v=this.m.get(t);if(v)return this.rb(t),(0,d.$_g)(()=>this.f.getTreeItem(t)).then(u=>{if(u){const g=this.ib(t,u,v.parent);return this.pb(t,g,v,v.parent),v.dispose(),g}return null})}return Promise.resolve(null)}db(h,t,v){const u=this.ib(h,t,v);if(t.id&&this.j.has(u.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(h,u),this.qb(u,v),u}eb(h){return k.$JM.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,v,u;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,v=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:u}}hb(h){if(!k.$8M.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,v){this.hb(t);const u=this.B(new R.$Tc),g=this.kb(h,t,v),a=this.lb(t);return{item:{handle:g,parentHandle:v?v.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(u,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,O.$4f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:v,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof k.$eN?h.iconPath:void 0}kb(h,{id:t,label:v,resourceUri:u},g,a){if(t)return`${i.b}/${t}`;const b=s(v,this.N),f=g?g.item.handle:i.a;let I=b?b.label:u?(0,F.$Rg)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const $=this.m.has(h)?this.m.get(h).item.handle:void 0,D=this.X(g)||[];let y,C=0;do{if(y=`${f}/${C}:${I}`,a||!this.j.has(y)||$===y)break;C++}while(C<=D.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$eN))return typeof h.iconPath=="string"||M.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$eN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return M.URI.isUri(h)?h:M.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,v,u){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(h,t);const g=this.X(u)||[],a=g.filter(b=>b.item.handle===v.item.handle)[0];a&&g.splice(g.indexOf(a),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const u=this.j.get(v.item.handle);u&&this.sb(u)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const u=this.j.get(v.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Me[281],Re([1,0,5,6,2,33,8,62,4,7]),function(me,e,S,F,M,N,R,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;class O extends F.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(p,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$7d),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,M.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class E extends F.$Uc{static c(){return(0,N.$Dg)()}constructor(p,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=p.getProxy(d.$gM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,r,o,s,n={}){const i=typeof s=="object"?s.viewColumn:s,c={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$$ic)(p),t=E.c();this.f.$createWebviewPanel((0,m.$ajc)(p),t,r,{title:o,panelOptions:l(n),webviewOptions:(0,m.$bjc)(p,this.m,n),serializeBuffersForPostMessage:h},c);const v=this.j.createNewWebview(t,n,p);return this.createNewWebviewPanel(t,r,o,i,n,v,!0)}$onDidChangeWebviewPanelViewStates(p){const r=Object.keys(p);r.sort((o,s)=>{const n=p[o],i=p[s];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const n=p[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:p}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$$ic)(p)}),new k.$iM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(p,r,o,s){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:c}=n,h=this.j.createNewWebview(p,o.webviewOptions,c),t=this.createNewWebviewPanel(p,r,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(p,r,o,s,n,i,c){const h=new O(p,this.f,i,{viewType:r,title:o,viewColumn:s,panelOptions:n,active:c});return this.g.set(p,h),h}getWebviewPanel(p){return this.g.get(p)}}e.$cjc=E;function l(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Me[282],Re([1,0,5,6,62,8,4,7]),function(me,e,S,F,M,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class d extends F.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,l,w,p,r,o){super(),this.#s=!1,this.#u=this.B(new S.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$7d),this.onDidDispose=this.#l.event,this.#i=w,this.#a=p,this.#e=E,this.#t=l,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(E,l){this.d=l,this.b=new Map,this.c=new Map,this.a=E.getProxy(R.$gM.MainThreadWebviewViews)}registerWebviewViewProvider(E,l,w,p){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:w,extension:E}),this.a.$registerWebviewViewProvider((0,M.$ajc)(E),l,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$$ic)(E)}),new m.$iM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(E,l,w,p,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:n}=o,i=this.d.createNewWebview(E,{},n),c=new d(E,this.a,l,w,i,!0);this.c.set(E,c),await s.resolveWebviewView(c,{state:p},r)}async $onDidChangeWebviewViewVisibility(E,l){this.e(E)._setVisible(l)}async $disposeWebviewView(E){const l=this.e(E);this.c.delete(E),l.dispose(),this.d.deleteWebview(E)}e(E){const l=this.c.get(E);if(!l)throw new Error("No webview found");return l}}e.$Gkc=k}),define(Me[283],Re([1,0,5,30,35,3]),function(me,e,S,F,M,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$BL=e.OutputChannelUpdateMode=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=void 0,e.$oL="text/x-code-output",e.$pL="output",e.$qL="Log",e.$rL="text/x-code-log-output",e.$sL="log",e.$tL="workbench.panel.output",e.$uL=new M.$yj("inOutput",!1),e.$vL=new M.$yj("activeLogOutput",!1),e.$wL=new M.$yj("activeLogOutput.levelSettable",!1),e.$xL=new M.$yj("activeLogOutput.level",""),e.$yL=new M.$yj("activeLogOutput.levelIsDefault",!1),e.$zL=new M.$yj("outputView.scrollLock",!1),e.$AL=(0,N.$hi)("outputService");var R;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$BL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$7d,this.onDidRegisterChannel=this.b.event,this.c=new S.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(O=>k.push(O)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}F.$Zn.add(e.$BL.OutputChannels,new m),e.$CL=new M.$yj("activeOutputChannel","")}),define(Me[115],Re([1,0,4,3,17,20,13,283,63,27,43,140,23,16,42,5,6]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0;class s extends R.$Tj{get disposed(){return this.n}constructor(h,t,v,u,g){super(),this.id=h,this.name=t,this.r=v,this.s=u,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$ue.fromString(t).byteLength,(0,R.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,v,u,g,a){this.i=t,this.j=v,this.k=u,this.l=g,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(S.$gM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$Om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,v]of this.g)v.visible=t===this.h}createOutputChannel(h,t,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof t=="object"&&t.log,g=(0,w.$Uf)(t)?t:void 0;if((0,w.$Uf)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const b=this.i.environment.extensionLogLevel?.find(([I])=>N.$Cm.equals(v.identifier,I))?.[1];b&&(a=(0,R.$5j)(b));const f=u?this.o(h,a,v):this.n(h,g,v);return f.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(h,a??this.m.getLevel(),f):this.q(h,f)}async n(h,t,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,g=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(h,g,t,v.identifier.value);return new s(b,h,a,this.a,v)}async o(h,t,v){const u=await this.p(v),g=h.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(u,`${g}.log`),b=`${v.identifier.value}.${g}`,f=this.l.createLogger(a,{id:b,name:h,logLevel:t,extensionId:v.identifier.value});return new n(b,h,f,this.a,v)}p(h){let t=this.d.get(h.identifier.value);if(!t){const v=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(v)}catch(u){if((0,p.$4k)(u)!==p.FileSystemProviderErrorCode.FileExists)throw u}return v})())}return t}q(h,t){let v=!1;const u=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return h},append(g){u(),t.then(a=>a.append(g))},appendLine(g){u(),t.then(a=>a.appendLine(g))},clear(){u(),t.then(g=>g.clear())},replace(g){u(),t.then(a=>a.replace(g))},show(g,a){u(),t.then(b=>b.show(g,a))},hide(){u(),t.then(g=>g.hide())},dispose(){v=!0,t.then(g=>g.dispose())}}}r(h,t,v){const u=new o.$Tc,g=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},a=u.add(new r.$7d);function b(f){t=f,a.fire(f)}return v.then(f=>{u.add(f),f.logLevel!==t&&b(f.logLevel),u.add(f.onDidChangeLogLevel(I=>b(I)))}),{...this.q(h,v),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(f,...I){g(),v.then($=>$.trace(f,...I))},debug(f,...I){g(),v.then($=>$.debug(f,...I))},info(f,...I){g(),v.then($=>$.info(f,...I))},warn(f,...I){g(),v.then($=>$.warn(f,...I))},error(f,...I){g(),v.then($=>$.error(f,...I))},dispose(){u.dispose()}}}};e.$hkc=i,e.$hkc=i=Je([qe(0,M.$AO),qe(1,k.$QO),qe(2,d.$7ic),qe(3,O.$Gic),qe(4,R.$Oj),qe(5,R.$Nj)],i),e.$ikc=(0,F.$hi)("IExtHostOutputService")}),define(Me[116],Re([1,0,3,11]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$4m=(0,S.$hi)("remoteAgentService"),e.$5m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const d=await M.getRoundTripTime();if(d===void 0)return;N=Math.min(N,d/2),await(0,F.$ih)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((m,d)=>m+d,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((m,d)=>m+d,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Me[284],Re([1,0,175,56,30,48,47,6,5,116,21,26,11]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=void 0,e.$TI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$UI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$VI=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$WI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$XI={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new d.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const p=new w;M.$Zn.add(e.$XI.ConfigurationMigration,p);let r=class extends m.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(c=>this.g(c,n?.uri))])}async g(n,i){const c=this.a.inspect(n.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,v]of h){const u=c[t];if(!u)continue;const g=[];if(u.value!==void 0){const a=await this.h(n,t,u.value,i,void 0);for(const b of a??[])g.push([b,[]])}for(const{identifiers:a,value:b}of u.overrides??[])if(b!==void 0){const f=await this.h(n,t,b,i,a);for(const I of f??[])g.push([I,a])}g.length&&await Promise.allSettled(g.map(async([[a,b],f])=>this.a.updateValue(a,b.value,{resource:i,overrideIdentifiers:f},v)))}}async h(n,i,c,h,t){const v=g=>{const b=this.a.inspect(g,{resource:h})[i];if(b)return t?b.overrides?.find(({identifiers:f})=>(0,E.$Rn)(f,t))?.value:b.value},u=await n.migrateFn(c,v);return Array.isArray(u)?u:[[n.key,u]]}};e.$YI=r,e.$YI=r=Je([qe(0,R.$Ni),qe(1,N.$qi)],r);let o=class extends m.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new l.$Eh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!O.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$Zn.as(F.$5n.Configuration).registerConfiguration({...e.$VI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$ZI=o,e.$ZI=o=Je([qe(0,k.$4m)],o)}),define(Me[285],Re([1,0,34,12,19,24,183,284,56,3,30]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kfb=e.$jfb=void 0,e.$lfb=r,e.$mfb=o,e.$jfb=(0,k.$hi)("editorResolverService"),e.$kfb="workbench.editorAssociations";const E=O.$Zn.as(d.$5n.Configuration),l={...m.$UI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(l);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var p;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function r(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(s,n){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(M.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$Rg)(n);return S.$ak(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Me[286],Re([1,0,46,12,19,21,24,2,3,204,48,222,116]),function(me,e,S,F,M,N,R,m,d,k,O,E,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,d.$hi)("pathService");let p=w=class{constructor(o,s,n,i){this.d=o,this.e=s,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===F.Schemas.file||o.scheme===F.Schemas.vscodeRemote?(0,S.$fg)(n??(0,R.$Rg)(o),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return F.Schemas.vscodeRemote;const n=(0,k.$RL)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:F.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?M.$gc:M.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:F.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$VL=p,e.$VL=p=w=Je([qe(1,l.$4m),qe(2,E.$DL),qe(3,O.$qi)],p)}),define(Me[117],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$oK=e.$nK=void 0;class S{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new S(0,0)}with(R){return new S(0,0)}}e.$nK=S;class F{constructor(R,m,d,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,m),this.end=new S(d,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$oK=F;var M;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Me[44],Re([1,0,18,34,26,46,15,3,19,14,117,11]),function(me,e,S,F,M,N,R,m,d,k,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$LK=e.$EK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$BK=e.$AK=e.$zK=e.$yK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.TextSearchCompleteMessageType=void 0,e.$vK=s,e.$wK=n,e.$xK=i,e.$CK=f,e.$DK=I,e.$FK=y,e.$GK=C,e.$HK=A,e.$IK=G,e.$JK=T,e.$KK=V,e.$MK=L,e.$OK=ue,e.$PK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.$pK="workbench.view.search",e.$qK="workbench.panel.search",e.$rK="workbench.view.search",e.$sK="search-result",e.$tK="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",p=(l.length+w.length+5)*2;e.$uK=(0,m.$hi)("searchService");var r;(function(le){le[le.file=0]="file",le[le.text=1]="text",le[le.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(le){le[le.File=1]="File",le[le.Text=2]="Text",le[le.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(le){return!!le.preview}function n(le){return!!le.resource}function i(le){return!!le.message}var c;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(we){this.resource=we,this.results=[]}}e.$yK=h;class t{constructor(we,_,ve,ne){this.ranges=_,this.webviewIndex=ne;const fe=Array.isArray(_)?_:[_];if(ve&&ve.matchLines===1&&v(fe)){we=(0,R.$Nf)(we,ve.matchLines);let W="",te=0,Ee=0;const Te=Math.floor(ve.charsPerLine/5),Ie=[];for(const pe of fe){const ge=Math.max(pe.startColumn-Te,0),J=pe.startColumn+ve.charsPerLine;if(ge>Ee+Te+p){const X=l+(ge-Ee)+w;W+=X+we.slice(ge,J),te+=ge-(Ee+X.length)}else W+=we.slice(Ee,J);Ie.push(new g(0,pe.startColumn-te,pe.endColumn-te)),Ee=J}this.preview={text:W,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const W=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:we,matches:(0,S.$2b)(_,te=>new u(te.startLineNumber-W,te.startColumn,te.endLineNumber-W,te.endColumn))}}}}e.$zK=t;function v(le){const we=le[0].startLineNumber;for(const _ of le)if(_.startLineNumber!==we||_.endLineNumber!==we)return!1;return!0}class u{constructor(we,_,ve,ne){this.startLineNumber=we,this.startColumn=_,this.endLineNumber=ve,this.endColumn=ne}}e.$AK=u;class g extends u{constructor(we,_,ve){super(we,_,we,ve)}}e.$BK=g;var a;(function(le){le.List="list",le.Tree="tree"})(a||(e.ViewMode=a={}));var b;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function f(le,we=!0){const _=le&&le.files&&le.files.exclude,ve=we&&le&&le.search&&le.search.exclude;if(!_&&!ve)return;if(!_||!ve)return _||ve;let ne=Object.create(null);return ne=M.$Qn(ne,M.$Nn(_)),ne=M.$Qn(ne,M.$Nn(ve),!0),ne}function I(le,we){return le.excludePattern&&F.$ak(le.excludePattern,we)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&F.$ak(le.includePattern,we)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(_=>{const ve=_.folder.fsPath;if(N.$hg(we,ve)){const ne=d.$mc(ve,we);return!_.includePattern||!!F.$ak(_.includePattern,ne)}else return!1}):!1:!0}var $;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class D extends Error{constructor(we,_){super(we),this.code=_}}e.$EK=D;function y(le){const we=le.message;if((0,k.$4)(le))return new D(we,$.canceled);try{const _=JSON.parse(we);return new D(_.message,_.code)}catch{return new D(we,$.other)}}function C(le){const we={message:le.message,code:le.code};return new Error(JSON.stringify(we))}function A(le){return le.type==="error"?!0:le.type==="success"}function G(le){return le.type==="success"}function T(le){return!!le.path}function V(le,we,_=!0){const ve=le.searchPath?le.searchPath:le.relativePath;return _?(0,R.$Kf)(ve,we):F.$ak(we,ve)}class P{constructor(we){this.path=we,this.results=[]}addMatch(we){this.results.push(we)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$LK=P;function L(le,we){const _={...le||{},...we||{}};return Object.keys(_).filter(ve=>{const ne=_[ve];return typeof ne=="boolean"&&ne})}class q{constructor(we,_){this.c=null,this.a={...we.excludePattern||{},..._.excludePattern||{}},this.b=F.$bk(this.a);let ve=we.includePattern;_.includePattern&&(ve?ve={...ve,..._.includePattern}:ve=_.includePattern),ve&&(this.c=F.$bk(ve))}matchesExcludesSync(we,_,ve){return!!(this.b&&this.b(we,_,ve))}includedInQuerySync(we,_,ve){return!(this.b&&this.b(we,_,ve)||this.c&&!this.c(we,_,ve))}includedInQuery(we,_,ve){const ne=this.b(we,_,ve),fe=()=>this.c?!!this.c(we,_,ve):!0;return(0,E.$6g)(ne)?ne.then(W=>W?!1:fe()):fe()}hasSiblingExcludeClauses(){return re(this.a)}}e.$NK=q;function re(le){for(const we in le)if(typeof le[we]!="boolean")return!0;return!1}function ue(le){if(!le)return;let we;return _=>(we||(we=(le()||Promise.resolve([])).then(ve=>ve?Se(ve):{})),we.then(ve=>!!ve[_]))}function ye(le){if(!le)return;let we;return _=>{if(!we){const ve=le();we=ve?Se(ve):{}}return!!we[_]}}function Se(le){const we={};for(const _ of le)we[_]=!0;return we}}),define(Me[36],Re([1,0,18,11,25,5,6,51,12,125,24,15,2,174,3,13,193,48,43,27,17,8,7,59,44,4,52]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v,u,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0;function b(G,T,V){return new O.$Jg(P=>D(P,V)).isEqual(G,T)}function f(G,T,V){return b(G.uri,T.uri,V)?0:(0,E.$ef)(G.uri.toString(),T.uri.toString())}function I(G,T,V){return G.index!==T.index?G.index<T.index?-1:1:b(G.uri,T.uri,V)?(0,E.$ef)(G.name,T.name):(0,E.$ef)(G.uri.toString(),T.uri.toString())}function $(G,T,V,P){const L=G.slice(0).sort((re,ue)=>V(re,ue,P)),q=T.slice(0).sort((re,ue)=>V(re,ue,P));return(0,S.$Eb)(L,q,(re,ue)=>V(re,ue,P))}function D(G,T){const V=T.getCapabilities(G.scheme);return!(V&&V&1024)}class y extends s.$Ai{static toExtHostWorkspace(T,V,P,L){if(!T)return{workspace:null,added:[],removed:[]};const{id:q,name:re,folders:ue,configuration:ye,transient:Se,isUntitled:le}=T,we=[],_=V;V?ue.forEach((W,te)=>{const Ee=l.URI.revive(W.uri),Te=y.o(P||V,Ee,L);Te?(Te.name=W.name,Te.index=W.index,we.push(Te)):we.push({uri:Ee,name:W.name,index:te})}):we.push(...ue.map(({uri:W,name:te,index:Ee})=>({uri:l.URI.revive(W),name:te,index:Ee}))),we.sort((W,te)=>W.index<te.index?-1:1);const ve=new y(q,re,we,!!Se,ye?l.URI.revive(ye):null,!!le,W=>D(W,L)),{added:ne,removed:fe}=$(_?_.workspaceFolders:[],ve.workspaceFolders,f,L);return{workspace:ve,added:ne,removed:fe}}static o(T,V,P){for(let L=0;L<T.folders.length;L++){const q=T.workspaceFolders[L];if(b(q.uri,V,P))return q}}constructor(T,V,P,L,q,re,ue){super(T,P.map(ye=>new s.$Bi(ye)),L,q,ue),this.t=V,this.u=re,this.q=[],this.s=m.$ni.forUris(ue),P.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,V){return V&&this.s.get(T)&&(T=(0,O.$Tg)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let C=class{constructor(T,V,P,L,q){this.c=new N.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$9d,this.C=new Map,this.h=L,this.s=P,this.t=q,this.j=new k.$om,this.k=new F.$gh,this.o=T.getProxy(g.$gM.MainThreadWorkspace),this.q=T.getProxy(g.$gM.MainThreadMessageService);const re=V.workspace;this.l=re?new y(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ue=>D(ue,P)):void 0}$initializeWorkspace(T,V){this.v=V,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:d.Schemas.untitled,path:(0,O.$Rg)((0,O.$Tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,V,P,...L){const q=[];if(Array.isArray(L)&&L.forEach(le=>{l.URI.isUri(le.uri)&&!q.some(we=>b(we.uri,le.uri,this.s))&&q.push({uri:le.uri,name:le.name||(0,O.$Qg)(le.uri)})}),this.n||[V,P].some(le=>typeof le!="number"||le<0)||P===0&&q.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(V+P>re.length)return!1;const ue=re.slice(0);ue.splice(V,P,...q.map(le=>({uri:le.uri,name:le.name||(0,O.$Qg)(le.uri),index:void 0})));for(let le=0;le<ue.length;le++){const we=ue[le];if(ue.some((_,ve)=>ve!==le&&b(we.uri,_.uri,this.s)))return!1}ue.forEach((le,we)=>le.index=we);const{added:ye,removed:Se}=$(re,ue,I,this.s);if(ye.length===0&&Se.length===0)return!1;if(this.o){const le=T.displayName||T.name;this.o.$updateWorkspaceFolders(le,V,P,q).then(void 0,we=>{this.n=void 0;const _={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,le,we.toString()),_,[])})}return this.y(ue),!0}getWorkspaceFolder(T,V){if(this.x)return this.x.getWorkspaceFolder(T,V)}async getWorkspaceFolder2(T,V){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,V)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,V){let P,L="";if(typeof T=="string"?(P=l.URI.file(T),L=T):typeof T<"u"&&(P=T,L=T.fsPath),!P)return L;const q=this.getWorkspaceFolder(P,!0);if(!q)return L;typeof V>"u"&&this.x&&(V=this.x.folders.length>1);let re=(0,O.$Wg)(q.uri,P);return V&&q.name&&(re=`${q.name}/${re}`),re}y(T){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:V,added:P,removed:L}=y.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=V||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:L}))}findFiles(T,V,P,L,q=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let re="",ue=!0;return V===null?ue=!1:V!==void 0&&(typeof V=="string"?re=V:re=V.pattern),this.z(T,void 0,{exclude:re,maxResults:P,useDefaultExcludes:ue,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},q)}findFiles2(T,V={},P,L=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${P.value}, entryPoint: findFiles2`),this.z(void 0,T,V,L)}async z(T,V,P,L=M.CancellationToken.None){if(L&&L.isCancellationRequested)return Promise.resolve([]);const q=typeof P.exclude=="string"?P.exclude:P.exclude?P.exclude.pattern:void 0,re={ignoreSymlinks:typeof P.followSymlinks=="boolean"?!P.followSymlinks:void 0,disregardIgnoreFiles:typeof P.useIgnoreFiles=="boolean"?!P.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof P.useGlobalIgnoreFiles=="boolean"?!P.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof P.useParentIgnoreFiles=="boolean"?!P.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof P.useDefaultExcludes=="boolean"?!P.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof P.useDefaultSearchExcludes=="boolean"?!P.useDefaultSearchExcludes:!1,maxResults:P.maxResults,excludePattern:q,shouldGlobSearch:typeof P.fuzzy=="boolean"?!P.fuzzy:!0,_reason:"startFileSearch"};let ue;if(T){const{includePattern:ye,folder:Se}=A(h.GlobPattern.from(T));ue=Se,re.includePattern=ye}else{const{includePattern:ye,folder:Se}=A(h.GlobPattern.from(V));ue=Se,re.filePattern=ye}return this.o.$startFileSearch(ue??null,re,L).then(ye=>Array.isArray(ye)?ye.map(Se=>l.URI.revive(Se)):[])}async findTextInFiles(T,V,P,L,q=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ue=typeof V.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:V.previewOptions,{includePattern:ye,folder:Se}=A(h.GlobPattern.from(V.include)),le=typeof V.exclude=="string"?V.exclude:V.exclude?V.exclude.pattern:void 0,we={ignoreSymlinks:typeof V.followSymlinks=="boolean"?!V.followSymlinks:void 0,disregardIgnoreFiles:typeof V.useIgnoreFiles=="boolean"?!V.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof V.useGlobalIgnoreFiles=="boolean"?!V.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof V.useParentIgnoreFiles=="boolean"?!V.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof V.useDefaultExcludes=="boolean"?!V.useDefaultExcludes:!0,fileEncoding:V.encoding,maxResults:V.maxResults,previewOptions:ue,afterContext:V.afterContext,beforeContext:V.beforeContext,includePattern:ye,excludePattern:le},_=!1;if(this.u[re]=ve=>{if(_)return;const ne=l.URI.revive(ve.resource);ve.results.forEach(fe=>{const W=(0,a.$Qh)(fe);(0,u.$vK)(W)?P({uri:ne,preview:{text:W.preview.text,matches:(0,S.$2b)(W.preview.matches,te=>new t.$kM(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))},ranges:(0,S.$2b)(W.ranges,te=>new t.$kM(te.startLineNumber,te.startColumn,te.endLineNumber,te.endColumn))}):P({uri:ne,text:W.text,lineNumber:W.lineNumber})})},q.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(T,Se??null,we,re,q);return delete this.u[re],ve||{}}catch(ve){throw delete this.u[re],ve}}$handleTextSearchResult(T,V){this.u[V]?.(T)}async save(T){const V=await this.o.$save(T,{saveAs:!1});return l.URI.revive(V)}async saveAs(T){const V=await this.o.$save(T,{saveAs:!0});return l.URI.revive(V)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,V){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,V);const P=this.t.transformOutgoingScheme(T),L=this.A++;return this.o.$registerEditSessionIdentityProvider(L,P),(0,R.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(T,V){this.h.info("Getting edit session identifier for workspaceFolder",T);const P=await this.resolveWorkspaceFolder(l.URI.revive(T));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const L=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!L),!L)return;const q=await L.provideEditSessionIdentity(P,V);if(this.h.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch(T,V,P,L){this.h.info("Getting edit session identifier for workspaceFolder",T);const q=await this.resolveWorkspaceFolder(l.URI.revive(T));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const re=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!re),!re)return;const ue=await re.provideEditSessionIdentityMatch?.(V,P,L);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(T){return(V,P,L)=>{const q=function(ue){V.call(P,ue)};return q.extension=T,this.B.event(q,void 0,L)}}async $onWillCreateEditSessionIdentity(T,V,P){const L=await this.resolveWorkspaceFolder(l.URI.revive(T));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:L},V,async(q,re)=>{const ue=Date.now();await Promise.resolve(q),Date.now()-ue>P&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),V.isCancellationRequested}registerCanonicalUriProvider(T,V){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,V);const P=this.t.transformOutgoingScheme(T),L=this.A++;return this.o.$registerCanonicalUriProvider(L,P),(0,R.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(T,V,P){const L=this.C.get(T.scheme);if(!L)return;const q=await L.provideCanonicalUri?.(l.URI.revive(T),V,P);if(q)return q}async $provideCanonicalUri(T,V,P){return this.provideCanonicalUri(l.URI.revive(T),{targetScheme:V},P)}};e.$1ic=C,e.$1ic=C=Je([qe(0,c.$AO),qe(1,i.$QO),qe(2,n.$Gic),qe(3,r.$Nj),qe(4,v.$Yic)],C),e.$2ic=(0,p.$hi)("IExtHostWorkspace");function A(G){let T,V;return G&&(typeof G=="string"?T=G:(T=G.pattern,V=l.URI.revive(G.baseUri))),{includePattern:T,folder:V}}}),define(Me[37],Re([1,0,26,5,36,4,7,195,56,16,11,3,17,13,2]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=e.$4ic=e.$3ic=void 0;function r(v,u){if(u){const g=u.split(".");let a=v;for(let b=0;a&&b<g.length;b++)a=a[g[b]];return a}}function o(v){return v instanceof p.URI}function s(v){return v&&v.uri instanceof p.URI&&v.languageId&&typeof v.languageId=="string"}function n(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&v.uri instanceof p.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function c(v){if(o(v))return{resource:v};if(s(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(n(v))return{overrideIdentifier:v.languageId};if(i(v))return{resource:v.uri};if(v===null)return{resource:null}}let h=class{constructor(u,g,a){this.a=u.getProxy(N.$gM.MainThreadConfiguration),this.c=g,this.b=a,this.d=new O.$gh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new t(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,g){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(u,g))}};e.$3ic=h,e.$3ic=h=Je([qe(0,l.$AO),qe(1,M.$2ic),qe(2,w.$Nj)],h);class t{constructor(u,g,a,b){this.a=new F.$7d,this.b=u,this.f=b,this.c=g,this.e=m.$lo.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,g){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$lo.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(g,a))}getConfiguration(u,g,a){const b=c(g)||{},f=this.g(u?r(this.e.getValue(void 0,b,this.c.workspace),u):this.e.getValue(void 0,b,this.c.workspace));u&&this.h(u,b,a?.identifier);function I(D){if(D==null)return null;if(typeof D=="boolean")return D?2:5;switch(D){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(D){return typeof r(f,D)<"u"},get:(D,y)=>{this.h(u?`${u}.${D}`:D,b,a?.identifier);let C=r(f,D);if(typeof C>"u")C=y;else{let A;const G=(T,V)=>{if((0,k.$Wf)(T)){let P;const L=()=>{A=A||(0,S.$Nn)(f),P=P||r(A,V)};return new Proxy(T,{get:(q,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return L(),()=>P;if(A)return P=P||r(A,V),P[re];const ue=q[re];return typeof re=="string"?G(ue,`${V}.${re}`):ue},set:(q,re,ue)=>(L(),P&&(P[re]=ue),!0),deleteProperty:(q,re)=>(L(),P&&delete P[re],!0),defineProperty:(q,re,ue)=>(L(),P&&Object.defineProperty(P,re,ue),!0)})}return Array.isArray(T)?(0,S.$Nn)(T):T};C=G(C,D)}return C},update:(D,y,C,A)=>{D=u?`${u}.${D}`:D;const G=I(C);return y!==void 0?this.b.$updateConfigurationOption(G,D,y,b,A):this.b.$removeConfigurationOption(G,D,b,A)},inspect:D=>{D=u?`${u}.${D}`:D;const y=this.e.inspect(D,b,this.c.workspace);if(y)return{key:D,defaultValue:(0,S.$Nn)(y.policy?.value??y.default?.value),globalValue:(0,S.$Nn)(y.user?.value??y.application?.value),workspaceValue:(0,S.$Nn)(y.workspace?.value),workspaceFolderValue:(0,S.$Nn)(y.workspaceFolder?.value),defaultLanguageValue:(0,S.$Nn)(y.default?.override),globalLanguageValue:(0,S.$Nn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,S.$Nn)(y.workspace?.override),workspaceFolderLanguageValue:(0,S.$Nn)(y.workspaceFolder?.override),languageIds:(0,S.$Nn)(y.overrideIdentifiers)}}};return typeof f=="object"&&(0,S.$Qn)($,f,!1),Object.freeze($)}g(u){const g=a=>(0,k.$Wf)(a)?new Proxy(a,{get:(b,f)=>g(b[f]),set:(b,f,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(b,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(b,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return g(u)}h(u,g,a){const b=d.$co.test(u)?4:this.d.get(u),f=a?`[${a.value}] `:"";if(b===4){typeof g?.resource>"u"&&this.f.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){g?.resource&&this.f.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,g){const a=new m.$no(u,g,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,f)=>a.affectsConfiguration(b,c(f))})}k(u){return u.reduce((g,a)=>(g.set(a[0],a[1]),g),new Map)}}e.$4ic=t,e.$5ic=(0,E.$hi)("IExtHostConfiguration")}),define(Me[118],Re([1,0,2,11,5,4,7,36,67,37,25,66,17,27,3,12,21,13,78,227,14]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$ukc=e.$tkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(G){function T(P){if(P!=null)return P}G.from=T;function V(P){if(P!=null)return P}G.to=V})(h||(h={}));var t;(function(G){function T(P){if(P!=null)return P}G.from=T;function V(P){if(P!=null)return P}G.to=V})(t||(t={}));var v;(function(G){function T(P){if(P!=null)return P}G.from=T;function V(P){if(P!=null)return P}G.to=V})(v||(v={}));var u;(function(G){function T(L){if(L){const q=L;return q&&!!q.process}else return!1}G.is=T;function V(L){if(L==null)return;const q={process:L.process,args:L.args};return L.options&&(q.options=v.from(L.options)),q}G.from=V;function P(L){if(L!=null)return new R.$4M(L.process,L.args,L.options)}G.to=P})(u||(u={}));var g;(function(G){function T(P){if(P!=null)return P}G.from=T;function V(P){if(P!=null)return P}G.to=V})(g||(g={}));var a;(function(G){function T(L){if(L){const q=L;return q&&(!!q.commandLine||!!q.command)}else return!1}G.is=T;function V(L){if(L==null)return;const q={};return L.commandLine!==void 0?q.commandLine=L.commandLine:(q.command=L.command,q.args=L.args),L.options&&(q.options=g.from(L.options)),q}G.from=V;function P(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new R.$5M(L.commandLine,L.options):new R.$5M(L.command,L.args?L.args:[],L.options)}G.to=P})(a||(a={}));var b;(function(G){function T(L){if(L){const q=L;return q&&q.customExecution==="customExecution"}else return!1}G.is=T;function V(L){return{customExecution:"customExecution"}}G.from=V;function P(L,q){return q.get(L)}G.to=P})(b||(e.CustomExecutionDTO=b={}));var f;(function(G){function T(V,P){let L;return V.scope!==void 0&&typeof V.scope!="number"?L=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===R.TaskScope.Workspace&&P&&P.workspaceFile?L=P.workspaceFile:L=i.$oH),{id:V._id,workspaceFolder:L}}G.from=T})(f||(e.TaskHandleDTO=f={}));var I;(function(G){function T(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}G.from=T})(I||(I={}));var $;(function(G){function T(L,q){if(L==null)return[];const re=[];for(const ue of L){const ye=V(ue,q);ye&&re.push(ye)}return re}G.fromMany=T;function V(L,q){if(L==null)return;let re;L.execution instanceof R.$4M?re=u.from(L.execution):L.execution instanceof R.$5M?re=a.from(L.execution):L.execution&&L.execution instanceof R.$6M&&(re=b.from(L.execution));const ue=h.from(L.definition);let ye;return L.scope?typeof L.scope=="number"?ye=L.scope:ye=L.scope.uri:ye=R.TaskScope.Workspace,!ue||!ye?void 0:{_id:L._id,definition:ue,name:L.name,source:{extensionId:q.identifier.value,label:L.source,scope:ye},execution:re,isBackground:L.isBackground,group:I.from(L.group),presentationOptions:t.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}G.from=V;async function P(L,q,re){if(L==null)return;let ue;u.is(L.execution)?ue=u.to(L.execution):a.is(L.execution)?ue=a.to(L.execution):b.is(L.execution)&&(ue=b.to(L._id,re));const ye=h.to(L.definition);let Se;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?Se=L.source.scope:Se=await q.resolveWorkspaceFolder(S.URI.revive(L.source.scope)):Se=R.TaskScope.Workspace),!ye||!Se)return;const le=new R.$7M(ye,Se,L.name,L.source.label,ue,L.problemMatchers);return L.isBackground!==void 0&&(le.isBackground=L.isBackground),L.group!==void 0&&(le.group=R.$3M.from(L.group._id),le.group&&L.group.isDefault&&(le.group=new R.$3M(le.group.id,le.group.label),L.group.isDefault===!0&&(le.group.isDefault=L.group.isDefault))),L.presentationOptions&&(le.presentationOptions=t.to(L.presentationOptions)),L._id&&(le._id=L._id),L.detail&&(le.detail=L.detail),le}G.to=P})($||(e.TaskDTO=$={}));var D;(function(G){function T(P){return P}G.from=T;function V(P){if(P)return Object.assign(Object.create(null),P)}G.to=V})(D||(D={}));class y{#e;constructor(T,V,P){this._id=V,this.a=P,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let C=class{constructor(T,V,P,L,q,re,ue,ye){this.q=new M.$7d,this.r=new M.$7d,this.s=new M.$7d,this.u=new M.$7d,this.a=T.getProxy(N.$gM.MainThreadTask),this.b=P,this.c=L,this.d=q,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,V,P){if(!P)return new R.$iM(()=>{});const L=this.x();return this.j.set(L,{type:V,provider:P,extension:T}),this.a.$registerTaskProvider(L,V),new R.$iM(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(T,V){this.a.$registerTaskSystem(T,V)}fetchTasks(T){return this.a.$fetchTasks(D.from(T)).then(async V=>{const P=[];for(const L of V){const q=await $.to(L,this.b,this.m);q&&P.push(q)}return P})}get taskExecutions(){const T=[];return this.k.forEach(V=>T.push(V)),T}terminateTask(T){if(!(T instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,V,P){const L=this.m.get(T.id);L&&(this.o.set(T.id,L),this.e.attachPtyToTerminal(V,await L.callback(P))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const V=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:V})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const V=await this.z(T.id);this.s.fire({execution:V,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const V=await this.z(T.id);this.u.fire({execution:V,exitCode:T.exitCode})}$provideTasks(T,V){const P=this.j.get(T);if(!P)return Promise.reject(new Error("no handler found"));const L=[],q=(0,F.$_g)(()=>P.provider.provideTasks(O.CancellationToken.None)).then(re=>this.v(V,L,P,re));return new Promise(re=>{q.then(ue=>{Promise.all(L).then(()=>{re(ue)})})})}async $resolveTask(T,V){const P=this.j.get(T);if(!P)return Promise.reject(new Error("no handler found"));if(V.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${P.type}].`);const L=await $.to(V,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const q=await P.provider.resolveTask(L,O.CancellationToken.None);if(!q)return;this.A(q,P);const re=$.from(q,P.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(re.execution)&&await this.y(re,q,!0),await this.w(re)}x(){return this.h++}async y(T,V,P){const L=await this.a.$createTaskId(T);!P&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,V.execution)),this.m.set(L,V.execution)}async z(T,V){if(typeof T=="string"){const q=this.l.get(T);if(!q)throw new c.$bb("Unexpected: The specified task is missing an execution");return q}const P=this.l.get(T.id);if(P)return P;let L;return V?L=Promise.resolve(new y(this,T.id,V)):L=$.to(T.task,this.b,this.m).then(q=>{if(!q)throw new c.$bb("Unexpected: Task does not exist.");return new y(this,T.id,q)}),this.l.set(T.id,L),L.then(q=>(this.k.set(T.id,q),q))}A(T,V){T._deprecated&&this.g.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const P=this.n.values();let L=P.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=P.next()}};e.$tkc=C,e.$tkc=C=Je([qe(0,l.$AO),qe(1,w.$QO),qe(2,m.$2ic),qe(3,d.$LO),qe(4,k.$5ic),qe(5,E.$qjc),qe(6,s.$Nj),qe(7,n.$Cic)],C);let A=class extends C{constructor(T,V,P,L,q,re,ue,ye){super(T,V,P,L,q,re,ue,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(T,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const P=$.from(V,T);if(P===void 0)throw new Error("Task is not valid");if(b.is(P.execution))await this.y(P,V,!1);else throw new c.$_;const L=await this.z(await this.a.$getTaskExecution(P),V);return this.a.$executeTask(P).catch(q=>{throw new Error(q)}),L}v(T,V,P,L){const q=[];if(L)for(const re of L){if(this.A(re,P),!re.definition||!T[re.definition.type]){const ye=re.source?re.source:"No task source";this.f.warn(`The task [${ye}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=$.from(re,P.extension);ue&&b.is(ue.execution)?(q.push(ue),V.push(this.y(ue,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:P.extension}}async w(T){if(b.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,V,P){}};e.$ukc=A,e.$ukc=A=Je([qe(0,l.$AO),qe(1,w.$QO),qe(2,m.$2ic),qe(3,d.$LO),qe(4,k.$5ic),qe(5,E.$qjc),qe(6,s.$Nj),qe(7,n.$Cic)],A),e.$vkc=(0,p.$hi)("IExtHostTask")}),define(Me[287],Re([1,0,44,29]),function(me,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=void 0,e.$VK=M,e.$XK=N;function M(R){return"cellResults"in R}e.$WK="rawCell#";function N(R,m){let d=-1;const k=[];let O=[];return R.forEach(l=>{l.range.startLineNumber!==d&&O.length>0&&(k.push([...O]),O=[]),O.push(l),d=l.range.endLineNumber}),O.length>0&&k.push([...O]),k.map(l=>{const w=[],p=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=p;o<=r;o++)w.push(m.getLineContent(o));return new S.$zK(w.join(`
`)+`
`,l.map(o=>new F.$at(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Me[288],Re([1,0,168,23,5,6,28,15,16,2,42,74,4,31,8,7,50,263,112,26,12,217,287,285]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,b,f,I,$,D){this.q=f,this.r=I,this.s=$,this.t=D,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new M.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$Aic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(l.$gM.MainThreadNotebook),this.c=a.getProxy(l.$gM.MainThreadNotebookDocuments),this.d=a.getProxy(l.$gM.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,A=y.cell.handle,T=this.g.get(C)?.getCell(A);if(T)return T.apiCell}if(y&&y.$mid===14){const C=y.uri,A=this.g.get(C);if(A)return A.apiNotebook}return y}}),u.B(b)}getEditorById(a){const b=this.h.get(a);if(!b)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(a){for(const[b,f]of this.h)if(f.apiEditor===a)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,b){const f=this.g.get(a);if(!f&&!b)throw new Error(`NO notebook document for '${a}'`);return f}static u(a,b){if(!b)return;const f=b.filenamePattern.map(I=>p.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(b.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:b.displayName,filenamePattern:f,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,b,f){const I=u.a++,$=typeof f.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(I,f),this.b.$registerNotebookCellStatusBarItemProvider(I,$,b);let D;return $!==void 0&&(D=f.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent($))),new r.$iM(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,$),D?.dispose()})}async createNotebookDocument(a){const b=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&p.NotebookData.from(a.content)});return k.URI.revive(b)}async openNotebookDocument(a){const b=this.g.get(a);if(b)return b.apiNotebook;const f=await this.c.$tryOpenNotebook(a),I=this.g.get(k.URI.revive(f));return(0,d.$6f)(I?.apiNotebook)}async showNotebookDocument(a,b){k.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let f;typeof b=="object"?f={position:p.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(p.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:f={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,f),$=I&&this.h.get(I)?.apiEditor;if($)return $;throw I?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,b,f,I){const $=this.f.get(a),D=k.URI.revive(b),y=this.g.get(D);if(!y||!$)return;const C=y.getCellFromIndex(f);if(!C)return;const A=await $.provideCellStatusBarItems(C.apiCell,I);if(!A)return;const G=new N.$Tc,T=this.p.add([G]),P=(Array.isArray(A)?A:[A]).map(L=>p.NotebookStatusBarItem.from(L,this.i,G));return{cacheId:T,items:P}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,b,f,I,$){if((0,m.$Ue)(b))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:b,serializer:f,options:I}),this.b.$registerNotebookSerializer(D,{id:a.identifier,location:a.extensionLocation},b,p.NotebookDocumentContentOptions.from(I),u.u(a,$)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(a,b,f){const I=this.x.get(a);if(!I)throw new Error("NO serializer found");const $=await I.serializer.deserializeNotebook(b.buffer,f);return new o.$cw(p.NotebookData.from($))}async $notebookToData(a,b,f){const I=this.x.get(a);if(!I)throw new Error("NO serializer found");const $=await I.serializer.serializeNotebook(p.NotebookData.to(b.value),f);return F.$ue.wrap($)}async $saveNotebook(a,b,f,I,$){const D=k.URI.revive(b),y=this.x.get(a);if(!y)throw new Error("NO serializer found");const C=this.g.get(D);if(!C)throw new Error("Document NOT found");if(C.versionId!==f)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new O.$9k((0,S.localize)(0,null,this.z(D)),6);await this.y(D,I);const A={metadata:(0,i.$Vn)(C.apiNotebook.metadata,L=>!(y.options?.transientDocumentMetadata??{})[L]),cells:[]};for(const L of C.apiNotebook.getCells()){const q=new r.$KN(L.kind,L.document.getText(),L.document.languageId,L.mime,y.options?.transientOutputs?[]:[...L.outputs],L.metadata,L.executionSummary);q.metadata=(0,i.$Vn)(L.metadata,re=>!(y.options?.transientCellMetadata??{})[re]),A.cells.push(q)}const G=await y.serializer.serializeNotebook(A,$);await this.s.value.writeFile(D,G);const T=this.s.getFileSystemProviderExtUri(D.scheme),V=await this.s.value.stat(D);return{name:T.basename(D),isFile:(V.type&O.FileType.File)!==0,isDirectory:(V.type&O.FileType.Directory)!==0,isSymbolicLink:(V.type&O.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&O.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((V.permissions??0)&O.FilePermission.Locked),etag:O.$hl({mtime:V.mtime,size:V.size}),children:void 0}}async $searchInNotebooks(a,b,f,I,$){const D=this.x.get(a)?.serializer;if(!D)return{limitHit:!1,results:[]};const y=new R.$Cc;await(async(V,P,L)=>{await Promise.all(V.map(async q=>await Promise.all(q.filenamePatterns.map(re=>{const ue={_reason:L._reason,folderQueries:L.folderQueries,includePattern:L.includePattern,excludePattern:L.excludePattern,maxResults:L.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ue,P,ye=>{ye.forEach(Se=>{y.has(Se)||I.some(we=>q.isFromSettings&&!we.isFromSettings?!1:we.filenamePatterns.some(_=>(0,v.$mfb)(_,Se)))||y.add(Se)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(f,$,b);const A=new R.$Bc;let G=!1;const T=Array.from(y).map(async V=>{const P=[];try{if($.isCancellationRequested)return;if(b.maxResults&&[...A.values()].reduce((ue,ye)=>ue+ye.cellResults.length,0)>b.maxResults){G=!0;return}const L=[],q=this.g.get(V);if(q)q.apiNotebook.getCells().forEach(ye=>L.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Se=>Se.items.map(le=>le.data.toString()))}));else{const ue=await this.s.value.readFile(V),ye=F.$ue.fromString(ue.toString()),Se=await D.deserializeNotebook(ye.buffer,$);if($.isCancellationRequested)return;p.NotebookData.from(Se).cells.forEach(we=>L.push({input:we.source,outputs:we.outputs.flatMap(_=>_.items.map(ve=>ve.valueBytes.toString()))}))}if($.isCancellationRequested)return;L.forEach((ue,ye)=>{const Se=b.contentPattern.pattern,le=new h.$2Tb(ue.input,void 0,ue.outputs),we=le.findInInputs(Se),_=le.findInOutputs(Se),ve=_.flatMap(ne=>(0,t.$XK)(ne.matches,ne.textBuffer)).map((ne,fe)=>(ne.webviewIndex=fe,ne));if(we.length>0||_.length>0){const ne={index:ye,contentResults:(0,t.$XK)(we,le.inputTextBuffer),webviewResults:ve};P.push(ne)}});const re={resource:V,cellResults:P};A.set(V,re);return}catch{return}});return await Promise.all(T),{limitHit:G,results:[...A.values()]}}async y(a,b){const f=await this.s.value.stat(a);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==O.$gl&&typeof f.mtime=="number"&&typeof f.size=="number"&&b.mtime<f.mtime&&b.etag!==O.$hl({mtime:b.mtime,size:f.size}))throw new O.$9k((0,S.localize)(1,null),3,b)}z(a){return a.scheme===c.Schemas.file?a.fsPath:a.toString()}A(a,b,f){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const I=new n.$Yjc(b,this.d,a,f.visibleRanges.map(p.NotebookRange.to),f.selections.map(p.NotebookRange.to),typeof f.viewColumn=="number"?p.ViewColumn.to(f.viewColumn):void 0);this.h.set(b,I)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const f of a.value.removedDocuments){const I=k.URI.revive(f),$=this.g.get(I);$&&($.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:$.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire($.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===I.toString()&&this.h.delete(D.id)}if(a.value.addedDocuments){const f=[];for(const I of a.value.addedDocuments){const $=k.URI.revive(I.uri);if(this.g.has($))throw new Error(`adding EXISTING notebook ${$} `);const D=new s.$Xjc(this.c,this.q,this.r,$,I);f.push(...I.cells.map(y=>s.$Wjc.asModelAddData(y))),this.g.get($)?.dispose(),this.g.set($,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this.m.fire(D.apiNotebook)}}if(a.value.addedEditors)for(const f of a.value.addedEditors){if(this.h.has(f.id))return;const I=k.URI.revive(f.documentUri),$=this.g.get(I);$&&this.A($,f.id,f)}const b=[];if(a.value.removedEditors)for(const f of a.value.removedEditors){const I=this.h.get(f);I&&(this.h.delete(f),this.k?.id===I.id&&(this.k=void 0),b.push(I))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const f=new Set;this.l.forEach(I=>f.add(I.id));for(const I of this.h.values()){const $=f.has(I.id);I._acceptVisibility($)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const b=w.$YO.String.with("notebookType","A notebook type"),f=new w.$1O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new w.$YO("data","Bytes to convert to data",$=>$ instanceof Uint8Array,$=>F.$ue.wrap($))],new w.$ZO("Notebook Data",$=>p.NotebookData.to($.value))),I=new w.$1O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new w.$YO("NotebookData","Notebook data to convert to bytes",$=>!0,$=>new o.$cw(p.NotebookData.from($)))],new w.$ZO("Bytes",$=>$.buffer));a.registerApiCommand(f),a.registerApiCommand(I)}}e.$8jc=u}),define(Me[289],Re([1,0,19,25,41,34,24,64,44]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class k{constructor(l,w,p){this.k=l,this.l=w,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$bk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$bk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const w=this.k.folderQueries||[];return new Promise((p,r)=>{const o=s=>{this.f++,l(s)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),i=S.$oc(n);this.j&&this.j(n,i)||this.v(o,{base:s,basename:i})}),Promise.all(w.map(s=>this.p(s,o))).then(s=>{p({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,M.$5i)(s)))})})}async p(l,w){const p=new F.$ee,r=this.q(l),o=this.r(),s=new d.$NK(this.k,l),n=!s.hasSiblingExcludeClauses();let i;try{this.h.add(p),i=m.$3d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,p.token),h=i.elapsed(),t=m.$3d.create();return this.g&&!this.e||(c&&c.forEach(v=>{const u=S.$hc.relative(l.folder.path,v.path);if(n){const g=S.$oc(v.path);this.v(w,{base:l.folder,relativePath:u,basename:g});return}this.s(o,l.folder,u,w)}),this.g&&!this.e)?null:(this.u(o,s,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(l){const w=(0,d.$MK)(this.k.includePattern,l.includePattern),p=(0,d.$MK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},w,p,r){if(p===this.a){const s=S.$oc(this.a);this.v(r,{base:w,relativePath:this.a,basename:s})}function o(s){const n=S.$oc(s),i=S.$nc(s);let c=l[i];c||(c=l[i]=[],o(i)),c.push({base:w,relativePath:s,basename:n})}o(p)}u({rootEntries:l,pathToEntries:w},p,r){const o=this,s=this.a;function n(i){const c=(0,d.$PK)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const v=i[h],{relativePath:u,basename:g}=v;if(p.matchesExcludesSync(u,g,s!==g?c:void 0))continue;const a=w[u];if(a)n(a);else{if(u===s)continue;o.v(r,v)}if(o.e)break}}n(l)}v(l,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(w))}}class O{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,w,p,r){const o=this.c(l.cacheKey),s=new k(l,w,o&&o.token);let n=0;const i=c=>{n+=c.length,p(c.map(h=>this.d(h)))};return this.e(s,O.a,i,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new F.$ee),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Ug(l.base,l.relativePath)}:{resource:l.base}}e(l,w,p,r){const o=r.onCancellationRequested(()=>{l.cancel()}),s=i=>{i&&(n.push(i),w>0&&n.length>=w&&(p(n),n=[]))};let n=[];return l.search(s).then(i=>(n.length&&p(n),o.dispose(),i),i=>(n.length&&p(n),o.dispose(),Promise.reject(i)))}}e.$Zjc=O}),define(Me[290],Re([1,0,18,258,34,96,28,12,19,24,15,16,2,95,185,47,13,48,107,286,44]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=void 0,e.$XL=I;let h=class{constructor(D,y,C,A,G){this.a=D,this.b=y,this.c=C,this.d=A,this.e=G}text(D,y,C={}){D=this.f(D,C);const A=this.a.getValue(),G=y&&y.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.h(y?.map(s.$Ci),C),type:2,contentPattern:D,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:A.search.usePCRE2||G||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(D,y){const C=this.a.getValue();D.isRegExp&&(D.pattern=D.pattern.replace(/\r?\n/g,"\\n"));const A={...D,wordSeparators:C.editor.wordSeparators};return this.j(D,y)&&(A.isCaseSensitive=!0),this.k(D)&&(A.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(A.notebookInfo||(A.notebookInfo={}),A.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),A}file(D,y={}){return{...this.h(D,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(D,y){return D?(D=Array.isArray(D)?D.map(a):a(D),y?this.parseSearchPaths(D):{pattern:v(...Array.isArray(D)?D:[D])}):{}}h(D=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),A=this.g(y.excludePattern,y.expandPatterns),G=D.length>1,T=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(L=>this.q(L,y,A)):D.map(L=>this.r(L,y,A,G))).filter(L=>!!L),V={_reason:y._reason,folderQueries:T,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:A.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const L=S.$Hb(S.$Rb(this.c.groups.map(ue=>ue.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const q=L.filter(ue=>(0,c.$DK)(V,ue.fsPath)),re=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...V,...re}}const P=y.extraFileResources&&y.extraFileResources.filter(L=>(0,c.$DK)(V,L.fsPath));return V.extraFileResources=P&&P.length?P:void 0,V}i(D){const y=[],C=new R.$Bc,A={};let G=!1;return D.forEach(T=>{if(T.scheme===m.Schemas.walkThrough)return;if((0,k.$Yg)(T)){const P=this.b.getWorkspaceFolder(T)?.uri??T.with({path:d.$nc(T.fsPath)});let L=C.get(P);L||(G=!0,L={folder:P,includePattern:{}},y.push(L),C.set(P,L));const q=d.$mc(P.fsPath,T.fsPath);(0,E.$6f)(L.includePattern)[q.replace(/\\/g,"/")]=!0}else T.fsPath&&(G=!0,A[T.fsPath]=!0)}),{folderQueries:y,includePattern:A,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(D,y){if(y.isSmartCase){if(D.isRegExp){if(O.$Lf(D.pattern,!0))return!0}else if(O.$Lf(D.pattern))return!0}return!!D.isCaseSensitive}k(D){return D.isMultiline||D.isRegExp&&(0,w.$mC)(D.pattern)||D.pattern.indexOf(`
`)>=0?!0:!!D.isMultiline}parseSearchPaths(D){const y=re=>d.$jc(re)||/^\.\.?([\/\\]|$)/.test(re),A=(Array.isArray(D)?D:u(D)).map(re=>{const ue=this.e.resolvedUserHome;return ue?(0,N.$hw)(re,ue.scheme===m.Schemas.file?ue.fsPath:ue.path):re}),G=F.$K(A,re=>y(re)?"searchPaths":"exprSegments"),T=(G.exprSegments||[]).map(re=>O.$6e(re,"/")).map(re=>O.$6e(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),g(re))),V={},P=this.m(G.searchPaths||[]);P&&P.length&&(V.searchPaths=P);const L=S.$Rb(T),q=v(...L);return q&&(V.pattern=q),V}l(D,y){return y.disregardExcludeSettings?void 0:(0,c.$CK)(D,!y.disregardSearchExcludeSettings)}m(D){if(!D||!D.length)return[];const y=D.flatMap(A=>{let{pathPortion:G,globPortion:T}=t(A);return T&&(T=b(T)),this.n(G).flatMap(P=>this.o(P,T))}),C=new Map;return y.forEach(A=>{const G=A.searchPath.toString(),T=C.get(G);T?A.pattern&&(T.pattern=T.pattern||{},T.pattern[A.pattern]=!0):C.set(G,{searchPath:A.searchPath,pattern:A.pattern?v(A.pattern):void 0})}),Array.from(C.values())}n(D){if(d.$jc(D)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:D})}]:[{searchPath:l.URI.file(d.$ic(D))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(D=a(D),D.startsWith("../")||D===".."){const A=d.$hc.resolve(y.path,D);return[{searchPath:y.with({path:A})}]}const C=b(D);return[{searchPath:y,pattern:C}]}else{if(D==="./"||D===".\\")return[];{const y=D.replace(/^\.[\/\\]/,""),A=this.b.getWorkspace().folders.map(G=>{const T=y.match(new RegExp(`^${O.$Ze(G.name)}(?:/(.*)|$)`));return T?{match:T,folder:G}:null}).filter(E.$3f);if(A.length)return A.map(G=>{const T=G.match[1];return{searchPath:G.folder.uri,pattern:T&&b(T)}});{const G=D.match(/\.[\/\\](.+)[\/\\]?/),T=G?G[1]:D,V=p.localize(0,null,T);throw new Error(V)}}}}o(D,y){const C=D.pattern&&y?`${D.pattern}/${y}`:D.pattern||y,A=[{searchPath:D.searchPath,pattern:C}];return C&&!C.endsWith("**")&&A.push({searchPath:D.searchPath,pattern:C+"/**"}),A}q(D,y,C){const A=this.r((0,s.$Ci)(D.searchPath),y,C,!1);return A?{...A,includePattern:D.pattern}:null}r(D,y,C,A){let G;const T=l.URI.isUri(D)?D:D.uri;if(C.searchPaths){const re=C.searchPaths.filter(ue=>(0,k.$Ng)(ue.searchPath,T))[0];if(re&&!re.pattern)return null;re&&(G=re.pattern)}const V=this.a.getValue({resource:T}),L={...this.l(V,y)||{},...G||{}},q=l.URI.isUri(D)?(0,k.$Rg)(D):D.name;return{folder:T,folderName:A?q:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!V.search.followSymlinks}}};e.$WL=h,e.$WL=h=Je([qe(0,r.$Ni),qe(1,s.$qi),qe(2,n.$tD),qe(3,o.$Nj),qe(4,i.$UL)],h);function t($){const D=$.match(/[\*\{\}\(\)\[\]\?]/);if(D){const y=D.index,C=$.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let A=$.substr(0,C.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function v(...$){return $.length?$.reduce((D,y)=>(D[y]=!0,D),Object.create(null)):void 0}function u($){return M.$_j($,",").map(D=>D.trim()).filter(D=>!!D.length)}function g($){return[`**/${$}/**`,`**/${$}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function a($){return $.replace(/\\/g,"/")}function b($){return a($).replace(/^\.\//,"").replace(/\/+$/g,"")}function f($){return $.replace(/([?*[\]])/g,"[$1]")}function I($,D){$=S.$Mb($,A=>A.toString());const y=[],C=D.getWorkspace();return $&&$.forEach(A=>{let G;if(D.getWorkbenchState()===2)G=(0,k.$Wg)(C.folders[0].uri,A),G&&G!=="."&&(G="./"+G);else{const T=D.getWorkspaceFolder(A);if(T){const V=T.name;if(C.folders.filter(L=>L.name===V).length===1){const L=(0,k.$Wg)(T.uri,A);L===""?G=`./${T.name}`:G=`./${T.name}/${L}`}else G=A.fsPath}}G&&y.push(f(G))}),y}}),define(Me[291],Re([1,0,24,2,25,14,3,290,44,48,11]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rub=l,e.$Sub=r;const E=7e3;function l(o,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],c=[];for(const a of n)if(/^workspaceContains:/.test(a)){const b=a.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||o.forceUsingSearch?c.push(b):i.push(b)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,O.$ah)(),v=a=>t({activationEvent:a}),u=Promise.all(i.map(a=>w(o,a,v))).then(()=>{}),g=p(o,s.identifier,c,v);return Promise.all([u,g]).then(()=>{t(void 0)}),h}async function w(o,s,n){for(const i of o.folders)if(await o.exists(S.$Ug(F.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function p(o,s,n,i){if(n.length===0)return Promise.resolve(void 0);const c=new M.$ee,h=o.checkExists(o.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},E);let v=!1;try{v=await h}catch(u){N.$4(u)||N.$1(u)}c.dispose(),clearTimeout(t),v&&i(`workspaceContains:${n.join(",")}`)}function r(o,s,n,i){const c=o.get(R.$gi),h=o.get(d.$uK),v=c.createInstance(m.$WL).file(s.map(u=>(0,k.$Ci)(F.URI.revive(u))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(v,i).then(u=>!!u.limitHit,u=>N.$4(u)?!1:Promise.reject(u))}}),define(Me[38],Re([1,0,164,19,89,24,11,6,51,2,13,4,37,223,82,36,22,108,14,20,23,206,7,102,3,27,85,17,71,86,66,88,5,291,81,208,12,79,64,21,80]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v,u,g,a,b,f,I,$,D,y,C,A,G,T,V,P,L,q){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=e.$Djc=e.$Cjc=e.$Bjc=void 0,e.$Bjc=(0,u.$hi)("IHostUtils");let ue=re=class extends m.$Uc{constructor(W,te,Ee,Te,Ie,pe,ge,J,X,ce,de,Oe,he){super(),this.X=Oe,this.Y=he,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=te,this.g=Ee,this.f=ge,this.j=Te,this.m=Ie,this.s=pe,this.t=X,this.u=ce,this.w=de,this.y=this.g.getProxy(E.$gM.MainThreadWorkspace),this.z=this.g.getProxy(E.$gM.MainThreadTelemetry),this.C=this.g.getProxy(E.$gM.MainThreadExtensionService),this.D=new R.$gh,this.F=new R.$gh,this.G=new R.$gh,this.H=new R.$gh,this.I=new ne(this.f.extensions.activationEvents),this.L=new s.$x0b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Dm(this.f.extensions.myExtensions);this.J=new s.$x0b(this.I,_(this.L,Ce)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${le(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${le(this.J)}`)),this.M=new p.$mjc(this.g,this.s),this.N=new A.$ujc(this.g),this.O=J,this.h=W.createChild(new f.$fi([p.$njc,this.M],[A.$vjc,this.N])),this.P=this.B(new w.$ljc(this.J,this.L,{onExtensionActivationError:(Ae,Le,U)=>{this.C.$onExtensionActivationError(Ae,n.$3(Le),U)},actualActivateExtension:async(Ae,Le)=>{if(s.$x0b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Le),new w.$kjc;const U=this.J.getExtensionDescription(Ae);return this.eb(U,Le)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(W){n.$1(W)}}async Z(){this.O.onWillDeactivateAll();let W=[];try{W=this.J.getAllExtensionDescriptions().map(Ie=>Ie.identifier).filter(Ie=>this.isActivated(Ie)).map(Ie=>this.db(Ie))}catch{}await Promise.all(W)}terminate(W,te=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${W}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const Ee=this.Z();Promise.race([(0,R.$ih)(5e3),Ee]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${te}`):this.s.info(`Extension host exiting with code ${te}`),this.s.flush(),this.s.dispose(),this.c.exit(te)})}isActivated(W){return this.G.isOpen()?this.P.isActivated(W):!1}async getExtension(W){const te=await this.C.$getExtension(W);return te&&{...te,identifier:new i.$Cm(te.identifier.value),extensionLocation:k.URI.revive(te.extensionLocation)}}$(W,te){return this.P.activateByEvent(W,te)}ab(W,te){return this.P.activateById(W,te)}activateByIdWithErrors(W,te){return this.ab(W,te).then(()=>{const Ee=this.P.getActivatedExtension(W);if(Ee.activationFailed)return Promise.reject(Ee.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(W=>this.J)}getExtensionExports(W){if(this.G.isOpen())return this.P.getActivatedExtension(W).exports;try{return this.P.getActivatedExtension(W).exports}catch{return null}}async bb(W){if(W.scheme===T.Schemas.file&&this.c.fsRealpath){const te=await this.c.fsRealpath(W.fsPath);return k.URI.file(te)}return W}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(W=>new ve(W))),this.Q}async cb(W){const te=d.$ni.forUris(Ee=>N.$Lg.ignorePathCasing(Ee));return await Promise.all(W.map(async Ee=>{if(this.vb(Ee)){const Te=await this.bb(Ee.extensionLocation);te.set(Te,Ee)}})),te}db(W){let te=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(W))return te;const Ee=this.P.getActivatedExtension(W);if(!Ee)return te;try{typeof Ee.module.deactivate=="function"&&(te=Promise.resolve(Ee.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${W.value}':`),this.s.error(Te)}try{(0,m.$Pc)(Ee.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this.s.error(Te)}return te}async eb(W,te){return this.f.remote.isRemote?this.C.$onWillActivateExtension(W.identifier):await this.C.$onWillActivateExtension(W.identifier),this.gb(W,te).then(Ee=>{const Te=Ee.activationTimes;return this.C.$onDidActivateExtension(W.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,te),this.fb(W,te,"success",Te),Ee},Ee=>{throw this.fb(W,te,"failure"),Ee})}fb(W,te,Ee,Te){const Ie=Se(W,te);this.z.$publicLog2("extensionActivationTimes",{...Ie,...Te||{},outcome:Ee})}gb(W,te){const Ee=Se(W,te);this.z.$publicLog2("activatePlugin",Ee);const Te=this.vb(W);if(!Te)return Promise.resolve(new w.$jjc(w.$gjc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${te.startup}, activationEvent: '${te.activationEvent}'${W.identifier.value!==te.extensionId.value?`, root cause: ${te.extensionId.value}`:""}`),this.s.flush();const Ie=new w.$hjc(te.startup);return Promise.all([this.wb(W,(0,N.$Ug)(W.extensionLocation,Te),Ie),this.hb(W)]).then(pe=>(M.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),re.ib(this.s,W.identifier,pe[0],pe[1],Ie))).then(pe=>(M.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),pe))}hb(W){const te=this.Y.createLanguageModelAccessInformation(W),Ee=new h.$pjc(W,this.M),Te=new h.$ojc(W.identifier.value,!1,this.M),Ie=new G.$wjc(W,this.N),pe=W.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([Ee.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const J=this;let X,ce;const de=(0,o.$5F)(W,"ipc")?this.f.messagePorts?.get(i.$Cm.toKey(W.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:Te,secrets:Ie,subscriptions:[],get languageModelAccessInformation(){return te},get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(Oe){return F.$kc(W.extensionLocation.fsPath,Oe)},get storagePath(){return J.O.workspaceValue(W)?.fsPath},get globalStoragePath(){return J.O.globalValue(W).fsPath},get logPath(){return F.$kc(J.f.logsLocation.fsPath,W.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,W.identifier.value)},get storageUri(){return J.O.workspaceValue(W)},get globalStorageUri(){return J.O.globalValue(W)},get extensionMode(){return pe},get extension(){return X===void 0&&(X=new we(J,W.identifier,W,ge,!1)),X},get extensionRuntime(){return(0,o.$6F)(W,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(W)},get messagePassingProtocol(){if(!ce){if(!de)return;const Oe=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",he=>he.data));de.start(),ce={onDidReceiveMessage:Oe,postMessage:de.postMessage.bind(de)}}return ce}})})}static ib(W,te,Ee,Te,Ie){return Ee=Ee||{activate:void 0,deactivate:void 0},this.jb(W,te,Ee,Te,Ie).then(pe=>new w.$ijc(!1,null,Ie.build(),Ee,pe,Te.subscriptions))}static jb(W,te,Ee,Te,Ie){if(typeof Ee.activate=="function")try{Ie.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${te.value}`);const pe=typeof global=="object"?global:self,ge=Ee.activate.apply(pe,[Te]);return Ie.activateCallStop(),Ie.activateResolveStart(),Promise.resolve(ge).then(J=>(Ie.activateResolveStop(),J))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(Ee)}kb(W,te){this.ab(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:te}).then(void 0,Ee=>{this.s.error(Ee)})}lb(W,te=0){const Te=Date.now();(0,L.$B)(()=>{for(let Ie=te;Ie<W.length;Ie+=1){const pe=W[Ie];for(const ge of pe.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Te>50){this.lb(W,Ie);break}else this.kb(pe,ge)}})}mb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(W=>{const te=W.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Ee=this.J.getAllExtensionDescriptions();if(te)this.lb(Ee);else for(const Te of Ee)if(Te.activationEvents)for(const Ie of Te.activationEvents)Ie==="onStartupFinished"&&this.kb(Te,Ie)})}nb(){const W=this.$("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.ob(pe.added)));const te=this.j.workspace?this.j.workspace.folders:[],Ee=this.ob(te),Te=this.qb(),Ie=Promise.all([Te,W,Ee]).then(()=>{});return Promise.race([Ie,(0,R.$ih)(1e4)]).then(()=>{this.mb()}),Ie}ob(W){return W.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(te=>this.pb(W,te))).then(()=>{})}async pb(W,te){if(this.isActivated(te.identifier))return;const Ee=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:W.map(pe=>pe.uri),forceUsingSearch:Ee||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,ge,J)=>this.y.$checkExists(pe,ge,J)},Ie=await(0,C.$Rub)(Te,te);if(Ie)return this.ab(te.identifier,{startup:!0,extensionId:te.identifier,activationEvent:Ie.activationEvent}).then(void 0,pe=>this.s.error(pe))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(W){throw console.error(W),W}}async rb(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:te}=this.f.environment;if(!W||!te)throw new Error(S.localize(0,null));const Ee=await this.wb(null,te,new w.$hjc(!1));if(!Ee||typeof Ee.run!="function")throw new Error(S.localize(1,null,te.toString()));return new Promise((Te,Ie)=>{const pe=(X,ce)=>{X?(L.$t&&this.s.error("Test runner called back with error",X),Ie(X)):(L.$t&&(ce?this.s.info(`Test runner called back with ${ce} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof ce=="number"&&ce>0?1:0))},ge=(0,N.$Ig)(te),J=Ee.run(ge,pe);J&&J.then&&J.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(X=>{L.$t&&this.s.error("Test runner finished with error",X),Ie(X instanceof Error&&X.stack?X.stack:String(X))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$ih)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,te){return this.R[W]=te,(0,m.$Sc)(()=>{delete this.R[W]})}async getRemoteExecServer(W){const{resolver:te}=await this.tb(W);return te?.resolveExecServer?.(W,{resolveAttempt:0})}async tb(W){const te=W.indexOf("+");if(te===-1)throw new t.$oM("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Ee=W.substr(0,te);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${Ee}`,!1),{authorityPrefix:Ee,resolver:this.R[Ee]}}async $resolveAuthority(W,te){const Ee=P.$3d.create(!1),Te=()=>`[resolveAuthority(${(0,v.$wl)(W)},${te})][${Ee.elapsed()}ms] `,Ie=z=>this.s.info(`${Te()}${z}`),pe=z=>this.s.warn(`${Te()}${z}`),ge=(z,K=void 0)=>this.s.error(`${Te()}${z}`,K),J=z=>{if(z instanceof t.$oM)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},X=async z=>{Ie(`activating resolver for ${z}...`);const{resolver:K,authorityPrefix:H}=await this.tb(z);if(!K)throw ge(`no resolver for ${H}`),new t.$oM(`No remote extension installed to resolve ${H}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:z}},ce=W.split(/@|%40/g).reverse();Ie(`activating remote resolvers ${ce.join(" -> ")}`);let de;try{de=await Promise.all(ce.map(X)).catch(async z=>{if(!(z instanceof t.$oM)||z._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return pe(`resolving nested authorities failed: ${z.message}`),[await X(W)]})}catch(z){return J(z)}const Oe=new R.$sh;Oe.cancelAndSet(()=>Ie("waiting..."),1e3);let he,Ce;for(const[z,{authorityPrefix:K,resolver:H,remoteAuthority:ee}]of de.entries())try{if(z===de.length-1)Ie("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${K}`),he=await H.resolve(ee,{resolveAttempt:te,execServer:Ce}),M.mark(`code/extHost/didResolveAuthorityOK/${K}`),Ie("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$nM.isManagedResolvedAuthority(he)?he:void 0));else{if(Ie(`invoking resolveExecServer() for ${ee}`),M.mark(`code/extHost/willResolveExecServer/${K}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:te,execServer:Ce}),!Ce)throw new t.$oM(`Exec server was not available for ${ee}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(se){return M.mark(`code/extHost/didResolveAuthorityError/${K}`),ge("returned an error",se),Oe.dispose(),J(se)}Oe.dispose();const Ae={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},Le={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};Ie(`returned ${t.$nM.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let U;if(t.$nM.isManagedResolvedAuthority(he)){const z=te;this.X.setFactory(z,he.makeConnection),U={authority:W,connectTo:new v.$tl(z),connectionToken:he.connectionToken}}else U={authority:W,connectTo:new v.$ul(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:U,options:Le,tunnelInformation:Ae}}}async $getCanonicalURI(W,te){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$wl)(W)})`);const{resolver:Ee}=await this.tb(W);if(!Ee)return null;const Te=k.URI.revive(te);if(typeof Ee.getCanonicalURI>"u")return Te;const Ie=await(0,R.$_g)(()=>Ee.getCanonicalURI(Te));return Ie||Te}$startExtensionHost(W){W.toAdd.forEach(Te=>Te.extensionLocation=k.URI.revive(Te.extensionLocation));const{globalRegistry:te,myExtensions:Ee}=ye(this.I,this.L,this.J,W);return this.L.set(te.getAllExtensionDescriptions()),this.J.set(Ee),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${le(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${le(this.J)}`)),this.sb()}$activateByEvent(W,te){return te===1?this.D.wait().then(Ee=>this.$(W,!1)):this.G.wait().then(Ee=>this.$(W,!1))}async $activate(W,te){return await this.G.wait(),this.J.getExtensionDescription(W)?(await this.ab(W,te),!0):!1}async $deltaExtensions(W){W.toAdd.forEach(pe=>pe.extensionLocation=k.URI.revive(pe.extensionLocation));const{globalRegistry:te,myExtensions:Ee}=ye(this.I,this.L,this.J,W),Te=await this.cb(Ee);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(te.getAllExtensionDescriptions()),this.J.set(Ee),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${le(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${le(this.J)}`)),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){const te=c.$ue.alloc(W),Ee=Math.random()%256;for(let Te=0;Te<W;Te++)te.writeUInt8(Ee,Te);return te}async $updateRemoteConnectionData(W){this.W=W,this.a.fire()}};e.$Cjc=ue,e.$Cjc=ue=re=Je([qe(0,u.$gi),qe(1,e.$Bjc),qe(2,b.$AO),qe(3,r.$2ic),qe(4,l.$5ic),qe(5,O.$Nj),qe(6,g.$QO),qe(7,a.$8ic),qe(8,I.$9Ab),qe(9,$.$qjc),qe(10,V.$yjc),qe(11,q.$zjc),qe(12,D.$Ric)],ue);function ye(fe,W,te,Ee){fe.addActivationEvents(Ee.addActivationEvents);const Te=new s.$x0b(fe,W.getAllExtensionDescriptions());Te.deltaExtensions(Ee.toAdd,Ee.toRemove);const Ie=new i.$Dm(te.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of Ee.myToRemove)Ie.delete(ge);for(const ge of Ee.myToAdd)Ie.add(ge);const pe=_(Te,Ie);return{globalRegistry:Te,myExtensions:pe}}function Se(fe,W){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}function le(fe){return fe.getAllExtensionDescriptions().map(W=>W.identifier.value).join(",")}e.$Djc=(0,u.$hi)("IExtHostExtensionService");class we{#e;#t;#i;constructor(W,te,Ee,Te,Ie){this.#e=W,this.#t=te,this.#i=Ee.identifier,this.id=Ee.identifier.value,this.extensionUri=Ee.extensionLocation,this.extensionPath=F.$ic((0,N.$Ig)(Ee.extensionLocation)),this.packageJSON=Ee,this.extensionKind=Te,this.isFromDifferentExtensionHost=Ie}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ejc=we;function _(fe,W){return fe.getAllExtensionDescriptions().filter(te=>W.has(te.identifier))}class ve{constructor(W){this.a=W}setSearchTree(W){this.a=W}findSubstr(W){return this.a.findSubstr(W)}forEach(W){return this.a.forEach(W)}}e.$Fjc=ve;class ne{constructor(W){this.a=new i.$Em,this.addActivationEvents(W)}readActivationEvents(W){return this.a.get(W.identifier)??[]}addActivationEvents(W){for(const te of Object.keys(W))this.a.set(te,W[te])}}}),define(Me[292],Re([1,0,89,2,4,37,22,20,17,27,3,38,13,15]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;let r=class{constructor(c,h,t,v,u,g,a){this.c=c,this.d=h,this.e=t,this.f=v,this.g=u,this.h=g,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Nkc=r,e.$Nkc=r=Je([qe(2,O.$gi),qe(3,N.$5ic),qe(4,E.$Djc),qe(5,k.$QO),qe(6,l.$Nj)],r);let o=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&p.a.size){const h=(0,w.$Ze)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",v=`@${t}+\\/${t}+|${t}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,t,v,u]=h,g=p.a.get(v);if(g!==void 0)return console.warn(`${v} as been renamed to ${g}, please update your imports`),t+g+u}c(c){return c.replace(/\\/g,"/")}};o=p=Je([qe(0,k.$QO)],o);class s{constructor(c,h,t,v,u){this.c=c,this.d=h,this.e=t,this.f=v,this.g=u,this.nodeModuleName="vscode",this.a=new m.$Em}load(c,h){const t=this.d.findSubstr(h);if(t){let v=this.a.get(t.identifier);return v||(v=this.c(t,this.e,this.f),this.a.set(t.identifier,v)),v}if(!this.b){let v="";this.d.forEach((u,g)=>v+=`	${g} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${v}`),this.b=this.c(R.$ZF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,t){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$gM.MainThreadTelemetry);const v=t.getProxy(M.$gM.MainThreadWindow);this.c=(u,g)=>{const a=F.URI.parse(u);return g?this.g(u,g):a.scheme==="http"||a.scheme==="https"?v.$openUri(a,u,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?v.$openUri(a,u,{}):this.g(u,g)}}load(c,h,t){const v=this.e.findSubstr(h);return v&&(this.a=v.identifier.value,this.h()),this.b=t(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,d.$AO)],n)}),define(Me[119],Re([1,0,39,6,19,73,3,67,65,38,7,36,220,37]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=e.$Gjc=void 0,e.$Gjc=(0,R.$hi)("IExtHostVariableResolverProvider");class p extends l.$CP{constructor(s,n,i,c,h,t,v){function u(){if(i){const g=i.activeEditor();if(g)return g.document.uri;const a=c.tabGroups.all.find(b=>b.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof O.$5N||a.input instanceof O.$0N)return a.input.modified;if(a.input instanceof O.$4N||a.input instanceof O.$9N||a.input instanceof O.$7N)return a.input.uri}}}super({getFolderUri:g=>{const a=t.folders.filter(b=>b.name===g);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(g,a)=>h.getConfiguration(void 0,g).get(a),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=u();if(g)return M.$ic(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const g=u();if(g){const a=n.getWorkspaceFolder(g);if(a)return M.$ic(a.uri.fsPath)}}},getSelectedText:()=>{if(i){const g=i.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(i){const g=i.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>s.getExtension(g)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(N.env))}}let r=class extends F.$Uc{constructor(s,n,i,c,h){super(),this.b=s,this.c=n,this.g=i,this.h=c,this.j=h,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Hjc=r,e.$Hjc=r=Je([qe(0,k.$Djc),qe(1,E.$2ic),qe(2,m.$LO),qe(3,w.$5ic),qe(4,d.$ejc)],r)}),define(Me[120],Re([1,0,11,5,2,20,3,4,65,38,17,7,36,212,214,37,119,6,40,31,8]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=e.$Ljc=e.$Kjc=e.$Jjc=e.$Ijc=void 0,e.$Ijc=(0,R.$hi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(f,I,$,D,y,C,A){this.N=I,this.O=$,this.P=D,this.Q=y,this.R=C,this.S=A,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$7d,this.o=new F.$7d,this.q=new F.$7d,this.w=new F.$7d,this.l=f.getProxy(m.$gM.MainThreadDebugService),this.A=new F.$7d,this.C=new F.$7d,this.y=new v(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(T=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem(f,I){const $=this.W(I);if(!$)return;const D=await this.H.get(f)?.getTreeItem?.($);return D?this.U(f,D):void 0}registerDebugVisualizationTree(f,I,$){const D=N.$Cm.toKey(f.identifier),y=this.jb(D,I);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(y,$),this.l.$registerDebugVisualizerTree(y,!!$.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(I)})}async $getVisualizerTreeItemChildren(f,I){const $=this.J.get(I)?.item;return $?(await this.H.get(f)?.getChildren?.($))?.map(y=>this.U(f,y))||[]:[]}async $editVisualizerTreeItem(f,I){const $=this.J.get(f);if(!$)return;const D=await this.H.get($.provider)?.editItem?.($.item,I);return this.U($.provider,D||$.item)}$disposeVisualizedTree(f){const I=this.J.get(f);if(!I)return;const $=[I.children];for(const D of $)if(D)for(const y of D)$.push(this.J.get(y)?.children),this.J.delete(y)}U(f,I){let $=this.I.get(I);return $||($=this.F++,this.I.set(I,$),this.J.set($,{provider:f,item:I})),c.DebugTreeItem.from(I,$)}asDebugSourceUri(f,I){const $=f;if(typeof $.sourceReference=="number"&&$.sourceReference>0){let D=`debug:${encodeURIComponent($.path||"")}`,y="?";return I&&(D+=`${y}session=${encodeURIComponent(I.id)}`,y="&"),D+=`${y}ref=${$.sourceReference}`,M.URI.parse(D)}else{if($.path)return M.URI.file($.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(f){const I=[];for(const $ of f.getAllExtensionDescriptions())if($.contributes){const D=$.contributes.debuggers;if(D&&D.length>0)for(const y of D)(0,p.$EG)(y)&&I.push(y.type)}this.l.$registerDebugTypes(I)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const f=[];return this.z.forEach(I=>f.push(I)),f}async $resolveDebugVisualizer(f,I){const $=this.L.get(f);if(!$)throw new Error(`No debug visualizer found with id '${f}'`);let{v:D,provider:y,extensionId:C}=$;if(D.visualization||(D=await y.resolveDebugVisualization?.(D,I)||D,$.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,D.visualization)}async $executeDebugVisualizerCommand(f){const I=this.L.get(f);if(!I)throw new Error(`No debug visualizer found with id '${f}'`);const $=I.v.visualization;$&&"command"in $&&this.S.executeCommand($.command,...$.arguments||[])}W(f){const I=this.m.get(f.sessionId);return I&&{session:I.api,variable:f.variable,containerId:f.containerId,frameId:f.frameId,threadId:f.threadId}}async $provideDebugVisualizers(f,I,$,D){const y=this.W($),C=this.jb(f,I),A=this.G.get(C);if(!y||!A)return[];const G=await A.provideDebugVisualization(y,D);return G?G.map(T=>{const V=++this.M;this.L.set(V,{v:T,provider:A,extensionId:f});const P=T.iconPath?this.lb(T.iconPath):void 0;return{id:V,name:T.name,iconClass:P?.iconClass,iconPath:P?.iconPath,visualization:this.kb(f,T.visualization)}}):[]}$disposeDebugVisualizers(f){for(const I of f)this.L.delete(I)}registerDebugVisualizationProvider(f,I,$){if(!f.contributes?.debugVisualizers?.some(C=>C.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const D=N.$Cm.toKey(f.identifier),y=this.jb(D,I);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(y,$),this.l.$registerDebugVisualizer(D,I),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,I),this.G.delete(I)})}addBreakpoints(f){const I=f.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(I,[],[]);const $=[],D=new Map;for(const y of I)if(y instanceof E.$jN){let C=D.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},D.set(y.location.uri.toString(),C),$.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof E.$kN&&$.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints($)}removeBreakpoints(f){const I=f.filter(C=>this.z.delete(C.id));this.gb([],I,[]);const $=I.filter(C=>C instanceof E.$jN).map(C=>C.id),D=I.filter(C=>C instanceof E.$kN).map(C=>C.id),y=I.filter(C=>C instanceof E.$lN).map(C=>C.id);return this.l.$unregisterBreakpoints($,D,y)}startDebugging(f,I,$){return this.l.$startDebugging(f?f.uri:void 0,I,{parentSessionID:$.parentSession?$.parentSession.id:void 0,lifecycleManagedByParent:$.lifecycleManagedByParent,repl:$.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:$.noDebug,compact:$.compact,suppressSaveBeforeStart:$.suppressSaveBeforeStart,suppressDebugStatusbar:$.suppressDebugStatusbar??$.debugUI?.simple,suppressDebugToolbar:$.suppressDebugToolbar??$.debugUI?.simple,suppressDebugView:$.suppressDebugView??$.debugUI?.simple})}stopDebugging(f){return this.l.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,I,$){if(!I)return new E.$iM(()=>{});const D=this.d++;return this.f.push({type:f,handle:D,provider:I}),this.l.$registerDebugConfigurationProvider(f,$,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,D),new E.$iM(()=>{this.f=this.f.filter(y=>y.provider!==I),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(f,I,$){if(!$)return new E.$iM(()=>{});if(!this.cb(f,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:I,handle:D,factory:$}),this.l.$registerDebugAdapterDescriptorFactory(I,D),new E.$iM(()=>{this.h=this.h.filter(y=>y.factory!==$),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(f,I){if(!I)return new E.$iM(()=>{});const $=this.j++;return this.k.push({type:f,handle:$,factory:I}),new E.$iM(()=>{this.k=this.k.filter(D=>D.factory!==I)})}async $runInTerminal(f,I){return Promise.resolve(void 0)}async $substituteVariables(f,I){let $;const D=await this.ib(f);return D&&($={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync($,I)}X(f,I){if(f.type==="implementation")return new g(f.implementation)}Y(){}async $startDASession(f,I){const $=this,D=await this.hb(I);return this.eb(this.$(D.type),D).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const C=this.Z(y),A=this.X(C,D);if(!A)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const G=A;return this.D.set(f,G),this.db(D).then(T=>(T&&this.E.set(f,T),G.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const P=V,L={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const q=await this.K.sign(P.arguments.value);L.body={signature:q},G.sendResponse(L)}else throw new Error("no signer")}catch(q){L.success=!1,L.message=q.message,G.sendResponse(L)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(V),V=(0,p.$JG)(V,!0),$.l.$acceptDAMessage(f,V)}),G.onError(V=>{T&&T.onError&&T.onError(V),this.l.$acceptDAError(f,V.name,V.message,V.stack)}),G.onExit(V=>{T&&T.onExit&&T.onExit(V??void 0,void 0),this.l.$acceptDAExit(f,V??void 0,void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),G.startSession()))})}$sendDAMessage(f,I){I=(0,p.$IG)(I,!1);const $=this.E.get(f);$&&$.onWillReceiveMessage&&$.onWillReceiveMessage(I),this.D.get(f)?.sendMessage(I)}$stopDASession(f){const I=this.E.get(f);this.E.delete(f),I&&I.onWillStopSession&&I.onWillStopSession();const $=this.D.get(f);return this.D.delete(f),$?$.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const I=[],$=[],D=[];if(f.added)for(const y of f.added){const C=y.id;if(C&&!this.z.has(C)){let A;if(y.type==="function")A=new E.$kN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")A=new E.$lN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const G=M.URI.revive(y.uri);A=new E.$jN(new E.$uM(G,new E.$jM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,E.$hN)(A,C),this.z.set(C,A),I.push(A)}}if(f.removed)for(const y of f.removed){const C=this.z.get(y);C&&(this.z.delete(y),$.push(C))}if(f.changed){for(const y of f.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof E.$kN&&y.type==="function"){const A=C;A.enabled=y.enabled,A.condition=y.condition,A.hitCondition=y.hitCondition,A.logMessage=y.logMessage,A.functionName=y.functionName}else if(C instanceof E.$jN&&y.type==="source"){const A=C;A.enabled=y.enabled,A.condition=y.condition,A.hitCondition=y.hitCondition,A.logMessage=y.logMessage,A.location=new E.$uM(M.URI.revive(y.uri),new E.$jM(y.line,y.character))}D.push(C)}}}this.gb(I,$,D)}async $acceptStackFrameFocus(f){let I;if(f){const $=await this.hb(f.sessionId);f.kind==="thread"?I=new E.$rN($.api,f.threadId):I=new E.$qN($.api,f.threadId,f.frameId)}this.B=I,this.C.fire(this.B)}$provideDebugConfigurations(f,I,$){return(0,S.$_g)(async()=>{const D=this.bb(f);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(I);return D.provideDebugConfigurations(y,$)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(f,I,$,D){return(0,S.$_g)(async()=>{const y=this.bb(f);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(I);return y.resolveDebugConfiguration(C,$,D)})}$resolveDebugConfigurationWithSubstitutedVariables(f,I,$,D){return(0,S.$_g)(async()=>{const y=this.bb(f);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(I);return y.resolveDebugConfigurationWithSubstitutedVariables(C,$,D)})}async $provideDebugAdapter(f,I){const $=this.ab(f);if(!$)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(I);return this.eb($,D).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(f){const I=await this.hb(f);this.n.fire(I.api)}async $acceptDebugSessionTerminated(f){const I=await this.hb(f);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged(f){this.u=f?await this.hb(f):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(f,I){(await this.hb(f))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(f,I){const D={session:(await this.hb(f)).api,event:I.event,body:I.body};this.w.fire(D)}Z(f){if(f instanceof E.$mN)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof E.$nN)return{type:"server",port:f.port,host:f.host};if(f instanceof E.$oN)return{type:"pipeServer",path:f.path};if(f instanceof E.$pN)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}$(f){const I=this.h.filter($=>$.type===f);if(I.length>0)return I[0].factory}ab(f){const I=this.h.filter($=>$.handle===f);if(I.length>0)return I[0].factory}bb(f){const I=this.f.filter($=>$.handle===f);if(I.length>0)return I[0].provider}cb(f,I){if(f.contributes){const $=f.contributes.debuggers;if($&&$.length>0){for(const D of $)if(D.label&&D.type&&D.type===I)return!0}}return!1}db(f){const $=f.configuration.type,D=this.k.filter(y=>y.type===$||y.type==="*").map(y=>(0,S.$_g)(()=>y.factory.createDebugAdapterTracker(f.api)).then(C=>C,C=>null));return Promise.race([Promise.all(D).then(y=>{const C=y.filter(A=>!!A);if(C.length>0)return new u(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(f,I){const $=I.configuration.debugServer;if(typeof $=="number")return Promise.resolve(new E.$nN($));if(f){const y=await this.O.getExtensionRegistry();return(0,S.$_g)(()=>f.createDebugAdapterDescriptor(I.api,this.fb(I,y))).then(C=>{if(C)return C})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,D))}fb(f,I){}gb(f,I,$){(f.length>0||I.length>0||$.length>0)&&this.A.fire(Object.freeze({added:f,removed:I,changed:$}))}async hb(f){if(f)if(typeof f=="string"){const I=this.m.get(f);if(I)return I}else{let I=this.m.get(f.id);if(!I){const $=await this.ib(f.folderUri),D=f.parent?this.m.get(f.parent):void 0;I=new t(this.l,f.id,f.type,f.name,$,f.configuration,D?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib(f){if(f){const I=M.URI.revive(f);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb(f,I){return`${f}\0${I}`}kb(f,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${f}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(f){const I=this.mb(f);let $,D;return"id"in I?D=n.ThemeIcon.asClassName(I):$=I,{iconPath:$,iconClass:D}}mb(f){if(f instanceof E.$eN)return{id:f.id};const I=typeof f=="object"&&"dark"in f?f.dark:f,$=typeof f=="object"&&"light"in f?f.light:f;return{dark:typeof I=="string"?M.URI.file(I):I,light:typeof $=="string"?M.URI.file($):$}}};e.$Jjc=h,e.$Jjc=h=Je([qe(0,O.$AO),qe(1,l.$2ic),qe(2,k.$Djc),qe(3,r.$5ic),qe(4,d.$ejc),qe(5,o.$Gjc),qe(6,i.$WO)],h);class t{constructor(f,I,$,D,y,C,A){this.f=f,this.g=I,this.h=$,this.j=D,this.k=y,this.l=C,this.m=A}get api(){const f=this;return this.d??=Object.freeze({id:f.g,type:f.h,get name(){return f.j},set name(I){f.j=I,f.f.$setDebugSessionName(f.g,I)},parentSession:f.m,workspaceFolder:f.k,configuration:f.l,customRequest(I,$){return f.f.$customDebugAdapterRequest(f.g,I,$)},getDebugProtocolBreakpoint(I){return f.f.$getDebugProtocolBreakpoint(f.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(f){this.j=f}get configuration(){return this.l}}e.$Kjc=t;class v{constructor(f){this.value=Object.freeze({append(I){f.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$Ljc=v;class u{constructor(f){this.d=f}onWillStartSession(){this.d.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(f):void 0)}onWillStopSession(){this.d.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.d.forEach(I=>I.onError?I.onError(f):void 0)}onExit(f,I){this.d.forEach($=>$.onExit?$.onExit(f,I):void 0)}}class g extends w.$$nb{constructor(f){super(),this.h=f,f.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.h.handleMessage(f)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(f,I,$,D,y,C,A){super(f,I,$,D,y,C,A)}};e.$Mjc=a,e.$Mjc=a=Je([qe(0,O.$AO),qe(1,l.$2ic),qe(2,k.$Djc),qe(3,r.$5ic),qe(4,d.$ejc),qe(5,o.$Gjc),qe(6,i.$WO)],a)}),define(Me[293],Re([1,0,14,89,2,4,241,13,54,71,27,190,17,59,38,61]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get(m.$Nj),t=i.get(l.$AO).getProxy(N.$gM.MainThreadErrors);S.setUnexpectedErrorHandler(v=>{c.error(v);const u=S.$3(v);t.$onUnexpectedError(u)})}static async installFullHandler(i){const c=i.get(m.$Nj),h=i.get(l.$AO),t=i.get(p.$Djc),v=i.get(r.$UO),u=h.getProxy(N.$gM.MainThreadExtensionService),g=h.getProxy(N.$gM.MainThreadErrors),a=await t.getExtensionPathIndex(),b=new WeakMap;function f(D,y){if(b.has(D))return b.get(D).stack;let C="",A,G;for(const V of y)C+=`
	at ${V.toString()}`,G=V.getFileName(),!A&&G&&(A=a.findSubstr(M.URI.file(G)));const T=`${D.name||"Error"}: ${D.message||""}${C}`;return b.set(D,{extensionIdentifier:A?.identifier,stack:T}),T}const I=Symbol("prepareStackTrace wrapped");let $=f;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(D){if(D===f||!D||D[I]){$=D||f;return}$=function(y,C){return f(y,C),D.call(Error,y,C)},Object.assign($,{[I]:!0})}}),S.setUnexpectedErrorHandler(D=>{c.error(D);const y=S.$3(D),C=b.get(D);if(!C?.extensionIdentifier){g.$onUnexpectedError(y);return}u.$onExtensionRuntimeError(C.extensionIdentifier,y);const A=v.onExtensionError(C.extensionIdentifier,D);c.trace("forwarded error to extension?",A,C)})}}e.$Okc=o;class s{constructor(i,c,h,t,v){this.a=h,this.b=new R.$F0b(i,null,t),c=s.e(c,this.b);const u=new k.$fi(...(0,d.$fs)());u.set(O.$QO,{_serviceBrand:void 0,...c,messagePorts:v}),u.set(l.$AO,new l.$BO(this.b)),u.set(w.$Yic,new w.$Zic(t)),u.set(p.$Bjc,h);const g=new E.$Wq(u,!0);g.invokeFunction(o.installEarlyHandler),this.d=g.invokeFunction(a=>a.get(m.$Nj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=g.invokeFunction(a=>a.get(p.$Djc)),this.c.initialize(),g.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(N.$gM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>M.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$Pkc=s}),define(Me[294],Re([1,0,18,11,25,41,12,19,24,2,44]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$2jc=e.$1jc=void 0,e.$3jc=r;class E{constructor(n,i,c){this.d=n,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const c=this.g.folderQueries||[],h=new M.$ee(i);return new Promise((t,v)=>{this.a=new w(n);let u=!1;const g=(a,b)=>{if(!u&&!this.b){const f=this.h(a);r(a)&&typeof this.g.maxResults=="number"&&this.c+f>this.g.maxResults&&(this.b=!0,u=!0,h.cancel(),a=this.j(a,this.g.maxResults-this.c));const I=this.h(a);this.c+=I,(I>0||!r(a))&&this.a.add(a,b)}};Promise.all(c.map((a,b)=>this.k(a,f=>g(f,b),h.token))).then(a=>{h.dispose(),this.a.flush();const b=a.some(f=>!!f&&!!f.limitHit);t({limitHit:this.b||b,messages:(0,S.$Rb)(a.map(f=>f?.message?Array.isArray(f.message)?f.message:[f.message]:[])),stats:{type:this.f}})},a=>{h.dispose();const b=(0,N.$5i)(a);v(new Error(b))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,i),preview:{matches:h.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,c){const h=new O.$NK(this.g,n),t=[],v={report:a=>{if(!this.l(a))return;const b=n.folder.scheme===R.Schemas.file?(0,O.$OK)(()=>this.e.readdir(d.$Tg(a.uri))):void 0,f=d.$Wg(n.folder,a.uri);if(f){const I=h.includedInQuery(f,m.$oc(f),b);(0,F.$6g)(I)?t.push(I.then($=>{$&&i(a)})):I&&i(a)}}},u=this.n(n);let g;return this.d.query.type===3?g=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,u,v,c):g=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),u,v,c),t.length&&await Promise.all(t),g}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,O.$MK)(this.g.includePattern,n.includePattern),c=(0,O.$MK)(this.g.excludePattern,n.excludePattern),h={folder:k.URI.from(n.folder),excludes:c,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$1jc=E;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!d.$Ng(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$2jc=w;function p(s){return r(s)?{preview:{matches:(0,S.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,S.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$4jc=o}),define(Me[121],Re([1,0,6,4,3,289,17,59,13,2,294]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=void 0,e.$7jc=l,e.$5jc=(0,M.$hi)("IExtHostSearch");let E=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(F.$gM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$Zjc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,S.$Sc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,S.$Sc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,S.$Sc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,n){const i=l(s),c=this.j.get(r);if(c)return this.l.fileSearch(i,c,h=>{this.c.$handleFileMatch(r,o,h.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=l(s);return this.t(c,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$provideAITextSearchResults(r,o,s,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=l(s);return this.v(c,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$enableExtensionHostSearch(){}t(r,o){return new O.$1jc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new O.$1jc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$6jc=E,e.$6jc=E=Je([qe(0,R.$AO),qe(1,m.$Yic),qe(2,d.$Nj)],E);function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(w),extraFileResources:p.extraFileResources&&p.extraFileResources.map(r=>k.URI.revive(r))}}function w(p){return{...p,folder:k.URI.revive(p.folder)}}}),define(Me[295],Re([1,0,25,14,5,6,12,32,2,150,146,134,94,20,42,13,57,58,203,4,244,273,78,84,250,229,251,88,252,230,218,31,253,37,254,120,110,255,232,245,256,257,67,65,246,38,259,63,260,43,27,274,275,247,233,261,262,79,80,235,288,264,207,265,276,266,115,236,267,268,269,17,270,121,81,271,237,272,82,85,118,61,66,277,278,248,279,280,86,8,7,238,59,239,62,281,282,109,36,213,77,22,117]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v,u,g,a,b,f,I,$,D,y,C,A,G,T,V,P,L,q,re,ue,ye,Se,le,we,_,ve,ne,fe,W,te,Ee,Te,Ie,pe,ge,J,X,ce,de,Oe,he,Ce,Ae,Le,U,z,K,H,ee,se,Ne,Ve,Ye,xe,et,ot,rt,tt,st,Be,it,Q,Z,$e,We,Qe,at,Fe,Ct,Lt,Xt,ei,zt,Dt,ti,Ut,ri,ii,Xe,Qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=Bt;function Bt(ht){const mt=ht.get(fe.$QO),ni=ht.get(ne.$Gic),Vt=ht.get(_.$7ic),Wt=ht.get(le.$Djc),dt=ht.get(Ut.$2ic),St=ht.get(st.$UO),si=ht.get(C.$5ic),xt=ht.get(Lt.$Yic),He=ht.get(ee.$AO),qt=ht.get(ot.$njc),jt=ht.get(rt.$8ic),Ht=ht.get(r.$Oj),$t=ht.get(r.$Nj),Pt=ht.get(Qe.$9Ab),Mt=ht.get(t.$Cic),Ot=ht.get(ti.$Ikc),oi=ht.get(Ve.$vjc),Kt=ht.get(ye.$ejc),Gt=ht.get(J.$zjc),yt=ht.get(v.$Mic),Rt=ht.get(b.$Ric);He.set(i.$hM.ExtHostFileSystemInfo,ni),He.set(i.$hM.ExtHostLogLevelServiceShape,Ht),He.set(i.$hM.ExtHostWorkspace,dt),He.set(i.$hM.ExtHostConfiguration,si),He.set(i.$hM.ExtHostExtensionService,Wt),He.set(i.$hM.ExtHostStorage,qt),He.set(i.$hM.ExtHostTunnelService,Pt),He.set(i.$hM.ExtHostWindow,Ot),He.set(i.$hM.ExtHostSecretState,oi),He.set(i.$hM.ExtHostTelemetry,St),He.set(i.$hM.ExtHostEditorTabs,Kt),He.set(i.$hM.ExtHostManagedSockets,Gt),He.set(i.$hM.ExtHostAuthentication,yt),He.set(i.$hM.ExtHostChatProvider,Rt);const Jt=He.set(i.$hM.ExtHostDecorations,ht.get(T.$Ojc)),Nt=He.set(i.$hM.ExtHostDocumentsAndEditors,ht.get(ue.$LO)),kt=He.set(i.$hM.ExtHostCommands,ht.get(D.$WO)),It=He.set(i.$hM.ExtHostTerminalService,ht.get(Be.$qjc)),Et=He.set(i.$hM.ExtHostDebugService,ht.get(G.$Ijc)),li=He.set(i.$hM.ExtHostSearch,ht.get(Ne.$5jc)),_t=He.set(i.$hM.ExtHostTask,ht.get(tt.$vkc)),ai=He.set(i.$hM.ExtHostOutputService,ht.get(Le.$ikc)),hi=He.set(i.$hM.ExtHostLocalization,ht.get(ge.$yjc)),be=He.set(i.$hM.ExtHostUrls,new Xt.$Fkc(He)),Pe=He.set(i.$hM.ExtHostDocuments,new re.$Jic(He,Nt)),ae=He.set(i.$hM.ExtHostDocumentContentProviders,new L.$Qjc(He,Nt,$t)),Y=He.set(i.$hM.ExtHostDocumentSaveParticipant,new q.$Rjc($t,Pe,He.getProxy(i.$gM.MainThreadBulkEdits))),ke=He.set(i.$hM.ExtHostNotebook,new ce.$8jc(He,kt,Nt,Pe,Vt,li)),Ue=He.set(i.$hM.ExtHostNotebookDocuments,new Oe.$ckc(ke)),Ze=He.set(i.$hM.ExtHostNotebookEditors,new he.$dkc($t,ke)),Ke=He.set(i.$hM.ExtHostNotebookKernels,new Ce.$ekc(He,mt,ke,kt,$t)),ut=He.set(i.$hM.ExtHostNotebookRenderers,new Ae.$gkc(He,ke)),wt=He.set(i.$hM.ExtHostNotebookDocumentSaveParticipant,new de.$bkc($t,ke,He.getProxy(i.$gM.MainThreadBulkEdits))),bt=He.set(i.$hM.ExtHostEditors,new Q.$Vic(He,Nt)),Zt=He.set(i.$hM.ExtHostTreeViews,new We.$Dkc(He.getProxy(i.$gM.MainThreadTreeViews),kt,$t)),At=He.set(i.$hM.ExtHostEditorInsets,new $.$Wic(He.getProxy(i.$gM.MainThreadEditorInsets),bt,mt.remote)),Tt=He.set(i.$hM.ExtHostDiagnostics,new V.$Iic(He,$t,ni,Nt)),yi=He.set(i.$hM.ExtHostLanguages,new pe.$_jc(He,Pe,kt.converter,xt)),ft=He.set(i.$hM.ExtHostLanguageFeatures,new Ie.$Kic(He,xt,Pe,kt,Tt,$t,Mt,St)),Ri=He.set(i.$hM.ExtHostFileSystem,new we.$Tjc(He,ft)),gi=He.set(i.$hM.ExtHostFileSystemEventService,new ve.$Ujc(He,$t,Nt)),pi=He.set(i.$hM.ExtHostQuickOpen,(0,H.$mkc)(He,dt,kt)),ki=He.set(i.$hM.ExtHostSCM,new se.$okc(He,kt,Pe,$t)),Ai=He.set(i.$hM.ExtHostQuickDiff,new K.$lkc(He,xt)),Fi=He.set(i.$hM.ExtHostShare,new Ye.$pkc(He,xt)),Ji=He.set(i.$hM.ExtHostComments,(0,y.$Xic)(He,kt,Pe)),Yi=He.set(i.$hM.ExtHostProgress,new z.$kkc(He.getProxy(i.$gM.MainThreadProgress))),Qi=He.set(i.$hM.ExtHostLabelService,new Te.$$jc(He)),Ei=He.set(i.$hM.ExtHostTheming,new Z.$Akc(He)),Oi=He.set(i.$hM.ExtHostTimeline,new $e.$Ckc(He,kt)),Di=He.set(i.$hM.ExtHostWebviews,new ei.$_ic(He,mt.remote,dt,$t,Mt)),Si=He.set(i.$hM.ExtHostWebviewPanels,new zt.$cjc(He,Di,dt)),Zi=He.set(i.$hM.ExtHostCustomEditors,new A.$djc(He,Pe,jt,Di,Si)),Xi=He.set(i.$hM.ExtHostWebviewViews,new Dt.$Gkc(He,Di)),wi=He.set(i.$hM.ExtHostTesting,new it.$wkc(He,$t,kt,Nt)),ln=He.set(i.$hM.ExtHostUriOpeners,new Ct.$Ekc(He)),hn=He.set(i.$hM.ExtHostProfileContentHandlers,new U.$jkc(He));He.set(i.$hM.ExtHostInteractive,new te.$9jc(He,ke,Nt,kt,$t));const Ni=He.set(i.$hM.ExtHostInlineChat,new W.$Vjc(He,kt,Pe,$t)),Ti=He.set(i.$hM.ExtHostChatAgents2,new a.$Qic(He,$t,kt)),dn=He.set(i.$hM.ExtHostChatVariables,new f.$Tic(He)),xi=He.set(i.$hM.ExtHostChat,new g.$Pic(He)),Li=He.set(i.$hM.ExtHostAiRelatedInformation,new c.$Bic(He)),fn=He.set(i.$hM.ExtHostAiEmbeddingVector,new Se.$Sjc(He)),Ii=He.set(i.$hM.ExtHostIssueReporter,new Ee.$0jc(He)),ji=He.set(i.$hM.ExtHostStatusBar,new et.$skc(He,kt.converter)),_i=He.set(i.$hM.ExtHostSpeech,new xe.$qkc(He)),en=Object.values(i.$hM);He.assertRegistered(en);const gn=new u.$Oic(He,Nt),zi=new I.$Uic(He),Ci=new X.$akc(He,$t),di=new P.$Pjc(He);return h.$Lic.register(kt),function(je,mi,ci){function nt(x){return(oe,ze,ct)=>{const vt=x(Ft=>{try{oe.call(ze,Ft)}catch(Pi){F.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),St.onExtensionError(je.identifier,Pi)}});return ct?.push(vt),vt}}const pt=function(){let x=!je.isUnderDevelopment;function oe(){x||($t.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function ze(ct){if(Array.isArray(ct))ct.forEach(ze);else if(typeof ct=="string")oe();else{const vt=ct;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Xe.$6F)(je,"documentFiltersExclusive")}return ct}}(),tn={getSession(x,oe,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,Xe.$6F)(je,"authLearnMore"),yt.getSession(je,x,oe,ze)},getSessions(x,oe){return(0,Xe.$6F)(je,"authGetSessions"),yt.getSessions(je,x,oe)},async hasSession(x,oe){return(0,Xe.$6F)(je,"authSession"),!!await yt.getSession(je,x,oe,{silent:!0})},get onDidChangeSessions(){return nt(yt.onDidChangeSessions)},registerAuthenticationProvider(x,oe,ze,ct){return yt.registerAuthenticationProvider(x,oe,ze,ct)}},nn={registerCommand(x,oe,ze){return kt.registerCommand(!0,x,oe,ze,void 0,je)},registerTextEditorCommand(x,oe,ze){return kt.registerCommand(!0,x,(...ct)=>{const vt=bt.getActiveTextEditor();if(!vt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}return vt.edit(Ft=>{oe.apply(ze,[vt,Ft,...ct])}).then(Ft=>{Ft||$t.warn("Edits from command "+x+" were not applied.")},Ft=>{$t.warn("An error occurred while running command "+x,Ft)})},void 0,void 0,je)},registerDiffInformationCommand:(x,oe,ze)=>((0,Xe.$6F)(je,"diffCommand"),kt.registerCommand(!0,x,async(...ct)=>{const vt=Nt.activeEditor(!0);if(!vt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}const Ft=await bt.getDiffInformation(vt.id);oe.apply(ze,[Ft,...ct])},void 0,void 0,je)),executeCommand(x,...oe){return kt.executeCommand(x,...oe)},getCommands(x=!1){return kt.getCommands(x)}},Ui={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return nt(It.onDidChangeShell)},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(St.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$6F)(je,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$6F)(je,"telemetry"),nt(St.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$TO)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,oe){return st.$SO.validateSender(x),St.instantiateLogger(je,x,oe)},openExternal(x,oe){return Ot.openUri(x,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===mt.environment.appUriScheme)return be.createAppUri(x);try{return await Ot.asExternalUri(x,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,R.$qg)(x,R.Schemas.http)||(0,R.$qg)(x,R.Schemas.https))return x;throw oe}},get remoteName(){return(0,o.$tm)(mt.remote.authority)},get remoteAuthority(){return(0,Xe.$6F)(je,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return nt($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Xe.$6F)(je,"handleIssueUri"),Ii.registerIssueUriRequestHandler(je,x)},registerIssueDataProvider(x){return(0,Xe.$6F)(je,"handleIssueUri"),Ii.registerIssueDataProvider(je,x)},get appQuality(){return(0,Xe.$6F)(je,"resolvers"),mt.quality},get appCommit(){return(0,Xe.$6F)(je,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(Ui);const mn={createTestController(x,oe,ze){return wi.createTestController(je,x,oe,ze)},createTestObserver(){return(0,Xe.$6F)(je,"testObserver"),wi.createTestObserver()},runTests(x){return(0,Xe.$6F)(je,"testObserver"),wi.runTests(x)},get onDidChangeTestResults(){return(0,Xe.$6F)(je,"testObserver"),nt(wi.onResultsChanged)},get testResults(){return(0,Xe.$6F)(je,"testObserver"),wi.results}},bi=mt.remote.isRemote?Fe.ExtensionKind.Workspace:Fe.ExtensionKind.UI,rn={getExtension(x,oe){(0,Xe.$5F)(je,"extensionsAny")||(oe=!1);const ze=mi.mine.getExtensionDescription(x);if(ze)return new le.$Ejc(Wt,je.identifier,ze,bi,!1);if(oe){const ct=mi.all.getExtensionDescription(x);if(ct)return new le.$Ejc(Wt,je.identifier,ct,bi,!0)}},get all(){const x=[];for(const oe of mi.mine.getAllExtensionDescriptions())x.push(new le.$Ejc(Wt,je.identifier,oe,bi,!1));return x},get allAcrossExtensionHosts(){(0,Xe.$6F)(je,"extensionsAny");const x=new w.$Dm(mi.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),oe=[];for(const ze of mi.all.getAllExtensionDescriptions()){const ct=!x.has(ze.identifier);oe.push(new le.$Ejc(Wt,je.identifier,ze,bi,ct))}return oe},get onDidChange(){return(0,Xe.$5F)(je,"extensionsAny")?nt(M.Event.any(mi.mine.onDidChange,mi.all.onDidChange)):nt(mi.mine.onDidChange)}},$n={createDiagnosticCollection(x){return Tt.createDiagnosticCollection(je.identifier,x)},get onDidChangeDiagnostics(){return nt(Tt.onDidChangeDiagnostics)},getDiagnostics:x=>Tt.getDiagnostics(x),getLanguages(){return yi.getLanguages()},setTextDocumentLanguage(x,oe){return yi.changeLanguage(x.uri,oe)},match(x,oe){const ze=at.LanguageSelector.from(x);let ct;return(0,O.$Ut)(ze)&&(ct=ke.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Ft=>Ft.document===oe))?.apiNotebook),(0,O.$Tt)(ze,oe.uri,oe.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(x,oe,ze){return ft.registerCodeActionProvider(je,pt(x),oe,ze)},registerDocumentPasteEditProvider(x,oe,ze){return(0,Xe.$6F)(je,"documentPaste"),ft.registerDocumentPasteEditProvider(je,pt(x),oe,ze)},registerCodeLensProvider(x,oe){return ft.registerCodeLensProvider(je,pt(x),oe)},registerDefinitionProvider(x,oe){return ft.registerDefinitionProvider(je,pt(x),oe)},registerDeclarationProvider(x,oe){return ft.registerDeclarationProvider(je,pt(x),oe)},registerImplementationProvider(x,oe){return ft.registerImplementationProvider(je,pt(x),oe)},registerTypeDefinitionProvider(x,oe){return ft.registerTypeDefinitionProvider(je,pt(x),oe)},registerHoverProvider(x,oe){return ft.registerHoverProvider(je,pt(x),oe,je.identifier)},registerEvaluatableExpressionProvider(x,oe){return ft.registerEvaluatableExpressionProvider(je,pt(x),oe,je.identifier)},registerInlineValuesProvider(x,oe){return ft.registerInlineValuesProvider(je,pt(x),oe,je.identifier)},registerDocumentHighlightProvider(x,oe){return ft.registerDocumentHighlightProvider(je,pt(x),oe)},registerMultiDocumentHighlightProvider(x,oe){return ft.registerMultiDocumentHighlightProvider(je,pt(x),oe)},registerLinkedEditingRangeProvider(x,oe){return ft.registerLinkedEditingRangeProvider(je,pt(x),oe)},registerReferenceProvider(x,oe){return ft.registerReferenceProvider(je,pt(x),oe)},registerRenameProvider(x,oe){return ft.registerRenameProvider(je,pt(x),oe)},registerNewSymbolNamesProvider(x,oe){return(0,Xe.$6F)(je,"newSymbolNamesProvider"),ft.registerNewSymbolNamesProvider(je,pt(x),oe)},registerDocumentSymbolProvider(x,oe,ze){return ft.registerDocumentSymbolProvider(je,pt(x),oe,ze)},registerWorkspaceSymbolProvider(x){return ft.registerWorkspaceSymbolProvider(je,x)},registerDocumentFormattingEditProvider(x,oe){return ft.registerDocumentFormattingEditProvider(je,pt(x),oe)},registerDocumentRangeFormattingEditProvider(x,oe){return ft.registerDocumentRangeFormattingEditProvider(je,pt(x),oe)},registerOnTypeFormattingEditProvider(x,oe,ze,...ct){return ft.registerOnTypeFormattingEditProvider(je,pt(x),oe,[ze].concat(ct))},registerDocumentSemanticTokensProvider(x,oe,ze){return ft.registerDocumentSemanticTokensProvider(je,pt(x),oe,ze)},registerDocumentRangeSemanticTokensProvider(x,oe,ze){return ft.registerDocumentRangeSemanticTokensProvider(je,pt(x),oe,ze)},registerSignatureHelpProvider(x,oe,ze,...ct){return typeof ze=="object"?ft.registerSignatureHelpProvider(je,pt(x),oe,ze):ft.registerSignatureHelpProvider(je,pt(x),oe,typeof ze>"u"?[]:[ze,...ct])},registerCompletionItemProvider(x,oe,...ze){return ft.registerCompletionItemProvider(je,pt(x),oe,ze)},registerInlineCompletionItemProvider(x,oe,ze){return oe.handleDidShowCompletionItem&&(0,Xe.$6F)(je,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$6F)(je,"inlineCompletionsAdditions"),ze&&(0,Xe.$6F)(je,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(je,pt(x),oe,ze)},registerInlineEditProvider(x,oe){return(0,Xe.$6F)(je,"inlineEdit"),ft.registerInlineEditProvider(je,pt(x),oe)},registerDocumentLinkProvider(x,oe){return ft.registerDocumentLinkProvider(je,pt(x),oe)},registerColorProvider(x,oe){return ft.registerColorProvider(je,pt(x),oe)},registerFoldingRangeProvider(x,oe){return ft.registerFoldingRangeProvider(je,pt(x),oe)},registerSelectionRangeProvider(x,oe){return ft.registerSelectionRangeProvider(je,x,oe)},registerCallHierarchyProvider(x,oe){return ft.registerCallHierarchyProvider(je,x,oe)},registerTypeHierarchyProvider(x,oe){return ft.registerTypeHierarchyProvider(je,x,oe)},setLanguageConfiguration:(x,oe)=>ft.setLanguageConfiguration(je,x,oe),getTokenInformationAtPosition(x,oe){return(0,Xe.$6F)(je,"tokenInformation"),yi.tokenAtPosition(x,oe)},registerInlayHintsProvider(x,oe){return ft.registerInlayHintsProvider(je,x,oe)},createLanguageStatusItem(x,oe){return yi.createLanguageStatusItem(je,x,oe)},registerDocumentDropEditProvider(x,oe,ze){return ft.registerDocumentOnDropEditProvider(je,x,oe,(0,Xe.$5F)(je,"dropMetadata")?ze:void 0)}},pn={get activeTextEditor(){return bt.getActiveTextEditor()},get visibleTextEditors(){return bt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(x,oe,ze){d.URI.isUri(x)&&x.scheme===R.Schemas.vscodeRemote&&!x.authority&&Mt.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(d.URI.isUri(x)?Promise.resolve(Bi.openTextDocument(x)):Promise.resolve(x));return bt.showTextDocument(ct,oe,ze)},createTextEditorDecorationType(x){return bt.createTextEditorDecorationType(je,x)},onDidChangeActiveTextEditor(x,oe,ze){return nt(bt.onDidChangeActiveTextEditor)(x,oe,ze)},onDidChangeVisibleTextEditors(x,oe,ze){return nt(bt.onDidChangeVisibleTextEditors)(x,oe,ze)},onDidChangeTextEditorSelection(x,oe,ze){return nt(bt.onDidChangeTextEditorSelection)(x,oe,ze)},onDidChangeTextEditorOptions(x,oe,ze){return nt(bt.onDidChangeTextEditorOptions)(x,oe,ze)},onDidChangeTextEditorVisibleRanges(x,oe,ze){return nt(bt.onDidChangeTextEditorVisibleRanges)(x,oe,ze)},onDidChangeTextEditorViewColumn(x,oe,ze){return nt(bt.onDidChangeTextEditorViewColumn)(x,oe,ze)},onDidCloseTerminal(x,oe,ze){return nt(It.onDidCloseTerminal)(x,oe,ze)},onDidOpenTerminal(x,oe,ze){return nt(It.onDidOpenTerminal)(x,oe,ze)},onDidChangeActiveTerminal(x,oe,ze){return nt(It.onDidChangeActiveTerminal)(x,oe,ze)},onDidChangeTerminalDimensions(x,oe,ze){return(0,Xe.$6F)(je,"terminalDimensions"),nt(It.onDidChangeTerminalDimensions)(x,oe,ze)},onDidChangeTerminalState(x,oe,ze){return nt(It.onDidChangeTerminalState)(x,oe,ze)},onDidWriteTerminalData(x,oe,ze){return(0,Xe.$6F)(je,"terminalDataWriteEvent"),nt(It.onDidWriteTerminalData)(x,oe,ze)},onDidExecuteTerminalCommand(x,oe,ze){return(0,Xe.$6F)(je,"terminalExecuteCommandEvent"),nt(It.onDidExecuteTerminalCommand)(x,oe,ze)},get state(){return Ot.getState(je)},onDidChangeWindowState(x,oe,ze){return nt(Ot.onDidChangeWindowState)(x,oe,ze)},showInformationMessage(x,...oe){return Ci.showMessage(je,m.default.Info,x,oe[0],oe.slice(1))},showWarningMessage(x,...oe){return Ci.showMessage(je,m.default.Warning,x,oe[0],oe.slice(1))},showErrorMessage(x,...oe){return Ci.showMessage(je,m.default.Error,x,oe[0],oe.slice(1))},showQuickPick(x,oe,ze){return pi.showQuickPick(je,x,oe,ze)},showWorkspaceFolderPick(x){return pi.showWorkspaceFolderPick(x)},showInputBox(x,oe){return pi.showInput(x,oe)},showOpenDialog(x){return di.showOpenDialog(je,x)},showSaveDialog(x){return di.showSaveDialog(x)},createStatusBarItem(x,oe,ze){let ct,vt,Ft;return typeof x=="string"?(ct=x,vt=oe,Ft=ze):(vt=x,Ft=oe),ji.createStatusBarEntry(je,ct,vt,Ft)},setStatusBarMessage(x,oe){return ji.setStatusBarMessage(x,oe)},withScmProgress(x){return Mt.report("window.withScmProgress",je,"Use 'withProgress' instead."),Yi.withProgress(je,{location:Fe.ProgressLocation.SourceControl},(oe,ze)=>x({report(ct){}}))},withProgress(x,oe){return Yi.withProgress(je,x,oe)},createOutputChannel(x,oe){return ai.createOutputChannel(x,oe,je)},createWebviewPanel(x,oe,ze,ct){return Si.createWebviewPanel(je,x,oe,ze,ct)},createWebviewTextEditorInset(x,oe,ze,ct){return(0,Xe.$6F)(je,"editorInsets"),At.createWebviewEditorInset(x,oe,ze,ct,je)},createTerminal(x,oe,ze){return typeof x=="object"?"pty"in x?It.createExtensionTerminal(x):It.createTerminalFromOptions(x):It.createTerminal(x,oe,ze)},registerTerminalLinkProvider(x){return It.registerLinkProvider(x)},registerTerminalProfileProvider(x,oe){return It.registerProfileProvider(je,x,oe)},registerTerminalQuickFixProvider(x,oe){return(0,Xe.$6F)(je,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(x,je.identifier.value,oe)},registerTreeDataProvider(x,oe){return Zt.registerTreeDataProvider(x,oe,je)},createTreeView(x,oe){return Zt.createTreeView(x,oe,je)},registerWebviewPanelSerializer:(x,oe)=>Si.registerWebviewPanelSerializer(je,x,oe),registerCustomEditorProvider:(x,oe,ze={})=>Zi.registerCustomEditorProvider(je,x,oe,ze),registerFileDecorationProvider(x){return Jt.registerFileDecorationProvider(x,je)},registerUriHandler(x){return be.registerUriHandler(je,x)},createQuickPick(){return pi.createQuickPick(je)},createInputBox(){return pi.createInputBox(je)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(x,oe,ze){return nt(Ei.onDidChangeActiveColorTheme)(x,oe,ze)},registerWebviewViewProvider(x,oe,ze){return Xi.registerWebviewViewProvider(je,x,oe,ze?.webviewOptions)},get activeNotebookEditor(){return ke.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,oe,ze){return nt(ke.onDidChangeActiveNotebookEditor)(x,oe,ze)},get visibleNotebookEditors(){return ke.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(ke.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,oe,ze){return nt(Ze.onDidChangeNotebookEditorSelection)(x,oe,ze)},onDidChangeNotebookEditorVisibleRanges(x,oe,ze){return nt(Ze.onDidChangeNotebookEditorVisibleRanges)(x,oe,ze)},showNotebookDocument(x,oe){return ke.showNotebookDocument(x,oe)},registerExternalUriOpener(x,oe,ze){return(0,Xe.$6F)(je,"externalUriOpener"),ln.registerExternalUriOpener(je.identifier,x,oe,ze)},registerProfileContentHandler(x,oe){return(0,Xe.$6F)(je,"profileContentHandlers"),hn.registerProfileContentHandler(je,x,oe)},registerQuickDiffProvider(x,oe,ze,ct){return(0,Xe.$6F)(je,"quickDiffProvider"),Ai.registerQuickDiffProvider(pt(x),oe,ze,ct)},get tabGroups(){return Kt.tabGroups},registerShareProvider(x,oe){return(0,Xe.$6F)(je,"shareProvider"),Fi.registerShareProvider(pt(x),oe)}},Bi={get rootPath(){return Mt.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(x){throw new F.$9("rootPath")},getWorkspaceFolder(x){return dt.getWorkspaceFolder(x)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(x){throw new F.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(x){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(x,oe,...ze)=>dt.updateWorkspaceFolders(je,x,oe||0,...ze),onDidChangeWorkspaceFolders:function(x,oe,ze){return nt(dt.onDidChangeWorkspace)(x,oe,ze)},asRelativePath:(x,oe)=>dt.getRelativePath(x,oe),findFiles:(x,oe,ze,ct)=>dt.findFiles(x,oe,ze,je.identifier,ct),findFiles2:(x,oe,ze)=>((0,Xe.$6F)(je,"findFiles2"),dt.findFiles2(x,oe,je.identifier,ze)),findTextInFiles:(x,oe,ze,ct)=>{(0,Xe.$6F)(je,"findTextInFiles");let vt,Ft;return typeof oe=="object"?(vt=oe,Ft=ze):(vt={},Ft=oe,ct=ze),dt.findTextInFiles(x,vt||{},Ft,je.identifier,ct)},save:x=>dt.save(x),saveAs:x=>dt.saveAs(x),saveAll:x=>dt.saveAll(x),applyEdit(x,oe){return gn.applyWorkspaceEdit(x,je,oe)},createFileSystemWatcher:(x,oe,ze,ct)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ct,correlate:!1}:oe&&((0,Xe.$6F)(je,"createFileSystemWatcher"),vt={...oe,correlate:!0}),gi.createFileSystemWatcher(dt,je,x,vt)},get textDocuments(){return Pe.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new F.$9("textDocuments")},openTextDocument(x){let oe;const ze=x;if(typeof x=="string")oe=Promise.resolve(d.URI.file(x));else if(d.URI.isUri(x))oe=Promise.resolve(x);else if(!ze||typeof ze=="object")oe=Pe.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Mt.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),Pe.ensureDocumentData(ct).then(vt=>vt.document)))},onDidOpenTextDocument:(x,oe,ze)=>nt(Pe.onDidAddDocument)(x,oe,ze),onDidCloseTextDocument:(x,oe,ze)=>nt(Pe.onDidRemoveDocument)(x,oe,ze),onDidChangeTextDocument:(x,oe,ze)=>nt(Pe.onDidChangeDocument)(x,oe,ze),onDidSaveTextDocument:(x,oe,ze)=>nt(Pe.onDidSaveDocument)(x,oe,ze),onWillSaveTextDocument:(x,oe,ze)=>nt(Y.getOnWillSaveTextDocumentEvent(je))(x,oe,ze),get notebookDocuments(){return ke.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,oe){let ze;if(d.URI.isUri(x))ze=x,await ke.openNotebookDocument(x);else if(typeof x=="string")ze=d.URI.revive(await ke.createNotebookDocument({viewType:x,content:oe}));else throw new Error("Invalid arguments");return ke.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(x,oe,ze){return nt(Ue.onDidSaveNotebookDocument)(x,oe,ze)},onDidChangeNotebookDocument(x,oe,ze){return nt(Ue.onDidChangeNotebookDocument)(x,oe,ze)},onWillSaveNotebookDocument(x,oe,ze){return nt(wt.getOnWillSaveNotebookDocumentEvent(je))(x,oe,ze)},get onDidOpenNotebookDocument(){return nt(ke.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(ke.onDidCloseNotebookDocument)},registerNotebookSerializer(x,oe,ze,ct){return ke.registerNotebookSerializer(je,x,oe,ze,(0,Xe.$5F)(je,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(x,oe,ze)=>nt(ci.onDidChangeConfiguration)(x,oe,ze),getConfiguration(x,oe){return oe=arguments.length===1?void 0:oe,ci.getConfiguration(x,oe,je)},registerTextDocumentContentProvider(x,oe){return ae.registerTextDocumentContentProvider(x,oe)},registerTaskProvider:(x,oe)=>(Mt.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(je,x,oe)),registerFileSystemProvider(x,oe,ze){return(0,N.$Rc)(Ri.registerFileSystemProvider(je,x,oe,ze),Vt.addFileSystemProvider(x,oe,ze))},get fs(){return Vt.value},registerFileSearchProvider:(x,oe)=>((0,Xe.$6F)(je,"fileSearchProvider"),li.registerFileSearchProvider(x,oe)),registerTextSearchProvider:(x,oe)=>((0,Xe.$6F)(je,"textSearchProvider"),li.registerTextSearchProvider(x,oe)),registerAITextSearchProvider:(x,oe)=>((0,Xe.$6F)(je,"aiTextSearchProvider"),(0,Xe.$6F)(je,"textSearchProvider"),li.registerAITextSearchProvider(x,oe)),registerRemoteAuthorityResolver:(x,oe)=>((0,Xe.$6F)(je,"resolvers"),Wt.registerRemoteAuthorityResolver(x,oe)),registerResourceLabelFormatter:x=>((0,Xe.$6F)(je,"resolvers"),Qi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Xe.$6F)(je,"resolvers"),Wt.getRemoteExecServer(x)),onDidCreateFiles:(x,oe,ze)=>nt(gi.onDidCreateFile)(x,oe,ze),onDidDeleteFiles:(x,oe,ze)=>nt(gi.onDidDeleteFile)(x,oe,ze),onDidRenameFiles:(x,oe,ze)=>nt(gi.onDidRenameFile)(x,oe,ze),onWillCreateFiles:(x,oe,ze)=>nt(gi.getOnWillCreateFileEvent(je))(x,oe,ze),onWillDeleteFiles:(x,oe,ze)=>nt(gi.getOnWillDeleteFileEvent(je))(x,oe,ze),onWillRenameFiles:(x,oe,ze)=>nt(gi.getOnWillRenameFileEvent(je))(x,oe,ze),openTunnel:x=>((0,Xe.$6F)(je,"tunnels"),Pt.openTunnel(je,x).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$6F)(je,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(x,oe,ze)=>((0,Xe.$6F)(je,"tunnels"),nt(Pt.onDidChangeTunnels)(x,oe,ze)),registerPortAttributesProvider:(x,oe)=>((0,Xe.$6F)(je,"portsAttributes"),Pt.registerPortsAttributesProvider(x,oe)),registerTunnelProvider:(x,oe)=>((0,Xe.$6F)(je,"tunnelFactory"),Pt.registerTunnelProvider(x,oe)),registerTimelineProvider:(x,oe)=>((0,Xe.$6F)(je,"timeline"),Oi.registerTimelineProvider(x,oe,je.identifier,kt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:x=>((0,Xe.$6F)(je,"workspaceTrust"),dt.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,oe,ze)=>nt(dt.onDidGrantWorkspaceTrust)(x,oe,ze),registerEditSessionIdentityProvider:(x,oe)=>((0,Xe.$6F)(je,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(x,oe)),onWillCreateEditSessionIdentity:(x,oe,ze)=>((0,Xe.$6F)(je,"editSessionIdentityProvider"),nt(dt.getOnWillCreateEditSessionIdentityEvent(je))(x,oe,ze)),registerCanonicalUriProvider:(x,oe)=>((0,Xe.$6F)(je,"canonicalUriProvider"),dt.registerCanonicalUriProvider(x,oe)),getCanonicalUri:(x,oe,ze)=>((0,Xe.$6F)(je,"canonicalUriProvider"),dt.provideCanonicalUri(x,oe,ze))},Vi={get inputBox(){return Mt.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(je)},createSourceControl(x,oe,ze){return ki.createSourceControl(je,x,oe,ze)}},sn={createCommentController(x,oe){return Ji.createCommentController(je,x,oe)}},on={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,Xe.$5F)(je,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(x,oe){return(0,Xe.$6F)(je,"debugVisualization"),Et.registerDebugVisualizationProvider(je,x,oe)},registerDebugVisualizationTreeProvider(x,oe){return(0,Xe.$6F)(je,"debugVisualization"),Et.registerDebugVisualizationTree(je,x,oe)},onDidStartDebugSession(x,oe,ze){return nt(Et.onDidStartDebugSession)(x,oe,ze)},onDidTerminateDebugSession(x,oe,ze){return nt(Et.onDidTerminateDebugSession)(x,oe,ze)},onDidChangeActiveDebugSession(x,oe,ze){return nt(Et.onDidChangeActiveDebugSession)(x,oe,ze)},onDidReceiveDebugSessionCustomEvent(x,oe,ze){return nt(Et.onDidReceiveDebugSessionCustomEvent)(x,oe,ze)},onDidChangeBreakpoints(x,oe,ze){return nt(Et.onDidChangeBreakpoints)(x,oe,ze)},onDidChangeActiveStackItem(x,oe,ze){return(0,Xe.$6F)(je,"debugFocus"),nt(Et.onDidChangeActiveStackItem)(x,oe,ze)},registerDebugConfigurationProvider(x,oe,ze){return Et.registerDebugConfigurationProvider(x,oe,ze||ri.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,oe){return Et.registerDebugAdapterDescriptorFactory(je,x,oe)},registerDebugAdapterTrackerFactory(x,oe){return Et.registerDebugAdapterTrackerFactory(x,oe)},startDebugging(x,oe,ze){return!ze||typeof ze=="object"&&"configuration"in ze?Et.startDebugging(x,oe,{parentSession:ze}):Et.startDebugging(x,oe,ze||{})},stopDebugging(x){return Et.stopDebugging(x)},addBreakpoints(x){return Et.addBreakpoints(x)},removeBreakpoints(x){return Et.removeBreakpoints(x)},asDebugSourceUri(x,oe){return Et.asDebugSourceUri(x,oe)}},an={registerTaskProvider:(x,oe)=>_t.registerTaskProvider(je,x,oe),fetchTasks:x=>_t.fetchTasks(x),executeTask:x=>_t.executeTask(je,x),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(x,oe,ze)=>nt(_t.onDidStartTask)(x,oe,ze),onDidEndTask:(x,oe,ze)=>nt(_t.onDidEndTask)(x,oe,ze),onDidStartTaskProcess:(x,oe,ze)=>nt(_t.onDidStartTaskProcess)(x,oe,ze),onDidEndTaskProcess:(x,oe,ze)=>nt(_t.onDidEndTaskProcess)(x,oe,ze)},vn={createNotebookController(x,oe,ze,ct,vt){return Ke.createNotebookController(je,x,oe,ze,ct,(0,Xe.$5F)(je,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(x,oe)=>ke.registerNotebookCellStatusBarItemProvider(je,x,oe),createRendererMessaging(x){return ut.createRendererMessaging(je,x)},createNotebookControllerDetectionTask(x){return(0,Xe.$6F)(je,"notebookKernelSource"),Ke.createNotebookControllerDetectionTask(je,x)},registerKernelSourceActionProvider(x,oe){return(0,Xe.$6F)(je,"notebookKernelSource"),Ke.registerKernelSourceActionProvider(je,x,oe)},onDidChangeNotebookCellExecutionState(x,oe,ze){return(0,Xe.$6F)(je,"notebookCellExecutionState"),nt(Ke.onDidChangeNotebookCellExecutionState)(x,oe,ze)}},wn={t(...x){if(typeof x[0]=="string"){const oe=x.shift(),ze=!x||typeof x[0]!="object"?x:x[0];return hi.getMessage(je.identifier.value,{message:oe,args:ze})}return hi.getMessage(je.identifier.value,x[0])},get bundle(){return hi.getBundle(je.identifier.value)},get uri(){return hi.getBundleUri(je.identifier.value)}},cn={_version:1,registerInteractiveEditorSessionProvider(x,oe){return(0,Xe.$6F)(je,"interactive"),Ni.registerProvider(je,x,oe)},registerInteractiveSessionProvider(x,oe){return(0,Xe.$6F)(je,"interactive"),xi.registerChatProvider(je,x,oe)},transferChatSession(x,oe){return(0,Xe.$6F)(je,"interactive"),xi.transferChatSession(x,oe)}},un={getRelatedInformation(x,oe){return(0,Xe.$6F)(je,"aiRelatedInformation"),Li.getRelatedInformation(je,x,oe)},registerRelatedInformationProvider(x,oe){return(0,Xe.$6F)(je,"aiRelatedInformation"),Li.registerRelatedInformationProvider(je,x,oe)},registerEmbeddingVectorProvider(x,oe){return(0,Xe.$6F)(je,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(je,x,oe)}},Wi={registerChatResponseProvider(x,oe,ze){return(0,Xe.$6F)(je,"chatProvider"),Rt.registerLanguageModel(je,x,oe,ze)},registerChatVariableResolver(x,oe,ze){return(0,Xe.$6F)(je,"chatVariableResolver"),dn.registerVariableResolver(je,x,oe,ze)},registerMappedEditsProvider(x,oe){return(0,Xe.$6F)(je,"mappedEditsProvider"),ft.registerMappedEditsProvider(je,x,oe)},createChatParticipant(x,oe){return(0,Xe.$6F)(je,"chatParticipant"),Ti.createChatAgent(je,x,oe)}},qi={get languageModels(){return(0,Xe.$6F)(je,"languageModels"),Rt.getLanguageModelIds()},onDidChangeLanguageModels:(x,oe,ze)=>((0,Xe.$6F)(je,"languageModels"),Rt.onDidChangeProviders(x,oe,ze)),sendChatRequest(x,oe,ze,ct){return(0,Xe.$6F)(je,"languageModels"),Rt.sendChatRequest(je,x,oe,ze,ct)}},Hi={registerSpeechProvider(x,oe){return(0,Xe.$6F)(je,"speech"),_i.registerProvider(je.identifier,x,oe)}};return{version:mt.version,ai:un,authentication:tn,commands:nn,comments:sn,chat:Wi,debug:on,env:Ui,extensions:rn,interactive:cn,l10n:wn,languages:$n,lm:qi,notebooks:vn,scm:Vi,speech:Hi,tasks:an,tests:mn,window:pn,workspace:Bi,Breakpoint:Fe.$iN,TerminalOutputAnchor:Fe.TerminalOutputAnchor,ChatResultFeedbackKind:Fe.ChatResultFeedbackKind,ChatVariableLevel:Fe.ChatVariableLevel,ChatCompletionItem:Fe.$bO,CallHierarchyIncomingCall:Fe.$GM,CallHierarchyItem:Fe.$FM,CallHierarchyOutgoingCall:Fe.$HM,CancellationError:F.$5,CancellationTokenSource:S.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Fe.$CM,CodeActionKind:Fe.$DM,CodeActionTriggerKind:Fe.CodeActionTriggerKind,CodeLens:Fe.$IM,Color:Fe.$VM,ColorInformation:Fe.$WM,ColorPresentation:Fe.$XM,ColorThemeKind:Fe.ColorThemeKind,CommentMode:Fe.CommentMode,CommentState:Fe.CommentState,CommentThreadCollapsibleState:Fe.CommentThreadCollapsibleState,CommentThreadState:Fe.CommentThreadState,CompletionItem:Fe.$PM,CompletionItemKind:Fe.CompletionItemKind,CompletionItemTag:Fe.CompletionItemTag,CompletionList:Fe.$QM,CompletionTriggerKind:Fe.CompletionTriggerKind,ConfigurationTarget:Fe.ConfigurationTarget,CustomExecution:Fe.$6M,DebugAdapterExecutable:Fe.$mN,DebugAdapterInlineImplementation:Fe.$pN,DebugAdapterNamedPipeServer:Fe.$oN,DebugAdapterServer:Fe.$nN,DebugConfigurationProviderTriggerKind:ri.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Fe.DebugConsoleMode,DebugVisualization:Fe.$FN,DecorationRangeBehavior:Fe.DecorationRangeBehavior,Diagnostic:Fe.$wM,DiagnosticRelatedInformation:Fe.$vM,DiagnosticSeverity:Fe.DiagnosticSeverity,DiagnosticTag:Fe.DiagnosticTag,Disposable:Fe.$iM,DocumentHighlight:Fe.$yM,DocumentHighlightKind:Fe.DocumentHighlightKind,MultiDocumentHighlight:Fe.$zM,DocumentLink:Fe.$UM,DocumentSymbol:Fe.$BM,EndOfLine:Fe.EndOfLine,EnvironmentVariableMutatorType:Fe.EnvironmentVariableMutatorType,EvaluatableExpression:Fe.$sN,InlineValueText:Fe.$tN,InlineValueVariableLookup:Fe.$uN,InlineValueEvaluatableExpression:Fe.$vN,InlineCompletionTriggerKind:Fe.InlineCompletionTriggerKind,EventEmitter:M.$7d,ExtensionKind:Fe.ExtensionKind,ExtensionMode:Fe.ExtensionMode,ExternalUriOpenerPriority:Fe.ExternalUriOpenerPriority,FileChangeType:Fe.FileChangeType,FileDecoration:Fe.$HN,FileDecoration2:Fe.$HN,FileSystemError:Fe.$yN,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Fe.$zN,FoldingRangeKind:Fe.FoldingRangeKind,FunctionBreakpoint:Fe.$kN,InlineCompletionItem:Fe.$RM,InlineCompletionList:Fe.$SM,Hover:Fe.$xM,IndentAction:E.IndentAction,Location:Fe.$uM,MarkdownString:Fe.$JM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Fe.$KM,PortAutoForwardAction:Fe.PortAutoForwardAction,Position:Fe.$jM,ProcessExecution:Fe.$4M,ProgressLocation:Fe.ProgressLocation,QuickInputButtons:Fe.$GN,Range:Fe.$kM,RelativePattern:Fe.$gN,Selection:Fe.$lM,SelectionRange:Fe.$EM,SemanticTokens:Fe.$CN,SemanticTokensBuilder:Fe.$BN,SemanticTokensEdit:Fe.$DN,SemanticTokensEdits:Fe.$EN,SemanticTokensLegend:Fe.$AN,ShellExecution:Fe.$5M,ShellQuoting:Fe.ShellQuoting,SignatureHelp:Fe.$MM,SignatureHelpTriggerKind:Fe.SignatureHelpTriggerKind,SignatureInformation:Fe.$LM,SnippetString:Fe.$tM,SourceBreakpoint:Fe.$jN,StandardTokenType:Fe.StandardTokenType,StatusBarAlignment:Fe.StatusBarAlignment,SymbolInformation:Fe.$AM,SymbolKind:Fe.SymbolKind,SymbolTag:Fe.SymbolTag,Task:Fe.$7M,TaskGroup:Fe.$3M,TaskPanelKind:Fe.TaskPanelKind,TaskRevealKind:Fe.TaskRevealKind,TaskScope:Fe.TaskScope,TerminalLink:Fe.$YM,TerminalQuickFixTerminalCommand:Fe.$1M,TerminalQuickFixOpener:Fe.$ZM,TerminalLocation:Fe.TerminalLocation,TerminalProfile:Fe.$2M,TerminalExitReason:Fe.TerminalExitReason,TextDocumentSaveReason:Fe.TextDocumentSaveReason,TextEdit:Fe.$pM,SnippetTextEdit:Fe.$rM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Fe.TextEditorLineNumbersStyle,TextEditorRevealType:Fe.TextEditorRevealType,TextEditorSelectionChangeKind:Fe.TextEditorSelectionChangeKind,SyntaxTokenType:Fe.SyntaxTokenType,TextDocumentChangeReason:Fe.TextDocumentChangeReason,ThemeColor:Fe.$fN,ThemeIcon:Fe.$eN,TreeItem:Fe.$8M,TreeItemCheckboxState:Fe.TreeItemCheckboxState,TreeItemCollapsibleState:Fe.TreeItemCollapsibleState,TypeHierarchyItem:Fe.$3N,UIKind:ii.UIKind,Uri:d.URI,ViewColumn:Fe.ViewColumn,WorkspaceEdit:Fe.$sM,DocumentPasteTriggerKind:Fe.DocumentPasteTriggerKind,DocumentDropEdit:Fe.$bN,DocumentPasteEditKind:Fe.$cN,DocumentPasteEdit:Fe.$dN,InlayHint:Fe.$OM,InlayHintLabelPart:Fe.$NM,InlayHintKind:Fe.InlayHintKind,RemoteAuthorityResolverError:Fe.$oM,ResolvedAuthority:Fe.$mM,ManagedResolvedAuthority:Fe.$nM,SourceControlInputBoxValidationType:Fe.SourceControlInputBoxValidationType,ExtensionRuntime:Fe.ExtensionRuntime,TimelineItem:Fe.$RN,NotebookRange:Fe.$JN,NotebookCellKind:Fe.NotebookCellKind,NotebookCellExecutionState:Fe.NotebookCellExecutionState,NotebookCellData:Fe.$KN,NotebookData:Fe.$LN,NotebookRendererScript:Fe.$PN,NotebookCellStatusBarAlignment:Fe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Fe.NotebookEditorRevealType,NotebookCellOutput:Fe.$NN,NotebookCellOutputItem:Fe.$MN,NotebookCellStatusBarItem:Fe.$ON,NotebookControllerAffinity:Fe.NotebookControllerAffinity,NotebookControllerAffinity2:Fe.NotebookControllerAffinity2,NotebookEdit:Fe.$qM,NotebookKernelSourceAction:Fe.$QN,NotebookVariablesRequestKind:Fe.NotebookVariablesRequestKind,PortAttributes:Fe.$TN,LinkedEditingRanges:Fe.$SN,TestResultState:Fe.TestResultState,TestRunRequest:Fe.$UN,TestMessage:Fe.$VN,TestTag:Fe.$WN,TestRunProfileKind:Fe.TestRunProfileKind,TextSearchCompleteMessageType:Qt.TextSearchCompleteMessageType,DataTransfer:Fe.$aN,DataTransferItem:Fe.$9M,CoveredCount:Fe.$XN,FileCoverage:Fe.$YN,StatementCoverage:Fe.$ZN,BranchCoverage:Fe.$1N,DeclarationCoverage:Fe.$2N,FunctionCoverage:Fe.$2N,WorkspaceTrustState:Fe.WorkspaceTrustState,LanguageStatusSeverity:Fe.LanguageStatusSeverity,QuickPickItemKind:Fe.QuickPickItemKind,InputBoxValidationSeverity:Fe.InputBoxValidationSeverity,TabInputText:Fe.$4N,TabInputTextDiff:Fe.$5N,TabInputTextMerge:Fe.$6N,TabInputCustom:Fe.$7N,TabInputNotebook:Fe.$9N,TabInputNotebookDiff:Fe.$0N,TabInputWebview:Fe.$8N,TabInputTerminal:Fe.$$N,TabInputInteractiveWindow:Fe.$_N,TabInputChat:Fe.$aO,TelemetryTrustedValue:s.$3o,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Fe.InteractiveSessionVoteDirection,ChatCopyKind:Fe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Fe.InteractiveEditorResponseFeedbackKind,StackFrame:Fe.$qN,Thread:Fe.$rN,RelatedInformationType:Fe.RelatedInformationType,SpeechToTextStatus:Fe.SpeechToTextStatus,PartialAcceptTriggerKind:Fe.PartialAcceptTriggerKind,KeywordRecognitionStatus:Fe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Fe.$cO,ChatResponseFileTreePart:Fe.$dO,ChatResponseAnchorPart:Fe.$eO,ChatResponseProgressPart:Fe.$fO,ChatResponseReferencePart:Fe.$hO,ChatResponseCommandButtonPart:Fe.$gO,ChatRequestTurn:Fe.$iO,ChatResponseTurn:Fe.$jO,LanguageModelChatSystemMessage:Fe.$kO,LanguageModelChatUserMessage:Fe.$lO,LanguageModelChatAssistantMessage:Fe.$mO,LanguageModelSystemMessage:Fe.$kO,LanguageModelUserMessage:Fe.$lO,LanguageModelAssistantMessage:Fe.$mO,LanguageModelError:Fe.$nO,NewSymbolName:Fe.$xN,NewSymbolNameTag:Fe.NewSymbolNameTag,InlineEdit:Fe.$oO,InlineEditTriggerKind:Fe.InlineEditTriggerKind}}}}),define(Me[296],Re([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,43,81,61,65,234,13,119,79,80,84,88]),function(me,e,S,F,M,N,R,m,d,k,O,E,l,w,p,r,o,s,n,i,c,h,t,v,u,g,a,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$es)(g.$yjc,g.$xjc,1),(0,S.$es)(v.$Oj,t.$Kkc,1),(0,S.$es)(r.$Cic,r.$Dic,1),(0,S.$es)(m.$WO,m.$VO,0),(0,S.$es)(b.$Mic,b.$Nic,0),(0,S.$es)(f.$Ric,f.$Sic,0),(0,S.$es)(R.$5ic,R.$3ic,0),(0,S.$es)(s.$7ic,s.$6ic,0),(0,S.$es)(E.$Ijc,E.$Mjc,0),(0,S.$es)(N.$Ojc,N.$Njc,0),(0,S.$es)(d.$LO,d.$KO,0),(0,S.$es)(a.$zjc,a.$Ajc,0),(0,S.$es)(n.$Gic,n.$Fic,0),(0,S.$es)(F.$ikc,F.$hkc,1),(0,S.$es)(l.$5jc,l.$6jc,0),(0,S.$es)(w.$njc,w.$mjc,0),(0,S.$es)(O.$vkc,O.$ukc,0),(0,S.$es)(k.$qjc,k.$tjc,0),(0,S.$es)(p.$9Ab,p.$0Ab,0),(0,S.$es)(o.$Ikc,o.$Hkc,0),(0,S.$es)(M.$2ic,M.$1ic,0),(0,S.$es)(i.$vjc,i.$ujc,0),(0,S.$es)(c.$UO,c.$RO,0),(0,S.$es)(h.$ejc,h.$fjc,0),(0,S.$es)(u.$Gjc,u.$Hjc,0)}),define(Me[297],Re([1,0,295,38,2,292,7,11,240]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;class k extends N.$Nkc{j(){}getModule(w,p){for(const r of this.b){const o=r(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends F.$Cjc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async ub(){this.h.createInstance(d.$Tmc);const w=this.h.invokeFunction(S.$Jkc);this.r=this.h.createInstance(k,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Ab()}vb(w){return w.browser}async wb(w,p,r){p=p.with({path:E(p.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=M.URI.revive(await this.C.$asBrowserUri(p)),n=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),c=`${p.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",h)}catch(a){throw console.error(o?`Loading code for extension ${o} failed: ${a.message}`:`Loading code failed: ${a.message}`),console.error(`${p.toString(!0)}${typeof a.line=="number"?` line ${a.line}`:""}${typeof a.column=="number"?` column ${a.column}`:""}`),console.error(a),a}w&&await this.w.initializeLocalizedMessages(w);const v={},u={exports:v},g=a=>{const b=this.r.getModule(a,p);if(b===void 0)throw new Error(`Cannot load module '${a}'`);return b};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(u,v,g),u.exports!==v?u.exports:v}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Ab(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+w;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,m.$ih)(10)}}e.$Umc=O;function E(l,w){return l.endsWith(w)?l:l+w}}),define(Me[298],Re([1,0,70,54,13,38,205,85,297]),function(me,e,S,F,M,N,R,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$es)(M.$Nj,new S.$ei(R.$Mkc,[!0],!0)),(0,F.$es)(N.$Djc,d.$Umc,0),(0,F.$es)(m.$8ic,m.$9ic,0)}),define(Me[304],Re([1,0,23,5,77,293,242,19,89,12,2,296,298]),function(me,e,S,F,M,N,R,m,d,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function r(t){self.fetch=async function(v,u){return v instanceof Request||w(String(v))&&(v=(await t(O.URI.parse(String(v)))).toString(!0)),p(v,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,u,g,a,b){(async()=>(w(u.toString())&&(u=(await t(O.URI.parse(u.toString()))).toString(!0)),super.open(v,u,g??!0,a,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(v,u){if(/^file:/i.test(v.toString()))v=k.$Bg.uriToBrowserUri(O.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const a=`(${function($){function D(A){return typeof A=="string"||A instanceof URL?String(A).replace(/^file:\/\//i,"vscode-file://vscode-app"):A}const y=fetch.bind(self);self.fetch=function(A,G){return A instanceof Request?y(A,G):y(D(A),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(A,G,T,V,P){return super.open(A,D(G),T??!0,V,P)}};const C=importScripts.bind(self);self.importScripts=(...A)=>{C(...A.map(D))},C($)}.toString()}('${v}'))`;u=u||{},u.name=`${name} -> ${u.name||m.$oc(v.toString())}`;const b=new Blob([a],{type:"application/javascript"}),f=URL.createObjectURL(b);return new t(f,u)}}else self.Worker=class extends R.$Vmc{constructor(t,v){super(l,t,{name:m.$oc(t.toString()),...v})}};const o=new class{constructor(){this.pid=void 0}exit(t){E()}};class s{constructor(){const v=new MessageChannel,u=new F.$7d;let g=!1;l(v.port2,[v.port2]),v.port1.onmessage=a=>{const{data:b}=a;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const f=S.$ue.wrap(new Uint8Array(b,0,b.byteLength));if((0,M.$Lm)(f,2)){g=!0,i("received terminate message from renderer");return}u.fire(f)},this.protocol={onMessage:u.event,send:a=>{if(!g){const b=a.buffer.buffer.slice(a.buffer.byteOffset,a.buffer.byteOffset+a.buffer.byteLength);v.port1.postMessage(b,[b])}}}}}function n(t){return new Promise(v=>{const u=t.onMessage(g=>{u.dispose();const a=JSON.parse(g.toString());t.send((0,M.$Km)(0)),v({protocol:t,initData:a})});t.send((0,M.$Km)(1))})}let i=t=>E();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(v){c(v)&&n(t.protocol).then(u=>{d.mark("code/extHost/didWaitForInitData");const g=new N.$Pkc(u.protocol,u.initData,o,null,v.data);r(a=>g.asBrowserUri(a)),i=a=>g.terminate(a)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9c3cc8b9948d52f04836997a7de01dbd9bb2a7bf/core/vs/workbench/api/worker/extensionHostWorker.js.map
